#include <tree_sitter/parser.h>

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 12
#define STATE_COUNT 3396
#define LARGE_STATE_COUNT 644
#define SYMBOL_COUNT 324
#define ALIAS_COUNT 7
#define TOKEN_COUNT 150
#define EXTERNAL_TOKEN_COUNT 4
#define FIELD_COUNT 36
#define MAX_ALIAS_SEQUENCE_LENGTH 9

enum {
  sym_identifier = 1,
  sym_hash_bang_line = 2,
  anon_sym_export = 3,
  anon_sym_STAR = 4,
  anon_sym_default = 5,
  anon_sym_EQ = 6,
  anon_sym_as = 7,
  anon_sym_namespace = 8,
  anon_sym_LBRACE = 9,
  anon_sym_COMMA = 10,
  anon_sym_RBRACE = 11,
  anon_sym_type = 12,
  anon_sym_typeof = 13,
  anon_sym_import = 14,
  anon_sym_from = 15,
  anon_sym_var = 16,
  anon_sym_let = 17,
  anon_sym_const = 18,
  anon_sym_BANG = 19,
  anon_sym_else = 20,
  anon_sym_if = 21,
  anon_sym_switch = 22,
  anon_sym_for = 23,
  anon_sym_LPAREN = 24,
  anon_sym_RPAREN = 25,
  anon_sym_await = 26,
  anon_sym_in = 27,
  anon_sym_of = 28,
  anon_sym_while = 29,
  anon_sym_do = 30,
  anon_sym_try = 31,
  anon_sym_with = 32,
  anon_sym_break = 33,
  anon_sym_continue = 34,
  anon_sym_debugger = 35,
  anon_sym_return = 36,
  anon_sym_throw = 37,
  anon_sym_SEMI = 38,
  anon_sym_COLON = 39,
  anon_sym_case = 40,
  anon_sym_catch = 41,
  anon_sym_finally = 42,
  anon_sym_yield = 43,
  anon_sym_LBRACK = 44,
  anon_sym_RBRACK = 45,
  anon_sym_LT = 46,
  anon_sym_GT = 47,
  anon_sym_SLASH = 48,
  anon_sym_DOT = 49,
  anon_sym_class = 50,
  anon_sym_async = 51,
  anon_sym_function = 52,
  anon_sym_EQ_GT = 53,
  anon_sym_QMARK_DOT = 54,
  anon_sym_new = 55,
  anon_sym_PLUS_EQ = 56,
  anon_sym_DASH_EQ = 57,
  anon_sym_STAR_EQ = 58,
  anon_sym_SLASH_EQ = 59,
  anon_sym_PERCENT_EQ = 60,
  anon_sym_CARET_EQ = 61,
  anon_sym_AMP_EQ = 62,
  anon_sym_PIPE_EQ = 63,
  anon_sym_GT_GT_EQ = 64,
  anon_sym_GT_GT_GT_EQ = 65,
  anon_sym_LT_LT_EQ = 66,
  anon_sym_STAR_STAR_EQ = 67,
  anon_sym_AMP_AMP_EQ = 68,
  anon_sym_PIPE_PIPE_EQ = 69,
  anon_sym_QMARK_QMARK_EQ = 70,
  anon_sym_DOT_DOT_DOT = 71,
  anon_sym_QMARK = 72,
  anon_sym_AMP_AMP = 73,
  anon_sym_PIPE_PIPE = 74,
  anon_sym_GT_GT = 75,
  anon_sym_GT_GT_GT = 76,
  anon_sym_LT_LT = 77,
  anon_sym_AMP = 78,
  anon_sym_CARET = 79,
  anon_sym_PIPE = 80,
  anon_sym_PLUS = 81,
  anon_sym_DASH = 82,
  anon_sym_PERCENT = 83,
  anon_sym_STAR_STAR = 84,
  anon_sym_LT_EQ = 85,
  anon_sym_EQ_EQ = 86,
  anon_sym_EQ_EQ_EQ = 87,
  anon_sym_BANG_EQ = 88,
  anon_sym_BANG_EQ_EQ = 89,
  anon_sym_GT_EQ = 90,
  anon_sym_QMARK_QMARK = 91,
  anon_sym_instanceof = 92,
  anon_sym_TILDE = 93,
  anon_sym_void = 94,
  anon_sym_delete = 95,
  anon_sym_PLUS_PLUS = 96,
  anon_sym_DASH_DASH = 97,
  anon_sym_DQUOTE = 98,
  aux_sym_string_token1 = 99,
  anon_sym_SQUOTE = 100,
  aux_sym_string_token2 = 101,
  sym_escape_sequence = 102,
  sym_comment = 103,
  anon_sym_BQUOTE = 104,
  anon_sym_DOLLAR_LBRACE = 105,
  anon_sym_SLASH2 = 106,
  sym_regex_pattern = 107,
  sym_regex_flags = 108,
  sym_number = 109,
  anon_sym_target = 110,
  sym_this = 111,
  sym_super = 112,
  sym_true = 113,
  sym_false = 114,
  sym_null = 115,
  sym_undefined = 116,
  anon_sym_AT = 117,
  anon_sym_static = 118,
  anon_sym_abstract = 119,
  anon_sym_get = 120,
  anon_sym_set = 121,
  anon_sym_declare = 122,
  anon_sym_public = 123,
  anon_sym_private = 124,
  anon_sym_protected = 125,
  anon_sym_module = 126,
  anon_sym_any = 127,
  anon_sym_number = 128,
  anon_sym_boolean = 129,
  anon_sym_string = 130,
  anon_sym_symbol = 131,
  anon_sym_require = 132,
  anon_sym_implements = 133,
  anon_sym_global = 134,
  anon_sym_interface = 135,
  anon_sym_extends = 136,
  anon_sym_enum = 137,
  sym_readonly = 138,
  anon_sym_DASH_QMARK_COLON = 139,
  anon_sym_QMARK_COLON = 140,
  anon_sym_asserts = 141,
  anon_sym_is = 142,
  anon_sym_infer = 143,
  anon_sym_keyof = 144,
  anon_sym_LBRACE_PIPE = 145,
  anon_sym_PIPE_RBRACE = 146,
  sym__automatic_semicolon = 147,
  sym__template_chars = 148,
  sym__function_signature_automatic_semicolon = 149,
  sym_program = 150,
  sym_export_statement = 151,
  sym_export_clause = 152,
  sym__import_export_specifier = 153,
  sym__declaration = 154,
  sym_import = 155,
  sym_import_statement = 156,
  sym_import_clause = 157,
  sym__from_clause = 158,
  sym_namespace_import = 159,
  sym_named_imports = 160,
  sym_expression_statement = 161,
  sym_variable_declaration = 162,
  sym_lexical_declaration = 163,
  sym_variable_declarator = 164,
  sym_statement_block = 165,
  sym_else_clause = 166,
  sym_if_statement = 167,
  sym_switch_statement = 168,
  sym_for_statement = 169,
  sym_for_in_statement = 170,
  sym__for_header = 171,
  sym_while_statement = 172,
  sym_do_statement = 173,
  sym_try_statement = 174,
  sym_with_statement = 175,
  sym_break_statement = 176,
  sym_continue_statement = 177,
  sym_debugger_statement = 178,
  sym_return_statement = 179,
  sym_throw_statement = 180,
  sym_empty_statement = 181,
  sym_labeled_statement = 182,
  sym_switch_body = 183,
  sym_switch_case = 184,
  sym_switch_default = 185,
  sym_catch_clause = 186,
  sym_finally_clause = 187,
  sym_parenthesized_expression = 188,
  sym__expression = 189,
  sym_yield_expression = 190,
  sym_object = 191,
  sym_assignment_pattern = 192,
  sym_array = 193,
  sym_nested_identifier = 194,
  sym_class = 195,
  sym_class_declaration = 196,
  sym_class_heritage = 197,
  sym_function = 198,
  sym_function_declaration = 199,
  sym_generator_function = 200,
  sym_generator_function_declaration = 201,
  sym_arrow_function = 202,
  sym__call_signature = 203,
  sym_call_expression = 204,
  sym_new_expression = 205,
  sym_await_expression = 206,
  sym_member_expression = 207,
  sym_subscript_expression = 208,
  sym_assignment_expression = 209,
  sym__augmented_assignment_lhs = 210,
  sym_augmented_assignment_expression = 211,
  sym__initializer = 212,
  sym_spread_element = 213,
  sym_ternary_expression = 214,
  sym_binary_expression = 215,
  sym_unary_expression = 216,
  sym_update_expression = 217,
  sym_sequence_expression = 218,
  sym_string = 219,
  sym_template_string = 220,
  sym_template_substitution = 221,
  sym_regex = 222,
  sym_meta_property = 223,
  sym_arguments = 224,
  sym_decorator = 225,
  sym_decorator_member_expression = 226,
  sym_decorator_call_expression = 227,
  sym_class_body = 228,
  sym_public_field_definition = 229,
  sym_formal_parameters = 230,
  sym_rest_parameter = 231,
  sym_method_definition = 232,
  sym_pair = 233,
  sym__property_name = 234,
  sym_computed_property_name = 235,
  sym_non_null_expression = 236,
  sym_method_signature = 237,
  sym_abstract_method_signature = 238,
  sym_function_signature = 239,
  sym_type_assertion = 240,
  sym_as_expression = 241,
  sym_import_require_clause = 242,
  sym_implements_clause = 243,
  sym_ambient_declaration = 244,
  sym_abstract_class_declaration = 245,
  sym_module = 246,
  sym_internal_module = 247,
  sym__module = 248,
  sym_import_alias = 249,
  sym_nested_type_identifier = 250,
  sym_interface_declaration = 251,
  sym_extends_clause = 252,
  sym_enum_declaration = 253,
  sym_enum_body = 254,
  sym_enum_assignment = 255,
  sym_type_alias_declaration = 256,
  sym_accessibility_modifier = 257,
  sym_required_parameter = 258,
  sym_optional_parameter = 259,
  sym__parameter_name = 260,
  sym__rest_identifier = 261,
  sym_rest_identifier = 262,
  sym_omitting_type_annotation = 263,
  sym_opting_type_annotation = 264,
  sym_type_annotation = 265,
  sym_asserts = 266,
  sym__type = 267,
  sym_optional_identifier = 268,
  sym__tuple_type_identifier = 269,
  sym_labeled_tuple_type_member = 270,
  sym__tuple_type_member = 271,
  sym_constructor_type = 272,
  sym__primary_type = 273,
  sym_infer_type = 274,
  sym_conditional_type = 275,
  sym_generic_type = 276,
  sym_type_predicate = 277,
  sym_type_predicate_annotation = 278,
  sym_type_query = 279,
  sym_index_type_query = 280,
  sym_lookup_type = 281,
  sym_mapped_type_clause = 282,
  sym_literal_type = 283,
  sym__number = 284,
  sym_existential_type = 285,
  sym_flow_maybe_type = 286,
  sym_parenthesized_type = 287,
  sym_predefined_type = 288,
  sym_type_arguments = 289,
  sym_object_type = 290,
  sym_call_signature = 291,
  sym_property_signature = 292,
  sym_type_parameters = 293,
  sym_type_parameter = 294,
  sym_default_type = 295,
  sym_constraint = 296,
  sym_construct_signature = 297,
  sym_index_signature = 298,
  sym_array_type = 299,
  sym__tuple_type_body = 300,
  sym_tuple_type = 301,
  sym_union_type = 302,
  sym_intersection_type = 303,
  sym_function_type = 304,
  aux_sym_program_repeat1 = 305,
  aux_sym_export_statement_repeat1 = 306,
  aux_sym_export_clause_repeat1 = 307,
  aux_sym_named_imports_repeat1 = 308,
  aux_sym_variable_declaration_repeat1 = 309,
  aux_sym_switch_body_repeat1 = 310,
  aux_sym_object_repeat1 = 311,
  aux_sym_array_repeat1 = 312,
  aux_sym_string_repeat1 = 313,
  aux_sym_string_repeat2 = 314,
  aux_sym_template_string_repeat1 = 315,
  aux_sym_class_body_repeat1 = 316,
  aux_sym_formal_parameters_repeat1 = 317,
  aux_sym_implements_clause_repeat1 = 318,
  aux_sym_extends_clause_repeat1 = 319,
  aux_sym_enum_body_repeat1 = 320,
  aux_sym_object_type_repeat1 = 321,
  aux_sym_type_parameters_repeat1 = 322,
  aux_sym__tuple_type_body_repeat1 = 323,
  alias_sym_array_pattern = 324,
  alias_sym_import_specifier = 325,
  alias_sym_object_pattern = 326,
  alias_sym_property_identifier = 327,
  alias_sym_shorthand_property_identifier = 328,
  alias_sym_statement_identifier = 329,
  alias_sym_type_identifier = 330,
};

static const char *ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_identifier] = "identifier",
  [sym_hash_bang_line] = "hash_bang_line",
  [anon_sym_export] = "export",
  [anon_sym_STAR] = "*",
  [anon_sym_default] = "default",
  [anon_sym_EQ] = "=",
  [anon_sym_as] = "as",
  [anon_sym_namespace] = "namespace",
  [anon_sym_LBRACE] = "{",
  [anon_sym_COMMA] = ",",
  [anon_sym_RBRACE] = "}",
  [anon_sym_type] = "type",
  [anon_sym_typeof] = "typeof",
  [anon_sym_import] = "import",
  [anon_sym_from] = "from",
  [anon_sym_var] = "var",
  [anon_sym_let] = "let",
  [anon_sym_const] = "const",
  [anon_sym_BANG] = "!",
  [anon_sym_else] = "else",
  [anon_sym_if] = "if",
  [anon_sym_switch] = "switch",
  [anon_sym_for] = "for",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_await] = "await",
  [anon_sym_in] = "in",
  [anon_sym_of] = "of",
  [anon_sym_while] = "while",
  [anon_sym_do] = "do",
  [anon_sym_try] = "try",
  [anon_sym_with] = "with",
  [anon_sym_break] = "break",
  [anon_sym_continue] = "continue",
  [anon_sym_debugger] = "debugger",
  [anon_sym_return] = "return",
  [anon_sym_throw] = "throw",
  [anon_sym_SEMI] = ";",
  [anon_sym_COLON] = ":",
  [anon_sym_case] = "case",
  [anon_sym_catch] = "catch",
  [anon_sym_finally] = "finally",
  [anon_sym_yield] = "yield",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_LT] = "<",
  [anon_sym_GT] = ">",
  [anon_sym_SLASH] = "/",
  [anon_sym_DOT] = ".",
  [anon_sym_class] = "class",
  [anon_sym_async] = "async",
  [anon_sym_function] = "function",
  [anon_sym_EQ_GT] = "=>",
  [anon_sym_QMARK_DOT] = "\?.",
  [anon_sym_new] = "new",
  [anon_sym_PLUS_EQ] = "+=",
  [anon_sym_DASH_EQ] = "-=",
  [anon_sym_STAR_EQ] = "*=",
  [anon_sym_SLASH_EQ] = "/=",
  [anon_sym_PERCENT_EQ] = "%=",
  [anon_sym_CARET_EQ] = "^=",
  [anon_sym_AMP_EQ] = "&=",
  [anon_sym_PIPE_EQ] = "|=",
  [anon_sym_GT_GT_EQ] = ">>=",
  [anon_sym_GT_GT_GT_EQ] = ">>>=",
  [anon_sym_LT_LT_EQ] = "<<=",
  [anon_sym_STAR_STAR_EQ] = "**=",
  [anon_sym_AMP_AMP_EQ] = "&&=",
  [anon_sym_PIPE_PIPE_EQ] = "||=",
  [anon_sym_QMARK_QMARK_EQ] = "\?\?=",
  [anon_sym_DOT_DOT_DOT] = "...",
  [anon_sym_QMARK] = "\?",
  [anon_sym_AMP_AMP] = "&&",
  [anon_sym_PIPE_PIPE] = "||",
  [anon_sym_GT_GT] = ">>",
  [anon_sym_GT_GT_GT] = ">>>",
  [anon_sym_LT_LT] = "<<",
  [anon_sym_AMP] = "&",
  [anon_sym_CARET] = "^",
  [anon_sym_PIPE] = "|",
  [anon_sym_PLUS] = "+",
  [anon_sym_DASH] = "-",
  [anon_sym_PERCENT] = "%",
  [anon_sym_STAR_STAR] = "**",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_EQ_EQ_EQ] = "===",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_BANG_EQ_EQ] = "!==",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_QMARK_QMARK] = "\?\?",
  [anon_sym_instanceof] = "instanceof",
  [anon_sym_TILDE] = "~",
  [anon_sym_void] = "void",
  [anon_sym_delete] = "delete",
  [anon_sym_PLUS_PLUS] = "++",
  [anon_sym_DASH_DASH] = "--",
  [anon_sym_DQUOTE] = "\"",
  [aux_sym_string_token1] = "string_token1",
  [anon_sym_SQUOTE] = "'",
  [aux_sym_string_token2] = "string_token2",
  [sym_escape_sequence] = "escape_sequence",
  [sym_comment] = "comment",
  [anon_sym_BQUOTE] = "`",
  [anon_sym_DOLLAR_LBRACE] = "${",
  [anon_sym_SLASH2] = "/",
  [sym_regex_pattern] = "regex_pattern",
  [sym_regex_flags] = "regex_flags",
  [sym_number] = "number",
  [anon_sym_target] = "target",
  [sym_this] = "this",
  [sym_super] = "super",
  [sym_true] = "true",
  [sym_false] = "false",
  [sym_null] = "null",
  [sym_undefined] = "undefined",
  [anon_sym_AT] = "@",
  [anon_sym_static] = "static",
  [anon_sym_abstract] = "abstract",
  [anon_sym_get] = "get",
  [anon_sym_set] = "set",
  [anon_sym_declare] = "declare",
  [anon_sym_public] = "public",
  [anon_sym_private] = "private",
  [anon_sym_protected] = "protected",
  [anon_sym_module] = "module",
  [anon_sym_any] = "any",
  [anon_sym_number] = "number",
  [anon_sym_boolean] = "boolean",
  [anon_sym_string] = "string",
  [anon_sym_symbol] = "symbol",
  [anon_sym_require] = "require",
  [anon_sym_implements] = "implements",
  [anon_sym_global] = "global",
  [anon_sym_interface] = "interface",
  [anon_sym_extends] = "extends",
  [anon_sym_enum] = "enum",
  [sym_readonly] = "readonly",
  [anon_sym_DASH_QMARK_COLON] = "-\?:",
  [anon_sym_QMARK_COLON] = "\?:",
  [anon_sym_asserts] = "asserts",
  [anon_sym_is] = "is",
  [anon_sym_infer] = "infer",
  [anon_sym_keyof] = "keyof",
  [anon_sym_LBRACE_PIPE] = "{|",
  [anon_sym_PIPE_RBRACE] = "|}",
  [sym__automatic_semicolon] = "_automatic_semicolon",
  [sym__template_chars] = "_template_chars",
  [sym__function_signature_automatic_semicolon] = "_function_signature_automatic_semicolon",
  [sym_program] = "program",
  [sym_export_statement] = "export_statement",
  [sym_export_clause] = "export_clause",
  [sym__import_export_specifier] = "export_specifier",
  [sym__declaration] = "_declaration",
  [sym_import] = "import",
  [sym_import_statement] = "import_statement",
  [sym_import_clause] = "import_clause",
  [sym__from_clause] = "_from_clause",
  [sym_namespace_import] = "namespace_import",
  [sym_named_imports] = "named_imports",
  [sym_expression_statement] = "expression_statement",
  [sym_variable_declaration] = "variable_declaration",
  [sym_lexical_declaration] = "lexical_declaration",
  [sym_variable_declarator] = "variable_declarator",
  [sym_statement_block] = "statement_block",
  [sym_else_clause] = "else_clause",
  [sym_if_statement] = "if_statement",
  [sym_switch_statement] = "switch_statement",
  [sym_for_statement] = "for_statement",
  [sym_for_in_statement] = "for_in_statement",
  [sym__for_header] = "_for_header",
  [sym_while_statement] = "while_statement",
  [sym_do_statement] = "do_statement",
  [sym_try_statement] = "try_statement",
  [sym_with_statement] = "with_statement",
  [sym_break_statement] = "break_statement",
  [sym_continue_statement] = "continue_statement",
  [sym_debugger_statement] = "debugger_statement",
  [sym_return_statement] = "return_statement",
  [sym_throw_statement] = "throw_statement",
  [sym_empty_statement] = "empty_statement",
  [sym_labeled_statement] = "labeled_statement",
  [sym_switch_body] = "switch_body",
  [sym_switch_case] = "switch_case",
  [sym_switch_default] = "switch_default",
  [sym_catch_clause] = "catch_clause",
  [sym_finally_clause] = "finally_clause",
  [sym_parenthesized_expression] = "parenthesized_expression",
  [sym__expression] = "_expression",
  [sym_yield_expression] = "yield_expression",
  [sym_object] = "object",
  [sym_assignment_pattern] = "assignment_pattern",
  [sym_array] = "array",
  [sym_nested_identifier] = "nested_identifier",
  [sym_class] = "class",
  [sym_class_declaration] = "class_declaration",
  [sym_class_heritage] = "class_heritage",
  [sym_function] = "function",
  [sym_function_declaration] = "function_declaration",
  [sym_generator_function] = "generator_function",
  [sym_generator_function_declaration] = "generator_function_declaration",
  [sym_arrow_function] = "arrow_function",
  [sym__call_signature] = "_call_signature",
  [sym_call_expression] = "call_expression",
  [sym_new_expression] = "new_expression",
  [sym_await_expression] = "await_expression",
  [sym_member_expression] = "member_expression",
  [sym_subscript_expression] = "subscript_expression",
  [sym_assignment_expression] = "assignment_expression",
  [sym__augmented_assignment_lhs] = "_augmented_assignment_lhs",
  [sym_augmented_assignment_expression] = "augmented_assignment_expression",
  [sym__initializer] = "_initializer",
  [sym_spread_element] = "spread_element",
  [sym_ternary_expression] = "ternary_expression",
  [sym_binary_expression] = "binary_expression",
  [sym_unary_expression] = "unary_expression",
  [sym_update_expression] = "update_expression",
  [sym_sequence_expression] = "sequence_expression",
  [sym_string] = "string",
  [sym_template_string] = "template_string",
  [sym_template_substitution] = "template_substitution",
  [sym_regex] = "regex",
  [sym_meta_property] = "meta_property",
  [sym_arguments] = "arguments",
  [sym_decorator] = "decorator",
  [sym_decorator_member_expression] = "member_expression",
  [sym_decorator_call_expression] = "call_expression",
  [sym_class_body] = "class_body",
  [sym_public_field_definition] = "public_field_definition",
  [sym_formal_parameters] = "formal_parameters",
  [sym_rest_parameter] = "rest_parameter",
  [sym_method_definition] = "method_definition",
  [sym_pair] = "pair",
  [sym__property_name] = "_property_name",
  [sym_computed_property_name] = "computed_property_name",
  [sym_non_null_expression] = "non_null_expression",
  [sym_method_signature] = "method_signature",
  [sym_abstract_method_signature] = "abstract_method_signature",
  [sym_function_signature] = "function_signature",
  [sym_type_assertion] = "type_assertion",
  [sym_as_expression] = "as_expression",
  [sym_import_require_clause] = "import_require_clause",
  [sym_implements_clause] = "implements_clause",
  [sym_ambient_declaration] = "ambient_declaration",
  [sym_abstract_class_declaration] = "abstract_class_declaration",
  [sym_module] = "module",
  [sym_internal_module] = "internal_module",
  [sym__module] = "_module",
  [sym_import_alias] = "import_alias",
  [sym_nested_type_identifier] = "nested_type_identifier",
  [sym_interface_declaration] = "interface_declaration",
  [sym_extends_clause] = "extends_clause",
  [sym_enum_declaration] = "enum_declaration",
  [sym_enum_body] = "enum_body",
  [sym_enum_assignment] = "enum_assignment",
  [sym_type_alias_declaration] = "type_alias_declaration",
  [sym_accessibility_modifier] = "accessibility_modifier",
  [sym_required_parameter] = "required_parameter",
  [sym_optional_parameter] = "optional_parameter",
  [sym__parameter_name] = "_parameter_name",
  [sym__rest_identifier] = "_rest_identifier",
  [sym_rest_identifier] = "rest_identifier",
  [sym_omitting_type_annotation] = "omitting_type_annotation",
  [sym_opting_type_annotation] = "opting_type_annotation",
  [sym_type_annotation] = "type_annotation",
  [sym_asserts] = "asserts",
  [sym__type] = "_type",
  [sym_optional_identifier] = "optional_identifier",
  [sym__tuple_type_identifier] = "_tuple_type_identifier",
  [sym_labeled_tuple_type_member] = "labeled_tuple_type_member",
  [sym__tuple_type_member] = "_tuple_type_member",
  [sym_constructor_type] = "constructor_type",
  [sym__primary_type] = "_primary_type",
  [sym_infer_type] = "infer_type",
  [sym_conditional_type] = "conditional_type",
  [sym_generic_type] = "generic_type",
  [sym_type_predicate] = "type_predicate",
  [sym_type_predicate_annotation] = "type_predicate_annotation",
  [sym_type_query] = "type_query",
  [sym_index_type_query] = "index_type_query",
  [sym_lookup_type] = "lookup_type",
  [sym_mapped_type_clause] = "mapped_type_clause",
  [sym_literal_type] = "literal_type",
  [sym__number] = "unary_expression",
  [sym_existential_type] = "existential_type",
  [sym_flow_maybe_type] = "flow_maybe_type",
  [sym_parenthesized_type] = "parenthesized_type",
  [sym_predefined_type] = "predefined_type",
  [sym_type_arguments] = "type_arguments",
  [sym_object_type] = "object_type",
  [sym_call_signature] = "call_signature",
  [sym_property_signature] = "property_signature",
  [sym_type_parameters] = "type_parameters",
  [sym_type_parameter] = "type_parameter",
  [sym_default_type] = "default_type",
  [sym_constraint] = "constraint",
  [sym_construct_signature] = "construct_signature",
  [sym_index_signature] = "index_signature",
  [sym_array_type] = "array_type",
  [sym__tuple_type_body] = "_tuple_type_body",
  [sym_tuple_type] = "tuple_type",
  [sym_union_type] = "union_type",
  [sym_intersection_type] = "intersection_type",
  [sym_function_type] = "function_type",
  [aux_sym_program_repeat1] = "program_repeat1",
  [aux_sym_export_statement_repeat1] = "export_statement_repeat1",
  [aux_sym_export_clause_repeat1] = "export_clause_repeat1",
  [aux_sym_named_imports_repeat1] = "named_imports_repeat1",
  [aux_sym_variable_declaration_repeat1] = "variable_declaration_repeat1",
  [aux_sym_switch_body_repeat1] = "switch_body_repeat1",
  [aux_sym_object_repeat1] = "object_repeat1",
  [aux_sym_array_repeat1] = "array_repeat1",
  [aux_sym_string_repeat1] = "string_repeat1",
  [aux_sym_string_repeat2] = "string_repeat2",
  [aux_sym_template_string_repeat1] = "template_string_repeat1",
  [aux_sym_class_body_repeat1] = "class_body_repeat1",
  [aux_sym_formal_parameters_repeat1] = "formal_parameters_repeat1",
  [aux_sym_implements_clause_repeat1] = "implements_clause_repeat1",
  [aux_sym_extends_clause_repeat1] = "extends_clause_repeat1",
  [aux_sym_enum_body_repeat1] = "enum_body_repeat1",
  [aux_sym_object_type_repeat1] = "object_type_repeat1",
  [aux_sym_type_parameters_repeat1] = "type_parameters_repeat1",
  [aux_sym__tuple_type_body_repeat1] = "_tuple_type_body_repeat1",
  [alias_sym_array_pattern] = "array_pattern",
  [alias_sym_import_specifier] = "import_specifier",
  [alias_sym_object_pattern] = "object_pattern",
  [alias_sym_property_identifier] = "property_identifier",
  [alias_sym_shorthand_property_identifier] = "shorthand_property_identifier",
  [alias_sym_statement_identifier] = "statement_identifier",
  [alias_sym_type_identifier] = "type_identifier",
};

static TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym_identifier] = sym_identifier,
  [sym_hash_bang_line] = sym_hash_bang_line,
  [anon_sym_export] = anon_sym_export,
  [anon_sym_STAR] = anon_sym_STAR,
  [anon_sym_default] = anon_sym_default,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_as] = anon_sym_as,
  [anon_sym_namespace] = anon_sym_namespace,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_type] = anon_sym_type,
  [anon_sym_typeof] = anon_sym_typeof,
  [anon_sym_import] = anon_sym_import,
  [anon_sym_from] = anon_sym_from,
  [anon_sym_var] = anon_sym_var,
  [anon_sym_let] = anon_sym_let,
  [anon_sym_const] = anon_sym_const,
  [anon_sym_BANG] = anon_sym_BANG,
  [anon_sym_else] = anon_sym_else,
  [anon_sym_if] = anon_sym_if,
  [anon_sym_switch] = anon_sym_switch,
  [anon_sym_for] = anon_sym_for,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_await] = anon_sym_await,
  [anon_sym_in] = anon_sym_in,
  [anon_sym_of] = anon_sym_of,
  [anon_sym_while] = anon_sym_while,
  [anon_sym_do] = anon_sym_do,
  [anon_sym_try] = anon_sym_try,
  [anon_sym_with] = anon_sym_with,
  [anon_sym_break] = anon_sym_break,
  [anon_sym_continue] = anon_sym_continue,
  [anon_sym_debugger] = anon_sym_debugger,
  [anon_sym_return] = anon_sym_return,
  [anon_sym_throw] = anon_sym_throw,
  [anon_sym_SEMI] = anon_sym_SEMI,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_case] = anon_sym_case,
  [anon_sym_catch] = anon_sym_catch,
  [anon_sym_finally] = anon_sym_finally,
  [anon_sym_yield] = anon_sym_yield,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_LT] = anon_sym_LT,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_SLASH] = anon_sym_SLASH,
  [anon_sym_DOT] = anon_sym_DOT,
  [anon_sym_class] = anon_sym_class,
  [anon_sym_async] = anon_sym_async,
  [anon_sym_function] = anon_sym_function,
  [anon_sym_EQ_GT] = anon_sym_EQ_GT,
  [anon_sym_QMARK_DOT] = anon_sym_QMARK_DOT,
  [anon_sym_new] = anon_sym_new,
  [anon_sym_PLUS_EQ] = anon_sym_PLUS_EQ,
  [anon_sym_DASH_EQ] = anon_sym_DASH_EQ,
  [anon_sym_STAR_EQ] = anon_sym_STAR_EQ,
  [anon_sym_SLASH_EQ] = anon_sym_SLASH_EQ,
  [anon_sym_PERCENT_EQ] = anon_sym_PERCENT_EQ,
  [anon_sym_CARET_EQ] = anon_sym_CARET_EQ,
  [anon_sym_AMP_EQ] = anon_sym_AMP_EQ,
  [anon_sym_PIPE_EQ] = anon_sym_PIPE_EQ,
  [anon_sym_GT_GT_EQ] = anon_sym_GT_GT_EQ,
  [anon_sym_GT_GT_GT_EQ] = anon_sym_GT_GT_GT_EQ,
  [anon_sym_LT_LT_EQ] = anon_sym_LT_LT_EQ,
  [anon_sym_STAR_STAR_EQ] = anon_sym_STAR_STAR_EQ,
  [anon_sym_AMP_AMP_EQ] = anon_sym_AMP_AMP_EQ,
  [anon_sym_PIPE_PIPE_EQ] = anon_sym_PIPE_PIPE_EQ,
  [anon_sym_QMARK_QMARK_EQ] = anon_sym_QMARK_QMARK_EQ,
  [anon_sym_DOT_DOT_DOT] = anon_sym_DOT_DOT_DOT,
  [anon_sym_QMARK] = anon_sym_QMARK,
  [anon_sym_AMP_AMP] = anon_sym_AMP_AMP,
  [anon_sym_PIPE_PIPE] = anon_sym_PIPE_PIPE,
  [anon_sym_GT_GT] = anon_sym_GT_GT,
  [anon_sym_GT_GT_GT] = anon_sym_GT_GT_GT,
  [anon_sym_LT_LT] = anon_sym_LT_LT,
  [anon_sym_AMP] = anon_sym_AMP,
  [anon_sym_CARET] = anon_sym_CARET,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [anon_sym_PLUS] = anon_sym_PLUS,
  [anon_sym_DASH] = anon_sym_DASH,
  [anon_sym_PERCENT] = anon_sym_PERCENT,
  [anon_sym_STAR_STAR] = anon_sym_STAR_STAR,
  [anon_sym_LT_EQ] = anon_sym_LT_EQ,
  [anon_sym_EQ_EQ] = anon_sym_EQ_EQ,
  [anon_sym_EQ_EQ_EQ] = anon_sym_EQ_EQ_EQ,
  [anon_sym_BANG_EQ] = anon_sym_BANG_EQ,
  [anon_sym_BANG_EQ_EQ] = anon_sym_BANG_EQ_EQ,
  [anon_sym_GT_EQ] = anon_sym_GT_EQ,
  [anon_sym_QMARK_QMARK] = anon_sym_QMARK_QMARK,
  [anon_sym_instanceof] = anon_sym_instanceof,
  [anon_sym_TILDE] = anon_sym_TILDE,
  [anon_sym_void] = anon_sym_void,
  [anon_sym_delete] = anon_sym_delete,
  [anon_sym_PLUS_PLUS] = anon_sym_PLUS_PLUS,
  [anon_sym_DASH_DASH] = anon_sym_DASH_DASH,
  [anon_sym_DQUOTE] = anon_sym_DQUOTE,
  [aux_sym_string_token1] = aux_sym_string_token1,
  [anon_sym_SQUOTE] = anon_sym_SQUOTE,
  [aux_sym_string_token2] = aux_sym_string_token2,
  [sym_escape_sequence] = sym_escape_sequence,
  [sym_comment] = sym_comment,
  [anon_sym_BQUOTE] = anon_sym_BQUOTE,
  [anon_sym_DOLLAR_LBRACE] = anon_sym_DOLLAR_LBRACE,
  [anon_sym_SLASH2] = anon_sym_SLASH,
  [sym_regex_pattern] = sym_regex_pattern,
  [sym_regex_flags] = sym_regex_flags,
  [sym_number] = sym_number,
  [anon_sym_target] = anon_sym_target,
  [sym_this] = sym_this,
  [sym_super] = sym_super,
  [sym_true] = sym_true,
  [sym_false] = sym_false,
  [sym_null] = sym_null,
  [sym_undefined] = sym_undefined,
  [anon_sym_AT] = anon_sym_AT,
  [anon_sym_static] = anon_sym_static,
  [anon_sym_abstract] = anon_sym_abstract,
  [anon_sym_get] = anon_sym_get,
  [anon_sym_set] = anon_sym_set,
  [anon_sym_declare] = anon_sym_declare,
  [anon_sym_public] = anon_sym_public,
  [anon_sym_private] = anon_sym_private,
  [anon_sym_protected] = anon_sym_protected,
  [anon_sym_module] = anon_sym_module,
  [anon_sym_any] = anon_sym_any,
  [anon_sym_number] = anon_sym_number,
  [anon_sym_boolean] = anon_sym_boolean,
  [anon_sym_string] = anon_sym_string,
  [anon_sym_symbol] = anon_sym_symbol,
  [anon_sym_require] = anon_sym_require,
  [anon_sym_implements] = anon_sym_implements,
  [anon_sym_global] = anon_sym_global,
  [anon_sym_interface] = anon_sym_interface,
  [anon_sym_extends] = anon_sym_extends,
  [anon_sym_enum] = anon_sym_enum,
  [sym_readonly] = sym_readonly,
  [anon_sym_DASH_QMARK_COLON] = anon_sym_DASH_QMARK_COLON,
  [anon_sym_QMARK_COLON] = anon_sym_QMARK_COLON,
  [anon_sym_asserts] = anon_sym_asserts,
  [anon_sym_is] = anon_sym_is,
  [anon_sym_infer] = anon_sym_infer,
  [anon_sym_keyof] = anon_sym_keyof,
  [anon_sym_LBRACE_PIPE] = anon_sym_LBRACE_PIPE,
  [anon_sym_PIPE_RBRACE] = anon_sym_PIPE_RBRACE,
  [sym__automatic_semicolon] = sym__automatic_semicolon,
  [sym__template_chars] = sym__template_chars,
  [sym__function_signature_automatic_semicolon] = sym__function_signature_automatic_semicolon,
  [sym_program] = sym_program,
  [sym_export_statement] = sym_export_statement,
  [sym_export_clause] = sym_export_clause,
  [sym__import_export_specifier] = sym__import_export_specifier,
  [sym__declaration] = sym__declaration,
  [sym_import] = sym_import,
  [sym_import_statement] = sym_import_statement,
  [sym_import_clause] = sym_import_clause,
  [sym__from_clause] = sym__from_clause,
  [sym_namespace_import] = sym_namespace_import,
  [sym_named_imports] = sym_named_imports,
  [sym_expression_statement] = sym_expression_statement,
  [sym_variable_declaration] = sym_variable_declaration,
  [sym_lexical_declaration] = sym_lexical_declaration,
  [sym_variable_declarator] = sym_variable_declarator,
  [sym_statement_block] = sym_statement_block,
  [sym_else_clause] = sym_else_clause,
  [sym_if_statement] = sym_if_statement,
  [sym_switch_statement] = sym_switch_statement,
  [sym_for_statement] = sym_for_statement,
  [sym_for_in_statement] = sym_for_in_statement,
  [sym__for_header] = sym__for_header,
  [sym_while_statement] = sym_while_statement,
  [sym_do_statement] = sym_do_statement,
  [sym_try_statement] = sym_try_statement,
  [sym_with_statement] = sym_with_statement,
  [sym_break_statement] = sym_break_statement,
  [sym_continue_statement] = sym_continue_statement,
  [sym_debugger_statement] = sym_debugger_statement,
  [sym_return_statement] = sym_return_statement,
  [sym_throw_statement] = sym_throw_statement,
  [sym_empty_statement] = sym_empty_statement,
  [sym_labeled_statement] = sym_labeled_statement,
  [sym_switch_body] = sym_switch_body,
  [sym_switch_case] = sym_switch_case,
  [sym_switch_default] = sym_switch_default,
  [sym_catch_clause] = sym_catch_clause,
  [sym_finally_clause] = sym_finally_clause,
  [sym_parenthesized_expression] = sym_parenthesized_expression,
  [sym__expression] = sym__expression,
  [sym_yield_expression] = sym_yield_expression,
  [sym_object] = sym_object,
  [sym_assignment_pattern] = sym_assignment_pattern,
  [sym_array] = sym_array,
  [sym_nested_identifier] = sym_nested_identifier,
  [sym_class] = sym_class,
  [sym_class_declaration] = sym_class_declaration,
  [sym_class_heritage] = sym_class_heritage,
  [sym_function] = sym_function,
  [sym_function_declaration] = sym_function_declaration,
  [sym_generator_function] = sym_generator_function,
  [sym_generator_function_declaration] = sym_generator_function_declaration,
  [sym_arrow_function] = sym_arrow_function,
  [sym__call_signature] = sym__call_signature,
  [sym_call_expression] = sym_call_expression,
  [sym_new_expression] = sym_new_expression,
  [sym_await_expression] = sym_await_expression,
  [sym_member_expression] = sym_member_expression,
  [sym_subscript_expression] = sym_subscript_expression,
  [sym_assignment_expression] = sym_assignment_expression,
  [sym__augmented_assignment_lhs] = sym__augmented_assignment_lhs,
  [sym_augmented_assignment_expression] = sym_augmented_assignment_expression,
  [sym__initializer] = sym__initializer,
  [sym_spread_element] = sym_spread_element,
  [sym_ternary_expression] = sym_ternary_expression,
  [sym_binary_expression] = sym_binary_expression,
  [sym_unary_expression] = sym_unary_expression,
  [sym_update_expression] = sym_update_expression,
  [sym_sequence_expression] = sym_sequence_expression,
  [sym_string] = sym_string,
  [sym_template_string] = sym_template_string,
  [sym_template_substitution] = sym_template_substitution,
  [sym_regex] = sym_regex,
  [sym_meta_property] = sym_meta_property,
  [sym_arguments] = sym_arguments,
  [sym_decorator] = sym_decorator,
  [sym_decorator_member_expression] = sym_member_expression,
  [sym_decorator_call_expression] = sym_call_expression,
  [sym_class_body] = sym_class_body,
  [sym_public_field_definition] = sym_public_field_definition,
  [sym_formal_parameters] = sym_formal_parameters,
  [sym_rest_parameter] = sym_rest_parameter,
  [sym_method_definition] = sym_method_definition,
  [sym_pair] = sym_pair,
  [sym__property_name] = sym__property_name,
  [sym_computed_property_name] = sym_computed_property_name,
  [sym_non_null_expression] = sym_non_null_expression,
  [sym_method_signature] = sym_method_signature,
  [sym_abstract_method_signature] = sym_abstract_method_signature,
  [sym_function_signature] = sym_function_signature,
  [sym_type_assertion] = sym_type_assertion,
  [sym_as_expression] = sym_as_expression,
  [sym_import_require_clause] = sym_import_require_clause,
  [sym_implements_clause] = sym_implements_clause,
  [sym_ambient_declaration] = sym_ambient_declaration,
  [sym_abstract_class_declaration] = sym_abstract_class_declaration,
  [sym_module] = sym_module,
  [sym_internal_module] = sym_internal_module,
  [sym__module] = sym__module,
  [sym_import_alias] = sym_import_alias,
  [sym_nested_type_identifier] = sym_nested_type_identifier,
  [sym_interface_declaration] = sym_interface_declaration,
  [sym_extends_clause] = sym_extends_clause,
  [sym_enum_declaration] = sym_enum_declaration,
  [sym_enum_body] = sym_enum_body,
  [sym_enum_assignment] = sym_enum_assignment,
  [sym_type_alias_declaration] = sym_type_alias_declaration,
  [sym_accessibility_modifier] = sym_accessibility_modifier,
  [sym_required_parameter] = sym_required_parameter,
  [sym_optional_parameter] = sym_optional_parameter,
  [sym__parameter_name] = sym__parameter_name,
  [sym__rest_identifier] = sym__rest_identifier,
  [sym_rest_identifier] = sym_rest_identifier,
  [sym_omitting_type_annotation] = sym_omitting_type_annotation,
  [sym_opting_type_annotation] = sym_opting_type_annotation,
  [sym_type_annotation] = sym_type_annotation,
  [sym_asserts] = sym_asserts,
  [sym__type] = sym__type,
  [sym_optional_identifier] = sym_optional_identifier,
  [sym__tuple_type_identifier] = sym__tuple_type_identifier,
  [sym_labeled_tuple_type_member] = sym_labeled_tuple_type_member,
  [sym__tuple_type_member] = sym__tuple_type_member,
  [sym_constructor_type] = sym_constructor_type,
  [sym__primary_type] = sym__primary_type,
  [sym_infer_type] = sym_infer_type,
  [sym_conditional_type] = sym_conditional_type,
  [sym_generic_type] = sym_generic_type,
  [sym_type_predicate] = sym_type_predicate,
  [sym_type_predicate_annotation] = sym_type_predicate_annotation,
  [sym_type_query] = sym_type_query,
  [sym_index_type_query] = sym_index_type_query,
  [sym_lookup_type] = sym_lookup_type,
  [sym_mapped_type_clause] = sym_mapped_type_clause,
  [sym_literal_type] = sym_literal_type,
  [sym__number] = sym_unary_expression,
  [sym_existential_type] = sym_existential_type,
  [sym_flow_maybe_type] = sym_flow_maybe_type,
  [sym_parenthesized_type] = sym_parenthesized_type,
  [sym_predefined_type] = sym_predefined_type,
  [sym_type_arguments] = sym_type_arguments,
  [sym_object_type] = sym_object_type,
  [sym_call_signature] = sym_call_signature,
  [sym_property_signature] = sym_property_signature,
  [sym_type_parameters] = sym_type_parameters,
  [sym_type_parameter] = sym_type_parameter,
  [sym_default_type] = sym_default_type,
  [sym_constraint] = sym_constraint,
  [sym_construct_signature] = sym_construct_signature,
  [sym_index_signature] = sym_index_signature,
  [sym_array_type] = sym_array_type,
  [sym__tuple_type_body] = sym__tuple_type_body,
  [sym_tuple_type] = sym_tuple_type,
  [sym_union_type] = sym_union_type,
  [sym_intersection_type] = sym_intersection_type,
  [sym_function_type] = sym_function_type,
  [aux_sym_program_repeat1] = aux_sym_program_repeat1,
  [aux_sym_export_statement_repeat1] = aux_sym_export_statement_repeat1,
  [aux_sym_export_clause_repeat1] = aux_sym_export_clause_repeat1,
  [aux_sym_named_imports_repeat1] = aux_sym_named_imports_repeat1,
  [aux_sym_variable_declaration_repeat1] = aux_sym_variable_declaration_repeat1,
  [aux_sym_switch_body_repeat1] = aux_sym_switch_body_repeat1,
  [aux_sym_object_repeat1] = aux_sym_object_repeat1,
  [aux_sym_array_repeat1] = aux_sym_array_repeat1,
  [aux_sym_string_repeat1] = aux_sym_string_repeat1,
  [aux_sym_string_repeat2] = aux_sym_string_repeat2,
  [aux_sym_template_string_repeat1] = aux_sym_template_string_repeat1,
  [aux_sym_class_body_repeat1] = aux_sym_class_body_repeat1,
  [aux_sym_formal_parameters_repeat1] = aux_sym_formal_parameters_repeat1,
  [aux_sym_implements_clause_repeat1] = aux_sym_implements_clause_repeat1,
  [aux_sym_extends_clause_repeat1] = aux_sym_extends_clause_repeat1,
  [aux_sym_enum_body_repeat1] = aux_sym_enum_body_repeat1,
  [aux_sym_object_type_repeat1] = aux_sym_object_type_repeat1,
  [aux_sym_type_parameters_repeat1] = aux_sym_type_parameters_repeat1,
  [aux_sym__tuple_type_body_repeat1] = aux_sym__tuple_type_body_repeat1,
  [alias_sym_array_pattern] = alias_sym_array_pattern,
  [alias_sym_import_specifier] = alias_sym_import_specifier,
  [alias_sym_object_pattern] = alias_sym_object_pattern,
  [alias_sym_property_identifier] = alias_sym_property_identifier,
  [alias_sym_shorthand_property_identifier] = alias_sym_shorthand_property_identifier,
  [alias_sym_statement_identifier] = alias_sym_statement_identifier,
  [alias_sym_type_identifier] = alias_sym_type_identifier,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_hash_bang_line] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_export] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_default] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_as] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_namespace] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_type] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_typeof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_import] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_from] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_var] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_let] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_const] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_switch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_await] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_in] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_of] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_do] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_try] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_with] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_break] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_continue] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_debugger] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_return] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_throw] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_case] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_catch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_finally] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_yield] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_class] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_async] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_function] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_new] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK_QMARK_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_instanceof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_void] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_delete] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_string_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_string_token2] = {
    .visible = false,
    .named = false,
  },
  [sym_escape_sequence] = {
    .visible = true,
    .named = true,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_BQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLAR_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH2] = {
    .visible = true,
    .named = false,
  },
  [sym_regex_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_regex_flags] = {
    .visible = true,
    .named = true,
  },
  [sym_number] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_target] = {
    .visible = true,
    .named = false,
  },
  [sym_this] = {
    .visible = true,
    .named = true,
  },
  [sym_super] = {
    .visible = true,
    .named = true,
  },
  [sym_true] = {
    .visible = true,
    .named = true,
  },
  [sym_false] = {
    .visible = true,
    .named = true,
  },
  [sym_null] = {
    .visible = true,
    .named = true,
  },
  [sym_undefined] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_static] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_abstract] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_get] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_set] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_declare] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_public] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_private] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_protected] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_module] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_any] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_number] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_boolean] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_string] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_symbol] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_require] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_implements] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_global] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_interface] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_extends] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_enum] = {
    .visible = true,
    .named = false,
  },
  [sym_readonly] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_DASH_QMARK_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_asserts] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_is] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_infer] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_keyof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [sym__automatic_semicolon] = {
    .visible = false,
    .named = true,
  },
  [sym__template_chars] = {
    .visible = false,
    .named = true,
  },
  [sym__function_signature_automatic_semicolon] = {
    .visible = false,
    .named = true,
  },
  [sym_program] = {
    .visible = true,
    .named = true,
  },
  [sym_export_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_export_clause] = {
    .visible = true,
    .named = true,
  },
  [sym__import_export_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym__declaration] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_import] = {
    .visible = true,
    .named = true,
  },
  [sym_import_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_import_clause] = {
    .visible = true,
    .named = true,
  },
  [sym__from_clause] = {
    .visible = false,
    .named = true,
  },
  [sym_namespace_import] = {
    .visible = true,
    .named = true,
  },
  [sym_named_imports] = {
    .visible = true,
    .named = true,
  },
  [sym_expression_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_variable_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_lexical_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_variable_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_statement_block] = {
    .visible = true,
    .named = true,
  },
  [sym_else_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_in_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__for_header] = {
    .visible = false,
    .named = true,
  },
  [sym_while_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_do_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_try_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_with_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_break_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_continue_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_debugger_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_return_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_throw_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_empty_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_labeled_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_body] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_case] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_default] = {
    .visible = true,
    .named = true,
  },
  [sym_catch_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_finally_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__expression] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_yield_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_object] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_array] = {
    .visible = true,
    .named = true,
  },
  [sym_nested_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_class] = {
    .visible = true,
    .named = true,
  },
  [sym_class_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_class_heritage] = {
    .visible = true,
    .named = true,
  },
  [sym_function] = {
    .visible = true,
    .named = true,
  },
  [sym_function_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_generator_function] = {
    .visible = true,
    .named = true,
  },
  [sym_generator_function_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_arrow_function] = {
    .visible = true,
    .named = true,
  },
  [sym__call_signature] = {
    .visible = false,
    .named = true,
  },
  [sym_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_new_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_await_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_member_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_subscript_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__augmented_assignment_lhs] = {
    .visible = false,
    .named = true,
  },
  [sym_augmented_assignment_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__initializer] = {
    .visible = false,
    .named = true,
  },
  [sym_spread_element] = {
    .visible = true,
    .named = true,
  },
  [sym_ternary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_binary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_unary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_update_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_sequence_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_string] = {
    .visible = true,
    .named = true,
  },
  [sym_template_string] = {
    .visible = true,
    .named = true,
  },
  [sym_template_substitution] = {
    .visible = true,
    .named = true,
  },
  [sym_regex] = {
    .visible = true,
    .named = true,
  },
  [sym_meta_property] = {
    .visible = true,
    .named = true,
  },
  [sym_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_decorator] = {
    .visible = true,
    .named = true,
  },
  [sym_decorator_member_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_decorator_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_class_body] = {
    .visible = true,
    .named = true,
  },
  [sym_public_field_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_formal_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_rest_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_method_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_pair] = {
    .visible = true,
    .named = true,
  },
  [sym__property_name] = {
    .visible = false,
    .named = true,
  },
  [sym_computed_property_name] = {
    .visible = true,
    .named = true,
  },
  [sym_non_null_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_method_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_method_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_function_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_type_assertion] = {
    .visible = true,
    .named = true,
  },
  [sym_as_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_import_require_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_implements_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_ambient_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_class_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_module] = {
    .visible = true,
    .named = true,
  },
  [sym_internal_module] = {
    .visible = true,
    .named = true,
  },
  [sym__module] = {
    .visible = false,
    .named = true,
  },
  [sym_import_alias] = {
    .visible = true,
    .named = true,
  },
  [sym_nested_type_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_interface_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_extends_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_body] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym_type_alias_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_accessibility_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_required_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_optional_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym__parameter_name] = {
    .visible = false,
    .named = true,
  },
  [sym__rest_identifier] = {
    .visible = false,
    .named = true,
  },
  [sym_rest_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_omitting_type_annotation] = {
    .visible = true,
    .named = true,
  },
  [sym_opting_type_annotation] = {
    .visible = true,
    .named = true,
  },
  [sym_type_annotation] = {
    .visible = true,
    .named = true,
  },
  [sym_asserts] = {
    .visible = true,
    .named = true,
  },
  [sym__type] = {
    .visible = false,
    .named = true,
  },
  [sym_optional_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym__tuple_type_identifier] = {
    .visible = false,
    .named = true,
  },
  [sym_labeled_tuple_type_member] = {
    .visible = true,
    .named = true,
  },
  [sym__tuple_type_member] = {
    .visible = false,
    .named = true,
  },
  [sym_constructor_type] = {
    .visible = true,
    .named = true,
  },
  [sym__primary_type] = {
    .visible = false,
    .named = true,
  },
  [sym_infer_type] = {
    .visible = true,
    .named = true,
  },
  [sym_conditional_type] = {
    .visible = true,
    .named = true,
  },
  [sym_generic_type] = {
    .visible = true,
    .named = true,
  },
  [sym_type_predicate] = {
    .visible = true,
    .named = true,
  },
  [sym_type_predicate_annotation] = {
    .visible = true,
    .named = true,
  },
  [sym_type_query] = {
    .visible = true,
    .named = true,
  },
  [sym_index_type_query] = {
    .visible = true,
    .named = true,
  },
  [sym_lookup_type] = {
    .visible = true,
    .named = true,
  },
  [sym_mapped_type_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_literal_type] = {
    .visible = true,
    .named = true,
  },
  [sym__number] = {
    .visible = true,
    .named = true,
  },
  [sym_existential_type] = {
    .visible = true,
    .named = true,
  },
  [sym_flow_maybe_type] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_type] = {
    .visible = true,
    .named = true,
  },
  [sym_predefined_type] = {
    .visible = true,
    .named = true,
  },
  [sym_type_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_object_type] = {
    .visible = true,
    .named = true,
  },
  [sym_call_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_property_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_type_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_type_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_default_type] = {
    .visible = true,
    .named = true,
  },
  [sym_constraint] = {
    .visible = true,
    .named = true,
  },
  [sym_construct_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_index_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_array_type] = {
    .visible = true,
    .named = true,
  },
  [sym__tuple_type_body] = {
    .visible = false,
    .named = true,
  },
  [sym_tuple_type] = {
    .visible = true,
    .named = true,
  },
  [sym_union_type] = {
    .visible = true,
    .named = true,
  },
  [sym_intersection_type] = {
    .visible = true,
    .named = true,
  },
  [sym_function_type] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_program_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_export_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_export_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_named_imports_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_variable_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_switch_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_object_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_array_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_template_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_class_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_formal_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_implements_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_extends_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_enum_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_object_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__tuple_type_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_array_pattern] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_import_specifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_object_pattern] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_property_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_shorthand_property_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_statement_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_type_identifier] = {
    .visible = true,
    .named = true,
  },
};

enum {
  field_alias = 1,
  field_alternative = 2,
  field_argument = 3,
  field_arguments = 4,
  field_body = 5,
  field_condition = 6,
  field_consequence = 7,
  field_constructor = 8,
  field_declaration = 9,
  field_decorator = 10,
  field_finalizer = 11,
  field_flags = 12,
  field_function = 13,
  field_handler = 14,
  field_increment = 15,
  field_index = 16,
  field_initializer = 17,
  field_key = 18,
  field_label = 19,
  field_left = 20,
  field_module = 21,
  field_name = 22,
  field_object = 23,
  field_operator = 24,
  field_parameter = 25,
  field_parameters = 26,
  field_pattern = 27,
  field_property = 28,
  field_return_type = 29,
  field_right = 30,
  field_sign = 31,
  field_source = 32,
  field_type = 33,
  field_type_arguments = 34,
  field_type_parameters = 35,
  field_value = 36,
};

static const char *ts_field_names[] = {
  [0] = NULL,
  [field_alias] = "alias",
  [field_alternative] = "alternative",
  [field_argument] = "argument",
  [field_arguments] = "arguments",
  [field_body] = "body",
  [field_condition] = "condition",
  [field_consequence] = "consequence",
  [field_constructor] = "constructor",
  [field_declaration] = "declaration",
  [field_decorator] = "decorator",
  [field_finalizer] = "finalizer",
  [field_flags] = "flags",
  [field_function] = "function",
  [field_handler] = "handler",
  [field_increment] = "increment",
  [field_index] = "index",
  [field_initializer] = "initializer",
  [field_key] = "key",
  [field_label] = "label",
  [field_left] = "left",
  [field_module] = "module",
  [field_name] = "name",
  [field_object] = "object",
  [field_operator] = "operator",
  [field_parameter] = "parameter",
  [field_parameters] = "parameters",
  [field_pattern] = "pattern",
  [field_property] = "property",
  [field_return_type] = "return_type",
  [field_right] = "right",
  [field_sign] = "sign",
  [field_source] = "source",
  [field_type] = "type",
  [field_type_arguments] = "type_arguments",
  [field_type_parameters] = "type_parameters",
  [field_value] = "value",
};

static const TSFieldMapSlice ts_field_map_slices[200] = {
  [2] = {.index = 0, .length = 1},
  [3] = {.index = 1, .length = 1},
  [4] = {.index = 2, .length = 1},
  [5] = {.index = 3, .length = 1},
  [6] = {.index = 4, .length = 2},
  [8] = {.index = 6, .length = 2},
  [9] = {.index = 3, .length = 1},
  [10] = {.index = 3, .length = 1},
  [13] = {.index = 8, .length = 1},
  [15] = {.index = 9, .length = 1},
  [16] = {.index = 9, .length = 1},
  [17] = {.index = 10, .length = 2},
  [18] = {.index = 12, .length = 2},
  [19] = {.index = 14, .length = 2},
  [20] = {.index = 16, .length = 2},
  [21] = {.index = 18, .length = 2},
  [22] = {.index = 20, .length = 2},
  [23] = {.index = 22, .length = 1},
  [24] = {.index = 23, .length = 2},
  [25] = {.index = 25, .length = 2},
  [26] = {.index = 27, .length = 2},
  [27] = {.index = 29, .length = 2},
  [29] = {.index = 31, .length = 2},
  [30] = {.index = 33, .length = 2},
  [31] = {.index = 31, .length = 2},
  [32] = {.index = 33, .length = 2},
  [33] = {.index = 31, .length = 2},
  [34] = {.index = 33, .length = 2},
  [35] = {.index = 35, .length = 2},
  [36] = {.index = 37, .length = 2},
  [37] = {.index = 39, .length = 3},
  [41] = {.index = 42, .length = 1},
  [42] = {.index = 43, .length = 2},
  [43] = {.index = 45, .length = 2},
  [44] = {.index = 47, .length = 2},
  [45] = {.index = 49, .length = 2},
  [46] = {.index = 51, .length = 1},
  [47] = {.index = 52, .length = 3},
  [49] = {.index = 55, .length = 1},
  [50] = {.index = 56, .length = 2},
  [51] = {.index = 58, .length = 1},
  [52] = {.index = 59, .length = 2},
  [53] = {.index = 61, .length = 4},
  [54] = {.index = 65, .length = 2},
  [55] = {.index = 67, .length = 2},
  [56] = {.index = 65, .length = 2},
  [57] = {.index = 67, .length = 2},
  [58] = {.index = 23, .length = 2},
  [59] = {.index = 27, .length = 2},
  [60] = {.index = 20, .length = 2},
  [61] = {.index = 25, .length = 2},
  [62] = {.index = 56, .length = 2},
  [63] = {.index = 69, .length = 3},
  [64] = {.index = 72, .length = 3},
  [65] = {.index = 20, .length = 2},
  [66] = {.index = 20, .length = 2},
  [67] = {.index = 75, .length = 4},
  [68] = {.index = 79, .length = 3},
  [69] = {.index = 82, .length = 2},
  [70] = {.index = 84, .length = 1},
  [71] = {.index = 85, .length = 1},
  [72] = {.index = 86, .length = 1},
  [73] = {.index = 87, .length = 1},
  [74] = {.index = 88, .length = 2},
  [75] = {.index = 90, .length = 3},
  [76] = {.index = 20, .length = 2},
  [77] = {.index = 93, .length = 2},
  [78] = {.index = 95, .length = 5},
  [79] = {.index = 100, .length = 2},
  [80] = {.index = 102, .length = 1},
  [81] = {.index = 103, .length = 2},
  [82] = {.index = 105, .length = 3},
  [83] = {.index = 105, .length = 3},
  [84] = {.index = 105, .length = 3},
  [85] = {.index = 108, .length = 2},
  [86] = {.index = 110, .length = 3},
  [87] = {.index = 113, .length = 3},
  [91] = {.index = 116, .length = 1},
  [92] = {.index = 117, .length = 3},
  [93] = {.index = 120, .length = 4},
  [94] = {.index = 124, .length = 2},
  [95] = {.index = 126, .length = 2},
  [96] = {.index = 128, .length = 2},
  [97] = {.index = 130, .length = 3},
  [98] = {.index = 133, .length = 2},
  [99] = {.index = 135, .length = 2},
  [100] = {.index = 137, .length = 4},
  [101] = {.index = 135, .length = 2},
  [102] = {.index = 141, .length = 4},
  [103] = {.index = 145, .length = 4},
  [104] = {.index = 149, .length = 5},
  [105] = {.index = 154, .length = 3},
  [106] = {.index = 154, .length = 3},
  [107] = {.index = 88, .length = 2},
  [108] = {.index = 90, .length = 3},
  [109] = {.index = 108, .length = 2},
  [110] = {.index = 157, .length = 3},
  [111] = {.index = 160, .length = 2},
  [112] = {.index = 162, .length = 3},
  [113] = {.index = 165, .length = 2},
  [114] = {.index = 100, .length = 2},
  [115] = {.index = 167, .length = 2},
  [116] = {.index = 169, .length = 5},
  [117] = {.index = 174, .length = 2},
  [118] = {.index = 176, .length = 1},
  [119] = {.index = 177, .length = 1},
  [120] = {.index = 178, .length = 1},
  [121] = {.index = 179, .length = 1},
  [122] = {.index = 180, .length = 2},
  [123] = {.index = 182, .length = 1},
  [124] = {.index = 183, .length = 2},
  [125] = {.index = 185, .length = 4},
  [126] = {.index = 189, .length = 2},
  [127] = {.index = 191, .length = 2},
  [128] = {.index = 193, .length = 3},
  [129] = {.index = 196, .length = 4},
  [130] = {.index = 200, .length = 4},
  [131] = {.index = 204, .length = 5},
  [132] = {.index = 167, .length = 2},
  [133] = {.index = 209, .length = 2},
  [134] = {.index = 211, .length = 3},
  [135] = {.index = 214, .length = 3},
  [136] = {.index = 217, .length = 2},
  [137] = {.index = 219, .length = 3},
  [138] = {.index = 222, .length = 4},
  [139] = {.index = 226, .length = 3},
  [140] = {.index = 229, .length = 3},
  [141] = {.index = 232, .length = 2},
  [142] = {.index = 234, .length = 5},
  [143] = {.index = 239, .length = 3},
  [144] = {.index = 242, .length = 2},
  [145] = {.index = 242, .length = 2},
  [146] = {.index = 244, .length = 3},
  [147] = {.index = 242, .length = 2},
  [148] = {.index = 242, .length = 2},
  [149] = {.index = 247, .length = 2},
  [150] = {.index = 249, .length = 4},
  [151] = {.index = 253, .length = 2},
  [152] = {.index = 255, .length = 2},
  [153] = {.index = 257, .length = 1},
  [154] = {.index = 258, .length = 2},
  [155] = {.index = 260, .length = 2},
  [156] = {.index = 262, .length = 3},
  [157] = {.index = 265, .length = 3},
  [158] = {.index = 268, .length = 5},
  [159] = {.index = 273, .length = 3},
  [161] = {.index = 276, .length = 4},
  [162] = {.index = 280, .length = 3},
  [163] = {.index = 283, .length = 4},
  [164] = {.index = 287, .length = 5},
  [165] = {.index = 292, .length = 2},
  [166] = {.index = 292, .length = 2},
  [167] = {.index = 292, .length = 2},
  [168] = {.index = 292, .length = 2},
  [169] = {.index = 294, .length = 4},
  [170] = {.index = 298, .length = 2},
  [171] = {.index = 298, .length = 2},
  [172] = {.index = 298, .length = 2},
  [173] = {.index = 300, .length = 4},
  [174] = {.index = 304, .length = 4},
  [175] = {.index = 308, .length = 2},
  [176] = {.index = 310, .length = 2},
  [177] = {.index = 312, .length = 2},
  [178] = {.index = 314, .length = 3},
  [179] = {.index = 317, .length = 3},
  [180] = {.index = 320, .length = 2},
  [181] = {.index = 322, .length = 4},
  [182] = {.index = 326, .length = 5},
  [183] = {.index = 331, .length = 5},
  [184] = {.index = 336, .length = 1},
  [185] = {.index = 337, .length = 4},
  [186] = {.index = 341, .length = 4},
  [187] = {.index = 345, .length = 2},
  [188] = {.index = 347, .length = 4},
  [189] = {.index = 351, .length = 3},
  [190] = {.index = 354, .length = 2},
  [191] = {.index = 356, .length = 3},
  [192] = {.index = 359, .length = 5},
  [193] = {.index = 364, .length = 5},
  [194] = {.index = 369, .length = 4},
  [195] = {.index = 373, .length = 4},
  [196] = {.index = 377, .length = 3},
  [197] = {.index = 380, .length = 5},
  [198] = {.index = 336, .length = 1},
  [199] = {.index = 385, .length = 4},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_decorator, 0},
  [1] =
    {field_parameters, 0},
  [2] =
    {field_declaration, 1},
  [3] =
    {field_name, 0},
  [4] =
    {field_body, 1, .inherited = true},
    {field_name, 1, .inherited = true},
  [6] =
    {field_argument, 1},
    {field_operator, 0},
  [8] =
    {field_body, 1},
  [9] =
    {field_constructor, 1},
  [10] =
    {field_argument, 0},
    {field_operator, 1},
  [12] =
    {field_arguments, 1},
    {field_function, 0},
  [14] =
    {field_parameters, 0},
    {field_return_type, 1},
  [16] =
    {field_parameters, 1},
    {field_type_parameters, 0},
  [18] =
    {field_decorator, 0, .inherited = true},
    {field_decorator, 1, .inherited = true},
  [20] =
    {field_left, 0},
    {field_right, 2},
  [22] =
    {field_label, 0},
  [23] =
    {field_object, 0},
    {field_property, 2},
  [25] =
    {field_body, 2},
    {field_parameter, 0},
  [27] =
    {field_arguments, 2},
    {field_function, 0},
  [29] =
    {field_body, 1},
    {field_name, 0},
  [31] =
    {field_name, 0},
    {field_value, 1, .inherited = true},
  [33] =
    {field_name, 0},
    {field_type, 1},
  [35] =
    {field_condition, 1},
    {field_consequence, 2},
  [37] =
    {field_body, 2},
    {field_value, 1},
  [39] =
    {field_body, 2},
    {field_left, 1, .inherited = true},
    {field_right, 1, .inherited = true},
  [42] =
    {field_value, 1, .inherited = true},
  [43] =
    {field_body, 2},
    {field_condition, 1},
  [45] =
    {field_body, 1},
    {field_handler, 2},
  [47] =
    {field_body, 1},
    {field_finalizer, 2},
  [49] =
    {field_body, 2},
    {field_object, 1},
  [51] =
    {field_label, 1},
  [52] =
    {field_parameters, 0, .inherited = true},
    {field_return_type, 0, .inherited = true},
    {field_type_parameters, 0, .inherited = true},
  [55] =
    {field_pattern, 1},
  [56] =
    {field_body, 2},
    {field_name, 1},
  [58] =
    {field_body, 2},
  [59] =
    {field_body, 2},
    {field_type_parameters, 1},
  [61] =
    {field_body, 2},
    {field_parameters, 1, .inherited = true},
    {field_return_type, 1, .inherited = true},
    {field_type_parameters, 1, .inherited = true},
  [65] =
    {field_arguments, 2},
    {field_constructor, 1},
  [67] =
    {field_constructor, 1},
    {field_type_arguments, 2},
  [69] =
    {field_left, 0},
    {field_operator, 1},
    {field_right, 2},
  [72] =
    {field_arguments, 2},
    {field_function, 0},
    {field_type_arguments, 1},
  [75] =
    {field_body, 2},
    {field_parameters, 0, .inherited = true},
    {field_return_type, 0, .inherited = true},
    {field_type_parameters, 0, .inherited = true},
  [79] =
    {field_parameters, 1},
    {field_return_type, 2},
    {field_type_parameters, 0},
  [82] =
    {field_declaration, 2},
    {field_decorator, 0, .inherited = true},
  [84] =
    {field_source, 1},
  [85] =
    {field_source, 2, .inherited = true},
  [86] =
    {field_value, 2},
  [87] =
    {field_name, 1},
  [88] =
    {field_index, 2},
    {field_object, 0},
  [90] =
    {field_arguments, 3},
    {field_function, 0},
    {field_type_arguments, 2},
  [93] =
    {field_key, 0},
    {field_value, 2},
  [95] =
    {field_body, 2},
    {field_name, 0},
    {field_parameters, 1, .inherited = true},
    {field_return_type, 1, .inherited = true},
    {field_type_parameters, 1, .inherited = true},
  [100] =
    {field_alias, 1, .inherited = true},
    {field_name, 1, .inherited = true},
  [102] =
    {field_value, 1},
  [103] =
    {field_name, 0},
    {field_type, 2},
  [105] =
    {field_name, 0},
    {field_type, 1},
    {field_value, 2, .inherited = true},
  [108] =
    {field_body, 3},
    {field_name, 2},
  [110] =
    {field_alternative, 3},
    {field_condition, 1},
    {field_consequence, 2},
  [113] =
    {field_body, 3},
    {field_left, 2, .inherited = true},
    {field_right, 2, .inherited = true},
  [116] =
    {field_value, 2, .inherited = true},
  [117] =
    {field_body, 1},
    {field_finalizer, 3},
    {field_handler, 2},
  [120] =
    {field_name, 0},
    {field_parameters, 1, .inherited = true},
    {field_return_type, 1, .inherited = true},
    {field_type_parameters, 1, .inherited = true},
  [124] =
    {field_module, 0},
    {field_name, 2},
  [126] =
    {field_flags, 3},
    {field_pattern, 1},
  [128] =
    {field_body, 3},
    {field_name, 1},
  [130] =
    {field_body, 3},
    {field_name, 1},
    {field_type_parameters, 2},
  [133] =
    {field_body, 3},
    {field_type_parameters, 1},
  [135] =
    {field_body, 3},
    {field_parameter, 1},
  [137] =
    {field_body, 3},
    {field_parameters, 2, .inherited = true},
    {field_return_type, 2, .inherited = true},
    {field_type_parameters, 2, .inherited = true},
  [141] =
    {field_body, 3},
    {field_parameters, 1, .inherited = true},
    {field_return_type, 1, .inherited = true},
    {field_type_parameters, 1, .inherited = true},
  [145] =
    {field_name, 1},
    {field_parameters, 2, .inherited = true},
    {field_return_type, 2, .inherited = true},
    {field_type_parameters, 2, .inherited = true},
  [149] =
    {field_body, 3},
    {field_name, 1},
    {field_parameters, 2, .inherited = true},
    {field_return_type, 2, .inherited = true},
    {field_type_parameters, 2, .inherited = true},
  [154] =
    {field_arguments, 3},
    {field_constructor, 1},
    {field_type_arguments, 2},
  [157] =
    {field_body, 3},
    {field_decorator, 0, .inherited = true},
    {field_name, 2},
  [160] =
    {field_body, 3},
    {field_decorator, 0, .inherited = true},
  [162] =
    {field_body, 3},
    {field_decorator, 0, .inherited = true},
    {field_type_parameters, 2},
  [165] =
    {field_alias, 2},
    {field_name, 0},
  [167] =
    {field_index, 3},
    {field_object, 0},
  [169] =
    {field_body, 3},
    {field_name, 0},
    {field_parameters, 2, .inherited = true},
    {field_return_type, 2, .inherited = true},
    {field_type_parameters, 2, .inherited = true},
  [174] =
    {field_name, 1},
    {field_value, 3},
  [176] =
    {field_source, 3, .inherited = true},
  [177] =
    {field_decorator, 1, .inherited = true},
  [178] =
    {field_decorator, 2, .inherited = true},
  [179] =
    {field_value, 3, .inherited = true},
  [180] =
    {field_body, 1},
    {field_condition, 3},
  [182] =
    {field_name, 2},
  [183] =
    {field_name, 1},
    {field_type, 2},
  [185] =
    {field_name, 0},
    {field_parameters, 2, .inherited = true},
    {field_return_type, 2, .inherited = true},
    {field_type_parameters, 2, .inherited = true},
  [189] =
    {field_name, 1},
    {field_value, 2, .inherited = true},
  [191] =
    {field_name, 0},
    {field_value, 2, .inherited = true},
  [193] =
    {field_body, 4},
    {field_name, 1},
    {field_type_parameters, 2},
  [196] =
    {field_body, 4},
    {field_parameters, 3, .inherited = true},
    {field_return_type, 3, .inherited = true},
    {field_type_parameters, 3, .inherited = true},
  [200] =
    {field_name, 2},
    {field_parameters, 3, .inherited = true},
    {field_return_type, 3, .inherited = true},
    {field_type_parameters, 3, .inherited = true},
  [204] =
    {field_body, 4},
    {field_name, 2},
    {field_parameters, 3, .inherited = true},
    {field_return_type, 3, .inherited = true},
    {field_type_parameters, 3, .inherited = true},
  [209] =
    {field_body, 4},
    {field_name, 2},
  [211] =
    {field_body, 4},
    {field_name, 2},
    {field_type_parameters, 3},
  [214] =
    {field_alternative, 4},
    {field_condition, 0},
    {field_consequence, 2},
  [217] =
    {field_decorator, 0, .inherited = true},
    {field_value, 3},
  [219] =
    {field_body, 4},
    {field_decorator, 0, .inherited = true},
    {field_name, 2},
  [222] =
    {field_body, 4},
    {field_decorator, 0, .inherited = true},
    {field_name, 2},
    {field_type_parameters, 3},
  [226] =
    {field_body, 4},
    {field_decorator, 0, .inherited = true},
    {field_type_parameters, 2},
  [229] =
    {field_body, 4},
    {field_decorator, 0, .inherited = true},
    {field_name, 3},
  [232] =
    {field_alias, 3},
    {field_name, 1},
  [234] =
    {field_body, 4},
    {field_name, 1},
    {field_parameters, 3, .inherited = true},
    {field_return_type, 3, .inherited = true},
    {field_type_parameters, 3, .inherited = true},
  [239] =
    {field_name, 1},
    {field_type_parameters, 2},
    {field_value, 4},
  [242] =
    {field_left, 1},
    {field_right, 3},
  [244] =
    {field_body, 5},
    {field_condition, 3},
    {field_initializer, 2},
  [247] =
    {field_decorator, 1, .inherited = true},
    {field_decorator, 3, .inherited = true},
  [249] =
    {field_name, 1},
    {field_parameters, 3, .inherited = true},
    {field_return_type, 3, .inherited = true},
    {field_type_parameters, 3, .inherited = true},
  [253] =
    {field_name, 2},
    {field_type, 3},
  [255] =
    {field_name, 1},
    {field_type, 3},
  [257] =
    {field_name, 3},
  [258] =
    {field_name, 2},
    {field_value, 3, .inherited = true},
  [260] =
    {field_name, 1},
    {field_value, 3, .inherited = true},
  [262] =
    {field_name, 1},
    {field_type, 2},
    {field_value, 3, .inherited = true},
  [265] =
    {field_name, 0},
    {field_type, 2},
    {field_value, 3, .inherited = true},
  [268] =
    {field_body, 5},
    {field_name, 3},
    {field_parameters, 4, .inherited = true},
    {field_return_type, 4, .inherited = true},
    {field_type_parameters, 4, .inherited = true},
  [273] =
    {field_body, 5},
    {field_name, 2},
    {field_type_parameters, 3},
  [276] =
    {field_body, 5},
    {field_decorator, 0, .inherited = true},
    {field_name, 2},
    {field_type_parameters, 3},
  [280] =
    {field_body, 5},
    {field_decorator, 0, .inherited = true},
    {field_name, 3},
  [283] =
    {field_body, 5},
    {field_decorator, 0, .inherited = true},
    {field_name, 3},
    {field_type_parameters, 4},
  [287] =
    {field_body, 5},
    {field_name, 2},
    {field_parameters, 4, .inherited = true},
    {field_return_type, 4, .inherited = true},
    {field_type_parameters, 4, .inherited = true},
  [292] =
    {field_left, 2},
    {field_right, 4},
  [294] =
    {field_body, 6},
    {field_condition, 3},
    {field_increment, 4},
    {field_initializer, 2},
  [298] =
    {field_body, 4},
    {field_parameter, 2},
  [300] =
    {field_name, 2},
    {field_parameters, 4, .inherited = true},
    {field_return_type, 4, .inherited = true},
    {field_type_parameters, 4, .inherited = true},
  [304] =
    {field_name, 3},
    {field_parameters, 4, .inherited = true},
    {field_return_type, 4, .inherited = true},
    {field_type_parameters, 4, .inherited = true},
  [308] =
    {field_name, 2},
    {field_type, 4},
  [310] =
    {field_name, 3},
    {field_type, 4},
  [312] =
    {field_name, 2},
    {field_value, 4, .inherited = true},
  [314] =
    {field_name, 2},
    {field_type, 3},
    {field_value, 4, .inherited = true},
  [317] =
    {field_name, 1},
    {field_type, 3},
    {field_value, 4, .inherited = true},
  [320] =
    {field_name, 3},
    {field_value, 4, .inherited = true},
  [322] =
    {field_body, 6},
    {field_decorator, 0, .inherited = true},
    {field_name, 3},
    {field_type_parameters, 4},
  [326] =
    {field_body, 6},
    {field_name, 3},
    {field_parameters, 5, .inherited = true},
    {field_return_type, 5, .inherited = true},
    {field_type_parameters, 5, .inherited = true},
  [331] =
    {field_body, 6},
    {field_name, 4},
    {field_parameters, 5, .inherited = true},
    {field_return_type, 5, .inherited = true},
    {field_type_parameters, 5, .inherited = true},
  [336] =
    {field_sign, 0},
  [337] =
    {field_name, 3},
    {field_parameters, 5, .inherited = true},
    {field_return_type, 5, .inherited = true},
    {field_type_parameters, 5, .inherited = true},
  [341] =
    {field_name, 4},
    {field_parameters, 5, .inherited = true},
    {field_return_type, 5, .inherited = true},
    {field_type_parameters, 5, .inherited = true},
  [345] =
    {field_name, 3},
    {field_type, 5},
  [347] =
    {field_alternative, 6},
    {field_consequence, 4},
    {field_left, 0},
    {field_right, 2},
  [351] =
    {field_name, 2},
    {field_type, 4},
    {field_value, 5, .inherited = true},
  [354] =
    {field_name, 3},
    {field_value, 5, .inherited = true},
  [356] =
    {field_name, 3},
    {field_type, 4},
    {field_value, 5, .inherited = true},
  [359] =
    {field_body, 7},
    {field_name, 4},
    {field_parameters, 6, .inherited = true},
    {field_return_type, 6, .inherited = true},
    {field_type_parameters, 6, .inherited = true},
  [364] =
    {field_body, 7},
    {field_name, 5},
    {field_parameters, 6, .inherited = true},
    {field_return_type, 6, .inherited = true},
    {field_type_parameters, 6, .inherited = true},
  [369] =
    {field_name, 4},
    {field_parameters, 6, .inherited = true},
    {field_return_type, 6, .inherited = true},
    {field_type_parameters, 6, .inherited = true},
  [373] =
    {field_name, 5},
    {field_parameters, 6, .inherited = true},
    {field_return_type, 6, .inherited = true},
    {field_type_parameters, 6, .inherited = true},
  [377] =
    {field_name, 3},
    {field_type, 5},
    {field_value, 6, .inherited = true},
  [380] =
    {field_body, 8},
    {field_name, 5},
    {field_parameters, 7, .inherited = true},
    {field_return_type, 7, .inherited = true},
    {field_type_parameters, 7, .inherited = true},
  [385] =
    {field_name, 5},
    {field_parameters, 7, .inherited = true},
    {field_return_type, 7, .inherited = true},
    {field_type_parameters, 7, .inherited = true},
};

static TSSymbol ts_alias_sequences[200][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [1] = {
    [0] = sym_identifier,
  },
  [7] = {
    [0] = alias_sym_property_identifier,
  },
  [9] = {
    [0] = alias_sym_object_pattern,
  },
  [10] = {
    [0] = alias_sym_array_pattern,
  },
  [11] = {
    [0] = alias_sym_object_pattern,
  },
  [12] = {
    [0] = alias_sym_array_pattern,
  },
  [14] = {
    [0] = alias_sym_type_identifier,
  },
  [15] = {
    [1] = sym_identifier,
  },
  [22] = {
    [0] = sym_identifier,
  },
  [23] = {
    [0] = alias_sym_statement_identifier,
  },
  [24] = {
    [0] = sym_identifier,
    [2] = alias_sym_property_identifier,
  },
  [25] = {
    [0] = sym_identifier,
  },
  [26] = {
    [0] = sym_identifier,
  },
  [28] = {
    [1] = alias_sym_shorthand_property_identifier,
  },
  [31] = {
    [0] = alias_sym_object_pattern,
  },
  [32] = {
    [0] = alias_sym_object_pattern,
  },
  [33] = {
    [0] = alias_sym_array_pattern,
  },
  [34] = {
    [0] = alias_sym_array_pattern,
  },
  [38] = {
    [1] = sym_identifier,
  },
  [39] = {
    [1] = alias_sym_object_pattern,
  },
  [40] = {
    [1] = alias_sym_array_pattern,
  },
  [46] = {
    [1] = alias_sym_statement_identifier,
  },
  [48] = {
    [1] = alias_sym_type_identifier,
  },
  [50] = {
    [1] = alias_sym_type_identifier,
  },
  [54] = {
    [1] = sym_identifier,
  },
  [55] = {
    [1] = sym_identifier,
  },
  [58] = {
    [2] = alias_sym_property_identifier,
  },
  [65] = {
    [0] = alias_sym_object_pattern,
  },
  [66] = {
    [0] = alias_sym_array_pattern,
  },
  [74] = {
    [0] = sym_identifier,
  },
  [75] = {
    [0] = sym_identifier,
  },
  [76] = {
    [0] = alias_sym_shorthand_property_identifier,
  },
  [79] = {
    [1] = alias_sym_import_specifier,
  },
  [83] = {
    [0] = alias_sym_object_pattern,
  },
  [84] = {
    [0] = alias_sym_array_pattern,
  },
  [88] = {
    [2] = sym_identifier,
  },
  [89] = {
    [2] = alias_sym_object_pattern,
  },
  [90] = {
    [2] = alias_sym_array_pattern,
  },
  [94] = {
    [2] = alias_sym_type_identifier,
  },
  [96] = {
    [1] = alias_sym_type_identifier,
  },
  [97] = {
    [1] = alias_sym_type_identifier,
  },
  [99] = {
    [1] = sym_identifier,
  },
  [105] = {
    [1] = sym_identifier,
  },
  [109] = {
    [2] = alias_sym_type_identifier,
  },
  [110] = {
    [2] = alias_sym_type_identifier,
  },
  [115] = {
    [0] = sym_identifier,
  },
  [117] = {
    [1] = alias_sym_type_identifier,
  },
  [128] = {
    [1] = alias_sym_type_identifier,
  },
  [133] = {
    [2] = alias_sym_type_identifier,
  },
  [134] = {
    [2] = alias_sym_type_identifier,
  },
  [137] = {
    [2] = alias_sym_type_identifier,
  },
  [138] = {
    [2] = alias_sym_type_identifier,
  },
  [140] = {
    [3] = alias_sym_type_identifier,
  },
  [143] = {
    [1] = alias_sym_type_identifier,
  },
  [144] = {
    [1] = sym_identifier,
  },
  [147] = {
    [1] = alias_sym_object_pattern,
  },
  [148] = {
    [1] = alias_sym_array_pattern,
  },
  [159] = {
    [2] = alias_sym_type_identifier,
  },
  [160] = {
    [3] = alias_sym_property_identifier,
  },
  [161] = {
    [2] = alias_sym_type_identifier,
  },
  [162] = {
    [3] = alias_sym_type_identifier,
  },
  [163] = {
    [3] = alias_sym_type_identifier,
  },
  [165] = {
    [2] = sym_identifier,
  },
  [167] = {
    [2] = alias_sym_object_pattern,
  },
  [168] = {
    [2] = alias_sym_array_pattern,
  },
  [171] = {
    [2] = alias_sym_object_pattern,
  },
  [172] = {
    [2] = alias_sym_array_pattern,
  },
  [181] = {
    [3] = alias_sym_type_identifier,
  },
  [198] = {
    [3] = sym_identifier,
  },
};

static uint16_t ts_non_terminal_alias_map[] = {
  sym__import_export_specifier, 2,
    sym__import_export_specifier,
    alias_sym_import_specifier,
  sym_object, 2,
    sym_object,
    alias_sym_object_pattern,
  sym_array, 2,
    sym_array,
    alias_sym_array_pattern,
  0,
};

static inline bool sym_identifier_character_set_1(int32_t lookahead) {
  return
    lookahead == 0 ||
    (0 <= lookahead && lookahead <= '#') ||
    ('%' <= lookahead && lookahead <= '/') ||
    (':' <= lookahead && lookahead <= '@') ||
    ('[' <= lookahead && lookahead <= '^') ||
    lookahead == '`' ||
    ('{' <= lookahead && lookahead <= '~') ||
    lookahead == 160 ||
    lookahead == 8203 ||
    lookahead == 8288 ||
    lookahead == 65279;
}

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(69);
      if (lookahead == '!') ADVANCE(82);
      if (lookahead == '"') ADVANCE(164);
      if (lookahead == '#') ADVANCE(13);
      if (lookahead == '$') ADVANCE(202);
      if (lookahead == '%') ADVANCE(150);
      if (lookahead == '&') ADVANCE(132);
      if (lookahead == '\'') ADVANCE(171);
      if (lookahead == '(') ADVANCE(83);
      if (lookahead == ')') ADVANCE(84);
      if (lookahead == '*') ADVANCE(72);
      if (lookahead == '+') ADVANCE(144);
      if (lookahead == ',') ADVANCE(79);
      if (lookahead == '-') ADVANCE(148);
      if (lookahead == '.') ADVANCE(98);
      if (lookahead == '/') ADVANCE(188);
      if (lookahead == '0') ADVANCE(193);
      if (lookahead == ':') ADVANCE(86);
      if (lookahead == ';') ADVANCE(85);
      if (lookahead == '<') ADVANCE(90);
      if (lookahead == '=') ADVANCE(75);
      if (lookahead == '>') ADVANCE(93);
      if (lookahead == '?') ADVANCE(119);
      if (lookahead == '@') ADVANCE(204);
      if (lookahead == '[') ADVANCE(87);
      if (lookahead == '\\') ADVANCE(33);
      if (lookahead == ']') ADVANCE(88);
      if (lookahead == '^') ADVANCE(135);
      if (lookahead == '`') ADVANCE(186);
      if (lookahead == '{') ADVANCE(78);
      if (lookahead == '|') ADVANCE(138);
      if (lookahead == '}') ADVANCE(80);
      if (lookahead == '~') ADVANCE(161);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(66)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(194);
      if (lookahead != 0 &&
          (lookahead < 0 || 31 < lookahead)) ADVANCE(203);
      END_STATE();
    case 1:
      if (lookahead == '\n') SKIP(18)
      if (lookahead == '"') ADVANCE(164);
      if (lookahead == '/') ADVANCE(166);
      if (lookahead == '\\') ADVANCE(2);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(169);
      if (lookahead != 0) ADVANCE(170);
      END_STATE();
    case 2:
      if (lookahead == '\n') ADVANCE(165);
      if (lookahead == '\r') ADVANCE(179);
      if (lookahead == 'u') ADVANCE(39);
      if (lookahead == 'x') ADVANCE(59);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(183);
      if (lookahead != 0) ADVANCE(178);
      END_STATE();
    case 3:
      if (lookahead == '\n') SKIP(21)
      if (lookahead == '\'') ADVANCE(171);
      if (lookahead == '/') ADVANCE(173);
      if (lookahead == '\\') ADVANCE(4);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(176);
      if (lookahead != 0) ADVANCE(177);
      END_STATE();
    case 4:
      if (lookahead == '\n') ADVANCE(172);
      if (lookahead == '\r') ADVANCE(180);
      if (lookahead == 'u') ADVANCE(39);
      if (lookahead == 'x') ADVANCE(59);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(183);
      if (lookahead != 0) ADVANCE(178);
      END_STATE();
    case 5:
      if (lookahead == '\n') SKIP(27)
      if (lookahead == '/') ADVANCE(22);
      if (lookahead == '[') ADVANCE(32);
      if (lookahead == '\\') ADVANCE(65);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(189);
      if (lookahead != 0) ADVANCE(190);
      END_STATE();
    case 6:
      if (lookahead == '!') ADVANCE(82);
      if (lookahead == '"') ADVANCE(164);
      if (lookahead == '%') ADVANCE(150);
      if (lookahead == '&') ADVANCE(132);
      if (lookahead == '\'') ADVANCE(171);
      if (lookahead == '(') ADVANCE(83);
      if (lookahead == ')') ADVANCE(84);
      if (lookahead == '*') ADVANCE(72);
      if (lookahead == '+') ADVANCE(144);
      if (lookahead == ',') ADVANCE(79);
      if (lookahead == '-') ADVANCE(147);
      if (lookahead == '.') ADVANCE(99);
      if (lookahead == '/') ADVANCE(96);
      if (lookahead == '0') ADVANCE(193);
      if (lookahead == ':') ADVANCE(86);
      if (lookahead == ';') ADVANCE(85);
      if (lookahead == '<') ADVANCE(90);
      if (lookahead == '=') ADVANCE(75);
      if (lookahead == '>') ADVANCE(93);
      if (lookahead == '?') ADVANCE(119);
      if (lookahead == '@') ADVANCE(204);
      if (lookahead == '[') ADVANCE(87);
      if (lookahead == '\\') ADVANCE(34);
      if (lookahead == ']') ADVANCE(88);
      if (lookahead == '^') ADVANCE(135);
      if (lookahead == '`') ADVANCE(186);
      if (lookahead == '{') ADVANCE(78);
      if (lookahead == '|') ADVANCE(138);
      if (lookahead == '}') ADVANCE(80);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(6)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(194);
      if (lookahead != 0 &&
          (lookahead < 0 || '#' < lookahead) &&
          lookahead != '~') ADVANCE(203);
      END_STATE();
    case 7:
      if (lookahead == '!') ADVANCE(82);
      if (lookahead == '"') ADVANCE(164);
      if (lookahead == '%') ADVANCE(150);
      if (lookahead == '&') ADVANCE(132);
      if (lookahead == '\'') ADVANCE(171);
      if (lookahead == '(') ADVANCE(83);
      if (lookahead == ')') ADVANCE(84);
      if (lookahead == '*') ADVANCE(72);
      if (lookahead == '+') ADVANCE(144);
      if (lookahead == ',') ADVANCE(79);
      if (lookahead == '-') ADVANCE(147);
      if (lookahead == '.') ADVANCE(97);
      if (lookahead == '/') ADVANCE(96);
      if (lookahead == ':') ADVANCE(86);
      if (lookahead == ';') ADVANCE(85);
      if (lookahead == '<') ADVANCE(90);
      if (lookahead == '=') ADVANCE(75);
      if (lookahead == '>') ADVANCE(93);
      if (lookahead == '?') ADVANCE(119);
      if (lookahead == '@') ADVANCE(204);
      if (lookahead == '[') ADVANCE(87);
      if (lookahead == '\\') ADVANCE(34);
      if (lookahead == ']') ADVANCE(88);
      if (lookahead == '^') ADVANCE(135);
      if (lookahead == '`') ADVANCE(186);
      if (lookahead == '{') ADVANCE(77);
      if (lookahead == '|') ADVANCE(137);
      if (lookahead == '}') ADVANCE(80);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(7)
      if (lookahead != 0 &&
          (lookahead < 0 || '#' < lookahead) &&
          (lookahead < '0' || '9' < lookahead) &&
          lookahead != '~') ADVANCE(203);
      END_STATE();
    case 8:
      if (lookahead == '!') ADVANCE(82);
      if (lookahead == '"') ADVANCE(164);
      if (lookahead == '%') ADVANCE(149);
      if (lookahead == '&') ADVANCE(133);
      if (lookahead == '\'') ADVANCE(171);
      if (lookahead == '(') ADVANCE(83);
      if (lookahead == '*') ADVANCE(73);
      if (lookahead == '+') ADVANCE(143);
      if (lookahead == ',') ADVANCE(79);
      if (lookahead == '-') ADVANCE(146);
      if (lookahead == '.') ADVANCE(99);
      if (lookahead == '/') ADVANCE(95);
      if (lookahead == '0') ADVANCE(193);
      if (lookahead == ':') ADVANCE(86);
      if (lookahead == '<') ADVANCE(91);
      if (lookahead == '=') ADVANCE(75);
      if (lookahead == '>') ADVANCE(94);
      if (lookahead == '?') ADVANCE(120);
      if (lookahead == '@') ADVANCE(204);
      if (lookahead == '[') ADVANCE(87);
      if (lookahead == '\\') ADVANCE(34);
      if (lookahead == '^') ADVANCE(134);
      if (lookahead == '`') ADVANCE(186);
      if (lookahead == '{') ADVANCE(78);
      if (lookahead == '|') ADVANCE(139);
      if (lookahead == '~') ADVANCE(161);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(8)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(194);
      if (lookahead != 0 &&
          (lookahead < 0 || '#' < lookahead) &&
          (lookahead < ')' || ';' < lookahead) &&
          lookahead != ']' &&
          lookahead != '}') ADVANCE(203);
      END_STATE();
    case 9:
      if (lookahead == '!') ADVANCE(82);
      if (lookahead == '%') ADVANCE(149);
      if (lookahead == '&') ADVANCE(133);
      if (lookahead == '(') ADVANCE(83);
      if (lookahead == ')') ADVANCE(84);
      if (lookahead == '*') ADVANCE(73);
      if (lookahead == '+') ADVANCE(143);
      if (lookahead == ',') ADVANCE(79);
      if (lookahead == '-') ADVANCE(146);
      if (lookahead == '.') ADVANCE(97);
      if (lookahead == '/') ADVANCE(95);
      if (lookahead == ':') ADVANCE(86);
      if (lookahead == ';') ADVANCE(85);
      if (lookahead == '<') ADVANCE(91);
      if (lookahead == '=') ADVANCE(30);
      if (lookahead == '>') ADVANCE(94);
      if (lookahead == '?') ADVANCE(120);
      if (lookahead == '[') ADVANCE(87);
      if (lookahead == '\\') ADVANCE(34);
      if (lookahead == ']') ADVANCE(88);
      if (lookahead == '^') ADVANCE(134);
      if (lookahead == '`') ADVANCE(186);
      if (lookahead == '{') ADVANCE(77);
      if (lookahead == '|') ADVANCE(139);
      if (lookahead == '}') ADVANCE(80);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(10)
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(191);
      if (lookahead != 0 &&
          (lookahead < 0 || '#' < lookahead) &&
          (lookahead < '\'' || '@' < lookahead) &&
          lookahead != '~') ADVANCE(203);
      END_STATE();
    case 10:
      if (lookahead == '!') ADVANCE(82);
      if (lookahead == '%') ADVANCE(149);
      if (lookahead == '&') ADVANCE(133);
      if (lookahead == '(') ADVANCE(83);
      if (lookahead == ')') ADVANCE(84);
      if (lookahead == '*') ADVANCE(73);
      if (lookahead == '+') ADVANCE(143);
      if (lookahead == ',') ADVANCE(79);
      if (lookahead == '-') ADVANCE(146);
      if (lookahead == '.') ADVANCE(97);
      if (lookahead == '/') ADVANCE(95);
      if (lookahead == ':') ADVANCE(86);
      if (lookahead == ';') ADVANCE(85);
      if (lookahead == '<') ADVANCE(91);
      if (lookahead == '=') ADVANCE(30);
      if (lookahead == '>') ADVANCE(94);
      if (lookahead == '?') ADVANCE(120);
      if (lookahead == '[') ADVANCE(87);
      if (lookahead == '\\') ADVANCE(34);
      if (lookahead == ']') ADVANCE(88);
      if (lookahead == '^') ADVANCE(134);
      if (lookahead == '`') ADVANCE(186);
      if (lookahead == '{') ADVANCE(77);
      if (lookahead == '|') ADVANCE(139);
      if (lookahead == '}') ADVANCE(80);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(10)
      if (lookahead != 0 &&
          (lookahead < 0 || '#' < lookahead) &&
          (lookahead < '\'' || '@' < lookahead) &&
          lookahead != '~') ADVANCE(203);
      END_STATE();
    case 11:
      if (lookahead == '!') ADVANCE(82);
      if (lookahead == '%') ADVANCE(149);
      if (lookahead == '&') ADVANCE(133);
      if (lookahead == '(') ADVANCE(83);
      if (lookahead == '*') ADVANCE(73);
      if (lookahead == '+') ADVANCE(143);
      if (lookahead == ',') ADVANCE(79);
      if (lookahead == '-') ADVANCE(146);
      if (lookahead == '.') ADVANCE(97);
      if (lookahead == '/') ADVANCE(95);
      if (lookahead == '<') ADVANCE(91);
      if (lookahead == '=') ADVANCE(30);
      if (lookahead == '>') ADVANCE(94);
      if (lookahead == '?') ADVANCE(120);
      if (lookahead == '[') ADVANCE(87);
      if (lookahead == '\\') ADVANCE(34);
      if (lookahead == '^') ADVANCE(134);
      if (lookahead == '`') ADVANCE(186);
      if (lookahead == '{') ADVANCE(78);
      if (lookahead == '|') ADVANCE(139);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(12)
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(191);
      if (lookahead != 0 &&
          (lookahead < 0 || '#' < lookahead) &&
          (lookahead < '\'' || '@' < lookahead) &&
          lookahead != ']' &&
          lookahead != '}' &&
          lookahead != '~') ADVANCE(203);
      END_STATE();
    case 12:
      if (lookahead == '!') ADVANCE(82);
      if (lookahead == '%') ADVANCE(149);
      if (lookahead == '&') ADVANCE(133);
      if (lookahead == '(') ADVANCE(83);
      if (lookahead == '*') ADVANCE(73);
      if (lookahead == '+') ADVANCE(143);
      if (lookahead == ',') ADVANCE(79);
      if (lookahead == '-') ADVANCE(146);
      if (lookahead == '.') ADVANCE(97);
      if (lookahead == '/') ADVANCE(95);
      if (lookahead == '<') ADVANCE(91);
      if (lookahead == '=') ADVANCE(30);
      if (lookahead == '>') ADVANCE(94);
      if (lookahead == '?') ADVANCE(120);
      if (lookahead == '[') ADVANCE(87);
      if (lookahead == '\\') ADVANCE(34);
      if (lookahead == '^') ADVANCE(134);
      if (lookahead == '`') ADVANCE(186);
      if (lookahead == '{') ADVANCE(78);
      if (lookahead == '|') ADVANCE(139);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(12)
      if (lookahead != 0 &&
          (lookahead < 0 || '#' < lookahead) &&
          (lookahead < '\'' || '@' < lookahead) &&
          lookahead != ']' &&
          lookahead != '}' &&
          lookahead != '~') ADVANCE(203);
      END_STATE();
    case 13:
      if (lookahead == '!') ADVANCE(70);
      END_STATE();
    case 14:
      if (lookahead == '!') ADVANCE(81);
      if (lookahead == '"') ADVANCE(164);
      if (lookahead == '&') ADVANCE(131);
      if (lookahead == '\'') ADVANCE(171);
      if (lookahead == '(') ADVANCE(83);
      if (lookahead == ')') ADVANCE(84);
      if (lookahead == '*') ADVANCE(71);
      if (lookahead == '+') ADVANCE(143);
      if (lookahead == ',') ADVANCE(79);
      if (lookahead == '-') ADVANCE(146);
      if (lookahead == '.') ADVANCE(98);
      if (lookahead == '/') ADVANCE(95);
      if (lookahead == '0') ADVANCE(193);
      if (lookahead == '<') ADVANCE(89);
      if (lookahead == '?') ADVANCE(118);
      if (lookahead == '@') ADVANCE(204);
      if (lookahead == '[') ADVANCE(87);
      if (lookahead == '\\') ADVANCE(34);
      if (lookahead == '`') ADVANCE(186);
      if (lookahead == '{') ADVANCE(78);
      if (lookahead == '|') ADVANCE(136);
      if (lookahead == '~') ADVANCE(161);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(14)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(194);
      if (lookahead != 0 &&
          (lookahead < 0 || '#' < lookahead) &&
          (lookahead < '%' || '>' < lookahead) &&
          lookahead != ']' &&
          lookahead != '^' &&
          lookahead != '}') ADVANCE(203);
      END_STATE();
    case 15:
      if (lookahead == '"') ADVANCE(164);
      if (lookahead == '&') ADVANCE(131);
      if (lookahead == '\'') ADVANCE(171);
      if (lookahead == '(') ADVANCE(83);
      if (lookahead == ')') ADVANCE(84);
      if (lookahead == '*') ADVANCE(71);
      if (lookahead == '+') ADVANCE(142);
      if (lookahead == ',') ADVANCE(79);
      if (lookahead == '-') ADVANCE(145);
      if (lookahead == '.') ADVANCE(25);
      if (lookahead == '/') ADVANCE(188);
      if (lookahead == '0') ADVANCE(193);
      if (lookahead == ':') ADVANCE(86);
      if (lookahead == ';') ADVANCE(85);
      if (lookahead == '<') ADVANCE(89);
      if (lookahead == '=') ADVANCE(74);
      if (lookahead == '>') ADVANCE(92);
      if (lookahead == '?') ADVANCE(118);
      if (lookahead == '@') ADVANCE(204);
      if (lookahead == '[') ADVANCE(87);
      if (lookahead == '\\') ADVANCE(34);
      if (lookahead == ']') ADVANCE(88);
      if (lookahead == '`') ADVANCE(186);
      if (lookahead == '{') ADVANCE(78);
      if (lookahead == '|') ADVANCE(141);
      if (lookahead == '}') ADVANCE(80);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(16)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(194);
      if (lookahead != 0 &&
          (lookahead < 0 || '#' < lookahead) &&
          lookahead != '%' &&
          lookahead != '^' &&
          lookahead != '~') ADVANCE(203);
      END_STATE();
    case 16:
      if (lookahead == '"') ADVANCE(164);
      if (lookahead == '&') ADVANCE(131);
      if (lookahead == '\'') ADVANCE(171);
      if (lookahead == '(') ADVANCE(83);
      if (lookahead == ')') ADVANCE(84);
      if (lookahead == '*') ADVANCE(71);
      if (lookahead == '+') ADVANCE(142);
      if (lookahead == ',') ADVANCE(79);
      if (lookahead == '-') ADVANCE(145);
      if (lookahead == '.') ADVANCE(25);
      if (lookahead == '/') ADVANCE(22);
      if (lookahead == '0') ADVANCE(193);
      if (lookahead == ':') ADVANCE(86);
      if (lookahead == ';') ADVANCE(85);
      if (lookahead == '<') ADVANCE(89);
      if (lookahead == '=') ADVANCE(74);
      if (lookahead == '>') ADVANCE(92);
      if (lookahead == '?') ADVANCE(118);
      if (lookahead == '@') ADVANCE(204);
      if (lookahead == '[') ADVANCE(87);
      if (lookahead == '\\') ADVANCE(34);
      if (lookahead == ']') ADVANCE(88);
      if (lookahead == '`') ADVANCE(186);
      if (lookahead == '{') ADVANCE(78);
      if (lookahead == '|') ADVANCE(141);
      if (lookahead == '}') ADVANCE(80);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(16)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(194);
      if (lookahead != 0 &&
          (lookahead < 0 || '#' < lookahead) &&
          lookahead != '%' &&
          lookahead != '^' &&
          lookahead != '~') ADVANCE(203);
      END_STATE();
    case 17:
      if (lookahead == '"') ADVANCE(164);
      if (lookahead == '\'') ADVANCE(171);
      if (lookahead == '(') ADVANCE(83);
      if (lookahead == '*') ADVANCE(71);
      if (lookahead == ',') ADVANCE(79);
      if (lookahead == '-') ADVANCE(145);
      if (lookahead == '.') ADVANCE(98);
      if (lookahead == '/') ADVANCE(22);
      if (lookahead == '0') ADVANCE(193);
      if (lookahead == ';') ADVANCE(85);
      if (lookahead == '<') ADVANCE(89);
      if (lookahead == '@') ADVANCE(204);
      if (lookahead == '[') ADVANCE(87);
      if (lookahead == '\\') ADVANCE(34);
      if (lookahead == '{') ADVANCE(77);
      if (lookahead == '|') ADVANCE(42);
      if (lookahead == '}') ADVANCE(80);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(17)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(194);
      if (lookahead != 0 &&
          (lookahead < 0 || '#' < lookahead) &&
          (lookahead < '%' || '?' < lookahead) &&
          lookahead != ']' &&
          lookahead != '^' &&
          lookahead != '`' &&
          lookahead != '~') ADVANCE(203);
      END_STATE();
    case 18:
      if (lookahead == '"') ADVANCE(164);
      if (lookahead == '/') ADVANCE(22);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(18)
      END_STATE();
    case 19:
      if (lookahead == '$') ADVANCE(36);
      if (lookahead == '-') ADVANCE(31);
      if (lookahead == '/') ADVANCE(22);
      if (lookahead == ':') ADVANCE(86);
      if (lookahead == '?') ADVANCE(29);
      if (lookahead == '\\') ADVANCE(35);
      if (lookahead == '`') ADVANCE(186);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(20)
      END_STATE();
    case 20:
      if (lookahead == '$') ADVANCE(36);
      if (lookahead == '-') ADVANCE(31);
      if (lookahead == '/') ADVANCE(22);
      if (lookahead == ':') ADVANCE(86);
      if (lookahead == '?') ADVANCE(29);
      if (lookahead == '`') ADVANCE(186);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(20)
      END_STATE();
    case 21:
      if (lookahead == '\'') ADVANCE(171);
      if (lookahead == '/') ADVANCE(22);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(21)
      END_STATE();
    case 22:
      if (lookahead == '*') ADVANCE(24);
      if (lookahead == '/') ADVANCE(185);
      END_STATE();
    case 23:
      if (lookahead == '*') ADVANCE(23);
      if (lookahead == '/') ADVANCE(184);
      if (lookahead != 0) ADVANCE(24);
      END_STATE();
    case 24:
      if (lookahead == '*') ADVANCE(23);
      if (lookahead != 0) ADVANCE(24);
      END_STATE();
    case 25:
      if (lookahead == '.') ADVANCE(26);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(200);
      END_STATE();
    case 26:
      if (lookahead == '.') ADVANCE(117);
      END_STATE();
    case 27:
      if (lookahead == '/') ADVANCE(22);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(27)
      END_STATE();
    case 28:
      if (lookahead == ':') ADVANCE(205);
      END_STATE();
    case 29:
      if (lookahead == ':') ADVANCE(206);
      END_STATE();
    case 30:
      if (lookahead == '=') ADVANCE(154);
      END_STATE();
    case 31:
      if (lookahead == '?') ADVANCE(28);
      END_STATE();
    case 32:
      if (lookahead == '\\') ADVANCE(64);
      if (lookahead == ']') ADVANCE(190);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(32);
      END_STATE();
    case 33:
      if (lookahead == 'u') ADVANCE(37);
      if (lookahead == 'x') ADVANCE(59);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(183);
      if (lookahead != 0) ADVANCE(178);
      END_STATE();
    case 34:
      if (lookahead == 'u') ADVANCE(38);
      END_STATE();
    case 35:
      if (lookahead == 'u') ADVANCE(39);
      if (lookahead == 'x') ADVANCE(59);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(183);
      if (lookahead != 0) ADVANCE(178);
      END_STATE();
    case 36:
      if (lookahead == '{') ADVANCE(187);
      END_STATE();
    case 37:
      if (lookahead == '{') ADVANCE(54);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(62);
      END_STATE();
    case 38:
      if (lookahead == '{') ADVANCE(57);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(63);
      END_STATE();
    case 39:
      if (lookahead == '{') ADVANCE(58);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(56);
      END_STATE();
    case 40:
      if (lookahead == '}') ADVANCE(203);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(40);
      END_STATE();
    case 41:
      if (lookahead == '}') ADVANCE(178);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(41);
      END_STATE();
    case 42:
      if (lookahead == '}') ADVANCE(208);
      END_STATE();
    case 43:
      if (lookahead == '}') ADVANCE(181);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(43);
      END_STATE();
    case 44:
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(50);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(199);
      END_STATE();
    case 45:
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(195);
      END_STATE();
    case 46:
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(196);
      END_STATE();
    case 47:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(194);
      END_STATE();
    case 48:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(200);
      END_STATE();
    case 49:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(198);
      END_STATE();
    case 50:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(199);
      END_STATE();
    case 51:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(203);
      END_STATE();
    case 52:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(178);
      END_STATE();
    case 53:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(197);
      END_STATE();
    case 54:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(43);
      END_STATE();
    case 55:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(181);
      END_STATE();
    case 56:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(59);
      END_STATE();
    case 57:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(40);
      END_STATE();
    case 58:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(41);
      END_STATE();
    case 59:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(52);
      END_STATE();
    case 60:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(55);
      END_STATE();
    case 61:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(51);
      END_STATE();
    case 62:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(60);
      END_STATE();
    case 63:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(61);
      END_STATE();
    case 64:
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(32);
      END_STATE();
    case 65:
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(190);
      END_STATE();
    case 66:
      if (eof) ADVANCE(69);
      if (lookahead == '!') ADVANCE(82);
      if (lookahead == '"') ADVANCE(164);
      if (lookahead == '#') ADVANCE(13);
      if (lookahead == '$') ADVANCE(202);
      if (lookahead == '%') ADVANCE(150);
      if (lookahead == '&') ADVANCE(132);
      if (lookahead == '\'') ADVANCE(171);
      if (lookahead == '(') ADVANCE(83);
      if (lookahead == ')') ADVANCE(84);
      if (lookahead == '*') ADVANCE(72);
      if (lookahead == '+') ADVANCE(144);
      if (lookahead == ',') ADVANCE(79);
      if (lookahead == '-') ADVANCE(148);
      if (lookahead == '.') ADVANCE(98);
      if (lookahead == '/') ADVANCE(95);
      if (lookahead == '0') ADVANCE(193);
      if (lookahead == ':') ADVANCE(86);
      if (lookahead == ';') ADVANCE(85);
      if (lookahead == '<') ADVANCE(90);
      if (lookahead == '=') ADVANCE(75);
      if (lookahead == '>') ADVANCE(93);
      if (lookahead == '?') ADVANCE(119);
      if (lookahead == '@') ADVANCE(204);
      if (lookahead == '[') ADVANCE(87);
      if (lookahead == '\\') ADVANCE(34);
      if (lookahead == ']') ADVANCE(88);
      if (lookahead == '^') ADVANCE(135);
      if (lookahead == '`') ADVANCE(186);
      if (lookahead == '{') ADVANCE(78);
      if (lookahead == '|') ADVANCE(138);
      if (lookahead == '}') ADVANCE(80);
      if (lookahead == '~') ADVANCE(161);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(66)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(194);
      if (lookahead != 0 &&
          (lookahead < 0 || 31 < lookahead)) ADVANCE(203);
      END_STATE();
    case 67:
      if (eof) ADVANCE(69);
      if (lookahead == '!') ADVANCE(82);
      if (lookahead == '"') ADVANCE(164);
      if (lookahead == '%') ADVANCE(149);
      if (lookahead == '&') ADVANCE(133);
      if (lookahead == '\'') ADVANCE(171);
      if (lookahead == '(') ADVANCE(83);
      if (lookahead == ')') ADVANCE(84);
      if (lookahead == '*') ADVANCE(73);
      if (lookahead == '+') ADVANCE(143);
      if (lookahead == ',') ADVANCE(79);
      if (lookahead == '-') ADVANCE(146);
      if (lookahead == '.') ADVANCE(99);
      if (lookahead == '/') ADVANCE(95);
      if (lookahead == '0') ADVANCE(193);
      if (lookahead == ':') ADVANCE(86);
      if (lookahead == ';') ADVANCE(85);
      if (lookahead == '<') ADVANCE(91);
      if (lookahead == '=') ADVANCE(75);
      if (lookahead == '>') ADVANCE(94);
      if (lookahead == '?') ADVANCE(120);
      if (lookahead == '@') ADVANCE(204);
      if (lookahead == '[') ADVANCE(87);
      if (lookahead == '\\') ADVANCE(34);
      if (lookahead == ']') ADVANCE(88);
      if (lookahead == '^') ADVANCE(134);
      if (lookahead == '`') ADVANCE(186);
      if (lookahead == '{') ADVANCE(77);
      if (lookahead == '|') ADVANCE(140);
      if (lookahead == '}') ADVANCE(80);
      if (lookahead == '~') ADVANCE(161);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(67)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(194);
      if (lookahead != 0 &&
          (lookahead < 0 || '#' < lookahead)) ADVANCE(203);
      END_STATE();
    case 68:
      if (eof) ADVANCE(69);
      if (lookahead == '!') ADVANCE(81);
      if (lookahead == '"') ADVANCE(164);
      if (lookahead == '#') ADVANCE(13);
      if (lookahead == '&') ADVANCE(131);
      if (lookahead == '\'') ADVANCE(171);
      if (lookahead == '(') ADVANCE(83);
      if (lookahead == ')') ADVANCE(84);
      if (lookahead == '*') ADVANCE(71);
      if (lookahead == '+') ADVANCE(143);
      if (lookahead == ',') ADVANCE(79);
      if (lookahead == '-') ADVANCE(146);
      if (lookahead == '.') ADVANCE(98);
      if (lookahead == '/') ADVANCE(95);
      if (lookahead == '0') ADVANCE(193);
      if (lookahead == ':') ADVANCE(86);
      if (lookahead == ';') ADVANCE(85);
      if (lookahead == '<') ADVANCE(89);
      if (lookahead == '=') ADVANCE(76);
      if (lookahead == '>') ADVANCE(92);
      if (lookahead == '?') ADVANCE(118);
      if (lookahead == '@') ADVANCE(204);
      if (lookahead == '[') ADVANCE(87);
      if (lookahead == '\\') ADVANCE(34);
      if (lookahead == ']') ADVANCE(88);
      if (lookahead == '`') ADVANCE(186);
      if (lookahead == '{') ADVANCE(77);
      if (lookahead == '|') ADVANCE(141);
      if (lookahead == '}') ADVANCE(80);
      if (lookahead == '~') ADVANCE(161);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(68)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(194);
      if (lookahead != 0 &&
          (lookahead < 0 || 31 < lookahead) &&
          lookahead != '%' &&
          lookahead != '^') ADVANCE(203);
      END_STATE();
    case 69:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(sym_hash_bang_line);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(70);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '*') ADVANCE(152);
      if (lookahead == '=') ADVANCE(104);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '*') ADVANCE(151);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(154);
      if (lookahead == '>') ADVANCE(100);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '>') ADVANCE(100);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      if (lookahead == '|') ADVANCE(207);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 80:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(anon_sym_BANG);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '=') ADVANCE(156);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(anon_sym_LT);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(130);
      if (lookahead == '=') ADVANCE(153);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(129);
      if (lookahead == '=') ADVANCE(153);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(anon_sym_GT);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(158);
      if (lookahead == '>') ADVANCE(125);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(158);
      if (lookahead == '>') ADVANCE(126);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(24);
      if (lookahead == '/') ADVANCE(185);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(24);
      if (lookahead == '/') ADVANCE(185);
      if (lookahead == '=') ADVANCE(105);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(26);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(200);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(200);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(anon_sym_EQ_GT);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(anon_sym_QMARK_DOT);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(anon_sym_DASH_EQ);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(anon_sym_STAR_EQ);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(anon_sym_SLASH_EQ);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(anon_sym_PERCENT_EQ);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(anon_sym_CARET_EQ);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(anon_sym_AMP_EQ);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(anon_sym_PIPE_EQ);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(anon_sym_GT_GT_EQ);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(anon_sym_GT_GT_GT_EQ);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(anon_sym_LT_LT_EQ);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(anon_sym_STAR_STAR_EQ);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(anon_sym_AMP_AMP_EQ);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE_EQ);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(anon_sym_QMARK_QMARK_EQ);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(anon_sym_DOT_DOT_DOT);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(anon_sym_QMARK);
      if (lookahead == '.') ADVANCE(101);
      if (lookahead == '?') ADVANCE(160);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(anon_sym_QMARK);
      if (lookahead == '.') ADVANCE(101);
      if (lookahead == '?') ADVANCE(159);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      if (lookahead == '=') ADVANCE(114);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      if (lookahead == '=') ADVANCE(115);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '=') ADVANCE(110);
      if (lookahead == '>') ADVANCE(128);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '>') ADVANCE(127);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(anon_sym_GT_GT_GT);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(anon_sym_GT_GT_GT);
      if (lookahead == '=') ADVANCE(111);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      if (lookahead == '=') ADVANCE(112);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(anon_sym_AMP);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(122);
      if (lookahead == '=') ADVANCE(108);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(121);
      END_STATE();
    case 134:
      ACCEPT_TOKEN(anon_sym_CARET);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(anon_sym_CARET);
      if (lookahead == '=') ADVANCE(107);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(anon_sym_PIPE);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '=') ADVANCE(109);
      if (lookahead == '|') ADVANCE(124);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '=') ADVANCE(109);
      if (lookahead == '|') ADVANCE(124);
      if (lookahead == '}') ADVANCE(208);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '|') ADVANCE(123);
      END_STATE();
    case 140:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '|') ADVANCE(123);
      if (lookahead == '}') ADVANCE(208);
      END_STATE();
    case 141:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '}') ADVANCE(208);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(anon_sym_PLUS);
      END_STATE();
    case 143:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(162);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(162);
      if (lookahead == '=') ADVANCE(102);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(anon_sym_DASH);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(163);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(163);
      if (lookahead == '=') ADVANCE(103);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(163);
      if (lookahead == '=') ADVANCE(103);
      if (lookahead == '?') ADVANCE(28);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      END_STATE();
    case 150:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      if (lookahead == '=') ADVANCE(106);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(anon_sym_STAR_STAR);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(anon_sym_STAR_STAR);
      if (lookahead == '=') ADVANCE(113);
      END_STATE();
    case 153:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      END_STATE();
    case 154:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      if (lookahead == '=') ADVANCE(155);
      END_STATE();
    case 155:
      ACCEPT_TOKEN(anon_sym_EQ_EQ_EQ);
      END_STATE();
    case 156:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      if (lookahead == '=') ADVANCE(157);
      END_STATE();
    case 157:
      ACCEPT_TOKEN(anon_sym_BANG_EQ_EQ);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 159:
      ACCEPT_TOKEN(anon_sym_QMARK_QMARK);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(anon_sym_QMARK_QMARK);
      if (lookahead == '=') ADVANCE(116);
      END_STATE();
    case 161:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 162:
      ACCEPT_TOKEN(anon_sym_PLUS_PLUS);
      END_STATE();
    case 163:
      ACCEPT_TOKEN(anon_sym_DASH_DASH);
      END_STATE();
    case 164:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 165:
      ACCEPT_TOKEN(aux_sym_string_token1);
      END_STATE();
    case 166:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead == '*') ADVANCE(168);
      if (lookahead == '/') ADVANCE(170);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(170);
      END_STATE();
    case 167:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead == '*') ADVANCE(167);
      if (lookahead == '/') ADVANCE(170);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(168);
      END_STATE();
    case 168:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead == '*') ADVANCE(167);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(168);
      END_STATE();
    case 169:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead == '/') ADVANCE(166);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(169);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(170);
      END_STATE();
    case 170:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(170);
      END_STATE();
    case 171:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      END_STATE();
    case 172:
      ACCEPT_TOKEN(aux_sym_string_token2);
      END_STATE();
    case 173:
      ACCEPT_TOKEN(aux_sym_string_token2);
      if (lookahead == '*') ADVANCE(175);
      if (lookahead == '/') ADVANCE(177);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(177);
      END_STATE();
    case 174:
      ACCEPT_TOKEN(aux_sym_string_token2);
      if (lookahead == '*') ADVANCE(174);
      if (lookahead == '/') ADVANCE(177);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(175);
      END_STATE();
    case 175:
      ACCEPT_TOKEN(aux_sym_string_token2);
      if (lookahead == '*') ADVANCE(174);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(175);
      END_STATE();
    case 176:
      ACCEPT_TOKEN(aux_sym_string_token2);
      if (lookahead == '/') ADVANCE(173);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(176);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(177);
      END_STATE();
    case 177:
      ACCEPT_TOKEN(aux_sym_string_token2);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(177);
      END_STATE();
    case 178:
      ACCEPT_TOKEN(sym_escape_sequence);
      END_STATE();
    case 179:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (lookahead == '\n') ADVANCE(165);
      END_STATE();
    case 180:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (lookahead == '\n') ADVANCE(172);
      END_STATE();
    case 181:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (lookahead == '\\') ADVANCE(34);
      if (!sym_identifier_character_set_1(lookahead)) ADVANCE(203);
      END_STATE();
    case 182:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(178);
      END_STATE();
    case 183:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(182);
      END_STATE();
    case 184:
      ACCEPT_TOKEN(sym_comment);
      END_STATE();
    case 185:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(185);
      END_STATE();
    case 186:
      ACCEPT_TOKEN(anon_sym_BQUOTE);
      END_STATE();
    case 187:
      ACCEPT_TOKEN(anon_sym_DOLLAR_LBRACE);
      END_STATE();
    case 188:
      ACCEPT_TOKEN(anon_sym_SLASH2);
      if (lookahead == '*') ADVANCE(24);
      if (lookahead == '/') ADVANCE(185);
      END_STATE();
    case 189:
      ACCEPT_TOKEN(sym_regex_pattern);
      if (lookahead == '/') ADVANCE(22);
      if (lookahead == '[') ADVANCE(32);
      if (lookahead == '\\') ADVANCE(65);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(189);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(190);
      END_STATE();
    case 190:
      ACCEPT_TOKEN(sym_regex_pattern);
      if (lookahead == '[') ADVANCE(32);
      if (lookahead == '\\') ADVANCE(65);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '/') ADVANCE(190);
      END_STATE();
    case 191:
      ACCEPT_TOKEN(sym_regex_flags);
      if (lookahead == '\\') ADVANCE(34);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(191);
      if (lookahead != 0 &&
          (lookahead < 0 || '#' < lookahead) &&
          (lookahead < '%' || '/' < lookahead) &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          (lookahead < '`' || '~' < lookahead) &&
          lookahead != 160 &&
          lookahead != 8203 &&
          lookahead != 8288 &&
          lookahead != 65279) ADVANCE(203);
      END_STATE();
    case 192:
      ACCEPT_TOKEN(sym_number);
      END_STATE();
    case 193:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '.') ADVANCE(201);
      if (lookahead == '0') ADVANCE(198);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(45);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(44);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(46);
      if (lookahead == 'X' ||
          lookahead == 'x') ADVANCE(53);
      if (lookahead == '_') ADVANCE(49);
      if (lookahead == 'n') ADVANCE(192);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(194);
      END_STATE();
    case 194:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '.') ADVANCE(201);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(44);
      if (lookahead == '_') ADVANCE(47);
      if (lookahead == 'n') ADVANCE(192);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(194);
      END_STATE();
    case 195:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(45);
      if (lookahead == 'n') ADVANCE(192);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(195);
      END_STATE();
    case 196:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(46);
      if (lookahead == 'n') ADVANCE(192);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(196);
      END_STATE();
    case 197:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(53);
      if (lookahead == 'n') ADVANCE(192);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(197);
      END_STATE();
    case 198:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(49);
      if (lookahead == 'n') ADVANCE(192);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(198);
      END_STATE();
    case 199:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(50);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(199);
      END_STATE();
    case 200:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(44);
      if (lookahead == '_') ADVANCE(48);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(200);
      END_STATE();
    case 201:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(44);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(200);
      END_STATE();
    case 202:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(34);
      if (lookahead == '{') ADVANCE(187);
      if (lookahead != 0 &&
          (lookahead < 0 || '#' < lookahead) &&
          (lookahead < '%' || '/' < lookahead) &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '|' || '~' < lookahead) &&
          lookahead != 160 &&
          lookahead != 8203 &&
          lookahead != 8288 &&
          lookahead != 65279) ADVANCE(203);
      END_STATE();
    case 203:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(34);
      if (!sym_identifier_character_set_1(lookahead)) ADVANCE(203);
      END_STATE();
    case 204:
      ACCEPT_TOKEN(anon_sym_AT);
      END_STATE();
    case 205:
      ACCEPT_TOKEN(anon_sym_DASH_QMARK_COLON);
      END_STATE();
    case 206:
      ACCEPT_TOKEN(anon_sym_QMARK_COLON);
      END_STATE();
    case 207:
      ACCEPT_TOKEN(anon_sym_LBRACE_PIPE);
      END_STATE();
    case 208:
      ACCEPT_TOKEN(anon_sym_PIPE_RBRACE);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (lookahead == 'a') ADVANCE(1);
      if (lookahead == 'b') ADVANCE(2);
      if (lookahead == 'c') ADVANCE(3);
      if (lookahead == 'd') ADVANCE(4);
      if (lookahead == 'e') ADVANCE(5);
      if (lookahead == 'f') ADVANCE(6);
      if (lookahead == 'g') ADVANCE(7);
      if (lookahead == 'i') ADVANCE(8);
      if (lookahead == 'k') ADVANCE(9);
      if (lookahead == 'l') ADVANCE(10);
      if (lookahead == 'm') ADVANCE(11);
      if (lookahead == 'n') ADVANCE(12);
      if (lookahead == 'o') ADVANCE(13);
      if (lookahead == 'p') ADVANCE(14);
      if (lookahead == 'r') ADVANCE(15);
      if (lookahead == 's') ADVANCE(16);
      if (lookahead == 't') ADVANCE(17);
      if (lookahead == 'u') ADVANCE(18);
      if (lookahead == 'v') ADVANCE(19);
      if (lookahead == 'w') ADVANCE(20);
      if (lookahead == 'y') ADVANCE(21);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(0)
      END_STATE();
    case 1:
      if (lookahead == 'b') ADVANCE(22);
      if (lookahead == 'n') ADVANCE(23);
      if (lookahead == 's') ADVANCE(24);
      if (lookahead == 'w') ADVANCE(25);
      END_STATE();
    case 2:
      if (lookahead == 'o') ADVANCE(26);
      if (lookahead == 'r') ADVANCE(27);
      END_STATE();
    case 3:
      if (lookahead == 'a') ADVANCE(28);
      if (lookahead == 'l') ADVANCE(29);
      if (lookahead == 'o') ADVANCE(30);
      END_STATE();
    case 4:
      if (lookahead == 'e') ADVANCE(31);
      if (lookahead == 'o') ADVANCE(32);
      END_STATE();
    case 5:
      if (lookahead == 'l') ADVANCE(33);
      if (lookahead == 'n') ADVANCE(34);
      if (lookahead == 'x') ADVANCE(35);
      END_STATE();
    case 6:
      if (lookahead == 'a') ADVANCE(36);
      if (lookahead == 'i') ADVANCE(37);
      if (lookahead == 'o') ADVANCE(38);
      if (lookahead == 'r') ADVANCE(39);
      if (lookahead == 'u') ADVANCE(40);
      END_STATE();
    case 7:
      if (lookahead == 'e') ADVANCE(41);
      if (lookahead == 'l') ADVANCE(42);
      END_STATE();
    case 8:
      if (lookahead == 'f') ADVANCE(43);
      if (lookahead == 'm') ADVANCE(44);
      if (lookahead == 'n') ADVANCE(45);
      if (lookahead == 's') ADVANCE(46);
      END_STATE();
    case 9:
      if (lookahead == 'e') ADVANCE(47);
      END_STATE();
    case 10:
      if (lookahead == 'e') ADVANCE(48);
      END_STATE();
    case 11:
      if (lookahead == 'o') ADVANCE(49);
      END_STATE();
    case 12:
      if (lookahead == 'a') ADVANCE(50);
      if (lookahead == 'e') ADVANCE(51);
      if (lookahead == 'u') ADVANCE(52);
      END_STATE();
    case 13:
      if (lookahead == 'f') ADVANCE(53);
      END_STATE();
    case 14:
      if (lookahead == 'r') ADVANCE(54);
      if (lookahead == 'u') ADVANCE(55);
      END_STATE();
    case 15:
      if (lookahead == 'e') ADVANCE(56);
      END_STATE();
    case 16:
      if (lookahead == 'e') ADVANCE(57);
      if (lookahead == 't') ADVANCE(58);
      if (lookahead == 'u') ADVANCE(59);
      if (lookahead == 'w') ADVANCE(60);
      if (lookahead == 'y') ADVANCE(61);
      END_STATE();
    case 17:
      if (lookahead == 'a') ADVANCE(62);
      if (lookahead == 'h') ADVANCE(63);
      if (lookahead == 'r') ADVANCE(64);
      if (lookahead == 'y') ADVANCE(65);
      END_STATE();
    case 18:
      if (lookahead == 'n') ADVANCE(66);
      END_STATE();
    case 19:
      if (lookahead == 'a') ADVANCE(67);
      if (lookahead == 'o') ADVANCE(68);
      END_STATE();
    case 20:
      if (lookahead == 'h') ADVANCE(69);
      if (lookahead == 'i') ADVANCE(70);
      END_STATE();
    case 21:
      if (lookahead == 'i') ADVANCE(71);
      END_STATE();
    case 22:
      if (lookahead == 's') ADVANCE(72);
      END_STATE();
    case 23:
      if (lookahead == 'y') ADVANCE(73);
      END_STATE();
    case 24:
      ACCEPT_TOKEN(anon_sym_as);
      if (lookahead == 's') ADVANCE(74);
      if (lookahead == 'y') ADVANCE(75);
      END_STATE();
    case 25:
      if (lookahead == 'a') ADVANCE(76);
      END_STATE();
    case 26:
      if (lookahead == 'o') ADVANCE(77);
      END_STATE();
    case 27:
      if (lookahead == 'e') ADVANCE(78);
      END_STATE();
    case 28:
      if (lookahead == 's') ADVANCE(79);
      if (lookahead == 't') ADVANCE(80);
      END_STATE();
    case 29:
      if (lookahead == 'a') ADVANCE(81);
      END_STATE();
    case 30:
      if (lookahead == 'n') ADVANCE(82);
      END_STATE();
    case 31:
      if (lookahead == 'b') ADVANCE(83);
      if (lookahead == 'c') ADVANCE(84);
      if (lookahead == 'f') ADVANCE(85);
      if (lookahead == 'l') ADVANCE(86);
      END_STATE();
    case 32:
      ACCEPT_TOKEN(anon_sym_do);
      END_STATE();
    case 33:
      if (lookahead == 's') ADVANCE(87);
      END_STATE();
    case 34:
      if (lookahead == 'u') ADVANCE(88);
      END_STATE();
    case 35:
      if (lookahead == 'p') ADVANCE(89);
      if (lookahead == 't') ADVANCE(90);
      END_STATE();
    case 36:
      if (lookahead == 'l') ADVANCE(91);
      END_STATE();
    case 37:
      if (lookahead == 'n') ADVANCE(92);
      END_STATE();
    case 38:
      if (lookahead == 'r') ADVANCE(93);
      END_STATE();
    case 39:
      if (lookahead == 'o') ADVANCE(94);
      END_STATE();
    case 40:
      if (lookahead == 'n') ADVANCE(95);
      END_STATE();
    case 41:
      if (lookahead == 't') ADVANCE(96);
      END_STATE();
    case 42:
      if (lookahead == 'o') ADVANCE(97);
      END_STATE();
    case 43:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 44:
      if (lookahead == 'p') ADVANCE(98);
      END_STATE();
    case 45:
      ACCEPT_TOKEN(anon_sym_in);
      if (lookahead == 'f') ADVANCE(99);
      if (lookahead == 's') ADVANCE(100);
      if (lookahead == 't') ADVANCE(101);
      END_STATE();
    case 46:
      ACCEPT_TOKEN(anon_sym_is);
      END_STATE();
    case 47:
      if (lookahead == 'y') ADVANCE(102);
      END_STATE();
    case 48:
      if (lookahead == 't') ADVANCE(103);
      END_STATE();
    case 49:
      if (lookahead == 'd') ADVANCE(104);
      END_STATE();
    case 50:
      if (lookahead == 'm') ADVANCE(105);
      END_STATE();
    case 51:
      if (lookahead == 'w') ADVANCE(106);
      END_STATE();
    case 52:
      if (lookahead == 'l') ADVANCE(107);
      if (lookahead == 'm') ADVANCE(108);
      END_STATE();
    case 53:
      ACCEPT_TOKEN(anon_sym_of);
      END_STATE();
    case 54:
      if (lookahead == 'i') ADVANCE(109);
      if (lookahead == 'o') ADVANCE(110);
      END_STATE();
    case 55:
      if (lookahead == 'b') ADVANCE(111);
      END_STATE();
    case 56:
      if (lookahead == 'a') ADVANCE(112);
      if (lookahead == 'q') ADVANCE(113);
      if (lookahead == 't') ADVANCE(114);
      END_STATE();
    case 57:
      if (lookahead == 't') ADVANCE(115);
      END_STATE();
    case 58:
      if (lookahead == 'a') ADVANCE(116);
      if (lookahead == 'r') ADVANCE(117);
      END_STATE();
    case 59:
      if (lookahead == 'p') ADVANCE(118);
      END_STATE();
    case 60:
      if (lookahead == 'i') ADVANCE(119);
      END_STATE();
    case 61:
      if (lookahead == 'm') ADVANCE(120);
      END_STATE();
    case 62:
      if (lookahead == 'r') ADVANCE(121);
      END_STATE();
    case 63:
      if (lookahead == 'i') ADVANCE(122);
      if (lookahead == 'r') ADVANCE(123);
      END_STATE();
    case 64:
      if (lookahead == 'u') ADVANCE(124);
      if (lookahead == 'y') ADVANCE(125);
      END_STATE();
    case 65:
      if (lookahead == 'p') ADVANCE(126);
      END_STATE();
    case 66:
      if (lookahead == 'd') ADVANCE(127);
      END_STATE();
    case 67:
      if (lookahead == 'r') ADVANCE(128);
      END_STATE();
    case 68:
      if (lookahead == 'i') ADVANCE(129);
      END_STATE();
    case 69:
      if (lookahead == 'i') ADVANCE(130);
      END_STATE();
    case 70:
      if (lookahead == 't') ADVANCE(131);
      END_STATE();
    case 71:
      if (lookahead == 'e') ADVANCE(132);
      END_STATE();
    case 72:
      if (lookahead == 't') ADVANCE(133);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(anon_sym_any);
      END_STATE();
    case 74:
      if (lookahead == 'e') ADVANCE(134);
      END_STATE();
    case 75:
      if (lookahead == 'n') ADVANCE(135);
      END_STATE();
    case 76:
      if (lookahead == 'i') ADVANCE(136);
      END_STATE();
    case 77:
      if (lookahead == 'l') ADVANCE(137);
      END_STATE();
    case 78:
      if (lookahead == 'a') ADVANCE(138);
      END_STATE();
    case 79:
      if (lookahead == 'e') ADVANCE(139);
      END_STATE();
    case 80:
      if (lookahead == 'c') ADVANCE(140);
      END_STATE();
    case 81:
      if (lookahead == 's') ADVANCE(141);
      END_STATE();
    case 82:
      if (lookahead == 's') ADVANCE(142);
      if (lookahead == 't') ADVANCE(143);
      END_STATE();
    case 83:
      if (lookahead == 'u') ADVANCE(144);
      END_STATE();
    case 84:
      if (lookahead == 'l') ADVANCE(145);
      END_STATE();
    case 85:
      if (lookahead == 'a') ADVANCE(146);
      END_STATE();
    case 86:
      if (lookahead == 'e') ADVANCE(147);
      END_STATE();
    case 87:
      if (lookahead == 'e') ADVANCE(148);
      END_STATE();
    case 88:
      if (lookahead == 'm') ADVANCE(149);
      END_STATE();
    case 89:
      if (lookahead == 'o') ADVANCE(150);
      END_STATE();
    case 90:
      if (lookahead == 'e') ADVANCE(151);
      END_STATE();
    case 91:
      if (lookahead == 's') ADVANCE(152);
      END_STATE();
    case 92:
      if (lookahead == 'a') ADVANCE(153);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(anon_sym_for);
      END_STATE();
    case 94:
      if (lookahead == 'm') ADVANCE(154);
      END_STATE();
    case 95:
      if (lookahead == 'c') ADVANCE(155);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(anon_sym_get);
      END_STATE();
    case 97:
      if (lookahead == 'b') ADVANCE(156);
      END_STATE();
    case 98:
      if (lookahead == 'l') ADVANCE(157);
      if (lookahead == 'o') ADVANCE(158);
      END_STATE();
    case 99:
      if (lookahead == 'e') ADVANCE(159);
      END_STATE();
    case 100:
      if (lookahead == 't') ADVANCE(160);
      END_STATE();
    case 101:
      if (lookahead == 'e') ADVANCE(161);
      END_STATE();
    case 102:
      if (lookahead == 'o') ADVANCE(162);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(anon_sym_let);
      END_STATE();
    case 104:
      if (lookahead == 'u') ADVANCE(163);
      END_STATE();
    case 105:
      if (lookahead == 'e') ADVANCE(164);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(anon_sym_new);
      END_STATE();
    case 107:
      if (lookahead == 'l') ADVANCE(165);
      END_STATE();
    case 108:
      if (lookahead == 'b') ADVANCE(166);
      END_STATE();
    case 109:
      if (lookahead == 'v') ADVANCE(167);
      END_STATE();
    case 110:
      if (lookahead == 't') ADVANCE(168);
      END_STATE();
    case 111:
      if (lookahead == 'l') ADVANCE(169);
      END_STATE();
    case 112:
      if (lookahead == 'd') ADVANCE(170);
      END_STATE();
    case 113:
      if (lookahead == 'u') ADVANCE(171);
      END_STATE();
    case 114:
      if (lookahead == 'u') ADVANCE(172);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(anon_sym_set);
      END_STATE();
    case 116:
      if (lookahead == 't') ADVANCE(173);
      END_STATE();
    case 117:
      if (lookahead == 'i') ADVANCE(174);
      END_STATE();
    case 118:
      if (lookahead == 'e') ADVANCE(175);
      END_STATE();
    case 119:
      if (lookahead == 't') ADVANCE(176);
      END_STATE();
    case 120:
      if (lookahead == 'b') ADVANCE(177);
      END_STATE();
    case 121:
      if (lookahead == 'g') ADVANCE(178);
      END_STATE();
    case 122:
      if (lookahead == 's') ADVANCE(179);
      END_STATE();
    case 123:
      if (lookahead == 'o') ADVANCE(180);
      END_STATE();
    case 124:
      if (lookahead == 'e') ADVANCE(181);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(anon_sym_try);
      END_STATE();
    case 126:
      if (lookahead == 'e') ADVANCE(182);
      END_STATE();
    case 127:
      if (lookahead == 'e') ADVANCE(183);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(anon_sym_var);
      END_STATE();
    case 129:
      if (lookahead == 'd') ADVANCE(184);
      END_STATE();
    case 130:
      if (lookahead == 'l') ADVANCE(185);
      END_STATE();
    case 131:
      if (lookahead == 'h') ADVANCE(186);
      END_STATE();
    case 132:
      if (lookahead == 'l') ADVANCE(187);
      END_STATE();
    case 133:
      if (lookahead == 'r') ADVANCE(188);
      END_STATE();
    case 134:
      if (lookahead == 'r') ADVANCE(189);
      END_STATE();
    case 135:
      if (lookahead == 'c') ADVANCE(190);
      END_STATE();
    case 136:
      if (lookahead == 't') ADVANCE(191);
      END_STATE();
    case 137:
      if (lookahead == 'e') ADVANCE(192);
      END_STATE();
    case 138:
      if (lookahead == 'k') ADVANCE(193);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(anon_sym_case);
      END_STATE();
    case 140:
      if (lookahead == 'h') ADVANCE(194);
      END_STATE();
    case 141:
      if (lookahead == 's') ADVANCE(195);
      END_STATE();
    case 142:
      if (lookahead == 't') ADVANCE(196);
      END_STATE();
    case 143:
      if (lookahead == 'i') ADVANCE(197);
      END_STATE();
    case 144:
      if (lookahead == 'g') ADVANCE(198);
      END_STATE();
    case 145:
      if (lookahead == 'a') ADVANCE(199);
      END_STATE();
    case 146:
      if (lookahead == 'u') ADVANCE(200);
      END_STATE();
    case 147:
      if (lookahead == 't') ADVANCE(201);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(anon_sym_enum);
      END_STATE();
    case 150:
      if (lookahead == 'r') ADVANCE(202);
      END_STATE();
    case 151:
      if (lookahead == 'n') ADVANCE(203);
      END_STATE();
    case 152:
      if (lookahead == 'e') ADVANCE(204);
      END_STATE();
    case 153:
      if (lookahead == 'l') ADVANCE(205);
      END_STATE();
    case 154:
      ACCEPT_TOKEN(anon_sym_from);
      END_STATE();
    case 155:
      if (lookahead == 't') ADVANCE(206);
      END_STATE();
    case 156:
      if (lookahead == 'a') ADVANCE(207);
      END_STATE();
    case 157:
      if (lookahead == 'e') ADVANCE(208);
      END_STATE();
    case 158:
      if (lookahead == 'r') ADVANCE(209);
      END_STATE();
    case 159:
      if (lookahead == 'r') ADVANCE(210);
      END_STATE();
    case 160:
      if (lookahead == 'a') ADVANCE(211);
      END_STATE();
    case 161:
      if (lookahead == 'r') ADVANCE(212);
      END_STATE();
    case 162:
      if (lookahead == 'f') ADVANCE(213);
      END_STATE();
    case 163:
      if (lookahead == 'l') ADVANCE(214);
      END_STATE();
    case 164:
      if (lookahead == 's') ADVANCE(215);
      END_STATE();
    case 165:
      ACCEPT_TOKEN(sym_null);
      END_STATE();
    case 166:
      if (lookahead == 'e') ADVANCE(216);
      END_STATE();
    case 167:
      if (lookahead == 'a') ADVANCE(217);
      END_STATE();
    case 168:
      if (lookahead == 'e') ADVANCE(218);
      END_STATE();
    case 169:
      if (lookahead == 'i') ADVANCE(219);
      END_STATE();
    case 170:
      if (lookahead == 'o') ADVANCE(220);
      END_STATE();
    case 171:
      if (lookahead == 'i') ADVANCE(221);
      END_STATE();
    case 172:
      if (lookahead == 'r') ADVANCE(222);
      END_STATE();
    case 173:
      if (lookahead == 'i') ADVANCE(223);
      END_STATE();
    case 174:
      if (lookahead == 'n') ADVANCE(224);
      END_STATE();
    case 175:
      if (lookahead == 'r') ADVANCE(225);
      END_STATE();
    case 176:
      if (lookahead == 'c') ADVANCE(226);
      END_STATE();
    case 177:
      if (lookahead == 'o') ADVANCE(227);
      END_STATE();
    case 178:
      if (lookahead == 'e') ADVANCE(228);
      END_STATE();
    case 179:
      ACCEPT_TOKEN(sym_this);
      END_STATE();
    case 180:
      if (lookahead == 'w') ADVANCE(229);
      END_STATE();
    case 181:
      ACCEPT_TOKEN(sym_true);
      END_STATE();
    case 182:
      ACCEPT_TOKEN(anon_sym_type);
      if (lookahead == 'o') ADVANCE(230);
      END_STATE();
    case 183:
      if (lookahead == 'f') ADVANCE(231);
      END_STATE();
    case 184:
      ACCEPT_TOKEN(anon_sym_void);
      END_STATE();
    case 185:
      if (lookahead == 'e') ADVANCE(232);
      END_STATE();
    case 186:
      ACCEPT_TOKEN(anon_sym_with);
      END_STATE();
    case 187:
      if (lookahead == 'd') ADVANCE(233);
      END_STATE();
    case 188:
      if (lookahead == 'a') ADVANCE(234);
      END_STATE();
    case 189:
      if (lookahead == 't') ADVANCE(235);
      END_STATE();
    case 190:
      ACCEPT_TOKEN(anon_sym_async);
      END_STATE();
    case 191:
      ACCEPT_TOKEN(anon_sym_await);
      END_STATE();
    case 192:
      if (lookahead == 'a') ADVANCE(236);
      END_STATE();
    case 193:
      ACCEPT_TOKEN(anon_sym_break);
      END_STATE();
    case 194:
      ACCEPT_TOKEN(anon_sym_catch);
      END_STATE();
    case 195:
      ACCEPT_TOKEN(anon_sym_class);
      END_STATE();
    case 196:
      ACCEPT_TOKEN(anon_sym_const);
      END_STATE();
    case 197:
      if (lookahead == 'n') ADVANCE(237);
      END_STATE();
    case 198:
      if (lookahead == 'g') ADVANCE(238);
      END_STATE();
    case 199:
      if (lookahead == 'r') ADVANCE(239);
      END_STATE();
    case 200:
      if (lookahead == 'l') ADVANCE(240);
      END_STATE();
    case 201:
      if (lookahead == 'e') ADVANCE(241);
      END_STATE();
    case 202:
      if (lookahead == 't') ADVANCE(242);
      END_STATE();
    case 203:
      if (lookahead == 'd') ADVANCE(243);
      END_STATE();
    case 204:
      ACCEPT_TOKEN(sym_false);
      END_STATE();
    case 205:
      if (lookahead == 'l') ADVANCE(244);
      END_STATE();
    case 206:
      if (lookahead == 'i') ADVANCE(245);
      END_STATE();
    case 207:
      if (lookahead == 'l') ADVANCE(246);
      END_STATE();
    case 208:
      if (lookahead == 'm') ADVANCE(247);
      END_STATE();
    case 209:
      if (lookahead == 't') ADVANCE(248);
      END_STATE();
    case 210:
      ACCEPT_TOKEN(anon_sym_infer);
      END_STATE();
    case 211:
      if (lookahead == 'n') ADVANCE(249);
      END_STATE();
    case 212:
      if (lookahead == 'f') ADVANCE(250);
      END_STATE();
    case 213:
      ACCEPT_TOKEN(anon_sym_keyof);
      END_STATE();
    case 214:
      if (lookahead == 'e') ADVANCE(251);
      END_STATE();
    case 215:
      if (lookahead == 'p') ADVANCE(252);
      END_STATE();
    case 216:
      if (lookahead == 'r') ADVANCE(253);
      END_STATE();
    case 217:
      if (lookahead == 't') ADVANCE(254);
      END_STATE();
    case 218:
      if (lookahead == 'c') ADVANCE(255);
      END_STATE();
    case 219:
      if (lookahead == 'c') ADVANCE(256);
      END_STATE();
    case 220:
      if (lookahead == 'n') ADVANCE(257);
      END_STATE();
    case 221:
      if (lookahead == 'r') ADVANCE(258);
      END_STATE();
    case 222:
      if (lookahead == 'n') ADVANCE(259);
      END_STATE();
    case 223:
      if (lookahead == 'c') ADVANCE(260);
      END_STATE();
    case 224:
      if (lookahead == 'g') ADVANCE(261);
      END_STATE();
    case 225:
      ACCEPT_TOKEN(sym_super);
      END_STATE();
    case 226:
      if (lookahead == 'h') ADVANCE(262);
      END_STATE();
    case 227:
      if (lookahead == 'l') ADVANCE(263);
      END_STATE();
    case 228:
      if (lookahead == 't') ADVANCE(264);
      END_STATE();
    case 229:
      ACCEPT_TOKEN(anon_sym_throw);
      END_STATE();
    case 230:
      if (lookahead == 'f') ADVANCE(265);
      END_STATE();
    case 231:
      if (lookahead == 'i') ADVANCE(266);
      END_STATE();
    case 232:
      ACCEPT_TOKEN(anon_sym_while);
      END_STATE();
    case 233:
      ACCEPT_TOKEN(anon_sym_yield);
      END_STATE();
    case 234:
      if (lookahead == 'c') ADVANCE(267);
      END_STATE();
    case 235:
      if (lookahead == 's') ADVANCE(268);
      END_STATE();
    case 236:
      if (lookahead == 'n') ADVANCE(269);
      END_STATE();
    case 237:
      if (lookahead == 'u') ADVANCE(270);
      END_STATE();
    case 238:
      if (lookahead == 'e') ADVANCE(271);
      END_STATE();
    case 239:
      if (lookahead == 'e') ADVANCE(272);
      END_STATE();
    case 240:
      if (lookahead == 't') ADVANCE(273);
      END_STATE();
    case 241:
      ACCEPT_TOKEN(anon_sym_delete);
      END_STATE();
    case 242:
      ACCEPT_TOKEN(anon_sym_export);
      END_STATE();
    case 243:
      if (lookahead == 's') ADVANCE(274);
      END_STATE();
    case 244:
      if (lookahead == 'y') ADVANCE(275);
      END_STATE();
    case 245:
      if (lookahead == 'o') ADVANCE(276);
      END_STATE();
    case 246:
      ACCEPT_TOKEN(anon_sym_global);
      END_STATE();
    case 247:
      if (lookahead == 'e') ADVANCE(277);
      END_STATE();
    case 248:
      ACCEPT_TOKEN(anon_sym_import);
      END_STATE();
    case 249:
      if (lookahead == 'c') ADVANCE(278);
      END_STATE();
    case 250:
      if (lookahead == 'a') ADVANCE(279);
      END_STATE();
    case 251:
      ACCEPT_TOKEN(anon_sym_module);
      END_STATE();
    case 252:
      if (lookahead == 'a') ADVANCE(280);
      END_STATE();
    case 253:
      ACCEPT_TOKEN(anon_sym_number);
      END_STATE();
    case 254:
      if (lookahead == 'e') ADVANCE(281);
      END_STATE();
    case 255:
      if (lookahead == 't') ADVANCE(282);
      END_STATE();
    case 256:
      ACCEPT_TOKEN(anon_sym_public);
      END_STATE();
    case 257:
      if (lookahead == 'l') ADVANCE(283);
      END_STATE();
    case 258:
      if (lookahead == 'e') ADVANCE(284);
      END_STATE();
    case 259:
      ACCEPT_TOKEN(anon_sym_return);
      END_STATE();
    case 260:
      ACCEPT_TOKEN(anon_sym_static);
      END_STATE();
    case 261:
      ACCEPT_TOKEN(anon_sym_string);
      END_STATE();
    case 262:
      ACCEPT_TOKEN(anon_sym_switch);
      END_STATE();
    case 263:
      ACCEPT_TOKEN(anon_sym_symbol);
      END_STATE();
    case 264:
      ACCEPT_TOKEN(anon_sym_target);
      END_STATE();
    case 265:
      ACCEPT_TOKEN(anon_sym_typeof);
      END_STATE();
    case 266:
      if (lookahead == 'n') ADVANCE(285);
      END_STATE();
    case 267:
      if (lookahead == 't') ADVANCE(286);
      END_STATE();
    case 268:
      ACCEPT_TOKEN(anon_sym_asserts);
      END_STATE();
    case 269:
      ACCEPT_TOKEN(anon_sym_boolean);
      END_STATE();
    case 270:
      if (lookahead == 'e') ADVANCE(287);
      END_STATE();
    case 271:
      if (lookahead == 'r') ADVANCE(288);
      END_STATE();
    case 272:
      ACCEPT_TOKEN(anon_sym_declare);
      END_STATE();
    case 273:
      ACCEPT_TOKEN(anon_sym_default);
      END_STATE();
    case 274:
      ACCEPT_TOKEN(anon_sym_extends);
      END_STATE();
    case 275:
      ACCEPT_TOKEN(anon_sym_finally);
      END_STATE();
    case 276:
      if (lookahead == 'n') ADVANCE(289);
      END_STATE();
    case 277:
      if (lookahead == 'n') ADVANCE(290);
      END_STATE();
    case 278:
      if (lookahead == 'e') ADVANCE(291);
      END_STATE();
    case 279:
      if (lookahead == 'c') ADVANCE(292);
      END_STATE();
    case 280:
      if (lookahead == 'c') ADVANCE(293);
      END_STATE();
    case 281:
      ACCEPT_TOKEN(anon_sym_private);
      END_STATE();
    case 282:
      if (lookahead == 'e') ADVANCE(294);
      END_STATE();
    case 283:
      if (lookahead == 'y') ADVANCE(295);
      END_STATE();
    case 284:
      ACCEPT_TOKEN(anon_sym_require);
      END_STATE();
    case 285:
      if (lookahead == 'e') ADVANCE(296);
      END_STATE();
    case 286:
      ACCEPT_TOKEN(anon_sym_abstract);
      END_STATE();
    case 287:
      ACCEPT_TOKEN(anon_sym_continue);
      END_STATE();
    case 288:
      ACCEPT_TOKEN(anon_sym_debugger);
      END_STATE();
    case 289:
      ACCEPT_TOKEN(anon_sym_function);
      END_STATE();
    case 290:
      if (lookahead == 't') ADVANCE(297);
      END_STATE();
    case 291:
      if (lookahead == 'o') ADVANCE(298);
      END_STATE();
    case 292:
      if (lookahead == 'e') ADVANCE(299);
      END_STATE();
    case 293:
      if (lookahead == 'e') ADVANCE(300);
      END_STATE();
    case 294:
      if (lookahead == 'd') ADVANCE(301);
      END_STATE();
    case 295:
      ACCEPT_TOKEN(sym_readonly);
      END_STATE();
    case 296:
      if (lookahead == 'd') ADVANCE(302);
      END_STATE();
    case 297:
      if (lookahead == 's') ADVANCE(303);
      END_STATE();
    case 298:
      if (lookahead == 'f') ADVANCE(304);
      END_STATE();
    case 299:
      ACCEPT_TOKEN(anon_sym_interface);
      END_STATE();
    case 300:
      ACCEPT_TOKEN(anon_sym_namespace);
      END_STATE();
    case 301:
      ACCEPT_TOKEN(anon_sym_protected);
      END_STATE();
    case 302:
      ACCEPT_TOKEN(sym_undefined);
      END_STATE();
    case 303:
      ACCEPT_TOKEN(anon_sym_implements);
      END_STATE();
    case 304:
      ACCEPT_TOKEN(anon_sym_instanceof);
      END_STATE();
    default:
      return false;
  }
}

static TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 68},
  [2] = {.lex_state = 68},
  [3] = {.lex_state = 68},
  [4] = {.lex_state = 68},
  [5] = {.lex_state = 68},
  [6] = {.lex_state = 68},
  [7] = {.lex_state = 68},
  [8] = {.lex_state = 68},
  [9] = {.lex_state = 68},
  [10] = {.lex_state = 68},
  [11] = {.lex_state = 68},
  [12] = {.lex_state = 68},
  [13] = {.lex_state = 68},
  [14] = {.lex_state = 68},
  [15] = {.lex_state = 68},
  [16] = {.lex_state = 68},
  [17] = {.lex_state = 68},
  [18] = {.lex_state = 68},
  [19] = {.lex_state = 68},
  [20] = {.lex_state = 68},
  [21] = {.lex_state = 68},
  [22] = {.lex_state = 68},
  [23] = {.lex_state = 68},
  [24] = {.lex_state = 68},
  [25] = {.lex_state = 68},
  [26] = {.lex_state = 68},
  [27] = {.lex_state = 68},
  [28] = {.lex_state = 68},
  [29] = {.lex_state = 68},
  [30] = {.lex_state = 68},
  [31] = {.lex_state = 68},
  [32] = {.lex_state = 68},
  [33] = {.lex_state = 68},
  [34] = {.lex_state = 68},
  [35] = {.lex_state = 68},
  [36] = {.lex_state = 68},
  [37] = {.lex_state = 68},
  [38] = {.lex_state = 68},
  [39] = {.lex_state = 68},
  [40] = {.lex_state = 68},
  [41] = {.lex_state = 68},
  [42] = {.lex_state = 68},
  [43] = {.lex_state = 68},
  [44] = {.lex_state = 68},
  [45] = {.lex_state = 68},
  [46] = {.lex_state = 68},
  [47] = {.lex_state = 68},
  [48] = {.lex_state = 14},
  [49] = {.lex_state = 14},
  [50] = {.lex_state = 14},
  [51] = {.lex_state = 14},
  [52] = {.lex_state = 14},
  [53] = {.lex_state = 14},
  [54] = {.lex_state = 14},
  [55] = {.lex_state = 14},
  [56] = {.lex_state = 14},
  [57] = {.lex_state = 14},
  [58] = {.lex_state = 14},
  [59] = {.lex_state = 6, .external_lex_state = 2},
  [60] = {.lex_state = 67, .external_lex_state = 2},
  [61] = {.lex_state = 67, .external_lex_state = 3},
  [62] = {.lex_state = 8, .external_lex_state = 2},
  [63] = {.lex_state = 67, .external_lex_state = 2},
  [64] = {.lex_state = 67, .external_lex_state = 3},
  [65] = {.lex_state = 67, .external_lex_state = 2},
  [66] = {.lex_state = 6, .external_lex_state = 2},
  [67] = {.lex_state = 6, .external_lex_state = 3},
  [68] = {.lex_state = 67, .external_lex_state = 3},
  [69] = {.lex_state = 67, .external_lex_state = 3},
  [70] = {.lex_state = 67, .external_lex_state = 3},
  [71] = {.lex_state = 67, .external_lex_state = 3},
  [72] = {.lex_state = 6, .external_lex_state = 2},
  [73] = {.lex_state = 67, .external_lex_state = 3},
  [74] = {.lex_state = 67, .external_lex_state = 3},
  [75] = {.lex_state = 67, .external_lex_state = 3},
  [76] = {.lex_state = 67, .external_lex_state = 3},
  [77] = {.lex_state = 67, .external_lex_state = 3},
  [78] = {.lex_state = 67, .external_lex_state = 3},
  [79] = {.lex_state = 67, .external_lex_state = 3},
  [80] = {.lex_state = 67, .external_lex_state = 3},
  [81] = {.lex_state = 67, .external_lex_state = 3},
  [82] = {.lex_state = 67, .external_lex_state = 3},
  [83] = {.lex_state = 67, .external_lex_state = 3},
  [84] = {.lex_state = 67, .external_lex_state = 3},
  [85] = {.lex_state = 67, .external_lex_state = 3},
  [86] = {.lex_state = 67, .external_lex_state = 3},
  [87] = {.lex_state = 6, .external_lex_state = 3},
  [88] = {.lex_state = 67, .external_lex_state = 3},
  [89] = {.lex_state = 6, .external_lex_state = 2},
  [90] = {.lex_state = 67, .external_lex_state = 3},
  [91] = {.lex_state = 6, .external_lex_state = 2},
  [92] = {.lex_state = 67, .external_lex_state = 3},
  [93] = {.lex_state = 67, .external_lex_state = 3},
  [94] = {.lex_state = 67, .external_lex_state = 3},
  [95] = {.lex_state = 67, .external_lex_state = 3},
  [96] = {.lex_state = 67, .external_lex_state = 3},
  [97] = {.lex_state = 67, .external_lex_state = 3},
  [98] = {.lex_state = 67, .external_lex_state = 3},
  [99] = {.lex_state = 6, .external_lex_state = 2},
  [100] = {.lex_state = 68},
  [101] = {.lex_state = 68},
  [102] = {.lex_state = 68},
  [103] = {.lex_state = 68},
  [104] = {.lex_state = 68},
  [105] = {.lex_state = 68},
  [106] = {.lex_state = 68},
  [107] = {.lex_state = 68},
  [108] = {.lex_state = 68},
  [109] = {.lex_state = 68},
  [110] = {.lex_state = 68},
  [111] = {.lex_state = 68},
  [112] = {.lex_state = 68},
  [113] = {.lex_state = 68},
  [114] = {.lex_state = 68},
  [115] = {.lex_state = 68},
  [116] = {.lex_state = 68},
  [117] = {.lex_state = 68},
  [118] = {.lex_state = 68, .external_lex_state = 4},
  [119] = {.lex_state = 7, .external_lex_state = 3},
  [120] = {.lex_state = 7, .external_lex_state = 3},
  [121] = {.lex_state = 7, .external_lex_state = 3},
  [122] = {.lex_state = 68},
  [123] = {.lex_state = 68},
  [124] = {.lex_state = 68},
  [125] = {.lex_state = 68},
  [126] = {.lex_state = 68},
  [127] = {.lex_state = 6, .external_lex_state = 3},
  [128] = {.lex_state = 68},
  [129] = {.lex_state = 68},
  [130] = {.lex_state = 68},
  [131] = {.lex_state = 68},
  [132] = {.lex_state = 68},
  [133] = {.lex_state = 6, .external_lex_state = 3},
  [134] = {.lex_state = 68},
  [135] = {.lex_state = 6, .external_lex_state = 3},
  [136] = {.lex_state = 68},
  [137] = {.lex_state = 68},
  [138] = {.lex_state = 68},
  [139] = {.lex_state = 68},
  [140] = {.lex_state = 68},
  [141] = {.lex_state = 68},
  [142] = {.lex_state = 68},
  [143] = {.lex_state = 68},
  [144] = {.lex_state = 68},
  [145] = {.lex_state = 68},
  [146] = {.lex_state = 7, .external_lex_state = 3},
  [147] = {.lex_state = 68},
  [148] = {.lex_state = 7, .external_lex_state = 3},
  [149] = {.lex_state = 68},
  [150] = {.lex_state = 68},
  [151] = {.lex_state = 68},
  [152] = {.lex_state = 6, .external_lex_state = 3},
  [153] = {.lex_state = 6, .external_lex_state = 3},
  [154] = {.lex_state = 68},
  [155] = {.lex_state = 68},
  [156] = {.lex_state = 68, .external_lex_state = 4},
  [157] = {.lex_state = 68},
  [158] = {.lex_state = 68},
  [159] = {.lex_state = 68},
  [160] = {.lex_state = 68},
  [161] = {.lex_state = 68},
  [162] = {.lex_state = 68},
  [163] = {.lex_state = 68},
  [164] = {.lex_state = 68},
  [165] = {.lex_state = 68},
  [166] = {.lex_state = 68},
  [167] = {.lex_state = 68},
  [168] = {.lex_state = 68},
  [169] = {.lex_state = 68},
  [170] = {.lex_state = 68},
  [171] = {.lex_state = 68},
  [172] = {.lex_state = 68},
  [173] = {.lex_state = 68},
  [174] = {.lex_state = 68},
  [175] = {.lex_state = 68},
  [176] = {.lex_state = 68},
  [177] = {.lex_state = 68},
  [178] = {.lex_state = 68},
  [179] = {.lex_state = 68},
  [180] = {.lex_state = 68},
  [181] = {.lex_state = 68},
  [182] = {.lex_state = 68},
  [183] = {.lex_state = 68},
  [184] = {.lex_state = 68},
  [185] = {.lex_state = 68},
  [186] = {.lex_state = 68},
  [187] = {.lex_state = 68},
  [188] = {.lex_state = 68},
  [189] = {.lex_state = 68},
  [190] = {.lex_state = 68},
  [191] = {.lex_state = 68},
  [192] = {.lex_state = 68},
  [193] = {.lex_state = 68},
  [194] = {.lex_state = 68},
  [195] = {.lex_state = 68},
  [196] = {.lex_state = 68},
  [197] = {.lex_state = 68},
  [198] = {.lex_state = 68},
  [199] = {.lex_state = 68},
  [200] = {.lex_state = 68},
  [201] = {.lex_state = 68},
  [202] = {.lex_state = 68},
  [203] = {.lex_state = 68},
  [204] = {.lex_state = 68},
  [205] = {.lex_state = 68},
  [206] = {.lex_state = 68},
  [207] = {.lex_state = 68},
  [208] = {.lex_state = 68},
  [209] = {.lex_state = 68},
  [210] = {.lex_state = 6, .external_lex_state = 3},
  [211] = {.lex_state = 6, .external_lex_state = 3},
  [212] = {.lex_state = 68},
  [213] = {.lex_state = 68},
  [214] = {.lex_state = 68},
  [215] = {.lex_state = 68},
  [216] = {.lex_state = 68},
  [217] = {.lex_state = 68},
  [218] = {.lex_state = 68},
  [219] = {.lex_state = 68},
  [220] = {.lex_state = 68},
  [221] = {.lex_state = 68},
  [222] = {.lex_state = 68},
  [223] = {.lex_state = 68},
  [224] = {.lex_state = 68},
  [225] = {.lex_state = 68},
  [226] = {.lex_state = 68},
  [227] = {.lex_state = 68},
  [228] = {.lex_state = 68},
  [229] = {.lex_state = 68},
  [230] = {.lex_state = 68},
  [231] = {.lex_state = 68},
  [232] = {.lex_state = 68},
  [233] = {.lex_state = 68},
  [234] = {.lex_state = 68},
  [235] = {.lex_state = 68},
  [236] = {.lex_state = 68},
  [237] = {.lex_state = 68},
  [238] = {.lex_state = 68},
  [239] = {.lex_state = 68},
  [240] = {.lex_state = 68},
  [241] = {.lex_state = 68},
  [242] = {.lex_state = 68},
  [243] = {.lex_state = 68},
  [244] = {.lex_state = 68},
  [245] = {.lex_state = 68},
  [246] = {.lex_state = 68},
  [247] = {.lex_state = 68},
  [248] = {.lex_state = 68},
  [249] = {.lex_state = 68},
  [250] = {.lex_state = 68},
  [251] = {.lex_state = 68},
  [252] = {.lex_state = 68},
  [253] = {.lex_state = 68},
  [254] = {.lex_state = 68},
  [255] = {.lex_state = 68},
  [256] = {.lex_state = 6, .external_lex_state = 3},
  [257] = {.lex_state = 68},
  [258] = {.lex_state = 68},
  [259] = {.lex_state = 68},
  [260] = {.lex_state = 68},
  [261] = {.lex_state = 68},
  [262] = {.lex_state = 68},
  [263] = {.lex_state = 68},
  [264] = {.lex_state = 68},
  [265] = {.lex_state = 68},
  [266] = {.lex_state = 68},
  [267] = {.lex_state = 68},
  [268] = {.lex_state = 68},
  [269] = {.lex_state = 68},
  [270] = {.lex_state = 68},
  [271] = {.lex_state = 68},
  [272] = {.lex_state = 68},
  [273] = {.lex_state = 68},
  [274] = {.lex_state = 68},
  [275] = {.lex_state = 68},
  [276] = {.lex_state = 68},
  [277] = {.lex_state = 68},
  [278] = {.lex_state = 68},
  [279] = {.lex_state = 68},
  [280] = {.lex_state = 68},
  [281] = {.lex_state = 68},
  [282] = {.lex_state = 68},
  [283] = {.lex_state = 68},
  [284] = {.lex_state = 68},
  [285] = {.lex_state = 68},
  [286] = {.lex_state = 68},
  [287] = {.lex_state = 68},
  [288] = {.lex_state = 68},
  [289] = {.lex_state = 68},
  [290] = {.lex_state = 68},
  [291] = {.lex_state = 68},
  [292] = {.lex_state = 68},
  [293] = {.lex_state = 68},
  [294] = {.lex_state = 68},
  [295] = {.lex_state = 68},
  [296] = {.lex_state = 68},
  [297] = {.lex_state = 68},
  [298] = {.lex_state = 68},
  [299] = {.lex_state = 68},
  [300] = {.lex_state = 68},
  [301] = {.lex_state = 68},
  [302] = {.lex_state = 68},
  [303] = {.lex_state = 68},
  [304] = {.lex_state = 68},
  [305] = {.lex_state = 68},
  [306] = {.lex_state = 68},
  [307] = {.lex_state = 68},
  [308] = {.lex_state = 68},
  [309] = {.lex_state = 68},
  [310] = {.lex_state = 68},
  [311] = {.lex_state = 68},
  [312] = {.lex_state = 68},
  [313] = {.lex_state = 68},
  [314] = {.lex_state = 68},
  [315] = {.lex_state = 68},
  [316] = {.lex_state = 68},
  [317] = {.lex_state = 68},
  [318] = {.lex_state = 68},
  [319] = {.lex_state = 68},
  [320] = {.lex_state = 68},
  [321] = {.lex_state = 68},
  [322] = {.lex_state = 68},
  [323] = {.lex_state = 68},
  [324] = {.lex_state = 68},
  [325] = {.lex_state = 68},
  [326] = {.lex_state = 68},
  [327] = {.lex_state = 68},
  [328] = {.lex_state = 68},
  [329] = {.lex_state = 68},
  [330] = {.lex_state = 68},
  [331] = {.lex_state = 68},
  [332] = {.lex_state = 68},
  [333] = {.lex_state = 68},
  [334] = {.lex_state = 68},
  [335] = {.lex_state = 68},
  [336] = {.lex_state = 68},
  [337] = {.lex_state = 68},
  [338] = {.lex_state = 68},
  [339] = {.lex_state = 68},
  [340] = {.lex_state = 68},
  [341] = {.lex_state = 68},
  [342] = {.lex_state = 68},
  [343] = {.lex_state = 68},
  [344] = {.lex_state = 68},
  [345] = {.lex_state = 68},
  [346] = {.lex_state = 68},
  [347] = {.lex_state = 68},
  [348] = {.lex_state = 68},
  [349] = {.lex_state = 68},
  [350] = {.lex_state = 68},
  [351] = {.lex_state = 68},
  [352] = {.lex_state = 68},
  [353] = {.lex_state = 68},
  [354] = {.lex_state = 68},
  [355] = {.lex_state = 68},
  [356] = {.lex_state = 68},
  [357] = {.lex_state = 68},
  [358] = {.lex_state = 68},
  [359] = {.lex_state = 68},
  [360] = {.lex_state = 68},
  [361] = {.lex_state = 68},
  [362] = {.lex_state = 68},
  [363] = {.lex_state = 68},
  [364] = {.lex_state = 68},
  [365] = {.lex_state = 68},
  [366] = {.lex_state = 68},
  [367] = {.lex_state = 68},
  [368] = {.lex_state = 68},
  [369] = {.lex_state = 68},
  [370] = {.lex_state = 68},
  [371] = {.lex_state = 68},
  [372] = {.lex_state = 68},
  [373] = {.lex_state = 68},
  [374] = {.lex_state = 68},
  [375] = {.lex_state = 68},
  [376] = {.lex_state = 68},
  [377] = {.lex_state = 68},
  [378] = {.lex_state = 68},
  [379] = {.lex_state = 68},
  [380] = {.lex_state = 68},
  [381] = {.lex_state = 68},
  [382] = {.lex_state = 68},
  [383] = {.lex_state = 68},
  [384] = {.lex_state = 68},
  [385] = {.lex_state = 68},
  [386] = {.lex_state = 68},
  [387] = {.lex_state = 68},
  [388] = {.lex_state = 68},
  [389] = {.lex_state = 68},
  [390] = {.lex_state = 68},
  [391] = {.lex_state = 68},
  [392] = {.lex_state = 68},
  [393] = {.lex_state = 68},
  [394] = {.lex_state = 68},
  [395] = {.lex_state = 68},
  [396] = {.lex_state = 68},
  [397] = {.lex_state = 68},
  [398] = {.lex_state = 68},
  [399] = {.lex_state = 68},
  [400] = {.lex_state = 68},
  [401] = {.lex_state = 68},
  [402] = {.lex_state = 68},
  [403] = {.lex_state = 68},
  [404] = {.lex_state = 68},
  [405] = {.lex_state = 68},
  [406] = {.lex_state = 68},
  [407] = {.lex_state = 68},
  [408] = {.lex_state = 68},
  [409] = {.lex_state = 68},
  [410] = {.lex_state = 68},
  [411] = {.lex_state = 68},
  [412] = {.lex_state = 68},
  [413] = {.lex_state = 68},
  [414] = {.lex_state = 68},
  [415] = {.lex_state = 68},
  [416] = {.lex_state = 68},
  [417] = {.lex_state = 68},
  [418] = {.lex_state = 68},
  [419] = {.lex_state = 68},
  [420] = {.lex_state = 68},
  [421] = {.lex_state = 68},
  [422] = {.lex_state = 68},
  [423] = {.lex_state = 68},
  [424] = {.lex_state = 68},
  [425] = {.lex_state = 68},
  [426] = {.lex_state = 68},
  [427] = {.lex_state = 68},
  [428] = {.lex_state = 68},
  [429] = {.lex_state = 68},
  [430] = {.lex_state = 68},
  [431] = {.lex_state = 68},
  [432] = {.lex_state = 68},
  [433] = {.lex_state = 68},
  [434] = {.lex_state = 68},
  [435] = {.lex_state = 68},
  [436] = {.lex_state = 68},
  [437] = {.lex_state = 68},
  [438] = {.lex_state = 68},
  [439] = {.lex_state = 68},
  [440] = {.lex_state = 68},
  [441] = {.lex_state = 68},
  [442] = {.lex_state = 68},
  [443] = {.lex_state = 68},
  [444] = {.lex_state = 68},
  [445] = {.lex_state = 68},
  [446] = {.lex_state = 68},
  [447] = {.lex_state = 68},
  [448] = {.lex_state = 68},
  [449] = {.lex_state = 68},
  [450] = {.lex_state = 68},
  [451] = {.lex_state = 6, .external_lex_state = 3},
  [452] = {.lex_state = 6, .external_lex_state = 3},
  [453] = {.lex_state = 6, .external_lex_state = 3},
  [454] = {.lex_state = 6, .external_lex_state = 3},
  [455] = {.lex_state = 6, .external_lex_state = 3},
  [456] = {.lex_state = 6, .external_lex_state = 3},
  [457] = {.lex_state = 6, .external_lex_state = 3},
  [458] = {.lex_state = 6, .external_lex_state = 3},
  [459] = {.lex_state = 6, .external_lex_state = 3},
  [460] = {.lex_state = 6, .external_lex_state = 2},
  [461] = {.lex_state = 15},
  [462] = {.lex_state = 6, .external_lex_state = 3},
  [463] = {.lex_state = 15},
  [464] = {.lex_state = 15},
  [465] = {.lex_state = 15},
  [466] = {.lex_state = 15},
  [467] = {.lex_state = 15},
  [468] = {.lex_state = 6, .external_lex_state = 3},
  [469] = {.lex_state = 6, .external_lex_state = 3},
  [470] = {.lex_state = 7, .external_lex_state = 2},
  [471] = {.lex_state = 6, .external_lex_state = 3},
  [472] = {.lex_state = 6, .external_lex_state = 2},
  [473] = {.lex_state = 6, .external_lex_state = 2},
  [474] = {.lex_state = 6, .external_lex_state = 3},
  [475] = {.lex_state = 6, .external_lex_state = 3},
  [476] = {.lex_state = 6, .external_lex_state = 3},
  [477] = {.lex_state = 6, .external_lex_state = 2},
  [478] = {.lex_state = 68},
  [479] = {.lex_state = 6, .external_lex_state = 3},
  [480] = {.lex_state = 68},
  [481] = {.lex_state = 6, .external_lex_state = 3},
  [482] = {.lex_state = 68},
  [483] = {.lex_state = 68, .external_lex_state = 4},
  [484] = {.lex_state = 7, .external_lex_state = 2},
  [485] = {.lex_state = 6, .external_lex_state = 2},
  [486] = {.lex_state = 6, .external_lex_state = 2},
  [487] = {.lex_state = 7, .external_lex_state = 2},
  [488] = {.lex_state = 68, .external_lex_state = 4},
  [489] = {.lex_state = 68},
  [490] = {.lex_state = 6, .external_lex_state = 2},
  [491] = {.lex_state = 68},
  [492] = {.lex_state = 68},
  [493] = {.lex_state = 6, .external_lex_state = 2},
  [494] = {.lex_state = 68},
  [495] = {.lex_state = 7, .external_lex_state = 2},
  [496] = {.lex_state = 68},
  [497] = {.lex_state = 6, .external_lex_state = 3},
  [498] = {.lex_state = 6, .external_lex_state = 2},
  [499] = {.lex_state = 6, .external_lex_state = 2},
  [500] = {.lex_state = 68, .external_lex_state = 4},
  [501] = {.lex_state = 68, .external_lex_state = 4},
  [502] = {.lex_state = 68, .external_lex_state = 4},
  [503] = {.lex_state = 6, .external_lex_state = 2},
  [504] = {.lex_state = 6, .external_lex_state = 3},
  [505] = {.lex_state = 68},
  [506] = {.lex_state = 68},
  [507] = {.lex_state = 68, .external_lex_state = 4},
  [508] = {.lex_state = 68},
  [509] = {.lex_state = 68},
  [510] = {.lex_state = 6, .external_lex_state = 3},
  [511] = {.lex_state = 68, .external_lex_state = 4},
  [512] = {.lex_state = 68, .external_lex_state = 4},
  [513] = {.lex_state = 68},
  [514] = {.lex_state = 68},
  [515] = {.lex_state = 7, .external_lex_state = 2},
  [516] = {.lex_state = 68},
  [517] = {.lex_state = 7, .external_lex_state = 2},
  [518] = {.lex_state = 68},
  [519] = {.lex_state = 6, .external_lex_state = 2},
  [520] = {.lex_state = 6, .external_lex_state = 2},
  [521] = {.lex_state = 68},
  [522] = {.lex_state = 68},
  [523] = {.lex_state = 68},
  [524] = {.lex_state = 68, .external_lex_state = 4},
  [525] = {.lex_state = 68, .external_lex_state = 4},
  [526] = {.lex_state = 68, .external_lex_state = 4},
  [527] = {.lex_state = 68, .external_lex_state = 4},
  [528] = {.lex_state = 68, .external_lex_state = 4},
  [529] = {.lex_state = 68, .external_lex_state = 4},
  [530] = {.lex_state = 68},
  [531] = {.lex_state = 68, .external_lex_state = 4},
  [532] = {.lex_state = 68, .external_lex_state = 4},
  [533] = {.lex_state = 68, .external_lex_state = 4},
  [534] = {.lex_state = 68},
  [535] = {.lex_state = 68},
  [536] = {.lex_state = 68, .external_lex_state = 4},
  [537] = {.lex_state = 68},
  [538] = {.lex_state = 68, .external_lex_state = 4},
  [539] = {.lex_state = 68},
  [540] = {.lex_state = 68, .external_lex_state = 4},
  [541] = {.lex_state = 68},
  [542] = {.lex_state = 68},
  [543] = {.lex_state = 68},
  [544] = {.lex_state = 68},
  [545] = {.lex_state = 68},
  [546] = {.lex_state = 68},
  [547] = {.lex_state = 68},
  [548] = {.lex_state = 68},
  [549] = {.lex_state = 68},
  [550] = {.lex_state = 68},
  [551] = {.lex_state = 68},
  [552] = {.lex_state = 15},
  [553] = {.lex_state = 68},
  [554] = {.lex_state = 68},
  [555] = {.lex_state = 68},
  [556] = {.lex_state = 68},
  [557] = {.lex_state = 68},
  [558] = {.lex_state = 68},
  [559] = {.lex_state = 68},
  [560] = {.lex_state = 68},
  [561] = {.lex_state = 68},
  [562] = {.lex_state = 68},
  [563] = {.lex_state = 68},
  [564] = {.lex_state = 68},
  [565] = {.lex_state = 68},
  [566] = {.lex_state = 68},
  [567] = {.lex_state = 68},
  [568] = {.lex_state = 68},
  [569] = {.lex_state = 68},
  [570] = {.lex_state = 68},
  [571] = {.lex_state = 68},
  [572] = {.lex_state = 68},
  [573] = {.lex_state = 68},
  [574] = {.lex_state = 68},
  [575] = {.lex_state = 68},
  [576] = {.lex_state = 68},
  [577] = {.lex_state = 68},
  [578] = {.lex_state = 68},
  [579] = {.lex_state = 68},
  [580] = {.lex_state = 68},
  [581] = {.lex_state = 68},
  [582] = {.lex_state = 68},
  [583] = {.lex_state = 68},
  [584] = {.lex_state = 68},
  [585] = {.lex_state = 68},
  [586] = {.lex_state = 68},
  [587] = {.lex_state = 68},
  [588] = {.lex_state = 68},
  [589] = {.lex_state = 68},
  [590] = {.lex_state = 68},
  [591] = {.lex_state = 68},
  [592] = {.lex_state = 68},
  [593] = {.lex_state = 68},
  [594] = {.lex_state = 68},
  [595] = {.lex_state = 68},
  [596] = {.lex_state = 68},
  [597] = {.lex_state = 68},
  [598] = {.lex_state = 68},
  [599] = {.lex_state = 68},
  [600] = {.lex_state = 68},
  [601] = {.lex_state = 68},
  [602] = {.lex_state = 68},
  [603] = {.lex_state = 68},
  [604] = {.lex_state = 68},
  [605] = {.lex_state = 68},
  [606] = {.lex_state = 68},
  [607] = {.lex_state = 68},
  [608] = {.lex_state = 68},
  [609] = {.lex_state = 68},
  [610] = {.lex_state = 68},
  [611] = {.lex_state = 68},
  [612] = {.lex_state = 68},
  [613] = {.lex_state = 68},
  [614] = {.lex_state = 68},
  [615] = {.lex_state = 68},
  [616] = {.lex_state = 68},
  [617] = {.lex_state = 68},
  [618] = {.lex_state = 68},
  [619] = {.lex_state = 68},
  [620] = {.lex_state = 68},
  [621] = {.lex_state = 68},
  [622] = {.lex_state = 68},
  [623] = {.lex_state = 68},
  [624] = {.lex_state = 68},
  [625] = {.lex_state = 68},
  [626] = {.lex_state = 68},
  [627] = {.lex_state = 68},
  [628] = {.lex_state = 68},
  [629] = {.lex_state = 68},
  [630] = {.lex_state = 68},
  [631] = {.lex_state = 68},
  [632] = {.lex_state = 68},
  [633] = {.lex_state = 68},
  [634] = {.lex_state = 68},
  [635] = {.lex_state = 68},
  [636] = {.lex_state = 6, .external_lex_state = 2},
  [637] = {.lex_state = 6, .external_lex_state = 3},
  [638] = {.lex_state = 6, .external_lex_state = 3},
  [639] = {.lex_state = 6, .external_lex_state = 3},
  [640] = {.lex_state = 6, .external_lex_state = 3},
  [641] = {.lex_state = 6, .external_lex_state = 3},
  [642] = {.lex_state = 6, .external_lex_state = 3},
  [643] = {.lex_state = 6, .external_lex_state = 3},
  [644] = {.lex_state = 6, .external_lex_state = 2},
  [645] = {.lex_state = 7, .external_lex_state = 2},
  [646] = {.lex_state = 6, .external_lex_state = 2},
  [647] = {.lex_state = 6, .external_lex_state = 3},
  [648] = {.lex_state = 6, .external_lex_state = 3},
  [649] = {.lex_state = 6, .external_lex_state = 3},
  [650] = {.lex_state = 6, .external_lex_state = 3},
  [651] = {.lex_state = 6, .external_lex_state = 3},
  [652] = {.lex_state = 6, .external_lex_state = 2},
  [653] = {.lex_state = 6, .external_lex_state = 3},
  [654] = {.lex_state = 6, .external_lex_state = 3},
  [655] = {.lex_state = 6, .external_lex_state = 2},
  [656] = {.lex_state = 6, .external_lex_state = 2},
  [657] = {.lex_state = 6, .external_lex_state = 2},
  [658] = {.lex_state = 6, .external_lex_state = 2},
  [659] = {.lex_state = 7, .external_lex_state = 2},
  [660] = {.lex_state = 6, .external_lex_state = 2},
  [661] = {.lex_state = 7, .external_lex_state = 2},
  [662] = {.lex_state = 6, .external_lex_state = 2},
  [663] = {.lex_state = 6, .external_lex_state = 2},
  [664] = {.lex_state = 6, .external_lex_state = 3},
  [665] = {.lex_state = 15},
  [666] = {.lex_state = 7, .external_lex_state = 2},
  [667] = {.lex_state = 6, .external_lex_state = 2},
  [668] = {.lex_state = 6, .external_lex_state = 3},
  [669] = {.lex_state = 7, .external_lex_state = 2},
  [670] = {.lex_state = 6, .external_lex_state = 3},
  [671] = {.lex_state = 6, .external_lex_state = 2},
  [672] = {.lex_state = 6, .external_lex_state = 3},
  [673] = {.lex_state = 7, .external_lex_state = 2},
  [674] = {.lex_state = 7, .external_lex_state = 2},
  [675] = {.lex_state = 6, .external_lex_state = 3},
  [676] = {.lex_state = 7, .external_lex_state = 2},
  [677] = {.lex_state = 7, .external_lex_state = 2},
  [678] = {.lex_state = 7, .external_lex_state = 2},
  [679] = {.lex_state = 7, .external_lex_state = 2},
  [680] = {.lex_state = 6, .external_lex_state = 2},
  [681] = {.lex_state = 6, .external_lex_state = 2},
  [682] = {.lex_state = 7, .external_lex_state = 2},
  [683] = {.lex_state = 6, .external_lex_state = 2},
  [684] = {.lex_state = 6, .external_lex_state = 3},
  [685] = {.lex_state = 7, .external_lex_state = 2},
  [686] = {.lex_state = 6, .external_lex_state = 2},
  [687] = {.lex_state = 6, .external_lex_state = 3},
  [688] = {.lex_state = 7, .external_lex_state = 2},
  [689] = {.lex_state = 6, .external_lex_state = 3},
  [690] = {.lex_state = 6, .external_lex_state = 2},
  [691] = {.lex_state = 15},
  [692] = {.lex_state = 6, .external_lex_state = 3},
  [693] = {.lex_state = 15},
  [694] = {.lex_state = 6, .external_lex_state = 3},
  [695] = {.lex_state = 6, .external_lex_state = 3},
  [696] = {.lex_state = 6, .external_lex_state = 3},
  [697] = {.lex_state = 6, .external_lex_state = 3},
  [698] = {.lex_state = 15},
  [699] = {.lex_state = 6, .external_lex_state = 3},
  [700] = {.lex_state = 6, .external_lex_state = 3},
  [701] = {.lex_state = 6, .external_lex_state = 3},
  [702] = {.lex_state = 6, .external_lex_state = 3},
  [703] = {.lex_state = 6, .external_lex_state = 3},
  [704] = {.lex_state = 15},
  [705] = {.lex_state = 15},
  [706] = {.lex_state = 15},
  [707] = {.lex_state = 6, .external_lex_state = 2},
  [708] = {.lex_state = 17},
  [709] = {.lex_state = 6, .external_lex_state = 3},
  [710] = {.lex_state = 17},
  [711] = {.lex_state = 15},
  [712] = {.lex_state = 15},
  [713] = {.lex_state = 15},
  [714] = {.lex_state = 15},
  [715] = {.lex_state = 6, .external_lex_state = 3},
  [716] = {.lex_state = 6, .external_lex_state = 3},
  [717] = {.lex_state = 15},
  [718] = {.lex_state = 6, .external_lex_state = 3},
  [719] = {.lex_state = 15},
  [720] = {.lex_state = 6, .external_lex_state = 3},
  [721] = {.lex_state = 17},
  [722] = {.lex_state = 15},
  [723] = {.lex_state = 6, .external_lex_state = 2},
  [724] = {.lex_state = 15},
  [725] = {.lex_state = 15},
  [726] = {.lex_state = 6, .external_lex_state = 2},
  [727] = {.lex_state = 15},
  [728] = {.lex_state = 6, .external_lex_state = 2},
  [729] = {.lex_state = 7, .external_lex_state = 2},
  [730] = {.lex_state = 15},
  [731] = {.lex_state = 7, .external_lex_state = 2},
  [732] = {.lex_state = 6, .external_lex_state = 2},
  [733] = {.lex_state = 6, .external_lex_state = 2},
  [734] = {.lex_state = 17},
  [735] = {.lex_state = 15},
  [736] = {.lex_state = 15},
  [737] = {.lex_state = 15},
  [738] = {.lex_state = 15},
  [739] = {.lex_state = 6, .external_lex_state = 2},
  [740] = {.lex_state = 15},
  [741] = {.lex_state = 17},
  [742] = {.lex_state = 17},
  [743] = {.lex_state = 6, .external_lex_state = 2},
  [744] = {.lex_state = 6, .external_lex_state = 3},
  [745] = {.lex_state = 15},
  [746] = {.lex_state = 7, .external_lex_state = 2},
  [747] = {.lex_state = 15},
  [748] = {.lex_state = 17},
  [749] = {.lex_state = 15},
  [750] = {.lex_state = 15},
  [751] = {.lex_state = 6, .external_lex_state = 3},
  [752] = {.lex_state = 15},
  [753] = {.lex_state = 6, .external_lex_state = 2},
  [754] = {.lex_state = 7, .external_lex_state = 2},
  [755] = {.lex_state = 15},
  [756] = {.lex_state = 15},
  [757] = {.lex_state = 15},
  [758] = {.lex_state = 6, .external_lex_state = 2},
  [759] = {.lex_state = 6, .external_lex_state = 2},
  [760] = {.lex_state = 15},
  [761] = {.lex_state = 15},
  [762] = {.lex_state = 6, .external_lex_state = 3},
  [763] = {.lex_state = 15},
  [764] = {.lex_state = 7, .external_lex_state = 2},
  [765] = {.lex_state = 15},
  [766] = {.lex_state = 15},
  [767] = {.lex_state = 6, .external_lex_state = 3},
  [768] = {.lex_state = 6, .external_lex_state = 3},
  [769] = {.lex_state = 15},
  [770] = {.lex_state = 6, .external_lex_state = 3},
  [771] = {.lex_state = 15},
  [772] = {.lex_state = 6, .external_lex_state = 3},
  [773] = {.lex_state = 6, .external_lex_state = 3},
  [774] = {.lex_state = 15},
  [775] = {.lex_state = 15},
  [776] = {.lex_state = 6, .external_lex_state = 3},
  [777] = {.lex_state = 15},
  [778] = {.lex_state = 7, .external_lex_state = 2},
  [779] = {.lex_state = 15},
  [780] = {.lex_state = 15},
  [781] = {.lex_state = 15},
  [782] = {.lex_state = 15},
  [783] = {.lex_state = 15},
  [784] = {.lex_state = 15},
  [785] = {.lex_state = 15},
  [786] = {.lex_state = 15},
  [787] = {.lex_state = 15},
  [788] = {.lex_state = 15},
  [789] = {.lex_state = 15},
  [790] = {.lex_state = 15},
  [791] = {.lex_state = 15},
  [792] = {.lex_state = 15},
  [793] = {.lex_state = 15},
  [794] = {.lex_state = 15},
  [795] = {.lex_state = 15},
  [796] = {.lex_state = 15},
  [797] = {.lex_state = 15},
  [798] = {.lex_state = 15},
  [799] = {.lex_state = 15},
  [800] = {.lex_state = 15},
  [801] = {.lex_state = 15},
  [802] = {.lex_state = 15},
  [803] = {.lex_state = 15},
  [804] = {.lex_state = 6, .external_lex_state = 2},
  [805] = {.lex_state = 15},
  [806] = {.lex_state = 6, .external_lex_state = 2},
  [807] = {.lex_state = 15},
  [808] = {.lex_state = 15},
  [809] = {.lex_state = 15},
  [810] = {.lex_state = 15},
  [811] = {.lex_state = 15},
  [812] = {.lex_state = 15},
  [813] = {.lex_state = 15},
  [814] = {.lex_state = 15},
  [815] = {.lex_state = 15},
  [816] = {.lex_state = 15},
  [817] = {.lex_state = 6, .external_lex_state = 2},
  [818] = {.lex_state = 15},
  [819] = {.lex_state = 15},
  [820] = {.lex_state = 6, .external_lex_state = 3},
  [821] = {.lex_state = 15},
  [822] = {.lex_state = 6, .external_lex_state = 3},
  [823] = {.lex_state = 6, .external_lex_state = 3},
  [824] = {.lex_state = 15},
  [825] = {.lex_state = 15},
  [826] = {.lex_state = 6, .external_lex_state = 2},
  [827] = {.lex_state = 15},
  [828] = {.lex_state = 15},
  [829] = {.lex_state = 6, .external_lex_state = 3},
  [830] = {.lex_state = 15},
  [831] = {.lex_state = 15},
  [832] = {.lex_state = 15},
  [833] = {.lex_state = 15},
  [834] = {.lex_state = 15},
  [835] = {.lex_state = 15},
  [836] = {.lex_state = 15},
  [837] = {.lex_state = 15},
  [838] = {.lex_state = 6, .external_lex_state = 3},
  [839] = {.lex_state = 15},
  [840] = {.lex_state = 15},
  [841] = {.lex_state = 15},
  [842] = {.lex_state = 15},
  [843] = {.lex_state = 15},
  [844] = {.lex_state = 6, .external_lex_state = 2},
  [845] = {.lex_state = 15},
  [846] = {.lex_state = 15},
  [847] = {.lex_state = 15},
  [848] = {.lex_state = 15},
  [849] = {.lex_state = 15},
  [850] = {.lex_state = 15},
  [851] = {.lex_state = 6, .external_lex_state = 3},
  [852] = {.lex_state = 15},
  [853] = {.lex_state = 15},
  [854] = {.lex_state = 6, .external_lex_state = 2},
  [855] = {.lex_state = 6, .external_lex_state = 3},
  [856] = {.lex_state = 15},
  [857] = {.lex_state = 6, .external_lex_state = 3},
  [858] = {.lex_state = 6, .external_lex_state = 3},
  [859] = {.lex_state = 6, .external_lex_state = 3},
  [860] = {.lex_state = 6, .external_lex_state = 2},
  [861] = {.lex_state = 6, .external_lex_state = 3},
  [862] = {.lex_state = 15},
  [863] = {.lex_state = 15},
  [864] = {.lex_state = 15},
  [865] = {.lex_state = 15},
  [866] = {.lex_state = 15},
  [867] = {.lex_state = 6, .external_lex_state = 3},
  [868] = {.lex_state = 15},
  [869] = {.lex_state = 15},
  [870] = {.lex_state = 15},
  [871] = {.lex_state = 15},
  [872] = {.lex_state = 15},
  [873] = {.lex_state = 15},
  [874] = {.lex_state = 15},
  [875] = {.lex_state = 15},
  [876] = {.lex_state = 15},
  [877] = {.lex_state = 15},
  [878] = {.lex_state = 15},
  [879] = {.lex_state = 15},
  [880] = {.lex_state = 15},
  [881] = {.lex_state = 15},
  [882] = {.lex_state = 15},
  [883] = {.lex_state = 15},
  [884] = {.lex_state = 6, .external_lex_state = 2},
  [885] = {.lex_state = 15},
  [886] = {.lex_state = 15},
  [887] = {.lex_state = 6, .external_lex_state = 3},
  [888] = {.lex_state = 15},
  [889] = {.lex_state = 15},
  [890] = {.lex_state = 6, .external_lex_state = 3},
  [891] = {.lex_state = 15},
  [892] = {.lex_state = 15},
  [893] = {.lex_state = 15},
  [894] = {.lex_state = 15},
  [895] = {.lex_state = 15},
  [896] = {.lex_state = 15},
  [897] = {.lex_state = 15},
  [898] = {.lex_state = 15},
  [899] = {.lex_state = 15},
  [900] = {.lex_state = 15},
  [901] = {.lex_state = 15},
  [902] = {.lex_state = 6, .external_lex_state = 3},
  [903] = {.lex_state = 15},
  [904] = {.lex_state = 15},
  [905] = {.lex_state = 15},
  [906] = {.lex_state = 15},
  [907] = {.lex_state = 6, .external_lex_state = 2},
  [908] = {.lex_state = 15},
  [909] = {.lex_state = 15},
  [910] = {.lex_state = 6, .external_lex_state = 3},
  [911] = {.lex_state = 15},
  [912] = {.lex_state = 15},
  [913] = {.lex_state = 15},
  [914] = {.lex_state = 6, .external_lex_state = 3},
  [915] = {.lex_state = 15},
  [916] = {.lex_state = 6, .external_lex_state = 3},
  [917] = {.lex_state = 6, .external_lex_state = 2},
  [918] = {.lex_state = 15},
  [919] = {.lex_state = 7, .external_lex_state = 2},
  [920] = {.lex_state = 15},
  [921] = {.lex_state = 15},
  [922] = {.lex_state = 15},
  [923] = {.lex_state = 15},
  [924] = {.lex_state = 15},
  [925] = {.lex_state = 15},
  [926] = {.lex_state = 6, .external_lex_state = 2},
  [927] = {.lex_state = 6, .external_lex_state = 2},
  [928] = {.lex_state = 6, .external_lex_state = 3},
  [929] = {.lex_state = 6, .external_lex_state = 2},
  [930] = {.lex_state = 6, .external_lex_state = 2},
  [931] = {.lex_state = 6, .external_lex_state = 2},
  [932] = {.lex_state = 6, .external_lex_state = 2},
  [933] = {.lex_state = 6, .external_lex_state = 3},
  [934] = {.lex_state = 7, .external_lex_state = 2},
  [935] = {.lex_state = 7, .external_lex_state = 2},
  [936] = {.lex_state = 6, .external_lex_state = 3},
  [937] = {.lex_state = 6, .external_lex_state = 3},
  [938] = {.lex_state = 6, .external_lex_state = 2},
  [939] = {.lex_state = 6, .external_lex_state = 2},
  [940] = {.lex_state = 6, .external_lex_state = 3},
  [941] = {.lex_state = 6, .external_lex_state = 2},
  [942] = {.lex_state = 6, .external_lex_state = 2},
  [943] = {.lex_state = 6, .external_lex_state = 3},
  [944] = {.lex_state = 6, .external_lex_state = 2},
  [945] = {.lex_state = 6, .external_lex_state = 2},
  [946] = {.lex_state = 6, .external_lex_state = 2},
  [947] = {.lex_state = 6, .external_lex_state = 2},
  [948] = {.lex_state = 6, .external_lex_state = 2},
  [949] = {.lex_state = 6, .external_lex_state = 2},
  [950] = {.lex_state = 6, .external_lex_state = 3},
  [951] = {.lex_state = 17},
  [952] = {.lex_state = 6, .external_lex_state = 2},
  [953] = {.lex_state = 6, .external_lex_state = 3},
  [954] = {.lex_state = 6, .external_lex_state = 2},
  [955] = {.lex_state = 6, .external_lex_state = 2},
  [956] = {.lex_state = 6, .external_lex_state = 2},
  [957] = {.lex_state = 6, .external_lex_state = 2},
  [958] = {.lex_state = 6, .external_lex_state = 3},
  [959] = {.lex_state = 6, .external_lex_state = 2},
  [960] = {.lex_state = 6, .external_lex_state = 2},
  [961] = {.lex_state = 7, .external_lex_state = 2},
  [962] = {.lex_state = 6, .external_lex_state = 2},
  [963] = {.lex_state = 6, .external_lex_state = 2},
  [964] = {.lex_state = 6, .external_lex_state = 2},
  [965] = {.lex_state = 7, .external_lex_state = 2},
  [966] = {.lex_state = 6, .external_lex_state = 2},
  [967] = {.lex_state = 6, .external_lex_state = 2},
  [968] = {.lex_state = 17},
  [969] = {.lex_state = 6, .external_lex_state = 2},
  [970] = {.lex_state = 6, .external_lex_state = 2},
  [971] = {.lex_state = 6, .external_lex_state = 2},
  [972] = {.lex_state = 6, .external_lex_state = 2},
  [973] = {.lex_state = 6, .external_lex_state = 2},
  [974] = {.lex_state = 6, .external_lex_state = 2},
  [975] = {.lex_state = 7, .external_lex_state = 2},
  [976] = {.lex_state = 6, .external_lex_state = 2},
  [977] = {.lex_state = 6, .external_lex_state = 2},
  [978] = {.lex_state = 6, .external_lex_state = 2},
  [979] = {.lex_state = 6, .external_lex_state = 2},
  [980] = {.lex_state = 6, .external_lex_state = 2},
  [981] = {.lex_state = 6, .external_lex_state = 2},
  [982] = {.lex_state = 6, .external_lex_state = 2},
  [983] = {.lex_state = 6, .external_lex_state = 3},
  [984] = {.lex_state = 6, .external_lex_state = 3},
  [985] = {.lex_state = 6, .external_lex_state = 2},
  [986] = {.lex_state = 6, .external_lex_state = 2},
  [987] = {.lex_state = 6, .external_lex_state = 2},
  [988] = {.lex_state = 6, .external_lex_state = 2},
  [989] = {.lex_state = 67, .external_lex_state = 3},
  [990] = {.lex_state = 15},
  [991] = {.lex_state = 15},
  [992] = {.lex_state = 68, .external_lex_state = 4},
  [993] = {.lex_state = 68, .external_lex_state = 4},
  [994] = {.lex_state = 68, .external_lex_state = 4},
  [995] = {.lex_state = 15},
  [996] = {.lex_state = 15},
  [997] = {.lex_state = 68, .external_lex_state = 4},
  [998] = {.lex_state = 15},
  [999] = {.lex_state = 15},
  [1000] = {.lex_state = 68, .external_lex_state = 4},
  [1001] = {.lex_state = 68, .external_lex_state = 4},
  [1002] = {.lex_state = 15},
  [1003] = {.lex_state = 15},
  [1004] = {.lex_state = 15},
  [1005] = {.lex_state = 15},
  [1006] = {.lex_state = 15},
  [1007] = {.lex_state = 15},
  [1008] = {.lex_state = 15},
  [1009] = {.lex_state = 15},
  [1010] = {.lex_state = 15},
  [1011] = {.lex_state = 15},
  [1012] = {.lex_state = 15},
  [1013] = {.lex_state = 15},
  [1014] = {.lex_state = 15},
  [1015] = {.lex_state = 15},
  [1016] = {.lex_state = 15},
  [1017] = {.lex_state = 15},
  [1018] = {.lex_state = 15},
  [1019] = {.lex_state = 15},
  [1020] = {.lex_state = 67, .external_lex_state = 2},
  [1021] = {.lex_state = 67, .external_lex_state = 3},
  [1022] = {.lex_state = 67, .external_lex_state = 3},
  [1023] = {.lex_state = 67, .external_lex_state = 2},
  [1024] = {.lex_state = 67, .external_lex_state = 2},
  [1025] = {.lex_state = 67, .external_lex_state = 2},
  [1026] = {.lex_state = 67, .external_lex_state = 2},
  [1027] = {.lex_state = 67, .external_lex_state = 3},
  [1028] = {.lex_state = 67, .external_lex_state = 2},
  [1029] = {.lex_state = 67, .external_lex_state = 2},
  [1030] = {.lex_state = 67, .external_lex_state = 2},
  [1031] = {.lex_state = 67, .external_lex_state = 2},
  [1032] = {.lex_state = 15},
  [1033] = {.lex_state = 67, .external_lex_state = 2},
  [1034] = {.lex_state = 15},
  [1035] = {.lex_state = 15},
  [1036] = {.lex_state = 15},
  [1037] = {.lex_state = 15},
  [1038] = {.lex_state = 15},
  [1039] = {.lex_state = 67, .external_lex_state = 2},
  [1040] = {.lex_state = 67, .external_lex_state = 2},
  [1041] = {.lex_state = 67, .external_lex_state = 2},
  [1042] = {.lex_state = 67, .external_lex_state = 2},
  [1043] = {.lex_state = 15},
  [1044] = {.lex_state = 67, .external_lex_state = 2},
  [1045] = {.lex_state = 67, .external_lex_state = 2},
  [1046] = {.lex_state = 67, .external_lex_state = 2},
  [1047] = {.lex_state = 67, .external_lex_state = 2},
  [1048] = {.lex_state = 67, .external_lex_state = 2},
  [1049] = {.lex_state = 67, .external_lex_state = 2},
  [1050] = {.lex_state = 67, .external_lex_state = 2},
  [1051] = {.lex_state = 67, .external_lex_state = 2},
  [1052] = {.lex_state = 67, .external_lex_state = 2},
  [1053] = {.lex_state = 67, .external_lex_state = 2},
  [1054] = {.lex_state = 67, .external_lex_state = 2},
  [1055] = {.lex_state = 67, .external_lex_state = 2},
  [1056] = {.lex_state = 67, .external_lex_state = 2},
  [1057] = {.lex_state = 67, .external_lex_state = 2},
  [1058] = {.lex_state = 67, .external_lex_state = 2},
  [1059] = {.lex_state = 67, .external_lex_state = 2},
  [1060] = {.lex_state = 67, .external_lex_state = 2},
  [1061] = {.lex_state = 67, .external_lex_state = 2},
  [1062] = {.lex_state = 67, .external_lex_state = 2},
  [1063] = {.lex_state = 67, .external_lex_state = 2},
  [1064] = {.lex_state = 67, .external_lex_state = 2},
  [1065] = {.lex_state = 67, .external_lex_state = 2},
  [1066] = {.lex_state = 67, .external_lex_state = 2},
  [1067] = {.lex_state = 67, .external_lex_state = 2},
  [1068] = {.lex_state = 67, .external_lex_state = 2},
  [1069] = {.lex_state = 67, .external_lex_state = 2},
  [1070] = {.lex_state = 67, .external_lex_state = 2},
  [1071] = {.lex_state = 67, .external_lex_state = 2},
  [1072] = {.lex_state = 67, .external_lex_state = 2},
  [1073] = {.lex_state = 67, .external_lex_state = 2},
  [1074] = {.lex_state = 67, .external_lex_state = 2},
  [1075] = {.lex_state = 67, .external_lex_state = 2},
  [1076] = {.lex_state = 67, .external_lex_state = 3},
  [1077] = {.lex_state = 67, .external_lex_state = 2},
  [1078] = {.lex_state = 67, .external_lex_state = 2},
  [1079] = {.lex_state = 67, .external_lex_state = 3},
  [1080] = {.lex_state = 67, .external_lex_state = 2},
  [1081] = {.lex_state = 67, .external_lex_state = 3},
  [1082] = {.lex_state = 67, .external_lex_state = 2},
  [1083] = {.lex_state = 67, .external_lex_state = 2},
  [1084] = {.lex_state = 67, .external_lex_state = 2},
  [1085] = {.lex_state = 67, .external_lex_state = 3},
  [1086] = {.lex_state = 67, .external_lex_state = 2},
  [1087] = {.lex_state = 67, .external_lex_state = 2},
  [1088] = {.lex_state = 67, .external_lex_state = 2},
  [1089] = {.lex_state = 67, .external_lex_state = 2},
  [1090] = {.lex_state = 67, .external_lex_state = 2},
  [1091] = {.lex_state = 67, .external_lex_state = 2},
  [1092] = {.lex_state = 67, .external_lex_state = 2},
  [1093] = {.lex_state = 67, .external_lex_state = 2},
  [1094] = {.lex_state = 67, .external_lex_state = 2},
  [1095] = {.lex_state = 67, .external_lex_state = 2},
  [1096] = {.lex_state = 67, .external_lex_state = 2},
  [1097] = {.lex_state = 67, .external_lex_state = 2},
  [1098] = {.lex_state = 67, .external_lex_state = 2},
  [1099] = {.lex_state = 67, .external_lex_state = 2},
  [1100] = {.lex_state = 67, .external_lex_state = 2},
  [1101] = {.lex_state = 67, .external_lex_state = 2},
  [1102] = {.lex_state = 67, .external_lex_state = 2},
  [1103] = {.lex_state = 67, .external_lex_state = 2},
  [1104] = {.lex_state = 67, .external_lex_state = 2},
  [1105] = {.lex_state = 67, .external_lex_state = 2},
  [1106] = {.lex_state = 67, .external_lex_state = 2},
  [1107] = {.lex_state = 67, .external_lex_state = 2},
  [1108] = {.lex_state = 67, .external_lex_state = 2},
  [1109] = {.lex_state = 67, .external_lex_state = 2},
  [1110] = {.lex_state = 67, .external_lex_state = 2},
  [1111] = {.lex_state = 67, .external_lex_state = 2},
  [1112] = {.lex_state = 67, .external_lex_state = 2},
  [1113] = {.lex_state = 67, .external_lex_state = 3},
  [1114] = {.lex_state = 67, .external_lex_state = 3},
  [1115] = {.lex_state = 67, .external_lex_state = 2},
  [1116] = {.lex_state = 67, .external_lex_state = 2},
  [1117] = {.lex_state = 67, .external_lex_state = 2},
  [1118] = {.lex_state = 67, .external_lex_state = 2},
  [1119] = {.lex_state = 67, .external_lex_state = 2},
  [1120] = {.lex_state = 67, .external_lex_state = 2},
  [1121] = {.lex_state = 67, .external_lex_state = 2},
  [1122] = {.lex_state = 67, .external_lex_state = 2},
  [1123] = {.lex_state = 67, .external_lex_state = 2},
  [1124] = {.lex_state = 67, .external_lex_state = 2},
  [1125] = {.lex_state = 67, .external_lex_state = 2},
  [1126] = {.lex_state = 67, .external_lex_state = 2},
  [1127] = {.lex_state = 67, .external_lex_state = 2},
  [1128] = {.lex_state = 67, .external_lex_state = 2},
  [1129] = {.lex_state = 67, .external_lex_state = 2},
  [1130] = {.lex_state = 67, .external_lex_state = 2},
  [1131] = {.lex_state = 67, .external_lex_state = 2},
  [1132] = {.lex_state = 67, .external_lex_state = 2},
  [1133] = {.lex_state = 67, .external_lex_state = 2},
  [1134] = {.lex_state = 67, .external_lex_state = 3},
  [1135] = {.lex_state = 67, .external_lex_state = 2},
  [1136] = {.lex_state = 67, .external_lex_state = 2},
  [1137] = {.lex_state = 67, .external_lex_state = 2},
  [1138] = {.lex_state = 67, .external_lex_state = 3},
  [1139] = {.lex_state = 67, .external_lex_state = 2},
  [1140] = {.lex_state = 67, .external_lex_state = 3},
  [1141] = {.lex_state = 67, .external_lex_state = 3},
  [1142] = {.lex_state = 67, .external_lex_state = 2},
  [1143] = {.lex_state = 67, .external_lex_state = 2},
  [1144] = {.lex_state = 67, .external_lex_state = 3},
  [1145] = {.lex_state = 67, .external_lex_state = 2},
  [1146] = {.lex_state = 67, .external_lex_state = 3},
  [1147] = {.lex_state = 67, .external_lex_state = 2},
  [1148] = {.lex_state = 67, .external_lex_state = 3},
  [1149] = {.lex_state = 67, .external_lex_state = 2},
  [1150] = {.lex_state = 67, .external_lex_state = 2},
  [1151] = {.lex_state = 67, .external_lex_state = 3},
  [1152] = {.lex_state = 67, .external_lex_state = 3},
  [1153] = {.lex_state = 67, .external_lex_state = 2},
  [1154] = {.lex_state = 67, .external_lex_state = 2},
  [1155] = {.lex_state = 67, .external_lex_state = 3},
  [1156] = {.lex_state = 67, .external_lex_state = 2},
  [1157] = {.lex_state = 67, .external_lex_state = 2},
  [1158] = {.lex_state = 67, .external_lex_state = 3},
  [1159] = {.lex_state = 67, .external_lex_state = 3},
  [1160] = {.lex_state = 67, .external_lex_state = 2},
  [1161] = {.lex_state = 67, .external_lex_state = 3},
  [1162] = {.lex_state = 67, .external_lex_state = 2},
  [1163] = {.lex_state = 67, .external_lex_state = 3},
  [1164] = {.lex_state = 67, .external_lex_state = 2},
  [1165] = {.lex_state = 67, .external_lex_state = 3},
  [1166] = {.lex_state = 67, .external_lex_state = 3},
  [1167] = {.lex_state = 67, .external_lex_state = 3},
  [1168] = {.lex_state = 67, .external_lex_state = 3},
  [1169] = {.lex_state = 67, .external_lex_state = 3},
  [1170] = {.lex_state = 67, .external_lex_state = 2},
  [1171] = {.lex_state = 67, .external_lex_state = 2},
  [1172] = {.lex_state = 67, .external_lex_state = 2},
  [1173] = {.lex_state = 67, .external_lex_state = 2},
  [1174] = {.lex_state = 67, .external_lex_state = 2},
  [1175] = {.lex_state = 67, .external_lex_state = 2},
  [1176] = {.lex_state = 67, .external_lex_state = 2},
  [1177] = {.lex_state = 67, .external_lex_state = 3},
  [1178] = {.lex_state = 67, .external_lex_state = 3},
  [1179] = {.lex_state = 67, .external_lex_state = 3},
  [1180] = {.lex_state = 67, .external_lex_state = 3},
  [1181] = {.lex_state = 67, .external_lex_state = 3},
  [1182] = {.lex_state = 67, .external_lex_state = 3},
  [1183] = {.lex_state = 67, .external_lex_state = 3},
  [1184] = {.lex_state = 67, .external_lex_state = 2},
  [1185] = {.lex_state = 67, .external_lex_state = 2},
  [1186] = {.lex_state = 67, .external_lex_state = 2},
  [1187] = {.lex_state = 67, .external_lex_state = 2},
  [1188] = {.lex_state = 67, .external_lex_state = 3},
  [1189] = {.lex_state = 67, .external_lex_state = 3},
  [1190] = {.lex_state = 8, .external_lex_state = 2},
  [1191] = {.lex_state = 67, .external_lex_state = 2},
  [1192] = {.lex_state = 67, .external_lex_state = 3},
  [1193] = {.lex_state = 67, .external_lex_state = 3},
  [1194] = {.lex_state = 67, .external_lex_state = 3},
  [1195] = {.lex_state = 67, .external_lex_state = 3},
  [1196] = {.lex_state = 67, .external_lex_state = 2},
  [1197] = {.lex_state = 67, .external_lex_state = 2},
  [1198] = {.lex_state = 67, .external_lex_state = 2},
  [1199] = {.lex_state = 67, .external_lex_state = 2},
  [1200] = {.lex_state = 67, .external_lex_state = 2},
  [1201] = {.lex_state = 67, .external_lex_state = 2},
  [1202] = {.lex_state = 67, .external_lex_state = 2},
  [1203] = {.lex_state = 67, .external_lex_state = 3},
  [1204] = {.lex_state = 67, .external_lex_state = 3},
  [1205] = {.lex_state = 67, .external_lex_state = 2},
  [1206] = {.lex_state = 67, .external_lex_state = 3},
  [1207] = {.lex_state = 67, .external_lex_state = 2},
  [1208] = {.lex_state = 67, .external_lex_state = 2},
  [1209] = {.lex_state = 67, .external_lex_state = 2},
  [1210] = {.lex_state = 67, .external_lex_state = 2},
  [1211] = {.lex_state = 67, .external_lex_state = 3},
  [1212] = {.lex_state = 67, .external_lex_state = 2},
  [1213] = {.lex_state = 67, .external_lex_state = 2},
  [1214] = {.lex_state = 67, .external_lex_state = 2},
  [1215] = {.lex_state = 67, .external_lex_state = 2},
  [1216] = {.lex_state = 67, .external_lex_state = 3},
  [1217] = {.lex_state = 67, .external_lex_state = 2},
  [1218] = {.lex_state = 67, .external_lex_state = 2},
  [1219] = {.lex_state = 67, .external_lex_state = 2},
  [1220] = {.lex_state = 67, .external_lex_state = 2},
  [1221] = {.lex_state = 67, .external_lex_state = 2},
  [1222] = {.lex_state = 67, .external_lex_state = 3},
  [1223] = {.lex_state = 67, .external_lex_state = 2},
  [1224] = {.lex_state = 67, .external_lex_state = 3},
  [1225] = {.lex_state = 67, .external_lex_state = 3},
  [1226] = {.lex_state = 67, .external_lex_state = 2},
  [1227] = {.lex_state = 67, .external_lex_state = 2},
  [1228] = {.lex_state = 67, .external_lex_state = 2},
  [1229] = {.lex_state = 67, .external_lex_state = 2},
  [1230] = {.lex_state = 67, .external_lex_state = 2},
  [1231] = {.lex_state = 67, .external_lex_state = 2},
  [1232] = {.lex_state = 67, .external_lex_state = 2},
  [1233] = {.lex_state = 67, .external_lex_state = 2},
  [1234] = {.lex_state = 67, .external_lex_state = 3},
  [1235] = {.lex_state = 67, .external_lex_state = 3},
  [1236] = {.lex_state = 67, .external_lex_state = 2},
  [1237] = {.lex_state = 67, .external_lex_state = 2},
  [1238] = {.lex_state = 67, .external_lex_state = 2},
  [1239] = {.lex_state = 67, .external_lex_state = 2},
  [1240] = {.lex_state = 67, .external_lex_state = 2},
  [1241] = {.lex_state = 67, .external_lex_state = 3},
  [1242] = {.lex_state = 67, .external_lex_state = 3},
  [1243] = {.lex_state = 67, .external_lex_state = 2},
  [1244] = {.lex_state = 67, .external_lex_state = 2},
  [1245] = {.lex_state = 67, .external_lex_state = 2},
  [1246] = {.lex_state = 67, .external_lex_state = 3},
  [1247] = {.lex_state = 67, .external_lex_state = 2},
  [1248] = {.lex_state = 8, .external_lex_state = 2},
  [1249] = {.lex_state = 8, .external_lex_state = 2},
  [1250] = {.lex_state = 67, .external_lex_state = 2},
  [1251] = {.lex_state = 67, .external_lex_state = 2},
  [1252] = {.lex_state = 67, .external_lex_state = 2},
  [1253] = {.lex_state = 8, .external_lex_state = 2},
  [1254] = {.lex_state = 67, .external_lex_state = 3},
  [1255] = {.lex_state = 8, .external_lex_state = 2},
  [1256] = {.lex_state = 67, .external_lex_state = 2},
  [1257] = {.lex_state = 8, .external_lex_state = 2},
  [1258] = {.lex_state = 8, .external_lex_state = 2},
  [1259] = {.lex_state = 8, .external_lex_state = 2},
  [1260] = {.lex_state = 67, .external_lex_state = 2},
  [1261] = {.lex_state = 8, .external_lex_state = 2},
  [1262] = {.lex_state = 67, .external_lex_state = 2},
  [1263] = {.lex_state = 8, .external_lex_state = 2},
  [1264] = {.lex_state = 8, .external_lex_state = 2},
  [1265] = {.lex_state = 67, .external_lex_state = 3},
  [1266] = {.lex_state = 8, .external_lex_state = 2},
  [1267] = {.lex_state = 8, .external_lex_state = 2},
  [1268] = {.lex_state = 67, .external_lex_state = 2},
  [1269] = {.lex_state = 67, .external_lex_state = 3},
  [1270] = {.lex_state = 67, .external_lex_state = 3},
  [1271] = {.lex_state = 67, .external_lex_state = 2},
  [1272] = {.lex_state = 8, .external_lex_state = 2},
  [1273] = {.lex_state = 8, .external_lex_state = 2},
  [1274] = {.lex_state = 8, .external_lex_state = 2},
  [1275] = {.lex_state = 8, .external_lex_state = 2},
  [1276] = {.lex_state = 67, .external_lex_state = 3},
  [1277] = {.lex_state = 8, .external_lex_state = 2},
  [1278] = {.lex_state = 67, .external_lex_state = 2},
  [1279] = {.lex_state = 67, .external_lex_state = 3},
  [1280] = {.lex_state = 67, .external_lex_state = 3},
  [1281] = {.lex_state = 67, .external_lex_state = 2},
  [1282] = {.lex_state = 67, .external_lex_state = 3},
  [1283] = {.lex_state = 67, .external_lex_state = 2},
  [1284] = {.lex_state = 8, .external_lex_state = 2},
  [1285] = {.lex_state = 67, .external_lex_state = 2},
  [1286] = {.lex_state = 67, .external_lex_state = 3},
  [1287] = {.lex_state = 67, .external_lex_state = 2},
  [1288] = {.lex_state = 8, .external_lex_state = 2},
  [1289] = {.lex_state = 67, .external_lex_state = 3},
  [1290] = {.lex_state = 9, .external_lex_state = 2},
  [1291] = {.lex_state = 67, .external_lex_state = 3},
  [1292] = {.lex_state = 67, .external_lex_state = 2},
  [1293] = {.lex_state = 67, .external_lex_state = 3},
  [1294] = {.lex_state = 8, .external_lex_state = 2},
  [1295] = {.lex_state = 67, .external_lex_state = 3},
  [1296] = {.lex_state = 67, .external_lex_state = 2},
  [1297] = {.lex_state = 67, .external_lex_state = 2},
  [1298] = {.lex_state = 67, .external_lex_state = 2},
  [1299] = {.lex_state = 8, .external_lex_state = 2},
  [1300] = {.lex_state = 67, .external_lex_state = 2},
  [1301] = {.lex_state = 67, .external_lex_state = 2},
  [1302] = {.lex_state = 67, .external_lex_state = 2},
  [1303] = {.lex_state = 67, .external_lex_state = 2},
  [1304] = {.lex_state = 67, .external_lex_state = 3},
  [1305] = {.lex_state = 67, .external_lex_state = 2},
  [1306] = {.lex_state = 67, .external_lex_state = 3},
  [1307] = {.lex_state = 67, .external_lex_state = 2},
  [1308] = {.lex_state = 67, .external_lex_state = 2},
  [1309] = {.lex_state = 67, .external_lex_state = 2},
  [1310] = {.lex_state = 67, .external_lex_state = 2},
  [1311] = {.lex_state = 67, .external_lex_state = 2},
  [1312] = {.lex_state = 67, .external_lex_state = 3},
  [1313] = {.lex_state = 67, .external_lex_state = 3},
  [1314] = {.lex_state = 67, .external_lex_state = 3},
  [1315] = {.lex_state = 67, .external_lex_state = 3},
  [1316] = {.lex_state = 8, .external_lex_state = 2},
  [1317] = {.lex_state = 8, .external_lex_state = 2},
  [1318] = {.lex_state = 8, .external_lex_state = 2},
  [1319] = {.lex_state = 67, .external_lex_state = 2},
  [1320] = {.lex_state = 67, .external_lex_state = 2},
  [1321] = {.lex_state = 67, .external_lex_state = 3},
  [1322] = {.lex_state = 67, .external_lex_state = 3},
  [1323] = {.lex_state = 67, .external_lex_state = 3},
  [1324] = {.lex_state = 8, .external_lex_state = 2},
  [1325] = {.lex_state = 67, .external_lex_state = 3},
  [1326] = {.lex_state = 67, .external_lex_state = 3},
  [1327] = {.lex_state = 67, .external_lex_state = 2},
  [1328] = {.lex_state = 67, .external_lex_state = 2},
  [1329] = {.lex_state = 67, .external_lex_state = 2},
  [1330] = {.lex_state = 8, .external_lex_state = 2},
  [1331] = {.lex_state = 67, .external_lex_state = 2},
  [1332] = {.lex_state = 67, .external_lex_state = 2},
  [1333] = {.lex_state = 8, .external_lex_state = 2},
  [1334] = {.lex_state = 67, .external_lex_state = 2},
  [1335] = {.lex_state = 8, .external_lex_state = 2},
  [1336] = {.lex_state = 67, .external_lex_state = 2},
  [1337] = {.lex_state = 67, .external_lex_state = 2},
  [1338] = {.lex_state = 67, .external_lex_state = 2},
  [1339] = {.lex_state = 8, .external_lex_state = 2},
  [1340] = {.lex_state = 67, .external_lex_state = 3},
  [1341] = {.lex_state = 67, .external_lex_state = 3},
  [1342] = {.lex_state = 8, .external_lex_state = 2},
  [1343] = {.lex_state = 67, .external_lex_state = 2},
  [1344] = {.lex_state = 67, .external_lex_state = 2},
  [1345] = {.lex_state = 67, .external_lex_state = 3},
  [1346] = {.lex_state = 67, .external_lex_state = 3},
  [1347] = {.lex_state = 67, .external_lex_state = 3},
  [1348] = {.lex_state = 67, .external_lex_state = 3},
  [1349] = {.lex_state = 67, .external_lex_state = 2},
  [1350] = {.lex_state = 67, .external_lex_state = 2},
  [1351] = {.lex_state = 8, .external_lex_state = 2},
  [1352] = {.lex_state = 67, .external_lex_state = 2},
  [1353] = {.lex_state = 67, .external_lex_state = 2},
  [1354] = {.lex_state = 67, .external_lex_state = 3},
  [1355] = {.lex_state = 67, .external_lex_state = 3},
  [1356] = {.lex_state = 67, .external_lex_state = 2},
  [1357] = {.lex_state = 8, .external_lex_state = 2},
  [1358] = {.lex_state = 67, .external_lex_state = 3},
  [1359] = {.lex_state = 67, .external_lex_state = 3},
  [1360] = {.lex_state = 67, .external_lex_state = 3},
  [1361] = {.lex_state = 67, .external_lex_state = 3},
  [1362] = {.lex_state = 67, .external_lex_state = 3},
  [1363] = {.lex_state = 67, .external_lex_state = 3},
  [1364] = {.lex_state = 67, .external_lex_state = 3},
  [1365] = {.lex_state = 67, .external_lex_state = 3},
  [1366] = {.lex_state = 67, .external_lex_state = 3},
  [1367] = {.lex_state = 67, .external_lex_state = 3},
  [1368] = {.lex_state = 67, .external_lex_state = 3},
  [1369] = {.lex_state = 67, .external_lex_state = 3},
  [1370] = {.lex_state = 8, .external_lex_state = 2},
  [1371] = {.lex_state = 67, .external_lex_state = 3},
  [1372] = {.lex_state = 67, .external_lex_state = 3},
  [1373] = {.lex_state = 67, .external_lex_state = 3},
  [1374] = {.lex_state = 67, .external_lex_state = 3},
  [1375] = {.lex_state = 67, .external_lex_state = 2},
  [1376] = {.lex_state = 67, .external_lex_state = 2},
  [1377] = {.lex_state = 67, .external_lex_state = 3},
  [1378] = {.lex_state = 67, .external_lex_state = 3},
  [1379] = {.lex_state = 67, .external_lex_state = 3},
  [1380] = {.lex_state = 67, .external_lex_state = 3},
  [1381] = {.lex_state = 67, .external_lex_state = 3},
  [1382] = {.lex_state = 67, .external_lex_state = 3},
  [1383] = {.lex_state = 67, .external_lex_state = 3},
  [1384] = {.lex_state = 67, .external_lex_state = 3},
  [1385] = {.lex_state = 67, .external_lex_state = 3},
  [1386] = {.lex_state = 67, .external_lex_state = 3},
  [1387] = {.lex_state = 67, .external_lex_state = 3},
  [1388] = {.lex_state = 67, .external_lex_state = 3},
  [1389] = {.lex_state = 8, .external_lex_state = 3},
  [1390] = {.lex_state = 67, .external_lex_state = 3},
  [1391] = {.lex_state = 67, .external_lex_state = 3},
  [1392] = {.lex_state = 67, .external_lex_state = 2},
  [1393] = {.lex_state = 67, .external_lex_state = 3},
  [1394] = {.lex_state = 67, .external_lex_state = 3},
  [1395] = {.lex_state = 67, .external_lex_state = 3},
  [1396] = {.lex_state = 67, .external_lex_state = 3},
  [1397] = {.lex_state = 67, .external_lex_state = 2},
  [1398] = {.lex_state = 67, .external_lex_state = 2},
  [1399] = {.lex_state = 67, .external_lex_state = 3},
  [1400] = {.lex_state = 67, .external_lex_state = 2},
  [1401] = {.lex_state = 67, .external_lex_state = 2},
  [1402] = {.lex_state = 67, .external_lex_state = 2},
  [1403] = {.lex_state = 67, .external_lex_state = 3},
  [1404] = {.lex_state = 67, .external_lex_state = 3},
  [1405] = {.lex_state = 67, .external_lex_state = 3},
  [1406] = {.lex_state = 67, .external_lex_state = 2},
  [1407] = {.lex_state = 8, .external_lex_state = 2},
  [1408] = {.lex_state = 67, .external_lex_state = 3},
  [1409] = {.lex_state = 67, .external_lex_state = 2},
  [1410] = {.lex_state = 9, .external_lex_state = 3},
  [1411] = {.lex_state = 67, .external_lex_state = 2},
  [1412] = {.lex_state = 67, .external_lex_state = 2},
  [1413] = {.lex_state = 67, .external_lex_state = 2},
  [1414] = {.lex_state = 67, .external_lex_state = 2},
  [1415] = {.lex_state = 67, .external_lex_state = 3},
  [1416] = {.lex_state = 67, .external_lex_state = 3},
  [1417] = {.lex_state = 67, .external_lex_state = 3},
  [1418] = {.lex_state = 67, .external_lex_state = 3},
  [1419] = {.lex_state = 67, .external_lex_state = 3},
  [1420] = {.lex_state = 67, .external_lex_state = 3},
  [1421] = {.lex_state = 67, .external_lex_state = 2},
  [1422] = {.lex_state = 67, .external_lex_state = 3},
  [1423] = {.lex_state = 67, .external_lex_state = 3},
  [1424] = {.lex_state = 67, .external_lex_state = 3},
  [1425] = {.lex_state = 67, .external_lex_state = 3},
  [1426] = {.lex_state = 67, .external_lex_state = 3},
  [1427] = {.lex_state = 67, .external_lex_state = 3},
  [1428] = {.lex_state = 67, .external_lex_state = 2},
  [1429] = {.lex_state = 67, .external_lex_state = 3},
  [1430] = {.lex_state = 67, .external_lex_state = 3},
  [1431] = {.lex_state = 67, .external_lex_state = 3},
  [1432] = {.lex_state = 67, .external_lex_state = 2},
  [1433] = {.lex_state = 67, .external_lex_state = 3},
  [1434] = {.lex_state = 67, .external_lex_state = 3},
  [1435] = {.lex_state = 67, .external_lex_state = 3},
  [1436] = {.lex_state = 67, .external_lex_state = 3},
  [1437] = {.lex_state = 67, .external_lex_state = 3},
  [1438] = {.lex_state = 67, .external_lex_state = 3},
  [1439] = {.lex_state = 67, .external_lex_state = 3},
  [1440] = {.lex_state = 67, .external_lex_state = 3},
  [1441] = {.lex_state = 8, .external_lex_state = 2},
  [1442] = {.lex_state = 67, .external_lex_state = 3},
  [1443] = {.lex_state = 67, .external_lex_state = 3},
  [1444] = {.lex_state = 67, .external_lex_state = 3},
  [1445] = {.lex_state = 67, .external_lex_state = 3},
  [1446] = {.lex_state = 67, .external_lex_state = 3},
  [1447] = {.lex_state = 67, .external_lex_state = 2},
  [1448] = {.lex_state = 67, .external_lex_state = 2},
  [1449] = {.lex_state = 67, .external_lex_state = 2},
  [1450] = {.lex_state = 67, .external_lex_state = 2},
  [1451] = {.lex_state = 67, .external_lex_state = 3},
  [1452] = {.lex_state = 67, .external_lex_state = 2},
  [1453] = {.lex_state = 67, .external_lex_state = 2},
  [1454] = {.lex_state = 67, .external_lex_state = 2},
  [1455] = {.lex_state = 67, .external_lex_state = 2},
  [1456] = {.lex_state = 67, .external_lex_state = 3},
  [1457] = {.lex_state = 67, .external_lex_state = 2},
  [1458] = {.lex_state = 67, .external_lex_state = 2},
  [1459] = {.lex_state = 8, .external_lex_state = 2},
  [1460] = {.lex_state = 67, .external_lex_state = 2},
  [1461] = {.lex_state = 67, .external_lex_state = 2},
  [1462] = {.lex_state = 67, .external_lex_state = 2},
  [1463] = {.lex_state = 67, .external_lex_state = 2},
  [1464] = {.lex_state = 67, .external_lex_state = 3},
  [1465] = {.lex_state = 67, .external_lex_state = 3},
  [1466] = {.lex_state = 67, .external_lex_state = 2},
  [1467] = {.lex_state = 67, .external_lex_state = 2},
  [1468] = {.lex_state = 67, .external_lex_state = 2},
  [1469] = {.lex_state = 67, .external_lex_state = 2},
  [1470] = {.lex_state = 8, .external_lex_state = 2},
  [1471] = {.lex_state = 67, .external_lex_state = 2},
  [1472] = {.lex_state = 67, .external_lex_state = 2},
  [1473] = {.lex_state = 67, .external_lex_state = 2},
  [1474] = {.lex_state = 67, .external_lex_state = 2},
  [1475] = {.lex_state = 8, .external_lex_state = 2},
  [1476] = {.lex_state = 67, .external_lex_state = 3},
  [1477] = {.lex_state = 67, .external_lex_state = 2},
  [1478] = {.lex_state = 67, .external_lex_state = 2},
  [1479] = {.lex_state = 67, .external_lex_state = 2},
  [1480] = {.lex_state = 67, .external_lex_state = 2},
  [1481] = {.lex_state = 67, .external_lex_state = 2},
  [1482] = {.lex_state = 67, .external_lex_state = 2},
  [1483] = {.lex_state = 67, .external_lex_state = 2},
  [1484] = {.lex_state = 67, .external_lex_state = 3},
  [1485] = {.lex_state = 67, .external_lex_state = 3},
  [1486] = {.lex_state = 67, .external_lex_state = 2},
  [1487] = {.lex_state = 67, .external_lex_state = 2},
  [1488] = {.lex_state = 67, .external_lex_state = 2},
  [1489] = {.lex_state = 67, .external_lex_state = 3},
  [1490] = {.lex_state = 67, .external_lex_state = 2},
  [1491] = {.lex_state = 67, .external_lex_state = 3},
  [1492] = {.lex_state = 67, .external_lex_state = 3},
  [1493] = {.lex_state = 67, .external_lex_state = 2},
  [1494] = {.lex_state = 67, .external_lex_state = 3},
  [1495] = {.lex_state = 67, .external_lex_state = 3},
  [1496] = {.lex_state = 67, .external_lex_state = 2},
  [1497] = {.lex_state = 8, .external_lex_state = 2},
  [1498] = {.lex_state = 67, .external_lex_state = 3},
  [1499] = {.lex_state = 67, .external_lex_state = 2},
  [1500] = {.lex_state = 67, .external_lex_state = 3},
  [1501] = {.lex_state = 67, .external_lex_state = 3},
  [1502] = {.lex_state = 67, .external_lex_state = 2},
  [1503] = {.lex_state = 67, .external_lex_state = 3},
  [1504] = {.lex_state = 67, .external_lex_state = 3},
  [1505] = {.lex_state = 67, .external_lex_state = 3},
  [1506] = {.lex_state = 67, .external_lex_state = 3},
  [1507] = {.lex_state = 67, .external_lex_state = 3},
  [1508] = {.lex_state = 67, .external_lex_state = 3},
  [1509] = {.lex_state = 67, .external_lex_state = 3},
  [1510] = {.lex_state = 67, .external_lex_state = 3},
  [1511] = {.lex_state = 67, .external_lex_state = 3},
  [1512] = {.lex_state = 67, .external_lex_state = 3},
  [1513] = {.lex_state = 67, .external_lex_state = 3},
  [1514] = {.lex_state = 67, .external_lex_state = 3},
  [1515] = {.lex_state = 67, .external_lex_state = 2},
  [1516] = {.lex_state = 15},
  [1517] = {.lex_state = 67, .external_lex_state = 3},
  [1518] = {.lex_state = 15},
  [1519] = {.lex_state = 67, .external_lex_state = 3},
  [1520] = {.lex_state = 15},
  [1521] = {.lex_state = 8, .external_lex_state = 2},
  [1522] = {.lex_state = 67, .external_lex_state = 2},
  [1523] = {.lex_state = 67, .external_lex_state = 2},
  [1524] = {.lex_state = 67, .external_lex_state = 2},
  [1525] = {.lex_state = 8, .external_lex_state = 2},
  [1526] = {.lex_state = 8, .external_lex_state = 2},
  [1527] = {.lex_state = 8, .external_lex_state = 2},
  [1528] = {.lex_state = 67, .external_lex_state = 3},
  [1529] = {.lex_state = 8, .external_lex_state = 2},
  [1530] = {.lex_state = 8, .external_lex_state = 2},
  [1531] = {.lex_state = 67, .external_lex_state = 3},
  [1532] = {.lex_state = 67, .external_lex_state = 3},
  [1533] = {.lex_state = 8, .external_lex_state = 2},
  [1534] = {.lex_state = 8, .external_lex_state = 2},
  [1535] = {.lex_state = 8, .external_lex_state = 2},
  [1536] = {.lex_state = 8, .external_lex_state = 2},
  [1537] = {.lex_state = 8, .external_lex_state = 2},
  [1538] = {.lex_state = 67, .external_lex_state = 3},
  [1539] = {.lex_state = 15},
  [1540] = {.lex_state = 8, .external_lex_state = 2},
  [1541] = {.lex_state = 8, .external_lex_state = 2},
  [1542] = {.lex_state = 8, .external_lex_state = 2},
  [1543] = {.lex_state = 67, .external_lex_state = 3},
  [1544] = {.lex_state = 15},
  [1545] = {.lex_state = 8, .external_lex_state = 2},
  [1546] = {.lex_state = 67, .external_lex_state = 2},
  [1547] = {.lex_state = 8, .external_lex_state = 2},
  [1548] = {.lex_state = 67, .external_lex_state = 3},
  [1549] = {.lex_state = 8, .external_lex_state = 2},
  [1550] = {.lex_state = 8, .external_lex_state = 2},
  [1551] = {.lex_state = 67, .external_lex_state = 3},
  [1552] = {.lex_state = 67, .external_lex_state = 2},
  [1553] = {.lex_state = 8, .external_lex_state = 2},
  [1554] = {.lex_state = 68},
  [1555] = {.lex_state = 68},
  [1556] = {.lex_state = 8, .external_lex_state = 2},
  [1557] = {.lex_state = 15},
  [1558] = {.lex_state = 8, .external_lex_state = 3},
  [1559] = {.lex_state = 67, .external_lex_state = 3},
  [1560] = {.lex_state = 67, .external_lex_state = 3},
  [1561] = {.lex_state = 67, .external_lex_state = 3},
  [1562] = {.lex_state = 8, .external_lex_state = 2},
  [1563] = {.lex_state = 8, .external_lex_state = 2},
  [1564] = {.lex_state = 8, .external_lex_state = 2},
  [1565] = {.lex_state = 15},
  [1566] = {.lex_state = 8, .external_lex_state = 2},
  [1567] = {.lex_state = 8, .external_lex_state = 2},
  [1568] = {.lex_state = 67, .external_lex_state = 2},
  [1569] = {.lex_state = 8, .external_lex_state = 2},
  [1570] = {.lex_state = 67, .external_lex_state = 3},
  [1571] = {.lex_state = 8, .external_lex_state = 3},
  [1572] = {.lex_state = 67, .external_lex_state = 3},
  [1573] = {.lex_state = 67, .external_lex_state = 3},
  [1574] = {.lex_state = 67, .external_lex_state = 3},
  [1575] = {.lex_state = 8, .external_lex_state = 2},
  [1576] = {.lex_state = 67, .external_lex_state = 3},
  [1577] = {.lex_state = 8, .external_lex_state = 2},
  [1578] = {.lex_state = 8, .external_lex_state = 2},
  [1579] = {.lex_state = 67, .external_lex_state = 3},
  [1580] = {.lex_state = 8, .external_lex_state = 2},
  [1581] = {.lex_state = 67, .external_lex_state = 3},
  [1582] = {.lex_state = 67, .external_lex_state = 3},
  [1583] = {.lex_state = 8, .external_lex_state = 2},
  [1584] = {.lex_state = 67, .external_lex_state = 3},
  [1585] = {.lex_state = 8, .external_lex_state = 2},
  [1586] = {.lex_state = 8, .external_lex_state = 2},
  [1587] = {.lex_state = 8, .external_lex_state = 2},
  [1588] = {.lex_state = 67, .external_lex_state = 3},
  [1589] = {.lex_state = 67, .external_lex_state = 3},
  [1590] = {.lex_state = 8, .external_lex_state = 2},
  [1591] = {.lex_state = 67, .external_lex_state = 2},
  [1592] = {.lex_state = 67, .external_lex_state = 3},
  [1593] = {.lex_state = 8, .external_lex_state = 2},
  [1594] = {.lex_state = 8, .external_lex_state = 2},
  [1595] = {.lex_state = 67, .external_lex_state = 3},
  [1596] = {.lex_state = 67, .external_lex_state = 3},
  [1597] = {.lex_state = 67, .external_lex_state = 3},
  [1598] = {.lex_state = 68},
  [1599] = {.lex_state = 8, .external_lex_state = 2},
  [1600] = {.lex_state = 9, .external_lex_state = 2},
  [1601] = {.lex_state = 67, .external_lex_state = 3},
  [1602] = {.lex_state = 67, .external_lex_state = 3},
  [1603] = {.lex_state = 67, .external_lex_state = 3},
  [1604] = {.lex_state = 67, .external_lex_state = 3},
  [1605] = {.lex_state = 67, .external_lex_state = 2},
  [1606] = {.lex_state = 67, .external_lex_state = 3},
  [1607] = {.lex_state = 67, .external_lex_state = 2},
  [1608] = {.lex_state = 67, .external_lex_state = 3},
  [1609] = {.lex_state = 11, .external_lex_state = 2},
  [1610] = {.lex_state = 8, .external_lex_state = 2},
  [1611] = {.lex_state = 67, .external_lex_state = 3},
  [1612] = {.lex_state = 67, .external_lex_state = 2},
  [1613] = {.lex_state = 8, .external_lex_state = 2},
  [1614] = {.lex_state = 67, .external_lex_state = 2},
  [1615] = {.lex_state = 67, .external_lex_state = 3},
  [1616] = {.lex_state = 8, .external_lex_state = 2},
  [1617] = {.lex_state = 67, .external_lex_state = 3},
  [1618] = {.lex_state = 8, .external_lex_state = 2},
  [1619] = {.lex_state = 8, .external_lex_state = 2},
  [1620] = {.lex_state = 15},
  [1621] = {.lex_state = 8, .external_lex_state = 2},
  [1622] = {.lex_state = 67, .external_lex_state = 3},
  [1623] = {.lex_state = 15},
  [1624] = {.lex_state = 8, .external_lex_state = 2},
  [1625] = {.lex_state = 8, .external_lex_state = 2},
  [1626] = {.lex_state = 8, .external_lex_state = 2},
  [1627] = {.lex_state = 15},
  [1628] = {.lex_state = 8, .external_lex_state = 2},
  [1629] = {.lex_state = 8, .external_lex_state = 2},
  [1630] = {.lex_state = 15},
  [1631] = {.lex_state = 8, .external_lex_state = 2},
  [1632] = {.lex_state = 8, .external_lex_state = 2},
  [1633] = {.lex_state = 67, .external_lex_state = 2},
  [1634] = {.lex_state = 67, .external_lex_state = 3},
  [1635] = {.lex_state = 67, .external_lex_state = 3},
  [1636] = {.lex_state = 67, .external_lex_state = 2},
  [1637] = {.lex_state = 67, .external_lex_state = 2},
  [1638] = {.lex_state = 67, .external_lex_state = 2},
  [1639] = {.lex_state = 67, .external_lex_state = 2},
  [1640] = {.lex_state = 67, .external_lex_state = 3},
  [1641] = {.lex_state = 67, .external_lex_state = 3},
  [1642] = {.lex_state = 67, .external_lex_state = 2},
  [1643] = {.lex_state = 8, .external_lex_state = 2},
  [1644] = {.lex_state = 8, .external_lex_state = 2},
  [1645] = {.lex_state = 15},
  [1646] = {.lex_state = 67, .external_lex_state = 3},
  [1647] = {.lex_state = 67, .external_lex_state = 2},
  [1648] = {.lex_state = 8, .external_lex_state = 2},
  [1649] = {.lex_state = 8, .external_lex_state = 2},
  [1650] = {.lex_state = 8, .external_lex_state = 2},
  [1651] = {.lex_state = 67, .external_lex_state = 3},
  [1652] = {.lex_state = 8, .external_lex_state = 2},
  [1653] = {.lex_state = 67, .external_lex_state = 3},
  [1654] = {.lex_state = 8, .external_lex_state = 2},
  [1655] = {.lex_state = 67, .external_lex_state = 2},
  [1656] = {.lex_state = 67, .external_lex_state = 2},
  [1657] = {.lex_state = 68},
  [1658] = {.lex_state = 67, .external_lex_state = 3},
  [1659] = {.lex_state = 15},
  [1660] = {.lex_state = 67, .external_lex_state = 3},
  [1661] = {.lex_state = 67, .external_lex_state = 3},
  [1662] = {.lex_state = 67, .external_lex_state = 3},
  [1663] = {.lex_state = 67, .external_lex_state = 3},
  [1664] = {.lex_state = 8, .external_lex_state = 2},
  [1665] = {.lex_state = 68},
  [1666] = {.lex_state = 67, .external_lex_state = 3},
  [1667] = {.lex_state = 8, .external_lex_state = 2},
  [1668] = {.lex_state = 67, .external_lex_state = 3},
  [1669] = {.lex_state = 67, .external_lex_state = 3},
  [1670] = {.lex_state = 67, .external_lex_state = 3},
  [1671] = {.lex_state = 67, .external_lex_state = 3},
  [1672] = {.lex_state = 8, .external_lex_state = 2},
  [1673] = {.lex_state = 8, .external_lex_state = 2},
  [1674] = {.lex_state = 8, .external_lex_state = 2},
  [1675] = {.lex_state = 8, .external_lex_state = 2},
  [1676] = {.lex_state = 8, .external_lex_state = 2},
  [1677] = {.lex_state = 8, .external_lex_state = 2},
  [1678] = {.lex_state = 8, .external_lex_state = 2},
  [1679] = {.lex_state = 8, .external_lex_state = 2},
  [1680] = {.lex_state = 8, .external_lex_state = 2},
  [1681] = {.lex_state = 8, .external_lex_state = 2},
  [1682] = {.lex_state = 67, .external_lex_state = 2},
  [1683] = {.lex_state = 8, .external_lex_state = 2},
  [1684] = {.lex_state = 8, .external_lex_state = 2},
  [1685] = {.lex_state = 8, .external_lex_state = 2},
  [1686] = {.lex_state = 8, .external_lex_state = 2},
  [1687] = {.lex_state = 8, .external_lex_state = 2},
  [1688] = {.lex_state = 8, .external_lex_state = 2},
  [1689] = {.lex_state = 8, .external_lex_state = 2},
  [1690] = {.lex_state = 8, .external_lex_state = 2},
  [1691] = {.lex_state = 67, .external_lex_state = 2},
  [1692] = {.lex_state = 8, .external_lex_state = 2},
  [1693] = {.lex_state = 67, .external_lex_state = 2},
  [1694] = {.lex_state = 8, .external_lex_state = 2},
  [1695] = {.lex_state = 68, .external_lex_state = 4},
  [1696] = {.lex_state = 67, .external_lex_state = 2},
  [1697] = {.lex_state = 67, .external_lex_state = 2},
  [1698] = {.lex_state = 68, .external_lex_state = 4},
  [1699] = {.lex_state = 8, .external_lex_state = 2},
  [1700] = {.lex_state = 8, .external_lex_state = 2},
  [1701] = {.lex_state = 68, .external_lex_state = 4},
  [1702] = {.lex_state = 8, .external_lex_state = 2},
  [1703] = {.lex_state = 8, .external_lex_state = 2},
  [1704] = {.lex_state = 8, .external_lex_state = 2},
  [1705] = {.lex_state = 8, .external_lex_state = 2},
  [1706] = {.lex_state = 8, .external_lex_state = 2},
  [1707] = {.lex_state = 8, .external_lex_state = 2},
  [1708] = {.lex_state = 8, .external_lex_state = 2},
  [1709] = {.lex_state = 8, .external_lex_state = 2},
  [1710] = {.lex_state = 8, .external_lex_state = 2},
  [1711] = {.lex_state = 8, .external_lex_state = 2},
  [1712] = {.lex_state = 68, .external_lex_state = 4},
  [1713] = {.lex_state = 67, .external_lex_state = 3},
  [1714] = {.lex_state = 68, .external_lex_state = 4},
  [1715] = {.lex_state = 68},
  [1716] = {.lex_state = 68, .external_lex_state = 4},
  [1717] = {.lex_state = 8, .external_lex_state = 2},
  [1718] = {.lex_state = 8, .external_lex_state = 2},
  [1719] = {.lex_state = 8, .external_lex_state = 2},
  [1720] = {.lex_state = 8, .external_lex_state = 2},
  [1721] = {.lex_state = 8, .external_lex_state = 2},
  [1722] = {.lex_state = 8, .external_lex_state = 2},
  [1723] = {.lex_state = 68, .external_lex_state = 4},
  [1724] = {.lex_state = 8, .external_lex_state = 2},
  [1725] = {.lex_state = 8, .external_lex_state = 2},
  [1726] = {.lex_state = 8, .external_lex_state = 2},
  [1727] = {.lex_state = 8, .external_lex_state = 2},
  [1728] = {.lex_state = 68, .external_lex_state = 4},
  [1729] = {.lex_state = 8, .external_lex_state = 2},
  [1730] = {.lex_state = 8, .external_lex_state = 2},
  [1731] = {.lex_state = 8, .external_lex_state = 2},
  [1732] = {.lex_state = 8, .external_lex_state = 2},
  [1733] = {.lex_state = 8, .external_lex_state = 2},
  [1734] = {.lex_state = 8, .external_lex_state = 2},
  [1735] = {.lex_state = 8, .external_lex_state = 2},
  [1736] = {.lex_state = 68, .external_lex_state = 4},
  [1737] = {.lex_state = 8, .external_lex_state = 2},
  [1738] = {.lex_state = 8, .external_lex_state = 2},
  [1739] = {.lex_state = 8, .external_lex_state = 2},
  [1740] = {.lex_state = 8, .external_lex_state = 2},
  [1741] = {.lex_state = 68, .external_lex_state = 4},
  [1742] = {.lex_state = 68, .external_lex_state = 4},
  [1743] = {.lex_state = 68, .external_lex_state = 4},
  [1744] = {.lex_state = 8, .external_lex_state = 2},
  [1745] = {.lex_state = 8, .external_lex_state = 2},
  [1746] = {.lex_state = 8, .external_lex_state = 2},
  [1747] = {.lex_state = 8, .external_lex_state = 2},
  [1748] = {.lex_state = 8, .external_lex_state = 2},
  [1749] = {.lex_state = 68, .external_lex_state = 4},
  [1750] = {.lex_state = 68, .external_lex_state = 4},
  [1751] = {.lex_state = 68, .external_lex_state = 4},
  [1752] = {.lex_state = 68, .external_lex_state = 4},
  [1753] = {.lex_state = 68, .external_lex_state = 4},
  [1754] = {.lex_state = 68, .external_lex_state = 4},
  [1755] = {.lex_state = 68, .external_lex_state = 4},
  [1756] = {.lex_state = 68, .external_lex_state = 4},
  [1757] = {.lex_state = 67, .external_lex_state = 2},
  [1758] = {.lex_state = 68, .external_lex_state = 4},
  [1759] = {.lex_state = 67, .external_lex_state = 2},
  [1760] = {.lex_state = 67, .external_lex_state = 2},
  [1761] = {.lex_state = 67, .external_lex_state = 2},
  [1762] = {.lex_state = 68, .external_lex_state = 4},
  [1763] = {.lex_state = 68, .external_lex_state = 4},
  [1764] = {.lex_state = 68, .external_lex_state = 4},
  [1765] = {.lex_state = 68, .external_lex_state = 4},
  [1766] = {.lex_state = 68, .external_lex_state = 4},
  [1767] = {.lex_state = 68, .external_lex_state = 4},
  [1768] = {.lex_state = 68, .external_lex_state = 4},
  [1769] = {.lex_state = 68, .external_lex_state = 4},
  [1770] = {.lex_state = 68, .external_lex_state = 4},
  [1771] = {.lex_state = 68, .external_lex_state = 4},
  [1772] = {.lex_state = 68, .external_lex_state = 4},
  [1773] = {.lex_state = 68, .external_lex_state = 4},
  [1774] = {.lex_state = 68, .external_lex_state = 4},
  [1775] = {.lex_state = 68, .external_lex_state = 4},
  [1776] = {.lex_state = 68, .external_lex_state = 4},
  [1777] = {.lex_state = 68, .external_lex_state = 4},
  [1778] = {.lex_state = 68, .external_lex_state = 4},
  [1779] = {.lex_state = 68, .external_lex_state = 4},
  [1780] = {.lex_state = 68, .external_lex_state = 4},
  [1781] = {.lex_state = 68, .external_lex_state = 4},
  [1782] = {.lex_state = 68, .external_lex_state = 4},
  [1783] = {.lex_state = 68, .external_lex_state = 4},
  [1784] = {.lex_state = 68, .external_lex_state = 4},
  [1785] = {.lex_state = 68, .external_lex_state = 4},
  [1786] = {.lex_state = 68, .external_lex_state = 4},
  [1787] = {.lex_state = 68},
  [1788] = {.lex_state = 68, .external_lex_state = 4},
  [1789] = {.lex_state = 68},
  [1790] = {.lex_state = 68},
  [1791] = {.lex_state = 68},
  [1792] = {.lex_state = 68},
  [1793] = {.lex_state = 68},
  [1794] = {.lex_state = 68, .external_lex_state = 4},
  [1795] = {.lex_state = 68, .external_lex_state = 4},
  [1796] = {.lex_state = 68, .external_lex_state = 4},
  [1797] = {.lex_state = 68},
  [1798] = {.lex_state = 68},
  [1799] = {.lex_state = 68, .external_lex_state = 4},
  [1800] = {.lex_state = 68},
  [1801] = {.lex_state = 68},
  [1802] = {.lex_state = 68},
  [1803] = {.lex_state = 68, .external_lex_state = 4},
  [1804] = {.lex_state = 68, .external_lex_state = 4},
  [1805] = {.lex_state = 68},
  [1806] = {.lex_state = 68, .external_lex_state = 4},
  [1807] = {.lex_state = 68},
  [1808] = {.lex_state = 68, .external_lex_state = 4},
  [1809] = {.lex_state = 68, .external_lex_state = 4},
  [1810] = {.lex_state = 68},
  [1811] = {.lex_state = 68},
  [1812] = {.lex_state = 68, .external_lex_state = 4},
  [1813] = {.lex_state = 68, .external_lex_state = 4},
  [1814] = {.lex_state = 17},
  [1815] = {.lex_state = 68},
  [1816] = {.lex_state = 68, .external_lex_state = 4},
  [1817] = {.lex_state = 68},
  [1818] = {.lex_state = 68},
  [1819] = {.lex_state = 68},
  [1820] = {.lex_state = 68, .external_lex_state = 4},
  [1821] = {.lex_state = 68},
  [1822] = {.lex_state = 68, .external_lex_state = 4},
  [1823] = {.lex_state = 68},
  [1824] = {.lex_state = 68},
  [1825] = {.lex_state = 68, .external_lex_state = 4},
  [1826] = {.lex_state = 68, .external_lex_state = 4},
  [1827] = {.lex_state = 68},
  [1828] = {.lex_state = 68},
  [1829] = {.lex_state = 68},
  [1830] = {.lex_state = 68},
  [1831] = {.lex_state = 68},
  [1832] = {.lex_state = 68, .external_lex_state = 4},
  [1833] = {.lex_state = 68},
  [1834] = {.lex_state = 68, .external_lex_state = 4},
  [1835] = {.lex_state = 68},
  [1836] = {.lex_state = 68},
  [1837] = {.lex_state = 68},
  [1838] = {.lex_state = 68},
  [1839] = {.lex_state = 68},
  [1840] = {.lex_state = 68},
  [1841] = {.lex_state = 17},
  [1842] = {.lex_state = 68},
  [1843] = {.lex_state = 68, .external_lex_state = 4},
  [1844] = {.lex_state = 68},
  [1845] = {.lex_state = 68},
  [1846] = {.lex_state = 68},
  [1847] = {.lex_state = 68},
  [1848] = {.lex_state = 68},
  [1849] = {.lex_state = 68},
  [1850] = {.lex_state = 68},
  [1851] = {.lex_state = 68},
  [1852] = {.lex_state = 68},
  [1853] = {.lex_state = 68},
  [1854] = {.lex_state = 68},
  [1855] = {.lex_state = 68},
  [1856] = {.lex_state = 68},
  [1857] = {.lex_state = 17},
  [1858] = {.lex_state = 17},
  [1859] = {.lex_state = 68},
  [1860] = {.lex_state = 17},
  [1861] = {.lex_state = 68},
  [1862] = {.lex_state = 17},
  [1863] = {.lex_state = 68},
  [1864] = {.lex_state = 68},
  [1865] = {.lex_state = 68},
  [1866] = {.lex_state = 17},
  [1867] = {.lex_state = 68},
  [1868] = {.lex_state = 68},
  [1869] = {.lex_state = 15, .external_lex_state = 4},
  [1870] = {.lex_state = 68},
  [1871] = {.lex_state = 15, .external_lex_state = 4},
  [1872] = {.lex_state = 15, .external_lex_state = 4},
  [1873] = {.lex_state = 15, .external_lex_state = 4},
  [1874] = {.lex_state = 68},
  [1875] = {.lex_state = 68},
  [1876] = {.lex_state = 68},
  [1877] = {.lex_state = 68},
  [1878] = {.lex_state = 68},
  [1879] = {.lex_state = 15, .external_lex_state = 4},
  [1880] = {.lex_state = 15, .external_lex_state = 4},
  [1881] = {.lex_state = 15, .external_lex_state = 4},
  [1882] = {.lex_state = 15, .external_lex_state = 4},
  [1883] = {.lex_state = 15, .external_lex_state = 4},
  [1884] = {.lex_state = 15, .external_lex_state = 4},
  [1885] = {.lex_state = 15, .external_lex_state = 4},
  [1886] = {.lex_state = 15, .external_lex_state = 4},
  [1887] = {.lex_state = 15, .external_lex_state = 4},
  [1888] = {.lex_state = 15, .external_lex_state = 4},
  [1889] = {.lex_state = 15, .external_lex_state = 4},
  [1890] = {.lex_state = 15, .external_lex_state = 4},
  [1891] = {.lex_state = 15, .external_lex_state = 4},
  [1892] = {.lex_state = 68},
  [1893] = {.lex_state = 68},
  [1894] = {.lex_state = 68},
  [1895] = {.lex_state = 68},
  [1896] = {.lex_state = 68},
  [1897] = {.lex_state = 68},
  [1898] = {.lex_state = 68},
  [1899] = {.lex_state = 68},
  [1900] = {.lex_state = 68},
  [1901] = {.lex_state = 68},
  [1902] = {.lex_state = 68},
  [1903] = {.lex_state = 68},
  [1904] = {.lex_state = 68},
  [1905] = {.lex_state = 68},
  [1906] = {.lex_state = 68},
  [1907] = {.lex_state = 68},
  [1908] = {.lex_state = 68},
  [1909] = {.lex_state = 68},
  [1910] = {.lex_state = 68},
  [1911] = {.lex_state = 68},
  [1912] = {.lex_state = 68},
  [1913] = {.lex_state = 15},
  [1914] = {.lex_state = 68},
  [1915] = {.lex_state = 68},
  [1916] = {.lex_state = 68},
  [1917] = {.lex_state = 68},
  [1918] = {.lex_state = 68},
  [1919] = {.lex_state = 68},
  [1920] = {.lex_state = 68},
  [1921] = {.lex_state = 68},
  [1922] = {.lex_state = 68},
  [1923] = {.lex_state = 68},
  [1924] = {.lex_state = 68},
  [1925] = {.lex_state = 68},
  [1926] = {.lex_state = 68},
  [1927] = {.lex_state = 68},
  [1928] = {.lex_state = 68},
  [1929] = {.lex_state = 68},
  [1930] = {.lex_state = 68},
  [1931] = {.lex_state = 68},
  [1932] = {.lex_state = 68},
  [1933] = {.lex_state = 68},
  [1934] = {.lex_state = 68},
  [1935] = {.lex_state = 68},
  [1936] = {.lex_state = 68},
  [1937] = {.lex_state = 68},
  [1938] = {.lex_state = 68},
  [1939] = {.lex_state = 68},
  [1940] = {.lex_state = 68},
  [1941] = {.lex_state = 68},
  [1942] = {.lex_state = 68},
  [1943] = {.lex_state = 68},
  [1944] = {.lex_state = 68},
  [1945] = {.lex_state = 68},
  [1946] = {.lex_state = 68},
  [1947] = {.lex_state = 68},
  [1948] = {.lex_state = 68},
  [1949] = {.lex_state = 68},
  [1950] = {.lex_state = 68},
  [1951] = {.lex_state = 68},
  [1952] = {.lex_state = 68},
  [1953] = {.lex_state = 68},
  [1954] = {.lex_state = 68},
  [1955] = {.lex_state = 68},
  [1956] = {.lex_state = 68},
  [1957] = {.lex_state = 68},
  [1958] = {.lex_state = 68},
  [1959] = {.lex_state = 68, .external_lex_state = 4},
  [1960] = {.lex_state = 68},
  [1961] = {.lex_state = 68, .external_lex_state = 4},
  [1962] = {.lex_state = 68},
  [1963] = {.lex_state = 6},
  [1964] = {.lex_state = 6},
  [1965] = {.lex_state = 68},
  [1966] = {.lex_state = 68},
  [1967] = {.lex_state = 6},
  [1968] = {.lex_state = 6},
  [1969] = {.lex_state = 6},
  [1970] = {.lex_state = 6},
  [1971] = {.lex_state = 68, .external_lex_state = 4},
  [1972] = {.lex_state = 68, .external_lex_state = 4},
  [1973] = {.lex_state = 68, .external_lex_state = 4},
  [1974] = {.lex_state = 68, .external_lex_state = 4},
  [1975] = {.lex_state = 68, .external_lex_state = 4},
  [1976] = {.lex_state = 68, .external_lex_state = 4},
  [1977] = {.lex_state = 68, .external_lex_state = 4},
  [1978] = {.lex_state = 68, .external_lex_state = 4},
  [1979] = {.lex_state = 68, .external_lex_state = 4},
  [1980] = {.lex_state = 68, .external_lex_state = 4},
  [1981] = {.lex_state = 68},
  [1982] = {.lex_state = 68, .external_lex_state = 4},
  [1983] = {.lex_state = 68, .external_lex_state = 4},
  [1984] = {.lex_state = 68, .external_lex_state = 4},
  [1985] = {.lex_state = 68, .external_lex_state = 4},
  [1986] = {.lex_state = 68, .external_lex_state = 4},
  [1987] = {.lex_state = 68, .external_lex_state = 4},
  [1988] = {.lex_state = 68, .external_lex_state = 4},
  [1989] = {.lex_state = 68, .external_lex_state = 4},
  [1990] = {.lex_state = 68, .external_lex_state = 4},
  [1991] = {.lex_state = 68, .external_lex_state = 4},
  [1992] = {.lex_state = 68, .external_lex_state = 4},
  [1993] = {.lex_state = 68, .external_lex_state = 4},
  [1994] = {.lex_state = 68, .external_lex_state = 4},
  [1995] = {.lex_state = 68, .external_lex_state = 4},
  [1996] = {.lex_state = 68, .external_lex_state = 4},
  [1997] = {.lex_state = 68, .external_lex_state = 4},
  [1998] = {.lex_state = 68, .external_lex_state = 4},
  [1999] = {.lex_state = 68, .external_lex_state = 4},
  [2000] = {.lex_state = 68, .external_lex_state = 4},
  [2001] = {.lex_state = 68, .external_lex_state = 4},
  [2002] = {.lex_state = 68, .external_lex_state = 5},
  [2003] = {.lex_state = 68, .external_lex_state = 4},
  [2004] = {.lex_state = 68, .external_lex_state = 4},
  [2005] = {.lex_state = 68, .external_lex_state = 4},
  [2006] = {.lex_state = 68, .external_lex_state = 4},
  [2007] = {.lex_state = 68, .external_lex_state = 4},
  [2008] = {.lex_state = 68, .external_lex_state = 4},
  [2009] = {.lex_state = 68, .external_lex_state = 4},
  [2010] = {.lex_state = 68},
  [2011] = {.lex_state = 68},
  [2012] = {.lex_state = 68, .external_lex_state = 4},
  [2013] = {.lex_state = 68, .external_lex_state = 4},
  [2014] = {.lex_state = 68, .external_lex_state = 4},
  [2015] = {.lex_state = 68, .external_lex_state = 4},
  [2016] = {.lex_state = 68, .external_lex_state = 4},
  [2017] = {.lex_state = 68, .external_lex_state = 4},
  [2018] = {.lex_state = 68, .external_lex_state = 4},
  [2019] = {.lex_state = 68, .external_lex_state = 4},
  [2020] = {.lex_state = 68, .external_lex_state = 4},
  [2021] = {.lex_state = 68, .external_lex_state = 4},
  [2022] = {.lex_state = 68, .external_lex_state = 4},
  [2023] = {.lex_state = 68, .external_lex_state = 4},
  [2024] = {.lex_state = 68, .external_lex_state = 4},
  [2025] = {.lex_state = 68, .external_lex_state = 4},
  [2026] = {.lex_state = 68, .external_lex_state = 4},
  [2027] = {.lex_state = 68, .external_lex_state = 4},
  [2028] = {.lex_state = 68, .external_lex_state = 4},
  [2029] = {.lex_state = 68, .external_lex_state = 5},
  [2030] = {.lex_state = 68, .external_lex_state = 5},
  [2031] = {.lex_state = 68, .external_lex_state = 4},
  [2032] = {.lex_state = 68, .external_lex_state = 5},
  [2033] = {.lex_state = 68, .external_lex_state = 4},
  [2034] = {.lex_state = 68, .external_lex_state = 4},
  [2035] = {.lex_state = 68, .external_lex_state = 4},
  [2036] = {.lex_state = 68, .external_lex_state = 4},
  [2037] = {.lex_state = 68, .external_lex_state = 4},
  [2038] = {.lex_state = 68, .external_lex_state = 4},
  [2039] = {.lex_state = 68, .external_lex_state = 4},
  [2040] = {.lex_state = 68, .external_lex_state = 4},
  [2041] = {.lex_state = 68, .external_lex_state = 4},
  [2042] = {.lex_state = 68, .external_lex_state = 4},
  [2043] = {.lex_state = 68, .external_lex_state = 4},
  [2044] = {.lex_state = 68, .external_lex_state = 4},
  [2045] = {.lex_state = 68, .external_lex_state = 4},
  [2046] = {.lex_state = 68, .external_lex_state = 4},
  [2047] = {.lex_state = 68, .external_lex_state = 4},
  [2048] = {.lex_state = 68, .external_lex_state = 4},
  [2049] = {.lex_state = 68, .external_lex_state = 4},
  [2050] = {.lex_state = 68, .external_lex_state = 4},
  [2051] = {.lex_state = 68, .external_lex_state = 4},
  [2052] = {.lex_state = 68, .external_lex_state = 4},
  [2053] = {.lex_state = 68, .external_lex_state = 4},
  [2054] = {.lex_state = 68, .external_lex_state = 4},
  [2055] = {.lex_state = 68, .external_lex_state = 4},
  [2056] = {.lex_state = 68, .external_lex_state = 4},
  [2057] = {.lex_state = 68, .external_lex_state = 4},
  [2058] = {.lex_state = 68, .external_lex_state = 4},
  [2059] = {.lex_state = 68},
  [2060] = {.lex_state = 68},
  [2061] = {.lex_state = 68, .external_lex_state = 4},
  [2062] = {.lex_state = 68, .external_lex_state = 5},
  [2063] = {.lex_state = 68},
  [2064] = {.lex_state = 68},
  [2065] = {.lex_state = 68, .external_lex_state = 4},
  [2066] = {.lex_state = 68, .external_lex_state = 4},
  [2067] = {.lex_state = 68},
  [2068] = {.lex_state = 68, .external_lex_state = 4},
  [2069] = {.lex_state = 68},
  [2070] = {.lex_state = 68, .external_lex_state = 5},
  [2071] = {.lex_state = 68, .external_lex_state = 5},
  [2072] = {.lex_state = 68},
  [2073] = {.lex_state = 68},
  [2074] = {.lex_state = 68},
  [2075] = {.lex_state = 68},
  [2076] = {.lex_state = 68},
  [2077] = {.lex_state = 68, .external_lex_state = 4},
  [2078] = {.lex_state = 68},
  [2079] = {.lex_state = 68, .external_lex_state = 5},
  [2080] = {.lex_state = 68},
  [2081] = {.lex_state = 68, .external_lex_state = 4},
  [2082] = {.lex_state = 68},
  [2083] = {.lex_state = 68},
  [2084] = {.lex_state = 68},
  [2085] = {.lex_state = 68},
  [2086] = {.lex_state = 68},
  [2087] = {.lex_state = 68},
  [2088] = {.lex_state = 68},
  [2089] = {.lex_state = 68, .external_lex_state = 4},
  [2090] = {.lex_state = 68},
  [2091] = {.lex_state = 68},
  [2092] = {.lex_state = 68},
  [2093] = {.lex_state = 68},
  [2094] = {.lex_state = 68},
  [2095] = {.lex_state = 68},
  [2096] = {.lex_state = 68, .external_lex_state = 5},
  [2097] = {.lex_state = 68, .external_lex_state = 5},
  [2098] = {.lex_state = 68},
  [2099] = {.lex_state = 68},
  [2100] = {.lex_state = 68},
  [2101] = {.lex_state = 68, .external_lex_state = 4},
  [2102] = {.lex_state = 68},
  [2103] = {.lex_state = 68, .external_lex_state = 4},
  [2104] = {.lex_state = 68},
  [2105] = {.lex_state = 68},
  [2106] = {.lex_state = 68},
  [2107] = {.lex_state = 68},
  [2108] = {.lex_state = 68},
  [2109] = {.lex_state = 68},
  [2110] = {.lex_state = 68},
  [2111] = {.lex_state = 68},
  [2112] = {.lex_state = 68},
  [2113] = {.lex_state = 68},
  [2114] = {.lex_state = 68},
  [2115] = {.lex_state = 68},
  [2116] = {.lex_state = 68},
  [2117] = {.lex_state = 68},
  [2118] = {.lex_state = 68, .external_lex_state = 4},
  [2119] = {.lex_state = 68, .external_lex_state = 5},
  [2120] = {.lex_state = 68},
  [2121] = {.lex_state = 68, .external_lex_state = 4},
  [2122] = {.lex_state = 68, .external_lex_state = 5},
  [2123] = {.lex_state = 68, .external_lex_state = 5},
  [2124] = {.lex_state = 68, .external_lex_state = 5},
  [2125] = {.lex_state = 68, .external_lex_state = 5},
  [2126] = {.lex_state = 68, .external_lex_state = 5},
  [2127] = {.lex_state = 68},
  [2128] = {.lex_state = 68, .external_lex_state = 5},
  [2129] = {.lex_state = 68, .external_lex_state = 5},
  [2130] = {.lex_state = 68, .external_lex_state = 5},
  [2131] = {.lex_state = 68, .external_lex_state = 5},
  [2132] = {.lex_state = 68},
  [2133] = {.lex_state = 68, .external_lex_state = 4},
  [2134] = {.lex_state = 68, .external_lex_state = 5},
  [2135] = {.lex_state = 68, .external_lex_state = 5},
  [2136] = {.lex_state = 68},
  [2137] = {.lex_state = 68, .external_lex_state = 4},
  [2138] = {.lex_state = 68, .external_lex_state = 5},
  [2139] = {.lex_state = 68, .external_lex_state = 5},
  [2140] = {.lex_state = 68},
  [2141] = {.lex_state = 68, .external_lex_state = 5},
  [2142] = {.lex_state = 68, .external_lex_state = 5},
  [2143] = {.lex_state = 68, .external_lex_state = 5},
  [2144] = {.lex_state = 68, .external_lex_state = 5},
  [2145] = {.lex_state = 68, .external_lex_state = 5},
  [2146] = {.lex_state = 68, .external_lex_state = 5},
  [2147] = {.lex_state = 68, .external_lex_state = 5},
  [2148] = {.lex_state = 68, .external_lex_state = 5},
  [2149] = {.lex_state = 68, .external_lex_state = 5},
  [2150] = {.lex_state = 68, .external_lex_state = 5},
  [2151] = {.lex_state = 68, .external_lex_state = 5},
  [2152] = {.lex_state = 68, .external_lex_state = 5},
  [2153] = {.lex_state = 68},
  [2154] = {.lex_state = 68, .external_lex_state = 5},
  [2155] = {.lex_state = 68, .external_lex_state = 5},
  [2156] = {.lex_state = 68, .external_lex_state = 5},
  [2157] = {.lex_state = 68, .external_lex_state = 5},
  [2158] = {.lex_state = 68, .external_lex_state = 5},
  [2159] = {.lex_state = 68, .external_lex_state = 5},
  [2160] = {.lex_state = 68, .external_lex_state = 4},
  [2161] = {.lex_state = 68, .external_lex_state = 5},
  [2162] = {.lex_state = 68, .external_lex_state = 5},
  [2163] = {.lex_state = 68, .external_lex_state = 5},
  [2164] = {.lex_state = 68, .external_lex_state = 5},
  [2165] = {.lex_state = 68, .external_lex_state = 5},
  [2166] = {.lex_state = 68, .external_lex_state = 5},
  [2167] = {.lex_state = 68, .external_lex_state = 5},
  [2168] = {.lex_state = 68, .external_lex_state = 5},
  [2169] = {.lex_state = 68, .external_lex_state = 5},
  [2170] = {.lex_state = 0, .external_lex_state = 4},
  [2171] = {.lex_state = 68, .external_lex_state = 4},
  [2172] = {.lex_state = 68},
  [2173] = {.lex_state = 68, .external_lex_state = 4},
  [2174] = {.lex_state = 68},
  [2175] = {.lex_state = 68},
  [2176] = {.lex_state = 68},
  [2177] = {.lex_state = 68},
  [2178] = {.lex_state = 68},
  [2179] = {.lex_state = 68},
  [2180] = {.lex_state = 68},
  [2181] = {.lex_state = 68},
  [2182] = {.lex_state = 68},
  [2183] = {.lex_state = 68},
  [2184] = {.lex_state = 14},
  [2185] = {.lex_state = 68},
  [2186] = {.lex_state = 68},
  [2187] = {.lex_state = 0, .external_lex_state = 4},
  [2188] = {.lex_state = 68, .external_lex_state = 5},
  [2189] = {.lex_state = 68},
  [2190] = {.lex_state = 0, .external_lex_state = 4},
  [2191] = {.lex_state = 68, .external_lex_state = 5},
  [2192] = {.lex_state = 0, .external_lex_state = 4},
  [2193] = {.lex_state = 68},
  [2194] = {.lex_state = 14},
  [2195] = {.lex_state = 68},
  [2196] = {.lex_state = 68},
  [2197] = {.lex_state = 68, .external_lex_state = 5},
  [2198] = {.lex_state = 68},
  [2199] = {.lex_state = 68},
  [2200] = {.lex_state = 68},
  [2201] = {.lex_state = 68},
  [2202] = {.lex_state = 68},
  [2203] = {.lex_state = 0, .external_lex_state = 4},
  [2204] = {.lex_state = 68},
  [2205] = {.lex_state = 0, .external_lex_state = 4},
  [2206] = {.lex_state = 68},
  [2207] = {.lex_state = 68},
  [2208] = {.lex_state = 68},
  [2209] = {.lex_state = 68},
  [2210] = {.lex_state = 68},
  [2211] = {.lex_state = 68},
  [2212] = {.lex_state = 68, .external_lex_state = 4},
  [2213] = {.lex_state = 68},
  [2214] = {.lex_state = 68, .external_lex_state = 4},
  [2215] = {.lex_state = 68, .external_lex_state = 4},
  [2216] = {.lex_state = 68},
  [2217] = {.lex_state = 68},
  [2218] = {.lex_state = 68},
  [2219] = {.lex_state = 68},
  [2220] = {.lex_state = 68},
  [2221] = {.lex_state = 68},
  [2222] = {.lex_state = 68, .external_lex_state = 4},
  [2223] = {.lex_state = 68},
  [2224] = {.lex_state = 68, .external_lex_state = 4},
  [2225] = {.lex_state = 68, .external_lex_state = 4},
  [2226] = {.lex_state = 68, .external_lex_state = 4},
  [2227] = {.lex_state = 68},
  [2228] = {.lex_state = 68, .external_lex_state = 4},
  [2229] = {.lex_state = 68, .external_lex_state = 4},
  [2230] = {.lex_state = 68},
  [2231] = {.lex_state = 68},
  [2232] = {.lex_state = 68, .external_lex_state = 4},
  [2233] = {.lex_state = 68},
  [2234] = {.lex_state = 68},
  [2235] = {.lex_state = 68},
  [2236] = {.lex_state = 0, .external_lex_state = 4},
  [2237] = {.lex_state = 68, .external_lex_state = 4},
  [2238] = {.lex_state = 68},
  [2239] = {.lex_state = 68},
  [2240] = {.lex_state = 68},
  [2241] = {.lex_state = 68, .external_lex_state = 4},
  [2242] = {.lex_state = 0, .external_lex_state = 4},
  [2243] = {.lex_state = 68, .external_lex_state = 4},
  [2244] = {.lex_state = 68, .external_lex_state = 4},
  [2245] = {.lex_state = 68},
  [2246] = {.lex_state = 68},
  [2247] = {.lex_state = 68, .external_lex_state = 4},
  [2248] = {.lex_state = 68, .external_lex_state = 4},
  [2249] = {.lex_state = 68, .external_lex_state = 4},
  [2250] = {.lex_state = 68, .external_lex_state = 4},
  [2251] = {.lex_state = 68},
  [2252] = {.lex_state = 68},
  [2253] = {.lex_state = 0, .external_lex_state = 4},
  [2254] = {.lex_state = 68},
  [2255] = {.lex_state = 68},
  [2256] = {.lex_state = 19, .external_lex_state = 6},
  [2257] = {.lex_state = 19, .external_lex_state = 6},
  [2258] = {.lex_state = 68},
  [2259] = {.lex_state = 0, .external_lex_state = 4},
  [2260] = {.lex_state = 19},
  [2261] = {.lex_state = 68},
  [2262] = {.lex_state = 68},
  [2263] = {.lex_state = 68},
  [2264] = {.lex_state = 0, .external_lex_state = 4},
  [2265] = {.lex_state = 68},
  [2266] = {.lex_state = 68},
  [2267] = {.lex_state = 68},
  [2268] = {.lex_state = 68},
  [2269] = {.lex_state = 68, .external_lex_state = 4},
  [2270] = {.lex_state = 68, .external_lex_state = 4},
  [2271] = {.lex_state = 0, .external_lex_state = 4},
  [2272] = {.lex_state = 14},
  [2273] = {.lex_state = 68},
  [2274] = {.lex_state = 19, .external_lex_state = 6},
  [2275] = {.lex_state = 0, .external_lex_state = 4},
  [2276] = {.lex_state = 68},
  [2277] = {.lex_state = 0, .external_lex_state = 4},
  [2278] = {.lex_state = 68},
  [2279] = {.lex_state = 68},
  [2280] = {.lex_state = 68},
  [2281] = {.lex_state = 68},
  [2282] = {.lex_state = 68, .external_lex_state = 4},
  [2283] = {.lex_state = 68},
  [2284] = {.lex_state = 68},
  [2285] = {.lex_state = 68},
  [2286] = {.lex_state = 0, .external_lex_state = 4},
  [2287] = {.lex_state = 68},
  [2288] = {.lex_state = 68},
  [2289] = {.lex_state = 68},
  [2290] = {.lex_state = 68},
  [2291] = {.lex_state = 68},
  [2292] = {.lex_state = 0, .external_lex_state = 4},
  [2293] = {.lex_state = 0, .external_lex_state = 4},
  [2294] = {.lex_state = 68},
  [2295] = {.lex_state = 68},
  [2296] = {.lex_state = 68},
  [2297] = {.lex_state = 68},
  [2298] = {.lex_state = 68},
  [2299] = {.lex_state = 0, .external_lex_state = 4},
  [2300] = {.lex_state = 0, .external_lex_state = 4},
  [2301] = {.lex_state = 0, .external_lex_state = 4},
  [2302] = {.lex_state = 0},
  [2303] = {.lex_state = 68},
  [2304] = {.lex_state = 19},
  [2305] = {.lex_state = 19},
  [2306] = {.lex_state = 19},
  [2307] = {.lex_state = 68},
  [2308] = {.lex_state = 68},
  [2309] = {.lex_state = 68},
  [2310] = {.lex_state = 68},
  [2311] = {.lex_state = 68},
  [2312] = {.lex_state = 0, .external_lex_state = 4},
  [2313] = {.lex_state = 68},
  [2314] = {.lex_state = 68},
  [2315] = {.lex_state = 68},
  [2316] = {.lex_state = 0, .external_lex_state = 4},
  [2317] = {.lex_state = 68},
  [2318] = {.lex_state = 0, .external_lex_state = 4},
  [2319] = {.lex_state = 19, .external_lex_state = 6},
  [2320] = {.lex_state = 68},
  [2321] = {.lex_state = 68},
  [2322] = {.lex_state = 19},
  [2323] = {.lex_state = 19},
  [2324] = {.lex_state = 68},
  [2325] = {.lex_state = 0, .external_lex_state = 4},
  [2326] = {.lex_state = 68},
  [2327] = {.lex_state = 68},
  [2328] = {.lex_state = 68},
  [2329] = {.lex_state = 68},
  [2330] = {.lex_state = 19, .external_lex_state = 6},
  [2331] = {.lex_state = 68},
  [2332] = {.lex_state = 68},
  [2333] = {.lex_state = 68},
  [2334] = {.lex_state = 68},
  [2335] = {.lex_state = 68},
  [2336] = {.lex_state = 0, .external_lex_state = 4},
  [2337] = {.lex_state = 68},
  [2338] = {.lex_state = 68},
  [2339] = {.lex_state = 68},
  [2340] = {.lex_state = 68},
  [2341] = {.lex_state = 0, .external_lex_state = 4},
  [2342] = {.lex_state = 68},
  [2343] = {.lex_state = 68},
  [2344] = {.lex_state = 68},
  [2345] = {.lex_state = 0, .external_lex_state = 4},
  [2346] = {.lex_state = 68},
  [2347] = {.lex_state = 0, .external_lex_state = 4},
  [2348] = {.lex_state = 68},
  [2349] = {.lex_state = 0, .external_lex_state = 4},
  [2350] = {.lex_state = 19, .external_lex_state = 6},
  [2351] = {.lex_state = 68},
  [2352] = {.lex_state = 0, .external_lex_state = 4},
  [2353] = {.lex_state = 68},
  [2354] = {.lex_state = 68},
  [2355] = {.lex_state = 68},
  [2356] = {.lex_state = 68},
  [2357] = {.lex_state = 68},
  [2358] = {.lex_state = 68},
  [2359] = {.lex_state = 68},
  [2360] = {.lex_state = 68},
  [2361] = {.lex_state = 0, .external_lex_state = 4},
  [2362] = {.lex_state = 19},
  [2363] = {.lex_state = 19},
  [2364] = {.lex_state = 68},
  [2365] = {.lex_state = 0, .external_lex_state = 4},
  [2366] = {.lex_state = 0, .external_lex_state = 4},
  [2367] = {.lex_state = 68},
  [2368] = {.lex_state = 68},
  [2369] = {.lex_state = 19},
  [2370] = {.lex_state = 19, .external_lex_state = 6},
  [2371] = {.lex_state = 68},
  [2372] = {.lex_state = 68},
  [2373] = {.lex_state = 68},
  [2374] = {.lex_state = 0, .external_lex_state = 4},
  [2375] = {.lex_state = 0, .external_lex_state = 4},
  [2376] = {.lex_state = 0, .external_lex_state = 4},
  [2377] = {.lex_state = 0},
  [2378] = {.lex_state = 68},
  [2379] = {.lex_state = 0},
  [2380] = {.lex_state = 0, .external_lex_state = 4},
  [2381] = {.lex_state = 0, .external_lex_state = 4},
  [2382] = {.lex_state = 68},
  [2383] = {.lex_state = 68},
  [2384] = {.lex_state = 0, .external_lex_state = 4},
  [2385] = {.lex_state = 68},
  [2386] = {.lex_state = 68},
  [2387] = {.lex_state = 68, .external_lex_state = 4},
  [2388] = {.lex_state = 68},
  [2389] = {.lex_state = 0},
  [2390] = {.lex_state = 68},
  [2391] = {.lex_state = 68, .external_lex_state = 4},
  [2392] = {.lex_state = 68},
  [2393] = {.lex_state = 68, .external_lex_state = 5},
  [2394] = {.lex_state = 68},
  [2395] = {.lex_state = 0, .external_lex_state = 4},
  [2396] = {.lex_state = 68},
  [2397] = {.lex_state = 68},
  [2398] = {.lex_state = 68},
  [2399] = {.lex_state = 68, .external_lex_state = 5},
  [2400] = {.lex_state = 68},
  [2401] = {.lex_state = 68},
  [2402] = {.lex_state = 0, .external_lex_state = 4},
  [2403] = {.lex_state = 68},
  [2404] = {.lex_state = 68, .external_lex_state = 5},
  [2405] = {.lex_state = 68},
  [2406] = {.lex_state = 68},
  [2407] = {.lex_state = 68},
  [2408] = {.lex_state = 68},
  [2409] = {.lex_state = 0, .external_lex_state = 4},
  [2410] = {.lex_state = 68},
  [2411] = {.lex_state = 68},
  [2412] = {.lex_state = 0, .external_lex_state = 4},
  [2413] = {.lex_state = 0, .external_lex_state = 4},
  [2414] = {.lex_state = 68, .external_lex_state = 4},
  [2415] = {.lex_state = 68, .external_lex_state = 5},
  [2416] = {.lex_state = 68},
  [2417] = {.lex_state = 68},
  [2418] = {.lex_state = 68, .external_lex_state = 5},
  [2419] = {.lex_state = 68, .external_lex_state = 5},
  [2420] = {.lex_state = 68},
  [2421] = {.lex_state = 68, .external_lex_state = 5},
  [2422] = {.lex_state = 68},
  [2423] = {.lex_state = 68},
  [2424] = {.lex_state = 68, .external_lex_state = 5},
  [2425] = {.lex_state = 0, .external_lex_state = 4},
  [2426] = {.lex_state = 68},
  [2427] = {.lex_state = 0, .external_lex_state = 4},
  [2428] = {.lex_state = 0, .external_lex_state = 4},
  [2429] = {.lex_state = 68, .external_lex_state = 5},
  [2430] = {.lex_state = 0, .external_lex_state = 4},
  [2431] = {.lex_state = 0, .external_lex_state = 4},
  [2432] = {.lex_state = 68},
  [2433] = {.lex_state = 0, .external_lex_state = 4},
  [2434] = {.lex_state = 68},
  [2435] = {.lex_state = 68},
  [2436] = {.lex_state = 68},
  [2437] = {.lex_state = 0, .external_lex_state = 4},
  [2438] = {.lex_state = 68},
  [2439] = {.lex_state = 0, .external_lex_state = 4},
  [2440] = {.lex_state = 68},
  [2441] = {.lex_state = 0, .external_lex_state = 4},
  [2442] = {.lex_state = 0, .external_lex_state = 4},
  [2443] = {.lex_state = 0, .external_lex_state = 4},
  [2444] = {.lex_state = 68},
  [2445] = {.lex_state = 0, .external_lex_state = 4},
  [2446] = {.lex_state = 0, .external_lex_state = 4},
  [2447] = {.lex_state = 0, .external_lex_state = 4},
  [2448] = {.lex_state = 68, .external_lex_state = 4},
  [2449] = {.lex_state = 0, .external_lex_state = 4},
  [2450] = {.lex_state = 68},
  [2451] = {.lex_state = 0, .external_lex_state = 4},
  [2452] = {.lex_state = 68},
  [2453] = {.lex_state = 68, .external_lex_state = 4},
  [2454] = {.lex_state = 68, .external_lex_state = 4},
  [2455] = {.lex_state = 0, .external_lex_state = 4},
  [2456] = {.lex_state = 68},
  [2457] = {.lex_state = 0, .external_lex_state = 4},
  [2458] = {.lex_state = 0, .external_lex_state = 4},
  [2459] = {.lex_state = 0, .external_lex_state = 4},
  [2460] = {.lex_state = 68, .external_lex_state = 5},
  [2461] = {.lex_state = 68},
  [2462] = {.lex_state = 68},
  [2463] = {.lex_state = 14},
  [2464] = {.lex_state = 68, .external_lex_state = 4},
  [2465] = {.lex_state = 0, .external_lex_state = 4},
  [2466] = {.lex_state = 0, .external_lex_state = 4},
  [2467] = {.lex_state = 68},
  [2468] = {.lex_state = 14},
  [2469] = {.lex_state = 0, .external_lex_state = 4},
  [2470] = {.lex_state = 0, .external_lex_state = 4},
  [2471] = {.lex_state = 0, .external_lex_state = 4},
  [2472] = {.lex_state = 68},
  [2473] = {.lex_state = 68},
  [2474] = {.lex_state = 68},
  [2475] = {.lex_state = 68},
  [2476] = {.lex_state = 0, .external_lex_state = 4},
  [2477] = {.lex_state = 0, .external_lex_state = 4},
  [2478] = {.lex_state = 0, .external_lex_state = 4},
  [2479] = {.lex_state = 0, .external_lex_state = 4},
  [2480] = {.lex_state = 68},
  [2481] = {.lex_state = 0, .external_lex_state = 4},
  [2482] = {.lex_state = 0, .external_lex_state = 4},
  [2483] = {.lex_state = 0, .external_lex_state = 4},
  [2484] = {.lex_state = 0, .external_lex_state = 4},
  [2485] = {.lex_state = 0, .external_lex_state = 4},
  [2486] = {.lex_state = 68},
  [2487] = {.lex_state = 68},
  [2488] = {.lex_state = 0, .external_lex_state = 4},
  [2489] = {.lex_state = 68, .external_lex_state = 5},
  [2490] = {.lex_state = 0, .external_lex_state = 4},
  [2491] = {.lex_state = 68},
  [2492] = {.lex_state = 0, .external_lex_state = 4},
  [2493] = {.lex_state = 0, .external_lex_state = 4},
  [2494] = {.lex_state = 0, .external_lex_state = 4},
  [2495] = {.lex_state = 68, .external_lex_state = 5},
  [2496] = {.lex_state = 68},
  [2497] = {.lex_state = 68, .external_lex_state = 4},
  [2498] = {.lex_state = 68},
  [2499] = {.lex_state = 68},
  [2500] = {.lex_state = 68, .external_lex_state = 4},
  [2501] = {.lex_state = 68, .external_lex_state = 4},
  [2502] = {.lex_state = 68},
  [2503] = {.lex_state = 68},
  [2504] = {.lex_state = 68},
  [2505] = {.lex_state = 68},
  [2506] = {.lex_state = 68},
  [2507] = {.lex_state = 68, .external_lex_state = 4},
  [2508] = {.lex_state = 68},
  [2509] = {.lex_state = 0, .external_lex_state = 4},
  [2510] = {.lex_state = 0, .external_lex_state = 4},
  [2511] = {.lex_state = 0, .external_lex_state = 4},
  [2512] = {.lex_state = 0, .external_lex_state = 4},
  [2513] = {.lex_state = 0, .external_lex_state = 4},
  [2514] = {.lex_state = 68},
  [2515] = {.lex_state = 0, .external_lex_state = 4},
  [2516] = {.lex_state = 68, .external_lex_state = 4},
  [2517] = {.lex_state = 68},
  [2518] = {.lex_state = 68},
  [2519] = {.lex_state = 0, .external_lex_state = 4},
  [2520] = {.lex_state = 68},
  [2521] = {.lex_state = 68},
  [2522] = {.lex_state = 68},
  [2523] = {.lex_state = 0},
  [2524] = {.lex_state = 68},
  [2525] = {.lex_state = 0, .external_lex_state = 4},
  [2526] = {.lex_state = 0, .external_lex_state = 4},
  [2527] = {.lex_state = 0, .external_lex_state = 4},
  [2528] = {.lex_state = 0, .external_lex_state = 4},
  [2529] = {.lex_state = 0, .external_lex_state = 4},
  [2530] = {.lex_state = 0, .external_lex_state = 4},
  [2531] = {.lex_state = 68, .external_lex_state = 5},
  [2532] = {.lex_state = 68},
  [2533] = {.lex_state = 68},
  [2534] = {.lex_state = 68},
  [2535] = {.lex_state = 0, .external_lex_state = 4},
  [2536] = {.lex_state = 68},
  [2537] = {.lex_state = 0, .external_lex_state = 4},
  [2538] = {.lex_state = 0, .external_lex_state = 4},
  [2539] = {.lex_state = 0, .external_lex_state = 4},
  [2540] = {.lex_state = 68},
  [2541] = {.lex_state = 0},
  [2542] = {.lex_state = 68},
  [2543] = {.lex_state = 68, .external_lex_state = 5},
  [2544] = {.lex_state = 68},
  [2545] = {.lex_state = 0, .external_lex_state = 4},
  [2546] = {.lex_state = 68, .external_lex_state = 5},
  [2547] = {.lex_state = 0, .external_lex_state = 4},
  [2548] = {.lex_state = 0, .external_lex_state = 4},
  [2549] = {.lex_state = 68},
  [2550] = {.lex_state = 0, .external_lex_state = 4},
  [2551] = {.lex_state = 68},
  [2552] = {.lex_state = 0, .external_lex_state = 4},
  [2553] = {.lex_state = 68, .external_lex_state = 5},
  [2554] = {.lex_state = 0, .external_lex_state = 4},
  [2555] = {.lex_state = 0, .external_lex_state = 4},
  [2556] = {.lex_state = 0, .external_lex_state = 4},
  [2557] = {.lex_state = 68, .external_lex_state = 4},
  [2558] = {.lex_state = 68},
  [2559] = {.lex_state = 0, .external_lex_state = 4},
  [2560] = {.lex_state = 0, .external_lex_state = 4},
  [2561] = {.lex_state = 68},
  [2562] = {.lex_state = 14},
  [2563] = {.lex_state = 0, .external_lex_state = 4},
  [2564] = {.lex_state = 14},
  [2565] = {.lex_state = 68},
  [2566] = {.lex_state = 0, .external_lex_state = 4},
  [2567] = {.lex_state = 68},
  [2568] = {.lex_state = 0},
  [2569] = {.lex_state = 0},
  [2570] = {.lex_state = 0, .external_lex_state = 4},
  [2571] = {.lex_state = 0},
  [2572] = {.lex_state = 0, .external_lex_state = 4},
  [2573] = {.lex_state = 0, .external_lex_state = 4},
  [2574] = {.lex_state = 68},
  [2575] = {.lex_state = 68},
  [2576] = {.lex_state = 0, .external_lex_state = 4},
  [2577] = {.lex_state = 0, .external_lex_state = 4},
  [2578] = {.lex_state = 0, .external_lex_state = 4},
  [2579] = {.lex_state = 68},
  [2580] = {.lex_state = 68},
  [2581] = {.lex_state = 0, .external_lex_state = 4},
  [2582] = {.lex_state = 0, .external_lex_state = 4},
  [2583] = {.lex_state = 68},
  [2584] = {.lex_state = 0, .external_lex_state = 4},
  [2585] = {.lex_state = 68},
  [2586] = {.lex_state = 0, .external_lex_state = 4},
  [2587] = {.lex_state = 0, .external_lex_state = 4},
  [2588] = {.lex_state = 68, .external_lex_state = 5},
  [2589] = {.lex_state = 0, .external_lex_state = 4},
  [2590] = {.lex_state = 0, .external_lex_state = 4},
  [2591] = {.lex_state = 0, .external_lex_state = 4},
  [2592] = {.lex_state = 0, .external_lex_state = 4},
  [2593] = {.lex_state = 0, .external_lex_state = 4},
  [2594] = {.lex_state = 0, .external_lex_state = 4},
  [2595] = {.lex_state = 0, .external_lex_state = 4},
  [2596] = {.lex_state = 0, .external_lex_state = 4},
  [2597] = {.lex_state = 0, .external_lex_state = 4},
  [2598] = {.lex_state = 68},
  [2599] = {.lex_state = 68},
  [2600] = {.lex_state = 0, .external_lex_state = 4},
  [2601] = {.lex_state = 68, .external_lex_state = 4},
  [2602] = {.lex_state = 0, .external_lex_state = 4},
  [2603] = {.lex_state = 68, .external_lex_state = 4},
  [2604] = {.lex_state = 0, .external_lex_state = 4},
  [2605] = {.lex_state = 0, .external_lex_state = 4},
  [2606] = {.lex_state = 0, .external_lex_state = 4},
  [2607] = {.lex_state = 0, .external_lex_state = 4},
  [2608] = {.lex_state = 0},
  [2609] = {.lex_state = 0},
  [2610] = {.lex_state = 68, .external_lex_state = 4},
  [2611] = {.lex_state = 68},
  [2612] = {.lex_state = 68},
  [2613] = {.lex_state = 68},
  [2614] = {.lex_state = 68},
  [2615] = {.lex_state = 68, .external_lex_state = 5},
  [2616] = {.lex_state = 0, .external_lex_state = 4},
  [2617] = {.lex_state = 0, .external_lex_state = 4},
  [2618] = {.lex_state = 0, .external_lex_state = 4},
  [2619] = {.lex_state = 0, .external_lex_state = 4},
  [2620] = {.lex_state = 0, .external_lex_state = 4},
  [2621] = {.lex_state = 1},
  [2622] = {.lex_state = 0},
  [2623] = {.lex_state = 0},
  [2624] = {.lex_state = 68},
  [2625] = {.lex_state = 68},
  [2626] = {.lex_state = 68},
  [2627] = {.lex_state = 68},
  [2628] = {.lex_state = 68},
  [2629] = {.lex_state = 68},
  [2630] = {.lex_state = 0},
  [2631] = {.lex_state = 3},
  [2632] = {.lex_state = 1},
  [2633] = {.lex_state = 68},
  [2634] = {.lex_state = 1},
  [2635] = {.lex_state = 3},
  [2636] = {.lex_state = 68},
  [2637] = {.lex_state = 0},
  [2638] = {.lex_state = 68},
  [2639] = {.lex_state = 3},
  [2640] = {.lex_state = 1},
  [2641] = {.lex_state = 3},
  [2642] = {.lex_state = 68},
  [2643] = {.lex_state = 0},
  [2644] = {.lex_state = 68},
  [2645] = {.lex_state = 68},
  [2646] = {.lex_state = 68},
  [2647] = {.lex_state = 3},
  [2648] = {.lex_state = 0, .external_lex_state = 4},
  [2649] = {.lex_state = 68},
  [2650] = {.lex_state = 1},
  [2651] = {.lex_state = 68},
  [2652] = {.lex_state = 68},
  [2653] = {.lex_state = 3},
  [2654] = {.lex_state = 1},
  [2655] = {.lex_state = 68},
  [2656] = {.lex_state = 68},
  [2657] = {.lex_state = 68},
  [2658] = {.lex_state = 68},
  [2659] = {.lex_state = 68},
  [2660] = {.lex_state = 68},
  [2661] = {.lex_state = 0},
  [2662] = {.lex_state = 68},
  [2663] = {.lex_state = 3},
  [2664] = {.lex_state = 1},
  [2665] = {.lex_state = 68},
  [2666] = {.lex_state = 68},
  [2667] = {.lex_state = 68},
  [2668] = {.lex_state = 68},
  [2669] = {.lex_state = 68},
  [2670] = {.lex_state = 0},
  [2671] = {.lex_state = 68},
  [2672] = {.lex_state = 68},
  [2673] = {.lex_state = 0},
  [2674] = {.lex_state = 68},
  [2675] = {.lex_state = 68},
  [2676] = {.lex_state = 0},
  [2677] = {.lex_state = 0},
  [2678] = {.lex_state = 68},
  [2679] = {.lex_state = 0, .external_lex_state = 4},
  [2680] = {.lex_state = 68},
  [2681] = {.lex_state = 0, .external_lex_state = 4},
  [2682] = {.lex_state = 68, .external_lex_state = 4},
  [2683] = {.lex_state = 68},
  [2684] = {.lex_state = 68},
  [2685] = {.lex_state = 68},
  [2686] = {.lex_state = 0},
  [2687] = {.lex_state = 3},
  [2688] = {.lex_state = 3},
  [2689] = {.lex_state = 68},
  [2690] = {.lex_state = 1},
  [2691] = {.lex_state = 68},
  [2692] = {.lex_state = 68},
  [2693] = {.lex_state = 0},
  [2694] = {.lex_state = 1},
  [2695] = {.lex_state = 0, .external_lex_state = 4},
  [2696] = {.lex_state = 0, .external_lex_state = 4},
  [2697] = {.lex_state = 68},
  [2698] = {.lex_state = 68},
  [2699] = {.lex_state = 68},
  [2700] = {.lex_state = 68},
  [2701] = {.lex_state = 3},
  [2702] = {.lex_state = 1},
  [2703] = {.lex_state = 3},
  [2704] = {.lex_state = 68},
  [2705] = {.lex_state = 68},
  [2706] = {.lex_state = 68},
  [2707] = {.lex_state = 68},
  [2708] = {.lex_state = 68, .external_lex_state = 5},
  [2709] = {.lex_state = 68, .external_lex_state = 5},
  [2710] = {.lex_state = 68},
  [2711] = {.lex_state = 68, .external_lex_state = 5},
  [2712] = {.lex_state = 68},
  [2713] = {.lex_state = 68},
  [2714] = {.lex_state = 3},
  [2715] = {.lex_state = 68},
  [2716] = {.lex_state = 68},
  [2717] = {.lex_state = 68},
  [2718] = {.lex_state = 68},
  [2719] = {.lex_state = 68},
  [2720] = {.lex_state = 68},
  [2721] = {.lex_state = 1},
  [2722] = {.lex_state = 68},
  [2723] = {.lex_state = 68},
  [2724] = {.lex_state = 3},
  [2725] = {.lex_state = 1},
  [2726] = {.lex_state = 68},
  [2727] = {.lex_state = 0},
  [2728] = {.lex_state = 68, .external_lex_state = 4},
  [2729] = {.lex_state = 0, .external_lex_state = 4},
  [2730] = {.lex_state = 68},
  [2731] = {.lex_state = 68},
  [2732] = {.lex_state = 0, .external_lex_state = 4},
  [2733] = {.lex_state = 68},
  [2734] = {.lex_state = 0},
  [2735] = {.lex_state = 68},
  [2736] = {.lex_state = 1},
  [2737] = {.lex_state = 68},
  [2738] = {.lex_state = 3},
  [2739] = {.lex_state = 1},
  [2740] = {.lex_state = 68},
  [2741] = {.lex_state = 19, .external_lex_state = 6},
  [2742] = {.lex_state = 0, .external_lex_state = 4},
  [2743] = {.lex_state = 68},
  [2744] = {.lex_state = 0, .external_lex_state = 4},
  [2745] = {.lex_state = 68},
  [2746] = {.lex_state = 0},
  [2747] = {.lex_state = 68},
  [2748] = {.lex_state = 3},
  [2749] = {.lex_state = 68},
  [2750] = {.lex_state = 1},
  [2751] = {.lex_state = 0},
  [2752] = {.lex_state = 0, .external_lex_state = 4},
  [2753] = {.lex_state = 68},
  [2754] = {.lex_state = 0, .external_lex_state = 4},
  [2755] = {.lex_state = 0},
  [2756] = {.lex_state = 68},
  [2757] = {.lex_state = 68},
  [2758] = {.lex_state = 0},
  [2759] = {.lex_state = 0},
  [2760] = {.lex_state = 68},
  [2761] = {.lex_state = 68},
  [2762] = {.lex_state = 0, .external_lex_state = 4},
  [2763] = {.lex_state = 0, .external_lex_state = 4},
  [2764] = {.lex_state = 0},
  [2765] = {.lex_state = 0},
  [2766] = {.lex_state = 68},
  [2767] = {.lex_state = 0},
  [2768] = {.lex_state = 0},
  [2769] = {.lex_state = 0},
  [2770] = {.lex_state = 68},
  [2771] = {.lex_state = 68},
  [2772] = {.lex_state = 0},
  [2773] = {.lex_state = 68},
  [2774] = {.lex_state = 0},
  [2775] = {.lex_state = 68},
  [2776] = {.lex_state = 68},
  [2777] = {.lex_state = 0},
  [2778] = {.lex_state = 0},
  [2779] = {.lex_state = 68},
  [2780] = {.lex_state = 0},
  [2781] = {.lex_state = 0},
  [2782] = {.lex_state = 0},
  [2783] = {.lex_state = 0},
  [2784] = {.lex_state = 68},
  [2785] = {.lex_state = 0, .external_lex_state = 4},
  [2786] = {.lex_state = 68},
  [2787] = {.lex_state = 0},
  [2788] = {.lex_state = 0},
  [2789] = {.lex_state = 0},
  [2790] = {.lex_state = 0},
  [2791] = {.lex_state = 0},
  [2792] = {.lex_state = 68},
  [2793] = {.lex_state = 0, .external_lex_state = 4},
  [2794] = {.lex_state = 68},
  [2795] = {.lex_state = 68},
  [2796] = {.lex_state = 0},
  [2797] = {.lex_state = 0},
  [2798] = {.lex_state = 0, .external_lex_state = 4},
  [2799] = {.lex_state = 68},
  [2800] = {.lex_state = 0},
  [2801] = {.lex_state = 68, .external_lex_state = 4},
  [2802] = {.lex_state = 0},
  [2803] = {.lex_state = 0, .external_lex_state = 4},
  [2804] = {.lex_state = 0},
  [2805] = {.lex_state = 68, .external_lex_state = 4},
  [2806] = {.lex_state = 0},
  [2807] = {.lex_state = 0},
  [2808] = {.lex_state = 0},
  [2809] = {.lex_state = 0},
  [2810] = {.lex_state = 0},
  [2811] = {.lex_state = 0, .external_lex_state = 4},
  [2812] = {.lex_state = 68},
  [2813] = {.lex_state = 68},
  [2814] = {.lex_state = 0},
  [2815] = {.lex_state = 0},
  [2816] = {.lex_state = 0},
  [2817] = {.lex_state = 0},
  [2818] = {.lex_state = 68},
  [2819] = {.lex_state = 68},
  [2820] = {.lex_state = 68},
  [2821] = {.lex_state = 14},
  [2822] = {.lex_state = 68, .external_lex_state = 4},
  [2823] = {.lex_state = 68},
  [2824] = {.lex_state = 0},
  [2825] = {.lex_state = 0},
  [2826] = {.lex_state = 68},
  [2827] = {.lex_state = 68},
  [2828] = {.lex_state = 0},
  [2829] = {.lex_state = 0},
  [2830] = {.lex_state = 14},
  [2831] = {.lex_state = 0},
  [2832] = {.lex_state = 0},
  [2833] = {.lex_state = 0, .external_lex_state = 4},
  [2834] = {.lex_state = 14},
  [2835] = {.lex_state = 0},
  [2836] = {.lex_state = 68, .external_lex_state = 4},
  [2837] = {.lex_state = 0},
  [2838] = {.lex_state = 0},
  [2839] = {.lex_state = 0},
  [2840] = {.lex_state = 0},
  [2841] = {.lex_state = 0},
  [2842] = {.lex_state = 0},
  [2843] = {.lex_state = 0},
  [2844] = {.lex_state = 0},
  [2845] = {.lex_state = 0},
  [2846] = {.lex_state = 0},
  [2847] = {.lex_state = 0, .external_lex_state = 4},
  [2848] = {.lex_state = 0},
  [2849] = {.lex_state = 0, .external_lex_state = 4},
  [2850] = {.lex_state = 0},
  [2851] = {.lex_state = 0},
  [2852] = {.lex_state = 0},
  [2853] = {.lex_state = 0},
  [2854] = {.lex_state = 0},
  [2855] = {.lex_state = 68},
  [2856] = {.lex_state = 0},
  [2857] = {.lex_state = 0},
  [2858] = {.lex_state = 0, .external_lex_state = 4},
  [2859] = {.lex_state = 0},
  [2860] = {.lex_state = 0},
  [2861] = {.lex_state = 0, .external_lex_state = 4},
  [2862] = {.lex_state = 0},
  [2863] = {.lex_state = 0},
  [2864] = {.lex_state = 0},
  [2865] = {.lex_state = 0, .external_lex_state = 4},
  [2866] = {.lex_state = 0, .external_lex_state = 4},
  [2867] = {.lex_state = 0, .external_lex_state = 4},
  [2868] = {.lex_state = 0},
  [2869] = {.lex_state = 0},
  [2870] = {.lex_state = 0},
  [2871] = {.lex_state = 0},
  [2872] = {.lex_state = 0},
  [2873] = {.lex_state = 0},
  [2874] = {.lex_state = 0},
  [2875] = {.lex_state = 68},
  [2876] = {.lex_state = 68},
  [2877] = {.lex_state = 0},
  [2878] = {.lex_state = 68, .external_lex_state = 4},
  [2879] = {.lex_state = 68},
  [2880] = {.lex_state = 0},
  [2881] = {.lex_state = 68},
  [2882] = {.lex_state = 68},
  [2883] = {.lex_state = 68},
  [2884] = {.lex_state = 0, .external_lex_state = 4},
  [2885] = {.lex_state = 0, .external_lex_state = 4},
  [2886] = {.lex_state = 0},
  [2887] = {.lex_state = 0},
  [2888] = {.lex_state = 0},
  [2889] = {.lex_state = 0, .external_lex_state = 4},
  [2890] = {.lex_state = 0, .external_lex_state = 4},
  [2891] = {.lex_state = 0},
  [2892] = {.lex_state = 68},
  [2893] = {.lex_state = 0, .external_lex_state = 4},
  [2894] = {.lex_state = 0},
  [2895] = {.lex_state = 0, .external_lex_state = 4},
  [2896] = {.lex_state = 0, .external_lex_state = 4},
  [2897] = {.lex_state = 0},
  [2898] = {.lex_state = 0},
  [2899] = {.lex_state = 0},
  [2900] = {.lex_state = 68},
  [2901] = {.lex_state = 0},
  [2902] = {.lex_state = 68},
  [2903] = {.lex_state = 68, .external_lex_state = 4},
  [2904] = {.lex_state = 0},
  [2905] = {.lex_state = 68},
  [2906] = {.lex_state = 68},
  [2907] = {.lex_state = 68},
  [2908] = {.lex_state = 0},
  [2909] = {.lex_state = 0},
  [2910] = {.lex_state = 68},
  [2911] = {.lex_state = 68},
  [2912] = {.lex_state = 0},
  [2913] = {.lex_state = 0},
  [2914] = {.lex_state = 0, .external_lex_state = 4},
  [2915] = {.lex_state = 0, .external_lex_state = 4},
  [2916] = {.lex_state = 0},
  [2917] = {.lex_state = 0},
  [2918] = {.lex_state = 0},
  [2919] = {.lex_state = 0, .external_lex_state = 4},
  [2920] = {.lex_state = 0},
  [2921] = {.lex_state = 0},
  [2922] = {.lex_state = 68},
  [2923] = {.lex_state = 0, .external_lex_state = 4},
  [2924] = {.lex_state = 0, .external_lex_state = 4},
  [2925] = {.lex_state = 68},
  [2926] = {.lex_state = 0},
  [2927] = {.lex_state = 68},
  [2928] = {.lex_state = 0, .external_lex_state = 4},
  [2929] = {.lex_state = 0},
  [2930] = {.lex_state = 0, .external_lex_state = 4},
  [2931] = {.lex_state = 0},
  [2932] = {.lex_state = 0},
  [2933] = {.lex_state = 0},
  [2934] = {.lex_state = 0, .external_lex_state = 4},
  [2935] = {.lex_state = 0, .external_lex_state = 4},
  [2936] = {.lex_state = 0},
  [2937] = {.lex_state = 0},
  [2938] = {.lex_state = 0},
  [2939] = {.lex_state = 0, .external_lex_state = 4},
  [2940] = {.lex_state = 0, .external_lex_state = 4},
  [2941] = {.lex_state = 68},
  [2942] = {.lex_state = 0, .external_lex_state = 4},
  [2943] = {.lex_state = 0, .external_lex_state = 4},
  [2944] = {.lex_state = 0, .external_lex_state = 4},
  [2945] = {.lex_state = 0},
  [2946] = {.lex_state = 0},
  [2947] = {.lex_state = 68},
  [2948] = {.lex_state = 0},
  [2949] = {.lex_state = 68},
  [2950] = {.lex_state = 0},
  [2951] = {.lex_state = 68},
  [2952] = {.lex_state = 68},
  [2953] = {.lex_state = 68},
  [2954] = {.lex_state = 0},
  [2955] = {.lex_state = 68},
  [2956] = {.lex_state = 0},
  [2957] = {.lex_state = 0, .external_lex_state = 4},
  [2958] = {.lex_state = 68},
  [2959] = {.lex_state = 68},
  [2960] = {.lex_state = 68},
  [2961] = {.lex_state = 68},
  [2962] = {.lex_state = 0},
  [2963] = {.lex_state = 68},
  [2964] = {.lex_state = 0, .external_lex_state = 4},
  [2965] = {.lex_state = 68},
  [2966] = {.lex_state = 68},
  [2967] = {.lex_state = 68},
  [2968] = {.lex_state = 68},
  [2969] = {.lex_state = 68},
  [2970] = {.lex_state = 68},
  [2971] = {.lex_state = 0},
  [2972] = {.lex_state = 68},
  [2973] = {.lex_state = 68},
  [2974] = {.lex_state = 68},
  [2975] = {.lex_state = 0},
  [2976] = {.lex_state = 68},
  [2977] = {.lex_state = 68},
  [2978] = {.lex_state = 0},
  [2979] = {.lex_state = 0, .external_lex_state = 4},
  [2980] = {.lex_state = 68},
  [2981] = {.lex_state = 0},
  [2982] = {.lex_state = 0},
  [2983] = {.lex_state = 0},
  [2984] = {.lex_state = 0},
  [2985] = {.lex_state = 0},
  [2986] = {.lex_state = 0},
  [2987] = {.lex_state = 0},
  [2988] = {.lex_state = 0},
  [2989] = {.lex_state = 68},
  [2990] = {.lex_state = 0, .external_lex_state = 4},
  [2991] = {.lex_state = 68},
  [2992] = {.lex_state = 0},
  [2993] = {.lex_state = 68},
  [2994] = {.lex_state = 68},
  [2995] = {.lex_state = 0},
  [2996] = {.lex_state = 0},
  [2997] = {.lex_state = 0},
  [2998] = {.lex_state = 68},
  [2999] = {.lex_state = 68},
  [3000] = {.lex_state = 68},
  [3001] = {.lex_state = 68},
  [3002] = {.lex_state = 68},
  [3003] = {.lex_state = 0, .external_lex_state = 4},
  [3004] = {.lex_state = 0},
  [3005] = {.lex_state = 68},
  [3006] = {.lex_state = 0, .external_lex_state = 4},
  [3007] = {.lex_state = 68},
  [3008] = {.lex_state = 68},
  [3009] = {.lex_state = 68},
  [3010] = {.lex_state = 0},
  [3011] = {.lex_state = 0},
  [3012] = {.lex_state = 0},
  [3013] = {.lex_state = 0},
  [3014] = {.lex_state = 68},
  [3015] = {.lex_state = 68},
  [3016] = {.lex_state = 68},
  [3017] = {.lex_state = 68},
  [3018] = {.lex_state = 68},
  [3019] = {.lex_state = 68},
  [3020] = {.lex_state = 0},
  [3021] = {.lex_state = 0},
  [3022] = {.lex_state = 68},
  [3023] = {.lex_state = 0},
  [3024] = {.lex_state = 0},
  [3025] = {.lex_state = 68},
  [3026] = {.lex_state = 68},
  [3027] = {.lex_state = 68},
  [3028] = {.lex_state = 68},
  [3029] = {.lex_state = 0, .external_lex_state = 4},
  [3030] = {.lex_state = 68},
  [3031] = {.lex_state = 0},
  [3032] = {.lex_state = 0},
  [3033] = {.lex_state = 68},
  [3034] = {.lex_state = 68},
  [3035] = {.lex_state = 68},
  [3036] = {.lex_state = 68},
  [3037] = {.lex_state = 68},
  [3038] = {.lex_state = 0},
  [3039] = {.lex_state = 68},
  [3040] = {.lex_state = 68},
  [3041] = {.lex_state = 68},
  [3042] = {.lex_state = 0, .external_lex_state = 4},
  [3043] = {.lex_state = 68},
  [3044] = {.lex_state = 68},
  [3045] = {.lex_state = 0},
  [3046] = {.lex_state = 68},
  [3047] = {.lex_state = 68},
  [3048] = {.lex_state = 0},
  [3049] = {.lex_state = 68},
  [3050] = {.lex_state = 68},
  [3051] = {.lex_state = 68},
  [3052] = {.lex_state = 68},
  [3053] = {.lex_state = 68},
  [3054] = {.lex_state = 0},
  [3055] = {.lex_state = 0},
  [3056] = {.lex_state = 68},
  [3057] = {.lex_state = 68},
  [3058] = {.lex_state = 0},
  [3059] = {.lex_state = 68},
  [3060] = {.lex_state = 0},
  [3061] = {.lex_state = 68},
  [3062] = {.lex_state = 68},
  [3063] = {.lex_state = 68},
  [3064] = {.lex_state = 0},
  [3065] = {.lex_state = 0},
  [3066] = {.lex_state = 0},
  [3067] = {.lex_state = 68},
  [3068] = {.lex_state = 68},
  [3069] = {.lex_state = 68},
  [3070] = {.lex_state = 0, .external_lex_state = 4},
  [3071] = {.lex_state = 0},
  [3072] = {.lex_state = 68},
  [3073] = {.lex_state = 0},
  [3074] = {.lex_state = 68},
  [3075] = {.lex_state = 68},
  [3076] = {.lex_state = 68},
  [3077] = {.lex_state = 68},
  [3078] = {.lex_state = 0},
  [3079] = {.lex_state = 68},
  [3080] = {.lex_state = 68},
  [3081] = {.lex_state = 68},
  [3082] = {.lex_state = 68},
  [3083] = {.lex_state = 68},
  [3084] = {.lex_state = 68},
  [3085] = {.lex_state = 68},
  [3086] = {.lex_state = 68},
  [3087] = {.lex_state = 0},
  [3088] = {.lex_state = 68},
  [3089] = {.lex_state = 0},
  [3090] = {.lex_state = 68},
  [3091] = {.lex_state = 68},
  [3092] = {.lex_state = 68},
  [3093] = {.lex_state = 0},
  [3094] = {.lex_state = 68},
  [3095] = {.lex_state = 68},
  [3096] = {.lex_state = 0},
  [3097] = {.lex_state = 0, .external_lex_state = 4},
  [3098] = {.lex_state = 68},
  [3099] = {.lex_state = 68},
  [3100] = {.lex_state = 68},
  [3101] = {.lex_state = 68},
  [3102] = {.lex_state = 68},
  [3103] = {.lex_state = 68},
  [3104] = {.lex_state = 0},
  [3105] = {.lex_state = 68},
  [3106] = {.lex_state = 68},
  [3107] = {.lex_state = 0},
  [3108] = {.lex_state = 0},
  [3109] = {.lex_state = 68},
  [3110] = {.lex_state = 68},
  [3111] = {.lex_state = 68},
  [3112] = {.lex_state = 0},
  [3113] = {.lex_state = 0},
  [3114] = {.lex_state = 68},
  [3115] = {.lex_state = 0},
  [3116] = {.lex_state = 68},
  [3117] = {.lex_state = 68},
  [3118] = {.lex_state = 0, .external_lex_state = 4},
  [3119] = {.lex_state = 68},
  [3120] = {.lex_state = 68},
  [3121] = {.lex_state = 0, .external_lex_state = 4},
  [3122] = {.lex_state = 0},
  [3123] = {.lex_state = 68},
  [3124] = {.lex_state = 68},
  [3125] = {.lex_state = 0, .external_lex_state = 4},
  [3126] = {.lex_state = 68},
  [3127] = {.lex_state = 68},
  [3128] = {.lex_state = 0, .external_lex_state = 4},
  [3129] = {.lex_state = 68},
  [3130] = {.lex_state = 68},
  [3131] = {.lex_state = 0},
  [3132] = {.lex_state = 68},
  [3133] = {.lex_state = 68},
  [3134] = {.lex_state = 0},
  [3135] = {.lex_state = 68},
  [3136] = {.lex_state = 0},
  [3137] = {.lex_state = 68},
  [3138] = {.lex_state = 0},
  [3139] = {.lex_state = 68},
  [3140] = {.lex_state = 68},
  [3141] = {.lex_state = 68},
  [3142] = {.lex_state = 0},
  [3143] = {.lex_state = 68},
  [3144] = {.lex_state = 68},
  [3145] = {.lex_state = 0},
  [3146] = {.lex_state = 68},
  [3147] = {.lex_state = 68},
  [3148] = {.lex_state = 0},
  [3149] = {.lex_state = 68},
  [3150] = {.lex_state = 68},
  [3151] = {.lex_state = 68},
  [3152] = {.lex_state = 68},
  [3153] = {.lex_state = 68},
  [3154] = {.lex_state = 68},
  [3155] = {.lex_state = 68},
  [3156] = {.lex_state = 68},
  [3157] = {.lex_state = 0},
  [3158] = {.lex_state = 68},
  [3159] = {.lex_state = 68},
  [3160] = {.lex_state = 5},
  [3161] = {.lex_state = 0},
  [3162] = {.lex_state = 0},
  [3163] = {.lex_state = 0},
  [3164] = {.lex_state = 0},
  [3165] = {.lex_state = 0},
  [3166] = {.lex_state = 0},
  [3167] = {.lex_state = 0},
  [3168] = {.lex_state = 0},
  [3169] = {.lex_state = 0},
  [3170] = {.lex_state = 0},
  [3171] = {.lex_state = 68},
  [3172] = {.lex_state = 0},
  [3173] = {.lex_state = 68},
  [3174] = {.lex_state = 0},
  [3175] = {.lex_state = 68},
  [3176] = {.lex_state = 68},
  [3177] = {.lex_state = 0},
  [3178] = {.lex_state = 68},
  [3179] = {.lex_state = 0},
  [3180] = {.lex_state = 0},
  [3181] = {.lex_state = 68},
  [3182] = {.lex_state = 0},
  [3183] = {.lex_state = 0},
  [3184] = {.lex_state = 0},
  [3185] = {.lex_state = 68},
  [3186] = {.lex_state = 0},
  [3187] = {.lex_state = 0},
  [3188] = {.lex_state = 68},
  [3189] = {.lex_state = 0},
  [3190] = {.lex_state = 0},
  [3191] = {.lex_state = 0},
  [3192] = {.lex_state = 5},
  [3193] = {.lex_state = 0},
  [3194] = {.lex_state = 0},
  [3195] = {.lex_state = 0},
  [3196] = {.lex_state = 68},
  [3197] = {.lex_state = 0},
  [3198] = {.lex_state = 68},
  [3199] = {.lex_state = 0},
  [3200] = {.lex_state = 68},
  [3201] = {.lex_state = 0},
  [3202] = {.lex_state = 0},
  [3203] = {.lex_state = 68},
  [3204] = {.lex_state = 0},
  [3205] = {.lex_state = 68},
  [3206] = {.lex_state = 68},
  [3207] = {.lex_state = 68},
  [3208] = {.lex_state = 68},
  [3209] = {.lex_state = 68},
  [3210] = {.lex_state = 0},
  [3211] = {.lex_state = 68},
  [3212] = {.lex_state = 0},
  [3213] = {.lex_state = 68},
  [3214] = {.lex_state = 0},
  [3215] = {.lex_state = 68},
  [3216] = {.lex_state = 68},
  [3217] = {.lex_state = 0},
  [3218] = {.lex_state = 0},
  [3219] = {.lex_state = 0},
  [3220] = {.lex_state = 68},
  [3221] = {.lex_state = 68},
  [3222] = {.lex_state = 0},
  [3223] = {.lex_state = 68},
  [3224] = {.lex_state = 5},
  [3225] = {.lex_state = 0},
  [3226] = {.lex_state = 68},
  [3227] = {.lex_state = 0},
  [3228] = {.lex_state = 68},
  [3229] = {.lex_state = 68},
  [3230] = {.lex_state = 68},
  [3231] = {.lex_state = 68},
  [3232] = {.lex_state = 68},
  [3233] = {.lex_state = 68},
  [3234] = {.lex_state = 0},
  [3235] = {.lex_state = 0},
  [3236] = {.lex_state = 0},
  [3237] = {.lex_state = 68},
  [3238] = {.lex_state = 68},
  [3239] = {.lex_state = 68},
  [3240] = {.lex_state = 68},
  [3241] = {.lex_state = 68},
  [3242] = {.lex_state = 68},
  [3243] = {.lex_state = 68},
  [3244] = {.lex_state = 68},
  [3245] = {.lex_state = 0},
  [3246] = {.lex_state = 68},
  [3247] = {.lex_state = 0},
  [3248] = {.lex_state = 0},
  [3249] = {.lex_state = 68},
  [3250] = {.lex_state = 68},
  [3251] = {.lex_state = 68},
  [3252] = {.lex_state = 68},
  [3253] = {.lex_state = 0},
  [3254] = {.lex_state = 0},
  [3255] = {.lex_state = 68},
  [3256] = {.lex_state = 0},
  [3257] = {.lex_state = 68},
  [3258] = {.lex_state = 68},
  [3259] = {.lex_state = 68},
  [3260] = {.lex_state = 68},
  [3261] = {.lex_state = 68},
  [3262] = {.lex_state = 68},
  [3263] = {.lex_state = 68},
  [3264] = {.lex_state = 0},
  [3265] = {.lex_state = 68},
  [3266] = {.lex_state = 0},
  [3267] = {.lex_state = 0},
  [3268] = {.lex_state = 0},
  [3269] = {.lex_state = 0},
  [3270] = {.lex_state = 0},
  [3271] = {.lex_state = 68},
  [3272] = {.lex_state = 0},
  [3273] = {.lex_state = 15},
  [3274] = {.lex_state = 68},
  [3275] = {.lex_state = 68},
  [3276] = {.lex_state = 68},
  [3277] = {.lex_state = 0},
  [3278] = {.lex_state = 68},
  [3279] = {.lex_state = 0},
  [3280] = {.lex_state = 68},
  [3281] = {.lex_state = 68},
  [3282] = {.lex_state = 0},
  [3283] = {.lex_state = 68},
  [3284] = {.lex_state = 0},
  [3285] = {.lex_state = 0},
  [3286] = {.lex_state = 0},
  [3287] = {.lex_state = 0},
  [3288] = {.lex_state = 0},
  [3289] = {.lex_state = 68},
  [3290] = {.lex_state = 68},
  [3291] = {.lex_state = 0},
  [3292] = {.lex_state = 15},
  [3293] = {.lex_state = 0},
  [3294] = {.lex_state = 0},
  [3295] = {.lex_state = 0},
  [3296] = {.lex_state = 0},
  [3297] = {.lex_state = 0},
  [3298] = {.lex_state = 0},
  [3299] = {.lex_state = 68},
  [3300] = {.lex_state = 0},
  [3301] = {.lex_state = 68},
  [3302] = {.lex_state = 0},
  [3303] = {.lex_state = 68},
  [3304] = {.lex_state = 0},
  [3305] = {.lex_state = 0},
  [3306] = {.lex_state = 0},
  [3307] = {.lex_state = 0},
  [3308] = {.lex_state = 68},
  [3309] = {.lex_state = 0},
  [3310] = {.lex_state = 68},
  [3311] = {.lex_state = 0},
  [3312] = {.lex_state = 68},
  [3313] = {.lex_state = 68},
  [3314] = {.lex_state = 0},
  [3315] = {.lex_state = 68},
  [3316] = {.lex_state = 0},
  [3317] = {.lex_state = 68},
  [3318] = {.lex_state = 0},
  [3319] = {.lex_state = 68},
  [3320] = {.lex_state = 0},
  [3321] = {.lex_state = 0},
  [3322] = {.lex_state = 68},
  [3323] = {.lex_state = 68},
  [3324] = {.lex_state = 0},
  [3325] = {.lex_state = 15},
  [3326] = {.lex_state = 0},
  [3327] = {.lex_state = 0},
  [3328] = {.lex_state = 68},
  [3329] = {.lex_state = 68},
  [3330] = {.lex_state = 68},
  [3331] = {.lex_state = 68},
  [3332] = {.lex_state = 0},
  [3333] = {.lex_state = 0},
  [3334] = {.lex_state = 68},
  [3335] = {.lex_state = 68},
  [3336] = {.lex_state = 0},
  [3337] = {.lex_state = 0},
  [3338] = {.lex_state = 68},
  [3339] = {.lex_state = 0},
  [3340] = {.lex_state = 0},
  [3341] = {.lex_state = 68},
  [3342] = {.lex_state = 68},
  [3343] = {.lex_state = 68},
  [3344] = {.lex_state = 68},
  [3345] = {.lex_state = 68},
  [3346] = {.lex_state = 0},
  [3347] = {.lex_state = 0},
  [3348] = {.lex_state = 0},
  [3349] = {.lex_state = 68},
  [3350] = {.lex_state = 0},
  [3351] = {.lex_state = 0},
  [3352] = {.lex_state = 0},
  [3353] = {.lex_state = 68},
  [3354] = {.lex_state = 68},
  [3355] = {.lex_state = 0},
  [3356] = {.lex_state = 0},
  [3357] = {.lex_state = 68},
  [3358] = {.lex_state = 0},
  [3359] = {.lex_state = 0},
  [3360] = {.lex_state = 0},
  [3361] = {.lex_state = 0},
  [3362] = {.lex_state = 68},
  [3363] = {.lex_state = 0},
  [3364] = {.lex_state = 68},
  [3365] = {.lex_state = 68},
  [3366] = {.lex_state = 68},
  [3367] = {.lex_state = 0},
  [3368] = {.lex_state = 68},
  [3369] = {.lex_state = 68},
  [3370] = {.lex_state = 68},
  [3371] = {.lex_state = 68},
  [3372] = {.lex_state = 0},
  [3373] = {.lex_state = 68},
  [3374] = {.lex_state = 68},
  [3375] = {.lex_state = 0},
  [3376] = {.lex_state = 68},
  [3377] = {.lex_state = 0},
  [3378] = {.lex_state = 5},
  [3379] = {.lex_state = 0},
  [3380] = {.lex_state = 0},
  [3381] = {.lex_state = 68},
  [3382] = {.lex_state = 68},
  [3383] = {.lex_state = 0},
  [3384] = {.lex_state = 15},
  [3385] = {.lex_state = 0},
  [3386] = {.lex_state = 68},
  [3387] = {.lex_state = 0},
  [3388] = {.lex_state = 68},
  [3389] = {.lex_state = 0},
  [3390] = {.lex_state = 0},
  [3391] = {.lex_state = 0},
  [3392] = {.lex_state = 0},
  [3393] = {.lex_state = 0},
  [3394] = {.lex_state = 0},
  [3395] = {.lex_state = 0},
};

enum {
  ts_external_token__automatic_semicolon = 0,
  ts_external_token__template_chars = 1,
  ts_external_token_PIPE_PIPE = 2,
  ts_external_token__function_signature_automatic_semicolon = 3,
};

static TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token__automatic_semicolon] = sym__automatic_semicolon,
  [ts_external_token__template_chars] = sym__template_chars,
  [ts_external_token_PIPE_PIPE] = anon_sym_PIPE_PIPE,
  [ts_external_token__function_signature_automatic_semicolon] = sym__function_signature_automatic_semicolon,
};

static bool ts_external_scanner_states[7][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token__automatic_semicolon] = true,
    [ts_external_token__template_chars] = true,
    [ts_external_token_PIPE_PIPE] = true,
    [ts_external_token__function_signature_automatic_semicolon] = true,
  },
  [2] = {
    [ts_external_token_PIPE_PIPE] = true,
  },
  [3] = {
    [ts_external_token__automatic_semicolon] = true,
    [ts_external_token_PIPE_PIPE] = true,
  },
  [4] = {
    [ts_external_token__automatic_semicolon] = true,
  },
  [5] = {
    [ts_external_token__automatic_semicolon] = true,
    [ts_external_token__function_signature_automatic_semicolon] = true,
  },
  [6] = {
    [ts_external_token__template_chars] = true,
  },
};

static uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym_identifier] = ACTIONS(1),
    [sym_hash_bang_line] = ACTIONS(1),
    [anon_sym_export] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_default] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_as] = ACTIONS(1),
    [anon_sym_namespace] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_type] = ACTIONS(1),
    [anon_sym_typeof] = ACTIONS(1),
    [anon_sym_import] = ACTIONS(1),
    [anon_sym_from] = ACTIONS(1),
    [anon_sym_var] = ACTIONS(1),
    [anon_sym_let] = ACTIONS(1),
    [anon_sym_const] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_switch] = ACTIONS(1),
    [anon_sym_for] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_await] = ACTIONS(1),
    [anon_sym_in] = ACTIONS(1),
    [anon_sym_of] = ACTIONS(1),
    [anon_sym_while] = ACTIONS(1),
    [anon_sym_do] = ACTIONS(1),
    [anon_sym_try] = ACTIONS(1),
    [anon_sym_with] = ACTIONS(1),
    [anon_sym_break] = ACTIONS(1),
    [anon_sym_continue] = ACTIONS(1),
    [anon_sym_debugger] = ACTIONS(1),
    [anon_sym_return] = ACTIONS(1),
    [anon_sym_throw] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_case] = ACTIONS(1),
    [anon_sym_catch] = ACTIONS(1),
    [anon_sym_finally] = ACTIONS(1),
    [anon_sym_yield] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_class] = ACTIONS(1),
    [anon_sym_async] = ACTIONS(1),
    [anon_sym_function] = ACTIONS(1),
    [anon_sym_EQ_GT] = ACTIONS(1),
    [anon_sym_QMARK_DOT] = ACTIONS(1),
    [anon_sym_new] = ACTIONS(1),
    [anon_sym_PLUS_EQ] = ACTIONS(1),
    [anon_sym_DASH_EQ] = ACTIONS(1),
    [anon_sym_STAR_EQ] = ACTIONS(1),
    [anon_sym_PERCENT_EQ] = ACTIONS(1),
    [anon_sym_CARET_EQ] = ACTIONS(1),
    [anon_sym_AMP_EQ] = ACTIONS(1),
    [anon_sym_PIPE_EQ] = ACTIONS(1),
    [anon_sym_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_LT_LT_EQ] = ACTIONS(1),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(1),
    [anon_sym_AMP_AMP] = ACTIONS(1),
    [anon_sym_PIPE_PIPE] = ACTIONS(1),
    [anon_sym_GT_GT] = ACTIONS(1),
    [anon_sym_GT_GT_GT] = ACTIONS(1),
    [anon_sym_LT_LT] = ACTIONS(1),
    [anon_sym_AMP] = ACTIONS(1),
    [anon_sym_CARET] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_STAR_STAR] = ACTIONS(1),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_QMARK_QMARK] = ACTIONS(1),
    [anon_sym_instanceof] = ACTIONS(1),
    [anon_sym_TILDE] = ACTIONS(1),
    [anon_sym_void] = ACTIONS(1),
    [anon_sym_delete] = ACTIONS(1),
    [anon_sym_PLUS_PLUS] = ACTIONS(1),
    [anon_sym_DASH_DASH] = ACTIONS(1),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [anon_sym_SQUOTE] = ACTIONS(1),
    [sym_escape_sequence] = ACTIONS(1),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1),
    [anon_sym_SLASH2] = ACTIONS(1),
    [sym_number] = ACTIONS(1),
    [anon_sym_target] = ACTIONS(1),
    [sym_this] = ACTIONS(1),
    [sym_super] = ACTIONS(1),
    [sym_true] = ACTIONS(1),
    [sym_false] = ACTIONS(1),
    [sym_null] = ACTIONS(1),
    [sym_undefined] = ACTIONS(1),
    [anon_sym_AT] = ACTIONS(1),
    [anon_sym_static] = ACTIONS(1),
    [anon_sym_abstract] = ACTIONS(1),
    [anon_sym_get] = ACTIONS(1),
    [anon_sym_set] = ACTIONS(1),
    [anon_sym_declare] = ACTIONS(1),
    [anon_sym_public] = ACTIONS(1),
    [anon_sym_private] = ACTIONS(1),
    [anon_sym_protected] = ACTIONS(1),
    [anon_sym_module] = ACTIONS(1),
    [anon_sym_any] = ACTIONS(1),
    [anon_sym_number] = ACTIONS(1),
    [anon_sym_boolean] = ACTIONS(1),
    [anon_sym_string] = ACTIONS(1),
    [anon_sym_symbol] = ACTIONS(1),
    [anon_sym_require] = ACTIONS(1),
    [anon_sym_implements] = ACTIONS(1),
    [anon_sym_global] = ACTIONS(1),
    [anon_sym_interface] = ACTIONS(1),
    [anon_sym_extends] = ACTIONS(1),
    [anon_sym_enum] = ACTIONS(1),
    [sym_readonly] = ACTIONS(1),
    [anon_sym_DASH_QMARK_COLON] = ACTIONS(1),
    [anon_sym_asserts] = ACTIONS(1),
    [anon_sym_is] = ACTIONS(1),
    [anon_sym_infer] = ACTIONS(1),
    [anon_sym_keyof] = ACTIONS(1),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1),
    [sym__automatic_semicolon] = ACTIONS(1),
    [sym__template_chars] = ACTIONS(1),
    [sym__function_signature_automatic_semicolon] = ACTIONS(1),
  },
  [1] = {
    [sym_program] = STATE(3367),
    [sym_export_statement] = STATE(19),
    [sym__declaration] = STATE(19),
    [sym_import] = STATE(1528),
    [sym_import_statement] = STATE(19),
    [sym_expression_statement] = STATE(19),
    [sym_variable_declaration] = STATE(572),
    [sym_lexical_declaration] = STATE(572),
    [sym_statement_block] = STATE(19),
    [sym_if_statement] = STATE(19),
    [sym_switch_statement] = STATE(19),
    [sym_for_statement] = STATE(19),
    [sym_for_in_statement] = STATE(19),
    [sym_while_statement] = STATE(19),
    [sym_do_statement] = STATE(19),
    [sym_try_statement] = STATE(19),
    [sym_with_statement] = STATE(19),
    [sym_break_statement] = STATE(19),
    [sym_continue_statement] = STATE(19),
    [sym_debugger_statement] = STATE(19),
    [sym_return_statement] = STATE(19),
    [sym_throw_statement] = STATE(19),
    [sym_empty_statement] = STATE(19),
    [sym_labeled_statement] = STATE(19),
    [sym_parenthesized_expression] = STATE(933),
    [sym__expression] = STATE(1345),
    [sym_yield_expression] = STATE(1543),
    [sym_object] = STATE(1367),
    [sym_array] = STATE(1369),
    [sym_class] = STATE(1528),
    [sym_class_declaration] = STATE(572),
    [sym_function] = STATE(1528),
    [sym_function_declaration] = STATE(572),
    [sym_generator_function] = STATE(1528),
    [sym_generator_function_declaration] = STATE(572),
    [sym_arrow_function] = STATE(1528),
    [sym__call_signature] = STATE(3359),
    [sym_call_expression] = STATE(1528),
    [sym_new_expression] = STATE(1543),
    [sym_await_expression] = STATE(1543),
    [sym_member_expression] = STATE(933),
    [sym_subscript_expression] = STATE(933),
    [sym_assignment_expression] = STATE(1543),
    [sym__augmented_assignment_lhs] = STATE(1970),
    [sym_augmented_assignment_expression] = STATE(1543),
    [sym_ternary_expression] = STATE(1543),
    [sym_binary_expression] = STATE(1543),
    [sym_unary_expression] = STATE(1543),
    [sym_update_expression] = STATE(1543),
    [sym_sequence_expression] = STATE(3070),
    [sym_string] = STATE(1528),
    [sym_template_string] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_meta_property] = STATE(1528),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(936),
    [sym_function_signature] = STATE(572),
    [sym_type_assertion] = STATE(1543),
    [sym_as_expression] = STATE(1543),
    [sym_ambient_declaration] = STATE(572),
    [sym_abstract_class_declaration] = STATE(572),
    [sym_module] = STATE(572),
    [sym_internal_module] = STATE(96),
    [sym_import_alias] = STATE(572),
    [sym_interface_declaration] = STATE(572),
    [sym_enum_declaration] = STATE(572),
    [sym_type_alias_declaration] = STATE(572),
    [sym_type_arguments] = STATE(381),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_program_repeat1] = STATE(19),
    [aux_sym_export_statement_repeat1] = STATE(2307),
    [ts_builtin_sym_end] = ACTIONS(5),
    [sym_identifier] = ACTIONS(7),
    [sym_hash_bang_line] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(95),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(97),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(99),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
    [sym_readonly] = ACTIONS(93),
  },
  [2] = {
    [sym_export_statement] = STATE(12),
    [sym__declaration] = STATE(12),
    [sym_import] = STATE(1528),
    [sym_import_statement] = STATE(12),
    [sym_expression_statement] = STATE(12),
    [sym_variable_declaration] = STATE(572),
    [sym_lexical_declaration] = STATE(572),
    [sym_statement_block] = STATE(12),
    [sym_if_statement] = STATE(12),
    [sym_switch_statement] = STATE(12),
    [sym_for_statement] = STATE(12),
    [sym_for_in_statement] = STATE(12),
    [sym_while_statement] = STATE(12),
    [sym_do_statement] = STATE(12),
    [sym_try_statement] = STATE(12),
    [sym_with_statement] = STATE(12),
    [sym_break_statement] = STATE(12),
    [sym_continue_statement] = STATE(12),
    [sym_debugger_statement] = STATE(12),
    [sym_return_statement] = STATE(12),
    [sym_throw_statement] = STATE(12),
    [sym_empty_statement] = STATE(12),
    [sym_labeled_statement] = STATE(12),
    [sym_parenthesized_expression] = STATE(933),
    [sym__expression] = STATE(1345),
    [sym_yield_expression] = STATE(1543),
    [sym_object] = STATE(1589),
    [sym_assignment_pattern] = STATE(2870),
    [sym_array] = STATE(1653),
    [sym_class] = STATE(1528),
    [sym_class_declaration] = STATE(572),
    [sym_function] = STATE(1528),
    [sym_function_declaration] = STATE(572),
    [sym_generator_function] = STATE(1528),
    [sym_generator_function_declaration] = STATE(572),
    [sym_arrow_function] = STATE(1528),
    [sym__call_signature] = STATE(3359),
    [sym_call_expression] = STATE(1528),
    [sym_new_expression] = STATE(1543),
    [sym_await_expression] = STATE(1543),
    [sym_member_expression] = STATE(933),
    [sym_subscript_expression] = STATE(933),
    [sym_assignment_expression] = STATE(1543),
    [sym__augmented_assignment_lhs] = STATE(1970),
    [sym_augmented_assignment_expression] = STATE(1543),
    [sym_spread_element] = STATE(2870),
    [sym_ternary_expression] = STATE(1543),
    [sym_binary_expression] = STATE(1543),
    [sym_unary_expression] = STATE(1543),
    [sym_update_expression] = STATE(1543),
    [sym_sequence_expression] = STATE(3070),
    [sym_string] = STATE(1582),
    [sym_template_string] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_meta_property] = STATE(1528),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_method_definition] = STATE(2870),
    [sym_pair] = STATE(2870),
    [sym__property_name] = STATE(2200),
    [sym_computed_property_name] = STATE(2200),
    [sym_non_null_expression] = STATE(936),
    [sym_function_signature] = STATE(572),
    [sym_type_assertion] = STATE(1543),
    [sym_as_expression] = STATE(1543),
    [sym_ambient_declaration] = STATE(572),
    [sym_abstract_class_declaration] = STATE(572),
    [sym_module] = STATE(572),
    [sym_internal_module] = STATE(96),
    [sym_import_alias] = STATE(572),
    [sym_interface_declaration] = STATE(572),
    [sym_enum_declaration] = STATE(572),
    [sym_type_alias_declaration] = STATE(572),
    [sym_accessibility_modifier] = STATE(1921),
    [sym_type_arguments] = STATE(381),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_program_repeat1] = STATE(12),
    [aux_sym_export_statement_repeat1] = STATE(2307),
    [aux_sym_object_repeat1] = STATE(2874),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_export] = ACTIONS(107),
    [anon_sym_STAR] = ACTIONS(109),
    [anon_sym_namespace] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_COMMA] = ACTIONS(113),
    [anon_sym_RBRACE] = ACTIONS(115),
    [anon_sym_type] = ACTIONS(117),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(119),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(121),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(125),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(127),
    [anon_sym_abstract] = ACTIONS(95),
    [anon_sym_get] = ACTIONS(129),
    [anon_sym_set] = ACTIONS(129),
    [anon_sym_declare] = ACTIONS(131),
    [anon_sym_public] = ACTIONS(133),
    [anon_sym_private] = ACTIONS(133),
    [anon_sym_protected] = ACTIONS(133),
    [anon_sym_module] = ACTIONS(135),
    [anon_sym_any] = ACTIONS(137),
    [anon_sym_number] = ACTIONS(137),
    [anon_sym_boolean] = ACTIONS(137),
    [anon_sym_string] = ACTIONS(137),
    [anon_sym_symbol] = ACTIONS(137),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
    [sym_readonly] = ACTIONS(139),
  },
  [3] = {
    [sym_export_statement] = STATE(24),
    [sym__declaration] = STATE(24),
    [sym_import] = STATE(1528),
    [sym_import_statement] = STATE(24),
    [sym_expression_statement] = STATE(24),
    [sym_variable_declaration] = STATE(572),
    [sym_lexical_declaration] = STATE(572),
    [sym_statement_block] = STATE(24),
    [sym_if_statement] = STATE(24),
    [sym_switch_statement] = STATE(24),
    [sym_for_statement] = STATE(24),
    [sym_for_in_statement] = STATE(24),
    [sym_while_statement] = STATE(24),
    [sym_do_statement] = STATE(24),
    [sym_try_statement] = STATE(24),
    [sym_with_statement] = STATE(24),
    [sym_break_statement] = STATE(24),
    [sym_continue_statement] = STATE(24),
    [sym_debugger_statement] = STATE(24),
    [sym_return_statement] = STATE(24),
    [sym_throw_statement] = STATE(24),
    [sym_empty_statement] = STATE(24),
    [sym_labeled_statement] = STATE(24),
    [sym_parenthesized_expression] = STATE(933),
    [sym__expression] = STATE(1345),
    [sym_yield_expression] = STATE(1543),
    [sym_object] = STATE(1589),
    [sym_assignment_pattern] = STATE(2913),
    [sym_array] = STATE(1653),
    [sym_class] = STATE(1528),
    [sym_class_declaration] = STATE(572),
    [sym_function] = STATE(1528),
    [sym_function_declaration] = STATE(572),
    [sym_generator_function] = STATE(1528),
    [sym_generator_function_declaration] = STATE(572),
    [sym_arrow_function] = STATE(1528),
    [sym__call_signature] = STATE(3359),
    [sym_call_expression] = STATE(1528),
    [sym_new_expression] = STATE(1543),
    [sym_await_expression] = STATE(1543),
    [sym_member_expression] = STATE(933),
    [sym_subscript_expression] = STATE(933),
    [sym_assignment_expression] = STATE(1543),
    [sym__augmented_assignment_lhs] = STATE(1970),
    [sym_augmented_assignment_expression] = STATE(1543),
    [sym_spread_element] = STATE(2913),
    [sym_ternary_expression] = STATE(1543),
    [sym_binary_expression] = STATE(1543),
    [sym_unary_expression] = STATE(1543),
    [sym_update_expression] = STATE(1543),
    [sym_sequence_expression] = STATE(3070),
    [sym_string] = STATE(1582),
    [sym_template_string] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_meta_property] = STATE(1528),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_method_definition] = STATE(2913),
    [sym_pair] = STATE(2913),
    [sym__property_name] = STATE(2200),
    [sym_computed_property_name] = STATE(2200),
    [sym_non_null_expression] = STATE(936),
    [sym_function_signature] = STATE(572),
    [sym_type_assertion] = STATE(1543),
    [sym_as_expression] = STATE(1543),
    [sym_ambient_declaration] = STATE(572),
    [sym_abstract_class_declaration] = STATE(572),
    [sym_module] = STATE(572),
    [sym_internal_module] = STATE(96),
    [sym_import_alias] = STATE(572),
    [sym_interface_declaration] = STATE(572),
    [sym_enum_declaration] = STATE(572),
    [sym_type_alias_declaration] = STATE(572),
    [sym_accessibility_modifier] = STATE(1921),
    [sym_type_arguments] = STATE(381),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_program_repeat1] = STATE(24),
    [aux_sym_export_statement_repeat1] = STATE(2307),
    [aux_sym_object_repeat1] = STATE(2912),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_export] = ACTIONS(143),
    [anon_sym_STAR] = ACTIONS(109),
    [anon_sym_namespace] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_COMMA] = ACTIONS(113),
    [anon_sym_RBRACE] = ACTIONS(147),
    [anon_sym_type] = ACTIONS(149),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(119),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(151),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(125),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(153),
    [anon_sym_abstract] = ACTIONS(95),
    [anon_sym_get] = ACTIONS(155),
    [anon_sym_set] = ACTIONS(155),
    [anon_sym_declare] = ACTIONS(157),
    [anon_sym_public] = ACTIONS(159),
    [anon_sym_private] = ACTIONS(159),
    [anon_sym_protected] = ACTIONS(159),
    [anon_sym_module] = ACTIONS(161),
    [anon_sym_any] = ACTIONS(163),
    [anon_sym_number] = ACTIONS(163),
    [anon_sym_boolean] = ACTIONS(163),
    [anon_sym_string] = ACTIONS(163),
    [anon_sym_symbol] = ACTIONS(163),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
    [sym_readonly] = ACTIONS(165),
  },
  [4] = {
    [sym_export_statement] = STATE(13),
    [sym__declaration] = STATE(13),
    [sym_import] = STATE(1528),
    [sym_import_statement] = STATE(13),
    [sym_expression_statement] = STATE(13),
    [sym_variable_declaration] = STATE(572),
    [sym_lexical_declaration] = STATE(572),
    [sym_statement_block] = STATE(13),
    [sym_if_statement] = STATE(13),
    [sym_switch_statement] = STATE(13),
    [sym_for_statement] = STATE(13),
    [sym_for_in_statement] = STATE(13),
    [sym_while_statement] = STATE(13),
    [sym_do_statement] = STATE(13),
    [sym_try_statement] = STATE(13),
    [sym_with_statement] = STATE(13),
    [sym_break_statement] = STATE(13),
    [sym_continue_statement] = STATE(13),
    [sym_debugger_statement] = STATE(13),
    [sym_return_statement] = STATE(13),
    [sym_throw_statement] = STATE(13),
    [sym_empty_statement] = STATE(13),
    [sym_labeled_statement] = STATE(13),
    [sym_parenthesized_expression] = STATE(933),
    [sym__expression] = STATE(1345),
    [sym_yield_expression] = STATE(1543),
    [sym_object] = STATE(1589),
    [sym_assignment_pattern] = STATE(2870),
    [sym_array] = STATE(1653),
    [sym_class] = STATE(1528),
    [sym_class_declaration] = STATE(572),
    [sym_function] = STATE(1528),
    [sym_function_declaration] = STATE(572),
    [sym_generator_function] = STATE(1528),
    [sym_generator_function_declaration] = STATE(572),
    [sym_arrow_function] = STATE(1528),
    [sym__call_signature] = STATE(3359),
    [sym_call_expression] = STATE(1528),
    [sym_new_expression] = STATE(1543),
    [sym_await_expression] = STATE(1543),
    [sym_member_expression] = STATE(933),
    [sym_subscript_expression] = STATE(933),
    [sym_assignment_expression] = STATE(1543),
    [sym__augmented_assignment_lhs] = STATE(1970),
    [sym_augmented_assignment_expression] = STATE(1543),
    [sym_spread_element] = STATE(2870),
    [sym_ternary_expression] = STATE(1543),
    [sym_binary_expression] = STATE(1543),
    [sym_unary_expression] = STATE(1543),
    [sym_update_expression] = STATE(1543),
    [sym_sequence_expression] = STATE(3070),
    [sym_string] = STATE(1582),
    [sym_template_string] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_meta_property] = STATE(1528),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_method_definition] = STATE(2870),
    [sym_pair] = STATE(2870),
    [sym__property_name] = STATE(2200),
    [sym_computed_property_name] = STATE(2200),
    [sym_non_null_expression] = STATE(936),
    [sym_function_signature] = STATE(572),
    [sym_type_assertion] = STATE(1543),
    [sym_as_expression] = STATE(1543),
    [sym_ambient_declaration] = STATE(572),
    [sym_abstract_class_declaration] = STATE(572),
    [sym_module] = STATE(572),
    [sym_internal_module] = STATE(96),
    [sym_import_alias] = STATE(572),
    [sym_interface_declaration] = STATE(572),
    [sym_enum_declaration] = STATE(572),
    [sym_type_alias_declaration] = STATE(572),
    [sym_accessibility_modifier] = STATE(1921),
    [sym_type_arguments] = STATE(381),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_program_repeat1] = STATE(13),
    [aux_sym_export_statement_repeat1] = STATE(2307),
    [aux_sym_object_repeat1] = STATE(2874),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_export] = ACTIONS(107),
    [anon_sym_STAR] = ACTIONS(109),
    [anon_sym_namespace] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_COMMA] = ACTIONS(113),
    [anon_sym_RBRACE] = ACTIONS(167),
    [anon_sym_type] = ACTIONS(117),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(119),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(121),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(125),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(127),
    [anon_sym_abstract] = ACTIONS(95),
    [anon_sym_get] = ACTIONS(129),
    [anon_sym_set] = ACTIONS(129),
    [anon_sym_declare] = ACTIONS(131),
    [anon_sym_public] = ACTIONS(133),
    [anon_sym_private] = ACTIONS(133),
    [anon_sym_protected] = ACTIONS(133),
    [anon_sym_module] = ACTIONS(135),
    [anon_sym_any] = ACTIONS(137),
    [anon_sym_number] = ACTIONS(137),
    [anon_sym_boolean] = ACTIONS(137),
    [anon_sym_string] = ACTIONS(137),
    [anon_sym_symbol] = ACTIONS(137),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
    [sym_readonly] = ACTIONS(139),
  },
  [5] = {
    [sym_export_statement] = STATE(13),
    [sym__declaration] = STATE(13),
    [sym_import] = STATE(1528),
    [sym_import_statement] = STATE(13),
    [sym_expression_statement] = STATE(13),
    [sym_variable_declaration] = STATE(572),
    [sym_lexical_declaration] = STATE(572),
    [sym_statement_block] = STATE(13),
    [sym_if_statement] = STATE(13),
    [sym_switch_statement] = STATE(13),
    [sym_for_statement] = STATE(13),
    [sym_for_in_statement] = STATE(13),
    [sym_while_statement] = STATE(13),
    [sym_do_statement] = STATE(13),
    [sym_try_statement] = STATE(13),
    [sym_with_statement] = STATE(13),
    [sym_break_statement] = STATE(13),
    [sym_continue_statement] = STATE(13),
    [sym_debugger_statement] = STATE(13),
    [sym_return_statement] = STATE(13),
    [sym_throw_statement] = STATE(13),
    [sym_empty_statement] = STATE(13),
    [sym_labeled_statement] = STATE(13),
    [sym_parenthesized_expression] = STATE(933),
    [sym__expression] = STATE(1345),
    [sym_yield_expression] = STATE(1543),
    [sym_object] = STATE(1589),
    [sym_assignment_pattern] = STATE(2870),
    [sym_array] = STATE(1653),
    [sym_class] = STATE(1528),
    [sym_class_declaration] = STATE(572),
    [sym_function] = STATE(1528),
    [sym_function_declaration] = STATE(572),
    [sym_generator_function] = STATE(1528),
    [sym_generator_function_declaration] = STATE(572),
    [sym_arrow_function] = STATE(1528),
    [sym__call_signature] = STATE(3359),
    [sym_call_expression] = STATE(1528),
    [sym_new_expression] = STATE(1543),
    [sym_await_expression] = STATE(1543),
    [sym_member_expression] = STATE(933),
    [sym_subscript_expression] = STATE(933),
    [sym_assignment_expression] = STATE(1543),
    [sym__augmented_assignment_lhs] = STATE(1970),
    [sym_augmented_assignment_expression] = STATE(1543),
    [sym_spread_element] = STATE(2870),
    [sym_ternary_expression] = STATE(1543),
    [sym_binary_expression] = STATE(1543),
    [sym_unary_expression] = STATE(1543),
    [sym_update_expression] = STATE(1543),
    [sym_sequence_expression] = STATE(3070),
    [sym_string] = STATE(1582),
    [sym_template_string] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_meta_property] = STATE(1528),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_method_definition] = STATE(2870),
    [sym_pair] = STATE(2870),
    [sym__property_name] = STATE(2200),
    [sym_computed_property_name] = STATE(2200),
    [sym_non_null_expression] = STATE(936),
    [sym_function_signature] = STATE(572),
    [sym_type_assertion] = STATE(1543),
    [sym_as_expression] = STATE(1543),
    [sym_ambient_declaration] = STATE(572),
    [sym_abstract_class_declaration] = STATE(572),
    [sym_module] = STATE(572),
    [sym_internal_module] = STATE(96),
    [sym_import_alias] = STATE(572),
    [sym_interface_declaration] = STATE(572),
    [sym_enum_declaration] = STATE(572),
    [sym_type_alias_declaration] = STATE(572),
    [sym_accessibility_modifier] = STATE(1921),
    [sym_type_arguments] = STATE(381),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_program_repeat1] = STATE(13),
    [aux_sym_export_statement_repeat1] = STATE(2307),
    [aux_sym_object_repeat1] = STATE(2874),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_export] = ACTIONS(107),
    [anon_sym_STAR] = ACTIONS(109),
    [anon_sym_namespace] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_COMMA] = ACTIONS(113),
    [anon_sym_RBRACE] = ACTIONS(169),
    [anon_sym_type] = ACTIONS(117),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(119),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(121),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(125),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(127),
    [anon_sym_abstract] = ACTIONS(95),
    [anon_sym_get] = ACTIONS(129),
    [anon_sym_set] = ACTIONS(129),
    [anon_sym_declare] = ACTIONS(131),
    [anon_sym_public] = ACTIONS(133),
    [anon_sym_private] = ACTIONS(133),
    [anon_sym_protected] = ACTIONS(133),
    [anon_sym_module] = ACTIONS(135),
    [anon_sym_any] = ACTIONS(137),
    [anon_sym_number] = ACTIONS(137),
    [anon_sym_boolean] = ACTIONS(137),
    [anon_sym_string] = ACTIONS(137),
    [anon_sym_symbol] = ACTIONS(137),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
    [sym_readonly] = ACTIONS(139),
  },
  [6] = {
    [sym_export_statement] = STATE(27),
    [sym__declaration] = STATE(27),
    [sym_import] = STATE(1528),
    [sym_import_statement] = STATE(27),
    [sym_expression_statement] = STATE(27),
    [sym_variable_declaration] = STATE(572),
    [sym_lexical_declaration] = STATE(572),
    [sym_statement_block] = STATE(27),
    [sym_if_statement] = STATE(27),
    [sym_switch_statement] = STATE(27),
    [sym_for_statement] = STATE(27),
    [sym_for_in_statement] = STATE(27),
    [sym_while_statement] = STATE(27),
    [sym_do_statement] = STATE(27),
    [sym_try_statement] = STATE(27),
    [sym_with_statement] = STATE(27),
    [sym_break_statement] = STATE(27),
    [sym_continue_statement] = STATE(27),
    [sym_debugger_statement] = STATE(27),
    [sym_return_statement] = STATE(27),
    [sym_throw_statement] = STATE(27),
    [sym_empty_statement] = STATE(27),
    [sym_labeled_statement] = STATE(27),
    [sym_parenthesized_expression] = STATE(933),
    [sym__expression] = STATE(1345),
    [sym_yield_expression] = STATE(1543),
    [sym_object] = STATE(1589),
    [sym_assignment_pattern] = STATE(2844),
    [sym_array] = STATE(1653),
    [sym_class] = STATE(1528),
    [sym_class_declaration] = STATE(572),
    [sym_function] = STATE(1528),
    [sym_function_declaration] = STATE(572),
    [sym_generator_function] = STATE(1528),
    [sym_generator_function_declaration] = STATE(572),
    [sym_arrow_function] = STATE(1528),
    [sym__call_signature] = STATE(3359),
    [sym_call_expression] = STATE(1528),
    [sym_new_expression] = STATE(1543),
    [sym_await_expression] = STATE(1543),
    [sym_member_expression] = STATE(933),
    [sym_subscript_expression] = STATE(933),
    [sym_assignment_expression] = STATE(1543),
    [sym__augmented_assignment_lhs] = STATE(1970),
    [sym_augmented_assignment_expression] = STATE(1543),
    [sym_spread_element] = STATE(2844),
    [sym_ternary_expression] = STATE(1543),
    [sym_binary_expression] = STATE(1543),
    [sym_unary_expression] = STATE(1543),
    [sym_update_expression] = STATE(1543),
    [sym_sequence_expression] = STATE(3070),
    [sym_string] = STATE(1582),
    [sym_template_string] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_meta_property] = STATE(1528),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_method_definition] = STATE(2844),
    [sym_pair] = STATE(2844),
    [sym__property_name] = STATE(2200),
    [sym_computed_property_name] = STATE(2200),
    [sym_non_null_expression] = STATE(936),
    [sym_function_signature] = STATE(572),
    [sym_type_assertion] = STATE(1543),
    [sym_as_expression] = STATE(1543),
    [sym_ambient_declaration] = STATE(572),
    [sym_abstract_class_declaration] = STATE(572),
    [sym_module] = STATE(572),
    [sym_internal_module] = STATE(96),
    [sym_import_alias] = STATE(572),
    [sym_interface_declaration] = STATE(572),
    [sym_enum_declaration] = STATE(572),
    [sym_type_alias_declaration] = STATE(572),
    [sym_accessibility_modifier] = STATE(1921),
    [sym_type_arguments] = STATE(381),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_program_repeat1] = STATE(27),
    [aux_sym_export_statement_repeat1] = STATE(2307),
    [aux_sym_object_repeat1] = STATE(2846),
    [sym_identifier] = ACTIONS(171),
    [anon_sym_export] = ACTIONS(173),
    [anon_sym_STAR] = ACTIONS(109),
    [anon_sym_namespace] = ACTIONS(175),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_COMMA] = ACTIONS(113),
    [anon_sym_RBRACE] = ACTIONS(177),
    [anon_sym_type] = ACTIONS(179),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(119),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(181),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(125),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(183),
    [anon_sym_abstract] = ACTIONS(95),
    [anon_sym_get] = ACTIONS(185),
    [anon_sym_set] = ACTIONS(185),
    [anon_sym_declare] = ACTIONS(187),
    [anon_sym_public] = ACTIONS(189),
    [anon_sym_private] = ACTIONS(189),
    [anon_sym_protected] = ACTIONS(189),
    [anon_sym_module] = ACTIONS(191),
    [anon_sym_any] = ACTIONS(193),
    [anon_sym_number] = ACTIONS(193),
    [anon_sym_boolean] = ACTIONS(193),
    [anon_sym_string] = ACTIONS(193),
    [anon_sym_symbol] = ACTIONS(193),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
    [sym_readonly] = ACTIONS(195),
  },
  [7] = {
    [sym_export_statement] = STATE(7),
    [sym__declaration] = STATE(7),
    [sym_import] = STATE(1528),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(572),
    [sym_lexical_declaration] = STATE(572),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(933),
    [sym__expression] = STATE(1345),
    [sym_yield_expression] = STATE(1543),
    [sym_object] = STATE(1367),
    [sym_array] = STATE(1369),
    [sym_class] = STATE(1528),
    [sym_class_declaration] = STATE(572),
    [sym_function] = STATE(1528),
    [sym_function_declaration] = STATE(572),
    [sym_generator_function] = STATE(1528),
    [sym_generator_function_declaration] = STATE(572),
    [sym_arrow_function] = STATE(1528),
    [sym__call_signature] = STATE(3359),
    [sym_call_expression] = STATE(1528),
    [sym_new_expression] = STATE(1543),
    [sym_await_expression] = STATE(1543),
    [sym_member_expression] = STATE(933),
    [sym_subscript_expression] = STATE(933),
    [sym_assignment_expression] = STATE(1543),
    [sym__augmented_assignment_lhs] = STATE(1970),
    [sym_augmented_assignment_expression] = STATE(1543),
    [sym_ternary_expression] = STATE(1543),
    [sym_binary_expression] = STATE(1543),
    [sym_unary_expression] = STATE(1543),
    [sym_update_expression] = STATE(1543),
    [sym_sequence_expression] = STATE(3070),
    [sym_string] = STATE(1528),
    [sym_template_string] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_meta_property] = STATE(1528),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(936),
    [sym_function_signature] = STATE(572),
    [sym_type_assertion] = STATE(1543),
    [sym_as_expression] = STATE(1543),
    [sym_ambient_declaration] = STATE(572),
    [sym_abstract_class_declaration] = STATE(572),
    [sym_module] = STATE(572),
    [sym_internal_module] = STATE(96),
    [sym_import_alias] = STATE(572),
    [sym_interface_declaration] = STATE(572),
    [sym_enum_declaration] = STATE(572),
    [sym_type_alias_declaration] = STATE(572),
    [sym_type_arguments] = STATE(381),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(2307),
    [ts_builtin_sym_end] = ACTIONS(197),
    [sym_identifier] = ACTIONS(199),
    [anon_sym_export] = ACTIONS(202),
    [anon_sym_default] = ACTIONS(205),
    [anon_sym_namespace] = ACTIONS(207),
    [anon_sym_LBRACE] = ACTIONS(210),
    [anon_sym_RBRACE] = ACTIONS(197),
    [anon_sym_type] = ACTIONS(213),
    [anon_sym_typeof] = ACTIONS(216),
    [anon_sym_import] = ACTIONS(219),
    [anon_sym_var] = ACTIONS(222),
    [anon_sym_let] = ACTIONS(225),
    [anon_sym_const] = ACTIONS(228),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_if] = ACTIONS(234),
    [anon_sym_switch] = ACTIONS(237),
    [anon_sym_for] = ACTIONS(240),
    [anon_sym_LPAREN] = ACTIONS(243),
    [anon_sym_await] = ACTIONS(246),
    [anon_sym_while] = ACTIONS(249),
    [anon_sym_do] = ACTIONS(252),
    [anon_sym_try] = ACTIONS(255),
    [anon_sym_with] = ACTIONS(258),
    [anon_sym_break] = ACTIONS(261),
    [anon_sym_continue] = ACTIONS(264),
    [anon_sym_debugger] = ACTIONS(267),
    [anon_sym_return] = ACTIONS(270),
    [anon_sym_throw] = ACTIONS(273),
    [anon_sym_SEMI] = ACTIONS(276),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_yield] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(282),
    [anon_sym_LT] = ACTIONS(285),
    [anon_sym_SLASH] = ACTIONS(288),
    [anon_sym_class] = ACTIONS(291),
    [anon_sym_async] = ACTIONS(294),
    [anon_sym_function] = ACTIONS(297),
    [anon_sym_new] = ACTIONS(300),
    [anon_sym_PLUS] = ACTIONS(303),
    [anon_sym_DASH] = ACTIONS(303),
    [anon_sym_TILDE] = ACTIONS(231),
    [anon_sym_void] = ACTIONS(216),
    [anon_sym_delete] = ACTIONS(216),
    [anon_sym_PLUS_PLUS] = ACTIONS(306),
    [anon_sym_DASH_DASH] = ACTIONS(306),
    [anon_sym_DQUOTE] = ACTIONS(309),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(315),
    [sym_number] = ACTIONS(318),
    [sym_this] = ACTIONS(321),
    [sym_super] = ACTIONS(321),
    [sym_true] = ACTIONS(321),
    [sym_false] = ACTIONS(321),
    [sym_null] = ACTIONS(321),
    [sym_undefined] = ACTIONS(321),
    [anon_sym_AT] = ACTIONS(324),
    [anon_sym_static] = ACTIONS(327),
    [anon_sym_abstract] = ACTIONS(330),
    [anon_sym_get] = ACTIONS(327),
    [anon_sym_set] = ACTIONS(327),
    [anon_sym_declare] = ACTIONS(333),
    [anon_sym_public] = ACTIONS(327),
    [anon_sym_private] = ACTIONS(327),
    [anon_sym_protected] = ACTIONS(327),
    [anon_sym_module] = ACTIONS(336),
    [anon_sym_any] = ACTIONS(327),
    [anon_sym_number] = ACTIONS(327),
    [anon_sym_boolean] = ACTIONS(327),
    [anon_sym_string] = ACTIONS(327),
    [anon_sym_symbol] = ACTIONS(327),
    [anon_sym_interface] = ACTIONS(339),
    [anon_sym_enum] = ACTIONS(342),
    [sym_readonly] = ACTIONS(327),
  },
  [8] = {
    [sym_export_statement] = STATE(7),
    [sym__declaration] = STATE(7),
    [sym_import] = STATE(1528),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(572),
    [sym_lexical_declaration] = STATE(572),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(933),
    [sym__expression] = STATE(1345),
    [sym_yield_expression] = STATE(1543),
    [sym_object] = STATE(1367),
    [sym_array] = STATE(1369),
    [sym_class] = STATE(1528),
    [sym_class_declaration] = STATE(572),
    [sym_function] = STATE(1528),
    [sym_function_declaration] = STATE(572),
    [sym_generator_function] = STATE(1528),
    [sym_generator_function_declaration] = STATE(572),
    [sym_arrow_function] = STATE(1528),
    [sym__call_signature] = STATE(3359),
    [sym_call_expression] = STATE(1528),
    [sym_new_expression] = STATE(1543),
    [sym_await_expression] = STATE(1543),
    [sym_member_expression] = STATE(933),
    [sym_subscript_expression] = STATE(933),
    [sym_assignment_expression] = STATE(1543),
    [sym__augmented_assignment_lhs] = STATE(1970),
    [sym_augmented_assignment_expression] = STATE(1543),
    [sym_ternary_expression] = STATE(1543),
    [sym_binary_expression] = STATE(1543),
    [sym_unary_expression] = STATE(1543),
    [sym_update_expression] = STATE(1543),
    [sym_sequence_expression] = STATE(3070),
    [sym_string] = STATE(1528),
    [sym_template_string] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_meta_property] = STATE(1528),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(936),
    [sym_function_signature] = STATE(572),
    [sym_type_assertion] = STATE(1543),
    [sym_as_expression] = STATE(1543),
    [sym_ambient_declaration] = STATE(572),
    [sym_abstract_class_declaration] = STATE(572),
    [sym_module] = STATE(572),
    [sym_internal_module] = STATE(96),
    [sym_import_alias] = STATE(572),
    [sym_interface_declaration] = STATE(572),
    [sym_enum_declaration] = STATE(572),
    [sym_type_alias_declaration] = STATE(572),
    [sym_type_arguments] = STATE(381),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(2307),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_default] = ACTIONS(345),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(347),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(95),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(97),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(99),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
    [sym_readonly] = ACTIONS(93),
  },
  [9] = {
    [sym_export_statement] = STATE(11),
    [sym__declaration] = STATE(11),
    [sym_import] = STATE(1528),
    [sym_import_statement] = STATE(11),
    [sym_expression_statement] = STATE(11),
    [sym_variable_declaration] = STATE(572),
    [sym_lexical_declaration] = STATE(572),
    [sym_statement_block] = STATE(11),
    [sym_if_statement] = STATE(11),
    [sym_switch_statement] = STATE(11),
    [sym_for_statement] = STATE(11),
    [sym_for_in_statement] = STATE(11),
    [sym_while_statement] = STATE(11),
    [sym_do_statement] = STATE(11),
    [sym_try_statement] = STATE(11),
    [sym_with_statement] = STATE(11),
    [sym_break_statement] = STATE(11),
    [sym_continue_statement] = STATE(11),
    [sym_debugger_statement] = STATE(11),
    [sym_return_statement] = STATE(11),
    [sym_throw_statement] = STATE(11),
    [sym_empty_statement] = STATE(11),
    [sym_labeled_statement] = STATE(11),
    [sym_parenthesized_expression] = STATE(933),
    [sym__expression] = STATE(1345),
    [sym_yield_expression] = STATE(1543),
    [sym_object] = STATE(1367),
    [sym_array] = STATE(1369),
    [sym_class] = STATE(1528),
    [sym_class_declaration] = STATE(572),
    [sym_function] = STATE(1528),
    [sym_function_declaration] = STATE(572),
    [sym_generator_function] = STATE(1528),
    [sym_generator_function_declaration] = STATE(572),
    [sym_arrow_function] = STATE(1528),
    [sym__call_signature] = STATE(3359),
    [sym_call_expression] = STATE(1528),
    [sym_new_expression] = STATE(1543),
    [sym_await_expression] = STATE(1543),
    [sym_member_expression] = STATE(933),
    [sym_subscript_expression] = STATE(933),
    [sym_assignment_expression] = STATE(1543),
    [sym__augmented_assignment_lhs] = STATE(1970),
    [sym_augmented_assignment_expression] = STATE(1543),
    [sym_ternary_expression] = STATE(1543),
    [sym_binary_expression] = STATE(1543),
    [sym_unary_expression] = STATE(1543),
    [sym_update_expression] = STATE(1543),
    [sym_sequence_expression] = STATE(3070),
    [sym_string] = STATE(1528),
    [sym_template_string] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_meta_property] = STATE(1528),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(936),
    [sym_function_signature] = STATE(572),
    [sym_type_assertion] = STATE(1543),
    [sym_as_expression] = STATE(1543),
    [sym_ambient_declaration] = STATE(572),
    [sym_abstract_class_declaration] = STATE(572),
    [sym_module] = STATE(572),
    [sym_internal_module] = STATE(96),
    [sym_import_alias] = STATE(572),
    [sym_interface_declaration] = STATE(572),
    [sym_enum_declaration] = STATE(572),
    [sym_type_alias_declaration] = STATE(572),
    [sym_type_arguments] = STATE(381),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_program_repeat1] = STATE(11),
    [aux_sym_export_statement_repeat1] = STATE(2307),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_default] = ACTIONS(349),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(351),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(349),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(95),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(97),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(99),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
    [sym_readonly] = ACTIONS(93),
  },
  [10] = {
    [sym_export_statement] = STATE(8),
    [sym__declaration] = STATE(8),
    [sym_import] = STATE(1528),
    [sym_import_statement] = STATE(8),
    [sym_expression_statement] = STATE(8),
    [sym_variable_declaration] = STATE(572),
    [sym_lexical_declaration] = STATE(572),
    [sym_statement_block] = STATE(8),
    [sym_if_statement] = STATE(8),
    [sym_switch_statement] = STATE(8),
    [sym_for_statement] = STATE(8),
    [sym_for_in_statement] = STATE(8),
    [sym_while_statement] = STATE(8),
    [sym_do_statement] = STATE(8),
    [sym_try_statement] = STATE(8),
    [sym_with_statement] = STATE(8),
    [sym_break_statement] = STATE(8),
    [sym_continue_statement] = STATE(8),
    [sym_debugger_statement] = STATE(8),
    [sym_return_statement] = STATE(8),
    [sym_throw_statement] = STATE(8),
    [sym_empty_statement] = STATE(8),
    [sym_labeled_statement] = STATE(8),
    [sym_parenthesized_expression] = STATE(933),
    [sym__expression] = STATE(1345),
    [sym_yield_expression] = STATE(1543),
    [sym_object] = STATE(1367),
    [sym_array] = STATE(1369),
    [sym_class] = STATE(1528),
    [sym_class_declaration] = STATE(572),
    [sym_function] = STATE(1528),
    [sym_function_declaration] = STATE(572),
    [sym_generator_function] = STATE(1528),
    [sym_generator_function_declaration] = STATE(572),
    [sym_arrow_function] = STATE(1528),
    [sym__call_signature] = STATE(3359),
    [sym_call_expression] = STATE(1528),
    [sym_new_expression] = STATE(1543),
    [sym_await_expression] = STATE(1543),
    [sym_member_expression] = STATE(933),
    [sym_subscript_expression] = STATE(933),
    [sym_assignment_expression] = STATE(1543),
    [sym__augmented_assignment_lhs] = STATE(1970),
    [sym_augmented_assignment_expression] = STATE(1543),
    [sym_ternary_expression] = STATE(1543),
    [sym_binary_expression] = STATE(1543),
    [sym_unary_expression] = STATE(1543),
    [sym_update_expression] = STATE(1543),
    [sym_sequence_expression] = STATE(3070),
    [sym_string] = STATE(1528),
    [sym_template_string] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_meta_property] = STATE(1528),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(936),
    [sym_function_signature] = STATE(572),
    [sym_type_assertion] = STATE(1543),
    [sym_as_expression] = STATE(1543),
    [sym_ambient_declaration] = STATE(572),
    [sym_abstract_class_declaration] = STATE(572),
    [sym_module] = STATE(572),
    [sym_internal_module] = STATE(96),
    [sym_import_alias] = STATE(572),
    [sym_interface_declaration] = STATE(572),
    [sym_enum_declaration] = STATE(572),
    [sym_type_alias_declaration] = STATE(572),
    [sym_type_arguments] = STATE(381),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_program_repeat1] = STATE(8),
    [aux_sym_export_statement_repeat1] = STATE(2307),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_default] = ACTIONS(353),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(355),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(353),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(95),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(97),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(99),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
    [sym_readonly] = ACTIONS(93),
  },
  [11] = {
    [sym_export_statement] = STATE(7),
    [sym__declaration] = STATE(7),
    [sym_import] = STATE(1528),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(572),
    [sym_lexical_declaration] = STATE(572),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(933),
    [sym__expression] = STATE(1345),
    [sym_yield_expression] = STATE(1543),
    [sym_object] = STATE(1367),
    [sym_array] = STATE(1369),
    [sym_class] = STATE(1528),
    [sym_class_declaration] = STATE(572),
    [sym_function] = STATE(1528),
    [sym_function_declaration] = STATE(572),
    [sym_generator_function] = STATE(1528),
    [sym_generator_function_declaration] = STATE(572),
    [sym_arrow_function] = STATE(1528),
    [sym__call_signature] = STATE(3359),
    [sym_call_expression] = STATE(1528),
    [sym_new_expression] = STATE(1543),
    [sym_await_expression] = STATE(1543),
    [sym_member_expression] = STATE(933),
    [sym_subscript_expression] = STATE(933),
    [sym_assignment_expression] = STATE(1543),
    [sym__augmented_assignment_lhs] = STATE(1970),
    [sym_augmented_assignment_expression] = STATE(1543),
    [sym_ternary_expression] = STATE(1543),
    [sym_binary_expression] = STATE(1543),
    [sym_unary_expression] = STATE(1543),
    [sym_update_expression] = STATE(1543),
    [sym_sequence_expression] = STATE(3070),
    [sym_string] = STATE(1528),
    [sym_template_string] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_meta_property] = STATE(1528),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(936),
    [sym_function_signature] = STATE(572),
    [sym_type_assertion] = STATE(1543),
    [sym_as_expression] = STATE(1543),
    [sym_ambient_declaration] = STATE(572),
    [sym_abstract_class_declaration] = STATE(572),
    [sym_module] = STATE(572),
    [sym_internal_module] = STATE(96),
    [sym_import_alias] = STATE(572),
    [sym_interface_declaration] = STATE(572),
    [sym_enum_declaration] = STATE(572),
    [sym_type_alias_declaration] = STATE(572),
    [sym_type_arguments] = STATE(381),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(2307),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_default] = ACTIONS(357),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(359),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(357),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(95),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(97),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(99),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
    [sym_readonly] = ACTIONS(93),
  },
  [12] = {
    [sym_export_statement] = STATE(7),
    [sym__declaration] = STATE(7),
    [sym_import] = STATE(1528),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(572),
    [sym_lexical_declaration] = STATE(572),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(933),
    [sym__expression] = STATE(1345),
    [sym_yield_expression] = STATE(1543),
    [sym_object] = STATE(1367),
    [sym_array] = STATE(1369),
    [sym_class] = STATE(1528),
    [sym_class_declaration] = STATE(572),
    [sym_function] = STATE(1528),
    [sym_function_declaration] = STATE(572),
    [sym_generator_function] = STATE(1528),
    [sym_generator_function_declaration] = STATE(572),
    [sym_arrow_function] = STATE(1528),
    [sym__call_signature] = STATE(3359),
    [sym_call_expression] = STATE(1528),
    [sym_new_expression] = STATE(1543),
    [sym_await_expression] = STATE(1543),
    [sym_member_expression] = STATE(933),
    [sym_subscript_expression] = STATE(933),
    [sym_assignment_expression] = STATE(1543),
    [sym__augmented_assignment_lhs] = STATE(1970),
    [sym_augmented_assignment_expression] = STATE(1543),
    [sym_ternary_expression] = STATE(1543),
    [sym_binary_expression] = STATE(1543),
    [sym_unary_expression] = STATE(1543),
    [sym_update_expression] = STATE(1543),
    [sym_sequence_expression] = STATE(3070),
    [sym_string] = STATE(1528),
    [sym_template_string] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_meta_property] = STATE(1528),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(936),
    [sym_function_signature] = STATE(572),
    [sym_type_assertion] = STATE(1543),
    [sym_as_expression] = STATE(1543),
    [sym_ambient_declaration] = STATE(572),
    [sym_abstract_class_declaration] = STATE(572),
    [sym_module] = STATE(572),
    [sym_internal_module] = STATE(96),
    [sym_import_alias] = STATE(572),
    [sym_interface_declaration] = STATE(572),
    [sym_enum_declaration] = STATE(572),
    [sym_type_alias_declaration] = STATE(572),
    [sym_type_arguments] = STATE(381),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(2307),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(361),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(95),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(97),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(99),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
    [sym_readonly] = ACTIONS(93),
  },
  [13] = {
    [sym_export_statement] = STATE(7),
    [sym__declaration] = STATE(7),
    [sym_import] = STATE(1528),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(572),
    [sym_lexical_declaration] = STATE(572),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(933),
    [sym__expression] = STATE(1345),
    [sym_yield_expression] = STATE(1543),
    [sym_object] = STATE(1367),
    [sym_array] = STATE(1369),
    [sym_class] = STATE(1528),
    [sym_class_declaration] = STATE(572),
    [sym_function] = STATE(1528),
    [sym_function_declaration] = STATE(572),
    [sym_generator_function] = STATE(1528),
    [sym_generator_function_declaration] = STATE(572),
    [sym_arrow_function] = STATE(1528),
    [sym__call_signature] = STATE(3359),
    [sym_call_expression] = STATE(1528),
    [sym_new_expression] = STATE(1543),
    [sym_await_expression] = STATE(1543),
    [sym_member_expression] = STATE(933),
    [sym_subscript_expression] = STATE(933),
    [sym_assignment_expression] = STATE(1543),
    [sym__augmented_assignment_lhs] = STATE(1970),
    [sym_augmented_assignment_expression] = STATE(1543),
    [sym_ternary_expression] = STATE(1543),
    [sym_binary_expression] = STATE(1543),
    [sym_unary_expression] = STATE(1543),
    [sym_update_expression] = STATE(1543),
    [sym_sequence_expression] = STATE(3070),
    [sym_string] = STATE(1528),
    [sym_template_string] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_meta_property] = STATE(1528),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(936),
    [sym_function_signature] = STATE(572),
    [sym_type_assertion] = STATE(1543),
    [sym_as_expression] = STATE(1543),
    [sym_ambient_declaration] = STATE(572),
    [sym_abstract_class_declaration] = STATE(572),
    [sym_module] = STATE(572),
    [sym_internal_module] = STATE(96),
    [sym_import_alias] = STATE(572),
    [sym_interface_declaration] = STATE(572),
    [sym_enum_declaration] = STATE(572),
    [sym_type_alias_declaration] = STATE(572),
    [sym_type_arguments] = STATE(381),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(2307),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(363),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(95),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(97),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(99),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
    [sym_readonly] = ACTIONS(93),
  },
  [14] = {
    [sym_export_statement] = STATE(7),
    [sym__declaration] = STATE(7),
    [sym_import] = STATE(1528),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(572),
    [sym_lexical_declaration] = STATE(572),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(933),
    [sym__expression] = STATE(1345),
    [sym_yield_expression] = STATE(1543),
    [sym_object] = STATE(1367),
    [sym_array] = STATE(1369),
    [sym_class] = STATE(1528),
    [sym_class_declaration] = STATE(572),
    [sym_function] = STATE(1528),
    [sym_function_declaration] = STATE(572),
    [sym_generator_function] = STATE(1528),
    [sym_generator_function_declaration] = STATE(572),
    [sym_arrow_function] = STATE(1528),
    [sym__call_signature] = STATE(3359),
    [sym_call_expression] = STATE(1528),
    [sym_new_expression] = STATE(1543),
    [sym_await_expression] = STATE(1543),
    [sym_member_expression] = STATE(933),
    [sym_subscript_expression] = STATE(933),
    [sym_assignment_expression] = STATE(1543),
    [sym__augmented_assignment_lhs] = STATE(1970),
    [sym_augmented_assignment_expression] = STATE(1543),
    [sym_ternary_expression] = STATE(1543),
    [sym_binary_expression] = STATE(1543),
    [sym_unary_expression] = STATE(1543),
    [sym_update_expression] = STATE(1543),
    [sym_sequence_expression] = STATE(3070),
    [sym_string] = STATE(1528),
    [sym_template_string] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_meta_property] = STATE(1528),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(936),
    [sym_function_signature] = STATE(572),
    [sym_type_assertion] = STATE(1543),
    [sym_as_expression] = STATE(1543),
    [sym_ambient_declaration] = STATE(572),
    [sym_abstract_class_declaration] = STATE(572),
    [sym_module] = STATE(572),
    [sym_internal_module] = STATE(96),
    [sym_import_alias] = STATE(572),
    [sym_interface_declaration] = STATE(572),
    [sym_enum_declaration] = STATE(572),
    [sym_type_alias_declaration] = STATE(572),
    [sym_type_arguments] = STATE(381),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(2307),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(365),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(95),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(97),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(99),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
    [sym_readonly] = ACTIONS(93),
  },
  [15] = {
    [sym_export_statement] = STATE(18),
    [sym__declaration] = STATE(18),
    [sym_import] = STATE(1528),
    [sym_import_statement] = STATE(18),
    [sym_expression_statement] = STATE(18),
    [sym_variable_declaration] = STATE(572),
    [sym_lexical_declaration] = STATE(572),
    [sym_statement_block] = STATE(18),
    [sym_if_statement] = STATE(18),
    [sym_switch_statement] = STATE(18),
    [sym_for_statement] = STATE(18),
    [sym_for_in_statement] = STATE(18),
    [sym_while_statement] = STATE(18),
    [sym_do_statement] = STATE(18),
    [sym_try_statement] = STATE(18),
    [sym_with_statement] = STATE(18),
    [sym_break_statement] = STATE(18),
    [sym_continue_statement] = STATE(18),
    [sym_debugger_statement] = STATE(18),
    [sym_return_statement] = STATE(18),
    [sym_throw_statement] = STATE(18),
    [sym_empty_statement] = STATE(18),
    [sym_labeled_statement] = STATE(18),
    [sym_parenthesized_expression] = STATE(933),
    [sym__expression] = STATE(1345),
    [sym_yield_expression] = STATE(1543),
    [sym_object] = STATE(1367),
    [sym_array] = STATE(1369),
    [sym_class] = STATE(1528),
    [sym_class_declaration] = STATE(572),
    [sym_function] = STATE(1528),
    [sym_function_declaration] = STATE(572),
    [sym_generator_function] = STATE(1528),
    [sym_generator_function_declaration] = STATE(572),
    [sym_arrow_function] = STATE(1528),
    [sym__call_signature] = STATE(3359),
    [sym_call_expression] = STATE(1528),
    [sym_new_expression] = STATE(1543),
    [sym_await_expression] = STATE(1543),
    [sym_member_expression] = STATE(933),
    [sym_subscript_expression] = STATE(933),
    [sym_assignment_expression] = STATE(1543),
    [sym__augmented_assignment_lhs] = STATE(1970),
    [sym_augmented_assignment_expression] = STATE(1543),
    [sym_ternary_expression] = STATE(1543),
    [sym_binary_expression] = STATE(1543),
    [sym_unary_expression] = STATE(1543),
    [sym_update_expression] = STATE(1543),
    [sym_sequence_expression] = STATE(3070),
    [sym_string] = STATE(1528),
    [sym_template_string] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_meta_property] = STATE(1528),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(936),
    [sym_function_signature] = STATE(572),
    [sym_type_assertion] = STATE(1543),
    [sym_as_expression] = STATE(1543),
    [sym_ambient_declaration] = STATE(572),
    [sym_abstract_class_declaration] = STATE(572),
    [sym_module] = STATE(572),
    [sym_internal_module] = STATE(96),
    [sym_import_alias] = STATE(572),
    [sym_interface_declaration] = STATE(572),
    [sym_enum_declaration] = STATE(572),
    [sym_type_alias_declaration] = STATE(572),
    [sym_type_arguments] = STATE(381),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_program_repeat1] = STATE(18),
    [aux_sym_export_statement_repeat1] = STATE(2307),
    [ts_builtin_sym_end] = ACTIONS(367),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(95),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(97),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(99),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
    [sym_readonly] = ACTIONS(93),
  },
  [16] = {
    [sym_export_statement] = STATE(13),
    [sym__declaration] = STATE(13),
    [sym_import] = STATE(1528),
    [sym_import_statement] = STATE(13),
    [sym_expression_statement] = STATE(13),
    [sym_variable_declaration] = STATE(572),
    [sym_lexical_declaration] = STATE(572),
    [sym_statement_block] = STATE(13),
    [sym_if_statement] = STATE(13),
    [sym_switch_statement] = STATE(13),
    [sym_for_statement] = STATE(13),
    [sym_for_in_statement] = STATE(13),
    [sym_while_statement] = STATE(13),
    [sym_do_statement] = STATE(13),
    [sym_try_statement] = STATE(13),
    [sym_with_statement] = STATE(13),
    [sym_break_statement] = STATE(13),
    [sym_continue_statement] = STATE(13),
    [sym_debugger_statement] = STATE(13),
    [sym_return_statement] = STATE(13),
    [sym_throw_statement] = STATE(13),
    [sym_empty_statement] = STATE(13),
    [sym_labeled_statement] = STATE(13),
    [sym_parenthesized_expression] = STATE(933),
    [sym__expression] = STATE(1345),
    [sym_yield_expression] = STATE(1543),
    [sym_object] = STATE(1367),
    [sym_array] = STATE(1369),
    [sym_class] = STATE(1528),
    [sym_class_declaration] = STATE(572),
    [sym_function] = STATE(1528),
    [sym_function_declaration] = STATE(572),
    [sym_generator_function] = STATE(1528),
    [sym_generator_function_declaration] = STATE(572),
    [sym_arrow_function] = STATE(1528),
    [sym__call_signature] = STATE(3359),
    [sym_call_expression] = STATE(1528),
    [sym_new_expression] = STATE(1543),
    [sym_await_expression] = STATE(1543),
    [sym_member_expression] = STATE(933),
    [sym_subscript_expression] = STATE(933),
    [sym_assignment_expression] = STATE(1543),
    [sym__augmented_assignment_lhs] = STATE(1970),
    [sym_augmented_assignment_expression] = STATE(1543),
    [sym_ternary_expression] = STATE(1543),
    [sym_binary_expression] = STATE(1543),
    [sym_unary_expression] = STATE(1543),
    [sym_update_expression] = STATE(1543),
    [sym_sequence_expression] = STATE(3070),
    [sym_string] = STATE(1528),
    [sym_template_string] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_meta_property] = STATE(1528),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(936),
    [sym_function_signature] = STATE(572),
    [sym_type_assertion] = STATE(1543),
    [sym_as_expression] = STATE(1543),
    [sym_ambient_declaration] = STATE(572),
    [sym_abstract_class_declaration] = STATE(572),
    [sym_module] = STATE(572),
    [sym_internal_module] = STATE(96),
    [sym_import_alias] = STATE(572),
    [sym_interface_declaration] = STATE(572),
    [sym_enum_declaration] = STATE(572),
    [sym_type_alias_declaration] = STATE(572),
    [sym_type_arguments] = STATE(381),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_program_repeat1] = STATE(13),
    [aux_sym_export_statement_repeat1] = STATE(2307),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(369),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(95),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(97),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(99),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
    [sym_readonly] = ACTIONS(93),
  },
  [17] = {
    [sym_export_statement] = STATE(7),
    [sym__declaration] = STATE(7),
    [sym_import] = STATE(1528),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(572),
    [sym_lexical_declaration] = STATE(572),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(933),
    [sym__expression] = STATE(1345),
    [sym_yield_expression] = STATE(1543),
    [sym_object] = STATE(1367),
    [sym_array] = STATE(1369),
    [sym_class] = STATE(1528),
    [sym_class_declaration] = STATE(572),
    [sym_function] = STATE(1528),
    [sym_function_declaration] = STATE(572),
    [sym_generator_function] = STATE(1528),
    [sym_generator_function_declaration] = STATE(572),
    [sym_arrow_function] = STATE(1528),
    [sym__call_signature] = STATE(3359),
    [sym_call_expression] = STATE(1528),
    [sym_new_expression] = STATE(1543),
    [sym_await_expression] = STATE(1543),
    [sym_member_expression] = STATE(933),
    [sym_subscript_expression] = STATE(933),
    [sym_assignment_expression] = STATE(1543),
    [sym__augmented_assignment_lhs] = STATE(1970),
    [sym_augmented_assignment_expression] = STATE(1543),
    [sym_ternary_expression] = STATE(1543),
    [sym_binary_expression] = STATE(1543),
    [sym_unary_expression] = STATE(1543),
    [sym_update_expression] = STATE(1543),
    [sym_sequence_expression] = STATE(3070),
    [sym_string] = STATE(1528),
    [sym_template_string] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_meta_property] = STATE(1528),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(936),
    [sym_function_signature] = STATE(572),
    [sym_type_assertion] = STATE(1543),
    [sym_as_expression] = STATE(1543),
    [sym_ambient_declaration] = STATE(572),
    [sym_abstract_class_declaration] = STATE(572),
    [sym_module] = STATE(572),
    [sym_internal_module] = STATE(96),
    [sym_import_alias] = STATE(572),
    [sym_interface_declaration] = STATE(572),
    [sym_enum_declaration] = STATE(572),
    [sym_type_alias_declaration] = STATE(572),
    [sym_type_arguments] = STATE(381),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(2307),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(371),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(95),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(97),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(99),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
    [sym_readonly] = ACTIONS(93),
  },
  [18] = {
    [sym_export_statement] = STATE(7),
    [sym__declaration] = STATE(7),
    [sym_import] = STATE(1528),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(572),
    [sym_lexical_declaration] = STATE(572),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(933),
    [sym__expression] = STATE(1345),
    [sym_yield_expression] = STATE(1543),
    [sym_object] = STATE(1367),
    [sym_array] = STATE(1369),
    [sym_class] = STATE(1528),
    [sym_class_declaration] = STATE(572),
    [sym_function] = STATE(1528),
    [sym_function_declaration] = STATE(572),
    [sym_generator_function] = STATE(1528),
    [sym_generator_function_declaration] = STATE(572),
    [sym_arrow_function] = STATE(1528),
    [sym__call_signature] = STATE(3359),
    [sym_call_expression] = STATE(1528),
    [sym_new_expression] = STATE(1543),
    [sym_await_expression] = STATE(1543),
    [sym_member_expression] = STATE(933),
    [sym_subscript_expression] = STATE(933),
    [sym_assignment_expression] = STATE(1543),
    [sym__augmented_assignment_lhs] = STATE(1970),
    [sym_augmented_assignment_expression] = STATE(1543),
    [sym_ternary_expression] = STATE(1543),
    [sym_binary_expression] = STATE(1543),
    [sym_unary_expression] = STATE(1543),
    [sym_update_expression] = STATE(1543),
    [sym_sequence_expression] = STATE(3070),
    [sym_string] = STATE(1528),
    [sym_template_string] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_meta_property] = STATE(1528),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(936),
    [sym_function_signature] = STATE(572),
    [sym_type_assertion] = STATE(1543),
    [sym_as_expression] = STATE(1543),
    [sym_ambient_declaration] = STATE(572),
    [sym_abstract_class_declaration] = STATE(572),
    [sym_module] = STATE(572),
    [sym_internal_module] = STATE(96),
    [sym_import_alias] = STATE(572),
    [sym_interface_declaration] = STATE(572),
    [sym_enum_declaration] = STATE(572),
    [sym_type_alias_declaration] = STATE(572),
    [sym_type_arguments] = STATE(381),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(2307),
    [ts_builtin_sym_end] = ACTIONS(373),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(95),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(97),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(99),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
    [sym_readonly] = ACTIONS(93),
  },
  [19] = {
    [sym_export_statement] = STATE(7),
    [sym__declaration] = STATE(7),
    [sym_import] = STATE(1528),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(572),
    [sym_lexical_declaration] = STATE(572),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(933),
    [sym__expression] = STATE(1345),
    [sym_yield_expression] = STATE(1543),
    [sym_object] = STATE(1367),
    [sym_array] = STATE(1369),
    [sym_class] = STATE(1528),
    [sym_class_declaration] = STATE(572),
    [sym_function] = STATE(1528),
    [sym_function_declaration] = STATE(572),
    [sym_generator_function] = STATE(1528),
    [sym_generator_function_declaration] = STATE(572),
    [sym_arrow_function] = STATE(1528),
    [sym__call_signature] = STATE(3359),
    [sym_call_expression] = STATE(1528),
    [sym_new_expression] = STATE(1543),
    [sym_await_expression] = STATE(1543),
    [sym_member_expression] = STATE(933),
    [sym_subscript_expression] = STATE(933),
    [sym_assignment_expression] = STATE(1543),
    [sym__augmented_assignment_lhs] = STATE(1970),
    [sym_augmented_assignment_expression] = STATE(1543),
    [sym_ternary_expression] = STATE(1543),
    [sym_binary_expression] = STATE(1543),
    [sym_unary_expression] = STATE(1543),
    [sym_update_expression] = STATE(1543),
    [sym_sequence_expression] = STATE(3070),
    [sym_string] = STATE(1528),
    [sym_template_string] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_meta_property] = STATE(1528),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(936),
    [sym_function_signature] = STATE(572),
    [sym_type_assertion] = STATE(1543),
    [sym_as_expression] = STATE(1543),
    [sym_ambient_declaration] = STATE(572),
    [sym_abstract_class_declaration] = STATE(572),
    [sym_module] = STATE(572),
    [sym_internal_module] = STATE(96),
    [sym_import_alias] = STATE(572),
    [sym_interface_declaration] = STATE(572),
    [sym_enum_declaration] = STATE(572),
    [sym_type_alias_declaration] = STATE(572),
    [sym_type_arguments] = STATE(381),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(2307),
    [ts_builtin_sym_end] = ACTIONS(367),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(95),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(97),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(99),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
    [sym_readonly] = ACTIONS(93),
  },
  [20] = {
    [sym_export_statement] = STATE(14),
    [sym__declaration] = STATE(14),
    [sym_import] = STATE(1528),
    [sym_import_statement] = STATE(14),
    [sym_expression_statement] = STATE(14),
    [sym_variable_declaration] = STATE(572),
    [sym_lexical_declaration] = STATE(572),
    [sym_statement_block] = STATE(14),
    [sym_if_statement] = STATE(14),
    [sym_switch_statement] = STATE(14),
    [sym_for_statement] = STATE(14),
    [sym_for_in_statement] = STATE(14),
    [sym_while_statement] = STATE(14),
    [sym_do_statement] = STATE(14),
    [sym_try_statement] = STATE(14),
    [sym_with_statement] = STATE(14),
    [sym_break_statement] = STATE(14),
    [sym_continue_statement] = STATE(14),
    [sym_debugger_statement] = STATE(14),
    [sym_return_statement] = STATE(14),
    [sym_throw_statement] = STATE(14),
    [sym_empty_statement] = STATE(14),
    [sym_labeled_statement] = STATE(14),
    [sym_parenthesized_expression] = STATE(933),
    [sym__expression] = STATE(1345),
    [sym_yield_expression] = STATE(1543),
    [sym_object] = STATE(1367),
    [sym_array] = STATE(1369),
    [sym_class] = STATE(1528),
    [sym_class_declaration] = STATE(572),
    [sym_function] = STATE(1528),
    [sym_function_declaration] = STATE(572),
    [sym_generator_function] = STATE(1528),
    [sym_generator_function_declaration] = STATE(572),
    [sym_arrow_function] = STATE(1528),
    [sym__call_signature] = STATE(3359),
    [sym_call_expression] = STATE(1528),
    [sym_new_expression] = STATE(1543),
    [sym_await_expression] = STATE(1543),
    [sym_member_expression] = STATE(933),
    [sym_subscript_expression] = STATE(933),
    [sym_assignment_expression] = STATE(1543),
    [sym__augmented_assignment_lhs] = STATE(1970),
    [sym_augmented_assignment_expression] = STATE(1543),
    [sym_ternary_expression] = STATE(1543),
    [sym_binary_expression] = STATE(1543),
    [sym_unary_expression] = STATE(1543),
    [sym_update_expression] = STATE(1543),
    [sym_sequence_expression] = STATE(3070),
    [sym_string] = STATE(1528),
    [sym_template_string] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_meta_property] = STATE(1528),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(936),
    [sym_function_signature] = STATE(572),
    [sym_type_assertion] = STATE(1543),
    [sym_as_expression] = STATE(1543),
    [sym_ambient_declaration] = STATE(572),
    [sym_abstract_class_declaration] = STATE(572),
    [sym_module] = STATE(572),
    [sym_internal_module] = STATE(96),
    [sym_import_alias] = STATE(572),
    [sym_interface_declaration] = STATE(572),
    [sym_enum_declaration] = STATE(572),
    [sym_type_alias_declaration] = STATE(572),
    [sym_type_arguments] = STATE(381),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_program_repeat1] = STATE(14),
    [aux_sym_export_statement_repeat1] = STATE(2307),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(375),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(95),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(97),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(99),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
    [sym_readonly] = ACTIONS(93),
  },
  [21] = {
    [sym_export_statement] = STATE(25),
    [sym__declaration] = STATE(25),
    [sym_import] = STATE(1528),
    [sym_import_statement] = STATE(25),
    [sym_expression_statement] = STATE(25),
    [sym_variable_declaration] = STATE(572),
    [sym_lexical_declaration] = STATE(572),
    [sym_statement_block] = STATE(25),
    [sym_if_statement] = STATE(25),
    [sym_switch_statement] = STATE(25),
    [sym_for_statement] = STATE(25),
    [sym_for_in_statement] = STATE(25),
    [sym_while_statement] = STATE(25),
    [sym_do_statement] = STATE(25),
    [sym_try_statement] = STATE(25),
    [sym_with_statement] = STATE(25),
    [sym_break_statement] = STATE(25),
    [sym_continue_statement] = STATE(25),
    [sym_debugger_statement] = STATE(25),
    [sym_return_statement] = STATE(25),
    [sym_throw_statement] = STATE(25),
    [sym_empty_statement] = STATE(25),
    [sym_labeled_statement] = STATE(25),
    [sym_parenthesized_expression] = STATE(933),
    [sym__expression] = STATE(1345),
    [sym_yield_expression] = STATE(1543),
    [sym_object] = STATE(1367),
    [sym_array] = STATE(1369),
    [sym_class] = STATE(1528),
    [sym_class_declaration] = STATE(572),
    [sym_function] = STATE(1528),
    [sym_function_declaration] = STATE(572),
    [sym_generator_function] = STATE(1528),
    [sym_generator_function_declaration] = STATE(572),
    [sym_arrow_function] = STATE(1528),
    [sym__call_signature] = STATE(3359),
    [sym_call_expression] = STATE(1528),
    [sym_new_expression] = STATE(1543),
    [sym_await_expression] = STATE(1543),
    [sym_member_expression] = STATE(933),
    [sym_subscript_expression] = STATE(933),
    [sym_assignment_expression] = STATE(1543),
    [sym__augmented_assignment_lhs] = STATE(1970),
    [sym_augmented_assignment_expression] = STATE(1543),
    [sym_ternary_expression] = STATE(1543),
    [sym_binary_expression] = STATE(1543),
    [sym_unary_expression] = STATE(1543),
    [sym_update_expression] = STATE(1543),
    [sym_sequence_expression] = STATE(3070),
    [sym_string] = STATE(1528),
    [sym_template_string] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_meta_property] = STATE(1528),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(936),
    [sym_function_signature] = STATE(572),
    [sym_type_assertion] = STATE(1543),
    [sym_as_expression] = STATE(1543),
    [sym_ambient_declaration] = STATE(572),
    [sym_abstract_class_declaration] = STATE(572),
    [sym_module] = STATE(572),
    [sym_internal_module] = STATE(96),
    [sym_import_alias] = STATE(572),
    [sym_interface_declaration] = STATE(572),
    [sym_enum_declaration] = STATE(572),
    [sym_type_alias_declaration] = STATE(572),
    [sym_type_arguments] = STATE(381),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_program_repeat1] = STATE(25),
    [aux_sym_export_statement_repeat1] = STATE(2307),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(377),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(95),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(97),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(99),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
    [sym_readonly] = ACTIONS(93),
  },
  [22] = {
    [sym_export_statement] = STATE(27),
    [sym__declaration] = STATE(27),
    [sym_import] = STATE(1528),
    [sym_import_statement] = STATE(27),
    [sym_expression_statement] = STATE(27),
    [sym_variable_declaration] = STATE(572),
    [sym_lexical_declaration] = STATE(572),
    [sym_statement_block] = STATE(27),
    [sym_if_statement] = STATE(27),
    [sym_switch_statement] = STATE(27),
    [sym_for_statement] = STATE(27),
    [sym_for_in_statement] = STATE(27),
    [sym_while_statement] = STATE(27),
    [sym_do_statement] = STATE(27),
    [sym_try_statement] = STATE(27),
    [sym_with_statement] = STATE(27),
    [sym_break_statement] = STATE(27),
    [sym_continue_statement] = STATE(27),
    [sym_debugger_statement] = STATE(27),
    [sym_return_statement] = STATE(27),
    [sym_throw_statement] = STATE(27),
    [sym_empty_statement] = STATE(27),
    [sym_labeled_statement] = STATE(27),
    [sym_parenthesized_expression] = STATE(933),
    [sym__expression] = STATE(1345),
    [sym_yield_expression] = STATE(1543),
    [sym_object] = STATE(1367),
    [sym_array] = STATE(1369),
    [sym_class] = STATE(1528),
    [sym_class_declaration] = STATE(572),
    [sym_function] = STATE(1528),
    [sym_function_declaration] = STATE(572),
    [sym_generator_function] = STATE(1528),
    [sym_generator_function_declaration] = STATE(572),
    [sym_arrow_function] = STATE(1528),
    [sym__call_signature] = STATE(3359),
    [sym_call_expression] = STATE(1528),
    [sym_new_expression] = STATE(1543),
    [sym_await_expression] = STATE(1543),
    [sym_member_expression] = STATE(933),
    [sym_subscript_expression] = STATE(933),
    [sym_assignment_expression] = STATE(1543),
    [sym__augmented_assignment_lhs] = STATE(1970),
    [sym_augmented_assignment_expression] = STATE(1543),
    [sym_ternary_expression] = STATE(1543),
    [sym_binary_expression] = STATE(1543),
    [sym_unary_expression] = STATE(1543),
    [sym_update_expression] = STATE(1543),
    [sym_sequence_expression] = STATE(3070),
    [sym_string] = STATE(1528),
    [sym_template_string] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_meta_property] = STATE(1528),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(936),
    [sym_function_signature] = STATE(572),
    [sym_type_assertion] = STATE(1543),
    [sym_as_expression] = STATE(1543),
    [sym_ambient_declaration] = STATE(572),
    [sym_abstract_class_declaration] = STATE(572),
    [sym_module] = STATE(572),
    [sym_internal_module] = STATE(96),
    [sym_import_alias] = STATE(572),
    [sym_interface_declaration] = STATE(572),
    [sym_enum_declaration] = STATE(572),
    [sym_type_alias_declaration] = STATE(572),
    [sym_type_arguments] = STATE(381),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_program_repeat1] = STATE(27),
    [aux_sym_export_statement_repeat1] = STATE(2307),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(379),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(95),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(97),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(99),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
    [sym_readonly] = ACTIONS(93),
  },
  [23] = {
    [sym_export_statement] = STATE(24),
    [sym__declaration] = STATE(24),
    [sym_import] = STATE(1528),
    [sym_import_statement] = STATE(24),
    [sym_expression_statement] = STATE(24),
    [sym_variable_declaration] = STATE(572),
    [sym_lexical_declaration] = STATE(572),
    [sym_statement_block] = STATE(24),
    [sym_if_statement] = STATE(24),
    [sym_switch_statement] = STATE(24),
    [sym_for_statement] = STATE(24),
    [sym_for_in_statement] = STATE(24),
    [sym_while_statement] = STATE(24),
    [sym_do_statement] = STATE(24),
    [sym_try_statement] = STATE(24),
    [sym_with_statement] = STATE(24),
    [sym_break_statement] = STATE(24),
    [sym_continue_statement] = STATE(24),
    [sym_debugger_statement] = STATE(24),
    [sym_return_statement] = STATE(24),
    [sym_throw_statement] = STATE(24),
    [sym_empty_statement] = STATE(24),
    [sym_labeled_statement] = STATE(24),
    [sym_parenthesized_expression] = STATE(933),
    [sym__expression] = STATE(1345),
    [sym_yield_expression] = STATE(1543),
    [sym_object] = STATE(1367),
    [sym_array] = STATE(1369),
    [sym_class] = STATE(1528),
    [sym_class_declaration] = STATE(572),
    [sym_function] = STATE(1528),
    [sym_function_declaration] = STATE(572),
    [sym_generator_function] = STATE(1528),
    [sym_generator_function_declaration] = STATE(572),
    [sym_arrow_function] = STATE(1528),
    [sym__call_signature] = STATE(3359),
    [sym_call_expression] = STATE(1528),
    [sym_new_expression] = STATE(1543),
    [sym_await_expression] = STATE(1543),
    [sym_member_expression] = STATE(933),
    [sym_subscript_expression] = STATE(933),
    [sym_assignment_expression] = STATE(1543),
    [sym__augmented_assignment_lhs] = STATE(1970),
    [sym_augmented_assignment_expression] = STATE(1543),
    [sym_ternary_expression] = STATE(1543),
    [sym_binary_expression] = STATE(1543),
    [sym_unary_expression] = STATE(1543),
    [sym_update_expression] = STATE(1543),
    [sym_sequence_expression] = STATE(3070),
    [sym_string] = STATE(1528),
    [sym_template_string] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_meta_property] = STATE(1528),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(936),
    [sym_function_signature] = STATE(572),
    [sym_type_assertion] = STATE(1543),
    [sym_as_expression] = STATE(1543),
    [sym_ambient_declaration] = STATE(572),
    [sym_abstract_class_declaration] = STATE(572),
    [sym_module] = STATE(572),
    [sym_internal_module] = STATE(96),
    [sym_import_alias] = STATE(572),
    [sym_interface_declaration] = STATE(572),
    [sym_enum_declaration] = STATE(572),
    [sym_type_alias_declaration] = STATE(572),
    [sym_type_arguments] = STATE(381),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_program_repeat1] = STATE(24),
    [aux_sym_export_statement_repeat1] = STATE(2307),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(381),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(95),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(97),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(99),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
    [sym_readonly] = ACTIONS(93),
  },
  [24] = {
    [sym_export_statement] = STATE(7),
    [sym__declaration] = STATE(7),
    [sym_import] = STATE(1528),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(572),
    [sym_lexical_declaration] = STATE(572),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(933),
    [sym__expression] = STATE(1345),
    [sym_yield_expression] = STATE(1543),
    [sym_object] = STATE(1367),
    [sym_array] = STATE(1369),
    [sym_class] = STATE(1528),
    [sym_class_declaration] = STATE(572),
    [sym_function] = STATE(1528),
    [sym_function_declaration] = STATE(572),
    [sym_generator_function] = STATE(1528),
    [sym_generator_function_declaration] = STATE(572),
    [sym_arrow_function] = STATE(1528),
    [sym__call_signature] = STATE(3359),
    [sym_call_expression] = STATE(1528),
    [sym_new_expression] = STATE(1543),
    [sym_await_expression] = STATE(1543),
    [sym_member_expression] = STATE(933),
    [sym_subscript_expression] = STATE(933),
    [sym_assignment_expression] = STATE(1543),
    [sym__augmented_assignment_lhs] = STATE(1970),
    [sym_augmented_assignment_expression] = STATE(1543),
    [sym_ternary_expression] = STATE(1543),
    [sym_binary_expression] = STATE(1543),
    [sym_unary_expression] = STATE(1543),
    [sym_update_expression] = STATE(1543),
    [sym_sequence_expression] = STATE(3070),
    [sym_string] = STATE(1528),
    [sym_template_string] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_meta_property] = STATE(1528),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(936),
    [sym_function_signature] = STATE(572),
    [sym_type_assertion] = STATE(1543),
    [sym_as_expression] = STATE(1543),
    [sym_ambient_declaration] = STATE(572),
    [sym_abstract_class_declaration] = STATE(572),
    [sym_module] = STATE(572),
    [sym_internal_module] = STATE(96),
    [sym_import_alias] = STATE(572),
    [sym_interface_declaration] = STATE(572),
    [sym_enum_declaration] = STATE(572),
    [sym_type_alias_declaration] = STATE(572),
    [sym_type_arguments] = STATE(381),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(2307),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(383),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(95),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(97),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(99),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
    [sym_readonly] = ACTIONS(93),
  },
  [25] = {
    [sym_export_statement] = STATE(7),
    [sym__declaration] = STATE(7),
    [sym_import] = STATE(1528),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(572),
    [sym_lexical_declaration] = STATE(572),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(933),
    [sym__expression] = STATE(1345),
    [sym_yield_expression] = STATE(1543),
    [sym_object] = STATE(1367),
    [sym_array] = STATE(1369),
    [sym_class] = STATE(1528),
    [sym_class_declaration] = STATE(572),
    [sym_function] = STATE(1528),
    [sym_function_declaration] = STATE(572),
    [sym_generator_function] = STATE(1528),
    [sym_generator_function_declaration] = STATE(572),
    [sym_arrow_function] = STATE(1528),
    [sym__call_signature] = STATE(3359),
    [sym_call_expression] = STATE(1528),
    [sym_new_expression] = STATE(1543),
    [sym_await_expression] = STATE(1543),
    [sym_member_expression] = STATE(933),
    [sym_subscript_expression] = STATE(933),
    [sym_assignment_expression] = STATE(1543),
    [sym__augmented_assignment_lhs] = STATE(1970),
    [sym_augmented_assignment_expression] = STATE(1543),
    [sym_ternary_expression] = STATE(1543),
    [sym_binary_expression] = STATE(1543),
    [sym_unary_expression] = STATE(1543),
    [sym_update_expression] = STATE(1543),
    [sym_sequence_expression] = STATE(3070),
    [sym_string] = STATE(1528),
    [sym_template_string] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_meta_property] = STATE(1528),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(936),
    [sym_function_signature] = STATE(572),
    [sym_type_assertion] = STATE(1543),
    [sym_as_expression] = STATE(1543),
    [sym_ambient_declaration] = STATE(572),
    [sym_abstract_class_declaration] = STATE(572),
    [sym_module] = STATE(572),
    [sym_internal_module] = STATE(96),
    [sym_import_alias] = STATE(572),
    [sym_interface_declaration] = STATE(572),
    [sym_enum_declaration] = STATE(572),
    [sym_type_alias_declaration] = STATE(572),
    [sym_type_arguments] = STATE(381),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(2307),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(385),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(95),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(97),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(99),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
    [sym_readonly] = ACTIONS(93),
  },
  [26] = {
    [sym_export_statement] = STATE(12),
    [sym__declaration] = STATE(12),
    [sym_import] = STATE(1528),
    [sym_import_statement] = STATE(12),
    [sym_expression_statement] = STATE(12),
    [sym_variable_declaration] = STATE(572),
    [sym_lexical_declaration] = STATE(572),
    [sym_statement_block] = STATE(12),
    [sym_if_statement] = STATE(12),
    [sym_switch_statement] = STATE(12),
    [sym_for_statement] = STATE(12),
    [sym_for_in_statement] = STATE(12),
    [sym_while_statement] = STATE(12),
    [sym_do_statement] = STATE(12),
    [sym_try_statement] = STATE(12),
    [sym_with_statement] = STATE(12),
    [sym_break_statement] = STATE(12),
    [sym_continue_statement] = STATE(12),
    [sym_debugger_statement] = STATE(12),
    [sym_return_statement] = STATE(12),
    [sym_throw_statement] = STATE(12),
    [sym_empty_statement] = STATE(12),
    [sym_labeled_statement] = STATE(12),
    [sym_parenthesized_expression] = STATE(933),
    [sym__expression] = STATE(1345),
    [sym_yield_expression] = STATE(1543),
    [sym_object] = STATE(1367),
    [sym_array] = STATE(1369),
    [sym_class] = STATE(1528),
    [sym_class_declaration] = STATE(572),
    [sym_function] = STATE(1528),
    [sym_function_declaration] = STATE(572),
    [sym_generator_function] = STATE(1528),
    [sym_generator_function_declaration] = STATE(572),
    [sym_arrow_function] = STATE(1528),
    [sym__call_signature] = STATE(3359),
    [sym_call_expression] = STATE(1528),
    [sym_new_expression] = STATE(1543),
    [sym_await_expression] = STATE(1543),
    [sym_member_expression] = STATE(933),
    [sym_subscript_expression] = STATE(933),
    [sym_assignment_expression] = STATE(1543),
    [sym__augmented_assignment_lhs] = STATE(1970),
    [sym_augmented_assignment_expression] = STATE(1543),
    [sym_ternary_expression] = STATE(1543),
    [sym_binary_expression] = STATE(1543),
    [sym_unary_expression] = STATE(1543),
    [sym_update_expression] = STATE(1543),
    [sym_sequence_expression] = STATE(3070),
    [sym_string] = STATE(1528),
    [sym_template_string] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_meta_property] = STATE(1528),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(936),
    [sym_function_signature] = STATE(572),
    [sym_type_assertion] = STATE(1543),
    [sym_as_expression] = STATE(1543),
    [sym_ambient_declaration] = STATE(572),
    [sym_abstract_class_declaration] = STATE(572),
    [sym_module] = STATE(572),
    [sym_internal_module] = STATE(96),
    [sym_import_alias] = STATE(572),
    [sym_interface_declaration] = STATE(572),
    [sym_enum_declaration] = STATE(572),
    [sym_type_alias_declaration] = STATE(572),
    [sym_type_arguments] = STATE(381),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_program_repeat1] = STATE(12),
    [aux_sym_export_statement_repeat1] = STATE(2307),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(387),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(95),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(97),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(99),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
    [sym_readonly] = ACTIONS(93),
  },
  [27] = {
    [sym_export_statement] = STATE(7),
    [sym__declaration] = STATE(7),
    [sym_import] = STATE(1528),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(572),
    [sym_lexical_declaration] = STATE(572),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(933),
    [sym__expression] = STATE(1345),
    [sym_yield_expression] = STATE(1543),
    [sym_object] = STATE(1367),
    [sym_array] = STATE(1369),
    [sym_class] = STATE(1528),
    [sym_class_declaration] = STATE(572),
    [sym_function] = STATE(1528),
    [sym_function_declaration] = STATE(572),
    [sym_generator_function] = STATE(1528),
    [sym_generator_function_declaration] = STATE(572),
    [sym_arrow_function] = STATE(1528),
    [sym__call_signature] = STATE(3359),
    [sym_call_expression] = STATE(1528),
    [sym_new_expression] = STATE(1543),
    [sym_await_expression] = STATE(1543),
    [sym_member_expression] = STATE(933),
    [sym_subscript_expression] = STATE(933),
    [sym_assignment_expression] = STATE(1543),
    [sym__augmented_assignment_lhs] = STATE(1970),
    [sym_augmented_assignment_expression] = STATE(1543),
    [sym_ternary_expression] = STATE(1543),
    [sym_binary_expression] = STATE(1543),
    [sym_unary_expression] = STATE(1543),
    [sym_update_expression] = STATE(1543),
    [sym_sequence_expression] = STATE(3070),
    [sym_string] = STATE(1528),
    [sym_template_string] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_meta_property] = STATE(1528),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(936),
    [sym_function_signature] = STATE(572),
    [sym_type_assertion] = STATE(1543),
    [sym_as_expression] = STATE(1543),
    [sym_ambient_declaration] = STATE(572),
    [sym_abstract_class_declaration] = STATE(572),
    [sym_module] = STATE(572),
    [sym_internal_module] = STATE(96),
    [sym_import_alias] = STATE(572),
    [sym_interface_declaration] = STATE(572),
    [sym_enum_declaration] = STATE(572),
    [sym_type_alias_declaration] = STATE(572),
    [sym_type_arguments] = STATE(381),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(2307),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(389),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(95),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(97),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(99),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
    [sym_readonly] = ACTIONS(93),
  },
  [28] = {
    [sym_export_statement] = STATE(17),
    [sym__declaration] = STATE(17),
    [sym_import] = STATE(1528),
    [sym_import_statement] = STATE(17),
    [sym_expression_statement] = STATE(17),
    [sym_variable_declaration] = STATE(572),
    [sym_lexical_declaration] = STATE(572),
    [sym_statement_block] = STATE(17),
    [sym_if_statement] = STATE(17),
    [sym_switch_statement] = STATE(17),
    [sym_for_statement] = STATE(17),
    [sym_for_in_statement] = STATE(17),
    [sym_while_statement] = STATE(17),
    [sym_do_statement] = STATE(17),
    [sym_try_statement] = STATE(17),
    [sym_with_statement] = STATE(17),
    [sym_break_statement] = STATE(17),
    [sym_continue_statement] = STATE(17),
    [sym_debugger_statement] = STATE(17),
    [sym_return_statement] = STATE(17),
    [sym_throw_statement] = STATE(17),
    [sym_empty_statement] = STATE(17),
    [sym_labeled_statement] = STATE(17),
    [sym_parenthesized_expression] = STATE(933),
    [sym__expression] = STATE(1345),
    [sym_yield_expression] = STATE(1543),
    [sym_object] = STATE(1367),
    [sym_array] = STATE(1369),
    [sym_class] = STATE(1528),
    [sym_class_declaration] = STATE(572),
    [sym_function] = STATE(1528),
    [sym_function_declaration] = STATE(572),
    [sym_generator_function] = STATE(1528),
    [sym_generator_function_declaration] = STATE(572),
    [sym_arrow_function] = STATE(1528),
    [sym__call_signature] = STATE(3359),
    [sym_call_expression] = STATE(1528),
    [sym_new_expression] = STATE(1543),
    [sym_await_expression] = STATE(1543),
    [sym_member_expression] = STATE(933),
    [sym_subscript_expression] = STATE(933),
    [sym_assignment_expression] = STATE(1543),
    [sym__augmented_assignment_lhs] = STATE(1970),
    [sym_augmented_assignment_expression] = STATE(1543),
    [sym_ternary_expression] = STATE(1543),
    [sym_binary_expression] = STATE(1543),
    [sym_unary_expression] = STATE(1543),
    [sym_update_expression] = STATE(1543),
    [sym_sequence_expression] = STATE(3070),
    [sym_string] = STATE(1528),
    [sym_template_string] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_meta_property] = STATE(1528),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(936),
    [sym_function_signature] = STATE(572),
    [sym_type_assertion] = STATE(1543),
    [sym_as_expression] = STATE(1543),
    [sym_ambient_declaration] = STATE(572),
    [sym_abstract_class_declaration] = STATE(572),
    [sym_module] = STATE(572),
    [sym_internal_module] = STATE(96),
    [sym_import_alias] = STATE(572),
    [sym_interface_declaration] = STATE(572),
    [sym_enum_declaration] = STATE(572),
    [sym_type_alias_declaration] = STATE(572),
    [sym_type_arguments] = STATE(381),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_program_repeat1] = STATE(17),
    [aux_sym_export_statement_repeat1] = STATE(2307),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(391),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(95),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(97),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(99),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
    [sym_readonly] = ACTIONS(93),
  },
  [29] = {
    [sym_export_statement] = STATE(581),
    [sym__declaration] = STATE(581),
    [sym_import] = STATE(1528),
    [sym_import_statement] = STATE(581),
    [sym_expression_statement] = STATE(581),
    [sym_variable_declaration] = STATE(572),
    [sym_lexical_declaration] = STATE(572),
    [sym_statement_block] = STATE(581),
    [sym_if_statement] = STATE(581),
    [sym_switch_statement] = STATE(581),
    [sym_for_statement] = STATE(581),
    [sym_for_in_statement] = STATE(581),
    [sym_while_statement] = STATE(581),
    [sym_do_statement] = STATE(581),
    [sym_try_statement] = STATE(581),
    [sym_with_statement] = STATE(581),
    [sym_break_statement] = STATE(581),
    [sym_continue_statement] = STATE(581),
    [sym_debugger_statement] = STATE(581),
    [sym_return_statement] = STATE(581),
    [sym_throw_statement] = STATE(581),
    [sym_empty_statement] = STATE(581),
    [sym_labeled_statement] = STATE(581),
    [sym_parenthesized_expression] = STATE(933),
    [sym__expression] = STATE(1345),
    [sym_yield_expression] = STATE(1543),
    [sym_object] = STATE(1367),
    [sym_array] = STATE(1369),
    [sym_class] = STATE(1528),
    [sym_class_declaration] = STATE(572),
    [sym_function] = STATE(1528),
    [sym_function_declaration] = STATE(572),
    [sym_generator_function] = STATE(1528),
    [sym_generator_function_declaration] = STATE(572),
    [sym_arrow_function] = STATE(1528),
    [sym__call_signature] = STATE(3359),
    [sym_call_expression] = STATE(1528),
    [sym_new_expression] = STATE(1543),
    [sym_await_expression] = STATE(1543),
    [sym_member_expression] = STATE(933),
    [sym_subscript_expression] = STATE(933),
    [sym_assignment_expression] = STATE(1543),
    [sym__augmented_assignment_lhs] = STATE(1970),
    [sym_augmented_assignment_expression] = STATE(1543),
    [sym_ternary_expression] = STATE(1543),
    [sym_binary_expression] = STATE(1543),
    [sym_unary_expression] = STATE(1543),
    [sym_update_expression] = STATE(1543),
    [sym_sequence_expression] = STATE(3070),
    [sym_string] = STATE(1528),
    [sym_template_string] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_meta_property] = STATE(1528),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(936),
    [sym_function_signature] = STATE(572),
    [sym_type_assertion] = STATE(1543),
    [sym_as_expression] = STATE(1543),
    [sym_ambient_declaration] = STATE(572),
    [sym_abstract_class_declaration] = STATE(572),
    [sym_module] = STATE(572),
    [sym_internal_module] = STATE(96),
    [sym_import_alias] = STATE(572),
    [sym_interface_declaration] = STATE(572),
    [sym_enum_declaration] = STATE(572),
    [sym_type_alias_declaration] = STATE(572),
    [sym_type_arguments] = STATE(381),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2307),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(95),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(97),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(99),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
    [sym_readonly] = ACTIONS(93),
  },
  [30] = {
    [sym_export_statement] = STATE(591),
    [sym__declaration] = STATE(591),
    [sym_import] = STATE(1528),
    [sym_import_statement] = STATE(591),
    [sym_expression_statement] = STATE(591),
    [sym_variable_declaration] = STATE(572),
    [sym_lexical_declaration] = STATE(572),
    [sym_statement_block] = STATE(591),
    [sym_if_statement] = STATE(591),
    [sym_switch_statement] = STATE(591),
    [sym_for_statement] = STATE(591),
    [sym_for_in_statement] = STATE(591),
    [sym_while_statement] = STATE(591),
    [sym_do_statement] = STATE(591),
    [sym_try_statement] = STATE(591),
    [sym_with_statement] = STATE(591),
    [sym_break_statement] = STATE(591),
    [sym_continue_statement] = STATE(591),
    [sym_debugger_statement] = STATE(591),
    [sym_return_statement] = STATE(591),
    [sym_throw_statement] = STATE(591),
    [sym_empty_statement] = STATE(591),
    [sym_labeled_statement] = STATE(591),
    [sym_parenthesized_expression] = STATE(933),
    [sym__expression] = STATE(1345),
    [sym_yield_expression] = STATE(1543),
    [sym_object] = STATE(1367),
    [sym_array] = STATE(1369),
    [sym_class] = STATE(1528),
    [sym_class_declaration] = STATE(572),
    [sym_function] = STATE(1528),
    [sym_function_declaration] = STATE(572),
    [sym_generator_function] = STATE(1528),
    [sym_generator_function_declaration] = STATE(572),
    [sym_arrow_function] = STATE(1528),
    [sym__call_signature] = STATE(3359),
    [sym_call_expression] = STATE(1528),
    [sym_new_expression] = STATE(1543),
    [sym_await_expression] = STATE(1543),
    [sym_member_expression] = STATE(933),
    [sym_subscript_expression] = STATE(933),
    [sym_assignment_expression] = STATE(1543),
    [sym__augmented_assignment_lhs] = STATE(1970),
    [sym_augmented_assignment_expression] = STATE(1543),
    [sym_ternary_expression] = STATE(1543),
    [sym_binary_expression] = STATE(1543),
    [sym_unary_expression] = STATE(1543),
    [sym_update_expression] = STATE(1543),
    [sym_sequence_expression] = STATE(3070),
    [sym_string] = STATE(1528),
    [sym_template_string] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_meta_property] = STATE(1528),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(936),
    [sym_function_signature] = STATE(572),
    [sym_type_assertion] = STATE(1543),
    [sym_as_expression] = STATE(1543),
    [sym_ambient_declaration] = STATE(572),
    [sym_abstract_class_declaration] = STATE(572),
    [sym_module] = STATE(572),
    [sym_internal_module] = STATE(96),
    [sym_import_alias] = STATE(572),
    [sym_interface_declaration] = STATE(572),
    [sym_enum_declaration] = STATE(572),
    [sym_type_alias_declaration] = STATE(572),
    [sym_type_arguments] = STATE(381),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2307),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(95),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(97),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(99),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
    [sym_readonly] = ACTIONS(93),
  },
  [31] = {
    [sym_export_statement] = STATE(581),
    [sym__declaration] = STATE(581),
    [sym_import] = STATE(1528),
    [sym_import_statement] = STATE(581),
    [sym_expression_statement] = STATE(581),
    [sym_variable_declaration] = STATE(572),
    [sym_lexical_declaration] = STATE(572),
    [sym_statement_block] = STATE(581),
    [sym_if_statement] = STATE(581),
    [sym_switch_statement] = STATE(581),
    [sym_for_statement] = STATE(581),
    [sym_for_in_statement] = STATE(581),
    [sym_while_statement] = STATE(581),
    [sym_do_statement] = STATE(581),
    [sym_try_statement] = STATE(581),
    [sym_with_statement] = STATE(581),
    [sym_break_statement] = STATE(581),
    [sym_continue_statement] = STATE(581),
    [sym_debugger_statement] = STATE(581),
    [sym_return_statement] = STATE(581),
    [sym_throw_statement] = STATE(581),
    [sym_empty_statement] = STATE(581),
    [sym_labeled_statement] = STATE(581),
    [sym_parenthesized_expression] = STATE(933),
    [sym__expression] = STATE(1345),
    [sym_yield_expression] = STATE(1543),
    [sym_object] = STATE(1367),
    [sym_array] = STATE(1369),
    [sym_class] = STATE(1528),
    [sym_class_declaration] = STATE(572),
    [sym_function] = STATE(1528),
    [sym_function_declaration] = STATE(572),
    [sym_generator_function] = STATE(1528),
    [sym_generator_function_declaration] = STATE(572),
    [sym_arrow_function] = STATE(1528),
    [sym__call_signature] = STATE(3359),
    [sym_call_expression] = STATE(1528),
    [sym_new_expression] = STATE(1543),
    [sym_await_expression] = STATE(1543),
    [sym_member_expression] = STATE(933),
    [sym_subscript_expression] = STATE(933),
    [sym_assignment_expression] = STATE(1543),
    [sym__augmented_assignment_lhs] = STATE(1970),
    [sym_augmented_assignment_expression] = STATE(1543),
    [sym_ternary_expression] = STATE(1543),
    [sym_binary_expression] = STATE(1543),
    [sym_unary_expression] = STATE(1543),
    [sym_update_expression] = STATE(1543),
    [sym_sequence_expression] = STATE(3070),
    [sym_string] = STATE(1528),
    [sym_template_string] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_meta_property] = STATE(1528),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(936),
    [sym_function_signature] = STATE(572),
    [sym_type_assertion] = STATE(1543),
    [sym_as_expression] = STATE(1543),
    [sym_ambient_declaration] = STATE(572),
    [sym_abstract_class_declaration] = STATE(572),
    [sym_module] = STATE(572),
    [sym_internal_module] = STATE(1383),
    [sym_import_alias] = STATE(572),
    [sym_interface_declaration] = STATE(572),
    [sym_enum_declaration] = STATE(572),
    [sym_type_alias_declaration] = STATE(572),
    [sym_type_arguments] = STATE(381),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2337),
    [sym_identifier] = ACTIONS(393),
    [anon_sym_export] = ACTIONS(395),
    [anon_sym_namespace] = ACTIONS(397),
    [anon_sym_LBRACE] = ACTIONS(399),
    [anon_sym_type] = ACTIONS(401),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(403),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(405),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(407),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(409),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(411),
    [anon_sym_async] = ACTIONS(413),
    [anon_sym_function] = ACTIONS(415),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(417),
    [anon_sym_abstract] = ACTIONS(95),
    [anon_sym_get] = ACTIONS(417),
    [anon_sym_set] = ACTIONS(417),
    [anon_sym_declare] = ACTIONS(419),
    [anon_sym_public] = ACTIONS(417),
    [anon_sym_private] = ACTIONS(417),
    [anon_sym_protected] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(421),
    [anon_sym_any] = ACTIONS(417),
    [anon_sym_number] = ACTIONS(417),
    [anon_sym_boolean] = ACTIONS(417),
    [anon_sym_string] = ACTIONS(417),
    [anon_sym_symbol] = ACTIONS(417),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
    [sym_readonly] = ACTIONS(417),
  },
  [32] = {
    [sym_export_statement] = STATE(3310),
    [sym__declaration] = STATE(3310),
    [sym_import] = STATE(1528),
    [sym_import_statement] = STATE(3310),
    [sym_expression_statement] = STATE(3310),
    [sym_variable_declaration] = STATE(572),
    [sym_lexical_declaration] = STATE(572),
    [sym_statement_block] = STATE(3310),
    [sym_if_statement] = STATE(3310),
    [sym_switch_statement] = STATE(3310),
    [sym_for_statement] = STATE(3310),
    [sym_for_in_statement] = STATE(3310),
    [sym_while_statement] = STATE(3310),
    [sym_do_statement] = STATE(3310),
    [sym_try_statement] = STATE(3310),
    [sym_with_statement] = STATE(3310),
    [sym_break_statement] = STATE(3310),
    [sym_continue_statement] = STATE(3310),
    [sym_debugger_statement] = STATE(3310),
    [sym_return_statement] = STATE(3310),
    [sym_throw_statement] = STATE(3310),
    [sym_empty_statement] = STATE(3310),
    [sym_labeled_statement] = STATE(3310),
    [sym_parenthesized_expression] = STATE(933),
    [sym__expression] = STATE(1345),
    [sym_yield_expression] = STATE(1543),
    [sym_object] = STATE(1367),
    [sym_array] = STATE(1369),
    [sym_class] = STATE(1528),
    [sym_class_declaration] = STATE(572),
    [sym_function] = STATE(1528),
    [sym_function_declaration] = STATE(572),
    [sym_generator_function] = STATE(1528),
    [sym_generator_function_declaration] = STATE(572),
    [sym_arrow_function] = STATE(1528),
    [sym__call_signature] = STATE(3359),
    [sym_call_expression] = STATE(1528),
    [sym_new_expression] = STATE(1543),
    [sym_await_expression] = STATE(1543),
    [sym_member_expression] = STATE(933),
    [sym_subscript_expression] = STATE(933),
    [sym_assignment_expression] = STATE(1543),
    [sym__augmented_assignment_lhs] = STATE(1970),
    [sym_augmented_assignment_expression] = STATE(1543),
    [sym_ternary_expression] = STATE(1543),
    [sym_binary_expression] = STATE(1543),
    [sym_unary_expression] = STATE(1543),
    [sym_update_expression] = STATE(1543),
    [sym_sequence_expression] = STATE(3070),
    [sym_string] = STATE(1528),
    [sym_template_string] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_meta_property] = STATE(1528),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(936),
    [sym_function_signature] = STATE(572),
    [sym_type_assertion] = STATE(1543),
    [sym_as_expression] = STATE(1543),
    [sym_ambient_declaration] = STATE(572),
    [sym_abstract_class_declaration] = STATE(572),
    [sym_module] = STATE(572),
    [sym_internal_module] = STATE(1383),
    [sym_import_alias] = STATE(572),
    [sym_interface_declaration] = STATE(572),
    [sym_enum_declaration] = STATE(572),
    [sym_type_alias_declaration] = STATE(572),
    [sym_type_arguments] = STATE(381),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2337),
    [sym_identifier] = ACTIONS(393),
    [anon_sym_export] = ACTIONS(395),
    [anon_sym_namespace] = ACTIONS(397),
    [anon_sym_LBRACE] = ACTIONS(399),
    [anon_sym_type] = ACTIONS(401),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(403),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(405),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(407),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(409),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(411),
    [anon_sym_async] = ACTIONS(413),
    [anon_sym_function] = ACTIONS(415),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(417),
    [anon_sym_abstract] = ACTIONS(95),
    [anon_sym_get] = ACTIONS(417),
    [anon_sym_set] = ACTIONS(417),
    [anon_sym_declare] = ACTIONS(419),
    [anon_sym_public] = ACTIONS(417),
    [anon_sym_private] = ACTIONS(417),
    [anon_sym_protected] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(421),
    [anon_sym_any] = ACTIONS(417),
    [anon_sym_number] = ACTIONS(417),
    [anon_sym_boolean] = ACTIONS(417),
    [anon_sym_string] = ACTIONS(417),
    [anon_sym_symbol] = ACTIONS(417),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
    [sym_readonly] = ACTIONS(417),
  },
  [33] = {
    [sym_export_statement] = STATE(614),
    [sym__declaration] = STATE(614),
    [sym_import] = STATE(1528),
    [sym_import_statement] = STATE(614),
    [sym_expression_statement] = STATE(614),
    [sym_variable_declaration] = STATE(572),
    [sym_lexical_declaration] = STATE(572),
    [sym_statement_block] = STATE(614),
    [sym_if_statement] = STATE(614),
    [sym_switch_statement] = STATE(614),
    [sym_for_statement] = STATE(614),
    [sym_for_in_statement] = STATE(614),
    [sym_while_statement] = STATE(614),
    [sym_do_statement] = STATE(614),
    [sym_try_statement] = STATE(614),
    [sym_with_statement] = STATE(614),
    [sym_break_statement] = STATE(614),
    [sym_continue_statement] = STATE(614),
    [sym_debugger_statement] = STATE(614),
    [sym_return_statement] = STATE(614),
    [sym_throw_statement] = STATE(614),
    [sym_empty_statement] = STATE(614),
    [sym_labeled_statement] = STATE(614),
    [sym_parenthesized_expression] = STATE(933),
    [sym__expression] = STATE(1345),
    [sym_yield_expression] = STATE(1543),
    [sym_object] = STATE(1367),
    [sym_array] = STATE(1369),
    [sym_class] = STATE(1528),
    [sym_class_declaration] = STATE(572),
    [sym_function] = STATE(1528),
    [sym_function_declaration] = STATE(572),
    [sym_generator_function] = STATE(1528),
    [sym_generator_function_declaration] = STATE(572),
    [sym_arrow_function] = STATE(1528),
    [sym__call_signature] = STATE(3359),
    [sym_call_expression] = STATE(1528),
    [sym_new_expression] = STATE(1543),
    [sym_await_expression] = STATE(1543),
    [sym_member_expression] = STATE(933),
    [sym_subscript_expression] = STATE(933),
    [sym_assignment_expression] = STATE(1543),
    [sym__augmented_assignment_lhs] = STATE(1970),
    [sym_augmented_assignment_expression] = STATE(1543),
    [sym_ternary_expression] = STATE(1543),
    [sym_binary_expression] = STATE(1543),
    [sym_unary_expression] = STATE(1543),
    [sym_update_expression] = STATE(1543),
    [sym_sequence_expression] = STATE(3070),
    [sym_string] = STATE(1528),
    [sym_template_string] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_meta_property] = STATE(1528),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(936),
    [sym_function_signature] = STATE(572),
    [sym_type_assertion] = STATE(1543),
    [sym_as_expression] = STATE(1543),
    [sym_ambient_declaration] = STATE(572),
    [sym_abstract_class_declaration] = STATE(572),
    [sym_module] = STATE(572),
    [sym_internal_module] = STATE(96),
    [sym_import_alias] = STATE(572),
    [sym_interface_declaration] = STATE(572),
    [sym_enum_declaration] = STATE(572),
    [sym_type_alias_declaration] = STATE(572),
    [sym_type_arguments] = STATE(381),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2307),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(95),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(97),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(99),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
    [sym_readonly] = ACTIONS(93),
  },
  [34] = {
    [sym_export_statement] = STATE(591),
    [sym__declaration] = STATE(591),
    [sym_import] = STATE(1528),
    [sym_import_statement] = STATE(591),
    [sym_expression_statement] = STATE(591),
    [sym_variable_declaration] = STATE(572),
    [sym_lexical_declaration] = STATE(572),
    [sym_statement_block] = STATE(591),
    [sym_if_statement] = STATE(591),
    [sym_switch_statement] = STATE(591),
    [sym_for_statement] = STATE(591),
    [sym_for_in_statement] = STATE(591),
    [sym_while_statement] = STATE(591),
    [sym_do_statement] = STATE(591),
    [sym_try_statement] = STATE(591),
    [sym_with_statement] = STATE(591),
    [sym_break_statement] = STATE(591),
    [sym_continue_statement] = STATE(591),
    [sym_debugger_statement] = STATE(591),
    [sym_return_statement] = STATE(591),
    [sym_throw_statement] = STATE(591),
    [sym_empty_statement] = STATE(591),
    [sym_labeled_statement] = STATE(591),
    [sym_parenthesized_expression] = STATE(933),
    [sym__expression] = STATE(1345),
    [sym_yield_expression] = STATE(1543),
    [sym_object] = STATE(1367),
    [sym_array] = STATE(1369),
    [sym_class] = STATE(1528),
    [sym_class_declaration] = STATE(572),
    [sym_function] = STATE(1528),
    [sym_function_declaration] = STATE(572),
    [sym_generator_function] = STATE(1528),
    [sym_generator_function_declaration] = STATE(572),
    [sym_arrow_function] = STATE(1528),
    [sym__call_signature] = STATE(3359),
    [sym_call_expression] = STATE(1528),
    [sym_new_expression] = STATE(1543),
    [sym_await_expression] = STATE(1543),
    [sym_member_expression] = STATE(933),
    [sym_subscript_expression] = STATE(933),
    [sym_assignment_expression] = STATE(1543),
    [sym__augmented_assignment_lhs] = STATE(1970),
    [sym_augmented_assignment_expression] = STATE(1543),
    [sym_ternary_expression] = STATE(1543),
    [sym_binary_expression] = STATE(1543),
    [sym_unary_expression] = STATE(1543),
    [sym_update_expression] = STATE(1543),
    [sym_sequence_expression] = STATE(3070),
    [sym_string] = STATE(1528),
    [sym_template_string] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_meta_property] = STATE(1528),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(936),
    [sym_function_signature] = STATE(572),
    [sym_type_assertion] = STATE(1543),
    [sym_as_expression] = STATE(1543),
    [sym_ambient_declaration] = STATE(572),
    [sym_abstract_class_declaration] = STATE(572),
    [sym_module] = STATE(572),
    [sym_internal_module] = STATE(1383),
    [sym_import_alias] = STATE(572),
    [sym_interface_declaration] = STATE(572),
    [sym_enum_declaration] = STATE(572),
    [sym_type_alias_declaration] = STATE(572),
    [sym_type_arguments] = STATE(381),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2337),
    [sym_identifier] = ACTIONS(393),
    [anon_sym_export] = ACTIONS(395),
    [anon_sym_namespace] = ACTIONS(397),
    [anon_sym_LBRACE] = ACTIONS(399),
    [anon_sym_type] = ACTIONS(401),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(403),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(405),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(407),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(409),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(411),
    [anon_sym_async] = ACTIONS(413),
    [anon_sym_function] = ACTIONS(415),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(417),
    [anon_sym_abstract] = ACTIONS(95),
    [anon_sym_get] = ACTIONS(417),
    [anon_sym_set] = ACTIONS(417),
    [anon_sym_declare] = ACTIONS(419),
    [anon_sym_public] = ACTIONS(417),
    [anon_sym_private] = ACTIONS(417),
    [anon_sym_protected] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(421),
    [anon_sym_any] = ACTIONS(417),
    [anon_sym_number] = ACTIONS(417),
    [anon_sym_boolean] = ACTIONS(417),
    [anon_sym_string] = ACTIONS(417),
    [anon_sym_symbol] = ACTIONS(417),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
    [sym_readonly] = ACTIONS(417),
  },
  [35] = {
    [sym_export_statement] = STATE(2855),
    [sym__declaration] = STATE(2855),
    [sym_import] = STATE(1528),
    [sym_import_statement] = STATE(2855),
    [sym_expression_statement] = STATE(2855),
    [sym_variable_declaration] = STATE(572),
    [sym_lexical_declaration] = STATE(572),
    [sym_statement_block] = STATE(2855),
    [sym_if_statement] = STATE(2855),
    [sym_switch_statement] = STATE(2855),
    [sym_for_statement] = STATE(2855),
    [sym_for_in_statement] = STATE(2855),
    [sym_while_statement] = STATE(2855),
    [sym_do_statement] = STATE(2855),
    [sym_try_statement] = STATE(2855),
    [sym_with_statement] = STATE(2855),
    [sym_break_statement] = STATE(2855),
    [sym_continue_statement] = STATE(2855),
    [sym_debugger_statement] = STATE(2855),
    [sym_return_statement] = STATE(2855),
    [sym_throw_statement] = STATE(2855),
    [sym_empty_statement] = STATE(2855),
    [sym_labeled_statement] = STATE(2855),
    [sym_parenthesized_expression] = STATE(933),
    [sym__expression] = STATE(1345),
    [sym_yield_expression] = STATE(1543),
    [sym_object] = STATE(1367),
    [sym_array] = STATE(1369),
    [sym_class] = STATE(1528),
    [sym_class_declaration] = STATE(572),
    [sym_function] = STATE(1528),
    [sym_function_declaration] = STATE(572),
    [sym_generator_function] = STATE(1528),
    [sym_generator_function_declaration] = STATE(572),
    [sym_arrow_function] = STATE(1528),
    [sym__call_signature] = STATE(3359),
    [sym_call_expression] = STATE(1528),
    [sym_new_expression] = STATE(1543),
    [sym_await_expression] = STATE(1543),
    [sym_member_expression] = STATE(933),
    [sym_subscript_expression] = STATE(933),
    [sym_assignment_expression] = STATE(1543),
    [sym__augmented_assignment_lhs] = STATE(1970),
    [sym_augmented_assignment_expression] = STATE(1543),
    [sym_ternary_expression] = STATE(1543),
    [sym_binary_expression] = STATE(1543),
    [sym_unary_expression] = STATE(1543),
    [sym_update_expression] = STATE(1543),
    [sym_sequence_expression] = STATE(3070),
    [sym_string] = STATE(1528),
    [sym_template_string] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_meta_property] = STATE(1528),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(936),
    [sym_function_signature] = STATE(572),
    [sym_type_assertion] = STATE(1543),
    [sym_as_expression] = STATE(1543),
    [sym_ambient_declaration] = STATE(572),
    [sym_abstract_class_declaration] = STATE(572),
    [sym_module] = STATE(572),
    [sym_internal_module] = STATE(1383),
    [sym_import_alias] = STATE(572),
    [sym_interface_declaration] = STATE(572),
    [sym_enum_declaration] = STATE(572),
    [sym_type_alias_declaration] = STATE(572),
    [sym_type_arguments] = STATE(381),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2337),
    [sym_identifier] = ACTIONS(393),
    [anon_sym_export] = ACTIONS(395),
    [anon_sym_namespace] = ACTIONS(397),
    [anon_sym_LBRACE] = ACTIONS(399),
    [anon_sym_type] = ACTIONS(401),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(403),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(405),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(407),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(409),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(411),
    [anon_sym_async] = ACTIONS(413),
    [anon_sym_function] = ACTIONS(415),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(417),
    [anon_sym_abstract] = ACTIONS(95),
    [anon_sym_get] = ACTIONS(417),
    [anon_sym_set] = ACTIONS(417),
    [anon_sym_declare] = ACTIONS(419),
    [anon_sym_public] = ACTIONS(417),
    [anon_sym_private] = ACTIONS(417),
    [anon_sym_protected] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(421),
    [anon_sym_any] = ACTIONS(417),
    [anon_sym_number] = ACTIONS(417),
    [anon_sym_boolean] = ACTIONS(417),
    [anon_sym_string] = ACTIONS(417),
    [anon_sym_symbol] = ACTIONS(417),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
    [sym_readonly] = ACTIONS(417),
  },
  [36] = {
    [sym_export_statement] = STATE(625),
    [sym__declaration] = STATE(625),
    [sym_import] = STATE(1528),
    [sym_import_statement] = STATE(625),
    [sym_expression_statement] = STATE(625),
    [sym_variable_declaration] = STATE(572),
    [sym_lexical_declaration] = STATE(572),
    [sym_statement_block] = STATE(625),
    [sym_if_statement] = STATE(625),
    [sym_switch_statement] = STATE(625),
    [sym_for_statement] = STATE(625),
    [sym_for_in_statement] = STATE(625),
    [sym_while_statement] = STATE(625),
    [sym_do_statement] = STATE(625),
    [sym_try_statement] = STATE(625),
    [sym_with_statement] = STATE(625),
    [sym_break_statement] = STATE(625),
    [sym_continue_statement] = STATE(625),
    [sym_debugger_statement] = STATE(625),
    [sym_return_statement] = STATE(625),
    [sym_throw_statement] = STATE(625),
    [sym_empty_statement] = STATE(625),
    [sym_labeled_statement] = STATE(625),
    [sym_parenthesized_expression] = STATE(933),
    [sym__expression] = STATE(1345),
    [sym_yield_expression] = STATE(1543),
    [sym_object] = STATE(1367),
    [sym_array] = STATE(1369),
    [sym_class] = STATE(1528),
    [sym_class_declaration] = STATE(572),
    [sym_function] = STATE(1528),
    [sym_function_declaration] = STATE(572),
    [sym_generator_function] = STATE(1528),
    [sym_generator_function_declaration] = STATE(572),
    [sym_arrow_function] = STATE(1528),
    [sym__call_signature] = STATE(3359),
    [sym_call_expression] = STATE(1528),
    [sym_new_expression] = STATE(1543),
    [sym_await_expression] = STATE(1543),
    [sym_member_expression] = STATE(933),
    [sym_subscript_expression] = STATE(933),
    [sym_assignment_expression] = STATE(1543),
    [sym__augmented_assignment_lhs] = STATE(1970),
    [sym_augmented_assignment_expression] = STATE(1543),
    [sym_ternary_expression] = STATE(1543),
    [sym_binary_expression] = STATE(1543),
    [sym_unary_expression] = STATE(1543),
    [sym_update_expression] = STATE(1543),
    [sym_sequence_expression] = STATE(3070),
    [sym_string] = STATE(1528),
    [sym_template_string] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_meta_property] = STATE(1528),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(936),
    [sym_function_signature] = STATE(572),
    [sym_type_assertion] = STATE(1543),
    [sym_as_expression] = STATE(1543),
    [sym_ambient_declaration] = STATE(572),
    [sym_abstract_class_declaration] = STATE(572),
    [sym_module] = STATE(572),
    [sym_internal_module] = STATE(1383),
    [sym_import_alias] = STATE(572),
    [sym_interface_declaration] = STATE(572),
    [sym_enum_declaration] = STATE(572),
    [sym_type_alias_declaration] = STATE(572),
    [sym_type_arguments] = STATE(381),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2337),
    [sym_identifier] = ACTIONS(393),
    [anon_sym_export] = ACTIONS(395),
    [anon_sym_namespace] = ACTIONS(397),
    [anon_sym_LBRACE] = ACTIONS(399),
    [anon_sym_type] = ACTIONS(401),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(403),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(405),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(407),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(409),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(411),
    [anon_sym_async] = ACTIONS(413),
    [anon_sym_function] = ACTIONS(415),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(417),
    [anon_sym_abstract] = ACTIONS(95),
    [anon_sym_get] = ACTIONS(417),
    [anon_sym_set] = ACTIONS(417),
    [anon_sym_declare] = ACTIONS(419),
    [anon_sym_public] = ACTIONS(417),
    [anon_sym_private] = ACTIONS(417),
    [anon_sym_protected] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(421),
    [anon_sym_any] = ACTIONS(417),
    [anon_sym_number] = ACTIONS(417),
    [anon_sym_boolean] = ACTIONS(417),
    [anon_sym_string] = ACTIONS(417),
    [anon_sym_symbol] = ACTIONS(417),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
    [sym_readonly] = ACTIONS(417),
  },
  [37] = {
    [sym_export_statement] = STATE(582),
    [sym__declaration] = STATE(582),
    [sym_import] = STATE(1528),
    [sym_import_statement] = STATE(582),
    [sym_expression_statement] = STATE(582),
    [sym_variable_declaration] = STATE(572),
    [sym_lexical_declaration] = STATE(572),
    [sym_statement_block] = STATE(582),
    [sym_if_statement] = STATE(582),
    [sym_switch_statement] = STATE(582),
    [sym_for_statement] = STATE(582),
    [sym_for_in_statement] = STATE(582),
    [sym_while_statement] = STATE(582),
    [sym_do_statement] = STATE(582),
    [sym_try_statement] = STATE(582),
    [sym_with_statement] = STATE(582),
    [sym_break_statement] = STATE(582),
    [sym_continue_statement] = STATE(582),
    [sym_debugger_statement] = STATE(582),
    [sym_return_statement] = STATE(582),
    [sym_throw_statement] = STATE(582),
    [sym_empty_statement] = STATE(582),
    [sym_labeled_statement] = STATE(582),
    [sym_parenthesized_expression] = STATE(933),
    [sym__expression] = STATE(1345),
    [sym_yield_expression] = STATE(1543),
    [sym_object] = STATE(1367),
    [sym_array] = STATE(1369),
    [sym_class] = STATE(1528),
    [sym_class_declaration] = STATE(572),
    [sym_function] = STATE(1528),
    [sym_function_declaration] = STATE(572),
    [sym_generator_function] = STATE(1528),
    [sym_generator_function_declaration] = STATE(572),
    [sym_arrow_function] = STATE(1528),
    [sym__call_signature] = STATE(3359),
    [sym_call_expression] = STATE(1528),
    [sym_new_expression] = STATE(1543),
    [sym_await_expression] = STATE(1543),
    [sym_member_expression] = STATE(933),
    [sym_subscript_expression] = STATE(933),
    [sym_assignment_expression] = STATE(1543),
    [sym__augmented_assignment_lhs] = STATE(1970),
    [sym_augmented_assignment_expression] = STATE(1543),
    [sym_ternary_expression] = STATE(1543),
    [sym_binary_expression] = STATE(1543),
    [sym_unary_expression] = STATE(1543),
    [sym_update_expression] = STATE(1543),
    [sym_sequence_expression] = STATE(3070),
    [sym_string] = STATE(1528),
    [sym_template_string] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_meta_property] = STATE(1528),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(936),
    [sym_function_signature] = STATE(572),
    [sym_type_assertion] = STATE(1543),
    [sym_as_expression] = STATE(1543),
    [sym_ambient_declaration] = STATE(572),
    [sym_abstract_class_declaration] = STATE(572),
    [sym_module] = STATE(572),
    [sym_internal_module] = STATE(96),
    [sym_import_alias] = STATE(572),
    [sym_interface_declaration] = STATE(572),
    [sym_enum_declaration] = STATE(572),
    [sym_type_alias_declaration] = STATE(572),
    [sym_type_arguments] = STATE(381),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2307),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(95),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(97),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(99),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
    [sym_readonly] = ACTIONS(93),
  },
  [38] = {
    [sym_export_statement] = STATE(582),
    [sym__declaration] = STATE(582),
    [sym_import] = STATE(1528),
    [sym_import_statement] = STATE(582),
    [sym_expression_statement] = STATE(582),
    [sym_variable_declaration] = STATE(572),
    [sym_lexical_declaration] = STATE(572),
    [sym_statement_block] = STATE(582),
    [sym_if_statement] = STATE(582),
    [sym_switch_statement] = STATE(582),
    [sym_for_statement] = STATE(582),
    [sym_for_in_statement] = STATE(582),
    [sym_while_statement] = STATE(582),
    [sym_do_statement] = STATE(582),
    [sym_try_statement] = STATE(582),
    [sym_with_statement] = STATE(582),
    [sym_break_statement] = STATE(582),
    [sym_continue_statement] = STATE(582),
    [sym_debugger_statement] = STATE(582),
    [sym_return_statement] = STATE(582),
    [sym_throw_statement] = STATE(582),
    [sym_empty_statement] = STATE(582),
    [sym_labeled_statement] = STATE(582),
    [sym_parenthesized_expression] = STATE(933),
    [sym__expression] = STATE(1345),
    [sym_yield_expression] = STATE(1543),
    [sym_object] = STATE(1367),
    [sym_array] = STATE(1369),
    [sym_class] = STATE(1528),
    [sym_class_declaration] = STATE(572),
    [sym_function] = STATE(1528),
    [sym_function_declaration] = STATE(572),
    [sym_generator_function] = STATE(1528),
    [sym_generator_function_declaration] = STATE(572),
    [sym_arrow_function] = STATE(1528),
    [sym__call_signature] = STATE(3359),
    [sym_call_expression] = STATE(1528),
    [sym_new_expression] = STATE(1543),
    [sym_await_expression] = STATE(1543),
    [sym_member_expression] = STATE(933),
    [sym_subscript_expression] = STATE(933),
    [sym_assignment_expression] = STATE(1543),
    [sym__augmented_assignment_lhs] = STATE(1970),
    [sym_augmented_assignment_expression] = STATE(1543),
    [sym_ternary_expression] = STATE(1543),
    [sym_binary_expression] = STATE(1543),
    [sym_unary_expression] = STATE(1543),
    [sym_update_expression] = STATE(1543),
    [sym_sequence_expression] = STATE(3070),
    [sym_string] = STATE(1528),
    [sym_template_string] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_meta_property] = STATE(1528),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(936),
    [sym_function_signature] = STATE(572),
    [sym_type_assertion] = STATE(1543),
    [sym_as_expression] = STATE(1543),
    [sym_ambient_declaration] = STATE(572),
    [sym_abstract_class_declaration] = STATE(572),
    [sym_module] = STATE(572),
    [sym_internal_module] = STATE(1383),
    [sym_import_alias] = STATE(572),
    [sym_interface_declaration] = STATE(572),
    [sym_enum_declaration] = STATE(572),
    [sym_type_alias_declaration] = STATE(572),
    [sym_type_arguments] = STATE(381),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2337),
    [sym_identifier] = ACTIONS(393),
    [anon_sym_export] = ACTIONS(395),
    [anon_sym_namespace] = ACTIONS(397),
    [anon_sym_LBRACE] = ACTIONS(399),
    [anon_sym_type] = ACTIONS(401),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(403),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(405),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(407),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(409),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(411),
    [anon_sym_async] = ACTIONS(413),
    [anon_sym_function] = ACTIONS(415),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(417),
    [anon_sym_abstract] = ACTIONS(95),
    [anon_sym_get] = ACTIONS(417),
    [anon_sym_set] = ACTIONS(417),
    [anon_sym_declare] = ACTIONS(419),
    [anon_sym_public] = ACTIONS(417),
    [anon_sym_private] = ACTIONS(417),
    [anon_sym_protected] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(421),
    [anon_sym_any] = ACTIONS(417),
    [anon_sym_number] = ACTIONS(417),
    [anon_sym_boolean] = ACTIONS(417),
    [anon_sym_string] = ACTIONS(417),
    [anon_sym_symbol] = ACTIONS(417),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
    [sym_readonly] = ACTIONS(417),
  },
  [39] = {
    [sym_export_statement] = STATE(614),
    [sym__declaration] = STATE(614),
    [sym_import] = STATE(1528),
    [sym_import_statement] = STATE(614),
    [sym_expression_statement] = STATE(614),
    [sym_variable_declaration] = STATE(572),
    [sym_lexical_declaration] = STATE(572),
    [sym_statement_block] = STATE(614),
    [sym_if_statement] = STATE(614),
    [sym_switch_statement] = STATE(614),
    [sym_for_statement] = STATE(614),
    [sym_for_in_statement] = STATE(614),
    [sym_while_statement] = STATE(614),
    [sym_do_statement] = STATE(614),
    [sym_try_statement] = STATE(614),
    [sym_with_statement] = STATE(614),
    [sym_break_statement] = STATE(614),
    [sym_continue_statement] = STATE(614),
    [sym_debugger_statement] = STATE(614),
    [sym_return_statement] = STATE(614),
    [sym_throw_statement] = STATE(614),
    [sym_empty_statement] = STATE(614),
    [sym_labeled_statement] = STATE(614),
    [sym_parenthesized_expression] = STATE(933),
    [sym__expression] = STATE(1345),
    [sym_yield_expression] = STATE(1543),
    [sym_object] = STATE(1367),
    [sym_array] = STATE(1369),
    [sym_class] = STATE(1528),
    [sym_class_declaration] = STATE(572),
    [sym_function] = STATE(1528),
    [sym_function_declaration] = STATE(572),
    [sym_generator_function] = STATE(1528),
    [sym_generator_function_declaration] = STATE(572),
    [sym_arrow_function] = STATE(1528),
    [sym__call_signature] = STATE(3359),
    [sym_call_expression] = STATE(1528),
    [sym_new_expression] = STATE(1543),
    [sym_await_expression] = STATE(1543),
    [sym_member_expression] = STATE(933),
    [sym_subscript_expression] = STATE(933),
    [sym_assignment_expression] = STATE(1543),
    [sym__augmented_assignment_lhs] = STATE(1970),
    [sym_augmented_assignment_expression] = STATE(1543),
    [sym_ternary_expression] = STATE(1543),
    [sym_binary_expression] = STATE(1543),
    [sym_unary_expression] = STATE(1543),
    [sym_update_expression] = STATE(1543),
    [sym_sequence_expression] = STATE(3070),
    [sym_string] = STATE(1528),
    [sym_template_string] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_meta_property] = STATE(1528),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(936),
    [sym_function_signature] = STATE(572),
    [sym_type_assertion] = STATE(1543),
    [sym_as_expression] = STATE(1543),
    [sym_ambient_declaration] = STATE(572),
    [sym_abstract_class_declaration] = STATE(572),
    [sym_module] = STATE(572),
    [sym_internal_module] = STATE(1383),
    [sym_import_alias] = STATE(572),
    [sym_interface_declaration] = STATE(572),
    [sym_enum_declaration] = STATE(572),
    [sym_type_alias_declaration] = STATE(572),
    [sym_type_arguments] = STATE(381),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2337),
    [sym_identifier] = ACTIONS(393),
    [anon_sym_export] = ACTIONS(395),
    [anon_sym_namespace] = ACTIONS(397),
    [anon_sym_LBRACE] = ACTIONS(399),
    [anon_sym_type] = ACTIONS(401),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(403),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(405),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(407),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(409),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(411),
    [anon_sym_async] = ACTIONS(413),
    [anon_sym_function] = ACTIONS(415),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(417),
    [anon_sym_abstract] = ACTIONS(95),
    [anon_sym_get] = ACTIONS(417),
    [anon_sym_set] = ACTIONS(417),
    [anon_sym_declare] = ACTIONS(419),
    [anon_sym_public] = ACTIONS(417),
    [anon_sym_private] = ACTIONS(417),
    [anon_sym_protected] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(421),
    [anon_sym_any] = ACTIONS(417),
    [anon_sym_number] = ACTIONS(417),
    [anon_sym_boolean] = ACTIONS(417),
    [anon_sym_string] = ACTIONS(417),
    [anon_sym_symbol] = ACTIONS(417),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
    [sym_readonly] = ACTIONS(417),
  },
  [40] = {
    [sym_export_statement] = STATE(543),
    [sym__declaration] = STATE(543),
    [sym_import] = STATE(1528),
    [sym_import_statement] = STATE(543),
    [sym_expression_statement] = STATE(543),
    [sym_variable_declaration] = STATE(572),
    [sym_lexical_declaration] = STATE(572),
    [sym_statement_block] = STATE(543),
    [sym_if_statement] = STATE(543),
    [sym_switch_statement] = STATE(543),
    [sym_for_statement] = STATE(543),
    [sym_for_in_statement] = STATE(543),
    [sym_while_statement] = STATE(543),
    [sym_do_statement] = STATE(543),
    [sym_try_statement] = STATE(543),
    [sym_with_statement] = STATE(543),
    [sym_break_statement] = STATE(543),
    [sym_continue_statement] = STATE(543),
    [sym_debugger_statement] = STATE(543),
    [sym_return_statement] = STATE(543),
    [sym_throw_statement] = STATE(543),
    [sym_empty_statement] = STATE(543),
    [sym_labeled_statement] = STATE(543),
    [sym_parenthesized_expression] = STATE(933),
    [sym__expression] = STATE(1345),
    [sym_yield_expression] = STATE(1543),
    [sym_object] = STATE(1367),
    [sym_array] = STATE(1369),
    [sym_class] = STATE(1528),
    [sym_class_declaration] = STATE(572),
    [sym_function] = STATE(1528),
    [sym_function_declaration] = STATE(572),
    [sym_generator_function] = STATE(1528),
    [sym_generator_function_declaration] = STATE(572),
    [sym_arrow_function] = STATE(1528),
    [sym__call_signature] = STATE(3359),
    [sym_call_expression] = STATE(1528),
    [sym_new_expression] = STATE(1543),
    [sym_await_expression] = STATE(1543),
    [sym_member_expression] = STATE(933),
    [sym_subscript_expression] = STATE(933),
    [sym_assignment_expression] = STATE(1543),
    [sym__augmented_assignment_lhs] = STATE(1970),
    [sym_augmented_assignment_expression] = STATE(1543),
    [sym_ternary_expression] = STATE(1543),
    [sym_binary_expression] = STATE(1543),
    [sym_unary_expression] = STATE(1543),
    [sym_update_expression] = STATE(1543),
    [sym_sequence_expression] = STATE(3070),
    [sym_string] = STATE(1528),
    [sym_template_string] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_meta_property] = STATE(1528),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(936),
    [sym_function_signature] = STATE(572),
    [sym_type_assertion] = STATE(1543),
    [sym_as_expression] = STATE(1543),
    [sym_ambient_declaration] = STATE(572),
    [sym_abstract_class_declaration] = STATE(572),
    [sym_module] = STATE(572),
    [sym_internal_module] = STATE(96),
    [sym_import_alias] = STATE(572),
    [sym_interface_declaration] = STATE(572),
    [sym_enum_declaration] = STATE(572),
    [sym_type_alias_declaration] = STATE(572),
    [sym_type_arguments] = STATE(381),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2307),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(95),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(97),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(99),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
    [sym_readonly] = ACTIONS(93),
  },
  [41] = {
    [sym_export_statement] = STATE(577),
    [sym__declaration] = STATE(577),
    [sym_import] = STATE(1528),
    [sym_import_statement] = STATE(577),
    [sym_expression_statement] = STATE(577),
    [sym_variable_declaration] = STATE(572),
    [sym_lexical_declaration] = STATE(572),
    [sym_statement_block] = STATE(577),
    [sym_if_statement] = STATE(577),
    [sym_switch_statement] = STATE(577),
    [sym_for_statement] = STATE(577),
    [sym_for_in_statement] = STATE(577),
    [sym_while_statement] = STATE(577),
    [sym_do_statement] = STATE(577),
    [sym_try_statement] = STATE(577),
    [sym_with_statement] = STATE(577),
    [sym_break_statement] = STATE(577),
    [sym_continue_statement] = STATE(577),
    [sym_debugger_statement] = STATE(577),
    [sym_return_statement] = STATE(577),
    [sym_throw_statement] = STATE(577),
    [sym_empty_statement] = STATE(577),
    [sym_labeled_statement] = STATE(577),
    [sym_parenthesized_expression] = STATE(933),
    [sym__expression] = STATE(1345),
    [sym_yield_expression] = STATE(1543),
    [sym_object] = STATE(1367),
    [sym_array] = STATE(1369),
    [sym_class] = STATE(1528),
    [sym_class_declaration] = STATE(572),
    [sym_function] = STATE(1528),
    [sym_function_declaration] = STATE(572),
    [sym_generator_function] = STATE(1528),
    [sym_generator_function_declaration] = STATE(572),
    [sym_arrow_function] = STATE(1528),
    [sym__call_signature] = STATE(3359),
    [sym_call_expression] = STATE(1528),
    [sym_new_expression] = STATE(1543),
    [sym_await_expression] = STATE(1543),
    [sym_member_expression] = STATE(933),
    [sym_subscript_expression] = STATE(933),
    [sym_assignment_expression] = STATE(1543),
    [sym__augmented_assignment_lhs] = STATE(1970),
    [sym_augmented_assignment_expression] = STATE(1543),
    [sym_ternary_expression] = STATE(1543),
    [sym_binary_expression] = STATE(1543),
    [sym_unary_expression] = STATE(1543),
    [sym_update_expression] = STATE(1543),
    [sym_sequence_expression] = STATE(3070),
    [sym_string] = STATE(1528),
    [sym_template_string] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_meta_property] = STATE(1528),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(936),
    [sym_function_signature] = STATE(572),
    [sym_type_assertion] = STATE(1543),
    [sym_as_expression] = STATE(1543),
    [sym_ambient_declaration] = STATE(572),
    [sym_abstract_class_declaration] = STATE(572),
    [sym_module] = STATE(572),
    [sym_internal_module] = STATE(96),
    [sym_import_alias] = STATE(572),
    [sym_interface_declaration] = STATE(572),
    [sym_enum_declaration] = STATE(572),
    [sym_type_alias_declaration] = STATE(572),
    [sym_type_arguments] = STATE(381),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2307),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(95),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(97),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(99),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
    [sym_readonly] = ACTIONS(93),
  },
  [42] = {
    [sym_export_statement] = STATE(601),
    [sym__declaration] = STATE(601),
    [sym_import] = STATE(1528),
    [sym_import_statement] = STATE(601),
    [sym_expression_statement] = STATE(601),
    [sym_variable_declaration] = STATE(572),
    [sym_lexical_declaration] = STATE(572),
    [sym_statement_block] = STATE(601),
    [sym_if_statement] = STATE(601),
    [sym_switch_statement] = STATE(601),
    [sym_for_statement] = STATE(601),
    [sym_for_in_statement] = STATE(601),
    [sym_while_statement] = STATE(601),
    [sym_do_statement] = STATE(601),
    [sym_try_statement] = STATE(601),
    [sym_with_statement] = STATE(601),
    [sym_break_statement] = STATE(601),
    [sym_continue_statement] = STATE(601),
    [sym_debugger_statement] = STATE(601),
    [sym_return_statement] = STATE(601),
    [sym_throw_statement] = STATE(601),
    [sym_empty_statement] = STATE(601),
    [sym_labeled_statement] = STATE(601),
    [sym_parenthesized_expression] = STATE(933),
    [sym__expression] = STATE(1345),
    [sym_yield_expression] = STATE(1543),
    [sym_object] = STATE(1367),
    [sym_array] = STATE(1369),
    [sym_class] = STATE(1528),
    [sym_class_declaration] = STATE(572),
    [sym_function] = STATE(1528),
    [sym_function_declaration] = STATE(572),
    [sym_generator_function] = STATE(1528),
    [sym_generator_function_declaration] = STATE(572),
    [sym_arrow_function] = STATE(1528),
    [sym__call_signature] = STATE(3359),
    [sym_call_expression] = STATE(1528),
    [sym_new_expression] = STATE(1543),
    [sym_await_expression] = STATE(1543),
    [sym_member_expression] = STATE(933),
    [sym_subscript_expression] = STATE(933),
    [sym_assignment_expression] = STATE(1543),
    [sym__augmented_assignment_lhs] = STATE(1970),
    [sym_augmented_assignment_expression] = STATE(1543),
    [sym_ternary_expression] = STATE(1543),
    [sym_binary_expression] = STATE(1543),
    [sym_unary_expression] = STATE(1543),
    [sym_update_expression] = STATE(1543),
    [sym_sequence_expression] = STATE(3070),
    [sym_string] = STATE(1528),
    [sym_template_string] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_meta_property] = STATE(1528),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(936),
    [sym_function_signature] = STATE(572),
    [sym_type_assertion] = STATE(1543),
    [sym_as_expression] = STATE(1543),
    [sym_ambient_declaration] = STATE(572),
    [sym_abstract_class_declaration] = STATE(572),
    [sym_module] = STATE(572),
    [sym_internal_module] = STATE(96),
    [sym_import_alias] = STATE(572),
    [sym_interface_declaration] = STATE(572),
    [sym_enum_declaration] = STATE(572),
    [sym_type_alias_declaration] = STATE(572),
    [sym_type_arguments] = STATE(381),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2307),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(95),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(97),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(99),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
    [sym_readonly] = ACTIONS(93),
  },
  [43] = {
    [sym_export_statement] = STATE(601),
    [sym__declaration] = STATE(601),
    [sym_import] = STATE(1528),
    [sym_import_statement] = STATE(601),
    [sym_expression_statement] = STATE(601),
    [sym_variable_declaration] = STATE(572),
    [sym_lexical_declaration] = STATE(572),
    [sym_statement_block] = STATE(601),
    [sym_if_statement] = STATE(601),
    [sym_switch_statement] = STATE(601),
    [sym_for_statement] = STATE(601),
    [sym_for_in_statement] = STATE(601),
    [sym_while_statement] = STATE(601),
    [sym_do_statement] = STATE(601),
    [sym_try_statement] = STATE(601),
    [sym_with_statement] = STATE(601),
    [sym_break_statement] = STATE(601),
    [sym_continue_statement] = STATE(601),
    [sym_debugger_statement] = STATE(601),
    [sym_return_statement] = STATE(601),
    [sym_throw_statement] = STATE(601),
    [sym_empty_statement] = STATE(601),
    [sym_labeled_statement] = STATE(601),
    [sym_parenthesized_expression] = STATE(933),
    [sym__expression] = STATE(1345),
    [sym_yield_expression] = STATE(1543),
    [sym_object] = STATE(1367),
    [sym_array] = STATE(1369),
    [sym_class] = STATE(1528),
    [sym_class_declaration] = STATE(572),
    [sym_function] = STATE(1528),
    [sym_function_declaration] = STATE(572),
    [sym_generator_function] = STATE(1528),
    [sym_generator_function_declaration] = STATE(572),
    [sym_arrow_function] = STATE(1528),
    [sym__call_signature] = STATE(3359),
    [sym_call_expression] = STATE(1528),
    [sym_new_expression] = STATE(1543),
    [sym_await_expression] = STATE(1543),
    [sym_member_expression] = STATE(933),
    [sym_subscript_expression] = STATE(933),
    [sym_assignment_expression] = STATE(1543),
    [sym__augmented_assignment_lhs] = STATE(1970),
    [sym_augmented_assignment_expression] = STATE(1543),
    [sym_ternary_expression] = STATE(1543),
    [sym_binary_expression] = STATE(1543),
    [sym_unary_expression] = STATE(1543),
    [sym_update_expression] = STATE(1543),
    [sym_sequence_expression] = STATE(3070),
    [sym_string] = STATE(1528),
    [sym_template_string] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_meta_property] = STATE(1528),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(936),
    [sym_function_signature] = STATE(572),
    [sym_type_assertion] = STATE(1543),
    [sym_as_expression] = STATE(1543),
    [sym_ambient_declaration] = STATE(572),
    [sym_abstract_class_declaration] = STATE(572),
    [sym_module] = STATE(572),
    [sym_internal_module] = STATE(1383),
    [sym_import_alias] = STATE(572),
    [sym_interface_declaration] = STATE(572),
    [sym_enum_declaration] = STATE(572),
    [sym_type_alias_declaration] = STATE(572),
    [sym_type_arguments] = STATE(381),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2337),
    [sym_identifier] = ACTIONS(393),
    [anon_sym_export] = ACTIONS(395),
    [anon_sym_namespace] = ACTIONS(397),
    [anon_sym_LBRACE] = ACTIONS(399),
    [anon_sym_type] = ACTIONS(401),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(403),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(405),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(407),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(409),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(411),
    [anon_sym_async] = ACTIONS(413),
    [anon_sym_function] = ACTIONS(415),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(417),
    [anon_sym_abstract] = ACTIONS(95),
    [anon_sym_get] = ACTIONS(417),
    [anon_sym_set] = ACTIONS(417),
    [anon_sym_declare] = ACTIONS(419),
    [anon_sym_public] = ACTIONS(417),
    [anon_sym_private] = ACTIONS(417),
    [anon_sym_protected] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(421),
    [anon_sym_any] = ACTIONS(417),
    [anon_sym_number] = ACTIONS(417),
    [anon_sym_boolean] = ACTIONS(417),
    [anon_sym_string] = ACTIONS(417),
    [anon_sym_symbol] = ACTIONS(417),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
    [sym_readonly] = ACTIONS(417),
  },
  [44] = {
    [sym_export_statement] = STATE(577),
    [sym__declaration] = STATE(577),
    [sym_import] = STATE(1528),
    [sym_import_statement] = STATE(577),
    [sym_expression_statement] = STATE(577),
    [sym_variable_declaration] = STATE(572),
    [sym_lexical_declaration] = STATE(572),
    [sym_statement_block] = STATE(577),
    [sym_if_statement] = STATE(577),
    [sym_switch_statement] = STATE(577),
    [sym_for_statement] = STATE(577),
    [sym_for_in_statement] = STATE(577),
    [sym_while_statement] = STATE(577),
    [sym_do_statement] = STATE(577),
    [sym_try_statement] = STATE(577),
    [sym_with_statement] = STATE(577),
    [sym_break_statement] = STATE(577),
    [sym_continue_statement] = STATE(577),
    [sym_debugger_statement] = STATE(577),
    [sym_return_statement] = STATE(577),
    [sym_throw_statement] = STATE(577),
    [sym_empty_statement] = STATE(577),
    [sym_labeled_statement] = STATE(577),
    [sym_parenthesized_expression] = STATE(933),
    [sym__expression] = STATE(1345),
    [sym_yield_expression] = STATE(1543),
    [sym_object] = STATE(1367),
    [sym_array] = STATE(1369),
    [sym_class] = STATE(1528),
    [sym_class_declaration] = STATE(572),
    [sym_function] = STATE(1528),
    [sym_function_declaration] = STATE(572),
    [sym_generator_function] = STATE(1528),
    [sym_generator_function_declaration] = STATE(572),
    [sym_arrow_function] = STATE(1528),
    [sym__call_signature] = STATE(3359),
    [sym_call_expression] = STATE(1528),
    [sym_new_expression] = STATE(1543),
    [sym_await_expression] = STATE(1543),
    [sym_member_expression] = STATE(933),
    [sym_subscript_expression] = STATE(933),
    [sym_assignment_expression] = STATE(1543),
    [sym__augmented_assignment_lhs] = STATE(1970),
    [sym_augmented_assignment_expression] = STATE(1543),
    [sym_ternary_expression] = STATE(1543),
    [sym_binary_expression] = STATE(1543),
    [sym_unary_expression] = STATE(1543),
    [sym_update_expression] = STATE(1543),
    [sym_sequence_expression] = STATE(3070),
    [sym_string] = STATE(1528),
    [sym_template_string] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_meta_property] = STATE(1528),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(936),
    [sym_function_signature] = STATE(572),
    [sym_type_assertion] = STATE(1543),
    [sym_as_expression] = STATE(1543),
    [sym_ambient_declaration] = STATE(572),
    [sym_abstract_class_declaration] = STATE(572),
    [sym_module] = STATE(572),
    [sym_internal_module] = STATE(1383),
    [sym_import_alias] = STATE(572),
    [sym_interface_declaration] = STATE(572),
    [sym_enum_declaration] = STATE(572),
    [sym_type_alias_declaration] = STATE(572),
    [sym_type_arguments] = STATE(381),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2337),
    [sym_identifier] = ACTIONS(393),
    [anon_sym_export] = ACTIONS(395),
    [anon_sym_namespace] = ACTIONS(397),
    [anon_sym_LBRACE] = ACTIONS(399),
    [anon_sym_type] = ACTIONS(401),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(403),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(405),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(407),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(409),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(411),
    [anon_sym_async] = ACTIONS(413),
    [anon_sym_function] = ACTIONS(415),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(417),
    [anon_sym_abstract] = ACTIONS(95),
    [anon_sym_get] = ACTIONS(417),
    [anon_sym_set] = ACTIONS(417),
    [anon_sym_declare] = ACTIONS(419),
    [anon_sym_public] = ACTIONS(417),
    [anon_sym_private] = ACTIONS(417),
    [anon_sym_protected] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(421),
    [anon_sym_any] = ACTIONS(417),
    [anon_sym_number] = ACTIONS(417),
    [anon_sym_boolean] = ACTIONS(417),
    [anon_sym_string] = ACTIONS(417),
    [anon_sym_symbol] = ACTIONS(417),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
    [sym_readonly] = ACTIONS(417),
  },
  [45] = {
    [sym_export_statement] = STATE(541),
    [sym__declaration] = STATE(541),
    [sym_import] = STATE(1528),
    [sym_import_statement] = STATE(541),
    [sym_expression_statement] = STATE(541),
    [sym_variable_declaration] = STATE(572),
    [sym_lexical_declaration] = STATE(572),
    [sym_statement_block] = STATE(541),
    [sym_if_statement] = STATE(541),
    [sym_switch_statement] = STATE(541),
    [sym_for_statement] = STATE(541),
    [sym_for_in_statement] = STATE(541),
    [sym_while_statement] = STATE(541),
    [sym_do_statement] = STATE(541),
    [sym_try_statement] = STATE(541),
    [sym_with_statement] = STATE(541),
    [sym_break_statement] = STATE(541),
    [sym_continue_statement] = STATE(541),
    [sym_debugger_statement] = STATE(541),
    [sym_return_statement] = STATE(541),
    [sym_throw_statement] = STATE(541),
    [sym_empty_statement] = STATE(541),
    [sym_labeled_statement] = STATE(541),
    [sym_parenthesized_expression] = STATE(933),
    [sym__expression] = STATE(1345),
    [sym_yield_expression] = STATE(1543),
    [sym_object] = STATE(1367),
    [sym_array] = STATE(1369),
    [sym_class] = STATE(1528),
    [sym_class_declaration] = STATE(572),
    [sym_function] = STATE(1528),
    [sym_function_declaration] = STATE(572),
    [sym_generator_function] = STATE(1528),
    [sym_generator_function_declaration] = STATE(572),
    [sym_arrow_function] = STATE(1528),
    [sym__call_signature] = STATE(3359),
    [sym_call_expression] = STATE(1528),
    [sym_new_expression] = STATE(1543),
    [sym_await_expression] = STATE(1543),
    [sym_member_expression] = STATE(933),
    [sym_subscript_expression] = STATE(933),
    [sym_assignment_expression] = STATE(1543),
    [sym__augmented_assignment_lhs] = STATE(1970),
    [sym_augmented_assignment_expression] = STATE(1543),
    [sym_ternary_expression] = STATE(1543),
    [sym_binary_expression] = STATE(1543),
    [sym_unary_expression] = STATE(1543),
    [sym_update_expression] = STATE(1543),
    [sym_sequence_expression] = STATE(3070),
    [sym_string] = STATE(1528),
    [sym_template_string] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_meta_property] = STATE(1528),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(936),
    [sym_function_signature] = STATE(572),
    [sym_type_assertion] = STATE(1543),
    [sym_as_expression] = STATE(1543),
    [sym_ambient_declaration] = STATE(572),
    [sym_abstract_class_declaration] = STATE(572),
    [sym_module] = STATE(572),
    [sym_internal_module] = STATE(96),
    [sym_import_alias] = STATE(572),
    [sym_interface_declaration] = STATE(572),
    [sym_enum_declaration] = STATE(572),
    [sym_type_alias_declaration] = STATE(572),
    [sym_type_arguments] = STATE(381),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2307),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(95),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(97),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(99),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
    [sym_readonly] = ACTIONS(93),
  },
  [46] = {
    [sym_export_statement] = STATE(625),
    [sym__declaration] = STATE(625),
    [sym_import] = STATE(1528),
    [sym_import_statement] = STATE(625),
    [sym_expression_statement] = STATE(625),
    [sym_variable_declaration] = STATE(572),
    [sym_lexical_declaration] = STATE(572),
    [sym_statement_block] = STATE(625),
    [sym_if_statement] = STATE(625),
    [sym_switch_statement] = STATE(625),
    [sym_for_statement] = STATE(625),
    [sym_for_in_statement] = STATE(625),
    [sym_while_statement] = STATE(625),
    [sym_do_statement] = STATE(625),
    [sym_try_statement] = STATE(625),
    [sym_with_statement] = STATE(625),
    [sym_break_statement] = STATE(625),
    [sym_continue_statement] = STATE(625),
    [sym_debugger_statement] = STATE(625),
    [sym_return_statement] = STATE(625),
    [sym_throw_statement] = STATE(625),
    [sym_empty_statement] = STATE(625),
    [sym_labeled_statement] = STATE(625),
    [sym_parenthesized_expression] = STATE(933),
    [sym__expression] = STATE(1345),
    [sym_yield_expression] = STATE(1543),
    [sym_object] = STATE(1367),
    [sym_array] = STATE(1369),
    [sym_class] = STATE(1528),
    [sym_class_declaration] = STATE(572),
    [sym_function] = STATE(1528),
    [sym_function_declaration] = STATE(572),
    [sym_generator_function] = STATE(1528),
    [sym_generator_function_declaration] = STATE(572),
    [sym_arrow_function] = STATE(1528),
    [sym__call_signature] = STATE(3359),
    [sym_call_expression] = STATE(1528),
    [sym_new_expression] = STATE(1543),
    [sym_await_expression] = STATE(1543),
    [sym_member_expression] = STATE(933),
    [sym_subscript_expression] = STATE(933),
    [sym_assignment_expression] = STATE(1543),
    [sym__augmented_assignment_lhs] = STATE(1970),
    [sym_augmented_assignment_expression] = STATE(1543),
    [sym_ternary_expression] = STATE(1543),
    [sym_binary_expression] = STATE(1543),
    [sym_unary_expression] = STATE(1543),
    [sym_update_expression] = STATE(1543),
    [sym_sequence_expression] = STATE(3070),
    [sym_string] = STATE(1528),
    [sym_template_string] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_meta_property] = STATE(1528),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(936),
    [sym_function_signature] = STATE(572),
    [sym_type_assertion] = STATE(1543),
    [sym_as_expression] = STATE(1543),
    [sym_ambient_declaration] = STATE(572),
    [sym_abstract_class_declaration] = STATE(572),
    [sym_module] = STATE(572),
    [sym_internal_module] = STATE(96),
    [sym_import_alias] = STATE(572),
    [sym_interface_declaration] = STATE(572),
    [sym_enum_declaration] = STATE(572),
    [sym_type_alias_declaration] = STATE(572),
    [sym_type_arguments] = STATE(381),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2307),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(95),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(97),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(99),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
    [sym_readonly] = ACTIONS(93),
  },
  [47] = {
    [sym_export_statement] = STATE(543),
    [sym__declaration] = STATE(543),
    [sym_import] = STATE(1528),
    [sym_import_statement] = STATE(543),
    [sym_expression_statement] = STATE(543),
    [sym_variable_declaration] = STATE(572),
    [sym_lexical_declaration] = STATE(572),
    [sym_statement_block] = STATE(543),
    [sym_if_statement] = STATE(543),
    [sym_switch_statement] = STATE(543),
    [sym_for_statement] = STATE(543),
    [sym_for_in_statement] = STATE(543),
    [sym_while_statement] = STATE(543),
    [sym_do_statement] = STATE(543),
    [sym_try_statement] = STATE(543),
    [sym_with_statement] = STATE(543),
    [sym_break_statement] = STATE(543),
    [sym_continue_statement] = STATE(543),
    [sym_debugger_statement] = STATE(543),
    [sym_return_statement] = STATE(543),
    [sym_throw_statement] = STATE(543),
    [sym_empty_statement] = STATE(543),
    [sym_labeled_statement] = STATE(543),
    [sym_parenthesized_expression] = STATE(933),
    [sym__expression] = STATE(1345),
    [sym_yield_expression] = STATE(1543),
    [sym_object] = STATE(1367),
    [sym_array] = STATE(1369),
    [sym_class] = STATE(1528),
    [sym_class_declaration] = STATE(572),
    [sym_function] = STATE(1528),
    [sym_function_declaration] = STATE(572),
    [sym_generator_function] = STATE(1528),
    [sym_generator_function_declaration] = STATE(572),
    [sym_arrow_function] = STATE(1528),
    [sym__call_signature] = STATE(3359),
    [sym_call_expression] = STATE(1528),
    [sym_new_expression] = STATE(1543),
    [sym_await_expression] = STATE(1543),
    [sym_member_expression] = STATE(933),
    [sym_subscript_expression] = STATE(933),
    [sym_assignment_expression] = STATE(1543),
    [sym__augmented_assignment_lhs] = STATE(1970),
    [sym_augmented_assignment_expression] = STATE(1543),
    [sym_ternary_expression] = STATE(1543),
    [sym_binary_expression] = STATE(1543),
    [sym_unary_expression] = STATE(1543),
    [sym_update_expression] = STATE(1543),
    [sym_sequence_expression] = STATE(3070),
    [sym_string] = STATE(1528),
    [sym_template_string] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_meta_property] = STATE(1528),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(936),
    [sym_function_signature] = STATE(572),
    [sym_type_assertion] = STATE(1543),
    [sym_as_expression] = STATE(1543),
    [sym_ambient_declaration] = STATE(572),
    [sym_abstract_class_declaration] = STATE(572),
    [sym_module] = STATE(572),
    [sym_internal_module] = STATE(1383),
    [sym_import_alias] = STATE(572),
    [sym_interface_declaration] = STATE(572),
    [sym_enum_declaration] = STATE(572),
    [sym_type_alias_declaration] = STATE(572),
    [sym_type_arguments] = STATE(381),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2337),
    [sym_identifier] = ACTIONS(393),
    [anon_sym_export] = ACTIONS(395),
    [anon_sym_namespace] = ACTIONS(397),
    [anon_sym_LBRACE] = ACTIONS(399),
    [anon_sym_type] = ACTIONS(401),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(403),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(405),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(407),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(409),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(411),
    [anon_sym_async] = ACTIONS(413),
    [anon_sym_function] = ACTIONS(415),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(417),
    [anon_sym_abstract] = ACTIONS(95),
    [anon_sym_get] = ACTIONS(417),
    [anon_sym_set] = ACTIONS(417),
    [anon_sym_declare] = ACTIONS(419),
    [anon_sym_public] = ACTIONS(417),
    [anon_sym_private] = ACTIONS(417),
    [anon_sym_protected] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(421),
    [anon_sym_any] = ACTIONS(417),
    [anon_sym_number] = ACTIONS(417),
    [anon_sym_boolean] = ACTIONS(417),
    [anon_sym_string] = ACTIONS(417),
    [anon_sym_symbol] = ACTIONS(417),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
    [sym_readonly] = ACTIONS(417),
  },
  [48] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(884),
    [sym__expression] = STATE(1137),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1605),
    [sym_array] = STATE(1655),
    [sym_nested_identifier] = STATE(3297),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3336),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(884),
    [sym_subscript_expression] = STATE(884),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1964),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_sequence_expression] = STATE(3314),
    [sym_string] = STATE(1614),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2569),
    [sym_rest_parameter] = STATE(2909),
    [sym_non_null_expression] = STATE(860),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_nested_type_identifier] = STATE(1957),
    [sym_accessibility_modifier] = STATE(1951),
    [sym_required_parameter] = STATE(2909),
    [sym_optional_parameter] = STATE(2909),
    [sym__parameter_name] = STATE(2186),
    [sym__rest_identifier] = STATE(2734),
    [sym__type] = STATE(2666),
    [sym_constructor_type] = STATE(2666),
    [sym__primary_type] = STATE(431),
    [sym_infer_type] = STATE(2666),
    [sym_conditional_type] = STATE(431),
    [sym_generic_type] = STATE(431),
    [sym_type_query] = STATE(431),
    [sym_index_type_query] = STATE(431),
    [sym_lookup_type] = STATE(431),
    [sym_literal_type] = STATE(431),
    [sym__number] = STATE(447),
    [sym_existential_type] = STATE(431),
    [sym_flow_maybe_type] = STATE(431),
    [sym_parenthesized_type] = STATE(431),
    [sym_predefined_type] = STATE(431),
    [sym_type_arguments] = STATE(414),
    [sym_object_type] = STATE(431),
    [sym_type_parameters] = STATE(3038),
    [sym_array_type] = STATE(431),
    [sym__tuple_type_body] = STATE(442),
    [sym_tuple_type] = STATE(431),
    [sym_union_type] = STATE(2666),
    [sym_intersection_type] = STATE(2666),
    [sym_function_type] = STATE(2666),
    [aux_sym_export_statement_repeat1] = STATE(1824),
    [sym_identifier] = ACTIONS(423),
    [anon_sym_export] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(427),
    [anon_sym_namespace] = ACTIONS(429),
    [anon_sym_LBRACE] = ACTIONS(431),
    [anon_sym_type] = ACTIONS(425),
    [anon_sym_typeof] = ACTIONS(433),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(437),
    [anon_sym_LPAREN] = ACTIONS(439),
    [anon_sym_RPAREN] = ACTIONS(441),
    [anon_sym_await] = ACTIONS(443),
    [anon_sym_yield] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(447),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(453),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(457),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(459),
    [anon_sym_QMARK] = ACTIONS(461),
    [anon_sym_AMP] = ACTIONS(463),
    [anon_sym_PIPE] = ACTIONS(465),
    [anon_sym_PLUS] = ACTIONS(467),
    [anon_sym_DASH] = ACTIONS(467),
    [anon_sym_TILDE] = ACTIONS(437),
    [anon_sym_void] = ACTIONS(469),
    [anon_sym_delete] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(473),
    [anon_sym_DASH_DASH] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(481),
    [sym_this] = ACTIONS(483),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(487),
    [sym_false] = ACTIONS(487),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(425),
    [anon_sym_get] = ACTIONS(425),
    [anon_sym_set] = ACTIONS(425),
    [anon_sym_declare] = ACTIONS(425),
    [anon_sym_public] = ACTIONS(489),
    [anon_sym_private] = ACTIONS(489),
    [anon_sym_protected] = ACTIONS(489),
    [anon_sym_module] = ACTIONS(425),
    [anon_sym_any] = ACTIONS(491),
    [anon_sym_number] = ACTIONS(491),
    [anon_sym_boolean] = ACTIONS(491),
    [anon_sym_string] = ACTIONS(491),
    [anon_sym_symbol] = ACTIONS(491),
    [sym_readonly] = ACTIONS(493),
    [anon_sym_infer] = ACTIONS(495),
    [anon_sym_keyof] = ACTIONS(497),
    [anon_sym_LBRACE_PIPE] = ACTIONS(499),
  },
  [49] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(884),
    [sym__expression] = STATE(1191),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1605),
    [sym_array] = STATE(1655),
    [sym_nested_identifier] = STATE(3297),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3336),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(884),
    [sym_subscript_expression] = STATE(884),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1964),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_sequence_expression] = STATE(3320),
    [sym_string] = STATE(1614),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2569),
    [sym_rest_parameter] = STATE(2909),
    [sym_non_null_expression] = STATE(860),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_nested_type_identifier] = STATE(1957),
    [sym_accessibility_modifier] = STATE(1951),
    [sym_required_parameter] = STATE(2909),
    [sym_optional_parameter] = STATE(2909),
    [sym__parameter_name] = STATE(2186),
    [sym__rest_identifier] = STATE(2734),
    [sym__type] = STATE(2666),
    [sym_constructor_type] = STATE(2666),
    [sym__primary_type] = STATE(431),
    [sym_infer_type] = STATE(2666),
    [sym_conditional_type] = STATE(431),
    [sym_generic_type] = STATE(431),
    [sym_type_query] = STATE(431),
    [sym_index_type_query] = STATE(431),
    [sym_lookup_type] = STATE(431),
    [sym_literal_type] = STATE(431),
    [sym__number] = STATE(447),
    [sym_existential_type] = STATE(431),
    [sym_flow_maybe_type] = STATE(431),
    [sym_parenthesized_type] = STATE(431),
    [sym_predefined_type] = STATE(431),
    [sym_type_arguments] = STATE(414),
    [sym_object_type] = STATE(431),
    [sym_type_parameters] = STATE(3038),
    [sym_array_type] = STATE(431),
    [sym__tuple_type_body] = STATE(442),
    [sym_tuple_type] = STATE(431),
    [sym_union_type] = STATE(2666),
    [sym_intersection_type] = STATE(2666),
    [sym_function_type] = STATE(2666),
    [aux_sym_export_statement_repeat1] = STATE(1824),
    [sym_identifier] = ACTIONS(423),
    [anon_sym_export] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(427),
    [anon_sym_namespace] = ACTIONS(429),
    [anon_sym_LBRACE] = ACTIONS(431),
    [anon_sym_type] = ACTIONS(425),
    [anon_sym_typeof] = ACTIONS(433),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(437),
    [anon_sym_LPAREN] = ACTIONS(439),
    [anon_sym_RPAREN] = ACTIONS(441),
    [anon_sym_await] = ACTIONS(443),
    [anon_sym_yield] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(447),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(453),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(457),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(459),
    [anon_sym_QMARK] = ACTIONS(461),
    [anon_sym_AMP] = ACTIONS(463),
    [anon_sym_PIPE] = ACTIONS(465),
    [anon_sym_PLUS] = ACTIONS(467),
    [anon_sym_DASH] = ACTIONS(467),
    [anon_sym_TILDE] = ACTIONS(437),
    [anon_sym_void] = ACTIONS(469),
    [anon_sym_delete] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(473),
    [anon_sym_DASH_DASH] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(481),
    [sym_this] = ACTIONS(483),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(487),
    [sym_false] = ACTIONS(487),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(425),
    [anon_sym_get] = ACTIONS(425),
    [anon_sym_set] = ACTIONS(425),
    [anon_sym_declare] = ACTIONS(425),
    [anon_sym_public] = ACTIONS(489),
    [anon_sym_private] = ACTIONS(489),
    [anon_sym_protected] = ACTIONS(489),
    [anon_sym_module] = ACTIONS(425),
    [anon_sym_any] = ACTIONS(491),
    [anon_sym_number] = ACTIONS(491),
    [anon_sym_boolean] = ACTIONS(491),
    [anon_sym_string] = ACTIONS(491),
    [anon_sym_symbol] = ACTIONS(491),
    [sym_readonly] = ACTIONS(493),
    [anon_sym_infer] = ACTIONS(495),
    [anon_sym_keyof] = ACTIONS(497),
    [anon_sym_LBRACE_PIPE] = ACTIONS(499),
  },
  [50] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(884),
    [sym__expression] = STATE(1191),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1605),
    [sym_array] = STATE(1655),
    [sym_nested_identifier] = STATE(3297),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3336),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(884),
    [sym_subscript_expression] = STATE(884),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1964),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_sequence_expression] = STATE(3320),
    [sym_string] = STATE(1614),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2569),
    [sym_rest_parameter] = STATE(2909),
    [sym_non_null_expression] = STATE(860),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_nested_type_identifier] = STATE(1957),
    [sym_accessibility_modifier] = STATE(1951),
    [sym_required_parameter] = STATE(2909),
    [sym_optional_parameter] = STATE(2909),
    [sym__parameter_name] = STATE(2186),
    [sym__rest_identifier] = STATE(2734),
    [sym__type] = STATE(2713),
    [sym_constructor_type] = STATE(2713),
    [sym__primary_type] = STATE(431),
    [sym_infer_type] = STATE(2713),
    [sym_conditional_type] = STATE(431),
    [sym_generic_type] = STATE(431),
    [sym_type_query] = STATE(431),
    [sym_index_type_query] = STATE(431),
    [sym_lookup_type] = STATE(431),
    [sym_literal_type] = STATE(431),
    [sym__number] = STATE(447),
    [sym_existential_type] = STATE(431),
    [sym_flow_maybe_type] = STATE(431),
    [sym_parenthesized_type] = STATE(431),
    [sym_predefined_type] = STATE(431),
    [sym_type_arguments] = STATE(414),
    [sym_object_type] = STATE(431),
    [sym_type_parameters] = STATE(3038),
    [sym_array_type] = STATE(431),
    [sym__tuple_type_body] = STATE(442),
    [sym_tuple_type] = STATE(431),
    [sym_union_type] = STATE(2713),
    [sym_intersection_type] = STATE(2713),
    [sym_function_type] = STATE(2713),
    [aux_sym_export_statement_repeat1] = STATE(1824),
    [sym_identifier] = ACTIONS(423),
    [anon_sym_export] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(427),
    [anon_sym_namespace] = ACTIONS(429),
    [anon_sym_LBRACE] = ACTIONS(431),
    [anon_sym_type] = ACTIONS(425),
    [anon_sym_typeof] = ACTIONS(433),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(437),
    [anon_sym_LPAREN] = ACTIONS(439),
    [anon_sym_RPAREN] = ACTIONS(441),
    [anon_sym_await] = ACTIONS(443),
    [anon_sym_yield] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(447),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(453),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(457),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(459),
    [anon_sym_QMARK] = ACTIONS(461),
    [anon_sym_AMP] = ACTIONS(463),
    [anon_sym_PIPE] = ACTIONS(465),
    [anon_sym_PLUS] = ACTIONS(467),
    [anon_sym_DASH] = ACTIONS(467),
    [anon_sym_TILDE] = ACTIONS(437),
    [anon_sym_void] = ACTIONS(469),
    [anon_sym_delete] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(473),
    [anon_sym_DASH_DASH] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(481),
    [sym_this] = ACTIONS(483),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(487),
    [sym_false] = ACTIONS(487),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(425),
    [anon_sym_get] = ACTIONS(425),
    [anon_sym_set] = ACTIONS(425),
    [anon_sym_declare] = ACTIONS(425),
    [anon_sym_public] = ACTIONS(489),
    [anon_sym_private] = ACTIONS(489),
    [anon_sym_protected] = ACTIONS(489),
    [anon_sym_module] = ACTIONS(425),
    [anon_sym_any] = ACTIONS(491),
    [anon_sym_number] = ACTIONS(491),
    [anon_sym_boolean] = ACTIONS(491),
    [anon_sym_string] = ACTIONS(491),
    [anon_sym_symbol] = ACTIONS(491),
    [sym_readonly] = ACTIONS(493),
    [anon_sym_infer] = ACTIONS(495),
    [anon_sym_keyof] = ACTIONS(497),
    [anon_sym_LBRACE_PIPE] = ACTIONS(499),
  },
  [51] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(884),
    [sym__expression] = STATE(1173),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1605),
    [sym_array] = STATE(1655),
    [sym_nested_identifier] = STATE(3297),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3336),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(884),
    [sym_subscript_expression] = STATE(884),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1964),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_sequence_expression] = STATE(3358),
    [sym_string] = STATE(1614),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2569),
    [sym_rest_parameter] = STATE(2909),
    [sym_non_null_expression] = STATE(860),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_nested_type_identifier] = STATE(1957),
    [sym_accessibility_modifier] = STATE(1951),
    [sym_required_parameter] = STATE(2909),
    [sym_optional_parameter] = STATE(2909),
    [sym__parameter_name] = STATE(2186),
    [sym__rest_identifier] = STATE(2734),
    [sym__type] = STATE(2666),
    [sym_constructor_type] = STATE(2666),
    [sym__primary_type] = STATE(431),
    [sym_infer_type] = STATE(2666),
    [sym_conditional_type] = STATE(431),
    [sym_generic_type] = STATE(431),
    [sym_type_query] = STATE(431),
    [sym_index_type_query] = STATE(431),
    [sym_lookup_type] = STATE(431),
    [sym_literal_type] = STATE(431),
    [sym__number] = STATE(447),
    [sym_existential_type] = STATE(431),
    [sym_flow_maybe_type] = STATE(431),
    [sym_parenthesized_type] = STATE(431),
    [sym_predefined_type] = STATE(431),
    [sym_type_arguments] = STATE(414),
    [sym_object_type] = STATE(431),
    [sym_type_parameters] = STATE(3038),
    [sym_array_type] = STATE(431),
    [sym__tuple_type_body] = STATE(442),
    [sym_tuple_type] = STATE(431),
    [sym_union_type] = STATE(2666),
    [sym_intersection_type] = STATE(2666),
    [sym_function_type] = STATE(2666),
    [aux_sym_export_statement_repeat1] = STATE(1824),
    [sym_identifier] = ACTIONS(423),
    [anon_sym_export] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(427),
    [anon_sym_namespace] = ACTIONS(429),
    [anon_sym_LBRACE] = ACTIONS(431),
    [anon_sym_type] = ACTIONS(425),
    [anon_sym_typeof] = ACTIONS(433),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(437),
    [anon_sym_LPAREN] = ACTIONS(439),
    [anon_sym_RPAREN] = ACTIONS(441),
    [anon_sym_await] = ACTIONS(443),
    [anon_sym_yield] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(447),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(453),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(457),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(459),
    [anon_sym_QMARK] = ACTIONS(461),
    [anon_sym_AMP] = ACTIONS(463),
    [anon_sym_PIPE] = ACTIONS(465),
    [anon_sym_PLUS] = ACTIONS(467),
    [anon_sym_DASH] = ACTIONS(467),
    [anon_sym_TILDE] = ACTIONS(437),
    [anon_sym_void] = ACTIONS(469),
    [anon_sym_delete] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(473),
    [anon_sym_DASH_DASH] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(481),
    [sym_this] = ACTIONS(483),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(487),
    [sym_false] = ACTIONS(487),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(425),
    [anon_sym_get] = ACTIONS(425),
    [anon_sym_set] = ACTIONS(425),
    [anon_sym_declare] = ACTIONS(425),
    [anon_sym_public] = ACTIONS(489),
    [anon_sym_private] = ACTIONS(489),
    [anon_sym_protected] = ACTIONS(489),
    [anon_sym_module] = ACTIONS(425),
    [anon_sym_any] = ACTIONS(491),
    [anon_sym_number] = ACTIONS(491),
    [anon_sym_boolean] = ACTIONS(491),
    [anon_sym_string] = ACTIONS(491),
    [anon_sym_symbol] = ACTIONS(491),
    [sym_readonly] = ACTIONS(493),
    [anon_sym_infer] = ACTIONS(495),
    [anon_sym_keyof] = ACTIONS(497),
    [anon_sym_LBRACE_PIPE] = ACTIONS(499),
  },
  [52] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(884),
    [sym__expression] = STATE(1096),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1283),
    [sym_array] = STATE(1281),
    [sym_nested_identifier] = STATE(3297),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3336),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(884),
    [sym_subscript_expression] = STATE(884),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1964),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1115),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2569),
    [sym_non_null_expression] = STATE(860),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_nested_type_identifier] = STATE(1957),
    [sym__type] = STATE(2358),
    [sym_constructor_type] = STATE(2358),
    [sym__primary_type] = STATE(431),
    [sym_infer_type] = STATE(2358),
    [sym_conditional_type] = STATE(431),
    [sym_generic_type] = STATE(431),
    [sym_type_query] = STATE(431),
    [sym_index_type_query] = STATE(431),
    [sym_lookup_type] = STATE(431),
    [sym_literal_type] = STATE(431),
    [sym__number] = STATE(447),
    [sym_existential_type] = STATE(431),
    [sym_flow_maybe_type] = STATE(431),
    [sym_parenthesized_type] = STATE(431),
    [sym_predefined_type] = STATE(431),
    [sym_type_arguments] = STATE(414),
    [sym_object_type] = STATE(431),
    [sym_type_parameters] = STATE(3038),
    [sym_array_type] = STATE(431),
    [sym__tuple_type_body] = STATE(442),
    [sym_tuple_type] = STATE(431),
    [sym_union_type] = STATE(2358),
    [sym_intersection_type] = STATE(2358),
    [sym_function_type] = STATE(2358),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(501),
    [anon_sym_export] = ACTIONS(503),
    [anon_sym_STAR] = ACTIONS(427),
    [anon_sym_namespace] = ACTIONS(505),
    [anon_sym_LBRACE] = ACTIONS(507),
    [anon_sym_type] = ACTIONS(503),
    [anon_sym_typeof] = ACTIONS(509),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(437),
    [anon_sym_LPAREN] = ACTIONS(439),
    [anon_sym_await] = ACTIONS(443),
    [anon_sym_yield] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(511),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(457),
    [anon_sym_QMARK] = ACTIONS(461),
    [anon_sym_AMP] = ACTIONS(463),
    [anon_sym_PIPE] = ACTIONS(465),
    [anon_sym_PLUS] = ACTIONS(515),
    [anon_sym_DASH] = ACTIONS(515),
    [anon_sym_TILDE] = ACTIONS(437),
    [anon_sym_void] = ACTIONS(469),
    [anon_sym_delete] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(473),
    [anon_sym_DASH_DASH] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(517),
    [sym_this] = ACTIONS(519),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(521),
    [sym_false] = ACTIONS(521),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(503),
    [anon_sym_get] = ACTIONS(503),
    [anon_sym_set] = ACTIONS(503),
    [anon_sym_declare] = ACTIONS(503),
    [anon_sym_public] = ACTIONS(503),
    [anon_sym_private] = ACTIONS(503),
    [anon_sym_protected] = ACTIONS(503),
    [anon_sym_module] = ACTIONS(503),
    [anon_sym_any] = ACTIONS(523),
    [anon_sym_number] = ACTIONS(523),
    [anon_sym_boolean] = ACTIONS(523),
    [anon_sym_string] = ACTIONS(523),
    [anon_sym_symbol] = ACTIONS(523),
    [sym_readonly] = ACTIONS(525),
    [anon_sym_infer] = ACTIONS(495),
    [anon_sym_keyof] = ACTIONS(497),
    [anon_sym_LBRACE_PIPE] = ACTIONS(499),
  },
  [53] = {
    [sym_import] = STATE(1528),
    [sym_parenthesized_expression] = STATE(983),
    [sym__expression] = STATE(1434),
    [sym_yield_expression] = STATE(1543),
    [sym_object] = STATE(1671),
    [sym_array] = STATE(1713),
    [sym_nested_identifier] = STATE(3297),
    [sym_class] = STATE(1528),
    [sym_function] = STATE(1528),
    [sym_generator_function] = STATE(1528),
    [sym_arrow_function] = STATE(1528),
    [sym__call_signature] = STATE(3235),
    [sym_call_expression] = STATE(1528),
    [sym_new_expression] = STATE(1543),
    [sym_await_expression] = STATE(1543),
    [sym_member_expression] = STATE(983),
    [sym_subscript_expression] = STATE(983),
    [sym_assignment_expression] = STATE(1543),
    [sym__augmented_assignment_lhs] = STATE(1963),
    [sym_augmented_assignment_expression] = STATE(1543),
    [sym_ternary_expression] = STATE(1543),
    [sym_binary_expression] = STATE(1543),
    [sym_unary_expression] = STATE(1543),
    [sym_update_expression] = STATE(1543),
    [sym_string] = STATE(1538),
    [sym_template_string] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_meta_property] = STATE(1528),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2569),
    [sym_non_null_expression] = STATE(984),
    [sym_type_assertion] = STATE(1543),
    [sym_as_expression] = STATE(1543),
    [sym_internal_module] = STATE(1543),
    [sym_nested_type_identifier] = STATE(1957),
    [sym__type] = STATE(2358),
    [sym_constructor_type] = STATE(2358),
    [sym__primary_type] = STATE(431),
    [sym_infer_type] = STATE(2358),
    [sym_conditional_type] = STATE(431),
    [sym_generic_type] = STATE(431),
    [sym_type_query] = STATE(431),
    [sym_index_type_query] = STATE(431),
    [sym_lookup_type] = STATE(431),
    [sym_literal_type] = STATE(431),
    [sym__number] = STATE(447),
    [sym_existential_type] = STATE(431),
    [sym_flow_maybe_type] = STATE(431),
    [sym_parenthesized_type] = STATE(431),
    [sym_predefined_type] = STATE(431),
    [sym_type_arguments] = STATE(310),
    [sym_object_type] = STATE(431),
    [sym_type_parameters] = STATE(3038),
    [sym_array_type] = STATE(431),
    [sym__tuple_type_body] = STATE(442),
    [sym_tuple_type] = STATE(431),
    [sym_union_type] = STATE(2358),
    [sym_intersection_type] = STATE(2358),
    [sym_function_type] = STATE(2358),
    [aux_sym_export_statement_repeat1] = STATE(2726),
    [sym_identifier] = ACTIONS(527),
    [anon_sym_export] = ACTIONS(529),
    [anon_sym_STAR] = ACTIONS(427),
    [anon_sym_namespace] = ACTIONS(531),
    [anon_sym_LBRACE] = ACTIONS(533),
    [anon_sym_type] = ACTIONS(529),
    [anon_sym_typeof] = ACTIONS(535),
    [anon_sym_import] = ACTIONS(537),
    [anon_sym_BANG] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(541),
    [anon_sym_await] = ACTIONS(543),
    [anon_sym_yield] = ACTIONS(545),
    [anon_sym_LBRACK] = ACTIONS(547),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(549),
    [anon_sym_async] = ACTIONS(551),
    [anon_sym_function] = ACTIONS(553),
    [anon_sym_new] = ACTIONS(555),
    [anon_sym_QMARK] = ACTIONS(461),
    [anon_sym_AMP] = ACTIONS(463),
    [anon_sym_PIPE] = ACTIONS(465),
    [anon_sym_PLUS] = ACTIONS(557),
    [anon_sym_DASH] = ACTIONS(557),
    [anon_sym_TILDE] = ACTIONS(539),
    [anon_sym_void] = ACTIONS(559),
    [anon_sym_delete] = ACTIONS(561),
    [anon_sym_PLUS_PLUS] = ACTIONS(563),
    [anon_sym_DASH_DASH] = ACTIONS(563),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(565),
    [sym_this] = ACTIONS(567),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(569),
    [sym_false] = ACTIONS(569),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(529),
    [anon_sym_get] = ACTIONS(529),
    [anon_sym_set] = ACTIONS(529),
    [anon_sym_declare] = ACTIONS(529),
    [anon_sym_public] = ACTIONS(529),
    [anon_sym_private] = ACTIONS(529),
    [anon_sym_protected] = ACTIONS(529),
    [anon_sym_module] = ACTIONS(529),
    [anon_sym_any] = ACTIONS(571),
    [anon_sym_number] = ACTIONS(571),
    [anon_sym_boolean] = ACTIONS(571),
    [anon_sym_string] = ACTIONS(571),
    [anon_sym_symbol] = ACTIONS(571),
    [sym_readonly] = ACTIONS(573),
    [anon_sym_infer] = ACTIONS(495),
    [anon_sym_keyof] = ACTIONS(497),
    [anon_sym_LBRACE_PIPE] = ACTIONS(499),
  },
  [54] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(884),
    [sym__expression] = STATE(1352),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1283),
    [sym_array] = STATE(1281),
    [sym_nested_identifier] = STATE(3166),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3336),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(884),
    [sym_subscript_expression] = STATE(884),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1964),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1254),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2568),
    [sym_non_null_expression] = STATE(860),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_nested_type_identifier] = STATE(1983),
    [sym__type] = STATE(2065),
    [sym_constructor_type] = STATE(2065),
    [sym__primary_type] = STATE(2018),
    [sym_infer_type] = STATE(2065),
    [sym_conditional_type] = STATE(2018),
    [sym_generic_type] = STATE(2018),
    [sym_type_query] = STATE(2018),
    [sym_index_type_query] = STATE(2018),
    [sym_lookup_type] = STATE(2018),
    [sym_literal_type] = STATE(2018),
    [sym__number] = STATE(2017),
    [sym_existential_type] = STATE(2018),
    [sym_flow_maybe_type] = STATE(2018),
    [sym_parenthesized_type] = STATE(2018),
    [sym_predefined_type] = STATE(2018),
    [sym_type_arguments] = STATE(414),
    [sym_object_type] = STATE(2018),
    [sym_type_parameters] = STATE(3142),
    [sym_array_type] = STATE(2018),
    [sym__tuple_type_body] = STATE(2025),
    [sym_tuple_type] = STATE(2018),
    [sym_union_type] = STATE(2065),
    [sym_intersection_type] = STATE(2065),
    [sym_function_type] = STATE(2065),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(575),
    [anon_sym_export] = ACTIONS(503),
    [anon_sym_STAR] = ACTIONS(577),
    [anon_sym_namespace] = ACTIONS(505),
    [anon_sym_LBRACE] = ACTIONS(579),
    [anon_sym_type] = ACTIONS(503),
    [anon_sym_typeof] = ACTIONS(581),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(437),
    [anon_sym_LPAREN] = ACTIONS(583),
    [anon_sym_await] = ACTIONS(443),
    [anon_sym_yield] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(585),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(587),
    [anon_sym_QMARK] = ACTIONS(589),
    [anon_sym_AMP] = ACTIONS(591),
    [anon_sym_PIPE] = ACTIONS(593),
    [anon_sym_PLUS] = ACTIONS(595),
    [anon_sym_DASH] = ACTIONS(595),
    [anon_sym_TILDE] = ACTIONS(437),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(473),
    [anon_sym_DASH_DASH] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(599),
    [sym_this] = ACTIONS(601),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(603),
    [sym_false] = ACTIONS(603),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(503),
    [anon_sym_get] = ACTIONS(503),
    [anon_sym_set] = ACTIONS(503),
    [anon_sym_declare] = ACTIONS(503),
    [anon_sym_public] = ACTIONS(503),
    [anon_sym_private] = ACTIONS(503),
    [anon_sym_protected] = ACTIONS(503),
    [anon_sym_module] = ACTIONS(503),
    [anon_sym_any] = ACTIONS(605),
    [anon_sym_number] = ACTIONS(605),
    [anon_sym_boolean] = ACTIONS(605),
    [anon_sym_string] = ACTIONS(605),
    [anon_sym_symbol] = ACTIONS(605),
    [sym_readonly] = ACTIONS(607),
    [anon_sym_infer] = ACTIONS(609),
    [anon_sym_keyof] = ACTIONS(611),
    [anon_sym_LBRACE_PIPE] = ACTIONS(613),
  },
  [55] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(978),
    [sym__expression] = STATE(1483),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1696),
    [sym_array] = STATE(1691),
    [sym_nested_identifier] = STATE(3297),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3169),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(978),
    [sym_subscript_expression] = STATE(978),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1967),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1638),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2569),
    [sym_non_null_expression] = STATE(977),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_nested_type_identifier] = STATE(1957),
    [sym__type] = STATE(2358),
    [sym_constructor_type] = STATE(2358),
    [sym__primary_type] = STATE(431),
    [sym_infer_type] = STATE(2358),
    [sym_conditional_type] = STATE(431),
    [sym_generic_type] = STATE(431),
    [sym_type_query] = STATE(431),
    [sym_index_type_query] = STATE(431),
    [sym_lookup_type] = STATE(431),
    [sym_literal_type] = STATE(431),
    [sym__number] = STATE(447),
    [sym_existential_type] = STATE(431),
    [sym_flow_maybe_type] = STATE(431),
    [sym_parenthesized_type] = STATE(431),
    [sym_predefined_type] = STATE(431),
    [sym_type_arguments] = STATE(380),
    [sym_object_type] = STATE(431),
    [sym_type_parameters] = STATE(3038),
    [sym_array_type] = STATE(431),
    [sym__tuple_type_body] = STATE(442),
    [sym_tuple_type] = STATE(431),
    [sym_union_type] = STATE(2358),
    [sym_intersection_type] = STATE(2358),
    [sym_function_type] = STATE(2358),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(615),
    [anon_sym_export] = ACTIONS(617),
    [anon_sym_STAR] = ACTIONS(427),
    [anon_sym_namespace] = ACTIONS(619),
    [anon_sym_LBRACE] = ACTIONS(507),
    [anon_sym_type] = ACTIONS(617),
    [anon_sym_typeof] = ACTIONS(621),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(439),
    [anon_sym_await] = ACTIONS(625),
    [anon_sym_yield] = ACTIONS(627),
    [anon_sym_LBRACK] = ACTIONS(629),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(631),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_QMARK] = ACTIONS(461),
    [anon_sym_AMP] = ACTIONS(463),
    [anon_sym_PIPE] = ACTIONS(465),
    [anon_sym_PLUS] = ACTIONS(635),
    [anon_sym_DASH] = ACTIONS(635),
    [anon_sym_TILDE] = ACTIONS(623),
    [anon_sym_void] = ACTIONS(637),
    [anon_sym_delete] = ACTIONS(639),
    [anon_sym_PLUS_PLUS] = ACTIONS(641),
    [anon_sym_DASH_DASH] = ACTIONS(641),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(643),
    [sym_this] = ACTIONS(645),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(647),
    [sym_false] = ACTIONS(647),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(617),
    [anon_sym_get] = ACTIONS(617),
    [anon_sym_set] = ACTIONS(617),
    [anon_sym_declare] = ACTIONS(617),
    [anon_sym_public] = ACTIONS(617),
    [anon_sym_private] = ACTIONS(617),
    [anon_sym_protected] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(617),
    [anon_sym_any] = ACTIONS(649),
    [anon_sym_number] = ACTIONS(649),
    [anon_sym_boolean] = ACTIONS(649),
    [anon_sym_string] = ACTIONS(649),
    [anon_sym_symbol] = ACTIONS(649),
    [sym_readonly] = ACTIONS(651),
    [anon_sym_infer] = ACTIONS(495),
    [anon_sym_keyof] = ACTIONS(497),
    [anon_sym_LBRACE_PIPE] = ACTIONS(499),
  },
  [56] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(963),
    [sym__expression] = STATE(1274),
    [sym_yield_expression] = STATE(1722),
    [sym_object] = STATE(1536),
    [sym_array] = STATE(1535),
    [sym_nested_identifier] = STATE(3297),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(3286),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1722),
    [sym_await_expression] = STATE(1722),
    [sym_member_expression] = STATE(963),
    [sym_subscript_expression] = STATE(963),
    [sym_assignment_expression] = STATE(1722),
    [sym__augmented_assignment_lhs] = STATE(1968),
    [sym_augmented_assignment_expression] = STATE(1722),
    [sym_ternary_expression] = STATE(1722),
    [sym_binary_expression] = STATE(1722),
    [sym_unary_expression] = STATE(1722),
    [sym_update_expression] = STATE(1722),
    [sym_string] = STATE(1575),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2569),
    [sym_non_null_expression] = STATE(952),
    [sym_type_assertion] = STATE(1722),
    [sym_as_expression] = STATE(1722),
    [sym_internal_module] = STATE(1722),
    [sym_nested_type_identifier] = STATE(1957),
    [sym__type] = STATE(2358),
    [sym_constructor_type] = STATE(2358),
    [sym__primary_type] = STATE(431),
    [sym_infer_type] = STATE(2358),
    [sym_conditional_type] = STATE(431),
    [sym_generic_type] = STATE(431),
    [sym_type_query] = STATE(431),
    [sym_index_type_query] = STATE(431),
    [sym_lookup_type] = STATE(431),
    [sym_literal_type] = STATE(431),
    [sym__number] = STATE(447),
    [sym_existential_type] = STATE(431),
    [sym_flow_maybe_type] = STATE(431),
    [sym_parenthesized_type] = STATE(431),
    [sym_predefined_type] = STATE(431),
    [sym_type_arguments] = STATE(266),
    [sym_object_type] = STATE(431),
    [sym_type_parameters] = STATE(3038),
    [sym_array_type] = STATE(431),
    [sym__tuple_type_body] = STATE(442),
    [sym_tuple_type] = STATE(431),
    [sym_union_type] = STATE(2358),
    [sym_intersection_type] = STATE(2358),
    [sym_function_type] = STATE(2358),
    [aux_sym_export_statement_repeat1] = STATE(2684),
    [sym_identifier] = ACTIONS(653),
    [anon_sym_export] = ACTIONS(655),
    [anon_sym_STAR] = ACTIONS(427),
    [anon_sym_namespace] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(659),
    [anon_sym_type] = ACTIONS(655),
    [anon_sym_typeof] = ACTIONS(661),
    [anon_sym_import] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_LPAREN] = ACTIONS(667),
    [anon_sym_await] = ACTIONS(669),
    [anon_sym_yield] = ACTIONS(671),
    [anon_sym_LBRACK] = ACTIONS(673),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(675),
    [anon_sym_class] = ACTIONS(677),
    [anon_sym_async] = ACTIONS(679),
    [anon_sym_function] = ACTIONS(681),
    [anon_sym_new] = ACTIONS(683),
    [anon_sym_QMARK] = ACTIONS(461),
    [anon_sym_AMP] = ACTIONS(463),
    [anon_sym_PIPE] = ACTIONS(465),
    [anon_sym_PLUS] = ACTIONS(685),
    [anon_sym_DASH] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_void] = ACTIONS(687),
    [anon_sym_delete] = ACTIONS(689),
    [anon_sym_PLUS_PLUS] = ACTIONS(691),
    [anon_sym_DASH_DASH] = ACTIONS(691),
    [anon_sym_DQUOTE] = ACTIONS(693),
    [anon_sym_SQUOTE] = ACTIONS(695),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(697),
    [sym_number] = ACTIONS(699),
    [sym_this] = ACTIONS(701),
    [sym_super] = ACTIONS(703),
    [sym_true] = ACTIONS(705),
    [sym_false] = ACTIONS(705),
    [sym_null] = ACTIONS(703),
    [sym_undefined] = ACTIONS(703),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(655),
    [anon_sym_get] = ACTIONS(655),
    [anon_sym_set] = ACTIONS(655),
    [anon_sym_declare] = ACTIONS(655),
    [anon_sym_public] = ACTIONS(655),
    [anon_sym_private] = ACTIONS(655),
    [anon_sym_protected] = ACTIONS(655),
    [anon_sym_module] = ACTIONS(655),
    [anon_sym_any] = ACTIONS(707),
    [anon_sym_number] = ACTIONS(707),
    [anon_sym_boolean] = ACTIONS(707),
    [anon_sym_string] = ACTIONS(707),
    [anon_sym_symbol] = ACTIONS(707),
    [sym_readonly] = ACTIONS(709),
    [anon_sym_infer] = ACTIONS(495),
    [anon_sym_keyof] = ACTIONS(497),
    [anon_sym_LBRACE_PIPE] = ACTIONS(499),
  },
  [57] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(965),
    [sym__expression] = STATE(1262),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1524),
    [sym_array] = STATE(1523),
    [sym_nested_identifier] = STATE(3297),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3348),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(965),
    [sym_subscript_expression] = STATE(965),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1969),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1115),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2569),
    [sym_non_null_expression] = STATE(975),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_nested_type_identifier] = STATE(1957),
    [sym__type] = STATE(2358),
    [sym_constructor_type] = STATE(2358),
    [sym__primary_type] = STATE(431),
    [sym_infer_type] = STATE(2358),
    [sym_conditional_type] = STATE(431),
    [sym_generic_type] = STATE(431),
    [sym_type_query] = STATE(431),
    [sym_index_type_query] = STATE(431),
    [sym_lookup_type] = STATE(431),
    [sym_literal_type] = STATE(431),
    [sym__number] = STATE(447),
    [sym_existential_type] = STATE(431),
    [sym_flow_maybe_type] = STATE(431),
    [sym_parenthesized_type] = STATE(431),
    [sym_predefined_type] = STATE(431),
    [sym_type_arguments] = STATE(302),
    [sym_object_type] = STATE(431),
    [sym_type_parameters] = STATE(3038),
    [sym_array_type] = STATE(431),
    [sym__tuple_type_body] = STATE(442),
    [sym_tuple_type] = STATE(431),
    [sym_union_type] = STATE(2358),
    [sym_intersection_type] = STATE(2358),
    [sym_function_type] = STATE(2358),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(711),
    [anon_sym_export] = ACTIONS(713),
    [anon_sym_STAR] = ACTIONS(427),
    [anon_sym_namespace] = ACTIONS(715),
    [anon_sym_LBRACE] = ACTIONS(507),
    [anon_sym_type] = ACTIONS(713),
    [anon_sym_typeof] = ACTIONS(717),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(719),
    [anon_sym_LPAREN] = ACTIONS(439),
    [anon_sym_await] = ACTIONS(721),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_LBRACK] = ACTIONS(511),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(725),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(727),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(729),
    [anon_sym_QMARK] = ACTIONS(461),
    [anon_sym_AMP] = ACTIONS(463),
    [anon_sym_PIPE] = ACTIONS(465),
    [anon_sym_PLUS] = ACTIONS(731),
    [anon_sym_DASH] = ACTIONS(731),
    [anon_sym_TILDE] = ACTIONS(719),
    [anon_sym_void] = ACTIONS(733),
    [anon_sym_delete] = ACTIONS(735),
    [anon_sym_PLUS_PLUS] = ACTIONS(737),
    [anon_sym_DASH_DASH] = ACTIONS(737),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(517),
    [sym_this] = ACTIONS(519),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(521),
    [sym_false] = ACTIONS(521),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(713),
    [anon_sym_get] = ACTIONS(713),
    [anon_sym_set] = ACTIONS(713),
    [anon_sym_declare] = ACTIONS(713),
    [anon_sym_public] = ACTIONS(713),
    [anon_sym_private] = ACTIONS(713),
    [anon_sym_protected] = ACTIONS(713),
    [anon_sym_module] = ACTIONS(713),
    [anon_sym_any] = ACTIONS(739),
    [anon_sym_number] = ACTIONS(739),
    [anon_sym_boolean] = ACTIONS(739),
    [anon_sym_string] = ACTIONS(739),
    [anon_sym_symbol] = ACTIONS(739),
    [sym_readonly] = ACTIONS(741),
    [anon_sym_infer] = ACTIONS(495),
    [anon_sym_keyof] = ACTIONS(497),
    [anon_sym_LBRACE_PIPE] = ACTIONS(499),
  },
  [58] = {
    [sym_import] = STATE(1528),
    [sym_parenthesized_expression] = STATE(933),
    [sym__expression] = STATE(1177),
    [sym_yield_expression] = STATE(1543),
    [sym_object] = STATE(1367),
    [sym_array] = STATE(1369),
    [sym_nested_identifier] = STATE(3297),
    [sym_class] = STATE(1528),
    [sym_function] = STATE(1528),
    [sym_generator_function] = STATE(1528),
    [sym_arrow_function] = STATE(1528),
    [sym__call_signature] = STATE(3359),
    [sym_call_expression] = STATE(1528),
    [sym_new_expression] = STATE(1543),
    [sym_await_expression] = STATE(1543),
    [sym_member_expression] = STATE(933),
    [sym_subscript_expression] = STATE(933),
    [sym_assignment_expression] = STATE(1543),
    [sym__augmented_assignment_lhs] = STATE(1970),
    [sym_augmented_assignment_expression] = STATE(1543),
    [sym_ternary_expression] = STATE(1543),
    [sym_binary_expression] = STATE(1543),
    [sym_unary_expression] = STATE(1543),
    [sym_update_expression] = STATE(1543),
    [sym_string] = STATE(1366),
    [sym_template_string] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_meta_property] = STATE(1528),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2569),
    [sym_non_null_expression] = STATE(936),
    [sym_type_assertion] = STATE(1543),
    [sym_as_expression] = STATE(1543),
    [sym_internal_module] = STATE(1543),
    [sym_nested_type_identifier] = STATE(1957),
    [sym__type] = STATE(2358),
    [sym_constructor_type] = STATE(2358),
    [sym__primary_type] = STATE(431),
    [sym_infer_type] = STATE(2358),
    [sym_conditional_type] = STATE(431),
    [sym_generic_type] = STATE(431),
    [sym_type_query] = STATE(431),
    [sym_index_type_query] = STATE(431),
    [sym_lookup_type] = STATE(431),
    [sym_literal_type] = STATE(431),
    [sym__number] = STATE(447),
    [sym_existential_type] = STATE(431),
    [sym_flow_maybe_type] = STATE(431),
    [sym_parenthesized_type] = STATE(431),
    [sym_predefined_type] = STATE(431),
    [sym_type_arguments] = STATE(381),
    [sym_object_type] = STATE(431),
    [sym_type_parameters] = STATE(3038),
    [sym_array_type] = STATE(431),
    [sym__tuple_type_body] = STATE(442),
    [sym_tuple_type] = STATE(431),
    [sym_union_type] = STATE(2358),
    [sym_intersection_type] = STATE(2358),
    [sym_function_type] = STATE(2358),
    [aux_sym_export_statement_repeat1] = STATE(2726),
    [sym_identifier] = ACTIONS(743),
    [anon_sym_export] = ACTIONS(745),
    [anon_sym_STAR] = ACTIONS(427),
    [anon_sym_namespace] = ACTIONS(747),
    [anon_sym_LBRACE] = ACTIONS(533),
    [anon_sym_type] = ACTIONS(745),
    [anon_sym_typeof] = ACTIONS(749),
    [anon_sym_import] = ACTIONS(537),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(541),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(751),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(549),
    [anon_sym_async] = ACTIONS(753),
    [anon_sym_function] = ACTIONS(553),
    [anon_sym_new] = ACTIONS(755),
    [anon_sym_QMARK] = ACTIONS(461),
    [anon_sym_AMP] = ACTIONS(463),
    [anon_sym_PIPE] = ACTIONS(465),
    [anon_sym_PLUS] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(757),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(759),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(761),
    [sym_this] = ACTIONS(763),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(765),
    [sym_false] = ACTIONS(765),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(745),
    [anon_sym_get] = ACTIONS(745),
    [anon_sym_set] = ACTIONS(745),
    [anon_sym_declare] = ACTIONS(745),
    [anon_sym_public] = ACTIONS(745),
    [anon_sym_private] = ACTIONS(745),
    [anon_sym_protected] = ACTIONS(745),
    [anon_sym_module] = ACTIONS(745),
    [anon_sym_any] = ACTIONS(767),
    [anon_sym_number] = ACTIONS(767),
    [anon_sym_boolean] = ACTIONS(767),
    [anon_sym_string] = ACTIONS(767),
    [anon_sym_symbol] = ACTIONS(767),
    [sym_readonly] = ACTIONS(769),
    [anon_sym_infer] = ACTIONS(495),
    [anon_sym_keyof] = ACTIONS(497),
    [anon_sym_LBRACE_PIPE] = ACTIONS(499),
  },
  [59] = {
    [sym_object] = STATE(2474),
    [sym_array] = STATE(2475),
    [sym_nested_identifier] = STATE(3297),
    [sym_string] = STATE(447),
    [sym_formal_parameters] = STATE(3296),
    [sym_nested_type_identifier] = STATE(1957),
    [sym__type] = STATE(2794),
    [sym_constructor_type] = STATE(2794),
    [sym__primary_type] = STATE(2659),
    [sym_infer_type] = STATE(2794),
    [sym_conditional_type] = STATE(2659),
    [sym_generic_type] = STATE(2659),
    [sym_type_query] = STATE(2659),
    [sym_index_type_query] = STATE(2659),
    [sym_lookup_type] = STATE(2659),
    [sym_literal_type] = STATE(2659),
    [sym__number] = STATE(447),
    [sym_existential_type] = STATE(2659),
    [sym_flow_maybe_type] = STATE(2659),
    [sym_parenthesized_type] = STATE(2659),
    [sym_predefined_type] = STATE(2659),
    [sym_object_type] = STATE(2659),
    [sym_type_parameters] = STATE(3048),
    [sym_array_type] = STATE(2659),
    [sym__tuple_type_body] = STATE(443),
    [sym_tuple_type] = STATE(2659),
    [sym_union_type] = STATE(2794),
    [sym_intersection_type] = STATE(2794),
    [sym_function_type] = STATE(2794),
    [sym_identifier] = ACTIONS(771),
    [anon_sym_export] = ACTIONS(773),
    [anon_sym_STAR] = ACTIONS(775),
    [anon_sym_EQ] = ACTIONS(777),
    [anon_sym_as] = ACTIONS(780),
    [anon_sym_namespace] = ACTIONS(773),
    [anon_sym_LBRACE] = ACTIONS(782),
    [anon_sym_COMMA] = ACTIONS(784),
    [anon_sym_type] = ACTIONS(773),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_BANG] = ACTIONS(780),
    [anon_sym_LPAREN] = ACTIONS(789),
    [anon_sym_RPAREN] = ACTIONS(784),
    [anon_sym_in] = ACTIONS(780),
    [anon_sym_COLON] = ACTIONS(784),
    [anon_sym_LBRACK] = ACTIONS(791),
    [anon_sym_LT] = ACTIONS(793),
    [anon_sym_GT] = ACTIONS(780),
    [anon_sym_SLASH] = ACTIONS(780),
    [anon_sym_DOT] = ACTIONS(795),
    [anon_sym_async] = ACTIONS(773),
    [anon_sym_EQ_GT] = ACTIONS(797),
    [anon_sym_QMARK_DOT] = ACTIONS(799),
    [anon_sym_new] = ACTIONS(801),
    [anon_sym_PLUS_EQ] = ACTIONS(803),
    [anon_sym_DASH_EQ] = ACTIONS(803),
    [anon_sym_STAR_EQ] = ACTIONS(803),
    [anon_sym_SLASH_EQ] = ACTIONS(803),
    [anon_sym_PERCENT_EQ] = ACTIONS(803),
    [anon_sym_CARET_EQ] = ACTIONS(803),
    [anon_sym_AMP_EQ] = ACTIONS(803),
    [anon_sym_PIPE_EQ] = ACTIONS(803),
    [anon_sym_GT_GT_EQ] = ACTIONS(803),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(803),
    [anon_sym_LT_LT_EQ] = ACTIONS(803),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(803),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(803),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(803),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(803),
    [anon_sym_QMARK] = ACTIONS(805),
    [anon_sym_AMP_AMP] = ACTIONS(780),
    [anon_sym_PIPE_PIPE] = ACTIONS(780),
    [anon_sym_GT_GT] = ACTIONS(780),
    [anon_sym_GT_GT_GT] = ACTIONS(780),
    [anon_sym_LT_LT] = ACTIONS(780),
    [anon_sym_AMP] = ACTIONS(807),
    [anon_sym_CARET] = ACTIONS(780),
    [anon_sym_PIPE] = ACTIONS(809),
    [anon_sym_PLUS] = ACTIONS(811),
    [anon_sym_DASH] = ACTIONS(811),
    [anon_sym_PERCENT] = ACTIONS(780),
    [anon_sym_STAR_STAR] = ACTIONS(780),
    [anon_sym_LT_EQ] = ACTIONS(813),
    [anon_sym_EQ_EQ] = ACTIONS(780),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(813),
    [anon_sym_BANG_EQ] = ACTIONS(780),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(813),
    [anon_sym_GT_EQ] = ACTIONS(813),
    [anon_sym_QMARK_QMARK] = ACTIONS(780),
    [anon_sym_instanceof] = ACTIONS(780),
    [anon_sym_void] = ACTIONS(815),
    [anon_sym_PLUS_PLUS] = ACTIONS(813),
    [anon_sym_DASH_DASH] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(817),
    [anon_sym_SQUOTE] = ACTIONS(819),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(813),
    [sym_number] = ACTIONS(821),
    [sym_this] = ACTIONS(823),
    [sym_true] = ACTIONS(825),
    [sym_false] = ACTIONS(825),
    [anon_sym_static] = ACTIONS(773),
    [anon_sym_get] = ACTIONS(773),
    [anon_sym_set] = ACTIONS(773),
    [anon_sym_declare] = ACTIONS(773),
    [anon_sym_public] = ACTIONS(773),
    [anon_sym_private] = ACTIONS(773),
    [anon_sym_protected] = ACTIONS(773),
    [anon_sym_module] = ACTIONS(773),
    [anon_sym_any] = ACTIONS(827),
    [anon_sym_number] = ACTIONS(827),
    [anon_sym_boolean] = ACTIONS(827),
    [anon_sym_string] = ACTIONS(827),
    [anon_sym_symbol] = ACTIONS(827),
    [sym_readonly] = ACTIONS(829),
    [anon_sym_infer] = ACTIONS(495),
    [anon_sym_keyof] = ACTIONS(497),
    [anon_sym_LBRACE_PIPE] = ACTIONS(499),
  },
  [60] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(884),
    [sym__expression] = STATE(1108),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1283),
    [sym_array] = STATE(1281),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3336),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(884),
    [sym_subscript_expression] = STATE(884),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1964),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(860),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(414),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(831),
    [anon_sym_export] = ACTIONS(503),
    [anon_sym_STAR] = ACTIONS(833),
    [anon_sym_as] = ACTIONS(835),
    [anon_sym_namespace] = ACTIONS(505),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_COMMA] = ACTIONS(839),
    [anon_sym_RBRACE] = ACTIONS(839),
    [anon_sym_type] = ACTIONS(503),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(841),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_RPAREN] = ACTIONS(839),
    [anon_sym_await] = ACTIONS(443),
    [anon_sym_in] = ACTIONS(835),
    [anon_sym_COLON] = ACTIONS(839),
    [anon_sym_yield] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_RBRACK] = ACTIONS(839),
    [anon_sym_LT] = ACTIONS(847),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_DOT] = ACTIONS(835),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_QMARK_DOT] = ACTIONS(839),
    [anon_sym_new] = ACTIONS(849),
    [anon_sym_QMARK] = ACTIONS(835),
    [anon_sym_AMP_AMP] = ACTIONS(839),
    [anon_sym_PIPE_PIPE] = ACTIONS(839),
    [anon_sym_GT_GT] = ACTIONS(835),
    [anon_sym_GT_GT_GT] = ACTIONS(839),
    [anon_sym_LT_LT] = ACTIONS(839),
    [anon_sym_AMP] = ACTIONS(835),
    [anon_sym_CARET] = ACTIONS(839),
    [anon_sym_PIPE] = ACTIONS(835),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(851),
    [anon_sym_PERCENT] = ACTIONS(839),
    [anon_sym_STAR_STAR] = ACTIONS(839),
    [anon_sym_LT_EQ] = ACTIONS(839),
    [anon_sym_EQ_EQ] = ACTIONS(835),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(839),
    [anon_sym_BANG_EQ] = ACTIONS(835),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(839),
    [anon_sym_GT_EQ] = ACTIONS(839),
    [anon_sym_QMARK_QMARK] = ACTIONS(839),
    [anon_sym_instanceof] = ACTIONS(835),
    [anon_sym_TILDE] = ACTIONS(437),
    [anon_sym_void] = ACTIONS(471),
    [anon_sym_delete] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(473),
    [anon_sym_DASH_DASH] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(503),
    [anon_sym_get] = ACTIONS(503),
    [anon_sym_set] = ACTIONS(503),
    [anon_sym_declare] = ACTIONS(503),
    [anon_sym_public] = ACTIONS(503),
    [anon_sym_private] = ACTIONS(503),
    [anon_sym_protected] = ACTIONS(503),
    [anon_sym_module] = ACTIONS(503),
    [anon_sym_any] = ACTIONS(503),
    [anon_sym_number] = ACTIONS(503),
    [anon_sym_boolean] = ACTIONS(503),
    [anon_sym_string] = ACTIONS(503),
    [anon_sym_symbol] = ACTIONS(503),
    [sym_readonly] = ACTIONS(503),
  },
  [61] = {
    [sym_import] = STATE(1528),
    [sym_parenthesized_expression] = STATE(933),
    [sym__expression] = STATE(1192),
    [sym_yield_expression] = STATE(1543),
    [sym_object] = STATE(1367),
    [sym_array] = STATE(1369),
    [sym_class] = STATE(1528),
    [sym_function] = STATE(1528),
    [sym_generator_function] = STATE(1528),
    [sym_arrow_function] = STATE(1528),
    [sym__call_signature] = STATE(3359),
    [sym_call_expression] = STATE(1528),
    [sym_new_expression] = STATE(1543),
    [sym_await_expression] = STATE(1543),
    [sym_member_expression] = STATE(933),
    [sym_subscript_expression] = STATE(933),
    [sym_assignment_expression] = STATE(1543),
    [sym__augmented_assignment_lhs] = STATE(1970),
    [sym_augmented_assignment_expression] = STATE(1543),
    [sym_ternary_expression] = STATE(1543),
    [sym_binary_expression] = STATE(1543),
    [sym_unary_expression] = STATE(1543),
    [sym_update_expression] = STATE(1543),
    [sym_string] = STATE(1528),
    [sym_template_string] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_meta_property] = STATE(1528),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(936),
    [sym_type_assertion] = STATE(1543),
    [sym_as_expression] = STATE(1543),
    [sym_internal_module] = STATE(1543),
    [sym_type_arguments] = STATE(381),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2726),
    [sym_identifier] = ACTIONS(855),
    [anon_sym_export] = ACTIONS(745),
    [anon_sym_STAR] = ACTIONS(857),
    [anon_sym_as] = ACTIONS(835),
    [anon_sym_namespace] = ACTIONS(747),
    [anon_sym_LBRACE] = ACTIONS(859),
    [anon_sym_COMMA] = ACTIONS(839),
    [anon_sym_RBRACE] = ACTIONS(839),
    [anon_sym_type] = ACTIONS(745),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(537),
    [anon_sym_BANG] = ACTIONS(861),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_in] = ACTIONS(835),
    [anon_sym_SEMI] = ACTIONS(839),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(847),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_DOT] = ACTIONS(835),
    [anon_sym_class] = ACTIONS(549),
    [anon_sym_async] = ACTIONS(753),
    [anon_sym_function] = ACTIONS(553),
    [anon_sym_QMARK_DOT] = ACTIONS(839),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_QMARK] = ACTIONS(835),
    [anon_sym_AMP_AMP] = ACTIONS(839),
    [anon_sym_PIPE_PIPE] = ACTIONS(839),
    [anon_sym_GT_GT] = ACTIONS(835),
    [anon_sym_GT_GT_GT] = ACTIONS(839),
    [anon_sym_LT_LT] = ACTIONS(839),
    [anon_sym_AMP] = ACTIONS(835),
    [anon_sym_CARET] = ACTIONS(839),
    [anon_sym_PIPE] = ACTIONS(835),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_PERCENT] = ACTIONS(839),
    [anon_sym_STAR_STAR] = ACTIONS(839),
    [anon_sym_LT_EQ] = ACTIONS(839),
    [anon_sym_EQ_EQ] = ACTIONS(835),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(839),
    [anon_sym_BANG_EQ] = ACTIONS(835),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(839),
    [anon_sym_GT_EQ] = ACTIONS(839),
    [anon_sym_QMARK_QMARK] = ACTIONS(839),
    [anon_sym_instanceof] = ACTIONS(835),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(745),
    [anon_sym_get] = ACTIONS(745),
    [anon_sym_set] = ACTIONS(745),
    [anon_sym_declare] = ACTIONS(745),
    [anon_sym_public] = ACTIONS(745),
    [anon_sym_private] = ACTIONS(745),
    [anon_sym_protected] = ACTIONS(745),
    [anon_sym_module] = ACTIONS(745),
    [anon_sym_any] = ACTIONS(745),
    [anon_sym_number] = ACTIONS(745),
    [anon_sym_boolean] = ACTIONS(745),
    [anon_sym_string] = ACTIONS(745),
    [anon_sym_symbol] = ACTIONS(745),
    [sym_readonly] = ACTIONS(745),
    [sym__automatic_semicolon] = ACTIONS(839),
  },
  [62] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(963),
    [sym__expression] = STATE(1261),
    [sym_yield_expression] = STATE(1722),
    [sym_object] = STATE(1536),
    [sym_array] = STATE(1535),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(3286),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1722),
    [sym_await_expression] = STATE(1722),
    [sym_member_expression] = STATE(963),
    [sym_subscript_expression] = STATE(963),
    [sym_assignment_expression] = STATE(1722),
    [sym__augmented_assignment_lhs] = STATE(1968),
    [sym_augmented_assignment_expression] = STATE(1722),
    [sym_ternary_expression] = STATE(1722),
    [sym_binary_expression] = STATE(1722),
    [sym_unary_expression] = STATE(1722),
    [sym_update_expression] = STATE(1722),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(952),
    [sym_type_assertion] = STATE(1722),
    [sym_as_expression] = STATE(1722),
    [sym_internal_module] = STATE(1722),
    [sym_type_arguments] = STATE(266),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2684),
    [sym_identifier] = ACTIONS(863),
    [anon_sym_export] = ACTIONS(655),
    [anon_sym_STAR] = ACTIONS(865),
    [anon_sym_as] = ACTIONS(835),
    [anon_sym_namespace] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(867),
    [anon_sym_COMMA] = ACTIONS(839),
    [anon_sym_type] = ACTIONS(655),
    [anon_sym_typeof] = ACTIONS(689),
    [anon_sym_import] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(869),
    [anon_sym_LPAREN] = ACTIONS(871),
    [anon_sym_await] = ACTIONS(669),
    [anon_sym_in] = ACTIONS(835),
    [anon_sym_yield] = ACTIONS(671),
    [anon_sym_LBRACK] = ACTIONS(873),
    [anon_sym_LT] = ACTIONS(847),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_SLASH] = ACTIONS(675),
    [anon_sym_DOT] = ACTIONS(835),
    [anon_sym_class] = ACTIONS(677),
    [anon_sym_async] = ACTIONS(679),
    [anon_sym_function] = ACTIONS(681),
    [anon_sym_QMARK_DOT] = ACTIONS(839),
    [anon_sym_new] = ACTIONS(875),
    [anon_sym_QMARK] = ACTIONS(835),
    [anon_sym_AMP_AMP] = ACTIONS(839),
    [anon_sym_PIPE_PIPE] = ACTIONS(839),
    [anon_sym_GT_GT] = ACTIONS(835),
    [anon_sym_GT_GT_GT] = ACTIONS(839),
    [anon_sym_LT_LT] = ACTIONS(839),
    [anon_sym_AMP] = ACTIONS(835),
    [anon_sym_CARET] = ACTIONS(839),
    [anon_sym_PIPE] = ACTIONS(835),
    [anon_sym_PLUS] = ACTIONS(877),
    [anon_sym_DASH] = ACTIONS(877),
    [anon_sym_PERCENT] = ACTIONS(839),
    [anon_sym_STAR_STAR] = ACTIONS(839),
    [anon_sym_LT_EQ] = ACTIONS(839),
    [anon_sym_EQ_EQ] = ACTIONS(835),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(839),
    [anon_sym_BANG_EQ] = ACTIONS(835),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(839),
    [anon_sym_GT_EQ] = ACTIONS(839),
    [anon_sym_QMARK_QMARK] = ACTIONS(839),
    [anon_sym_instanceof] = ACTIONS(835),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_void] = ACTIONS(689),
    [anon_sym_delete] = ACTIONS(689),
    [anon_sym_PLUS_PLUS] = ACTIONS(691),
    [anon_sym_DASH_DASH] = ACTIONS(691),
    [anon_sym_DQUOTE] = ACTIONS(693),
    [anon_sym_SQUOTE] = ACTIONS(695),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(697),
    [sym_number] = ACTIONS(879),
    [sym_this] = ACTIONS(703),
    [sym_super] = ACTIONS(703),
    [sym_true] = ACTIONS(703),
    [sym_false] = ACTIONS(703),
    [sym_null] = ACTIONS(703),
    [sym_undefined] = ACTIONS(703),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(655),
    [anon_sym_get] = ACTIONS(655),
    [anon_sym_set] = ACTIONS(655),
    [anon_sym_declare] = ACTIONS(655),
    [anon_sym_public] = ACTIONS(655),
    [anon_sym_private] = ACTIONS(655),
    [anon_sym_protected] = ACTIONS(655),
    [anon_sym_module] = ACTIONS(655),
    [anon_sym_any] = ACTIONS(655),
    [anon_sym_number] = ACTIONS(655),
    [anon_sym_boolean] = ACTIONS(655),
    [anon_sym_string] = ACTIONS(655),
    [anon_sym_symbol] = ACTIONS(655),
    [sym_readonly] = ACTIONS(655),
    [anon_sym_LBRACE_PIPE] = ACTIONS(839),
  },
  [63] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(978),
    [sym__expression] = STATE(1453),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1696),
    [sym_array] = STATE(1691),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3169),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(978),
    [sym_subscript_expression] = STATE(978),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1967),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(977),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(380),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(881),
    [anon_sym_export] = ACTIONS(617),
    [anon_sym_STAR] = ACTIONS(883),
    [anon_sym_as] = ACTIONS(835),
    [anon_sym_namespace] = ACTIONS(619),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_type] = ACTIONS(617),
    [anon_sym_typeof] = ACTIONS(639),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(885),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(625),
    [anon_sym_in] = ACTIONS(835),
    [anon_sym_COLON] = ACTIONS(839),
    [anon_sym_yield] = ACTIONS(627),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_RBRACK] = ACTIONS(839),
    [anon_sym_LT] = ACTIONS(847),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_DOT] = ACTIONS(835),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(631),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_QMARK_DOT] = ACTIONS(839),
    [anon_sym_new] = ACTIONS(887),
    [anon_sym_QMARK] = ACTIONS(835),
    [anon_sym_AMP_AMP] = ACTIONS(839),
    [anon_sym_PIPE_PIPE] = ACTIONS(839),
    [anon_sym_GT_GT] = ACTIONS(835),
    [anon_sym_GT_GT_GT] = ACTIONS(839),
    [anon_sym_LT_LT] = ACTIONS(839),
    [anon_sym_AMP] = ACTIONS(835),
    [anon_sym_CARET] = ACTIONS(839),
    [anon_sym_PIPE] = ACTIONS(835),
    [anon_sym_PLUS] = ACTIONS(889),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(839),
    [anon_sym_STAR_STAR] = ACTIONS(839),
    [anon_sym_LT_EQ] = ACTIONS(839),
    [anon_sym_EQ_EQ] = ACTIONS(835),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(839),
    [anon_sym_BANG_EQ] = ACTIONS(835),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(839),
    [anon_sym_GT_EQ] = ACTIONS(839),
    [anon_sym_QMARK_QMARK] = ACTIONS(839),
    [anon_sym_instanceof] = ACTIONS(835),
    [anon_sym_TILDE] = ACTIONS(623),
    [anon_sym_void] = ACTIONS(639),
    [anon_sym_delete] = ACTIONS(639),
    [anon_sym_PLUS_PLUS] = ACTIONS(641),
    [anon_sym_DASH_DASH] = ACTIONS(641),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(617),
    [anon_sym_get] = ACTIONS(617),
    [anon_sym_set] = ACTIONS(617),
    [anon_sym_declare] = ACTIONS(617),
    [anon_sym_public] = ACTIONS(617),
    [anon_sym_private] = ACTIONS(617),
    [anon_sym_protected] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(617),
    [anon_sym_any] = ACTIONS(617),
    [anon_sym_number] = ACTIONS(617),
    [anon_sym_boolean] = ACTIONS(617),
    [anon_sym_string] = ACTIONS(617),
    [anon_sym_symbol] = ACTIONS(617),
    [sym_readonly] = ACTIONS(617),
  },
  [64] = {
    [sym_import] = STATE(1528),
    [sym_parenthesized_expression] = STATE(983),
    [sym__expression] = STATE(1361),
    [sym_yield_expression] = STATE(1543),
    [sym_object] = STATE(1671),
    [sym_array] = STATE(1713),
    [sym_class] = STATE(1528),
    [sym_function] = STATE(1528),
    [sym_generator_function] = STATE(1528),
    [sym_arrow_function] = STATE(1528),
    [sym__call_signature] = STATE(3235),
    [sym_call_expression] = STATE(1528),
    [sym_new_expression] = STATE(1543),
    [sym_await_expression] = STATE(1543),
    [sym_member_expression] = STATE(983),
    [sym_subscript_expression] = STATE(983),
    [sym_assignment_expression] = STATE(1543),
    [sym__augmented_assignment_lhs] = STATE(1963),
    [sym_augmented_assignment_expression] = STATE(1543),
    [sym_ternary_expression] = STATE(1543),
    [sym_binary_expression] = STATE(1543),
    [sym_unary_expression] = STATE(1543),
    [sym_update_expression] = STATE(1543),
    [sym_string] = STATE(1528),
    [sym_template_string] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_meta_property] = STATE(1528),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(984),
    [sym_type_assertion] = STATE(1543),
    [sym_as_expression] = STATE(1543),
    [sym_internal_module] = STATE(1543),
    [sym_type_arguments] = STATE(310),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2726),
    [sym_identifier] = ACTIONS(891),
    [anon_sym_export] = ACTIONS(529),
    [anon_sym_STAR] = ACTIONS(893),
    [anon_sym_as] = ACTIONS(835),
    [anon_sym_namespace] = ACTIONS(531),
    [anon_sym_LBRACE] = ACTIONS(859),
    [anon_sym_type] = ACTIONS(529),
    [anon_sym_typeof] = ACTIONS(561),
    [anon_sym_import] = ACTIONS(537),
    [anon_sym_BANG] = ACTIONS(895),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(543),
    [anon_sym_in] = ACTIONS(835),
    [anon_sym_SEMI] = ACTIONS(839),
    [anon_sym_yield] = ACTIONS(545),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(847),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_DOT] = ACTIONS(835),
    [anon_sym_class] = ACTIONS(549),
    [anon_sym_async] = ACTIONS(551),
    [anon_sym_function] = ACTIONS(553),
    [anon_sym_QMARK_DOT] = ACTIONS(839),
    [anon_sym_new] = ACTIONS(897),
    [anon_sym_QMARK] = ACTIONS(835),
    [anon_sym_AMP_AMP] = ACTIONS(839),
    [anon_sym_PIPE_PIPE] = ACTIONS(839),
    [anon_sym_GT_GT] = ACTIONS(835),
    [anon_sym_GT_GT_GT] = ACTIONS(839),
    [anon_sym_LT_LT] = ACTIONS(839),
    [anon_sym_AMP] = ACTIONS(835),
    [anon_sym_CARET] = ACTIONS(839),
    [anon_sym_PIPE] = ACTIONS(835),
    [anon_sym_PLUS] = ACTIONS(899),
    [anon_sym_DASH] = ACTIONS(899),
    [anon_sym_PERCENT] = ACTIONS(839),
    [anon_sym_STAR_STAR] = ACTIONS(839),
    [anon_sym_LT_EQ] = ACTIONS(839),
    [anon_sym_EQ_EQ] = ACTIONS(835),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(839),
    [anon_sym_BANG_EQ] = ACTIONS(835),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(839),
    [anon_sym_GT_EQ] = ACTIONS(839),
    [anon_sym_QMARK_QMARK] = ACTIONS(839),
    [anon_sym_instanceof] = ACTIONS(835),
    [anon_sym_TILDE] = ACTIONS(539),
    [anon_sym_void] = ACTIONS(561),
    [anon_sym_delete] = ACTIONS(561),
    [anon_sym_PLUS_PLUS] = ACTIONS(563),
    [anon_sym_DASH_DASH] = ACTIONS(563),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(529),
    [anon_sym_get] = ACTIONS(529),
    [anon_sym_set] = ACTIONS(529),
    [anon_sym_declare] = ACTIONS(529),
    [anon_sym_public] = ACTIONS(529),
    [anon_sym_private] = ACTIONS(529),
    [anon_sym_protected] = ACTIONS(529),
    [anon_sym_module] = ACTIONS(529),
    [anon_sym_any] = ACTIONS(529),
    [anon_sym_number] = ACTIONS(529),
    [anon_sym_boolean] = ACTIONS(529),
    [anon_sym_string] = ACTIONS(529),
    [anon_sym_symbol] = ACTIONS(529),
    [sym_readonly] = ACTIONS(529),
    [sym__automatic_semicolon] = ACTIONS(839),
  },
  [65] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(965),
    [sym__expression] = STATE(1300),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1524),
    [sym_array] = STATE(1523),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3348),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(965),
    [sym_subscript_expression] = STATE(965),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1969),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(975),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(302),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(901),
    [anon_sym_export] = ACTIONS(713),
    [anon_sym_STAR] = ACTIONS(903),
    [anon_sym_as] = ACTIONS(835),
    [anon_sym_namespace] = ACTIONS(715),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_COMMA] = ACTIONS(839),
    [anon_sym_type] = ACTIONS(713),
    [anon_sym_typeof] = ACTIONS(735),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(721),
    [anon_sym_in] = ACTIONS(835),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(847),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_SLASH] = ACTIONS(725),
    [anon_sym_DOT] = ACTIONS(835),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(727),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_QMARK_DOT] = ACTIONS(839),
    [anon_sym_new] = ACTIONS(907),
    [anon_sym_QMARK] = ACTIONS(835),
    [anon_sym_AMP_AMP] = ACTIONS(839),
    [anon_sym_PIPE_PIPE] = ACTIONS(839),
    [anon_sym_GT_GT] = ACTIONS(835),
    [anon_sym_GT_GT_GT] = ACTIONS(839),
    [anon_sym_LT_LT] = ACTIONS(839),
    [anon_sym_AMP] = ACTIONS(835),
    [anon_sym_CARET] = ACTIONS(839),
    [anon_sym_PIPE] = ACTIONS(835),
    [anon_sym_PLUS] = ACTIONS(909),
    [anon_sym_DASH] = ACTIONS(909),
    [anon_sym_PERCENT] = ACTIONS(839),
    [anon_sym_STAR_STAR] = ACTIONS(839),
    [anon_sym_LT_EQ] = ACTIONS(839),
    [anon_sym_EQ_EQ] = ACTIONS(835),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(839),
    [anon_sym_BANG_EQ] = ACTIONS(835),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(839),
    [anon_sym_GT_EQ] = ACTIONS(839),
    [anon_sym_QMARK_QMARK] = ACTIONS(839),
    [anon_sym_instanceof] = ACTIONS(835),
    [anon_sym_TILDE] = ACTIONS(719),
    [anon_sym_void] = ACTIONS(735),
    [anon_sym_delete] = ACTIONS(735),
    [anon_sym_PLUS_PLUS] = ACTIONS(737),
    [anon_sym_DASH_DASH] = ACTIONS(737),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(713),
    [anon_sym_get] = ACTIONS(713),
    [anon_sym_set] = ACTIONS(713),
    [anon_sym_declare] = ACTIONS(713),
    [anon_sym_public] = ACTIONS(713),
    [anon_sym_private] = ACTIONS(713),
    [anon_sym_protected] = ACTIONS(713),
    [anon_sym_module] = ACTIONS(713),
    [anon_sym_any] = ACTIONS(713),
    [anon_sym_number] = ACTIONS(713),
    [anon_sym_boolean] = ACTIONS(713),
    [anon_sym_string] = ACTIONS(713),
    [anon_sym_symbol] = ACTIONS(713),
    [anon_sym_implements] = ACTIONS(835),
    [sym_readonly] = ACTIONS(713),
  },
  [66] = {
    [sym_nested_identifier] = STATE(3297),
    [sym_string] = STATE(447),
    [sym_formal_parameters] = STATE(3296),
    [sym_nested_type_identifier] = STATE(1957),
    [sym__type] = STATE(2794),
    [sym_constructor_type] = STATE(2794),
    [sym__primary_type] = STATE(2659),
    [sym_infer_type] = STATE(2794),
    [sym_conditional_type] = STATE(2659),
    [sym_generic_type] = STATE(2659),
    [sym_type_query] = STATE(2659),
    [sym_index_type_query] = STATE(2659),
    [sym_lookup_type] = STATE(2659),
    [sym_literal_type] = STATE(2659),
    [sym__number] = STATE(447),
    [sym_existential_type] = STATE(2659),
    [sym_flow_maybe_type] = STATE(2659),
    [sym_parenthesized_type] = STATE(2659),
    [sym_predefined_type] = STATE(2659),
    [sym_object_type] = STATE(2659),
    [sym_type_parameters] = STATE(3048),
    [sym_array_type] = STATE(2659),
    [sym__tuple_type_body] = STATE(443),
    [sym_tuple_type] = STATE(2659),
    [sym_union_type] = STATE(2794),
    [sym_intersection_type] = STATE(2794),
    [sym_function_type] = STATE(2794),
    [sym_identifier] = ACTIONS(911),
    [anon_sym_STAR] = ACTIONS(775),
    [anon_sym_EQ] = ACTIONS(913),
    [anon_sym_as] = ACTIONS(780),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_COMMA] = ACTIONS(813),
    [anon_sym_RBRACE] = ACTIONS(813),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_BANG] = ACTIONS(780),
    [anon_sym_LPAREN] = ACTIONS(789),
    [anon_sym_RPAREN] = ACTIONS(813),
    [anon_sym_in] = ACTIONS(780),
    [anon_sym_COLON] = ACTIONS(813),
    [anon_sym_LBRACK] = ACTIONS(917),
    [anon_sym_RBRACK] = ACTIONS(813),
    [anon_sym_LT] = ACTIONS(793),
    [anon_sym_GT] = ACTIONS(780),
    [anon_sym_SLASH] = ACTIONS(780),
    [anon_sym_DOT] = ACTIONS(795),
    [anon_sym_EQ_GT] = ACTIONS(797),
    [anon_sym_QMARK_DOT] = ACTIONS(799),
    [anon_sym_new] = ACTIONS(801),
    [anon_sym_PLUS_EQ] = ACTIONS(803),
    [anon_sym_DASH_EQ] = ACTIONS(803),
    [anon_sym_STAR_EQ] = ACTIONS(803),
    [anon_sym_SLASH_EQ] = ACTIONS(803),
    [anon_sym_PERCENT_EQ] = ACTIONS(803),
    [anon_sym_CARET_EQ] = ACTIONS(803),
    [anon_sym_AMP_EQ] = ACTIONS(803),
    [anon_sym_PIPE_EQ] = ACTIONS(803),
    [anon_sym_GT_GT_EQ] = ACTIONS(803),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(803),
    [anon_sym_LT_LT_EQ] = ACTIONS(803),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(803),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(803),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(803),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(803),
    [anon_sym_QMARK] = ACTIONS(805),
    [anon_sym_AMP_AMP] = ACTIONS(780),
    [anon_sym_PIPE_PIPE] = ACTIONS(780),
    [anon_sym_GT_GT] = ACTIONS(780),
    [anon_sym_GT_GT_GT] = ACTIONS(780),
    [anon_sym_LT_LT] = ACTIONS(780),
    [anon_sym_AMP] = ACTIONS(807),
    [anon_sym_CARET] = ACTIONS(780),
    [anon_sym_PIPE] = ACTIONS(809),
    [anon_sym_PLUS] = ACTIONS(811),
    [anon_sym_DASH] = ACTIONS(811),
    [anon_sym_PERCENT] = ACTIONS(780),
    [anon_sym_STAR_STAR] = ACTIONS(780),
    [anon_sym_LT_EQ] = ACTIONS(813),
    [anon_sym_EQ_EQ] = ACTIONS(780),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(813),
    [anon_sym_BANG_EQ] = ACTIONS(780),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(813),
    [anon_sym_GT_EQ] = ACTIONS(813),
    [anon_sym_QMARK_QMARK] = ACTIONS(780),
    [anon_sym_instanceof] = ACTIONS(780),
    [anon_sym_void] = ACTIONS(815),
    [anon_sym_PLUS_PLUS] = ACTIONS(813),
    [anon_sym_DASH_DASH] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(817),
    [anon_sym_SQUOTE] = ACTIONS(819),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(813),
    [sym_number] = ACTIONS(821),
    [sym_this] = ACTIONS(919),
    [sym_true] = ACTIONS(825),
    [sym_false] = ACTIONS(825),
    [anon_sym_any] = ACTIONS(815),
    [anon_sym_number] = ACTIONS(815),
    [anon_sym_boolean] = ACTIONS(815),
    [anon_sym_string] = ACTIONS(815),
    [anon_sym_symbol] = ACTIONS(815),
    [sym_readonly] = ACTIONS(921),
    [anon_sym_infer] = ACTIONS(495),
    [anon_sym_keyof] = ACTIONS(497),
    [anon_sym_LBRACE_PIPE] = ACTIONS(499),
  },
  [67] = {
    [sym_nested_identifier] = STATE(3297),
    [sym_string] = STATE(447),
    [sym_formal_parameters] = STATE(3296),
    [sym_nested_type_identifier] = STATE(1957),
    [sym__type] = STATE(2794),
    [sym_constructor_type] = STATE(2794),
    [sym__primary_type] = STATE(2659),
    [sym_infer_type] = STATE(2794),
    [sym_conditional_type] = STATE(2659),
    [sym_generic_type] = STATE(2659),
    [sym_type_query] = STATE(2659),
    [sym_index_type_query] = STATE(2659),
    [sym_lookup_type] = STATE(2659),
    [sym_literal_type] = STATE(2659),
    [sym__number] = STATE(447),
    [sym_existential_type] = STATE(2659),
    [sym_flow_maybe_type] = STATE(2659),
    [sym_parenthesized_type] = STATE(2659),
    [sym_predefined_type] = STATE(2659),
    [sym_object_type] = STATE(2659),
    [sym_type_parameters] = STATE(3048),
    [sym_array_type] = STATE(2659),
    [sym__tuple_type_body] = STATE(443),
    [sym_tuple_type] = STATE(2659),
    [sym_union_type] = STATE(2794),
    [sym_intersection_type] = STATE(2794),
    [sym_function_type] = STATE(2794),
    [sym_identifier] = ACTIONS(911),
    [anon_sym_STAR] = ACTIONS(775),
    [anon_sym_EQ] = ACTIONS(923),
    [anon_sym_as] = ACTIONS(780),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_COMMA] = ACTIONS(813),
    [anon_sym_RBRACE] = ACTIONS(813),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_BANG] = ACTIONS(780),
    [anon_sym_LPAREN] = ACTIONS(789),
    [anon_sym_in] = ACTIONS(780),
    [anon_sym_SEMI] = ACTIONS(813),
    [anon_sym_LBRACK] = ACTIONS(925),
    [anon_sym_LT] = ACTIONS(793),
    [anon_sym_GT] = ACTIONS(780),
    [anon_sym_SLASH] = ACTIONS(780),
    [anon_sym_DOT] = ACTIONS(927),
    [anon_sym_EQ_GT] = ACTIONS(929),
    [anon_sym_QMARK_DOT] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(801),
    [anon_sym_PLUS_EQ] = ACTIONS(803),
    [anon_sym_DASH_EQ] = ACTIONS(803),
    [anon_sym_STAR_EQ] = ACTIONS(803),
    [anon_sym_SLASH_EQ] = ACTIONS(803),
    [anon_sym_PERCENT_EQ] = ACTIONS(803),
    [anon_sym_CARET_EQ] = ACTIONS(803),
    [anon_sym_AMP_EQ] = ACTIONS(803),
    [anon_sym_PIPE_EQ] = ACTIONS(803),
    [anon_sym_GT_GT_EQ] = ACTIONS(803),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(803),
    [anon_sym_LT_LT_EQ] = ACTIONS(803),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(803),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(803),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(803),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(803),
    [anon_sym_QMARK] = ACTIONS(805),
    [anon_sym_AMP_AMP] = ACTIONS(780),
    [anon_sym_PIPE_PIPE] = ACTIONS(780),
    [anon_sym_GT_GT] = ACTIONS(780),
    [anon_sym_GT_GT_GT] = ACTIONS(780),
    [anon_sym_LT_LT] = ACTIONS(780),
    [anon_sym_AMP] = ACTIONS(807),
    [anon_sym_CARET] = ACTIONS(780),
    [anon_sym_PIPE] = ACTIONS(809),
    [anon_sym_PLUS] = ACTIONS(811),
    [anon_sym_DASH] = ACTIONS(811),
    [anon_sym_PERCENT] = ACTIONS(780),
    [anon_sym_STAR_STAR] = ACTIONS(780),
    [anon_sym_LT_EQ] = ACTIONS(813),
    [anon_sym_EQ_EQ] = ACTIONS(780),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(813),
    [anon_sym_BANG_EQ] = ACTIONS(780),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(813),
    [anon_sym_GT_EQ] = ACTIONS(813),
    [anon_sym_QMARK_QMARK] = ACTIONS(780),
    [anon_sym_instanceof] = ACTIONS(780),
    [anon_sym_void] = ACTIONS(815),
    [anon_sym_PLUS_PLUS] = ACTIONS(813),
    [anon_sym_DASH_DASH] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(817),
    [anon_sym_SQUOTE] = ACTIONS(819),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(813),
    [sym_number] = ACTIONS(821),
    [sym_this] = ACTIONS(919),
    [sym_true] = ACTIONS(825),
    [sym_false] = ACTIONS(825),
    [anon_sym_any] = ACTIONS(815),
    [anon_sym_number] = ACTIONS(815),
    [anon_sym_boolean] = ACTIONS(815),
    [anon_sym_string] = ACTIONS(815),
    [anon_sym_symbol] = ACTIONS(815),
    [sym_readonly] = ACTIONS(921),
    [anon_sym_infer] = ACTIONS(495),
    [anon_sym_keyof] = ACTIONS(497),
    [anon_sym_LBRACE_PIPE] = ACTIONS(499),
    [sym__automatic_semicolon] = ACTIONS(813),
  },
  [68] = {
    [sym_statement_block] = STATE(75),
    [ts_builtin_sym_end] = ACTIONS(933),
    [sym_identifier] = ACTIONS(935),
    [anon_sym_export] = ACTIONS(935),
    [anon_sym_STAR] = ACTIONS(935),
    [anon_sym_default] = ACTIONS(935),
    [anon_sym_as] = ACTIONS(935),
    [anon_sym_namespace] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(933),
    [anon_sym_RBRACE] = ACTIONS(933),
    [anon_sym_type] = ACTIONS(935),
    [anon_sym_typeof] = ACTIONS(935),
    [anon_sym_import] = ACTIONS(935),
    [anon_sym_var] = ACTIONS(935),
    [anon_sym_let] = ACTIONS(935),
    [anon_sym_const] = ACTIONS(935),
    [anon_sym_BANG] = ACTIONS(935),
    [anon_sym_else] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_switch] = ACTIONS(935),
    [anon_sym_for] = ACTIONS(935),
    [anon_sym_LPAREN] = ACTIONS(933),
    [anon_sym_await] = ACTIONS(935),
    [anon_sym_in] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_try] = ACTIONS(935),
    [anon_sym_with] = ACTIONS(935),
    [anon_sym_break] = ACTIONS(935),
    [anon_sym_continue] = ACTIONS(935),
    [anon_sym_debugger] = ACTIONS(935),
    [anon_sym_return] = ACTIONS(935),
    [anon_sym_throw] = ACTIONS(935),
    [anon_sym_SEMI] = ACTIONS(933),
    [anon_sym_case] = ACTIONS(935),
    [anon_sym_yield] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(933),
    [anon_sym_LT] = ACTIONS(935),
    [anon_sym_GT] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(939),
    [anon_sym_class] = ACTIONS(935),
    [anon_sym_async] = ACTIONS(935),
    [anon_sym_function] = ACTIONS(935),
    [anon_sym_QMARK_DOT] = ACTIONS(933),
    [anon_sym_new] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(933),
    [anon_sym_PIPE_PIPE] = ACTIONS(933),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_GT_GT_GT] = ACTIONS(933),
    [anon_sym_LT_LT] = ACTIONS(933),
    [anon_sym_AMP] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(933),
    [anon_sym_PIPE] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_DASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(933),
    [anon_sym_STAR_STAR] = ACTIONS(933),
    [anon_sym_LT_EQ] = ACTIONS(933),
    [anon_sym_EQ_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(933),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(933),
    [anon_sym_GT_EQ] = ACTIONS(933),
    [anon_sym_QMARK_QMARK] = ACTIONS(933),
    [anon_sym_instanceof] = ACTIONS(935),
    [anon_sym_TILDE] = ACTIONS(933),
    [anon_sym_void] = ACTIONS(935),
    [anon_sym_delete] = ACTIONS(935),
    [anon_sym_PLUS_PLUS] = ACTIONS(933),
    [anon_sym_DASH_DASH] = ACTIONS(933),
    [anon_sym_DQUOTE] = ACTIONS(933),
    [anon_sym_SQUOTE] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(933),
    [sym_number] = ACTIONS(933),
    [sym_this] = ACTIONS(935),
    [sym_super] = ACTIONS(935),
    [sym_true] = ACTIONS(935),
    [sym_false] = ACTIONS(935),
    [sym_null] = ACTIONS(935),
    [sym_undefined] = ACTIONS(935),
    [anon_sym_AT] = ACTIONS(933),
    [anon_sym_static] = ACTIONS(935),
    [anon_sym_abstract] = ACTIONS(935),
    [anon_sym_get] = ACTIONS(935),
    [anon_sym_set] = ACTIONS(935),
    [anon_sym_declare] = ACTIONS(935),
    [anon_sym_public] = ACTIONS(935),
    [anon_sym_private] = ACTIONS(935),
    [anon_sym_protected] = ACTIONS(935),
    [anon_sym_module] = ACTIONS(935),
    [anon_sym_any] = ACTIONS(935),
    [anon_sym_number] = ACTIONS(935),
    [anon_sym_boolean] = ACTIONS(935),
    [anon_sym_string] = ACTIONS(935),
    [anon_sym_symbol] = ACTIONS(935),
    [anon_sym_interface] = ACTIONS(935),
    [anon_sym_enum] = ACTIONS(935),
    [sym_readonly] = ACTIONS(935),
    [sym__automatic_semicolon] = ACTIONS(933),
  },
  [69] = {
    [ts_builtin_sym_end] = ACTIONS(941),
    [sym_identifier] = ACTIONS(943),
    [anon_sym_export] = ACTIONS(943),
    [anon_sym_STAR] = ACTIONS(945),
    [anon_sym_default] = ACTIONS(943),
    [anon_sym_EQ] = ACTIONS(945),
    [anon_sym_as] = ACTIONS(945),
    [anon_sym_namespace] = ACTIONS(943),
    [anon_sym_LBRACE] = ACTIONS(941),
    [anon_sym_COMMA] = ACTIONS(947),
    [anon_sym_RBRACE] = ACTIONS(941),
    [anon_sym_type] = ACTIONS(943),
    [anon_sym_typeof] = ACTIONS(943),
    [anon_sym_import] = ACTIONS(943),
    [anon_sym_var] = ACTIONS(943),
    [anon_sym_let] = ACTIONS(943),
    [anon_sym_const] = ACTIONS(943),
    [anon_sym_BANG] = ACTIONS(943),
    [anon_sym_else] = ACTIONS(943),
    [anon_sym_if] = ACTIONS(943),
    [anon_sym_switch] = ACTIONS(943),
    [anon_sym_for] = ACTIONS(943),
    [anon_sym_LPAREN] = ACTIONS(941),
    [anon_sym_await] = ACTIONS(943),
    [anon_sym_in] = ACTIONS(945),
    [anon_sym_while] = ACTIONS(943),
    [anon_sym_do] = ACTIONS(943),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_with] = ACTIONS(943),
    [anon_sym_break] = ACTIONS(943),
    [anon_sym_continue] = ACTIONS(943),
    [anon_sym_debugger] = ACTIONS(943),
    [anon_sym_return] = ACTIONS(943),
    [anon_sym_throw] = ACTIONS(943),
    [anon_sym_SEMI] = ACTIONS(941),
    [anon_sym_case] = ACTIONS(943),
    [anon_sym_yield] = ACTIONS(943),
    [anon_sym_LBRACK] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(943),
    [anon_sym_GT] = ACTIONS(945),
    [anon_sym_SLASH] = ACTIONS(943),
    [anon_sym_DOT] = ACTIONS(945),
    [anon_sym_class] = ACTIONS(943),
    [anon_sym_async] = ACTIONS(943),
    [anon_sym_function] = ACTIONS(943),
    [anon_sym_QMARK_DOT] = ACTIONS(947),
    [anon_sym_new] = ACTIONS(943),
    [anon_sym_QMARK] = ACTIONS(945),
    [anon_sym_AMP_AMP] = ACTIONS(947),
    [anon_sym_PIPE_PIPE] = ACTIONS(947),
    [anon_sym_GT_GT] = ACTIONS(945),
    [anon_sym_GT_GT_GT] = ACTIONS(947),
    [anon_sym_LT_LT] = ACTIONS(947),
    [anon_sym_AMP] = ACTIONS(945),
    [anon_sym_CARET] = ACTIONS(947),
    [anon_sym_PIPE] = ACTIONS(945),
    [anon_sym_PLUS] = ACTIONS(943),
    [anon_sym_DASH] = ACTIONS(943),
    [anon_sym_PERCENT] = ACTIONS(947),
    [anon_sym_STAR_STAR] = ACTIONS(947),
    [anon_sym_LT_EQ] = ACTIONS(947),
    [anon_sym_EQ_EQ] = ACTIONS(945),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(947),
    [anon_sym_BANG_EQ] = ACTIONS(945),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(947),
    [anon_sym_GT_EQ] = ACTIONS(947),
    [anon_sym_QMARK_QMARK] = ACTIONS(947),
    [anon_sym_instanceof] = ACTIONS(945),
    [anon_sym_TILDE] = ACTIONS(941),
    [anon_sym_void] = ACTIONS(943),
    [anon_sym_delete] = ACTIONS(943),
    [anon_sym_PLUS_PLUS] = ACTIONS(941),
    [anon_sym_DASH_DASH] = ACTIONS(941),
    [anon_sym_DQUOTE] = ACTIONS(941),
    [anon_sym_SQUOTE] = ACTIONS(941),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(941),
    [sym_number] = ACTIONS(941),
    [sym_this] = ACTIONS(943),
    [sym_super] = ACTIONS(943),
    [sym_true] = ACTIONS(943),
    [sym_false] = ACTIONS(943),
    [sym_null] = ACTIONS(943),
    [sym_undefined] = ACTIONS(943),
    [anon_sym_AT] = ACTIONS(941),
    [anon_sym_static] = ACTIONS(943),
    [anon_sym_abstract] = ACTIONS(943),
    [anon_sym_get] = ACTIONS(943),
    [anon_sym_set] = ACTIONS(943),
    [anon_sym_declare] = ACTIONS(943),
    [anon_sym_public] = ACTIONS(943),
    [anon_sym_private] = ACTIONS(943),
    [anon_sym_protected] = ACTIONS(943),
    [anon_sym_module] = ACTIONS(943),
    [anon_sym_any] = ACTIONS(943),
    [anon_sym_number] = ACTIONS(943),
    [anon_sym_boolean] = ACTIONS(943),
    [anon_sym_string] = ACTIONS(943),
    [anon_sym_symbol] = ACTIONS(943),
    [anon_sym_interface] = ACTIONS(943),
    [anon_sym_enum] = ACTIONS(943),
    [sym_readonly] = ACTIONS(943),
    [sym__automatic_semicolon] = ACTIONS(949),
  },
  [70] = {
    [sym_statement_block] = STATE(75),
    [ts_builtin_sym_end] = ACTIONS(933),
    [sym_identifier] = ACTIONS(935),
    [anon_sym_export] = ACTIONS(935),
    [anon_sym_STAR] = ACTIONS(935),
    [anon_sym_default] = ACTIONS(935),
    [anon_sym_as] = ACTIONS(935),
    [anon_sym_namespace] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(933),
    [anon_sym_RBRACE] = ACTIONS(933),
    [anon_sym_type] = ACTIONS(935),
    [anon_sym_typeof] = ACTIONS(935),
    [anon_sym_import] = ACTIONS(935),
    [anon_sym_var] = ACTIONS(935),
    [anon_sym_let] = ACTIONS(935),
    [anon_sym_const] = ACTIONS(935),
    [anon_sym_BANG] = ACTIONS(935),
    [anon_sym_else] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_switch] = ACTIONS(935),
    [anon_sym_for] = ACTIONS(935),
    [anon_sym_LPAREN] = ACTIONS(933),
    [anon_sym_await] = ACTIONS(935),
    [anon_sym_in] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_try] = ACTIONS(935),
    [anon_sym_with] = ACTIONS(935),
    [anon_sym_break] = ACTIONS(935),
    [anon_sym_continue] = ACTIONS(935),
    [anon_sym_debugger] = ACTIONS(935),
    [anon_sym_return] = ACTIONS(935),
    [anon_sym_throw] = ACTIONS(935),
    [anon_sym_SEMI] = ACTIONS(933),
    [anon_sym_case] = ACTIONS(935),
    [anon_sym_yield] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(933),
    [anon_sym_LT] = ACTIONS(935),
    [anon_sym_GT] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_class] = ACTIONS(935),
    [anon_sym_async] = ACTIONS(935),
    [anon_sym_function] = ACTIONS(935),
    [anon_sym_QMARK_DOT] = ACTIONS(933),
    [anon_sym_new] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(933),
    [anon_sym_PIPE_PIPE] = ACTIONS(933),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_GT_GT_GT] = ACTIONS(933),
    [anon_sym_LT_LT] = ACTIONS(933),
    [anon_sym_AMP] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(933),
    [anon_sym_PIPE] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_DASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(933),
    [anon_sym_STAR_STAR] = ACTIONS(933),
    [anon_sym_LT_EQ] = ACTIONS(933),
    [anon_sym_EQ_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(933),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(933),
    [anon_sym_GT_EQ] = ACTIONS(933),
    [anon_sym_QMARK_QMARK] = ACTIONS(933),
    [anon_sym_instanceof] = ACTIONS(935),
    [anon_sym_TILDE] = ACTIONS(933),
    [anon_sym_void] = ACTIONS(935),
    [anon_sym_delete] = ACTIONS(935),
    [anon_sym_PLUS_PLUS] = ACTIONS(933),
    [anon_sym_DASH_DASH] = ACTIONS(933),
    [anon_sym_DQUOTE] = ACTIONS(933),
    [anon_sym_SQUOTE] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(933),
    [sym_number] = ACTIONS(933),
    [sym_this] = ACTIONS(935),
    [sym_super] = ACTIONS(935),
    [sym_true] = ACTIONS(935),
    [sym_false] = ACTIONS(935),
    [sym_null] = ACTIONS(935),
    [sym_undefined] = ACTIONS(935),
    [anon_sym_AT] = ACTIONS(933),
    [anon_sym_static] = ACTIONS(935),
    [anon_sym_abstract] = ACTIONS(935),
    [anon_sym_get] = ACTIONS(935),
    [anon_sym_set] = ACTIONS(935),
    [anon_sym_declare] = ACTIONS(935),
    [anon_sym_public] = ACTIONS(935),
    [anon_sym_private] = ACTIONS(935),
    [anon_sym_protected] = ACTIONS(935),
    [anon_sym_module] = ACTIONS(935),
    [anon_sym_any] = ACTIONS(935),
    [anon_sym_number] = ACTIONS(935),
    [anon_sym_boolean] = ACTIONS(935),
    [anon_sym_string] = ACTIONS(935),
    [anon_sym_symbol] = ACTIONS(935),
    [anon_sym_interface] = ACTIONS(935),
    [anon_sym_enum] = ACTIONS(935),
    [sym_readonly] = ACTIONS(935),
    [sym__automatic_semicolon] = ACTIONS(933),
  },
  [71] = {
    [ts_builtin_sym_end] = ACTIONS(951),
    [sym_identifier] = ACTIONS(953),
    [anon_sym_export] = ACTIONS(953),
    [anon_sym_STAR] = ACTIONS(955),
    [anon_sym_default] = ACTIONS(953),
    [anon_sym_as] = ACTIONS(955),
    [anon_sym_namespace] = ACTIONS(953),
    [anon_sym_LBRACE] = ACTIONS(951),
    [anon_sym_COMMA] = ACTIONS(957),
    [anon_sym_RBRACE] = ACTIONS(951),
    [anon_sym_type] = ACTIONS(953),
    [anon_sym_typeof] = ACTIONS(953),
    [anon_sym_import] = ACTIONS(953),
    [anon_sym_var] = ACTIONS(953),
    [anon_sym_let] = ACTIONS(953),
    [anon_sym_const] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(953),
    [anon_sym_else] = ACTIONS(953),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_switch] = ACTIONS(953),
    [anon_sym_for] = ACTIONS(953),
    [anon_sym_LPAREN] = ACTIONS(951),
    [anon_sym_await] = ACTIONS(953),
    [anon_sym_in] = ACTIONS(955),
    [anon_sym_while] = ACTIONS(953),
    [anon_sym_do] = ACTIONS(953),
    [anon_sym_try] = ACTIONS(953),
    [anon_sym_with] = ACTIONS(953),
    [anon_sym_break] = ACTIONS(953),
    [anon_sym_continue] = ACTIONS(953),
    [anon_sym_debugger] = ACTIONS(953),
    [anon_sym_return] = ACTIONS(953),
    [anon_sym_throw] = ACTIONS(953),
    [anon_sym_SEMI] = ACTIONS(951),
    [anon_sym_case] = ACTIONS(953),
    [anon_sym_yield] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(951),
    [anon_sym_LT] = ACTIONS(953),
    [anon_sym_GT] = ACTIONS(955),
    [anon_sym_SLASH] = ACTIONS(953),
    [anon_sym_DOT] = ACTIONS(955),
    [anon_sym_class] = ACTIONS(953),
    [anon_sym_async] = ACTIONS(953),
    [anon_sym_function] = ACTIONS(953),
    [anon_sym_QMARK_DOT] = ACTIONS(957),
    [anon_sym_new] = ACTIONS(953),
    [anon_sym_QMARK] = ACTIONS(955),
    [anon_sym_AMP_AMP] = ACTIONS(957),
    [anon_sym_PIPE_PIPE] = ACTIONS(957),
    [anon_sym_GT_GT] = ACTIONS(955),
    [anon_sym_GT_GT_GT] = ACTIONS(957),
    [anon_sym_LT_LT] = ACTIONS(957),
    [anon_sym_AMP] = ACTIONS(955),
    [anon_sym_CARET] = ACTIONS(957),
    [anon_sym_PIPE] = ACTIONS(955),
    [anon_sym_PLUS] = ACTIONS(953),
    [anon_sym_DASH] = ACTIONS(953),
    [anon_sym_PERCENT] = ACTIONS(957),
    [anon_sym_STAR_STAR] = ACTIONS(957),
    [anon_sym_LT_EQ] = ACTIONS(957),
    [anon_sym_EQ_EQ] = ACTIONS(955),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(957),
    [anon_sym_BANG_EQ] = ACTIONS(955),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(957),
    [anon_sym_GT_EQ] = ACTIONS(957),
    [anon_sym_QMARK_QMARK] = ACTIONS(957),
    [anon_sym_instanceof] = ACTIONS(955),
    [anon_sym_TILDE] = ACTIONS(951),
    [anon_sym_void] = ACTIONS(953),
    [anon_sym_delete] = ACTIONS(953),
    [anon_sym_PLUS_PLUS] = ACTIONS(951),
    [anon_sym_DASH_DASH] = ACTIONS(951),
    [anon_sym_DQUOTE] = ACTIONS(951),
    [anon_sym_SQUOTE] = ACTIONS(951),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(951),
    [sym_number] = ACTIONS(951),
    [sym_this] = ACTIONS(953),
    [sym_super] = ACTIONS(953),
    [sym_true] = ACTIONS(953),
    [sym_false] = ACTIONS(953),
    [sym_null] = ACTIONS(953),
    [sym_undefined] = ACTIONS(953),
    [anon_sym_AT] = ACTIONS(951),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_abstract] = ACTIONS(953),
    [anon_sym_get] = ACTIONS(953),
    [anon_sym_set] = ACTIONS(953),
    [anon_sym_declare] = ACTIONS(953),
    [anon_sym_public] = ACTIONS(953),
    [anon_sym_private] = ACTIONS(953),
    [anon_sym_protected] = ACTIONS(953),
    [anon_sym_module] = ACTIONS(953),
    [anon_sym_any] = ACTIONS(953),
    [anon_sym_number] = ACTIONS(953),
    [anon_sym_boolean] = ACTIONS(953),
    [anon_sym_string] = ACTIONS(953),
    [anon_sym_symbol] = ACTIONS(953),
    [anon_sym_interface] = ACTIONS(953),
    [anon_sym_enum] = ACTIONS(953),
    [sym_readonly] = ACTIONS(953),
    [sym__automatic_semicolon] = ACTIONS(959),
  },
  [72] = {
    [sym_nested_identifier] = STATE(3297),
    [sym_string] = STATE(447),
    [sym_formal_parameters] = STATE(3296),
    [sym_nested_type_identifier] = STATE(1957),
    [sym__type] = STATE(2794),
    [sym_constructor_type] = STATE(2794),
    [sym__primary_type] = STATE(2659),
    [sym_infer_type] = STATE(2794),
    [sym_conditional_type] = STATE(2659),
    [sym_generic_type] = STATE(2659),
    [sym_type_query] = STATE(2659),
    [sym_index_type_query] = STATE(2659),
    [sym_lookup_type] = STATE(2659),
    [sym_literal_type] = STATE(2659),
    [sym__number] = STATE(447),
    [sym_existential_type] = STATE(2659),
    [sym_flow_maybe_type] = STATE(2659),
    [sym_parenthesized_type] = STATE(2659),
    [sym_predefined_type] = STATE(2659),
    [sym_object_type] = STATE(2659),
    [sym_type_parameters] = STATE(3048),
    [sym_array_type] = STATE(2659),
    [sym__tuple_type_body] = STATE(443),
    [sym_tuple_type] = STATE(2659),
    [sym_union_type] = STATE(2794),
    [sym_intersection_type] = STATE(2794),
    [sym_function_type] = STATE(2794),
    [sym_identifier] = ACTIONS(911),
    [anon_sym_STAR] = ACTIONS(775),
    [anon_sym_EQ] = ACTIONS(961),
    [anon_sym_as] = ACTIONS(780),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_BANG] = ACTIONS(780),
    [anon_sym_LPAREN] = ACTIONS(789),
    [anon_sym_in] = ACTIONS(780),
    [anon_sym_COLON] = ACTIONS(813),
    [anon_sym_LBRACK] = ACTIONS(917),
    [anon_sym_RBRACK] = ACTIONS(813),
    [anon_sym_LT] = ACTIONS(793),
    [anon_sym_GT] = ACTIONS(780),
    [anon_sym_SLASH] = ACTIONS(780),
    [anon_sym_DOT] = ACTIONS(795),
    [anon_sym_EQ_GT] = ACTIONS(963),
    [anon_sym_QMARK_DOT] = ACTIONS(799),
    [anon_sym_new] = ACTIONS(801),
    [anon_sym_PLUS_EQ] = ACTIONS(803),
    [anon_sym_DASH_EQ] = ACTIONS(803),
    [anon_sym_STAR_EQ] = ACTIONS(803),
    [anon_sym_SLASH_EQ] = ACTIONS(803),
    [anon_sym_PERCENT_EQ] = ACTIONS(803),
    [anon_sym_CARET_EQ] = ACTIONS(803),
    [anon_sym_AMP_EQ] = ACTIONS(803),
    [anon_sym_PIPE_EQ] = ACTIONS(803),
    [anon_sym_GT_GT_EQ] = ACTIONS(803),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(803),
    [anon_sym_LT_LT_EQ] = ACTIONS(803),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(803),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(803),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(803),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(803),
    [anon_sym_QMARK] = ACTIONS(805),
    [anon_sym_AMP_AMP] = ACTIONS(780),
    [anon_sym_PIPE_PIPE] = ACTIONS(780),
    [anon_sym_GT_GT] = ACTIONS(780),
    [anon_sym_GT_GT_GT] = ACTIONS(780),
    [anon_sym_LT_LT] = ACTIONS(780),
    [anon_sym_AMP] = ACTIONS(807),
    [anon_sym_CARET] = ACTIONS(780),
    [anon_sym_PIPE] = ACTIONS(809),
    [anon_sym_PLUS] = ACTIONS(811),
    [anon_sym_DASH] = ACTIONS(811),
    [anon_sym_PERCENT] = ACTIONS(780),
    [anon_sym_STAR_STAR] = ACTIONS(780),
    [anon_sym_LT_EQ] = ACTIONS(813),
    [anon_sym_EQ_EQ] = ACTIONS(780),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(813),
    [anon_sym_BANG_EQ] = ACTIONS(780),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(813),
    [anon_sym_GT_EQ] = ACTIONS(813),
    [anon_sym_QMARK_QMARK] = ACTIONS(780),
    [anon_sym_instanceof] = ACTIONS(780),
    [anon_sym_void] = ACTIONS(815),
    [anon_sym_PLUS_PLUS] = ACTIONS(813),
    [anon_sym_DASH_DASH] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(817),
    [anon_sym_SQUOTE] = ACTIONS(819),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(813),
    [sym_number] = ACTIONS(821),
    [sym_this] = ACTIONS(919),
    [sym_true] = ACTIONS(825),
    [sym_false] = ACTIONS(825),
    [anon_sym_any] = ACTIONS(815),
    [anon_sym_number] = ACTIONS(815),
    [anon_sym_boolean] = ACTIONS(815),
    [anon_sym_string] = ACTIONS(815),
    [anon_sym_symbol] = ACTIONS(815),
    [sym_readonly] = ACTIONS(921),
    [anon_sym_infer] = ACTIONS(495),
    [anon_sym_keyof] = ACTIONS(497),
    [anon_sym_LBRACE_PIPE] = ACTIONS(499),
  },
  [73] = {
    [ts_builtin_sym_end] = ACTIONS(965),
    [sym_identifier] = ACTIONS(967),
    [anon_sym_export] = ACTIONS(967),
    [anon_sym_STAR] = ACTIONS(969),
    [anon_sym_default] = ACTIONS(967),
    [anon_sym_as] = ACTIONS(969),
    [anon_sym_namespace] = ACTIONS(967),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_COMMA] = ACTIONS(971),
    [anon_sym_RBRACE] = ACTIONS(965),
    [anon_sym_type] = ACTIONS(967),
    [anon_sym_typeof] = ACTIONS(967),
    [anon_sym_import] = ACTIONS(967),
    [anon_sym_var] = ACTIONS(967),
    [anon_sym_let] = ACTIONS(967),
    [anon_sym_const] = ACTIONS(967),
    [anon_sym_BANG] = ACTIONS(967),
    [anon_sym_else] = ACTIONS(967),
    [anon_sym_if] = ACTIONS(967),
    [anon_sym_switch] = ACTIONS(967),
    [anon_sym_for] = ACTIONS(967),
    [anon_sym_LPAREN] = ACTIONS(965),
    [anon_sym_await] = ACTIONS(967),
    [anon_sym_in] = ACTIONS(969),
    [anon_sym_while] = ACTIONS(967),
    [anon_sym_do] = ACTIONS(967),
    [anon_sym_try] = ACTIONS(967),
    [anon_sym_with] = ACTIONS(967),
    [anon_sym_break] = ACTIONS(967),
    [anon_sym_continue] = ACTIONS(967),
    [anon_sym_debugger] = ACTIONS(967),
    [anon_sym_return] = ACTIONS(967),
    [anon_sym_throw] = ACTIONS(967),
    [anon_sym_SEMI] = ACTIONS(965),
    [anon_sym_case] = ACTIONS(967),
    [anon_sym_yield] = ACTIONS(967),
    [anon_sym_LBRACK] = ACTIONS(965),
    [anon_sym_LT] = ACTIONS(967),
    [anon_sym_GT] = ACTIONS(969),
    [anon_sym_SLASH] = ACTIONS(967),
    [anon_sym_DOT] = ACTIONS(969),
    [anon_sym_class] = ACTIONS(967),
    [anon_sym_async] = ACTIONS(967),
    [anon_sym_function] = ACTIONS(967),
    [anon_sym_QMARK_DOT] = ACTIONS(971),
    [anon_sym_new] = ACTIONS(967),
    [anon_sym_QMARK] = ACTIONS(969),
    [anon_sym_AMP_AMP] = ACTIONS(971),
    [anon_sym_PIPE_PIPE] = ACTIONS(971),
    [anon_sym_GT_GT] = ACTIONS(969),
    [anon_sym_GT_GT_GT] = ACTIONS(971),
    [anon_sym_LT_LT] = ACTIONS(971),
    [anon_sym_AMP] = ACTIONS(969),
    [anon_sym_CARET] = ACTIONS(971),
    [anon_sym_PIPE] = ACTIONS(969),
    [anon_sym_PLUS] = ACTIONS(967),
    [anon_sym_DASH] = ACTIONS(967),
    [anon_sym_PERCENT] = ACTIONS(971),
    [anon_sym_STAR_STAR] = ACTIONS(971),
    [anon_sym_LT_EQ] = ACTIONS(971),
    [anon_sym_EQ_EQ] = ACTIONS(969),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(971),
    [anon_sym_BANG_EQ] = ACTIONS(969),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(971),
    [anon_sym_GT_EQ] = ACTIONS(971),
    [anon_sym_QMARK_QMARK] = ACTIONS(971),
    [anon_sym_instanceof] = ACTIONS(969),
    [anon_sym_TILDE] = ACTIONS(965),
    [anon_sym_void] = ACTIONS(967),
    [anon_sym_delete] = ACTIONS(967),
    [anon_sym_PLUS_PLUS] = ACTIONS(965),
    [anon_sym_DASH_DASH] = ACTIONS(965),
    [anon_sym_DQUOTE] = ACTIONS(965),
    [anon_sym_SQUOTE] = ACTIONS(965),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(965),
    [sym_number] = ACTIONS(965),
    [sym_this] = ACTIONS(967),
    [sym_super] = ACTIONS(967),
    [sym_true] = ACTIONS(967),
    [sym_false] = ACTIONS(967),
    [sym_null] = ACTIONS(967),
    [sym_undefined] = ACTIONS(967),
    [anon_sym_AT] = ACTIONS(965),
    [anon_sym_static] = ACTIONS(967),
    [anon_sym_abstract] = ACTIONS(967),
    [anon_sym_get] = ACTIONS(967),
    [anon_sym_set] = ACTIONS(967),
    [anon_sym_declare] = ACTIONS(967),
    [anon_sym_public] = ACTIONS(967),
    [anon_sym_private] = ACTIONS(967),
    [anon_sym_protected] = ACTIONS(967),
    [anon_sym_module] = ACTIONS(967),
    [anon_sym_any] = ACTIONS(967),
    [anon_sym_number] = ACTIONS(967),
    [anon_sym_boolean] = ACTIONS(967),
    [anon_sym_string] = ACTIONS(967),
    [anon_sym_symbol] = ACTIONS(967),
    [anon_sym_interface] = ACTIONS(967),
    [anon_sym_enum] = ACTIONS(967),
    [sym_readonly] = ACTIONS(967),
    [sym__automatic_semicolon] = ACTIONS(973),
  },
  [74] = {
    [ts_builtin_sym_end] = ACTIONS(975),
    [sym_identifier] = ACTIONS(977),
    [anon_sym_export] = ACTIONS(977),
    [anon_sym_STAR] = ACTIONS(977),
    [anon_sym_default] = ACTIONS(977),
    [anon_sym_as] = ACTIONS(977),
    [anon_sym_namespace] = ACTIONS(977),
    [anon_sym_LBRACE] = ACTIONS(975),
    [anon_sym_COMMA] = ACTIONS(975),
    [anon_sym_RBRACE] = ACTIONS(975),
    [anon_sym_type] = ACTIONS(977),
    [anon_sym_typeof] = ACTIONS(977),
    [anon_sym_import] = ACTIONS(977),
    [anon_sym_var] = ACTIONS(977),
    [anon_sym_let] = ACTIONS(977),
    [anon_sym_const] = ACTIONS(977),
    [anon_sym_BANG] = ACTIONS(977),
    [anon_sym_else] = ACTIONS(977),
    [anon_sym_if] = ACTIONS(977),
    [anon_sym_switch] = ACTIONS(977),
    [anon_sym_for] = ACTIONS(977),
    [anon_sym_LPAREN] = ACTIONS(975),
    [anon_sym_await] = ACTIONS(977),
    [anon_sym_in] = ACTIONS(977),
    [anon_sym_while] = ACTIONS(977),
    [anon_sym_do] = ACTIONS(977),
    [anon_sym_try] = ACTIONS(977),
    [anon_sym_with] = ACTIONS(977),
    [anon_sym_break] = ACTIONS(977),
    [anon_sym_continue] = ACTIONS(977),
    [anon_sym_debugger] = ACTIONS(977),
    [anon_sym_return] = ACTIONS(977),
    [anon_sym_throw] = ACTIONS(977),
    [anon_sym_SEMI] = ACTIONS(975),
    [anon_sym_case] = ACTIONS(977),
    [anon_sym_yield] = ACTIONS(977),
    [anon_sym_LBRACK] = ACTIONS(975),
    [anon_sym_LT] = ACTIONS(977),
    [anon_sym_GT] = ACTIONS(977),
    [anon_sym_SLASH] = ACTIONS(977),
    [anon_sym_DOT] = ACTIONS(977),
    [anon_sym_class] = ACTIONS(977),
    [anon_sym_async] = ACTIONS(977),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_QMARK_DOT] = ACTIONS(975),
    [anon_sym_new] = ACTIONS(977),
    [anon_sym_QMARK] = ACTIONS(977),
    [anon_sym_AMP_AMP] = ACTIONS(975),
    [anon_sym_PIPE_PIPE] = ACTIONS(975),
    [anon_sym_GT_GT] = ACTIONS(977),
    [anon_sym_GT_GT_GT] = ACTIONS(975),
    [anon_sym_LT_LT] = ACTIONS(975),
    [anon_sym_AMP] = ACTIONS(977),
    [anon_sym_CARET] = ACTIONS(975),
    [anon_sym_PIPE] = ACTIONS(977),
    [anon_sym_PLUS] = ACTIONS(977),
    [anon_sym_DASH] = ACTIONS(977),
    [anon_sym_PERCENT] = ACTIONS(975),
    [anon_sym_STAR_STAR] = ACTIONS(975),
    [anon_sym_LT_EQ] = ACTIONS(975),
    [anon_sym_EQ_EQ] = ACTIONS(977),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(975),
    [anon_sym_BANG_EQ] = ACTIONS(977),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(975),
    [anon_sym_GT_EQ] = ACTIONS(975),
    [anon_sym_QMARK_QMARK] = ACTIONS(975),
    [anon_sym_instanceof] = ACTIONS(977),
    [anon_sym_TILDE] = ACTIONS(975),
    [anon_sym_void] = ACTIONS(977),
    [anon_sym_delete] = ACTIONS(977),
    [anon_sym_PLUS_PLUS] = ACTIONS(975),
    [anon_sym_DASH_DASH] = ACTIONS(975),
    [anon_sym_DQUOTE] = ACTIONS(975),
    [anon_sym_SQUOTE] = ACTIONS(975),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(975),
    [sym_number] = ACTIONS(975),
    [sym_this] = ACTIONS(977),
    [sym_super] = ACTIONS(977),
    [sym_true] = ACTIONS(977),
    [sym_false] = ACTIONS(977),
    [sym_null] = ACTIONS(977),
    [sym_undefined] = ACTIONS(977),
    [anon_sym_AT] = ACTIONS(975),
    [anon_sym_static] = ACTIONS(977),
    [anon_sym_abstract] = ACTIONS(977),
    [anon_sym_get] = ACTIONS(977),
    [anon_sym_set] = ACTIONS(977),
    [anon_sym_declare] = ACTIONS(977),
    [anon_sym_public] = ACTIONS(977),
    [anon_sym_private] = ACTIONS(977),
    [anon_sym_protected] = ACTIONS(977),
    [anon_sym_module] = ACTIONS(977),
    [anon_sym_any] = ACTIONS(977),
    [anon_sym_number] = ACTIONS(977),
    [anon_sym_boolean] = ACTIONS(977),
    [anon_sym_string] = ACTIONS(977),
    [anon_sym_symbol] = ACTIONS(977),
    [anon_sym_interface] = ACTIONS(977),
    [anon_sym_enum] = ACTIONS(977),
    [sym_readonly] = ACTIONS(977),
    [sym__automatic_semicolon] = ACTIONS(975),
  },
  [75] = {
    [ts_builtin_sym_end] = ACTIONS(979),
    [sym_identifier] = ACTIONS(981),
    [anon_sym_export] = ACTIONS(981),
    [anon_sym_STAR] = ACTIONS(981),
    [anon_sym_default] = ACTIONS(981),
    [anon_sym_as] = ACTIONS(981),
    [anon_sym_namespace] = ACTIONS(981),
    [anon_sym_LBRACE] = ACTIONS(979),
    [anon_sym_COMMA] = ACTIONS(979),
    [anon_sym_RBRACE] = ACTIONS(979),
    [anon_sym_type] = ACTIONS(981),
    [anon_sym_typeof] = ACTIONS(981),
    [anon_sym_import] = ACTIONS(981),
    [anon_sym_var] = ACTIONS(981),
    [anon_sym_let] = ACTIONS(981),
    [anon_sym_const] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(981),
    [anon_sym_else] = ACTIONS(981),
    [anon_sym_if] = ACTIONS(981),
    [anon_sym_switch] = ACTIONS(981),
    [anon_sym_for] = ACTIONS(981),
    [anon_sym_LPAREN] = ACTIONS(979),
    [anon_sym_await] = ACTIONS(981),
    [anon_sym_in] = ACTIONS(981),
    [anon_sym_while] = ACTIONS(981),
    [anon_sym_do] = ACTIONS(981),
    [anon_sym_try] = ACTIONS(981),
    [anon_sym_with] = ACTIONS(981),
    [anon_sym_break] = ACTIONS(981),
    [anon_sym_continue] = ACTIONS(981),
    [anon_sym_debugger] = ACTIONS(981),
    [anon_sym_return] = ACTIONS(981),
    [anon_sym_throw] = ACTIONS(981),
    [anon_sym_SEMI] = ACTIONS(979),
    [anon_sym_case] = ACTIONS(981),
    [anon_sym_yield] = ACTIONS(981),
    [anon_sym_LBRACK] = ACTIONS(979),
    [anon_sym_LT] = ACTIONS(981),
    [anon_sym_GT] = ACTIONS(981),
    [anon_sym_SLASH] = ACTIONS(981),
    [anon_sym_DOT] = ACTIONS(981),
    [anon_sym_class] = ACTIONS(981),
    [anon_sym_async] = ACTIONS(981),
    [anon_sym_function] = ACTIONS(981),
    [anon_sym_QMARK_DOT] = ACTIONS(979),
    [anon_sym_new] = ACTIONS(981),
    [anon_sym_QMARK] = ACTIONS(981),
    [anon_sym_AMP_AMP] = ACTIONS(979),
    [anon_sym_PIPE_PIPE] = ACTIONS(979),
    [anon_sym_GT_GT] = ACTIONS(981),
    [anon_sym_GT_GT_GT] = ACTIONS(979),
    [anon_sym_LT_LT] = ACTIONS(979),
    [anon_sym_AMP] = ACTIONS(981),
    [anon_sym_CARET] = ACTIONS(979),
    [anon_sym_PIPE] = ACTIONS(981),
    [anon_sym_PLUS] = ACTIONS(981),
    [anon_sym_DASH] = ACTIONS(981),
    [anon_sym_PERCENT] = ACTIONS(979),
    [anon_sym_STAR_STAR] = ACTIONS(979),
    [anon_sym_LT_EQ] = ACTIONS(979),
    [anon_sym_EQ_EQ] = ACTIONS(981),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(979),
    [anon_sym_BANG_EQ] = ACTIONS(981),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(979),
    [anon_sym_GT_EQ] = ACTIONS(979),
    [anon_sym_QMARK_QMARK] = ACTIONS(979),
    [anon_sym_instanceof] = ACTIONS(981),
    [anon_sym_TILDE] = ACTIONS(979),
    [anon_sym_void] = ACTIONS(981),
    [anon_sym_delete] = ACTIONS(981),
    [anon_sym_PLUS_PLUS] = ACTIONS(979),
    [anon_sym_DASH_DASH] = ACTIONS(979),
    [anon_sym_DQUOTE] = ACTIONS(979),
    [anon_sym_SQUOTE] = ACTIONS(979),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(979),
    [sym_number] = ACTIONS(979),
    [sym_this] = ACTIONS(981),
    [sym_super] = ACTIONS(981),
    [sym_true] = ACTIONS(981),
    [sym_false] = ACTIONS(981),
    [sym_null] = ACTIONS(981),
    [sym_undefined] = ACTIONS(981),
    [anon_sym_AT] = ACTIONS(979),
    [anon_sym_static] = ACTIONS(981),
    [anon_sym_abstract] = ACTIONS(981),
    [anon_sym_get] = ACTIONS(981),
    [anon_sym_set] = ACTIONS(981),
    [anon_sym_declare] = ACTIONS(981),
    [anon_sym_public] = ACTIONS(981),
    [anon_sym_private] = ACTIONS(981),
    [anon_sym_protected] = ACTIONS(981),
    [anon_sym_module] = ACTIONS(981),
    [anon_sym_any] = ACTIONS(981),
    [anon_sym_number] = ACTIONS(981),
    [anon_sym_boolean] = ACTIONS(981),
    [anon_sym_string] = ACTIONS(981),
    [anon_sym_symbol] = ACTIONS(981),
    [anon_sym_interface] = ACTIONS(981),
    [anon_sym_enum] = ACTIONS(981),
    [sym_readonly] = ACTIONS(981),
    [sym__automatic_semicolon] = ACTIONS(979),
  },
  [76] = {
    [ts_builtin_sym_end] = ACTIONS(983),
    [sym_identifier] = ACTIONS(985),
    [anon_sym_export] = ACTIONS(985),
    [anon_sym_STAR] = ACTIONS(987),
    [anon_sym_default] = ACTIONS(985),
    [anon_sym_as] = ACTIONS(987),
    [anon_sym_namespace] = ACTIONS(985),
    [anon_sym_LBRACE] = ACTIONS(983),
    [anon_sym_COMMA] = ACTIONS(989),
    [anon_sym_RBRACE] = ACTIONS(983),
    [anon_sym_type] = ACTIONS(985),
    [anon_sym_typeof] = ACTIONS(985),
    [anon_sym_import] = ACTIONS(985),
    [anon_sym_var] = ACTIONS(985),
    [anon_sym_let] = ACTIONS(985),
    [anon_sym_const] = ACTIONS(985),
    [anon_sym_BANG] = ACTIONS(985),
    [anon_sym_else] = ACTIONS(985),
    [anon_sym_if] = ACTIONS(985),
    [anon_sym_switch] = ACTIONS(985),
    [anon_sym_for] = ACTIONS(985),
    [anon_sym_LPAREN] = ACTIONS(983),
    [anon_sym_await] = ACTIONS(985),
    [anon_sym_in] = ACTIONS(987),
    [anon_sym_while] = ACTIONS(985),
    [anon_sym_do] = ACTIONS(985),
    [anon_sym_try] = ACTIONS(985),
    [anon_sym_with] = ACTIONS(985),
    [anon_sym_break] = ACTIONS(985),
    [anon_sym_continue] = ACTIONS(985),
    [anon_sym_debugger] = ACTIONS(985),
    [anon_sym_return] = ACTIONS(985),
    [anon_sym_throw] = ACTIONS(985),
    [anon_sym_SEMI] = ACTIONS(983),
    [anon_sym_case] = ACTIONS(985),
    [anon_sym_yield] = ACTIONS(985),
    [anon_sym_LBRACK] = ACTIONS(983),
    [anon_sym_LT] = ACTIONS(985),
    [anon_sym_GT] = ACTIONS(987),
    [anon_sym_SLASH] = ACTIONS(985),
    [anon_sym_DOT] = ACTIONS(987),
    [anon_sym_class] = ACTIONS(985),
    [anon_sym_async] = ACTIONS(985),
    [anon_sym_function] = ACTIONS(985),
    [anon_sym_QMARK_DOT] = ACTIONS(989),
    [anon_sym_new] = ACTIONS(985),
    [anon_sym_QMARK] = ACTIONS(987),
    [anon_sym_AMP_AMP] = ACTIONS(989),
    [anon_sym_PIPE_PIPE] = ACTIONS(989),
    [anon_sym_GT_GT] = ACTIONS(987),
    [anon_sym_GT_GT_GT] = ACTIONS(989),
    [anon_sym_LT_LT] = ACTIONS(989),
    [anon_sym_AMP] = ACTIONS(987),
    [anon_sym_CARET] = ACTIONS(989),
    [anon_sym_PIPE] = ACTIONS(987),
    [anon_sym_PLUS] = ACTIONS(985),
    [anon_sym_DASH] = ACTIONS(985),
    [anon_sym_PERCENT] = ACTIONS(989),
    [anon_sym_STAR_STAR] = ACTIONS(989),
    [anon_sym_LT_EQ] = ACTIONS(989),
    [anon_sym_EQ_EQ] = ACTIONS(987),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(989),
    [anon_sym_BANG_EQ] = ACTIONS(987),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(989),
    [anon_sym_GT_EQ] = ACTIONS(989),
    [anon_sym_QMARK_QMARK] = ACTIONS(989),
    [anon_sym_instanceof] = ACTIONS(987),
    [anon_sym_TILDE] = ACTIONS(983),
    [anon_sym_void] = ACTIONS(985),
    [anon_sym_delete] = ACTIONS(985),
    [anon_sym_PLUS_PLUS] = ACTIONS(983),
    [anon_sym_DASH_DASH] = ACTIONS(983),
    [anon_sym_DQUOTE] = ACTIONS(983),
    [anon_sym_SQUOTE] = ACTIONS(983),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(983),
    [sym_number] = ACTIONS(983),
    [sym_this] = ACTIONS(985),
    [sym_super] = ACTIONS(985),
    [sym_true] = ACTIONS(985),
    [sym_false] = ACTIONS(985),
    [sym_null] = ACTIONS(985),
    [sym_undefined] = ACTIONS(985),
    [anon_sym_AT] = ACTIONS(983),
    [anon_sym_static] = ACTIONS(985),
    [anon_sym_abstract] = ACTIONS(985),
    [anon_sym_get] = ACTIONS(985),
    [anon_sym_set] = ACTIONS(985),
    [anon_sym_declare] = ACTIONS(985),
    [anon_sym_public] = ACTIONS(985),
    [anon_sym_private] = ACTIONS(985),
    [anon_sym_protected] = ACTIONS(985),
    [anon_sym_module] = ACTIONS(985),
    [anon_sym_any] = ACTIONS(985),
    [anon_sym_number] = ACTIONS(985),
    [anon_sym_boolean] = ACTIONS(985),
    [anon_sym_string] = ACTIONS(985),
    [anon_sym_symbol] = ACTIONS(985),
    [anon_sym_interface] = ACTIONS(985),
    [anon_sym_enum] = ACTIONS(985),
    [sym_readonly] = ACTIONS(985),
    [sym__automatic_semicolon] = ACTIONS(991),
  },
  [77] = {
    [ts_builtin_sym_end] = ACTIONS(993),
    [sym_identifier] = ACTIONS(995),
    [anon_sym_export] = ACTIONS(995),
    [anon_sym_STAR] = ACTIONS(997),
    [anon_sym_default] = ACTIONS(995),
    [anon_sym_as] = ACTIONS(997),
    [anon_sym_namespace] = ACTIONS(995),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_COMMA] = ACTIONS(999),
    [anon_sym_RBRACE] = ACTIONS(993),
    [anon_sym_type] = ACTIONS(995),
    [anon_sym_typeof] = ACTIONS(995),
    [anon_sym_import] = ACTIONS(995),
    [anon_sym_var] = ACTIONS(995),
    [anon_sym_let] = ACTIONS(995),
    [anon_sym_const] = ACTIONS(995),
    [anon_sym_BANG] = ACTIONS(995),
    [anon_sym_else] = ACTIONS(995),
    [anon_sym_if] = ACTIONS(995),
    [anon_sym_switch] = ACTIONS(995),
    [anon_sym_for] = ACTIONS(995),
    [anon_sym_LPAREN] = ACTIONS(993),
    [anon_sym_await] = ACTIONS(995),
    [anon_sym_in] = ACTIONS(997),
    [anon_sym_while] = ACTIONS(995),
    [anon_sym_do] = ACTIONS(995),
    [anon_sym_try] = ACTIONS(995),
    [anon_sym_with] = ACTIONS(995),
    [anon_sym_break] = ACTIONS(995),
    [anon_sym_continue] = ACTIONS(995),
    [anon_sym_debugger] = ACTIONS(995),
    [anon_sym_return] = ACTIONS(995),
    [anon_sym_throw] = ACTIONS(995),
    [anon_sym_SEMI] = ACTIONS(993),
    [anon_sym_case] = ACTIONS(995),
    [anon_sym_yield] = ACTIONS(995),
    [anon_sym_LBRACK] = ACTIONS(993),
    [anon_sym_LT] = ACTIONS(995),
    [anon_sym_GT] = ACTIONS(997),
    [anon_sym_SLASH] = ACTIONS(995),
    [anon_sym_DOT] = ACTIONS(997),
    [anon_sym_class] = ACTIONS(995),
    [anon_sym_async] = ACTIONS(995),
    [anon_sym_function] = ACTIONS(995),
    [anon_sym_QMARK_DOT] = ACTIONS(999),
    [anon_sym_new] = ACTIONS(995),
    [anon_sym_QMARK] = ACTIONS(997),
    [anon_sym_AMP_AMP] = ACTIONS(999),
    [anon_sym_PIPE_PIPE] = ACTIONS(999),
    [anon_sym_GT_GT] = ACTIONS(997),
    [anon_sym_GT_GT_GT] = ACTIONS(999),
    [anon_sym_LT_LT] = ACTIONS(999),
    [anon_sym_AMP] = ACTIONS(997),
    [anon_sym_CARET] = ACTIONS(999),
    [anon_sym_PIPE] = ACTIONS(997),
    [anon_sym_PLUS] = ACTIONS(995),
    [anon_sym_DASH] = ACTIONS(995),
    [anon_sym_PERCENT] = ACTIONS(999),
    [anon_sym_STAR_STAR] = ACTIONS(999),
    [anon_sym_LT_EQ] = ACTIONS(999),
    [anon_sym_EQ_EQ] = ACTIONS(997),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(999),
    [anon_sym_BANG_EQ] = ACTIONS(997),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(999),
    [anon_sym_GT_EQ] = ACTIONS(999),
    [anon_sym_QMARK_QMARK] = ACTIONS(999),
    [anon_sym_instanceof] = ACTIONS(997),
    [anon_sym_TILDE] = ACTIONS(993),
    [anon_sym_void] = ACTIONS(995),
    [anon_sym_delete] = ACTIONS(995),
    [anon_sym_PLUS_PLUS] = ACTIONS(993),
    [anon_sym_DASH_DASH] = ACTIONS(993),
    [anon_sym_DQUOTE] = ACTIONS(993),
    [anon_sym_SQUOTE] = ACTIONS(993),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(993),
    [sym_number] = ACTIONS(993),
    [sym_this] = ACTIONS(995),
    [sym_super] = ACTIONS(995),
    [sym_true] = ACTIONS(995),
    [sym_false] = ACTIONS(995),
    [sym_null] = ACTIONS(995),
    [sym_undefined] = ACTIONS(995),
    [anon_sym_AT] = ACTIONS(993),
    [anon_sym_static] = ACTIONS(995),
    [anon_sym_abstract] = ACTIONS(995),
    [anon_sym_get] = ACTIONS(995),
    [anon_sym_set] = ACTIONS(995),
    [anon_sym_declare] = ACTIONS(995),
    [anon_sym_public] = ACTIONS(995),
    [anon_sym_private] = ACTIONS(995),
    [anon_sym_protected] = ACTIONS(995),
    [anon_sym_module] = ACTIONS(995),
    [anon_sym_any] = ACTIONS(995),
    [anon_sym_number] = ACTIONS(995),
    [anon_sym_boolean] = ACTIONS(995),
    [anon_sym_string] = ACTIONS(995),
    [anon_sym_symbol] = ACTIONS(995),
    [anon_sym_interface] = ACTIONS(995),
    [anon_sym_enum] = ACTIONS(995),
    [sym_readonly] = ACTIONS(995),
    [sym__automatic_semicolon] = ACTIONS(1001),
  },
  [78] = {
    [ts_builtin_sym_end] = ACTIONS(1003),
    [sym_identifier] = ACTIONS(1005),
    [anon_sym_export] = ACTIONS(1005),
    [anon_sym_STAR] = ACTIONS(1007),
    [anon_sym_default] = ACTIONS(1005),
    [anon_sym_as] = ACTIONS(1007),
    [anon_sym_namespace] = ACTIONS(1005),
    [anon_sym_LBRACE] = ACTIONS(1003),
    [anon_sym_COMMA] = ACTIONS(1009),
    [anon_sym_RBRACE] = ACTIONS(1003),
    [anon_sym_type] = ACTIONS(1005),
    [anon_sym_typeof] = ACTIONS(1005),
    [anon_sym_import] = ACTIONS(1005),
    [anon_sym_var] = ACTIONS(1005),
    [anon_sym_let] = ACTIONS(1005),
    [anon_sym_const] = ACTIONS(1005),
    [anon_sym_BANG] = ACTIONS(1005),
    [anon_sym_else] = ACTIONS(1005),
    [anon_sym_if] = ACTIONS(1005),
    [anon_sym_switch] = ACTIONS(1005),
    [anon_sym_for] = ACTIONS(1005),
    [anon_sym_LPAREN] = ACTIONS(1003),
    [anon_sym_await] = ACTIONS(1005),
    [anon_sym_in] = ACTIONS(1007),
    [anon_sym_while] = ACTIONS(1005),
    [anon_sym_do] = ACTIONS(1005),
    [anon_sym_try] = ACTIONS(1005),
    [anon_sym_with] = ACTIONS(1005),
    [anon_sym_break] = ACTIONS(1005),
    [anon_sym_continue] = ACTIONS(1005),
    [anon_sym_debugger] = ACTIONS(1005),
    [anon_sym_return] = ACTIONS(1005),
    [anon_sym_throw] = ACTIONS(1005),
    [anon_sym_SEMI] = ACTIONS(1003),
    [anon_sym_case] = ACTIONS(1005),
    [anon_sym_yield] = ACTIONS(1005),
    [anon_sym_LBRACK] = ACTIONS(1003),
    [anon_sym_LT] = ACTIONS(1005),
    [anon_sym_GT] = ACTIONS(1007),
    [anon_sym_SLASH] = ACTIONS(1005),
    [anon_sym_DOT] = ACTIONS(1007),
    [anon_sym_class] = ACTIONS(1005),
    [anon_sym_async] = ACTIONS(1005),
    [anon_sym_function] = ACTIONS(1005),
    [anon_sym_QMARK_DOT] = ACTIONS(1009),
    [anon_sym_new] = ACTIONS(1005),
    [anon_sym_QMARK] = ACTIONS(1007),
    [anon_sym_AMP_AMP] = ACTIONS(1009),
    [anon_sym_PIPE_PIPE] = ACTIONS(1009),
    [anon_sym_GT_GT] = ACTIONS(1007),
    [anon_sym_GT_GT_GT] = ACTIONS(1009),
    [anon_sym_LT_LT] = ACTIONS(1009),
    [anon_sym_AMP] = ACTIONS(1007),
    [anon_sym_CARET] = ACTIONS(1009),
    [anon_sym_PIPE] = ACTIONS(1007),
    [anon_sym_PLUS] = ACTIONS(1005),
    [anon_sym_DASH] = ACTIONS(1005),
    [anon_sym_PERCENT] = ACTIONS(1009),
    [anon_sym_STAR_STAR] = ACTIONS(1009),
    [anon_sym_LT_EQ] = ACTIONS(1009),
    [anon_sym_EQ_EQ] = ACTIONS(1007),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1009),
    [anon_sym_BANG_EQ] = ACTIONS(1007),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1009),
    [anon_sym_GT_EQ] = ACTIONS(1009),
    [anon_sym_QMARK_QMARK] = ACTIONS(1009),
    [anon_sym_instanceof] = ACTIONS(1007),
    [anon_sym_TILDE] = ACTIONS(1003),
    [anon_sym_void] = ACTIONS(1005),
    [anon_sym_delete] = ACTIONS(1005),
    [anon_sym_PLUS_PLUS] = ACTIONS(1003),
    [anon_sym_DASH_DASH] = ACTIONS(1003),
    [anon_sym_DQUOTE] = ACTIONS(1003),
    [anon_sym_SQUOTE] = ACTIONS(1003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1003),
    [sym_number] = ACTIONS(1003),
    [sym_this] = ACTIONS(1005),
    [sym_super] = ACTIONS(1005),
    [sym_true] = ACTIONS(1005),
    [sym_false] = ACTIONS(1005),
    [sym_null] = ACTIONS(1005),
    [sym_undefined] = ACTIONS(1005),
    [anon_sym_AT] = ACTIONS(1003),
    [anon_sym_static] = ACTIONS(1005),
    [anon_sym_abstract] = ACTIONS(1005),
    [anon_sym_get] = ACTIONS(1005),
    [anon_sym_set] = ACTIONS(1005),
    [anon_sym_declare] = ACTIONS(1005),
    [anon_sym_public] = ACTIONS(1005),
    [anon_sym_private] = ACTIONS(1005),
    [anon_sym_protected] = ACTIONS(1005),
    [anon_sym_module] = ACTIONS(1005),
    [anon_sym_any] = ACTIONS(1005),
    [anon_sym_number] = ACTIONS(1005),
    [anon_sym_boolean] = ACTIONS(1005),
    [anon_sym_string] = ACTIONS(1005),
    [anon_sym_symbol] = ACTIONS(1005),
    [anon_sym_interface] = ACTIONS(1005),
    [anon_sym_enum] = ACTIONS(1005),
    [sym_readonly] = ACTIONS(1005),
    [sym__automatic_semicolon] = ACTIONS(1011),
  },
  [79] = {
    [ts_builtin_sym_end] = ACTIONS(941),
    [sym_identifier] = ACTIONS(943),
    [anon_sym_export] = ACTIONS(943),
    [anon_sym_STAR] = ACTIONS(943),
    [anon_sym_default] = ACTIONS(943),
    [anon_sym_as] = ACTIONS(943),
    [anon_sym_namespace] = ACTIONS(943),
    [anon_sym_LBRACE] = ACTIONS(941),
    [anon_sym_COMMA] = ACTIONS(941),
    [anon_sym_RBRACE] = ACTIONS(941),
    [anon_sym_type] = ACTIONS(943),
    [anon_sym_typeof] = ACTIONS(943),
    [anon_sym_import] = ACTIONS(943),
    [anon_sym_var] = ACTIONS(943),
    [anon_sym_let] = ACTIONS(943),
    [anon_sym_const] = ACTIONS(943),
    [anon_sym_BANG] = ACTIONS(943),
    [anon_sym_else] = ACTIONS(943),
    [anon_sym_if] = ACTIONS(943),
    [anon_sym_switch] = ACTIONS(943),
    [anon_sym_for] = ACTIONS(943),
    [anon_sym_LPAREN] = ACTIONS(941),
    [anon_sym_await] = ACTIONS(943),
    [anon_sym_in] = ACTIONS(943),
    [anon_sym_while] = ACTIONS(943),
    [anon_sym_do] = ACTIONS(943),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_with] = ACTIONS(943),
    [anon_sym_break] = ACTIONS(943),
    [anon_sym_continue] = ACTIONS(943),
    [anon_sym_debugger] = ACTIONS(943),
    [anon_sym_return] = ACTIONS(943),
    [anon_sym_throw] = ACTIONS(943),
    [anon_sym_SEMI] = ACTIONS(941),
    [anon_sym_case] = ACTIONS(943),
    [anon_sym_yield] = ACTIONS(943),
    [anon_sym_LBRACK] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(943),
    [anon_sym_GT] = ACTIONS(943),
    [anon_sym_SLASH] = ACTIONS(943),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_class] = ACTIONS(943),
    [anon_sym_async] = ACTIONS(943),
    [anon_sym_function] = ACTIONS(943),
    [anon_sym_QMARK_DOT] = ACTIONS(941),
    [anon_sym_new] = ACTIONS(943),
    [anon_sym_QMARK] = ACTIONS(943),
    [anon_sym_AMP_AMP] = ACTIONS(941),
    [anon_sym_PIPE_PIPE] = ACTIONS(941),
    [anon_sym_GT_GT] = ACTIONS(943),
    [anon_sym_GT_GT_GT] = ACTIONS(941),
    [anon_sym_LT_LT] = ACTIONS(941),
    [anon_sym_AMP] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(941),
    [anon_sym_PIPE] = ACTIONS(943),
    [anon_sym_PLUS] = ACTIONS(943),
    [anon_sym_DASH] = ACTIONS(943),
    [anon_sym_PERCENT] = ACTIONS(941),
    [anon_sym_STAR_STAR] = ACTIONS(941),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_EQ_EQ] = ACTIONS(943),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(943),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(941),
    [anon_sym_QMARK_QMARK] = ACTIONS(941),
    [anon_sym_instanceof] = ACTIONS(943),
    [anon_sym_TILDE] = ACTIONS(941),
    [anon_sym_void] = ACTIONS(943),
    [anon_sym_delete] = ACTIONS(943),
    [anon_sym_PLUS_PLUS] = ACTIONS(941),
    [anon_sym_DASH_DASH] = ACTIONS(941),
    [anon_sym_DQUOTE] = ACTIONS(941),
    [anon_sym_SQUOTE] = ACTIONS(941),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(941),
    [sym_number] = ACTIONS(941),
    [sym_this] = ACTIONS(943),
    [sym_super] = ACTIONS(943),
    [sym_true] = ACTIONS(943),
    [sym_false] = ACTIONS(943),
    [sym_null] = ACTIONS(943),
    [sym_undefined] = ACTIONS(943),
    [anon_sym_AT] = ACTIONS(941),
    [anon_sym_static] = ACTIONS(943),
    [anon_sym_abstract] = ACTIONS(943),
    [anon_sym_get] = ACTIONS(943),
    [anon_sym_set] = ACTIONS(943),
    [anon_sym_declare] = ACTIONS(943),
    [anon_sym_public] = ACTIONS(943),
    [anon_sym_private] = ACTIONS(943),
    [anon_sym_protected] = ACTIONS(943),
    [anon_sym_module] = ACTIONS(943),
    [anon_sym_any] = ACTIONS(943),
    [anon_sym_number] = ACTIONS(943),
    [anon_sym_boolean] = ACTIONS(943),
    [anon_sym_string] = ACTIONS(943),
    [anon_sym_symbol] = ACTIONS(943),
    [anon_sym_interface] = ACTIONS(943),
    [anon_sym_enum] = ACTIONS(943),
    [sym_readonly] = ACTIONS(943),
    [sym__automatic_semicolon] = ACTIONS(1013),
  },
  [80] = {
    [ts_builtin_sym_end] = ACTIONS(1015),
    [sym_identifier] = ACTIONS(1017),
    [anon_sym_export] = ACTIONS(1017),
    [anon_sym_STAR] = ACTIONS(1017),
    [anon_sym_default] = ACTIONS(1017),
    [anon_sym_as] = ACTIONS(1017),
    [anon_sym_namespace] = ACTIONS(1017),
    [anon_sym_LBRACE] = ACTIONS(1015),
    [anon_sym_COMMA] = ACTIONS(1015),
    [anon_sym_RBRACE] = ACTIONS(1015),
    [anon_sym_type] = ACTIONS(1017),
    [anon_sym_typeof] = ACTIONS(1017),
    [anon_sym_import] = ACTIONS(1017),
    [anon_sym_var] = ACTIONS(1017),
    [anon_sym_let] = ACTIONS(1017),
    [anon_sym_const] = ACTIONS(1017),
    [anon_sym_BANG] = ACTIONS(1017),
    [anon_sym_else] = ACTIONS(1017),
    [anon_sym_if] = ACTIONS(1017),
    [anon_sym_switch] = ACTIONS(1017),
    [anon_sym_for] = ACTIONS(1017),
    [anon_sym_LPAREN] = ACTIONS(1015),
    [anon_sym_await] = ACTIONS(1017),
    [anon_sym_in] = ACTIONS(1017),
    [anon_sym_while] = ACTIONS(1017),
    [anon_sym_do] = ACTIONS(1017),
    [anon_sym_try] = ACTIONS(1017),
    [anon_sym_with] = ACTIONS(1017),
    [anon_sym_break] = ACTIONS(1017),
    [anon_sym_continue] = ACTIONS(1017),
    [anon_sym_debugger] = ACTIONS(1017),
    [anon_sym_return] = ACTIONS(1017),
    [anon_sym_throw] = ACTIONS(1017),
    [anon_sym_SEMI] = ACTIONS(1015),
    [anon_sym_case] = ACTIONS(1017),
    [anon_sym_yield] = ACTIONS(1017),
    [anon_sym_LBRACK] = ACTIONS(1015),
    [anon_sym_LT] = ACTIONS(1017),
    [anon_sym_GT] = ACTIONS(1017),
    [anon_sym_SLASH] = ACTIONS(1017),
    [anon_sym_DOT] = ACTIONS(1017),
    [anon_sym_class] = ACTIONS(1017),
    [anon_sym_async] = ACTIONS(1017),
    [anon_sym_function] = ACTIONS(1017),
    [anon_sym_QMARK_DOT] = ACTIONS(1015),
    [anon_sym_new] = ACTIONS(1017),
    [anon_sym_QMARK] = ACTIONS(1017),
    [anon_sym_AMP_AMP] = ACTIONS(1015),
    [anon_sym_PIPE_PIPE] = ACTIONS(1015),
    [anon_sym_GT_GT] = ACTIONS(1017),
    [anon_sym_GT_GT_GT] = ACTIONS(1015),
    [anon_sym_LT_LT] = ACTIONS(1015),
    [anon_sym_AMP] = ACTIONS(1017),
    [anon_sym_CARET] = ACTIONS(1015),
    [anon_sym_PIPE] = ACTIONS(1017),
    [anon_sym_PLUS] = ACTIONS(1017),
    [anon_sym_DASH] = ACTIONS(1017),
    [anon_sym_PERCENT] = ACTIONS(1015),
    [anon_sym_STAR_STAR] = ACTIONS(1015),
    [anon_sym_LT_EQ] = ACTIONS(1015),
    [anon_sym_EQ_EQ] = ACTIONS(1017),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1015),
    [anon_sym_BANG_EQ] = ACTIONS(1017),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1015),
    [anon_sym_GT_EQ] = ACTIONS(1015),
    [anon_sym_QMARK_QMARK] = ACTIONS(1015),
    [anon_sym_instanceof] = ACTIONS(1017),
    [anon_sym_TILDE] = ACTIONS(1015),
    [anon_sym_void] = ACTIONS(1017),
    [anon_sym_delete] = ACTIONS(1017),
    [anon_sym_PLUS_PLUS] = ACTIONS(1015),
    [anon_sym_DASH_DASH] = ACTIONS(1015),
    [anon_sym_DQUOTE] = ACTIONS(1015),
    [anon_sym_SQUOTE] = ACTIONS(1015),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1015),
    [sym_number] = ACTIONS(1015),
    [sym_this] = ACTIONS(1017),
    [sym_super] = ACTIONS(1017),
    [sym_true] = ACTIONS(1017),
    [sym_false] = ACTIONS(1017),
    [sym_null] = ACTIONS(1017),
    [sym_undefined] = ACTIONS(1017),
    [anon_sym_AT] = ACTIONS(1015),
    [anon_sym_static] = ACTIONS(1017),
    [anon_sym_abstract] = ACTIONS(1017),
    [anon_sym_get] = ACTIONS(1017),
    [anon_sym_set] = ACTIONS(1017),
    [anon_sym_declare] = ACTIONS(1017),
    [anon_sym_public] = ACTIONS(1017),
    [anon_sym_private] = ACTIONS(1017),
    [anon_sym_protected] = ACTIONS(1017),
    [anon_sym_module] = ACTIONS(1017),
    [anon_sym_any] = ACTIONS(1017),
    [anon_sym_number] = ACTIONS(1017),
    [anon_sym_boolean] = ACTIONS(1017),
    [anon_sym_string] = ACTIONS(1017),
    [anon_sym_symbol] = ACTIONS(1017),
    [anon_sym_interface] = ACTIONS(1017),
    [anon_sym_enum] = ACTIONS(1017),
    [sym_readonly] = ACTIONS(1017),
    [sym__automatic_semicolon] = ACTIONS(1015),
  },
  [81] = {
    [ts_builtin_sym_end] = ACTIONS(1019),
    [sym_identifier] = ACTIONS(1021),
    [anon_sym_export] = ACTIONS(1021),
    [anon_sym_STAR] = ACTIONS(1023),
    [anon_sym_default] = ACTIONS(1021),
    [anon_sym_as] = ACTIONS(1023),
    [anon_sym_namespace] = ACTIONS(1021),
    [anon_sym_LBRACE] = ACTIONS(1019),
    [anon_sym_COMMA] = ACTIONS(1025),
    [anon_sym_RBRACE] = ACTIONS(1019),
    [anon_sym_type] = ACTIONS(1021),
    [anon_sym_typeof] = ACTIONS(1021),
    [anon_sym_import] = ACTIONS(1021),
    [anon_sym_var] = ACTIONS(1021),
    [anon_sym_let] = ACTIONS(1021),
    [anon_sym_const] = ACTIONS(1021),
    [anon_sym_BANG] = ACTIONS(1021),
    [anon_sym_else] = ACTIONS(1021),
    [anon_sym_if] = ACTIONS(1021),
    [anon_sym_switch] = ACTIONS(1021),
    [anon_sym_for] = ACTIONS(1021),
    [anon_sym_LPAREN] = ACTIONS(1019),
    [anon_sym_await] = ACTIONS(1021),
    [anon_sym_in] = ACTIONS(1023),
    [anon_sym_while] = ACTIONS(1021),
    [anon_sym_do] = ACTIONS(1021),
    [anon_sym_try] = ACTIONS(1021),
    [anon_sym_with] = ACTIONS(1021),
    [anon_sym_break] = ACTIONS(1021),
    [anon_sym_continue] = ACTIONS(1021),
    [anon_sym_debugger] = ACTIONS(1021),
    [anon_sym_return] = ACTIONS(1021),
    [anon_sym_throw] = ACTIONS(1021),
    [anon_sym_SEMI] = ACTIONS(1019),
    [anon_sym_case] = ACTIONS(1021),
    [anon_sym_yield] = ACTIONS(1021),
    [anon_sym_LBRACK] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(1021),
    [anon_sym_GT] = ACTIONS(1023),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_DOT] = ACTIONS(1023),
    [anon_sym_class] = ACTIONS(1021),
    [anon_sym_async] = ACTIONS(1021),
    [anon_sym_function] = ACTIONS(1021),
    [anon_sym_QMARK_DOT] = ACTIONS(1025),
    [anon_sym_new] = ACTIONS(1021),
    [anon_sym_QMARK] = ACTIONS(1023),
    [anon_sym_AMP_AMP] = ACTIONS(1025),
    [anon_sym_PIPE_PIPE] = ACTIONS(1025),
    [anon_sym_GT_GT] = ACTIONS(1023),
    [anon_sym_GT_GT_GT] = ACTIONS(1025),
    [anon_sym_LT_LT] = ACTIONS(1025),
    [anon_sym_AMP] = ACTIONS(1023),
    [anon_sym_CARET] = ACTIONS(1025),
    [anon_sym_PIPE] = ACTIONS(1023),
    [anon_sym_PLUS] = ACTIONS(1021),
    [anon_sym_DASH] = ACTIONS(1021),
    [anon_sym_PERCENT] = ACTIONS(1025),
    [anon_sym_STAR_STAR] = ACTIONS(1025),
    [anon_sym_LT_EQ] = ACTIONS(1025),
    [anon_sym_EQ_EQ] = ACTIONS(1023),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1025),
    [anon_sym_BANG_EQ] = ACTIONS(1023),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1025),
    [anon_sym_GT_EQ] = ACTIONS(1025),
    [anon_sym_QMARK_QMARK] = ACTIONS(1025),
    [anon_sym_instanceof] = ACTIONS(1023),
    [anon_sym_TILDE] = ACTIONS(1019),
    [anon_sym_void] = ACTIONS(1021),
    [anon_sym_delete] = ACTIONS(1021),
    [anon_sym_PLUS_PLUS] = ACTIONS(1019),
    [anon_sym_DASH_DASH] = ACTIONS(1019),
    [anon_sym_DQUOTE] = ACTIONS(1019),
    [anon_sym_SQUOTE] = ACTIONS(1019),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1019),
    [sym_number] = ACTIONS(1019),
    [sym_this] = ACTIONS(1021),
    [sym_super] = ACTIONS(1021),
    [sym_true] = ACTIONS(1021),
    [sym_false] = ACTIONS(1021),
    [sym_null] = ACTIONS(1021),
    [sym_undefined] = ACTIONS(1021),
    [anon_sym_AT] = ACTIONS(1019),
    [anon_sym_static] = ACTIONS(1021),
    [anon_sym_abstract] = ACTIONS(1021),
    [anon_sym_get] = ACTIONS(1021),
    [anon_sym_set] = ACTIONS(1021),
    [anon_sym_declare] = ACTIONS(1021),
    [anon_sym_public] = ACTIONS(1021),
    [anon_sym_private] = ACTIONS(1021),
    [anon_sym_protected] = ACTIONS(1021),
    [anon_sym_module] = ACTIONS(1021),
    [anon_sym_any] = ACTIONS(1021),
    [anon_sym_number] = ACTIONS(1021),
    [anon_sym_boolean] = ACTIONS(1021),
    [anon_sym_string] = ACTIONS(1021),
    [anon_sym_symbol] = ACTIONS(1021),
    [anon_sym_interface] = ACTIONS(1021),
    [anon_sym_enum] = ACTIONS(1021),
    [sym_readonly] = ACTIONS(1021),
    [sym__automatic_semicolon] = ACTIONS(1027),
  },
  [82] = {
    [ts_builtin_sym_end] = ACTIONS(1029),
    [sym_identifier] = ACTIONS(1031),
    [anon_sym_export] = ACTIONS(1031),
    [anon_sym_STAR] = ACTIONS(1033),
    [anon_sym_default] = ACTIONS(1031),
    [anon_sym_as] = ACTIONS(1033),
    [anon_sym_namespace] = ACTIONS(1031),
    [anon_sym_LBRACE] = ACTIONS(1029),
    [anon_sym_COMMA] = ACTIONS(1035),
    [anon_sym_RBRACE] = ACTIONS(1029),
    [anon_sym_type] = ACTIONS(1031),
    [anon_sym_typeof] = ACTIONS(1031),
    [anon_sym_import] = ACTIONS(1031),
    [anon_sym_var] = ACTIONS(1031),
    [anon_sym_let] = ACTIONS(1031),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_BANG] = ACTIONS(1031),
    [anon_sym_else] = ACTIONS(1031),
    [anon_sym_if] = ACTIONS(1031),
    [anon_sym_switch] = ACTIONS(1031),
    [anon_sym_for] = ACTIONS(1031),
    [anon_sym_LPAREN] = ACTIONS(1029),
    [anon_sym_await] = ACTIONS(1031),
    [anon_sym_in] = ACTIONS(1033),
    [anon_sym_while] = ACTIONS(1031),
    [anon_sym_do] = ACTIONS(1031),
    [anon_sym_try] = ACTIONS(1031),
    [anon_sym_with] = ACTIONS(1031),
    [anon_sym_break] = ACTIONS(1031),
    [anon_sym_continue] = ACTIONS(1031),
    [anon_sym_debugger] = ACTIONS(1031),
    [anon_sym_return] = ACTIONS(1031),
    [anon_sym_throw] = ACTIONS(1031),
    [anon_sym_SEMI] = ACTIONS(1029),
    [anon_sym_case] = ACTIONS(1031),
    [anon_sym_yield] = ACTIONS(1031),
    [anon_sym_LBRACK] = ACTIONS(1029),
    [anon_sym_LT] = ACTIONS(1031),
    [anon_sym_GT] = ACTIONS(1033),
    [anon_sym_SLASH] = ACTIONS(1031),
    [anon_sym_DOT] = ACTIONS(1033),
    [anon_sym_class] = ACTIONS(1031),
    [anon_sym_async] = ACTIONS(1031),
    [anon_sym_function] = ACTIONS(1031),
    [anon_sym_QMARK_DOT] = ACTIONS(1035),
    [anon_sym_new] = ACTIONS(1031),
    [anon_sym_QMARK] = ACTIONS(1033),
    [anon_sym_AMP_AMP] = ACTIONS(1035),
    [anon_sym_PIPE_PIPE] = ACTIONS(1035),
    [anon_sym_GT_GT] = ACTIONS(1033),
    [anon_sym_GT_GT_GT] = ACTIONS(1035),
    [anon_sym_LT_LT] = ACTIONS(1035),
    [anon_sym_AMP] = ACTIONS(1033),
    [anon_sym_CARET] = ACTIONS(1035),
    [anon_sym_PIPE] = ACTIONS(1033),
    [anon_sym_PLUS] = ACTIONS(1031),
    [anon_sym_DASH] = ACTIONS(1031),
    [anon_sym_PERCENT] = ACTIONS(1035),
    [anon_sym_STAR_STAR] = ACTIONS(1035),
    [anon_sym_LT_EQ] = ACTIONS(1035),
    [anon_sym_EQ_EQ] = ACTIONS(1033),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1035),
    [anon_sym_BANG_EQ] = ACTIONS(1033),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1035),
    [anon_sym_GT_EQ] = ACTIONS(1035),
    [anon_sym_QMARK_QMARK] = ACTIONS(1035),
    [anon_sym_instanceof] = ACTIONS(1033),
    [anon_sym_TILDE] = ACTIONS(1029),
    [anon_sym_void] = ACTIONS(1031),
    [anon_sym_delete] = ACTIONS(1031),
    [anon_sym_PLUS_PLUS] = ACTIONS(1029),
    [anon_sym_DASH_DASH] = ACTIONS(1029),
    [anon_sym_DQUOTE] = ACTIONS(1029),
    [anon_sym_SQUOTE] = ACTIONS(1029),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1029),
    [sym_number] = ACTIONS(1029),
    [sym_this] = ACTIONS(1031),
    [sym_super] = ACTIONS(1031),
    [sym_true] = ACTIONS(1031),
    [sym_false] = ACTIONS(1031),
    [sym_null] = ACTIONS(1031),
    [sym_undefined] = ACTIONS(1031),
    [anon_sym_AT] = ACTIONS(1029),
    [anon_sym_static] = ACTIONS(1031),
    [anon_sym_abstract] = ACTIONS(1031),
    [anon_sym_get] = ACTIONS(1031),
    [anon_sym_set] = ACTIONS(1031),
    [anon_sym_declare] = ACTIONS(1031),
    [anon_sym_public] = ACTIONS(1031),
    [anon_sym_private] = ACTIONS(1031),
    [anon_sym_protected] = ACTIONS(1031),
    [anon_sym_module] = ACTIONS(1031),
    [anon_sym_any] = ACTIONS(1031),
    [anon_sym_number] = ACTIONS(1031),
    [anon_sym_boolean] = ACTIONS(1031),
    [anon_sym_string] = ACTIONS(1031),
    [anon_sym_symbol] = ACTIONS(1031),
    [anon_sym_interface] = ACTIONS(1031),
    [anon_sym_enum] = ACTIONS(1031),
    [sym_readonly] = ACTIONS(1031),
    [sym__automatic_semicolon] = ACTIONS(1037),
  },
  [83] = {
    [ts_builtin_sym_end] = ACTIONS(1039),
    [sym_identifier] = ACTIONS(1041),
    [anon_sym_export] = ACTIONS(1041),
    [anon_sym_STAR] = ACTIONS(1043),
    [anon_sym_default] = ACTIONS(1041),
    [anon_sym_as] = ACTIONS(1043),
    [anon_sym_namespace] = ACTIONS(1041),
    [anon_sym_LBRACE] = ACTIONS(1039),
    [anon_sym_COMMA] = ACTIONS(1045),
    [anon_sym_RBRACE] = ACTIONS(1039),
    [anon_sym_type] = ACTIONS(1041),
    [anon_sym_typeof] = ACTIONS(1041),
    [anon_sym_import] = ACTIONS(1041),
    [anon_sym_var] = ACTIONS(1041),
    [anon_sym_let] = ACTIONS(1041),
    [anon_sym_const] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(1041),
    [anon_sym_else] = ACTIONS(1041),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_switch] = ACTIONS(1041),
    [anon_sym_for] = ACTIONS(1041),
    [anon_sym_LPAREN] = ACTIONS(1039),
    [anon_sym_await] = ACTIONS(1041),
    [anon_sym_in] = ACTIONS(1043),
    [anon_sym_while] = ACTIONS(1041),
    [anon_sym_do] = ACTIONS(1041),
    [anon_sym_try] = ACTIONS(1041),
    [anon_sym_with] = ACTIONS(1041),
    [anon_sym_break] = ACTIONS(1041),
    [anon_sym_continue] = ACTIONS(1041),
    [anon_sym_debugger] = ACTIONS(1041),
    [anon_sym_return] = ACTIONS(1041),
    [anon_sym_throw] = ACTIONS(1041),
    [anon_sym_SEMI] = ACTIONS(1039),
    [anon_sym_case] = ACTIONS(1041),
    [anon_sym_yield] = ACTIONS(1041),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_LT] = ACTIONS(1041),
    [anon_sym_GT] = ACTIONS(1043),
    [anon_sym_SLASH] = ACTIONS(1041),
    [anon_sym_DOT] = ACTIONS(1043),
    [anon_sym_class] = ACTIONS(1041),
    [anon_sym_async] = ACTIONS(1041),
    [anon_sym_function] = ACTIONS(1041),
    [anon_sym_QMARK_DOT] = ACTIONS(1045),
    [anon_sym_new] = ACTIONS(1041),
    [anon_sym_QMARK] = ACTIONS(1043),
    [anon_sym_AMP_AMP] = ACTIONS(1045),
    [anon_sym_PIPE_PIPE] = ACTIONS(1045),
    [anon_sym_GT_GT] = ACTIONS(1043),
    [anon_sym_GT_GT_GT] = ACTIONS(1045),
    [anon_sym_LT_LT] = ACTIONS(1045),
    [anon_sym_AMP] = ACTIONS(1043),
    [anon_sym_CARET] = ACTIONS(1045),
    [anon_sym_PIPE] = ACTIONS(1043),
    [anon_sym_PLUS] = ACTIONS(1041),
    [anon_sym_DASH] = ACTIONS(1041),
    [anon_sym_PERCENT] = ACTIONS(1045),
    [anon_sym_STAR_STAR] = ACTIONS(1045),
    [anon_sym_LT_EQ] = ACTIONS(1045),
    [anon_sym_EQ_EQ] = ACTIONS(1043),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1045),
    [anon_sym_BANG_EQ] = ACTIONS(1043),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1045),
    [anon_sym_GT_EQ] = ACTIONS(1045),
    [anon_sym_QMARK_QMARK] = ACTIONS(1045),
    [anon_sym_instanceof] = ACTIONS(1043),
    [anon_sym_TILDE] = ACTIONS(1039),
    [anon_sym_void] = ACTIONS(1041),
    [anon_sym_delete] = ACTIONS(1041),
    [anon_sym_PLUS_PLUS] = ACTIONS(1039),
    [anon_sym_DASH_DASH] = ACTIONS(1039),
    [anon_sym_DQUOTE] = ACTIONS(1039),
    [anon_sym_SQUOTE] = ACTIONS(1039),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1039),
    [sym_number] = ACTIONS(1039),
    [sym_this] = ACTIONS(1041),
    [sym_super] = ACTIONS(1041),
    [sym_true] = ACTIONS(1041),
    [sym_false] = ACTIONS(1041),
    [sym_null] = ACTIONS(1041),
    [sym_undefined] = ACTIONS(1041),
    [anon_sym_AT] = ACTIONS(1039),
    [anon_sym_static] = ACTIONS(1041),
    [anon_sym_abstract] = ACTIONS(1041),
    [anon_sym_get] = ACTIONS(1041),
    [anon_sym_set] = ACTIONS(1041),
    [anon_sym_declare] = ACTIONS(1041),
    [anon_sym_public] = ACTIONS(1041),
    [anon_sym_private] = ACTIONS(1041),
    [anon_sym_protected] = ACTIONS(1041),
    [anon_sym_module] = ACTIONS(1041),
    [anon_sym_any] = ACTIONS(1041),
    [anon_sym_number] = ACTIONS(1041),
    [anon_sym_boolean] = ACTIONS(1041),
    [anon_sym_string] = ACTIONS(1041),
    [anon_sym_symbol] = ACTIONS(1041),
    [anon_sym_interface] = ACTIONS(1041),
    [anon_sym_enum] = ACTIONS(1041),
    [sym_readonly] = ACTIONS(1041),
    [sym__automatic_semicolon] = ACTIONS(1047),
  },
  [84] = {
    [ts_builtin_sym_end] = ACTIONS(1049),
    [sym_identifier] = ACTIONS(1051),
    [anon_sym_export] = ACTIONS(1051),
    [anon_sym_STAR] = ACTIONS(1051),
    [anon_sym_default] = ACTIONS(1051),
    [anon_sym_as] = ACTIONS(1051),
    [anon_sym_namespace] = ACTIONS(1051),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_COMMA] = ACTIONS(1049),
    [anon_sym_RBRACE] = ACTIONS(1049),
    [anon_sym_type] = ACTIONS(1051),
    [anon_sym_typeof] = ACTIONS(1051),
    [anon_sym_import] = ACTIONS(1051),
    [anon_sym_var] = ACTIONS(1051),
    [anon_sym_let] = ACTIONS(1051),
    [anon_sym_const] = ACTIONS(1051),
    [anon_sym_BANG] = ACTIONS(1051),
    [anon_sym_else] = ACTIONS(1051),
    [anon_sym_if] = ACTIONS(1051),
    [anon_sym_switch] = ACTIONS(1051),
    [anon_sym_for] = ACTIONS(1051),
    [anon_sym_LPAREN] = ACTIONS(1049),
    [anon_sym_await] = ACTIONS(1051),
    [anon_sym_in] = ACTIONS(1051),
    [anon_sym_while] = ACTIONS(1051),
    [anon_sym_do] = ACTIONS(1051),
    [anon_sym_try] = ACTIONS(1051),
    [anon_sym_with] = ACTIONS(1051),
    [anon_sym_break] = ACTIONS(1051),
    [anon_sym_continue] = ACTIONS(1051),
    [anon_sym_debugger] = ACTIONS(1051),
    [anon_sym_return] = ACTIONS(1051),
    [anon_sym_throw] = ACTIONS(1051),
    [anon_sym_SEMI] = ACTIONS(1049),
    [anon_sym_case] = ACTIONS(1051),
    [anon_sym_yield] = ACTIONS(1051),
    [anon_sym_LBRACK] = ACTIONS(1049),
    [anon_sym_LT] = ACTIONS(1051),
    [anon_sym_GT] = ACTIONS(1051),
    [anon_sym_SLASH] = ACTIONS(1051),
    [anon_sym_DOT] = ACTIONS(1051),
    [anon_sym_class] = ACTIONS(1051),
    [anon_sym_async] = ACTIONS(1051),
    [anon_sym_function] = ACTIONS(1051),
    [anon_sym_QMARK_DOT] = ACTIONS(1049),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_QMARK] = ACTIONS(1051),
    [anon_sym_AMP_AMP] = ACTIONS(1049),
    [anon_sym_PIPE_PIPE] = ACTIONS(1049),
    [anon_sym_GT_GT] = ACTIONS(1051),
    [anon_sym_GT_GT_GT] = ACTIONS(1049),
    [anon_sym_LT_LT] = ACTIONS(1049),
    [anon_sym_AMP] = ACTIONS(1051),
    [anon_sym_CARET] = ACTIONS(1049),
    [anon_sym_PIPE] = ACTIONS(1051),
    [anon_sym_PLUS] = ACTIONS(1051),
    [anon_sym_DASH] = ACTIONS(1051),
    [anon_sym_PERCENT] = ACTIONS(1049),
    [anon_sym_STAR_STAR] = ACTIONS(1049),
    [anon_sym_LT_EQ] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(1051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1049),
    [anon_sym_BANG_EQ] = ACTIONS(1051),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1049),
    [anon_sym_GT_EQ] = ACTIONS(1049),
    [anon_sym_QMARK_QMARK] = ACTIONS(1049),
    [anon_sym_instanceof] = ACTIONS(1051),
    [anon_sym_TILDE] = ACTIONS(1049),
    [anon_sym_void] = ACTIONS(1051),
    [anon_sym_delete] = ACTIONS(1051),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_DQUOTE] = ACTIONS(1049),
    [anon_sym_SQUOTE] = ACTIONS(1049),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1049),
    [sym_number] = ACTIONS(1049),
    [sym_this] = ACTIONS(1051),
    [sym_super] = ACTIONS(1051),
    [sym_true] = ACTIONS(1051),
    [sym_false] = ACTIONS(1051),
    [sym_null] = ACTIONS(1051),
    [sym_undefined] = ACTIONS(1051),
    [anon_sym_AT] = ACTIONS(1049),
    [anon_sym_static] = ACTIONS(1051),
    [anon_sym_abstract] = ACTIONS(1051),
    [anon_sym_get] = ACTIONS(1051),
    [anon_sym_set] = ACTIONS(1051),
    [anon_sym_declare] = ACTIONS(1051),
    [anon_sym_public] = ACTIONS(1051),
    [anon_sym_private] = ACTIONS(1051),
    [anon_sym_protected] = ACTIONS(1051),
    [anon_sym_module] = ACTIONS(1051),
    [anon_sym_any] = ACTIONS(1051),
    [anon_sym_number] = ACTIONS(1051),
    [anon_sym_boolean] = ACTIONS(1051),
    [anon_sym_string] = ACTIONS(1051),
    [anon_sym_symbol] = ACTIONS(1051),
    [anon_sym_interface] = ACTIONS(1051),
    [anon_sym_enum] = ACTIONS(1051),
    [sym_readonly] = ACTIONS(1051),
    [sym__automatic_semicolon] = ACTIONS(1049),
  },
  [85] = {
    [ts_builtin_sym_end] = ACTIONS(1053),
    [sym_identifier] = ACTIONS(1055),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_STAR] = ACTIONS(1057),
    [anon_sym_default] = ACTIONS(1055),
    [anon_sym_as] = ACTIONS(1057),
    [anon_sym_namespace] = ACTIONS(1055),
    [anon_sym_LBRACE] = ACTIONS(1053),
    [anon_sym_COMMA] = ACTIONS(1059),
    [anon_sym_RBRACE] = ACTIONS(1053),
    [anon_sym_type] = ACTIONS(1055),
    [anon_sym_typeof] = ACTIONS(1055),
    [anon_sym_import] = ACTIONS(1055),
    [anon_sym_var] = ACTIONS(1055),
    [anon_sym_let] = ACTIONS(1055),
    [anon_sym_const] = ACTIONS(1055),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_else] = ACTIONS(1055),
    [anon_sym_if] = ACTIONS(1055),
    [anon_sym_switch] = ACTIONS(1055),
    [anon_sym_for] = ACTIONS(1055),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_await] = ACTIONS(1055),
    [anon_sym_in] = ACTIONS(1057),
    [anon_sym_while] = ACTIONS(1055),
    [anon_sym_do] = ACTIONS(1055),
    [anon_sym_try] = ACTIONS(1055),
    [anon_sym_with] = ACTIONS(1055),
    [anon_sym_break] = ACTIONS(1055),
    [anon_sym_continue] = ACTIONS(1055),
    [anon_sym_debugger] = ACTIONS(1055),
    [anon_sym_return] = ACTIONS(1055),
    [anon_sym_throw] = ACTIONS(1055),
    [anon_sym_SEMI] = ACTIONS(1053),
    [anon_sym_case] = ACTIONS(1055),
    [anon_sym_yield] = ACTIONS(1055),
    [anon_sym_LBRACK] = ACTIONS(1053),
    [anon_sym_LT] = ACTIONS(1055),
    [anon_sym_GT] = ACTIONS(1057),
    [anon_sym_SLASH] = ACTIONS(1055),
    [anon_sym_DOT] = ACTIONS(1057),
    [anon_sym_class] = ACTIONS(1055),
    [anon_sym_async] = ACTIONS(1055),
    [anon_sym_function] = ACTIONS(1055),
    [anon_sym_QMARK_DOT] = ACTIONS(1059),
    [anon_sym_new] = ACTIONS(1055),
    [anon_sym_QMARK] = ACTIONS(1057),
    [anon_sym_AMP_AMP] = ACTIONS(1059),
    [anon_sym_PIPE_PIPE] = ACTIONS(1059),
    [anon_sym_GT_GT] = ACTIONS(1057),
    [anon_sym_GT_GT_GT] = ACTIONS(1059),
    [anon_sym_LT_LT] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1057),
    [anon_sym_CARET] = ACTIONS(1059),
    [anon_sym_PIPE] = ACTIONS(1057),
    [anon_sym_PLUS] = ACTIONS(1055),
    [anon_sym_DASH] = ACTIONS(1055),
    [anon_sym_PERCENT] = ACTIONS(1059),
    [anon_sym_STAR_STAR] = ACTIONS(1059),
    [anon_sym_LT_EQ] = ACTIONS(1059),
    [anon_sym_EQ_EQ] = ACTIONS(1057),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1059),
    [anon_sym_BANG_EQ] = ACTIONS(1057),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1059),
    [anon_sym_GT_EQ] = ACTIONS(1059),
    [anon_sym_QMARK_QMARK] = ACTIONS(1059),
    [anon_sym_instanceof] = ACTIONS(1057),
    [anon_sym_TILDE] = ACTIONS(1053),
    [anon_sym_void] = ACTIONS(1055),
    [anon_sym_delete] = ACTIONS(1055),
    [anon_sym_PLUS_PLUS] = ACTIONS(1053),
    [anon_sym_DASH_DASH] = ACTIONS(1053),
    [anon_sym_DQUOTE] = ACTIONS(1053),
    [anon_sym_SQUOTE] = ACTIONS(1053),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1053),
    [sym_number] = ACTIONS(1053),
    [sym_this] = ACTIONS(1055),
    [sym_super] = ACTIONS(1055),
    [sym_true] = ACTIONS(1055),
    [sym_false] = ACTIONS(1055),
    [sym_null] = ACTIONS(1055),
    [sym_undefined] = ACTIONS(1055),
    [anon_sym_AT] = ACTIONS(1053),
    [anon_sym_static] = ACTIONS(1055),
    [anon_sym_abstract] = ACTIONS(1055),
    [anon_sym_get] = ACTIONS(1055),
    [anon_sym_set] = ACTIONS(1055),
    [anon_sym_declare] = ACTIONS(1055),
    [anon_sym_public] = ACTIONS(1055),
    [anon_sym_private] = ACTIONS(1055),
    [anon_sym_protected] = ACTIONS(1055),
    [anon_sym_module] = ACTIONS(1055),
    [anon_sym_any] = ACTIONS(1055),
    [anon_sym_number] = ACTIONS(1055),
    [anon_sym_boolean] = ACTIONS(1055),
    [anon_sym_string] = ACTIONS(1055),
    [anon_sym_symbol] = ACTIONS(1055),
    [anon_sym_interface] = ACTIONS(1055),
    [anon_sym_enum] = ACTIONS(1055),
    [sym_readonly] = ACTIONS(1055),
    [sym__automatic_semicolon] = ACTIONS(1061),
  },
  [86] = {
    [ts_builtin_sym_end] = ACTIONS(1063),
    [sym_identifier] = ACTIONS(1065),
    [anon_sym_export] = ACTIONS(1065),
    [anon_sym_STAR] = ACTIONS(1065),
    [anon_sym_default] = ACTIONS(1065),
    [anon_sym_as] = ACTIONS(1065),
    [anon_sym_namespace] = ACTIONS(1065),
    [anon_sym_LBRACE] = ACTIONS(1063),
    [anon_sym_COMMA] = ACTIONS(1063),
    [anon_sym_RBRACE] = ACTIONS(1063),
    [anon_sym_type] = ACTIONS(1065),
    [anon_sym_typeof] = ACTIONS(1065),
    [anon_sym_import] = ACTIONS(1065),
    [anon_sym_var] = ACTIONS(1065),
    [anon_sym_let] = ACTIONS(1065),
    [anon_sym_const] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1065),
    [anon_sym_else] = ACTIONS(1065),
    [anon_sym_if] = ACTIONS(1065),
    [anon_sym_switch] = ACTIONS(1065),
    [anon_sym_for] = ACTIONS(1065),
    [anon_sym_LPAREN] = ACTIONS(1063),
    [anon_sym_await] = ACTIONS(1065),
    [anon_sym_in] = ACTIONS(1065),
    [anon_sym_while] = ACTIONS(1065),
    [anon_sym_do] = ACTIONS(1065),
    [anon_sym_try] = ACTIONS(1065),
    [anon_sym_with] = ACTIONS(1065),
    [anon_sym_break] = ACTIONS(1065),
    [anon_sym_continue] = ACTIONS(1065),
    [anon_sym_debugger] = ACTIONS(1065),
    [anon_sym_return] = ACTIONS(1065),
    [anon_sym_throw] = ACTIONS(1065),
    [anon_sym_SEMI] = ACTIONS(1063),
    [anon_sym_case] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(1065),
    [anon_sym_LBRACK] = ACTIONS(1063),
    [anon_sym_LT] = ACTIONS(1065),
    [anon_sym_GT] = ACTIONS(1065),
    [anon_sym_SLASH] = ACTIONS(1065),
    [anon_sym_DOT] = ACTIONS(1065),
    [anon_sym_class] = ACTIONS(1065),
    [anon_sym_async] = ACTIONS(1065),
    [anon_sym_function] = ACTIONS(1065),
    [anon_sym_QMARK_DOT] = ACTIONS(1063),
    [anon_sym_new] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(1065),
    [anon_sym_AMP_AMP] = ACTIONS(1063),
    [anon_sym_PIPE_PIPE] = ACTIONS(1063),
    [anon_sym_GT_GT] = ACTIONS(1065),
    [anon_sym_GT_GT_GT] = ACTIONS(1063),
    [anon_sym_LT_LT] = ACTIONS(1063),
    [anon_sym_AMP] = ACTIONS(1065),
    [anon_sym_CARET] = ACTIONS(1063),
    [anon_sym_PIPE] = ACTIONS(1065),
    [anon_sym_PLUS] = ACTIONS(1065),
    [anon_sym_DASH] = ACTIONS(1065),
    [anon_sym_PERCENT] = ACTIONS(1063),
    [anon_sym_STAR_STAR] = ACTIONS(1063),
    [anon_sym_LT_EQ] = ACTIONS(1063),
    [anon_sym_EQ_EQ] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1063),
    [anon_sym_BANG_EQ] = ACTIONS(1065),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1063),
    [anon_sym_GT_EQ] = ACTIONS(1063),
    [anon_sym_QMARK_QMARK] = ACTIONS(1063),
    [anon_sym_instanceof] = ACTIONS(1065),
    [anon_sym_TILDE] = ACTIONS(1063),
    [anon_sym_void] = ACTIONS(1065),
    [anon_sym_delete] = ACTIONS(1065),
    [anon_sym_PLUS_PLUS] = ACTIONS(1063),
    [anon_sym_DASH_DASH] = ACTIONS(1063),
    [anon_sym_DQUOTE] = ACTIONS(1063),
    [anon_sym_SQUOTE] = ACTIONS(1063),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1063),
    [sym_number] = ACTIONS(1063),
    [sym_this] = ACTIONS(1065),
    [sym_super] = ACTIONS(1065),
    [sym_true] = ACTIONS(1065),
    [sym_false] = ACTIONS(1065),
    [sym_null] = ACTIONS(1065),
    [sym_undefined] = ACTIONS(1065),
    [anon_sym_AT] = ACTIONS(1063),
    [anon_sym_static] = ACTIONS(1065),
    [anon_sym_abstract] = ACTIONS(1065),
    [anon_sym_get] = ACTIONS(1065),
    [anon_sym_set] = ACTIONS(1065),
    [anon_sym_declare] = ACTIONS(1065),
    [anon_sym_public] = ACTIONS(1065),
    [anon_sym_private] = ACTIONS(1065),
    [anon_sym_protected] = ACTIONS(1065),
    [anon_sym_module] = ACTIONS(1065),
    [anon_sym_any] = ACTIONS(1065),
    [anon_sym_number] = ACTIONS(1065),
    [anon_sym_boolean] = ACTIONS(1065),
    [anon_sym_string] = ACTIONS(1065),
    [anon_sym_symbol] = ACTIONS(1065),
    [anon_sym_interface] = ACTIONS(1065),
    [anon_sym_enum] = ACTIONS(1065),
    [sym_readonly] = ACTIONS(1065),
    [sym__automatic_semicolon] = ACTIONS(1063),
  },
  [87] = {
    [sym_nested_identifier] = STATE(3297),
    [sym_string] = STATE(447),
    [sym_formal_parameters] = STATE(3296),
    [sym_nested_type_identifier] = STATE(1957),
    [sym__type] = STATE(2794),
    [sym_constructor_type] = STATE(2794),
    [sym__primary_type] = STATE(2659),
    [sym_infer_type] = STATE(2794),
    [sym_conditional_type] = STATE(2659),
    [sym_generic_type] = STATE(2659),
    [sym_type_query] = STATE(2659),
    [sym_index_type_query] = STATE(2659),
    [sym_lookup_type] = STATE(2659),
    [sym_literal_type] = STATE(2659),
    [sym__number] = STATE(447),
    [sym_existential_type] = STATE(2659),
    [sym_flow_maybe_type] = STATE(2659),
    [sym_parenthesized_type] = STATE(2659),
    [sym_predefined_type] = STATE(2659),
    [sym_object_type] = STATE(2659),
    [sym_type_parameters] = STATE(3048),
    [sym_array_type] = STATE(2659),
    [sym__tuple_type_body] = STATE(443),
    [sym_tuple_type] = STATE(2659),
    [sym_union_type] = STATE(2794),
    [sym_intersection_type] = STATE(2794),
    [sym_function_type] = STATE(2794),
    [sym_identifier] = ACTIONS(911),
    [anon_sym_STAR] = ACTIONS(775),
    [anon_sym_EQ] = ACTIONS(1067),
    [anon_sym_as] = ACTIONS(780),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_BANG] = ACTIONS(780),
    [anon_sym_LPAREN] = ACTIONS(789),
    [anon_sym_in] = ACTIONS(780),
    [anon_sym_SEMI] = ACTIONS(813),
    [anon_sym_LBRACK] = ACTIONS(925),
    [anon_sym_LT] = ACTIONS(793),
    [anon_sym_GT] = ACTIONS(780),
    [anon_sym_SLASH] = ACTIONS(780),
    [anon_sym_DOT] = ACTIONS(927),
    [anon_sym_EQ_GT] = ACTIONS(1069),
    [anon_sym_QMARK_DOT] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(801),
    [anon_sym_PLUS_EQ] = ACTIONS(803),
    [anon_sym_DASH_EQ] = ACTIONS(803),
    [anon_sym_STAR_EQ] = ACTIONS(803),
    [anon_sym_SLASH_EQ] = ACTIONS(803),
    [anon_sym_PERCENT_EQ] = ACTIONS(803),
    [anon_sym_CARET_EQ] = ACTIONS(803),
    [anon_sym_AMP_EQ] = ACTIONS(803),
    [anon_sym_PIPE_EQ] = ACTIONS(803),
    [anon_sym_GT_GT_EQ] = ACTIONS(803),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(803),
    [anon_sym_LT_LT_EQ] = ACTIONS(803),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(803),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(803),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(803),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(803),
    [anon_sym_QMARK] = ACTIONS(805),
    [anon_sym_AMP_AMP] = ACTIONS(780),
    [anon_sym_PIPE_PIPE] = ACTIONS(780),
    [anon_sym_GT_GT] = ACTIONS(780),
    [anon_sym_GT_GT_GT] = ACTIONS(780),
    [anon_sym_LT_LT] = ACTIONS(780),
    [anon_sym_AMP] = ACTIONS(807),
    [anon_sym_CARET] = ACTIONS(780),
    [anon_sym_PIPE] = ACTIONS(809),
    [anon_sym_PLUS] = ACTIONS(811),
    [anon_sym_DASH] = ACTIONS(811),
    [anon_sym_PERCENT] = ACTIONS(780),
    [anon_sym_STAR_STAR] = ACTIONS(780),
    [anon_sym_LT_EQ] = ACTIONS(813),
    [anon_sym_EQ_EQ] = ACTIONS(780),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(813),
    [anon_sym_BANG_EQ] = ACTIONS(780),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(813),
    [anon_sym_GT_EQ] = ACTIONS(813),
    [anon_sym_QMARK_QMARK] = ACTIONS(780),
    [anon_sym_instanceof] = ACTIONS(780),
    [anon_sym_void] = ACTIONS(815),
    [anon_sym_PLUS_PLUS] = ACTIONS(813),
    [anon_sym_DASH_DASH] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(817),
    [anon_sym_SQUOTE] = ACTIONS(819),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(813),
    [sym_number] = ACTIONS(821),
    [sym_this] = ACTIONS(919),
    [sym_true] = ACTIONS(825),
    [sym_false] = ACTIONS(825),
    [anon_sym_any] = ACTIONS(815),
    [anon_sym_number] = ACTIONS(815),
    [anon_sym_boolean] = ACTIONS(815),
    [anon_sym_string] = ACTIONS(815),
    [anon_sym_symbol] = ACTIONS(815),
    [sym_readonly] = ACTIONS(921),
    [anon_sym_infer] = ACTIONS(495),
    [anon_sym_keyof] = ACTIONS(497),
    [anon_sym_LBRACE_PIPE] = ACTIONS(499),
    [sym__automatic_semicolon] = ACTIONS(813),
  },
  [88] = {
    [ts_builtin_sym_end] = ACTIONS(1071),
    [sym_identifier] = ACTIONS(1073),
    [anon_sym_export] = ACTIONS(1073),
    [anon_sym_STAR] = ACTIONS(1073),
    [anon_sym_default] = ACTIONS(1073),
    [anon_sym_as] = ACTIONS(1073),
    [anon_sym_namespace] = ACTIONS(1073),
    [anon_sym_LBRACE] = ACTIONS(1071),
    [anon_sym_COMMA] = ACTIONS(1071),
    [anon_sym_RBRACE] = ACTIONS(1071),
    [anon_sym_type] = ACTIONS(1073),
    [anon_sym_typeof] = ACTIONS(1073),
    [anon_sym_import] = ACTIONS(1073),
    [anon_sym_var] = ACTIONS(1073),
    [anon_sym_let] = ACTIONS(1073),
    [anon_sym_const] = ACTIONS(1073),
    [anon_sym_BANG] = ACTIONS(1073),
    [anon_sym_else] = ACTIONS(1073),
    [anon_sym_if] = ACTIONS(1073),
    [anon_sym_switch] = ACTIONS(1073),
    [anon_sym_for] = ACTIONS(1073),
    [anon_sym_LPAREN] = ACTIONS(1071),
    [anon_sym_await] = ACTIONS(1073),
    [anon_sym_in] = ACTIONS(1073),
    [anon_sym_while] = ACTIONS(1073),
    [anon_sym_do] = ACTIONS(1073),
    [anon_sym_try] = ACTIONS(1073),
    [anon_sym_with] = ACTIONS(1073),
    [anon_sym_break] = ACTIONS(1073),
    [anon_sym_continue] = ACTIONS(1073),
    [anon_sym_debugger] = ACTIONS(1073),
    [anon_sym_return] = ACTIONS(1073),
    [anon_sym_throw] = ACTIONS(1073),
    [anon_sym_SEMI] = ACTIONS(1071),
    [anon_sym_case] = ACTIONS(1073),
    [anon_sym_yield] = ACTIONS(1073),
    [anon_sym_LBRACK] = ACTIONS(1071),
    [anon_sym_LT] = ACTIONS(1073),
    [anon_sym_GT] = ACTIONS(1073),
    [anon_sym_SLASH] = ACTIONS(1073),
    [anon_sym_DOT] = ACTIONS(1073),
    [anon_sym_class] = ACTIONS(1073),
    [anon_sym_async] = ACTIONS(1073),
    [anon_sym_function] = ACTIONS(1073),
    [anon_sym_QMARK_DOT] = ACTIONS(1071),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_QMARK] = ACTIONS(1073),
    [anon_sym_AMP_AMP] = ACTIONS(1071),
    [anon_sym_PIPE_PIPE] = ACTIONS(1071),
    [anon_sym_GT_GT] = ACTIONS(1073),
    [anon_sym_GT_GT_GT] = ACTIONS(1071),
    [anon_sym_LT_LT] = ACTIONS(1071),
    [anon_sym_AMP] = ACTIONS(1073),
    [anon_sym_CARET] = ACTIONS(1071),
    [anon_sym_PIPE] = ACTIONS(1073),
    [anon_sym_PLUS] = ACTIONS(1073),
    [anon_sym_DASH] = ACTIONS(1073),
    [anon_sym_PERCENT] = ACTIONS(1071),
    [anon_sym_STAR_STAR] = ACTIONS(1071),
    [anon_sym_LT_EQ] = ACTIONS(1071),
    [anon_sym_EQ_EQ] = ACTIONS(1073),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1071),
    [anon_sym_BANG_EQ] = ACTIONS(1073),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1071),
    [anon_sym_GT_EQ] = ACTIONS(1071),
    [anon_sym_QMARK_QMARK] = ACTIONS(1071),
    [anon_sym_instanceof] = ACTIONS(1073),
    [anon_sym_TILDE] = ACTIONS(1071),
    [anon_sym_void] = ACTIONS(1073),
    [anon_sym_delete] = ACTIONS(1073),
    [anon_sym_PLUS_PLUS] = ACTIONS(1071),
    [anon_sym_DASH_DASH] = ACTIONS(1071),
    [anon_sym_DQUOTE] = ACTIONS(1071),
    [anon_sym_SQUOTE] = ACTIONS(1071),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1071),
    [sym_number] = ACTIONS(1071),
    [sym_this] = ACTIONS(1073),
    [sym_super] = ACTIONS(1073),
    [sym_true] = ACTIONS(1073),
    [sym_false] = ACTIONS(1073),
    [sym_null] = ACTIONS(1073),
    [sym_undefined] = ACTIONS(1073),
    [anon_sym_AT] = ACTIONS(1071),
    [anon_sym_static] = ACTIONS(1073),
    [anon_sym_abstract] = ACTIONS(1073),
    [anon_sym_get] = ACTIONS(1073),
    [anon_sym_set] = ACTIONS(1073),
    [anon_sym_declare] = ACTIONS(1073),
    [anon_sym_public] = ACTIONS(1073),
    [anon_sym_private] = ACTIONS(1073),
    [anon_sym_protected] = ACTIONS(1073),
    [anon_sym_module] = ACTIONS(1073),
    [anon_sym_any] = ACTIONS(1073),
    [anon_sym_number] = ACTIONS(1073),
    [anon_sym_boolean] = ACTIONS(1073),
    [anon_sym_string] = ACTIONS(1073),
    [anon_sym_symbol] = ACTIONS(1073),
    [anon_sym_interface] = ACTIONS(1073),
    [anon_sym_enum] = ACTIONS(1073),
    [sym_readonly] = ACTIONS(1073),
    [sym__automatic_semicolon] = ACTIONS(1071),
  },
  [89] = {
    [sym_nested_identifier] = STATE(3297),
    [sym_string] = STATE(447),
    [sym_formal_parameters] = STATE(3296),
    [sym_nested_type_identifier] = STATE(1957),
    [sym__type] = STATE(2794),
    [sym_constructor_type] = STATE(2794),
    [sym__primary_type] = STATE(2692),
    [sym_infer_type] = STATE(2794),
    [sym_conditional_type] = STATE(2692),
    [sym_generic_type] = STATE(2692),
    [sym_type_query] = STATE(2692),
    [sym_index_type_query] = STATE(2692),
    [sym_lookup_type] = STATE(2692),
    [sym_literal_type] = STATE(2692),
    [sym__number] = STATE(447),
    [sym_existential_type] = STATE(2692),
    [sym_flow_maybe_type] = STATE(2692),
    [sym_parenthesized_type] = STATE(2692),
    [sym_predefined_type] = STATE(2692),
    [sym_object_type] = STATE(2692),
    [sym_type_parameters] = STATE(3048),
    [sym_array_type] = STATE(2692),
    [sym__tuple_type_body] = STATE(2053),
    [sym_tuple_type] = STATE(2692),
    [sym_union_type] = STATE(2794),
    [sym_intersection_type] = STATE(2794),
    [sym_function_type] = STATE(2794),
    [sym_identifier] = ACTIONS(911),
    [anon_sym_STAR] = ACTIONS(775),
    [anon_sym_EQ] = ACTIONS(913),
    [anon_sym_as] = ACTIONS(780),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_COMMA] = ACTIONS(813),
    [anon_sym_RBRACE] = ACTIONS(813),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_BANG] = ACTIONS(780),
    [anon_sym_LPAREN] = ACTIONS(789),
    [anon_sym_in] = ACTIONS(780),
    [anon_sym_LBRACK] = ACTIONS(1075),
    [anon_sym_LT] = ACTIONS(793),
    [anon_sym_GT] = ACTIONS(780),
    [anon_sym_SLASH] = ACTIONS(780),
    [anon_sym_DOT] = ACTIONS(795),
    [anon_sym_EQ_GT] = ACTIONS(797),
    [anon_sym_QMARK_DOT] = ACTIONS(799),
    [anon_sym_new] = ACTIONS(801),
    [anon_sym_PLUS_EQ] = ACTIONS(803),
    [anon_sym_DASH_EQ] = ACTIONS(803),
    [anon_sym_STAR_EQ] = ACTIONS(803),
    [anon_sym_SLASH_EQ] = ACTIONS(803),
    [anon_sym_PERCENT_EQ] = ACTIONS(803),
    [anon_sym_CARET_EQ] = ACTIONS(803),
    [anon_sym_AMP_EQ] = ACTIONS(803),
    [anon_sym_PIPE_EQ] = ACTIONS(803),
    [anon_sym_GT_GT_EQ] = ACTIONS(803),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(803),
    [anon_sym_LT_LT_EQ] = ACTIONS(803),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(803),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(803),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(803),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(803),
    [anon_sym_QMARK] = ACTIONS(805),
    [anon_sym_AMP_AMP] = ACTIONS(780),
    [anon_sym_PIPE_PIPE] = ACTIONS(780),
    [anon_sym_GT_GT] = ACTIONS(780),
    [anon_sym_GT_GT_GT] = ACTIONS(780),
    [anon_sym_LT_LT] = ACTIONS(780),
    [anon_sym_AMP] = ACTIONS(807),
    [anon_sym_CARET] = ACTIONS(780),
    [anon_sym_PIPE] = ACTIONS(809),
    [anon_sym_PLUS] = ACTIONS(811),
    [anon_sym_DASH] = ACTIONS(811),
    [anon_sym_PERCENT] = ACTIONS(780),
    [anon_sym_STAR_STAR] = ACTIONS(780),
    [anon_sym_LT_EQ] = ACTIONS(813),
    [anon_sym_EQ_EQ] = ACTIONS(780),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(813),
    [anon_sym_BANG_EQ] = ACTIONS(780),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(813),
    [anon_sym_GT_EQ] = ACTIONS(813),
    [anon_sym_QMARK_QMARK] = ACTIONS(780),
    [anon_sym_instanceof] = ACTIONS(780),
    [anon_sym_void] = ACTIONS(815),
    [anon_sym_PLUS_PLUS] = ACTIONS(813),
    [anon_sym_DASH_DASH] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(817),
    [anon_sym_SQUOTE] = ACTIONS(819),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(813),
    [sym_number] = ACTIONS(821),
    [sym_this] = ACTIONS(1077),
    [sym_true] = ACTIONS(825),
    [sym_false] = ACTIONS(825),
    [anon_sym_any] = ACTIONS(815),
    [anon_sym_number] = ACTIONS(815),
    [anon_sym_boolean] = ACTIONS(815),
    [anon_sym_string] = ACTIONS(815),
    [anon_sym_symbol] = ACTIONS(815),
    [sym_readonly] = ACTIONS(921),
    [anon_sym_infer] = ACTIONS(495),
    [anon_sym_keyof] = ACTIONS(497),
    [anon_sym_LBRACE_PIPE] = ACTIONS(499),
  },
  [90] = {
    [ts_builtin_sym_end] = ACTIONS(1079),
    [sym_identifier] = ACTIONS(1081),
    [anon_sym_export] = ACTIONS(1081),
    [anon_sym_STAR] = ACTIONS(1081),
    [anon_sym_default] = ACTIONS(1081),
    [anon_sym_as] = ACTIONS(1081),
    [anon_sym_namespace] = ACTIONS(1081),
    [anon_sym_LBRACE] = ACTIONS(1079),
    [anon_sym_COMMA] = ACTIONS(1079),
    [anon_sym_RBRACE] = ACTIONS(1079),
    [anon_sym_type] = ACTIONS(1081),
    [anon_sym_typeof] = ACTIONS(1081),
    [anon_sym_import] = ACTIONS(1081),
    [anon_sym_var] = ACTIONS(1081),
    [anon_sym_let] = ACTIONS(1081),
    [anon_sym_const] = ACTIONS(1081),
    [anon_sym_BANG] = ACTIONS(1081),
    [anon_sym_else] = ACTIONS(1081),
    [anon_sym_if] = ACTIONS(1081),
    [anon_sym_switch] = ACTIONS(1081),
    [anon_sym_for] = ACTIONS(1081),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(1081),
    [anon_sym_in] = ACTIONS(1081),
    [anon_sym_while] = ACTIONS(1081),
    [anon_sym_do] = ACTIONS(1081),
    [anon_sym_try] = ACTIONS(1081),
    [anon_sym_with] = ACTIONS(1081),
    [anon_sym_break] = ACTIONS(1081),
    [anon_sym_continue] = ACTIONS(1081),
    [anon_sym_debugger] = ACTIONS(1081),
    [anon_sym_return] = ACTIONS(1081),
    [anon_sym_throw] = ACTIONS(1081),
    [anon_sym_SEMI] = ACTIONS(1079),
    [anon_sym_case] = ACTIONS(1081),
    [anon_sym_yield] = ACTIONS(1081),
    [anon_sym_LBRACK] = ACTIONS(1079),
    [anon_sym_LT] = ACTIONS(1081),
    [anon_sym_GT] = ACTIONS(1081),
    [anon_sym_SLASH] = ACTIONS(1081),
    [anon_sym_DOT] = ACTIONS(1081),
    [anon_sym_class] = ACTIONS(1081),
    [anon_sym_async] = ACTIONS(1081),
    [anon_sym_function] = ACTIONS(1081),
    [anon_sym_QMARK_DOT] = ACTIONS(1079),
    [anon_sym_new] = ACTIONS(1081),
    [anon_sym_QMARK] = ACTIONS(1081),
    [anon_sym_AMP_AMP] = ACTIONS(1079),
    [anon_sym_PIPE_PIPE] = ACTIONS(1079),
    [anon_sym_GT_GT] = ACTIONS(1081),
    [anon_sym_GT_GT_GT] = ACTIONS(1079),
    [anon_sym_LT_LT] = ACTIONS(1079),
    [anon_sym_AMP] = ACTIONS(1081),
    [anon_sym_CARET] = ACTIONS(1079),
    [anon_sym_PIPE] = ACTIONS(1081),
    [anon_sym_PLUS] = ACTIONS(1081),
    [anon_sym_DASH] = ACTIONS(1081),
    [anon_sym_PERCENT] = ACTIONS(1079),
    [anon_sym_STAR_STAR] = ACTIONS(1079),
    [anon_sym_LT_EQ] = ACTIONS(1079),
    [anon_sym_EQ_EQ] = ACTIONS(1081),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1079),
    [anon_sym_BANG_EQ] = ACTIONS(1081),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1079),
    [anon_sym_GT_EQ] = ACTIONS(1079),
    [anon_sym_QMARK_QMARK] = ACTIONS(1079),
    [anon_sym_instanceof] = ACTIONS(1081),
    [anon_sym_TILDE] = ACTIONS(1079),
    [anon_sym_void] = ACTIONS(1081),
    [anon_sym_delete] = ACTIONS(1081),
    [anon_sym_PLUS_PLUS] = ACTIONS(1079),
    [anon_sym_DASH_DASH] = ACTIONS(1079),
    [anon_sym_DQUOTE] = ACTIONS(1079),
    [anon_sym_SQUOTE] = ACTIONS(1079),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1079),
    [sym_number] = ACTIONS(1079),
    [sym_this] = ACTIONS(1081),
    [sym_super] = ACTIONS(1081),
    [sym_true] = ACTIONS(1081),
    [sym_false] = ACTIONS(1081),
    [sym_null] = ACTIONS(1081),
    [sym_undefined] = ACTIONS(1081),
    [anon_sym_AT] = ACTIONS(1079),
    [anon_sym_static] = ACTIONS(1081),
    [anon_sym_abstract] = ACTIONS(1081),
    [anon_sym_get] = ACTIONS(1081),
    [anon_sym_set] = ACTIONS(1081),
    [anon_sym_declare] = ACTIONS(1081),
    [anon_sym_public] = ACTIONS(1081),
    [anon_sym_private] = ACTIONS(1081),
    [anon_sym_protected] = ACTIONS(1081),
    [anon_sym_module] = ACTIONS(1081),
    [anon_sym_any] = ACTIONS(1081),
    [anon_sym_number] = ACTIONS(1081),
    [anon_sym_boolean] = ACTIONS(1081),
    [anon_sym_string] = ACTIONS(1081),
    [anon_sym_symbol] = ACTIONS(1081),
    [anon_sym_interface] = ACTIONS(1081),
    [anon_sym_enum] = ACTIONS(1081),
    [sym_readonly] = ACTIONS(1081),
    [sym__automatic_semicolon] = ACTIONS(1079),
  },
  [91] = {
    [sym_nested_identifier] = STATE(3297),
    [sym_string] = STATE(447),
    [sym_formal_parameters] = STATE(3296),
    [sym_nested_type_identifier] = STATE(1957),
    [sym__type] = STATE(2794),
    [sym_constructor_type] = STATE(2794),
    [sym__primary_type] = STATE(2659),
    [sym_infer_type] = STATE(2794),
    [sym_conditional_type] = STATE(2659),
    [sym_generic_type] = STATE(2659),
    [sym_type_query] = STATE(2659),
    [sym_index_type_query] = STATE(2659),
    [sym_lookup_type] = STATE(2659),
    [sym_literal_type] = STATE(2659),
    [sym__number] = STATE(447),
    [sym_existential_type] = STATE(2659),
    [sym_flow_maybe_type] = STATE(2659),
    [sym_parenthesized_type] = STATE(2659),
    [sym_predefined_type] = STATE(2659),
    [sym_object_type] = STATE(2659),
    [sym_type_parameters] = STATE(3048),
    [sym_array_type] = STATE(2659),
    [sym__tuple_type_body] = STATE(443),
    [sym_tuple_type] = STATE(2659),
    [sym_union_type] = STATE(2794),
    [sym_intersection_type] = STATE(2794),
    [sym_function_type] = STATE(2794),
    [sym_identifier] = ACTIONS(911),
    [anon_sym_STAR] = ACTIONS(775),
    [anon_sym_EQ] = ACTIONS(1083),
    [anon_sym_as] = ACTIONS(780),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_COMMA] = ACTIONS(813),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_BANG] = ACTIONS(780),
    [anon_sym_LPAREN] = ACTIONS(789),
    [anon_sym_in] = ACTIONS(780),
    [anon_sym_LBRACK] = ACTIONS(917),
    [anon_sym_LT] = ACTIONS(793),
    [anon_sym_GT] = ACTIONS(780),
    [anon_sym_SLASH] = ACTIONS(780),
    [anon_sym_DOT] = ACTIONS(795),
    [anon_sym_EQ_GT] = ACTIONS(1085),
    [anon_sym_QMARK_DOT] = ACTIONS(799),
    [anon_sym_new] = ACTIONS(801),
    [anon_sym_PLUS_EQ] = ACTIONS(803),
    [anon_sym_DASH_EQ] = ACTIONS(803),
    [anon_sym_STAR_EQ] = ACTIONS(803),
    [anon_sym_SLASH_EQ] = ACTIONS(803),
    [anon_sym_PERCENT_EQ] = ACTIONS(803),
    [anon_sym_CARET_EQ] = ACTIONS(803),
    [anon_sym_AMP_EQ] = ACTIONS(803),
    [anon_sym_PIPE_EQ] = ACTIONS(803),
    [anon_sym_GT_GT_EQ] = ACTIONS(803),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(803),
    [anon_sym_LT_LT_EQ] = ACTIONS(803),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(803),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(803),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(803),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(803),
    [anon_sym_QMARK] = ACTIONS(805),
    [anon_sym_AMP_AMP] = ACTIONS(780),
    [anon_sym_PIPE_PIPE] = ACTIONS(780),
    [anon_sym_GT_GT] = ACTIONS(780),
    [anon_sym_GT_GT_GT] = ACTIONS(780),
    [anon_sym_LT_LT] = ACTIONS(780),
    [anon_sym_AMP] = ACTIONS(807),
    [anon_sym_CARET] = ACTIONS(780),
    [anon_sym_PIPE] = ACTIONS(809),
    [anon_sym_PLUS] = ACTIONS(811),
    [anon_sym_DASH] = ACTIONS(811),
    [anon_sym_PERCENT] = ACTIONS(780),
    [anon_sym_STAR_STAR] = ACTIONS(780),
    [anon_sym_LT_EQ] = ACTIONS(813),
    [anon_sym_EQ_EQ] = ACTIONS(780),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(813),
    [anon_sym_BANG_EQ] = ACTIONS(780),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(813),
    [anon_sym_GT_EQ] = ACTIONS(813),
    [anon_sym_QMARK_QMARK] = ACTIONS(780),
    [anon_sym_instanceof] = ACTIONS(780),
    [anon_sym_void] = ACTIONS(815),
    [anon_sym_PLUS_PLUS] = ACTIONS(813),
    [anon_sym_DASH_DASH] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(817),
    [anon_sym_SQUOTE] = ACTIONS(819),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(813),
    [sym_number] = ACTIONS(821),
    [sym_this] = ACTIONS(919),
    [sym_true] = ACTIONS(825),
    [sym_false] = ACTIONS(825),
    [anon_sym_any] = ACTIONS(815),
    [anon_sym_number] = ACTIONS(815),
    [anon_sym_boolean] = ACTIONS(815),
    [anon_sym_string] = ACTIONS(815),
    [anon_sym_symbol] = ACTIONS(815),
    [anon_sym_implements] = ACTIONS(780),
    [sym_readonly] = ACTIONS(921),
    [anon_sym_infer] = ACTIONS(495),
    [anon_sym_keyof] = ACTIONS(497),
    [anon_sym_LBRACE_PIPE] = ACTIONS(499),
  },
  [92] = {
    [ts_builtin_sym_end] = ACTIONS(1087),
    [sym_identifier] = ACTIONS(1089),
    [anon_sym_export] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_default] = ACTIONS(1089),
    [anon_sym_as] = ACTIONS(1089),
    [anon_sym_namespace] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1087),
    [anon_sym_COMMA] = ACTIONS(1087),
    [anon_sym_RBRACE] = ACTIONS(1087),
    [anon_sym_type] = ACTIONS(1089),
    [anon_sym_typeof] = ACTIONS(1089),
    [anon_sym_import] = ACTIONS(1089),
    [anon_sym_var] = ACTIONS(1089),
    [anon_sym_let] = ACTIONS(1089),
    [anon_sym_const] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1089),
    [anon_sym_else] = ACTIONS(1089),
    [anon_sym_if] = ACTIONS(1089),
    [anon_sym_switch] = ACTIONS(1089),
    [anon_sym_for] = ACTIONS(1089),
    [anon_sym_LPAREN] = ACTIONS(1087),
    [anon_sym_await] = ACTIONS(1089),
    [anon_sym_in] = ACTIONS(1089),
    [anon_sym_while] = ACTIONS(1089),
    [anon_sym_do] = ACTIONS(1089),
    [anon_sym_try] = ACTIONS(1089),
    [anon_sym_with] = ACTIONS(1089),
    [anon_sym_break] = ACTIONS(1089),
    [anon_sym_continue] = ACTIONS(1089),
    [anon_sym_debugger] = ACTIONS(1089),
    [anon_sym_return] = ACTIONS(1089),
    [anon_sym_throw] = ACTIONS(1089),
    [anon_sym_SEMI] = ACTIONS(1087),
    [anon_sym_case] = ACTIONS(1089),
    [anon_sym_yield] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1087),
    [anon_sym_LT] = ACTIONS(1089),
    [anon_sym_GT] = ACTIONS(1089),
    [anon_sym_SLASH] = ACTIONS(1089),
    [anon_sym_DOT] = ACTIONS(1089),
    [anon_sym_class] = ACTIONS(1089),
    [anon_sym_async] = ACTIONS(1089),
    [anon_sym_function] = ACTIONS(1089),
    [anon_sym_QMARK_DOT] = ACTIONS(1087),
    [anon_sym_new] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1089),
    [anon_sym_AMP_AMP] = ACTIONS(1087),
    [anon_sym_PIPE_PIPE] = ACTIONS(1087),
    [anon_sym_GT_GT] = ACTIONS(1089),
    [anon_sym_GT_GT_GT] = ACTIONS(1087),
    [anon_sym_LT_LT] = ACTIONS(1087),
    [anon_sym_AMP] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1087),
    [anon_sym_PIPE] = ACTIONS(1089),
    [anon_sym_PLUS] = ACTIONS(1089),
    [anon_sym_DASH] = ACTIONS(1089),
    [anon_sym_PERCENT] = ACTIONS(1087),
    [anon_sym_STAR_STAR] = ACTIONS(1087),
    [anon_sym_LT_EQ] = ACTIONS(1087),
    [anon_sym_EQ_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1087),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1087),
    [anon_sym_GT_EQ] = ACTIONS(1087),
    [anon_sym_QMARK_QMARK] = ACTIONS(1087),
    [anon_sym_instanceof] = ACTIONS(1089),
    [anon_sym_TILDE] = ACTIONS(1087),
    [anon_sym_void] = ACTIONS(1089),
    [anon_sym_delete] = ACTIONS(1089),
    [anon_sym_PLUS_PLUS] = ACTIONS(1087),
    [anon_sym_DASH_DASH] = ACTIONS(1087),
    [anon_sym_DQUOTE] = ACTIONS(1087),
    [anon_sym_SQUOTE] = ACTIONS(1087),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1087),
    [sym_number] = ACTIONS(1087),
    [sym_this] = ACTIONS(1089),
    [sym_super] = ACTIONS(1089),
    [sym_true] = ACTIONS(1089),
    [sym_false] = ACTIONS(1089),
    [sym_null] = ACTIONS(1089),
    [sym_undefined] = ACTIONS(1089),
    [anon_sym_AT] = ACTIONS(1087),
    [anon_sym_static] = ACTIONS(1089),
    [anon_sym_abstract] = ACTIONS(1089),
    [anon_sym_get] = ACTIONS(1089),
    [anon_sym_set] = ACTIONS(1089),
    [anon_sym_declare] = ACTIONS(1089),
    [anon_sym_public] = ACTIONS(1089),
    [anon_sym_private] = ACTIONS(1089),
    [anon_sym_protected] = ACTIONS(1089),
    [anon_sym_module] = ACTIONS(1089),
    [anon_sym_any] = ACTIONS(1089),
    [anon_sym_number] = ACTIONS(1089),
    [anon_sym_boolean] = ACTIONS(1089),
    [anon_sym_string] = ACTIONS(1089),
    [anon_sym_symbol] = ACTIONS(1089),
    [anon_sym_interface] = ACTIONS(1089),
    [anon_sym_enum] = ACTIONS(1089),
    [sym_readonly] = ACTIONS(1089),
    [sym__automatic_semicolon] = ACTIONS(1087),
  },
  [93] = {
    [ts_builtin_sym_end] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1093),
    [anon_sym_export] = ACTIONS(1093),
    [anon_sym_STAR] = ACTIONS(1093),
    [anon_sym_default] = ACTIONS(1093),
    [anon_sym_as] = ACTIONS(1093),
    [anon_sym_namespace] = ACTIONS(1093),
    [anon_sym_LBRACE] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1091),
    [anon_sym_RBRACE] = ACTIONS(1091),
    [anon_sym_type] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(1093),
    [anon_sym_import] = ACTIONS(1093),
    [anon_sym_var] = ACTIONS(1093),
    [anon_sym_let] = ACTIONS(1093),
    [anon_sym_const] = ACTIONS(1093),
    [anon_sym_BANG] = ACTIONS(1093),
    [anon_sym_else] = ACTIONS(1093),
    [anon_sym_if] = ACTIONS(1093),
    [anon_sym_switch] = ACTIONS(1093),
    [anon_sym_for] = ACTIONS(1093),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_in] = ACTIONS(1093),
    [anon_sym_while] = ACTIONS(1093),
    [anon_sym_do] = ACTIONS(1093),
    [anon_sym_try] = ACTIONS(1093),
    [anon_sym_with] = ACTIONS(1093),
    [anon_sym_break] = ACTIONS(1093),
    [anon_sym_continue] = ACTIONS(1093),
    [anon_sym_debugger] = ACTIONS(1093),
    [anon_sym_return] = ACTIONS(1093),
    [anon_sym_throw] = ACTIONS(1093),
    [anon_sym_SEMI] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1093),
    [anon_sym_yield] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1093),
    [anon_sym_GT] = ACTIONS(1093),
    [anon_sym_SLASH] = ACTIONS(1093),
    [anon_sym_DOT] = ACTIONS(1093),
    [anon_sym_class] = ACTIONS(1093),
    [anon_sym_async] = ACTIONS(1093),
    [anon_sym_function] = ACTIONS(1093),
    [anon_sym_QMARK_DOT] = ACTIONS(1091),
    [anon_sym_new] = ACTIONS(1093),
    [anon_sym_QMARK] = ACTIONS(1093),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1093),
    [anon_sym_GT_GT_GT] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1093),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PIPE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1093),
    [anon_sym_DASH] = ACTIONS(1093),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1093),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1093),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1091),
    [anon_sym_QMARK_QMARK] = ACTIONS(1091),
    [anon_sym_instanceof] = ACTIONS(1093),
    [anon_sym_TILDE] = ACTIONS(1091),
    [anon_sym_void] = ACTIONS(1093),
    [anon_sym_delete] = ACTIONS(1093),
    [anon_sym_PLUS_PLUS] = ACTIONS(1091),
    [anon_sym_DASH_DASH] = ACTIONS(1091),
    [anon_sym_DQUOTE] = ACTIONS(1091),
    [anon_sym_SQUOTE] = ACTIONS(1091),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1091),
    [sym_number] = ACTIONS(1091),
    [sym_this] = ACTIONS(1093),
    [sym_super] = ACTIONS(1093),
    [sym_true] = ACTIONS(1093),
    [sym_false] = ACTIONS(1093),
    [sym_null] = ACTIONS(1093),
    [sym_undefined] = ACTIONS(1093),
    [anon_sym_AT] = ACTIONS(1091),
    [anon_sym_static] = ACTIONS(1093),
    [anon_sym_abstract] = ACTIONS(1093),
    [anon_sym_get] = ACTIONS(1093),
    [anon_sym_set] = ACTIONS(1093),
    [anon_sym_declare] = ACTIONS(1093),
    [anon_sym_public] = ACTIONS(1093),
    [anon_sym_private] = ACTIONS(1093),
    [anon_sym_protected] = ACTIONS(1093),
    [anon_sym_module] = ACTIONS(1093),
    [anon_sym_any] = ACTIONS(1093),
    [anon_sym_number] = ACTIONS(1093),
    [anon_sym_boolean] = ACTIONS(1093),
    [anon_sym_string] = ACTIONS(1093),
    [anon_sym_symbol] = ACTIONS(1093),
    [anon_sym_interface] = ACTIONS(1093),
    [anon_sym_enum] = ACTIONS(1093),
    [sym_readonly] = ACTIONS(1093),
    [sym__automatic_semicolon] = ACTIONS(1091),
  },
  [94] = {
    [ts_builtin_sym_end] = ACTIONS(1049),
    [sym_identifier] = ACTIONS(1051),
    [anon_sym_export] = ACTIONS(1051),
    [anon_sym_STAR] = ACTIONS(1051),
    [anon_sym_default] = ACTIONS(1051),
    [anon_sym_as] = ACTIONS(1051),
    [anon_sym_namespace] = ACTIONS(1051),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_COMMA] = ACTIONS(1049),
    [anon_sym_RBRACE] = ACTIONS(1049),
    [anon_sym_type] = ACTIONS(1051),
    [anon_sym_typeof] = ACTIONS(1051),
    [anon_sym_import] = ACTIONS(1051),
    [anon_sym_var] = ACTIONS(1051),
    [anon_sym_let] = ACTIONS(1051),
    [anon_sym_const] = ACTIONS(1051),
    [anon_sym_BANG] = ACTIONS(1051),
    [anon_sym_else] = ACTIONS(1051),
    [anon_sym_if] = ACTIONS(1051),
    [anon_sym_switch] = ACTIONS(1051),
    [anon_sym_for] = ACTIONS(1051),
    [anon_sym_LPAREN] = ACTIONS(1049),
    [anon_sym_await] = ACTIONS(1051),
    [anon_sym_in] = ACTIONS(1051),
    [anon_sym_while] = ACTIONS(1051),
    [anon_sym_do] = ACTIONS(1051),
    [anon_sym_try] = ACTIONS(1051),
    [anon_sym_with] = ACTIONS(1051),
    [anon_sym_break] = ACTIONS(1051),
    [anon_sym_continue] = ACTIONS(1051),
    [anon_sym_debugger] = ACTIONS(1051),
    [anon_sym_return] = ACTIONS(1051),
    [anon_sym_throw] = ACTIONS(1051),
    [anon_sym_SEMI] = ACTIONS(1049),
    [anon_sym_case] = ACTIONS(1051),
    [anon_sym_yield] = ACTIONS(1051),
    [anon_sym_LBRACK] = ACTIONS(1049),
    [anon_sym_LT] = ACTIONS(1051),
    [anon_sym_GT] = ACTIONS(1051),
    [anon_sym_SLASH] = ACTIONS(1051),
    [anon_sym_DOT] = ACTIONS(1051),
    [anon_sym_class] = ACTIONS(1051),
    [anon_sym_async] = ACTIONS(1051),
    [anon_sym_function] = ACTIONS(1051),
    [anon_sym_QMARK_DOT] = ACTIONS(1049),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_QMARK] = ACTIONS(1051),
    [anon_sym_AMP_AMP] = ACTIONS(1049),
    [anon_sym_PIPE_PIPE] = ACTIONS(1049),
    [anon_sym_GT_GT] = ACTIONS(1051),
    [anon_sym_GT_GT_GT] = ACTIONS(1049),
    [anon_sym_LT_LT] = ACTIONS(1049),
    [anon_sym_AMP] = ACTIONS(1051),
    [anon_sym_CARET] = ACTIONS(1049),
    [anon_sym_PIPE] = ACTIONS(1051),
    [anon_sym_PLUS] = ACTIONS(1051),
    [anon_sym_DASH] = ACTIONS(1051),
    [anon_sym_PERCENT] = ACTIONS(1049),
    [anon_sym_STAR_STAR] = ACTIONS(1049),
    [anon_sym_LT_EQ] = ACTIONS(1049),
    [anon_sym_EQ_EQ] = ACTIONS(1051),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1049),
    [anon_sym_BANG_EQ] = ACTIONS(1051),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1049),
    [anon_sym_GT_EQ] = ACTIONS(1049),
    [anon_sym_QMARK_QMARK] = ACTIONS(1049),
    [anon_sym_instanceof] = ACTIONS(1051),
    [anon_sym_TILDE] = ACTIONS(1049),
    [anon_sym_void] = ACTIONS(1051),
    [anon_sym_delete] = ACTIONS(1051),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_DQUOTE] = ACTIONS(1049),
    [anon_sym_SQUOTE] = ACTIONS(1049),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1049),
    [sym_number] = ACTIONS(1049),
    [sym_this] = ACTIONS(1051),
    [sym_super] = ACTIONS(1051),
    [sym_true] = ACTIONS(1051),
    [sym_false] = ACTIONS(1051),
    [sym_null] = ACTIONS(1051),
    [sym_undefined] = ACTIONS(1051),
    [anon_sym_AT] = ACTIONS(1049),
    [anon_sym_static] = ACTIONS(1051),
    [anon_sym_abstract] = ACTIONS(1051),
    [anon_sym_get] = ACTIONS(1051),
    [anon_sym_set] = ACTIONS(1051),
    [anon_sym_declare] = ACTIONS(1051),
    [anon_sym_public] = ACTIONS(1051),
    [anon_sym_private] = ACTIONS(1051),
    [anon_sym_protected] = ACTIONS(1051),
    [anon_sym_module] = ACTIONS(1051),
    [anon_sym_any] = ACTIONS(1051),
    [anon_sym_number] = ACTIONS(1051),
    [anon_sym_boolean] = ACTIONS(1051),
    [anon_sym_string] = ACTIONS(1051),
    [anon_sym_symbol] = ACTIONS(1051),
    [anon_sym_interface] = ACTIONS(1051),
    [anon_sym_enum] = ACTIONS(1051),
    [sym_readonly] = ACTIONS(1051),
    [sym__automatic_semicolon] = ACTIONS(1095),
  },
  [95] = {
    [ts_builtin_sym_end] = ACTIONS(1097),
    [sym_identifier] = ACTIONS(1099),
    [anon_sym_export] = ACTIONS(1099),
    [anon_sym_STAR] = ACTIONS(1101),
    [anon_sym_default] = ACTIONS(1099),
    [anon_sym_as] = ACTIONS(1101),
    [anon_sym_namespace] = ACTIONS(1099),
    [anon_sym_LBRACE] = ACTIONS(1097),
    [anon_sym_COMMA] = ACTIONS(1103),
    [anon_sym_RBRACE] = ACTIONS(1097),
    [anon_sym_type] = ACTIONS(1099),
    [anon_sym_typeof] = ACTIONS(1099),
    [anon_sym_import] = ACTIONS(1099),
    [anon_sym_var] = ACTIONS(1099),
    [anon_sym_let] = ACTIONS(1099),
    [anon_sym_const] = ACTIONS(1099),
    [anon_sym_BANG] = ACTIONS(1099),
    [anon_sym_else] = ACTIONS(1099),
    [anon_sym_if] = ACTIONS(1099),
    [anon_sym_switch] = ACTIONS(1099),
    [anon_sym_for] = ACTIONS(1099),
    [anon_sym_LPAREN] = ACTIONS(1097),
    [anon_sym_await] = ACTIONS(1099),
    [anon_sym_in] = ACTIONS(1101),
    [anon_sym_while] = ACTIONS(1099),
    [anon_sym_do] = ACTIONS(1099),
    [anon_sym_try] = ACTIONS(1099),
    [anon_sym_with] = ACTIONS(1099),
    [anon_sym_break] = ACTIONS(1099),
    [anon_sym_continue] = ACTIONS(1099),
    [anon_sym_debugger] = ACTIONS(1099),
    [anon_sym_return] = ACTIONS(1099),
    [anon_sym_throw] = ACTIONS(1099),
    [anon_sym_SEMI] = ACTIONS(1097),
    [anon_sym_case] = ACTIONS(1099),
    [anon_sym_yield] = ACTIONS(1099),
    [anon_sym_LBRACK] = ACTIONS(1097),
    [anon_sym_LT] = ACTIONS(1099),
    [anon_sym_GT] = ACTIONS(1101),
    [anon_sym_SLASH] = ACTIONS(1099),
    [anon_sym_DOT] = ACTIONS(1101),
    [anon_sym_class] = ACTIONS(1099),
    [anon_sym_async] = ACTIONS(1099),
    [anon_sym_function] = ACTIONS(1099),
    [anon_sym_QMARK_DOT] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(1099),
    [anon_sym_QMARK] = ACTIONS(1101),
    [anon_sym_AMP_AMP] = ACTIONS(1103),
    [anon_sym_PIPE_PIPE] = ACTIONS(1103),
    [anon_sym_GT_GT] = ACTIONS(1101),
    [anon_sym_GT_GT_GT] = ACTIONS(1103),
    [anon_sym_LT_LT] = ACTIONS(1103),
    [anon_sym_AMP] = ACTIONS(1101),
    [anon_sym_CARET] = ACTIONS(1103),
    [anon_sym_PIPE] = ACTIONS(1101),
    [anon_sym_PLUS] = ACTIONS(1099),
    [anon_sym_DASH] = ACTIONS(1099),
    [anon_sym_PERCENT] = ACTIONS(1103),
    [anon_sym_STAR_STAR] = ACTIONS(1103),
    [anon_sym_LT_EQ] = ACTIONS(1103),
    [anon_sym_EQ_EQ] = ACTIONS(1101),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1103),
    [anon_sym_BANG_EQ] = ACTIONS(1101),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1103),
    [anon_sym_GT_EQ] = ACTIONS(1103),
    [anon_sym_QMARK_QMARK] = ACTIONS(1103),
    [anon_sym_instanceof] = ACTIONS(1101),
    [anon_sym_TILDE] = ACTIONS(1097),
    [anon_sym_void] = ACTIONS(1099),
    [anon_sym_delete] = ACTIONS(1099),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_DQUOTE] = ACTIONS(1097),
    [anon_sym_SQUOTE] = ACTIONS(1097),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1097),
    [sym_number] = ACTIONS(1097),
    [sym_this] = ACTIONS(1099),
    [sym_super] = ACTIONS(1099),
    [sym_true] = ACTIONS(1099),
    [sym_false] = ACTIONS(1099),
    [sym_null] = ACTIONS(1099),
    [sym_undefined] = ACTIONS(1099),
    [anon_sym_AT] = ACTIONS(1097),
    [anon_sym_static] = ACTIONS(1099),
    [anon_sym_abstract] = ACTIONS(1099),
    [anon_sym_get] = ACTIONS(1099),
    [anon_sym_set] = ACTIONS(1099),
    [anon_sym_declare] = ACTIONS(1099),
    [anon_sym_public] = ACTIONS(1099),
    [anon_sym_private] = ACTIONS(1099),
    [anon_sym_protected] = ACTIONS(1099),
    [anon_sym_module] = ACTIONS(1099),
    [anon_sym_any] = ACTIONS(1099),
    [anon_sym_number] = ACTIONS(1099),
    [anon_sym_boolean] = ACTIONS(1099),
    [anon_sym_string] = ACTIONS(1099),
    [anon_sym_symbol] = ACTIONS(1099),
    [anon_sym_interface] = ACTIONS(1099),
    [anon_sym_enum] = ACTIONS(1099),
    [sym_readonly] = ACTIONS(1099),
    [sym__automatic_semicolon] = ACTIONS(1105),
  },
  [96] = {
    [ts_builtin_sym_end] = ACTIONS(1107),
    [sym_identifier] = ACTIONS(1109),
    [anon_sym_export] = ACTIONS(1109),
    [anon_sym_STAR] = ACTIONS(1111),
    [anon_sym_default] = ACTIONS(1109),
    [anon_sym_as] = ACTIONS(1111),
    [anon_sym_namespace] = ACTIONS(1109),
    [anon_sym_LBRACE] = ACTIONS(1107),
    [anon_sym_COMMA] = ACTIONS(1113),
    [anon_sym_RBRACE] = ACTIONS(1107),
    [anon_sym_type] = ACTIONS(1109),
    [anon_sym_typeof] = ACTIONS(1109),
    [anon_sym_import] = ACTIONS(1109),
    [anon_sym_var] = ACTIONS(1109),
    [anon_sym_let] = ACTIONS(1109),
    [anon_sym_const] = ACTIONS(1109),
    [anon_sym_BANG] = ACTIONS(1109),
    [anon_sym_else] = ACTIONS(1109),
    [anon_sym_if] = ACTIONS(1109),
    [anon_sym_switch] = ACTIONS(1109),
    [anon_sym_for] = ACTIONS(1109),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1109),
    [anon_sym_in] = ACTIONS(1111),
    [anon_sym_while] = ACTIONS(1109),
    [anon_sym_do] = ACTIONS(1109),
    [anon_sym_try] = ACTIONS(1109),
    [anon_sym_with] = ACTIONS(1109),
    [anon_sym_break] = ACTIONS(1109),
    [anon_sym_continue] = ACTIONS(1109),
    [anon_sym_debugger] = ACTIONS(1109),
    [anon_sym_return] = ACTIONS(1109),
    [anon_sym_throw] = ACTIONS(1109),
    [anon_sym_SEMI] = ACTIONS(1107),
    [anon_sym_case] = ACTIONS(1109),
    [anon_sym_yield] = ACTIONS(1109),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(1109),
    [anon_sym_GT] = ACTIONS(1111),
    [anon_sym_SLASH] = ACTIONS(1109),
    [anon_sym_DOT] = ACTIONS(1111),
    [anon_sym_class] = ACTIONS(1109),
    [anon_sym_async] = ACTIONS(1109),
    [anon_sym_function] = ACTIONS(1109),
    [anon_sym_QMARK_DOT] = ACTIONS(1113),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_QMARK] = ACTIONS(1111),
    [anon_sym_AMP_AMP] = ACTIONS(1113),
    [anon_sym_PIPE_PIPE] = ACTIONS(1113),
    [anon_sym_GT_GT] = ACTIONS(1111),
    [anon_sym_GT_GT_GT] = ACTIONS(1113),
    [anon_sym_LT_LT] = ACTIONS(1113),
    [anon_sym_AMP] = ACTIONS(1111),
    [anon_sym_CARET] = ACTIONS(1113),
    [anon_sym_PIPE] = ACTIONS(1111),
    [anon_sym_PLUS] = ACTIONS(1109),
    [anon_sym_DASH] = ACTIONS(1109),
    [anon_sym_PERCENT] = ACTIONS(1113),
    [anon_sym_STAR_STAR] = ACTIONS(1113),
    [anon_sym_LT_EQ] = ACTIONS(1113),
    [anon_sym_EQ_EQ] = ACTIONS(1111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1113),
    [anon_sym_BANG_EQ] = ACTIONS(1111),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1113),
    [anon_sym_GT_EQ] = ACTIONS(1113),
    [anon_sym_QMARK_QMARK] = ACTIONS(1113),
    [anon_sym_instanceof] = ACTIONS(1111),
    [anon_sym_TILDE] = ACTIONS(1107),
    [anon_sym_void] = ACTIONS(1109),
    [anon_sym_delete] = ACTIONS(1109),
    [anon_sym_PLUS_PLUS] = ACTIONS(1107),
    [anon_sym_DASH_DASH] = ACTIONS(1107),
    [anon_sym_DQUOTE] = ACTIONS(1107),
    [anon_sym_SQUOTE] = ACTIONS(1107),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1107),
    [sym_number] = ACTIONS(1107),
    [sym_this] = ACTIONS(1109),
    [sym_super] = ACTIONS(1109),
    [sym_true] = ACTIONS(1109),
    [sym_false] = ACTIONS(1109),
    [sym_null] = ACTIONS(1109),
    [sym_undefined] = ACTIONS(1109),
    [anon_sym_AT] = ACTIONS(1107),
    [anon_sym_static] = ACTIONS(1109),
    [anon_sym_abstract] = ACTIONS(1109),
    [anon_sym_get] = ACTIONS(1109),
    [anon_sym_set] = ACTIONS(1109),
    [anon_sym_declare] = ACTIONS(1109),
    [anon_sym_public] = ACTIONS(1109),
    [anon_sym_private] = ACTIONS(1109),
    [anon_sym_protected] = ACTIONS(1109),
    [anon_sym_module] = ACTIONS(1109),
    [anon_sym_any] = ACTIONS(1109),
    [anon_sym_number] = ACTIONS(1109),
    [anon_sym_boolean] = ACTIONS(1109),
    [anon_sym_string] = ACTIONS(1109),
    [anon_sym_symbol] = ACTIONS(1109),
    [anon_sym_interface] = ACTIONS(1109),
    [anon_sym_enum] = ACTIONS(1109),
    [sym_readonly] = ACTIONS(1109),
    [sym__automatic_semicolon] = ACTIONS(1113),
  },
  [97] = {
    [ts_builtin_sym_end] = ACTIONS(1115),
    [sym_identifier] = ACTIONS(1117),
    [anon_sym_export] = ACTIONS(1117),
    [anon_sym_STAR] = ACTIONS(1119),
    [anon_sym_default] = ACTIONS(1117),
    [anon_sym_as] = ACTIONS(1119),
    [anon_sym_namespace] = ACTIONS(1117),
    [anon_sym_LBRACE] = ACTIONS(1115),
    [anon_sym_COMMA] = ACTIONS(1121),
    [anon_sym_RBRACE] = ACTIONS(1115),
    [anon_sym_type] = ACTIONS(1117),
    [anon_sym_typeof] = ACTIONS(1117),
    [anon_sym_import] = ACTIONS(1117),
    [anon_sym_var] = ACTIONS(1117),
    [anon_sym_let] = ACTIONS(1117),
    [anon_sym_const] = ACTIONS(1117),
    [anon_sym_BANG] = ACTIONS(1117),
    [anon_sym_else] = ACTIONS(1117),
    [anon_sym_if] = ACTIONS(1117),
    [anon_sym_switch] = ACTIONS(1117),
    [anon_sym_for] = ACTIONS(1117),
    [anon_sym_LPAREN] = ACTIONS(1115),
    [anon_sym_await] = ACTIONS(1117),
    [anon_sym_in] = ACTIONS(1119),
    [anon_sym_while] = ACTIONS(1117),
    [anon_sym_do] = ACTIONS(1117),
    [anon_sym_try] = ACTIONS(1117),
    [anon_sym_with] = ACTIONS(1117),
    [anon_sym_break] = ACTIONS(1117),
    [anon_sym_continue] = ACTIONS(1117),
    [anon_sym_debugger] = ACTIONS(1117),
    [anon_sym_return] = ACTIONS(1117),
    [anon_sym_throw] = ACTIONS(1117),
    [anon_sym_SEMI] = ACTIONS(1115),
    [anon_sym_case] = ACTIONS(1117),
    [anon_sym_yield] = ACTIONS(1117),
    [anon_sym_LBRACK] = ACTIONS(1115),
    [anon_sym_LT] = ACTIONS(1117),
    [anon_sym_GT] = ACTIONS(1119),
    [anon_sym_SLASH] = ACTIONS(1117),
    [anon_sym_DOT] = ACTIONS(1119),
    [anon_sym_class] = ACTIONS(1117),
    [anon_sym_async] = ACTIONS(1117),
    [anon_sym_function] = ACTIONS(1117),
    [anon_sym_QMARK_DOT] = ACTIONS(1121),
    [anon_sym_new] = ACTIONS(1117),
    [anon_sym_QMARK] = ACTIONS(1119),
    [anon_sym_AMP_AMP] = ACTIONS(1121),
    [anon_sym_PIPE_PIPE] = ACTIONS(1121),
    [anon_sym_GT_GT] = ACTIONS(1119),
    [anon_sym_GT_GT_GT] = ACTIONS(1121),
    [anon_sym_LT_LT] = ACTIONS(1121),
    [anon_sym_AMP] = ACTIONS(1119),
    [anon_sym_CARET] = ACTIONS(1121),
    [anon_sym_PIPE] = ACTIONS(1119),
    [anon_sym_PLUS] = ACTIONS(1117),
    [anon_sym_DASH] = ACTIONS(1117),
    [anon_sym_PERCENT] = ACTIONS(1121),
    [anon_sym_STAR_STAR] = ACTIONS(1121),
    [anon_sym_LT_EQ] = ACTIONS(1121),
    [anon_sym_EQ_EQ] = ACTIONS(1119),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1121),
    [anon_sym_BANG_EQ] = ACTIONS(1119),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1121),
    [anon_sym_GT_EQ] = ACTIONS(1121),
    [anon_sym_QMARK_QMARK] = ACTIONS(1121),
    [anon_sym_instanceof] = ACTIONS(1119),
    [anon_sym_TILDE] = ACTIONS(1115),
    [anon_sym_void] = ACTIONS(1117),
    [anon_sym_delete] = ACTIONS(1117),
    [anon_sym_PLUS_PLUS] = ACTIONS(1115),
    [anon_sym_DASH_DASH] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1115),
    [anon_sym_SQUOTE] = ACTIONS(1115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1115),
    [sym_number] = ACTIONS(1115),
    [sym_this] = ACTIONS(1117),
    [sym_super] = ACTIONS(1117),
    [sym_true] = ACTIONS(1117),
    [sym_false] = ACTIONS(1117),
    [sym_null] = ACTIONS(1117),
    [sym_undefined] = ACTIONS(1117),
    [anon_sym_AT] = ACTIONS(1115),
    [anon_sym_static] = ACTIONS(1117),
    [anon_sym_abstract] = ACTIONS(1117),
    [anon_sym_get] = ACTIONS(1117),
    [anon_sym_set] = ACTIONS(1117),
    [anon_sym_declare] = ACTIONS(1117),
    [anon_sym_public] = ACTIONS(1117),
    [anon_sym_private] = ACTIONS(1117),
    [anon_sym_protected] = ACTIONS(1117),
    [anon_sym_module] = ACTIONS(1117),
    [anon_sym_any] = ACTIONS(1117),
    [anon_sym_number] = ACTIONS(1117),
    [anon_sym_boolean] = ACTIONS(1117),
    [anon_sym_string] = ACTIONS(1117),
    [anon_sym_symbol] = ACTIONS(1117),
    [anon_sym_interface] = ACTIONS(1117),
    [anon_sym_enum] = ACTIONS(1117),
    [sym_readonly] = ACTIONS(1117),
    [sym__automatic_semicolon] = ACTIONS(1123),
  },
  [98] = {
    [ts_builtin_sym_end] = ACTIONS(1125),
    [sym_identifier] = ACTIONS(1127),
    [anon_sym_export] = ACTIONS(1127),
    [anon_sym_STAR] = ACTIONS(1129),
    [anon_sym_default] = ACTIONS(1127),
    [anon_sym_as] = ACTIONS(1129),
    [anon_sym_namespace] = ACTIONS(1127),
    [anon_sym_LBRACE] = ACTIONS(1125),
    [anon_sym_COMMA] = ACTIONS(1131),
    [anon_sym_RBRACE] = ACTIONS(1125),
    [anon_sym_type] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1127),
    [anon_sym_import] = ACTIONS(1127),
    [anon_sym_var] = ACTIONS(1127),
    [anon_sym_let] = ACTIONS(1127),
    [anon_sym_const] = ACTIONS(1127),
    [anon_sym_BANG] = ACTIONS(1127),
    [anon_sym_else] = ACTIONS(1127),
    [anon_sym_if] = ACTIONS(1127),
    [anon_sym_switch] = ACTIONS(1127),
    [anon_sym_for] = ACTIONS(1127),
    [anon_sym_LPAREN] = ACTIONS(1125),
    [anon_sym_await] = ACTIONS(1127),
    [anon_sym_in] = ACTIONS(1129),
    [anon_sym_while] = ACTIONS(1127),
    [anon_sym_do] = ACTIONS(1127),
    [anon_sym_try] = ACTIONS(1127),
    [anon_sym_with] = ACTIONS(1127),
    [anon_sym_break] = ACTIONS(1127),
    [anon_sym_continue] = ACTIONS(1127),
    [anon_sym_debugger] = ACTIONS(1127),
    [anon_sym_return] = ACTIONS(1127),
    [anon_sym_throw] = ACTIONS(1127),
    [anon_sym_SEMI] = ACTIONS(1125),
    [anon_sym_case] = ACTIONS(1127),
    [anon_sym_yield] = ACTIONS(1127),
    [anon_sym_LBRACK] = ACTIONS(1125),
    [anon_sym_LT] = ACTIONS(1127),
    [anon_sym_GT] = ACTIONS(1129),
    [anon_sym_SLASH] = ACTIONS(1127),
    [anon_sym_DOT] = ACTIONS(1129),
    [anon_sym_class] = ACTIONS(1127),
    [anon_sym_async] = ACTIONS(1127),
    [anon_sym_function] = ACTIONS(1127),
    [anon_sym_QMARK_DOT] = ACTIONS(1131),
    [anon_sym_new] = ACTIONS(1127),
    [anon_sym_QMARK] = ACTIONS(1129),
    [anon_sym_AMP_AMP] = ACTIONS(1131),
    [anon_sym_PIPE_PIPE] = ACTIONS(1131),
    [anon_sym_GT_GT] = ACTIONS(1129),
    [anon_sym_GT_GT_GT] = ACTIONS(1131),
    [anon_sym_LT_LT] = ACTIONS(1131),
    [anon_sym_AMP] = ACTIONS(1129),
    [anon_sym_CARET] = ACTIONS(1131),
    [anon_sym_PIPE] = ACTIONS(1129),
    [anon_sym_PLUS] = ACTIONS(1127),
    [anon_sym_DASH] = ACTIONS(1127),
    [anon_sym_PERCENT] = ACTIONS(1131),
    [anon_sym_STAR_STAR] = ACTIONS(1131),
    [anon_sym_LT_EQ] = ACTIONS(1131),
    [anon_sym_EQ_EQ] = ACTIONS(1129),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1131),
    [anon_sym_BANG_EQ] = ACTIONS(1129),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1131),
    [anon_sym_GT_EQ] = ACTIONS(1131),
    [anon_sym_QMARK_QMARK] = ACTIONS(1131),
    [anon_sym_instanceof] = ACTIONS(1129),
    [anon_sym_TILDE] = ACTIONS(1125),
    [anon_sym_void] = ACTIONS(1127),
    [anon_sym_delete] = ACTIONS(1127),
    [anon_sym_PLUS_PLUS] = ACTIONS(1125),
    [anon_sym_DASH_DASH] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1125),
    [anon_sym_SQUOTE] = ACTIONS(1125),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1125),
    [sym_number] = ACTIONS(1125),
    [sym_this] = ACTIONS(1127),
    [sym_super] = ACTIONS(1127),
    [sym_true] = ACTIONS(1127),
    [sym_false] = ACTIONS(1127),
    [sym_null] = ACTIONS(1127),
    [sym_undefined] = ACTIONS(1127),
    [anon_sym_AT] = ACTIONS(1125),
    [anon_sym_static] = ACTIONS(1127),
    [anon_sym_abstract] = ACTIONS(1127),
    [anon_sym_get] = ACTIONS(1127),
    [anon_sym_set] = ACTIONS(1127),
    [anon_sym_declare] = ACTIONS(1127),
    [anon_sym_public] = ACTIONS(1127),
    [anon_sym_private] = ACTIONS(1127),
    [anon_sym_protected] = ACTIONS(1127),
    [anon_sym_module] = ACTIONS(1127),
    [anon_sym_any] = ACTIONS(1127),
    [anon_sym_number] = ACTIONS(1127),
    [anon_sym_boolean] = ACTIONS(1127),
    [anon_sym_string] = ACTIONS(1127),
    [anon_sym_symbol] = ACTIONS(1127),
    [anon_sym_interface] = ACTIONS(1127),
    [anon_sym_enum] = ACTIONS(1127),
    [sym_readonly] = ACTIONS(1127),
    [sym__automatic_semicolon] = ACTIONS(1133),
  },
  [99] = {
    [sym_nested_identifier] = STATE(3297),
    [sym_string] = STATE(447),
    [sym_formal_parameters] = STATE(3296),
    [sym_nested_type_identifier] = STATE(1957),
    [sym__type] = STATE(2794),
    [sym_constructor_type] = STATE(2794),
    [sym__primary_type] = STATE(2659),
    [sym_infer_type] = STATE(2794),
    [sym_conditional_type] = STATE(2659),
    [sym_generic_type] = STATE(2659),
    [sym_type_query] = STATE(2659),
    [sym_index_type_query] = STATE(2659),
    [sym_lookup_type] = STATE(2659),
    [sym_literal_type] = STATE(2659),
    [sym__number] = STATE(447),
    [sym_existential_type] = STATE(2659),
    [sym_flow_maybe_type] = STATE(2659),
    [sym_parenthesized_type] = STATE(2659),
    [sym_predefined_type] = STATE(2659),
    [sym_object_type] = STATE(2659),
    [sym_type_parameters] = STATE(3048),
    [sym_array_type] = STATE(2659),
    [sym__tuple_type_body] = STATE(443),
    [sym_tuple_type] = STATE(2659),
    [sym_union_type] = STATE(2794),
    [sym_intersection_type] = STATE(2794),
    [sym_function_type] = STATE(2794),
    [sym_identifier] = ACTIONS(911),
    [anon_sym_STAR] = ACTIONS(775),
    [anon_sym_EQ] = ACTIONS(1135),
    [anon_sym_as] = ACTIONS(780),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_COMMA] = ACTIONS(813),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_BANG] = ACTIONS(780),
    [anon_sym_LPAREN] = ACTIONS(789),
    [anon_sym_in] = ACTIONS(780),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [anon_sym_LT] = ACTIONS(793),
    [anon_sym_GT] = ACTIONS(780),
    [anon_sym_SLASH] = ACTIONS(780),
    [anon_sym_DOT] = ACTIONS(1139),
    [anon_sym_EQ_GT] = ACTIONS(1141),
    [anon_sym_QMARK_DOT] = ACTIONS(1143),
    [anon_sym_new] = ACTIONS(801),
    [anon_sym_PLUS_EQ] = ACTIONS(803),
    [anon_sym_DASH_EQ] = ACTIONS(803),
    [anon_sym_STAR_EQ] = ACTIONS(803),
    [anon_sym_SLASH_EQ] = ACTIONS(803),
    [anon_sym_PERCENT_EQ] = ACTIONS(803),
    [anon_sym_CARET_EQ] = ACTIONS(803),
    [anon_sym_AMP_EQ] = ACTIONS(803),
    [anon_sym_PIPE_EQ] = ACTIONS(803),
    [anon_sym_GT_GT_EQ] = ACTIONS(803),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(803),
    [anon_sym_LT_LT_EQ] = ACTIONS(803),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(803),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(803),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(803),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(803),
    [anon_sym_QMARK] = ACTIONS(805),
    [anon_sym_AMP_AMP] = ACTIONS(780),
    [anon_sym_PIPE_PIPE] = ACTIONS(780),
    [anon_sym_GT_GT] = ACTIONS(780),
    [anon_sym_GT_GT_GT] = ACTIONS(780),
    [anon_sym_LT_LT] = ACTIONS(780),
    [anon_sym_AMP] = ACTIONS(807),
    [anon_sym_CARET] = ACTIONS(780),
    [anon_sym_PIPE] = ACTIONS(809),
    [anon_sym_PLUS] = ACTIONS(811),
    [anon_sym_DASH] = ACTIONS(811),
    [anon_sym_PERCENT] = ACTIONS(780),
    [anon_sym_STAR_STAR] = ACTIONS(780),
    [anon_sym_LT_EQ] = ACTIONS(813),
    [anon_sym_EQ_EQ] = ACTIONS(780),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(813),
    [anon_sym_BANG_EQ] = ACTIONS(780),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(813),
    [anon_sym_GT_EQ] = ACTIONS(813),
    [anon_sym_QMARK_QMARK] = ACTIONS(780),
    [anon_sym_instanceof] = ACTIONS(780),
    [anon_sym_void] = ACTIONS(815),
    [anon_sym_PLUS_PLUS] = ACTIONS(813),
    [anon_sym_DASH_DASH] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(817),
    [anon_sym_SQUOTE] = ACTIONS(819),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(813),
    [sym_number] = ACTIONS(821),
    [sym_this] = ACTIONS(919),
    [sym_true] = ACTIONS(825),
    [sym_false] = ACTIONS(825),
    [anon_sym_any] = ACTIONS(815),
    [anon_sym_number] = ACTIONS(815),
    [anon_sym_boolean] = ACTIONS(815),
    [anon_sym_string] = ACTIONS(815),
    [anon_sym_symbol] = ACTIONS(815),
    [sym_readonly] = ACTIONS(921),
    [anon_sym_infer] = ACTIONS(495),
    [anon_sym_keyof] = ACTIONS(497),
    [anon_sym_LBRACE_PIPE] = ACTIONS(499),
  },
  [100] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(884),
    [sym__expression] = STATE(1278),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1283),
    [sym_array] = STATE(1281),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3336),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(884),
    [sym_subscript_expression] = STATE(884),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1964),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_spread_element] = STATE(2788),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_sequence_expression] = STATE(3222),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(860),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym__rest_identifier] = STATE(2787),
    [sym_rest_identifier] = STATE(2661),
    [sym_optional_identifier] = STATE(2661),
    [sym__tuple_type_identifier] = STATE(2661),
    [sym_labeled_tuple_type_member] = STATE(2790),
    [sym__tuple_type_member] = STATE(2790),
    [sym_type_arguments] = STATE(414),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [aux_sym_array_repeat1] = STATE(2789),
    [sym_identifier] = ACTIONS(1145),
    [anon_sym_export] = ACTIONS(503),
    [anon_sym_namespace] = ACTIONS(505),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_COMMA] = ACTIONS(1147),
    [anon_sym_type] = ACTIONS(503),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(437),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(443),
    [anon_sym_yield] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_RBRACK] = ACTIONS(1149),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(849),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1151),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(851),
    [anon_sym_TILDE] = ACTIONS(437),
    [anon_sym_void] = ACTIONS(471),
    [anon_sym_delete] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(473),
    [anon_sym_DASH_DASH] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(503),
    [anon_sym_get] = ACTIONS(503),
    [anon_sym_set] = ACTIONS(503),
    [anon_sym_declare] = ACTIONS(503),
    [anon_sym_public] = ACTIONS(503),
    [anon_sym_private] = ACTIONS(503),
    [anon_sym_protected] = ACTIONS(503),
    [anon_sym_module] = ACTIONS(503),
    [anon_sym_any] = ACTIONS(503),
    [anon_sym_number] = ACTIONS(503),
    [anon_sym_boolean] = ACTIONS(503),
    [anon_sym_string] = ACTIONS(503),
    [anon_sym_symbol] = ACTIONS(503),
    [sym_readonly] = ACTIONS(503),
  },
  [101] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(884),
    [sym__expression] = STATE(1310),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1283),
    [sym_array] = STATE(1281),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3336),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(884),
    [sym_subscript_expression] = STATE(884),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1964),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_spread_element] = STATE(2899),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(860),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym__rest_identifier] = STATE(2787),
    [sym_rest_identifier] = STATE(2661),
    [sym_optional_identifier] = STATE(2661),
    [sym__tuple_type_identifier] = STATE(2661),
    [sym_labeled_tuple_type_member] = STATE(2790),
    [sym__tuple_type_member] = STATE(2790),
    [sym_type_arguments] = STATE(414),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [aux_sym_array_repeat1] = STATE(2898),
    [sym_identifier] = ACTIONS(1145),
    [anon_sym_export] = ACTIONS(503),
    [anon_sym_namespace] = ACTIONS(505),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_COMMA] = ACTIONS(1147),
    [anon_sym_type] = ACTIONS(503),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(437),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(443),
    [anon_sym_yield] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_RBRACK] = ACTIONS(1153),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(849),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1151),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(851),
    [anon_sym_TILDE] = ACTIONS(437),
    [anon_sym_void] = ACTIONS(471),
    [anon_sym_delete] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(473),
    [anon_sym_DASH_DASH] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(503),
    [anon_sym_get] = ACTIONS(503),
    [anon_sym_set] = ACTIONS(503),
    [anon_sym_declare] = ACTIONS(503),
    [anon_sym_public] = ACTIONS(503),
    [anon_sym_private] = ACTIONS(503),
    [anon_sym_protected] = ACTIONS(503),
    [anon_sym_module] = ACTIONS(503),
    [anon_sym_any] = ACTIONS(503),
    [anon_sym_number] = ACTIONS(503),
    [anon_sym_boolean] = ACTIONS(503),
    [anon_sym_string] = ACTIONS(503),
    [anon_sym_symbol] = ACTIONS(503),
    [sym_readonly] = ACTIONS(503),
  },
  [102] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(884),
    [sym__expression] = STATE(1319),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1283),
    [sym_array] = STATE(1281),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3336),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(884),
    [sym_subscript_expression] = STATE(884),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1964),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_spread_element] = STATE(2852),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(860),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym__rest_identifier] = STATE(2787),
    [sym_rest_identifier] = STATE(2661),
    [sym_optional_identifier] = STATE(2661),
    [sym__tuple_type_identifier] = STATE(2661),
    [sym_labeled_tuple_type_member] = STATE(2790),
    [sym__tuple_type_member] = STATE(2790),
    [sym_type_arguments] = STATE(414),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [aux_sym_array_repeat1] = STATE(2853),
    [sym_identifier] = ACTIONS(1145),
    [anon_sym_export] = ACTIONS(503),
    [anon_sym_namespace] = ACTIONS(505),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_COMMA] = ACTIONS(1147),
    [anon_sym_type] = ACTIONS(503),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(437),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(443),
    [anon_sym_yield] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_RBRACK] = ACTIONS(1155),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(849),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1151),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(851),
    [anon_sym_TILDE] = ACTIONS(437),
    [anon_sym_void] = ACTIONS(471),
    [anon_sym_delete] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(473),
    [anon_sym_DASH_DASH] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(503),
    [anon_sym_get] = ACTIONS(503),
    [anon_sym_set] = ACTIONS(503),
    [anon_sym_declare] = ACTIONS(503),
    [anon_sym_public] = ACTIONS(503),
    [anon_sym_private] = ACTIONS(503),
    [anon_sym_protected] = ACTIONS(503),
    [anon_sym_module] = ACTIONS(503),
    [anon_sym_any] = ACTIONS(503),
    [anon_sym_number] = ACTIONS(503),
    [anon_sym_boolean] = ACTIONS(503),
    [anon_sym_string] = ACTIONS(503),
    [anon_sym_symbol] = ACTIONS(503),
    [sym_readonly] = ACTIONS(503),
  },
  [103] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(884),
    [sym__expression] = STATE(1310),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1283),
    [sym_array] = STATE(1281),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3336),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(884),
    [sym_subscript_expression] = STATE(884),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1964),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_spread_element] = STATE(2899),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(860),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym__rest_identifier] = STATE(2787),
    [sym_rest_identifier] = STATE(2661),
    [sym_optional_identifier] = STATE(2661),
    [sym__tuple_type_identifier] = STATE(2661),
    [sym_labeled_tuple_type_member] = STATE(2790),
    [sym__tuple_type_member] = STATE(2790),
    [sym_type_arguments] = STATE(414),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [aux_sym_array_repeat1] = STATE(2898),
    [sym_identifier] = ACTIONS(1145),
    [anon_sym_export] = ACTIONS(503),
    [anon_sym_namespace] = ACTIONS(505),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_COMMA] = ACTIONS(1147),
    [anon_sym_type] = ACTIONS(503),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(437),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(443),
    [anon_sym_yield] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_RBRACK] = ACTIONS(1157),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(849),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1151),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(851),
    [anon_sym_TILDE] = ACTIONS(437),
    [anon_sym_void] = ACTIONS(471),
    [anon_sym_delete] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(473),
    [anon_sym_DASH_DASH] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(503),
    [anon_sym_get] = ACTIONS(503),
    [anon_sym_set] = ACTIONS(503),
    [anon_sym_declare] = ACTIONS(503),
    [anon_sym_public] = ACTIONS(503),
    [anon_sym_private] = ACTIONS(503),
    [anon_sym_protected] = ACTIONS(503),
    [anon_sym_module] = ACTIONS(503),
    [anon_sym_any] = ACTIONS(503),
    [anon_sym_number] = ACTIONS(503),
    [anon_sym_boolean] = ACTIONS(503),
    [anon_sym_string] = ACTIONS(503),
    [anon_sym_symbol] = ACTIONS(503),
    [sym_readonly] = ACTIONS(503),
  },
  [104] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(884),
    [sym__expression] = STATE(1310),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1283),
    [sym_array] = STATE(1281),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3336),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(884),
    [sym_subscript_expression] = STATE(884),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1964),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_spread_element] = STATE(2899),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(860),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym__rest_identifier] = STATE(2787),
    [sym_rest_identifier] = STATE(2661),
    [sym_optional_identifier] = STATE(2661),
    [sym__tuple_type_identifier] = STATE(2661),
    [sym_labeled_tuple_type_member] = STATE(2790),
    [sym__tuple_type_member] = STATE(2790),
    [sym_type_arguments] = STATE(414),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [aux_sym_array_repeat1] = STATE(2898),
    [sym_identifier] = ACTIONS(1145),
    [anon_sym_export] = ACTIONS(503),
    [anon_sym_namespace] = ACTIONS(505),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_COMMA] = ACTIONS(1147),
    [anon_sym_type] = ACTIONS(503),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(437),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(443),
    [anon_sym_yield] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_RBRACK] = ACTIONS(1159),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(849),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1151),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(851),
    [anon_sym_TILDE] = ACTIONS(437),
    [anon_sym_void] = ACTIONS(471),
    [anon_sym_delete] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(473),
    [anon_sym_DASH_DASH] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(503),
    [anon_sym_get] = ACTIONS(503),
    [anon_sym_set] = ACTIONS(503),
    [anon_sym_declare] = ACTIONS(503),
    [anon_sym_public] = ACTIONS(503),
    [anon_sym_private] = ACTIONS(503),
    [anon_sym_protected] = ACTIONS(503),
    [anon_sym_module] = ACTIONS(503),
    [anon_sym_any] = ACTIONS(503),
    [anon_sym_number] = ACTIONS(503),
    [anon_sym_boolean] = ACTIONS(503),
    [anon_sym_string] = ACTIONS(503),
    [anon_sym_symbol] = ACTIONS(503),
    [sym_readonly] = ACTIONS(503),
  },
  [105] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(884),
    [sym__expression] = STATE(1303),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1283),
    [sym_array] = STATE(1281),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3336),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(884),
    [sym_subscript_expression] = STATE(884),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1964),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_spread_element] = STATE(2929),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(860),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym__rest_identifier] = STATE(2787),
    [sym_rest_identifier] = STATE(2661),
    [sym_optional_identifier] = STATE(2661),
    [sym__tuple_type_identifier] = STATE(2661),
    [sym_labeled_tuple_type_member] = STATE(2790),
    [sym__tuple_type_member] = STATE(2790),
    [sym_type_arguments] = STATE(414),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [aux_sym_array_repeat1] = STATE(2931),
    [sym_identifier] = ACTIONS(1145),
    [anon_sym_export] = ACTIONS(503),
    [anon_sym_namespace] = ACTIONS(505),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_COMMA] = ACTIONS(1147),
    [anon_sym_type] = ACTIONS(503),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(437),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(443),
    [anon_sym_yield] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_RBRACK] = ACTIONS(1161),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(849),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1151),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(851),
    [anon_sym_TILDE] = ACTIONS(437),
    [anon_sym_void] = ACTIONS(471),
    [anon_sym_delete] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(473),
    [anon_sym_DASH_DASH] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(503),
    [anon_sym_get] = ACTIONS(503),
    [anon_sym_set] = ACTIONS(503),
    [anon_sym_declare] = ACTIONS(503),
    [anon_sym_public] = ACTIONS(503),
    [anon_sym_private] = ACTIONS(503),
    [anon_sym_protected] = ACTIONS(503),
    [anon_sym_module] = ACTIONS(503),
    [anon_sym_any] = ACTIONS(503),
    [anon_sym_number] = ACTIONS(503),
    [anon_sym_boolean] = ACTIONS(503),
    [anon_sym_string] = ACTIONS(503),
    [anon_sym_symbol] = ACTIONS(503),
    [sym_readonly] = ACTIONS(503),
  },
  [106] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(884),
    [sym__expression] = STATE(1331),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1283),
    [sym_array] = STATE(1281),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3336),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(884),
    [sym_subscript_expression] = STATE(884),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1964),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_spread_element] = STATE(2788),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(860),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym__rest_identifier] = STATE(2787),
    [sym_rest_identifier] = STATE(2661),
    [sym_optional_identifier] = STATE(2661),
    [sym__tuple_type_identifier] = STATE(2661),
    [sym_labeled_tuple_type_member] = STATE(2790),
    [sym__tuple_type_member] = STATE(2790),
    [sym_type_arguments] = STATE(414),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [aux_sym_array_repeat1] = STATE(2789),
    [sym_identifier] = ACTIONS(1145),
    [anon_sym_export] = ACTIONS(503),
    [anon_sym_namespace] = ACTIONS(505),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_COMMA] = ACTIONS(1147),
    [anon_sym_type] = ACTIONS(503),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(437),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(443),
    [anon_sym_yield] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_RBRACK] = ACTIONS(1149),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(849),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1151),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(851),
    [anon_sym_TILDE] = ACTIONS(437),
    [anon_sym_void] = ACTIONS(471),
    [anon_sym_delete] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(473),
    [anon_sym_DASH_DASH] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(503),
    [anon_sym_get] = ACTIONS(503),
    [anon_sym_set] = ACTIONS(503),
    [anon_sym_declare] = ACTIONS(503),
    [anon_sym_public] = ACTIONS(503),
    [anon_sym_private] = ACTIONS(503),
    [anon_sym_protected] = ACTIONS(503),
    [anon_sym_module] = ACTIONS(503),
    [anon_sym_any] = ACTIONS(503),
    [anon_sym_number] = ACTIONS(503),
    [anon_sym_boolean] = ACTIONS(503),
    [anon_sym_string] = ACTIONS(503),
    [anon_sym_symbol] = ACTIONS(503),
    [sym_readonly] = ACTIONS(503),
  },
  [107] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(884),
    [sym__expression] = STATE(1303),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1283),
    [sym_array] = STATE(1281),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3336),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(884),
    [sym_subscript_expression] = STATE(884),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1964),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_spread_element] = STATE(2929),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(860),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym__rest_identifier] = STATE(2787),
    [sym_rest_identifier] = STATE(2661),
    [sym_optional_identifier] = STATE(2661),
    [sym__tuple_type_identifier] = STATE(2661),
    [sym_labeled_tuple_type_member] = STATE(2790),
    [sym__tuple_type_member] = STATE(2790),
    [sym_type_arguments] = STATE(414),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [aux_sym_array_repeat1] = STATE(2931),
    [sym_identifier] = ACTIONS(1145),
    [anon_sym_export] = ACTIONS(503),
    [anon_sym_namespace] = ACTIONS(505),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_COMMA] = ACTIONS(1147),
    [anon_sym_type] = ACTIONS(503),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(437),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(443),
    [anon_sym_yield] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_RBRACK] = ACTIONS(1163),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(849),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1151),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(851),
    [anon_sym_TILDE] = ACTIONS(437),
    [anon_sym_void] = ACTIONS(471),
    [anon_sym_delete] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(473),
    [anon_sym_DASH_DASH] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(503),
    [anon_sym_get] = ACTIONS(503),
    [anon_sym_set] = ACTIONS(503),
    [anon_sym_declare] = ACTIONS(503),
    [anon_sym_public] = ACTIONS(503),
    [anon_sym_private] = ACTIONS(503),
    [anon_sym_protected] = ACTIONS(503),
    [anon_sym_module] = ACTIONS(503),
    [anon_sym_any] = ACTIONS(503),
    [anon_sym_number] = ACTIONS(503),
    [anon_sym_boolean] = ACTIONS(503),
    [anon_sym_string] = ACTIONS(503),
    [anon_sym_symbol] = ACTIONS(503),
    [sym_readonly] = ACTIONS(503),
  },
  [108] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(884),
    [sym__expression] = STATE(1310),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1283),
    [sym_array] = STATE(1281),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3336),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(884),
    [sym_subscript_expression] = STATE(884),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1964),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_spread_element] = STATE(2899),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(860),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym__rest_identifier] = STATE(2787),
    [sym_rest_identifier] = STATE(2661),
    [sym_optional_identifier] = STATE(2661),
    [sym__tuple_type_identifier] = STATE(2661),
    [sym_labeled_tuple_type_member] = STATE(2831),
    [sym__tuple_type_member] = STATE(2831),
    [sym_type_arguments] = STATE(414),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [aux_sym_array_repeat1] = STATE(2898),
    [sym_identifier] = ACTIONS(1145),
    [anon_sym_export] = ACTIONS(503),
    [anon_sym_namespace] = ACTIONS(505),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_COMMA] = ACTIONS(1147),
    [anon_sym_type] = ACTIONS(503),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(437),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(443),
    [anon_sym_yield] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_RBRACK] = ACTIONS(1165),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(849),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1151),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(851),
    [anon_sym_TILDE] = ACTIONS(437),
    [anon_sym_void] = ACTIONS(471),
    [anon_sym_delete] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(473),
    [anon_sym_DASH_DASH] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(503),
    [anon_sym_get] = ACTIONS(503),
    [anon_sym_set] = ACTIONS(503),
    [anon_sym_declare] = ACTIONS(503),
    [anon_sym_public] = ACTIONS(503),
    [anon_sym_private] = ACTIONS(503),
    [anon_sym_protected] = ACTIONS(503),
    [anon_sym_module] = ACTIONS(503),
    [anon_sym_any] = ACTIONS(503),
    [anon_sym_number] = ACTIONS(503),
    [anon_sym_boolean] = ACTIONS(503),
    [anon_sym_string] = ACTIONS(503),
    [anon_sym_symbol] = ACTIONS(503),
    [sym_readonly] = ACTIONS(503),
  },
  [109] = {
    [sym_import] = STATE(1528),
    [sym_expression_statement] = STATE(150),
    [sym_variable_declaration] = STATE(150),
    [sym_lexical_declaration] = STATE(150),
    [sym_empty_statement] = STATE(150),
    [sym_parenthesized_expression] = STATE(943),
    [sym__expression] = STATE(1345),
    [sym_yield_expression] = STATE(1543),
    [sym_object] = STATE(1424),
    [sym_array] = STATE(1491),
    [sym_class] = STATE(1528),
    [sym_function] = STATE(1528),
    [sym_generator_function] = STATE(1528),
    [sym_arrow_function] = STATE(1528),
    [sym__call_signature] = STATE(3359),
    [sym_call_expression] = STATE(1528),
    [sym_new_expression] = STATE(1543),
    [sym_await_expression] = STATE(1543),
    [sym_member_expression] = STATE(943),
    [sym_subscript_expression] = STATE(943),
    [sym_assignment_expression] = STATE(1543),
    [sym__augmented_assignment_lhs] = STATE(1970),
    [sym_augmented_assignment_expression] = STATE(1543),
    [sym_ternary_expression] = STATE(1543),
    [sym_binary_expression] = STATE(1543),
    [sym_unary_expression] = STATE(1543),
    [sym_update_expression] = STATE(1543),
    [sym_sequence_expression] = STATE(3070),
    [sym_string] = STATE(1528),
    [sym_template_string] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_meta_property] = STATE(1528),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(937),
    [sym_type_assertion] = STATE(1543),
    [sym_as_expression] = STATE(1543),
    [sym_internal_module] = STATE(1543),
    [sym_type_arguments] = STATE(381),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2726),
    [sym_identifier] = ACTIONS(1167),
    [anon_sym_export] = ACTIONS(1169),
    [anon_sym_namespace] = ACTIONS(1171),
    [anon_sym_LBRACE] = ACTIONS(859),
    [anon_sym_type] = ACTIONS(1169),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(537),
    [anon_sym_var] = ACTIONS(1173),
    [anon_sym_let] = ACTIONS(1175),
    [anon_sym_const] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(549),
    [anon_sym_async] = ACTIONS(1177),
    [anon_sym_function] = ACTIONS(553),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1169),
    [anon_sym_get] = ACTIONS(1169),
    [anon_sym_set] = ACTIONS(1169),
    [anon_sym_declare] = ACTIONS(1169),
    [anon_sym_public] = ACTIONS(1169),
    [anon_sym_private] = ACTIONS(1169),
    [anon_sym_protected] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1169),
    [anon_sym_any] = ACTIONS(1169),
    [anon_sym_number] = ACTIONS(1169),
    [anon_sym_boolean] = ACTIONS(1169),
    [anon_sym_string] = ACTIONS(1169),
    [anon_sym_symbol] = ACTIONS(1169),
    [sym_readonly] = ACTIONS(1169),
  },
  [110] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(884),
    [sym__expression] = STATE(1392),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1283),
    [sym_array] = STATE(1281),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3336),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(884),
    [sym_subscript_expression] = STATE(884),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1964),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_sequence_expression] = STATE(3222),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(860),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym__rest_identifier] = STATE(2787),
    [sym_rest_identifier] = STATE(2661),
    [sym_optional_identifier] = STATE(2661),
    [sym__tuple_type_identifier] = STATE(2661),
    [sym_labeled_tuple_type_member] = STATE(2831),
    [sym__tuple_type_member] = STATE(2831),
    [sym_type_arguments] = STATE(414),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(1145),
    [anon_sym_export] = ACTIONS(503),
    [anon_sym_namespace] = ACTIONS(505),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_type] = ACTIONS(503),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(437),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(443),
    [anon_sym_yield] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_RBRACK] = ACTIONS(1179),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(849),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(459),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(851),
    [anon_sym_TILDE] = ACTIONS(437),
    [anon_sym_void] = ACTIONS(471),
    [anon_sym_delete] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(473),
    [anon_sym_DASH_DASH] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(503),
    [anon_sym_get] = ACTIONS(503),
    [anon_sym_set] = ACTIONS(503),
    [anon_sym_declare] = ACTIONS(503),
    [anon_sym_public] = ACTIONS(503),
    [anon_sym_private] = ACTIONS(503),
    [anon_sym_protected] = ACTIONS(503),
    [anon_sym_module] = ACTIONS(503),
    [anon_sym_any] = ACTIONS(503),
    [anon_sym_number] = ACTIONS(503),
    [anon_sym_boolean] = ACTIONS(503),
    [anon_sym_string] = ACTIONS(503),
    [anon_sym_symbol] = ACTIONS(503),
    [sym_readonly] = ACTIONS(503),
  },
  [111] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(884),
    [sym__expression] = STATE(1411),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1283),
    [sym_array] = STATE(1281),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3336),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(884),
    [sym_subscript_expression] = STATE(884),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1964),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_sequence_expression] = STATE(3346),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(860),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym__rest_identifier] = STATE(2787),
    [sym_rest_identifier] = STATE(2661),
    [sym_optional_identifier] = STATE(2661),
    [sym__tuple_type_identifier] = STATE(2661),
    [sym_labeled_tuple_type_member] = STATE(2790),
    [sym__tuple_type_member] = STATE(2790),
    [sym_type_arguments] = STATE(414),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(1145),
    [anon_sym_export] = ACTIONS(503),
    [anon_sym_namespace] = ACTIONS(505),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_type] = ACTIONS(503),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(437),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(443),
    [anon_sym_yield] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_RBRACK] = ACTIONS(1181),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(849),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(459),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(851),
    [anon_sym_TILDE] = ACTIONS(437),
    [anon_sym_void] = ACTIONS(471),
    [anon_sym_delete] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(473),
    [anon_sym_DASH_DASH] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(503),
    [anon_sym_get] = ACTIONS(503),
    [anon_sym_set] = ACTIONS(503),
    [anon_sym_declare] = ACTIONS(503),
    [anon_sym_public] = ACTIONS(503),
    [anon_sym_private] = ACTIONS(503),
    [anon_sym_protected] = ACTIONS(503),
    [anon_sym_module] = ACTIONS(503),
    [anon_sym_any] = ACTIONS(503),
    [anon_sym_number] = ACTIONS(503),
    [anon_sym_boolean] = ACTIONS(503),
    [anon_sym_string] = ACTIONS(503),
    [anon_sym_symbol] = ACTIONS(503),
    [sym_readonly] = ACTIONS(503),
  },
  [112] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(884),
    [sym__expression] = STATE(1191),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1605),
    [sym_array] = STATE(1655),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3336),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(884),
    [sym_subscript_expression] = STATE(884),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1964),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_sequence_expression] = STATE(3320),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_rest_parameter] = STATE(2909),
    [sym_non_null_expression] = STATE(860),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_accessibility_modifier] = STATE(1951),
    [sym_required_parameter] = STATE(2909),
    [sym_optional_parameter] = STATE(2909),
    [sym__parameter_name] = STATE(2186),
    [sym__rest_identifier] = STATE(2734),
    [sym_type_arguments] = STATE(414),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(1824),
    [sym_identifier] = ACTIONS(1183),
    [anon_sym_export] = ACTIONS(425),
    [anon_sym_namespace] = ACTIONS(429),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_type] = ACTIONS(425),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(437),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_RPAREN] = ACTIONS(441),
    [anon_sym_await] = ACTIONS(443),
    [anon_sym_yield] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(453),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(849),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(459),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(851),
    [anon_sym_TILDE] = ACTIONS(437),
    [anon_sym_void] = ACTIONS(471),
    [anon_sym_delete] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(473),
    [anon_sym_DASH_DASH] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(1185),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(425),
    [anon_sym_get] = ACTIONS(425),
    [anon_sym_set] = ACTIONS(425),
    [anon_sym_declare] = ACTIONS(425),
    [anon_sym_public] = ACTIONS(489),
    [anon_sym_private] = ACTIONS(489),
    [anon_sym_protected] = ACTIONS(489),
    [anon_sym_module] = ACTIONS(425),
    [anon_sym_any] = ACTIONS(425),
    [anon_sym_number] = ACTIONS(425),
    [anon_sym_boolean] = ACTIONS(425),
    [anon_sym_string] = ACTIONS(425),
    [anon_sym_symbol] = ACTIONS(425),
    [sym_readonly] = ACTIONS(1187),
  },
  [113] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(884),
    [sym__expression] = STATE(1137),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1605),
    [sym_array] = STATE(1655),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3336),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(884),
    [sym_subscript_expression] = STATE(884),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1964),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_sequence_expression] = STATE(3314),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_rest_parameter] = STATE(2909),
    [sym_non_null_expression] = STATE(860),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_accessibility_modifier] = STATE(1951),
    [sym_required_parameter] = STATE(2909),
    [sym_optional_parameter] = STATE(2909),
    [sym__parameter_name] = STATE(2186),
    [sym__rest_identifier] = STATE(2734),
    [sym_type_arguments] = STATE(414),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(1824),
    [sym_identifier] = ACTIONS(1183),
    [anon_sym_export] = ACTIONS(425),
    [anon_sym_namespace] = ACTIONS(429),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_type] = ACTIONS(425),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(437),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_RPAREN] = ACTIONS(441),
    [anon_sym_await] = ACTIONS(443),
    [anon_sym_yield] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(453),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(849),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(459),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(851),
    [anon_sym_TILDE] = ACTIONS(437),
    [anon_sym_void] = ACTIONS(471),
    [anon_sym_delete] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(473),
    [anon_sym_DASH_DASH] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(1185),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(425),
    [anon_sym_get] = ACTIONS(425),
    [anon_sym_set] = ACTIONS(425),
    [anon_sym_declare] = ACTIONS(425),
    [anon_sym_public] = ACTIONS(489),
    [anon_sym_private] = ACTIONS(489),
    [anon_sym_protected] = ACTIONS(489),
    [anon_sym_module] = ACTIONS(425),
    [anon_sym_any] = ACTIONS(425),
    [anon_sym_number] = ACTIONS(425),
    [anon_sym_boolean] = ACTIONS(425),
    [anon_sym_string] = ACTIONS(425),
    [anon_sym_symbol] = ACTIONS(425),
    [sym_readonly] = ACTIONS(1187),
  },
  [114] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(884),
    [sym__expression] = STATE(1471),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1283),
    [sym_array] = STATE(1281),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3336),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(884),
    [sym_subscript_expression] = STATE(884),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1964),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_sequence_expression] = STATE(3234),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(860),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym__rest_identifier] = STATE(2787),
    [sym_rest_identifier] = STATE(2661),
    [sym_optional_identifier] = STATE(2661),
    [sym__tuple_type_identifier] = STATE(2661),
    [sym_labeled_tuple_type_member] = STATE(2790),
    [sym__tuple_type_member] = STATE(2790),
    [sym_type_arguments] = STATE(414),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(1145),
    [anon_sym_export] = ACTIONS(503),
    [anon_sym_namespace] = ACTIONS(505),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_type] = ACTIONS(503),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(437),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(443),
    [anon_sym_yield] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_RBRACK] = ACTIONS(1181),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(849),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(459),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(851),
    [anon_sym_TILDE] = ACTIONS(437),
    [anon_sym_void] = ACTIONS(471),
    [anon_sym_delete] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(473),
    [anon_sym_DASH_DASH] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(503),
    [anon_sym_get] = ACTIONS(503),
    [anon_sym_set] = ACTIONS(503),
    [anon_sym_declare] = ACTIONS(503),
    [anon_sym_public] = ACTIONS(503),
    [anon_sym_private] = ACTIONS(503),
    [anon_sym_protected] = ACTIONS(503),
    [anon_sym_module] = ACTIONS(503),
    [anon_sym_any] = ACTIONS(503),
    [anon_sym_number] = ACTIONS(503),
    [anon_sym_boolean] = ACTIONS(503),
    [anon_sym_string] = ACTIONS(503),
    [anon_sym_symbol] = ACTIONS(503),
    [sym_readonly] = ACTIONS(503),
  },
  [115] = {
    [sym_import] = STATE(1528),
    [sym_expression_statement] = STATE(149),
    [sym_variable_declaration] = STATE(149),
    [sym_lexical_declaration] = STATE(149),
    [sym_empty_statement] = STATE(149),
    [sym_parenthesized_expression] = STATE(943),
    [sym__expression] = STATE(1345),
    [sym_yield_expression] = STATE(1543),
    [sym_object] = STATE(1424),
    [sym_array] = STATE(1491),
    [sym_class] = STATE(1528),
    [sym_function] = STATE(1528),
    [sym_generator_function] = STATE(1528),
    [sym_arrow_function] = STATE(1528),
    [sym__call_signature] = STATE(3359),
    [sym_call_expression] = STATE(1528),
    [sym_new_expression] = STATE(1543),
    [sym_await_expression] = STATE(1543),
    [sym_member_expression] = STATE(943),
    [sym_subscript_expression] = STATE(943),
    [sym_assignment_expression] = STATE(1543),
    [sym__augmented_assignment_lhs] = STATE(1970),
    [sym_augmented_assignment_expression] = STATE(1543),
    [sym_ternary_expression] = STATE(1543),
    [sym_binary_expression] = STATE(1543),
    [sym_unary_expression] = STATE(1543),
    [sym_update_expression] = STATE(1543),
    [sym_sequence_expression] = STATE(3070),
    [sym_string] = STATE(1528),
    [sym_template_string] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_meta_property] = STATE(1528),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(937),
    [sym_type_assertion] = STATE(1543),
    [sym_as_expression] = STATE(1543),
    [sym_internal_module] = STATE(1543),
    [sym_type_arguments] = STATE(381),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2726),
    [sym_identifier] = ACTIONS(1167),
    [anon_sym_export] = ACTIONS(1169),
    [anon_sym_namespace] = ACTIONS(1171),
    [anon_sym_LBRACE] = ACTIONS(859),
    [anon_sym_type] = ACTIONS(1169),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(537),
    [anon_sym_var] = ACTIONS(1173),
    [anon_sym_let] = ACTIONS(1175),
    [anon_sym_const] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(549),
    [anon_sym_async] = ACTIONS(1177),
    [anon_sym_function] = ACTIONS(553),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1169),
    [anon_sym_get] = ACTIONS(1169),
    [anon_sym_set] = ACTIONS(1169),
    [anon_sym_declare] = ACTIONS(1169),
    [anon_sym_public] = ACTIONS(1169),
    [anon_sym_private] = ACTIONS(1169),
    [anon_sym_protected] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1169),
    [anon_sym_any] = ACTIONS(1169),
    [anon_sym_number] = ACTIONS(1169),
    [anon_sym_boolean] = ACTIONS(1169),
    [anon_sym_string] = ACTIONS(1169),
    [anon_sym_symbol] = ACTIONS(1169),
    [sym_readonly] = ACTIONS(1169),
  },
  [116] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(884),
    [sym__expression] = STATE(1392),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1283),
    [sym_array] = STATE(1281),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3336),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(884),
    [sym_subscript_expression] = STATE(884),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1964),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_sequence_expression] = STATE(3222),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(860),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym__rest_identifier] = STATE(2787),
    [sym_rest_identifier] = STATE(2661),
    [sym_optional_identifier] = STATE(2661),
    [sym__tuple_type_identifier] = STATE(2661),
    [sym_labeled_tuple_type_member] = STATE(2790),
    [sym__tuple_type_member] = STATE(2790),
    [sym_type_arguments] = STATE(414),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(1145),
    [anon_sym_export] = ACTIONS(503),
    [anon_sym_namespace] = ACTIONS(505),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_type] = ACTIONS(503),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(437),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(443),
    [anon_sym_yield] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_RBRACK] = ACTIONS(1181),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(849),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(459),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(851),
    [anon_sym_TILDE] = ACTIONS(437),
    [anon_sym_void] = ACTIONS(471),
    [anon_sym_delete] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(473),
    [anon_sym_DASH_DASH] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(503),
    [anon_sym_get] = ACTIONS(503),
    [anon_sym_set] = ACTIONS(503),
    [anon_sym_declare] = ACTIONS(503),
    [anon_sym_public] = ACTIONS(503),
    [anon_sym_private] = ACTIONS(503),
    [anon_sym_protected] = ACTIONS(503),
    [anon_sym_module] = ACTIONS(503),
    [anon_sym_any] = ACTIONS(503),
    [anon_sym_number] = ACTIONS(503),
    [anon_sym_boolean] = ACTIONS(503),
    [anon_sym_string] = ACTIONS(503),
    [anon_sym_symbol] = ACTIONS(503),
    [sym_readonly] = ACTIONS(503),
  },
  [117] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(884),
    [sym__expression] = STATE(1173),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1605),
    [sym_array] = STATE(1655),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3336),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(884),
    [sym_subscript_expression] = STATE(884),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1964),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_sequence_expression] = STATE(3358),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_rest_parameter] = STATE(2909),
    [sym_non_null_expression] = STATE(860),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_accessibility_modifier] = STATE(1951),
    [sym_required_parameter] = STATE(2909),
    [sym_optional_parameter] = STATE(2909),
    [sym__parameter_name] = STATE(2186),
    [sym__rest_identifier] = STATE(2734),
    [sym_type_arguments] = STATE(414),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(1824),
    [sym_identifier] = ACTIONS(1183),
    [anon_sym_export] = ACTIONS(425),
    [anon_sym_namespace] = ACTIONS(429),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_type] = ACTIONS(425),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(437),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_RPAREN] = ACTIONS(441),
    [anon_sym_await] = ACTIONS(443),
    [anon_sym_yield] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(453),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(849),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(459),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(851),
    [anon_sym_TILDE] = ACTIONS(437),
    [anon_sym_void] = ACTIONS(471),
    [anon_sym_delete] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(473),
    [anon_sym_DASH_DASH] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(1185),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(425),
    [anon_sym_get] = ACTIONS(425),
    [anon_sym_set] = ACTIONS(425),
    [anon_sym_declare] = ACTIONS(425),
    [anon_sym_public] = ACTIONS(489),
    [anon_sym_private] = ACTIONS(489),
    [anon_sym_protected] = ACTIONS(489),
    [anon_sym_module] = ACTIONS(425),
    [anon_sym_any] = ACTIONS(425),
    [anon_sym_number] = ACTIONS(425),
    [anon_sym_boolean] = ACTIONS(425),
    [anon_sym_string] = ACTIONS(425),
    [anon_sym_symbol] = ACTIONS(425),
    [sym_readonly] = ACTIONS(1187),
  },
  [118] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(884),
    [sym__expression] = STATE(1105),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1283),
    [sym_array] = STATE(1281),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3336),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(884),
    [sym_subscript_expression] = STATE(884),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1964),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(860),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(414),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(831),
    [anon_sym_export] = ACTIONS(503),
    [anon_sym_namespace] = ACTIONS(505),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_COMMA] = ACTIONS(1189),
    [anon_sym_RBRACE] = ACTIONS(1189),
    [anon_sym_type] = ACTIONS(503),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(437),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(443),
    [anon_sym_SEMI] = ACTIONS(1189),
    [anon_sym_yield] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(849),
    [anon_sym_AMP] = ACTIONS(1189),
    [anon_sym_PIPE] = ACTIONS(1191),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(851),
    [anon_sym_TILDE] = ACTIONS(437),
    [anon_sym_void] = ACTIONS(471),
    [anon_sym_delete] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(473),
    [anon_sym_DASH_DASH] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(503),
    [anon_sym_get] = ACTIONS(503),
    [anon_sym_set] = ACTIONS(503),
    [anon_sym_declare] = ACTIONS(503),
    [anon_sym_public] = ACTIONS(503),
    [anon_sym_private] = ACTIONS(503),
    [anon_sym_protected] = ACTIONS(503),
    [anon_sym_module] = ACTIONS(503),
    [anon_sym_any] = ACTIONS(503),
    [anon_sym_number] = ACTIONS(503),
    [anon_sym_boolean] = ACTIONS(503),
    [anon_sym_string] = ACTIONS(503),
    [anon_sym_symbol] = ACTIONS(503),
    [anon_sym_extends] = ACTIONS(1191),
    [sym_readonly] = ACTIONS(503),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1189),
    [sym__automatic_semicolon] = ACTIONS(1189),
  },
  [119] = {
    [sym_export_clause] = STATE(2682),
    [sym__declaration] = STATE(624),
    [sym_variable_declaration] = STATE(572),
    [sym_lexical_declaration] = STATE(572),
    [sym_class_declaration] = STATE(572),
    [sym_function_declaration] = STATE(572),
    [sym_generator_function_declaration] = STATE(572),
    [sym_decorator] = STATE(1945),
    [sym_function_signature] = STATE(621),
    [sym_ambient_declaration] = STATE(572),
    [sym_abstract_class_declaration] = STATE(572),
    [sym_module] = STATE(572),
    [sym_internal_module] = STATE(542),
    [sym_import_alias] = STATE(572),
    [sym_interface_declaration] = STATE(572),
    [sym_enum_declaration] = STATE(572),
    [sym_type_alias_declaration] = STATE(572),
    [aux_sym_export_statement_repeat1] = STATE(2373),
    [aux_sym_object_repeat1] = STATE(2894),
    [anon_sym_STAR] = ACTIONS(1193),
    [anon_sym_default] = ACTIONS(1195),
    [anon_sym_EQ] = ACTIONS(1197),
    [anon_sym_as] = ACTIONS(1199),
    [anon_sym_namespace] = ACTIONS(1201),
    [anon_sym_LBRACE] = ACTIONS(1203),
    [anon_sym_COMMA] = ACTIONS(813),
    [anon_sym_RBRACE] = ACTIONS(1205),
    [anon_sym_type] = ACTIONS(1207),
    [anon_sym_import] = ACTIONS(1209),
    [anon_sym_var] = ACTIONS(1211),
    [anon_sym_let] = ACTIONS(1213),
    [anon_sym_const] = ACTIONS(1215),
    [anon_sym_BANG] = ACTIONS(780),
    [anon_sym_LPAREN] = ACTIONS(1217),
    [anon_sym_in] = ACTIONS(780),
    [anon_sym_SEMI] = ACTIONS(813),
    [anon_sym_COLON] = ACTIONS(1220),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_LT] = ACTIONS(1225),
    [anon_sym_GT] = ACTIONS(780),
    [anon_sym_SLASH] = ACTIONS(780),
    [anon_sym_DOT] = ACTIONS(1228),
    [anon_sym_class] = ACTIONS(1230),
    [anon_sym_async] = ACTIONS(1232),
    [anon_sym_function] = ACTIONS(1234),
    [anon_sym_EQ_GT] = ACTIONS(929),
    [anon_sym_QMARK_DOT] = ACTIONS(931),
    [anon_sym_PLUS_EQ] = ACTIONS(803),
    [anon_sym_DASH_EQ] = ACTIONS(803),
    [anon_sym_STAR_EQ] = ACTIONS(803),
    [anon_sym_SLASH_EQ] = ACTIONS(803),
    [anon_sym_PERCENT_EQ] = ACTIONS(803),
    [anon_sym_CARET_EQ] = ACTIONS(803),
    [anon_sym_AMP_EQ] = ACTIONS(803),
    [anon_sym_PIPE_EQ] = ACTIONS(803),
    [anon_sym_GT_GT_EQ] = ACTIONS(803),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(803),
    [anon_sym_LT_LT_EQ] = ACTIONS(803),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(803),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(803),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(803),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(803),
    [anon_sym_QMARK] = ACTIONS(1225),
    [anon_sym_AMP_AMP] = ACTIONS(780),
    [anon_sym_PIPE_PIPE] = ACTIONS(780),
    [anon_sym_GT_GT] = ACTIONS(780),
    [anon_sym_GT_GT_GT] = ACTIONS(780),
    [anon_sym_LT_LT] = ACTIONS(780),
    [anon_sym_AMP] = ACTIONS(780),
    [anon_sym_CARET] = ACTIONS(780),
    [anon_sym_PIPE] = ACTIONS(780),
    [anon_sym_PLUS] = ACTIONS(780),
    [anon_sym_DASH] = ACTIONS(780),
    [anon_sym_PERCENT] = ACTIONS(780),
    [anon_sym_STAR_STAR] = ACTIONS(780),
    [anon_sym_LT_EQ] = ACTIONS(813),
    [anon_sym_EQ_EQ] = ACTIONS(780),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(813),
    [anon_sym_BANG_EQ] = ACTIONS(780),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(813),
    [anon_sym_GT_EQ] = ACTIONS(813),
    [anon_sym_QMARK_QMARK] = ACTIONS(780),
    [anon_sym_instanceof] = ACTIONS(813),
    [anon_sym_PLUS_PLUS] = ACTIONS(813),
    [anon_sym_DASH_DASH] = ACTIONS(813),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(813),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_abstract] = ACTIONS(1236),
    [anon_sym_declare] = ACTIONS(1238),
    [anon_sym_module] = ACTIONS(1240),
    [anon_sym_interface] = ACTIONS(1242),
    [anon_sym_enum] = ACTIONS(1244),
    [sym__automatic_semicolon] = ACTIONS(813),
  },
  [120] = {
    [sym_export_clause] = STATE(2682),
    [sym__declaration] = STATE(624),
    [sym_variable_declaration] = STATE(572),
    [sym_lexical_declaration] = STATE(572),
    [sym_class_declaration] = STATE(572),
    [sym_function_declaration] = STATE(572),
    [sym_generator_function_declaration] = STATE(572),
    [sym_decorator] = STATE(1945),
    [sym_function_signature] = STATE(621),
    [sym_ambient_declaration] = STATE(572),
    [sym_abstract_class_declaration] = STATE(572),
    [sym_module] = STATE(572),
    [sym_internal_module] = STATE(542),
    [sym_import_alias] = STATE(572),
    [sym_interface_declaration] = STATE(572),
    [sym_enum_declaration] = STATE(572),
    [sym_type_alias_declaration] = STATE(572),
    [aux_sym_export_statement_repeat1] = STATE(2373),
    [aux_sym_object_repeat1] = STATE(2868),
    [anon_sym_STAR] = ACTIONS(1193),
    [anon_sym_default] = ACTIONS(1195),
    [anon_sym_EQ] = ACTIONS(1197),
    [anon_sym_as] = ACTIONS(1199),
    [anon_sym_namespace] = ACTIONS(1201),
    [anon_sym_LBRACE] = ACTIONS(1203),
    [anon_sym_COMMA] = ACTIONS(813),
    [anon_sym_RBRACE] = ACTIONS(1246),
    [anon_sym_type] = ACTIONS(1207),
    [anon_sym_import] = ACTIONS(1209),
    [anon_sym_var] = ACTIONS(1211),
    [anon_sym_let] = ACTIONS(1213),
    [anon_sym_const] = ACTIONS(1215),
    [anon_sym_BANG] = ACTIONS(780),
    [anon_sym_LPAREN] = ACTIONS(1217),
    [anon_sym_in] = ACTIONS(780),
    [anon_sym_SEMI] = ACTIONS(813),
    [anon_sym_COLON] = ACTIONS(1220),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_LT] = ACTIONS(1225),
    [anon_sym_GT] = ACTIONS(780),
    [anon_sym_SLASH] = ACTIONS(780),
    [anon_sym_DOT] = ACTIONS(1228),
    [anon_sym_class] = ACTIONS(1230),
    [anon_sym_async] = ACTIONS(1232),
    [anon_sym_function] = ACTIONS(1234),
    [anon_sym_EQ_GT] = ACTIONS(929),
    [anon_sym_QMARK_DOT] = ACTIONS(931),
    [anon_sym_PLUS_EQ] = ACTIONS(803),
    [anon_sym_DASH_EQ] = ACTIONS(803),
    [anon_sym_STAR_EQ] = ACTIONS(803),
    [anon_sym_SLASH_EQ] = ACTIONS(803),
    [anon_sym_PERCENT_EQ] = ACTIONS(803),
    [anon_sym_CARET_EQ] = ACTIONS(803),
    [anon_sym_AMP_EQ] = ACTIONS(803),
    [anon_sym_PIPE_EQ] = ACTIONS(803),
    [anon_sym_GT_GT_EQ] = ACTIONS(803),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(803),
    [anon_sym_LT_LT_EQ] = ACTIONS(803),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(803),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(803),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(803),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(803),
    [anon_sym_QMARK] = ACTIONS(1225),
    [anon_sym_AMP_AMP] = ACTIONS(780),
    [anon_sym_PIPE_PIPE] = ACTIONS(780),
    [anon_sym_GT_GT] = ACTIONS(780),
    [anon_sym_GT_GT_GT] = ACTIONS(780),
    [anon_sym_LT_LT] = ACTIONS(780),
    [anon_sym_AMP] = ACTIONS(780),
    [anon_sym_CARET] = ACTIONS(780),
    [anon_sym_PIPE] = ACTIONS(780),
    [anon_sym_PLUS] = ACTIONS(780),
    [anon_sym_DASH] = ACTIONS(780),
    [anon_sym_PERCENT] = ACTIONS(780),
    [anon_sym_STAR_STAR] = ACTIONS(780),
    [anon_sym_LT_EQ] = ACTIONS(813),
    [anon_sym_EQ_EQ] = ACTIONS(780),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(813),
    [anon_sym_BANG_EQ] = ACTIONS(780),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(813),
    [anon_sym_GT_EQ] = ACTIONS(813),
    [anon_sym_QMARK_QMARK] = ACTIONS(780),
    [anon_sym_instanceof] = ACTIONS(813),
    [anon_sym_PLUS_PLUS] = ACTIONS(813),
    [anon_sym_DASH_DASH] = ACTIONS(813),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(813),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_abstract] = ACTIONS(1236),
    [anon_sym_declare] = ACTIONS(1238),
    [anon_sym_module] = ACTIONS(1240),
    [anon_sym_interface] = ACTIONS(1242),
    [anon_sym_enum] = ACTIONS(1244),
    [sym__automatic_semicolon] = ACTIONS(813),
  },
  [121] = {
    [sym_export_clause] = STATE(2682),
    [sym__declaration] = STATE(624),
    [sym_variable_declaration] = STATE(572),
    [sym_lexical_declaration] = STATE(572),
    [sym_class_declaration] = STATE(572),
    [sym_function_declaration] = STATE(572),
    [sym_generator_function_declaration] = STATE(572),
    [sym_decorator] = STATE(1945),
    [sym_function_signature] = STATE(621),
    [sym_ambient_declaration] = STATE(572),
    [sym_abstract_class_declaration] = STATE(572),
    [sym_module] = STATE(572),
    [sym_internal_module] = STATE(542),
    [sym_import_alias] = STATE(572),
    [sym_interface_declaration] = STATE(572),
    [sym_enum_declaration] = STATE(572),
    [sym_type_alias_declaration] = STATE(572),
    [aux_sym_export_statement_repeat1] = STATE(2373),
    [aux_sym_object_repeat1] = STATE(2854),
    [anon_sym_STAR] = ACTIONS(1193),
    [anon_sym_default] = ACTIONS(1195),
    [anon_sym_EQ] = ACTIONS(1197),
    [anon_sym_as] = ACTIONS(1199),
    [anon_sym_namespace] = ACTIONS(1201),
    [anon_sym_LBRACE] = ACTIONS(1203),
    [anon_sym_COMMA] = ACTIONS(813),
    [anon_sym_RBRACE] = ACTIONS(1248),
    [anon_sym_type] = ACTIONS(1207),
    [anon_sym_import] = ACTIONS(1209),
    [anon_sym_var] = ACTIONS(1211),
    [anon_sym_let] = ACTIONS(1213),
    [anon_sym_const] = ACTIONS(1215),
    [anon_sym_BANG] = ACTIONS(780),
    [anon_sym_LPAREN] = ACTIONS(1217),
    [anon_sym_in] = ACTIONS(780),
    [anon_sym_SEMI] = ACTIONS(813),
    [anon_sym_COLON] = ACTIONS(1220),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_LT] = ACTIONS(1225),
    [anon_sym_GT] = ACTIONS(780),
    [anon_sym_SLASH] = ACTIONS(780),
    [anon_sym_DOT] = ACTIONS(1228),
    [anon_sym_class] = ACTIONS(1230),
    [anon_sym_async] = ACTIONS(1232),
    [anon_sym_function] = ACTIONS(1234),
    [anon_sym_EQ_GT] = ACTIONS(929),
    [anon_sym_QMARK_DOT] = ACTIONS(931),
    [anon_sym_PLUS_EQ] = ACTIONS(803),
    [anon_sym_DASH_EQ] = ACTIONS(803),
    [anon_sym_STAR_EQ] = ACTIONS(803),
    [anon_sym_SLASH_EQ] = ACTIONS(803),
    [anon_sym_PERCENT_EQ] = ACTIONS(803),
    [anon_sym_CARET_EQ] = ACTIONS(803),
    [anon_sym_AMP_EQ] = ACTIONS(803),
    [anon_sym_PIPE_EQ] = ACTIONS(803),
    [anon_sym_GT_GT_EQ] = ACTIONS(803),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(803),
    [anon_sym_LT_LT_EQ] = ACTIONS(803),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(803),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(803),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(803),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(803),
    [anon_sym_QMARK] = ACTIONS(1225),
    [anon_sym_AMP_AMP] = ACTIONS(780),
    [anon_sym_PIPE_PIPE] = ACTIONS(780),
    [anon_sym_GT_GT] = ACTIONS(780),
    [anon_sym_GT_GT_GT] = ACTIONS(780),
    [anon_sym_LT_LT] = ACTIONS(780),
    [anon_sym_AMP] = ACTIONS(780),
    [anon_sym_CARET] = ACTIONS(780),
    [anon_sym_PIPE] = ACTIONS(780),
    [anon_sym_PLUS] = ACTIONS(780),
    [anon_sym_DASH] = ACTIONS(780),
    [anon_sym_PERCENT] = ACTIONS(780),
    [anon_sym_STAR_STAR] = ACTIONS(780),
    [anon_sym_LT_EQ] = ACTIONS(813),
    [anon_sym_EQ_EQ] = ACTIONS(780),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(813),
    [anon_sym_BANG_EQ] = ACTIONS(780),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(813),
    [anon_sym_GT_EQ] = ACTIONS(813),
    [anon_sym_QMARK_QMARK] = ACTIONS(780),
    [anon_sym_instanceof] = ACTIONS(813),
    [anon_sym_PLUS_PLUS] = ACTIONS(813),
    [anon_sym_DASH_DASH] = ACTIONS(813),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(813),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_abstract] = ACTIONS(1236),
    [anon_sym_declare] = ACTIONS(1238),
    [anon_sym_module] = ACTIONS(1240),
    [anon_sym_interface] = ACTIONS(1242),
    [anon_sym_enum] = ACTIONS(1244),
    [sym__automatic_semicolon] = ACTIONS(813),
  },
  [122] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(884),
    [sym__expression] = STATE(1327),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1283),
    [sym_array] = STATE(1281),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3336),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(884),
    [sym_subscript_expression] = STATE(884),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1964),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_spread_element] = STATE(2788),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_sequence_expression] = STATE(3222),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(860),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(414),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [aux_sym_array_repeat1] = STATE(2789),
    [sym_identifier] = ACTIONS(831),
    [anon_sym_export] = ACTIONS(503),
    [anon_sym_namespace] = ACTIONS(505),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_COMMA] = ACTIONS(1147),
    [anon_sym_type] = ACTIONS(503),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(437),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(443),
    [anon_sym_yield] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_RBRACK] = ACTIONS(1250),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(849),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(851),
    [anon_sym_TILDE] = ACTIONS(437),
    [anon_sym_void] = ACTIONS(471),
    [anon_sym_delete] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(473),
    [anon_sym_DASH_DASH] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(503),
    [anon_sym_get] = ACTIONS(503),
    [anon_sym_set] = ACTIONS(503),
    [anon_sym_declare] = ACTIONS(503),
    [anon_sym_public] = ACTIONS(503),
    [anon_sym_private] = ACTIONS(503),
    [anon_sym_protected] = ACTIONS(503),
    [anon_sym_module] = ACTIONS(503),
    [anon_sym_any] = ACTIONS(503),
    [anon_sym_number] = ACTIONS(503),
    [anon_sym_boolean] = ACTIONS(503),
    [anon_sym_string] = ACTIONS(503),
    [anon_sym_symbol] = ACTIONS(503),
    [sym_readonly] = ACTIONS(503),
  },
  [123] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(884),
    [sym__expression] = STATE(1336),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1283),
    [sym_array] = STATE(1281),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3336),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(884),
    [sym_subscript_expression] = STATE(884),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1964),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_spread_element] = STATE(2788),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(860),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_mapped_type_clause] = STATE(3339),
    [sym_type_arguments] = STATE(414),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [aux_sym_array_repeat1] = STATE(2789),
    [sym_identifier] = ACTIONS(1252),
    [anon_sym_export] = ACTIONS(1254),
    [anon_sym_namespace] = ACTIONS(1256),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_COMMA] = ACTIONS(1147),
    [anon_sym_type] = ACTIONS(1254),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(437),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(443),
    [anon_sym_yield] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_RBRACK] = ACTIONS(1250),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(1258),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(849),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(851),
    [anon_sym_TILDE] = ACTIONS(437),
    [anon_sym_void] = ACTIONS(471),
    [anon_sym_delete] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(473),
    [anon_sym_DASH_DASH] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1254),
    [anon_sym_get] = ACTIONS(1254),
    [anon_sym_set] = ACTIONS(1254),
    [anon_sym_declare] = ACTIONS(1254),
    [anon_sym_public] = ACTIONS(1254),
    [anon_sym_private] = ACTIONS(1254),
    [anon_sym_protected] = ACTIONS(1254),
    [anon_sym_module] = ACTIONS(1254),
    [anon_sym_any] = ACTIONS(1254),
    [anon_sym_number] = ACTIONS(1254),
    [anon_sym_boolean] = ACTIONS(1254),
    [anon_sym_string] = ACTIONS(1254),
    [anon_sym_symbol] = ACTIONS(1254),
    [sym_readonly] = ACTIONS(1254),
  },
  [124] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(884),
    [sym__expression] = STATE(1278),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1283),
    [sym_array] = STATE(1281),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3336),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(884),
    [sym_subscript_expression] = STATE(884),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1964),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_spread_element] = STATE(2788),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_sequence_expression] = STATE(3222),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(860),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(414),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [aux_sym_array_repeat1] = STATE(2789),
    [sym_identifier] = ACTIONS(831),
    [anon_sym_export] = ACTIONS(503),
    [anon_sym_namespace] = ACTIONS(505),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_COMMA] = ACTIONS(1147),
    [anon_sym_type] = ACTIONS(503),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(437),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(443),
    [anon_sym_yield] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_RBRACK] = ACTIONS(1250),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(849),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(851),
    [anon_sym_TILDE] = ACTIONS(437),
    [anon_sym_void] = ACTIONS(471),
    [anon_sym_delete] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(473),
    [anon_sym_DASH_DASH] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(503),
    [anon_sym_get] = ACTIONS(503),
    [anon_sym_set] = ACTIONS(503),
    [anon_sym_declare] = ACTIONS(503),
    [anon_sym_public] = ACTIONS(503),
    [anon_sym_private] = ACTIONS(503),
    [anon_sym_protected] = ACTIONS(503),
    [anon_sym_module] = ACTIONS(503),
    [anon_sym_any] = ACTIONS(503),
    [anon_sym_number] = ACTIONS(503),
    [anon_sym_boolean] = ACTIONS(503),
    [anon_sym_string] = ACTIONS(503),
    [anon_sym_symbol] = ACTIONS(503),
    [sym_readonly] = ACTIONS(503),
  },
  [125] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(884),
    [sym__expression] = STATE(1105),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1283),
    [sym_array] = STATE(1281),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3336),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(884),
    [sym_subscript_expression] = STATE(884),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1964),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(860),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(414),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(831),
    [anon_sym_export] = ACTIONS(503),
    [anon_sym_namespace] = ACTIONS(505),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_COMMA] = ACTIONS(1189),
    [anon_sym_type] = ACTIONS(503),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(437),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_RPAREN] = ACTIONS(1189),
    [anon_sym_await] = ACTIONS(443),
    [anon_sym_yield] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(1189),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(849),
    [anon_sym_AMP] = ACTIONS(1189),
    [anon_sym_PIPE] = ACTIONS(1189),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(851),
    [anon_sym_TILDE] = ACTIONS(437),
    [anon_sym_void] = ACTIONS(471),
    [anon_sym_delete] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(473),
    [anon_sym_DASH_DASH] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(503),
    [anon_sym_get] = ACTIONS(503),
    [anon_sym_set] = ACTIONS(503),
    [anon_sym_declare] = ACTIONS(503),
    [anon_sym_public] = ACTIONS(503),
    [anon_sym_private] = ACTIONS(503),
    [anon_sym_protected] = ACTIONS(503),
    [anon_sym_module] = ACTIONS(503),
    [anon_sym_any] = ACTIONS(503),
    [anon_sym_number] = ACTIONS(503),
    [anon_sym_boolean] = ACTIONS(503),
    [anon_sym_string] = ACTIONS(503),
    [anon_sym_symbol] = ACTIONS(503),
    [anon_sym_extends] = ACTIONS(1191),
    [sym_readonly] = ACTIONS(503),
  },
  [126] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(965),
    [sym__expression] = STATE(1250),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1524),
    [sym_array] = STATE(1523),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3348),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(965),
    [sym_subscript_expression] = STATE(965),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1969),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(975),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(302),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(901),
    [anon_sym_export] = ACTIONS(713),
    [anon_sym_namespace] = ACTIONS(715),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_COMMA] = ACTIONS(1189),
    [anon_sym_type] = ACTIONS(713),
    [anon_sym_typeof] = ACTIONS(735),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(719),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(721),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(1189),
    [anon_sym_SLASH] = ACTIONS(725),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(727),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(907),
    [anon_sym_AMP] = ACTIONS(1189),
    [anon_sym_PIPE] = ACTIONS(1189),
    [anon_sym_PLUS] = ACTIONS(909),
    [anon_sym_DASH] = ACTIONS(909),
    [anon_sym_TILDE] = ACTIONS(719),
    [anon_sym_void] = ACTIONS(735),
    [anon_sym_delete] = ACTIONS(735),
    [anon_sym_PLUS_PLUS] = ACTIONS(737),
    [anon_sym_DASH_DASH] = ACTIONS(737),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(713),
    [anon_sym_get] = ACTIONS(713),
    [anon_sym_set] = ACTIONS(713),
    [anon_sym_declare] = ACTIONS(713),
    [anon_sym_public] = ACTIONS(713),
    [anon_sym_private] = ACTIONS(713),
    [anon_sym_protected] = ACTIONS(713),
    [anon_sym_module] = ACTIONS(713),
    [anon_sym_any] = ACTIONS(713),
    [anon_sym_number] = ACTIONS(713),
    [anon_sym_boolean] = ACTIONS(713),
    [anon_sym_string] = ACTIONS(713),
    [anon_sym_symbol] = ACTIONS(713),
    [anon_sym_extends] = ACTIONS(1191),
    [sym_readonly] = ACTIONS(713),
  },
  [127] = {
    [sym__declaration] = STATE(557),
    [sym_variable_declaration] = STATE(572),
    [sym_lexical_declaration] = STATE(572),
    [sym_class_declaration] = STATE(572),
    [sym_function_declaration] = STATE(572),
    [sym_generator_function_declaration] = STATE(572),
    [sym_decorator] = STATE(1945),
    [sym_function_signature] = STATE(572),
    [sym_ambient_declaration] = STATE(572),
    [sym_abstract_class_declaration] = STATE(572),
    [sym_module] = STATE(572),
    [sym_internal_module] = STATE(542),
    [sym_import_alias] = STATE(572),
    [sym_interface_declaration] = STATE(572),
    [sym_enum_declaration] = STATE(572),
    [sym_type_alias_declaration] = STATE(572),
    [aux_sym_export_statement_repeat1] = STATE(2373),
    [aux_sym_object_repeat1] = STATE(2854),
    [anon_sym_STAR] = ACTIONS(780),
    [anon_sym_EQ] = ACTIONS(1260),
    [anon_sym_as] = ACTIONS(780),
    [anon_sym_namespace] = ACTIONS(1201),
    [anon_sym_COMMA] = ACTIONS(813),
    [anon_sym_RBRACE] = ACTIONS(1248),
    [anon_sym_type] = ACTIONS(1207),
    [anon_sym_import] = ACTIONS(1209),
    [anon_sym_var] = ACTIONS(1211),
    [anon_sym_let] = ACTIONS(1213),
    [anon_sym_const] = ACTIONS(1215),
    [anon_sym_BANG] = ACTIONS(780),
    [anon_sym_LPAREN] = ACTIONS(1217),
    [anon_sym_in] = ACTIONS(780),
    [anon_sym_SEMI] = ACTIONS(813),
    [anon_sym_COLON] = ACTIONS(1220),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_LT] = ACTIONS(1225),
    [anon_sym_GT] = ACTIONS(780),
    [anon_sym_SLASH] = ACTIONS(780),
    [anon_sym_DOT] = ACTIONS(1228),
    [anon_sym_class] = ACTIONS(1230),
    [anon_sym_async] = ACTIONS(1232),
    [anon_sym_function] = ACTIONS(1234),
    [anon_sym_EQ_GT] = ACTIONS(929),
    [anon_sym_QMARK_DOT] = ACTIONS(931),
    [anon_sym_PLUS_EQ] = ACTIONS(803),
    [anon_sym_DASH_EQ] = ACTIONS(803),
    [anon_sym_STAR_EQ] = ACTIONS(803),
    [anon_sym_SLASH_EQ] = ACTIONS(803),
    [anon_sym_PERCENT_EQ] = ACTIONS(803),
    [anon_sym_CARET_EQ] = ACTIONS(803),
    [anon_sym_AMP_EQ] = ACTIONS(803),
    [anon_sym_PIPE_EQ] = ACTIONS(803),
    [anon_sym_GT_GT_EQ] = ACTIONS(803),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(803),
    [anon_sym_LT_LT_EQ] = ACTIONS(803),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(803),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(803),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(803),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(803),
    [anon_sym_QMARK] = ACTIONS(1225),
    [anon_sym_AMP_AMP] = ACTIONS(780),
    [anon_sym_PIPE_PIPE] = ACTIONS(780),
    [anon_sym_GT_GT] = ACTIONS(780),
    [anon_sym_GT_GT_GT] = ACTIONS(780),
    [anon_sym_LT_LT] = ACTIONS(780),
    [anon_sym_AMP] = ACTIONS(780),
    [anon_sym_CARET] = ACTIONS(780),
    [anon_sym_PIPE] = ACTIONS(780),
    [anon_sym_PLUS] = ACTIONS(780),
    [anon_sym_DASH] = ACTIONS(780),
    [anon_sym_PERCENT] = ACTIONS(780),
    [anon_sym_STAR_STAR] = ACTIONS(780),
    [anon_sym_LT_EQ] = ACTIONS(813),
    [anon_sym_EQ_EQ] = ACTIONS(780),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(813),
    [anon_sym_BANG_EQ] = ACTIONS(780),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(813),
    [anon_sym_GT_EQ] = ACTIONS(813),
    [anon_sym_QMARK_QMARK] = ACTIONS(780),
    [anon_sym_instanceof] = ACTIONS(813),
    [anon_sym_PLUS_PLUS] = ACTIONS(813),
    [anon_sym_DASH_DASH] = ACTIONS(813),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(813),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_abstract] = ACTIONS(1236),
    [anon_sym_declare] = ACTIONS(1238),
    [anon_sym_module] = ACTIONS(1262),
    [anon_sym_global] = ACTIONS(1264),
    [anon_sym_interface] = ACTIONS(1242),
    [anon_sym_enum] = ACTIONS(1244),
    [sym__automatic_semicolon] = ACTIONS(813),
  },
  [128] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(884),
    [sym__expression] = STATE(1244),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1283),
    [sym_array] = STATE(1281),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3336),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(884),
    [sym_subscript_expression] = STATE(884),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1964),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_spread_element] = STATE(2917),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(860),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(414),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [aux_sym_array_repeat1] = STATE(2916),
    [sym_identifier] = ACTIONS(831),
    [anon_sym_export] = ACTIONS(503),
    [anon_sym_namespace] = ACTIONS(505),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_COMMA] = ACTIONS(1147),
    [anon_sym_type] = ACTIONS(503),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(437),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(443),
    [anon_sym_yield] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_RBRACK] = ACTIONS(1266),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(849),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(851),
    [anon_sym_TILDE] = ACTIONS(437),
    [anon_sym_void] = ACTIONS(471),
    [anon_sym_delete] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(473),
    [anon_sym_DASH_DASH] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(503),
    [anon_sym_get] = ACTIONS(503),
    [anon_sym_set] = ACTIONS(503),
    [anon_sym_declare] = ACTIONS(503),
    [anon_sym_public] = ACTIONS(503),
    [anon_sym_private] = ACTIONS(503),
    [anon_sym_protected] = ACTIONS(503),
    [anon_sym_module] = ACTIONS(503),
    [anon_sym_any] = ACTIONS(503),
    [anon_sym_number] = ACTIONS(503),
    [anon_sym_boolean] = ACTIONS(503),
    [anon_sym_string] = ACTIONS(503),
    [anon_sym_symbol] = ACTIONS(503),
    [sym_readonly] = ACTIONS(503),
  },
  [129] = {
    [sym_import] = STATE(1528),
    [sym_parenthesized_expression] = STATE(983),
    [sym__expression] = STATE(1358),
    [sym_yield_expression] = STATE(1543),
    [sym_object] = STATE(1671),
    [sym_array] = STATE(1713),
    [sym_class] = STATE(1528),
    [sym_function] = STATE(1528),
    [sym_generator_function] = STATE(1528),
    [sym_arrow_function] = STATE(1528),
    [sym__call_signature] = STATE(3235),
    [sym_call_expression] = STATE(1528),
    [sym_new_expression] = STATE(1543),
    [sym_await_expression] = STATE(1543),
    [sym_member_expression] = STATE(983),
    [sym_subscript_expression] = STATE(983),
    [sym_assignment_expression] = STATE(1543),
    [sym__augmented_assignment_lhs] = STATE(1963),
    [sym_augmented_assignment_expression] = STATE(1543),
    [sym_ternary_expression] = STATE(1543),
    [sym_binary_expression] = STATE(1543),
    [sym_unary_expression] = STATE(1543),
    [sym_update_expression] = STATE(1543),
    [sym_string] = STATE(1528),
    [sym_template_string] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_meta_property] = STATE(1528),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(984),
    [sym_type_assertion] = STATE(1543),
    [sym_as_expression] = STATE(1543),
    [sym_internal_module] = STATE(1543),
    [sym_type_arguments] = STATE(310),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2726),
    [sym_identifier] = ACTIONS(891),
    [anon_sym_export] = ACTIONS(529),
    [anon_sym_namespace] = ACTIONS(531),
    [anon_sym_LBRACE] = ACTIONS(859),
    [anon_sym_COMMA] = ACTIONS(1189),
    [anon_sym_type] = ACTIONS(529),
    [anon_sym_typeof] = ACTIONS(561),
    [anon_sym_import] = ACTIONS(537),
    [anon_sym_BANG] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(543),
    [anon_sym_yield] = ACTIONS(545),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(1189),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(549),
    [anon_sym_async] = ACTIONS(551),
    [anon_sym_function] = ACTIONS(553),
    [anon_sym_new] = ACTIONS(897),
    [anon_sym_AMP] = ACTIONS(1189),
    [anon_sym_PIPE] = ACTIONS(1189),
    [anon_sym_PLUS] = ACTIONS(899),
    [anon_sym_DASH] = ACTIONS(899),
    [anon_sym_TILDE] = ACTIONS(539),
    [anon_sym_void] = ACTIONS(561),
    [anon_sym_delete] = ACTIONS(561),
    [anon_sym_PLUS_PLUS] = ACTIONS(563),
    [anon_sym_DASH_DASH] = ACTIONS(563),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(529),
    [anon_sym_get] = ACTIONS(529),
    [anon_sym_set] = ACTIONS(529),
    [anon_sym_declare] = ACTIONS(529),
    [anon_sym_public] = ACTIONS(529),
    [anon_sym_private] = ACTIONS(529),
    [anon_sym_protected] = ACTIONS(529),
    [anon_sym_module] = ACTIONS(529),
    [anon_sym_any] = ACTIONS(529),
    [anon_sym_number] = ACTIONS(529),
    [anon_sym_boolean] = ACTIONS(529),
    [anon_sym_string] = ACTIONS(529),
    [anon_sym_symbol] = ACTIONS(529),
    [anon_sym_extends] = ACTIONS(1191),
    [sym_readonly] = ACTIONS(529),
  },
  [130] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(884),
    [sym__expression] = STATE(1319),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1283),
    [sym_array] = STATE(1281),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3336),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(884),
    [sym_subscript_expression] = STATE(884),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1964),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_spread_element] = STATE(2852),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(860),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(414),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [aux_sym_array_repeat1] = STATE(2853),
    [sym_identifier] = ACTIONS(831),
    [anon_sym_export] = ACTIONS(503),
    [anon_sym_namespace] = ACTIONS(505),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_COMMA] = ACTIONS(1147),
    [anon_sym_type] = ACTIONS(503),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(437),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(443),
    [anon_sym_yield] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_RBRACK] = ACTIONS(1268),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(849),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(851),
    [anon_sym_TILDE] = ACTIONS(437),
    [anon_sym_void] = ACTIONS(471),
    [anon_sym_delete] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(473),
    [anon_sym_DASH_DASH] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(503),
    [anon_sym_get] = ACTIONS(503),
    [anon_sym_set] = ACTIONS(503),
    [anon_sym_declare] = ACTIONS(503),
    [anon_sym_public] = ACTIONS(503),
    [anon_sym_private] = ACTIONS(503),
    [anon_sym_protected] = ACTIONS(503),
    [anon_sym_module] = ACTIONS(503),
    [anon_sym_any] = ACTIONS(503),
    [anon_sym_number] = ACTIONS(503),
    [anon_sym_boolean] = ACTIONS(503),
    [anon_sym_string] = ACTIONS(503),
    [anon_sym_symbol] = ACTIONS(503),
    [sym_readonly] = ACTIONS(503),
  },
  [131] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(963),
    [sym__expression] = STATE(1288),
    [sym_yield_expression] = STATE(1722),
    [sym_object] = STATE(1536),
    [sym_array] = STATE(1535),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(3286),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1722),
    [sym_await_expression] = STATE(1722),
    [sym_member_expression] = STATE(963),
    [sym_subscript_expression] = STATE(963),
    [sym_assignment_expression] = STATE(1722),
    [sym__augmented_assignment_lhs] = STATE(1968),
    [sym_augmented_assignment_expression] = STATE(1722),
    [sym_ternary_expression] = STATE(1722),
    [sym_binary_expression] = STATE(1722),
    [sym_unary_expression] = STATE(1722),
    [sym_update_expression] = STATE(1722),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(952),
    [sym_type_assertion] = STATE(1722),
    [sym_as_expression] = STATE(1722),
    [sym_internal_module] = STATE(1722),
    [sym_type_arguments] = STATE(266),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2684),
    [sym_identifier] = ACTIONS(863),
    [anon_sym_export] = ACTIONS(655),
    [anon_sym_namespace] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(1270),
    [anon_sym_COMMA] = ACTIONS(1189),
    [anon_sym_type] = ACTIONS(655),
    [anon_sym_typeof] = ACTIONS(689),
    [anon_sym_import] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_LPAREN] = ACTIONS(871),
    [anon_sym_await] = ACTIONS(669),
    [anon_sym_yield] = ACTIONS(671),
    [anon_sym_LBRACK] = ACTIONS(873),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(1189),
    [anon_sym_SLASH] = ACTIONS(675),
    [anon_sym_class] = ACTIONS(677),
    [anon_sym_async] = ACTIONS(679),
    [anon_sym_function] = ACTIONS(681),
    [anon_sym_new] = ACTIONS(875),
    [anon_sym_AMP] = ACTIONS(1189),
    [anon_sym_PIPE] = ACTIONS(1189),
    [anon_sym_PLUS] = ACTIONS(877),
    [anon_sym_DASH] = ACTIONS(877),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_void] = ACTIONS(689),
    [anon_sym_delete] = ACTIONS(689),
    [anon_sym_PLUS_PLUS] = ACTIONS(691),
    [anon_sym_DASH_DASH] = ACTIONS(691),
    [anon_sym_DQUOTE] = ACTIONS(693),
    [anon_sym_SQUOTE] = ACTIONS(695),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(697),
    [sym_number] = ACTIONS(879),
    [sym_this] = ACTIONS(703),
    [sym_super] = ACTIONS(703),
    [sym_true] = ACTIONS(703),
    [sym_false] = ACTIONS(703),
    [sym_null] = ACTIONS(703),
    [sym_undefined] = ACTIONS(703),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(655),
    [anon_sym_get] = ACTIONS(655),
    [anon_sym_set] = ACTIONS(655),
    [anon_sym_declare] = ACTIONS(655),
    [anon_sym_public] = ACTIONS(655),
    [anon_sym_private] = ACTIONS(655),
    [anon_sym_protected] = ACTIONS(655),
    [anon_sym_module] = ACTIONS(655),
    [anon_sym_any] = ACTIONS(655),
    [anon_sym_number] = ACTIONS(655),
    [anon_sym_boolean] = ACTIONS(655),
    [anon_sym_string] = ACTIONS(655),
    [anon_sym_symbol] = ACTIONS(655),
    [anon_sym_extends] = ACTIONS(1191),
    [sym_readonly] = ACTIONS(655),
  },
  [132] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(884),
    [sym__expression] = STATE(1256),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1283),
    [sym_array] = STATE(1281),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3336),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(884),
    [sym_subscript_expression] = STATE(884),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1964),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_spread_element] = STATE(2781),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(860),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(414),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(831),
    [anon_sym_export] = ACTIONS(503),
    [anon_sym_namespace] = ACTIONS(505),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_COMMA] = ACTIONS(1272),
    [anon_sym_type] = ACTIONS(503),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(437),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_RPAREN] = ACTIONS(1272),
    [anon_sym_await] = ACTIONS(443),
    [anon_sym_yield] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_RBRACK] = ACTIONS(1272),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(849),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(851),
    [anon_sym_TILDE] = ACTIONS(437),
    [anon_sym_void] = ACTIONS(471),
    [anon_sym_delete] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(473),
    [anon_sym_DASH_DASH] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(503),
    [anon_sym_get] = ACTIONS(503),
    [anon_sym_set] = ACTIONS(503),
    [anon_sym_declare] = ACTIONS(503),
    [anon_sym_public] = ACTIONS(503),
    [anon_sym_private] = ACTIONS(503),
    [anon_sym_protected] = ACTIONS(503),
    [anon_sym_module] = ACTIONS(503),
    [anon_sym_any] = ACTIONS(503),
    [anon_sym_number] = ACTIONS(503),
    [anon_sym_boolean] = ACTIONS(503),
    [anon_sym_string] = ACTIONS(503),
    [anon_sym_symbol] = ACTIONS(503),
    [sym_readonly] = ACTIONS(503),
  },
  [133] = {
    [sym__declaration] = STATE(557),
    [sym_variable_declaration] = STATE(572),
    [sym_lexical_declaration] = STATE(572),
    [sym_class_declaration] = STATE(572),
    [sym_function_declaration] = STATE(572),
    [sym_generator_function_declaration] = STATE(572),
    [sym_decorator] = STATE(1945),
    [sym_function_signature] = STATE(572),
    [sym_ambient_declaration] = STATE(572),
    [sym_abstract_class_declaration] = STATE(572),
    [sym_module] = STATE(572),
    [sym_internal_module] = STATE(542),
    [sym_import_alias] = STATE(572),
    [sym_interface_declaration] = STATE(572),
    [sym_enum_declaration] = STATE(572),
    [sym_type_alias_declaration] = STATE(572),
    [aux_sym_export_statement_repeat1] = STATE(2373),
    [aux_sym_object_repeat1] = STATE(2868),
    [anon_sym_STAR] = ACTIONS(780),
    [anon_sym_EQ] = ACTIONS(1260),
    [anon_sym_as] = ACTIONS(780),
    [anon_sym_namespace] = ACTIONS(1201),
    [anon_sym_COMMA] = ACTIONS(813),
    [anon_sym_RBRACE] = ACTIONS(1246),
    [anon_sym_type] = ACTIONS(1207),
    [anon_sym_import] = ACTIONS(1209),
    [anon_sym_var] = ACTIONS(1211),
    [anon_sym_let] = ACTIONS(1213),
    [anon_sym_const] = ACTIONS(1215),
    [anon_sym_BANG] = ACTIONS(780),
    [anon_sym_LPAREN] = ACTIONS(1217),
    [anon_sym_in] = ACTIONS(780),
    [anon_sym_SEMI] = ACTIONS(813),
    [anon_sym_COLON] = ACTIONS(1220),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_LT] = ACTIONS(1225),
    [anon_sym_GT] = ACTIONS(780),
    [anon_sym_SLASH] = ACTIONS(780),
    [anon_sym_DOT] = ACTIONS(1228),
    [anon_sym_class] = ACTIONS(1230),
    [anon_sym_async] = ACTIONS(1232),
    [anon_sym_function] = ACTIONS(1234),
    [anon_sym_EQ_GT] = ACTIONS(929),
    [anon_sym_QMARK_DOT] = ACTIONS(931),
    [anon_sym_PLUS_EQ] = ACTIONS(803),
    [anon_sym_DASH_EQ] = ACTIONS(803),
    [anon_sym_STAR_EQ] = ACTIONS(803),
    [anon_sym_SLASH_EQ] = ACTIONS(803),
    [anon_sym_PERCENT_EQ] = ACTIONS(803),
    [anon_sym_CARET_EQ] = ACTIONS(803),
    [anon_sym_AMP_EQ] = ACTIONS(803),
    [anon_sym_PIPE_EQ] = ACTIONS(803),
    [anon_sym_GT_GT_EQ] = ACTIONS(803),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(803),
    [anon_sym_LT_LT_EQ] = ACTIONS(803),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(803),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(803),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(803),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(803),
    [anon_sym_QMARK] = ACTIONS(1225),
    [anon_sym_AMP_AMP] = ACTIONS(780),
    [anon_sym_PIPE_PIPE] = ACTIONS(780),
    [anon_sym_GT_GT] = ACTIONS(780),
    [anon_sym_GT_GT_GT] = ACTIONS(780),
    [anon_sym_LT_LT] = ACTIONS(780),
    [anon_sym_AMP] = ACTIONS(780),
    [anon_sym_CARET] = ACTIONS(780),
    [anon_sym_PIPE] = ACTIONS(780),
    [anon_sym_PLUS] = ACTIONS(780),
    [anon_sym_DASH] = ACTIONS(780),
    [anon_sym_PERCENT] = ACTIONS(780),
    [anon_sym_STAR_STAR] = ACTIONS(780),
    [anon_sym_LT_EQ] = ACTIONS(813),
    [anon_sym_EQ_EQ] = ACTIONS(780),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(813),
    [anon_sym_BANG_EQ] = ACTIONS(780),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(813),
    [anon_sym_GT_EQ] = ACTIONS(813),
    [anon_sym_QMARK_QMARK] = ACTIONS(780),
    [anon_sym_instanceof] = ACTIONS(813),
    [anon_sym_PLUS_PLUS] = ACTIONS(813),
    [anon_sym_DASH_DASH] = ACTIONS(813),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(813),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_abstract] = ACTIONS(1236),
    [anon_sym_declare] = ACTIONS(1238),
    [anon_sym_module] = ACTIONS(1262),
    [anon_sym_global] = ACTIONS(1264),
    [anon_sym_interface] = ACTIONS(1242),
    [anon_sym_enum] = ACTIONS(1244),
    [sym__automatic_semicolon] = ACTIONS(813),
  },
  [134] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(884),
    [sym__expression] = STATE(1309),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1283),
    [sym_array] = STATE(1281),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3336),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(884),
    [sym_subscript_expression] = STATE(884),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1964),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_spread_element] = STATE(2929),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(860),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(414),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [aux_sym_array_repeat1] = STATE(2931),
    [sym_identifier] = ACTIONS(831),
    [anon_sym_export] = ACTIONS(503),
    [anon_sym_namespace] = ACTIONS(505),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_COMMA] = ACTIONS(1147),
    [anon_sym_type] = ACTIONS(503),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(437),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(443),
    [anon_sym_yield] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_RBRACK] = ACTIONS(1274),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(849),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(851),
    [anon_sym_TILDE] = ACTIONS(437),
    [anon_sym_void] = ACTIONS(471),
    [anon_sym_delete] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(473),
    [anon_sym_DASH_DASH] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(503),
    [anon_sym_get] = ACTIONS(503),
    [anon_sym_set] = ACTIONS(503),
    [anon_sym_declare] = ACTIONS(503),
    [anon_sym_public] = ACTIONS(503),
    [anon_sym_private] = ACTIONS(503),
    [anon_sym_protected] = ACTIONS(503),
    [anon_sym_module] = ACTIONS(503),
    [anon_sym_any] = ACTIONS(503),
    [anon_sym_number] = ACTIONS(503),
    [anon_sym_boolean] = ACTIONS(503),
    [anon_sym_string] = ACTIONS(503),
    [anon_sym_symbol] = ACTIONS(503),
    [sym_readonly] = ACTIONS(503),
  },
  [135] = {
    [sym__declaration] = STATE(557),
    [sym_variable_declaration] = STATE(572),
    [sym_lexical_declaration] = STATE(572),
    [sym_class_declaration] = STATE(572),
    [sym_function_declaration] = STATE(572),
    [sym_generator_function_declaration] = STATE(572),
    [sym_decorator] = STATE(1945),
    [sym_function_signature] = STATE(572),
    [sym_ambient_declaration] = STATE(572),
    [sym_abstract_class_declaration] = STATE(572),
    [sym_module] = STATE(572),
    [sym_internal_module] = STATE(542),
    [sym_import_alias] = STATE(572),
    [sym_interface_declaration] = STATE(572),
    [sym_enum_declaration] = STATE(572),
    [sym_type_alias_declaration] = STATE(572),
    [aux_sym_export_statement_repeat1] = STATE(2373),
    [aux_sym_object_repeat1] = STATE(2894),
    [anon_sym_STAR] = ACTIONS(780),
    [anon_sym_EQ] = ACTIONS(1260),
    [anon_sym_as] = ACTIONS(780),
    [anon_sym_namespace] = ACTIONS(1201),
    [anon_sym_COMMA] = ACTIONS(813),
    [anon_sym_RBRACE] = ACTIONS(1205),
    [anon_sym_type] = ACTIONS(1207),
    [anon_sym_import] = ACTIONS(1209),
    [anon_sym_var] = ACTIONS(1211),
    [anon_sym_let] = ACTIONS(1213),
    [anon_sym_const] = ACTIONS(1215),
    [anon_sym_BANG] = ACTIONS(780),
    [anon_sym_LPAREN] = ACTIONS(1217),
    [anon_sym_in] = ACTIONS(780),
    [anon_sym_SEMI] = ACTIONS(813),
    [anon_sym_COLON] = ACTIONS(1220),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_LT] = ACTIONS(1225),
    [anon_sym_GT] = ACTIONS(780),
    [anon_sym_SLASH] = ACTIONS(780),
    [anon_sym_DOT] = ACTIONS(1228),
    [anon_sym_class] = ACTIONS(1230),
    [anon_sym_async] = ACTIONS(1232),
    [anon_sym_function] = ACTIONS(1234),
    [anon_sym_EQ_GT] = ACTIONS(929),
    [anon_sym_QMARK_DOT] = ACTIONS(931),
    [anon_sym_PLUS_EQ] = ACTIONS(803),
    [anon_sym_DASH_EQ] = ACTIONS(803),
    [anon_sym_STAR_EQ] = ACTIONS(803),
    [anon_sym_SLASH_EQ] = ACTIONS(803),
    [anon_sym_PERCENT_EQ] = ACTIONS(803),
    [anon_sym_CARET_EQ] = ACTIONS(803),
    [anon_sym_AMP_EQ] = ACTIONS(803),
    [anon_sym_PIPE_EQ] = ACTIONS(803),
    [anon_sym_GT_GT_EQ] = ACTIONS(803),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(803),
    [anon_sym_LT_LT_EQ] = ACTIONS(803),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(803),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(803),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(803),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(803),
    [anon_sym_QMARK] = ACTIONS(1225),
    [anon_sym_AMP_AMP] = ACTIONS(780),
    [anon_sym_PIPE_PIPE] = ACTIONS(780),
    [anon_sym_GT_GT] = ACTIONS(780),
    [anon_sym_GT_GT_GT] = ACTIONS(780),
    [anon_sym_LT_LT] = ACTIONS(780),
    [anon_sym_AMP] = ACTIONS(780),
    [anon_sym_CARET] = ACTIONS(780),
    [anon_sym_PIPE] = ACTIONS(780),
    [anon_sym_PLUS] = ACTIONS(780),
    [anon_sym_DASH] = ACTIONS(780),
    [anon_sym_PERCENT] = ACTIONS(780),
    [anon_sym_STAR_STAR] = ACTIONS(780),
    [anon_sym_LT_EQ] = ACTIONS(813),
    [anon_sym_EQ_EQ] = ACTIONS(780),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(813),
    [anon_sym_BANG_EQ] = ACTIONS(780),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(813),
    [anon_sym_GT_EQ] = ACTIONS(813),
    [anon_sym_QMARK_QMARK] = ACTIONS(780),
    [anon_sym_instanceof] = ACTIONS(813),
    [anon_sym_PLUS_PLUS] = ACTIONS(813),
    [anon_sym_DASH_DASH] = ACTIONS(813),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(813),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_abstract] = ACTIONS(1236),
    [anon_sym_declare] = ACTIONS(1238),
    [anon_sym_module] = ACTIONS(1262),
    [anon_sym_global] = ACTIONS(1264),
    [anon_sym_interface] = ACTIONS(1242),
    [anon_sym_enum] = ACTIONS(1244),
    [sym__automatic_semicolon] = ACTIONS(813),
  },
  [136] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(884),
    [sym__expression] = STATE(1344),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1283),
    [sym_array] = STATE(1281),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3336),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(884),
    [sym_subscript_expression] = STATE(884),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1964),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_spread_element] = STATE(2824),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(860),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(414),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [aux_sym_array_repeat1] = STATE(2825),
    [sym_identifier] = ACTIONS(831),
    [anon_sym_export] = ACTIONS(503),
    [anon_sym_namespace] = ACTIONS(505),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_COMMA] = ACTIONS(1147),
    [anon_sym_type] = ACTIONS(503),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(437),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_RPAREN] = ACTIONS(1276),
    [anon_sym_await] = ACTIONS(443),
    [anon_sym_yield] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(849),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(851),
    [anon_sym_TILDE] = ACTIONS(437),
    [anon_sym_void] = ACTIONS(471),
    [anon_sym_delete] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(473),
    [anon_sym_DASH_DASH] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(503),
    [anon_sym_get] = ACTIONS(503),
    [anon_sym_set] = ACTIONS(503),
    [anon_sym_declare] = ACTIONS(503),
    [anon_sym_public] = ACTIONS(503),
    [anon_sym_private] = ACTIONS(503),
    [anon_sym_protected] = ACTIONS(503),
    [anon_sym_module] = ACTIONS(503),
    [anon_sym_any] = ACTIONS(503),
    [anon_sym_number] = ACTIONS(503),
    [anon_sym_boolean] = ACTIONS(503),
    [anon_sym_string] = ACTIONS(503),
    [anon_sym_symbol] = ACTIONS(503),
    [sym_readonly] = ACTIONS(503),
  },
  [137] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(884),
    [sym__expression] = STATE(1252),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1283),
    [sym_array] = STATE(1281),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3336),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(884),
    [sym_subscript_expression] = STATE(884),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1964),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_spread_element] = STATE(2788),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(860),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(414),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [aux_sym_array_repeat1] = STATE(2789),
    [sym_identifier] = ACTIONS(831),
    [anon_sym_export] = ACTIONS(503),
    [anon_sym_namespace] = ACTIONS(505),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_COMMA] = ACTIONS(1147),
    [anon_sym_type] = ACTIONS(503),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(437),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(443),
    [anon_sym_yield] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_RBRACK] = ACTIONS(1250),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(849),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(851),
    [anon_sym_TILDE] = ACTIONS(437),
    [anon_sym_void] = ACTIONS(471),
    [anon_sym_delete] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(473),
    [anon_sym_DASH_DASH] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(503),
    [anon_sym_get] = ACTIONS(503),
    [anon_sym_set] = ACTIONS(503),
    [anon_sym_declare] = ACTIONS(503),
    [anon_sym_public] = ACTIONS(503),
    [anon_sym_private] = ACTIONS(503),
    [anon_sym_protected] = ACTIONS(503),
    [anon_sym_module] = ACTIONS(503),
    [anon_sym_any] = ACTIONS(503),
    [anon_sym_number] = ACTIONS(503),
    [anon_sym_boolean] = ACTIONS(503),
    [anon_sym_string] = ACTIONS(503),
    [anon_sym_symbol] = ACTIONS(503),
    [sym_readonly] = ACTIONS(503),
  },
  [138] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(884),
    [sym__expression] = STATE(1310),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1283),
    [sym_array] = STATE(1281),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3336),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(884),
    [sym_subscript_expression] = STATE(884),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1964),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_spread_element] = STATE(2899),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(860),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(414),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [aux_sym_array_repeat1] = STATE(2898),
    [sym_identifier] = ACTIONS(831),
    [anon_sym_export] = ACTIONS(503),
    [anon_sym_namespace] = ACTIONS(505),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_COMMA] = ACTIONS(1147),
    [anon_sym_type] = ACTIONS(503),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(437),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(443),
    [anon_sym_yield] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_RBRACK] = ACTIONS(1278),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(849),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(851),
    [anon_sym_TILDE] = ACTIONS(437),
    [anon_sym_void] = ACTIONS(471),
    [anon_sym_delete] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(473),
    [anon_sym_DASH_DASH] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(503),
    [anon_sym_get] = ACTIONS(503),
    [anon_sym_set] = ACTIONS(503),
    [anon_sym_declare] = ACTIONS(503),
    [anon_sym_public] = ACTIONS(503),
    [anon_sym_private] = ACTIONS(503),
    [anon_sym_protected] = ACTIONS(503),
    [anon_sym_module] = ACTIONS(503),
    [anon_sym_any] = ACTIONS(503),
    [anon_sym_number] = ACTIONS(503),
    [anon_sym_boolean] = ACTIONS(503),
    [anon_sym_string] = ACTIONS(503),
    [anon_sym_symbol] = ACTIONS(503),
    [sym_readonly] = ACTIONS(503),
  },
  [139] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(884),
    [sym__expression] = STATE(1320),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1283),
    [sym_array] = STATE(1281),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3336),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(884),
    [sym_subscript_expression] = STATE(884),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1964),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_spread_element] = STATE(2862),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(860),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(414),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [aux_sym_array_repeat1] = STATE(2863),
    [sym_identifier] = ACTIONS(831),
    [anon_sym_export] = ACTIONS(503),
    [anon_sym_namespace] = ACTIONS(505),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_COMMA] = ACTIONS(1147),
    [anon_sym_type] = ACTIONS(503),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(437),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_RPAREN] = ACTIONS(1280),
    [anon_sym_await] = ACTIONS(443),
    [anon_sym_yield] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(849),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(851),
    [anon_sym_TILDE] = ACTIONS(437),
    [anon_sym_void] = ACTIONS(471),
    [anon_sym_delete] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(473),
    [anon_sym_DASH_DASH] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(503),
    [anon_sym_get] = ACTIONS(503),
    [anon_sym_set] = ACTIONS(503),
    [anon_sym_declare] = ACTIONS(503),
    [anon_sym_public] = ACTIONS(503),
    [anon_sym_private] = ACTIONS(503),
    [anon_sym_protected] = ACTIONS(503),
    [anon_sym_module] = ACTIONS(503),
    [anon_sym_any] = ACTIONS(503),
    [anon_sym_number] = ACTIONS(503),
    [anon_sym_boolean] = ACTIONS(503),
    [anon_sym_string] = ACTIONS(503),
    [anon_sym_symbol] = ACTIONS(503),
    [sym_readonly] = ACTIONS(503),
  },
  [140] = {
    [sym_import] = STATE(1528),
    [sym_parenthesized_expression] = STATE(933),
    [sym__expression] = STATE(1148),
    [sym_yield_expression] = STATE(1543),
    [sym_object] = STATE(1367),
    [sym_array] = STATE(1369),
    [sym_class] = STATE(1528),
    [sym_function] = STATE(1528),
    [sym_generator_function] = STATE(1528),
    [sym_arrow_function] = STATE(1528),
    [sym__call_signature] = STATE(3359),
    [sym_call_expression] = STATE(1528),
    [sym_new_expression] = STATE(1543),
    [sym_await_expression] = STATE(1543),
    [sym_member_expression] = STATE(933),
    [sym_subscript_expression] = STATE(933),
    [sym_assignment_expression] = STATE(1543),
    [sym__augmented_assignment_lhs] = STATE(1970),
    [sym_augmented_assignment_expression] = STATE(1543),
    [sym_ternary_expression] = STATE(1543),
    [sym_binary_expression] = STATE(1543),
    [sym_unary_expression] = STATE(1543),
    [sym_update_expression] = STATE(1543),
    [sym_string] = STATE(1528),
    [sym_template_string] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_meta_property] = STATE(1528),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(936),
    [sym_type_assertion] = STATE(1543),
    [sym_as_expression] = STATE(1543),
    [sym_internal_module] = STATE(1543),
    [sym_type_arguments] = STATE(381),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2726),
    [sym_identifier] = ACTIONS(855),
    [anon_sym_export] = ACTIONS(745),
    [anon_sym_namespace] = ACTIONS(747),
    [anon_sym_LBRACE] = ACTIONS(859),
    [anon_sym_COMMA] = ACTIONS(1189),
    [anon_sym_type] = ACTIONS(745),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(537),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(1189),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(549),
    [anon_sym_async] = ACTIONS(753),
    [anon_sym_function] = ACTIONS(553),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(1189),
    [anon_sym_PIPE] = ACTIONS(1189),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(745),
    [anon_sym_get] = ACTIONS(745),
    [anon_sym_set] = ACTIONS(745),
    [anon_sym_declare] = ACTIONS(745),
    [anon_sym_public] = ACTIONS(745),
    [anon_sym_private] = ACTIONS(745),
    [anon_sym_protected] = ACTIONS(745),
    [anon_sym_module] = ACTIONS(745),
    [anon_sym_any] = ACTIONS(745),
    [anon_sym_number] = ACTIONS(745),
    [anon_sym_boolean] = ACTIONS(745),
    [anon_sym_string] = ACTIONS(745),
    [anon_sym_symbol] = ACTIONS(745),
    [anon_sym_extends] = ACTIONS(1191),
    [sym_readonly] = ACTIONS(745),
  },
  [141] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(978),
    [sym__expression] = STATE(1432),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1696),
    [sym_array] = STATE(1691),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3169),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(978),
    [sym_subscript_expression] = STATE(978),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1967),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(977),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(380),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(881),
    [anon_sym_export] = ACTIONS(617),
    [anon_sym_namespace] = ACTIONS(619),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_COMMA] = ACTIONS(1189),
    [anon_sym_type] = ACTIONS(617),
    [anon_sym_typeof] = ACTIONS(639),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(625),
    [anon_sym_yield] = ACTIONS(627),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(1189),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(631),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(887),
    [anon_sym_AMP] = ACTIONS(1189),
    [anon_sym_PIPE] = ACTIONS(1189),
    [anon_sym_PLUS] = ACTIONS(889),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(623),
    [anon_sym_void] = ACTIONS(639),
    [anon_sym_delete] = ACTIONS(639),
    [anon_sym_PLUS_PLUS] = ACTIONS(641),
    [anon_sym_DASH_DASH] = ACTIONS(641),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(617),
    [anon_sym_get] = ACTIONS(617),
    [anon_sym_set] = ACTIONS(617),
    [anon_sym_declare] = ACTIONS(617),
    [anon_sym_public] = ACTIONS(617),
    [anon_sym_private] = ACTIONS(617),
    [anon_sym_protected] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(617),
    [anon_sym_any] = ACTIONS(617),
    [anon_sym_number] = ACTIONS(617),
    [anon_sym_boolean] = ACTIONS(617),
    [anon_sym_string] = ACTIONS(617),
    [anon_sym_symbol] = ACTIONS(617),
    [anon_sym_extends] = ACTIONS(1191),
    [sym_readonly] = ACTIONS(617),
  },
  [142] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(884),
    [sym__expression] = STATE(1303),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1283),
    [sym_array] = STATE(1281),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3336),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(884),
    [sym_subscript_expression] = STATE(884),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1964),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_spread_element] = STATE(2929),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(860),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(414),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [aux_sym_array_repeat1] = STATE(2931),
    [sym_identifier] = ACTIONS(831),
    [anon_sym_export] = ACTIONS(503),
    [anon_sym_namespace] = ACTIONS(505),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_COMMA] = ACTIONS(1147),
    [anon_sym_type] = ACTIONS(503),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(437),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(443),
    [anon_sym_yield] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_RBRACK] = ACTIONS(1274),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(849),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(851),
    [anon_sym_TILDE] = ACTIONS(437),
    [anon_sym_void] = ACTIONS(471),
    [anon_sym_delete] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(473),
    [anon_sym_DASH_DASH] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(503),
    [anon_sym_get] = ACTIONS(503),
    [anon_sym_set] = ACTIONS(503),
    [anon_sym_declare] = ACTIONS(503),
    [anon_sym_public] = ACTIONS(503),
    [anon_sym_private] = ACTIONS(503),
    [anon_sym_protected] = ACTIONS(503),
    [anon_sym_module] = ACTIONS(503),
    [anon_sym_any] = ACTIONS(503),
    [anon_sym_number] = ACTIONS(503),
    [anon_sym_boolean] = ACTIONS(503),
    [anon_sym_string] = ACTIONS(503),
    [anon_sym_symbol] = ACTIONS(503),
    [sym_readonly] = ACTIONS(503),
  },
  [143] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(884),
    [sym__expression] = STATE(1302),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1283),
    [sym_array] = STATE(1281),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3336),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(884),
    [sym_subscript_expression] = STATE(884),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1964),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_spread_element] = STATE(2765),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(860),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(414),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [aux_sym_array_repeat1] = STATE(2769),
    [sym_identifier] = ACTIONS(831),
    [anon_sym_export] = ACTIONS(503),
    [anon_sym_namespace] = ACTIONS(505),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_COMMA] = ACTIONS(1147),
    [anon_sym_type] = ACTIONS(503),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(437),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_RPAREN] = ACTIONS(1282),
    [anon_sym_await] = ACTIONS(443),
    [anon_sym_yield] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(849),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(851),
    [anon_sym_TILDE] = ACTIONS(437),
    [anon_sym_void] = ACTIONS(471),
    [anon_sym_delete] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(473),
    [anon_sym_DASH_DASH] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(503),
    [anon_sym_get] = ACTIONS(503),
    [anon_sym_set] = ACTIONS(503),
    [anon_sym_declare] = ACTIONS(503),
    [anon_sym_public] = ACTIONS(503),
    [anon_sym_private] = ACTIONS(503),
    [anon_sym_protected] = ACTIONS(503),
    [anon_sym_module] = ACTIONS(503),
    [anon_sym_any] = ACTIONS(503),
    [anon_sym_number] = ACTIONS(503),
    [anon_sym_boolean] = ACTIONS(503),
    [anon_sym_string] = ACTIONS(503),
    [anon_sym_symbol] = ACTIONS(503),
    [sym_readonly] = ACTIONS(503),
  },
  [144] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(884),
    [sym__expression] = STATE(1271),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1283),
    [sym_array] = STATE(1281),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3336),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(884),
    [sym_subscript_expression] = STATE(884),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1964),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_spread_element] = STATE(2796),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(860),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(414),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [aux_sym_array_repeat1] = STATE(2791),
    [sym_identifier] = ACTIONS(831),
    [anon_sym_export] = ACTIONS(503),
    [anon_sym_namespace] = ACTIONS(505),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_COMMA] = ACTIONS(1147),
    [anon_sym_type] = ACTIONS(503),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(437),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_RPAREN] = ACTIONS(1284),
    [anon_sym_await] = ACTIONS(443),
    [anon_sym_yield] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(849),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(851),
    [anon_sym_TILDE] = ACTIONS(437),
    [anon_sym_void] = ACTIONS(471),
    [anon_sym_delete] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(473),
    [anon_sym_DASH_DASH] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(503),
    [anon_sym_get] = ACTIONS(503),
    [anon_sym_set] = ACTIONS(503),
    [anon_sym_declare] = ACTIONS(503),
    [anon_sym_public] = ACTIONS(503),
    [anon_sym_private] = ACTIONS(503),
    [anon_sym_protected] = ACTIONS(503),
    [anon_sym_module] = ACTIONS(503),
    [anon_sym_any] = ACTIONS(503),
    [anon_sym_number] = ACTIONS(503),
    [anon_sym_boolean] = ACTIONS(503),
    [anon_sym_string] = ACTIONS(503),
    [anon_sym_symbol] = ACTIONS(503),
    [sym_readonly] = ACTIONS(503),
  },
  [145] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(884),
    [sym__expression] = STATE(1448),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1283),
    [sym_array] = STATE(1281),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3336),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(884),
    [sym_subscript_expression] = STATE(884),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1964),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_spread_element] = STATE(2781),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_sequence_expression] = STATE(2630),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(860),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(414),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(831),
    [anon_sym_export] = ACTIONS(503),
    [anon_sym_namespace] = ACTIONS(505),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_COMMA] = ACTIONS(1272),
    [anon_sym_type] = ACTIONS(503),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(437),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(443),
    [anon_sym_yield] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_RBRACK] = ACTIONS(1272),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(849),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(851),
    [anon_sym_TILDE] = ACTIONS(437),
    [anon_sym_void] = ACTIONS(471),
    [anon_sym_delete] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(473),
    [anon_sym_DASH_DASH] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(503),
    [anon_sym_get] = ACTIONS(503),
    [anon_sym_set] = ACTIONS(503),
    [anon_sym_declare] = ACTIONS(503),
    [anon_sym_public] = ACTIONS(503),
    [anon_sym_private] = ACTIONS(503),
    [anon_sym_protected] = ACTIONS(503),
    [anon_sym_module] = ACTIONS(503),
    [anon_sym_any] = ACTIONS(503),
    [anon_sym_number] = ACTIONS(503),
    [anon_sym_boolean] = ACTIONS(503),
    [anon_sym_string] = ACTIONS(503),
    [anon_sym_symbol] = ACTIONS(503),
    [sym_readonly] = ACTIONS(503),
  },
  [146] = {
    [sym_export_clause] = STATE(2682),
    [sym__declaration] = STATE(624),
    [sym_variable_declaration] = STATE(572),
    [sym_lexical_declaration] = STATE(572),
    [sym_class_declaration] = STATE(572),
    [sym_function_declaration] = STATE(572),
    [sym_generator_function_declaration] = STATE(572),
    [sym_decorator] = STATE(1945),
    [sym_function_signature] = STATE(621),
    [sym_ambient_declaration] = STATE(572),
    [sym_abstract_class_declaration] = STATE(572),
    [sym_module] = STATE(572),
    [sym_internal_module] = STATE(542),
    [sym_import_alias] = STATE(572),
    [sym_interface_declaration] = STATE(572),
    [sym_enum_declaration] = STATE(572),
    [sym_type_alias_declaration] = STATE(572),
    [aux_sym_export_statement_repeat1] = STATE(2373),
    [anon_sym_STAR] = ACTIONS(1193),
    [anon_sym_default] = ACTIONS(1195),
    [anon_sym_EQ] = ACTIONS(1286),
    [anon_sym_as] = ACTIONS(1199),
    [anon_sym_namespace] = ACTIONS(1201),
    [anon_sym_LBRACE] = ACTIONS(1203),
    [anon_sym_COMMA] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(1207),
    [anon_sym_import] = ACTIONS(1209),
    [anon_sym_var] = ACTIONS(1211),
    [anon_sym_let] = ACTIONS(1213),
    [anon_sym_const] = ACTIONS(1215),
    [anon_sym_BANG] = ACTIONS(780),
    [anon_sym_LPAREN] = ACTIONS(813),
    [anon_sym_in] = ACTIONS(780),
    [anon_sym_SEMI] = ACTIONS(813),
    [anon_sym_COLON] = ACTIONS(1288),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_LT] = ACTIONS(780),
    [anon_sym_GT] = ACTIONS(780),
    [anon_sym_SLASH] = ACTIONS(780),
    [anon_sym_DOT] = ACTIONS(1228),
    [anon_sym_class] = ACTIONS(1230),
    [anon_sym_async] = ACTIONS(1232),
    [anon_sym_function] = ACTIONS(1234),
    [anon_sym_EQ_GT] = ACTIONS(929),
    [anon_sym_QMARK_DOT] = ACTIONS(931),
    [anon_sym_PLUS_EQ] = ACTIONS(803),
    [anon_sym_DASH_EQ] = ACTIONS(803),
    [anon_sym_STAR_EQ] = ACTIONS(803),
    [anon_sym_SLASH_EQ] = ACTIONS(803),
    [anon_sym_PERCENT_EQ] = ACTIONS(803),
    [anon_sym_CARET_EQ] = ACTIONS(803),
    [anon_sym_AMP_EQ] = ACTIONS(803),
    [anon_sym_PIPE_EQ] = ACTIONS(803),
    [anon_sym_GT_GT_EQ] = ACTIONS(803),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(803),
    [anon_sym_LT_LT_EQ] = ACTIONS(803),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(803),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(803),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(803),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(803),
    [anon_sym_QMARK] = ACTIONS(780),
    [anon_sym_AMP_AMP] = ACTIONS(780),
    [anon_sym_PIPE_PIPE] = ACTIONS(780),
    [anon_sym_GT_GT] = ACTIONS(780),
    [anon_sym_GT_GT_GT] = ACTIONS(780),
    [anon_sym_LT_LT] = ACTIONS(780),
    [anon_sym_AMP] = ACTIONS(780),
    [anon_sym_CARET] = ACTIONS(780),
    [anon_sym_PIPE] = ACTIONS(780),
    [anon_sym_PLUS] = ACTIONS(780),
    [anon_sym_DASH] = ACTIONS(780),
    [anon_sym_PERCENT] = ACTIONS(780),
    [anon_sym_STAR_STAR] = ACTIONS(780),
    [anon_sym_LT_EQ] = ACTIONS(813),
    [anon_sym_EQ_EQ] = ACTIONS(780),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(813),
    [anon_sym_BANG_EQ] = ACTIONS(780),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(813),
    [anon_sym_GT_EQ] = ACTIONS(813),
    [anon_sym_QMARK_QMARK] = ACTIONS(780),
    [anon_sym_instanceof] = ACTIONS(813),
    [anon_sym_PLUS_PLUS] = ACTIONS(813),
    [anon_sym_DASH_DASH] = ACTIONS(813),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(813),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_abstract] = ACTIONS(1236),
    [anon_sym_declare] = ACTIONS(1238),
    [anon_sym_module] = ACTIONS(1240),
    [anon_sym_interface] = ACTIONS(1242),
    [anon_sym_enum] = ACTIONS(1244),
    [sym__automatic_semicolon] = ACTIONS(813),
  },
  [147] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(884),
    [sym__expression] = STATE(1331),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1283),
    [sym_array] = STATE(1281),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3336),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(884),
    [sym_subscript_expression] = STATE(884),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1964),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_spread_element] = STATE(2788),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(860),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(414),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [aux_sym_array_repeat1] = STATE(2789),
    [sym_identifier] = ACTIONS(831),
    [anon_sym_export] = ACTIONS(503),
    [anon_sym_namespace] = ACTIONS(505),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_COMMA] = ACTIONS(1147),
    [anon_sym_type] = ACTIONS(503),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(437),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(443),
    [anon_sym_yield] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_RBRACK] = ACTIONS(1250),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(849),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(851),
    [anon_sym_TILDE] = ACTIONS(437),
    [anon_sym_void] = ACTIONS(471),
    [anon_sym_delete] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(473),
    [anon_sym_DASH_DASH] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(503),
    [anon_sym_get] = ACTIONS(503),
    [anon_sym_set] = ACTIONS(503),
    [anon_sym_declare] = ACTIONS(503),
    [anon_sym_public] = ACTIONS(503),
    [anon_sym_private] = ACTIONS(503),
    [anon_sym_protected] = ACTIONS(503),
    [anon_sym_module] = ACTIONS(503),
    [anon_sym_any] = ACTIONS(503),
    [anon_sym_number] = ACTIONS(503),
    [anon_sym_boolean] = ACTIONS(503),
    [anon_sym_string] = ACTIONS(503),
    [anon_sym_symbol] = ACTIONS(503),
    [sym_readonly] = ACTIONS(503),
  },
  [148] = {
    [sym_export_clause] = STATE(2682),
    [sym__declaration] = STATE(624),
    [sym_variable_declaration] = STATE(572),
    [sym_lexical_declaration] = STATE(572),
    [sym_class_declaration] = STATE(572),
    [sym_function_declaration] = STATE(572),
    [sym_generator_function_declaration] = STATE(572),
    [sym_decorator] = STATE(1945),
    [sym_function_signature] = STATE(621),
    [sym_ambient_declaration] = STATE(572),
    [sym_abstract_class_declaration] = STATE(572),
    [sym_module] = STATE(572),
    [sym_internal_module] = STATE(542),
    [sym_import_alias] = STATE(572),
    [sym_interface_declaration] = STATE(572),
    [sym_enum_declaration] = STATE(572),
    [sym_type_alias_declaration] = STATE(572),
    [aux_sym_export_statement_repeat1] = STATE(2373),
    [anon_sym_STAR] = ACTIONS(1193),
    [anon_sym_default] = ACTIONS(1195),
    [anon_sym_EQ] = ACTIONS(1286),
    [anon_sym_as] = ACTIONS(1199),
    [anon_sym_namespace] = ACTIONS(1201),
    [anon_sym_LBRACE] = ACTIONS(1203),
    [anon_sym_COMMA] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(1207),
    [anon_sym_import] = ACTIONS(1209),
    [anon_sym_var] = ACTIONS(1211),
    [anon_sym_let] = ACTIONS(1213),
    [anon_sym_const] = ACTIONS(1215),
    [anon_sym_BANG] = ACTIONS(780),
    [anon_sym_LPAREN] = ACTIONS(813),
    [anon_sym_in] = ACTIONS(780),
    [anon_sym_SEMI] = ACTIONS(813),
    [anon_sym_COLON] = ACTIONS(1290),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_LT] = ACTIONS(780),
    [anon_sym_GT] = ACTIONS(780),
    [anon_sym_SLASH] = ACTIONS(780),
    [anon_sym_DOT] = ACTIONS(1228),
    [anon_sym_class] = ACTIONS(1230),
    [anon_sym_async] = ACTIONS(1232),
    [anon_sym_function] = ACTIONS(1234),
    [anon_sym_EQ_GT] = ACTIONS(929),
    [anon_sym_QMARK_DOT] = ACTIONS(931),
    [anon_sym_PLUS_EQ] = ACTIONS(803),
    [anon_sym_DASH_EQ] = ACTIONS(803),
    [anon_sym_STAR_EQ] = ACTIONS(803),
    [anon_sym_SLASH_EQ] = ACTIONS(803),
    [anon_sym_PERCENT_EQ] = ACTIONS(803),
    [anon_sym_CARET_EQ] = ACTIONS(803),
    [anon_sym_AMP_EQ] = ACTIONS(803),
    [anon_sym_PIPE_EQ] = ACTIONS(803),
    [anon_sym_GT_GT_EQ] = ACTIONS(803),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(803),
    [anon_sym_LT_LT_EQ] = ACTIONS(803),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(803),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(803),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(803),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(803),
    [anon_sym_QMARK] = ACTIONS(780),
    [anon_sym_AMP_AMP] = ACTIONS(780),
    [anon_sym_PIPE_PIPE] = ACTIONS(780),
    [anon_sym_GT_GT] = ACTIONS(780),
    [anon_sym_GT_GT_GT] = ACTIONS(780),
    [anon_sym_LT_LT] = ACTIONS(780),
    [anon_sym_AMP] = ACTIONS(780),
    [anon_sym_CARET] = ACTIONS(780),
    [anon_sym_PIPE] = ACTIONS(780),
    [anon_sym_PLUS] = ACTIONS(780),
    [anon_sym_DASH] = ACTIONS(780),
    [anon_sym_PERCENT] = ACTIONS(780),
    [anon_sym_STAR_STAR] = ACTIONS(780),
    [anon_sym_LT_EQ] = ACTIONS(813),
    [anon_sym_EQ_EQ] = ACTIONS(780),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(813),
    [anon_sym_BANG_EQ] = ACTIONS(780),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(813),
    [anon_sym_GT_EQ] = ACTIONS(813),
    [anon_sym_QMARK_QMARK] = ACTIONS(780),
    [anon_sym_instanceof] = ACTIONS(813),
    [anon_sym_PLUS_PLUS] = ACTIONS(813),
    [anon_sym_DASH_DASH] = ACTIONS(813),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(813),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_abstract] = ACTIONS(1236),
    [anon_sym_declare] = ACTIONS(1292),
    [anon_sym_module] = ACTIONS(1240),
    [anon_sym_interface] = ACTIONS(1242),
    [anon_sym_enum] = ACTIONS(1244),
    [sym__automatic_semicolon] = ACTIONS(813),
  },
  [149] = {
    [sym_import] = STATE(1528),
    [sym_expression_statement] = STATE(168),
    [sym_empty_statement] = STATE(168),
    [sym_parenthesized_expression] = STATE(933),
    [sym__expression] = STATE(1345),
    [sym_yield_expression] = STATE(1543),
    [sym_object] = STATE(1367),
    [sym_array] = STATE(1369),
    [sym_class] = STATE(1528),
    [sym_function] = STATE(1528),
    [sym_generator_function] = STATE(1528),
    [sym_arrow_function] = STATE(1528),
    [sym__call_signature] = STATE(3359),
    [sym_call_expression] = STATE(1528),
    [sym_new_expression] = STATE(1543),
    [sym_await_expression] = STATE(1543),
    [sym_member_expression] = STATE(933),
    [sym_subscript_expression] = STATE(933),
    [sym_assignment_expression] = STATE(1543),
    [sym__augmented_assignment_lhs] = STATE(1970),
    [sym_augmented_assignment_expression] = STATE(1543),
    [sym_ternary_expression] = STATE(1543),
    [sym_binary_expression] = STATE(1543),
    [sym_unary_expression] = STATE(1543),
    [sym_update_expression] = STATE(1543),
    [sym_sequence_expression] = STATE(3070),
    [sym_string] = STATE(1528),
    [sym_template_string] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_meta_property] = STATE(1528),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(936),
    [sym_type_assertion] = STATE(1543),
    [sym_as_expression] = STATE(1543),
    [sym_internal_module] = STATE(1543),
    [sym_type_arguments] = STATE(381),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2726),
    [sym_identifier] = ACTIONS(855),
    [anon_sym_export] = ACTIONS(745),
    [anon_sym_namespace] = ACTIONS(747),
    [anon_sym_LBRACE] = ACTIONS(859),
    [anon_sym_type] = ACTIONS(745),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(537),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(549),
    [anon_sym_async] = ACTIONS(753),
    [anon_sym_function] = ACTIONS(553),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(745),
    [anon_sym_get] = ACTIONS(745),
    [anon_sym_set] = ACTIONS(745),
    [anon_sym_declare] = ACTIONS(745),
    [anon_sym_public] = ACTIONS(745),
    [anon_sym_private] = ACTIONS(745),
    [anon_sym_protected] = ACTIONS(745),
    [anon_sym_module] = ACTIONS(745),
    [anon_sym_any] = ACTIONS(745),
    [anon_sym_number] = ACTIONS(745),
    [anon_sym_boolean] = ACTIONS(745),
    [anon_sym_string] = ACTIONS(745),
    [anon_sym_symbol] = ACTIONS(745),
    [sym_readonly] = ACTIONS(745),
  },
  [150] = {
    [sym_import] = STATE(1528),
    [sym_expression_statement] = STATE(167),
    [sym_empty_statement] = STATE(167),
    [sym_parenthesized_expression] = STATE(933),
    [sym__expression] = STATE(1345),
    [sym_yield_expression] = STATE(1543),
    [sym_object] = STATE(1367),
    [sym_array] = STATE(1369),
    [sym_class] = STATE(1528),
    [sym_function] = STATE(1528),
    [sym_generator_function] = STATE(1528),
    [sym_arrow_function] = STATE(1528),
    [sym__call_signature] = STATE(3359),
    [sym_call_expression] = STATE(1528),
    [sym_new_expression] = STATE(1543),
    [sym_await_expression] = STATE(1543),
    [sym_member_expression] = STATE(933),
    [sym_subscript_expression] = STATE(933),
    [sym_assignment_expression] = STATE(1543),
    [sym__augmented_assignment_lhs] = STATE(1970),
    [sym_augmented_assignment_expression] = STATE(1543),
    [sym_ternary_expression] = STATE(1543),
    [sym_binary_expression] = STATE(1543),
    [sym_unary_expression] = STATE(1543),
    [sym_update_expression] = STATE(1543),
    [sym_sequence_expression] = STATE(3070),
    [sym_string] = STATE(1528),
    [sym_template_string] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_meta_property] = STATE(1528),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(936),
    [sym_type_assertion] = STATE(1543),
    [sym_as_expression] = STATE(1543),
    [sym_internal_module] = STATE(1543),
    [sym_type_arguments] = STATE(381),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2726),
    [sym_identifier] = ACTIONS(855),
    [anon_sym_export] = ACTIONS(745),
    [anon_sym_namespace] = ACTIONS(747),
    [anon_sym_LBRACE] = ACTIONS(859),
    [anon_sym_type] = ACTIONS(745),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(537),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(549),
    [anon_sym_async] = ACTIONS(753),
    [anon_sym_function] = ACTIONS(553),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(745),
    [anon_sym_get] = ACTIONS(745),
    [anon_sym_set] = ACTIONS(745),
    [anon_sym_declare] = ACTIONS(745),
    [anon_sym_public] = ACTIONS(745),
    [anon_sym_private] = ACTIONS(745),
    [anon_sym_protected] = ACTIONS(745),
    [anon_sym_module] = ACTIONS(745),
    [anon_sym_any] = ACTIONS(745),
    [anon_sym_number] = ACTIONS(745),
    [anon_sym_boolean] = ACTIONS(745),
    [anon_sym_string] = ACTIONS(745),
    [anon_sym_symbol] = ACTIONS(745),
    [sym_readonly] = ACTIONS(745),
  },
  [151] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(965),
    [sym__expression] = STATE(1215),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1524),
    [sym_array] = STATE(1523),
    [sym_nested_identifier] = STATE(3297),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3348),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(965),
    [sym_subscript_expression] = STATE(965),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1969),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(975),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_nested_type_identifier] = STATE(2283),
    [sym_generic_type] = STATE(2652),
    [sym_type_arguments] = STATE(302),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(1294),
    [anon_sym_export] = ACTIONS(713),
    [anon_sym_namespace] = ACTIONS(715),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_type] = ACTIONS(713),
    [anon_sym_typeof] = ACTIONS(735),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(719),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(721),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(725),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(727),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(907),
    [anon_sym_PLUS] = ACTIONS(909),
    [anon_sym_DASH] = ACTIONS(909),
    [anon_sym_TILDE] = ACTIONS(719),
    [anon_sym_void] = ACTIONS(735),
    [anon_sym_delete] = ACTIONS(735),
    [anon_sym_PLUS_PLUS] = ACTIONS(737),
    [anon_sym_DASH_DASH] = ACTIONS(737),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(713),
    [anon_sym_get] = ACTIONS(713),
    [anon_sym_set] = ACTIONS(713),
    [anon_sym_declare] = ACTIONS(713),
    [anon_sym_public] = ACTIONS(713),
    [anon_sym_private] = ACTIONS(713),
    [anon_sym_protected] = ACTIONS(713),
    [anon_sym_module] = ACTIONS(713),
    [anon_sym_any] = ACTIONS(713),
    [anon_sym_number] = ACTIONS(713),
    [anon_sym_boolean] = ACTIONS(713),
    [anon_sym_string] = ACTIONS(713),
    [anon_sym_symbol] = ACTIONS(713),
    [sym_readonly] = ACTIONS(713),
  },
  [152] = {
    [sym__declaration] = STATE(557),
    [sym_variable_declaration] = STATE(572),
    [sym_lexical_declaration] = STATE(572),
    [sym_class_declaration] = STATE(572),
    [sym_function_declaration] = STATE(572),
    [sym_generator_function_declaration] = STATE(572),
    [sym_decorator] = STATE(1945),
    [sym_function_signature] = STATE(572),
    [sym_ambient_declaration] = STATE(572),
    [sym_abstract_class_declaration] = STATE(572),
    [sym_module] = STATE(572),
    [sym_internal_module] = STATE(542),
    [sym_import_alias] = STATE(572),
    [sym_interface_declaration] = STATE(572),
    [sym_enum_declaration] = STATE(572),
    [sym_type_alias_declaration] = STATE(572),
    [aux_sym_export_statement_repeat1] = STATE(2373),
    [anon_sym_STAR] = ACTIONS(780),
    [anon_sym_EQ] = ACTIONS(923),
    [anon_sym_as] = ACTIONS(780),
    [anon_sym_namespace] = ACTIONS(1201),
    [anon_sym_COMMA] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(1207),
    [anon_sym_import] = ACTIONS(1209),
    [anon_sym_var] = ACTIONS(1211),
    [anon_sym_let] = ACTIONS(1213),
    [anon_sym_const] = ACTIONS(1215),
    [anon_sym_BANG] = ACTIONS(780),
    [anon_sym_LPAREN] = ACTIONS(813),
    [anon_sym_in] = ACTIONS(780),
    [anon_sym_SEMI] = ACTIONS(813),
    [anon_sym_COLON] = ACTIONS(1290),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_LT] = ACTIONS(780),
    [anon_sym_GT] = ACTIONS(780),
    [anon_sym_SLASH] = ACTIONS(780),
    [anon_sym_DOT] = ACTIONS(1228),
    [anon_sym_class] = ACTIONS(1230),
    [anon_sym_async] = ACTIONS(1232),
    [anon_sym_function] = ACTIONS(1234),
    [anon_sym_EQ_GT] = ACTIONS(929),
    [anon_sym_QMARK_DOT] = ACTIONS(931),
    [anon_sym_PLUS_EQ] = ACTIONS(803),
    [anon_sym_DASH_EQ] = ACTIONS(803),
    [anon_sym_STAR_EQ] = ACTIONS(803),
    [anon_sym_SLASH_EQ] = ACTIONS(803),
    [anon_sym_PERCENT_EQ] = ACTIONS(803),
    [anon_sym_CARET_EQ] = ACTIONS(803),
    [anon_sym_AMP_EQ] = ACTIONS(803),
    [anon_sym_PIPE_EQ] = ACTIONS(803),
    [anon_sym_GT_GT_EQ] = ACTIONS(803),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(803),
    [anon_sym_LT_LT_EQ] = ACTIONS(803),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(803),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(803),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(803),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(803),
    [anon_sym_QMARK] = ACTIONS(780),
    [anon_sym_AMP_AMP] = ACTIONS(780),
    [anon_sym_PIPE_PIPE] = ACTIONS(780),
    [anon_sym_GT_GT] = ACTIONS(780),
    [anon_sym_GT_GT_GT] = ACTIONS(780),
    [anon_sym_LT_LT] = ACTIONS(780),
    [anon_sym_AMP] = ACTIONS(780),
    [anon_sym_CARET] = ACTIONS(780),
    [anon_sym_PIPE] = ACTIONS(780),
    [anon_sym_PLUS] = ACTIONS(780),
    [anon_sym_DASH] = ACTIONS(780),
    [anon_sym_PERCENT] = ACTIONS(780),
    [anon_sym_STAR_STAR] = ACTIONS(780),
    [anon_sym_LT_EQ] = ACTIONS(813),
    [anon_sym_EQ_EQ] = ACTIONS(780),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(813),
    [anon_sym_BANG_EQ] = ACTIONS(780),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(813),
    [anon_sym_GT_EQ] = ACTIONS(813),
    [anon_sym_QMARK_QMARK] = ACTIONS(780),
    [anon_sym_instanceof] = ACTIONS(813),
    [anon_sym_PLUS_PLUS] = ACTIONS(813),
    [anon_sym_DASH_DASH] = ACTIONS(813),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(813),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_abstract] = ACTIONS(1236),
    [anon_sym_declare] = ACTIONS(1292),
    [anon_sym_module] = ACTIONS(1296),
    [anon_sym_global] = ACTIONS(1264),
    [anon_sym_interface] = ACTIONS(1242),
    [anon_sym_enum] = ACTIONS(1244),
    [sym__automatic_semicolon] = ACTIONS(813),
  },
  [153] = {
    [sym__declaration] = STATE(557),
    [sym_variable_declaration] = STATE(572),
    [sym_lexical_declaration] = STATE(572),
    [sym_class_declaration] = STATE(572),
    [sym_function_declaration] = STATE(572),
    [sym_generator_function_declaration] = STATE(572),
    [sym_decorator] = STATE(1945),
    [sym_function_signature] = STATE(572),
    [sym_ambient_declaration] = STATE(572),
    [sym_abstract_class_declaration] = STATE(572),
    [sym_module] = STATE(572),
    [sym_internal_module] = STATE(542),
    [sym_import_alias] = STATE(572),
    [sym_interface_declaration] = STATE(572),
    [sym_enum_declaration] = STATE(572),
    [sym_type_alias_declaration] = STATE(572),
    [aux_sym_export_statement_repeat1] = STATE(2373),
    [anon_sym_STAR] = ACTIONS(780),
    [anon_sym_EQ] = ACTIONS(923),
    [anon_sym_as] = ACTIONS(780),
    [anon_sym_namespace] = ACTIONS(1201),
    [anon_sym_COMMA] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(1207),
    [anon_sym_import] = ACTIONS(1209),
    [anon_sym_var] = ACTIONS(1211),
    [anon_sym_let] = ACTIONS(1213),
    [anon_sym_const] = ACTIONS(1215),
    [anon_sym_BANG] = ACTIONS(780),
    [anon_sym_LPAREN] = ACTIONS(813),
    [anon_sym_in] = ACTIONS(780),
    [anon_sym_SEMI] = ACTIONS(813),
    [anon_sym_COLON] = ACTIONS(1288),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_LT] = ACTIONS(780),
    [anon_sym_GT] = ACTIONS(780),
    [anon_sym_SLASH] = ACTIONS(780),
    [anon_sym_DOT] = ACTIONS(1228),
    [anon_sym_class] = ACTIONS(1230),
    [anon_sym_async] = ACTIONS(1232),
    [anon_sym_function] = ACTIONS(1234),
    [anon_sym_EQ_GT] = ACTIONS(929),
    [anon_sym_QMARK_DOT] = ACTIONS(931),
    [anon_sym_PLUS_EQ] = ACTIONS(803),
    [anon_sym_DASH_EQ] = ACTIONS(803),
    [anon_sym_STAR_EQ] = ACTIONS(803),
    [anon_sym_SLASH_EQ] = ACTIONS(803),
    [anon_sym_PERCENT_EQ] = ACTIONS(803),
    [anon_sym_CARET_EQ] = ACTIONS(803),
    [anon_sym_AMP_EQ] = ACTIONS(803),
    [anon_sym_PIPE_EQ] = ACTIONS(803),
    [anon_sym_GT_GT_EQ] = ACTIONS(803),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(803),
    [anon_sym_LT_LT_EQ] = ACTIONS(803),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(803),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(803),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(803),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(803),
    [anon_sym_QMARK] = ACTIONS(780),
    [anon_sym_AMP_AMP] = ACTIONS(780),
    [anon_sym_PIPE_PIPE] = ACTIONS(780),
    [anon_sym_GT_GT] = ACTIONS(780),
    [anon_sym_GT_GT_GT] = ACTIONS(780),
    [anon_sym_LT_LT] = ACTIONS(780),
    [anon_sym_AMP] = ACTIONS(780),
    [anon_sym_CARET] = ACTIONS(780),
    [anon_sym_PIPE] = ACTIONS(780),
    [anon_sym_PLUS] = ACTIONS(780),
    [anon_sym_DASH] = ACTIONS(780),
    [anon_sym_PERCENT] = ACTIONS(780),
    [anon_sym_STAR_STAR] = ACTIONS(780),
    [anon_sym_LT_EQ] = ACTIONS(813),
    [anon_sym_EQ_EQ] = ACTIONS(780),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(813),
    [anon_sym_BANG_EQ] = ACTIONS(780),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(813),
    [anon_sym_GT_EQ] = ACTIONS(813),
    [anon_sym_QMARK_QMARK] = ACTIONS(780),
    [anon_sym_instanceof] = ACTIONS(813),
    [anon_sym_PLUS_PLUS] = ACTIONS(813),
    [anon_sym_DASH_DASH] = ACTIONS(813),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(813),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_abstract] = ACTIONS(1236),
    [anon_sym_declare] = ACTIONS(1238),
    [anon_sym_module] = ACTIONS(1262),
    [anon_sym_global] = ACTIONS(1264),
    [anon_sym_interface] = ACTIONS(1242),
    [anon_sym_enum] = ACTIONS(1244),
    [sym__automatic_semicolon] = ACTIONS(813),
  },
  [154] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(965),
    [sym__expression] = STATE(1268),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1524),
    [sym_array] = STATE(1523),
    [sym_nested_identifier] = STATE(3297),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3348),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(965),
    [sym_subscript_expression] = STATE(965),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1969),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(975),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_nested_type_identifier] = STATE(2599),
    [sym_generic_type] = STATE(2883),
    [sym_type_arguments] = STATE(302),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(1298),
    [anon_sym_export] = ACTIONS(713),
    [anon_sym_namespace] = ACTIONS(715),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_type] = ACTIONS(713),
    [anon_sym_typeof] = ACTIONS(735),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(719),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(721),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(725),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(727),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(907),
    [anon_sym_PLUS] = ACTIONS(909),
    [anon_sym_DASH] = ACTIONS(909),
    [anon_sym_TILDE] = ACTIONS(719),
    [anon_sym_void] = ACTIONS(735),
    [anon_sym_delete] = ACTIONS(735),
    [anon_sym_PLUS_PLUS] = ACTIONS(737),
    [anon_sym_DASH_DASH] = ACTIONS(737),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(713),
    [anon_sym_get] = ACTIONS(713),
    [anon_sym_set] = ACTIONS(713),
    [anon_sym_declare] = ACTIONS(713),
    [anon_sym_public] = ACTIONS(713),
    [anon_sym_private] = ACTIONS(713),
    [anon_sym_protected] = ACTIONS(713),
    [anon_sym_module] = ACTIONS(713),
    [anon_sym_any] = ACTIONS(713),
    [anon_sym_number] = ACTIONS(713),
    [anon_sym_boolean] = ACTIONS(713),
    [anon_sym_string] = ACTIONS(713),
    [anon_sym_symbol] = ACTIONS(713),
    [sym_readonly] = ACTIONS(713),
  },
  [155] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(963),
    [sym__expression] = STATE(1190),
    [sym_yield_expression] = STATE(1722),
    [sym_object] = STATE(1536),
    [sym_array] = STATE(1535),
    [sym_nested_identifier] = STATE(3204),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(3286),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1722),
    [sym_await_expression] = STATE(1722),
    [sym_member_expression] = STATE(963),
    [sym_subscript_expression] = STATE(963),
    [sym_assignment_expression] = STATE(1722),
    [sym__augmented_assignment_lhs] = STATE(1968),
    [sym_augmented_assignment_expression] = STATE(1722),
    [sym_ternary_expression] = STATE(1722),
    [sym_binary_expression] = STATE(1722),
    [sym_unary_expression] = STATE(1722),
    [sym_update_expression] = STATE(1722),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(952),
    [sym_type_assertion] = STATE(1722),
    [sym_as_expression] = STATE(1722),
    [sym_internal_module] = STATE(1722),
    [sym_nested_type_identifier] = STATE(2272),
    [sym_generic_type] = STATE(2643),
    [sym_type_arguments] = STATE(266),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2684),
    [sym_identifier] = ACTIONS(1300),
    [anon_sym_export] = ACTIONS(655),
    [anon_sym_namespace] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(1270),
    [anon_sym_type] = ACTIONS(655),
    [anon_sym_typeof] = ACTIONS(689),
    [anon_sym_import] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_LPAREN] = ACTIONS(871),
    [anon_sym_await] = ACTIONS(669),
    [anon_sym_yield] = ACTIONS(671),
    [anon_sym_LBRACK] = ACTIONS(873),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(675),
    [anon_sym_class] = ACTIONS(677),
    [anon_sym_async] = ACTIONS(679),
    [anon_sym_function] = ACTIONS(681),
    [anon_sym_new] = ACTIONS(875),
    [anon_sym_PLUS] = ACTIONS(877),
    [anon_sym_DASH] = ACTIONS(877),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_void] = ACTIONS(689),
    [anon_sym_delete] = ACTIONS(689),
    [anon_sym_PLUS_PLUS] = ACTIONS(691),
    [anon_sym_DASH_DASH] = ACTIONS(691),
    [anon_sym_DQUOTE] = ACTIONS(693),
    [anon_sym_SQUOTE] = ACTIONS(695),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(697),
    [sym_number] = ACTIONS(879),
    [sym_this] = ACTIONS(703),
    [sym_super] = ACTIONS(703),
    [sym_true] = ACTIONS(703),
    [sym_false] = ACTIONS(703),
    [sym_null] = ACTIONS(703),
    [sym_undefined] = ACTIONS(703),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(655),
    [anon_sym_get] = ACTIONS(655),
    [anon_sym_set] = ACTIONS(655),
    [anon_sym_declare] = ACTIONS(655),
    [anon_sym_public] = ACTIONS(655),
    [anon_sym_private] = ACTIONS(655),
    [anon_sym_protected] = ACTIONS(655),
    [anon_sym_module] = ACTIONS(655),
    [anon_sym_any] = ACTIONS(655),
    [anon_sym_number] = ACTIONS(655),
    [anon_sym_boolean] = ACTIONS(655),
    [anon_sym_string] = ACTIONS(655),
    [anon_sym_symbol] = ACTIONS(655),
    [sym_readonly] = ACTIONS(655),
  },
  [156] = {
    [sym_import] = STATE(1528),
    [sym_parenthesized_expression] = STATE(933),
    [sym__expression] = STATE(1323),
    [sym_yield_expression] = STATE(1543),
    [sym_object] = STATE(1367),
    [sym_array] = STATE(1369),
    [sym_class] = STATE(1528),
    [sym_function] = STATE(1528),
    [sym_generator_function] = STATE(1528),
    [sym_arrow_function] = STATE(1528),
    [sym__call_signature] = STATE(3359),
    [sym_call_expression] = STATE(1528),
    [sym_new_expression] = STATE(1543),
    [sym_await_expression] = STATE(1543),
    [sym_member_expression] = STATE(933),
    [sym_subscript_expression] = STATE(933),
    [sym_assignment_expression] = STATE(1543),
    [sym__augmented_assignment_lhs] = STATE(1970),
    [sym_augmented_assignment_expression] = STATE(1543),
    [sym_ternary_expression] = STATE(1543),
    [sym_binary_expression] = STATE(1543),
    [sym_unary_expression] = STATE(1543),
    [sym_update_expression] = STATE(1543),
    [sym_sequence_expression] = STATE(2940),
    [sym_string] = STATE(1528),
    [sym_template_string] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_meta_property] = STATE(1528),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(936),
    [sym_type_assertion] = STATE(1543),
    [sym_as_expression] = STATE(1543),
    [sym_internal_module] = STATE(1543),
    [sym_type_arguments] = STATE(381),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2726),
    [sym_identifier] = ACTIONS(855),
    [anon_sym_export] = ACTIONS(745),
    [anon_sym_namespace] = ACTIONS(747),
    [anon_sym_LBRACE] = ACTIONS(859),
    [anon_sym_type] = ACTIONS(745),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(537),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(1302),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(549),
    [anon_sym_async] = ACTIONS(753),
    [anon_sym_function] = ACTIONS(553),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(745),
    [anon_sym_get] = ACTIONS(745),
    [anon_sym_set] = ACTIONS(745),
    [anon_sym_declare] = ACTIONS(745),
    [anon_sym_public] = ACTIONS(745),
    [anon_sym_private] = ACTIONS(745),
    [anon_sym_protected] = ACTIONS(745),
    [anon_sym_module] = ACTIONS(745),
    [anon_sym_any] = ACTIONS(745),
    [anon_sym_number] = ACTIONS(745),
    [anon_sym_boolean] = ACTIONS(745),
    [anon_sym_string] = ACTIONS(745),
    [anon_sym_symbol] = ACTIONS(745),
    [sym_readonly] = ACTIONS(745),
    [sym__automatic_semicolon] = ACTIONS(1302),
  },
  [157] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(884),
    [sym__expression] = STATE(1105),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1283),
    [sym_array] = STATE(1281),
    [sym_nested_identifier] = STATE(2008),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3336),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(884),
    [sym_subscript_expression] = STATE(884),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1964),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(860),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_nested_type_identifier] = STATE(3077),
    [sym_generic_type] = STATE(2037),
    [sym_type_arguments] = STATE(414),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(1304),
    [anon_sym_export] = ACTIONS(503),
    [anon_sym_namespace] = ACTIONS(505),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_type] = ACTIONS(503),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(437),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(443),
    [anon_sym_yield] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(849),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(851),
    [anon_sym_TILDE] = ACTIONS(437),
    [anon_sym_void] = ACTIONS(471),
    [anon_sym_delete] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(473),
    [anon_sym_DASH_DASH] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(503),
    [anon_sym_get] = ACTIONS(503),
    [anon_sym_set] = ACTIONS(503),
    [anon_sym_declare] = ACTIONS(503),
    [anon_sym_public] = ACTIONS(503),
    [anon_sym_private] = ACTIONS(503),
    [anon_sym_protected] = ACTIONS(503),
    [anon_sym_module] = ACTIONS(503),
    [anon_sym_any] = ACTIONS(503),
    [anon_sym_number] = ACTIONS(503),
    [anon_sym_boolean] = ACTIONS(503),
    [anon_sym_string] = ACTIONS(503),
    [anon_sym_symbol] = ACTIONS(503),
    [sym_readonly] = ACTIONS(503),
  },
  [158] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(978),
    [sym__expression] = STATE(1432),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1696),
    [sym_array] = STATE(1691),
    [sym_nested_identifier] = STATE(1960),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3169),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(978),
    [sym_subscript_expression] = STATE(978),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1967),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(977),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_nested_type_identifier] = STATE(3120),
    [sym_generic_type] = STATE(433),
    [sym_type_arguments] = STATE(380),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(1306),
    [anon_sym_export] = ACTIONS(617),
    [anon_sym_namespace] = ACTIONS(619),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_type] = ACTIONS(617),
    [anon_sym_typeof] = ACTIONS(639),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(625),
    [anon_sym_yield] = ACTIONS(627),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(631),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(887),
    [anon_sym_PLUS] = ACTIONS(889),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(623),
    [anon_sym_void] = ACTIONS(639),
    [anon_sym_delete] = ACTIONS(639),
    [anon_sym_PLUS_PLUS] = ACTIONS(641),
    [anon_sym_DASH_DASH] = ACTIONS(641),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(617),
    [anon_sym_get] = ACTIONS(617),
    [anon_sym_set] = ACTIONS(617),
    [anon_sym_declare] = ACTIONS(617),
    [anon_sym_public] = ACTIONS(617),
    [anon_sym_private] = ACTIONS(617),
    [anon_sym_protected] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(617),
    [anon_sym_any] = ACTIONS(617),
    [anon_sym_number] = ACTIONS(617),
    [anon_sym_boolean] = ACTIONS(617),
    [anon_sym_string] = ACTIONS(617),
    [anon_sym_symbol] = ACTIONS(617),
    [sym_readonly] = ACTIONS(617),
  },
  [159] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(963),
    [sym__expression] = STATE(1317),
    [sym_yield_expression] = STATE(1722),
    [sym_object] = STATE(1536),
    [sym_array] = STATE(1535),
    [sym_nested_identifier] = STATE(3204),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(3286),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1722),
    [sym_await_expression] = STATE(1722),
    [sym_member_expression] = STATE(963),
    [sym_subscript_expression] = STATE(963),
    [sym_assignment_expression] = STATE(1722),
    [sym__augmented_assignment_lhs] = STATE(1968),
    [sym_augmented_assignment_expression] = STATE(1722),
    [sym_ternary_expression] = STATE(1722),
    [sym_binary_expression] = STATE(1722),
    [sym_unary_expression] = STATE(1722),
    [sym_update_expression] = STATE(1722),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(952),
    [sym_type_assertion] = STATE(1722),
    [sym_as_expression] = STATE(1722),
    [sym_internal_module] = STATE(1722),
    [sym_nested_type_identifier] = STATE(2562),
    [sym_generic_type] = STATE(2817),
    [sym_type_arguments] = STATE(266),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2684),
    [sym_identifier] = ACTIONS(1308),
    [anon_sym_export] = ACTIONS(655),
    [anon_sym_namespace] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(1270),
    [anon_sym_type] = ACTIONS(655),
    [anon_sym_typeof] = ACTIONS(689),
    [anon_sym_import] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_LPAREN] = ACTIONS(871),
    [anon_sym_await] = ACTIONS(669),
    [anon_sym_yield] = ACTIONS(671),
    [anon_sym_LBRACK] = ACTIONS(873),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(675),
    [anon_sym_class] = ACTIONS(677),
    [anon_sym_async] = ACTIONS(679),
    [anon_sym_function] = ACTIONS(681),
    [anon_sym_new] = ACTIONS(875),
    [anon_sym_PLUS] = ACTIONS(877),
    [anon_sym_DASH] = ACTIONS(877),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_void] = ACTIONS(689),
    [anon_sym_delete] = ACTIONS(689),
    [anon_sym_PLUS_PLUS] = ACTIONS(691),
    [anon_sym_DASH_DASH] = ACTIONS(691),
    [anon_sym_DQUOTE] = ACTIONS(693),
    [anon_sym_SQUOTE] = ACTIONS(695),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(697),
    [sym_number] = ACTIONS(879),
    [sym_this] = ACTIONS(703),
    [sym_super] = ACTIONS(703),
    [sym_true] = ACTIONS(703),
    [sym_false] = ACTIONS(703),
    [sym_null] = ACTIONS(703),
    [sym_undefined] = ACTIONS(703),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(655),
    [anon_sym_get] = ACTIONS(655),
    [anon_sym_set] = ACTIONS(655),
    [anon_sym_declare] = ACTIONS(655),
    [anon_sym_public] = ACTIONS(655),
    [anon_sym_private] = ACTIONS(655),
    [anon_sym_protected] = ACTIONS(655),
    [anon_sym_module] = ACTIONS(655),
    [anon_sym_any] = ACTIONS(655),
    [anon_sym_number] = ACTIONS(655),
    [anon_sym_boolean] = ACTIONS(655),
    [anon_sym_string] = ACTIONS(655),
    [anon_sym_symbol] = ACTIONS(655),
    [sym_readonly] = ACTIONS(655),
  },
  [160] = {
    [sym_import] = STATE(1528),
    [sym_parenthesized_expression] = STATE(933),
    [sym__expression] = STATE(1148),
    [sym_yield_expression] = STATE(1543),
    [sym_object] = STATE(1367),
    [sym_array] = STATE(1369),
    [sym_nested_identifier] = STATE(1960),
    [sym_class] = STATE(1528),
    [sym_function] = STATE(1528),
    [sym_generator_function] = STATE(1528),
    [sym_arrow_function] = STATE(1528),
    [sym__call_signature] = STATE(3359),
    [sym_call_expression] = STATE(1528),
    [sym_new_expression] = STATE(1543),
    [sym_await_expression] = STATE(1543),
    [sym_member_expression] = STATE(933),
    [sym_subscript_expression] = STATE(933),
    [sym_assignment_expression] = STATE(1543),
    [sym__augmented_assignment_lhs] = STATE(1970),
    [sym_augmented_assignment_expression] = STATE(1543),
    [sym_ternary_expression] = STATE(1543),
    [sym_binary_expression] = STATE(1543),
    [sym_unary_expression] = STATE(1543),
    [sym_update_expression] = STATE(1543),
    [sym_string] = STATE(1528),
    [sym_template_string] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_meta_property] = STATE(1528),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(936),
    [sym_type_assertion] = STATE(1543),
    [sym_as_expression] = STATE(1543),
    [sym_internal_module] = STATE(1543),
    [sym_nested_type_identifier] = STATE(3120),
    [sym_generic_type] = STATE(433),
    [sym_type_arguments] = STATE(381),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2726),
    [sym_identifier] = ACTIONS(1310),
    [anon_sym_export] = ACTIONS(745),
    [anon_sym_namespace] = ACTIONS(747),
    [anon_sym_LBRACE] = ACTIONS(859),
    [anon_sym_type] = ACTIONS(745),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(537),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(549),
    [anon_sym_async] = ACTIONS(753),
    [anon_sym_function] = ACTIONS(553),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(745),
    [anon_sym_get] = ACTIONS(745),
    [anon_sym_set] = ACTIONS(745),
    [anon_sym_declare] = ACTIONS(745),
    [anon_sym_public] = ACTIONS(745),
    [anon_sym_private] = ACTIONS(745),
    [anon_sym_protected] = ACTIONS(745),
    [anon_sym_module] = ACTIONS(745),
    [anon_sym_any] = ACTIONS(745),
    [anon_sym_number] = ACTIONS(745),
    [anon_sym_boolean] = ACTIONS(745),
    [anon_sym_string] = ACTIONS(745),
    [anon_sym_symbol] = ACTIONS(745),
    [sym_readonly] = ACTIONS(745),
  },
  [161] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(965),
    [sym__expression] = STATE(1250),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1524),
    [sym_array] = STATE(1523),
    [sym_nested_identifier] = STATE(1960),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3348),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(965),
    [sym_subscript_expression] = STATE(965),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1969),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(975),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_nested_type_identifier] = STATE(3120),
    [sym_generic_type] = STATE(433),
    [sym_type_arguments] = STATE(302),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(1312),
    [anon_sym_export] = ACTIONS(713),
    [anon_sym_namespace] = ACTIONS(715),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_type] = ACTIONS(713),
    [anon_sym_typeof] = ACTIONS(735),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(719),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(721),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(725),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(727),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(907),
    [anon_sym_PLUS] = ACTIONS(909),
    [anon_sym_DASH] = ACTIONS(909),
    [anon_sym_TILDE] = ACTIONS(719),
    [anon_sym_void] = ACTIONS(735),
    [anon_sym_delete] = ACTIONS(735),
    [anon_sym_PLUS_PLUS] = ACTIONS(737),
    [anon_sym_DASH_DASH] = ACTIONS(737),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(713),
    [anon_sym_get] = ACTIONS(713),
    [anon_sym_set] = ACTIONS(713),
    [anon_sym_declare] = ACTIONS(713),
    [anon_sym_public] = ACTIONS(713),
    [anon_sym_private] = ACTIONS(713),
    [anon_sym_protected] = ACTIONS(713),
    [anon_sym_module] = ACTIONS(713),
    [anon_sym_any] = ACTIONS(713),
    [anon_sym_number] = ACTIONS(713),
    [anon_sym_boolean] = ACTIONS(713),
    [anon_sym_string] = ACTIONS(713),
    [anon_sym_symbol] = ACTIONS(713),
    [sym_readonly] = ACTIONS(713),
  },
  [162] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(963),
    [sym__expression] = STATE(1288),
    [sym_yield_expression] = STATE(1722),
    [sym_object] = STATE(1536),
    [sym_array] = STATE(1535),
    [sym_nested_identifier] = STATE(1960),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(3286),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1722),
    [sym_await_expression] = STATE(1722),
    [sym_member_expression] = STATE(963),
    [sym_subscript_expression] = STATE(963),
    [sym_assignment_expression] = STATE(1722),
    [sym__augmented_assignment_lhs] = STATE(1968),
    [sym_augmented_assignment_expression] = STATE(1722),
    [sym_ternary_expression] = STATE(1722),
    [sym_binary_expression] = STATE(1722),
    [sym_unary_expression] = STATE(1722),
    [sym_update_expression] = STATE(1722),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(952),
    [sym_type_assertion] = STATE(1722),
    [sym_as_expression] = STATE(1722),
    [sym_internal_module] = STATE(1722),
    [sym_nested_type_identifier] = STATE(3120),
    [sym_generic_type] = STATE(433),
    [sym_type_arguments] = STATE(266),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2684),
    [sym_identifier] = ACTIONS(1314),
    [anon_sym_export] = ACTIONS(655),
    [anon_sym_namespace] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(1270),
    [anon_sym_type] = ACTIONS(655),
    [anon_sym_typeof] = ACTIONS(689),
    [anon_sym_import] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_LPAREN] = ACTIONS(871),
    [anon_sym_await] = ACTIONS(669),
    [anon_sym_yield] = ACTIONS(671),
    [anon_sym_LBRACK] = ACTIONS(873),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(675),
    [anon_sym_class] = ACTIONS(677),
    [anon_sym_async] = ACTIONS(679),
    [anon_sym_function] = ACTIONS(681),
    [anon_sym_new] = ACTIONS(875),
    [anon_sym_PLUS] = ACTIONS(877),
    [anon_sym_DASH] = ACTIONS(877),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_void] = ACTIONS(689),
    [anon_sym_delete] = ACTIONS(689),
    [anon_sym_PLUS_PLUS] = ACTIONS(691),
    [anon_sym_DASH_DASH] = ACTIONS(691),
    [anon_sym_DQUOTE] = ACTIONS(693),
    [anon_sym_SQUOTE] = ACTIONS(695),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(697),
    [sym_number] = ACTIONS(879),
    [sym_this] = ACTIONS(703),
    [sym_super] = ACTIONS(703),
    [sym_true] = ACTIONS(703),
    [sym_false] = ACTIONS(703),
    [sym_null] = ACTIONS(703),
    [sym_undefined] = ACTIONS(703),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(655),
    [anon_sym_get] = ACTIONS(655),
    [anon_sym_set] = ACTIONS(655),
    [anon_sym_declare] = ACTIONS(655),
    [anon_sym_public] = ACTIONS(655),
    [anon_sym_private] = ACTIONS(655),
    [anon_sym_protected] = ACTIONS(655),
    [anon_sym_module] = ACTIONS(655),
    [anon_sym_any] = ACTIONS(655),
    [anon_sym_number] = ACTIONS(655),
    [anon_sym_boolean] = ACTIONS(655),
    [anon_sym_string] = ACTIONS(655),
    [anon_sym_symbol] = ACTIONS(655),
    [sym_readonly] = ACTIONS(655),
  },
  [163] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(884),
    [sym__expression] = STATE(1105),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1283),
    [sym_array] = STATE(1281),
    [sym_nested_identifier] = STATE(1960),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3336),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(884),
    [sym_subscript_expression] = STATE(884),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1964),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(860),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_nested_type_identifier] = STATE(3120),
    [sym_generic_type] = STATE(433),
    [sym_type_arguments] = STATE(414),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(1316),
    [anon_sym_export] = ACTIONS(503),
    [anon_sym_namespace] = ACTIONS(505),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_type] = ACTIONS(503),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(437),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(443),
    [anon_sym_yield] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(849),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(851),
    [anon_sym_TILDE] = ACTIONS(437),
    [anon_sym_void] = ACTIONS(471),
    [anon_sym_delete] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(473),
    [anon_sym_DASH_DASH] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(503),
    [anon_sym_get] = ACTIONS(503),
    [anon_sym_set] = ACTIONS(503),
    [anon_sym_declare] = ACTIONS(503),
    [anon_sym_public] = ACTIONS(503),
    [anon_sym_private] = ACTIONS(503),
    [anon_sym_protected] = ACTIONS(503),
    [anon_sym_module] = ACTIONS(503),
    [anon_sym_any] = ACTIONS(503),
    [anon_sym_number] = ACTIONS(503),
    [anon_sym_boolean] = ACTIONS(503),
    [anon_sym_string] = ACTIONS(503),
    [anon_sym_symbol] = ACTIONS(503),
    [sym_readonly] = ACTIONS(503),
  },
  [164] = {
    [sym_import] = STATE(1528),
    [sym_parenthesized_expression] = STATE(983),
    [sym__expression] = STATE(1358),
    [sym_yield_expression] = STATE(1543),
    [sym_object] = STATE(1671),
    [sym_array] = STATE(1713),
    [sym_nested_identifier] = STATE(1960),
    [sym_class] = STATE(1528),
    [sym_function] = STATE(1528),
    [sym_generator_function] = STATE(1528),
    [sym_arrow_function] = STATE(1528),
    [sym__call_signature] = STATE(3235),
    [sym_call_expression] = STATE(1528),
    [sym_new_expression] = STATE(1543),
    [sym_await_expression] = STATE(1543),
    [sym_member_expression] = STATE(983),
    [sym_subscript_expression] = STATE(983),
    [sym_assignment_expression] = STATE(1543),
    [sym__augmented_assignment_lhs] = STATE(1963),
    [sym_augmented_assignment_expression] = STATE(1543),
    [sym_ternary_expression] = STATE(1543),
    [sym_binary_expression] = STATE(1543),
    [sym_unary_expression] = STATE(1543),
    [sym_update_expression] = STATE(1543),
    [sym_string] = STATE(1528),
    [sym_template_string] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_meta_property] = STATE(1528),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(984),
    [sym_type_assertion] = STATE(1543),
    [sym_as_expression] = STATE(1543),
    [sym_internal_module] = STATE(1543),
    [sym_nested_type_identifier] = STATE(3120),
    [sym_generic_type] = STATE(433),
    [sym_type_arguments] = STATE(310),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2726),
    [sym_identifier] = ACTIONS(1318),
    [anon_sym_export] = ACTIONS(529),
    [anon_sym_namespace] = ACTIONS(531),
    [anon_sym_LBRACE] = ACTIONS(859),
    [anon_sym_type] = ACTIONS(529),
    [anon_sym_typeof] = ACTIONS(561),
    [anon_sym_import] = ACTIONS(537),
    [anon_sym_BANG] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(543),
    [anon_sym_yield] = ACTIONS(545),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(549),
    [anon_sym_async] = ACTIONS(551),
    [anon_sym_function] = ACTIONS(553),
    [anon_sym_new] = ACTIONS(897),
    [anon_sym_PLUS] = ACTIONS(899),
    [anon_sym_DASH] = ACTIONS(899),
    [anon_sym_TILDE] = ACTIONS(539),
    [anon_sym_void] = ACTIONS(561),
    [anon_sym_delete] = ACTIONS(561),
    [anon_sym_PLUS_PLUS] = ACTIONS(563),
    [anon_sym_DASH_DASH] = ACTIONS(563),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(529),
    [anon_sym_get] = ACTIONS(529),
    [anon_sym_set] = ACTIONS(529),
    [anon_sym_declare] = ACTIONS(529),
    [anon_sym_public] = ACTIONS(529),
    [anon_sym_private] = ACTIONS(529),
    [anon_sym_protected] = ACTIONS(529),
    [anon_sym_module] = ACTIONS(529),
    [anon_sym_any] = ACTIONS(529),
    [anon_sym_number] = ACTIONS(529),
    [anon_sym_boolean] = ACTIONS(529),
    [anon_sym_string] = ACTIONS(529),
    [anon_sym_symbol] = ACTIONS(529),
    [sym_readonly] = ACTIONS(529),
  },
  [165] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(985),
    [sym__expression] = STATE(1682),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1759),
    [sym_array] = STATE(1757),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3169),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(985),
    [sym_subscript_expression] = STATE(985),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1967),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(986),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(380),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(1320),
    [anon_sym_export] = ACTIONS(1322),
    [anon_sym_namespace] = ACTIONS(1324),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_type] = ACTIONS(1322),
    [anon_sym_typeof] = ACTIONS(639),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_var] = ACTIONS(1326),
    [anon_sym_let] = ACTIONS(1326),
    [anon_sym_const] = ACTIONS(1326),
    [anon_sym_BANG] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(625),
    [anon_sym_yield] = ACTIONS(627),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(1328),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(887),
    [anon_sym_PLUS] = ACTIONS(889),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(623),
    [anon_sym_void] = ACTIONS(639),
    [anon_sym_delete] = ACTIONS(639),
    [anon_sym_PLUS_PLUS] = ACTIONS(641),
    [anon_sym_DASH_DASH] = ACTIONS(641),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1322),
    [anon_sym_get] = ACTIONS(1322),
    [anon_sym_set] = ACTIONS(1322),
    [anon_sym_declare] = ACTIONS(1322),
    [anon_sym_public] = ACTIONS(1322),
    [anon_sym_private] = ACTIONS(1322),
    [anon_sym_protected] = ACTIONS(1322),
    [anon_sym_module] = ACTIONS(1322),
    [anon_sym_any] = ACTIONS(1322),
    [anon_sym_number] = ACTIONS(1322),
    [anon_sym_boolean] = ACTIONS(1322),
    [anon_sym_string] = ACTIONS(1322),
    [anon_sym_symbol] = ACTIONS(1322),
    [sym_readonly] = ACTIONS(1322),
  },
  [166] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(884),
    [sym__expression] = STATE(1105),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1283),
    [sym_array] = STATE(1281),
    [sym_nested_identifier] = STATE(1960),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3336),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(884),
    [sym_subscript_expression] = STATE(884),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1964),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(860),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_nested_type_identifier] = STATE(3120),
    [sym_generic_type] = STATE(433),
    [sym_type_arguments] = STATE(414),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(1330),
    [anon_sym_export] = ACTIONS(503),
    [anon_sym_namespace] = ACTIONS(505),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_type] = ACTIONS(503),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(437),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(443),
    [anon_sym_yield] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(849),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(851),
    [anon_sym_TILDE] = ACTIONS(437),
    [anon_sym_void] = ACTIONS(471),
    [anon_sym_delete] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(473),
    [anon_sym_DASH_DASH] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(503),
    [anon_sym_get] = ACTIONS(503),
    [anon_sym_set] = ACTIONS(503),
    [anon_sym_declare] = ACTIONS(503),
    [anon_sym_public] = ACTIONS(503),
    [anon_sym_private] = ACTIONS(503),
    [anon_sym_protected] = ACTIONS(503),
    [anon_sym_module] = ACTIONS(503),
    [anon_sym_any] = ACTIONS(503),
    [anon_sym_number] = ACTIONS(503),
    [anon_sym_boolean] = ACTIONS(503),
    [anon_sym_string] = ACTIONS(503),
    [anon_sym_symbol] = ACTIONS(503),
    [sym_readonly] = ACTIONS(503),
  },
  [167] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(884),
    [sym__expression] = STATE(1462),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1283),
    [sym_array] = STATE(1281),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3336),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(884),
    [sym_subscript_expression] = STATE(884),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1964),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_sequence_expression] = STATE(3294),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(860),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(414),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(831),
    [anon_sym_export] = ACTIONS(503),
    [anon_sym_namespace] = ACTIONS(505),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_type] = ACTIONS(503),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(437),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_RPAREN] = ACTIONS(1332),
    [anon_sym_await] = ACTIONS(443),
    [anon_sym_yield] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(849),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(851),
    [anon_sym_TILDE] = ACTIONS(437),
    [anon_sym_void] = ACTIONS(471),
    [anon_sym_delete] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(473),
    [anon_sym_DASH_DASH] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(503),
    [anon_sym_get] = ACTIONS(503),
    [anon_sym_set] = ACTIONS(503),
    [anon_sym_declare] = ACTIONS(503),
    [anon_sym_public] = ACTIONS(503),
    [anon_sym_private] = ACTIONS(503),
    [anon_sym_protected] = ACTIONS(503),
    [anon_sym_module] = ACTIONS(503),
    [anon_sym_any] = ACTIONS(503),
    [anon_sym_number] = ACTIONS(503),
    [anon_sym_boolean] = ACTIONS(503),
    [anon_sym_string] = ACTIONS(503),
    [anon_sym_symbol] = ACTIONS(503),
    [sym_readonly] = ACTIONS(503),
  },
  [168] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(884),
    [sym__expression] = STATE(1400),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1283),
    [sym_array] = STATE(1281),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3336),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(884),
    [sym_subscript_expression] = STATE(884),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1964),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_sequence_expression] = STATE(3194),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(860),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(414),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(831),
    [anon_sym_export] = ACTIONS(503),
    [anon_sym_namespace] = ACTIONS(505),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_type] = ACTIONS(503),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(437),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_RPAREN] = ACTIONS(1334),
    [anon_sym_await] = ACTIONS(443),
    [anon_sym_yield] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(849),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(851),
    [anon_sym_TILDE] = ACTIONS(437),
    [anon_sym_void] = ACTIONS(471),
    [anon_sym_delete] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(473),
    [anon_sym_DASH_DASH] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(503),
    [anon_sym_get] = ACTIONS(503),
    [anon_sym_set] = ACTIONS(503),
    [anon_sym_declare] = ACTIONS(503),
    [anon_sym_public] = ACTIONS(503),
    [anon_sym_private] = ACTIONS(503),
    [anon_sym_protected] = ACTIONS(503),
    [anon_sym_module] = ACTIONS(503),
    [anon_sym_any] = ACTIONS(503),
    [anon_sym_number] = ACTIONS(503),
    [anon_sym_boolean] = ACTIONS(503),
    [anon_sym_string] = ACTIONS(503),
    [anon_sym_symbol] = ACTIONS(503),
    [sym_readonly] = ACTIONS(503),
  },
  [169] = {
    [sym_import] = STATE(1212),
    [sym_statement_block] = STATE(1142),
    [sym_parenthesized_expression] = STATE(884),
    [sym__expression] = STATE(1090),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1283),
    [sym_array] = STATE(1281),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3336),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(884),
    [sym_subscript_expression] = STATE(884),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1964),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(860),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(414),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(831),
    [anon_sym_export] = ACTIONS(503),
    [anon_sym_namespace] = ACTIONS(505),
    [anon_sym_LBRACE] = ACTIONS(1336),
    [anon_sym_type] = ACTIONS(503),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(437),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(443),
    [anon_sym_yield] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(849),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(851),
    [anon_sym_TILDE] = ACTIONS(437),
    [anon_sym_void] = ACTIONS(471),
    [anon_sym_delete] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(473),
    [anon_sym_DASH_DASH] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(503),
    [anon_sym_get] = ACTIONS(503),
    [anon_sym_set] = ACTIONS(503),
    [anon_sym_declare] = ACTIONS(503),
    [anon_sym_public] = ACTIONS(503),
    [anon_sym_private] = ACTIONS(503),
    [anon_sym_protected] = ACTIONS(503),
    [anon_sym_module] = ACTIONS(503),
    [anon_sym_any] = ACTIONS(503),
    [anon_sym_number] = ACTIONS(503),
    [anon_sym_boolean] = ACTIONS(503),
    [anon_sym_string] = ACTIONS(503),
    [anon_sym_symbol] = ACTIONS(503),
    [sym_readonly] = ACTIONS(503),
  },
  [170] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(884),
    [sym__expression] = STATE(1458),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1283),
    [sym_array] = STATE(1281),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3336),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(884),
    [sym_subscript_expression] = STATE(884),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1964),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_sequence_expression] = STATE(3306),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(860),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(414),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(831),
    [anon_sym_export] = ACTIONS(503),
    [anon_sym_namespace] = ACTIONS(505),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_type] = ACTIONS(503),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(437),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(443),
    [anon_sym_yield] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(849),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(851),
    [anon_sym_TILDE] = ACTIONS(437),
    [anon_sym_void] = ACTIONS(471),
    [anon_sym_delete] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(473),
    [anon_sym_DASH_DASH] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(503),
    [anon_sym_get] = ACTIONS(503),
    [anon_sym_set] = ACTIONS(503),
    [anon_sym_declare] = ACTIONS(503),
    [anon_sym_public] = ACTIONS(503),
    [anon_sym_private] = ACTIONS(503),
    [anon_sym_protected] = ACTIONS(503),
    [anon_sym_module] = ACTIONS(503),
    [anon_sym_any] = ACTIONS(503),
    [anon_sym_number] = ACTIONS(503),
    [anon_sym_boolean] = ACTIONS(503),
    [anon_sym_string] = ACTIONS(503),
    [anon_sym_symbol] = ACTIONS(503),
    [sym_readonly] = ACTIONS(503),
  },
  [171] = {
    [sym_import] = STATE(1212),
    [sym_statement_block] = STATE(1156),
    [sym_parenthesized_expression] = STATE(965),
    [sym__expression] = STATE(1308),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1524),
    [sym_array] = STATE(1523),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3348),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(965),
    [sym_subscript_expression] = STATE(965),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1969),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(975),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(302),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(901),
    [anon_sym_export] = ACTIONS(713),
    [anon_sym_namespace] = ACTIONS(715),
    [anon_sym_LBRACE] = ACTIONS(1336),
    [anon_sym_type] = ACTIONS(713),
    [anon_sym_typeof] = ACTIONS(735),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(719),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(721),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(725),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(727),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(907),
    [anon_sym_PLUS] = ACTIONS(909),
    [anon_sym_DASH] = ACTIONS(909),
    [anon_sym_TILDE] = ACTIONS(719),
    [anon_sym_void] = ACTIONS(735),
    [anon_sym_delete] = ACTIONS(735),
    [anon_sym_PLUS_PLUS] = ACTIONS(737),
    [anon_sym_DASH_DASH] = ACTIONS(737),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(713),
    [anon_sym_get] = ACTIONS(713),
    [anon_sym_set] = ACTIONS(713),
    [anon_sym_declare] = ACTIONS(713),
    [anon_sym_public] = ACTIONS(713),
    [anon_sym_private] = ACTIONS(713),
    [anon_sym_protected] = ACTIONS(713),
    [anon_sym_module] = ACTIONS(713),
    [anon_sym_any] = ACTIONS(713),
    [anon_sym_number] = ACTIONS(713),
    [anon_sym_boolean] = ACTIONS(713),
    [anon_sym_string] = ACTIONS(713),
    [anon_sym_symbol] = ACTIONS(713),
    [sym_readonly] = ACTIONS(713),
  },
  [172] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(884),
    [sym__expression] = STATE(1413),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1283),
    [sym_array] = STATE(1281),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3336),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(884),
    [sym_subscript_expression] = STATE(884),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1964),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_sequence_expression] = STATE(3168),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(860),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(414),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(831),
    [anon_sym_export] = ACTIONS(503),
    [anon_sym_namespace] = ACTIONS(505),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_type] = ACTIONS(503),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(437),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(443),
    [anon_sym_yield] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(849),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(851),
    [anon_sym_TILDE] = ACTIONS(437),
    [anon_sym_void] = ACTIONS(471),
    [anon_sym_delete] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(473),
    [anon_sym_DASH_DASH] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(503),
    [anon_sym_get] = ACTIONS(503),
    [anon_sym_set] = ACTIONS(503),
    [anon_sym_declare] = ACTIONS(503),
    [anon_sym_public] = ACTIONS(503),
    [anon_sym_private] = ACTIONS(503),
    [anon_sym_protected] = ACTIONS(503),
    [anon_sym_module] = ACTIONS(503),
    [anon_sym_any] = ACTIONS(503),
    [anon_sym_number] = ACTIONS(503),
    [anon_sym_boolean] = ACTIONS(503),
    [anon_sym_string] = ACTIONS(503),
    [anon_sym_symbol] = ACTIONS(503),
    [sym_readonly] = ACTIONS(503),
  },
  [173] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(884),
    [sym__expression] = STATE(1463),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1283),
    [sym_array] = STATE(1281),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3336),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(884),
    [sym_subscript_expression] = STATE(884),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1964),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_sequence_expression] = STATE(3293),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(860),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(414),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(831),
    [anon_sym_export] = ACTIONS(503),
    [anon_sym_namespace] = ACTIONS(505),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_type] = ACTIONS(503),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(437),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(443),
    [anon_sym_yield] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(849),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(851),
    [anon_sym_TILDE] = ACTIONS(437),
    [anon_sym_void] = ACTIONS(471),
    [anon_sym_delete] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(473),
    [anon_sym_DASH_DASH] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(503),
    [anon_sym_get] = ACTIONS(503),
    [anon_sym_set] = ACTIONS(503),
    [anon_sym_declare] = ACTIONS(503),
    [anon_sym_public] = ACTIONS(503),
    [anon_sym_private] = ACTIONS(503),
    [anon_sym_protected] = ACTIONS(503),
    [anon_sym_module] = ACTIONS(503),
    [anon_sym_any] = ACTIONS(503),
    [anon_sym_number] = ACTIONS(503),
    [anon_sym_boolean] = ACTIONS(503),
    [anon_sym_string] = ACTIONS(503),
    [anon_sym_symbol] = ACTIONS(503),
    [sym_readonly] = ACTIONS(503),
  },
  [174] = {
    [sym_import] = STATE(1528),
    [sym_statement_block] = STATE(1572),
    [sym_parenthesized_expression] = STATE(983),
    [sym__expression] = STATE(1427),
    [sym_yield_expression] = STATE(1543),
    [sym_object] = STATE(1671),
    [sym_array] = STATE(1713),
    [sym_class] = STATE(1528),
    [sym_function] = STATE(1528),
    [sym_generator_function] = STATE(1528),
    [sym_arrow_function] = STATE(1528),
    [sym__call_signature] = STATE(3235),
    [sym_call_expression] = STATE(1528),
    [sym_new_expression] = STATE(1543),
    [sym_await_expression] = STATE(1543),
    [sym_member_expression] = STATE(983),
    [sym_subscript_expression] = STATE(983),
    [sym_assignment_expression] = STATE(1543),
    [sym__augmented_assignment_lhs] = STATE(1963),
    [sym_augmented_assignment_expression] = STATE(1543),
    [sym_ternary_expression] = STATE(1543),
    [sym_binary_expression] = STATE(1543),
    [sym_unary_expression] = STATE(1543),
    [sym_update_expression] = STATE(1543),
    [sym_string] = STATE(1528),
    [sym_template_string] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_meta_property] = STATE(1528),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(984),
    [sym_type_assertion] = STATE(1543),
    [sym_as_expression] = STATE(1543),
    [sym_internal_module] = STATE(1543),
    [sym_type_arguments] = STATE(310),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2726),
    [sym_identifier] = ACTIONS(891),
    [anon_sym_export] = ACTIONS(529),
    [anon_sym_namespace] = ACTIONS(531),
    [anon_sym_LBRACE] = ACTIONS(1338),
    [anon_sym_type] = ACTIONS(529),
    [anon_sym_typeof] = ACTIONS(561),
    [anon_sym_import] = ACTIONS(537),
    [anon_sym_BANG] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(543),
    [anon_sym_yield] = ACTIONS(545),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(549),
    [anon_sym_async] = ACTIONS(551),
    [anon_sym_function] = ACTIONS(553),
    [anon_sym_new] = ACTIONS(897),
    [anon_sym_PLUS] = ACTIONS(899),
    [anon_sym_DASH] = ACTIONS(899),
    [anon_sym_TILDE] = ACTIONS(539),
    [anon_sym_void] = ACTIONS(561),
    [anon_sym_delete] = ACTIONS(561),
    [anon_sym_PLUS_PLUS] = ACTIONS(563),
    [anon_sym_DASH_DASH] = ACTIONS(563),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(529),
    [anon_sym_get] = ACTIONS(529),
    [anon_sym_set] = ACTIONS(529),
    [anon_sym_declare] = ACTIONS(529),
    [anon_sym_public] = ACTIONS(529),
    [anon_sym_private] = ACTIONS(529),
    [anon_sym_protected] = ACTIONS(529),
    [anon_sym_module] = ACTIONS(529),
    [anon_sym_any] = ACTIONS(529),
    [anon_sym_number] = ACTIONS(529),
    [anon_sym_boolean] = ACTIONS(529),
    [anon_sym_string] = ACTIONS(529),
    [anon_sym_symbol] = ACTIONS(529),
    [sym_readonly] = ACTIONS(529),
  },
  [175] = {
    [sym_import] = STATE(1724),
    [sym_statement_block] = STATE(1740),
    [sym_parenthesized_expression] = STATE(963),
    [sym__expression] = STATE(1316),
    [sym_yield_expression] = STATE(1722),
    [sym_object] = STATE(1536),
    [sym_array] = STATE(1535),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(3286),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1722),
    [sym_await_expression] = STATE(1722),
    [sym_member_expression] = STATE(963),
    [sym_subscript_expression] = STATE(963),
    [sym_assignment_expression] = STATE(1722),
    [sym__augmented_assignment_lhs] = STATE(1968),
    [sym_augmented_assignment_expression] = STATE(1722),
    [sym_ternary_expression] = STATE(1722),
    [sym_binary_expression] = STATE(1722),
    [sym_unary_expression] = STATE(1722),
    [sym_update_expression] = STATE(1722),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(952),
    [sym_type_assertion] = STATE(1722),
    [sym_as_expression] = STATE(1722),
    [sym_internal_module] = STATE(1722),
    [sym_type_arguments] = STATE(266),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2684),
    [sym_identifier] = ACTIONS(863),
    [anon_sym_export] = ACTIONS(655),
    [anon_sym_namespace] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(1340),
    [anon_sym_type] = ACTIONS(655),
    [anon_sym_typeof] = ACTIONS(689),
    [anon_sym_import] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_LPAREN] = ACTIONS(871),
    [anon_sym_await] = ACTIONS(669),
    [anon_sym_yield] = ACTIONS(671),
    [anon_sym_LBRACK] = ACTIONS(873),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(675),
    [anon_sym_class] = ACTIONS(677),
    [anon_sym_async] = ACTIONS(679),
    [anon_sym_function] = ACTIONS(681),
    [anon_sym_new] = ACTIONS(875),
    [anon_sym_PLUS] = ACTIONS(877),
    [anon_sym_DASH] = ACTIONS(877),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_void] = ACTIONS(689),
    [anon_sym_delete] = ACTIONS(689),
    [anon_sym_PLUS_PLUS] = ACTIONS(691),
    [anon_sym_DASH_DASH] = ACTIONS(691),
    [anon_sym_DQUOTE] = ACTIONS(693),
    [anon_sym_SQUOTE] = ACTIONS(695),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(697),
    [sym_number] = ACTIONS(879),
    [sym_this] = ACTIONS(703),
    [sym_super] = ACTIONS(703),
    [sym_true] = ACTIONS(703),
    [sym_false] = ACTIONS(703),
    [sym_null] = ACTIONS(703),
    [sym_undefined] = ACTIONS(703),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(655),
    [anon_sym_get] = ACTIONS(655),
    [anon_sym_set] = ACTIONS(655),
    [anon_sym_declare] = ACTIONS(655),
    [anon_sym_public] = ACTIONS(655),
    [anon_sym_private] = ACTIONS(655),
    [anon_sym_protected] = ACTIONS(655),
    [anon_sym_module] = ACTIONS(655),
    [anon_sym_any] = ACTIONS(655),
    [anon_sym_number] = ACTIONS(655),
    [anon_sym_boolean] = ACTIONS(655),
    [anon_sym_string] = ACTIONS(655),
    [anon_sym_symbol] = ACTIONS(655),
    [sym_readonly] = ACTIONS(655),
  },
  [176] = {
    [sym_import] = STATE(1724),
    [sym_statement_block] = STATE(1705),
    [sym_parenthesized_expression] = STATE(963),
    [sym__expression] = STATE(1248),
    [sym_yield_expression] = STATE(1722),
    [sym_object] = STATE(1536),
    [sym_array] = STATE(1535),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(3286),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1722),
    [sym_await_expression] = STATE(1722),
    [sym_member_expression] = STATE(963),
    [sym_subscript_expression] = STATE(963),
    [sym_assignment_expression] = STATE(1722),
    [sym__augmented_assignment_lhs] = STATE(1968),
    [sym_augmented_assignment_expression] = STATE(1722),
    [sym_ternary_expression] = STATE(1722),
    [sym_binary_expression] = STATE(1722),
    [sym_unary_expression] = STATE(1722),
    [sym_update_expression] = STATE(1722),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(952),
    [sym_type_assertion] = STATE(1722),
    [sym_as_expression] = STATE(1722),
    [sym_internal_module] = STATE(1722),
    [sym_type_arguments] = STATE(266),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2684),
    [sym_identifier] = ACTIONS(863),
    [anon_sym_export] = ACTIONS(655),
    [anon_sym_namespace] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(1340),
    [anon_sym_type] = ACTIONS(655),
    [anon_sym_typeof] = ACTIONS(689),
    [anon_sym_import] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_LPAREN] = ACTIONS(871),
    [anon_sym_await] = ACTIONS(669),
    [anon_sym_yield] = ACTIONS(671),
    [anon_sym_LBRACK] = ACTIONS(873),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(675),
    [anon_sym_class] = ACTIONS(677),
    [anon_sym_async] = ACTIONS(679),
    [anon_sym_function] = ACTIONS(681),
    [anon_sym_new] = ACTIONS(875),
    [anon_sym_PLUS] = ACTIONS(877),
    [anon_sym_DASH] = ACTIONS(877),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_void] = ACTIONS(689),
    [anon_sym_delete] = ACTIONS(689),
    [anon_sym_PLUS_PLUS] = ACTIONS(691),
    [anon_sym_DASH_DASH] = ACTIONS(691),
    [anon_sym_DQUOTE] = ACTIONS(693),
    [anon_sym_SQUOTE] = ACTIONS(695),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(697),
    [sym_number] = ACTIONS(879),
    [sym_this] = ACTIONS(703),
    [sym_super] = ACTIONS(703),
    [sym_true] = ACTIONS(703),
    [sym_false] = ACTIONS(703),
    [sym_null] = ACTIONS(703),
    [sym_undefined] = ACTIONS(703),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(655),
    [anon_sym_get] = ACTIONS(655),
    [anon_sym_set] = ACTIONS(655),
    [anon_sym_declare] = ACTIONS(655),
    [anon_sym_public] = ACTIONS(655),
    [anon_sym_private] = ACTIONS(655),
    [anon_sym_protected] = ACTIONS(655),
    [anon_sym_module] = ACTIONS(655),
    [anon_sym_any] = ACTIONS(655),
    [anon_sym_number] = ACTIONS(655),
    [anon_sym_boolean] = ACTIONS(655),
    [anon_sym_string] = ACTIONS(655),
    [anon_sym_symbol] = ACTIONS(655),
    [sym_readonly] = ACTIONS(655),
  },
  [177] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(884),
    [sym__expression] = STATE(1461),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1283),
    [sym_array] = STATE(1281),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3336),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(884),
    [sym_subscript_expression] = STATE(884),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1964),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_sequence_expression] = STATE(3302),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(860),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(414),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(831),
    [anon_sym_export] = ACTIONS(503),
    [anon_sym_namespace] = ACTIONS(505),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_type] = ACTIONS(503),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(437),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(443),
    [anon_sym_yield] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(849),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(851),
    [anon_sym_TILDE] = ACTIONS(437),
    [anon_sym_void] = ACTIONS(471),
    [anon_sym_delete] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(473),
    [anon_sym_DASH_DASH] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(503),
    [anon_sym_get] = ACTIONS(503),
    [anon_sym_set] = ACTIONS(503),
    [anon_sym_declare] = ACTIONS(503),
    [anon_sym_public] = ACTIONS(503),
    [anon_sym_private] = ACTIONS(503),
    [anon_sym_protected] = ACTIONS(503),
    [anon_sym_module] = ACTIONS(503),
    [anon_sym_any] = ACTIONS(503),
    [anon_sym_number] = ACTIONS(503),
    [anon_sym_boolean] = ACTIONS(503),
    [anon_sym_string] = ACTIONS(503),
    [anon_sym_symbol] = ACTIONS(503),
    [sym_readonly] = ACTIONS(503),
  },
  [178] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(884),
    [sym__expression] = STATE(1205),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1283),
    [sym_array] = STATE(1281),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3336),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(884),
    [sym_subscript_expression] = STATE(884),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1964),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_sequence_expression] = STATE(3295),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(860),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(414),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(831),
    [anon_sym_export] = ACTIONS(503),
    [anon_sym_namespace] = ACTIONS(505),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_type] = ACTIONS(503),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(437),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(443),
    [anon_sym_yield] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(849),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(851),
    [anon_sym_TILDE] = ACTIONS(437),
    [anon_sym_void] = ACTIONS(471),
    [anon_sym_delete] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(473),
    [anon_sym_DASH_DASH] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(503),
    [anon_sym_get] = ACTIONS(503),
    [anon_sym_set] = ACTIONS(503),
    [anon_sym_declare] = ACTIONS(503),
    [anon_sym_public] = ACTIONS(503),
    [anon_sym_private] = ACTIONS(503),
    [anon_sym_protected] = ACTIONS(503),
    [anon_sym_module] = ACTIONS(503),
    [anon_sym_any] = ACTIONS(503),
    [anon_sym_number] = ACTIONS(503),
    [anon_sym_boolean] = ACTIONS(503),
    [anon_sym_string] = ACTIONS(503),
    [anon_sym_symbol] = ACTIONS(503),
    [sym_readonly] = ACTIONS(503),
  },
  [179] = {
    [sym_import] = STATE(1265),
    [sym_parenthesized_expression] = STATE(751),
    [sym__expression] = STATE(1697),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1195),
    [sym_array] = STATE(1181),
    [sym_class] = STATE(1265),
    [sym_function] = STATE(1265),
    [sym_generator_function] = STATE(1265),
    [sym_arrow_function] = STATE(1265),
    [sym__call_signature] = STATE(3359),
    [sym_call_expression] = STATE(1265),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(751),
    [sym_subscript_expression] = STATE(751),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1967),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1265),
    [sym_template_string] = STATE(1265),
    [sym_regex] = STATE(1265),
    [sym_meta_property] = STATE(1265),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2377),
    [sym_non_null_expression] = STATE(977),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(380),
    [sym_type_parameters] = STATE(2982),
    [aux_sym_export_statement_repeat1] = STATE(2726),
    [sym_identifier] = ACTIONS(1342),
    [anon_sym_export] = ACTIONS(1344),
    [anon_sym_namespace] = ACTIONS(1346),
    [anon_sym_LBRACE] = ACTIONS(859),
    [anon_sym_type] = ACTIONS(1344),
    [anon_sym_typeof] = ACTIONS(639),
    [anon_sym_import] = ACTIONS(537),
    [anon_sym_BANG] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(625),
    [anon_sym_yield] = ACTIONS(627),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_DOT] = ACTIONS(1348),
    [anon_sym_class] = ACTIONS(549),
    [anon_sym_async] = ACTIONS(1350),
    [anon_sym_function] = ACTIONS(553),
    [anon_sym_new] = ACTIONS(1352),
    [anon_sym_PLUS] = ACTIONS(889),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(623),
    [anon_sym_void] = ACTIONS(639),
    [anon_sym_delete] = ACTIONS(639),
    [anon_sym_PLUS_PLUS] = ACTIONS(641),
    [anon_sym_DASH_DASH] = ACTIONS(641),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(1354),
    [sym_this] = ACTIONS(1356),
    [sym_super] = ACTIONS(1356),
    [sym_true] = ACTIONS(1356),
    [sym_false] = ACTIONS(1356),
    [sym_null] = ACTIONS(1356),
    [sym_undefined] = ACTIONS(1356),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1344),
    [anon_sym_get] = ACTIONS(1344),
    [anon_sym_set] = ACTIONS(1344),
    [anon_sym_declare] = ACTIONS(1344),
    [anon_sym_public] = ACTIONS(1344),
    [anon_sym_private] = ACTIONS(1344),
    [anon_sym_protected] = ACTIONS(1344),
    [anon_sym_module] = ACTIONS(1344),
    [anon_sym_any] = ACTIONS(1344),
    [anon_sym_number] = ACTIONS(1344),
    [anon_sym_boolean] = ACTIONS(1344),
    [anon_sym_string] = ACTIONS(1344),
    [anon_sym_symbol] = ACTIONS(1344),
    [sym_readonly] = ACTIONS(1344),
  },
  [180] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(978),
    [sym__expression] = STATE(1607),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1696),
    [sym_array] = STATE(1691),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3169),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(978),
    [sym_subscript_expression] = STATE(978),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1967),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(977),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_mapped_type_clause] = STATE(3225),
    [sym_type_arguments] = STATE(380),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(1358),
    [anon_sym_export] = ACTIONS(1360),
    [anon_sym_namespace] = ACTIONS(1362),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_type] = ACTIONS(1360),
    [anon_sym_typeof] = ACTIONS(639),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(625),
    [anon_sym_yield] = ACTIONS(627),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(1364),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(887),
    [anon_sym_PLUS] = ACTIONS(889),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(623),
    [anon_sym_void] = ACTIONS(639),
    [anon_sym_delete] = ACTIONS(639),
    [anon_sym_PLUS_PLUS] = ACTIONS(641),
    [anon_sym_DASH_DASH] = ACTIONS(641),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1360),
    [anon_sym_get] = ACTIONS(1360),
    [anon_sym_set] = ACTIONS(1360),
    [anon_sym_declare] = ACTIONS(1360),
    [anon_sym_public] = ACTIONS(1360),
    [anon_sym_private] = ACTIONS(1360),
    [anon_sym_protected] = ACTIONS(1360),
    [anon_sym_module] = ACTIONS(1360),
    [anon_sym_any] = ACTIONS(1360),
    [anon_sym_number] = ACTIONS(1360),
    [anon_sym_boolean] = ACTIONS(1360),
    [anon_sym_string] = ACTIONS(1360),
    [anon_sym_symbol] = ACTIONS(1360),
    [sym_readonly] = ACTIONS(1360),
  },
  [181] = {
    [sym_import] = STATE(1212),
    [sym_statement_block] = STATE(1223),
    [sym_parenthesized_expression] = STATE(965),
    [sym__expression] = STATE(1329),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1524),
    [sym_array] = STATE(1523),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3348),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(965),
    [sym_subscript_expression] = STATE(965),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1969),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(975),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(302),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(901),
    [anon_sym_export] = ACTIONS(713),
    [anon_sym_namespace] = ACTIONS(715),
    [anon_sym_LBRACE] = ACTIONS(1336),
    [anon_sym_type] = ACTIONS(713),
    [anon_sym_typeof] = ACTIONS(735),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(719),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(721),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(725),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(727),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(907),
    [anon_sym_PLUS] = ACTIONS(909),
    [anon_sym_DASH] = ACTIONS(909),
    [anon_sym_TILDE] = ACTIONS(719),
    [anon_sym_void] = ACTIONS(735),
    [anon_sym_delete] = ACTIONS(735),
    [anon_sym_PLUS_PLUS] = ACTIONS(737),
    [anon_sym_DASH_DASH] = ACTIONS(737),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(713),
    [anon_sym_get] = ACTIONS(713),
    [anon_sym_set] = ACTIONS(713),
    [anon_sym_declare] = ACTIONS(713),
    [anon_sym_public] = ACTIONS(713),
    [anon_sym_private] = ACTIONS(713),
    [anon_sym_protected] = ACTIONS(713),
    [anon_sym_module] = ACTIONS(713),
    [anon_sym_any] = ACTIONS(713),
    [anon_sym_number] = ACTIONS(713),
    [anon_sym_boolean] = ACTIONS(713),
    [anon_sym_string] = ACTIONS(713),
    [anon_sym_symbol] = ACTIONS(713),
    [sym_readonly] = ACTIONS(713),
  },
  [182] = {
    [sym_import] = STATE(1528),
    [sym_statement_block] = STATE(1548),
    [sym_parenthesized_expression] = STATE(983),
    [sym__expression] = STATE(1444),
    [sym_yield_expression] = STATE(1543),
    [sym_object] = STATE(1671),
    [sym_array] = STATE(1713),
    [sym_class] = STATE(1528),
    [sym_function] = STATE(1528),
    [sym_generator_function] = STATE(1528),
    [sym_arrow_function] = STATE(1528),
    [sym__call_signature] = STATE(3235),
    [sym_call_expression] = STATE(1528),
    [sym_new_expression] = STATE(1543),
    [sym_await_expression] = STATE(1543),
    [sym_member_expression] = STATE(983),
    [sym_subscript_expression] = STATE(983),
    [sym_assignment_expression] = STATE(1543),
    [sym__augmented_assignment_lhs] = STATE(1963),
    [sym_augmented_assignment_expression] = STATE(1543),
    [sym_ternary_expression] = STATE(1543),
    [sym_binary_expression] = STATE(1543),
    [sym_unary_expression] = STATE(1543),
    [sym_update_expression] = STATE(1543),
    [sym_string] = STATE(1528),
    [sym_template_string] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_meta_property] = STATE(1528),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(984),
    [sym_type_assertion] = STATE(1543),
    [sym_as_expression] = STATE(1543),
    [sym_internal_module] = STATE(1543),
    [sym_type_arguments] = STATE(310),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2726),
    [sym_identifier] = ACTIONS(891),
    [anon_sym_export] = ACTIONS(529),
    [anon_sym_namespace] = ACTIONS(531),
    [anon_sym_LBRACE] = ACTIONS(1338),
    [anon_sym_type] = ACTIONS(529),
    [anon_sym_typeof] = ACTIONS(561),
    [anon_sym_import] = ACTIONS(537),
    [anon_sym_BANG] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(543),
    [anon_sym_yield] = ACTIONS(545),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(549),
    [anon_sym_async] = ACTIONS(551),
    [anon_sym_function] = ACTIONS(553),
    [anon_sym_new] = ACTIONS(897),
    [anon_sym_PLUS] = ACTIONS(899),
    [anon_sym_DASH] = ACTIONS(899),
    [anon_sym_TILDE] = ACTIONS(539),
    [anon_sym_void] = ACTIONS(561),
    [anon_sym_delete] = ACTIONS(561),
    [anon_sym_PLUS_PLUS] = ACTIONS(563),
    [anon_sym_DASH_DASH] = ACTIONS(563),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(529),
    [anon_sym_get] = ACTIONS(529),
    [anon_sym_set] = ACTIONS(529),
    [anon_sym_declare] = ACTIONS(529),
    [anon_sym_public] = ACTIONS(529),
    [anon_sym_private] = ACTIONS(529),
    [anon_sym_protected] = ACTIONS(529),
    [anon_sym_module] = ACTIONS(529),
    [anon_sym_any] = ACTIONS(529),
    [anon_sym_number] = ACTIONS(529),
    [anon_sym_boolean] = ACTIONS(529),
    [anon_sym_string] = ACTIONS(529),
    [anon_sym_symbol] = ACTIONS(529),
    [sym_readonly] = ACTIONS(529),
  },
  [183] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(884),
    [sym__expression] = STATE(1397),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1283),
    [sym_array] = STATE(1281),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3336),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(884),
    [sym_subscript_expression] = STATE(884),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1964),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_sequence_expression] = STATE(3177),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(860),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(414),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(831),
    [anon_sym_export] = ACTIONS(503),
    [anon_sym_namespace] = ACTIONS(505),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_type] = ACTIONS(503),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(437),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(443),
    [anon_sym_yield] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(849),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(851),
    [anon_sym_TILDE] = ACTIONS(437),
    [anon_sym_void] = ACTIONS(471),
    [anon_sym_delete] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(473),
    [anon_sym_DASH_DASH] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(503),
    [anon_sym_get] = ACTIONS(503),
    [anon_sym_set] = ACTIONS(503),
    [anon_sym_declare] = ACTIONS(503),
    [anon_sym_public] = ACTIONS(503),
    [anon_sym_private] = ACTIONS(503),
    [anon_sym_protected] = ACTIONS(503),
    [anon_sym_module] = ACTIONS(503),
    [anon_sym_any] = ACTIONS(503),
    [anon_sym_number] = ACTIONS(503),
    [anon_sym_boolean] = ACTIONS(503),
    [anon_sym_string] = ACTIONS(503),
    [anon_sym_symbol] = ACTIONS(503),
    [sym_readonly] = ACTIONS(503),
  },
  [184] = {
    [sym_import] = STATE(1039),
    [sym_parenthesized_expression] = STATE(661),
    [sym__expression] = STATE(1682),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1023),
    [sym_array] = STATE(1024),
    [sym_class] = STATE(1039),
    [sym_function] = STATE(1039),
    [sym_generator_function] = STATE(1039),
    [sym_arrow_function] = STATE(1039),
    [sym__call_signature] = STATE(3348),
    [sym_call_expression] = STATE(1039),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(661),
    [sym_subscript_expression] = STATE(661),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1967),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1039),
    [sym_template_string] = STATE(1039),
    [sym_regex] = STATE(1039),
    [sym_meta_property] = STATE(1039),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2377),
    [sym_non_null_expression] = STATE(977),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(380),
    [sym_type_parameters] = STATE(2982),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(1366),
    [anon_sym_export] = ACTIONS(1368),
    [anon_sym_namespace] = ACTIONS(1370),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_type] = ACTIONS(1368),
    [anon_sym_typeof] = ACTIONS(639),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(625),
    [anon_sym_yield] = ACTIONS(627),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(725),
    [anon_sym_DOT] = ACTIONS(1372),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(1374),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(887),
    [anon_sym_PLUS] = ACTIONS(889),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(623),
    [anon_sym_void] = ACTIONS(639),
    [anon_sym_delete] = ACTIONS(639),
    [anon_sym_PLUS_PLUS] = ACTIONS(641),
    [anon_sym_DASH_DASH] = ACTIONS(641),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(1376),
    [sym_this] = ACTIONS(1378),
    [sym_super] = ACTIONS(1378),
    [sym_true] = ACTIONS(1378),
    [sym_false] = ACTIONS(1378),
    [sym_null] = ACTIONS(1378),
    [sym_undefined] = ACTIONS(1378),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1368),
    [anon_sym_get] = ACTIONS(1368),
    [anon_sym_set] = ACTIONS(1368),
    [anon_sym_declare] = ACTIONS(1368),
    [anon_sym_public] = ACTIONS(1368),
    [anon_sym_private] = ACTIONS(1368),
    [anon_sym_protected] = ACTIONS(1368),
    [anon_sym_module] = ACTIONS(1368),
    [anon_sym_any] = ACTIONS(1368),
    [anon_sym_number] = ACTIONS(1368),
    [anon_sym_boolean] = ACTIONS(1368),
    [anon_sym_string] = ACTIONS(1368),
    [anon_sym_symbol] = ACTIONS(1368),
    [sym_readonly] = ACTIONS(1368),
  },
  [185] = {
    [sym_import] = STATE(1212),
    [sym_statement_block] = STATE(1142),
    [sym_parenthesized_expression] = STATE(965),
    [sym__expression] = STATE(1311),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1524),
    [sym_array] = STATE(1523),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3348),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(965),
    [sym_subscript_expression] = STATE(965),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1969),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(975),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(302),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(901),
    [anon_sym_export] = ACTIONS(713),
    [anon_sym_namespace] = ACTIONS(715),
    [anon_sym_LBRACE] = ACTIONS(1336),
    [anon_sym_type] = ACTIONS(713),
    [anon_sym_typeof] = ACTIONS(735),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(719),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(721),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(725),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(727),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(907),
    [anon_sym_PLUS] = ACTIONS(909),
    [anon_sym_DASH] = ACTIONS(909),
    [anon_sym_TILDE] = ACTIONS(719),
    [anon_sym_void] = ACTIONS(735),
    [anon_sym_delete] = ACTIONS(735),
    [anon_sym_PLUS_PLUS] = ACTIONS(737),
    [anon_sym_DASH_DASH] = ACTIONS(737),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(713),
    [anon_sym_get] = ACTIONS(713),
    [anon_sym_set] = ACTIONS(713),
    [anon_sym_declare] = ACTIONS(713),
    [anon_sym_public] = ACTIONS(713),
    [anon_sym_private] = ACTIONS(713),
    [anon_sym_protected] = ACTIONS(713),
    [anon_sym_module] = ACTIONS(713),
    [anon_sym_any] = ACTIONS(713),
    [anon_sym_number] = ACTIONS(713),
    [anon_sym_boolean] = ACTIONS(713),
    [anon_sym_string] = ACTIONS(713),
    [anon_sym_symbol] = ACTIONS(713),
    [sym_readonly] = ACTIONS(713),
  },
  [186] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(884),
    [sym__expression] = STATE(1398),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1283),
    [sym_array] = STATE(1281),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3336),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(884),
    [sym_subscript_expression] = STATE(884),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1964),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_sequence_expression] = STATE(3391),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(860),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(414),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(831),
    [anon_sym_export] = ACTIONS(503),
    [anon_sym_namespace] = ACTIONS(505),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_type] = ACTIONS(503),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(437),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(443),
    [anon_sym_yield] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(849),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(851),
    [anon_sym_TILDE] = ACTIONS(437),
    [anon_sym_void] = ACTIONS(471),
    [anon_sym_delete] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(473),
    [anon_sym_DASH_DASH] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(503),
    [anon_sym_get] = ACTIONS(503),
    [anon_sym_set] = ACTIONS(503),
    [anon_sym_declare] = ACTIONS(503),
    [anon_sym_public] = ACTIONS(503),
    [anon_sym_private] = ACTIONS(503),
    [anon_sym_protected] = ACTIONS(503),
    [anon_sym_module] = ACTIONS(503),
    [anon_sym_any] = ACTIONS(503),
    [anon_sym_number] = ACTIONS(503),
    [anon_sym_boolean] = ACTIONS(503),
    [anon_sym_string] = ACTIONS(503),
    [anon_sym_symbol] = ACTIONS(503),
    [sym_readonly] = ACTIONS(503),
  },
  [187] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(884),
    [sym__expression] = STATE(1392),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1283),
    [sym_array] = STATE(1281),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3336),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(884),
    [sym_subscript_expression] = STATE(884),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1964),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_sequence_expression] = STATE(3222),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(860),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(414),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(831),
    [anon_sym_export] = ACTIONS(503),
    [anon_sym_namespace] = ACTIONS(505),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_type] = ACTIONS(503),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(437),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(443),
    [anon_sym_yield] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(849),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(851),
    [anon_sym_TILDE] = ACTIONS(437),
    [anon_sym_void] = ACTIONS(471),
    [anon_sym_delete] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(473),
    [anon_sym_DASH_DASH] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(503),
    [anon_sym_get] = ACTIONS(503),
    [anon_sym_set] = ACTIONS(503),
    [anon_sym_declare] = ACTIONS(503),
    [anon_sym_public] = ACTIONS(503),
    [anon_sym_private] = ACTIONS(503),
    [anon_sym_protected] = ACTIONS(503),
    [anon_sym_module] = ACTIONS(503),
    [anon_sym_any] = ACTIONS(503),
    [anon_sym_number] = ACTIONS(503),
    [anon_sym_boolean] = ACTIONS(503),
    [anon_sym_string] = ACTIONS(503),
    [anon_sym_symbol] = ACTIONS(503),
    [sym_readonly] = ACTIONS(503),
  },
  [188] = {
    [sym_import] = STATE(1528),
    [sym_statement_block] = STATE(1561),
    [sym_parenthesized_expression] = STATE(983),
    [sym__expression] = STATE(1395),
    [sym_yield_expression] = STATE(1543),
    [sym_object] = STATE(1671),
    [sym_array] = STATE(1713),
    [sym_class] = STATE(1528),
    [sym_function] = STATE(1528),
    [sym_generator_function] = STATE(1528),
    [sym_arrow_function] = STATE(1528),
    [sym__call_signature] = STATE(3235),
    [sym_call_expression] = STATE(1528),
    [sym_new_expression] = STATE(1543),
    [sym_await_expression] = STATE(1543),
    [sym_member_expression] = STATE(983),
    [sym_subscript_expression] = STATE(983),
    [sym_assignment_expression] = STATE(1543),
    [sym__augmented_assignment_lhs] = STATE(1963),
    [sym_augmented_assignment_expression] = STATE(1543),
    [sym_ternary_expression] = STATE(1543),
    [sym_binary_expression] = STATE(1543),
    [sym_unary_expression] = STATE(1543),
    [sym_update_expression] = STATE(1543),
    [sym_string] = STATE(1528),
    [sym_template_string] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_meta_property] = STATE(1528),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(984),
    [sym_type_assertion] = STATE(1543),
    [sym_as_expression] = STATE(1543),
    [sym_internal_module] = STATE(1543),
    [sym_type_arguments] = STATE(310),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2726),
    [sym_identifier] = ACTIONS(891),
    [anon_sym_export] = ACTIONS(529),
    [anon_sym_namespace] = ACTIONS(531),
    [anon_sym_LBRACE] = ACTIONS(1338),
    [anon_sym_type] = ACTIONS(529),
    [anon_sym_typeof] = ACTIONS(561),
    [anon_sym_import] = ACTIONS(537),
    [anon_sym_BANG] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(543),
    [anon_sym_yield] = ACTIONS(545),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(549),
    [anon_sym_async] = ACTIONS(551),
    [anon_sym_function] = ACTIONS(553),
    [anon_sym_new] = ACTIONS(897),
    [anon_sym_PLUS] = ACTIONS(899),
    [anon_sym_DASH] = ACTIONS(899),
    [anon_sym_TILDE] = ACTIONS(539),
    [anon_sym_void] = ACTIONS(561),
    [anon_sym_delete] = ACTIONS(561),
    [anon_sym_PLUS_PLUS] = ACTIONS(563),
    [anon_sym_DASH_DASH] = ACTIONS(563),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(529),
    [anon_sym_get] = ACTIONS(529),
    [anon_sym_set] = ACTIONS(529),
    [anon_sym_declare] = ACTIONS(529),
    [anon_sym_public] = ACTIONS(529),
    [anon_sym_private] = ACTIONS(529),
    [anon_sym_protected] = ACTIONS(529),
    [anon_sym_module] = ACTIONS(529),
    [anon_sym_any] = ACTIONS(529),
    [anon_sym_number] = ACTIONS(529),
    [anon_sym_boolean] = ACTIONS(529),
    [anon_sym_string] = ACTIONS(529),
    [anon_sym_symbol] = ACTIONS(529),
    [sym_readonly] = ACTIONS(529),
  },
  [189] = {
    [sym_import] = STATE(1528),
    [sym_statement_block] = STATE(1512),
    [sym_parenthesized_expression] = STATE(983),
    [sym__expression] = STATE(1476),
    [sym_yield_expression] = STATE(1543),
    [sym_object] = STATE(1671),
    [sym_array] = STATE(1713),
    [sym_class] = STATE(1528),
    [sym_function] = STATE(1528),
    [sym_generator_function] = STATE(1528),
    [sym_arrow_function] = STATE(1528),
    [sym__call_signature] = STATE(3235),
    [sym_call_expression] = STATE(1528),
    [sym_new_expression] = STATE(1543),
    [sym_await_expression] = STATE(1543),
    [sym_member_expression] = STATE(983),
    [sym_subscript_expression] = STATE(983),
    [sym_assignment_expression] = STATE(1543),
    [sym__augmented_assignment_lhs] = STATE(1963),
    [sym_augmented_assignment_expression] = STATE(1543),
    [sym_ternary_expression] = STATE(1543),
    [sym_binary_expression] = STATE(1543),
    [sym_unary_expression] = STATE(1543),
    [sym_update_expression] = STATE(1543),
    [sym_string] = STATE(1528),
    [sym_template_string] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_meta_property] = STATE(1528),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(984),
    [sym_type_assertion] = STATE(1543),
    [sym_as_expression] = STATE(1543),
    [sym_internal_module] = STATE(1543),
    [sym_type_arguments] = STATE(310),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2726),
    [sym_identifier] = ACTIONS(891),
    [anon_sym_export] = ACTIONS(529),
    [anon_sym_namespace] = ACTIONS(531),
    [anon_sym_LBRACE] = ACTIONS(1338),
    [anon_sym_type] = ACTIONS(529),
    [anon_sym_typeof] = ACTIONS(561),
    [anon_sym_import] = ACTIONS(537),
    [anon_sym_BANG] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(543),
    [anon_sym_yield] = ACTIONS(545),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(549),
    [anon_sym_async] = ACTIONS(551),
    [anon_sym_function] = ACTIONS(553),
    [anon_sym_new] = ACTIONS(897),
    [anon_sym_PLUS] = ACTIONS(899),
    [anon_sym_DASH] = ACTIONS(899),
    [anon_sym_TILDE] = ACTIONS(539),
    [anon_sym_void] = ACTIONS(561),
    [anon_sym_delete] = ACTIONS(561),
    [anon_sym_PLUS_PLUS] = ACTIONS(563),
    [anon_sym_DASH_DASH] = ACTIONS(563),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(529),
    [anon_sym_get] = ACTIONS(529),
    [anon_sym_set] = ACTIONS(529),
    [anon_sym_declare] = ACTIONS(529),
    [anon_sym_public] = ACTIONS(529),
    [anon_sym_private] = ACTIONS(529),
    [anon_sym_protected] = ACTIONS(529),
    [anon_sym_module] = ACTIONS(529),
    [anon_sym_any] = ACTIONS(529),
    [anon_sym_number] = ACTIONS(529),
    [anon_sym_boolean] = ACTIONS(529),
    [anon_sym_string] = ACTIONS(529),
    [anon_sym_symbol] = ACTIONS(529),
    [sym_readonly] = ACTIONS(529),
  },
  [190] = {
    [sym_import] = STATE(1528),
    [sym_statement_block] = STATE(1670),
    [sym_parenthesized_expression] = STATE(983),
    [sym__expression] = STATE(1484),
    [sym_yield_expression] = STATE(1543),
    [sym_object] = STATE(1671),
    [sym_array] = STATE(1713),
    [sym_class] = STATE(1528),
    [sym_function] = STATE(1528),
    [sym_generator_function] = STATE(1528),
    [sym_arrow_function] = STATE(1528),
    [sym__call_signature] = STATE(3235),
    [sym_call_expression] = STATE(1528),
    [sym_new_expression] = STATE(1543),
    [sym_await_expression] = STATE(1543),
    [sym_member_expression] = STATE(983),
    [sym_subscript_expression] = STATE(983),
    [sym_assignment_expression] = STATE(1543),
    [sym__augmented_assignment_lhs] = STATE(1963),
    [sym_augmented_assignment_expression] = STATE(1543),
    [sym_ternary_expression] = STATE(1543),
    [sym_binary_expression] = STATE(1543),
    [sym_unary_expression] = STATE(1543),
    [sym_update_expression] = STATE(1543),
    [sym_string] = STATE(1528),
    [sym_template_string] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_meta_property] = STATE(1528),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(984),
    [sym_type_assertion] = STATE(1543),
    [sym_as_expression] = STATE(1543),
    [sym_internal_module] = STATE(1543),
    [sym_type_arguments] = STATE(310),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2726),
    [sym_identifier] = ACTIONS(891),
    [anon_sym_export] = ACTIONS(529),
    [anon_sym_namespace] = ACTIONS(531),
    [anon_sym_LBRACE] = ACTIONS(1338),
    [anon_sym_type] = ACTIONS(529),
    [anon_sym_typeof] = ACTIONS(561),
    [anon_sym_import] = ACTIONS(537),
    [anon_sym_BANG] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(543),
    [anon_sym_yield] = ACTIONS(545),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(549),
    [anon_sym_async] = ACTIONS(551),
    [anon_sym_function] = ACTIONS(553),
    [anon_sym_new] = ACTIONS(897),
    [anon_sym_PLUS] = ACTIONS(899),
    [anon_sym_DASH] = ACTIONS(899),
    [anon_sym_TILDE] = ACTIONS(539),
    [anon_sym_void] = ACTIONS(561),
    [anon_sym_delete] = ACTIONS(561),
    [anon_sym_PLUS_PLUS] = ACTIONS(563),
    [anon_sym_DASH_DASH] = ACTIONS(563),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(529),
    [anon_sym_get] = ACTIONS(529),
    [anon_sym_set] = ACTIONS(529),
    [anon_sym_declare] = ACTIONS(529),
    [anon_sym_public] = ACTIONS(529),
    [anon_sym_private] = ACTIONS(529),
    [anon_sym_protected] = ACTIONS(529),
    [anon_sym_module] = ACTIONS(529),
    [anon_sym_any] = ACTIONS(529),
    [anon_sym_number] = ACTIONS(529),
    [anon_sym_boolean] = ACTIONS(529),
    [anon_sym_string] = ACTIONS(529),
    [anon_sym_symbol] = ACTIONS(529),
    [sym_readonly] = ACTIONS(529),
  },
  [191] = {
    [sym_import] = STATE(1528),
    [sym_statement_block] = STATE(1669),
    [sym_parenthesized_expression] = STATE(983),
    [sym__expression] = STATE(1485),
    [sym_yield_expression] = STATE(1543),
    [sym_object] = STATE(1671),
    [sym_array] = STATE(1713),
    [sym_class] = STATE(1528),
    [sym_function] = STATE(1528),
    [sym_generator_function] = STATE(1528),
    [sym_arrow_function] = STATE(1528),
    [sym__call_signature] = STATE(3235),
    [sym_call_expression] = STATE(1528),
    [sym_new_expression] = STATE(1543),
    [sym_await_expression] = STATE(1543),
    [sym_member_expression] = STATE(983),
    [sym_subscript_expression] = STATE(983),
    [sym_assignment_expression] = STATE(1543),
    [sym__augmented_assignment_lhs] = STATE(1963),
    [sym_augmented_assignment_expression] = STATE(1543),
    [sym_ternary_expression] = STATE(1543),
    [sym_binary_expression] = STATE(1543),
    [sym_unary_expression] = STATE(1543),
    [sym_update_expression] = STATE(1543),
    [sym_string] = STATE(1528),
    [sym_template_string] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_meta_property] = STATE(1528),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(984),
    [sym_type_assertion] = STATE(1543),
    [sym_as_expression] = STATE(1543),
    [sym_internal_module] = STATE(1543),
    [sym_type_arguments] = STATE(310),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2726),
    [sym_identifier] = ACTIONS(891),
    [anon_sym_export] = ACTIONS(529),
    [anon_sym_namespace] = ACTIONS(531),
    [anon_sym_LBRACE] = ACTIONS(1338),
    [anon_sym_type] = ACTIONS(529),
    [anon_sym_typeof] = ACTIONS(561),
    [anon_sym_import] = ACTIONS(537),
    [anon_sym_BANG] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(543),
    [anon_sym_yield] = ACTIONS(545),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(549),
    [anon_sym_async] = ACTIONS(551),
    [anon_sym_function] = ACTIONS(553),
    [anon_sym_new] = ACTIONS(897),
    [anon_sym_PLUS] = ACTIONS(899),
    [anon_sym_DASH] = ACTIONS(899),
    [anon_sym_TILDE] = ACTIONS(539),
    [anon_sym_void] = ACTIONS(561),
    [anon_sym_delete] = ACTIONS(561),
    [anon_sym_PLUS_PLUS] = ACTIONS(563),
    [anon_sym_DASH_DASH] = ACTIONS(563),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(529),
    [anon_sym_get] = ACTIONS(529),
    [anon_sym_set] = ACTIONS(529),
    [anon_sym_declare] = ACTIONS(529),
    [anon_sym_public] = ACTIONS(529),
    [anon_sym_private] = ACTIONS(529),
    [anon_sym_protected] = ACTIONS(529),
    [anon_sym_module] = ACTIONS(529),
    [anon_sym_any] = ACTIONS(529),
    [anon_sym_number] = ACTIONS(529),
    [anon_sym_boolean] = ACTIONS(529),
    [anon_sym_string] = ACTIONS(529),
    [anon_sym_symbol] = ACTIONS(529),
    [sym_readonly] = ACTIONS(529),
  },
  [192] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(884),
    [sym__expression] = STATE(1488),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1283),
    [sym_array] = STATE(1281),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3336),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(884),
    [sym_subscript_expression] = STATE(884),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1964),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_sequence_expression] = STATE(3197),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(860),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(414),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(831),
    [anon_sym_export] = ACTIONS(503),
    [anon_sym_namespace] = ACTIONS(505),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_type] = ACTIONS(503),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(437),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(443),
    [anon_sym_yield] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(849),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(851),
    [anon_sym_TILDE] = ACTIONS(437),
    [anon_sym_void] = ACTIONS(471),
    [anon_sym_delete] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(473),
    [anon_sym_DASH_DASH] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(503),
    [anon_sym_get] = ACTIONS(503),
    [anon_sym_set] = ACTIONS(503),
    [anon_sym_declare] = ACTIONS(503),
    [anon_sym_public] = ACTIONS(503),
    [anon_sym_private] = ACTIONS(503),
    [anon_sym_protected] = ACTIONS(503),
    [anon_sym_module] = ACTIONS(503),
    [anon_sym_any] = ACTIONS(503),
    [anon_sym_number] = ACTIONS(503),
    [anon_sym_boolean] = ACTIONS(503),
    [anon_sym_string] = ACTIONS(503),
    [anon_sym_symbol] = ACTIONS(503),
    [sym_readonly] = ACTIONS(503),
  },
  [193] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(884),
    [sym__expression] = STATE(1466),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1283),
    [sym_array] = STATE(1281),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3336),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(884),
    [sym_subscript_expression] = STATE(884),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1964),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_sequence_expression] = STATE(3291),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(860),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(414),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(831),
    [anon_sym_export] = ACTIONS(503),
    [anon_sym_namespace] = ACTIONS(505),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_type] = ACTIONS(503),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(437),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(443),
    [anon_sym_yield] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(849),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(851),
    [anon_sym_TILDE] = ACTIONS(437),
    [anon_sym_void] = ACTIONS(471),
    [anon_sym_delete] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(473),
    [anon_sym_DASH_DASH] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(503),
    [anon_sym_get] = ACTIONS(503),
    [anon_sym_set] = ACTIONS(503),
    [anon_sym_declare] = ACTIONS(503),
    [anon_sym_public] = ACTIONS(503),
    [anon_sym_private] = ACTIONS(503),
    [anon_sym_protected] = ACTIONS(503),
    [anon_sym_module] = ACTIONS(503),
    [anon_sym_any] = ACTIONS(503),
    [anon_sym_number] = ACTIONS(503),
    [anon_sym_boolean] = ACTIONS(503),
    [anon_sym_string] = ACTIONS(503),
    [anon_sym_symbol] = ACTIONS(503),
    [sym_readonly] = ACTIONS(503),
  },
  [194] = {
    [sym_import] = STATE(1528),
    [sym_statement_block] = STATE(1669),
    [sym_parenthesized_expression] = STATE(933),
    [sym__expression] = STATE(1241),
    [sym_yield_expression] = STATE(1543),
    [sym_object] = STATE(1367),
    [sym_array] = STATE(1369),
    [sym_class] = STATE(1528),
    [sym_function] = STATE(1528),
    [sym_generator_function] = STATE(1528),
    [sym_arrow_function] = STATE(1528),
    [sym__call_signature] = STATE(3359),
    [sym_call_expression] = STATE(1528),
    [sym_new_expression] = STATE(1543),
    [sym_await_expression] = STATE(1543),
    [sym_member_expression] = STATE(933),
    [sym_subscript_expression] = STATE(933),
    [sym_assignment_expression] = STATE(1543),
    [sym__augmented_assignment_lhs] = STATE(1970),
    [sym_augmented_assignment_expression] = STATE(1543),
    [sym_ternary_expression] = STATE(1543),
    [sym_binary_expression] = STATE(1543),
    [sym_unary_expression] = STATE(1543),
    [sym_update_expression] = STATE(1543),
    [sym_string] = STATE(1528),
    [sym_template_string] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_meta_property] = STATE(1528),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(936),
    [sym_type_assertion] = STATE(1543),
    [sym_as_expression] = STATE(1543),
    [sym_internal_module] = STATE(1543),
    [sym_type_arguments] = STATE(381),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2726),
    [sym_identifier] = ACTIONS(855),
    [anon_sym_export] = ACTIONS(745),
    [anon_sym_namespace] = ACTIONS(747),
    [anon_sym_LBRACE] = ACTIONS(1338),
    [anon_sym_type] = ACTIONS(745),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(537),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(549),
    [anon_sym_async] = ACTIONS(753),
    [anon_sym_function] = ACTIONS(553),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(745),
    [anon_sym_get] = ACTIONS(745),
    [anon_sym_set] = ACTIONS(745),
    [anon_sym_declare] = ACTIONS(745),
    [anon_sym_public] = ACTIONS(745),
    [anon_sym_private] = ACTIONS(745),
    [anon_sym_protected] = ACTIONS(745),
    [anon_sym_module] = ACTIONS(745),
    [anon_sym_any] = ACTIONS(745),
    [anon_sym_number] = ACTIONS(745),
    [anon_sym_boolean] = ACTIONS(745),
    [anon_sym_string] = ACTIONS(745),
    [anon_sym_symbol] = ACTIONS(745),
    [sym_readonly] = ACTIONS(745),
  },
  [195] = {
    [sym_import] = STATE(1724),
    [sym_statement_block] = STATE(1679),
    [sym_parenthesized_expression] = STATE(963),
    [sym__expression] = STATE(1277),
    [sym_yield_expression] = STATE(1722),
    [sym_object] = STATE(1536),
    [sym_array] = STATE(1535),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(3286),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1722),
    [sym_await_expression] = STATE(1722),
    [sym_member_expression] = STATE(963),
    [sym_subscript_expression] = STATE(963),
    [sym_assignment_expression] = STATE(1722),
    [sym__augmented_assignment_lhs] = STATE(1968),
    [sym_augmented_assignment_expression] = STATE(1722),
    [sym_ternary_expression] = STATE(1722),
    [sym_binary_expression] = STATE(1722),
    [sym_unary_expression] = STATE(1722),
    [sym_update_expression] = STATE(1722),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(952),
    [sym_type_assertion] = STATE(1722),
    [sym_as_expression] = STATE(1722),
    [sym_internal_module] = STATE(1722),
    [sym_type_arguments] = STATE(266),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2684),
    [sym_identifier] = ACTIONS(863),
    [anon_sym_export] = ACTIONS(655),
    [anon_sym_namespace] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(1340),
    [anon_sym_type] = ACTIONS(655),
    [anon_sym_typeof] = ACTIONS(689),
    [anon_sym_import] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_LPAREN] = ACTIONS(871),
    [anon_sym_await] = ACTIONS(669),
    [anon_sym_yield] = ACTIONS(671),
    [anon_sym_LBRACK] = ACTIONS(873),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(675),
    [anon_sym_class] = ACTIONS(677),
    [anon_sym_async] = ACTIONS(679),
    [anon_sym_function] = ACTIONS(681),
    [anon_sym_new] = ACTIONS(875),
    [anon_sym_PLUS] = ACTIONS(877),
    [anon_sym_DASH] = ACTIONS(877),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_void] = ACTIONS(689),
    [anon_sym_delete] = ACTIONS(689),
    [anon_sym_PLUS_PLUS] = ACTIONS(691),
    [anon_sym_DASH_DASH] = ACTIONS(691),
    [anon_sym_DQUOTE] = ACTIONS(693),
    [anon_sym_SQUOTE] = ACTIONS(695),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(697),
    [sym_number] = ACTIONS(879),
    [sym_this] = ACTIONS(703),
    [sym_super] = ACTIONS(703),
    [sym_true] = ACTIONS(703),
    [sym_false] = ACTIONS(703),
    [sym_null] = ACTIONS(703),
    [sym_undefined] = ACTIONS(703),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(655),
    [anon_sym_get] = ACTIONS(655),
    [anon_sym_set] = ACTIONS(655),
    [anon_sym_declare] = ACTIONS(655),
    [anon_sym_public] = ACTIONS(655),
    [anon_sym_private] = ACTIONS(655),
    [anon_sym_protected] = ACTIONS(655),
    [anon_sym_module] = ACTIONS(655),
    [anon_sym_any] = ACTIONS(655),
    [anon_sym_number] = ACTIONS(655),
    [anon_sym_boolean] = ACTIONS(655),
    [anon_sym_string] = ACTIONS(655),
    [anon_sym_symbol] = ACTIONS(655),
    [sym_readonly] = ACTIONS(655),
  },
  [196] = {
    [sym_import] = STATE(1528),
    [sym_statement_block] = STATE(1670),
    [sym_parenthesized_expression] = STATE(933),
    [sym__expression] = STATE(1134),
    [sym_yield_expression] = STATE(1543),
    [sym_object] = STATE(1367),
    [sym_array] = STATE(1369),
    [sym_class] = STATE(1528),
    [sym_function] = STATE(1528),
    [sym_generator_function] = STATE(1528),
    [sym_arrow_function] = STATE(1528),
    [sym__call_signature] = STATE(3359),
    [sym_call_expression] = STATE(1528),
    [sym_new_expression] = STATE(1543),
    [sym_await_expression] = STATE(1543),
    [sym_member_expression] = STATE(933),
    [sym_subscript_expression] = STATE(933),
    [sym_assignment_expression] = STATE(1543),
    [sym__augmented_assignment_lhs] = STATE(1970),
    [sym_augmented_assignment_expression] = STATE(1543),
    [sym_ternary_expression] = STATE(1543),
    [sym_binary_expression] = STATE(1543),
    [sym_unary_expression] = STATE(1543),
    [sym_update_expression] = STATE(1543),
    [sym_string] = STATE(1528),
    [sym_template_string] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_meta_property] = STATE(1528),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(936),
    [sym_type_assertion] = STATE(1543),
    [sym_as_expression] = STATE(1543),
    [sym_internal_module] = STATE(1543),
    [sym_type_arguments] = STATE(381),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2726),
    [sym_identifier] = ACTIONS(855),
    [anon_sym_export] = ACTIONS(745),
    [anon_sym_namespace] = ACTIONS(747),
    [anon_sym_LBRACE] = ACTIONS(1338),
    [anon_sym_type] = ACTIONS(745),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(537),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(549),
    [anon_sym_async] = ACTIONS(753),
    [anon_sym_function] = ACTIONS(553),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(745),
    [anon_sym_get] = ACTIONS(745),
    [anon_sym_set] = ACTIONS(745),
    [anon_sym_declare] = ACTIONS(745),
    [anon_sym_public] = ACTIONS(745),
    [anon_sym_private] = ACTIONS(745),
    [anon_sym_protected] = ACTIONS(745),
    [anon_sym_module] = ACTIONS(745),
    [anon_sym_any] = ACTIONS(745),
    [anon_sym_number] = ACTIONS(745),
    [anon_sym_boolean] = ACTIONS(745),
    [anon_sym_string] = ACTIONS(745),
    [anon_sym_symbol] = ACTIONS(745),
    [sym_readonly] = ACTIONS(745),
  },
  [197] = {
    [sym_import] = STATE(1265),
    [sym_parenthesized_expression] = STATE(751),
    [sym__expression] = STATE(1697),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1195),
    [sym_array] = STATE(1181),
    [sym_class] = STATE(1265),
    [sym_function] = STATE(1265),
    [sym_generator_function] = STATE(1265),
    [sym_arrow_function] = STATE(1265),
    [sym__call_signature] = STATE(3235),
    [sym_call_expression] = STATE(1265),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(751),
    [sym_subscript_expression] = STATE(751),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1967),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1265),
    [sym_template_string] = STATE(1265),
    [sym_regex] = STATE(1265),
    [sym_meta_property] = STATE(1265),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2377),
    [sym_non_null_expression] = STATE(977),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(380),
    [sym_type_parameters] = STATE(2982),
    [aux_sym_export_statement_repeat1] = STATE(2726),
    [sym_identifier] = ACTIONS(1380),
    [anon_sym_export] = ACTIONS(1382),
    [anon_sym_namespace] = ACTIONS(1384),
    [anon_sym_LBRACE] = ACTIONS(859),
    [anon_sym_type] = ACTIONS(1382),
    [anon_sym_typeof] = ACTIONS(639),
    [anon_sym_import] = ACTIONS(537),
    [anon_sym_BANG] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(625),
    [anon_sym_yield] = ACTIONS(627),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_DOT] = ACTIONS(1348),
    [anon_sym_class] = ACTIONS(549),
    [anon_sym_async] = ACTIONS(1386),
    [anon_sym_function] = ACTIONS(553),
    [anon_sym_new] = ACTIONS(1352),
    [anon_sym_PLUS] = ACTIONS(889),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(623),
    [anon_sym_void] = ACTIONS(639),
    [anon_sym_delete] = ACTIONS(639),
    [anon_sym_PLUS_PLUS] = ACTIONS(641),
    [anon_sym_DASH_DASH] = ACTIONS(641),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(1354),
    [sym_this] = ACTIONS(1356),
    [sym_super] = ACTIONS(1356),
    [sym_true] = ACTIONS(1356),
    [sym_false] = ACTIONS(1356),
    [sym_null] = ACTIONS(1356),
    [sym_undefined] = ACTIONS(1356),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1382),
    [anon_sym_get] = ACTIONS(1382),
    [anon_sym_set] = ACTIONS(1382),
    [anon_sym_declare] = ACTIONS(1382),
    [anon_sym_public] = ACTIONS(1382),
    [anon_sym_private] = ACTIONS(1382),
    [anon_sym_protected] = ACTIONS(1382),
    [anon_sym_module] = ACTIONS(1382),
    [anon_sym_any] = ACTIONS(1382),
    [anon_sym_number] = ACTIONS(1382),
    [anon_sym_boolean] = ACTIONS(1382),
    [anon_sym_string] = ACTIONS(1382),
    [anon_sym_symbol] = ACTIONS(1382),
    [sym_readonly] = ACTIONS(1382),
  },
  [198] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(884),
    [sym__expression] = STATE(1460),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1283),
    [sym_array] = STATE(1281),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3336),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(884),
    [sym_subscript_expression] = STATE(884),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1964),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_sequence_expression] = STATE(3305),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(860),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(414),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(831),
    [anon_sym_export] = ACTIONS(503),
    [anon_sym_namespace] = ACTIONS(505),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_type] = ACTIONS(503),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(437),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(443),
    [anon_sym_yield] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(849),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(851),
    [anon_sym_TILDE] = ACTIONS(437),
    [anon_sym_void] = ACTIONS(471),
    [anon_sym_delete] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(473),
    [anon_sym_DASH_DASH] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(503),
    [anon_sym_get] = ACTIONS(503),
    [anon_sym_set] = ACTIONS(503),
    [anon_sym_declare] = ACTIONS(503),
    [anon_sym_public] = ACTIONS(503),
    [anon_sym_private] = ACTIONS(503),
    [anon_sym_protected] = ACTIONS(503),
    [anon_sym_module] = ACTIONS(503),
    [anon_sym_any] = ACTIONS(503),
    [anon_sym_number] = ACTIONS(503),
    [anon_sym_boolean] = ACTIONS(503),
    [anon_sym_string] = ACTIONS(503),
    [anon_sym_symbol] = ACTIONS(503),
    [sym_readonly] = ACTIONS(503),
  },
  [199] = {
    [sym_import] = STATE(1528),
    [sym_statement_block] = STATE(1512),
    [sym_parenthesized_expression] = STATE(933),
    [sym__expression] = STATE(1194),
    [sym_yield_expression] = STATE(1543),
    [sym_object] = STATE(1367),
    [sym_array] = STATE(1369),
    [sym_class] = STATE(1528),
    [sym_function] = STATE(1528),
    [sym_generator_function] = STATE(1528),
    [sym_arrow_function] = STATE(1528),
    [sym__call_signature] = STATE(3359),
    [sym_call_expression] = STATE(1528),
    [sym_new_expression] = STATE(1543),
    [sym_await_expression] = STATE(1543),
    [sym_member_expression] = STATE(933),
    [sym_subscript_expression] = STATE(933),
    [sym_assignment_expression] = STATE(1543),
    [sym__augmented_assignment_lhs] = STATE(1970),
    [sym_augmented_assignment_expression] = STATE(1543),
    [sym_ternary_expression] = STATE(1543),
    [sym_binary_expression] = STATE(1543),
    [sym_unary_expression] = STATE(1543),
    [sym_update_expression] = STATE(1543),
    [sym_string] = STATE(1528),
    [sym_template_string] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_meta_property] = STATE(1528),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(936),
    [sym_type_assertion] = STATE(1543),
    [sym_as_expression] = STATE(1543),
    [sym_internal_module] = STATE(1543),
    [sym_type_arguments] = STATE(381),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2726),
    [sym_identifier] = ACTIONS(855),
    [anon_sym_export] = ACTIONS(745),
    [anon_sym_namespace] = ACTIONS(747),
    [anon_sym_LBRACE] = ACTIONS(1338),
    [anon_sym_type] = ACTIONS(745),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(537),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(549),
    [anon_sym_async] = ACTIONS(753),
    [anon_sym_function] = ACTIONS(553),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(745),
    [anon_sym_get] = ACTIONS(745),
    [anon_sym_set] = ACTIONS(745),
    [anon_sym_declare] = ACTIONS(745),
    [anon_sym_public] = ACTIONS(745),
    [anon_sym_private] = ACTIONS(745),
    [anon_sym_protected] = ACTIONS(745),
    [anon_sym_module] = ACTIONS(745),
    [anon_sym_any] = ACTIONS(745),
    [anon_sym_number] = ACTIONS(745),
    [anon_sym_boolean] = ACTIONS(745),
    [anon_sym_string] = ACTIONS(745),
    [anon_sym_symbol] = ACTIONS(745),
    [sym_readonly] = ACTIONS(745),
  },
  [200] = {
    [sym_import] = STATE(1212),
    [sym_statement_block] = STATE(1201),
    [sym_parenthesized_expression] = STATE(965),
    [sym__expression] = STATE(1296),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1524),
    [sym_array] = STATE(1523),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3348),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(965),
    [sym_subscript_expression] = STATE(965),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1969),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(975),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(302),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(901),
    [anon_sym_export] = ACTIONS(713),
    [anon_sym_namespace] = ACTIONS(715),
    [anon_sym_LBRACE] = ACTIONS(1336),
    [anon_sym_type] = ACTIONS(713),
    [anon_sym_typeof] = ACTIONS(735),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(719),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(721),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(725),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(727),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(907),
    [anon_sym_PLUS] = ACTIONS(909),
    [anon_sym_DASH] = ACTIONS(909),
    [anon_sym_TILDE] = ACTIONS(719),
    [anon_sym_void] = ACTIONS(735),
    [anon_sym_delete] = ACTIONS(735),
    [anon_sym_PLUS_PLUS] = ACTIONS(737),
    [anon_sym_DASH_DASH] = ACTIONS(737),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(713),
    [anon_sym_get] = ACTIONS(713),
    [anon_sym_set] = ACTIONS(713),
    [anon_sym_declare] = ACTIONS(713),
    [anon_sym_public] = ACTIONS(713),
    [anon_sym_private] = ACTIONS(713),
    [anon_sym_protected] = ACTIONS(713),
    [anon_sym_module] = ACTIONS(713),
    [anon_sym_any] = ACTIONS(713),
    [anon_sym_number] = ACTIONS(713),
    [anon_sym_boolean] = ACTIONS(713),
    [anon_sym_string] = ACTIONS(713),
    [anon_sym_symbol] = ACTIONS(713),
    [sym_readonly] = ACTIONS(713),
  },
  [201] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(884),
    [sym__expression] = STATE(1162),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1283),
    [sym_array] = STATE(1281),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3336),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(884),
    [sym_subscript_expression] = STATE(884),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1964),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_sequence_expression] = STATE(3389),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(860),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(414),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(831),
    [anon_sym_export] = ACTIONS(503),
    [anon_sym_namespace] = ACTIONS(505),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_type] = ACTIONS(503),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(437),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(443),
    [anon_sym_yield] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(849),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(851),
    [anon_sym_TILDE] = ACTIONS(437),
    [anon_sym_void] = ACTIONS(471),
    [anon_sym_delete] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(473),
    [anon_sym_DASH_DASH] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(503),
    [anon_sym_get] = ACTIONS(503),
    [anon_sym_set] = ACTIONS(503),
    [anon_sym_declare] = ACTIONS(503),
    [anon_sym_public] = ACTIONS(503),
    [anon_sym_private] = ACTIONS(503),
    [anon_sym_protected] = ACTIONS(503),
    [anon_sym_module] = ACTIONS(503),
    [anon_sym_any] = ACTIONS(503),
    [anon_sym_number] = ACTIONS(503),
    [anon_sym_boolean] = ACTIONS(503),
    [anon_sym_string] = ACTIONS(503),
    [anon_sym_symbol] = ACTIONS(503),
    [sym_readonly] = ACTIONS(503),
  },
  [202] = {
    [sym_import] = STATE(1724),
    [sym_statement_block] = STATE(1726),
    [sym_parenthesized_expression] = STATE(963),
    [sym__expression] = STATE(1253),
    [sym_yield_expression] = STATE(1722),
    [sym_object] = STATE(1536),
    [sym_array] = STATE(1535),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(3286),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1722),
    [sym_await_expression] = STATE(1722),
    [sym_member_expression] = STATE(963),
    [sym_subscript_expression] = STATE(963),
    [sym_assignment_expression] = STATE(1722),
    [sym__augmented_assignment_lhs] = STATE(1968),
    [sym_augmented_assignment_expression] = STATE(1722),
    [sym_ternary_expression] = STATE(1722),
    [sym_binary_expression] = STATE(1722),
    [sym_unary_expression] = STATE(1722),
    [sym_update_expression] = STATE(1722),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(952),
    [sym_type_assertion] = STATE(1722),
    [sym_as_expression] = STATE(1722),
    [sym_internal_module] = STATE(1722),
    [sym_type_arguments] = STATE(266),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2684),
    [sym_identifier] = ACTIONS(863),
    [anon_sym_export] = ACTIONS(655),
    [anon_sym_namespace] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(1340),
    [anon_sym_type] = ACTIONS(655),
    [anon_sym_typeof] = ACTIONS(689),
    [anon_sym_import] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_LPAREN] = ACTIONS(871),
    [anon_sym_await] = ACTIONS(669),
    [anon_sym_yield] = ACTIONS(671),
    [anon_sym_LBRACK] = ACTIONS(873),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(675),
    [anon_sym_class] = ACTIONS(677),
    [anon_sym_async] = ACTIONS(679),
    [anon_sym_function] = ACTIONS(681),
    [anon_sym_new] = ACTIONS(875),
    [anon_sym_PLUS] = ACTIONS(877),
    [anon_sym_DASH] = ACTIONS(877),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_void] = ACTIONS(689),
    [anon_sym_delete] = ACTIONS(689),
    [anon_sym_PLUS_PLUS] = ACTIONS(691),
    [anon_sym_DASH_DASH] = ACTIONS(691),
    [anon_sym_DQUOTE] = ACTIONS(693),
    [anon_sym_SQUOTE] = ACTIONS(695),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(697),
    [sym_number] = ACTIONS(879),
    [sym_this] = ACTIONS(703),
    [sym_super] = ACTIONS(703),
    [sym_true] = ACTIONS(703),
    [sym_false] = ACTIONS(703),
    [sym_null] = ACTIONS(703),
    [sym_undefined] = ACTIONS(703),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(655),
    [anon_sym_get] = ACTIONS(655),
    [anon_sym_set] = ACTIONS(655),
    [anon_sym_declare] = ACTIONS(655),
    [anon_sym_public] = ACTIONS(655),
    [anon_sym_private] = ACTIONS(655),
    [anon_sym_protected] = ACTIONS(655),
    [anon_sym_module] = ACTIONS(655),
    [anon_sym_any] = ACTIONS(655),
    [anon_sym_number] = ACTIONS(655),
    [anon_sym_boolean] = ACTIONS(655),
    [anon_sym_string] = ACTIONS(655),
    [anon_sym_symbol] = ACTIONS(655),
    [sym_readonly] = ACTIONS(655),
  },
  [203] = {
    [sym_import] = STATE(1212),
    [sym_statement_block] = STATE(1143),
    [sym_parenthesized_expression] = STATE(965),
    [sym__expression] = STATE(1305),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1524),
    [sym_array] = STATE(1523),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3348),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(965),
    [sym_subscript_expression] = STATE(965),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1969),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(975),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(302),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(901),
    [anon_sym_export] = ACTIONS(713),
    [anon_sym_namespace] = ACTIONS(715),
    [anon_sym_LBRACE] = ACTIONS(1336),
    [anon_sym_type] = ACTIONS(713),
    [anon_sym_typeof] = ACTIONS(735),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(719),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(721),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(725),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(727),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(907),
    [anon_sym_PLUS] = ACTIONS(909),
    [anon_sym_DASH] = ACTIONS(909),
    [anon_sym_TILDE] = ACTIONS(719),
    [anon_sym_void] = ACTIONS(735),
    [anon_sym_delete] = ACTIONS(735),
    [anon_sym_PLUS_PLUS] = ACTIONS(737),
    [anon_sym_DASH_DASH] = ACTIONS(737),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(713),
    [anon_sym_get] = ACTIONS(713),
    [anon_sym_set] = ACTIONS(713),
    [anon_sym_declare] = ACTIONS(713),
    [anon_sym_public] = ACTIONS(713),
    [anon_sym_private] = ACTIONS(713),
    [anon_sym_protected] = ACTIONS(713),
    [anon_sym_module] = ACTIONS(713),
    [anon_sym_any] = ACTIONS(713),
    [anon_sym_number] = ACTIONS(713),
    [anon_sym_boolean] = ACTIONS(713),
    [anon_sym_string] = ACTIONS(713),
    [anon_sym_symbol] = ACTIONS(713),
    [sym_readonly] = ACTIONS(713),
  },
  [204] = {
    [sym_import] = STATE(1039),
    [sym_parenthesized_expression] = STATE(661),
    [sym__expression] = STATE(1682),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1023),
    [sym_array] = STATE(1024),
    [sym_class] = STATE(1039),
    [sym_function] = STATE(1039),
    [sym_generator_function] = STATE(1039),
    [sym_arrow_function] = STATE(1039),
    [sym__call_signature] = STATE(3336),
    [sym_call_expression] = STATE(1039),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(661),
    [sym_subscript_expression] = STATE(661),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1967),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1039),
    [sym_template_string] = STATE(1039),
    [sym_regex] = STATE(1039),
    [sym_meta_property] = STATE(1039),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(977),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(380),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(1388),
    [anon_sym_export] = ACTIONS(1390),
    [anon_sym_namespace] = ACTIONS(1392),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_type] = ACTIONS(1390),
    [anon_sym_typeof] = ACTIONS(639),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(625),
    [anon_sym_yield] = ACTIONS(627),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_DOT] = ACTIONS(1372),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(1394),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(887),
    [anon_sym_PLUS] = ACTIONS(889),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(623),
    [anon_sym_void] = ACTIONS(639),
    [anon_sym_delete] = ACTIONS(639),
    [anon_sym_PLUS_PLUS] = ACTIONS(641),
    [anon_sym_DASH_DASH] = ACTIONS(641),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(1376),
    [sym_this] = ACTIONS(1378),
    [sym_super] = ACTIONS(1378),
    [sym_true] = ACTIONS(1378),
    [sym_false] = ACTIONS(1378),
    [sym_null] = ACTIONS(1378),
    [sym_undefined] = ACTIONS(1378),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1390),
    [anon_sym_get] = ACTIONS(1390),
    [anon_sym_set] = ACTIONS(1390),
    [anon_sym_declare] = ACTIONS(1390),
    [anon_sym_public] = ACTIONS(1390),
    [anon_sym_private] = ACTIONS(1390),
    [anon_sym_protected] = ACTIONS(1390),
    [anon_sym_module] = ACTIONS(1390),
    [anon_sym_any] = ACTIONS(1390),
    [anon_sym_number] = ACTIONS(1390),
    [anon_sym_boolean] = ACTIONS(1390),
    [anon_sym_string] = ACTIONS(1390),
    [anon_sym_symbol] = ACTIONS(1390),
    [sym_readonly] = ACTIONS(1390),
  },
  [205] = {
    [sym_import] = STATE(1724),
    [sym_statement_block] = STATE(1733),
    [sym_parenthesized_expression] = STATE(963),
    [sym__expression] = STATE(1258),
    [sym_yield_expression] = STATE(1722),
    [sym_object] = STATE(1536),
    [sym_array] = STATE(1535),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(3286),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1722),
    [sym_await_expression] = STATE(1722),
    [sym_member_expression] = STATE(963),
    [sym_subscript_expression] = STATE(963),
    [sym_assignment_expression] = STATE(1722),
    [sym__augmented_assignment_lhs] = STATE(1968),
    [sym_augmented_assignment_expression] = STATE(1722),
    [sym_ternary_expression] = STATE(1722),
    [sym_binary_expression] = STATE(1722),
    [sym_unary_expression] = STATE(1722),
    [sym_update_expression] = STATE(1722),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(952),
    [sym_type_assertion] = STATE(1722),
    [sym_as_expression] = STATE(1722),
    [sym_internal_module] = STATE(1722),
    [sym_type_arguments] = STATE(266),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2684),
    [sym_identifier] = ACTIONS(863),
    [anon_sym_export] = ACTIONS(655),
    [anon_sym_namespace] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(1340),
    [anon_sym_type] = ACTIONS(655),
    [anon_sym_typeof] = ACTIONS(689),
    [anon_sym_import] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_LPAREN] = ACTIONS(871),
    [anon_sym_await] = ACTIONS(669),
    [anon_sym_yield] = ACTIONS(671),
    [anon_sym_LBRACK] = ACTIONS(873),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(675),
    [anon_sym_class] = ACTIONS(677),
    [anon_sym_async] = ACTIONS(679),
    [anon_sym_function] = ACTIONS(681),
    [anon_sym_new] = ACTIONS(875),
    [anon_sym_PLUS] = ACTIONS(877),
    [anon_sym_DASH] = ACTIONS(877),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_void] = ACTIONS(689),
    [anon_sym_delete] = ACTIONS(689),
    [anon_sym_PLUS_PLUS] = ACTIONS(691),
    [anon_sym_DASH_DASH] = ACTIONS(691),
    [anon_sym_DQUOTE] = ACTIONS(693),
    [anon_sym_SQUOTE] = ACTIONS(695),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(697),
    [sym_number] = ACTIONS(879),
    [sym_this] = ACTIONS(703),
    [sym_super] = ACTIONS(703),
    [sym_true] = ACTIONS(703),
    [sym_false] = ACTIONS(703),
    [sym_null] = ACTIONS(703),
    [sym_undefined] = ACTIONS(703),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(655),
    [anon_sym_get] = ACTIONS(655),
    [anon_sym_set] = ACTIONS(655),
    [anon_sym_declare] = ACTIONS(655),
    [anon_sym_public] = ACTIONS(655),
    [anon_sym_private] = ACTIONS(655),
    [anon_sym_protected] = ACTIONS(655),
    [anon_sym_module] = ACTIONS(655),
    [anon_sym_any] = ACTIONS(655),
    [anon_sym_number] = ACTIONS(655),
    [anon_sym_boolean] = ACTIONS(655),
    [anon_sym_string] = ACTIONS(655),
    [anon_sym_symbol] = ACTIONS(655),
    [sym_readonly] = ACTIONS(655),
  },
  [206] = {
    [ts_builtin_sym_end] = ACTIONS(1396),
    [sym_identifier] = ACTIONS(1398),
    [anon_sym_export] = ACTIONS(1398),
    [anon_sym_default] = ACTIONS(1398),
    [anon_sym_EQ] = ACTIONS(1398),
    [anon_sym_namespace] = ACTIONS(1398),
    [anon_sym_LBRACE] = ACTIONS(1396),
    [anon_sym_COMMA] = ACTIONS(1396),
    [anon_sym_RBRACE] = ACTIONS(1396),
    [anon_sym_type] = ACTIONS(1398),
    [anon_sym_typeof] = ACTIONS(1398),
    [anon_sym_import] = ACTIONS(1398),
    [anon_sym_var] = ACTIONS(1398),
    [anon_sym_let] = ACTIONS(1398),
    [anon_sym_const] = ACTIONS(1398),
    [anon_sym_BANG] = ACTIONS(1396),
    [anon_sym_else] = ACTIONS(1398),
    [anon_sym_if] = ACTIONS(1398),
    [anon_sym_switch] = ACTIONS(1398),
    [anon_sym_for] = ACTIONS(1398),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(1396),
    [anon_sym_await] = ACTIONS(1398),
    [anon_sym_while] = ACTIONS(1398),
    [anon_sym_do] = ACTIONS(1398),
    [anon_sym_try] = ACTIONS(1398),
    [anon_sym_with] = ACTIONS(1398),
    [anon_sym_break] = ACTIONS(1398),
    [anon_sym_continue] = ACTIONS(1398),
    [anon_sym_debugger] = ACTIONS(1398),
    [anon_sym_return] = ACTIONS(1398),
    [anon_sym_throw] = ACTIONS(1398),
    [anon_sym_SEMI] = ACTIONS(1396),
    [anon_sym_COLON] = ACTIONS(1396),
    [anon_sym_case] = ACTIONS(1398),
    [anon_sym_yield] = ACTIONS(1398),
    [anon_sym_LBRACK] = ACTIONS(1396),
    [anon_sym_RBRACK] = ACTIONS(1396),
    [anon_sym_LT] = ACTIONS(1396),
    [anon_sym_GT] = ACTIONS(1396),
    [anon_sym_SLASH] = ACTIONS(1398),
    [anon_sym_DOT] = ACTIONS(1017),
    [anon_sym_class] = ACTIONS(1398),
    [anon_sym_async] = ACTIONS(1398),
    [anon_sym_function] = ACTIONS(1398),
    [anon_sym_EQ_GT] = ACTIONS(1396),
    [anon_sym_new] = ACTIONS(1398),
    [anon_sym_QMARK] = ACTIONS(1396),
    [anon_sym_AMP] = ACTIONS(1396),
    [anon_sym_PIPE] = ACTIONS(1396),
    [anon_sym_PLUS] = ACTIONS(1398),
    [anon_sym_DASH] = ACTIONS(1398),
    [anon_sym_TILDE] = ACTIONS(1396),
    [anon_sym_void] = ACTIONS(1398),
    [anon_sym_delete] = ACTIONS(1398),
    [anon_sym_PLUS_PLUS] = ACTIONS(1396),
    [anon_sym_DASH_DASH] = ACTIONS(1396),
    [anon_sym_DQUOTE] = ACTIONS(1396),
    [anon_sym_SQUOTE] = ACTIONS(1396),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1396),
    [sym_number] = ACTIONS(1396),
    [sym_this] = ACTIONS(1398),
    [sym_super] = ACTIONS(1398),
    [sym_true] = ACTIONS(1398),
    [sym_false] = ACTIONS(1398),
    [sym_null] = ACTIONS(1398),
    [sym_undefined] = ACTIONS(1398),
    [anon_sym_AT] = ACTIONS(1396),
    [anon_sym_static] = ACTIONS(1398),
    [anon_sym_abstract] = ACTIONS(1398),
    [anon_sym_get] = ACTIONS(1398),
    [anon_sym_set] = ACTIONS(1398),
    [anon_sym_declare] = ACTIONS(1398),
    [anon_sym_public] = ACTIONS(1398),
    [anon_sym_private] = ACTIONS(1398),
    [anon_sym_protected] = ACTIONS(1398),
    [anon_sym_module] = ACTIONS(1398),
    [anon_sym_any] = ACTIONS(1398),
    [anon_sym_number] = ACTIONS(1398),
    [anon_sym_boolean] = ACTIONS(1398),
    [anon_sym_string] = ACTIONS(1398),
    [anon_sym_symbol] = ACTIONS(1398),
    [anon_sym_implements] = ACTIONS(1398),
    [anon_sym_interface] = ACTIONS(1398),
    [anon_sym_extends] = ACTIONS(1398),
    [anon_sym_enum] = ACTIONS(1398),
    [sym_readonly] = ACTIONS(1398),
  },
  [207] = {
    [sym_import] = STATE(1724),
    [sym_statement_block] = STATE(1734),
    [sym_parenthesized_expression] = STATE(963),
    [sym__expression] = STATE(1259),
    [sym_yield_expression] = STATE(1722),
    [sym_object] = STATE(1536),
    [sym_array] = STATE(1535),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(3286),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1722),
    [sym_await_expression] = STATE(1722),
    [sym_member_expression] = STATE(963),
    [sym_subscript_expression] = STATE(963),
    [sym_assignment_expression] = STATE(1722),
    [sym__augmented_assignment_lhs] = STATE(1968),
    [sym_augmented_assignment_expression] = STATE(1722),
    [sym_ternary_expression] = STATE(1722),
    [sym_binary_expression] = STATE(1722),
    [sym_unary_expression] = STATE(1722),
    [sym_update_expression] = STATE(1722),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(952),
    [sym_type_assertion] = STATE(1722),
    [sym_as_expression] = STATE(1722),
    [sym_internal_module] = STATE(1722),
    [sym_type_arguments] = STATE(266),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2684),
    [sym_identifier] = ACTIONS(863),
    [anon_sym_export] = ACTIONS(655),
    [anon_sym_namespace] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(1340),
    [anon_sym_type] = ACTIONS(655),
    [anon_sym_typeof] = ACTIONS(689),
    [anon_sym_import] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_LPAREN] = ACTIONS(871),
    [anon_sym_await] = ACTIONS(669),
    [anon_sym_yield] = ACTIONS(671),
    [anon_sym_LBRACK] = ACTIONS(873),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(675),
    [anon_sym_class] = ACTIONS(677),
    [anon_sym_async] = ACTIONS(679),
    [anon_sym_function] = ACTIONS(681),
    [anon_sym_new] = ACTIONS(875),
    [anon_sym_PLUS] = ACTIONS(877),
    [anon_sym_DASH] = ACTIONS(877),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_void] = ACTIONS(689),
    [anon_sym_delete] = ACTIONS(689),
    [anon_sym_PLUS_PLUS] = ACTIONS(691),
    [anon_sym_DASH_DASH] = ACTIONS(691),
    [anon_sym_DQUOTE] = ACTIONS(693),
    [anon_sym_SQUOTE] = ACTIONS(695),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(697),
    [sym_number] = ACTIONS(879),
    [sym_this] = ACTIONS(703),
    [sym_super] = ACTIONS(703),
    [sym_true] = ACTIONS(703),
    [sym_false] = ACTIONS(703),
    [sym_null] = ACTIONS(703),
    [sym_undefined] = ACTIONS(703),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(655),
    [anon_sym_get] = ACTIONS(655),
    [anon_sym_set] = ACTIONS(655),
    [anon_sym_declare] = ACTIONS(655),
    [anon_sym_public] = ACTIONS(655),
    [anon_sym_private] = ACTIONS(655),
    [anon_sym_protected] = ACTIONS(655),
    [anon_sym_module] = ACTIONS(655),
    [anon_sym_any] = ACTIONS(655),
    [anon_sym_number] = ACTIONS(655),
    [anon_sym_boolean] = ACTIONS(655),
    [anon_sym_string] = ACTIONS(655),
    [anon_sym_symbol] = ACTIONS(655),
    [sym_readonly] = ACTIONS(655),
  },
  [208] = {
    [sym_import] = STATE(1351),
    [sym_parenthesized_expression] = STATE(844),
    [sym__expression] = STATE(1693),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1342),
    [sym_array] = STATE(1339),
    [sym_class] = STATE(1351),
    [sym_function] = STATE(1351),
    [sym_generator_function] = STATE(1351),
    [sym_arrow_function] = STATE(1351),
    [sym__call_signature] = STATE(3286),
    [sym_call_expression] = STATE(1351),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(844),
    [sym_subscript_expression] = STATE(844),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1967),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1351),
    [sym_template_string] = STATE(1351),
    [sym_regex] = STATE(1351),
    [sym_meta_property] = STATE(1351),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(977),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(380),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2684),
    [sym_identifier] = ACTIONS(1400),
    [anon_sym_export] = ACTIONS(1402),
    [anon_sym_namespace] = ACTIONS(1404),
    [anon_sym_LBRACE] = ACTIONS(1270),
    [anon_sym_type] = ACTIONS(1402),
    [anon_sym_typeof] = ACTIONS(639),
    [anon_sym_import] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(871),
    [anon_sym_await] = ACTIONS(625),
    [anon_sym_yield] = ACTIONS(627),
    [anon_sym_LBRACK] = ACTIONS(873),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(675),
    [anon_sym_DOT] = ACTIONS(1406),
    [anon_sym_class] = ACTIONS(677),
    [anon_sym_async] = ACTIONS(1408),
    [anon_sym_function] = ACTIONS(681),
    [anon_sym_new] = ACTIONS(1410),
    [anon_sym_PLUS] = ACTIONS(889),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(623),
    [anon_sym_void] = ACTIONS(639),
    [anon_sym_delete] = ACTIONS(639),
    [anon_sym_PLUS_PLUS] = ACTIONS(641),
    [anon_sym_DASH_DASH] = ACTIONS(641),
    [anon_sym_DQUOTE] = ACTIONS(693),
    [anon_sym_SQUOTE] = ACTIONS(695),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(697),
    [sym_number] = ACTIONS(1412),
    [sym_this] = ACTIONS(1414),
    [sym_super] = ACTIONS(1414),
    [sym_true] = ACTIONS(1414),
    [sym_false] = ACTIONS(1414),
    [sym_null] = ACTIONS(1414),
    [sym_undefined] = ACTIONS(1414),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1402),
    [anon_sym_get] = ACTIONS(1402),
    [anon_sym_set] = ACTIONS(1402),
    [anon_sym_declare] = ACTIONS(1402),
    [anon_sym_public] = ACTIONS(1402),
    [anon_sym_private] = ACTIONS(1402),
    [anon_sym_protected] = ACTIONS(1402),
    [anon_sym_module] = ACTIONS(1402),
    [anon_sym_any] = ACTIONS(1402),
    [anon_sym_number] = ACTIONS(1402),
    [anon_sym_boolean] = ACTIONS(1402),
    [anon_sym_string] = ACTIONS(1402),
    [anon_sym_symbol] = ACTIONS(1402),
    [sym_readonly] = ACTIONS(1402),
  },
  [209] = {
    [sym_import] = STATE(1351),
    [sym_parenthesized_expression] = STATE(844),
    [sym__expression] = STATE(1693),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1342),
    [sym_array] = STATE(1339),
    [sym_class] = STATE(1351),
    [sym_function] = STATE(1351),
    [sym_generator_function] = STATE(1351),
    [sym_arrow_function] = STATE(1351),
    [sym__call_signature] = STATE(3286),
    [sym_call_expression] = STATE(1351),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(844),
    [sym_subscript_expression] = STATE(844),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1967),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1351),
    [sym_template_string] = STATE(1351),
    [sym_regex] = STATE(1351),
    [sym_meta_property] = STATE(1351),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2377),
    [sym_non_null_expression] = STATE(977),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(380),
    [sym_type_parameters] = STATE(2982),
    [aux_sym_export_statement_repeat1] = STATE(2684),
    [sym_identifier] = ACTIONS(1400),
    [anon_sym_export] = ACTIONS(1402),
    [anon_sym_namespace] = ACTIONS(1404),
    [anon_sym_LBRACE] = ACTIONS(1270),
    [anon_sym_type] = ACTIONS(1402),
    [anon_sym_typeof] = ACTIONS(639),
    [anon_sym_import] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(871),
    [anon_sym_await] = ACTIONS(625),
    [anon_sym_yield] = ACTIONS(627),
    [anon_sym_LBRACK] = ACTIONS(873),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(675),
    [anon_sym_DOT] = ACTIONS(1406),
    [anon_sym_class] = ACTIONS(677),
    [anon_sym_async] = ACTIONS(1408),
    [anon_sym_function] = ACTIONS(681),
    [anon_sym_new] = ACTIONS(1410),
    [anon_sym_PLUS] = ACTIONS(889),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(623),
    [anon_sym_void] = ACTIONS(639),
    [anon_sym_delete] = ACTIONS(639),
    [anon_sym_PLUS_PLUS] = ACTIONS(641),
    [anon_sym_DASH_DASH] = ACTIONS(641),
    [anon_sym_DQUOTE] = ACTIONS(693),
    [anon_sym_SQUOTE] = ACTIONS(695),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(697),
    [sym_number] = ACTIONS(1412),
    [sym_this] = ACTIONS(1414),
    [sym_super] = ACTIONS(1414),
    [sym_true] = ACTIONS(1414),
    [sym_false] = ACTIONS(1414),
    [sym_null] = ACTIONS(1414),
    [sym_undefined] = ACTIONS(1414),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1402),
    [anon_sym_get] = ACTIONS(1402),
    [anon_sym_set] = ACTIONS(1402),
    [anon_sym_declare] = ACTIONS(1402),
    [anon_sym_public] = ACTIONS(1402),
    [anon_sym_private] = ACTIONS(1402),
    [anon_sym_protected] = ACTIONS(1402),
    [anon_sym_module] = ACTIONS(1402),
    [anon_sym_any] = ACTIONS(1402),
    [anon_sym_number] = ACTIONS(1402),
    [anon_sym_boolean] = ACTIONS(1402),
    [anon_sym_string] = ACTIONS(1402),
    [anon_sym_symbol] = ACTIONS(1402),
    [sym_readonly] = ACTIONS(1402),
  },
  [210] = {
    [sym__call_signature] = STATE(3284),
    [sym_string] = STATE(2332),
    [sym_formal_parameters] = STATE(2295),
    [sym__property_name] = STATE(2332),
    [sym_computed_property_name] = STATE(2332),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_object_repeat1] = STATE(2894),
    [sym_identifier] = ACTIONS(1416),
    [anon_sym_export] = ACTIONS(1418),
    [anon_sym_STAR] = ACTIONS(1420),
    [anon_sym_EQ] = ACTIONS(1260),
    [anon_sym_as] = ACTIONS(780),
    [anon_sym_namespace] = ACTIONS(1418),
    [anon_sym_COMMA] = ACTIONS(813),
    [anon_sym_RBRACE] = ACTIONS(1205),
    [anon_sym_type] = ACTIONS(1418),
    [anon_sym_BANG] = ACTIONS(780),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_in] = ACTIONS(780),
    [anon_sym_SEMI] = ACTIONS(813),
    [anon_sym_COLON] = ACTIONS(1220),
    [anon_sym_LBRACK] = ACTIONS(1427),
    [anon_sym_LT] = ACTIONS(1429),
    [anon_sym_GT] = ACTIONS(780),
    [anon_sym_SLASH] = ACTIONS(780),
    [anon_sym_DOT] = ACTIONS(927),
    [anon_sym_async] = ACTIONS(1418),
    [anon_sym_function] = ACTIONS(1433),
    [anon_sym_EQ_GT] = ACTIONS(929),
    [anon_sym_QMARK_DOT] = ACTIONS(931),
    [anon_sym_PLUS_EQ] = ACTIONS(803),
    [anon_sym_DASH_EQ] = ACTIONS(803),
    [anon_sym_STAR_EQ] = ACTIONS(803),
    [anon_sym_SLASH_EQ] = ACTIONS(803),
    [anon_sym_PERCENT_EQ] = ACTIONS(803),
    [anon_sym_CARET_EQ] = ACTIONS(803),
    [anon_sym_AMP_EQ] = ACTIONS(803),
    [anon_sym_PIPE_EQ] = ACTIONS(803),
    [anon_sym_GT_GT_EQ] = ACTIONS(803),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(803),
    [anon_sym_LT_LT_EQ] = ACTIONS(803),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(803),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(803),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(803),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(803),
    [anon_sym_QMARK] = ACTIONS(1225),
    [anon_sym_AMP_AMP] = ACTIONS(780),
    [anon_sym_PIPE_PIPE] = ACTIONS(780),
    [anon_sym_GT_GT] = ACTIONS(780),
    [anon_sym_GT_GT_GT] = ACTIONS(780),
    [anon_sym_LT_LT] = ACTIONS(780),
    [anon_sym_AMP] = ACTIONS(780),
    [anon_sym_CARET] = ACTIONS(780),
    [anon_sym_PIPE] = ACTIONS(780),
    [anon_sym_PLUS] = ACTIONS(780),
    [anon_sym_DASH] = ACTIONS(780),
    [anon_sym_PERCENT] = ACTIONS(780),
    [anon_sym_STAR_STAR] = ACTIONS(780),
    [anon_sym_LT_EQ] = ACTIONS(813),
    [anon_sym_EQ_EQ] = ACTIONS(780),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(813),
    [anon_sym_BANG_EQ] = ACTIONS(780),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(813),
    [anon_sym_GT_EQ] = ACTIONS(813),
    [anon_sym_QMARK_QMARK] = ACTIONS(780),
    [anon_sym_instanceof] = ACTIONS(780),
    [anon_sym_PLUS_PLUS] = ACTIONS(813),
    [anon_sym_DASH_DASH] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(817),
    [anon_sym_SQUOTE] = ACTIONS(819),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(813),
    [sym_number] = ACTIONS(1435),
    [anon_sym_static] = ACTIONS(1418),
    [anon_sym_get] = ACTIONS(1437),
    [anon_sym_set] = ACTIONS(1437),
    [anon_sym_declare] = ACTIONS(1418),
    [anon_sym_public] = ACTIONS(1418),
    [anon_sym_private] = ACTIONS(1418),
    [anon_sym_protected] = ACTIONS(1418),
    [anon_sym_module] = ACTIONS(1418),
    [anon_sym_any] = ACTIONS(1418),
    [anon_sym_number] = ACTIONS(1418),
    [anon_sym_boolean] = ACTIONS(1418),
    [anon_sym_string] = ACTIONS(1418),
    [anon_sym_symbol] = ACTIONS(1418),
    [sym_readonly] = ACTIONS(1418),
    [sym__automatic_semicolon] = ACTIONS(813),
  },
  [211] = {
    [sym__call_signature] = STATE(3284),
    [sym_string] = STATE(2332),
    [sym_formal_parameters] = STATE(2295),
    [sym__property_name] = STATE(2332),
    [sym_computed_property_name] = STATE(2332),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_object_repeat1] = STATE(2868),
    [sym_identifier] = ACTIONS(1416),
    [anon_sym_export] = ACTIONS(1418),
    [anon_sym_STAR] = ACTIONS(1420),
    [anon_sym_EQ] = ACTIONS(1260),
    [anon_sym_as] = ACTIONS(780),
    [anon_sym_namespace] = ACTIONS(1418),
    [anon_sym_COMMA] = ACTIONS(813),
    [anon_sym_RBRACE] = ACTIONS(1246),
    [anon_sym_type] = ACTIONS(1418),
    [anon_sym_BANG] = ACTIONS(780),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_in] = ACTIONS(780),
    [anon_sym_SEMI] = ACTIONS(813),
    [anon_sym_COLON] = ACTIONS(1220),
    [anon_sym_LBRACK] = ACTIONS(1427),
    [anon_sym_LT] = ACTIONS(1429),
    [anon_sym_GT] = ACTIONS(780),
    [anon_sym_SLASH] = ACTIONS(780),
    [anon_sym_DOT] = ACTIONS(927),
    [anon_sym_async] = ACTIONS(1418),
    [anon_sym_function] = ACTIONS(1433),
    [anon_sym_EQ_GT] = ACTIONS(929),
    [anon_sym_QMARK_DOT] = ACTIONS(931),
    [anon_sym_PLUS_EQ] = ACTIONS(803),
    [anon_sym_DASH_EQ] = ACTIONS(803),
    [anon_sym_STAR_EQ] = ACTIONS(803),
    [anon_sym_SLASH_EQ] = ACTIONS(803),
    [anon_sym_PERCENT_EQ] = ACTIONS(803),
    [anon_sym_CARET_EQ] = ACTIONS(803),
    [anon_sym_AMP_EQ] = ACTIONS(803),
    [anon_sym_PIPE_EQ] = ACTIONS(803),
    [anon_sym_GT_GT_EQ] = ACTIONS(803),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(803),
    [anon_sym_LT_LT_EQ] = ACTIONS(803),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(803),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(803),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(803),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(803),
    [anon_sym_QMARK] = ACTIONS(1225),
    [anon_sym_AMP_AMP] = ACTIONS(780),
    [anon_sym_PIPE_PIPE] = ACTIONS(780),
    [anon_sym_GT_GT] = ACTIONS(780),
    [anon_sym_GT_GT_GT] = ACTIONS(780),
    [anon_sym_LT_LT] = ACTIONS(780),
    [anon_sym_AMP] = ACTIONS(780),
    [anon_sym_CARET] = ACTIONS(780),
    [anon_sym_PIPE] = ACTIONS(780),
    [anon_sym_PLUS] = ACTIONS(780),
    [anon_sym_DASH] = ACTIONS(780),
    [anon_sym_PERCENT] = ACTIONS(780),
    [anon_sym_STAR_STAR] = ACTIONS(780),
    [anon_sym_LT_EQ] = ACTIONS(813),
    [anon_sym_EQ_EQ] = ACTIONS(780),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(813),
    [anon_sym_BANG_EQ] = ACTIONS(780),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(813),
    [anon_sym_GT_EQ] = ACTIONS(813),
    [anon_sym_QMARK_QMARK] = ACTIONS(780),
    [anon_sym_instanceof] = ACTIONS(780),
    [anon_sym_PLUS_PLUS] = ACTIONS(813),
    [anon_sym_DASH_DASH] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(817),
    [anon_sym_SQUOTE] = ACTIONS(819),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(813),
    [sym_number] = ACTIONS(1435),
    [anon_sym_static] = ACTIONS(1418),
    [anon_sym_get] = ACTIONS(1437),
    [anon_sym_set] = ACTIONS(1437),
    [anon_sym_declare] = ACTIONS(1418),
    [anon_sym_public] = ACTIONS(1418),
    [anon_sym_private] = ACTIONS(1418),
    [anon_sym_protected] = ACTIONS(1418),
    [anon_sym_module] = ACTIONS(1418),
    [anon_sym_any] = ACTIONS(1418),
    [anon_sym_number] = ACTIONS(1418),
    [anon_sym_boolean] = ACTIONS(1418),
    [anon_sym_string] = ACTIONS(1418),
    [anon_sym_symbol] = ACTIONS(1418),
    [sym_readonly] = ACTIONS(1418),
    [sym__automatic_semicolon] = ACTIONS(813),
  },
  [212] = {
    [sym_import] = STATE(1212),
    [sym_statement_block] = STATE(1154),
    [sym_parenthesized_expression] = STATE(978),
    [sym__expression] = STATE(1502),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1696),
    [sym_array] = STATE(1691),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3169),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(978),
    [sym_subscript_expression] = STATE(978),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1967),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(977),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(380),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(881),
    [anon_sym_export] = ACTIONS(617),
    [anon_sym_namespace] = ACTIONS(619),
    [anon_sym_LBRACE] = ACTIONS(1336),
    [anon_sym_type] = ACTIONS(617),
    [anon_sym_typeof] = ACTIONS(639),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(625),
    [anon_sym_yield] = ACTIONS(627),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(631),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(887),
    [anon_sym_PLUS] = ACTIONS(889),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(623),
    [anon_sym_void] = ACTIONS(639),
    [anon_sym_delete] = ACTIONS(639),
    [anon_sym_PLUS_PLUS] = ACTIONS(641),
    [anon_sym_DASH_DASH] = ACTIONS(641),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(617),
    [anon_sym_get] = ACTIONS(617),
    [anon_sym_set] = ACTIONS(617),
    [anon_sym_declare] = ACTIONS(617),
    [anon_sym_public] = ACTIONS(617),
    [anon_sym_private] = ACTIONS(617),
    [anon_sym_protected] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(617),
    [anon_sym_any] = ACTIONS(617),
    [anon_sym_number] = ACTIONS(617),
    [anon_sym_boolean] = ACTIONS(617),
    [anon_sym_string] = ACTIONS(617),
    [anon_sym_symbol] = ACTIONS(617),
    [sym_readonly] = ACTIONS(617),
  },
  [213] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(884),
    [sym__expression] = STATE(1455),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1283),
    [sym_array] = STATE(1281),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3336),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(884),
    [sym_subscript_expression] = STATE(884),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1964),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_sequence_expression] = STATE(3184),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(860),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(414),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(831),
    [anon_sym_export] = ACTIONS(503),
    [anon_sym_namespace] = ACTIONS(505),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_type] = ACTIONS(503),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(437),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(443),
    [anon_sym_yield] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(849),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(851),
    [anon_sym_TILDE] = ACTIONS(437),
    [anon_sym_void] = ACTIONS(471),
    [anon_sym_delete] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(473),
    [anon_sym_DASH_DASH] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(503),
    [anon_sym_get] = ACTIONS(503),
    [anon_sym_set] = ACTIONS(503),
    [anon_sym_declare] = ACTIONS(503),
    [anon_sym_public] = ACTIONS(503),
    [anon_sym_private] = ACTIONS(503),
    [anon_sym_protected] = ACTIONS(503),
    [anon_sym_module] = ACTIONS(503),
    [anon_sym_any] = ACTIONS(503),
    [anon_sym_number] = ACTIONS(503),
    [anon_sym_boolean] = ACTIONS(503),
    [anon_sym_string] = ACTIONS(503),
    [anon_sym_symbol] = ACTIONS(503),
    [sym_readonly] = ACTIONS(503),
  },
  [214] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(884),
    [sym__expression] = STATE(1454),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1283),
    [sym_array] = STATE(1281),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3336),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(884),
    [sym_subscript_expression] = STATE(884),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1964),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_sequence_expression] = STATE(3183),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(860),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(414),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(831),
    [anon_sym_export] = ACTIONS(503),
    [anon_sym_namespace] = ACTIONS(505),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_type] = ACTIONS(503),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(437),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(443),
    [anon_sym_yield] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(849),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(851),
    [anon_sym_TILDE] = ACTIONS(437),
    [anon_sym_void] = ACTIONS(471),
    [anon_sym_delete] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(473),
    [anon_sym_DASH_DASH] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(503),
    [anon_sym_get] = ACTIONS(503),
    [anon_sym_set] = ACTIONS(503),
    [anon_sym_declare] = ACTIONS(503),
    [anon_sym_public] = ACTIONS(503),
    [anon_sym_private] = ACTIONS(503),
    [anon_sym_protected] = ACTIONS(503),
    [anon_sym_module] = ACTIONS(503),
    [anon_sym_any] = ACTIONS(503),
    [anon_sym_number] = ACTIONS(503),
    [anon_sym_boolean] = ACTIONS(503),
    [anon_sym_string] = ACTIONS(503),
    [anon_sym_symbol] = ACTIONS(503),
    [sym_readonly] = ACTIONS(503),
  },
  [215] = {
    [sym_import] = STATE(1212),
    [sym_statement_block] = STATE(1143),
    [sym_parenthesized_expression] = STATE(978),
    [sym__expression] = STATE(1487),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1696),
    [sym_array] = STATE(1691),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3169),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(978),
    [sym_subscript_expression] = STATE(978),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1967),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(977),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(380),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(881),
    [anon_sym_export] = ACTIONS(617),
    [anon_sym_namespace] = ACTIONS(619),
    [anon_sym_LBRACE] = ACTIONS(1336),
    [anon_sym_type] = ACTIONS(617),
    [anon_sym_typeof] = ACTIONS(639),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(625),
    [anon_sym_yield] = ACTIONS(627),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(631),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(887),
    [anon_sym_PLUS] = ACTIONS(889),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(623),
    [anon_sym_void] = ACTIONS(639),
    [anon_sym_delete] = ACTIONS(639),
    [anon_sym_PLUS_PLUS] = ACTIONS(641),
    [anon_sym_DASH_DASH] = ACTIONS(641),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(617),
    [anon_sym_get] = ACTIONS(617),
    [anon_sym_set] = ACTIONS(617),
    [anon_sym_declare] = ACTIONS(617),
    [anon_sym_public] = ACTIONS(617),
    [anon_sym_private] = ACTIONS(617),
    [anon_sym_protected] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(617),
    [anon_sym_any] = ACTIONS(617),
    [anon_sym_number] = ACTIONS(617),
    [anon_sym_boolean] = ACTIONS(617),
    [anon_sym_string] = ACTIONS(617),
    [anon_sym_symbol] = ACTIONS(617),
    [sym_readonly] = ACTIONS(617),
  },
  [216] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(884),
    [sym__expression] = STATE(1452),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1283),
    [sym_array] = STATE(1281),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3336),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(884),
    [sym_subscript_expression] = STATE(884),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1964),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_sequence_expression] = STATE(3182),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(860),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(414),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(831),
    [anon_sym_export] = ACTIONS(503),
    [anon_sym_namespace] = ACTIONS(505),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_type] = ACTIONS(503),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(437),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(443),
    [anon_sym_yield] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(849),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(851),
    [anon_sym_TILDE] = ACTIONS(437),
    [anon_sym_void] = ACTIONS(471),
    [anon_sym_delete] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(473),
    [anon_sym_DASH_DASH] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(503),
    [anon_sym_get] = ACTIONS(503),
    [anon_sym_set] = ACTIONS(503),
    [anon_sym_declare] = ACTIONS(503),
    [anon_sym_public] = ACTIONS(503),
    [anon_sym_private] = ACTIONS(503),
    [anon_sym_protected] = ACTIONS(503),
    [anon_sym_module] = ACTIONS(503),
    [anon_sym_any] = ACTIONS(503),
    [anon_sym_number] = ACTIONS(503),
    [anon_sym_boolean] = ACTIONS(503),
    [anon_sym_string] = ACTIONS(503),
    [anon_sym_symbol] = ACTIONS(503),
    [sym_readonly] = ACTIONS(503),
  },
  [217] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(978),
    [sym__expression] = STATE(1607),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1696),
    [sym_array] = STATE(1691),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3169),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(978),
    [sym_subscript_expression] = STATE(978),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1967),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(977),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_mapped_type_clause] = STATE(3339),
    [sym_type_arguments] = STATE(380),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(1439),
    [anon_sym_export] = ACTIONS(1441),
    [anon_sym_namespace] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_type] = ACTIONS(1441),
    [anon_sym_typeof] = ACTIONS(639),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(625),
    [anon_sym_yield] = ACTIONS(627),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(1445),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(887),
    [anon_sym_PLUS] = ACTIONS(889),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(623),
    [anon_sym_void] = ACTIONS(639),
    [anon_sym_delete] = ACTIONS(639),
    [anon_sym_PLUS_PLUS] = ACTIONS(641),
    [anon_sym_DASH_DASH] = ACTIONS(641),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1441),
    [anon_sym_get] = ACTIONS(1441),
    [anon_sym_set] = ACTIONS(1441),
    [anon_sym_declare] = ACTIONS(1441),
    [anon_sym_public] = ACTIONS(1441),
    [anon_sym_private] = ACTIONS(1441),
    [anon_sym_protected] = ACTIONS(1441),
    [anon_sym_module] = ACTIONS(1441),
    [anon_sym_any] = ACTIONS(1441),
    [anon_sym_number] = ACTIONS(1441),
    [anon_sym_boolean] = ACTIONS(1441),
    [anon_sym_string] = ACTIONS(1441),
    [anon_sym_symbol] = ACTIONS(1441),
    [sym_readonly] = ACTIONS(1441),
  },
  [218] = {
    [sym_import] = STATE(1212),
    [sym_statement_block] = STATE(1201),
    [sym_parenthesized_expression] = STATE(978),
    [sym__expression] = STATE(1474),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1696),
    [sym_array] = STATE(1691),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3169),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(978),
    [sym_subscript_expression] = STATE(978),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1967),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(977),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(380),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(881),
    [anon_sym_export] = ACTIONS(617),
    [anon_sym_namespace] = ACTIONS(619),
    [anon_sym_LBRACE] = ACTIONS(1336),
    [anon_sym_type] = ACTIONS(617),
    [anon_sym_typeof] = ACTIONS(639),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(625),
    [anon_sym_yield] = ACTIONS(627),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(631),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(887),
    [anon_sym_PLUS] = ACTIONS(889),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(623),
    [anon_sym_void] = ACTIONS(639),
    [anon_sym_delete] = ACTIONS(639),
    [anon_sym_PLUS_PLUS] = ACTIONS(641),
    [anon_sym_DASH_DASH] = ACTIONS(641),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(617),
    [anon_sym_get] = ACTIONS(617),
    [anon_sym_set] = ACTIONS(617),
    [anon_sym_declare] = ACTIONS(617),
    [anon_sym_public] = ACTIONS(617),
    [anon_sym_private] = ACTIONS(617),
    [anon_sym_protected] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(617),
    [anon_sym_any] = ACTIONS(617),
    [anon_sym_number] = ACTIONS(617),
    [anon_sym_boolean] = ACTIONS(617),
    [anon_sym_string] = ACTIONS(617),
    [anon_sym_symbol] = ACTIONS(617),
    [sym_readonly] = ACTIONS(617),
  },
  [219] = {
    [sym_import] = STATE(1212),
    [sym_statement_block] = STATE(1156),
    [sym_parenthesized_expression] = STATE(978),
    [sym__expression] = STATE(1472),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1696),
    [sym_array] = STATE(1691),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3169),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(978),
    [sym_subscript_expression] = STATE(978),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1967),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(977),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(380),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(881),
    [anon_sym_export] = ACTIONS(617),
    [anon_sym_namespace] = ACTIONS(619),
    [anon_sym_LBRACE] = ACTIONS(1336),
    [anon_sym_type] = ACTIONS(617),
    [anon_sym_typeof] = ACTIONS(639),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(625),
    [anon_sym_yield] = ACTIONS(627),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(631),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(887),
    [anon_sym_PLUS] = ACTIONS(889),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(623),
    [anon_sym_void] = ACTIONS(639),
    [anon_sym_delete] = ACTIONS(639),
    [anon_sym_PLUS_PLUS] = ACTIONS(641),
    [anon_sym_DASH_DASH] = ACTIONS(641),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(617),
    [anon_sym_get] = ACTIONS(617),
    [anon_sym_set] = ACTIONS(617),
    [anon_sym_declare] = ACTIONS(617),
    [anon_sym_public] = ACTIONS(617),
    [anon_sym_private] = ACTIONS(617),
    [anon_sym_protected] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(617),
    [anon_sym_any] = ACTIONS(617),
    [anon_sym_number] = ACTIONS(617),
    [anon_sym_boolean] = ACTIONS(617),
    [anon_sym_string] = ACTIONS(617),
    [anon_sym_symbol] = ACTIONS(617),
    [sym_readonly] = ACTIONS(617),
  },
  [220] = {
    [sym_import] = STATE(1212),
    [sym_statement_block] = STATE(1142),
    [sym_parenthesized_expression] = STATE(978),
    [sym__expression] = STATE(1469),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1696),
    [sym_array] = STATE(1691),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3169),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(978),
    [sym_subscript_expression] = STATE(978),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1967),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(977),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(380),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(881),
    [anon_sym_export] = ACTIONS(617),
    [anon_sym_namespace] = ACTIONS(619),
    [anon_sym_LBRACE] = ACTIONS(1336),
    [anon_sym_type] = ACTIONS(617),
    [anon_sym_typeof] = ACTIONS(639),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(625),
    [anon_sym_yield] = ACTIONS(627),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(631),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(887),
    [anon_sym_PLUS] = ACTIONS(889),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(623),
    [anon_sym_void] = ACTIONS(639),
    [anon_sym_delete] = ACTIONS(639),
    [anon_sym_PLUS_PLUS] = ACTIONS(641),
    [anon_sym_DASH_DASH] = ACTIONS(641),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(617),
    [anon_sym_get] = ACTIONS(617),
    [anon_sym_set] = ACTIONS(617),
    [anon_sym_declare] = ACTIONS(617),
    [anon_sym_public] = ACTIONS(617),
    [anon_sym_private] = ACTIONS(617),
    [anon_sym_protected] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(617),
    [anon_sym_any] = ACTIONS(617),
    [anon_sym_number] = ACTIONS(617),
    [anon_sym_boolean] = ACTIONS(617),
    [anon_sym_string] = ACTIONS(617),
    [anon_sym_symbol] = ACTIONS(617),
    [sym_readonly] = ACTIONS(617),
  },
  [221] = {
    [sym_import] = STATE(1212),
    [sym_statement_block] = STATE(1223),
    [sym_parenthesized_expression] = STATE(978),
    [sym__expression] = STATE(1468),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1696),
    [sym_array] = STATE(1691),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3169),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(978),
    [sym_subscript_expression] = STATE(978),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1967),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(977),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(380),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(881),
    [anon_sym_export] = ACTIONS(617),
    [anon_sym_namespace] = ACTIONS(619),
    [anon_sym_LBRACE] = ACTIONS(1336),
    [anon_sym_type] = ACTIONS(617),
    [anon_sym_typeof] = ACTIONS(639),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(625),
    [anon_sym_yield] = ACTIONS(627),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(631),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(887),
    [anon_sym_PLUS] = ACTIONS(889),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(623),
    [anon_sym_void] = ACTIONS(639),
    [anon_sym_delete] = ACTIONS(639),
    [anon_sym_PLUS_PLUS] = ACTIONS(641),
    [anon_sym_DASH_DASH] = ACTIONS(641),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(617),
    [anon_sym_get] = ACTIONS(617),
    [anon_sym_set] = ACTIONS(617),
    [anon_sym_declare] = ACTIONS(617),
    [anon_sym_public] = ACTIONS(617),
    [anon_sym_private] = ACTIONS(617),
    [anon_sym_protected] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(617),
    [anon_sym_any] = ACTIONS(617),
    [anon_sym_number] = ACTIONS(617),
    [anon_sym_boolean] = ACTIONS(617),
    [anon_sym_string] = ACTIONS(617),
    [anon_sym_symbol] = ACTIONS(617),
    [sym_readonly] = ACTIONS(617),
  },
  [222] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(884),
    [sym__expression] = STATE(1450),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1283),
    [sym_array] = STATE(1281),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3336),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(884),
    [sym_subscript_expression] = STATE(884),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1964),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_sequence_expression] = STATE(3179),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(860),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(414),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(831),
    [anon_sym_export] = ACTIONS(503),
    [anon_sym_namespace] = ACTIONS(505),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_type] = ACTIONS(503),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(437),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(443),
    [anon_sym_yield] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(849),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(851),
    [anon_sym_TILDE] = ACTIONS(437),
    [anon_sym_void] = ACTIONS(471),
    [anon_sym_delete] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(473),
    [anon_sym_DASH_DASH] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(503),
    [anon_sym_get] = ACTIONS(503),
    [anon_sym_set] = ACTIONS(503),
    [anon_sym_declare] = ACTIONS(503),
    [anon_sym_public] = ACTIONS(503),
    [anon_sym_private] = ACTIONS(503),
    [anon_sym_protected] = ACTIONS(503),
    [anon_sym_module] = ACTIONS(503),
    [anon_sym_any] = ACTIONS(503),
    [anon_sym_number] = ACTIONS(503),
    [anon_sym_boolean] = ACTIONS(503),
    [anon_sym_string] = ACTIONS(503),
    [anon_sym_symbol] = ACTIONS(503),
    [sym_readonly] = ACTIONS(503),
  },
  [223] = {
    [sym_import] = STATE(1528),
    [sym_statement_block] = STATE(1561),
    [sym_parenthesized_expression] = STATE(933),
    [sym__expression] = STATE(1178),
    [sym_yield_expression] = STATE(1543),
    [sym_object] = STATE(1367),
    [sym_array] = STATE(1369),
    [sym_class] = STATE(1528),
    [sym_function] = STATE(1528),
    [sym_generator_function] = STATE(1528),
    [sym_arrow_function] = STATE(1528),
    [sym__call_signature] = STATE(3359),
    [sym_call_expression] = STATE(1528),
    [sym_new_expression] = STATE(1543),
    [sym_await_expression] = STATE(1543),
    [sym_member_expression] = STATE(933),
    [sym_subscript_expression] = STATE(933),
    [sym_assignment_expression] = STATE(1543),
    [sym__augmented_assignment_lhs] = STATE(1970),
    [sym_augmented_assignment_expression] = STATE(1543),
    [sym_ternary_expression] = STATE(1543),
    [sym_binary_expression] = STATE(1543),
    [sym_unary_expression] = STATE(1543),
    [sym_update_expression] = STATE(1543),
    [sym_string] = STATE(1528),
    [sym_template_string] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_meta_property] = STATE(1528),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(936),
    [sym_type_assertion] = STATE(1543),
    [sym_as_expression] = STATE(1543),
    [sym_internal_module] = STATE(1543),
    [sym_type_arguments] = STATE(381),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2726),
    [sym_identifier] = ACTIONS(855),
    [anon_sym_export] = ACTIONS(745),
    [anon_sym_namespace] = ACTIONS(747),
    [anon_sym_LBRACE] = ACTIONS(1338),
    [anon_sym_type] = ACTIONS(745),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(537),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(549),
    [anon_sym_async] = ACTIONS(753),
    [anon_sym_function] = ACTIONS(553),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(745),
    [anon_sym_get] = ACTIONS(745),
    [anon_sym_set] = ACTIONS(745),
    [anon_sym_declare] = ACTIONS(745),
    [anon_sym_public] = ACTIONS(745),
    [anon_sym_private] = ACTIONS(745),
    [anon_sym_protected] = ACTIONS(745),
    [anon_sym_module] = ACTIONS(745),
    [anon_sym_any] = ACTIONS(745),
    [anon_sym_number] = ACTIONS(745),
    [anon_sym_boolean] = ACTIONS(745),
    [anon_sym_string] = ACTIONS(745),
    [anon_sym_symbol] = ACTIONS(745),
    [sym_readonly] = ACTIONS(745),
  },
  [224] = {
    [sym_import] = STATE(1039),
    [sym_parenthesized_expression] = STATE(661),
    [sym__expression] = STATE(1682),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1023),
    [sym_array] = STATE(1024),
    [sym_class] = STATE(1039),
    [sym_function] = STATE(1039),
    [sym_generator_function] = STATE(1039),
    [sym_arrow_function] = STATE(1039),
    [sym__call_signature] = STATE(3169),
    [sym_call_expression] = STATE(1039),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(661),
    [sym_subscript_expression] = STATE(661),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1967),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1039),
    [sym_template_string] = STATE(1039),
    [sym_regex] = STATE(1039),
    [sym_meta_property] = STATE(1039),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2377),
    [sym_non_null_expression] = STATE(977),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(380),
    [sym_type_parameters] = STATE(2982),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(1447),
    [anon_sym_export] = ACTIONS(1449),
    [anon_sym_namespace] = ACTIONS(1451),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_type] = ACTIONS(1449),
    [anon_sym_typeof] = ACTIONS(639),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(625),
    [anon_sym_yield] = ACTIONS(627),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_DOT] = ACTIONS(1372),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(1453),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(887),
    [anon_sym_PLUS] = ACTIONS(889),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(623),
    [anon_sym_void] = ACTIONS(639),
    [anon_sym_delete] = ACTIONS(639),
    [anon_sym_PLUS_PLUS] = ACTIONS(641),
    [anon_sym_DASH_DASH] = ACTIONS(641),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(1376),
    [sym_this] = ACTIONS(1378),
    [sym_super] = ACTIONS(1378),
    [sym_true] = ACTIONS(1378),
    [sym_false] = ACTIONS(1378),
    [sym_null] = ACTIONS(1378),
    [sym_undefined] = ACTIONS(1378),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1449),
    [anon_sym_get] = ACTIONS(1449),
    [anon_sym_set] = ACTIONS(1449),
    [anon_sym_declare] = ACTIONS(1449),
    [anon_sym_public] = ACTIONS(1449),
    [anon_sym_private] = ACTIONS(1449),
    [anon_sym_protected] = ACTIONS(1449),
    [anon_sym_module] = ACTIONS(1449),
    [anon_sym_any] = ACTIONS(1449),
    [anon_sym_number] = ACTIONS(1449),
    [anon_sym_boolean] = ACTIONS(1449),
    [anon_sym_string] = ACTIONS(1449),
    [anon_sym_symbol] = ACTIONS(1449),
    [sym_readonly] = ACTIONS(1449),
  },
  [225] = {
    [sym_import] = STATE(1039),
    [sym_parenthesized_expression] = STATE(661),
    [sym__expression] = STATE(1682),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1023),
    [sym_array] = STATE(1024),
    [sym_class] = STATE(1039),
    [sym_function] = STATE(1039),
    [sym_generator_function] = STATE(1039),
    [sym_arrow_function] = STATE(1039),
    [sym__call_signature] = STATE(3169),
    [sym_call_expression] = STATE(1039),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(661),
    [sym_subscript_expression] = STATE(661),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1967),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1039),
    [sym_template_string] = STATE(1039),
    [sym_regex] = STATE(1039),
    [sym_meta_property] = STATE(1039),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(977),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(380),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(1447),
    [anon_sym_export] = ACTIONS(1449),
    [anon_sym_namespace] = ACTIONS(1451),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_type] = ACTIONS(1449),
    [anon_sym_typeof] = ACTIONS(639),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(625),
    [anon_sym_yield] = ACTIONS(627),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_DOT] = ACTIONS(1348),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(1453),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(887),
    [anon_sym_PLUS] = ACTIONS(889),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(623),
    [anon_sym_void] = ACTIONS(639),
    [anon_sym_delete] = ACTIONS(639),
    [anon_sym_PLUS_PLUS] = ACTIONS(641),
    [anon_sym_DASH_DASH] = ACTIONS(641),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(1376),
    [sym_this] = ACTIONS(1378),
    [sym_super] = ACTIONS(1378),
    [sym_true] = ACTIONS(1378),
    [sym_false] = ACTIONS(1378),
    [sym_null] = ACTIONS(1378),
    [sym_undefined] = ACTIONS(1378),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1449),
    [anon_sym_get] = ACTIONS(1449),
    [anon_sym_set] = ACTIONS(1449),
    [anon_sym_declare] = ACTIONS(1449),
    [anon_sym_public] = ACTIONS(1449),
    [anon_sym_private] = ACTIONS(1449),
    [anon_sym_protected] = ACTIONS(1449),
    [anon_sym_module] = ACTIONS(1449),
    [anon_sym_any] = ACTIONS(1449),
    [anon_sym_number] = ACTIONS(1449),
    [anon_sym_boolean] = ACTIONS(1449),
    [anon_sym_string] = ACTIONS(1449),
    [anon_sym_symbol] = ACTIONS(1449),
    [sym_readonly] = ACTIONS(1449),
  },
  [226] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(884),
    [sym__expression] = STATE(1471),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1283),
    [sym_array] = STATE(1281),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3336),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(884),
    [sym_subscript_expression] = STATE(884),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1964),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_sequence_expression] = STATE(3234),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(860),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(414),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(831),
    [anon_sym_export] = ACTIONS(503),
    [anon_sym_namespace] = ACTIONS(505),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_type] = ACTIONS(503),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(437),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(443),
    [anon_sym_yield] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(849),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(851),
    [anon_sym_TILDE] = ACTIONS(437),
    [anon_sym_void] = ACTIONS(471),
    [anon_sym_delete] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(473),
    [anon_sym_DASH_DASH] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(503),
    [anon_sym_get] = ACTIONS(503),
    [anon_sym_set] = ACTIONS(503),
    [anon_sym_declare] = ACTIONS(503),
    [anon_sym_public] = ACTIONS(503),
    [anon_sym_private] = ACTIONS(503),
    [anon_sym_protected] = ACTIONS(503),
    [anon_sym_module] = ACTIONS(503),
    [anon_sym_any] = ACTIONS(503),
    [anon_sym_number] = ACTIONS(503),
    [anon_sym_boolean] = ACTIONS(503),
    [anon_sym_string] = ACTIONS(503),
    [anon_sym_symbol] = ACTIONS(503),
    [sym_readonly] = ACTIONS(503),
  },
  [227] = {
    [sym_import] = STATE(1212),
    [sym_statement_block] = STATE(1154),
    [sym_parenthesized_expression] = STATE(965),
    [sym__expression] = STATE(1337),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1524),
    [sym_array] = STATE(1523),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3348),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(965),
    [sym_subscript_expression] = STATE(965),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1969),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(975),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(302),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(901),
    [anon_sym_export] = ACTIONS(713),
    [anon_sym_namespace] = ACTIONS(715),
    [anon_sym_LBRACE] = ACTIONS(1336),
    [anon_sym_type] = ACTIONS(713),
    [anon_sym_typeof] = ACTIONS(735),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(719),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(721),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(725),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(727),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(907),
    [anon_sym_PLUS] = ACTIONS(909),
    [anon_sym_DASH] = ACTIONS(909),
    [anon_sym_TILDE] = ACTIONS(719),
    [anon_sym_void] = ACTIONS(735),
    [anon_sym_delete] = ACTIONS(735),
    [anon_sym_PLUS_PLUS] = ACTIONS(737),
    [anon_sym_DASH_DASH] = ACTIONS(737),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(713),
    [anon_sym_get] = ACTIONS(713),
    [anon_sym_set] = ACTIONS(713),
    [anon_sym_declare] = ACTIONS(713),
    [anon_sym_public] = ACTIONS(713),
    [anon_sym_private] = ACTIONS(713),
    [anon_sym_protected] = ACTIONS(713),
    [anon_sym_module] = ACTIONS(713),
    [anon_sym_any] = ACTIONS(713),
    [anon_sym_number] = ACTIONS(713),
    [anon_sym_boolean] = ACTIONS(713),
    [anon_sym_string] = ACTIONS(713),
    [anon_sym_symbol] = ACTIONS(713),
    [sym_readonly] = ACTIONS(713),
  },
  [228] = {
    [sym_import] = STATE(1039),
    [sym_parenthesized_expression] = STATE(661),
    [sym__expression] = STATE(1682),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1023),
    [sym_array] = STATE(1024),
    [sym_class] = STATE(1039),
    [sym_function] = STATE(1039),
    [sym_generator_function] = STATE(1039),
    [sym_arrow_function] = STATE(1039),
    [sym__call_signature] = STATE(3336),
    [sym_call_expression] = STATE(1039),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(661),
    [sym_subscript_expression] = STATE(661),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1967),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1039),
    [sym_template_string] = STATE(1039),
    [sym_regex] = STATE(1039),
    [sym_meta_property] = STATE(1039),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2377),
    [sym_non_null_expression] = STATE(977),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(380),
    [sym_type_parameters] = STATE(2982),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(1388),
    [anon_sym_export] = ACTIONS(1390),
    [anon_sym_namespace] = ACTIONS(1392),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_type] = ACTIONS(1390),
    [anon_sym_typeof] = ACTIONS(639),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(625),
    [anon_sym_yield] = ACTIONS(627),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_DOT] = ACTIONS(1372),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(1394),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(887),
    [anon_sym_PLUS] = ACTIONS(889),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(623),
    [anon_sym_void] = ACTIONS(639),
    [anon_sym_delete] = ACTIONS(639),
    [anon_sym_PLUS_PLUS] = ACTIONS(641),
    [anon_sym_DASH_DASH] = ACTIONS(641),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(1376),
    [sym_this] = ACTIONS(1378),
    [sym_super] = ACTIONS(1378),
    [sym_true] = ACTIONS(1378),
    [sym_false] = ACTIONS(1378),
    [sym_null] = ACTIONS(1378),
    [sym_undefined] = ACTIONS(1378),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1390),
    [anon_sym_get] = ACTIONS(1390),
    [anon_sym_set] = ACTIONS(1390),
    [anon_sym_declare] = ACTIONS(1390),
    [anon_sym_public] = ACTIONS(1390),
    [anon_sym_private] = ACTIONS(1390),
    [anon_sym_protected] = ACTIONS(1390),
    [anon_sym_module] = ACTIONS(1390),
    [anon_sym_any] = ACTIONS(1390),
    [anon_sym_number] = ACTIONS(1390),
    [anon_sym_boolean] = ACTIONS(1390),
    [anon_sym_string] = ACTIONS(1390),
    [anon_sym_symbol] = ACTIONS(1390),
    [sym_readonly] = ACTIONS(1390),
  },
  [229] = {
    [sym_import] = STATE(1039),
    [sym_parenthesized_expression] = STATE(661),
    [sym__expression] = STATE(1682),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1023),
    [sym_array] = STATE(1024),
    [sym_class] = STATE(1039),
    [sym_function] = STATE(1039),
    [sym_generator_function] = STATE(1039),
    [sym_arrow_function] = STATE(1039),
    [sym__call_signature] = STATE(3348),
    [sym_call_expression] = STATE(1039),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(661),
    [sym_subscript_expression] = STATE(661),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1967),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1039),
    [sym_template_string] = STATE(1039),
    [sym_regex] = STATE(1039),
    [sym_meta_property] = STATE(1039),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(977),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(380),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(1366),
    [anon_sym_export] = ACTIONS(1368),
    [anon_sym_namespace] = ACTIONS(1370),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_type] = ACTIONS(1368),
    [anon_sym_typeof] = ACTIONS(639),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(625),
    [anon_sym_yield] = ACTIONS(627),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(725),
    [anon_sym_DOT] = ACTIONS(1372),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(1374),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(887),
    [anon_sym_PLUS] = ACTIONS(889),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(623),
    [anon_sym_void] = ACTIONS(639),
    [anon_sym_delete] = ACTIONS(639),
    [anon_sym_PLUS_PLUS] = ACTIONS(641),
    [anon_sym_DASH_DASH] = ACTIONS(641),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(1376),
    [sym_this] = ACTIONS(1378),
    [sym_super] = ACTIONS(1378),
    [sym_true] = ACTIONS(1378),
    [sym_false] = ACTIONS(1378),
    [sym_null] = ACTIONS(1378),
    [sym_undefined] = ACTIONS(1378),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1368),
    [anon_sym_get] = ACTIONS(1368),
    [anon_sym_set] = ACTIONS(1368),
    [anon_sym_declare] = ACTIONS(1368),
    [anon_sym_public] = ACTIONS(1368),
    [anon_sym_private] = ACTIONS(1368),
    [anon_sym_protected] = ACTIONS(1368),
    [anon_sym_module] = ACTIONS(1368),
    [anon_sym_any] = ACTIONS(1368),
    [anon_sym_number] = ACTIONS(1368),
    [anon_sym_boolean] = ACTIONS(1368),
    [anon_sym_string] = ACTIONS(1368),
    [anon_sym_symbol] = ACTIONS(1368),
    [sym_readonly] = ACTIONS(1368),
  },
  [230] = {
    [sym_import] = STATE(1528),
    [sym_parenthesized_expression] = STATE(983),
    [sym__expression] = STATE(1465),
    [sym_yield_expression] = STATE(1543),
    [sym_object] = STATE(1671),
    [sym_array] = STATE(1713),
    [sym_class] = STATE(1528),
    [sym_function] = STATE(1528),
    [sym_generator_function] = STATE(1528),
    [sym_arrow_function] = STATE(1528),
    [sym__call_signature] = STATE(3235),
    [sym_call_expression] = STATE(1528),
    [sym_new_expression] = STATE(1543),
    [sym_await_expression] = STATE(1543),
    [sym_member_expression] = STATE(983),
    [sym_subscript_expression] = STATE(983),
    [sym_assignment_expression] = STATE(1543),
    [sym__augmented_assignment_lhs] = STATE(1963),
    [sym_augmented_assignment_expression] = STATE(1543),
    [sym_ternary_expression] = STATE(1543),
    [sym_binary_expression] = STATE(1543),
    [sym_unary_expression] = STATE(1543),
    [sym_update_expression] = STATE(1543),
    [sym_string] = STATE(1528),
    [sym_template_string] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_meta_property] = STATE(1528),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(984),
    [sym_function_signature] = STATE(579),
    [sym_type_assertion] = STATE(1543),
    [sym_as_expression] = STATE(1543),
    [sym_internal_module] = STATE(1543),
    [sym_type_arguments] = STATE(310),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2726),
    [sym_identifier] = ACTIONS(891),
    [anon_sym_export] = ACTIONS(529),
    [anon_sym_namespace] = ACTIONS(531),
    [anon_sym_LBRACE] = ACTIONS(859),
    [anon_sym_type] = ACTIONS(529),
    [anon_sym_typeof] = ACTIONS(561),
    [anon_sym_import] = ACTIONS(537),
    [anon_sym_BANG] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(543),
    [anon_sym_yield] = ACTIONS(545),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(549),
    [anon_sym_async] = ACTIONS(1455),
    [anon_sym_function] = ACTIONS(1457),
    [anon_sym_new] = ACTIONS(897),
    [anon_sym_PLUS] = ACTIONS(899),
    [anon_sym_DASH] = ACTIONS(899),
    [anon_sym_TILDE] = ACTIONS(539),
    [anon_sym_void] = ACTIONS(561),
    [anon_sym_delete] = ACTIONS(561),
    [anon_sym_PLUS_PLUS] = ACTIONS(563),
    [anon_sym_DASH_DASH] = ACTIONS(563),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(529),
    [anon_sym_get] = ACTIONS(529),
    [anon_sym_set] = ACTIONS(529),
    [anon_sym_declare] = ACTIONS(529),
    [anon_sym_public] = ACTIONS(529),
    [anon_sym_private] = ACTIONS(529),
    [anon_sym_protected] = ACTIONS(529),
    [anon_sym_module] = ACTIONS(529),
    [anon_sym_any] = ACTIONS(529),
    [anon_sym_number] = ACTIONS(529),
    [anon_sym_boolean] = ACTIONS(529),
    [anon_sym_string] = ACTIONS(529),
    [anon_sym_symbol] = ACTIONS(529),
    [sym_readonly] = ACTIONS(529),
  },
  [231] = {
    [sym_import] = STATE(1039),
    [sym_parenthesized_expression] = STATE(661),
    [sym__expression] = STATE(1682),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1023),
    [sym_array] = STATE(1024),
    [sym_class] = STATE(1039),
    [sym_function] = STATE(1039),
    [sym_generator_function] = STATE(1039),
    [sym_arrow_function] = STATE(1039),
    [sym__call_signature] = STATE(3336),
    [sym_call_expression] = STATE(1039),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(661),
    [sym_subscript_expression] = STATE(661),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1967),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1039),
    [sym_template_string] = STATE(1039),
    [sym_regex] = STATE(1039),
    [sym_meta_property] = STATE(1039),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2608),
    [sym_non_null_expression] = STATE(977),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(380),
    [sym_type_parameters] = STATE(3065),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(1388),
    [anon_sym_export] = ACTIONS(1390),
    [anon_sym_namespace] = ACTIONS(1392),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_type] = ACTIONS(1390),
    [anon_sym_typeof] = ACTIONS(639),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(625),
    [anon_sym_yield] = ACTIONS(627),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_DOT] = ACTIONS(1372),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(1394),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(887),
    [anon_sym_PLUS] = ACTIONS(889),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(623),
    [anon_sym_void] = ACTIONS(639),
    [anon_sym_delete] = ACTIONS(639),
    [anon_sym_PLUS_PLUS] = ACTIONS(641),
    [anon_sym_DASH_DASH] = ACTIONS(641),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(1376),
    [sym_this] = ACTIONS(1378),
    [sym_super] = ACTIONS(1378),
    [sym_true] = ACTIONS(1378),
    [sym_false] = ACTIONS(1378),
    [sym_null] = ACTIONS(1378),
    [sym_undefined] = ACTIONS(1378),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1390),
    [anon_sym_get] = ACTIONS(1390),
    [anon_sym_set] = ACTIONS(1390),
    [anon_sym_declare] = ACTIONS(1390),
    [anon_sym_public] = ACTIONS(1390),
    [anon_sym_private] = ACTIONS(1390),
    [anon_sym_protected] = ACTIONS(1390),
    [anon_sym_module] = ACTIONS(1390),
    [anon_sym_any] = ACTIONS(1390),
    [anon_sym_number] = ACTIONS(1390),
    [anon_sym_boolean] = ACTIONS(1390),
    [anon_sym_string] = ACTIONS(1390),
    [anon_sym_symbol] = ACTIONS(1390),
    [sym_readonly] = ACTIONS(1390),
  },
  [232] = {
    [sym_import] = STATE(1212),
    [sym_variable_declarator] = STATE(2732),
    [sym_parenthesized_expression] = STATE(987),
    [sym__expression] = STATE(1682),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1114),
    [sym_array] = STATE(1113),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3169),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(987),
    [sym_subscript_expression] = STATE(987),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1967),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(988),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(380),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(1459),
    [anon_sym_export] = ACTIONS(1461),
    [anon_sym_namespace] = ACTIONS(1463),
    [anon_sym_LBRACE] = ACTIONS(859),
    [anon_sym_type] = ACTIONS(1461),
    [anon_sym_typeof] = ACTIONS(639),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(625),
    [anon_sym_yield] = ACTIONS(627),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(1465),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(887),
    [anon_sym_PLUS] = ACTIONS(889),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(623),
    [anon_sym_void] = ACTIONS(639),
    [anon_sym_delete] = ACTIONS(639),
    [anon_sym_PLUS_PLUS] = ACTIONS(641),
    [anon_sym_DASH_DASH] = ACTIONS(641),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1461),
    [anon_sym_get] = ACTIONS(1461),
    [anon_sym_set] = ACTIONS(1461),
    [anon_sym_declare] = ACTIONS(1461),
    [anon_sym_public] = ACTIONS(1461),
    [anon_sym_private] = ACTIONS(1461),
    [anon_sym_protected] = ACTIONS(1461),
    [anon_sym_module] = ACTIONS(1461),
    [anon_sym_any] = ACTIONS(1461),
    [anon_sym_number] = ACTIONS(1461),
    [anon_sym_boolean] = ACTIONS(1461),
    [anon_sym_string] = ACTIONS(1461),
    [anon_sym_symbol] = ACTIONS(1461),
    [sym_readonly] = ACTIONS(1461),
  },
  [233] = {
    [sym_import] = STATE(1212),
    [sym_variable_declarator] = STATE(2729),
    [sym_parenthesized_expression] = STATE(987),
    [sym__expression] = STATE(1682),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1114),
    [sym_array] = STATE(1113),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3169),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(987),
    [sym_subscript_expression] = STATE(987),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1967),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(988),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(380),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(1459),
    [anon_sym_export] = ACTIONS(1461),
    [anon_sym_namespace] = ACTIONS(1463),
    [anon_sym_LBRACE] = ACTIONS(859),
    [anon_sym_type] = ACTIONS(1461),
    [anon_sym_typeof] = ACTIONS(639),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(625),
    [anon_sym_yield] = ACTIONS(627),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(1465),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(887),
    [anon_sym_PLUS] = ACTIONS(889),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(623),
    [anon_sym_void] = ACTIONS(639),
    [anon_sym_delete] = ACTIONS(639),
    [anon_sym_PLUS_PLUS] = ACTIONS(641),
    [anon_sym_DASH_DASH] = ACTIONS(641),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1461),
    [anon_sym_get] = ACTIONS(1461),
    [anon_sym_set] = ACTIONS(1461),
    [anon_sym_declare] = ACTIONS(1461),
    [anon_sym_public] = ACTIONS(1461),
    [anon_sym_private] = ACTIONS(1461),
    [anon_sym_protected] = ACTIONS(1461),
    [anon_sym_module] = ACTIONS(1461),
    [anon_sym_any] = ACTIONS(1461),
    [anon_sym_number] = ACTIONS(1461),
    [anon_sym_boolean] = ACTIONS(1461),
    [anon_sym_string] = ACTIONS(1461),
    [anon_sym_symbol] = ACTIONS(1461),
    [sym_readonly] = ACTIONS(1461),
  },
  [234] = {
    [sym_import] = STATE(1039),
    [sym_parenthesized_expression] = STATE(661),
    [sym__expression] = STATE(1682),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1023),
    [sym_array] = STATE(1024),
    [sym_class] = STATE(1039),
    [sym_function] = STATE(1039),
    [sym_generator_function] = STATE(1039),
    [sym_arrow_function] = STATE(1039),
    [sym__call_signature] = STATE(3169),
    [sym_call_expression] = STATE(1039),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(661),
    [sym_subscript_expression] = STATE(661),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1967),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1039),
    [sym_template_string] = STATE(1039),
    [sym_regex] = STATE(1039),
    [sym_meta_property] = STATE(1039),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(977),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(380),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(1447),
    [anon_sym_export] = ACTIONS(1449),
    [anon_sym_namespace] = ACTIONS(1451),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_type] = ACTIONS(1449),
    [anon_sym_typeof] = ACTIONS(639),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(625),
    [anon_sym_yield] = ACTIONS(627),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_DOT] = ACTIONS(1372),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(1453),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(887),
    [anon_sym_PLUS] = ACTIONS(889),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(623),
    [anon_sym_void] = ACTIONS(639),
    [anon_sym_delete] = ACTIONS(639),
    [anon_sym_PLUS_PLUS] = ACTIONS(641),
    [anon_sym_DASH_DASH] = ACTIONS(641),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(1376),
    [sym_this] = ACTIONS(1378),
    [sym_super] = ACTIONS(1378),
    [sym_true] = ACTIONS(1378),
    [sym_false] = ACTIONS(1378),
    [sym_null] = ACTIONS(1378),
    [sym_undefined] = ACTIONS(1378),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1449),
    [anon_sym_get] = ACTIONS(1449),
    [anon_sym_set] = ACTIONS(1449),
    [anon_sym_declare] = ACTIONS(1449),
    [anon_sym_public] = ACTIONS(1449),
    [anon_sym_private] = ACTIONS(1449),
    [anon_sym_protected] = ACTIONS(1449),
    [anon_sym_module] = ACTIONS(1449),
    [anon_sym_any] = ACTIONS(1449),
    [anon_sym_number] = ACTIONS(1449),
    [anon_sym_boolean] = ACTIONS(1449),
    [anon_sym_string] = ACTIONS(1449),
    [anon_sym_symbol] = ACTIONS(1449),
    [sym_readonly] = ACTIONS(1449),
  },
  [235] = {
    [sym_import] = STATE(1212),
    [sym_statement_block] = STATE(1223),
    [sym_parenthesized_expression] = STATE(884),
    [sym__expression] = STATE(1093),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1283),
    [sym_array] = STATE(1281),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3336),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(884),
    [sym_subscript_expression] = STATE(884),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1964),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(860),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(414),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(831),
    [anon_sym_export] = ACTIONS(503),
    [anon_sym_namespace] = ACTIONS(505),
    [anon_sym_LBRACE] = ACTIONS(1336),
    [anon_sym_type] = ACTIONS(503),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(437),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(443),
    [anon_sym_yield] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(849),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(851),
    [anon_sym_TILDE] = ACTIONS(437),
    [anon_sym_void] = ACTIONS(471),
    [anon_sym_delete] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(473),
    [anon_sym_DASH_DASH] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(503),
    [anon_sym_get] = ACTIONS(503),
    [anon_sym_set] = ACTIONS(503),
    [anon_sym_declare] = ACTIONS(503),
    [anon_sym_public] = ACTIONS(503),
    [anon_sym_private] = ACTIONS(503),
    [anon_sym_protected] = ACTIONS(503),
    [anon_sym_module] = ACTIONS(503),
    [anon_sym_any] = ACTIONS(503),
    [anon_sym_number] = ACTIONS(503),
    [anon_sym_boolean] = ACTIONS(503),
    [anon_sym_string] = ACTIONS(503),
    [anon_sym_symbol] = ACTIONS(503),
    [sym_readonly] = ACTIONS(503),
  },
  [236] = {
    [sym_import] = STATE(1528),
    [sym_statement_block] = STATE(1572),
    [sym_parenthesized_expression] = STATE(933),
    [sym__expression] = STATE(1188),
    [sym_yield_expression] = STATE(1543),
    [sym_object] = STATE(1367),
    [sym_array] = STATE(1369),
    [sym_class] = STATE(1528),
    [sym_function] = STATE(1528),
    [sym_generator_function] = STATE(1528),
    [sym_arrow_function] = STATE(1528),
    [sym__call_signature] = STATE(3359),
    [sym_call_expression] = STATE(1528),
    [sym_new_expression] = STATE(1543),
    [sym_await_expression] = STATE(1543),
    [sym_member_expression] = STATE(933),
    [sym_subscript_expression] = STATE(933),
    [sym_assignment_expression] = STATE(1543),
    [sym__augmented_assignment_lhs] = STATE(1970),
    [sym_augmented_assignment_expression] = STATE(1543),
    [sym_ternary_expression] = STATE(1543),
    [sym_binary_expression] = STATE(1543),
    [sym_unary_expression] = STATE(1543),
    [sym_update_expression] = STATE(1543),
    [sym_string] = STATE(1528),
    [sym_template_string] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_meta_property] = STATE(1528),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(936),
    [sym_type_assertion] = STATE(1543),
    [sym_as_expression] = STATE(1543),
    [sym_internal_module] = STATE(1543),
    [sym_type_arguments] = STATE(381),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2726),
    [sym_identifier] = ACTIONS(855),
    [anon_sym_export] = ACTIONS(745),
    [anon_sym_namespace] = ACTIONS(747),
    [anon_sym_LBRACE] = ACTIONS(1338),
    [anon_sym_type] = ACTIONS(745),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(537),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(549),
    [anon_sym_async] = ACTIONS(753),
    [anon_sym_function] = ACTIONS(553),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(745),
    [anon_sym_get] = ACTIONS(745),
    [anon_sym_set] = ACTIONS(745),
    [anon_sym_declare] = ACTIONS(745),
    [anon_sym_public] = ACTIONS(745),
    [anon_sym_private] = ACTIONS(745),
    [anon_sym_protected] = ACTIONS(745),
    [anon_sym_module] = ACTIONS(745),
    [anon_sym_any] = ACTIONS(745),
    [anon_sym_number] = ACTIONS(745),
    [anon_sym_boolean] = ACTIONS(745),
    [anon_sym_string] = ACTIONS(745),
    [anon_sym_symbol] = ACTIONS(745),
    [sym_readonly] = ACTIONS(745),
  },
  [237] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(884),
    [sym__expression] = STATE(1411),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1283),
    [sym_array] = STATE(1281),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3336),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(884),
    [sym_subscript_expression] = STATE(884),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1964),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_sequence_expression] = STATE(3346),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(860),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(414),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(831),
    [anon_sym_export] = ACTIONS(503),
    [anon_sym_namespace] = ACTIONS(505),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_type] = ACTIONS(503),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(437),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(443),
    [anon_sym_yield] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(849),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(851),
    [anon_sym_TILDE] = ACTIONS(437),
    [anon_sym_void] = ACTIONS(471),
    [anon_sym_delete] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(473),
    [anon_sym_DASH_DASH] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(503),
    [anon_sym_get] = ACTIONS(503),
    [anon_sym_set] = ACTIONS(503),
    [anon_sym_declare] = ACTIONS(503),
    [anon_sym_public] = ACTIONS(503),
    [anon_sym_private] = ACTIONS(503),
    [anon_sym_protected] = ACTIONS(503),
    [anon_sym_module] = ACTIONS(503),
    [anon_sym_any] = ACTIONS(503),
    [anon_sym_number] = ACTIONS(503),
    [anon_sym_boolean] = ACTIONS(503),
    [anon_sym_string] = ACTIONS(503),
    [anon_sym_symbol] = ACTIONS(503),
    [sym_readonly] = ACTIONS(503),
  },
  [238] = {
    [sym_import] = STATE(1212),
    [sym_statement_block] = STATE(1156),
    [sym_parenthesized_expression] = STATE(884),
    [sym__expression] = STATE(1062),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1283),
    [sym_array] = STATE(1281),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3336),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(884),
    [sym_subscript_expression] = STATE(884),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1964),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(860),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(414),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(831),
    [anon_sym_export] = ACTIONS(503),
    [anon_sym_namespace] = ACTIONS(505),
    [anon_sym_LBRACE] = ACTIONS(1336),
    [anon_sym_type] = ACTIONS(503),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(437),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(443),
    [anon_sym_yield] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(849),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(851),
    [anon_sym_TILDE] = ACTIONS(437),
    [anon_sym_void] = ACTIONS(471),
    [anon_sym_delete] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(473),
    [anon_sym_DASH_DASH] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(503),
    [anon_sym_get] = ACTIONS(503),
    [anon_sym_set] = ACTIONS(503),
    [anon_sym_declare] = ACTIONS(503),
    [anon_sym_public] = ACTIONS(503),
    [anon_sym_private] = ACTIONS(503),
    [anon_sym_protected] = ACTIONS(503),
    [anon_sym_module] = ACTIONS(503),
    [anon_sym_any] = ACTIONS(503),
    [anon_sym_number] = ACTIONS(503),
    [anon_sym_boolean] = ACTIONS(503),
    [anon_sym_string] = ACTIONS(503),
    [anon_sym_symbol] = ACTIONS(503),
    [sym_readonly] = ACTIONS(503),
  },
  [239] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(884),
    [sym__expression] = STATE(1409),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1283),
    [sym_array] = STATE(1281),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3336),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(884),
    [sym_subscript_expression] = STATE(884),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1964),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_sequence_expression] = STATE(3383),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(860),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(414),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(831),
    [anon_sym_export] = ACTIONS(503),
    [anon_sym_namespace] = ACTIONS(505),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_type] = ACTIONS(503),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(437),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(443),
    [anon_sym_yield] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(849),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(851),
    [anon_sym_TILDE] = ACTIONS(437),
    [anon_sym_void] = ACTIONS(471),
    [anon_sym_delete] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(473),
    [anon_sym_DASH_DASH] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(503),
    [anon_sym_get] = ACTIONS(503),
    [anon_sym_set] = ACTIONS(503),
    [anon_sym_declare] = ACTIONS(503),
    [anon_sym_public] = ACTIONS(503),
    [anon_sym_private] = ACTIONS(503),
    [anon_sym_protected] = ACTIONS(503),
    [anon_sym_module] = ACTIONS(503),
    [anon_sym_any] = ACTIONS(503),
    [anon_sym_number] = ACTIONS(503),
    [anon_sym_boolean] = ACTIONS(503),
    [anon_sym_string] = ACTIONS(503),
    [anon_sym_symbol] = ACTIONS(503),
    [sym_readonly] = ACTIONS(503),
  },
  [240] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(884),
    [sym__expression] = STATE(1406),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1283),
    [sym_array] = STATE(1281),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3336),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(884),
    [sym_subscript_expression] = STATE(884),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1964),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_sequence_expression] = STATE(3390),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(860),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(414),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(831),
    [anon_sym_export] = ACTIONS(503),
    [anon_sym_namespace] = ACTIONS(505),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_type] = ACTIONS(503),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(437),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(443),
    [anon_sym_yield] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(849),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(851),
    [anon_sym_TILDE] = ACTIONS(437),
    [anon_sym_void] = ACTIONS(471),
    [anon_sym_delete] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(473),
    [anon_sym_DASH_DASH] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(503),
    [anon_sym_get] = ACTIONS(503),
    [anon_sym_set] = ACTIONS(503),
    [anon_sym_declare] = ACTIONS(503),
    [anon_sym_public] = ACTIONS(503),
    [anon_sym_private] = ACTIONS(503),
    [anon_sym_protected] = ACTIONS(503),
    [anon_sym_module] = ACTIONS(503),
    [anon_sym_any] = ACTIONS(503),
    [anon_sym_number] = ACTIONS(503),
    [anon_sym_boolean] = ACTIONS(503),
    [anon_sym_string] = ACTIONS(503),
    [anon_sym_symbol] = ACTIONS(503),
    [sym_readonly] = ACTIONS(503),
  },
  [241] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(884),
    [sym__expression] = STATE(1401),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1283),
    [sym_array] = STATE(1281),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3336),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(884),
    [sym_subscript_expression] = STATE(884),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1964),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_sequence_expression] = STATE(3395),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(860),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(414),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(831),
    [anon_sym_export] = ACTIONS(503),
    [anon_sym_namespace] = ACTIONS(505),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_type] = ACTIONS(503),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(437),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(443),
    [anon_sym_yield] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(849),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(851),
    [anon_sym_TILDE] = ACTIONS(437),
    [anon_sym_void] = ACTIONS(471),
    [anon_sym_delete] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(473),
    [anon_sym_DASH_DASH] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(503),
    [anon_sym_get] = ACTIONS(503),
    [anon_sym_set] = ACTIONS(503),
    [anon_sym_declare] = ACTIONS(503),
    [anon_sym_public] = ACTIONS(503),
    [anon_sym_private] = ACTIONS(503),
    [anon_sym_protected] = ACTIONS(503),
    [anon_sym_module] = ACTIONS(503),
    [anon_sym_any] = ACTIONS(503),
    [anon_sym_number] = ACTIONS(503),
    [anon_sym_boolean] = ACTIONS(503),
    [anon_sym_string] = ACTIONS(503),
    [anon_sym_symbol] = ACTIONS(503),
    [sym_readonly] = ACTIONS(503),
  },
  [242] = {
    [sym_import] = STATE(1039),
    [sym_parenthesized_expression] = STATE(661),
    [sym__expression] = STATE(1682),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1023),
    [sym_array] = STATE(1024),
    [sym_class] = STATE(1039),
    [sym_function] = STATE(1039),
    [sym_generator_function] = STATE(1039),
    [sym_arrow_function] = STATE(1039),
    [sym__call_signature] = STATE(3169),
    [sym_call_expression] = STATE(1039),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(661),
    [sym_subscript_expression] = STATE(661),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1967),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1039),
    [sym_template_string] = STATE(1039),
    [sym_regex] = STATE(1039),
    [sym_meta_property] = STATE(1039),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(977),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(380),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(1447),
    [anon_sym_export] = ACTIONS(1449),
    [anon_sym_namespace] = ACTIONS(1451),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_type] = ACTIONS(1449),
    [anon_sym_typeof] = ACTIONS(639),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(625),
    [anon_sym_yield] = ACTIONS(627),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_DOT] = ACTIONS(1406),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(1453),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(887),
    [anon_sym_PLUS] = ACTIONS(889),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(623),
    [anon_sym_void] = ACTIONS(639),
    [anon_sym_delete] = ACTIONS(639),
    [anon_sym_PLUS_PLUS] = ACTIONS(641),
    [anon_sym_DASH_DASH] = ACTIONS(641),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(1376),
    [sym_this] = ACTIONS(1378),
    [sym_super] = ACTIONS(1378),
    [sym_true] = ACTIONS(1378),
    [sym_false] = ACTIONS(1378),
    [sym_null] = ACTIONS(1378),
    [sym_undefined] = ACTIONS(1378),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1449),
    [anon_sym_get] = ACTIONS(1449),
    [anon_sym_set] = ACTIONS(1449),
    [anon_sym_declare] = ACTIONS(1449),
    [anon_sym_public] = ACTIONS(1449),
    [anon_sym_private] = ACTIONS(1449),
    [anon_sym_protected] = ACTIONS(1449),
    [anon_sym_module] = ACTIONS(1449),
    [anon_sym_any] = ACTIONS(1449),
    [anon_sym_number] = ACTIONS(1449),
    [anon_sym_boolean] = ACTIONS(1449),
    [anon_sym_string] = ACTIONS(1449),
    [anon_sym_symbol] = ACTIONS(1449),
    [sym_readonly] = ACTIONS(1449),
  },
  [243] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(884),
    [sym__expression] = STATE(1353),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1283),
    [sym_array] = STATE(1281),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3336),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(884),
    [sym_subscript_expression] = STATE(884),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1964),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_sequence_expression] = STATE(3234),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(860),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(414),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(831),
    [anon_sym_export] = ACTIONS(503),
    [anon_sym_namespace] = ACTIONS(505),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_type] = ACTIONS(503),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(437),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(443),
    [anon_sym_yield] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(849),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(851),
    [anon_sym_TILDE] = ACTIONS(437),
    [anon_sym_void] = ACTIONS(471),
    [anon_sym_delete] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(473),
    [anon_sym_DASH_DASH] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(503),
    [anon_sym_get] = ACTIONS(503),
    [anon_sym_set] = ACTIONS(503),
    [anon_sym_declare] = ACTIONS(503),
    [anon_sym_public] = ACTIONS(503),
    [anon_sym_private] = ACTIONS(503),
    [anon_sym_protected] = ACTIONS(503),
    [anon_sym_module] = ACTIONS(503),
    [anon_sym_any] = ACTIONS(503),
    [anon_sym_number] = ACTIONS(503),
    [anon_sym_boolean] = ACTIONS(503),
    [anon_sym_string] = ACTIONS(503),
    [anon_sym_symbol] = ACTIONS(503),
    [sym_readonly] = ACTIONS(503),
  },
  [244] = {
    [sym_import] = STATE(1212),
    [sym_statement_block] = STATE(1201),
    [sym_parenthesized_expression] = STATE(884),
    [sym__expression] = STATE(1120),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1283),
    [sym_array] = STATE(1281),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3336),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(884),
    [sym_subscript_expression] = STATE(884),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1964),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(860),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(414),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(831),
    [anon_sym_export] = ACTIONS(503),
    [anon_sym_namespace] = ACTIONS(505),
    [anon_sym_LBRACE] = ACTIONS(1336),
    [anon_sym_type] = ACTIONS(503),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(437),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(443),
    [anon_sym_yield] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(849),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(851),
    [anon_sym_TILDE] = ACTIONS(437),
    [anon_sym_void] = ACTIONS(471),
    [anon_sym_delete] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(473),
    [anon_sym_DASH_DASH] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(503),
    [anon_sym_get] = ACTIONS(503),
    [anon_sym_set] = ACTIONS(503),
    [anon_sym_declare] = ACTIONS(503),
    [anon_sym_public] = ACTIONS(503),
    [anon_sym_private] = ACTIONS(503),
    [anon_sym_protected] = ACTIONS(503),
    [anon_sym_module] = ACTIONS(503),
    [anon_sym_any] = ACTIONS(503),
    [anon_sym_number] = ACTIONS(503),
    [anon_sym_boolean] = ACTIONS(503),
    [anon_sym_string] = ACTIONS(503),
    [anon_sym_symbol] = ACTIONS(503),
    [sym_readonly] = ACTIONS(503),
  },
  [245] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(884),
    [sym__expression] = STATE(1094),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1283),
    [sym_array] = STATE(1281),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3336),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(884),
    [sym_subscript_expression] = STATE(884),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1964),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_sequence_expression] = STATE(2630),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(860),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(414),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(831),
    [anon_sym_export] = ACTIONS(503),
    [anon_sym_namespace] = ACTIONS(505),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_type] = ACTIONS(503),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(437),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(443),
    [anon_sym_yield] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(849),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(851),
    [anon_sym_TILDE] = ACTIONS(437),
    [anon_sym_void] = ACTIONS(471),
    [anon_sym_delete] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(473),
    [anon_sym_DASH_DASH] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(503),
    [anon_sym_get] = ACTIONS(503),
    [anon_sym_set] = ACTIONS(503),
    [anon_sym_declare] = ACTIONS(503),
    [anon_sym_public] = ACTIONS(503),
    [anon_sym_private] = ACTIONS(503),
    [anon_sym_protected] = ACTIONS(503),
    [anon_sym_module] = ACTIONS(503),
    [anon_sym_any] = ACTIONS(503),
    [anon_sym_number] = ACTIONS(503),
    [anon_sym_boolean] = ACTIONS(503),
    [anon_sym_string] = ACTIONS(503),
    [anon_sym_symbol] = ACTIONS(503),
    [sym_readonly] = ACTIONS(503),
  },
  [246] = {
    [sym_import] = STATE(1265),
    [sym_parenthesized_expression] = STATE(751),
    [sym__expression] = STATE(1697),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1195),
    [sym_array] = STATE(1181),
    [sym_class] = STATE(1265),
    [sym_function] = STATE(1265),
    [sym_generator_function] = STATE(1265),
    [sym_arrow_function] = STATE(1265),
    [sym__call_signature] = STATE(3235),
    [sym_call_expression] = STATE(1265),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(751),
    [sym_subscript_expression] = STATE(751),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1967),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1265),
    [sym_template_string] = STATE(1265),
    [sym_regex] = STATE(1265),
    [sym_meta_property] = STATE(1265),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(977),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(380),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2726),
    [sym_identifier] = ACTIONS(1380),
    [anon_sym_export] = ACTIONS(1382),
    [anon_sym_namespace] = ACTIONS(1384),
    [anon_sym_LBRACE] = ACTIONS(859),
    [anon_sym_type] = ACTIONS(1382),
    [anon_sym_typeof] = ACTIONS(639),
    [anon_sym_import] = ACTIONS(537),
    [anon_sym_BANG] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(625),
    [anon_sym_yield] = ACTIONS(627),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_DOT] = ACTIONS(1348),
    [anon_sym_class] = ACTIONS(549),
    [anon_sym_async] = ACTIONS(1386),
    [anon_sym_function] = ACTIONS(553),
    [anon_sym_new] = ACTIONS(1352),
    [anon_sym_PLUS] = ACTIONS(889),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(623),
    [anon_sym_void] = ACTIONS(639),
    [anon_sym_delete] = ACTIONS(639),
    [anon_sym_PLUS_PLUS] = ACTIONS(641),
    [anon_sym_DASH_DASH] = ACTIONS(641),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(1354),
    [sym_this] = ACTIONS(1356),
    [sym_super] = ACTIONS(1356),
    [sym_true] = ACTIONS(1356),
    [sym_false] = ACTIONS(1356),
    [sym_null] = ACTIONS(1356),
    [sym_undefined] = ACTIONS(1356),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1382),
    [anon_sym_get] = ACTIONS(1382),
    [anon_sym_set] = ACTIONS(1382),
    [anon_sym_declare] = ACTIONS(1382),
    [anon_sym_public] = ACTIONS(1382),
    [anon_sym_private] = ACTIONS(1382),
    [anon_sym_protected] = ACTIONS(1382),
    [anon_sym_module] = ACTIONS(1382),
    [anon_sym_any] = ACTIONS(1382),
    [anon_sym_number] = ACTIONS(1382),
    [anon_sym_boolean] = ACTIONS(1382),
    [anon_sym_string] = ACTIONS(1382),
    [anon_sym_symbol] = ACTIONS(1382),
    [sym_readonly] = ACTIONS(1382),
  },
  [247] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(884),
    [sym__expression] = STATE(1356),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1283),
    [sym_array] = STATE(1281),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3336),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(884),
    [sym_subscript_expression] = STATE(884),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1964),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_sequence_expression] = STATE(3218),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(860),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(414),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(831),
    [anon_sym_export] = ACTIONS(503),
    [anon_sym_namespace] = ACTIONS(505),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_type] = ACTIONS(503),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(437),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(443),
    [anon_sym_yield] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(849),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(851),
    [anon_sym_TILDE] = ACTIONS(437),
    [anon_sym_void] = ACTIONS(471),
    [anon_sym_delete] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(473),
    [anon_sym_DASH_DASH] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(503),
    [anon_sym_get] = ACTIONS(503),
    [anon_sym_set] = ACTIONS(503),
    [anon_sym_declare] = ACTIONS(503),
    [anon_sym_public] = ACTIONS(503),
    [anon_sym_private] = ACTIONS(503),
    [anon_sym_protected] = ACTIONS(503),
    [anon_sym_module] = ACTIONS(503),
    [anon_sym_any] = ACTIONS(503),
    [anon_sym_number] = ACTIONS(503),
    [anon_sym_boolean] = ACTIONS(503),
    [anon_sym_string] = ACTIONS(503),
    [anon_sym_symbol] = ACTIONS(503),
    [sym_readonly] = ACTIONS(503),
  },
  [248] = {
    [sym_import] = STATE(1212),
    [sym_statement_block] = STATE(1143),
    [sym_parenthesized_expression] = STATE(884),
    [sym__expression] = STATE(1050),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1283),
    [sym_array] = STATE(1281),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3336),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(884),
    [sym_subscript_expression] = STATE(884),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1964),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(860),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(414),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(831),
    [anon_sym_export] = ACTIONS(503),
    [anon_sym_namespace] = ACTIONS(505),
    [anon_sym_LBRACE] = ACTIONS(1336),
    [anon_sym_type] = ACTIONS(503),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(437),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(443),
    [anon_sym_yield] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(849),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(851),
    [anon_sym_TILDE] = ACTIONS(437),
    [anon_sym_void] = ACTIONS(471),
    [anon_sym_delete] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(473),
    [anon_sym_DASH_DASH] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(503),
    [anon_sym_get] = ACTIONS(503),
    [anon_sym_set] = ACTIONS(503),
    [anon_sym_declare] = ACTIONS(503),
    [anon_sym_public] = ACTIONS(503),
    [anon_sym_private] = ACTIONS(503),
    [anon_sym_protected] = ACTIONS(503),
    [anon_sym_module] = ACTIONS(503),
    [anon_sym_any] = ACTIONS(503),
    [anon_sym_number] = ACTIONS(503),
    [anon_sym_boolean] = ACTIONS(503),
    [anon_sym_string] = ACTIONS(503),
    [anon_sym_symbol] = ACTIONS(503),
    [sym_readonly] = ACTIONS(503),
  },
  [249] = {
    [sym_import] = STATE(1265),
    [sym_parenthesized_expression] = STATE(751),
    [sym__expression] = STATE(1697),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1195),
    [sym_array] = STATE(1181),
    [sym_class] = STATE(1265),
    [sym_function] = STATE(1265),
    [sym_generator_function] = STATE(1265),
    [sym_arrow_function] = STATE(1265),
    [sym__call_signature] = STATE(3359),
    [sym_call_expression] = STATE(1265),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(751),
    [sym_subscript_expression] = STATE(751),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1967),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1265),
    [sym_template_string] = STATE(1265),
    [sym_regex] = STATE(1265),
    [sym_meta_property] = STATE(1265),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(977),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(380),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2726),
    [sym_identifier] = ACTIONS(1342),
    [anon_sym_export] = ACTIONS(1344),
    [anon_sym_namespace] = ACTIONS(1346),
    [anon_sym_LBRACE] = ACTIONS(859),
    [anon_sym_type] = ACTIONS(1344),
    [anon_sym_typeof] = ACTIONS(639),
    [anon_sym_import] = ACTIONS(537),
    [anon_sym_BANG] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(625),
    [anon_sym_yield] = ACTIONS(627),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_DOT] = ACTIONS(1348),
    [anon_sym_class] = ACTIONS(549),
    [anon_sym_async] = ACTIONS(1350),
    [anon_sym_function] = ACTIONS(553),
    [anon_sym_new] = ACTIONS(1352),
    [anon_sym_PLUS] = ACTIONS(889),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(623),
    [anon_sym_void] = ACTIONS(639),
    [anon_sym_delete] = ACTIONS(639),
    [anon_sym_PLUS_PLUS] = ACTIONS(641),
    [anon_sym_DASH_DASH] = ACTIONS(641),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(1354),
    [sym_this] = ACTIONS(1356),
    [sym_super] = ACTIONS(1356),
    [sym_true] = ACTIONS(1356),
    [sym_false] = ACTIONS(1356),
    [sym_null] = ACTIONS(1356),
    [sym_undefined] = ACTIONS(1356),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1344),
    [anon_sym_get] = ACTIONS(1344),
    [anon_sym_set] = ACTIONS(1344),
    [anon_sym_declare] = ACTIONS(1344),
    [anon_sym_public] = ACTIONS(1344),
    [anon_sym_private] = ACTIONS(1344),
    [anon_sym_protected] = ACTIONS(1344),
    [anon_sym_module] = ACTIONS(1344),
    [anon_sym_any] = ACTIONS(1344),
    [anon_sym_number] = ACTIONS(1344),
    [anon_sym_boolean] = ACTIONS(1344),
    [anon_sym_string] = ACTIONS(1344),
    [anon_sym_symbol] = ACTIONS(1344),
    [sym_readonly] = ACTIONS(1344),
  },
  [250] = {
    [sym_import] = STATE(1528),
    [sym_statement_block] = STATE(1548),
    [sym_parenthesized_expression] = STATE(933),
    [sym__expression] = STATE(1159),
    [sym_yield_expression] = STATE(1543),
    [sym_object] = STATE(1367),
    [sym_array] = STATE(1369),
    [sym_class] = STATE(1528),
    [sym_function] = STATE(1528),
    [sym_generator_function] = STATE(1528),
    [sym_arrow_function] = STATE(1528),
    [sym__call_signature] = STATE(3359),
    [sym_call_expression] = STATE(1528),
    [sym_new_expression] = STATE(1543),
    [sym_await_expression] = STATE(1543),
    [sym_member_expression] = STATE(933),
    [sym_subscript_expression] = STATE(933),
    [sym_assignment_expression] = STATE(1543),
    [sym__augmented_assignment_lhs] = STATE(1970),
    [sym_augmented_assignment_expression] = STATE(1543),
    [sym_ternary_expression] = STATE(1543),
    [sym_binary_expression] = STATE(1543),
    [sym_unary_expression] = STATE(1543),
    [sym_update_expression] = STATE(1543),
    [sym_string] = STATE(1528),
    [sym_template_string] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_meta_property] = STATE(1528),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(936),
    [sym_type_assertion] = STATE(1543),
    [sym_as_expression] = STATE(1543),
    [sym_internal_module] = STATE(1543),
    [sym_type_arguments] = STATE(381),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2726),
    [sym_identifier] = ACTIONS(855),
    [anon_sym_export] = ACTIONS(745),
    [anon_sym_namespace] = ACTIONS(747),
    [anon_sym_LBRACE] = ACTIONS(1338),
    [anon_sym_type] = ACTIONS(745),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(537),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(549),
    [anon_sym_async] = ACTIONS(753),
    [anon_sym_function] = ACTIONS(553),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(745),
    [anon_sym_get] = ACTIONS(745),
    [anon_sym_set] = ACTIONS(745),
    [anon_sym_declare] = ACTIONS(745),
    [anon_sym_public] = ACTIONS(745),
    [anon_sym_private] = ACTIONS(745),
    [anon_sym_protected] = ACTIONS(745),
    [anon_sym_module] = ACTIONS(745),
    [anon_sym_any] = ACTIONS(745),
    [anon_sym_number] = ACTIONS(745),
    [anon_sym_boolean] = ACTIONS(745),
    [anon_sym_string] = ACTIONS(745),
    [anon_sym_symbol] = ACTIONS(745),
    [sym_readonly] = ACTIONS(745),
  },
  [251] = {
    [sym_import] = STATE(1528),
    [sym_parenthesized_expression] = STATE(933),
    [sym__expression] = STATE(1314),
    [sym_yield_expression] = STATE(1543),
    [sym_object] = STATE(1367),
    [sym_array] = STATE(1369),
    [sym_class] = STATE(1528),
    [sym_function] = STATE(1528),
    [sym_generator_function] = STATE(1528),
    [sym_arrow_function] = STATE(1528),
    [sym__call_signature] = STATE(3359),
    [sym_call_expression] = STATE(1528),
    [sym_new_expression] = STATE(1543),
    [sym_await_expression] = STATE(1543),
    [sym_member_expression] = STATE(933),
    [sym_subscript_expression] = STATE(933),
    [sym_assignment_expression] = STATE(1543),
    [sym__augmented_assignment_lhs] = STATE(1970),
    [sym_augmented_assignment_expression] = STATE(1543),
    [sym_ternary_expression] = STATE(1543),
    [sym_binary_expression] = STATE(1543),
    [sym_unary_expression] = STATE(1543),
    [sym_update_expression] = STATE(1543),
    [sym_sequence_expression] = STATE(2939),
    [sym_string] = STATE(1528),
    [sym_template_string] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_meta_property] = STATE(1528),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(936),
    [sym_type_assertion] = STATE(1543),
    [sym_as_expression] = STATE(1543),
    [sym_internal_module] = STATE(1543),
    [sym_type_arguments] = STATE(381),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2726),
    [sym_identifier] = ACTIONS(855),
    [anon_sym_export] = ACTIONS(745),
    [anon_sym_namespace] = ACTIONS(747),
    [anon_sym_LBRACE] = ACTIONS(859),
    [anon_sym_type] = ACTIONS(745),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(537),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(549),
    [anon_sym_async] = ACTIONS(753),
    [anon_sym_function] = ACTIONS(553),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(745),
    [anon_sym_get] = ACTIONS(745),
    [anon_sym_set] = ACTIONS(745),
    [anon_sym_declare] = ACTIONS(745),
    [anon_sym_public] = ACTIONS(745),
    [anon_sym_private] = ACTIONS(745),
    [anon_sym_protected] = ACTIONS(745),
    [anon_sym_module] = ACTIONS(745),
    [anon_sym_any] = ACTIONS(745),
    [anon_sym_number] = ACTIONS(745),
    [anon_sym_boolean] = ACTIONS(745),
    [anon_sym_string] = ACTIONS(745),
    [anon_sym_symbol] = ACTIONS(745),
    [sym_readonly] = ACTIONS(745),
  },
  [252] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(884),
    [sym__expression] = STATE(1376),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1283),
    [sym_array] = STATE(1281),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3336),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(884),
    [sym_subscript_expression] = STATE(884),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1964),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_sequence_expression] = STATE(3201),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(860),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(414),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(831),
    [anon_sym_export] = ACTIONS(503),
    [anon_sym_namespace] = ACTIONS(505),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_type] = ACTIONS(503),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(437),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(443),
    [anon_sym_yield] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(849),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(851),
    [anon_sym_TILDE] = ACTIONS(437),
    [anon_sym_void] = ACTIONS(471),
    [anon_sym_delete] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(473),
    [anon_sym_DASH_DASH] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(503),
    [anon_sym_get] = ACTIONS(503),
    [anon_sym_set] = ACTIONS(503),
    [anon_sym_declare] = ACTIONS(503),
    [anon_sym_public] = ACTIONS(503),
    [anon_sym_private] = ACTIONS(503),
    [anon_sym_protected] = ACTIONS(503),
    [anon_sym_module] = ACTIONS(503),
    [anon_sym_any] = ACTIONS(503),
    [anon_sym_number] = ACTIONS(503),
    [anon_sym_boolean] = ACTIONS(503),
    [anon_sym_string] = ACTIONS(503),
    [anon_sym_symbol] = ACTIONS(503),
    [sym_readonly] = ACTIONS(503),
  },
  [253] = {
    [sym_import] = STATE(1212),
    [sym_statement_block] = STATE(1154),
    [sym_parenthesized_expression] = STATE(884),
    [sym__expression] = STATE(1130),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1283),
    [sym_array] = STATE(1281),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3336),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(884),
    [sym_subscript_expression] = STATE(884),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1964),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(860),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(414),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(831),
    [anon_sym_export] = ACTIONS(503),
    [anon_sym_namespace] = ACTIONS(505),
    [anon_sym_LBRACE] = ACTIONS(1336),
    [anon_sym_type] = ACTIONS(503),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(437),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(443),
    [anon_sym_yield] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(849),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(851),
    [anon_sym_TILDE] = ACTIONS(437),
    [anon_sym_void] = ACTIONS(471),
    [anon_sym_delete] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(473),
    [anon_sym_DASH_DASH] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(503),
    [anon_sym_get] = ACTIONS(503),
    [anon_sym_set] = ACTIONS(503),
    [anon_sym_declare] = ACTIONS(503),
    [anon_sym_public] = ACTIONS(503),
    [anon_sym_private] = ACTIONS(503),
    [anon_sym_protected] = ACTIONS(503),
    [anon_sym_module] = ACTIONS(503),
    [anon_sym_any] = ACTIONS(503),
    [anon_sym_number] = ACTIONS(503),
    [anon_sym_boolean] = ACTIONS(503),
    [anon_sym_string] = ACTIONS(503),
    [anon_sym_symbol] = ACTIONS(503),
    [sym_readonly] = ACTIONS(503),
  },
  [254] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(884),
    [sym__expression] = STATE(1375),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1283),
    [sym_array] = STATE(1281),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3336),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(884),
    [sym_subscript_expression] = STATE(884),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1964),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_sequence_expression] = STATE(3202),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(860),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(414),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(831),
    [anon_sym_export] = ACTIONS(503),
    [anon_sym_namespace] = ACTIONS(505),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_type] = ACTIONS(503),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(437),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(443),
    [anon_sym_yield] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(849),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(851),
    [anon_sym_TILDE] = ACTIONS(437),
    [anon_sym_void] = ACTIONS(471),
    [anon_sym_delete] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(473),
    [anon_sym_DASH_DASH] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(503),
    [anon_sym_get] = ACTIONS(503),
    [anon_sym_set] = ACTIONS(503),
    [anon_sym_declare] = ACTIONS(503),
    [anon_sym_public] = ACTIONS(503),
    [anon_sym_private] = ACTIONS(503),
    [anon_sym_protected] = ACTIONS(503),
    [anon_sym_module] = ACTIONS(503),
    [anon_sym_any] = ACTIONS(503),
    [anon_sym_number] = ACTIONS(503),
    [anon_sym_boolean] = ACTIONS(503),
    [anon_sym_string] = ACTIONS(503),
    [anon_sym_symbol] = ACTIONS(503),
    [sym_readonly] = ACTIONS(503),
  },
  [255] = {
    [sym_import] = STATE(1528),
    [sym_parenthesized_expression] = STATE(933),
    [sym__expression] = STATE(1295),
    [sym_yield_expression] = STATE(1543),
    [sym_object] = STATE(1367),
    [sym_array] = STATE(1369),
    [sym_class] = STATE(1528),
    [sym_function] = STATE(1528),
    [sym_generator_function] = STATE(1528),
    [sym_arrow_function] = STATE(1528),
    [sym__call_signature] = STATE(3359),
    [sym_call_expression] = STATE(1528),
    [sym_new_expression] = STATE(1543),
    [sym_await_expression] = STATE(1543),
    [sym_member_expression] = STATE(933),
    [sym_subscript_expression] = STATE(933),
    [sym_assignment_expression] = STATE(1543),
    [sym__augmented_assignment_lhs] = STATE(1970),
    [sym_augmented_assignment_expression] = STATE(1543),
    [sym_ternary_expression] = STATE(1543),
    [sym_binary_expression] = STATE(1543),
    [sym_unary_expression] = STATE(1543),
    [sym_update_expression] = STATE(1543),
    [sym_sequence_expression] = STATE(3042),
    [sym_string] = STATE(1528),
    [sym_template_string] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_meta_property] = STATE(1528),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(936),
    [sym_type_assertion] = STATE(1543),
    [sym_as_expression] = STATE(1543),
    [sym_internal_module] = STATE(1543),
    [sym_type_arguments] = STATE(381),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2726),
    [sym_identifier] = ACTIONS(855),
    [anon_sym_export] = ACTIONS(745),
    [anon_sym_namespace] = ACTIONS(747),
    [anon_sym_LBRACE] = ACTIONS(859),
    [anon_sym_type] = ACTIONS(745),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(537),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(549),
    [anon_sym_async] = ACTIONS(753),
    [anon_sym_function] = ACTIONS(553),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(745),
    [anon_sym_get] = ACTIONS(745),
    [anon_sym_set] = ACTIONS(745),
    [anon_sym_declare] = ACTIONS(745),
    [anon_sym_public] = ACTIONS(745),
    [anon_sym_private] = ACTIONS(745),
    [anon_sym_protected] = ACTIONS(745),
    [anon_sym_module] = ACTIONS(745),
    [anon_sym_any] = ACTIONS(745),
    [anon_sym_number] = ACTIONS(745),
    [anon_sym_boolean] = ACTIONS(745),
    [anon_sym_string] = ACTIONS(745),
    [anon_sym_symbol] = ACTIONS(745),
    [sym_readonly] = ACTIONS(745),
  },
  [256] = {
    [sym__call_signature] = STATE(3284),
    [sym_string] = STATE(2332),
    [sym_formal_parameters] = STATE(2295),
    [sym__property_name] = STATE(2332),
    [sym_computed_property_name] = STATE(2332),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_object_repeat1] = STATE(2854),
    [sym_identifier] = ACTIONS(1416),
    [anon_sym_export] = ACTIONS(1418),
    [anon_sym_STAR] = ACTIONS(1420),
    [anon_sym_EQ] = ACTIONS(1260),
    [anon_sym_as] = ACTIONS(780),
    [anon_sym_namespace] = ACTIONS(1418),
    [anon_sym_COMMA] = ACTIONS(813),
    [anon_sym_RBRACE] = ACTIONS(1248),
    [anon_sym_type] = ACTIONS(1418),
    [anon_sym_BANG] = ACTIONS(780),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_in] = ACTIONS(780),
    [anon_sym_SEMI] = ACTIONS(813),
    [anon_sym_COLON] = ACTIONS(1220),
    [anon_sym_LBRACK] = ACTIONS(1427),
    [anon_sym_LT] = ACTIONS(1429),
    [anon_sym_GT] = ACTIONS(780),
    [anon_sym_SLASH] = ACTIONS(780),
    [anon_sym_DOT] = ACTIONS(927),
    [anon_sym_async] = ACTIONS(1418),
    [anon_sym_function] = ACTIONS(1433),
    [anon_sym_EQ_GT] = ACTIONS(929),
    [anon_sym_QMARK_DOT] = ACTIONS(931),
    [anon_sym_PLUS_EQ] = ACTIONS(803),
    [anon_sym_DASH_EQ] = ACTIONS(803),
    [anon_sym_STAR_EQ] = ACTIONS(803),
    [anon_sym_SLASH_EQ] = ACTIONS(803),
    [anon_sym_PERCENT_EQ] = ACTIONS(803),
    [anon_sym_CARET_EQ] = ACTIONS(803),
    [anon_sym_AMP_EQ] = ACTIONS(803),
    [anon_sym_PIPE_EQ] = ACTIONS(803),
    [anon_sym_GT_GT_EQ] = ACTIONS(803),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(803),
    [anon_sym_LT_LT_EQ] = ACTIONS(803),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(803),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(803),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(803),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(803),
    [anon_sym_QMARK] = ACTIONS(1225),
    [anon_sym_AMP_AMP] = ACTIONS(780),
    [anon_sym_PIPE_PIPE] = ACTIONS(780),
    [anon_sym_GT_GT] = ACTIONS(780),
    [anon_sym_GT_GT_GT] = ACTIONS(780),
    [anon_sym_LT_LT] = ACTIONS(780),
    [anon_sym_AMP] = ACTIONS(780),
    [anon_sym_CARET] = ACTIONS(780),
    [anon_sym_PIPE] = ACTIONS(780),
    [anon_sym_PLUS] = ACTIONS(780),
    [anon_sym_DASH] = ACTIONS(780),
    [anon_sym_PERCENT] = ACTIONS(780),
    [anon_sym_STAR_STAR] = ACTIONS(780),
    [anon_sym_LT_EQ] = ACTIONS(813),
    [anon_sym_EQ_EQ] = ACTIONS(780),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(813),
    [anon_sym_BANG_EQ] = ACTIONS(780),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(813),
    [anon_sym_GT_EQ] = ACTIONS(813),
    [anon_sym_QMARK_QMARK] = ACTIONS(780),
    [anon_sym_instanceof] = ACTIONS(780),
    [anon_sym_PLUS_PLUS] = ACTIONS(813),
    [anon_sym_DASH_DASH] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(817),
    [anon_sym_SQUOTE] = ACTIONS(819),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(813),
    [sym_number] = ACTIONS(1435),
    [anon_sym_static] = ACTIONS(1418),
    [anon_sym_get] = ACTIONS(1437),
    [anon_sym_set] = ACTIONS(1437),
    [anon_sym_declare] = ACTIONS(1418),
    [anon_sym_public] = ACTIONS(1418),
    [anon_sym_private] = ACTIONS(1418),
    [anon_sym_protected] = ACTIONS(1418),
    [anon_sym_module] = ACTIONS(1418),
    [anon_sym_any] = ACTIONS(1418),
    [anon_sym_number] = ACTIONS(1418),
    [anon_sym_boolean] = ACTIONS(1418),
    [anon_sym_string] = ACTIONS(1418),
    [anon_sym_symbol] = ACTIONS(1418),
    [sym_readonly] = ACTIONS(1418),
    [sym__automatic_semicolon] = ACTIONS(813),
  },
  [257] = {
    [sym_import] = STATE(1528),
    [sym_parenthesized_expression] = STATE(983),
    [sym__expression] = STATE(1390),
    [sym_yield_expression] = STATE(1543),
    [sym_object] = STATE(1671),
    [sym_array] = STATE(1713),
    [sym_class] = STATE(1528),
    [sym_function] = STATE(1528),
    [sym_generator_function] = STATE(1528),
    [sym_arrow_function] = STATE(1528),
    [sym__call_signature] = STATE(3235),
    [sym_call_expression] = STATE(1528),
    [sym_new_expression] = STATE(1543),
    [sym_await_expression] = STATE(1543),
    [sym_member_expression] = STATE(983),
    [sym_subscript_expression] = STATE(983),
    [sym_assignment_expression] = STATE(1543),
    [sym__augmented_assignment_lhs] = STATE(1963),
    [sym_augmented_assignment_expression] = STATE(1543),
    [sym_ternary_expression] = STATE(1543),
    [sym_binary_expression] = STATE(1543),
    [sym_unary_expression] = STATE(1543),
    [sym_update_expression] = STATE(1543),
    [sym_string] = STATE(1528),
    [sym_template_string] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_meta_property] = STATE(1528),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(984),
    [sym_function_signature] = STATE(2537),
    [sym_type_assertion] = STATE(1543),
    [sym_as_expression] = STATE(1543),
    [sym_internal_module] = STATE(1543),
    [sym_type_arguments] = STATE(310),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2726),
    [sym_identifier] = ACTIONS(891),
    [anon_sym_export] = ACTIONS(529),
    [anon_sym_namespace] = ACTIONS(531),
    [anon_sym_LBRACE] = ACTIONS(859),
    [anon_sym_type] = ACTIONS(529),
    [anon_sym_typeof] = ACTIONS(561),
    [anon_sym_import] = ACTIONS(537),
    [anon_sym_BANG] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(543),
    [anon_sym_yield] = ACTIONS(545),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(549),
    [anon_sym_async] = ACTIONS(1467),
    [anon_sym_function] = ACTIONS(1469),
    [anon_sym_new] = ACTIONS(897),
    [anon_sym_PLUS] = ACTIONS(899),
    [anon_sym_DASH] = ACTIONS(899),
    [anon_sym_TILDE] = ACTIONS(539),
    [anon_sym_void] = ACTIONS(561),
    [anon_sym_delete] = ACTIONS(561),
    [anon_sym_PLUS_PLUS] = ACTIONS(563),
    [anon_sym_DASH_DASH] = ACTIONS(563),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(529),
    [anon_sym_get] = ACTIONS(529),
    [anon_sym_set] = ACTIONS(529),
    [anon_sym_declare] = ACTIONS(529),
    [anon_sym_public] = ACTIONS(529),
    [anon_sym_private] = ACTIONS(529),
    [anon_sym_protected] = ACTIONS(529),
    [anon_sym_module] = ACTIONS(529),
    [anon_sym_any] = ACTIONS(529),
    [anon_sym_number] = ACTIONS(529),
    [anon_sym_boolean] = ACTIONS(529),
    [anon_sym_string] = ACTIONS(529),
    [anon_sym_symbol] = ACTIONS(529),
    [sym_readonly] = ACTIONS(529),
  },
  [258] = {
    [sym_import] = STATE(1528),
    [sym_parenthesized_expression] = STATE(933),
    [sym__expression] = STATE(1152),
    [sym_yield_expression] = STATE(1543),
    [sym_object] = STATE(1367),
    [sym_array] = STATE(1369),
    [sym_class] = STATE(1528),
    [sym_function] = STATE(1528),
    [sym_generator_function] = STATE(1528),
    [sym_arrow_function] = STATE(1528),
    [sym__call_signature] = STATE(3359),
    [sym_call_expression] = STATE(1528),
    [sym_new_expression] = STATE(1543),
    [sym_await_expression] = STATE(1543),
    [sym_member_expression] = STATE(933),
    [sym_subscript_expression] = STATE(933),
    [sym_assignment_expression] = STATE(1543),
    [sym__augmented_assignment_lhs] = STATE(1970),
    [sym_augmented_assignment_expression] = STATE(1543),
    [sym_ternary_expression] = STATE(1543),
    [sym_binary_expression] = STATE(1543),
    [sym_unary_expression] = STATE(1543),
    [sym_update_expression] = STATE(1543),
    [sym_string] = STATE(1528),
    [sym_template_string] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_meta_property] = STATE(1528),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(936),
    [sym_type_assertion] = STATE(1543),
    [sym_as_expression] = STATE(1543),
    [sym_internal_module] = STATE(1543),
    [sym_type_arguments] = STATE(381),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2726),
    [sym_identifier] = ACTIONS(855),
    [anon_sym_export] = ACTIONS(745),
    [anon_sym_namespace] = ACTIONS(747),
    [anon_sym_LBRACE] = ACTIONS(859),
    [anon_sym_type] = ACTIONS(745),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(537),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(549),
    [anon_sym_async] = ACTIONS(753),
    [anon_sym_function] = ACTIONS(553),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(745),
    [anon_sym_get] = ACTIONS(745),
    [anon_sym_set] = ACTIONS(745),
    [anon_sym_declare] = ACTIONS(745),
    [anon_sym_public] = ACTIONS(745),
    [anon_sym_private] = ACTIONS(745),
    [anon_sym_protected] = ACTIONS(745),
    [anon_sym_module] = ACTIONS(745),
    [anon_sym_any] = ACTIONS(745),
    [anon_sym_number] = ACTIONS(745),
    [anon_sym_boolean] = ACTIONS(745),
    [anon_sym_string] = ACTIONS(745),
    [anon_sym_symbol] = ACTIONS(745),
    [sym_readonly] = ACTIONS(745),
  },
  [259] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(884),
    [sym__expression] = STATE(1132),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1283),
    [sym_array] = STATE(1281),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3336),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(884),
    [sym_subscript_expression] = STATE(884),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1964),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(860),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(414),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(831),
    [anon_sym_export] = ACTIONS(503),
    [anon_sym_namespace] = ACTIONS(505),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_type] = ACTIONS(503),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(437),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(443),
    [anon_sym_yield] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(849),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(851),
    [anon_sym_TILDE] = ACTIONS(437),
    [anon_sym_void] = ACTIONS(471),
    [anon_sym_delete] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(473),
    [anon_sym_DASH_DASH] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(503),
    [anon_sym_get] = ACTIONS(503),
    [anon_sym_set] = ACTIONS(503),
    [anon_sym_declare] = ACTIONS(503),
    [anon_sym_public] = ACTIONS(503),
    [anon_sym_private] = ACTIONS(503),
    [anon_sym_protected] = ACTIONS(503),
    [anon_sym_module] = ACTIONS(503),
    [anon_sym_any] = ACTIONS(503),
    [anon_sym_number] = ACTIONS(503),
    [anon_sym_boolean] = ACTIONS(503),
    [anon_sym_string] = ACTIONS(503),
    [anon_sym_symbol] = ACTIONS(503),
    [sym_readonly] = ACTIONS(503),
  },
  [260] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(884),
    [sym__expression] = STATE(1104),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1283),
    [sym_array] = STATE(1281),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3336),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(884),
    [sym_subscript_expression] = STATE(884),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1964),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(860),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(414),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(831),
    [anon_sym_export] = ACTIONS(503),
    [anon_sym_namespace] = ACTIONS(505),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_type] = ACTIONS(503),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(437),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(443),
    [anon_sym_yield] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(849),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(851),
    [anon_sym_TILDE] = ACTIONS(437),
    [anon_sym_void] = ACTIONS(471),
    [anon_sym_delete] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(473),
    [anon_sym_DASH_DASH] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(503),
    [anon_sym_get] = ACTIONS(503),
    [anon_sym_set] = ACTIONS(503),
    [anon_sym_declare] = ACTIONS(503),
    [anon_sym_public] = ACTIONS(503),
    [anon_sym_private] = ACTIONS(503),
    [anon_sym_protected] = ACTIONS(503),
    [anon_sym_module] = ACTIONS(503),
    [anon_sym_any] = ACTIONS(503),
    [anon_sym_number] = ACTIONS(503),
    [anon_sym_boolean] = ACTIONS(503),
    [anon_sym_string] = ACTIONS(503),
    [anon_sym_symbol] = ACTIONS(503),
    [sym_readonly] = ACTIONS(503),
  },
  [261] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(963),
    [sym__expression] = STATE(1318),
    [sym_yield_expression] = STATE(1722),
    [sym_object] = STATE(1536),
    [sym_array] = STATE(1535),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(3286),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1722),
    [sym_await_expression] = STATE(1722),
    [sym_member_expression] = STATE(963),
    [sym_subscript_expression] = STATE(963),
    [sym_assignment_expression] = STATE(1722),
    [sym__augmented_assignment_lhs] = STATE(1968),
    [sym_augmented_assignment_expression] = STATE(1722),
    [sym_ternary_expression] = STATE(1722),
    [sym_binary_expression] = STATE(1722),
    [sym_unary_expression] = STATE(1722),
    [sym_update_expression] = STATE(1722),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(952),
    [sym_type_assertion] = STATE(1722),
    [sym_as_expression] = STATE(1722),
    [sym_internal_module] = STATE(1722),
    [sym_type_arguments] = STATE(266),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2684),
    [sym_identifier] = ACTIONS(863),
    [anon_sym_export] = ACTIONS(655),
    [anon_sym_namespace] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(1270),
    [anon_sym_type] = ACTIONS(655),
    [anon_sym_typeof] = ACTIONS(689),
    [anon_sym_import] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_LPAREN] = ACTIONS(871),
    [anon_sym_await] = ACTIONS(669),
    [anon_sym_yield] = ACTIONS(671),
    [anon_sym_LBRACK] = ACTIONS(873),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(675),
    [anon_sym_class] = ACTIONS(677),
    [anon_sym_async] = ACTIONS(679),
    [anon_sym_function] = ACTIONS(681),
    [anon_sym_new] = ACTIONS(875),
    [anon_sym_PLUS] = ACTIONS(877),
    [anon_sym_DASH] = ACTIONS(877),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_void] = ACTIONS(689),
    [anon_sym_delete] = ACTIONS(689),
    [anon_sym_PLUS_PLUS] = ACTIONS(691),
    [anon_sym_DASH_DASH] = ACTIONS(691),
    [anon_sym_DQUOTE] = ACTIONS(693),
    [anon_sym_SQUOTE] = ACTIONS(695),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(697),
    [sym_number] = ACTIONS(879),
    [sym_this] = ACTIONS(703),
    [sym_super] = ACTIONS(703),
    [sym_true] = ACTIONS(703),
    [sym_false] = ACTIONS(703),
    [sym_null] = ACTIONS(703),
    [sym_undefined] = ACTIONS(703),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(655),
    [anon_sym_get] = ACTIONS(655),
    [anon_sym_set] = ACTIONS(655),
    [anon_sym_declare] = ACTIONS(655),
    [anon_sym_public] = ACTIONS(655),
    [anon_sym_private] = ACTIONS(655),
    [anon_sym_protected] = ACTIONS(655),
    [anon_sym_module] = ACTIONS(655),
    [anon_sym_any] = ACTIONS(655),
    [anon_sym_number] = ACTIONS(655),
    [anon_sym_boolean] = ACTIONS(655),
    [anon_sym_string] = ACTIONS(655),
    [anon_sym_symbol] = ACTIONS(655),
    [sym_readonly] = ACTIONS(655),
  },
  [262] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(884),
    [sym__expression] = STATE(1197),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1283),
    [sym_array] = STATE(1281),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3336),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(884),
    [sym_subscript_expression] = STATE(884),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1964),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(860),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(414),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(831),
    [anon_sym_export] = ACTIONS(503),
    [anon_sym_namespace] = ACTIONS(505),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_type] = ACTIONS(503),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(437),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(443),
    [anon_sym_yield] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(849),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(851),
    [anon_sym_TILDE] = ACTIONS(437),
    [anon_sym_void] = ACTIONS(471),
    [anon_sym_delete] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(473),
    [anon_sym_DASH_DASH] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(503),
    [anon_sym_get] = ACTIONS(503),
    [anon_sym_set] = ACTIONS(503),
    [anon_sym_declare] = ACTIONS(503),
    [anon_sym_public] = ACTIONS(503),
    [anon_sym_private] = ACTIONS(503),
    [anon_sym_protected] = ACTIONS(503),
    [anon_sym_module] = ACTIONS(503),
    [anon_sym_any] = ACTIONS(503),
    [anon_sym_number] = ACTIONS(503),
    [anon_sym_boolean] = ACTIONS(503),
    [anon_sym_string] = ACTIONS(503),
    [anon_sym_symbol] = ACTIONS(503),
    [sym_readonly] = ACTIONS(503),
  },
  [263] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(884),
    [sym__expression] = STATE(1122),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1283),
    [sym_array] = STATE(1281),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3336),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(884),
    [sym_subscript_expression] = STATE(884),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1964),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(860),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(414),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(831),
    [anon_sym_export] = ACTIONS(503),
    [anon_sym_namespace] = ACTIONS(505),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_type] = ACTIONS(503),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(437),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(443),
    [anon_sym_yield] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(849),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(851),
    [anon_sym_TILDE] = ACTIONS(437),
    [anon_sym_void] = ACTIONS(471),
    [anon_sym_delete] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(473),
    [anon_sym_DASH_DASH] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(1471),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(503),
    [anon_sym_get] = ACTIONS(503),
    [anon_sym_set] = ACTIONS(503),
    [anon_sym_declare] = ACTIONS(503),
    [anon_sym_public] = ACTIONS(503),
    [anon_sym_private] = ACTIONS(503),
    [anon_sym_protected] = ACTIONS(503),
    [anon_sym_module] = ACTIONS(503),
    [anon_sym_any] = ACTIONS(503),
    [anon_sym_number] = ACTIONS(503),
    [anon_sym_boolean] = ACTIONS(503),
    [anon_sym_string] = ACTIONS(503),
    [anon_sym_symbol] = ACTIONS(503),
    [sym_readonly] = ACTIONS(503),
  },
  [264] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(963),
    [sym__expression] = STATE(1335),
    [sym_yield_expression] = STATE(1722),
    [sym_object] = STATE(1536),
    [sym_array] = STATE(1535),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(3286),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1722),
    [sym_await_expression] = STATE(1722),
    [sym_member_expression] = STATE(963),
    [sym_subscript_expression] = STATE(963),
    [sym_assignment_expression] = STATE(1722),
    [sym__augmented_assignment_lhs] = STATE(1968),
    [sym_augmented_assignment_expression] = STATE(1722),
    [sym_ternary_expression] = STATE(1722),
    [sym_binary_expression] = STATE(1722),
    [sym_unary_expression] = STATE(1722),
    [sym_update_expression] = STATE(1722),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(952),
    [sym_type_assertion] = STATE(1722),
    [sym_as_expression] = STATE(1722),
    [sym_internal_module] = STATE(1722),
    [sym_type_arguments] = STATE(266),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2684),
    [sym_identifier] = ACTIONS(863),
    [anon_sym_export] = ACTIONS(655),
    [anon_sym_namespace] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(1270),
    [anon_sym_type] = ACTIONS(655),
    [anon_sym_typeof] = ACTIONS(689),
    [anon_sym_import] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_LPAREN] = ACTIONS(871),
    [anon_sym_await] = ACTIONS(669),
    [anon_sym_yield] = ACTIONS(671),
    [anon_sym_LBRACK] = ACTIONS(873),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(675),
    [anon_sym_class] = ACTIONS(677),
    [anon_sym_async] = ACTIONS(679),
    [anon_sym_function] = ACTIONS(681),
    [anon_sym_new] = ACTIONS(875),
    [anon_sym_PLUS] = ACTIONS(877),
    [anon_sym_DASH] = ACTIONS(877),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_void] = ACTIONS(689),
    [anon_sym_delete] = ACTIONS(689),
    [anon_sym_PLUS_PLUS] = ACTIONS(691),
    [anon_sym_DASH_DASH] = ACTIONS(691),
    [anon_sym_DQUOTE] = ACTIONS(693),
    [anon_sym_SQUOTE] = ACTIONS(695),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(697),
    [sym_number] = ACTIONS(1473),
    [sym_this] = ACTIONS(703),
    [sym_super] = ACTIONS(703),
    [sym_true] = ACTIONS(703),
    [sym_false] = ACTIONS(703),
    [sym_null] = ACTIONS(703),
    [sym_undefined] = ACTIONS(703),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(655),
    [anon_sym_get] = ACTIONS(655),
    [anon_sym_set] = ACTIONS(655),
    [anon_sym_declare] = ACTIONS(655),
    [anon_sym_public] = ACTIONS(655),
    [anon_sym_private] = ACTIONS(655),
    [anon_sym_protected] = ACTIONS(655),
    [anon_sym_module] = ACTIONS(655),
    [anon_sym_any] = ACTIONS(655),
    [anon_sym_number] = ACTIONS(655),
    [anon_sym_boolean] = ACTIONS(655),
    [anon_sym_string] = ACTIONS(655),
    [anon_sym_symbol] = ACTIONS(655),
    [sym_readonly] = ACTIONS(655),
  },
  [265] = {
    [ts_builtin_sym_end] = ACTIONS(1475),
    [sym_identifier] = ACTIONS(1477),
    [anon_sym_export] = ACTIONS(1477),
    [anon_sym_default] = ACTIONS(1477),
    [anon_sym_EQ] = ACTIONS(1477),
    [anon_sym_namespace] = ACTIONS(1477),
    [anon_sym_LBRACE] = ACTIONS(1475),
    [anon_sym_COMMA] = ACTIONS(1475),
    [anon_sym_RBRACE] = ACTIONS(1475),
    [anon_sym_type] = ACTIONS(1477),
    [anon_sym_typeof] = ACTIONS(1477),
    [anon_sym_import] = ACTIONS(1477),
    [anon_sym_var] = ACTIONS(1477),
    [anon_sym_let] = ACTIONS(1477),
    [anon_sym_const] = ACTIONS(1477),
    [anon_sym_BANG] = ACTIONS(1475),
    [anon_sym_else] = ACTIONS(1477),
    [anon_sym_if] = ACTIONS(1477),
    [anon_sym_switch] = ACTIONS(1477),
    [anon_sym_for] = ACTIONS(1477),
    [anon_sym_LPAREN] = ACTIONS(1475),
    [anon_sym_RPAREN] = ACTIONS(1475),
    [anon_sym_await] = ACTIONS(1477),
    [anon_sym_while] = ACTIONS(1477),
    [anon_sym_do] = ACTIONS(1477),
    [anon_sym_try] = ACTIONS(1477),
    [anon_sym_with] = ACTIONS(1477),
    [anon_sym_break] = ACTIONS(1477),
    [anon_sym_continue] = ACTIONS(1477),
    [anon_sym_debugger] = ACTIONS(1477),
    [anon_sym_return] = ACTIONS(1477),
    [anon_sym_throw] = ACTIONS(1477),
    [anon_sym_SEMI] = ACTIONS(1475),
    [anon_sym_COLON] = ACTIONS(1475),
    [anon_sym_case] = ACTIONS(1477),
    [anon_sym_yield] = ACTIONS(1477),
    [anon_sym_LBRACK] = ACTIONS(1475),
    [anon_sym_RBRACK] = ACTIONS(1475),
    [anon_sym_LT] = ACTIONS(1475),
    [anon_sym_GT] = ACTIONS(1475),
    [anon_sym_SLASH] = ACTIONS(1477),
    [anon_sym_class] = ACTIONS(1477),
    [anon_sym_async] = ACTIONS(1477),
    [anon_sym_function] = ACTIONS(1477),
    [anon_sym_EQ_GT] = ACTIONS(1475),
    [anon_sym_new] = ACTIONS(1477),
    [anon_sym_QMARK] = ACTIONS(1475),
    [anon_sym_AMP] = ACTIONS(1475),
    [anon_sym_PIPE] = ACTIONS(1475),
    [anon_sym_PLUS] = ACTIONS(1477),
    [anon_sym_DASH] = ACTIONS(1477),
    [anon_sym_TILDE] = ACTIONS(1475),
    [anon_sym_void] = ACTIONS(1477),
    [anon_sym_delete] = ACTIONS(1477),
    [anon_sym_PLUS_PLUS] = ACTIONS(1475),
    [anon_sym_DASH_DASH] = ACTIONS(1475),
    [anon_sym_DQUOTE] = ACTIONS(1475),
    [anon_sym_SQUOTE] = ACTIONS(1475),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1475),
    [sym_number] = ACTIONS(1475),
    [sym_this] = ACTIONS(1477),
    [sym_super] = ACTIONS(1477),
    [sym_true] = ACTIONS(1477),
    [sym_false] = ACTIONS(1477),
    [sym_null] = ACTIONS(1477),
    [sym_undefined] = ACTIONS(1477),
    [anon_sym_AT] = ACTIONS(1475),
    [anon_sym_static] = ACTIONS(1477),
    [anon_sym_abstract] = ACTIONS(1477),
    [anon_sym_get] = ACTIONS(1477),
    [anon_sym_set] = ACTIONS(1477),
    [anon_sym_declare] = ACTIONS(1477),
    [anon_sym_public] = ACTIONS(1477),
    [anon_sym_private] = ACTIONS(1477),
    [anon_sym_protected] = ACTIONS(1477),
    [anon_sym_module] = ACTIONS(1477),
    [anon_sym_any] = ACTIONS(1477),
    [anon_sym_number] = ACTIONS(1477),
    [anon_sym_boolean] = ACTIONS(1477),
    [anon_sym_string] = ACTIONS(1477),
    [anon_sym_symbol] = ACTIONS(1477),
    [anon_sym_implements] = ACTIONS(1477),
    [anon_sym_interface] = ACTIONS(1477),
    [anon_sym_extends] = ACTIONS(1477),
    [anon_sym_enum] = ACTIONS(1477),
    [sym_readonly] = ACTIONS(1477),
  },
  [266] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(963),
    [sym__expression] = STATE(1324),
    [sym_yield_expression] = STATE(1722),
    [sym_object] = STATE(1536),
    [sym_array] = STATE(1535),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(3286),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1722),
    [sym_await_expression] = STATE(1722),
    [sym_member_expression] = STATE(963),
    [sym_subscript_expression] = STATE(963),
    [sym_assignment_expression] = STATE(1722),
    [sym__augmented_assignment_lhs] = STATE(1968),
    [sym_augmented_assignment_expression] = STATE(1722),
    [sym_ternary_expression] = STATE(1722),
    [sym_binary_expression] = STATE(1722),
    [sym_unary_expression] = STATE(1722),
    [sym_update_expression] = STATE(1722),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(952),
    [sym_type_assertion] = STATE(1722),
    [sym_as_expression] = STATE(1722),
    [sym_internal_module] = STATE(1722),
    [sym_type_arguments] = STATE(266),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2684),
    [sym_identifier] = ACTIONS(863),
    [anon_sym_export] = ACTIONS(655),
    [anon_sym_namespace] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(1270),
    [anon_sym_type] = ACTIONS(655),
    [anon_sym_typeof] = ACTIONS(689),
    [anon_sym_import] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_LPAREN] = ACTIONS(871),
    [anon_sym_await] = ACTIONS(669),
    [anon_sym_yield] = ACTIONS(671),
    [anon_sym_LBRACK] = ACTIONS(873),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(675),
    [anon_sym_class] = ACTIONS(677),
    [anon_sym_async] = ACTIONS(679),
    [anon_sym_function] = ACTIONS(681),
    [anon_sym_new] = ACTIONS(875),
    [anon_sym_PLUS] = ACTIONS(877),
    [anon_sym_DASH] = ACTIONS(877),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_void] = ACTIONS(689),
    [anon_sym_delete] = ACTIONS(689),
    [anon_sym_PLUS_PLUS] = ACTIONS(691),
    [anon_sym_DASH_DASH] = ACTIONS(691),
    [anon_sym_DQUOTE] = ACTIONS(693),
    [anon_sym_SQUOTE] = ACTIONS(695),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(697),
    [sym_number] = ACTIONS(879),
    [sym_this] = ACTIONS(703),
    [sym_super] = ACTIONS(703),
    [sym_true] = ACTIONS(703),
    [sym_false] = ACTIONS(703),
    [sym_null] = ACTIONS(703),
    [sym_undefined] = ACTIONS(703),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(655),
    [anon_sym_get] = ACTIONS(655),
    [anon_sym_set] = ACTIONS(655),
    [anon_sym_declare] = ACTIONS(655),
    [anon_sym_public] = ACTIONS(655),
    [anon_sym_private] = ACTIONS(655),
    [anon_sym_protected] = ACTIONS(655),
    [anon_sym_module] = ACTIONS(655),
    [anon_sym_any] = ACTIONS(655),
    [anon_sym_number] = ACTIONS(655),
    [anon_sym_boolean] = ACTIONS(655),
    [anon_sym_string] = ACTIONS(655),
    [anon_sym_symbol] = ACTIONS(655),
    [sym_readonly] = ACTIONS(655),
  },
  [267] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(963),
    [sym__expression] = STATE(1333),
    [sym_yield_expression] = STATE(1722),
    [sym_object] = STATE(1536),
    [sym_array] = STATE(1535),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(3286),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1722),
    [sym_await_expression] = STATE(1722),
    [sym_member_expression] = STATE(963),
    [sym_subscript_expression] = STATE(963),
    [sym_assignment_expression] = STATE(1722),
    [sym__augmented_assignment_lhs] = STATE(1968),
    [sym_augmented_assignment_expression] = STATE(1722),
    [sym_ternary_expression] = STATE(1722),
    [sym_binary_expression] = STATE(1722),
    [sym_unary_expression] = STATE(1722),
    [sym_update_expression] = STATE(1722),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(952),
    [sym_type_assertion] = STATE(1722),
    [sym_as_expression] = STATE(1722),
    [sym_internal_module] = STATE(1722),
    [sym_type_arguments] = STATE(266),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2684),
    [sym_identifier] = ACTIONS(863),
    [anon_sym_export] = ACTIONS(655),
    [anon_sym_namespace] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(1270),
    [anon_sym_type] = ACTIONS(655),
    [anon_sym_typeof] = ACTIONS(689),
    [anon_sym_import] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_LPAREN] = ACTIONS(871),
    [anon_sym_await] = ACTIONS(669),
    [anon_sym_yield] = ACTIONS(671),
    [anon_sym_LBRACK] = ACTIONS(873),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(675),
    [anon_sym_class] = ACTIONS(677),
    [anon_sym_async] = ACTIONS(679),
    [anon_sym_function] = ACTIONS(681),
    [anon_sym_new] = ACTIONS(875),
    [anon_sym_PLUS] = ACTIONS(877),
    [anon_sym_DASH] = ACTIONS(877),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_void] = ACTIONS(689),
    [anon_sym_delete] = ACTIONS(689),
    [anon_sym_PLUS_PLUS] = ACTIONS(691),
    [anon_sym_DASH_DASH] = ACTIONS(691),
    [anon_sym_DQUOTE] = ACTIONS(693),
    [anon_sym_SQUOTE] = ACTIONS(695),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(697),
    [sym_number] = ACTIONS(879),
    [sym_this] = ACTIONS(703),
    [sym_super] = ACTIONS(703),
    [sym_true] = ACTIONS(703),
    [sym_false] = ACTIONS(703),
    [sym_null] = ACTIONS(703),
    [sym_undefined] = ACTIONS(703),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(655),
    [anon_sym_get] = ACTIONS(655),
    [anon_sym_set] = ACTIONS(655),
    [anon_sym_declare] = ACTIONS(655),
    [anon_sym_public] = ACTIONS(655),
    [anon_sym_private] = ACTIONS(655),
    [anon_sym_protected] = ACTIONS(655),
    [anon_sym_module] = ACTIONS(655),
    [anon_sym_any] = ACTIONS(655),
    [anon_sym_number] = ACTIONS(655),
    [anon_sym_boolean] = ACTIONS(655),
    [anon_sym_string] = ACTIONS(655),
    [anon_sym_symbol] = ACTIONS(655),
    [sym_readonly] = ACTIONS(655),
  },
  [268] = {
    [sym_import] = STATE(1528),
    [sym_parenthesized_expression] = STATE(983),
    [sym__expression] = STATE(1498),
    [sym_yield_expression] = STATE(1543),
    [sym_object] = STATE(1671),
    [sym_array] = STATE(1713),
    [sym_class] = STATE(1528),
    [sym_function] = STATE(1528),
    [sym_generator_function] = STATE(1528),
    [sym_arrow_function] = STATE(1528),
    [sym__call_signature] = STATE(3235),
    [sym_call_expression] = STATE(1528),
    [sym_new_expression] = STATE(1543),
    [sym_await_expression] = STATE(1543),
    [sym_member_expression] = STATE(983),
    [sym_subscript_expression] = STATE(983),
    [sym_assignment_expression] = STATE(1543),
    [sym__augmented_assignment_lhs] = STATE(1963),
    [sym_augmented_assignment_expression] = STATE(1543),
    [sym_ternary_expression] = STATE(1543),
    [sym_binary_expression] = STATE(1543),
    [sym_unary_expression] = STATE(1543),
    [sym_update_expression] = STATE(1543),
    [sym_string] = STATE(1528),
    [sym_template_string] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_meta_property] = STATE(1528),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(984),
    [sym_type_assertion] = STATE(1543),
    [sym_as_expression] = STATE(1543),
    [sym_internal_module] = STATE(1543),
    [sym_type_arguments] = STATE(310),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2726),
    [sym_identifier] = ACTIONS(891),
    [anon_sym_export] = ACTIONS(529),
    [anon_sym_namespace] = ACTIONS(531),
    [anon_sym_LBRACE] = ACTIONS(859),
    [anon_sym_type] = ACTIONS(529),
    [anon_sym_typeof] = ACTIONS(561),
    [anon_sym_import] = ACTIONS(537),
    [anon_sym_BANG] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(543),
    [anon_sym_yield] = ACTIONS(545),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(549),
    [anon_sym_async] = ACTIONS(551),
    [anon_sym_function] = ACTIONS(553),
    [anon_sym_new] = ACTIONS(897),
    [anon_sym_PLUS] = ACTIONS(899),
    [anon_sym_DASH] = ACTIONS(899),
    [anon_sym_TILDE] = ACTIONS(539),
    [anon_sym_void] = ACTIONS(561),
    [anon_sym_delete] = ACTIONS(561),
    [anon_sym_PLUS_PLUS] = ACTIONS(563),
    [anon_sym_DASH_DASH] = ACTIONS(563),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(529),
    [anon_sym_get] = ACTIONS(529),
    [anon_sym_set] = ACTIONS(529),
    [anon_sym_declare] = ACTIONS(529),
    [anon_sym_public] = ACTIONS(529),
    [anon_sym_private] = ACTIONS(529),
    [anon_sym_protected] = ACTIONS(529),
    [anon_sym_module] = ACTIONS(529),
    [anon_sym_any] = ACTIONS(529),
    [anon_sym_number] = ACTIONS(529),
    [anon_sym_boolean] = ACTIONS(529),
    [anon_sym_string] = ACTIONS(529),
    [anon_sym_symbol] = ACTIONS(529),
    [sym_readonly] = ACTIONS(529),
  },
  [269] = {
    [sym_import] = STATE(1528),
    [sym_parenthesized_expression] = STATE(933),
    [sym__expression] = STATE(1182),
    [sym_yield_expression] = STATE(1543),
    [sym_object] = STATE(1367),
    [sym_array] = STATE(1369),
    [sym_class] = STATE(1528),
    [sym_function] = STATE(1528),
    [sym_generator_function] = STATE(1528),
    [sym_arrow_function] = STATE(1528),
    [sym__call_signature] = STATE(3359),
    [sym_call_expression] = STATE(1528),
    [sym_new_expression] = STATE(1543),
    [sym_await_expression] = STATE(1543),
    [sym_member_expression] = STATE(933),
    [sym_subscript_expression] = STATE(933),
    [sym_assignment_expression] = STATE(1543),
    [sym__augmented_assignment_lhs] = STATE(1970),
    [sym_augmented_assignment_expression] = STATE(1543),
    [sym_ternary_expression] = STATE(1543),
    [sym_binary_expression] = STATE(1543),
    [sym_unary_expression] = STATE(1543),
    [sym_update_expression] = STATE(1543),
    [sym_string] = STATE(1528),
    [sym_template_string] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_meta_property] = STATE(1528),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(936),
    [sym_type_assertion] = STATE(1543),
    [sym_as_expression] = STATE(1543),
    [sym_internal_module] = STATE(1543),
    [sym_type_arguments] = STATE(381),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2726),
    [sym_identifier] = ACTIONS(855),
    [anon_sym_export] = ACTIONS(745),
    [anon_sym_namespace] = ACTIONS(747),
    [anon_sym_LBRACE] = ACTIONS(859),
    [anon_sym_type] = ACTIONS(745),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(537),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(549),
    [anon_sym_async] = ACTIONS(753),
    [anon_sym_function] = ACTIONS(553),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(745),
    [anon_sym_get] = ACTIONS(745),
    [anon_sym_set] = ACTIONS(745),
    [anon_sym_declare] = ACTIONS(745),
    [anon_sym_public] = ACTIONS(745),
    [anon_sym_private] = ACTIONS(745),
    [anon_sym_protected] = ACTIONS(745),
    [anon_sym_module] = ACTIONS(745),
    [anon_sym_any] = ACTIONS(745),
    [anon_sym_number] = ACTIONS(745),
    [anon_sym_boolean] = ACTIONS(745),
    [anon_sym_string] = ACTIONS(745),
    [anon_sym_symbol] = ACTIONS(745),
    [sym_readonly] = ACTIONS(745),
  },
  [270] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(963),
    [sym__expression] = STATE(1335),
    [sym_yield_expression] = STATE(1722),
    [sym_object] = STATE(1536),
    [sym_array] = STATE(1535),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(3286),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1722),
    [sym_await_expression] = STATE(1722),
    [sym_member_expression] = STATE(963),
    [sym_subscript_expression] = STATE(963),
    [sym_assignment_expression] = STATE(1722),
    [sym__augmented_assignment_lhs] = STATE(1968),
    [sym_augmented_assignment_expression] = STATE(1722),
    [sym_ternary_expression] = STATE(1722),
    [sym_binary_expression] = STATE(1722),
    [sym_unary_expression] = STATE(1722),
    [sym_update_expression] = STATE(1722),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(952),
    [sym_type_assertion] = STATE(1722),
    [sym_as_expression] = STATE(1722),
    [sym_internal_module] = STATE(1722),
    [sym_type_arguments] = STATE(266),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2684),
    [sym_identifier] = ACTIONS(863),
    [anon_sym_export] = ACTIONS(655),
    [anon_sym_namespace] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(1270),
    [anon_sym_type] = ACTIONS(655),
    [anon_sym_typeof] = ACTIONS(689),
    [anon_sym_import] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_LPAREN] = ACTIONS(871),
    [anon_sym_await] = ACTIONS(669),
    [anon_sym_yield] = ACTIONS(671),
    [anon_sym_LBRACK] = ACTIONS(873),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(675),
    [anon_sym_class] = ACTIONS(677),
    [anon_sym_async] = ACTIONS(679),
    [anon_sym_function] = ACTIONS(681),
    [anon_sym_new] = ACTIONS(875),
    [anon_sym_PLUS] = ACTIONS(877),
    [anon_sym_DASH] = ACTIONS(877),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_void] = ACTIONS(689),
    [anon_sym_delete] = ACTIONS(689),
    [anon_sym_PLUS_PLUS] = ACTIONS(691),
    [anon_sym_DASH_DASH] = ACTIONS(691),
    [anon_sym_DQUOTE] = ACTIONS(693),
    [anon_sym_SQUOTE] = ACTIONS(695),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(697),
    [sym_number] = ACTIONS(879),
    [sym_this] = ACTIONS(703),
    [sym_super] = ACTIONS(703),
    [sym_true] = ACTIONS(703),
    [sym_false] = ACTIONS(703),
    [sym_null] = ACTIONS(703),
    [sym_undefined] = ACTIONS(703),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(655),
    [anon_sym_get] = ACTIONS(655),
    [anon_sym_set] = ACTIONS(655),
    [anon_sym_declare] = ACTIONS(655),
    [anon_sym_public] = ACTIONS(655),
    [anon_sym_private] = ACTIONS(655),
    [anon_sym_protected] = ACTIONS(655),
    [anon_sym_module] = ACTIONS(655),
    [anon_sym_any] = ACTIONS(655),
    [anon_sym_number] = ACTIONS(655),
    [anon_sym_boolean] = ACTIONS(655),
    [anon_sym_string] = ACTIONS(655),
    [anon_sym_symbol] = ACTIONS(655),
    [sym_readonly] = ACTIONS(655),
  },
  [271] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(884),
    [sym__expression] = STATE(1197),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1283),
    [sym_array] = STATE(1281),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3336),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(884),
    [sym_subscript_expression] = STATE(884),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1964),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(860),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(414),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(1479),
    [anon_sym_export] = ACTIONS(503),
    [anon_sym_namespace] = ACTIONS(505),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_type] = ACTIONS(503),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(437),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(443),
    [anon_sym_yield] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(849),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(851),
    [anon_sym_TILDE] = ACTIONS(437),
    [anon_sym_void] = ACTIONS(471),
    [anon_sym_delete] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(473),
    [anon_sym_DASH_DASH] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(503),
    [anon_sym_get] = ACTIONS(503),
    [anon_sym_set] = ACTIONS(503),
    [anon_sym_declare] = ACTIONS(503),
    [anon_sym_public] = ACTIONS(503),
    [anon_sym_private] = ACTIONS(503),
    [anon_sym_protected] = ACTIONS(503),
    [anon_sym_module] = ACTIONS(503),
    [anon_sym_any] = ACTIONS(503),
    [anon_sym_number] = ACTIONS(503),
    [anon_sym_boolean] = ACTIONS(503),
    [anon_sym_string] = ACTIONS(503),
    [anon_sym_symbol] = ACTIONS(503),
    [sym_readonly] = ACTIONS(503),
  },
  [272] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(965),
    [sym__expression] = STATE(1243),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1524),
    [sym_array] = STATE(1523),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3348),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(965),
    [sym_subscript_expression] = STATE(965),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1969),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(975),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(302),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(901),
    [anon_sym_export] = ACTIONS(713),
    [anon_sym_namespace] = ACTIONS(715),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_type] = ACTIONS(713),
    [anon_sym_typeof] = ACTIONS(735),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(719),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(721),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(725),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(727),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(907),
    [anon_sym_PLUS] = ACTIONS(909),
    [anon_sym_DASH] = ACTIONS(909),
    [anon_sym_TILDE] = ACTIONS(719),
    [anon_sym_void] = ACTIONS(735),
    [anon_sym_delete] = ACTIONS(735),
    [anon_sym_PLUS_PLUS] = ACTIONS(737),
    [anon_sym_DASH_DASH] = ACTIONS(737),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(713),
    [anon_sym_get] = ACTIONS(713),
    [anon_sym_set] = ACTIONS(713),
    [anon_sym_declare] = ACTIONS(713),
    [anon_sym_public] = ACTIONS(713),
    [anon_sym_private] = ACTIONS(713),
    [anon_sym_protected] = ACTIONS(713),
    [anon_sym_module] = ACTIONS(713),
    [anon_sym_any] = ACTIONS(713),
    [anon_sym_number] = ACTIONS(713),
    [anon_sym_boolean] = ACTIONS(713),
    [anon_sym_string] = ACTIONS(713),
    [anon_sym_symbol] = ACTIONS(713),
    [sym_readonly] = ACTIONS(713),
  },
  [273] = {
    [ts_builtin_sym_end] = ACTIONS(1481),
    [sym_identifier] = ACTIONS(1483),
    [anon_sym_export] = ACTIONS(1483),
    [anon_sym_default] = ACTIONS(1483),
    [anon_sym_EQ] = ACTIONS(1483),
    [anon_sym_namespace] = ACTIONS(1483),
    [anon_sym_LBRACE] = ACTIONS(1481),
    [anon_sym_COMMA] = ACTIONS(1481),
    [anon_sym_RBRACE] = ACTIONS(1481),
    [anon_sym_type] = ACTIONS(1483),
    [anon_sym_typeof] = ACTIONS(1483),
    [anon_sym_import] = ACTIONS(1483),
    [anon_sym_var] = ACTIONS(1483),
    [anon_sym_let] = ACTIONS(1483),
    [anon_sym_const] = ACTIONS(1483),
    [anon_sym_BANG] = ACTIONS(1481),
    [anon_sym_else] = ACTIONS(1483),
    [anon_sym_if] = ACTIONS(1483),
    [anon_sym_switch] = ACTIONS(1483),
    [anon_sym_for] = ACTIONS(1483),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_RPAREN] = ACTIONS(1481),
    [anon_sym_await] = ACTIONS(1483),
    [anon_sym_while] = ACTIONS(1483),
    [anon_sym_do] = ACTIONS(1483),
    [anon_sym_try] = ACTIONS(1483),
    [anon_sym_with] = ACTIONS(1483),
    [anon_sym_break] = ACTIONS(1483),
    [anon_sym_continue] = ACTIONS(1483),
    [anon_sym_debugger] = ACTIONS(1483),
    [anon_sym_return] = ACTIONS(1483),
    [anon_sym_throw] = ACTIONS(1483),
    [anon_sym_SEMI] = ACTIONS(1481),
    [anon_sym_COLON] = ACTIONS(1481),
    [anon_sym_case] = ACTIONS(1483),
    [anon_sym_yield] = ACTIONS(1483),
    [anon_sym_LBRACK] = ACTIONS(1481),
    [anon_sym_RBRACK] = ACTIONS(1481),
    [anon_sym_LT] = ACTIONS(1481),
    [anon_sym_GT] = ACTIONS(1481),
    [anon_sym_SLASH] = ACTIONS(1483),
    [anon_sym_class] = ACTIONS(1483),
    [anon_sym_async] = ACTIONS(1483),
    [anon_sym_function] = ACTIONS(1483),
    [anon_sym_EQ_GT] = ACTIONS(1481),
    [anon_sym_new] = ACTIONS(1483),
    [anon_sym_QMARK] = ACTIONS(1481),
    [anon_sym_AMP] = ACTIONS(1481),
    [anon_sym_PIPE] = ACTIONS(1481),
    [anon_sym_PLUS] = ACTIONS(1483),
    [anon_sym_DASH] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1481),
    [anon_sym_void] = ACTIONS(1483),
    [anon_sym_delete] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1481),
    [anon_sym_DASH_DASH] = ACTIONS(1481),
    [anon_sym_DQUOTE] = ACTIONS(1481),
    [anon_sym_SQUOTE] = ACTIONS(1481),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1481),
    [sym_number] = ACTIONS(1481),
    [sym_this] = ACTIONS(1483),
    [sym_super] = ACTIONS(1483),
    [sym_true] = ACTIONS(1483),
    [sym_false] = ACTIONS(1483),
    [sym_null] = ACTIONS(1483),
    [sym_undefined] = ACTIONS(1483),
    [anon_sym_AT] = ACTIONS(1481),
    [anon_sym_static] = ACTIONS(1483),
    [anon_sym_abstract] = ACTIONS(1483),
    [anon_sym_get] = ACTIONS(1483),
    [anon_sym_set] = ACTIONS(1483),
    [anon_sym_declare] = ACTIONS(1483),
    [anon_sym_public] = ACTIONS(1483),
    [anon_sym_private] = ACTIONS(1483),
    [anon_sym_protected] = ACTIONS(1483),
    [anon_sym_module] = ACTIONS(1483),
    [anon_sym_any] = ACTIONS(1483),
    [anon_sym_number] = ACTIONS(1483),
    [anon_sym_boolean] = ACTIONS(1483),
    [anon_sym_string] = ACTIONS(1483),
    [anon_sym_symbol] = ACTIONS(1483),
    [anon_sym_implements] = ACTIONS(1483),
    [anon_sym_interface] = ACTIONS(1483),
    [anon_sym_extends] = ACTIONS(1483),
    [anon_sym_enum] = ACTIONS(1483),
    [sym_readonly] = ACTIONS(1483),
  },
  [274] = {
    [sym_import] = STATE(1528),
    [sym_parenthesized_expression] = STATE(933),
    [sym__expression] = STATE(1177),
    [sym_yield_expression] = STATE(1543),
    [sym_object] = STATE(1367),
    [sym_array] = STATE(1369),
    [sym_class] = STATE(1528),
    [sym_function] = STATE(1528),
    [sym_generator_function] = STATE(1528),
    [sym_arrow_function] = STATE(1528),
    [sym__call_signature] = STATE(3359),
    [sym_call_expression] = STATE(1528),
    [sym_new_expression] = STATE(1543),
    [sym_await_expression] = STATE(1543),
    [sym_member_expression] = STATE(933),
    [sym_subscript_expression] = STATE(933),
    [sym_assignment_expression] = STATE(1543),
    [sym__augmented_assignment_lhs] = STATE(1970),
    [sym_augmented_assignment_expression] = STATE(1543),
    [sym_ternary_expression] = STATE(1543),
    [sym_binary_expression] = STATE(1543),
    [sym_unary_expression] = STATE(1543),
    [sym_update_expression] = STATE(1543),
    [sym_string] = STATE(1528),
    [sym_template_string] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_meta_property] = STATE(1528),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(936),
    [sym_type_assertion] = STATE(1543),
    [sym_as_expression] = STATE(1543),
    [sym_internal_module] = STATE(1543),
    [sym_type_arguments] = STATE(381),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2726),
    [sym_identifier] = ACTIONS(855),
    [anon_sym_export] = ACTIONS(745),
    [anon_sym_namespace] = ACTIONS(747),
    [anon_sym_LBRACE] = ACTIONS(859),
    [anon_sym_type] = ACTIONS(745),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(537),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(549),
    [anon_sym_async] = ACTIONS(753),
    [anon_sym_function] = ACTIONS(553),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(745),
    [anon_sym_get] = ACTIONS(745),
    [anon_sym_set] = ACTIONS(745),
    [anon_sym_declare] = ACTIONS(745),
    [anon_sym_public] = ACTIONS(745),
    [anon_sym_private] = ACTIONS(745),
    [anon_sym_protected] = ACTIONS(745),
    [anon_sym_module] = ACTIONS(745),
    [anon_sym_any] = ACTIONS(745),
    [anon_sym_number] = ACTIONS(745),
    [anon_sym_boolean] = ACTIONS(745),
    [anon_sym_string] = ACTIONS(745),
    [anon_sym_symbol] = ACTIONS(745),
    [sym_readonly] = ACTIONS(745),
  },
  [275] = {
    [ts_builtin_sym_end] = ACTIONS(1485),
    [sym_identifier] = ACTIONS(1487),
    [anon_sym_export] = ACTIONS(1487),
    [anon_sym_default] = ACTIONS(1487),
    [anon_sym_EQ] = ACTIONS(1487),
    [anon_sym_namespace] = ACTIONS(1487),
    [anon_sym_LBRACE] = ACTIONS(1485),
    [anon_sym_COMMA] = ACTIONS(1485),
    [anon_sym_RBRACE] = ACTIONS(1485),
    [anon_sym_type] = ACTIONS(1487),
    [anon_sym_typeof] = ACTIONS(1487),
    [anon_sym_import] = ACTIONS(1487),
    [anon_sym_var] = ACTIONS(1487),
    [anon_sym_let] = ACTIONS(1487),
    [anon_sym_const] = ACTIONS(1487),
    [anon_sym_BANG] = ACTIONS(1485),
    [anon_sym_else] = ACTIONS(1487),
    [anon_sym_if] = ACTIONS(1487),
    [anon_sym_switch] = ACTIONS(1487),
    [anon_sym_for] = ACTIONS(1487),
    [anon_sym_LPAREN] = ACTIONS(1485),
    [anon_sym_RPAREN] = ACTIONS(1485),
    [anon_sym_await] = ACTIONS(1487),
    [anon_sym_while] = ACTIONS(1487),
    [anon_sym_do] = ACTIONS(1487),
    [anon_sym_try] = ACTIONS(1487),
    [anon_sym_with] = ACTIONS(1487),
    [anon_sym_break] = ACTIONS(1487),
    [anon_sym_continue] = ACTIONS(1487),
    [anon_sym_debugger] = ACTIONS(1487),
    [anon_sym_return] = ACTIONS(1487),
    [anon_sym_throw] = ACTIONS(1487),
    [anon_sym_SEMI] = ACTIONS(1485),
    [anon_sym_COLON] = ACTIONS(1485),
    [anon_sym_case] = ACTIONS(1487),
    [anon_sym_yield] = ACTIONS(1487),
    [anon_sym_LBRACK] = ACTIONS(1485),
    [anon_sym_RBRACK] = ACTIONS(1485),
    [anon_sym_LT] = ACTIONS(1485),
    [anon_sym_GT] = ACTIONS(1485),
    [anon_sym_SLASH] = ACTIONS(1487),
    [anon_sym_class] = ACTIONS(1487),
    [anon_sym_async] = ACTIONS(1487),
    [anon_sym_function] = ACTIONS(1487),
    [anon_sym_EQ_GT] = ACTIONS(1485),
    [anon_sym_new] = ACTIONS(1487),
    [anon_sym_QMARK] = ACTIONS(1485),
    [anon_sym_AMP] = ACTIONS(1485),
    [anon_sym_PIPE] = ACTIONS(1485),
    [anon_sym_PLUS] = ACTIONS(1487),
    [anon_sym_DASH] = ACTIONS(1487),
    [anon_sym_TILDE] = ACTIONS(1485),
    [anon_sym_void] = ACTIONS(1487),
    [anon_sym_delete] = ACTIONS(1487),
    [anon_sym_PLUS_PLUS] = ACTIONS(1485),
    [anon_sym_DASH_DASH] = ACTIONS(1485),
    [anon_sym_DQUOTE] = ACTIONS(1485),
    [anon_sym_SQUOTE] = ACTIONS(1485),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1485),
    [sym_number] = ACTIONS(1485),
    [sym_this] = ACTIONS(1487),
    [sym_super] = ACTIONS(1487),
    [sym_true] = ACTIONS(1487),
    [sym_false] = ACTIONS(1487),
    [sym_null] = ACTIONS(1487),
    [sym_undefined] = ACTIONS(1487),
    [anon_sym_AT] = ACTIONS(1485),
    [anon_sym_static] = ACTIONS(1487),
    [anon_sym_abstract] = ACTIONS(1487),
    [anon_sym_get] = ACTIONS(1487),
    [anon_sym_set] = ACTIONS(1487),
    [anon_sym_declare] = ACTIONS(1487),
    [anon_sym_public] = ACTIONS(1487),
    [anon_sym_private] = ACTIONS(1487),
    [anon_sym_protected] = ACTIONS(1487),
    [anon_sym_module] = ACTIONS(1487),
    [anon_sym_any] = ACTIONS(1487),
    [anon_sym_number] = ACTIONS(1487),
    [anon_sym_boolean] = ACTIONS(1487),
    [anon_sym_string] = ACTIONS(1487),
    [anon_sym_symbol] = ACTIONS(1487),
    [anon_sym_implements] = ACTIONS(1487),
    [anon_sym_interface] = ACTIONS(1487),
    [anon_sym_extends] = ACTIONS(1487),
    [anon_sym_enum] = ACTIONS(1487),
    [sym_readonly] = ACTIONS(1487),
  },
  [276] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(965),
    [sym__expression] = STATE(1285),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1524),
    [sym_array] = STATE(1523),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3348),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(965),
    [sym_subscript_expression] = STATE(965),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1969),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(975),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(302),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(901),
    [anon_sym_export] = ACTIONS(713),
    [anon_sym_namespace] = ACTIONS(715),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_type] = ACTIONS(713),
    [anon_sym_typeof] = ACTIONS(735),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(719),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(721),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(725),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(727),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(907),
    [anon_sym_PLUS] = ACTIONS(909),
    [anon_sym_DASH] = ACTIONS(909),
    [anon_sym_TILDE] = ACTIONS(719),
    [anon_sym_void] = ACTIONS(735),
    [anon_sym_delete] = ACTIONS(735),
    [anon_sym_PLUS_PLUS] = ACTIONS(737),
    [anon_sym_DASH_DASH] = ACTIONS(737),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(713),
    [anon_sym_get] = ACTIONS(713),
    [anon_sym_set] = ACTIONS(713),
    [anon_sym_declare] = ACTIONS(713),
    [anon_sym_public] = ACTIONS(713),
    [anon_sym_private] = ACTIONS(713),
    [anon_sym_protected] = ACTIONS(713),
    [anon_sym_module] = ACTIONS(713),
    [anon_sym_any] = ACTIONS(713),
    [anon_sym_number] = ACTIONS(713),
    [anon_sym_boolean] = ACTIONS(713),
    [anon_sym_string] = ACTIONS(713),
    [anon_sym_symbol] = ACTIONS(713),
    [sym_readonly] = ACTIONS(713),
  },
  [277] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(978),
    [sym__expression] = STATE(1552),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1696),
    [sym_array] = STATE(1691),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3169),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(978),
    [sym_subscript_expression] = STATE(978),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1967),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(977),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(380),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(881),
    [anon_sym_export] = ACTIONS(617),
    [anon_sym_namespace] = ACTIONS(619),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_type] = ACTIONS(617),
    [anon_sym_typeof] = ACTIONS(639),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(625),
    [anon_sym_yield] = ACTIONS(627),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(631),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(887),
    [anon_sym_PLUS] = ACTIONS(889),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(623),
    [anon_sym_void] = ACTIONS(639),
    [anon_sym_delete] = ACTIONS(639),
    [anon_sym_PLUS_PLUS] = ACTIONS(641),
    [anon_sym_DASH_DASH] = ACTIONS(641),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(617),
    [anon_sym_get] = ACTIONS(617),
    [anon_sym_set] = ACTIONS(617),
    [anon_sym_declare] = ACTIONS(617),
    [anon_sym_public] = ACTIONS(617),
    [anon_sym_private] = ACTIONS(617),
    [anon_sym_protected] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(617),
    [anon_sym_any] = ACTIONS(617),
    [anon_sym_number] = ACTIONS(617),
    [anon_sym_boolean] = ACTIONS(617),
    [anon_sym_string] = ACTIONS(617),
    [anon_sym_symbol] = ACTIONS(617),
    [sym_readonly] = ACTIONS(617),
  },
  [278] = {
    [sym_import] = STATE(1528),
    [sym_parenthesized_expression] = STATE(933),
    [sym__expression] = STATE(1169),
    [sym_yield_expression] = STATE(1543),
    [sym_object] = STATE(1367),
    [sym_array] = STATE(1369),
    [sym_class] = STATE(1528),
    [sym_function] = STATE(1528),
    [sym_generator_function] = STATE(1528),
    [sym_arrow_function] = STATE(1528),
    [sym__call_signature] = STATE(3359),
    [sym_call_expression] = STATE(1528),
    [sym_new_expression] = STATE(1543),
    [sym_await_expression] = STATE(1543),
    [sym_member_expression] = STATE(933),
    [sym_subscript_expression] = STATE(933),
    [sym_assignment_expression] = STATE(1543),
    [sym__augmented_assignment_lhs] = STATE(1970),
    [sym_augmented_assignment_expression] = STATE(1543),
    [sym_ternary_expression] = STATE(1543),
    [sym_binary_expression] = STATE(1543),
    [sym_unary_expression] = STATE(1543),
    [sym_update_expression] = STATE(1543),
    [sym_string] = STATE(1528),
    [sym_template_string] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_meta_property] = STATE(1528),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(936),
    [sym_type_assertion] = STATE(1543),
    [sym_as_expression] = STATE(1543),
    [sym_internal_module] = STATE(1543),
    [sym_type_arguments] = STATE(381),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2726),
    [sym_identifier] = ACTIONS(855),
    [anon_sym_export] = ACTIONS(745),
    [anon_sym_namespace] = ACTIONS(747),
    [anon_sym_LBRACE] = ACTIONS(859),
    [anon_sym_type] = ACTIONS(745),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(537),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(549),
    [anon_sym_async] = ACTIONS(753),
    [anon_sym_function] = ACTIONS(553),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(745),
    [anon_sym_get] = ACTIONS(745),
    [anon_sym_set] = ACTIONS(745),
    [anon_sym_declare] = ACTIONS(745),
    [anon_sym_public] = ACTIONS(745),
    [anon_sym_private] = ACTIONS(745),
    [anon_sym_protected] = ACTIONS(745),
    [anon_sym_module] = ACTIONS(745),
    [anon_sym_any] = ACTIONS(745),
    [anon_sym_number] = ACTIONS(745),
    [anon_sym_boolean] = ACTIONS(745),
    [anon_sym_string] = ACTIONS(745),
    [anon_sym_symbol] = ACTIONS(745),
    [sym_readonly] = ACTIONS(745),
  },
  [279] = {
    [sym_import] = STATE(1528),
    [sym_parenthesized_expression] = STATE(933),
    [sym__expression] = STATE(1168),
    [sym_yield_expression] = STATE(1543),
    [sym_object] = STATE(1367),
    [sym_array] = STATE(1369),
    [sym_class] = STATE(1528),
    [sym_function] = STATE(1528),
    [sym_generator_function] = STATE(1528),
    [sym_arrow_function] = STATE(1528),
    [sym__call_signature] = STATE(3359),
    [sym_call_expression] = STATE(1528),
    [sym_new_expression] = STATE(1543),
    [sym_await_expression] = STATE(1543),
    [sym_member_expression] = STATE(933),
    [sym_subscript_expression] = STATE(933),
    [sym_assignment_expression] = STATE(1543),
    [sym__augmented_assignment_lhs] = STATE(1970),
    [sym_augmented_assignment_expression] = STATE(1543),
    [sym_ternary_expression] = STATE(1543),
    [sym_binary_expression] = STATE(1543),
    [sym_unary_expression] = STATE(1543),
    [sym_update_expression] = STATE(1543),
    [sym_string] = STATE(1528),
    [sym_template_string] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_meta_property] = STATE(1528),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(936),
    [sym_type_assertion] = STATE(1543),
    [sym_as_expression] = STATE(1543),
    [sym_internal_module] = STATE(1543),
    [sym_type_arguments] = STATE(381),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2726),
    [sym_identifier] = ACTIONS(855),
    [anon_sym_export] = ACTIONS(745),
    [anon_sym_namespace] = ACTIONS(747),
    [anon_sym_LBRACE] = ACTIONS(859),
    [anon_sym_type] = ACTIONS(745),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(537),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(549),
    [anon_sym_async] = ACTIONS(753),
    [anon_sym_function] = ACTIONS(553),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(745),
    [anon_sym_get] = ACTIONS(745),
    [anon_sym_set] = ACTIONS(745),
    [anon_sym_declare] = ACTIONS(745),
    [anon_sym_public] = ACTIONS(745),
    [anon_sym_private] = ACTIONS(745),
    [anon_sym_protected] = ACTIONS(745),
    [anon_sym_module] = ACTIONS(745),
    [anon_sym_any] = ACTIONS(745),
    [anon_sym_number] = ACTIONS(745),
    [anon_sym_boolean] = ACTIONS(745),
    [anon_sym_string] = ACTIONS(745),
    [anon_sym_symbol] = ACTIONS(745),
    [sym_readonly] = ACTIONS(745),
  },
  [280] = {
    [sym_import] = STATE(1528),
    [sym_parenthesized_expression] = STATE(933),
    [sym__expression] = STATE(1167),
    [sym_yield_expression] = STATE(1543),
    [sym_object] = STATE(1367),
    [sym_array] = STATE(1369),
    [sym_class] = STATE(1528),
    [sym_function] = STATE(1528),
    [sym_generator_function] = STATE(1528),
    [sym_arrow_function] = STATE(1528),
    [sym__call_signature] = STATE(3359),
    [sym_call_expression] = STATE(1528),
    [sym_new_expression] = STATE(1543),
    [sym_await_expression] = STATE(1543),
    [sym_member_expression] = STATE(933),
    [sym_subscript_expression] = STATE(933),
    [sym_assignment_expression] = STATE(1543),
    [sym__augmented_assignment_lhs] = STATE(1970),
    [sym_augmented_assignment_expression] = STATE(1543),
    [sym_ternary_expression] = STATE(1543),
    [sym_binary_expression] = STATE(1543),
    [sym_unary_expression] = STATE(1543),
    [sym_update_expression] = STATE(1543),
    [sym_string] = STATE(1528),
    [sym_template_string] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_meta_property] = STATE(1528),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(936),
    [sym_type_assertion] = STATE(1543),
    [sym_as_expression] = STATE(1543),
    [sym_internal_module] = STATE(1543),
    [sym_type_arguments] = STATE(381),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2726),
    [sym_identifier] = ACTIONS(855),
    [anon_sym_export] = ACTIONS(745),
    [anon_sym_namespace] = ACTIONS(747),
    [anon_sym_LBRACE] = ACTIONS(859),
    [anon_sym_type] = ACTIONS(745),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(537),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(549),
    [anon_sym_async] = ACTIONS(753),
    [anon_sym_function] = ACTIONS(553),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(745),
    [anon_sym_get] = ACTIONS(745),
    [anon_sym_set] = ACTIONS(745),
    [anon_sym_declare] = ACTIONS(745),
    [anon_sym_public] = ACTIONS(745),
    [anon_sym_private] = ACTIONS(745),
    [anon_sym_protected] = ACTIONS(745),
    [anon_sym_module] = ACTIONS(745),
    [anon_sym_any] = ACTIONS(745),
    [anon_sym_number] = ACTIONS(745),
    [anon_sym_boolean] = ACTIONS(745),
    [anon_sym_string] = ACTIONS(745),
    [anon_sym_symbol] = ACTIONS(745),
    [sym_readonly] = ACTIONS(745),
  },
  [281] = {
    [sym_import] = STATE(1528),
    [sym_parenthesized_expression] = STATE(933),
    [sym__expression] = STATE(1166),
    [sym_yield_expression] = STATE(1543),
    [sym_object] = STATE(1367),
    [sym_array] = STATE(1369),
    [sym_class] = STATE(1528),
    [sym_function] = STATE(1528),
    [sym_generator_function] = STATE(1528),
    [sym_arrow_function] = STATE(1528),
    [sym__call_signature] = STATE(3359),
    [sym_call_expression] = STATE(1528),
    [sym_new_expression] = STATE(1543),
    [sym_await_expression] = STATE(1543),
    [sym_member_expression] = STATE(933),
    [sym_subscript_expression] = STATE(933),
    [sym_assignment_expression] = STATE(1543),
    [sym__augmented_assignment_lhs] = STATE(1970),
    [sym_augmented_assignment_expression] = STATE(1543),
    [sym_ternary_expression] = STATE(1543),
    [sym_binary_expression] = STATE(1543),
    [sym_unary_expression] = STATE(1543),
    [sym_update_expression] = STATE(1543),
    [sym_string] = STATE(1528),
    [sym_template_string] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_meta_property] = STATE(1528),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(936),
    [sym_type_assertion] = STATE(1543),
    [sym_as_expression] = STATE(1543),
    [sym_internal_module] = STATE(1543),
    [sym_type_arguments] = STATE(381),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2726),
    [sym_identifier] = ACTIONS(855),
    [anon_sym_export] = ACTIONS(745),
    [anon_sym_namespace] = ACTIONS(747),
    [anon_sym_LBRACE] = ACTIONS(859),
    [anon_sym_type] = ACTIONS(745),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(537),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(549),
    [anon_sym_async] = ACTIONS(753),
    [anon_sym_function] = ACTIONS(553),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(745),
    [anon_sym_get] = ACTIONS(745),
    [anon_sym_set] = ACTIONS(745),
    [anon_sym_declare] = ACTIONS(745),
    [anon_sym_public] = ACTIONS(745),
    [anon_sym_private] = ACTIONS(745),
    [anon_sym_protected] = ACTIONS(745),
    [anon_sym_module] = ACTIONS(745),
    [anon_sym_any] = ACTIONS(745),
    [anon_sym_number] = ACTIONS(745),
    [anon_sym_boolean] = ACTIONS(745),
    [anon_sym_string] = ACTIONS(745),
    [anon_sym_symbol] = ACTIONS(745),
    [sym_readonly] = ACTIONS(745),
  },
  [282] = {
    [sym_import] = STATE(1528),
    [sym_parenthesized_expression] = STATE(933),
    [sym__expression] = STATE(1165),
    [sym_yield_expression] = STATE(1543),
    [sym_object] = STATE(1367),
    [sym_array] = STATE(1369),
    [sym_class] = STATE(1528),
    [sym_function] = STATE(1528),
    [sym_generator_function] = STATE(1528),
    [sym_arrow_function] = STATE(1528),
    [sym__call_signature] = STATE(3359),
    [sym_call_expression] = STATE(1528),
    [sym_new_expression] = STATE(1543),
    [sym_await_expression] = STATE(1543),
    [sym_member_expression] = STATE(933),
    [sym_subscript_expression] = STATE(933),
    [sym_assignment_expression] = STATE(1543),
    [sym__augmented_assignment_lhs] = STATE(1970),
    [sym_augmented_assignment_expression] = STATE(1543),
    [sym_ternary_expression] = STATE(1543),
    [sym_binary_expression] = STATE(1543),
    [sym_unary_expression] = STATE(1543),
    [sym_update_expression] = STATE(1543),
    [sym_string] = STATE(1528),
    [sym_template_string] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_meta_property] = STATE(1528),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(936),
    [sym_type_assertion] = STATE(1543),
    [sym_as_expression] = STATE(1543),
    [sym_internal_module] = STATE(1543),
    [sym_type_arguments] = STATE(381),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2726),
    [sym_identifier] = ACTIONS(855),
    [anon_sym_export] = ACTIONS(745),
    [anon_sym_namespace] = ACTIONS(747),
    [anon_sym_LBRACE] = ACTIONS(859),
    [anon_sym_type] = ACTIONS(745),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(537),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(549),
    [anon_sym_async] = ACTIONS(753),
    [anon_sym_function] = ACTIONS(553),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(745),
    [anon_sym_get] = ACTIONS(745),
    [anon_sym_set] = ACTIONS(745),
    [anon_sym_declare] = ACTIONS(745),
    [anon_sym_public] = ACTIONS(745),
    [anon_sym_private] = ACTIONS(745),
    [anon_sym_protected] = ACTIONS(745),
    [anon_sym_module] = ACTIONS(745),
    [anon_sym_any] = ACTIONS(745),
    [anon_sym_number] = ACTIONS(745),
    [anon_sym_boolean] = ACTIONS(745),
    [anon_sym_string] = ACTIONS(745),
    [anon_sym_symbol] = ACTIONS(745),
    [sym_readonly] = ACTIONS(745),
  },
  [283] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(978),
    [sym__expression] = STATE(1499),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1696),
    [sym_array] = STATE(1691),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3169),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(978),
    [sym_subscript_expression] = STATE(978),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1967),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(977),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(380),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(881),
    [anon_sym_export] = ACTIONS(617),
    [anon_sym_namespace] = ACTIONS(619),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_type] = ACTIONS(617),
    [anon_sym_typeof] = ACTIONS(639),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(625),
    [anon_sym_yield] = ACTIONS(627),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(631),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(887),
    [anon_sym_PLUS] = ACTIONS(889),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(623),
    [anon_sym_void] = ACTIONS(639),
    [anon_sym_delete] = ACTIONS(639),
    [anon_sym_PLUS_PLUS] = ACTIONS(641),
    [anon_sym_DASH_DASH] = ACTIONS(641),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(617),
    [anon_sym_get] = ACTIONS(617),
    [anon_sym_set] = ACTIONS(617),
    [anon_sym_declare] = ACTIONS(617),
    [anon_sym_public] = ACTIONS(617),
    [anon_sym_private] = ACTIONS(617),
    [anon_sym_protected] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(617),
    [anon_sym_any] = ACTIONS(617),
    [anon_sym_number] = ACTIONS(617),
    [anon_sym_boolean] = ACTIONS(617),
    [anon_sym_string] = ACTIONS(617),
    [anon_sym_symbol] = ACTIONS(617),
    [sym_readonly] = ACTIONS(617),
  },
  [284] = {
    [ts_builtin_sym_end] = ACTIONS(1489),
    [sym_identifier] = ACTIONS(1491),
    [anon_sym_export] = ACTIONS(1491),
    [anon_sym_default] = ACTIONS(1491),
    [anon_sym_EQ] = ACTIONS(1491),
    [anon_sym_namespace] = ACTIONS(1491),
    [anon_sym_LBRACE] = ACTIONS(1489),
    [anon_sym_COMMA] = ACTIONS(1489),
    [anon_sym_RBRACE] = ACTIONS(1489),
    [anon_sym_type] = ACTIONS(1491),
    [anon_sym_typeof] = ACTIONS(1491),
    [anon_sym_import] = ACTIONS(1491),
    [anon_sym_var] = ACTIONS(1491),
    [anon_sym_let] = ACTIONS(1491),
    [anon_sym_const] = ACTIONS(1491),
    [anon_sym_BANG] = ACTIONS(1489),
    [anon_sym_else] = ACTIONS(1491),
    [anon_sym_if] = ACTIONS(1491),
    [anon_sym_switch] = ACTIONS(1491),
    [anon_sym_for] = ACTIONS(1491),
    [anon_sym_LPAREN] = ACTIONS(1489),
    [anon_sym_RPAREN] = ACTIONS(1489),
    [anon_sym_await] = ACTIONS(1491),
    [anon_sym_while] = ACTIONS(1491),
    [anon_sym_do] = ACTIONS(1491),
    [anon_sym_try] = ACTIONS(1491),
    [anon_sym_with] = ACTIONS(1491),
    [anon_sym_break] = ACTIONS(1491),
    [anon_sym_continue] = ACTIONS(1491),
    [anon_sym_debugger] = ACTIONS(1491),
    [anon_sym_return] = ACTIONS(1491),
    [anon_sym_throw] = ACTIONS(1491),
    [anon_sym_SEMI] = ACTIONS(1489),
    [anon_sym_COLON] = ACTIONS(1489),
    [anon_sym_case] = ACTIONS(1491),
    [anon_sym_yield] = ACTIONS(1491),
    [anon_sym_LBRACK] = ACTIONS(1489),
    [anon_sym_RBRACK] = ACTIONS(1489),
    [anon_sym_LT] = ACTIONS(1489),
    [anon_sym_GT] = ACTIONS(1489),
    [anon_sym_SLASH] = ACTIONS(1491),
    [anon_sym_class] = ACTIONS(1491),
    [anon_sym_async] = ACTIONS(1491),
    [anon_sym_function] = ACTIONS(1491),
    [anon_sym_EQ_GT] = ACTIONS(1489),
    [anon_sym_new] = ACTIONS(1491),
    [anon_sym_QMARK] = ACTIONS(1489),
    [anon_sym_AMP] = ACTIONS(1489),
    [anon_sym_PIPE] = ACTIONS(1489),
    [anon_sym_PLUS] = ACTIONS(1491),
    [anon_sym_DASH] = ACTIONS(1491),
    [anon_sym_TILDE] = ACTIONS(1489),
    [anon_sym_void] = ACTIONS(1491),
    [anon_sym_delete] = ACTIONS(1491),
    [anon_sym_PLUS_PLUS] = ACTIONS(1489),
    [anon_sym_DASH_DASH] = ACTIONS(1489),
    [anon_sym_DQUOTE] = ACTIONS(1489),
    [anon_sym_SQUOTE] = ACTIONS(1489),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1489),
    [sym_number] = ACTIONS(1489),
    [sym_this] = ACTIONS(1491),
    [sym_super] = ACTIONS(1491),
    [sym_true] = ACTIONS(1491),
    [sym_false] = ACTIONS(1491),
    [sym_null] = ACTIONS(1491),
    [sym_undefined] = ACTIONS(1491),
    [anon_sym_AT] = ACTIONS(1489),
    [anon_sym_static] = ACTIONS(1491),
    [anon_sym_abstract] = ACTIONS(1491),
    [anon_sym_get] = ACTIONS(1491),
    [anon_sym_set] = ACTIONS(1491),
    [anon_sym_declare] = ACTIONS(1491),
    [anon_sym_public] = ACTIONS(1491),
    [anon_sym_private] = ACTIONS(1491),
    [anon_sym_protected] = ACTIONS(1491),
    [anon_sym_module] = ACTIONS(1491),
    [anon_sym_any] = ACTIONS(1491),
    [anon_sym_number] = ACTIONS(1491),
    [anon_sym_boolean] = ACTIONS(1491),
    [anon_sym_string] = ACTIONS(1491),
    [anon_sym_symbol] = ACTIONS(1491),
    [anon_sym_implements] = ACTIONS(1491),
    [anon_sym_interface] = ACTIONS(1491),
    [anon_sym_extends] = ACTIONS(1491),
    [anon_sym_enum] = ACTIONS(1491),
    [sym_readonly] = ACTIONS(1491),
  },
  [285] = {
    [sym_import] = STATE(1528),
    [sym_parenthesized_expression] = STATE(933),
    [sym__expression] = STATE(1189),
    [sym_yield_expression] = STATE(1543),
    [sym_object] = STATE(1367),
    [sym_array] = STATE(1369),
    [sym_class] = STATE(1528),
    [sym_function] = STATE(1528),
    [sym_generator_function] = STATE(1528),
    [sym_arrow_function] = STATE(1528),
    [sym__call_signature] = STATE(3359),
    [sym_call_expression] = STATE(1528),
    [sym_new_expression] = STATE(1543),
    [sym_await_expression] = STATE(1543),
    [sym_member_expression] = STATE(933),
    [sym_subscript_expression] = STATE(933),
    [sym_assignment_expression] = STATE(1543),
    [sym__augmented_assignment_lhs] = STATE(1970),
    [sym_augmented_assignment_expression] = STATE(1543),
    [sym_ternary_expression] = STATE(1543),
    [sym_binary_expression] = STATE(1543),
    [sym_unary_expression] = STATE(1543),
    [sym_update_expression] = STATE(1543),
    [sym_string] = STATE(1528),
    [sym_template_string] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_meta_property] = STATE(1528),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(936),
    [sym_type_assertion] = STATE(1543),
    [sym_as_expression] = STATE(1543),
    [sym_internal_module] = STATE(1543),
    [sym_type_arguments] = STATE(381),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2726),
    [sym_identifier] = ACTIONS(855),
    [anon_sym_export] = ACTIONS(745),
    [anon_sym_namespace] = ACTIONS(747),
    [anon_sym_LBRACE] = ACTIONS(859),
    [anon_sym_type] = ACTIONS(745),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(537),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(549),
    [anon_sym_async] = ACTIONS(753),
    [anon_sym_function] = ACTIONS(553),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(745),
    [anon_sym_get] = ACTIONS(745),
    [anon_sym_set] = ACTIONS(745),
    [anon_sym_declare] = ACTIONS(745),
    [anon_sym_public] = ACTIONS(745),
    [anon_sym_private] = ACTIONS(745),
    [anon_sym_protected] = ACTIONS(745),
    [anon_sym_module] = ACTIONS(745),
    [anon_sym_any] = ACTIONS(745),
    [anon_sym_number] = ACTIONS(745),
    [anon_sym_boolean] = ACTIONS(745),
    [anon_sym_string] = ACTIONS(745),
    [anon_sym_symbol] = ACTIONS(745),
    [sym_readonly] = ACTIONS(745),
  },
  [286] = {
    [sym_import] = STATE(1528),
    [sym_parenthesized_expression] = STATE(933),
    [sym__expression] = STATE(1163),
    [sym_yield_expression] = STATE(1543),
    [sym_object] = STATE(1367),
    [sym_array] = STATE(1369),
    [sym_class] = STATE(1528),
    [sym_function] = STATE(1528),
    [sym_generator_function] = STATE(1528),
    [sym_arrow_function] = STATE(1528),
    [sym__call_signature] = STATE(3359),
    [sym_call_expression] = STATE(1528),
    [sym_new_expression] = STATE(1543),
    [sym_await_expression] = STATE(1543),
    [sym_member_expression] = STATE(933),
    [sym_subscript_expression] = STATE(933),
    [sym_assignment_expression] = STATE(1543),
    [sym__augmented_assignment_lhs] = STATE(1970),
    [sym_augmented_assignment_expression] = STATE(1543),
    [sym_ternary_expression] = STATE(1543),
    [sym_binary_expression] = STATE(1543),
    [sym_unary_expression] = STATE(1543),
    [sym_update_expression] = STATE(1543),
    [sym_string] = STATE(1528),
    [sym_template_string] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_meta_property] = STATE(1528),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(936),
    [sym_type_assertion] = STATE(1543),
    [sym_as_expression] = STATE(1543),
    [sym_internal_module] = STATE(1543),
    [sym_type_arguments] = STATE(381),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2726),
    [sym_identifier] = ACTIONS(855),
    [anon_sym_export] = ACTIONS(745),
    [anon_sym_namespace] = ACTIONS(747),
    [anon_sym_LBRACE] = ACTIONS(859),
    [anon_sym_type] = ACTIONS(745),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(537),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(549),
    [anon_sym_async] = ACTIONS(753),
    [anon_sym_function] = ACTIONS(553),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(745),
    [anon_sym_get] = ACTIONS(745),
    [anon_sym_set] = ACTIONS(745),
    [anon_sym_declare] = ACTIONS(745),
    [anon_sym_public] = ACTIONS(745),
    [anon_sym_private] = ACTIONS(745),
    [anon_sym_protected] = ACTIONS(745),
    [anon_sym_module] = ACTIONS(745),
    [anon_sym_any] = ACTIONS(745),
    [anon_sym_number] = ACTIONS(745),
    [anon_sym_boolean] = ACTIONS(745),
    [anon_sym_string] = ACTIONS(745),
    [anon_sym_symbol] = ACTIONS(745),
    [sym_readonly] = ACTIONS(745),
  },
  [287] = {
    [sym_import] = STATE(1528),
    [sym_parenthesized_expression] = STATE(933),
    [sym__expression] = STATE(1161),
    [sym_yield_expression] = STATE(1543),
    [sym_object] = STATE(1367),
    [sym_array] = STATE(1369),
    [sym_class] = STATE(1528),
    [sym_function] = STATE(1528),
    [sym_generator_function] = STATE(1528),
    [sym_arrow_function] = STATE(1528),
    [sym__call_signature] = STATE(3359),
    [sym_call_expression] = STATE(1528),
    [sym_new_expression] = STATE(1543),
    [sym_await_expression] = STATE(1543),
    [sym_member_expression] = STATE(933),
    [sym_subscript_expression] = STATE(933),
    [sym_assignment_expression] = STATE(1543),
    [sym__augmented_assignment_lhs] = STATE(1970),
    [sym_augmented_assignment_expression] = STATE(1543),
    [sym_ternary_expression] = STATE(1543),
    [sym_binary_expression] = STATE(1543),
    [sym_unary_expression] = STATE(1543),
    [sym_update_expression] = STATE(1543),
    [sym_string] = STATE(1528),
    [sym_template_string] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_meta_property] = STATE(1528),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(936),
    [sym_type_assertion] = STATE(1543),
    [sym_as_expression] = STATE(1543),
    [sym_internal_module] = STATE(1543),
    [sym_type_arguments] = STATE(381),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2726),
    [sym_identifier] = ACTIONS(855),
    [anon_sym_export] = ACTIONS(745),
    [anon_sym_namespace] = ACTIONS(747),
    [anon_sym_LBRACE] = ACTIONS(859),
    [anon_sym_type] = ACTIONS(745),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(537),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(549),
    [anon_sym_async] = ACTIONS(753),
    [anon_sym_function] = ACTIONS(553),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(745),
    [anon_sym_get] = ACTIONS(745),
    [anon_sym_set] = ACTIONS(745),
    [anon_sym_declare] = ACTIONS(745),
    [anon_sym_public] = ACTIONS(745),
    [anon_sym_private] = ACTIONS(745),
    [anon_sym_protected] = ACTIONS(745),
    [anon_sym_module] = ACTIONS(745),
    [anon_sym_any] = ACTIONS(745),
    [anon_sym_number] = ACTIONS(745),
    [anon_sym_boolean] = ACTIONS(745),
    [anon_sym_string] = ACTIONS(745),
    [anon_sym_symbol] = ACTIONS(745),
    [sym_readonly] = ACTIONS(745),
  },
  [288] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(884),
    [sym__expression] = STATE(1297),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1283),
    [sym_array] = STATE(1281),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3336),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(884),
    [sym_subscript_expression] = STATE(884),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1964),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(860),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(414),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(831),
    [anon_sym_export] = ACTIONS(503),
    [anon_sym_namespace] = ACTIONS(505),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_type] = ACTIONS(503),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(437),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(443),
    [anon_sym_yield] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(849),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(851),
    [anon_sym_TILDE] = ACTIONS(437),
    [anon_sym_void] = ACTIONS(471),
    [anon_sym_delete] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(473),
    [anon_sym_DASH_DASH] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(503),
    [anon_sym_get] = ACTIONS(503),
    [anon_sym_set] = ACTIONS(503),
    [anon_sym_declare] = ACTIONS(503),
    [anon_sym_public] = ACTIONS(503),
    [anon_sym_private] = ACTIONS(503),
    [anon_sym_protected] = ACTIONS(503),
    [anon_sym_module] = ACTIONS(503),
    [anon_sym_any] = ACTIONS(503),
    [anon_sym_number] = ACTIONS(503),
    [anon_sym_boolean] = ACTIONS(503),
    [anon_sym_string] = ACTIONS(503),
    [anon_sym_symbol] = ACTIONS(503),
    [sym_readonly] = ACTIONS(503),
  },
  [289] = {
    [sym_import] = STATE(1528),
    [sym_parenthesized_expression] = STATE(933),
    [sym__expression] = STATE(1158),
    [sym_yield_expression] = STATE(1543),
    [sym_object] = STATE(1367),
    [sym_array] = STATE(1369),
    [sym_class] = STATE(1528),
    [sym_function] = STATE(1528),
    [sym_generator_function] = STATE(1528),
    [sym_arrow_function] = STATE(1528),
    [sym__call_signature] = STATE(3359),
    [sym_call_expression] = STATE(1528),
    [sym_new_expression] = STATE(1543),
    [sym_await_expression] = STATE(1543),
    [sym_member_expression] = STATE(933),
    [sym_subscript_expression] = STATE(933),
    [sym_assignment_expression] = STATE(1543),
    [sym__augmented_assignment_lhs] = STATE(1970),
    [sym_augmented_assignment_expression] = STATE(1543),
    [sym_ternary_expression] = STATE(1543),
    [sym_binary_expression] = STATE(1543),
    [sym_unary_expression] = STATE(1543),
    [sym_update_expression] = STATE(1543),
    [sym_string] = STATE(1528),
    [sym_template_string] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_meta_property] = STATE(1528),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(936),
    [sym_type_assertion] = STATE(1543),
    [sym_as_expression] = STATE(1543),
    [sym_internal_module] = STATE(1543),
    [sym_type_arguments] = STATE(381),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2726),
    [sym_identifier] = ACTIONS(855),
    [anon_sym_export] = ACTIONS(745),
    [anon_sym_namespace] = ACTIONS(747),
    [anon_sym_LBRACE] = ACTIONS(859),
    [anon_sym_type] = ACTIONS(745),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(537),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(549),
    [anon_sym_async] = ACTIONS(753),
    [anon_sym_function] = ACTIONS(553),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(745),
    [anon_sym_get] = ACTIONS(745),
    [anon_sym_set] = ACTIONS(745),
    [anon_sym_declare] = ACTIONS(745),
    [anon_sym_public] = ACTIONS(745),
    [anon_sym_private] = ACTIONS(745),
    [anon_sym_protected] = ACTIONS(745),
    [anon_sym_module] = ACTIONS(745),
    [anon_sym_any] = ACTIONS(745),
    [anon_sym_number] = ACTIONS(745),
    [anon_sym_boolean] = ACTIONS(745),
    [anon_sym_string] = ACTIONS(745),
    [anon_sym_symbol] = ACTIONS(745),
    [sym_readonly] = ACTIONS(745),
  },
  [290] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(965),
    [sym__expression] = STATE(1292),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1524),
    [sym_array] = STATE(1523),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3348),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(965),
    [sym_subscript_expression] = STATE(965),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1969),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(975),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(302),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(901),
    [anon_sym_export] = ACTIONS(713),
    [anon_sym_namespace] = ACTIONS(715),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_type] = ACTIONS(713),
    [anon_sym_typeof] = ACTIONS(735),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(719),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(721),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(725),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(727),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(907),
    [anon_sym_PLUS] = ACTIONS(909),
    [anon_sym_DASH] = ACTIONS(909),
    [anon_sym_TILDE] = ACTIONS(719),
    [anon_sym_void] = ACTIONS(735),
    [anon_sym_delete] = ACTIONS(735),
    [anon_sym_PLUS_PLUS] = ACTIONS(737),
    [anon_sym_DASH_DASH] = ACTIONS(737),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(713),
    [anon_sym_get] = ACTIONS(713),
    [anon_sym_set] = ACTIONS(713),
    [anon_sym_declare] = ACTIONS(713),
    [anon_sym_public] = ACTIONS(713),
    [anon_sym_private] = ACTIONS(713),
    [anon_sym_protected] = ACTIONS(713),
    [anon_sym_module] = ACTIONS(713),
    [anon_sym_any] = ACTIONS(713),
    [anon_sym_number] = ACTIONS(713),
    [anon_sym_boolean] = ACTIONS(713),
    [anon_sym_string] = ACTIONS(713),
    [anon_sym_symbol] = ACTIONS(713),
    [sym_readonly] = ACTIONS(713),
  },
  [291] = {
    [sym_import] = STATE(1528),
    [sym_parenthesized_expression] = STATE(933),
    [sym__expression] = STATE(1180),
    [sym_yield_expression] = STATE(1543),
    [sym_object] = STATE(1367),
    [sym_array] = STATE(1369),
    [sym_class] = STATE(1528),
    [sym_function] = STATE(1528),
    [sym_generator_function] = STATE(1528),
    [sym_arrow_function] = STATE(1528),
    [sym__call_signature] = STATE(3359),
    [sym_call_expression] = STATE(1528),
    [sym_new_expression] = STATE(1543),
    [sym_await_expression] = STATE(1543),
    [sym_member_expression] = STATE(933),
    [sym_subscript_expression] = STATE(933),
    [sym_assignment_expression] = STATE(1543),
    [sym__augmented_assignment_lhs] = STATE(1970),
    [sym_augmented_assignment_expression] = STATE(1543),
    [sym_ternary_expression] = STATE(1543),
    [sym_binary_expression] = STATE(1543),
    [sym_unary_expression] = STATE(1543),
    [sym_update_expression] = STATE(1543),
    [sym_string] = STATE(1528),
    [sym_template_string] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_meta_property] = STATE(1528),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(936),
    [sym_type_assertion] = STATE(1543),
    [sym_as_expression] = STATE(1543),
    [sym_internal_module] = STATE(1543),
    [sym_type_arguments] = STATE(381),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2726),
    [sym_identifier] = ACTIONS(855),
    [anon_sym_export] = ACTIONS(745),
    [anon_sym_namespace] = ACTIONS(747),
    [anon_sym_LBRACE] = ACTIONS(859),
    [anon_sym_type] = ACTIONS(745),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(537),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(549),
    [anon_sym_async] = ACTIONS(753),
    [anon_sym_function] = ACTIONS(553),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(745),
    [anon_sym_get] = ACTIONS(745),
    [anon_sym_set] = ACTIONS(745),
    [anon_sym_declare] = ACTIONS(745),
    [anon_sym_public] = ACTIONS(745),
    [anon_sym_private] = ACTIONS(745),
    [anon_sym_protected] = ACTIONS(745),
    [anon_sym_module] = ACTIONS(745),
    [anon_sym_any] = ACTIONS(745),
    [anon_sym_number] = ACTIONS(745),
    [anon_sym_boolean] = ACTIONS(745),
    [anon_sym_string] = ACTIONS(745),
    [anon_sym_symbol] = ACTIONS(745),
    [sym_readonly] = ACTIONS(745),
  },
  [292] = {
    [ts_builtin_sym_end] = ACTIONS(1493),
    [sym_identifier] = ACTIONS(1495),
    [anon_sym_export] = ACTIONS(1495),
    [anon_sym_default] = ACTIONS(1495),
    [anon_sym_EQ] = ACTIONS(1495),
    [anon_sym_namespace] = ACTIONS(1495),
    [anon_sym_LBRACE] = ACTIONS(1493),
    [anon_sym_COMMA] = ACTIONS(1493),
    [anon_sym_RBRACE] = ACTIONS(1493),
    [anon_sym_type] = ACTIONS(1495),
    [anon_sym_typeof] = ACTIONS(1495),
    [anon_sym_import] = ACTIONS(1495),
    [anon_sym_var] = ACTIONS(1495),
    [anon_sym_let] = ACTIONS(1495),
    [anon_sym_const] = ACTIONS(1495),
    [anon_sym_BANG] = ACTIONS(1493),
    [anon_sym_else] = ACTIONS(1495),
    [anon_sym_if] = ACTIONS(1495),
    [anon_sym_switch] = ACTIONS(1495),
    [anon_sym_for] = ACTIONS(1495),
    [anon_sym_LPAREN] = ACTIONS(1493),
    [anon_sym_RPAREN] = ACTIONS(1493),
    [anon_sym_await] = ACTIONS(1495),
    [anon_sym_while] = ACTIONS(1495),
    [anon_sym_do] = ACTIONS(1495),
    [anon_sym_try] = ACTIONS(1495),
    [anon_sym_with] = ACTIONS(1495),
    [anon_sym_break] = ACTIONS(1495),
    [anon_sym_continue] = ACTIONS(1495),
    [anon_sym_debugger] = ACTIONS(1495),
    [anon_sym_return] = ACTIONS(1495),
    [anon_sym_throw] = ACTIONS(1495),
    [anon_sym_SEMI] = ACTIONS(1493),
    [anon_sym_COLON] = ACTIONS(1493),
    [anon_sym_case] = ACTIONS(1495),
    [anon_sym_yield] = ACTIONS(1495),
    [anon_sym_LBRACK] = ACTIONS(1493),
    [anon_sym_RBRACK] = ACTIONS(1493),
    [anon_sym_LT] = ACTIONS(1493),
    [anon_sym_GT] = ACTIONS(1493),
    [anon_sym_SLASH] = ACTIONS(1495),
    [anon_sym_class] = ACTIONS(1495),
    [anon_sym_async] = ACTIONS(1495),
    [anon_sym_function] = ACTIONS(1495),
    [anon_sym_EQ_GT] = ACTIONS(1493),
    [anon_sym_new] = ACTIONS(1495),
    [anon_sym_QMARK] = ACTIONS(1493),
    [anon_sym_AMP] = ACTIONS(1493),
    [anon_sym_PIPE] = ACTIONS(1493),
    [anon_sym_PLUS] = ACTIONS(1495),
    [anon_sym_DASH] = ACTIONS(1495),
    [anon_sym_TILDE] = ACTIONS(1493),
    [anon_sym_void] = ACTIONS(1495),
    [anon_sym_delete] = ACTIONS(1495),
    [anon_sym_PLUS_PLUS] = ACTIONS(1493),
    [anon_sym_DASH_DASH] = ACTIONS(1493),
    [anon_sym_DQUOTE] = ACTIONS(1493),
    [anon_sym_SQUOTE] = ACTIONS(1493),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1493),
    [sym_number] = ACTIONS(1493),
    [sym_this] = ACTIONS(1495),
    [sym_super] = ACTIONS(1495),
    [sym_true] = ACTIONS(1495),
    [sym_false] = ACTIONS(1495),
    [sym_null] = ACTIONS(1495),
    [sym_undefined] = ACTIONS(1495),
    [anon_sym_AT] = ACTIONS(1493),
    [anon_sym_static] = ACTIONS(1495),
    [anon_sym_abstract] = ACTIONS(1495),
    [anon_sym_get] = ACTIONS(1495),
    [anon_sym_set] = ACTIONS(1495),
    [anon_sym_declare] = ACTIONS(1495),
    [anon_sym_public] = ACTIONS(1495),
    [anon_sym_private] = ACTIONS(1495),
    [anon_sym_protected] = ACTIONS(1495),
    [anon_sym_module] = ACTIONS(1495),
    [anon_sym_any] = ACTIONS(1495),
    [anon_sym_number] = ACTIONS(1495),
    [anon_sym_boolean] = ACTIONS(1495),
    [anon_sym_string] = ACTIONS(1495),
    [anon_sym_symbol] = ACTIONS(1495),
    [anon_sym_implements] = ACTIONS(1495),
    [anon_sym_interface] = ACTIONS(1495),
    [anon_sym_extends] = ACTIONS(1495),
    [anon_sym_enum] = ACTIONS(1495),
    [sym_readonly] = ACTIONS(1495),
  },
  [293] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(978),
    [sym__expression] = STATE(1496),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1696),
    [sym_array] = STATE(1691),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3169),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(978),
    [sym_subscript_expression] = STATE(978),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1967),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(977),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(380),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(881),
    [anon_sym_export] = ACTIONS(617),
    [anon_sym_namespace] = ACTIONS(619),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_type] = ACTIONS(617),
    [anon_sym_typeof] = ACTIONS(639),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(625),
    [anon_sym_yield] = ACTIONS(627),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(631),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(887),
    [anon_sym_PLUS] = ACTIONS(889),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(623),
    [anon_sym_void] = ACTIONS(639),
    [anon_sym_delete] = ACTIONS(639),
    [anon_sym_PLUS_PLUS] = ACTIONS(641),
    [anon_sym_DASH_DASH] = ACTIONS(641),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(617),
    [anon_sym_get] = ACTIONS(617),
    [anon_sym_set] = ACTIONS(617),
    [anon_sym_declare] = ACTIONS(617),
    [anon_sym_public] = ACTIONS(617),
    [anon_sym_private] = ACTIONS(617),
    [anon_sym_protected] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(617),
    [anon_sym_any] = ACTIONS(617),
    [anon_sym_number] = ACTIONS(617),
    [anon_sym_boolean] = ACTIONS(617),
    [anon_sym_string] = ACTIONS(617),
    [anon_sym_symbol] = ACTIONS(617),
    [sym_readonly] = ACTIONS(617),
  },
  [294] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(978),
    [sym__expression] = STATE(1568),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1696),
    [sym_array] = STATE(1691),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3169),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(978),
    [sym_subscript_expression] = STATE(978),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1967),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(977),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(380),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(881),
    [anon_sym_export] = ACTIONS(617),
    [anon_sym_namespace] = ACTIONS(619),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_type] = ACTIONS(617),
    [anon_sym_typeof] = ACTIONS(639),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(625),
    [anon_sym_yield] = ACTIONS(627),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(631),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(887),
    [anon_sym_PLUS] = ACTIONS(889),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(623),
    [anon_sym_void] = ACTIONS(639),
    [anon_sym_delete] = ACTIONS(639),
    [anon_sym_PLUS_PLUS] = ACTIONS(641),
    [anon_sym_DASH_DASH] = ACTIONS(641),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(617),
    [anon_sym_get] = ACTIONS(617),
    [anon_sym_set] = ACTIONS(617),
    [anon_sym_declare] = ACTIONS(617),
    [anon_sym_public] = ACTIONS(617),
    [anon_sym_private] = ACTIONS(617),
    [anon_sym_protected] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(617),
    [anon_sym_any] = ACTIONS(617),
    [anon_sym_number] = ACTIONS(617),
    [anon_sym_boolean] = ACTIONS(617),
    [anon_sym_string] = ACTIONS(617),
    [anon_sym_symbol] = ACTIONS(617),
    [sym_readonly] = ACTIONS(617),
  },
  [295] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(884),
    [sym__expression] = STATE(1421),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1283),
    [sym_array] = STATE(1281),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3336),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(884),
    [sym_subscript_expression] = STATE(884),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1964),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(860),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(414),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(831),
    [anon_sym_export] = ACTIONS(503),
    [anon_sym_namespace] = ACTIONS(505),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_type] = ACTIONS(503),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(437),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(443),
    [anon_sym_yield] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(849),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(851),
    [anon_sym_TILDE] = ACTIONS(437),
    [anon_sym_void] = ACTIONS(471),
    [anon_sym_delete] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(473),
    [anon_sym_DASH_DASH] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(503),
    [anon_sym_get] = ACTIONS(503),
    [anon_sym_set] = ACTIONS(503),
    [anon_sym_declare] = ACTIONS(503),
    [anon_sym_public] = ACTIONS(503),
    [anon_sym_private] = ACTIONS(503),
    [anon_sym_protected] = ACTIONS(503),
    [anon_sym_module] = ACTIONS(503),
    [anon_sym_any] = ACTIONS(503),
    [anon_sym_number] = ACTIONS(503),
    [anon_sym_boolean] = ACTIONS(503),
    [anon_sym_string] = ACTIONS(503),
    [anon_sym_symbol] = ACTIONS(503),
    [sym_readonly] = ACTIONS(503),
  },
  [296] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(884),
    [sym__expression] = STATE(1414),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1283),
    [sym_array] = STATE(1281),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3336),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(884),
    [sym_subscript_expression] = STATE(884),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1964),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(860),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(414),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(831),
    [anon_sym_export] = ACTIONS(503),
    [anon_sym_namespace] = ACTIONS(505),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_type] = ACTIONS(503),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(437),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(443),
    [anon_sym_yield] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(849),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(851),
    [anon_sym_TILDE] = ACTIONS(437),
    [anon_sym_void] = ACTIONS(471),
    [anon_sym_delete] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(473),
    [anon_sym_DASH_DASH] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(503),
    [anon_sym_get] = ACTIONS(503),
    [anon_sym_set] = ACTIONS(503),
    [anon_sym_declare] = ACTIONS(503),
    [anon_sym_public] = ACTIONS(503),
    [anon_sym_private] = ACTIONS(503),
    [anon_sym_protected] = ACTIONS(503),
    [anon_sym_module] = ACTIONS(503),
    [anon_sym_any] = ACTIONS(503),
    [anon_sym_number] = ACTIONS(503),
    [anon_sym_boolean] = ACTIONS(503),
    [anon_sym_string] = ACTIONS(503),
    [anon_sym_symbol] = ACTIONS(503),
    [sym_readonly] = ACTIONS(503),
  },
  [297] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(884),
    [sym__expression] = STATE(1412),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1283),
    [sym_array] = STATE(1281),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3336),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(884),
    [sym_subscript_expression] = STATE(884),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1964),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(860),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(414),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(831),
    [anon_sym_export] = ACTIONS(503),
    [anon_sym_namespace] = ACTIONS(505),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_type] = ACTIONS(503),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(437),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(443),
    [anon_sym_yield] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(849),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(851),
    [anon_sym_TILDE] = ACTIONS(437),
    [anon_sym_void] = ACTIONS(471),
    [anon_sym_delete] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(473),
    [anon_sym_DASH_DASH] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(503),
    [anon_sym_get] = ACTIONS(503),
    [anon_sym_set] = ACTIONS(503),
    [anon_sym_declare] = ACTIONS(503),
    [anon_sym_public] = ACTIONS(503),
    [anon_sym_private] = ACTIONS(503),
    [anon_sym_protected] = ACTIONS(503),
    [anon_sym_module] = ACTIONS(503),
    [anon_sym_any] = ACTIONS(503),
    [anon_sym_number] = ACTIONS(503),
    [anon_sym_boolean] = ACTIONS(503),
    [anon_sym_string] = ACTIONS(503),
    [anon_sym_symbol] = ACTIONS(503),
    [sym_readonly] = ACTIONS(503),
  },
  [298] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(965),
    [sym__expression] = STATE(1307),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1524),
    [sym_array] = STATE(1523),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3348),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(965),
    [sym_subscript_expression] = STATE(965),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1969),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(975),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(302),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(901),
    [anon_sym_export] = ACTIONS(713),
    [anon_sym_namespace] = ACTIONS(715),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_type] = ACTIONS(713),
    [anon_sym_typeof] = ACTIONS(735),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(719),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(721),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(725),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(727),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(907),
    [anon_sym_PLUS] = ACTIONS(909),
    [anon_sym_DASH] = ACTIONS(909),
    [anon_sym_TILDE] = ACTIONS(719),
    [anon_sym_void] = ACTIONS(735),
    [anon_sym_delete] = ACTIONS(735),
    [anon_sym_PLUS_PLUS] = ACTIONS(737),
    [anon_sym_DASH_DASH] = ACTIONS(737),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(1497),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(713),
    [anon_sym_get] = ACTIONS(713),
    [anon_sym_set] = ACTIONS(713),
    [anon_sym_declare] = ACTIONS(713),
    [anon_sym_public] = ACTIONS(713),
    [anon_sym_private] = ACTIONS(713),
    [anon_sym_protected] = ACTIONS(713),
    [anon_sym_module] = ACTIONS(713),
    [anon_sym_any] = ACTIONS(713),
    [anon_sym_number] = ACTIONS(713),
    [anon_sym_boolean] = ACTIONS(713),
    [anon_sym_string] = ACTIONS(713),
    [anon_sym_symbol] = ACTIONS(713),
    [sym_readonly] = ACTIONS(713),
  },
  [299] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(965),
    [sym__expression] = STATE(1298),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1524),
    [sym_array] = STATE(1523),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3348),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(965),
    [sym_subscript_expression] = STATE(965),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1969),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(975),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(302),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(901),
    [anon_sym_export] = ACTIONS(713),
    [anon_sym_namespace] = ACTIONS(715),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_type] = ACTIONS(713),
    [anon_sym_typeof] = ACTIONS(735),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(719),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(721),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(725),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(727),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(907),
    [anon_sym_PLUS] = ACTIONS(909),
    [anon_sym_DASH] = ACTIONS(909),
    [anon_sym_TILDE] = ACTIONS(719),
    [anon_sym_void] = ACTIONS(735),
    [anon_sym_delete] = ACTIONS(735),
    [anon_sym_PLUS_PLUS] = ACTIONS(737),
    [anon_sym_DASH_DASH] = ACTIONS(737),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(713),
    [anon_sym_get] = ACTIONS(713),
    [anon_sym_set] = ACTIONS(713),
    [anon_sym_declare] = ACTIONS(713),
    [anon_sym_public] = ACTIONS(713),
    [anon_sym_private] = ACTIONS(713),
    [anon_sym_protected] = ACTIONS(713),
    [anon_sym_module] = ACTIONS(713),
    [anon_sym_any] = ACTIONS(713),
    [anon_sym_number] = ACTIONS(713),
    [anon_sym_boolean] = ACTIONS(713),
    [anon_sym_string] = ACTIONS(713),
    [anon_sym_symbol] = ACTIONS(713),
    [sym_readonly] = ACTIONS(713),
  },
  [300] = {
    [sym_import] = STATE(1528),
    [sym_parenthesized_expression] = STATE(983),
    [sym__expression] = STATE(1391),
    [sym_yield_expression] = STATE(1543),
    [sym_object] = STATE(1671),
    [sym_array] = STATE(1713),
    [sym_class] = STATE(1528),
    [sym_function] = STATE(1528),
    [sym_generator_function] = STATE(1528),
    [sym_arrow_function] = STATE(1528),
    [sym__call_signature] = STATE(3235),
    [sym_call_expression] = STATE(1528),
    [sym_new_expression] = STATE(1543),
    [sym_await_expression] = STATE(1543),
    [sym_member_expression] = STATE(983),
    [sym_subscript_expression] = STATE(983),
    [sym_assignment_expression] = STATE(1543),
    [sym__augmented_assignment_lhs] = STATE(1963),
    [sym_augmented_assignment_expression] = STATE(1543),
    [sym_ternary_expression] = STATE(1543),
    [sym_binary_expression] = STATE(1543),
    [sym_unary_expression] = STATE(1543),
    [sym_update_expression] = STATE(1543),
    [sym_string] = STATE(1528),
    [sym_template_string] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_meta_property] = STATE(1528),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(984),
    [sym_type_assertion] = STATE(1543),
    [sym_as_expression] = STATE(1543),
    [sym_internal_module] = STATE(1543),
    [sym_type_arguments] = STATE(310),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2726),
    [sym_identifier] = ACTIONS(891),
    [anon_sym_export] = ACTIONS(529),
    [anon_sym_namespace] = ACTIONS(531),
    [anon_sym_LBRACE] = ACTIONS(859),
    [anon_sym_type] = ACTIONS(529),
    [anon_sym_typeof] = ACTIONS(561),
    [anon_sym_import] = ACTIONS(537),
    [anon_sym_BANG] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(543),
    [anon_sym_yield] = ACTIONS(545),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(549),
    [anon_sym_async] = ACTIONS(551),
    [anon_sym_function] = ACTIONS(553),
    [anon_sym_new] = ACTIONS(897),
    [anon_sym_PLUS] = ACTIONS(899),
    [anon_sym_DASH] = ACTIONS(899),
    [anon_sym_TILDE] = ACTIONS(539),
    [anon_sym_void] = ACTIONS(561),
    [anon_sym_delete] = ACTIONS(561),
    [anon_sym_PLUS_PLUS] = ACTIONS(563),
    [anon_sym_DASH_DASH] = ACTIONS(563),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(529),
    [anon_sym_get] = ACTIONS(529),
    [anon_sym_set] = ACTIONS(529),
    [anon_sym_declare] = ACTIONS(529),
    [anon_sym_public] = ACTIONS(529),
    [anon_sym_private] = ACTIONS(529),
    [anon_sym_protected] = ACTIONS(529),
    [anon_sym_module] = ACTIONS(529),
    [anon_sym_any] = ACTIONS(529),
    [anon_sym_number] = ACTIONS(529),
    [anon_sym_boolean] = ACTIONS(529),
    [anon_sym_string] = ACTIONS(529),
    [anon_sym_symbol] = ACTIONS(529),
    [sym_readonly] = ACTIONS(529),
  },
  [301] = {
    [sym_import] = STATE(1528),
    [sym_parenthesized_expression] = STATE(983),
    [sym__expression] = STATE(1489),
    [sym_yield_expression] = STATE(1543),
    [sym_object] = STATE(1671),
    [sym_array] = STATE(1713),
    [sym_class] = STATE(1528),
    [sym_function] = STATE(1528),
    [sym_generator_function] = STATE(1528),
    [sym_arrow_function] = STATE(1528),
    [sym__call_signature] = STATE(3235),
    [sym_call_expression] = STATE(1528),
    [sym_new_expression] = STATE(1543),
    [sym_await_expression] = STATE(1543),
    [sym_member_expression] = STATE(983),
    [sym_subscript_expression] = STATE(983),
    [sym_assignment_expression] = STATE(1543),
    [sym__augmented_assignment_lhs] = STATE(1963),
    [sym_augmented_assignment_expression] = STATE(1543),
    [sym_ternary_expression] = STATE(1543),
    [sym_binary_expression] = STATE(1543),
    [sym_unary_expression] = STATE(1543),
    [sym_update_expression] = STATE(1543),
    [sym_string] = STATE(1528),
    [sym_template_string] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_meta_property] = STATE(1528),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(984),
    [sym_type_assertion] = STATE(1543),
    [sym_as_expression] = STATE(1543),
    [sym_internal_module] = STATE(1543),
    [sym_type_arguments] = STATE(310),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2726),
    [sym_identifier] = ACTIONS(891),
    [anon_sym_export] = ACTIONS(529),
    [anon_sym_namespace] = ACTIONS(531),
    [anon_sym_LBRACE] = ACTIONS(859),
    [anon_sym_type] = ACTIONS(529),
    [anon_sym_typeof] = ACTIONS(561),
    [anon_sym_import] = ACTIONS(537),
    [anon_sym_BANG] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(543),
    [anon_sym_yield] = ACTIONS(545),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(549),
    [anon_sym_async] = ACTIONS(551),
    [anon_sym_function] = ACTIONS(553),
    [anon_sym_new] = ACTIONS(897),
    [anon_sym_PLUS] = ACTIONS(899),
    [anon_sym_DASH] = ACTIONS(899),
    [anon_sym_TILDE] = ACTIONS(539),
    [anon_sym_void] = ACTIONS(561),
    [anon_sym_delete] = ACTIONS(561),
    [anon_sym_PLUS_PLUS] = ACTIONS(563),
    [anon_sym_DASH_DASH] = ACTIONS(563),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(529),
    [anon_sym_get] = ACTIONS(529),
    [anon_sym_set] = ACTIONS(529),
    [anon_sym_declare] = ACTIONS(529),
    [anon_sym_public] = ACTIONS(529),
    [anon_sym_private] = ACTIONS(529),
    [anon_sym_protected] = ACTIONS(529),
    [anon_sym_module] = ACTIONS(529),
    [anon_sym_any] = ACTIONS(529),
    [anon_sym_number] = ACTIONS(529),
    [anon_sym_boolean] = ACTIONS(529),
    [anon_sym_string] = ACTIONS(529),
    [anon_sym_symbol] = ACTIONS(529),
    [sym_readonly] = ACTIONS(529),
  },
  [302] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(965),
    [sym__expression] = STATE(1025),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1524),
    [sym_array] = STATE(1523),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3348),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(965),
    [sym_subscript_expression] = STATE(965),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1969),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(975),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(302),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(901),
    [anon_sym_export] = ACTIONS(713),
    [anon_sym_namespace] = ACTIONS(715),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_type] = ACTIONS(713),
    [anon_sym_typeof] = ACTIONS(735),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(719),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(721),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(725),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(727),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(907),
    [anon_sym_PLUS] = ACTIONS(909),
    [anon_sym_DASH] = ACTIONS(909),
    [anon_sym_TILDE] = ACTIONS(719),
    [anon_sym_void] = ACTIONS(735),
    [anon_sym_delete] = ACTIONS(735),
    [anon_sym_PLUS_PLUS] = ACTIONS(737),
    [anon_sym_DASH_DASH] = ACTIONS(737),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(713),
    [anon_sym_get] = ACTIONS(713),
    [anon_sym_set] = ACTIONS(713),
    [anon_sym_declare] = ACTIONS(713),
    [anon_sym_public] = ACTIONS(713),
    [anon_sym_private] = ACTIONS(713),
    [anon_sym_protected] = ACTIONS(713),
    [anon_sym_module] = ACTIONS(713),
    [anon_sym_any] = ACTIONS(713),
    [anon_sym_number] = ACTIONS(713),
    [anon_sym_boolean] = ACTIONS(713),
    [anon_sym_string] = ACTIONS(713),
    [anon_sym_symbol] = ACTIONS(713),
    [sym_readonly] = ACTIONS(713),
  },
  [303] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(884),
    [sym__expression] = STATE(1105),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1283),
    [sym_array] = STATE(1281),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3336),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(884),
    [sym_subscript_expression] = STATE(884),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1964),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(860),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(414),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(831),
    [anon_sym_export] = ACTIONS(503),
    [anon_sym_namespace] = ACTIONS(505),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_type] = ACTIONS(503),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(437),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(443),
    [anon_sym_yield] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(849),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(851),
    [anon_sym_TILDE] = ACTIONS(437),
    [anon_sym_void] = ACTIONS(471),
    [anon_sym_delete] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(473),
    [anon_sym_DASH_DASH] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(503),
    [anon_sym_get] = ACTIONS(503),
    [anon_sym_set] = ACTIONS(503),
    [anon_sym_declare] = ACTIONS(503),
    [anon_sym_public] = ACTIONS(503),
    [anon_sym_private] = ACTIONS(503),
    [anon_sym_protected] = ACTIONS(503),
    [anon_sym_module] = ACTIONS(503),
    [anon_sym_any] = ACTIONS(503),
    [anon_sym_number] = ACTIONS(503),
    [anon_sym_boolean] = ACTIONS(503),
    [anon_sym_string] = ACTIONS(503),
    [anon_sym_symbol] = ACTIONS(503),
    [sym_readonly] = ACTIONS(503),
  },
  [304] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(978),
    [sym__expression] = STATE(1490),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1696),
    [sym_array] = STATE(1691),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3169),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(978),
    [sym_subscript_expression] = STATE(978),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1967),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(977),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(380),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(881),
    [anon_sym_export] = ACTIONS(617),
    [anon_sym_namespace] = ACTIONS(619),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_type] = ACTIONS(617),
    [anon_sym_typeof] = ACTIONS(639),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(625),
    [anon_sym_yield] = ACTIONS(627),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(631),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(887),
    [anon_sym_PLUS] = ACTIONS(889),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(623),
    [anon_sym_void] = ACTIONS(639),
    [anon_sym_delete] = ACTIONS(639),
    [anon_sym_PLUS_PLUS] = ACTIONS(641),
    [anon_sym_DASH_DASH] = ACTIONS(641),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(617),
    [anon_sym_get] = ACTIONS(617),
    [anon_sym_set] = ACTIONS(617),
    [anon_sym_declare] = ACTIONS(617),
    [anon_sym_public] = ACTIONS(617),
    [anon_sym_private] = ACTIONS(617),
    [anon_sym_protected] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(617),
    [anon_sym_any] = ACTIONS(617),
    [anon_sym_number] = ACTIONS(617),
    [anon_sym_boolean] = ACTIONS(617),
    [anon_sym_string] = ACTIONS(617),
    [anon_sym_symbol] = ACTIONS(617),
    [sym_readonly] = ACTIONS(617),
  },
  [305] = {
    [sym_import] = STATE(1528),
    [sym_parenthesized_expression] = STATE(933),
    [sym__expression] = STATE(1203),
    [sym_yield_expression] = STATE(1543),
    [sym_object] = STATE(1367),
    [sym_array] = STATE(1369),
    [sym_class] = STATE(1528),
    [sym_function] = STATE(1528),
    [sym_generator_function] = STATE(1528),
    [sym_arrow_function] = STATE(1528),
    [sym__call_signature] = STATE(3359),
    [sym_call_expression] = STATE(1528),
    [sym_new_expression] = STATE(1543),
    [sym_await_expression] = STATE(1543),
    [sym_member_expression] = STATE(933),
    [sym_subscript_expression] = STATE(933),
    [sym_assignment_expression] = STATE(1543),
    [sym__augmented_assignment_lhs] = STATE(1970),
    [sym_augmented_assignment_expression] = STATE(1543),
    [sym_ternary_expression] = STATE(1543),
    [sym_binary_expression] = STATE(1543),
    [sym_unary_expression] = STATE(1543),
    [sym_update_expression] = STATE(1543),
    [sym_string] = STATE(1528),
    [sym_template_string] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_meta_property] = STATE(1528),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(936),
    [sym_type_assertion] = STATE(1543),
    [sym_as_expression] = STATE(1543),
    [sym_internal_module] = STATE(1543),
    [sym_type_arguments] = STATE(381),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2726),
    [sym_identifier] = ACTIONS(855),
    [anon_sym_export] = ACTIONS(745),
    [anon_sym_namespace] = ACTIONS(747),
    [anon_sym_LBRACE] = ACTIONS(859),
    [anon_sym_type] = ACTIONS(745),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(537),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(549),
    [anon_sym_async] = ACTIONS(753),
    [anon_sym_function] = ACTIONS(553),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(745),
    [anon_sym_get] = ACTIONS(745),
    [anon_sym_set] = ACTIONS(745),
    [anon_sym_declare] = ACTIONS(745),
    [anon_sym_public] = ACTIONS(745),
    [anon_sym_private] = ACTIONS(745),
    [anon_sym_protected] = ACTIONS(745),
    [anon_sym_module] = ACTIONS(745),
    [anon_sym_any] = ACTIONS(745),
    [anon_sym_number] = ACTIONS(745),
    [anon_sym_boolean] = ACTIONS(745),
    [anon_sym_string] = ACTIONS(745),
    [anon_sym_symbol] = ACTIONS(745),
    [sym_readonly] = ACTIONS(745),
  },
  [306] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(884),
    [sym__expression] = STATE(1106),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1283),
    [sym_array] = STATE(1281),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3336),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(884),
    [sym_subscript_expression] = STATE(884),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1964),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(860),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(414),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(831),
    [anon_sym_export] = ACTIONS(503),
    [anon_sym_namespace] = ACTIONS(505),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_type] = ACTIONS(503),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(437),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(443),
    [anon_sym_yield] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(849),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(851),
    [anon_sym_TILDE] = ACTIONS(437),
    [anon_sym_void] = ACTIONS(471),
    [anon_sym_delete] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(473),
    [anon_sym_DASH_DASH] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(503),
    [anon_sym_get] = ACTIONS(503),
    [anon_sym_set] = ACTIONS(503),
    [anon_sym_declare] = ACTIONS(503),
    [anon_sym_public] = ACTIONS(503),
    [anon_sym_private] = ACTIONS(503),
    [anon_sym_protected] = ACTIONS(503),
    [anon_sym_module] = ACTIONS(503),
    [anon_sym_any] = ACTIONS(503),
    [anon_sym_number] = ACTIONS(503),
    [anon_sym_boolean] = ACTIONS(503),
    [anon_sym_string] = ACTIONS(503),
    [anon_sym_symbol] = ACTIONS(503),
    [sym_readonly] = ACTIONS(503),
  },
  [307] = {
    [sym_import] = STATE(1528),
    [sym_parenthesized_expression] = STATE(933),
    [sym__expression] = STATE(1179),
    [sym_yield_expression] = STATE(1543),
    [sym_object] = STATE(1367),
    [sym_array] = STATE(1369),
    [sym_class] = STATE(1528),
    [sym_function] = STATE(1528),
    [sym_generator_function] = STATE(1528),
    [sym_arrow_function] = STATE(1528),
    [sym__call_signature] = STATE(3359),
    [sym_call_expression] = STATE(1528),
    [sym_new_expression] = STATE(1543),
    [sym_await_expression] = STATE(1543),
    [sym_member_expression] = STATE(933),
    [sym_subscript_expression] = STATE(933),
    [sym_assignment_expression] = STATE(1543),
    [sym__augmented_assignment_lhs] = STATE(1970),
    [sym_augmented_assignment_expression] = STATE(1543),
    [sym_ternary_expression] = STATE(1543),
    [sym_binary_expression] = STATE(1543),
    [sym_unary_expression] = STATE(1543),
    [sym_update_expression] = STATE(1543),
    [sym_string] = STATE(1528),
    [sym_template_string] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_meta_property] = STATE(1528),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(936),
    [sym_type_assertion] = STATE(1543),
    [sym_as_expression] = STATE(1543),
    [sym_internal_module] = STATE(1543),
    [sym_type_arguments] = STATE(381),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2726),
    [sym_identifier] = ACTIONS(855),
    [anon_sym_export] = ACTIONS(745),
    [anon_sym_namespace] = ACTIONS(747),
    [anon_sym_LBRACE] = ACTIONS(859),
    [anon_sym_type] = ACTIONS(745),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(537),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(549),
    [anon_sym_async] = ACTIONS(753),
    [anon_sym_function] = ACTIONS(553),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(745),
    [anon_sym_get] = ACTIONS(745),
    [anon_sym_set] = ACTIONS(745),
    [anon_sym_declare] = ACTIONS(745),
    [anon_sym_public] = ACTIONS(745),
    [anon_sym_private] = ACTIONS(745),
    [anon_sym_protected] = ACTIONS(745),
    [anon_sym_module] = ACTIONS(745),
    [anon_sym_any] = ACTIONS(745),
    [anon_sym_number] = ACTIONS(745),
    [anon_sym_boolean] = ACTIONS(745),
    [anon_sym_string] = ACTIONS(745),
    [anon_sym_symbol] = ACTIONS(745),
    [sym_readonly] = ACTIONS(745),
  },
  [308] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(963),
    [sym__expression] = STATE(1330),
    [sym_yield_expression] = STATE(1722),
    [sym_object] = STATE(1536),
    [sym_array] = STATE(1535),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(3286),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1722),
    [sym_await_expression] = STATE(1722),
    [sym_member_expression] = STATE(963),
    [sym_subscript_expression] = STATE(963),
    [sym_assignment_expression] = STATE(1722),
    [sym__augmented_assignment_lhs] = STATE(1968),
    [sym_augmented_assignment_expression] = STATE(1722),
    [sym_ternary_expression] = STATE(1722),
    [sym_binary_expression] = STATE(1722),
    [sym_unary_expression] = STATE(1722),
    [sym_update_expression] = STATE(1722),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(952),
    [sym_type_assertion] = STATE(1722),
    [sym_as_expression] = STATE(1722),
    [sym_internal_module] = STATE(1722),
    [sym_type_arguments] = STATE(266),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2684),
    [sym_identifier] = ACTIONS(863),
    [anon_sym_export] = ACTIONS(655),
    [anon_sym_namespace] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(1270),
    [anon_sym_type] = ACTIONS(655),
    [anon_sym_typeof] = ACTIONS(689),
    [anon_sym_import] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_LPAREN] = ACTIONS(871),
    [anon_sym_await] = ACTIONS(669),
    [anon_sym_yield] = ACTIONS(671),
    [anon_sym_LBRACK] = ACTIONS(873),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(675),
    [anon_sym_class] = ACTIONS(677),
    [anon_sym_async] = ACTIONS(679),
    [anon_sym_function] = ACTIONS(681),
    [anon_sym_new] = ACTIONS(875),
    [anon_sym_PLUS] = ACTIONS(877),
    [anon_sym_DASH] = ACTIONS(877),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_void] = ACTIONS(689),
    [anon_sym_delete] = ACTIONS(689),
    [anon_sym_PLUS_PLUS] = ACTIONS(691),
    [anon_sym_DASH_DASH] = ACTIONS(691),
    [anon_sym_DQUOTE] = ACTIONS(693),
    [anon_sym_SQUOTE] = ACTIONS(695),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(697),
    [sym_number] = ACTIONS(879),
    [sym_this] = ACTIONS(703),
    [sym_super] = ACTIONS(703),
    [sym_true] = ACTIONS(703),
    [sym_false] = ACTIONS(703),
    [sym_null] = ACTIONS(703),
    [sym_undefined] = ACTIONS(703),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(655),
    [anon_sym_get] = ACTIONS(655),
    [anon_sym_set] = ACTIONS(655),
    [anon_sym_declare] = ACTIONS(655),
    [anon_sym_public] = ACTIONS(655),
    [anon_sym_private] = ACTIONS(655),
    [anon_sym_protected] = ACTIONS(655),
    [anon_sym_module] = ACTIONS(655),
    [anon_sym_any] = ACTIONS(655),
    [anon_sym_number] = ACTIONS(655),
    [anon_sym_boolean] = ACTIONS(655),
    [anon_sym_string] = ACTIONS(655),
    [anon_sym_symbol] = ACTIONS(655),
    [sym_readonly] = ACTIONS(655),
  },
  [309] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(884),
    [sym__expression] = STATE(1107),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1283),
    [sym_array] = STATE(1281),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3336),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(884),
    [sym_subscript_expression] = STATE(884),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1964),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(860),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(414),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(831),
    [anon_sym_export] = ACTIONS(503),
    [anon_sym_namespace] = ACTIONS(505),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_type] = ACTIONS(503),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(437),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(443),
    [anon_sym_yield] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(849),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(851),
    [anon_sym_TILDE] = ACTIONS(437),
    [anon_sym_void] = ACTIONS(471),
    [anon_sym_delete] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(473),
    [anon_sym_DASH_DASH] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(503),
    [anon_sym_get] = ACTIONS(503),
    [anon_sym_set] = ACTIONS(503),
    [anon_sym_declare] = ACTIONS(503),
    [anon_sym_public] = ACTIONS(503),
    [anon_sym_private] = ACTIONS(503),
    [anon_sym_protected] = ACTIONS(503),
    [anon_sym_module] = ACTIONS(503),
    [anon_sym_any] = ACTIONS(503),
    [anon_sym_number] = ACTIONS(503),
    [anon_sym_boolean] = ACTIONS(503),
    [anon_sym_string] = ACTIONS(503),
    [anon_sym_symbol] = ACTIONS(503),
    [sym_readonly] = ACTIONS(503),
  },
  [310] = {
    [sym_import] = STATE(1528),
    [sym_parenthesized_expression] = STATE(983),
    [sym__expression] = STATE(1146),
    [sym_yield_expression] = STATE(1543),
    [sym_object] = STATE(1671),
    [sym_array] = STATE(1713),
    [sym_class] = STATE(1528),
    [sym_function] = STATE(1528),
    [sym_generator_function] = STATE(1528),
    [sym_arrow_function] = STATE(1528),
    [sym__call_signature] = STATE(3235),
    [sym_call_expression] = STATE(1528),
    [sym_new_expression] = STATE(1543),
    [sym_await_expression] = STATE(1543),
    [sym_member_expression] = STATE(983),
    [sym_subscript_expression] = STATE(983),
    [sym_assignment_expression] = STATE(1543),
    [sym__augmented_assignment_lhs] = STATE(1963),
    [sym_augmented_assignment_expression] = STATE(1543),
    [sym_ternary_expression] = STATE(1543),
    [sym_binary_expression] = STATE(1543),
    [sym_unary_expression] = STATE(1543),
    [sym_update_expression] = STATE(1543),
    [sym_string] = STATE(1528),
    [sym_template_string] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_meta_property] = STATE(1528),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(984),
    [sym_type_assertion] = STATE(1543),
    [sym_as_expression] = STATE(1543),
    [sym_internal_module] = STATE(1543),
    [sym_type_arguments] = STATE(310),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2726),
    [sym_identifier] = ACTIONS(891),
    [anon_sym_export] = ACTIONS(529),
    [anon_sym_namespace] = ACTIONS(531),
    [anon_sym_LBRACE] = ACTIONS(859),
    [anon_sym_type] = ACTIONS(529),
    [anon_sym_typeof] = ACTIONS(561),
    [anon_sym_import] = ACTIONS(537),
    [anon_sym_BANG] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(543),
    [anon_sym_yield] = ACTIONS(545),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(549),
    [anon_sym_async] = ACTIONS(551),
    [anon_sym_function] = ACTIONS(553),
    [anon_sym_new] = ACTIONS(897),
    [anon_sym_PLUS] = ACTIONS(899),
    [anon_sym_DASH] = ACTIONS(899),
    [anon_sym_TILDE] = ACTIONS(539),
    [anon_sym_void] = ACTIONS(561),
    [anon_sym_delete] = ACTIONS(561),
    [anon_sym_PLUS_PLUS] = ACTIONS(563),
    [anon_sym_DASH_DASH] = ACTIONS(563),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(529),
    [anon_sym_get] = ACTIONS(529),
    [anon_sym_set] = ACTIONS(529),
    [anon_sym_declare] = ACTIONS(529),
    [anon_sym_public] = ACTIONS(529),
    [anon_sym_private] = ACTIONS(529),
    [anon_sym_protected] = ACTIONS(529),
    [anon_sym_module] = ACTIONS(529),
    [anon_sym_any] = ACTIONS(529),
    [anon_sym_number] = ACTIONS(529),
    [anon_sym_boolean] = ACTIONS(529),
    [anon_sym_string] = ACTIONS(529),
    [anon_sym_symbol] = ACTIONS(529),
    [sym_readonly] = ACTIONS(529),
  },
  [311] = {
    [sym_import] = STATE(1528),
    [sym_parenthesized_expression] = STATE(933),
    [sym__expression] = STATE(1148),
    [sym_yield_expression] = STATE(1543),
    [sym_object] = STATE(1367),
    [sym_array] = STATE(1369),
    [sym_class] = STATE(1528),
    [sym_function] = STATE(1528),
    [sym_generator_function] = STATE(1528),
    [sym_arrow_function] = STATE(1528),
    [sym__call_signature] = STATE(3359),
    [sym_call_expression] = STATE(1528),
    [sym_new_expression] = STATE(1543),
    [sym_await_expression] = STATE(1543),
    [sym_member_expression] = STATE(933),
    [sym_subscript_expression] = STATE(933),
    [sym_assignment_expression] = STATE(1543),
    [sym__augmented_assignment_lhs] = STATE(1970),
    [sym_augmented_assignment_expression] = STATE(1543),
    [sym_ternary_expression] = STATE(1543),
    [sym_binary_expression] = STATE(1543),
    [sym_unary_expression] = STATE(1543),
    [sym_update_expression] = STATE(1543),
    [sym_string] = STATE(1528),
    [sym_template_string] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_meta_property] = STATE(1528),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(936),
    [sym_type_assertion] = STATE(1543),
    [sym_as_expression] = STATE(1543),
    [sym_internal_module] = STATE(1543),
    [sym_type_arguments] = STATE(381),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2726),
    [sym_identifier] = ACTIONS(855),
    [anon_sym_export] = ACTIONS(745),
    [anon_sym_namespace] = ACTIONS(747),
    [anon_sym_LBRACE] = ACTIONS(859),
    [anon_sym_type] = ACTIONS(745),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(537),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(549),
    [anon_sym_async] = ACTIONS(753),
    [anon_sym_function] = ACTIONS(553),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(745),
    [anon_sym_get] = ACTIONS(745),
    [anon_sym_set] = ACTIONS(745),
    [anon_sym_declare] = ACTIONS(745),
    [anon_sym_public] = ACTIONS(745),
    [anon_sym_private] = ACTIONS(745),
    [anon_sym_protected] = ACTIONS(745),
    [anon_sym_module] = ACTIONS(745),
    [anon_sym_any] = ACTIONS(745),
    [anon_sym_number] = ACTIONS(745),
    [anon_sym_boolean] = ACTIONS(745),
    [anon_sym_string] = ACTIONS(745),
    [anon_sym_symbol] = ACTIONS(745),
    [sym_readonly] = ACTIONS(745),
  },
  [312] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(978),
    [sym__expression] = STATE(1486),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1696),
    [sym_array] = STATE(1691),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3169),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(978),
    [sym_subscript_expression] = STATE(978),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1967),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(977),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(380),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(881),
    [anon_sym_export] = ACTIONS(617),
    [anon_sym_namespace] = ACTIONS(619),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_type] = ACTIONS(617),
    [anon_sym_typeof] = ACTIONS(639),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(625),
    [anon_sym_yield] = ACTIONS(627),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(631),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(887),
    [anon_sym_PLUS] = ACTIONS(889),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(623),
    [anon_sym_void] = ACTIONS(639),
    [anon_sym_delete] = ACTIONS(639),
    [anon_sym_PLUS_PLUS] = ACTIONS(641),
    [anon_sym_DASH_DASH] = ACTIONS(641),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(617),
    [anon_sym_get] = ACTIONS(617),
    [anon_sym_set] = ACTIONS(617),
    [anon_sym_declare] = ACTIONS(617),
    [anon_sym_public] = ACTIONS(617),
    [anon_sym_private] = ACTIONS(617),
    [anon_sym_protected] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(617),
    [anon_sym_any] = ACTIONS(617),
    [anon_sym_number] = ACTIONS(617),
    [anon_sym_boolean] = ACTIONS(617),
    [anon_sym_string] = ACTIONS(617),
    [anon_sym_symbol] = ACTIONS(617),
    [sym_readonly] = ACTIONS(617),
  },
  [313] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(965),
    [sym__expression] = STATE(1260),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1524),
    [sym_array] = STATE(1523),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3348),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(965),
    [sym_subscript_expression] = STATE(965),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1969),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(975),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(302),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(901),
    [anon_sym_export] = ACTIONS(713),
    [anon_sym_namespace] = ACTIONS(715),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_type] = ACTIONS(713),
    [anon_sym_typeof] = ACTIONS(735),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(719),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(721),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(725),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(727),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(907),
    [anon_sym_PLUS] = ACTIONS(909),
    [anon_sym_DASH] = ACTIONS(909),
    [anon_sym_TILDE] = ACTIONS(719),
    [anon_sym_void] = ACTIONS(735),
    [anon_sym_delete] = ACTIONS(735),
    [anon_sym_PLUS_PLUS] = ACTIONS(737),
    [anon_sym_DASH_DASH] = ACTIONS(737),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(713),
    [anon_sym_get] = ACTIONS(713),
    [anon_sym_set] = ACTIONS(713),
    [anon_sym_declare] = ACTIONS(713),
    [anon_sym_public] = ACTIONS(713),
    [anon_sym_private] = ACTIONS(713),
    [anon_sym_protected] = ACTIONS(713),
    [anon_sym_module] = ACTIONS(713),
    [anon_sym_any] = ACTIONS(713),
    [anon_sym_number] = ACTIONS(713),
    [anon_sym_boolean] = ACTIONS(713),
    [anon_sym_string] = ACTIONS(713),
    [anon_sym_symbol] = ACTIONS(713),
    [sym_readonly] = ACTIONS(713),
  },
  [314] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(965),
    [sym__expression] = STATE(1301),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1524),
    [sym_array] = STATE(1523),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3348),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(965),
    [sym_subscript_expression] = STATE(965),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1969),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(975),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(302),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(901),
    [anon_sym_export] = ACTIONS(713),
    [anon_sym_namespace] = ACTIONS(715),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_type] = ACTIONS(713),
    [anon_sym_typeof] = ACTIONS(735),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(719),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(721),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(725),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(727),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(907),
    [anon_sym_PLUS] = ACTIONS(909),
    [anon_sym_DASH] = ACTIONS(909),
    [anon_sym_TILDE] = ACTIONS(719),
    [anon_sym_void] = ACTIONS(735),
    [anon_sym_delete] = ACTIONS(735),
    [anon_sym_PLUS_PLUS] = ACTIONS(737),
    [anon_sym_DASH_DASH] = ACTIONS(737),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(713),
    [anon_sym_get] = ACTIONS(713),
    [anon_sym_set] = ACTIONS(713),
    [anon_sym_declare] = ACTIONS(713),
    [anon_sym_public] = ACTIONS(713),
    [anon_sym_private] = ACTIONS(713),
    [anon_sym_protected] = ACTIONS(713),
    [anon_sym_module] = ACTIONS(713),
    [anon_sym_any] = ACTIONS(713),
    [anon_sym_number] = ACTIONS(713),
    [anon_sym_boolean] = ACTIONS(713),
    [anon_sym_string] = ACTIONS(713),
    [anon_sym_symbol] = ACTIONS(713),
    [sym_readonly] = ACTIONS(713),
  },
  [315] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(963),
    [sym__expression] = STATE(1275),
    [sym_yield_expression] = STATE(1722),
    [sym_object] = STATE(1536),
    [sym_array] = STATE(1535),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(3286),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1722),
    [sym_await_expression] = STATE(1722),
    [sym_member_expression] = STATE(963),
    [sym_subscript_expression] = STATE(963),
    [sym_assignment_expression] = STATE(1722),
    [sym__augmented_assignment_lhs] = STATE(1968),
    [sym_augmented_assignment_expression] = STATE(1722),
    [sym_ternary_expression] = STATE(1722),
    [sym_binary_expression] = STATE(1722),
    [sym_unary_expression] = STATE(1722),
    [sym_update_expression] = STATE(1722),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(952),
    [sym_type_assertion] = STATE(1722),
    [sym_as_expression] = STATE(1722),
    [sym_internal_module] = STATE(1722),
    [sym_type_arguments] = STATE(266),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2684),
    [sym_identifier] = ACTIONS(863),
    [anon_sym_export] = ACTIONS(655),
    [anon_sym_namespace] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(1270),
    [anon_sym_type] = ACTIONS(655),
    [anon_sym_typeof] = ACTIONS(689),
    [anon_sym_import] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_LPAREN] = ACTIONS(871),
    [anon_sym_await] = ACTIONS(669),
    [anon_sym_yield] = ACTIONS(671),
    [anon_sym_LBRACK] = ACTIONS(873),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(675),
    [anon_sym_class] = ACTIONS(677),
    [anon_sym_async] = ACTIONS(679),
    [anon_sym_function] = ACTIONS(681),
    [anon_sym_new] = ACTIONS(875),
    [anon_sym_PLUS] = ACTIONS(877),
    [anon_sym_DASH] = ACTIONS(877),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_void] = ACTIONS(689),
    [anon_sym_delete] = ACTIONS(689),
    [anon_sym_PLUS_PLUS] = ACTIONS(691),
    [anon_sym_DASH_DASH] = ACTIONS(691),
    [anon_sym_DQUOTE] = ACTIONS(693),
    [anon_sym_SQUOTE] = ACTIONS(695),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(697),
    [sym_number] = ACTIONS(879),
    [sym_this] = ACTIONS(703),
    [sym_super] = ACTIONS(703),
    [sym_true] = ACTIONS(703),
    [sym_false] = ACTIONS(703),
    [sym_null] = ACTIONS(703),
    [sym_undefined] = ACTIONS(703),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(655),
    [anon_sym_get] = ACTIONS(655),
    [anon_sym_set] = ACTIONS(655),
    [anon_sym_declare] = ACTIONS(655),
    [anon_sym_public] = ACTIONS(655),
    [anon_sym_private] = ACTIONS(655),
    [anon_sym_protected] = ACTIONS(655),
    [anon_sym_module] = ACTIONS(655),
    [anon_sym_any] = ACTIONS(655),
    [anon_sym_number] = ACTIONS(655),
    [anon_sym_boolean] = ACTIONS(655),
    [anon_sym_string] = ACTIONS(655),
    [anon_sym_symbol] = ACTIONS(655),
    [sym_readonly] = ACTIONS(655),
  },
  [316] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(884),
    [sym__expression] = STATE(1412),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1283),
    [sym_array] = STATE(1281),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3336),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(884),
    [sym_subscript_expression] = STATE(884),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1964),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(860),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(414),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(1499),
    [anon_sym_export] = ACTIONS(503),
    [anon_sym_namespace] = ACTIONS(505),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_type] = ACTIONS(503),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(437),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(443),
    [anon_sym_yield] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(849),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(851),
    [anon_sym_TILDE] = ACTIONS(437),
    [anon_sym_void] = ACTIONS(471),
    [anon_sym_delete] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(473),
    [anon_sym_DASH_DASH] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(503),
    [anon_sym_get] = ACTIONS(503),
    [anon_sym_set] = ACTIONS(503),
    [anon_sym_declare] = ACTIONS(503),
    [anon_sym_public] = ACTIONS(503),
    [anon_sym_private] = ACTIONS(503),
    [anon_sym_protected] = ACTIONS(503),
    [anon_sym_module] = ACTIONS(503),
    [anon_sym_any] = ACTIONS(503),
    [anon_sym_number] = ACTIONS(503),
    [anon_sym_boolean] = ACTIONS(503),
    [anon_sym_string] = ACTIONS(503),
    [anon_sym_symbol] = ACTIONS(503),
    [sym_readonly] = ACTIONS(503),
  },
  [317] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(965),
    [sym__expression] = STATE(1250),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1524),
    [sym_array] = STATE(1523),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3348),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(965),
    [sym_subscript_expression] = STATE(965),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1969),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(975),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(302),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(901),
    [anon_sym_export] = ACTIONS(713),
    [anon_sym_namespace] = ACTIONS(715),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_type] = ACTIONS(713),
    [anon_sym_typeof] = ACTIONS(735),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(719),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(721),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(725),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(727),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(907),
    [anon_sym_PLUS] = ACTIONS(909),
    [anon_sym_DASH] = ACTIONS(909),
    [anon_sym_TILDE] = ACTIONS(719),
    [anon_sym_void] = ACTIONS(735),
    [anon_sym_delete] = ACTIONS(735),
    [anon_sym_PLUS_PLUS] = ACTIONS(737),
    [anon_sym_DASH_DASH] = ACTIONS(737),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(713),
    [anon_sym_get] = ACTIONS(713),
    [anon_sym_set] = ACTIONS(713),
    [anon_sym_declare] = ACTIONS(713),
    [anon_sym_public] = ACTIONS(713),
    [anon_sym_private] = ACTIONS(713),
    [anon_sym_protected] = ACTIONS(713),
    [anon_sym_module] = ACTIONS(713),
    [anon_sym_any] = ACTIONS(713),
    [anon_sym_number] = ACTIONS(713),
    [anon_sym_boolean] = ACTIONS(713),
    [anon_sym_string] = ACTIONS(713),
    [anon_sym_symbol] = ACTIONS(713),
    [sym_readonly] = ACTIONS(713),
  },
  [318] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(963),
    [sym__expression] = STATE(1274),
    [sym_yield_expression] = STATE(1722),
    [sym_object] = STATE(1536),
    [sym_array] = STATE(1535),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(3286),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1722),
    [sym_await_expression] = STATE(1722),
    [sym_member_expression] = STATE(963),
    [sym_subscript_expression] = STATE(963),
    [sym_assignment_expression] = STATE(1722),
    [sym__augmented_assignment_lhs] = STATE(1968),
    [sym_augmented_assignment_expression] = STATE(1722),
    [sym_ternary_expression] = STATE(1722),
    [sym_binary_expression] = STATE(1722),
    [sym_unary_expression] = STATE(1722),
    [sym_update_expression] = STATE(1722),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(952),
    [sym_type_assertion] = STATE(1722),
    [sym_as_expression] = STATE(1722),
    [sym_internal_module] = STATE(1722),
    [sym_type_arguments] = STATE(266),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2684),
    [sym_identifier] = ACTIONS(863),
    [anon_sym_export] = ACTIONS(655),
    [anon_sym_namespace] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(1270),
    [anon_sym_type] = ACTIONS(655),
    [anon_sym_typeof] = ACTIONS(689),
    [anon_sym_import] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_LPAREN] = ACTIONS(871),
    [anon_sym_await] = ACTIONS(669),
    [anon_sym_yield] = ACTIONS(671),
    [anon_sym_LBRACK] = ACTIONS(873),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(675),
    [anon_sym_class] = ACTIONS(677),
    [anon_sym_async] = ACTIONS(679),
    [anon_sym_function] = ACTIONS(681),
    [anon_sym_new] = ACTIONS(875),
    [anon_sym_PLUS] = ACTIONS(877),
    [anon_sym_DASH] = ACTIONS(877),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_void] = ACTIONS(689),
    [anon_sym_delete] = ACTIONS(689),
    [anon_sym_PLUS_PLUS] = ACTIONS(691),
    [anon_sym_DASH_DASH] = ACTIONS(691),
    [anon_sym_DQUOTE] = ACTIONS(693),
    [anon_sym_SQUOTE] = ACTIONS(695),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(697),
    [sym_number] = ACTIONS(879),
    [sym_this] = ACTIONS(703),
    [sym_super] = ACTIONS(703),
    [sym_true] = ACTIONS(703),
    [sym_false] = ACTIONS(703),
    [sym_null] = ACTIONS(703),
    [sym_undefined] = ACTIONS(703),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(655),
    [anon_sym_get] = ACTIONS(655),
    [anon_sym_set] = ACTIONS(655),
    [anon_sym_declare] = ACTIONS(655),
    [anon_sym_public] = ACTIONS(655),
    [anon_sym_private] = ACTIONS(655),
    [anon_sym_protected] = ACTIONS(655),
    [anon_sym_module] = ACTIONS(655),
    [anon_sym_any] = ACTIONS(655),
    [anon_sym_number] = ACTIONS(655),
    [anon_sym_boolean] = ACTIONS(655),
    [anon_sym_string] = ACTIONS(655),
    [anon_sym_symbol] = ACTIONS(655),
    [sym_readonly] = ACTIONS(655),
  },
  [319] = {
    [sym_import] = STATE(1528),
    [sym_parenthesized_expression] = STATE(933),
    [sym__expression] = STATE(1211),
    [sym_yield_expression] = STATE(1543),
    [sym_object] = STATE(1367),
    [sym_array] = STATE(1369),
    [sym_class] = STATE(1528),
    [sym_function] = STATE(1528),
    [sym_generator_function] = STATE(1528),
    [sym_arrow_function] = STATE(1528),
    [sym__call_signature] = STATE(3359),
    [sym_call_expression] = STATE(1528),
    [sym_new_expression] = STATE(1543),
    [sym_await_expression] = STATE(1543),
    [sym_member_expression] = STATE(933),
    [sym_subscript_expression] = STATE(933),
    [sym_assignment_expression] = STATE(1543),
    [sym__augmented_assignment_lhs] = STATE(1970),
    [sym_augmented_assignment_expression] = STATE(1543),
    [sym_ternary_expression] = STATE(1543),
    [sym_binary_expression] = STATE(1543),
    [sym_unary_expression] = STATE(1543),
    [sym_update_expression] = STATE(1543),
    [sym_string] = STATE(1528),
    [sym_template_string] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_meta_property] = STATE(1528),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(936),
    [sym_type_assertion] = STATE(1543),
    [sym_as_expression] = STATE(1543),
    [sym_internal_module] = STATE(1543),
    [sym_type_arguments] = STATE(381),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2726),
    [sym_identifier] = ACTIONS(855),
    [anon_sym_export] = ACTIONS(745),
    [anon_sym_namespace] = ACTIONS(747),
    [anon_sym_LBRACE] = ACTIONS(859),
    [anon_sym_type] = ACTIONS(745),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(537),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(549),
    [anon_sym_async] = ACTIONS(753),
    [anon_sym_function] = ACTIONS(553),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(745),
    [anon_sym_get] = ACTIONS(745),
    [anon_sym_set] = ACTIONS(745),
    [anon_sym_declare] = ACTIONS(745),
    [anon_sym_public] = ACTIONS(745),
    [anon_sym_private] = ACTIONS(745),
    [anon_sym_protected] = ACTIONS(745),
    [anon_sym_module] = ACTIONS(745),
    [anon_sym_any] = ACTIONS(745),
    [anon_sym_number] = ACTIONS(745),
    [anon_sym_boolean] = ACTIONS(745),
    [anon_sym_string] = ACTIONS(745),
    [anon_sym_symbol] = ACTIONS(745),
    [sym_readonly] = ACTIONS(745),
  },
  [320] = {
    [sym_import] = STATE(1528),
    [sym_parenthesized_expression] = STATE(983),
    [sym__expression] = STATE(1179),
    [sym_yield_expression] = STATE(1543),
    [sym_object] = STATE(1671),
    [sym_array] = STATE(1713),
    [sym_class] = STATE(1528),
    [sym_function] = STATE(1528),
    [sym_generator_function] = STATE(1528),
    [sym_arrow_function] = STATE(1528),
    [sym__call_signature] = STATE(3235),
    [sym_call_expression] = STATE(1528),
    [sym_new_expression] = STATE(1543),
    [sym_await_expression] = STATE(1543),
    [sym_member_expression] = STATE(983),
    [sym_subscript_expression] = STATE(983),
    [sym_assignment_expression] = STATE(1543),
    [sym__augmented_assignment_lhs] = STATE(1963),
    [sym_augmented_assignment_expression] = STATE(1543),
    [sym_ternary_expression] = STATE(1543),
    [sym_binary_expression] = STATE(1543),
    [sym_unary_expression] = STATE(1543),
    [sym_update_expression] = STATE(1543),
    [sym_string] = STATE(1528),
    [sym_template_string] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_meta_property] = STATE(1528),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(984),
    [sym_type_assertion] = STATE(1543),
    [sym_as_expression] = STATE(1543),
    [sym_internal_module] = STATE(1543),
    [sym_type_arguments] = STATE(310),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2726),
    [sym_identifier] = ACTIONS(891),
    [anon_sym_export] = ACTIONS(529),
    [anon_sym_namespace] = ACTIONS(531),
    [anon_sym_LBRACE] = ACTIONS(859),
    [anon_sym_type] = ACTIONS(529),
    [anon_sym_typeof] = ACTIONS(561),
    [anon_sym_import] = ACTIONS(537),
    [anon_sym_BANG] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(543),
    [anon_sym_yield] = ACTIONS(545),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(549),
    [anon_sym_async] = ACTIONS(551),
    [anon_sym_function] = ACTIONS(553),
    [anon_sym_new] = ACTIONS(897),
    [anon_sym_PLUS] = ACTIONS(899),
    [anon_sym_DASH] = ACTIONS(899),
    [anon_sym_TILDE] = ACTIONS(539),
    [anon_sym_void] = ACTIONS(561),
    [anon_sym_delete] = ACTIONS(561),
    [anon_sym_PLUS_PLUS] = ACTIONS(563),
    [anon_sym_DASH_DASH] = ACTIONS(563),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(529),
    [anon_sym_get] = ACTIONS(529),
    [anon_sym_set] = ACTIONS(529),
    [anon_sym_declare] = ACTIONS(529),
    [anon_sym_public] = ACTIONS(529),
    [anon_sym_private] = ACTIONS(529),
    [anon_sym_protected] = ACTIONS(529),
    [anon_sym_module] = ACTIONS(529),
    [anon_sym_any] = ACTIONS(529),
    [anon_sym_number] = ACTIONS(529),
    [anon_sym_boolean] = ACTIONS(529),
    [anon_sym_string] = ACTIONS(529),
    [anon_sym_symbol] = ACTIONS(529),
    [sym_readonly] = ACTIONS(529),
  },
  [321] = {
    [sym_import] = STATE(1528),
    [sym_parenthesized_expression] = STATE(983),
    [sym__expression] = STATE(1362),
    [sym_yield_expression] = STATE(1543),
    [sym_object] = STATE(1671),
    [sym_array] = STATE(1713),
    [sym_class] = STATE(1528),
    [sym_function] = STATE(1528),
    [sym_generator_function] = STATE(1528),
    [sym_arrow_function] = STATE(1528),
    [sym__call_signature] = STATE(3235),
    [sym_call_expression] = STATE(1528),
    [sym_new_expression] = STATE(1543),
    [sym_await_expression] = STATE(1543),
    [sym_member_expression] = STATE(983),
    [sym_subscript_expression] = STATE(983),
    [sym_assignment_expression] = STATE(1543),
    [sym__augmented_assignment_lhs] = STATE(1963),
    [sym_augmented_assignment_expression] = STATE(1543),
    [sym_ternary_expression] = STATE(1543),
    [sym_binary_expression] = STATE(1543),
    [sym_unary_expression] = STATE(1543),
    [sym_update_expression] = STATE(1543),
    [sym_string] = STATE(1528),
    [sym_template_string] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_meta_property] = STATE(1528),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(984),
    [sym_type_assertion] = STATE(1543),
    [sym_as_expression] = STATE(1543),
    [sym_internal_module] = STATE(1543),
    [sym_type_arguments] = STATE(310),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2726),
    [sym_identifier] = ACTIONS(891),
    [anon_sym_export] = ACTIONS(529),
    [anon_sym_namespace] = ACTIONS(531),
    [anon_sym_LBRACE] = ACTIONS(859),
    [anon_sym_type] = ACTIONS(529),
    [anon_sym_typeof] = ACTIONS(561),
    [anon_sym_import] = ACTIONS(537),
    [anon_sym_BANG] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(543),
    [anon_sym_yield] = ACTIONS(545),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(549),
    [anon_sym_async] = ACTIONS(551),
    [anon_sym_function] = ACTIONS(553),
    [anon_sym_new] = ACTIONS(897),
    [anon_sym_PLUS] = ACTIONS(899),
    [anon_sym_DASH] = ACTIONS(899),
    [anon_sym_TILDE] = ACTIONS(539),
    [anon_sym_void] = ACTIONS(561),
    [anon_sym_delete] = ACTIONS(561),
    [anon_sym_PLUS_PLUS] = ACTIONS(563),
    [anon_sym_DASH_DASH] = ACTIONS(563),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(529),
    [anon_sym_get] = ACTIONS(529),
    [anon_sym_set] = ACTIONS(529),
    [anon_sym_declare] = ACTIONS(529),
    [anon_sym_public] = ACTIONS(529),
    [anon_sym_private] = ACTIONS(529),
    [anon_sym_protected] = ACTIONS(529),
    [anon_sym_module] = ACTIONS(529),
    [anon_sym_any] = ACTIONS(529),
    [anon_sym_number] = ACTIONS(529),
    [anon_sym_boolean] = ACTIONS(529),
    [anon_sym_string] = ACTIONS(529),
    [anon_sym_symbol] = ACTIONS(529),
    [sym_readonly] = ACTIONS(529),
  },
  [322] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(978),
    [sym__expression] = STATE(1483),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1696),
    [sym_array] = STATE(1691),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3169),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(978),
    [sym_subscript_expression] = STATE(978),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1967),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(977),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(380),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(881),
    [anon_sym_export] = ACTIONS(617),
    [anon_sym_namespace] = ACTIONS(619),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_type] = ACTIONS(617),
    [anon_sym_typeof] = ACTIONS(639),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(625),
    [anon_sym_yield] = ACTIONS(627),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(631),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(887),
    [anon_sym_PLUS] = ACTIONS(889),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(623),
    [anon_sym_void] = ACTIONS(639),
    [anon_sym_delete] = ACTIONS(639),
    [anon_sym_PLUS_PLUS] = ACTIONS(641),
    [anon_sym_DASH_DASH] = ACTIONS(641),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(617),
    [anon_sym_get] = ACTIONS(617),
    [anon_sym_set] = ACTIONS(617),
    [anon_sym_declare] = ACTIONS(617),
    [anon_sym_public] = ACTIONS(617),
    [anon_sym_private] = ACTIONS(617),
    [anon_sym_protected] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(617),
    [anon_sym_any] = ACTIONS(617),
    [anon_sym_number] = ACTIONS(617),
    [anon_sym_boolean] = ACTIONS(617),
    [anon_sym_string] = ACTIONS(617),
    [anon_sym_symbol] = ACTIONS(617),
    [sym_readonly] = ACTIONS(617),
  },
  [323] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(965),
    [sym__expression] = STATE(1020),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1524),
    [sym_array] = STATE(1523),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3348),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(965),
    [sym_subscript_expression] = STATE(965),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1969),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(975),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(302),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(901),
    [anon_sym_export] = ACTIONS(713),
    [anon_sym_namespace] = ACTIONS(715),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_type] = ACTIONS(713),
    [anon_sym_typeof] = ACTIONS(735),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(719),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(721),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(725),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(727),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(907),
    [anon_sym_PLUS] = ACTIONS(909),
    [anon_sym_DASH] = ACTIONS(909),
    [anon_sym_TILDE] = ACTIONS(719),
    [anon_sym_void] = ACTIONS(735),
    [anon_sym_delete] = ACTIONS(735),
    [anon_sym_PLUS_PLUS] = ACTIONS(737),
    [anon_sym_DASH_DASH] = ACTIONS(737),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(713),
    [anon_sym_get] = ACTIONS(713),
    [anon_sym_set] = ACTIONS(713),
    [anon_sym_declare] = ACTIONS(713),
    [anon_sym_public] = ACTIONS(713),
    [anon_sym_private] = ACTIONS(713),
    [anon_sym_protected] = ACTIONS(713),
    [anon_sym_module] = ACTIONS(713),
    [anon_sym_any] = ACTIONS(713),
    [anon_sym_number] = ACTIONS(713),
    [anon_sym_boolean] = ACTIONS(713),
    [anon_sym_string] = ACTIONS(713),
    [anon_sym_symbol] = ACTIONS(713),
    [sym_readonly] = ACTIONS(713),
  },
  [324] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(965),
    [sym__expression] = STATE(1247),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1524),
    [sym_array] = STATE(1523),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3348),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(965),
    [sym_subscript_expression] = STATE(965),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1969),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(975),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(302),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(901),
    [anon_sym_export] = ACTIONS(713),
    [anon_sym_namespace] = ACTIONS(715),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_type] = ACTIONS(713),
    [anon_sym_typeof] = ACTIONS(735),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(719),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(721),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(725),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(727),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(907),
    [anon_sym_PLUS] = ACTIONS(909),
    [anon_sym_DASH] = ACTIONS(909),
    [anon_sym_TILDE] = ACTIONS(719),
    [anon_sym_void] = ACTIONS(735),
    [anon_sym_delete] = ACTIONS(735),
    [anon_sym_PLUS_PLUS] = ACTIONS(737),
    [anon_sym_DASH_DASH] = ACTIONS(737),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(713),
    [anon_sym_get] = ACTIONS(713),
    [anon_sym_set] = ACTIONS(713),
    [anon_sym_declare] = ACTIONS(713),
    [anon_sym_public] = ACTIONS(713),
    [anon_sym_private] = ACTIONS(713),
    [anon_sym_protected] = ACTIONS(713),
    [anon_sym_module] = ACTIONS(713),
    [anon_sym_any] = ACTIONS(713),
    [anon_sym_number] = ACTIONS(713),
    [anon_sym_boolean] = ACTIONS(713),
    [anon_sym_string] = ACTIONS(713),
    [anon_sym_symbol] = ACTIONS(713),
    [sym_readonly] = ACTIONS(713),
  },
  [325] = {
    [sym_import] = STATE(1528),
    [sym_parenthesized_expression] = STATE(983),
    [sym__expression] = STATE(1404),
    [sym_yield_expression] = STATE(1543),
    [sym_object] = STATE(1671),
    [sym_array] = STATE(1713),
    [sym_class] = STATE(1528),
    [sym_function] = STATE(1528),
    [sym_generator_function] = STATE(1528),
    [sym_arrow_function] = STATE(1528),
    [sym__call_signature] = STATE(3235),
    [sym_call_expression] = STATE(1528),
    [sym_new_expression] = STATE(1543),
    [sym_await_expression] = STATE(1543),
    [sym_member_expression] = STATE(983),
    [sym_subscript_expression] = STATE(983),
    [sym_assignment_expression] = STATE(1543),
    [sym__augmented_assignment_lhs] = STATE(1963),
    [sym_augmented_assignment_expression] = STATE(1543),
    [sym_ternary_expression] = STATE(1543),
    [sym_binary_expression] = STATE(1543),
    [sym_unary_expression] = STATE(1543),
    [sym_update_expression] = STATE(1543),
    [sym_string] = STATE(1528),
    [sym_template_string] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_meta_property] = STATE(1528),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(984),
    [sym_type_assertion] = STATE(1543),
    [sym_as_expression] = STATE(1543),
    [sym_internal_module] = STATE(1543),
    [sym_type_arguments] = STATE(310),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2726),
    [sym_identifier] = ACTIONS(891),
    [anon_sym_export] = ACTIONS(529),
    [anon_sym_namespace] = ACTIONS(531),
    [anon_sym_LBRACE] = ACTIONS(859),
    [anon_sym_type] = ACTIONS(529),
    [anon_sym_typeof] = ACTIONS(561),
    [anon_sym_import] = ACTIONS(537),
    [anon_sym_BANG] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(543),
    [anon_sym_yield] = ACTIONS(545),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(549),
    [anon_sym_async] = ACTIONS(551),
    [anon_sym_function] = ACTIONS(553),
    [anon_sym_new] = ACTIONS(897),
    [anon_sym_PLUS] = ACTIONS(899),
    [anon_sym_DASH] = ACTIONS(899),
    [anon_sym_TILDE] = ACTIONS(539),
    [anon_sym_void] = ACTIONS(561),
    [anon_sym_delete] = ACTIONS(561),
    [anon_sym_PLUS_PLUS] = ACTIONS(563),
    [anon_sym_DASH_DASH] = ACTIONS(563),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(529),
    [anon_sym_get] = ACTIONS(529),
    [anon_sym_set] = ACTIONS(529),
    [anon_sym_declare] = ACTIONS(529),
    [anon_sym_public] = ACTIONS(529),
    [anon_sym_private] = ACTIONS(529),
    [anon_sym_protected] = ACTIONS(529),
    [anon_sym_module] = ACTIONS(529),
    [anon_sym_any] = ACTIONS(529),
    [anon_sym_number] = ACTIONS(529),
    [anon_sym_boolean] = ACTIONS(529),
    [anon_sym_string] = ACTIONS(529),
    [anon_sym_symbol] = ACTIONS(529),
    [sym_readonly] = ACTIONS(529),
  },
  [326] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(963),
    [sym__expression] = STATE(1267),
    [sym_yield_expression] = STATE(1722),
    [sym_object] = STATE(1536),
    [sym_array] = STATE(1535),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(3286),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1722),
    [sym_await_expression] = STATE(1722),
    [sym_member_expression] = STATE(963),
    [sym_subscript_expression] = STATE(963),
    [sym_assignment_expression] = STATE(1722),
    [sym__augmented_assignment_lhs] = STATE(1968),
    [sym_augmented_assignment_expression] = STATE(1722),
    [sym_ternary_expression] = STATE(1722),
    [sym_binary_expression] = STATE(1722),
    [sym_unary_expression] = STATE(1722),
    [sym_update_expression] = STATE(1722),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(952),
    [sym_type_assertion] = STATE(1722),
    [sym_as_expression] = STATE(1722),
    [sym_internal_module] = STATE(1722),
    [sym_type_arguments] = STATE(266),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2684),
    [sym_identifier] = ACTIONS(863),
    [anon_sym_export] = ACTIONS(655),
    [anon_sym_namespace] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(1270),
    [anon_sym_type] = ACTIONS(655),
    [anon_sym_typeof] = ACTIONS(689),
    [anon_sym_import] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_LPAREN] = ACTIONS(871),
    [anon_sym_await] = ACTIONS(669),
    [anon_sym_yield] = ACTIONS(671),
    [anon_sym_LBRACK] = ACTIONS(873),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(675),
    [anon_sym_class] = ACTIONS(677),
    [anon_sym_async] = ACTIONS(679),
    [anon_sym_function] = ACTIONS(681),
    [anon_sym_new] = ACTIONS(875),
    [anon_sym_PLUS] = ACTIONS(877),
    [anon_sym_DASH] = ACTIONS(877),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_void] = ACTIONS(689),
    [anon_sym_delete] = ACTIONS(689),
    [anon_sym_PLUS_PLUS] = ACTIONS(691),
    [anon_sym_DASH_DASH] = ACTIONS(691),
    [anon_sym_DQUOTE] = ACTIONS(693),
    [anon_sym_SQUOTE] = ACTIONS(695),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(697),
    [sym_number] = ACTIONS(879),
    [sym_this] = ACTIONS(703),
    [sym_super] = ACTIONS(703),
    [sym_true] = ACTIONS(703),
    [sym_false] = ACTIONS(703),
    [sym_null] = ACTIONS(703),
    [sym_undefined] = ACTIONS(703),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(655),
    [anon_sym_get] = ACTIONS(655),
    [anon_sym_set] = ACTIONS(655),
    [anon_sym_declare] = ACTIONS(655),
    [anon_sym_public] = ACTIONS(655),
    [anon_sym_private] = ACTIONS(655),
    [anon_sym_protected] = ACTIONS(655),
    [anon_sym_module] = ACTIONS(655),
    [anon_sym_any] = ACTIONS(655),
    [anon_sym_number] = ACTIONS(655),
    [anon_sym_boolean] = ACTIONS(655),
    [anon_sym_string] = ACTIONS(655),
    [anon_sym_symbol] = ACTIONS(655),
    [sym_readonly] = ACTIONS(655),
  },
  [327] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(978),
    [sym__expression] = STATE(1482),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1696),
    [sym_array] = STATE(1691),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3169),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(978),
    [sym_subscript_expression] = STATE(978),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1967),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(977),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(380),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(881),
    [anon_sym_export] = ACTIONS(617),
    [anon_sym_namespace] = ACTIONS(619),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_type] = ACTIONS(617),
    [anon_sym_typeof] = ACTIONS(639),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(625),
    [anon_sym_yield] = ACTIONS(627),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(631),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(887),
    [anon_sym_PLUS] = ACTIONS(889),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(623),
    [anon_sym_void] = ACTIONS(639),
    [anon_sym_delete] = ACTIONS(639),
    [anon_sym_PLUS_PLUS] = ACTIONS(641),
    [anon_sym_DASH_DASH] = ACTIONS(641),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(617),
    [anon_sym_get] = ACTIONS(617),
    [anon_sym_set] = ACTIONS(617),
    [anon_sym_declare] = ACTIONS(617),
    [anon_sym_public] = ACTIONS(617),
    [anon_sym_private] = ACTIONS(617),
    [anon_sym_protected] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(617),
    [anon_sym_any] = ACTIONS(617),
    [anon_sym_number] = ACTIONS(617),
    [anon_sym_boolean] = ACTIONS(617),
    [anon_sym_string] = ACTIONS(617),
    [anon_sym_symbol] = ACTIONS(617),
    [sym_readonly] = ACTIONS(617),
  },
  [328] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(884),
    [sym__expression] = STATE(1116),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1283),
    [sym_array] = STATE(1281),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3336),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(884),
    [sym_subscript_expression] = STATE(884),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1964),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(860),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(414),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(831),
    [anon_sym_export] = ACTIONS(503),
    [anon_sym_namespace] = ACTIONS(505),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_type] = ACTIONS(503),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(437),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(443),
    [anon_sym_yield] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(849),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(851),
    [anon_sym_TILDE] = ACTIONS(437),
    [anon_sym_void] = ACTIONS(471),
    [anon_sym_delete] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(473),
    [anon_sym_DASH_DASH] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(503),
    [anon_sym_get] = ACTIONS(503),
    [anon_sym_set] = ACTIONS(503),
    [anon_sym_declare] = ACTIONS(503),
    [anon_sym_public] = ACTIONS(503),
    [anon_sym_private] = ACTIONS(503),
    [anon_sym_protected] = ACTIONS(503),
    [anon_sym_module] = ACTIONS(503),
    [anon_sym_any] = ACTIONS(503),
    [anon_sym_number] = ACTIONS(503),
    [anon_sym_boolean] = ACTIONS(503),
    [anon_sym_string] = ACTIONS(503),
    [anon_sym_symbol] = ACTIONS(503),
    [sym_readonly] = ACTIONS(503),
  },
  [329] = {
    [sym_import] = STATE(1528),
    [sym_parenthesized_expression] = STATE(983),
    [sym__expression] = STATE(1360),
    [sym_yield_expression] = STATE(1543),
    [sym_object] = STATE(1671),
    [sym_array] = STATE(1713),
    [sym_class] = STATE(1528),
    [sym_function] = STATE(1528),
    [sym_generator_function] = STATE(1528),
    [sym_arrow_function] = STATE(1528),
    [sym__call_signature] = STATE(3235),
    [sym_call_expression] = STATE(1528),
    [sym_new_expression] = STATE(1543),
    [sym_await_expression] = STATE(1543),
    [sym_member_expression] = STATE(983),
    [sym_subscript_expression] = STATE(983),
    [sym_assignment_expression] = STATE(1543),
    [sym__augmented_assignment_lhs] = STATE(1963),
    [sym_augmented_assignment_expression] = STATE(1543),
    [sym_ternary_expression] = STATE(1543),
    [sym_binary_expression] = STATE(1543),
    [sym_unary_expression] = STATE(1543),
    [sym_update_expression] = STATE(1543),
    [sym_string] = STATE(1528),
    [sym_template_string] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_meta_property] = STATE(1528),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(984),
    [sym_type_assertion] = STATE(1543),
    [sym_as_expression] = STATE(1543),
    [sym_internal_module] = STATE(1543),
    [sym_type_arguments] = STATE(310),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2726),
    [sym_identifier] = ACTIONS(891),
    [anon_sym_export] = ACTIONS(529),
    [anon_sym_namespace] = ACTIONS(531),
    [anon_sym_LBRACE] = ACTIONS(859),
    [anon_sym_type] = ACTIONS(529),
    [anon_sym_typeof] = ACTIONS(561),
    [anon_sym_import] = ACTIONS(537),
    [anon_sym_BANG] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(543),
    [anon_sym_yield] = ACTIONS(545),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(549),
    [anon_sym_async] = ACTIONS(551),
    [anon_sym_function] = ACTIONS(553),
    [anon_sym_new] = ACTIONS(897),
    [anon_sym_PLUS] = ACTIONS(899),
    [anon_sym_DASH] = ACTIONS(899),
    [anon_sym_TILDE] = ACTIONS(539),
    [anon_sym_void] = ACTIONS(561),
    [anon_sym_delete] = ACTIONS(561),
    [anon_sym_PLUS_PLUS] = ACTIONS(563),
    [anon_sym_DASH_DASH] = ACTIONS(563),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(529),
    [anon_sym_get] = ACTIONS(529),
    [anon_sym_set] = ACTIONS(529),
    [anon_sym_declare] = ACTIONS(529),
    [anon_sym_public] = ACTIONS(529),
    [anon_sym_private] = ACTIONS(529),
    [anon_sym_protected] = ACTIONS(529),
    [anon_sym_module] = ACTIONS(529),
    [anon_sym_any] = ACTIONS(529),
    [anon_sym_number] = ACTIONS(529),
    [anon_sym_boolean] = ACTIONS(529),
    [anon_sym_string] = ACTIONS(529),
    [anon_sym_symbol] = ACTIONS(529),
    [sym_readonly] = ACTIONS(529),
  },
  [330] = {
    [sym_import] = STATE(1528),
    [sym_parenthesized_expression] = STATE(983),
    [sym__expression] = STATE(1362),
    [sym_yield_expression] = STATE(1543),
    [sym_object] = STATE(1671),
    [sym_array] = STATE(1713),
    [sym_class] = STATE(1528),
    [sym_function] = STATE(1528),
    [sym_generator_function] = STATE(1528),
    [sym_arrow_function] = STATE(1528),
    [sym__call_signature] = STATE(3235),
    [sym_call_expression] = STATE(1528),
    [sym_new_expression] = STATE(1543),
    [sym_await_expression] = STATE(1543),
    [sym_member_expression] = STATE(983),
    [sym_subscript_expression] = STATE(983),
    [sym_assignment_expression] = STATE(1543),
    [sym__augmented_assignment_lhs] = STATE(1963),
    [sym_augmented_assignment_expression] = STATE(1543),
    [sym_ternary_expression] = STATE(1543),
    [sym_binary_expression] = STATE(1543),
    [sym_unary_expression] = STATE(1543),
    [sym_update_expression] = STATE(1543),
    [sym_string] = STATE(1528),
    [sym_template_string] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_meta_property] = STATE(1528),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(984),
    [sym_type_assertion] = STATE(1543),
    [sym_as_expression] = STATE(1543),
    [sym_internal_module] = STATE(1543),
    [sym_type_arguments] = STATE(310),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2726),
    [sym_identifier] = ACTIONS(891),
    [anon_sym_export] = ACTIONS(529),
    [anon_sym_namespace] = ACTIONS(531),
    [anon_sym_LBRACE] = ACTIONS(859),
    [anon_sym_type] = ACTIONS(529),
    [anon_sym_typeof] = ACTIONS(561),
    [anon_sym_import] = ACTIONS(537),
    [anon_sym_BANG] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(543),
    [anon_sym_yield] = ACTIONS(545),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(549),
    [anon_sym_async] = ACTIONS(551),
    [anon_sym_function] = ACTIONS(553),
    [anon_sym_new] = ACTIONS(897),
    [anon_sym_PLUS] = ACTIONS(899),
    [anon_sym_DASH] = ACTIONS(899),
    [anon_sym_TILDE] = ACTIONS(539),
    [anon_sym_void] = ACTIONS(561),
    [anon_sym_delete] = ACTIONS(561),
    [anon_sym_PLUS_PLUS] = ACTIONS(563),
    [anon_sym_DASH_DASH] = ACTIONS(563),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(1501),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(529),
    [anon_sym_get] = ACTIONS(529),
    [anon_sym_set] = ACTIONS(529),
    [anon_sym_declare] = ACTIONS(529),
    [anon_sym_public] = ACTIONS(529),
    [anon_sym_private] = ACTIONS(529),
    [anon_sym_protected] = ACTIONS(529),
    [anon_sym_module] = ACTIONS(529),
    [anon_sym_any] = ACTIONS(529),
    [anon_sym_number] = ACTIONS(529),
    [anon_sym_boolean] = ACTIONS(529),
    [anon_sym_string] = ACTIONS(529),
    [anon_sym_symbol] = ACTIONS(529),
    [sym_readonly] = ACTIONS(529),
  },
  [331] = {
    [sym_import] = STATE(1528),
    [sym_parenthesized_expression] = STATE(933),
    [sym__expression] = STATE(1152),
    [sym_yield_expression] = STATE(1543),
    [sym_object] = STATE(1367),
    [sym_array] = STATE(1369),
    [sym_class] = STATE(1528),
    [sym_function] = STATE(1528),
    [sym_generator_function] = STATE(1528),
    [sym_arrow_function] = STATE(1528),
    [sym__call_signature] = STATE(3359),
    [sym_call_expression] = STATE(1528),
    [sym_new_expression] = STATE(1543),
    [sym_await_expression] = STATE(1543),
    [sym_member_expression] = STATE(933),
    [sym_subscript_expression] = STATE(933),
    [sym_assignment_expression] = STATE(1543),
    [sym__augmented_assignment_lhs] = STATE(1970),
    [sym_augmented_assignment_expression] = STATE(1543),
    [sym_ternary_expression] = STATE(1543),
    [sym_binary_expression] = STATE(1543),
    [sym_unary_expression] = STATE(1543),
    [sym_update_expression] = STATE(1543),
    [sym_string] = STATE(1528),
    [sym_template_string] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_meta_property] = STATE(1528),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(936),
    [sym_type_assertion] = STATE(1543),
    [sym_as_expression] = STATE(1543),
    [sym_internal_module] = STATE(1543),
    [sym_type_arguments] = STATE(381),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2726),
    [sym_identifier] = ACTIONS(1503),
    [anon_sym_export] = ACTIONS(745),
    [anon_sym_namespace] = ACTIONS(747),
    [anon_sym_LBRACE] = ACTIONS(859),
    [anon_sym_type] = ACTIONS(745),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(537),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(549),
    [anon_sym_async] = ACTIONS(753),
    [anon_sym_function] = ACTIONS(553),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(745),
    [anon_sym_get] = ACTIONS(745),
    [anon_sym_set] = ACTIONS(745),
    [anon_sym_declare] = ACTIONS(745),
    [anon_sym_public] = ACTIONS(745),
    [anon_sym_private] = ACTIONS(745),
    [anon_sym_protected] = ACTIONS(745),
    [anon_sym_module] = ACTIONS(745),
    [anon_sym_any] = ACTIONS(745),
    [anon_sym_number] = ACTIONS(745),
    [anon_sym_boolean] = ACTIONS(745),
    [anon_sym_string] = ACTIONS(745),
    [anon_sym_symbol] = ACTIONS(745),
    [sym_readonly] = ACTIONS(745),
  },
  [332] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(978),
    [sym__expression] = STATE(1481),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1696),
    [sym_array] = STATE(1691),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3169),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(978),
    [sym_subscript_expression] = STATE(978),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1967),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(977),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(380),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(881),
    [anon_sym_export] = ACTIONS(617),
    [anon_sym_namespace] = ACTIONS(619),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_type] = ACTIONS(617),
    [anon_sym_typeof] = ACTIONS(639),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(625),
    [anon_sym_yield] = ACTIONS(627),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(631),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(887),
    [anon_sym_PLUS] = ACTIONS(889),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(623),
    [anon_sym_void] = ACTIONS(639),
    [anon_sym_delete] = ACTIONS(639),
    [anon_sym_PLUS_PLUS] = ACTIONS(641),
    [anon_sym_DASH_DASH] = ACTIONS(641),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(617),
    [anon_sym_get] = ACTIONS(617),
    [anon_sym_set] = ACTIONS(617),
    [anon_sym_declare] = ACTIONS(617),
    [anon_sym_public] = ACTIONS(617),
    [anon_sym_private] = ACTIONS(617),
    [anon_sym_protected] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(617),
    [anon_sym_any] = ACTIONS(617),
    [anon_sym_number] = ACTIONS(617),
    [anon_sym_boolean] = ACTIONS(617),
    [anon_sym_string] = ACTIONS(617),
    [anon_sym_symbol] = ACTIONS(617),
    [sym_readonly] = ACTIONS(617),
  },
  [333] = {
    [sym_import] = STATE(1528),
    [sym_parenthesized_expression] = STATE(983),
    [sym__expression] = STATE(1359),
    [sym_yield_expression] = STATE(1543),
    [sym_object] = STATE(1671),
    [sym_array] = STATE(1713),
    [sym_class] = STATE(1528),
    [sym_function] = STATE(1528),
    [sym_generator_function] = STATE(1528),
    [sym_arrow_function] = STATE(1528),
    [sym__call_signature] = STATE(3235),
    [sym_call_expression] = STATE(1528),
    [sym_new_expression] = STATE(1543),
    [sym_await_expression] = STATE(1543),
    [sym_member_expression] = STATE(983),
    [sym_subscript_expression] = STATE(983),
    [sym_assignment_expression] = STATE(1543),
    [sym__augmented_assignment_lhs] = STATE(1963),
    [sym_augmented_assignment_expression] = STATE(1543),
    [sym_ternary_expression] = STATE(1543),
    [sym_binary_expression] = STATE(1543),
    [sym_unary_expression] = STATE(1543),
    [sym_update_expression] = STATE(1543),
    [sym_string] = STATE(1528),
    [sym_template_string] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_meta_property] = STATE(1528),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(984),
    [sym_type_assertion] = STATE(1543),
    [sym_as_expression] = STATE(1543),
    [sym_internal_module] = STATE(1543),
    [sym_type_arguments] = STATE(310),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2726),
    [sym_identifier] = ACTIONS(891),
    [anon_sym_export] = ACTIONS(529),
    [anon_sym_namespace] = ACTIONS(531),
    [anon_sym_LBRACE] = ACTIONS(859),
    [anon_sym_type] = ACTIONS(529),
    [anon_sym_typeof] = ACTIONS(561),
    [anon_sym_import] = ACTIONS(537),
    [anon_sym_BANG] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(543),
    [anon_sym_yield] = ACTIONS(545),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(549),
    [anon_sym_async] = ACTIONS(551),
    [anon_sym_function] = ACTIONS(553),
    [anon_sym_new] = ACTIONS(897),
    [anon_sym_PLUS] = ACTIONS(899),
    [anon_sym_DASH] = ACTIONS(899),
    [anon_sym_TILDE] = ACTIONS(539),
    [anon_sym_void] = ACTIONS(561),
    [anon_sym_delete] = ACTIONS(561),
    [anon_sym_PLUS_PLUS] = ACTIONS(563),
    [anon_sym_DASH_DASH] = ACTIONS(563),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(529),
    [anon_sym_get] = ACTIONS(529),
    [anon_sym_set] = ACTIONS(529),
    [anon_sym_declare] = ACTIONS(529),
    [anon_sym_public] = ACTIONS(529),
    [anon_sym_private] = ACTIONS(529),
    [anon_sym_protected] = ACTIONS(529),
    [anon_sym_module] = ACTIONS(529),
    [anon_sym_any] = ACTIONS(529),
    [anon_sym_number] = ACTIONS(529),
    [anon_sym_boolean] = ACTIONS(529),
    [anon_sym_string] = ACTIONS(529),
    [anon_sym_symbol] = ACTIONS(529),
    [sym_readonly] = ACTIONS(529),
  },
  [334] = {
    [sym_import] = STATE(1528),
    [sym_parenthesized_expression] = STATE(983),
    [sym__expression] = STATE(1358),
    [sym_yield_expression] = STATE(1543),
    [sym_object] = STATE(1671),
    [sym_array] = STATE(1713),
    [sym_class] = STATE(1528),
    [sym_function] = STATE(1528),
    [sym_generator_function] = STATE(1528),
    [sym_arrow_function] = STATE(1528),
    [sym__call_signature] = STATE(3235),
    [sym_call_expression] = STATE(1528),
    [sym_new_expression] = STATE(1543),
    [sym_await_expression] = STATE(1543),
    [sym_member_expression] = STATE(983),
    [sym_subscript_expression] = STATE(983),
    [sym_assignment_expression] = STATE(1543),
    [sym__augmented_assignment_lhs] = STATE(1963),
    [sym_augmented_assignment_expression] = STATE(1543),
    [sym_ternary_expression] = STATE(1543),
    [sym_binary_expression] = STATE(1543),
    [sym_unary_expression] = STATE(1543),
    [sym_update_expression] = STATE(1543),
    [sym_string] = STATE(1528),
    [sym_template_string] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_meta_property] = STATE(1528),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(984),
    [sym_type_assertion] = STATE(1543),
    [sym_as_expression] = STATE(1543),
    [sym_internal_module] = STATE(1543),
    [sym_type_arguments] = STATE(310),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2726),
    [sym_identifier] = ACTIONS(891),
    [anon_sym_export] = ACTIONS(529),
    [anon_sym_namespace] = ACTIONS(531),
    [anon_sym_LBRACE] = ACTIONS(859),
    [anon_sym_type] = ACTIONS(529),
    [anon_sym_typeof] = ACTIONS(561),
    [anon_sym_import] = ACTIONS(537),
    [anon_sym_BANG] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(543),
    [anon_sym_yield] = ACTIONS(545),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(549),
    [anon_sym_async] = ACTIONS(551),
    [anon_sym_function] = ACTIONS(553),
    [anon_sym_new] = ACTIONS(897),
    [anon_sym_PLUS] = ACTIONS(899),
    [anon_sym_DASH] = ACTIONS(899),
    [anon_sym_TILDE] = ACTIONS(539),
    [anon_sym_void] = ACTIONS(561),
    [anon_sym_delete] = ACTIONS(561),
    [anon_sym_PLUS_PLUS] = ACTIONS(563),
    [anon_sym_DASH_DASH] = ACTIONS(563),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(529),
    [anon_sym_get] = ACTIONS(529),
    [anon_sym_set] = ACTIONS(529),
    [anon_sym_declare] = ACTIONS(529),
    [anon_sym_public] = ACTIONS(529),
    [anon_sym_private] = ACTIONS(529),
    [anon_sym_protected] = ACTIONS(529),
    [anon_sym_module] = ACTIONS(529),
    [anon_sym_any] = ACTIONS(529),
    [anon_sym_number] = ACTIONS(529),
    [anon_sym_boolean] = ACTIONS(529),
    [anon_sym_string] = ACTIONS(529),
    [anon_sym_symbol] = ACTIONS(529),
    [sym_readonly] = ACTIONS(529),
  },
  [335] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(978),
    [sym__expression] = STATE(1522),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1696),
    [sym_array] = STATE(1691),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3169),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(978),
    [sym_subscript_expression] = STATE(978),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1967),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(977),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(380),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(881),
    [anon_sym_export] = ACTIONS(617),
    [anon_sym_namespace] = ACTIONS(619),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_type] = ACTIONS(617),
    [anon_sym_typeof] = ACTIONS(639),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(625),
    [anon_sym_yield] = ACTIONS(627),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(631),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(887),
    [anon_sym_PLUS] = ACTIONS(889),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(623),
    [anon_sym_void] = ACTIONS(639),
    [anon_sym_delete] = ACTIONS(639),
    [anon_sym_PLUS_PLUS] = ACTIONS(641),
    [anon_sym_DASH_DASH] = ACTIONS(641),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(617),
    [anon_sym_get] = ACTIONS(617),
    [anon_sym_set] = ACTIONS(617),
    [anon_sym_declare] = ACTIONS(617),
    [anon_sym_public] = ACTIONS(617),
    [anon_sym_private] = ACTIONS(617),
    [anon_sym_protected] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(617),
    [anon_sym_any] = ACTIONS(617),
    [anon_sym_number] = ACTIONS(617),
    [anon_sym_boolean] = ACTIONS(617),
    [anon_sym_string] = ACTIONS(617),
    [anon_sym_symbol] = ACTIONS(617),
    [sym_readonly] = ACTIONS(617),
  },
  [336] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(963),
    [sym__expression] = STATE(1266),
    [sym_yield_expression] = STATE(1722),
    [sym_object] = STATE(1536),
    [sym_array] = STATE(1535),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(3286),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1722),
    [sym_await_expression] = STATE(1722),
    [sym_member_expression] = STATE(963),
    [sym_subscript_expression] = STATE(963),
    [sym_assignment_expression] = STATE(1722),
    [sym__augmented_assignment_lhs] = STATE(1968),
    [sym_augmented_assignment_expression] = STATE(1722),
    [sym_ternary_expression] = STATE(1722),
    [sym_binary_expression] = STATE(1722),
    [sym_unary_expression] = STATE(1722),
    [sym_update_expression] = STATE(1722),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(952),
    [sym_type_assertion] = STATE(1722),
    [sym_as_expression] = STATE(1722),
    [sym_internal_module] = STATE(1722),
    [sym_type_arguments] = STATE(266),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2684),
    [sym_identifier] = ACTIONS(863),
    [anon_sym_export] = ACTIONS(655),
    [anon_sym_namespace] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(1270),
    [anon_sym_type] = ACTIONS(655),
    [anon_sym_typeof] = ACTIONS(689),
    [anon_sym_import] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_LPAREN] = ACTIONS(871),
    [anon_sym_await] = ACTIONS(669),
    [anon_sym_yield] = ACTIONS(671),
    [anon_sym_LBRACK] = ACTIONS(873),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(675),
    [anon_sym_class] = ACTIONS(677),
    [anon_sym_async] = ACTIONS(679),
    [anon_sym_function] = ACTIONS(681),
    [anon_sym_new] = ACTIONS(875),
    [anon_sym_PLUS] = ACTIONS(877),
    [anon_sym_DASH] = ACTIONS(877),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_void] = ACTIONS(689),
    [anon_sym_delete] = ACTIONS(689),
    [anon_sym_PLUS_PLUS] = ACTIONS(691),
    [anon_sym_DASH_DASH] = ACTIONS(691),
    [anon_sym_DQUOTE] = ACTIONS(693),
    [anon_sym_SQUOTE] = ACTIONS(695),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(697),
    [sym_number] = ACTIONS(879),
    [sym_this] = ACTIONS(703),
    [sym_super] = ACTIONS(703),
    [sym_true] = ACTIONS(703),
    [sym_false] = ACTIONS(703),
    [sym_null] = ACTIONS(703),
    [sym_undefined] = ACTIONS(703),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(655),
    [anon_sym_get] = ACTIONS(655),
    [anon_sym_set] = ACTIONS(655),
    [anon_sym_declare] = ACTIONS(655),
    [anon_sym_public] = ACTIONS(655),
    [anon_sym_private] = ACTIONS(655),
    [anon_sym_protected] = ACTIONS(655),
    [anon_sym_module] = ACTIONS(655),
    [anon_sym_any] = ACTIONS(655),
    [anon_sym_number] = ACTIONS(655),
    [anon_sym_boolean] = ACTIONS(655),
    [anon_sym_string] = ACTIONS(655),
    [anon_sym_symbol] = ACTIONS(655),
    [sym_readonly] = ACTIONS(655),
  },
  [337] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(978),
    [sym__expression] = STATE(1480),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1696),
    [sym_array] = STATE(1691),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3169),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(978),
    [sym_subscript_expression] = STATE(978),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1967),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(977),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(380),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(881),
    [anon_sym_export] = ACTIONS(617),
    [anon_sym_namespace] = ACTIONS(619),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_type] = ACTIONS(617),
    [anon_sym_typeof] = ACTIONS(639),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(625),
    [anon_sym_yield] = ACTIONS(627),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(631),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(887),
    [anon_sym_PLUS] = ACTIONS(889),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(623),
    [anon_sym_void] = ACTIONS(639),
    [anon_sym_delete] = ACTIONS(639),
    [anon_sym_PLUS_PLUS] = ACTIONS(641),
    [anon_sym_DASH_DASH] = ACTIONS(641),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(617),
    [anon_sym_get] = ACTIONS(617),
    [anon_sym_set] = ACTIONS(617),
    [anon_sym_declare] = ACTIONS(617),
    [anon_sym_public] = ACTIONS(617),
    [anon_sym_private] = ACTIONS(617),
    [anon_sym_protected] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(617),
    [anon_sym_any] = ACTIONS(617),
    [anon_sym_number] = ACTIONS(617),
    [anon_sym_boolean] = ACTIONS(617),
    [anon_sym_string] = ACTIONS(617),
    [anon_sym_symbol] = ACTIONS(617),
    [sym_readonly] = ACTIONS(617),
  },
  [338] = {
    [sym_import] = STATE(1528),
    [sym_parenthesized_expression] = STATE(983),
    [sym__expression] = STATE(1416),
    [sym_yield_expression] = STATE(1543),
    [sym_object] = STATE(1671),
    [sym_array] = STATE(1713),
    [sym_class] = STATE(1528),
    [sym_function] = STATE(1528),
    [sym_generator_function] = STATE(1528),
    [sym_arrow_function] = STATE(1528),
    [sym__call_signature] = STATE(3235),
    [sym_call_expression] = STATE(1528),
    [sym_new_expression] = STATE(1543),
    [sym_await_expression] = STATE(1543),
    [sym_member_expression] = STATE(983),
    [sym_subscript_expression] = STATE(983),
    [sym_assignment_expression] = STATE(1543),
    [sym__augmented_assignment_lhs] = STATE(1963),
    [sym_augmented_assignment_expression] = STATE(1543),
    [sym_ternary_expression] = STATE(1543),
    [sym_binary_expression] = STATE(1543),
    [sym_unary_expression] = STATE(1543),
    [sym_update_expression] = STATE(1543),
    [sym_string] = STATE(1528),
    [sym_template_string] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_meta_property] = STATE(1528),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(984),
    [sym_type_assertion] = STATE(1543),
    [sym_as_expression] = STATE(1543),
    [sym_internal_module] = STATE(1543),
    [sym_type_arguments] = STATE(310),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2726),
    [sym_identifier] = ACTIONS(891),
    [anon_sym_export] = ACTIONS(529),
    [anon_sym_namespace] = ACTIONS(531),
    [anon_sym_LBRACE] = ACTIONS(859),
    [anon_sym_type] = ACTIONS(529),
    [anon_sym_typeof] = ACTIONS(561),
    [anon_sym_import] = ACTIONS(537),
    [anon_sym_BANG] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(543),
    [anon_sym_yield] = ACTIONS(545),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(549),
    [anon_sym_async] = ACTIONS(551),
    [anon_sym_function] = ACTIONS(553),
    [anon_sym_new] = ACTIONS(897),
    [anon_sym_PLUS] = ACTIONS(899),
    [anon_sym_DASH] = ACTIONS(899),
    [anon_sym_TILDE] = ACTIONS(539),
    [anon_sym_void] = ACTIONS(561),
    [anon_sym_delete] = ACTIONS(561),
    [anon_sym_PLUS_PLUS] = ACTIONS(563),
    [anon_sym_DASH_DASH] = ACTIONS(563),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(529),
    [anon_sym_get] = ACTIONS(529),
    [anon_sym_set] = ACTIONS(529),
    [anon_sym_declare] = ACTIONS(529),
    [anon_sym_public] = ACTIONS(529),
    [anon_sym_private] = ACTIONS(529),
    [anon_sym_protected] = ACTIONS(529),
    [anon_sym_module] = ACTIONS(529),
    [anon_sym_any] = ACTIONS(529),
    [anon_sym_number] = ACTIONS(529),
    [anon_sym_boolean] = ACTIONS(529),
    [anon_sym_string] = ACTIONS(529),
    [anon_sym_symbol] = ACTIONS(529),
    [sym_readonly] = ACTIONS(529),
  },
  [339] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(965),
    [sym__expression] = STATE(1262),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1524),
    [sym_array] = STATE(1523),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3348),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(965),
    [sym_subscript_expression] = STATE(965),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1969),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(975),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(302),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(901),
    [anon_sym_export] = ACTIONS(713),
    [anon_sym_namespace] = ACTIONS(715),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_type] = ACTIONS(713),
    [anon_sym_typeof] = ACTIONS(735),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(719),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(721),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(725),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(727),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(907),
    [anon_sym_PLUS] = ACTIONS(909),
    [anon_sym_DASH] = ACTIONS(909),
    [anon_sym_TILDE] = ACTIONS(719),
    [anon_sym_void] = ACTIONS(735),
    [anon_sym_delete] = ACTIONS(735),
    [anon_sym_PLUS_PLUS] = ACTIONS(737),
    [anon_sym_DASH_DASH] = ACTIONS(737),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(713),
    [anon_sym_get] = ACTIONS(713),
    [anon_sym_set] = ACTIONS(713),
    [anon_sym_declare] = ACTIONS(713),
    [anon_sym_public] = ACTIONS(713),
    [anon_sym_private] = ACTIONS(713),
    [anon_sym_protected] = ACTIONS(713),
    [anon_sym_module] = ACTIONS(713),
    [anon_sym_any] = ACTIONS(713),
    [anon_sym_number] = ACTIONS(713),
    [anon_sym_boolean] = ACTIONS(713),
    [anon_sym_string] = ACTIONS(713),
    [anon_sym_symbol] = ACTIONS(713),
    [sym_readonly] = ACTIONS(713),
  },
  [340] = {
    [sym_import] = STATE(1528),
    [sym_parenthesized_expression] = STATE(983),
    [sym__expression] = STATE(1433),
    [sym_yield_expression] = STATE(1543),
    [sym_object] = STATE(1671),
    [sym_array] = STATE(1713),
    [sym_class] = STATE(1528),
    [sym_function] = STATE(1528),
    [sym_generator_function] = STATE(1528),
    [sym_arrow_function] = STATE(1528),
    [sym__call_signature] = STATE(3235),
    [sym_call_expression] = STATE(1528),
    [sym_new_expression] = STATE(1543),
    [sym_await_expression] = STATE(1543),
    [sym_member_expression] = STATE(983),
    [sym_subscript_expression] = STATE(983),
    [sym_assignment_expression] = STATE(1543),
    [sym__augmented_assignment_lhs] = STATE(1963),
    [sym_augmented_assignment_expression] = STATE(1543),
    [sym_ternary_expression] = STATE(1543),
    [sym_binary_expression] = STATE(1543),
    [sym_unary_expression] = STATE(1543),
    [sym_update_expression] = STATE(1543),
    [sym_string] = STATE(1528),
    [sym_template_string] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_meta_property] = STATE(1528),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(984),
    [sym_type_assertion] = STATE(1543),
    [sym_as_expression] = STATE(1543),
    [sym_internal_module] = STATE(1543),
    [sym_type_arguments] = STATE(310),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2726),
    [sym_identifier] = ACTIONS(891),
    [anon_sym_export] = ACTIONS(529),
    [anon_sym_namespace] = ACTIONS(531),
    [anon_sym_LBRACE] = ACTIONS(859),
    [anon_sym_type] = ACTIONS(529),
    [anon_sym_typeof] = ACTIONS(561),
    [anon_sym_import] = ACTIONS(537),
    [anon_sym_BANG] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(543),
    [anon_sym_yield] = ACTIONS(545),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(549),
    [anon_sym_async] = ACTIONS(551),
    [anon_sym_function] = ACTIONS(553),
    [anon_sym_new] = ACTIONS(897),
    [anon_sym_PLUS] = ACTIONS(899),
    [anon_sym_DASH] = ACTIONS(899),
    [anon_sym_TILDE] = ACTIONS(539),
    [anon_sym_void] = ACTIONS(561),
    [anon_sym_delete] = ACTIONS(561),
    [anon_sym_PLUS_PLUS] = ACTIONS(563),
    [anon_sym_DASH_DASH] = ACTIONS(563),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(529),
    [anon_sym_get] = ACTIONS(529),
    [anon_sym_set] = ACTIONS(529),
    [anon_sym_declare] = ACTIONS(529),
    [anon_sym_public] = ACTIONS(529),
    [anon_sym_private] = ACTIONS(529),
    [anon_sym_protected] = ACTIONS(529),
    [anon_sym_module] = ACTIONS(529),
    [anon_sym_any] = ACTIONS(529),
    [anon_sym_number] = ACTIONS(529),
    [anon_sym_boolean] = ACTIONS(529),
    [anon_sym_string] = ACTIONS(529),
    [anon_sym_symbol] = ACTIONS(529),
    [sym_readonly] = ACTIONS(529),
  },
  [341] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(978),
    [sym__expression] = STATE(1493),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1696),
    [sym_array] = STATE(1691),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3169),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(978),
    [sym_subscript_expression] = STATE(978),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1967),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(977),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(380),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(881),
    [anon_sym_export] = ACTIONS(617),
    [anon_sym_namespace] = ACTIONS(619),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_type] = ACTIONS(617),
    [anon_sym_typeof] = ACTIONS(639),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(625),
    [anon_sym_yield] = ACTIONS(627),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(631),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(887),
    [anon_sym_PLUS] = ACTIONS(889),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(623),
    [anon_sym_void] = ACTIONS(639),
    [anon_sym_delete] = ACTIONS(639),
    [anon_sym_PLUS_PLUS] = ACTIONS(641),
    [anon_sym_DASH_DASH] = ACTIONS(641),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(617),
    [anon_sym_get] = ACTIONS(617),
    [anon_sym_set] = ACTIONS(617),
    [anon_sym_declare] = ACTIONS(617),
    [anon_sym_public] = ACTIONS(617),
    [anon_sym_private] = ACTIONS(617),
    [anon_sym_protected] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(617),
    [anon_sym_any] = ACTIONS(617),
    [anon_sym_number] = ACTIONS(617),
    [anon_sym_boolean] = ACTIONS(617),
    [anon_sym_string] = ACTIONS(617),
    [anon_sym_symbol] = ACTIONS(617),
    [sym_readonly] = ACTIONS(617),
  },
  [342] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(965),
    [sym__expression] = STATE(1332),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1524),
    [sym_array] = STATE(1523),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3348),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(965),
    [sym_subscript_expression] = STATE(965),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1969),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(975),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(302),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(901),
    [anon_sym_export] = ACTIONS(713),
    [anon_sym_namespace] = ACTIONS(715),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_type] = ACTIONS(713),
    [anon_sym_typeof] = ACTIONS(735),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(719),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(721),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(725),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(727),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(907),
    [anon_sym_PLUS] = ACTIONS(909),
    [anon_sym_DASH] = ACTIONS(909),
    [anon_sym_TILDE] = ACTIONS(719),
    [anon_sym_void] = ACTIONS(735),
    [anon_sym_delete] = ACTIONS(735),
    [anon_sym_PLUS_PLUS] = ACTIONS(737),
    [anon_sym_DASH_DASH] = ACTIONS(737),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(713),
    [anon_sym_get] = ACTIONS(713),
    [anon_sym_set] = ACTIONS(713),
    [anon_sym_declare] = ACTIONS(713),
    [anon_sym_public] = ACTIONS(713),
    [anon_sym_private] = ACTIONS(713),
    [anon_sym_protected] = ACTIONS(713),
    [anon_sym_module] = ACTIONS(713),
    [anon_sym_any] = ACTIONS(713),
    [anon_sym_number] = ACTIONS(713),
    [anon_sym_boolean] = ACTIONS(713),
    [anon_sym_string] = ACTIONS(713),
    [anon_sym_symbol] = ACTIONS(713),
    [sym_readonly] = ACTIONS(713),
  },
  [343] = {
    [sym_import] = STATE(1528),
    [sym_parenthesized_expression] = STATE(983),
    [sym__expression] = STATE(1434),
    [sym_yield_expression] = STATE(1543),
    [sym_object] = STATE(1671),
    [sym_array] = STATE(1713),
    [sym_class] = STATE(1528),
    [sym_function] = STATE(1528),
    [sym_generator_function] = STATE(1528),
    [sym_arrow_function] = STATE(1528),
    [sym__call_signature] = STATE(3235),
    [sym_call_expression] = STATE(1528),
    [sym_new_expression] = STATE(1543),
    [sym_await_expression] = STATE(1543),
    [sym_member_expression] = STATE(983),
    [sym_subscript_expression] = STATE(983),
    [sym_assignment_expression] = STATE(1543),
    [sym__augmented_assignment_lhs] = STATE(1963),
    [sym_augmented_assignment_expression] = STATE(1543),
    [sym_ternary_expression] = STATE(1543),
    [sym_binary_expression] = STATE(1543),
    [sym_unary_expression] = STATE(1543),
    [sym_update_expression] = STATE(1543),
    [sym_string] = STATE(1528),
    [sym_template_string] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_meta_property] = STATE(1528),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(984),
    [sym_type_assertion] = STATE(1543),
    [sym_as_expression] = STATE(1543),
    [sym_internal_module] = STATE(1543),
    [sym_type_arguments] = STATE(310),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2726),
    [sym_identifier] = ACTIONS(891),
    [anon_sym_export] = ACTIONS(529),
    [anon_sym_namespace] = ACTIONS(531),
    [anon_sym_LBRACE] = ACTIONS(859),
    [anon_sym_type] = ACTIONS(529),
    [anon_sym_typeof] = ACTIONS(561),
    [anon_sym_import] = ACTIONS(537),
    [anon_sym_BANG] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(543),
    [anon_sym_yield] = ACTIONS(545),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(549),
    [anon_sym_async] = ACTIONS(551),
    [anon_sym_function] = ACTIONS(553),
    [anon_sym_new] = ACTIONS(897),
    [anon_sym_PLUS] = ACTIONS(899),
    [anon_sym_DASH] = ACTIONS(899),
    [anon_sym_TILDE] = ACTIONS(539),
    [anon_sym_void] = ACTIONS(561),
    [anon_sym_delete] = ACTIONS(561),
    [anon_sym_PLUS_PLUS] = ACTIONS(563),
    [anon_sym_DASH_DASH] = ACTIONS(563),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(529),
    [anon_sym_get] = ACTIONS(529),
    [anon_sym_set] = ACTIONS(529),
    [anon_sym_declare] = ACTIONS(529),
    [anon_sym_public] = ACTIONS(529),
    [anon_sym_private] = ACTIONS(529),
    [anon_sym_protected] = ACTIONS(529),
    [anon_sym_module] = ACTIONS(529),
    [anon_sym_any] = ACTIONS(529),
    [anon_sym_number] = ACTIONS(529),
    [anon_sym_boolean] = ACTIONS(529),
    [anon_sym_string] = ACTIONS(529),
    [anon_sym_symbol] = ACTIONS(529),
    [sym_readonly] = ACTIONS(529),
  },
  [344] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(963),
    [sym__expression] = STATE(1284),
    [sym_yield_expression] = STATE(1722),
    [sym_object] = STATE(1536),
    [sym_array] = STATE(1535),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(3286),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1722),
    [sym_await_expression] = STATE(1722),
    [sym_member_expression] = STATE(963),
    [sym_subscript_expression] = STATE(963),
    [sym_assignment_expression] = STATE(1722),
    [sym__augmented_assignment_lhs] = STATE(1968),
    [sym_augmented_assignment_expression] = STATE(1722),
    [sym_ternary_expression] = STATE(1722),
    [sym_binary_expression] = STATE(1722),
    [sym_unary_expression] = STATE(1722),
    [sym_update_expression] = STATE(1722),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(952),
    [sym_type_assertion] = STATE(1722),
    [sym_as_expression] = STATE(1722),
    [sym_internal_module] = STATE(1722),
    [sym_type_arguments] = STATE(266),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2684),
    [sym_identifier] = ACTIONS(863),
    [anon_sym_export] = ACTIONS(655),
    [anon_sym_namespace] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(1270),
    [anon_sym_type] = ACTIONS(655),
    [anon_sym_typeof] = ACTIONS(689),
    [anon_sym_import] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_LPAREN] = ACTIONS(871),
    [anon_sym_await] = ACTIONS(669),
    [anon_sym_yield] = ACTIONS(671),
    [anon_sym_LBRACK] = ACTIONS(873),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(675),
    [anon_sym_class] = ACTIONS(677),
    [anon_sym_async] = ACTIONS(679),
    [anon_sym_function] = ACTIONS(681),
    [anon_sym_new] = ACTIONS(875),
    [anon_sym_PLUS] = ACTIONS(877),
    [anon_sym_DASH] = ACTIONS(877),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_void] = ACTIONS(689),
    [anon_sym_delete] = ACTIONS(689),
    [anon_sym_PLUS_PLUS] = ACTIONS(691),
    [anon_sym_DASH_DASH] = ACTIONS(691),
    [anon_sym_DQUOTE] = ACTIONS(693),
    [anon_sym_SQUOTE] = ACTIONS(695),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(697),
    [sym_number] = ACTIONS(879),
    [sym_this] = ACTIONS(703),
    [sym_super] = ACTIONS(703),
    [sym_true] = ACTIONS(703),
    [sym_false] = ACTIONS(703),
    [sym_null] = ACTIONS(703),
    [sym_undefined] = ACTIONS(703),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(655),
    [anon_sym_get] = ACTIONS(655),
    [anon_sym_set] = ACTIONS(655),
    [anon_sym_declare] = ACTIONS(655),
    [anon_sym_public] = ACTIONS(655),
    [anon_sym_private] = ACTIONS(655),
    [anon_sym_protected] = ACTIONS(655),
    [anon_sym_module] = ACTIONS(655),
    [anon_sym_any] = ACTIONS(655),
    [anon_sym_number] = ACTIONS(655),
    [anon_sym_boolean] = ACTIONS(655),
    [anon_sym_string] = ACTIONS(655),
    [anon_sym_symbol] = ACTIONS(655),
    [sym_readonly] = ACTIONS(655),
  },
  [345] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(965),
    [sym__expression] = STATE(1338),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1524),
    [sym_array] = STATE(1523),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3348),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(965),
    [sym_subscript_expression] = STATE(965),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1969),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(975),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(302),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(901),
    [anon_sym_export] = ACTIONS(713),
    [anon_sym_namespace] = ACTIONS(715),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_type] = ACTIONS(713),
    [anon_sym_typeof] = ACTIONS(735),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(719),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(721),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(725),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(727),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(907),
    [anon_sym_PLUS] = ACTIONS(909),
    [anon_sym_DASH] = ACTIONS(909),
    [anon_sym_TILDE] = ACTIONS(719),
    [anon_sym_void] = ACTIONS(735),
    [anon_sym_delete] = ACTIONS(735),
    [anon_sym_PLUS_PLUS] = ACTIONS(737),
    [anon_sym_DASH_DASH] = ACTIONS(737),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(713),
    [anon_sym_get] = ACTIONS(713),
    [anon_sym_set] = ACTIONS(713),
    [anon_sym_declare] = ACTIONS(713),
    [anon_sym_public] = ACTIONS(713),
    [anon_sym_private] = ACTIONS(713),
    [anon_sym_protected] = ACTIONS(713),
    [anon_sym_module] = ACTIONS(713),
    [anon_sym_any] = ACTIONS(713),
    [anon_sym_number] = ACTIONS(713),
    [anon_sym_boolean] = ACTIONS(713),
    [anon_sym_string] = ACTIONS(713),
    [anon_sym_symbol] = ACTIONS(713),
    [sym_readonly] = ACTIONS(713),
  },
  [346] = {
    [sym_import] = STATE(1528),
    [sym_parenthesized_expression] = STATE(983),
    [sym__expression] = STATE(1405),
    [sym_yield_expression] = STATE(1543),
    [sym_object] = STATE(1671),
    [sym_array] = STATE(1713),
    [sym_class] = STATE(1528),
    [sym_function] = STATE(1528),
    [sym_generator_function] = STATE(1528),
    [sym_arrow_function] = STATE(1528),
    [sym__call_signature] = STATE(3235),
    [sym_call_expression] = STATE(1528),
    [sym_new_expression] = STATE(1543),
    [sym_await_expression] = STATE(1543),
    [sym_member_expression] = STATE(983),
    [sym_subscript_expression] = STATE(983),
    [sym_assignment_expression] = STATE(1543),
    [sym__augmented_assignment_lhs] = STATE(1963),
    [sym_augmented_assignment_expression] = STATE(1543),
    [sym_ternary_expression] = STATE(1543),
    [sym_binary_expression] = STATE(1543),
    [sym_unary_expression] = STATE(1543),
    [sym_update_expression] = STATE(1543),
    [sym_string] = STATE(1528),
    [sym_template_string] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_meta_property] = STATE(1528),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(984),
    [sym_type_assertion] = STATE(1543),
    [sym_as_expression] = STATE(1543),
    [sym_internal_module] = STATE(1543),
    [sym_type_arguments] = STATE(310),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2726),
    [sym_identifier] = ACTIONS(891),
    [anon_sym_export] = ACTIONS(529),
    [anon_sym_namespace] = ACTIONS(531),
    [anon_sym_LBRACE] = ACTIONS(859),
    [anon_sym_type] = ACTIONS(529),
    [anon_sym_typeof] = ACTIONS(561),
    [anon_sym_import] = ACTIONS(537),
    [anon_sym_BANG] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(543),
    [anon_sym_yield] = ACTIONS(545),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(549),
    [anon_sym_async] = ACTIONS(551),
    [anon_sym_function] = ACTIONS(553),
    [anon_sym_new] = ACTIONS(897),
    [anon_sym_PLUS] = ACTIONS(899),
    [anon_sym_DASH] = ACTIONS(899),
    [anon_sym_TILDE] = ACTIONS(539),
    [anon_sym_void] = ACTIONS(561),
    [anon_sym_delete] = ACTIONS(561),
    [anon_sym_PLUS_PLUS] = ACTIONS(563),
    [anon_sym_DASH_DASH] = ACTIONS(563),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(529),
    [anon_sym_get] = ACTIONS(529),
    [anon_sym_set] = ACTIONS(529),
    [anon_sym_declare] = ACTIONS(529),
    [anon_sym_public] = ACTIONS(529),
    [anon_sym_private] = ACTIONS(529),
    [anon_sym_protected] = ACTIONS(529),
    [anon_sym_module] = ACTIONS(529),
    [anon_sym_any] = ACTIONS(529),
    [anon_sym_number] = ACTIONS(529),
    [anon_sym_boolean] = ACTIONS(529),
    [anon_sym_string] = ACTIONS(529),
    [anon_sym_symbol] = ACTIONS(529),
    [sym_readonly] = ACTIONS(529),
  },
  [347] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(978),
    [sym__expression] = STATE(1479),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1696),
    [sym_array] = STATE(1691),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3169),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(978),
    [sym_subscript_expression] = STATE(978),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1967),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(977),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(380),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(881),
    [anon_sym_export] = ACTIONS(617),
    [anon_sym_namespace] = ACTIONS(619),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_type] = ACTIONS(617),
    [anon_sym_typeof] = ACTIONS(639),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(625),
    [anon_sym_yield] = ACTIONS(627),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(631),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(887),
    [anon_sym_PLUS] = ACTIONS(889),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(623),
    [anon_sym_void] = ACTIONS(639),
    [anon_sym_delete] = ACTIONS(639),
    [anon_sym_PLUS_PLUS] = ACTIONS(641),
    [anon_sym_DASH_DASH] = ACTIONS(641),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(617),
    [anon_sym_get] = ACTIONS(617),
    [anon_sym_set] = ACTIONS(617),
    [anon_sym_declare] = ACTIONS(617),
    [anon_sym_public] = ACTIONS(617),
    [anon_sym_private] = ACTIONS(617),
    [anon_sym_protected] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(617),
    [anon_sym_any] = ACTIONS(617),
    [anon_sym_number] = ACTIONS(617),
    [anon_sym_boolean] = ACTIONS(617),
    [anon_sym_string] = ACTIONS(617),
    [anon_sym_symbol] = ACTIONS(617),
    [sym_readonly] = ACTIONS(617),
  },
  [348] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(978),
    [sym__expression] = STATE(1478),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1696),
    [sym_array] = STATE(1691),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3169),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(978),
    [sym_subscript_expression] = STATE(978),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1967),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(977),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(380),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(881),
    [anon_sym_export] = ACTIONS(617),
    [anon_sym_namespace] = ACTIONS(619),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_type] = ACTIONS(617),
    [anon_sym_typeof] = ACTIONS(639),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(625),
    [anon_sym_yield] = ACTIONS(627),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(631),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(887),
    [anon_sym_PLUS] = ACTIONS(889),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(623),
    [anon_sym_void] = ACTIONS(639),
    [anon_sym_delete] = ACTIONS(639),
    [anon_sym_PLUS_PLUS] = ACTIONS(641),
    [anon_sym_DASH_DASH] = ACTIONS(641),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(617),
    [anon_sym_get] = ACTIONS(617),
    [anon_sym_set] = ACTIONS(617),
    [anon_sym_declare] = ACTIONS(617),
    [anon_sym_public] = ACTIONS(617),
    [anon_sym_private] = ACTIONS(617),
    [anon_sym_protected] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(617),
    [anon_sym_any] = ACTIONS(617),
    [anon_sym_number] = ACTIONS(617),
    [anon_sym_boolean] = ACTIONS(617),
    [anon_sym_string] = ACTIONS(617),
    [anon_sym_symbol] = ACTIONS(617),
    [sym_readonly] = ACTIONS(617),
  },
  [349] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(978),
    [sym__expression] = STATE(1477),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1696),
    [sym_array] = STATE(1691),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3169),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(978),
    [sym_subscript_expression] = STATE(978),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1967),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(977),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(380),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(881),
    [anon_sym_export] = ACTIONS(617),
    [anon_sym_namespace] = ACTIONS(619),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_type] = ACTIONS(617),
    [anon_sym_typeof] = ACTIONS(639),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(625),
    [anon_sym_yield] = ACTIONS(627),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(631),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(887),
    [anon_sym_PLUS] = ACTIONS(889),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(623),
    [anon_sym_void] = ACTIONS(639),
    [anon_sym_delete] = ACTIONS(639),
    [anon_sym_PLUS_PLUS] = ACTIONS(641),
    [anon_sym_DASH_DASH] = ACTIONS(641),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(617),
    [anon_sym_get] = ACTIONS(617),
    [anon_sym_set] = ACTIONS(617),
    [anon_sym_declare] = ACTIONS(617),
    [anon_sym_public] = ACTIONS(617),
    [anon_sym_private] = ACTIONS(617),
    [anon_sym_protected] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(617),
    [anon_sym_any] = ACTIONS(617),
    [anon_sym_number] = ACTIONS(617),
    [anon_sym_boolean] = ACTIONS(617),
    [anon_sym_string] = ACTIONS(617),
    [anon_sym_symbol] = ACTIONS(617),
    [sym_readonly] = ACTIONS(617),
  },
  [350] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(978),
    [sym__expression] = STATE(1612),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1696),
    [sym_array] = STATE(1691),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3169),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(978),
    [sym_subscript_expression] = STATE(978),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1967),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(977),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(380),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(881),
    [anon_sym_export] = ACTIONS(617),
    [anon_sym_namespace] = ACTIONS(619),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_type] = ACTIONS(617),
    [anon_sym_typeof] = ACTIONS(639),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(625),
    [anon_sym_yield] = ACTIONS(627),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(631),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(887),
    [anon_sym_PLUS] = ACTIONS(889),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(623),
    [anon_sym_void] = ACTIONS(639),
    [anon_sym_delete] = ACTIONS(639),
    [anon_sym_PLUS_PLUS] = ACTIONS(641),
    [anon_sym_DASH_DASH] = ACTIONS(641),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(617),
    [anon_sym_get] = ACTIONS(617),
    [anon_sym_set] = ACTIONS(617),
    [anon_sym_declare] = ACTIONS(617),
    [anon_sym_public] = ACTIONS(617),
    [anon_sym_private] = ACTIONS(617),
    [anon_sym_protected] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(617),
    [anon_sym_any] = ACTIONS(617),
    [anon_sym_number] = ACTIONS(617),
    [anon_sym_boolean] = ACTIONS(617),
    [anon_sym_string] = ACTIONS(617),
    [anon_sym_symbol] = ACTIONS(617),
    [sym_readonly] = ACTIONS(617),
  },
  [351] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(884),
    [sym__expression] = STATE(1059),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1283),
    [sym_array] = STATE(1281),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3336),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(884),
    [sym_subscript_expression] = STATE(884),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1964),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(860),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(414),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(831),
    [anon_sym_export] = ACTIONS(503),
    [anon_sym_namespace] = ACTIONS(505),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_type] = ACTIONS(503),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(437),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(443),
    [anon_sym_yield] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(849),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(851),
    [anon_sym_TILDE] = ACTIONS(437),
    [anon_sym_void] = ACTIONS(471),
    [anon_sym_delete] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(473),
    [anon_sym_DASH_DASH] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(503),
    [anon_sym_get] = ACTIONS(503),
    [anon_sym_set] = ACTIONS(503),
    [anon_sym_declare] = ACTIONS(503),
    [anon_sym_public] = ACTIONS(503),
    [anon_sym_private] = ACTIONS(503),
    [anon_sym_protected] = ACTIONS(503),
    [anon_sym_module] = ACTIONS(503),
    [anon_sym_any] = ACTIONS(503),
    [anon_sym_number] = ACTIONS(503),
    [anon_sym_boolean] = ACTIONS(503),
    [anon_sym_string] = ACTIONS(503),
    [anon_sym_symbol] = ACTIONS(503),
    [sym_readonly] = ACTIONS(503),
  },
  [352] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(978),
    [sym__expression] = STATE(1473),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1696),
    [sym_array] = STATE(1691),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3169),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(978),
    [sym_subscript_expression] = STATE(978),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1967),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(977),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(380),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(881),
    [anon_sym_export] = ACTIONS(617),
    [anon_sym_namespace] = ACTIONS(619),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_type] = ACTIONS(617),
    [anon_sym_typeof] = ACTIONS(639),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(625),
    [anon_sym_yield] = ACTIONS(627),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(631),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(887),
    [anon_sym_PLUS] = ACTIONS(889),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(623),
    [anon_sym_void] = ACTIONS(639),
    [anon_sym_delete] = ACTIONS(639),
    [anon_sym_PLUS_PLUS] = ACTIONS(641),
    [anon_sym_DASH_DASH] = ACTIONS(641),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(617),
    [anon_sym_get] = ACTIONS(617),
    [anon_sym_set] = ACTIONS(617),
    [anon_sym_declare] = ACTIONS(617),
    [anon_sym_public] = ACTIONS(617),
    [anon_sym_private] = ACTIONS(617),
    [anon_sym_protected] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(617),
    [anon_sym_any] = ACTIONS(617),
    [anon_sym_number] = ACTIONS(617),
    [anon_sym_boolean] = ACTIONS(617),
    [anon_sym_string] = ACTIONS(617),
    [anon_sym_symbol] = ACTIONS(617),
    [sym_readonly] = ACTIONS(617),
  },
  [353] = {
    [sym_import] = STATE(1528),
    [sym_parenthesized_expression] = STATE(983),
    [sym__expression] = STATE(1436),
    [sym_yield_expression] = STATE(1543),
    [sym_object] = STATE(1671),
    [sym_array] = STATE(1713),
    [sym_class] = STATE(1528),
    [sym_function] = STATE(1528),
    [sym_generator_function] = STATE(1528),
    [sym_arrow_function] = STATE(1528),
    [sym__call_signature] = STATE(3235),
    [sym_call_expression] = STATE(1528),
    [sym_new_expression] = STATE(1543),
    [sym_await_expression] = STATE(1543),
    [sym_member_expression] = STATE(983),
    [sym_subscript_expression] = STATE(983),
    [sym_assignment_expression] = STATE(1543),
    [sym__augmented_assignment_lhs] = STATE(1963),
    [sym_augmented_assignment_expression] = STATE(1543),
    [sym_ternary_expression] = STATE(1543),
    [sym_binary_expression] = STATE(1543),
    [sym_unary_expression] = STATE(1543),
    [sym_update_expression] = STATE(1543),
    [sym_string] = STATE(1528),
    [sym_template_string] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_meta_property] = STATE(1528),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(984),
    [sym_type_assertion] = STATE(1543),
    [sym_as_expression] = STATE(1543),
    [sym_internal_module] = STATE(1543),
    [sym_type_arguments] = STATE(310),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2726),
    [sym_identifier] = ACTIONS(891),
    [anon_sym_export] = ACTIONS(529),
    [anon_sym_namespace] = ACTIONS(531),
    [anon_sym_LBRACE] = ACTIONS(859),
    [anon_sym_type] = ACTIONS(529),
    [anon_sym_typeof] = ACTIONS(561),
    [anon_sym_import] = ACTIONS(537),
    [anon_sym_BANG] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(543),
    [anon_sym_yield] = ACTIONS(545),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(549),
    [anon_sym_async] = ACTIONS(551),
    [anon_sym_function] = ACTIONS(553),
    [anon_sym_new] = ACTIONS(897),
    [anon_sym_PLUS] = ACTIONS(899),
    [anon_sym_DASH] = ACTIONS(899),
    [anon_sym_TILDE] = ACTIONS(539),
    [anon_sym_void] = ACTIONS(561),
    [anon_sym_delete] = ACTIONS(561),
    [anon_sym_PLUS_PLUS] = ACTIONS(563),
    [anon_sym_DASH_DASH] = ACTIONS(563),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(529),
    [anon_sym_get] = ACTIONS(529),
    [anon_sym_set] = ACTIONS(529),
    [anon_sym_declare] = ACTIONS(529),
    [anon_sym_public] = ACTIONS(529),
    [anon_sym_private] = ACTIONS(529),
    [anon_sym_protected] = ACTIONS(529),
    [anon_sym_module] = ACTIONS(529),
    [anon_sym_any] = ACTIONS(529),
    [anon_sym_number] = ACTIONS(529),
    [anon_sym_boolean] = ACTIONS(529),
    [anon_sym_string] = ACTIONS(529),
    [anon_sym_symbol] = ACTIONS(529),
    [sym_readonly] = ACTIONS(529),
  },
  [354] = {
    [sym_import] = STATE(1528),
    [sym_parenthesized_expression] = STATE(933),
    [sym__expression] = STATE(1222),
    [sym_yield_expression] = STATE(1543),
    [sym_object] = STATE(1367),
    [sym_array] = STATE(1369),
    [sym_class] = STATE(1528),
    [sym_function] = STATE(1528),
    [sym_generator_function] = STATE(1528),
    [sym_arrow_function] = STATE(1528),
    [sym__call_signature] = STATE(3359),
    [sym_call_expression] = STATE(1528),
    [sym_new_expression] = STATE(1543),
    [sym_await_expression] = STATE(1543),
    [sym_member_expression] = STATE(933),
    [sym_subscript_expression] = STATE(933),
    [sym_assignment_expression] = STATE(1543),
    [sym__augmented_assignment_lhs] = STATE(1970),
    [sym_augmented_assignment_expression] = STATE(1543),
    [sym_ternary_expression] = STATE(1543),
    [sym_binary_expression] = STATE(1543),
    [sym_unary_expression] = STATE(1543),
    [sym_update_expression] = STATE(1543),
    [sym_string] = STATE(1528),
    [sym_template_string] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_meta_property] = STATE(1528),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(936),
    [sym_type_assertion] = STATE(1543),
    [sym_as_expression] = STATE(1543),
    [sym_internal_module] = STATE(1543),
    [sym_type_arguments] = STATE(381),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2726),
    [sym_identifier] = ACTIONS(855),
    [anon_sym_export] = ACTIONS(745),
    [anon_sym_namespace] = ACTIONS(747),
    [anon_sym_LBRACE] = ACTIONS(859),
    [anon_sym_type] = ACTIONS(745),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(537),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(549),
    [anon_sym_async] = ACTIONS(753),
    [anon_sym_function] = ACTIONS(553),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(745),
    [anon_sym_get] = ACTIONS(745),
    [anon_sym_set] = ACTIONS(745),
    [anon_sym_declare] = ACTIONS(745),
    [anon_sym_public] = ACTIONS(745),
    [anon_sym_private] = ACTIONS(745),
    [anon_sym_protected] = ACTIONS(745),
    [anon_sym_module] = ACTIONS(745),
    [anon_sym_any] = ACTIONS(745),
    [anon_sym_number] = ACTIONS(745),
    [anon_sym_boolean] = ACTIONS(745),
    [anon_sym_string] = ACTIONS(745),
    [anon_sym_symbol] = ACTIONS(745),
    [sym_readonly] = ACTIONS(745),
  },
  [355] = {
    [sym_import] = STATE(1528),
    [sym_parenthesized_expression] = STATE(933),
    [sym__expression] = STATE(1144),
    [sym_yield_expression] = STATE(1543),
    [sym_object] = STATE(1367),
    [sym_array] = STATE(1369),
    [sym_class] = STATE(1528),
    [sym_function] = STATE(1528),
    [sym_generator_function] = STATE(1528),
    [sym_arrow_function] = STATE(1528),
    [sym__call_signature] = STATE(3359),
    [sym_call_expression] = STATE(1528),
    [sym_new_expression] = STATE(1543),
    [sym_await_expression] = STATE(1543),
    [sym_member_expression] = STATE(933),
    [sym_subscript_expression] = STATE(933),
    [sym_assignment_expression] = STATE(1543),
    [sym__augmented_assignment_lhs] = STATE(1970),
    [sym_augmented_assignment_expression] = STATE(1543),
    [sym_ternary_expression] = STATE(1543),
    [sym_binary_expression] = STATE(1543),
    [sym_unary_expression] = STATE(1543),
    [sym_update_expression] = STATE(1543),
    [sym_string] = STATE(1528),
    [sym_template_string] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_meta_property] = STATE(1528),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(936),
    [sym_type_assertion] = STATE(1543),
    [sym_as_expression] = STATE(1543),
    [sym_internal_module] = STATE(1543),
    [sym_type_arguments] = STATE(381),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2726),
    [sym_identifier] = ACTIONS(855),
    [anon_sym_export] = ACTIONS(745),
    [anon_sym_namespace] = ACTIONS(747),
    [anon_sym_LBRACE] = ACTIONS(859),
    [anon_sym_type] = ACTIONS(745),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(537),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(549),
    [anon_sym_async] = ACTIONS(753),
    [anon_sym_function] = ACTIONS(553),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(745),
    [anon_sym_get] = ACTIONS(745),
    [anon_sym_set] = ACTIONS(745),
    [anon_sym_declare] = ACTIONS(745),
    [anon_sym_public] = ACTIONS(745),
    [anon_sym_private] = ACTIONS(745),
    [anon_sym_protected] = ACTIONS(745),
    [anon_sym_module] = ACTIONS(745),
    [anon_sym_any] = ACTIONS(745),
    [anon_sym_number] = ACTIONS(745),
    [anon_sym_boolean] = ACTIONS(745),
    [anon_sym_string] = ACTIONS(745),
    [anon_sym_symbol] = ACTIONS(745),
    [sym_readonly] = ACTIONS(745),
  },
  [356] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(884),
    [sym__expression] = STATE(1122),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1283),
    [sym_array] = STATE(1281),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3336),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(884),
    [sym_subscript_expression] = STATE(884),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1964),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(860),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(414),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(831),
    [anon_sym_export] = ACTIONS(503),
    [anon_sym_namespace] = ACTIONS(505),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_type] = ACTIONS(503),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(437),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(443),
    [anon_sym_yield] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(849),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(851),
    [anon_sym_TILDE] = ACTIONS(437),
    [anon_sym_void] = ACTIONS(471),
    [anon_sym_delete] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(473),
    [anon_sym_DASH_DASH] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(1505),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(503),
    [anon_sym_get] = ACTIONS(503),
    [anon_sym_set] = ACTIONS(503),
    [anon_sym_declare] = ACTIONS(503),
    [anon_sym_public] = ACTIONS(503),
    [anon_sym_private] = ACTIONS(503),
    [anon_sym_protected] = ACTIONS(503),
    [anon_sym_module] = ACTIONS(503),
    [anon_sym_any] = ACTIONS(503),
    [anon_sym_number] = ACTIONS(503),
    [anon_sym_boolean] = ACTIONS(503),
    [anon_sym_string] = ACTIONS(503),
    [anon_sym_symbol] = ACTIONS(503),
    [sym_readonly] = ACTIONS(503),
  },
  [357] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(963),
    [sym__expression] = STATE(1264),
    [sym_yield_expression] = STATE(1722),
    [sym_object] = STATE(1536),
    [sym_array] = STATE(1535),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(3286),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1722),
    [sym_await_expression] = STATE(1722),
    [sym_member_expression] = STATE(963),
    [sym_subscript_expression] = STATE(963),
    [sym_assignment_expression] = STATE(1722),
    [sym__augmented_assignment_lhs] = STATE(1968),
    [sym_augmented_assignment_expression] = STATE(1722),
    [sym_ternary_expression] = STATE(1722),
    [sym_binary_expression] = STATE(1722),
    [sym_unary_expression] = STATE(1722),
    [sym_update_expression] = STATE(1722),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(952),
    [sym_type_assertion] = STATE(1722),
    [sym_as_expression] = STATE(1722),
    [sym_internal_module] = STATE(1722),
    [sym_type_arguments] = STATE(266),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2684),
    [sym_identifier] = ACTIONS(863),
    [anon_sym_export] = ACTIONS(655),
    [anon_sym_namespace] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(1270),
    [anon_sym_type] = ACTIONS(655),
    [anon_sym_typeof] = ACTIONS(689),
    [anon_sym_import] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_LPAREN] = ACTIONS(871),
    [anon_sym_await] = ACTIONS(669),
    [anon_sym_yield] = ACTIONS(671),
    [anon_sym_LBRACK] = ACTIONS(873),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(675),
    [anon_sym_class] = ACTIONS(677),
    [anon_sym_async] = ACTIONS(679),
    [anon_sym_function] = ACTIONS(681),
    [anon_sym_new] = ACTIONS(875),
    [anon_sym_PLUS] = ACTIONS(877),
    [anon_sym_DASH] = ACTIONS(877),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_void] = ACTIONS(689),
    [anon_sym_delete] = ACTIONS(689),
    [anon_sym_PLUS_PLUS] = ACTIONS(691),
    [anon_sym_DASH_DASH] = ACTIONS(691),
    [anon_sym_DQUOTE] = ACTIONS(693),
    [anon_sym_SQUOTE] = ACTIONS(695),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(697),
    [sym_number] = ACTIONS(879),
    [sym_this] = ACTIONS(703),
    [sym_super] = ACTIONS(703),
    [sym_true] = ACTIONS(703),
    [sym_false] = ACTIONS(703),
    [sym_null] = ACTIONS(703),
    [sym_undefined] = ACTIONS(703),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(655),
    [anon_sym_get] = ACTIONS(655),
    [anon_sym_set] = ACTIONS(655),
    [anon_sym_declare] = ACTIONS(655),
    [anon_sym_public] = ACTIONS(655),
    [anon_sym_private] = ACTIONS(655),
    [anon_sym_protected] = ACTIONS(655),
    [anon_sym_module] = ACTIONS(655),
    [anon_sym_any] = ACTIONS(655),
    [anon_sym_number] = ACTIONS(655),
    [anon_sym_boolean] = ACTIONS(655),
    [anon_sym_string] = ACTIONS(655),
    [anon_sym_symbol] = ACTIONS(655),
    [sym_readonly] = ACTIONS(655),
  },
  [358] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(884),
    [sym__expression] = STATE(1122),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1283),
    [sym_array] = STATE(1281),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3336),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(884),
    [sym_subscript_expression] = STATE(884),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1964),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(860),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(414),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(831),
    [anon_sym_export] = ACTIONS(503),
    [anon_sym_namespace] = ACTIONS(505),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_type] = ACTIONS(503),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(437),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(443),
    [anon_sym_yield] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(849),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(851),
    [anon_sym_TILDE] = ACTIONS(437),
    [anon_sym_void] = ACTIONS(471),
    [anon_sym_delete] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(473),
    [anon_sym_DASH_DASH] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(503),
    [anon_sym_get] = ACTIONS(503),
    [anon_sym_set] = ACTIONS(503),
    [anon_sym_declare] = ACTIONS(503),
    [anon_sym_public] = ACTIONS(503),
    [anon_sym_private] = ACTIONS(503),
    [anon_sym_protected] = ACTIONS(503),
    [anon_sym_module] = ACTIONS(503),
    [anon_sym_any] = ACTIONS(503),
    [anon_sym_number] = ACTIONS(503),
    [anon_sym_boolean] = ACTIONS(503),
    [anon_sym_string] = ACTIONS(503),
    [anon_sym_symbol] = ACTIONS(503),
    [sym_readonly] = ACTIONS(503),
  },
  [359] = {
    [sym_import] = STATE(1528),
    [sym_parenthesized_expression] = STATE(933),
    [sym__expression] = STATE(1141),
    [sym_yield_expression] = STATE(1543),
    [sym_object] = STATE(1367),
    [sym_array] = STATE(1369),
    [sym_class] = STATE(1528),
    [sym_function] = STATE(1528),
    [sym_generator_function] = STATE(1528),
    [sym_arrow_function] = STATE(1528),
    [sym__call_signature] = STATE(3359),
    [sym_call_expression] = STATE(1528),
    [sym_new_expression] = STATE(1543),
    [sym_await_expression] = STATE(1543),
    [sym_member_expression] = STATE(933),
    [sym_subscript_expression] = STATE(933),
    [sym_assignment_expression] = STATE(1543),
    [sym__augmented_assignment_lhs] = STATE(1970),
    [sym_augmented_assignment_expression] = STATE(1543),
    [sym_ternary_expression] = STATE(1543),
    [sym_binary_expression] = STATE(1543),
    [sym_unary_expression] = STATE(1543),
    [sym_update_expression] = STATE(1543),
    [sym_string] = STATE(1528),
    [sym_template_string] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_meta_property] = STATE(1528),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(936),
    [sym_type_assertion] = STATE(1543),
    [sym_as_expression] = STATE(1543),
    [sym_internal_module] = STATE(1543),
    [sym_type_arguments] = STATE(381),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2726),
    [sym_identifier] = ACTIONS(855),
    [anon_sym_export] = ACTIONS(745),
    [anon_sym_namespace] = ACTIONS(747),
    [anon_sym_LBRACE] = ACTIONS(859),
    [anon_sym_type] = ACTIONS(745),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(537),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(549),
    [anon_sym_async] = ACTIONS(753),
    [anon_sym_function] = ACTIONS(553),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(745),
    [anon_sym_get] = ACTIONS(745),
    [anon_sym_set] = ACTIONS(745),
    [anon_sym_declare] = ACTIONS(745),
    [anon_sym_public] = ACTIONS(745),
    [anon_sym_private] = ACTIONS(745),
    [anon_sym_protected] = ACTIONS(745),
    [anon_sym_module] = ACTIONS(745),
    [anon_sym_any] = ACTIONS(745),
    [anon_sym_number] = ACTIONS(745),
    [anon_sym_boolean] = ACTIONS(745),
    [anon_sym_string] = ACTIONS(745),
    [anon_sym_symbol] = ACTIONS(745),
    [sym_readonly] = ACTIONS(745),
  },
  [360] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(884),
    [sym__expression] = STATE(1020),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1283),
    [sym_array] = STATE(1281),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3336),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(884),
    [sym_subscript_expression] = STATE(884),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1964),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(860),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(414),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(831),
    [anon_sym_export] = ACTIONS(503),
    [anon_sym_namespace] = ACTIONS(505),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_type] = ACTIONS(503),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(437),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(443),
    [anon_sym_yield] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(849),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(851),
    [anon_sym_TILDE] = ACTIONS(437),
    [anon_sym_void] = ACTIONS(471),
    [anon_sym_delete] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(473),
    [anon_sym_DASH_DASH] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(503),
    [anon_sym_get] = ACTIONS(503),
    [anon_sym_set] = ACTIONS(503),
    [anon_sym_declare] = ACTIONS(503),
    [anon_sym_public] = ACTIONS(503),
    [anon_sym_private] = ACTIONS(503),
    [anon_sym_protected] = ACTIONS(503),
    [anon_sym_module] = ACTIONS(503),
    [anon_sym_any] = ACTIONS(503),
    [anon_sym_number] = ACTIONS(503),
    [anon_sym_boolean] = ACTIONS(503),
    [anon_sym_string] = ACTIONS(503),
    [anon_sym_symbol] = ACTIONS(503),
    [sym_readonly] = ACTIONS(503),
  },
  [361] = {
    [sym_import] = STATE(1528),
    [sym_parenthesized_expression] = STATE(933),
    [sym__expression] = STATE(1155),
    [sym_yield_expression] = STATE(1543),
    [sym_object] = STATE(1367),
    [sym_array] = STATE(1369),
    [sym_class] = STATE(1528),
    [sym_function] = STATE(1528),
    [sym_generator_function] = STATE(1528),
    [sym_arrow_function] = STATE(1528),
    [sym__call_signature] = STATE(3359),
    [sym_call_expression] = STATE(1528),
    [sym_new_expression] = STATE(1543),
    [sym_await_expression] = STATE(1543),
    [sym_member_expression] = STATE(933),
    [sym_subscript_expression] = STATE(933),
    [sym_assignment_expression] = STATE(1543),
    [sym__augmented_assignment_lhs] = STATE(1970),
    [sym_augmented_assignment_expression] = STATE(1543),
    [sym_ternary_expression] = STATE(1543),
    [sym_binary_expression] = STATE(1543),
    [sym_unary_expression] = STATE(1543),
    [sym_update_expression] = STATE(1543),
    [sym_string] = STATE(1528),
    [sym_template_string] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_meta_property] = STATE(1528),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(936),
    [sym_type_assertion] = STATE(1543),
    [sym_as_expression] = STATE(1543),
    [sym_internal_module] = STATE(1543),
    [sym_type_arguments] = STATE(381),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2726),
    [sym_identifier] = ACTIONS(855),
    [anon_sym_export] = ACTIONS(745),
    [anon_sym_namespace] = ACTIONS(747),
    [anon_sym_LBRACE] = ACTIONS(859),
    [anon_sym_type] = ACTIONS(745),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(537),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(549),
    [anon_sym_async] = ACTIONS(753),
    [anon_sym_function] = ACTIONS(553),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(745),
    [anon_sym_get] = ACTIONS(745),
    [anon_sym_set] = ACTIONS(745),
    [anon_sym_declare] = ACTIONS(745),
    [anon_sym_public] = ACTIONS(745),
    [anon_sym_private] = ACTIONS(745),
    [anon_sym_protected] = ACTIONS(745),
    [anon_sym_module] = ACTIONS(745),
    [anon_sym_any] = ACTIONS(745),
    [anon_sym_number] = ACTIONS(745),
    [anon_sym_boolean] = ACTIONS(745),
    [anon_sym_string] = ACTIONS(745),
    [anon_sym_symbol] = ACTIONS(745),
    [sym_readonly] = ACTIONS(745),
  },
  [362] = {
    [sym_import] = STATE(1528),
    [sym_parenthesized_expression] = STATE(933),
    [sym__expression] = STATE(1138),
    [sym_yield_expression] = STATE(1543),
    [sym_object] = STATE(1367),
    [sym_array] = STATE(1369),
    [sym_class] = STATE(1528),
    [sym_function] = STATE(1528),
    [sym_generator_function] = STATE(1528),
    [sym_arrow_function] = STATE(1528),
    [sym__call_signature] = STATE(3359),
    [sym_call_expression] = STATE(1528),
    [sym_new_expression] = STATE(1543),
    [sym_await_expression] = STATE(1543),
    [sym_member_expression] = STATE(933),
    [sym_subscript_expression] = STATE(933),
    [sym_assignment_expression] = STATE(1543),
    [sym__augmented_assignment_lhs] = STATE(1970),
    [sym_augmented_assignment_expression] = STATE(1543),
    [sym_ternary_expression] = STATE(1543),
    [sym_binary_expression] = STATE(1543),
    [sym_unary_expression] = STATE(1543),
    [sym_update_expression] = STATE(1543),
    [sym_string] = STATE(1528),
    [sym_template_string] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_meta_property] = STATE(1528),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(936),
    [sym_type_assertion] = STATE(1543),
    [sym_as_expression] = STATE(1543),
    [sym_internal_module] = STATE(1543),
    [sym_type_arguments] = STATE(381),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2726),
    [sym_identifier] = ACTIONS(855),
    [anon_sym_export] = ACTIONS(745),
    [anon_sym_namespace] = ACTIONS(747),
    [anon_sym_LBRACE] = ACTIONS(859),
    [anon_sym_type] = ACTIONS(745),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(537),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(549),
    [anon_sym_async] = ACTIONS(753),
    [anon_sym_function] = ACTIONS(553),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(745),
    [anon_sym_get] = ACTIONS(745),
    [anon_sym_set] = ACTIONS(745),
    [anon_sym_declare] = ACTIONS(745),
    [anon_sym_public] = ACTIONS(745),
    [anon_sym_private] = ACTIONS(745),
    [anon_sym_protected] = ACTIONS(745),
    [anon_sym_module] = ACTIONS(745),
    [anon_sym_any] = ACTIONS(745),
    [anon_sym_number] = ACTIONS(745),
    [anon_sym_boolean] = ACTIONS(745),
    [anon_sym_string] = ACTIONS(745),
    [anon_sym_symbol] = ACTIONS(745),
    [sym_readonly] = ACTIONS(745),
  },
  [363] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(884),
    [sym__expression] = STATE(1352),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1283),
    [sym_array] = STATE(1281),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3336),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(884),
    [sym_subscript_expression] = STATE(884),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1964),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(860),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(414),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(831),
    [anon_sym_export] = ACTIONS(503),
    [anon_sym_namespace] = ACTIONS(505),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_type] = ACTIONS(503),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(437),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(443),
    [anon_sym_yield] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(849),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(851),
    [anon_sym_TILDE] = ACTIONS(437),
    [anon_sym_void] = ACTIONS(471),
    [anon_sym_delete] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(473),
    [anon_sym_DASH_DASH] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(503),
    [anon_sym_get] = ACTIONS(503),
    [anon_sym_set] = ACTIONS(503),
    [anon_sym_declare] = ACTIONS(503),
    [anon_sym_public] = ACTIONS(503),
    [anon_sym_private] = ACTIONS(503),
    [anon_sym_protected] = ACTIONS(503),
    [anon_sym_module] = ACTIONS(503),
    [anon_sym_any] = ACTIONS(503),
    [anon_sym_number] = ACTIONS(503),
    [anon_sym_boolean] = ACTIONS(503),
    [anon_sym_string] = ACTIONS(503),
    [anon_sym_symbol] = ACTIONS(503),
    [sym_readonly] = ACTIONS(503),
  },
  [364] = {
    [sym_import] = STATE(1528),
    [sym_parenthesized_expression] = STATE(933),
    [sym__expression] = STATE(1326),
    [sym_yield_expression] = STATE(1543),
    [sym_object] = STATE(1367),
    [sym_array] = STATE(1369),
    [sym_class] = STATE(1528),
    [sym_function] = STATE(1528),
    [sym_generator_function] = STATE(1528),
    [sym_arrow_function] = STATE(1528),
    [sym__call_signature] = STATE(3359),
    [sym_call_expression] = STATE(1528),
    [sym_new_expression] = STATE(1543),
    [sym_await_expression] = STATE(1543),
    [sym_member_expression] = STATE(933),
    [sym_subscript_expression] = STATE(933),
    [sym_assignment_expression] = STATE(1543),
    [sym__augmented_assignment_lhs] = STATE(1970),
    [sym_augmented_assignment_expression] = STATE(1543),
    [sym_ternary_expression] = STATE(1543),
    [sym_binary_expression] = STATE(1543),
    [sym_unary_expression] = STATE(1543),
    [sym_update_expression] = STATE(1543),
    [sym_string] = STATE(1528),
    [sym_template_string] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_meta_property] = STATE(1528),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(936),
    [sym_type_assertion] = STATE(1543),
    [sym_as_expression] = STATE(1543),
    [sym_internal_module] = STATE(1543),
    [sym_type_arguments] = STATE(381),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2726),
    [sym_identifier] = ACTIONS(855),
    [anon_sym_export] = ACTIONS(745),
    [anon_sym_namespace] = ACTIONS(747),
    [anon_sym_LBRACE] = ACTIONS(859),
    [anon_sym_type] = ACTIONS(745),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(537),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(549),
    [anon_sym_async] = ACTIONS(753),
    [anon_sym_function] = ACTIONS(553),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(745),
    [anon_sym_get] = ACTIONS(745),
    [anon_sym_set] = ACTIONS(745),
    [anon_sym_declare] = ACTIONS(745),
    [anon_sym_public] = ACTIONS(745),
    [anon_sym_private] = ACTIONS(745),
    [anon_sym_protected] = ACTIONS(745),
    [anon_sym_module] = ACTIONS(745),
    [anon_sym_any] = ACTIONS(745),
    [anon_sym_number] = ACTIONS(745),
    [anon_sym_boolean] = ACTIONS(745),
    [anon_sym_string] = ACTIONS(745),
    [anon_sym_symbol] = ACTIONS(745),
    [sym_readonly] = ACTIONS(745),
  },
  [365] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(978),
    [sym__expression] = STATE(1642),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1696),
    [sym_array] = STATE(1691),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3169),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(978),
    [sym_subscript_expression] = STATE(978),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1967),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(977),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(380),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(881),
    [anon_sym_export] = ACTIONS(617),
    [anon_sym_namespace] = ACTIONS(619),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_type] = ACTIONS(617),
    [anon_sym_typeof] = ACTIONS(639),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(625),
    [anon_sym_yield] = ACTIONS(627),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(631),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(887),
    [anon_sym_PLUS] = ACTIONS(889),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(623),
    [anon_sym_void] = ACTIONS(639),
    [anon_sym_delete] = ACTIONS(639),
    [anon_sym_PLUS_PLUS] = ACTIONS(641),
    [anon_sym_DASH_DASH] = ACTIONS(641),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(617),
    [anon_sym_get] = ACTIONS(617),
    [anon_sym_set] = ACTIONS(617),
    [anon_sym_declare] = ACTIONS(617),
    [anon_sym_public] = ACTIONS(617),
    [anon_sym_private] = ACTIONS(617),
    [anon_sym_protected] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(617),
    [anon_sym_any] = ACTIONS(617),
    [anon_sym_number] = ACTIONS(617),
    [anon_sym_boolean] = ACTIONS(617),
    [anon_sym_string] = ACTIONS(617),
    [anon_sym_symbol] = ACTIONS(617),
    [sym_readonly] = ACTIONS(617),
  },
  [366] = {
    [sym_import] = STATE(1528),
    [sym_parenthesized_expression] = STATE(983),
    [sym__expression] = STATE(1437),
    [sym_yield_expression] = STATE(1543),
    [sym_object] = STATE(1671),
    [sym_array] = STATE(1713),
    [sym_class] = STATE(1528),
    [sym_function] = STATE(1528),
    [sym_generator_function] = STATE(1528),
    [sym_arrow_function] = STATE(1528),
    [sym__call_signature] = STATE(3235),
    [sym_call_expression] = STATE(1528),
    [sym_new_expression] = STATE(1543),
    [sym_await_expression] = STATE(1543),
    [sym_member_expression] = STATE(983),
    [sym_subscript_expression] = STATE(983),
    [sym_assignment_expression] = STATE(1543),
    [sym__augmented_assignment_lhs] = STATE(1963),
    [sym_augmented_assignment_expression] = STATE(1543),
    [sym_ternary_expression] = STATE(1543),
    [sym_binary_expression] = STATE(1543),
    [sym_unary_expression] = STATE(1543),
    [sym_update_expression] = STATE(1543),
    [sym_string] = STATE(1528),
    [sym_template_string] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_meta_property] = STATE(1528),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(984),
    [sym_type_assertion] = STATE(1543),
    [sym_as_expression] = STATE(1543),
    [sym_internal_module] = STATE(1543),
    [sym_type_arguments] = STATE(310),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2726),
    [sym_identifier] = ACTIONS(891),
    [anon_sym_export] = ACTIONS(529),
    [anon_sym_namespace] = ACTIONS(531),
    [anon_sym_LBRACE] = ACTIONS(859),
    [anon_sym_type] = ACTIONS(529),
    [anon_sym_typeof] = ACTIONS(561),
    [anon_sym_import] = ACTIONS(537),
    [anon_sym_BANG] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(543),
    [anon_sym_yield] = ACTIONS(545),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(549),
    [anon_sym_async] = ACTIONS(551),
    [anon_sym_function] = ACTIONS(553),
    [anon_sym_new] = ACTIONS(897),
    [anon_sym_PLUS] = ACTIONS(899),
    [anon_sym_DASH] = ACTIONS(899),
    [anon_sym_TILDE] = ACTIONS(539),
    [anon_sym_void] = ACTIONS(561),
    [anon_sym_delete] = ACTIONS(561),
    [anon_sym_PLUS_PLUS] = ACTIONS(563),
    [anon_sym_DASH_DASH] = ACTIONS(563),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(529),
    [anon_sym_get] = ACTIONS(529),
    [anon_sym_set] = ACTIONS(529),
    [anon_sym_declare] = ACTIONS(529),
    [anon_sym_public] = ACTIONS(529),
    [anon_sym_private] = ACTIONS(529),
    [anon_sym_protected] = ACTIONS(529),
    [anon_sym_module] = ACTIONS(529),
    [anon_sym_any] = ACTIONS(529),
    [anon_sym_number] = ACTIONS(529),
    [anon_sym_boolean] = ACTIONS(529),
    [anon_sym_string] = ACTIONS(529),
    [anon_sym_symbol] = ACTIONS(529),
    [sym_readonly] = ACTIONS(529),
  },
  [367] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(884),
    [sym__expression] = STATE(1126),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1283),
    [sym_array] = STATE(1281),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3336),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(884),
    [sym_subscript_expression] = STATE(884),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1964),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(860),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(414),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(831),
    [anon_sym_export] = ACTIONS(503),
    [anon_sym_namespace] = ACTIONS(505),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_type] = ACTIONS(503),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(437),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(443),
    [anon_sym_yield] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(849),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(851),
    [anon_sym_TILDE] = ACTIONS(437),
    [anon_sym_void] = ACTIONS(471),
    [anon_sym_delete] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(473),
    [anon_sym_DASH_DASH] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(503),
    [anon_sym_get] = ACTIONS(503),
    [anon_sym_set] = ACTIONS(503),
    [anon_sym_declare] = ACTIONS(503),
    [anon_sym_public] = ACTIONS(503),
    [anon_sym_private] = ACTIONS(503),
    [anon_sym_protected] = ACTIONS(503),
    [anon_sym_module] = ACTIONS(503),
    [anon_sym_any] = ACTIONS(503),
    [anon_sym_number] = ACTIONS(503),
    [anon_sym_boolean] = ACTIONS(503),
    [anon_sym_string] = ACTIONS(503),
    [anon_sym_symbol] = ACTIONS(503),
    [sym_readonly] = ACTIONS(503),
  },
  [368] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(963),
    [sym__expression] = STATE(1299),
    [sym_yield_expression] = STATE(1722),
    [sym_object] = STATE(1536),
    [sym_array] = STATE(1535),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(3286),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1722),
    [sym_await_expression] = STATE(1722),
    [sym_member_expression] = STATE(963),
    [sym_subscript_expression] = STATE(963),
    [sym_assignment_expression] = STATE(1722),
    [sym__augmented_assignment_lhs] = STATE(1968),
    [sym_augmented_assignment_expression] = STATE(1722),
    [sym_ternary_expression] = STATE(1722),
    [sym_binary_expression] = STATE(1722),
    [sym_unary_expression] = STATE(1722),
    [sym_update_expression] = STATE(1722),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(952),
    [sym_type_assertion] = STATE(1722),
    [sym_as_expression] = STATE(1722),
    [sym_internal_module] = STATE(1722),
    [sym_type_arguments] = STATE(266),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2684),
    [sym_identifier] = ACTIONS(863),
    [anon_sym_export] = ACTIONS(655),
    [anon_sym_namespace] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(1270),
    [anon_sym_type] = ACTIONS(655),
    [anon_sym_typeof] = ACTIONS(689),
    [anon_sym_import] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_LPAREN] = ACTIONS(871),
    [anon_sym_await] = ACTIONS(669),
    [anon_sym_yield] = ACTIONS(671),
    [anon_sym_LBRACK] = ACTIONS(873),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(675),
    [anon_sym_class] = ACTIONS(677),
    [anon_sym_async] = ACTIONS(679),
    [anon_sym_function] = ACTIONS(681),
    [anon_sym_new] = ACTIONS(875),
    [anon_sym_PLUS] = ACTIONS(877),
    [anon_sym_DASH] = ACTIONS(877),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_void] = ACTIONS(689),
    [anon_sym_delete] = ACTIONS(689),
    [anon_sym_PLUS_PLUS] = ACTIONS(691),
    [anon_sym_DASH_DASH] = ACTIONS(691),
    [anon_sym_DQUOTE] = ACTIONS(693),
    [anon_sym_SQUOTE] = ACTIONS(695),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(697),
    [sym_number] = ACTIONS(879),
    [sym_this] = ACTIONS(703),
    [sym_super] = ACTIONS(703),
    [sym_true] = ACTIONS(703),
    [sym_false] = ACTIONS(703),
    [sym_null] = ACTIONS(703),
    [sym_undefined] = ACTIONS(703),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(655),
    [anon_sym_get] = ACTIONS(655),
    [anon_sym_set] = ACTIONS(655),
    [anon_sym_declare] = ACTIONS(655),
    [anon_sym_public] = ACTIONS(655),
    [anon_sym_private] = ACTIONS(655),
    [anon_sym_protected] = ACTIONS(655),
    [anon_sym_module] = ACTIONS(655),
    [anon_sym_any] = ACTIONS(655),
    [anon_sym_number] = ACTIONS(655),
    [anon_sym_boolean] = ACTIONS(655),
    [anon_sym_string] = ACTIONS(655),
    [anon_sym_symbol] = ACTIONS(655),
    [sym_readonly] = ACTIONS(655),
  },
  [369] = {
    [sym_import] = STATE(1528),
    [sym_parenthesized_expression] = STATE(983),
    [sym__expression] = STATE(1438),
    [sym_yield_expression] = STATE(1543),
    [sym_object] = STATE(1671),
    [sym_array] = STATE(1713),
    [sym_class] = STATE(1528),
    [sym_function] = STATE(1528),
    [sym_generator_function] = STATE(1528),
    [sym_arrow_function] = STATE(1528),
    [sym__call_signature] = STATE(3235),
    [sym_call_expression] = STATE(1528),
    [sym_new_expression] = STATE(1543),
    [sym_await_expression] = STATE(1543),
    [sym_member_expression] = STATE(983),
    [sym_subscript_expression] = STATE(983),
    [sym_assignment_expression] = STATE(1543),
    [sym__augmented_assignment_lhs] = STATE(1963),
    [sym_augmented_assignment_expression] = STATE(1543),
    [sym_ternary_expression] = STATE(1543),
    [sym_binary_expression] = STATE(1543),
    [sym_unary_expression] = STATE(1543),
    [sym_update_expression] = STATE(1543),
    [sym_string] = STATE(1528),
    [sym_template_string] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_meta_property] = STATE(1528),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(984),
    [sym_type_assertion] = STATE(1543),
    [sym_as_expression] = STATE(1543),
    [sym_internal_module] = STATE(1543),
    [sym_type_arguments] = STATE(310),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2726),
    [sym_identifier] = ACTIONS(891),
    [anon_sym_export] = ACTIONS(529),
    [anon_sym_namespace] = ACTIONS(531),
    [anon_sym_LBRACE] = ACTIONS(859),
    [anon_sym_type] = ACTIONS(529),
    [anon_sym_typeof] = ACTIONS(561),
    [anon_sym_import] = ACTIONS(537),
    [anon_sym_BANG] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(543),
    [anon_sym_yield] = ACTIONS(545),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(549),
    [anon_sym_async] = ACTIONS(551),
    [anon_sym_function] = ACTIONS(553),
    [anon_sym_new] = ACTIONS(897),
    [anon_sym_PLUS] = ACTIONS(899),
    [anon_sym_DASH] = ACTIONS(899),
    [anon_sym_TILDE] = ACTIONS(539),
    [anon_sym_void] = ACTIONS(561),
    [anon_sym_delete] = ACTIONS(561),
    [anon_sym_PLUS_PLUS] = ACTIONS(563),
    [anon_sym_DASH_DASH] = ACTIONS(563),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(529),
    [anon_sym_get] = ACTIONS(529),
    [anon_sym_set] = ACTIONS(529),
    [anon_sym_declare] = ACTIONS(529),
    [anon_sym_public] = ACTIONS(529),
    [anon_sym_private] = ACTIONS(529),
    [anon_sym_protected] = ACTIONS(529),
    [anon_sym_module] = ACTIONS(529),
    [anon_sym_any] = ACTIONS(529),
    [anon_sym_number] = ACTIONS(529),
    [anon_sym_boolean] = ACTIONS(529),
    [anon_sym_string] = ACTIONS(529),
    [anon_sym_symbol] = ACTIONS(529),
    [sym_readonly] = ACTIONS(529),
  },
  [370] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(963),
    [sym__expression] = STATE(1263),
    [sym_yield_expression] = STATE(1722),
    [sym_object] = STATE(1536),
    [sym_array] = STATE(1535),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(3286),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1722),
    [sym_await_expression] = STATE(1722),
    [sym_member_expression] = STATE(963),
    [sym_subscript_expression] = STATE(963),
    [sym_assignment_expression] = STATE(1722),
    [sym__augmented_assignment_lhs] = STATE(1968),
    [sym_augmented_assignment_expression] = STATE(1722),
    [sym_ternary_expression] = STATE(1722),
    [sym_binary_expression] = STATE(1722),
    [sym_unary_expression] = STATE(1722),
    [sym_update_expression] = STATE(1722),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(952),
    [sym_type_assertion] = STATE(1722),
    [sym_as_expression] = STATE(1722),
    [sym_internal_module] = STATE(1722),
    [sym_type_arguments] = STATE(266),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2684),
    [sym_identifier] = ACTIONS(863),
    [anon_sym_export] = ACTIONS(655),
    [anon_sym_namespace] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(1270),
    [anon_sym_type] = ACTIONS(655),
    [anon_sym_typeof] = ACTIONS(689),
    [anon_sym_import] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_LPAREN] = ACTIONS(871),
    [anon_sym_await] = ACTIONS(669),
    [anon_sym_yield] = ACTIONS(671),
    [anon_sym_LBRACK] = ACTIONS(873),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(675),
    [anon_sym_class] = ACTIONS(677),
    [anon_sym_async] = ACTIONS(679),
    [anon_sym_function] = ACTIONS(681),
    [anon_sym_new] = ACTIONS(875),
    [anon_sym_PLUS] = ACTIONS(877),
    [anon_sym_DASH] = ACTIONS(877),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_void] = ACTIONS(689),
    [anon_sym_delete] = ACTIONS(689),
    [anon_sym_PLUS_PLUS] = ACTIONS(691),
    [anon_sym_DASH_DASH] = ACTIONS(691),
    [anon_sym_DQUOTE] = ACTIONS(693),
    [anon_sym_SQUOTE] = ACTIONS(695),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(697),
    [sym_number] = ACTIONS(879),
    [sym_this] = ACTIONS(703),
    [sym_super] = ACTIONS(703),
    [sym_true] = ACTIONS(703),
    [sym_false] = ACTIONS(703),
    [sym_null] = ACTIONS(703),
    [sym_undefined] = ACTIONS(703),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(655),
    [anon_sym_get] = ACTIONS(655),
    [anon_sym_set] = ACTIONS(655),
    [anon_sym_declare] = ACTIONS(655),
    [anon_sym_public] = ACTIONS(655),
    [anon_sym_private] = ACTIONS(655),
    [anon_sym_protected] = ACTIONS(655),
    [anon_sym_module] = ACTIONS(655),
    [anon_sym_any] = ACTIONS(655),
    [anon_sym_number] = ACTIONS(655),
    [anon_sym_boolean] = ACTIONS(655),
    [anon_sym_string] = ACTIONS(655),
    [anon_sym_symbol] = ACTIONS(655),
    [sym_readonly] = ACTIONS(655),
  },
  [371] = {
    [sym_import] = STATE(1528),
    [sym_parenthesized_expression] = STATE(933),
    [sym__expression] = STATE(1325),
    [sym_yield_expression] = STATE(1543),
    [sym_object] = STATE(1367),
    [sym_array] = STATE(1369),
    [sym_class] = STATE(1528),
    [sym_function] = STATE(1528),
    [sym_generator_function] = STATE(1528),
    [sym_arrow_function] = STATE(1528),
    [sym__call_signature] = STATE(3359),
    [sym_call_expression] = STATE(1528),
    [sym_new_expression] = STATE(1543),
    [sym_await_expression] = STATE(1543),
    [sym_member_expression] = STATE(933),
    [sym_subscript_expression] = STATE(933),
    [sym_assignment_expression] = STATE(1543),
    [sym__augmented_assignment_lhs] = STATE(1970),
    [sym_augmented_assignment_expression] = STATE(1543),
    [sym_ternary_expression] = STATE(1543),
    [sym_binary_expression] = STATE(1543),
    [sym_unary_expression] = STATE(1543),
    [sym_update_expression] = STATE(1543),
    [sym_string] = STATE(1528),
    [sym_template_string] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_meta_property] = STATE(1528),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(936),
    [sym_type_assertion] = STATE(1543),
    [sym_as_expression] = STATE(1543),
    [sym_internal_module] = STATE(1543),
    [sym_type_arguments] = STATE(381),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2726),
    [sym_identifier] = ACTIONS(855),
    [anon_sym_export] = ACTIONS(745),
    [anon_sym_namespace] = ACTIONS(747),
    [anon_sym_LBRACE] = ACTIONS(859),
    [anon_sym_type] = ACTIONS(745),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(537),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(549),
    [anon_sym_async] = ACTIONS(753),
    [anon_sym_function] = ACTIONS(553),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(745),
    [anon_sym_get] = ACTIONS(745),
    [anon_sym_set] = ACTIONS(745),
    [anon_sym_declare] = ACTIONS(745),
    [anon_sym_public] = ACTIONS(745),
    [anon_sym_private] = ACTIONS(745),
    [anon_sym_protected] = ACTIONS(745),
    [anon_sym_module] = ACTIONS(745),
    [anon_sym_any] = ACTIONS(745),
    [anon_sym_number] = ACTIONS(745),
    [anon_sym_boolean] = ACTIONS(745),
    [anon_sym_string] = ACTIONS(745),
    [anon_sym_symbol] = ACTIONS(745),
    [sym_readonly] = ACTIONS(745),
  },
  [372] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(963),
    [sym__expression] = STATE(1255),
    [sym_yield_expression] = STATE(1722),
    [sym_object] = STATE(1536),
    [sym_array] = STATE(1535),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(3286),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1722),
    [sym_await_expression] = STATE(1722),
    [sym_member_expression] = STATE(963),
    [sym_subscript_expression] = STATE(963),
    [sym_assignment_expression] = STATE(1722),
    [sym__augmented_assignment_lhs] = STATE(1968),
    [sym_augmented_assignment_expression] = STATE(1722),
    [sym_ternary_expression] = STATE(1722),
    [sym_binary_expression] = STATE(1722),
    [sym_unary_expression] = STATE(1722),
    [sym_update_expression] = STATE(1722),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(952),
    [sym_type_assertion] = STATE(1722),
    [sym_as_expression] = STATE(1722),
    [sym_internal_module] = STATE(1722),
    [sym_type_arguments] = STATE(266),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2684),
    [sym_identifier] = ACTIONS(863),
    [anon_sym_export] = ACTIONS(655),
    [anon_sym_namespace] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(1270),
    [anon_sym_type] = ACTIONS(655),
    [anon_sym_typeof] = ACTIONS(689),
    [anon_sym_import] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_LPAREN] = ACTIONS(871),
    [anon_sym_await] = ACTIONS(669),
    [anon_sym_yield] = ACTIONS(671),
    [anon_sym_LBRACK] = ACTIONS(873),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(675),
    [anon_sym_class] = ACTIONS(677),
    [anon_sym_async] = ACTIONS(679),
    [anon_sym_function] = ACTIONS(681),
    [anon_sym_new] = ACTIONS(875),
    [anon_sym_PLUS] = ACTIONS(877),
    [anon_sym_DASH] = ACTIONS(877),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_void] = ACTIONS(689),
    [anon_sym_delete] = ACTIONS(689),
    [anon_sym_PLUS_PLUS] = ACTIONS(691),
    [anon_sym_DASH_DASH] = ACTIONS(691),
    [anon_sym_DQUOTE] = ACTIONS(693),
    [anon_sym_SQUOTE] = ACTIONS(695),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(697),
    [sym_number] = ACTIONS(879),
    [sym_this] = ACTIONS(703),
    [sym_super] = ACTIONS(703),
    [sym_true] = ACTIONS(703),
    [sym_false] = ACTIONS(703),
    [sym_null] = ACTIONS(703),
    [sym_undefined] = ACTIONS(703),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(655),
    [anon_sym_get] = ACTIONS(655),
    [anon_sym_set] = ACTIONS(655),
    [anon_sym_declare] = ACTIONS(655),
    [anon_sym_public] = ACTIONS(655),
    [anon_sym_private] = ACTIONS(655),
    [anon_sym_protected] = ACTIONS(655),
    [anon_sym_module] = ACTIONS(655),
    [anon_sym_any] = ACTIONS(655),
    [anon_sym_number] = ACTIONS(655),
    [anon_sym_boolean] = ACTIONS(655),
    [anon_sym_string] = ACTIONS(655),
    [anon_sym_symbol] = ACTIONS(655),
    [sym_readonly] = ACTIONS(655),
  },
  [373] = {
    [sym_import] = STATE(1528),
    [sym_parenthesized_expression] = STATE(933),
    [sym__expression] = STATE(1321),
    [sym_yield_expression] = STATE(1543),
    [sym_object] = STATE(1367),
    [sym_array] = STATE(1369),
    [sym_class] = STATE(1528),
    [sym_function] = STATE(1528),
    [sym_generator_function] = STATE(1528),
    [sym_arrow_function] = STATE(1528),
    [sym__call_signature] = STATE(3359),
    [sym_call_expression] = STATE(1528),
    [sym_new_expression] = STATE(1543),
    [sym_await_expression] = STATE(1543),
    [sym_member_expression] = STATE(933),
    [sym_subscript_expression] = STATE(933),
    [sym_assignment_expression] = STATE(1543),
    [sym__augmented_assignment_lhs] = STATE(1970),
    [sym_augmented_assignment_expression] = STATE(1543),
    [sym_ternary_expression] = STATE(1543),
    [sym_binary_expression] = STATE(1543),
    [sym_unary_expression] = STATE(1543),
    [sym_update_expression] = STATE(1543),
    [sym_string] = STATE(1528),
    [sym_template_string] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_meta_property] = STATE(1528),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(936),
    [sym_type_assertion] = STATE(1543),
    [sym_as_expression] = STATE(1543),
    [sym_internal_module] = STATE(1543),
    [sym_type_arguments] = STATE(381),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2726),
    [sym_identifier] = ACTIONS(855),
    [anon_sym_export] = ACTIONS(745),
    [anon_sym_namespace] = ACTIONS(747),
    [anon_sym_LBRACE] = ACTIONS(859),
    [anon_sym_type] = ACTIONS(745),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(537),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(549),
    [anon_sym_async] = ACTIONS(753),
    [anon_sym_function] = ACTIONS(553),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(745),
    [anon_sym_get] = ACTIONS(745),
    [anon_sym_set] = ACTIONS(745),
    [anon_sym_declare] = ACTIONS(745),
    [anon_sym_public] = ACTIONS(745),
    [anon_sym_private] = ACTIONS(745),
    [anon_sym_protected] = ACTIONS(745),
    [anon_sym_module] = ACTIONS(745),
    [anon_sym_any] = ACTIONS(745),
    [anon_sym_number] = ACTIONS(745),
    [anon_sym_boolean] = ACTIONS(745),
    [anon_sym_string] = ACTIONS(745),
    [anon_sym_symbol] = ACTIONS(745),
    [sym_readonly] = ACTIONS(745),
  },
  [374] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(884),
    [sym__expression] = STATE(1118),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1283),
    [sym_array] = STATE(1281),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3336),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(884),
    [sym_subscript_expression] = STATE(884),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1964),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(860),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(414),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(831),
    [anon_sym_export] = ACTIONS(503),
    [anon_sym_namespace] = ACTIONS(505),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_type] = ACTIONS(503),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(437),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(443),
    [anon_sym_yield] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(849),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(851),
    [anon_sym_TILDE] = ACTIONS(437),
    [anon_sym_void] = ACTIONS(471),
    [anon_sym_delete] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(473),
    [anon_sym_DASH_DASH] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(503),
    [anon_sym_get] = ACTIONS(503),
    [anon_sym_set] = ACTIONS(503),
    [anon_sym_declare] = ACTIONS(503),
    [anon_sym_public] = ACTIONS(503),
    [anon_sym_private] = ACTIONS(503),
    [anon_sym_protected] = ACTIONS(503),
    [anon_sym_module] = ACTIONS(503),
    [anon_sym_any] = ACTIONS(503),
    [anon_sym_number] = ACTIONS(503),
    [anon_sym_boolean] = ACTIONS(503),
    [anon_sym_string] = ACTIONS(503),
    [anon_sym_symbol] = ACTIONS(503),
    [sym_readonly] = ACTIONS(503),
  },
  [375] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(978),
    [sym__expression] = STATE(1457),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1696),
    [sym_array] = STATE(1691),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3169),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(978),
    [sym_subscript_expression] = STATE(978),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1967),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(977),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(380),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(881),
    [anon_sym_export] = ACTIONS(617),
    [anon_sym_namespace] = ACTIONS(619),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_type] = ACTIONS(617),
    [anon_sym_typeof] = ACTIONS(639),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(625),
    [anon_sym_yield] = ACTIONS(627),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(631),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(887),
    [anon_sym_PLUS] = ACTIONS(889),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(623),
    [anon_sym_void] = ACTIONS(639),
    [anon_sym_delete] = ACTIONS(639),
    [anon_sym_PLUS_PLUS] = ACTIONS(641),
    [anon_sym_DASH_DASH] = ACTIONS(641),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(1497),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(617),
    [anon_sym_get] = ACTIONS(617),
    [anon_sym_set] = ACTIONS(617),
    [anon_sym_declare] = ACTIONS(617),
    [anon_sym_public] = ACTIONS(617),
    [anon_sym_private] = ACTIONS(617),
    [anon_sym_protected] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(617),
    [anon_sym_any] = ACTIONS(617),
    [anon_sym_number] = ACTIONS(617),
    [anon_sym_boolean] = ACTIONS(617),
    [anon_sym_string] = ACTIONS(617),
    [anon_sym_symbol] = ACTIONS(617),
    [sym_readonly] = ACTIONS(617),
  },
  [376] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(884),
    [sym__expression] = STATE(1055),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1283),
    [sym_array] = STATE(1281),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3336),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(884),
    [sym_subscript_expression] = STATE(884),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1964),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(860),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(414),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(831),
    [anon_sym_export] = ACTIONS(503),
    [anon_sym_namespace] = ACTIONS(505),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_type] = ACTIONS(503),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(437),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(443),
    [anon_sym_yield] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(849),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(851),
    [anon_sym_TILDE] = ACTIONS(437),
    [anon_sym_void] = ACTIONS(471),
    [anon_sym_delete] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(473),
    [anon_sym_DASH_DASH] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(503),
    [anon_sym_get] = ACTIONS(503),
    [anon_sym_set] = ACTIONS(503),
    [anon_sym_declare] = ACTIONS(503),
    [anon_sym_public] = ACTIONS(503),
    [anon_sym_private] = ACTIONS(503),
    [anon_sym_protected] = ACTIONS(503),
    [anon_sym_module] = ACTIONS(503),
    [anon_sym_any] = ACTIONS(503),
    [anon_sym_number] = ACTIONS(503),
    [anon_sym_boolean] = ACTIONS(503),
    [anon_sym_string] = ACTIONS(503),
    [anon_sym_symbol] = ACTIONS(503),
    [sym_readonly] = ACTIONS(503),
  },
  [377] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(963),
    [sym__expression] = STATE(1249),
    [sym_yield_expression] = STATE(1722),
    [sym_object] = STATE(1536),
    [sym_array] = STATE(1535),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(3286),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1722),
    [sym_await_expression] = STATE(1722),
    [sym_member_expression] = STATE(963),
    [sym_subscript_expression] = STATE(963),
    [sym_assignment_expression] = STATE(1722),
    [sym__augmented_assignment_lhs] = STATE(1968),
    [sym_augmented_assignment_expression] = STATE(1722),
    [sym_ternary_expression] = STATE(1722),
    [sym_binary_expression] = STATE(1722),
    [sym_unary_expression] = STATE(1722),
    [sym_update_expression] = STATE(1722),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(952),
    [sym_type_assertion] = STATE(1722),
    [sym_as_expression] = STATE(1722),
    [sym_internal_module] = STATE(1722),
    [sym_type_arguments] = STATE(266),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2684),
    [sym_identifier] = ACTIONS(863),
    [anon_sym_export] = ACTIONS(655),
    [anon_sym_namespace] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(1270),
    [anon_sym_type] = ACTIONS(655),
    [anon_sym_typeof] = ACTIONS(689),
    [anon_sym_import] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_LPAREN] = ACTIONS(871),
    [anon_sym_await] = ACTIONS(669),
    [anon_sym_yield] = ACTIONS(671),
    [anon_sym_LBRACK] = ACTIONS(873),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(675),
    [anon_sym_class] = ACTIONS(677),
    [anon_sym_async] = ACTIONS(679),
    [anon_sym_function] = ACTIONS(681),
    [anon_sym_new] = ACTIONS(875),
    [anon_sym_PLUS] = ACTIONS(877),
    [anon_sym_DASH] = ACTIONS(877),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_void] = ACTIONS(689),
    [anon_sym_delete] = ACTIONS(689),
    [anon_sym_PLUS_PLUS] = ACTIONS(691),
    [anon_sym_DASH_DASH] = ACTIONS(691),
    [anon_sym_DQUOTE] = ACTIONS(693),
    [anon_sym_SQUOTE] = ACTIONS(695),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(697),
    [sym_number] = ACTIONS(879),
    [sym_this] = ACTIONS(703),
    [sym_super] = ACTIONS(703),
    [sym_true] = ACTIONS(703),
    [sym_false] = ACTIONS(703),
    [sym_null] = ACTIONS(703),
    [sym_undefined] = ACTIONS(703),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(655),
    [anon_sym_get] = ACTIONS(655),
    [anon_sym_set] = ACTIONS(655),
    [anon_sym_declare] = ACTIONS(655),
    [anon_sym_public] = ACTIONS(655),
    [anon_sym_private] = ACTIONS(655),
    [anon_sym_protected] = ACTIONS(655),
    [anon_sym_module] = ACTIONS(655),
    [anon_sym_any] = ACTIONS(655),
    [anon_sym_number] = ACTIONS(655),
    [anon_sym_boolean] = ACTIONS(655),
    [anon_sym_string] = ACTIONS(655),
    [anon_sym_symbol] = ACTIONS(655),
    [sym_readonly] = ACTIONS(655),
  },
  [378] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(884),
    [sym__expression] = STATE(1123),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1283),
    [sym_array] = STATE(1281),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3336),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(884),
    [sym_subscript_expression] = STATE(884),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1964),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(860),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(414),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(831),
    [anon_sym_export] = ACTIONS(503),
    [anon_sym_namespace] = ACTIONS(505),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_type] = ACTIONS(503),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(437),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(443),
    [anon_sym_yield] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(849),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(851),
    [anon_sym_TILDE] = ACTIONS(437),
    [anon_sym_void] = ACTIONS(471),
    [anon_sym_delete] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(473),
    [anon_sym_DASH_DASH] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(503),
    [anon_sym_get] = ACTIONS(503),
    [anon_sym_set] = ACTIONS(503),
    [anon_sym_declare] = ACTIONS(503),
    [anon_sym_public] = ACTIONS(503),
    [anon_sym_private] = ACTIONS(503),
    [anon_sym_protected] = ACTIONS(503),
    [anon_sym_module] = ACTIONS(503),
    [anon_sym_any] = ACTIONS(503),
    [anon_sym_number] = ACTIONS(503),
    [anon_sym_boolean] = ACTIONS(503),
    [anon_sym_string] = ACTIONS(503),
    [anon_sym_symbol] = ACTIONS(503),
    [sym_readonly] = ACTIONS(503),
  },
  [379] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(965),
    [sym__expression] = STATE(1334),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1524),
    [sym_array] = STATE(1523),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3348),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(965),
    [sym_subscript_expression] = STATE(965),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1969),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(975),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(302),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(901),
    [anon_sym_export] = ACTIONS(713),
    [anon_sym_namespace] = ACTIONS(715),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_type] = ACTIONS(713),
    [anon_sym_typeof] = ACTIONS(735),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(719),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(721),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(725),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(727),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(907),
    [anon_sym_PLUS] = ACTIONS(909),
    [anon_sym_DASH] = ACTIONS(909),
    [anon_sym_TILDE] = ACTIONS(719),
    [anon_sym_void] = ACTIONS(735),
    [anon_sym_delete] = ACTIONS(735),
    [anon_sym_PLUS_PLUS] = ACTIONS(737),
    [anon_sym_DASH_DASH] = ACTIONS(737),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(713),
    [anon_sym_get] = ACTIONS(713),
    [anon_sym_set] = ACTIONS(713),
    [anon_sym_declare] = ACTIONS(713),
    [anon_sym_public] = ACTIONS(713),
    [anon_sym_private] = ACTIONS(713),
    [anon_sym_protected] = ACTIONS(713),
    [anon_sym_module] = ACTIONS(713),
    [anon_sym_any] = ACTIONS(713),
    [anon_sym_number] = ACTIONS(713),
    [anon_sym_boolean] = ACTIONS(713),
    [anon_sym_string] = ACTIONS(713),
    [anon_sym_symbol] = ACTIONS(713),
    [sym_readonly] = ACTIONS(713),
  },
  [380] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(978),
    [sym__expression] = STATE(1025),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1696),
    [sym_array] = STATE(1691),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3169),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(978),
    [sym_subscript_expression] = STATE(978),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1967),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(977),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(380),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(881),
    [anon_sym_export] = ACTIONS(617),
    [anon_sym_namespace] = ACTIONS(619),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_type] = ACTIONS(617),
    [anon_sym_typeof] = ACTIONS(639),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(625),
    [anon_sym_yield] = ACTIONS(627),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(631),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(887),
    [anon_sym_PLUS] = ACTIONS(889),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(623),
    [anon_sym_void] = ACTIONS(639),
    [anon_sym_delete] = ACTIONS(639),
    [anon_sym_PLUS_PLUS] = ACTIONS(641),
    [anon_sym_DASH_DASH] = ACTIONS(641),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(617),
    [anon_sym_get] = ACTIONS(617),
    [anon_sym_set] = ACTIONS(617),
    [anon_sym_declare] = ACTIONS(617),
    [anon_sym_public] = ACTIONS(617),
    [anon_sym_private] = ACTIONS(617),
    [anon_sym_protected] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(617),
    [anon_sym_any] = ACTIONS(617),
    [anon_sym_number] = ACTIONS(617),
    [anon_sym_boolean] = ACTIONS(617),
    [anon_sym_string] = ACTIONS(617),
    [anon_sym_symbol] = ACTIONS(617),
    [sym_readonly] = ACTIONS(617),
  },
  [381] = {
    [sym_import] = STATE(1528),
    [sym_parenthesized_expression] = STATE(933),
    [sym__expression] = STATE(1146),
    [sym_yield_expression] = STATE(1543),
    [sym_object] = STATE(1367),
    [sym_array] = STATE(1369),
    [sym_class] = STATE(1528),
    [sym_function] = STATE(1528),
    [sym_generator_function] = STATE(1528),
    [sym_arrow_function] = STATE(1528),
    [sym__call_signature] = STATE(3359),
    [sym_call_expression] = STATE(1528),
    [sym_new_expression] = STATE(1543),
    [sym_await_expression] = STATE(1543),
    [sym_member_expression] = STATE(933),
    [sym_subscript_expression] = STATE(933),
    [sym_assignment_expression] = STATE(1543),
    [sym__augmented_assignment_lhs] = STATE(1970),
    [sym_augmented_assignment_expression] = STATE(1543),
    [sym_ternary_expression] = STATE(1543),
    [sym_binary_expression] = STATE(1543),
    [sym_unary_expression] = STATE(1543),
    [sym_update_expression] = STATE(1543),
    [sym_string] = STATE(1528),
    [sym_template_string] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_meta_property] = STATE(1528),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(936),
    [sym_type_assertion] = STATE(1543),
    [sym_as_expression] = STATE(1543),
    [sym_internal_module] = STATE(1543),
    [sym_type_arguments] = STATE(381),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2726),
    [sym_identifier] = ACTIONS(855),
    [anon_sym_export] = ACTIONS(745),
    [anon_sym_namespace] = ACTIONS(747),
    [anon_sym_LBRACE] = ACTIONS(859),
    [anon_sym_type] = ACTIONS(745),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(537),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(549),
    [anon_sym_async] = ACTIONS(753),
    [anon_sym_function] = ACTIONS(553),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(745),
    [anon_sym_get] = ACTIONS(745),
    [anon_sym_set] = ACTIONS(745),
    [anon_sym_declare] = ACTIONS(745),
    [anon_sym_public] = ACTIONS(745),
    [anon_sym_private] = ACTIONS(745),
    [anon_sym_protected] = ACTIONS(745),
    [anon_sym_module] = ACTIONS(745),
    [anon_sym_any] = ACTIONS(745),
    [anon_sym_number] = ACTIONS(745),
    [anon_sym_boolean] = ACTIONS(745),
    [anon_sym_string] = ACTIONS(745),
    [anon_sym_symbol] = ACTIONS(745),
    [sym_readonly] = ACTIONS(745),
  },
  [382] = {
    [sym_import] = STATE(1528),
    [sym_parenthesized_expression] = STATE(933),
    [sym__expression] = STATE(1234),
    [sym_yield_expression] = STATE(1543),
    [sym_object] = STATE(1367),
    [sym_array] = STATE(1369),
    [sym_class] = STATE(1528),
    [sym_function] = STATE(1528),
    [sym_generator_function] = STATE(1528),
    [sym_arrow_function] = STATE(1528),
    [sym__call_signature] = STATE(3359),
    [sym_call_expression] = STATE(1528),
    [sym_new_expression] = STATE(1543),
    [sym_await_expression] = STATE(1543),
    [sym_member_expression] = STATE(933),
    [sym_subscript_expression] = STATE(933),
    [sym_assignment_expression] = STATE(1543),
    [sym__augmented_assignment_lhs] = STATE(1970),
    [sym_augmented_assignment_expression] = STATE(1543),
    [sym_ternary_expression] = STATE(1543),
    [sym_binary_expression] = STATE(1543),
    [sym_unary_expression] = STATE(1543),
    [sym_update_expression] = STATE(1543),
    [sym_string] = STATE(1528),
    [sym_template_string] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_meta_property] = STATE(1528),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(936),
    [sym_type_assertion] = STATE(1543),
    [sym_as_expression] = STATE(1543),
    [sym_internal_module] = STATE(1543),
    [sym_type_arguments] = STATE(381),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2726),
    [sym_identifier] = ACTIONS(855),
    [anon_sym_export] = ACTIONS(745),
    [anon_sym_namespace] = ACTIONS(747),
    [anon_sym_LBRACE] = ACTIONS(859),
    [anon_sym_type] = ACTIONS(745),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(537),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(549),
    [anon_sym_async] = ACTIONS(753),
    [anon_sym_function] = ACTIONS(553),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(745),
    [anon_sym_get] = ACTIONS(745),
    [anon_sym_set] = ACTIONS(745),
    [anon_sym_declare] = ACTIONS(745),
    [anon_sym_public] = ACTIONS(745),
    [anon_sym_private] = ACTIONS(745),
    [anon_sym_protected] = ACTIONS(745),
    [anon_sym_module] = ACTIONS(745),
    [anon_sym_any] = ACTIONS(745),
    [anon_sym_number] = ACTIONS(745),
    [anon_sym_boolean] = ACTIONS(745),
    [anon_sym_string] = ACTIONS(745),
    [anon_sym_symbol] = ACTIONS(745),
    [sym_readonly] = ACTIONS(745),
  },
  [383] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(978),
    [sym__expression] = STATE(1591),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1696),
    [sym_array] = STATE(1691),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3169),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(978),
    [sym_subscript_expression] = STATE(978),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1967),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(977),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(380),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(881),
    [anon_sym_export] = ACTIONS(617),
    [anon_sym_namespace] = ACTIONS(619),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_type] = ACTIONS(617),
    [anon_sym_typeof] = ACTIONS(639),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(625),
    [anon_sym_yield] = ACTIONS(627),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(631),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(887),
    [anon_sym_PLUS] = ACTIONS(889),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(623),
    [anon_sym_void] = ACTIONS(639),
    [anon_sym_delete] = ACTIONS(639),
    [anon_sym_PLUS_PLUS] = ACTIONS(641),
    [anon_sym_DASH_DASH] = ACTIONS(641),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(617),
    [anon_sym_get] = ACTIONS(617),
    [anon_sym_set] = ACTIONS(617),
    [anon_sym_declare] = ACTIONS(617),
    [anon_sym_public] = ACTIONS(617),
    [anon_sym_private] = ACTIONS(617),
    [anon_sym_protected] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(617),
    [anon_sym_any] = ACTIONS(617),
    [anon_sym_number] = ACTIONS(617),
    [anon_sym_boolean] = ACTIONS(617),
    [anon_sym_string] = ACTIONS(617),
    [anon_sym_symbol] = ACTIONS(617),
    [sym_readonly] = ACTIONS(617),
  },
  [384] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(884),
    [sym__expression] = STATE(1125),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1283),
    [sym_array] = STATE(1281),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3336),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(884),
    [sym_subscript_expression] = STATE(884),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1964),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(860),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(414),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(831),
    [anon_sym_export] = ACTIONS(503),
    [anon_sym_namespace] = ACTIONS(505),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_type] = ACTIONS(503),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(437),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(443),
    [anon_sym_yield] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(849),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(851),
    [anon_sym_TILDE] = ACTIONS(437),
    [anon_sym_void] = ACTIONS(471),
    [anon_sym_delete] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(473),
    [anon_sym_DASH_DASH] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(503),
    [anon_sym_get] = ACTIONS(503),
    [anon_sym_set] = ACTIONS(503),
    [anon_sym_declare] = ACTIONS(503),
    [anon_sym_public] = ACTIONS(503),
    [anon_sym_private] = ACTIONS(503),
    [anon_sym_protected] = ACTIONS(503),
    [anon_sym_module] = ACTIONS(503),
    [anon_sym_any] = ACTIONS(503),
    [anon_sym_number] = ACTIONS(503),
    [anon_sym_boolean] = ACTIONS(503),
    [anon_sym_string] = ACTIONS(503),
    [anon_sym_symbol] = ACTIONS(503),
    [sym_readonly] = ACTIONS(503),
  },
  [385] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(963),
    [sym__expression] = STATE(1257),
    [sym_yield_expression] = STATE(1722),
    [sym_object] = STATE(1536),
    [sym_array] = STATE(1535),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(3286),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1722),
    [sym_await_expression] = STATE(1722),
    [sym_member_expression] = STATE(963),
    [sym_subscript_expression] = STATE(963),
    [sym_assignment_expression] = STATE(1722),
    [sym__augmented_assignment_lhs] = STATE(1968),
    [sym_augmented_assignment_expression] = STATE(1722),
    [sym_ternary_expression] = STATE(1722),
    [sym_binary_expression] = STATE(1722),
    [sym_unary_expression] = STATE(1722),
    [sym_update_expression] = STATE(1722),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(952),
    [sym_type_assertion] = STATE(1722),
    [sym_as_expression] = STATE(1722),
    [sym_internal_module] = STATE(1722),
    [sym_type_arguments] = STATE(266),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2684),
    [sym_identifier] = ACTIONS(863),
    [anon_sym_export] = ACTIONS(655),
    [anon_sym_namespace] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(1270),
    [anon_sym_type] = ACTIONS(655),
    [anon_sym_typeof] = ACTIONS(689),
    [anon_sym_import] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_LPAREN] = ACTIONS(871),
    [anon_sym_await] = ACTIONS(669),
    [anon_sym_yield] = ACTIONS(671),
    [anon_sym_LBRACK] = ACTIONS(873),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(675),
    [anon_sym_class] = ACTIONS(677),
    [anon_sym_async] = ACTIONS(679),
    [anon_sym_function] = ACTIONS(681),
    [anon_sym_new] = ACTIONS(875),
    [anon_sym_PLUS] = ACTIONS(877),
    [anon_sym_DASH] = ACTIONS(877),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_void] = ACTIONS(689),
    [anon_sym_delete] = ACTIONS(689),
    [anon_sym_PLUS_PLUS] = ACTIONS(691),
    [anon_sym_DASH_DASH] = ACTIONS(691),
    [anon_sym_DQUOTE] = ACTIONS(693),
    [anon_sym_SQUOTE] = ACTIONS(695),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(697),
    [sym_number] = ACTIONS(879),
    [sym_this] = ACTIONS(703),
    [sym_super] = ACTIONS(703),
    [sym_true] = ACTIONS(703),
    [sym_false] = ACTIONS(703),
    [sym_null] = ACTIONS(703),
    [sym_undefined] = ACTIONS(703),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(655),
    [anon_sym_get] = ACTIONS(655),
    [anon_sym_set] = ACTIONS(655),
    [anon_sym_declare] = ACTIONS(655),
    [anon_sym_public] = ACTIONS(655),
    [anon_sym_private] = ACTIONS(655),
    [anon_sym_protected] = ACTIONS(655),
    [anon_sym_module] = ACTIONS(655),
    [anon_sym_any] = ACTIONS(655),
    [anon_sym_number] = ACTIONS(655),
    [anon_sym_boolean] = ACTIONS(655),
    [anon_sym_string] = ACTIONS(655),
    [anon_sym_symbol] = ACTIONS(655),
    [sym_readonly] = ACTIONS(655),
  },
  [386] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(965),
    [sym__expression] = STATE(1245),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1524),
    [sym_array] = STATE(1523),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3348),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(965),
    [sym_subscript_expression] = STATE(965),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1969),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(975),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(302),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(901),
    [anon_sym_export] = ACTIONS(713),
    [anon_sym_namespace] = ACTIONS(715),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_type] = ACTIONS(713),
    [anon_sym_typeof] = ACTIONS(735),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(719),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(721),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(725),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(727),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(907),
    [anon_sym_PLUS] = ACTIONS(909),
    [anon_sym_DASH] = ACTIONS(909),
    [anon_sym_TILDE] = ACTIONS(719),
    [anon_sym_void] = ACTIONS(735),
    [anon_sym_delete] = ACTIONS(735),
    [anon_sym_PLUS_PLUS] = ACTIONS(737),
    [anon_sym_DASH_DASH] = ACTIONS(737),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(713),
    [anon_sym_get] = ACTIONS(713),
    [anon_sym_set] = ACTIONS(713),
    [anon_sym_declare] = ACTIONS(713),
    [anon_sym_public] = ACTIONS(713),
    [anon_sym_private] = ACTIONS(713),
    [anon_sym_protected] = ACTIONS(713),
    [anon_sym_module] = ACTIONS(713),
    [anon_sym_any] = ACTIONS(713),
    [anon_sym_number] = ACTIONS(713),
    [anon_sym_boolean] = ACTIONS(713),
    [anon_sym_string] = ACTIONS(713),
    [anon_sym_symbol] = ACTIONS(713),
    [sym_readonly] = ACTIONS(713),
  },
  [387] = {
    [sym_import] = STATE(1528),
    [sym_parenthesized_expression] = STATE(983),
    [sym__expression] = STATE(1439),
    [sym_yield_expression] = STATE(1543),
    [sym_object] = STATE(1671),
    [sym_array] = STATE(1713),
    [sym_class] = STATE(1528),
    [sym_function] = STATE(1528),
    [sym_generator_function] = STATE(1528),
    [sym_arrow_function] = STATE(1528),
    [sym__call_signature] = STATE(3235),
    [sym_call_expression] = STATE(1528),
    [sym_new_expression] = STATE(1543),
    [sym_await_expression] = STATE(1543),
    [sym_member_expression] = STATE(983),
    [sym_subscript_expression] = STATE(983),
    [sym_assignment_expression] = STATE(1543),
    [sym__augmented_assignment_lhs] = STATE(1963),
    [sym_augmented_assignment_expression] = STATE(1543),
    [sym_ternary_expression] = STATE(1543),
    [sym_binary_expression] = STATE(1543),
    [sym_unary_expression] = STATE(1543),
    [sym_update_expression] = STATE(1543),
    [sym_string] = STATE(1528),
    [sym_template_string] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_meta_property] = STATE(1528),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(984),
    [sym_type_assertion] = STATE(1543),
    [sym_as_expression] = STATE(1543),
    [sym_internal_module] = STATE(1543),
    [sym_type_arguments] = STATE(310),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2726),
    [sym_identifier] = ACTIONS(891),
    [anon_sym_export] = ACTIONS(529),
    [anon_sym_namespace] = ACTIONS(531),
    [anon_sym_LBRACE] = ACTIONS(859),
    [anon_sym_type] = ACTIONS(529),
    [anon_sym_typeof] = ACTIONS(561),
    [anon_sym_import] = ACTIONS(537),
    [anon_sym_BANG] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(543),
    [anon_sym_yield] = ACTIONS(545),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(549),
    [anon_sym_async] = ACTIONS(551),
    [anon_sym_function] = ACTIONS(553),
    [anon_sym_new] = ACTIONS(897),
    [anon_sym_PLUS] = ACTIONS(899),
    [anon_sym_DASH] = ACTIONS(899),
    [anon_sym_TILDE] = ACTIONS(539),
    [anon_sym_void] = ACTIONS(561),
    [anon_sym_delete] = ACTIONS(561),
    [anon_sym_PLUS_PLUS] = ACTIONS(563),
    [anon_sym_DASH_DASH] = ACTIONS(563),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(529),
    [anon_sym_get] = ACTIONS(529),
    [anon_sym_set] = ACTIONS(529),
    [anon_sym_declare] = ACTIONS(529),
    [anon_sym_public] = ACTIONS(529),
    [anon_sym_private] = ACTIONS(529),
    [anon_sym_protected] = ACTIONS(529),
    [anon_sym_module] = ACTIONS(529),
    [anon_sym_any] = ACTIONS(529),
    [anon_sym_number] = ACTIONS(529),
    [anon_sym_boolean] = ACTIONS(529),
    [anon_sym_string] = ACTIONS(529),
    [anon_sym_symbol] = ACTIONS(529),
    [sym_readonly] = ACTIONS(529),
  },
  [388] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(963),
    [sym__expression] = STATE(1273),
    [sym_yield_expression] = STATE(1722),
    [sym_object] = STATE(1536),
    [sym_array] = STATE(1535),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(3286),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1722),
    [sym_await_expression] = STATE(1722),
    [sym_member_expression] = STATE(963),
    [sym_subscript_expression] = STATE(963),
    [sym_assignment_expression] = STATE(1722),
    [sym__augmented_assignment_lhs] = STATE(1968),
    [sym_augmented_assignment_expression] = STATE(1722),
    [sym_ternary_expression] = STATE(1722),
    [sym_binary_expression] = STATE(1722),
    [sym_unary_expression] = STATE(1722),
    [sym_update_expression] = STATE(1722),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(952),
    [sym_type_assertion] = STATE(1722),
    [sym_as_expression] = STATE(1722),
    [sym_internal_module] = STATE(1722),
    [sym_type_arguments] = STATE(266),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2684),
    [sym_identifier] = ACTIONS(863),
    [anon_sym_export] = ACTIONS(655),
    [anon_sym_namespace] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(1270),
    [anon_sym_type] = ACTIONS(655),
    [anon_sym_typeof] = ACTIONS(689),
    [anon_sym_import] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_LPAREN] = ACTIONS(871),
    [anon_sym_await] = ACTIONS(669),
    [anon_sym_yield] = ACTIONS(671),
    [anon_sym_LBRACK] = ACTIONS(873),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(675),
    [anon_sym_class] = ACTIONS(677),
    [anon_sym_async] = ACTIONS(679),
    [anon_sym_function] = ACTIONS(681),
    [anon_sym_new] = ACTIONS(875),
    [anon_sym_PLUS] = ACTIONS(877),
    [anon_sym_DASH] = ACTIONS(877),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_void] = ACTIONS(689),
    [anon_sym_delete] = ACTIONS(689),
    [anon_sym_PLUS_PLUS] = ACTIONS(691),
    [anon_sym_DASH_DASH] = ACTIONS(691),
    [anon_sym_DQUOTE] = ACTIONS(693),
    [anon_sym_SQUOTE] = ACTIONS(695),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(697),
    [sym_number] = ACTIONS(879),
    [sym_this] = ACTIONS(703),
    [sym_super] = ACTIONS(703),
    [sym_true] = ACTIONS(703),
    [sym_false] = ACTIONS(703),
    [sym_null] = ACTIONS(703),
    [sym_undefined] = ACTIONS(703),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(655),
    [anon_sym_get] = ACTIONS(655),
    [anon_sym_set] = ACTIONS(655),
    [anon_sym_declare] = ACTIONS(655),
    [anon_sym_public] = ACTIONS(655),
    [anon_sym_private] = ACTIONS(655),
    [anon_sym_protected] = ACTIONS(655),
    [anon_sym_module] = ACTIONS(655),
    [anon_sym_any] = ACTIONS(655),
    [anon_sym_number] = ACTIONS(655),
    [anon_sym_boolean] = ACTIONS(655),
    [anon_sym_string] = ACTIONS(655),
    [anon_sym_symbol] = ACTIONS(655),
    [sym_readonly] = ACTIONS(655),
  },
  [389] = {
    [sym_import] = STATE(1528),
    [sym_parenthesized_expression] = STATE(983),
    [sym__expression] = STATE(1440),
    [sym_yield_expression] = STATE(1543),
    [sym_object] = STATE(1671),
    [sym_array] = STATE(1713),
    [sym_class] = STATE(1528),
    [sym_function] = STATE(1528),
    [sym_generator_function] = STATE(1528),
    [sym_arrow_function] = STATE(1528),
    [sym__call_signature] = STATE(3235),
    [sym_call_expression] = STATE(1528),
    [sym_new_expression] = STATE(1543),
    [sym_await_expression] = STATE(1543),
    [sym_member_expression] = STATE(983),
    [sym_subscript_expression] = STATE(983),
    [sym_assignment_expression] = STATE(1543),
    [sym__augmented_assignment_lhs] = STATE(1963),
    [sym_augmented_assignment_expression] = STATE(1543),
    [sym_ternary_expression] = STATE(1543),
    [sym_binary_expression] = STATE(1543),
    [sym_unary_expression] = STATE(1543),
    [sym_update_expression] = STATE(1543),
    [sym_string] = STATE(1528),
    [sym_template_string] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_meta_property] = STATE(1528),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(984),
    [sym_type_assertion] = STATE(1543),
    [sym_as_expression] = STATE(1543),
    [sym_internal_module] = STATE(1543),
    [sym_type_arguments] = STATE(310),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2726),
    [sym_identifier] = ACTIONS(891),
    [anon_sym_export] = ACTIONS(529),
    [anon_sym_namespace] = ACTIONS(531),
    [anon_sym_LBRACE] = ACTIONS(859),
    [anon_sym_type] = ACTIONS(529),
    [anon_sym_typeof] = ACTIONS(561),
    [anon_sym_import] = ACTIONS(537),
    [anon_sym_BANG] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(543),
    [anon_sym_yield] = ACTIONS(545),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(549),
    [anon_sym_async] = ACTIONS(551),
    [anon_sym_function] = ACTIONS(553),
    [anon_sym_new] = ACTIONS(897),
    [anon_sym_PLUS] = ACTIONS(899),
    [anon_sym_DASH] = ACTIONS(899),
    [anon_sym_TILDE] = ACTIONS(539),
    [anon_sym_void] = ACTIONS(561),
    [anon_sym_delete] = ACTIONS(561),
    [anon_sym_PLUS_PLUS] = ACTIONS(563),
    [anon_sym_DASH_DASH] = ACTIONS(563),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(529),
    [anon_sym_get] = ACTIONS(529),
    [anon_sym_set] = ACTIONS(529),
    [anon_sym_declare] = ACTIONS(529),
    [anon_sym_public] = ACTIONS(529),
    [anon_sym_private] = ACTIONS(529),
    [anon_sym_protected] = ACTIONS(529),
    [anon_sym_module] = ACTIONS(529),
    [anon_sym_any] = ACTIONS(529),
    [anon_sym_number] = ACTIONS(529),
    [anon_sym_boolean] = ACTIONS(529),
    [anon_sym_string] = ACTIONS(529),
    [anon_sym_symbol] = ACTIONS(529),
    [sym_readonly] = ACTIONS(529),
  },
  [390] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(987),
    [sym__expression] = STATE(1682),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1760),
    [sym_array] = STATE(1761),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3169),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(987),
    [sym_subscript_expression] = STATE(987),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1967),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(988),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(380),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(1507),
    [anon_sym_export] = ACTIONS(1461),
    [anon_sym_namespace] = ACTIONS(1463),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_type] = ACTIONS(1461),
    [anon_sym_typeof] = ACTIONS(639),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(625),
    [anon_sym_yield] = ACTIONS(627),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(1465),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(887),
    [anon_sym_PLUS] = ACTIONS(889),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(623),
    [anon_sym_void] = ACTIONS(639),
    [anon_sym_delete] = ACTIONS(639),
    [anon_sym_PLUS_PLUS] = ACTIONS(641),
    [anon_sym_DASH_DASH] = ACTIONS(641),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1461),
    [anon_sym_get] = ACTIONS(1461),
    [anon_sym_set] = ACTIONS(1461),
    [anon_sym_declare] = ACTIONS(1461),
    [anon_sym_public] = ACTIONS(1461),
    [anon_sym_private] = ACTIONS(1461),
    [anon_sym_protected] = ACTIONS(1461),
    [anon_sym_module] = ACTIONS(1461),
    [anon_sym_any] = ACTIONS(1461),
    [anon_sym_number] = ACTIONS(1461),
    [anon_sym_boolean] = ACTIONS(1461),
    [anon_sym_string] = ACTIONS(1461),
    [anon_sym_symbol] = ACTIONS(1461),
    [sym_readonly] = ACTIONS(1461),
  },
  [391] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(978),
    [sym__expression] = STATE(1515),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1696),
    [sym_array] = STATE(1691),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3169),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(978),
    [sym_subscript_expression] = STATE(978),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1967),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(977),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(380),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(881),
    [anon_sym_export] = ACTIONS(617),
    [anon_sym_namespace] = ACTIONS(619),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_type] = ACTIONS(617),
    [anon_sym_typeof] = ACTIONS(639),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(625),
    [anon_sym_yield] = ACTIONS(627),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(631),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(887),
    [anon_sym_PLUS] = ACTIONS(889),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(623),
    [anon_sym_void] = ACTIONS(639),
    [anon_sym_delete] = ACTIONS(639),
    [anon_sym_PLUS_PLUS] = ACTIONS(641),
    [anon_sym_DASH_DASH] = ACTIONS(641),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(617),
    [anon_sym_get] = ACTIONS(617),
    [anon_sym_set] = ACTIONS(617),
    [anon_sym_declare] = ACTIONS(617),
    [anon_sym_public] = ACTIONS(617),
    [anon_sym_private] = ACTIONS(617),
    [anon_sym_protected] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(617),
    [anon_sym_any] = ACTIONS(617),
    [anon_sym_number] = ACTIONS(617),
    [anon_sym_boolean] = ACTIONS(617),
    [anon_sym_string] = ACTIONS(617),
    [anon_sym_symbol] = ACTIONS(617),
    [sym_readonly] = ACTIONS(617),
  },
  [392] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(963),
    [sym__expression] = STATE(1294),
    [sym_yield_expression] = STATE(1722),
    [sym_object] = STATE(1536),
    [sym_array] = STATE(1535),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(3286),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1722),
    [sym_await_expression] = STATE(1722),
    [sym_member_expression] = STATE(963),
    [sym_subscript_expression] = STATE(963),
    [sym_assignment_expression] = STATE(1722),
    [sym__augmented_assignment_lhs] = STATE(1968),
    [sym_augmented_assignment_expression] = STATE(1722),
    [sym_ternary_expression] = STATE(1722),
    [sym_binary_expression] = STATE(1722),
    [sym_unary_expression] = STATE(1722),
    [sym_update_expression] = STATE(1722),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(952),
    [sym_type_assertion] = STATE(1722),
    [sym_as_expression] = STATE(1722),
    [sym_internal_module] = STATE(1722),
    [sym_type_arguments] = STATE(266),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2684),
    [sym_identifier] = ACTIONS(863),
    [anon_sym_export] = ACTIONS(655),
    [anon_sym_namespace] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(1270),
    [anon_sym_type] = ACTIONS(655),
    [anon_sym_typeof] = ACTIONS(689),
    [anon_sym_import] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_LPAREN] = ACTIONS(871),
    [anon_sym_await] = ACTIONS(669),
    [anon_sym_yield] = ACTIONS(671),
    [anon_sym_LBRACK] = ACTIONS(873),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(675),
    [anon_sym_class] = ACTIONS(677),
    [anon_sym_async] = ACTIONS(679),
    [anon_sym_function] = ACTIONS(681),
    [anon_sym_new] = ACTIONS(875),
    [anon_sym_PLUS] = ACTIONS(877),
    [anon_sym_DASH] = ACTIONS(877),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_void] = ACTIONS(689),
    [anon_sym_delete] = ACTIONS(689),
    [anon_sym_PLUS_PLUS] = ACTIONS(691),
    [anon_sym_DASH_DASH] = ACTIONS(691),
    [anon_sym_DQUOTE] = ACTIONS(693),
    [anon_sym_SQUOTE] = ACTIONS(695),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(697),
    [sym_number] = ACTIONS(879),
    [sym_this] = ACTIONS(703),
    [sym_super] = ACTIONS(703),
    [sym_true] = ACTIONS(703),
    [sym_false] = ACTIONS(703),
    [sym_null] = ACTIONS(703),
    [sym_undefined] = ACTIONS(703),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(655),
    [anon_sym_get] = ACTIONS(655),
    [anon_sym_set] = ACTIONS(655),
    [anon_sym_declare] = ACTIONS(655),
    [anon_sym_public] = ACTIONS(655),
    [anon_sym_private] = ACTIONS(655),
    [anon_sym_protected] = ACTIONS(655),
    [anon_sym_module] = ACTIONS(655),
    [anon_sym_any] = ACTIONS(655),
    [anon_sym_number] = ACTIONS(655),
    [anon_sym_boolean] = ACTIONS(655),
    [anon_sym_string] = ACTIONS(655),
    [anon_sym_symbol] = ACTIONS(655),
    [sym_readonly] = ACTIONS(655),
  },
  [393] = {
    [sym_import] = STATE(1528),
    [sym_parenthesized_expression] = STATE(933),
    [sym__expression] = STATE(1304),
    [sym_yield_expression] = STATE(1543),
    [sym_object] = STATE(1367),
    [sym_array] = STATE(1369),
    [sym_class] = STATE(1528),
    [sym_function] = STATE(1528),
    [sym_generator_function] = STATE(1528),
    [sym_arrow_function] = STATE(1528),
    [sym__call_signature] = STATE(3359),
    [sym_call_expression] = STATE(1528),
    [sym_new_expression] = STATE(1543),
    [sym_await_expression] = STATE(1543),
    [sym_member_expression] = STATE(933),
    [sym_subscript_expression] = STATE(933),
    [sym_assignment_expression] = STATE(1543),
    [sym__augmented_assignment_lhs] = STATE(1970),
    [sym_augmented_assignment_expression] = STATE(1543),
    [sym_ternary_expression] = STATE(1543),
    [sym_binary_expression] = STATE(1543),
    [sym_unary_expression] = STATE(1543),
    [sym_update_expression] = STATE(1543),
    [sym_string] = STATE(1528),
    [sym_template_string] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_meta_property] = STATE(1528),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(936),
    [sym_type_assertion] = STATE(1543),
    [sym_as_expression] = STATE(1543),
    [sym_internal_module] = STATE(1543),
    [sym_type_arguments] = STATE(381),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2726),
    [sym_identifier] = ACTIONS(855),
    [anon_sym_export] = ACTIONS(745),
    [anon_sym_namespace] = ACTIONS(747),
    [anon_sym_LBRACE] = ACTIONS(859),
    [anon_sym_type] = ACTIONS(745),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(537),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(549),
    [anon_sym_async] = ACTIONS(753),
    [anon_sym_function] = ACTIONS(553),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(745),
    [anon_sym_get] = ACTIONS(745),
    [anon_sym_set] = ACTIONS(745),
    [anon_sym_declare] = ACTIONS(745),
    [anon_sym_public] = ACTIONS(745),
    [anon_sym_private] = ACTIONS(745),
    [anon_sym_protected] = ACTIONS(745),
    [anon_sym_module] = ACTIONS(745),
    [anon_sym_any] = ACTIONS(745),
    [anon_sym_number] = ACTIONS(745),
    [anon_sym_boolean] = ACTIONS(745),
    [anon_sym_string] = ACTIONS(745),
    [anon_sym_symbol] = ACTIONS(745),
    [sym_readonly] = ACTIONS(745),
  },
  [394] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(965),
    [sym__expression] = STATE(1287),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1524),
    [sym_array] = STATE(1523),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3348),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(965),
    [sym_subscript_expression] = STATE(965),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1969),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(975),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(302),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(901),
    [anon_sym_export] = ACTIONS(713),
    [anon_sym_namespace] = ACTIONS(715),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_type] = ACTIONS(713),
    [anon_sym_typeof] = ACTIONS(735),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(719),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(721),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(725),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(727),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(907),
    [anon_sym_PLUS] = ACTIONS(909),
    [anon_sym_DASH] = ACTIONS(909),
    [anon_sym_TILDE] = ACTIONS(719),
    [anon_sym_void] = ACTIONS(735),
    [anon_sym_delete] = ACTIONS(735),
    [anon_sym_PLUS_PLUS] = ACTIONS(737),
    [anon_sym_DASH_DASH] = ACTIONS(737),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(713),
    [anon_sym_get] = ACTIONS(713),
    [anon_sym_set] = ACTIONS(713),
    [anon_sym_declare] = ACTIONS(713),
    [anon_sym_public] = ACTIONS(713),
    [anon_sym_private] = ACTIONS(713),
    [anon_sym_protected] = ACTIONS(713),
    [anon_sym_module] = ACTIONS(713),
    [anon_sym_any] = ACTIONS(713),
    [anon_sym_number] = ACTIONS(713),
    [anon_sym_boolean] = ACTIONS(713),
    [anon_sym_string] = ACTIONS(713),
    [anon_sym_symbol] = ACTIONS(713),
    [sym_readonly] = ACTIONS(713),
  },
  [395] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(963),
    [sym__expression] = STATE(1288),
    [sym_yield_expression] = STATE(1722),
    [sym_object] = STATE(1536),
    [sym_array] = STATE(1535),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(3286),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1722),
    [sym_await_expression] = STATE(1722),
    [sym_member_expression] = STATE(963),
    [sym_subscript_expression] = STATE(963),
    [sym_assignment_expression] = STATE(1722),
    [sym__augmented_assignment_lhs] = STATE(1968),
    [sym_augmented_assignment_expression] = STATE(1722),
    [sym_ternary_expression] = STATE(1722),
    [sym_binary_expression] = STATE(1722),
    [sym_unary_expression] = STATE(1722),
    [sym_update_expression] = STATE(1722),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(952),
    [sym_type_assertion] = STATE(1722),
    [sym_as_expression] = STATE(1722),
    [sym_internal_module] = STATE(1722),
    [sym_type_arguments] = STATE(266),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2684),
    [sym_identifier] = ACTIONS(863),
    [anon_sym_export] = ACTIONS(655),
    [anon_sym_namespace] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(1270),
    [anon_sym_type] = ACTIONS(655),
    [anon_sym_typeof] = ACTIONS(689),
    [anon_sym_import] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_LPAREN] = ACTIONS(871),
    [anon_sym_await] = ACTIONS(669),
    [anon_sym_yield] = ACTIONS(671),
    [anon_sym_LBRACK] = ACTIONS(873),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(675),
    [anon_sym_class] = ACTIONS(677),
    [anon_sym_async] = ACTIONS(679),
    [anon_sym_function] = ACTIONS(681),
    [anon_sym_new] = ACTIONS(875),
    [anon_sym_PLUS] = ACTIONS(877),
    [anon_sym_DASH] = ACTIONS(877),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_void] = ACTIONS(689),
    [anon_sym_delete] = ACTIONS(689),
    [anon_sym_PLUS_PLUS] = ACTIONS(691),
    [anon_sym_DASH_DASH] = ACTIONS(691),
    [anon_sym_DQUOTE] = ACTIONS(693),
    [anon_sym_SQUOTE] = ACTIONS(695),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(697),
    [sym_number] = ACTIONS(879),
    [sym_this] = ACTIONS(703),
    [sym_super] = ACTIONS(703),
    [sym_true] = ACTIONS(703),
    [sym_false] = ACTIONS(703),
    [sym_null] = ACTIONS(703),
    [sym_undefined] = ACTIONS(703),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(655),
    [anon_sym_get] = ACTIONS(655),
    [anon_sym_set] = ACTIONS(655),
    [anon_sym_declare] = ACTIONS(655),
    [anon_sym_public] = ACTIONS(655),
    [anon_sym_private] = ACTIONS(655),
    [anon_sym_protected] = ACTIONS(655),
    [anon_sym_module] = ACTIONS(655),
    [anon_sym_any] = ACTIONS(655),
    [anon_sym_number] = ACTIONS(655),
    [anon_sym_boolean] = ACTIONS(655),
    [anon_sym_string] = ACTIONS(655),
    [anon_sym_symbol] = ACTIONS(655),
    [sym_readonly] = ACTIONS(655),
  },
  [396] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(884),
    [sym__expression] = STATE(1122),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1283),
    [sym_array] = STATE(1281),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3336),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(884),
    [sym_subscript_expression] = STATE(884),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1964),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(860),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(414),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(831),
    [anon_sym_export] = ACTIONS(503),
    [anon_sym_namespace] = ACTIONS(505),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_type] = ACTIONS(503),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(437),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(443),
    [anon_sym_yield] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(849),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(851),
    [anon_sym_TILDE] = ACTIONS(437),
    [anon_sym_void] = ACTIONS(471),
    [anon_sym_delete] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(473),
    [anon_sym_DASH_DASH] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(1497),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(503),
    [anon_sym_get] = ACTIONS(503),
    [anon_sym_set] = ACTIONS(503),
    [anon_sym_declare] = ACTIONS(503),
    [anon_sym_public] = ACTIONS(503),
    [anon_sym_private] = ACTIONS(503),
    [anon_sym_protected] = ACTIONS(503),
    [anon_sym_module] = ACTIONS(503),
    [anon_sym_any] = ACTIONS(503),
    [anon_sym_number] = ACTIONS(503),
    [anon_sym_boolean] = ACTIONS(503),
    [anon_sym_string] = ACTIONS(503),
    [anon_sym_symbol] = ACTIONS(503),
    [sym_readonly] = ACTIONS(503),
  },
  [397] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(978),
    [sym__expression] = STATE(1467),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1696),
    [sym_array] = STATE(1691),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3169),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(978),
    [sym_subscript_expression] = STATE(978),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1967),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(977),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(380),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(881),
    [anon_sym_export] = ACTIONS(617),
    [anon_sym_namespace] = ACTIONS(619),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_type] = ACTIONS(617),
    [anon_sym_typeof] = ACTIONS(639),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(625),
    [anon_sym_yield] = ACTIONS(627),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(631),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(887),
    [anon_sym_PLUS] = ACTIONS(889),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(623),
    [anon_sym_void] = ACTIONS(639),
    [anon_sym_delete] = ACTIONS(639),
    [anon_sym_PLUS_PLUS] = ACTIONS(641),
    [anon_sym_DASH_DASH] = ACTIONS(641),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(617),
    [anon_sym_get] = ACTIONS(617),
    [anon_sym_set] = ACTIONS(617),
    [anon_sym_declare] = ACTIONS(617),
    [anon_sym_public] = ACTIONS(617),
    [anon_sym_private] = ACTIONS(617),
    [anon_sym_protected] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(617),
    [anon_sym_any] = ACTIONS(617),
    [anon_sym_number] = ACTIONS(617),
    [anon_sym_boolean] = ACTIONS(617),
    [anon_sym_string] = ACTIONS(617),
    [anon_sym_symbol] = ACTIONS(617),
    [sym_readonly] = ACTIONS(617),
  },
  [398] = {
    [sym_import] = STATE(1528),
    [sym_parenthesized_expression] = STATE(933),
    [sym__expression] = STATE(1180),
    [sym_yield_expression] = STATE(1543),
    [sym_object] = STATE(1367),
    [sym_array] = STATE(1369),
    [sym_class] = STATE(1528),
    [sym_function] = STATE(1528),
    [sym_generator_function] = STATE(1528),
    [sym_arrow_function] = STATE(1528),
    [sym__call_signature] = STATE(3359),
    [sym_call_expression] = STATE(1528),
    [sym_new_expression] = STATE(1543),
    [sym_await_expression] = STATE(1543),
    [sym_member_expression] = STATE(933),
    [sym_subscript_expression] = STATE(933),
    [sym_assignment_expression] = STATE(1543),
    [sym__augmented_assignment_lhs] = STATE(1970),
    [sym_augmented_assignment_expression] = STATE(1543),
    [sym_ternary_expression] = STATE(1543),
    [sym_binary_expression] = STATE(1543),
    [sym_unary_expression] = STATE(1543),
    [sym_update_expression] = STATE(1543),
    [sym_string] = STATE(1528),
    [sym_template_string] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_meta_property] = STATE(1528),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(936),
    [sym_type_assertion] = STATE(1543),
    [sym_as_expression] = STATE(1543),
    [sym_internal_module] = STATE(1543),
    [sym_type_arguments] = STATE(381),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2726),
    [sym_identifier] = ACTIONS(855),
    [anon_sym_export] = ACTIONS(745),
    [anon_sym_namespace] = ACTIONS(747),
    [anon_sym_LBRACE] = ACTIONS(859),
    [anon_sym_type] = ACTIONS(745),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(537),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(549),
    [anon_sym_async] = ACTIONS(753),
    [anon_sym_function] = ACTIONS(553),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(1501),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(745),
    [anon_sym_get] = ACTIONS(745),
    [anon_sym_set] = ACTIONS(745),
    [anon_sym_declare] = ACTIONS(745),
    [anon_sym_public] = ACTIONS(745),
    [anon_sym_private] = ACTIONS(745),
    [anon_sym_protected] = ACTIONS(745),
    [anon_sym_module] = ACTIONS(745),
    [anon_sym_any] = ACTIONS(745),
    [anon_sym_number] = ACTIONS(745),
    [anon_sym_boolean] = ACTIONS(745),
    [anon_sym_string] = ACTIONS(745),
    [anon_sym_symbol] = ACTIONS(745),
    [sym_readonly] = ACTIONS(745),
  },
  [399] = {
    [sym_import] = STATE(1528),
    [sym_parenthesized_expression] = STATE(933),
    [sym__expression] = STATE(1155),
    [sym_yield_expression] = STATE(1543),
    [sym_object] = STATE(1367),
    [sym_array] = STATE(1369),
    [sym_class] = STATE(1528),
    [sym_function] = STATE(1528),
    [sym_generator_function] = STATE(1528),
    [sym_arrow_function] = STATE(1528),
    [sym__call_signature] = STATE(3359),
    [sym_call_expression] = STATE(1528),
    [sym_new_expression] = STATE(1543),
    [sym_await_expression] = STATE(1543),
    [sym_member_expression] = STATE(933),
    [sym_subscript_expression] = STATE(933),
    [sym_assignment_expression] = STATE(1543),
    [sym__augmented_assignment_lhs] = STATE(1970),
    [sym_augmented_assignment_expression] = STATE(1543),
    [sym_ternary_expression] = STATE(1543),
    [sym_binary_expression] = STATE(1543),
    [sym_unary_expression] = STATE(1543),
    [sym_update_expression] = STATE(1543),
    [sym_string] = STATE(1528),
    [sym_template_string] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_meta_property] = STATE(1528),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(936),
    [sym_type_assertion] = STATE(1543),
    [sym_as_expression] = STATE(1543),
    [sym_internal_module] = STATE(1543),
    [sym_type_arguments] = STATE(381),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2726),
    [sym_identifier] = ACTIONS(1503),
    [anon_sym_export] = ACTIONS(745),
    [anon_sym_namespace] = ACTIONS(747),
    [anon_sym_LBRACE] = ACTIONS(859),
    [anon_sym_type] = ACTIONS(745),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(537),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(549),
    [anon_sym_async] = ACTIONS(753),
    [anon_sym_function] = ACTIONS(553),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(745),
    [anon_sym_get] = ACTIONS(745),
    [anon_sym_set] = ACTIONS(745),
    [anon_sym_declare] = ACTIONS(745),
    [anon_sym_public] = ACTIONS(745),
    [anon_sym_private] = ACTIONS(745),
    [anon_sym_protected] = ACTIONS(745),
    [anon_sym_module] = ACTIONS(745),
    [anon_sym_any] = ACTIONS(745),
    [anon_sym_number] = ACTIONS(745),
    [anon_sym_boolean] = ACTIONS(745),
    [anon_sym_string] = ACTIONS(745),
    [anon_sym_symbol] = ACTIONS(745),
    [sym_readonly] = ACTIONS(745),
  },
  [400] = {
    [sym_import] = STATE(1724),
    [sym_parenthesized_expression] = STATE(963),
    [sym__expression] = STATE(1272),
    [sym_yield_expression] = STATE(1722),
    [sym_object] = STATE(1536),
    [sym_array] = STATE(1535),
    [sym_class] = STATE(1724),
    [sym_function] = STATE(1724),
    [sym_generator_function] = STATE(1724),
    [sym_arrow_function] = STATE(1724),
    [sym__call_signature] = STATE(3286),
    [sym_call_expression] = STATE(1724),
    [sym_new_expression] = STATE(1722),
    [sym_await_expression] = STATE(1722),
    [sym_member_expression] = STATE(963),
    [sym_subscript_expression] = STATE(963),
    [sym_assignment_expression] = STATE(1722),
    [sym__augmented_assignment_lhs] = STATE(1968),
    [sym_augmented_assignment_expression] = STATE(1722),
    [sym_ternary_expression] = STATE(1722),
    [sym_binary_expression] = STATE(1722),
    [sym_unary_expression] = STATE(1722),
    [sym_update_expression] = STATE(1722),
    [sym_string] = STATE(1724),
    [sym_template_string] = STATE(1724),
    [sym_regex] = STATE(1724),
    [sym_meta_property] = STATE(1724),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(952),
    [sym_type_assertion] = STATE(1722),
    [sym_as_expression] = STATE(1722),
    [sym_internal_module] = STATE(1722),
    [sym_type_arguments] = STATE(266),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2684),
    [sym_identifier] = ACTIONS(863),
    [anon_sym_export] = ACTIONS(655),
    [anon_sym_namespace] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(1270),
    [anon_sym_type] = ACTIONS(655),
    [anon_sym_typeof] = ACTIONS(689),
    [anon_sym_import] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_LPAREN] = ACTIONS(871),
    [anon_sym_await] = ACTIONS(669),
    [anon_sym_yield] = ACTIONS(671),
    [anon_sym_LBRACK] = ACTIONS(873),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(675),
    [anon_sym_class] = ACTIONS(677),
    [anon_sym_async] = ACTIONS(679),
    [anon_sym_function] = ACTIONS(681),
    [anon_sym_new] = ACTIONS(875),
    [anon_sym_PLUS] = ACTIONS(877),
    [anon_sym_DASH] = ACTIONS(877),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_void] = ACTIONS(689),
    [anon_sym_delete] = ACTIONS(689),
    [anon_sym_PLUS_PLUS] = ACTIONS(691),
    [anon_sym_DASH_DASH] = ACTIONS(691),
    [anon_sym_DQUOTE] = ACTIONS(693),
    [anon_sym_SQUOTE] = ACTIONS(695),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(697),
    [sym_number] = ACTIONS(879),
    [sym_this] = ACTIONS(703),
    [sym_super] = ACTIONS(703),
    [sym_true] = ACTIONS(703),
    [sym_false] = ACTIONS(703),
    [sym_null] = ACTIONS(703),
    [sym_undefined] = ACTIONS(703),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(655),
    [anon_sym_get] = ACTIONS(655),
    [anon_sym_set] = ACTIONS(655),
    [anon_sym_declare] = ACTIONS(655),
    [anon_sym_public] = ACTIONS(655),
    [anon_sym_private] = ACTIONS(655),
    [anon_sym_protected] = ACTIONS(655),
    [anon_sym_module] = ACTIONS(655),
    [anon_sym_any] = ACTIONS(655),
    [anon_sym_number] = ACTIONS(655),
    [anon_sym_boolean] = ACTIONS(655),
    [anon_sym_string] = ACTIONS(655),
    [anon_sym_symbol] = ACTIONS(655),
    [sym_readonly] = ACTIONS(655),
  },
  [401] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(884),
    [sym__expression] = STATE(1051),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1283),
    [sym_array] = STATE(1281),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3336),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(884),
    [sym_subscript_expression] = STATE(884),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1964),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(860),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(414),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(831),
    [anon_sym_export] = ACTIONS(503),
    [anon_sym_namespace] = ACTIONS(505),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_type] = ACTIONS(503),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(437),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(443),
    [anon_sym_yield] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(849),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(851),
    [anon_sym_TILDE] = ACTIONS(437),
    [anon_sym_void] = ACTIONS(471),
    [anon_sym_delete] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(473),
    [anon_sym_DASH_DASH] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(503),
    [anon_sym_get] = ACTIONS(503),
    [anon_sym_set] = ACTIONS(503),
    [anon_sym_declare] = ACTIONS(503),
    [anon_sym_public] = ACTIONS(503),
    [anon_sym_private] = ACTIONS(503),
    [anon_sym_protected] = ACTIONS(503),
    [anon_sym_module] = ACTIONS(503),
    [anon_sym_any] = ACTIONS(503),
    [anon_sym_number] = ACTIONS(503),
    [anon_sym_boolean] = ACTIONS(503),
    [anon_sym_string] = ACTIONS(503),
    [anon_sym_symbol] = ACTIONS(503),
    [sym_readonly] = ACTIONS(503),
  },
  [402] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(965),
    [sym__expression] = STATE(1251),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1524),
    [sym_array] = STATE(1523),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3348),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(965),
    [sym_subscript_expression] = STATE(965),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1969),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(975),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(302),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(901),
    [anon_sym_export] = ACTIONS(713),
    [anon_sym_namespace] = ACTIONS(715),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_type] = ACTIONS(713),
    [anon_sym_typeof] = ACTIONS(735),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(719),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(721),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(725),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(727),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(907),
    [anon_sym_PLUS] = ACTIONS(909),
    [anon_sym_DASH] = ACTIONS(909),
    [anon_sym_TILDE] = ACTIONS(719),
    [anon_sym_void] = ACTIONS(735),
    [anon_sym_delete] = ACTIONS(735),
    [anon_sym_PLUS_PLUS] = ACTIONS(737),
    [anon_sym_DASH_DASH] = ACTIONS(737),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(713),
    [anon_sym_get] = ACTIONS(713),
    [anon_sym_set] = ACTIONS(713),
    [anon_sym_declare] = ACTIONS(713),
    [anon_sym_public] = ACTIONS(713),
    [anon_sym_private] = ACTIONS(713),
    [anon_sym_protected] = ACTIONS(713),
    [anon_sym_module] = ACTIONS(713),
    [anon_sym_any] = ACTIONS(713),
    [anon_sym_number] = ACTIONS(713),
    [anon_sym_boolean] = ACTIONS(713),
    [anon_sym_string] = ACTIONS(713),
    [anon_sym_symbol] = ACTIONS(713),
    [sym_readonly] = ACTIONS(713),
  },
  [403] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(978),
    [sym__expression] = STATE(1457),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1696),
    [sym_array] = STATE(1691),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3169),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(978),
    [sym_subscript_expression] = STATE(978),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1967),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(977),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(380),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(881),
    [anon_sym_export] = ACTIONS(617),
    [anon_sym_namespace] = ACTIONS(619),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_type] = ACTIONS(617),
    [anon_sym_typeof] = ACTIONS(639),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(625),
    [anon_sym_yield] = ACTIONS(627),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(631),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(887),
    [anon_sym_PLUS] = ACTIONS(889),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(623),
    [anon_sym_void] = ACTIONS(639),
    [anon_sym_delete] = ACTIONS(639),
    [anon_sym_PLUS_PLUS] = ACTIONS(641),
    [anon_sym_DASH_DASH] = ACTIONS(641),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(617),
    [anon_sym_get] = ACTIONS(617),
    [anon_sym_set] = ACTIONS(617),
    [anon_sym_declare] = ACTIONS(617),
    [anon_sym_public] = ACTIONS(617),
    [anon_sym_private] = ACTIONS(617),
    [anon_sym_protected] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(617),
    [anon_sym_any] = ACTIONS(617),
    [anon_sym_number] = ACTIONS(617),
    [anon_sym_boolean] = ACTIONS(617),
    [anon_sym_string] = ACTIONS(617),
    [anon_sym_symbol] = ACTIONS(617),
    [sym_readonly] = ACTIONS(617),
  },
  [404] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(978),
    [sym__expression] = STATE(1449),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1696),
    [sym_array] = STATE(1691),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3169),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(978),
    [sym_subscript_expression] = STATE(978),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1967),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(977),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(380),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(881),
    [anon_sym_export] = ACTIONS(617),
    [anon_sym_namespace] = ACTIONS(619),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_type] = ACTIONS(617),
    [anon_sym_typeof] = ACTIONS(639),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(625),
    [anon_sym_yield] = ACTIONS(627),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(631),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(887),
    [anon_sym_PLUS] = ACTIONS(889),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(623),
    [anon_sym_void] = ACTIONS(639),
    [anon_sym_delete] = ACTIONS(639),
    [anon_sym_PLUS_PLUS] = ACTIONS(641),
    [anon_sym_DASH_DASH] = ACTIONS(641),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(617),
    [anon_sym_get] = ACTIONS(617),
    [anon_sym_set] = ACTIONS(617),
    [anon_sym_declare] = ACTIONS(617),
    [anon_sym_public] = ACTIONS(617),
    [anon_sym_private] = ACTIONS(617),
    [anon_sym_protected] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(617),
    [anon_sym_any] = ACTIONS(617),
    [anon_sym_number] = ACTIONS(617),
    [anon_sym_boolean] = ACTIONS(617),
    [anon_sym_string] = ACTIONS(617),
    [anon_sym_symbol] = ACTIONS(617),
    [sym_readonly] = ACTIONS(617),
  },
  [405] = {
    [sym_import] = STATE(1528),
    [sym_parenthesized_expression] = STATE(983),
    [sym__expression] = STATE(1442),
    [sym_yield_expression] = STATE(1543),
    [sym_object] = STATE(1671),
    [sym_array] = STATE(1713),
    [sym_class] = STATE(1528),
    [sym_function] = STATE(1528),
    [sym_generator_function] = STATE(1528),
    [sym_arrow_function] = STATE(1528),
    [sym__call_signature] = STATE(3235),
    [sym_call_expression] = STATE(1528),
    [sym_new_expression] = STATE(1543),
    [sym_await_expression] = STATE(1543),
    [sym_member_expression] = STATE(983),
    [sym_subscript_expression] = STATE(983),
    [sym_assignment_expression] = STATE(1543),
    [sym__augmented_assignment_lhs] = STATE(1963),
    [sym_augmented_assignment_expression] = STATE(1543),
    [sym_ternary_expression] = STATE(1543),
    [sym_binary_expression] = STATE(1543),
    [sym_unary_expression] = STATE(1543),
    [sym_update_expression] = STATE(1543),
    [sym_string] = STATE(1528),
    [sym_template_string] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_meta_property] = STATE(1528),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(984),
    [sym_type_assertion] = STATE(1543),
    [sym_as_expression] = STATE(1543),
    [sym_internal_module] = STATE(1543),
    [sym_type_arguments] = STATE(310),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2726),
    [sym_identifier] = ACTIONS(891),
    [anon_sym_export] = ACTIONS(529),
    [anon_sym_namespace] = ACTIONS(531),
    [anon_sym_LBRACE] = ACTIONS(859),
    [anon_sym_type] = ACTIONS(529),
    [anon_sym_typeof] = ACTIONS(561),
    [anon_sym_import] = ACTIONS(537),
    [anon_sym_BANG] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(543),
    [anon_sym_yield] = ACTIONS(545),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(549),
    [anon_sym_async] = ACTIONS(551),
    [anon_sym_function] = ACTIONS(553),
    [anon_sym_new] = ACTIONS(897),
    [anon_sym_PLUS] = ACTIONS(899),
    [anon_sym_DASH] = ACTIONS(899),
    [anon_sym_TILDE] = ACTIONS(539),
    [anon_sym_void] = ACTIONS(561),
    [anon_sym_delete] = ACTIONS(561),
    [anon_sym_PLUS_PLUS] = ACTIONS(563),
    [anon_sym_DASH_DASH] = ACTIONS(563),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(529),
    [anon_sym_get] = ACTIONS(529),
    [anon_sym_set] = ACTIONS(529),
    [anon_sym_declare] = ACTIONS(529),
    [anon_sym_public] = ACTIONS(529),
    [anon_sym_private] = ACTIONS(529),
    [anon_sym_protected] = ACTIONS(529),
    [anon_sym_module] = ACTIONS(529),
    [anon_sym_any] = ACTIONS(529),
    [anon_sym_number] = ACTIONS(529),
    [anon_sym_boolean] = ACTIONS(529),
    [anon_sym_string] = ACTIONS(529),
    [anon_sym_symbol] = ACTIONS(529),
    [sym_readonly] = ACTIONS(529),
  },
  [406] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(978),
    [sym__expression] = STATE(1447),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1696),
    [sym_array] = STATE(1691),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3169),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(978),
    [sym_subscript_expression] = STATE(978),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1967),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(977),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(380),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(881),
    [anon_sym_export] = ACTIONS(617),
    [anon_sym_namespace] = ACTIONS(619),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_type] = ACTIONS(617),
    [anon_sym_typeof] = ACTIONS(639),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(625),
    [anon_sym_yield] = ACTIONS(627),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(631),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(887),
    [anon_sym_PLUS] = ACTIONS(889),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(623),
    [anon_sym_void] = ACTIONS(639),
    [anon_sym_delete] = ACTIONS(639),
    [anon_sym_PLUS_PLUS] = ACTIONS(641),
    [anon_sym_DASH_DASH] = ACTIONS(641),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(617),
    [anon_sym_get] = ACTIONS(617),
    [anon_sym_set] = ACTIONS(617),
    [anon_sym_declare] = ACTIONS(617),
    [anon_sym_public] = ACTIONS(617),
    [anon_sym_private] = ACTIONS(617),
    [anon_sym_protected] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(617),
    [anon_sym_any] = ACTIONS(617),
    [anon_sym_number] = ACTIONS(617),
    [anon_sym_boolean] = ACTIONS(617),
    [anon_sym_string] = ACTIONS(617),
    [anon_sym_symbol] = ACTIONS(617),
    [sym_readonly] = ACTIONS(617),
  },
  [407] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(978),
    [sym__expression] = STATE(1432),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1696),
    [sym_array] = STATE(1691),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3169),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(978),
    [sym_subscript_expression] = STATE(978),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1967),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(977),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(380),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(881),
    [anon_sym_export] = ACTIONS(617),
    [anon_sym_namespace] = ACTIONS(619),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_type] = ACTIONS(617),
    [anon_sym_typeof] = ACTIONS(639),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(625),
    [anon_sym_yield] = ACTIONS(627),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(631),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(887),
    [anon_sym_PLUS] = ACTIONS(889),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(623),
    [anon_sym_void] = ACTIONS(639),
    [anon_sym_delete] = ACTIONS(639),
    [anon_sym_PLUS_PLUS] = ACTIONS(641),
    [anon_sym_DASH_DASH] = ACTIONS(641),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(617),
    [anon_sym_get] = ACTIONS(617),
    [anon_sym_set] = ACTIONS(617),
    [anon_sym_declare] = ACTIONS(617),
    [anon_sym_public] = ACTIONS(617),
    [anon_sym_private] = ACTIONS(617),
    [anon_sym_protected] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(617),
    [anon_sym_any] = ACTIONS(617),
    [anon_sym_number] = ACTIONS(617),
    [anon_sym_boolean] = ACTIONS(617),
    [anon_sym_string] = ACTIONS(617),
    [anon_sym_symbol] = ACTIONS(617),
    [sym_readonly] = ACTIONS(617),
  },
  [408] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(978),
    [sym__expression] = STATE(1607),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1696),
    [sym_array] = STATE(1691),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3169),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(978),
    [sym_subscript_expression] = STATE(978),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1967),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(977),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(380),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(881),
    [anon_sym_export] = ACTIONS(617),
    [anon_sym_namespace] = ACTIONS(619),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_type] = ACTIONS(617),
    [anon_sym_typeof] = ACTIONS(639),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(625),
    [anon_sym_yield] = ACTIONS(627),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(631),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(887),
    [anon_sym_PLUS] = ACTIONS(889),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(623),
    [anon_sym_void] = ACTIONS(639),
    [anon_sym_delete] = ACTIONS(639),
    [anon_sym_PLUS_PLUS] = ACTIONS(641),
    [anon_sym_DASH_DASH] = ACTIONS(641),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(617),
    [anon_sym_get] = ACTIONS(617),
    [anon_sym_set] = ACTIONS(617),
    [anon_sym_declare] = ACTIONS(617),
    [anon_sym_public] = ACTIONS(617),
    [anon_sym_private] = ACTIONS(617),
    [anon_sym_protected] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(617),
    [anon_sym_any] = ACTIONS(617),
    [anon_sym_number] = ACTIONS(617),
    [anon_sym_boolean] = ACTIONS(617),
    [anon_sym_string] = ACTIONS(617),
    [anon_sym_symbol] = ACTIONS(617),
    [sym_readonly] = ACTIONS(617),
  },
  [409] = {
    [sym_import] = STATE(1528),
    [sym_parenthesized_expression] = STATE(983),
    [sym__expression] = STATE(1443),
    [sym_yield_expression] = STATE(1543),
    [sym_object] = STATE(1671),
    [sym_array] = STATE(1713),
    [sym_class] = STATE(1528),
    [sym_function] = STATE(1528),
    [sym_generator_function] = STATE(1528),
    [sym_arrow_function] = STATE(1528),
    [sym__call_signature] = STATE(3235),
    [sym_call_expression] = STATE(1528),
    [sym_new_expression] = STATE(1543),
    [sym_await_expression] = STATE(1543),
    [sym_member_expression] = STATE(983),
    [sym_subscript_expression] = STATE(983),
    [sym_assignment_expression] = STATE(1543),
    [sym__augmented_assignment_lhs] = STATE(1963),
    [sym_augmented_assignment_expression] = STATE(1543),
    [sym_ternary_expression] = STATE(1543),
    [sym_binary_expression] = STATE(1543),
    [sym_unary_expression] = STATE(1543),
    [sym_update_expression] = STATE(1543),
    [sym_string] = STATE(1528),
    [sym_template_string] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_meta_property] = STATE(1528),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(984),
    [sym_type_assertion] = STATE(1543),
    [sym_as_expression] = STATE(1543),
    [sym_internal_module] = STATE(1543),
    [sym_type_arguments] = STATE(310),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2726),
    [sym_identifier] = ACTIONS(891),
    [anon_sym_export] = ACTIONS(529),
    [anon_sym_namespace] = ACTIONS(531),
    [anon_sym_LBRACE] = ACTIONS(859),
    [anon_sym_type] = ACTIONS(529),
    [anon_sym_typeof] = ACTIONS(561),
    [anon_sym_import] = ACTIONS(537),
    [anon_sym_BANG] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(543),
    [anon_sym_yield] = ACTIONS(545),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(549),
    [anon_sym_async] = ACTIONS(551),
    [anon_sym_function] = ACTIONS(553),
    [anon_sym_new] = ACTIONS(897),
    [anon_sym_PLUS] = ACTIONS(899),
    [anon_sym_DASH] = ACTIONS(899),
    [anon_sym_TILDE] = ACTIONS(539),
    [anon_sym_void] = ACTIONS(561),
    [anon_sym_delete] = ACTIONS(561),
    [anon_sym_PLUS_PLUS] = ACTIONS(563),
    [anon_sym_DASH_DASH] = ACTIONS(563),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(529),
    [anon_sym_get] = ACTIONS(529),
    [anon_sym_set] = ACTIONS(529),
    [anon_sym_declare] = ACTIONS(529),
    [anon_sym_public] = ACTIONS(529),
    [anon_sym_private] = ACTIONS(529),
    [anon_sym_protected] = ACTIONS(529),
    [anon_sym_module] = ACTIONS(529),
    [anon_sym_any] = ACTIONS(529),
    [anon_sym_number] = ACTIONS(529),
    [anon_sym_boolean] = ACTIONS(529),
    [anon_sym_string] = ACTIONS(529),
    [anon_sym_symbol] = ACTIONS(529),
    [sym_readonly] = ACTIONS(529),
  },
  [410] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(884),
    [sym__expression] = STATE(1128),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1283),
    [sym_array] = STATE(1281),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3336),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(884),
    [sym_subscript_expression] = STATE(884),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1964),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(860),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(414),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(831),
    [anon_sym_export] = ACTIONS(503),
    [anon_sym_namespace] = ACTIONS(505),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_type] = ACTIONS(503),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(437),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(443),
    [anon_sym_yield] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(849),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(851),
    [anon_sym_TILDE] = ACTIONS(437),
    [anon_sym_void] = ACTIONS(471),
    [anon_sym_delete] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(473),
    [anon_sym_DASH_DASH] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(503),
    [anon_sym_get] = ACTIONS(503),
    [anon_sym_set] = ACTIONS(503),
    [anon_sym_declare] = ACTIONS(503),
    [anon_sym_public] = ACTIONS(503),
    [anon_sym_private] = ACTIONS(503),
    [anon_sym_protected] = ACTIONS(503),
    [anon_sym_module] = ACTIONS(503),
    [anon_sym_any] = ACTIONS(503),
    [anon_sym_number] = ACTIONS(503),
    [anon_sym_boolean] = ACTIONS(503),
    [anon_sym_string] = ACTIONS(503),
    [anon_sym_symbol] = ACTIONS(503),
    [sym_readonly] = ACTIONS(503),
  },
  [411] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(884),
    [sym__expression] = STATE(1124),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1283),
    [sym_array] = STATE(1281),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3336),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(884),
    [sym_subscript_expression] = STATE(884),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1964),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(860),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(414),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(831),
    [anon_sym_export] = ACTIONS(503),
    [anon_sym_namespace] = ACTIONS(505),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_type] = ACTIONS(503),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(437),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(443),
    [anon_sym_yield] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(849),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(851),
    [anon_sym_TILDE] = ACTIONS(437),
    [anon_sym_void] = ACTIONS(471),
    [anon_sym_delete] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(473),
    [anon_sym_DASH_DASH] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(503),
    [anon_sym_get] = ACTIONS(503),
    [anon_sym_set] = ACTIONS(503),
    [anon_sym_declare] = ACTIONS(503),
    [anon_sym_public] = ACTIONS(503),
    [anon_sym_private] = ACTIONS(503),
    [anon_sym_protected] = ACTIONS(503),
    [anon_sym_module] = ACTIONS(503),
    [anon_sym_any] = ACTIONS(503),
    [anon_sym_number] = ACTIONS(503),
    [anon_sym_boolean] = ACTIONS(503),
    [anon_sym_string] = ACTIONS(503),
    [anon_sym_symbol] = ACTIONS(503),
    [sym_readonly] = ACTIONS(503),
  },
  [412] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(965),
    [sym__expression] = STATE(1328),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1524),
    [sym_array] = STATE(1523),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3348),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(965),
    [sym_subscript_expression] = STATE(965),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1969),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(975),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(302),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(901),
    [anon_sym_export] = ACTIONS(713),
    [anon_sym_namespace] = ACTIONS(715),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_type] = ACTIONS(713),
    [anon_sym_typeof] = ACTIONS(735),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(719),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(721),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(725),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(727),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(907),
    [anon_sym_PLUS] = ACTIONS(909),
    [anon_sym_DASH] = ACTIONS(909),
    [anon_sym_TILDE] = ACTIONS(719),
    [anon_sym_void] = ACTIONS(735),
    [anon_sym_delete] = ACTIONS(735),
    [anon_sym_PLUS_PLUS] = ACTIONS(737),
    [anon_sym_DASH_DASH] = ACTIONS(737),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(713),
    [anon_sym_get] = ACTIONS(713),
    [anon_sym_set] = ACTIONS(713),
    [anon_sym_declare] = ACTIONS(713),
    [anon_sym_public] = ACTIONS(713),
    [anon_sym_private] = ACTIONS(713),
    [anon_sym_protected] = ACTIONS(713),
    [anon_sym_module] = ACTIONS(713),
    [anon_sym_any] = ACTIONS(713),
    [anon_sym_number] = ACTIONS(713),
    [anon_sym_boolean] = ACTIONS(713),
    [anon_sym_string] = ACTIONS(713),
    [anon_sym_symbol] = ACTIONS(713),
    [sym_readonly] = ACTIONS(713),
  },
  [413] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(978),
    [sym__expression] = STATE(1020),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1696),
    [sym_array] = STATE(1691),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3169),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(978),
    [sym_subscript_expression] = STATE(978),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1967),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(977),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(380),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(881),
    [anon_sym_export] = ACTIONS(617),
    [anon_sym_namespace] = ACTIONS(619),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_type] = ACTIONS(617),
    [anon_sym_typeof] = ACTIONS(639),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(625),
    [anon_sym_yield] = ACTIONS(627),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(631),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(887),
    [anon_sym_PLUS] = ACTIONS(889),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(623),
    [anon_sym_void] = ACTIONS(639),
    [anon_sym_delete] = ACTIONS(639),
    [anon_sym_PLUS_PLUS] = ACTIONS(641),
    [anon_sym_DASH_DASH] = ACTIONS(641),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(617),
    [anon_sym_get] = ACTIONS(617),
    [anon_sym_set] = ACTIONS(617),
    [anon_sym_declare] = ACTIONS(617),
    [anon_sym_public] = ACTIONS(617),
    [anon_sym_private] = ACTIONS(617),
    [anon_sym_protected] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(617),
    [anon_sym_any] = ACTIONS(617),
    [anon_sym_number] = ACTIONS(617),
    [anon_sym_boolean] = ACTIONS(617),
    [anon_sym_string] = ACTIONS(617),
    [anon_sym_symbol] = ACTIONS(617),
    [sym_readonly] = ACTIONS(617),
  },
  [414] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(884),
    [sym__expression] = STATE(1025),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1283),
    [sym_array] = STATE(1281),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3336),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(884),
    [sym_subscript_expression] = STATE(884),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1964),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(860),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(414),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(831),
    [anon_sym_export] = ACTIONS(503),
    [anon_sym_namespace] = ACTIONS(505),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_type] = ACTIONS(503),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(437),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(443),
    [anon_sym_yield] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(849),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(851),
    [anon_sym_TILDE] = ACTIONS(437),
    [anon_sym_void] = ACTIONS(471),
    [anon_sym_delete] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(473),
    [anon_sym_DASH_DASH] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(503),
    [anon_sym_get] = ACTIONS(503),
    [anon_sym_set] = ACTIONS(503),
    [anon_sym_declare] = ACTIONS(503),
    [anon_sym_public] = ACTIONS(503),
    [anon_sym_private] = ACTIONS(503),
    [anon_sym_protected] = ACTIONS(503),
    [anon_sym_module] = ACTIONS(503),
    [anon_sym_any] = ACTIONS(503),
    [anon_sym_number] = ACTIONS(503),
    [anon_sym_boolean] = ACTIONS(503),
    [anon_sym_string] = ACTIONS(503),
    [anon_sym_symbol] = ACTIONS(503),
    [sym_readonly] = ACTIONS(503),
  },
  [415] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(884),
    [sym__expression] = STATE(1096),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1283),
    [sym_array] = STATE(1281),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3336),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(884),
    [sym_subscript_expression] = STATE(884),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1964),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(860),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(414),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(831),
    [anon_sym_export] = ACTIONS(503),
    [anon_sym_namespace] = ACTIONS(505),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_type] = ACTIONS(503),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(437),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(443),
    [anon_sym_yield] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(849),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(851),
    [anon_sym_TILDE] = ACTIONS(437),
    [anon_sym_void] = ACTIONS(471),
    [anon_sym_delete] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(473),
    [anon_sym_DASH_DASH] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(503),
    [anon_sym_get] = ACTIONS(503),
    [anon_sym_set] = ACTIONS(503),
    [anon_sym_declare] = ACTIONS(503),
    [anon_sym_public] = ACTIONS(503),
    [anon_sym_private] = ACTIONS(503),
    [anon_sym_protected] = ACTIONS(503),
    [anon_sym_module] = ACTIONS(503),
    [anon_sym_any] = ACTIONS(503),
    [anon_sym_number] = ACTIONS(503),
    [anon_sym_boolean] = ACTIONS(503),
    [anon_sym_string] = ACTIONS(503),
    [anon_sym_symbol] = ACTIONS(503),
    [sym_readonly] = ACTIONS(503),
  },
  [416] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(965),
    [sym__expression] = STATE(1343),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1524),
    [sym_array] = STATE(1523),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3348),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(965),
    [sym_subscript_expression] = STATE(965),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1969),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(975),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(302),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(901),
    [anon_sym_export] = ACTIONS(713),
    [anon_sym_namespace] = ACTIONS(715),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_type] = ACTIONS(713),
    [anon_sym_typeof] = ACTIONS(735),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(719),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(721),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(725),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(727),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(907),
    [anon_sym_PLUS] = ACTIONS(909),
    [anon_sym_DASH] = ACTIONS(909),
    [anon_sym_TILDE] = ACTIONS(719),
    [anon_sym_void] = ACTIONS(735),
    [anon_sym_delete] = ACTIONS(735),
    [anon_sym_PLUS_PLUS] = ACTIONS(737),
    [anon_sym_DASH_DASH] = ACTIONS(737),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(713),
    [anon_sym_get] = ACTIONS(713),
    [anon_sym_set] = ACTIONS(713),
    [anon_sym_declare] = ACTIONS(713),
    [anon_sym_public] = ACTIONS(713),
    [anon_sym_private] = ACTIONS(713),
    [anon_sym_protected] = ACTIONS(713),
    [anon_sym_module] = ACTIONS(713),
    [anon_sym_any] = ACTIONS(713),
    [anon_sym_number] = ACTIONS(713),
    [anon_sym_boolean] = ACTIONS(713),
    [anon_sym_string] = ACTIONS(713),
    [anon_sym_symbol] = ACTIONS(713),
    [sym_readonly] = ACTIONS(713),
  },
  [417] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(965),
    [sym__expression] = STATE(1307),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1524),
    [sym_array] = STATE(1523),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3348),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(965),
    [sym_subscript_expression] = STATE(965),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1969),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(975),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(302),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(901),
    [anon_sym_export] = ACTIONS(713),
    [anon_sym_namespace] = ACTIONS(715),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_type] = ACTIONS(713),
    [anon_sym_typeof] = ACTIONS(735),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(719),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(721),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(725),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(727),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(907),
    [anon_sym_PLUS] = ACTIONS(909),
    [anon_sym_DASH] = ACTIONS(909),
    [anon_sym_TILDE] = ACTIONS(719),
    [anon_sym_void] = ACTIONS(735),
    [anon_sym_delete] = ACTIONS(735),
    [anon_sym_PLUS_PLUS] = ACTIONS(737),
    [anon_sym_DASH_DASH] = ACTIONS(737),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(713),
    [anon_sym_get] = ACTIONS(713),
    [anon_sym_set] = ACTIONS(713),
    [anon_sym_declare] = ACTIONS(713),
    [anon_sym_public] = ACTIONS(713),
    [anon_sym_private] = ACTIONS(713),
    [anon_sym_protected] = ACTIONS(713),
    [anon_sym_module] = ACTIONS(713),
    [anon_sym_any] = ACTIONS(713),
    [anon_sym_number] = ACTIONS(713),
    [anon_sym_boolean] = ACTIONS(713),
    [anon_sym_string] = ACTIONS(713),
    [anon_sym_symbol] = ACTIONS(713),
    [sym_readonly] = ACTIONS(713),
  },
  [418] = {
    [sym_import] = STATE(1528),
    [sym_parenthesized_expression] = STATE(983),
    [sym__expression] = STATE(1445),
    [sym_yield_expression] = STATE(1543),
    [sym_object] = STATE(1671),
    [sym_array] = STATE(1713),
    [sym_class] = STATE(1528),
    [sym_function] = STATE(1528),
    [sym_generator_function] = STATE(1528),
    [sym_arrow_function] = STATE(1528),
    [sym__call_signature] = STATE(3235),
    [sym_call_expression] = STATE(1528),
    [sym_new_expression] = STATE(1543),
    [sym_await_expression] = STATE(1543),
    [sym_member_expression] = STATE(983),
    [sym_subscript_expression] = STATE(983),
    [sym_assignment_expression] = STATE(1543),
    [sym__augmented_assignment_lhs] = STATE(1963),
    [sym_augmented_assignment_expression] = STATE(1543),
    [sym_ternary_expression] = STATE(1543),
    [sym_binary_expression] = STATE(1543),
    [sym_unary_expression] = STATE(1543),
    [sym_update_expression] = STATE(1543),
    [sym_string] = STATE(1528),
    [sym_template_string] = STATE(1528),
    [sym_regex] = STATE(1528),
    [sym_meta_property] = STATE(1528),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(984),
    [sym_type_assertion] = STATE(1543),
    [sym_as_expression] = STATE(1543),
    [sym_internal_module] = STATE(1543),
    [sym_type_arguments] = STATE(310),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2726),
    [sym_identifier] = ACTIONS(891),
    [anon_sym_export] = ACTIONS(529),
    [anon_sym_namespace] = ACTIONS(531),
    [anon_sym_LBRACE] = ACTIONS(859),
    [anon_sym_type] = ACTIONS(529),
    [anon_sym_typeof] = ACTIONS(561),
    [anon_sym_import] = ACTIONS(537),
    [anon_sym_BANG] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(543),
    [anon_sym_yield] = ACTIONS(545),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(549),
    [anon_sym_async] = ACTIONS(551),
    [anon_sym_function] = ACTIONS(553),
    [anon_sym_new] = ACTIONS(897),
    [anon_sym_PLUS] = ACTIONS(899),
    [anon_sym_DASH] = ACTIONS(899),
    [anon_sym_TILDE] = ACTIONS(539),
    [anon_sym_void] = ACTIONS(561),
    [anon_sym_delete] = ACTIONS(561),
    [anon_sym_PLUS_PLUS] = ACTIONS(563),
    [anon_sym_DASH_DASH] = ACTIONS(563),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(529),
    [anon_sym_get] = ACTIONS(529),
    [anon_sym_set] = ACTIONS(529),
    [anon_sym_declare] = ACTIONS(529),
    [anon_sym_public] = ACTIONS(529),
    [anon_sym_private] = ACTIONS(529),
    [anon_sym_protected] = ACTIONS(529),
    [anon_sym_module] = ACTIONS(529),
    [anon_sym_any] = ACTIONS(529),
    [anon_sym_number] = ACTIONS(529),
    [anon_sym_boolean] = ACTIONS(529),
    [anon_sym_string] = ACTIONS(529),
    [anon_sym_symbol] = ACTIONS(529),
    [sym_readonly] = ACTIONS(529),
  },
  [419] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(884),
    [sym__expression] = STATE(1121),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1283),
    [sym_array] = STATE(1281),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1212),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(3336),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(884),
    [sym_subscript_expression] = STATE(884),
    [sym_assignment_expression] = STATE(1220),
    [sym__augmented_assignment_lhs] = STATE(1964),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(2295),
    [sym_non_null_expression] = STATE(860),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(414),
    [sym_type_parameters] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(2627),
    [sym_identifier] = ACTIONS(831),
    [anon_sym_export] = ACTIONS(503),
    [anon_sym_namespace] = ACTIONS(505),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_type] = ACTIONS(503),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(437),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_await] = ACTIONS(443),
    [anon_sym_yield] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(849),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(851),
    [anon_sym_TILDE] = ACTIONS(437),
    [anon_sym_void] = ACTIONS(471),
    [anon_sym_delete] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(473),
    [anon_sym_DASH_DASH] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(853),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(503),
    [anon_sym_get] = ACTIONS(503),
    [anon_sym_set] = ACTIONS(503),
    [anon_sym_declare] = ACTIONS(503),
    [anon_sym_public] = ACTIONS(503),
    [anon_sym_private] = ACTIONS(503),
    [anon_sym_protected] = ACTIONS(503),
    [anon_sym_module] = ACTIONS(503),
    [anon_sym_any] = ACTIONS(503),
    [anon_sym_number] = ACTIONS(503),
    [anon_sym_boolean] = ACTIONS(503),
    [anon_sym_string] = ACTIONS(503),
    [anon_sym_symbol] = ACTIONS(503),
    [sym_readonly] = ACTIONS(503),
  },
  [420] = {
    [ts_builtin_sym_end] = ACTIONS(1509),
    [sym_identifier] = ACTIONS(1511),
    [anon_sym_export] = ACTIONS(1511),
    [anon_sym_default] = ACTIONS(1511),
    [anon_sym_EQ] = ACTIONS(1511),
    [anon_sym_namespace] = ACTIONS(1511),
    [anon_sym_LBRACE] = ACTIONS(1509),
    [anon_sym_COMMA] = ACTIONS(1509),
    [anon_sym_RBRACE] = ACTIONS(1509),
    [anon_sym_type] = ACTIONS(1511),
    [anon_sym_typeof] = ACTIONS(1511),
    [anon_sym_import] = ACTIONS(1511),
    [anon_sym_var] = ACTIONS(1511),
    [anon_sym_let] = ACTIONS(1511),
    [anon_sym_const] = ACTIONS(1511),
    [anon_sym_BANG] = ACTIONS(1509),
    [anon_sym_else] = ACTIONS(1511),
    [anon_sym_if] = ACTIONS(1511),
    [anon_sym_switch] = ACTIONS(1511),
    [anon_sym_for] = ACTIONS(1511),
    [anon_sym_LPAREN] = ACTIONS(1509),
    [anon_sym_RPAREN] = ACTIONS(1509),
    [anon_sym_await] = ACTIONS(1511),
    [anon_sym_while] = ACTIONS(1511),
    [anon_sym_do] = ACTIONS(1511),
    [anon_sym_try] = ACTIONS(1511),
    [anon_sym_with] = ACTIONS(1511),
    [anon_sym_break] = ACTIONS(1511),
    [anon_sym_continue] = ACTIONS(1511),
    [anon_sym_debugger] = ACTIONS(1511),
    [anon_sym_return] = ACTIONS(1511),
    [anon_sym_throw] = ACTIONS(1511),
    [anon_sym_SEMI] = ACTIONS(1509),
    [anon_sym_COLON] = ACTIONS(1509),
    [anon_sym_case] = ACTIONS(1511),
    [anon_sym_yield] = ACTIONS(1511),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_RBRACK] = ACTIONS(1509),
    [anon_sym_LT] = ACTIONS(1509),
    [anon_sym_GT] = ACTIONS(1509),
    [anon_sym_SLASH] = ACTIONS(1511),
    [anon_sym_class] = ACTIONS(1511),
    [anon_sym_async] = ACTIONS(1511),
    [anon_sym_function] = ACTIONS(1511),
    [anon_sym_EQ_GT] = ACTIONS(1509),
    [anon_sym_new] = ACTIONS(1511),
    [anon_sym_QMARK] = ACTIONS(1509),
    [anon_sym_AMP] = ACTIONS(1509),
    [anon_sym_PIPE] = ACTIONS(1509),
    [anon_sym_PLUS] = ACTIONS(1511),
    [anon_sym_DASH] = ACTIONS(1511),
    [anon_sym_TILDE] = ACTIONS(1509),
    [anon_sym_void] = ACTIONS(1511),
    [anon_sym_delete] = ACTIONS(1511),
    [anon_sym_PLUS_PLUS] = ACTIONS(1509),
    [anon_sym_DASH_DASH] = ACTIONS(1509),
    [anon_sym_DQUOTE] = ACTIONS(1509),
    [anon_sym_SQUOTE] = ACTIONS(1509),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1509),
    [sym_number] = ACTIONS(1509),
    [sym_this] = ACTIONS(1511),
    [sym_super] = ACTIONS(1511),
    [sym_true] = ACTIONS(1511),
    [sym_false] = ACTIONS(1511),
    [sym_null] = ACTIONS(1511),
    [sym_undefined] = ACTIONS(1511),
    [anon_sym_AT] = ACTIONS(1509),
    [anon_sym_static] = ACTIONS(1511),
    [anon_sym_abstract] = ACTIONS(1511),
    [anon_sym_get] = ACTIONS(1511),
    [anon_sym_set] = ACTIONS(1511),
    [anon_sym_declare] = ACTIONS(1511),
    [anon_sym_public] = ACTIONS(1511),
    [anon_sym_private] = ACTIONS(1511),
    [anon_sym_protected] = ACTIONS(1511),
    [anon_sym_module] = ACTIONS(1511),
    [anon_sym_any] = ACTIONS(1511),
    [anon_sym_number] = ACTIONS(1511),
    [anon_sym_boolean] = ACTIONS(1511),
    [anon_sym_string] = ACTIONS(1511),
    [anon_sym_symbol] = ACTIONS(1511),
    [anon_sym_interface] = ACTIONS(1511),
    [anon_sym_extends] = ACTIONS(1511),
    [anon_sym_enum] = ACTIONS(1511),
    [sym_readonly] = ACTIONS(1511),
  },
  [421] = {
    [ts_builtin_sym_end] = ACTIONS(1513),
    [sym_identifier] = ACTIONS(1515),
    [anon_sym_export] = ACTIONS(1515),
    [anon_sym_default] = ACTIONS(1515),
    [anon_sym_EQ] = ACTIONS(1515),
    [anon_sym_namespace] = ACTIONS(1515),
    [anon_sym_LBRACE] = ACTIONS(1513),
    [anon_sym_COMMA] = ACTIONS(1513),
    [anon_sym_RBRACE] = ACTIONS(1513),
    [anon_sym_type] = ACTIONS(1515),
    [anon_sym_typeof] = ACTIONS(1515),
    [anon_sym_import] = ACTIONS(1515),
    [anon_sym_var] = ACTIONS(1515),
    [anon_sym_let] = ACTIONS(1515),
    [anon_sym_const] = ACTIONS(1515),
    [anon_sym_BANG] = ACTIONS(1513),
    [anon_sym_else] = ACTIONS(1515),
    [anon_sym_if] = ACTIONS(1515),
    [anon_sym_switch] = ACTIONS(1515),
    [anon_sym_for] = ACTIONS(1515),
    [anon_sym_LPAREN] = ACTIONS(1513),
    [anon_sym_RPAREN] = ACTIONS(1513),
    [anon_sym_await] = ACTIONS(1515),
    [anon_sym_while] = ACTIONS(1515),
    [anon_sym_do] = ACTIONS(1515),
    [anon_sym_try] = ACTIONS(1515),
    [anon_sym_with] = ACTIONS(1515),
    [anon_sym_break] = ACTIONS(1515),
    [anon_sym_continue] = ACTIONS(1515),
    [anon_sym_debugger] = ACTIONS(1515),
    [anon_sym_return] = ACTIONS(1515),
    [anon_sym_throw] = ACTIONS(1515),
    [anon_sym_SEMI] = ACTIONS(1513),
    [anon_sym_COLON] = ACTIONS(1513),
    [anon_sym_case] = ACTIONS(1515),
    [anon_sym_yield] = ACTIONS(1515),
    [anon_sym_LBRACK] = ACTIONS(1513),
    [anon_sym_RBRACK] = ACTIONS(1513),
    [anon_sym_LT] = ACTIONS(1513),
    [anon_sym_GT] = ACTIONS(1513),
    [anon_sym_SLASH] = ACTIONS(1515),
    [anon_sym_class] = ACTIONS(1515),
    [anon_sym_async] = ACTIONS(1515),
    [anon_sym_function] = ACTIONS(1515),
    [anon_sym_EQ_GT] = ACTIONS(1513),
    [anon_sym_new] = ACTIONS(1515),
    [anon_sym_QMARK] = ACTIONS(1513),
    [anon_sym_AMP] = ACTIONS(1513),
    [anon_sym_PIPE] = ACTIONS(1513),
    [anon_sym_PLUS] = ACTIONS(1515),
    [anon_sym_DASH] = ACTIONS(1515),
    [anon_sym_TILDE] = ACTIONS(1513),
    [anon_sym_void] = ACTIONS(1515),
    [anon_sym_delete] = ACTIONS(1515),
    [anon_sym_PLUS_PLUS] = ACTIONS(1513),
    [anon_sym_DASH_DASH] = ACTIONS(1513),
    [anon_sym_DQUOTE] = ACTIONS(1513),
    [anon_sym_SQUOTE] = ACTIONS(1513),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1513),
    [sym_number] = ACTIONS(1513),
    [sym_this] = ACTIONS(1515),
    [sym_super] = ACTIONS(1515),
    [sym_true] = ACTIONS(1515),
    [sym_false] = ACTIONS(1515),
    [sym_null] = ACTIONS(1515),
    [sym_undefined] = ACTIONS(1515),
    [anon_sym_AT] = ACTIONS(1513),
    [anon_sym_static] = ACTIONS(1515),
    [anon_sym_abstract] = ACTIONS(1515),
    [anon_sym_get] = ACTIONS(1515),
    [anon_sym_set] = ACTIONS(1515),
    [anon_sym_declare] = ACTIONS(1515),
    [anon_sym_public] = ACTIONS(1515),
    [anon_sym_private] = ACTIONS(1515),
    [anon_sym_protected] = ACTIONS(1515),
    [anon_sym_module] = ACTIONS(1515),
    [anon_sym_any] = ACTIONS(1515),
    [anon_sym_number] = ACTIONS(1515),
    [anon_sym_boolean] = ACTIONS(1515),
    [anon_sym_string] = ACTIONS(1515),
    [anon_sym_symbol] = ACTIONS(1515),
    [anon_sym_interface] = ACTIONS(1515),
    [anon_sym_extends] = ACTIONS(1515),
    [anon_sym_enum] = ACTIONS(1515),
    [sym_readonly] = ACTIONS(1515),
  },
  [422] = {
    [ts_builtin_sym_end] = ACTIONS(1517),
    [sym_identifier] = ACTIONS(1519),
    [anon_sym_export] = ACTIONS(1519),
    [anon_sym_default] = ACTIONS(1519),
    [anon_sym_EQ] = ACTIONS(1519),
    [anon_sym_namespace] = ACTIONS(1519),
    [anon_sym_LBRACE] = ACTIONS(1517),
    [anon_sym_COMMA] = ACTIONS(1517),
    [anon_sym_RBRACE] = ACTIONS(1517),
    [anon_sym_type] = ACTIONS(1519),
    [anon_sym_typeof] = ACTIONS(1519),
    [anon_sym_import] = ACTIONS(1519),
    [anon_sym_var] = ACTIONS(1519),
    [anon_sym_let] = ACTIONS(1519),
    [anon_sym_const] = ACTIONS(1519),
    [anon_sym_BANG] = ACTIONS(1517),
    [anon_sym_else] = ACTIONS(1519),
    [anon_sym_if] = ACTIONS(1519),
    [anon_sym_switch] = ACTIONS(1519),
    [anon_sym_for] = ACTIONS(1519),
    [anon_sym_LPAREN] = ACTIONS(1517),
    [anon_sym_RPAREN] = ACTIONS(1517),
    [anon_sym_await] = ACTIONS(1519),
    [anon_sym_while] = ACTIONS(1519),
    [anon_sym_do] = ACTIONS(1519),
    [anon_sym_try] = ACTIONS(1519),
    [anon_sym_with] = ACTIONS(1519),
    [anon_sym_break] = ACTIONS(1519),
    [anon_sym_continue] = ACTIONS(1519),
    [anon_sym_debugger] = ACTIONS(1519),
    [anon_sym_return] = ACTIONS(1519),
    [anon_sym_throw] = ACTIONS(1519),
    [anon_sym_SEMI] = ACTIONS(1517),
    [anon_sym_COLON] = ACTIONS(1517),
    [anon_sym_case] = ACTIONS(1519),
    [anon_sym_yield] = ACTIONS(1519),
    [anon_sym_LBRACK] = ACTIONS(1517),
    [anon_sym_RBRACK] = ACTIONS(1517),
    [anon_sym_LT] = ACTIONS(1517),
    [anon_sym_GT] = ACTIONS(1517),
    [anon_sym_SLASH] = ACTIONS(1519),
    [anon_sym_class] = ACTIONS(1519),
    [anon_sym_async] = ACTIONS(1519),
    [anon_sym_function] = ACTIONS(1519),
    [anon_sym_EQ_GT] = ACTIONS(1517),
    [anon_sym_new] = ACTIONS(1519),
    [anon_sym_QMARK] = ACTIONS(1517),
    [anon_sym_AMP] = ACTIONS(1517),
    [anon_sym_PIPE] = ACTIONS(1517),
    [anon_sym_PLUS] = ACTIONS(1519),
    [anon_sym_DASH] = ACTIONS(1519),
    [anon_sym_TILDE] = ACTIONS(1517),
    [anon_sym_void] = ACTIONS(1519),
    [anon_sym_delete] = ACTIONS(1519),
    [anon_sym_PLUS_PLUS] = ACTIONS(1517),
    [anon_sym_DASH_DASH] = ACTIONS(1517),
    [anon_sym_DQUOTE] = ACTIONS(1517),
    [anon_sym_SQUOTE] = ACTIONS(1517),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1517),
    [sym_number] = ACTIONS(1517),
    [sym_this] = ACTIONS(1519),
    [sym_super] = ACTIONS(1519),
    [sym_true] = ACTIONS(1519),
    [sym_false] = ACTIONS(1519),
    [sym_null] = ACTIONS(1519),
    [sym_undefined] = ACTIONS(1519),
    [anon_sym_AT] = ACTIONS(1517),
    [anon_sym_static] = ACTIONS(1519),
    [anon_sym_abstract] = ACTIONS(1519),
    [anon_sym_get] = ACTIONS(1519),
    [anon_sym_set] = ACTIONS(1519),
    [anon_sym_declare] = ACTIONS(1519),
    [anon_sym_public] = ACTIONS(1519),
    [anon_sym_private] = ACTIONS(1519),
    [anon_sym_protected] = ACTIONS(1519),
    [anon_sym_module] = ACTIONS(1519),
    [anon_sym_any] = ACTIONS(1519),
    [anon_sym_number] = ACTIONS(1519),
    [anon_sym_boolean] = ACTIONS(1519),
    [anon_sym_string] = ACTIONS(1519),
    [anon_sym_symbol] = ACTIONS(1519),
    [anon_sym_interface] = ACTIONS(1519),
    [anon_sym_extends] = ACTIONS(1519),
    [anon_sym_enum] = ACTIONS(1519),
    [sym_readonly] = ACTIONS(1519),
  },
  [423] = {
    [ts_builtin_sym_end] = ACTIONS(1521),
    [sym_identifier] = ACTIONS(1523),
    [anon_sym_export] = ACTIONS(1523),
    [anon_sym_default] = ACTIONS(1523),
    [anon_sym_EQ] = ACTIONS(1523),
    [anon_sym_namespace] = ACTIONS(1523),
    [anon_sym_LBRACE] = ACTIONS(1521),
    [anon_sym_COMMA] = ACTIONS(1521),
    [anon_sym_RBRACE] = ACTIONS(1521),
    [anon_sym_type] = ACTIONS(1523),
    [anon_sym_typeof] = ACTIONS(1523),
    [anon_sym_import] = ACTIONS(1523),
    [anon_sym_var] = ACTIONS(1523),
    [anon_sym_let] = ACTIONS(1523),
    [anon_sym_const] = ACTIONS(1523),
    [anon_sym_BANG] = ACTIONS(1521),
    [anon_sym_else] = ACTIONS(1523),
    [anon_sym_if] = ACTIONS(1523),
    [anon_sym_switch] = ACTIONS(1523),
    [anon_sym_for] = ACTIONS(1523),
    [anon_sym_LPAREN] = ACTIONS(1521),
    [anon_sym_RPAREN] = ACTIONS(1521),
    [anon_sym_await] = ACTIONS(1523),
    [anon_sym_while] = ACTIONS(1523),
    [anon_sym_do] = ACTIONS(1523),
    [anon_sym_try] = ACTIONS(1523),
    [anon_sym_with] = ACTIONS(1523),
    [anon_sym_break] = ACTIONS(1523),
    [anon_sym_continue] = ACTIONS(1523),
    [anon_sym_debugger] = ACTIONS(1523),
    [anon_sym_return] = ACTIONS(1523),
    [anon_sym_throw] = ACTIONS(1523),
    [anon_sym_SEMI] = ACTIONS(1521),
    [anon_sym_COLON] = ACTIONS(1521),
    [anon_sym_case] = ACTIONS(1523),
    [anon_sym_yield] = ACTIONS(1523),
    [anon_sym_LBRACK] = ACTIONS(1525),
    [anon_sym_RBRACK] = ACTIONS(1521),
    [anon_sym_LT] = ACTIONS(1521),
    [anon_sym_GT] = ACTIONS(1521),
    [anon_sym_SLASH] = ACTIONS(1523),
    [anon_sym_class] = ACTIONS(1523),
    [anon_sym_async] = ACTIONS(1523),
    [anon_sym_function] = ACTIONS(1523),
    [anon_sym_EQ_GT] = ACTIONS(1521),
    [anon_sym_new] = ACTIONS(1523),
    [anon_sym_QMARK] = ACTIONS(1521),
    [anon_sym_AMP] = ACTIONS(1521),
    [anon_sym_PIPE] = ACTIONS(1521),
    [anon_sym_PLUS] = ACTIONS(1523),
    [anon_sym_DASH] = ACTIONS(1523),
    [anon_sym_TILDE] = ACTIONS(1521),
    [anon_sym_void] = ACTIONS(1523),
    [anon_sym_delete] = ACTIONS(1523),
    [anon_sym_PLUS_PLUS] = ACTIONS(1521),
    [anon_sym_DASH_DASH] = ACTIONS(1521),
    [anon_sym_DQUOTE] = ACTIONS(1521),
    [anon_sym_SQUOTE] = ACTIONS(1521),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1521),
    [sym_number] = ACTIONS(1521),
    [sym_this] = ACTIONS(1523),
    [sym_super] = ACTIONS(1523),
    [sym_true] = ACTIONS(1523),
    [sym_false] = ACTIONS(1523),
    [sym_null] = ACTIONS(1523),
    [sym_undefined] = ACTIONS(1523),
    [anon_sym_AT] = ACTIONS(1521),
    [anon_sym_static] = ACTIONS(1523),
    [anon_sym_abstract] = ACTIONS(1523),
    [anon_sym_get] = ACTIONS(1523),
    [anon_sym_set] = ACTIONS(1523),
    [anon_sym_declare] = ACTIONS(1523),
    [anon_sym_public] = ACTIONS(1523),
    [anon_sym_private] = ACTIONS(1523),
    [anon_sym_protected] = ACTIONS(1523),
    [anon_sym_module] = ACTIONS(1523),
    [anon_sym_any] = ACTIONS(1523),
    [anon_sym_number] = ACTIONS(1523),
    [anon_sym_boolean] = ACTIONS(1523),
    [anon_sym_string] = ACTIONS(1523),
    [anon_sym_symbol] = ACTIONS(1523),
    [anon_sym_interface] = ACTIONS(1523),
    [anon_sym_extends] = ACTIONS(1523),
    [anon_sym_enum] = ACTIONS(1523),
    [sym_readonly] = ACTIONS(1523),
  },
  [424] = {
    [ts_builtin_sym_end] = ACTIONS(1527),
    [sym_identifier] = ACTIONS(1529),
    [anon_sym_export] = ACTIONS(1529),
    [anon_sym_default] = ACTIONS(1529),
    [anon_sym_EQ] = ACTIONS(1529),
    [anon_sym_namespace] = ACTIONS(1529),
    [anon_sym_LBRACE] = ACTIONS(1527),
    [anon_sym_COMMA] = ACTIONS(1527),
    [anon_sym_RBRACE] = ACTIONS(1527),
    [anon_sym_type] = ACTIONS(1529),
    [anon_sym_typeof] = ACTIONS(1529),
    [anon_sym_import] = ACTIONS(1529),
    [anon_sym_var] = ACTIONS(1529),
    [anon_sym_let] = ACTIONS(1529),
    [anon_sym_const] = ACTIONS(1529),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_else] = ACTIONS(1529),
    [anon_sym_if] = ACTIONS(1529),
    [anon_sym_switch] = ACTIONS(1529),
    [anon_sym_for] = ACTIONS(1529),
    [anon_sym_LPAREN] = ACTIONS(1527),
    [anon_sym_RPAREN] = ACTIONS(1527),
    [anon_sym_await] = ACTIONS(1529),
    [anon_sym_while] = ACTIONS(1529),
    [anon_sym_do] = ACTIONS(1529),
    [anon_sym_try] = ACTIONS(1529),
    [anon_sym_with] = ACTIONS(1529),
    [anon_sym_break] = ACTIONS(1529),
    [anon_sym_continue] = ACTIONS(1529),
    [anon_sym_debugger] = ACTIONS(1529),
    [anon_sym_return] = ACTIONS(1529),
    [anon_sym_throw] = ACTIONS(1529),
    [anon_sym_SEMI] = ACTIONS(1527),
    [anon_sym_COLON] = ACTIONS(1527),
    [anon_sym_case] = ACTIONS(1529),
    [anon_sym_yield] = ACTIONS(1529),
    [anon_sym_LBRACK] = ACTIONS(1527),
    [anon_sym_RBRACK] = ACTIONS(1527),
    [anon_sym_LT] = ACTIONS(1527),
    [anon_sym_GT] = ACTIONS(1527),
    [anon_sym_SLASH] = ACTIONS(1529),
    [anon_sym_class] = ACTIONS(1529),
    [anon_sym_async] = ACTIONS(1529),
    [anon_sym_function] = ACTIONS(1529),
    [anon_sym_EQ_GT] = ACTIONS(1527),
    [anon_sym_new] = ACTIONS(1529),
    [anon_sym_QMARK] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_PIPE] = ACTIONS(1527),
    [anon_sym_PLUS] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(1529),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_void] = ACTIONS(1529),
    [anon_sym_delete] = ACTIONS(1529),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_DQUOTE] = ACTIONS(1527),
    [anon_sym_SQUOTE] = ACTIONS(1527),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1527),
    [sym_number] = ACTIONS(1527),
    [sym_this] = ACTIONS(1529),
    [sym_super] = ACTIONS(1529),
    [sym_true] = ACTIONS(1529),
    [sym_false] = ACTIONS(1529),
    [sym_null] = ACTIONS(1529),
    [sym_undefined] = ACTIONS(1529),
    [anon_sym_AT] = ACTIONS(1527),
    [anon_sym_static] = ACTIONS(1529),
    [anon_sym_abstract] = ACTIONS(1529),
    [anon_sym_get] = ACTIONS(1529),
    [anon_sym_set] = ACTIONS(1529),
    [anon_sym_declare] = ACTIONS(1529),
    [anon_sym_public] = ACTIONS(1529),
    [anon_sym_private] = ACTIONS(1529),
    [anon_sym_protected] = ACTIONS(1529),
    [anon_sym_module] = ACTIONS(1529),
    [anon_sym_any] = ACTIONS(1529),
    [anon_sym_number] = ACTIONS(1529),
    [anon_sym_boolean] = ACTIONS(1529),
    [anon_sym_string] = ACTIONS(1529),
    [anon_sym_symbol] = ACTIONS(1529),
    [anon_sym_interface] = ACTIONS(1529),
    [anon_sym_extends] = ACTIONS(1529),
    [anon_sym_enum] = ACTIONS(1529),
    [sym_readonly] = ACTIONS(1529),
  },
  [425] = {
    [ts_builtin_sym_end] = ACTIONS(1531),
    [sym_identifier] = ACTIONS(1533),
    [anon_sym_export] = ACTIONS(1533),
    [anon_sym_default] = ACTIONS(1533),
    [anon_sym_EQ] = ACTIONS(1533),
    [anon_sym_namespace] = ACTIONS(1533),
    [anon_sym_LBRACE] = ACTIONS(1531),
    [anon_sym_COMMA] = ACTIONS(1531),
    [anon_sym_RBRACE] = ACTIONS(1531),
    [anon_sym_type] = ACTIONS(1533),
    [anon_sym_typeof] = ACTIONS(1533),
    [anon_sym_import] = ACTIONS(1533),
    [anon_sym_var] = ACTIONS(1533),
    [anon_sym_let] = ACTIONS(1533),
    [anon_sym_const] = ACTIONS(1533),
    [anon_sym_BANG] = ACTIONS(1531),
    [anon_sym_else] = ACTIONS(1533),
    [anon_sym_if] = ACTIONS(1533),
    [anon_sym_switch] = ACTIONS(1533),
    [anon_sym_for] = ACTIONS(1533),
    [anon_sym_LPAREN] = ACTIONS(1531),
    [anon_sym_RPAREN] = ACTIONS(1531),
    [anon_sym_await] = ACTIONS(1533),
    [anon_sym_while] = ACTIONS(1533),
    [anon_sym_do] = ACTIONS(1533),
    [anon_sym_try] = ACTIONS(1533),
    [anon_sym_with] = ACTIONS(1533),
    [anon_sym_break] = ACTIONS(1533),
    [anon_sym_continue] = ACTIONS(1533),
    [anon_sym_debugger] = ACTIONS(1533),
    [anon_sym_return] = ACTIONS(1533),
    [anon_sym_throw] = ACTIONS(1533),
    [anon_sym_SEMI] = ACTIONS(1531),
    [anon_sym_COLON] = ACTIONS(1531),
    [anon_sym_case] = ACTIONS(1533),
    [anon_sym_yield] = ACTIONS(1533),
    [anon_sym_LBRACK] = ACTIONS(1531),
    [anon_sym_RBRACK] = ACTIONS(1531),
    [anon_sym_LT] = ACTIONS(1531),
    [anon_sym_GT] = ACTIONS(1531),
    [anon_sym_SLASH] = ACTIONS(1533),
    [anon_sym_class] = ACTIONS(1533),
    [anon_sym_async] = ACTIONS(1533),
    [anon_sym_function] = ACTIONS(1533),
    [anon_sym_EQ_GT] = ACTIONS(1531),
    [anon_sym_new] = ACTIONS(1533),
    [anon_sym_QMARK] = ACTIONS(1531),
    [anon_sym_AMP] = ACTIONS(1531),
    [anon_sym_PIPE] = ACTIONS(1531),
    [anon_sym_PLUS] = ACTIONS(1533),
    [anon_sym_DASH] = ACTIONS(1533),
    [anon_sym_TILDE] = ACTIONS(1531),
    [anon_sym_void] = ACTIONS(1533),
    [anon_sym_delete] = ACTIONS(1533),
    [anon_sym_PLUS_PLUS] = ACTIONS(1531),
    [anon_sym_DASH_DASH] = ACTIONS(1531),
    [anon_sym_DQUOTE] = ACTIONS(1531),
    [anon_sym_SQUOTE] = ACTIONS(1531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1531),
    [sym_number] = ACTIONS(1531),
    [sym_this] = ACTIONS(1533),
    [sym_super] = ACTIONS(1533),
    [sym_true] = ACTIONS(1533),
    [sym_false] = ACTIONS(1533),
    [sym_null] = ACTIONS(1533),
    [sym_undefined] = ACTIONS(1533),
    [anon_sym_AT] = ACTIONS(1531),
    [anon_sym_static] = ACTIONS(1533),
    [anon_sym_abstract] = ACTIONS(1533),
    [anon_sym_get] = ACTIONS(1533),
    [anon_sym_set] = ACTIONS(1533),
    [anon_sym_declare] = ACTIONS(1533),
    [anon_sym_public] = ACTIONS(1533),
    [anon_sym_private] = ACTIONS(1533),
    [anon_sym_protected] = ACTIONS(1533),
    [anon_sym_module] = ACTIONS(1533),
    [anon_sym_any] = ACTIONS(1533),
    [anon_sym_number] = ACTIONS(1533),
    [anon_sym_boolean] = ACTIONS(1533),
    [anon_sym_string] = ACTIONS(1533),
    [anon_sym_symbol] = ACTIONS(1533),
    [anon_sym_interface] = ACTIONS(1533),
    [anon_sym_extends] = ACTIONS(1533),
    [anon_sym_enum] = ACTIONS(1533),
    [sym_readonly] = ACTIONS(1533),
  },
  [426] = {
    [ts_builtin_sym_end] = ACTIONS(1535),
    [sym_identifier] = ACTIONS(1537),
    [anon_sym_export] = ACTIONS(1537),
    [anon_sym_default] = ACTIONS(1537),
    [anon_sym_EQ] = ACTIONS(1537),
    [anon_sym_namespace] = ACTIONS(1537),
    [anon_sym_LBRACE] = ACTIONS(1535),
    [anon_sym_COMMA] = ACTIONS(1535),
    [anon_sym_RBRACE] = ACTIONS(1535),
    [anon_sym_type] = ACTIONS(1537),
    [anon_sym_typeof] = ACTIONS(1537),
    [anon_sym_import] = ACTIONS(1537),
    [anon_sym_var] = ACTIONS(1537),
    [anon_sym_let] = ACTIONS(1537),
    [anon_sym_const] = ACTIONS(1537),
    [anon_sym_BANG] = ACTIONS(1535),
    [anon_sym_else] = ACTIONS(1537),
    [anon_sym_if] = ACTIONS(1537),
    [anon_sym_switch] = ACTIONS(1537),
    [anon_sym_for] = ACTIONS(1537),
    [anon_sym_LPAREN] = ACTIONS(1535),
    [anon_sym_RPAREN] = ACTIONS(1535),
    [anon_sym_await] = ACTIONS(1537),
    [anon_sym_while] = ACTIONS(1537),
    [anon_sym_do] = ACTIONS(1537),
    [anon_sym_try] = ACTIONS(1537),
    [anon_sym_with] = ACTIONS(1537),
    [anon_sym_break] = ACTIONS(1537),
    [anon_sym_continue] = ACTIONS(1537),
    [anon_sym_debugger] = ACTIONS(1537),
    [anon_sym_return] = ACTIONS(1537),
    [anon_sym_throw] = ACTIONS(1537),
    [anon_sym_SEMI] = ACTIONS(1535),
    [anon_sym_COLON] = ACTIONS(1535),
    [anon_sym_case] = ACTIONS(1537),
    [anon_sym_yield] = ACTIONS(1537),
    [anon_sym_LBRACK] = ACTIONS(1535),
    [anon_sym_RBRACK] = ACTIONS(1535),
    [anon_sym_LT] = ACTIONS(1535),
    [anon_sym_GT] = ACTIONS(1535),
    [anon_sym_SLASH] = ACTIONS(1537),
    [anon_sym_class] = ACTIONS(1537),
    [anon_sym_async] = ACTIONS(1537),
    [anon_sym_function] = ACTIONS(1537),
    [anon_sym_EQ_GT] = ACTIONS(1535),
    [anon_sym_new] = ACTIONS(1537),
    [anon_sym_QMARK] = ACTIONS(1535),
    [anon_sym_AMP] = ACTIONS(1535),
    [anon_sym_PIPE] = ACTIONS(1535),
    [anon_sym_PLUS] = ACTIONS(1537),
    [anon_sym_DASH] = ACTIONS(1537),
    [anon_sym_TILDE] = ACTIONS(1535),
    [anon_sym_void] = ACTIONS(1537),
    [anon_sym_delete] = ACTIONS(1537),
    [anon_sym_PLUS_PLUS] = ACTIONS(1535),
    [anon_sym_DASH_DASH] = ACTIONS(1535),
    [anon_sym_DQUOTE] = ACTIONS(1535),
    [anon_sym_SQUOTE] = ACTIONS(1535),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1535),
    [sym_number] = ACTIONS(1535),
    [sym_this] = ACTIONS(1537),
    [sym_super] = ACTIONS(1537),
    [sym_true] = ACTIONS(1537),
    [sym_false] = ACTIONS(1537),
    [sym_null] = ACTIONS(1537),
    [sym_undefined] = ACTIONS(1537),
    [anon_sym_AT] = ACTIONS(1535),
    [anon_sym_static] = ACTIONS(1537),
    [anon_sym_abstract] = ACTIONS(1537),
    [anon_sym_get] = ACTIONS(1537),
    [anon_sym_set] = ACTIONS(1537),
    [anon_sym_declare] = ACTIONS(1537),
    [anon_sym_public] = ACTIONS(1537),
    [anon_sym_private] = ACTIONS(1537),
    [anon_sym_protected] = ACTIONS(1537),
    [anon_sym_module] = ACTIONS(1537),
    [anon_sym_any] = ACTIONS(1537),
    [anon_sym_number] = ACTIONS(1537),
    [anon_sym_boolean] = ACTIONS(1537),
    [anon_sym_string] = ACTIONS(1537),
    [anon_sym_symbol] = ACTIONS(1537),
    [anon_sym_interface] = ACTIONS(1537),
    [anon_sym_extends] = ACTIONS(1537),
    [anon_sym_enum] = ACTIONS(1537),
    [sym_readonly] = ACTIONS(1537),
  },
  [427] = {
    [ts_builtin_sym_end] = ACTIONS(1539),
    [sym_identifier] = ACTIONS(1541),
    [anon_sym_export] = ACTIONS(1541),
    [anon_sym_default] = ACTIONS(1541),
    [anon_sym_EQ] = ACTIONS(1541),
    [anon_sym_namespace] = ACTIONS(1541),
    [anon_sym_LBRACE] = ACTIONS(1539),
    [anon_sym_COMMA] = ACTIONS(1539),
    [anon_sym_RBRACE] = ACTIONS(1539),
    [anon_sym_type] = ACTIONS(1541),
    [anon_sym_typeof] = ACTIONS(1541),
    [anon_sym_import] = ACTIONS(1541),
    [anon_sym_var] = ACTIONS(1541),
    [anon_sym_let] = ACTIONS(1541),
    [anon_sym_const] = ACTIONS(1541),
    [anon_sym_BANG] = ACTIONS(1539),
    [anon_sym_else] = ACTIONS(1541),
    [anon_sym_if] = ACTIONS(1541),
    [anon_sym_switch] = ACTIONS(1541),
    [anon_sym_for] = ACTIONS(1541),
    [anon_sym_LPAREN] = ACTIONS(1539),
    [anon_sym_RPAREN] = ACTIONS(1539),
    [anon_sym_await] = ACTIONS(1541),
    [anon_sym_while] = ACTIONS(1541),
    [anon_sym_do] = ACTIONS(1541),
    [anon_sym_try] = ACTIONS(1541),
    [anon_sym_with] = ACTIONS(1541),
    [anon_sym_break] = ACTIONS(1541),
    [anon_sym_continue] = ACTIONS(1541),
    [anon_sym_debugger] = ACTIONS(1541),
    [anon_sym_return] = ACTIONS(1541),
    [anon_sym_throw] = ACTIONS(1541),
    [anon_sym_SEMI] = ACTIONS(1539),
    [anon_sym_COLON] = ACTIONS(1539),
    [anon_sym_case] = ACTIONS(1541),
    [anon_sym_yield] = ACTIONS(1541),
    [anon_sym_LBRACK] = ACTIONS(1539),
    [anon_sym_RBRACK] = ACTIONS(1539),
    [anon_sym_LT] = ACTIONS(1539),
    [anon_sym_GT] = ACTIONS(1539),
    [anon_sym_SLASH] = ACTIONS(1541),
    [anon_sym_class] = ACTIONS(1541),
    [anon_sym_async] = ACTIONS(1541),
    [anon_sym_function] = ACTIONS(1541),
    [anon_sym_EQ_GT] = ACTIONS(1539),
    [anon_sym_new] = ACTIONS(1541),
    [anon_sym_QMARK] = ACTIONS(1539),
    [anon_sym_AMP] = ACTIONS(1539),
    [anon_sym_PIPE] = ACTIONS(1539),
    [anon_sym_PLUS] = ACTIONS(1541),
    [anon_sym_DASH] = ACTIONS(1541),
    [anon_sym_TILDE] = ACTIONS(1539),
    [anon_sym_void] = ACTIONS(1541),
    [anon_sym_delete] = ACTIONS(1541),
    [anon_sym_PLUS_PLUS] = ACTIONS(1539),
    [anon_sym_DASH_DASH] = ACTIONS(1539),
    [anon_sym_DQUOTE] = ACTIONS(1539),
    [anon_sym_SQUOTE] = ACTIONS(1539),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1539),
    [sym_number] = ACTIONS(1539),
    [sym_this] = ACTIONS(1541),
    [sym_super] = ACTIONS(1541),
    [sym_true] = ACTIONS(1541),
    [sym_false] = ACTIONS(1541),
    [sym_null] = ACTIONS(1541),
    [sym_undefined] = ACTIONS(1541),
    [anon_sym_AT] = ACTIONS(1539),
    [anon_sym_static] = ACTIONS(1541),
    [anon_sym_abstract] = ACTIONS(1541),
    [anon_sym_get] = ACTIONS(1541),
    [anon_sym_set] = ACTIONS(1541),
    [anon_sym_declare] = ACTIONS(1541),
    [anon_sym_public] = ACTIONS(1541),
    [anon_sym_private] = ACTIONS(1541),
    [anon_sym_protected] = ACTIONS(1541),
    [anon_sym_module] = ACTIONS(1541),
    [anon_sym_any] = ACTIONS(1541),
    [anon_sym_number] = ACTIONS(1541),
    [anon_sym_boolean] = ACTIONS(1541),
    [anon_sym_string] = ACTIONS(1541),
    [anon_sym_symbol] = ACTIONS(1541),
    [anon_sym_interface] = ACTIONS(1541),
    [anon_sym_extends] = ACTIONS(1541),
    [anon_sym_enum] = ACTIONS(1541),
    [sym_readonly] = ACTIONS(1541),
  },
  [428] = {
    [ts_builtin_sym_end] = ACTIONS(1543),
    [sym_identifier] = ACTIONS(1545),
    [anon_sym_export] = ACTIONS(1545),
    [anon_sym_default] = ACTIONS(1545),
    [anon_sym_EQ] = ACTIONS(1545),
    [anon_sym_namespace] = ACTIONS(1545),
    [anon_sym_LBRACE] = ACTIONS(1543),
    [anon_sym_COMMA] = ACTIONS(1543),
    [anon_sym_RBRACE] = ACTIONS(1543),
    [anon_sym_type] = ACTIONS(1545),
    [anon_sym_typeof] = ACTIONS(1545),
    [anon_sym_import] = ACTIONS(1545),
    [anon_sym_var] = ACTIONS(1545),
    [anon_sym_let] = ACTIONS(1545),
    [anon_sym_const] = ACTIONS(1545),
    [anon_sym_BANG] = ACTIONS(1543),
    [anon_sym_else] = ACTIONS(1545),
    [anon_sym_if] = ACTIONS(1545),
    [anon_sym_switch] = ACTIONS(1545),
    [anon_sym_for] = ACTIONS(1545),
    [anon_sym_LPAREN] = ACTIONS(1543),
    [anon_sym_RPAREN] = ACTIONS(1543),
    [anon_sym_await] = ACTIONS(1545),
    [anon_sym_while] = ACTIONS(1545),
    [anon_sym_do] = ACTIONS(1545),
    [anon_sym_try] = ACTIONS(1545),
    [anon_sym_with] = ACTIONS(1545),
    [anon_sym_break] = ACTIONS(1545),
    [anon_sym_continue] = ACTIONS(1545),
    [anon_sym_debugger] = ACTIONS(1545),
    [anon_sym_return] = ACTIONS(1545),
    [anon_sym_throw] = ACTIONS(1545),
    [anon_sym_SEMI] = ACTIONS(1543),
    [anon_sym_COLON] = ACTIONS(1543),
    [anon_sym_case] = ACTIONS(1545),
    [anon_sym_yield] = ACTIONS(1545),
    [anon_sym_LBRACK] = ACTIONS(1543),
    [anon_sym_RBRACK] = ACTIONS(1543),
    [anon_sym_LT] = ACTIONS(1543),
    [anon_sym_GT] = ACTIONS(1543),
    [anon_sym_SLASH] = ACTIONS(1545),
    [anon_sym_class] = ACTIONS(1545),
    [anon_sym_async] = ACTIONS(1545),
    [anon_sym_function] = ACTIONS(1545),
    [anon_sym_EQ_GT] = ACTIONS(1543),
    [anon_sym_new] = ACTIONS(1545),
    [anon_sym_QMARK] = ACTIONS(1543),
    [anon_sym_AMP] = ACTIONS(1543),
    [anon_sym_PIPE] = ACTIONS(1543),
    [anon_sym_PLUS] = ACTIONS(1545),
    [anon_sym_DASH] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1543),
    [anon_sym_void] = ACTIONS(1545),
    [anon_sym_delete] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1543),
    [anon_sym_DASH_DASH] = ACTIONS(1543),
    [anon_sym_DQUOTE] = ACTIONS(1543),
    [anon_sym_SQUOTE] = ACTIONS(1543),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1543),
    [sym_number] = ACTIONS(1543),
    [sym_this] = ACTIONS(1545),
    [sym_super] = ACTIONS(1545),
    [sym_true] = ACTIONS(1545),
    [sym_false] = ACTIONS(1545),
    [sym_null] = ACTIONS(1545),
    [sym_undefined] = ACTIONS(1545),
    [anon_sym_AT] = ACTIONS(1543),
    [anon_sym_static] = ACTIONS(1545),
    [anon_sym_abstract] = ACTIONS(1545),
    [anon_sym_get] = ACTIONS(1545),
    [anon_sym_set] = ACTIONS(1545),
    [anon_sym_declare] = ACTIONS(1545),
    [anon_sym_public] = ACTIONS(1545),
    [anon_sym_private] = ACTIONS(1545),
    [anon_sym_protected] = ACTIONS(1545),
    [anon_sym_module] = ACTIONS(1545),
    [anon_sym_any] = ACTIONS(1545),
    [anon_sym_number] = ACTIONS(1545),
    [anon_sym_boolean] = ACTIONS(1545),
    [anon_sym_string] = ACTIONS(1545),
    [anon_sym_symbol] = ACTIONS(1545),
    [anon_sym_interface] = ACTIONS(1545),
    [anon_sym_extends] = ACTIONS(1545),
    [anon_sym_enum] = ACTIONS(1545),
    [sym_readonly] = ACTIONS(1545),
  },
  [429] = {
    [ts_builtin_sym_end] = ACTIONS(1547),
    [sym_identifier] = ACTIONS(1549),
    [anon_sym_export] = ACTIONS(1549),
    [anon_sym_default] = ACTIONS(1549),
    [anon_sym_EQ] = ACTIONS(1549),
    [anon_sym_namespace] = ACTIONS(1549),
    [anon_sym_LBRACE] = ACTIONS(1547),
    [anon_sym_COMMA] = ACTIONS(1547),
    [anon_sym_RBRACE] = ACTIONS(1547),
    [anon_sym_type] = ACTIONS(1549),
    [anon_sym_typeof] = ACTIONS(1549),
    [anon_sym_import] = ACTIONS(1549),
    [anon_sym_var] = ACTIONS(1549),
    [anon_sym_let] = ACTIONS(1549),
    [anon_sym_const] = ACTIONS(1549),
    [anon_sym_BANG] = ACTIONS(1547),
    [anon_sym_else] = ACTIONS(1549),
    [anon_sym_if] = ACTIONS(1549),
    [anon_sym_switch] = ACTIONS(1549),
    [anon_sym_for] = ACTIONS(1549),
    [anon_sym_LPAREN] = ACTIONS(1547),
    [anon_sym_RPAREN] = ACTIONS(1547),
    [anon_sym_await] = ACTIONS(1549),
    [anon_sym_while] = ACTIONS(1549),
    [anon_sym_do] = ACTIONS(1549),
    [anon_sym_try] = ACTIONS(1549),
    [anon_sym_with] = ACTIONS(1549),
    [anon_sym_break] = ACTIONS(1549),
    [anon_sym_continue] = ACTIONS(1549),
    [anon_sym_debugger] = ACTIONS(1549),
    [anon_sym_return] = ACTIONS(1549),
    [anon_sym_throw] = ACTIONS(1549),
    [anon_sym_SEMI] = ACTIONS(1547),
    [anon_sym_COLON] = ACTIONS(1547),
    [anon_sym_case] = ACTIONS(1549),
    [anon_sym_yield] = ACTIONS(1549),
    [anon_sym_LBRACK] = ACTIONS(1547),
    [anon_sym_RBRACK] = ACTIONS(1547),
    [anon_sym_LT] = ACTIONS(1547),
    [anon_sym_GT] = ACTIONS(1547),
    [anon_sym_SLASH] = ACTIONS(1549),
    [anon_sym_class] = ACTIONS(1549),
    [anon_sym_async] = ACTIONS(1549),
    [anon_sym_function] = ACTIONS(1549),
    [anon_sym_EQ_GT] = ACTIONS(1547),
    [anon_sym_new] = ACTIONS(1549),
    [anon_sym_QMARK] = ACTIONS(1547),
    [anon_sym_AMP] = ACTIONS(1547),
    [anon_sym_PIPE] = ACTIONS(1547),
    [anon_sym_PLUS] = ACTIONS(1549),
    [anon_sym_DASH] = ACTIONS(1549),
    [anon_sym_TILDE] = ACTIONS(1547),
    [anon_sym_void] = ACTIONS(1549),
    [anon_sym_delete] = ACTIONS(1549),
    [anon_sym_PLUS_PLUS] = ACTIONS(1547),
    [anon_sym_DASH_DASH] = ACTIONS(1547),
    [anon_sym_DQUOTE] = ACTIONS(1547),
    [anon_sym_SQUOTE] = ACTIONS(1547),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1547),
    [sym_number] = ACTIONS(1547),
    [sym_this] = ACTIONS(1549),
    [sym_super] = ACTIONS(1549),
    [sym_true] = ACTIONS(1549),
    [sym_false] = ACTIONS(1549),
    [sym_null] = ACTIONS(1549),
    [sym_undefined] = ACTIONS(1549),
    [anon_sym_AT] = ACTIONS(1547),
    [anon_sym_static] = ACTIONS(1549),
    [anon_sym_abstract] = ACTIONS(1549),
    [anon_sym_get] = ACTIONS(1549),
    [anon_sym_set] = ACTIONS(1549),
    [anon_sym_declare] = ACTIONS(1549),
    [anon_sym_public] = ACTIONS(1549),
    [anon_sym_private] = ACTIONS(1549),
    [anon_sym_protected] = ACTIONS(1549),
    [anon_sym_module] = ACTIONS(1549),
    [anon_sym_any] = ACTIONS(1549),
    [anon_sym_number] = ACTIONS(1549),
    [anon_sym_boolean] = ACTIONS(1549),
    [anon_sym_string] = ACTIONS(1549),
    [anon_sym_symbol] = ACTIONS(1549),
    [anon_sym_interface] = ACTIONS(1549),
    [anon_sym_extends] = ACTIONS(1549),
    [anon_sym_enum] = ACTIONS(1549),
    [sym_readonly] = ACTIONS(1549),
  },
  [430] = {
    [ts_builtin_sym_end] = ACTIONS(1551),
    [sym_identifier] = ACTIONS(1553),
    [anon_sym_export] = ACTIONS(1553),
    [anon_sym_default] = ACTIONS(1553),
    [anon_sym_EQ] = ACTIONS(1553),
    [anon_sym_namespace] = ACTIONS(1553),
    [anon_sym_LBRACE] = ACTIONS(1551),
    [anon_sym_COMMA] = ACTIONS(1551),
    [anon_sym_RBRACE] = ACTIONS(1551),
    [anon_sym_type] = ACTIONS(1553),
    [anon_sym_typeof] = ACTIONS(1553),
    [anon_sym_import] = ACTIONS(1553),
    [anon_sym_var] = ACTIONS(1553),
    [anon_sym_let] = ACTIONS(1553),
    [anon_sym_const] = ACTIONS(1553),
    [anon_sym_BANG] = ACTIONS(1551),
    [anon_sym_else] = ACTIONS(1553),
    [anon_sym_if] = ACTIONS(1553),
    [anon_sym_switch] = ACTIONS(1553),
    [anon_sym_for] = ACTIONS(1553),
    [anon_sym_LPAREN] = ACTIONS(1551),
    [anon_sym_RPAREN] = ACTIONS(1551),
    [anon_sym_await] = ACTIONS(1553),
    [anon_sym_while] = ACTIONS(1553),
    [anon_sym_do] = ACTIONS(1553),
    [anon_sym_try] = ACTIONS(1553),
    [anon_sym_with] = ACTIONS(1553),
    [anon_sym_break] = ACTIONS(1553),
    [anon_sym_continue] = ACTIONS(1553),
    [anon_sym_debugger] = ACTIONS(1553),
    [anon_sym_return] = ACTIONS(1553),
    [anon_sym_throw] = ACTIONS(1553),
    [anon_sym_SEMI] = ACTIONS(1551),
    [anon_sym_COLON] = ACTIONS(1551),
    [anon_sym_case] = ACTIONS(1553),
    [anon_sym_yield] = ACTIONS(1553),
    [anon_sym_LBRACK] = ACTIONS(1551),
    [anon_sym_RBRACK] = ACTIONS(1551),
    [anon_sym_LT] = ACTIONS(1551),
    [anon_sym_GT] = ACTIONS(1551),
    [anon_sym_SLASH] = ACTIONS(1553),
    [anon_sym_class] = ACTIONS(1553),
    [anon_sym_async] = ACTIONS(1553),
    [anon_sym_function] = ACTIONS(1553),
    [anon_sym_EQ_GT] = ACTIONS(1551),
    [anon_sym_new] = ACTIONS(1553),
    [anon_sym_QMARK] = ACTIONS(1551),
    [anon_sym_AMP] = ACTIONS(1551),
    [anon_sym_PIPE] = ACTIONS(1551),
    [anon_sym_PLUS] = ACTIONS(1553),
    [anon_sym_DASH] = ACTIONS(1553),
    [anon_sym_TILDE] = ACTIONS(1551),
    [anon_sym_void] = ACTIONS(1553),
    [anon_sym_delete] = ACTIONS(1553),
    [anon_sym_PLUS_PLUS] = ACTIONS(1551),
    [anon_sym_DASH_DASH] = ACTIONS(1551),
    [anon_sym_DQUOTE] = ACTIONS(1551),
    [anon_sym_SQUOTE] = ACTIONS(1551),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1551),
    [sym_number] = ACTIONS(1551),
    [sym_this] = ACTIONS(1553),
    [sym_super] = ACTIONS(1553),
    [sym_true] = ACTIONS(1553),
    [sym_false] = ACTIONS(1553),
    [sym_null] = ACTIONS(1553),
    [sym_undefined] = ACTIONS(1553),
    [anon_sym_AT] = ACTIONS(1551),
    [anon_sym_static] = ACTIONS(1553),
    [anon_sym_abstract] = ACTIONS(1553),
    [anon_sym_get] = ACTIONS(1553),
    [anon_sym_set] = ACTIONS(1553),
    [anon_sym_declare] = ACTIONS(1553),
    [anon_sym_public] = ACTIONS(1553),
    [anon_sym_private] = ACTIONS(1553),
    [anon_sym_protected] = ACTIONS(1553),
    [anon_sym_module] = ACTIONS(1553),
    [anon_sym_any] = ACTIONS(1553),
    [anon_sym_number] = ACTIONS(1553),
    [anon_sym_boolean] = ACTIONS(1553),
    [anon_sym_string] = ACTIONS(1553),
    [anon_sym_symbol] = ACTIONS(1553),
    [anon_sym_interface] = ACTIONS(1553),
    [anon_sym_extends] = ACTIONS(1553),
    [anon_sym_enum] = ACTIONS(1553),
    [sym_readonly] = ACTIONS(1553),
  },
  [431] = {
    [ts_builtin_sym_end] = ACTIONS(1555),
    [sym_identifier] = ACTIONS(1557),
    [anon_sym_export] = ACTIONS(1557),
    [anon_sym_default] = ACTIONS(1557),
    [anon_sym_EQ] = ACTIONS(1557),
    [anon_sym_namespace] = ACTIONS(1557),
    [anon_sym_LBRACE] = ACTIONS(1555),
    [anon_sym_COMMA] = ACTIONS(1555),
    [anon_sym_RBRACE] = ACTIONS(1555),
    [anon_sym_type] = ACTIONS(1557),
    [anon_sym_typeof] = ACTIONS(1557),
    [anon_sym_import] = ACTIONS(1557),
    [anon_sym_var] = ACTIONS(1557),
    [anon_sym_let] = ACTIONS(1557),
    [anon_sym_const] = ACTIONS(1557),
    [anon_sym_BANG] = ACTIONS(1555),
    [anon_sym_else] = ACTIONS(1557),
    [anon_sym_if] = ACTIONS(1557),
    [anon_sym_switch] = ACTIONS(1557),
    [anon_sym_for] = ACTIONS(1557),
    [anon_sym_LPAREN] = ACTIONS(1555),
    [anon_sym_RPAREN] = ACTIONS(1555),
    [anon_sym_await] = ACTIONS(1557),
    [anon_sym_while] = ACTIONS(1557),
    [anon_sym_do] = ACTIONS(1557),
    [anon_sym_try] = ACTIONS(1557),
    [anon_sym_with] = ACTIONS(1557),
    [anon_sym_break] = ACTIONS(1557),
    [anon_sym_continue] = ACTIONS(1557),
    [anon_sym_debugger] = ACTIONS(1557),
    [anon_sym_return] = ACTIONS(1557),
    [anon_sym_throw] = ACTIONS(1557),
    [anon_sym_SEMI] = ACTIONS(1555),
    [anon_sym_COLON] = ACTIONS(1555),
    [anon_sym_case] = ACTIONS(1557),
    [anon_sym_yield] = ACTIONS(1557),
    [anon_sym_LBRACK] = ACTIONS(1525),
    [anon_sym_RBRACK] = ACTIONS(1555),
    [anon_sym_LT] = ACTIONS(1555),
    [anon_sym_GT] = ACTIONS(1555),
    [anon_sym_SLASH] = ACTIONS(1557),
    [anon_sym_class] = ACTIONS(1557),
    [anon_sym_async] = ACTIONS(1557),
    [anon_sym_function] = ACTIONS(1557),
    [anon_sym_EQ_GT] = ACTIONS(1555),
    [anon_sym_new] = ACTIONS(1557),
    [anon_sym_QMARK] = ACTIONS(1555),
    [anon_sym_AMP] = ACTIONS(1555),
    [anon_sym_PIPE] = ACTIONS(1555),
    [anon_sym_PLUS] = ACTIONS(1557),
    [anon_sym_DASH] = ACTIONS(1557),
    [anon_sym_TILDE] = ACTIONS(1555),
    [anon_sym_void] = ACTIONS(1557),
    [anon_sym_delete] = ACTIONS(1557),
    [anon_sym_PLUS_PLUS] = ACTIONS(1555),
    [anon_sym_DASH_DASH] = ACTIONS(1555),
    [anon_sym_DQUOTE] = ACTIONS(1555),
    [anon_sym_SQUOTE] = ACTIONS(1555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1555),
    [sym_number] = ACTIONS(1555),
    [sym_this] = ACTIONS(1557),
    [sym_super] = ACTIONS(1557),
    [sym_true] = ACTIONS(1557),
    [sym_false] = ACTIONS(1557),
    [sym_null] = ACTIONS(1557),
    [sym_undefined] = ACTIONS(1557),
    [anon_sym_AT] = ACTIONS(1555),
    [anon_sym_static] = ACTIONS(1557),
    [anon_sym_abstract] = ACTIONS(1557),
    [anon_sym_get] = ACTIONS(1557),
    [anon_sym_set] = ACTIONS(1557),
    [anon_sym_declare] = ACTIONS(1557),
    [anon_sym_public] = ACTIONS(1557),
    [anon_sym_private] = ACTIONS(1557),
    [anon_sym_protected] = ACTIONS(1557),
    [anon_sym_module] = ACTIONS(1557),
    [anon_sym_any] = ACTIONS(1557),
    [anon_sym_number] = ACTIONS(1557),
    [anon_sym_boolean] = ACTIONS(1557),
    [anon_sym_string] = ACTIONS(1557),
    [anon_sym_symbol] = ACTIONS(1557),
    [anon_sym_interface] = ACTIONS(1557),
    [anon_sym_extends] = ACTIONS(1557),
    [anon_sym_enum] = ACTIONS(1557),
    [sym_readonly] = ACTIONS(1557),
  },
  [432] = {
    [ts_builtin_sym_end] = ACTIONS(1079),
    [sym_identifier] = ACTIONS(1081),
    [anon_sym_export] = ACTIONS(1081),
    [anon_sym_default] = ACTIONS(1081),
    [anon_sym_EQ] = ACTIONS(1081),
    [anon_sym_namespace] = ACTIONS(1081),
    [anon_sym_LBRACE] = ACTIONS(1079),
    [anon_sym_COMMA] = ACTIONS(1079),
    [anon_sym_RBRACE] = ACTIONS(1079),
    [anon_sym_type] = ACTIONS(1081),
    [anon_sym_typeof] = ACTIONS(1081),
    [anon_sym_import] = ACTIONS(1081),
    [anon_sym_var] = ACTIONS(1081),
    [anon_sym_let] = ACTIONS(1081),
    [anon_sym_const] = ACTIONS(1081),
    [anon_sym_BANG] = ACTIONS(1079),
    [anon_sym_else] = ACTIONS(1081),
    [anon_sym_if] = ACTIONS(1081),
    [anon_sym_switch] = ACTIONS(1081),
    [anon_sym_for] = ACTIONS(1081),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_RPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(1081),
    [anon_sym_while] = ACTIONS(1081),
    [anon_sym_do] = ACTIONS(1081),
    [anon_sym_try] = ACTIONS(1081),
    [anon_sym_with] = ACTIONS(1081),
    [anon_sym_break] = ACTIONS(1081),
    [anon_sym_continue] = ACTIONS(1081),
    [anon_sym_debugger] = ACTIONS(1081),
    [anon_sym_return] = ACTIONS(1081),
    [anon_sym_throw] = ACTIONS(1081),
    [anon_sym_SEMI] = ACTIONS(1079),
    [anon_sym_COLON] = ACTIONS(1079),
    [anon_sym_case] = ACTIONS(1081),
    [anon_sym_yield] = ACTIONS(1081),
    [anon_sym_LBRACK] = ACTIONS(1079),
    [anon_sym_RBRACK] = ACTIONS(1079),
    [anon_sym_LT] = ACTIONS(1079),
    [anon_sym_GT] = ACTIONS(1079),
    [anon_sym_SLASH] = ACTIONS(1081),
    [anon_sym_class] = ACTIONS(1081),
    [anon_sym_async] = ACTIONS(1081),
    [anon_sym_function] = ACTIONS(1081),
    [anon_sym_EQ_GT] = ACTIONS(1079),
    [anon_sym_new] = ACTIONS(1081),
    [anon_sym_QMARK] = ACTIONS(1079),
    [anon_sym_AMP] = ACTIONS(1079),
    [anon_sym_PIPE] = ACTIONS(1079),
    [anon_sym_PLUS] = ACTIONS(1081),
    [anon_sym_DASH] = ACTIONS(1081),
    [anon_sym_TILDE] = ACTIONS(1079),
    [anon_sym_void] = ACTIONS(1081),
    [anon_sym_delete] = ACTIONS(1081),
    [anon_sym_PLUS_PLUS] = ACTIONS(1079),
    [anon_sym_DASH_DASH] = ACTIONS(1079),
    [anon_sym_DQUOTE] = ACTIONS(1079),
    [anon_sym_SQUOTE] = ACTIONS(1079),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1079),
    [sym_number] = ACTIONS(1079),
    [sym_this] = ACTIONS(1081),
    [sym_super] = ACTIONS(1081),
    [sym_true] = ACTIONS(1081),
    [sym_false] = ACTIONS(1081),
    [sym_null] = ACTIONS(1081),
    [sym_undefined] = ACTIONS(1081),
    [anon_sym_AT] = ACTIONS(1079),
    [anon_sym_static] = ACTIONS(1081),
    [anon_sym_abstract] = ACTIONS(1081),
    [anon_sym_get] = ACTIONS(1081),
    [anon_sym_set] = ACTIONS(1081),
    [anon_sym_declare] = ACTIONS(1081),
    [anon_sym_public] = ACTIONS(1081),
    [anon_sym_private] = ACTIONS(1081),
    [anon_sym_protected] = ACTIONS(1081),
    [anon_sym_module] = ACTIONS(1081),
    [anon_sym_any] = ACTIONS(1081),
    [anon_sym_number] = ACTIONS(1081),
    [anon_sym_boolean] = ACTIONS(1081),
    [anon_sym_string] = ACTIONS(1081),
    [anon_sym_symbol] = ACTIONS(1081),
    [anon_sym_interface] = ACTIONS(1081),
    [anon_sym_extends] = ACTIONS(1081),
    [anon_sym_enum] = ACTIONS(1081),
    [sym_readonly] = ACTIONS(1081),
  },
  [433] = {
    [ts_builtin_sym_end] = ACTIONS(1559),
    [sym_identifier] = ACTIONS(1561),
    [anon_sym_export] = ACTIONS(1561),
    [anon_sym_default] = ACTIONS(1561),
    [anon_sym_EQ] = ACTIONS(1561),
    [anon_sym_namespace] = ACTIONS(1561),
    [anon_sym_LBRACE] = ACTIONS(1559),
    [anon_sym_COMMA] = ACTIONS(1559),
    [anon_sym_RBRACE] = ACTIONS(1559),
    [anon_sym_type] = ACTIONS(1561),
    [anon_sym_typeof] = ACTIONS(1561),
    [anon_sym_import] = ACTIONS(1561),
    [anon_sym_var] = ACTIONS(1561),
    [anon_sym_let] = ACTIONS(1561),
    [anon_sym_const] = ACTIONS(1561),
    [anon_sym_BANG] = ACTIONS(1559),
    [anon_sym_else] = ACTIONS(1561),
    [anon_sym_if] = ACTIONS(1561),
    [anon_sym_switch] = ACTIONS(1561),
    [anon_sym_for] = ACTIONS(1561),
    [anon_sym_LPAREN] = ACTIONS(1559),
    [anon_sym_RPAREN] = ACTIONS(1559),
    [anon_sym_await] = ACTIONS(1561),
    [anon_sym_while] = ACTIONS(1561),
    [anon_sym_do] = ACTIONS(1561),
    [anon_sym_try] = ACTIONS(1561),
    [anon_sym_with] = ACTIONS(1561),
    [anon_sym_break] = ACTIONS(1561),
    [anon_sym_continue] = ACTIONS(1561),
    [anon_sym_debugger] = ACTIONS(1561),
    [anon_sym_return] = ACTIONS(1561),
    [anon_sym_throw] = ACTIONS(1561),
    [anon_sym_SEMI] = ACTIONS(1559),
    [anon_sym_COLON] = ACTIONS(1559),
    [anon_sym_case] = ACTIONS(1561),
    [anon_sym_yield] = ACTIONS(1561),
    [anon_sym_LBRACK] = ACTIONS(1559),
    [anon_sym_RBRACK] = ACTIONS(1559),
    [anon_sym_LT] = ACTIONS(1559),
    [anon_sym_GT] = ACTIONS(1559),
    [anon_sym_SLASH] = ACTIONS(1561),
    [anon_sym_class] = ACTIONS(1561),
    [anon_sym_async] = ACTIONS(1561),
    [anon_sym_function] = ACTIONS(1561),
    [anon_sym_EQ_GT] = ACTIONS(1559),
    [anon_sym_new] = ACTIONS(1561),
    [anon_sym_QMARK] = ACTIONS(1559),
    [anon_sym_AMP] = ACTIONS(1559),
    [anon_sym_PIPE] = ACTIONS(1559),
    [anon_sym_PLUS] = ACTIONS(1561),
    [anon_sym_DASH] = ACTIONS(1561),
    [anon_sym_TILDE] = ACTIONS(1559),
    [anon_sym_void] = ACTIONS(1561),
    [anon_sym_delete] = ACTIONS(1561),
    [anon_sym_PLUS_PLUS] = ACTIONS(1559),
    [anon_sym_DASH_DASH] = ACTIONS(1559),
    [anon_sym_DQUOTE] = ACTIONS(1559),
    [anon_sym_SQUOTE] = ACTIONS(1559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1559),
    [sym_number] = ACTIONS(1559),
    [sym_this] = ACTIONS(1561),
    [sym_super] = ACTIONS(1561),
    [sym_true] = ACTIONS(1561),
    [sym_false] = ACTIONS(1561),
    [sym_null] = ACTIONS(1561),
    [sym_undefined] = ACTIONS(1561),
    [anon_sym_AT] = ACTIONS(1559),
    [anon_sym_static] = ACTIONS(1561),
    [anon_sym_abstract] = ACTIONS(1561),
    [anon_sym_get] = ACTIONS(1561),
    [anon_sym_set] = ACTIONS(1561),
    [anon_sym_declare] = ACTIONS(1561),
    [anon_sym_public] = ACTIONS(1561),
    [anon_sym_private] = ACTIONS(1561),
    [anon_sym_protected] = ACTIONS(1561),
    [anon_sym_module] = ACTIONS(1561),
    [anon_sym_any] = ACTIONS(1561),
    [anon_sym_number] = ACTIONS(1561),
    [anon_sym_boolean] = ACTIONS(1561),
    [anon_sym_string] = ACTIONS(1561),
    [anon_sym_symbol] = ACTIONS(1561),
    [anon_sym_interface] = ACTIONS(1561),
    [anon_sym_extends] = ACTIONS(1561),
    [anon_sym_enum] = ACTIONS(1561),
    [sym_readonly] = ACTIONS(1561),
  },
  [434] = {
    [ts_builtin_sym_end] = ACTIONS(1189),
    [sym_identifier] = ACTIONS(1191),
    [anon_sym_export] = ACTIONS(1191),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_EQ] = ACTIONS(1191),
    [anon_sym_namespace] = ACTIONS(1191),
    [anon_sym_LBRACE] = ACTIONS(1189),
    [anon_sym_COMMA] = ACTIONS(1189),
    [anon_sym_RBRACE] = ACTIONS(1189),
    [anon_sym_type] = ACTIONS(1191),
    [anon_sym_typeof] = ACTIONS(1191),
    [anon_sym_import] = ACTIONS(1191),
    [anon_sym_var] = ACTIONS(1191),
    [anon_sym_let] = ACTIONS(1191),
    [anon_sym_const] = ACTIONS(1191),
    [anon_sym_BANG] = ACTIONS(1189),
    [anon_sym_else] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1191),
    [anon_sym_switch] = ACTIONS(1191),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_LPAREN] = ACTIONS(1189),
    [anon_sym_RPAREN] = ACTIONS(1189),
    [anon_sym_await] = ACTIONS(1191),
    [anon_sym_while] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(1191),
    [anon_sym_try] = ACTIONS(1191),
    [anon_sym_with] = ACTIONS(1191),
    [anon_sym_break] = ACTIONS(1191),
    [anon_sym_continue] = ACTIONS(1191),
    [anon_sym_debugger] = ACTIONS(1191),
    [anon_sym_return] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1191),
    [anon_sym_SEMI] = ACTIONS(1189),
    [anon_sym_COLON] = ACTIONS(1189),
    [anon_sym_case] = ACTIONS(1191),
    [anon_sym_yield] = ACTIONS(1191),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_RBRACK] = ACTIONS(1189),
    [anon_sym_LT] = ACTIONS(1189),
    [anon_sym_GT] = ACTIONS(1189),
    [anon_sym_SLASH] = ACTIONS(1191),
    [anon_sym_class] = ACTIONS(1191),
    [anon_sym_async] = ACTIONS(1191),
    [anon_sym_function] = ACTIONS(1191),
    [anon_sym_EQ_GT] = ACTIONS(1189),
    [anon_sym_new] = ACTIONS(1191),
    [anon_sym_QMARK] = ACTIONS(1189),
    [anon_sym_AMP] = ACTIONS(1189),
    [anon_sym_PIPE] = ACTIONS(1189),
    [anon_sym_PLUS] = ACTIONS(1191),
    [anon_sym_DASH] = ACTIONS(1191),
    [anon_sym_TILDE] = ACTIONS(1189),
    [anon_sym_void] = ACTIONS(1191),
    [anon_sym_delete] = ACTIONS(1191),
    [anon_sym_PLUS_PLUS] = ACTIONS(1189),
    [anon_sym_DASH_DASH] = ACTIONS(1189),
    [anon_sym_DQUOTE] = ACTIONS(1189),
    [anon_sym_SQUOTE] = ACTIONS(1189),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1189),
    [sym_number] = ACTIONS(1189),
    [sym_this] = ACTIONS(1191),
    [sym_super] = ACTIONS(1191),
    [sym_true] = ACTIONS(1191),
    [sym_false] = ACTIONS(1191),
    [sym_null] = ACTIONS(1191),
    [sym_undefined] = ACTIONS(1191),
    [anon_sym_AT] = ACTIONS(1189),
    [anon_sym_static] = ACTIONS(1191),
    [anon_sym_abstract] = ACTIONS(1191),
    [anon_sym_get] = ACTIONS(1191),
    [anon_sym_set] = ACTIONS(1191),
    [anon_sym_declare] = ACTIONS(1191),
    [anon_sym_public] = ACTIONS(1191),
    [anon_sym_private] = ACTIONS(1191),
    [anon_sym_protected] = ACTIONS(1191),
    [anon_sym_module] = ACTIONS(1191),
    [anon_sym_any] = ACTIONS(1191),
    [anon_sym_number] = ACTIONS(1191),
    [anon_sym_boolean] = ACTIONS(1191),
    [anon_sym_string] = ACTIONS(1191),
    [anon_sym_symbol] = ACTIONS(1191),
    [anon_sym_interface] = ACTIONS(1191),
    [anon_sym_extends] = ACTIONS(1191),
    [anon_sym_enum] = ACTIONS(1191),
    [sym_readonly] = ACTIONS(1191),
  },
  [435] = {
    [ts_builtin_sym_end] = ACTIONS(1563),
    [sym_identifier] = ACTIONS(1565),
    [anon_sym_export] = ACTIONS(1565),
    [anon_sym_default] = ACTIONS(1565),
    [anon_sym_EQ] = ACTIONS(1565),
    [anon_sym_namespace] = ACTIONS(1565),
    [anon_sym_LBRACE] = ACTIONS(1563),
    [anon_sym_COMMA] = ACTIONS(1563),
    [anon_sym_RBRACE] = ACTIONS(1563),
    [anon_sym_type] = ACTIONS(1565),
    [anon_sym_typeof] = ACTIONS(1565),
    [anon_sym_import] = ACTIONS(1565),
    [anon_sym_var] = ACTIONS(1565),
    [anon_sym_let] = ACTIONS(1565),
    [anon_sym_const] = ACTIONS(1565),
    [anon_sym_BANG] = ACTIONS(1563),
    [anon_sym_else] = ACTIONS(1565),
    [anon_sym_if] = ACTIONS(1565),
    [anon_sym_switch] = ACTIONS(1565),
    [anon_sym_for] = ACTIONS(1565),
    [anon_sym_LPAREN] = ACTIONS(1563),
    [anon_sym_RPAREN] = ACTIONS(1563),
    [anon_sym_await] = ACTIONS(1565),
    [anon_sym_while] = ACTIONS(1565),
    [anon_sym_do] = ACTIONS(1565),
    [anon_sym_try] = ACTIONS(1565),
    [anon_sym_with] = ACTIONS(1565),
    [anon_sym_break] = ACTIONS(1565),
    [anon_sym_continue] = ACTIONS(1565),
    [anon_sym_debugger] = ACTIONS(1565),
    [anon_sym_return] = ACTIONS(1565),
    [anon_sym_throw] = ACTIONS(1565),
    [anon_sym_SEMI] = ACTIONS(1563),
    [anon_sym_COLON] = ACTIONS(1563),
    [anon_sym_case] = ACTIONS(1565),
    [anon_sym_yield] = ACTIONS(1565),
    [anon_sym_LBRACK] = ACTIONS(1563),
    [anon_sym_RBRACK] = ACTIONS(1563),
    [anon_sym_LT] = ACTIONS(1563),
    [anon_sym_GT] = ACTIONS(1563),
    [anon_sym_SLASH] = ACTIONS(1565),
    [anon_sym_class] = ACTIONS(1565),
    [anon_sym_async] = ACTIONS(1565),
    [anon_sym_function] = ACTIONS(1565),
    [anon_sym_EQ_GT] = ACTIONS(1563),
    [anon_sym_new] = ACTIONS(1565),
    [anon_sym_QMARK] = ACTIONS(1563),
    [anon_sym_AMP] = ACTIONS(1563),
    [anon_sym_PIPE] = ACTIONS(1563),
    [anon_sym_PLUS] = ACTIONS(1565),
    [anon_sym_DASH] = ACTIONS(1565),
    [anon_sym_TILDE] = ACTIONS(1563),
    [anon_sym_void] = ACTIONS(1565),
    [anon_sym_delete] = ACTIONS(1565),
    [anon_sym_PLUS_PLUS] = ACTIONS(1563),
    [anon_sym_DASH_DASH] = ACTIONS(1563),
    [anon_sym_DQUOTE] = ACTIONS(1563),
    [anon_sym_SQUOTE] = ACTIONS(1563),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1563),
    [sym_number] = ACTIONS(1563),
    [sym_this] = ACTIONS(1565),
    [sym_super] = ACTIONS(1565),
    [sym_true] = ACTIONS(1565),
    [sym_false] = ACTIONS(1565),
    [sym_null] = ACTIONS(1565),
    [sym_undefined] = ACTIONS(1565),
    [anon_sym_AT] = ACTIONS(1563),
    [anon_sym_static] = ACTIONS(1565),
    [anon_sym_abstract] = ACTIONS(1565),
    [anon_sym_get] = ACTIONS(1565),
    [anon_sym_set] = ACTIONS(1565),
    [anon_sym_declare] = ACTIONS(1565),
    [anon_sym_public] = ACTIONS(1565),
    [anon_sym_private] = ACTIONS(1565),
    [anon_sym_protected] = ACTIONS(1565),
    [anon_sym_module] = ACTIONS(1565),
    [anon_sym_any] = ACTIONS(1565),
    [anon_sym_number] = ACTIONS(1565),
    [anon_sym_boolean] = ACTIONS(1565),
    [anon_sym_string] = ACTIONS(1565),
    [anon_sym_symbol] = ACTIONS(1565),
    [anon_sym_interface] = ACTIONS(1565),
    [anon_sym_extends] = ACTIONS(1565),
    [anon_sym_enum] = ACTIONS(1565),
    [sym_readonly] = ACTIONS(1565),
  },
  [436] = {
    [ts_builtin_sym_end] = ACTIONS(1087),
    [sym_identifier] = ACTIONS(1089),
    [anon_sym_export] = ACTIONS(1089),
    [anon_sym_default] = ACTIONS(1089),
    [anon_sym_EQ] = ACTIONS(1089),
    [anon_sym_namespace] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1087),
    [anon_sym_COMMA] = ACTIONS(1087),
    [anon_sym_RBRACE] = ACTIONS(1087),
    [anon_sym_type] = ACTIONS(1089),
    [anon_sym_typeof] = ACTIONS(1089),
    [anon_sym_import] = ACTIONS(1089),
    [anon_sym_var] = ACTIONS(1089),
    [anon_sym_let] = ACTIONS(1089),
    [anon_sym_const] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1087),
    [anon_sym_else] = ACTIONS(1089),
    [anon_sym_if] = ACTIONS(1089),
    [anon_sym_switch] = ACTIONS(1089),
    [anon_sym_for] = ACTIONS(1089),
    [anon_sym_LPAREN] = ACTIONS(1087),
    [anon_sym_RPAREN] = ACTIONS(1087),
    [anon_sym_await] = ACTIONS(1089),
    [anon_sym_while] = ACTIONS(1089),
    [anon_sym_do] = ACTIONS(1089),
    [anon_sym_try] = ACTIONS(1089),
    [anon_sym_with] = ACTIONS(1089),
    [anon_sym_break] = ACTIONS(1089),
    [anon_sym_continue] = ACTIONS(1089),
    [anon_sym_debugger] = ACTIONS(1089),
    [anon_sym_return] = ACTIONS(1089),
    [anon_sym_throw] = ACTIONS(1089),
    [anon_sym_SEMI] = ACTIONS(1087),
    [anon_sym_COLON] = ACTIONS(1087),
    [anon_sym_case] = ACTIONS(1089),
    [anon_sym_yield] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1087),
    [anon_sym_RBRACK] = ACTIONS(1087),
    [anon_sym_LT] = ACTIONS(1087),
    [anon_sym_GT] = ACTIONS(1087),
    [anon_sym_SLASH] = ACTIONS(1089),
    [anon_sym_class] = ACTIONS(1089),
    [anon_sym_async] = ACTIONS(1089),
    [anon_sym_function] = ACTIONS(1089),
    [anon_sym_EQ_GT] = ACTIONS(1087),
    [anon_sym_new] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1087),
    [anon_sym_AMP] = ACTIONS(1087),
    [anon_sym_PIPE] = ACTIONS(1087),
    [anon_sym_PLUS] = ACTIONS(1089),
    [anon_sym_DASH] = ACTIONS(1089),
    [anon_sym_TILDE] = ACTIONS(1087),
    [anon_sym_void] = ACTIONS(1089),
    [anon_sym_delete] = ACTIONS(1089),
    [anon_sym_PLUS_PLUS] = ACTIONS(1087),
    [anon_sym_DASH_DASH] = ACTIONS(1087),
    [anon_sym_DQUOTE] = ACTIONS(1087),
    [anon_sym_SQUOTE] = ACTIONS(1087),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1087),
    [sym_number] = ACTIONS(1087),
    [sym_this] = ACTIONS(1089),
    [sym_super] = ACTIONS(1089),
    [sym_true] = ACTIONS(1089),
    [sym_false] = ACTIONS(1089),
    [sym_null] = ACTIONS(1089),
    [sym_undefined] = ACTIONS(1089),
    [anon_sym_AT] = ACTIONS(1087),
    [anon_sym_static] = ACTIONS(1089),
    [anon_sym_abstract] = ACTIONS(1089),
    [anon_sym_get] = ACTIONS(1089),
    [anon_sym_set] = ACTIONS(1089),
    [anon_sym_declare] = ACTIONS(1089),
    [anon_sym_public] = ACTIONS(1089),
    [anon_sym_private] = ACTIONS(1089),
    [anon_sym_protected] = ACTIONS(1089),
    [anon_sym_module] = ACTIONS(1089),
    [anon_sym_any] = ACTIONS(1089),
    [anon_sym_number] = ACTIONS(1089),
    [anon_sym_boolean] = ACTIONS(1089),
    [anon_sym_string] = ACTIONS(1089),
    [anon_sym_symbol] = ACTIONS(1089),
    [anon_sym_interface] = ACTIONS(1089),
    [anon_sym_extends] = ACTIONS(1089),
    [anon_sym_enum] = ACTIONS(1089),
    [sym_readonly] = ACTIONS(1089),
  },
  [437] = {
    [ts_builtin_sym_end] = ACTIONS(1567),
    [sym_identifier] = ACTIONS(1569),
    [anon_sym_export] = ACTIONS(1569),
    [anon_sym_default] = ACTIONS(1569),
    [anon_sym_EQ] = ACTIONS(1569),
    [anon_sym_namespace] = ACTIONS(1569),
    [anon_sym_LBRACE] = ACTIONS(1567),
    [anon_sym_COMMA] = ACTIONS(1567),
    [anon_sym_RBRACE] = ACTIONS(1567),
    [anon_sym_type] = ACTIONS(1569),
    [anon_sym_typeof] = ACTIONS(1569),
    [anon_sym_import] = ACTIONS(1569),
    [anon_sym_var] = ACTIONS(1569),
    [anon_sym_let] = ACTIONS(1569),
    [anon_sym_const] = ACTIONS(1569),
    [anon_sym_BANG] = ACTIONS(1567),
    [anon_sym_else] = ACTIONS(1569),
    [anon_sym_if] = ACTIONS(1569),
    [anon_sym_switch] = ACTIONS(1569),
    [anon_sym_for] = ACTIONS(1569),
    [anon_sym_LPAREN] = ACTIONS(1567),
    [anon_sym_RPAREN] = ACTIONS(1567),
    [anon_sym_await] = ACTIONS(1569),
    [anon_sym_while] = ACTIONS(1569),
    [anon_sym_do] = ACTIONS(1569),
    [anon_sym_try] = ACTIONS(1569),
    [anon_sym_with] = ACTIONS(1569),
    [anon_sym_break] = ACTIONS(1569),
    [anon_sym_continue] = ACTIONS(1569),
    [anon_sym_debugger] = ACTIONS(1569),
    [anon_sym_return] = ACTIONS(1569),
    [anon_sym_throw] = ACTIONS(1569),
    [anon_sym_SEMI] = ACTIONS(1567),
    [anon_sym_COLON] = ACTIONS(1567),
    [anon_sym_case] = ACTIONS(1569),
    [anon_sym_yield] = ACTIONS(1569),
    [anon_sym_LBRACK] = ACTIONS(1567),
    [anon_sym_RBRACK] = ACTIONS(1567),
    [anon_sym_LT] = ACTIONS(1567),
    [anon_sym_GT] = ACTIONS(1567),
    [anon_sym_SLASH] = ACTIONS(1569),
    [anon_sym_class] = ACTIONS(1569),
    [anon_sym_async] = ACTIONS(1569),
    [anon_sym_function] = ACTIONS(1569),
    [anon_sym_EQ_GT] = ACTIONS(1567),
    [anon_sym_new] = ACTIONS(1569),
    [anon_sym_QMARK] = ACTIONS(1567),
    [anon_sym_AMP] = ACTIONS(1567),
    [anon_sym_PIPE] = ACTIONS(1567),
    [anon_sym_PLUS] = ACTIONS(1569),
    [anon_sym_DASH] = ACTIONS(1569),
    [anon_sym_TILDE] = ACTIONS(1567),
    [anon_sym_void] = ACTIONS(1569),
    [anon_sym_delete] = ACTIONS(1569),
    [anon_sym_PLUS_PLUS] = ACTIONS(1567),
    [anon_sym_DASH_DASH] = ACTIONS(1567),
    [anon_sym_DQUOTE] = ACTIONS(1567),
    [anon_sym_SQUOTE] = ACTIONS(1567),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1567),
    [sym_number] = ACTIONS(1567),
    [sym_this] = ACTIONS(1569),
    [sym_super] = ACTIONS(1569),
    [sym_true] = ACTIONS(1569),
    [sym_false] = ACTIONS(1569),
    [sym_null] = ACTIONS(1569),
    [sym_undefined] = ACTIONS(1569),
    [anon_sym_AT] = ACTIONS(1567),
    [anon_sym_static] = ACTIONS(1569),
    [anon_sym_abstract] = ACTIONS(1569),
    [anon_sym_get] = ACTIONS(1569),
    [anon_sym_set] = ACTIONS(1569),
    [anon_sym_declare] = ACTIONS(1569),
    [anon_sym_public] = ACTIONS(1569),
    [anon_sym_private] = ACTIONS(1569),
    [anon_sym_protected] = ACTIONS(1569),
    [anon_sym_module] = ACTIONS(1569),
    [anon_sym_any] = ACTIONS(1569),
    [anon_sym_number] = ACTIONS(1569),
    [anon_sym_boolean] = ACTIONS(1569),
    [anon_sym_string] = ACTIONS(1569),
    [anon_sym_symbol] = ACTIONS(1569),
    [anon_sym_interface] = ACTIONS(1569),
    [anon_sym_extends] = ACTIONS(1569),
    [anon_sym_enum] = ACTIONS(1569),
    [sym_readonly] = ACTIONS(1569),
  },
  [438] = {
    [ts_builtin_sym_end] = ACTIONS(1571),
    [sym_identifier] = ACTIONS(1573),
    [anon_sym_export] = ACTIONS(1573),
    [anon_sym_default] = ACTIONS(1573),
    [anon_sym_EQ] = ACTIONS(1573),
    [anon_sym_namespace] = ACTIONS(1573),
    [anon_sym_LBRACE] = ACTIONS(1571),
    [anon_sym_COMMA] = ACTIONS(1571),
    [anon_sym_RBRACE] = ACTIONS(1571),
    [anon_sym_type] = ACTIONS(1573),
    [anon_sym_typeof] = ACTIONS(1573),
    [anon_sym_import] = ACTIONS(1573),
    [anon_sym_var] = ACTIONS(1573),
    [anon_sym_let] = ACTIONS(1573),
    [anon_sym_const] = ACTIONS(1573),
    [anon_sym_BANG] = ACTIONS(1571),
    [anon_sym_else] = ACTIONS(1573),
    [anon_sym_if] = ACTIONS(1573),
    [anon_sym_switch] = ACTIONS(1573),
    [anon_sym_for] = ACTIONS(1573),
    [anon_sym_LPAREN] = ACTIONS(1571),
    [anon_sym_RPAREN] = ACTIONS(1571),
    [anon_sym_await] = ACTIONS(1573),
    [anon_sym_while] = ACTIONS(1573),
    [anon_sym_do] = ACTIONS(1573),
    [anon_sym_try] = ACTIONS(1573),
    [anon_sym_with] = ACTIONS(1573),
    [anon_sym_break] = ACTIONS(1573),
    [anon_sym_continue] = ACTIONS(1573),
    [anon_sym_debugger] = ACTIONS(1573),
    [anon_sym_return] = ACTIONS(1573),
    [anon_sym_throw] = ACTIONS(1573),
    [anon_sym_SEMI] = ACTIONS(1571),
    [anon_sym_COLON] = ACTIONS(1571),
    [anon_sym_case] = ACTIONS(1573),
    [anon_sym_yield] = ACTIONS(1573),
    [anon_sym_LBRACK] = ACTIONS(1571),
    [anon_sym_RBRACK] = ACTIONS(1571),
    [anon_sym_LT] = ACTIONS(1571),
    [anon_sym_GT] = ACTIONS(1571),
    [anon_sym_SLASH] = ACTIONS(1573),
    [anon_sym_class] = ACTIONS(1573),
    [anon_sym_async] = ACTIONS(1573),
    [anon_sym_function] = ACTIONS(1573),
    [anon_sym_EQ_GT] = ACTIONS(1571),
    [anon_sym_new] = ACTIONS(1573),
    [anon_sym_QMARK] = ACTIONS(1571),
    [anon_sym_AMP] = ACTIONS(1571),
    [anon_sym_PIPE] = ACTIONS(1571),
    [anon_sym_PLUS] = ACTIONS(1573),
    [anon_sym_DASH] = ACTIONS(1573),
    [anon_sym_TILDE] = ACTIONS(1571),
    [anon_sym_void] = ACTIONS(1573),
    [anon_sym_delete] = ACTIONS(1573),
    [anon_sym_PLUS_PLUS] = ACTIONS(1571),
    [anon_sym_DASH_DASH] = ACTIONS(1571),
    [anon_sym_DQUOTE] = ACTIONS(1571),
    [anon_sym_SQUOTE] = ACTIONS(1571),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1571),
    [sym_number] = ACTIONS(1571),
    [sym_this] = ACTIONS(1573),
    [sym_super] = ACTIONS(1573),
    [sym_true] = ACTIONS(1573),
    [sym_false] = ACTIONS(1573),
    [sym_null] = ACTIONS(1573),
    [sym_undefined] = ACTIONS(1573),
    [anon_sym_AT] = ACTIONS(1571),
    [anon_sym_static] = ACTIONS(1573),
    [anon_sym_abstract] = ACTIONS(1573),
    [anon_sym_get] = ACTIONS(1573),
    [anon_sym_set] = ACTIONS(1573),
    [anon_sym_declare] = ACTIONS(1573),
    [anon_sym_public] = ACTIONS(1573),
    [anon_sym_private] = ACTIONS(1573),
    [anon_sym_protected] = ACTIONS(1573),
    [anon_sym_module] = ACTIONS(1573),
    [anon_sym_any] = ACTIONS(1573),
    [anon_sym_number] = ACTIONS(1573),
    [anon_sym_boolean] = ACTIONS(1573),
    [anon_sym_string] = ACTIONS(1573),
    [anon_sym_symbol] = ACTIONS(1573),
    [anon_sym_interface] = ACTIONS(1573),
    [anon_sym_extends] = ACTIONS(1573),
    [anon_sym_enum] = ACTIONS(1573),
    [sym_readonly] = ACTIONS(1573),
  },
  [439] = {
    [ts_builtin_sym_end] = ACTIONS(1575),
    [sym_identifier] = ACTIONS(1577),
    [anon_sym_export] = ACTIONS(1577),
    [anon_sym_default] = ACTIONS(1577),
    [anon_sym_EQ] = ACTIONS(1577),
    [anon_sym_namespace] = ACTIONS(1577),
    [anon_sym_LBRACE] = ACTIONS(1575),
    [anon_sym_COMMA] = ACTIONS(1575),
    [anon_sym_RBRACE] = ACTIONS(1575),
    [anon_sym_type] = ACTIONS(1577),
    [anon_sym_typeof] = ACTIONS(1577),
    [anon_sym_import] = ACTIONS(1577),
    [anon_sym_var] = ACTIONS(1577),
    [anon_sym_let] = ACTIONS(1577),
    [anon_sym_const] = ACTIONS(1577),
    [anon_sym_BANG] = ACTIONS(1575),
    [anon_sym_else] = ACTIONS(1577),
    [anon_sym_if] = ACTIONS(1577),
    [anon_sym_switch] = ACTIONS(1577),
    [anon_sym_for] = ACTIONS(1577),
    [anon_sym_LPAREN] = ACTIONS(1575),
    [anon_sym_RPAREN] = ACTIONS(1575),
    [anon_sym_await] = ACTIONS(1577),
    [anon_sym_while] = ACTIONS(1577),
    [anon_sym_do] = ACTIONS(1577),
    [anon_sym_try] = ACTIONS(1577),
    [anon_sym_with] = ACTIONS(1577),
    [anon_sym_break] = ACTIONS(1577),
    [anon_sym_continue] = ACTIONS(1577),
    [anon_sym_debugger] = ACTIONS(1577),
    [anon_sym_return] = ACTIONS(1577),
    [anon_sym_throw] = ACTIONS(1577),
    [anon_sym_SEMI] = ACTIONS(1575),
    [anon_sym_COLON] = ACTIONS(1575),
    [anon_sym_case] = ACTIONS(1577),
    [anon_sym_yield] = ACTIONS(1577),
    [anon_sym_LBRACK] = ACTIONS(1579),
    [anon_sym_RBRACK] = ACTIONS(1575),
    [anon_sym_LT] = ACTIONS(1575),
    [anon_sym_GT] = ACTIONS(1575),
    [anon_sym_SLASH] = ACTIONS(1577),
    [anon_sym_class] = ACTIONS(1577),
    [anon_sym_async] = ACTIONS(1577),
    [anon_sym_function] = ACTIONS(1577),
    [anon_sym_EQ_GT] = ACTIONS(1575),
    [anon_sym_new] = ACTIONS(1577),
    [anon_sym_QMARK] = ACTIONS(1575),
    [anon_sym_AMP] = ACTIONS(1579),
    [anon_sym_PIPE] = ACTIONS(1579),
    [anon_sym_PLUS] = ACTIONS(1577),
    [anon_sym_DASH] = ACTIONS(1577),
    [anon_sym_TILDE] = ACTIONS(1575),
    [anon_sym_void] = ACTIONS(1577),
    [anon_sym_delete] = ACTIONS(1577),
    [anon_sym_PLUS_PLUS] = ACTIONS(1575),
    [anon_sym_DASH_DASH] = ACTIONS(1575),
    [anon_sym_DQUOTE] = ACTIONS(1575),
    [anon_sym_SQUOTE] = ACTIONS(1575),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1575),
    [sym_number] = ACTIONS(1575),
    [sym_this] = ACTIONS(1577),
    [sym_super] = ACTIONS(1577),
    [sym_true] = ACTIONS(1577),
    [sym_false] = ACTIONS(1577),
    [sym_null] = ACTIONS(1577),
    [sym_undefined] = ACTIONS(1577),
    [anon_sym_AT] = ACTIONS(1575),
    [anon_sym_static] = ACTIONS(1577),
    [anon_sym_abstract] = ACTIONS(1577),
    [anon_sym_get] = ACTIONS(1577),
    [anon_sym_set] = ACTIONS(1577),
    [anon_sym_declare] = ACTIONS(1577),
    [anon_sym_public] = ACTIONS(1577),
    [anon_sym_private] = ACTIONS(1577),
    [anon_sym_protected] = ACTIONS(1577),
    [anon_sym_module] = ACTIONS(1577),
    [anon_sym_any] = ACTIONS(1577),
    [anon_sym_number] = ACTIONS(1577),
    [anon_sym_boolean] = ACTIONS(1577),
    [anon_sym_string] = ACTIONS(1577),
    [anon_sym_symbol] = ACTIONS(1577),
    [anon_sym_interface] = ACTIONS(1577),
    [anon_sym_extends] = ACTIONS(1581),
    [anon_sym_enum] = ACTIONS(1577),
    [sym_readonly] = ACTIONS(1577),
  },
  [440] = {
    [ts_builtin_sym_end] = ACTIONS(1579),
    [sym_identifier] = ACTIONS(1581),
    [anon_sym_export] = ACTIONS(1581),
    [anon_sym_default] = ACTIONS(1581),
    [anon_sym_EQ] = ACTIONS(1581),
    [anon_sym_namespace] = ACTIONS(1581),
    [anon_sym_LBRACE] = ACTIONS(1579),
    [anon_sym_COMMA] = ACTIONS(1579),
    [anon_sym_RBRACE] = ACTIONS(1579),
    [anon_sym_type] = ACTIONS(1581),
    [anon_sym_typeof] = ACTIONS(1581),
    [anon_sym_import] = ACTIONS(1581),
    [anon_sym_var] = ACTIONS(1581),
    [anon_sym_let] = ACTIONS(1581),
    [anon_sym_const] = ACTIONS(1581),
    [anon_sym_BANG] = ACTIONS(1579),
    [anon_sym_else] = ACTIONS(1581),
    [anon_sym_if] = ACTIONS(1581),
    [anon_sym_switch] = ACTIONS(1581),
    [anon_sym_for] = ACTIONS(1581),
    [anon_sym_LPAREN] = ACTIONS(1579),
    [anon_sym_RPAREN] = ACTIONS(1579),
    [anon_sym_await] = ACTIONS(1581),
    [anon_sym_while] = ACTIONS(1581),
    [anon_sym_do] = ACTIONS(1581),
    [anon_sym_try] = ACTIONS(1581),
    [anon_sym_with] = ACTIONS(1581),
    [anon_sym_break] = ACTIONS(1581),
    [anon_sym_continue] = ACTIONS(1581),
    [anon_sym_debugger] = ACTIONS(1581),
    [anon_sym_return] = ACTIONS(1581),
    [anon_sym_throw] = ACTIONS(1581),
    [anon_sym_SEMI] = ACTIONS(1579),
    [anon_sym_COLON] = ACTIONS(1579),
    [anon_sym_case] = ACTIONS(1581),
    [anon_sym_yield] = ACTIONS(1581),
    [anon_sym_LBRACK] = ACTIONS(1579),
    [anon_sym_RBRACK] = ACTIONS(1579),
    [anon_sym_LT] = ACTIONS(1579),
    [anon_sym_GT] = ACTIONS(1579),
    [anon_sym_SLASH] = ACTIONS(1581),
    [anon_sym_class] = ACTIONS(1581),
    [anon_sym_async] = ACTIONS(1581),
    [anon_sym_function] = ACTIONS(1581),
    [anon_sym_EQ_GT] = ACTIONS(1579),
    [anon_sym_new] = ACTIONS(1581),
    [anon_sym_QMARK] = ACTIONS(1579),
    [anon_sym_AMP] = ACTIONS(1579),
    [anon_sym_PIPE] = ACTIONS(1579),
    [anon_sym_PLUS] = ACTIONS(1581),
    [anon_sym_DASH] = ACTIONS(1581),
    [anon_sym_TILDE] = ACTIONS(1579),
    [anon_sym_void] = ACTIONS(1581),
    [anon_sym_delete] = ACTIONS(1581),
    [anon_sym_PLUS_PLUS] = ACTIONS(1579),
    [anon_sym_DASH_DASH] = ACTIONS(1579),
    [anon_sym_DQUOTE] = ACTIONS(1579),
    [anon_sym_SQUOTE] = ACTIONS(1579),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1579),
    [sym_number] = ACTIONS(1579),
    [sym_this] = ACTIONS(1581),
    [sym_super] = ACTIONS(1581),
    [sym_true] = ACTIONS(1581),
    [sym_false] = ACTIONS(1581),
    [sym_null] = ACTIONS(1581),
    [sym_undefined] = ACTIONS(1581),
    [anon_sym_AT] = ACTIONS(1579),
    [anon_sym_static] = ACTIONS(1581),
    [anon_sym_abstract] = ACTIONS(1581),
    [anon_sym_get] = ACTIONS(1581),
    [anon_sym_set] = ACTIONS(1581),
    [anon_sym_declare] = ACTIONS(1581),
    [anon_sym_public] = ACTIONS(1581),
    [anon_sym_private] = ACTIONS(1581),
    [anon_sym_protected] = ACTIONS(1581),
    [anon_sym_module] = ACTIONS(1581),
    [anon_sym_any] = ACTIONS(1581),
    [anon_sym_number] = ACTIONS(1581),
    [anon_sym_boolean] = ACTIONS(1581),
    [anon_sym_string] = ACTIONS(1581),
    [anon_sym_symbol] = ACTIONS(1581),
    [anon_sym_interface] = ACTIONS(1581),
    [anon_sym_extends] = ACTIONS(1581),
    [anon_sym_enum] = ACTIONS(1581),
    [sym_readonly] = ACTIONS(1581),
  },
  [441] = {
    [ts_builtin_sym_end] = ACTIONS(1583),
    [sym_identifier] = ACTIONS(1585),
    [anon_sym_export] = ACTIONS(1585),
    [anon_sym_default] = ACTIONS(1585),
    [anon_sym_EQ] = ACTIONS(1585),
    [anon_sym_namespace] = ACTIONS(1585),
    [anon_sym_LBRACE] = ACTIONS(1583),
    [anon_sym_COMMA] = ACTIONS(1583),
    [anon_sym_RBRACE] = ACTIONS(1583),
    [anon_sym_type] = ACTIONS(1585),
    [anon_sym_typeof] = ACTIONS(1585),
    [anon_sym_import] = ACTIONS(1585),
    [anon_sym_var] = ACTIONS(1585),
    [anon_sym_let] = ACTIONS(1585),
    [anon_sym_const] = ACTIONS(1585),
    [anon_sym_BANG] = ACTIONS(1583),
    [anon_sym_else] = ACTIONS(1585),
    [anon_sym_if] = ACTIONS(1585),
    [anon_sym_switch] = ACTIONS(1585),
    [anon_sym_for] = ACTIONS(1585),
    [anon_sym_LPAREN] = ACTIONS(1583),
    [anon_sym_RPAREN] = ACTIONS(1583),
    [anon_sym_await] = ACTIONS(1585),
    [anon_sym_while] = ACTIONS(1585),
    [anon_sym_do] = ACTIONS(1585),
    [anon_sym_try] = ACTIONS(1585),
    [anon_sym_with] = ACTIONS(1585),
    [anon_sym_break] = ACTIONS(1585),
    [anon_sym_continue] = ACTIONS(1585),
    [anon_sym_debugger] = ACTIONS(1585),
    [anon_sym_return] = ACTIONS(1585),
    [anon_sym_throw] = ACTIONS(1585),
    [anon_sym_SEMI] = ACTIONS(1583),
    [anon_sym_COLON] = ACTIONS(1583),
    [anon_sym_case] = ACTIONS(1585),
    [anon_sym_yield] = ACTIONS(1585),
    [anon_sym_LBRACK] = ACTIONS(1583),
    [anon_sym_RBRACK] = ACTIONS(1583),
    [anon_sym_LT] = ACTIONS(1583),
    [anon_sym_GT] = ACTIONS(1583),
    [anon_sym_SLASH] = ACTIONS(1585),
    [anon_sym_class] = ACTIONS(1585),
    [anon_sym_async] = ACTIONS(1585),
    [anon_sym_function] = ACTIONS(1585),
    [anon_sym_EQ_GT] = ACTIONS(1583),
    [anon_sym_new] = ACTIONS(1585),
    [anon_sym_QMARK] = ACTIONS(1583),
    [anon_sym_AMP] = ACTIONS(1583),
    [anon_sym_PIPE] = ACTIONS(1583),
    [anon_sym_PLUS] = ACTIONS(1585),
    [anon_sym_DASH] = ACTIONS(1585),
    [anon_sym_TILDE] = ACTIONS(1583),
    [anon_sym_void] = ACTIONS(1585),
    [anon_sym_delete] = ACTIONS(1585),
    [anon_sym_PLUS_PLUS] = ACTIONS(1583),
    [anon_sym_DASH_DASH] = ACTIONS(1583),
    [anon_sym_DQUOTE] = ACTIONS(1583),
    [anon_sym_SQUOTE] = ACTIONS(1583),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1583),
    [sym_number] = ACTIONS(1583),
    [sym_this] = ACTIONS(1585),
    [sym_super] = ACTIONS(1585),
    [sym_true] = ACTIONS(1585),
    [sym_false] = ACTIONS(1585),
    [sym_null] = ACTIONS(1585),
    [sym_undefined] = ACTIONS(1585),
    [anon_sym_AT] = ACTIONS(1583),
    [anon_sym_static] = ACTIONS(1585),
    [anon_sym_abstract] = ACTIONS(1585),
    [anon_sym_get] = ACTIONS(1585),
    [anon_sym_set] = ACTIONS(1585),
    [anon_sym_declare] = ACTIONS(1585),
    [anon_sym_public] = ACTIONS(1585),
    [anon_sym_private] = ACTIONS(1585),
    [anon_sym_protected] = ACTIONS(1585),
    [anon_sym_module] = ACTIONS(1585),
    [anon_sym_any] = ACTIONS(1585),
    [anon_sym_number] = ACTIONS(1585),
    [anon_sym_boolean] = ACTIONS(1585),
    [anon_sym_string] = ACTIONS(1585),
    [anon_sym_symbol] = ACTIONS(1585),
    [anon_sym_interface] = ACTIONS(1585),
    [anon_sym_extends] = ACTIONS(1585),
    [anon_sym_enum] = ACTIONS(1585),
    [sym_readonly] = ACTIONS(1585),
  },
  [442] = {
    [ts_builtin_sym_end] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(1589),
    [anon_sym_export] = ACTIONS(1589),
    [anon_sym_default] = ACTIONS(1589),
    [anon_sym_EQ] = ACTIONS(1589),
    [anon_sym_namespace] = ACTIONS(1589),
    [anon_sym_LBRACE] = ACTIONS(1587),
    [anon_sym_COMMA] = ACTIONS(1587),
    [anon_sym_RBRACE] = ACTIONS(1587),
    [anon_sym_type] = ACTIONS(1589),
    [anon_sym_typeof] = ACTIONS(1589),
    [anon_sym_import] = ACTIONS(1589),
    [anon_sym_var] = ACTIONS(1589),
    [anon_sym_let] = ACTIONS(1589),
    [anon_sym_const] = ACTIONS(1589),
    [anon_sym_BANG] = ACTIONS(1587),
    [anon_sym_else] = ACTIONS(1589),
    [anon_sym_if] = ACTIONS(1589),
    [anon_sym_switch] = ACTIONS(1589),
    [anon_sym_for] = ACTIONS(1589),
    [anon_sym_LPAREN] = ACTIONS(1587),
    [anon_sym_RPAREN] = ACTIONS(1587),
    [anon_sym_await] = ACTIONS(1589),
    [anon_sym_while] = ACTIONS(1589),
    [anon_sym_do] = ACTIONS(1589),
    [anon_sym_try] = ACTIONS(1589),
    [anon_sym_with] = ACTIONS(1589),
    [anon_sym_break] = ACTIONS(1589),
    [anon_sym_continue] = ACTIONS(1589),
    [anon_sym_debugger] = ACTIONS(1589),
    [anon_sym_return] = ACTIONS(1589),
    [anon_sym_throw] = ACTIONS(1589),
    [anon_sym_SEMI] = ACTIONS(1587),
    [anon_sym_COLON] = ACTIONS(1587),
    [anon_sym_case] = ACTIONS(1589),
    [anon_sym_yield] = ACTIONS(1589),
    [anon_sym_LBRACK] = ACTIONS(1587),
    [anon_sym_RBRACK] = ACTIONS(1587),
    [anon_sym_LT] = ACTIONS(1587),
    [anon_sym_GT] = ACTIONS(1587),
    [anon_sym_SLASH] = ACTIONS(1589),
    [anon_sym_class] = ACTIONS(1589),
    [anon_sym_async] = ACTIONS(1589),
    [anon_sym_function] = ACTIONS(1589),
    [anon_sym_EQ_GT] = ACTIONS(1587),
    [anon_sym_new] = ACTIONS(1589),
    [anon_sym_QMARK] = ACTIONS(1587),
    [anon_sym_AMP] = ACTIONS(1587),
    [anon_sym_PIPE] = ACTIONS(1587),
    [anon_sym_PLUS] = ACTIONS(1589),
    [anon_sym_DASH] = ACTIONS(1589),
    [anon_sym_TILDE] = ACTIONS(1587),
    [anon_sym_void] = ACTIONS(1589),
    [anon_sym_delete] = ACTIONS(1589),
    [anon_sym_PLUS_PLUS] = ACTIONS(1587),
    [anon_sym_DASH_DASH] = ACTIONS(1587),
    [anon_sym_DQUOTE] = ACTIONS(1587),
    [anon_sym_SQUOTE] = ACTIONS(1587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1587),
    [sym_number] = ACTIONS(1587),
    [sym_this] = ACTIONS(1589),
    [sym_super] = ACTIONS(1589),
    [sym_true] = ACTIONS(1589),
    [sym_false] = ACTIONS(1589),
    [sym_null] = ACTIONS(1589),
    [sym_undefined] = ACTIONS(1589),
    [anon_sym_AT] = ACTIONS(1587),
    [anon_sym_static] = ACTIONS(1589),
    [anon_sym_abstract] = ACTIONS(1589),
    [anon_sym_get] = ACTIONS(1589),
    [anon_sym_set] = ACTIONS(1589),
    [anon_sym_declare] = ACTIONS(1589),
    [anon_sym_public] = ACTIONS(1589),
    [anon_sym_private] = ACTIONS(1589),
    [anon_sym_protected] = ACTIONS(1589),
    [anon_sym_module] = ACTIONS(1589),
    [anon_sym_any] = ACTIONS(1589),
    [anon_sym_number] = ACTIONS(1589),
    [anon_sym_boolean] = ACTIONS(1589),
    [anon_sym_string] = ACTIONS(1589),
    [anon_sym_symbol] = ACTIONS(1589),
    [anon_sym_interface] = ACTIONS(1589),
    [anon_sym_extends] = ACTIONS(1589),
    [anon_sym_enum] = ACTIONS(1589),
    [sym_readonly] = ACTIONS(1589),
  },
  [443] = {
    [ts_builtin_sym_end] = ACTIONS(1591),
    [sym_identifier] = ACTIONS(1593),
    [anon_sym_export] = ACTIONS(1593),
    [anon_sym_default] = ACTIONS(1593),
    [anon_sym_EQ] = ACTIONS(1593),
    [anon_sym_namespace] = ACTIONS(1593),
    [anon_sym_LBRACE] = ACTIONS(1591),
    [anon_sym_COMMA] = ACTIONS(1591),
    [anon_sym_RBRACE] = ACTIONS(1591),
    [anon_sym_type] = ACTIONS(1593),
    [anon_sym_typeof] = ACTIONS(1593),
    [anon_sym_import] = ACTIONS(1593),
    [anon_sym_var] = ACTIONS(1593),
    [anon_sym_let] = ACTIONS(1593),
    [anon_sym_const] = ACTIONS(1593),
    [anon_sym_BANG] = ACTIONS(1591),
    [anon_sym_else] = ACTIONS(1593),
    [anon_sym_if] = ACTIONS(1593),
    [anon_sym_switch] = ACTIONS(1593),
    [anon_sym_for] = ACTIONS(1593),
    [anon_sym_LPAREN] = ACTIONS(1591),
    [anon_sym_RPAREN] = ACTIONS(1591),
    [anon_sym_await] = ACTIONS(1593),
    [anon_sym_while] = ACTIONS(1593),
    [anon_sym_do] = ACTIONS(1593),
    [anon_sym_try] = ACTIONS(1593),
    [anon_sym_with] = ACTIONS(1593),
    [anon_sym_break] = ACTIONS(1593),
    [anon_sym_continue] = ACTIONS(1593),
    [anon_sym_debugger] = ACTIONS(1593),
    [anon_sym_return] = ACTIONS(1593),
    [anon_sym_throw] = ACTIONS(1593),
    [anon_sym_SEMI] = ACTIONS(1591),
    [anon_sym_COLON] = ACTIONS(1591),
    [anon_sym_case] = ACTIONS(1593),
    [anon_sym_yield] = ACTIONS(1593),
    [anon_sym_LBRACK] = ACTIONS(1591),
    [anon_sym_RBRACK] = ACTIONS(1591),
    [anon_sym_LT] = ACTIONS(1591),
    [anon_sym_GT] = ACTIONS(1591),
    [anon_sym_SLASH] = ACTIONS(1593),
    [anon_sym_class] = ACTIONS(1593),
    [anon_sym_async] = ACTIONS(1593),
    [anon_sym_function] = ACTIONS(1593),
    [anon_sym_EQ_GT] = ACTIONS(1591),
    [anon_sym_new] = ACTIONS(1593),
    [anon_sym_QMARK] = ACTIONS(1591),
    [anon_sym_AMP] = ACTIONS(1591),
    [anon_sym_PIPE] = ACTIONS(1591),
    [anon_sym_PLUS] = ACTIONS(1593),
    [anon_sym_DASH] = ACTIONS(1593),
    [anon_sym_TILDE] = ACTIONS(1591),
    [anon_sym_void] = ACTIONS(1593),
    [anon_sym_delete] = ACTIONS(1593),
    [anon_sym_PLUS_PLUS] = ACTIONS(1591),
    [anon_sym_DASH_DASH] = ACTIONS(1591),
    [anon_sym_DQUOTE] = ACTIONS(1591),
    [anon_sym_SQUOTE] = ACTIONS(1591),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1591),
    [sym_number] = ACTIONS(1591),
    [sym_this] = ACTIONS(1593),
    [sym_super] = ACTIONS(1593),
    [sym_true] = ACTIONS(1593),
    [sym_false] = ACTIONS(1593),
    [sym_null] = ACTIONS(1593),
    [sym_undefined] = ACTIONS(1593),
    [anon_sym_AT] = ACTIONS(1591),
    [anon_sym_static] = ACTIONS(1593),
    [anon_sym_abstract] = ACTIONS(1593),
    [anon_sym_get] = ACTIONS(1593),
    [anon_sym_set] = ACTIONS(1593),
    [anon_sym_declare] = ACTIONS(1593),
    [anon_sym_public] = ACTIONS(1593),
    [anon_sym_private] = ACTIONS(1593),
    [anon_sym_protected] = ACTIONS(1593),
    [anon_sym_module] = ACTIONS(1593),
    [anon_sym_any] = ACTIONS(1593),
    [anon_sym_number] = ACTIONS(1593),
    [anon_sym_boolean] = ACTIONS(1593),
    [anon_sym_string] = ACTIONS(1593),
    [anon_sym_symbol] = ACTIONS(1593),
    [anon_sym_interface] = ACTIONS(1593),
    [anon_sym_extends] = ACTIONS(1593),
    [anon_sym_enum] = ACTIONS(1593),
    [sym_readonly] = ACTIONS(1593),
  },
  [444] = {
    [ts_builtin_sym_end] = ACTIONS(1595),
    [sym_identifier] = ACTIONS(1597),
    [anon_sym_export] = ACTIONS(1597),
    [anon_sym_default] = ACTIONS(1597),
    [anon_sym_EQ] = ACTIONS(1597),
    [anon_sym_namespace] = ACTIONS(1597),
    [anon_sym_LBRACE] = ACTIONS(1595),
    [anon_sym_COMMA] = ACTIONS(1595),
    [anon_sym_RBRACE] = ACTIONS(1595),
    [anon_sym_type] = ACTIONS(1597),
    [anon_sym_typeof] = ACTIONS(1597),
    [anon_sym_import] = ACTIONS(1597),
    [anon_sym_var] = ACTIONS(1597),
    [anon_sym_let] = ACTIONS(1597),
    [anon_sym_const] = ACTIONS(1597),
    [anon_sym_BANG] = ACTIONS(1595),
    [anon_sym_else] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1597),
    [anon_sym_switch] = ACTIONS(1597),
    [anon_sym_for] = ACTIONS(1597),
    [anon_sym_LPAREN] = ACTIONS(1595),
    [anon_sym_RPAREN] = ACTIONS(1595),
    [anon_sym_await] = ACTIONS(1597),
    [anon_sym_while] = ACTIONS(1597),
    [anon_sym_do] = ACTIONS(1597),
    [anon_sym_try] = ACTIONS(1597),
    [anon_sym_with] = ACTIONS(1597),
    [anon_sym_break] = ACTIONS(1597),
    [anon_sym_continue] = ACTIONS(1597),
    [anon_sym_debugger] = ACTIONS(1597),
    [anon_sym_return] = ACTIONS(1597),
    [anon_sym_throw] = ACTIONS(1597),
    [anon_sym_SEMI] = ACTIONS(1595),
    [anon_sym_COLON] = ACTIONS(1595),
    [anon_sym_case] = ACTIONS(1597),
    [anon_sym_yield] = ACTIONS(1597),
    [anon_sym_LBRACK] = ACTIONS(1595),
    [anon_sym_RBRACK] = ACTIONS(1595),
    [anon_sym_LT] = ACTIONS(1595),
    [anon_sym_GT] = ACTIONS(1595),
    [anon_sym_SLASH] = ACTIONS(1597),
    [anon_sym_class] = ACTIONS(1597),
    [anon_sym_async] = ACTIONS(1597),
    [anon_sym_function] = ACTIONS(1597),
    [anon_sym_EQ_GT] = ACTIONS(1595),
    [anon_sym_new] = ACTIONS(1597),
    [anon_sym_QMARK] = ACTIONS(1595),
    [anon_sym_AMP] = ACTIONS(1595),
    [anon_sym_PIPE] = ACTIONS(1595),
    [anon_sym_PLUS] = ACTIONS(1597),
    [anon_sym_DASH] = ACTIONS(1597),
    [anon_sym_TILDE] = ACTIONS(1595),
    [anon_sym_void] = ACTIONS(1597),
    [anon_sym_delete] = ACTIONS(1597),
    [anon_sym_PLUS_PLUS] = ACTIONS(1595),
    [anon_sym_DASH_DASH] = ACTIONS(1595),
    [anon_sym_DQUOTE] = ACTIONS(1595),
    [anon_sym_SQUOTE] = ACTIONS(1595),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1595),
    [sym_number] = ACTIONS(1595),
    [sym_this] = ACTIONS(1597),
    [sym_super] = ACTIONS(1597),
    [sym_true] = ACTIONS(1597),
    [sym_false] = ACTIONS(1597),
    [sym_null] = ACTIONS(1597),
    [sym_undefined] = ACTIONS(1597),
    [anon_sym_AT] = ACTIONS(1595),
    [anon_sym_static] = ACTIONS(1597),
    [anon_sym_abstract] = ACTIONS(1597),
    [anon_sym_get] = ACTIONS(1597),
    [anon_sym_set] = ACTIONS(1597),
    [anon_sym_declare] = ACTIONS(1597),
    [anon_sym_public] = ACTIONS(1597),
    [anon_sym_private] = ACTIONS(1597),
    [anon_sym_protected] = ACTIONS(1597),
    [anon_sym_module] = ACTIONS(1597),
    [anon_sym_any] = ACTIONS(1597),
    [anon_sym_number] = ACTIONS(1597),
    [anon_sym_boolean] = ACTIONS(1597),
    [anon_sym_string] = ACTIONS(1597),
    [anon_sym_symbol] = ACTIONS(1597),
    [anon_sym_interface] = ACTIONS(1597),
    [anon_sym_extends] = ACTIONS(1597),
    [anon_sym_enum] = ACTIONS(1597),
    [sym_readonly] = ACTIONS(1597),
  },
  [445] = {
    [ts_builtin_sym_end] = ACTIONS(1599),
    [sym_identifier] = ACTIONS(1601),
    [anon_sym_export] = ACTIONS(1601),
    [anon_sym_default] = ACTIONS(1601),
    [anon_sym_EQ] = ACTIONS(1601),
    [anon_sym_namespace] = ACTIONS(1601),
    [anon_sym_LBRACE] = ACTIONS(1599),
    [anon_sym_COMMA] = ACTIONS(1599),
    [anon_sym_RBRACE] = ACTIONS(1599),
    [anon_sym_type] = ACTIONS(1601),
    [anon_sym_typeof] = ACTIONS(1601),
    [anon_sym_import] = ACTIONS(1601),
    [anon_sym_var] = ACTIONS(1601),
    [anon_sym_let] = ACTIONS(1601),
    [anon_sym_const] = ACTIONS(1601),
    [anon_sym_BANG] = ACTIONS(1599),
    [anon_sym_else] = ACTIONS(1601),
    [anon_sym_if] = ACTIONS(1601),
    [anon_sym_switch] = ACTIONS(1601),
    [anon_sym_for] = ACTIONS(1601),
    [anon_sym_LPAREN] = ACTIONS(1599),
    [anon_sym_RPAREN] = ACTIONS(1599),
    [anon_sym_await] = ACTIONS(1601),
    [anon_sym_while] = ACTIONS(1601),
    [anon_sym_do] = ACTIONS(1601),
    [anon_sym_try] = ACTIONS(1601),
    [anon_sym_with] = ACTIONS(1601),
    [anon_sym_break] = ACTIONS(1601),
    [anon_sym_continue] = ACTIONS(1601),
    [anon_sym_debugger] = ACTIONS(1601),
    [anon_sym_return] = ACTIONS(1601),
    [anon_sym_throw] = ACTIONS(1601),
    [anon_sym_SEMI] = ACTIONS(1599),
    [anon_sym_COLON] = ACTIONS(1599),
    [anon_sym_case] = ACTIONS(1601),
    [anon_sym_yield] = ACTIONS(1601),
    [anon_sym_LBRACK] = ACTIONS(1599),
    [anon_sym_RBRACK] = ACTIONS(1599),
    [anon_sym_LT] = ACTIONS(1599),
    [anon_sym_GT] = ACTIONS(1599),
    [anon_sym_SLASH] = ACTIONS(1601),
    [anon_sym_class] = ACTIONS(1601),
    [anon_sym_async] = ACTIONS(1601),
    [anon_sym_function] = ACTIONS(1601),
    [anon_sym_EQ_GT] = ACTIONS(1599),
    [anon_sym_new] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(1599),
    [anon_sym_AMP] = ACTIONS(1599),
    [anon_sym_PIPE] = ACTIONS(1599),
    [anon_sym_PLUS] = ACTIONS(1601),
    [anon_sym_DASH] = ACTIONS(1601),
    [anon_sym_TILDE] = ACTIONS(1599),
    [anon_sym_void] = ACTIONS(1601),
    [anon_sym_delete] = ACTIONS(1601),
    [anon_sym_PLUS_PLUS] = ACTIONS(1599),
    [anon_sym_DASH_DASH] = ACTIONS(1599),
    [anon_sym_DQUOTE] = ACTIONS(1599),
    [anon_sym_SQUOTE] = ACTIONS(1599),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1599),
    [sym_number] = ACTIONS(1599),
    [sym_this] = ACTIONS(1601),
    [sym_super] = ACTIONS(1601),
    [sym_true] = ACTIONS(1601),
    [sym_false] = ACTIONS(1601),
    [sym_null] = ACTIONS(1601),
    [sym_undefined] = ACTIONS(1601),
    [anon_sym_AT] = ACTIONS(1599),
    [anon_sym_static] = ACTIONS(1601),
    [anon_sym_abstract] = ACTIONS(1601),
    [anon_sym_get] = ACTIONS(1601),
    [anon_sym_set] = ACTIONS(1601),
    [anon_sym_declare] = ACTIONS(1601),
    [anon_sym_public] = ACTIONS(1601),
    [anon_sym_private] = ACTIONS(1601),
    [anon_sym_protected] = ACTIONS(1601),
    [anon_sym_module] = ACTIONS(1601),
    [anon_sym_any] = ACTIONS(1601),
    [anon_sym_number] = ACTIONS(1601),
    [anon_sym_boolean] = ACTIONS(1601),
    [anon_sym_string] = ACTIONS(1601),
    [anon_sym_symbol] = ACTIONS(1601),
    [anon_sym_interface] = ACTIONS(1601),
    [anon_sym_extends] = ACTIONS(1601),
    [anon_sym_enum] = ACTIONS(1601),
    [sym_readonly] = ACTIONS(1601),
  },
  [446] = {
    [ts_builtin_sym_end] = ACTIONS(1603),
    [sym_identifier] = ACTIONS(1605),
    [anon_sym_export] = ACTIONS(1605),
    [anon_sym_default] = ACTIONS(1605),
    [anon_sym_EQ] = ACTIONS(1605),
    [anon_sym_namespace] = ACTIONS(1605),
    [anon_sym_LBRACE] = ACTIONS(1603),
    [anon_sym_COMMA] = ACTIONS(1603),
    [anon_sym_RBRACE] = ACTIONS(1603),
    [anon_sym_type] = ACTIONS(1605),
    [anon_sym_typeof] = ACTIONS(1605),
    [anon_sym_import] = ACTIONS(1605),
    [anon_sym_var] = ACTIONS(1605),
    [anon_sym_let] = ACTIONS(1605),
    [anon_sym_const] = ACTIONS(1605),
    [anon_sym_BANG] = ACTIONS(1603),
    [anon_sym_else] = ACTIONS(1605),
    [anon_sym_if] = ACTIONS(1605),
    [anon_sym_switch] = ACTIONS(1605),
    [anon_sym_for] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(1603),
    [anon_sym_RPAREN] = ACTIONS(1603),
    [anon_sym_await] = ACTIONS(1605),
    [anon_sym_while] = ACTIONS(1605),
    [anon_sym_do] = ACTIONS(1605),
    [anon_sym_try] = ACTIONS(1605),
    [anon_sym_with] = ACTIONS(1605),
    [anon_sym_break] = ACTIONS(1605),
    [anon_sym_continue] = ACTIONS(1605),
    [anon_sym_debugger] = ACTIONS(1605),
    [anon_sym_return] = ACTIONS(1605),
    [anon_sym_throw] = ACTIONS(1605),
    [anon_sym_SEMI] = ACTIONS(1603),
    [anon_sym_COLON] = ACTIONS(1603),
    [anon_sym_case] = ACTIONS(1605),
    [anon_sym_yield] = ACTIONS(1605),
    [anon_sym_LBRACK] = ACTIONS(1603),
    [anon_sym_RBRACK] = ACTIONS(1603),
    [anon_sym_LT] = ACTIONS(1603),
    [anon_sym_GT] = ACTIONS(1603),
    [anon_sym_SLASH] = ACTIONS(1605),
    [anon_sym_class] = ACTIONS(1605),
    [anon_sym_async] = ACTIONS(1605),
    [anon_sym_function] = ACTIONS(1605),
    [anon_sym_EQ_GT] = ACTIONS(1603),
    [anon_sym_new] = ACTIONS(1605),
    [anon_sym_QMARK] = ACTIONS(1603),
    [anon_sym_AMP] = ACTIONS(1603),
    [anon_sym_PIPE] = ACTIONS(1603),
    [anon_sym_PLUS] = ACTIONS(1605),
    [anon_sym_DASH] = ACTIONS(1605),
    [anon_sym_TILDE] = ACTIONS(1603),
    [anon_sym_void] = ACTIONS(1605),
    [anon_sym_delete] = ACTIONS(1605),
    [anon_sym_PLUS_PLUS] = ACTIONS(1603),
    [anon_sym_DASH_DASH] = ACTIONS(1603),
    [anon_sym_DQUOTE] = ACTIONS(1603),
    [anon_sym_SQUOTE] = ACTIONS(1603),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1603),
    [sym_number] = ACTIONS(1603),
    [sym_this] = ACTIONS(1605),
    [sym_super] = ACTIONS(1605),
    [sym_true] = ACTIONS(1605),
    [sym_false] = ACTIONS(1605),
    [sym_null] = ACTIONS(1605),
    [sym_undefined] = ACTIONS(1605),
    [anon_sym_AT] = ACTIONS(1603),
    [anon_sym_static] = ACTIONS(1605),
    [anon_sym_abstract] = ACTIONS(1605),
    [anon_sym_get] = ACTIONS(1605),
    [anon_sym_set] = ACTIONS(1605),
    [anon_sym_declare] = ACTIONS(1605),
    [anon_sym_public] = ACTIONS(1605),
    [anon_sym_private] = ACTIONS(1605),
    [anon_sym_protected] = ACTIONS(1605),
    [anon_sym_module] = ACTIONS(1605),
    [anon_sym_any] = ACTIONS(1605),
    [anon_sym_number] = ACTIONS(1605),
    [anon_sym_boolean] = ACTIONS(1605),
    [anon_sym_string] = ACTIONS(1605),
    [anon_sym_symbol] = ACTIONS(1605),
    [anon_sym_interface] = ACTIONS(1605),
    [anon_sym_extends] = ACTIONS(1605),
    [anon_sym_enum] = ACTIONS(1605),
    [sym_readonly] = ACTIONS(1605),
  },
  [447] = {
    [ts_builtin_sym_end] = ACTIONS(1607),
    [sym_identifier] = ACTIONS(1609),
    [anon_sym_export] = ACTIONS(1609),
    [anon_sym_default] = ACTIONS(1609),
    [anon_sym_EQ] = ACTIONS(1609),
    [anon_sym_namespace] = ACTIONS(1609),
    [anon_sym_LBRACE] = ACTIONS(1607),
    [anon_sym_COMMA] = ACTIONS(1607),
    [anon_sym_RBRACE] = ACTIONS(1607),
    [anon_sym_type] = ACTIONS(1609),
    [anon_sym_typeof] = ACTIONS(1609),
    [anon_sym_import] = ACTIONS(1609),
    [anon_sym_var] = ACTIONS(1609),
    [anon_sym_let] = ACTIONS(1609),
    [anon_sym_const] = ACTIONS(1609),
    [anon_sym_BANG] = ACTIONS(1607),
    [anon_sym_else] = ACTIONS(1609),
    [anon_sym_if] = ACTIONS(1609),
    [anon_sym_switch] = ACTIONS(1609),
    [anon_sym_for] = ACTIONS(1609),
    [anon_sym_LPAREN] = ACTIONS(1607),
    [anon_sym_RPAREN] = ACTIONS(1607),
    [anon_sym_await] = ACTIONS(1609),
    [anon_sym_while] = ACTIONS(1609),
    [anon_sym_do] = ACTIONS(1609),
    [anon_sym_try] = ACTIONS(1609),
    [anon_sym_with] = ACTIONS(1609),
    [anon_sym_break] = ACTIONS(1609),
    [anon_sym_continue] = ACTIONS(1609),
    [anon_sym_debugger] = ACTIONS(1609),
    [anon_sym_return] = ACTIONS(1609),
    [anon_sym_throw] = ACTIONS(1609),
    [anon_sym_SEMI] = ACTIONS(1607),
    [anon_sym_COLON] = ACTIONS(1607),
    [anon_sym_case] = ACTIONS(1609),
    [anon_sym_yield] = ACTIONS(1609),
    [anon_sym_LBRACK] = ACTIONS(1607),
    [anon_sym_RBRACK] = ACTIONS(1607),
    [anon_sym_LT] = ACTIONS(1607),
    [anon_sym_GT] = ACTIONS(1607),
    [anon_sym_SLASH] = ACTIONS(1609),
    [anon_sym_class] = ACTIONS(1609),
    [anon_sym_async] = ACTIONS(1609),
    [anon_sym_function] = ACTIONS(1609),
    [anon_sym_EQ_GT] = ACTIONS(1607),
    [anon_sym_new] = ACTIONS(1609),
    [anon_sym_QMARK] = ACTIONS(1607),
    [anon_sym_AMP] = ACTIONS(1607),
    [anon_sym_PIPE] = ACTIONS(1607),
    [anon_sym_PLUS] = ACTIONS(1609),
    [anon_sym_DASH] = ACTIONS(1609),
    [anon_sym_TILDE] = ACTIONS(1607),
    [anon_sym_void] = ACTIONS(1609),
    [anon_sym_delete] = ACTIONS(1609),
    [anon_sym_PLUS_PLUS] = ACTIONS(1607),
    [anon_sym_DASH_DASH] = ACTIONS(1607),
    [anon_sym_DQUOTE] = ACTIONS(1607),
    [anon_sym_SQUOTE] = ACTIONS(1607),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1607),
    [sym_number] = ACTIONS(1607),
    [sym_this] = ACTIONS(1609),
    [sym_super] = ACTIONS(1609),
    [sym_true] = ACTIONS(1609),
    [sym_false] = ACTIONS(1609),
    [sym_null] = ACTIONS(1609),
    [sym_undefined] = ACTIONS(1609),
    [anon_sym_AT] = ACTIONS(1607),
    [anon_sym_static] = ACTIONS(1609),
    [anon_sym_abstract] = ACTIONS(1609),
    [anon_sym_get] = ACTIONS(1609),
    [anon_sym_set] = ACTIONS(1609),
    [anon_sym_declare] = ACTIONS(1609),
    [anon_sym_public] = ACTIONS(1609),
    [anon_sym_private] = ACTIONS(1609),
    [anon_sym_protected] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(1609),
    [anon_sym_any] = ACTIONS(1609),
    [anon_sym_number] = ACTIONS(1609),
    [anon_sym_boolean] = ACTIONS(1609),
    [anon_sym_string] = ACTIONS(1609),
    [anon_sym_symbol] = ACTIONS(1609),
    [anon_sym_interface] = ACTIONS(1609),
    [anon_sym_extends] = ACTIONS(1609),
    [anon_sym_enum] = ACTIONS(1609),
    [sym_readonly] = ACTIONS(1609),
  },
  [448] = {
    [ts_builtin_sym_end] = ACTIONS(1611),
    [sym_identifier] = ACTIONS(1613),
    [anon_sym_export] = ACTIONS(1613),
    [anon_sym_default] = ACTIONS(1613),
    [anon_sym_EQ] = ACTIONS(1613),
    [anon_sym_namespace] = ACTIONS(1613),
    [anon_sym_LBRACE] = ACTIONS(1611),
    [anon_sym_COMMA] = ACTIONS(1611),
    [anon_sym_RBRACE] = ACTIONS(1611),
    [anon_sym_type] = ACTIONS(1613),
    [anon_sym_typeof] = ACTIONS(1613),
    [anon_sym_import] = ACTIONS(1613),
    [anon_sym_var] = ACTIONS(1613),
    [anon_sym_let] = ACTIONS(1613),
    [anon_sym_const] = ACTIONS(1613),
    [anon_sym_BANG] = ACTIONS(1611),
    [anon_sym_else] = ACTIONS(1613),
    [anon_sym_if] = ACTIONS(1613),
    [anon_sym_switch] = ACTIONS(1613),
    [anon_sym_for] = ACTIONS(1613),
    [anon_sym_LPAREN] = ACTIONS(1611),
    [anon_sym_RPAREN] = ACTIONS(1611),
    [anon_sym_await] = ACTIONS(1613),
    [anon_sym_while] = ACTIONS(1613),
    [anon_sym_do] = ACTIONS(1613),
    [anon_sym_try] = ACTIONS(1613),
    [anon_sym_with] = ACTIONS(1613),
    [anon_sym_break] = ACTIONS(1613),
    [anon_sym_continue] = ACTIONS(1613),
    [anon_sym_debugger] = ACTIONS(1613),
    [anon_sym_return] = ACTIONS(1613),
    [anon_sym_throw] = ACTIONS(1613),
    [anon_sym_SEMI] = ACTIONS(1611),
    [anon_sym_COLON] = ACTIONS(1611),
    [anon_sym_case] = ACTIONS(1613),
    [anon_sym_yield] = ACTIONS(1613),
    [anon_sym_LBRACK] = ACTIONS(1611),
    [anon_sym_RBRACK] = ACTIONS(1611),
    [anon_sym_LT] = ACTIONS(1611),
    [anon_sym_GT] = ACTIONS(1611),
    [anon_sym_SLASH] = ACTIONS(1613),
    [anon_sym_class] = ACTIONS(1613),
    [anon_sym_async] = ACTIONS(1613),
    [anon_sym_function] = ACTIONS(1613),
    [anon_sym_EQ_GT] = ACTIONS(1611),
    [anon_sym_new] = ACTIONS(1613),
    [anon_sym_QMARK] = ACTIONS(1611),
    [anon_sym_AMP] = ACTIONS(1611),
    [anon_sym_PIPE] = ACTIONS(1611),
    [anon_sym_PLUS] = ACTIONS(1613),
    [anon_sym_DASH] = ACTIONS(1613),
    [anon_sym_TILDE] = ACTIONS(1611),
    [anon_sym_void] = ACTIONS(1613),
    [anon_sym_delete] = ACTIONS(1613),
    [anon_sym_PLUS_PLUS] = ACTIONS(1611),
    [anon_sym_DASH_DASH] = ACTIONS(1611),
    [anon_sym_DQUOTE] = ACTIONS(1611),
    [anon_sym_SQUOTE] = ACTIONS(1611),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1611),
    [sym_number] = ACTIONS(1611),
    [sym_this] = ACTIONS(1613),
    [sym_super] = ACTIONS(1613),
    [sym_true] = ACTIONS(1613),
    [sym_false] = ACTIONS(1613),
    [sym_null] = ACTIONS(1613),
    [sym_undefined] = ACTIONS(1613),
    [anon_sym_AT] = ACTIONS(1611),
    [anon_sym_static] = ACTIONS(1613),
    [anon_sym_abstract] = ACTIONS(1613),
    [anon_sym_get] = ACTIONS(1613),
    [anon_sym_set] = ACTIONS(1613),
    [anon_sym_declare] = ACTIONS(1613),
    [anon_sym_public] = ACTIONS(1613),
    [anon_sym_private] = ACTIONS(1613),
    [anon_sym_protected] = ACTIONS(1613),
    [anon_sym_module] = ACTIONS(1613),
    [anon_sym_any] = ACTIONS(1613),
    [anon_sym_number] = ACTIONS(1613),
    [anon_sym_boolean] = ACTIONS(1613),
    [anon_sym_string] = ACTIONS(1613),
    [anon_sym_symbol] = ACTIONS(1613),
    [anon_sym_interface] = ACTIONS(1613),
    [anon_sym_extends] = ACTIONS(1613),
    [anon_sym_enum] = ACTIONS(1613),
    [sym_readonly] = ACTIONS(1613),
  },
  [449] = {
    [ts_builtin_sym_end] = ACTIONS(1615),
    [sym_identifier] = ACTIONS(1617),
    [anon_sym_export] = ACTIONS(1617),
    [anon_sym_default] = ACTIONS(1617),
    [anon_sym_EQ] = ACTIONS(1617),
    [anon_sym_namespace] = ACTIONS(1617),
    [anon_sym_LBRACE] = ACTIONS(1615),
    [anon_sym_COMMA] = ACTIONS(1615),
    [anon_sym_RBRACE] = ACTIONS(1615),
    [anon_sym_type] = ACTIONS(1617),
    [anon_sym_typeof] = ACTIONS(1617),
    [anon_sym_import] = ACTIONS(1617),
    [anon_sym_var] = ACTIONS(1617),
    [anon_sym_let] = ACTIONS(1617),
    [anon_sym_const] = ACTIONS(1617),
    [anon_sym_BANG] = ACTIONS(1615),
    [anon_sym_else] = ACTIONS(1617),
    [anon_sym_if] = ACTIONS(1617),
    [anon_sym_switch] = ACTIONS(1617),
    [anon_sym_for] = ACTIONS(1617),
    [anon_sym_LPAREN] = ACTIONS(1615),
    [anon_sym_RPAREN] = ACTIONS(1615),
    [anon_sym_await] = ACTIONS(1617),
    [anon_sym_while] = ACTIONS(1617),
    [anon_sym_do] = ACTIONS(1617),
    [anon_sym_try] = ACTIONS(1617),
    [anon_sym_with] = ACTIONS(1617),
    [anon_sym_break] = ACTIONS(1617),
    [anon_sym_continue] = ACTIONS(1617),
    [anon_sym_debugger] = ACTIONS(1617),
    [anon_sym_return] = ACTIONS(1617),
    [anon_sym_throw] = ACTIONS(1617),
    [anon_sym_SEMI] = ACTIONS(1615),
    [anon_sym_COLON] = ACTIONS(1615),
    [anon_sym_case] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(1617),
    [anon_sym_LBRACK] = ACTIONS(1615),
    [anon_sym_RBRACK] = ACTIONS(1615),
    [anon_sym_LT] = ACTIONS(1615),
    [anon_sym_GT] = ACTIONS(1615),
    [anon_sym_SLASH] = ACTIONS(1617),
    [anon_sym_class] = ACTIONS(1617),
    [anon_sym_async] = ACTIONS(1617),
    [anon_sym_function] = ACTIONS(1617),
    [anon_sym_EQ_GT] = ACTIONS(1615),
    [anon_sym_new] = ACTIONS(1617),
    [anon_sym_QMARK] = ACTIONS(1615),
    [anon_sym_AMP] = ACTIONS(1615),
    [anon_sym_PIPE] = ACTIONS(1615),
    [anon_sym_PLUS] = ACTIONS(1617),
    [anon_sym_DASH] = ACTIONS(1617),
    [anon_sym_TILDE] = ACTIONS(1615),
    [anon_sym_void] = ACTIONS(1617),
    [anon_sym_delete] = ACTIONS(1617),
    [anon_sym_PLUS_PLUS] = ACTIONS(1615),
    [anon_sym_DASH_DASH] = ACTIONS(1615),
    [anon_sym_DQUOTE] = ACTIONS(1615),
    [anon_sym_SQUOTE] = ACTIONS(1615),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1615),
    [sym_number] = ACTIONS(1615),
    [sym_this] = ACTIONS(1617),
    [sym_super] = ACTIONS(1617),
    [sym_true] = ACTIONS(1617),
    [sym_false] = ACTIONS(1617),
    [sym_null] = ACTIONS(1617),
    [sym_undefined] = ACTIONS(1617),
    [anon_sym_AT] = ACTIONS(1615),
    [anon_sym_static] = ACTIONS(1617),
    [anon_sym_abstract] = ACTIONS(1617),
    [anon_sym_get] = ACTIONS(1617),
    [anon_sym_set] = ACTIONS(1617),
    [anon_sym_declare] = ACTIONS(1617),
    [anon_sym_public] = ACTIONS(1617),
    [anon_sym_private] = ACTIONS(1617),
    [anon_sym_protected] = ACTIONS(1617),
    [anon_sym_module] = ACTIONS(1617),
    [anon_sym_any] = ACTIONS(1617),
    [anon_sym_number] = ACTIONS(1617),
    [anon_sym_boolean] = ACTIONS(1617),
    [anon_sym_string] = ACTIONS(1617),
    [anon_sym_symbol] = ACTIONS(1617),
    [anon_sym_interface] = ACTIONS(1617),
    [anon_sym_extends] = ACTIONS(1617),
    [anon_sym_enum] = ACTIONS(1617),
    [sym_readonly] = ACTIONS(1617),
  },
  [450] = {
    [ts_builtin_sym_end] = ACTIONS(1619),
    [sym_identifier] = ACTIONS(1621),
    [anon_sym_export] = ACTIONS(1621),
    [anon_sym_default] = ACTIONS(1621),
    [anon_sym_EQ] = ACTIONS(1621),
    [anon_sym_namespace] = ACTIONS(1621),
    [anon_sym_LBRACE] = ACTIONS(1619),
    [anon_sym_COMMA] = ACTIONS(1619),
    [anon_sym_RBRACE] = ACTIONS(1619),
    [anon_sym_type] = ACTIONS(1621),
    [anon_sym_typeof] = ACTIONS(1621),
    [anon_sym_import] = ACTIONS(1621),
    [anon_sym_var] = ACTIONS(1621),
    [anon_sym_let] = ACTIONS(1621),
    [anon_sym_const] = ACTIONS(1621),
    [anon_sym_BANG] = ACTIONS(1619),
    [anon_sym_else] = ACTIONS(1621),
    [anon_sym_if] = ACTIONS(1621),
    [anon_sym_switch] = ACTIONS(1621),
    [anon_sym_for] = ACTIONS(1621),
    [anon_sym_LPAREN] = ACTIONS(1619),
    [anon_sym_RPAREN] = ACTIONS(1619),
    [anon_sym_await] = ACTIONS(1621),
    [anon_sym_while] = ACTIONS(1621),
    [anon_sym_do] = ACTIONS(1621),
    [anon_sym_try] = ACTIONS(1621),
    [anon_sym_with] = ACTIONS(1621),
    [anon_sym_break] = ACTIONS(1621),
    [anon_sym_continue] = ACTIONS(1621),
    [anon_sym_debugger] = ACTIONS(1621),
    [anon_sym_return] = ACTIONS(1621),
    [anon_sym_throw] = ACTIONS(1621),
    [anon_sym_SEMI] = ACTIONS(1619),
    [anon_sym_COLON] = ACTIONS(1619),
    [anon_sym_case] = ACTIONS(1621),
    [anon_sym_yield] = ACTIONS(1621),
    [anon_sym_LBRACK] = ACTIONS(1619),
    [anon_sym_RBRACK] = ACTIONS(1619),
    [anon_sym_LT] = ACTIONS(1619),
    [anon_sym_GT] = ACTIONS(1619),
    [anon_sym_SLASH] = ACTIONS(1621),
    [anon_sym_class] = ACTIONS(1621),
    [anon_sym_async] = ACTIONS(1621),
    [anon_sym_function] = ACTIONS(1621),
    [anon_sym_EQ_GT] = ACTIONS(1619),
    [anon_sym_new] = ACTIONS(1621),
    [anon_sym_QMARK] = ACTIONS(1619),
    [anon_sym_AMP] = ACTIONS(1619),
    [anon_sym_PIPE] = ACTIONS(1619),
    [anon_sym_PLUS] = ACTIONS(1621),
    [anon_sym_DASH] = ACTIONS(1621),
    [anon_sym_TILDE] = ACTIONS(1619),
    [anon_sym_void] = ACTIONS(1621),
    [anon_sym_delete] = ACTIONS(1621),
    [anon_sym_PLUS_PLUS] = ACTIONS(1619),
    [anon_sym_DASH_DASH] = ACTIONS(1619),
    [anon_sym_DQUOTE] = ACTIONS(1619),
    [anon_sym_SQUOTE] = ACTIONS(1619),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1619),
    [sym_number] = ACTIONS(1619),
    [sym_this] = ACTIONS(1621),
    [sym_super] = ACTIONS(1621),
    [sym_true] = ACTIONS(1621),
    [sym_false] = ACTIONS(1621),
    [sym_null] = ACTIONS(1621),
    [sym_undefined] = ACTIONS(1621),
    [anon_sym_AT] = ACTIONS(1619),
    [anon_sym_static] = ACTIONS(1621),
    [anon_sym_abstract] = ACTIONS(1621),
    [anon_sym_get] = ACTIONS(1621),
    [anon_sym_set] = ACTIONS(1621),
    [anon_sym_declare] = ACTIONS(1621),
    [anon_sym_public] = ACTIONS(1621),
    [anon_sym_private] = ACTIONS(1621),
    [anon_sym_protected] = ACTIONS(1621),
    [anon_sym_module] = ACTIONS(1621),
    [anon_sym_any] = ACTIONS(1621),
    [anon_sym_number] = ACTIONS(1621),
    [anon_sym_boolean] = ACTIONS(1621),
    [anon_sym_string] = ACTIONS(1621),
    [anon_sym_symbol] = ACTIONS(1621),
    [anon_sym_interface] = ACTIONS(1621),
    [anon_sym_extends] = ACTIONS(1621),
    [anon_sym_enum] = ACTIONS(1621),
    [sym_readonly] = ACTIONS(1621),
  },
  [451] = {
    [sym_string] = STATE(2332),
    [sym__property_name] = STATE(2332),
    [sym_computed_property_name] = STATE(2332),
    [aux_sym_object_repeat1] = STATE(2854),
    [sym_identifier] = ACTIONS(1623),
    [anon_sym_export] = ACTIONS(1623),
    [anon_sym_STAR] = ACTIONS(1420),
    [anon_sym_EQ] = ACTIONS(1260),
    [anon_sym_as] = ACTIONS(780),
    [anon_sym_namespace] = ACTIONS(1623),
    [anon_sym_COMMA] = ACTIONS(813),
    [anon_sym_RBRACE] = ACTIONS(1248),
    [anon_sym_type] = ACTIONS(1623),
    [anon_sym_BANG] = ACTIONS(780),
    [anon_sym_LPAREN] = ACTIONS(1217),
    [anon_sym_in] = ACTIONS(780),
    [anon_sym_SEMI] = ACTIONS(813),
    [anon_sym_COLON] = ACTIONS(1220),
    [anon_sym_LBRACK] = ACTIONS(1427),
    [anon_sym_LT] = ACTIONS(1225),
    [anon_sym_GT] = ACTIONS(780),
    [anon_sym_SLASH] = ACTIONS(780),
    [anon_sym_DOT] = ACTIONS(927),
    [anon_sym_async] = ACTIONS(1625),
    [anon_sym_EQ_GT] = ACTIONS(929),
    [anon_sym_QMARK_DOT] = ACTIONS(931),
    [anon_sym_PLUS_EQ] = ACTIONS(803),
    [anon_sym_DASH_EQ] = ACTIONS(803),
    [anon_sym_STAR_EQ] = ACTIONS(803),
    [anon_sym_SLASH_EQ] = ACTIONS(803),
    [anon_sym_PERCENT_EQ] = ACTIONS(803),
    [anon_sym_CARET_EQ] = ACTIONS(803),
    [anon_sym_AMP_EQ] = ACTIONS(803),
    [anon_sym_PIPE_EQ] = ACTIONS(803),
    [anon_sym_GT_GT_EQ] = ACTIONS(803),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(803),
    [anon_sym_LT_LT_EQ] = ACTIONS(803),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(803),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(803),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(803),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(803),
    [anon_sym_QMARK] = ACTIONS(1225),
    [anon_sym_AMP_AMP] = ACTIONS(780),
    [anon_sym_PIPE_PIPE] = ACTIONS(780),
    [anon_sym_GT_GT] = ACTIONS(780),
    [anon_sym_GT_GT_GT] = ACTIONS(780),
    [anon_sym_LT_LT] = ACTIONS(780),
    [anon_sym_AMP] = ACTIONS(780),
    [anon_sym_CARET] = ACTIONS(780),
    [anon_sym_PIPE] = ACTIONS(780),
    [anon_sym_PLUS] = ACTIONS(780),
    [anon_sym_DASH] = ACTIONS(780),
    [anon_sym_PERCENT] = ACTIONS(780),
    [anon_sym_STAR_STAR] = ACTIONS(780),
    [anon_sym_LT_EQ] = ACTIONS(813),
    [anon_sym_EQ_EQ] = ACTIONS(780),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(813),
    [anon_sym_BANG_EQ] = ACTIONS(780),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(813),
    [anon_sym_GT_EQ] = ACTIONS(813),
    [anon_sym_QMARK_QMARK] = ACTIONS(780),
    [anon_sym_instanceof] = ACTIONS(780),
    [anon_sym_PLUS_PLUS] = ACTIONS(813),
    [anon_sym_DASH_DASH] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(817),
    [anon_sym_SQUOTE] = ACTIONS(819),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(813),
    [sym_number] = ACTIONS(1435),
    [anon_sym_static] = ACTIONS(1623),
    [anon_sym_get] = ACTIONS(1627),
    [anon_sym_set] = ACTIONS(1627),
    [anon_sym_declare] = ACTIONS(1623),
    [anon_sym_public] = ACTIONS(1623),
    [anon_sym_private] = ACTIONS(1623),
    [anon_sym_protected] = ACTIONS(1623),
    [anon_sym_module] = ACTIONS(1623),
    [anon_sym_any] = ACTIONS(1623),
    [anon_sym_number] = ACTIONS(1623),
    [anon_sym_boolean] = ACTIONS(1623),
    [anon_sym_string] = ACTIONS(1623),
    [anon_sym_symbol] = ACTIONS(1623),
    [sym_readonly] = ACTIONS(1629),
    [sym__automatic_semicolon] = ACTIONS(813),
  },
  [452] = {
    [sym_string] = STATE(2332),
    [sym__property_name] = STATE(2332),
    [sym_computed_property_name] = STATE(2332),
    [aux_sym_object_repeat1] = STATE(2854),
    [sym_identifier] = ACTIONS(1623),
    [anon_sym_export] = ACTIONS(1623),
    [anon_sym_STAR] = ACTIONS(1420),
    [anon_sym_EQ] = ACTIONS(1260),
    [anon_sym_as] = ACTIONS(780),
    [anon_sym_namespace] = ACTIONS(1623),
    [anon_sym_COMMA] = ACTIONS(813),
    [anon_sym_RBRACE] = ACTIONS(1248),
    [anon_sym_type] = ACTIONS(1623),
    [anon_sym_BANG] = ACTIONS(780),
    [anon_sym_LPAREN] = ACTIONS(1217),
    [anon_sym_in] = ACTIONS(780),
    [anon_sym_SEMI] = ACTIONS(813),
    [anon_sym_COLON] = ACTIONS(1220),
    [anon_sym_LBRACK] = ACTIONS(1427),
    [anon_sym_LT] = ACTIONS(1225),
    [anon_sym_GT] = ACTIONS(780),
    [anon_sym_SLASH] = ACTIONS(780),
    [anon_sym_DOT] = ACTIONS(927),
    [anon_sym_async] = ACTIONS(1625),
    [anon_sym_EQ_GT] = ACTIONS(929),
    [anon_sym_QMARK_DOT] = ACTIONS(931),
    [anon_sym_PLUS_EQ] = ACTIONS(803),
    [anon_sym_DASH_EQ] = ACTIONS(803),
    [anon_sym_STAR_EQ] = ACTIONS(803),
    [anon_sym_SLASH_EQ] = ACTIONS(803),
    [anon_sym_PERCENT_EQ] = ACTIONS(803),
    [anon_sym_CARET_EQ] = ACTIONS(803),
    [anon_sym_AMP_EQ] = ACTIONS(803),
    [anon_sym_PIPE_EQ] = ACTIONS(803),
    [anon_sym_GT_GT_EQ] = ACTIONS(803),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(803),
    [anon_sym_LT_LT_EQ] = ACTIONS(803),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(803),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(803),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(803),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(803),
    [anon_sym_QMARK] = ACTIONS(1225),
    [anon_sym_AMP_AMP] = ACTIONS(780),
    [anon_sym_PIPE_PIPE] = ACTIONS(780),
    [anon_sym_GT_GT] = ACTIONS(780),
    [anon_sym_GT_GT_GT] = ACTIONS(780),
    [anon_sym_LT_LT] = ACTIONS(780),
    [anon_sym_AMP] = ACTIONS(780),
    [anon_sym_CARET] = ACTIONS(780),
    [anon_sym_PIPE] = ACTIONS(780),
    [anon_sym_PLUS] = ACTIONS(780),
    [anon_sym_DASH] = ACTIONS(780),
    [anon_sym_PERCENT] = ACTIONS(780),
    [anon_sym_STAR_STAR] = ACTIONS(780),
    [anon_sym_LT_EQ] = ACTIONS(813),
    [anon_sym_EQ_EQ] = ACTIONS(780),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(813),
    [anon_sym_BANG_EQ] = ACTIONS(780),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(813),
    [anon_sym_GT_EQ] = ACTIONS(813),
    [anon_sym_QMARK_QMARK] = ACTIONS(780),
    [anon_sym_instanceof] = ACTIONS(780),
    [anon_sym_PLUS_PLUS] = ACTIONS(813),
    [anon_sym_DASH_DASH] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(817),
    [anon_sym_SQUOTE] = ACTIONS(819),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(813),
    [sym_number] = ACTIONS(1435),
    [anon_sym_static] = ACTIONS(1623),
    [anon_sym_get] = ACTIONS(1627),
    [anon_sym_set] = ACTIONS(1627),
    [anon_sym_declare] = ACTIONS(1623),
    [anon_sym_public] = ACTIONS(1623),
    [anon_sym_private] = ACTIONS(1623),
    [anon_sym_protected] = ACTIONS(1623),
    [anon_sym_module] = ACTIONS(1623),
    [anon_sym_any] = ACTIONS(1623),
    [anon_sym_number] = ACTIONS(1623),
    [anon_sym_boolean] = ACTIONS(1623),
    [anon_sym_string] = ACTIONS(1623),
    [anon_sym_symbol] = ACTIONS(1623),
    [sym_readonly] = ACTIONS(1623),
    [sym__automatic_semicolon] = ACTIONS(813),
  },
  [453] = {
    [sym_string] = STATE(2332),
    [sym__property_name] = STATE(2332),
    [sym_computed_property_name] = STATE(2332),
    [aux_sym_object_repeat1] = STATE(2868),
    [sym_identifier] = ACTIONS(1623),
    [anon_sym_export] = ACTIONS(1623),
    [anon_sym_STAR] = ACTIONS(1420),
    [anon_sym_EQ] = ACTIONS(1260),
    [anon_sym_as] = ACTIONS(780),
    [anon_sym_namespace] = ACTIONS(1623),
    [anon_sym_COMMA] = ACTIONS(813),
    [anon_sym_RBRACE] = ACTIONS(1246),
    [anon_sym_type] = ACTIONS(1623),
    [anon_sym_BANG] = ACTIONS(780),
    [anon_sym_LPAREN] = ACTIONS(1217),
    [anon_sym_in] = ACTIONS(780),
    [anon_sym_SEMI] = ACTIONS(813),
    [anon_sym_COLON] = ACTIONS(1220),
    [anon_sym_LBRACK] = ACTIONS(1427),
    [anon_sym_LT] = ACTIONS(1225),
    [anon_sym_GT] = ACTIONS(780),
    [anon_sym_SLASH] = ACTIONS(780),
    [anon_sym_DOT] = ACTIONS(927),
    [anon_sym_async] = ACTIONS(1625),
    [anon_sym_EQ_GT] = ACTIONS(929),
    [anon_sym_QMARK_DOT] = ACTIONS(931),
    [anon_sym_PLUS_EQ] = ACTIONS(803),
    [anon_sym_DASH_EQ] = ACTIONS(803),
    [anon_sym_STAR_EQ] = ACTIONS(803),
    [anon_sym_SLASH_EQ] = ACTIONS(803),
    [anon_sym_PERCENT_EQ] = ACTIONS(803),
    [anon_sym_CARET_EQ] = ACTIONS(803),
    [anon_sym_AMP_EQ] = ACTIONS(803),
    [anon_sym_PIPE_EQ] = ACTIONS(803),
    [anon_sym_GT_GT_EQ] = ACTIONS(803),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(803),
    [anon_sym_LT_LT_EQ] = ACTIONS(803),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(803),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(803),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(803),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(803),
    [anon_sym_QMARK] = ACTIONS(1225),
    [anon_sym_AMP_AMP] = ACTIONS(780),
    [anon_sym_PIPE_PIPE] = ACTIONS(780),
    [anon_sym_GT_GT] = ACTIONS(780),
    [anon_sym_GT_GT_GT] = ACTIONS(780),
    [anon_sym_LT_LT] = ACTIONS(780),
    [anon_sym_AMP] = ACTIONS(780),
    [anon_sym_CARET] = ACTIONS(780),
    [anon_sym_PIPE] = ACTIONS(780),
    [anon_sym_PLUS] = ACTIONS(780),
    [anon_sym_DASH] = ACTIONS(780),
    [anon_sym_PERCENT] = ACTIONS(780),
    [anon_sym_STAR_STAR] = ACTIONS(780),
    [anon_sym_LT_EQ] = ACTIONS(813),
    [anon_sym_EQ_EQ] = ACTIONS(780),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(813),
    [anon_sym_BANG_EQ] = ACTIONS(780),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(813),
    [anon_sym_GT_EQ] = ACTIONS(813),
    [anon_sym_QMARK_QMARK] = ACTIONS(780),
    [anon_sym_instanceof] = ACTIONS(780),
    [anon_sym_PLUS_PLUS] = ACTIONS(813),
    [anon_sym_DASH_DASH] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(817),
    [anon_sym_SQUOTE] = ACTIONS(819),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(813),
    [sym_number] = ACTIONS(1435),
    [anon_sym_static] = ACTIONS(1623),
    [anon_sym_get] = ACTIONS(1627),
    [anon_sym_set] = ACTIONS(1627),
    [anon_sym_declare] = ACTIONS(1623),
    [anon_sym_public] = ACTIONS(1623),
    [anon_sym_private] = ACTIONS(1623),
    [anon_sym_protected] = ACTIONS(1623),
    [anon_sym_module] = ACTIONS(1623),
    [anon_sym_any] = ACTIONS(1623),
    [anon_sym_number] = ACTIONS(1623),
    [anon_sym_boolean] = ACTIONS(1623),
    [anon_sym_string] = ACTIONS(1623),
    [anon_sym_symbol] = ACTIONS(1623),
    [sym_readonly] = ACTIONS(1623),
    [sym__automatic_semicolon] = ACTIONS(813),
  },
  [454] = {
    [sym_string] = STATE(2332),
    [sym__property_name] = STATE(2332),
    [sym_computed_property_name] = STATE(2332),
    [aux_sym_object_repeat1] = STATE(2894),
    [sym_identifier] = ACTIONS(1623),
    [anon_sym_export] = ACTIONS(1623),
    [anon_sym_STAR] = ACTIONS(780),
    [anon_sym_EQ] = ACTIONS(1260),
    [anon_sym_as] = ACTIONS(780),
    [anon_sym_namespace] = ACTIONS(1623),
    [anon_sym_COMMA] = ACTIONS(813),
    [anon_sym_RBRACE] = ACTIONS(1205),
    [anon_sym_type] = ACTIONS(1623),
    [anon_sym_BANG] = ACTIONS(780),
    [anon_sym_LPAREN] = ACTIONS(1217),
    [anon_sym_in] = ACTIONS(780),
    [anon_sym_SEMI] = ACTIONS(813),
    [anon_sym_COLON] = ACTIONS(1220),
    [anon_sym_LBRACK] = ACTIONS(1427),
    [anon_sym_LT] = ACTIONS(1225),
    [anon_sym_GT] = ACTIONS(780),
    [anon_sym_SLASH] = ACTIONS(780),
    [anon_sym_DOT] = ACTIONS(927),
    [anon_sym_async] = ACTIONS(1623),
    [anon_sym_EQ_GT] = ACTIONS(929),
    [anon_sym_QMARK_DOT] = ACTIONS(931),
    [anon_sym_PLUS_EQ] = ACTIONS(803),
    [anon_sym_DASH_EQ] = ACTIONS(803),
    [anon_sym_STAR_EQ] = ACTIONS(803),
    [anon_sym_SLASH_EQ] = ACTIONS(803),
    [anon_sym_PERCENT_EQ] = ACTIONS(803),
    [anon_sym_CARET_EQ] = ACTIONS(803),
    [anon_sym_AMP_EQ] = ACTIONS(803),
    [anon_sym_PIPE_EQ] = ACTIONS(803),
    [anon_sym_GT_GT_EQ] = ACTIONS(803),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(803),
    [anon_sym_LT_LT_EQ] = ACTIONS(803),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(803),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(803),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(803),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(803),
    [anon_sym_QMARK] = ACTIONS(1225),
    [anon_sym_AMP_AMP] = ACTIONS(780),
    [anon_sym_PIPE_PIPE] = ACTIONS(780),
    [anon_sym_GT_GT] = ACTIONS(780),
    [anon_sym_GT_GT_GT] = ACTIONS(780),
    [anon_sym_LT_LT] = ACTIONS(780),
    [anon_sym_AMP] = ACTIONS(780),
    [anon_sym_CARET] = ACTIONS(780),
    [anon_sym_PIPE] = ACTIONS(780),
    [anon_sym_PLUS] = ACTIONS(780),
    [anon_sym_DASH] = ACTIONS(780),
    [anon_sym_PERCENT] = ACTIONS(780),
    [anon_sym_STAR_STAR] = ACTIONS(780),
    [anon_sym_LT_EQ] = ACTIONS(813),
    [anon_sym_EQ_EQ] = ACTIONS(780),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(813),
    [anon_sym_BANG_EQ] = ACTIONS(780),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(813),
    [anon_sym_GT_EQ] = ACTIONS(813),
    [anon_sym_QMARK_QMARK] = ACTIONS(780),
    [anon_sym_instanceof] = ACTIONS(780),
    [anon_sym_PLUS_PLUS] = ACTIONS(813),
    [anon_sym_DASH_DASH] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(817),
    [anon_sym_SQUOTE] = ACTIONS(819),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(813),
    [sym_number] = ACTIONS(1435),
    [anon_sym_static] = ACTIONS(1623),
    [anon_sym_get] = ACTIONS(1623),
    [anon_sym_set] = ACTIONS(1623),
    [anon_sym_declare] = ACTIONS(1623),
    [anon_sym_public] = ACTIONS(1623),
    [anon_sym_private] = ACTIONS(1623),
    [anon_sym_protected] = ACTIONS(1623),
    [anon_sym_module] = ACTIONS(1623),
    [anon_sym_any] = ACTIONS(1623),
    [anon_sym_number] = ACTIONS(1623),
    [anon_sym_boolean] = ACTIONS(1623),
    [anon_sym_string] = ACTIONS(1623),
    [anon_sym_symbol] = ACTIONS(1623),
    [sym_readonly] = ACTIONS(1623),
    [sym__automatic_semicolon] = ACTIONS(813),
  },
  [455] = {
    [sym_string] = STATE(2332),
    [sym__property_name] = STATE(2332),
    [sym_computed_property_name] = STATE(2332),
    [aux_sym_object_repeat1] = STATE(2868),
    [sym_identifier] = ACTIONS(1623),
    [anon_sym_export] = ACTIONS(1623),
    [anon_sym_STAR] = ACTIONS(780),
    [anon_sym_EQ] = ACTIONS(1260),
    [anon_sym_as] = ACTIONS(780),
    [anon_sym_namespace] = ACTIONS(1623),
    [anon_sym_COMMA] = ACTIONS(813),
    [anon_sym_RBRACE] = ACTIONS(1246),
    [anon_sym_type] = ACTIONS(1623),
    [anon_sym_BANG] = ACTIONS(780),
    [anon_sym_LPAREN] = ACTIONS(1217),
    [anon_sym_in] = ACTIONS(780),
    [anon_sym_SEMI] = ACTIONS(813),
    [anon_sym_COLON] = ACTIONS(1220),
    [anon_sym_LBRACK] = ACTIONS(1427),
    [anon_sym_LT] = ACTIONS(1225),
    [anon_sym_GT] = ACTIONS(780),
    [anon_sym_SLASH] = ACTIONS(780),
    [anon_sym_DOT] = ACTIONS(927),
    [anon_sym_async] = ACTIONS(1623),
    [anon_sym_EQ_GT] = ACTIONS(929),
    [anon_sym_QMARK_DOT] = ACTIONS(931),
    [anon_sym_PLUS_EQ] = ACTIONS(803),
    [anon_sym_DASH_EQ] = ACTIONS(803),
    [anon_sym_STAR_EQ] = ACTIONS(803),
    [anon_sym_SLASH_EQ] = ACTIONS(803),
    [anon_sym_PERCENT_EQ] = ACTIONS(803),
    [anon_sym_CARET_EQ] = ACTIONS(803),
    [anon_sym_AMP_EQ] = ACTIONS(803),
    [anon_sym_PIPE_EQ] = ACTIONS(803),
    [anon_sym_GT_GT_EQ] = ACTIONS(803),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(803),
    [anon_sym_LT_LT_EQ] = ACTIONS(803),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(803),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(803),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(803),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(803),
    [anon_sym_QMARK] = ACTIONS(1225),
    [anon_sym_AMP_AMP] = ACTIONS(780),
    [anon_sym_PIPE_PIPE] = ACTIONS(780),
    [anon_sym_GT_GT] = ACTIONS(780),
    [anon_sym_GT_GT_GT] = ACTIONS(780),
    [anon_sym_LT_LT] = ACTIONS(780),
    [anon_sym_AMP] = ACTIONS(780),
    [anon_sym_CARET] = ACTIONS(780),
    [anon_sym_PIPE] = ACTIONS(780),
    [anon_sym_PLUS] = ACTIONS(780),
    [anon_sym_DASH] = ACTIONS(780),
    [anon_sym_PERCENT] = ACTIONS(780),
    [anon_sym_STAR_STAR] = ACTIONS(780),
    [anon_sym_LT_EQ] = ACTIONS(813),
    [anon_sym_EQ_EQ] = ACTIONS(780),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(813),
    [anon_sym_BANG_EQ] = ACTIONS(780),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(813),
    [anon_sym_GT_EQ] = ACTIONS(813),
    [anon_sym_QMARK_QMARK] = ACTIONS(780),
    [anon_sym_instanceof] = ACTIONS(780),
    [anon_sym_PLUS_PLUS] = ACTIONS(813),
    [anon_sym_DASH_DASH] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(817),
    [anon_sym_SQUOTE] = ACTIONS(819),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(813),
    [sym_number] = ACTIONS(1435),
    [anon_sym_static] = ACTIONS(1623),
    [anon_sym_get] = ACTIONS(1623),
    [anon_sym_set] = ACTIONS(1623),
    [anon_sym_declare] = ACTIONS(1623),
    [anon_sym_public] = ACTIONS(1623),
    [anon_sym_private] = ACTIONS(1623),
    [anon_sym_protected] = ACTIONS(1623),
    [anon_sym_module] = ACTIONS(1623),
    [anon_sym_any] = ACTIONS(1623),
    [anon_sym_number] = ACTIONS(1623),
    [anon_sym_boolean] = ACTIONS(1623),
    [anon_sym_string] = ACTIONS(1623),
    [anon_sym_symbol] = ACTIONS(1623),
    [sym_readonly] = ACTIONS(1623),
    [sym__automatic_semicolon] = ACTIONS(813),
  },
  [456] = {
    [sym_string] = STATE(2332),
    [sym__property_name] = STATE(2332),
    [sym_computed_property_name] = STATE(2332),
    [aux_sym_object_repeat1] = STATE(2894),
    [sym_identifier] = ACTIONS(1623),
    [anon_sym_export] = ACTIONS(1623),
    [anon_sym_STAR] = ACTIONS(1420),
    [anon_sym_EQ] = ACTIONS(1260),
    [anon_sym_as] = ACTIONS(780),
    [anon_sym_namespace] = ACTIONS(1623),
    [anon_sym_COMMA] = ACTIONS(813),
    [anon_sym_RBRACE] = ACTIONS(1205),
    [anon_sym_type] = ACTIONS(1623),
    [anon_sym_BANG] = ACTIONS(780),
    [anon_sym_LPAREN] = ACTIONS(1217),
    [anon_sym_in] = ACTIONS(780),
    [anon_sym_SEMI] = ACTIONS(813),
    [anon_sym_COLON] = ACTIONS(1220),
    [anon_sym_LBRACK] = ACTIONS(1427),
    [anon_sym_LT] = ACTIONS(1225),
    [anon_sym_GT] = ACTIONS(780),
    [anon_sym_SLASH] = ACTIONS(780),
    [anon_sym_DOT] = ACTIONS(927),
    [anon_sym_async] = ACTIONS(1625),
    [anon_sym_EQ_GT] = ACTIONS(929),
    [anon_sym_QMARK_DOT] = ACTIONS(931),
    [anon_sym_PLUS_EQ] = ACTIONS(803),
    [anon_sym_DASH_EQ] = ACTIONS(803),
    [anon_sym_STAR_EQ] = ACTIONS(803),
    [anon_sym_SLASH_EQ] = ACTIONS(803),
    [anon_sym_PERCENT_EQ] = ACTIONS(803),
    [anon_sym_CARET_EQ] = ACTIONS(803),
    [anon_sym_AMP_EQ] = ACTIONS(803),
    [anon_sym_PIPE_EQ] = ACTIONS(803),
    [anon_sym_GT_GT_EQ] = ACTIONS(803),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(803),
    [anon_sym_LT_LT_EQ] = ACTIONS(803),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(803),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(803),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(803),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(803),
    [anon_sym_QMARK] = ACTIONS(1225),
    [anon_sym_AMP_AMP] = ACTIONS(780),
    [anon_sym_PIPE_PIPE] = ACTIONS(780),
    [anon_sym_GT_GT] = ACTIONS(780),
    [anon_sym_GT_GT_GT] = ACTIONS(780),
    [anon_sym_LT_LT] = ACTIONS(780),
    [anon_sym_AMP] = ACTIONS(780),
    [anon_sym_CARET] = ACTIONS(780),
    [anon_sym_PIPE] = ACTIONS(780),
    [anon_sym_PLUS] = ACTIONS(780),
    [anon_sym_DASH] = ACTIONS(780),
    [anon_sym_PERCENT] = ACTIONS(780),
    [anon_sym_STAR_STAR] = ACTIONS(780),
    [anon_sym_LT_EQ] = ACTIONS(813),
    [anon_sym_EQ_EQ] = ACTIONS(780),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(813),
    [anon_sym_BANG_EQ] = ACTIONS(780),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(813),
    [anon_sym_GT_EQ] = ACTIONS(813),
    [anon_sym_QMARK_QMARK] = ACTIONS(780),
    [anon_sym_instanceof] = ACTIONS(780),
    [anon_sym_PLUS_PLUS] = ACTIONS(813),
    [anon_sym_DASH_DASH] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(817),
    [anon_sym_SQUOTE] = ACTIONS(819),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(813),
    [sym_number] = ACTIONS(1435),
    [anon_sym_static] = ACTIONS(1623),
    [anon_sym_get] = ACTIONS(1627),
    [anon_sym_set] = ACTIONS(1627),
    [anon_sym_declare] = ACTIONS(1623),
    [anon_sym_public] = ACTIONS(1623),
    [anon_sym_private] = ACTIONS(1623),
    [anon_sym_protected] = ACTIONS(1623),
    [anon_sym_module] = ACTIONS(1623),
    [anon_sym_any] = ACTIONS(1623),
    [anon_sym_number] = ACTIONS(1623),
    [anon_sym_boolean] = ACTIONS(1623),
    [anon_sym_string] = ACTIONS(1623),
    [anon_sym_symbol] = ACTIONS(1623),
    [sym_readonly] = ACTIONS(1623),
    [sym__automatic_semicolon] = ACTIONS(813),
  },
  [457] = {
    [sym_string] = STATE(2332),
    [sym__property_name] = STATE(2332),
    [sym_computed_property_name] = STATE(2332),
    [aux_sym_object_repeat1] = STATE(2868),
    [sym_identifier] = ACTIONS(1623),
    [anon_sym_export] = ACTIONS(1623),
    [anon_sym_STAR] = ACTIONS(1420),
    [anon_sym_EQ] = ACTIONS(1260),
    [anon_sym_as] = ACTIONS(780),
    [anon_sym_namespace] = ACTIONS(1623),
    [anon_sym_COMMA] = ACTIONS(813),
    [anon_sym_RBRACE] = ACTIONS(1246),
    [anon_sym_type] = ACTIONS(1623),
    [anon_sym_BANG] = ACTIONS(780),
    [anon_sym_LPAREN] = ACTIONS(1217),
    [anon_sym_in] = ACTIONS(780),
    [anon_sym_SEMI] = ACTIONS(813),
    [anon_sym_COLON] = ACTIONS(1220),
    [anon_sym_LBRACK] = ACTIONS(1427),
    [anon_sym_LT] = ACTIONS(1225),
    [anon_sym_GT] = ACTIONS(780),
    [anon_sym_SLASH] = ACTIONS(780),
    [anon_sym_DOT] = ACTIONS(927),
    [anon_sym_async] = ACTIONS(1625),
    [anon_sym_EQ_GT] = ACTIONS(929),
    [anon_sym_QMARK_DOT] = ACTIONS(931),
    [anon_sym_PLUS_EQ] = ACTIONS(803),
    [anon_sym_DASH_EQ] = ACTIONS(803),
    [anon_sym_STAR_EQ] = ACTIONS(803),
    [anon_sym_SLASH_EQ] = ACTIONS(803),
    [anon_sym_PERCENT_EQ] = ACTIONS(803),
    [anon_sym_CARET_EQ] = ACTIONS(803),
    [anon_sym_AMP_EQ] = ACTIONS(803),
    [anon_sym_PIPE_EQ] = ACTIONS(803),
    [anon_sym_GT_GT_EQ] = ACTIONS(803),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(803),
    [anon_sym_LT_LT_EQ] = ACTIONS(803),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(803),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(803),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(803),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(803),
    [anon_sym_QMARK] = ACTIONS(1225),
    [anon_sym_AMP_AMP] = ACTIONS(780),
    [anon_sym_PIPE_PIPE] = ACTIONS(780),
    [anon_sym_GT_GT] = ACTIONS(780),
    [anon_sym_GT_GT_GT] = ACTIONS(780),
    [anon_sym_LT_LT] = ACTIONS(780),
    [anon_sym_AMP] = ACTIONS(780),
    [anon_sym_CARET] = ACTIONS(780),
    [anon_sym_PIPE] = ACTIONS(780),
    [anon_sym_PLUS] = ACTIONS(780),
    [anon_sym_DASH] = ACTIONS(780),
    [anon_sym_PERCENT] = ACTIONS(780),
    [anon_sym_STAR_STAR] = ACTIONS(780),
    [anon_sym_LT_EQ] = ACTIONS(813),
    [anon_sym_EQ_EQ] = ACTIONS(780),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(813),
    [anon_sym_BANG_EQ] = ACTIONS(780),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(813),
    [anon_sym_GT_EQ] = ACTIONS(813),
    [anon_sym_QMARK_QMARK] = ACTIONS(780),
    [anon_sym_instanceof] = ACTIONS(780),
    [anon_sym_PLUS_PLUS] = ACTIONS(813),
    [anon_sym_DASH_DASH] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(817),
    [anon_sym_SQUOTE] = ACTIONS(819),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(813),
    [sym_number] = ACTIONS(1435),
    [anon_sym_static] = ACTIONS(1623),
    [anon_sym_get] = ACTIONS(1627),
    [anon_sym_set] = ACTIONS(1627),
    [anon_sym_declare] = ACTIONS(1623),
    [anon_sym_public] = ACTIONS(1623),
    [anon_sym_private] = ACTIONS(1623),
    [anon_sym_protected] = ACTIONS(1623),
    [anon_sym_module] = ACTIONS(1623),
    [anon_sym_any] = ACTIONS(1623),
    [anon_sym_number] = ACTIONS(1623),
    [anon_sym_boolean] = ACTIONS(1623),
    [anon_sym_string] = ACTIONS(1623),
    [anon_sym_symbol] = ACTIONS(1623),
    [sym_readonly] = ACTIONS(1629),
    [sym__automatic_semicolon] = ACTIONS(813),
  },
  [458] = {
    [sym_string] = STATE(2332),
    [sym__property_name] = STATE(2332),
    [sym_computed_property_name] = STATE(2332),
    [aux_sym_object_repeat1] = STATE(2894),
    [sym_identifier] = ACTIONS(1623),
    [anon_sym_export] = ACTIONS(1623),
    [anon_sym_STAR] = ACTIONS(1420),
    [anon_sym_EQ] = ACTIONS(1260),
    [anon_sym_as] = ACTIONS(780),
    [anon_sym_namespace] = ACTIONS(1623),
    [anon_sym_COMMA] = ACTIONS(813),
    [anon_sym_RBRACE] = ACTIONS(1205),
    [anon_sym_type] = ACTIONS(1623),
    [anon_sym_BANG] = ACTIONS(780),
    [anon_sym_LPAREN] = ACTIONS(1217),
    [anon_sym_in] = ACTIONS(780),
    [anon_sym_SEMI] = ACTIONS(813),
    [anon_sym_COLON] = ACTIONS(1220),
    [anon_sym_LBRACK] = ACTIONS(1427),
    [anon_sym_LT] = ACTIONS(1225),
    [anon_sym_GT] = ACTIONS(780),
    [anon_sym_SLASH] = ACTIONS(780),
    [anon_sym_DOT] = ACTIONS(927),
    [anon_sym_async] = ACTIONS(1625),
    [anon_sym_EQ_GT] = ACTIONS(929),
    [anon_sym_QMARK_DOT] = ACTIONS(931),
    [anon_sym_PLUS_EQ] = ACTIONS(803),
    [anon_sym_DASH_EQ] = ACTIONS(803),
    [anon_sym_STAR_EQ] = ACTIONS(803),
    [anon_sym_SLASH_EQ] = ACTIONS(803),
    [anon_sym_PERCENT_EQ] = ACTIONS(803),
    [anon_sym_CARET_EQ] = ACTIONS(803),
    [anon_sym_AMP_EQ] = ACTIONS(803),
    [anon_sym_PIPE_EQ] = ACTIONS(803),
    [anon_sym_GT_GT_EQ] = ACTIONS(803),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(803),
    [anon_sym_LT_LT_EQ] = ACTIONS(803),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(803),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(803),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(803),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(803),
    [anon_sym_QMARK] = ACTIONS(1225),
    [anon_sym_AMP_AMP] = ACTIONS(780),
    [anon_sym_PIPE_PIPE] = ACTIONS(780),
    [anon_sym_GT_GT] = ACTIONS(780),
    [anon_sym_GT_GT_GT] = ACTIONS(780),
    [anon_sym_LT_LT] = ACTIONS(780),
    [anon_sym_AMP] = ACTIONS(780),
    [anon_sym_CARET] = ACTIONS(780),
    [anon_sym_PIPE] = ACTIONS(780),
    [anon_sym_PLUS] = ACTIONS(780),
    [anon_sym_DASH] = ACTIONS(780),
    [anon_sym_PERCENT] = ACTIONS(780),
    [anon_sym_STAR_STAR] = ACTIONS(780),
    [anon_sym_LT_EQ] = ACTIONS(813),
    [anon_sym_EQ_EQ] = ACTIONS(780),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(813),
    [anon_sym_BANG_EQ] = ACTIONS(780),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(813),
    [anon_sym_GT_EQ] = ACTIONS(813),
    [anon_sym_QMARK_QMARK] = ACTIONS(780),
    [anon_sym_instanceof] = ACTIONS(780),
    [anon_sym_PLUS_PLUS] = ACTIONS(813),
    [anon_sym_DASH_DASH] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(817),
    [anon_sym_SQUOTE] = ACTIONS(819),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(813),
    [sym_number] = ACTIONS(1435),
    [anon_sym_static] = ACTIONS(1623),
    [anon_sym_get] = ACTIONS(1627),
    [anon_sym_set] = ACTIONS(1627),
    [anon_sym_declare] = ACTIONS(1623),
    [anon_sym_public] = ACTIONS(1623),
    [anon_sym_private] = ACTIONS(1623),
    [anon_sym_protected] = ACTIONS(1623),
    [anon_sym_module] = ACTIONS(1623),
    [anon_sym_any] = ACTIONS(1623),
    [anon_sym_number] = ACTIONS(1623),
    [anon_sym_boolean] = ACTIONS(1623),
    [anon_sym_string] = ACTIONS(1623),
    [anon_sym_symbol] = ACTIONS(1623),
    [sym_readonly] = ACTIONS(1629),
    [sym__automatic_semicolon] = ACTIONS(813),
  },
  [459] = {
    [sym_string] = STATE(2332),
    [sym__property_name] = STATE(2332),
    [sym_computed_property_name] = STATE(2332),
    [aux_sym_object_repeat1] = STATE(2854),
    [sym_identifier] = ACTIONS(1623),
    [anon_sym_export] = ACTIONS(1623),
    [anon_sym_STAR] = ACTIONS(780),
    [anon_sym_EQ] = ACTIONS(1260),
    [anon_sym_as] = ACTIONS(780),
    [anon_sym_namespace] = ACTIONS(1623),
    [anon_sym_COMMA] = ACTIONS(813),
    [anon_sym_RBRACE] = ACTIONS(1248),
    [anon_sym_type] = ACTIONS(1623),
    [anon_sym_BANG] = ACTIONS(780),
    [anon_sym_LPAREN] = ACTIONS(1217),
    [anon_sym_in] = ACTIONS(780),
    [anon_sym_SEMI] = ACTIONS(813),
    [anon_sym_COLON] = ACTIONS(1220),
    [anon_sym_LBRACK] = ACTIONS(1427),
    [anon_sym_LT] = ACTIONS(1225),
    [anon_sym_GT] = ACTIONS(780),
    [anon_sym_SLASH] = ACTIONS(780),
    [anon_sym_DOT] = ACTIONS(927),
    [anon_sym_async] = ACTIONS(1623),
    [anon_sym_EQ_GT] = ACTIONS(929),
    [anon_sym_QMARK_DOT] = ACTIONS(931),
    [anon_sym_PLUS_EQ] = ACTIONS(803),
    [anon_sym_DASH_EQ] = ACTIONS(803),
    [anon_sym_STAR_EQ] = ACTIONS(803),
    [anon_sym_SLASH_EQ] = ACTIONS(803),
    [anon_sym_PERCENT_EQ] = ACTIONS(803),
    [anon_sym_CARET_EQ] = ACTIONS(803),
    [anon_sym_AMP_EQ] = ACTIONS(803),
    [anon_sym_PIPE_EQ] = ACTIONS(803),
    [anon_sym_GT_GT_EQ] = ACTIONS(803),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(803),
    [anon_sym_LT_LT_EQ] = ACTIONS(803),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(803),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(803),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(803),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(803),
    [anon_sym_QMARK] = ACTIONS(1225),
    [anon_sym_AMP_AMP] = ACTIONS(780),
    [anon_sym_PIPE_PIPE] = ACTIONS(780),
    [anon_sym_GT_GT] = ACTIONS(780),
    [anon_sym_GT_GT_GT] = ACTIONS(780),
    [anon_sym_LT_LT] = ACTIONS(780),
    [anon_sym_AMP] = ACTIONS(780),
    [anon_sym_CARET] = ACTIONS(780),
    [anon_sym_PIPE] = ACTIONS(780),
    [anon_sym_PLUS] = ACTIONS(780),
    [anon_sym_DASH] = ACTIONS(780),
    [anon_sym_PERCENT] = ACTIONS(780),
    [anon_sym_STAR_STAR] = ACTIONS(780),
    [anon_sym_LT_EQ] = ACTIONS(813),
    [anon_sym_EQ_EQ] = ACTIONS(780),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(813),
    [anon_sym_BANG_EQ] = ACTIONS(780),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(813),
    [anon_sym_GT_EQ] = ACTIONS(813),
    [anon_sym_QMARK_QMARK] = ACTIONS(780),
    [anon_sym_instanceof] = ACTIONS(780),
    [anon_sym_PLUS_PLUS] = ACTIONS(813),
    [anon_sym_DASH_DASH] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(817),
    [anon_sym_SQUOTE] = ACTIONS(819),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(813),
    [sym_number] = ACTIONS(1435),
    [anon_sym_static] = ACTIONS(1623),
    [anon_sym_get] = ACTIONS(1623),
    [anon_sym_set] = ACTIONS(1623),
    [anon_sym_declare] = ACTIONS(1623),
    [anon_sym_public] = ACTIONS(1623),
    [anon_sym_private] = ACTIONS(1623),
    [anon_sym_protected] = ACTIONS(1623),
    [anon_sym_module] = ACTIONS(1623),
    [anon_sym_any] = ACTIONS(1623),
    [anon_sym_number] = ACTIONS(1623),
    [anon_sym_boolean] = ACTIONS(1623),
    [anon_sym_string] = ACTIONS(1623),
    [anon_sym_symbol] = ACTIONS(1623),
    [sym_readonly] = ACTIONS(1623),
    [sym__automatic_semicolon] = ACTIONS(813),
  },
  [460] = {
    [sym__call_signature] = STATE(3191),
    [sym_arguments] = STATE(1174),
    [sym_formal_parameters] = STATE(2295),
    [sym_type_arguments] = STATE(1073),
    [sym_type_parameters] = STATE(3054),
    [sym_identifier] = ACTIONS(1631),
    [anon_sym_export] = ACTIONS(1633),
    [anon_sym_STAR] = ACTIONS(1635),
    [anon_sym_EQ] = ACTIONS(961),
    [anon_sym_as] = ACTIONS(1635),
    [anon_sym_namespace] = ACTIONS(1633),
    [anon_sym_COMMA] = ACTIONS(1637),
    [anon_sym_RBRACE] = ACTIONS(1637),
    [anon_sym_type] = ACTIONS(1633),
    [anon_sym_BANG] = ACTIONS(1635),
    [anon_sym_LPAREN] = ACTIONS(1637),
    [anon_sym_RPAREN] = ACTIONS(1637),
    [anon_sym_in] = ACTIONS(1635),
    [anon_sym_COLON] = ACTIONS(1637),
    [anon_sym_LBRACK] = ACTIONS(1639),
    [anon_sym_RBRACK] = ACTIONS(1637),
    [anon_sym_LT] = ACTIONS(1635),
    [anon_sym_GT] = ACTIONS(1635),
    [anon_sym_SLASH] = ACTIONS(1635),
    [anon_sym_DOT] = ACTIONS(1641),
    [anon_sym_async] = ACTIONS(1633),
    [anon_sym_function] = ACTIONS(1643),
    [anon_sym_EQ_GT] = ACTIONS(797),
    [anon_sym_QMARK_DOT] = ACTIONS(799),
    [anon_sym_PLUS_EQ] = ACTIONS(803),
    [anon_sym_DASH_EQ] = ACTIONS(803),
    [anon_sym_STAR_EQ] = ACTIONS(803),
    [anon_sym_SLASH_EQ] = ACTIONS(803),
    [anon_sym_PERCENT_EQ] = ACTIONS(803),
    [anon_sym_CARET_EQ] = ACTIONS(803),
    [anon_sym_AMP_EQ] = ACTIONS(803),
    [anon_sym_PIPE_EQ] = ACTIONS(803),
    [anon_sym_GT_GT_EQ] = ACTIONS(803),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(803),
    [anon_sym_LT_LT_EQ] = ACTIONS(803),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(803),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(803),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(803),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(803),
    [anon_sym_QMARK] = ACTIONS(1635),
    [anon_sym_AMP_AMP] = ACTIONS(1635),
    [anon_sym_PIPE_PIPE] = ACTIONS(1635),
    [anon_sym_GT_GT] = ACTIONS(1635),
    [anon_sym_GT_GT_GT] = ACTIONS(1635),
    [anon_sym_LT_LT] = ACTIONS(1635),
    [anon_sym_AMP] = ACTIONS(1635),
    [anon_sym_CARET] = ACTIONS(1635),
    [anon_sym_PIPE] = ACTIONS(1635),
    [anon_sym_PLUS] = ACTIONS(1635),
    [anon_sym_DASH] = ACTIONS(1635),
    [anon_sym_PERCENT] = ACTIONS(1635),
    [anon_sym_STAR_STAR] = ACTIONS(1635),
    [anon_sym_LT_EQ] = ACTIONS(1637),
    [anon_sym_EQ_EQ] = ACTIONS(1635),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1637),
    [anon_sym_BANG_EQ] = ACTIONS(1635),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1637),
    [anon_sym_GT_EQ] = ACTIONS(1637),
    [anon_sym_QMARK_QMARK] = ACTIONS(1635),
    [anon_sym_instanceof] = ACTIONS(1635),
    [anon_sym_PLUS_PLUS] = ACTIONS(1637),
    [anon_sym_DASH_DASH] = ACTIONS(1637),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1637),
    [anon_sym_static] = ACTIONS(1633),
    [anon_sym_get] = ACTIONS(1633),
    [anon_sym_set] = ACTIONS(1633),
    [anon_sym_declare] = ACTIONS(1633),
    [anon_sym_public] = ACTIONS(1633),
    [anon_sym_private] = ACTIONS(1633),
    [anon_sym_protected] = ACTIONS(1633),
    [anon_sym_module] = ACTIONS(1633),
    [anon_sym_any] = ACTIONS(1633),
    [anon_sym_number] = ACTIONS(1633),
    [anon_sym_boolean] = ACTIONS(1633),
    [anon_sym_string] = ACTIONS(1633),
    [anon_sym_symbol] = ACTIONS(1633),
    [sym_readonly] = ACTIONS(1633),
  },
  [461] = {
    [sym_object] = STATE(2505),
    [sym_array] = STATE(2487),
    [sym_nested_identifier] = STATE(3297),
    [sym_string] = STATE(447),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(3296),
    [sym_rest_parameter] = STATE(2909),
    [sym_nested_type_identifier] = STATE(1957),
    [sym_accessibility_modifier] = STATE(1951),
    [sym_required_parameter] = STATE(2909),
    [sym_optional_parameter] = STATE(2909),
    [sym__parameter_name] = STATE(2186),
    [sym__rest_identifier] = STATE(2734),
    [sym__type] = STATE(2713),
    [sym_constructor_type] = STATE(2713),
    [sym__primary_type] = STATE(431),
    [sym_infer_type] = STATE(2713),
    [sym_conditional_type] = STATE(431),
    [sym_generic_type] = STATE(431),
    [sym_type_query] = STATE(431),
    [sym_index_type_query] = STATE(431),
    [sym_lookup_type] = STATE(431),
    [sym_literal_type] = STATE(431),
    [sym__number] = STATE(447),
    [sym_existential_type] = STATE(431),
    [sym_flow_maybe_type] = STATE(431),
    [sym_parenthesized_type] = STATE(431),
    [sym_predefined_type] = STATE(431),
    [sym_object_type] = STATE(431),
    [sym_type_parameters] = STATE(3048),
    [sym_array_type] = STATE(431),
    [sym__tuple_type_body] = STATE(442),
    [sym_tuple_type] = STATE(431),
    [sym_union_type] = STATE(2713),
    [sym_intersection_type] = STATE(2713),
    [sym_function_type] = STATE(2713),
    [aux_sym_export_statement_repeat1] = STATE(1844),
    [sym_identifier] = ACTIONS(1645),
    [anon_sym_export] = ACTIONS(1647),
    [anon_sym_STAR] = ACTIONS(427),
    [anon_sym_namespace] = ACTIONS(1647),
    [anon_sym_LBRACE] = ACTIONS(1649),
    [anon_sym_type] = ACTIONS(1647),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_LPAREN] = ACTIONS(789),
    [anon_sym_RPAREN] = ACTIONS(441),
    [anon_sym_LBRACK] = ACTIONS(1651),
    [anon_sym_LT] = ACTIONS(1653),
    [anon_sym_async] = ACTIONS(1647),
    [anon_sym_new] = ACTIONS(801),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(459),
    [anon_sym_QMARK] = ACTIONS(461),
    [anon_sym_AMP] = ACTIONS(463),
    [anon_sym_PIPE] = ACTIONS(465),
    [anon_sym_PLUS] = ACTIONS(1655),
    [anon_sym_DASH] = ACTIONS(1655),
    [anon_sym_void] = ACTIONS(815),
    [anon_sym_DQUOTE] = ACTIONS(817),
    [anon_sym_SQUOTE] = ACTIONS(819),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(821),
    [sym_this] = ACTIONS(1657),
    [sym_true] = ACTIONS(825),
    [sym_false] = ACTIONS(825),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1647),
    [anon_sym_get] = ACTIONS(1647),
    [anon_sym_set] = ACTIONS(1647),
    [anon_sym_declare] = ACTIONS(1647),
    [anon_sym_public] = ACTIONS(1659),
    [anon_sym_private] = ACTIONS(1659),
    [anon_sym_protected] = ACTIONS(1659),
    [anon_sym_module] = ACTIONS(1647),
    [anon_sym_any] = ACTIONS(1661),
    [anon_sym_number] = ACTIONS(1661),
    [anon_sym_boolean] = ACTIONS(1661),
    [anon_sym_string] = ACTIONS(1661),
    [anon_sym_symbol] = ACTIONS(1661),
    [sym_readonly] = ACTIONS(1663),
    [anon_sym_infer] = ACTIONS(495),
    [anon_sym_keyof] = ACTIONS(497),
    [anon_sym_LBRACE_PIPE] = ACTIONS(499),
  },
  [462] = {
    [sym__call_signature] = STATE(3284),
    [sym_arguments] = STATE(1581),
    [sym_formal_parameters] = STATE(2295),
    [sym_type_arguments] = STATE(1378),
    [sym_type_parameters] = STATE(3054),
    [sym_identifier] = ACTIONS(1665),
    [anon_sym_export] = ACTIONS(1667),
    [anon_sym_STAR] = ACTIONS(1635),
    [anon_sym_EQ] = ACTIONS(961),
    [anon_sym_as] = ACTIONS(1635),
    [anon_sym_namespace] = ACTIONS(1667),
    [anon_sym_COMMA] = ACTIONS(1637),
    [anon_sym_RBRACE] = ACTIONS(1637),
    [anon_sym_type] = ACTIONS(1667),
    [anon_sym_BANG] = ACTIONS(1635),
    [anon_sym_LPAREN] = ACTIONS(1637),
    [anon_sym_in] = ACTIONS(1635),
    [anon_sym_SEMI] = ACTIONS(1637),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_LT] = ACTIONS(1635),
    [anon_sym_GT] = ACTIONS(1635),
    [anon_sym_SLASH] = ACTIONS(1635),
    [anon_sym_DOT] = ACTIONS(1228),
    [anon_sym_async] = ACTIONS(1667),
    [anon_sym_function] = ACTIONS(1669),
    [anon_sym_EQ_GT] = ACTIONS(929),
    [anon_sym_QMARK_DOT] = ACTIONS(931),
    [anon_sym_PLUS_EQ] = ACTIONS(803),
    [anon_sym_DASH_EQ] = ACTIONS(803),
    [anon_sym_STAR_EQ] = ACTIONS(803),
    [anon_sym_SLASH_EQ] = ACTIONS(803),
    [anon_sym_PERCENT_EQ] = ACTIONS(803),
    [anon_sym_CARET_EQ] = ACTIONS(803),
    [anon_sym_AMP_EQ] = ACTIONS(803),
    [anon_sym_PIPE_EQ] = ACTIONS(803),
    [anon_sym_GT_GT_EQ] = ACTIONS(803),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(803),
    [anon_sym_LT_LT_EQ] = ACTIONS(803),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(803),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(803),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(803),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(803),
    [anon_sym_QMARK] = ACTIONS(1635),
    [anon_sym_AMP_AMP] = ACTIONS(1635),
    [anon_sym_PIPE_PIPE] = ACTIONS(1635),
    [anon_sym_GT_GT] = ACTIONS(1635),
    [anon_sym_GT_GT_GT] = ACTIONS(1635),
    [anon_sym_LT_LT] = ACTIONS(1635),
    [anon_sym_AMP] = ACTIONS(1635),
    [anon_sym_CARET] = ACTIONS(1635),
    [anon_sym_PIPE] = ACTIONS(1635),
    [anon_sym_PLUS] = ACTIONS(1635),
    [anon_sym_DASH] = ACTIONS(1635),
    [anon_sym_PERCENT] = ACTIONS(1635),
    [anon_sym_STAR_STAR] = ACTIONS(1635),
    [anon_sym_LT_EQ] = ACTIONS(1637),
    [anon_sym_EQ_EQ] = ACTIONS(1635),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1637),
    [anon_sym_BANG_EQ] = ACTIONS(1635),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1637),
    [anon_sym_GT_EQ] = ACTIONS(1637),
    [anon_sym_QMARK_QMARK] = ACTIONS(1635),
    [anon_sym_instanceof] = ACTIONS(1635),
    [anon_sym_PLUS_PLUS] = ACTIONS(1637),
    [anon_sym_DASH_DASH] = ACTIONS(1637),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1637),
    [anon_sym_static] = ACTIONS(1667),
    [anon_sym_get] = ACTIONS(1667),
    [anon_sym_set] = ACTIONS(1667),
    [anon_sym_declare] = ACTIONS(1667),
    [anon_sym_public] = ACTIONS(1667),
    [anon_sym_private] = ACTIONS(1667),
    [anon_sym_protected] = ACTIONS(1667),
    [anon_sym_module] = ACTIONS(1667),
    [anon_sym_any] = ACTIONS(1667),
    [anon_sym_number] = ACTIONS(1667),
    [anon_sym_boolean] = ACTIONS(1667),
    [anon_sym_string] = ACTIONS(1667),
    [anon_sym_symbol] = ACTIONS(1667),
    [sym_readonly] = ACTIONS(1667),
    [sym__automatic_semicolon] = ACTIONS(1637),
  },
  [463] = {
    [sym_object] = STATE(2505),
    [sym_array] = STATE(2487),
    [sym_nested_identifier] = STATE(3297),
    [sym_string] = STATE(447),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(3296),
    [sym_rest_parameter] = STATE(2909),
    [sym_nested_type_identifier] = STATE(1957),
    [sym_accessibility_modifier] = STATE(1951),
    [sym_required_parameter] = STATE(2909),
    [sym_optional_parameter] = STATE(2909),
    [sym__parameter_name] = STATE(2186),
    [sym__rest_identifier] = STATE(2734),
    [sym__type] = STATE(2666),
    [sym_constructor_type] = STATE(2666),
    [sym__primary_type] = STATE(431),
    [sym_infer_type] = STATE(2666),
    [sym_conditional_type] = STATE(431),
    [sym_generic_type] = STATE(431),
    [sym_type_query] = STATE(431),
    [sym_index_type_query] = STATE(431),
    [sym_lookup_type] = STATE(431),
    [sym_literal_type] = STATE(431),
    [sym__number] = STATE(447),
    [sym_existential_type] = STATE(431),
    [sym_flow_maybe_type] = STATE(431),
    [sym_parenthesized_type] = STATE(431),
    [sym_predefined_type] = STATE(431),
    [sym_object_type] = STATE(431),
    [sym_type_parameters] = STATE(3048),
    [sym_array_type] = STATE(431),
    [sym__tuple_type_body] = STATE(442),
    [sym_tuple_type] = STATE(431),
    [sym_union_type] = STATE(2666),
    [sym_intersection_type] = STATE(2666),
    [sym_function_type] = STATE(2666),
    [aux_sym_export_statement_repeat1] = STATE(1844),
    [sym_identifier] = ACTIONS(1645),
    [anon_sym_export] = ACTIONS(1647),
    [anon_sym_STAR] = ACTIONS(427),
    [anon_sym_namespace] = ACTIONS(1647),
    [anon_sym_LBRACE] = ACTIONS(1649),
    [anon_sym_type] = ACTIONS(1647),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_LPAREN] = ACTIONS(789),
    [anon_sym_RPAREN] = ACTIONS(441),
    [anon_sym_LBRACK] = ACTIONS(1651),
    [anon_sym_LT] = ACTIONS(1653),
    [anon_sym_async] = ACTIONS(1647),
    [anon_sym_new] = ACTIONS(801),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(459),
    [anon_sym_QMARK] = ACTIONS(461),
    [anon_sym_AMP] = ACTIONS(463),
    [anon_sym_PIPE] = ACTIONS(465),
    [anon_sym_PLUS] = ACTIONS(1655),
    [anon_sym_DASH] = ACTIONS(1655),
    [anon_sym_void] = ACTIONS(815),
    [anon_sym_DQUOTE] = ACTIONS(817),
    [anon_sym_SQUOTE] = ACTIONS(819),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(821),
    [sym_this] = ACTIONS(1657),
    [sym_true] = ACTIONS(825),
    [sym_false] = ACTIONS(825),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1647),
    [anon_sym_get] = ACTIONS(1647),
    [anon_sym_set] = ACTIONS(1647),
    [anon_sym_declare] = ACTIONS(1647),
    [anon_sym_public] = ACTIONS(1659),
    [anon_sym_private] = ACTIONS(1659),
    [anon_sym_protected] = ACTIONS(1659),
    [anon_sym_module] = ACTIONS(1647),
    [anon_sym_any] = ACTIONS(1661),
    [anon_sym_number] = ACTIONS(1661),
    [anon_sym_boolean] = ACTIONS(1661),
    [anon_sym_string] = ACTIONS(1661),
    [anon_sym_symbol] = ACTIONS(1661),
    [sym_readonly] = ACTIONS(1663),
    [anon_sym_infer] = ACTIONS(495),
    [anon_sym_keyof] = ACTIONS(497),
    [anon_sym_LBRACE_PIPE] = ACTIONS(499),
  },
  [464] = {
    [sym_object] = STATE(2505),
    [sym_array] = STATE(2487),
    [sym_nested_identifier] = STATE(3297),
    [sym_string] = STATE(447),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(3296),
    [sym_rest_parameter] = STATE(2909),
    [sym_nested_type_identifier] = STATE(1957),
    [sym_accessibility_modifier] = STATE(1951),
    [sym_required_parameter] = STATE(2909),
    [sym_optional_parameter] = STATE(2909),
    [sym__parameter_name] = STATE(2186),
    [sym__rest_identifier] = STATE(2734),
    [sym__type] = STATE(2720),
    [sym_constructor_type] = STATE(2720),
    [sym__primary_type] = STATE(431),
    [sym_infer_type] = STATE(2720),
    [sym_conditional_type] = STATE(431),
    [sym_generic_type] = STATE(431),
    [sym_type_query] = STATE(431),
    [sym_index_type_query] = STATE(431),
    [sym_lookup_type] = STATE(431),
    [sym_literal_type] = STATE(431),
    [sym__number] = STATE(447),
    [sym_existential_type] = STATE(431),
    [sym_flow_maybe_type] = STATE(431),
    [sym_parenthesized_type] = STATE(431),
    [sym_predefined_type] = STATE(431),
    [sym_object_type] = STATE(431),
    [sym_type_parameters] = STATE(3048),
    [sym_array_type] = STATE(431),
    [sym__tuple_type_body] = STATE(442),
    [sym_tuple_type] = STATE(431),
    [sym_union_type] = STATE(2720),
    [sym_intersection_type] = STATE(2720),
    [sym_function_type] = STATE(2720),
    [aux_sym_export_statement_repeat1] = STATE(1844),
    [sym_identifier] = ACTIONS(1645),
    [anon_sym_export] = ACTIONS(1647),
    [anon_sym_STAR] = ACTIONS(427),
    [anon_sym_namespace] = ACTIONS(1647),
    [anon_sym_LBRACE] = ACTIONS(1649),
    [anon_sym_type] = ACTIONS(1647),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_LPAREN] = ACTIONS(789),
    [anon_sym_RPAREN] = ACTIONS(441),
    [anon_sym_LBRACK] = ACTIONS(1651),
    [anon_sym_LT] = ACTIONS(1653),
    [anon_sym_async] = ACTIONS(1647),
    [anon_sym_new] = ACTIONS(801),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(459),
    [anon_sym_QMARK] = ACTIONS(461),
    [anon_sym_AMP] = ACTIONS(463),
    [anon_sym_PIPE] = ACTIONS(465),
    [anon_sym_PLUS] = ACTIONS(1655),
    [anon_sym_DASH] = ACTIONS(1655),
    [anon_sym_void] = ACTIONS(815),
    [anon_sym_DQUOTE] = ACTIONS(817),
    [anon_sym_SQUOTE] = ACTIONS(819),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(821),
    [sym_this] = ACTIONS(1657),
    [sym_true] = ACTIONS(825),
    [sym_false] = ACTIONS(825),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1647),
    [anon_sym_get] = ACTIONS(1647),
    [anon_sym_set] = ACTIONS(1647),
    [anon_sym_declare] = ACTIONS(1647),
    [anon_sym_public] = ACTIONS(1659),
    [anon_sym_private] = ACTIONS(1659),
    [anon_sym_protected] = ACTIONS(1659),
    [anon_sym_module] = ACTIONS(1647),
    [anon_sym_any] = ACTIONS(1661),
    [anon_sym_number] = ACTIONS(1661),
    [anon_sym_boolean] = ACTIONS(1661),
    [anon_sym_string] = ACTIONS(1661),
    [anon_sym_symbol] = ACTIONS(1661),
    [sym_readonly] = ACTIONS(1663),
    [anon_sym_infer] = ACTIONS(495),
    [anon_sym_keyof] = ACTIONS(497),
    [anon_sym_LBRACE_PIPE] = ACTIONS(499),
  },
  [465] = {
    [sym_object] = STATE(2505),
    [sym_array] = STATE(2487),
    [sym_nested_identifier] = STATE(3297),
    [sym_string] = STATE(447),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(3296),
    [sym_rest_parameter] = STATE(2909),
    [sym_nested_type_identifier] = STATE(1957),
    [sym_accessibility_modifier] = STATE(1951),
    [sym_required_parameter] = STATE(2909),
    [sym_optional_parameter] = STATE(2909),
    [sym__parameter_name] = STATE(2186),
    [sym__rest_identifier] = STATE(2734),
    [sym__type] = STATE(2680),
    [sym_constructor_type] = STATE(2680),
    [sym__primary_type] = STATE(431),
    [sym_infer_type] = STATE(2680),
    [sym_conditional_type] = STATE(431),
    [sym_generic_type] = STATE(431),
    [sym_type_query] = STATE(431),
    [sym_index_type_query] = STATE(431),
    [sym_lookup_type] = STATE(431),
    [sym_literal_type] = STATE(431),
    [sym__number] = STATE(447),
    [sym_existential_type] = STATE(431),
    [sym_flow_maybe_type] = STATE(431),
    [sym_parenthesized_type] = STATE(431),
    [sym_predefined_type] = STATE(431),
    [sym_object_type] = STATE(431),
    [sym_type_parameters] = STATE(3048),
    [sym_array_type] = STATE(431),
    [sym__tuple_type_body] = STATE(442),
    [sym_tuple_type] = STATE(431),
    [sym_union_type] = STATE(2680),
    [sym_intersection_type] = STATE(2680),
    [sym_function_type] = STATE(2680),
    [aux_sym_export_statement_repeat1] = STATE(1844),
    [sym_identifier] = ACTIONS(1645),
    [anon_sym_export] = ACTIONS(1647),
    [anon_sym_STAR] = ACTIONS(427),
    [anon_sym_namespace] = ACTIONS(1647),
    [anon_sym_LBRACE] = ACTIONS(1649),
    [anon_sym_type] = ACTIONS(1647),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_LPAREN] = ACTIONS(789),
    [anon_sym_RPAREN] = ACTIONS(441),
    [anon_sym_LBRACK] = ACTIONS(1651),
    [anon_sym_LT] = ACTIONS(1653),
    [anon_sym_async] = ACTIONS(1647),
    [anon_sym_new] = ACTIONS(801),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(459),
    [anon_sym_QMARK] = ACTIONS(461),
    [anon_sym_AMP] = ACTIONS(463),
    [anon_sym_PIPE] = ACTIONS(465),
    [anon_sym_PLUS] = ACTIONS(1655),
    [anon_sym_DASH] = ACTIONS(1655),
    [anon_sym_void] = ACTIONS(815),
    [anon_sym_DQUOTE] = ACTIONS(817),
    [anon_sym_SQUOTE] = ACTIONS(819),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(821),
    [sym_this] = ACTIONS(1657),
    [sym_true] = ACTIONS(825),
    [sym_false] = ACTIONS(825),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1647),
    [anon_sym_get] = ACTIONS(1647),
    [anon_sym_set] = ACTIONS(1647),
    [anon_sym_declare] = ACTIONS(1647),
    [anon_sym_public] = ACTIONS(1659),
    [anon_sym_private] = ACTIONS(1659),
    [anon_sym_protected] = ACTIONS(1659),
    [anon_sym_module] = ACTIONS(1647),
    [anon_sym_any] = ACTIONS(1661),
    [anon_sym_number] = ACTIONS(1661),
    [anon_sym_boolean] = ACTIONS(1661),
    [anon_sym_string] = ACTIONS(1661),
    [anon_sym_symbol] = ACTIONS(1661),
    [sym_readonly] = ACTIONS(1663),
    [anon_sym_infer] = ACTIONS(495),
    [anon_sym_keyof] = ACTIONS(497),
    [anon_sym_LBRACE_PIPE] = ACTIONS(499),
  },
  [466] = {
    [sym_object] = STATE(2505),
    [sym_array] = STATE(2487),
    [sym_nested_identifier] = STATE(3297),
    [sym_string] = STATE(447),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(3296),
    [sym_rest_parameter] = STATE(2909),
    [sym_nested_type_identifier] = STATE(1957),
    [sym_accessibility_modifier] = STATE(1951),
    [sym_required_parameter] = STATE(2909),
    [sym_optional_parameter] = STATE(2909),
    [sym__parameter_name] = STATE(2186),
    [sym__rest_identifier] = STATE(2734),
    [sym__type] = STATE(2691),
    [sym_constructor_type] = STATE(2691),
    [sym__primary_type] = STATE(431),
    [sym_infer_type] = STATE(2691),
    [sym_conditional_type] = STATE(431),
    [sym_generic_type] = STATE(431),
    [sym_type_query] = STATE(431),
    [sym_index_type_query] = STATE(431),
    [sym_lookup_type] = STATE(431),
    [sym_literal_type] = STATE(431),
    [sym__number] = STATE(447),
    [sym_existential_type] = STATE(431),
    [sym_flow_maybe_type] = STATE(431),
    [sym_parenthesized_type] = STATE(431),
    [sym_predefined_type] = STATE(431),
    [sym_object_type] = STATE(431),
    [sym_type_parameters] = STATE(3048),
    [sym_array_type] = STATE(431),
    [sym__tuple_type_body] = STATE(442),
    [sym_tuple_type] = STATE(431),
    [sym_union_type] = STATE(2691),
    [sym_intersection_type] = STATE(2691),
    [sym_function_type] = STATE(2691),
    [aux_sym_export_statement_repeat1] = STATE(1844),
    [sym_identifier] = ACTIONS(1645),
    [anon_sym_export] = ACTIONS(1647),
    [anon_sym_STAR] = ACTIONS(427),
    [anon_sym_namespace] = ACTIONS(1647),
    [anon_sym_LBRACE] = ACTIONS(1649),
    [anon_sym_type] = ACTIONS(1647),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_LPAREN] = ACTIONS(789),
    [anon_sym_RPAREN] = ACTIONS(441),
    [anon_sym_LBRACK] = ACTIONS(1651),
    [anon_sym_LT] = ACTIONS(1653),
    [anon_sym_async] = ACTIONS(1647),
    [anon_sym_new] = ACTIONS(801),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(459),
    [anon_sym_QMARK] = ACTIONS(461),
    [anon_sym_AMP] = ACTIONS(463),
    [anon_sym_PIPE] = ACTIONS(465),
    [anon_sym_PLUS] = ACTIONS(1655),
    [anon_sym_DASH] = ACTIONS(1655),
    [anon_sym_void] = ACTIONS(815),
    [anon_sym_DQUOTE] = ACTIONS(817),
    [anon_sym_SQUOTE] = ACTIONS(819),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(821),
    [sym_this] = ACTIONS(1657),
    [sym_true] = ACTIONS(825),
    [sym_false] = ACTIONS(825),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1647),
    [anon_sym_get] = ACTIONS(1647),
    [anon_sym_set] = ACTIONS(1647),
    [anon_sym_declare] = ACTIONS(1647),
    [anon_sym_public] = ACTIONS(1659),
    [anon_sym_private] = ACTIONS(1659),
    [anon_sym_protected] = ACTIONS(1659),
    [anon_sym_module] = ACTIONS(1647),
    [anon_sym_any] = ACTIONS(1661),
    [anon_sym_number] = ACTIONS(1661),
    [anon_sym_boolean] = ACTIONS(1661),
    [anon_sym_string] = ACTIONS(1661),
    [anon_sym_symbol] = ACTIONS(1661),
    [sym_readonly] = ACTIONS(1663),
    [anon_sym_infer] = ACTIONS(495),
    [anon_sym_keyof] = ACTIONS(497),
    [anon_sym_LBRACE_PIPE] = ACTIONS(499),
  },
  [467] = {
    [sym_object] = STATE(2505),
    [sym_array] = STATE(2487),
    [sym_nested_identifier] = STATE(3297),
    [sym_string] = STATE(447),
    [sym_decorator] = STATE(1945),
    [sym_formal_parameters] = STATE(3296),
    [sym_rest_parameter] = STATE(2909),
    [sym_nested_type_identifier] = STATE(1957),
    [sym_accessibility_modifier] = STATE(1951),
    [sym_required_parameter] = STATE(2909),
    [sym_optional_parameter] = STATE(2909),
    [sym__parameter_name] = STATE(2186),
    [sym__rest_identifier] = STATE(2734),
    [sym__type] = STATE(2649),
    [sym_constructor_type] = STATE(2649),
    [sym__primary_type] = STATE(431),
    [sym_infer_type] = STATE(2649),
    [sym_conditional_type] = STATE(431),
    [sym_generic_type] = STATE(431),
    [sym_type_query] = STATE(431),
    [sym_index_type_query] = STATE(431),
    [sym_lookup_type] = STATE(431),
    [sym_literal_type] = STATE(431),
    [sym__number] = STATE(447),
    [sym_existential_type] = STATE(431),
    [sym_flow_maybe_type] = STATE(431),
    [sym_parenthesized_type] = STATE(431),
    [sym_predefined_type] = STATE(431),
    [sym_object_type] = STATE(431),
    [sym_type_parameters] = STATE(3048),
    [sym_array_type] = STATE(431),
    [sym__tuple_type_body] = STATE(442),
    [sym_tuple_type] = STATE(431),
    [sym_union_type] = STATE(2649),
    [sym_intersection_type] = STATE(2649),
    [sym_function_type] = STATE(2649),
    [aux_sym_export_statement_repeat1] = STATE(1844),
    [sym_identifier] = ACTIONS(1645),
    [anon_sym_export] = ACTIONS(1647),
    [anon_sym_STAR] = ACTIONS(427),
    [anon_sym_namespace] = ACTIONS(1647),
    [anon_sym_LBRACE] = ACTIONS(1649),
    [anon_sym_type] = ACTIONS(1647),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_LPAREN] = ACTIONS(789),
    [anon_sym_RPAREN] = ACTIONS(441),
    [anon_sym_LBRACK] = ACTIONS(1651),
    [anon_sym_LT] = ACTIONS(1653),
    [anon_sym_async] = ACTIONS(1647),
    [anon_sym_new] = ACTIONS(801),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(459),
    [anon_sym_QMARK] = ACTIONS(461),
    [anon_sym_AMP] = ACTIONS(463),
    [anon_sym_PIPE] = ACTIONS(465),
    [anon_sym_PLUS] = ACTIONS(1655),
    [anon_sym_DASH] = ACTIONS(1655),
    [anon_sym_void] = ACTIONS(815),
    [anon_sym_DQUOTE] = ACTIONS(817),
    [anon_sym_SQUOTE] = ACTIONS(819),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(821),
    [sym_this] = ACTIONS(1657),
    [sym_true] = ACTIONS(825),
    [sym_false] = ACTIONS(825),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1647),
    [anon_sym_get] = ACTIONS(1647),
    [anon_sym_set] = ACTIONS(1647),
    [anon_sym_declare] = ACTIONS(1647),
    [anon_sym_public] = ACTIONS(1659),
    [anon_sym_private] = ACTIONS(1659),
    [anon_sym_protected] = ACTIONS(1659),
    [anon_sym_module] = ACTIONS(1647),
    [anon_sym_any] = ACTIONS(1661),
    [anon_sym_number] = ACTIONS(1661),
    [anon_sym_boolean] = ACTIONS(1661),
    [anon_sym_string] = ACTIONS(1661),
    [anon_sym_symbol] = ACTIONS(1661),
    [sym_readonly] = ACTIONS(1663),
    [anon_sym_infer] = ACTIONS(495),
    [anon_sym_keyof] = ACTIONS(497),
    [anon_sym_LBRACE_PIPE] = ACTIONS(499),
  },
  [468] = {
    [aux_sym_object_repeat1] = STATE(2854),
    [sym_identifier] = ACTIONS(1671),
    [anon_sym_export] = ACTIONS(1671),
    [anon_sym_STAR] = ACTIONS(1671),
    [anon_sym_EQ] = ACTIONS(1260),
    [anon_sym_as] = ACTIONS(780),
    [anon_sym_namespace] = ACTIONS(1671),
    [anon_sym_COMMA] = ACTIONS(813),
    [anon_sym_RBRACE] = ACTIONS(1248),
    [anon_sym_type] = ACTIONS(1671),
    [anon_sym_BANG] = ACTIONS(780),
    [anon_sym_LPAREN] = ACTIONS(1217),
    [anon_sym_in] = ACTIONS(780),
    [anon_sym_SEMI] = ACTIONS(813),
    [anon_sym_COLON] = ACTIONS(1220),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_LT] = ACTIONS(1225),
    [anon_sym_GT] = ACTIONS(780),
    [anon_sym_SLASH] = ACTIONS(780),
    [anon_sym_DOT] = ACTIONS(927),
    [anon_sym_async] = ACTIONS(1671),
    [anon_sym_EQ_GT] = ACTIONS(929),
    [anon_sym_QMARK_DOT] = ACTIONS(931),
    [anon_sym_PLUS_EQ] = ACTIONS(803),
    [anon_sym_DASH_EQ] = ACTIONS(803),
    [anon_sym_STAR_EQ] = ACTIONS(803),
    [anon_sym_SLASH_EQ] = ACTIONS(803),
    [anon_sym_PERCENT_EQ] = ACTIONS(803),
    [anon_sym_CARET_EQ] = ACTIONS(803),
    [anon_sym_AMP_EQ] = ACTIONS(803),
    [anon_sym_PIPE_EQ] = ACTIONS(803),
    [anon_sym_GT_GT_EQ] = ACTIONS(803),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(803),
    [anon_sym_LT_LT_EQ] = ACTIONS(803),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(803),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(803),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(803),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(803),
    [anon_sym_QMARK] = ACTIONS(1225),
    [anon_sym_AMP_AMP] = ACTIONS(780),
    [anon_sym_PIPE_PIPE] = ACTIONS(780),
    [anon_sym_GT_GT] = ACTIONS(780),
    [anon_sym_GT_GT_GT] = ACTIONS(780),
    [anon_sym_LT_LT] = ACTIONS(780),
    [anon_sym_AMP] = ACTIONS(780),
    [anon_sym_CARET] = ACTIONS(780),
    [anon_sym_PIPE] = ACTIONS(780),
    [anon_sym_PLUS] = ACTIONS(780),
    [anon_sym_DASH] = ACTIONS(780),
    [anon_sym_PERCENT] = ACTIONS(780),
    [anon_sym_STAR_STAR] = ACTIONS(780),
    [anon_sym_LT_EQ] = ACTIONS(813),
    [anon_sym_EQ_EQ] = ACTIONS(780),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(813),
    [anon_sym_BANG_EQ] = ACTIONS(780),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(813),
    [anon_sym_GT_EQ] = ACTIONS(813),
    [anon_sym_QMARK_QMARK] = ACTIONS(780),
    [anon_sym_instanceof] = ACTIONS(780),
    [anon_sym_PLUS_PLUS] = ACTIONS(813),
    [anon_sym_DASH_DASH] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_SQUOTE] = ACTIONS(1673),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(813),
    [sym_number] = ACTIONS(1673),
    [anon_sym_static] = ACTIONS(1671),
    [anon_sym_get] = ACTIONS(1671),
    [anon_sym_set] = ACTIONS(1671),
    [anon_sym_declare] = ACTIONS(1671),
    [anon_sym_public] = ACTIONS(1671),
    [anon_sym_private] = ACTIONS(1671),
    [anon_sym_protected] = ACTIONS(1671),
    [anon_sym_module] = ACTIONS(1671),
    [anon_sym_any] = ACTIONS(1671),
    [anon_sym_number] = ACTIONS(1671),
    [anon_sym_boolean] = ACTIONS(1671),
    [anon_sym_string] = ACTIONS(1671),
    [anon_sym_symbol] = ACTIONS(1671),
    [sym_readonly] = ACTIONS(1671),
    [sym__automatic_semicolon] = ACTIONS(813),
  },
  [469] = {
    [aux_sym_object_repeat1] = STATE(2894),
    [sym_identifier] = ACTIONS(1671),
    [anon_sym_export] = ACTIONS(1671),
    [anon_sym_STAR] = ACTIONS(1671),
    [anon_sym_EQ] = ACTIONS(1260),
    [anon_sym_as] = ACTIONS(780),
    [anon_sym_namespace] = ACTIONS(1671),
    [anon_sym_COMMA] = ACTIONS(813),
    [anon_sym_RBRACE] = ACTIONS(1205),
    [anon_sym_type] = ACTIONS(1671),
    [anon_sym_BANG] = ACTIONS(780),
    [anon_sym_LPAREN] = ACTIONS(1217),
    [anon_sym_in] = ACTIONS(780),
    [anon_sym_SEMI] = ACTIONS(813),
    [anon_sym_COLON] = ACTIONS(1220),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_LT] = ACTIONS(1225),
    [anon_sym_GT] = ACTIONS(780),
    [anon_sym_SLASH] = ACTIONS(780),
    [anon_sym_DOT] = ACTIONS(927),
    [anon_sym_async] = ACTIONS(1671),
    [anon_sym_EQ_GT] = ACTIONS(929),
    [anon_sym_QMARK_DOT] = ACTIONS(931),
    [anon_sym_PLUS_EQ] = ACTIONS(803),
    [anon_sym_DASH_EQ] = ACTIONS(803),
    [anon_sym_STAR_EQ] = ACTIONS(803),
    [anon_sym_SLASH_EQ] = ACTIONS(803),
    [anon_sym_PERCENT_EQ] = ACTIONS(803),
    [anon_sym_CARET_EQ] = ACTIONS(803),
    [anon_sym_AMP_EQ] = ACTIONS(803),
    [anon_sym_PIPE_EQ] = ACTIONS(803),
    [anon_sym_GT_GT_EQ] = ACTIONS(803),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(803),
    [anon_sym_LT_LT_EQ] = ACTIONS(803),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(803),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(803),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(803),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(803),
    [anon_sym_QMARK] = ACTIONS(1225),
    [anon_sym_AMP_AMP] = ACTIONS(780),
    [anon_sym_PIPE_PIPE] = ACTIONS(780),
    [anon_sym_GT_GT] = ACTIONS(780),
    [anon_sym_GT_GT_GT] = ACTIONS(780),
    [anon_sym_LT_LT] = ACTIONS(780),
    [anon_sym_AMP] = ACTIONS(780),
    [anon_sym_CARET] = ACTIONS(780),
    [anon_sym_PIPE] = ACTIONS(780),
    [anon_sym_PLUS] = ACTIONS(780),
    [anon_sym_DASH] = ACTIONS(780),
    [anon_sym_PERCENT] = ACTIONS(780),
    [anon_sym_STAR_STAR] = ACTIONS(780),
    [anon_sym_LT_EQ] = ACTIONS(813),
    [anon_sym_EQ_EQ] = ACTIONS(780),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(813),
    [anon_sym_BANG_EQ] = ACTIONS(780),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(813),
    [anon_sym_GT_EQ] = ACTIONS(813),
    [anon_sym_QMARK_QMARK] = ACTIONS(780),
    [anon_sym_instanceof] = ACTIONS(780),
    [anon_sym_PLUS_PLUS] = ACTIONS(813),
    [anon_sym_DASH_DASH] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_SQUOTE] = ACTIONS(1673),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(813),
    [sym_number] = ACTIONS(1673),
    [anon_sym_static] = ACTIONS(1671),
    [anon_sym_get] = ACTIONS(1671),
    [anon_sym_set] = ACTIONS(1671),
    [anon_sym_declare] = ACTIONS(1671),
    [anon_sym_public] = ACTIONS(1671),
    [anon_sym_private] = ACTIONS(1671),
    [anon_sym_protected] = ACTIONS(1671),
    [anon_sym_module] = ACTIONS(1671),
    [anon_sym_any] = ACTIONS(1671),
    [anon_sym_number] = ACTIONS(1671),
    [anon_sym_boolean] = ACTIONS(1671),
    [anon_sym_string] = ACTIONS(1671),
    [anon_sym_symbol] = ACTIONS(1671),
    [sym_readonly] = ACTIONS(1671),
    [sym__automatic_semicolon] = ACTIONS(813),
  },
  [470] = {
    [sym__call_signature] = STATE(3352),
    [sym_arguments] = STATE(1174),
    [sym_formal_parameters] = STATE(2295),
    [sym_type_arguments] = STATE(1073),
    [sym_type_parameters] = STATE(3054),
    [sym_identifier] = ACTIONS(1675),
    [anon_sym_export] = ACTIONS(1677),
    [anon_sym_STAR] = ACTIONS(1635),
    [anon_sym_EQ] = ACTIONS(961),
    [anon_sym_as] = ACTIONS(1635),
    [anon_sym_namespace] = ACTIONS(1677),
    [anon_sym_LBRACE] = ACTIONS(1637),
    [anon_sym_COMMA] = ACTIONS(1637),
    [anon_sym_type] = ACTIONS(1677),
    [anon_sym_BANG] = ACTIONS(1635),
    [anon_sym_LPAREN] = ACTIONS(1637),
    [anon_sym_in] = ACTIONS(1635),
    [anon_sym_LBRACK] = ACTIONS(1639),
    [anon_sym_LT] = ACTIONS(1635),
    [anon_sym_GT] = ACTIONS(1635),
    [anon_sym_SLASH] = ACTIONS(1635),
    [anon_sym_DOT] = ACTIONS(1641),
    [anon_sym_async] = ACTIONS(1677),
    [anon_sym_function] = ACTIONS(1643),
    [anon_sym_EQ_GT] = ACTIONS(1085),
    [anon_sym_QMARK_DOT] = ACTIONS(799),
    [anon_sym_PLUS_EQ] = ACTIONS(803),
    [anon_sym_DASH_EQ] = ACTIONS(803),
    [anon_sym_STAR_EQ] = ACTIONS(803),
    [anon_sym_SLASH_EQ] = ACTIONS(803),
    [anon_sym_PERCENT_EQ] = ACTIONS(803),
    [anon_sym_CARET_EQ] = ACTIONS(803),
    [anon_sym_AMP_EQ] = ACTIONS(803),
    [anon_sym_PIPE_EQ] = ACTIONS(803),
    [anon_sym_GT_GT_EQ] = ACTIONS(803),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(803),
    [anon_sym_LT_LT_EQ] = ACTIONS(803),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(803),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(803),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(803),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(803),
    [anon_sym_QMARK] = ACTIONS(1635),
    [anon_sym_AMP_AMP] = ACTIONS(1635),
    [anon_sym_PIPE_PIPE] = ACTIONS(1635),
    [anon_sym_GT_GT] = ACTIONS(1635),
    [anon_sym_GT_GT_GT] = ACTIONS(1635),
    [anon_sym_LT_LT] = ACTIONS(1635),
    [anon_sym_AMP] = ACTIONS(1635),
    [anon_sym_CARET] = ACTIONS(1635),
    [anon_sym_PIPE] = ACTIONS(1635),
    [anon_sym_PLUS] = ACTIONS(1635),
    [anon_sym_DASH] = ACTIONS(1635),
    [anon_sym_PERCENT] = ACTIONS(1635),
    [anon_sym_STAR_STAR] = ACTIONS(1635),
    [anon_sym_LT_EQ] = ACTIONS(1637),
    [anon_sym_EQ_EQ] = ACTIONS(1635),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1637),
    [anon_sym_BANG_EQ] = ACTIONS(1635),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1637),
    [anon_sym_GT_EQ] = ACTIONS(1637),
    [anon_sym_QMARK_QMARK] = ACTIONS(1635),
    [anon_sym_instanceof] = ACTIONS(1635),
    [anon_sym_PLUS_PLUS] = ACTIONS(1637),
    [anon_sym_DASH_DASH] = ACTIONS(1637),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1637),
    [anon_sym_static] = ACTIONS(1677),
    [anon_sym_get] = ACTIONS(1677),
    [anon_sym_set] = ACTIONS(1677),
    [anon_sym_declare] = ACTIONS(1677),
    [anon_sym_public] = ACTIONS(1677),
    [anon_sym_private] = ACTIONS(1677),
    [anon_sym_protected] = ACTIONS(1677),
    [anon_sym_module] = ACTIONS(1677),
    [anon_sym_any] = ACTIONS(1677),
    [anon_sym_number] = ACTIONS(1677),
    [anon_sym_boolean] = ACTIONS(1677),
    [anon_sym_string] = ACTIONS(1677),
    [anon_sym_symbol] = ACTIONS(1677),
    [anon_sym_implements] = ACTIONS(1635),
    [sym_readonly] = ACTIONS(1677),
  },
  [471] = {
    [aux_sym_object_repeat1] = STATE(2868),
    [sym_identifier] = ACTIONS(1671),
    [anon_sym_export] = ACTIONS(1671),
    [anon_sym_STAR] = ACTIONS(1671),
    [anon_sym_EQ] = ACTIONS(1260),
    [anon_sym_as] = ACTIONS(780),
    [anon_sym_namespace] = ACTIONS(1671),
    [anon_sym_COMMA] = ACTIONS(813),
    [anon_sym_RBRACE] = ACTIONS(1246),
    [anon_sym_type] = ACTIONS(1671),
    [anon_sym_BANG] = ACTIONS(780),
    [anon_sym_LPAREN] = ACTIONS(1217),
    [anon_sym_in] = ACTIONS(780),
    [anon_sym_SEMI] = ACTIONS(813),
    [anon_sym_COLON] = ACTIONS(1220),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_LT] = ACTIONS(1225),
    [anon_sym_GT] = ACTIONS(780),
    [anon_sym_SLASH] = ACTIONS(780),
    [anon_sym_DOT] = ACTIONS(927),
    [anon_sym_async] = ACTIONS(1671),
    [anon_sym_EQ_GT] = ACTIONS(929),
    [anon_sym_QMARK_DOT] = ACTIONS(931),
    [anon_sym_PLUS_EQ] = ACTIONS(803),
    [anon_sym_DASH_EQ] = ACTIONS(803),
    [anon_sym_STAR_EQ] = ACTIONS(803),
    [anon_sym_SLASH_EQ] = ACTIONS(803),
    [anon_sym_PERCENT_EQ] = ACTIONS(803),
    [anon_sym_CARET_EQ] = ACTIONS(803),
    [anon_sym_AMP_EQ] = ACTIONS(803),
    [anon_sym_PIPE_EQ] = ACTIONS(803),
    [anon_sym_GT_GT_EQ] = ACTIONS(803),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(803),
    [anon_sym_LT_LT_EQ] = ACTIONS(803),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(803),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(803),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(803),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(803),
    [anon_sym_QMARK] = ACTIONS(1225),
    [anon_sym_AMP_AMP] = ACTIONS(780),
    [anon_sym_PIPE_PIPE] = ACTIONS(780),
    [anon_sym_GT_GT] = ACTIONS(780),
    [anon_sym_GT_GT_GT] = ACTIONS(780),
    [anon_sym_LT_LT] = ACTIONS(780),
    [anon_sym_AMP] = ACTIONS(780),
    [anon_sym_CARET] = ACTIONS(780),
    [anon_sym_PIPE] = ACTIONS(780),
    [anon_sym_PLUS] = ACTIONS(780),
    [anon_sym_DASH] = ACTIONS(780),
    [anon_sym_PERCENT] = ACTIONS(780),
    [anon_sym_STAR_STAR] = ACTIONS(780),
    [anon_sym_LT_EQ] = ACTIONS(813),
    [anon_sym_EQ_EQ] = ACTIONS(780),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(813),
    [anon_sym_BANG_EQ] = ACTIONS(780),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(813),
    [anon_sym_GT_EQ] = ACTIONS(813),
    [anon_sym_QMARK_QMARK] = ACTIONS(780),
    [anon_sym_instanceof] = ACTIONS(780),
    [anon_sym_PLUS_PLUS] = ACTIONS(813),
    [anon_sym_DASH_DASH] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_SQUOTE] = ACTIONS(1673),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(813),
    [sym_number] = ACTIONS(1673),
    [anon_sym_static] = ACTIONS(1671),
    [anon_sym_get] = ACTIONS(1671),
    [anon_sym_set] = ACTIONS(1671),
    [anon_sym_declare] = ACTIONS(1671),
    [anon_sym_public] = ACTIONS(1671),
    [anon_sym_private] = ACTIONS(1671),
    [anon_sym_protected] = ACTIONS(1671),
    [anon_sym_module] = ACTIONS(1671),
    [anon_sym_any] = ACTIONS(1671),
    [anon_sym_number] = ACTIONS(1671),
    [anon_sym_boolean] = ACTIONS(1671),
    [anon_sym_string] = ACTIONS(1671),
    [anon_sym_symbol] = ACTIONS(1671),
    [sym_readonly] = ACTIONS(1671),
    [sym__automatic_semicolon] = ACTIONS(813),
  },
  [472] = {
    [sym__call_signature] = STATE(3191),
    [sym_formal_parameters] = STATE(2295),
    [sym_type_parameters] = STATE(3054),
    [sym_identifier] = ACTIONS(1631),
    [anon_sym_export] = ACTIONS(1633),
    [anon_sym_STAR] = ACTIONS(780),
    [anon_sym_EQ] = ACTIONS(913),
    [anon_sym_as] = ACTIONS(780),
    [anon_sym_namespace] = ACTIONS(1633),
    [anon_sym_COMMA] = ACTIONS(813),
    [anon_sym_RBRACE] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(1633),
    [anon_sym_BANG] = ACTIONS(780),
    [anon_sym_LPAREN] = ACTIONS(1679),
    [anon_sym_RPAREN] = ACTIONS(813),
    [anon_sym_in] = ACTIONS(780),
    [anon_sym_COLON] = ACTIONS(813),
    [anon_sym_LBRACK] = ACTIONS(1639),
    [anon_sym_RBRACK] = ACTIONS(813),
    [anon_sym_LT] = ACTIONS(1682),
    [anon_sym_GT] = ACTIONS(780),
    [anon_sym_SLASH] = ACTIONS(780),
    [anon_sym_DOT] = ACTIONS(1641),
    [anon_sym_async] = ACTIONS(1633),
    [anon_sym_function] = ACTIONS(1643),
    [anon_sym_EQ_GT] = ACTIONS(797),
    [anon_sym_QMARK_DOT] = ACTIONS(799),
    [anon_sym_PLUS_EQ] = ACTIONS(803),
    [anon_sym_DASH_EQ] = ACTIONS(803),
    [anon_sym_STAR_EQ] = ACTIONS(803),
    [anon_sym_SLASH_EQ] = ACTIONS(803),
    [anon_sym_PERCENT_EQ] = ACTIONS(803),
    [anon_sym_CARET_EQ] = ACTIONS(803),
    [anon_sym_AMP_EQ] = ACTIONS(803),
    [anon_sym_PIPE_EQ] = ACTIONS(803),
    [anon_sym_GT_GT_EQ] = ACTIONS(803),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(803),
    [anon_sym_LT_LT_EQ] = ACTIONS(803),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(803),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(803),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(803),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(803),
    [anon_sym_QMARK] = ACTIONS(780),
    [anon_sym_AMP_AMP] = ACTIONS(780),
    [anon_sym_PIPE_PIPE] = ACTIONS(780),
    [anon_sym_GT_GT] = ACTIONS(780),
    [anon_sym_GT_GT_GT] = ACTIONS(780),
    [anon_sym_LT_LT] = ACTIONS(780),
    [anon_sym_AMP] = ACTIONS(780),
    [anon_sym_CARET] = ACTIONS(780),
    [anon_sym_PIPE] = ACTIONS(780),
    [anon_sym_PLUS] = ACTIONS(780),
    [anon_sym_DASH] = ACTIONS(780),
    [anon_sym_PERCENT] = ACTIONS(780),
    [anon_sym_STAR_STAR] = ACTIONS(780),
    [anon_sym_LT_EQ] = ACTIONS(813),
    [anon_sym_EQ_EQ] = ACTIONS(780),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(813),
    [anon_sym_BANG_EQ] = ACTIONS(780),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(813),
    [anon_sym_GT_EQ] = ACTIONS(813),
    [anon_sym_QMARK_QMARK] = ACTIONS(780),
    [anon_sym_instanceof] = ACTIONS(780),
    [anon_sym_PLUS_PLUS] = ACTIONS(813),
    [anon_sym_DASH_DASH] = ACTIONS(813),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(813),
    [anon_sym_static] = ACTIONS(1633),
    [anon_sym_get] = ACTIONS(1633),
    [anon_sym_set] = ACTIONS(1633),
    [anon_sym_declare] = ACTIONS(1633),
    [anon_sym_public] = ACTIONS(1633),
    [anon_sym_private] = ACTIONS(1633),
    [anon_sym_protected] = ACTIONS(1633),
    [anon_sym_module] = ACTIONS(1633),
    [anon_sym_any] = ACTIONS(1633),
    [anon_sym_number] = ACTIONS(1633),
    [anon_sym_boolean] = ACTIONS(1633),
    [anon_sym_string] = ACTIONS(1633),
    [anon_sym_symbol] = ACTIONS(1633),
    [sym_readonly] = ACTIONS(1633),
  },
  [473] = {
    [sym__call_signature] = STATE(3333),
    [sym_arguments] = STATE(1689),
    [sym_formal_parameters] = STATE(2295),
    [sym_type_arguments] = STATE(1644),
    [sym_type_parameters] = STATE(3054),
    [sym_identifier] = ACTIONS(1685),
    [anon_sym_export] = ACTIONS(1687),
    [anon_sym_STAR] = ACTIONS(1635),
    [anon_sym_EQ] = ACTIONS(961),
    [anon_sym_as] = ACTIONS(1635),
    [anon_sym_namespace] = ACTIONS(1687),
    [anon_sym_LBRACE] = ACTIONS(1635),
    [anon_sym_COMMA] = ACTIONS(1637),
    [anon_sym_type] = ACTIONS(1687),
    [anon_sym_BANG] = ACTIONS(1635),
    [anon_sym_LPAREN] = ACTIONS(1637),
    [anon_sym_in] = ACTIONS(1635),
    [anon_sym_LBRACK] = ACTIONS(1689),
    [anon_sym_LT] = ACTIONS(1635),
    [anon_sym_GT] = ACTIONS(1635),
    [anon_sym_SLASH] = ACTIONS(1635),
    [anon_sym_DOT] = ACTIONS(1691),
    [anon_sym_async] = ACTIONS(1687),
    [anon_sym_function] = ACTIONS(1693),
    [anon_sym_EQ_GT] = ACTIONS(1141),
    [anon_sym_QMARK_DOT] = ACTIONS(1143),
    [anon_sym_PLUS_EQ] = ACTIONS(803),
    [anon_sym_DASH_EQ] = ACTIONS(803),
    [anon_sym_STAR_EQ] = ACTIONS(803),
    [anon_sym_SLASH_EQ] = ACTIONS(803),
    [anon_sym_PERCENT_EQ] = ACTIONS(803),
    [anon_sym_CARET_EQ] = ACTIONS(803),
    [anon_sym_AMP_EQ] = ACTIONS(803),
    [anon_sym_PIPE_EQ] = ACTIONS(803),
    [anon_sym_GT_GT_EQ] = ACTIONS(803),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(803),
    [anon_sym_LT_LT_EQ] = ACTIONS(803),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(803),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(803),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(803),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(803),
    [anon_sym_QMARK] = ACTIONS(1635),
    [anon_sym_AMP_AMP] = ACTIONS(1635),
    [anon_sym_PIPE_PIPE] = ACTIONS(1635),
    [anon_sym_GT_GT] = ACTIONS(1635),
    [anon_sym_GT_GT_GT] = ACTIONS(1635),
    [anon_sym_LT_LT] = ACTIONS(1635),
    [anon_sym_AMP] = ACTIONS(1635),
    [anon_sym_CARET] = ACTIONS(1635),
    [anon_sym_PIPE] = ACTIONS(1635),
    [anon_sym_PLUS] = ACTIONS(1635),
    [anon_sym_DASH] = ACTIONS(1635),
    [anon_sym_PERCENT] = ACTIONS(1635),
    [anon_sym_STAR_STAR] = ACTIONS(1635),
    [anon_sym_LT_EQ] = ACTIONS(1637),
    [anon_sym_EQ_EQ] = ACTIONS(1635),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1637),
    [anon_sym_BANG_EQ] = ACTIONS(1635),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1637),
    [anon_sym_GT_EQ] = ACTIONS(1637),
    [anon_sym_QMARK_QMARK] = ACTIONS(1635),
    [anon_sym_instanceof] = ACTIONS(1635),
    [anon_sym_PLUS_PLUS] = ACTIONS(1637),
    [anon_sym_DASH_DASH] = ACTIONS(1637),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1637),
    [anon_sym_static] = ACTIONS(1687),
    [anon_sym_get] = ACTIONS(1687),
    [anon_sym_set] = ACTIONS(1687),
    [anon_sym_declare] = ACTIONS(1687),
    [anon_sym_public] = ACTIONS(1687),
    [anon_sym_private] = ACTIONS(1687),
    [anon_sym_protected] = ACTIONS(1687),
    [anon_sym_module] = ACTIONS(1687),
    [anon_sym_any] = ACTIONS(1687),
    [anon_sym_number] = ACTIONS(1687),
    [anon_sym_boolean] = ACTIONS(1687),
    [anon_sym_string] = ACTIONS(1687),
    [anon_sym_symbol] = ACTIONS(1687),
    [sym_readonly] = ACTIONS(1687),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1637),
  },
  [474] = {
    [sym__call_signature] = STATE(3284),
    [sym_formal_parameters] = STATE(2295),
    [sym_type_parameters] = STATE(3054),
    [sym_identifier] = ACTIONS(1665),
    [anon_sym_export] = ACTIONS(1667),
    [anon_sym_STAR] = ACTIONS(780),
    [anon_sym_EQ] = ACTIONS(923),
    [anon_sym_as] = ACTIONS(780),
    [anon_sym_namespace] = ACTIONS(1667),
    [anon_sym_COMMA] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(1667),
    [anon_sym_BANG] = ACTIONS(780),
    [anon_sym_LPAREN] = ACTIONS(1679),
    [anon_sym_in] = ACTIONS(1695),
    [anon_sym_of] = ACTIONS(1698),
    [anon_sym_SEMI] = ACTIONS(813),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_LT] = ACTIONS(1682),
    [anon_sym_GT] = ACTIONS(780),
    [anon_sym_SLASH] = ACTIONS(780),
    [anon_sym_DOT] = ACTIONS(1228),
    [anon_sym_async] = ACTIONS(1667),
    [anon_sym_function] = ACTIONS(1669),
    [anon_sym_EQ_GT] = ACTIONS(929),
    [anon_sym_QMARK_DOT] = ACTIONS(931),
    [anon_sym_PLUS_EQ] = ACTIONS(803),
    [anon_sym_DASH_EQ] = ACTIONS(803),
    [anon_sym_STAR_EQ] = ACTIONS(803),
    [anon_sym_SLASH_EQ] = ACTIONS(803),
    [anon_sym_PERCENT_EQ] = ACTIONS(803),
    [anon_sym_CARET_EQ] = ACTIONS(803),
    [anon_sym_AMP_EQ] = ACTIONS(803),
    [anon_sym_PIPE_EQ] = ACTIONS(803),
    [anon_sym_GT_GT_EQ] = ACTIONS(803),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(803),
    [anon_sym_LT_LT_EQ] = ACTIONS(803),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(803),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(803),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(803),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(803),
    [anon_sym_QMARK] = ACTIONS(780),
    [anon_sym_AMP_AMP] = ACTIONS(780),
    [anon_sym_PIPE_PIPE] = ACTIONS(780),
    [anon_sym_GT_GT] = ACTIONS(780),
    [anon_sym_GT_GT_GT] = ACTIONS(780),
    [anon_sym_LT_LT] = ACTIONS(780),
    [anon_sym_AMP] = ACTIONS(780),
    [anon_sym_CARET] = ACTIONS(780),
    [anon_sym_PIPE] = ACTIONS(780),
    [anon_sym_PLUS] = ACTIONS(780),
    [anon_sym_DASH] = ACTIONS(780),
    [anon_sym_PERCENT] = ACTIONS(780),
    [anon_sym_STAR_STAR] = ACTIONS(780),
    [anon_sym_LT_EQ] = ACTIONS(813),
    [anon_sym_EQ_EQ] = ACTIONS(780),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(813),
    [anon_sym_BANG_EQ] = ACTIONS(780),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(813),
    [anon_sym_GT_EQ] = ACTIONS(813),
    [anon_sym_QMARK_QMARK] = ACTIONS(780),
    [anon_sym_instanceof] = ACTIONS(780),
    [anon_sym_PLUS_PLUS] = ACTIONS(813),
    [anon_sym_DASH_DASH] = ACTIONS(813),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(813),
    [anon_sym_static] = ACTIONS(1667),
    [anon_sym_get] = ACTIONS(1667),
    [anon_sym_set] = ACTIONS(1667),
    [anon_sym_declare] = ACTIONS(1667),
    [anon_sym_public] = ACTIONS(1667),
    [anon_sym_private] = ACTIONS(1667),
    [anon_sym_protected] = ACTIONS(1667),
    [anon_sym_module] = ACTIONS(1667),
    [anon_sym_any] = ACTIONS(1667),
    [anon_sym_number] = ACTIONS(1667),
    [anon_sym_boolean] = ACTIONS(1667),
    [anon_sym_string] = ACTIONS(1667),
    [anon_sym_symbol] = ACTIONS(1667),
    [sym_readonly] = ACTIONS(1667),
    [sym__automatic_semicolon] = ACTIONS(813),
  },
  [475] = {
    [sym__call_signature] = STATE(3284),
    [sym_formal_parameters] = STATE(2295),
    [sym_type_parameters] = STATE(3054),
    [sym_identifier] = ACTIONS(1665),
    [anon_sym_export] = ACTIONS(1667),
    [anon_sym_STAR] = ACTIONS(780),
    [anon_sym_EQ] = ACTIONS(923),
    [anon_sym_as] = ACTIONS(780),
    [anon_sym_namespace] = ACTIONS(1667),
    [anon_sym_COMMA] = ACTIONS(813),
    [anon_sym_RBRACE] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(1667),
    [anon_sym_BANG] = ACTIONS(780),
    [anon_sym_LPAREN] = ACTIONS(1679),
    [anon_sym_in] = ACTIONS(780),
    [anon_sym_SEMI] = ACTIONS(813),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_LT] = ACTIONS(1682),
    [anon_sym_GT] = ACTIONS(780),
    [anon_sym_SLASH] = ACTIONS(780),
    [anon_sym_DOT] = ACTIONS(1228),
    [anon_sym_async] = ACTIONS(1667),
    [anon_sym_function] = ACTIONS(1669),
    [anon_sym_EQ_GT] = ACTIONS(929),
    [anon_sym_QMARK_DOT] = ACTIONS(931),
    [anon_sym_PLUS_EQ] = ACTIONS(803),
    [anon_sym_DASH_EQ] = ACTIONS(803),
    [anon_sym_STAR_EQ] = ACTIONS(803),
    [anon_sym_SLASH_EQ] = ACTIONS(803),
    [anon_sym_PERCENT_EQ] = ACTIONS(803),
    [anon_sym_CARET_EQ] = ACTIONS(803),
    [anon_sym_AMP_EQ] = ACTIONS(803),
    [anon_sym_PIPE_EQ] = ACTIONS(803),
    [anon_sym_GT_GT_EQ] = ACTIONS(803),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(803),
    [anon_sym_LT_LT_EQ] = ACTIONS(803),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(803),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(803),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(803),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(803),
    [anon_sym_QMARK] = ACTIONS(780),
    [anon_sym_AMP_AMP] = ACTIONS(780),
    [anon_sym_PIPE_PIPE] = ACTIONS(780),
    [anon_sym_GT_GT] = ACTIONS(780),
    [anon_sym_GT_GT_GT] = ACTIONS(780),
    [anon_sym_LT_LT] = ACTIONS(780),
    [anon_sym_AMP] = ACTIONS(780),
    [anon_sym_CARET] = ACTIONS(780),
    [anon_sym_PIPE] = ACTIONS(780),
    [anon_sym_PLUS] = ACTIONS(780),
    [anon_sym_DASH] = ACTIONS(780),
    [anon_sym_PERCENT] = ACTIONS(780),
    [anon_sym_STAR_STAR] = ACTIONS(780),
    [anon_sym_LT_EQ] = ACTIONS(813),
    [anon_sym_EQ_EQ] = ACTIONS(780),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(813),
    [anon_sym_BANG_EQ] = ACTIONS(780),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(813),
    [anon_sym_GT_EQ] = ACTIONS(813),
    [anon_sym_QMARK_QMARK] = ACTIONS(780),
    [anon_sym_instanceof] = ACTIONS(780),
    [anon_sym_PLUS_PLUS] = ACTIONS(813),
    [anon_sym_DASH_DASH] = ACTIONS(813),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(813),
    [anon_sym_static] = ACTIONS(1667),
    [anon_sym_get] = ACTIONS(1667),
    [anon_sym_set] = ACTIONS(1667),
    [anon_sym_declare] = ACTIONS(1667),
    [anon_sym_public] = ACTIONS(1667),
    [anon_sym_private] = ACTIONS(1667),
    [anon_sym_protected] = ACTIONS(1667),
    [anon_sym_module] = ACTIONS(1667),
    [anon_sym_any] = ACTIONS(1667),
    [anon_sym_number] = ACTIONS(1667),
    [anon_sym_boolean] = ACTIONS(1667),
    [anon_sym_string] = ACTIONS(1667),
    [anon_sym_symbol] = ACTIONS(1667),
    [sym_readonly] = ACTIONS(1667),
    [sym__automatic_semicolon] = ACTIONS(813),
  },
  [476] = {
    [sym__call_signature] = STATE(3284),
    [sym_formal_parameters] = STATE(2295),
    [sym_type_parameters] = STATE(3054),
    [sym_identifier] = ACTIONS(1665),
    [anon_sym_export] = ACTIONS(1667),
    [anon_sym_STAR] = ACTIONS(780),
    [anon_sym_EQ] = ACTIONS(923),
    [anon_sym_as] = ACTIONS(780),
    [anon_sym_namespace] = ACTIONS(1667),
    [anon_sym_COMMA] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(1667),
    [anon_sym_BANG] = ACTIONS(780),
    [anon_sym_LPAREN] = ACTIONS(1679),
    [anon_sym_in] = ACTIONS(780),
    [anon_sym_SEMI] = ACTIONS(813),
    [anon_sym_COLON] = ACTIONS(1288),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_LT] = ACTIONS(1682),
    [anon_sym_GT] = ACTIONS(780),
    [anon_sym_SLASH] = ACTIONS(780),
    [anon_sym_DOT] = ACTIONS(1228),
    [anon_sym_async] = ACTIONS(1667),
    [anon_sym_function] = ACTIONS(1433),
    [anon_sym_EQ_GT] = ACTIONS(929),
    [anon_sym_QMARK_DOT] = ACTIONS(931),
    [anon_sym_PLUS_EQ] = ACTIONS(803),
    [anon_sym_DASH_EQ] = ACTIONS(803),
    [anon_sym_STAR_EQ] = ACTIONS(803),
    [anon_sym_SLASH_EQ] = ACTIONS(803),
    [anon_sym_PERCENT_EQ] = ACTIONS(803),
    [anon_sym_CARET_EQ] = ACTIONS(803),
    [anon_sym_AMP_EQ] = ACTIONS(803),
    [anon_sym_PIPE_EQ] = ACTIONS(803),
    [anon_sym_GT_GT_EQ] = ACTIONS(803),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(803),
    [anon_sym_LT_LT_EQ] = ACTIONS(803),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(803),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(803),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(803),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(803),
    [anon_sym_QMARK] = ACTIONS(780),
    [anon_sym_AMP_AMP] = ACTIONS(780),
    [anon_sym_PIPE_PIPE] = ACTIONS(780),
    [anon_sym_GT_GT] = ACTIONS(780),
    [anon_sym_GT_GT_GT] = ACTIONS(780),
    [anon_sym_LT_LT] = ACTIONS(780),
    [anon_sym_AMP] = ACTIONS(780),
    [anon_sym_CARET] = ACTIONS(780),
    [anon_sym_PIPE] = ACTIONS(780),
    [anon_sym_PLUS] = ACTIONS(780),
    [anon_sym_DASH] = ACTIONS(780),
    [anon_sym_PERCENT] = ACTIONS(780),
    [anon_sym_STAR_STAR] = ACTIONS(780),
    [anon_sym_LT_EQ] = ACTIONS(813),
    [anon_sym_EQ_EQ] = ACTIONS(780),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(813),
    [anon_sym_BANG_EQ] = ACTIONS(780),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(813),
    [anon_sym_GT_EQ] = ACTIONS(813),
    [anon_sym_QMARK_QMARK] = ACTIONS(780),
    [anon_sym_instanceof] = ACTIONS(780),
    [anon_sym_PLUS_PLUS] = ACTIONS(813),
    [anon_sym_DASH_DASH] = ACTIONS(813),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(813),
    [anon_sym_static] = ACTIONS(1667),
    [anon_sym_get] = ACTIONS(1667),
    [anon_sym_set] = ACTIONS(1667),
    [anon_sym_declare] = ACTIONS(1667),
    [anon_sym_public] = ACTIONS(1667),
    [anon_sym_private] = ACTIONS(1667),
    [anon_sym_protected] = ACTIONS(1667),
    [anon_sym_module] = ACTIONS(1667),
    [anon_sym_any] = ACTIONS(1667),
    [anon_sym_number] = ACTIONS(1667),
    [anon_sym_boolean] = ACTIONS(1667),
    [anon_sym_string] = ACTIONS(1667),
    [anon_sym_symbol] = ACTIONS(1667),
    [sym_readonly] = ACTIONS(1667),
    [sym__automatic_semicolon] = ACTIONS(813),
  },
  [477] = {
    [sym__call_signature] = STATE(3164),
    [sym_arguments] = STATE(1174),
    [sym_formal_parameters] = STATE(2295),
    [sym_type_arguments] = STATE(1073),
    [sym_type_parameters] = STATE(3054),
    [sym_identifier] = ACTIONS(1700),
    [anon_sym_export] = ACTIONS(1702),
    [anon_sym_STAR] = ACTIONS(1635),
    [anon_sym_EQ] = ACTIONS(961),
    [anon_sym_as] = ACTIONS(1635),
    [anon_sym_namespace] = ACTIONS(1702),
    [anon_sym_type] = ACTIONS(1702),
    [anon_sym_BANG] = ACTIONS(1635),
    [anon_sym_LPAREN] = ACTIONS(1637),
    [anon_sym_in] = ACTIONS(1635),
    [anon_sym_COLON] = ACTIONS(1637),
    [anon_sym_LBRACK] = ACTIONS(1639),
    [anon_sym_RBRACK] = ACTIONS(1637),
    [anon_sym_LT] = ACTIONS(1635),
    [anon_sym_GT] = ACTIONS(1635),
    [anon_sym_SLASH] = ACTIONS(1635),
    [anon_sym_DOT] = ACTIONS(1641),
    [anon_sym_async] = ACTIONS(1702),
    [anon_sym_function] = ACTIONS(1643),
    [anon_sym_EQ_GT] = ACTIONS(963),
    [anon_sym_QMARK_DOT] = ACTIONS(799),
    [anon_sym_PLUS_EQ] = ACTIONS(803),
    [anon_sym_DASH_EQ] = ACTIONS(803),
    [anon_sym_STAR_EQ] = ACTIONS(803),
    [anon_sym_SLASH_EQ] = ACTIONS(803),
    [anon_sym_PERCENT_EQ] = ACTIONS(803),
    [anon_sym_CARET_EQ] = ACTIONS(803),
    [anon_sym_AMP_EQ] = ACTIONS(803),
    [anon_sym_PIPE_EQ] = ACTIONS(803),
    [anon_sym_GT_GT_EQ] = ACTIONS(803),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(803),
    [anon_sym_LT_LT_EQ] = ACTIONS(803),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(803),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(803),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(803),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(803),
    [anon_sym_QMARK] = ACTIONS(1635),
    [anon_sym_AMP_AMP] = ACTIONS(1635),
    [anon_sym_PIPE_PIPE] = ACTIONS(1635),
    [anon_sym_GT_GT] = ACTIONS(1635),
    [anon_sym_GT_GT_GT] = ACTIONS(1635),
    [anon_sym_LT_LT] = ACTIONS(1635),
    [anon_sym_AMP] = ACTIONS(1635),
    [anon_sym_CARET] = ACTIONS(1635),
    [anon_sym_PIPE] = ACTIONS(1635),
    [anon_sym_PLUS] = ACTIONS(1635),
    [anon_sym_DASH] = ACTIONS(1635),
    [anon_sym_PERCENT] = ACTIONS(1635),
    [anon_sym_STAR_STAR] = ACTIONS(1635),
    [anon_sym_LT_EQ] = ACTIONS(1637),
    [anon_sym_EQ_EQ] = ACTIONS(1635),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1637),
    [anon_sym_BANG_EQ] = ACTIONS(1635),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1637),
    [anon_sym_GT_EQ] = ACTIONS(1637),
    [anon_sym_QMARK_QMARK] = ACTIONS(1635),
    [anon_sym_instanceof] = ACTIONS(1635),
    [anon_sym_PLUS_PLUS] = ACTIONS(1637),
    [anon_sym_DASH_DASH] = ACTIONS(1637),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1637),
    [anon_sym_static] = ACTIONS(1702),
    [anon_sym_get] = ACTIONS(1702),
    [anon_sym_set] = ACTIONS(1702),
    [anon_sym_declare] = ACTIONS(1702),
    [anon_sym_public] = ACTIONS(1702),
    [anon_sym_private] = ACTIONS(1702),
    [anon_sym_protected] = ACTIONS(1702),
    [anon_sym_module] = ACTIONS(1702),
    [anon_sym_any] = ACTIONS(1702),
    [anon_sym_number] = ACTIONS(1702),
    [anon_sym_boolean] = ACTIONS(1702),
    [anon_sym_string] = ACTIONS(1702),
    [anon_sym_symbol] = ACTIONS(1702),
    [sym_readonly] = ACTIONS(1702),
  },
  [478] = {
    [sym_type_arguments] = STATE(284),
    [ts_builtin_sym_end] = ACTIONS(1559),
    [sym_identifier] = ACTIONS(1561),
    [anon_sym_export] = ACTIONS(1561),
    [anon_sym_default] = ACTIONS(1561),
    [anon_sym_namespace] = ACTIONS(1561),
    [anon_sym_LBRACE] = ACTIONS(1559),
    [anon_sym_RBRACE] = ACTIONS(1559),
    [anon_sym_type] = ACTIONS(1561),
    [anon_sym_typeof] = ACTIONS(1561),
    [anon_sym_import] = ACTIONS(1561),
    [anon_sym_var] = ACTIONS(1561),
    [anon_sym_let] = ACTIONS(1561),
    [anon_sym_const] = ACTIONS(1561),
    [anon_sym_BANG] = ACTIONS(1559),
    [anon_sym_else] = ACTIONS(1561),
    [anon_sym_if] = ACTIONS(1561),
    [anon_sym_switch] = ACTIONS(1561),
    [anon_sym_for] = ACTIONS(1561),
    [anon_sym_LPAREN] = ACTIONS(1559),
    [anon_sym_await] = ACTIONS(1561),
    [anon_sym_while] = ACTIONS(1561),
    [anon_sym_do] = ACTIONS(1561),
    [anon_sym_try] = ACTIONS(1561),
    [anon_sym_with] = ACTIONS(1561),
    [anon_sym_break] = ACTIONS(1561),
    [anon_sym_continue] = ACTIONS(1561),
    [anon_sym_debugger] = ACTIONS(1561),
    [anon_sym_return] = ACTIONS(1561),
    [anon_sym_throw] = ACTIONS(1561),
    [anon_sym_SEMI] = ACTIONS(1559),
    [anon_sym_case] = ACTIONS(1561),
    [anon_sym_yield] = ACTIONS(1561),
    [anon_sym_LBRACK] = ACTIONS(1559),
    [anon_sym_LT] = ACTIONS(1559),
    [anon_sym_SLASH] = ACTIONS(1561),
    [anon_sym_DOT] = ACTIONS(1704),
    [anon_sym_class] = ACTIONS(1561),
    [anon_sym_async] = ACTIONS(1561),
    [anon_sym_function] = ACTIONS(1561),
    [anon_sym_new] = ACTIONS(1561),
    [anon_sym_AMP] = ACTIONS(1559),
    [anon_sym_PIPE] = ACTIONS(1559),
    [anon_sym_PLUS] = ACTIONS(1561),
    [anon_sym_DASH] = ACTIONS(1561),
    [anon_sym_TILDE] = ACTIONS(1559),
    [anon_sym_void] = ACTIONS(1561),
    [anon_sym_delete] = ACTIONS(1561),
    [anon_sym_PLUS_PLUS] = ACTIONS(1559),
    [anon_sym_DASH_DASH] = ACTIONS(1559),
    [anon_sym_DQUOTE] = ACTIONS(1559),
    [anon_sym_SQUOTE] = ACTIONS(1559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1559),
    [sym_number] = ACTIONS(1559),
    [sym_this] = ACTIONS(1561),
    [sym_super] = ACTIONS(1561),
    [sym_true] = ACTIONS(1561),
    [sym_false] = ACTIONS(1561),
    [sym_null] = ACTIONS(1561),
    [sym_undefined] = ACTIONS(1561),
    [anon_sym_AT] = ACTIONS(1559),
    [anon_sym_static] = ACTIONS(1561),
    [anon_sym_abstract] = ACTIONS(1561),
    [anon_sym_get] = ACTIONS(1561),
    [anon_sym_set] = ACTIONS(1561),
    [anon_sym_declare] = ACTIONS(1561),
    [anon_sym_public] = ACTIONS(1561),
    [anon_sym_private] = ACTIONS(1561),
    [anon_sym_protected] = ACTIONS(1561),
    [anon_sym_module] = ACTIONS(1561),
    [anon_sym_any] = ACTIONS(1561),
    [anon_sym_number] = ACTIONS(1561),
    [anon_sym_boolean] = ACTIONS(1561),
    [anon_sym_string] = ACTIONS(1561),
    [anon_sym_symbol] = ACTIONS(1561),
    [anon_sym_interface] = ACTIONS(1561),
    [anon_sym_extends] = ACTIONS(1561),
    [anon_sym_enum] = ACTIONS(1561),
    [sym_readonly] = ACTIONS(1561),
  },
  [479] = {
    [sym__call_signature] = STATE(3248),
    [sym_arguments] = STATE(1581),
    [sym_formal_parameters] = STATE(2295),
    [sym_type_arguments] = STATE(1378),
    [sym_type_parameters] = STATE(3054),
    [sym_identifier] = ACTIONS(1706),
    [anon_sym_export] = ACTIONS(1708),
    [anon_sym_STAR] = ACTIONS(1635),
    [anon_sym_EQ] = ACTIONS(961),
    [anon_sym_as] = ACTIONS(1635),
    [anon_sym_namespace] = ACTIONS(1708),
    [anon_sym_type] = ACTIONS(1708),
    [anon_sym_BANG] = ACTIONS(1635),
    [anon_sym_LPAREN] = ACTIONS(1637),
    [anon_sym_in] = ACTIONS(1635),
    [anon_sym_SEMI] = ACTIONS(1637),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_LT] = ACTIONS(1635),
    [anon_sym_GT] = ACTIONS(1635),
    [anon_sym_SLASH] = ACTIONS(1635),
    [anon_sym_DOT] = ACTIONS(1228),
    [anon_sym_async] = ACTIONS(1708),
    [anon_sym_function] = ACTIONS(1669),
    [anon_sym_EQ_GT] = ACTIONS(1069),
    [anon_sym_QMARK_DOT] = ACTIONS(931),
    [anon_sym_PLUS_EQ] = ACTIONS(803),
    [anon_sym_DASH_EQ] = ACTIONS(803),
    [anon_sym_STAR_EQ] = ACTIONS(803),
    [anon_sym_SLASH_EQ] = ACTIONS(803),
    [anon_sym_PERCENT_EQ] = ACTIONS(803),
    [anon_sym_CARET_EQ] = ACTIONS(803),
    [anon_sym_AMP_EQ] = ACTIONS(803),
    [anon_sym_PIPE_EQ] = ACTIONS(803),
    [anon_sym_GT_GT_EQ] = ACTIONS(803),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(803),
    [anon_sym_LT_LT_EQ] = ACTIONS(803),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(803),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(803),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(803),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(803),
    [anon_sym_QMARK] = ACTIONS(1635),
    [anon_sym_AMP_AMP] = ACTIONS(1635),
    [anon_sym_PIPE_PIPE] = ACTIONS(1635),
    [anon_sym_GT_GT] = ACTIONS(1635),
    [anon_sym_GT_GT_GT] = ACTIONS(1635),
    [anon_sym_LT_LT] = ACTIONS(1635),
    [anon_sym_AMP] = ACTIONS(1635),
    [anon_sym_CARET] = ACTIONS(1635),
    [anon_sym_PIPE] = ACTIONS(1635),
    [anon_sym_PLUS] = ACTIONS(1635),
    [anon_sym_DASH] = ACTIONS(1635),
    [anon_sym_PERCENT] = ACTIONS(1635),
    [anon_sym_STAR_STAR] = ACTIONS(1635),
    [anon_sym_LT_EQ] = ACTIONS(1637),
    [anon_sym_EQ_EQ] = ACTIONS(1635),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1637),
    [anon_sym_BANG_EQ] = ACTIONS(1635),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1637),
    [anon_sym_GT_EQ] = ACTIONS(1637),
    [anon_sym_QMARK_QMARK] = ACTIONS(1635),
    [anon_sym_instanceof] = ACTIONS(1635),
    [anon_sym_PLUS_PLUS] = ACTIONS(1637),
    [anon_sym_DASH_DASH] = ACTIONS(1637),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1637),
    [anon_sym_static] = ACTIONS(1708),
    [anon_sym_get] = ACTIONS(1708),
    [anon_sym_set] = ACTIONS(1708),
    [anon_sym_declare] = ACTIONS(1708),
    [anon_sym_public] = ACTIONS(1708),
    [anon_sym_private] = ACTIONS(1708),
    [anon_sym_protected] = ACTIONS(1708),
    [anon_sym_module] = ACTIONS(1708),
    [anon_sym_any] = ACTIONS(1708),
    [anon_sym_number] = ACTIONS(1708),
    [anon_sym_boolean] = ACTIONS(1708),
    [anon_sym_string] = ACTIONS(1708),
    [anon_sym_symbol] = ACTIONS(1708),
    [sym_readonly] = ACTIONS(1708),
    [sym__automatic_semicolon] = ACTIONS(1637),
  },
  [480] = {
    [sym_type_arguments] = STATE(284),
    [ts_builtin_sym_end] = ACTIONS(1710),
    [sym_identifier] = ACTIONS(1712),
    [anon_sym_export] = ACTIONS(1712),
    [anon_sym_default] = ACTIONS(1712),
    [anon_sym_namespace] = ACTIONS(1712),
    [anon_sym_LBRACE] = ACTIONS(1710),
    [anon_sym_RBRACE] = ACTIONS(1710),
    [anon_sym_type] = ACTIONS(1712),
    [anon_sym_typeof] = ACTIONS(1712),
    [anon_sym_import] = ACTIONS(1712),
    [anon_sym_var] = ACTIONS(1712),
    [anon_sym_let] = ACTIONS(1712),
    [anon_sym_const] = ACTIONS(1712),
    [anon_sym_BANG] = ACTIONS(1710),
    [anon_sym_else] = ACTIONS(1712),
    [anon_sym_if] = ACTIONS(1712),
    [anon_sym_switch] = ACTIONS(1712),
    [anon_sym_for] = ACTIONS(1712),
    [anon_sym_LPAREN] = ACTIONS(1710),
    [anon_sym_await] = ACTIONS(1712),
    [anon_sym_while] = ACTIONS(1712),
    [anon_sym_do] = ACTIONS(1712),
    [anon_sym_try] = ACTIONS(1712),
    [anon_sym_with] = ACTIONS(1712),
    [anon_sym_break] = ACTIONS(1712),
    [anon_sym_continue] = ACTIONS(1712),
    [anon_sym_debugger] = ACTIONS(1712),
    [anon_sym_return] = ACTIONS(1712),
    [anon_sym_throw] = ACTIONS(1712),
    [anon_sym_SEMI] = ACTIONS(1710),
    [anon_sym_case] = ACTIONS(1712),
    [anon_sym_yield] = ACTIONS(1712),
    [anon_sym_LBRACK] = ACTIONS(1710),
    [anon_sym_LT] = ACTIONS(1714),
    [anon_sym_SLASH] = ACTIONS(1712),
    [anon_sym_DOT] = ACTIONS(1717),
    [anon_sym_class] = ACTIONS(1712),
    [anon_sym_async] = ACTIONS(1712),
    [anon_sym_function] = ACTIONS(1712),
    [anon_sym_new] = ACTIONS(1712),
    [anon_sym_AMP] = ACTIONS(1710),
    [anon_sym_PIPE] = ACTIONS(1710),
    [anon_sym_PLUS] = ACTIONS(1712),
    [anon_sym_DASH] = ACTIONS(1712),
    [anon_sym_TILDE] = ACTIONS(1710),
    [anon_sym_void] = ACTIONS(1712),
    [anon_sym_delete] = ACTIONS(1712),
    [anon_sym_PLUS_PLUS] = ACTIONS(1710),
    [anon_sym_DASH_DASH] = ACTIONS(1710),
    [anon_sym_DQUOTE] = ACTIONS(1710),
    [anon_sym_SQUOTE] = ACTIONS(1710),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1710),
    [sym_number] = ACTIONS(1710),
    [sym_this] = ACTIONS(1712),
    [sym_super] = ACTIONS(1712),
    [sym_true] = ACTIONS(1712),
    [sym_false] = ACTIONS(1712),
    [sym_null] = ACTIONS(1712),
    [sym_undefined] = ACTIONS(1712),
    [anon_sym_AT] = ACTIONS(1710),
    [anon_sym_static] = ACTIONS(1712),
    [anon_sym_abstract] = ACTIONS(1712),
    [anon_sym_get] = ACTIONS(1712),
    [anon_sym_set] = ACTIONS(1712),
    [anon_sym_declare] = ACTIONS(1712),
    [anon_sym_public] = ACTIONS(1712),
    [anon_sym_private] = ACTIONS(1712),
    [anon_sym_protected] = ACTIONS(1712),
    [anon_sym_module] = ACTIONS(1712),
    [anon_sym_any] = ACTIONS(1712),
    [anon_sym_number] = ACTIONS(1712),
    [anon_sym_boolean] = ACTIONS(1712),
    [anon_sym_string] = ACTIONS(1712),
    [anon_sym_symbol] = ACTIONS(1712),
    [anon_sym_interface] = ACTIONS(1712),
    [anon_sym_extends] = ACTIONS(1712),
    [anon_sym_enum] = ACTIONS(1712),
    [sym_readonly] = ACTIONS(1712),
  },
  [481] = {
    [sym__call_signature] = STATE(3284),
    [sym_formal_parameters] = STATE(2295),
    [sym_type_parameters] = STATE(3054),
    [sym_identifier] = ACTIONS(1665),
    [anon_sym_export] = ACTIONS(1667),
    [anon_sym_STAR] = ACTIONS(780),
    [anon_sym_EQ] = ACTIONS(923),
    [anon_sym_as] = ACTIONS(780),
    [anon_sym_namespace] = ACTIONS(1667),
    [anon_sym_COMMA] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(1667),
    [anon_sym_BANG] = ACTIONS(780),
    [anon_sym_LPAREN] = ACTIONS(1679),
    [anon_sym_in] = ACTIONS(780),
    [anon_sym_SEMI] = ACTIONS(813),
    [anon_sym_COLON] = ACTIONS(1290),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_LT] = ACTIONS(1682),
    [anon_sym_GT] = ACTIONS(780),
    [anon_sym_SLASH] = ACTIONS(780),
    [anon_sym_DOT] = ACTIONS(1228),
    [anon_sym_async] = ACTIONS(1667),
    [anon_sym_function] = ACTIONS(1719),
    [anon_sym_EQ_GT] = ACTIONS(929),
    [anon_sym_QMARK_DOT] = ACTIONS(931),
    [anon_sym_PLUS_EQ] = ACTIONS(803),
    [anon_sym_DASH_EQ] = ACTIONS(803),
    [anon_sym_STAR_EQ] = ACTIONS(803),
    [anon_sym_SLASH_EQ] = ACTIONS(803),
    [anon_sym_PERCENT_EQ] = ACTIONS(803),
    [anon_sym_CARET_EQ] = ACTIONS(803),
    [anon_sym_AMP_EQ] = ACTIONS(803),
    [anon_sym_PIPE_EQ] = ACTIONS(803),
    [anon_sym_GT_GT_EQ] = ACTIONS(803),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(803),
    [anon_sym_LT_LT_EQ] = ACTIONS(803),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(803),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(803),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(803),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(803),
    [anon_sym_QMARK] = ACTIONS(780),
    [anon_sym_AMP_AMP] = ACTIONS(780),
    [anon_sym_PIPE_PIPE] = ACTIONS(780),
    [anon_sym_GT_GT] = ACTIONS(780),
    [anon_sym_GT_GT_GT] = ACTIONS(780),
    [anon_sym_LT_LT] = ACTIONS(780),
    [anon_sym_AMP] = ACTIONS(780),
    [anon_sym_CARET] = ACTIONS(780),
    [anon_sym_PIPE] = ACTIONS(780),
    [anon_sym_PLUS] = ACTIONS(780),
    [anon_sym_DASH] = ACTIONS(780),
    [anon_sym_PERCENT] = ACTIONS(780),
    [anon_sym_STAR_STAR] = ACTIONS(780),
    [anon_sym_LT_EQ] = ACTIONS(813),
    [anon_sym_EQ_EQ] = ACTIONS(780),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(813),
    [anon_sym_BANG_EQ] = ACTIONS(780),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(813),
    [anon_sym_GT_EQ] = ACTIONS(813),
    [anon_sym_QMARK_QMARK] = ACTIONS(780),
    [anon_sym_instanceof] = ACTIONS(780),
    [anon_sym_PLUS_PLUS] = ACTIONS(813),
    [anon_sym_DASH_DASH] = ACTIONS(813),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(813),
    [anon_sym_static] = ACTIONS(1667),
    [anon_sym_get] = ACTIONS(1667),
    [anon_sym_set] = ACTIONS(1667),
    [anon_sym_declare] = ACTIONS(1667),
    [anon_sym_public] = ACTIONS(1667),
    [anon_sym_private] = ACTIONS(1667),
    [anon_sym_protected] = ACTIONS(1667),
    [anon_sym_module] = ACTIONS(1667),
    [anon_sym_any] = ACTIONS(1667),
    [anon_sym_number] = ACTIONS(1667),
    [anon_sym_boolean] = ACTIONS(1667),
    [anon_sym_string] = ACTIONS(1667),
    [anon_sym_symbol] = ACTIONS(1667),
    [sym_readonly] = ACTIONS(1667),
    [sym__automatic_semicolon] = ACTIONS(813),
  },
  [482] = {
    [sym_type_arguments] = STATE(284),
    [ts_builtin_sym_end] = ACTIONS(1721),
    [sym_identifier] = ACTIONS(1723),
    [anon_sym_export] = ACTIONS(1723),
    [anon_sym_default] = ACTIONS(1723),
    [anon_sym_namespace] = ACTIONS(1723),
    [anon_sym_LBRACE] = ACTIONS(1721),
    [anon_sym_RBRACE] = ACTIONS(1721),
    [anon_sym_type] = ACTIONS(1723),
    [anon_sym_typeof] = ACTIONS(1723),
    [anon_sym_import] = ACTIONS(1723),
    [anon_sym_var] = ACTIONS(1723),
    [anon_sym_let] = ACTIONS(1723),
    [anon_sym_const] = ACTIONS(1723),
    [anon_sym_BANG] = ACTIONS(1721),
    [anon_sym_else] = ACTIONS(1723),
    [anon_sym_if] = ACTIONS(1723),
    [anon_sym_switch] = ACTIONS(1723),
    [anon_sym_for] = ACTIONS(1723),
    [anon_sym_LPAREN] = ACTIONS(1721),
    [anon_sym_await] = ACTIONS(1723),
    [anon_sym_while] = ACTIONS(1723),
    [anon_sym_do] = ACTIONS(1723),
    [anon_sym_try] = ACTIONS(1723),
    [anon_sym_with] = ACTIONS(1723),
    [anon_sym_break] = ACTIONS(1723),
    [anon_sym_continue] = ACTIONS(1723),
    [anon_sym_debugger] = ACTIONS(1723),
    [anon_sym_return] = ACTIONS(1723),
    [anon_sym_throw] = ACTIONS(1723),
    [anon_sym_SEMI] = ACTIONS(1721),
    [anon_sym_case] = ACTIONS(1723),
    [anon_sym_yield] = ACTIONS(1723),
    [anon_sym_LBRACK] = ACTIONS(1721),
    [anon_sym_LT] = ACTIONS(1721),
    [anon_sym_SLASH] = ACTIONS(1723),
    [anon_sym_DOT] = ACTIONS(1717),
    [anon_sym_class] = ACTIONS(1723),
    [anon_sym_async] = ACTIONS(1723),
    [anon_sym_function] = ACTIONS(1723),
    [anon_sym_new] = ACTIONS(1723),
    [anon_sym_AMP] = ACTIONS(1721),
    [anon_sym_PIPE] = ACTIONS(1721),
    [anon_sym_PLUS] = ACTIONS(1723),
    [anon_sym_DASH] = ACTIONS(1723),
    [anon_sym_TILDE] = ACTIONS(1721),
    [anon_sym_void] = ACTIONS(1723),
    [anon_sym_delete] = ACTIONS(1723),
    [anon_sym_PLUS_PLUS] = ACTIONS(1721),
    [anon_sym_DASH_DASH] = ACTIONS(1721),
    [anon_sym_DQUOTE] = ACTIONS(1721),
    [anon_sym_SQUOTE] = ACTIONS(1721),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1721),
    [sym_number] = ACTIONS(1721),
    [sym_this] = ACTIONS(1723),
    [sym_super] = ACTIONS(1723),
    [sym_true] = ACTIONS(1723),
    [sym_false] = ACTIONS(1723),
    [sym_null] = ACTIONS(1723),
    [sym_undefined] = ACTIONS(1723),
    [anon_sym_AT] = ACTIONS(1721),
    [anon_sym_static] = ACTIONS(1723),
    [anon_sym_abstract] = ACTIONS(1723),
    [anon_sym_get] = ACTIONS(1723),
    [anon_sym_set] = ACTIONS(1723),
    [anon_sym_declare] = ACTIONS(1723),
    [anon_sym_public] = ACTIONS(1723),
    [anon_sym_private] = ACTIONS(1723),
    [anon_sym_protected] = ACTIONS(1723),
    [anon_sym_module] = ACTIONS(1723),
    [anon_sym_any] = ACTIONS(1723),
    [anon_sym_number] = ACTIONS(1723),
    [anon_sym_boolean] = ACTIONS(1723),
    [anon_sym_string] = ACTIONS(1723),
    [anon_sym_symbol] = ACTIONS(1723),
    [anon_sym_interface] = ACTIONS(1723),
    [anon_sym_extends] = ACTIONS(1723),
    [anon_sym_enum] = ACTIONS(1723),
    [sym_readonly] = ACTIONS(1723),
  },
  [483] = {
    [ts_builtin_sym_end] = ACTIONS(1049),
    [sym_identifier] = ACTIONS(1051),
    [anon_sym_export] = ACTIONS(1051),
    [anon_sym_default] = ACTIONS(1051),
    [anon_sym_namespace] = ACTIONS(1051),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_COMMA] = ACTIONS(1049),
    [anon_sym_RBRACE] = ACTIONS(1049),
    [anon_sym_type] = ACTIONS(1051),
    [anon_sym_typeof] = ACTIONS(1051),
    [anon_sym_import] = ACTIONS(1051),
    [anon_sym_var] = ACTIONS(1051),
    [anon_sym_let] = ACTIONS(1051),
    [anon_sym_const] = ACTIONS(1051),
    [anon_sym_BANG] = ACTIONS(1049),
    [anon_sym_else] = ACTIONS(1051),
    [anon_sym_if] = ACTIONS(1051),
    [anon_sym_switch] = ACTIONS(1051),
    [anon_sym_for] = ACTIONS(1051),
    [anon_sym_LPAREN] = ACTIONS(1049),
    [anon_sym_await] = ACTIONS(1051),
    [anon_sym_while] = ACTIONS(1051),
    [anon_sym_do] = ACTIONS(1051),
    [anon_sym_try] = ACTIONS(1051),
    [anon_sym_with] = ACTIONS(1051),
    [anon_sym_break] = ACTIONS(1051),
    [anon_sym_continue] = ACTIONS(1051),
    [anon_sym_debugger] = ACTIONS(1051),
    [anon_sym_return] = ACTIONS(1051),
    [anon_sym_throw] = ACTIONS(1051),
    [anon_sym_SEMI] = ACTIONS(1049),
    [anon_sym_case] = ACTIONS(1051),
    [anon_sym_catch] = ACTIONS(1051),
    [anon_sym_finally] = ACTIONS(1051),
    [anon_sym_yield] = ACTIONS(1051),
    [anon_sym_LBRACK] = ACTIONS(1049),
    [anon_sym_LT] = ACTIONS(1049),
    [anon_sym_SLASH] = ACTIONS(1051),
    [anon_sym_class] = ACTIONS(1051),
    [anon_sym_async] = ACTIONS(1051),
    [anon_sym_function] = ACTIONS(1051),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_PLUS] = ACTIONS(1051),
    [anon_sym_DASH] = ACTIONS(1051),
    [anon_sym_TILDE] = ACTIONS(1049),
    [anon_sym_void] = ACTIONS(1051),
    [anon_sym_delete] = ACTIONS(1051),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_DQUOTE] = ACTIONS(1049),
    [anon_sym_SQUOTE] = ACTIONS(1049),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1049),
    [sym_number] = ACTIONS(1049),
    [sym_this] = ACTIONS(1051),
    [sym_super] = ACTIONS(1051),
    [sym_true] = ACTIONS(1051),
    [sym_false] = ACTIONS(1051),
    [sym_null] = ACTIONS(1051),
    [sym_undefined] = ACTIONS(1051),
    [anon_sym_AT] = ACTIONS(1049),
    [anon_sym_static] = ACTIONS(1051),
    [anon_sym_abstract] = ACTIONS(1051),
    [anon_sym_get] = ACTIONS(1051),
    [anon_sym_set] = ACTIONS(1051),
    [anon_sym_declare] = ACTIONS(1051),
    [anon_sym_public] = ACTIONS(1051),
    [anon_sym_private] = ACTIONS(1051),
    [anon_sym_protected] = ACTIONS(1051),
    [anon_sym_module] = ACTIONS(1051),
    [anon_sym_any] = ACTIONS(1051),
    [anon_sym_number] = ACTIONS(1051),
    [anon_sym_boolean] = ACTIONS(1051),
    [anon_sym_string] = ACTIONS(1051),
    [anon_sym_symbol] = ACTIONS(1051),
    [anon_sym_interface] = ACTIONS(1051),
    [anon_sym_enum] = ACTIONS(1051),
    [sym_readonly] = ACTIONS(1051),
    [sym__automatic_semicolon] = ACTIONS(1725),
  },
  [484] = {
    [sym_object] = STATE(2474),
    [sym_array] = STATE(2475),
    [sym_identifier] = ACTIONS(1727),
    [anon_sym_export] = ACTIONS(773),
    [anon_sym_STAR] = ACTIONS(780),
    [anon_sym_EQ] = ACTIONS(777),
    [anon_sym_as] = ACTIONS(780),
    [anon_sym_namespace] = ACTIONS(773),
    [anon_sym_LBRACE] = ACTIONS(1729),
    [anon_sym_COMMA] = ACTIONS(784),
    [anon_sym_type] = ACTIONS(773),
    [anon_sym_BANG] = ACTIONS(780),
    [anon_sym_LPAREN] = ACTIONS(813),
    [anon_sym_RPAREN] = ACTIONS(784),
    [anon_sym_in] = ACTIONS(780),
    [anon_sym_COLON] = ACTIONS(784),
    [anon_sym_LBRACK] = ACTIONS(1731),
    [anon_sym_LT] = ACTIONS(780),
    [anon_sym_GT] = ACTIONS(780),
    [anon_sym_SLASH] = ACTIONS(780),
    [anon_sym_DOT] = ACTIONS(1641),
    [anon_sym_async] = ACTIONS(773),
    [anon_sym_EQ_GT] = ACTIONS(797),
    [anon_sym_QMARK_DOT] = ACTIONS(799),
    [anon_sym_PLUS_EQ] = ACTIONS(803),
    [anon_sym_DASH_EQ] = ACTIONS(803),
    [anon_sym_STAR_EQ] = ACTIONS(803),
    [anon_sym_SLASH_EQ] = ACTIONS(803),
    [anon_sym_PERCENT_EQ] = ACTIONS(803),
    [anon_sym_CARET_EQ] = ACTIONS(803),
    [anon_sym_AMP_EQ] = ACTIONS(803),
    [anon_sym_PIPE_EQ] = ACTIONS(803),
    [anon_sym_GT_GT_EQ] = ACTIONS(803),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(803),
    [anon_sym_LT_LT_EQ] = ACTIONS(803),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(803),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(803),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(803),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(803),
    [anon_sym_QMARK] = ACTIONS(1733),
    [anon_sym_AMP_AMP] = ACTIONS(780),
    [anon_sym_PIPE_PIPE] = ACTIONS(780),
    [anon_sym_GT_GT] = ACTIONS(780),
    [anon_sym_GT_GT_GT] = ACTIONS(780),
    [anon_sym_LT_LT] = ACTIONS(780),
    [anon_sym_AMP] = ACTIONS(780),
    [anon_sym_CARET] = ACTIONS(780),
    [anon_sym_PIPE] = ACTIONS(780),
    [anon_sym_PLUS] = ACTIONS(780),
    [anon_sym_DASH] = ACTIONS(780),
    [anon_sym_PERCENT] = ACTIONS(780),
    [anon_sym_STAR_STAR] = ACTIONS(780),
    [anon_sym_LT_EQ] = ACTIONS(813),
    [anon_sym_EQ_EQ] = ACTIONS(780),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(813),
    [anon_sym_BANG_EQ] = ACTIONS(780),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(813),
    [anon_sym_GT_EQ] = ACTIONS(813),
    [anon_sym_QMARK_QMARK] = ACTIONS(780),
    [anon_sym_instanceof] = ACTIONS(780),
    [anon_sym_PLUS_PLUS] = ACTIONS(813),
    [anon_sym_DASH_DASH] = ACTIONS(813),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(813),
    [sym_this] = ACTIONS(1727),
    [anon_sym_static] = ACTIONS(773),
    [anon_sym_get] = ACTIONS(773),
    [anon_sym_set] = ACTIONS(773),
    [anon_sym_declare] = ACTIONS(773),
    [anon_sym_public] = ACTIONS(773),
    [anon_sym_private] = ACTIONS(773),
    [anon_sym_protected] = ACTIONS(773),
    [anon_sym_module] = ACTIONS(773),
    [anon_sym_any] = ACTIONS(773),
    [anon_sym_number] = ACTIONS(773),
    [anon_sym_boolean] = ACTIONS(773),
    [anon_sym_string] = ACTIONS(773),
    [anon_sym_symbol] = ACTIONS(773),
    [sym_readonly] = ACTIONS(773),
  },
  [485] = {
    [sym__call_signature] = STATE(3191),
    [sym_formal_parameters] = STATE(2295),
    [sym_type_parameters] = STATE(3054),
    [sym_identifier] = ACTIONS(1631),
    [anon_sym_export] = ACTIONS(1633),
    [anon_sym_STAR] = ACTIONS(780),
    [anon_sym_EQ] = ACTIONS(777),
    [anon_sym_as] = ACTIONS(780),
    [anon_sym_namespace] = ACTIONS(1633),
    [anon_sym_COMMA] = ACTIONS(784),
    [anon_sym_type] = ACTIONS(1633),
    [anon_sym_BANG] = ACTIONS(780),
    [anon_sym_LPAREN] = ACTIONS(1679),
    [anon_sym_RPAREN] = ACTIONS(784),
    [anon_sym_in] = ACTIONS(780),
    [anon_sym_COLON] = ACTIONS(1736),
    [anon_sym_LBRACK] = ACTIONS(1639),
    [anon_sym_LT] = ACTIONS(1682),
    [anon_sym_GT] = ACTIONS(780),
    [anon_sym_SLASH] = ACTIONS(780),
    [anon_sym_DOT] = ACTIONS(1641),
    [anon_sym_async] = ACTIONS(1633),
    [anon_sym_function] = ACTIONS(1643),
    [anon_sym_EQ_GT] = ACTIONS(797),
    [anon_sym_QMARK_DOT] = ACTIONS(799),
    [anon_sym_PLUS_EQ] = ACTIONS(803),
    [anon_sym_DASH_EQ] = ACTIONS(803),
    [anon_sym_STAR_EQ] = ACTIONS(803),
    [anon_sym_SLASH_EQ] = ACTIONS(803),
    [anon_sym_PERCENT_EQ] = ACTIONS(803),
    [anon_sym_CARET_EQ] = ACTIONS(803),
    [anon_sym_AMP_EQ] = ACTIONS(803),
    [anon_sym_PIPE_EQ] = ACTIONS(803),
    [anon_sym_GT_GT_EQ] = ACTIONS(803),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(803),
    [anon_sym_LT_LT_EQ] = ACTIONS(803),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(803),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(803),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(803),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(803),
    [anon_sym_QMARK] = ACTIONS(1733),
    [anon_sym_AMP_AMP] = ACTIONS(780),
    [anon_sym_PIPE_PIPE] = ACTIONS(780),
    [anon_sym_GT_GT] = ACTIONS(780),
    [anon_sym_GT_GT_GT] = ACTIONS(780),
    [anon_sym_LT_LT] = ACTIONS(780),
    [anon_sym_AMP] = ACTIONS(780),
    [anon_sym_CARET] = ACTIONS(780),
    [anon_sym_PIPE] = ACTIONS(780),
    [anon_sym_PLUS] = ACTIONS(780),
    [anon_sym_DASH] = ACTIONS(780),
    [anon_sym_PERCENT] = ACTIONS(780),
    [anon_sym_STAR_STAR] = ACTIONS(780),
    [anon_sym_LT_EQ] = ACTIONS(813),
    [anon_sym_EQ_EQ] = ACTIONS(780),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(813),
    [anon_sym_BANG_EQ] = ACTIONS(780),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(813),
    [anon_sym_GT_EQ] = ACTIONS(813),
    [anon_sym_QMARK_QMARK] = ACTIONS(780),
    [anon_sym_instanceof] = ACTIONS(780),
    [anon_sym_PLUS_PLUS] = ACTIONS(813),
    [anon_sym_DASH_DASH] = ACTIONS(813),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(813),
    [anon_sym_static] = ACTIONS(1633),
    [anon_sym_get] = ACTIONS(1633),
    [anon_sym_set] = ACTIONS(1633),
    [anon_sym_declare] = ACTIONS(1633),
    [anon_sym_public] = ACTIONS(1633),
    [anon_sym_private] = ACTIONS(1633),
    [anon_sym_protected] = ACTIONS(1633),
    [anon_sym_module] = ACTIONS(1633),
    [anon_sym_any] = ACTIONS(1633),
    [anon_sym_number] = ACTIONS(1633),
    [anon_sym_boolean] = ACTIONS(1633),
    [anon_sym_string] = ACTIONS(1633),
    [anon_sym_symbol] = ACTIONS(1633),
    [sym_readonly] = ACTIONS(1633),
  },
  [486] = {
    [sym__call_signature] = STATE(3333),
    [sym_formal_parameters] = STATE(2295),
    [sym_type_parameters] = STATE(3054),
    [sym_identifier] = ACTIONS(1685),
    [anon_sym_export] = ACTIONS(1687),
    [anon_sym_STAR] = ACTIONS(780),
    [anon_sym_EQ] = ACTIONS(1135),
    [anon_sym_as] = ACTIONS(780),
    [anon_sym_namespace] = ACTIONS(1687),
    [anon_sym_LBRACE] = ACTIONS(780),
    [anon_sym_COMMA] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(1687),
    [anon_sym_BANG] = ACTIONS(780),
    [anon_sym_LPAREN] = ACTIONS(1679),
    [anon_sym_in] = ACTIONS(780),
    [anon_sym_LBRACK] = ACTIONS(1689),
    [anon_sym_LT] = ACTIONS(1682),
    [anon_sym_GT] = ACTIONS(780),
    [anon_sym_SLASH] = ACTIONS(780),
    [anon_sym_DOT] = ACTIONS(1691),
    [anon_sym_async] = ACTIONS(1687),
    [anon_sym_function] = ACTIONS(1693),
    [anon_sym_EQ_GT] = ACTIONS(1141),
    [anon_sym_QMARK_DOT] = ACTIONS(1143),
    [anon_sym_PLUS_EQ] = ACTIONS(803),
    [anon_sym_DASH_EQ] = ACTIONS(803),
    [anon_sym_STAR_EQ] = ACTIONS(803),
    [anon_sym_SLASH_EQ] = ACTIONS(803),
    [anon_sym_PERCENT_EQ] = ACTIONS(803),
    [anon_sym_CARET_EQ] = ACTIONS(803),
    [anon_sym_AMP_EQ] = ACTIONS(803),
    [anon_sym_PIPE_EQ] = ACTIONS(803),
    [anon_sym_GT_GT_EQ] = ACTIONS(803),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(803),
    [anon_sym_LT_LT_EQ] = ACTIONS(803),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(803),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(803),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(803),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(803),
    [anon_sym_QMARK] = ACTIONS(780),
    [anon_sym_AMP_AMP] = ACTIONS(780),
    [anon_sym_PIPE_PIPE] = ACTIONS(780),
    [anon_sym_GT_GT] = ACTIONS(780),
    [anon_sym_GT_GT_GT] = ACTIONS(780),
    [anon_sym_LT_LT] = ACTIONS(780),
    [anon_sym_AMP] = ACTIONS(780),
    [anon_sym_CARET] = ACTIONS(780),
    [anon_sym_PIPE] = ACTIONS(780),
    [anon_sym_PLUS] = ACTIONS(780),
    [anon_sym_DASH] = ACTIONS(780),
    [anon_sym_PERCENT] = ACTIONS(780),
    [anon_sym_STAR_STAR] = ACTIONS(780),
    [anon_sym_LT_EQ] = ACTIONS(813),
    [anon_sym_EQ_EQ] = ACTIONS(780),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(813),
    [anon_sym_BANG_EQ] = ACTIONS(780),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(813),
    [anon_sym_GT_EQ] = ACTIONS(813),
    [anon_sym_QMARK_QMARK] = ACTIONS(780),
    [anon_sym_instanceof] = ACTIONS(780),
    [anon_sym_PLUS_PLUS] = ACTIONS(813),
    [anon_sym_DASH_DASH] = ACTIONS(813),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(813),
    [anon_sym_static] = ACTIONS(1687),
    [anon_sym_get] = ACTIONS(1687),
    [anon_sym_set] = ACTIONS(1687),
    [anon_sym_declare] = ACTIONS(1687),
    [anon_sym_public] = ACTIONS(1687),
    [anon_sym_private] = ACTIONS(1687),
    [anon_sym_protected] = ACTIONS(1687),
    [anon_sym_module] = ACTIONS(1687),
    [anon_sym_any] = ACTIONS(1687),
    [anon_sym_number] = ACTIONS(1687),
    [anon_sym_boolean] = ACTIONS(1687),
    [anon_sym_string] = ACTIONS(1687),
    [anon_sym_symbol] = ACTIONS(1687),
    [sym_readonly] = ACTIONS(1687),
    [anon_sym_LBRACE_PIPE] = ACTIONS(813),
  },
  [487] = {
    [sym_object] = STATE(2474),
    [sym_array] = STATE(2475),
    [sym_identifier] = ACTIONS(1727),
    [anon_sym_export] = ACTIONS(773),
    [anon_sym_STAR] = ACTIONS(780),
    [anon_sym_EQ] = ACTIONS(777),
    [anon_sym_as] = ACTIONS(780),
    [anon_sym_namespace] = ACTIONS(773),
    [anon_sym_LBRACE] = ACTIONS(1729),
    [anon_sym_COMMA] = ACTIONS(784),
    [anon_sym_type] = ACTIONS(773),
    [anon_sym_BANG] = ACTIONS(780),
    [anon_sym_LPAREN] = ACTIONS(813),
    [anon_sym_RPAREN] = ACTIONS(784),
    [anon_sym_in] = ACTIONS(780),
    [anon_sym_COLON] = ACTIONS(1736),
    [anon_sym_LBRACK] = ACTIONS(1738),
    [anon_sym_LT] = ACTIONS(780),
    [anon_sym_GT] = ACTIONS(780),
    [anon_sym_SLASH] = ACTIONS(780),
    [anon_sym_DOT] = ACTIONS(1641),
    [anon_sym_async] = ACTIONS(773),
    [anon_sym_EQ_GT] = ACTIONS(797),
    [anon_sym_QMARK_DOT] = ACTIONS(799),
    [anon_sym_PLUS_EQ] = ACTIONS(803),
    [anon_sym_DASH_EQ] = ACTIONS(803),
    [anon_sym_STAR_EQ] = ACTIONS(803),
    [anon_sym_SLASH_EQ] = ACTIONS(803),
    [anon_sym_PERCENT_EQ] = ACTIONS(803),
    [anon_sym_CARET_EQ] = ACTIONS(803),
    [anon_sym_AMP_EQ] = ACTIONS(803),
    [anon_sym_PIPE_EQ] = ACTIONS(803),
    [anon_sym_GT_GT_EQ] = ACTIONS(803),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(803),
    [anon_sym_LT_LT_EQ] = ACTIONS(803),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(803),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(803),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(803),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(803),
    [anon_sym_QMARK] = ACTIONS(1733),
    [anon_sym_AMP_AMP] = ACTIONS(780),
    [anon_sym_PIPE_PIPE] = ACTIONS(780),
    [anon_sym_GT_GT] = ACTIONS(780),
    [anon_sym_GT_GT_GT] = ACTIONS(780),
    [anon_sym_LT_LT] = ACTIONS(780),
    [anon_sym_AMP] = ACTIONS(780),
    [anon_sym_CARET] = ACTIONS(780),
    [anon_sym_PIPE] = ACTIONS(780),
    [anon_sym_PLUS] = ACTIONS(780),
    [anon_sym_DASH] = ACTIONS(780),
    [anon_sym_PERCENT] = ACTIONS(780),
    [anon_sym_STAR_STAR] = ACTIONS(780),
    [anon_sym_LT_EQ] = ACTIONS(813),
    [anon_sym_EQ_EQ] = ACTIONS(780),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(813),
    [anon_sym_BANG_EQ] = ACTIONS(780),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(813),
    [anon_sym_GT_EQ] = ACTIONS(813),
    [anon_sym_QMARK_QMARK] = ACTIONS(780),
    [anon_sym_instanceof] = ACTIONS(780),
    [anon_sym_PLUS_PLUS] = ACTIONS(813),
    [anon_sym_DASH_DASH] = ACTIONS(813),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(813),
    [sym_this] = ACTIONS(1727),
    [anon_sym_static] = ACTIONS(773),
    [anon_sym_get] = ACTIONS(773),
    [anon_sym_set] = ACTIONS(773),
    [anon_sym_declare] = ACTIONS(773),
    [anon_sym_public] = ACTIONS(773),
    [anon_sym_private] = ACTIONS(773),
    [anon_sym_protected] = ACTIONS(773),
    [anon_sym_module] = ACTIONS(773),
    [anon_sym_any] = ACTIONS(773),
    [anon_sym_number] = ACTIONS(773),
    [anon_sym_boolean] = ACTIONS(773),
    [anon_sym_string] = ACTIONS(773),
    [anon_sym_symbol] = ACTIONS(773),
    [sym_readonly] = ACTIONS(773),
  },
  [488] = {
    [ts_builtin_sym_end] = ACTIONS(941),
    [sym_identifier] = ACTIONS(943),
    [anon_sym_export] = ACTIONS(943),
    [anon_sym_default] = ACTIONS(943),
    [anon_sym_namespace] = ACTIONS(943),
    [anon_sym_LBRACE] = ACTIONS(941),
    [anon_sym_COMMA] = ACTIONS(941),
    [anon_sym_RBRACE] = ACTIONS(941),
    [anon_sym_type] = ACTIONS(943),
    [anon_sym_typeof] = ACTIONS(943),
    [anon_sym_import] = ACTIONS(943),
    [anon_sym_var] = ACTIONS(943),
    [anon_sym_let] = ACTIONS(943),
    [anon_sym_const] = ACTIONS(943),
    [anon_sym_BANG] = ACTIONS(941),
    [anon_sym_else] = ACTIONS(943),
    [anon_sym_if] = ACTIONS(943),
    [anon_sym_switch] = ACTIONS(943),
    [anon_sym_for] = ACTIONS(943),
    [anon_sym_LPAREN] = ACTIONS(941),
    [anon_sym_await] = ACTIONS(943),
    [anon_sym_while] = ACTIONS(943),
    [anon_sym_do] = ACTIONS(943),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_with] = ACTIONS(943),
    [anon_sym_break] = ACTIONS(943),
    [anon_sym_continue] = ACTIONS(943),
    [anon_sym_debugger] = ACTIONS(943),
    [anon_sym_return] = ACTIONS(943),
    [anon_sym_throw] = ACTIONS(943),
    [anon_sym_SEMI] = ACTIONS(941),
    [anon_sym_case] = ACTIONS(943),
    [anon_sym_catch] = ACTIONS(943),
    [anon_sym_finally] = ACTIONS(943),
    [anon_sym_yield] = ACTIONS(943),
    [anon_sym_LBRACK] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(941),
    [anon_sym_SLASH] = ACTIONS(943),
    [anon_sym_class] = ACTIONS(943),
    [anon_sym_async] = ACTIONS(943),
    [anon_sym_function] = ACTIONS(943),
    [anon_sym_new] = ACTIONS(943),
    [anon_sym_PLUS] = ACTIONS(943),
    [anon_sym_DASH] = ACTIONS(943),
    [anon_sym_TILDE] = ACTIONS(941),
    [anon_sym_void] = ACTIONS(943),
    [anon_sym_delete] = ACTIONS(943),
    [anon_sym_PLUS_PLUS] = ACTIONS(941),
    [anon_sym_DASH_DASH] = ACTIONS(941),
    [anon_sym_DQUOTE] = ACTIONS(941),
    [anon_sym_SQUOTE] = ACTIONS(941),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(941),
    [sym_number] = ACTIONS(941),
    [sym_this] = ACTIONS(943),
    [sym_super] = ACTIONS(943),
    [sym_true] = ACTIONS(943),
    [sym_false] = ACTIONS(943),
    [sym_null] = ACTIONS(943),
    [sym_undefined] = ACTIONS(943),
    [anon_sym_AT] = ACTIONS(941),
    [anon_sym_static] = ACTIONS(943),
    [anon_sym_abstract] = ACTIONS(943),
    [anon_sym_get] = ACTIONS(943),
    [anon_sym_set] = ACTIONS(943),
    [anon_sym_declare] = ACTIONS(943),
    [anon_sym_public] = ACTIONS(943),
    [anon_sym_private] = ACTIONS(943),
    [anon_sym_protected] = ACTIONS(943),
    [anon_sym_module] = ACTIONS(943),
    [anon_sym_any] = ACTIONS(943),
    [anon_sym_number] = ACTIONS(943),
    [anon_sym_boolean] = ACTIONS(943),
    [anon_sym_string] = ACTIONS(943),
    [anon_sym_symbol] = ACTIONS(943),
    [anon_sym_interface] = ACTIONS(943),
    [anon_sym_enum] = ACTIONS(943),
    [sym_readonly] = ACTIONS(943),
    [sym__automatic_semicolon] = ACTIONS(949),
  },
  [489] = {
    [sym_type_arguments] = STATE(275),
    [ts_builtin_sym_end] = ACTIONS(1615),
    [sym_identifier] = ACTIONS(1617),
    [anon_sym_export] = ACTIONS(1617),
    [anon_sym_default] = ACTIONS(1617),
    [anon_sym_namespace] = ACTIONS(1617),
    [anon_sym_LBRACE] = ACTIONS(1615),
    [anon_sym_RBRACE] = ACTIONS(1615),
    [anon_sym_type] = ACTIONS(1617),
    [anon_sym_typeof] = ACTIONS(1617),
    [anon_sym_import] = ACTIONS(1617),
    [anon_sym_var] = ACTIONS(1617),
    [anon_sym_let] = ACTIONS(1617),
    [anon_sym_const] = ACTIONS(1617),
    [anon_sym_BANG] = ACTIONS(1615),
    [anon_sym_else] = ACTIONS(1617),
    [anon_sym_if] = ACTIONS(1617),
    [anon_sym_switch] = ACTIONS(1617),
    [anon_sym_for] = ACTIONS(1617),
    [anon_sym_LPAREN] = ACTIONS(1615),
    [anon_sym_await] = ACTIONS(1617),
    [anon_sym_while] = ACTIONS(1617),
    [anon_sym_do] = ACTIONS(1617),
    [anon_sym_try] = ACTIONS(1617),
    [anon_sym_with] = ACTIONS(1617),
    [anon_sym_break] = ACTIONS(1617),
    [anon_sym_continue] = ACTIONS(1617),
    [anon_sym_debugger] = ACTIONS(1617),
    [anon_sym_return] = ACTIONS(1617),
    [anon_sym_throw] = ACTIONS(1617),
    [anon_sym_SEMI] = ACTIONS(1615),
    [anon_sym_case] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(1617),
    [anon_sym_LBRACK] = ACTIONS(1615),
    [anon_sym_LT] = ACTIONS(1615),
    [anon_sym_SLASH] = ACTIONS(1617),
    [anon_sym_class] = ACTIONS(1617),
    [anon_sym_async] = ACTIONS(1617),
    [anon_sym_function] = ACTIONS(1617),
    [anon_sym_new] = ACTIONS(1617),
    [anon_sym_AMP] = ACTIONS(1615),
    [anon_sym_PIPE] = ACTIONS(1615),
    [anon_sym_PLUS] = ACTIONS(1617),
    [anon_sym_DASH] = ACTIONS(1617),
    [anon_sym_TILDE] = ACTIONS(1615),
    [anon_sym_void] = ACTIONS(1617),
    [anon_sym_delete] = ACTIONS(1617),
    [anon_sym_PLUS_PLUS] = ACTIONS(1615),
    [anon_sym_DASH_DASH] = ACTIONS(1615),
    [anon_sym_DQUOTE] = ACTIONS(1615),
    [anon_sym_SQUOTE] = ACTIONS(1615),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1615),
    [sym_number] = ACTIONS(1615),
    [sym_this] = ACTIONS(1617),
    [sym_super] = ACTIONS(1617),
    [sym_true] = ACTIONS(1617),
    [sym_false] = ACTIONS(1617),
    [sym_null] = ACTIONS(1617),
    [sym_undefined] = ACTIONS(1617),
    [anon_sym_AT] = ACTIONS(1615),
    [anon_sym_static] = ACTIONS(1617),
    [anon_sym_abstract] = ACTIONS(1617),
    [anon_sym_get] = ACTIONS(1617),
    [anon_sym_set] = ACTIONS(1617),
    [anon_sym_declare] = ACTIONS(1617),
    [anon_sym_public] = ACTIONS(1617),
    [anon_sym_private] = ACTIONS(1617),
    [anon_sym_protected] = ACTIONS(1617),
    [anon_sym_module] = ACTIONS(1617),
    [anon_sym_any] = ACTIONS(1617),
    [anon_sym_number] = ACTIONS(1617),
    [anon_sym_boolean] = ACTIONS(1617),
    [anon_sym_string] = ACTIONS(1617),
    [anon_sym_symbol] = ACTIONS(1617),
    [anon_sym_interface] = ACTIONS(1617),
    [anon_sym_extends] = ACTIONS(1617),
    [anon_sym_enum] = ACTIONS(1617),
    [sym_readonly] = ACTIONS(1617),
  },
  [490] = {
    [sym__call_signature] = STATE(3191),
    [sym_formal_parameters] = STATE(2295),
    [sym_type_parameters] = STATE(3054),
    [sym_identifier] = ACTIONS(1631),
    [anon_sym_export] = ACTIONS(1633),
    [anon_sym_STAR] = ACTIONS(780),
    [anon_sym_EQ] = ACTIONS(777),
    [anon_sym_as] = ACTIONS(780),
    [anon_sym_namespace] = ACTIONS(1633),
    [anon_sym_COMMA] = ACTIONS(784),
    [anon_sym_type] = ACTIONS(1633),
    [anon_sym_BANG] = ACTIONS(780),
    [anon_sym_LPAREN] = ACTIONS(1679),
    [anon_sym_RPAREN] = ACTIONS(784),
    [anon_sym_in] = ACTIONS(780),
    [anon_sym_COLON] = ACTIONS(784),
    [anon_sym_LBRACK] = ACTIONS(1639),
    [anon_sym_LT] = ACTIONS(1682),
    [anon_sym_GT] = ACTIONS(780),
    [anon_sym_SLASH] = ACTIONS(780),
    [anon_sym_DOT] = ACTIONS(1641),
    [anon_sym_async] = ACTIONS(1633),
    [anon_sym_function] = ACTIONS(1643),
    [anon_sym_EQ_GT] = ACTIONS(797),
    [anon_sym_QMARK_DOT] = ACTIONS(799),
    [anon_sym_PLUS_EQ] = ACTIONS(803),
    [anon_sym_DASH_EQ] = ACTIONS(803),
    [anon_sym_STAR_EQ] = ACTIONS(803),
    [anon_sym_SLASH_EQ] = ACTIONS(803),
    [anon_sym_PERCENT_EQ] = ACTIONS(803),
    [anon_sym_CARET_EQ] = ACTIONS(803),
    [anon_sym_AMP_EQ] = ACTIONS(803),
    [anon_sym_PIPE_EQ] = ACTIONS(803),
    [anon_sym_GT_GT_EQ] = ACTIONS(803),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(803),
    [anon_sym_LT_LT_EQ] = ACTIONS(803),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(803),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(803),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(803),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(803),
    [anon_sym_QMARK] = ACTIONS(1733),
    [anon_sym_AMP_AMP] = ACTIONS(780),
    [anon_sym_PIPE_PIPE] = ACTIONS(780),
    [anon_sym_GT_GT] = ACTIONS(780),
    [anon_sym_GT_GT_GT] = ACTIONS(780),
    [anon_sym_LT_LT] = ACTIONS(780),
    [anon_sym_AMP] = ACTIONS(780),
    [anon_sym_CARET] = ACTIONS(780),
    [anon_sym_PIPE] = ACTIONS(780),
    [anon_sym_PLUS] = ACTIONS(780),
    [anon_sym_DASH] = ACTIONS(780),
    [anon_sym_PERCENT] = ACTIONS(780),
    [anon_sym_STAR_STAR] = ACTIONS(780),
    [anon_sym_LT_EQ] = ACTIONS(813),
    [anon_sym_EQ_EQ] = ACTIONS(780),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(813),
    [anon_sym_BANG_EQ] = ACTIONS(780),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(813),
    [anon_sym_GT_EQ] = ACTIONS(813),
    [anon_sym_QMARK_QMARK] = ACTIONS(780),
    [anon_sym_instanceof] = ACTIONS(780),
    [anon_sym_PLUS_PLUS] = ACTIONS(813),
    [anon_sym_DASH_DASH] = ACTIONS(813),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(813),
    [anon_sym_static] = ACTIONS(1633),
    [anon_sym_get] = ACTIONS(1633),
    [anon_sym_set] = ACTIONS(1633),
    [anon_sym_declare] = ACTIONS(1633),
    [anon_sym_public] = ACTIONS(1633),
    [anon_sym_private] = ACTIONS(1633),
    [anon_sym_protected] = ACTIONS(1633),
    [anon_sym_module] = ACTIONS(1633),
    [anon_sym_any] = ACTIONS(1633),
    [anon_sym_number] = ACTIONS(1633),
    [anon_sym_boolean] = ACTIONS(1633),
    [anon_sym_string] = ACTIONS(1633),
    [anon_sym_symbol] = ACTIONS(1633),
    [sym_readonly] = ACTIONS(1633),
  },
  [491] = {
    [ts_builtin_sym_end] = ACTIONS(1559),
    [sym_identifier] = ACTIONS(1561),
    [anon_sym_export] = ACTIONS(1561),
    [anon_sym_default] = ACTIONS(1561),
    [anon_sym_namespace] = ACTIONS(1561),
    [anon_sym_LBRACE] = ACTIONS(1559),
    [anon_sym_RBRACE] = ACTIONS(1559),
    [anon_sym_type] = ACTIONS(1561),
    [anon_sym_typeof] = ACTIONS(1561),
    [anon_sym_import] = ACTIONS(1561),
    [anon_sym_var] = ACTIONS(1561),
    [anon_sym_let] = ACTIONS(1561),
    [anon_sym_const] = ACTIONS(1561),
    [anon_sym_BANG] = ACTIONS(1559),
    [anon_sym_else] = ACTIONS(1561),
    [anon_sym_if] = ACTIONS(1561),
    [anon_sym_switch] = ACTIONS(1561),
    [anon_sym_for] = ACTIONS(1561),
    [anon_sym_LPAREN] = ACTIONS(1559),
    [anon_sym_await] = ACTIONS(1561),
    [anon_sym_while] = ACTIONS(1561),
    [anon_sym_do] = ACTIONS(1561),
    [anon_sym_try] = ACTIONS(1561),
    [anon_sym_with] = ACTIONS(1561),
    [anon_sym_break] = ACTIONS(1561),
    [anon_sym_continue] = ACTIONS(1561),
    [anon_sym_debugger] = ACTIONS(1561),
    [anon_sym_return] = ACTIONS(1561),
    [anon_sym_throw] = ACTIONS(1561),
    [anon_sym_SEMI] = ACTIONS(1559),
    [anon_sym_case] = ACTIONS(1561),
    [anon_sym_yield] = ACTIONS(1561),
    [anon_sym_LBRACK] = ACTIONS(1559),
    [anon_sym_LT] = ACTIONS(1559),
    [anon_sym_SLASH] = ACTIONS(1561),
    [anon_sym_DOT] = ACTIONS(1704),
    [anon_sym_class] = ACTIONS(1561),
    [anon_sym_async] = ACTIONS(1561),
    [anon_sym_function] = ACTIONS(1561),
    [anon_sym_new] = ACTIONS(1561),
    [anon_sym_AMP] = ACTIONS(1559),
    [anon_sym_PIPE] = ACTIONS(1559),
    [anon_sym_PLUS] = ACTIONS(1561),
    [anon_sym_DASH] = ACTIONS(1561),
    [anon_sym_TILDE] = ACTIONS(1559),
    [anon_sym_void] = ACTIONS(1561),
    [anon_sym_delete] = ACTIONS(1561),
    [anon_sym_PLUS_PLUS] = ACTIONS(1559),
    [anon_sym_DASH_DASH] = ACTIONS(1559),
    [anon_sym_DQUOTE] = ACTIONS(1559),
    [anon_sym_SQUOTE] = ACTIONS(1559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1559),
    [sym_number] = ACTIONS(1559),
    [sym_this] = ACTIONS(1561),
    [sym_super] = ACTIONS(1561),
    [sym_true] = ACTIONS(1561),
    [sym_false] = ACTIONS(1561),
    [sym_null] = ACTIONS(1561),
    [sym_undefined] = ACTIONS(1561),
    [anon_sym_AT] = ACTIONS(1559),
    [anon_sym_static] = ACTIONS(1561),
    [anon_sym_abstract] = ACTIONS(1561),
    [anon_sym_get] = ACTIONS(1561),
    [anon_sym_set] = ACTIONS(1561),
    [anon_sym_declare] = ACTIONS(1561),
    [anon_sym_public] = ACTIONS(1561),
    [anon_sym_private] = ACTIONS(1561),
    [anon_sym_protected] = ACTIONS(1561),
    [anon_sym_module] = ACTIONS(1561),
    [anon_sym_any] = ACTIONS(1561),
    [anon_sym_number] = ACTIONS(1561),
    [anon_sym_boolean] = ACTIONS(1561),
    [anon_sym_string] = ACTIONS(1561),
    [anon_sym_symbol] = ACTIONS(1561),
    [anon_sym_interface] = ACTIONS(1561),
    [anon_sym_extends] = ACTIONS(1561),
    [anon_sym_enum] = ACTIONS(1561),
    [sym_readonly] = ACTIONS(1561),
  },
  [492] = {
    [sym_catch_clause] = STATE(516),
    [sym_finally_clause] = STATE(546),
    [ts_builtin_sym_end] = ACTIONS(1740),
    [sym_identifier] = ACTIONS(1742),
    [anon_sym_export] = ACTIONS(1742),
    [anon_sym_default] = ACTIONS(1742),
    [anon_sym_namespace] = ACTIONS(1742),
    [anon_sym_LBRACE] = ACTIONS(1740),
    [anon_sym_RBRACE] = ACTIONS(1740),
    [anon_sym_type] = ACTIONS(1742),
    [anon_sym_typeof] = ACTIONS(1742),
    [anon_sym_import] = ACTIONS(1742),
    [anon_sym_var] = ACTIONS(1742),
    [anon_sym_let] = ACTIONS(1742),
    [anon_sym_const] = ACTIONS(1742),
    [anon_sym_BANG] = ACTIONS(1740),
    [anon_sym_else] = ACTIONS(1742),
    [anon_sym_if] = ACTIONS(1742),
    [anon_sym_switch] = ACTIONS(1742),
    [anon_sym_for] = ACTIONS(1742),
    [anon_sym_LPAREN] = ACTIONS(1740),
    [anon_sym_await] = ACTIONS(1742),
    [anon_sym_while] = ACTIONS(1742),
    [anon_sym_do] = ACTIONS(1742),
    [anon_sym_try] = ACTIONS(1742),
    [anon_sym_with] = ACTIONS(1742),
    [anon_sym_break] = ACTIONS(1742),
    [anon_sym_continue] = ACTIONS(1742),
    [anon_sym_debugger] = ACTIONS(1742),
    [anon_sym_return] = ACTIONS(1742),
    [anon_sym_throw] = ACTIONS(1742),
    [anon_sym_SEMI] = ACTIONS(1740),
    [anon_sym_case] = ACTIONS(1742),
    [anon_sym_catch] = ACTIONS(1744),
    [anon_sym_finally] = ACTIONS(1746),
    [anon_sym_yield] = ACTIONS(1742),
    [anon_sym_LBRACK] = ACTIONS(1740),
    [anon_sym_LT] = ACTIONS(1740),
    [anon_sym_SLASH] = ACTIONS(1742),
    [anon_sym_class] = ACTIONS(1742),
    [anon_sym_async] = ACTIONS(1742),
    [anon_sym_function] = ACTIONS(1742),
    [anon_sym_new] = ACTIONS(1742),
    [anon_sym_PLUS] = ACTIONS(1742),
    [anon_sym_DASH] = ACTIONS(1742),
    [anon_sym_TILDE] = ACTIONS(1740),
    [anon_sym_void] = ACTIONS(1742),
    [anon_sym_delete] = ACTIONS(1742),
    [anon_sym_PLUS_PLUS] = ACTIONS(1740),
    [anon_sym_DASH_DASH] = ACTIONS(1740),
    [anon_sym_DQUOTE] = ACTIONS(1740),
    [anon_sym_SQUOTE] = ACTIONS(1740),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_number] = ACTIONS(1740),
    [sym_this] = ACTIONS(1742),
    [sym_super] = ACTIONS(1742),
    [sym_true] = ACTIONS(1742),
    [sym_false] = ACTIONS(1742),
    [sym_null] = ACTIONS(1742),
    [sym_undefined] = ACTIONS(1742),
    [anon_sym_AT] = ACTIONS(1740),
    [anon_sym_static] = ACTIONS(1742),
    [anon_sym_abstract] = ACTIONS(1742),
    [anon_sym_get] = ACTIONS(1742),
    [anon_sym_set] = ACTIONS(1742),
    [anon_sym_declare] = ACTIONS(1742),
    [anon_sym_public] = ACTIONS(1742),
    [anon_sym_private] = ACTIONS(1742),
    [anon_sym_protected] = ACTIONS(1742),
    [anon_sym_module] = ACTIONS(1742),
    [anon_sym_any] = ACTIONS(1742),
    [anon_sym_number] = ACTIONS(1742),
    [anon_sym_boolean] = ACTIONS(1742),
    [anon_sym_string] = ACTIONS(1742),
    [anon_sym_symbol] = ACTIONS(1742),
    [anon_sym_interface] = ACTIONS(1742),
    [anon_sym_enum] = ACTIONS(1742),
    [sym_readonly] = ACTIONS(1742),
  },
  [493] = {
    [sym__call_signature] = STATE(3191),
    [sym_formal_parameters] = STATE(2295),
    [sym_type_parameters] = STATE(3054),
    [sym_identifier] = ACTIONS(1631),
    [anon_sym_export] = ACTIONS(1633),
    [anon_sym_STAR] = ACTIONS(780),
    [anon_sym_EQ] = ACTIONS(913),
    [anon_sym_as] = ACTIONS(780),
    [anon_sym_namespace] = ACTIONS(1633),
    [anon_sym_COMMA] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(1633),
    [anon_sym_BANG] = ACTIONS(780),
    [anon_sym_LPAREN] = ACTIONS(1679),
    [anon_sym_in] = ACTIONS(780),
    [anon_sym_COLON] = ACTIONS(1748),
    [anon_sym_LBRACK] = ACTIONS(1639),
    [anon_sym_RBRACK] = ACTIONS(813),
    [anon_sym_LT] = ACTIONS(1682),
    [anon_sym_GT] = ACTIONS(780),
    [anon_sym_SLASH] = ACTIONS(780),
    [anon_sym_DOT] = ACTIONS(1641),
    [anon_sym_async] = ACTIONS(1633),
    [anon_sym_function] = ACTIONS(1643),
    [anon_sym_EQ_GT] = ACTIONS(797),
    [anon_sym_QMARK_DOT] = ACTIONS(799),
    [anon_sym_PLUS_EQ] = ACTIONS(803),
    [anon_sym_DASH_EQ] = ACTIONS(803),
    [anon_sym_STAR_EQ] = ACTIONS(803),
    [anon_sym_SLASH_EQ] = ACTIONS(803),
    [anon_sym_PERCENT_EQ] = ACTIONS(803),
    [anon_sym_CARET_EQ] = ACTIONS(803),
    [anon_sym_AMP_EQ] = ACTIONS(803),
    [anon_sym_PIPE_EQ] = ACTIONS(803),
    [anon_sym_GT_GT_EQ] = ACTIONS(803),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(803),
    [anon_sym_LT_LT_EQ] = ACTIONS(803),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(803),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(803),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(803),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(803),
    [anon_sym_QMARK] = ACTIONS(780),
    [anon_sym_AMP_AMP] = ACTIONS(780),
    [anon_sym_PIPE_PIPE] = ACTIONS(780),
    [anon_sym_GT_GT] = ACTIONS(780),
    [anon_sym_GT_GT_GT] = ACTIONS(780),
    [anon_sym_LT_LT] = ACTIONS(780),
    [anon_sym_AMP] = ACTIONS(780),
    [anon_sym_CARET] = ACTIONS(780),
    [anon_sym_PIPE] = ACTIONS(780),
    [anon_sym_PLUS] = ACTIONS(780),
    [anon_sym_DASH] = ACTIONS(780),
    [anon_sym_PERCENT] = ACTIONS(780),
    [anon_sym_STAR_STAR] = ACTIONS(780),
    [anon_sym_LT_EQ] = ACTIONS(813),
    [anon_sym_EQ_EQ] = ACTIONS(780),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(813),
    [anon_sym_BANG_EQ] = ACTIONS(780),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(813),
    [anon_sym_GT_EQ] = ACTIONS(813),
    [anon_sym_QMARK_QMARK] = ACTIONS(780),
    [anon_sym_instanceof] = ACTIONS(780),
    [anon_sym_PLUS_PLUS] = ACTIONS(813),
    [anon_sym_DASH_DASH] = ACTIONS(813),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(813),
    [anon_sym_static] = ACTIONS(1633),
    [anon_sym_get] = ACTIONS(1633),
    [anon_sym_set] = ACTIONS(1633),
    [anon_sym_declare] = ACTIONS(1633),
    [anon_sym_public] = ACTIONS(1633),
    [anon_sym_private] = ACTIONS(1633),
    [anon_sym_protected] = ACTIONS(1633),
    [anon_sym_module] = ACTIONS(1633),
    [anon_sym_any] = ACTIONS(1633),
    [anon_sym_number] = ACTIONS(1633),
    [anon_sym_boolean] = ACTIONS(1633),
    [anon_sym_string] = ACTIONS(1633),
    [anon_sym_symbol] = ACTIONS(1633),
    [sym_readonly] = ACTIONS(1633),
  },
  [494] = {
    [sym_type_arguments] = STATE(275),
    [ts_builtin_sym_end] = ACTIONS(1750),
    [sym_identifier] = ACTIONS(1752),
    [anon_sym_export] = ACTIONS(1752),
    [anon_sym_default] = ACTIONS(1752),
    [anon_sym_namespace] = ACTIONS(1752),
    [anon_sym_LBRACE] = ACTIONS(1750),
    [anon_sym_RBRACE] = ACTIONS(1750),
    [anon_sym_type] = ACTIONS(1752),
    [anon_sym_typeof] = ACTIONS(1752),
    [anon_sym_import] = ACTIONS(1752),
    [anon_sym_var] = ACTIONS(1752),
    [anon_sym_let] = ACTIONS(1752),
    [anon_sym_const] = ACTIONS(1752),
    [anon_sym_BANG] = ACTIONS(1750),
    [anon_sym_else] = ACTIONS(1752),
    [anon_sym_if] = ACTIONS(1752),
    [anon_sym_switch] = ACTIONS(1752),
    [anon_sym_for] = ACTIONS(1752),
    [anon_sym_LPAREN] = ACTIONS(1750),
    [anon_sym_await] = ACTIONS(1752),
    [anon_sym_while] = ACTIONS(1752),
    [anon_sym_do] = ACTIONS(1752),
    [anon_sym_try] = ACTIONS(1752),
    [anon_sym_with] = ACTIONS(1752),
    [anon_sym_break] = ACTIONS(1752),
    [anon_sym_continue] = ACTIONS(1752),
    [anon_sym_debugger] = ACTIONS(1752),
    [anon_sym_return] = ACTIONS(1752),
    [anon_sym_throw] = ACTIONS(1752),
    [anon_sym_SEMI] = ACTIONS(1750),
    [anon_sym_case] = ACTIONS(1752),
    [anon_sym_yield] = ACTIONS(1752),
    [anon_sym_LBRACK] = ACTIONS(1750),
    [anon_sym_LT] = ACTIONS(1754),
    [anon_sym_SLASH] = ACTIONS(1752),
    [anon_sym_class] = ACTIONS(1752),
    [anon_sym_async] = ACTIONS(1752),
    [anon_sym_function] = ACTIONS(1752),
    [anon_sym_new] = ACTIONS(1752),
    [anon_sym_AMP] = ACTIONS(1750),
    [anon_sym_PIPE] = ACTIONS(1750),
    [anon_sym_PLUS] = ACTIONS(1752),
    [anon_sym_DASH] = ACTIONS(1752),
    [anon_sym_TILDE] = ACTIONS(1750),
    [anon_sym_void] = ACTIONS(1752),
    [anon_sym_delete] = ACTIONS(1752),
    [anon_sym_PLUS_PLUS] = ACTIONS(1750),
    [anon_sym_DASH_DASH] = ACTIONS(1750),
    [anon_sym_DQUOTE] = ACTIONS(1750),
    [anon_sym_SQUOTE] = ACTIONS(1750),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1750),
    [sym_number] = ACTIONS(1750),
    [sym_this] = ACTIONS(1752),
    [sym_super] = ACTIONS(1752),
    [sym_true] = ACTIONS(1752),
    [sym_false] = ACTIONS(1752),
    [sym_null] = ACTIONS(1752),
    [sym_undefined] = ACTIONS(1752),
    [anon_sym_AT] = ACTIONS(1750),
    [anon_sym_static] = ACTIONS(1752),
    [anon_sym_abstract] = ACTIONS(1752),
    [anon_sym_get] = ACTIONS(1752),
    [anon_sym_set] = ACTIONS(1752),
    [anon_sym_declare] = ACTIONS(1752),
    [anon_sym_public] = ACTIONS(1752),
    [anon_sym_private] = ACTIONS(1752),
    [anon_sym_protected] = ACTIONS(1752),
    [anon_sym_module] = ACTIONS(1752),
    [anon_sym_any] = ACTIONS(1752),
    [anon_sym_number] = ACTIONS(1752),
    [anon_sym_boolean] = ACTIONS(1752),
    [anon_sym_string] = ACTIONS(1752),
    [anon_sym_symbol] = ACTIONS(1752),
    [anon_sym_interface] = ACTIONS(1752),
    [anon_sym_extends] = ACTIONS(1752),
    [anon_sym_enum] = ACTIONS(1752),
    [sym_readonly] = ACTIONS(1752),
  },
  [495] = {
    [sym__call_signature] = STATE(3352),
    [sym_formal_parameters] = STATE(2295),
    [sym_type_parameters] = STATE(3054),
    [sym_identifier] = ACTIONS(1675),
    [anon_sym_export] = ACTIONS(1677),
    [anon_sym_STAR] = ACTIONS(780),
    [anon_sym_EQ] = ACTIONS(1083),
    [anon_sym_as] = ACTIONS(780),
    [anon_sym_namespace] = ACTIONS(1677),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_COMMA] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(1677),
    [anon_sym_BANG] = ACTIONS(780),
    [anon_sym_LPAREN] = ACTIONS(1679),
    [anon_sym_in] = ACTIONS(780),
    [anon_sym_LBRACK] = ACTIONS(1639),
    [anon_sym_LT] = ACTIONS(1682),
    [anon_sym_GT] = ACTIONS(780),
    [anon_sym_SLASH] = ACTIONS(780),
    [anon_sym_DOT] = ACTIONS(1641),
    [anon_sym_async] = ACTIONS(1677),
    [anon_sym_function] = ACTIONS(1643),
    [anon_sym_EQ_GT] = ACTIONS(1085),
    [anon_sym_QMARK_DOT] = ACTIONS(799),
    [anon_sym_PLUS_EQ] = ACTIONS(803),
    [anon_sym_DASH_EQ] = ACTIONS(803),
    [anon_sym_STAR_EQ] = ACTIONS(803),
    [anon_sym_SLASH_EQ] = ACTIONS(803),
    [anon_sym_PERCENT_EQ] = ACTIONS(803),
    [anon_sym_CARET_EQ] = ACTIONS(803),
    [anon_sym_AMP_EQ] = ACTIONS(803),
    [anon_sym_PIPE_EQ] = ACTIONS(803),
    [anon_sym_GT_GT_EQ] = ACTIONS(803),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(803),
    [anon_sym_LT_LT_EQ] = ACTIONS(803),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(803),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(803),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(803),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(803),
    [anon_sym_QMARK] = ACTIONS(780),
    [anon_sym_AMP_AMP] = ACTIONS(780),
    [anon_sym_PIPE_PIPE] = ACTIONS(780),
    [anon_sym_GT_GT] = ACTIONS(780),
    [anon_sym_GT_GT_GT] = ACTIONS(780),
    [anon_sym_LT_LT] = ACTIONS(780),
    [anon_sym_AMP] = ACTIONS(780),
    [anon_sym_CARET] = ACTIONS(780),
    [anon_sym_PIPE] = ACTIONS(780),
    [anon_sym_PLUS] = ACTIONS(780),
    [anon_sym_DASH] = ACTIONS(780),
    [anon_sym_PERCENT] = ACTIONS(780),
    [anon_sym_STAR_STAR] = ACTIONS(780),
    [anon_sym_LT_EQ] = ACTIONS(813),
    [anon_sym_EQ_EQ] = ACTIONS(780),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(813),
    [anon_sym_BANG_EQ] = ACTIONS(780),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(813),
    [anon_sym_GT_EQ] = ACTIONS(813),
    [anon_sym_QMARK_QMARK] = ACTIONS(780),
    [anon_sym_instanceof] = ACTIONS(780),
    [anon_sym_PLUS_PLUS] = ACTIONS(813),
    [anon_sym_DASH_DASH] = ACTIONS(813),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(813),
    [anon_sym_static] = ACTIONS(1677),
    [anon_sym_get] = ACTIONS(1677),
    [anon_sym_set] = ACTIONS(1677),
    [anon_sym_declare] = ACTIONS(1677),
    [anon_sym_public] = ACTIONS(1677),
    [anon_sym_private] = ACTIONS(1677),
    [anon_sym_protected] = ACTIONS(1677),
    [anon_sym_module] = ACTIONS(1677),
    [anon_sym_any] = ACTIONS(1677),
    [anon_sym_number] = ACTIONS(1677),
    [anon_sym_boolean] = ACTIONS(1677),
    [anon_sym_string] = ACTIONS(1677),
    [anon_sym_symbol] = ACTIONS(1677),
    [anon_sym_implements] = ACTIONS(780),
    [sym_readonly] = ACTIONS(1677),
  },
  [496] = {
    [ts_builtin_sym_end] = ACTIONS(1015),
    [sym_identifier] = ACTIONS(1017),
    [anon_sym_export] = ACTIONS(1017),
    [anon_sym_default] = ACTIONS(1017),
    [anon_sym_namespace] = ACTIONS(1017),
    [anon_sym_LBRACE] = ACTIONS(1015),
    [anon_sym_RBRACE] = ACTIONS(1015),
    [anon_sym_type] = ACTIONS(1017),
    [anon_sym_typeof] = ACTIONS(1017),
    [anon_sym_import] = ACTIONS(1017),
    [anon_sym_var] = ACTIONS(1017),
    [anon_sym_let] = ACTIONS(1017),
    [anon_sym_const] = ACTIONS(1017),
    [anon_sym_BANG] = ACTIONS(1015),
    [anon_sym_else] = ACTIONS(1017),
    [anon_sym_if] = ACTIONS(1017),
    [anon_sym_switch] = ACTIONS(1017),
    [anon_sym_for] = ACTIONS(1017),
    [anon_sym_LPAREN] = ACTIONS(1015),
    [anon_sym_await] = ACTIONS(1017),
    [anon_sym_while] = ACTIONS(1017),
    [anon_sym_do] = ACTIONS(1017),
    [anon_sym_try] = ACTIONS(1017),
    [anon_sym_with] = ACTIONS(1017),
    [anon_sym_break] = ACTIONS(1017),
    [anon_sym_continue] = ACTIONS(1017),
    [anon_sym_debugger] = ACTIONS(1017),
    [anon_sym_return] = ACTIONS(1017),
    [anon_sym_throw] = ACTIONS(1017),
    [anon_sym_SEMI] = ACTIONS(1015),
    [anon_sym_case] = ACTIONS(1017),
    [anon_sym_yield] = ACTIONS(1017),
    [anon_sym_LBRACK] = ACTIONS(1015),
    [anon_sym_LT] = ACTIONS(1757),
    [anon_sym_SLASH] = ACTIONS(1017),
    [anon_sym_DOT] = ACTIONS(1017),
    [anon_sym_class] = ACTIONS(1017),
    [anon_sym_async] = ACTIONS(1017),
    [anon_sym_function] = ACTIONS(1017),
    [anon_sym_new] = ACTIONS(1017),
    [anon_sym_AMP] = ACTIONS(1015),
    [anon_sym_PIPE] = ACTIONS(1015),
    [anon_sym_PLUS] = ACTIONS(1017),
    [anon_sym_DASH] = ACTIONS(1017),
    [anon_sym_TILDE] = ACTIONS(1015),
    [anon_sym_void] = ACTIONS(1017),
    [anon_sym_delete] = ACTIONS(1017),
    [anon_sym_PLUS_PLUS] = ACTIONS(1015),
    [anon_sym_DASH_DASH] = ACTIONS(1015),
    [anon_sym_DQUOTE] = ACTIONS(1015),
    [anon_sym_SQUOTE] = ACTIONS(1015),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1015),
    [sym_number] = ACTIONS(1015),
    [sym_this] = ACTIONS(1017),
    [sym_super] = ACTIONS(1017),
    [sym_true] = ACTIONS(1017),
    [sym_false] = ACTIONS(1017),
    [sym_null] = ACTIONS(1017),
    [sym_undefined] = ACTIONS(1017),
    [anon_sym_AT] = ACTIONS(1015),
    [anon_sym_static] = ACTIONS(1017),
    [anon_sym_abstract] = ACTIONS(1017),
    [anon_sym_get] = ACTIONS(1017),
    [anon_sym_set] = ACTIONS(1017),
    [anon_sym_declare] = ACTIONS(1017),
    [anon_sym_public] = ACTIONS(1017),
    [anon_sym_private] = ACTIONS(1017),
    [anon_sym_protected] = ACTIONS(1017),
    [anon_sym_module] = ACTIONS(1017),
    [anon_sym_any] = ACTIONS(1017),
    [anon_sym_number] = ACTIONS(1017),
    [anon_sym_boolean] = ACTIONS(1017),
    [anon_sym_string] = ACTIONS(1017),
    [anon_sym_symbol] = ACTIONS(1017),
    [anon_sym_interface] = ACTIONS(1017),
    [anon_sym_extends] = ACTIONS(1017),
    [anon_sym_enum] = ACTIONS(1017),
    [sym_readonly] = ACTIONS(1017),
  },
  [497] = {
    [sym__call_signature] = STATE(3248),
    [sym_formal_parameters] = STATE(2295),
    [sym_type_parameters] = STATE(3054),
    [sym_identifier] = ACTIONS(1706),
    [anon_sym_export] = ACTIONS(1708),
    [anon_sym_STAR] = ACTIONS(780),
    [anon_sym_EQ] = ACTIONS(1067),
    [anon_sym_as] = ACTIONS(780),
    [anon_sym_namespace] = ACTIONS(1708),
    [anon_sym_type] = ACTIONS(1708),
    [anon_sym_BANG] = ACTIONS(780),
    [anon_sym_LPAREN] = ACTIONS(1679),
    [anon_sym_in] = ACTIONS(780),
    [anon_sym_SEMI] = ACTIONS(813),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_LT] = ACTIONS(1682),
    [anon_sym_GT] = ACTIONS(780),
    [anon_sym_SLASH] = ACTIONS(780),
    [anon_sym_DOT] = ACTIONS(1228),
    [anon_sym_async] = ACTIONS(1708),
    [anon_sym_function] = ACTIONS(1760),
    [anon_sym_EQ_GT] = ACTIONS(1069),
    [anon_sym_QMARK_DOT] = ACTIONS(931),
    [anon_sym_PLUS_EQ] = ACTIONS(803),
    [anon_sym_DASH_EQ] = ACTIONS(803),
    [anon_sym_STAR_EQ] = ACTIONS(803),
    [anon_sym_SLASH_EQ] = ACTIONS(803),
    [anon_sym_PERCENT_EQ] = ACTIONS(803),
    [anon_sym_CARET_EQ] = ACTIONS(803),
    [anon_sym_AMP_EQ] = ACTIONS(803),
    [anon_sym_PIPE_EQ] = ACTIONS(803),
    [anon_sym_GT_GT_EQ] = ACTIONS(803),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(803),
    [anon_sym_LT_LT_EQ] = ACTIONS(803),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(803),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(803),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(803),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(803),
    [anon_sym_QMARK] = ACTIONS(780),
    [anon_sym_AMP_AMP] = ACTIONS(780),
    [anon_sym_PIPE_PIPE] = ACTIONS(780),
    [anon_sym_GT_GT] = ACTIONS(780),
    [anon_sym_GT_GT_GT] = ACTIONS(780),
    [anon_sym_LT_LT] = ACTIONS(780),
    [anon_sym_AMP] = ACTIONS(780),
    [anon_sym_CARET] = ACTIONS(780),
    [anon_sym_PIPE] = ACTIONS(780),
    [anon_sym_PLUS] = ACTIONS(780),
    [anon_sym_DASH] = ACTIONS(780),
    [anon_sym_PERCENT] = ACTIONS(780),
    [anon_sym_STAR_STAR] = ACTIONS(780),
    [anon_sym_LT_EQ] = ACTIONS(813),
    [anon_sym_EQ_EQ] = ACTIONS(780),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(813),
    [anon_sym_BANG_EQ] = ACTIONS(780),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(813),
    [anon_sym_GT_EQ] = ACTIONS(813),
    [anon_sym_QMARK_QMARK] = ACTIONS(780),
    [anon_sym_instanceof] = ACTIONS(780),
    [anon_sym_PLUS_PLUS] = ACTIONS(813),
    [anon_sym_DASH_DASH] = ACTIONS(813),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(813),
    [anon_sym_static] = ACTIONS(1708),
    [anon_sym_get] = ACTIONS(1708),
    [anon_sym_set] = ACTIONS(1708),
    [anon_sym_declare] = ACTIONS(1708),
    [anon_sym_public] = ACTIONS(1708),
    [anon_sym_private] = ACTIONS(1708),
    [anon_sym_protected] = ACTIONS(1708),
    [anon_sym_module] = ACTIONS(1708),
    [anon_sym_any] = ACTIONS(1708),
    [anon_sym_number] = ACTIONS(1708),
    [anon_sym_boolean] = ACTIONS(1708),
    [anon_sym_string] = ACTIONS(1708),
    [anon_sym_symbol] = ACTIONS(1708),
    [sym_readonly] = ACTIONS(1708),
    [sym__automatic_semicolon] = ACTIONS(813),
  },
  [498] = {
    [sym__call_signature] = STATE(3164),
    [sym_formal_parameters] = STATE(2295),
    [sym_type_parameters] = STATE(3054),
    [sym_identifier] = ACTIONS(1700),
    [anon_sym_export] = ACTIONS(1702),
    [anon_sym_STAR] = ACTIONS(780),
    [anon_sym_EQ] = ACTIONS(961),
    [anon_sym_as] = ACTIONS(780),
    [anon_sym_namespace] = ACTIONS(1702),
    [anon_sym_type] = ACTIONS(1702),
    [anon_sym_BANG] = ACTIONS(780),
    [anon_sym_LPAREN] = ACTIONS(1679),
    [anon_sym_in] = ACTIONS(780),
    [anon_sym_COLON] = ACTIONS(1748),
    [anon_sym_LBRACK] = ACTIONS(1639),
    [anon_sym_RBRACK] = ACTIONS(813),
    [anon_sym_LT] = ACTIONS(1682),
    [anon_sym_GT] = ACTIONS(780),
    [anon_sym_SLASH] = ACTIONS(780),
    [anon_sym_DOT] = ACTIONS(1641),
    [anon_sym_async] = ACTIONS(1702),
    [anon_sym_function] = ACTIONS(1643),
    [anon_sym_EQ_GT] = ACTIONS(963),
    [anon_sym_QMARK_DOT] = ACTIONS(799),
    [anon_sym_PLUS_EQ] = ACTIONS(803),
    [anon_sym_DASH_EQ] = ACTIONS(803),
    [anon_sym_STAR_EQ] = ACTIONS(803),
    [anon_sym_SLASH_EQ] = ACTIONS(803),
    [anon_sym_PERCENT_EQ] = ACTIONS(803),
    [anon_sym_CARET_EQ] = ACTIONS(803),
    [anon_sym_AMP_EQ] = ACTIONS(803),
    [anon_sym_PIPE_EQ] = ACTIONS(803),
    [anon_sym_GT_GT_EQ] = ACTIONS(803),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(803),
    [anon_sym_LT_LT_EQ] = ACTIONS(803),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(803),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(803),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(803),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(803),
    [anon_sym_QMARK] = ACTIONS(780),
    [anon_sym_AMP_AMP] = ACTIONS(780),
    [anon_sym_PIPE_PIPE] = ACTIONS(780),
    [anon_sym_GT_GT] = ACTIONS(780),
    [anon_sym_GT_GT_GT] = ACTIONS(780),
    [anon_sym_LT_LT] = ACTIONS(780),
    [anon_sym_AMP] = ACTIONS(780),
    [anon_sym_CARET] = ACTIONS(780),
    [anon_sym_PIPE] = ACTIONS(780),
    [anon_sym_PLUS] = ACTIONS(780),
    [anon_sym_DASH] = ACTIONS(780),
    [anon_sym_PERCENT] = ACTIONS(780),
    [anon_sym_STAR_STAR] = ACTIONS(780),
    [anon_sym_LT_EQ] = ACTIONS(813),
    [anon_sym_EQ_EQ] = ACTIONS(780),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(813),
    [anon_sym_BANG_EQ] = ACTIONS(780),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(813),
    [anon_sym_GT_EQ] = ACTIONS(813),
    [anon_sym_QMARK_QMARK] = ACTIONS(780),
    [anon_sym_instanceof] = ACTIONS(780),
    [anon_sym_PLUS_PLUS] = ACTIONS(813),
    [anon_sym_DASH_DASH] = ACTIONS(813),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(813),
    [anon_sym_static] = ACTIONS(1702),
    [anon_sym_get] = ACTIONS(1702),
    [anon_sym_set] = ACTIONS(1702),
    [anon_sym_declare] = ACTIONS(1702),
    [anon_sym_public] = ACTIONS(1702),
    [anon_sym_private] = ACTIONS(1702),
    [anon_sym_protected] = ACTIONS(1702),
    [anon_sym_module] = ACTIONS(1702),
    [anon_sym_any] = ACTIONS(1702),
    [anon_sym_number] = ACTIONS(1702),
    [anon_sym_boolean] = ACTIONS(1702),
    [anon_sym_string] = ACTIONS(1702),
    [anon_sym_symbol] = ACTIONS(1702),
    [sym_readonly] = ACTIONS(1702),
  },
  [499] = {
    [sym__call_signature] = STATE(3164),
    [sym_formal_parameters] = STATE(2295),
    [sym_type_parameters] = STATE(3054),
    [sym_identifier] = ACTIONS(1700),
    [anon_sym_export] = ACTIONS(1702),
    [anon_sym_STAR] = ACTIONS(780),
    [anon_sym_EQ] = ACTIONS(961),
    [anon_sym_as] = ACTIONS(780),
    [anon_sym_namespace] = ACTIONS(1702),
    [anon_sym_type] = ACTIONS(1702),
    [anon_sym_BANG] = ACTIONS(780),
    [anon_sym_LPAREN] = ACTIONS(1679),
    [anon_sym_in] = ACTIONS(780),
    [anon_sym_COLON] = ACTIONS(1762),
    [anon_sym_LBRACK] = ACTIONS(1639),
    [anon_sym_RBRACK] = ACTIONS(813),
    [anon_sym_LT] = ACTIONS(1682),
    [anon_sym_GT] = ACTIONS(780),
    [anon_sym_SLASH] = ACTIONS(780),
    [anon_sym_DOT] = ACTIONS(1641),
    [anon_sym_async] = ACTIONS(1702),
    [anon_sym_function] = ACTIONS(1643),
    [anon_sym_EQ_GT] = ACTIONS(963),
    [anon_sym_QMARK_DOT] = ACTIONS(799),
    [anon_sym_PLUS_EQ] = ACTIONS(803),
    [anon_sym_DASH_EQ] = ACTIONS(803),
    [anon_sym_STAR_EQ] = ACTIONS(803),
    [anon_sym_SLASH_EQ] = ACTIONS(803),
    [anon_sym_PERCENT_EQ] = ACTIONS(803),
    [anon_sym_CARET_EQ] = ACTIONS(803),
    [anon_sym_AMP_EQ] = ACTIONS(803),
    [anon_sym_PIPE_EQ] = ACTIONS(803),
    [anon_sym_GT_GT_EQ] = ACTIONS(803),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(803),
    [anon_sym_LT_LT_EQ] = ACTIONS(803),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(803),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(803),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(803),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(803),
    [anon_sym_QMARK] = ACTIONS(780),
    [anon_sym_AMP_AMP] = ACTIONS(780),
    [anon_sym_PIPE_PIPE] = ACTIONS(780),
    [anon_sym_GT_GT] = ACTIONS(780),
    [anon_sym_GT_GT_GT] = ACTIONS(780),
    [anon_sym_LT_LT] = ACTIONS(780),
    [anon_sym_AMP] = ACTIONS(780),
    [anon_sym_CARET] = ACTIONS(780),
    [anon_sym_PIPE] = ACTIONS(780),
    [anon_sym_PLUS] = ACTIONS(780),
    [anon_sym_DASH] = ACTIONS(780),
    [anon_sym_PERCENT] = ACTIONS(780),
    [anon_sym_STAR_STAR] = ACTIONS(780),
    [anon_sym_LT_EQ] = ACTIONS(813),
    [anon_sym_EQ_EQ] = ACTIONS(780),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(813),
    [anon_sym_BANG_EQ] = ACTIONS(780),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(813),
    [anon_sym_GT_EQ] = ACTIONS(813),
    [anon_sym_QMARK_QMARK] = ACTIONS(780),
    [anon_sym_instanceof] = ACTIONS(780),
    [anon_sym_PLUS_PLUS] = ACTIONS(813),
    [anon_sym_DASH_DASH] = ACTIONS(813),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(813),
    [anon_sym_static] = ACTIONS(1702),
    [anon_sym_get] = ACTIONS(1702),
    [anon_sym_set] = ACTIONS(1702),
    [anon_sym_declare] = ACTIONS(1702),
    [anon_sym_public] = ACTIONS(1702),
    [anon_sym_private] = ACTIONS(1702),
    [anon_sym_protected] = ACTIONS(1702),
    [anon_sym_module] = ACTIONS(1702),
    [anon_sym_any] = ACTIONS(1702),
    [anon_sym_number] = ACTIONS(1702),
    [anon_sym_boolean] = ACTIONS(1702),
    [anon_sym_string] = ACTIONS(1702),
    [anon_sym_symbol] = ACTIONS(1702),
    [sym_readonly] = ACTIONS(1702),
  },
  [500] = {
    [ts_builtin_sym_end] = ACTIONS(1049),
    [sym_identifier] = ACTIONS(1051),
    [anon_sym_export] = ACTIONS(1051),
    [anon_sym_default] = ACTIONS(1051),
    [anon_sym_namespace] = ACTIONS(1051),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_COMMA] = ACTIONS(1049),
    [anon_sym_RBRACE] = ACTIONS(1049),
    [anon_sym_type] = ACTIONS(1051),
    [anon_sym_typeof] = ACTIONS(1051),
    [anon_sym_import] = ACTIONS(1051),
    [anon_sym_var] = ACTIONS(1051),
    [anon_sym_let] = ACTIONS(1051),
    [anon_sym_const] = ACTIONS(1051),
    [anon_sym_BANG] = ACTIONS(1049),
    [anon_sym_else] = ACTIONS(1051),
    [anon_sym_if] = ACTIONS(1051),
    [anon_sym_switch] = ACTIONS(1051),
    [anon_sym_for] = ACTIONS(1051),
    [anon_sym_LPAREN] = ACTIONS(1049),
    [anon_sym_await] = ACTIONS(1051),
    [anon_sym_while] = ACTIONS(1051),
    [anon_sym_do] = ACTIONS(1051),
    [anon_sym_try] = ACTIONS(1051),
    [anon_sym_with] = ACTIONS(1051),
    [anon_sym_break] = ACTIONS(1051),
    [anon_sym_continue] = ACTIONS(1051),
    [anon_sym_debugger] = ACTIONS(1051),
    [anon_sym_return] = ACTIONS(1051),
    [anon_sym_throw] = ACTIONS(1051),
    [anon_sym_SEMI] = ACTIONS(1049),
    [anon_sym_case] = ACTIONS(1051),
    [anon_sym_yield] = ACTIONS(1051),
    [anon_sym_LBRACK] = ACTIONS(1049),
    [anon_sym_LT] = ACTIONS(1049),
    [anon_sym_SLASH] = ACTIONS(1051),
    [anon_sym_class] = ACTIONS(1051),
    [anon_sym_async] = ACTIONS(1051),
    [anon_sym_function] = ACTIONS(1051),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_PLUS] = ACTIONS(1051),
    [anon_sym_DASH] = ACTIONS(1051),
    [anon_sym_TILDE] = ACTIONS(1049),
    [anon_sym_void] = ACTIONS(1051),
    [anon_sym_delete] = ACTIONS(1051),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_DQUOTE] = ACTIONS(1049),
    [anon_sym_SQUOTE] = ACTIONS(1049),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1049),
    [sym_number] = ACTIONS(1049),
    [sym_this] = ACTIONS(1051),
    [sym_super] = ACTIONS(1051),
    [sym_true] = ACTIONS(1051),
    [sym_false] = ACTIONS(1051),
    [sym_null] = ACTIONS(1051),
    [sym_undefined] = ACTIONS(1051),
    [anon_sym_AT] = ACTIONS(1049),
    [anon_sym_static] = ACTIONS(1051),
    [anon_sym_abstract] = ACTIONS(1051),
    [anon_sym_get] = ACTIONS(1051),
    [anon_sym_set] = ACTIONS(1051),
    [anon_sym_declare] = ACTIONS(1051),
    [anon_sym_public] = ACTIONS(1051),
    [anon_sym_private] = ACTIONS(1051),
    [anon_sym_protected] = ACTIONS(1051),
    [anon_sym_module] = ACTIONS(1051),
    [anon_sym_any] = ACTIONS(1051),
    [anon_sym_number] = ACTIONS(1051),
    [anon_sym_boolean] = ACTIONS(1051),
    [anon_sym_string] = ACTIONS(1051),
    [anon_sym_symbol] = ACTIONS(1051),
    [anon_sym_interface] = ACTIONS(1051),
    [anon_sym_enum] = ACTIONS(1051),
    [sym_readonly] = ACTIONS(1051),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1049),
    [sym__automatic_semicolon] = ACTIONS(1764),
  },
  [501] = {
    [ts_builtin_sym_end] = ACTIONS(1071),
    [sym_identifier] = ACTIONS(1073),
    [anon_sym_export] = ACTIONS(1073),
    [anon_sym_default] = ACTIONS(1073),
    [anon_sym_namespace] = ACTIONS(1073),
    [anon_sym_LBRACE] = ACTIONS(1071),
    [anon_sym_COMMA] = ACTIONS(1071),
    [anon_sym_RBRACE] = ACTIONS(1071),
    [anon_sym_type] = ACTIONS(1073),
    [anon_sym_typeof] = ACTIONS(1073),
    [anon_sym_import] = ACTIONS(1073),
    [anon_sym_var] = ACTIONS(1073),
    [anon_sym_let] = ACTIONS(1073),
    [anon_sym_const] = ACTIONS(1073),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_else] = ACTIONS(1073),
    [anon_sym_if] = ACTIONS(1073),
    [anon_sym_switch] = ACTIONS(1073),
    [anon_sym_for] = ACTIONS(1073),
    [anon_sym_LPAREN] = ACTIONS(1071),
    [anon_sym_await] = ACTIONS(1073),
    [anon_sym_while] = ACTIONS(1073),
    [anon_sym_do] = ACTIONS(1073),
    [anon_sym_try] = ACTIONS(1073),
    [anon_sym_with] = ACTIONS(1073),
    [anon_sym_break] = ACTIONS(1073),
    [anon_sym_continue] = ACTIONS(1073),
    [anon_sym_debugger] = ACTIONS(1073),
    [anon_sym_return] = ACTIONS(1073),
    [anon_sym_throw] = ACTIONS(1073),
    [anon_sym_SEMI] = ACTIONS(1071),
    [anon_sym_case] = ACTIONS(1073),
    [anon_sym_yield] = ACTIONS(1073),
    [anon_sym_LBRACK] = ACTIONS(1071),
    [anon_sym_LT] = ACTIONS(1071),
    [anon_sym_SLASH] = ACTIONS(1073),
    [anon_sym_class] = ACTIONS(1073),
    [anon_sym_async] = ACTIONS(1073),
    [anon_sym_function] = ACTIONS(1073),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_PLUS] = ACTIONS(1073),
    [anon_sym_DASH] = ACTIONS(1073),
    [anon_sym_TILDE] = ACTIONS(1071),
    [anon_sym_void] = ACTIONS(1073),
    [anon_sym_delete] = ACTIONS(1073),
    [anon_sym_PLUS_PLUS] = ACTIONS(1071),
    [anon_sym_DASH_DASH] = ACTIONS(1071),
    [anon_sym_DQUOTE] = ACTIONS(1071),
    [anon_sym_SQUOTE] = ACTIONS(1071),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1071),
    [sym_number] = ACTIONS(1071),
    [sym_this] = ACTIONS(1073),
    [sym_super] = ACTIONS(1073),
    [sym_true] = ACTIONS(1073),
    [sym_false] = ACTIONS(1073),
    [sym_null] = ACTIONS(1073),
    [sym_undefined] = ACTIONS(1073),
    [anon_sym_AT] = ACTIONS(1071),
    [anon_sym_static] = ACTIONS(1073),
    [anon_sym_abstract] = ACTIONS(1073),
    [anon_sym_get] = ACTIONS(1073),
    [anon_sym_set] = ACTIONS(1073),
    [anon_sym_declare] = ACTIONS(1073),
    [anon_sym_public] = ACTIONS(1073),
    [anon_sym_private] = ACTIONS(1073),
    [anon_sym_protected] = ACTIONS(1073),
    [anon_sym_module] = ACTIONS(1073),
    [anon_sym_any] = ACTIONS(1073),
    [anon_sym_number] = ACTIONS(1073),
    [anon_sym_boolean] = ACTIONS(1073),
    [anon_sym_string] = ACTIONS(1073),
    [anon_sym_symbol] = ACTIONS(1073),
    [anon_sym_interface] = ACTIONS(1073),
    [anon_sym_enum] = ACTIONS(1073),
    [sym_readonly] = ACTIONS(1073),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1071),
    [sym__automatic_semicolon] = ACTIONS(1071),
  },
  [502] = {
    [ts_builtin_sym_end] = ACTIONS(1063),
    [sym_identifier] = ACTIONS(1065),
    [anon_sym_export] = ACTIONS(1065),
    [anon_sym_default] = ACTIONS(1065),
    [anon_sym_namespace] = ACTIONS(1065),
    [anon_sym_LBRACE] = ACTIONS(1063),
    [anon_sym_COMMA] = ACTIONS(1063),
    [anon_sym_RBRACE] = ACTIONS(1063),
    [anon_sym_type] = ACTIONS(1065),
    [anon_sym_typeof] = ACTIONS(1065),
    [anon_sym_import] = ACTIONS(1065),
    [anon_sym_var] = ACTIONS(1065),
    [anon_sym_let] = ACTIONS(1065),
    [anon_sym_const] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1063),
    [anon_sym_else] = ACTIONS(1065),
    [anon_sym_if] = ACTIONS(1065),
    [anon_sym_switch] = ACTIONS(1065),
    [anon_sym_for] = ACTIONS(1065),
    [anon_sym_LPAREN] = ACTIONS(1063),
    [anon_sym_await] = ACTIONS(1065),
    [anon_sym_while] = ACTIONS(1065),
    [anon_sym_do] = ACTIONS(1065),
    [anon_sym_try] = ACTIONS(1065),
    [anon_sym_with] = ACTIONS(1065),
    [anon_sym_break] = ACTIONS(1065),
    [anon_sym_continue] = ACTIONS(1065),
    [anon_sym_debugger] = ACTIONS(1065),
    [anon_sym_return] = ACTIONS(1065),
    [anon_sym_throw] = ACTIONS(1065),
    [anon_sym_SEMI] = ACTIONS(1063),
    [anon_sym_case] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(1065),
    [anon_sym_LBRACK] = ACTIONS(1063),
    [anon_sym_LT] = ACTIONS(1063),
    [anon_sym_SLASH] = ACTIONS(1065),
    [anon_sym_class] = ACTIONS(1065),
    [anon_sym_async] = ACTIONS(1065),
    [anon_sym_function] = ACTIONS(1065),
    [anon_sym_new] = ACTIONS(1065),
    [anon_sym_PLUS] = ACTIONS(1065),
    [anon_sym_DASH] = ACTIONS(1065),
    [anon_sym_TILDE] = ACTIONS(1063),
    [anon_sym_void] = ACTIONS(1065),
    [anon_sym_delete] = ACTIONS(1065),
    [anon_sym_PLUS_PLUS] = ACTIONS(1063),
    [anon_sym_DASH_DASH] = ACTIONS(1063),
    [anon_sym_DQUOTE] = ACTIONS(1063),
    [anon_sym_SQUOTE] = ACTIONS(1063),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1063),
    [sym_number] = ACTIONS(1063),
    [sym_this] = ACTIONS(1065),
    [sym_super] = ACTIONS(1065),
    [sym_true] = ACTIONS(1065),
    [sym_false] = ACTIONS(1065),
    [sym_null] = ACTIONS(1065),
    [sym_undefined] = ACTIONS(1065),
    [anon_sym_AT] = ACTIONS(1063),
    [anon_sym_static] = ACTIONS(1065),
    [anon_sym_abstract] = ACTIONS(1065),
    [anon_sym_get] = ACTIONS(1065),
    [anon_sym_set] = ACTIONS(1065),
    [anon_sym_declare] = ACTIONS(1065),
    [anon_sym_public] = ACTIONS(1065),
    [anon_sym_private] = ACTIONS(1065),
    [anon_sym_protected] = ACTIONS(1065),
    [anon_sym_module] = ACTIONS(1065),
    [anon_sym_any] = ACTIONS(1065),
    [anon_sym_number] = ACTIONS(1065),
    [anon_sym_boolean] = ACTIONS(1065),
    [anon_sym_string] = ACTIONS(1065),
    [anon_sym_symbol] = ACTIONS(1065),
    [anon_sym_interface] = ACTIONS(1065),
    [anon_sym_enum] = ACTIONS(1065),
    [sym_readonly] = ACTIONS(1065),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1063),
    [sym__automatic_semicolon] = ACTIONS(1063),
  },
  [503] = {
    [sym__call_signature] = STATE(3164),
    [sym_formal_parameters] = STATE(2295),
    [sym_type_parameters] = STATE(3054),
    [sym_identifier] = ACTIONS(1700),
    [anon_sym_export] = ACTIONS(1702),
    [anon_sym_STAR] = ACTIONS(780),
    [anon_sym_EQ] = ACTIONS(961),
    [anon_sym_as] = ACTIONS(780),
    [anon_sym_namespace] = ACTIONS(1702),
    [anon_sym_type] = ACTIONS(1702),
    [anon_sym_BANG] = ACTIONS(780),
    [anon_sym_LPAREN] = ACTIONS(1679),
    [anon_sym_in] = ACTIONS(780),
    [anon_sym_COLON] = ACTIONS(813),
    [anon_sym_LBRACK] = ACTIONS(1639),
    [anon_sym_RBRACK] = ACTIONS(813),
    [anon_sym_LT] = ACTIONS(1682),
    [anon_sym_GT] = ACTIONS(780),
    [anon_sym_SLASH] = ACTIONS(780),
    [anon_sym_DOT] = ACTIONS(1641),
    [anon_sym_async] = ACTIONS(1702),
    [anon_sym_function] = ACTIONS(1643),
    [anon_sym_EQ_GT] = ACTIONS(963),
    [anon_sym_QMARK_DOT] = ACTIONS(799),
    [anon_sym_PLUS_EQ] = ACTIONS(803),
    [anon_sym_DASH_EQ] = ACTIONS(803),
    [anon_sym_STAR_EQ] = ACTIONS(803),
    [anon_sym_SLASH_EQ] = ACTIONS(803),
    [anon_sym_PERCENT_EQ] = ACTIONS(803),
    [anon_sym_CARET_EQ] = ACTIONS(803),
    [anon_sym_AMP_EQ] = ACTIONS(803),
    [anon_sym_PIPE_EQ] = ACTIONS(803),
    [anon_sym_GT_GT_EQ] = ACTIONS(803),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(803),
    [anon_sym_LT_LT_EQ] = ACTIONS(803),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(803),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(803),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(803),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(803),
    [anon_sym_QMARK] = ACTIONS(780),
    [anon_sym_AMP_AMP] = ACTIONS(780),
    [anon_sym_PIPE_PIPE] = ACTIONS(780),
    [anon_sym_GT_GT] = ACTIONS(780),
    [anon_sym_GT_GT_GT] = ACTIONS(780),
    [anon_sym_LT_LT] = ACTIONS(780),
    [anon_sym_AMP] = ACTIONS(780),
    [anon_sym_CARET] = ACTIONS(780),
    [anon_sym_PIPE] = ACTIONS(780),
    [anon_sym_PLUS] = ACTIONS(780),
    [anon_sym_DASH] = ACTIONS(780),
    [anon_sym_PERCENT] = ACTIONS(780),
    [anon_sym_STAR_STAR] = ACTIONS(780),
    [anon_sym_LT_EQ] = ACTIONS(813),
    [anon_sym_EQ_EQ] = ACTIONS(780),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(813),
    [anon_sym_BANG_EQ] = ACTIONS(780),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(813),
    [anon_sym_GT_EQ] = ACTIONS(813),
    [anon_sym_QMARK_QMARK] = ACTIONS(780),
    [anon_sym_instanceof] = ACTIONS(780),
    [anon_sym_PLUS_PLUS] = ACTIONS(813),
    [anon_sym_DASH_DASH] = ACTIONS(813),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(813),
    [anon_sym_static] = ACTIONS(1702),
    [anon_sym_get] = ACTIONS(1702),
    [anon_sym_set] = ACTIONS(1702),
    [anon_sym_declare] = ACTIONS(1702),
    [anon_sym_public] = ACTIONS(1702),
    [anon_sym_private] = ACTIONS(1702),
    [anon_sym_protected] = ACTIONS(1702),
    [anon_sym_module] = ACTIONS(1702),
    [anon_sym_any] = ACTIONS(1702),
    [anon_sym_number] = ACTIONS(1702),
    [anon_sym_boolean] = ACTIONS(1702),
    [anon_sym_string] = ACTIONS(1702),
    [anon_sym_symbol] = ACTIONS(1702),
    [sym_readonly] = ACTIONS(1702),
  },
  [504] = {
    [sym__call_signature] = STATE(3248),
    [sym_formal_parameters] = STATE(2295),
    [sym_type_parameters] = STATE(3054),
    [sym_identifier] = ACTIONS(1706),
    [anon_sym_export] = ACTIONS(1708),
    [anon_sym_STAR] = ACTIONS(780),
    [anon_sym_EQ] = ACTIONS(1067),
    [anon_sym_as] = ACTIONS(780),
    [anon_sym_namespace] = ACTIONS(1708),
    [anon_sym_type] = ACTIONS(1708),
    [anon_sym_BANG] = ACTIONS(780),
    [anon_sym_LPAREN] = ACTIONS(1679),
    [anon_sym_in] = ACTIONS(780),
    [anon_sym_SEMI] = ACTIONS(813),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_LT] = ACTIONS(1682),
    [anon_sym_GT] = ACTIONS(780),
    [anon_sym_SLASH] = ACTIONS(780),
    [anon_sym_DOT] = ACTIONS(1228),
    [anon_sym_async] = ACTIONS(1708),
    [anon_sym_function] = ACTIONS(1766),
    [anon_sym_EQ_GT] = ACTIONS(1069),
    [anon_sym_QMARK_DOT] = ACTIONS(931),
    [anon_sym_PLUS_EQ] = ACTIONS(803),
    [anon_sym_DASH_EQ] = ACTIONS(803),
    [anon_sym_STAR_EQ] = ACTIONS(803),
    [anon_sym_SLASH_EQ] = ACTIONS(803),
    [anon_sym_PERCENT_EQ] = ACTIONS(803),
    [anon_sym_CARET_EQ] = ACTIONS(803),
    [anon_sym_AMP_EQ] = ACTIONS(803),
    [anon_sym_PIPE_EQ] = ACTIONS(803),
    [anon_sym_GT_GT_EQ] = ACTIONS(803),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(803),
    [anon_sym_LT_LT_EQ] = ACTIONS(803),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(803),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(803),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(803),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(803),
    [anon_sym_QMARK] = ACTIONS(780),
    [anon_sym_AMP_AMP] = ACTIONS(780),
    [anon_sym_PIPE_PIPE] = ACTIONS(780),
    [anon_sym_GT_GT] = ACTIONS(780),
    [anon_sym_GT_GT_GT] = ACTIONS(780),
    [anon_sym_LT_LT] = ACTIONS(780),
    [anon_sym_AMP] = ACTIONS(780),
    [anon_sym_CARET] = ACTIONS(780),
    [anon_sym_PIPE] = ACTIONS(780),
    [anon_sym_PLUS] = ACTIONS(780),
    [anon_sym_DASH] = ACTIONS(780),
    [anon_sym_PERCENT] = ACTIONS(780),
    [anon_sym_STAR_STAR] = ACTIONS(780),
    [anon_sym_LT_EQ] = ACTIONS(813),
    [anon_sym_EQ_EQ] = ACTIONS(780),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(813),
    [anon_sym_BANG_EQ] = ACTIONS(780),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(813),
    [anon_sym_GT_EQ] = ACTIONS(813),
    [anon_sym_QMARK_QMARK] = ACTIONS(780),
    [anon_sym_instanceof] = ACTIONS(780),
    [anon_sym_PLUS_PLUS] = ACTIONS(813),
    [anon_sym_DASH_DASH] = ACTIONS(813),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(813),
    [anon_sym_static] = ACTIONS(1708),
    [anon_sym_get] = ACTIONS(1708),
    [anon_sym_set] = ACTIONS(1708),
    [anon_sym_declare] = ACTIONS(1708),
    [anon_sym_public] = ACTIONS(1708),
    [anon_sym_private] = ACTIONS(1708),
    [anon_sym_protected] = ACTIONS(1708),
    [anon_sym_module] = ACTIONS(1708),
    [anon_sym_any] = ACTIONS(1708),
    [anon_sym_number] = ACTIONS(1708),
    [anon_sym_boolean] = ACTIONS(1708),
    [anon_sym_string] = ACTIONS(1708),
    [anon_sym_symbol] = ACTIONS(1708),
    [sym_readonly] = ACTIONS(1708),
    [sym__automatic_semicolon] = ACTIONS(813),
  },
  [505] = {
    [ts_builtin_sym_end] = ACTIONS(1768),
    [sym_identifier] = ACTIONS(1770),
    [anon_sym_export] = ACTIONS(1770),
    [anon_sym_default] = ACTIONS(1770),
    [anon_sym_namespace] = ACTIONS(1770),
    [anon_sym_LBRACE] = ACTIONS(1768),
    [anon_sym_RBRACE] = ACTIONS(1768),
    [anon_sym_type] = ACTIONS(1770),
    [anon_sym_typeof] = ACTIONS(1770),
    [anon_sym_import] = ACTIONS(1770),
    [anon_sym_var] = ACTIONS(1770),
    [anon_sym_let] = ACTIONS(1770),
    [anon_sym_const] = ACTIONS(1770),
    [anon_sym_BANG] = ACTIONS(1768),
    [anon_sym_else] = ACTIONS(1770),
    [anon_sym_if] = ACTIONS(1770),
    [anon_sym_switch] = ACTIONS(1770),
    [anon_sym_for] = ACTIONS(1770),
    [anon_sym_LPAREN] = ACTIONS(1768),
    [anon_sym_await] = ACTIONS(1770),
    [anon_sym_while] = ACTIONS(1770),
    [anon_sym_do] = ACTIONS(1770),
    [anon_sym_try] = ACTIONS(1770),
    [anon_sym_with] = ACTIONS(1770),
    [anon_sym_break] = ACTIONS(1770),
    [anon_sym_continue] = ACTIONS(1770),
    [anon_sym_debugger] = ACTIONS(1770),
    [anon_sym_return] = ACTIONS(1770),
    [anon_sym_throw] = ACTIONS(1770),
    [anon_sym_SEMI] = ACTIONS(1768),
    [anon_sym_case] = ACTIONS(1770),
    [anon_sym_yield] = ACTIONS(1770),
    [anon_sym_LBRACK] = ACTIONS(1768),
    [anon_sym_LT] = ACTIONS(1768),
    [anon_sym_SLASH] = ACTIONS(1770),
    [anon_sym_class] = ACTIONS(1770),
    [anon_sym_async] = ACTIONS(1770),
    [anon_sym_function] = ACTIONS(1770),
    [anon_sym_new] = ACTIONS(1770),
    [anon_sym_AMP] = ACTIONS(1772),
    [anon_sym_PIPE] = ACTIONS(1774),
    [anon_sym_PLUS] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_TILDE] = ACTIONS(1768),
    [anon_sym_void] = ACTIONS(1770),
    [anon_sym_delete] = ACTIONS(1770),
    [anon_sym_PLUS_PLUS] = ACTIONS(1768),
    [anon_sym_DASH_DASH] = ACTIONS(1768),
    [anon_sym_DQUOTE] = ACTIONS(1768),
    [anon_sym_SQUOTE] = ACTIONS(1768),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1768),
    [sym_number] = ACTIONS(1768),
    [sym_this] = ACTIONS(1770),
    [sym_super] = ACTIONS(1770),
    [sym_true] = ACTIONS(1770),
    [sym_false] = ACTIONS(1770),
    [sym_null] = ACTIONS(1770),
    [sym_undefined] = ACTIONS(1770),
    [anon_sym_AT] = ACTIONS(1768),
    [anon_sym_static] = ACTIONS(1770),
    [anon_sym_abstract] = ACTIONS(1770),
    [anon_sym_get] = ACTIONS(1770),
    [anon_sym_set] = ACTIONS(1770),
    [anon_sym_declare] = ACTIONS(1770),
    [anon_sym_public] = ACTIONS(1770),
    [anon_sym_private] = ACTIONS(1770),
    [anon_sym_protected] = ACTIONS(1770),
    [anon_sym_module] = ACTIONS(1770),
    [anon_sym_any] = ACTIONS(1770),
    [anon_sym_number] = ACTIONS(1770),
    [anon_sym_boolean] = ACTIONS(1770),
    [anon_sym_string] = ACTIONS(1770),
    [anon_sym_symbol] = ACTIONS(1770),
    [anon_sym_interface] = ACTIONS(1770),
    [anon_sym_extends] = ACTIONS(1776),
    [anon_sym_enum] = ACTIONS(1770),
    [sym_readonly] = ACTIONS(1770),
  },
  [506] = {
    [ts_builtin_sym_end] = ACTIONS(1778),
    [sym_identifier] = ACTIONS(1780),
    [anon_sym_export] = ACTIONS(1780),
    [anon_sym_default] = ACTIONS(1780),
    [anon_sym_namespace] = ACTIONS(1780),
    [anon_sym_LBRACE] = ACTIONS(1778),
    [anon_sym_RBRACE] = ACTIONS(1778),
    [anon_sym_type] = ACTIONS(1780),
    [anon_sym_typeof] = ACTIONS(1780),
    [anon_sym_import] = ACTIONS(1780),
    [anon_sym_var] = ACTIONS(1780),
    [anon_sym_let] = ACTIONS(1780),
    [anon_sym_const] = ACTIONS(1780),
    [anon_sym_BANG] = ACTIONS(1778),
    [anon_sym_else] = ACTIONS(1780),
    [anon_sym_if] = ACTIONS(1780),
    [anon_sym_switch] = ACTIONS(1780),
    [anon_sym_for] = ACTIONS(1780),
    [anon_sym_LPAREN] = ACTIONS(1778),
    [anon_sym_await] = ACTIONS(1780),
    [anon_sym_while] = ACTIONS(1780),
    [anon_sym_do] = ACTIONS(1780),
    [anon_sym_try] = ACTIONS(1780),
    [anon_sym_with] = ACTIONS(1780),
    [anon_sym_break] = ACTIONS(1780),
    [anon_sym_continue] = ACTIONS(1780),
    [anon_sym_debugger] = ACTIONS(1780),
    [anon_sym_return] = ACTIONS(1780),
    [anon_sym_throw] = ACTIONS(1780),
    [anon_sym_SEMI] = ACTIONS(1778),
    [anon_sym_case] = ACTIONS(1780),
    [anon_sym_yield] = ACTIONS(1780),
    [anon_sym_LBRACK] = ACTIONS(1778),
    [anon_sym_LT] = ACTIONS(1778),
    [anon_sym_SLASH] = ACTIONS(1780),
    [anon_sym_class] = ACTIONS(1780),
    [anon_sym_async] = ACTIONS(1780),
    [anon_sym_function] = ACTIONS(1780),
    [anon_sym_new] = ACTIONS(1780),
    [anon_sym_AMP] = ACTIONS(1772),
    [anon_sym_PIPE] = ACTIONS(1774),
    [anon_sym_PLUS] = ACTIONS(1780),
    [anon_sym_DASH] = ACTIONS(1780),
    [anon_sym_TILDE] = ACTIONS(1778),
    [anon_sym_void] = ACTIONS(1780),
    [anon_sym_delete] = ACTIONS(1780),
    [anon_sym_PLUS_PLUS] = ACTIONS(1778),
    [anon_sym_DASH_DASH] = ACTIONS(1778),
    [anon_sym_DQUOTE] = ACTIONS(1778),
    [anon_sym_SQUOTE] = ACTIONS(1778),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1778),
    [sym_number] = ACTIONS(1778),
    [sym_this] = ACTIONS(1780),
    [sym_super] = ACTIONS(1780),
    [sym_true] = ACTIONS(1780),
    [sym_false] = ACTIONS(1780),
    [sym_null] = ACTIONS(1780),
    [sym_undefined] = ACTIONS(1780),
    [anon_sym_AT] = ACTIONS(1778),
    [anon_sym_static] = ACTIONS(1780),
    [anon_sym_abstract] = ACTIONS(1780),
    [anon_sym_get] = ACTIONS(1780),
    [anon_sym_set] = ACTIONS(1780),
    [anon_sym_declare] = ACTIONS(1780),
    [anon_sym_public] = ACTIONS(1780),
    [anon_sym_private] = ACTIONS(1780),
    [anon_sym_protected] = ACTIONS(1780),
    [anon_sym_module] = ACTIONS(1780),
    [anon_sym_any] = ACTIONS(1780),
    [anon_sym_number] = ACTIONS(1780),
    [anon_sym_boolean] = ACTIONS(1780),
    [anon_sym_string] = ACTIONS(1780),
    [anon_sym_symbol] = ACTIONS(1780),
    [anon_sym_interface] = ACTIONS(1780),
    [anon_sym_extends] = ACTIONS(1780),
    [anon_sym_enum] = ACTIONS(1780),
    [sym_readonly] = ACTIONS(1780),
  },
  [507] = {
    [ts_builtin_sym_end] = ACTIONS(975),
    [sym_identifier] = ACTIONS(977),
    [anon_sym_export] = ACTIONS(977),
    [anon_sym_default] = ACTIONS(977),
    [anon_sym_namespace] = ACTIONS(977),
    [anon_sym_LBRACE] = ACTIONS(975),
    [anon_sym_COMMA] = ACTIONS(975),
    [anon_sym_RBRACE] = ACTIONS(975),
    [anon_sym_type] = ACTIONS(977),
    [anon_sym_typeof] = ACTIONS(977),
    [anon_sym_import] = ACTIONS(977),
    [anon_sym_var] = ACTIONS(977),
    [anon_sym_let] = ACTIONS(977),
    [anon_sym_const] = ACTIONS(977),
    [anon_sym_BANG] = ACTIONS(975),
    [anon_sym_else] = ACTIONS(977),
    [anon_sym_if] = ACTIONS(977),
    [anon_sym_switch] = ACTIONS(977),
    [anon_sym_for] = ACTIONS(977),
    [anon_sym_LPAREN] = ACTIONS(975),
    [anon_sym_await] = ACTIONS(977),
    [anon_sym_while] = ACTIONS(977),
    [anon_sym_do] = ACTIONS(977),
    [anon_sym_try] = ACTIONS(977),
    [anon_sym_with] = ACTIONS(977),
    [anon_sym_break] = ACTIONS(977),
    [anon_sym_continue] = ACTIONS(977),
    [anon_sym_debugger] = ACTIONS(977),
    [anon_sym_return] = ACTIONS(977),
    [anon_sym_throw] = ACTIONS(977),
    [anon_sym_SEMI] = ACTIONS(975),
    [anon_sym_case] = ACTIONS(977),
    [anon_sym_yield] = ACTIONS(977),
    [anon_sym_LBRACK] = ACTIONS(975),
    [anon_sym_LT] = ACTIONS(975),
    [anon_sym_SLASH] = ACTIONS(977),
    [anon_sym_class] = ACTIONS(977),
    [anon_sym_async] = ACTIONS(977),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_new] = ACTIONS(977),
    [anon_sym_PLUS] = ACTIONS(977),
    [anon_sym_DASH] = ACTIONS(977),
    [anon_sym_TILDE] = ACTIONS(975),
    [anon_sym_void] = ACTIONS(977),
    [anon_sym_delete] = ACTIONS(977),
    [anon_sym_PLUS_PLUS] = ACTIONS(975),
    [anon_sym_DASH_DASH] = ACTIONS(975),
    [anon_sym_DQUOTE] = ACTIONS(975),
    [anon_sym_SQUOTE] = ACTIONS(975),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(975),
    [sym_number] = ACTIONS(975),
    [sym_this] = ACTIONS(977),
    [sym_super] = ACTIONS(977),
    [sym_true] = ACTIONS(977),
    [sym_false] = ACTIONS(977),
    [sym_null] = ACTIONS(977),
    [sym_undefined] = ACTIONS(977),
    [anon_sym_AT] = ACTIONS(975),
    [anon_sym_static] = ACTIONS(977),
    [anon_sym_abstract] = ACTIONS(977),
    [anon_sym_get] = ACTIONS(977),
    [anon_sym_set] = ACTIONS(977),
    [anon_sym_declare] = ACTIONS(977),
    [anon_sym_public] = ACTIONS(977),
    [anon_sym_private] = ACTIONS(977),
    [anon_sym_protected] = ACTIONS(977),
    [anon_sym_module] = ACTIONS(977),
    [anon_sym_any] = ACTIONS(977),
    [anon_sym_number] = ACTIONS(977),
    [anon_sym_boolean] = ACTIONS(977),
    [anon_sym_string] = ACTIONS(977),
    [anon_sym_symbol] = ACTIONS(977),
    [anon_sym_interface] = ACTIONS(977),
    [anon_sym_enum] = ACTIONS(977),
    [sym_readonly] = ACTIONS(977),
    [anon_sym_PIPE_RBRACE] = ACTIONS(975),
    [sym__automatic_semicolon] = ACTIONS(975),
  },
  [508] = {
    [ts_builtin_sym_end] = ACTIONS(1782),
    [sym_identifier] = ACTIONS(1784),
    [anon_sym_export] = ACTIONS(1784),
    [anon_sym_default] = ACTIONS(1784),
    [anon_sym_namespace] = ACTIONS(1784),
    [anon_sym_LBRACE] = ACTIONS(1782),
    [anon_sym_RBRACE] = ACTIONS(1782),
    [anon_sym_type] = ACTIONS(1784),
    [anon_sym_typeof] = ACTIONS(1784),
    [anon_sym_import] = ACTIONS(1784),
    [anon_sym_var] = ACTIONS(1784),
    [anon_sym_let] = ACTIONS(1784),
    [anon_sym_const] = ACTIONS(1784),
    [anon_sym_BANG] = ACTIONS(1782),
    [anon_sym_else] = ACTIONS(1784),
    [anon_sym_if] = ACTIONS(1784),
    [anon_sym_switch] = ACTIONS(1784),
    [anon_sym_for] = ACTIONS(1784),
    [anon_sym_LPAREN] = ACTIONS(1782),
    [anon_sym_await] = ACTIONS(1784),
    [anon_sym_while] = ACTIONS(1784),
    [anon_sym_do] = ACTIONS(1784),
    [anon_sym_try] = ACTIONS(1784),
    [anon_sym_with] = ACTIONS(1784),
    [anon_sym_break] = ACTIONS(1784),
    [anon_sym_continue] = ACTIONS(1784),
    [anon_sym_debugger] = ACTIONS(1784),
    [anon_sym_return] = ACTIONS(1784),
    [anon_sym_throw] = ACTIONS(1784),
    [anon_sym_SEMI] = ACTIONS(1782),
    [anon_sym_case] = ACTIONS(1784),
    [anon_sym_yield] = ACTIONS(1784),
    [anon_sym_LBRACK] = ACTIONS(1782),
    [anon_sym_LT] = ACTIONS(1782),
    [anon_sym_SLASH] = ACTIONS(1784),
    [anon_sym_class] = ACTIONS(1784),
    [anon_sym_async] = ACTIONS(1784),
    [anon_sym_function] = ACTIONS(1784),
    [anon_sym_new] = ACTIONS(1784),
    [anon_sym_AMP] = ACTIONS(1772),
    [anon_sym_PIPE] = ACTIONS(1774),
    [anon_sym_PLUS] = ACTIONS(1784),
    [anon_sym_DASH] = ACTIONS(1784),
    [anon_sym_TILDE] = ACTIONS(1782),
    [anon_sym_void] = ACTIONS(1784),
    [anon_sym_delete] = ACTIONS(1784),
    [anon_sym_PLUS_PLUS] = ACTIONS(1782),
    [anon_sym_DASH_DASH] = ACTIONS(1782),
    [anon_sym_DQUOTE] = ACTIONS(1782),
    [anon_sym_SQUOTE] = ACTIONS(1782),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1782),
    [sym_number] = ACTIONS(1782),
    [sym_this] = ACTIONS(1784),
    [sym_super] = ACTIONS(1784),
    [sym_true] = ACTIONS(1784),
    [sym_false] = ACTIONS(1784),
    [sym_null] = ACTIONS(1784),
    [sym_undefined] = ACTIONS(1784),
    [anon_sym_AT] = ACTIONS(1782),
    [anon_sym_static] = ACTIONS(1784),
    [anon_sym_abstract] = ACTIONS(1784),
    [anon_sym_get] = ACTIONS(1784),
    [anon_sym_set] = ACTIONS(1784),
    [anon_sym_declare] = ACTIONS(1784),
    [anon_sym_public] = ACTIONS(1784),
    [anon_sym_private] = ACTIONS(1784),
    [anon_sym_protected] = ACTIONS(1784),
    [anon_sym_module] = ACTIONS(1784),
    [anon_sym_any] = ACTIONS(1784),
    [anon_sym_number] = ACTIONS(1784),
    [anon_sym_boolean] = ACTIONS(1784),
    [anon_sym_string] = ACTIONS(1784),
    [anon_sym_symbol] = ACTIONS(1784),
    [anon_sym_interface] = ACTIONS(1784),
    [anon_sym_extends] = ACTIONS(1776),
    [anon_sym_enum] = ACTIONS(1784),
    [sym_readonly] = ACTIONS(1784),
  },
  [509] = {
    [ts_builtin_sym_end] = ACTIONS(1071),
    [sym_identifier] = ACTIONS(1073),
    [anon_sym_export] = ACTIONS(1073),
    [anon_sym_default] = ACTIONS(1073),
    [anon_sym_namespace] = ACTIONS(1073),
    [anon_sym_LBRACE] = ACTIONS(1071),
    [anon_sym_COMMA] = ACTIONS(1071),
    [anon_sym_RBRACE] = ACTIONS(1071),
    [anon_sym_type] = ACTIONS(1073),
    [anon_sym_typeof] = ACTIONS(1073),
    [anon_sym_import] = ACTIONS(1073),
    [anon_sym_var] = ACTIONS(1073),
    [anon_sym_let] = ACTIONS(1073),
    [anon_sym_const] = ACTIONS(1073),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_else] = ACTIONS(1073),
    [anon_sym_if] = ACTIONS(1073),
    [anon_sym_switch] = ACTIONS(1073),
    [anon_sym_for] = ACTIONS(1073),
    [anon_sym_LPAREN] = ACTIONS(1071),
    [anon_sym_await] = ACTIONS(1073),
    [anon_sym_while] = ACTIONS(1073),
    [anon_sym_do] = ACTIONS(1073),
    [anon_sym_try] = ACTIONS(1073),
    [anon_sym_with] = ACTIONS(1073),
    [anon_sym_break] = ACTIONS(1073),
    [anon_sym_continue] = ACTIONS(1073),
    [anon_sym_debugger] = ACTIONS(1073),
    [anon_sym_return] = ACTIONS(1073),
    [anon_sym_throw] = ACTIONS(1073),
    [anon_sym_SEMI] = ACTIONS(1071),
    [anon_sym_case] = ACTIONS(1073),
    [anon_sym_catch] = ACTIONS(1073),
    [anon_sym_finally] = ACTIONS(1073),
    [anon_sym_yield] = ACTIONS(1073),
    [anon_sym_LBRACK] = ACTIONS(1071),
    [anon_sym_LT] = ACTIONS(1071),
    [anon_sym_SLASH] = ACTIONS(1073),
    [anon_sym_class] = ACTIONS(1073),
    [anon_sym_async] = ACTIONS(1073),
    [anon_sym_function] = ACTIONS(1073),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_PLUS] = ACTIONS(1073),
    [anon_sym_DASH] = ACTIONS(1073),
    [anon_sym_TILDE] = ACTIONS(1071),
    [anon_sym_void] = ACTIONS(1073),
    [anon_sym_delete] = ACTIONS(1073),
    [anon_sym_PLUS_PLUS] = ACTIONS(1071),
    [anon_sym_DASH_DASH] = ACTIONS(1071),
    [anon_sym_DQUOTE] = ACTIONS(1071),
    [anon_sym_SQUOTE] = ACTIONS(1071),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1071),
    [sym_number] = ACTIONS(1071),
    [sym_this] = ACTIONS(1073),
    [sym_super] = ACTIONS(1073),
    [sym_true] = ACTIONS(1073),
    [sym_false] = ACTIONS(1073),
    [sym_null] = ACTIONS(1073),
    [sym_undefined] = ACTIONS(1073),
    [anon_sym_AT] = ACTIONS(1071),
    [anon_sym_static] = ACTIONS(1073),
    [anon_sym_abstract] = ACTIONS(1073),
    [anon_sym_get] = ACTIONS(1073),
    [anon_sym_set] = ACTIONS(1073),
    [anon_sym_declare] = ACTIONS(1073),
    [anon_sym_public] = ACTIONS(1073),
    [anon_sym_private] = ACTIONS(1073),
    [anon_sym_protected] = ACTIONS(1073),
    [anon_sym_module] = ACTIONS(1073),
    [anon_sym_any] = ACTIONS(1073),
    [anon_sym_number] = ACTIONS(1073),
    [anon_sym_boolean] = ACTIONS(1073),
    [anon_sym_string] = ACTIONS(1073),
    [anon_sym_symbol] = ACTIONS(1073),
    [anon_sym_interface] = ACTIONS(1073),
    [anon_sym_enum] = ACTIONS(1073),
    [sym_readonly] = ACTIONS(1073),
  },
  [510] = {
    [sym__call_signature] = STATE(3248),
    [sym_formal_parameters] = STATE(2295),
    [sym_type_parameters] = STATE(3054),
    [sym_identifier] = ACTIONS(1706),
    [anon_sym_export] = ACTIONS(1708),
    [anon_sym_STAR] = ACTIONS(780),
    [anon_sym_EQ] = ACTIONS(1067),
    [anon_sym_as] = ACTIONS(780),
    [anon_sym_namespace] = ACTIONS(1708),
    [anon_sym_type] = ACTIONS(1708),
    [anon_sym_BANG] = ACTIONS(780),
    [anon_sym_LPAREN] = ACTIONS(1679),
    [anon_sym_in] = ACTIONS(780),
    [anon_sym_SEMI] = ACTIONS(813),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_LT] = ACTIONS(1682),
    [anon_sym_GT] = ACTIONS(780),
    [anon_sym_SLASH] = ACTIONS(780),
    [anon_sym_DOT] = ACTIONS(1228),
    [anon_sym_async] = ACTIONS(1708),
    [anon_sym_function] = ACTIONS(1669),
    [anon_sym_EQ_GT] = ACTIONS(1069),
    [anon_sym_QMARK_DOT] = ACTIONS(931),
    [anon_sym_PLUS_EQ] = ACTIONS(803),
    [anon_sym_DASH_EQ] = ACTIONS(803),
    [anon_sym_STAR_EQ] = ACTIONS(803),
    [anon_sym_SLASH_EQ] = ACTIONS(803),
    [anon_sym_PERCENT_EQ] = ACTIONS(803),
    [anon_sym_CARET_EQ] = ACTIONS(803),
    [anon_sym_AMP_EQ] = ACTIONS(803),
    [anon_sym_PIPE_EQ] = ACTIONS(803),
    [anon_sym_GT_GT_EQ] = ACTIONS(803),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(803),
    [anon_sym_LT_LT_EQ] = ACTIONS(803),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(803),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(803),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(803),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(803),
    [anon_sym_QMARK] = ACTIONS(780),
    [anon_sym_AMP_AMP] = ACTIONS(780),
    [anon_sym_PIPE_PIPE] = ACTIONS(780),
    [anon_sym_GT_GT] = ACTIONS(780),
    [anon_sym_GT_GT_GT] = ACTIONS(780),
    [anon_sym_LT_LT] = ACTIONS(780),
    [anon_sym_AMP] = ACTIONS(780),
    [anon_sym_CARET] = ACTIONS(780),
    [anon_sym_PIPE] = ACTIONS(780),
    [anon_sym_PLUS] = ACTIONS(780),
    [anon_sym_DASH] = ACTIONS(780),
    [anon_sym_PERCENT] = ACTIONS(780),
    [anon_sym_STAR_STAR] = ACTIONS(780),
    [anon_sym_LT_EQ] = ACTIONS(813),
    [anon_sym_EQ_EQ] = ACTIONS(780),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(813),
    [anon_sym_BANG_EQ] = ACTIONS(780),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(813),
    [anon_sym_GT_EQ] = ACTIONS(813),
    [anon_sym_QMARK_QMARK] = ACTIONS(780),
    [anon_sym_instanceof] = ACTIONS(780),
    [anon_sym_PLUS_PLUS] = ACTIONS(813),
    [anon_sym_DASH_DASH] = ACTIONS(813),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(813),
    [anon_sym_static] = ACTIONS(1708),
    [anon_sym_get] = ACTIONS(1708),
    [anon_sym_set] = ACTIONS(1708),
    [anon_sym_declare] = ACTIONS(1708),
    [anon_sym_public] = ACTIONS(1708),
    [anon_sym_private] = ACTIONS(1708),
    [anon_sym_protected] = ACTIONS(1708),
    [anon_sym_module] = ACTIONS(1708),
    [anon_sym_any] = ACTIONS(1708),
    [anon_sym_number] = ACTIONS(1708),
    [anon_sym_boolean] = ACTIONS(1708),
    [anon_sym_string] = ACTIONS(1708),
    [anon_sym_symbol] = ACTIONS(1708),
    [sym_readonly] = ACTIONS(1708),
    [sym__automatic_semicolon] = ACTIONS(813),
  },
  [511] = {
    [ts_builtin_sym_end] = ACTIONS(941),
    [sym_identifier] = ACTIONS(943),
    [anon_sym_export] = ACTIONS(943),
    [anon_sym_default] = ACTIONS(943),
    [anon_sym_namespace] = ACTIONS(943),
    [anon_sym_LBRACE] = ACTIONS(941),
    [anon_sym_COMMA] = ACTIONS(941),
    [anon_sym_RBRACE] = ACTIONS(941),
    [anon_sym_type] = ACTIONS(943),
    [anon_sym_typeof] = ACTIONS(943),
    [anon_sym_import] = ACTIONS(943),
    [anon_sym_var] = ACTIONS(943),
    [anon_sym_let] = ACTIONS(943),
    [anon_sym_const] = ACTIONS(943),
    [anon_sym_BANG] = ACTIONS(941),
    [anon_sym_else] = ACTIONS(943),
    [anon_sym_if] = ACTIONS(943),
    [anon_sym_switch] = ACTIONS(943),
    [anon_sym_for] = ACTIONS(943),
    [anon_sym_LPAREN] = ACTIONS(941),
    [anon_sym_await] = ACTIONS(943),
    [anon_sym_while] = ACTIONS(943),
    [anon_sym_do] = ACTIONS(943),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_with] = ACTIONS(943),
    [anon_sym_break] = ACTIONS(943),
    [anon_sym_continue] = ACTIONS(943),
    [anon_sym_debugger] = ACTIONS(943),
    [anon_sym_return] = ACTIONS(943),
    [anon_sym_throw] = ACTIONS(943),
    [anon_sym_SEMI] = ACTIONS(941),
    [anon_sym_case] = ACTIONS(943),
    [anon_sym_yield] = ACTIONS(943),
    [anon_sym_LBRACK] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(941),
    [anon_sym_SLASH] = ACTIONS(943),
    [anon_sym_class] = ACTIONS(943),
    [anon_sym_async] = ACTIONS(943),
    [anon_sym_function] = ACTIONS(943),
    [anon_sym_new] = ACTIONS(943),
    [anon_sym_PLUS] = ACTIONS(943),
    [anon_sym_DASH] = ACTIONS(943),
    [anon_sym_TILDE] = ACTIONS(941),
    [anon_sym_void] = ACTIONS(943),
    [anon_sym_delete] = ACTIONS(943),
    [anon_sym_PLUS_PLUS] = ACTIONS(941),
    [anon_sym_DASH_DASH] = ACTIONS(941),
    [anon_sym_DQUOTE] = ACTIONS(941),
    [anon_sym_SQUOTE] = ACTIONS(941),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(941),
    [sym_number] = ACTIONS(941),
    [sym_this] = ACTIONS(943),
    [sym_super] = ACTIONS(943),
    [sym_true] = ACTIONS(943),
    [sym_false] = ACTIONS(943),
    [sym_null] = ACTIONS(943),
    [sym_undefined] = ACTIONS(943),
    [anon_sym_AT] = ACTIONS(941),
    [anon_sym_static] = ACTIONS(943),
    [anon_sym_abstract] = ACTIONS(943),
    [anon_sym_get] = ACTIONS(943),
    [anon_sym_set] = ACTIONS(943),
    [anon_sym_declare] = ACTIONS(943),
    [anon_sym_public] = ACTIONS(943),
    [anon_sym_private] = ACTIONS(943),
    [anon_sym_protected] = ACTIONS(943),
    [anon_sym_module] = ACTIONS(943),
    [anon_sym_any] = ACTIONS(943),
    [anon_sym_number] = ACTIONS(943),
    [anon_sym_boolean] = ACTIONS(943),
    [anon_sym_string] = ACTIONS(943),
    [anon_sym_symbol] = ACTIONS(943),
    [anon_sym_interface] = ACTIONS(943),
    [anon_sym_enum] = ACTIONS(943),
    [sym_readonly] = ACTIONS(943),
    [anon_sym_PIPE_RBRACE] = ACTIONS(941),
    [sym__automatic_semicolon] = ACTIONS(1786),
  },
  [512] = {
    [ts_builtin_sym_end] = ACTIONS(1049),
    [sym_identifier] = ACTIONS(1051),
    [anon_sym_export] = ACTIONS(1051),
    [anon_sym_default] = ACTIONS(1051),
    [anon_sym_namespace] = ACTIONS(1051),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_COMMA] = ACTIONS(1049),
    [anon_sym_RBRACE] = ACTIONS(1049),
    [anon_sym_type] = ACTIONS(1051),
    [anon_sym_typeof] = ACTIONS(1051),
    [anon_sym_import] = ACTIONS(1051),
    [anon_sym_var] = ACTIONS(1051),
    [anon_sym_let] = ACTIONS(1051),
    [anon_sym_const] = ACTIONS(1051),
    [anon_sym_BANG] = ACTIONS(1049),
    [anon_sym_else] = ACTIONS(1051),
    [anon_sym_if] = ACTIONS(1051),
    [anon_sym_switch] = ACTIONS(1051),
    [anon_sym_for] = ACTIONS(1051),
    [anon_sym_LPAREN] = ACTIONS(1049),
    [anon_sym_await] = ACTIONS(1051),
    [anon_sym_while] = ACTIONS(1051),
    [anon_sym_do] = ACTIONS(1051),
    [anon_sym_try] = ACTIONS(1051),
    [anon_sym_with] = ACTIONS(1051),
    [anon_sym_break] = ACTIONS(1051),
    [anon_sym_continue] = ACTIONS(1051),
    [anon_sym_debugger] = ACTIONS(1051),
    [anon_sym_return] = ACTIONS(1051),
    [anon_sym_throw] = ACTIONS(1051),
    [anon_sym_SEMI] = ACTIONS(1049),
    [anon_sym_case] = ACTIONS(1051),
    [anon_sym_yield] = ACTIONS(1051),
    [anon_sym_LBRACK] = ACTIONS(1049),
    [anon_sym_LT] = ACTIONS(1049),
    [anon_sym_SLASH] = ACTIONS(1051),
    [anon_sym_class] = ACTIONS(1051),
    [anon_sym_async] = ACTIONS(1051),
    [anon_sym_function] = ACTIONS(1051),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_PLUS] = ACTIONS(1051),
    [anon_sym_DASH] = ACTIONS(1051),
    [anon_sym_TILDE] = ACTIONS(1049),
    [anon_sym_void] = ACTIONS(1051),
    [anon_sym_delete] = ACTIONS(1051),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_DQUOTE] = ACTIONS(1049),
    [anon_sym_SQUOTE] = ACTIONS(1049),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1049),
    [sym_number] = ACTIONS(1049),
    [sym_this] = ACTIONS(1051),
    [sym_super] = ACTIONS(1051),
    [sym_true] = ACTIONS(1051),
    [sym_false] = ACTIONS(1051),
    [sym_null] = ACTIONS(1051),
    [sym_undefined] = ACTIONS(1051),
    [anon_sym_AT] = ACTIONS(1049),
    [anon_sym_static] = ACTIONS(1051),
    [anon_sym_abstract] = ACTIONS(1051),
    [anon_sym_get] = ACTIONS(1051),
    [anon_sym_set] = ACTIONS(1051),
    [anon_sym_declare] = ACTIONS(1051),
    [anon_sym_public] = ACTIONS(1051),
    [anon_sym_private] = ACTIONS(1051),
    [anon_sym_protected] = ACTIONS(1051),
    [anon_sym_module] = ACTIONS(1051),
    [anon_sym_any] = ACTIONS(1051),
    [anon_sym_number] = ACTIONS(1051),
    [anon_sym_boolean] = ACTIONS(1051),
    [anon_sym_string] = ACTIONS(1051),
    [anon_sym_symbol] = ACTIONS(1051),
    [anon_sym_interface] = ACTIONS(1051),
    [anon_sym_enum] = ACTIONS(1051),
    [sym_readonly] = ACTIONS(1051),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1049),
    [sym__automatic_semicolon] = ACTIONS(1049),
  },
  [513] = {
    [ts_builtin_sym_end] = ACTIONS(1049),
    [sym_identifier] = ACTIONS(1051),
    [anon_sym_export] = ACTIONS(1051),
    [anon_sym_default] = ACTIONS(1051),
    [anon_sym_namespace] = ACTIONS(1051),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_COMMA] = ACTIONS(1049),
    [anon_sym_RBRACE] = ACTIONS(1049),
    [anon_sym_type] = ACTIONS(1051),
    [anon_sym_typeof] = ACTIONS(1051),
    [anon_sym_import] = ACTIONS(1051),
    [anon_sym_var] = ACTIONS(1051),
    [anon_sym_let] = ACTIONS(1051),
    [anon_sym_const] = ACTIONS(1051),
    [anon_sym_BANG] = ACTIONS(1049),
    [anon_sym_else] = ACTIONS(1051),
    [anon_sym_if] = ACTIONS(1051),
    [anon_sym_switch] = ACTIONS(1051),
    [anon_sym_for] = ACTIONS(1051),
    [anon_sym_LPAREN] = ACTIONS(1049),
    [anon_sym_await] = ACTIONS(1051),
    [anon_sym_while] = ACTIONS(1051),
    [anon_sym_do] = ACTIONS(1051),
    [anon_sym_try] = ACTIONS(1051),
    [anon_sym_with] = ACTIONS(1051),
    [anon_sym_break] = ACTIONS(1051),
    [anon_sym_continue] = ACTIONS(1051),
    [anon_sym_debugger] = ACTIONS(1051),
    [anon_sym_return] = ACTIONS(1051),
    [anon_sym_throw] = ACTIONS(1051),
    [anon_sym_SEMI] = ACTIONS(1049),
    [anon_sym_case] = ACTIONS(1051),
    [anon_sym_catch] = ACTIONS(1051),
    [anon_sym_finally] = ACTIONS(1051),
    [anon_sym_yield] = ACTIONS(1051),
    [anon_sym_LBRACK] = ACTIONS(1049),
    [anon_sym_LT] = ACTIONS(1049),
    [anon_sym_SLASH] = ACTIONS(1051),
    [anon_sym_class] = ACTIONS(1051),
    [anon_sym_async] = ACTIONS(1051),
    [anon_sym_function] = ACTIONS(1051),
    [anon_sym_new] = ACTIONS(1051),
    [anon_sym_PLUS] = ACTIONS(1051),
    [anon_sym_DASH] = ACTIONS(1051),
    [anon_sym_TILDE] = ACTIONS(1049),
    [anon_sym_void] = ACTIONS(1051),
    [anon_sym_delete] = ACTIONS(1051),
    [anon_sym_PLUS_PLUS] = ACTIONS(1049),
    [anon_sym_DASH_DASH] = ACTIONS(1049),
    [anon_sym_DQUOTE] = ACTIONS(1049),
    [anon_sym_SQUOTE] = ACTIONS(1049),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1049),
    [sym_number] = ACTIONS(1049),
    [sym_this] = ACTIONS(1051),
    [sym_super] = ACTIONS(1051),
    [sym_true] = ACTIONS(1051),
    [sym_false] = ACTIONS(1051),
    [sym_null] = ACTIONS(1051),
    [sym_undefined] = ACTIONS(1051),
    [anon_sym_AT] = ACTIONS(1049),
    [anon_sym_static] = ACTIONS(1051),
    [anon_sym_abstract] = ACTIONS(1051),
    [anon_sym_get] = ACTIONS(1051),
    [anon_sym_set] = ACTIONS(1051),
    [anon_sym_declare] = ACTIONS(1051),
    [anon_sym_public] = ACTIONS(1051),
    [anon_sym_private] = ACTIONS(1051),
    [anon_sym_protected] = ACTIONS(1051),
    [anon_sym_module] = ACTIONS(1051),
    [anon_sym_any] = ACTIONS(1051),
    [anon_sym_number] = ACTIONS(1051),
    [anon_sym_boolean] = ACTIONS(1051),
    [anon_sym_string] = ACTIONS(1051),
    [anon_sym_symbol] = ACTIONS(1051),
    [anon_sym_interface] = ACTIONS(1051),
    [anon_sym_enum] = ACTIONS(1051),
    [sym_readonly] = ACTIONS(1051),
  },
  [514] = {
    [ts_builtin_sym_end] = ACTIONS(1788),
    [sym_identifier] = ACTIONS(1790),
    [anon_sym_export] = ACTIONS(1790),
    [anon_sym_default] = ACTIONS(1790),
    [anon_sym_namespace] = ACTIONS(1790),
    [anon_sym_LBRACE] = ACTIONS(1788),
    [anon_sym_RBRACE] = ACTIONS(1788),
    [anon_sym_type] = ACTIONS(1790),
    [anon_sym_typeof] = ACTIONS(1790),
    [anon_sym_import] = ACTIONS(1790),
    [anon_sym_var] = ACTIONS(1790),
    [anon_sym_let] = ACTIONS(1790),
    [anon_sym_const] = ACTIONS(1790),
    [anon_sym_BANG] = ACTIONS(1788),
    [anon_sym_else] = ACTIONS(1790),
    [anon_sym_if] = ACTIONS(1790),
    [anon_sym_switch] = ACTIONS(1790),
    [anon_sym_for] = ACTIONS(1790),
    [anon_sym_LPAREN] = ACTIONS(1788),
    [anon_sym_await] = ACTIONS(1790),
    [anon_sym_while] = ACTIONS(1790),
    [anon_sym_do] = ACTIONS(1790),
    [anon_sym_try] = ACTIONS(1790),
    [anon_sym_with] = ACTIONS(1790),
    [anon_sym_break] = ACTIONS(1790),
    [anon_sym_continue] = ACTIONS(1790),
    [anon_sym_debugger] = ACTIONS(1790),
    [anon_sym_return] = ACTIONS(1790),
    [anon_sym_throw] = ACTIONS(1790),
    [anon_sym_SEMI] = ACTIONS(1788),
    [anon_sym_case] = ACTIONS(1790),
    [anon_sym_yield] = ACTIONS(1790),
    [anon_sym_LBRACK] = ACTIONS(1788),
    [anon_sym_LT] = ACTIONS(1788),
    [anon_sym_SLASH] = ACTIONS(1790),
    [anon_sym_class] = ACTIONS(1790),
    [anon_sym_async] = ACTIONS(1790),
    [anon_sym_function] = ACTIONS(1790),
    [anon_sym_new] = ACTIONS(1790),
    [anon_sym_AMP] = ACTIONS(1772),
    [anon_sym_PIPE] = ACTIONS(1774),
    [anon_sym_PLUS] = ACTIONS(1790),
    [anon_sym_DASH] = ACTIONS(1790),
    [anon_sym_TILDE] = ACTIONS(1788),
    [anon_sym_void] = ACTIONS(1790),
    [anon_sym_delete] = ACTIONS(1790),
    [anon_sym_PLUS_PLUS] = ACTIONS(1788),
    [anon_sym_DASH_DASH] = ACTIONS(1788),
    [anon_sym_DQUOTE] = ACTIONS(1788),
    [anon_sym_SQUOTE] = ACTIONS(1788),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1788),
    [sym_number] = ACTIONS(1788),
    [sym_this] = ACTIONS(1790),
    [sym_super] = ACTIONS(1790),
    [sym_true] = ACTIONS(1790),
    [sym_false] = ACTIONS(1790),
    [sym_null] = ACTIONS(1790),
    [sym_undefined] = ACTIONS(1790),
    [anon_sym_AT] = ACTIONS(1788),
    [anon_sym_static] = ACTIONS(1790),
    [anon_sym_abstract] = ACTIONS(1790),
    [anon_sym_get] = ACTIONS(1790),
    [anon_sym_set] = ACTIONS(1790),
    [anon_sym_declare] = ACTIONS(1790),
    [anon_sym_public] = ACTIONS(1790),
    [anon_sym_private] = ACTIONS(1790),
    [anon_sym_protected] = ACTIONS(1790),
    [anon_sym_module] = ACTIONS(1790),
    [anon_sym_any] = ACTIONS(1790),
    [anon_sym_number] = ACTIONS(1790),
    [anon_sym_boolean] = ACTIONS(1790),
    [anon_sym_string] = ACTIONS(1790),
    [anon_sym_symbol] = ACTIONS(1790),
    [anon_sym_interface] = ACTIONS(1790),
    [anon_sym_extends] = ACTIONS(1776),
    [anon_sym_enum] = ACTIONS(1790),
    [sym_readonly] = ACTIONS(1790),
  },
  [515] = {
    [sym_identifier] = ACTIONS(1671),
    [anon_sym_export] = ACTIONS(1671),
    [anon_sym_STAR] = ACTIONS(780),
    [anon_sym_EQ] = ACTIONS(777),
    [anon_sym_as] = ACTIONS(780),
    [anon_sym_namespace] = ACTIONS(1671),
    [anon_sym_LBRACE] = ACTIONS(1673),
    [anon_sym_COMMA] = ACTIONS(784),
    [anon_sym_type] = ACTIONS(1671),
    [anon_sym_BANG] = ACTIONS(780),
    [anon_sym_LPAREN] = ACTIONS(813),
    [anon_sym_RPAREN] = ACTIONS(784),
    [anon_sym_in] = ACTIONS(780),
    [anon_sym_COLON] = ACTIONS(1736),
    [anon_sym_LBRACK] = ACTIONS(1639),
    [anon_sym_LT] = ACTIONS(780),
    [anon_sym_GT] = ACTIONS(780),
    [anon_sym_SLASH] = ACTIONS(780),
    [anon_sym_DOT] = ACTIONS(1641),
    [anon_sym_async] = ACTIONS(1671),
    [anon_sym_EQ_GT] = ACTIONS(797),
    [anon_sym_QMARK_DOT] = ACTIONS(799),
    [anon_sym_PLUS_EQ] = ACTIONS(803),
    [anon_sym_DASH_EQ] = ACTIONS(803),
    [anon_sym_STAR_EQ] = ACTIONS(803),
    [anon_sym_SLASH_EQ] = ACTIONS(803),
    [anon_sym_PERCENT_EQ] = ACTIONS(803),
    [anon_sym_CARET_EQ] = ACTIONS(803),
    [anon_sym_AMP_EQ] = ACTIONS(803),
    [anon_sym_PIPE_EQ] = ACTIONS(803),
    [anon_sym_GT_GT_EQ] = ACTIONS(803),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(803),
    [anon_sym_LT_LT_EQ] = ACTIONS(803),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(803),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(803),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(803),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(803),
    [anon_sym_QMARK] = ACTIONS(1733),
    [anon_sym_AMP_AMP] = ACTIONS(780),
    [anon_sym_PIPE_PIPE] = ACTIONS(780),
    [anon_sym_GT_GT] = ACTIONS(780),
    [anon_sym_GT_GT_GT] = ACTIONS(780),
    [anon_sym_LT_LT] = ACTIONS(780),
    [anon_sym_AMP] = ACTIONS(780),
    [anon_sym_CARET] = ACTIONS(780),
    [anon_sym_PIPE] = ACTIONS(780),
    [anon_sym_PLUS] = ACTIONS(780),
    [anon_sym_DASH] = ACTIONS(780),
    [anon_sym_PERCENT] = ACTIONS(780),
    [anon_sym_STAR_STAR] = ACTIONS(780),
    [anon_sym_LT_EQ] = ACTIONS(813),
    [anon_sym_EQ_EQ] = ACTIONS(780),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(813),
    [anon_sym_BANG_EQ] = ACTIONS(780),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(813),
    [anon_sym_GT_EQ] = ACTIONS(813),
    [anon_sym_QMARK_QMARK] = ACTIONS(780),
    [anon_sym_instanceof] = ACTIONS(780),
    [anon_sym_PLUS_PLUS] = ACTIONS(813),
    [anon_sym_DASH_DASH] = ACTIONS(813),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(813),
    [sym_this] = ACTIONS(1671),
    [anon_sym_static] = ACTIONS(1671),
    [anon_sym_get] = ACTIONS(1671),
    [anon_sym_set] = ACTIONS(1671),
    [anon_sym_declare] = ACTIONS(1671),
    [anon_sym_public] = ACTIONS(1671),
    [anon_sym_private] = ACTIONS(1671),
    [anon_sym_protected] = ACTIONS(1671),
    [anon_sym_module] = ACTIONS(1671),
    [anon_sym_any] = ACTIONS(1671),
    [anon_sym_number] = ACTIONS(1671),
    [anon_sym_boolean] = ACTIONS(1671),
    [anon_sym_string] = ACTIONS(1671),
    [anon_sym_symbol] = ACTIONS(1671),
    [sym_readonly] = ACTIONS(1671),
  },
  [516] = {
    [sym_finally_clause] = STATE(567),
    [ts_builtin_sym_end] = ACTIONS(1792),
    [sym_identifier] = ACTIONS(1794),
    [anon_sym_export] = ACTIONS(1794),
    [anon_sym_default] = ACTIONS(1794),
    [anon_sym_namespace] = ACTIONS(1794),
    [anon_sym_LBRACE] = ACTIONS(1792),
    [anon_sym_RBRACE] = ACTIONS(1792),
    [anon_sym_type] = ACTIONS(1794),
    [anon_sym_typeof] = ACTIONS(1794),
    [anon_sym_import] = ACTIONS(1794),
    [anon_sym_var] = ACTIONS(1794),
    [anon_sym_let] = ACTIONS(1794),
    [anon_sym_const] = ACTIONS(1794),
    [anon_sym_BANG] = ACTIONS(1792),
    [anon_sym_else] = ACTIONS(1794),
    [anon_sym_if] = ACTIONS(1794),
    [anon_sym_switch] = ACTIONS(1794),
    [anon_sym_for] = ACTIONS(1794),
    [anon_sym_LPAREN] = ACTIONS(1792),
    [anon_sym_await] = ACTIONS(1794),
    [anon_sym_while] = ACTIONS(1794),
    [anon_sym_do] = ACTIONS(1794),
    [anon_sym_try] = ACTIONS(1794),
    [anon_sym_with] = ACTIONS(1794),
    [anon_sym_break] = ACTIONS(1794),
    [anon_sym_continue] = ACTIONS(1794),
    [anon_sym_debugger] = ACTIONS(1794),
    [anon_sym_return] = ACTIONS(1794),
    [anon_sym_throw] = ACTIONS(1794),
    [anon_sym_SEMI] = ACTIONS(1792),
    [anon_sym_case] = ACTIONS(1794),
    [anon_sym_finally] = ACTIONS(1746),
    [anon_sym_yield] = ACTIONS(1794),
    [anon_sym_LBRACK] = ACTIONS(1792),
    [anon_sym_LT] = ACTIONS(1792),
    [anon_sym_SLASH] = ACTIONS(1794),
    [anon_sym_class] = ACTIONS(1794),
    [anon_sym_async] = ACTIONS(1794),
    [anon_sym_function] = ACTIONS(1794),
    [anon_sym_new] = ACTIONS(1794),
    [anon_sym_PLUS] = ACTIONS(1794),
    [anon_sym_DASH] = ACTIONS(1794),
    [anon_sym_TILDE] = ACTIONS(1792),
    [anon_sym_void] = ACTIONS(1794),
    [anon_sym_delete] = ACTIONS(1794),
    [anon_sym_PLUS_PLUS] = ACTIONS(1792),
    [anon_sym_DASH_DASH] = ACTIONS(1792),
    [anon_sym_DQUOTE] = ACTIONS(1792),
    [anon_sym_SQUOTE] = ACTIONS(1792),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1792),
    [sym_number] = ACTIONS(1792),
    [sym_this] = ACTIONS(1794),
    [sym_super] = ACTIONS(1794),
    [sym_true] = ACTIONS(1794),
    [sym_false] = ACTIONS(1794),
    [sym_null] = ACTIONS(1794),
    [sym_undefined] = ACTIONS(1794),
    [anon_sym_AT] = ACTIONS(1792),
    [anon_sym_static] = ACTIONS(1794),
    [anon_sym_abstract] = ACTIONS(1794),
    [anon_sym_get] = ACTIONS(1794),
    [anon_sym_set] = ACTIONS(1794),
    [anon_sym_declare] = ACTIONS(1794),
    [anon_sym_public] = ACTIONS(1794),
    [anon_sym_private] = ACTIONS(1794),
    [anon_sym_protected] = ACTIONS(1794),
    [anon_sym_module] = ACTIONS(1794),
    [anon_sym_any] = ACTIONS(1794),
    [anon_sym_number] = ACTIONS(1794),
    [anon_sym_boolean] = ACTIONS(1794),
    [anon_sym_string] = ACTIONS(1794),
    [anon_sym_symbol] = ACTIONS(1794),
    [anon_sym_interface] = ACTIONS(1794),
    [anon_sym_enum] = ACTIONS(1794),
    [sym_readonly] = ACTIONS(1794),
  },
  [517] = {
    [sym_identifier] = ACTIONS(1671),
    [anon_sym_export] = ACTIONS(1671),
    [anon_sym_STAR] = ACTIONS(780),
    [anon_sym_EQ] = ACTIONS(777),
    [anon_sym_as] = ACTIONS(780),
    [anon_sym_namespace] = ACTIONS(1671),
    [anon_sym_LBRACE] = ACTIONS(1673),
    [anon_sym_COMMA] = ACTIONS(784),
    [anon_sym_type] = ACTIONS(1671),
    [anon_sym_BANG] = ACTIONS(780),
    [anon_sym_LPAREN] = ACTIONS(813),
    [anon_sym_RPAREN] = ACTIONS(784),
    [anon_sym_in] = ACTIONS(780),
    [anon_sym_COLON] = ACTIONS(784),
    [anon_sym_LBRACK] = ACTIONS(1639),
    [anon_sym_LT] = ACTIONS(780),
    [anon_sym_GT] = ACTIONS(780),
    [anon_sym_SLASH] = ACTIONS(780),
    [anon_sym_DOT] = ACTIONS(1641),
    [anon_sym_async] = ACTIONS(1671),
    [anon_sym_EQ_GT] = ACTIONS(797),
    [anon_sym_QMARK_DOT] = ACTIONS(799),
    [anon_sym_PLUS_EQ] = ACTIONS(803),
    [anon_sym_DASH_EQ] = ACTIONS(803),
    [anon_sym_STAR_EQ] = ACTIONS(803),
    [anon_sym_SLASH_EQ] = ACTIONS(803),
    [anon_sym_PERCENT_EQ] = ACTIONS(803),
    [anon_sym_CARET_EQ] = ACTIONS(803),
    [anon_sym_AMP_EQ] = ACTIONS(803),
    [anon_sym_PIPE_EQ] = ACTIONS(803),
    [anon_sym_GT_GT_EQ] = ACTIONS(803),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(803),
    [anon_sym_LT_LT_EQ] = ACTIONS(803),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(803),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(803),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(803),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(803),
    [anon_sym_QMARK] = ACTIONS(1733),
    [anon_sym_AMP_AMP] = ACTIONS(780),
    [anon_sym_PIPE_PIPE] = ACTIONS(780),
    [anon_sym_GT_GT] = ACTIONS(780),
    [anon_sym_GT_GT_GT] = ACTIONS(780),
    [anon_sym_LT_LT] = ACTIONS(780),
    [anon_sym_AMP] = ACTIONS(780),
    [anon_sym_CARET] = ACTIONS(780),
    [anon_sym_PIPE] = ACTIONS(780),
    [anon_sym_PLUS] = ACTIONS(780),
    [anon_sym_DASH] = ACTIONS(780),
    [anon_sym_PERCENT] = ACTIONS(780),
    [anon_sym_STAR_STAR] = ACTIONS(780),
    [anon_sym_LT_EQ] = ACTIONS(813),
    [anon_sym_EQ_EQ] = ACTIONS(780),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(813),
    [anon_sym_BANG_EQ] = ACTIONS(780),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(813),
    [anon_sym_GT_EQ] = ACTIONS(813),
    [anon_sym_QMARK_QMARK] = ACTIONS(780),
    [anon_sym_instanceof] = ACTIONS(780),
    [anon_sym_PLUS_PLUS] = ACTIONS(813),
    [anon_sym_DASH_DASH] = ACTIONS(813),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(813),
    [sym_this] = ACTIONS(1671),
    [anon_sym_static] = ACTIONS(1671),
    [anon_sym_get] = ACTIONS(1671),
    [anon_sym_set] = ACTIONS(1671),
    [anon_sym_declare] = ACTIONS(1671),
    [anon_sym_public] = ACTIONS(1671),
    [anon_sym_private] = ACTIONS(1671),
    [anon_sym_protected] = ACTIONS(1671),
    [anon_sym_module] = ACTIONS(1671),
    [anon_sym_any] = ACTIONS(1671),
    [anon_sym_number] = ACTIONS(1671),
    [anon_sym_boolean] = ACTIONS(1671),
    [anon_sym_string] = ACTIONS(1671),
    [anon_sym_symbol] = ACTIONS(1671),
    [sym_readonly] = ACTIONS(1671),
  },
  [518] = {
    [sym_statement_block] = STATE(586),
    [ts_builtin_sym_end] = ACTIONS(933),
    [sym_identifier] = ACTIONS(935),
    [anon_sym_export] = ACTIONS(935),
    [anon_sym_default] = ACTIONS(935),
    [anon_sym_namespace] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(1796),
    [anon_sym_RBRACE] = ACTIONS(933),
    [anon_sym_type] = ACTIONS(935),
    [anon_sym_typeof] = ACTIONS(935),
    [anon_sym_import] = ACTIONS(935),
    [anon_sym_var] = ACTIONS(935),
    [anon_sym_let] = ACTIONS(935),
    [anon_sym_const] = ACTIONS(935),
    [anon_sym_BANG] = ACTIONS(933),
    [anon_sym_else] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_switch] = ACTIONS(935),
    [anon_sym_for] = ACTIONS(935),
    [anon_sym_LPAREN] = ACTIONS(933),
    [anon_sym_await] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_try] = ACTIONS(935),
    [anon_sym_with] = ACTIONS(935),
    [anon_sym_break] = ACTIONS(935),
    [anon_sym_continue] = ACTIONS(935),
    [anon_sym_debugger] = ACTIONS(935),
    [anon_sym_return] = ACTIONS(935),
    [anon_sym_throw] = ACTIONS(935),
    [anon_sym_SEMI] = ACTIONS(933),
    [anon_sym_case] = ACTIONS(935),
    [anon_sym_yield] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(933),
    [anon_sym_LT] = ACTIONS(933),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(1798),
    [anon_sym_class] = ACTIONS(935),
    [anon_sym_async] = ACTIONS(935),
    [anon_sym_function] = ACTIONS(935),
    [anon_sym_new] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_DASH] = ACTIONS(935),
    [anon_sym_TILDE] = ACTIONS(933),
    [anon_sym_void] = ACTIONS(935),
    [anon_sym_delete] = ACTIONS(935),
    [anon_sym_PLUS_PLUS] = ACTIONS(933),
    [anon_sym_DASH_DASH] = ACTIONS(933),
    [anon_sym_DQUOTE] = ACTIONS(933),
    [anon_sym_SQUOTE] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(933),
    [sym_number] = ACTIONS(933),
    [sym_this] = ACTIONS(935),
    [sym_super] = ACTIONS(935),
    [sym_true] = ACTIONS(935),
    [sym_false] = ACTIONS(935),
    [sym_null] = ACTIONS(935),
    [sym_undefined] = ACTIONS(935),
    [anon_sym_AT] = ACTIONS(933),
    [anon_sym_static] = ACTIONS(935),
    [anon_sym_abstract] = ACTIONS(935),
    [anon_sym_get] = ACTIONS(935),
    [anon_sym_set] = ACTIONS(935),
    [anon_sym_declare] = ACTIONS(935),
    [anon_sym_public] = ACTIONS(935),
    [anon_sym_private] = ACTIONS(935),
    [anon_sym_protected] = ACTIONS(935),
    [anon_sym_module] = ACTIONS(935),
    [anon_sym_any] = ACTIONS(935),
    [anon_sym_number] = ACTIONS(935),
    [anon_sym_boolean] = ACTIONS(935),
    [anon_sym_string] = ACTIONS(935),
    [anon_sym_symbol] = ACTIONS(935),
    [anon_sym_interface] = ACTIONS(935),
    [anon_sym_enum] = ACTIONS(935),
    [sym_readonly] = ACTIONS(935),
  },
  [519] = {
    [sym__call_signature] = STATE(3164),
    [sym_formal_parameters] = STATE(2295),
    [sym_type_parameters] = STATE(3054),
    [sym_identifier] = ACTIONS(1700),
    [anon_sym_export] = ACTIONS(1702),
    [anon_sym_STAR] = ACTIONS(780),
    [anon_sym_EQ] = ACTIONS(961),
    [anon_sym_as] = ACTIONS(780),
    [anon_sym_namespace] = ACTIONS(1702),
    [anon_sym_type] = ACTIONS(1702),
    [anon_sym_BANG] = ACTIONS(780),
    [anon_sym_LPAREN] = ACTIONS(1679),
    [anon_sym_in] = ACTIONS(1695),
    [anon_sym_of] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1639),
    [anon_sym_LT] = ACTIONS(1682),
    [anon_sym_GT] = ACTIONS(780),
    [anon_sym_SLASH] = ACTIONS(780),
    [anon_sym_DOT] = ACTIONS(1641),
    [anon_sym_async] = ACTIONS(1702),
    [anon_sym_function] = ACTIONS(1643),
    [anon_sym_EQ_GT] = ACTIONS(963),
    [anon_sym_QMARK_DOT] = ACTIONS(799),
    [anon_sym_PLUS_EQ] = ACTIONS(803),
    [anon_sym_DASH_EQ] = ACTIONS(803),
    [anon_sym_STAR_EQ] = ACTIONS(803),
    [anon_sym_SLASH_EQ] = ACTIONS(803),
    [anon_sym_PERCENT_EQ] = ACTIONS(803),
    [anon_sym_CARET_EQ] = ACTIONS(803),
    [anon_sym_AMP_EQ] = ACTIONS(803),
    [anon_sym_PIPE_EQ] = ACTIONS(803),
    [anon_sym_GT_GT_EQ] = ACTIONS(803),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(803),
    [anon_sym_LT_LT_EQ] = ACTIONS(803),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(803),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(803),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(803),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(803),
    [anon_sym_QMARK] = ACTIONS(780),
    [anon_sym_AMP_AMP] = ACTIONS(780),
    [anon_sym_PIPE_PIPE] = ACTIONS(780),
    [anon_sym_GT_GT] = ACTIONS(780),
    [anon_sym_GT_GT_GT] = ACTIONS(780),
    [anon_sym_LT_LT] = ACTIONS(780),
    [anon_sym_AMP] = ACTIONS(780),
    [anon_sym_CARET] = ACTIONS(780),
    [anon_sym_PIPE] = ACTIONS(780),
    [anon_sym_PLUS] = ACTIONS(780),
    [anon_sym_DASH] = ACTIONS(780),
    [anon_sym_PERCENT] = ACTIONS(780),
    [anon_sym_STAR_STAR] = ACTIONS(780),
    [anon_sym_LT_EQ] = ACTIONS(813),
    [anon_sym_EQ_EQ] = ACTIONS(780),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(813),
    [anon_sym_BANG_EQ] = ACTIONS(780),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(813),
    [anon_sym_GT_EQ] = ACTIONS(813),
    [anon_sym_QMARK_QMARK] = ACTIONS(780),
    [anon_sym_instanceof] = ACTIONS(780),
    [anon_sym_PLUS_PLUS] = ACTIONS(813),
    [anon_sym_DASH_DASH] = ACTIONS(813),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(813),
    [anon_sym_static] = ACTIONS(1702),
    [anon_sym_get] = ACTIONS(1702),
    [anon_sym_set] = ACTIONS(1702),
    [anon_sym_declare] = ACTIONS(1702),
    [anon_sym_public] = ACTIONS(1702),
    [anon_sym_private] = ACTIONS(1702),
    [anon_sym_protected] = ACTIONS(1702),
    [anon_sym_module] = ACTIONS(1702),
    [anon_sym_any] = ACTIONS(1702),
    [anon_sym_number] = ACTIONS(1702),
    [anon_sym_boolean] = ACTIONS(1702),
    [anon_sym_string] = ACTIONS(1702),
    [anon_sym_symbol] = ACTIONS(1702),
    [sym_readonly] = ACTIONS(1702),
  },
  [520] = {
    [sym__call_signature] = STATE(3164),
    [sym_formal_parameters] = STATE(2295),
    [sym_type_parameters] = STATE(3054),
    [sym_identifier] = ACTIONS(1700),
    [anon_sym_export] = ACTIONS(1702),
    [anon_sym_STAR] = ACTIONS(780),
    [anon_sym_EQ] = ACTIONS(961),
    [anon_sym_as] = ACTIONS(780),
    [anon_sym_namespace] = ACTIONS(1702),
    [anon_sym_type] = ACTIONS(1702),
    [anon_sym_BANG] = ACTIONS(780),
    [anon_sym_LPAREN] = ACTIONS(1679),
    [anon_sym_in] = ACTIONS(1800),
    [anon_sym_of] = ACTIONS(1803),
    [anon_sym_LBRACK] = ACTIONS(1639),
    [anon_sym_LT] = ACTIONS(1682),
    [anon_sym_GT] = ACTIONS(780),
    [anon_sym_SLASH] = ACTIONS(780),
    [anon_sym_DOT] = ACTIONS(1641),
    [anon_sym_async] = ACTIONS(1702),
    [anon_sym_function] = ACTIONS(1643),
    [anon_sym_EQ_GT] = ACTIONS(963),
    [anon_sym_QMARK_DOT] = ACTIONS(799),
    [anon_sym_PLUS_EQ] = ACTIONS(803),
    [anon_sym_DASH_EQ] = ACTIONS(803),
    [anon_sym_STAR_EQ] = ACTIONS(803),
    [anon_sym_SLASH_EQ] = ACTIONS(803),
    [anon_sym_PERCENT_EQ] = ACTIONS(803),
    [anon_sym_CARET_EQ] = ACTIONS(803),
    [anon_sym_AMP_EQ] = ACTIONS(803),
    [anon_sym_PIPE_EQ] = ACTIONS(803),
    [anon_sym_GT_GT_EQ] = ACTIONS(803),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(803),
    [anon_sym_LT_LT_EQ] = ACTIONS(803),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(803),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(803),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(803),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(803),
    [anon_sym_QMARK] = ACTIONS(780),
    [anon_sym_AMP_AMP] = ACTIONS(780),
    [anon_sym_PIPE_PIPE] = ACTIONS(780),
    [anon_sym_GT_GT] = ACTIONS(780),
    [anon_sym_GT_GT_GT] = ACTIONS(780),
    [anon_sym_LT_LT] = ACTIONS(780),
    [anon_sym_AMP] = ACTIONS(780),
    [anon_sym_CARET] = ACTIONS(780),
    [anon_sym_PIPE] = ACTIONS(780),
    [anon_sym_PLUS] = ACTIONS(780),
    [anon_sym_DASH] = ACTIONS(780),
    [anon_sym_PERCENT] = ACTIONS(780),
    [anon_sym_STAR_STAR] = ACTIONS(780),
    [anon_sym_LT_EQ] = ACTIONS(813),
    [anon_sym_EQ_EQ] = ACTIONS(780),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(813),
    [anon_sym_BANG_EQ] = ACTIONS(780),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(813),
    [anon_sym_GT_EQ] = ACTIONS(813),
    [anon_sym_QMARK_QMARK] = ACTIONS(780),
    [anon_sym_instanceof] = ACTIONS(780),
    [anon_sym_PLUS_PLUS] = ACTIONS(813),
    [anon_sym_DASH_DASH] = ACTIONS(813),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(813),
    [anon_sym_static] = ACTIONS(1702),
    [anon_sym_get] = ACTIONS(1702),
    [anon_sym_set] = ACTIONS(1702),
    [anon_sym_declare] = ACTIONS(1702),
    [anon_sym_public] = ACTIONS(1702),
    [anon_sym_private] = ACTIONS(1702),
    [anon_sym_protected] = ACTIONS(1702),
    [anon_sym_module] = ACTIONS(1702),
    [anon_sym_any] = ACTIONS(1702),
    [anon_sym_number] = ACTIONS(1702),
    [anon_sym_boolean] = ACTIONS(1702),
    [anon_sym_string] = ACTIONS(1702),
    [anon_sym_symbol] = ACTIONS(1702),
    [sym_readonly] = ACTIONS(1702),
  },
  [521] = {
    [ts_builtin_sym_end] = ACTIONS(1805),
    [sym_identifier] = ACTIONS(1807),
    [anon_sym_export] = ACTIONS(1807),
    [anon_sym_default] = ACTIONS(1807),
    [anon_sym_namespace] = ACTIONS(1807),
    [anon_sym_LBRACE] = ACTIONS(1805),
    [anon_sym_RBRACE] = ACTIONS(1805),
    [anon_sym_type] = ACTIONS(1807),
    [anon_sym_typeof] = ACTIONS(1807),
    [anon_sym_import] = ACTIONS(1807),
    [anon_sym_var] = ACTIONS(1807),
    [anon_sym_let] = ACTIONS(1807),
    [anon_sym_const] = ACTIONS(1807),
    [anon_sym_BANG] = ACTIONS(1805),
    [anon_sym_else] = ACTIONS(1807),
    [anon_sym_if] = ACTIONS(1807),
    [anon_sym_switch] = ACTIONS(1807),
    [anon_sym_for] = ACTIONS(1807),
    [anon_sym_LPAREN] = ACTIONS(1805),
    [anon_sym_RPAREN] = ACTIONS(1805),
    [anon_sym_await] = ACTIONS(1807),
    [anon_sym_while] = ACTIONS(1807),
    [anon_sym_do] = ACTIONS(1807),
    [anon_sym_try] = ACTIONS(1807),
    [anon_sym_with] = ACTIONS(1807),
    [anon_sym_break] = ACTIONS(1807),
    [anon_sym_continue] = ACTIONS(1807),
    [anon_sym_debugger] = ACTIONS(1807),
    [anon_sym_return] = ACTIONS(1807),
    [anon_sym_throw] = ACTIONS(1807),
    [anon_sym_SEMI] = ACTIONS(1805),
    [anon_sym_case] = ACTIONS(1807),
    [anon_sym_yield] = ACTIONS(1807),
    [anon_sym_LBRACK] = ACTIONS(1805),
    [anon_sym_LT] = ACTIONS(1805),
    [anon_sym_SLASH] = ACTIONS(1807),
    [anon_sym_class] = ACTIONS(1807),
    [anon_sym_async] = ACTIONS(1807),
    [anon_sym_function] = ACTIONS(1807),
    [anon_sym_new] = ACTIONS(1807),
    [anon_sym_PLUS] = ACTIONS(1807),
    [anon_sym_DASH] = ACTIONS(1807),
    [anon_sym_TILDE] = ACTIONS(1805),
    [anon_sym_void] = ACTIONS(1807),
    [anon_sym_delete] = ACTIONS(1807),
    [anon_sym_PLUS_PLUS] = ACTIONS(1805),
    [anon_sym_DASH_DASH] = ACTIONS(1805),
    [anon_sym_DQUOTE] = ACTIONS(1805),
    [anon_sym_SQUOTE] = ACTIONS(1805),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1805),
    [sym_number] = ACTIONS(1805),
    [sym_this] = ACTIONS(1807),
    [sym_super] = ACTIONS(1807),
    [sym_true] = ACTIONS(1807),
    [sym_false] = ACTIONS(1807),
    [sym_null] = ACTIONS(1807),
    [sym_undefined] = ACTIONS(1807),
    [anon_sym_AT] = ACTIONS(1805),
    [anon_sym_static] = ACTIONS(1807),
    [anon_sym_abstract] = ACTIONS(1807),
    [anon_sym_get] = ACTIONS(1807),
    [anon_sym_set] = ACTIONS(1807),
    [anon_sym_declare] = ACTIONS(1807),
    [anon_sym_public] = ACTIONS(1807),
    [anon_sym_private] = ACTIONS(1807),
    [anon_sym_protected] = ACTIONS(1807),
    [anon_sym_module] = ACTIONS(1807),
    [anon_sym_any] = ACTIONS(1807),
    [anon_sym_number] = ACTIONS(1807),
    [anon_sym_boolean] = ACTIONS(1807),
    [anon_sym_string] = ACTIONS(1807),
    [anon_sym_symbol] = ACTIONS(1807),
    [anon_sym_interface] = ACTIONS(1807),
    [anon_sym_enum] = ACTIONS(1807),
    [sym_readonly] = ACTIONS(1807),
  },
  [522] = {
    [ts_builtin_sym_end] = ACTIONS(1809),
    [sym_identifier] = ACTIONS(1811),
    [anon_sym_export] = ACTIONS(1811),
    [anon_sym_default] = ACTIONS(1811),
    [anon_sym_namespace] = ACTIONS(1811),
    [anon_sym_LBRACE] = ACTIONS(1809),
    [anon_sym_RBRACE] = ACTIONS(1809),
    [anon_sym_type] = ACTIONS(1811),
    [anon_sym_typeof] = ACTIONS(1811),
    [anon_sym_import] = ACTIONS(1811),
    [anon_sym_var] = ACTIONS(1811),
    [anon_sym_let] = ACTIONS(1811),
    [anon_sym_const] = ACTIONS(1811),
    [anon_sym_BANG] = ACTIONS(1809),
    [anon_sym_else] = ACTIONS(1811),
    [anon_sym_if] = ACTIONS(1811),
    [anon_sym_switch] = ACTIONS(1811),
    [anon_sym_for] = ACTIONS(1811),
    [anon_sym_LPAREN] = ACTIONS(1809),
    [anon_sym_await] = ACTIONS(1811),
    [anon_sym_while] = ACTIONS(1811),
    [anon_sym_do] = ACTIONS(1811),
    [anon_sym_try] = ACTIONS(1811),
    [anon_sym_with] = ACTIONS(1811),
    [anon_sym_break] = ACTIONS(1811),
    [anon_sym_continue] = ACTIONS(1811),
    [anon_sym_debugger] = ACTIONS(1811),
    [anon_sym_return] = ACTIONS(1811),
    [anon_sym_throw] = ACTIONS(1811),
    [anon_sym_SEMI] = ACTIONS(1809),
    [anon_sym_case] = ACTIONS(1811),
    [anon_sym_finally] = ACTIONS(1811),
    [anon_sym_yield] = ACTIONS(1811),
    [anon_sym_LBRACK] = ACTIONS(1809),
    [anon_sym_LT] = ACTIONS(1809),
    [anon_sym_SLASH] = ACTIONS(1811),
    [anon_sym_class] = ACTIONS(1811),
    [anon_sym_async] = ACTIONS(1811),
    [anon_sym_function] = ACTIONS(1811),
    [anon_sym_new] = ACTIONS(1811),
    [anon_sym_PLUS] = ACTIONS(1811),
    [anon_sym_DASH] = ACTIONS(1811),
    [anon_sym_TILDE] = ACTIONS(1809),
    [anon_sym_void] = ACTIONS(1811),
    [anon_sym_delete] = ACTIONS(1811),
    [anon_sym_PLUS_PLUS] = ACTIONS(1809),
    [anon_sym_DASH_DASH] = ACTIONS(1809),
    [anon_sym_DQUOTE] = ACTIONS(1809),
    [anon_sym_SQUOTE] = ACTIONS(1809),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1809),
    [sym_number] = ACTIONS(1809),
    [sym_this] = ACTIONS(1811),
    [sym_super] = ACTIONS(1811),
    [sym_true] = ACTIONS(1811),
    [sym_false] = ACTIONS(1811),
    [sym_null] = ACTIONS(1811),
    [sym_undefined] = ACTIONS(1811),
    [anon_sym_AT] = ACTIONS(1809),
    [anon_sym_static] = ACTIONS(1811),
    [anon_sym_abstract] = ACTIONS(1811),
    [anon_sym_get] = ACTIONS(1811),
    [anon_sym_set] = ACTIONS(1811),
    [anon_sym_declare] = ACTIONS(1811),
    [anon_sym_public] = ACTIONS(1811),
    [anon_sym_private] = ACTIONS(1811),
    [anon_sym_protected] = ACTIONS(1811),
    [anon_sym_module] = ACTIONS(1811),
    [anon_sym_any] = ACTIONS(1811),
    [anon_sym_number] = ACTIONS(1811),
    [anon_sym_boolean] = ACTIONS(1811),
    [anon_sym_string] = ACTIONS(1811),
    [anon_sym_symbol] = ACTIONS(1811),
    [anon_sym_interface] = ACTIONS(1811),
    [anon_sym_enum] = ACTIONS(1811),
    [sym_readonly] = ACTIONS(1811),
  },
  [523] = {
    [sym_statement_block] = STATE(586),
    [ts_builtin_sym_end] = ACTIONS(933),
    [sym_identifier] = ACTIONS(935),
    [anon_sym_export] = ACTIONS(935),
    [anon_sym_default] = ACTIONS(935),
    [anon_sym_namespace] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(1796),
    [anon_sym_RBRACE] = ACTIONS(933),
    [anon_sym_type] = ACTIONS(935),
    [anon_sym_typeof] = ACTIONS(935),
    [anon_sym_import] = ACTIONS(935),
    [anon_sym_var] = ACTIONS(935),
    [anon_sym_let] = ACTIONS(935),
    [anon_sym_const] = ACTIONS(935),
    [anon_sym_BANG] = ACTIONS(933),
    [anon_sym_else] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_switch] = ACTIONS(935),
    [anon_sym_for] = ACTIONS(935),
    [anon_sym_LPAREN] = ACTIONS(933),
    [anon_sym_await] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_try] = ACTIONS(935),
    [anon_sym_with] = ACTIONS(935),
    [anon_sym_break] = ACTIONS(935),
    [anon_sym_continue] = ACTIONS(935),
    [anon_sym_debugger] = ACTIONS(935),
    [anon_sym_return] = ACTIONS(935),
    [anon_sym_throw] = ACTIONS(935),
    [anon_sym_SEMI] = ACTIONS(933),
    [anon_sym_case] = ACTIONS(935),
    [anon_sym_yield] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(933),
    [anon_sym_LT] = ACTIONS(933),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_class] = ACTIONS(935),
    [anon_sym_async] = ACTIONS(935),
    [anon_sym_function] = ACTIONS(935),
    [anon_sym_new] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_DASH] = ACTIONS(935),
    [anon_sym_TILDE] = ACTIONS(933),
    [anon_sym_void] = ACTIONS(935),
    [anon_sym_delete] = ACTIONS(935),
    [anon_sym_PLUS_PLUS] = ACTIONS(933),
    [anon_sym_DASH_DASH] = ACTIONS(933),
    [anon_sym_DQUOTE] = ACTIONS(933),
    [anon_sym_SQUOTE] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(933),
    [sym_number] = ACTIONS(933),
    [sym_this] = ACTIONS(935),
    [sym_super] = ACTIONS(935),
    [sym_true] = ACTIONS(935),
    [sym_false] = ACTIONS(935),
    [sym_null] = ACTIONS(935),
    [sym_undefined] = ACTIONS(935),
    [anon_sym_AT] = ACTIONS(933),
    [anon_sym_static] = ACTIONS(935),
    [anon_sym_abstract] = ACTIONS(935),
    [anon_sym_get] = ACTIONS(935),
    [anon_sym_set] = ACTIONS(935),
    [anon_sym_declare] = ACTIONS(935),
    [anon_sym_public] = ACTIONS(935),
    [anon_sym_private] = ACTIONS(935),
    [anon_sym_protected] = ACTIONS(935),
    [anon_sym_module] = ACTIONS(935),
    [anon_sym_any] = ACTIONS(935),
    [anon_sym_number] = ACTIONS(935),
    [anon_sym_boolean] = ACTIONS(935),
    [anon_sym_string] = ACTIONS(935),
    [anon_sym_symbol] = ACTIONS(935),
    [anon_sym_interface] = ACTIONS(935),
    [anon_sym_enum] = ACTIONS(935),
    [sym_readonly] = ACTIONS(935),
  },
  [524] = {
    [ts_builtin_sym_end] = ACTIONS(1003),
    [sym_identifier] = ACTIONS(1005),
    [anon_sym_export] = ACTIONS(1005),
    [anon_sym_default] = ACTIONS(1005),
    [anon_sym_namespace] = ACTIONS(1005),
    [anon_sym_LBRACE] = ACTIONS(1003),
    [anon_sym_RBRACE] = ACTIONS(1003),
    [anon_sym_type] = ACTIONS(1005),
    [anon_sym_typeof] = ACTIONS(1005),
    [anon_sym_import] = ACTIONS(1005),
    [anon_sym_var] = ACTIONS(1005),
    [anon_sym_let] = ACTIONS(1005),
    [anon_sym_const] = ACTIONS(1005),
    [anon_sym_BANG] = ACTIONS(1003),
    [anon_sym_else] = ACTIONS(1005),
    [anon_sym_if] = ACTIONS(1005),
    [anon_sym_switch] = ACTIONS(1005),
    [anon_sym_for] = ACTIONS(1005),
    [anon_sym_LPAREN] = ACTIONS(1003),
    [anon_sym_await] = ACTIONS(1005),
    [anon_sym_while] = ACTIONS(1005),
    [anon_sym_do] = ACTIONS(1005),
    [anon_sym_try] = ACTIONS(1005),
    [anon_sym_with] = ACTIONS(1005),
    [anon_sym_break] = ACTIONS(1005),
    [anon_sym_continue] = ACTIONS(1005),
    [anon_sym_debugger] = ACTIONS(1005),
    [anon_sym_return] = ACTIONS(1005),
    [anon_sym_throw] = ACTIONS(1005),
    [anon_sym_SEMI] = ACTIONS(1003),
    [anon_sym_case] = ACTIONS(1005),
    [anon_sym_yield] = ACTIONS(1005),
    [anon_sym_LBRACK] = ACTIONS(1003),
    [anon_sym_LT] = ACTIONS(1003),
    [anon_sym_SLASH] = ACTIONS(1005),
    [anon_sym_class] = ACTIONS(1005),
    [anon_sym_async] = ACTIONS(1005),
    [anon_sym_function] = ACTIONS(1005),
    [anon_sym_new] = ACTIONS(1005),
    [anon_sym_PLUS] = ACTIONS(1005),
    [anon_sym_DASH] = ACTIONS(1005),
    [anon_sym_TILDE] = ACTIONS(1003),
    [anon_sym_void] = ACTIONS(1005),
    [anon_sym_delete] = ACTIONS(1005),
    [anon_sym_PLUS_PLUS] = ACTIONS(1003),
    [anon_sym_DASH_DASH] = ACTIONS(1003),
    [anon_sym_DQUOTE] = ACTIONS(1003),
    [anon_sym_SQUOTE] = ACTIONS(1003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1003),
    [sym_number] = ACTIONS(1003),
    [sym_this] = ACTIONS(1005),
    [sym_super] = ACTIONS(1005),
    [sym_true] = ACTIONS(1005),
    [sym_false] = ACTIONS(1005),
    [sym_null] = ACTIONS(1005),
    [sym_undefined] = ACTIONS(1005),
    [anon_sym_AT] = ACTIONS(1003),
    [anon_sym_static] = ACTIONS(1005),
    [anon_sym_abstract] = ACTIONS(1005),
    [anon_sym_get] = ACTIONS(1005),
    [anon_sym_set] = ACTIONS(1005),
    [anon_sym_declare] = ACTIONS(1005),
    [anon_sym_public] = ACTIONS(1005),
    [anon_sym_private] = ACTIONS(1005),
    [anon_sym_protected] = ACTIONS(1005),
    [anon_sym_module] = ACTIONS(1005),
    [anon_sym_any] = ACTIONS(1005),
    [anon_sym_number] = ACTIONS(1005),
    [anon_sym_boolean] = ACTIONS(1005),
    [anon_sym_string] = ACTIONS(1005),
    [anon_sym_symbol] = ACTIONS(1005),
    [anon_sym_interface] = ACTIONS(1005),
    [anon_sym_enum] = ACTIONS(1005),
    [sym_readonly] = ACTIONS(1005),
    [sym__automatic_semicolon] = ACTIONS(1011),
  },
  [525] = {
    [ts_builtin_sym_end] = ACTIONS(1019),
    [sym_identifier] = ACTIONS(1021),
    [anon_sym_export] = ACTIONS(1021),
    [anon_sym_default] = ACTIONS(1021),
    [anon_sym_namespace] = ACTIONS(1021),
    [anon_sym_LBRACE] = ACTIONS(1019),
    [anon_sym_RBRACE] = ACTIONS(1019),
    [anon_sym_type] = ACTIONS(1021),
    [anon_sym_typeof] = ACTIONS(1021),
    [anon_sym_import] = ACTIONS(1021),
    [anon_sym_var] = ACTIONS(1021),
    [anon_sym_let] = ACTIONS(1021),
    [anon_sym_const] = ACTIONS(1021),
    [anon_sym_BANG] = ACTIONS(1019),
    [anon_sym_else] = ACTIONS(1021),
    [anon_sym_if] = ACTIONS(1021),
    [anon_sym_switch] = ACTIONS(1021),
    [anon_sym_for] = ACTIONS(1021),
    [anon_sym_LPAREN] = ACTIONS(1019),
    [anon_sym_await] = ACTIONS(1021),
    [anon_sym_while] = ACTIONS(1021),
    [anon_sym_do] = ACTIONS(1021),
    [anon_sym_try] = ACTIONS(1021),
    [anon_sym_with] = ACTIONS(1021),
    [anon_sym_break] = ACTIONS(1021),
    [anon_sym_continue] = ACTIONS(1021),
    [anon_sym_debugger] = ACTIONS(1021),
    [anon_sym_return] = ACTIONS(1021),
    [anon_sym_throw] = ACTIONS(1021),
    [anon_sym_SEMI] = ACTIONS(1019),
    [anon_sym_case] = ACTIONS(1021),
    [anon_sym_yield] = ACTIONS(1021),
    [anon_sym_LBRACK] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(1019),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_class] = ACTIONS(1021),
    [anon_sym_async] = ACTIONS(1021),
    [anon_sym_function] = ACTIONS(1021),
    [anon_sym_new] = ACTIONS(1021),
    [anon_sym_PLUS] = ACTIONS(1021),
    [anon_sym_DASH] = ACTIONS(1021),
    [anon_sym_TILDE] = ACTIONS(1019),
    [anon_sym_void] = ACTIONS(1021),
    [anon_sym_delete] = ACTIONS(1021),
    [anon_sym_PLUS_PLUS] = ACTIONS(1019),
    [anon_sym_DASH_DASH] = ACTIONS(1019),
    [anon_sym_DQUOTE] = ACTIONS(1019),
    [anon_sym_SQUOTE] = ACTIONS(1019),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1019),
    [sym_number] = ACTIONS(1019),
    [sym_this] = ACTIONS(1021),
    [sym_super] = ACTIONS(1021),
    [sym_true] = ACTIONS(1021),
    [sym_false] = ACTIONS(1021),
    [sym_null] = ACTIONS(1021),
    [sym_undefined] = ACTIONS(1021),
    [anon_sym_AT] = ACTIONS(1019),
    [anon_sym_static] = ACTIONS(1021),
    [anon_sym_abstract] = ACTIONS(1021),
    [anon_sym_get] = ACTIONS(1021),
    [anon_sym_set] = ACTIONS(1021),
    [anon_sym_declare] = ACTIONS(1021),
    [anon_sym_public] = ACTIONS(1021),
    [anon_sym_private] = ACTIONS(1021),
    [anon_sym_protected] = ACTIONS(1021),
    [anon_sym_module] = ACTIONS(1021),
    [anon_sym_any] = ACTIONS(1021),
    [anon_sym_number] = ACTIONS(1021),
    [anon_sym_boolean] = ACTIONS(1021),
    [anon_sym_string] = ACTIONS(1021),
    [anon_sym_symbol] = ACTIONS(1021),
    [anon_sym_interface] = ACTIONS(1021),
    [anon_sym_enum] = ACTIONS(1021),
    [sym_readonly] = ACTIONS(1021),
    [sym__automatic_semicolon] = ACTIONS(1027),
  },
  [526] = {
    [ts_builtin_sym_end] = ACTIONS(965),
    [sym_identifier] = ACTIONS(967),
    [anon_sym_export] = ACTIONS(967),
    [anon_sym_default] = ACTIONS(967),
    [anon_sym_namespace] = ACTIONS(967),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_RBRACE] = ACTIONS(965),
    [anon_sym_type] = ACTIONS(967),
    [anon_sym_typeof] = ACTIONS(967),
    [anon_sym_import] = ACTIONS(967),
    [anon_sym_var] = ACTIONS(967),
    [anon_sym_let] = ACTIONS(967),
    [anon_sym_const] = ACTIONS(967),
    [anon_sym_BANG] = ACTIONS(965),
    [anon_sym_else] = ACTIONS(967),
    [anon_sym_if] = ACTIONS(967),
    [anon_sym_switch] = ACTIONS(967),
    [anon_sym_for] = ACTIONS(967),
    [anon_sym_LPAREN] = ACTIONS(965),
    [anon_sym_await] = ACTIONS(967),
    [anon_sym_while] = ACTIONS(967),
    [anon_sym_do] = ACTIONS(967),
    [anon_sym_try] = ACTIONS(967),
    [anon_sym_with] = ACTIONS(967),
    [anon_sym_break] = ACTIONS(967),
    [anon_sym_continue] = ACTIONS(967),
    [anon_sym_debugger] = ACTIONS(967),
    [anon_sym_return] = ACTIONS(967),
    [anon_sym_throw] = ACTIONS(967),
    [anon_sym_SEMI] = ACTIONS(965),
    [anon_sym_case] = ACTIONS(967),
    [anon_sym_yield] = ACTIONS(967),
    [anon_sym_LBRACK] = ACTIONS(965),
    [anon_sym_LT] = ACTIONS(965),
    [anon_sym_SLASH] = ACTIONS(967),
    [anon_sym_class] = ACTIONS(967),
    [anon_sym_async] = ACTIONS(967),
    [anon_sym_function] = ACTIONS(967),
    [anon_sym_new] = ACTIONS(967),
    [anon_sym_PLUS] = ACTIONS(967),
    [anon_sym_DASH] = ACTIONS(967),
    [anon_sym_TILDE] = ACTIONS(965),
    [anon_sym_void] = ACTIONS(967),
    [anon_sym_delete] = ACTIONS(967),
    [anon_sym_PLUS_PLUS] = ACTIONS(965),
    [anon_sym_DASH_DASH] = ACTIONS(965),
    [anon_sym_DQUOTE] = ACTIONS(965),
    [anon_sym_SQUOTE] = ACTIONS(965),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(965),
    [sym_number] = ACTIONS(965),
    [sym_this] = ACTIONS(967),
    [sym_super] = ACTIONS(967),
    [sym_true] = ACTIONS(967),
    [sym_false] = ACTIONS(967),
    [sym_null] = ACTIONS(967),
    [sym_undefined] = ACTIONS(967),
    [anon_sym_AT] = ACTIONS(965),
    [anon_sym_static] = ACTIONS(967),
    [anon_sym_abstract] = ACTIONS(967),
    [anon_sym_get] = ACTIONS(967),
    [anon_sym_set] = ACTIONS(967),
    [anon_sym_declare] = ACTIONS(967),
    [anon_sym_public] = ACTIONS(967),
    [anon_sym_private] = ACTIONS(967),
    [anon_sym_protected] = ACTIONS(967),
    [anon_sym_module] = ACTIONS(967),
    [anon_sym_any] = ACTIONS(967),
    [anon_sym_number] = ACTIONS(967),
    [anon_sym_boolean] = ACTIONS(967),
    [anon_sym_string] = ACTIONS(967),
    [anon_sym_symbol] = ACTIONS(967),
    [anon_sym_interface] = ACTIONS(967),
    [anon_sym_enum] = ACTIONS(967),
    [sym_readonly] = ACTIONS(967),
    [sym__automatic_semicolon] = ACTIONS(973),
  },
  [527] = {
    [ts_builtin_sym_end] = ACTIONS(1053),
    [sym_identifier] = ACTIONS(1055),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_default] = ACTIONS(1055),
    [anon_sym_namespace] = ACTIONS(1055),
    [anon_sym_LBRACE] = ACTIONS(1053),
    [anon_sym_RBRACE] = ACTIONS(1053),
    [anon_sym_type] = ACTIONS(1055),
    [anon_sym_typeof] = ACTIONS(1055),
    [anon_sym_import] = ACTIONS(1055),
    [anon_sym_var] = ACTIONS(1055),
    [anon_sym_let] = ACTIONS(1055),
    [anon_sym_const] = ACTIONS(1055),
    [anon_sym_BANG] = ACTIONS(1053),
    [anon_sym_else] = ACTIONS(1055),
    [anon_sym_if] = ACTIONS(1055),
    [anon_sym_switch] = ACTIONS(1055),
    [anon_sym_for] = ACTIONS(1055),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_await] = ACTIONS(1055),
    [anon_sym_while] = ACTIONS(1055),
    [anon_sym_do] = ACTIONS(1055),
    [anon_sym_try] = ACTIONS(1055),
    [anon_sym_with] = ACTIONS(1055),
    [anon_sym_break] = ACTIONS(1055),
    [anon_sym_continue] = ACTIONS(1055),
    [anon_sym_debugger] = ACTIONS(1055),
    [anon_sym_return] = ACTIONS(1055),
    [anon_sym_throw] = ACTIONS(1055),
    [anon_sym_SEMI] = ACTIONS(1053),
    [anon_sym_case] = ACTIONS(1055),
    [anon_sym_yield] = ACTIONS(1055),
    [anon_sym_LBRACK] = ACTIONS(1053),
    [anon_sym_LT] = ACTIONS(1053),
    [anon_sym_SLASH] = ACTIONS(1055),
    [anon_sym_class] = ACTIONS(1055),
    [anon_sym_async] = ACTIONS(1055),
    [anon_sym_function] = ACTIONS(1055),
    [anon_sym_new] = ACTIONS(1055),
    [anon_sym_PLUS] = ACTIONS(1055),
    [anon_sym_DASH] = ACTIONS(1055),
    [anon_sym_TILDE] = ACTIONS(1053),
    [anon_sym_void] = ACTIONS(1055),
    [anon_sym_delete] = ACTIONS(1055),
    [anon_sym_PLUS_PLUS] = ACTIONS(1053),
    [anon_sym_DASH_DASH] = ACTIONS(1053),
    [anon_sym_DQUOTE] = ACTIONS(1053),
    [anon_sym_SQUOTE] = ACTIONS(1053),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1053),
    [sym_number] = ACTIONS(1053),
    [sym_this] = ACTIONS(1055),
    [sym_super] = ACTIONS(1055),
    [sym_true] = ACTIONS(1055),
    [sym_false] = ACTIONS(1055),
    [sym_null] = ACTIONS(1055),
    [sym_undefined] = ACTIONS(1055),
    [anon_sym_AT] = ACTIONS(1053),
    [anon_sym_static] = ACTIONS(1055),
    [anon_sym_abstract] = ACTIONS(1055),
    [anon_sym_get] = ACTIONS(1055),
    [anon_sym_set] = ACTIONS(1055),
    [anon_sym_declare] = ACTIONS(1055),
    [anon_sym_public] = ACTIONS(1055),
    [anon_sym_private] = ACTIONS(1055),
    [anon_sym_protected] = ACTIONS(1055),
    [anon_sym_module] = ACTIONS(1055),
    [anon_sym_any] = ACTIONS(1055),
    [anon_sym_number] = ACTIONS(1055),
    [anon_sym_boolean] = ACTIONS(1055),
    [anon_sym_string] = ACTIONS(1055),
    [anon_sym_symbol] = ACTIONS(1055),
    [anon_sym_interface] = ACTIONS(1055),
    [anon_sym_enum] = ACTIONS(1055),
    [sym_readonly] = ACTIONS(1055),
    [sym__automatic_semicolon] = ACTIONS(1061),
  },
  [528] = {
    [ts_builtin_sym_end] = ACTIONS(951),
    [sym_identifier] = ACTIONS(953),
    [anon_sym_export] = ACTIONS(953),
    [anon_sym_default] = ACTIONS(953),
    [anon_sym_namespace] = ACTIONS(953),
    [anon_sym_LBRACE] = ACTIONS(951),
    [anon_sym_RBRACE] = ACTIONS(951),
    [anon_sym_type] = ACTIONS(953),
    [anon_sym_typeof] = ACTIONS(953),
    [anon_sym_import] = ACTIONS(953),
    [anon_sym_var] = ACTIONS(953),
    [anon_sym_let] = ACTIONS(953),
    [anon_sym_const] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(951),
    [anon_sym_else] = ACTIONS(953),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_switch] = ACTIONS(953),
    [anon_sym_for] = ACTIONS(953),
    [anon_sym_LPAREN] = ACTIONS(951),
    [anon_sym_await] = ACTIONS(953),
    [anon_sym_while] = ACTIONS(953),
    [anon_sym_do] = ACTIONS(953),
    [anon_sym_try] = ACTIONS(953),
    [anon_sym_with] = ACTIONS(953),
    [anon_sym_break] = ACTIONS(953),
    [anon_sym_continue] = ACTIONS(953),
    [anon_sym_debugger] = ACTIONS(953),
    [anon_sym_return] = ACTIONS(953),
    [anon_sym_throw] = ACTIONS(953),
    [anon_sym_SEMI] = ACTIONS(951),
    [anon_sym_case] = ACTIONS(953),
    [anon_sym_yield] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(951),
    [anon_sym_LT] = ACTIONS(951),
    [anon_sym_SLASH] = ACTIONS(953),
    [anon_sym_class] = ACTIONS(953),
    [anon_sym_async] = ACTIONS(953),
    [anon_sym_function] = ACTIONS(953),
    [anon_sym_new] = ACTIONS(953),
    [anon_sym_PLUS] = ACTIONS(953),
    [anon_sym_DASH] = ACTIONS(953),
    [anon_sym_TILDE] = ACTIONS(951),
    [anon_sym_void] = ACTIONS(953),
    [anon_sym_delete] = ACTIONS(953),
    [anon_sym_PLUS_PLUS] = ACTIONS(951),
    [anon_sym_DASH_DASH] = ACTIONS(951),
    [anon_sym_DQUOTE] = ACTIONS(951),
    [anon_sym_SQUOTE] = ACTIONS(951),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(951),
    [sym_number] = ACTIONS(951),
    [sym_this] = ACTIONS(953),
    [sym_super] = ACTIONS(953),
    [sym_true] = ACTIONS(953),
    [sym_false] = ACTIONS(953),
    [sym_null] = ACTIONS(953),
    [sym_undefined] = ACTIONS(953),
    [anon_sym_AT] = ACTIONS(951),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_abstract] = ACTIONS(953),
    [anon_sym_get] = ACTIONS(953),
    [anon_sym_set] = ACTIONS(953),
    [anon_sym_declare] = ACTIONS(953),
    [anon_sym_public] = ACTIONS(953),
    [anon_sym_private] = ACTIONS(953),
    [anon_sym_protected] = ACTIONS(953),
    [anon_sym_module] = ACTIONS(953),
    [anon_sym_any] = ACTIONS(953),
    [anon_sym_number] = ACTIONS(953),
    [anon_sym_boolean] = ACTIONS(953),
    [anon_sym_string] = ACTIONS(953),
    [anon_sym_symbol] = ACTIONS(953),
    [anon_sym_interface] = ACTIONS(953),
    [anon_sym_enum] = ACTIONS(953),
    [sym_readonly] = ACTIONS(953),
    [sym__automatic_semicolon] = ACTIONS(959),
  },
  [529] = {
    [ts_builtin_sym_end] = ACTIONS(983),
    [sym_identifier] = ACTIONS(985),
    [anon_sym_export] = ACTIONS(985),
    [anon_sym_default] = ACTIONS(985),
    [anon_sym_namespace] = ACTIONS(985),
    [anon_sym_LBRACE] = ACTIONS(983),
    [anon_sym_RBRACE] = ACTIONS(983),
    [anon_sym_type] = ACTIONS(985),
    [anon_sym_typeof] = ACTIONS(985),
    [anon_sym_import] = ACTIONS(985),
    [anon_sym_var] = ACTIONS(985),
    [anon_sym_let] = ACTIONS(985),
    [anon_sym_const] = ACTIONS(985),
    [anon_sym_BANG] = ACTIONS(983),
    [anon_sym_else] = ACTIONS(985),
    [anon_sym_if] = ACTIONS(985),
    [anon_sym_switch] = ACTIONS(985),
    [anon_sym_for] = ACTIONS(985),
    [anon_sym_LPAREN] = ACTIONS(983),
    [anon_sym_await] = ACTIONS(985),
    [anon_sym_while] = ACTIONS(985),
    [anon_sym_do] = ACTIONS(985),
    [anon_sym_try] = ACTIONS(985),
    [anon_sym_with] = ACTIONS(985),
    [anon_sym_break] = ACTIONS(985),
    [anon_sym_continue] = ACTIONS(985),
    [anon_sym_debugger] = ACTIONS(985),
    [anon_sym_return] = ACTIONS(985),
    [anon_sym_throw] = ACTIONS(985),
    [anon_sym_SEMI] = ACTIONS(983),
    [anon_sym_case] = ACTIONS(985),
    [anon_sym_yield] = ACTIONS(985),
    [anon_sym_LBRACK] = ACTIONS(983),
    [anon_sym_LT] = ACTIONS(983),
    [anon_sym_SLASH] = ACTIONS(985),
    [anon_sym_class] = ACTIONS(985),
    [anon_sym_async] = ACTIONS(985),
    [anon_sym_function] = ACTIONS(985),
    [anon_sym_new] = ACTIONS(985),
    [anon_sym_PLUS] = ACTIONS(985),
    [anon_sym_DASH] = ACTIONS(985),
    [anon_sym_TILDE] = ACTIONS(983),
    [anon_sym_void] = ACTIONS(985),
    [anon_sym_delete] = ACTIONS(985),
    [anon_sym_PLUS_PLUS] = ACTIONS(983),
    [anon_sym_DASH_DASH] = ACTIONS(983),
    [anon_sym_DQUOTE] = ACTIONS(983),
    [anon_sym_SQUOTE] = ACTIONS(983),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(983),
    [sym_number] = ACTIONS(983),
    [sym_this] = ACTIONS(985),
    [sym_super] = ACTIONS(985),
    [sym_true] = ACTIONS(985),
    [sym_false] = ACTIONS(985),
    [sym_null] = ACTIONS(985),
    [sym_undefined] = ACTIONS(985),
    [anon_sym_AT] = ACTIONS(983),
    [anon_sym_static] = ACTIONS(985),
    [anon_sym_abstract] = ACTIONS(985),
    [anon_sym_get] = ACTIONS(985),
    [anon_sym_set] = ACTIONS(985),
    [anon_sym_declare] = ACTIONS(985),
    [anon_sym_public] = ACTIONS(985),
    [anon_sym_private] = ACTIONS(985),
    [anon_sym_protected] = ACTIONS(985),
    [anon_sym_module] = ACTIONS(985),
    [anon_sym_any] = ACTIONS(985),
    [anon_sym_number] = ACTIONS(985),
    [anon_sym_boolean] = ACTIONS(985),
    [anon_sym_string] = ACTIONS(985),
    [anon_sym_symbol] = ACTIONS(985),
    [anon_sym_interface] = ACTIONS(985),
    [anon_sym_enum] = ACTIONS(985),
    [sym_readonly] = ACTIONS(985),
    [sym__automatic_semicolon] = ACTIONS(991),
  },
  [530] = {
    [ts_builtin_sym_end] = ACTIONS(1813),
    [sym_identifier] = ACTIONS(1815),
    [anon_sym_export] = ACTIONS(1815),
    [anon_sym_default] = ACTIONS(1815),
    [anon_sym_namespace] = ACTIONS(1815),
    [anon_sym_LBRACE] = ACTIONS(1813),
    [anon_sym_RBRACE] = ACTIONS(1813),
    [anon_sym_type] = ACTIONS(1815),
    [anon_sym_typeof] = ACTIONS(1815),
    [anon_sym_import] = ACTIONS(1815),
    [anon_sym_var] = ACTIONS(1815),
    [anon_sym_let] = ACTIONS(1815),
    [anon_sym_const] = ACTIONS(1815),
    [anon_sym_BANG] = ACTIONS(1813),
    [anon_sym_else] = ACTIONS(1815),
    [anon_sym_if] = ACTIONS(1815),
    [anon_sym_switch] = ACTIONS(1815),
    [anon_sym_for] = ACTIONS(1815),
    [anon_sym_LPAREN] = ACTIONS(1813),
    [anon_sym_RPAREN] = ACTIONS(1813),
    [anon_sym_await] = ACTIONS(1815),
    [anon_sym_while] = ACTIONS(1815),
    [anon_sym_do] = ACTIONS(1815),
    [anon_sym_try] = ACTIONS(1815),
    [anon_sym_with] = ACTIONS(1815),
    [anon_sym_break] = ACTIONS(1815),
    [anon_sym_continue] = ACTIONS(1815),
    [anon_sym_debugger] = ACTIONS(1815),
    [anon_sym_return] = ACTIONS(1815),
    [anon_sym_throw] = ACTIONS(1815),
    [anon_sym_SEMI] = ACTIONS(1813),
    [anon_sym_case] = ACTIONS(1815),
    [anon_sym_yield] = ACTIONS(1815),
    [anon_sym_LBRACK] = ACTIONS(1813),
    [anon_sym_LT] = ACTIONS(1813),
    [anon_sym_SLASH] = ACTIONS(1815),
    [anon_sym_class] = ACTIONS(1815),
    [anon_sym_async] = ACTIONS(1815),
    [anon_sym_function] = ACTIONS(1815),
    [anon_sym_new] = ACTIONS(1815),
    [anon_sym_PLUS] = ACTIONS(1815),
    [anon_sym_DASH] = ACTIONS(1815),
    [anon_sym_TILDE] = ACTIONS(1813),
    [anon_sym_void] = ACTIONS(1815),
    [anon_sym_delete] = ACTIONS(1815),
    [anon_sym_PLUS_PLUS] = ACTIONS(1813),
    [anon_sym_DASH_DASH] = ACTIONS(1813),
    [anon_sym_DQUOTE] = ACTIONS(1813),
    [anon_sym_SQUOTE] = ACTIONS(1813),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1813),
    [sym_number] = ACTIONS(1813),
    [sym_this] = ACTIONS(1815),
    [sym_super] = ACTIONS(1815),
    [sym_true] = ACTIONS(1815),
    [sym_false] = ACTIONS(1815),
    [sym_null] = ACTIONS(1815),
    [sym_undefined] = ACTIONS(1815),
    [anon_sym_AT] = ACTIONS(1813),
    [anon_sym_static] = ACTIONS(1815),
    [anon_sym_abstract] = ACTIONS(1815),
    [anon_sym_get] = ACTIONS(1815),
    [anon_sym_set] = ACTIONS(1815),
    [anon_sym_declare] = ACTIONS(1815),
    [anon_sym_public] = ACTIONS(1815),
    [anon_sym_private] = ACTIONS(1815),
    [anon_sym_protected] = ACTIONS(1815),
    [anon_sym_module] = ACTIONS(1815),
    [anon_sym_any] = ACTIONS(1815),
    [anon_sym_number] = ACTIONS(1815),
    [anon_sym_boolean] = ACTIONS(1815),
    [anon_sym_string] = ACTIONS(1815),
    [anon_sym_symbol] = ACTIONS(1815),
    [anon_sym_interface] = ACTIONS(1815),
    [anon_sym_enum] = ACTIONS(1815),
    [sym_readonly] = ACTIONS(1815),
  },
  [531] = {
    [ts_builtin_sym_end] = ACTIONS(993),
    [sym_identifier] = ACTIONS(995),
    [anon_sym_export] = ACTIONS(995),
    [anon_sym_default] = ACTIONS(995),
    [anon_sym_namespace] = ACTIONS(995),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_RBRACE] = ACTIONS(993),
    [anon_sym_type] = ACTIONS(995),
    [anon_sym_typeof] = ACTIONS(995),
    [anon_sym_import] = ACTIONS(995),
    [anon_sym_var] = ACTIONS(995),
    [anon_sym_let] = ACTIONS(995),
    [anon_sym_const] = ACTIONS(995),
    [anon_sym_BANG] = ACTIONS(993),
    [anon_sym_else] = ACTIONS(995),
    [anon_sym_if] = ACTIONS(995),
    [anon_sym_switch] = ACTIONS(995),
    [anon_sym_for] = ACTIONS(995),
    [anon_sym_LPAREN] = ACTIONS(993),
    [anon_sym_await] = ACTIONS(995),
    [anon_sym_while] = ACTIONS(995),
    [anon_sym_do] = ACTIONS(995),
    [anon_sym_try] = ACTIONS(995),
    [anon_sym_with] = ACTIONS(995),
    [anon_sym_break] = ACTIONS(995),
    [anon_sym_continue] = ACTIONS(995),
    [anon_sym_debugger] = ACTIONS(995),
    [anon_sym_return] = ACTIONS(995),
    [anon_sym_throw] = ACTIONS(995),
    [anon_sym_SEMI] = ACTIONS(993),
    [anon_sym_case] = ACTIONS(995),
    [anon_sym_yield] = ACTIONS(995),
    [anon_sym_LBRACK] = ACTIONS(993),
    [anon_sym_LT] = ACTIONS(993),
    [anon_sym_SLASH] = ACTIONS(995),
    [anon_sym_class] = ACTIONS(995),
    [anon_sym_async] = ACTIONS(995),
    [anon_sym_function] = ACTIONS(995),
    [anon_sym_new] = ACTIONS(995),
    [anon_sym_PLUS] = ACTIONS(995),
    [anon_sym_DASH] = ACTIONS(995),
    [anon_sym_TILDE] = ACTIONS(993),
    [anon_sym_void] = ACTIONS(995),
    [anon_sym_delete] = ACTIONS(995),
    [anon_sym_PLUS_PLUS] = ACTIONS(993),
    [anon_sym_DASH_DASH] = ACTIONS(993),
    [anon_sym_DQUOTE] = ACTIONS(993),
    [anon_sym_SQUOTE] = ACTIONS(993),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(993),
    [sym_number] = ACTIONS(993),
    [sym_this] = ACTIONS(995),
    [sym_super] = ACTIONS(995),
    [sym_true] = ACTIONS(995),
    [sym_false] = ACTIONS(995),
    [sym_null] = ACTIONS(995),
    [sym_undefined] = ACTIONS(995),
    [anon_sym_AT] = ACTIONS(993),
    [anon_sym_static] = ACTIONS(995),
    [anon_sym_abstract] = ACTIONS(995),
    [anon_sym_get] = ACTIONS(995),
    [anon_sym_set] = ACTIONS(995),
    [anon_sym_declare] = ACTIONS(995),
    [anon_sym_public] = ACTIONS(995),
    [anon_sym_private] = ACTIONS(995),
    [anon_sym_protected] = ACTIONS(995),
    [anon_sym_module] = ACTIONS(995),
    [anon_sym_any] = ACTIONS(995),
    [anon_sym_number] = ACTIONS(995),
    [anon_sym_boolean] = ACTIONS(995),
    [anon_sym_string] = ACTIONS(995),
    [anon_sym_symbol] = ACTIONS(995),
    [anon_sym_interface] = ACTIONS(995),
    [anon_sym_enum] = ACTIONS(995),
    [sym_readonly] = ACTIONS(995),
    [sym__automatic_semicolon] = ACTIONS(1001),
  },
  [532] = {
    [ts_builtin_sym_end] = ACTIONS(1039),
    [sym_identifier] = ACTIONS(1041),
    [anon_sym_export] = ACTIONS(1041),
    [anon_sym_default] = ACTIONS(1041),
    [anon_sym_namespace] = ACTIONS(1041),
    [anon_sym_LBRACE] = ACTIONS(1039),
    [anon_sym_RBRACE] = ACTIONS(1039),
    [anon_sym_type] = ACTIONS(1041),
    [anon_sym_typeof] = ACTIONS(1041),
    [anon_sym_import] = ACTIONS(1041),
    [anon_sym_var] = ACTIONS(1041),
    [anon_sym_let] = ACTIONS(1041),
    [anon_sym_const] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(1039),
    [anon_sym_else] = ACTIONS(1041),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_switch] = ACTIONS(1041),
    [anon_sym_for] = ACTIONS(1041),
    [anon_sym_LPAREN] = ACTIONS(1039),
    [anon_sym_await] = ACTIONS(1041),
    [anon_sym_while] = ACTIONS(1041),
    [anon_sym_do] = ACTIONS(1041),
    [anon_sym_try] = ACTIONS(1041),
    [anon_sym_with] = ACTIONS(1041),
    [anon_sym_break] = ACTIONS(1041),
    [anon_sym_continue] = ACTIONS(1041),
    [anon_sym_debugger] = ACTIONS(1041),
    [anon_sym_return] = ACTIONS(1041),
    [anon_sym_throw] = ACTIONS(1041),
    [anon_sym_SEMI] = ACTIONS(1039),
    [anon_sym_case] = ACTIONS(1041),
    [anon_sym_yield] = ACTIONS(1041),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_LT] = ACTIONS(1039),
    [anon_sym_SLASH] = ACTIONS(1041),
    [anon_sym_class] = ACTIONS(1041),
    [anon_sym_async] = ACTIONS(1041),
    [anon_sym_function] = ACTIONS(1041),
    [anon_sym_new] = ACTIONS(1041),
    [anon_sym_PLUS] = ACTIONS(1041),
    [anon_sym_DASH] = ACTIONS(1041),
    [anon_sym_TILDE] = ACTIONS(1039),
    [anon_sym_void] = ACTIONS(1041),
    [anon_sym_delete] = ACTIONS(1041),
    [anon_sym_PLUS_PLUS] = ACTIONS(1039),
    [anon_sym_DASH_DASH] = ACTIONS(1039),
    [anon_sym_DQUOTE] = ACTIONS(1039),
    [anon_sym_SQUOTE] = ACTIONS(1039),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1039),
    [sym_number] = ACTIONS(1039),
    [sym_this] = ACTIONS(1041),
    [sym_super] = ACTIONS(1041),
    [sym_true] = ACTIONS(1041),
    [sym_false] = ACTIONS(1041),
    [sym_null] = ACTIONS(1041),
    [sym_undefined] = ACTIONS(1041),
    [anon_sym_AT] = ACTIONS(1039),
    [anon_sym_static] = ACTIONS(1041),
    [anon_sym_abstract] = ACTIONS(1041),
    [anon_sym_get] = ACTIONS(1041),
    [anon_sym_set] = ACTIONS(1041),
    [anon_sym_declare] = ACTIONS(1041),
    [anon_sym_public] = ACTIONS(1041),
    [anon_sym_private] = ACTIONS(1041),
    [anon_sym_protected] = ACTIONS(1041),
    [anon_sym_module] = ACTIONS(1041),
    [anon_sym_any] = ACTIONS(1041),
    [anon_sym_number] = ACTIONS(1041),
    [anon_sym_boolean] = ACTIONS(1041),
    [anon_sym_string] = ACTIONS(1041),
    [anon_sym_symbol] = ACTIONS(1041),
    [anon_sym_interface] = ACTIONS(1041),
    [anon_sym_enum] = ACTIONS(1041),
    [sym_readonly] = ACTIONS(1041),
    [sym__automatic_semicolon] = ACTIONS(1047),
  },
  [533] = {
    [ts_builtin_sym_end] = ACTIONS(1029),
    [sym_identifier] = ACTIONS(1031),
    [anon_sym_export] = ACTIONS(1031),
    [anon_sym_default] = ACTIONS(1031),
    [anon_sym_namespace] = ACTIONS(1031),
    [anon_sym_LBRACE] = ACTIONS(1029),
    [anon_sym_RBRACE] = ACTIONS(1029),
    [anon_sym_type] = ACTIONS(1031),
    [anon_sym_typeof] = ACTIONS(1031),
    [anon_sym_import] = ACTIONS(1031),
    [anon_sym_var] = ACTIONS(1031),
    [anon_sym_let] = ACTIONS(1031),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_BANG] = ACTIONS(1029),
    [anon_sym_else] = ACTIONS(1031),
    [anon_sym_if] = ACTIONS(1031),
    [anon_sym_switch] = ACTIONS(1031),
    [anon_sym_for] = ACTIONS(1031),
    [anon_sym_LPAREN] = ACTIONS(1029),
    [anon_sym_await] = ACTIONS(1031),
    [anon_sym_while] = ACTIONS(1031),
    [anon_sym_do] = ACTIONS(1031),
    [anon_sym_try] = ACTIONS(1031),
    [anon_sym_with] = ACTIONS(1031),
    [anon_sym_break] = ACTIONS(1031),
    [anon_sym_continue] = ACTIONS(1031),
    [anon_sym_debugger] = ACTIONS(1031),
    [anon_sym_return] = ACTIONS(1031),
    [anon_sym_throw] = ACTIONS(1031),
    [anon_sym_SEMI] = ACTIONS(1029),
    [anon_sym_case] = ACTIONS(1031),
    [anon_sym_yield] = ACTIONS(1031),
    [anon_sym_LBRACK] = ACTIONS(1029),
    [anon_sym_LT] = ACTIONS(1029),
    [anon_sym_SLASH] = ACTIONS(1031),
    [anon_sym_class] = ACTIONS(1031),
    [anon_sym_async] = ACTIONS(1031),
    [anon_sym_function] = ACTIONS(1031),
    [anon_sym_new] = ACTIONS(1031),
    [anon_sym_PLUS] = ACTIONS(1031),
    [anon_sym_DASH] = ACTIONS(1031),
    [anon_sym_TILDE] = ACTIONS(1029),
    [anon_sym_void] = ACTIONS(1031),
    [anon_sym_delete] = ACTIONS(1031),
    [anon_sym_PLUS_PLUS] = ACTIONS(1029),
    [anon_sym_DASH_DASH] = ACTIONS(1029),
    [anon_sym_DQUOTE] = ACTIONS(1029),
    [anon_sym_SQUOTE] = ACTIONS(1029),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1029),
    [sym_number] = ACTIONS(1029),
    [sym_this] = ACTIONS(1031),
    [sym_super] = ACTIONS(1031),
    [sym_true] = ACTIONS(1031),
    [sym_false] = ACTIONS(1031),
    [sym_null] = ACTIONS(1031),
    [sym_undefined] = ACTIONS(1031),
    [anon_sym_AT] = ACTIONS(1029),
    [anon_sym_static] = ACTIONS(1031),
    [anon_sym_abstract] = ACTIONS(1031),
    [anon_sym_get] = ACTIONS(1031),
    [anon_sym_set] = ACTIONS(1031),
    [anon_sym_declare] = ACTIONS(1031),
    [anon_sym_public] = ACTIONS(1031),
    [anon_sym_private] = ACTIONS(1031),
    [anon_sym_protected] = ACTIONS(1031),
    [anon_sym_module] = ACTIONS(1031),
    [anon_sym_any] = ACTIONS(1031),
    [anon_sym_number] = ACTIONS(1031),
    [anon_sym_boolean] = ACTIONS(1031),
    [anon_sym_string] = ACTIONS(1031),
    [anon_sym_symbol] = ACTIONS(1031),
    [anon_sym_interface] = ACTIONS(1031),
    [anon_sym_enum] = ACTIONS(1031),
    [sym_readonly] = ACTIONS(1031),
    [sym__automatic_semicolon] = ACTIONS(1037),
  },
  [534] = {
    [ts_builtin_sym_end] = ACTIONS(1817),
    [sym_identifier] = ACTIONS(1819),
    [anon_sym_export] = ACTIONS(1819),
    [anon_sym_default] = ACTIONS(1819),
    [anon_sym_namespace] = ACTIONS(1819),
    [anon_sym_LBRACE] = ACTIONS(1817),
    [anon_sym_RBRACE] = ACTIONS(1817),
    [anon_sym_type] = ACTIONS(1819),
    [anon_sym_typeof] = ACTIONS(1819),
    [anon_sym_import] = ACTIONS(1819),
    [anon_sym_var] = ACTIONS(1819),
    [anon_sym_let] = ACTIONS(1819),
    [anon_sym_const] = ACTIONS(1819),
    [anon_sym_BANG] = ACTIONS(1817),
    [anon_sym_else] = ACTIONS(1819),
    [anon_sym_if] = ACTIONS(1819),
    [anon_sym_switch] = ACTIONS(1819),
    [anon_sym_for] = ACTIONS(1819),
    [anon_sym_LPAREN] = ACTIONS(1817),
    [anon_sym_await] = ACTIONS(1819),
    [anon_sym_while] = ACTIONS(1819),
    [anon_sym_do] = ACTIONS(1819),
    [anon_sym_try] = ACTIONS(1819),
    [anon_sym_with] = ACTIONS(1819),
    [anon_sym_break] = ACTIONS(1819),
    [anon_sym_continue] = ACTIONS(1819),
    [anon_sym_debugger] = ACTIONS(1819),
    [anon_sym_return] = ACTIONS(1819),
    [anon_sym_throw] = ACTIONS(1819),
    [anon_sym_SEMI] = ACTIONS(1817),
    [anon_sym_case] = ACTIONS(1819),
    [anon_sym_finally] = ACTIONS(1819),
    [anon_sym_yield] = ACTIONS(1819),
    [anon_sym_LBRACK] = ACTIONS(1817),
    [anon_sym_LT] = ACTIONS(1817),
    [anon_sym_SLASH] = ACTIONS(1819),
    [anon_sym_class] = ACTIONS(1819),
    [anon_sym_async] = ACTIONS(1819),
    [anon_sym_function] = ACTIONS(1819),
    [anon_sym_new] = ACTIONS(1819),
    [anon_sym_PLUS] = ACTIONS(1819),
    [anon_sym_DASH] = ACTIONS(1819),
    [anon_sym_TILDE] = ACTIONS(1817),
    [anon_sym_void] = ACTIONS(1819),
    [anon_sym_delete] = ACTIONS(1819),
    [anon_sym_PLUS_PLUS] = ACTIONS(1817),
    [anon_sym_DASH_DASH] = ACTIONS(1817),
    [anon_sym_DQUOTE] = ACTIONS(1817),
    [anon_sym_SQUOTE] = ACTIONS(1817),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1817),
    [sym_number] = ACTIONS(1817),
    [sym_this] = ACTIONS(1819),
    [sym_super] = ACTIONS(1819),
    [sym_true] = ACTIONS(1819),
    [sym_false] = ACTIONS(1819),
    [sym_null] = ACTIONS(1819),
    [sym_undefined] = ACTIONS(1819),
    [anon_sym_AT] = ACTIONS(1817),
    [anon_sym_static] = ACTIONS(1819),
    [anon_sym_abstract] = ACTIONS(1819),
    [anon_sym_get] = ACTIONS(1819),
    [anon_sym_set] = ACTIONS(1819),
    [anon_sym_declare] = ACTIONS(1819),
    [anon_sym_public] = ACTIONS(1819),
    [anon_sym_private] = ACTIONS(1819),
    [anon_sym_protected] = ACTIONS(1819),
    [anon_sym_module] = ACTIONS(1819),
    [anon_sym_any] = ACTIONS(1819),
    [anon_sym_number] = ACTIONS(1819),
    [anon_sym_boolean] = ACTIONS(1819),
    [anon_sym_string] = ACTIONS(1819),
    [anon_sym_symbol] = ACTIONS(1819),
    [anon_sym_interface] = ACTIONS(1819),
    [anon_sym_enum] = ACTIONS(1819),
    [sym_readonly] = ACTIONS(1819),
  },
  [535] = {
    [ts_builtin_sym_end] = ACTIONS(1821),
    [sym_identifier] = ACTIONS(1823),
    [anon_sym_export] = ACTIONS(1823),
    [anon_sym_default] = ACTIONS(1823),
    [anon_sym_namespace] = ACTIONS(1823),
    [anon_sym_LBRACE] = ACTIONS(1821),
    [anon_sym_RBRACE] = ACTIONS(1821),
    [anon_sym_type] = ACTIONS(1823),
    [anon_sym_typeof] = ACTIONS(1823),
    [anon_sym_import] = ACTIONS(1823),
    [anon_sym_var] = ACTIONS(1823),
    [anon_sym_let] = ACTIONS(1823),
    [anon_sym_const] = ACTIONS(1823),
    [anon_sym_BANG] = ACTIONS(1821),
    [anon_sym_else] = ACTIONS(1823),
    [anon_sym_if] = ACTIONS(1823),
    [anon_sym_switch] = ACTIONS(1823),
    [anon_sym_for] = ACTIONS(1823),
    [anon_sym_LPAREN] = ACTIONS(1821),
    [anon_sym_await] = ACTIONS(1823),
    [anon_sym_while] = ACTIONS(1823),
    [anon_sym_do] = ACTIONS(1823),
    [anon_sym_try] = ACTIONS(1823),
    [anon_sym_with] = ACTIONS(1823),
    [anon_sym_break] = ACTIONS(1823),
    [anon_sym_continue] = ACTIONS(1823),
    [anon_sym_debugger] = ACTIONS(1823),
    [anon_sym_return] = ACTIONS(1823),
    [anon_sym_throw] = ACTIONS(1823),
    [anon_sym_SEMI] = ACTIONS(1821),
    [anon_sym_case] = ACTIONS(1823),
    [anon_sym_finally] = ACTIONS(1823),
    [anon_sym_yield] = ACTIONS(1823),
    [anon_sym_LBRACK] = ACTIONS(1821),
    [anon_sym_LT] = ACTIONS(1821),
    [anon_sym_SLASH] = ACTIONS(1823),
    [anon_sym_class] = ACTIONS(1823),
    [anon_sym_async] = ACTIONS(1823),
    [anon_sym_function] = ACTIONS(1823),
    [anon_sym_new] = ACTIONS(1823),
    [anon_sym_PLUS] = ACTIONS(1823),
    [anon_sym_DASH] = ACTIONS(1823),
    [anon_sym_TILDE] = ACTIONS(1821),
    [anon_sym_void] = ACTIONS(1823),
    [anon_sym_delete] = ACTIONS(1823),
    [anon_sym_PLUS_PLUS] = ACTIONS(1821),
    [anon_sym_DASH_DASH] = ACTIONS(1821),
    [anon_sym_DQUOTE] = ACTIONS(1821),
    [anon_sym_SQUOTE] = ACTIONS(1821),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1821),
    [sym_number] = ACTIONS(1821),
    [sym_this] = ACTIONS(1823),
    [sym_super] = ACTIONS(1823),
    [sym_true] = ACTIONS(1823),
    [sym_false] = ACTIONS(1823),
    [sym_null] = ACTIONS(1823),
    [sym_undefined] = ACTIONS(1823),
    [anon_sym_AT] = ACTIONS(1821),
    [anon_sym_static] = ACTIONS(1823),
    [anon_sym_abstract] = ACTIONS(1823),
    [anon_sym_get] = ACTIONS(1823),
    [anon_sym_set] = ACTIONS(1823),
    [anon_sym_declare] = ACTIONS(1823),
    [anon_sym_public] = ACTIONS(1823),
    [anon_sym_private] = ACTIONS(1823),
    [anon_sym_protected] = ACTIONS(1823),
    [anon_sym_module] = ACTIONS(1823),
    [anon_sym_any] = ACTIONS(1823),
    [anon_sym_number] = ACTIONS(1823),
    [anon_sym_boolean] = ACTIONS(1823),
    [anon_sym_string] = ACTIONS(1823),
    [anon_sym_symbol] = ACTIONS(1823),
    [anon_sym_interface] = ACTIONS(1823),
    [anon_sym_enum] = ACTIONS(1823),
    [sym_readonly] = ACTIONS(1823),
  },
  [536] = {
    [ts_builtin_sym_end] = ACTIONS(1115),
    [sym_identifier] = ACTIONS(1117),
    [anon_sym_export] = ACTIONS(1117),
    [anon_sym_default] = ACTIONS(1117),
    [anon_sym_namespace] = ACTIONS(1117),
    [anon_sym_LBRACE] = ACTIONS(1115),
    [anon_sym_RBRACE] = ACTIONS(1115),
    [anon_sym_type] = ACTIONS(1117),
    [anon_sym_typeof] = ACTIONS(1117),
    [anon_sym_import] = ACTIONS(1117),
    [anon_sym_var] = ACTIONS(1117),
    [anon_sym_let] = ACTIONS(1117),
    [anon_sym_const] = ACTIONS(1117),
    [anon_sym_BANG] = ACTIONS(1115),
    [anon_sym_else] = ACTIONS(1117),
    [anon_sym_if] = ACTIONS(1117),
    [anon_sym_switch] = ACTIONS(1117),
    [anon_sym_for] = ACTIONS(1117),
    [anon_sym_LPAREN] = ACTIONS(1115),
    [anon_sym_await] = ACTIONS(1117),
    [anon_sym_while] = ACTIONS(1117),
    [anon_sym_do] = ACTIONS(1117),
    [anon_sym_try] = ACTIONS(1117),
    [anon_sym_with] = ACTIONS(1117),
    [anon_sym_break] = ACTIONS(1117),
    [anon_sym_continue] = ACTIONS(1117),
    [anon_sym_debugger] = ACTIONS(1117),
    [anon_sym_return] = ACTIONS(1117),
    [anon_sym_throw] = ACTIONS(1117),
    [anon_sym_SEMI] = ACTIONS(1115),
    [anon_sym_case] = ACTIONS(1117),
    [anon_sym_yield] = ACTIONS(1117),
    [anon_sym_LBRACK] = ACTIONS(1115),
    [anon_sym_LT] = ACTIONS(1115),
    [anon_sym_SLASH] = ACTIONS(1117),
    [anon_sym_class] = ACTIONS(1117),
    [anon_sym_async] = ACTIONS(1117),
    [anon_sym_function] = ACTIONS(1117),
    [anon_sym_new] = ACTIONS(1117),
    [anon_sym_PLUS] = ACTIONS(1117),
    [anon_sym_DASH] = ACTIONS(1117),
    [anon_sym_TILDE] = ACTIONS(1115),
    [anon_sym_void] = ACTIONS(1117),
    [anon_sym_delete] = ACTIONS(1117),
    [anon_sym_PLUS_PLUS] = ACTIONS(1115),
    [anon_sym_DASH_DASH] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1115),
    [anon_sym_SQUOTE] = ACTIONS(1115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1115),
    [sym_number] = ACTIONS(1115),
    [sym_this] = ACTIONS(1117),
    [sym_super] = ACTIONS(1117),
    [sym_true] = ACTIONS(1117),
    [sym_false] = ACTIONS(1117),
    [sym_null] = ACTIONS(1117),
    [sym_undefined] = ACTIONS(1117),
    [anon_sym_AT] = ACTIONS(1115),
    [anon_sym_static] = ACTIONS(1117),
    [anon_sym_abstract] = ACTIONS(1117),
    [anon_sym_get] = ACTIONS(1117),
    [anon_sym_set] = ACTIONS(1117),
    [anon_sym_declare] = ACTIONS(1117),
    [anon_sym_public] = ACTIONS(1117),
    [anon_sym_private] = ACTIONS(1117),
    [anon_sym_protected] = ACTIONS(1117),
    [anon_sym_module] = ACTIONS(1117),
    [anon_sym_any] = ACTIONS(1117),
    [anon_sym_number] = ACTIONS(1117),
    [anon_sym_boolean] = ACTIONS(1117),
    [anon_sym_string] = ACTIONS(1117),
    [anon_sym_symbol] = ACTIONS(1117),
    [anon_sym_interface] = ACTIONS(1117),
    [anon_sym_enum] = ACTIONS(1117),
    [sym_readonly] = ACTIONS(1117),
    [sym__automatic_semicolon] = ACTIONS(1123),
  },
  [537] = {
    [ts_builtin_sym_end] = ACTIONS(1825),
    [sym_identifier] = ACTIONS(1827),
    [anon_sym_export] = ACTIONS(1827),
    [anon_sym_default] = ACTIONS(1827),
    [anon_sym_namespace] = ACTIONS(1827),
    [anon_sym_LBRACE] = ACTIONS(1825),
    [anon_sym_RBRACE] = ACTIONS(1825),
    [anon_sym_type] = ACTIONS(1827),
    [anon_sym_typeof] = ACTIONS(1827),
    [anon_sym_import] = ACTIONS(1827),
    [anon_sym_var] = ACTIONS(1827),
    [anon_sym_let] = ACTIONS(1827),
    [anon_sym_const] = ACTIONS(1827),
    [anon_sym_BANG] = ACTIONS(1825),
    [anon_sym_else] = ACTIONS(1827),
    [anon_sym_if] = ACTIONS(1827),
    [anon_sym_switch] = ACTIONS(1827),
    [anon_sym_for] = ACTIONS(1827),
    [anon_sym_LPAREN] = ACTIONS(1825),
    [anon_sym_await] = ACTIONS(1827),
    [anon_sym_while] = ACTIONS(1827),
    [anon_sym_do] = ACTIONS(1827),
    [anon_sym_try] = ACTIONS(1827),
    [anon_sym_with] = ACTIONS(1827),
    [anon_sym_break] = ACTIONS(1827),
    [anon_sym_continue] = ACTIONS(1827),
    [anon_sym_debugger] = ACTIONS(1827),
    [anon_sym_return] = ACTIONS(1827),
    [anon_sym_throw] = ACTIONS(1827),
    [anon_sym_SEMI] = ACTIONS(1825),
    [anon_sym_case] = ACTIONS(1827),
    [anon_sym_finally] = ACTIONS(1827),
    [anon_sym_yield] = ACTIONS(1827),
    [anon_sym_LBRACK] = ACTIONS(1825),
    [anon_sym_LT] = ACTIONS(1825),
    [anon_sym_SLASH] = ACTIONS(1827),
    [anon_sym_class] = ACTIONS(1827),
    [anon_sym_async] = ACTIONS(1827),
    [anon_sym_function] = ACTIONS(1827),
    [anon_sym_new] = ACTIONS(1827),
    [anon_sym_PLUS] = ACTIONS(1827),
    [anon_sym_DASH] = ACTIONS(1827),
    [anon_sym_TILDE] = ACTIONS(1825),
    [anon_sym_void] = ACTIONS(1827),
    [anon_sym_delete] = ACTIONS(1827),
    [anon_sym_PLUS_PLUS] = ACTIONS(1825),
    [anon_sym_DASH_DASH] = ACTIONS(1825),
    [anon_sym_DQUOTE] = ACTIONS(1825),
    [anon_sym_SQUOTE] = ACTIONS(1825),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1825),
    [sym_number] = ACTIONS(1825),
    [sym_this] = ACTIONS(1827),
    [sym_super] = ACTIONS(1827),
    [sym_true] = ACTIONS(1827),
    [sym_false] = ACTIONS(1827),
    [sym_null] = ACTIONS(1827),
    [sym_undefined] = ACTIONS(1827),
    [anon_sym_AT] = ACTIONS(1825),
    [anon_sym_static] = ACTIONS(1827),
    [anon_sym_abstract] = ACTIONS(1827),
    [anon_sym_get] = ACTIONS(1827),
    [anon_sym_set] = ACTIONS(1827),
    [anon_sym_declare] = ACTIONS(1827),
    [anon_sym_public] = ACTIONS(1827),
    [anon_sym_private] = ACTIONS(1827),
    [anon_sym_protected] = ACTIONS(1827),
    [anon_sym_module] = ACTIONS(1827),
    [anon_sym_any] = ACTIONS(1827),
    [anon_sym_number] = ACTIONS(1827),
    [anon_sym_boolean] = ACTIONS(1827),
    [anon_sym_string] = ACTIONS(1827),
    [anon_sym_symbol] = ACTIONS(1827),
    [anon_sym_interface] = ACTIONS(1827),
    [anon_sym_enum] = ACTIONS(1827),
    [sym_readonly] = ACTIONS(1827),
  },
  [538] = {
    [ts_builtin_sym_end] = ACTIONS(1125),
    [sym_identifier] = ACTIONS(1127),
    [anon_sym_export] = ACTIONS(1127),
    [anon_sym_default] = ACTIONS(1127),
    [anon_sym_namespace] = ACTIONS(1127),
    [anon_sym_LBRACE] = ACTIONS(1125),
    [anon_sym_RBRACE] = ACTIONS(1125),
    [anon_sym_type] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1127),
    [anon_sym_import] = ACTIONS(1127),
    [anon_sym_var] = ACTIONS(1127),
    [anon_sym_let] = ACTIONS(1127),
    [anon_sym_const] = ACTIONS(1127),
    [anon_sym_BANG] = ACTIONS(1125),
    [anon_sym_else] = ACTIONS(1127),
    [anon_sym_if] = ACTIONS(1127),
    [anon_sym_switch] = ACTIONS(1127),
    [anon_sym_for] = ACTIONS(1127),
    [anon_sym_LPAREN] = ACTIONS(1125),
    [anon_sym_await] = ACTIONS(1127),
    [anon_sym_while] = ACTIONS(1127),
    [anon_sym_do] = ACTIONS(1127),
    [anon_sym_try] = ACTIONS(1127),
    [anon_sym_with] = ACTIONS(1127),
    [anon_sym_break] = ACTIONS(1127),
    [anon_sym_continue] = ACTIONS(1127),
    [anon_sym_debugger] = ACTIONS(1127),
    [anon_sym_return] = ACTIONS(1127),
    [anon_sym_throw] = ACTIONS(1127),
    [anon_sym_SEMI] = ACTIONS(1125),
    [anon_sym_case] = ACTIONS(1127),
    [anon_sym_yield] = ACTIONS(1127),
    [anon_sym_LBRACK] = ACTIONS(1125),
    [anon_sym_LT] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(1127),
    [anon_sym_class] = ACTIONS(1127),
    [anon_sym_async] = ACTIONS(1127),
    [anon_sym_function] = ACTIONS(1127),
    [anon_sym_new] = ACTIONS(1127),
    [anon_sym_PLUS] = ACTIONS(1127),
    [anon_sym_DASH] = ACTIONS(1127),
    [anon_sym_TILDE] = ACTIONS(1125),
    [anon_sym_void] = ACTIONS(1127),
    [anon_sym_delete] = ACTIONS(1127),
    [anon_sym_PLUS_PLUS] = ACTIONS(1125),
    [anon_sym_DASH_DASH] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1125),
    [anon_sym_SQUOTE] = ACTIONS(1125),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1125),
    [sym_number] = ACTIONS(1125),
    [sym_this] = ACTIONS(1127),
    [sym_super] = ACTIONS(1127),
    [sym_true] = ACTIONS(1127),
    [sym_false] = ACTIONS(1127),
    [sym_null] = ACTIONS(1127),
    [sym_undefined] = ACTIONS(1127),
    [anon_sym_AT] = ACTIONS(1125),
    [anon_sym_static] = ACTIONS(1127),
    [anon_sym_abstract] = ACTIONS(1127),
    [anon_sym_get] = ACTIONS(1127),
    [anon_sym_set] = ACTIONS(1127),
    [anon_sym_declare] = ACTIONS(1127),
    [anon_sym_public] = ACTIONS(1127),
    [anon_sym_private] = ACTIONS(1127),
    [anon_sym_protected] = ACTIONS(1127),
    [anon_sym_module] = ACTIONS(1127),
    [anon_sym_any] = ACTIONS(1127),
    [anon_sym_number] = ACTIONS(1127),
    [anon_sym_boolean] = ACTIONS(1127),
    [anon_sym_string] = ACTIONS(1127),
    [anon_sym_symbol] = ACTIONS(1127),
    [anon_sym_interface] = ACTIONS(1127),
    [anon_sym_enum] = ACTIONS(1127),
    [sym_readonly] = ACTIONS(1127),
    [sym__automatic_semicolon] = ACTIONS(1133),
  },
  [539] = {
    [ts_builtin_sym_end] = ACTIONS(1015),
    [sym_identifier] = ACTIONS(1017),
    [anon_sym_export] = ACTIONS(1017),
    [anon_sym_default] = ACTIONS(1017),
    [anon_sym_namespace] = ACTIONS(1017),
    [anon_sym_LBRACE] = ACTIONS(1015),
    [anon_sym_RBRACE] = ACTIONS(1015),
    [anon_sym_type] = ACTIONS(1017),
    [anon_sym_typeof] = ACTIONS(1017),
    [anon_sym_import] = ACTIONS(1017),
    [anon_sym_var] = ACTIONS(1017),
    [anon_sym_let] = ACTIONS(1017),
    [anon_sym_const] = ACTIONS(1017),
    [anon_sym_BANG] = ACTIONS(1015),
    [anon_sym_else] = ACTIONS(1017),
    [anon_sym_if] = ACTIONS(1017),
    [anon_sym_switch] = ACTIONS(1017),
    [anon_sym_for] = ACTIONS(1017),
    [anon_sym_LPAREN] = ACTIONS(1015),
    [anon_sym_await] = ACTIONS(1017),
    [anon_sym_while] = ACTIONS(1017),
    [anon_sym_do] = ACTIONS(1017),
    [anon_sym_try] = ACTIONS(1017),
    [anon_sym_with] = ACTIONS(1017),
    [anon_sym_break] = ACTIONS(1017),
    [anon_sym_continue] = ACTIONS(1017),
    [anon_sym_debugger] = ACTIONS(1017),
    [anon_sym_return] = ACTIONS(1017),
    [anon_sym_throw] = ACTIONS(1017),
    [anon_sym_SEMI] = ACTIONS(1015),
    [anon_sym_case] = ACTIONS(1017),
    [anon_sym_yield] = ACTIONS(1017),
    [anon_sym_LBRACK] = ACTIONS(1015),
    [anon_sym_LT] = ACTIONS(1015),
    [anon_sym_SLASH] = ACTIONS(1017),
    [anon_sym_DOT] = ACTIONS(1017),
    [anon_sym_class] = ACTIONS(1017),
    [anon_sym_async] = ACTIONS(1017),
    [anon_sym_function] = ACTIONS(1017),
    [anon_sym_new] = ACTIONS(1017),
    [anon_sym_PLUS] = ACTIONS(1017),
    [anon_sym_DASH] = ACTIONS(1017),
    [anon_sym_TILDE] = ACTIONS(1015),
    [anon_sym_void] = ACTIONS(1017),
    [anon_sym_delete] = ACTIONS(1017),
    [anon_sym_PLUS_PLUS] = ACTIONS(1015),
    [anon_sym_DASH_DASH] = ACTIONS(1015),
    [anon_sym_DQUOTE] = ACTIONS(1015),
    [anon_sym_SQUOTE] = ACTIONS(1015),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1015),
    [sym_number] = ACTIONS(1015),
    [sym_this] = ACTIONS(1017),
    [sym_super] = ACTIONS(1017),
    [sym_true] = ACTIONS(1017),
    [sym_false] = ACTIONS(1017),
    [sym_null] = ACTIONS(1017),
    [sym_undefined] = ACTIONS(1017),
    [anon_sym_AT] = ACTIONS(1015),
    [anon_sym_static] = ACTIONS(1017),
    [anon_sym_abstract] = ACTIONS(1017),
    [anon_sym_get] = ACTIONS(1017),
    [anon_sym_set] = ACTIONS(1017),
    [anon_sym_declare] = ACTIONS(1017),
    [anon_sym_public] = ACTIONS(1017),
    [anon_sym_private] = ACTIONS(1017),
    [anon_sym_protected] = ACTIONS(1017),
    [anon_sym_module] = ACTIONS(1017),
    [anon_sym_any] = ACTIONS(1017),
    [anon_sym_number] = ACTIONS(1017),
    [anon_sym_boolean] = ACTIONS(1017),
    [anon_sym_string] = ACTIONS(1017),
    [anon_sym_symbol] = ACTIONS(1017),
    [anon_sym_interface] = ACTIONS(1017),
    [anon_sym_enum] = ACTIONS(1017),
    [sym_readonly] = ACTIONS(1017),
  },
  [540] = {
    [ts_builtin_sym_end] = ACTIONS(1097),
    [sym_identifier] = ACTIONS(1099),
    [anon_sym_export] = ACTIONS(1099),
    [anon_sym_default] = ACTIONS(1099),
    [anon_sym_namespace] = ACTIONS(1099),
    [anon_sym_LBRACE] = ACTIONS(1097),
    [anon_sym_RBRACE] = ACTIONS(1097),
    [anon_sym_type] = ACTIONS(1099),
    [anon_sym_typeof] = ACTIONS(1099),
    [anon_sym_import] = ACTIONS(1099),
    [anon_sym_var] = ACTIONS(1099),
    [anon_sym_let] = ACTIONS(1099),
    [anon_sym_const] = ACTIONS(1099),
    [anon_sym_BANG] = ACTIONS(1097),
    [anon_sym_else] = ACTIONS(1099),
    [anon_sym_if] = ACTIONS(1099),
    [anon_sym_switch] = ACTIONS(1099),
    [anon_sym_for] = ACTIONS(1099),
    [anon_sym_LPAREN] = ACTIONS(1097),
    [anon_sym_await] = ACTIONS(1099),
    [anon_sym_while] = ACTIONS(1099),
    [anon_sym_do] = ACTIONS(1099),
    [anon_sym_try] = ACTIONS(1099),
    [anon_sym_with] = ACTIONS(1099),
    [anon_sym_break] = ACTIONS(1099),
    [anon_sym_continue] = ACTIONS(1099),
    [anon_sym_debugger] = ACTIONS(1099),
    [anon_sym_return] = ACTIONS(1099),
    [anon_sym_throw] = ACTIONS(1099),
    [anon_sym_SEMI] = ACTIONS(1097),
    [anon_sym_case] = ACTIONS(1099),
    [anon_sym_yield] = ACTIONS(1099),
    [anon_sym_LBRACK] = ACTIONS(1097),
    [anon_sym_LT] = ACTIONS(1097),
    [anon_sym_SLASH] = ACTIONS(1099),
    [anon_sym_class] = ACTIONS(1099),
    [anon_sym_async] = ACTIONS(1099),
    [anon_sym_function] = ACTIONS(1099),
    [anon_sym_new] = ACTIONS(1099),
    [anon_sym_PLUS] = ACTIONS(1099),
    [anon_sym_DASH] = ACTIONS(1099),
    [anon_sym_TILDE] = ACTIONS(1097),
    [anon_sym_void] = ACTIONS(1099),
    [anon_sym_delete] = ACTIONS(1099),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_DQUOTE] = ACTIONS(1097),
    [anon_sym_SQUOTE] = ACTIONS(1097),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1097),
    [sym_number] = ACTIONS(1097),
    [sym_this] = ACTIONS(1099),
    [sym_super] = ACTIONS(1099),
    [sym_true] = ACTIONS(1099),
    [sym_false] = ACTIONS(1099),
    [sym_null] = ACTIONS(1099),
    [sym_undefined] = ACTIONS(1099),
    [anon_sym_AT] = ACTIONS(1097),
    [anon_sym_static] = ACTIONS(1099),
    [anon_sym_abstract] = ACTIONS(1099),
    [anon_sym_get] = ACTIONS(1099),
    [anon_sym_set] = ACTIONS(1099),
    [anon_sym_declare] = ACTIONS(1099),
    [anon_sym_public] = ACTIONS(1099),
    [anon_sym_private] = ACTIONS(1099),
    [anon_sym_protected] = ACTIONS(1099),
    [anon_sym_module] = ACTIONS(1099),
    [anon_sym_any] = ACTIONS(1099),
    [anon_sym_number] = ACTIONS(1099),
    [anon_sym_boolean] = ACTIONS(1099),
    [anon_sym_string] = ACTIONS(1099),
    [anon_sym_symbol] = ACTIONS(1099),
    [anon_sym_interface] = ACTIONS(1099),
    [anon_sym_enum] = ACTIONS(1099),
    [sym_readonly] = ACTIONS(1099),
    [sym__automatic_semicolon] = ACTIONS(1105),
  },
  [541] = {
    [sym_else_clause] = STATE(545),
    [ts_builtin_sym_end] = ACTIONS(1829),
    [sym_identifier] = ACTIONS(1831),
    [anon_sym_export] = ACTIONS(1831),
    [anon_sym_default] = ACTIONS(1831),
    [anon_sym_namespace] = ACTIONS(1831),
    [anon_sym_LBRACE] = ACTIONS(1829),
    [anon_sym_RBRACE] = ACTIONS(1829),
    [anon_sym_type] = ACTIONS(1831),
    [anon_sym_typeof] = ACTIONS(1831),
    [anon_sym_import] = ACTIONS(1831),
    [anon_sym_var] = ACTIONS(1831),
    [anon_sym_let] = ACTIONS(1831),
    [anon_sym_const] = ACTIONS(1831),
    [anon_sym_BANG] = ACTIONS(1829),
    [anon_sym_else] = ACTIONS(1833),
    [anon_sym_if] = ACTIONS(1831),
    [anon_sym_switch] = ACTIONS(1831),
    [anon_sym_for] = ACTIONS(1831),
    [anon_sym_LPAREN] = ACTIONS(1829),
    [anon_sym_await] = ACTIONS(1831),
    [anon_sym_while] = ACTIONS(1831),
    [anon_sym_do] = ACTIONS(1831),
    [anon_sym_try] = ACTIONS(1831),
    [anon_sym_with] = ACTIONS(1831),
    [anon_sym_break] = ACTIONS(1831),
    [anon_sym_continue] = ACTIONS(1831),
    [anon_sym_debugger] = ACTIONS(1831),
    [anon_sym_return] = ACTIONS(1831),
    [anon_sym_throw] = ACTIONS(1831),
    [anon_sym_SEMI] = ACTIONS(1829),
    [anon_sym_case] = ACTIONS(1831),
    [anon_sym_yield] = ACTIONS(1831),
    [anon_sym_LBRACK] = ACTIONS(1829),
    [anon_sym_LT] = ACTIONS(1829),
    [anon_sym_SLASH] = ACTIONS(1831),
    [anon_sym_class] = ACTIONS(1831),
    [anon_sym_async] = ACTIONS(1831),
    [anon_sym_function] = ACTIONS(1831),
    [anon_sym_new] = ACTIONS(1831),
    [anon_sym_PLUS] = ACTIONS(1831),
    [anon_sym_DASH] = ACTIONS(1831),
    [anon_sym_TILDE] = ACTIONS(1829),
    [anon_sym_void] = ACTIONS(1831),
    [anon_sym_delete] = ACTIONS(1831),
    [anon_sym_PLUS_PLUS] = ACTIONS(1829),
    [anon_sym_DASH_DASH] = ACTIONS(1829),
    [anon_sym_DQUOTE] = ACTIONS(1829),
    [anon_sym_SQUOTE] = ACTIONS(1829),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1829),
    [sym_number] = ACTIONS(1829),
    [sym_this] = ACTIONS(1831),
    [sym_super] = ACTIONS(1831),
    [sym_true] = ACTIONS(1831),
    [sym_false] = ACTIONS(1831),
    [sym_null] = ACTIONS(1831),
    [sym_undefined] = ACTIONS(1831),
    [anon_sym_AT] = ACTIONS(1829),
    [anon_sym_static] = ACTIONS(1831),
    [anon_sym_abstract] = ACTIONS(1831),
    [anon_sym_get] = ACTIONS(1831),
    [anon_sym_set] = ACTIONS(1831),
    [anon_sym_declare] = ACTIONS(1831),
    [anon_sym_public] = ACTIONS(1831),
    [anon_sym_private] = ACTIONS(1831),
    [anon_sym_protected] = ACTIONS(1831),
    [anon_sym_module] = ACTIONS(1831),
    [anon_sym_any] = ACTIONS(1831),
    [anon_sym_number] = ACTIONS(1831),
    [anon_sym_boolean] = ACTIONS(1831),
    [anon_sym_string] = ACTIONS(1831),
    [anon_sym_symbol] = ACTIONS(1831),
    [anon_sym_interface] = ACTIONS(1831),
    [anon_sym_enum] = ACTIONS(1831),
    [sym_readonly] = ACTIONS(1831),
  },
  [542] = {
    [ts_builtin_sym_end] = ACTIONS(1107),
    [sym_identifier] = ACTIONS(1109),
    [anon_sym_export] = ACTIONS(1109),
    [anon_sym_default] = ACTIONS(1109),
    [anon_sym_namespace] = ACTIONS(1109),
    [anon_sym_LBRACE] = ACTIONS(1107),
    [anon_sym_RBRACE] = ACTIONS(1107),
    [anon_sym_type] = ACTIONS(1109),
    [anon_sym_typeof] = ACTIONS(1109),
    [anon_sym_import] = ACTIONS(1109),
    [anon_sym_var] = ACTIONS(1109),
    [anon_sym_let] = ACTIONS(1109),
    [anon_sym_const] = ACTIONS(1109),
    [anon_sym_BANG] = ACTIONS(1107),
    [anon_sym_else] = ACTIONS(1109),
    [anon_sym_if] = ACTIONS(1109),
    [anon_sym_switch] = ACTIONS(1109),
    [anon_sym_for] = ACTIONS(1109),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1109),
    [anon_sym_while] = ACTIONS(1109),
    [anon_sym_do] = ACTIONS(1109),
    [anon_sym_try] = ACTIONS(1109),
    [anon_sym_with] = ACTIONS(1109),
    [anon_sym_break] = ACTIONS(1109),
    [anon_sym_continue] = ACTIONS(1109),
    [anon_sym_debugger] = ACTIONS(1109),
    [anon_sym_return] = ACTIONS(1109),
    [anon_sym_throw] = ACTIONS(1109),
    [anon_sym_SEMI] = ACTIONS(1107),
    [anon_sym_case] = ACTIONS(1109),
    [anon_sym_yield] = ACTIONS(1109),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(1107),
    [anon_sym_SLASH] = ACTIONS(1109),
    [anon_sym_class] = ACTIONS(1109),
    [anon_sym_async] = ACTIONS(1109),
    [anon_sym_function] = ACTIONS(1109),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_PLUS] = ACTIONS(1109),
    [anon_sym_DASH] = ACTIONS(1109),
    [anon_sym_TILDE] = ACTIONS(1107),
    [anon_sym_void] = ACTIONS(1109),
    [anon_sym_delete] = ACTIONS(1109),
    [anon_sym_PLUS_PLUS] = ACTIONS(1107),
    [anon_sym_DASH_DASH] = ACTIONS(1107),
    [anon_sym_DQUOTE] = ACTIONS(1107),
    [anon_sym_SQUOTE] = ACTIONS(1107),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1107),
    [sym_number] = ACTIONS(1107),
    [sym_this] = ACTIONS(1109),
    [sym_super] = ACTIONS(1109),
    [sym_true] = ACTIONS(1109),
    [sym_false] = ACTIONS(1109),
    [sym_null] = ACTIONS(1109),
    [sym_undefined] = ACTIONS(1109),
    [anon_sym_AT] = ACTIONS(1107),
    [anon_sym_static] = ACTIONS(1109),
    [anon_sym_abstract] = ACTIONS(1109),
    [anon_sym_get] = ACTIONS(1109),
    [anon_sym_set] = ACTIONS(1109),
    [anon_sym_declare] = ACTIONS(1109),
    [anon_sym_public] = ACTIONS(1109),
    [anon_sym_private] = ACTIONS(1109),
    [anon_sym_protected] = ACTIONS(1109),
    [anon_sym_module] = ACTIONS(1109),
    [anon_sym_any] = ACTIONS(1109),
    [anon_sym_number] = ACTIONS(1109),
    [anon_sym_boolean] = ACTIONS(1109),
    [anon_sym_string] = ACTIONS(1109),
    [anon_sym_symbol] = ACTIONS(1109),
    [anon_sym_interface] = ACTIONS(1109),
    [anon_sym_enum] = ACTIONS(1109),
    [sym_readonly] = ACTIONS(1109),
  },
  [543] = {
    [ts_builtin_sym_end] = ACTIONS(1835),
    [sym_identifier] = ACTIONS(1837),
    [anon_sym_export] = ACTIONS(1837),
    [anon_sym_default] = ACTIONS(1837),
    [anon_sym_namespace] = ACTIONS(1837),
    [anon_sym_LBRACE] = ACTIONS(1835),
    [anon_sym_RBRACE] = ACTIONS(1835),
    [anon_sym_type] = ACTIONS(1837),
    [anon_sym_typeof] = ACTIONS(1837),
    [anon_sym_import] = ACTIONS(1837),
    [anon_sym_var] = ACTIONS(1837),
    [anon_sym_let] = ACTIONS(1837),
    [anon_sym_const] = ACTIONS(1837),
    [anon_sym_BANG] = ACTIONS(1835),
    [anon_sym_else] = ACTIONS(1837),
    [anon_sym_if] = ACTIONS(1837),
    [anon_sym_switch] = ACTIONS(1837),
    [anon_sym_for] = ACTIONS(1837),
    [anon_sym_LPAREN] = ACTIONS(1835),
    [anon_sym_await] = ACTIONS(1837),
    [anon_sym_while] = ACTIONS(1837),
    [anon_sym_do] = ACTIONS(1837),
    [anon_sym_try] = ACTIONS(1837),
    [anon_sym_with] = ACTIONS(1837),
    [anon_sym_break] = ACTIONS(1837),
    [anon_sym_continue] = ACTIONS(1837),
    [anon_sym_debugger] = ACTIONS(1837),
    [anon_sym_return] = ACTIONS(1837),
    [anon_sym_throw] = ACTIONS(1837),
    [anon_sym_SEMI] = ACTIONS(1835),
    [anon_sym_case] = ACTIONS(1837),
    [anon_sym_yield] = ACTIONS(1837),
    [anon_sym_LBRACK] = ACTIONS(1835),
    [anon_sym_LT] = ACTIONS(1835),
    [anon_sym_SLASH] = ACTIONS(1837),
    [anon_sym_class] = ACTIONS(1837),
    [anon_sym_async] = ACTIONS(1837),
    [anon_sym_function] = ACTIONS(1837),
    [anon_sym_new] = ACTIONS(1837),
    [anon_sym_PLUS] = ACTIONS(1837),
    [anon_sym_DASH] = ACTIONS(1837),
    [anon_sym_TILDE] = ACTIONS(1835),
    [anon_sym_void] = ACTIONS(1837),
    [anon_sym_delete] = ACTIONS(1837),
    [anon_sym_PLUS_PLUS] = ACTIONS(1835),
    [anon_sym_DASH_DASH] = ACTIONS(1835),
    [anon_sym_DQUOTE] = ACTIONS(1835),
    [anon_sym_SQUOTE] = ACTIONS(1835),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1835),
    [sym_number] = ACTIONS(1835),
    [sym_this] = ACTIONS(1837),
    [sym_super] = ACTIONS(1837),
    [sym_true] = ACTIONS(1837),
    [sym_false] = ACTIONS(1837),
    [sym_null] = ACTIONS(1837),
    [sym_undefined] = ACTIONS(1837),
    [anon_sym_AT] = ACTIONS(1835),
    [anon_sym_static] = ACTIONS(1837),
    [anon_sym_abstract] = ACTIONS(1837),
    [anon_sym_get] = ACTIONS(1837),
    [anon_sym_set] = ACTIONS(1837),
    [anon_sym_declare] = ACTIONS(1837),
    [anon_sym_public] = ACTIONS(1837),
    [anon_sym_private] = ACTIONS(1837),
    [anon_sym_protected] = ACTIONS(1837),
    [anon_sym_module] = ACTIONS(1837),
    [anon_sym_any] = ACTIONS(1837),
    [anon_sym_number] = ACTIONS(1837),
    [anon_sym_boolean] = ACTIONS(1837),
    [anon_sym_string] = ACTIONS(1837),
    [anon_sym_symbol] = ACTIONS(1837),
    [anon_sym_interface] = ACTIONS(1837),
    [anon_sym_enum] = ACTIONS(1837),
    [sym_readonly] = ACTIONS(1837),
  },
  [544] = {
    [ts_builtin_sym_end] = ACTIONS(1839),
    [sym_identifier] = ACTIONS(1841),
    [anon_sym_export] = ACTIONS(1841),
    [anon_sym_default] = ACTIONS(1841),
    [anon_sym_namespace] = ACTIONS(1841),
    [anon_sym_LBRACE] = ACTIONS(1839),
    [anon_sym_RBRACE] = ACTIONS(1839),
    [anon_sym_type] = ACTIONS(1841),
    [anon_sym_typeof] = ACTIONS(1841),
    [anon_sym_import] = ACTIONS(1841),
    [anon_sym_var] = ACTIONS(1841),
    [anon_sym_let] = ACTIONS(1841),
    [anon_sym_const] = ACTIONS(1841),
    [anon_sym_BANG] = ACTIONS(1839),
    [anon_sym_else] = ACTIONS(1841),
    [anon_sym_if] = ACTIONS(1841),
    [anon_sym_switch] = ACTIONS(1841),
    [anon_sym_for] = ACTIONS(1841),
    [anon_sym_LPAREN] = ACTIONS(1839),
    [anon_sym_await] = ACTIONS(1841),
    [anon_sym_while] = ACTIONS(1841),
    [anon_sym_do] = ACTIONS(1841),
    [anon_sym_try] = ACTIONS(1841),
    [anon_sym_with] = ACTIONS(1841),
    [anon_sym_break] = ACTIONS(1841),
    [anon_sym_continue] = ACTIONS(1841),
    [anon_sym_debugger] = ACTIONS(1841),
    [anon_sym_return] = ACTIONS(1841),
    [anon_sym_throw] = ACTIONS(1841),
    [anon_sym_SEMI] = ACTIONS(1839),
    [anon_sym_case] = ACTIONS(1841),
    [anon_sym_yield] = ACTIONS(1841),
    [anon_sym_LBRACK] = ACTIONS(1839),
    [anon_sym_LT] = ACTIONS(1839),
    [anon_sym_SLASH] = ACTIONS(1841),
    [anon_sym_class] = ACTIONS(1841),
    [anon_sym_async] = ACTIONS(1841),
    [anon_sym_function] = ACTIONS(1841),
    [anon_sym_new] = ACTIONS(1841),
    [anon_sym_PLUS] = ACTIONS(1841),
    [anon_sym_DASH] = ACTIONS(1841),
    [anon_sym_TILDE] = ACTIONS(1839),
    [anon_sym_void] = ACTIONS(1841),
    [anon_sym_delete] = ACTIONS(1841),
    [anon_sym_PLUS_PLUS] = ACTIONS(1839),
    [anon_sym_DASH_DASH] = ACTIONS(1839),
    [anon_sym_DQUOTE] = ACTIONS(1839),
    [anon_sym_SQUOTE] = ACTIONS(1839),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1839),
    [sym_number] = ACTIONS(1839),
    [sym_this] = ACTIONS(1841),
    [sym_super] = ACTIONS(1841),
    [sym_true] = ACTIONS(1841),
    [sym_false] = ACTIONS(1841),
    [sym_null] = ACTIONS(1841),
    [sym_undefined] = ACTIONS(1841),
    [anon_sym_AT] = ACTIONS(1839),
    [anon_sym_static] = ACTIONS(1841),
    [anon_sym_abstract] = ACTIONS(1841),
    [anon_sym_get] = ACTIONS(1841),
    [anon_sym_set] = ACTIONS(1841),
    [anon_sym_declare] = ACTIONS(1841),
    [anon_sym_public] = ACTIONS(1841),
    [anon_sym_private] = ACTIONS(1841),
    [anon_sym_protected] = ACTIONS(1841),
    [anon_sym_module] = ACTIONS(1841),
    [anon_sym_any] = ACTIONS(1841),
    [anon_sym_number] = ACTIONS(1841),
    [anon_sym_boolean] = ACTIONS(1841),
    [anon_sym_string] = ACTIONS(1841),
    [anon_sym_symbol] = ACTIONS(1841),
    [anon_sym_interface] = ACTIONS(1841),
    [anon_sym_enum] = ACTIONS(1841),
    [sym_readonly] = ACTIONS(1841),
  },
  [545] = {
    [ts_builtin_sym_end] = ACTIONS(1843),
    [sym_identifier] = ACTIONS(1845),
    [anon_sym_export] = ACTIONS(1845),
    [anon_sym_default] = ACTIONS(1845),
    [anon_sym_namespace] = ACTIONS(1845),
    [anon_sym_LBRACE] = ACTIONS(1843),
    [anon_sym_RBRACE] = ACTIONS(1843),
    [anon_sym_type] = ACTIONS(1845),
    [anon_sym_typeof] = ACTIONS(1845),
    [anon_sym_import] = ACTIONS(1845),
    [anon_sym_var] = ACTIONS(1845),
    [anon_sym_let] = ACTIONS(1845),
    [anon_sym_const] = ACTIONS(1845),
    [anon_sym_BANG] = ACTIONS(1843),
    [anon_sym_else] = ACTIONS(1845),
    [anon_sym_if] = ACTIONS(1845),
    [anon_sym_switch] = ACTIONS(1845),
    [anon_sym_for] = ACTIONS(1845),
    [anon_sym_LPAREN] = ACTIONS(1843),
    [anon_sym_await] = ACTIONS(1845),
    [anon_sym_while] = ACTIONS(1845),
    [anon_sym_do] = ACTIONS(1845),
    [anon_sym_try] = ACTIONS(1845),
    [anon_sym_with] = ACTIONS(1845),
    [anon_sym_break] = ACTIONS(1845),
    [anon_sym_continue] = ACTIONS(1845),
    [anon_sym_debugger] = ACTIONS(1845),
    [anon_sym_return] = ACTIONS(1845),
    [anon_sym_throw] = ACTIONS(1845),
    [anon_sym_SEMI] = ACTIONS(1843),
    [anon_sym_case] = ACTIONS(1845),
    [anon_sym_yield] = ACTIONS(1845),
    [anon_sym_LBRACK] = ACTIONS(1843),
    [anon_sym_LT] = ACTIONS(1843),
    [anon_sym_SLASH] = ACTIONS(1845),
    [anon_sym_class] = ACTIONS(1845),
    [anon_sym_async] = ACTIONS(1845),
    [anon_sym_function] = ACTIONS(1845),
    [anon_sym_new] = ACTIONS(1845),
    [anon_sym_PLUS] = ACTIONS(1845),
    [anon_sym_DASH] = ACTIONS(1845),
    [anon_sym_TILDE] = ACTIONS(1843),
    [anon_sym_void] = ACTIONS(1845),
    [anon_sym_delete] = ACTIONS(1845),
    [anon_sym_PLUS_PLUS] = ACTIONS(1843),
    [anon_sym_DASH_DASH] = ACTIONS(1843),
    [anon_sym_DQUOTE] = ACTIONS(1843),
    [anon_sym_SQUOTE] = ACTIONS(1843),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1843),
    [sym_number] = ACTIONS(1843),
    [sym_this] = ACTIONS(1845),
    [sym_super] = ACTIONS(1845),
    [sym_true] = ACTIONS(1845),
    [sym_false] = ACTIONS(1845),
    [sym_null] = ACTIONS(1845),
    [sym_undefined] = ACTIONS(1845),
    [anon_sym_AT] = ACTIONS(1843),
    [anon_sym_static] = ACTIONS(1845),
    [anon_sym_abstract] = ACTIONS(1845),
    [anon_sym_get] = ACTIONS(1845),
    [anon_sym_set] = ACTIONS(1845),
    [anon_sym_declare] = ACTIONS(1845),
    [anon_sym_public] = ACTIONS(1845),
    [anon_sym_private] = ACTIONS(1845),
    [anon_sym_protected] = ACTIONS(1845),
    [anon_sym_module] = ACTIONS(1845),
    [anon_sym_any] = ACTIONS(1845),
    [anon_sym_number] = ACTIONS(1845),
    [anon_sym_boolean] = ACTIONS(1845),
    [anon_sym_string] = ACTIONS(1845),
    [anon_sym_symbol] = ACTIONS(1845),
    [anon_sym_interface] = ACTIONS(1845),
    [anon_sym_enum] = ACTIONS(1845),
    [sym_readonly] = ACTIONS(1845),
  },
  [546] = {
    [ts_builtin_sym_end] = ACTIONS(1847),
    [sym_identifier] = ACTIONS(1849),
    [anon_sym_export] = ACTIONS(1849),
    [anon_sym_default] = ACTIONS(1849),
    [anon_sym_namespace] = ACTIONS(1849),
    [anon_sym_LBRACE] = ACTIONS(1847),
    [anon_sym_RBRACE] = ACTIONS(1847),
    [anon_sym_type] = ACTIONS(1849),
    [anon_sym_typeof] = ACTIONS(1849),
    [anon_sym_import] = ACTIONS(1849),
    [anon_sym_var] = ACTIONS(1849),
    [anon_sym_let] = ACTIONS(1849),
    [anon_sym_const] = ACTIONS(1849),
    [anon_sym_BANG] = ACTIONS(1847),
    [anon_sym_else] = ACTIONS(1849),
    [anon_sym_if] = ACTIONS(1849),
    [anon_sym_switch] = ACTIONS(1849),
    [anon_sym_for] = ACTIONS(1849),
    [anon_sym_LPAREN] = ACTIONS(1847),
    [anon_sym_await] = ACTIONS(1849),
    [anon_sym_while] = ACTIONS(1849),
    [anon_sym_do] = ACTIONS(1849),
    [anon_sym_try] = ACTIONS(1849),
    [anon_sym_with] = ACTIONS(1849),
    [anon_sym_break] = ACTIONS(1849),
    [anon_sym_continue] = ACTIONS(1849),
    [anon_sym_debugger] = ACTIONS(1849),
    [anon_sym_return] = ACTIONS(1849),
    [anon_sym_throw] = ACTIONS(1849),
    [anon_sym_SEMI] = ACTIONS(1847),
    [anon_sym_case] = ACTIONS(1849),
    [anon_sym_yield] = ACTIONS(1849),
    [anon_sym_LBRACK] = ACTIONS(1847),
    [anon_sym_LT] = ACTIONS(1847),
    [anon_sym_SLASH] = ACTIONS(1849),
    [anon_sym_class] = ACTIONS(1849),
    [anon_sym_async] = ACTIONS(1849),
    [anon_sym_function] = ACTIONS(1849),
    [anon_sym_new] = ACTIONS(1849),
    [anon_sym_PLUS] = ACTIONS(1849),
    [anon_sym_DASH] = ACTIONS(1849),
    [anon_sym_TILDE] = ACTIONS(1847),
    [anon_sym_void] = ACTIONS(1849),
    [anon_sym_delete] = ACTIONS(1849),
    [anon_sym_PLUS_PLUS] = ACTIONS(1847),
    [anon_sym_DASH_DASH] = ACTIONS(1847),
    [anon_sym_DQUOTE] = ACTIONS(1847),
    [anon_sym_SQUOTE] = ACTIONS(1847),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1847),
    [sym_number] = ACTIONS(1847),
    [sym_this] = ACTIONS(1849),
    [sym_super] = ACTIONS(1849),
    [sym_true] = ACTIONS(1849),
    [sym_false] = ACTIONS(1849),
    [sym_null] = ACTIONS(1849),
    [sym_undefined] = ACTIONS(1849),
    [anon_sym_AT] = ACTIONS(1847),
    [anon_sym_static] = ACTIONS(1849),
    [anon_sym_abstract] = ACTIONS(1849),
    [anon_sym_get] = ACTIONS(1849),
    [anon_sym_set] = ACTIONS(1849),
    [anon_sym_declare] = ACTIONS(1849),
    [anon_sym_public] = ACTIONS(1849),
    [anon_sym_private] = ACTIONS(1849),
    [anon_sym_protected] = ACTIONS(1849),
    [anon_sym_module] = ACTIONS(1849),
    [anon_sym_any] = ACTIONS(1849),
    [anon_sym_number] = ACTIONS(1849),
    [anon_sym_boolean] = ACTIONS(1849),
    [anon_sym_string] = ACTIONS(1849),
    [anon_sym_symbol] = ACTIONS(1849),
    [anon_sym_interface] = ACTIONS(1849),
    [anon_sym_enum] = ACTIONS(1849),
    [sym_readonly] = ACTIONS(1849),
  },
  [547] = {
    [ts_builtin_sym_end] = ACTIONS(1851),
    [sym_identifier] = ACTIONS(1853),
    [anon_sym_export] = ACTIONS(1853),
    [anon_sym_default] = ACTIONS(1853),
    [anon_sym_namespace] = ACTIONS(1853),
    [anon_sym_LBRACE] = ACTIONS(1851),
    [anon_sym_RBRACE] = ACTIONS(1851),
    [anon_sym_type] = ACTIONS(1853),
    [anon_sym_typeof] = ACTIONS(1853),
    [anon_sym_import] = ACTIONS(1853),
    [anon_sym_var] = ACTIONS(1853),
    [anon_sym_let] = ACTIONS(1853),
    [anon_sym_const] = ACTIONS(1853),
    [anon_sym_BANG] = ACTIONS(1851),
    [anon_sym_else] = ACTIONS(1853),
    [anon_sym_if] = ACTIONS(1853),
    [anon_sym_switch] = ACTIONS(1853),
    [anon_sym_for] = ACTIONS(1853),
    [anon_sym_LPAREN] = ACTIONS(1851),
    [anon_sym_await] = ACTIONS(1853),
    [anon_sym_while] = ACTIONS(1853),
    [anon_sym_do] = ACTIONS(1853),
    [anon_sym_try] = ACTIONS(1853),
    [anon_sym_with] = ACTIONS(1853),
    [anon_sym_break] = ACTIONS(1853),
    [anon_sym_continue] = ACTIONS(1853),
    [anon_sym_debugger] = ACTIONS(1853),
    [anon_sym_return] = ACTIONS(1853),
    [anon_sym_throw] = ACTIONS(1853),
    [anon_sym_SEMI] = ACTIONS(1851),
    [anon_sym_case] = ACTIONS(1853),
    [anon_sym_yield] = ACTIONS(1853),
    [anon_sym_LBRACK] = ACTIONS(1851),
    [anon_sym_LT] = ACTIONS(1851),
    [anon_sym_SLASH] = ACTIONS(1853),
    [anon_sym_class] = ACTIONS(1853),
    [anon_sym_async] = ACTIONS(1853),
    [anon_sym_function] = ACTIONS(1853),
    [anon_sym_new] = ACTIONS(1853),
    [anon_sym_PLUS] = ACTIONS(1853),
    [anon_sym_DASH] = ACTIONS(1853),
    [anon_sym_TILDE] = ACTIONS(1851),
    [anon_sym_void] = ACTIONS(1853),
    [anon_sym_delete] = ACTIONS(1853),
    [anon_sym_PLUS_PLUS] = ACTIONS(1851),
    [anon_sym_DASH_DASH] = ACTIONS(1851),
    [anon_sym_DQUOTE] = ACTIONS(1851),
    [anon_sym_SQUOTE] = ACTIONS(1851),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1851),
    [sym_number] = ACTIONS(1851),
    [sym_this] = ACTIONS(1853),
    [sym_super] = ACTIONS(1853),
    [sym_true] = ACTIONS(1853),
    [sym_false] = ACTIONS(1853),
    [sym_null] = ACTIONS(1853),
    [sym_undefined] = ACTIONS(1853),
    [anon_sym_AT] = ACTIONS(1851),
    [anon_sym_static] = ACTIONS(1853),
    [anon_sym_abstract] = ACTIONS(1853),
    [anon_sym_get] = ACTIONS(1853),
    [anon_sym_set] = ACTIONS(1853),
    [anon_sym_declare] = ACTIONS(1853),
    [anon_sym_public] = ACTIONS(1853),
    [anon_sym_private] = ACTIONS(1853),
    [anon_sym_protected] = ACTIONS(1853),
    [anon_sym_module] = ACTIONS(1853),
    [anon_sym_any] = ACTIONS(1853),
    [anon_sym_number] = ACTIONS(1853),
    [anon_sym_boolean] = ACTIONS(1853),
    [anon_sym_string] = ACTIONS(1853),
    [anon_sym_symbol] = ACTIONS(1853),
    [anon_sym_interface] = ACTIONS(1853),
    [anon_sym_enum] = ACTIONS(1853),
    [sym_readonly] = ACTIONS(1853),
  },
  [548] = {
    [ts_builtin_sym_end] = ACTIONS(1855),
    [sym_identifier] = ACTIONS(1857),
    [anon_sym_export] = ACTIONS(1857),
    [anon_sym_default] = ACTIONS(1857),
    [anon_sym_namespace] = ACTIONS(1857),
    [anon_sym_LBRACE] = ACTIONS(1855),
    [anon_sym_RBRACE] = ACTIONS(1855),
    [anon_sym_type] = ACTIONS(1857),
    [anon_sym_typeof] = ACTIONS(1857),
    [anon_sym_import] = ACTIONS(1857),
    [anon_sym_var] = ACTIONS(1857),
    [anon_sym_let] = ACTIONS(1857),
    [anon_sym_const] = ACTIONS(1857),
    [anon_sym_BANG] = ACTIONS(1855),
    [anon_sym_else] = ACTIONS(1857),
    [anon_sym_if] = ACTIONS(1857),
    [anon_sym_switch] = ACTIONS(1857),
    [anon_sym_for] = ACTIONS(1857),
    [anon_sym_LPAREN] = ACTIONS(1855),
    [anon_sym_await] = ACTIONS(1857),
    [anon_sym_while] = ACTIONS(1857),
    [anon_sym_do] = ACTIONS(1857),
    [anon_sym_try] = ACTIONS(1857),
    [anon_sym_with] = ACTIONS(1857),
    [anon_sym_break] = ACTIONS(1857),
    [anon_sym_continue] = ACTIONS(1857),
    [anon_sym_debugger] = ACTIONS(1857),
    [anon_sym_return] = ACTIONS(1857),
    [anon_sym_throw] = ACTIONS(1857),
    [anon_sym_SEMI] = ACTIONS(1855),
    [anon_sym_case] = ACTIONS(1857),
    [anon_sym_yield] = ACTIONS(1857),
    [anon_sym_LBRACK] = ACTIONS(1855),
    [anon_sym_LT] = ACTIONS(1855),
    [anon_sym_SLASH] = ACTIONS(1857),
    [anon_sym_class] = ACTIONS(1857),
    [anon_sym_async] = ACTIONS(1857),
    [anon_sym_function] = ACTIONS(1857),
    [anon_sym_new] = ACTIONS(1857),
    [anon_sym_PLUS] = ACTIONS(1857),
    [anon_sym_DASH] = ACTIONS(1857),
    [anon_sym_TILDE] = ACTIONS(1855),
    [anon_sym_void] = ACTIONS(1857),
    [anon_sym_delete] = ACTIONS(1857),
    [anon_sym_PLUS_PLUS] = ACTIONS(1855),
    [anon_sym_DASH_DASH] = ACTIONS(1855),
    [anon_sym_DQUOTE] = ACTIONS(1855),
    [anon_sym_SQUOTE] = ACTIONS(1855),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1855),
    [sym_number] = ACTIONS(1855),
    [sym_this] = ACTIONS(1857),
    [sym_super] = ACTIONS(1857),
    [sym_true] = ACTIONS(1857),
    [sym_false] = ACTIONS(1857),
    [sym_null] = ACTIONS(1857),
    [sym_undefined] = ACTIONS(1857),
    [anon_sym_AT] = ACTIONS(1855),
    [anon_sym_static] = ACTIONS(1857),
    [anon_sym_abstract] = ACTIONS(1857),
    [anon_sym_get] = ACTIONS(1857),
    [anon_sym_set] = ACTIONS(1857),
    [anon_sym_declare] = ACTIONS(1857),
    [anon_sym_public] = ACTIONS(1857),
    [anon_sym_private] = ACTIONS(1857),
    [anon_sym_protected] = ACTIONS(1857),
    [anon_sym_module] = ACTIONS(1857),
    [anon_sym_any] = ACTIONS(1857),
    [anon_sym_number] = ACTIONS(1857),
    [anon_sym_boolean] = ACTIONS(1857),
    [anon_sym_string] = ACTIONS(1857),
    [anon_sym_symbol] = ACTIONS(1857),
    [anon_sym_interface] = ACTIONS(1857),
    [anon_sym_enum] = ACTIONS(1857),
    [sym_readonly] = ACTIONS(1857),
  },
  [549] = {
    [ts_builtin_sym_end] = ACTIONS(1859),
    [sym_identifier] = ACTIONS(1861),
    [anon_sym_export] = ACTIONS(1861),
    [anon_sym_default] = ACTIONS(1861),
    [anon_sym_namespace] = ACTIONS(1861),
    [anon_sym_LBRACE] = ACTIONS(1859),
    [anon_sym_RBRACE] = ACTIONS(1859),
    [anon_sym_type] = ACTIONS(1861),
    [anon_sym_typeof] = ACTIONS(1861),
    [anon_sym_import] = ACTIONS(1861),
    [anon_sym_var] = ACTIONS(1861),
    [anon_sym_let] = ACTIONS(1861),
    [anon_sym_const] = ACTIONS(1861),
    [anon_sym_BANG] = ACTIONS(1859),
    [anon_sym_else] = ACTIONS(1861),
    [anon_sym_if] = ACTIONS(1861),
    [anon_sym_switch] = ACTIONS(1861),
    [anon_sym_for] = ACTIONS(1861),
    [anon_sym_LPAREN] = ACTIONS(1859),
    [anon_sym_await] = ACTIONS(1861),
    [anon_sym_while] = ACTIONS(1861),
    [anon_sym_do] = ACTIONS(1861),
    [anon_sym_try] = ACTIONS(1861),
    [anon_sym_with] = ACTIONS(1861),
    [anon_sym_break] = ACTIONS(1861),
    [anon_sym_continue] = ACTIONS(1861),
    [anon_sym_debugger] = ACTIONS(1861),
    [anon_sym_return] = ACTIONS(1861),
    [anon_sym_throw] = ACTIONS(1861),
    [anon_sym_SEMI] = ACTIONS(1859),
    [anon_sym_case] = ACTIONS(1861),
    [anon_sym_yield] = ACTIONS(1861),
    [anon_sym_LBRACK] = ACTIONS(1859),
    [anon_sym_LT] = ACTIONS(1859),
    [anon_sym_SLASH] = ACTIONS(1861),
    [anon_sym_class] = ACTIONS(1861),
    [anon_sym_async] = ACTIONS(1861),
    [anon_sym_function] = ACTIONS(1861),
    [anon_sym_new] = ACTIONS(1861),
    [anon_sym_PLUS] = ACTIONS(1861),
    [anon_sym_DASH] = ACTIONS(1861),
    [anon_sym_TILDE] = ACTIONS(1859),
    [anon_sym_void] = ACTIONS(1861),
    [anon_sym_delete] = ACTIONS(1861),
    [anon_sym_PLUS_PLUS] = ACTIONS(1859),
    [anon_sym_DASH_DASH] = ACTIONS(1859),
    [anon_sym_DQUOTE] = ACTIONS(1859),
    [anon_sym_SQUOTE] = ACTIONS(1859),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1859),
    [sym_number] = ACTIONS(1859),
    [sym_this] = ACTIONS(1861),
    [sym_super] = ACTIONS(1861),
    [sym_true] = ACTIONS(1861),
    [sym_false] = ACTIONS(1861),
    [sym_null] = ACTIONS(1861),
    [sym_undefined] = ACTIONS(1861),
    [anon_sym_AT] = ACTIONS(1859),
    [anon_sym_static] = ACTIONS(1861),
    [anon_sym_abstract] = ACTIONS(1861),
    [anon_sym_get] = ACTIONS(1861),
    [anon_sym_set] = ACTIONS(1861),
    [anon_sym_declare] = ACTIONS(1861),
    [anon_sym_public] = ACTIONS(1861),
    [anon_sym_private] = ACTIONS(1861),
    [anon_sym_protected] = ACTIONS(1861),
    [anon_sym_module] = ACTIONS(1861),
    [anon_sym_any] = ACTIONS(1861),
    [anon_sym_number] = ACTIONS(1861),
    [anon_sym_boolean] = ACTIONS(1861),
    [anon_sym_string] = ACTIONS(1861),
    [anon_sym_symbol] = ACTIONS(1861),
    [anon_sym_interface] = ACTIONS(1861),
    [anon_sym_enum] = ACTIONS(1861),
    [sym_readonly] = ACTIONS(1861),
  },
  [550] = {
    [ts_builtin_sym_end] = ACTIONS(1863),
    [sym_identifier] = ACTIONS(1865),
    [anon_sym_export] = ACTIONS(1865),
    [anon_sym_default] = ACTIONS(1865),
    [anon_sym_namespace] = ACTIONS(1865),
    [anon_sym_LBRACE] = ACTIONS(1863),
    [anon_sym_RBRACE] = ACTIONS(1863),
    [anon_sym_type] = ACTIONS(1865),
    [anon_sym_typeof] = ACTIONS(1865),
    [anon_sym_import] = ACTIONS(1865),
    [anon_sym_var] = ACTIONS(1865),
    [anon_sym_let] = ACTIONS(1865),
    [anon_sym_const] = ACTIONS(1865),
    [anon_sym_BANG] = ACTIONS(1863),
    [anon_sym_else] = ACTIONS(1865),
    [anon_sym_if] = ACTIONS(1865),
    [anon_sym_switch] = ACTIONS(1865),
    [anon_sym_for] = ACTIONS(1865),
    [anon_sym_LPAREN] = ACTIONS(1863),
    [anon_sym_await] = ACTIONS(1865),
    [anon_sym_while] = ACTIONS(1865),
    [anon_sym_do] = ACTIONS(1865),
    [anon_sym_try] = ACTIONS(1865),
    [anon_sym_with] = ACTIONS(1865),
    [anon_sym_break] = ACTIONS(1865),
    [anon_sym_continue] = ACTIONS(1865),
    [anon_sym_debugger] = ACTIONS(1865),
    [anon_sym_return] = ACTIONS(1865),
    [anon_sym_throw] = ACTIONS(1865),
    [anon_sym_SEMI] = ACTIONS(1863),
    [anon_sym_case] = ACTIONS(1865),
    [anon_sym_yield] = ACTIONS(1865),
    [anon_sym_LBRACK] = ACTIONS(1863),
    [anon_sym_LT] = ACTIONS(1863),
    [anon_sym_SLASH] = ACTIONS(1865),
    [anon_sym_class] = ACTIONS(1865),
    [anon_sym_async] = ACTIONS(1865),
    [anon_sym_function] = ACTIONS(1865),
    [anon_sym_new] = ACTIONS(1865),
    [anon_sym_PLUS] = ACTIONS(1865),
    [anon_sym_DASH] = ACTIONS(1865),
    [anon_sym_TILDE] = ACTIONS(1863),
    [anon_sym_void] = ACTIONS(1865),
    [anon_sym_delete] = ACTIONS(1865),
    [anon_sym_PLUS_PLUS] = ACTIONS(1863),
    [anon_sym_DASH_DASH] = ACTIONS(1863),
    [anon_sym_DQUOTE] = ACTIONS(1863),
    [anon_sym_SQUOTE] = ACTIONS(1863),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1863),
    [sym_number] = ACTIONS(1863),
    [sym_this] = ACTIONS(1865),
    [sym_super] = ACTIONS(1865),
    [sym_true] = ACTIONS(1865),
    [sym_false] = ACTIONS(1865),
    [sym_null] = ACTIONS(1865),
    [sym_undefined] = ACTIONS(1865),
    [anon_sym_AT] = ACTIONS(1863),
    [anon_sym_static] = ACTIONS(1865),
    [anon_sym_abstract] = ACTIONS(1865),
    [anon_sym_get] = ACTIONS(1865),
    [anon_sym_set] = ACTIONS(1865),
    [anon_sym_declare] = ACTIONS(1865),
    [anon_sym_public] = ACTIONS(1865),
    [anon_sym_private] = ACTIONS(1865),
    [anon_sym_protected] = ACTIONS(1865),
    [anon_sym_module] = ACTIONS(1865),
    [anon_sym_any] = ACTIONS(1865),
    [anon_sym_number] = ACTIONS(1865),
    [anon_sym_boolean] = ACTIONS(1865),
    [anon_sym_string] = ACTIONS(1865),
    [anon_sym_symbol] = ACTIONS(1865),
    [anon_sym_interface] = ACTIONS(1865),
    [anon_sym_enum] = ACTIONS(1865),
    [sym_readonly] = ACTIONS(1865),
  },
  [551] = {
    [ts_builtin_sym_end] = ACTIONS(1867),
    [sym_identifier] = ACTIONS(1869),
    [anon_sym_export] = ACTIONS(1869),
    [anon_sym_default] = ACTIONS(1869),
    [anon_sym_namespace] = ACTIONS(1869),
    [anon_sym_LBRACE] = ACTIONS(1867),
    [anon_sym_RBRACE] = ACTIONS(1867),
    [anon_sym_type] = ACTIONS(1869),
    [anon_sym_typeof] = ACTIONS(1869),
    [anon_sym_import] = ACTIONS(1869),
    [anon_sym_var] = ACTIONS(1869),
    [anon_sym_let] = ACTIONS(1869),
    [anon_sym_const] = ACTIONS(1869),
    [anon_sym_BANG] = ACTIONS(1867),
    [anon_sym_else] = ACTIONS(1869),
    [anon_sym_if] = ACTIONS(1869),
    [anon_sym_switch] = ACTIONS(1869),
    [anon_sym_for] = ACTIONS(1869),
    [anon_sym_LPAREN] = ACTIONS(1867),
    [anon_sym_await] = ACTIONS(1869),
    [anon_sym_while] = ACTIONS(1869),
    [anon_sym_do] = ACTIONS(1869),
    [anon_sym_try] = ACTIONS(1869),
    [anon_sym_with] = ACTIONS(1869),
    [anon_sym_break] = ACTIONS(1869),
    [anon_sym_continue] = ACTIONS(1869),
    [anon_sym_debugger] = ACTIONS(1869),
    [anon_sym_return] = ACTIONS(1869),
    [anon_sym_throw] = ACTIONS(1869),
    [anon_sym_SEMI] = ACTIONS(1867),
    [anon_sym_case] = ACTIONS(1869),
    [anon_sym_yield] = ACTIONS(1869),
    [anon_sym_LBRACK] = ACTIONS(1867),
    [anon_sym_LT] = ACTIONS(1867),
    [anon_sym_SLASH] = ACTIONS(1869),
    [anon_sym_class] = ACTIONS(1869),
    [anon_sym_async] = ACTIONS(1869),
    [anon_sym_function] = ACTIONS(1869),
    [anon_sym_new] = ACTIONS(1869),
    [anon_sym_PLUS] = ACTIONS(1869),
    [anon_sym_DASH] = ACTIONS(1869),
    [anon_sym_TILDE] = ACTIONS(1867),
    [anon_sym_void] = ACTIONS(1869),
    [anon_sym_delete] = ACTIONS(1869),
    [anon_sym_PLUS_PLUS] = ACTIONS(1867),
    [anon_sym_DASH_DASH] = ACTIONS(1867),
    [anon_sym_DQUOTE] = ACTIONS(1867),
    [anon_sym_SQUOTE] = ACTIONS(1867),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1867),
    [sym_number] = ACTIONS(1867),
    [sym_this] = ACTIONS(1869),
    [sym_super] = ACTIONS(1869),
    [sym_true] = ACTIONS(1869),
    [sym_false] = ACTIONS(1869),
    [sym_null] = ACTIONS(1869),
    [sym_undefined] = ACTIONS(1869),
    [anon_sym_AT] = ACTIONS(1867),
    [anon_sym_static] = ACTIONS(1869),
    [anon_sym_abstract] = ACTIONS(1869),
    [anon_sym_get] = ACTIONS(1869),
    [anon_sym_set] = ACTIONS(1869),
    [anon_sym_declare] = ACTIONS(1869),
    [anon_sym_public] = ACTIONS(1869),
    [anon_sym_private] = ACTIONS(1869),
    [anon_sym_protected] = ACTIONS(1869),
    [anon_sym_module] = ACTIONS(1869),
    [anon_sym_any] = ACTIONS(1869),
    [anon_sym_number] = ACTIONS(1869),
    [anon_sym_boolean] = ACTIONS(1869),
    [anon_sym_string] = ACTIONS(1869),
    [anon_sym_symbol] = ACTIONS(1869),
    [anon_sym_interface] = ACTIONS(1869),
    [anon_sym_enum] = ACTIONS(1869),
    [sym_readonly] = ACTIONS(1869),
  },
  [552] = {
    [sym_object] = STATE(2474),
    [sym_array] = STATE(2475),
    [sym_nested_identifier] = STATE(3297),
    [sym_string] = STATE(447),
    [sym_formal_parameters] = STATE(3296),
    [sym_nested_type_identifier] = STATE(1957),
    [sym__type] = STATE(2794),
    [sym_constructor_type] = STATE(2794),
    [sym__primary_type] = STATE(2659),
    [sym_infer_type] = STATE(2794),
    [sym_conditional_type] = STATE(2659),
    [sym_generic_type] = STATE(2659),
    [sym_type_query] = STATE(2659),
    [sym_index_type_query] = STATE(2659),
    [sym_lookup_type] = STATE(2659),
    [sym_literal_type] = STATE(2659),
    [sym__number] = STATE(447),
    [sym_existential_type] = STATE(2659),
    [sym_flow_maybe_type] = STATE(2659),
    [sym_parenthesized_type] = STATE(2659),
    [sym_predefined_type] = STATE(2659),
    [sym_object_type] = STATE(2659),
    [sym_type_parameters] = STATE(3048),
    [sym_array_type] = STATE(2659),
    [sym__tuple_type_body] = STATE(443),
    [sym_tuple_type] = STATE(2659),
    [sym_union_type] = STATE(2794),
    [sym_intersection_type] = STATE(2794),
    [sym_function_type] = STATE(2794),
    [sym_identifier] = ACTIONS(771),
    [anon_sym_export] = ACTIONS(773),
    [anon_sym_STAR] = ACTIONS(427),
    [anon_sym_EQ] = ACTIONS(1736),
    [anon_sym_namespace] = ACTIONS(773),
    [anon_sym_LBRACE] = ACTIONS(782),
    [anon_sym_COMMA] = ACTIONS(1736),
    [anon_sym_type] = ACTIONS(773),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_LPAREN] = ACTIONS(789),
    [anon_sym_RPAREN] = ACTIONS(1736),
    [anon_sym_COLON] = ACTIONS(1736),
    [anon_sym_LBRACK] = ACTIONS(1651),
    [anon_sym_LT] = ACTIONS(1653),
    [anon_sym_async] = ACTIONS(773),
    [anon_sym_new] = ACTIONS(801),
    [anon_sym_QMARK] = ACTIONS(461),
    [anon_sym_AMP] = ACTIONS(463),
    [anon_sym_PIPE] = ACTIONS(465),
    [anon_sym_PLUS] = ACTIONS(1655),
    [anon_sym_DASH] = ACTIONS(1655),
    [anon_sym_void] = ACTIONS(815),
    [anon_sym_DQUOTE] = ACTIONS(817),
    [anon_sym_SQUOTE] = ACTIONS(819),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(821),
    [sym_this] = ACTIONS(823),
    [sym_true] = ACTIONS(825),
    [sym_false] = ACTIONS(825),
    [anon_sym_static] = ACTIONS(773),
    [anon_sym_get] = ACTIONS(773),
    [anon_sym_set] = ACTIONS(773),
    [anon_sym_declare] = ACTIONS(773),
    [anon_sym_public] = ACTIONS(773),
    [anon_sym_private] = ACTIONS(773),
    [anon_sym_protected] = ACTIONS(773),
    [anon_sym_module] = ACTIONS(773),
    [anon_sym_any] = ACTIONS(827),
    [anon_sym_number] = ACTIONS(827),
    [anon_sym_boolean] = ACTIONS(827),
    [anon_sym_string] = ACTIONS(827),
    [anon_sym_symbol] = ACTIONS(827),
    [sym_readonly] = ACTIONS(829),
    [anon_sym_infer] = ACTIONS(495),
    [anon_sym_keyof] = ACTIONS(497),
    [anon_sym_LBRACE_PIPE] = ACTIONS(499),
  },
  [553] = {
    [ts_builtin_sym_end] = ACTIONS(1063),
    [sym_identifier] = ACTIONS(1065),
    [anon_sym_export] = ACTIONS(1065),
    [anon_sym_default] = ACTIONS(1065),
    [anon_sym_namespace] = ACTIONS(1065),
    [anon_sym_LBRACE] = ACTIONS(1063),
    [anon_sym_RBRACE] = ACTIONS(1063),
    [anon_sym_type] = ACTIONS(1065),
    [anon_sym_typeof] = ACTIONS(1065),
    [anon_sym_import] = ACTIONS(1065),
    [anon_sym_var] = ACTIONS(1065),
    [anon_sym_let] = ACTIONS(1065),
    [anon_sym_const] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1063),
    [anon_sym_else] = ACTIONS(1065),
    [anon_sym_if] = ACTIONS(1065),
    [anon_sym_switch] = ACTIONS(1065),
    [anon_sym_for] = ACTIONS(1065),
    [anon_sym_LPAREN] = ACTIONS(1063),
    [anon_sym_await] = ACTIONS(1065),
    [anon_sym_while] = ACTIONS(1065),
    [anon_sym_do] = ACTIONS(1065),
    [anon_sym_try] = ACTIONS(1065),
    [anon_sym_with] = ACTIONS(1065),
    [anon_sym_break] = ACTIONS(1065),
    [anon_sym_continue] = ACTIONS(1065),
    [anon_sym_debugger] = ACTIONS(1065),
    [anon_sym_return] = ACTIONS(1065),
    [anon_sym_throw] = ACTIONS(1065),
    [anon_sym_SEMI] = ACTIONS(1063),
    [anon_sym_case] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(1065),
    [anon_sym_LBRACK] = ACTIONS(1063),
    [anon_sym_LT] = ACTIONS(1063),
    [anon_sym_SLASH] = ACTIONS(1065),
    [anon_sym_class] = ACTIONS(1065),
    [anon_sym_async] = ACTIONS(1065),
    [anon_sym_function] = ACTIONS(1065),
    [anon_sym_new] = ACTIONS(1065),
    [anon_sym_PLUS] = ACTIONS(1065),
    [anon_sym_DASH] = ACTIONS(1065),
    [anon_sym_TILDE] = ACTIONS(1063),
    [anon_sym_void] = ACTIONS(1065),
    [anon_sym_delete] = ACTIONS(1065),
    [anon_sym_PLUS_PLUS] = ACTIONS(1063),
    [anon_sym_DASH_DASH] = ACTIONS(1063),
    [anon_sym_DQUOTE] = ACTIONS(1063),
    [anon_sym_SQUOTE] = ACTIONS(1063),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1063),
    [sym_number] = ACTIONS(1063),
    [sym_this] = ACTIONS(1065),
    [sym_super] = ACTIONS(1065),
    [sym_true] = ACTIONS(1065),
    [sym_false] = ACTIONS(1065),
    [sym_null] = ACTIONS(1065),
    [sym_undefined] = ACTIONS(1065),
    [anon_sym_AT] = ACTIONS(1063),
    [anon_sym_static] = ACTIONS(1065),
    [anon_sym_abstract] = ACTIONS(1065),
    [anon_sym_get] = ACTIONS(1065),
    [anon_sym_set] = ACTIONS(1065),
    [anon_sym_declare] = ACTIONS(1065),
    [anon_sym_public] = ACTIONS(1065),
    [anon_sym_private] = ACTIONS(1065),
    [anon_sym_protected] = ACTIONS(1065),
    [anon_sym_module] = ACTIONS(1065),
    [anon_sym_any] = ACTIONS(1065),
    [anon_sym_number] = ACTIONS(1065),
    [anon_sym_boolean] = ACTIONS(1065),
    [anon_sym_string] = ACTIONS(1065),
    [anon_sym_symbol] = ACTIONS(1065),
    [anon_sym_interface] = ACTIONS(1065),
    [anon_sym_enum] = ACTIONS(1065),
    [sym_readonly] = ACTIONS(1065),
  },
  [554] = {
    [ts_builtin_sym_end] = ACTIONS(1871),
    [sym_identifier] = ACTIONS(1873),
    [anon_sym_export] = ACTIONS(1873),
    [anon_sym_default] = ACTIONS(1873),
    [anon_sym_namespace] = ACTIONS(1873),
    [anon_sym_LBRACE] = ACTIONS(1871),
    [anon_sym_RBRACE] = ACTIONS(1871),
    [anon_sym_type] = ACTIONS(1873),
    [anon_sym_typeof] = ACTIONS(1873),
    [anon_sym_import] = ACTIONS(1873),
    [anon_sym_var] = ACTIONS(1873),
    [anon_sym_let] = ACTIONS(1873),
    [anon_sym_const] = ACTIONS(1873),
    [anon_sym_BANG] = ACTIONS(1871),
    [anon_sym_else] = ACTIONS(1873),
    [anon_sym_if] = ACTIONS(1873),
    [anon_sym_switch] = ACTIONS(1873),
    [anon_sym_for] = ACTIONS(1873),
    [anon_sym_LPAREN] = ACTIONS(1871),
    [anon_sym_await] = ACTIONS(1873),
    [anon_sym_while] = ACTIONS(1873),
    [anon_sym_do] = ACTIONS(1873),
    [anon_sym_try] = ACTIONS(1873),
    [anon_sym_with] = ACTIONS(1873),
    [anon_sym_break] = ACTIONS(1873),
    [anon_sym_continue] = ACTIONS(1873),
    [anon_sym_debugger] = ACTIONS(1873),
    [anon_sym_return] = ACTIONS(1873),
    [anon_sym_throw] = ACTIONS(1873),
    [anon_sym_SEMI] = ACTIONS(1871),
    [anon_sym_case] = ACTIONS(1873),
    [anon_sym_yield] = ACTIONS(1873),
    [anon_sym_LBRACK] = ACTIONS(1871),
    [anon_sym_LT] = ACTIONS(1871),
    [anon_sym_SLASH] = ACTIONS(1873),
    [anon_sym_class] = ACTIONS(1873),
    [anon_sym_async] = ACTIONS(1873),
    [anon_sym_function] = ACTIONS(1873),
    [anon_sym_new] = ACTIONS(1873),
    [anon_sym_PLUS] = ACTIONS(1873),
    [anon_sym_DASH] = ACTIONS(1873),
    [anon_sym_TILDE] = ACTIONS(1871),
    [anon_sym_void] = ACTIONS(1873),
    [anon_sym_delete] = ACTIONS(1873),
    [anon_sym_PLUS_PLUS] = ACTIONS(1871),
    [anon_sym_DASH_DASH] = ACTIONS(1871),
    [anon_sym_DQUOTE] = ACTIONS(1871),
    [anon_sym_SQUOTE] = ACTIONS(1871),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1871),
    [sym_number] = ACTIONS(1871),
    [sym_this] = ACTIONS(1873),
    [sym_super] = ACTIONS(1873),
    [sym_true] = ACTIONS(1873),
    [sym_false] = ACTIONS(1873),
    [sym_null] = ACTIONS(1873),
    [sym_undefined] = ACTIONS(1873),
    [anon_sym_AT] = ACTIONS(1871),
    [anon_sym_static] = ACTIONS(1873),
    [anon_sym_abstract] = ACTIONS(1873),
    [anon_sym_get] = ACTIONS(1873),
    [anon_sym_set] = ACTIONS(1873),
    [anon_sym_declare] = ACTIONS(1873),
    [anon_sym_public] = ACTIONS(1873),
    [anon_sym_private] = ACTIONS(1873),
    [anon_sym_protected] = ACTIONS(1873),
    [anon_sym_module] = ACTIONS(1873),
    [anon_sym_any] = ACTIONS(1873),
    [anon_sym_number] = ACTIONS(1873),
    [anon_sym_boolean] = ACTIONS(1873),
    [anon_sym_string] = ACTIONS(1873),
    [anon_sym_symbol] = ACTIONS(1873),
    [anon_sym_interface] = ACTIONS(1873),
    [anon_sym_enum] = ACTIONS(1873),
    [sym_readonly] = ACTIONS(1873),
  },
  [555] = {
    [ts_builtin_sym_end] = ACTIONS(1875),
    [sym_identifier] = ACTIONS(1877),
    [anon_sym_export] = ACTIONS(1877),
    [anon_sym_default] = ACTIONS(1877),
    [anon_sym_namespace] = ACTIONS(1877),
    [anon_sym_LBRACE] = ACTIONS(1875),
    [anon_sym_RBRACE] = ACTIONS(1875),
    [anon_sym_type] = ACTIONS(1877),
    [anon_sym_typeof] = ACTIONS(1877),
    [anon_sym_import] = ACTIONS(1877),
    [anon_sym_var] = ACTIONS(1877),
    [anon_sym_let] = ACTIONS(1877),
    [anon_sym_const] = ACTIONS(1877),
    [anon_sym_BANG] = ACTIONS(1875),
    [anon_sym_else] = ACTIONS(1877),
    [anon_sym_if] = ACTIONS(1877),
    [anon_sym_switch] = ACTIONS(1877),
    [anon_sym_for] = ACTIONS(1877),
    [anon_sym_LPAREN] = ACTIONS(1875),
    [anon_sym_await] = ACTIONS(1877),
    [anon_sym_while] = ACTIONS(1877),
    [anon_sym_do] = ACTIONS(1877),
    [anon_sym_try] = ACTIONS(1877),
    [anon_sym_with] = ACTIONS(1877),
    [anon_sym_break] = ACTIONS(1877),
    [anon_sym_continue] = ACTIONS(1877),
    [anon_sym_debugger] = ACTIONS(1877),
    [anon_sym_return] = ACTIONS(1877),
    [anon_sym_throw] = ACTIONS(1877),
    [anon_sym_SEMI] = ACTIONS(1875),
    [anon_sym_case] = ACTIONS(1877),
    [anon_sym_yield] = ACTIONS(1877),
    [anon_sym_LBRACK] = ACTIONS(1875),
    [anon_sym_LT] = ACTIONS(1875),
    [anon_sym_SLASH] = ACTIONS(1877),
    [anon_sym_class] = ACTIONS(1877),
    [anon_sym_async] = ACTIONS(1877),
    [anon_sym_function] = ACTIONS(1877),
    [anon_sym_new] = ACTIONS(1877),
    [anon_sym_PLUS] = ACTIONS(1877),
    [anon_sym_DASH] = ACTIONS(1877),
    [anon_sym_TILDE] = ACTIONS(1875),
    [anon_sym_void] = ACTIONS(1877),
    [anon_sym_delete] = ACTIONS(1877),
    [anon_sym_PLUS_PLUS] = ACTIONS(1875),
    [anon_sym_DASH_DASH] = ACTIONS(1875),
    [anon_sym_DQUOTE] = ACTIONS(1875),
    [anon_sym_SQUOTE] = ACTIONS(1875),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1875),
    [sym_number] = ACTIONS(1875),
    [sym_this] = ACTIONS(1877),
    [sym_super] = ACTIONS(1877),
    [sym_true] = ACTIONS(1877),
    [sym_false] = ACTIONS(1877),
    [sym_null] = ACTIONS(1877),
    [sym_undefined] = ACTIONS(1877),
    [anon_sym_AT] = ACTIONS(1875),
    [anon_sym_static] = ACTIONS(1877),
    [anon_sym_abstract] = ACTIONS(1877),
    [anon_sym_get] = ACTIONS(1877),
    [anon_sym_set] = ACTIONS(1877),
    [anon_sym_declare] = ACTIONS(1877),
    [anon_sym_public] = ACTIONS(1877),
    [anon_sym_private] = ACTIONS(1877),
    [anon_sym_protected] = ACTIONS(1877),
    [anon_sym_module] = ACTIONS(1877),
    [anon_sym_any] = ACTIONS(1877),
    [anon_sym_number] = ACTIONS(1877),
    [anon_sym_boolean] = ACTIONS(1877),
    [anon_sym_string] = ACTIONS(1877),
    [anon_sym_symbol] = ACTIONS(1877),
    [anon_sym_interface] = ACTIONS(1877),
    [anon_sym_enum] = ACTIONS(1877),
    [sym_readonly] = ACTIONS(1877),
  },
  [556] = {
    [ts_builtin_sym_end] = ACTIONS(1879),
    [sym_identifier] = ACTIONS(1881),
    [anon_sym_export] = ACTIONS(1881),
    [anon_sym_default] = ACTIONS(1881),
    [anon_sym_namespace] = ACTIONS(1881),
    [anon_sym_LBRACE] = ACTIONS(1879),
    [anon_sym_RBRACE] = ACTIONS(1879),
    [anon_sym_type] = ACTIONS(1881),
    [anon_sym_typeof] = ACTIONS(1881),
    [anon_sym_import] = ACTIONS(1881),
    [anon_sym_var] = ACTIONS(1881),
    [anon_sym_let] = ACTIONS(1881),
    [anon_sym_const] = ACTIONS(1881),
    [anon_sym_BANG] = ACTIONS(1879),
    [anon_sym_else] = ACTIONS(1881),
    [anon_sym_if] = ACTIONS(1881),
    [anon_sym_switch] = ACTIONS(1881),
    [anon_sym_for] = ACTIONS(1881),
    [anon_sym_LPAREN] = ACTIONS(1879),
    [anon_sym_await] = ACTIONS(1881),
    [anon_sym_while] = ACTIONS(1881),
    [anon_sym_do] = ACTIONS(1881),
    [anon_sym_try] = ACTIONS(1881),
    [anon_sym_with] = ACTIONS(1881),
    [anon_sym_break] = ACTIONS(1881),
    [anon_sym_continue] = ACTIONS(1881),
    [anon_sym_debugger] = ACTIONS(1881),
    [anon_sym_return] = ACTIONS(1881),
    [anon_sym_throw] = ACTIONS(1881),
    [anon_sym_SEMI] = ACTIONS(1879),
    [anon_sym_case] = ACTIONS(1881),
    [anon_sym_yield] = ACTIONS(1881),
    [anon_sym_LBRACK] = ACTIONS(1879),
    [anon_sym_LT] = ACTIONS(1879),
    [anon_sym_SLASH] = ACTIONS(1881),
    [anon_sym_class] = ACTIONS(1881),
    [anon_sym_async] = ACTIONS(1881),
    [anon_sym_function] = ACTIONS(1881),
    [anon_sym_new] = ACTIONS(1881),
    [anon_sym_PLUS] = ACTIONS(1881),
    [anon_sym_DASH] = ACTIONS(1881),
    [anon_sym_TILDE] = ACTIONS(1879),
    [anon_sym_void] = ACTIONS(1881),
    [anon_sym_delete] = ACTIONS(1881),
    [anon_sym_PLUS_PLUS] = ACTIONS(1879),
    [anon_sym_DASH_DASH] = ACTIONS(1879),
    [anon_sym_DQUOTE] = ACTIONS(1879),
    [anon_sym_SQUOTE] = ACTIONS(1879),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1879),
    [sym_number] = ACTIONS(1879),
    [sym_this] = ACTIONS(1881),
    [sym_super] = ACTIONS(1881),
    [sym_true] = ACTIONS(1881),
    [sym_false] = ACTIONS(1881),
    [sym_null] = ACTIONS(1881),
    [sym_undefined] = ACTIONS(1881),
    [anon_sym_AT] = ACTIONS(1879),
    [anon_sym_static] = ACTIONS(1881),
    [anon_sym_abstract] = ACTIONS(1881),
    [anon_sym_get] = ACTIONS(1881),
    [anon_sym_set] = ACTIONS(1881),
    [anon_sym_declare] = ACTIONS(1881),
    [anon_sym_public] = ACTIONS(1881),
    [anon_sym_private] = ACTIONS(1881),
    [anon_sym_protected] = ACTIONS(1881),
    [anon_sym_module] = ACTIONS(1881),
    [anon_sym_any] = ACTIONS(1881),
    [anon_sym_number] = ACTIONS(1881),
    [anon_sym_boolean] = ACTIONS(1881),
    [anon_sym_string] = ACTIONS(1881),
    [anon_sym_symbol] = ACTIONS(1881),
    [anon_sym_interface] = ACTIONS(1881),
    [anon_sym_enum] = ACTIONS(1881),
    [sym_readonly] = ACTIONS(1881),
  },
  [557] = {
    [ts_builtin_sym_end] = ACTIONS(1883),
    [sym_identifier] = ACTIONS(1885),
    [anon_sym_export] = ACTIONS(1885),
    [anon_sym_default] = ACTIONS(1885),
    [anon_sym_namespace] = ACTIONS(1885),
    [anon_sym_LBRACE] = ACTIONS(1883),
    [anon_sym_RBRACE] = ACTIONS(1883),
    [anon_sym_type] = ACTIONS(1885),
    [anon_sym_typeof] = ACTIONS(1885),
    [anon_sym_import] = ACTIONS(1885),
    [anon_sym_var] = ACTIONS(1885),
    [anon_sym_let] = ACTIONS(1885),
    [anon_sym_const] = ACTIONS(1885),
    [anon_sym_BANG] = ACTIONS(1883),
    [anon_sym_else] = ACTIONS(1885),
    [anon_sym_if] = ACTIONS(1885),
    [anon_sym_switch] = ACTIONS(1885),
    [anon_sym_for] = ACTIONS(1885),
    [anon_sym_LPAREN] = ACTIONS(1883),
    [anon_sym_await] = ACTIONS(1885),
    [anon_sym_while] = ACTIONS(1885),
    [anon_sym_do] = ACTIONS(1885),
    [anon_sym_try] = ACTIONS(1885),
    [anon_sym_with] = ACTIONS(1885),
    [anon_sym_break] = ACTIONS(1885),
    [anon_sym_continue] = ACTIONS(1885),
    [anon_sym_debugger] = ACTIONS(1885),
    [anon_sym_return] = ACTIONS(1885),
    [anon_sym_throw] = ACTIONS(1885),
    [anon_sym_SEMI] = ACTIONS(1883),
    [anon_sym_case] = ACTIONS(1885),
    [anon_sym_yield] = ACTIONS(1885),
    [anon_sym_LBRACK] = ACTIONS(1883),
    [anon_sym_LT] = ACTIONS(1883),
    [anon_sym_SLASH] = ACTIONS(1885),
    [anon_sym_class] = ACTIONS(1885),
    [anon_sym_async] = ACTIONS(1885),
    [anon_sym_function] = ACTIONS(1885),
    [anon_sym_new] = ACTIONS(1885),
    [anon_sym_PLUS] = ACTIONS(1885),
    [anon_sym_DASH] = ACTIONS(1885),
    [anon_sym_TILDE] = ACTIONS(1883),
    [anon_sym_void] = ACTIONS(1885),
    [anon_sym_delete] = ACTIONS(1885),
    [anon_sym_PLUS_PLUS] = ACTIONS(1883),
    [anon_sym_DASH_DASH] = ACTIONS(1883),
    [anon_sym_DQUOTE] = ACTIONS(1883),
    [anon_sym_SQUOTE] = ACTIONS(1883),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1883),
    [sym_number] = ACTIONS(1883),
    [sym_this] = ACTIONS(1885),
    [sym_super] = ACTIONS(1885),
    [sym_true] = ACTIONS(1885),
    [sym_false] = ACTIONS(1885),
    [sym_null] = ACTIONS(1885),
    [sym_undefined] = ACTIONS(1885),
    [anon_sym_AT] = ACTIONS(1883),
    [anon_sym_static] = ACTIONS(1885),
    [anon_sym_abstract] = ACTIONS(1885),
    [anon_sym_get] = ACTIONS(1885),
    [anon_sym_set] = ACTIONS(1885),
    [anon_sym_declare] = ACTIONS(1885),
    [anon_sym_public] = ACTIONS(1885),
    [anon_sym_private] = ACTIONS(1885),
    [anon_sym_protected] = ACTIONS(1885),
    [anon_sym_module] = ACTIONS(1885),
    [anon_sym_any] = ACTIONS(1885),
    [anon_sym_number] = ACTIONS(1885),
    [anon_sym_boolean] = ACTIONS(1885),
    [anon_sym_string] = ACTIONS(1885),
    [anon_sym_symbol] = ACTIONS(1885),
    [anon_sym_interface] = ACTIONS(1885),
    [anon_sym_enum] = ACTIONS(1885),
    [sym_readonly] = ACTIONS(1885),
  },
  [558] = {
    [ts_builtin_sym_end] = ACTIONS(1887),
    [sym_identifier] = ACTIONS(1889),
    [anon_sym_export] = ACTIONS(1889),
    [anon_sym_default] = ACTIONS(1889),
    [anon_sym_namespace] = ACTIONS(1889),
    [anon_sym_LBRACE] = ACTIONS(1887),
    [anon_sym_RBRACE] = ACTIONS(1887),
    [anon_sym_type] = ACTIONS(1889),
    [anon_sym_typeof] = ACTIONS(1889),
    [anon_sym_import] = ACTIONS(1889),
    [anon_sym_var] = ACTIONS(1889),
    [anon_sym_let] = ACTIONS(1889),
    [anon_sym_const] = ACTIONS(1889),
    [anon_sym_BANG] = ACTIONS(1887),
    [anon_sym_else] = ACTIONS(1889),
    [anon_sym_if] = ACTIONS(1889),
    [anon_sym_switch] = ACTIONS(1889),
    [anon_sym_for] = ACTIONS(1889),
    [anon_sym_LPAREN] = ACTIONS(1887),
    [anon_sym_await] = ACTIONS(1889),
    [anon_sym_while] = ACTIONS(1889),
    [anon_sym_do] = ACTIONS(1889),
    [anon_sym_try] = ACTIONS(1889),
    [anon_sym_with] = ACTIONS(1889),
    [anon_sym_break] = ACTIONS(1889),
    [anon_sym_continue] = ACTIONS(1889),
    [anon_sym_debugger] = ACTIONS(1889),
    [anon_sym_return] = ACTIONS(1889),
    [anon_sym_throw] = ACTIONS(1889),
    [anon_sym_SEMI] = ACTIONS(1887),
    [anon_sym_case] = ACTIONS(1889),
    [anon_sym_yield] = ACTIONS(1889),
    [anon_sym_LBRACK] = ACTIONS(1887),
    [anon_sym_LT] = ACTIONS(1887),
    [anon_sym_SLASH] = ACTIONS(1889),
    [anon_sym_class] = ACTIONS(1889),
    [anon_sym_async] = ACTIONS(1889),
    [anon_sym_function] = ACTIONS(1889),
    [anon_sym_new] = ACTIONS(1889),
    [anon_sym_PLUS] = ACTIONS(1889),
    [anon_sym_DASH] = ACTIONS(1889),
    [anon_sym_TILDE] = ACTIONS(1887),
    [anon_sym_void] = ACTIONS(1889),
    [anon_sym_delete] = ACTIONS(1889),
    [anon_sym_PLUS_PLUS] = ACTIONS(1887),
    [anon_sym_DASH_DASH] = ACTIONS(1887),
    [anon_sym_DQUOTE] = ACTIONS(1887),
    [anon_sym_SQUOTE] = ACTIONS(1887),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1887),
    [sym_number] = ACTIONS(1887),
    [sym_this] = ACTIONS(1889),
    [sym_super] = ACTIONS(1889),
    [sym_true] = ACTIONS(1889),
    [sym_false] = ACTIONS(1889),
    [sym_null] = ACTIONS(1889),
    [sym_undefined] = ACTIONS(1889),
    [anon_sym_AT] = ACTIONS(1887),
    [anon_sym_static] = ACTIONS(1889),
    [anon_sym_abstract] = ACTIONS(1889),
    [anon_sym_get] = ACTIONS(1889),
    [anon_sym_set] = ACTIONS(1889),
    [anon_sym_declare] = ACTIONS(1889),
    [anon_sym_public] = ACTIONS(1889),
    [anon_sym_private] = ACTIONS(1889),
    [anon_sym_protected] = ACTIONS(1889),
    [anon_sym_module] = ACTIONS(1889),
    [anon_sym_any] = ACTIONS(1889),
    [anon_sym_number] = ACTIONS(1889),
    [anon_sym_boolean] = ACTIONS(1889),
    [anon_sym_string] = ACTIONS(1889),
    [anon_sym_symbol] = ACTIONS(1889),
    [anon_sym_interface] = ACTIONS(1889),
    [anon_sym_enum] = ACTIONS(1889),
    [sym_readonly] = ACTIONS(1889),
  },
  [559] = {
    [ts_builtin_sym_end] = ACTIONS(1891),
    [sym_identifier] = ACTIONS(1893),
    [anon_sym_export] = ACTIONS(1893),
    [anon_sym_default] = ACTIONS(1893),
    [anon_sym_namespace] = ACTIONS(1893),
    [anon_sym_LBRACE] = ACTIONS(1891),
    [anon_sym_RBRACE] = ACTIONS(1891),
    [anon_sym_type] = ACTIONS(1893),
    [anon_sym_typeof] = ACTIONS(1893),
    [anon_sym_import] = ACTIONS(1893),
    [anon_sym_var] = ACTIONS(1893),
    [anon_sym_let] = ACTIONS(1893),
    [anon_sym_const] = ACTIONS(1893),
    [anon_sym_BANG] = ACTIONS(1891),
    [anon_sym_else] = ACTIONS(1893),
    [anon_sym_if] = ACTIONS(1893),
    [anon_sym_switch] = ACTIONS(1893),
    [anon_sym_for] = ACTIONS(1893),
    [anon_sym_LPAREN] = ACTIONS(1891),
    [anon_sym_await] = ACTIONS(1893),
    [anon_sym_while] = ACTIONS(1893),
    [anon_sym_do] = ACTIONS(1893),
    [anon_sym_try] = ACTIONS(1893),
    [anon_sym_with] = ACTIONS(1893),
    [anon_sym_break] = ACTIONS(1893),
    [anon_sym_continue] = ACTIONS(1893),
    [anon_sym_debugger] = ACTIONS(1893),
    [anon_sym_return] = ACTIONS(1893),
    [anon_sym_throw] = ACTIONS(1893),
    [anon_sym_SEMI] = ACTIONS(1891),
    [anon_sym_case] = ACTIONS(1893),
    [anon_sym_yield] = ACTIONS(1893),
    [anon_sym_LBRACK] = ACTIONS(1891),
    [anon_sym_LT] = ACTIONS(1891),
    [anon_sym_SLASH] = ACTIONS(1893),
    [anon_sym_class] = ACTIONS(1893),
    [anon_sym_async] = ACTIONS(1893),
    [anon_sym_function] = ACTIONS(1893),
    [anon_sym_new] = ACTIONS(1893),
    [anon_sym_PLUS] = ACTIONS(1893),
    [anon_sym_DASH] = ACTIONS(1893),
    [anon_sym_TILDE] = ACTIONS(1891),
    [anon_sym_void] = ACTIONS(1893),
    [anon_sym_delete] = ACTIONS(1893),
    [anon_sym_PLUS_PLUS] = ACTIONS(1891),
    [anon_sym_DASH_DASH] = ACTIONS(1891),
    [anon_sym_DQUOTE] = ACTIONS(1891),
    [anon_sym_SQUOTE] = ACTIONS(1891),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1891),
    [sym_number] = ACTIONS(1891),
    [sym_this] = ACTIONS(1893),
    [sym_super] = ACTIONS(1893),
    [sym_true] = ACTIONS(1893),
    [sym_false] = ACTIONS(1893),
    [sym_null] = ACTIONS(1893),
    [sym_undefined] = ACTIONS(1893),
    [anon_sym_AT] = ACTIONS(1891),
    [anon_sym_static] = ACTIONS(1893),
    [anon_sym_abstract] = ACTIONS(1893),
    [anon_sym_get] = ACTIONS(1893),
    [anon_sym_set] = ACTIONS(1893),
    [anon_sym_declare] = ACTIONS(1893),
    [anon_sym_public] = ACTIONS(1893),
    [anon_sym_private] = ACTIONS(1893),
    [anon_sym_protected] = ACTIONS(1893),
    [anon_sym_module] = ACTIONS(1893),
    [anon_sym_any] = ACTIONS(1893),
    [anon_sym_number] = ACTIONS(1893),
    [anon_sym_boolean] = ACTIONS(1893),
    [anon_sym_string] = ACTIONS(1893),
    [anon_sym_symbol] = ACTIONS(1893),
    [anon_sym_interface] = ACTIONS(1893),
    [anon_sym_enum] = ACTIONS(1893),
    [sym_readonly] = ACTIONS(1893),
  },
  [560] = {
    [ts_builtin_sym_end] = ACTIONS(1895),
    [sym_identifier] = ACTIONS(1897),
    [anon_sym_export] = ACTIONS(1897),
    [anon_sym_default] = ACTIONS(1897),
    [anon_sym_namespace] = ACTIONS(1897),
    [anon_sym_LBRACE] = ACTIONS(1895),
    [anon_sym_RBRACE] = ACTIONS(1895),
    [anon_sym_type] = ACTIONS(1897),
    [anon_sym_typeof] = ACTIONS(1897),
    [anon_sym_import] = ACTIONS(1897),
    [anon_sym_var] = ACTIONS(1897),
    [anon_sym_let] = ACTIONS(1897),
    [anon_sym_const] = ACTIONS(1897),
    [anon_sym_BANG] = ACTIONS(1895),
    [anon_sym_else] = ACTIONS(1897),
    [anon_sym_if] = ACTIONS(1897),
    [anon_sym_switch] = ACTIONS(1897),
    [anon_sym_for] = ACTIONS(1897),
    [anon_sym_LPAREN] = ACTIONS(1895),
    [anon_sym_await] = ACTIONS(1897),
    [anon_sym_while] = ACTIONS(1897),
    [anon_sym_do] = ACTIONS(1897),
    [anon_sym_try] = ACTIONS(1897),
    [anon_sym_with] = ACTIONS(1897),
    [anon_sym_break] = ACTIONS(1897),
    [anon_sym_continue] = ACTIONS(1897),
    [anon_sym_debugger] = ACTIONS(1897),
    [anon_sym_return] = ACTIONS(1897),
    [anon_sym_throw] = ACTIONS(1897),
    [anon_sym_SEMI] = ACTIONS(1895),
    [anon_sym_case] = ACTIONS(1897),
    [anon_sym_yield] = ACTIONS(1897),
    [anon_sym_LBRACK] = ACTIONS(1895),
    [anon_sym_LT] = ACTIONS(1895),
    [anon_sym_SLASH] = ACTIONS(1897),
    [anon_sym_class] = ACTIONS(1897),
    [anon_sym_async] = ACTIONS(1897),
    [anon_sym_function] = ACTIONS(1897),
    [anon_sym_new] = ACTIONS(1897),
    [anon_sym_PLUS] = ACTIONS(1897),
    [anon_sym_DASH] = ACTIONS(1897),
    [anon_sym_TILDE] = ACTIONS(1895),
    [anon_sym_void] = ACTIONS(1897),
    [anon_sym_delete] = ACTIONS(1897),
    [anon_sym_PLUS_PLUS] = ACTIONS(1895),
    [anon_sym_DASH_DASH] = ACTIONS(1895),
    [anon_sym_DQUOTE] = ACTIONS(1895),
    [anon_sym_SQUOTE] = ACTIONS(1895),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1895),
    [sym_number] = ACTIONS(1895),
    [sym_this] = ACTIONS(1897),
    [sym_super] = ACTIONS(1897),
    [sym_true] = ACTIONS(1897),
    [sym_false] = ACTIONS(1897),
    [sym_null] = ACTIONS(1897),
    [sym_undefined] = ACTIONS(1897),
    [anon_sym_AT] = ACTIONS(1895),
    [anon_sym_static] = ACTIONS(1897),
    [anon_sym_abstract] = ACTIONS(1897),
    [anon_sym_get] = ACTIONS(1897),
    [anon_sym_set] = ACTIONS(1897),
    [anon_sym_declare] = ACTIONS(1897),
    [anon_sym_public] = ACTIONS(1897),
    [anon_sym_private] = ACTIONS(1897),
    [anon_sym_protected] = ACTIONS(1897),
    [anon_sym_module] = ACTIONS(1897),
    [anon_sym_any] = ACTIONS(1897),
    [anon_sym_number] = ACTIONS(1897),
    [anon_sym_boolean] = ACTIONS(1897),
    [anon_sym_string] = ACTIONS(1897),
    [anon_sym_symbol] = ACTIONS(1897),
    [anon_sym_interface] = ACTIONS(1897),
    [anon_sym_enum] = ACTIONS(1897),
    [sym_readonly] = ACTIONS(1897),
  },
  [561] = {
    [ts_builtin_sym_end] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1093),
    [anon_sym_export] = ACTIONS(1093),
    [anon_sym_default] = ACTIONS(1093),
    [anon_sym_namespace] = ACTIONS(1093),
    [anon_sym_LBRACE] = ACTIONS(1091),
    [anon_sym_RBRACE] = ACTIONS(1091),
    [anon_sym_type] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(1093),
    [anon_sym_import] = ACTIONS(1093),
    [anon_sym_var] = ACTIONS(1093),
    [anon_sym_let] = ACTIONS(1093),
    [anon_sym_const] = ACTIONS(1093),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_else] = ACTIONS(1093),
    [anon_sym_if] = ACTIONS(1093),
    [anon_sym_switch] = ACTIONS(1093),
    [anon_sym_for] = ACTIONS(1093),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_while] = ACTIONS(1093),
    [anon_sym_do] = ACTIONS(1093),
    [anon_sym_try] = ACTIONS(1093),
    [anon_sym_with] = ACTIONS(1093),
    [anon_sym_break] = ACTIONS(1093),
    [anon_sym_continue] = ACTIONS(1093),
    [anon_sym_debugger] = ACTIONS(1093),
    [anon_sym_return] = ACTIONS(1093),
    [anon_sym_throw] = ACTIONS(1093),
    [anon_sym_SEMI] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1093),
    [anon_sym_yield] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1093),
    [anon_sym_class] = ACTIONS(1093),
    [anon_sym_async] = ACTIONS(1093),
    [anon_sym_function] = ACTIONS(1093),
    [anon_sym_new] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1093),
    [anon_sym_DASH] = ACTIONS(1093),
    [anon_sym_TILDE] = ACTIONS(1091),
    [anon_sym_void] = ACTIONS(1093),
    [anon_sym_delete] = ACTIONS(1093),
    [anon_sym_PLUS_PLUS] = ACTIONS(1091),
    [anon_sym_DASH_DASH] = ACTIONS(1091),
    [anon_sym_DQUOTE] = ACTIONS(1091),
    [anon_sym_SQUOTE] = ACTIONS(1091),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1091),
    [sym_number] = ACTIONS(1091),
    [sym_this] = ACTIONS(1093),
    [sym_super] = ACTIONS(1093),
    [sym_true] = ACTIONS(1093),
    [sym_false] = ACTIONS(1093),
    [sym_null] = ACTIONS(1093),
    [sym_undefined] = ACTIONS(1093),
    [anon_sym_AT] = ACTIONS(1091),
    [anon_sym_static] = ACTIONS(1093),
    [anon_sym_abstract] = ACTIONS(1093),
    [anon_sym_get] = ACTIONS(1093),
    [anon_sym_set] = ACTIONS(1093),
    [anon_sym_declare] = ACTIONS(1093),
    [anon_sym_public] = ACTIONS(1093),
    [anon_sym_private] = ACTIONS(1093),
    [anon_sym_protected] = ACTIONS(1093),
    [anon_sym_module] = ACTIONS(1093),
    [anon_sym_any] = ACTIONS(1093),
    [anon_sym_number] = ACTIONS(1093),
    [anon_sym_boolean] = ACTIONS(1093),
    [anon_sym_string] = ACTIONS(1093),
    [anon_sym_symbol] = ACTIONS(1093),
    [anon_sym_interface] = ACTIONS(1093),
    [anon_sym_enum] = ACTIONS(1093),
    [sym_readonly] = ACTIONS(1093),
  },
  [562] = {
    [ts_builtin_sym_end] = ACTIONS(1899),
    [sym_identifier] = ACTIONS(1901),
    [anon_sym_export] = ACTIONS(1901),
    [anon_sym_default] = ACTIONS(1901),
    [anon_sym_namespace] = ACTIONS(1901),
    [anon_sym_LBRACE] = ACTIONS(1899),
    [anon_sym_RBRACE] = ACTIONS(1899),
    [anon_sym_type] = ACTIONS(1901),
    [anon_sym_typeof] = ACTIONS(1901),
    [anon_sym_import] = ACTIONS(1901),
    [anon_sym_var] = ACTIONS(1901),
    [anon_sym_let] = ACTIONS(1901),
    [anon_sym_const] = ACTIONS(1901),
    [anon_sym_BANG] = ACTIONS(1899),
    [anon_sym_else] = ACTIONS(1901),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_switch] = ACTIONS(1901),
    [anon_sym_for] = ACTIONS(1901),
    [anon_sym_LPAREN] = ACTIONS(1899),
    [anon_sym_await] = ACTIONS(1901),
    [anon_sym_while] = ACTIONS(1901),
    [anon_sym_do] = ACTIONS(1901),
    [anon_sym_try] = ACTIONS(1901),
    [anon_sym_with] = ACTIONS(1901),
    [anon_sym_break] = ACTIONS(1901),
    [anon_sym_continue] = ACTIONS(1901),
    [anon_sym_debugger] = ACTIONS(1901),
    [anon_sym_return] = ACTIONS(1901),
    [anon_sym_throw] = ACTIONS(1901),
    [anon_sym_SEMI] = ACTIONS(1899),
    [anon_sym_case] = ACTIONS(1901),
    [anon_sym_yield] = ACTIONS(1901),
    [anon_sym_LBRACK] = ACTIONS(1899),
    [anon_sym_LT] = ACTIONS(1899),
    [anon_sym_SLASH] = ACTIONS(1901),
    [anon_sym_class] = ACTIONS(1901),
    [anon_sym_async] = ACTIONS(1901),
    [anon_sym_function] = ACTIONS(1901),
    [anon_sym_new] = ACTIONS(1901),
    [anon_sym_PLUS] = ACTIONS(1901),
    [anon_sym_DASH] = ACTIONS(1901),
    [anon_sym_TILDE] = ACTIONS(1899),
    [anon_sym_void] = ACTIONS(1901),
    [anon_sym_delete] = ACTIONS(1901),
    [anon_sym_PLUS_PLUS] = ACTIONS(1899),
    [anon_sym_DASH_DASH] = ACTIONS(1899),
    [anon_sym_DQUOTE] = ACTIONS(1899),
    [anon_sym_SQUOTE] = ACTIONS(1899),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1899),
    [sym_number] = ACTIONS(1899),
    [sym_this] = ACTIONS(1901),
    [sym_super] = ACTIONS(1901),
    [sym_true] = ACTIONS(1901),
    [sym_false] = ACTIONS(1901),
    [sym_null] = ACTIONS(1901),
    [sym_undefined] = ACTIONS(1901),
    [anon_sym_AT] = ACTIONS(1899),
    [anon_sym_static] = ACTIONS(1901),
    [anon_sym_abstract] = ACTIONS(1901),
    [anon_sym_get] = ACTIONS(1901),
    [anon_sym_set] = ACTIONS(1901),
    [anon_sym_declare] = ACTIONS(1901),
    [anon_sym_public] = ACTIONS(1901),
    [anon_sym_private] = ACTIONS(1901),
    [anon_sym_protected] = ACTIONS(1901),
    [anon_sym_module] = ACTIONS(1901),
    [anon_sym_any] = ACTIONS(1901),
    [anon_sym_number] = ACTIONS(1901),
    [anon_sym_boolean] = ACTIONS(1901),
    [anon_sym_string] = ACTIONS(1901),
    [anon_sym_symbol] = ACTIONS(1901),
    [anon_sym_interface] = ACTIONS(1901),
    [anon_sym_enum] = ACTIONS(1901),
    [sym_readonly] = ACTIONS(1901),
  },
  [563] = {
    [ts_builtin_sym_end] = ACTIONS(1903),
    [sym_identifier] = ACTIONS(1905),
    [anon_sym_export] = ACTIONS(1905),
    [anon_sym_default] = ACTIONS(1905),
    [anon_sym_namespace] = ACTIONS(1905),
    [anon_sym_LBRACE] = ACTIONS(1903),
    [anon_sym_RBRACE] = ACTIONS(1903),
    [anon_sym_type] = ACTIONS(1905),
    [anon_sym_typeof] = ACTIONS(1905),
    [anon_sym_import] = ACTIONS(1905),
    [anon_sym_var] = ACTIONS(1905),
    [anon_sym_let] = ACTIONS(1905),
    [anon_sym_const] = ACTIONS(1905),
    [anon_sym_BANG] = ACTIONS(1903),
    [anon_sym_else] = ACTIONS(1905),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_switch] = ACTIONS(1905),
    [anon_sym_for] = ACTIONS(1905),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [anon_sym_await] = ACTIONS(1905),
    [anon_sym_while] = ACTIONS(1905),
    [anon_sym_do] = ACTIONS(1905),
    [anon_sym_try] = ACTIONS(1905),
    [anon_sym_with] = ACTIONS(1905),
    [anon_sym_break] = ACTIONS(1905),
    [anon_sym_continue] = ACTIONS(1905),
    [anon_sym_debugger] = ACTIONS(1905),
    [anon_sym_return] = ACTIONS(1905),
    [anon_sym_throw] = ACTIONS(1905),
    [anon_sym_SEMI] = ACTIONS(1903),
    [anon_sym_case] = ACTIONS(1905),
    [anon_sym_yield] = ACTIONS(1905),
    [anon_sym_LBRACK] = ACTIONS(1903),
    [anon_sym_LT] = ACTIONS(1903),
    [anon_sym_SLASH] = ACTIONS(1905),
    [anon_sym_class] = ACTIONS(1905),
    [anon_sym_async] = ACTIONS(1905),
    [anon_sym_function] = ACTIONS(1905),
    [anon_sym_new] = ACTIONS(1905),
    [anon_sym_PLUS] = ACTIONS(1905),
    [anon_sym_DASH] = ACTIONS(1905),
    [anon_sym_TILDE] = ACTIONS(1903),
    [anon_sym_void] = ACTIONS(1905),
    [anon_sym_delete] = ACTIONS(1905),
    [anon_sym_PLUS_PLUS] = ACTIONS(1903),
    [anon_sym_DASH_DASH] = ACTIONS(1903),
    [anon_sym_DQUOTE] = ACTIONS(1903),
    [anon_sym_SQUOTE] = ACTIONS(1903),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1903),
    [sym_number] = ACTIONS(1903),
    [sym_this] = ACTIONS(1905),
    [sym_super] = ACTIONS(1905),
    [sym_true] = ACTIONS(1905),
    [sym_false] = ACTIONS(1905),
    [sym_null] = ACTIONS(1905),
    [sym_undefined] = ACTIONS(1905),
    [anon_sym_AT] = ACTIONS(1903),
    [anon_sym_static] = ACTIONS(1905),
    [anon_sym_abstract] = ACTIONS(1905),
    [anon_sym_get] = ACTIONS(1905),
    [anon_sym_set] = ACTIONS(1905),
    [anon_sym_declare] = ACTIONS(1905),
    [anon_sym_public] = ACTIONS(1905),
    [anon_sym_private] = ACTIONS(1905),
    [anon_sym_protected] = ACTIONS(1905),
    [anon_sym_module] = ACTIONS(1905),
    [anon_sym_any] = ACTIONS(1905),
    [anon_sym_number] = ACTIONS(1905),
    [anon_sym_boolean] = ACTIONS(1905),
    [anon_sym_string] = ACTIONS(1905),
    [anon_sym_symbol] = ACTIONS(1905),
    [anon_sym_interface] = ACTIONS(1905),
    [anon_sym_enum] = ACTIONS(1905),
    [sym_readonly] = ACTIONS(1905),
  },
  [564] = {
    [ts_builtin_sym_end] = ACTIONS(1907),
    [sym_identifier] = ACTIONS(1909),
    [anon_sym_export] = ACTIONS(1909),
    [anon_sym_default] = ACTIONS(1909),
    [anon_sym_namespace] = ACTIONS(1909),
    [anon_sym_LBRACE] = ACTIONS(1907),
    [anon_sym_RBRACE] = ACTIONS(1907),
    [anon_sym_type] = ACTIONS(1909),
    [anon_sym_typeof] = ACTIONS(1909),
    [anon_sym_import] = ACTIONS(1909),
    [anon_sym_var] = ACTIONS(1909),
    [anon_sym_let] = ACTIONS(1909),
    [anon_sym_const] = ACTIONS(1909),
    [anon_sym_BANG] = ACTIONS(1907),
    [anon_sym_else] = ACTIONS(1909),
    [anon_sym_if] = ACTIONS(1909),
    [anon_sym_switch] = ACTIONS(1909),
    [anon_sym_for] = ACTIONS(1909),
    [anon_sym_LPAREN] = ACTIONS(1907),
    [anon_sym_await] = ACTIONS(1909),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_do] = ACTIONS(1909),
    [anon_sym_try] = ACTIONS(1909),
    [anon_sym_with] = ACTIONS(1909),
    [anon_sym_break] = ACTIONS(1909),
    [anon_sym_continue] = ACTIONS(1909),
    [anon_sym_debugger] = ACTIONS(1909),
    [anon_sym_return] = ACTIONS(1909),
    [anon_sym_throw] = ACTIONS(1909),
    [anon_sym_SEMI] = ACTIONS(1907),
    [anon_sym_case] = ACTIONS(1909),
    [anon_sym_yield] = ACTIONS(1909),
    [anon_sym_LBRACK] = ACTIONS(1907),
    [anon_sym_LT] = ACTIONS(1907),
    [anon_sym_SLASH] = ACTIONS(1909),
    [anon_sym_class] = ACTIONS(1909),
    [anon_sym_async] = ACTIONS(1909),
    [anon_sym_function] = ACTIONS(1909),
    [anon_sym_new] = ACTIONS(1909),
    [anon_sym_PLUS] = ACTIONS(1909),
    [anon_sym_DASH] = ACTIONS(1909),
    [anon_sym_TILDE] = ACTIONS(1907),
    [anon_sym_void] = ACTIONS(1909),
    [anon_sym_delete] = ACTIONS(1909),
    [anon_sym_PLUS_PLUS] = ACTIONS(1907),
    [anon_sym_DASH_DASH] = ACTIONS(1907),
    [anon_sym_DQUOTE] = ACTIONS(1907),
    [anon_sym_SQUOTE] = ACTIONS(1907),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1907),
    [sym_number] = ACTIONS(1907),
    [sym_this] = ACTIONS(1909),
    [sym_super] = ACTIONS(1909),
    [sym_true] = ACTIONS(1909),
    [sym_false] = ACTIONS(1909),
    [sym_null] = ACTIONS(1909),
    [sym_undefined] = ACTIONS(1909),
    [anon_sym_AT] = ACTIONS(1907),
    [anon_sym_static] = ACTIONS(1909),
    [anon_sym_abstract] = ACTIONS(1909),
    [anon_sym_get] = ACTIONS(1909),
    [anon_sym_set] = ACTIONS(1909),
    [anon_sym_declare] = ACTIONS(1909),
    [anon_sym_public] = ACTIONS(1909),
    [anon_sym_private] = ACTIONS(1909),
    [anon_sym_protected] = ACTIONS(1909),
    [anon_sym_module] = ACTIONS(1909),
    [anon_sym_any] = ACTIONS(1909),
    [anon_sym_number] = ACTIONS(1909),
    [anon_sym_boolean] = ACTIONS(1909),
    [anon_sym_string] = ACTIONS(1909),
    [anon_sym_symbol] = ACTIONS(1909),
    [anon_sym_interface] = ACTIONS(1909),
    [anon_sym_enum] = ACTIONS(1909),
    [sym_readonly] = ACTIONS(1909),
  },
  [565] = {
    [ts_builtin_sym_end] = ACTIONS(1911),
    [sym_identifier] = ACTIONS(1913),
    [anon_sym_export] = ACTIONS(1913),
    [anon_sym_default] = ACTIONS(1913),
    [anon_sym_namespace] = ACTIONS(1913),
    [anon_sym_LBRACE] = ACTIONS(1911),
    [anon_sym_RBRACE] = ACTIONS(1911),
    [anon_sym_type] = ACTIONS(1913),
    [anon_sym_typeof] = ACTIONS(1913),
    [anon_sym_import] = ACTIONS(1913),
    [anon_sym_var] = ACTIONS(1913),
    [anon_sym_let] = ACTIONS(1913),
    [anon_sym_const] = ACTIONS(1913),
    [anon_sym_BANG] = ACTIONS(1911),
    [anon_sym_else] = ACTIONS(1913),
    [anon_sym_if] = ACTIONS(1913),
    [anon_sym_switch] = ACTIONS(1913),
    [anon_sym_for] = ACTIONS(1913),
    [anon_sym_LPAREN] = ACTIONS(1911),
    [anon_sym_await] = ACTIONS(1913),
    [anon_sym_while] = ACTIONS(1913),
    [anon_sym_do] = ACTIONS(1913),
    [anon_sym_try] = ACTIONS(1913),
    [anon_sym_with] = ACTIONS(1913),
    [anon_sym_break] = ACTIONS(1913),
    [anon_sym_continue] = ACTIONS(1913),
    [anon_sym_debugger] = ACTIONS(1913),
    [anon_sym_return] = ACTIONS(1913),
    [anon_sym_throw] = ACTIONS(1913),
    [anon_sym_SEMI] = ACTIONS(1911),
    [anon_sym_case] = ACTIONS(1913),
    [anon_sym_yield] = ACTIONS(1913),
    [anon_sym_LBRACK] = ACTIONS(1911),
    [anon_sym_LT] = ACTIONS(1911),
    [anon_sym_SLASH] = ACTIONS(1913),
    [anon_sym_class] = ACTIONS(1913),
    [anon_sym_async] = ACTIONS(1913),
    [anon_sym_function] = ACTIONS(1913),
    [anon_sym_new] = ACTIONS(1913),
    [anon_sym_PLUS] = ACTIONS(1913),
    [anon_sym_DASH] = ACTIONS(1913),
    [anon_sym_TILDE] = ACTIONS(1911),
    [anon_sym_void] = ACTIONS(1913),
    [anon_sym_delete] = ACTIONS(1913),
    [anon_sym_PLUS_PLUS] = ACTIONS(1911),
    [anon_sym_DASH_DASH] = ACTIONS(1911),
    [anon_sym_DQUOTE] = ACTIONS(1911),
    [anon_sym_SQUOTE] = ACTIONS(1911),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1911),
    [sym_number] = ACTIONS(1911),
    [sym_this] = ACTIONS(1913),
    [sym_super] = ACTIONS(1913),
    [sym_true] = ACTIONS(1913),
    [sym_false] = ACTIONS(1913),
    [sym_null] = ACTIONS(1913),
    [sym_undefined] = ACTIONS(1913),
    [anon_sym_AT] = ACTIONS(1911),
    [anon_sym_static] = ACTIONS(1913),
    [anon_sym_abstract] = ACTIONS(1913),
    [anon_sym_get] = ACTIONS(1913),
    [anon_sym_set] = ACTIONS(1913),
    [anon_sym_declare] = ACTIONS(1913),
    [anon_sym_public] = ACTIONS(1913),
    [anon_sym_private] = ACTIONS(1913),
    [anon_sym_protected] = ACTIONS(1913),
    [anon_sym_module] = ACTIONS(1913),
    [anon_sym_any] = ACTIONS(1913),
    [anon_sym_number] = ACTIONS(1913),
    [anon_sym_boolean] = ACTIONS(1913),
    [anon_sym_string] = ACTIONS(1913),
    [anon_sym_symbol] = ACTIONS(1913),
    [anon_sym_interface] = ACTIONS(1913),
    [anon_sym_enum] = ACTIONS(1913),
    [sym_readonly] = ACTIONS(1913),
  },
  [566] = {
    [ts_builtin_sym_end] = ACTIONS(1915),
    [sym_identifier] = ACTIONS(1917),
    [anon_sym_export] = ACTIONS(1917),
    [anon_sym_default] = ACTIONS(1917),
    [anon_sym_namespace] = ACTIONS(1917),
    [anon_sym_LBRACE] = ACTIONS(1915),
    [anon_sym_RBRACE] = ACTIONS(1915),
    [anon_sym_type] = ACTIONS(1917),
    [anon_sym_typeof] = ACTIONS(1917),
    [anon_sym_import] = ACTIONS(1917),
    [anon_sym_var] = ACTIONS(1917),
    [anon_sym_let] = ACTIONS(1917),
    [anon_sym_const] = ACTIONS(1917),
    [anon_sym_BANG] = ACTIONS(1915),
    [anon_sym_else] = ACTIONS(1917),
    [anon_sym_if] = ACTIONS(1917),
    [anon_sym_switch] = ACTIONS(1917),
    [anon_sym_for] = ACTIONS(1917),
    [anon_sym_LPAREN] = ACTIONS(1915),
    [anon_sym_await] = ACTIONS(1917),
    [anon_sym_while] = ACTIONS(1917),
    [anon_sym_do] = ACTIONS(1917),
    [anon_sym_try] = ACTIONS(1917),
    [anon_sym_with] = ACTIONS(1917),
    [anon_sym_break] = ACTIONS(1917),
    [anon_sym_continue] = ACTIONS(1917),
    [anon_sym_debugger] = ACTIONS(1917),
    [anon_sym_return] = ACTIONS(1917),
    [anon_sym_throw] = ACTIONS(1917),
    [anon_sym_SEMI] = ACTIONS(1915),
    [anon_sym_case] = ACTIONS(1917),
    [anon_sym_yield] = ACTIONS(1917),
    [anon_sym_LBRACK] = ACTIONS(1915),
    [anon_sym_LT] = ACTIONS(1915),
    [anon_sym_SLASH] = ACTIONS(1917),
    [anon_sym_class] = ACTIONS(1917),
    [anon_sym_async] = ACTIONS(1917),
    [anon_sym_function] = ACTIONS(1917),
    [anon_sym_new] = ACTIONS(1917),
    [anon_sym_PLUS] = ACTIONS(1917),
    [anon_sym_DASH] = ACTIONS(1917),
    [anon_sym_TILDE] = ACTIONS(1915),
    [anon_sym_void] = ACTIONS(1917),
    [anon_sym_delete] = ACTIONS(1917),
    [anon_sym_PLUS_PLUS] = ACTIONS(1915),
    [anon_sym_DASH_DASH] = ACTIONS(1915),
    [anon_sym_DQUOTE] = ACTIONS(1915),
    [anon_sym_SQUOTE] = ACTIONS(1915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1915),
    [sym_number] = ACTIONS(1915),
    [sym_this] = ACTIONS(1917),
    [sym_super] = ACTIONS(1917),
    [sym_true] = ACTIONS(1917),
    [sym_false] = ACTIONS(1917),
    [sym_null] = ACTIONS(1917),
    [sym_undefined] = ACTIONS(1917),
    [anon_sym_AT] = ACTIONS(1915),
    [anon_sym_static] = ACTIONS(1917),
    [anon_sym_abstract] = ACTIONS(1917),
    [anon_sym_get] = ACTIONS(1917),
    [anon_sym_set] = ACTIONS(1917),
    [anon_sym_declare] = ACTIONS(1917),
    [anon_sym_public] = ACTIONS(1917),
    [anon_sym_private] = ACTIONS(1917),
    [anon_sym_protected] = ACTIONS(1917),
    [anon_sym_module] = ACTIONS(1917),
    [anon_sym_any] = ACTIONS(1917),
    [anon_sym_number] = ACTIONS(1917),
    [anon_sym_boolean] = ACTIONS(1917),
    [anon_sym_string] = ACTIONS(1917),
    [anon_sym_symbol] = ACTIONS(1917),
    [anon_sym_interface] = ACTIONS(1917),
    [anon_sym_enum] = ACTIONS(1917),
    [sym_readonly] = ACTIONS(1917),
  },
  [567] = {
    [ts_builtin_sym_end] = ACTIONS(1919),
    [sym_identifier] = ACTIONS(1921),
    [anon_sym_export] = ACTIONS(1921),
    [anon_sym_default] = ACTIONS(1921),
    [anon_sym_namespace] = ACTIONS(1921),
    [anon_sym_LBRACE] = ACTIONS(1919),
    [anon_sym_RBRACE] = ACTIONS(1919),
    [anon_sym_type] = ACTIONS(1921),
    [anon_sym_typeof] = ACTIONS(1921),
    [anon_sym_import] = ACTIONS(1921),
    [anon_sym_var] = ACTIONS(1921),
    [anon_sym_let] = ACTIONS(1921),
    [anon_sym_const] = ACTIONS(1921),
    [anon_sym_BANG] = ACTIONS(1919),
    [anon_sym_else] = ACTIONS(1921),
    [anon_sym_if] = ACTIONS(1921),
    [anon_sym_switch] = ACTIONS(1921),
    [anon_sym_for] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1919),
    [anon_sym_await] = ACTIONS(1921),
    [anon_sym_while] = ACTIONS(1921),
    [anon_sym_do] = ACTIONS(1921),
    [anon_sym_try] = ACTIONS(1921),
    [anon_sym_with] = ACTIONS(1921),
    [anon_sym_break] = ACTIONS(1921),
    [anon_sym_continue] = ACTIONS(1921),
    [anon_sym_debugger] = ACTIONS(1921),
    [anon_sym_return] = ACTIONS(1921),
    [anon_sym_throw] = ACTIONS(1921),
    [anon_sym_SEMI] = ACTIONS(1919),
    [anon_sym_case] = ACTIONS(1921),
    [anon_sym_yield] = ACTIONS(1921),
    [anon_sym_LBRACK] = ACTIONS(1919),
    [anon_sym_LT] = ACTIONS(1919),
    [anon_sym_SLASH] = ACTIONS(1921),
    [anon_sym_class] = ACTIONS(1921),
    [anon_sym_async] = ACTIONS(1921),
    [anon_sym_function] = ACTIONS(1921),
    [anon_sym_new] = ACTIONS(1921),
    [anon_sym_PLUS] = ACTIONS(1921),
    [anon_sym_DASH] = ACTIONS(1921),
    [anon_sym_TILDE] = ACTIONS(1919),
    [anon_sym_void] = ACTIONS(1921),
    [anon_sym_delete] = ACTIONS(1921),
    [anon_sym_PLUS_PLUS] = ACTIONS(1919),
    [anon_sym_DASH_DASH] = ACTIONS(1919),
    [anon_sym_DQUOTE] = ACTIONS(1919),
    [anon_sym_SQUOTE] = ACTIONS(1919),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1919),
    [sym_number] = ACTIONS(1919),
    [sym_this] = ACTIONS(1921),
    [sym_super] = ACTIONS(1921),
    [sym_true] = ACTIONS(1921),
    [sym_false] = ACTIONS(1921),
    [sym_null] = ACTIONS(1921),
    [sym_undefined] = ACTIONS(1921),
    [anon_sym_AT] = ACTIONS(1919),
    [anon_sym_static] = ACTIONS(1921),
    [anon_sym_abstract] = ACTIONS(1921),
    [anon_sym_get] = ACTIONS(1921),
    [anon_sym_set] = ACTIONS(1921),
    [anon_sym_declare] = ACTIONS(1921),
    [anon_sym_public] = ACTIONS(1921),
    [anon_sym_private] = ACTIONS(1921),
    [anon_sym_protected] = ACTIONS(1921),
    [anon_sym_module] = ACTIONS(1921),
    [anon_sym_any] = ACTIONS(1921),
    [anon_sym_number] = ACTIONS(1921),
    [anon_sym_boolean] = ACTIONS(1921),
    [anon_sym_string] = ACTIONS(1921),
    [anon_sym_symbol] = ACTIONS(1921),
    [anon_sym_interface] = ACTIONS(1921),
    [anon_sym_enum] = ACTIONS(1921),
    [sym_readonly] = ACTIONS(1921),
  },
  [568] = {
    [ts_builtin_sym_end] = ACTIONS(1923),
    [sym_identifier] = ACTIONS(1925),
    [anon_sym_export] = ACTIONS(1925),
    [anon_sym_default] = ACTIONS(1925),
    [anon_sym_namespace] = ACTIONS(1925),
    [anon_sym_LBRACE] = ACTIONS(1923),
    [anon_sym_RBRACE] = ACTIONS(1923),
    [anon_sym_type] = ACTIONS(1925),
    [anon_sym_typeof] = ACTIONS(1925),
    [anon_sym_import] = ACTIONS(1925),
    [anon_sym_var] = ACTIONS(1925),
    [anon_sym_let] = ACTIONS(1925),
    [anon_sym_const] = ACTIONS(1925),
    [anon_sym_BANG] = ACTIONS(1923),
    [anon_sym_else] = ACTIONS(1925),
    [anon_sym_if] = ACTIONS(1925),
    [anon_sym_switch] = ACTIONS(1925),
    [anon_sym_for] = ACTIONS(1925),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_await] = ACTIONS(1925),
    [anon_sym_while] = ACTIONS(1925),
    [anon_sym_do] = ACTIONS(1925),
    [anon_sym_try] = ACTIONS(1925),
    [anon_sym_with] = ACTIONS(1925),
    [anon_sym_break] = ACTIONS(1925),
    [anon_sym_continue] = ACTIONS(1925),
    [anon_sym_debugger] = ACTIONS(1925),
    [anon_sym_return] = ACTIONS(1925),
    [anon_sym_throw] = ACTIONS(1925),
    [anon_sym_SEMI] = ACTIONS(1923),
    [anon_sym_case] = ACTIONS(1925),
    [anon_sym_yield] = ACTIONS(1925),
    [anon_sym_LBRACK] = ACTIONS(1923),
    [anon_sym_LT] = ACTIONS(1923),
    [anon_sym_SLASH] = ACTIONS(1925),
    [anon_sym_class] = ACTIONS(1925),
    [anon_sym_async] = ACTIONS(1925),
    [anon_sym_function] = ACTIONS(1925),
    [anon_sym_new] = ACTIONS(1925),
    [anon_sym_PLUS] = ACTIONS(1925),
    [anon_sym_DASH] = ACTIONS(1925),
    [anon_sym_TILDE] = ACTIONS(1923),
    [anon_sym_void] = ACTIONS(1925),
    [anon_sym_delete] = ACTIONS(1925),
    [anon_sym_PLUS_PLUS] = ACTIONS(1923),
    [anon_sym_DASH_DASH] = ACTIONS(1923),
    [anon_sym_DQUOTE] = ACTIONS(1923),
    [anon_sym_SQUOTE] = ACTIONS(1923),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1923),
    [sym_number] = ACTIONS(1923),
    [sym_this] = ACTIONS(1925),
    [sym_super] = ACTIONS(1925),
    [sym_true] = ACTIONS(1925),
    [sym_false] = ACTIONS(1925),
    [sym_null] = ACTIONS(1925),
    [sym_undefined] = ACTIONS(1925),
    [anon_sym_AT] = ACTIONS(1923),
    [anon_sym_static] = ACTIONS(1925),
    [anon_sym_abstract] = ACTIONS(1925),
    [anon_sym_get] = ACTIONS(1925),
    [anon_sym_set] = ACTIONS(1925),
    [anon_sym_declare] = ACTIONS(1925),
    [anon_sym_public] = ACTIONS(1925),
    [anon_sym_private] = ACTIONS(1925),
    [anon_sym_protected] = ACTIONS(1925),
    [anon_sym_module] = ACTIONS(1925),
    [anon_sym_any] = ACTIONS(1925),
    [anon_sym_number] = ACTIONS(1925),
    [anon_sym_boolean] = ACTIONS(1925),
    [anon_sym_string] = ACTIONS(1925),
    [anon_sym_symbol] = ACTIONS(1925),
    [anon_sym_interface] = ACTIONS(1925),
    [anon_sym_enum] = ACTIONS(1925),
    [sym_readonly] = ACTIONS(1925),
  },
  [569] = {
    [ts_builtin_sym_end] = ACTIONS(1927),
    [sym_identifier] = ACTIONS(1929),
    [anon_sym_export] = ACTIONS(1929),
    [anon_sym_default] = ACTIONS(1929),
    [anon_sym_namespace] = ACTIONS(1929),
    [anon_sym_LBRACE] = ACTIONS(1927),
    [anon_sym_RBRACE] = ACTIONS(1927),
    [anon_sym_type] = ACTIONS(1929),
    [anon_sym_typeof] = ACTIONS(1929),
    [anon_sym_import] = ACTIONS(1929),
    [anon_sym_var] = ACTIONS(1929),
    [anon_sym_let] = ACTIONS(1929),
    [anon_sym_const] = ACTIONS(1929),
    [anon_sym_BANG] = ACTIONS(1927),
    [anon_sym_else] = ACTIONS(1929),
    [anon_sym_if] = ACTIONS(1929),
    [anon_sym_switch] = ACTIONS(1929),
    [anon_sym_for] = ACTIONS(1929),
    [anon_sym_LPAREN] = ACTIONS(1927),
    [anon_sym_await] = ACTIONS(1929),
    [anon_sym_while] = ACTIONS(1929),
    [anon_sym_do] = ACTIONS(1929),
    [anon_sym_try] = ACTIONS(1929),
    [anon_sym_with] = ACTIONS(1929),
    [anon_sym_break] = ACTIONS(1929),
    [anon_sym_continue] = ACTIONS(1929),
    [anon_sym_debugger] = ACTIONS(1929),
    [anon_sym_return] = ACTIONS(1929),
    [anon_sym_throw] = ACTIONS(1929),
    [anon_sym_SEMI] = ACTIONS(1927),
    [anon_sym_case] = ACTIONS(1929),
    [anon_sym_yield] = ACTIONS(1929),
    [anon_sym_LBRACK] = ACTIONS(1927),
    [anon_sym_LT] = ACTIONS(1927),
    [anon_sym_SLASH] = ACTIONS(1929),
    [anon_sym_class] = ACTIONS(1929),
    [anon_sym_async] = ACTIONS(1929),
    [anon_sym_function] = ACTIONS(1929),
    [anon_sym_new] = ACTIONS(1929),
    [anon_sym_PLUS] = ACTIONS(1929),
    [anon_sym_DASH] = ACTIONS(1929),
    [anon_sym_TILDE] = ACTIONS(1927),
    [anon_sym_void] = ACTIONS(1929),
    [anon_sym_delete] = ACTIONS(1929),
    [anon_sym_PLUS_PLUS] = ACTIONS(1927),
    [anon_sym_DASH_DASH] = ACTIONS(1927),
    [anon_sym_DQUOTE] = ACTIONS(1927),
    [anon_sym_SQUOTE] = ACTIONS(1927),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1927),
    [sym_number] = ACTIONS(1927),
    [sym_this] = ACTIONS(1929),
    [sym_super] = ACTIONS(1929),
    [sym_true] = ACTIONS(1929),
    [sym_false] = ACTIONS(1929),
    [sym_null] = ACTIONS(1929),
    [sym_undefined] = ACTIONS(1929),
    [anon_sym_AT] = ACTIONS(1927),
    [anon_sym_static] = ACTIONS(1929),
    [anon_sym_abstract] = ACTIONS(1929),
    [anon_sym_get] = ACTIONS(1929),
    [anon_sym_set] = ACTIONS(1929),
    [anon_sym_declare] = ACTIONS(1929),
    [anon_sym_public] = ACTIONS(1929),
    [anon_sym_private] = ACTIONS(1929),
    [anon_sym_protected] = ACTIONS(1929),
    [anon_sym_module] = ACTIONS(1929),
    [anon_sym_any] = ACTIONS(1929),
    [anon_sym_number] = ACTIONS(1929),
    [anon_sym_boolean] = ACTIONS(1929),
    [anon_sym_string] = ACTIONS(1929),
    [anon_sym_symbol] = ACTIONS(1929),
    [anon_sym_interface] = ACTIONS(1929),
    [anon_sym_enum] = ACTIONS(1929),
    [sym_readonly] = ACTIONS(1929),
  },
  [570] = {
    [ts_builtin_sym_end] = ACTIONS(1931),
    [sym_identifier] = ACTIONS(1933),
    [anon_sym_export] = ACTIONS(1933),
    [anon_sym_default] = ACTIONS(1933),
    [anon_sym_namespace] = ACTIONS(1933),
    [anon_sym_LBRACE] = ACTIONS(1931),
    [anon_sym_RBRACE] = ACTIONS(1931),
    [anon_sym_type] = ACTIONS(1933),
    [anon_sym_typeof] = ACTIONS(1933),
    [anon_sym_import] = ACTIONS(1933),
    [anon_sym_var] = ACTIONS(1933),
    [anon_sym_let] = ACTIONS(1933),
    [anon_sym_const] = ACTIONS(1933),
    [anon_sym_BANG] = ACTIONS(1931),
    [anon_sym_else] = ACTIONS(1933),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_switch] = ACTIONS(1933),
    [anon_sym_for] = ACTIONS(1933),
    [anon_sym_LPAREN] = ACTIONS(1931),
    [anon_sym_await] = ACTIONS(1933),
    [anon_sym_while] = ACTIONS(1933),
    [anon_sym_do] = ACTIONS(1933),
    [anon_sym_try] = ACTIONS(1933),
    [anon_sym_with] = ACTIONS(1933),
    [anon_sym_break] = ACTIONS(1933),
    [anon_sym_continue] = ACTIONS(1933),
    [anon_sym_debugger] = ACTIONS(1933),
    [anon_sym_return] = ACTIONS(1933),
    [anon_sym_throw] = ACTIONS(1933),
    [anon_sym_SEMI] = ACTIONS(1931),
    [anon_sym_case] = ACTIONS(1933),
    [anon_sym_yield] = ACTIONS(1933),
    [anon_sym_LBRACK] = ACTIONS(1931),
    [anon_sym_LT] = ACTIONS(1931),
    [anon_sym_SLASH] = ACTIONS(1933),
    [anon_sym_class] = ACTIONS(1933),
    [anon_sym_async] = ACTIONS(1933),
    [anon_sym_function] = ACTIONS(1933),
    [anon_sym_new] = ACTIONS(1933),
    [anon_sym_PLUS] = ACTIONS(1933),
    [anon_sym_DASH] = ACTIONS(1933),
    [anon_sym_TILDE] = ACTIONS(1931),
    [anon_sym_void] = ACTIONS(1933),
    [anon_sym_delete] = ACTIONS(1933),
    [anon_sym_PLUS_PLUS] = ACTIONS(1931),
    [anon_sym_DASH_DASH] = ACTIONS(1931),
    [anon_sym_DQUOTE] = ACTIONS(1931),
    [anon_sym_SQUOTE] = ACTIONS(1931),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1931),
    [sym_number] = ACTIONS(1931),
    [sym_this] = ACTIONS(1933),
    [sym_super] = ACTIONS(1933),
    [sym_true] = ACTIONS(1933),
    [sym_false] = ACTIONS(1933),
    [sym_null] = ACTIONS(1933),
    [sym_undefined] = ACTIONS(1933),
    [anon_sym_AT] = ACTIONS(1931),
    [anon_sym_static] = ACTIONS(1933),
    [anon_sym_abstract] = ACTIONS(1933),
    [anon_sym_get] = ACTIONS(1933),
    [anon_sym_set] = ACTIONS(1933),
    [anon_sym_declare] = ACTIONS(1933),
    [anon_sym_public] = ACTIONS(1933),
    [anon_sym_private] = ACTIONS(1933),
    [anon_sym_protected] = ACTIONS(1933),
    [anon_sym_module] = ACTIONS(1933),
    [anon_sym_any] = ACTIONS(1933),
    [anon_sym_number] = ACTIONS(1933),
    [anon_sym_boolean] = ACTIONS(1933),
    [anon_sym_string] = ACTIONS(1933),
    [anon_sym_symbol] = ACTIONS(1933),
    [anon_sym_interface] = ACTIONS(1933),
    [anon_sym_enum] = ACTIONS(1933),
    [sym_readonly] = ACTIONS(1933),
  },
  [571] = {
    [ts_builtin_sym_end] = ACTIONS(1935),
    [sym_identifier] = ACTIONS(1937),
    [anon_sym_export] = ACTIONS(1937),
    [anon_sym_default] = ACTIONS(1937),
    [anon_sym_namespace] = ACTIONS(1937),
    [anon_sym_LBRACE] = ACTIONS(1935),
    [anon_sym_RBRACE] = ACTIONS(1935),
    [anon_sym_type] = ACTIONS(1937),
    [anon_sym_typeof] = ACTIONS(1937),
    [anon_sym_import] = ACTIONS(1937),
    [anon_sym_var] = ACTIONS(1937),
    [anon_sym_let] = ACTIONS(1937),
    [anon_sym_const] = ACTIONS(1937),
    [anon_sym_BANG] = ACTIONS(1935),
    [anon_sym_else] = ACTIONS(1937),
    [anon_sym_if] = ACTIONS(1937),
    [anon_sym_switch] = ACTIONS(1937),
    [anon_sym_for] = ACTIONS(1937),
    [anon_sym_LPAREN] = ACTIONS(1935),
    [anon_sym_await] = ACTIONS(1937),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_do] = ACTIONS(1937),
    [anon_sym_try] = ACTIONS(1937),
    [anon_sym_with] = ACTIONS(1937),
    [anon_sym_break] = ACTIONS(1937),
    [anon_sym_continue] = ACTIONS(1937),
    [anon_sym_debugger] = ACTIONS(1937),
    [anon_sym_return] = ACTIONS(1937),
    [anon_sym_throw] = ACTIONS(1937),
    [anon_sym_SEMI] = ACTIONS(1935),
    [anon_sym_case] = ACTIONS(1937),
    [anon_sym_yield] = ACTIONS(1937),
    [anon_sym_LBRACK] = ACTIONS(1935),
    [anon_sym_LT] = ACTIONS(1935),
    [anon_sym_SLASH] = ACTIONS(1937),
    [anon_sym_class] = ACTIONS(1937),
    [anon_sym_async] = ACTIONS(1937),
    [anon_sym_function] = ACTIONS(1937),
    [anon_sym_new] = ACTIONS(1937),
    [anon_sym_PLUS] = ACTIONS(1937),
    [anon_sym_DASH] = ACTIONS(1937),
    [anon_sym_TILDE] = ACTIONS(1935),
    [anon_sym_void] = ACTIONS(1937),
    [anon_sym_delete] = ACTIONS(1937),
    [anon_sym_PLUS_PLUS] = ACTIONS(1935),
    [anon_sym_DASH_DASH] = ACTIONS(1935),
    [anon_sym_DQUOTE] = ACTIONS(1935),
    [anon_sym_SQUOTE] = ACTIONS(1935),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1935),
    [sym_number] = ACTIONS(1935),
    [sym_this] = ACTIONS(1937),
    [sym_super] = ACTIONS(1937),
    [sym_true] = ACTIONS(1937),
    [sym_false] = ACTIONS(1937),
    [sym_null] = ACTIONS(1937),
    [sym_undefined] = ACTIONS(1937),
    [anon_sym_AT] = ACTIONS(1935),
    [anon_sym_static] = ACTIONS(1937),
    [anon_sym_abstract] = ACTIONS(1937),
    [anon_sym_get] = ACTIONS(1937),
    [anon_sym_set] = ACTIONS(1937),
    [anon_sym_declare] = ACTIONS(1937),
    [anon_sym_public] = ACTIONS(1937),
    [anon_sym_private] = ACTIONS(1937),
    [anon_sym_protected] = ACTIONS(1937),
    [anon_sym_module] = ACTIONS(1937),
    [anon_sym_any] = ACTIONS(1937),
    [anon_sym_number] = ACTIONS(1937),
    [anon_sym_boolean] = ACTIONS(1937),
    [anon_sym_string] = ACTIONS(1937),
    [anon_sym_symbol] = ACTIONS(1937),
    [anon_sym_interface] = ACTIONS(1937),
    [anon_sym_enum] = ACTIONS(1937),
    [sym_readonly] = ACTIONS(1937),
  },
  [572] = {
    [ts_builtin_sym_end] = ACTIONS(1107),
    [sym_identifier] = ACTIONS(1109),
    [anon_sym_export] = ACTIONS(1109),
    [anon_sym_default] = ACTIONS(1109),
    [anon_sym_namespace] = ACTIONS(1109),
    [anon_sym_LBRACE] = ACTIONS(1107),
    [anon_sym_RBRACE] = ACTIONS(1107),
    [anon_sym_type] = ACTIONS(1109),
    [anon_sym_typeof] = ACTIONS(1109),
    [anon_sym_import] = ACTIONS(1109),
    [anon_sym_var] = ACTIONS(1109),
    [anon_sym_let] = ACTIONS(1109),
    [anon_sym_const] = ACTIONS(1109),
    [anon_sym_BANG] = ACTIONS(1107),
    [anon_sym_else] = ACTIONS(1109),
    [anon_sym_if] = ACTIONS(1109),
    [anon_sym_switch] = ACTIONS(1109),
    [anon_sym_for] = ACTIONS(1109),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1109),
    [anon_sym_while] = ACTIONS(1109),
    [anon_sym_do] = ACTIONS(1109),
    [anon_sym_try] = ACTIONS(1109),
    [anon_sym_with] = ACTIONS(1109),
    [anon_sym_break] = ACTIONS(1109),
    [anon_sym_continue] = ACTIONS(1109),
    [anon_sym_debugger] = ACTIONS(1109),
    [anon_sym_return] = ACTIONS(1109),
    [anon_sym_throw] = ACTIONS(1109),
    [anon_sym_SEMI] = ACTIONS(1107),
    [anon_sym_case] = ACTIONS(1109),
    [anon_sym_yield] = ACTIONS(1109),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(1107),
    [anon_sym_SLASH] = ACTIONS(1109),
    [anon_sym_class] = ACTIONS(1109),
    [anon_sym_async] = ACTIONS(1109),
    [anon_sym_function] = ACTIONS(1109),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_PLUS] = ACTIONS(1109),
    [anon_sym_DASH] = ACTIONS(1109),
    [anon_sym_TILDE] = ACTIONS(1107),
    [anon_sym_void] = ACTIONS(1109),
    [anon_sym_delete] = ACTIONS(1109),
    [anon_sym_PLUS_PLUS] = ACTIONS(1107),
    [anon_sym_DASH_DASH] = ACTIONS(1107),
    [anon_sym_DQUOTE] = ACTIONS(1107),
    [anon_sym_SQUOTE] = ACTIONS(1107),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1107),
    [sym_number] = ACTIONS(1107),
    [sym_this] = ACTIONS(1109),
    [sym_super] = ACTIONS(1109),
    [sym_true] = ACTIONS(1109),
    [sym_false] = ACTIONS(1109),
    [sym_null] = ACTIONS(1109),
    [sym_undefined] = ACTIONS(1109),
    [anon_sym_AT] = ACTIONS(1107),
    [anon_sym_static] = ACTIONS(1109),
    [anon_sym_abstract] = ACTIONS(1109),
    [anon_sym_get] = ACTIONS(1109),
    [anon_sym_set] = ACTIONS(1109),
    [anon_sym_declare] = ACTIONS(1109),
    [anon_sym_public] = ACTIONS(1109),
    [anon_sym_private] = ACTIONS(1109),
    [anon_sym_protected] = ACTIONS(1109),
    [anon_sym_module] = ACTIONS(1109),
    [anon_sym_any] = ACTIONS(1109),
    [anon_sym_number] = ACTIONS(1109),
    [anon_sym_boolean] = ACTIONS(1109),
    [anon_sym_string] = ACTIONS(1109),
    [anon_sym_symbol] = ACTIONS(1109),
    [anon_sym_interface] = ACTIONS(1109),
    [anon_sym_enum] = ACTIONS(1109),
    [sym_readonly] = ACTIONS(1109),
  },
  [573] = {
    [ts_builtin_sym_end] = ACTIONS(1939),
    [sym_identifier] = ACTIONS(1941),
    [anon_sym_export] = ACTIONS(1941),
    [anon_sym_default] = ACTIONS(1941),
    [anon_sym_namespace] = ACTIONS(1941),
    [anon_sym_LBRACE] = ACTIONS(1939),
    [anon_sym_RBRACE] = ACTIONS(1939),
    [anon_sym_type] = ACTIONS(1941),
    [anon_sym_typeof] = ACTIONS(1941),
    [anon_sym_import] = ACTIONS(1941),
    [anon_sym_var] = ACTIONS(1941),
    [anon_sym_let] = ACTIONS(1941),
    [anon_sym_const] = ACTIONS(1941),
    [anon_sym_BANG] = ACTIONS(1939),
    [anon_sym_else] = ACTIONS(1941),
    [anon_sym_if] = ACTIONS(1941),
    [anon_sym_switch] = ACTIONS(1941),
    [anon_sym_for] = ACTIONS(1941),
    [anon_sym_LPAREN] = ACTIONS(1939),
    [anon_sym_await] = ACTIONS(1941),
    [anon_sym_while] = ACTIONS(1941),
    [anon_sym_do] = ACTIONS(1941),
    [anon_sym_try] = ACTIONS(1941),
    [anon_sym_with] = ACTIONS(1941),
    [anon_sym_break] = ACTIONS(1941),
    [anon_sym_continue] = ACTIONS(1941),
    [anon_sym_debugger] = ACTIONS(1941),
    [anon_sym_return] = ACTIONS(1941),
    [anon_sym_throw] = ACTIONS(1941),
    [anon_sym_SEMI] = ACTIONS(1939),
    [anon_sym_case] = ACTIONS(1941),
    [anon_sym_yield] = ACTIONS(1941),
    [anon_sym_LBRACK] = ACTIONS(1939),
    [anon_sym_LT] = ACTIONS(1939),
    [anon_sym_SLASH] = ACTIONS(1941),
    [anon_sym_class] = ACTIONS(1941),
    [anon_sym_async] = ACTIONS(1941),
    [anon_sym_function] = ACTIONS(1941),
    [anon_sym_new] = ACTIONS(1941),
    [anon_sym_PLUS] = ACTIONS(1941),
    [anon_sym_DASH] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(1939),
    [anon_sym_void] = ACTIONS(1941),
    [anon_sym_delete] = ACTIONS(1941),
    [anon_sym_PLUS_PLUS] = ACTIONS(1939),
    [anon_sym_DASH_DASH] = ACTIONS(1939),
    [anon_sym_DQUOTE] = ACTIONS(1939),
    [anon_sym_SQUOTE] = ACTIONS(1939),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1939),
    [sym_number] = ACTIONS(1939),
    [sym_this] = ACTIONS(1941),
    [sym_super] = ACTIONS(1941),
    [sym_true] = ACTIONS(1941),
    [sym_false] = ACTIONS(1941),
    [sym_null] = ACTIONS(1941),
    [sym_undefined] = ACTIONS(1941),
    [anon_sym_AT] = ACTIONS(1939),
    [anon_sym_static] = ACTIONS(1941),
    [anon_sym_abstract] = ACTIONS(1941),
    [anon_sym_get] = ACTIONS(1941),
    [anon_sym_set] = ACTIONS(1941),
    [anon_sym_declare] = ACTIONS(1941),
    [anon_sym_public] = ACTIONS(1941),
    [anon_sym_private] = ACTIONS(1941),
    [anon_sym_protected] = ACTIONS(1941),
    [anon_sym_module] = ACTIONS(1941),
    [anon_sym_any] = ACTIONS(1941),
    [anon_sym_number] = ACTIONS(1941),
    [anon_sym_boolean] = ACTIONS(1941),
    [anon_sym_string] = ACTIONS(1941),
    [anon_sym_symbol] = ACTIONS(1941),
    [anon_sym_interface] = ACTIONS(1941),
    [anon_sym_enum] = ACTIONS(1941),
    [sym_readonly] = ACTIONS(1941),
  },
  [574] = {
    [ts_builtin_sym_end] = ACTIONS(1943),
    [sym_identifier] = ACTIONS(1945),
    [anon_sym_export] = ACTIONS(1945),
    [anon_sym_default] = ACTIONS(1945),
    [anon_sym_namespace] = ACTIONS(1945),
    [anon_sym_LBRACE] = ACTIONS(1943),
    [anon_sym_RBRACE] = ACTIONS(1943),
    [anon_sym_type] = ACTIONS(1945),
    [anon_sym_typeof] = ACTIONS(1945),
    [anon_sym_import] = ACTIONS(1945),
    [anon_sym_var] = ACTIONS(1945),
    [anon_sym_let] = ACTIONS(1945),
    [anon_sym_const] = ACTIONS(1945),
    [anon_sym_BANG] = ACTIONS(1943),
    [anon_sym_else] = ACTIONS(1945),
    [anon_sym_if] = ACTIONS(1945),
    [anon_sym_switch] = ACTIONS(1945),
    [anon_sym_for] = ACTIONS(1945),
    [anon_sym_LPAREN] = ACTIONS(1943),
    [anon_sym_await] = ACTIONS(1945),
    [anon_sym_while] = ACTIONS(1945),
    [anon_sym_do] = ACTIONS(1945),
    [anon_sym_try] = ACTIONS(1945),
    [anon_sym_with] = ACTIONS(1945),
    [anon_sym_break] = ACTIONS(1945),
    [anon_sym_continue] = ACTIONS(1945),
    [anon_sym_debugger] = ACTIONS(1945),
    [anon_sym_return] = ACTIONS(1945),
    [anon_sym_throw] = ACTIONS(1945),
    [anon_sym_SEMI] = ACTIONS(1943),
    [anon_sym_case] = ACTIONS(1945),
    [anon_sym_yield] = ACTIONS(1945),
    [anon_sym_LBRACK] = ACTIONS(1943),
    [anon_sym_LT] = ACTIONS(1943),
    [anon_sym_SLASH] = ACTIONS(1945),
    [anon_sym_class] = ACTIONS(1945),
    [anon_sym_async] = ACTIONS(1945),
    [anon_sym_function] = ACTIONS(1945),
    [anon_sym_new] = ACTIONS(1945),
    [anon_sym_PLUS] = ACTIONS(1945),
    [anon_sym_DASH] = ACTIONS(1945),
    [anon_sym_TILDE] = ACTIONS(1943),
    [anon_sym_void] = ACTIONS(1945),
    [anon_sym_delete] = ACTIONS(1945),
    [anon_sym_PLUS_PLUS] = ACTIONS(1943),
    [anon_sym_DASH_DASH] = ACTIONS(1943),
    [anon_sym_DQUOTE] = ACTIONS(1943),
    [anon_sym_SQUOTE] = ACTIONS(1943),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1943),
    [sym_number] = ACTIONS(1943),
    [sym_this] = ACTIONS(1945),
    [sym_super] = ACTIONS(1945),
    [sym_true] = ACTIONS(1945),
    [sym_false] = ACTIONS(1945),
    [sym_null] = ACTIONS(1945),
    [sym_undefined] = ACTIONS(1945),
    [anon_sym_AT] = ACTIONS(1943),
    [anon_sym_static] = ACTIONS(1945),
    [anon_sym_abstract] = ACTIONS(1945),
    [anon_sym_get] = ACTIONS(1945),
    [anon_sym_set] = ACTIONS(1945),
    [anon_sym_declare] = ACTIONS(1945),
    [anon_sym_public] = ACTIONS(1945),
    [anon_sym_private] = ACTIONS(1945),
    [anon_sym_protected] = ACTIONS(1945),
    [anon_sym_module] = ACTIONS(1945),
    [anon_sym_any] = ACTIONS(1945),
    [anon_sym_number] = ACTIONS(1945),
    [anon_sym_boolean] = ACTIONS(1945),
    [anon_sym_string] = ACTIONS(1945),
    [anon_sym_symbol] = ACTIONS(1945),
    [anon_sym_interface] = ACTIONS(1945),
    [anon_sym_enum] = ACTIONS(1945),
    [sym_readonly] = ACTIONS(1945),
  },
  [575] = {
    [ts_builtin_sym_end] = ACTIONS(1947),
    [sym_identifier] = ACTIONS(1949),
    [anon_sym_export] = ACTIONS(1949),
    [anon_sym_default] = ACTIONS(1949),
    [anon_sym_namespace] = ACTIONS(1949),
    [anon_sym_LBRACE] = ACTIONS(1947),
    [anon_sym_RBRACE] = ACTIONS(1947),
    [anon_sym_type] = ACTIONS(1949),
    [anon_sym_typeof] = ACTIONS(1949),
    [anon_sym_import] = ACTIONS(1949),
    [anon_sym_var] = ACTIONS(1949),
    [anon_sym_let] = ACTIONS(1949),
    [anon_sym_const] = ACTIONS(1949),
    [anon_sym_BANG] = ACTIONS(1947),
    [anon_sym_else] = ACTIONS(1949),
    [anon_sym_if] = ACTIONS(1949),
    [anon_sym_switch] = ACTIONS(1949),
    [anon_sym_for] = ACTIONS(1949),
    [anon_sym_LPAREN] = ACTIONS(1947),
    [anon_sym_await] = ACTIONS(1949),
    [anon_sym_while] = ACTIONS(1949),
    [anon_sym_do] = ACTIONS(1949),
    [anon_sym_try] = ACTIONS(1949),
    [anon_sym_with] = ACTIONS(1949),
    [anon_sym_break] = ACTIONS(1949),
    [anon_sym_continue] = ACTIONS(1949),
    [anon_sym_debugger] = ACTIONS(1949),
    [anon_sym_return] = ACTIONS(1949),
    [anon_sym_throw] = ACTIONS(1949),
    [anon_sym_SEMI] = ACTIONS(1947),
    [anon_sym_case] = ACTIONS(1949),
    [anon_sym_yield] = ACTIONS(1949),
    [anon_sym_LBRACK] = ACTIONS(1947),
    [anon_sym_LT] = ACTIONS(1947),
    [anon_sym_SLASH] = ACTIONS(1949),
    [anon_sym_class] = ACTIONS(1949),
    [anon_sym_async] = ACTIONS(1949),
    [anon_sym_function] = ACTIONS(1949),
    [anon_sym_new] = ACTIONS(1949),
    [anon_sym_PLUS] = ACTIONS(1949),
    [anon_sym_DASH] = ACTIONS(1949),
    [anon_sym_TILDE] = ACTIONS(1947),
    [anon_sym_void] = ACTIONS(1949),
    [anon_sym_delete] = ACTIONS(1949),
    [anon_sym_PLUS_PLUS] = ACTIONS(1947),
    [anon_sym_DASH_DASH] = ACTIONS(1947),
    [anon_sym_DQUOTE] = ACTIONS(1947),
    [anon_sym_SQUOTE] = ACTIONS(1947),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1947),
    [sym_number] = ACTIONS(1947),
    [sym_this] = ACTIONS(1949),
    [sym_super] = ACTIONS(1949),
    [sym_true] = ACTIONS(1949),
    [sym_false] = ACTIONS(1949),
    [sym_null] = ACTIONS(1949),
    [sym_undefined] = ACTIONS(1949),
    [anon_sym_AT] = ACTIONS(1947),
    [anon_sym_static] = ACTIONS(1949),
    [anon_sym_abstract] = ACTIONS(1949),
    [anon_sym_get] = ACTIONS(1949),
    [anon_sym_set] = ACTIONS(1949),
    [anon_sym_declare] = ACTIONS(1949),
    [anon_sym_public] = ACTIONS(1949),
    [anon_sym_private] = ACTIONS(1949),
    [anon_sym_protected] = ACTIONS(1949),
    [anon_sym_module] = ACTIONS(1949),
    [anon_sym_any] = ACTIONS(1949),
    [anon_sym_number] = ACTIONS(1949),
    [anon_sym_boolean] = ACTIONS(1949),
    [anon_sym_string] = ACTIONS(1949),
    [anon_sym_symbol] = ACTIONS(1949),
    [anon_sym_interface] = ACTIONS(1949),
    [anon_sym_enum] = ACTIONS(1949),
    [sym_readonly] = ACTIONS(1949),
  },
  [576] = {
    [ts_builtin_sym_end] = ACTIONS(1951),
    [sym_identifier] = ACTIONS(1953),
    [anon_sym_export] = ACTIONS(1953),
    [anon_sym_default] = ACTIONS(1953),
    [anon_sym_namespace] = ACTIONS(1953),
    [anon_sym_LBRACE] = ACTIONS(1951),
    [anon_sym_RBRACE] = ACTIONS(1951),
    [anon_sym_type] = ACTIONS(1953),
    [anon_sym_typeof] = ACTIONS(1953),
    [anon_sym_import] = ACTIONS(1953),
    [anon_sym_var] = ACTIONS(1953),
    [anon_sym_let] = ACTIONS(1953),
    [anon_sym_const] = ACTIONS(1953),
    [anon_sym_BANG] = ACTIONS(1951),
    [anon_sym_else] = ACTIONS(1953),
    [anon_sym_if] = ACTIONS(1953),
    [anon_sym_switch] = ACTIONS(1953),
    [anon_sym_for] = ACTIONS(1953),
    [anon_sym_LPAREN] = ACTIONS(1951),
    [anon_sym_await] = ACTIONS(1953),
    [anon_sym_while] = ACTIONS(1953),
    [anon_sym_do] = ACTIONS(1953),
    [anon_sym_try] = ACTIONS(1953),
    [anon_sym_with] = ACTIONS(1953),
    [anon_sym_break] = ACTIONS(1953),
    [anon_sym_continue] = ACTIONS(1953),
    [anon_sym_debugger] = ACTIONS(1953),
    [anon_sym_return] = ACTIONS(1953),
    [anon_sym_throw] = ACTIONS(1953),
    [anon_sym_SEMI] = ACTIONS(1951),
    [anon_sym_case] = ACTIONS(1953),
    [anon_sym_yield] = ACTIONS(1953),
    [anon_sym_LBRACK] = ACTIONS(1951),
    [anon_sym_LT] = ACTIONS(1951),
    [anon_sym_SLASH] = ACTIONS(1953),
    [anon_sym_class] = ACTIONS(1953),
    [anon_sym_async] = ACTIONS(1953),
    [anon_sym_function] = ACTIONS(1953),
    [anon_sym_new] = ACTIONS(1953),
    [anon_sym_PLUS] = ACTIONS(1953),
    [anon_sym_DASH] = ACTIONS(1953),
    [anon_sym_TILDE] = ACTIONS(1951),
    [anon_sym_void] = ACTIONS(1953),
    [anon_sym_delete] = ACTIONS(1953),
    [anon_sym_PLUS_PLUS] = ACTIONS(1951),
    [anon_sym_DASH_DASH] = ACTIONS(1951),
    [anon_sym_DQUOTE] = ACTIONS(1951),
    [anon_sym_SQUOTE] = ACTIONS(1951),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1951),
    [sym_number] = ACTIONS(1951),
    [sym_this] = ACTIONS(1953),
    [sym_super] = ACTIONS(1953),
    [sym_true] = ACTIONS(1953),
    [sym_false] = ACTIONS(1953),
    [sym_null] = ACTIONS(1953),
    [sym_undefined] = ACTIONS(1953),
    [anon_sym_AT] = ACTIONS(1951),
    [anon_sym_static] = ACTIONS(1953),
    [anon_sym_abstract] = ACTIONS(1953),
    [anon_sym_get] = ACTIONS(1953),
    [anon_sym_set] = ACTIONS(1953),
    [anon_sym_declare] = ACTIONS(1953),
    [anon_sym_public] = ACTIONS(1953),
    [anon_sym_private] = ACTIONS(1953),
    [anon_sym_protected] = ACTIONS(1953),
    [anon_sym_module] = ACTIONS(1953),
    [anon_sym_any] = ACTIONS(1953),
    [anon_sym_number] = ACTIONS(1953),
    [anon_sym_boolean] = ACTIONS(1953),
    [anon_sym_string] = ACTIONS(1953),
    [anon_sym_symbol] = ACTIONS(1953),
    [anon_sym_interface] = ACTIONS(1953),
    [anon_sym_enum] = ACTIONS(1953),
    [sym_readonly] = ACTIONS(1953),
  },
  [577] = {
    [ts_builtin_sym_end] = ACTIONS(1955),
    [sym_identifier] = ACTIONS(1957),
    [anon_sym_export] = ACTIONS(1957),
    [anon_sym_default] = ACTIONS(1957),
    [anon_sym_namespace] = ACTIONS(1957),
    [anon_sym_LBRACE] = ACTIONS(1955),
    [anon_sym_RBRACE] = ACTIONS(1955),
    [anon_sym_type] = ACTIONS(1957),
    [anon_sym_typeof] = ACTIONS(1957),
    [anon_sym_import] = ACTIONS(1957),
    [anon_sym_var] = ACTIONS(1957),
    [anon_sym_let] = ACTIONS(1957),
    [anon_sym_const] = ACTIONS(1957),
    [anon_sym_BANG] = ACTIONS(1955),
    [anon_sym_else] = ACTIONS(1957),
    [anon_sym_if] = ACTIONS(1957),
    [anon_sym_switch] = ACTIONS(1957),
    [anon_sym_for] = ACTIONS(1957),
    [anon_sym_LPAREN] = ACTIONS(1955),
    [anon_sym_await] = ACTIONS(1957),
    [anon_sym_while] = ACTIONS(1957),
    [anon_sym_do] = ACTIONS(1957),
    [anon_sym_try] = ACTIONS(1957),
    [anon_sym_with] = ACTIONS(1957),
    [anon_sym_break] = ACTIONS(1957),
    [anon_sym_continue] = ACTIONS(1957),
    [anon_sym_debugger] = ACTIONS(1957),
    [anon_sym_return] = ACTIONS(1957),
    [anon_sym_throw] = ACTIONS(1957),
    [anon_sym_SEMI] = ACTIONS(1955),
    [anon_sym_case] = ACTIONS(1957),
    [anon_sym_yield] = ACTIONS(1957),
    [anon_sym_LBRACK] = ACTIONS(1955),
    [anon_sym_LT] = ACTIONS(1955),
    [anon_sym_SLASH] = ACTIONS(1957),
    [anon_sym_class] = ACTIONS(1957),
    [anon_sym_async] = ACTIONS(1957),
    [anon_sym_function] = ACTIONS(1957),
    [anon_sym_new] = ACTIONS(1957),
    [anon_sym_PLUS] = ACTIONS(1957),
    [anon_sym_DASH] = ACTIONS(1957),
    [anon_sym_TILDE] = ACTIONS(1955),
    [anon_sym_void] = ACTIONS(1957),
    [anon_sym_delete] = ACTIONS(1957),
    [anon_sym_PLUS_PLUS] = ACTIONS(1955),
    [anon_sym_DASH_DASH] = ACTIONS(1955),
    [anon_sym_DQUOTE] = ACTIONS(1955),
    [anon_sym_SQUOTE] = ACTIONS(1955),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1955),
    [sym_number] = ACTIONS(1955),
    [sym_this] = ACTIONS(1957),
    [sym_super] = ACTIONS(1957),
    [sym_true] = ACTIONS(1957),
    [sym_false] = ACTIONS(1957),
    [sym_null] = ACTIONS(1957),
    [sym_undefined] = ACTIONS(1957),
    [anon_sym_AT] = ACTIONS(1955),
    [anon_sym_static] = ACTIONS(1957),
    [anon_sym_abstract] = ACTIONS(1957),
    [anon_sym_get] = ACTIONS(1957),
    [anon_sym_set] = ACTIONS(1957),
    [anon_sym_declare] = ACTIONS(1957),
    [anon_sym_public] = ACTIONS(1957),
    [anon_sym_private] = ACTIONS(1957),
    [anon_sym_protected] = ACTIONS(1957),
    [anon_sym_module] = ACTIONS(1957),
    [anon_sym_any] = ACTIONS(1957),
    [anon_sym_number] = ACTIONS(1957),
    [anon_sym_boolean] = ACTIONS(1957),
    [anon_sym_string] = ACTIONS(1957),
    [anon_sym_symbol] = ACTIONS(1957),
    [anon_sym_interface] = ACTIONS(1957),
    [anon_sym_enum] = ACTIONS(1957),
    [sym_readonly] = ACTIONS(1957),
  },
  [578] = {
    [ts_builtin_sym_end] = ACTIONS(1959),
    [sym_identifier] = ACTIONS(1961),
    [anon_sym_export] = ACTIONS(1961),
    [anon_sym_default] = ACTIONS(1961),
    [anon_sym_namespace] = ACTIONS(1961),
    [anon_sym_LBRACE] = ACTIONS(1959),
    [anon_sym_RBRACE] = ACTIONS(1959),
    [anon_sym_type] = ACTIONS(1961),
    [anon_sym_typeof] = ACTIONS(1961),
    [anon_sym_import] = ACTIONS(1961),
    [anon_sym_var] = ACTIONS(1961),
    [anon_sym_let] = ACTIONS(1961),
    [anon_sym_const] = ACTIONS(1961),
    [anon_sym_BANG] = ACTIONS(1959),
    [anon_sym_else] = ACTIONS(1961),
    [anon_sym_if] = ACTIONS(1961),
    [anon_sym_switch] = ACTIONS(1961),
    [anon_sym_for] = ACTIONS(1961),
    [anon_sym_LPAREN] = ACTIONS(1959),
    [anon_sym_await] = ACTIONS(1961),
    [anon_sym_while] = ACTIONS(1961),
    [anon_sym_do] = ACTIONS(1961),
    [anon_sym_try] = ACTIONS(1961),
    [anon_sym_with] = ACTIONS(1961),
    [anon_sym_break] = ACTIONS(1961),
    [anon_sym_continue] = ACTIONS(1961),
    [anon_sym_debugger] = ACTIONS(1961),
    [anon_sym_return] = ACTIONS(1961),
    [anon_sym_throw] = ACTIONS(1961),
    [anon_sym_SEMI] = ACTIONS(1959),
    [anon_sym_case] = ACTIONS(1961),
    [anon_sym_yield] = ACTIONS(1961),
    [anon_sym_LBRACK] = ACTIONS(1959),
    [anon_sym_LT] = ACTIONS(1959),
    [anon_sym_SLASH] = ACTIONS(1961),
    [anon_sym_class] = ACTIONS(1961),
    [anon_sym_async] = ACTIONS(1961),
    [anon_sym_function] = ACTIONS(1961),
    [anon_sym_new] = ACTIONS(1961),
    [anon_sym_PLUS] = ACTIONS(1961),
    [anon_sym_DASH] = ACTIONS(1961),
    [anon_sym_TILDE] = ACTIONS(1959),
    [anon_sym_void] = ACTIONS(1961),
    [anon_sym_delete] = ACTIONS(1961),
    [anon_sym_PLUS_PLUS] = ACTIONS(1959),
    [anon_sym_DASH_DASH] = ACTIONS(1959),
    [anon_sym_DQUOTE] = ACTIONS(1959),
    [anon_sym_SQUOTE] = ACTIONS(1959),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1959),
    [sym_number] = ACTIONS(1959),
    [sym_this] = ACTIONS(1961),
    [sym_super] = ACTIONS(1961),
    [sym_true] = ACTIONS(1961),
    [sym_false] = ACTIONS(1961),
    [sym_null] = ACTIONS(1961),
    [sym_undefined] = ACTIONS(1961),
    [anon_sym_AT] = ACTIONS(1959),
    [anon_sym_static] = ACTIONS(1961),
    [anon_sym_abstract] = ACTIONS(1961),
    [anon_sym_get] = ACTIONS(1961),
    [anon_sym_set] = ACTIONS(1961),
    [anon_sym_declare] = ACTIONS(1961),
    [anon_sym_public] = ACTIONS(1961),
    [anon_sym_private] = ACTIONS(1961),
    [anon_sym_protected] = ACTIONS(1961),
    [anon_sym_module] = ACTIONS(1961),
    [anon_sym_any] = ACTIONS(1961),
    [anon_sym_number] = ACTIONS(1961),
    [anon_sym_boolean] = ACTIONS(1961),
    [anon_sym_string] = ACTIONS(1961),
    [anon_sym_symbol] = ACTIONS(1961),
    [anon_sym_interface] = ACTIONS(1961),
    [anon_sym_enum] = ACTIONS(1961),
    [sym_readonly] = ACTIONS(1961),
  },
  [579] = {
    [ts_builtin_sym_end] = ACTIONS(1963),
    [sym_identifier] = ACTIONS(1965),
    [anon_sym_export] = ACTIONS(1965),
    [anon_sym_default] = ACTIONS(1965),
    [anon_sym_namespace] = ACTIONS(1965),
    [anon_sym_LBRACE] = ACTIONS(1963),
    [anon_sym_RBRACE] = ACTIONS(1963),
    [anon_sym_type] = ACTIONS(1965),
    [anon_sym_typeof] = ACTIONS(1965),
    [anon_sym_import] = ACTIONS(1965),
    [anon_sym_var] = ACTIONS(1965),
    [anon_sym_let] = ACTIONS(1965),
    [anon_sym_const] = ACTIONS(1965),
    [anon_sym_BANG] = ACTIONS(1963),
    [anon_sym_else] = ACTIONS(1965),
    [anon_sym_if] = ACTIONS(1965),
    [anon_sym_switch] = ACTIONS(1965),
    [anon_sym_for] = ACTIONS(1965),
    [anon_sym_LPAREN] = ACTIONS(1963),
    [anon_sym_await] = ACTIONS(1965),
    [anon_sym_while] = ACTIONS(1965),
    [anon_sym_do] = ACTIONS(1965),
    [anon_sym_try] = ACTIONS(1965),
    [anon_sym_with] = ACTIONS(1965),
    [anon_sym_break] = ACTIONS(1965),
    [anon_sym_continue] = ACTIONS(1965),
    [anon_sym_debugger] = ACTIONS(1965),
    [anon_sym_return] = ACTIONS(1965),
    [anon_sym_throw] = ACTIONS(1965),
    [anon_sym_SEMI] = ACTIONS(1963),
    [anon_sym_case] = ACTIONS(1965),
    [anon_sym_yield] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1963),
    [anon_sym_LT] = ACTIONS(1963),
    [anon_sym_SLASH] = ACTIONS(1965),
    [anon_sym_class] = ACTIONS(1965),
    [anon_sym_async] = ACTIONS(1965),
    [anon_sym_function] = ACTIONS(1965),
    [anon_sym_new] = ACTIONS(1965),
    [anon_sym_PLUS] = ACTIONS(1965),
    [anon_sym_DASH] = ACTIONS(1965),
    [anon_sym_TILDE] = ACTIONS(1963),
    [anon_sym_void] = ACTIONS(1965),
    [anon_sym_delete] = ACTIONS(1965),
    [anon_sym_PLUS_PLUS] = ACTIONS(1963),
    [anon_sym_DASH_DASH] = ACTIONS(1963),
    [anon_sym_DQUOTE] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1963),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1963),
    [sym_number] = ACTIONS(1963),
    [sym_this] = ACTIONS(1965),
    [sym_super] = ACTIONS(1965),
    [sym_true] = ACTIONS(1965),
    [sym_false] = ACTIONS(1965),
    [sym_null] = ACTIONS(1965),
    [sym_undefined] = ACTIONS(1965),
    [anon_sym_AT] = ACTIONS(1963),
    [anon_sym_static] = ACTIONS(1965),
    [anon_sym_abstract] = ACTIONS(1965),
    [anon_sym_get] = ACTIONS(1965),
    [anon_sym_set] = ACTIONS(1965),
    [anon_sym_declare] = ACTIONS(1965),
    [anon_sym_public] = ACTIONS(1965),
    [anon_sym_private] = ACTIONS(1965),
    [anon_sym_protected] = ACTIONS(1965),
    [anon_sym_module] = ACTIONS(1965),
    [anon_sym_any] = ACTIONS(1965),
    [anon_sym_number] = ACTIONS(1965),
    [anon_sym_boolean] = ACTIONS(1965),
    [anon_sym_string] = ACTIONS(1965),
    [anon_sym_symbol] = ACTIONS(1965),
    [anon_sym_interface] = ACTIONS(1965),
    [anon_sym_enum] = ACTIONS(1965),
    [sym_readonly] = ACTIONS(1965),
  },
  [580] = {
    [ts_builtin_sym_end] = ACTIONS(1967),
    [sym_identifier] = ACTIONS(1969),
    [anon_sym_export] = ACTIONS(1969),
    [anon_sym_default] = ACTIONS(1969),
    [anon_sym_namespace] = ACTIONS(1969),
    [anon_sym_LBRACE] = ACTIONS(1967),
    [anon_sym_RBRACE] = ACTIONS(1967),
    [anon_sym_type] = ACTIONS(1969),
    [anon_sym_typeof] = ACTIONS(1969),
    [anon_sym_import] = ACTIONS(1969),
    [anon_sym_var] = ACTIONS(1969),
    [anon_sym_let] = ACTIONS(1969),
    [anon_sym_const] = ACTIONS(1969),
    [anon_sym_BANG] = ACTIONS(1967),
    [anon_sym_else] = ACTIONS(1969),
    [anon_sym_if] = ACTIONS(1969),
    [anon_sym_switch] = ACTIONS(1969),
    [anon_sym_for] = ACTIONS(1969),
    [anon_sym_LPAREN] = ACTIONS(1967),
    [anon_sym_await] = ACTIONS(1969),
    [anon_sym_while] = ACTIONS(1969),
    [anon_sym_do] = ACTIONS(1969),
    [anon_sym_try] = ACTIONS(1969),
    [anon_sym_with] = ACTIONS(1969),
    [anon_sym_break] = ACTIONS(1969),
    [anon_sym_continue] = ACTIONS(1969),
    [anon_sym_debugger] = ACTIONS(1969),
    [anon_sym_return] = ACTIONS(1969),
    [anon_sym_throw] = ACTIONS(1969),
    [anon_sym_SEMI] = ACTIONS(1967),
    [anon_sym_case] = ACTIONS(1969),
    [anon_sym_yield] = ACTIONS(1969),
    [anon_sym_LBRACK] = ACTIONS(1967),
    [anon_sym_LT] = ACTIONS(1967),
    [anon_sym_SLASH] = ACTIONS(1969),
    [anon_sym_class] = ACTIONS(1969),
    [anon_sym_async] = ACTIONS(1969),
    [anon_sym_function] = ACTIONS(1969),
    [anon_sym_new] = ACTIONS(1969),
    [anon_sym_PLUS] = ACTIONS(1969),
    [anon_sym_DASH] = ACTIONS(1969),
    [anon_sym_TILDE] = ACTIONS(1967),
    [anon_sym_void] = ACTIONS(1969),
    [anon_sym_delete] = ACTIONS(1969),
    [anon_sym_PLUS_PLUS] = ACTIONS(1967),
    [anon_sym_DASH_DASH] = ACTIONS(1967),
    [anon_sym_DQUOTE] = ACTIONS(1967),
    [anon_sym_SQUOTE] = ACTIONS(1967),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1967),
    [sym_number] = ACTIONS(1967),
    [sym_this] = ACTIONS(1969),
    [sym_super] = ACTIONS(1969),
    [sym_true] = ACTIONS(1969),
    [sym_false] = ACTIONS(1969),
    [sym_null] = ACTIONS(1969),
    [sym_undefined] = ACTIONS(1969),
    [anon_sym_AT] = ACTIONS(1967),
    [anon_sym_static] = ACTIONS(1969),
    [anon_sym_abstract] = ACTIONS(1969),
    [anon_sym_get] = ACTIONS(1969),
    [anon_sym_set] = ACTIONS(1969),
    [anon_sym_declare] = ACTIONS(1969),
    [anon_sym_public] = ACTIONS(1969),
    [anon_sym_private] = ACTIONS(1969),
    [anon_sym_protected] = ACTIONS(1969),
    [anon_sym_module] = ACTIONS(1969),
    [anon_sym_any] = ACTIONS(1969),
    [anon_sym_number] = ACTIONS(1969),
    [anon_sym_boolean] = ACTIONS(1969),
    [anon_sym_string] = ACTIONS(1969),
    [anon_sym_symbol] = ACTIONS(1969),
    [anon_sym_interface] = ACTIONS(1969),
    [anon_sym_enum] = ACTIONS(1969),
    [sym_readonly] = ACTIONS(1969),
  },
  [581] = {
    [ts_builtin_sym_end] = ACTIONS(1971),
    [sym_identifier] = ACTIONS(1973),
    [anon_sym_export] = ACTIONS(1973),
    [anon_sym_default] = ACTIONS(1973),
    [anon_sym_namespace] = ACTIONS(1973),
    [anon_sym_LBRACE] = ACTIONS(1971),
    [anon_sym_RBRACE] = ACTIONS(1971),
    [anon_sym_type] = ACTIONS(1973),
    [anon_sym_typeof] = ACTIONS(1973),
    [anon_sym_import] = ACTIONS(1973),
    [anon_sym_var] = ACTIONS(1973),
    [anon_sym_let] = ACTIONS(1973),
    [anon_sym_const] = ACTIONS(1973),
    [anon_sym_BANG] = ACTIONS(1971),
    [anon_sym_else] = ACTIONS(1973),
    [anon_sym_if] = ACTIONS(1973),
    [anon_sym_switch] = ACTIONS(1973),
    [anon_sym_for] = ACTIONS(1973),
    [anon_sym_LPAREN] = ACTIONS(1971),
    [anon_sym_await] = ACTIONS(1973),
    [anon_sym_while] = ACTIONS(1973),
    [anon_sym_do] = ACTIONS(1973),
    [anon_sym_try] = ACTIONS(1973),
    [anon_sym_with] = ACTIONS(1973),
    [anon_sym_break] = ACTIONS(1973),
    [anon_sym_continue] = ACTIONS(1973),
    [anon_sym_debugger] = ACTIONS(1973),
    [anon_sym_return] = ACTIONS(1973),
    [anon_sym_throw] = ACTIONS(1973),
    [anon_sym_SEMI] = ACTIONS(1971),
    [anon_sym_case] = ACTIONS(1973),
    [anon_sym_yield] = ACTIONS(1973),
    [anon_sym_LBRACK] = ACTIONS(1971),
    [anon_sym_LT] = ACTIONS(1971),
    [anon_sym_SLASH] = ACTIONS(1973),
    [anon_sym_class] = ACTIONS(1973),
    [anon_sym_async] = ACTIONS(1973),
    [anon_sym_function] = ACTIONS(1973),
    [anon_sym_new] = ACTIONS(1973),
    [anon_sym_PLUS] = ACTIONS(1973),
    [anon_sym_DASH] = ACTIONS(1973),
    [anon_sym_TILDE] = ACTIONS(1971),
    [anon_sym_void] = ACTIONS(1973),
    [anon_sym_delete] = ACTIONS(1973),
    [anon_sym_PLUS_PLUS] = ACTIONS(1971),
    [anon_sym_DASH_DASH] = ACTIONS(1971),
    [anon_sym_DQUOTE] = ACTIONS(1971),
    [anon_sym_SQUOTE] = ACTIONS(1971),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1971),
    [sym_number] = ACTIONS(1971),
    [sym_this] = ACTIONS(1973),
    [sym_super] = ACTIONS(1973),
    [sym_true] = ACTIONS(1973),
    [sym_false] = ACTIONS(1973),
    [sym_null] = ACTIONS(1973),
    [sym_undefined] = ACTIONS(1973),
    [anon_sym_AT] = ACTIONS(1971),
    [anon_sym_static] = ACTIONS(1973),
    [anon_sym_abstract] = ACTIONS(1973),
    [anon_sym_get] = ACTIONS(1973),
    [anon_sym_set] = ACTIONS(1973),
    [anon_sym_declare] = ACTIONS(1973),
    [anon_sym_public] = ACTIONS(1973),
    [anon_sym_private] = ACTIONS(1973),
    [anon_sym_protected] = ACTIONS(1973),
    [anon_sym_module] = ACTIONS(1973),
    [anon_sym_any] = ACTIONS(1973),
    [anon_sym_number] = ACTIONS(1973),
    [anon_sym_boolean] = ACTIONS(1973),
    [anon_sym_string] = ACTIONS(1973),
    [anon_sym_symbol] = ACTIONS(1973),
    [anon_sym_interface] = ACTIONS(1973),
    [anon_sym_enum] = ACTIONS(1973),
    [sym_readonly] = ACTIONS(1973),
  },
  [582] = {
    [ts_builtin_sym_end] = ACTIONS(1975),
    [sym_identifier] = ACTIONS(1977),
    [anon_sym_export] = ACTIONS(1977),
    [anon_sym_default] = ACTIONS(1977),
    [anon_sym_namespace] = ACTIONS(1977),
    [anon_sym_LBRACE] = ACTIONS(1975),
    [anon_sym_RBRACE] = ACTIONS(1975),
    [anon_sym_type] = ACTIONS(1977),
    [anon_sym_typeof] = ACTIONS(1977),
    [anon_sym_import] = ACTIONS(1977),
    [anon_sym_var] = ACTIONS(1977),
    [anon_sym_let] = ACTIONS(1977),
    [anon_sym_const] = ACTIONS(1977),
    [anon_sym_BANG] = ACTIONS(1975),
    [anon_sym_else] = ACTIONS(1977),
    [anon_sym_if] = ACTIONS(1977),
    [anon_sym_switch] = ACTIONS(1977),
    [anon_sym_for] = ACTIONS(1977),
    [anon_sym_LPAREN] = ACTIONS(1975),
    [anon_sym_await] = ACTIONS(1977),
    [anon_sym_while] = ACTIONS(1977),
    [anon_sym_do] = ACTIONS(1977),
    [anon_sym_try] = ACTIONS(1977),
    [anon_sym_with] = ACTIONS(1977),
    [anon_sym_break] = ACTIONS(1977),
    [anon_sym_continue] = ACTIONS(1977),
    [anon_sym_debugger] = ACTIONS(1977),
    [anon_sym_return] = ACTIONS(1977),
    [anon_sym_throw] = ACTIONS(1977),
    [anon_sym_SEMI] = ACTIONS(1975),
    [anon_sym_case] = ACTIONS(1977),
    [anon_sym_yield] = ACTIONS(1977),
    [anon_sym_LBRACK] = ACTIONS(1975),
    [anon_sym_LT] = ACTIONS(1975),
    [anon_sym_SLASH] = ACTIONS(1977),
    [anon_sym_class] = ACTIONS(1977),
    [anon_sym_async] = ACTIONS(1977),
    [anon_sym_function] = ACTIONS(1977),
    [anon_sym_new] = ACTIONS(1977),
    [anon_sym_PLUS] = ACTIONS(1977),
    [anon_sym_DASH] = ACTIONS(1977),
    [anon_sym_TILDE] = ACTIONS(1975),
    [anon_sym_void] = ACTIONS(1977),
    [anon_sym_delete] = ACTIONS(1977),
    [anon_sym_PLUS_PLUS] = ACTIONS(1975),
    [anon_sym_DASH_DASH] = ACTIONS(1975),
    [anon_sym_DQUOTE] = ACTIONS(1975),
    [anon_sym_SQUOTE] = ACTIONS(1975),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1975),
    [sym_number] = ACTIONS(1975),
    [sym_this] = ACTIONS(1977),
    [sym_super] = ACTIONS(1977),
    [sym_true] = ACTIONS(1977),
    [sym_false] = ACTIONS(1977),
    [sym_null] = ACTIONS(1977),
    [sym_undefined] = ACTIONS(1977),
    [anon_sym_AT] = ACTIONS(1975),
    [anon_sym_static] = ACTIONS(1977),
    [anon_sym_abstract] = ACTIONS(1977),
    [anon_sym_get] = ACTIONS(1977),
    [anon_sym_set] = ACTIONS(1977),
    [anon_sym_declare] = ACTIONS(1977),
    [anon_sym_public] = ACTIONS(1977),
    [anon_sym_private] = ACTIONS(1977),
    [anon_sym_protected] = ACTIONS(1977),
    [anon_sym_module] = ACTIONS(1977),
    [anon_sym_any] = ACTIONS(1977),
    [anon_sym_number] = ACTIONS(1977),
    [anon_sym_boolean] = ACTIONS(1977),
    [anon_sym_string] = ACTIONS(1977),
    [anon_sym_symbol] = ACTIONS(1977),
    [anon_sym_interface] = ACTIONS(1977),
    [anon_sym_enum] = ACTIONS(1977),
    [sym_readonly] = ACTIONS(1977),
  },
  [583] = {
    [ts_builtin_sym_end] = ACTIONS(1979),
    [sym_identifier] = ACTIONS(1981),
    [anon_sym_export] = ACTIONS(1981),
    [anon_sym_default] = ACTIONS(1981),
    [anon_sym_namespace] = ACTIONS(1981),
    [anon_sym_LBRACE] = ACTIONS(1979),
    [anon_sym_RBRACE] = ACTIONS(1979),
    [anon_sym_type] = ACTIONS(1981),
    [anon_sym_typeof] = ACTIONS(1981),
    [anon_sym_import] = ACTIONS(1981),
    [anon_sym_var] = ACTIONS(1981),
    [anon_sym_let] = ACTIONS(1981),
    [anon_sym_const] = ACTIONS(1981),
    [anon_sym_BANG] = ACTIONS(1979),
    [anon_sym_else] = ACTIONS(1981),
    [anon_sym_if] = ACTIONS(1981),
    [anon_sym_switch] = ACTIONS(1981),
    [anon_sym_for] = ACTIONS(1981),
    [anon_sym_LPAREN] = ACTIONS(1979),
    [anon_sym_await] = ACTIONS(1981),
    [anon_sym_while] = ACTIONS(1981),
    [anon_sym_do] = ACTIONS(1981),
    [anon_sym_try] = ACTIONS(1981),
    [anon_sym_with] = ACTIONS(1981),
    [anon_sym_break] = ACTIONS(1981),
    [anon_sym_continue] = ACTIONS(1981),
    [anon_sym_debugger] = ACTIONS(1981),
    [anon_sym_return] = ACTIONS(1981),
    [anon_sym_throw] = ACTIONS(1981),
    [anon_sym_SEMI] = ACTIONS(1979),
    [anon_sym_case] = ACTIONS(1981),
    [anon_sym_yield] = ACTIONS(1981),
    [anon_sym_LBRACK] = ACTIONS(1979),
    [anon_sym_LT] = ACTIONS(1979),
    [anon_sym_SLASH] = ACTIONS(1981),
    [anon_sym_class] = ACTIONS(1981),
    [anon_sym_async] = ACTIONS(1981),
    [anon_sym_function] = ACTIONS(1981),
    [anon_sym_new] = ACTIONS(1981),
    [anon_sym_PLUS] = ACTIONS(1981),
    [anon_sym_DASH] = ACTIONS(1981),
    [anon_sym_TILDE] = ACTIONS(1979),
    [anon_sym_void] = ACTIONS(1981),
    [anon_sym_delete] = ACTIONS(1981),
    [anon_sym_PLUS_PLUS] = ACTIONS(1979),
    [anon_sym_DASH_DASH] = ACTIONS(1979),
    [anon_sym_DQUOTE] = ACTIONS(1979),
    [anon_sym_SQUOTE] = ACTIONS(1979),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1979),
    [sym_number] = ACTIONS(1979),
    [sym_this] = ACTIONS(1981),
    [sym_super] = ACTIONS(1981),
    [sym_true] = ACTIONS(1981),
    [sym_false] = ACTIONS(1981),
    [sym_null] = ACTIONS(1981),
    [sym_undefined] = ACTIONS(1981),
    [anon_sym_AT] = ACTIONS(1979),
    [anon_sym_static] = ACTIONS(1981),
    [anon_sym_abstract] = ACTIONS(1981),
    [anon_sym_get] = ACTIONS(1981),
    [anon_sym_set] = ACTIONS(1981),
    [anon_sym_declare] = ACTIONS(1981),
    [anon_sym_public] = ACTIONS(1981),
    [anon_sym_private] = ACTIONS(1981),
    [anon_sym_protected] = ACTIONS(1981),
    [anon_sym_module] = ACTIONS(1981),
    [anon_sym_any] = ACTIONS(1981),
    [anon_sym_number] = ACTIONS(1981),
    [anon_sym_boolean] = ACTIONS(1981),
    [anon_sym_string] = ACTIONS(1981),
    [anon_sym_symbol] = ACTIONS(1981),
    [anon_sym_interface] = ACTIONS(1981),
    [anon_sym_enum] = ACTIONS(1981),
    [sym_readonly] = ACTIONS(1981),
  },
  [584] = {
    [ts_builtin_sym_end] = ACTIONS(1983),
    [sym_identifier] = ACTIONS(1985),
    [anon_sym_export] = ACTIONS(1985),
    [anon_sym_default] = ACTIONS(1985),
    [anon_sym_namespace] = ACTIONS(1985),
    [anon_sym_LBRACE] = ACTIONS(1983),
    [anon_sym_RBRACE] = ACTIONS(1983),
    [anon_sym_type] = ACTIONS(1985),
    [anon_sym_typeof] = ACTIONS(1985),
    [anon_sym_import] = ACTIONS(1985),
    [anon_sym_var] = ACTIONS(1985),
    [anon_sym_let] = ACTIONS(1985),
    [anon_sym_const] = ACTIONS(1985),
    [anon_sym_BANG] = ACTIONS(1983),
    [anon_sym_else] = ACTIONS(1985),
    [anon_sym_if] = ACTIONS(1985),
    [anon_sym_switch] = ACTIONS(1985),
    [anon_sym_for] = ACTIONS(1985),
    [anon_sym_LPAREN] = ACTIONS(1983),
    [anon_sym_await] = ACTIONS(1985),
    [anon_sym_while] = ACTIONS(1985),
    [anon_sym_do] = ACTIONS(1985),
    [anon_sym_try] = ACTIONS(1985),
    [anon_sym_with] = ACTIONS(1985),
    [anon_sym_break] = ACTIONS(1985),
    [anon_sym_continue] = ACTIONS(1985),
    [anon_sym_debugger] = ACTIONS(1985),
    [anon_sym_return] = ACTIONS(1985),
    [anon_sym_throw] = ACTIONS(1985),
    [anon_sym_SEMI] = ACTIONS(1983),
    [anon_sym_case] = ACTIONS(1985),
    [anon_sym_yield] = ACTIONS(1985),
    [anon_sym_LBRACK] = ACTIONS(1983),
    [anon_sym_LT] = ACTIONS(1983),
    [anon_sym_SLASH] = ACTIONS(1985),
    [anon_sym_class] = ACTIONS(1985),
    [anon_sym_async] = ACTIONS(1985),
    [anon_sym_function] = ACTIONS(1985),
    [anon_sym_new] = ACTIONS(1985),
    [anon_sym_PLUS] = ACTIONS(1985),
    [anon_sym_DASH] = ACTIONS(1985),
    [anon_sym_TILDE] = ACTIONS(1983),
    [anon_sym_void] = ACTIONS(1985),
    [anon_sym_delete] = ACTIONS(1985),
    [anon_sym_PLUS_PLUS] = ACTIONS(1983),
    [anon_sym_DASH_DASH] = ACTIONS(1983),
    [anon_sym_DQUOTE] = ACTIONS(1983),
    [anon_sym_SQUOTE] = ACTIONS(1983),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1983),
    [sym_number] = ACTIONS(1983),
    [sym_this] = ACTIONS(1985),
    [sym_super] = ACTIONS(1985),
    [sym_true] = ACTIONS(1985),
    [sym_false] = ACTIONS(1985),
    [sym_null] = ACTIONS(1985),
    [sym_undefined] = ACTIONS(1985),
    [anon_sym_AT] = ACTIONS(1983),
    [anon_sym_static] = ACTIONS(1985),
    [anon_sym_abstract] = ACTIONS(1985),
    [anon_sym_get] = ACTIONS(1985),
    [anon_sym_set] = ACTIONS(1985),
    [anon_sym_declare] = ACTIONS(1985),
    [anon_sym_public] = ACTIONS(1985),
    [anon_sym_private] = ACTIONS(1985),
    [anon_sym_protected] = ACTIONS(1985),
    [anon_sym_module] = ACTIONS(1985),
    [anon_sym_any] = ACTIONS(1985),
    [anon_sym_number] = ACTIONS(1985),
    [anon_sym_boolean] = ACTIONS(1985),
    [anon_sym_string] = ACTIONS(1985),
    [anon_sym_symbol] = ACTIONS(1985),
    [anon_sym_interface] = ACTIONS(1985),
    [anon_sym_enum] = ACTIONS(1985),
    [sym_readonly] = ACTIONS(1985),
  },
  [585] = {
    [ts_builtin_sym_end] = ACTIONS(1987),
    [sym_identifier] = ACTIONS(1989),
    [anon_sym_export] = ACTIONS(1989),
    [anon_sym_default] = ACTIONS(1989),
    [anon_sym_namespace] = ACTIONS(1989),
    [anon_sym_LBRACE] = ACTIONS(1987),
    [anon_sym_RBRACE] = ACTIONS(1987),
    [anon_sym_type] = ACTIONS(1989),
    [anon_sym_typeof] = ACTIONS(1989),
    [anon_sym_import] = ACTIONS(1989),
    [anon_sym_var] = ACTIONS(1989),
    [anon_sym_let] = ACTIONS(1989),
    [anon_sym_const] = ACTIONS(1989),
    [anon_sym_BANG] = ACTIONS(1987),
    [anon_sym_else] = ACTIONS(1989),
    [anon_sym_if] = ACTIONS(1989),
    [anon_sym_switch] = ACTIONS(1989),
    [anon_sym_for] = ACTIONS(1989),
    [anon_sym_LPAREN] = ACTIONS(1987),
    [anon_sym_await] = ACTIONS(1989),
    [anon_sym_while] = ACTIONS(1989),
    [anon_sym_do] = ACTIONS(1989),
    [anon_sym_try] = ACTIONS(1989),
    [anon_sym_with] = ACTIONS(1989),
    [anon_sym_break] = ACTIONS(1989),
    [anon_sym_continue] = ACTIONS(1989),
    [anon_sym_debugger] = ACTIONS(1989),
    [anon_sym_return] = ACTIONS(1989),
    [anon_sym_throw] = ACTIONS(1989),
    [anon_sym_SEMI] = ACTIONS(1987),
    [anon_sym_case] = ACTIONS(1989),
    [anon_sym_yield] = ACTIONS(1989),
    [anon_sym_LBRACK] = ACTIONS(1987),
    [anon_sym_LT] = ACTIONS(1987),
    [anon_sym_SLASH] = ACTIONS(1989),
    [anon_sym_class] = ACTIONS(1989),
    [anon_sym_async] = ACTIONS(1989),
    [anon_sym_function] = ACTIONS(1989),
    [anon_sym_new] = ACTIONS(1989),
    [anon_sym_PLUS] = ACTIONS(1989),
    [anon_sym_DASH] = ACTIONS(1989),
    [anon_sym_TILDE] = ACTIONS(1987),
    [anon_sym_void] = ACTIONS(1989),
    [anon_sym_delete] = ACTIONS(1989),
    [anon_sym_PLUS_PLUS] = ACTIONS(1987),
    [anon_sym_DASH_DASH] = ACTIONS(1987),
    [anon_sym_DQUOTE] = ACTIONS(1987),
    [anon_sym_SQUOTE] = ACTIONS(1987),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1987),
    [sym_number] = ACTIONS(1987),
    [sym_this] = ACTIONS(1989),
    [sym_super] = ACTIONS(1989),
    [sym_true] = ACTIONS(1989),
    [sym_false] = ACTIONS(1989),
    [sym_null] = ACTIONS(1989),
    [sym_undefined] = ACTIONS(1989),
    [anon_sym_AT] = ACTIONS(1987),
    [anon_sym_static] = ACTIONS(1989),
    [anon_sym_abstract] = ACTIONS(1989),
    [anon_sym_get] = ACTIONS(1989),
    [anon_sym_set] = ACTIONS(1989),
    [anon_sym_declare] = ACTIONS(1989),
    [anon_sym_public] = ACTIONS(1989),
    [anon_sym_private] = ACTIONS(1989),
    [anon_sym_protected] = ACTIONS(1989),
    [anon_sym_module] = ACTIONS(1989),
    [anon_sym_any] = ACTIONS(1989),
    [anon_sym_number] = ACTIONS(1989),
    [anon_sym_boolean] = ACTIONS(1989),
    [anon_sym_string] = ACTIONS(1989),
    [anon_sym_symbol] = ACTIONS(1989),
    [anon_sym_interface] = ACTIONS(1989),
    [anon_sym_enum] = ACTIONS(1989),
    [sym_readonly] = ACTIONS(1989),
  },
  [586] = {
    [ts_builtin_sym_end] = ACTIONS(979),
    [sym_identifier] = ACTIONS(981),
    [anon_sym_export] = ACTIONS(981),
    [anon_sym_default] = ACTIONS(981),
    [anon_sym_namespace] = ACTIONS(981),
    [anon_sym_LBRACE] = ACTIONS(979),
    [anon_sym_RBRACE] = ACTIONS(979),
    [anon_sym_type] = ACTIONS(981),
    [anon_sym_typeof] = ACTIONS(981),
    [anon_sym_import] = ACTIONS(981),
    [anon_sym_var] = ACTIONS(981),
    [anon_sym_let] = ACTIONS(981),
    [anon_sym_const] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(979),
    [anon_sym_else] = ACTIONS(981),
    [anon_sym_if] = ACTIONS(981),
    [anon_sym_switch] = ACTIONS(981),
    [anon_sym_for] = ACTIONS(981),
    [anon_sym_LPAREN] = ACTIONS(979),
    [anon_sym_await] = ACTIONS(981),
    [anon_sym_while] = ACTIONS(981),
    [anon_sym_do] = ACTIONS(981),
    [anon_sym_try] = ACTIONS(981),
    [anon_sym_with] = ACTIONS(981),
    [anon_sym_break] = ACTIONS(981),
    [anon_sym_continue] = ACTIONS(981),
    [anon_sym_debugger] = ACTIONS(981),
    [anon_sym_return] = ACTIONS(981),
    [anon_sym_throw] = ACTIONS(981),
    [anon_sym_SEMI] = ACTIONS(979),
    [anon_sym_case] = ACTIONS(981),
    [anon_sym_yield] = ACTIONS(981),
    [anon_sym_LBRACK] = ACTIONS(979),
    [anon_sym_LT] = ACTIONS(979),
    [anon_sym_SLASH] = ACTIONS(981),
    [anon_sym_class] = ACTIONS(981),
    [anon_sym_async] = ACTIONS(981),
    [anon_sym_function] = ACTIONS(981),
    [anon_sym_new] = ACTIONS(981),
    [anon_sym_PLUS] = ACTIONS(981),
    [anon_sym_DASH] = ACTIONS(981),
    [anon_sym_TILDE] = ACTIONS(979),
    [anon_sym_void] = ACTIONS(981),
    [anon_sym_delete] = ACTIONS(981),
    [anon_sym_PLUS_PLUS] = ACTIONS(979),
    [anon_sym_DASH_DASH] = ACTIONS(979),
    [anon_sym_DQUOTE] = ACTIONS(979),
    [anon_sym_SQUOTE] = ACTIONS(979),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(979),
    [sym_number] = ACTIONS(979),
    [sym_this] = ACTIONS(981),
    [sym_super] = ACTIONS(981),
    [sym_true] = ACTIONS(981),
    [sym_false] = ACTIONS(981),
    [sym_null] = ACTIONS(981),
    [sym_undefined] = ACTIONS(981),
    [anon_sym_AT] = ACTIONS(979),
    [anon_sym_static] = ACTIONS(981),
    [anon_sym_abstract] = ACTIONS(981),
    [anon_sym_get] = ACTIONS(981),
    [anon_sym_set] = ACTIONS(981),
    [anon_sym_declare] = ACTIONS(981),
    [anon_sym_public] = ACTIONS(981),
    [anon_sym_private] = ACTIONS(981),
    [anon_sym_protected] = ACTIONS(981),
    [anon_sym_module] = ACTIONS(981),
    [anon_sym_any] = ACTIONS(981),
    [anon_sym_number] = ACTIONS(981),
    [anon_sym_boolean] = ACTIONS(981),
    [anon_sym_string] = ACTIONS(981),
    [anon_sym_symbol] = ACTIONS(981),
    [anon_sym_interface] = ACTIONS(981),
    [anon_sym_enum] = ACTIONS(981),
    [sym_readonly] = ACTIONS(981),
  },
  [587] = {
    [ts_builtin_sym_end] = ACTIONS(1991),
    [sym_identifier] = ACTIONS(1993),
    [anon_sym_export] = ACTIONS(1993),
    [anon_sym_default] = ACTIONS(1993),
    [anon_sym_namespace] = ACTIONS(1993),
    [anon_sym_LBRACE] = ACTIONS(1991),
    [anon_sym_RBRACE] = ACTIONS(1991),
    [anon_sym_type] = ACTIONS(1993),
    [anon_sym_typeof] = ACTIONS(1993),
    [anon_sym_import] = ACTIONS(1993),
    [anon_sym_var] = ACTIONS(1993),
    [anon_sym_let] = ACTIONS(1993),
    [anon_sym_const] = ACTIONS(1993),
    [anon_sym_BANG] = ACTIONS(1991),
    [anon_sym_else] = ACTIONS(1993),
    [anon_sym_if] = ACTIONS(1993),
    [anon_sym_switch] = ACTIONS(1993),
    [anon_sym_for] = ACTIONS(1993),
    [anon_sym_LPAREN] = ACTIONS(1991),
    [anon_sym_await] = ACTIONS(1993),
    [anon_sym_while] = ACTIONS(1993),
    [anon_sym_do] = ACTIONS(1993),
    [anon_sym_try] = ACTIONS(1993),
    [anon_sym_with] = ACTIONS(1993),
    [anon_sym_break] = ACTIONS(1993),
    [anon_sym_continue] = ACTIONS(1993),
    [anon_sym_debugger] = ACTIONS(1993),
    [anon_sym_return] = ACTIONS(1993),
    [anon_sym_throw] = ACTIONS(1993),
    [anon_sym_SEMI] = ACTIONS(1991),
    [anon_sym_case] = ACTIONS(1993),
    [anon_sym_yield] = ACTIONS(1993),
    [anon_sym_LBRACK] = ACTIONS(1991),
    [anon_sym_LT] = ACTIONS(1991),
    [anon_sym_SLASH] = ACTIONS(1993),
    [anon_sym_class] = ACTIONS(1993),
    [anon_sym_async] = ACTIONS(1993),
    [anon_sym_function] = ACTIONS(1993),
    [anon_sym_new] = ACTIONS(1993),
    [anon_sym_PLUS] = ACTIONS(1993),
    [anon_sym_DASH] = ACTIONS(1993),
    [anon_sym_TILDE] = ACTIONS(1991),
    [anon_sym_void] = ACTIONS(1993),
    [anon_sym_delete] = ACTIONS(1993),
    [anon_sym_PLUS_PLUS] = ACTIONS(1991),
    [anon_sym_DASH_DASH] = ACTIONS(1991),
    [anon_sym_DQUOTE] = ACTIONS(1991),
    [anon_sym_SQUOTE] = ACTIONS(1991),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1991),
    [sym_number] = ACTIONS(1991),
    [sym_this] = ACTIONS(1993),
    [sym_super] = ACTIONS(1993),
    [sym_true] = ACTIONS(1993),
    [sym_false] = ACTIONS(1993),
    [sym_null] = ACTIONS(1993),
    [sym_undefined] = ACTIONS(1993),
    [anon_sym_AT] = ACTIONS(1991),
    [anon_sym_static] = ACTIONS(1993),
    [anon_sym_abstract] = ACTIONS(1993),
    [anon_sym_get] = ACTIONS(1993),
    [anon_sym_set] = ACTIONS(1993),
    [anon_sym_declare] = ACTIONS(1993),
    [anon_sym_public] = ACTIONS(1993),
    [anon_sym_private] = ACTIONS(1993),
    [anon_sym_protected] = ACTIONS(1993),
    [anon_sym_module] = ACTIONS(1993),
    [anon_sym_any] = ACTIONS(1993),
    [anon_sym_number] = ACTIONS(1993),
    [anon_sym_boolean] = ACTIONS(1993),
    [anon_sym_string] = ACTIONS(1993),
    [anon_sym_symbol] = ACTIONS(1993),
    [anon_sym_interface] = ACTIONS(1993),
    [anon_sym_enum] = ACTIONS(1993),
    [sym_readonly] = ACTIONS(1993),
  },
  [588] = {
    [ts_builtin_sym_end] = ACTIONS(1995),
    [sym_identifier] = ACTIONS(1997),
    [anon_sym_export] = ACTIONS(1997),
    [anon_sym_default] = ACTIONS(1997),
    [anon_sym_namespace] = ACTIONS(1997),
    [anon_sym_LBRACE] = ACTIONS(1995),
    [anon_sym_RBRACE] = ACTIONS(1995),
    [anon_sym_type] = ACTIONS(1997),
    [anon_sym_typeof] = ACTIONS(1997),
    [anon_sym_import] = ACTIONS(1997),
    [anon_sym_var] = ACTIONS(1997),
    [anon_sym_let] = ACTIONS(1997),
    [anon_sym_const] = ACTIONS(1997),
    [anon_sym_BANG] = ACTIONS(1995),
    [anon_sym_else] = ACTIONS(1997),
    [anon_sym_if] = ACTIONS(1997),
    [anon_sym_switch] = ACTIONS(1997),
    [anon_sym_for] = ACTIONS(1997),
    [anon_sym_LPAREN] = ACTIONS(1995),
    [anon_sym_await] = ACTIONS(1997),
    [anon_sym_while] = ACTIONS(1997),
    [anon_sym_do] = ACTIONS(1997),
    [anon_sym_try] = ACTIONS(1997),
    [anon_sym_with] = ACTIONS(1997),
    [anon_sym_break] = ACTIONS(1997),
    [anon_sym_continue] = ACTIONS(1997),
    [anon_sym_debugger] = ACTIONS(1997),
    [anon_sym_return] = ACTIONS(1997),
    [anon_sym_throw] = ACTIONS(1997),
    [anon_sym_SEMI] = ACTIONS(1995),
    [anon_sym_case] = ACTIONS(1997),
    [anon_sym_yield] = ACTIONS(1997),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [anon_sym_LT] = ACTIONS(1995),
    [anon_sym_SLASH] = ACTIONS(1997),
    [anon_sym_class] = ACTIONS(1997),
    [anon_sym_async] = ACTIONS(1997),
    [anon_sym_function] = ACTIONS(1997),
    [anon_sym_new] = ACTIONS(1997),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_TILDE] = ACTIONS(1995),
    [anon_sym_void] = ACTIONS(1997),
    [anon_sym_delete] = ACTIONS(1997),
    [anon_sym_PLUS_PLUS] = ACTIONS(1995),
    [anon_sym_DASH_DASH] = ACTIONS(1995),
    [anon_sym_DQUOTE] = ACTIONS(1995),
    [anon_sym_SQUOTE] = ACTIONS(1995),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1995),
    [sym_number] = ACTIONS(1995),
    [sym_this] = ACTIONS(1997),
    [sym_super] = ACTIONS(1997),
    [sym_true] = ACTIONS(1997),
    [sym_false] = ACTIONS(1997),
    [sym_null] = ACTIONS(1997),
    [sym_undefined] = ACTIONS(1997),
    [anon_sym_AT] = ACTIONS(1995),
    [anon_sym_static] = ACTIONS(1997),
    [anon_sym_abstract] = ACTIONS(1997),
    [anon_sym_get] = ACTIONS(1997),
    [anon_sym_set] = ACTIONS(1997),
    [anon_sym_declare] = ACTIONS(1997),
    [anon_sym_public] = ACTIONS(1997),
    [anon_sym_private] = ACTIONS(1997),
    [anon_sym_protected] = ACTIONS(1997),
    [anon_sym_module] = ACTIONS(1997),
    [anon_sym_any] = ACTIONS(1997),
    [anon_sym_number] = ACTIONS(1997),
    [anon_sym_boolean] = ACTIONS(1997),
    [anon_sym_string] = ACTIONS(1997),
    [anon_sym_symbol] = ACTIONS(1997),
    [anon_sym_interface] = ACTIONS(1997),
    [anon_sym_enum] = ACTIONS(1997),
    [sym_readonly] = ACTIONS(1997),
  },
  [589] = {
    [ts_builtin_sym_end] = ACTIONS(1999),
    [sym_identifier] = ACTIONS(2001),
    [anon_sym_export] = ACTIONS(2001),
    [anon_sym_default] = ACTIONS(2001),
    [anon_sym_namespace] = ACTIONS(2001),
    [anon_sym_LBRACE] = ACTIONS(1999),
    [anon_sym_RBRACE] = ACTIONS(1999),
    [anon_sym_type] = ACTIONS(2001),
    [anon_sym_typeof] = ACTIONS(2001),
    [anon_sym_import] = ACTIONS(2001),
    [anon_sym_var] = ACTIONS(2001),
    [anon_sym_let] = ACTIONS(2001),
    [anon_sym_const] = ACTIONS(2001),
    [anon_sym_BANG] = ACTIONS(1999),
    [anon_sym_else] = ACTIONS(2001),
    [anon_sym_if] = ACTIONS(2001),
    [anon_sym_switch] = ACTIONS(2001),
    [anon_sym_for] = ACTIONS(2001),
    [anon_sym_LPAREN] = ACTIONS(1999),
    [anon_sym_await] = ACTIONS(2001),
    [anon_sym_while] = ACTIONS(2001),
    [anon_sym_do] = ACTIONS(2001),
    [anon_sym_try] = ACTIONS(2001),
    [anon_sym_with] = ACTIONS(2001),
    [anon_sym_break] = ACTIONS(2001),
    [anon_sym_continue] = ACTIONS(2001),
    [anon_sym_debugger] = ACTIONS(2001),
    [anon_sym_return] = ACTIONS(2001),
    [anon_sym_throw] = ACTIONS(2001),
    [anon_sym_SEMI] = ACTIONS(1999),
    [anon_sym_case] = ACTIONS(2001),
    [anon_sym_yield] = ACTIONS(2001),
    [anon_sym_LBRACK] = ACTIONS(1999),
    [anon_sym_LT] = ACTIONS(1999),
    [anon_sym_SLASH] = ACTIONS(2001),
    [anon_sym_class] = ACTIONS(2001),
    [anon_sym_async] = ACTIONS(2001),
    [anon_sym_function] = ACTIONS(2001),
    [anon_sym_new] = ACTIONS(2001),
    [anon_sym_PLUS] = ACTIONS(2001),
    [anon_sym_DASH] = ACTIONS(2001),
    [anon_sym_TILDE] = ACTIONS(1999),
    [anon_sym_void] = ACTIONS(2001),
    [anon_sym_delete] = ACTIONS(2001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1999),
    [anon_sym_DQUOTE] = ACTIONS(1999),
    [anon_sym_SQUOTE] = ACTIONS(1999),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1999),
    [sym_number] = ACTIONS(1999),
    [sym_this] = ACTIONS(2001),
    [sym_super] = ACTIONS(2001),
    [sym_true] = ACTIONS(2001),
    [sym_false] = ACTIONS(2001),
    [sym_null] = ACTIONS(2001),
    [sym_undefined] = ACTIONS(2001),
    [anon_sym_AT] = ACTIONS(1999),
    [anon_sym_static] = ACTIONS(2001),
    [anon_sym_abstract] = ACTIONS(2001),
    [anon_sym_get] = ACTIONS(2001),
    [anon_sym_set] = ACTIONS(2001),
    [anon_sym_declare] = ACTIONS(2001),
    [anon_sym_public] = ACTIONS(2001),
    [anon_sym_private] = ACTIONS(2001),
    [anon_sym_protected] = ACTIONS(2001),
    [anon_sym_module] = ACTIONS(2001),
    [anon_sym_any] = ACTIONS(2001),
    [anon_sym_number] = ACTIONS(2001),
    [anon_sym_boolean] = ACTIONS(2001),
    [anon_sym_string] = ACTIONS(2001),
    [anon_sym_symbol] = ACTIONS(2001),
    [anon_sym_interface] = ACTIONS(2001),
    [anon_sym_enum] = ACTIONS(2001),
    [sym_readonly] = ACTIONS(2001),
  },
  [590] = {
    [ts_builtin_sym_end] = ACTIONS(2003),
    [sym_identifier] = ACTIONS(2005),
    [anon_sym_export] = ACTIONS(2005),
    [anon_sym_default] = ACTIONS(2005),
    [anon_sym_namespace] = ACTIONS(2005),
    [anon_sym_LBRACE] = ACTIONS(2003),
    [anon_sym_RBRACE] = ACTIONS(2003),
    [anon_sym_type] = ACTIONS(2005),
    [anon_sym_typeof] = ACTIONS(2005),
    [anon_sym_import] = ACTIONS(2005),
    [anon_sym_var] = ACTIONS(2005),
    [anon_sym_let] = ACTIONS(2005),
    [anon_sym_const] = ACTIONS(2005),
    [anon_sym_BANG] = ACTIONS(2003),
    [anon_sym_else] = ACTIONS(2005),
    [anon_sym_if] = ACTIONS(2005),
    [anon_sym_switch] = ACTIONS(2005),
    [anon_sym_for] = ACTIONS(2005),
    [anon_sym_LPAREN] = ACTIONS(2003),
    [anon_sym_await] = ACTIONS(2005),
    [anon_sym_while] = ACTIONS(2005),
    [anon_sym_do] = ACTIONS(2005),
    [anon_sym_try] = ACTIONS(2005),
    [anon_sym_with] = ACTIONS(2005),
    [anon_sym_break] = ACTIONS(2005),
    [anon_sym_continue] = ACTIONS(2005),
    [anon_sym_debugger] = ACTIONS(2005),
    [anon_sym_return] = ACTIONS(2005),
    [anon_sym_throw] = ACTIONS(2005),
    [anon_sym_SEMI] = ACTIONS(2003),
    [anon_sym_case] = ACTIONS(2005),
    [anon_sym_yield] = ACTIONS(2005),
    [anon_sym_LBRACK] = ACTIONS(2003),
    [anon_sym_LT] = ACTIONS(2003),
    [anon_sym_SLASH] = ACTIONS(2005),
    [anon_sym_class] = ACTIONS(2005),
    [anon_sym_async] = ACTIONS(2005),
    [anon_sym_function] = ACTIONS(2005),
    [anon_sym_new] = ACTIONS(2005),
    [anon_sym_PLUS] = ACTIONS(2005),
    [anon_sym_DASH] = ACTIONS(2005),
    [anon_sym_TILDE] = ACTIONS(2003),
    [anon_sym_void] = ACTIONS(2005),
    [anon_sym_delete] = ACTIONS(2005),
    [anon_sym_PLUS_PLUS] = ACTIONS(2003),
    [anon_sym_DASH_DASH] = ACTIONS(2003),
    [anon_sym_DQUOTE] = ACTIONS(2003),
    [anon_sym_SQUOTE] = ACTIONS(2003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2003),
    [sym_number] = ACTIONS(2003),
    [sym_this] = ACTIONS(2005),
    [sym_super] = ACTIONS(2005),
    [sym_true] = ACTIONS(2005),
    [sym_false] = ACTIONS(2005),
    [sym_null] = ACTIONS(2005),
    [sym_undefined] = ACTIONS(2005),
    [anon_sym_AT] = ACTIONS(2003),
    [anon_sym_static] = ACTIONS(2005),
    [anon_sym_abstract] = ACTIONS(2005),
    [anon_sym_get] = ACTIONS(2005),
    [anon_sym_set] = ACTIONS(2005),
    [anon_sym_declare] = ACTIONS(2005),
    [anon_sym_public] = ACTIONS(2005),
    [anon_sym_private] = ACTIONS(2005),
    [anon_sym_protected] = ACTIONS(2005),
    [anon_sym_module] = ACTIONS(2005),
    [anon_sym_any] = ACTIONS(2005),
    [anon_sym_number] = ACTIONS(2005),
    [anon_sym_boolean] = ACTIONS(2005),
    [anon_sym_string] = ACTIONS(2005),
    [anon_sym_symbol] = ACTIONS(2005),
    [anon_sym_interface] = ACTIONS(2005),
    [anon_sym_enum] = ACTIONS(2005),
    [sym_readonly] = ACTIONS(2005),
  },
  [591] = {
    [ts_builtin_sym_end] = ACTIONS(2007),
    [sym_identifier] = ACTIONS(2009),
    [anon_sym_export] = ACTIONS(2009),
    [anon_sym_default] = ACTIONS(2009),
    [anon_sym_namespace] = ACTIONS(2009),
    [anon_sym_LBRACE] = ACTIONS(2007),
    [anon_sym_RBRACE] = ACTIONS(2007),
    [anon_sym_type] = ACTIONS(2009),
    [anon_sym_typeof] = ACTIONS(2009),
    [anon_sym_import] = ACTIONS(2009),
    [anon_sym_var] = ACTIONS(2009),
    [anon_sym_let] = ACTIONS(2009),
    [anon_sym_const] = ACTIONS(2009),
    [anon_sym_BANG] = ACTIONS(2007),
    [anon_sym_else] = ACTIONS(2009),
    [anon_sym_if] = ACTIONS(2009),
    [anon_sym_switch] = ACTIONS(2009),
    [anon_sym_for] = ACTIONS(2009),
    [anon_sym_LPAREN] = ACTIONS(2007),
    [anon_sym_await] = ACTIONS(2009),
    [anon_sym_while] = ACTIONS(2009),
    [anon_sym_do] = ACTIONS(2009),
    [anon_sym_try] = ACTIONS(2009),
    [anon_sym_with] = ACTIONS(2009),
    [anon_sym_break] = ACTIONS(2009),
    [anon_sym_continue] = ACTIONS(2009),
    [anon_sym_debugger] = ACTIONS(2009),
    [anon_sym_return] = ACTIONS(2009),
    [anon_sym_throw] = ACTIONS(2009),
    [anon_sym_SEMI] = ACTIONS(2007),
    [anon_sym_case] = ACTIONS(2009),
    [anon_sym_yield] = ACTIONS(2009),
    [anon_sym_LBRACK] = ACTIONS(2007),
    [anon_sym_LT] = ACTIONS(2007),
    [anon_sym_SLASH] = ACTIONS(2009),
    [anon_sym_class] = ACTIONS(2009),
    [anon_sym_async] = ACTIONS(2009),
    [anon_sym_function] = ACTIONS(2009),
    [anon_sym_new] = ACTIONS(2009),
    [anon_sym_PLUS] = ACTIONS(2009),
    [anon_sym_DASH] = ACTIONS(2009),
    [anon_sym_TILDE] = ACTIONS(2007),
    [anon_sym_void] = ACTIONS(2009),
    [anon_sym_delete] = ACTIONS(2009),
    [anon_sym_PLUS_PLUS] = ACTIONS(2007),
    [anon_sym_DASH_DASH] = ACTIONS(2007),
    [anon_sym_DQUOTE] = ACTIONS(2007),
    [anon_sym_SQUOTE] = ACTIONS(2007),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2007),
    [sym_number] = ACTIONS(2007),
    [sym_this] = ACTIONS(2009),
    [sym_super] = ACTIONS(2009),
    [sym_true] = ACTIONS(2009),
    [sym_false] = ACTIONS(2009),
    [sym_null] = ACTIONS(2009),
    [sym_undefined] = ACTIONS(2009),
    [anon_sym_AT] = ACTIONS(2007),
    [anon_sym_static] = ACTIONS(2009),
    [anon_sym_abstract] = ACTIONS(2009),
    [anon_sym_get] = ACTIONS(2009),
    [anon_sym_set] = ACTIONS(2009),
    [anon_sym_declare] = ACTIONS(2009),
    [anon_sym_public] = ACTIONS(2009),
    [anon_sym_private] = ACTIONS(2009),
    [anon_sym_protected] = ACTIONS(2009),
    [anon_sym_module] = ACTIONS(2009),
    [anon_sym_any] = ACTIONS(2009),
    [anon_sym_number] = ACTIONS(2009),
    [anon_sym_boolean] = ACTIONS(2009),
    [anon_sym_string] = ACTIONS(2009),
    [anon_sym_symbol] = ACTIONS(2009),
    [anon_sym_interface] = ACTIONS(2009),
    [anon_sym_enum] = ACTIONS(2009),
    [sym_readonly] = ACTIONS(2009),
  },
  [592] = {
    [ts_builtin_sym_end] = ACTIONS(2011),
    [sym_identifier] = ACTIONS(2013),
    [anon_sym_export] = ACTIONS(2013),
    [anon_sym_default] = ACTIONS(2013),
    [anon_sym_namespace] = ACTIONS(2013),
    [anon_sym_LBRACE] = ACTIONS(2011),
    [anon_sym_RBRACE] = ACTIONS(2011),
    [anon_sym_type] = ACTIONS(2013),
    [anon_sym_typeof] = ACTIONS(2013),
    [anon_sym_import] = ACTIONS(2013),
    [anon_sym_var] = ACTIONS(2013),
    [anon_sym_let] = ACTIONS(2013),
    [anon_sym_const] = ACTIONS(2013),
    [anon_sym_BANG] = ACTIONS(2011),
    [anon_sym_else] = ACTIONS(2013),
    [anon_sym_if] = ACTIONS(2013),
    [anon_sym_switch] = ACTIONS(2013),
    [anon_sym_for] = ACTIONS(2013),
    [anon_sym_LPAREN] = ACTIONS(2011),
    [anon_sym_await] = ACTIONS(2013),
    [anon_sym_while] = ACTIONS(2013),
    [anon_sym_do] = ACTIONS(2013),
    [anon_sym_try] = ACTIONS(2013),
    [anon_sym_with] = ACTIONS(2013),
    [anon_sym_break] = ACTIONS(2013),
    [anon_sym_continue] = ACTIONS(2013),
    [anon_sym_debugger] = ACTIONS(2013),
    [anon_sym_return] = ACTIONS(2013),
    [anon_sym_throw] = ACTIONS(2013),
    [anon_sym_SEMI] = ACTIONS(2011),
    [anon_sym_case] = ACTIONS(2013),
    [anon_sym_yield] = ACTIONS(2013),
    [anon_sym_LBRACK] = ACTIONS(2011),
    [anon_sym_LT] = ACTIONS(2011),
    [anon_sym_SLASH] = ACTIONS(2013),
    [anon_sym_class] = ACTIONS(2013),
    [anon_sym_async] = ACTIONS(2013),
    [anon_sym_function] = ACTIONS(2013),
    [anon_sym_new] = ACTIONS(2013),
    [anon_sym_PLUS] = ACTIONS(2013),
    [anon_sym_DASH] = ACTIONS(2013),
    [anon_sym_TILDE] = ACTIONS(2011),
    [anon_sym_void] = ACTIONS(2013),
    [anon_sym_delete] = ACTIONS(2013),
    [anon_sym_PLUS_PLUS] = ACTIONS(2011),
    [anon_sym_DASH_DASH] = ACTIONS(2011),
    [anon_sym_DQUOTE] = ACTIONS(2011),
    [anon_sym_SQUOTE] = ACTIONS(2011),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2011),
    [sym_number] = ACTIONS(2011),
    [sym_this] = ACTIONS(2013),
    [sym_super] = ACTIONS(2013),
    [sym_true] = ACTIONS(2013),
    [sym_false] = ACTIONS(2013),
    [sym_null] = ACTIONS(2013),
    [sym_undefined] = ACTIONS(2013),
    [anon_sym_AT] = ACTIONS(2011),
    [anon_sym_static] = ACTIONS(2013),
    [anon_sym_abstract] = ACTIONS(2013),
    [anon_sym_get] = ACTIONS(2013),
    [anon_sym_set] = ACTIONS(2013),
    [anon_sym_declare] = ACTIONS(2013),
    [anon_sym_public] = ACTIONS(2013),
    [anon_sym_private] = ACTIONS(2013),
    [anon_sym_protected] = ACTIONS(2013),
    [anon_sym_module] = ACTIONS(2013),
    [anon_sym_any] = ACTIONS(2013),
    [anon_sym_number] = ACTIONS(2013),
    [anon_sym_boolean] = ACTIONS(2013),
    [anon_sym_string] = ACTIONS(2013),
    [anon_sym_symbol] = ACTIONS(2013),
    [anon_sym_interface] = ACTIONS(2013),
    [anon_sym_enum] = ACTIONS(2013),
    [sym_readonly] = ACTIONS(2013),
  },
  [593] = {
    [ts_builtin_sym_end] = ACTIONS(2015),
    [sym_identifier] = ACTIONS(2017),
    [anon_sym_export] = ACTIONS(2017),
    [anon_sym_default] = ACTIONS(2017),
    [anon_sym_namespace] = ACTIONS(2017),
    [anon_sym_LBRACE] = ACTIONS(2015),
    [anon_sym_RBRACE] = ACTIONS(2015),
    [anon_sym_type] = ACTIONS(2017),
    [anon_sym_typeof] = ACTIONS(2017),
    [anon_sym_import] = ACTIONS(2017),
    [anon_sym_var] = ACTIONS(2017),
    [anon_sym_let] = ACTIONS(2017),
    [anon_sym_const] = ACTIONS(2017),
    [anon_sym_BANG] = ACTIONS(2015),
    [anon_sym_else] = ACTIONS(2017),
    [anon_sym_if] = ACTIONS(2017),
    [anon_sym_switch] = ACTIONS(2017),
    [anon_sym_for] = ACTIONS(2017),
    [anon_sym_LPAREN] = ACTIONS(2015),
    [anon_sym_await] = ACTIONS(2017),
    [anon_sym_while] = ACTIONS(2017),
    [anon_sym_do] = ACTIONS(2017),
    [anon_sym_try] = ACTIONS(2017),
    [anon_sym_with] = ACTIONS(2017),
    [anon_sym_break] = ACTIONS(2017),
    [anon_sym_continue] = ACTIONS(2017),
    [anon_sym_debugger] = ACTIONS(2017),
    [anon_sym_return] = ACTIONS(2017),
    [anon_sym_throw] = ACTIONS(2017),
    [anon_sym_SEMI] = ACTIONS(2015),
    [anon_sym_case] = ACTIONS(2017),
    [anon_sym_yield] = ACTIONS(2017),
    [anon_sym_LBRACK] = ACTIONS(2015),
    [anon_sym_LT] = ACTIONS(2015),
    [anon_sym_SLASH] = ACTIONS(2017),
    [anon_sym_class] = ACTIONS(2017),
    [anon_sym_async] = ACTIONS(2017),
    [anon_sym_function] = ACTIONS(2017),
    [anon_sym_new] = ACTIONS(2017),
    [anon_sym_PLUS] = ACTIONS(2017),
    [anon_sym_DASH] = ACTIONS(2017),
    [anon_sym_TILDE] = ACTIONS(2015),
    [anon_sym_void] = ACTIONS(2017),
    [anon_sym_delete] = ACTIONS(2017),
    [anon_sym_PLUS_PLUS] = ACTIONS(2015),
    [anon_sym_DASH_DASH] = ACTIONS(2015),
    [anon_sym_DQUOTE] = ACTIONS(2015),
    [anon_sym_SQUOTE] = ACTIONS(2015),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2015),
    [sym_number] = ACTIONS(2015),
    [sym_this] = ACTIONS(2017),
    [sym_super] = ACTIONS(2017),
    [sym_true] = ACTIONS(2017),
    [sym_false] = ACTIONS(2017),
    [sym_null] = ACTIONS(2017),
    [sym_undefined] = ACTIONS(2017),
    [anon_sym_AT] = ACTIONS(2015),
    [anon_sym_static] = ACTIONS(2017),
    [anon_sym_abstract] = ACTIONS(2017),
    [anon_sym_get] = ACTIONS(2017),
    [anon_sym_set] = ACTIONS(2017),
    [anon_sym_declare] = ACTIONS(2017),
    [anon_sym_public] = ACTIONS(2017),
    [anon_sym_private] = ACTIONS(2017),
    [anon_sym_protected] = ACTIONS(2017),
    [anon_sym_module] = ACTIONS(2017),
    [anon_sym_any] = ACTIONS(2017),
    [anon_sym_number] = ACTIONS(2017),
    [anon_sym_boolean] = ACTIONS(2017),
    [anon_sym_string] = ACTIONS(2017),
    [anon_sym_symbol] = ACTIONS(2017),
    [anon_sym_interface] = ACTIONS(2017),
    [anon_sym_enum] = ACTIONS(2017),
    [sym_readonly] = ACTIONS(2017),
  },
  [594] = {
    [ts_builtin_sym_end] = ACTIONS(2019),
    [sym_identifier] = ACTIONS(2021),
    [anon_sym_export] = ACTIONS(2021),
    [anon_sym_default] = ACTIONS(2021),
    [anon_sym_namespace] = ACTIONS(2021),
    [anon_sym_LBRACE] = ACTIONS(2019),
    [anon_sym_RBRACE] = ACTIONS(2019),
    [anon_sym_type] = ACTIONS(2021),
    [anon_sym_typeof] = ACTIONS(2021),
    [anon_sym_import] = ACTIONS(2021),
    [anon_sym_var] = ACTIONS(2021),
    [anon_sym_let] = ACTIONS(2021),
    [anon_sym_const] = ACTIONS(2021),
    [anon_sym_BANG] = ACTIONS(2019),
    [anon_sym_else] = ACTIONS(2021),
    [anon_sym_if] = ACTIONS(2021),
    [anon_sym_switch] = ACTIONS(2021),
    [anon_sym_for] = ACTIONS(2021),
    [anon_sym_LPAREN] = ACTIONS(2019),
    [anon_sym_await] = ACTIONS(2021),
    [anon_sym_while] = ACTIONS(2021),
    [anon_sym_do] = ACTIONS(2021),
    [anon_sym_try] = ACTIONS(2021),
    [anon_sym_with] = ACTIONS(2021),
    [anon_sym_break] = ACTIONS(2021),
    [anon_sym_continue] = ACTIONS(2021),
    [anon_sym_debugger] = ACTIONS(2021),
    [anon_sym_return] = ACTIONS(2021),
    [anon_sym_throw] = ACTIONS(2021),
    [anon_sym_SEMI] = ACTIONS(2019),
    [anon_sym_case] = ACTIONS(2021),
    [anon_sym_yield] = ACTIONS(2021),
    [anon_sym_LBRACK] = ACTIONS(2019),
    [anon_sym_LT] = ACTIONS(2019),
    [anon_sym_SLASH] = ACTIONS(2021),
    [anon_sym_class] = ACTIONS(2021),
    [anon_sym_async] = ACTIONS(2021),
    [anon_sym_function] = ACTIONS(2021),
    [anon_sym_new] = ACTIONS(2021),
    [anon_sym_PLUS] = ACTIONS(2021),
    [anon_sym_DASH] = ACTIONS(2021),
    [anon_sym_TILDE] = ACTIONS(2019),
    [anon_sym_void] = ACTIONS(2021),
    [anon_sym_delete] = ACTIONS(2021),
    [anon_sym_PLUS_PLUS] = ACTIONS(2019),
    [anon_sym_DASH_DASH] = ACTIONS(2019),
    [anon_sym_DQUOTE] = ACTIONS(2019),
    [anon_sym_SQUOTE] = ACTIONS(2019),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2019),
    [sym_number] = ACTIONS(2019),
    [sym_this] = ACTIONS(2021),
    [sym_super] = ACTIONS(2021),
    [sym_true] = ACTIONS(2021),
    [sym_false] = ACTIONS(2021),
    [sym_null] = ACTIONS(2021),
    [sym_undefined] = ACTIONS(2021),
    [anon_sym_AT] = ACTIONS(2019),
    [anon_sym_static] = ACTIONS(2021),
    [anon_sym_abstract] = ACTIONS(2021),
    [anon_sym_get] = ACTIONS(2021),
    [anon_sym_set] = ACTIONS(2021),
    [anon_sym_declare] = ACTIONS(2021),
    [anon_sym_public] = ACTIONS(2021),
    [anon_sym_private] = ACTIONS(2021),
    [anon_sym_protected] = ACTIONS(2021),
    [anon_sym_module] = ACTIONS(2021),
    [anon_sym_any] = ACTIONS(2021),
    [anon_sym_number] = ACTIONS(2021),
    [anon_sym_boolean] = ACTIONS(2021),
    [anon_sym_string] = ACTIONS(2021),
    [anon_sym_symbol] = ACTIONS(2021),
    [anon_sym_interface] = ACTIONS(2021),
    [anon_sym_enum] = ACTIONS(2021),
    [sym_readonly] = ACTIONS(2021),
  },
  [595] = {
    [ts_builtin_sym_end] = ACTIONS(2023),
    [sym_identifier] = ACTIONS(2025),
    [anon_sym_export] = ACTIONS(2025),
    [anon_sym_default] = ACTIONS(2025),
    [anon_sym_namespace] = ACTIONS(2025),
    [anon_sym_LBRACE] = ACTIONS(2023),
    [anon_sym_RBRACE] = ACTIONS(2023),
    [anon_sym_type] = ACTIONS(2025),
    [anon_sym_typeof] = ACTIONS(2025),
    [anon_sym_import] = ACTIONS(2025),
    [anon_sym_var] = ACTIONS(2025),
    [anon_sym_let] = ACTIONS(2025),
    [anon_sym_const] = ACTIONS(2025),
    [anon_sym_BANG] = ACTIONS(2023),
    [anon_sym_else] = ACTIONS(2025),
    [anon_sym_if] = ACTIONS(2025),
    [anon_sym_switch] = ACTIONS(2025),
    [anon_sym_for] = ACTIONS(2025),
    [anon_sym_LPAREN] = ACTIONS(2023),
    [anon_sym_await] = ACTIONS(2025),
    [anon_sym_while] = ACTIONS(2025),
    [anon_sym_do] = ACTIONS(2025),
    [anon_sym_try] = ACTIONS(2025),
    [anon_sym_with] = ACTIONS(2025),
    [anon_sym_break] = ACTIONS(2025),
    [anon_sym_continue] = ACTIONS(2025),
    [anon_sym_debugger] = ACTIONS(2025),
    [anon_sym_return] = ACTIONS(2025),
    [anon_sym_throw] = ACTIONS(2025),
    [anon_sym_SEMI] = ACTIONS(2023),
    [anon_sym_case] = ACTIONS(2025),
    [anon_sym_yield] = ACTIONS(2025),
    [anon_sym_LBRACK] = ACTIONS(2023),
    [anon_sym_LT] = ACTIONS(2023),
    [anon_sym_SLASH] = ACTIONS(2025),
    [anon_sym_class] = ACTIONS(2025),
    [anon_sym_async] = ACTIONS(2025),
    [anon_sym_function] = ACTIONS(2025),
    [anon_sym_new] = ACTIONS(2025),
    [anon_sym_PLUS] = ACTIONS(2025),
    [anon_sym_DASH] = ACTIONS(2025),
    [anon_sym_TILDE] = ACTIONS(2023),
    [anon_sym_void] = ACTIONS(2025),
    [anon_sym_delete] = ACTIONS(2025),
    [anon_sym_PLUS_PLUS] = ACTIONS(2023),
    [anon_sym_DASH_DASH] = ACTIONS(2023),
    [anon_sym_DQUOTE] = ACTIONS(2023),
    [anon_sym_SQUOTE] = ACTIONS(2023),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2023),
    [sym_number] = ACTIONS(2023),
    [sym_this] = ACTIONS(2025),
    [sym_super] = ACTIONS(2025),
    [sym_true] = ACTIONS(2025),
    [sym_false] = ACTIONS(2025),
    [sym_null] = ACTIONS(2025),
    [sym_undefined] = ACTIONS(2025),
    [anon_sym_AT] = ACTIONS(2023),
    [anon_sym_static] = ACTIONS(2025),
    [anon_sym_abstract] = ACTIONS(2025),
    [anon_sym_get] = ACTIONS(2025),
    [anon_sym_set] = ACTIONS(2025),
    [anon_sym_declare] = ACTIONS(2025),
    [anon_sym_public] = ACTIONS(2025),
    [anon_sym_private] = ACTIONS(2025),
    [anon_sym_protected] = ACTIONS(2025),
    [anon_sym_module] = ACTIONS(2025),
    [anon_sym_any] = ACTIONS(2025),
    [anon_sym_number] = ACTIONS(2025),
    [anon_sym_boolean] = ACTIONS(2025),
    [anon_sym_string] = ACTIONS(2025),
    [anon_sym_symbol] = ACTIONS(2025),
    [anon_sym_interface] = ACTIONS(2025),
    [anon_sym_enum] = ACTIONS(2025),
    [sym_readonly] = ACTIONS(2025),
  },
  [596] = {
    [ts_builtin_sym_end] = ACTIONS(2027),
    [sym_identifier] = ACTIONS(2029),
    [anon_sym_export] = ACTIONS(2029),
    [anon_sym_default] = ACTIONS(2029),
    [anon_sym_namespace] = ACTIONS(2029),
    [anon_sym_LBRACE] = ACTIONS(2027),
    [anon_sym_RBRACE] = ACTIONS(2027),
    [anon_sym_type] = ACTIONS(2029),
    [anon_sym_typeof] = ACTIONS(2029),
    [anon_sym_import] = ACTIONS(2029),
    [anon_sym_var] = ACTIONS(2029),
    [anon_sym_let] = ACTIONS(2029),
    [anon_sym_const] = ACTIONS(2029),
    [anon_sym_BANG] = ACTIONS(2027),
    [anon_sym_else] = ACTIONS(2029),
    [anon_sym_if] = ACTIONS(2029),
    [anon_sym_switch] = ACTIONS(2029),
    [anon_sym_for] = ACTIONS(2029),
    [anon_sym_LPAREN] = ACTIONS(2027),
    [anon_sym_await] = ACTIONS(2029),
    [anon_sym_while] = ACTIONS(2029),
    [anon_sym_do] = ACTIONS(2029),
    [anon_sym_try] = ACTIONS(2029),
    [anon_sym_with] = ACTIONS(2029),
    [anon_sym_break] = ACTIONS(2029),
    [anon_sym_continue] = ACTIONS(2029),
    [anon_sym_debugger] = ACTIONS(2029),
    [anon_sym_return] = ACTIONS(2029),
    [anon_sym_throw] = ACTIONS(2029),
    [anon_sym_SEMI] = ACTIONS(2027),
    [anon_sym_case] = ACTIONS(2029),
    [anon_sym_yield] = ACTIONS(2029),
    [anon_sym_LBRACK] = ACTIONS(2027),
    [anon_sym_LT] = ACTIONS(2027),
    [anon_sym_SLASH] = ACTIONS(2029),
    [anon_sym_class] = ACTIONS(2029),
    [anon_sym_async] = ACTIONS(2029),
    [anon_sym_function] = ACTIONS(2029),
    [anon_sym_new] = ACTIONS(2029),
    [anon_sym_PLUS] = ACTIONS(2029),
    [anon_sym_DASH] = ACTIONS(2029),
    [anon_sym_TILDE] = ACTIONS(2027),
    [anon_sym_void] = ACTIONS(2029),
    [anon_sym_delete] = ACTIONS(2029),
    [anon_sym_PLUS_PLUS] = ACTIONS(2027),
    [anon_sym_DASH_DASH] = ACTIONS(2027),
    [anon_sym_DQUOTE] = ACTIONS(2027),
    [anon_sym_SQUOTE] = ACTIONS(2027),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2027),
    [sym_number] = ACTIONS(2027),
    [sym_this] = ACTIONS(2029),
    [sym_super] = ACTIONS(2029),
    [sym_true] = ACTIONS(2029),
    [sym_false] = ACTIONS(2029),
    [sym_null] = ACTIONS(2029),
    [sym_undefined] = ACTIONS(2029),
    [anon_sym_AT] = ACTIONS(2027),
    [anon_sym_static] = ACTIONS(2029),
    [anon_sym_abstract] = ACTIONS(2029),
    [anon_sym_get] = ACTIONS(2029),
    [anon_sym_set] = ACTIONS(2029),
    [anon_sym_declare] = ACTIONS(2029),
    [anon_sym_public] = ACTIONS(2029),
    [anon_sym_private] = ACTIONS(2029),
    [anon_sym_protected] = ACTIONS(2029),
    [anon_sym_module] = ACTIONS(2029),
    [anon_sym_any] = ACTIONS(2029),
    [anon_sym_number] = ACTIONS(2029),
    [anon_sym_boolean] = ACTIONS(2029),
    [anon_sym_string] = ACTIONS(2029),
    [anon_sym_symbol] = ACTIONS(2029),
    [anon_sym_interface] = ACTIONS(2029),
    [anon_sym_enum] = ACTIONS(2029),
    [sym_readonly] = ACTIONS(2029),
  },
  [597] = {
    [ts_builtin_sym_end] = ACTIONS(2031),
    [sym_identifier] = ACTIONS(2033),
    [anon_sym_export] = ACTIONS(2033),
    [anon_sym_default] = ACTIONS(2033),
    [anon_sym_namespace] = ACTIONS(2033),
    [anon_sym_LBRACE] = ACTIONS(2031),
    [anon_sym_RBRACE] = ACTIONS(2031),
    [anon_sym_type] = ACTIONS(2033),
    [anon_sym_typeof] = ACTIONS(2033),
    [anon_sym_import] = ACTIONS(2033),
    [anon_sym_var] = ACTIONS(2033),
    [anon_sym_let] = ACTIONS(2033),
    [anon_sym_const] = ACTIONS(2033),
    [anon_sym_BANG] = ACTIONS(2031),
    [anon_sym_else] = ACTIONS(2033),
    [anon_sym_if] = ACTIONS(2033),
    [anon_sym_switch] = ACTIONS(2033),
    [anon_sym_for] = ACTIONS(2033),
    [anon_sym_LPAREN] = ACTIONS(2031),
    [anon_sym_await] = ACTIONS(2033),
    [anon_sym_while] = ACTIONS(2033),
    [anon_sym_do] = ACTIONS(2033),
    [anon_sym_try] = ACTIONS(2033),
    [anon_sym_with] = ACTIONS(2033),
    [anon_sym_break] = ACTIONS(2033),
    [anon_sym_continue] = ACTIONS(2033),
    [anon_sym_debugger] = ACTIONS(2033),
    [anon_sym_return] = ACTIONS(2033),
    [anon_sym_throw] = ACTIONS(2033),
    [anon_sym_SEMI] = ACTIONS(2031),
    [anon_sym_case] = ACTIONS(2033),
    [anon_sym_yield] = ACTIONS(2033),
    [anon_sym_LBRACK] = ACTIONS(2031),
    [anon_sym_LT] = ACTIONS(2031),
    [anon_sym_SLASH] = ACTIONS(2033),
    [anon_sym_class] = ACTIONS(2033),
    [anon_sym_async] = ACTIONS(2033),
    [anon_sym_function] = ACTIONS(2033),
    [anon_sym_new] = ACTIONS(2033),
    [anon_sym_PLUS] = ACTIONS(2033),
    [anon_sym_DASH] = ACTIONS(2033),
    [anon_sym_TILDE] = ACTIONS(2031),
    [anon_sym_void] = ACTIONS(2033),
    [anon_sym_delete] = ACTIONS(2033),
    [anon_sym_PLUS_PLUS] = ACTIONS(2031),
    [anon_sym_DASH_DASH] = ACTIONS(2031),
    [anon_sym_DQUOTE] = ACTIONS(2031),
    [anon_sym_SQUOTE] = ACTIONS(2031),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2031),
    [sym_number] = ACTIONS(2031),
    [sym_this] = ACTIONS(2033),
    [sym_super] = ACTIONS(2033),
    [sym_true] = ACTIONS(2033),
    [sym_false] = ACTIONS(2033),
    [sym_null] = ACTIONS(2033),
    [sym_undefined] = ACTIONS(2033),
    [anon_sym_AT] = ACTIONS(2031),
    [anon_sym_static] = ACTIONS(2033),
    [anon_sym_abstract] = ACTIONS(2033),
    [anon_sym_get] = ACTIONS(2033),
    [anon_sym_set] = ACTIONS(2033),
    [anon_sym_declare] = ACTIONS(2033),
    [anon_sym_public] = ACTIONS(2033),
    [anon_sym_private] = ACTIONS(2033),
    [anon_sym_protected] = ACTIONS(2033),
    [anon_sym_module] = ACTIONS(2033),
    [anon_sym_any] = ACTIONS(2033),
    [anon_sym_number] = ACTIONS(2033),
    [anon_sym_boolean] = ACTIONS(2033),
    [anon_sym_string] = ACTIONS(2033),
    [anon_sym_symbol] = ACTIONS(2033),
    [anon_sym_interface] = ACTIONS(2033),
    [anon_sym_enum] = ACTIONS(2033),
    [sym_readonly] = ACTIONS(2033),
  },
  [598] = {
    [ts_builtin_sym_end] = ACTIONS(2035),
    [sym_identifier] = ACTIONS(2037),
    [anon_sym_export] = ACTIONS(2037),
    [anon_sym_default] = ACTIONS(2037),
    [anon_sym_namespace] = ACTIONS(2037),
    [anon_sym_LBRACE] = ACTIONS(2035),
    [anon_sym_RBRACE] = ACTIONS(2035),
    [anon_sym_type] = ACTIONS(2037),
    [anon_sym_typeof] = ACTIONS(2037),
    [anon_sym_import] = ACTIONS(2037),
    [anon_sym_var] = ACTIONS(2037),
    [anon_sym_let] = ACTIONS(2037),
    [anon_sym_const] = ACTIONS(2037),
    [anon_sym_BANG] = ACTIONS(2035),
    [anon_sym_else] = ACTIONS(2037),
    [anon_sym_if] = ACTIONS(2037),
    [anon_sym_switch] = ACTIONS(2037),
    [anon_sym_for] = ACTIONS(2037),
    [anon_sym_LPAREN] = ACTIONS(2035),
    [anon_sym_await] = ACTIONS(2037),
    [anon_sym_while] = ACTIONS(2037),
    [anon_sym_do] = ACTIONS(2037),
    [anon_sym_try] = ACTIONS(2037),
    [anon_sym_with] = ACTIONS(2037),
    [anon_sym_break] = ACTIONS(2037),
    [anon_sym_continue] = ACTIONS(2037),
    [anon_sym_debugger] = ACTIONS(2037),
    [anon_sym_return] = ACTIONS(2037),
    [anon_sym_throw] = ACTIONS(2037),
    [anon_sym_SEMI] = ACTIONS(2035),
    [anon_sym_case] = ACTIONS(2037),
    [anon_sym_yield] = ACTIONS(2037),
    [anon_sym_LBRACK] = ACTIONS(2035),
    [anon_sym_LT] = ACTIONS(2035),
    [anon_sym_SLASH] = ACTIONS(2037),
    [anon_sym_class] = ACTIONS(2037),
    [anon_sym_async] = ACTIONS(2037),
    [anon_sym_function] = ACTIONS(2037),
    [anon_sym_new] = ACTIONS(2037),
    [anon_sym_PLUS] = ACTIONS(2037),
    [anon_sym_DASH] = ACTIONS(2037),
    [anon_sym_TILDE] = ACTIONS(2035),
    [anon_sym_void] = ACTIONS(2037),
    [anon_sym_delete] = ACTIONS(2037),
    [anon_sym_PLUS_PLUS] = ACTIONS(2035),
    [anon_sym_DASH_DASH] = ACTIONS(2035),
    [anon_sym_DQUOTE] = ACTIONS(2035),
    [anon_sym_SQUOTE] = ACTIONS(2035),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2035),
    [sym_number] = ACTIONS(2035),
    [sym_this] = ACTIONS(2037),
    [sym_super] = ACTIONS(2037),
    [sym_true] = ACTIONS(2037),
    [sym_false] = ACTIONS(2037),
    [sym_null] = ACTIONS(2037),
    [sym_undefined] = ACTIONS(2037),
    [anon_sym_AT] = ACTIONS(2035),
    [anon_sym_static] = ACTIONS(2037),
    [anon_sym_abstract] = ACTIONS(2037),
    [anon_sym_get] = ACTIONS(2037),
    [anon_sym_set] = ACTIONS(2037),
    [anon_sym_declare] = ACTIONS(2037),
    [anon_sym_public] = ACTIONS(2037),
    [anon_sym_private] = ACTIONS(2037),
    [anon_sym_protected] = ACTIONS(2037),
    [anon_sym_module] = ACTIONS(2037),
    [anon_sym_any] = ACTIONS(2037),
    [anon_sym_number] = ACTIONS(2037),
    [anon_sym_boolean] = ACTIONS(2037),
    [anon_sym_string] = ACTIONS(2037),
    [anon_sym_symbol] = ACTIONS(2037),
    [anon_sym_interface] = ACTIONS(2037),
    [anon_sym_enum] = ACTIONS(2037),
    [sym_readonly] = ACTIONS(2037),
  },
  [599] = {
    [ts_builtin_sym_end] = ACTIONS(2039),
    [sym_identifier] = ACTIONS(2041),
    [anon_sym_export] = ACTIONS(2041),
    [anon_sym_default] = ACTIONS(2041),
    [anon_sym_namespace] = ACTIONS(2041),
    [anon_sym_LBRACE] = ACTIONS(2039),
    [anon_sym_RBRACE] = ACTIONS(2039),
    [anon_sym_type] = ACTIONS(2041),
    [anon_sym_typeof] = ACTIONS(2041),
    [anon_sym_import] = ACTIONS(2041),
    [anon_sym_var] = ACTIONS(2041),
    [anon_sym_let] = ACTIONS(2041),
    [anon_sym_const] = ACTIONS(2041),
    [anon_sym_BANG] = ACTIONS(2039),
    [anon_sym_else] = ACTIONS(2041),
    [anon_sym_if] = ACTIONS(2041),
    [anon_sym_switch] = ACTIONS(2041),
    [anon_sym_for] = ACTIONS(2041),
    [anon_sym_LPAREN] = ACTIONS(2039),
    [anon_sym_await] = ACTIONS(2041),
    [anon_sym_while] = ACTIONS(2041),
    [anon_sym_do] = ACTIONS(2041),
    [anon_sym_try] = ACTIONS(2041),
    [anon_sym_with] = ACTIONS(2041),
    [anon_sym_break] = ACTIONS(2041),
    [anon_sym_continue] = ACTIONS(2041),
    [anon_sym_debugger] = ACTIONS(2041),
    [anon_sym_return] = ACTIONS(2041),
    [anon_sym_throw] = ACTIONS(2041),
    [anon_sym_SEMI] = ACTIONS(2039),
    [anon_sym_case] = ACTIONS(2041),
    [anon_sym_yield] = ACTIONS(2041),
    [anon_sym_LBRACK] = ACTIONS(2039),
    [anon_sym_LT] = ACTIONS(2039),
    [anon_sym_SLASH] = ACTIONS(2041),
    [anon_sym_class] = ACTIONS(2041),
    [anon_sym_async] = ACTIONS(2041),
    [anon_sym_function] = ACTIONS(2041),
    [anon_sym_new] = ACTIONS(2041),
    [anon_sym_PLUS] = ACTIONS(2041),
    [anon_sym_DASH] = ACTIONS(2041),
    [anon_sym_TILDE] = ACTIONS(2039),
    [anon_sym_void] = ACTIONS(2041),
    [anon_sym_delete] = ACTIONS(2041),
    [anon_sym_PLUS_PLUS] = ACTIONS(2039),
    [anon_sym_DASH_DASH] = ACTIONS(2039),
    [anon_sym_DQUOTE] = ACTIONS(2039),
    [anon_sym_SQUOTE] = ACTIONS(2039),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2039),
    [sym_number] = ACTIONS(2039),
    [sym_this] = ACTIONS(2041),
    [sym_super] = ACTIONS(2041),
    [sym_true] = ACTIONS(2041),
    [sym_false] = ACTIONS(2041),
    [sym_null] = ACTIONS(2041),
    [sym_undefined] = ACTIONS(2041),
    [anon_sym_AT] = ACTIONS(2039),
    [anon_sym_static] = ACTIONS(2041),
    [anon_sym_abstract] = ACTIONS(2041),
    [anon_sym_get] = ACTIONS(2041),
    [anon_sym_set] = ACTIONS(2041),
    [anon_sym_declare] = ACTIONS(2041),
    [anon_sym_public] = ACTIONS(2041),
    [anon_sym_private] = ACTIONS(2041),
    [anon_sym_protected] = ACTIONS(2041),
    [anon_sym_module] = ACTIONS(2041),
    [anon_sym_any] = ACTIONS(2041),
    [anon_sym_number] = ACTIONS(2041),
    [anon_sym_boolean] = ACTIONS(2041),
    [anon_sym_string] = ACTIONS(2041),
    [anon_sym_symbol] = ACTIONS(2041),
    [anon_sym_interface] = ACTIONS(2041),
    [anon_sym_enum] = ACTIONS(2041),
    [sym_readonly] = ACTIONS(2041),
  },
  [600] = {
    [ts_builtin_sym_end] = ACTIONS(2043),
    [sym_identifier] = ACTIONS(2045),
    [anon_sym_export] = ACTIONS(2045),
    [anon_sym_default] = ACTIONS(2045),
    [anon_sym_namespace] = ACTIONS(2045),
    [anon_sym_LBRACE] = ACTIONS(2043),
    [anon_sym_RBRACE] = ACTIONS(2043),
    [anon_sym_type] = ACTIONS(2045),
    [anon_sym_typeof] = ACTIONS(2045),
    [anon_sym_import] = ACTIONS(2045),
    [anon_sym_var] = ACTIONS(2045),
    [anon_sym_let] = ACTIONS(2045),
    [anon_sym_const] = ACTIONS(2045),
    [anon_sym_BANG] = ACTIONS(2043),
    [anon_sym_else] = ACTIONS(2045),
    [anon_sym_if] = ACTIONS(2045),
    [anon_sym_switch] = ACTIONS(2045),
    [anon_sym_for] = ACTIONS(2045),
    [anon_sym_LPAREN] = ACTIONS(2043),
    [anon_sym_await] = ACTIONS(2045),
    [anon_sym_while] = ACTIONS(2045),
    [anon_sym_do] = ACTIONS(2045),
    [anon_sym_try] = ACTIONS(2045),
    [anon_sym_with] = ACTIONS(2045),
    [anon_sym_break] = ACTIONS(2045),
    [anon_sym_continue] = ACTIONS(2045),
    [anon_sym_debugger] = ACTIONS(2045),
    [anon_sym_return] = ACTIONS(2045),
    [anon_sym_throw] = ACTIONS(2045),
    [anon_sym_SEMI] = ACTIONS(2043),
    [anon_sym_case] = ACTIONS(2045),
    [anon_sym_yield] = ACTIONS(2045),
    [anon_sym_LBRACK] = ACTIONS(2043),
    [anon_sym_LT] = ACTIONS(2043),
    [anon_sym_SLASH] = ACTIONS(2045),
    [anon_sym_class] = ACTIONS(2045),
    [anon_sym_async] = ACTIONS(2045),
    [anon_sym_function] = ACTIONS(2045),
    [anon_sym_new] = ACTIONS(2045),
    [anon_sym_PLUS] = ACTIONS(2045),
    [anon_sym_DASH] = ACTIONS(2045),
    [anon_sym_TILDE] = ACTIONS(2043),
    [anon_sym_void] = ACTIONS(2045),
    [anon_sym_delete] = ACTIONS(2045),
    [anon_sym_PLUS_PLUS] = ACTIONS(2043),
    [anon_sym_DASH_DASH] = ACTIONS(2043),
    [anon_sym_DQUOTE] = ACTIONS(2043),
    [anon_sym_SQUOTE] = ACTIONS(2043),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2043),
    [sym_number] = ACTIONS(2043),
    [sym_this] = ACTIONS(2045),
    [sym_super] = ACTIONS(2045),
    [sym_true] = ACTIONS(2045),
    [sym_false] = ACTIONS(2045),
    [sym_null] = ACTIONS(2045),
    [sym_undefined] = ACTIONS(2045),
    [anon_sym_AT] = ACTIONS(2043),
    [anon_sym_static] = ACTIONS(2045),
    [anon_sym_abstract] = ACTIONS(2045),
    [anon_sym_get] = ACTIONS(2045),
    [anon_sym_set] = ACTIONS(2045),
    [anon_sym_declare] = ACTIONS(2045),
    [anon_sym_public] = ACTIONS(2045),
    [anon_sym_private] = ACTIONS(2045),
    [anon_sym_protected] = ACTIONS(2045),
    [anon_sym_module] = ACTIONS(2045),
    [anon_sym_any] = ACTIONS(2045),
    [anon_sym_number] = ACTIONS(2045),
    [anon_sym_boolean] = ACTIONS(2045),
    [anon_sym_string] = ACTIONS(2045),
    [anon_sym_symbol] = ACTIONS(2045),
    [anon_sym_interface] = ACTIONS(2045),
    [anon_sym_enum] = ACTIONS(2045),
    [sym_readonly] = ACTIONS(2045),
  },
  [601] = {
    [ts_builtin_sym_end] = ACTIONS(2047),
    [sym_identifier] = ACTIONS(2049),
    [anon_sym_export] = ACTIONS(2049),
    [anon_sym_default] = ACTIONS(2049),
    [anon_sym_namespace] = ACTIONS(2049),
    [anon_sym_LBRACE] = ACTIONS(2047),
    [anon_sym_RBRACE] = ACTIONS(2047),
    [anon_sym_type] = ACTIONS(2049),
    [anon_sym_typeof] = ACTIONS(2049),
    [anon_sym_import] = ACTIONS(2049),
    [anon_sym_var] = ACTIONS(2049),
    [anon_sym_let] = ACTIONS(2049),
    [anon_sym_const] = ACTIONS(2049),
    [anon_sym_BANG] = ACTIONS(2047),
    [anon_sym_else] = ACTIONS(2049),
    [anon_sym_if] = ACTIONS(2049),
    [anon_sym_switch] = ACTIONS(2049),
    [anon_sym_for] = ACTIONS(2049),
    [anon_sym_LPAREN] = ACTIONS(2047),
    [anon_sym_await] = ACTIONS(2049),
    [anon_sym_while] = ACTIONS(2049),
    [anon_sym_do] = ACTIONS(2049),
    [anon_sym_try] = ACTIONS(2049),
    [anon_sym_with] = ACTIONS(2049),
    [anon_sym_break] = ACTIONS(2049),
    [anon_sym_continue] = ACTIONS(2049),
    [anon_sym_debugger] = ACTIONS(2049),
    [anon_sym_return] = ACTIONS(2049),
    [anon_sym_throw] = ACTIONS(2049),
    [anon_sym_SEMI] = ACTIONS(2047),
    [anon_sym_case] = ACTIONS(2049),
    [anon_sym_yield] = ACTIONS(2049),
    [anon_sym_LBRACK] = ACTIONS(2047),
    [anon_sym_LT] = ACTIONS(2047),
    [anon_sym_SLASH] = ACTIONS(2049),
    [anon_sym_class] = ACTIONS(2049),
    [anon_sym_async] = ACTIONS(2049),
    [anon_sym_function] = ACTIONS(2049),
    [anon_sym_new] = ACTIONS(2049),
    [anon_sym_PLUS] = ACTIONS(2049),
    [anon_sym_DASH] = ACTIONS(2049),
    [anon_sym_TILDE] = ACTIONS(2047),
    [anon_sym_void] = ACTIONS(2049),
    [anon_sym_delete] = ACTIONS(2049),
    [anon_sym_PLUS_PLUS] = ACTIONS(2047),
    [anon_sym_DASH_DASH] = ACTIONS(2047),
    [anon_sym_DQUOTE] = ACTIONS(2047),
    [anon_sym_SQUOTE] = ACTIONS(2047),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2047),
    [sym_number] = ACTIONS(2047),
    [sym_this] = ACTIONS(2049),
    [sym_super] = ACTIONS(2049),
    [sym_true] = ACTIONS(2049),
    [sym_false] = ACTIONS(2049),
    [sym_null] = ACTIONS(2049),
    [sym_undefined] = ACTIONS(2049),
    [anon_sym_AT] = ACTIONS(2047),
    [anon_sym_static] = ACTIONS(2049),
    [anon_sym_abstract] = ACTIONS(2049),
    [anon_sym_get] = ACTIONS(2049),
    [anon_sym_set] = ACTIONS(2049),
    [anon_sym_declare] = ACTIONS(2049),
    [anon_sym_public] = ACTIONS(2049),
    [anon_sym_private] = ACTIONS(2049),
    [anon_sym_protected] = ACTIONS(2049),
    [anon_sym_module] = ACTIONS(2049),
    [anon_sym_any] = ACTIONS(2049),
    [anon_sym_number] = ACTIONS(2049),
    [anon_sym_boolean] = ACTIONS(2049),
    [anon_sym_string] = ACTIONS(2049),
    [anon_sym_symbol] = ACTIONS(2049),
    [anon_sym_interface] = ACTIONS(2049),
    [anon_sym_enum] = ACTIONS(2049),
    [sym_readonly] = ACTIONS(2049),
  },
  [602] = {
    [ts_builtin_sym_end] = ACTIONS(2051),
    [sym_identifier] = ACTIONS(2053),
    [anon_sym_export] = ACTIONS(2053),
    [anon_sym_default] = ACTIONS(2053),
    [anon_sym_namespace] = ACTIONS(2053),
    [anon_sym_LBRACE] = ACTIONS(2051),
    [anon_sym_RBRACE] = ACTIONS(2051),
    [anon_sym_type] = ACTIONS(2053),
    [anon_sym_typeof] = ACTIONS(2053),
    [anon_sym_import] = ACTIONS(2053),
    [anon_sym_var] = ACTIONS(2053),
    [anon_sym_let] = ACTIONS(2053),
    [anon_sym_const] = ACTIONS(2053),
    [anon_sym_BANG] = ACTIONS(2051),
    [anon_sym_else] = ACTIONS(2053),
    [anon_sym_if] = ACTIONS(2053),
    [anon_sym_switch] = ACTIONS(2053),
    [anon_sym_for] = ACTIONS(2053),
    [anon_sym_LPAREN] = ACTIONS(2051),
    [anon_sym_await] = ACTIONS(2053),
    [anon_sym_while] = ACTIONS(2053),
    [anon_sym_do] = ACTIONS(2053),
    [anon_sym_try] = ACTIONS(2053),
    [anon_sym_with] = ACTIONS(2053),
    [anon_sym_break] = ACTIONS(2053),
    [anon_sym_continue] = ACTIONS(2053),
    [anon_sym_debugger] = ACTIONS(2053),
    [anon_sym_return] = ACTIONS(2053),
    [anon_sym_throw] = ACTIONS(2053),
    [anon_sym_SEMI] = ACTIONS(2051),
    [anon_sym_case] = ACTIONS(2053),
    [anon_sym_yield] = ACTIONS(2053),
    [anon_sym_LBRACK] = ACTIONS(2051),
    [anon_sym_LT] = ACTIONS(2051),
    [anon_sym_SLASH] = ACTIONS(2053),
    [anon_sym_class] = ACTIONS(2053),
    [anon_sym_async] = ACTIONS(2053),
    [anon_sym_function] = ACTIONS(2053),
    [anon_sym_new] = ACTIONS(2053),
    [anon_sym_PLUS] = ACTIONS(2053),
    [anon_sym_DASH] = ACTIONS(2053),
    [anon_sym_TILDE] = ACTIONS(2051),
    [anon_sym_void] = ACTIONS(2053),
    [anon_sym_delete] = ACTIONS(2053),
    [anon_sym_PLUS_PLUS] = ACTIONS(2051),
    [anon_sym_DASH_DASH] = ACTIONS(2051),
    [anon_sym_DQUOTE] = ACTIONS(2051),
    [anon_sym_SQUOTE] = ACTIONS(2051),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2051),
    [sym_number] = ACTIONS(2051),
    [sym_this] = ACTIONS(2053),
    [sym_super] = ACTIONS(2053),
    [sym_true] = ACTIONS(2053),
    [sym_false] = ACTIONS(2053),
    [sym_null] = ACTIONS(2053),
    [sym_undefined] = ACTIONS(2053),
    [anon_sym_AT] = ACTIONS(2051),
    [anon_sym_static] = ACTIONS(2053),
    [anon_sym_abstract] = ACTIONS(2053),
    [anon_sym_get] = ACTIONS(2053),
    [anon_sym_set] = ACTIONS(2053),
    [anon_sym_declare] = ACTIONS(2053),
    [anon_sym_public] = ACTIONS(2053),
    [anon_sym_private] = ACTIONS(2053),
    [anon_sym_protected] = ACTIONS(2053),
    [anon_sym_module] = ACTIONS(2053),
    [anon_sym_any] = ACTIONS(2053),
    [anon_sym_number] = ACTIONS(2053),
    [anon_sym_boolean] = ACTIONS(2053),
    [anon_sym_string] = ACTIONS(2053),
    [anon_sym_symbol] = ACTIONS(2053),
    [anon_sym_interface] = ACTIONS(2053),
    [anon_sym_enum] = ACTIONS(2053),
    [sym_readonly] = ACTIONS(2053),
  },
  [603] = {
    [ts_builtin_sym_end] = ACTIONS(2055),
    [sym_identifier] = ACTIONS(2057),
    [anon_sym_export] = ACTIONS(2057),
    [anon_sym_default] = ACTIONS(2057),
    [anon_sym_namespace] = ACTIONS(2057),
    [anon_sym_LBRACE] = ACTIONS(2055),
    [anon_sym_RBRACE] = ACTIONS(2055),
    [anon_sym_type] = ACTIONS(2057),
    [anon_sym_typeof] = ACTIONS(2057),
    [anon_sym_import] = ACTIONS(2057),
    [anon_sym_var] = ACTIONS(2057),
    [anon_sym_let] = ACTIONS(2057),
    [anon_sym_const] = ACTIONS(2057),
    [anon_sym_BANG] = ACTIONS(2055),
    [anon_sym_else] = ACTIONS(2057),
    [anon_sym_if] = ACTIONS(2057),
    [anon_sym_switch] = ACTIONS(2057),
    [anon_sym_for] = ACTIONS(2057),
    [anon_sym_LPAREN] = ACTIONS(2055),
    [anon_sym_await] = ACTIONS(2057),
    [anon_sym_while] = ACTIONS(2057),
    [anon_sym_do] = ACTIONS(2057),
    [anon_sym_try] = ACTIONS(2057),
    [anon_sym_with] = ACTIONS(2057),
    [anon_sym_break] = ACTIONS(2057),
    [anon_sym_continue] = ACTIONS(2057),
    [anon_sym_debugger] = ACTIONS(2057),
    [anon_sym_return] = ACTIONS(2057),
    [anon_sym_throw] = ACTIONS(2057),
    [anon_sym_SEMI] = ACTIONS(2055),
    [anon_sym_case] = ACTIONS(2057),
    [anon_sym_yield] = ACTIONS(2057),
    [anon_sym_LBRACK] = ACTIONS(2055),
    [anon_sym_LT] = ACTIONS(2055),
    [anon_sym_SLASH] = ACTIONS(2057),
    [anon_sym_class] = ACTIONS(2057),
    [anon_sym_async] = ACTIONS(2057),
    [anon_sym_function] = ACTIONS(2057),
    [anon_sym_new] = ACTIONS(2057),
    [anon_sym_PLUS] = ACTIONS(2057),
    [anon_sym_DASH] = ACTIONS(2057),
    [anon_sym_TILDE] = ACTIONS(2055),
    [anon_sym_void] = ACTIONS(2057),
    [anon_sym_delete] = ACTIONS(2057),
    [anon_sym_PLUS_PLUS] = ACTIONS(2055),
    [anon_sym_DASH_DASH] = ACTIONS(2055),
    [anon_sym_DQUOTE] = ACTIONS(2055),
    [anon_sym_SQUOTE] = ACTIONS(2055),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2055),
    [sym_number] = ACTIONS(2055),
    [sym_this] = ACTIONS(2057),
    [sym_super] = ACTIONS(2057),
    [sym_true] = ACTIONS(2057),
    [sym_false] = ACTIONS(2057),
    [sym_null] = ACTIONS(2057),
    [sym_undefined] = ACTIONS(2057),
    [anon_sym_AT] = ACTIONS(2055),
    [anon_sym_static] = ACTIONS(2057),
    [anon_sym_abstract] = ACTIONS(2057),
    [anon_sym_get] = ACTIONS(2057),
    [anon_sym_set] = ACTIONS(2057),
    [anon_sym_declare] = ACTIONS(2057),
    [anon_sym_public] = ACTIONS(2057),
    [anon_sym_private] = ACTIONS(2057),
    [anon_sym_protected] = ACTIONS(2057),
    [anon_sym_module] = ACTIONS(2057),
    [anon_sym_any] = ACTIONS(2057),
    [anon_sym_number] = ACTIONS(2057),
    [anon_sym_boolean] = ACTIONS(2057),
    [anon_sym_string] = ACTIONS(2057),
    [anon_sym_symbol] = ACTIONS(2057),
    [anon_sym_interface] = ACTIONS(2057),
    [anon_sym_enum] = ACTIONS(2057),
    [sym_readonly] = ACTIONS(2057),
  },
  [604] = {
    [ts_builtin_sym_end] = ACTIONS(2059),
    [sym_identifier] = ACTIONS(2061),
    [anon_sym_export] = ACTIONS(2061),
    [anon_sym_default] = ACTIONS(2061),
    [anon_sym_namespace] = ACTIONS(2061),
    [anon_sym_LBRACE] = ACTIONS(2059),
    [anon_sym_RBRACE] = ACTIONS(2059),
    [anon_sym_type] = ACTIONS(2061),
    [anon_sym_typeof] = ACTIONS(2061),
    [anon_sym_import] = ACTIONS(2061),
    [anon_sym_var] = ACTIONS(2061),
    [anon_sym_let] = ACTIONS(2061),
    [anon_sym_const] = ACTIONS(2061),
    [anon_sym_BANG] = ACTIONS(2059),
    [anon_sym_else] = ACTIONS(2061),
    [anon_sym_if] = ACTIONS(2061),
    [anon_sym_switch] = ACTIONS(2061),
    [anon_sym_for] = ACTIONS(2061),
    [anon_sym_LPAREN] = ACTIONS(2059),
    [anon_sym_await] = ACTIONS(2061),
    [anon_sym_while] = ACTIONS(2061),
    [anon_sym_do] = ACTIONS(2061),
    [anon_sym_try] = ACTIONS(2061),
    [anon_sym_with] = ACTIONS(2061),
    [anon_sym_break] = ACTIONS(2061),
    [anon_sym_continue] = ACTIONS(2061),
    [anon_sym_debugger] = ACTIONS(2061),
    [anon_sym_return] = ACTIONS(2061),
    [anon_sym_throw] = ACTIONS(2061),
    [anon_sym_SEMI] = ACTIONS(2059),
    [anon_sym_case] = ACTIONS(2061),
    [anon_sym_yield] = ACTIONS(2061),
    [anon_sym_LBRACK] = ACTIONS(2059),
    [anon_sym_LT] = ACTIONS(2059),
    [anon_sym_SLASH] = ACTIONS(2061),
    [anon_sym_class] = ACTIONS(2061),
    [anon_sym_async] = ACTIONS(2061),
    [anon_sym_function] = ACTIONS(2061),
    [anon_sym_new] = ACTIONS(2061),
    [anon_sym_PLUS] = ACTIONS(2061),
    [anon_sym_DASH] = ACTIONS(2061),
    [anon_sym_TILDE] = ACTIONS(2059),
    [anon_sym_void] = ACTIONS(2061),
    [anon_sym_delete] = ACTIONS(2061),
    [anon_sym_PLUS_PLUS] = ACTIONS(2059),
    [anon_sym_DASH_DASH] = ACTIONS(2059),
    [anon_sym_DQUOTE] = ACTIONS(2059),
    [anon_sym_SQUOTE] = ACTIONS(2059),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2059),
    [sym_number] = ACTIONS(2059),
    [sym_this] = ACTIONS(2061),
    [sym_super] = ACTIONS(2061),
    [sym_true] = ACTIONS(2061),
    [sym_false] = ACTIONS(2061),
    [sym_null] = ACTIONS(2061),
    [sym_undefined] = ACTIONS(2061),
    [anon_sym_AT] = ACTIONS(2059),
    [anon_sym_static] = ACTIONS(2061),
    [anon_sym_abstract] = ACTIONS(2061),
    [anon_sym_get] = ACTIONS(2061),
    [anon_sym_set] = ACTIONS(2061),
    [anon_sym_declare] = ACTIONS(2061),
    [anon_sym_public] = ACTIONS(2061),
    [anon_sym_private] = ACTIONS(2061),
    [anon_sym_protected] = ACTIONS(2061),
    [anon_sym_module] = ACTIONS(2061),
    [anon_sym_any] = ACTIONS(2061),
    [anon_sym_number] = ACTIONS(2061),
    [anon_sym_boolean] = ACTIONS(2061),
    [anon_sym_string] = ACTIONS(2061),
    [anon_sym_symbol] = ACTIONS(2061),
    [anon_sym_interface] = ACTIONS(2061),
    [anon_sym_enum] = ACTIONS(2061),
    [sym_readonly] = ACTIONS(2061),
  },
  [605] = {
    [ts_builtin_sym_end] = ACTIONS(2063),
    [sym_identifier] = ACTIONS(2065),
    [anon_sym_export] = ACTIONS(2065),
    [anon_sym_default] = ACTIONS(2065),
    [anon_sym_namespace] = ACTIONS(2065),
    [anon_sym_LBRACE] = ACTIONS(2063),
    [anon_sym_RBRACE] = ACTIONS(2063),
    [anon_sym_type] = ACTIONS(2065),
    [anon_sym_typeof] = ACTIONS(2065),
    [anon_sym_import] = ACTIONS(2065),
    [anon_sym_var] = ACTIONS(2065),
    [anon_sym_let] = ACTIONS(2065),
    [anon_sym_const] = ACTIONS(2065),
    [anon_sym_BANG] = ACTIONS(2063),
    [anon_sym_else] = ACTIONS(2065),
    [anon_sym_if] = ACTIONS(2065),
    [anon_sym_switch] = ACTIONS(2065),
    [anon_sym_for] = ACTIONS(2065),
    [anon_sym_LPAREN] = ACTIONS(2063),
    [anon_sym_await] = ACTIONS(2065),
    [anon_sym_while] = ACTIONS(2065),
    [anon_sym_do] = ACTIONS(2065),
    [anon_sym_try] = ACTIONS(2065),
    [anon_sym_with] = ACTIONS(2065),
    [anon_sym_break] = ACTIONS(2065),
    [anon_sym_continue] = ACTIONS(2065),
    [anon_sym_debugger] = ACTIONS(2065),
    [anon_sym_return] = ACTIONS(2065),
    [anon_sym_throw] = ACTIONS(2065),
    [anon_sym_SEMI] = ACTIONS(2063),
    [anon_sym_case] = ACTIONS(2065),
    [anon_sym_yield] = ACTIONS(2065),
    [anon_sym_LBRACK] = ACTIONS(2063),
    [anon_sym_LT] = ACTIONS(2063),
    [anon_sym_SLASH] = ACTIONS(2065),
    [anon_sym_class] = ACTIONS(2065),
    [anon_sym_async] = ACTIONS(2065),
    [anon_sym_function] = ACTIONS(2065),
    [anon_sym_new] = ACTIONS(2065),
    [anon_sym_PLUS] = ACTIONS(2065),
    [anon_sym_DASH] = ACTIONS(2065),
    [anon_sym_TILDE] = ACTIONS(2063),
    [anon_sym_void] = ACTIONS(2065),
    [anon_sym_delete] = ACTIONS(2065),
    [anon_sym_PLUS_PLUS] = ACTIONS(2063),
    [anon_sym_DASH_DASH] = ACTIONS(2063),
    [anon_sym_DQUOTE] = ACTIONS(2063),
    [anon_sym_SQUOTE] = ACTIONS(2063),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2063),
    [sym_number] = ACTIONS(2063),
    [sym_this] = ACTIONS(2065),
    [sym_super] = ACTIONS(2065),
    [sym_true] = ACTIONS(2065),
    [sym_false] = ACTIONS(2065),
    [sym_null] = ACTIONS(2065),
    [sym_undefined] = ACTIONS(2065),
    [anon_sym_AT] = ACTIONS(2063),
    [anon_sym_static] = ACTIONS(2065),
    [anon_sym_abstract] = ACTIONS(2065),
    [anon_sym_get] = ACTIONS(2065),
    [anon_sym_set] = ACTIONS(2065),
    [anon_sym_declare] = ACTIONS(2065),
    [anon_sym_public] = ACTIONS(2065),
    [anon_sym_private] = ACTIONS(2065),
    [anon_sym_protected] = ACTIONS(2065),
    [anon_sym_module] = ACTIONS(2065),
    [anon_sym_any] = ACTIONS(2065),
    [anon_sym_number] = ACTIONS(2065),
    [anon_sym_boolean] = ACTIONS(2065),
    [anon_sym_string] = ACTIONS(2065),
    [anon_sym_symbol] = ACTIONS(2065),
    [anon_sym_interface] = ACTIONS(2065),
    [anon_sym_enum] = ACTIONS(2065),
    [sym_readonly] = ACTIONS(2065),
  },
  [606] = {
    [ts_builtin_sym_end] = ACTIONS(2067),
    [sym_identifier] = ACTIONS(2069),
    [anon_sym_export] = ACTIONS(2069),
    [anon_sym_default] = ACTIONS(2069),
    [anon_sym_namespace] = ACTIONS(2069),
    [anon_sym_LBRACE] = ACTIONS(2067),
    [anon_sym_RBRACE] = ACTIONS(2067),
    [anon_sym_type] = ACTIONS(2069),
    [anon_sym_typeof] = ACTIONS(2069),
    [anon_sym_import] = ACTIONS(2069),
    [anon_sym_var] = ACTIONS(2069),
    [anon_sym_let] = ACTIONS(2069),
    [anon_sym_const] = ACTIONS(2069),
    [anon_sym_BANG] = ACTIONS(2067),
    [anon_sym_else] = ACTIONS(2069),
    [anon_sym_if] = ACTIONS(2069),
    [anon_sym_switch] = ACTIONS(2069),
    [anon_sym_for] = ACTIONS(2069),
    [anon_sym_LPAREN] = ACTIONS(2067),
    [anon_sym_await] = ACTIONS(2069),
    [anon_sym_while] = ACTIONS(2069),
    [anon_sym_do] = ACTIONS(2069),
    [anon_sym_try] = ACTIONS(2069),
    [anon_sym_with] = ACTIONS(2069),
    [anon_sym_break] = ACTIONS(2069),
    [anon_sym_continue] = ACTIONS(2069),
    [anon_sym_debugger] = ACTIONS(2069),
    [anon_sym_return] = ACTIONS(2069),
    [anon_sym_throw] = ACTIONS(2069),
    [anon_sym_SEMI] = ACTIONS(2067),
    [anon_sym_case] = ACTIONS(2069),
    [anon_sym_yield] = ACTIONS(2069),
    [anon_sym_LBRACK] = ACTIONS(2067),
    [anon_sym_LT] = ACTIONS(2067),
    [anon_sym_SLASH] = ACTIONS(2069),
    [anon_sym_class] = ACTIONS(2069),
    [anon_sym_async] = ACTIONS(2069),
    [anon_sym_function] = ACTIONS(2069),
    [anon_sym_new] = ACTIONS(2069),
    [anon_sym_PLUS] = ACTIONS(2069),
    [anon_sym_DASH] = ACTIONS(2069),
    [anon_sym_TILDE] = ACTIONS(2067),
    [anon_sym_void] = ACTIONS(2069),
    [anon_sym_delete] = ACTIONS(2069),
    [anon_sym_PLUS_PLUS] = ACTIONS(2067),
    [anon_sym_DASH_DASH] = ACTIONS(2067),
    [anon_sym_DQUOTE] = ACTIONS(2067),
    [anon_sym_SQUOTE] = ACTIONS(2067),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2067),
    [sym_number] = ACTIONS(2067),
    [sym_this] = ACTIONS(2069),
    [sym_super] = ACTIONS(2069),
    [sym_true] = ACTIONS(2069),
    [sym_false] = ACTIONS(2069),
    [sym_null] = ACTIONS(2069),
    [sym_undefined] = ACTIONS(2069),
    [anon_sym_AT] = ACTIONS(2067),
    [anon_sym_static] = ACTIONS(2069),
    [anon_sym_abstract] = ACTIONS(2069),
    [anon_sym_get] = ACTIONS(2069),
    [anon_sym_set] = ACTIONS(2069),
    [anon_sym_declare] = ACTIONS(2069),
    [anon_sym_public] = ACTIONS(2069),
    [anon_sym_private] = ACTIONS(2069),
    [anon_sym_protected] = ACTIONS(2069),
    [anon_sym_module] = ACTIONS(2069),
    [anon_sym_any] = ACTIONS(2069),
    [anon_sym_number] = ACTIONS(2069),
    [anon_sym_boolean] = ACTIONS(2069),
    [anon_sym_string] = ACTIONS(2069),
    [anon_sym_symbol] = ACTIONS(2069),
    [anon_sym_interface] = ACTIONS(2069),
    [anon_sym_enum] = ACTIONS(2069),
    [sym_readonly] = ACTIONS(2069),
  },
  [607] = {
    [ts_builtin_sym_end] = ACTIONS(2071),
    [sym_identifier] = ACTIONS(2073),
    [anon_sym_export] = ACTIONS(2073),
    [anon_sym_default] = ACTIONS(2073),
    [anon_sym_namespace] = ACTIONS(2073),
    [anon_sym_LBRACE] = ACTIONS(2071),
    [anon_sym_RBRACE] = ACTIONS(2071),
    [anon_sym_type] = ACTIONS(2073),
    [anon_sym_typeof] = ACTIONS(2073),
    [anon_sym_import] = ACTIONS(2073),
    [anon_sym_var] = ACTIONS(2073),
    [anon_sym_let] = ACTIONS(2073),
    [anon_sym_const] = ACTIONS(2073),
    [anon_sym_BANG] = ACTIONS(2071),
    [anon_sym_else] = ACTIONS(2073),
    [anon_sym_if] = ACTIONS(2073),
    [anon_sym_switch] = ACTIONS(2073),
    [anon_sym_for] = ACTIONS(2073),
    [anon_sym_LPAREN] = ACTIONS(2071),
    [anon_sym_await] = ACTIONS(2073),
    [anon_sym_while] = ACTIONS(2073),
    [anon_sym_do] = ACTIONS(2073),
    [anon_sym_try] = ACTIONS(2073),
    [anon_sym_with] = ACTIONS(2073),
    [anon_sym_break] = ACTIONS(2073),
    [anon_sym_continue] = ACTIONS(2073),
    [anon_sym_debugger] = ACTIONS(2073),
    [anon_sym_return] = ACTIONS(2073),
    [anon_sym_throw] = ACTIONS(2073),
    [anon_sym_SEMI] = ACTIONS(2071),
    [anon_sym_case] = ACTIONS(2073),
    [anon_sym_yield] = ACTIONS(2073),
    [anon_sym_LBRACK] = ACTIONS(2071),
    [anon_sym_LT] = ACTIONS(2071),
    [anon_sym_SLASH] = ACTIONS(2073),
    [anon_sym_class] = ACTIONS(2073),
    [anon_sym_async] = ACTIONS(2073),
    [anon_sym_function] = ACTIONS(2073),
    [anon_sym_new] = ACTIONS(2073),
    [anon_sym_PLUS] = ACTIONS(2073),
    [anon_sym_DASH] = ACTIONS(2073),
    [anon_sym_TILDE] = ACTIONS(2071),
    [anon_sym_void] = ACTIONS(2073),
    [anon_sym_delete] = ACTIONS(2073),
    [anon_sym_PLUS_PLUS] = ACTIONS(2071),
    [anon_sym_DASH_DASH] = ACTIONS(2071),
    [anon_sym_DQUOTE] = ACTIONS(2071),
    [anon_sym_SQUOTE] = ACTIONS(2071),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2071),
    [sym_number] = ACTIONS(2071),
    [sym_this] = ACTIONS(2073),
    [sym_super] = ACTIONS(2073),
    [sym_true] = ACTIONS(2073),
    [sym_false] = ACTIONS(2073),
    [sym_null] = ACTIONS(2073),
    [sym_undefined] = ACTIONS(2073),
    [anon_sym_AT] = ACTIONS(2071),
    [anon_sym_static] = ACTIONS(2073),
    [anon_sym_abstract] = ACTIONS(2073),
    [anon_sym_get] = ACTIONS(2073),
    [anon_sym_set] = ACTIONS(2073),
    [anon_sym_declare] = ACTIONS(2073),
    [anon_sym_public] = ACTIONS(2073),
    [anon_sym_private] = ACTIONS(2073),
    [anon_sym_protected] = ACTIONS(2073),
    [anon_sym_module] = ACTIONS(2073),
    [anon_sym_any] = ACTIONS(2073),
    [anon_sym_number] = ACTIONS(2073),
    [anon_sym_boolean] = ACTIONS(2073),
    [anon_sym_string] = ACTIONS(2073),
    [anon_sym_symbol] = ACTIONS(2073),
    [anon_sym_interface] = ACTIONS(2073),
    [anon_sym_enum] = ACTIONS(2073),
    [sym_readonly] = ACTIONS(2073),
  },
  [608] = {
    [ts_builtin_sym_end] = ACTIONS(2075),
    [sym_identifier] = ACTIONS(2077),
    [anon_sym_export] = ACTIONS(2077),
    [anon_sym_default] = ACTIONS(2077),
    [anon_sym_namespace] = ACTIONS(2077),
    [anon_sym_LBRACE] = ACTIONS(2075),
    [anon_sym_RBRACE] = ACTIONS(2075),
    [anon_sym_type] = ACTIONS(2077),
    [anon_sym_typeof] = ACTIONS(2077),
    [anon_sym_import] = ACTIONS(2077),
    [anon_sym_var] = ACTIONS(2077),
    [anon_sym_let] = ACTIONS(2077),
    [anon_sym_const] = ACTIONS(2077),
    [anon_sym_BANG] = ACTIONS(2075),
    [anon_sym_else] = ACTIONS(2077),
    [anon_sym_if] = ACTIONS(2077),
    [anon_sym_switch] = ACTIONS(2077),
    [anon_sym_for] = ACTIONS(2077),
    [anon_sym_LPAREN] = ACTIONS(2075),
    [anon_sym_await] = ACTIONS(2077),
    [anon_sym_while] = ACTIONS(2077),
    [anon_sym_do] = ACTIONS(2077),
    [anon_sym_try] = ACTIONS(2077),
    [anon_sym_with] = ACTIONS(2077),
    [anon_sym_break] = ACTIONS(2077),
    [anon_sym_continue] = ACTIONS(2077),
    [anon_sym_debugger] = ACTIONS(2077),
    [anon_sym_return] = ACTIONS(2077),
    [anon_sym_throw] = ACTIONS(2077),
    [anon_sym_SEMI] = ACTIONS(2075),
    [anon_sym_case] = ACTIONS(2077),
    [anon_sym_yield] = ACTIONS(2077),
    [anon_sym_LBRACK] = ACTIONS(2075),
    [anon_sym_LT] = ACTIONS(2075),
    [anon_sym_SLASH] = ACTIONS(2077),
    [anon_sym_class] = ACTIONS(2077),
    [anon_sym_async] = ACTIONS(2077),
    [anon_sym_function] = ACTIONS(2077),
    [anon_sym_new] = ACTIONS(2077),
    [anon_sym_PLUS] = ACTIONS(2077),
    [anon_sym_DASH] = ACTIONS(2077),
    [anon_sym_TILDE] = ACTIONS(2075),
    [anon_sym_void] = ACTIONS(2077),
    [anon_sym_delete] = ACTIONS(2077),
    [anon_sym_PLUS_PLUS] = ACTIONS(2075),
    [anon_sym_DASH_DASH] = ACTIONS(2075),
    [anon_sym_DQUOTE] = ACTIONS(2075),
    [anon_sym_SQUOTE] = ACTIONS(2075),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2075),
    [sym_number] = ACTIONS(2075),
    [sym_this] = ACTIONS(2077),
    [sym_super] = ACTIONS(2077),
    [sym_true] = ACTIONS(2077),
    [sym_false] = ACTIONS(2077),
    [sym_null] = ACTIONS(2077),
    [sym_undefined] = ACTIONS(2077),
    [anon_sym_AT] = ACTIONS(2075),
    [anon_sym_static] = ACTIONS(2077),
    [anon_sym_abstract] = ACTIONS(2077),
    [anon_sym_get] = ACTIONS(2077),
    [anon_sym_set] = ACTIONS(2077),
    [anon_sym_declare] = ACTIONS(2077),
    [anon_sym_public] = ACTIONS(2077),
    [anon_sym_private] = ACTIONS(2077),
    [anon_sym_protected] = ACTIONS(2077),
    [anon_sym_module] = ACTIONS(2077),
    [anon_sym_any] = ACTIONS(2077),
    [anon_sym_number] = ACTIONS(2077),
    [anon_sym_boolean] = ACTIONS(2077),
    [anon_sym_string] = ACTIONS(2077),
    [anon_sym_symbol] = ACTIONS(2077),
    [anon_sym_interface] = ACTIONS(2077),
    [anon_sym_enum] = ACTIONS(2077),
    [sym_readonly] = ACTIONS(2077),
  },
  [609] = {
    [ts_builtin_sym_end] = ACTIONS(2079),
    [sym_identifier] = ACTIONS(2081),
    [anon_sym_export] = ACTIONS(2081),
    [anon_sym_default] = ACTIONS(2081),
    [anon_sym_namespace] = ACTIONS(2081),
    [anon_sym_LBRACE] = ACTIONS(2079),
    [anon_sym_RBRACE] = ACTIONS(2079),
    [anon_sym_type] = ACTIONS(2081),
    [anon_sym_typeof] = ACTIONS(2081),
    [anon_sym_import] = ACTIONS(2081),
    [anon_sym_var] = ACTIONS(2081),
    [anon_sym_let] = ACTIONS(2081),
    [anon_sym_const] = ACTIONS(2081),
    [anon_sym_BANG] = ACTIONS(2079),
    [anon_sym_else] = ACTIONS(2081),
    [anon_sym_if] = ACTIONS(2081),
    [anon_sym_switch] = ACTIONS(2081),
    [anon_sym_for] = ACTIONS(2081),
    [anon_sym_LPAREN] = ACTIONS(2079),
    [anon_sym_await] = ACTIONS(2081),
    [anon_sym_while] = ACTIONS(2081),
    [anon_sym_do] = ACTIONS(2081),
    [anon_sym_try] = ACTIONS(2081),
    [anon_sym_with] = ACTIONS(2081),
    [anon_sym_break] = ACTIONS(2081),
    [anon_sym_continue] = ACTIONS(2081),
    [anon_sym_debugger] = ACTIONS(2081),
    [anon_sym_return] = ACTIONS(2081),
    [anon_sym_throw] = ACTIONS(2081),
    [anon_sym_SEMI] = ACTIONS(2079),
    [anon_sym_case] = ACTIONS(2081),
    [anon_sym_yield] = ACTIONS(2081),
    [anon_sym_LBRACK] = ACTIONS(2079),
    [anon_sym_LT] = ACTIONS(2079),
    [anon_sym_SLASH] = ACTIONS(2081),
    [anon_sym_class] = ACTIONS(2081),
    [anon_sym_async] = ACTIONS(2081),
    [anon_sym_function] = ACTIONS(2081),
    [anon_sym_new] = ACTIONS(2081),
    [anon_sym_PLUS] = ACTIONS(2081),
    [anon_sym_DASH] = ACTIONS(2081),
    [anon_sym_TILDE] = ACTIONS(2079),
    [anon_sym_void] = ACTIONS(2081),
    [anon_sym_delete] = ACTIONS(2081),
    [anon_sym_PLUS_PLUS] = ACTIONS(2079),
    [anon_sym_DASH_DASH] = ACTIONS(2079),
    [anon_sym_DQUOTE] = ACTIONS(2079),
    [anon_sym_SQUOTE] = ACTIONS(2079),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2079),
    [sym_number] = ACTIONS(2079),
    [sym_this] = ACTIONS(2081),
    [sym_super] = ACTIONS(2081),
    [sym_true] = ACTIONS(2081),
    [sym_false] = ACTIONS(2081),
    [sym_null] = ACTIONS(2081),
    [sym_undefined] = ACTIONS(2081),
    [anon_sym_AT] = ACTIONS(2079),
    [anon_sym_static] = ACTIONS(2081),
    [anon_sym_abstract] = ACTIONS(2081),
    [anon_sym_get] = ACTIONS(2081),
    [anon_sym_set] = ACTIONS(2081),
    [anon_sym_declare] = ACTIONS(2081),
    [anon_sym_public] = ACTIONS(2081),
    [anon_sym_private] = ACTIONS(2081),
    [anon_sym_protected] = ACTIONS(2081),
    [anon_sym_module] = ACTIONS(2081),
    [anon_sym_any] = ACTIONS(2081),
    [anon_sym_number] = ACTIONS(2081),
    [anon_sym_boolean] = ACTIONS(2081),
    [anon_sym_string] = ACTIONS(2081),
    [anon_sym_symbol] = ACTIONS(2081),
    [anon_sym_interface] = ACTIONS(2081),
    [anon_sym_enum] = ACTIONS(2081),
    [sym_readonly] = ACTIONS(2081),
  },
  [610] = {
    [ts_builtin_sym_end] = ACTIONS(2083),
    [sym_identifier] = ACTIONS(2085),
    [anon_sym_export] = ACTIONS(2085),
    [anon_sym_default] = ACTIONS(2085),
    [anon_sym_namespace] = ACTIONS(2085),
    [anon_sym_LBRACE] = ACTIONS(2083),
    [anon_sym_RBRACE] = ACTIONS(2083),
    [anon_sym_type] = ACTIONS(2085),
    [anon_sym_typeof] = ACTIONS(2085),
    [anon_sym_import] = ACTIONS(2085),
    [anon_sym_var] = ACTIONS(2085),
    [anon_sym_let] = ACTIONS(2085),
    [anon_sym_const] = ACTIONS(2085),
    [anon_sym_BANG] = ACTIONS(2083),
    [anon_sym_else] = ACTIONS(2085),
    [anon_sym_if] = ACTIONS(2085),
    [anon_sym_switch] = ACTIONS(2085),
    [anon_sym_for] = ACTIONS(2085),
    [anon_sym_LPAREN] = ACTIONS(2083),
    [anon_sym_await] = ACTIONS(2085),
    [anon_sym_while] = ACTIONS(2085),
    [anon_sym_do] = ACTIONS(2085),
    [anon_sym_try] = ACTIONS(2085),
    [anon_sym_with] = ACTIONS(2085),
    [anon_sym_break] = ACTIONS(2085),
    [anon_sym_continue] = ACTIONS(2085),
    [anon_sym_debugger] = ACTIONS(2085),
    [anon_sym_return] = ACTIONS(2085),
    [anon_sym_throw] = ACTIONS(2085),
    [anon_sym_SEMI] = ACTIONS(2083),
    [anon_sym_case] = ACTIONS(2085),
    [anon_sym_yield] = ACTIONS(2085),
    [anon_sym_LBRACK] = ACTIONS(2083),
    [anon_sym_LT] = ACTIONS(2083),
    [anon_sym_SLASH] = ACTIONS(2085),
    [anon_sym_class] = ACTIONS(2085),
    [anon_sym_async] = ACTIONS(2085),
    [anon_sym_function] = ACTIONS(2085),
    [anon_sym_new] = ACTIONS(2085),
    [anon_sym_PLUS] = ACTIONS(2085),
    [anon_sym_DASH] = ACTIONS(2085),
    [anon_sym_TILDE] = ACTIONS(2083),
    [anon_sym_void] = ACTIONS(2085),
    [anon_sym_delete] = ACTIONS(2085),
    [anon_sym_PLUS_PLUS] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(2083),
    [anon_sym_DQUOTE] = ACTIONS(2083),
    [anon_sym_SQUOTE] = ACTIONS(2083),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2083),
    [sym_number] = ACTIONS(2083),
    [sym_this] = ACTIONS(2085),
    [sym_super] = ACTIONS(2085),
    [sym_true] = ACTIONS(2085),
    [sym_false] = ACTIONS(2085),
    [sym_null] = ACTIONS(2085),
    [sym_undefined] = ACTIONS(2085),
    [anon_sym_AT] = ACTIONS(2083),
    [anon_sym_static] = ACTIONS(2085),
    [anon_sym_abstract] = ACTIONS(2085),
    [anon_sym_get] = ACTIONS(2085),
    [anon_sym_set] = ACTIONS(2085),
    [anon_sym_declare] = ACTIONS(2085),
    [anon_sym_public] = ACTIONS(2085),
    [anon_sym_private] = ACTIONS(2085),
    [anon_sym_protected] = ACTIONS(2085),
    [anon_sym_module] = ACTIONS(2085),
    [anon_sym_any] = ACTIONS(2085),
    [anon_sym_number] = ACTIONS(2085),
    [anon_sym_boolean] = ACTIONS(2085),
    [anon_sym_string] = ACTIONS(2085),
    [anon_sym_symbol] = ACTIONS(2085),
    [anon_sym_interface] = ACTIONS(2085),
    [anon_sym_enum] = ACTIONS(2085),
    [sym_readonly] = ACTIONS(2085),
  },
  [611] = {
    [ts_builtin_sym_end] = ACTIONS(2087),
    [sym_identifier] = ACTIONS(2089),
    [anon_sym_export] = ACTIONS(2089),
    [anon_sym_default] = ACTIONS(2089),
    [anon_sym_namespace] = ACTIONS(2089),
    [anon_sym_LBRACE] = ACTIONS(2087),
    [anon_sym_RBRACE] = ACTIONS(2087),
    [anon_sym_type] = ACTIONS(2089),
    [anon_sym_typeof] = ACTIONS(2089),
    [anon_sym_import] = ACTIONS(2089),
    [anon_sym_var] = ACTIONS(2089),
    [anon_sym_let] = ACTIONS(2089),
    [anon_sym_const] = ACTIONS(2089),
    [anon_sym_BANG] = ACTIONS(2087),
    [anon_sym_else] = ACTIONS(2089),
    [anon_sym_if] = ACTIONS(2089),
    [anon_sym_switch] = ACTIONS(2089),
    [anon_sym_for] = ACTIONS(2089),
    [anon_sym_LPAREN] = ACTIONS(2087),
    [anon_sym_await] = ACTIONS(2089),
    [anon_sym_while] = ACTIONS(2089),
    [anon_sym_do] = ACTIONS(2089),
    [anon_sym_try] = ACTIONS(2089),
    [anon_sym_with] = ACTIONS(2089),
    [anon_sym_break] = ACTIONS(2089),
    [anon_sym_continue] = ACTIONS(2089),
    [anon_sym_debugger] = ACTIONS(2089),
    [anon_sym_return] = ACTIONS(2089),
    [anon_sym_throw] = ACTIONS(2089),
    [anon_sym_SEMI] = ACTIONS(2087),
    [anon_sym_case] = ACTIONS(2089),
    [anon_sym_yield] = ACTIONS(2089),
    [anon_sym_LBRACK] = ACTIONS(2087),
    [anon_sym_LT] = ACTIONS(2087),
    [anon_sym_SLASH] = ACTIONS(2089),
    [anon_sym_class] = ACTIONS(2089),
    [anon_sym_async] = ACTIONS(2089),
    [anon_sym_function] = ACTIONS(2089),
    [anon_sym_new] = ACTIONS(2089),
    [anon_sym_PLUS] = ACTIONS(2089),
    [anon_sym_DASH] = ACTIONS(2089),
    [anon_sym_TILDE] = ACTIONS(2087),
    [anon_sym_void] = ACTIONS(2089),
    [anon_sym_delete] = ACTIONS(2089),
    [anon_sym_PLUS_PLUS] = ACTIONS(2087),
    [anon_sym_DASH_DASH] = ACTIONS(2087),
    [anon_sym_DQUOTE] = ACTIONS(2087),
    [anon_sym_SQUOTE] = ACTIONS(2087),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2087),
    [sym_number] = ACTIONS(2087),
    [sym_this] = ACTIONS(2089),
    [sym_super] = ACTIONS(2089),
    [sym_true] = ACTIONS(2089),
    [sym_false] = ACTIONS(2089),
    [sym_null] = ACTIONS(2089),
    [sym_undefined] = ACTIONS(2089),
    [anon_sym_AT] = ACTIONS(2087),
    [anon_sym_static] = ACTIONS(2089),
    [anon_sym_abstract] = ACTIONS(2089),
    [anon_sym_get] = ACTIONS(2089),
    [anon_sym_set] = ACTIONS(2089),
    [anon_sym_declare] = ACTIONS(2089),
    [anon_sym_public] = ACTIONS(2089),
    [anon_sym_private] = ACTIONS(2089),
    [anon_sym_protected] = ACTIONS(2089),
    [anon_sym_module] = ACTIONS(2089),
    [anon_sym_any] = ACTIONS(2089),
    [anon_sym_number] = ACTIONS(2089),
    [anon_sym_boolean] = ACTIONS(2089),
    [anon_sym_string] = ACTIONS(2089),
    [anon_sym_symbol] = ACTIONS(2089),
    [anon_sym_interface] = ACTIONS(2089),
    [anon_sym_enum] = ACTIONS(2089),
    [sym_readonly] = ACTIONS(2089),
  },
  [612] = {
    [ts_builtin_sym_end] = ACTIONS(975),
    [sym_identifier] = ACTIONS(977),
    [anon_sym_export] = ACTIONS(977),
    [anon_sym_default] = ACTIONS(977),
    [anon_sym_namespace] = ACTIONS(977),
    [anon_sym_LBRACE] = ACTIONS(975),
    [anon_sym_RBRACE] = ACTIONS(975),
    [anon_sym_type] = ACTIONS(977),
    [anon_sym_typeof] = ACTIONS(977),
    [anon_sym_import] = ACTIONS(977),
    [anon_sym_var] = ACTIONS(977),
    [anon_sym_let] = ACTIONS(977),
    [anon_sym_const] = ACTIONS(977),
    [anon_sym_BANG] = ACTIONS(975),
    [anon_sym_else] = ACTIONS(977),
    [anon_sym_if] = ACTIONS(977),
    [anon_sym_switch] = ACTIONS(977),
    [anon_sym_for] = ACTIONS(977),
    [anon_sym_LPAREN] = ACTIONS(975),
    [anon_sym_await] = ACTIONS(977),
    [anon_sym_while] = ACTIONS(977),
    [anon_sym_do] = ACTIONS(977),
    [anon_sym_try] = ACTIONS(977),
    [anon_sym_with] = ACTIONS(977),
    [anon_sym_break] = ACTIONS(977),
    [anon_sym_continue] = ACTIONS(977),
    [anon_sym_debugger] = ACTIONS(977),
    [anon_sym_return] = ACTIONS(977),
    [anon_sym_throw] = ACTIONS(977),
    [anon_sym_SEMI] = ACTIONS(975),
    [anon_sym_case] = ACTIONS(977),
    [anon_sym_yield] = ACTIONS(977),
    [anon_sym_LBRACK] = ACTIONS(975),
    [anon_sym_LT] = ACTIONS(975),
    [anon_sym_SLASH] = ACTIONS(977),
    [anon_sym_class] = ACTIONS(977),
    [anon_sym_async] = ACTIONS(977),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_new] = ACTIONS(977),
    [anon_sym_PLUS] = ACTIONS(977),
    [anon_sym_DASH] = ACTIONS(977),
    [anon_sym_TILDE] = ACTIONS(975),
    [anon_sym_void] = ACTIONS(977),
    [anon_sym_delete] = ACTIONS(977),
    [anon_sym_PLUS_PLUS] = ACTIONS(975),
    [anon_sym_DASH_DASH] = ACTIONS(975),
    [anon_sym_DQUOTE] = ACTIONS(975),
    [anon_sym_SQUOTE] = ACTIONS(975),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(975),
    [sym_number] = ACTIONS(975),
    [sym_this] = ACTIONS(977),
    [sym_super] = ACTIONS(977),
    [sym_true] = ACTIONS(977),
    [sym_false] = ACTIONS(977),
    [sym_null] = ACTIONS(977),
    [sym_undefined] = ACTIONS(977),
    [anon_sym_AT] = ACTIONS(975),
    [anon_sym_static] = ACTIONS(977),
    [anon_sym_abstract] = ACTIONS(977),
    [anon_sym_get] = ACTIONS(977),
    [anon_sym_set] = ACTIONS(977),
    [anon_sym_declare] = ACTIONS(977),
    [anon_sym_public] = ACTIONS(977),
    [anon_sym_private] = ACTIONS(977),
    [anon_sym_protected] = ACTIONS(977),
    [anon_sym_module] = ACTIONS(977),
    [anon_sym_any] = ACTIONS(977),
    [anon_sym_number] = ACTIONS(977),
    [anon_sym_boolean] = ACTIONS(977),
    [anon_sym_string] = ACTIONS(977),
    [anon_sym_symbol] = ACTIONS(977),
    [anon_sym_interface] = ACTIONS(977),
    [anon_sym_enum] = ACTIONS(977),
    [sym_readonly] = ACTIONS(977),
  },
  [613] = {
    [ts_builtin_sym_end] = ACTIONS(2091),
    [sym_identifier] = ACTIONS(2093),
    [anon_sym_export] = ACTIONS(2093),
    [anon_sym_default] = ACTIONS(2093),
    [anon_sym_namespace] = ACTIONS(2093),
    [anon_sym_LBRACE] = ACTIONS(2091),
    [anon_sym_RBRACE] = ACTIONS(2091),
    [anon_sym_type] = ACTIONS(2093),
    [anon_sym_typeof] = ACTIONS(2093),
    [anon_sym_import] = ACTIONS(2093),
    [anon_sym_var] = ACTIONS(2093),
    [anon_sym_let] = ACTIONS(2093),
    [anon_sym_const] = ACTIONS(2093),
    [anon_sym_BANG] = ACTIONS(2091),
    [anon_sym_else] = ACTIONS(2093),
    [anon_sym_if] = ACTIONS(2093),
    [anon_sym_switch] = ACTIONS(2093),
    [anon_sym_for] = ACTIONS(2093),
    [anon_sym_LPAREN] = ACTIONS(2091),
    [anon_sym_await] = ACTIONS(2093),
    [anon_sym_while] = ACTIONS(2093),
    [anon_sym_do] = ACTIONS(2093),
    [anon_sym_try] = ACTIONS(2093),
    [anon_sym_with] = ACTIONS(2093),
    [anon_sym_break] = ACTIONS(2093),
    [anon_sym_continue] = ACTIONS(2093),
    [anon_sym_debugger] = ACTIONS(2093),
    [anon_sym_return] = ACTIONS(2093),
    [anon_sym_throw] = ACTIONS(2093),
    [anon_sym_SEMI] = ACTIONS(2091),
    [anon_sym_case] = ACTIONS(2093),
    [anon_sym_yield] = ACTIONS(2093),
    [anon_sym_LBRACK] = ACTIONS(2091),
    [anon_sym_LT] = ACTIONS(2091),
    [anon_sym_SLASH] = ACTIONS(2093),
    [anon_sym_class] = ACTIONS(2093),
    [anon_sym_async] = ACTIONS(2093),
    [anon_sym_function] = ACTIONS(2093),
    [anon_sym_new] = ACTIONS(2093),
    [anon_sym_PLUS] = ACTIONS(2093),
    [anon_sym_DASH] = ACTIONS(2093),
    [anon_sym_TILDE] = ACTIONS(2091),
    [anon_sym_void] = ACTIONS(2093),
    [anon_sym_delete] = ACTIONS(2093),
    [anon_sym_PLUS_PLUS] = ACTIONS(2091),
    [anon_sym_DASH_DASH] = ACTIONS(2091),
    [anon_sym_DQUOTE] = ACTIONS(2091),
    [anon_sym_SQUOTE] = ACTIONS(2091),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2091),
    [sym_number] = ACTIONS(2091),
    [sym_this] = ACTIONS(2093),
    [sym_super] = ACTIONS(2093),
    [sym_true] = ACTIONS(2093),
    [sym_false] = ACTIONS(2093),
    [sym_null] = ACTIONS(2093),
    [sym_undefined] = ACTIONS(2093),
    [anon_sym_AT] = ACTIONS(2091),
    [anon_sym_static] = ACTIONS(2093),
    [anon_sym_abstract] = ACTIONS(2093),
    [anon_sym_get] = ACTIONS(2093),
    [anon_sym_set] = ACTIONS(2093),
    [anon_sym_declare] = ACTIONS(2093),
    [anon_sym_public] = ACTIONS(2093),
    [anon_sym_private] = ACTIONS(2093),
    [anon_sym_protected] = ACTIONS(2093),
    [anon_sym_module] = ACTIONS(2093),
    [anon_sym_any] = ACTIONS(2093),
    [anon_sym_number] = ACTIONS(2093),
    [anon_sym_boolean] = ACTIONS(2093),
    [anon_sym_string] = ACTIONS(2093),
    [anon_sym_symbol] = ACTIONS(2093),
    [anon_sym_interface] = ACTIONS(2093),
    [anon_sym_enum] = ACTIONS(2093),
    [sym_readonly] = ACTIONS(2093),
  },
  [614] = {
    [ts_builtin_sym_end] = ACTIONS(2095),
    [sym_identifier] = ACTIONS(2097),
    [anon_sym_export] = ACTIONS(2097),
    [anon_sym_default] = ACTIONS(2097),
    [anon_sym_namespace] = ACTIONS(2097),
    [anon_sym_LBRACE] = ACTIONS(2095),
    [anon_sym_RBRACE] = ACTIONS(2095),
    [anon_sym_type] = ACTIONS(2097),
    [anon_sym_typeof] = ACTIONS(2097),
    [anon_sym_import] = ACTIONS(2097),
    [anon_sym_var] = ACTIONS(2097),
    [anon_sym_let] = ACTIONS(2097),
    [anon_sym_const] = ACTIONS(2097),
    [anon_sym_BANG] = ACTIONS(2095),
    [anon_sym_else] = ACTIONS(2097),
    [anon_sym_if] = ACTIONS(2097),
    [anon_sym_switch] = ACTIONS(2097),
    [anon_sym_for] = ACTIONS(2097),
    [anon_sym_LPAREN] = ACTIONS(2095),
    [anon_sym_await] = ACTIONS(2097),
    [anon_sym_while] = ACTIONS(2097),
    [anon_sym_do] = ACTIONS(2097),
    [anon_sym_try] = ACTIONS(2097),
    [anon_sym_with] = ACTIONS(2097),
    [anon_sym_break] = ACTIONS(2097),
    [anon_sym_continue] = ACTIONS(2097),
    [anon_sym_debugger] = ACTIONS(2097),
    [anon_sym_return] = ACTIONS(2097),
    [anon_sym_throw] = ACTIONS(2097),
    [anon_sym_SEMI] = ACTIONS(2095),
    [anon_sym_case] = ACTIONS(2097),
    [anon_sym_yield] = ACTIONS(2097),
    [anon_sym_LBRACK] = ACTIONS(2095),
    [anon_sym_LT] = ACTIONS(2095),
    [anon_sym_SLASH] = ACTIONS(2097),
    [anon_sym_class] = ACTIONS(2097),
    [anon_sym_async] = ACTIONS(2097),
    [anon_sym_function] = ACTIONS(2097),
    [anon_sym_new] = ACTIONS(2097),
    [anon_sym_PLUS] = ACTIONS(2097),
    [anon_sym_DASH] = ACTIONS(2097),
    [anon_sym_TILDE] = ACTIONS(2095),
    [anon_sym_void] = ACTIONS(2097),
    [anon_sym_delete] = ACTIONS(2097),
    [anon_sym_PLUS_PLUS] = ACTIONS(2095),
    [anon_sym_DASH_DASH] = ACTIONS(2095),
    [anon_sym_DQUOTE] = ACTIONS(2095),
    [anon_sym_SQUOTE] = ACTIONS(2095),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2095),
    [sym_number] = ACTIONS(2095),
    [sym_this] = ACTIONS(2097),
    [sym_super] = ACTIONS(2097),
    [sym_true] = ACTIONS(2097),
    [sym_false] = ACTIONS(2097),
    [sym_null] = ACTIONS(2097),
    [sym_undefined] = ACTIONS(2097),
    [anon_sym_AT] = ACTIONS(2095),
    [anon_sym_static] = ACTIONS(2097),
    [anon_sym_abstract] = ACTIONS(2097),
    [anon_sym_get] = ACTIONS(2097),
    [anon_sym_set] = ACTIONS(2097),
    [anon_sym_declare] = ACTIONS(2097),
    [anon_sym_public] = ACTIONS(2097),
    [anon_sym_private] = ACTIONS(2097),
    [anon_sym_protected] = ACTIONS(2097),
    [anon_sym_module] = ACTIONS(2097),
    [anon_sym_any] = ACTIONS(2097),
    [anon_sym_number] = ACTIONS(2097),
    [anon_sym_boolean] = ACTIONS(2097),
    [anon_sym_string] = ACTIONS(2097),
    [anon_sym_symbol] = ACTIONS(2097),
    [anon_sym_interface] = ACTIONS(2097),
    [anon_sym_enum] = ACTIONS(2097),
    [sym_readonly] = ACTIONS(2097),
  },
  [615] = {
    [ts_builtin_sym_end] = ACTIONS(2099),
    [sym_identifier] = ACTIONS(2101),
    [anon_sym_export] = ACTIONS(2101),
    [anon_sym_default] = ACTIONS(2101),
    [anon_sym_namespace] = ACTIONS(2101),
    [anon_sym_LBRACE] = ACTIONS(2099),
    [anon_sym_RBRACE] = ACTIONS(2099),
    [anon_sym_type] = ACTIONS(2101),
    [anon_sym_typeof] = ACTIONS(2101),
    [anon_sym_import] = ACTIONS(2101),
    [anon_sym_var] = ACTIONS(2101),
    [anon_sym_let] = ACTIONS(2101),
    [anon_sym_const] = ACTIONS(2101),
    [anon_sym_BANG] = ACTIONS(2099),
    [anon_sym_else] = ACTIONS(2101),
    [anon_sym_if] = ACTIONS(2101),
    [anon_sym_switch] = ACTIONS(2101),
    [anon_sym_for] = ACTIONS(2101),
    [anon_sym_LPAREN] = ACTIONS(2099),
    [anon_sym_await] = ACTIONS(2101),
    [anon_sym_while] = ACTIONS(2101),
    [anon_sym_do] = ACTIONS(2101),
    [anon_sym_try] = ACTIONS(2101),
    [anon_sym_with] = ACTIONS(2101),
    [anon_sym_break] = ACTIONS(2101),
    [anon_sym_continue] = ACTIONS(2101),
    [anon_sym_debugger] = ACTIONS(2101),
    [anon_sym_return] = ACTIONS(2101),
    [anon_sym_throw] = ACTIONS(2101),
    [anon_sym_SEMI] = ACTIONS(2099),
    [anon_sym_case] = ACTIONS(2101),
    [anon_sym_yield] = ACTIONS(2101),
    [anon_sym_LBRACK] = ACTIONS(2099),
    [anon_sym_LT] = ACTIONS(2099),
    [anon_sym_SLASH] = ACTIONS(2101),
    [anon_sym_class] = ACTIONS(2101),
    [anon_sym_async] = ACTIONS(2101),
    [anon_sym_function] = ACTIONS(2101),
    [anon_sym_new] = ACTIONS(2101),
    [anon_sym_PLUS] = ACTIONS(2101),
    [anon_sym_DASH] = ACTIONS(2101),
    [anon_sym_TILDE] = ACTIONS(2099),
    [anon_sym_void] = ACTIONS(2101),
    [anon_sym_delete] = ACTIONS(2101),
    [anon_sym_PLUS_PLUS] = ACTIONS(2099),
    [anon_sym_DASH_DASH] = ACTIONS(2099),
    [anon_sym_DQUOTE] = ACTIONS(2099),
    [anon_sym_SQUOTE] = ACTIONS(2099),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2099),
    [sym_number] = ACTIONS(2099),
    [sym_this] = ACTIONS(2101),
    [sym_super] = ACTIONS(2101),
    [sym_true] = ACTIONS(2101),
    [sym_false] = ACTIONS(2101),
    [sym_null] = ACTIONS(2101),
    [sym_undefined] = ACTIONS(2101),
    [anon_sym_AT] = ACTIONS(2099),
    [anon_sym_static] = ACTIONS(2101),
    [anon_sym_abstract] = ACTIONS(2101),
    [anon_sym_get] = ACTIONS(2101),
    [anon_sym_set] = ACTIONS(2101),
    [anon_sym_declare] = ACTIONS(2101),
    [anon_sym_public] = ACTIONS(2101),
    [anon_sym_private] = ACTIONS(2101),
    [anon_sym_protected] = ACTIONS(2101),
    [anon_sym_module] = ACTIONS(2101),
    [anon_sym_any] = ACTIONS(2101),
    [anon_sym_number] = ACTIONS(2101),
    [anon_sym_boolean] = ACTIONS(2101),
    [anon_sym_string] = ACTIONS(2101),
    [anon_sym_symbol] = ACTIONS(2101),
    [anon_sym_interface] = ACTIONS(2101),
    [anon_sym_enum] = ACTIONS(2101),
    [sym_readonly] = ACTIONS(2101),
  },
  [616] = {
    [ts_builtin_sym_end] = ACTIONS(2103),
    [sym_identifier] = ACTIONS(2105),
    [anon_sym_export] = ACTIONS(2105),
    [anon_sym_default] = ACTIONS(2105),
    [anon_sym_namespace] = ACTIONS(2105),
    [anon_sym_LBRACE] = ACTIONS(2103),
    [anon_sym_RBRACE] = ACTIONS(2103),
    [anon_sym_type] = ACTIONS(2105),
    [anon_sym_typeof] = ACTIONS(2105),
    [anon_sym_import] = ACTIONS(2105),
    [anon_sym_var] = ACTIONS(2105),
    [anon_sym_let] = ACTIONS(2105),
    [anon_sym_const] = ACTIONS(2105),
    [anon_sym_BANG] = ACTIONS(2103),
    [anon_sym_else] = ACTIONS(2105),
    [anon_sym_if] = ACTIONS(2105),
    [anon_sym_switch] = ACTIONS(2105),
    [anon_sym_for] = ACTIONS(2105),
    [anon_sym_LPAREN] = ACTIONS(2103),
    [anon_sym_await] = ACTIONS(2105),
    [anon_sym_while] = ACTIONS(2105),
    [anon_sym_do] = ACTIONS(2105),
    [anon_sym_try] = ACTIONS(2105),
    [anon_sym_with] = ACTIONS(2105),
    [anon_sym_break] = ACTIONS(2105),
    [anon_sym_continue] = ACTIONS(2105),
    [anon_sym_debugger] = ACTIONS(2105),
    [anon_sym_return] = ACTIONS(2105),
    [anon_sym_throw] = ACTIONS(2105),
    [anon_sym_SEMI] = ACTIONS(2103),
    [anon_sym_case] = ACTIONS(2105),
    [anon_sym_yield] = ACTIONS(2105),
    [anon_sym_LBRACK] = ACTIONS(2103),
    [anon_sym_LT] = ACTIONS(2103),
    [anon_sym_SLASH] = ACTIONS(2105),
    [anon_sym_class] = ACTIONS(2105),
    [anon_sym_async] = ACTIONS(2105),
    [anon_sym_function] = ACTIONS(2105),
    [anon_sym_new] = ACTIONS(2105),
    [anon_sym_PLUS] = ACTIONS(2105),
    [anon_sym_DASH] = ACTIONS(2105),
    [anon_sym_TILDE] = ACTIONS(2103),
    [anon_sym_void] = ACTIONS(2105),
    [anon_sym_delete] = ACTIONS(2105),
    [anon_sym_PLUS_PLUS] = ACTIONS(2103),
    [anon_sym_DASH_DASH] = ACTIONS(2103),
    [anon_sym_DQUOTE] = ACTIONS(2103),
    [anon_sym_SQUOTE] = ACTIONS(2103),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2103),
    [sym_number] = ACTIONS(2103),
    [sym_this] = ACTIONS(2105),
    [sym_super] = ACTIONS(2105),
    [sym_true] = ACTIONS(2105),
    [sym_false] = ACTIONS(2105),
    [sym_null] = ACTIONS(2105),
    [sym_undefined] = ACTIONS(2105),
    [anon_sym_AT] = ACTIONS(2103),
    [anon_sym_static] = ACTIONS(2105),
    [anon_sym_abstract] = ACTIONS(2105),
    [anon_sym_get] = ACTIONS(2105),
    [anon_sym_set] = ACTIONS(2105),
    [anon_sym_declare] = ACTIONS(2105),
    [anon_sym_public] = ACTIONS(2105),
    [anon_sym_private] = ACTIONS(2105),
    [anon_sym_protected] = ACTIONS(2105),
    [anon_sym_module] = ACTIONS(2105),
    [anon_sym_any] = ACTIONS(2105),
    [anon_sym_number] = ACTIONS(2105),
    [anon_sym_boolean] = ACTIONS(2105),
    [anon_sym_string] = ACTIONS(2105),
    [anon_sym_symbol] = ACTIONS(2105),
    [anon_sym_interface] = ACTIONS(2105),
    [anon_sym_enum] = ACTIONS(2105),
    [sym_readonly] = ACTIONS(2105),
  },
  [617] = {
    [ts_builtin_sym_end] = ACTIONS(2107),
    [sym_identifier] = ACTIONS(2109),
    [anon_sym_export] = ACTIONS(2109),
    [anon_sym_default] = ACTIONS(2109),
    [anon_sym_namespace] = ACTIONS(2109),
    [anon_sym_LBRACE] = ACTIONS(2107),
    [anon_sym_RBRACE] = ACTIONS(2107),
    [anon_sym_type] = ACTIONS(2109),
    [anon_sym_typeof] = ACTIONS(2109),
    [anon_sym_import] = ACTIONS(2109),
    [anon_sym_var] = ACTIONS(2109),
    [anon_sym_let] = ACTIONS(2109),
    [anon_sym_const] = ACTIONS(2109),
    [anon_sym_BANG] = ACTIONS(2107),
    [anon_sym_else] = ACTIONS(2109),
    [anon_sym_if] = ACTIONS(2109),
    [anon_sym_switch] = ACTIONS(2109),
    [anon_sym_for] = ACTIONS(2109),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_await] = ACTIONS(2109),
    [anon_sym_while] = ACTIONS(2109),
    [anon_sym_do] = ACTIONS(2109),
    [anon_sym_try] = ACTIONS(2109),
    [anon_sym_with] = ACTIONS(2109),
    [anon_sym_break] = ACTIONS(2109),
    [anon_sym_continue] = ACTIONS(2109),
    [anon_sym_debugger] = ACTIONS(2109),
    [anon_sym_return] = ACTIONS(2109),
    [anon_sym_throw] = ACTIONS(2109),
    [anon_sym_SEMI] = ACTIONS(2107),
    [anon_sym_case] = ACTIONS(2109),
    [anon_sym_yield] = ACTIONS(2109),
    [anon_sym_LBRACK] = ACTIONS(2107),
    [anon_sym_LT] = ACTIONS(2107),
    [anon_sym_SLASH] = ACTIONS(2109),
    [anon_sym_class] = ACTIONS(2109),
    [anon_sym_async] = ACTIONS(2109),
    [anon_sym_function] = ACTIONS(2109),
    [anon_sym_new] = ACTIONS(2109),
    [anon_sym_PLUS] = ACTIONS(2109),
    [anon_sym_DASH] = ACTIONS(2109),
    [anon_sym_TILDE] = ACTIONS(2107),
    [anon_sym_void] = ACTIONS(2109),
    [anon_sym_delete] = ACTIONS(2109),
    [anon_sym_PLUS_PLUS] = ACTIONS(2107),
    [anon_sym_DASH_DASH] = ACTIONS(2107),
    [anon_sym_DQUOTE] = ACTIONS(2107),
    [anon_sym_SQUOTE] = ACTIONS(2107),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2107),
    [sym_number] = ACTIONS(2107),
    [sym_this] = ACTIONS(2109),
    [sym_super] = ACTIONS(2109),
    [sym_true] = ACTIONS(2109),
    [sym_false] = ACTIONS(2109),
    [sym_null] = ACTIONS(2109),
    [sym_undefined] = ACTIONS(2109),
    [anon_sym_AT] = ACTIONS(2107),
    [anon_sym_static] = ACTIONS(2109),
    [anon_sym_abstract] = ACTIONS(2109),
    [anon_sym_get] = ACTIONS(2109),
    [anon_sym_set] = ACTIONS(2109),
    [anon_sym_declare] = ACTIONS(2109),
    [anon_sym_public] = ACTIONS(2109),
    [anon_sym_private] = ACTIONS(2109),
    [anon_sym_protected] = ACTIONS(2109),
    [anon_sym_module] = ACTIONS(2109),
    [anon_sym_any] = ACTIONS(2109),
    [anon_sym_number] = ACTIONS(2109),
    [anon_sym_boolean] = ACTIONS(2109),
    [anon_sym_string] = ACTIONS(2109),
    [anon_sym_symbol] = ACTIONS(2109),
    [anon_sym_interface] = ACTIONS(2109),
    [anon_sym_enum] = ACTIONS(2109),
    [sym_readonly] = ACTIONS(2109),
  },
  [618] = {
    [ts_builtin_sym_end] = ACTIONS(2111),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_export] = ACTIONS(2113),
    [anon_sym_default] = ACTIONS(2113),
    [anon_sym_namespace] = ACTIONS(2113),
    [anon_sym_LBRACE] = ACTIONS(2111),
    [anon_sym_RBRACE] = ACTIONS(2111),
    [anon_sym_type] = ACTIONS(2113),
    [anon_sym_typeof] = ACTIONS(2113),
    [anon_sym_import] = ACTIONS(2113),
    [anon_sym_var] = ACTIONS(2113),
    [anon_sym_let] = ACTIONS(2113),
    [anon_sym_const] = ACTIONS(2113),
    [anon_sym_BANG] = ACTIONS(2111),
    [anon_sym_else] = ACTIONS(2113),
    [anon_sym_if] = ACTIONS(2113),
    [anon_sym_switch] = ACTIONS(2113),
    [anon_sym_for] = ACTIONS(2113),
    [anon_sym_LPAREN] = ACTIONS(2111),
    [anon_sym_await] = ACTIONS(2113),
    [anon_sym_while] = ACTIONS(2113),
    [anon_sym_do] = ACTIONS(2113),
    [anon_sym_try] = ACTIONS(2113),
    [anon_sym_with] = ACTIONS(2113),
    [anon_sym_break] = ACTIONS(2113),
    [anon_sym_continue] = ACTIONS(2113),
    [anon_sym_debugger] = ACTIONS(2113),
    [anon_sym_return] = ACTIONS(2113),
    [anon_sym_throw] = ACTIONS(2113),
    [anon_sym_SEMI] = ACTIONS(2111),
    [anon_sym_case] = ACTIONS(2113),
    [anon_sym_yield] = ACTIONS(2113),
    [anon_sym_LBRACK] = ACTIONS(2111),
    [anon_sym_LT] = ACTIONS(2111),
    [anon_sym_SLASH] = ACTIONS(2113),
    [anon_sym_class] = ACTIONS(2113),
    [anon_sym_async] = ACTIONS(2113),
    [anon_sym_function] = ACTIONS(2113),
    [anon_sym_new] = ACTIONS(2113),
    [anon_sym_PLUS] = ACTIONS(2113),
    [anon_sym_DASH] = ACTIONS(2113),
    [anon_sym_TILDE] = ACTIONS(2111),
    [anon_sym_void] = ACTIONS(2113),
    [anon_sym_delete] = ACTIONS(2113),
    [anon_sym_PLUS_PLUS] = ACTIONS(2111),
    [anon_sym_DASH_DASH] = ACTIONS(2111),
    [anon_sym_DQUOTE] = ACTIONS(2111),
    [anon_sym_SQUOTE] = ACTIONS(2111),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2111),
    [sym_number] = ACTIONS(2111),
    [sym_this] = ACTIONS(2113),
    [sym_super] = ACTIONS(2113),
    [sym_true] = ACTIONS(2113),
    [sym_false] = ACTIONS(2113),
    [sym_null] = ACTIONS(2113),
    [sym_undefined] = ACTIONS(2113),
    [anon_sym_AT] = ACTIONS(2111),
    [anon_sym_static] = ACTIONS(2113),
    [anon_sym_abstract] = ACTIONS(2113),
    [anon_sym_get] = ACTIONS(2113),
    [anon_sym_set] = ACTIONS(2113),
    [anon_sym_declare] = ACTIONS(2113),
    [anon_sym_public] = ACTIONS(2113),
    [anon_sym_private] = ACTIONS(2113),
    [anon_sym_protected] = ACTIONS(2113),
    [anon_sym_module] = ACTIONS(2113),
    [anon_sym_any] = ACTIONS(2113),
    [anon_sym_number] = ACTIONS(2113),
    [anon_sym_boolean] = ACTIONS(2113),
    [anon_sym_string] = ACTIONS(2113),
    [anon_sym_symbol] = ACTIONS(2113),
    [anon_sym_interface] = ACTIONS(2113),
    [anon_sym_enum] = ACTIONS(2113),
    [sym_readonly] = ACTIONS(2113),
  },
  [619] = {
    [ts_builtin_sym_end] = ACTIONS(2115),
    [sym_identifier] = ACTIONS(2117),
    [anon_sym_export] = ACTIONS(2117),
    [anon_sym_default] = ACTIONS(2117),
    [anon_sym_namespace] = ACTIONS(2117),
    [anon_sym_LBRACE] = ACTIONS(2115),
    [anon_sym_RBRACE] = ACTIONS(2115),
    [anon_sym_type] = ACTIONS(2117),
    [anon_sym_typeof] = ACTIONS(2117),
    [anon_sym_import] = ACTIONS(2117),
    [anon_sym_var] = ACTIONS(2117),
    [anon_sym_let] = ACTIONS(2117),
    [anon_sym_const] = ACTIONS(2117),
    [anon_sym_BANG] = ACTIONS(2115),
    [anon_sym_else] = ACTIONS(2117),
    [anon_sym_if] = ACTIONS(2117),
    [anon_sym_switch] = ACTIONS(2117),
    [anon_sym_for] = ACTIONS(2117),
    [anon_sym_LPAREN] = ACTIONS(2115),
    [anon_sym_await] = ACTIONS(2117),
    [anon_sym_while] = ACTIONS(2117),
    [anon_sym_do] = ACTIONS(2117),
    [anon_sym_try] = ACTIONS(2117),
    [anon_sym_with] = ACTIONS(2117),
    [anon_sym_break] = ACTIONS(2117),
    [anon_sym_continue] = ACTIONS(2117),
    [anon_sym_debugger] = ACTIONS(2117),
    [anon_sym_return] = ACTIONS(2117),
    [anon_sym_throw] = ACTIONS(2117),
    [anon_sym_SEMI] = ACTIONS(2115),
    [anon_sym_case] = ACTIONS(2117),
    [anon_sym_yield] = ACTIONS(2117),
    [anon_sym_LBRACK] = ACTIONS(2115),
    [anon_sym_LT] = ACTIONS(2115),
    [anon_sym_SLASH] = ACTIONS(2117),
    [anon_sym_class] = ACTIONS(2117),
    [anon_sym_async] = ACTIONS(2117),
    [anon_sym_function] = ACTIONS(2117),
    [anon_sym_new] = ACTIONS(2117),
    [anon_sym_PLUS] = ACTIONS(2117),
    [anon_sym_DASH] = ACTIONS(2117),
    [anon_sym_TILDE] = ACTIONS(2115),
    [anon_sym_void] = ACTIONS(2117),
    [anon_sym_delete] = ACTIONS(2117),
    [anon_sym_PLUS_PLUS] = ACTIONS(2115),
    [anon_sym_DASH_DASH] = ACTIONS(2115),
    [anon_sym_DQUOTE] = ACTIONS(2115),
    [anon_sym_SQUOTE] = ACTIONS(2115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2115),
    [sym_number] = ACTIONS(2115),
    [sym_this] = ACTIONS(2117),
    [sym_super] = ACTIONS(2117),
    [sym_true] = ACTIONS(2117),
    [sym_false] = ACTIONS(2117),
    [sym_null] = ACTIONS(2117),
    [sym_undefined] = ACTIONS(2117),
    [anon_sym_AT] = ACTIONS(2115),
    [anon_sym_static] = ACTIONS(2117),
    [anon_sym_abstract] = ACTIONS(2117),
    [anon_sym_get] = ACTIONS(2117),
    [anon_sym_set] = ACTIONS(2117),
    [anon_sym_declare] = ACTIONS(2117),
    [anon_sym_public] = ACTIONS(2117),
    [anon_sym_private] = ACTIONS(2117),
    [anon_sym_protected] = ACTIONS(2117),
    [anon_sym_module] = ACTIONS(2117),
    [anon_sym_any] = ACTIONS(2117),
    [anon_sym_number] = ACTIONS(2117),
    [anon_sym_boolean] = ACTIONS(2117),
    [anon_sym_string] = ACTIONS(2117),
    [anon_sym_symbol] = ACTIONS(2117),
    [anon_sym_interface] = ACTIONS(2117),
    [anon_sym_enum] = ACTIONS(2117),
    [sym_readonly] = ACTIONS(2117),
  },
  [620] = {
    [ts_builtin_sym_end] = ACTIONS(2119),
    [sym_identifier] = ACTIONS(2121),
    [anon_sym_export] = ACTIONS(2121),
    [anon_sym_default] = ACTIONS(2121),
    [anon_sym_namespace] = ACTIONS(2121),
    [anon_sym_LBRACE] = ACTIONS(2119),
    [anon_sym_RBRACE] = ACTIONS(2119),
    [anon_sym_type] = ACTIONS(2121),
    [anon_sym_typeof] = ACTIONS(2121),
    [anon_sym_import] = ACTIONS(2121),
    [anon_sym_var] = ACTIONS(2121),
    [anon_sym_let] = ACTIONS(2121),
    [anon_sym_const] = ACTIONS(2121),
    [anon_sym_BANG] = ACTIONS(2119),
    [anon_sym_else] = ACTIONS(2121),
    [anon_sym_if] = ACTIONS(2121),
    [anon_sym_switch] = ACTIONS(2121),
    [anon_sym_for] = ACTIONS(2121),
    [anon_sym_LPAREN] = ACTIONS(2119),
    [anon_sym_await] = ACTIONS(2121),
    [anon_sym_while] = ACTIONS(2121),
    [anon_sym_do] = ACTIONS(2121),
    [anon_sym_try] = ACTIONS(2121),
    [anon_sym_with] = ACTIONS(2121),
    [anon_sym_break] = ACTIONS(2121),
    [anon_sym_continue] = ACTIONS(2121),
    [anon_sym_debugger] = ACTIONS(2121),
    [anon_sym_return] = ACTIONS(2121),
    [anon_sym_throw] = ACTIONS(2121),
    [anon_sym_SEMI] = ACTIONS(2119),
    [anon_sym_case] = ACTIONS(2121),
    [anon_sym_yield] = ACTIONS(2121),
    [anon_sym_LBRACK] = ACTIONS(2119),
    [anon_sym_LT] = ACTIONS(2119),
    [anon_sym_SLASH] = ACTIONS(2121),
    [anon_sym_class] = ACTIONS(2121),
    [anon_sym_async] = ACTIONS(2121),
    [anon_sym_function] = ACTIONS(2121),
    [anon_sym_new] = ACTIONS(2121),
    [anon_sym_PLUS] = ACTIONS(2121),
    [anon_sym_DASH] = ACTIONS(2121),
    [anon_sym_TILDE] = ACTIONS(2119),
    [anon_sym_void] = ACTIONS(2121),
    [anon_sym_delete] = ACTIONS(2121),
    [anon_sym_PLUS_PLUS] = ACTIONS(2119),
    [anon_sym_DASH_DASH] = ACTIONS(2119),
    [anon_sym_DQUOTE] = ACTIONS(2119),
    [anon_sym_SQUOTE] = ACTIONS(2119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2119),
    [sym_number] = ACTIONS(2119),
    [sym_this] = ACTIONS(2121),
    [sym_super] = ACTIONS(2121),
    [sym_true] = ACTIONS(2121),
    [sym_false] = ACTIONS(2121),
    [sym_null] = ACTIONS(2121),
    [sym_undefined] = ACTIONS(2121),
    [anon_sym_AT] = ACTIONS(2119),
    [anon_sym_static] = ACTIONS(2121),
    [anon_sym_abstract] = ACTIONS(2121),
    [anon_sym_get] = ACTIONS(2121),
    [anon_sym_set] = ACTIONS(2121),
    [anon_sym_declare] = ACTIONS(2121),
    [anon_sym_public] = ACTIONS(2121),
    [anon_sym_private] = ACTIONS(2121),
    [anon_sym_protected] = ACTIONS(2121),
    [anon_sym_module] = ACTIONS(2121),
    [anon_sym_any] = ACTIONS(2121),
    [anon_sym_number] = ACTIONS(2121),
    [anon_sym_boolean] = ACTIONS(2121),
    [anon_sym_string] = ACTIONS(2121),
    [anon_sym_symbol] = ACTIONS(2121),
    [anon_sym_interface] = ACTIONS(2121),
    [anon_sym_enum] = ACTIONS(2121),
    [sym_readonly] = ACTIONS(2121),
  },
  [621] = {
    [ts_builtin_sym_end] = ACTIONS(2123),
    [sym_identifier] = ACTIONS(2125),
    [anon_sym_export] = ACTIONS(2125),
    [anon_sym_default] = ACTIONS(2125),
    [anon_sym_namespace] = ACTIONS(2125),
    [anon_sym_LBRACE] = ACTIONS(2123),
    [anon_sym_RBRACE] = ACTIONS(2123),
    [anon_sym_type] = ACTIONS(2125),
    [anon_sym_typeof] = ACTIONS(2125),
    [anon_sym_import] = ACTIONS(2125),
    [anon_sym_var] = ACTIONS(2125),
    [anon_sym_let] = ACTIONS(2125),
    [anon_sym_const] = ACTIONS(2125),
    [anon_sym_BANG] = ACTIONS(2123),
    [anon_sym_else] = ACTIONS(2125),
    [anon_sym_if] = ACTIONS(2125),
    [anon_sym_switch] = ACTIONS(2125),
    [anon_sym_for] = ACTIONS(2125),
    [anon_sym_LPAREN] = ACTIONS(2123),
    [anon_sym_await] = ACTIONS(2125),
    [anon_sym_while] = ACTIONS(2125),
    [anon_sym_do] = ACTIONS(2125),
    [anon_sym_try] = ACTIONS(2125),
    [anon_sym_with] = ACTIONS(2125),
    [anon_sym_break] = ACTIONS(2125),
    [anon_sym_continue] = ACTIONS(2125),
    [anon_sym_debugger] = ACTIONS(2125),
    [anon_sym_return] = ACTIONS(2125),
    [anon_sym_throw] = ACTIONS(2125),
    [anon_sym_SEMI] = ACTIONS(2123),
    [anon_sym_case] = ACTIONS(2125),
    [anon_sym_yield] = ACTIONS(2125),
    [anon_sym_LBRACK] = ACTIONS(2123),
    [anon_sym_LT] = ACTIONS(2123),
    [anon_sym_SLASH] = ACTIONS(2125),
    [anon_sym_class] = ACTIONS(2125),
    [anon_sym_async] = ACTIONS(2125),
    [anon_sym_function] = ACTIONS(2125),
    [anon_sym_new] = ACTIONS(2125),
    [anon_sym_PLUS] = ACTIONS(2125),
    [anon_sym_DASH] = ACTIONS(2125),
    [anon_sym_TILDE] = ACTIONS(2123),
    [anon_sym_void] = ACTIONS(2125),
    [anon_sym_delete] = ACTIONS(2125),
    [anon_sym_PLUS_PLUS] = ACTIONS(2123),
    [anon_sym_DASH_DASH] = ACTIONS(2123),
    [anon_sym_DQUOTE] = ACTIONS(2123),
    [anon_sym_SQUOTE] = ACTIONS(2123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2123),
    [sym_number] = ACTIONS(2123),
    [sym_this] = ACTIONS(2125),
    [sym_super] = ACTIONS(2125),
    [sym_true] = ACTIONS(2125),
    [sym_false] = ACTIONS(2125),
    [sym_null] = ACTIONS(2125),
    [sym_undefined] = ACTIONS(2125),
    [anon_sym_AT] = ACTIONS(2123),
    [anon_sym_static] = ACTIONS(2125),
    [anon_sym_abstract] = ACTIONS(2125),
    [anon_sym_get] = ACTIONS(2125),
    [anon_sym_set] = ACTIONS(2125),
    [anon_sym_declare] = ACTIONS(2125),
    [anon_sym_public] = ACTIONS(2125),
    [anon_sym_private] = ACTIONS(2125),
    [anon_sym_protected] = ACTIONS(2125),
    [anon_sym_module] = ACTIONS(2125),
    [anon_sym_any] = ACTIONS(2125),
    [anon_sym_number] = ACTIONS(2125),
    [anon_sym_boolean] = ACTIONS(2125),
    [anon_sym_string] = ACTIONS(2125),
    [anon_sym_symbol] = ACTIONS(2125),
    [anon_sym_interface] = ACTIONS(2125),
    [anon_sym_enum] = ACTIONS(2125),
    [sym_readonly] = ACTIONS(2125),
  },
  [622] = {
    [ts_builtin_sym_end] = ACTIONS(2127),
    [sym_identifier] = ACTIONS(2129),
    [anon_sym_export] = ACTIONS(2129),
    [anon_sym_default] = ACTIONS(2129),
    [anon_sym_namespace] = ACTIONS(2129),
    [anon_sym_LBRACE] = ACTIONS(2127),
    [anon_sym_RBRACE] = ACTIONS(2127),
    [anon_sym_type] = ACTIONS(2129),
    [anon_sym_typeof] = ACTIONS(2129),
    [anon_sym_import] = ACTIONS(2129),
    [anon_sym_var] = ACTIONS(2129),
    [anon_sym_let] = ACTIONS(2129),
    [anon_sym_const] = ACTIONS(2129),
    [anon_sym_BANG] = ACTIONS(2127),
    [anon_sym_else] = ACTIONS(2129),
    [anon_sym_if] = ACTIONS(2129),
    [anon_sym_switch] = ACTIONS(2129),
    [anon_sym_for] = ACTIONS(2129),
    [anon_sym_LPAREN] = ACTIONS(2127),
    [anon_sym_await] = ACTIONS(2129),
    [anon_sym_while] = ACTIONS(2129),
    [anon_sym_do] = ACTIONS(2129),
    [anon_sym_try] = ACTIONS(2129),
    [anon_sym_with] = ACTIONS(2129),
    [anon_sym_break] = ACTIONS(2129),
    [anon_sym_continue] = ACTIONS(2129),
    [anon_sym_debugger] = ACTIONS(2129),
    [anon_sym_return] = ACTIONS(2129),
    [anon_sym_throw] = ACTIONS(2129),
    [anon_sym_SEMI] = ACTIONS(2127),
    [anon_sym_case] = ACTIONS(2129),
    [anon_sym_yield] = ACTIONS(2129),
    [anon_sym_LBRACK] = ACTIONS(2127),
    [anon_sym_LT] = ACTIONS(2127),
    [anon_sym_SLASH] = ACTIONS(2129),
    [anon_sym_class] = ACTIONS(2129),
    [anon_sym_async] = ACTIONS(2129),
    [anon_sym_function] = ACTIONS(2129),
    [anon_sym_new] = ACTIONS(2129),
    [anon_sym_PLUS] = ACTIONS(2129),
    [anon_sym_DASH] = ACTIONS(2129),
    [anon_sym_TILDE] = ACTIONS(2127),
    [anon_sym_void] = ACTIONS(2129),
    [anon_sym_delete] = ACTIONS(2129),
    [anon_sym_PLUS_PLUS] = ACTIONS(2127),
    [anon_sym_DASH_DASH] = ACTIONS(2127),
    [anon_sym_DQUOTE] = ACTIONS(2127),
    [anon_sym_SQUOTE] = ACTIONS(2127),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2127),
    [sym_number] = ACTIONS(2127),
    [sym_this] = ACTIONS(2129),
    [sym_super] = ACTIONS(2129),
    [sym_true] = ACTIONS(2129),
    [sym_false] = ACTIONS(2129),
    [sym_null] = ACTIONS(2129),
    [sym_undefined] = ACTIONS(2129),
    [anon_sym_AT] = ACTIONS(2127),
    [anon_sym_static] = ACTIONS(2129),
    [anon_sym_abstract] = ACTIONS(2129),
    [anon_sym_get] = ACTIONS(2129),
    [anon_sym_set] = ACTIONS(2129),
    [anon_sym_declare] = ACTIONS(2129),
    [anon_sym_public] = ACTIONS(2129),
    [anon_sym_private] = ACTIONS(2129),
    [anon_sym_protected] = ACTIONS(2129),
    [anon_sym_module] = ACTIONS(2129),
    [anon_sym_any] = ACTIONS(2129),
    [anon_sym_number] = ACTIONS(2129),
    [anon_sym_boolean] = ACTIONS(2129),
    [anon_sym_string] = ACTIONS(2129),
    [anon_sym_symbol] = ACTIONS(2129),
    [anon_sym_interface] = ACTIONS(2129),
    [anon_sym_enum] = ACTIONS(2129),
    [sym_readonly] = ACTIONS(2129),
  },
  [623] = {
    [ts_builtin_sym_end] = ACTIONS(2131),
    [sym_identifier] = ACTIONS(2133),
    [anon_sym_export] = ACTIONS(2133),
    [anon_sym_default] = ACTIONS(2133),
    [anon_sym_namespace] = ACTIONS(2133),
    [anon_sym_LBRACE] = ACTIONS(2131),
    [anon_sym_RBRACE] = ACTIONS(2131),
    [anon_sym_type] = ACTIONS(2133),
    [anon_sym_typeof] = ACTIONS(2133),
    [anon_sym_import] = ACTIONS(2133),
    [anon_sym_var] = ACTIONS(2133),
    [anon_sym_let] = ACTIONS(2133),
    [anon_sym_const] = ACTIONS(2133),
    [anon_sym_BANG] = ACTIONS(2131),
    [anon_sym_else] = ACTIONS(2133),
    [anon_sym_if] = ACTIONS(2133),
    [anon_sym_switch] = ACTIONS(2133),
    [anon_sym_for] = ACTIONS(2133),
    [anon_sym_LPAREN] = ACTIONS(2131),
    [anon_sym_await] = ACTIONS(2133),
    [anon_sym_while] = ACTIONS(2133),
    [anon_sym_do] = ACTIONS(2133),
    [anon_sym_try] = ACTIONS(2133),
    [anon_sym_with] = ACTIONS(2133),
    [anon_sym_break] = ACTIONS(2133),
    [anon_sym_continue] = ACTIONS(2133),
    [anon_sym_debugger] = ACTIONS(2133),
    [anon_sym_return] = ACTIONS(2133),
    [anon_sym_throw] = ACTIONS(2133),
    [anon_sym_SEMI] = ACTIONS(2131),
    [anon_sym_case] = ACTIONS(2133),
    [anon_sym_yield] = ACTIONS(2133),
    [anon_sym_LBRACK] = ACTIONS(2131),
    [anon_sym_LT] = ACTIONS(2131),
    [anon_sym_SLASH] = ACTIONS(2133),
    [anon_sym_class] = ACTIONS(2133),
    [anon_sym_async] = ACTIONS(2133),
    [anon_sym_function] = ACTIONS(2133),
    [anon_sym_new] = ACTIONS(2133),
    [anon_sym_PLUS] = ACTIONS(2133),
    [anon_sym_DASH] = ACTIONS(2133),
    [anon_sym_TILDE] = ACTIONS(2131),
    [anon_sym_void] = ACTIONS(2133),
    [anon_sym_delete] = ACTIONS(2133),
    [anon_sym_PLUS_PLUS] = ACTIONS(2131),
    [anon_sym_DASH_DASH] = ACTIONS(2131),
    [anon_sym_DQUOTE] = ACTIONS(2131),
    [anon_sym_SQUOTE] = ACTIONS(2131),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2131),
    [sym_number] = ACTIONS(2131),
    [sym_this] = ACTIONS(2133),
    [sym_super] = ACTIONS(2133),
    [sym_true] = ACTIONS(2133),
    [sym_false] = ACTIONS(2133),
    [sym_null] = ACTIONS(2133),
    [sym_undefined] = ACTIONS(2133),
    [anon_sym_AT] = ACTIONS(2131),
    [anon_sym_static] = ACTIONS(2133),
    [anon_sym_abstract] = ACTIONS(2133),
    [anon_sym_get] = ACTIONS(2133),
    [anon_sym_set] = ACTIONS(2133),
    [anon_sym_declare] = ACTIONS(2133),
    [anon_sym_public] = ACTIONS(2133),
    [anon_sym_private] = ACTIONS(2133),
    [anon_sym_protected] = ACTIONS(2133),
    [anon_sym_module] = ACTIONS(2133),
    [anon_sym_any] = ACTIONS(2133),
    [anon_sym_number] = ACTIONS(2133),
    [anon_sym_boolean] = ACTIONS(2133),
    [anon_sym_string] = ACTIONS(2133),
    [anon_sym_symbol] = ACTIONS(2133),
    [anon_sym_interface] = ACTIONS(2133),
    [anon_sym_enum] = ACTIONS(2133),
    [sym_readonly] = ACTIONS(2133),
  },
  [624] = {
    [ts_builtin_sym_end] = ACTIONS(2135),
    [sym_identifier] = ACTIONS(2137),
    [anon_sym_export] = ACTIONS(2137),
    [anon_sym_default] = ACTIONS(2137),
    [anon_sym_namespace] = ACTIONS(2137),
    [anon_sym_LBRACE] = ACTIONS(2135),
    [anon_sym_RBRACE] = ACTIONS(2135),
    [anon_sym_type] = ACTIONS(2137),
    [anon_sym_typeof] = ACTIONS(2137),
    [anon_sym_import] = ACTIONS(2137),
    [anon_sym_var] = ACTIONS(2137),
    [anon_sym_let] = ACTIONS(2137),
    [anon_sym_const] = ACTIONS(2137),
    [anon_sym_BANG] = ACTIONS(2135),
    [anon_sym_else] = ACTIONS(2137),
    [anon_sym_if] = ACTIONS(2137),
    [anon_sym_switch] = ACTIONS(2137),
    [anon_sym_for] = ACTIONS(2137),
    [anon_sym_LPAREN] = ACTIONS(2135),
    [anon_sym_await] = ACTIONS(2137),
    [anon_sym_while] = ACTIONS(2137),
    [anon_sym_do] = ACTIONS(2137),
    [anon_sym_try] = ACTIONS(2137),
    [anon_sym_with] = ACTIONS(2137),
    [anon_sym_break] = ACTIONS(2137),
    [anon_sym_continue] = ACTIONS(2137),
    [anon_sym_debugger] = ACTIONS(2137),
    [anon_sym_return] = ACTIONS(2137),
    [anon_sym_throw] = ACTIONS(2137),
    [anon_sym_SEMI] = ACTIONS(2135),
    [anon_sym_case] = ACTIONS(2137),
    [anon_sym_yield] = ACTIONS(2137),
    [anon_sym_LBRACK] = ACTIONS(2135),
    [anon_sym_LT] = ACTIONS(2135),
    [anon_sym_SLASH] = ACTIONS(2137),
    [anon_sym_class] = ACTIONS(2137),
    [anon_sym_async] = ACTIONS(2137),
    [anon_sym_function] = ACTIONS(2137),
    [anon_sym_new] = ACTIONS(2137),
    [anon_sym_PLUS] = ACTIONS(2137),
    [anon_sym_DASH] = ACTIONS(2137),
    [anon_sym_TILDE] = ACTIONS(2135),
    [anon_sym_void] = ACTIONS(2137),
    [anon_sym_delete] = ACTIONS(2137),
    [anon_sym_PLUS_PLUS] = ACTIONS(2135),
    [anon_sym_DASH_DASH] = ACTIONS(2135),
    [anon_sym_DQUOTE] = ACTIONS(2135),
    [anon_sym_SQUOTE] = ACTIONS(2135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2135),
    [sym_number] = ACTIONS(2135),
    [sym_this] = ACTIONS(2137),
    [sym_super] = ACTIONS(2137),
    [sym_true] = ACTIONS(2137),
    [sym_false] = ACTIONS(2137),
    [sym_null] = ACTIONS(2137),
    [sym_undefined] = ACTIONS(2137),
    [anon_sym_AT] = ACTIONS(2135),
    [anon_sym_static] = ACTIONS(2137),
    [anon_sym_abstract] = ACTIONS(2137),
    [anon_sym_get] = ACTIONS(2137),
    [anon_sym_set] = ACTIONS(2137),
    [anon_sym_declare] = ACTIONS(2137),
    [anon_sym_public] = ACTIONS(2137),
    [anon_sym_private] = ACTIONS(2137),
    [anon_sym_protected] = ACTIONS(2137),
    [anon_sym_module] = ACTIONS(2137),
    [anon_sym_any] = ACTIONS(2137),
    [anon_sym_number] = ACTIONS(2137),
    [anon_sym_boolean] = ACTIONS(2137),
    [anon_sym_string] = ACTIONS(2137),
    [anon_sym_symbol] = ACTIONS(2137),
    [anon_sym_interface] = ACTIONS(2137),
    [anon_sym_enum] = ACTIONS(2137),
    [sym_readonly] = ACTIONS(2137),
  },
  [625] = {
    [ts_builtin_sym_end] = ACTIONS(2139),
    [sym_identifier] = ACTIONS(2141),
    [anon_sym_export] = ACTIONS(2141),
    [anon_sym_default] = ACTIONS(2141),
    [anon_sym_namespace] = ACTIONS(2141),
    [anon_sym_LBRACE] = ACTIONS(2139),
    [anon_sym_RBRACE] = ACTIONS(2139),
    [anon_sym_type] = ACTIONS(2141),
    [anon_sym_typeof] = ACTIONS(2141),
    [anon_sym_import] = ACTIONS(2141),
    [anon_sym_var] = ACTIONS(2141),
    [anon_sym_let] = ACTIONS(2141),
    [anon_sym_const] = ACTIONS(2141),
    [anon_sym_BANG] = ACTIONS(2139),
    [anon_sym_else] = ACTIONS(2141),
    [anon_sym_if] = ACTIONS(2141),
    [anon_sym_switch] = ACTIONS(2141),
    [anon_sym_for] = ACTIONS(2141),
    [anon_sym_LPAREN] = ACTIONS(2139),
    [anon_sym_await] = ACTIONS(2141),
    [anon_sym_while] = ACTIONS(2141),
    [anon_sym_do] = ACTIONS(2141),
    [anon_sym_try] = ACTIONS(2141),
    [anon_sym_with] = ACTIONS(2141),
    [anon_sym_break] = ACTIONS(2141),
    [anon_sym_continue] = ACTIONS(2141),
    [anon_sym_debugger] = ACTIONS(2141),
    [anon_sym_return] = ACTIONS(2141),
    [anon_sym_throw] = ACTIONS(2141),
    [anon_sym_SEMI] = ACTIONS(2139),
    [anon_sym_case] = ACTIONS(2141),
    [anon_sym_yield] = ACTIONS(2141),
    [anon_sym_LBRACK] = ACTIONS(2139),
    [anon_sym_LT] = ACTIONS(2139),
    [anon_sym_SLASH] = ACTIONS(2141),
    [anon_sym_class] = ACTIONS(2141),
    [anon_sym_async] = ACTIONS(2141),
    [anon_sym_function] = ACTIONS(2141),
    [anon_sym_new] = ACTIONS(2141),
    [anon_sym_PLUS] = ACTIONS(2141),
    [anon_sym_DASH] = ACTIONS(2141),
    [anon_sym_TILDE] = ACTIONS(2139),
    [anon_sym_void] = ACTIONS(2141),
    [anon_sym_delete] = ACTIONS(2141),
    [anon_sym_PLUS_PLUS] = ACTIONS(2139),
    [anon_sym_DASH_DASH] = ACTIONS(2139),
    [anon_sym_DQUOTE] = ACTIONS(2139),
    [anon_sym_SQUOTE] = ACTIONS(2139),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2139),
    [sym_number] = ACTIONS(2139),
    [sym_this] = ACTIONS(2141),
    [sym_super] = ACTIONS(2141),
    [sym_true] = ACTIONS(2141),
    [sym_false] = ACTIONS(2141),
    [sym_null] = ACTIONS(2141),
    [sym_undefined] = ACTIONS(2141),
    [anon_sym_AT] = ACTIONS(2139),
    [anon_sym_static] = ACTIONS(2141),
    [anon_sym_abstract] = ACTIONS(2141),
    [anon_sym_get] = ACTIONS(2141),
    [anon_sym_set] = ACTIONS(2141),
    [anon_sym_declare] = ACTIONS(2141),
    [anon_sym_public] = ACTIONS(2141),
    [anon_sym_private] = ACTIONS(2141),
    [anon_sym_protected] = ACTIONS(2141),
    [anon_sym_module] = ACTIONS(2141),
    [anon_sym_any] = ACTIONS(2141),
    [anon_sym_number] = ACTIONS(2141),
    [anon_sym_boolean] = ACTIONS(2141),
    [anon_sym_string] = ACTIONS(2141),
    [anon_sym_symbol] = ACTIONS(2141),
    [anon_sym_interface] = ACTIONS(2141),
    [anon_sym_enum] = ACTIONS(2141),
    [sym_readonly] = ACTIONS(2141),
  },
  [626] = {
    [sym_identifier] = ACTIONS(2143),
    [anon_sym_export] = ACTIONS(2143),
    [anon_sym_namespace] = ACTIONS(2143),
    [anon_sym_LBRACE] = ACTIONS(2145),
    [anon_sym_type] = ACTIONS(2143),
    [anon_sym_typeof] = ACTIONS(2143),
    [anon_sym_import] = ACTIONS(2143),
    [anon_sym_var] = ACTIONS(2143),
    [anon_sym_let] = ACTIONS(2143),
    [anon_sym_const] = ACTIONS(2143),
    [anon_sym_BANG] = ACTIONS(2145),
    [anon_sym_if] = ACTIONS(2143),
    [anon_sym_switch] = ACTIONS(2143),
    [anon_sym_for] = ACTIONS(2143),
    [anon_sym_LPAREN] = ACTIONS(2145),
    [anon_sym_await] = ACTIONS(2143),
    [anon_sym_while] = ACTIONS(2143),
    [anon_sym_do] = ACTIONS(2143),
    [anon_sym_try] = ACTIONS(2143),
    [anon_sym_with] = ACTIONS(2143),
    [anon_sym_break] = ACTIONS(2143),
    [anon_sym_continue] = ACTIONS(2143),
    [anon_sym_debugger] = ACTIONS(2143),
    [anon_sym_return] = ACTIONS(2143),
    [anon_sym_throw] = ACTIONS(2143),
    [anon_sym_SEMI] = ACTIONS(2145),
    [anon_sym_yield] = ACTIONS(2143),
    [anon_sym_LBRACK] = ACTIONS(2145),
    [anon_sym_LT] = ACTIONS(2145),
    [anon_sym_SLASH] = ACTIONS(2143),
    [anon_sym_class] = ACTIONS(2143),
    [anon_sym_async] = ACTIONS(2143),
    [anon_sym_function] = ACTIONS(2143),
    [anon_sym_new] = ACTIONS(2143),
    [anon_sym_PLUS] = ACTIONS(2143),
    [anon_sym_DASH] = ACTIONS(2143),
    [anon_sym_TILDE] = ACTIONS(2145),
    [anon_sym_void] = ACTIONS(2143),
    [anon_sym_delete] = ACTIONS(2143),
    [anon_sym_PLUS_PLUS] = ACTIONS(2145),
    [anon_sym_DASH_DASH] = ACTIONS(2145),
    [anon_sym_DQUOTE] = ACTIONS(2145),
    [anon_sym_SQUOTE] = ACTIONS(2145),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2145),
    [sym_number] = ACTIONS(2145),
    [sym_this] = ACTIONS(2143),
    [sym_super] = ACTIONS(2143),
    [sym_true] = ACTIONS(2143),
    [sym_false] = ACTIONS(2143),
    [sym_null] = ACTIONS(2143),
    [sym_undefined] = ACTIONS(2143),
    [anon_sym_AT] = ACTIONS(2145),
    [anon_sym_static] = ACTIONS(2143),
    [anon_sym_abstract] = ACTIONS(2143),
    [anon_sym_get] = ACTIONS(2143),
    [anon_sym_set] = ACTIONS(2143),
    [anon_sym_declare] = ACTIONS(2143),
    [anon_sym_public] = ACTIONS(2143),
    [anon_sym_private] = ACTIONS(2143),
    [anon_sym_protected] = ACTIONS(2143),
    [anon_sym_module] = ACTIONS(2143),
    [anon_sym_any] = ACTIONS(2143),
    [anon_sym_number] = ACTIONS(2143),
    [anon_sym_boolean] = ACTIONS(2143),
    [anon_sym_string] = ACTIONS(2143),
    [anon_sym_symbol] = ACTIONS(2143),
    [anon_sym_interface] = ACTIONS(2143),
    [anon_sym_enum] = ACTIONS(2143),
    [sym_readonly] = ACTIONS(2143),
  },
  [627] = {
    [sym_identifier] = ACTIONS(2147),
    [anon_sym_export] = ACTIONS(2147),
    [anon_sym_namespace] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2149),
    [anon_sym_type] = ACTIONS(2147),
    [anon_sym_typeof] = ACTIONS(2147),
    [anon_sym_import] = ACTIONS(2147),
    [anon_sym_var] = ACTIONS(2147),
    [anon_sym_let] = ACTIONS(2147),
    [anon_sym_const] = ACTIONS(2147),
    [anon_sym_BANG] = ACTIONS(2149),
    [anon_sym_if] = ACTIONS(2147),
    [anon_sym_switch] = ACTIONS(2147),
    [anon_sym_for] = ACTIONS(2147),
    [anon_sym_LPAREN] = ACTIONS(2149),
    [anon_sym_await] = ACTIONS(2147),
    [anon_sym_while] = ACTIONS(2147),
    [anon_sym_do] = ACTIONS(2147),
    [anon_sym_try] = ACTIONS(2147),
    [anon_sym_with] = ACTIONS(2147),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_continue] = ACTIONS(2147),
    [anon_sym_debugger] = ACTIONS(2147),
    [anon_sym_return] = ACTIONS(2147),
    [anon_sym_throw] = ACTIONS(2147),
    [anon_sym_SEMI] = ACTIONS(2149),
    [anon_sym_yield] = ACTIONS(2147),
    [anon_sym_LBRACK] = ACTIONS(2149),
    [anon_sym_LT] = ACTIONS(2149),
    [anon_sym_SLASH] = ACTIONS(2147),
    [anon_sym_class] = ACTIONS(2147),
    [anon_sym_async] = ACTIONS(2147),
    [anon_sym_function] = ACTIONS(2147),
    [anon_sym_new] = ACTIONS(2147),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_DASH] = ACTIONS(2147),
    [anon_sym_TILDE] = ACTIONS(2149),
    [anon_sym_void] = ACTIONS(2147),
    [anon_sym_delete] = ACTIONS(2147),
    [anon_sym_PLUS_PLUS] = ACTIONS(2149),
    [anon_sym_DASH_DASH] = ACTIONS(2149),
    [anon_sym_DQUOTE] = ACTIONS(2149),
    [anon_sym_SQUOTE] = ACTIONS(2149),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2149),
    [sym_number] = ACTIONS(2149),
    [sym_this] = ACTIONS(2147),
    [sym_super] = ACTIONS(2147),
    [sym_true] = ACTIONS(2147),
    [sym_false] = ACTIONS(2147),
    [sym_null] = ACTIONS(2147),
    [sym_undefined] = ACTIONS(2147),
    [anon_sym_AT] = ACTIONS(2149),
    [anon_sym_static] = ACTIONS(2147),
    [anon_sym_abstract] = ACTIONS(2147),
    [anon_sym_get] = ACTIONS(2147),
    [anon_sym_set] = ACTIONS(2147),
    [anon_sym_declare] = ACTIONS(2147),
    [anon_sym_public] = ACTIONS(2147),
    [anon_sym_private] = ACTIONS(2147),
    [anon_sym_protected] = ACTIONS(2147),
    [anon_sym_module] = ACTIONS(2147),
    [anon_sym_any] = ACTIONS(2147),
    [anon_sym_number] = ACTIONS(2147),
    [anon_sym_boolean] = ACTIONS(2147),
    [anon_sym_string] = ACTIONS(2147),
    [anon_sym_symbol] = ACTIONS(2147),
    [anon_sym_interface] = ACTIONS(2147),
    [anon_sym_enum] = ACTIONS(2147),
    [sym_readonly] = ACTIONS(2147),
  },
  [628] = {
    [sym_identifier] = ACTIONS(2151),
    [anon_sym_export] = ACTIONS(2151),
    [anon_sym_namespace] = ACTIONS(2151),
    [anon_sym_LBRACE] = ACTIONS(2153),
    [anon_sym_type] = ACTIONS(2151),
    [anon_sym_typeof] = ACTIONS(2151),
    [anon_sym_import] = ACTIONS(2151),
    [anon_sym_var] = ACTIONS(2151),
    [anon_sym_let] = ACTIONS(2151),
    [anon_sym_const] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(2153),
    [anon_sym_if] = ACTIONS(2151),
    [anon_sym_switch] = ACTIONS(2151),
    [anon_sym_for] = ACTIONS(2151),
    [anon_sym_LPAREN] = ACTIONS(2153),
    [anon_sym_await] = ACTIONS(2151),
    [anon_sym_while] = ACTIONS(2151),
    [anon_sym_do] = ACTIONS(2151),
    [anon_sym_try] = ACTIONS(2151),
    [anon_sym_with] = ACTIONS(2151),
    [anon_sym_break] = ACTIONS(2151),
    [anon_sym_continue] = ACTIONS(2151),
    [anon_sym_debugger] = ACTIONS(2151),
    [anon_sym_return] = ACTIONS(2151),
    [anon_sym_throw] = ACTIONS(2151),
    [anon_sym_SEMI] = ACTIONS(2153),
    [anon_sym_yield] = ACTIONS(2151),
    [anon_sym_LBRACK] = ACTIONS(2153),
    [anon_sym_LT] = ACTIONS(2153),
    [anon_sym_SLASH] = ACTIONS(2151),
    [anon_sym_class] = ACTIONS(2151),
    [anon_sym_async] = ACTIONS(2151),
    [anon_sym_function] = ACTIONS(2151),
    [anon_sym_new] = ACTIONS(2151),
    [anon_sym_PLUS] = ACTIONS(2151),
    [anon_sym_DASH] = ACTIONS(2151),
    [anon_sym_TILDE] = ACTIONS(2153),
    [anon_sym_void] = ACTIONS(2151),
    [anon_sym_delete] = ACTIONS(2151),
    [anon_sym_PLUS_PLUS] = ACTIONS(2153),
    [anon_sym_DASH_DASH] = ACTIONS(2153),
    [anon_sym_DQUOTE] = ACTIONS(2153),
    [anon_sym_SQUOTE] = ACTIONS(2153),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2153),
    [sym_number] = ACTIONS(2153),
    [sym_this] = ACTIONS(2151),
    [sym_super] = ACTIONS(2151),
    [sym_true] = ACTIONS(2151),
    [sym_false] = ACTIONS(2151),
    [sym_null] = ACTIONS(2151),
    [sym_undefined] = ACTIONS(2151),
    [anon_sym_AT] = ACTIONS(2153),
    [anon_sym_static] = ACTIONS(2151),
    [anon_sym_abstract] = ACTIONS(2151),
    [anon_sym_get] = ACTIONS(2151),
    [anon_sym_set] = ACTIONS(2151),
    [anon_sym_declare] = ACTIONS(2151),
    [anon_sym_public] = ACTIONS(2151),
    [anon_sym_private] = ACTIONS(2151),
    [anon_sym_protected] = ACTIONS(2151),
    [anon_sym_module] = ACTIONS(2151),
    [anon_sym_any] = ACTIONS(2151),
    [anon_sym_number] = ACTIONS(2151),
    [anon_sym_boolean] = ACTIONS(2151),
    [anon_sym_string] = ACTIONS(2151),
    [anon_sym_symbol] = ACTIONS(2151),
    [anon_sym_interface] = ACTIONS(2151),
    [anon_sym_enum] = ACTIONS(2151),
    [sym_readonly] = ACTIONS(2151),
  },
  [629] = {
    [sym_identifier] = ACTIONS(2155),
    [anon_sym_export] = ACTIONS(2155),
    [anon_sym_namespace] = ACTIONS(2155),
    [anon_sym_LBRACE] = ACTIONS(2157),
    [anon_sym_type] = ACTIONS(2155),
    [anon_sym_typeof] = ACTIONS(2155),
    [anon_sym_import] = ACTIONS(2155),
    [anon_sym_var] = ACTIONS(2155),
    [anon_sym_let] = ACTIONS(2155),
    [anon_sym_const] = ACTIONS(2155),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_if] = ACTIONS(2155),
    [anon_sym_switch] = ACTIONS(2155),
    [anon_sym_for] = ACTIONS(2155),
    [anon_sym_LPAREN] = ACTIONS(2157),
    [anon_sym_await] = ACTIONS(2155),
    [anon_sym_while] = ACTIONS(2155),
    [anon_sym_do] = ACTIONS(2155),
    [anon_sym_try] = ACTIONS(2155),
    [anon_sym_with] = ACTIONS(2155),
    [anon_sym_break] = ACTIONS(2155),
    [anon_sym_continue] = ACTIONS(2155),
    [anon_sym_debugger] = ACTIONS(2155),
    [anon_sym_return] = ACTIONS(2155),
    [anon_sym_throw] = ACTIONS(2155),
    [anon_sym_SEMI] = ACTIONS(2157),
    [anon_sym_yield] = ACTIONS(2155),
    [anon_sym_LBRACK] = ACTIONS(2157),
    [anon_sym_LT] = ACTIONS(2157),
    [anon_sym_SLASH] = ACTIONS(2155),
    [anon_sym_class] = ACTIONS(2155),
    [anon_sym_async] = ACTIONS(2155),
    [anon_sym_function] = ACTIONS(2155),
    [anon_sym_new] = ACTIONS(2155),
    [anon_sym_PLUS] = ACTIONS(2155),
    [anon_sym_DASH] = ACTIONS(2155),
    [anon_sym_TILDE] = ACTIONS(2157),
    [anon_sym_void] = ACTIONS(2155),
    [anon_sym_delete] = ACTIONS(2155),
    [anon_sym_PLUS_PLUS] = ACTIONS(2157),
    [anon_sym_DASH_DASH] = ACTIONS(2157),
    [anon_sym_DQUOTE] = ACTIONS(2157),
    [anon_sym_SQUOTE] = ACTIONS(2157),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2157),
    [sym_number] = ACTIONS(2157),
    [sym_this] = ACTIONS(2155),
    [sym_super] = ACTIONS(2155),
    [sym_true] = ACTIONS(2155),
    [sym_false] = ACTIONS(2155),
    [sym_null] = ACTIONS(2155),
    [sym_undefined] = ACTIONS(2155),
    [anon_sym_AT] = ACTIONS(2157),
    [anon_sym_static] = ACTIONS(2155),
    [anon_sym_abstract] = ACTIONS(2155),
    [anon_sym_get] = ACTIONS(2155),
    [anon_sym_set] = ACTIONS(2155),
    [anon_sym_declare] = ACTIONS(2155),
    [anon_sym_public] = ACTIONS(2155),
    [anon_sym_private] = ACTIONS(2155),
    [anon_sym_protected] = ACTIONS(2155),
    [anon_sym_module] = ACTIONS(2155),
    [anon_sym_any] = ACTIONS(2155),
    [anon_sym_number] = ACTIONS(2155),
    [anon_sym_boolean] = ACTIONS(2155),
    [anon_sym_string] = ACTIONS(2155),
    [anon_sym_symbol] = ACTIONS(2155),
    [anon_sym_interface] = ACTIONS(2155),
    [anon_sym_enum] = ACTIONS(2155),
    [sym_readonly] = ACTIONS(2155),
  },
  [630] = {
    [sym_identifier] = ACTIONS(2159),
    [anon_sym_export] = ACTIONS(2159),
    [anon_sym_namespace] = ACTIONS(2159),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_type] = ACTIONS(2159),
    [anon_sym_typeof] = ACTIONS(2159),
    [anon_sym_import] = ACTIONS(2159),
    [anon_sym_var] = ACTIONS(2159),
    [anon_sym_let] = ACTIONS(2159),
    [anon_sym_const] = ACTIONS(2159),
    [anon_sym_BANG] = ACTIONS(2161),
    [anon_sym_if] = ACTIONS(2159),
    [anon_sym_switch] = ACTIONS(2159),
    [anon_sym_for] = ACTIONS(2159),
    [anon_sym_LPAREN] = ACTIONS(2161),
    [anon_sym_await] = ACTIONS(2159),
    [anon_sym_while] = ACTIONS(2159),
    [anon_sym_do] = ACTIONS(2159),
    [anon_sym_try] = ACTIONS(2159),
    [anon_sym_with] = ACTIONS(2159),
    [anon_sym_break] = ACTIONS(2159),
    [anon_sym_continue] = ACTIONS(2159),
    [anon_sym_debugger] = ACTIONS(2159),
    [anon_sym_return] = ACTIONS(2159),
    [anon_sym_throw] = ACTIONS(2159),
    [anon_sym_SEMI] = ACTIONS(2161),
    [anon_sym_yield] = ACTIONS(2159),
    [anon_sym_LBRACK] = ACTIONS(2161),
    [anon_sym_LT] = ACTIONS(2161),
    [anon_sym_SLASH] = ACTIONS(2159),
    [anon_sym_class] = ACTIONS(2159),
    [anon_sym_async] = ACTIONS(2159),
    [anon_sym_function] = ACTIONS(2159),
    [anon_sym_new] = ACTIONS(2159),
    [anon_sym_PLUS] = ACTIONS(2159),
    [anon_sym_DASH] = ACTIONS(2159),
    [anon_sym_TILDE] = ACTIONS(2161),
    [anon_sym_void] = ACTIONS(2159),
    [anon_sym_delete] = ACTIONS(2159),
    [anon_sym_PLUS_PLUS] = ACTIONS(2161),
    [anon_sym_DASH_DASH] = ACTIONS(2161),
    [anon_sym_DQUOTE] = ACTIONS(2161),
    [anon_sym_SQUOTE] = ACTIONS(2161),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2161),
    [sym_number] = ACTIONS(2161),
    [sym_this] = ACTIONS(2159),
    [sym_super] = ACTIONS(2159),
    [sym_true] = ACTIONS(2159),
    [sym_false] = ACTIONS(2159),
    [sym_null] = ACTIONS(2159),
    [sym_undefined] = ACTIONS(2159),
    [anon_sym_AT] = ACTIONS(2161),
    [anon_sym_static] = ACTIONS(2159),
    [anon_sym_abstract] = ACTIONS(2159),
    [anon_sym_get] = ACTIONS(2159),
    [anon_sym_set] = ACTIONS(2159),
    [anon_sym_declare] = ACTIONS(2159),
    [anon_sym_public] = ACTIONS(2159),
    [anon_sym_private] = ACTIONS(2159),
    [anon_sym_protected] = ACTIONS(2159),
    [anon_sym_module] = ACTIONS(2159),
    [anon_sym_any] = ACTIONS(2159),
    [anon_sym_number] = ACTIONS(2159),
    [anon_sym_boolean] = ACTIONS(2159),
    [anon_sym_string] = ACTIONS(2159),
    [anon_sym_symbol] = ACTIONS(2159),
    [anon_sym_interface] = ACTIONS(2159),
    [anon_sym_enum] = ACTIONS(2159),
    [sym_readonly] = ACTIONS(2159),
  },
  [631] = {
    [sym_identifier] = ACTIONS(2163),
    [anon_sym_export] = ACTIONS(2163),
    [anon_sym_namespace] = ACTIONS(2163),
    [anon_sym_LBRACE] = ACTIONS(2165),
    [anon_sym_type] = ACTIONS(2163),
    [anon_sym_typeof] = ACTIONS(2163),
    [anon_sym_import] = ACTIONS(2163),
    [anon_sym_var] = ACTIONS(2163),
    [anon_sym_let] = ACTIONS(2163),
    [anon_sym_const] = ACTIONS(2163),
    [anon_sym_BANG] = ACTIONS(2165),
    [anon_sym_if] = ACTIONS(2163),
    [anon_sym_switch] = ACTIONS(2163),
    [anon_sym_for] = ACTIONS(2163),
    [anon_sym_LPAREN] = ACTIONS(2165),
    [anon_sym_await] = ACTIONS(2163),
    [anon_sym_while] = ACTIONS(2163),
    [anon_sym_do] = ACTIONS(2163),
    [anon_sym_try] = ACTIONS(2163),
    [anon_sym_with] = ACTIONS(2163),
    [anon_sym_break] = ACTIONS(2163),
    [anon_sym_continue] = ACTIONS(2163),
    [anon_sym_debugger] = ACTIONS(2163),
    [anon_sym_return] = ACTIONS(2163),
    [anon_sym_throw] = ACTIONS(2163),
    [anon_sym_SEMI] = ACTIONS(2165),
    [anon_sym_yield] = ACTIONS(2163),
    [anon_sym_LBRACK] = ACTIONS(2165),
    [anon_sym_LT] = ACTIONS(2165),
    [anon_sym_SLASH] = ACTIONS(2163),
    [anon_sym_class] = ACTIONS(2163),
    [anon_sym_async] = ACTIONS(2163),
    [anon_sym_function] = ACTIONS(2163),
    [anon_sym_new] = ACTIONS(2163),
    [anon_sym_PLUS] = ACTIONS(2163),
    [anon_sym_DASH] = ACTIONS(2163),
    [anon_sym_TILDE] = ACTIONS(2165),
    [anon_sym_void] = ACTIONS(2163),
    [anon_sym_delete] = ACTIONS(2163),
    [anon_sym_PLUS_PLUS] = ACTIONS(2165),
    [anon_sym_DASH_DASH] = ACTIONS(2165),
    [anon_sym_DQUOTE] = ACTIONS(2165),
    [anon_sym_SQUOTE] = ACTIONS(2165),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2165),
    [sym_number] = ACTIONS(2165),
    [sym_this] = ACTIONS(2163),
    [sym_super] = ACTIONS(2163),
    [sym_true] = ACTIONS(2163),
    [sym_false] = ACTIONS(2163),
    [sym_null] = ACTIONS(2163),
    [sym_undefined] = ACTIONS(2163),
    [anon_sym_AT] = ACTIONS(2165),
    [anon_sym_static] = ACTIONS(2163),
    [anon_sym_abstract] = ACTIONS(2163),
    [anon_sym_get] = ACTIONS(2163),
    [anon_sym_set] = ACTIONS(2163),
    [anon_sym_declare] = ACTIONS(2163),
    [anon_sym_public] = ACTIONS(2163),
    [anon_sym_private] = ACTIONS(2163),
    [anon_sym_protected] = ACTIONS(2163),
    [anon_sym_module] = ACTIONS(2163),
    [anon_sym_any] = ACTIONS(2163),
    [anon_sym_number] = ACTIONS(2163),
    [anon_sym_boolean] = ACTIONS(2163),
    [anon_sym_string] = ACTIONS(2163),
    [anon_sym_symbol] = ACTIONS(2163),
    [anon_sym_interface] = ACTIONS(2163),
    [anon_sym_enum] = ACTIONS(2163),
    [sym_readonly] = ACTIONS(2163),
  },
  [632] = {
    [sym_identifier] = ACTIONS(2167),
    [anon_sym_export] = ACTIONS(2167),
    [anon_sym_namespace] = ACTIONS(2167),
    [anon_sym_LBRACE] = ACTIONS(2169),
    [anon_sym_type] = ACTIONS(2167),
    [anon_sym_typeof] = ACTIONS(2167),
    [anon_sym_import] = ACTIONS(2167),
    [anon_sym_var] = ACTIONS(2167),
    [anon_sym_let] = ACTIONS(2167),
    [anon_sym_const] = ACTIONS(2167),
    [anon_sym_BANG] = ACTIONS(2169),
    [anon_sym_if] = ACTIONS(2167),
    [anon_sym_switch] = ACTIONS(2167),
    [anon_sym_for] = ACTIONS(2167),
    [anon_sym_LPAREN] = ACTIONS(2169),
    [anon_sym_await] = ACTIONS(2167),
    [anon_sym_while] = ACTIONS(2167),
    [anon_sym_do] = ACTIONS(2167),
    [anon_sym_try] = ACTIONS(2167),
    [anon_sym_with] = ACTIONS(2167),
    [anon_sym_break] = ACTIONS(2167),
    [anon_sym_continue] = ACTIONS(2167),
    [anon_sym_debugger] = ACTIONS(2167),
    [anon_sym_return] = ACTIONS(2167),
    [anon_sym_throw] = ACTIONS(2167),
    [anon_sym_SEMI] = ACTIONS(2169),
    [anon_sym_yield] = ACTIONS(2167),
    [anon_sym_LBRACK] = ACTIONS(2169),
    [anon_sym_LT] = ACTIONS(2169),
    [anon_sym_SLASH] = ACTIONS(2167),
    [anon_sym_class] = ACTIONS(2167),
    [anon_sym_async] = ACTIONS(2167),
    [anon_sym_function] = ACTIONS(2167),
    [anon_sym_new] = ACTIONS(2167),
    [anon_sym_PLUS] = ACTIONS(2167),
    [anon_sym_DASH] = ACTIONS(2167),
    [anon_sym_TILDE] = ACTIONS(2169),
    [anon_sym_void] = ACTIONS(2167),
    [anon_sym_delete] = ACTIONS(2167),
    [anon_sym_PLUS_PLUS] = ACTIONS(2169),
    [anon_sym_DASH_DASH] = ACTIONS(2169),
    [anon_sym_DQUOTE] = ACTIONS(2169),
    [anon_sym_SQUOTE] = ACTIONS(2169),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2169),
    [sym_number] = ACTIONS(2169),
    [sym_this] = ACTIONS(2167),
    [sym_super] = ACTIONS(2167),
    [sym_true] = ACTIONS(2167),
    [sym_false] = ACTIONS(2167),
    [sym_null] = ACTIONS(2167),
    [sym_undefined] = ACTIONS(2167),
    [anon_sym_AT] = ACTIONS(2169),
    [anon_sym_static] = ACTIONS(2167),
    [anon_sym_abstract] = ACTIONS(2167),
    [anon_sym_get] = ACTIONS(2167),
    [anon_sym_set] = ACTIONS(2167),
    [anon_sym_declare] = ACTIONS(2167),
    [anon_sym_public] = ACTIONS(2167),
    [anon_sym_private] = ACTIONS(2167),
    [anon_sym_protected] = ACTIONS(2167),
    [anon_sym_module] = ACTIONS(2167),
    [anon_sym_any] = ACTIONS(2167),
    [anon_sym_number] = ACTIONS(2167),
    [anon_sym_boolean] = ACTIONS(2167),
    [anon_sym_string] = ACTIONS(2167),
    [anon_sym_symbol] = ACTIONS(2167),
    [anon_sym_interface] = ACTIONS(2167),
    [anon_sym_enum] = ACTIONS(2167),
    [sym_readonly] = ACTIONS(2167),
  },
  [633] = {
    [sym_identifier] = ACTIONS(2171),
    [anon_sym_export] = ACTIONS(2171),
    [anon_sym_namespace] = ACTIONS(2171),
    [anon_sym_LBRACE] = ACTIONS(2173),
    [anon_sym_type] = ACTIONS(2171),
    [anon_sym_typeof] = ACTIONS(2171),
    [anon_sym_import] = ACTIONS(2171),
    [anon_sym_var] = ACTIONS(2171),
    [anon_sym_let] = ACTIONS(2171),
    [anon_sym_const] = ACTIONS(2171),
    [anon_sym_BANG] = ACTIONS(2173),
    [anon_sym_if] = ACTIONS(2171),
    [anon_sym_switch] = ACTIONS(2171),
    [anon_sym_for] = ACTIONS(2171),
    [anon_sym_LPAREN] = ACTIONS(2173),
    [anon_sym_await] = ACTIONS(2171),
    [anon_sym_while] = ACTIONS(2171),
    [anon_sym_do] = ACTIONS(2171),
    [anon_sym_try] = ACTIONS(2171),
    [anon_sym_with] = ACTIONS(2171),
    [anon_sym_break] = ACTIONS(2171),
    [anon_sym_continue] = ACTIONS(2171),
    [anon_sym_debugger] = ACTIONS(2171),
    [anon_sym_return] = ACTIONS(2171),
    [anon_sym_throw] = ACTIONS(2171),
    [anon_sym_SEMI] = ACTIONS(2173),
    [anon_sym_yield] = ACTIONS(2171),
    [anon_sym_LBRACK] = ACTIONS(2173),
    [anon_sym_LT] = ACTIONS(2173),
    [anon_sym_SLASH] = ACTIONS(2171),
    [anon_sym_class] = ACTIONS(2171),
    [anon_sym_async] = ACTIONS(2171),
    [anon_sym_function] = ACTIONS(2171),
    [anon_sym_new] = ACTIONS(2171),
    [anon_sym_PLUS] = ACTIONS(2171),
    [anon_sym_DASH] = ACTIONS(2171),
    [anon_sym_TILDE] = ACTIONS(2173),
    [anon_sym_void] = ACTIONS(2171),
    [anon_sym_delete] = ACTIONS(2171),
    [anon_sym_PLUS_PLUS] = ACTIONS(2173),
    [anon_sym_DASH_DASH] = ACTIONS(2173),
    [anon_sym_DQUOTE] = ACTIONS(2173),
    [anon_sym_SQUOTE] = ACTIONS(2173),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2173),
    [sym_number] = ACTIONS(2173),
    [sym_this] = ACTIONS(2171),
    [sym_super] = ACTIONS(2171),
    [sym_true] = ACTIONS(2171),
    [sym_false] = ACTIONS(2171),
    [sym_null] = ACTIONS(2171),
    [sym_undefined] = ACTIONS(2171),
    [anon_sym_AT] = ACTIONS(2173),
    [anon_sym_static] = ACTIONS(2171),
    [anon_sym_abstract] = ACTIONS(2171),
    [anon_sym_get] = ACTIONS(2171),
    [anon_sym_set] = ACTIONS(2171),
    [anon_sym_declare] = ACTIONS(2171),
    [anon_sym_public] = ACTIONS(2171),
    [anon_sym_private] = ACTIONS(2171),
    [anon_sym_protected] = ACTIONS(2171),
    [anon_sym_module] = ACTIONS(2171),
    [anon_sym_any] = ACTIONS(2171),
    [anon_sym_number] = ACTIONS(2171),
    [anon_sym_boolean] = ACTIONS(2171),
    [anon_sym_string] = ACTIONS(2171),
    [anon_sym_symbol] = ACTIONS(2171),
    [anon_sym_interface] = ACTIONS(2171),
    [anon_sym_enum] = ACTIONS(2171),
    [sym_readonly] = ACTIONS(2171),
  },
  [634] = {
    [sym_identifier] = ACTIONS(2175),
    [anon_sym_export] = ACTIONS(2175),
    [anon_sym_namespace] = ACTIONS(2175),
    [anon_sym_LBRACE] = ACTIONS(2177),
    [anon_sym_type] = ACTIONS(2175),
    [anon_sym_typeof] = ACTIONS(2175),
    [anon_sym_import] = ACTIONS(2175),
    [anon_sym_var] = ACTIONS(2175),
    [anon_sym_let] = ACTIONS(2175),
    [anon_sym_const] = ACTIONS(2175),
    [anon_sym_BANG] = ACTIONS(2177),
    [anon_sym_if] = ACTIONS(2175),
    [anon_sym_switch] = ACTIONS(2175),
    [anon_sym_for] = ACTIONS(2175),
    [anon_sym_LPAREN] = ACTIONS(2177),
    [anon_sym_await] = ACTIONS(2175),
    [anon_sym_while] = ACTIONS(2175),
    [anon_sym_do] = ACTIONS(2175),
    [anon_sym_try] = ACTIONS(2175),
    [anon_sym_with] = ACTIONS(2175),
    [anon_sym_break] = ACTIONS(2175),
    [anon_sym_continue] = ACTIONS(2175),
    [anon_sym_debugger] = ACTIONS(2175),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_throw] = ACTIONS(2175),
    [anon_sym_SEMI] = ACTIONS(2177),
    [anon_sym_yield] = ACTIONS(2175),
    [anon_sym_LBRACK] = ACTIONS(2177),
    [anon_sym_LT] = ACTIONS(2177),
    [anon_sym_SLASH] = ACTIONS(2175),
    [anon_sym_class] = ACTIONS(2175),
    [anon_sym_async] = ACTIONS(2175),
    [anon_sym_function] = ACTIONS(2175),
    [anon_sym_new] = ACTIONS(2175),
    [anon_sym_PLUS] = ACTIONS(2175),
    [anon_sym_DASH] = ACTIONS(2175),
    [anon_sym_TILDE] = ACTIONS(2177),
    [anon_sym_void] = ACTIONS(2175),
    [anon_sym_delete] = ACTIONS(2175),
    [anon_sym_PLUS_PLUS] = ACTIONS(2177),
    [anon_sym_DASH_DASH] = ACTIONS(2177),
    [anon_sym_DQUOTE] = ACTIONS(2177),
    [anon_sym_SQUOTE] = ACTIONS(2177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2177),
    [sym_number] = ACTIONS(2177),
    [sym_this] = ACTIONS(2175),
    [sym_super] = ACTIONS(2175),
    [sym_true] = ACTIONS(2175),
    [sym_false] = ACTIONS(2175),
    [sym_null] = ACTIONS(2175),
    [sym_undefined] = ACTIONS(2175),
    [anon_sym_AT] = ACTIONS(2177),
    [anon_sym_static] = ACTIONS(2175),
    [anon_sym_abstract] = ACTIONS(2175),
    [anon_sym_get] = ACTIONS(2175),
    [anon_sym_set] = ACTIONS(2175),
    [anon_sym_declare] = ACTIONS(2175),
    [anon_sym_public] = ACTIONS(2175),
    [anon_sym_private] = ACTIONS(2175),
    [anon_sym_protected] = ACTIONS(2175),
    [anon_sym_module] = ACTIONS(2175),
    [anon_sym_any] = ACTIONS(2175),
    [anon_sym_number] = ACTIONS(2175),
    [anon_sym_boolean] = ACTIONS(2175),
    [anon_sym_string] = ACTIONS(2175),
    [anon_sym_symbol] = ACTIONS(2175),
    [anon_sym_interface] = ACTIONS(2175),
    [anon_sym_enum] = ACTIONS(2175),
    [sym_readonly] = ACTIONS(2175),
  },
  [635] = {
    [sym_identifier] = ACTIONS(2179),
    [anon_sym_export] = ACTIONS(2179),
    [anon_sym_namespace] = ACTIONS(2179),
    [anon_sym_LBRACE] = ACTIONS(2181),
    [anon_sym_type] = ACTIONS(2179),
    [anon_sym_typeof] = ACTIONS(2179),
    [anon_sym_import] = ACTIONS(2179),
    [anon_sym_var] = ACTIONS(2179),
    [anon_sym_let] = ACTIONS(2179),
    [anon_sym_const] = ACTIONS(2179),
    [anon_sym_BANG] = ACTIONS(2181),
    [anon_sym_if] = ACTIONS(2179),
    [anon_sym_switch] = ACTIONS(2179),
    [anon_sym_for] = ACTIONS(2179),
    [anon_sym_LPAREN] = ACTIONS(2181),
    [anon_sym_await] = ACTIONS(2179),
    [anon_sym_while] = ACTIONS(2179),
    [anon_sym_do] = ACTIONS(2179),
    [anon_sym_try] = ACTIONS(2179),
    [anon_sym_with] = ACTIONS(2179),
    [anon_sym_break] = ACTIONS(2179),
    [anon_sym_continue] = ACTIONS(2179),
    [anon_sym_debugger] = ACTIONS(2179),
    [anon_sym_return] = ACTIONS(2179),
    [anon_sym_throw] = ACTIONS(2179),
    [anon_sym_SEMI] = ACTIONS(2181),
    [anon_sym_yield] = ACTIONS(2179),
    [anon_sym_LBRACK] = ACTIONS(2181),
    [anon_sym_LT] = ACTIONS(2181),
    [anon_sym_SLASH] = ACTIONS(2179),
    [anon_sym_class] = ACTIONS(2179),
    [anon_sym_async] = ACTIONS(2179),
    [anon_sym_function] = ACTIONS(2179),
    [anon_sym_new] = ACTIONS(2179),
    [anon_sym_PLUS] = ACTIONS(2179),
    [anon_sym_DASH] = ACTIONS(2179),
    [anon_sym_TILDE] = ACTIONS(2181),
    [anon_sym_void] = ACTIONS(2179),
    [anon_sym_delete] = ACTIONS(2179),
    [anon_sym_PLUS_PLUS] = ACTIONS(2181),
    [anon_sym_DASH_DASH] = ACTIONS(2181),
    [anon_sym_DQUOTE] = ACTIONS(2181),
    [anon_sym_SQUOTE] = ACTIONS(2181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2181),
    [sym_number] = ACTIONS(2181),
    [sym_this] = ACTIONS(2179),
    [sym_super] = ACTIONS(2179),
    [sym_true] = ACTIONS(2179),
    [sym_false] = ACTIONS(2179),
    [sym_null] = ACTIONS(2179),
    [sym_undefined] = ACTIONS(2179),
    [anon_sym_AT] = ACTIONS(2181),
    [anon_sym_static] = ACTIONS(2179),
    [anon_sym_abstract] = ACTIONS(2179),
    [anon_sym_get] = ACTIONS(2179),
    [anon_sym_set] = ACTIONS(2179),
    [anon_sym_declare] = ACTIONS(2179),
    [anon_sym_public] = ACTIONS(2179),
    [anon_sym_private] = ACTIONS(2179),
    [anon_sym_protected] = ACTIONS(2179),
    [anon_sym_module] = ACTIONS(2179),
    [anon_sym_any] = ACTIONS(2179),
    [anon_sym_number] = ACTIONS(2179),
    [anon_sym_boolean] = ACTIONS(2179),
    [anon_sym_string] = ACTIONS(2179),
    [anon_sym_symbol] = ACTIONS(2179),
    [anon_sym_interface] = ACTIONS(2179),
    [anon_sym_enum] = ACTIONS(2179),
    [sym_readonly] = ACTIONS(2179),
  },
  [636] = {
    [sym_nested_identifier] = STATE(1092),
    [sym_string] = STATE(1091),
    [sym_arguments] = STATE(1174),
    [sym__module] = STATE(1221),
    [sym_type_arguments] = STATE(1073),
    [sym_identifier] = ACTIONS(2183),
    [anon_sym_STAR] = ACTIONS(1635),
    [anon_sym_EQ] = ACTIONS(961),
    [anon_sym_as] = ACTIONS(1635),
    [anon_sym_COMMA] = ACTIONS(1637),
    [anon_sym_RBRACE] = ACTIONS(1637),
    [anon_sym_BANG] = ACTIONS(1635),
    [anon_sym_LPAREN] = ACTIONS(2185),
    [anon_sym_RPAREN] = ACTIONS(1637),
    [anon_sym_in] = ACTIONS(1635),
    [anon_sym_COLON] = ACTIONS(1637),
    [anon_sym_LBRACK] = ACTIONS(1639),
    [anon_sym_RBRACK] = ACTIONS(1637),
    [anon_sym_LT] = ACTIONS(2187),
    [anon_sym_GT] = ACTIONS(1635),
    [anon_sym_SLASH] = ACTIONS(1635),
    [anon_sym_DOT] = ACTIONS(1641),
    [anon_sym_EQ_GT] = ACTIONS(797),
    [anon_sym_QMARK_DOT] = ACTIONS(799),
    [anon_sym_PLUS_EQ] = ACTIONS(803),
    [anon_sym_DASH_EQ] = ACTIONS(803),
    [anon_sym_STAR_EQ] = ACTIONS(803),
    [anon_sym_SLASH_EQ] = ACTIONS(803),
    [anon_sym_PERCENT_EQ] = ACTIONS(803),
    [anon_sym_CARET_EQ] = ACTIONS(803),
    [anon_sym_AMP_EQ] = ACTIONS(803),
    [anon_sym_PIPE_EQ] = ACTIONS(803),
    [anon_sym_GT_GT_EQ] = ACTIONS(803),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(803),
    [anon_sym_LT_LT_EQ] = ACTIONS(803),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(803),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(803),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(803),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(803),
    [anon_sym_QMARK] = ACTIONS(1635),
    [anon_sym_AMP_AMP] = ACTIONS(1635),
    [anon_sym_PIPE_PIPE] = ACTIONS(1635),
    [anon_sym_GT_GT] = ACTIONS(1635),
    [anon_sym_GT_GT_GT] = ACTIONS(1635),
    [anon_sym_LT_LT] = ACTIONS(1635),
    [anon_sym_AMP] = ACTIONS(1635),
    [anon_sym_CARET] = ACTIONS(1635),
    [anon_sym_PIPE] = ACTIONS(1635),
    [anon_sym_PLUS] = ACTIONS(1635),
    [anon_sym_DASH] = ACTIONS(1635),
    [anon_sym_PERCENT] = ACTIONS(1635),
    [anon_sym_STAR_STAR] = ACTIONS(1635),
    [anon_sym_LT_EQ] = ACTIONS(1637),
    [anon_sym_EQ_EQ] = ACTIONS(1635),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1637),
    [anon_sym_BANG_EQ] = ACTIONS(1635),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1637),
    [anon_sym_GT_EQ] = ACTIONS(1637),
    [anon_sym_QMARK_QMARK] = ACTIONS(1635),
    [anon_sym_instanceof] = ACTIONS(1635),
    [anon_sym_PLUS_PLUS] = ACTIONS(1637),
    [anon_sym_DASH_DASH] = ACTIONS(1637),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1637),
  },
  [637] = {
    [sym_nested_identifier] = STATE(68),
    [sym_string] = STATE(70),
    [sym__module] = STATE(93),
    [aux_sym_object_repeat1] = STATE(2854),
    [sym_identifier] = ACTIONS(2189),
    [anon_sym_STAR] = ACTIONS(780),
    [anon_sym_EQ] = ACTIONS(1260),
    [anon_sym_as] = ACTIONS(780),
    [anon_sym_COMMA] = ACTIONS(813),
    [anon_sym_RBRACE] = ACTIONS(1248),
    [anon_sym_BANG] = ACTIONS(780),
    [anon_sym_LPAREN] = ACTIONS(1217),
    [anon_sym_in] = ACTIONS(780),
    [anon_sym_SEMI] = ACTIONS(813),
    [anon_sym_COLON] = ACTIONS(1220),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_LT] = ACTIONS(1225),
    [anon_sym_GT] = ACTIONS(780),
    [anon_sym_SLASH] = ACTIONS(780),
    [anon_sym_DOT] = ACTIONS(1228),
    [anon_sym_EQ_GT] = ACTIONS(929),
    [anon_sym_QMARK_DOT] = ACTIONS(931),
    [anon_sym_PLUS_EQ] = ACTIONS(803),
    [anon_sym_DASH_EQ] = ACTIONS(803),
    [anon_sym_STAR_EQ] = ACTIONS(803),
    [anon_sym_SLASH_EQ] = ACTIONS(803),
    [anon_sym_PERCENT_EQ] = ACTIONS(803),
    [anon_sym_CARET_EQ] = ACTIONS(803),
    [anon_sym_AMP_EQ] = ACTIONS(803),
    [anon_sym_PIPE_EQ] = ACTIONS(803),
    [anon_sym_GT_GT_EQ] = ACTIONS(803),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(803),
    [anon_sym_LT_LT_EQ] = ACTIONS(803),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(803),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(803),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(803),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(803),
    [anon_sym_QMARK] = ACTIONS(1225),
    [anon_sym_AMP_AMP] = ACTIONS(780),
    [anon_sym_PIPE_PIPE] = ACTIONS(780),
    [anon_sym_GT_GT] = ACTIONS(780),
    [anon_sym_GT_GT_GT] = ACTIONS(780),
    [anon_sym_LT_LT] = ACTIONS(780),
    [anon_sym_AMP] = ACTIONS(780),
    [anon_sym_CARET] = ACTIONS(780),
    [anon_sym_PIPE] = ACTIONS(780),
    [anon_sym_PLUS] = ACTIONS(780),
    [anon_sym_DASH] = ACTIONS(780),
    [anon_sym_PERCENT] = ACTIONS(780),
    [anon_sym_STAR_STAR] = ACTIONS(780),
    [anon_sym_LT_EQ] = ACTIONS(813),
    [anon_sym_EQ_EQ] = ACTIONS(780),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(813),
    [anon_sym_BANG_EQ] = ACTIONS(780),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(813),
    [anon_sym_GT_EQ] = ACTIONS(813),
    [anon_sym_QMARK_QMARK] = ACTIONS(780),
    [anon_sym_instanceof] = ACTIONS(780),
    [anon_sym_PLUS_PLUS] = ACTIONS(813),
    [anon_sym_DASH_DASH] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(2191),
    [anon_sym_SQUOTE] = ACTIONS(2193),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(813),
    [sym__automatic_semicolon] = ACTIONS(813),
  },
  [638] = {
    [sym_nested_identifier] = STATE(518),
    [sym_string] = STATE(523),
    [sym__module] = STATE(564),
    [aux_sym_object_repeat1] = STATE(2894),
    [sym_identifier] = ACTIONS(2195),
    [anon_sym_STAR] = ACTIONS(780),
    [anon_sym_EQ] = ACTIONS(1260),
    [anon_sym_as] = ACTIONS(780),
    [anon_sym_COMMA] = ACTIONS(813),
    [anon_sym_RBRACE] = ACTIONS(1205),
    [anon_sym_BANG] = ACTIONS(780),
    [anon_sym_LPAREN] = ACTIONS(1217),
    [anon_sym_in] = ACTIONS(780),
    [anon_sym_SEMI] = ACTIONS(813),
    [anon_sym_COLON] = ACTIONS(1220),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_LT] = ACTIONS(1225),
    [anon_sym_GT] = ACTIONS(780),
    [anon_sym_SLASH] = ACTIONS(780),
    [anon_sym_DOT] = ACTIONS(1228),
    [anon_sym_EQ_GT] = ACTIONS(929),
    [anon_sym_QMARK_DOT] = ACTIONS(931),
    [anon_sym_PLUS_EQ] = ACTIONS(803),
    [anon_sym_DASH_EQ] = ACTIONS(803),
    [anon_sym_STAR_EQ] = ACTIONS(803),
    [anon_sym_SLASH_EQ] = ACTIONS(803),
    [anon_sym_PERCENT_EQ] = ACTIONS(803),
    [anon_sym_CARET_EQ] = ACTIONS(803),
    [anon_sym_AMP_EQ] = ACTIONS(803),
    [anon_sym_PIPE_EQ] = ACTIONS(803),
    [anon_sym_GT_GT_EQ] = ACTIONS(803),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(803),
    [anon_sym_LT_LT_EQ] = ACTIONS(803),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(803),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(803),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(803),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(803),
    [anon_sym_QMARK] = ACTIONS(1225),
    [anon_sym_AMP_AMP] = ACTIONS(780),
    [anon_sym_PIPE_PIPE] = ACTIONS(780),
    [anon_sym_GT_GT] = ACTIONS(780),
    [anon_sym_GT_GT_GT] = ACTIONS(780),
    [anon_sym_LT_LT] = ACTIONS(780),
    [anon_sym_AMP] = ACTIONS(780),
    [anon_sym_CARET] = ACTIONS(780),
    [anon_sym_PIPE] = ACTIONS(780),
    [anon_sym_PLUS] = ACTIONS(780),
    [anon_sym_DASH] = ACTIONS(780),
    [anon_sym_PERCENT] = ACTIONS(780),
    [anon_sym_STAR_STAR] = ACTIONS(780),
    [anon_sym_LT_EQ] = ACTIONS(813),
    [anon_sym_EQ_EQ] = ACTIONS(780),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(813),
    [anon_sym_BANG_EQ] = ACTIONS(780),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(813),
    [anon_sym_GT_EQ] = ACTIONS(813),
    [anon_sym_QMARK_QMARK] = ACTIONS(780),
    [anon_sym_instanceof] = ACTIONS(780),
    [anon_sym_PLUS_PLUS] = ACTIONS(813),
    [anon_sym_DASH_DASH] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(817),
    [anon_sym_SQUOTE] = ACTIONS(819),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(813),
    [sym__automatic_semicolon] = ACTIONS(813),
  },
  [639] = {
    [sym_nested_identifier] = STATE(518),
    [sym_string] = STATE(523),
    [sym__module] = STATE(564),
    [aux_sym_object_repeat1] = STATE(2868),
    [sym_identifier] = ACTIONS(2195),
    [anon_sym_STAR] = ACTIONS(780),
    [anon_sym_EQ] = ACTIONS(1260),
    [anon_sym_as] = ACTIONS(780),
    [anon_sym_COMMA] = ACTIONS(813),
    [anon_sym_RBRACE] = ACTIONS(1246),
    [anon_sym_BANG] = ACTIONS(780),
    [anon_sym_LPAREN] = ACTIONS(1217),
    [anon_sym_in] = ACTIONS(780),
    [anon_sym_SEMI] = ACTIONS(813),
    [anon_sym_COLON] = ACTIONS(1220),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_LT] = ACTIONS(1225),
    [anon_sym_GT] = ACTIONS(780),
    [anon_sym_SLASH] = ACTIONS(780),
    [anon_sym_DOT] = ACTIONS(1228),
    [anon_sym_EQ_GT] = ACTIONS(929),
    [anon_sym_QMARK_DOT] = ACTIONS(931),
    [anon_sym_PLUS_EQ] = ACTIONS(803),
    [anon_sym_DASH_EQ] = ACTIONS(803),
    [anon_sym_STAR_EQ] = ACTIONS(803),
    [anon_sym_SLASH_EQ] = ACTIONS(803),
    [anon_sym_PERCENT_EQ] = ACTIONS(803),
    [anon_sym_CARET_EQ] = ACTIONS(803),
    [anon_sym_AMP_EQ] = ACTIONS(803),
    [anon_sym_PIPE_EQ] = ACTIONS(803),
    [anon_sym_GT_GT_EQ] = ACTIONS(803),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(803),
    [anon_sym_LT_LT_EQ] = ACTIONS(803),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(803),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(803),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(803),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(803),
    [anon_sym_QMARK] = ACTIONS(1225),
    [anon_sym_AMP_AMP] = ACTIONS(780),
    [anon_sym_PIPE_PIPE] = ACTIONS(780),
    [anon_sym_GT_GT] = ACTIONS(780),
    [anon_sym_GT_GT_GT] = ACTIONS(780),
    [anon_sym_LT_LT] = ACTIONS(780),
    [anon_sym_AMP] = ACTIONS(780),
    [anon_sym_CARET] = ACTIONS(780),
    [anon_sym_PIPE] = ACTIONS(780),
    [anon_sym_PLUS] = ACTIONS(780),
    [anon_sym_DASH] = ACTIONS(780),
    [anon_sym_PERCENT] = ACTIONS(780),
    [anon_sym_STAR_STAR] = ACTIONS(780),
    [anon_sym_LT_EQ] = ACTIONS(813),
    [anon_sym_EQ_EQ] = ACTIONS(780),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(813),
    [anon_sym_BANG_EQ] = ACTIONS(780),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(813),
    [anon_sym_GT_EQ] = ACTIONS(813),
    [anon_sym_QMARK_QMARK] = ACTIONS(780),
    [anon_sym_instanceof] = ACTIONS(780),
    [anon_sym_PLUS_PLUS] = ACTIONS(813),
    [anon_sym_DASH_DASH] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(817),
    [anon_sym_SQUOTE] = ACTIONS(819),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(813),
    [sym__automatic_semicolon] = ACTIONS(813),
  },
  [640] = {
    [sym_nested_identifier] = STATE(1092),
    [sym_string] = STATE(1091),
    [sym_arguments] = STATE(1581),
    [sym__module] = STATE(1221),
    [sym_type_arguments] = STATE(1378),
    [sym_identifier] = ACTIONS(2183),
    [anon_sym_STAR] = ACTIONS(1635),
    [anon_sym_EQ] = ACTIONS(961),
    [anon_sym_as] = ACTIONS(1635),
    [anon_sym_COMMA] = ACTIONS(1637),
    [anon_sym_RBRACE] = ACTIONS(1637),
    [anon_sym_BANG] = ACTIONS(1635),
    [anon_sym_LPAREN] = ACTIONS(2197),
    [anon_sym_in] = ACTIONS(1635),
    [anon_sym_SEMI] = ACTIONS(1637),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_LT] = ACTIONS(2199),
    [anon_sym_GT] = ACTIONS(1635),
    [anon_sym_SLASH] = ACTIONS(1635),
    [anon_sym_DOT] = ACTIONS(1228),
    [anon_sym_EQ_GT] = ACTIONS(929),
    [anon_sym_QMARK_DOT] = ACTIONS(931),
    [anon_sym_PLUS_EQ] = ACTIONS(803),
    [anon_sym_DASH_EQ] = ACTIONS(803),
    [anon_sym_STAR_EQ] = ACTIONS(803),
    [anon_sym_SLASH_EQ] = ACTIONS(803),
    [anon_sym_PERCENT_EQ] = ACTIONS(803),
    [anon_sym_CARET_EQ] = ACTIONS(803),
    [anon_sym_AMP_EQ] = ACTIONS(803),
    [anon_sym_PIPE_EQ] = ACTIONS(803),
    [anon_sym_GT_GT_EQ] = ACTIONS(803),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(803),
    [anon_sym_LT_LT_EQ] = ACTIONS(803),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(803),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(803),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(803),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(803),
    [anon_sym_QMARK] = ACTIONS(1635),
    [anon_sym_AMP_AMP] = ACTIONS(1635),
    [anon_sym_PIPE_PIPE] = ACTIONS(1635),
    [anon_sym_GT_GT] = ACTIONS(1635),
    [anon_sym_GT_GT_GT] = ACTIONS(1635),
    [anon_sym_LT_LT] = ACTIONS(1635),
    [anon_sym_AMP] = ACTIONS(1635),
    [anon_sym_CARET] = ACTIONS(1635),
    [anon_sym_PIPE] = ACTIONS(1635),
    [anon_sym_PLUS] = ACTIONS(1635),
    [anon_sym_DASH] = ACTIONS(1635),
    [anon_sym_PERCENT] = ACTIONS(1635),
    [anon_sym_STAR_STAR] = ACTIONS(1635),
    [anon_sym_LT_EQ] = ACTIONS(1637),
    [anon_sym_EQ_EQ] = ACTIONS(1635),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1637),
    [anon_sym_BANG_EQ] = ACTIONS(1635),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1637),
    [anon_sym_GT_EQ] = ACTIONS(1637),
    [anon_sym_QMARK_QMARK] = ACTIONS(1635),
    [anon_sym_instanceof] = ACTIONS(1635),
    [anon_sym_PLUS_PLUS] = ACTIONS(1637),
    [anon_sym_DASH_DASH] = ACTIONS(1637),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1637),
    [sym__automatic_semicolon] = ACTIONS(1637),
  },
  [641] = {
    [sym_nested_identifier] = STATE(518),
    [sym_string] = STATE(523),
    [sym__module] = STATE(564),
    [aux_sym_object_repeat1] = STATE(2854),
    [sym_identifier] = ACTIONS(2195),
    [anon_sym_STAR] = ACTIONS(780),
    [anon_sym_EQ] = ACTIONS(1260),
    [anon_sym_as] = ACTIONS(780),
    [anon_sym_COMMA] = ACTIONS(813),
    [anon_sym_RBRACE] = ACTIONS(1248),
    [anon_sym_BANG] = ACTIONS(780),
    [anon_sym_LPAREN] = ACTIONS(1217),
    [anon_sym_in] = ACTIONS(780),
    [anon_sym_SEMI] = ACTIONS(813),
    [anon_sym_COLON] = ACTIONS(1220),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_LT] = ACTIONS(1225),
    [anon_sym_GT] = ACTIONS(780),
    [anon_sym_SLASH] = ACTIONS(780),
    [anon_sym_DOT] = ACTIONS(1228),
    [anon_sym_EQ_GT] = ACTIONS(929),
    [anon_sym_QMARK_DOT] = ACTIONS(931),
    [anon_sym_PLUS_EQ] = ACTIONS(803),
    [anon_sym_DASH_EQ] = ACTIONS(803),
    [anon_sym_STAR_EQ] = ACTIONS(803),
    [anon_sym_SLASH_EQ] = ACTIONS(803),
    [anon_sym_PERCENT_EQ] = ACTIONS(803),
    [anon_sym_CARET_EQ] = ACTIONS(803),
    [anon_sym_AMP_EQ] = ACTIONS(803),
    [anon_sym_PIPE_EQ] = ACTIONS(803),
    [anon_sym_GT_GT_EQ] = ACTIONS(803),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(803),
    [anon_sym_LT_LT_EQ] = ACTIONS(803),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(803),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(803),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(803),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(803),
    [anon_sym_QMARK] = ACTIONS(1225),
    [anon_sym_AMP_AMP] = ACTIONS(780),
    [anon_sym_PIPE_PIPE] = ACTIONS(780),
    [anon_sym_GT_GT] = ACTIONS(780),
    [anon_sym_GT_GT_GT] = ACTIONS(780),
    [anon_sym_LT_LT] = ACTIONS(780),
    [anon_sym_AMP] = ACTIONS(780),
    [anon_sym_CARET] = ACTIONS(780),
    [anon_sym_PIPE] = ACTIONS(780),
    [anon_sym_PLUS] = ACTIONS(780),
    [anon_sym_DASH] = ACTIONS(780),
    [anon_sym_PERCENT] = ACTIONS(780),
    [anon_sym_STAR_STAR] = ACTIONS(780),
    [anon_sym_LT_EQ] = ACTIONS(813),
    [anon_sym_EQ_EQ] = ACTIONS(780),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(813),
    [anon_sym_BANG_EQ] = ACTIONS(780),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(813),
    [anon_sym_GT_EQ] = ACTIONS(813),
    [anon_sym_QMARK_QMARK] = ACTIONS(780),
    [anon_sym_instanceof] = ACTIONS(780),
    [anon_sym_PLUS_PLUS] = ACTIONS(813),
    [anon_sym_DASH_DASH] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(817),
    [anon_sym_SQUOTE] = ACTIONS(819),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(813),
    [sym__automatic_semicolon] = ACTIONS(813),
  },
  [642] = {
    [sym_nested_identifier] = STATE(68),
    [sym_string] = STATE(70),
    [sym__module] = STATE(93),
    [aux_sym_object_repeat1] = STATE(2894),
    [sym_identifier] = ACTIONS(2189),
    [anon_sym_STAR] = ACTIONS(780),
    [anon_sym_EQ] = ACTIONS(1260),
    [anon_sym_as] = ACTIONS(780),
    [anon_sym_COMMA] = ACTIONS(813),
    [anon_sym_RBRACE] = ACTIONS(1205),
    [anon_sym_BANG] = ACTIONS(780),
    [anon_sym_LPAREN] = ACTIONS(1217),
    [anon_sym_in] = ACTIONS(780),
    [anon_sym_SEMI] = ACTIONS(813),
    [anon_sym_COLON] = ACTIONS(1220),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_LT] = ACTIONS(1225),
    [anon_sym_GT] = ACTIONS(780),
    [anon_sym_SLASH] = ACTIONS(780),
    [anon_sym_DOT] = ACTIONS(1228),
    [anon_sym_EQ_GT] = ACTIONS(929),
    [anon_sym_QMARK_DOT] = ACTIONS(931),
    [anon_sym_PLUS_EQ] = ACTIONS(803),
    [anon_sym_DASH_EQ] = ACTIONS(803),
    [anon_sym_STAR_EQ] = ACTIONS(803),
    [anon_sym_SLASH_EQ] = ACTIONS(803),
    [anon_sym_PERCENT_EQ] = ACTIONS(803),
    [anon_sym_CARET_EQ] = ACTIONS(803),
    [anon_sym_AMP_EQ] = ACTIONS(803),
    [anon_sym_PIPE_EQ] = ACTIONS(803),
    [anon_sym_GT_GT_EQ] = ACTIONS(803),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(803),
    [anon_sym_LT_LT_EQ] = ACTIONS(803),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(803),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(803),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(803),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(803),
    [anon_sym_QMARK] = ACTIONS(1225),
    [anon_sym_AMP_AMP] = ACTIONS(780),
    [anon_sym_PIPE_PIPE] = ACTIONS(780),
    [anon_sym_GT_GT] = ACTIONS(780),
    [anon_sym_GT_GT_GT] = ACTIONS(780),
    [anon_sym_LT_LT] = ACTIONS(780),
    [anon_sym_AMP] = ACTIONS(780),
    [anon_sym_CARET] = ACTIONS(780),
    [anon_sym_PIPE] = ACTIONS(780),
    [anon_sym_PLUS] = ACTIONS(780),
    [anon_sym_DASH] = ACTIONS(780),
    [anon_sym_PERCENT] = ACTIONS(780),
    [anon_sym_STAR_STAR] = ACTIONS(780),
    [anon_sym_LT_EQ] = ACTIONS(813),
    [anon_sym_EQ_EQ] = ACTIONS(780),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(813),
    [anon_sym_BANG_EQ] = ACTIONS(780),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(813),
    [anon_sym_GT_EQ] = ACTIONS(813),
    [anon_sym_QMARK_QMARK] = ACTIONS(780),
    [anon_sym_instanceof] = ACTIONS(780),
    [anon_sym_PLUS_PLUS] = ACTIONS(813),
    [anon_sym_DASH_DASH] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(2191),
    [anon_sym_SQUOTE] = ACTIONS(2193),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(813),
    [sym__automatic_semicolon] = ACTIONS(813),
  },
  [643] = {
    [sym_nested_identifier] = STATE(68),
    [sym_string] = STATE(70),
    [sym__module] = STATE(93),
    [aux_sym_object_repeat1] = STATE(2868),
    [sym_identifier] = ACTIONS(2189),
    [anon_sym_STAR] = ACTIONS(780),
    [anon_sym_EQ] = ACTIONS(1260),
    [anon_sym_as] = ACTIONS(780),
    [anon_sym_COMMA] = ACTIONS(813),
    [anon_sym_RBRACE] = ACTIONS(1246),
    [anon_sym_BANG] = ACTIONS(780),
    [anon_sym_LPAREN] = ACTIONS(1217),
    [anon_sym_in] = ACTIONS(780),
    [anon_sym_SEMI] = ACTIONS(813),
    [anon_sym_COLON] = ACTIONS(1220),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_LT] = ACTIONS(1225),
    [anon_sym_GT] = ACTIONS(780),
    [anon_sym_SLASH] = ACTIONS(780),
    [anon_sym_DOT] = ACTIONS(1228),
    [anon_sym_EQ_GT] = ACTIONS(929),
    [anon_sym_QMARK_DOT] = ACTIONS(931),
    [anon_sym_PLUS_EQ] = ACTIONS(803),
    [anon_sym_DASH_EQ] = ACTIONS(803),
    [anon_sym_STAR_EQ] = ACTIONS(803),
    [anon_sym_SLASH_EQ] = ACTIONS(803),
    [anon_sym_PERCENT_EQ] = ACTIONS(803),
    [anon_sym_CARET_EQ] = ACTIONS(803),
    [anon_sym_AMP_EQ] = ACTIONS(803),
    [anon_sym_PIPE_EQ] = ACTIONS(803),
    [anon_sym_GT_GT_EQ] = ACTIONS(803),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(803),
    [anon_sym_LT_LT_EQ] = ACTIONS(803),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(803),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(803),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(803),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(803),
    [anon_sym_QMARK] = ACTIONS(1225),
    [anon_sym_AMP_AMP] = ACTIONS(780),
    [anon_sym_PIPE_PIPE] = ACTIONS(780),
    [anon_sym_GT_GT] = ACTIONS(780),
    [anon_sym_GT_GT_GT] = ACTIONS(780),
    [anon_sym_LT_LT] = ACTIONS(780),
    [anon_sym_AMP] = ACTIONS(780),
    [anon_sym_CARET] = ACTIONS(780),
    [anon_sym_PIPE] = ACTIONS(780),
    [anon_sym_PLUS] = ACTIONS(780),
    [anon_sym_DASH] = ACTIONS(780),
    [anon_sym_PERCENT] = ACTIONS(780),
    [anon_sym_STAR_STAR] = ACTIONS(780),
    [anon_sym_LT_EQ] = ACTIONS(813),
    [anon_sym_EQ_EQ] = ACTIONS(780),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(813),
    [anon_sym_BANG_EQ] = ACTIONS(780),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(813),
    [anon_sym_GT_EQ] = ACTIONS(813),
    [anon_sym_QMARK_QMARK] = ACTIONS(780),
    [anon_sym_instanceof] = ACTIONS(780),
    [anon_sym_PLUS_PLUS] = ACTIONS(813),
    [anon_sym_DASH_DASH] = ACTIONS(813),
    [anon_sym_DQUOTE] = ACTIONS(2191),
    [anon_sym_SQUOTE] = ACTIONS(2193),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(813),
    [sym__automatic_semicolon] = ACTIONS(813),
  },
};

static uint16_t ts_small_parse_table[] = {
  [0] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(475), 1,
      anon_sym_DQUOTE,
    ACTIONS(477), 1,
      anon_sym_SQUOTE,
    ACTIONS(797), 1,
      anon_sym_EQ_GT,
    ACTIONS(799), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(913), 1,
      anon_sym_EQ,
    ACTIONS(1639), 1,
      anon_sym_LBRACK,
    ACTIONS(1641), 1,
      anon_sym_DOT,
    ACTIONS(2183), 1,
      sym_identifier,
    STATE(1091), 1,
      sym_string,
    STATE(1092), 1,
      sym_nested_identifier,
    STATE(1221), 1,
      sym__module,
    ACTIONS(813), 13,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(803), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(780), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [95] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(475), 1,
      anon_sym_DQUOTE,
    ACTIONS(477), 1,
      anon_sym_SQUOTE,
    ACTIONS(799), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(961), 1,
      anon_sym_EQ,
    ACTIONS(1085), 1,
      anon_sym_EQ_GT,
    ACTIONS(1639), 1,
      anon_sym_LBRACK,
    ACTIONS(1641), 1,
      anon_sym_DOT,
    ACTIONS(2183), 1,
      sym_identifier,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2187), 1,
      anon_sym_LT,
    STATE(1073), 1,
      sym_type_arguments,
    STATE(1091), 1,
      sym_string,
    STATE(1092), 1,
      sym_nested_identifier,
    STATE(1174), 1,
      sym_arguments,
    STATE(1221), 1,
      sym__module,
    ACTIONS(1637), 9,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(803), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1635), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_implements,
  [198] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(475), 1,
      anon_sym_DQUOTE,
    ACTIONS(477), 1,
      anon_sym_SQUOTE,
    ACTIONS(961), 1,
      anon_sym_EQ,
    ACTIONS(1141), 1,
      anon_sym_EQ_GT,
    ACTIONS(1143), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1689), 1,
      anon_sym_LBRACK,
    ACTIONS(1691), 1,
      anon_sym_DOT,
    ACTIONS(2183), 1,
      sym_identifier,
    ACTIONS(2201), 1,
      anon_sym_LPAREN,
    ACTIONS(2203), 1,
      anon_sym_LT,
    STATE(1091), 1,
      sym_string,
    STATE(1092), 1,
      sym_nested_identifier,
    STATE(1221), 1,
      sym__module,
    STATE(1644), 1,
      sym_type_arguments,
    STATE(1689), 1,
      sym_arguments,
    ACTIONS(1637), 9,
      anon_sym_COMMA,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
    ACTIONS(803), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1635), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [301] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(923), 1,
      anon_sym_EQ,
    ACTIONS(929), 1,
      anon_sym_EQ_GT,
    ACTIONS(931), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1223), 1,
      anon_sym_LBRACK,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1288), 1,
      anon_sym_COLON,
    ACTIONS(2195), 1,
      sym_identifier,
    STATE(518), 1,
      sym_nested_identifier,
    STATE(523), 1,
      sym_string,
    STATE(564), 1,
      sym__module,
    ACTIONS(813), 11,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(803), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(780), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [397] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(923), 1,
      anon_sym_EQ,
    ACTIONS(929), 1,
      anon_sym_EQ_GT,
    ACTIONS(931), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1223), 1,
      anon_sym_LBRACK,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1288), 1,
      anon_sym_COLON,
    ACTIONS(2189), 1,
      sym_identifier,
    ACTIONS(2191), 1,
      anon_sym_DQUOTE,
    ACTIONS(2193), 1,
      anon_sym_SQUOTE,
    STATE(68), 1,
      sym_nested_identifier,
    STATE(70), 1,
      sym_string,
    STATE(93), 1,
      sym__module,
    ACTIONS(813), 11,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(803), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(780), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [493] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(475), 1,
      anon_sym_DQUOTE,
    ACTIONS(477), 1,
      anon_sym_SQUOTE,
    ACTIONS(931), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(961), 1,
      anon_sym_EQ,
    ACTIONS(1069), 1,
      anon_sym_EQ_GT,
    ACTIONS(1223), 1,
      anon_sym_LBRACK,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(2183), 1,
      sym_identifier,
    ACTIONS(2197), 1,
      anon_sym_LPAREN,
    ACTIONS(2199), 1,
      anon_sym_LT,
    STATE(1091), 1,
      sym_string,
    STATE(1092), 1,
      sym_nested_identifier,
    STATE(1221), 1,
      sym__module,
    STATE(1378), 1,
      sym_type_arguments,
    STATE(1581), 1,
      sym_arguments,
    ACTIONS(1637), 9,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(803), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1635), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [595] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(923), 1,
      anon_sym_EQ,
    ACTIONS(929), 1,
      anon_sym_EQ_GT,
    ACTIONS(931), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1223), 1,
      anon_sym_LBRACK,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1290), 1,
      anon_sym_COLON,
    ACTIONS(2195), 1,
      sym_identifier,
    STATE(518), 1,
      sym_nested_identifier,
    STATE(523), 1,
      sym_string,
    STATE(564), 1,
      sym__module,
    ACTIONS(813), 11,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(803), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(780), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [691] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(81), 1,
      anon_sym_DQUOTE,
    ACTIONS(83), 1,
      anon_sym_SQUOTE,
    ACTIONS(923), 1,
      anon_sym_EQ,
    ACTIONS(929), 1,
      anon_sym_EQ_GT,
    ACTIONS(931), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1223), 1,
      anon_sym_LBRACK,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(2205), 1,
      sym_identifier,
    STATE(1076), 1,
      sym_nested_identifier,
    STATE(1081), 1,
      sym_string,
    STATE(1289), 1,
      sym__module,
    ACTIONS(813), 12,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(803), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(780), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [785] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(475), 1,
      anon_sym_DQUOTE,
    ACTIONS(477), 1,
      anon_sym_SQUOTE,
    ACTIONS(799), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(961), 1,
      anon_sym_EQ,
    ACTIONS(963), 1,
      anon_sym_EQ_GT,
    ACTIONS(1639), 1,
      anon_sym_LBRACK,
    ACTIONS(1641), 1,
      anon_sym_DOT,
    ACTIONS(2183), 1,
      sym_identifier,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2187), 1,
      anon_sym_LT,
    STATE(1073), 1,
      sym_type_arguments,
    STATE(1091), 1,
      sym_string,
    STATE(1092), 1,
      sym_nested_identifier,
    STATE(1174), 1,
      sym_arguments,
    STATE(1221), 1,
      sym__module,
    ACTIONS(1637), 9,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(803), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1635), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [887] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(81), 1,
      anon_sym_DQUOTE,
    ACTIONS(83), 1,
      anon_sym_SQUOTE,
    ACTIONS(923), 1,
      anon_sym_EQ,
    ACTIONS(929), 1,
      anon_sym_EQ_GT,
    ACTIONS(931), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1223), 1,
      anon_sym_LBRACK,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1695), 1,
      anon_sym_in,
    ACTIONS(1698), 1,
      anon_sym_of,
    ACTIONS(2205), 1,
      sym_identifier,
    STATE(1076), 1,
      sym_nested_identifier,
    STATE(1081), 1,
      sym_string,
    STATE(1289), 1,
      sym__module,
    ACTIONS(813), 11,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(803), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(780), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [985] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(81), 1,
      anon_sym_DQUOTE,
    ACTIONS(83), 1,
      anon_sym_SQUOTE,
    ACTIONS(923), 1,
      anon_sym_EQ,
    ACTIONS(929), 1,
      anon_sym_EQ_GT,
    ACTIONS(931), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1223), 1,
      anon_sym_LBRACK,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1290), 1,
      anon_sym_COLON,
    ACTIONS(2205), 1,
      sym_identifier,
    STATE(1076), 1,
      sym_nested_identifier,
    STATE(1081), 1,
      sym_string,
    STATE(1289), 1,
      sym__module,
    ACTIONS(813), 11,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(803), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(780), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [1081] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(693), 1,
      anon_sym_DQUOTE,
    ACTIONS(695), 1,
      anon_sym_SQUOTE,
    ACTIONS(1135), 1,
      anon_sym_EQ,
    ACTIONS(1141), 1,
      anon_sym_EQ_GT,
    ACTIONS(1143), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1689), 1,
      anon_sym_LBRACK,
    ACTIONS(1691), 1,
      anon_sym_DOT,
    ACTIONS(2207), 1,
      sym_identifier,
    STATE(1521), 1,
      sym_nested_identifier,
    STATE(1545), 1,
      sym_string,
    STATE(1747), 1,
      sym__module,
    ACTIONS(813), 10,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
    ACTIONS(803), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(780), 25,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [1174] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(475), 1,
      anon_sym_DQUOTE,
    ACTIONS(477), 1,
      anon_sym_SQUOTE,
    ACTIONS(777), 1,
      anon_sym_EQ,
    ACTIONS(797), 1,
      anon_sym_EQ_GT,
    ACTIONS(799), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1639), 1,
      anon_sym_LBRACK,
    ACTIONS(1641), 1,
      anon_sym_DOT,
    ACTIONS(1733), 1,
      anon_sym_QMARK,
    ACTIONS(2183), 1,
      sym_identifier,
    STATE(1091), 1,
      sym_string,
    STATE(1092), 1,
      sym_nested_identifier,
    STATE(1221), 1,
      sym__module,
    ACTIONS(784), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(813), 8,
      anon_sym_LPAREN,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(803), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(780), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [1271] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(475), 1,
      anon_sym_DQUOTE,
    ACTIONS(477), 1,
      anon_sym_SQUOTE,
    ACTIONS(797), 1,
      anon_sym_EQ_GT,
    ACTIONS(799), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(913), 1,
      anon_sym_EQ,
    ACTIONS(1639), 1,
      anon_sym_LBRACK,
    ACTIONS(1641), 1,
      anon_sym_DOT,
    ACTIONS(1748), 1,
      anon_sym_COLON,
    ACTIONS(2183), 1,
      sym_identifier,
    STATE(1091), 1,
      sym_string,
    STATE(1092), 1,
      sym_nested_identifier,
    STATE(1221), 1,
      sym__module,
    ACTIONS(813), 10,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(803), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(780), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [1366] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(475), 1,
      anon_sym_DQUOTE,
    ACTIONS(477), 1,
      anon_sym_SQUOTE,
    ACTIONS(777), 1,
      anon_sym_EQ,
    ACTIONS(797), 1,
      anon_sym_EQ_GT,
    ACTIONS(799), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1639), 1,
      anon_sym_LBRACK,
    ACTIONS(1641), 1,
      anon_sym_DOT,
    ACTIONS(1733), 1,
      anon_sym_QMARK,
    ACTIONS(1736), 1,
      anon_sym_COLON,
    ACTIONS(2183), 1,
      sym_identifier,
    STATE(1091), 1,
      sym_string,
    STATE(1092), 1,
      sym_nested_identifier,
    STATE(1221), 1,
      sym__module,
    ACTIONS(784), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(813), 8,
      anon_sym_LPAREN,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(803), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(780), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [1465] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(475), 1,
      anon_sym_DQUOTE,
    ACTIONS(477), 1,
      anon_sym_SQUOTE,
    ACTIONS(799), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1083), 1,
      anon_sym_EQ,
    ACTIONS(1085), 1,
      anon_sym_EQ_GT,
    ACTIONS(1639), 1,
      anon_sym_LBRACK,
    ACTIONS(1641), 1,
      anon_sym_DOT,
    ACTIONS(2183), 1,
      sym_identifier,
    STATE(1091), 1,
      sym_string,
    STATE(1092), 1,
      sym_nested_identifier,
    STATE(1221), 1,
      sym__module,
    ACTIONS(813), 10,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(803), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(780), 25,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_implements,
  [1558] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(475), 1,
      anon_sym_DQUOTE,
    ACTIONS(477), 1,
      anon_sym_SQUOTE,
    ACTIONS(799), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(961), 1,
      anon_sym_EQ,
    ACTIONS(963), 1,
      anon_sym_EQ_GT,
    ACTIONS(1639), 1,
      anon_sym_LBRACK,
    ACTIONS(1641), 1,
      anon_sym_DOT,
    ACTIONS(1748), 1,
      anon_sym_COLON,
    ACTIONS(2183), 1,
      sym_identifier,
    STATE(1091), 1,
      sym_string,
    STATE(1092), 1,
      sym_nested_identifier,
    STATE(1221), 1,
      sym__module,
    ACTIONS(813), 9,
      anon_sym_LPAREN,
      anon_sym_RBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(803), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(780), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [1652] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2187), 1,
      anon_sym_LT,
    ACTIONS(2211), 1,
      anon_sym_EQ,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2219), 1,
      anon_sym_QMARK_DOT,
    STATE(1069), 1,
      sym_type_arguments,
    STATE(1160), 1,
      sym_arguments,
    ACTIONS(2221), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2213), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
    ACTIONS(2209), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [1738] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(475), 1,
      anon_sym_DQUOTE,
    ACTIONS(477), 1,
      anon_sym_SQUOTE,
    ACTIONS(799), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(961), 1,
      anon_sym_EQ,
    ACTIONS(963), 1,
      anon_sym_EQ_GT,
    ACTIONS(1639), 1,
      anon_sym_LBRACK,
    ACTIONS(1641), 1,
      anon_sym_DOT,
    ACTIONS(2183), 1,
      sym_identifier,
    STATE(1091), 1,
      sym_string,
    STATE(1092), 1,
      sym_nested_identifier,
    STATE(1221), 1,
      sym__module,
    ACTIONS(813), 10,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(803), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(780), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [1830] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(475), 1,
      anon_sym_DQUOTE,
    ACTIONS(477), 1,
      anon_sym_SQUOTE,
    ACTIONS(799), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(961), 1,
      anon_sym_EQ,
    ACTIONS(963), 1,
      anon_sym_EQ_GT,
    ACTIONS(1639), 1,
      anon_sym_LBRACK,
    ACTIONS(1641), 1,
      anon_sym_DOT,
    ACTIONS(1762), 1,
      anon_sym_COLON,
    ACTIONS(2183), 1,
      sym_identifier,
    STATE(1091), 1,
      sym_string,
    STATE(1092), 1,
      sym_nested_identifier,
    STATE(1221), 1,
      sym__module,
    ACTIONS(813), 9,
      anon_sym_LPAREN,
      anon_sym_RBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(803), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(780), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [1924] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(81), 1,
      anon_sym_DQUOTE,
    ACTIONS(83), 1,
      anon_sym_SQUOTE,
    ACTIONS(931), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1067), 1,
      anon_sym_EQ,
    ACTIONS(1069), 1,
      anon_sym_EQ_GT,
    ACTIONS(1223), 1,
      anon_sym_LBRACK,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(2205), 1,
      sym_identifier,
    STATE(1076), 1,
      sym_nested_identifier,
    STATE(1081), 1,
      sym_string,
    STATE(1289), 1,
      sym__module,
    ACTIONS(813), 10,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(803), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(780), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [2016] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_STAR,
    ACTIONS(461), 1,
      anon_sym_QMARK,
    ACTIONS(463), 1,
      anon_sym_AMP,
    ACTIONS(465), 1,
      anon_sym_PIPE,
    ACTIONS(495), 1,
      anon_sym_infer,
    ACTIONS(497), 1,
      anon_sym_keyof,
    ACTIONS(499), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(787), 1,
      anon_sym_typeof,
    ACTIONS(789), 1,
      anon_sym_LPAREN,
    ACTIONS(801), 1,
      anon_sym_new,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(821), 1,
      sym_number,
    ACTIONS(911), 1,
      sym_identifier,
    ACTIONS(915), 1,
      anon_sym_LBRACE,
    ACTIONS(919), 1,
      sym_this,
    ACTIONS(921), 1,
      sym_readonly,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2225), 1,
      anon_sym_LBRACK,
    STATE(443), 1,
      sym__tuple_type_body,
    STATE(1957), 1,
      sym_nested_type_identifier,
    STATE(3048), 1,
      sym_type_parameters,
    STATE(3296), 1,
      sym_formal_parameters,
    STATE(3297), 1,
      sym_nested_identifier,
    ACTIONS(825), 2,
      sym_true,
      sym_false,
    ACTIONS(1655), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(447), 2,
      sym_string,
      sym__number,
    ACTIONS(2223), 4,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(815), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2794), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2659), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [2142] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2227), 23,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2229), 36,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [2209] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(475), 1,
      anon_sym_DQUOTE,
    ACTIONS(477), 1,
      anon_sym_SQUOTE,
    ACTIONS(799), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(961), 1,
      anon_sym_EQ,
    ACTIONS(963), 1,
      anon_sym_EQ_GT,
    ACTIONS(1639), 1,
      anon_sym_LBRACK,
    ACTIONS(1641), 1,
      anon_sym_DOT,
    ACTIONS(1695), 1,
      anon_sym_in,
    ACTIONS(1698), 1,
      anon_sym_of,
    ACTIONS(2183), 1,
      sym_identifier,
    STATE(1091), 1,
      sym_string,
    STATE(1092), 1,
      sym_nested_identifier,
    STATE(1221), 1,
      sym__module,
    ACTIONS(813), 8,
      anon_sym_LPAREN,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(803), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(780), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [2304] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2219), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2231), 1,
      anon_sym_EQ,
    ACTIONS(2233), 1,
      anon_sym_LT,
    ACTIONS(2236), 1,
      anon_sym_DOT,
    ACTIONS(2238), 1,
      anon_sym_EQ_GT,
    STATE(2045), 1,
      sym_type_arguments,
    ACTIONS(1561), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1559), 6,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1113), 10,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2221), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1111), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [2391] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2159), 23,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2161), 36,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [2458] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2219), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2240), 1,
      anon_sym_EQ,
    ACTIONS(2244), 1,
      anon_sym_BANG,
    ACTIONS(2246), 1,
      anon_sym_in,
    ACTIONS(2249), 1,
      anon_sym_of,
    ACTIONS(2251), 1,
      anon_sym_COLON,
    ACTIONS(2253), 1,
      anon_sym_EQ_GT,
    STATE(2451), 1,
      sym_type_annotation,
    STATE(2754), 1,
      sym__initializer,
    ACTIONS(2242), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(1113), 10,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2221), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1111), 20,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [2551] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2219), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2231), 1,
      anon_sym_EQ,
    ACTIONS(2238), 1,
      anon_sym_EQ_GT,
    ACTIONS(2255), 1,
      anon_sym_LT,
    ACTIONS(2258), 1,
      anon_sym_DOT,
    STATE(284), 1,
      sym_type_arguments,
    ACTIONS(1559), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(1561), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1113), 14,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2221), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1111), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [2638] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(929), 1,
      anon_sym_EQ_GT,
    ACTIONS(931), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1205), 1,
      anon_sym_RBRACE,
    ACTIONS(1217), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_COLON,
    ACTIONS(1223), 1,
      anon_sym_LBRACK,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1260), 1,
      anon_sym_EQ,
    ACTIONS(2260), 1,
      sym_identifier,
    STATE(2894), 1,
      aux_sym_object_repeat1,
    ACTIONS(1225), 2,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(813), 10,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(803), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(780), 22,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [2729] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2262), 23,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2264), 36,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [2796] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2266), 23,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2268), 36,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [2863] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(929), 1,
      anon_sym_EQ_GT,
    ACTIONS(931), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1217), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_COLON,
    ACTIONS(1223), 1,
      anon_sym_LBRACK,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1248), 1,
      anon_sym_RBRACE,
    ACTIONS(1260), 1,
      anon_sym_EQ,
    ACTIONS(2260), 1,
      sym_identifier,
    STATE(2854), 1,
      aux_sym_object_repeat1,
    ACTIONS(1225), 2,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(813), 10,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(803), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(780), 22,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [2954] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2270), 23,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2272), 36,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [3021] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2274), 23,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2276), 36,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [3088] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2278), 23,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2280), 36,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [3155] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2282), 23,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2284), 36,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [3222] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1710), 1,
      anon_sym_extends,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2219), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2231), 1,
      anon_sym_EQ,
    ACTIONS(2238), 1,
      anon_sym_EQ_GT,
    ACTIONS(2255), 1,
      anon_sym_LT,
    ACTIONS(2286), 1,
      anon_sym_COMMA,
    ACTIONS(2292), 1,
      anon_sym_DOT,
    STATE(284), 1,
      sym_type_arguments,
    ACTIONS(2289), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1113), 14,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2221), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1111), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [3311] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(797), 1,
      anon_sym_EQ_GT,
    ACTIONS(799), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(961), 1,
      anon_sym_EQ,
    ACTIONS(1639), 1,
      anon_sym_LBRACK,
    ACTIONS(1641), 1,
      anon_sym_DOT,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2187), 1,
      anon_sym_LT,
    STATE(1073), 1,
      sym_type_arguments,
    STATE(1174), 1,
      sym_arguments,
    ACTIONS(1637), 14,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(803), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1635), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [3398] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2147), 23,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2149), 36,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [3465] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(475), 1,
      anon_sym_DQUOTE,
    ACTIONS(477), 1,
      anon_sym_SQUOTE,
    ACTIONS(799), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(961), 1,
      anon_sym_EQ,
    ACTIONS(963), 1,
      anon_sym_EQ_GT,
    ACTIONS(1639), 1,
      anon_sym_LBRACK,
    ACTIONS(1641), 1,
      anon_sym_DOT,
    ACTIONS(1800), 1,
      anon_sym_in,
    ACTIONS(1803), 1,
      anon_sym_of,
    ACTIONS(2183), 1,
      sym_identifier,
    STATE(1091), 1,
      sym_string,
    STATE(1092), 1,
      sym_nested_identifier,
    STATE(1221), 1,
      sym__module,
    ACTIONS(813), 8,
      anon_sym_LPAREN,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(803), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(780), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [3560] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2219), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2231), 1,
      anon_sym_EQ,
    ACTIONS(2233), 1,
      anon_sym_LT,
    ACTIONS(2238), 1,
      anon_sym_EQ_GT,
    ACTIONS(2294), 1,
      anon_sym_DOT,
    STATE(2045), 1,
      sym_type_arguments,
    ACTIONS(2286), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(2289), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1710), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1113), 10,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2221), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1111), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [3649] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1396), 1,
      anon_sym_extends,
    ACTIONS(2302), 1,
      anon_sym_DOT,
    ACTIONS(2296), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(2299), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2266), 19,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2268), 32,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [3724] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2187), 1,
      anon_sym_LT,
    ACTIONS(2211), 1,
      anon_sym_EQ,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2219), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2238), 1,
      anon_sym_EQ_GT,
    STATE(1069), 1,
      sym_type_arguments,
    STATE(1160), 1,
      sym_arguments,
    ACTIONS(2213), 14,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2221), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2209), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [3811] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(929), 1,
      anon_sym_EQ_GT,
    ACTIONS(931), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1217), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_COLON,
    ACTIONS(1223), 1,
      anon_sym_LBRACK,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1246), 1,
      anon_sym_RBRACE,
    ACTIONS(1260), 1,
      anon_sym_EQ,
    ACTIONS(2260), 1,
      sym_identifier,
    STATE(2868), 1,
      aux_sym_object_repeat1,
    ACTIONS(1225), 2,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(813), 10,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(803), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(780), 22,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [3902] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1015), 1,
      anon_sym_extends,
    ACTIONS(2299), 1,
      anon_sym_LT,
    ACTIONS(2302), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
    ACTIONS(2305), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2266), 19,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2268), 32,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [3977] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1220), 1,
      anon_sym_COLON,
    ACTIONS(1248), 1,
      anon_sym_RBRACE,
    ACTIONS(2308), 1,
      anon_sym_EQ,
    ACTIONS(2310), 1,
      anon_sym_LPAREN,
    ACTIONS(2313), 1,
      anon_sym_LBRACK,
    ACTIONS(2318), 1,
      anon_sym_DOT,
    ACTIONS(2320), 1,
      anon_sym_EQ_GT,
    ACTIONS(2322), 1,
      anon_sym_QMARK_DOT,
    STATE(2854), 1,
      aux_sym_object_repeat1,
    ACTIONS(2315), 2,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1113), 12,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2221), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1111), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [4065] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(797), 1,
      anon_sym_EQ_GT,
    ACTIONS(799), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(913), 1,
      anon_sym_EQ,
    ACTIONS(1189), 1,
      anon_sym_extends,
    ACTIONS(1639), 1,
      anon_sym_LBRACK,
    ACTIONS(1641), 1,
      anon_sym_DOT,
    ACTIONS(2324), 1,
      anon_sym_COMMA,
    ACTIONS(2327), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(813), 14,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(803), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(780), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [4149] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(475), 1,
      anon_sym_DQUOTE,
    ACTIONS(477), 1,
      anon_sym_SQUOTE,
    ACTIONS(479), 1,
      anon_sym_BQUOTE,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2330), 1,
      sym_identifier,
    ACTIONS(2332), 1,
      anon_sym_STAR,
    ACTIONS(2334), 1,
      anon_sym_LBRACE,
    ACTIONS(2336), 1,
      anon_sym_typeof,
    ACTIONS(2338), 1,
      anon_sym_LPAREN,
    ACTIONS(2340), 1,
      anon_sym_LBRACK,
    ACTIONS(2342), 1,
      anon_sym_new,
    ACTIONS(2344), 1,
      anon_sym_QMARK,
    ACTIONS(2346), 1,
      anon_sym_AMP,
    ACTIONS(2348), 1,
      anon_sym_PIPE,
    ACTIONS(2354), 1,
      sym_number,
    ACTIONS(2356), 1,
      sym_this,
    ACTIONS(2360), 1,
      sym_readonly,
    ACTIONS(2362), 1,
      anon_sym_infer,
    ACTIONS(2364), 1,
      anon_sym_keyof,
    ACTIONS(2366), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1028), 1,
      sym_nested_type_identifier,
    STATE(1082), 1,
      sym__tuple_type_body,
    STATE(1219), 1,
      sym_template_string,
    STATE(3078), 1,
      sym_type_parameters,
    STATE(3195), 1,
      sym_nested_identifier,
    STATE(3385), 1,
      sym_formal_parameters,
    ACTIONS(2350), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2358), 2,
      sym_true,
      sym_false,
    STATE(1087), 2,
      sym_string,
      sym__number,
    ACTIONS(2352), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1052), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(1084), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [4275] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(929), 1,
      anon_sym_EQ_GT,
    ACTIONS(931), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1205), 1,
      anon_sym_RBRACE,
    ACTIONS(1217), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_COLON,
    ACTIONS(1223), 1,
      anon_sym_LBRACK,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1260), 1,
      anon_sym_EQ,
    STATE(2894), 1,
      aux_sym_object_repeat1,
    ACTIONS(1225), 2,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(813), 12,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(803), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(780), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [4363] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(81), 1,
      anon_sym_DQUOTE,
    ACTIONS(83), 1,
      anon_sym_SQUOTE,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2368), 1,
      sym_identifier,
    ACTIONS(2370), 1,
      anon_sym_STAR,
    ACTIONS(2372), 1,
      anon_sym_LBRACE,
    ACTIONS(2374), 1,
      anon_sym_typeof,
    ACTIONS(2376), 1,
      anon_sym_LPAREN,
    ACTIONS(2378), 1,
      anon_sym_LBRACK,
    ACTIONS(2380), 1,
      anon_sym_new,
    ACTIONS(2382), 1,
      anon_sym_QMARK,
    ACTIONS(2384), 1,
      anon_sym_AMP,
    ACTIONS(2386), 1,
      anon_sym_PIPE,
    ACTIONS(2392), 1,
      sym_number,
    ACTIONS(2394), 1,
      sym_this,
    ACTIONS(2398), 1,
      sym_readonly,
    ACTIONS(2400), 1,
      anon_sym_infer,
    ACTIONS(2402), 1,
      anon_sym_keyof,
    ACTIONS(2404), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1291), 1,
      sym_nested_type_identifier,
    STATE(1423), 1,
      sym__tuple_type_body,
    STATE(1570), 1,
      sym_template_string,
    STATE(3021), 1,
      sym_type_parameters,
    STATE(3214), 1,
      sym_nested_identifier,
    STATE(3277), 1,
      sym_formal_parameters,
    ACTIONS(2388), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2396), 2,
      sym_true,
      sym_false,
    STATE(1420), 2,
      sym_string,
      sym__number,
    ACTIONS(2390), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1371), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(1422), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [4489] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2255), 1,
      anon_sym_LT,
    ACTIONS(2313), 1,
      anon_sym_LBRACK,
    ACTIONS(2320), 1,
      anon_sym_EQ_GT,
    ACTIONS(2322), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2406), 1,
      anon_sym_EQ,
    ACTIONS(2408), 1,
      anon_sym_DOT,
    STATE(284), 1,
      sym_type_arguments,
    ACTIONS(1559), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(1561), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1113), 13,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2221), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1111), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [4575] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(929), 1,
      anon_sym_EQ_GT,
    ACTIONS(931), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1217), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_COLON,
    ACTIONS(1223), 1,
      anon_sym_LBRACK,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1248), 1,
      anon_sym_RBRACE,
    ACTIONS(1260), 1,
      anon_sym_EQ,
    STATE(2854), 1,
      aux_sym_object_repeat1,
    ACTIONS(1225), 2,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(813), 12,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(803), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(780), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [4663] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(929), 1,
      anon_sym_EQ_GT,
    ACTIONS(931), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1217), 1,
      anon_sym_LPAREN,
    ACTIONS(1220), 1,
      anon_sym_COLON,
    ACTIONS(1223), 1,
      anon_sym_LBRACK,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1246), 1,
      anon_sym_RBRACE,
    ACTIONS(1260), 1,
      anon_sym_EQ,
    STATE(2868), 1,
      aux_sym_object_repeat1,
    ACTIONS(1225), 2,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(813), 12,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(803), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(780), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [4751] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(929), 1,
      anon_sym_EQ_GT,
    ACTIONS(931), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(961), 1,
      anon_sym_EQ,
    ACTIONS(1223), 1,
      anon_sym_LBRACK,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(2197), 1,
      anon_sym_LPAREN,
    ACTIONS(2199), 1,
      anon_sym_LT,
    STATE(1378), 1,
      sym_type_arguments,
    STATE(1581), 1,
      sym_arguments,
    ACTIONS(1637), 13,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(803), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1635), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [4837] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_STAR,
    ACTIONS(461), 1,
      anon_sym_QMARK,
    ACTIONS(463), 1,
      anon_sym_AMP,
    ACTIONS(465), 1,
      anon_sym_PIPE,
    ACTIONS(495), 1,
      anon_sym_infer,
    ACTIONS(497), 1,
      anon_sym_keyof,
    ACTIONS(499), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(787), 1,
      anon_sym_typeof,
    ACTIONS(789), 1,
      anon_sym_LPAREN,
    ACTIONS(801), 1,
      anon_sym_new,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(821), 1,
      sym_number,
    ACTIONS(915), 1,
      anon_sym_LBRACE,
    ACTIONS(921), 1,
      sym_readonly,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2225), 1,
      anon_sym_LBRACK,
    ACTIONS(2410), 1,
      sym_identifier,
    ACTIONS(2412), 1,
      sym_this,
    ACTIONS(2414), 1,
      anon_sym_asserts,
    STATE(442), 1,
      sym__tuple_type_body,
    STATE(1957), 1,
      sym_nested_type_identifier,
    STATE(3035), 1,
      sym_type_predicate,
    STATE(3048), 1,
      sym_type_parameters,
    STATE(3296), 1,
      sym_formal_parameters,
    STATE(3297), 1,
      sym_nested_identifier,
    ACTIONS(825), 2,
      sym_true,
      sym_false,
    ACTIONS(1655), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(447), 2,
      sym_string,
      sym__number,
    ACTIONS(815), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2105), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(431), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [4963] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1710), 1,
      anon_sym_extends,
    ACTIONS(2255), 1,
      anon_sym_LT,
    ACTIONS(2286), 1,
      anon_sym_COMMA,
    ACTIONS(2313), 1,
      anon_sym_LBRACK,
    ACTIONS(2320), 1,
      anon_sym_EQ_GT,
    ACTIONS(2322), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2406), 1,
      anon_sym_EQ,
    ACTIONS(2416), 1,
      anon_sym_DOT,
    STATE(284), 1,
      sym_type_arguments,
    ACTIONS(2289), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1113), 13,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2221), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1111), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [5051] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1220), 1,
      anon_sym_COLON,
    ACTIONS(1246), 1,
      anon_sym_RBRACE,
    ACTIONS(2308), 1,
      anon_sym_EQ,
    ACTIONS(2310), 1,
      anon_sym_LPAREN,
    ACTIONS(2313), 1,
      anon_sym_LBRACK,
    ACTIONS(2318), 1,
      anon_sym_DOT,
    ACTIONS(2320), 1,
      anon_sym_EQ_GT,
    ACTIONS(2322), 1,
      anon_sym_QMARK_DOT,
    STATE(2868), 1,
      aux_sym_object_repeat1,
    ACTIONS(2315), 2,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1113), 12,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2221), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1111), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [5139] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1205), 1,
      anon_sym_RBRACE,
    ACTIONS(1220), 1,
      anon_sym_COLON,
    ACTIONS(2308), 1,
      anon_sym_EQ,
    ACTIONS(2310), 1,
      anon_sym_LPAREN,
    ACTIONS(2313), 1,
      anon_sym_LBRACK,
    ACTIONS(2318), 1,
      anon_sym_DOT,
    ACTIONS(2320), 1,
      anon_sym_EQ_GT,
    ACTIONS(2322), 1,
      anon_sym_QMARK_DOT,
    STATE(2894), 1,
      aux_sym_object_repeat1,
    ACTIONS(2315), 2,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1113), 12,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2221), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1111), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [5227] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(797), 1,
      anon_sym_EQ_GT,
    ACTIONS(799), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(913), 1,
      anon_sym_EQ,
    ACTIONS(1639), 1,
      anon_sym_LBRACK,
    ACTIONS(1641), 1,
      anon_sym_DOT,
    ACTIONS(2324), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(2327), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1189), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(813), 10,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(803), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(780), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [5311] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2197), 1,
      anon_sym_LPAREN,
    ACTIONS(2199), 1,
      anon_sym_LT,
    ACTIONS(2211), 1,
      anon_sym_EQ,
    ACTIONS(2313), 1,
      anon_sym_LBRACK,
    ACTIONS(2318), 1,
      anon_sym_DOT,
    ACTIONS(2320), 1,
      anon_sym_EQ_GT,
    ACTIONS(2322), 1,
      anon_sym_QMARK_DOT,
    STATE(1377), 1,
      sym_type_arguments,
    STATE(1513), 1,
      sym_arguments,
    ACTIONS(2213), 13,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2221), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2209), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [5397] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(577), 1,
      anon_sym_STAR,
    ACTIONS(589), 1,
      anon_sym_QMARK,
    ACTIONS(591), 1,
      anon_sym_AMP,
    ACTIONS(593), 1,
      anon_sym_PIPE,
    ACTIONS(609), 1,
      anon_sym_infer,
    ACTIONS(611), 1,
      anon_sym_keyof,
    ACTIONS(613), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2418), 1,
      sym_identifier,
    ACTIONS(2420), 1,
      anon_sym_LBRACE,
    ACTIONS(2422), 1,
      anon_sym_typeof,
    ACTIONS(2424), 1,
      anon_sym_LPAREN,
    ACTIONS(2426), 1,
      anon_sym_LBRACK,
    ACTIONS(2428), 1,
      anon_sym_new,
    ACTIONS(2434), 1,
      anon_sym_DQUOTE,
    ACTIONS(2436), 1,
      anon_sym_SQUOTE,
    ACTIONS(2438), 1,
      sym_number,
    ACTIONS(2440), 1,
      sym_this,
    ACTIONS(2444), 1,
      sym_readonly,
    ACTIONS(2446), 1,
      anon_sym_asserts,
    STATE(1983), 1,
      sym_nested_type_identifier,
    STATE(2025), 1,
      sym__tuple_type_body,
    STATE(2270), 1,
      sym_type_predicate,
    STATE(3157), 1,
      sym_type_parameters,
    STATE(3166), 1,
      sym_nested_identifier,
    STATE(3324), 1,
      sym_formal_parameters,
    ACTIONS(2430), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2442), 2,
      sym_true,
      sym_false,
    STATE(2017), 2,
      sym_string,
      sym__number,
    ACTIONS(2432), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2065), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2018), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [5523] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2448), 1,
      sym_identifier,
    ACTIONS(2450), 1,
      anon_sym_STAR,
    ACTIONS(2452), 1,
      anon_sym_LBRACE,
    ACTIONS(2454), 1,
      anon_sym_typeof,
    ACTIONS(2456), 1,
      anon_sym_LPAREN,
    ACTIONS(2458), 1,
      anon_sym_LBRACK,
    ACTIONS(2460), 1,
      anon_sym_new,
    ACTIONS(2462), 1,
      anon_sym_QMARK,
    ACTIONS(2464), 1,
      anon_sym_AMP,
    ACTIONS(2466), 1,
      anon_sym_PIPE,
    ACTIONS(2472), 1,
      anon_sym_DQUOTE,
    ACTIONS(2474), 1,
      anon_sym_SQUOTE,
    ACTIONS(2476), 1,
      sym_number,
    ACTIONS(2478), 1,
      sym_this,
    ACTIONS(2482), 1,
      sym_readonly,
    ACTIONS(2484), 1,
      anon_sym_asserts,
    ACTIONS(2486), 1,
      anon_sym_infer,
    ACTIONS(2488), 1,
      anon_sym_keyof,
    ACTIONS(2490), 1,
      anon_sym_LBRACE_PIPE,
    STATE(2062), 1,
      sym_nested_type_identifier,
    STATE(2119), 1,
      sym__tuple_type_body,
    STATE(2708), 1,
      sym_type_predicate,
    STATE(3122), 1,
      sym_type_parameters,
    STATE(3212), 1,
      sym_nested_identifier,
    STATE(3347), 1,
      sym_formal_parameters,
    ACTIONS(2468), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2480), 2,
      sym_true,
      sym_false,
    STATE(2122), 2,
      sym_string,
      sym__number,
    ACTIONS(2470), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2197), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2123), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [5649] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(693), 1,
      anon_sym_DQUOTE,
    ACTIONS(695), 1,
      anon_sym_SQUOTE,
    ACTIONS(697), 1,
      anon_sym_BQUOTE,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2492), 1,
      sym_identifier,
    ACTIONS(2494), 1,
      anon_sym_STAR,
    ACTIONS(2496), 1,
      anon_sym_LBRACE,
    ACTIONS(2498), 1,
      anon_sym_typeof,
    ACTIONS(2500), 1,
      anon_sym_LPAREN,
    ACTIONS(2502), 1,
      anon_sym_LBRACK,
    ACTIONS(2504), 1,
      anon_sym_new,
    ACTIONS(2506), 1,
      anon_sym_QMARK,
    ACTIONS(2508), 1,
      anon_sym_AMP,
    ACTIONS(2510), 1,
      anon_sym_PIPE,
    ACTIONS(2516), 1,
      sym_number,
    ACTIONS(2518), 1,
      sym_this,
    ACTIONS(2522), 1,
      sym_readonly,
    ACTIONS(2524), 1,
      anon_sym_infer,
    ACTIONS(2526), 1,
      anon_sym_keyof,
    ACTIONS(2528), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1497), 1,
      sym_nested_type_identifier,
    STATE(1567), 1,
      sym__tuple_type_body,
    STATE(1681), 1,
      sym_template_string,
    STATE(2997), 1,
      sym_type_parameters,
    STATE(3219), 1,
      sym_nested_identifier,
    STATE(3288), 1,
      sym_formal_parameters,
    ACTIONS(2512), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2520), 2,
      sym_true,
      sym_false,
    STATE(1564), 2,
      sym_string,
      sym__number,
    ACTIONS(2514), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1650), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(1566), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [5775] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2219), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2231), 1,
      anon_sym_EQ,
    ACTIONS(2238), 1,
      anon_sym_EQ_GT,
    ACTIONS(2255), 1,
      anon_sym_LT,
    ACTIONS(2530), 1,
      anon_sym_DOT,
    STATE(284), 1,
      sym_type_arguments,
    ACTIONS(1559), 2,
      anon_sym_RPAREN,
      anon_sym_extends,
    ACTIONS(1561), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1113), 12,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2221), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1111), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [5860] = 36,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(1729), 1,
      anon_sym_LBRACE,
    ACTIONS(2434), 1,
      anon_sym_DQUOTE,
    ACTIONS(2436), 1,
      anon_sym_SQUOTE,
    ACTIONS(2534), 1,
      anon_sym_export,
    ACTIONS(2536), 1,
      anon_sym_STAR,
    ACTIONS(2538), 1,
      anon_sym_COMMA,
    ACTIONS(2540), 1,
      anon_sym_RBRACE,
    ACTIONS(2542), 1,
      anon_sym_LPAREN,
    ACTIONS(2544), 1,
      anon_sym_SEMI,
    ACTIONS(2546), 1,
      anon_sym_LBRACK,
    ACTIONS(2548), 1,
      anon_sym_async,
    ACTIONS(2550), 1,
      anon_sym_new,
    ACTIONS(2552), 1,
      anon_sym_DASH,
    ACTIONS(2554), 1,
      sym_number,
    ACTIONS(2556), 1,
      anon_sym_static,
    ACTIONS(2562), 1,
      sym_readonly,
    ACTIONS(2564), 1,
      anon_sym_PIPE_RBRACE,
    STATE(1924), 1,
      sym_accessibility_modifier,
    STATE(1945), 1,
      sym_decorator,
    STATE(2066), 1,
      sym_formal_parameters,
    STATE(2493), 1,
      sym__call_signature,
    STATE(2668), 1,
      aux_sym_export_statement_repeat1,
    STATE(2912), 1,
      aux_sym_object_repeat1,
    STATE(3032), 1,
      sym_type_parameters,
    STATE(3210), 1,
      sym_array,
    STATE(3217), 1,
      sym_object,
    ACTIONS(2558), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2560), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1987), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2913), 4,
      sym_assignment_pattern,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(2345), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(2532), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [5991] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2255), 1,
      anon_sym_LT,
    ACTIONS(2313), 1,
      anon_sym_LBRACK,
    ACTIONS(2322), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2566), 1,
      anon_sym_EQ,
    ACTIONS(2568), 1,
      anon_sym_DOT,
    ACTIONS(2570), 1,
      anon_sym_EQ_GT,
    STATE(284), 1,
      sym_type_arguments,
    ACTIONS(1710), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(2289), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1113), 12,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2221), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1111), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [6076] = 36,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(1729), 1,
      anon_sym_LBRACE,
    ACTIONS(2434), 1,
      anon_sym_DQUOTE,
    ACTIONS(2436), 1,
      anon_sym_SQUOTE,
    ACTIONS(2534), 1,
      anon_sym_export,
    ACTIONS(2536), 1,
      anon_sym_STAR,
    ACTIONS(2542), 1,
      anon_sym_LPAREN,
    ACTIONS(2546), 1,
      anon_sym_LBRACK,
    ACTIONS(2548), 1,
      anon_sym_async,
    ACTIONS(2550), 1,
      anon_sym_new,
    ACTIONS(2552), 1,
      anon_sym_DASH,
    ACTIONS(2554), 1,
      sym_number,
    ACTIONS(2556), 1,
      anon_sym_static,
    ACTIONS(2562), 1,
      sym_readonly,
    ACTIONS(2572), 1,
      anon_sym_COMMA,
    ACTIONS(2574), 1,
      anon_sym_RBRACE,
    ACTIONS(2576), 1,
      anon_sym_SEMI,
    ACTIONS(2578), 1,
      anon_sym_PIPE_RBRACE,
    STATE(1924), 1,
      sym_accessibility_modifier,
    STATE(1945), 1,
      sym_decorator,
    STATE(2066), 1,
      sym_formal_parameters,
    STATE(2493), 1,
      sym__call_signature,
    STATE(2668), 1,
      aux_sym_export_statement_repeat1,
    STATE(2912), 1,
      aux_sym_object_repeat1,
    STATE(3032), 1,
      sym_type_parameters,
    STATE(3210), 1,
      sym_array,
    STATE(3217), 1,
      sym_object,
    ACTIONS(2558), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2560), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1987), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2913), 4,
      sym_assignment_pattern,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(2300), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(2532), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [6207] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_STAR,
    ACTIONS(461), 1,
      anon_sym_QMARK,
    ACTIONS(463), 1,
      anon_sym_AMP,
    ACTIONS(465), 1,
      anon_sym_PIPE,
    ACTIONS(495), 1,
      anon_sym_infer,
    ACTIONS(497), 1,
      anon_sym_keyof,
    ACTIONS(499), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(787), 1,
      anon_sym_typeof,
    ACTIONS(789), 1,
      anon_sym_LPAREN,
    ACTIONS(801), 1,
      anon_sym_new,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(821), 1,
      sym_number,
    ACTIONS(911), 1,
      sym_identifier,
    ACTIONS(915), 1,
      anon_sym_LBRACE,
    ACTIONS(921), 1,
      sym_readonly,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2225), 1,
      anon_sym_LBRACK,
    ACTIONS(2580), 1,
      anon_sym_GT,
    ACTIONS(2582), 1,
      sym_this,
    STATE(442), 1,
      sym__tuple_type_body,
    STATE(1957), 1,
      sym_nested_type_identifier,
    STATE(3048), 1,
      sym_type_parameters,
    STATE(3296), 1,
      sym_formal_parameters,
    STATE(3297), 1,
      sym_nested_identifier,
    ACTIONS(825), 2,
      sym_true,
      sym_false,
    ACTIONS(1655), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(447), 2,
      sym_string,
      sym__number,
    ACTIONS(815), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2346), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(431), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [6330] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_STAR,
    ACTIONS(461), 1,
      anon_sym_QMARK,
    ACTIONS(463), 1,
      anon_sym_AMP,
    ACTIONS(465), 1,
      anon_sym_PIPE,
    ACTIONS(495), 1,
      anon_sym_infer,
    ACTIONS(497), 1,
      anon_sym_keyof,
    ACTIONS(499), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(787), 1,
      anon_sym_typeof,
    ACTIONS(789), 1,
      anon_sym_LPAREN,
    ACTIONS(801), 1,
      anon_sym_new,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(821), 1,
      sym_number,
    ACTIONS(911), 1,
      sym_identifier,
    ACTIONS(915), 1,
      anon_sym_LBRACE,
    ACTIONS(921), 1,
      sym_readonly,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2225), 1,
      anon_sym_LBRACK,
    ACTIONS(2582), 1,
      sym_this,
    ACTIONS(2584), 1,
      anon_sym_GT,
    STATE(442), 1,
      sym__tuple_type_body,
    STATE(1957), 1,
      sym_nested_type_identifier,
    STATE(3048), 1,
      sym_type_parameters,
    STATE(3296), 1,
      sym_formal_parameters,
    STATE(3297), 1,
      sym_nested_identifier,
    ACTIONS(825), 2,
      sym_true,
      sym_false,
    ACTIONS(1655), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(447), 2,
      sym_string,
      sym__number,
    ACTIONS(815), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2346), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(431), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [6453] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_STAR,
    ACTIONS(461), 1,
      anon_sym_QMARK,
    ACTIONS(463), 1,
      anon_sym_AMP,
    ACTIONS(465), 1,
      anon_sym_PIPE,
    ACTIONS(495), 1,
      anon_sym_infer,
    ACTIONS(497), 1,
      anon_sym_keyof,
    ACTIONS(499), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(787), 1,
      anon_sym_typeof,
    ACTIONS(789), 1,
      anon_sym_LPAREN,
    ACTIONS(801), 1,
      anon_sym_new,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(821), 1,
      sym_number,
    ACTIONS(911), 1,
      sym_identifier,
    ACTIONS(915), 1,
      anon_sym_LBRACE,
    ACTIONS(921), 1,
      sym_readonly,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2225), 1,
      anon_sym_LBRACK,
    ACTIONS(2582), 1,
      sym_this,
    ACTIONS(2586), 1,
      anon_sym_RBRACK,
    STATE(442), 1,
      sym__tuple_type_body,
    STATE(1957), 1,
      sym_nested_type_identifier,
    STATE(3048), 1,
      sym_type_parameters,
    STATE(3296), 1,
      sym_formal_parameters,
    STATE(3297), 1,
      sym_nested_identifier,
    ACTIONS(825), 2,
      sym_true,
      sym_false,
    ACTIONS(1655), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(447), 2,
      sym_string,
      sym__number,
    ACTIONS(815), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2718), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(431), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [6576] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_STAR,
    ACTIONS(461), 1,
      anon_sym_QMARK,
    ACTIONS(463), 1,
      anon_sym_AMP,
    ACTIONS(465), 1,
      anon_sym_PIPE,
    ACTIONS(495), 1,
      anon_sym_infer,
    ACTIONS(497), 1,
      anon_sym_keyof,
    ACTIONS(499), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(787), 1,
      anon_sym_typeof,
    ACTIONS(789), 1,
      anon_sym_LPAREN,
    ACTIONS(801), 1,
      anon_sym_new,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(821), 1,
      sym_number,
    ACTIONS(911), 1,
      sym_identifier,
    ACTIONS(915), 1,
      anon_sym_LBRACE,
    ACTIONS(921), 1,
      sym_readonly,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2225), 1,
      anon_sym_LBRACK,
    ACTIONS(2582), 1,
      sym_this,
    ACTIONS(2588), 1,
      anon_sym_RBRACK,
    STATE(442), 1,
      sym__tuple_type_body,
    STATE(1957), 1,
      sym_nested_type_identifier,
    STATE(3048), 1,
      sym_type_parameters,
    STATE(3296), 1,
      sym_formal_parameters,
    STATE(3297), 1,
      sym_nested_identifier,
    ACTIONS(825), 2,
      sym_true,
      sym_false,
    ACTIONS(1655), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(447), 2,
      sym_string,
      sym__number,
    ACTIONS(815), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2683), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(431), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [6699] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2302), 1,
      anon_sym_DOT,
    ACTIONS(2296), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
    ACTIONS(2299), 3,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1396), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2266), 20,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2268), 26,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [6772] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2299), 1,
      anon_sym_LT,
    ACTIONS(2305), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1015), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2302), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DOT,
    ACTIONS(2266), 20,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2268), 26,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [6845] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_STAR,
    ACTIONS(461), 1,
      anon_sym_QMARK,
    ACTIONS(463), 1,
      anon_sym_AMP,
    ACTIONS(465), 1,
      anon_sym_PIPE,
    ACTIONS(495), 1,
      anon_sym_infer,
    ACTIONS(497), 1,
      anon_sym_keyof,
    ACTIONS(499), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(787), 1,
      anon_sym_typeof,
    ACTIONS(789), 1,
      anon_sym_LPAREN,
    ACTIONS(801), 1,
      anon_sym_new,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(821), 1,
      sym_number,
    ACTIONS(911), 1,
      sym_identifier,
    ACTIONS(915), 1,
      anon_sym_LBRACE,
    ACTIONS(921), 1,
      sym_readonly,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2225), 1,
      anon_sym_LBRACK,
    ACTIONS(2582), 1,
      sym_this,
    ACTIONS(2590), 1,
      anon_sym_RBRACK,
    STATE(442), 1,
      sym__tuple_type_body,
    STATE(1957), 1,
      sym_nested_type_identifier,
    STATE(3048), 1,
      sym_type_parameters,
    STATE(3296), 1,
      sym_formal_parameters,
    STATE(3297), 1,
      sym_nested_identifier,
    ACTIONS(825), 2,
      sym_true,
      sym_false,
    ACTIONS(1655), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(447), 2,
      sym_string,
      sym__number,
    ACTIONS(815), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2644), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(431), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [6968] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(923), 1,
      anon_sym_EQ,
    ACTIONS(929), 1,
      anon_sym_EQ_GT,
    ACTIONS(931), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1223), 1,
      anon_sym_LBRACK,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1290), 1,
      anon_sym_COLON,
    ACTIONS(2260), 1,
      sym_identifier,
    ACTIONS(813), 11,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(803), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(780), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [7049] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_STAR,
    ACTIONS(461), 1,
      anon_sym_QMARK,
    ACTIONS(463), 1,
      anon_sym_AMP,
    ACTIONS(465), 1,
      anon_sym_PIPE,
    ACTIONS(495), 1,
      anon_sym_infer,
    ACTIONS(497), 1,
      anon_sym_keyof,
    ACTIONS(499), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(787), 1,
      anon_sym_typeof,
    ACTIONS(789), 1,
      anon_sym_LPAREN,
    ACTIONS(801), 1,
      anon_sym_new,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(821), 1,
      sym_number,
    ACTIONS(911), 1,
      sym_identifier,
    ACTIONS(915), 1,
      anon_sym_LBRACE,
    ACTIONS(921), 1,
      sym_readonly,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2225), 1,
      anon_sym_LBRACK,
    ACTIONS(2582), 1,
      sym_this,
    ACTIONS(2592), 1,
      anon_sym_GT,
    STATE(442), 1,
      sym__tuple_type_body,
    STATE(1957), 1,
      sym_nested_type_identifier,
    STATE(3048), 1,
      sym_type_parameters,
    STATE(3296), 1,
      sym_formal_parameters,
    STATE(3297), 1,
      sym_nested_identifier,
    ACTIONS(825), 2,
      sym_true,
      sym_false,
    ACTIONS(1655), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(447), 2,
      sym_string,
      sym__number,
    ACTIONS(815), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2346), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(431), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [7172] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(923), 1,
      anon_sym_EQ,
    ACTIONS(929), 1,
      anon_sym_EQ_GT,
    ACTIONS(931), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1223), 1,
      anon_sym_LBRACK,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1288), 1,
      anon_sym_COLON,
    ACTIONS(2260), 1,
      sym_identifier,
    ACTIONS(813), 11,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(803), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(780), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [7253] = 36,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(1729), 1,
      anon_sym_LBRACE,
    ACTIONS(2434), 1,
      anon_sym_DQUOTE,
    ACTIONS(2436), 1,
      anon_sym_SQUOTE,
    ACTIONS(2536), 1,
      anon_sym_STAR,
    ACTIONS(2542), 1,
      anon_sym_LPAREN,
    ACTIONS(2546), 1,
      anon_sym_LBRACK,
    ACTIONS(2550), 1,
      anon_sym_new,
    ACTIONS(2552), 1,
      anon_sym_DASH,
    ACTIONS(2554), 1,
      sym_number,
    ACTIONS(2572), 1,
      anon_sym_COMMA,
    ACTIONS(2576), 1,
      anon_sym_SEMI,
    ACTIONS(2578), 1,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2596), 1,
      anon_sym_export,
    ACTIONS(2598), 1,
      anon_sym_RBRACE,
    ACTIONS(2600), 1,
      anon_sym_async,
    ACTIONS(2602), 1,
      anon_sym_static,
    ACTIONS(2608), 1,
      sym_readonly,
    STATE(1924), 1,
      sym_accessibility_modifier,
    STATE(1945), 1,
      sym_decorator,
    STATE(2066), 1,
      sym_formal_parameters,
    STATE(2493), 1,
      sym__call_signature,
    STATE(2668), 1,
      aux_sym_export_statement_repeat1,
    STATE(2846), 1,
      aux_sym_object_repeat1,
    STATE(3032), 1,
      sym_type_parameters,
    STATE(3210), 1,
      sym_array,
    STATE(3217), 1,
      sym_object,
    ACTIONS(2604), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2606), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1987), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2844), 4,
      sym_assignment_pattern,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(2300), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(2594), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [7384] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_STAR,
    ACTIONS(461), 1,
      anon_sym_QMARK,
    ACTIONS(463), 1,
      anon_sym_AMP,
    ACTIONS(465), 1,
      anon_sym_PIPE,
    ACTIONS(495), 1,
      anon_sym_infer,
    ACTIONS(497), 1,
      anon_sym_keyof,
    ACTIONS(499), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(787), 1,
      anon_sym_typeof,
    ACTIONS(789), 1,
      anon_sym_LPAREN,
    ACTIONS(801), 1,
      anon_sym_new,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(821), 1,
      sym_number,
    ACTIONS(911), 1,
      sym_identifier,
    ACTIONS(915), 1,
      anon_sym_LBRACE,
    ACTIONS(921), 1,
      sym_readonly,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2225), 1,
      anon_sym_LBRACK,
    ACTIONS(2582), 1,
      sym_this,
    ACTIONS(2610), 1,
      anon_sym_RBRACK,
    STATE(442), 1,
      sym__tuple_type_body,
    STATE(1957), 1,
      sym_nested_type_identifier,
    STATE(3048), 1,
      sym_type_parameters,
    STATE(3296), 1,
      sym_formal_parameters,
    STATE(3297), 1,
      sym_nested_identifier,
    ACTIONS(825), 2,
      sym_true,
      sym_false,
    ACTIONS(1655), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(447), 2,
      sym_string,
      sym__number,
    ACTIONS(815), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2718), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(431), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [7507] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1710), 1,
      anon_sym_extends,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2219), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2238), 1,
      anon_sym_EQ_GT,
    ACTIONS(2255), 1,
      anon_sym_LT,
    ACTIONS(2612), 1,
      anon_sym_EQ,
    ACTIONS(2618), 1,
      anon_sym_RPAREN,
    ACTIONS(2622), 1,
      anon_sym_DOT,
    ACTIONS(2624), 1,
      anon_sym_QMARK,
    STATE(284), 1,
      sym_type_arguments,
    ACTIONS(2289), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2615), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(1113), 10,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2221), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1111), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [7598] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_STAR,
    ACTIONS(461), 1,
      anon_sym_QMARK,
    ACTIONS(463), 1,
      anon_sym_AMP,
    ACTIONS(465), 1,
      anon_sym_PIPE,
    ACTIONS(495), 1,
      anon_sym_infer,
    ACTIONS(497), 1,
      anon_sym_keyof,
    ACTIONS(499), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(787), 1,
      anon_sym_typeof,
    ACTIONS(789), 1,
      anon_sym_LPAREN,
    ACTIONS(801), 1,
      anon_sym_new,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(821), 1,
      sym_number,
    ACTIONS(911), 1,
      sym_identifier,
    ACTIONS(915), 1,
      anon_sym_LBRACE,
    ACTIONS(921), 1,
      sym_readonly,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2225), 1,
      anon_sym_LBRACK,
    ACTIONS(2582), 1,
      sym_this,
    ACTIONS(2627), 1,
      anon_sym_GT,
    STATE(442), 1,
      sym__tuple_type_body,
    STATE(1957), 1,
      sym_nested_type_identifier,
    STATE(3048), 1,
      sym_type_parameters,
    STATE(3296), 1,
      sym_formal_parameters,
    STATE(3297), 1,
      sym_nested_identifier,
    ACTIONS(825), 2,
      sym_true,
      sym_false,
    ACTIONS(1655), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(447), 2,
      sym_string,
      sym__number,
    ACTIONS(815), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2346), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(431), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [7721] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_STAR,
    ACTIONS(461), 1,
      anon_sym_QMARK,
    ACTIONS(463), 1,
      anon_sym_AMP,
    ACTIONS(465), 1,
      anon_sym_PIPE,
    ACTIONS(495), 1,
      anon_sym_infer,
    ACTIONS(497), 1,
      anon_sym_keyof,
    ACTIONS(499), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(787), 1,
      anon_sym_typeof,
    ACTIONS(789), 1,
      anon_sym_LPAREN,
    ACTIONS(801), 1,
      anon_sym_new,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(821), 1,
      sym_number,
    ACTIONS(911), 1,
      sym_identifier,
    ACTIONS(915), 1,
      anon_sym_LBRACE,
    ACTIONS(921), 1,
      sym_readonly,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2225), 1,
      anon_sym_LBRACK,
    ACTIONS(2582), 1,
      sym_this,
    ACTIONS(2629), 1,
      anon_sym_GT,
    STATE(442), 1,
      sym__tuple_type_body,
    STATE(1957), 1,
      sym_nested_type_identifier,
    STATE(3048), 1,
      sym_type_parameters,
    STATE(3296), 1,
      sym_formal_parameters,
    STATE(3297), 1,
      sym_nested_identifier,
    ACTIONS(825), 2,
      sym_true,
      sym_false,
    ACTIONS(1655), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(447), 2,
      sym_string,
      sym__number,
    ACTIONS(815), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2346), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(431), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [7844] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1710), 1,
      anon_sym_extends,
    ACTIONS(2255), 1,
      anon_sym_LT,
    ACTIONS(2286), 1,
      anon_sym_COMMA,
    ACTIONS(2631), 1,
      anon_sym_EQ,
    ACTIONS(2633), 1,
      anon_sym_LBRACK,
    ACTIONS(2635), 1,
      anon_sym_DOT,
    ACTIONS(2637), 1,
      anon_sym_EQ_GT,
    ACTIONS(2639), 1,
      anon_sym_QMARK_DOT,
    STATE(284), 1,
      sym_type_arguments,
    ACTIONS(2289), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1113), 11,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2221), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1111), 19,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [7931] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_STAR,
    ACTIONS(461), 1,
      anon_sym_QMARK,
    ACTIONS(463), 1,
      anon_sym_AMP,
    ACTIONS(465), 1,
      anon_sym_PIPE,
    ACTIONS(495), 1,
      anon_sym_infer,
    ACTIONS(497), 1,
      anon_sym_keyof,
    ACTIONS(499), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(787), 1,
      anon_sym_typeof,
    ACTIONS(789), 1,
      anon_sym_LPAREN,
    ACTIONS(801), 1,
      anon_sym_new,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(821), 1,
      sym_number,
    ACTIONS(911), 1,
      sym_identifier,
    ACTIONS(915), 1,
      anon_sym_LBRACE,
    ACTIONS(921), 1,
      sym_readonly,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2225), 1,
      anon_sym_LBRACK,
    ACTIONS(2582), 1,
      sym_this,
    ACTIONS(2641), 1,
      anon_sym_GT,
    STATE(442), 1,
      sym__tuple_type_body,
    STATE(1957), 1,
      sym_nested_type_identifier,
    STATE(3048), 1,
      sym_type_parameters,
    STATE(3296), 1,
      sym_formal_parameters,
    STATE(3297), 1,
      sym_nested_identifier,
    ACTIONS(825), 2,
      sym_true,
      sym_false,
    ACTIONS(1655), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(447), 2,
      sym_string,
      sym__number,
    ACTIONS(815), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2346), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(431), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [8054] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2255), 1,
      anon_sym_LT,
    ACTIONS(2631), 1,
      anon_sym_EQ,
    ACTIONS(2633), 1,
      anon_sym_LBRACK,
    ACTIONS(2637), 1,
      anon_sym_EQ_GT,
    ACTIONS(2639), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2643), 1,
      anon_sym_DOT,
    STATE(284), 1,
      sym_type_arguments,
    ACTIONS(1559), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(1561), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1113), 11,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2221), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1111), 19,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [8139] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2187), 1,
      anon_sym_LT,
    ACTIONS(2211), 1,
      anon_sym_EQ,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2219), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2645), 1,
      anon_sym_EQ_GT,
    STATE(1069), 1,
      sym_type_arguments,
    STATE(1160), 1,
      sym_arguments,
    ACTIONS(2213), 12,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
    ACTIONS(2221), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2209), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [8224] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_STAR,
    ACTIONS(461), 1,
      anon_sym_QMARK,
    ACTIONS(463), 1,
      anon_sym_AMP,
    ACTIONS(465), 1,
      anon_sym_PIPE,
    ACTIONS(495), 1,
      anon_sym_infer,
    ACTIONS(497), 1,
      anon_sym_keyof,
    ACTIONS(499), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(787), 1,
      anon_sym_typeof,
    ACTIONS(789), 1,
      anon_sym_LPAREN,
    ACTIONS(801), 1,
      anon_sym_new,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(821), 1,
      sym_number,
    ACTIONS(915), 1,
      anon_sym_LBRACE,
    ACTIONS(921), 1,
      sym_readonly,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2225), 1,
      anon_sym_LBRACK,
    ACTIONS(2582), 1,
      sym_this,
    ACTIONS(2647), 1,
      sym_identifier,
    STATE(442), 1,
      sym__tuple_type_body,
    STATE(1957), 1,
      sym_nested_type_identifier,
    STATE(2927), 1,
      sym_type_parameter,
    STATE(3048), 1,
      sym_type_parameters,
    STATE(3296), 1,
      sym_formal_parameters,
    STATE(3297), 1,
      sym_nested_identifier,
    ACTIONS(825), 2,
      sym_true,
      sym_false,
    ACTIONS(1655), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(447), 2,
      sym_string,
      sym__number,
    ACTIONS(815), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2358), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(431), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [8347] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2219), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2255), 1,
      anon_sym_LT,
    ACTIONS(2258), 1,
      anon_sym_DOT,
    ACTIONS(2645), 1,
      anon_sym_EQ_GT,
    ACTIONS(2649), 1,
      anon_sym_EQ,
    STATE(284), 1,
      sym_type_arguments,
    ACTIONS(1559), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(1561), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1113), 12,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
    ACTIONS(2221), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1111), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [8432] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2201), 1,
      anon_sym_LPAREN,
    ACTIONS(2203), 1,
      anon_sym_LT,
    ACTIONS(2211), 1,
      anon_sym_EQ,
    ACTIONS(2633), 1,
      anon_sym_LBRACK,
    ACTIONS(2637), 1,
      anon_sym_EQ_GT,
    ACTIONS(2639), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2651), 1,
      anon_sym_DOT,
    STATE(1667), 1,
      sym_type_arguments,
    STATE(1677), 1,
      sym_arguments,
    ACTIONS(2213), 11,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2221), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2209), 22,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [8517] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2211), 1,
      anon_sym_EQ,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2219), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2253), 1,
      anon_sym_EQ_GT,
    ACTIONS(2255), 1,
      anon_sym_LT,
    ACTIONS(2653), 1,
      anon_sym_DOT,
    STATE(284), 1,
      sym_type_arguments,
    ACTIONS(1559), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(1561), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1113), 12,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2221), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1111), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [8602] = 36,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(1729), 1,
      anon_sym_LBRACE,
    ACTIONS(2434), 1,
      anon_sym_DQUOTE,
    ACTIONS(2436), 1,
      anon_sym_SQUOTE,
    ACTIONS(2536), 1,
      anon_sym_STAR,
    ACTIONS(2542), 1,
      anon_sym_LPAREN,
    ACTIONS(2546), 1,
      anon_sym_LBRACK,
    ACTIONS(2550), 1,
      anon_sym_new,
    ACTIONS(2552), 1,
      anon_sym_DASH,
    ACTIONS(2554), 1,
      sym_number,
    ACTIONS(2572), 1,
      anon_sym_COMMA,
    ACTIONS(2576), 1,
      anon_sym_SEMI,
    ACTIONS(2578), 1,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2657), 1,
      anon_sym_export,
    ACTIONS(2659), 1,
      anon_sym_RBRACE,
    ACTIONS(2661), 1,
      anon_sym_async,
    ACTIONS(2663), 1,
      anon_sym_static,
    ACTIONS(2669), 1,
      sym_readonly,
    STATE(1924), 1,
      sym_accessibility_modifier,
    STATE(1945), 1,
      sym_decorator,
    STATE(2066), 1,
      sym_formal_parameters,
    STATE(2493), 1,
      sym__call_signature,
    STATE(2668), 1,
      aux_sym_export_statement_repeat1,
    STATE(2751), 1,
      aux_sym_object_repeat1,
    STATE(3032), 1,
      sym_type_parameters,
    STATE(3210), 1,
      sym_array,
    STATE(3217), 1,
      sym_object,
    ACTIONS(2665), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2667), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1987), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2780), 4,
      sym_assignment_pattern,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(2300), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(2655), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [8733] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_STAR,
    ACTIONS(461), 1,
      anon_sym_QMARK,
    ACTIONS(463), 1,
      anon_sym_AMP,
    ACTIONS(465), 1,
      anon_sym_PIPE,
    ACTIONS(495), 1,
      anon_sym_infer,
    ACTIONS(497), 1,
      anon_sym_keyof,
    ACTIONS(499), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(787), 1,
      anon_sym_typeof,
    ACTIONS(789), 1,
      anon_sym_LPAREN,
    ACTIONS(801), 1,
      anon_sym_new,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(821), 1,
      sym_number,
    ACTIONS(911), 1,
      sym_identifier,
    ACTIONS(915), 1,
      anon_sym_LBRACE,
    ACTIONS(921), 1,
      sym_readonly,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2225), 1,
      anon_sym_LBRACK,
    ACTIONS(2582), 1,
      sym_this,
    ACTIONS(2671), 1,
      anon_sym_GT,
    STATE(442), 1,
      sym__tuple_type_body,
    STATE(1957), 1,
      sym_nested_type_identifier,
    STATE(3048), 1,
      sym_type_parameters,
    STATE(3296), 1,
      sym_formal_parameters,
    STATE(3297), 1,
      sym_nested_identifier,
    ACTIONS(825), 2,
      sym_true,
      sym_false,
    ACTIONS(1655), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(447), 2,
      sym_string,
      sym__number,
    ACTIONS(815), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2346), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(431), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [8856] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_STAR,
    ACTIONS(461), 1,
      anon_sym_QMARK,
    ACTIONS(463), 1,
      anon_sym_AMP,
    ACTIONS(465), 1,
      anon_sym_PIPE,
    ACTIONS(495), 1,
      anon_sym_infer,
    ACTIONS(497), 1,
      anon_sym_keyof,
    ACTIONS(499), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(787), 1,
      anon_sym_typeof,
    ACTIONS(789), 1,
      anon_sym_LPAREN,
    ACTIONS(801), 1,
      anon_sym_new,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(821), 1,
      sym_number,
    ACTIONS(911), 1,
      sym_identifier,
    ACTIONS(915), 1,
      anon_sym_LBRACE,
    ACTIONS(921), 1,
      sym_readonly,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2225), 1,
      anon_sym_LBRACK,
    ACTIONS(2582), 1,
      sym_this,
    ACTIONS(2673), 1,
      anon_sym_GT,
    STATE(442), 1,
      sym__tuple_type_body,
    STATE(1957), 1,
      sym_nested_type_identifier,
    STATE(3048), 1,
      sym_type_parameters,
    STATE(3296), 1,
      sym_formal_parameters,
    STATE(3297), 1,
      sym_nested_identifier,
    ACTIONS(825), 2,
      sym_true,
      sym_false,
    ACTIONS(1655), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(447), 2,
      sym_string,
      sym__number,
    ACTIONS(815), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2346), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(431), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [8979] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_STAR,
    ACTIONS(461), 1,
      anon_sym_QMARK,
    ACTIONS(463), 1,
      anon_sym_AMP,
    ACTIONS(465), 1,
      anon_sym_PIPE,
    ACTIONS(495), 1,
      anon_sym_infer,
    ACTIONS(497), 1,
      anon_sym_keyof,
    ACTIONS(499), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(787), 1,
      anon_sym_typeof,
    ACTIONS(789), 1,
      anon_sym_LPAREN,
    ACTIONS(801), 1,
      anon_sym_new,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(821), 1,
      sym_number,
    ACTIONS(911), 1,
      sym_identifier,
    ACTIONS(915), 1,
      anon_sym_LBRACE,
    ACTIONS(921), 1,
      sym_readonly,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2225), 1,
      anon_sym_LBRACK,
    ACTIONS(2582), 1,
      sym_this,
    ACTIONS(2675), 1,
      anon_sym_RBRACK,
    STATE(442), 1,
      sym__tuple_type_body,
    STATE(1957), 1,
      sym_nested_type_identifier,
    STATE(3048), 1,
      sym_type_parameters,
    STATE(3296), 1,
      sym_formal_parameters,
    STATE(3297), 1,
      sym_nested_identifier,
    ACTIONS(825), 2,
      sym_true,
      sym_false,
    ACTIONS(1655), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(447), 2,
      sym_string,
      sym__number,
    ACTIONS(815), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2710), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(431), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [9102] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_STAR,
    ACTIONS(461), 1,
      anon_sym_QMARK,
    ACTIONS(463), 1,
      anon_sym_AMP,
    ACTIONS(465), 1,
      anon_sym_PIPE,
    ACTIONS(495), 1,
      anon_sym_infer,
    ACTIONS(497), 1,
      anon_sym_keyof,
    ACTIONS(499), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(787), 1,
      anon_sym_typeof,
    ACTIONS(789), 1,
      anon_sym_LPAREN,
    ACTIONS(801), 1,
      anon_sym_new,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(821), 1,
      sym_number,
    ACTIONS(911), 1,
      sym_identifier,
    ACTIONS(915), 1,
      anon_sym_LBRACE,
    ACTIONS(921), 1,
      sym_readonly,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2225), 1,
      anon_sym_LBRACK,
    ACTIONS(2582), 1,
      sym_this,
    ACTIONS(2677), 1,
      anon_sym_RBRACK,
    STATE(442), 1,
      sym__tuple_type_body,
    STATE(1957), 1,
      sym_nested_type_identifier,
    STATE(3048), 1,
      sym_type_parameters,
    STATE(3296), 1,
      sym_formal_parameters,
    STATE(3297), 1,
      sym_nested_identifier,
    ACTIONS(825), 2,
      sym_true,
      sym_false,
    ACTIONS(1655), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(447), 2,
      sym_string,
      sym__number,
    ACTIONS(815), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2718), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(431), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [9225] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(797), 1,
      anon_sym_EQ_GT,
    ACTIONS(799), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(913), 1,
      anon_sym_EQ,
    ACTIONS(1639), 1,
      anon_sym_LBRACK,
    ACTIONS(1641), 1,
      anon_sym_DOT,
    ACTIONS(803), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(813), 15,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(780), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [9302] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_STAR,
    ACTIONS(461), 1,
      anon_sym_QMARK,
    ACTIONS(463), 1,
      anon_sym_AMP,
    ACTIONS(465), 1,
      anon_sym_PIPE,
    ACTIONS(495), 1,
      anon_sym_infer,
    ACTIONS(497), 1,
      anon_sym_keyof,
    ACTIONS(499), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(787), 1,
      anon_sym_typeof,
    ACTIONS(789), 1,
      anon_sym_LPAREN,
    ACTIONS(801), 1,
      anon_sym_new,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(821), 1,
      sym_number,
    ACTIONS(911), 1,
      sym_identifier,
    ACTIONS(915), 1,
      anon_sym_LBRACE,
    ACTIONS(921), 1,
      sym_readonly,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2225), 1,
      anon_sym_LBRACK,
    ACTIONS(2582), 1,
      sym_this,
    ACTIONS(2679), 1,
      anon_sym_GT,
    STATE(442), 1,
      sym__tuple_type_body,
    STATE(1957), 1,
      sym_nested_type_identifier,
    STATE(3048), 1,
      sym_type_parameters,
    STATE(3296), 1,
      sym_formal_parameters,
    STATE(3297), 1,
      sym_nested_identifier,
    ACTIONS(825), 2,
      sym_true,
      sym_false,
    ACTIONS(1655), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(447), 2,
      sym_string,
      sym__number,
    ACTIONS(815), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2346), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(431), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [9425] = 36,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(1729), 1,
      anon_sym_LBRACE,
    ACTIONS(2434), 1,
      anon_sym_DQUOTE,
    ACTIONS(2436), 1,
      anon_sym_SQUOTE,
    ACTIONS(2534), 1,
      anon_sym_export,
    ACTIONS(2536), 1,
      anon_sym_STAR,
    ACTIONS(2542), 1,
      anon_sym_LPAREN,
    ACTIONS(2546), 1,
      anon_sym_LBRACK,
    ACTIONS(2548), 1,
      anon_sym_async,
    ACTIONS(2550), 1,
      anon_sym_new,
    ACTIONS(2552), 1,
      anon_sym_DASH,
    ACTIONS(2554), 1,
      sym_number,
    ACTIONS(2556), 1,
      anon_sym_static,
    ACTIONS(2562), 1,
      sym_readonly,
    ACTIONS(2572), 1,
      anon_sym_COMMA,
    ACTIONS(2576), 1,
      anon_sym_SEMI,
    ACTIONS(2578), 1,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2681), 1,
      anon_sym_RBRACE,
    STATE(1924), 1,
      sym_accessibility_modifier,
    STATE(1945), 1,
      sym_decorator,
    STATE(2066), 1,
      sym_formal_parameters,
    STATE(2493), 1,
      sym__call_signature,
    STATE(2668), 1,
      aux_sym_export_statement_repeat1,
    STATE(2912), 1,
      aux_sym_object_repeat1,
    STATE(3032), 1,
      sym_type_parameters,
    STATE(3210), 1,
      sym_array,
    STATE(3217), 1,
      sym_object,
    ACTIONS(2558), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2560), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1987), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2913), 4,
      sym_assignment_pattern,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(2300), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(2532), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [9556] = 36,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(1729), 1,
      anon_sym_LBRACE,
    ACTIONS(2434), 1,
      anon_sym_DQUOTE,
    ACTIONS(2436), 1,
      anon_sym_SQUOTE,
    ACTIONS(2536), 1,
      anon_sym_STAR,
    ACTIONS(2542), 1,
      anon_sym_LPAREN,
    ACTIONS(2546), 1,
      anon_sym_LBRACK,
    ACTIONS(2550), 1,
      anon_sym_new,
    ACTIONS(2552), 1,
      anon_sym_DASH,
    ACTIONS(2554), 1,
      sym_number,
    ACTIONS(2572), 1,
      anon_sym_COMMA,
    ACTIONS(2576), 1,
      anon_sym_SEMI,
    ACTIONS(2578), 1,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2685), 1,
      anon_sym_export,
    ACTIONS(2687), 1,
      anon_sym_RBRACE,
    ACTIONS(2689), 1,
      anon_sym_async,
    ACTIONS(2691), 1,
      anon_sym_static,
    ACTIONS(2697), 1,
      sym_readonly,
    STATE(1924), 1,
      sym_accessibility_modifier,
    STATE(1945), 1,
      sym_decorator,
    STATE(2066), 1,
      sym_formal_parameters,
    STATE(2493), 1,
      sym__call_signature,
    STATE(2668), 1,
      aux_sym_export_statement_repeat1,
    STATE(2874), 1,
      aux_sym_object_repeat1,
    STATE(3032), 1,
      sym_type_parameters,
    STATE(3210), 1,
      sym_array,
    STATE(3217), 1,
      sym_object,
    ACTIONS(2693), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2695), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1987), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2870), 4,
      sym_assignment_pattern,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(2300), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(2683), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [9687] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(961), 1,
      anon_sym_EQ,
    ACTIONS(1141), 1,
      anon_sym_EQ_GT,
    ACTIONS(1143), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1689), 1,
      anon_sym_LBRACK,
    ACTIONS(1691), 1,
      anon_sym_DOT,
    ACTIONS(2201), 1,
      anon_sym_LPAREN,
    ACTIONS(2203), 1,
      anon_sym_LT,
    STATE(1644), 1,
      sym_type_arguments,
    STATE(1689), 1,
      sym_arguments,
    ACTIONS(1637), 11,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
    ACTIONS(803), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1635), 22,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [9772] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(923), 1,
      anon_sym_EQ,
    ACTIONS(929), 1,
      anon_sym_EQ_GT,
    ACTIONS(931), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1189), 1,
      anon_sym_extends,
    ACTIONS(1223), 1,
      anon_sym_LBRACK,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(2324), 1,
      anon_sym_COMMA,
    ACTIONS(2327), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(813), 13,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(803), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(780), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [9855] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_STAR,
    ACTIONS(461), 1,
      anon_sym_QMARK,
    ACTIONS(463), 1,
      anon_sym_AMP,
    ACTIONS(465), 1,
      anon_sym_PIPE,
    ACTIONS(495), 1,
      anon_sym_infer,
    ACTIONS(497), 1,
      anon_sym_keyof,
    ACTIONS(499), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(787), 1,
      anon_sym_typeof,
    ACTIONS(789), 1,
      anon_sym_LPAREN,
    ACTIONS(801), 1,
      anon_sym_new,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(821), 1,
      sym_number,
    ACTIONS(911), 1,
      sym_identifier,
    ACTIONS(915), 1,
      anon_sym_LBRACE,
    ACTIONS(921), 1,
      sym_readonly,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2225), 1,
      anon_sym_LBRACK,
    ACTIONS(2582), 1,
      sym_this,
    ACTIONS(2699), 1,
      anon_sym_GT,
    STATE(442), 1,
      sym__tuple_type_body,
    STATE(1957), 1,
      sym_nested_type_identifier,
    STATE(3048), 1,
      sym_type_parameters,
    STATE(3296), 1,
      sym_formal_parameters,
    STATE(3297), 1,
      sym_nested_identifier,
    ACTIONS(825), 2,
      sym_true,
      sym_false,
    ACTIONS(1655), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(447), 2,
      sym_string,
      sym__number,
    ACTIONS(815), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2346), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(431), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [9978] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1710), 1,
      anon_sym_extends,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2219), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2255), 1,
      anon_sym_LT,
    ACTIONS(2286), 1,
      anon_sym_COMMA,
    ACTIONS(2292), 1,
      anon_sym_DOT,
    ACTIONS(2645), 1,
      anon_sym_EQ_GT,
    ACTIONS(2649), 1,
      anon_sym_EQ,
    STATE(284), 1,
      sym_type_arguments,
    ACTIONS(2289), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1113), 12,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
    ACTIONS(2221), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1111), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [10065] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_STAR,
    ACTIONS(461), 1,
      anon_sym_QMARK,
    ACTIONS(463), 1,
      anon_sym_AMP,
    ACTIONS(465), 1,
      anon_sym_PIPE,
    ACTIONS(495), 1,
      anon_sym_infer,
    ACTIONS(497), 1,
      anon_sym_keyof,
    ACTIONS(499), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(787), 1,
      anon_sym_typeof,
    ACTIONS(789), 1,
      anon_sym_LPAREN,
    ACTIONS(801), 1,
      anon_sym_new,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(821), 1,
      sym_number,
    ACTIONS(911), 1,
      sym_identifier,
    ACTIONS(915), 1,
      anon_sym_LBRACE,
    ACTIONS(921), 1,
      sym_readonly,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2225), 1,
      anon_sym_LBRACK,
    ACTIONS(2582), 1,
      sym_this,
    ACTIONS(2701), 1,
      anon_sym_RBRACK,
    STATE(442), 1,
      sym__tuple_type_body,
    STATE(1957), 1,
      sym_nested_type_identifier,
    STATE(3048), 1,
      sym_type_parameters,
    STATE(3296), 1,
      sym_formal_parameters,
    STATE(3297), 1,
      sym_nested_identifier,
    ACTIONS(825), 2,
      sym_true,
      sym_false,
    ACTIONS(1655), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(447), 2,
      sym_string,
      sym__number,
    ACTIONS(815), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2718), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(431), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [10188] = 36,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(1729), 1,
      anon_sym_LBRACE,
    ACTIONS(2434), 1,
      anon_sym_DQUOTE,
    ACTIONS(2436), 1,
      anon_sym_SQUOTE,
    ACTIONS(2536), 1,
      anon_sym_STAR,
    ACTIONS(2542), 1,
      anon_sym_LPAREN,
    ACTIONS(2546), 1,
      anon_sym_LBRACK,
    ACTIONS(2550), 1,
      anon_sym_new,
    ACTIONS(2552), 1,
      anon_sym_DASH,
    ACTIONS(2554), 1,
      sym_number,
    ACTIONS(2572), 1,
      anon_sym_COMMA,
    ACTIONS(2576), 1,
      anon_sym_SEMI,
    ACTIONS(2578), 1,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2657), 1,
      anon_sym_export,
    ACTIONS(2661), 1,
      anon_sym_async,
    ACTIONS(2663), 1,
      anon_sym_static,
    ACTIONS(2669), 1,
      sym_readonly,
    ACTIONS(2703), 1,
      anon_sym_RBRACE,
    STATE(1924), 1,
      sym_accessibility_modifier,
    STATE(1945), 1,
      sym_decorator,
    STATE(2066), 1,
      sym_formal_parameters,
    STATE(2493), 1,
      sym__call_signature,
    STATE(2668), 1,
      aux_sym_export_statement_repeat1,
    STATE(2751), 1,
      aux_sym_object_repeat1,
    STATE(3032), 1,
      sym_type_parameters,
    STATE(3210), 1,
      sym_array,
    STATE(3217), 1,
      sym_object,
    ACTIONS(2665), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2667), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1987), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2780), 4,
      sym_assignment_pattern,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(2300), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(2655), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [10319] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_STAR,
    ACTIONS(461), 1,
      anon_sym_QMARK,
    ACTIONS(463), 1,
      anon_sym_AMP,
    ACTIONS(465), 1,
      anon_sym_PIPE,
    ACTIONS(495), 1,
      anon_sym_infer,
    ACTIONS(497), 1,
      anon_sym_keyof,
    ACTIONS(499), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(787), 1,
      anon_sym_typeof,
    ACTIONS(789), 1,
      anon_sym_LPAREN,
    ACTIONS(801), 1,
      anon_sym_new,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(821), 1,
      sym_number,
    ACTIONS(911), 1,
      sym_identifier,
    ACTIONS(915), 1,
      anon_sym_LBRACE,
    ACTIONS(921), 1,
      sym_readonly,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2225), 1,
      anon_sym_LBRACK,
    ACTIONS(2582), 1,
      sym_this,
    ACTIONS(2705), 1,
      anon_sym_RBRACK,
    STATE(442), 1,
      sym__tuple_type_body,
    STATE(1957), 1,
      sym_nested_type_identifier,
    STATE(3048), 1,
      sym_type_parameters,
    STATE(3296), 1,
      sym_formal_parameters,
    STATE(3297), 1,
      sym_nested_identifier,
    ACTIONS(825), 2,
      sym_true,
      sym_false,
    ACTIONS(1655), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(447), 2,
      sym_string,
      sym__number,
    ACTIONS(815), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2655), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(431), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [10442] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_STAR,
    ACTIONS(461), 1,
      anon_sym_QMARK,
    ACTIONS(463), 1,
      anon_sym_AMP,
    ACTIONS(465), 1,
      anon_sym_PIPE,
    ACTIONS(495), 1,
      anon_sym_infer,
    ACTIONS(497), 1,
      anon_sym_keyof,
    ACTIONS(499), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(787), 1,
      anon_sym_typeof,
    ACTIONS(789), 1,
      anon_sym_LPAREN,
    ACTIONS(801), 1,
      anon_sym_new,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(821), 1,
      sym_number,
    ACTIONS(911), 1,
      sym_identifier,
    ACTIONS(915), 1,
      anon_sym_LBRACE,
    ACTIONS(921), 1,
      sym_readonly,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2225), 1,
      anon_sym_LBRACK,
    ACTIONS(2582), 1,
      sym_this,
    ACTIONS(2707), 1,
      anon_sym_GT,
    STATE(442), 1,
      sym__tuple_type_body,
    STATE(1957), 1,
      sym_nested_type_identifier,
    STATE(3048), 1,
      sym_type_parameters,
    STATE(3296), 1,
      sym_formal_parameters,
    STATE(3297), 1,
      sym_nested_identifier,
    ACTIONS(825), 2,
      sym_true,
      sym_false,
    ACTIONS(1655), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(447), 2,
      sym_string,
      sym__number,
    ACTIONS(815), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2346), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(431), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [10565] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2197), 1,
      anon_sym_LPAREN,
    ACTIONS(2199), 1,
      anon_sym_LT,
    ACTIONS(2211), 1,
      anon_sym_EQ,
    ACTIONS(2313), 1,
      anon_sym_LBRACK,
    ACTIONS(2318), 1,
      anon_sym_DOT,
    ACTIONS(2322), 1,
      anon_sym_QMARK_DOT,
    STATE(1377), 1,
      sym_type_arguments,
    STATE(1513), 1,
      sym_arguments,
    ACTIONS(2213), 13,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2221), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2209), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [10648] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_STAR,
    ACTIONS(461), 1,
      anon_sym_QMARK,
    ACTIONS(463), 1,
      anon_sym_AMP,
    ACTIONS(465), 1,
      anon_sym_PIPE,
    ACTIONS(495), 1,
      anon_sym_infer,
    ACTIONS(497), 1,
      anon_sym_keyof,
    ACTIONS(499), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(787), 1,
      anon_sym_typeof,
    ACTIONS(789), 1,
      anon_sym_LPAREN,
    ACTIONS(801), 1,
      anon_sym_new,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(821), 1,
      sym_number,
    ACTIONS(911), 1,
      sym_identifier,
    ACTIONS(915), 1,
      anon_sym_LBRACE,
    ACTIONS(921), 1,
      sym_readonly,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2225), 1,
      anon_sym_LBRACK,
    ACTIONS(2582), 1,
      sym_this,
    ACTIONS(2709), 1,
      anon_sym_RBRACK,
    STATE(442), 1,
      sym__tuple_type_body,
    STATE(1957), 1,
      sym_nested_type_identifier,
    STATE(3048), 1,
      sym_type_parameters,
    STATE(3296), 1,
      sym_formal_parameters,
    STATE(3297), 1,
      sym_nested_identifier,
    ACTIONS(825), 2,
      sym_true,
      sym_false,
    ACTIONS(1655), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(447), 2,
      sym_string,
      sym__number,
    ACTIONS(815), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2718), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(431), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [10771] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2211), 1,
      anon_sym_EQ,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2219), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2253), 1,
      anon_sym_EQ_GT,
    ACTIONS(2255), 1,
      anon_sym_LT,
    ACTIONS(2711), 1,
      anon_sym_DOT,
    STATE(284), 1,
      sym_type_arguments,
    ACTIONS(1710), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(2289), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1113), 12,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2221), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1111), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [10856] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(799), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(961), 1,
      anon_sym_EQ,
    ACTIONS(1085), 1,
      anon_sym_EQ_GT,
    ACTIONS(1639), 1,
      anon_sym_LBRACK,
    ACTIONS(1641), 1,
      anon_sym_DOT,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2187), 1,
      anon_sym_LT,
    STATE(1073), 1,
      sym_type_arguments,
    STATE(1174), 1,
      sym_arguments,
    ACTIONS(1637), 12,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
    ACTIONS(803), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1635), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [10941] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_STAR,
    ACTIONS(461), 1,
      anon_sym_QMARK,
    ACTIONS(463), 1,
      anon_sym_AMP,
    ACTIONS(465), 1,
      anon_sym_PIPE,
    ACTIONS(495), 1,
      anon_sym_infer,
    ACTIONS(497), 1,
      anon_sym_keyof,
    ACTIONS(499), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(787), 1,
      anon_sym_typeof,
    ACTIONS(789), 1,
      anon_sym_LPAREN,
    ACTIONS(801), 1,
      anon_sym_new,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(821), 1,
      sym_number,
    ACTIONS(911), 1,
      sym_identifier,
    ACTIONS(915), 1,
      anon_sym_LBRACE,
    ACTIONS(921), 1,
      sym_readonly,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2225), 1,
      anon_sym_LBRACK,
    ACTIONS(2582), 1,
      sym_this,
    ACTIONS(2713), 1,
      anon_sym_GT,
    STATE(442), 1,
      sym__tuple_type_body,
    STATE(1957), 1,
      sym_nested_type_identifier,
    STATE(3048), 1,
      sym_type_parameters,
    STATE(3296), 1,
      sym_formal_parameters,
    STATE(3297), 1,
      sym_nested_identifier,
    ACTIONS(825), 2,
      sym_true,
      sym_false,
    ACTIONS(1655), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(447), 2,
      sym_string,
      sym__number,
    ACTIONS(815), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2346), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(431), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [11064] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_STAR,
    ACTIONS(461), 1,
      anon_sym_QMARK,
    ACTIONS(463), 1,
      anon_sym_AMP,
    ACTIONS(465), 1,
      anon_sym_PIPE,
    ACTIONS(495), 1,
      anon_sym_infer,
    ACTIONS(497), 1,
      anon_sym_keyof,
    ACTIONS(499), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(787), 1,
      anon_sym_typeof,
    ACTIONS(789), 1,
      anon_sym_LPAREN,
    ACTIONS(801), 1,
      anon_sym_new,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(821), 1,
      sym_number,
    ACTIONS(911), 1,
      sym_identifier,
    ACTIONS(915), 1,
      anon_sym_LBRACE,
    ACTIONS(921), 1,
      sym_readonly,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2225), 1,
      anon_sym_LBRACK,
    ACTIONS(2582), 1,
      sym_this,
    ACTIONS(2715), 1,
      anon_sym_GT,
    STATE(442), 1,
      sym__tuple_type_body,
    STATE(1957), 1,
      sym_nested_type_identifier,
    STATE(3048), 1,
      sym_type_parameters,
    STATE(3296), 1,
      sym_formal_parameters,
    STATE(3297), 1,
      sym_nested_identifier,
    ACTIONS(825), 2,
      sym_true,
      sym_false,
    ACTIONS(1655), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(447), 2,
      sym_string,
      sym__number,
    ACTIONS(815), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2346), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(431), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [11187] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_STAR,
    ACTIONS(461), 1,
      anon_sym_QMARK,
    ACTIONS(463), 1,
      anon_sym_AMP,
    ACTIONS(465), 1,
      anon_sym_PIPE,
    ACTIONS(495), 1,
      anon_sym_infer,
    ACTIONS(497), 1,
      anon_sym_keyof,
    ACTIONS(499), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(787), 1,
      anon_sym_typeof,
    ACTIONS(789), 1,
      anon_sym_LPAREN,
    ACTIONS(801), 1,
      anon_sym_new,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(821), 1,
      sym_number,
    ACTIONS(911), 1,
      sym_identifier,
    ACTIONS(915), 1,
      anon_sym_LBRACE,
    ACTIONS(921), 1,
      sym_readonly,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2225), 1,
      anon_sym_LBRACK,
    ACTIONS(2582), 1,
      sym_this,
    ACTIONS(2717), 1,
      anon_sym_RBRACK,
    STATE(442), 1,
      sym__tuple_type_body,
    STATE(1957), 1,
      sym_nested_type_identifier,
    STATE(3048), 1,
      sym_type_parameters,
    STATE(3296), 1,
      sym_formal_parameters,
    STATE(3297), 1,
      sym_nested_identifier,
    ACTIONS(825), 2,
      sym_true,
      sym_false,
    ACTIONS(1655), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(447), 2,
      sym_string,
      sym__number,
    ACTIONS(815), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2718), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(431), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [11310] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2631), 1,
      anon_sym_EQ,
    ACTIONS(2633), 1,
      anon_sym_LBRACK,
    ACTIONS(2637), 1,
      anon_sym_EQ_GT,
    ACTIONS(2639), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2719), 1,
      anon_sym_LBRACE,
    ACTIONS(2721), 1,
      anon_sym_COMMA,
    ACTIONS(2723), 1,
      anon_sym_LT,
    ACTIONS(2726), 1,
      anon_sym_DOT,
    ACTIONS(2728), 1,
      anon_sym_LBRACE_PIPE,
    STATE(2623), 1,
      aux_sym_extends_clause_repeat1,
    STATE(2816), 1,
      sym_type_arguments,
    ACTIONS(1113), 10,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2221), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1111), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [11399] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2219), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2231), 1,
      anon_sym_EQ,
    ACTIONS(2238), 1,
      anon_sym_EQ_GT,
    ACTIONS(1113), 15,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2221), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1111), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [11476] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_STAR,
    ACTIONS(461), 1,
      anon_sym_QMARK,
    ACTIONS(463), 1,
      anon_sym_AMP,
    ACTIONS(465), 1,
      anon_sym_PIPE,
    ACTIONS(495), 1,
      anon_sym_infer,
    ACTIONS(497), 1,
      anon_sym_keyof,
    ACTIONS(499), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(787), 1,
      anon_sym_typeof,
    ACTIONS(789), 1,
      anon_sym_LPAREN,
    ACTIONS(801), 1,
      anon_sym_new,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(821), 1,
      sym_number,
    ACTIONS(911), 1,
      sym_identifier,
    ACTIONS(915), 1,
      anon_sym_LBRACE,
    ACTIONS(921), 1,
      sym_readonly,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2225), 1,
      anon_sym_LBRACK,
    ACTIONS(2582), 1,
      sym_this,
    ACTIONS(2730), 1,
      anon_sym_RBRACK,
    STATE(442), 1,
      sym__tuple_type_body,
    STATE(1957), 1,
      sym_nested_type_identifier,
    STATE(3048), 1,
      sym_type_parameters,
    STATE(3296), 1,
      sym_formal_parameters,
    STATE(3297), 1,
      sym_nested_identifier,
    ACTIONS(825), 2,
      sym_true,
      sym_false,
    ACTIONS(1655), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(447), 2,
      sym_string,
      sym__number,
    ACTIONS(815), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2671), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(431), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [11599] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_STAR,
    ACTIONS(461), 1,
      anon_sym_QMARK,
    ACTIONS(463), 1,
      anon_sym_AMP,
    ACTIONS(465), 1,
      anon_sym_PIPE,
    ACTIONS(495), 1,
      anon_sym_infer,
    ACTIONS(497), 1,
      anon_sym_keyof,
    ACTIONS(499), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(787), 1,
      anon_sym_typeof,
    ACTIONS(789), 1,
      anon_sym_LPAREN,
    ACTIONS(801), 1,
      anon_sym_new,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(821), 1,
      sym_number,
    ACTIONS(911), 1,
      sym_identifier,
    ACTIONS(915), 1,
      anon_sym_LBRACE,
    ACTIONS(921), 1,
      sym_readonly,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2225), 1,
      anon_sym_LBRACK,
    ACTIONS(2582), 1,
      sym_this,
    ACTIONS(2732), 1,
      anon_sym_GT,
    STATE(442), 1,
      sym__tuple_type_body,
    STATE(1957), 1,
      sym_nested_type_identifier,
    STATE(3048), 1,
      sym_type_parameters,
    STATE(3296), 1,
      sym_formal_parameters,
    STATE(3297), 1,
      sym_nested_identifier,
    ACTIONS(825), 2,
      sym_true,
      sym_false,
    ACTIONS(1655), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(447), 2,
      sym_string,
      sym__number,
    ACTIONS(815), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2346), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(431), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [11722] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2255), 1,
      anon_sym_LT,
    ACTIONS(2313), 1,
      anon_sym_LBRACK,
    ACTIONS(2322), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2566), 1,
      anon_sym_EQ,
    ACTIONS(2570), 1,
      anon_sym_EQ_GT,
    ACTIONS(2734), 1,
      anon_sym_DOT,
    STATE(284), 1,
      sym_type_arguments,
    ACTIONS(1559), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(1561), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1113), 12,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2221), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1111), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [11807] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_STAR,
    ACTIONS(461), 1,
      anon_sym_QMARK,
    ACTIONS(463), 1,
      anon_sym_AMP,
    ACTIONS(465), 1,
      anon_sym_PIPE,
    ACTIONS(495), 1,
      anon_sym_infer,
    ACTIONS(497), 1,
      anon_sym_keyof,
    ACTIONS(499), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(787), 1,
      anon_sym_typeof,
    ACTIONS(789), 1,
      anon_sym_LPAREN,
    ACTIONS(801), 1,
      anon_sym_new,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(821), 1,
      sym_number,
    ACTIONS(911), 1,
      sym_identifier,
    ACTIONS(915), 1,
      anon_sym_LBRACE,
    ACTIONS(921), 1,
      sym_readonly,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2225), 1,
      anon_sym_LBRACK,
    ACTIONS(2582), 1,
      sym_this,
    ACTIONS(2736), 1,
      anon_sym_RBRACK,
    STATE(442), 1,
      sym__tuple_type_body,
    STATE(1957), 1,
      sym_nested_type_identifier,
    STATE(3048), 1,
      sym_type_parameters,
    STATE(3296), 1,
      sym_formal_parameters,
    STATE(3297), 1,
      sym_nested_identifier,
    ACTIONS(825), 2,
      sym_true,
      sym_false,
    ACTIONS(1655), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(447), 2,
      sym_string,
      sym__number,
    ACTIONS(815), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2718), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(431), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [11930] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2219), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2255), 1,
      anon_sym_LT,
    ACTIONS(2645), 1,
      anon_sym_EQ_GT,
    ACTIONS(2649), 1,
      anon_sym_EQ,
    ACTIONS(2738), 1,
      anon_sym_COMMA,
    ACTIONS(2740), 1,
      anon_sym_DOT,
    STATE(284), 1,
      sym_type_arguments,
    STATE(2731), 1,
      aux_sym_extends_clause_repeat1,
    ACTIONS(2728), 2,
      anon_sym_LBRACE,
      anon_sym_implements,
    ACTIONS(1113), 10,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2221), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1111), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [12017] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_STAR,
    ACTIONS(461), 1,
      anon_sym_QMARK,
    ACTIONS(463), 1,
      anon_sym_AMP,
    ACTIONS(465), 1,
      anon_sym_PIPE,
    ACTIONS(495), 1,
      anon_sym_infer,
    ACTIONS(497), 1,
      anon_sym_keyof,
    ACTIONS(499), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(787), 1,
      anon_sym_typeof,
    ACTIONS(789), 1,
      anon_sym_LPAREN,
    ACTIONS(801), 1,
      anon_sym_new,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(821), 1,
      sym_number,
    ACTIONS(911), 1,
      sym_identifier,
    ACTIONS(915), 1,
      anon_sym_LBRACE,
    ACTIONS(921), 1,
      sym_readonly,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2225), 1,
      anon_sym_LBRACK,
    ACTIONS(2582), 1,
      sym_this,
    STATE(442), 1,
      sym__tuple_type_body,
    STATE(1957), 1,
      sym_nested_type_identifier,
    STATE(3048), 1,
      sym_type_parameters,
    STATE(3296), 1,
      sym_formal_parameters,
    STATE(3297), 1,
      sym_nested_identifier,
    ACTIONS(825), 2,
      sym_true,
      sym_false,
    ACTIONS(1655), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(447), 2,
      sym_string,
      sym__number,
    ACTIONS(815), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2329), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(431), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [12137] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(81), 1,
      anon_sym_DQUOTE,
    ACTIONS(83), 1,
      anon_sym_SQUOTE,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2368), 1,
      sym_identifier,
    ACTIONS(2370), 1,
      anon_sym_STAR,
    ACTIONS(2372), 1,
      anon_sym_LBRACE,
    ACTIONS(2374), 1,
      anon_sym_typeof,
    ACTIONS(2376), 1,
      anon_sym_LPAREN,
    ACTIONS(2378), 1,
      anon_sym_LBRACK,
    ACTIONS(2380), 1,
      anon_sym_new,
    ACTIONS(2382), 1,
      anon_sym_QMARK,
    ACTIONS(2384), 1,
      anon_sym_AMP,
    ACTIONS(2386), 1,
      anon_sym_PIPE,
    ACTIONS(2392), 1,
      sym_number,
    ACTIONS(2394), 1,
      sym_this,
    ACTIONS(2398), 1,
      sym_readonly,
    ACTIONS(2400), 1,
      anon_sym_infer,
    ACTIONS(2402), 1,
      anon_sym_keyof,
    ACTIONS(2404), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1291), 1,
      sym_nested_type_identifier,
    STATE(1423), 1,
      sym__tuple_type_body,
    STATE(3021), 1,
      sym_type_parameters,
    STATE(3214), 1,
      sym_nested_identifier,
    STATE(3277), 1,
      sym_formal_parameters,
    ACTIONS(2388), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2396), 2,
      sym_true,
      sym_false,
    STATE(1420), 2,
      sym_string,
      sym__number,
    ACTIONS(2390), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1373), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(1422), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [12257] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2227), 23,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2229), 33,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [12321] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2219), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2231), 1,
      anon_sym_EQ,
    ACTIONS(2238), 1,
      anon_sym_EQ_GT,
    ACTIONS(2742), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(1113), 12,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2221), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1111), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [12399] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2450), 1,
      anon_sym_STAR,
    ACTIONS(2452), 1,
      anon_sym_LBRACE,
    ACTIONS(2454), 1,
      anon_sym_typeof,
    ACTIONS(2456), 1,
      anon_sym_LPAREN,
    ACTIONS(2458), 1,
      anon_sym_LBRACK,
    ACTIONS(2460), 1,
      anon_sym_new,
    ACTIONS(2462), 1,
      anon_sym_QMARK,
    ACTIONS(2464), 1,
      anon_sym_AMP,
    ACTIONS(2466), 1,
      anon_sym_PIPE,
    ACTIONS(2472), 1,
      anon_sym_DQUOTE,
    ACTIONS(2474), 1,
      anon_sym_SQUOTE,
    ACTIONS(2476), 1,
      sym_number,
    ACTIONS(2482), 1,
      sym_readonly,
    ACTIONS(2486), 1,
      anon_sym_infer,
    ACTIONS(2488), 1,
      anon_sym_keyof,
    ACTIONS(2490), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2744), 1,
      sym_identifier,
    ACTIONS(2746), 1,
      sym_this,
    STATE(2062), 1,
      sym_nested_type_identifier,
    STATE(2119), 1,
      sym__tuple_type_body,
    STATE(3122), 1,
      sym_type_parameters,
    STATE(3212), 1,
      sym_nested_identifier,
    STATE(3347), 1,
      sym_formal_parameters,
    ACTIONS(2468), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2480), 2,
      sym_true,
      sym_false,
    STATE(2122), 2,
      sym_string,
      sym__number,
    ACTIONS(2470), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2156), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2123), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [12519] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2147), 23,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2149), 33,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [12583] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_STAR,
    ACTIONS(461), 1,
      anon_sym_QMARK,
    ACTIONS(463), 1,
      anon_sym_AMP,
    ACTIONS(465), 1,
      anon_sym_PIPE,
    ACTIONS(495), 1,
      anon_sym_infer,
    ACTIONS(497), 1,
      anon_sym_keyof,
    ACTIONS(499), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(787), 1,
      anon_sym_typeof,
    ACTIONS(789), 1,
      anon_sym_LPAREN,
    ACTIONS(801), 1,
      anon_sym_new,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(821), 1,
      sym_number,
    ACTIONS(911), 1,
      sym_identifier,
    ACTIONS(915), 1,
      anon_sym_LBRACE,
    ACTIONS(921), 1,
      sym_readonly,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2502), 1,
      anon_sym_LBRACK,
    ACTIONS(2748), 1,
      sym_this,
    STATE(1631), 1,
      sym__tuple_type_body,
    STATE(1957), 1,
      sym_nested_type_identifier,
    STATE(3048), 1,
      sym_type_parameters,
    STATE(3296), 1,
      sym_formal_parameters,
    STATE(3297), 1,
      sym_nested_identifier,
    ACTIONS(825), 2,
      sym_true,
      sym_false,
    ACTIONS(1655), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(447), 2,
      sym_string,
      sym__number,
    ACTIONS(815), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2794), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2717), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [12703] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(923), 1,
      anon_sym_EQ,
    ACTIONS(929), 1,
      anon_sym_EQ_GT,
    ACTIONS(931), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1223), 1,
      anon_sym_LBRACK,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1288), 1,
      anon_sym_COLON,
    ACTIONS(813), 13,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(803), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(780), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [12781] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1288), 1,
      anon_sym_COLON,
    ACTIONS(2313), 1,
      anon_sym_LBRACK,
    ACTIONS(2318), 1,
      anon_sym_DOT,
    ACTIONS(2320), 1,
      anon_sym_EQ_GT,
    ACTIONS(2322), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2406), 1,
      anon_sym_EQ,
    ACTIONS(1113), 13,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2221), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1111), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [12859] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(577), 1,
      anon_sym_STAR,
    ACTIONS(589), 1,
      anon_sym_QMARK,
    ACTIONS(591), 1,
      anon_sym_AMP,
    ACTIONS(593), 1,
      anon_sym_PIPE,
    ACTIONS(609), 1,
      anon_sym_infer,
    ACTIONS(611), 1,
      anon_sym_keyof,
    ACTIONS(613), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2420), 1,
      anon_sym_LBRACE,
    ACTIONS(2422), 1,
      anon_sym_typeof,
    ACTIONS(2424), 1,
      anon_sym_LPAREN,
    ACTIONS(2426), 1,
      anon_sym_LBRACK,
    ACTIONS(2428), 1,
      anon_sym_new,
    ACTIONS(2434), 1,
      anon_sym_DQUOTE,
    ACTIONS(2436), 1,
      anon_sym_SQUOTE,
    ACTIONS(2438), 1,
      sym_number,
    ACTIONS(2444), 1,
      sym_readonly,
    ACTIONS(2750), 1,
      sym_identifier,
    ACTIONS(2752), 1,
      sym_this,
    STATE(1983), 1,
      sym_nested_type_identifier,
    STATE(2025), 1,
      sym__tuple_type_body,
    STATE(3157), 1,
      sym_type_parameters,
    STATE(3166), 1,
      sym_nested_identifier,
    STATE(3324), 1,
      sym_formal_parameters,
    ACTIONS(2430), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2442), 2,
      sym_true,
      sym_false,
    STATE(2017), 2,
      sym_string,
      sym__number,
    ACTIONS(2432), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2500), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2018), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [12979] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(693), 1,
      anon_sym_DQUOTE,
    ACTIONS(695), 1,
      anon_sym_SQUOTE,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2492), 1,
      sym_identifier,
    ACTIONS(2494), 1,
      anon_sym_STAR,
    ACTIONS(2496), 1,
      anon_sym_LBRACE,
    ACTIONS(2498), 1,
      anon_sym_typeof,
    ACTIONS(2500), 1,
      anon_sym_LPAREN,
    ACTIONS(2502), 1,
      anon_sym_LBRACK,
    ACTIONS(2504), 1,
      anon_sym_new,
    ACTIONS(2506), 1,
      anon_sym_QMARK,
    ACTIONS(2508), 1,
      anon_sym_AMP,
    ACTIONS(2510), 1,
      anon_sym_PIPE,
    ACTIONS(2516), 1,
      sym_number,
    ACTIONS(2518), 1,
      sym_this,
    ACTIONS(2522), 1,
      sym_readonly,
    ACTIONS(2524), 1,
      anon_sym_infer,
    ACTIONS(2526), 1,
      anon_sym_keyof,
    ACTIONS(2528), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1497), 1,
      sym_nested_type_identifier,
    STATE(1567), 1,
      sym__tuple_type_body,
    STATE(2997), 1,
      sym_type_parameters,
    STATE(3219), 1,
      sym_nested_identifier,
    STATE(3288), 1,
      sym_formal_parameters,
    ACTIONS(2512), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2520), 2,
      sym_true,
      sym_false,
    STATE(1564), 2,
      sym_string,
      sym__number,
    ACTIONS(2514), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1553), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(1566), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [13099] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2266), 23,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2268), 33,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [13163] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_STAR,
    ACTIONS(461), 1,
      anon_sym_QMARK,
    ACTIONS(463), 1,
      anon_sym_AMP,
    ACTIONS(465), 1,
      anon_sym_PIPE,
    ACTIONS(495), 1,
      anon_sym_infer,
    ACTIONS(497), 1,
      anon_sym_keyof,
    ACTIONS(499), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(787), 1,
      anon_sym_typeof,
    ACTIONS(789), 1,
      anon_sym_LPAREN,
    ACTIONS(801), 1,
      anon_sym_new,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(821), 1,
      sym_number,
    ACTIONS(911), 1,
      sym_identifier,
    ACTIONS(915), 1,
      anon_sym_LBRACE,
    ACTIONS(921), 1,
      sym_readonly,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2225), 1,
      anon_sym_LBRACK,
    ACTIONS(2582), 1,
      sym_this,
    STATE(442), 1,
      sym__tuple_type_body,
    STATE(1957), 1,
      sym_nested_type_identifier,
    STATE(3048), 1,
      sym_type_parameters,
    STATE(3296), 1,
      sym_formal_parameters,
    STATE(3297), 1,
      sym_nested_identifier,
    ACTIONS(825), 2,
      sym_true,
      sym_false,
    ACTIONS(1655), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(447), 2,
      sym_string,
      sym__number,
    ACTIONS(815), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2745), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(431), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [13283] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2219), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2255), 1,
      anon_sym_LT,
    ACTIONS(2645), 1,
      anon_sym_EQ_GT,
    ACTIONS(2649), 1,
      anon_sym_EQ,
    ACTIONS(2740), 1,
      anon_sym_DOT,
    STATE(284), 1,
      sym_type_arguments,
    ACTIONS(2754), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(1113), 10,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2221), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1111), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [13365] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2450), 1,
      anon_sym_STAR,
    ACTIONS(2452), 1,
      anon_sym_LBRACE,
    ACTIONS(2454), 1,
      anon_sym_typeof,
    ACTIONS(2456), 1,
      anon_sym_LPAREN,
    ACTIONS(2458), 1,
      anon_sym_LBRACK,
    ACTIONS(2460), 1,
      anon_sym_new,
    ACTIONS(2462), 1,
      anon_sym_QMARK,
    ACTIONS(2464), 1,
      anon_sym_AMP,
    ACTIONS(2466), 1,
      anon_sym_PIPE,
    ACTIONS(2472), 1,
      anon_sym_DQUOTE,
    ACTIONS(2474), 1,
      anon_sym_SQUOTE,
    ACTIONS(2476), 1,
      sym_number,
    ACTIONS(2482), 1,
      sym_readonly,
    ACTIONS(2486), 1,
      anon_sym_infer,
    ACTIONS(2488), 1,
      anon_sym_keyof,
    ACTIONS(2490), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2744), 1,
      sym_identifier,
    ACTIONS(2746), 1,
      sym_this,
    STATE(2062), 1,
      sym_nested_type_identifier,
    STATE(2119), 1,
      sym__tuple_type_body,
    STATE(3122), 1,
      sym_type_parameters,
    STATE(3212), 1,
      sym_nested_identifier,
    STATE(3347), 1,
      sym_formal_parameters,
    ACTIONS(2468), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2480), 2,
      sym_true,
      sym_false,
    STATE(2122), 2,
      sym_string,
      sym__number,
    ACTIONS(2470), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2130), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2123), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [13485] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(577), 1,
      anon_sym_STAR,
    ACTIONS(589), 1,
      anon_sym_QMARK,
    ACTIONS(591), 1,
      anon_sym_AMP,
    ACTIONS(593), 1,
      anon_sym_PIPE,
    ACTIONS(609), 1,
      anon_sym_infer,
    ACTIONS(611), 1,
      anon_sym_keyof,
    ACTIONS(613), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2420), 1,
      anon_sym_LBRACE,
    ACTIONS(2422), 1,
      anon_sym_typeof,
    ACTIONS(2424), 1,
      anon_sym_LPAREN,
    ACTIONS(2426), 1,
      anon_sym_LBRACK,
    ACTIONS(2428), 1,
      anon_sym_new,
    ACTIONS(2434), 1,
      anon_sym_DQUOTE,
    ACTIONS(2436), 1,
      anon_sym_SQUOTE,
    ACTIONS(2438), 1,
      sym_number,
    ACTIONS(2444), 1,
      sym_readonly,
    ACTIONS(2750), 1,
      sym_identifier,
    ACTIONS(2752), 1,
      sym_this,
    STATE(1983), 1,
      sym_nested_type_identifier,
    STATE(2025), 1,
      sym__tuple_type_body,
    STATE(3157), 1,
      sym_type_parameters,
    STATE(3166), 1,
      sym_nested_identifier,
    STATE(3324), 1,
      sym_formal_parameters,
    ACTIONS(2430), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2442), 2,
      sym_true,
      sym_false,
    STATE(2017), 2,
      sym_string,
      sym__number,
    ACTIONS(2432), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2042), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2018), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [13605] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(577), 1,
      anon_sym_STAR,
    ACTIONS(589), 1,
      anon_sym_QMARK,
    ACTIONS(591), 1,
      anon_sym_AMP,
    ACTIONS(593), 1,
      anon_sym_PIPE,
    ACTIONS(609), 1,
      anon_sym_infer,
    ACTIONS(611), 1,
      anon_sym_keyof,
    ACTIONS(613), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2420), 1,
      anon_sym_LBRACE,
    ACTIONS(2422), 1,
      anon_sym_typeof,
    ACTIONS(2424), 1,
      anon_sym_LPAREN,
    ACTIONS(2426), 1,
      anon_sym_LBRACK,
    ACTIONS(2428), 1,
      anon_sym_new,
    ACTIONS(2434), 1,
      anon_sym_DQUOTE,
    ACTIONS(2436), 1,
      anon_sym_SQUOTE,
    ACTIONS(2438), 1,
      sym_number,
    ACTIONS(2444), 1,
      sym_readonly,
    ACTIONS(2750), 1,
      sym_identifier,
    ACTIONS(2752), 1,
      sym_this,
    STATE(1983), 1,
      sym_nested_type_identifier,
    STATE(2025), 1,
      sym__tuple_type_body,
    STATE(3157), 1,
      sym_type_parameters,
    STATE(3166), 1,
      sym_nested_identifier,
    STATE(3324), 1,
      sym_formal_parameters,
    ACTIONS(2430), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2442), 2,
      sym_true,
      sym_false,
    STATE(2017), 2,
      sym_string,
      sym__number,
    ACTIONS(2432), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2118), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2018), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [13725] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(577), 1,
      anon_sym_STAR,
    ACTIONS(589), 1,
      anon_sym_QMARK,
    ACTIONS(591), 1,
      anon_sym_AMP,
    ACTIONS(593), 1,
      anon_sym_PIPE,
    ACTIONS(609), 1,
      anon_sym_infer,
    ACTIONS(611), 1,
      anon_sym_keyof,
    ACTIONS(613), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2420), 1,
      anon_sym_LBRACE,
    ACTIONS(2422), 1,
      anon_sym_typeof,
    ACTIONS(2424), 1,
      anon_sym_LPAREN,
    ACTIONS(2426), 1,
      anon_sym_LBRACK,
    ACTIONS(2428), 1,
      anon_sym_new,
    ACTIONS(2434), 1,
      anon_sym_DQUOTE,
    ACTIONS(2436), 1,
      anon_sym_SQUOTE,
    ACTIONS(2438), 1,
      sym_number,
    ACTIONS(2444), 1,
      sym_readonly,
    ACTIONS(2750), 1,
      sym_identifier,
    ACTIONS(2752), 1,
      sym_this,
    STATE(1983), 1,
      sym_nested_type_identifier,
    STATE(2025), 1,
      sym__tuple_type_body,
    STATE(3157), 1,
      sym_type_parameters,
    STATE(3166), 1,
      sym_nested_identifier,
    STATE(3324), 1,
      sym_formal_parameters,
    ACTIONS(2430), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2442), 2,
      sym_true,
      sym_false,
    STATE(2017), 2,
      sym_string,
      sym__number,
    ACTIONS(2432), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2121), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2018), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [13845] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(577), 1,
      anon_sym_STAR,
    ACTIONS(589), 1,
      anon_sym_QMARK,
    ACTIONS(591), 1,
      anon_sym_AMP,
    ACTIONS(593), 1,
      anon_sym_PIPE,
    ACTIONS(609), 1,
      anon_sym_infer,
    ACTIONS(611), 1,
      anon_sym_keyof,
    ACTIONS(613), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2420), 1,
      anon_sym_LBRACE,
    ACTIONS(2422), 1,
      anon_sym_typeof,
    ACTIONS(2424), 1,
      anon_sym_LPAREN,
    ACTIONS(2426), 1,
      anon_sym_LBRACK,
    ACTIONS(2428), 1,
      anon_sym_new,
    ACTIONS(2434), 1,
      anon_sym_DQUOTE,
    ACTIONS(2436), 1,
      anon_sym_SQUOTE,
    ACTIONS(2438), 1,
      sym_number,
    ACTIONS(2444), 1,
      sym_readonly,
    ACTIONS(2750), 1,
      sym_identifier,
    ACTIONS(2752), 1,
      sym_this,
    STATE(1983), 1,
      sym_nested_type_identifier,
    STATE(2025), 1,
      sym__tuple_type_body,
    STATE(3157), 1,
      sym_type_parameters,
    STATE(3166), 1,
      sym_nested_identifier,
    STATE(3324), 1,
      sym_formal_parameters,
    ACTIONS(2430), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2442), 2,
      sym_true,
      sym_false,
    STATE(2017), 2,
      sym_string,
      sym__number,
    ACTIONS(2432), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2048), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2018), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [13965] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(577), 1,
      anon_sym_STAR,
    ACTIONS(589), 1,
      anon_sym_QMARK,
    ACTIONS(591), 1,
      anon_sym_AMP,
    ACTIONS(593), 1,
      anon_sym_PIPE,
    ACTIONS(609), 1,
      anon_sym_infer,
    ACTIONS(611), 1,
      anon_sym_keyof,
    ACTIONS(613), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2420), 1,
      anon_sym_LBRACE,
    ACTIONS(2422), 1,
      anon_sym_typeof,
    ACTIONS(2424), 1,
      anon_sym_LPAREN,
    ACTIONS(2426), 1,
      anon_sym_LBRACK,
    ACTIONS(2428), 1,
      anon_sym_new,
    ACTIONS(2434), 1,
      anon_sym_DQUOTE,
    ACTIONS(2436), 1,
      anon_sym_SQUOTE,
    ACTIONS(2438), 1,
      sym_number,
    ACTIONS(2444), 1,
      sym_readonly,
    ACTIONS(2750), 1,
      sym_identifier,
    ACTIONS(2752), 1,
      sym_this,
    STATE(1983), 1,
      sym_nested_type_identifier,
    STATE(2025), 1,
      sym__tuple_type_body,
    STATE(3157), 1,
      sym_type_parameters,
    STATE(3166), 1,
      sym_nested_identifier,
    STATE(3324), 1,
      sym_formal_parameters,
    ACTIONS(2430), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2442), 2,
      sym_true,
      sym_false,
    STATE(2017), 2,
      sym_string,
      sym__number,
    ACTIONS(2432), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2044), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2018), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [14085] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(81), 1,
      anon_sym_DQUOTE,
    ACTIONS(83), 1,
      anon_sym_SQUOTE,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2368), 1,
      sym_identifier,
    ACTIONS(2370), 1,
      anon_sym_STAR,
    ACTIONS(2372), 1,
      anon_sym_LBRACE,
    ACTIONS(2374), 1,
      anon_sym_typeof,
    ACTIONS(2376), 1,
      anon_sym_LPAREN,
    ACTIONS(2378), 1,
      anon_sym_LBRACK,
    ACTIONS(2380), 1,
      anon_sym_new,
    ACTIONS(2382), 1,
      anon_sym_QMARK,
    ACTIONS(2384), 1,
      anon_sym_AMP,
    ACTIONS(2386), 1,
      anon_sym_PIPE,
    ACTIONS(2392), 1,
      sym_number,
    ACTIONS(2394), 1,
      sym_this,
    ACTIONS(2398), 1,
      sym_readonly,
    ACTIONS(2400), 1,
      anon_sym_infer,
    ACTIONS(2402), 1,
      anon_sym_keyof,
    ACTIONS(2404), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1291), 1,
      sym_nested_type_identifier,
    STATE(1423), 1,
      sym__tuple_type_body,
    STATE(3021), 1,
      sym_type_parameters,
    STATE(3214), 1,
      sym_nested_identifier,
    STATE(3277), 1,
      sym_formal_parameters,
    ACTIONS(2388), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2396), 2,
      sym_true,
      sym_false,
    STATE(1420), 2,
      sym_string,
      sym__number,
    ACTIONS(2390), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1393), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(1422), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [14205] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(81), 1,
      anon_sym_DQUOTE,
    ACTIONS(83), 1,
      anon_sym_SQUOTE,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2368), 1,
      sym_identifier,
    ACTIONS(2370), 1,
      anon_sym_STAR,
    ACTIONS(2372), 1,
      anon_sym_LBRACE,
    ACTIONS(2374), 1,
      anon_sym_typeof,
    ACTIONS(2376), 1,
      anon_sym_LPAREN,
    ACTIONS(2378), 1,
      anon_sym_LBRACK,
    ACTIONS(2380), 1,
      anon_sym_new,
    ACTIONS(2382), 1,
      anon_sym_QMARK,
    ACTIONS(2384), 1,
      anon_sym_AMP,
    ACTIONS(2386), 1,
      anon_sym_PIPE,
    ACTIONS(2392), 1,
      sym_number,
    ACTIONS(2394), 1,
      sym_this,
    ACTIONS(2398), 1,
      sym_readonly,
    ACTIONS(2400), 1,
      anon_sym_infer,
    ACTIONS(2402), 1,
      anon_sym_keyof,
    ACTIONS(2404), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1291), 1,
      sym_nested_type_identifier,
    STATE(1423), 1,
      sym__tuple_type_body,
    STATE(3021), 1,
      sym_type_parameters,
    STATE(3214), 1,
      sym_nested_identifier,
    STATE(3277), 1,
      sym_formal_parameters,
    ACTIONS(2388), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2396), 2,
      sym_true,
      sym_false,
    STATE(1420), 2,
      sym_string,
      sym__number,
    ACTIONS(2390), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1431), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(1422), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [14325] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(577), 1,
      anon_sym_STAR,
    ACTIONS(589), 1,
      anon_sym_QMARK,
    ACTIONS(591), 1,
      anon_sym_AMP,
    ACTIONS(593), 1,
      anon_sym_PIPE,
    ACTIONS(609), 1,
      anon_sym_infer,
    ACTIONS(611), 1,
      anon_sym_keyof,
    ACTIONS(613), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2420), 1,
      anon_sym_LBRACE,
    ACTIONS(2422), 1,
      anon_sym_typeof,
    ACTIONS(2424), 1,
      anon_sym_LPAREN,
    ACTIONS(2426), 1,
      anon_sym_LBRACK,
    ACTIONS(2428), 1,
      anon_sym_new,
    ACTIONS(2434), 1,
      anon_sym_DQUOTE,
    ACTIONS(2436), 1,
      anon_sym_SQUOTE,
    ACTIONS(2438), 1,
      sym_number,
    ACTIONS(2444), 1,
      sym_readonly,
    ACTIONS(2750), 1,
      sym_identifier,
    ACTIONS(2752), 1,
      sym_this,
    STATE(1983), 1,
      sym_nested_type_identifier,
    STATE(2025), 1,
      sym__tuple_type_body,
    STATE(3157), 1,
      sym_type_parameters,
    STATE(3166), 1,
      sym_nested_identifier,
    STATE(3324), 1,
      sym_formal_parameters,
    ACTIONS(2430), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2442), 2,
      sym_true,
      sym_false,
    STATE(2017), 2,
      sym_string,
      sym__number,
    ACTIONS(2432), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2052), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2018), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [14445] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_STAR,
    ACTIONS(461), 1,
      anon_sym_QMARK,
    ACTIONS(463), 1,
      anon_sym_AMP,
    ACTIONS(465), 1,
      anon_sym_PIPE,
    ACTIONS(495), 1,
      anon_sym_infer,
    ACTIONS(497), 1,
      anon_sym_keyof,
    ACTIONS(499), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(787), 1,
      anon_sym_typeof,
    ACTIONS(789), 1,
      anon_sym_LPAREN,
    ACTIONS(801), 1,
      anon_sym_new,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(821), 1,
      sym_number,
    ACTIONS(911), 1,
      sym_identifier,
    ACTIONS(915), 1,
      anon_sym_LBRACE,
    ACTIONS(921), 1,
      sym_readonly,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2225), 1,
      anon_sym_LBRACK,
    ACTIONS(2582), 1,
      sym_this,
    STATE(442), 1,
      sym__tuple_type_body,
    STATE(1957), 1,
      sym_nested_type_identifier,
    STATE(3048), 1,
      sym_type_parameters,
    STATE(3296), 1,
      sym_formal_parameters,
    STATE(3297), 1,
      sym_nested_identifier,
    ACTIONS(825), 2,
      sym_true,
      sym_false,
    ACTIONS(1655), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(447), 2,
      sym_string,
      sym__number,
    ACTIONS(815), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2747), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(431), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [14565] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(81), 1,
      anon_sym_DQUOTE,
    ACTIONS(83), 1,
      anon_sym_SQUOTE,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2368), 1,
      sym_identifier,
    ACTIONS(2370), 1,
      anon_sym_STAR,
    ACTIONS(2372), 1,
      anon_sym_LBRACE,
    ACTIONS(2374), 1,
      anon_sym_typeof,
    ACTIONS(2376), 1,
      anon_sym_LPAREN,
    ACTIONS(2378), 1,
      anon_sym_LBRACK,
    ACTIONS(2380), 1,
      anon_sym_new,
    ACTIONS(2382), 1,
      anon_sym_QMARK,
    ACTIONS(2384), 1,
      anon_sym_AMP,
    ACTIONS(2386), 1,
      anon_sym_PIPE,
    ACTIONS(2392), 1,
      sym_number,
    ACTIONS(2394), 1,
      sym_this,
    ACTIONS(2398), 1,
      sym_readonly,
    ACTIONS(2400), 1,
      anon_sym_infer,
    ACTIONS(2402), 1,
      anon_sym_keyof,
    ACTIONS(2404), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1291), 1,
      sym_nested_type_identifier,
    STATE(1423), 1,
      sym__tuple_type_body,
    STATE(3021), 1,
      sym_type_parameters,
    STATE(3214), 1,
      sym_nested_identifier,
    STATE(3277), 1,
      sym_formal_parameters,
    ACTIONS(2388), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2396), 2,
      sym_true,
      sym_false,
    STATE(1420), 2,
      sym_string,
      sym__number,
    ACTIONS(2390), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1429), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(1422), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [14685] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(81), 1,
      anon_sym_DQUOTE,
    ACTIONS(83), 1,
      anon_sym_SQUOTE,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2368), 1,
      sym_identifier,
    ACTIONS(2370), 1,
      anon_sym_STAR,
    ACTIONS(2372), 1,
      anon_sym_LBRACE,
    ACTIONS(2374), 1,
      anon_sym_typeof,
    ACTIONS(2376), 1,
      anon_sym_LPAREN,
    ACTIONS(2378), 1,
      anon_sym_LBRACK,
    ACTIONS(2380), 1,
      anon_sym_new,
    ACTIONS(2382), 1,
      anon_sym_QMARK,
    ACTIONS(2384), 1,
      anon_sym_AMP,
    ACTIONS(2386), 1,
      anon_sym_PIPE,
    ACTIONS(2392), 1,
      sym_number,
    ACTIONS(2394), 1,
      sym_this,
    ACTIONS(2398), 1,
      sym_readonly,
    ACTIONS(2400), 1,
      anon_sym_infer,
    ACTIONS(2402), 1,
      anon_sym_keyof,
    ACTIONS(2404), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1291), 1,
      sym_nested_type_identifier,
    STATE(1423), 1,
      sym__tuple_type_body,
    STATE(3021), 1,
      sym_type_parameters,
    STATE(3214), 1,
      sym_nested_identifier,
    STATE(3277), 1,
      sym_formal_parameters,
    ACTIONS(2388), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2396), 2,
      sym_true,
      sym_false,
    STATE(1420), 2,
      sym_string,
      sym__number,
    ACTIONS(2390), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1426), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(1422), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [14805] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(693), 1,
      anon_sym_DQUOTE,
    ACTIONS(695), 1,
      anon_sym_SQUOTE,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2492), 1,
      sym_identifier,
    ACTIONS(2494), 1,
      anon_sym_STAR,
    ACTIONS(2496), 1,
      anon_sym_LBRACE,
    ACTIONS(2498), 1,
      anon_sym_typeof,
    ACTIONS(2500), 1,
      anon_sym_LPAREN,
    ACTIONS(2502), 1,
      anon_sym_LBRACK,
    ACTIONS(2504), 1,
      anon_sym_new,
    ACTIONS(2506), 1,
      anon_sym_QMARK,
    ACTIONS(2508), 1,
      anon_sym_AMP,
    ACTIONS(2510), 1,
      anon_sym_PIPE,
    ACTIONS(2516), 1,
      sym_number,
    ACTIONS(2518), 1,
      sym_this,
    ACTIONS(2522), 1,
      sym_readonly,
    ACTIONS(2524), 1,
      anon_sym_infer,
    ACTIONS(2526), 1,
      anon_sym_keyof,
    ACTIONS(2528), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1497), 1,
      sym_nested_type_identifier,
    STATE(1567), 1,
      sym__tuple_type_body,
    STATE(2997), 1,
      sym_type_parameters,
    STATE(3219), 1,
      sym_nested_identifier,
    STATE(3288), 1,
      sym_formal_parameters,
    ACTIONS(2512), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2520), 2,
      sym_true,
      sym_false,
    STATE(1564), 2,
      sym_string,
      sym__number,
    ACTIONS(2514), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1534), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(1566), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [14925] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_STAR,
    ACTIONS(461), 1,
      anon_sym_QMARK,
    ACTIONS(463), 1,
      anon_sym_AMP,
    ACTIONS(465), 1,
      anon_sym_PIPE,
    ACTIONS(495), 1,
      anon_sym_infer,
    ACTIONS(497), 1,
      anon_sym_keyof,
    ACTIONS(499), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(787), 1,
      anon_sym_typeof,
    ACTIONS(789), 1,
      anon_sym_LPAREN,
    ACTIONS(801), 1,
      anon_sym_new,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(821), 1,
      sym_number,
    ACTIONS(911), 1,
      sym_identifier,
    ACTIONS(915), 1,
      anon_sym_LBRACE,
    ACTIONS(921), 1,
      sym_readonly,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2225), 1,
      anon_sym_LBRACK,
    ACTIONS(2582), 1,
      sym_this,
    STATE(442), 1,
      sym__tuple_type_body,
    STATE(1957), 1,
      sym_nested_type_identifier,
    STATE(3048), 1,
      sym_type_parameters,
    STATE(3296), 1,
      sym_formal_parameters,
    STATE(3297), 1,
      sym_nested_identifier,
    ACTIONS(825), 2,
      sym_true,
      sym_false,
    ACTIONS(1655), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(447), 2,
      sym_string,
      sym__number,
    ACTIONS(815), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2749), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(431), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [15045] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_STAR,
    ACTIONS(461), 1,
      anon_sym_QMARK,
    ACTIONS(463), 1,
      anon_sym_AMP,
    ACTIONS(465), 1,
      anon_sym_PIPE,
    ACTIONS(495), 1,
      anon_sym_infer,
    ACTIONS(497), 1,
      anon_sym_keyof,
    ACTIONS(499), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(787), 1,
      anon_sym_typeof,
    ACTIONS(789), 1,
      anon_sym_LPAREN,
    ACTIONS(801), 1,
      anon_sym_new,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(821), 1,
      sym_number,
    ACTIONS(911), 1,
      sym_identifier,
    ACTIONS(915), 1,
      anon_sym_LBRACE,
    ACTIONS(921), 1,
      sym_readonly,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2458), 1,
      anon_sym_LBRACK,
    ACTIONS(2756), 1,
      sym_this,
    STATE(1957), 1,
      sym_nested_type_identifier,
    STATE(2146), 1,
      sym__tuple_type_body,
    STATE(3048), 1,
      sym_type_parameters,
    STATE(3296), 1,
      sym_formal_parameters,
    STATE(3297), 1,
      sym_nested_identifier,
    ACTIONS(825), 2,
      sym_true,
      sym_false,
    ACTIONS(1655), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(447), 2,
      sym_string,
      sym__number,
    ACTIONS(815), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2794), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2705), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [15165] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_STAR,
    ACTIONS(461), 1,
      anon_sym_QMARK,
    ACTIONS(463), 1,
      anon_sym_AMP,
    ACTIONS(465), 1,
      anon_sym_PIPE,
    ACTIONS(495), 1,
      anon_sym_infer,
    ACTIONS(497), 1,
      anon_sym_keyof,
    ACTIONS(499), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(787), 1,
      anon_sym_typeof,
    ACTIONS(789), 1,
      anon_sym_LPAREN,
    ACTIONS(801), 1,
      anon_sym_new,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(821), 1,
      sym_number,
    ACTIONS(911), 1,
      sym_identifier,
    ACTIONS(915), 1,
      anon_sym_LBRACE,
    ACTIONS(921), 1,
      sym_readonly,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2225), 1,
      anon_sym_LBRACK,
    ACTIONS(2758), 1,
      sym_this,
    STATE(442), 1,
      sym__tuple_type_body,
    STATE(1957), 1,
      sym_nested_type_identifier,
    STATE(3048), 1,
      sym_type_parameters,
    STATE(3296), 1,
      sym_formal_parameters,
    STATE(3297), 1,
      sym_nested_identifier,
    ACTIONS(825), 2,
      sym_true,
      sym_false,
    ACTIONS(1655), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(447), 2,
      sym_string,
      sym__number,
    ACTIONS(815), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2794), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(423), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [15285] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_STAR,
    ACTIONS(495), 1,
      anon_sym_infer,
    ACTIONS(499), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(789), 1,
      anon_sym_LPAREN,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(821), 1,
      sym_number,
    ACTIONS(915), 1,
      anon_sym_LBRACE,
    ACTIONS(921), 1,
      sym_readonly,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2225), 1,
      anon_sym_LBRACK,
    ACTIONS(2582), 1,
      sym_this,
    ACTIONS(2760), 1,
      sym_identifier,
    ACTIONS(2762), 1,
      anon_sym_typeof,
    ACTIONS(2764), 1,
      anon_sym_new,
    ACTIONS(2766), 1,
      anon_sym_QMARK,
    ACTIONS(2768), 1,
      anon_sym_AMP,
    ACTIONS(2770), 1,
      anon_sym_PIPE,
    ACTIONS(2772), 1,
      anon_sym_keyof,
    STATE(442), 1,
      sym__tuple_type_body,
    STATE(494), 1,
      sym_nested_type_identifier,
    STATE(3020), 1,
      sym_type_parameters,
    STATE(3297), 1,
      sym_nested_identifier,
    STATE(3316), 1,
      sym_formal_parameters,
    ACTIONS(825), 2,
      sym_true,
      sym_false,
    ACTIONS(1655), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(447), 2,
      sym_string,
      sym__number,
    ACTIONS(815), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(506), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(431), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [15405] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_STAR,
    ACTIONS(495), 1,
      anon_sym_infer,
    ACTIONS(499), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(789), 1,
      anon_sym_LPAREN,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(821), 1,
      sym_number,
    ACTIONS(915), 1,
      anon_sym_LBRACE,
    ACTIONS(921), 1,
      sym_readonly,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2225), 1,
      anon_sym_LBRACK,
    ACTIONS(2582), 1,
      sym_this,
    ACTIONS(2760), 1,
      sym_identifier,
    ACTIONS(2762), 1,
      anon_sym_typeof,
    ACTIONS(2764), 1,
      anon_sym_new,
    ACTIONS(2766), 1,
      anon_sym_QMARK,
    ACTIONS(2768), 1,
      anon_sym_AMP,
    ACTIONS(2770), 1,
      anon_sym_PIPE,
    ACTIONS(2772), 1,
      anon_sym_keyof,
    STATE(442), 1,
      sym__tuple_type_body,
    STATE(494), 1,
      sym_nested_type_identifier,
    STATE(3020), 1,
      sym_type_parameters,
    STATE(3297), 1,
      sym_nested_identifier,
    STATE(3316), 1,
      sym_formal_parameters,
    ACTIONS(825), 2,
      sym_true,
      sym_false,
    ACTIONS(1655), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(447), 2,
      sym_string,
      sym__number,
    ACTIONS(815), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(444), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(431), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [15525] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_STAR,
    ACTIONS(461), 1,
      anon_sym_QMARK,
    ACTIONS(463), 1,
      anon_sym_AMP,
    ACTIONS(465), 1,
      anon_sym_PIPE,
    ACTIONS(495), 1,
      anon_sym_infer,
    ACTIONS(497), 1,
      anon_sym_keyof,
    ACTIONS(499), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(787), 1,
      anon_sym_typeof,
    ACTIONS(789), 1,
      anon_sym_LPAREN,
    ACTIONS(801), 1,
      anon_sym_new,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(821), 1,
      sym_number,
    ACTIONS(911), 1,
      sym_identifier,
    ACTIONS(915), 1,
      anon_sym_LBRACE,
    ACTIONS(921), 1,
      sym_readonly,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2225), 1,
      anon_sym_LBRACK,
    ACTIONS(2582), 1,
      sym_this,
    STATE(442), 1,
      sym__tuple_type_body,
    STATE(1957), 1,
      sym_nested_type_identifier,
    STATE(3048), 1,
      sym_type_parameters,
    STATE(3296), 1,
      sym_formal_parameters,
    STATE(3297), 1,
      sym_nested_identifier,
    ACTIONS(825), 2,
      sym_true,
      sym_false,
    ACTIONS(1655), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(447), 2,
      sym_string,
      sym__number,
    ACTIONS(815), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(422), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(431), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [15645] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_STAR,
    ACTIONS(461), 1,
      anon_sym_QMARK,
    ACTIONS(463), 1,
      anon_sym_AMP,
    ACTIONS(465), 1,
      anon_sym_PIPE,
    ACTIONS(495), 1,
      anon_sym_infer,
    ACTIONS(497), 1,
      anon_sym_keyof,
    ACTIONS(499), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(787), 1,
      anon_sym_typeof,
    ACTIONS(789), 1,
      anon_sym_LPAREN,
    ACTIONS(801), 1,
      anon_sym_new,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(821), 1,
      sym_number,
    ACTIONS(911), 1,
      sym_identifier,
    ACTIONS(915), 1,
      anon_sym_LBRACE,
    ACTIONS(921), 1,
      sym_readonly,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2225), 1,
      anon_sym_LBRACK,
    ACTIONS(2582), 1,
      sym_this,
    STATE(442), 1,
      sym__tuple_type_body,
    STATE(1957), 1,
      sym_nested_type_identifier,
    STATE(3048), 1,
      sym_type_parameters,
    STATE(3296), 1,
      sym_formal_parameters,
    STATE(3297), 1,
      sym_nested_identifier,
    ACTIONS(825), 2,
      sym_true,
      sym_false,
    ACTIONS(1655), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(447), 2,
      sym_string,
      sym__number,
    ACTIONS(815), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(430), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(431), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [15765] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(577), 1,
      anon_sym_STAR,
    ACTIONS(589), 1,
      anon_sym_QMARK,
    ACTIONS(591), 1,
      anon_sym_AMP,
    ACTIONS(593), 1,
      anon_sym_PIPE,
    ACTIONS(609), 1,
      anon_sym_infer,
    ACTIONS(611), 1,
      anon_sym_keyof,
    ACTIONS(613), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2420), 1,
      anon_sym_LBRACE,
    ACTIONS(2422), 1,
      anon_sym_typeof,
    ACTIONS(2424), 1,
      anon_sym_LPAREN,
    ACTIONS(2426), 1,
      anon_sym_LBRACK,
    ACTIONS(2428), 1,
      anon_sym_new,
    ACTIONS(2434), 1,
      anon_sym_DQUOTE,
    ACTIONS(2436), 1,
      anon_sym_SQUOTE,
    ACTIONS(2438), 1,
      sym_number,
    ACTIONS(2444), 1,
      sym_readonly,
    ACTIONS(2750), 1,
      sym_identifier,
    ACTIONS(2752), 1,
      sym_this,
    STATE(1983), 1,
      sym_nested_type_identifier,
    STATE(2025), 1,
      sym__tuple_type_body,
    STATE(3157), 1,
      sym_type_parameters,
    STATE(3166), 1,
      sym_nested_identifier,
    STATE(3324), 1,
      sym_formal_parameters,
    ACTIONS(2430), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2442), 2,
      sym_true,
      sym_false,
    STATE(2017), 2,
      sym_string,
      sym__number,
    ACTIONS(2432), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2557), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2018), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [15885] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(81), 1,
      anon_sym_DQUOTE,
    ACTIONS(83), 1,
      anon_sym_SQUOTE,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2368), 1,
      sym_identifier,
    ACTIONS(2370), 1,
      anon_sym_STAR,
    ACTIONS(2372), 1,
      anon_sym_LBRACE,
    ACTIONS(2374), 1,
      anon_sym_typeof,
    ACTIONS(2376), 1,
      anon_sym_LPAREN,
    ACTIONS(2378), 1,
      anon_sym_LBRACK,
    ACTIONS(2380), 1,
      anon_sym_new,
    ACTIONS(2382), 1,
      anon_sym_QMARK,
    ACTIONS(2384), 1,
      anon_sym_AMP,
    ACTIONS(2386), 1,
      anon_sym_PIPE,
    ACTIONS(2392), 1,
      sym_number,
    ACTIONS(2394), 1,
      sym_this,
    ACTIONS(2398), 1,
      sym_readonly,
    ACTIONS(2400), 1,
      anon_sym_infer,
    ACTIONS(2402), 1,
      anon_sym_keyof,
    ACTIONS(2404), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1291), 1,
      sym_nested_type_identifier,
    STATE(1423), 1,
      sym__tuple_type_body,
    STATE(3021), 1,
      sym_type_parameters,
    STATE(3214), 1,
      sym_nested_identifier,
    STATE(3277), 1,
      sym_formal_parameters,
    ACTIONS(2388), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2396), 2,
      sym_true,
      sym_false,
    STATE(1420), 2,
      sym_string,
      sym__number,
    ACTIONS(2390), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1510), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(1422), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [16005] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(81), 1,
      anon_sym_DQUOTE,
    ACTIONS(83), 1,
      anon_sym_SQUOTE,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2368), 1,
      sym_identifier,
    ACTIONS(2370), 1,
      anon_sym_STAR,
    ACTIONS(2372), 1,
      anon_sym_LBRACE,
    ACTIONS(2374), 1,
      anon_sym_typeof,
    ACTIONS(2376), 1,
      anon_sym_LPAREN,
    ACTIONS(2378), 1,
      anon_sym_LBRACK,
    ACTIONS(2380), 1,
      anon_sym_new,
    ACTIONS(2382), 1,
      anon_sym_QMARK,
    ACTIONS(2384), 1,
      anon_sym_AMP,
    ACTIONS(2386), 1,
      anon_sym_PIPE,
    ACTIONS(2392), 1,
      sym_number,
    ACTIONS(2394), 1,
      sym_this,
    ACTIONS(2398), 1,
      sym_readonly,
    ACTIONS(2400), 1,
      anon_sym_infer,
    ACTIONS(2402), 1,
      anon_sym_keyof,
    ACTIONS(2404), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1291), 1,
      sym_nested_type_identifier,
    STATE(1423), 1,
      sym__tuple_type_body,
    STATE(3021), 1,
      sym_type_parameters,
    STATE(3214), 1,
      sym_nested_identifier,
    STATE(3277), 1,
      sym_formal_parameters,
    ACTIONS(2388), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2396), 2,
      sym_true,
      sym_false,
    STATE(1420), 2,
      sym_string,
      sym__number,
    ACTIONS(2390), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1509), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(1422), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [16125] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_STAR,
    ACTIONS(461), 1,
      anon_sym_QMARK,
    ACTIONS(463), 1,
      anon_sym_AMP,
    ACTIONS(465), 1,
      anon_sym_PIPE,
    ACTIONS(495), 1,
      anon_sym_infer,
    ACTIONS(497), 1,
      anon_sym_keyof,
    ACTIONS(499), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(787), 1,
      anon_sym_typeof,
    ACTIONS(789), 1,
      anon_sym_LPAREN,
    ACTIONS(801), 1,
      anon_sym_new,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(821), 1,
      sym_number,
    ACTIONS(911), 1,
      sym_identifier,
    ACTIONS(915), 1,
      anon_sym_LBRACE,
    ACTIONS(919), 1,
      sym_this,
    ACTIONS(921), 1,
      sym_readonly,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2225), 1,
      anon_sym_LBRACK,
    STATE(443), 1,
      sym__tuple_type_body,
    STATE(1957), 1,
      sym_nested_type_identifier,
    STATE(3048), 1,
      sym_type_parameters,
    STATE(3296), 1,
      sym_formal_parameters,
    STATE(3297), 1,
      sym_nested_identifier,
    ACTIONS(825), 2,
      sym_true,
      sym_false,
    ACTIONS(1655), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(447), 2,
      sym_string,
      sym__number,
    ACTIONS(815), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2794), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2659), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [16245] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(81), 1,
      anon_sym_DQUOTE,
    ACTIONS(83), 1,
      anon_sym_SQUOTE,
    ACTIONS(463), 1,
      anon_sym_AMP,
    ACTIONS(465), 1,
      anon_sym_PIPE,
    ACTIONS(495), 1,
      anon_sym_infer,
    ACTIONS(801), 1,
      anon_sym_new,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2368), 1,
      sym_identifier,
    ACTIONS(2370), 1,
      anon_sym_STAR,
    ACTIONS(2372), 1,
      anon_sym_LBRACE,
    ACTIONS(2374), 1,
      anon_sym_typeof,
    ACTIONS(2376), 1,
      anon_sym_LPAREN,
    ACTIONS(2378), 1,
      anon_sym_LBRACK,
    ACTIONS(2382), 1,
      anon_sym_QMARK,
    ACTIONS(2392), 1,
      sym_number,
    ACTIONS(2398), 1,
      sym_readonly,
    ACTIONS(2402), 1,
      anon_sym_keyof,
    ACTIONS(2404), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2774), 1,
      sym_this,
    STATE(1291), 1,
      sym_nested_type_identifier,
    STATE(1423), 1,
      sym__tuple_type_body,
    STATE(3048), 1,
      sym_type_parameters,
    STATE(3214), 1,
      sym_nested_identifier,
    STATE(3296), 1,
      sym_formal_parameters,
    ACTIONS(2388), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2396), 2,
      sym_true,
      sym_false,
    STATE(1420), 2,
      sym_string,
      sym__number,
    ACTIONS(2390), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2775), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(1508), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [16365] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2187), 1,
      anon_sym_LT,
    ACTIONS(2211), 1,
      anon_sym_EQ,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2219), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2253), 1,
      anon_sym_EQ_GT,
    STATE(1069), 1,
      sym_type_arguments,
    STATE(1160), 1,
      sym_arguments,
    ACTIONS(2213), 11,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2221), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2209), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [16449] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_STAR,
    ACTIONS(461), 1,
      anon_sym_QMARK,
    ACTIONS(463), 1,
      anon_sym_AMP,
    ACTIONS(465), 1,
      anon_sym_PIPE,
    ACTIONS(495), 1,
      anon_sym_infer,
    ACTIONS(497), 1,
      anon_sym_keyof,
    ACTIONS(499), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(787), 1,
      anon_sym_typeof,
    ACTIONS(789), 1,
      anon_sym_LPAREN,
    ACTIONS(801), 1,
      anon_sym_new,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(821), 1,
      sym_number,
    ACTIONS(911), 1,
      sym_identifier,
    ACTIONS(915), 1,
      anon_sym_LBRACE,
    ACTIONS(921), 1,
      sym_readonly,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2225), 1,
      anon_sym_LBRACK,
    ACTIONS(2582), 1,
      sym_this,
    STATE(442), 1,
      sym__tuple_type_body,
    STATE(1957), 1,
      sym_nested_type_identifier,
    STATE(3048), 1,
      sym_type_parameters,
    STATE(3296), 1,
      sym_formal_parameters,
    STATE(3297), 1,
      sym_nested_identifier,
    ACTIONS(825), 2,
      sym_true,
      sym_false,
    ACTIONS(1655), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(447), 2,
      sym_string,
      sym__number,
    ACTIONS(815), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2678), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(431), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [16569] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(799), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(961), 1,
      anon_sym_EQ,
    ACTIONS(963), 1,
      anon_sym_EQ_GT,
    ACTIONS(1639), 1,
      anon_sym_LBRACK,
    ACTIONS(1641), 1,
      anon_sym_DOT,
    ACTIONS(1189), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(2327), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(813), 12,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(803), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(780), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [16649] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_STAR,
    ACTIONS(461), 1,
      anon_sym_QMARK,
    ACTIONS(463), 1,
      anon_sym_AMP,
    ACTIONS(465), 1,
      anon_sym_PIPE,
    ACTIONS(495), 1,
      anon_sym_infer,
    ACTIONS(497), 1,
      anon_sym_keyof,
    ACTIONS(499), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(787), 1,
      anon_sym_typeof,
    ACTIONS(789), 1,
      anon_sym_LPAREN,
    ACTIONS(801), 1,
      anon_sym_new,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(821), 1,
      sym_number,
    ACTIONS(911), 1,
      sym_identifier,
    ACTIONS(915), 1,
      anon_sym_LBRACE,
    ACTIONS(921), 1,
      sym_readonly,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2225), 1,
      anon_sym_LBRACK,
    ACTIONS(2582), 1,
      sym_this,
    STATE(442), 1,
      sym__tuple_type_body,
    STATE(1957), 1,
      sym_nested_type_identifier,
    STATE(3048), 1,
      sym_type_parameters,
    STATE(3296), 1,
      sym_formal_parameters,
    STATE(3297), 1,
      sym_nested_identifier,
    ACTIONS(825), 2,
      sym_true,
      sym_false,
    ACTIONS(1655), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(447), 2,
      sym_string,
      sym__number,
    ACTIONS(815), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(445), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(431), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [16769] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(475), 1,
      anon_sym_DQUOTE,
    ACTIONS(477), 1,
      anon_sym_SQUOTE,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2330), 1,
      sym_identifier,
    ACTIONS(2332), 1,
      anon_sym_STAR,
    ACTIONS(2334), 1,
      anon_sym_LBRACE,
    ACTIONS(2336), 1,
      anon_sym_typeof,
    ACTIONS(2338), 1,
      anon_sym_LPAREN,
    ACTIONS(2340), 1,
      anon_sym_LBRACK,
    ACTIONS(2342), 1,
      anon_sym_new,
    ACTIONS(2344), 1,
      anon_sym_QMARK,
    ACTIONS(2346), 1,
      anon_sym_AMP,
    ACTIONS(2348), 1,
      anon_sym_PIPE,
    ACTIONS(2354), 1,
      sym_number,
    ACTIONS(2356), 1,
      sym_this,
    ACTIONS(2360), 1,
      sym_readonly,
    ACTIONS(2362), 1,
      anon_sym_infer,
    ACTIONS(2364), 1,
      anon_sym_keyof,
    ACTIONS(2366), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1028), 1,
      sym_nested_type_identifier,
    STATE(1082), 1,
      sym__tuple_type_body,
    STATE(3078), 1,
      sym_type_parameters,
    STATE(3195), 1,
      sym_nested_identifier,
    STATE(3385), 1,
      sym_formal_parameters,
    ACTIONS(2350), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2358), 2,
      sym_true,
      sym_false,
    STATE(1087), 2,
      sym_string,
      sym__number,
    ACTIONS(2352), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1098), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(1084), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [16889] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(81), 1,
      anon_sym_DQUOTE,
    ACTIONS(83), 1,
      anon_sym_SQUOTE,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2368), 1,
      sym_identifier,
    ACTIONS(2370), 1,
      anon_sym_STAR,
    ACTIONS(2372), 1,
      anon_sym_LBRACE,
    ACTIONS(2374), 1,
      anon_sym_typeof,
    ACTIONS(2376), 1,
      anon_sym_LPAREN,
    ACTIONS(2378), 1,
      anon_sym_LBRACK,
    ACTIONS(2380), 1,
      anon_sym_new,
    ACTIONS(2382), 1,
      anon_sym_QMARK,
    ACTIONS(2384), 1,
      anon_sym_AMP,
    ACTIONS(2386), 1,
      anon_sym_PIPE,
    ACTIONS(2392), 1,
      sym_number,
    ACTIONS(2394), 1,
      sym_this,
    ACTIONS(2398), 1,
      sym_readonly,
    ACTIONS(2400), 1,
      anon_sym_infer,
    ACTIONS(2402), 1,
      anon_sym_keyof,
    ACTIONS(2404), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1291), 1,
      sym_nested_type_identifier,
    STATE(1423), 1,
      sym__tuple_type_body,
    STATE(3021), 1,
      sym_type_parameters,
    STATE(3214), 1,
      sym_nested_identifier,
    STATE(3277), 1,
      sym_formal_parameters,
    ACTIONS(2388), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2396), 2,
      sym_true,
      sym_false,
    STATE(1420), 2,
      sym_string,
      sym__number,
    ACTIONS(2390), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1363), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(1422), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [17009] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_STAR,
    ACTIONS(461), 1,
      anon_sym_QMARK,
    ACTIONS(463), 1,
      anon_sym_AMP,
    ACTIONS(465), 1,
      anon_sym_PIPE,
    ACTIONS(495), 1,
      anon_sym_infer,
    ACTIONS(497), 1,
      anon_sym_keyof,
    ACTIONS(499), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(787), 1,
      anon_sym_typeof,
    ACTIONS(789), 1,
      anon_sym_LPAREN,
    ACTIONS(801), 1,
      anon_sym_new,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(821), 1,
      sym_number,
    ACTIONS(911), 1,
      sym_identifier,
    ACTIONS(915), 1,
      anon_sym_LBRACE,
    ACTIONS(921), 1,
      sym_readonly,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2225), 1,
      anon_sym_LBRACK,
    ACTIONS(2582), 1,
      sym_this,
    STATE(442), 1,
      sym__tuple_type_body,
    STATE(1957), 1,
      sym_nested_type_identifier,
    STATE(3048), 1,
      sym_type_parameters,
    STATE(3296), 1,
      sym_formal_parameters,
    STATE(3297), 1,
      sym_nested_identifier,
    ACTIONS(825), 2,
      sym_true,
      sym_false,
    ACTIONS(1655), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(447), 2,
      sym_string,
      sym__number,
    ACTIONS(815), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2626), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(431), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [17129] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_STAR,
    ACTIONS(461), 1,
      anon_sym_QMARK,
    ACTIONS(463), 1,
      anon_sym_AMP,
    ACTIONS(465), 1,
      anon_sym_PIPE,
    ACTIONS(495), 1,
      anon_sym_infer,
    ACTIONS(497), 1,
      anon_sym_keyof,
    ACTIONS(499), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(787), 1,
      anon_sym_typeof,
    ACTIONS(789), 1,
      anon_sym_LPAREN,
    ACTIONS(801), 1,
      anon_sym_new,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(821), 1,
      sym_number,
    ACTIONS(911), 1,
      sym_identifier,
    ACTIONS(915), 1,
      anon_sym_LBRACE,
    ACTIONS(921), 1,
      sym_readonly,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2225), 1,
      anon_sym_LBRACK,
    ACTIONS(2582), 1,
      sym_this,
    STATE(442), 1,
      sym__tuple_type_body,
    STATE(1957), 1,
      sym_nested_type_identifier,
    STATE(3048), 1,
      sym_type_parameters,
    STATE(3296), 1,
      sym_formal_parameters,
    STATE(3297), 1,
      sym_nested_identifier,
    ACTIONS(825), 2,
      sym_true,
      sym_false,
    ACTIONS(1655), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(447), 2,
      sym_string,
      sym__number,
    ACTIONS(815), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2298), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(431), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [17249] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_STAR,
    ACTIONS(461), 1,
      anon_sym_QMARK,
    ACTIONS(463), 1,
      anon_sym_AMP,
    ACTIONS(465), 1,
      anon_sym_PIPE,
    ACTIONS(495), 1,
      anon_sym_infer,
    ACTIONS(497), 1,
      anon_sym_keyof,
    ACTIONS(499), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(787), 1,
      anon_sym_typeof,
    ACTIONS(789), 1,
      anon_sym_LPAREN,
    ACTIONS(801), 1,
      anon_sym_new,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(821), 1,
      sym_number,
    ACTIONS(911), 1,
      sym_identifier,
    ACTIONS(915), 1,
      anon_sym_LBRACE,
    ACTIONS(921), 1,
      sym_readonly,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2225), 1,
      anon_sym_LBRACK,
    ACTIONS(2582), 1,
      sym_this,
    STATE(442), 1,
      sym__tuple_type_body,
    STATE(1957), 1,
      sym_nested_type_identifier,
    STATE(3048), 1,
      sym_type_parameters,
    STATE(3296), 1,
      sym_formal_parameters,
    STATE(3297), 1,
      sym_nested_identifier,
    ACTIONS(825), 2,
      sym_true,
      sym_false,
    ACTIONS(1655), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(447), 2,
      sym_string,
      sym__number,
    ACTIONS(815), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2712), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(431), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [17369] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_STAR,
    ACTIONS(461), 1,
      anon_sym_QMARK,
    ACTIONS(463), 1,
      anon_sym_AMP,
    ACTIONS(465), 1,
      anon_sym_PIPE,
    ACTIONS(495), 1,
      anon_sym_infer,
    ACTIONS(497), 1,
      anon_sym_keyof,
    ACTIONS(499), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(787), 1,
      anon_sym_typeof,
    ACTIONS(789), 1,
      anon_sym_LPAREN,
    ACTIONS(801), 1,
      anon_sym_new,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(821), 1,
      sym_number,
    ACTIONS(911), 1,
      sym_identifier,
    ACTIONS(915), 1,
      anon_sym_LBRACE,
    ACTIONS(921), 1,
      sym_readonly,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2225), 1,
      anon_sym_LBRACK,
    ACTIONS(2582), 1,
      sym_this,
    STATE(442), 1,
      sym__tuple_type_body,
    STATE(1957), 1,
      sym_nested_type_identifier,
    STATE(3048), 1,
      sym_type_parameters,
    STATE(3296), 1,
      sym_formal_parameters,
    STATE(3297), 1,
      sym_nested_identifier,
    ACTIONS(825), 2,
      sym_true,
      sym_false,
    ACTIONS(1655), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(447), 2,
      sym_string,
      sym__number,
    ACTIONS(815), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(429), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(431), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [17489] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(463), 1,
      anon_sym_AMP,
    ACTIONS(465), 1,
      anon_sym_PIPE,
    ACTIONS(495), 1,
      anon_sym_infer,
    ACTIONS(693), 1,
      anon_sym_DQUOTE,
    ACTIONS(695), 1,
      anon_sym_SQUOTE,
    ACTIONS(801), 1,
      anon_sym_new,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2492), 1,
      sym_identifier,
    ACTIONS(2494), 1,
      anon_sym_STAR,
    ACTIONS(2496), 1,
      anon_sym_LBRACE,
    ACTIONS(2498), 1,
      anon_sym_typeof,
    ACTIONS(2500), 1,
      anon_sym_LPAREN,
    ACTIONS(2502), 1,
      anon_sym_LBRACK,
    ACTIONS(2506), 1,
      anon_sym_QMARK,
    ACTIONS(2516), 1,
      sym_number,
    ACTIONS(2522), 1,
      sym_readonly,
    ACTIONS(2526), 1,
      anon_sym_keyof,
    ACTIONS(2528), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2776), 1,
      sym_this,
    STATE(1497), 1,
      sym_nested_type_identifier,
    STATE(1567), 1,
      sym__tuple_type_body,
    STATE(3048), 1,
      sym_type_parameters,
    STATE(3219), 1,
      sym_nested_identifier,
    STATE(3296), 1,
      sym_formal_parameters,
    ACTIONS(2512), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2520), 2,
      sym_true,
      sym_false,
    STATE(1564), 2,
      sym_string,
      sym__number,
    ACTIONS(2514), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2753), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(1618), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [17609] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_STAR,
    ACTIONS(461), 1,
      anon_sym_QMARK,
    ACTIONS(463), 1,
      anon_sym_AMP,
    ACTIONS(465), 1,
      anon_sym_PIPE,
    ACTIONS(495), 1,
      anon_sym_infer,
    ACTIONS(497), 1,
      anon_sym_keyof,
    ACTIONS(499), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(787), 1,
      anon_sym_typeof,
    ACTIONS(789), 1,
      anon_sym_LPAREN,
    ACTIONS(801), 1,
      anon_sym_new,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(821), 1,
      sym_number,
    ACTIONS(911), 1,
      sym_identifier,
    ACTIONS(915), 1,
      anon_sym_LBRACE,
    ACTIONS(921), 1,
      sym_readonly,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2225), 1,
      anon_sym_LBRACK,
    ACTIONS(2582), 1,
      sym_this,
    STATE(442), 1,
      sym__tuple_type_body,
    STATE(1957), 1,
      sym_nested_type_identifier,
    STATE(3048), 1,
      sym_type_parameters,
    STATE(3296), 1,
      sym_formal_parameters,
    STATE(3297), 1,
      sym_nested_identifier,
    ACTIONS(825), 2,
      sym_true,
      sym_false,
    ACTIONS(1655), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(447), 2,
      sym_string,
      sym__number,
    ACTIONS(815), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(424), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(431), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [17729] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(693), 1,
      anon_sym_DQUOTE,
    ACTIONS(695), 1,
      anon_sym_SQUOTE,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2492), 1,
      sym_identifier,
    ACTIONS(2494), 1,
      anon_sym_STAR,
    ACTIONS(2496), 1,
      anon_sym_LBRACE,
    ACTIONS(2498), 1,
      anon_sym_typeof,
    ACTIONS(2500), 1,
      anon_sym_LPAREN,
    ACTIONS(2502), 1,
      anon_sym_LBRACK,
    ACTIONS(2504), 1,
      anon_sym_new,
    ACTIONS(2506), 1,
      anon_sym_QMARK,
    ACTIONS(2508), 1,
      anon_sym_AMP,
    ACTIONS(2510), 1,
      anon_sym_PIPE,
    ACTIONS(2516), 1,
      sym_number,
    ACTIONS(2518), 1,
      sym_this,
    ACTIONS(2522), 1,
      sym_readonly,
    ACTIONS(2524), 1,
      anon_sym_infer,
    ACTIONS(2526), 1,
      anon_sym_keyof,
    ACTIONS(2528), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1497), 1,
      sym_nested_type_identifier,
    STATE(1567), 1,
      sym__tuple_type_body,
    STATE(2997), 1,
      sym_type_parameters,
    STATE(3219), 1,
      sym_nested_identifier,
    STATE(3288), 1,
      sym_formal_parameters,
    ACTIONS(2512), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2520), 2,
      sym_true,
      sym_false,
    STATE(1564), 2,
      sym_string,
      sym__number,
    ACTIONS(2514), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1621), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(1566), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [17849] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2219), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2231), 1,
      anon_sym_EQ,
    ACTIONS(2238), 1,
      anon_sym_EQ_GT,
    ACTIONS(2781), 1,
      anon_sym_COLON,
    ACTIONS(2778), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    ACTIONS(1113), 10,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2221), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1111), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [17929] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(693), 1,
      anon_sym_DQUOTE,
    ACTIONS(695), 1,
      anon_sym_SQUOTE,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2492), 1,
      sym_identifier,
    ACTIONS(2494), 1,
      anon_sym_STAR,
    ACTIONS(2496), 1,
      anon_sym_LBRACE,
    ACTIONS(2498), 1,
      anon_sym_typeof,
    ACTIONS(2500), 1,
      anon_sym_LPAREN,
    ACTIONS(2502), 1,
      anon_sym_LBRACK,
    ACTIONS(2504), 1,
      anon_sym_new,
    ACTIONS(2506), 1,
      anon_sym_QMARK,
    ACTIONS(2508), 1,
      anon_sym_AMP,
    ACTIONS(2510), 1,
      anon_sym_PIPE,
    ACTIONS(2516), 1,
      sym_number,
    ACTIONS(2518), 1,
      sym_this,
    ACTIONS(2522), 1,
      sym_readonly,
    ACTIONS(2524), 1,
      anon_sym_infer,
    ACTIONS(2526), 1,
      anon_sym_keyof,
    ACTIONS(2528), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1497), 1,
      sym_nested_type_identifier,
    STATE(1567), 1,
      sym__tuple_type_body,
    STATE(2997), 1,
      sym_type_parameters,
    STATE(3219), 1,
      sym_nested_identifier,
    STATE(3288), 1,
      sym_formal_parameters,
    ACTIONS(2512), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2520), 2,
      sym_true,
      sym_false,
    STATE(1564), 2,
      sym_string,
      sym__number,
    ACTIONS(2514), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1626), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(1566), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [18049] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_STAR,
    ACTIONS(461), 1,
      anon_sym_QMARK,
    ACTIONS(463), 1,
      anon_sym_AMP,
    ACTIONS(465), 1,
      anon_sym_PIPE,
    ACTIONS(495), 1,
      anon_sym_infer,
    ACTIONS(497), 1,
      anon_sym_keyof,
    ACTIONS(499), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(787), 1,
      anon_sym_typeof,
    ACTIONS(789), 1,
      anon_sym_LPAREN,
    ACTIONS(801), 1,
      anon_sym_new,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(821), 1,
      sym_number,
    ACTIONS(911), 1,
      sym_identifier,
    ACTIONS(915), 1,
      anon_sym_LBRACE,
    ACTIONS(921), 1,
      sym_readonly,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2225), 1,
      anon_sym_LBRACK,
    ACTIONS(2582), 1,
      sym_this,
    STATE(442), 1,
      sym__tuple_type_body,
    STATE(1957), 1,
      sym_nested_type_identifier,
    STATE(3048), 1,
      sym_type_parameters,
    STATE(3296), 1,
      sym_formal_parameters,
    STATE(3297), 1,
      sym_nested_identifier,
    ACTIONS(825), 2,
      sym_true,
      sym_false,
    ACTIONS(1655), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(447), 2,
      sym_string,
      sym__number,
    ACTIONS(815), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1965), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(431), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [18169] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2313), 1,
      anon_sym_LBRACK,
    ACTIONS(2318), 1,
      anon_sym_DOT,
    ACTIONS(2320), 1,
      anon_sym_EQ_GT,
    ACTIONS(2322), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2406), 1,
      anon_sym_EQ,
    ACTIONS(1113), 14,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2221), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1111), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [18245] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_STAR,
    ACTIONS(461), 1,
      anon_sym_QMARK,
    ACTIONS(463), 1,
      anon_sym_AMP,
    ACTIONS(465), 1,
      anon_sym_PIPE,
    ACTIONS(495), 1,
      anon_sym_infer,
    ACTIONS(497), 1,
      anon_sym_keyof,
    ACTIONS(499), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(787), 1,
      anon_sym_typeof,
    ACTIONS(789), 1,
      anon_sym_LPAREN,
    ACTIONS(801), 1,
      anon_sym_new,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(821), 1,
      sym_number,
    ACTIONS(911), 1,
      sym_identifier,
    ACTIONS(915), 1,
      anon_sym_LBRACE,
    ACTIONS(921), 1,
      sym_readonly,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2225), 1,
      anon_sym_LBRACK,
    ACTIONS(2582), 1,
      sym_this,
    STATE(442), 1,
      sym__tuple_type_body,
    STATE(1957), 1,
      sym_nested_type_identifier,
    STATE(3048), 1,
      sym_type_parameters,
    STATE(3296), 1,
      sym_formal_parameters,
    STATE(3297), 1,
      sym_nested_identifier,
    ACTIONS(825), 2,
      sym_true,
      sym_false,
    ACTIONS(1655), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(447), 2,
      sym_string,
      sym__number,
    ACTIONS(815), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(444), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(431), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [18365] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2278), 23,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2280), 33,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [18429] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1015), 1,
      anon_sym_extends,
    ACTIONS(2299), 1,
      anon_sym_LT,
    ACTIONS(2302), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
    ACTIONS(2305), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2266), 19,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2268), 29,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [18501] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_STAR,
    ACTIONS(461), 1,
      anon_sym_QMARK,
    ACTIONS(463), 1,
      anon_sym_AMP,
    ACTIONS(465), 1,
      anon_sym_PIPE,
    ACTIONS(495), 1,
      anon_sym_infer,
    ACTIONS(497), 1,
      anon_sym_keyof,
    ACTIONS(499), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(787), 1,
      anon_sym_typeof,
    ACTIONS(789), 1,
      anon_sym_LPAREN,
    ACTIONS(801), 1,
      anon_sym_new,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(821), 1,
      sym_number,
    ACTIONS(911), 1,
      sym_identifier,
    ACTIONS(915), 1,
      anon_sym_LBRACE,
    ACTIONS(921), 1,
      sym_readonly,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2225), 1,
      anon_sym_LBRACK,
    ACTIONS(2582), 1,
      sym_this,
    STATE(442), 1,
      sym__tuple_type_body,
    STATE(1957), 1,
      sym_nested_type_identifier,
    STATE(3048), 1,
      sym_type_parameters,
    STATE(3296), 1,
      sym_formal_parameters,
    STATE(3297), 1,
      sym_nested_identifier,
    ACTIONS(825), 2,
      sym_true,
      sym_false,
    ACTIONS(1655), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(447), 2,
      sym_string,
      sym__number,
    ACTIONS(815), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2339), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(431), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [18621] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_STAR,
    ACTIONS(461), 1,
      anon_sym_QMARK,
    ACTIONS(463), 1,
      anon_sym_AMP,
    ACTIONS(465), 1,
      anon_sym_PIPE,
    ACTIONS(495), 1,
      anon_sym_infer,
    ACTIONS(497), 1,
      anon_sym_keyof,
    ACTIONS(499), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(787), 1,
      anon_sym_typeof,
    ACTIONS(789), 1,
      anon_sym_LPAREN,
    ACTIONS(801), 1,
      anon_sym_new,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(821), 1,
      sym_number,
    ACTIONS(911), 1,
      sym_identifier,
    ACTIONS(915), 1,
      anon_sym_LBRACE,
    ACTIONS(921), 1,
      sym_readonly,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2225), 1,
      anon_sym_LBRACK,
    ACTIONS(2582), 1,
      sym_this,
    STATE(442), 1,
      sym__tuple_type_body,
    STATE(1957), 1,
      sym_nested_type_identifier,
    STATE(3048), 1,
      sym_type_parameters,
    STATE(3296), 1,
      sym_formal_parameters,
    STATE(3297), 1,
      sym_nested_identifier,
    ACTIONS(825), 2,
      sym_true,
      sym_false,
    ACTIONS(1655), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(447), 2,
      sym_string,
      sym__number,
    ACTIONS(815), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2423), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(431), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [18741] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(799), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(961), 1,
      anon_sym_EQ,
    ACTIONS(963), 1,
      anon_sym_EQ_GT,
    ACTIONS(1639), 1,
      anon_sym_LBRACK,
    ACTIONS(1641), 1,
      anon_sym_DOT,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2187), 1,
      anon_sym_LT,
    STATE(1073), 1,
      sym_type_arguments,
    STATE(1174), 1,
      sym_arguments,
    ACTIONS(1637), 11,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(803), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1635), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [18825] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_STAR,
    ACTIONS(461), 1,
      anon_sym_QMARK,
    ACTIONS(463), 1,
      anon_sym_AMP,
    ACTIONS(465), 1,
      anon_sym_PIPE,
    ACTIONS(495), 1,
      anon_sym_infer,
    ACTIONS(497), 1,
      anon_sym_keyof,
    ACTIONS(499), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(787), 1,
      anon_sym_typeof,
    ACTIONS(789), 1,
      anon_sym_LPAREN,
    ACTIONS(801), 1,
      anon_sym_new,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(821), 1,
      sym_number,
    ACTIONS(911), 1,
      sym_identifier,
    ACTIONS(915), 1,
      anon_sym_LBRACE,
    ACTIONS(921), 1,
      sym_readonly,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2225), 1,
      anon_sym_LBRACK,
    ACTIONS(2582), 1,
      sym_this,
    STATE(442), 1,
      sym__tuple_type_body,
    STATE(1957), 1,
      sym_nested_type_identifier,
    STATE(3048), 1,
      sym_type_parameters,
    STATE(3296), 1,
      sym_formal_parameters,
    STATE(3297), 1,
      sym_nested_identifier,
    ACTIONS(825), 2,
      sym_true,
      sym_false,
    ACTIONS(1655), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(447), 2,
      sym_string,
      sym__number,
    ACTIONS(815), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2273), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(431), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [18945] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(577), 1,
      anon_sym_STAR,
    ACTIONS(589), 1,
      anon_sym_QMARK,
    ACTIONS(591), 1,
      anon_sym_AMP,
    ACTIONS(593), 1,
      anon_sym_PIPE,
    ACTIONS(609), 1,
      anon_sym_infer,
    ACTIONS(611), 1,
      anon_sym_keyof,
    ACTIONS(613), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2420), 1,
      anon_sym_LBRACE,
    ACTIONS(2422), 1,
      anon_sym_typeof,
    ACTIONS(2424), 1,
      anon_sym_LPAREN,
    ACTIONS(2426), 1,
      anon_sym_LBRACK,
    ACTIONS(2428), 1,
      anon_sym_new,
    ACTIONS(2434), 1,
      anon_sym_DQUOTE,
    ACTIONS(2436), 1,
      anon_sym_SQUOTE,
    ACTIONS(2438), 1,
      sym_number,
    ACTIONS(2444), 1,
      sym_readonly,
    ACTIONS(2750), 1,
      sym_identifier,
    ACTIONS(2752), 1,
      sym_this,
    STATE(1983), 1,
      sym_nested_type_identifier,
    STATE(2025), 1,
      sym__tuple_type_body,
    STATE(3157), 1,
      sym_type_parameters,
    STATE(3166), 1,
      sym_nested_identifier,
    STATE(3324), 1,
      sym_formal_parameters,
    ACTIONS(2430), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2442), 2,
      sym_true,
      sym_false,
    STATE(2017), 2,
      sym_string,
      sym__number,
    ACTIONS(2432), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2020), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2018), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [19065] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(923), 1,
      anon_sym_EQ,
    ACTIONS(929), 1,
      anon_sym_EQ_GT,
    ACTIONS(931), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1223), 1,
      anon_sym_LBRACK,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1290), 1,
      anon_sym_COLON,
    ACTIONS(813), 13,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(803), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(780), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [19143] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_STAR,
    ACTIONS(461), 1,
      anon_sym_QMARK,
    ACTIONS(463), 1,
      anon_sym_AMP,
    ACTIONS(465), 1,
      anon_sym_PIPE,
    ACTIONS(495), 1,
      anon_sym_infer,
    ACTIONS(497), 1,
      anon_sym_keyof,
    ACTIONS(499), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(787), 1,
      anon_sym_typeof,
    ACTIONS(789), 1,
      anon_sym_LPAREN,
    ACTIONS(801), 1,
      anon_sym_new,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(821), 1,
      sym_number,
    ACTIONS(911), 1,
      sym_identifier,
    ACTIONS(915), 1,
      anon_sym_LBRACE,
    ACTIONS(921), 1,
      sym_readonly,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2225), 1,
      anon_sym_LBRACK,
    ACTIONS(2582), 1,
      sym_this,
    STATE(442), 1,
      sym__tuple_type_body,
    STATE(1957), 1,
      sym_nested_type_identifier,
    STATE(3048), 1,
      sym_type_parameters,
    STATE(3296), 1,
      sym_formal_parameters,
    STATE(3297), 1,
      sym_nested_identifier,
    ACTIONS(825), 2,
      sym_true,
      sym_false,
    ACTIONS(1655), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(447), 2,
      sym_string,
      sym__number,
    ACTIONS(815), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1962), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(431), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [19263] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_STAR,
    ACTIONS(461), 1,
      anon_sym_QMARK,
    ACTIONS(463), 1,
      anon_sym_AMP,
    ACTIONS(465), 1,
      anon_sym_PIPE,
    ACTIONS(495), 1,
      anon_sym_infer,
    ACTIONS(497), 1,
      anon_sym_keyof,
    ACTIONS(499), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(787), 1,
      anon_sym_typeof,
    ACTIONS(789), 1,
      anon_sym_LPAREN,
    ACTIONS(801), 1,
      anon_sym_new,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(821), 1,
      sym_number,
    ACTIONS(911), 1,
      sym_identifier,
    ACTIONS(915), 1,
      anon_sym_LBRACE,
    ACTIONS(921), 1,
      sym_readonly,
    ACTIONS(1077), 1,
      sym_this,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2426), 1,
      anon_sym_LBRACK,
    STATE(1957), 1,
      sym_nested_type_identifier,
    STATE(2053), 1,
      sym__tuple_type_body,
    STATE(3048), 1,
      sym_type_parameters,
    STATE(3296), 1,
      sym_formal_parameters,
    STATE(3297), 1,
      sym_nested_identifier,
    ACTIONS(825), 2,
      sym_true,
      sym_false,
    ACTIONS(1655), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(447), 2,
      sym_string,
      sym__number,
    ACTIONS(815), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2794), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2692), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [19383] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(475), 1,
      anon_sym_DQUOTE,
    ACTIONS(477), 1,
      anon_sym_SQUOTE,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2330), 1,
      sym_identifier,
    ACTIONS(2332), 1,
      anon_sym_STAR,
    ACTIONS(2334), 1,
      anon_sym_LBRACE,
    ACTIONS(2336), 1,
      anon_sym_typeof,
    ACTIONS(2338), 1,
      anon_sym_LPAREN,
    ACTIONS(2340), 1,
      anon_sym_LBRACK,
    ACTIONS(2342), 1,
      anon_sym_new,
    ACTIONS(2344), 1,
      anon_sym_QMARK,
    ACTIONS(2346), 1,
      anon_sym_AMP,
    ACTIONS(2348), 1,
      anon_sym_PIPE,
    ACTIONS(2354), 1,
      sym_number,
    ACTIONS(2356), 1,
      sym_this,
    ACTIONS(2360), 1,
      sym_readonly,
    ACTIONS(2362), 1,
      anon_sym_infer,
    ACTIONS(2364), 1,
      anon_sym_keyof,
    ACTIONS(2366), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1028), 1,
      sym_nested_type_identifier,
    STATE(1082), 1,
      sym__tuple_type_body,
    STATE(3078), 1,
      sym_type_parameters,
    STATE(3195), 1,
      sym_nested_identifier,
    STATE(3385), 1,
      sym_formal_parameters,
    ACTIONS(2350), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2358), 2,
      sym_true,
      sym_false,
    STATE(1087), 2,
      sym_string,
      sym__number,
    ACTIONS(2352), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1067), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(1084), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [19503] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(577), 1,
      anon_sym_STAR,
    ACTIONS(589), 1,
      anon_sym_QMARK,
    ACTIONS(591), 1,
      anon_sym_AMP,
    ACTIONS(593), 1,
      anon_sym_PIPE,
    ACTIONS(609), 1,
      anon_sym_infer,
    ACTIONS(611), 1,
      anon_sym_keyof,
    ACTIONS(613), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2420), 1,
      anon_sym_LBRACE,
    ACTIONS(2422), 1,
      anon_sym_typeof,
    ACTIONS(2424), 1,
      anon_sym_LPAREN,
    ACTIONS(2426), 1,
      anon_sym_LBRACK,
    ACTIONS(2428), 1,
      anon_sym_new,
    ACTIONS(2434), 1,
      anon_sym_DQUOTE,
    ACTIONS(2436), 1,
      anon_sym_SQUOTE,
    ACTIONS(2438), 1,
      sym_number,
    ACTIONS(2444), 1,
      sym_readonly,
    ACTIONS(2750), 1,
      sym_identifier,
    ACTIONS(2752), 1,
      sym_this,
    STATE(1983), 1,
      sym_nested_type_identifier,
    STATE(2025), 1,
      sym__tuple_type_body,
    STATE(3157), 1,
      sym_type_parameters,
    STATE(3166), 1,
      sym_nested_identifier,
    STATE(3324), 1,
      sym_formal_parameters,
    ACTIONS(2430), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2442), 2,
      sym_true,
      sym_false,
    STATE(2017), 2,
      sym_string,
      sym__number,
    ACTIONS(2432), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2024), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2018), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [19623] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_STAR,
    ACTIONS(495), 1,
      anon_sym_infer,
    ACTIONS(499), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(789), 1,
      anon_sym_LPAREN,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(821), 1,
      sym_number,
    ACTIONS(915), 1,
      anon_sym_LBRACE,
    ACTIONS(921), 1,
      sym_readonly,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2225), 1,
      anon_sym_LBRACK,
    ACTIONS(2582), 1,
      sym_this,
    ACTIONS(2760), 1,
      sym_identifier,
    ACTIONS(2762), 1,
      anon_sym_typeof,
    ACTIONS(2764), 1,
      anon_sym_new,
    ACTIONS(2766), 1,
      anon_sym_QMARK,
    ACTIONS(2768), 1,
      anon_sym_AMP,
    ACTIONS(2770), 1,
      anon_sym_PIPE,
    ACTIONS(2772), 1,
      anon_sym_keyof,
    STATE(442), 1,
      sym__tuple_type_body,
    STATE(494), 1,
      sym_nested_type_identifier,
    STATE(3020), 1,
      sym_type_parameters,
    STATE(3297), 1,
      sym_nested_identifier,
    STATE(3316), 1,
      sym_formal_parameters,
    ACTIONS(825), 2,
      sym_true,
      sym_false,
    ACTIONS(1655), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(447), 2,
      sym_string,
      sym__number,
    ACTIONS(815), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(508), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(431), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [19743] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_STAR,
    ACTIONS(461), 1,
      anon_sym_QMARK,
    ACTIONS(463), 1,
      anon_sym_AMP,
    ACTIONS(465), 1,
      anon_sym_PIPE,
    ACTIONS(495), 1,
      anon_sym_infer,
    ACTIONS(497), 1,
      anon_sym_keyof,
    ACTIONS(499), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(787), 1,
      anon_sym_typeof,
    ACTIONS(789), 1,
      anon_sym_LPAREN,
    ACTIONS(801), 1,
      anon_sym_new,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(821), 1,
      sym_number,
    ACTIONS(911), 1,
      sym_identifier,
    ACTIONS(915), 1,
      anon_sym_LBRACE,
    ACTIONS(921), 1,
      sym_readonly,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2225), 1,
      anon_sym_LBRACK,
    ACTIONS(2582), 1,
      sym_this,
    STATE(442), 1,
      sym__tuple_type_body,
    STATE(1957), 1,
      sym_nested_type_identifier,
    STATE(3048), 1,
      sym_type_parameters,
    STATE(3296), 1,
      sym_formal_parameters,
    STATE(3297), 1,
      sym_nested_identifier,
    ACTIONS(825), 2,
      sym_true,
      sym_false,
    ACTIONS(1655), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(447), 2,
      sym_string,
      sym__number,
    ACTIONS(815), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2284), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(431), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [19863] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_STAR,
    ACTIONS(461), 1,
      anon_sym_QMARK,
    ACTIONS(463), 1,
      anon_sym_AMP,
    ACTIONS(465), 1,
      anon_sym_PIPE,
    ACTIONS(495), 1,
      anon_sym_infer,
    ACTIONS(497), 1,
      anon_sym_keyof,
    ACTIONS(499), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(787), 1,
      anon_sym_typeof,
    ACTIONS(789), 1,
      anon_sym_LPAREN,
    ACTIONS(801), 1,
      anon_sym_new,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(821), 1,
      sym_number,
    ACTIONS(911), 1,
      sym_identifier,
    ACTIONS(915), 1,
      anon_sym_LBRACE,
    ACTIONS(921), 1,
      sym_readonly,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2225), 1,
      anon_sym_LBRACK,
    ACTIONS(2582), 1,
      sym_this,
    STATE(442), 1,
      sym__tuple_type_body,
    STATE(1957), 1,
      sym_nested_type_identifier,
    STATE(3048), 1,
      sym_type_parameters,
    STATE(3296), 1,
      sym_formal_parameters,
    STATE(3297), 1,
      sym_nested_identifier,
    ACTIONS(825), 2,
      sym_true,
      sym_false,
    ACTIONS(1655), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(447), 2,
      sym_string,
      sym__number,
    ACTIONS(815), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2354), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(431), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [19983] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(475), 1,
      anon_sym_DQUOTE,
    ACTIONS(477), 1,
      anon_sym_SQUOTE,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2330), 1,
      sym_identifier,
    ACTIONS(2332), 1,
      anon_sym_STAR,
    ACTIONS(2334), 1,
      anon_sym_LBRACE,
    ACTIONS(2336), 1,
      anon_sym_typeof,
    ACTIONS(2338), 1,
      anon_sym_LPAREN,
    ACTIONS(2340), 1,
      anon_sym_LBRACK,
    ACTIONS(2342), 1,
      anon_sym_new,
    ACTIONS(2344), 1,
      anon_sym_QMARK,
    ACTIONS(2346), 1,
      anon_sym_AMP,
    ACTIONS(2348), 1,
      anon_sym_PIPE,
    ACTIONS(2354), 1,
      sym_number,
    ACTIONS(2356), 1,
      sym_this,
    ACTIONS(2360), 1,
      sym_readonly,
    ACTIONS(2362), 1,
      anon_sym_infer,
    ACTIONS(2364), 1,
      anon_sym_keyof,
    ACTIONS(2366), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1028), 1,
      sym_nested_type_identifier,
    STATE(1082), 1,
      sym__tuple_type_body,
    STATE(3078), 1,
      sym_type_parameters,
    STATE(3195), 1,
      sym_nested_identifier,
    STATE(3385), 1,
      sym_formal_parameters,
    ACTIONS(2350), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2358), 2,
      sym_true,
      sym_false,
    STATE(1087), 2,
      sym_string,
      sym__number,
    ACTIONS(2352), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1129), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(1084), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [20103] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2159), 23,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2161), 33,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [20167] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_STAR,
    ACTIONS(461), 1,
      anon_sym_QMARK,
    ACTIONS(463), 1,
      anon_sym_AMP,
    ACTIONS(465), 1,
      anon_sym_PIPE,
    ACTIONS(495), 1,
      anon_sym_infer,
    ACTIONS(497), 1,
      anon_sym_keyof,
    ACTIONS(499), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(787), 1,
      anon_sym_typeof,
    ACTIONS(789), 1,
      anon_sym_LPAREN,
    ACTIONS(801), 1,
      anon_sym_new,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(821), 1,
      sym_number,
    ACTIONS(911), 1,
      sym_identifier,
    ACTIONS(915), 1,
      anon_sym_LBRACE,
    ACTIONS(921), 1,
      sym_readonly,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2225), 1,
      anon_sym_LBRACK,
    ACTIONS(2582), 1,
      sym_this,
    STATE(442), 1,
      sym__tuple_type_body,
    STATE(1957), 1,
      sym_nested_type_identifier,
    STATE(3048), 1,
      sym_type_parameters,
    STATE(3296), 1,
      sym_formal_parameters,
    STATE(3297), 1,
      sym_nested_identifier,
    ACTIONS(825), 2,
      sym_true,
      sym_false,
    ACTIONS(1655), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(447), 2,
      sym_string,
      sym__number,
    ACTIONS(815), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2105), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(431), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [20287] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(693), 1,
      anon_sym_DQUOTE,
    ACTIONS(695), 1,
      anon_sym_SQUOTE,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2492), 1,
      sym_identifier,
    ACTIONS(2494), 1,
      anon_sym_STAR,
    ACTIONS(2496), 1,
      anon_sym_LBRACE,
    ACTIONS(2498), 1,
      anon_sym_typeof,
    ACTIONS(2500), 1,
      anon_sym_LPAREN,
    ACTIONS(2502), 1,
      anon_sym_LBRACK,
    ACTIONS(2504), 1,
      anon_sym_new,
    ACTIONS(2506), 1,
      anon_sym_QMARK,
    ACTIONS(2508), 1,
      anon_sym_AMP,
    ACTIONS(2510), 1,
      anon_sym_PIPE,
    ACTIONS(2516), 1,
      sym_number,
    ACTIONS(2518), 1,
      sym_this,
    ACTIONS(2522), 1,
      sym_readonly,
    ACTIONS(2524), 1,
      anon_sym_infer,
    ACTIONS(2526), 1,
      anon_sym_keyof,
    ACTIONS(2528), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1497), 1,
      sym_nested_type_identifier,
    STATE(1567), 1,
      sym__tuple_type_body,
    STATE(2997), 1,
      sym_type_parameters,
    STATE(3219), 1,
      sym_nested_identifier,
    STATE(3288), 1,
      sym_formal_parameters,
    ACTIONS(2512), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2520), 2,
      sym_true,
      sym_false,
    STATE(1564), 2,
      sym_string,
      sym__number,
    ACTIONS(2514), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1599), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(1566), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [20407] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(577), 1,
      anon_sym_STAR,
    ACTIONS(589), 1,
      anon_sym_QMARK,
    ACTIONS(591), 1,
      anon_sym_AMP,
    ACTIONS(593), 1,
      anon_sym_PIPE,
    ACTIONS(609), 1,
      anon_sym_infer,
    ACTIONS(611), 1,
      anon_sym_keyof,
    ACTIONS(613), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2420), 1,
      anon_sym_LBRACE,
    ACTIONS(2422), 1,
      anon_sym_typeof,
    ACTIONS(2424), 1,
      anon_sym_LPAREN,
    ACTIONS(2426), 1,
      anon_sym_LBRACK,
    ACTIONS(2428), 1,
      anon_sym_new,
    ACTIONS(2434), 1,
      anon_sym_DQUOTE,
    ACTIONS(2436), 1,
      anon_sym_SQUOTE,
    ACTIONS(2438), 1,
      sym_number,
    ACTIONS(2444), 1,
      sym_readonly,
    ACTIONS(2750), 1,
      sym_identifier,
    ACTIONS(2752), 1,
      sym_this,
    STATE(1983), 1,
      sym_nested_type_identifier,
    STATE(2025), 1,
      sym__tuple_type_body,
    STATE(3157), 1,
      sym_type_parameters,
    STATE(3166), 1,
      sym_nested_identifier,
    STATE(3324), 1,
      sym_formal_parameters,
    ACTIONS(2430), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2442), 2,
      sym_true,
      sym_false,
    STATE(2017), 2,
      sym_string,
      sym__number,
    ACTIONS(2432), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2028), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2018), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [20527] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(577), 1,
      anon_sym_STAR,
    ACTIONS(589), 1,
      anon_sym_QMARK,
    ACTIONS(591), 1,
      anon_sym_AMP,
    ACTIONS(593), 1,
      anon_sym_PIPE,
    ACTIONS(609), 1,
      anon_sym_infer,
    ACTIONS(611), 1,
      anon_sym_keyof,
    ACTIONS(613), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2420), 1,
      anon_sym_LBRACE,
    ACTIONS(2422), 1,
      anon_sym_typeof,
    ACTIONS(2424), 1,
      anon_sym_LPAREN,
    ACTIONS(2426), 1,
      anon_sym_LBRACK,
    ACTIONS(2428), 1,
      anon_sym_new,
    ACTIONS(2434), 1,
      anon_sym_DQUOTE,
    ACTIONS(2436), 1,
      anon_sym_SQUOTE,
    ACTIONS(2438), 1,
      sym_number,
    ACTIONS(2444), 1,
      sym_readonly,
    ACTIONS(2750), 1,
      sym_identifier,
    ACTIONS(2752), 1,
      sym_this,
    STATE(1983), 1,
      sym_nested_type_identifier,
    STATE(2025), 1,
      sym__tuple_type_body,
    STATE(3157), 1,
      sym_type_parameters,
    STATE(3166), 1,
      sym_nested_identifier,
    STATE(3324), 1,
      sym_formal_parameters,
    ACTIONS(2430), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2442), 2,
      sym_true,
      sym_false,
    STATE(2017), 2,
      sym_string,
      sym__number,
    ACTIONS(2432), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2101), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2018), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [20647] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(693), 1,
      anon_sym_DQUOTE,
    ACTIONS(695), 1,
      anon_sym_SQUOTE,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2492), 1,
      sym_identifier,
    ACTIONS(2494), 1,
      anon_sym_STAR,
    ACTIONS(2496), 1,
      anon_sym_LBRACE,
    ACTIONS(2498), 1,
      anon_sym_typeof,
    ACTIONS(2500), 1,
      anon_sym_LPAREN,
    ACTIONS(2502), 1,
      anon_sym_LBRACK,
    ACTIONS(2504), 1,
      anon_sym_new,
    ACTIONS(2506), 1,
      anon_sym_QMARK,
    ACTIONS(2508), 1,
      anon_sym_AMP,
    ACTIONS(2510), 1,
      anon_sym_PIPE,
    ACTIONS(2516), 1,
      sym_number,
    ACTIONS(2518), 1,
      sym_this,
    ACTIONS(2522), 1,
      sym_readonly,
    ACTIONS(2524), 1,
      anon_sym_infer,
    ACTIONS(2526), 1,
      anon_sym_keyof,
    ACTIONS(2528), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1497), 1,
      sym_nested_type_identifier,
    STATE(1567), 1,
      sym__tuple_type_body,
    STATE(2997), 1,
      sym_type_parameters,
    STATE(3219), 1,
      sym_nested_identifier,
    STATE(3288), 1,
      sym_formal_parameters,
    ACTIONS(2512), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2520), 2,
      sym_true,
      sym_false,
    STATE(1564), 2,
      sym_string,
      sym__number,
    ACTIONS(2514), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1594), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(1566), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [20767] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2201), 1,
      anon_sym_LPAREN,
    ACTIONS(2203), 1,
      anon_sym_LT,
    ACTIONS(2211), 1,
      anon_sym_EQ,
    ACTIONS(2633), 1,
      anon_sym_LBRACK,
    ACTIONS(2639), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2651), 1,
      anon_sym_DOT,
    STATE(1667), 1,
      sym_type_arguments,
    STATE(1677), 1,
      sym_arguments,
    ACTIONS(2213), 11,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2221), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2209), 22,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [20849] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_STAR,
    ACTIONS(461), 1,
      anon_sym_QMARK,
    ACTIONS(463), 1,
      anon_sym_AMP,
    ACTIONS(465), 1,
      anon_sym_PIPE,
    ACTIONS(495), 1,
      anon_sym_infer,
    ACTIONS(497), 1,
      anon_sym_keyof,
    ACTIONS(499), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(787), 1,
      anon_sym_typeof,
    ACTIONS(789), 1,
      anon_sym_LPAREN,
    ACTIONS(801), 1,
      anon_sym_new,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(821), 1,
      sym_number,
    ACTIONS(911), 1,
      sym_identifier,
    ACTIONS(915), 1,
      anon_sym_LBRACE,
    ACTIONS(921), 1,
      sym_readonly,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2225), 1,
      anon_sym_LBRACK,
    ACTIONS(2582), 1,
      sym_this,
    STATE(442), 1,
      sym__tuple_type_body,
    STATE(1957), 1,
      sym_nested_type_identifier,
    STATE(3048), 1,
      sym_type_parameters,
    STATE(3296), 1,
      sym_formal_parameters,
    STATE(3297), 1,
      sym_nested_identifier,
    ACTIONS(825), 2,
      sym_true,
      sym_false,
    ACTIONS(1655), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(447), 2,
      sym_string,
      sym__number,
    ACTIONS(815), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2456), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(431), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [20969] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(81), 1,
      anon_sym_DQUOTE,
    ACTIONS(83), 1,
      anon_sym_SQUOTE,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2368), 1,
      sym_identifier,
    ACTIONS(2370), 1,
      anon_sym_STAR,
    ACTIONS(2372), 1,
      anon_sym_LBRACE,
    ACTIONS(2374), 1,
      anon_sym_typeof,
    ACTIONS(2376), 1,
      anon_sym_LPAREN,
    ACTIONS(2378), 1,
      anon_sym_LBRACK,
    ACTIONS(2380), 1,
      anon_sym_new,
    ACTIONS(2382), 1,
      anon_sym_QMARK,
    ACTIONS(2384), 1,
      anon_sym_AMP,
    ACTIONS(2386), 1,
      anon_sym_PIPE,
    ACTIONS(2392), 1,
      sym_number,
    ACTIONS(2394), 1,
      sym_this,
    ACTIONS(2398), 1,
      sym_readonly,
    ACTIONS(2400), 1,
      anon_sym_infer,
    ACTIONS(2402), 1,
      anon_sym_keyof,
    ACTIONS(2404), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1291), 1,
      sym_nested_type_identifier,
    STATE(1423), 1,
      sym__tuple_type_body,
    STATE(3021), 1,
      sym_type_parameters,
    STATE(3214), 1,
      sym_nested_identifier,
    STATE(3277), 1,
      sym_formal_parameters,
    ACTIONS(2388), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2396), 2,
      sym_true,
      sym_false,
    STATE(1420), 2,
      sym_string,
      sym__number,
    ACTIONS(2390), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1385), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(1422), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [21089] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2450), 1,
      anon_sym_STAR,
    ACTIONS(2452), 1,
      anon_sym_LBRACE,
    ACTIONS(2454), 1,
      anon_sym_typeof,
    ACTIONS(2456), 1,
      anon_sym_LPAREN,
    ACTIONS(2458), 1,
      anon_sym_LBRACK,
    ACTIONS(2460), 1,
      anon_sym_new,
    ACTIONS(2462), 1,
      anon_sym_QMARK,
    ACTIONS(2464), 1,
      anon_sym_AMP,
    ACTIONS(2466), 1,
      anon_sym_PIPE,
    ACTIONS(2472), 1,
      anon_sym_DQUOTE,
    ACTIONS(2474), 1,
      anon_sym_SQUOTE,
    ACTIONS(2476), 1,
      sym_number,
    ACTIONS(2482), 1,
      sym_readonly,
    ACTIONS(2486), 1,
      anon_sym_infer,
    ACTIONS(2488), 1,
      anon_sym_keyof,
    ACTIONS(2490), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2744), 1,
      sym_identifier,
    ACTIONS(2746), 1,
      sym_this,
    STATE(2062), 1,
      sym_nested_type_identifier,
    STATE(2119), 1,
      sym__tuple_type_body,
    STATE(3122), 1,
      sym_type_parameters,
    STATE(3212), 1,
      sym_nested_identifier,
    STATE(3347), 1,
      sym_formal_parameters,
    ACTIONS(2468), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2480), 2,
      sym_true,
      sym_false,
    STATE(2122), 2,
      sym_string,
      sym__number,
    ACTIONS(2470), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2157), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2123), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [21209] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2450), 1,
      anon_sym_STAR,
    ACTIONS(2452), 1,
      anon_sym_LBRACE,
    ACTIONS(2454), 1,
      anon_sym_typeof,
    ACTIONS(2456), 1,
      anon_sym_LPAREN,
    ACTIONS(2458), 1,
      anon_sym_LBRACK,
    ACTIONS(2460), 1,
      anon_sym_new,
    ACTIONS(2462), 1,
      anon_sym_QMARK,
    ACTIONS(2464), 1,
      anon_sym_AMP,
    ACTIONS(2466), 1,
      anon_sym_PIPE,
    ACTIONS(2472), 1,
      anon_sym_DQUOTE,
    ACTIONS(2474), 1,
      anon_sym_SQUOTE,
    ACTIONS(2476), 1,
      sym_number,
    ACTIONS(2482), 1,
      sym_readonly,
    ACTIONS(2486), 1,
      anon_sym_infer,
    ACTIONS(2488), 1,
      anon_sym_keyof,
    ACTIONS(2490), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2744), 1,
      sym_identifier,
    ACTIONS(2746), 1,
      sym_this,
    STATE(2062), 1,
      sym_nested_type_identifier,
    STATE(2119), 1,
      sym__tuple_type_body,
    STATE(3122), 1,
      sym_type_parameters,
    STATE(3212), 1,
      sym_nested_identifier,
    STATE(3347), 1,
      sym_formal_parameters,
    ACTIONS(2468), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2480), 2,
      sym_true,
      sym_false,
    STATE(2122), 2,
      sym_string,
      sym__number,
    ACTIONS(2470), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2191), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2123), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [21329] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_STAR,
    ACTIONS(461), 1,
      anon_sym_QMARK,
    ACTIONS(463), 1,
      anon_sym_AMP,
    ACTIONS(465), 1,
      anon_sym_PIPE,
    ACTIONS(495), 1,
      anon_sym_infer,
    ACTIONS(497), 1,
      anon_sym_keyof,
    ACTIONS(499), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(787), 1,
      anon_sym_typeof,
    ACTIONS(789), 1,
      anon_sym_LPAREN,
    ACTIONS(801), 1,
      anon_sym_new,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(821), 1,
      sym_number,
    ACTIONS(911), 1,
      sym_identifier,
    ACTIONS(915), 1,
      anon_sym_LBRACE,
    ACTIONS(921), 1,
      sym_readonly,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2225), 1,
      anon_sym_LBRACK,
    ACTIONS(2582), 1,
      sym_this,
    STATE(442), 1,
      sym__tuple_type_body,
    STATE(1957), 1,
      sym_nested_type_identifier,
    STATE(3048), 1,
      sym_type_parameters,
    STATE(3296), 1,
      sym_formal_parameters,
    STATE(3297), 1,
      sym_nested_identifier,
    ACTIONS(825), 2,
      sym_true,
      sym_false,
    ACTIONS(1655), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(447), 2,
      sym_string,
      sym__number,
    ACTIONS(815), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2675), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(431), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [21449] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(475), 1,
      anon_sym_DQUOTE,
    ACTIONS(477), 1,
      anon_sym_SQUOTE,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2330), 1,
      sym_identifier,
    ACTIONS(2332), 1,
      anon_sym_STAR,
    ACTIONS(2334), 1,
      anon_sym_LBRACE,
    ACTIONS(2336), 1,
      anon_sym_typeof,
    ACTIONS(2338), 1,
      anon_sym_LPAREN,
    ACTIONS(2340), 1,
      anon_sym_LBRACK,
    ACTIONS(2342), 1,
      anon_sym_new,
    ACTIONS(2344), 1,
      anon_sym_QMARK,
    ACTIONS(2346), 1,
      anon_sym_AMP,
    ACTIONS(2348), 1,
      anon_sym_PIPE,
    ACTIONS(2354), 1,
      sym_number,
    ACTIONS(2356), 1,
      sym_this,
    ACTIONS(2360), 1,
      sym_readonly,
    ACTIONS(2362), 1,
      anon_sym_infer,
    ACTIONS(2364), 1,
      anon_sym_keyof,
    ACTIONS(2366), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1028), 1,
      sym_nested_type_identifier,
    STATE(1082), 1,
      sym__tuple_type_body,
    STATE(3078), 1,
      sym_type_parameters,
    STATE(3195), 1,
      sym_nested_identifier,
    STATE(3385), 1,
      sym_formal_parameters,
    ACTIONS(2350), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2358), 2,
      sym_true,
      sym_false,
    STATE(1087), 2,
      sym_string,
      sym__number,
    ACTIONS(2352), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1086), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(1084), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [21569] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1396), 1,
      anon_sym_extends,
    ACTIONS(2302), 1,
      anon_sym_DOT,
    ACTIONS(2296), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(2299), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2266), 19,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2268), 29,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [21641] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_STAR,
    ACTIONS(461), 1,
      anon_sym_QMARK,
    ACTIONS(463), 1,
      anon_sym_AMP,
    ACTIONS(465), 1,
      anon_sym_PIPE,
    ACTIONS(495), 1,
      anon_sym_infer,
    ACTIONS(497), 1,
      anon_sym_keyof,
    ACTIONS(499), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(787), 1,
      anon_sym_typeof,
    ACTIONS(789), 1,
      anon_sym_LPAREN,
    ACTIONS(801), 1,
      anon_sym_new,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(821), 1,
      sym_number,
    ACTIONS(911), 1,
      sym_identifier,
    ACTIONS(915), 1,
      anon_sym_LBRACE,
    ACTIONS(921), 1,
      sym_readonly,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2340), 1,
      anon_sym_LBRACK,
    ACTIONS(2783), 1,
      sym_this,
    STATE(1064), 1,
      sym__tuple_type_body,
    STATE(1957), 1,
      sym_nested_type_identifier,
    STATE(3048), 1,
      sym_type_parameters,
    STATE(3296), 1,
      sym_formal_parameters,
    STATE(3297), 1,
      sym_nested_identifier,
    ACTIONS(825), 2,
      sym_true,
      sym_false,
    ACTIONS(1655), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(447), 2,
      sym_string,
      sym__number,
    ACTIONS(815), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2794), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2699), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [21761] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_STAR,
    ACTIONS(461), 1,
      anon_sym_QMARK,
    ACTIONS(463), 1,
      anon_sym_AMP,
    ACTIONS(465), 1,
      anon_sym_PIPE,
    ACTIONS(495), 1,
      anon_sym_infer,
    ACTIONS(497), 1,
      anon_sym_keyof,
    ACTIONS(499), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(787), 1,
      anon_sym_typeof,
    ACTIONS(789), 1,
      anon_sym_LPAREN,
    ACTIONS(801), 1,
      anon_sym_new,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(821), 1,
      sym_number,
    ACTIONS(911), 1,
      sym_identifier,
    ACTIONS(915), 1,
      anon_sym_LBRACE,
    ACTIONS(921), 1,
      sym_readonly,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2225), 1,
      anon_sym_LBRACK,
    ACTIONS(2582), 1,
      sym_this,
    STATE(442), 1,
      sym__tuple_type_body,
    STATE(1957), 1,
      sym_nested_type_identifier,
    STATE(3048), 1,
      sym_type_parameters,
    STATE(3296), 1,
      sym_formal_parameters,
    STATE(3297), 1,
      sym_nested_identifier,
    ACTIONS(825), 2,
      sym_true,
      sym_false,
    ACTIONS(1655), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(447), 2,
      sym_string,
      sym__number,
    ACTIONS(815), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2674), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(431), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [21881] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2631), 1,
      anon_sym_EQ,
    ACTIONS(2633), 1,
      anon_sym_LBRACK,
    ACTIONS(2637), 1,
      anon_sym_EQ_GT,
    ACTIONS(2639), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2723), 1,
      anon_sym_LT,
    ACTIONS(2726), 1,
      anon_sym_DOT,
    ACTIONS(2785), 1,
      anon_sym_LBRACE,
    STATE(2816), 1,
      sym_type_arguments,
    ACTIONS(2754), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1113), 10,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2221), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1111), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [21965] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2282), 23,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2284), 33,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [22029] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_STAR,
    ACTIONS(461), 1,
      anon_sym_QMARK,
    ACTIONS(463), 1,
      anon_sym_AMP,
    ACTIONS(465), 1,
      anon_sym_PIPE,
    ACTIONS(495), 1,
      anon_sym_infer,
    ACTIONS(497), 1,
      anon_sym_keyof,
    ACTIONS(499), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(787), 1,
      anon_sym_typeof,
    ACTIONS(789), 1,
      anon_sym_LPAREN,
    ACTIONS(801), 1,
      anon_sym_new,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(821), 1,
      sym_number,
    ACTIONS(911), 1,
      sym_identifier,
    ACTIONS(915), 1,
      anon_sym_LBRACE,
    ACTIONS(921), 1,
      sym_readonly,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2225), 1,
      anon_sym_LBRACK,
    ACTIONS(2582), 1,
      sym_this,
    STATE(442), 1,
      sym__tuple_type_body,
    STATE(1957), 1,
      sym_nested_type_identifier,
    STATE(3048), 1,
      sym_type_parameters,
    STATE(3296), 1,
      sym_formal_parameters,
    STATE(3297), 1,
      sym_nested_identifier,
    ACTIONS(825), 2,
      sym_true,
      sym_false,
    ACTIONS(1655), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(447), 2,
      sym_string,
      sym__number,
    ACTIONS(815), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2672), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(431), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [22149] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2262), 23,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2264), 33,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [22213] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2313), 1,
      anon_sym_LBRACK,
    ACTIONS(2318), 1,
      anon_sym_DOT,
    ACTIONS(2320), 1,
      anon_sym_EQ_GT,
    ACTIONS(2322), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2406), 1,
      anon_sym_EQ,
    ACTIONS(2787), 1,
      anon_sym_in,
    ACTIONS(2790), 1,
      anon_sym_of,
    ACTIONS(1113), 13,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2221), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1111), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [22293] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(923), 1,
      anon_sym_EQ,
    ACTIONS(929), 1,
      anon_sym_EQ_GT,
    ACTIONS(931), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1223), 1,
      anon_sym_LBRACK,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1695), 1,
      anon_sym_in,
    ACTIONS(2792), 1,
      anon_sym_of,
    ACTIONS(813), 13,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(803), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(780), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [22373] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2231), 1,
      anon_sym_EQ,
    ACTIONS(2221), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1113), 18,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1111), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [22441] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(923), 1,
      anon_sym_EQ,
    ACTIONS(929), 1,
      anon_sym_EQ_GT,
    ACTIONS(931), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1223), 1,
      anon_sym_LBRACK,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(813), 14,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(803), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(780), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [22517] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_STAR,
    ACTIONS(461), 1,
      anon_sym_QMARK,
    ACTIONS(463), 1,
      anon_sym_AMP,
    ACTIONS(465), 1,
      anon_sym_PIPE,
    ACTIONS(495), 1,
      anon_sym_infer,
    ACTIONS(497), 1,
      anon_sym_keyof,
    ACTIONS(499), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(787), 1,
      anon_sym_typeof,
    ACTIONS(789), 1,
      anon_sym_LPAREN,
    ACTIONS(801), 1,
      anon_sym_new,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(821), 1,
      sym_number,
    ACTIONS(911), 1,
      sym_identifier,
    ACTIONS(915), 1,
      anon_sym_LBRACE,
    ACTIONS(921), 1,
      sym_readonly,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2225), 1,
      anon_sym_LBRACK,
    ACTIONS(2582), 1,
      sym_this,
    STATE(442), 1,
      sym__tuple_type_body,
    STATE(1957), 1,
      sym_nested_type_identifier,
    STATE(3048), 1,
      sym_type_parameters,
    STATE(3296), 1,
      sym_formal_parameters,
    STATE(3297), 1,
      sym_nested_identifier,
    ACTIONS(825), 2,
      sym_true,
      sym_false,
    ACTIONS(1655), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(447), 2,
      sym_string,
      sym__number,
    ACTIONS(815), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2346), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(431), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [22637] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2450), 1,
      anon_sym_STAR,
    ACTIONS(2452), 1,
      anon_sym_LBRACE,
    ACTIONS(2454), 1,
      anon_sym_typeof,
    ACTIONS(2456), 1,
      anon_sym_LPAREN,
    ACTIONS(2458), 1,
      anon_sym_LBRACK,
    ACTIONS(2460), 1,
      anon_sym_new,
    ACTIONS(2462), 1,
      anon_sym_QMARK,
    ACTIONS(2464), 1,
      anon_sym_AMP,
    ACTIONS(2466), 1,
      anon_sym_PIPE,
    ACTIONS(2472), 1,
      anon_sym_DQUOTE,
    ACTIONS(2474), 1,
      anon_sym_SQUOTE,
    ACTIONS(2476), 1,
      sym_number,
    ACTIONS(2482), 1,
      sym_readonly,
    ACTIONS(2486), 1,
      anon_sym_infer,
    ACTIONS(2488), 1,
      anon_sym_keyof,
    ACTIONS(2490), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2744), 1,
      sym_identifier,
    ACTIONS(2746), 1,
      sym_this,
    STATE(2062), 1,
      sym_nested_type_identifier,
    STATE(2119), 1,
      sym__tuple_type_body,
    STATE(3122), 1,
      sym_type_parameters,
    STATE(3212), 1,
      sym_nested_identifier,
    STATE(3347), 1,
      sym_formal_parameters,
    ACTIONS(2468), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2480), 2,
      sym_true,
      sym_false,
    STATE(2122), 2,
      sym_string,
      sym__number,
    ACTIONS(2470), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2188), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2123), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [22757] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(577), 1,
      anon_sym_STAR,
    ACTIONS(589), 1,
      anon_sym_QMARK,
    ACTIONS(591), 1,
      anon_sym_AMP,
    ACTIONS(593), 1,
      anon_sym_PIPE,
    ACTIONS(609), 1,
      anon_sym_infer,
    ACTIONS(611), 1,
      anon_sym_keyof,
    ACTIONS(613), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2420), 1,
      anon_sym_LBRACE,
    ACTIONS(2422), 1,
      anon_sym_typeof,
    ACTIONS(2424), 1,
      anon_sym_LPAREN,
    ACTIONS(2426), 1,
      anon_sym_LBRACK,
    ACTIONS(2428), 1,
      anon_sym_new,
    ACTIONS(2434), 1,
      anon_sym_DQUOTE,
    ACTIONS(2436), 1,
      anon_sym_SQUOTE,
    ACTIONS(2438), 1,
      sym_number,
    ACTIONS(2444), 1,
      sym_readonly,
    ACTIONS(2750), 1,
      sym_identifier,
    ACTIONS(2752), 1,
      sym_this,
    STATE(1983), 1,
      sym_nested_type_identifier,
    STATE(2025), 1,
      sym__tuple_type_body,
    STATE(3157), 1,
      sym_type_parameters,
    STATE(3166), 1,
      sym_nested_identifier,
    STATE(3324), 1,
      sym_formal_parameters,
    ACTIONS(2430), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2442), 2,
      sym_true,
      sym_false,
    STATE(2017), 2,
      sym_string,
      sym__number,
    ACTIONS(2432), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2160), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2018), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [22877] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(475), 1,
      anon_sym_DQUOTE,
    ACTIONS(477), 1,
      anon_sym_SQUOTE,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2330), 1,
      sym_identifier,
    ACTIONS(2332), 1,
      anon_sym_STAR,
    ACTIONS(2334), 1,
      anon_sym_LBRACE,
    ACTIONS(2336), 1,
      anon_sym_typeof,
    ACTIONS(2338), 1,
      anon_sym_LPAREN,
    ACTIONS(2340), 1,
      anon_sym_LBRACK,
    ACTIONS(2342), 1,
      anon_sym_new,
    ACTIONS(2344), 1,
      anon_sym_QMARK,
    ACTIONS(2346), 1,
      anon_sym_AMP,
    ACTIONS(2348), 1,
      anon_sym_PIPE,
    ACTIONS(2354), 1,
      sym_number,
    ACTIONS(2356), 1,
      sym_this,
    ACTIONS(2360), 1,
      sym_readonly,
    ACTIONS(2362), 1,
      anon_sym_infer,
    ACTIONS(2364), 1,
      anon_sym_keyof,
    ACTIONS(2366), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1028), 1,
      sym_nested_type_identifier,
    STATE(1082), 1,
      sym__tuple_type_body,
    STATE(3078), 1,
      sym_type_parameters,
    STATE(3195), 1,
      sym_nested_identifier,
    STATE(3385), 1,
      sym_formal_parameters,
    ACTIONS(2350), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2358), 2,
      sym_true,
      sym_false,
    STATE(1087), 2,
      sym_string,
      sym__number,
    ACTIONS(2352), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1095), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(1084), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [22997] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(577), 1,
      anon_sym_STAR,
    ACTIONS(589), 1,
      anon_sym_QMARK,
    ACTIONS(591), 1,
      anon_sym_AMP,
    ACTIONS(593), 1,
      anon_sym_PIPE,
    ACTIONS(609), 1,
      anon_sym_infer,
    ACTIONS(611), 1,
      anon_sym_keyof,
    ACTIONS(613), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2420), 1,
      anon_sym_LBRACE,
    ACTIONS(2422), 1,
      anon_sym_typeof,
    ACTIONS(2424), 1,
      anon_sym_LPAREN,
    ACTIONS(2426), 1,
      anon_sym_LBRACK,
    ACTIONS(2428), 1,
      anon_sym_new,
    ACTIONS(2434), 1,
      anon_sym_DQUOTE,
    ACTIONS(2436), 1,
      anon_sym_SQUOTE,
    ACTIONS(2438), 1,
      sym_number,
    ACTIONS(2444), 1,
      sym_readonly,
    ACTIONS(2750), 1,
      sym_identifier,
    ACTIONS(2752), 1,
      sym_this,
    STATE(1983), 1,
      sym_nested_type_identifier,
    STATE(2025), 1,
      sym__tuple_type_body,
    STATE(3157), 1,
      sym_type_parameters,
    STATE(3166), 1,
      sym_nested_identifier,
    STATE(3324), 1,
      sym_formal_parameters,
    ACTIONS(2430), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2442), 2,
      sym_true,
      sym_false,
    STATE(2017), 2,
      sym_string,
      sym__number,
    ACTIONS(2432), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2065), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2018), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [23117] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(931), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1067), 1,
      anon_sym_EQ,
    ACTIONS(1069), 1,
      anon_sym_EQ_GT,
    ACTIONS(1223), 1,
      anon_sym_LBRACK,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(1189), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(2327), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(813), 12,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(803), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(780), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [23197] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2450), 1,
      anon_sym_STAR,
    ACTIONS(2452), 1,
      anon_sym_LBRACE,
    ACTIONS(2454), 1,
      anon_sym_typeof,
    ACTIONS(2456), 1,
      anon_sym_LPAREN,
    ACTIONS(2458), 1,
      anon_sym_LBRACK,
    ACTIONS(2460), 1,
      anon_sym_new,
    ACTIONS(2462), 1,
      anon_sym_QMARK,
    ACTIONS(2464), 1,
      anon_sym_AMP,
    ACTIONS(2466), 1,
      anon_sym_PIPE,
    ACTIONS(2472), 1,
      anon_sym_DQUOTE,
    ACTIONS(2474), 1,
      anon_sym_SQUOTE,
    ACTIONS(2476), 1,
      sym_number,
    ACTIONS(2482), 1,
      sym_readonly,
    ACTIONS(2486), 1,
      anon_sym_infer,
    ACTIONS(2488), 1,
      anon_sym_keyof,
    ACTIONS(2490), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2744), 1,
      sym_identifier,
    ACTIONS(2746), 1,
      sym_this,
    STATE(2062), 1,
      sym_nested_type_identifier,
    STATE(2119), 1,
      sym__tuple_type_body,
    STATE(3122), 1,
      sym_type_parameters,
    STATE(3212), 1,
      sym_nested_identifier,
    STATE(3347), 1,
      sym_formal_parameters,
    ACTIONS(2468), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2480), 2,
      sym_true,
      sym_false,
    STATE(2122), 2,
      sym_string,
      sym__number,
    ACTIONS(2470), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2165), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2123), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [23317] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(577), 1,
      anon_sym_STAR,
    ACTIONS(589), 1,
      anon_sym_QMARK,
    ACTIONS(591), 1,
      anon_sym_AMP,
    ACTIONS(593), 1,
      anon_sym_PIPE,
    ACTIONS(609), 1,
      anon_sym_infer,
    ACTIONS(611), 1,
      anon_sym_keyof,
    ACTIONS(613), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2420), 1,
      anon_sym_LBRACE,
    ACTIONS(2422), 1,
      anon_sym_typeof,
    ACTIONS(2424), 1,
      anon_sym_LPAREN,
    ACTIONS(2426), 1,
      anon_sym_LBRACK,
    ACTIONS(2428), 1,
      anon_sym_new,
    ACTIONS(2434), 1,
      anon_sym_DQUOTE,
    ACTIONS(2436), 1,
      anon_sym_SQUOTE,
    ACTIONS(2438), 1,
      sym_number,
    ACTIONS(2444), 1,
      sym_readonly,
    ACTIONS(2750), 1,
      sym_identifier,
    ACTIONS(2752), 1,
      sym_this,
    STATE(1983), 1,
      sym_nested_type_identifier,
    STATE(2025), 1,
      sym__tuple_type_body,
    STATE(3157), 1,
      sym_type_parameters,
    STATE(3166), 1,
      sym_nested_identifier,
    STATE(3324), 1,
      sym_formal_parameters,
    ACTIONS(2430), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2442), 2,
      sym_true,
      sym_false,
    STATE(2017), 2,
      sym_string,
      sym__number,
    ACTIONS(2432), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2033), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2018), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [23437] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_STAR,
    ACTIONS(461), 1,
      anon_sym_QMARK,
    ACTIONS(463), 1,
      anon_sym_AMP,
    ACTIONS(465), 1,
      anon_sym_PIPE,
    ACTIONS(495), 1,
      anon_sym_infer,
    ACTIONS(497), 1,
      anon_sym_keyof,
    ACTIONS(499), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(787), 1,
      anon_sym_typeof,
    ACTIONS(789), 1,
      anon_sym_LPAREN,
    ACTIONS(801), 1,
      anon_sym_new,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(821), 1,
      sym_number,
    ACTIONS(911), 1,
      sym_identifier,
    ACTIONS(915), 1,
      anon_sym_LBRACE,
    ACTIONS(921), 1,
      sym_readonly,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2225), 1,
      anon_sym_LBRACK,
    ACTIONS(2582), 1,
      sym_this,
    STATE(442), 1,
      sym__tuple_type_body,
    STATE(1957), 1,
      sym_nested_type_identifier,
    STATE(3048), 1,
      sym_type_parameters,
    STATE(3296), 1,
      sym_formal_parameters,
    STATE(3297), 1,
      sym_nested_identifier,
    ACTIONS(825), 2,
      sym_true,
      sym_false,
    ACTIONS(1655), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(447), 2,
      sym_string,
      sym__number,
    ACTIONS(815), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2743), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(431), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [23557] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_STAR,
    ACTIONS(495), 1,
      anon_sym_infer,
    ACTIONS(499), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(789), 1,
      anon_sym_LPAREN,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(821), 1,
      sym_number,
    ACTIONS(915), 1,
      anon_sym_LBRACE,
    ACTIONS(921), 1,
      sym_readonly,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2225), 1,
      anon_sym_LBRACK,
    ACTIONS(2582), 1,
      sym_this,
    ACTIONS(2760), 1,
      sym_identifier,
    ACTIONS(2762), 1,
      anon_sym_typeof,
    ACTIONS(2764), 1,
      anon_sym_new,
    ACTIONS(2766), 1,
      anon_sym_QMARK,
    ACTIONS(2768), 1,
      anon_sym_AMP,
    ACTIONS(2770), 1,
      anon_sym_PIPE,
    ACTIONS(2772), 1,
      anon_sym_keyof,
    STATE(442), 1,
      sym__tuple_type_body,
    STATE(494), 1,
      sym_nested_type_identifier,
    STATE(3020), 1,
      sym_type_parameters,
    STATE(3297), 1,
      sym_nested_identifier,
    STATE(3316), 1,
      sym_formal_parameters,
    ACTIONS(825), 2,
      sym_true,
      sym_false,
    ACTIONS(1655), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(447), 2,
      sym_string,
      sym__number,
    ACTIONS(815), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(445), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(431), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [23677] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(463), 1,
      anon_sym_AMP,
    ACTIONS(465), 1,
      anon_sym_PIPE,
    ACTIONS(475), 1,
      anon_sym_DQUOTE,
    ACTIONS(477), 1,
      anon_sym_SQUOTE,
    ACTIONS(495), 1,
      anon_sym_infer,
    ACTIONS(801), 1,
      anon_sym_new,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2330), 1,
      sym_identifier,
    ACTIONS(2332), 1,
      anon_sym_STAR,
    ACTIONS(2334), 1,
      anon_sym_LBRACE,
    ACTIONS(2336), 1,
      anon_sym_typeof,
    ACTIONS(2338), 1,
      anon_sym_LPAREN,
    ACTIONS(2340), 1,
      anon_sym_LBRACK,
    ACTIONS(2344), 1,
      anon_sym_QMARK,
    ACTIONS(2354), 1,
      sym_number,
    ACTIONS(2360), 1,
      sym_readonly,
    ACTIONS(2364), 1,
      anon_sym_keyof,
    ACTIONS(2366), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2794), 1,
      sym_this,
    STATE(1028), 1,
      sym_nested_type_identifier,
    STATE(1082), 1,
      sym__tuple_type_body,
    STATE(3048), 1,
      sym_type_parameters,
    STATE(3195), 1,
      sym_nested_identifier,
    STATE(3296), 1,
      sym_formal_parameters,
    ACTIONS(2350), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2358), 2,
      sym_true,
      sym_false,
    STATE(1087), 2,
      sym_string,
      sym__number,
    ACTIONS(2352), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2766), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(1072), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [23797] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(475), 1,
      anon_sym_DQUOTE,
    ACTIONS(477), 1,
      anon_sym_SQUOTE,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2330), 1,
      sym_identifier,
    ACTIONS(2332), 1,
      anon_sym_STAR,
    ACTIONS(2334), 1,
      anon_sym_LBRACE,
    ACTIONS(2336), 1,
      anon_sym_typeof,
    ACTIONS(2338), 1,
      anon_sym_LPAREN,
    ACTIONS(2340), 1,
      anon_sym_LBRACK,
    ACTIONS(2342), 1,
      anon_sym_new,
    ACTIONS(2344), 1,
      anon_sym_QMARK,
    ACTIONS(2346), 1,
      anon_sym_AMP,
    ACTIONS(2348), 1,
      anon_sym_PIPE,
    ACTIONS(2354), 1,
      sym_number,
    ACTIONS(2356), 1,
      sym_this,
    ACTIONS(2360), 1,
      sym_readonly,
    ACTIONS(2362), 1,
      anon_sym_infer,
    ACTIONS(2364), 1,
      anon_sym_keyof,
    ACTIONS(2366), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1028), 1,
      sym_nested_type_identifier,
    STATE(1082), 1,
      sym__tuple_type_body,
    STATE(3078), 1,
      sym_type_parameters,
    STATE(3195), 1,
      sym_nested_identifier,
    STATE(3385), 1,
      sym_formal_parameters,
    ACTIONS(2350), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2358), 2,
      sym_true,
      sym_false,
    STATE(1087), 2,
      sym_string,
      sym__number,
    ACTIONS(2352), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1071), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(1084), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [23917] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(475), 1,
      anon_sym_DQUOTE,
    ACTIONS(477), 1,
      anon_sym_SQUOTE,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2330), 1,
      sym_identifier,
    ACTIONS(2332), 1,
      anon_sym_STAR,
    ACTIONS(2334), 1,
      anon_sym_LBRACE,
    ACTIONS(2336), 1,
      anon_sym_typeof,
    ACTIONS(2338), 1,
      anon_sym_LPAREN,
    ACTIONS(2340), 1,
      anon_sym_LBRACK,
    ACTIONS(2342), 1,
      anon_sym_new,
    ACTIONS(2344), 1,
      anon_sym_QMARK,
    ACTIONS(2346), 1,
      anon_sym_AMP,
    ACTIONS(2348), 1,
      anon_sym_PIPE,
    ACTIONS(2354), 1,
      sym_number,
    ACTIONS(2356), 1,
      sym_this,
    ACTIONS(2360), 1,
      sym_readonly,
    ACTIONS(2362), 1,
      anon_sym_infer,
    ACTIONS(2364), 1,
      anon_sym_keyof,
    ACTIONS(2366), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1028), 1,
      sym_nested_type_identifier,
    STATE(1082), 1,
      sym__tuple_type_body,
    STATE(3078), 1,
      sym_type_parameters,
    STATE(3195), 1,
      sym_nested_identifier,
    STATE(3385), 1,
      sym_formal_parameters,
    ACTIONS(2350), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2358), 2,
      sym_true,
      sym_false,
    STATE(1087), 2,
      sym_string,
      sym__number,
    ACTIONS(2352), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1070), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(1084), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [24037] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_STAR,
    ACTIONS(461), 1,
      anon_sym_QMARK,
    ACTIONS(463), 1,
      anon_sym_AMP,
    ACTIONS(465), 1,
      anon_sym_PIPE,
    ACTIONS(495), 1,
      anon_sym_infer,
    ACTIONS(497), 1,
      anon_sym_keyof,
    ACTIONS(499), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(787), 1,
      anon_sym_typeof,
    ACTIONS(789), 1,
      anon_sym_LPAREN,
    ACTIONS(801), 1,
      anon_sym_new,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(821), 1,
      sym_number,
    ACTIONS(911), 1,
      sym_identifier,
    ACTIONS(915), 1,
      anon_sym_LBRACE,
    ACTIONS(921), 1,
      sym_readonly,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2378), 1,
      anon_sym_LBRACK,
    ACTIONS(2796), 1,
      sym_this,
    STATE(1494), 1,
      sym__tuple_type_body,
    STATE(1957), 1,
      sym_nested_type_identifier,
    STATE(3048), 1,
      sym_type_parameters,
    STATE(3296), 1,
      sym_formal_parameters,
    STATE(3297), 1,
      sym_nested_identifier,
    ACTIONS(825), 2,
      sym_true,
      sym_false,
    ACTIONS(1655), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(447), 2,
      sym_string,
      sym__number,
    ACTIONS(815), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2794), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2685), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [24157] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_STAR,
    ACTIONS(495), 1,
      anon_sym_infer,
    ACTIONS(499), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(789), 1,
      anon_sym_LPAREN,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(821), 1,
      sym_number,
    ACTIONS(915), 1,
      anon_sym_LBRACE,
    ACTIONS(921), 1,
      sym_readonly,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2225), 1,
      anon_sym_LBRACK,
    ACTIONS(2582), 1,
      sym_this,
    ACTIONS(2760), 1,
      sym_identifier,
    ACTIONS(2762), 1,
      anon_sym_typeof,
    ACTIONS(2764), 1,
      anon_sym_new,
    ACTIONS(2766), 1,
      anon_sym_QMARK,
    ACTIONS(2768), 1,
      anon_sym_AMP,
    ACTIONS(2770), 1,
      anon_sym_PIPE,
    ACTIONS(2772), 1,
      anon_sym_keyof,
    STATE(442), 1,
      sym__tuple_type_body,
    STATE(494), 1,
      sym_nested_type_identifier,
    STATE(3020), 1,
      sym_type_parameters,
    STATE(3297), 1,
      sym_nested_identifier,
    STATE(3316), 1,
      sym_formal_parameters,
    ACTIONS(825), 2,
      sym_true,
      sym_false,
    ACTIONS(1655), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(447), 2,
      sym_string,
      sym__number,
    ACTIONS(815), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(430), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(431), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [24277] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_STAR,
    ACTIONS(495), 1,
      anon_sym_infer,
    ACTIONS(499), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(789), 1,
      anon_sym_LPAREN,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(821), 1,
      sym_number,
    ACTIONS(915), 1,
      anon_sym_LBRACE,
    ACTIONS(921), 1,
      sym_readonly,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2225), 1,
      anon_sym_LBRACK,
    ACTIONS(2582), 1,
      sym_this,
    ACTIONS(2760), 1,
      sym_identifier,
    ACTIONS(2762), 1,
      anon_sym_typeof,
    ACTIONS(2764), 1,
      anon_sym_new,
    ACTIONS(2766), 1,
      anon_sym_QMARK,
    ACTIONS(2768), 1,
      anon_sym_AMP,
    ACTIONS(2770), 1,
      anon_sym_PIPE,
    ACTIONS(2772), 1,
      anon_sym_keyof,
    STATE(442), 1,
      sym__tuple_type_body,
    STATE(494), 1,
      sym_nested_type_identifier,
    STATE(3020), 1,
      sym_type_parameters,
    STATE(3297), 1,
      sym_nested_identifier,
    STATE(3316), 1,
      sym_formal_parameters,
    ACTIONS(825), 2,
      sym_true,
      sym_false,
    ACTIONS(1655), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(447), 2,
      sym_string,
      sym__number,
    ACTIONS(815), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(514), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(431), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [24397] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_STAR,
    ACTIONS(461), 1,
      anon_sym_QMARK,
    ACTIONS(463), 1,
      anon_sym_AMP,
    ACTIONS(465), 1,
      anon_sym_PIPE,
    ACTIONS(495), 1,
      anon_sym_infer,
    ACTIONS(497), 1,
      anon_sym_keyof,
    ACTIONS(499), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(787), 1,
      anon_sym_typeof,
    ACTIONS(789), 1,
      anon_sym_LPAREN,
    ACTIONS(801), 1,
      anon_sym_new,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(821), 1,
      sym_number,
    ACTIONS(911), 1,
      sym_identifier,
    ACTIONS(915), 1,
      anon_sym_LBRACE,
    ACTIONS(921), 1,
      sym_readonly,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2225), 1,
      anon_sym_LBRACK,
    ACTIONS(2582), 1,
      sym_this,
    STATE(442), 1,
      sym__tuple_type_body,
    STATE(1957), 1,
      sym_nested_type_identifier,
    STATE(3048), 1,
      sym_type_parameters,
    STATE(3296), 1,
      sym_formal_parameters,
    STATE(3297), 1,
      sym_nested_identifier,
    ACTIONS(825), 2,
      sym_true,
      sym_false,
    ACTIONS(1655), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(447), 2,
      sym_string,
      sym__number,
    ACTIONS(815), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2723), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(431), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [24517] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_STAR,
    ACTIONS(461), 1,
      anon_sym_QMARK,
    ACTIONS(463), 1,
      anon_sym_AMP,
    ACTIONS(465), 1,
      anon_sym_PIPE,
    ACTIONS(495), 1,
      anon_sym_infer,
    ACTIONS(497), 1,
      anon_sym_keyof,
    ACTIONS(499), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(787), 1,
      anon_sym_typeof,
    ACTIONS(789), 1,
      anon_sym_LPAREN,
    ACTIONS(801), 1,
      anon_sym_new,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(821), 1,
      sym_number,
    ACTIONS(911), 1,
      sym_identifier,
    ACTIONS(915), 1,
      anon_sym_LBRACE,
    ACTIONS(921), 1,
      sym_readonly,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2225), 1,
      anon_sym_LBRACK,
    ACTIONS(2582), 1,
      sym_this,
    STATE(442), 1,
      sym__tuple_type_body,
    STATE(1957), 1,
      sym_nested_type_identifier,
    STATE(3048), 1,
      sym_type_parameters,
    STATE(3296), 1,
      sym_formal_parameters,
    STATE(3297), 1,
      sym_nested_identifier,
    ACTIONS(825), 2,
      sym_true,
      sym_false,
    ACTIONS(1655), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(447), 2,
      sym_string,
      sym__number,
    ACTIONS(815), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2722), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(431), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [24637] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_STAR,
    ACTIONS(495), 1,
      anon_sym_infer,
    ACTIONS(499), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(789), 1,
      anon_sym_LPAREN,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(821), 1,
      sym_number,
    ACTIONS(915), 1,
      anon_sym_LBRACE,
    ACTIONS(921), 1,
      sym_readonly,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2225), 1,
      anon_sym_LBRACK,
    ACTIONS(2582), 1,
      sym_this,
    ACTIONS(2760), 1,
      sym_identifier,
    ACTIONS(2762), 1,
      anon_sym_typeof,
    ACTIONS(2764), 1,
      anon_sym_new,
    ACTIONS(2766), 1,
      anon_sym_QMARK,
    ACTIONS(2768), 1,
      anon_sym_AMP,
    ACTIONS(2770), 1,
      anon_sym_PIPE,
    ACTIONS(2772), 1,
      anon_sym_keyof,
    STATE(442), 1,
      sym__tuple_type_body,
    STATE(494), 1,
      sym_nested_type_identifier,
    STATE(3020), 1,
      sym_type_parameters,
    STATE(3297), 1,
      sym_nested_identifier,
    STATE(3316), 1,
      sym_formal_parameters,
    ACTIONS(825), 2,
      sym_true,
      sym_false,
    ACTIONS(1655), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(447), 2,
      sym_string,
      sym__number,
    ACTIONS(815), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(422), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(431), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [24757] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(577), 1,
      anon_sym_STAR,
    ACTIONS(589), 1,
      anon_sym_QMARK,
    ACTIONS(591), 1,
      anon_sym_AMP,
    ACTIONS(593), 1,
      anon_sym_PIPE,
    ACTIONS(609), 1,
      anon_sym_infer,
    ACTIONS(611), 1,
      anon_sym_keyof,
    ACTIONS(613), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2420), 1,
      anon_sym_LBRACE,
    ACTIONS(2422), 1,
      anon_sym_typeof,
    ACTIONS(2424), 1,
      anon_sym_LPAREN,
    ACTIONS(2426), 1,
      anon_sym_LBRACK,
    ACTIONS(2428), 1,
      anon_sym_new,
    ACTIONS(2434), 1,
      anon_sym_DQUOTE,
    ACTIONS(2436), 1,
      anon_sym_SQUOTE,
    ACTIONS(2438), 1,
      sym_number,
    ACTIONS(2444), 1,
      sym_readonly,
    ACTIONS(2750), 1,
      sym_identifier,
    ACTIONS(2752), 1,
      sym_this,
    STATE(1983), 1,
      sym_nested_type_identifier,
    STATE(2025), 1,
      sym__tuple_type_body,
    STATE(3157), 1,
      sym_type_parameters,
    STATE(3166), 1,
      sym_nested_identifier,
    STATE(3324), 1,
      sym_formal_parameters,
    ACTIONS(2430), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2442), 2,
      sym_true,
      sym_false,
    STATE(2017), 2,
      sym_string,
      sym__number,
    ACTIONS(2432), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2603), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2018), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [24877] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_STAR,
    ACTIONS(463), 1,
      anon_sym_AMP,
    ACTIONS(465), 1,
      anon_sym_PIPE,
    ACTIONS(495), 1,
      anon_sym_infer,
    ACTIONS(499), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(789), 1,
      anon_sym_LPAREN,
    ACTIONS(801), 1,
      anon_sym_new,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(821), 1,
      sym_number,
    ACTIONS(915), 1,
      anon_sym_LBRACE,
    ACTIONS(921), 1,
      sym_readonly,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2225), 1,
      anon_sym_LBRACK,
    ACTIONS(2758), 1,
      sym_this,
    ACTIONS(2760), 1,
      sym_identifier,
    ACTIONS(2762), 1,
      anon_sym_typeof,
    ACTIONS(2766), 1,
      anon_sym_QMARK,
    ACTIONS(2772), 1,
      anon_sym_keyof,
    STATE(442), 1,
      sym__tuple_type_body,
    STATE(494), 1,
      sym_nested_type_identifier,
    STATE(3048), 1,
      sym_type_parameters,
    STATE(3296), 1,
      sym_formal_parameters,
    STATE(3297), 1,
      sym_nested_identifier,
    ACTIONS(825), 2,
      sym_true,
      sym_false,
    ACTIONS(1655), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(447), 2,
      sym_string,
      sym__number,
    ACTIONS(815), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2756), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(423), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [24997] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_STAR,
    ACTIONS(495), 1,
      anon_sym_infer,
    ACTIONS(499), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(789), 1,
      anon_sym_LPAREN,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(821), 1,
      sym_number,
    ACTIONS(915), 1,
      anon_sym_LBRACE,
    ACTIONS(921), 1,
      sym_readonly,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2225), 1,
      anon_sym_LBRACK,
    ACTIONS(2582), 1,
      sym_this,
    ACTIONS(2760), 1,
      sym_identifier,
    ACTIONS(2762), 1,
      anon_sym_typeof,
    ACTIONS(2764), 1,
      anon_sym_new,
    ACTIONS(2766), 1,
      anon_sym_QMARK,
    ACTIONS(2768), 1,
      anon_sym_AMP,
    ACTIONS(2770), 1,
      anon_sym_PIPE,
    ACTIONS(2772), 1,
      anon_sym_keyof,
    STATE(442), 1,
      sym__tuple_type_body,
    STATE(494), 1,
      sym_nested_type_identifier,
    STATE(3020), 1,
      sym_type_parameters,
    STATE(3297), 1,
      sym_nested_identifier,
    STATE(3316), 1,
      sym_formal_parameters,
    ACTIONS(825), 2,
      sym_true,
      sym_false,
    ACTIONS(1655), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(447), 2,
      sym_string,
      sym__number,
    ACTIONS(815), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(424), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(431), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [25117] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2219), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2231), 1,
      anon_sym_EQ,
    ACTIONS(1113), 15,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2221), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1111), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [25191] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_STAR,
    ACTIONS(495), 1,
      anon_sym_infer,
    ACTIONS(499), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(789), 1,
      anon_sym_LPAREN,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(821), 1,
      sym_number,
    ACTIONS(915), 1,
      anon_sym_LBRACE,
    ACTIONS(921), 1,
      sym_readonly,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2225), 1,
      anon_sym_LBRACK,
    ACTIONS(2582), 1,
      sym_this,
    ACTIONS(2760), 1,
      sym_identifier,
    ACTIONS(2762), 1,
      anon_sym_typeof,
    ACTIONS(2764), 1,
      anon_sym_new,
    ACTIONS(2766), 1,
      anon_sym_QMARK,
    ACTIONS(2768), 1,
      anon_sym_AMP,
    ACTIONS(2770), 1,
      anon_sym_PIPE,
    ACTIONS(2772), 1,
      anon_sym_keyof,
    STATE(442), 1,
      sym__tuple_type_body,
    STATE(494), 1,
      sym_nested_type_identifier,
    STATE(3020), 1,
      sym_type_parameters,
    STATE(3297), 1,
      sym_nested_identifier,
    STATE(3316), 1,
      sym_formal_parameters,
    ACTIONS(825), 2,
      sym_true,
      sym_false,
    ACTIONS(1655), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(447), 2,
      sym_string,
      sym__number,
    ACTIONS(815), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(429), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(431), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [25311] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2450), 1,
      anon_sym_STAR,
    ACTIONS(2452), 1,
      anon_sym_LBRACE,
    ACTIONS(2454), 1,
      anon_sym_typeof,
    ACTIONS(2456), 1,
      anon_sym_LPAREN,
    ACTIONS(2458), 1,
      anon_sym_LBRACK,
    ACTIONS(2460), 1,
      anon_sym_new,
    ACTIONS(2462), 1,
      anon_sym_QMARK,
    ACTIONS(2464), 1,
      anon_sym_AMP,
    ACTIONS(2466), 1,
      anon_sym_PIPE,
    ACTIONS(2472), 1,
      anon_sym_DQUOTE,
    ACTIONS(2474), 1,
      anon_sym_SQUOTE,
    ACTIONS(2476), 1,
      sym_number,
    ACTIONS(2482), 1,
      sym_readonly,
    ACTIONS(2486), 1,
      anon_sym_infer,
    ACTIONS(2488), 1,
      anon_sym_keyof,
    ACTIONS(2490), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2744), 1,
      sym_identifier,
    ACTIONS(2746), 1,
      sym_this,
    STATE(2062), 1,
      sym_nested_type_identifier,
    STATE(2119), 1,
      sym__tuple_type_body,
    STATE(3122), 1,
      sym_type_parameters,
    STATE(3212), 1,
      sym_nested_identifier,
    STATE(3347), 1,
      sym_formal_parameters,
    ACTIONS(2468), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2480), 2,
      sym_true,
      sym_false,
    STATE(2122), 2,
      sym_string,
      sym__number,
    ACTIONS(2470), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2148), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2123), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [25431] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2270), 23,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2272), 33,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [25495] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_STAR,
    ACTIONS(461), 1,
      anon_sym_QMARK,
    ACTIONS(463), 1,
      anon_sym_AMP,
    ACTIONS(465), 1,
      anon_sym_PIPE,
    ACTIONS(495), 1,
      anon_sym_infer,
    ACTIONS(497), 1,
      anon_sym_keyof,
    ACTIONS(499), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(787), 1,
      anon_sym_typeof,
    ACTIONS(789), 1,
      anon_sym_LPAREN,
    ACTIONS(801), 1,
      anon_sym_new,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(821), 1,
      sym_number,
    ACTIONS(911), 1,
      sym_identifier,
    ACTIONS(915), 1,
      anon_sym_LBRACE,
    ACTIONS(921), 1,
      sym_readonly,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2225), 1,
      anon_sym_LBRACK,
    ACTIONS(2582), 1,
      sym_this,
    STATE(442), 1,
      sym__tuple_type_body,
    STATE(1957), 1,
      sym_nested_type_identifier,
    STATE(3048), 1,
      sym_type_parameters,
    STATE(3296), 1,
      sym_formal_parameters,
    STATE(3297), 1,
      sym_nested_identifier,
    ACTIONS(825), 2,
      sym_true,
      sym_false,
    ACTIONS(1655), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(447), 2,
      sym_string,
      sym__number,
    ACTIONS(815), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2706), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(431), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [25615] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_STAR,
    ACTIONS(461), 1,
      anon_sym_QMARK,
    ACTIONS(463), 1,
      anon_sym_AMP,
    ACTIONS(465), 1,
      anon_sym_PIPE,
    ACTIONS(495), 1,
      anon_sym_infer,
    ACTIONS(497), 1,
      anon_sym_keyof,
    ACTIONS(499), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(787), 1,
      anon_sym_typeof,
    ACTIONS(789), 1,
      anon_sym_LPAREN,
    ACTIONS(801), 1,
      anon_sym_new,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(821), 1,
      sym_number,
    ACTIONS(911), 1,
      sym_identifier,
    ACTIONS(915), 1,
      anon_sym_LBRACE,
    ACTIONS(921), 1,
      sym_readonly,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2225), 1,
      anon_sym_LBRACK,
    ACTIONS(2582), 1,
      sym_this,
    STATE(442), 1,
      sym__tuple_type_body,
    STATE(1957), 1,
      sym_nested_type_identifier,
    STATE(3048), 1,
      sym_type_parameters,
    STATE(3296), 1,
      sym_formal_parameters,
    STATE(3297), 1,
      sym_nested_identifier,
    ACTIONS(825), 2,
      sym_true,
      sym_false,
    ACTIONS(1655), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(447), 2,
      sym_string,
      sym__number,
    ACTIONS(815), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1966), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(431), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [25735] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(931), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(961), 1,
      anon_sym_EQ,
    ACTIONS(1069), 1,
      anon_sym_EQ_GT,
    ACTIONS(1223), 1,
      anon_sym_LBRACK,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(2197), 1,
      anon_sym_LPAREN,
    ACTIONS(2199), 1,
      anon_sym_LT,
    STATE(1378), 1,
      sym_type_arguments,
    STATE(1581), 1,
      sym_arguments,
    ACTIONS(1637), 11,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(803), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1635), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [25819] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_STAR,
    ACTIONS(461), 1,
      anon_sym_QMARK,
    ACTIONS(463), 1,
      anon_sym_AMP,
    ACTIONS(465), 1,
      anon_sym_PIPE,
    ACTIONS(495), 1,
      anon_sym_infer,
    ACTIONS(497), 1,
      anon_sym_keyof,
    ACTIONS(499), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(787), 1,
      anon_sym_typeof,
    ACTIONS(789), 1,
      anon_sym_LPAREN,
    ACTIONS(801), 1,
      anon_sym_new,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(821), 1,
      sym_number,
    ACTIONS(911), 1,
      sym_identifier,
    ACTIONS(915), 1,
      anon_sym_LBRACE,
    ACTIONS(921), 1,
      sym_readonly,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2225), 1,
      anon_sym_LBRACK,
    ACTIONS(2582), 1,
      sym_this,
    STATE(442), 1,
      sym__tuple_type_body,
    STATE(1957), 1,
      sym_nested_type_identifier,
    STATE(3048), 1,
      sym_type_parameters,
    STATE(3296), 1,
      sym_formal_parameters,
    STATE(3297), 1,
      sym_nested_identifier,
    ACTIONS(825), 2,
      sym_true,
      sym_false,
    ACTIONS(1655), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(447), 2,
      sym_string,
      sym__number,
    ACTIONS(815), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2258), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(431), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [25939] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(693), 1,
      anon_sym_DQUOTE,
    ACTIONS(695), 1,
      anon_sym_SQUOTE,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2492), 1,
      sym_identifier,
    ACTIONS(2494), 1,
      anon_sym_STAR,
    ACTIONS(2496), 1,
      anon_sym_LBRACE,
    ACTIONS(2498), 1,
      anon_sym_typeof,
    ACTIONS(2500), 1,
      anon_sym_LPAREN,
    ACTIONS(2502), 1,
      anon_sym_LBRACK,
    ACTIONS(2504), 1,
      anon_sym_new,
    ACTIONS(2506), 1,
      anon_sym_QMARK,
    ACTIONS(2508), 1,
      anon_sym_AMP,
    ACTIONS(2510), 1,
      anon_sym_PIPE,
    ACTIONS(2516), 1,
      sym_number,
    ACTIONS(2518), 1,
      sym_this,
    ACTIONS(2522), 1,
      sym_readonly,
    ACTIONS(2524), 1,
      anon_sym_infer,
    ACTIONS(2526), 1,
      anon_sym_keyof,
    ACTIONS(2528), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1497), 1,
      sym_nested_type_identifier,
    STATE(1567), 1,
      sym__tuple_type_body,
    STATE(2997), 1,
      sym_type_parameters,
    STATE(3219), 1,
      sym_nested_identifier,
    STATE(3288), 1,
      sym_formal_parameters,
    ACTIONS(2512), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2520), 2,
      sym_true,
      sym_false,
    STATE(1564), 2,
      sym_string,
      sym__number,
    ACTIONS(2514), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1585), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(1566), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [26059] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(693), 1,
      anon_sym_DQUOTE,
    ACTIONS(695), 1,
      anon_sym_SQUOTE,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2492), 1,
      sym_identifier,
    ACTIONS(2494), 1,
      anon_sym_STAR,
    ACTIONS(2496), 1,
      anon_sym_LBRACE,
    ACTIONS(2498), 1,
      anon_sym_typeof,
    ACTIONS(2500), 1,
      anon_sym_LPAREN,
    ACTIONS(2502), 1,
      anon_sym_LBRACK,
    ACTIONS(2504), 1,
      anon_sym_new,
    ACTIONS(2506), 1,
      anon_sym_QMARK,
    ACTIONS(2508), 1,
      anon_sym_AMP,
    ACTIONS(2510), 1,
      anon_sym_PIPE,
    ACTIONS(2516), 1,
      sym_number,
    ACTIONS(2518), 1,
      sym_this,
    ACTIONS(2522), 1,
      sym_readonly,
    ACTIONS(2524), 1,
      anon_sym_infer,
    ACTIONS(2526), 1,
      anon_sym_keyof,
    ACTIONS(2528), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1497), 1,
      sym_nested_type_identifier,
    STATE(1567), 1,
      sym__tuple_type_body,
    STATE(2997), 1,
      sym_type_parameters,
    STATE(3219), 1,
      sym_nested_identifier,
    STATE(3288), 1,
      sym_formal_parameters,
    ACTIONS(2512), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2520), 2,
      sym_true,
      sym_false,
    STATE(1564), 2,
      sym_string,
      sym__number,
    ACTIONS(2514), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1540), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(1566), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [26179] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_STAR,
    ACTIONS(461), 1,
      anon_sym_QMARK,
    ACTIONS(463), 1,
      anon_sym_AMP,
    ACTIONS(465), 1,
      anon_sym_PIPE,
    ACTIONS(495), 1,
      anon_sym_infer,
    ACTIONS(497), 1,
      anon_sym_keyof,
    ACTIONS(499), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(787), 1,
      anon_sym_typeof,
    ACTIONS(789), 1,
      anon_sym_LPAREN,
    ACTIONS(801), 1,
      anon_sym_new,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(821), 1,
      sym_number,
    ACTIONS(911), 1,
      sym_identifier,
    ACTIONS(915), 1,
      anon_sym_LBRACE,
    ACTIONS(921), 1,
      sym_readonly,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2225), 1,
      anon_sym_LBRACK,
    ACTIONS(2582), 1,
      sym_this,
    STATE(442), 1,
      sym__tuple_type_body,
    STATE(1957), 1,
      sym_nested_type_identifier,
    STATE(3048), 1,
      sym_type_parameters,
    STATE(3296), 1,
      sym_formal_parameters,
    STATE(3297), 1,
      sym_nested_identifier,
    ACTIONS(825), 2,
      sym_true,
      sym_false,
    ACTIONS(1655), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(447), 2,
      sym_string,
      sym__number,
    ACTIONS(815), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2665), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(431), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [26299] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2450), 1,
      anon_sym_STAR,
    ACTIONS(2452), 1,
      anon_sym_LBRACE,
    ACTIONS(2454), 1,
      anon_sym_typeof,
    ACTIONS(2456), 1,
      anon_sym_LPAREN,
    ACTIONS(2458), 1,
      anon_sym_LBRACK,
    ACTIONS(2460), 1,
      anon_sym_new,
    ACTIONS(2462), 1,
      anon_sym_QMARK,
    ACTIONS(2464), 1,
      anon_sym_AMP,
    ACTIONS(2466), 1,
      anon_sym_PIPE,
    ACTIONS(2472), 1,
      anon_sym_DQUOTE,
    ACTIONS(2474), 1,
      anon_sym_SQUOTE,
    ACTIONS(2476), 1,
      sym_number,
    ACTIONS(2482), 1,
      sym_readonly,
    ACTIONS(2486), 1,
      anon_sym_infer,
    ACTIONS(2488), 1,
      anon_sym_keyof,
    ACTIONS(2490), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2744), 1,
      sym_identifier,
    ACTIONS(2746), 1,
      sym_this,
    STATE(2062), 1,
      sym_nested_type_identifier,
    STATE(2119), 1,
      sym__tuple_type_body,
    STATE(3122), 1,
      sym_type_parameters,
    STATE(3212), 1,
      sym_nested_identifier,
    STATE(3347), 1,
      sym_formal_parameters,
    ACTIONS(2468), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2480), 2,
      sym_true,
      sym_false,
    STATE(2122), 2,
      sym_string,
      sym__number,
    ACTIONS(2470), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2143), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2123), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [26419] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2450), 1,
      anon_sym_STAR,
    ACTIONS(2452), 1,
      anon_sym_LBRACE,
    ACTIONS(2454), 1,
      anon_sym_typeof,
    ACTIONS(2456), 1,
      anon_sym_LPAREN,
    ACTIONS(2458), 1,
      anon_sym_LBRACK,
    ACTIONS(2460), 1,
      anon_sym_new,
    ACTIONS(2462), 1,
      anon_sym_QMARK,
    ACTIONS(2464), 1,
      anon_sym_AMP,
    ACTIONS(2466), 1,
      anon_sym_PIPE,
    ACTIONS(2472), 1,
      anon_sym_DQUOTE,
    ACTIONS(2474), 1,
      anon_sym_SQUOTE,
    ACTIONS(2476), 1,
      sym_number,
    ACTIONS(2482), 1,
      sym_readonly,
    ACTIONS(2486), 1,
      anon_sym_infer,
    ACTIONS(2488), 1,
      anon_sym_keyof,
    ACTIONS(2490), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2744), 1,
      sym_identifier,
    ACTIONS(2746), 1,
      sym_this,
    STATE(2062), 1,
      sym_nested_type_identifier,
    STATE(2119), 1,
      sym__tuple_type_body,
    STATE(3122), 1,
      sym_type_parameters,
    STATE(3212), 1,
      sym_nested_identifier,
    STATE(3347), 1,
      sym_formal_parameters,
    ACTIONS(2468), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2480), 2,
      sym_true,
      sym_false,
    STATE(2122), 2,
      sym_string,
      sym__number,
    ACTIONS(2470), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2167), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2123), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [26539] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(577), 1,
      anon_sym_STAR,
    ACTIONS(589), 1,
      anon_sym_QMARK,
    ACTIONS(591), 1,
      anon_sym_AMP,
    ACTIONS(593), 1,
      anon_sym_PIPE,
    ACTIONS(609), 1,
      anon_sym_infer,
    ACTIONS(611), 1,
      anon_sym_keyof,
    ACTIONS(613), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2420), 1,
      anon_sym_LBRACE,
    ACTIONS(2422), 1,
      anon_sym_typeof,
    ACTIONS(2424), 1,
      anon_sym_LPAREN,
    ACTIONS(2426), 1,
      anon_sym_LBRACK,
    ACTIONS(2428), 1,
      anon_sym_new,
    ACTIONS(2434), 1,
      anon_sym_DQUOTE,
    ACTIONS(2436), 1,
      anon_sym_SQUOTE,
    ACTIONS(2438), 1,
      sym_number,
    ACTIONS(2444), 1,
      sym_readonly,
    ACTIONS(2750), 1,
      sym_identifier,
    ACTIONS(2752), 1,
      sym_this,
    STATE(1983), 1,
      sym_nested_type_identifier,
    STATE(2025), 1,
      sym__tuple_type_body,
    STATE(3157), 1,
      sym_type_parameters,
    STATE(3166), 1,
      sym_nested_identifier,
    STATE(3324), 1,
      sym_formal_parameters,
    ACTIONS(2430), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2442), 2,
      sym_true,
      sym_false,
    STATE(2017), 2,
      sym_string,
      sym__number,
    ACTIONS(2432), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2089), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2018), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [26659] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_STAR,
    ACTIONS(461), 1,
      anon_sym_QMARK,
    ACTIONS(463), 1,
      anon_sym_AMP,
    ACTIONS(465), 1,
      anon_sym_PIPE,
    ACTIONS(495), 1,
      anon_sym_infer,
    ACTIONS(497), 1,
      anon_sym_keyof,
    ACTIONS(499), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(787), 1,
      anon_sym_typeof,
    ACTIONS(789), 1,
      anon_sym_LPAREN,
    ACTIONS(801), 1,
      anon_sym_new,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(821), 1,
      sym_number,
    ACTIONS(911), 1,
      sym_identifier,
    ACTIONS(915), 1,
      anon_sym_LBRACE,
    ACTIONS(921), 1,
      sym_readonly,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2225), 1,
      anon_sym_LBRACK,
    ACTIONS(2582), 1,
      sym_this,
    STATE(442), 1,
      sym__tuple_type_body,
    STATE(1957), 1,
      sym_nested_type_identifier,
    STATE(3048), 1,
      sym_type_parameters,
    STATE(3296), 1,
      sym_formal_parameters,
    STATE(3297), 1,
      sym_nested_identifier,
    ACTIONS(825), 2,
      sym_true,
      sym_false,
    ACTIONS(1655), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(447), 2,
      sym_string,
      sym__number,
    ACTIONS(815), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2657), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(431), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [26779] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_STAR,
    ACTIONS(461), 1,
      anon_sym_QMARK,
    ACTIONS(463), 1,
      anon_sym_AMP,
    ACTIONS(465), 1,
      anon_sym_PIPE,
    ACTIONS(495), 1,
      anon_sym_infer,
    ACTIONS(497), 1,
      anon_sym_keyof,
    ACTIONS(499), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(787), 1,
      anon_sym_typeof,
    ACTIONS(789), 1,
      anon_sym_LPAREN,
    ACTIONS(801), 1,
      anon_sym_new,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(821), 1,
      sym_number,
    ACTIONS(911), 1,
      sym_identifier,
    ACTIONS(915), 1,
      anon_sym_LBRACE,
    ACTIONS(921), 1,
      sym_readonly,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2225), 1,
      anon_sym_LBRACK,
    ACTIONS(2582), 1,
      sym_this,
    STATE(442), 1,
      sym__tuple_type_body,
    STATE(1957), 1,
      sym_nested_type_identifier,
    STATE(3048), 1,
      sym_type_parameters,
    STATE(3296), 1,
      sym_formal_parameters,
    STATE(3297), 1,
      sym_nested_identifier,
    ACTIONS(825), 2,
      sym_true,
      sym_false,
    ACTIONS(1655), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(447), 2,
      sym_string,
      sym__number,
    ACTIONS(815), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2642), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(431), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [26899] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(693), 1,
      anon_sym_DQUOTE,
    ACTIONS(695), 1,
      anon_sym_SQUOTE,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2492), 1,
      sym_identifier,
    ACTIONS(2494), 1,
      anon_sym_STAR,
    ACTIONS(2496), 1,
      anon_sym_LBRACE,
    ACTIONS(2498), 1,
      anon_sym_typeof,
    ACTIONS(2500), 1,
      anon_sym_LPAREN,
    ACTIONS(2502), 1,
      anon_sym_LBRACK,
    ACTIONS(2504), 1,
      anon_sym_new,
    ACTIONS(2506), 1,
      anon_sym_QMARK,
    ACTIONS(2508), 1,
      anon_sym_AMP,
    ACTIONS(2510), 1,
      anon_sym_PIPE,
    ACTIONS(2516), 1,
      sym_number,
    ACTIONS(2518), 1,
      sym_this,
    ACTIONS(2522), 1,
      sym_readonly,
    ACTIONS(2524), 1,
      anon_sym_infer,
    ACTIONS(2526), 1,
      anon_sym_keyof,
    ACTIONS(2528), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1497), 1,
      sym_nested_type_identifier,
    STATE(1567), 1,
      sym__tuple_type_body,
    STATE(2997), 1,
      sym_type_parameters,
    STATE(3219), 1,
      sym_nested_identifier,
    STATE(3288), 1,
      sym_formal_parameters,
    ACTIONS(2512), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2520), 2,
      sym_true,
      sym_false,
    STATE(1564), 2,
      sym_string,
      sym__number,
    ACTIONS(2514), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1530), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(1566), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [27019] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_STAR,
    ACTIONS(461), 1,
      anon_sym_QMARK,
    ACTIONS(463), 1,
      anon_sym_AMP,
    ACTIONS(465), 1,
      anon_sym_PIPE,
    ACTIONS(495), 1,
      anon_sym_infer,
    ACTIONS(497), 1,
      anon_sym_keyof,
    ACTIONS(499), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(787), 1,
      anon_sym_typeof,
    ACTIONS(789), 1,
      anon_sym_LPAREN,
    ACTIONS(801), 1,
      anon_sym_new,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(821), 1,
      sym_number,
    ACTIONS(911), 1,
      sym_identifier,
    ACTIONS(915), 1,
      anon_sym_LBRACE,
    ACTIONS(921), 1,
      sym_readonly,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2225), 1,
      anon_sym_LBRACK,
    ACTIONS(2582), 1,
      sym_this,
    STATE(442), 1,
      sym__tuple_type_body,
    STATE(1957), 1,
      sym_nested_type_identifier,
    STATE(3048), 1,
      sym_type_parameters,
    STATE(3296), 1,
      sym_formal_parameters,
    STATE(3297), 1,
      sym_nested_identifier,
    ACTIONS(825), 2,
      sym_true,
      sym_false,
    ACTIONS(1655), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(447), 2,
      sym_string,
      sym__number,
    ACTIONS(815), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2629), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(431), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [27139] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1290), 1,
      anon_sym_COLON,
    ACTIONS(2313), 1,
      anon_sym_LBRACK,
    ACTIONS(2318), 1,
      anon_sym_DOT,
    ACTIONS(2320), 1,
      anon_sym_EQ_GT,
    ACTIONS(2322), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2406), 1,
      anon_sym_EQ,
    ACTIONS(1113), 13,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2221), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1111), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [27217] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_STAR,
    ACTIONS(461), 1,
      anon_sym_QMARK,
    ACTIONS(463), 1,
      anon_sym_AMP,
    ACTIONS(465), 1,
      anon_sym_PIPE,
    ACTIONS(495), 1,
      anon_sym_infer,
    ACTIONS(497), 1,
      anon_sym_keyof,
    ACTIONS(499), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(787), 1,
      anon_sym_typeof,
    ACTIONS(789), 1,
      anon_sym_LPAREN,
    ACTIONS(801), 1,
      anon_sym_new,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(821), 1,
      sym_number,
    ACTIONS(911), 1,
      sym_identifier,
    ACTIONS(915), 1,
      anon_sym_LBRACE,
    ACTIONS(921), 1,
      sym_readonly,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2225), 1,
      anon_sym_LBRACK,
    ACTIONS(2582), 1,
      sym_this,
    STATE(442), 1,
      sym__tuple_type_body,
    STATE(1957), 1,
      sym_nested_type_identifier,
    STATE(3048), 1,
      sym_type_parameters,
    STATE(3296), 1,
      sym_formal_parameters,
    STATE(3297), 1,
      sym_nested_identifier,
    ACTIONS(825), 2,
      sym_true,
      sym_false,
    ACTIONS(1655), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(447), 2,
      sym_string,
      sym__number,
    ACTIONS(815), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2280), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(431), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [27337] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_STAR,
    ACTIONS(461), 1,
      anon_sym_QMARK,
    ACTIONS(463), 1,
      anon_sym_AMP,
    ACTIONS(465), 1,
      anon_sym_PIPE,
    ACTIONS(495), 1,
      anon_sym_infer,
    ACTIONS(497), 1,
      anon_sym_keyof,
    ACTIONS(499), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(787), 1,
      anon_sym_typeof,
    ACTIONS(789), 1,
      anon_sym_LPAREN,
    ACTIONS(801), 1,
      anon_sym_new,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(821), 1,
      sym_number,
    ACTIONS(911), 1,
      sym_identifier,
    ACTIONS(915), 1,
      anon_sym_LBRACE,
    ACTIONS(921), 1,
      sym_readonly,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2225), 1,
      anon_sym_LBRACK,
    ACTIONS(2582), 1,
      sym_this,
    STATE(442), 1,
      sym__tuple_type_body,
    STATE(1957), 1,
      sym_nested_type_identifier,
    STATE(3048), 1,
      sym_type_parameters,
    STATE(3296), 1,
      sym_formal_parameters,
    STATE(3297), 1,
      sym_nested_identifier,
    ACTIONS(825), 2,
      sym_true,
      sym_false,
    ACTIONS(1655), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(447), 2,
      sym_string,
      sym__number,
    ACTIONS(815), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2645), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(431), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [27457] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(577), 1,
      anon_sym_STAR,
    ACTIONS(589), 1,
      anon_sym_QMARK,
    ACTIONS(591), 1,
      anon_sym_AMP,
    ACTIONS(593), 1,
      anon_sym_PIPE,
    ACTIONS(609), 1,
      anon_sym_infer,
    ACTIONS(611), 1,
      anon_sym_keyof,
    ACTIONS(613), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2420), 1,
      anon_sym_LBRACE,
    ACTIONS(2422), 1,
      anon_sym_typeof,
    ACTIONS(2424), 1,
      anon_sym_LPAREN,
    ACTIONS(2426), 1,
      anon_sym_LBRACK,
    ACTIONS(2428), 1,
      anon_sym_new,
    ACTIONS(2434), 1,
      anon_sym_DQUOTE,
    ACTIONS(2436), 1,
      anon_sym_SQUOTE,
    ACTIONS(2438), 1,
      sym_number,
    ACTIONS(2444), 1,
      sym_readonly,
    ACTIONS(2750), 1,
      sym_identifier,
    ACTIONS(2752), 1,
      sym_this,
    STATE(1983), 1,
      sym_nested_type_identifier,
    STATE(2025), 1,
      sym__tuple_type_body,
    STATE(3157), 1,
      sym_type_parameters,
    STATE(3166), 1,
      sym_nested_identifier,
    STATE(3324), 1,
      sym_formal_parameters,
    ACTIONS(2430), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2442), 2,
      sym_true,
      sym_false,
    STATE(2017), 2,
      sym_string,
      sym__number,
    ACTIONS(2432), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2497), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2018), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [27577] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_STAR,
    ACTIONS(461), 1,
      anon_sym_QMARK,
    ACTIONS(463), 1,
      anon_sym_AMP,
    ACTIONS(465), 1,
      anon_sym_PIPE,
    ACTIONS(495), 1,
      anon_sym_infer,
    ACTIONS(497), 1,
      anon_sym_keyof,
    ACTIONS(499), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(787), 1,
      anon_sym_typeof,
    ACTIONS(789), 1,
      anon_sym_LPAREN,
    ACTIONS(801), 1,
      anon_sym_new,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(821), 1,
      sym_number,
    ACTIONS(911), 1,
      sym_identifier,
    ACTIONS(915), 1,
      anon_sym_LBRACE,
    ACTIONS(921), 1,
      sym_readonly,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2225), 1,
      anon_sym_LBRACK,
    ACTIONS(2582), 1,
      sym_this,
    STATE(442), 1,
      sym__tuple_type_body,
    STATE(1957), 1,
      sym_nested_type_identifier,
    STATE(3048), 1,
      sym_type_parameters,
    STATE(3296), 1,
      sym_formal_parameters,
    STATE(3297), 1,
      sym_nested_identifier,
    ACTIONS(825), 2,
      sym_true,
      sym_false,
    ACTIONS(1655), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(447), 2,
      sym_string,
      sym__number,
    ACTIONS(815), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2358), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(431), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [27697] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(777), 1,
      anon_sym_EQ,
    ACTIONS(797), 1,
      anon_sym_EQ_GT,
    ACTIONS(799), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1189), 1,
      anon_sym_extends,
    ACTIONS(1639), 1,
      anon_sym_LBRACK,
    ACTIONS(1641), 1,
      anon_sym_DOT,
    ACTIONS(1733), 1,
      anon_sym_QMARK,
    ACTIONS(2798), 1,
      anon_sym_RPAREN,
    ACTIONS(784), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(2327), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(813), 10,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(803), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(780), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [27783] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(475), 1,
      anon_sym_DQUOTE,
    ACTIONS(477), 1,
      anon_sym_SQUOTE,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2330), 1,
      sym_identifier,
    ACTIONS(2332), 1,
      anon_sym_STAR,
    ACTIONS(2334), 1,
      anon_sym_LBRACE,
    ACTIONS(2336), 1,
      anon_sym_typeof,
    ACTIONS(2338), 1,
      anon_sym_LPAREN,
    ACTIONS(2340), 1,
      anon_sym_LBRACK,
    ACTIONS(2342), 1,
      anon_sym_new,
    ACTIONS(2344), 1,
      anon_sym_QMARK,
    ACTIONS(2346), 1,
      anon_sym_AMP,
    ACTIONS(2348), 1,
      anon_sym_PIPE,
    ACTIONS(2354), 1,
      sym_number,
    ACTIONS(2356), 1,
      sym_this,
    ACTIONS(2360), 1,
      sym_readonly,
    ACTIONS(2362), 1,
      anon_sym_infer,
    ACTIONS(2364), 1,
      anon_sym_keyof,
    ACTIONS(2366), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1028), 1,
      sym_nested_type_identifier,
    STATE(1082), 1,
      sym__tuple_type_body,
    STATE(3078), 1,
      sym_type_parameters,
    STATE(3195), 1,
      sym_nested_identifier,
    STATE(3385), 1,
      sym_formal_parameters,
    ACTIONS(2350), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2358), 2,
      sym_true,
      sym_false,
    STATE(1087), 2,
      sym_string,
      sym__number,
    ACTIONS(2352), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1083), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(1084), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [27903] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(577), 1,
      anon_sym_STAR,
    ACTIONS(589), 1,
      anon_sym_QMARK,
    ACTIONS(591), 1,
      anon_sym_AMP,
    ACTIONS(593), 1,
      anon_sym_PIPE,
    ACTIONS(609), 1,
      anon_sym_infer,
    ACTIONS(611), 1,
      anon_sym_keyof,
    ACTIONS(613), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2420), 1,
      anon_sym_LBRACE,
    ACTIONS(2422), 1,
      anon_sym_typeof,
    ACTIONS(2424), 1,
      anon_sym_LPAREN,
    ACTIONS(2426), 1,
      anon_sym_LBRACK,
    ACTIONS(2428), 1,
      anon_sym_new,
    ACTIONS(2434), 1,
      anon_sym_DQUOTE,
    ACTIONS(2436), 1,
      anon_sym_SQUOTE,
    ACTIONS(2438), 1,
      sym_number,
    ACTIONS(2444), 1,
      sym_readonly,
    ACTIONS(2750), 1,
      sym_identifier,
    ACTIONS(2752), 1,
      sym_this,
    STATE(1983), 1,
      sym_nested_type_identifier,
    STATE(2025), 1,
      sym__tuple_type_body,
    STATE(3157), 1,
      sym_type_parameters,
    STATE(3166), 1,
      sym_nested_identifier,
    STATE(3324), 1,
      sym_formal_parameters,
    ACTIONS(2430), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2442), 2,
      sym_true,
      sym_false,
    STATE(2017), 2,
      sym_string,
      sym__number,
    ACTIONS(2432), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2040), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2018), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [28023] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2274), 23,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2276), 33,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [28087] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_STAR,
    ACTIONS(461), 1,
      anon_sym_QMARK,
    ACTIONS(463), 1,
      anon_sym_AMP,
    ACTIONS(465), 1,
      anon_sym_PIPE,
    ACTIONS(495), 1,
      anon_sym_infer,
    ACTIONS(497), 1,
      anon_sym_keyof,
    ACTIONS(499), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(787), 1,
      anon_sym_typeof,
    ACTIONS(789), 1,
      anon_sym_LPAREN,
    ACTIONS(801), 1,
      anon_sym_new,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(821), 1,
      sym_number,
    ACTIONS(911), 1,
      sym_identifier,
    ACTIONS(915), 1,
      anon_sym_LBRACE,
    ACTIONS(921), 1,
      sym_readonly,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2225), 1,
      anon_sym_LBRACK,
    ACTIONS(2582), 1,
      sym_this,
    STATE(442), 1,
      sym__tuple_type_body,
    STATE(1957), 1,
      sym_nested_type_identifier,
    STATE(3048), 1,
      sym_type_parameters,
    STATE(3296), 1,
      sym_formal_parameters,
    STATE(3297), 1,
      sym_nested_identifier,
    ACTIONS(825), 2,
      sym_true,
      sym_false,
    ACTIONS(1655), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(447), 2,
      sym_string,
      sym__number,
    ACTIONS(815), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2624), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(431), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [28207] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_STAR,
    ACTIONS(461), 1,
      anon_sym_QMARK,
    ACTIONS(463), 1,
      anon_sym_AMP,
    ACTIONS(465), 1,
      anon_sym_PIPE,
    ACTIONS(495), 1,
      anon_sym_infer,
    ACTIONS(497), 1,
      anon_sym_keyof,
    ACTIONS(499), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(787), 1,
      anon_sym_typeof,
    ACTIONS(789), 1,
      anon_sym_LPAREN,
    ACTIONS(801), 1,
      anon_sym_new,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(821), 1,
      sym_number,
    ACTIONS(911), 1,
      sym_identifier,
    ACTIONS(915), 1,
      anon_sym_LBRACE,
    ACTIONS(921), 1,
      sym_readonly,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2225), 1,
      anon_sym_LBRACK,
    ACTIONS(2582), 1,
      sym_this,
    STATE(442), 1,
      sym__tuple_type_body,
    STATE(1957), 1,
      sym_nested_type_identifier,
    STATE(3048), 1,
      sym_type_parameters,
    STATE(3296), 1,
      sym_formal_parameters,
    STATE(3297), 1,
      sym_nested_identifier,
    ACTIONS(825), 2,
      sym_true,
      sym_false,
    ACTIONS(1655), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(447), 2,
      sym_string,
      sym__number,
    ACTIONS(815), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2625), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(431), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [28327] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_STAR,
    ACTIONS(461), 1,
      anon_sym_QMARK,
    ACTIONS(463), 1,
      anon_sym_AMP,
    ACTIONS(465), 1,
      anon_sym_PIPE,
    ACTIONS(495), 1,
      anon_sym_infer,
    ACTIONS(497), 1,
      anon_sym_keyof,
    ACTIONS(499), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(787), 1,
      anon_sym_typeof,
    ACTIONS(789), 1,
      anon_sym_LPAREN,
    ACTIONS(801), 1,
      anon_sym_new,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(821), 1,
      sym_number,
    ACTIONS(911), 1,
      sym_identifier,
    ACTIONS(915), 1,
      anon_sym_LBRACE,
    ACTIONS(921), 1,
      sym_readonly,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2225), 1,
      anon_sym_LBRACK,
    ACTIONS(2582), 1,
      sym_this,
    STATE(442), 1,
      sym__tuple_type_body,
    STATE(1957), 1,
      sym_nested_type_identifier,
    STATE(3048), 1,
      sym_type_parameters,
    STATE(3296), 1,
      sym_formal_parameters,
    STATE(3297), 1,
      sym_nested_identifier,
    ACTIONS(825), 2,
      sym_true,
      sym_false,
    ACTIONS(1655), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(447), 2,
      sym_string,
      sym__number,
    ACTIONS(815), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2633), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(431), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [28447] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2197), 1,
      anon_sym_LPAREN,
    ACTIONS(2199), 1,
      anon_sym_LT,
    ACTIONS(2211), 1,
      anon_sym_EQ,
    ACTIONS(2313), 1,
      anon_sym_LBRACK,
    ACTIONS(2318), 1,
      anon_sym_DOT,
    ACTIONS(2322), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2570), 1,
      anon_sym_EQ_GT,
    STATE(1377), 1,
      sym_type_arguments,
    STATE(1513), 1,
      sym_arguments,
    ACTIONS(2213), 11,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2221), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2209), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [28531] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_STAR,
    ACTIONS(461), 1,
      anon_sym_QMARK,
    ACTIONS(463), 1,
      anon_sym_AMP,
    ACTIONS(465), 1,
      anon_sym_PIPE,
    ACTIONS(495), 1,
      anon_sym_infer,
    ACTIONS(497), 1,
      anon_sym_keyof,
    ACTIONS(499), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(787), 1,
      anon_sym_typeof,
    ACTIONS(789), 1,
      anon_sym_LPAREN,
    ACTIONS(801), 1,
      anon_sym_new,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(821), 1,
      sym_number,
    ACTIONS(911), 1,
      sym_identifier,
    ACTIONS(915), 1,
      anon_sym_LBRACE,
    ACTIONS(921), 1,
      sym_readonly,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2225), 1,
      anon_sym_LBRACK,
    ACTIONS(2582), 1,
      sym_this,
    STATE(442), 1,
      sym__tuple_type_body,
    STATE(1957), 1,
      sym_nested_type_identifier,
    STATE(3048), 1,
      sym_type_parameters,
    STATE(3296), 1,
      sym_formal_parameters,
    STATE(3297), 1,
      sym_nested_identifier,
    ACTIONS(825), 2,
      sym_true,
      sym_false,
    ACTIONS(1655), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(447), 2,
      sym_string,
      sym__number,
    ACTIONS(815), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2565), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(431), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [28651] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2313), 1,
      anon_sym_LBRACK,
    ACTIONS(2318), 1,
      anon_sym_DOT,
    ACTIONS(2320), 1,
      anon_sym_EQ_GT,
    ACTIONS(2322), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2406), 1,
      anon_sym_EQ,
    ACTIONS(2802), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(1113), 12,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2221), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1111), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [28729] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1135), 1,
      anon_sym_EQ,
    ACTIONS(1141), 1,
      anon_sym_EQ_GT,
    ACTIONS(1143), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1189), 1,
      anon_sym_extends,
    ACTIONS(1689), 1,
      anon_sym_LBRACK,
    ACTIONS(1691), 1,
      anon_sym_DOT,
    ACTIONS(2324), 1,
      anon_sym_COMMA,
    ACTIONS(2327), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(813), 11,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
    ACTIONS(803), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(780), 20,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [28811] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(475), 1,
      anon_sym_DQUOTE,
    ACTIONS(477), 1,
      anon_sym_SQUOTE,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2330), 1,
      sym_identifier,
    ACTIONS(2332), 1,
      anon_sym_STAR,
    ACTIONS(2334), 1,
      anon_sym_LBRACE,
    ACTIONS(2336), 1,
      anon_sym_typeof,
    ACTIONS(2338), 1,
      anon_sym_LPAREN,
    ACTIONS(2340), 1,
      anon_sym_LBRACK,
    ACTIONS(2342), 1,
      anon_sym_new,
    ACTIONS(2344), 1,
      anon_sym_QMARK,
    ACTIONS(2346), 1,
      anon_sym_AMP,
    ACTIONS(2348), 1,
      anon_sym_PIPE,
    ACTIONS(2354), 1,
      sym_number,
    ACTIONS(2356), 1,
      sym_this,
    ACTIONS(2360), 1,
      sym_readonly,
    ACTIONS(2362), 1,
      anon_sym_infer,
    ACTIONS(2364), 1,
      anon_sym_keyof,
    ACTIONS(2366), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1028), 1,
      sym_nested_type_identifier,
    STATE(1082), 1,
      sym__tuple_type_body,
    STATE(3078), 1,
      sym_type_parameters,
    STATE(3195), 1,
      sym_nested_identifier,
    STATE(3385), 1,
      sym_formal_parameters,
    ACTIONS(2350), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2358), 2,
      sym_true,
      sym_false,
    STATE(1087), 2,
      sym_string,
      sym__number,
    ACTIONS(2352), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1127), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(1084), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [28931] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(799), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1083), 1,
      anon_sym_EQ,
    ACTIONS(1085), 1,
      anon_sym_EQ_GT,
    ACTIONS(1189), 1,
      anon_sym_extends,
    ACTIONS(1639), 1,
      anon_sym_LBRACK,
    ACTIONS(1641), 1,
      anon_sym_DOT,
    ACTIONS(2324), 1,
      anon_sym_COMMA,
    ACTIONS(2327), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(813), 12,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
    ACTIONS(803), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(780), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [29013] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(463), 1,
      anon_sym_AMP,
    ACTIONS(465), 1,
      anon_sym_PIPE,
    ACTIONS(495), 1,
      anon_sym_infer,
    ACTIONS(801), 1,
      anon_sym_new,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2450), 1,
      anon_sym_STAR,
    ACTIONS(2452), 1,
      anon_sym_LBRACE,
    ACTIONS(2454), 1,
      anon_sym_typeof,
    ACTIONS(2456), 1,
      anon_sym_LPAREN,
    ACTIONS(2458), 1,
      anon_sym_LBRACK,
    ACTIONS(2462), 1,
      anon_sym_QMARK,
    ACTIONS(2472), 1,
      anon_sym_DQUOTE,
    ACTIONS(2474), 1,
      anon_sym_SQUOTE,
    ACTIONS(2476), 1,
      sym_number,
    ACTIONS(2482), 1,
      sym_readonly,
    ACTIONS(2488), 1,
      anon_sym_keyof,
    ACTIONS(2490), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2744), 1,
      sym_identifier,
    ACTIONS(2804), 1,
      sym_this,
    STATE(2062), 1,
      sym_nested_type_identifier,
    STATE(2119), 1,
      sym__tuple_type_body,
    STATE(3048), 1,
      sym_type_parameters,
    STATE(3212), 1,
      sym_nested_identifier,
    STATE(3296), 1,
      sym_formal_parameters,
    ACTIONS(2468), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2480), 2,
      sym_true,
      sym_false,
    STATE(2122), 2,
      sym_string,
      sym__number,
    ACTIONS(2470), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2757), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2141), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [29133] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2450), 1,
      anon_sym_STAR,
    ACTIONS(2452), 1,
      anon_sym_LBRACE,
    ACTIONS(2454), 1,
      anon_sym_typeof,
    ACTIONS(2456), 1,
      anon_sym_LPAREN,
    ACTIONS(2458), 1,
      anon_sym_LBRACK,
    ACTIONS(2460), 1,
      anon_sym_new,
    ACTIONS(2462), 1,
      anon_sym_QMARK,
    ACTIONS(2464), 1,
      anon_sym_AMP,
    ACTIONS(2466), 1,
      anon_sym_PIPE,
    ACTIONS(2472), 1,
      anon_sym_DQUOTE,
    ACTIONS(2474), 1,
      anon_sym_SQUOTE,
    ACTIONS(2476), 1,
      sym_number,
    ACTIONS(2482), 1,
      sym_readonly,
    ACTIONS(2486), 1,
      anon_sym_infer,
    ACTIONS(2488), 1,
      anon_sym_keyof,
    ACTIONS(2490), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2744), 1,
      sym_identifier,
    ACTIONS(2746), 1,
      sym_this,
    STATE(2062), 1,
      sym_nested_type_identifier,
    STATE(2119), 1,
      sym__tuple_type_body,
    STATE(3122), 1,
      sym_type_parameters,
    STATE(3212), 1,
      sym_nested_identifier,
    STATE(3347), 1,
      sym_formal_parameters,
    ACTIONS(2468), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2480), 2,
      sym_true,
      sym_false,
    STATE(2122), 2,
      sym_string,
      sym__number,
    ACTIONS(2470), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2142), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2123), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [29253] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_STAR,
    ACTIONS(461), 1,
      anon_sym_QMARK,
    ACTIONS(463), 1,
      anon_sym_AMP,
    ACTIONS(465), 1,
      anon_sym_PIPE,
    ACTIONS(495), 1,
      anon_sym_infer,
    ACTIONS(497), 1,
      anon_sym_keyof,
    ACTIONS(499), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(787), 1,
      anon_sym_typeof,
    ACTIONS(789), 1,
      anon_sym_LPAREN,
    ACTIONS(801), 1,
      anon_sym_new,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(821), 1,
      sym_number,
    ACTIONS(911), 1,
      sym_identifier,
    ACTIONS(915), 1,
      anon_sym_LBRACE,
    ACTIONS(921), 1,
      sym_readonly,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2225), 1,
      anon_sym_LBRACK,
    ACTIONS(2582), 1,
      sym_this,
    STATE(442), 1,
      sym__tuple_type_body,
    STATE(1957), 1,
      sym_nested_type_identifier,
    STATE(3048), 1,
      sym_type_parameters,
    STATE(3296), 1,
      sym_formal_parameters,
    STATE(3297), 1,
      sym_nested_identifier,
    ACTIONS(825), 2,
      sym_true,
      sym_false,
    ACTIONS(1655), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(447), 2,
      sym_string,
      sym__number,
    ACTIONS(815), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2416), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(431), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [29373] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2450), 1,
      anon_sym_STAR,
    ACTIONS(2452), 1,
      anon_sym_LBRACE,
    ACTIONS(2454), 1,
      anon_sym_typeof,
    ACTIONS(2456), 1,
      anon_sym_LPAREN,
    ACTIONS(2458), 1,
      anon_sym_LBRACK,
    ACTIONS(2460), 1,
      anon_sym_new,
    ACTIONS(2462), 1,
      anon_sym_QMARK,
    ACTIONS(2464), 1,
      anon_sym_AMP,
    ACTIONS(2466), 1,
      anon_sym_PIPE,
    ACTIONS(2472), 1,
      anon_sym_DQUOTE,
    ACTIONS(2474), 1,
      anon_sym_SQUOTE,
    ACTIONS(2476), 1,
      sym_number,
    ACTIONS(2482), 1,
      sym_readonly,
    ACTIONS(2486), 1,
      anon_sym_infer,
    ACTIONS(2488), 1,
      anon_sym_keyof,
    ACTIONS(2490), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2744), 1,
      sym_identifier,
    ACTIONS(2746), 1,
      sym_this,
    STATE(2062), 1,
      sym_nested_type_identifier,
    STATE(2119), 1,
      sym__tuple_type_body,
    STATE(3122), 1,
      sym_type_parameters,
    STATE(3212), 1,
      sym_nested_identifier,
    STATE(3347), 1,
      sym_formal_parameters,
    ACTIONS(2468), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2480), 2,
      sym_true,
      sym_false,
    STATE(2122), 2,
      sym_string,
      sym__number,
    ACTIONS(2470), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2159), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2123), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [29493] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(463), 1,
      anon_sym_AMP,
    ACTIONS(465), 1,
      anon_sym_PIPE,
    ACTIONS(495), 1,
      anon_sym_infer,
    ACTIONS(577), 1,
      anon_sym_STAR,
    ACTIONS(589), 1,
      anon_sym_QMARK,
    ACTIONS(611), 1,
      anon_sym_keyof,
    ACTIONS(613), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(801), 1,
      anon_sym_new,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2420), 1,
      anon_sym_LBRACE,
    ACTIONS(2422), 1,
      anon_sym_typeof,
    ACTIONS(2424), 1,
      anon_sym_LPAREN,
    ACTIONS(2426), 1,
      anon_sym_LBRACK,
    ACTIONS(2434), 1,
      anon_sym_DQUOTE,
    ACTIONS(2436), 1,
      anon_sym_SQUOTE,
    ACTIONS(2438), 1,
      sym_number,
    ACTIONS(2444), 1,
      sym_readonly,
    ACTIONS(2750), 1,
      sym_identifier,
    ACTIONS(2806), 1,
      sym_this,
    STATE(1983), 1,
      sym_nested_type_identifier,
    STATE(2025), 1,
      sym__tuple_type_body,
    STATE(3048), 1,
      sym_type_parameters,
    STATE(3166), 1,
      sym_nested_identifier,
    STATE(3296), 1,
      sym_formal_parameters,
    ACTIONS(2430), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2442), 2,
      sym_true,
      sym_false,
    STATE(2017), 2,
      sym_string,
      sym__number,
    ACTIONS(2432), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2771), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2039), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [29613] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      anon_sym_STAR,
    ACTIONS(495), 1,
      anon_sym_infer,
    ACTIONS(499), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(789), 1,
      anon_sym_LPAREN,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(821), 1,
      sym_number,
    ACTIONS(915), 1,
      anon_sym_LBRACE,
    ACTIONS(921), 1,
      sym_readonly,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2225), 1,
      anon_sym_LBRACK,
    ACTIONS(2582), 1,
      sym_this,
    ACTIONS(2760), 1,
      sym_identifier,
    ACTIONS(2762), 1,
      anon_sym_typeof,
    ACTIONS(2764), 1,
      anon_sym_new,
    ACTIONS(2766), 1,
      anon_sym_QMARK,
    ACTIONS(2768), 1,
      anon_sym_AMP,
    ACTIONS(2770), 1,
      anon_sym_PIPE,
    ACTIONS(2772), 1,
      anon_sym_keyof,
    STATE(442), 1,
      sym__tuple_type_body,
    STATE(494), 1,
      sym_nested_type_identifier,
    STATE(3020), 1,
      sym_type_parameters,
    STATE(3297), 1,
      sym_nested_identifier,
    STATE(3316), 1,
      sym_formal_parameters,
    ACTIONS(825), 2,
      sym_true,
      sym_false,
    ACTIONS(1655), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(447), 2,
      sym_string,
      sym__number,
    ACTIONS(815), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(505), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(431), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [29733] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2299), 1,
      anon_sym_LT,
    ACTIONS(1015), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(2302), 2,
      anon_sym_LBRACK,
      anon_sym_DOT,
    ACTIONS(2305), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2266), 19,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2268), 28,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [29804] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2219), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2238), 1,
      anon_sym_EQ_GT,
    ACTIONS(2612), 1,
      anon_sym_EQ,
    ACTIONS(2624), 1,
      anon_sym_QMARK,
    ACTIONS(2808), 1,
      anon_sym_COLON,
    ACTIONS(2615), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(1113), 10,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2221), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1111), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [29885] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2299), 1,
      anon_sym_LT,
    ACTIONS(1015), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(2302), 2,
      anon_sym_LBRACK,
      anon_sym_DOT,
    ACTIONS(2305), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2266), 19,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2268), 28,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [29956] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2219), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2238), 1,
      anon_sym_EQ_GT,
    ACTIONS(2612), 1,
      anon_sym_EQ,
    ACTIONS(2624), 1,
      anon_sym_QMARK,
    ACTIONS(2615), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(1113), 10,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2221), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1111), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [30035] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1396), 1,
      anon_sym_extends,
    ACTIONS(2302), 1,
      anon_sym_DOT,
    ACTIONS(2296), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(2299), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2266), 20,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2268), 27,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [30106] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(797), 1,
      anon_sym_EQ_GT,
    ACTIONS(799), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(913), 1,
      anon_sym_EQ,
    ACTIONS(1639), 1,
      anon_sym_LBRACK,
    ACTIONS(1641), 1,
      anon_sym_DOT,
    ACTIONS(1748), 1,
      anon_sym_COLON,
    ACTIONS(813), 12,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(803), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(780), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [30183] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1015), 1,
      anon_sym_extends,
    ACTIONS(2299), 1,
      anon_sym_LT,
    ACTIONS(2302), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
    ACTIONS(2305), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2266), 20,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2268), 27,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [30254] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2313), 1,
      anon_sym_LBRACK,
    ACTIONS(2318), 1,
      anon_sym_DOT,
    ACTIONS(2322), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2406), 1,
      anon_sym_EQ,
    ACTIONS(1113), 14,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2221), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1111), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [30327] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(799), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1083), 1,
      anon_sym_EQ,
    ACTIONS(1085), 1,
      anon_sym_EQ_GT,
    ACTIONS(1639), 1,
      anon_sym_LBRACK,
    ACTIONS(1641), 1,
      anon_sym_DOT,
    ACTIONS(813), 13,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
    ACTIONS(803), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(780), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [30402] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2219), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2645), 1,
      anon_sym_EQ_GT,
    ACTIONS(2649), 1,
      anon_sym_EQ,
    ACTIONS(1113), 13,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
    ACTIONS(2221), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1111), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [30477] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2406), 1,
      anon_sym_EQ,
    ACTIONS(2221), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1113), 17,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1111), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [30544] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2406), 1,
      anon_sym_EQ,
    ACTIONS(2787), 1,
      anon_sym_in,
    ACTIONS(2790), 1,
      anon_sym_of,
    ACTIONS(2221), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1113), 16,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1111), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [30615] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2219), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2231), 1,
      anon_sym_EQ,
    ACTIONS(2238), 1,
      anon_sym_EQ_GT,
    ACTIONS(2810), 1,
      anon_sym_in,
    ACTIONS(2812), 1,
      anon_sym_COLON,
    ACTIONS(1113), 12,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2221), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1111), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [30694] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(777), 1,
      anon_sym_EQ,
    ACTIONS(797), 1,
      anon_sym_EQ_GT,
    ACTIONS(799), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1639), 1,
      anon_sym_LBRACK,
    ACTIONS(1641), 1,
      anon_sym_DOT,
    ACTIONS(1733), 1,
      anon_sym_QMARK,
    ACTIONS(784), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(813), 10,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(803), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(780), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [30773] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2296), 1,
      anon_sym_LBRACK,
    ACTIONS(2302), 1,
      anon_sym_DOT,
    ACTIONS(1396), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(2299), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2266), 19,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2268), 28,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [30844] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(777), 1,
      anon_sym_EQ,
    ACTIONS(797), 1,
      anon_sym_EQ_GT,
    ACTIONS(799), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1639), 1,
      anon_sym_LBRACK,
    ACTIONS(1641), 1,
      anon_sym_DOT,
    ACTIONS(1733), 1,
      anon_sym_QMARK,
    ACTIONS(1736), 1,
      anon_sym_COLON,
    ACTIONS(784), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(813), 10,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(803), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(780), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [30925] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2219), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2231), 1,
      anon_sym_EQ,
    ACTIONS(2238), 1,
      anon_sym_EQ_GT,
    ACTIONS(2817), 1,
      anon_sym_COLON,
    ACTIONS(2819), 1,
      anon_sym_QMARK,
    ACTIONS(2814), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(1113), 10,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2221), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1111), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [31006] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2313), 1,
      anon_sym_LBRACK,
    ACTIONS(2318), 1,
      anon_sym_DOT,
    ACTIONS(2322), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2406), 1,
      anon_sym_EQ,
    ACTIONS(2787), 1,
      anon_sym_in,
    ACTIONS(2790), 1,
      anon_sym_of,
    ACTIONS(1113), 13,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2221), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1111), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [31083] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1135), 1,
      anon_sym_EQ,
    ACTIONS(1141), 1,
      anon_sym_EQ_GT,
    ACTIONS(1143), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1689), 1,
      anon_sym_LBRACK,
    ACTIONS(1691), 1,
      anon_sym_DOT,
    ACTIONS(813), 12,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
    ACTIONS(803), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(780), 23,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [31158] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2631), 1,
      anon_sym_EQ,
    ACTIONS(2633), 1,
      anon_sym_LBRACK,
    ACTIONS(2637), 1,
      anon_sym_EQ_GT,
    ACTIONS(2639), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2651), 1,
      anon_sym_DOT,
    ACTIONS(1113), 12,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2221), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1111), 23,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [31233] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1396), 1,
      anon_sym_extends,
    ACTIONS(2302), 1,
      anon_sym_DOT,
    ACTIONS(2296), 2,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
    ACTIONS(2299), 3,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2266), 20,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2268), 28,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [31304] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2296), 1,
      anon_sym_LBRACK,
    ACTIONS(2302), 1,
      anon_sym_DOT,
    ACTIONS(1396), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(2299), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2266), 19,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2268), 28,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [31375] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1015), 1,
      anon_sym_extends,
    ACTIONS(2299), 1,
      anon_sym_LT,
    ACTIONS(2305), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2302), 3,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
    ACTIONS(2266), 20,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2268), 28,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [31446] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2159), 24,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2161), 30,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [31508] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(931), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1067), 1,
      anon_sym_EQ,
    ACTIONS(1069), 1,
      anon_sym_EQ_GT,
    ACTIONS(1223), 1,
      anon_sym_LBRACK,
    ACTIONS(1228), 1,
      anon_sym_DOT,
    ACTIONS(813), 12,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(803), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(780), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [31582] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(1729), 1,
      anon_sym_LBRACE,
    ACTIONS(2434), 1,
      anon_sym_DQUOTE,
    ACTIONS(2436), 1,
      anon_sym_SQUOTE,
    ACTIONS(2536), 1,
      anon_sym_STAR,
    ACTIONS(2542), 1,
      anon_sym_LPAREN,
    ACTIONS(2546), 1,
      anon_sym_LBRACK,
    ACTIONS(2550), 1,
      anon_sym_new,
    ACTIONS(2552), 1,
      anon_sym_DASH,
    ACTIONS(2554), 1,
      sym_number,
    ACTIONS(2824), 1,
      anon_sym_export,
    ACTIONS(2828), 1,
      anon_sym_async,
    ACTIONS(2830), 1,
      anon_sym_static,
    ACTIONS(2836), 1,
      sym_readonly,
    STATE(1924), 1,
      sym_accessibility_modifier,
    STATE(1945), 1,
      sym_decorator,
    STATE(2066), 1,
      sym_formal_parameters,
    STATE(2493), 1,
      sym__call_signature,
    STATE(2668), 1,
      aux_sym_export_statement_repeat1,
    STATE(3032), 1,
      sym_type_parameters,
    STATE(3210), 1,
      sym_array,
    STATE(3217), 1,
      sym_object,
    ACTIONS(2826), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(2832), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2834), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1987), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3011), 4,
      sym_assignment_pattern,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(2316), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(2822), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [31702] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2631), 1,
      anon_sym_EQ,
    ACTIONS(1113), 15,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2221), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1111), 23,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [31768] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2313), 1,
      anon_sym_LBRACK,
    ACTIONS(2318), 1,
      anon_sym_DOT,
    ACTIONS(2322), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2566), 1,
      anon_sym_EQ,
    ACTIONS(2570), 1,
      anon_sym_EQ_GT,
    ACTIONS(1113), 12,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2221), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1111), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [31842] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2211), 1,
      anon_sym_EQ,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2219), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2253), 1,
      anon_sym_EQ_GT,
    ACTIONS(1113), 12,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2221), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1111), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [31916] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(799), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(961), 1,
      anon_sym_EQ,
    ACTIONS(963), 1,
      anon_sym_EQ_GT,
    ACTIONS(1639), 1,
      anon_sym_LBRACK,
    ACTIONS(1641), 1,
      anon_sym_DOT,
    ACTIONS(1748), 1,
      anon_sym_COLON,
    ACTIONS(813), 11,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_RBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(803), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(780), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [31992] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2211), 1,
      anon_sym_EQ,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2219), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2253), 1,
      anon_sym_EQ_GT,
    ACTIONS(2810), 1,
      anon_sym_in,
    ACTIONS(2812), 1,
      anon_sym_COLON,
    ACTIONS(1113), 11,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_RBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2221), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1111), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [32070] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(799), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(961), 1,
      anon_sym_EQ,
    ACTIONS(963), 1,
      anon_sym_EQ_GT,
    ACTIONS(1639), 1,
      anon_sym_LBRACK,
    ACTIONS(1641), 1,
      anon_sym_DOT,
    ACTIONS(813), 12,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(803), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(780), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [32144] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2262), 23,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2264), 31,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [32206] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2211), 1,
      anon_sym_EQ,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2219), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2253), 1,
      anon_sym_EQ_GT,
    ACTIONS(2810), 1,
      anon_sym_in,
    ACTIONS(2838), 1,
      anon_sym_COLON,
    ACTIONS(1113), 11,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_RBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2221), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1111), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [32284] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(799), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(961), 1,
      anon_sym_EQ,
    ACTIONS(963), 1,
      anon_sym_EQ_GT,
    ACTIONS(1639), 1,
      anon_sym_LBRACK,
    ACTIONS(1641), 1,
      anon_sym_DOT,
    ACTIONS(1762), 1,
      anon_sym_COLON,
    ACTIONS(813), 11,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_RBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(803), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(780), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [32360] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2299), 1,
      anon_sym_LT,
    ACTIONS(2302), 1,
      anon_sym_DOT,
    ACTIONS(2296), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(2266), 22,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2268), 27,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [32428] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2302), 1,
      anon_sym_DOT,
    ACTIONS(2296), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2299), 2,
      anon_sym_LBRACE,
      anon_sym_LT,
    ACTIONS(2266), 22,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2268), 27,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [32496] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2631), 1,
      anon_sym_EQ,
    ACTIONS(2633), 1,
      anon_sym_LBRACK,
    ACTIONS(2639), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2651), 1,
      anon_sym_DOT,
    ACTIONS(1113), 12,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2221), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1111), 23,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [32568] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2262), 24,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2264), 30,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [32630] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2219), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2649), 1,
      anon_sym_EQ,
    ACTIONS(1113), 13,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
    ACTIONS(2221), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1111), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [32702] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2266), 24,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2268), 30,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [32764] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2282), 24,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2284), 30,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [32826] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(1729), 1,
      anon_sym_LBRACE,
    ACTIONS(2434), 1,
      anon_sym_DQUOTE,
    ACTIONS(2436), 1,
      anon_sym_SQUOTE,
    ACTIONS(2536), 1,
      anon_sym_STAR,
    ACTIONS(2542), 1,
      anon_sym_LPAREN,
    ACTIONS(2546), 1,
      anon_sym_LBRACK,
    ACTIONS(2550), 1,
      anon_sym_new,
    ACTIONS(2552), 1,
      anon_sym_DASH,
    ACTIONS(2554), 1,
      sym_number,
    ACTIONS(2824), 1,
      anon_sym_export,
    ACTIONS(2828), 1,
      anon_sym_async,
    ACTIONS(2830), 1,
      anon_sym_static,
    ACTIONS(2836), 1,
      sym_readonly,
    STATE(1924), 1,
      sym_accessibility_modifier,
    STATE(1945), 1,
      sym_decorator,
    STATE(2066), 1,
      sym_formal_parameters,
    STATE(2493), 1,
      sym__call_signature,
    STATE(2668), 1,
      aux_sym_export_statement_repeat1,
    STATE(3032), 1,
      sym_type_parameters,
    STATE(3210), 1,
      sym_array,
    STATE(3217), 1,
      sym_object,
    ACTIONS(2826), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(2832), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2834), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1987), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3011), 4,
      sym_assignment_pattern,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(2365), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(2822), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [32946] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2840), 1,
      anon_sym_COLON,
    ACTIONS(2262), 23,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2264), 30,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [33010] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2274), 24,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2276), 30,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [33072] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2227), 24,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2229), 30,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [33134] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2262), 23,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2264), 31,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [33196] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2270), 24,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2272), 30,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [33258] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2278), 24,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2280), 30,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [33320] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2649), 1,
      anon_sym_EQ,
    ACTIONS(2221), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1113), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
    ACTIONS(1111), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [33386] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2147), 24,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2149), 30,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [33448] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2211), 1,
      anon_sym_EQ,
    ACTIONS(1113), 15,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2221), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1111), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [33513] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2211), 1,
      anon_sym_EQ,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2219), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1113), 12,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2221), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1111), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [33584] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(799), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(961), 1,
      anon_sym_EQ,
    ACTIONS(963), 1,
      anon_sym_EQ_GT,
    ACTIONS(1639), 1,
      anon_sym_LBRACK,
    ACTIONS(1641), 1,
      anon_sym_DOT,
    ACTIONS(1695), 1,
      anon_sym_in,
    ACTIONS(2792), 1,
      anon_sym_of,
    ACTIONS(813), 10,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(803), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(780), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [33661] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2211), 1,
      anon_sym_EQ,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2219), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2246), 1,
      anon_sym_in,
    ACTIONS(2249), 1,
      anon_sym_of,
    ACTIONS(2253), 1,
      anon_sym_EQ_GT,
    ACTIONS(1113), 10,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2221), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1111), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [33738] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2211), 1,
      anon_sym_EQ,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2219), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2253), 1,
      anon_sym_EQ_GT,
    ACTIONS(2787), 1,
      anon_sym_in,
    ACTIONS(2790), 1,
      anon_sym_of,
    ACTIONS(1113), 10,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2221), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1111), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [33815] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(799), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(961), 1,
      anon_sym_EQ,
    ACTIONS(963), 1,
      anon_sym_EQ_GT,
    ACTIONS(1639), 1,
      anon_sym_LBRACK,
    ACTIONS(1641), 1,
      anon_sym_DOT,
    ACTIONS(1800), 1,
      anon_sym_in,
    ACTIONS(2842), 1,
      anon_sym_of,
    ACTIONS(813), 10,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(803), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(780), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [33892] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2313), 1,
      anon_sym_LBRACK,
    ACTIONS(2318), 1,
      anon_sym_DOT,
    ACTIONS(2322), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2566), 1,
      anon_sym_EQ,
    ACTIONS(1113), 12,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2221), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1111), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [33963] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2566), 1,
      anon_sym_EQ,
    ACTIONS(1113), 15,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2221), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1111), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [34028] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2211), 1,
      anon_sym_EQ,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2219), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2787), 1,
      anon_sym_in,
    ACTIONS(2790), 1,
      anon_sym_of,
    ACTIONS(1113), 10,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2221), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1111), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [34102] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2211), 1,
      anon_sym_EQ,
    ACTIONS(2787), 1,
      anon_sym_in,
    ACTIONS(2790), 1,
      anon_sym_of,
    ACTIONS(1113), 13,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2221), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1111), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [34170] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2211), 1,
      anon_sym_EQ,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2219), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2246), 1,
      anon_sym_in,
    ACTIONS(2249), 1,
      anon_sym_of,
    ACTIONS(1113), 10,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2221), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1111), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [34244] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2211), 1,
      anon_sym_EQ,
    ACTIONS(2246), 1,
      anon_sym_in,
    ACTIONS(2249), 1,
      anon_sym_of,
    ACTIONS(1113), 13,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2221), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1111), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [34312] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2434), 1,
      anon_sym_DQUOTE,
    ACTIONS(2436), 1,
      anon_sym_SQUOTE,
    ACTIONS(2844), 1,
      sym_identifier,
    ACTIONS(2846), 1,
      anon_sym_STAR,
    ACTIONS(2850), 1,
      anon_sym_LBRACE,
    STATE(3005), 1,
      sym_import_clause,
    ACTIONS(2854), 2,
      anon_sym_type,
      anon_sym_typeof,
    STATE(2990), 2,
      sym_string,
      sym_import_require_clause,
    STATE(3271), 2,
      sym_namespace_import,
      sym_named_imports,
    ACTIONS(2848), 15,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
    ACTIONS(2852), 22,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [34387] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2434), 1,
      anon_sym_DQUOTE,
    ACTIONS(2436), 1,
      anon_sym_SQUOTE,
    ACTIONS(2542), 1,
      anon_sym_LPAREN,
    ACTIONS(2550), 1,
      anon_sym_new,
    ACTIONS(2552), 1,
      anon_sym_DASH,
    ACTIONS(2858), 1,
      anon_sym_export,
    ACTIONS(2860), 1,
      anon_sym_STAR,
    ACTIONS(2866), 1,
      anon_sym_LBRACK,
    ACTIONS(2868), 1,
      anon_sym_async,
    ACTIONS(2870), 1,
      sym_number,
    ACTIONS(2872), 1,
      anon_sym_static,
    ACTIONS(2878), 1,
      sym_readonly,
    STATE(1920), 1,
      sym_accessibility_modifier,
    STATE(1945), 1,
      sym_decorator,
    STATE(2066), 1,
      sym_formal_parameters,
    STATE(2493), 1,
      sym__call_signature,
    STATE(2668), 1,
      aux_sym_export_statement_repeat1,
    STATE(3032), 1,
      sym_type_parameters,
    ACTIONS(2862), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(2864), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2874), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2876), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1982), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2277), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(2856), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [34493] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2434), 1,
      anon_sym_DQUOTE,
    ACTIONS(2436), 1,
      anon_sym_SQUOTE,
    ACTIONS(2542), 1,
      anon_sym_LPAREN,
    ACTIONS(2550), 1,
      anon_sym_new,
    ACTIONS(2552), 1,
      anon_sym_DASH,
    ACTIONS(2858), 1,
      anon_sym_export,
    ACTIONS(2860), 1,
      anon_sym_STAR,
    ACTIONS(2866), 1,
      anon_sym_LBRACK,
    ACTIONS(2868), 1,
      anon_sym_async,
    ACTIONS(2870), 1,
      sym_number,
    ACTIONS(2872), 1,
      anon_sym_static,
    ACTIONS(2878), 1,
      sym_readonly,
    STATE(1920), 1,
      sym_accessibility_modifier,
    STATE(1945), 1,
      sym_decorator,
    STATE(2066), 1,
      sym_formal_parameters,
    STATE(2493), 1,
      sym__call_signature,
    STATE(2668), 1,
      aux_sym_export_statement_repeat1,
    STATE(3032), 1,
      sym_type_parameters,
    ACTIONS(2874), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2880), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(2882), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2876), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1982), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2352), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(2856), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [34599] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1203), 1,
      anon_sym_LBRACE,
    ACTIONS(2884), 1,
      anon_sym_STAR,
    ACTIONS(2886), 1,
      anon_sym_default,
    ACTIONS(2888), 1,
      anon_sym_EQ,
    ACTIONS(2890), 1,
      anon_sym_as,
    ACTIONS(2892), 1,
      anon_sym_namespace,
    ACTIONS(2896), 1,
      anon_sym_type,
    ACTIONS(2898), 1,
      anon_sym_import,
    ACTIONS(2900), 1,
      anon_sym_var,
    ACTIONS(2902), 1,
      anon_sym_let,
    ACTIONS(2904), 1,
      anon_sym_const,
    ACTIONS(2906), 1,
      anon_sym_class,
    ACTIONS(2908), 1,
      anon_sym_async,
    ACTIONS(2910), 1,
      anon_sym_function,
    ACTIONS(2912), 1,
      anon_sym_abstract,
    ACTIONS(2914), 1,
      anon_sym_declare,
    ACTIONS(2916), 1,
      anon_sym_module,
    ACTIONS(2918), 1,
      anon_sym_interface,
    ACTIONS(2920), 1,
      anon_sym_enum,
    STATE(1945), 1,
      sym_decorator,
    STATE(2407), 1,
      aux_sym_export_statement_repeat1,
    STATE(2525), 1,
      sym__declaration,
    STATE(2526), 1,
      sym_function_signature,
    STATE(2527), 1,
      sym_internal_module,
    STATE(2728), 1,
      sym_export_clause,
    STATE(2868), 1,
      aux_sym_object_repeat1,
    ACTIONS(2894), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    STATE(2519), 12,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [34709] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1203), 1,
      anon_sym_LBRACE,
    ACTIONS(2884), 1,
      anon_sym_STAR,
    ACTIONS(2886), 1,
      anon_sym_default,
    ACTIONS(2888), 1,
      anon_sym_EQ,
    ACTIONS(2890), 1,
      anon_sym_as,
    ACTIONS(2892), 1,
      anon_sym_namespace,
    ACTIONS(2896), 1,
      anon_sym_type,
    ACTIONS(2898), 1,
      anon_sym_import,
    ACTIONS(2900), 1,
      anon_sym_var,
    ACTIONS(2902), 1,
      anon_sym_let,
    ACTIONS(2904), 1,
      anon_sym_const,
    ACTIONS(2906), 1,
      anon_sym_class,
    ACTIONS(2908), 1,
      anon_sym_async,
    ACTIONS(2910), 1,
      anon_sym_function,
    ACTIONS(2912), 1,
      anon_sym_abstract,
    ACTIONS(2914), 1,
      anon_sym_declare,
    ACTIONS(2916), 1,
      anon_sym_module,
    ACTIONS(2918), 1,
      anon_sym_interface,
    ACTIONS(2920), 1,
      anon_sym_enum,
    STATE(1945), 1,
      sym_decorator,
    STATE(2407), 1,
      aux_sym_export_statement_repeat1,
    STATE(2525), 1,
      sym__declaration,
    STATE(2526), 1,
      sym_function_signature,
    STATE(2527), 1,
      sym_internal_module,
    STATE(2728), 1,
      sym_export_clause,
    STATE(2806), 1,
      aux_sym_object_repeat1,
    ACTIONS(2894), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    STATE(2519), 12,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [34819] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1203), 1,
      anon_sym_LBRACE,
    ACTIONS(2884), 1,
      anon_sym_STAR,
    ACTIONS(2886), 1,
      anon_sym_default,
    ACTIONS(2888), 1,
      anon_sym_EQ,
    ACTIONS(2890), 1,
      anon_sym_as,
    ACTIONS(2892), 1,
      anon_sym_namespace,
    ACTIONS(2896), 1,
      anon_sym_type,
    ACTIONS(2898), 1,
      anon_sym_import,
    ACTIONS(2900), 1,
      anon_sym_var,
    ACTIONS(2902), 1,
      anon_sym_let,
    ACTIONS(2904), 1,
      anon_sym_const,
    ACTIONS(2906), 1,
      anon_sym_class,
    ACTIONS(2908), 1,
      anon_sym_async,
    ACTIONS(2910), 1,
      anon_sym_function,
    ACTIONS(2912), 1,
      anon_sym_abstract,
    ACTIONS(2914), 1,
      anon_sym_declare,
    ACTIONS(2916), 1,
      anon_sym_module,
    ACTIONS(2918), 1,
      anon_sym_interface,
    ACTIONS(2920), 1,
      anon_sym_enum,
    STATE(1945), 1,
      sym_decorator,
    STATE(2407), 1,
      aux_sym_export_statement_repeat1,
    STATE(2525), 1,
      sym__declaration,
    STATE(2526), 1,
      sym_function_signature,
    STATE(2527), 1,
      sym_internal_module,
    STATE(2728), 1,
      sym_export_clause,
    STATE(2854), 1,
      aux_sym_object_repeat1,
    ACTIONS(2894), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    STATE(2519), 12,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [34929] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2434), 1,
      anon_sym_DQUOTE,
    ACTIONS(2436), 1,
      anon_sym_SQUOTE,
    ACTIONS(2542), 1,
      anon_sym_LPAREN,
    ACTIONS(2550), 1,
      anon_sym_new,
    ACTIONS(2552), 1,
      anon_sym_DASH,
    ACTIONS(2858), 1,
      anon_sym_export,
    ACTIONS(2860), 1,
      anon_sym_STAR,
    ACTIONS(2866), 1,
      anon_sym_LBRACK,
    ACTIONS(2868), 1,
      anon_sym_async,
    ACTIONS(2870), 1,
      sym_number,
    ACTIONS(2872), 1,
      anon_sym_static,
    ACTIONS(2878), 1,
      sym_readonly,
    STATE(1920), 1,
      sym_accessibility_modifier,
    STATE(1945), 1,
      sym_decorator,
    STATE(2066), 1,
      sym_formal_parameters,
    STATE(2493), 1,
      sym__call_signature,
    STATE(2668), 1,
      aux_sym_export_statement_repeat1,
    STATE(3032), 1,
      sym_type_parameters,
    ACTIONS(2576), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(2578), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2874), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2876), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1982), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2300), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(2856), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [35035] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2434), 1,
      anon_sym_DQUOTE,
    ACTIONS(2436), 1,
      anon_sym_SQUOTE,
    ACTIONS(2542), 1,
      anon_sym_LPAREN,
    ACTIONS(2550), 1,
      anon_sym_new,
    ACTIONS(2552), 1,
      anon_sym_DASH,
    ACTIONS(2858), 1,
      anon_sym_export,
    ACTIONS(2860), 1,
      anon_sym_STAR,
    ACTIONS(2866), 1,
      anon_sym_LBRACK,
    ACTIONS(2868), 1,
      anon_sym_async,
    ACTIONS(2870), 1,
      sym_number,
    ACTIONS(2872), 1,
      anon_sym_static,
    ACTIONS(2878), 1,
      sym_readonly,
    STATE(1920), 1,
      sym_accessibility_modifier,
    STATE(1945), 1,
      sym_decorator,
    STATE(2066), 1,
      sym_formal_parameters,
    STATE(2493), 1,
      sym__call_signature,
    STATE(2668), 1,
      aux_sym_export_statement_repeat1,
    STATE(3032), 1,
      sym_type_parameters,
    ACTIONS(2874), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2922), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(2924), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2876), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1982), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2325), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(2856), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [35141] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1203), 1,
      anon_sym_LBRACE,
    ACTIONS(2884), 1,
      anon_sym_STAR,
    ACTIONS(2886), 1,
      anon_sym_default,
    ACTIONS(2888), 1,
      anon_sym_EQ,
    ACTIONS(2890), 1,
      anon_sym_as,
    ACTIONS(2892), 1,
      anon_sym_namespace,
    ACTIONS(2896), 1,
      anon_sym_type,
    ACTIONS(2898), 1,
      anon_sym_import,
    ACTIONS(2900), 1,
      anon_sym_var,
    ACTIONS(2902), 1,
      anon_sym_let,
    ACTIONS(2904), 1,
      anon_sym_const,
    ACTIONS(2906), 1,
      anon_sym_class,
    ACTIONS(2908), 1,
      anon_sym_async,
    ACTIONS(2910), 1,
      anon_sym_function,
    ACTIONS(2912), 1,
      anon_sym_abstract,
    ACTIONS(2914), 1,
      anon_sym_declare,
    ACTIONS(2916), 1,
      anon_sym_module,
    ACTIONS(2918), 1,
      anon_sym_interface,
    ACTIONS(2920), 1,
      anon_sym_enum,
    STATE(1945), 1,
      sym_decorator,
    STATE(2407), 1,
      aux_sym_export_statement_repeat1,
    STATE(2525), 1,
      sym__declaration,
    STATE(2526), 1,
      sym_function_signature,
    STATE(2527), 1,
      sym_internal_module,
    STATE(2728), 1,
      sym_export_clause,
    STATE(2894), 1,
      aux_sym_object_repeat1,
    ACTIONS(2894), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    STATE(2519), 12,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [35251] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2434), 1,
      anon_sym_DQUOTE,
    ACTIONS(2436), 1,
      anon_sym_SQUOTE,
    ACTIONS(2542), 1,
      anon_sym_LPAREN,
    ACTIONS(2550), 1,
      anon_sym_new,
    ACTIONS(2552), 1,
      anon_sym_DASH,
    ACTIONS(2858), 1,
      anon_sym_export,
    ACTIONS(2860), 1,
      anon_sym_STAR,
    ACTIONS(2866), 1,
      anon_sym_LBRACK,
    ACTIONS(2868), 1,
      anon_sym_async,
    ACTIONS(2870), 1,
      sym_number,
    ACTIONS(2872), 1,
      anon_sym_static,
    ACTIONS(2878), 1,
      sym_readonly,
    STATE(1920), 1,
      sym_accessibility_modifier,
    STATE(1945), 1,
      sym_decorator,
    STATE(2066), 1,
      sym_formal_parameters,
    STATE(2493), 1,
      sym__call_signature,
    STATE(2668), 1,
      aux_sym_export_statement_repeat1,
    STATE(3032), 1,
      sym_type_parameters,
    ACTIONS(2544), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(2564), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2874), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2876), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1982), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2345), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(2856), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [35357] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2434), 1,
      anon_sym_DQUOTE,
    ACTIONS(2436), 1,
      anon_sym_SQUOTE,
    ACTIONS(2542), 1,
      anon_sym_LPAREN,
    ACTIONS(2550), 1,
      anon_sym_new,
    ACTIONS(2552), 1,
      anon_sym_DASH,
    ACTIONS(2858), 1,
      anon_sym_export,
    ACTIONS(2860), 1,
      anon_sym_STAR,
    ACTIONS(2866), 1,
      anon_sym_LBRACK,
    ACTIONS(2868), 1,
      anon_sym_async,
    ACTIONS(2870), 1,
      sym_number,
    ACTIONS(2872), 1,
      anon_sym_static,
    ACTIONS(2878), 1,
      sym_readonly,
    STATE(1920), 1,
      sym_accessibility_modifier,
    STATE(1945), 1,
      sym_decorator,
    STATE(2066), 1,
      sym_formal_parameters,
    STATE(2493), 1,
      sym__call_signature,
    STATE(2668), 1,
      aux_sym_export_statement_repeat1,
    STATE(3032), 1,
      sym_type_parameters,
    ACTIONS(2874), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2926), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(2928), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2876), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1982), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2318), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(2856), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [35463] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1203), 1,
      anon_sym_LBRACE,
    ACTIONS(2884), 1,
      anon_sym_STAR,
    ACTIONS(2886), 1,
      anon_sym_default,
    ACTIONS(2890), 1,
      anon_sym_as,
    ACTIONS(2892), 1,
      anon_sym_namespace,
    ACTIONS(2896), 1,
      anon_sym_type,
    ACTIONS(2898), 1,
      anon_sym_import,
    ACTIONS(2900), 1,
      anon_sym_var,
    ACTIONS(2902), 1,
      anon_sym_let,
    ACTIONS(2904), 1,
      anon_sym_const,
    ACTIONS(2906), 1,
      anon_sym_class,
    ACTIONS(2908), 1,
      anon_sym_async,
    ACTIONS(2910), 1,
      anon_sym_function,
    ACTIONS(2912), 1,
      anon_sym_abstract,
    ACTIONS(2914), 1,
      anon_sym_declare,
    ACTIONS(2916), 1,
      anon_sym_module,
    ACTIONS(2918), 1,
      anon_sym_interface,
    ACTIONS(2920), 1,
      anon_sym_enum,
    ACTIONS(2930), 1,
      anon_sym_EQ,
    STATE(1945), 1,
      sym_decorator,
    STATE(2407), 1,
      aux_sym_export_statement_repeat1,
    STATE(2525), 1,
      sym__declaration,
    STATE(2526), 1,
      sym_function_signature,
    STATE(2527), 1,
      sym_internal_module,
    STATE(2728), 1,
      sym_export_clause,
    ACTIONS(2894), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    STATE(2519), 12,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [35570] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1203), 1,
      anon_sym_LBRACE,
    ACTIONS(2884), 1,
      anon_sym_STAR,
    ACTIONS(2886), 1,
      anon_sym_default,
    ACTIONS(2888), 1,
      anon_sym_EQ,
    ACTIONS(2890), 1,
      anon_sym_as,
    ACTIONS(2892), 1,
      anon_sym_namespace,
    ACTIONS(2896), 1,
      anon_sym_type,
    ACTIONS(2898), 1,
      anon_sym_import,
    ACTIONS(2900), 1,
      anon_sym_var,
    ACTIONS(2902), 1,
      anon_sym_let,
    ACTIONS(2904), 1,
      anon_sym_const,
    ACTIONS(2906), 1,
      anon_sym_class,
    ACTIONS(2908), 1,
      anon_sym_async,
    ACTIONS(2910), 1,
      anon_sym_function,
    ACTIONS(2912), 1,
      anon_sym_abstract,
    ACTIONS(2914), 1,
      anon_sym_declare,
    ACTIONS(2916), 1,
      anon_sym_module,
    ACTIONS(2918), 1,
      anon_sym_interface,
    ACTIONS(2920), 1,
      anon_sym_enum,
    STATE(1945), 1,
      sym_decorator,
    STATE(2407), 1,
      aux_sym_export_statement_repeat1,
    STATE(2525), 1,
      sym__declaration,
    STATE(2526), 1,
      sym_function_signature,
    STATE(2527), 1,
      sym_internal_module,
    STATE(2728), 1,
      sym_export_clause,
    ACTIONS(2932), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(2894), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    STATE(2519), 12,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [35679] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2434), 1,
      anon_sym_DQUOTE,
    ACTIONS(2436), 1,
      anon_sym_SQUOTE,
    ACTIONS(2542), 1,
      anon_sym_LPAREN,
    ACTIONS(2550), 1,
      anon_sym_new,
    ACTIONS(2552), 1,
      anon_sym_DASH,
    ACTIONS(2858), 1,
      anon_sym_export,
    ACTIONS(2860), 1,
      anon_sym_STAR,
    ACTIONS(2866), 1,
      anon_sym_LBRACK,
    ACTIONS(2868), 1,
      anon_sym_async,
    ACTIONS(2870), 1,
      sym_number,
    ACTIONS(2872), 1,
      anon_sym_static,
    ACTIONS(2878), 1,
      sym_readonly,
    STATE(1920), 1,
      sym_accessibility_modifier,
    STATE(1945), 1,
      sym_decorator,
    STATE(2066), 1,
      sym_formal_parameters,
    STATE(2493), 1,
      sym__call_signature,
    STATE(2668), 1,
      aux_sym_export_statement_repeat1,
    STATE(3032), 1,
      sym_type_parameters,
    ACTIONS(2874), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2935), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2876), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1982), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2619), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(2856), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [35781] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2434), 1,
      anon_sym_DQUOTE,
    ACTIONS(2436), 1,
      anon_sym_SQUOTE,
    ACTIONS(2542), 1,
      anon_sym_LPAREN,
    ACTIONS(2550), 1,
      anon_sym_new,
    ACTIONS(2552), 1,
      anon_sym_DASH,
    ACTIONS(2858), 1,
      anon_sym_export,
    ACTIONS(2860), 1,
      anon_sym_STAR,
    ACTIONS(2866), 1,
      anon_sym_LBRACK,
    ACTIONS(2868), 1,
      anon_sym_async,
    ACTIONS(2870), 1,
      sym_number,
    ACTIONS(2872), 1,
      anon_sym_static,
    ACTIONS(2878), 1,
      sym_readonly,
    STATE(1920), 1,
      sym_accessibility_modifier,
    STATE(1945), 1,
      sym_decorator,
    STATE(2066), 1,
      sym_formal_parameters,
    STATE(2493), 1,
      sym__call_signature,
    STATE(2668), 1,
      aux_sym_export_statement_repeat1,
    STATE(3032), 1,
      sym_type_parameters,
    ACTIONS(2874), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2937), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2876), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1982), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2619), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(2856), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [35883] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2434), 1,
      anon_sym_DQUOTE,
    ACTIONS(2436), 1,
      anon_sym_SQUOTE,
    ACTIONS(2542), 1,
      anon_sym_LPAREN,
    ACTIONS(2550), 1,
      anon_sym_new,
    ACTIONS(2552), 1,
      anon_sym_DASH,
    ACTIONS(2858), 1,
      anon_sym_export,
    ACTIONS(2860), 1,
      anon_sym_STAR,
    ACTIONS(2866), 1,
      anon_sym_LBRACK,
    ACTIONS(2868), 1,
      anon_sym_async,
    ACTIONS(2870), 1,
      sym_number,
    ACTIONS(2872), 1,
      anon_sym_static,
    ACTIONS(2878), 1,
      sym_readonly,
    STATE(1920), 1,
      sym_accessibility_modifier,
    STATE(1945), 1,
      sym_decorator,
    STATE(2066), 1,
      sym_formal_parameters,
    STATE(2493), 1,
      sym__call_signature,
    STATE(2668), 1,
      aux_sym_export_statement_repeat1,
    STATE(3032), 1,
      sym_type_parameters,
    ACTIONS(2874), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2939), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2876), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1982), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2619), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(2856), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [35985] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2434), 1,
      anon_sym_DQUOTE,
    ACTIONS(2436), 1,
      anon_sym_SQUOTE,
    ACTIONS(2542), 1,
      anon_sym_LPAREN,
    ACTIONS(2550), 1,
      anon_sym_new,
    ACTIONS(2552), 1,
      anon_sym_DASH,
    ACTIONS(2858), 1,
      anon_sym_export,
    ACTIONS(2860), 1,
      anon_sym_STAR,
    ACTIONS(2866), 1,
      anon_sym_LBRACK,
    ACTIONS(2868), 1,
      anon_sym_async,
    ACTIONS(2870), 1,
      sym_number,
    ACTIONS(2872), 1,
      anon_sym_static,
    ACTIONS(2878), 1,
      sym_readonly,
    STATE(1920), 1,
      sym_accessibility_modifier,
    STATE(1945), 1,
      sym_decorator,
    STATE(2066), 1,
      sym_formal_parameters,
    STATE(2493), 1,
      sym__call_signature,
    STATE(2668), 1,
      aux_sym_export_statement_repeat1,
    STATE(3032), 1,
      sym_type_parameters,
    ACTIONS(2874), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2941), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2876), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1982), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2619), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(2856), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [36087] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2434), 1,
      anon_sym_DQUOTE,
    ACTIONS(2436), 1,
      anon_sym_SQUOTE,
    ACTIONS(2542), 1,
      anon_sym_LPAREN,
    ACTIONS(2550), 1,
      anon_sym_new,
    ACTIONS(2552), 1,
      anon_sym_DASH,
    ACTIONS(2858), 1,
      anon_sym_export,
    ACTIONS(2860), 1,
      anon_sym_STAR,
    ACTIONS(2866), 1,
      anon_sym_LBRACK,
    ACTIONS(2868), 1,
      anon_sym_async,
    ACTIONS(2870), 1,
      sym_number,
    ACTIONS(2872), 1,
      anon_sym_static,
    ACTIONS(2878), 1,
      sym_readonly,
    STATE(1920), 1,
      sym_accessibility_modifier,
    STATE(1945), 1,
      sym_decorator,
    STATE(2066), 1,
      sym_formal_parameters,
    STATE(2493), 1,
      sym__call_signature,
    STATE(2668), 1,
      aux_sym_export_statement_repeat1,
    STATE(3032), 1,
      sym_type_parameters,
    ACTIONS(2874), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2943), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2876), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1982), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2619), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(2856), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [36189] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2434), 1,
      anon_sym_DQUOTE,
    ACTIONS(2436), 1,
      anon_sym_SQUOTE,
    ACTIONS(2542), 1,
      anon_sym_LPAREN,
    ACTIONS(2550), 1,
      anon_sym_new,
    ACTIONS(2552), 1,
      anon_sym_DASH,
    ACTIONS(2858), 1,
      anon_sym_export,
    ACTIONS(2860), 1,
      anon_sym_STAR,
    ACTIONS(2866), 1,
      anon_sym_LBRACK,
    ACTIONS(2868), 1,
      anon_sym_async,
    ACTIONS(2870), 1,
      sym_number,
    ACTIONS(2872), 1,
      anon_sym_static,
    ACTIONS(2878), 1,
      sym_readonly,
    STATE(1920), 1,
      sym_accessibility_modifier,
    STATE(1945), 1,
      sym_decorator,
    STATE(2066), 1,
      sym_formal_parameters,
    STATE(2493), 1,
      sym__call_signature,
    STATE(2668), 1,
      aux_sym_export_statement_repeat1,
    STATE(3032), 1,
      sym_type_parameters,
    ACTIONS(2874), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2945), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2876), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1982), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2619), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(2856), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [36291] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2434), 1,
      anon_sym_DQUOTE,
    ACTIONS(2436), 1,
      anon_sym_SQUOTE,
    ACTIONS(2542), 1,
      anon_sym_LPAREN,
    ACTIONS(2550), 1,
      anon_sym_new,
    ACTIONS(2552), 1,
      anon_sym_DASH,
    ACTIONS(2858), 1,
      anon_sym_export,
    ACTIONS(2860), 1,
      anon_sym_STAR,
    ACTIONS(2866), 1,
      anon_sym_LBRACK,
    ACTIONS(2868), 1,
      anon_sym_async,
    ACTIONS(2870), 1,
      sym_number,
    ACTIONS(2872), 1,
      anon_sym_static,
    ACTIONS(2878), 1,
      sym_readonly,
    STATE(1920), 1,
      sym_accessibility_modifier,
    STATE(1945), 1,
      sym_decorator,
    STATE(2066), 1,
      sym_formal_parameters,
    STATE(2493), 1,
      sym__call_signature,
    STATE(2668), 1,
      aux_sym_export_statement_repeat1,
    STATE(3032), 1,
      sym_type_parameters,
    ACTIONS(2874), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2947), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2876), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1982), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2619), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(2856), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [36393] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2434), 1,
      anon_sym_DQUOTE,
    ACTIONS(2436), 1,
      anon_sym_SQUOTE,
    ACTIONS(2542), 1,
      anon_sym_LPAREN,
    ACTIONS(2550), 1,
      anon_sym_new,
    ACTIONS(2552), 1,
      anon_sym_DASH,
    ACTIONS(2858), 1,
      anon_sym_export,
    ACTIONS(2860), 1,
      anon_sym_STAR,
    ACTIONS(2866), 1,
      anon_sym_LBRACK,
    ACTIONS(2868), 1,
      anon_sym_async,
    ACTIONS(2870), 1,
      sym_number,
    ACTIONS(2872), 1,
      anon_sym_static,
    ACTIONS(2878), 1,
      sym_readonly,
    STATE(1920), 1,
      sym_accessibility_modifier,
    STATE(1945), 1,
      sym_decorator,
    STATE(2066), 1,
      sym_formal_parameters,
    STATE(2493), 1,
      sym__call_signature,
    STATE(2668), 1,
      aux_sym_export_statement_repeat1,
    STATE(3032), 1,
      sym_type_parameters,
    ACTIONS(2874), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2949), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2876), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1982), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2619), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(2856), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [36495] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2434), 1,
      anon_sym_DQUOTE,
    ACTIONS(2436), 1,
      anon_sym_SQUOTE,
    ACTIONS(2542), 1,
      anon_sym_LPAREN,
    ACTIONS(2550), 1,
      anon_sym_new,
    ACTIONS(2552), 1,
      anon_sym_DASH,
    ACTIONS(2858), 1,
      anon_sym_export,
    ACTIONS(2860), 1,
      anon_sym_STAR,
    ACTIONS(2866), 1,
      anon_sym_LBRACK,
    ACTIONS(2868), 1,
      anon_sym_async,
    ACTIONS(2870), 1,
      sym_number,
    ACTIONS(2872), 1,
      anon_sym_static,
    ACTIONS(2878), 1,
      sym_readonly,
    STATE(1920), 1,
      sym_accessibility_modifier,
    STATE(1945), 1,
      sym_decorator,
    STATE(2066), 1,
      sym_formal_parameters,
    STATE(2493), 1,
      sym__call_signature,
    STATE(2668), 1,
      aux_sym_export_statement_repeat1,
    STATE(3032), 1,
      sym_type_parameters,
    ACTIONS(2874), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2951), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2876), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1982), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2619), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(2856), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [36597] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2434), 1,
      anon_sym_DQUOTE,
    ACTIONS(2436), 1,
      anon_sym_SQUOTE,
    ACTIONS(2542), 1,
      anon_sym_LPAREN,
    ACTIONS(2550), 1,
      anon_sym_new,
    ACTIONS(2552), 1,
      anon_sym_DASH,
    ACTIONS(2858), 1,
      anon_sym_export,
    ACTIONS(2860), 1,
      anon_sym_STAR,
    ACTIONS(2866), 1,
      anon_sym_LBRACK,
    ACTIONS(2868), 1,
      anon_sym_async,
    ACTIONS(2870), 1,
      sym_number,
    ACTIONS(2872), 1,
      anon_sym_static,
    ACTIONS(2878), 1,
      sym_readonly,
    STATE(1920), 1,
      sym_accessibility_modifier,
    STATE(1945), 1,
      sym_decorator,
    STATE(2066), 1,
      sym_formal_parameters,
    STATE(2493), 1,
      sym__call_signature,
    STATE(2668), 1,
      aux_sym_export_statement_repeat1,
    STATE(3032), 1,
      sym_type_parameters,
    ACTIONS(2874), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2953), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2876), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1982), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2619), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(2856), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [36699] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2434), 1,
      anon_sym_DQUOTE,
    ACTIONS(2436), 1,
      anon_sym_SQUOTE,
    ACTIONS(2542), 1,
      anon_sym_LPAREN,
    ACTIONS(2550), 1,
      anon_sym_new,
    ACTIONS(2552), 1,
      anon_sym_DASH,
    ACTIONS(2858), 1,
      anon_sym_export,
    ACTIONS(2860), 1,
      anon_sym_STAR,
    ACTIONS(2866), 1,
      anon_sym_LBRACK,
    ACTIONS(2868), 1,
      anon_sym_async,
    ACTIONS(2870), 1,
      sym_number,
    ACTIONS(2872), 1,
      anon_sym_static,
    ACTIONS(2878), 1,
      sym_readonly,
    STATE(1920), 1,
      sym_accessibility_modifier,
    STATE(1945), 1,
      sym_decorator,
    STATE(2066), 1,
      sym_formal_parameters,
    STATE(2493), 1,
      sym__call_signature,
    STATE(2668), 1,
      aux_sym_export_statement_repeat1,
    STATE(3032), 1,
      sym_type_parameters,
    ACTIONS(2874), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2955), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2876), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1982), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2619), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(2856), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [36801] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2434), 1,
      anon_sym_DQUOTE,
    ACTIONS(2436), 1,
      anon_sym_SQUOTE,
    ACTIONS(2542), 1,
      anon_sym_LPAREN,
    ACTIONS(2550), 1,
      anon_sym_new,
    ACTIONS(2552), 1,
      anon_sym_DASH,
    ACTIONS(2858), 1,
      anon_sym_export,
    ACTIONS(2860), 1,
      anon_sym_STAR,
    ACTIONS(2866), 1,
      anon_sym_LBRACK,
    ACTIONS(2868), 1,
      anon_sym_async,
    ACTIONS(2870), 1,
      sym_number,
    ACTIONS(2872), 1,
      anon_sym_static,
    ACTIONS(2878), 1,
      sym_readonly,
    STATE(1920), 1,
      sym_accessibility_modifier,
    STATE(1945), 1,
      sym_decorator,
    STATE(2066), 1,
      sym_formal_parameters,
    STATE(2493), 1,
      sym__call_signature,
    STATE(2668), 1,
      aux_sym_export_statement_repeat1,
    STATE(3032), 1,
      sym_type_parameters,
    ACTIONS(2874), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2957), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2876), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1982), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2619), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(2856), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [36903] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2434), 1,
      anon_sym_DQUOTE,
    ACTIONS(2436), 1,
      anon_sym_SQUOTE,
    ACTIONS(2542), 1,
      anon_sym_LPAREN,
    ACTIONS(2550), 1,
      anon_sym_new,
    ACTIONS(2552), 1,
      anon_sym_DASH,
    ACTIONS(2858), 1,
      anon_sym_export,
    ACTIONS(2860), 1,
      anon_sym_STAR,
    ACTIONS(2866), 1,
      anon_sym_LBRACK,
    ACTIONS(2868), 1,
      anon_sym_async,
    ACTIONS(2870), 1,
      sym_number,
    ACTIONS(2872), 1,
      anon_sym_static,
    ACTIONS(2878), 1,
      sym_readonly,
    STATE(1920), 1,
      sym_accessibility_modifier,
    STATE(1945), 1,
      sym_decorator,
    STATE(2066), 1,
      sym_formal_parameters,
    STATE(2493), 1,
      sym__call_signature,
    STATE(2668), 1,
      aux_sym_export_statement_repeat1,
    STATE(3032), 1,
      sym_type_parameters,
    ACTIONS(2874), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2959), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2876), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1982), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2619), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(2856), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [37005] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2434), 1,
      anon_sym_DQUOTE,
    ACTIONS(2436), 1,
      anon_sym_SQUOTE,
    ACTIONS(2542), 1,
      anon_sym_LPAREN,
    ACTIONS(2550), 1,
      anon_sym_new,
    ACTIONS(2552), 1,
      anon_sym_DASH,
    ACTIONS(2858), 1,
      anon_sym_export,
    ACTIONS(2860), 1,
      anon_sym_STAR,
    ACTIONS(2866), 1,
      anon_sym_LBRACK,
    ACTIONS(2868), 1,
      anon_sym_async,
    ACTIONS(2870), 1,
      sym_number,
    ACTIONS(2872), 1,
      anon_sym_static,
    ACTIONS(2878), 1,
      sym_readonly,
    STATE(1920), 1,
      sym_accessibility_modifier,
    STATE(1945), 1,
      sym_decorator,
    STATE(2066), 1,
      sym_formal_parameters,
    STATE(2493), 1,
      sym__call_signature,
    STATE(2668), 1,
      aux_sym_export_statement_repeat1,
    STATE(3032), 1,
      sym_type_parameters,
    ACTIONS(2874), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2961), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2876), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1982), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2619), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(2856), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [37107] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2434), 1,
      anon_sym_DQUOTE,
    ACTIONS(2436), 1,
      anon_sym_SQUOTE,
    ACTIONS(2542), 1,
      anon_sym_LPAREN,
    ACTIONS(2550), 1,
      anon_sym_new,
    ACTIONS(2552), 1,
      anon_sym_DASH,
    ACTIONS(2858), 1,
      anon_sym_export,
    ACTIONS(2860), 1,
      anon_sym_STAR,
    ACTIONS(2866), 1,
      anon_sym_LBRACK,
    ACTIONS(2868), 1,
      anon_sym_async,
    ACTIONS(2870), 1,
      sym_number,
    ACTIONS(2872), 1,
      anon_sym_static,
    ACTIONS(2878), 1,
      sym_readonly,
    STATE(1920), 1,
      sym_accessibility_modifier,
    STATE(1945), 1,
      sym_decorator,
    STATE(2066), 1,
      sym_formal_parameters,
    STATE(2493), 1,
      sym__call_signature,
    STATE(2668), 1,
      aux_sym_export_statement_repeat1,
    STATE(3032), 1,
      sym_type_parameters,
    ACTIONS(2874), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2963), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2876), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1982), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2619), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(2856), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [37209] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2434), 1,
      anon_sym_DQUOTE,
    ACTIONS(2436), 1,
      anon_sym_SQUOTE,
    ACTIONS(2542), 1,
      anon_sym_LPAREN,
    ACTIONS(2550), 1,
      anon_sym_new,
    ACTIONS(2552), 1,
      anon_sym_DASH,
    ACTIONS(2858), 1,
      anon_sym_export,
    ACTIONS(2860), 1,
      anon_sym_STAR,
    ACTIONS(2866), 1,
      anon_sym_LBRACK,
    ACTIONS(2868), 1,
      anon_sym_async,
    ACTIONS(2870), 1,
      sym_number,
    ACTIONS(2872), 1,
      anon_sym_static,
    ACTIONS(2878), 1,
      sym_readonly,
    STATE(1920), 1,
      sym_accessibility_modifier,
    STATE(1945), 1,
      sym_decorator,
    STATE(2066), 1,
      sym_formal_parameters,
    STATE(2493), 1,
      sym__call_signature,
    STATE(2668), 1,
      aux_sym_export_statement_repeat1,
    STATE(3032), 1,
      sym_type_parameters,
    ACTIONS(2874), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2965), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2876), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1982), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2619), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(2856), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [37311] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2434), 1,
      anon_sym_DQUOTE,
    ACTIONS(2436), 1,
      anon_sym_SQUOTE,
    ACTIONS(2542), 1,
      anon_sym_LPAREN,
    ACTIONS(2550), 1,
      anon_sym_new,
    ACTIONS(2552), 1,
      anon_sym_DASH,
    ACTIONS(2858), 1,
      anon_sym_export,
    ACTIONS(2860), 1,
      anon_sym_STAR,
    ACTIONS(2866), 1,
      anon_sym_LBRACK,
    ACTIONS(2868), 1,
      anon_sym_async,
    ACTIONS(2870), 1,
      sym_number,
    ACTIONS(2872), 1,
      anon_sym_static,
    ACTIONS(2878), 1,
      sym_readonly,
    STATE(1920), 1,
      sym_accessibility_modifier,
    STATE(1945), 1,
      sym_decorator,
    STATE(2066), 1,
      sym_formal_parameters,
    STATE(2493), 1,
      sym__call_signature,
    STATE(2668), 1,
      aux_sym_export_statement_repeat1,
    STATE(3032), 1,
      sym_type_parameters,
    ACTIONS(2874), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2967), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2876), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1982), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2619), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(2856), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [37413] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2434), 1,
      anon_sym_DQUOTE,
    ACTIONS(2436), 1,
      anon_sym_SQUOTE,
    ACTIONS(2542), 1,
      anon_sym_LPAREN,
    ACTIONS(2550), 1,
      anon_sym_new,
    ACTIONS(2552), 1,
      anon_sym_DASH,
    ACTIONS(2858), 1,
      anon_sym_export,
    ACTIONS(2860), 1,
      anon_sym_STAR,
    ACTIONS(2866), 1,
      anon_sym_LBRACK,
    ACTIONS(2868), 1,
      anon_sym_async,
    ACTIONS(2870), 1,
      sym_number,
    ACTIONS(2872), 1,
      anon_sym_static,
    ACTIONS(2878), 1,
      sym_readonly,
    STATE(1920), 1,
      sym_accessibility_modifier,
    STATE(1945), 1,
      sym_decorator,
    STATE(2066), 1,
      sym_formal_parameters,
    STATE(2493), 1,
      sym__call_signature,
    STATE(2668), 1,
      aux_sym_export_statement_repeat1,
    STATE(3032), 1,
      sym_type_parameters,
    ACTIONS(2874), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2969), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2876), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1982), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2619), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(2856), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [37515] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2975), 1,
      anon_sym_QMARK_DOT,
    STATE(2727), 1,
      sym_type_arguments,
    STATE(1171), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2971), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2973), 25,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [37578] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1081), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1079), 31,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [37631] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1089), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1087), 31,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [37684] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2187), 1,
      anon_sym_LT,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2219), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2977), 1,
      anon_sym_EQ,
    STATE(1069), 1,
      sym_type_arguments,
    STATE(1160), 1,
      sym_arguments,
    ACTIONS(2209), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2213), 24,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [37753] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2187), 1,
      anon_sym_LT,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2219), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2979), 1,
      anon_sym_EQ,
    STATE(1069), 1,
      sym_type_arguments,
    STATE(1160), 1,
      sym_arguments,
    ACTIONS(2209), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2213), 24,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [37822] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2727), 1,
      sym_type_arguments,
    STATE(1171), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2981), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2983), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [37879] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2985), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2987), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [37931] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(945), 1,
      anon_sym_EQ,
    ACTIONS(2989), 1,
      sym__automatic_semicolon,
    ACTIONS(943), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(941), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [37987] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2991), 1,
      anon_sym_LT,
    STATE(1057), 1,
      sym_type_arguments,
    ACTIONS(1752), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1750), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [38043] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2994), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2996), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [38095] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2998), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3000), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [38147] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(945), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(947), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [38199] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2434), 1,
      anon_sym_DQUOTE,
    ACTIONS(2436), 1,
      anon_sym_SQUOTE,
    ACTIONS(2542), 1,
      anon_sym_LPAREN,
    ACTIONS(2550), 1,
      anon_sym_new,
    ACTIONS(2552), 1,
      anon_sym_DASH,
    ACTIONS(2858), 1,
      anon_sym_export,
    ACTIONS(2860), 1,
      anon_sym_STAR,
    ACTIONS(2866), 1,
      anon_sym_LBRACK,
    ACTIONS(2868), 1,
      anon_sym_async,
    ACTIONS(2870), 1,
      sym_number,
    ACTIONS(2872), 1,
      anon_sym_static,
    ACTIONS(2878), 1,
      sym_readonly,
    STATE(1920), 1,
      sym_accessibility_modifier,
    STATE(1945), 1,
      sym_decorator,
    STATE(2066), 1,
      sym_formal_parameters,
    STATE(2493), 1,
      sym__call_signature,
    STATE(2668), 1,
      aux_sym_export_statement_repeat1,
    STATE(3032), 1,
      sym_type_parameters,
    ACTIONS(2874), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2876), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1982), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2293), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(2856), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [38297] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1057), 1,
      sym_type_arguments,
    ACTIONS(1617), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1615), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [38351] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2434), 1,
      anon_sym_DQUOTE,
    ACTIONS(2436), 1,
      anon_sym_SQUOTE,
    ACTIONS(2542), 1,
      anon_sym_LPAREN,
    ACTIONS(2550), 1,
      anon_sym_new,
    ACTIONS(2552), 1,
      anon_sym_DASH,
    ACTIONS(2858), 1,
      anon_sym_export,
    ACTIONS(2860), 1,
      anon_sym_STAR,
    ACTIONS(2866), 1,
      anon_sym_LBRACK,
    ACTIONS(2868), 1,
      anon_sym_async,
    ACTIONS(2870), 1,
      sym_number,
    ACTIONS(2872), 1,
      anon_sym_static,
    ACTIONS(2878), 1,
      sym_readonly,
    STATE(1920), 1,
      sym_accessibility_modifier,
    STATE(1945), 1,
      sym_decorator,
    STATE(2066), 1,
      sym_formal_parameters,
    STATE(2493), 1,
      sym__call_signature,
    STATE(2668), 1,
      aux_sym_export_statement_repeat1,
    STATE(3032), 1,
      sym_type_parameters,
    ACTIONS(2874), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2876), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1982), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2301), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(2856), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [38449] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2434), 1,
      anon_sym_DQUOTE,
    ACTIONS(2436), 1,
      anon_sym_SQUOTE,
    ACTIONS(2542), 1,
      anon_sym_LPAREN,
    ACTIONS(2550), 1,
      anon_sym_new,
    ACTIONS(2552), 1,
      anon_sym_DASH,
    ACTIONS(2858), 1,
      anon_sym_export,
    ACTIONS(2860), 1,
      anon_sym_STAR,
    ACTIONS(2866), 1,
      anon_sym_LBRACK,
    ACTIONS(2868), 1,
      anon_sym_async,
    ACTIONS(2870), 1,
      sym_number,
    ACTIONS(2872), 1,
      anon_sym_static,
    ACTIONS(2878), 1,
      sym_readonly,
    STATE(1920), 1,
      sym_accessibility_modifier,
    STATE(1945), 1,
      sym_decorator,
    STATE(2066), 1,
      sym_formal_parameters,
    STATE(2493), 1,
      sym__call_signature,
    STATE(2668), 1,
      aux_sym_export_statement_repeat1,
    STATE(3032), 1,
      sym_type_parameters,
    ACTIONS(2874), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2876), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1982), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2316), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(2856), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [38547] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2434), 1,
      anon_sym_DQUOTE,
    ACTIONS(2436), 1,
      anon_sym_SQUOTE,
    ACTIONS(2542), 1,
      anon_sym_LPAREN,
    ACTIONS(2550), 1,
      anon_sym_new,
    ACTIONS(2552), 1,
      anon_sym_DASH,
    ACTIONS(2858), 1,
      anon_sym_export,
    ACTIONS(2860), 1,
      anon_sym_STAR,
    ACTIONS(2866), 1,
      anon_sym_LBRACK,
    ACTIONS(2868), 1,
      anon_sym_async,
    ACTIONS(2870), 1,
      sym_number,
    ACTIONS(2872), 1,
      anon_sym_static,
    ACTIONS(2878), 1,
      sym_readonly,
    STATE(1920), 1,
      sym_accessibility_modifier,
    STATE(1945), 1,
      sym_decorator,
    STATE(2066), 1,
      sym_formal_parameters,
    STATE(2493), 1,
      sym__call_signature,
    STATE(2668), 1,
      aux_sym_export_statement_repeat1,
    STATE(3032), 1,
      sym_type_parameters,
    ACTIONS(2874), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2876), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1982), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2365), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(2856), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [38645] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2434), 1,
      anon_sym_DQUOTE,
    ACTIONS(2436), 1,
      anon_sym_SQUOTE,
    ACTIONS(2542), 1,
      anon_sym_LPAREN,
    ACTIONS(2550), 1,
      anon_sym_new,
    ACTIONS(2552), 1,
      anon_sym_DASH,
    ACTIONS(2858), 1,
      anon_sym_export,
    ACTIONS(2860), 1,
      anon_sym_STAR,
    ACTIONS(2866), 1,
      anon_sym_LBRACK,
    ACTIONS(2868), 1,
      anon_sym_async,
    ACTIONS(2870), 1,
      sym_number,
    ACTIONS(2872), 1,
      anon_sym_static,
    ACTIONS(2878), 1,
      sym_readonly,
    STATE(1920), 1,
      sym_accessibility_modifier,
    STATE(1945), 1,
      sym_decorator,
    STATE(2066), 1,
      sym_formal_parameters,
    STATE(2493), 1,
      sym__call_signature,
    STATE(2668), 1,
      aux_sym_export_statement_repeat1,
    STATE(3032), 1,
      sym_type_parameters,
    ACTIONS(2874), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2876), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1982), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2349), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(2856), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [38743] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2434), 1,
      anon_sym_DQUOTE,
    ACTIONS(2436), 1,
      anon_sym_SQUOTE,
    ACTIONS(2542), 1,
      anon_sym_LPAREN,
    ACTIONS(2550), 1,
      anon_sym_new,
    ACTIONS(2552), 1,
      anon_sym_DASH,
    ACTIONS(2858), 1,
      anon_sym_export,
    ACTIONS(2860), 1,
      anon_sym_STAR,
    ACTIONS(2866), 1,
      anon_sym_LBRACK,
    ACTIONS(2868), 1,
      anon_sym_async,
    ACTIONS(2870), 1,
      sym_number,
    ACTIONS(2872), 1,
      anon_sym_static,
    ACTIONS(2878), 1,
      sym_readonly,
    STATE(1920), 1,
      sym_accessibility_modifier,
    STATE(1945), 1,
      sym_decorator,
    STATE(2066), 1,
      sym_formal_parameters,
    STATE(2493), 1,
      sym__call_signature,
    STATE(2668), 1,
      aux_sym_export_statement_repeat1,
    STATE(3032), 1,
      sym_type_parameters,
    ACTIONS(2874), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2876), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1982), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2275), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(2856), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [38841] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2187), 1,
      anon_sym_LT,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2219), 1,
      anon_sym_QMARK_DOT,
    STATE(1069), 1,
      sym_type_arguments,
    STATE(1160), 1,
      sym_arguments,
    ACTIONS(2209), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2213), 24,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [38907] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3002), 1,
      anon_sym_DOT,
    STATE(1065), 1,
      sym_type_arguments,
    ACTIONS(1561), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1559), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [38963] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3004), 1,
      anon_sym_LT,
    ACTIONS(3007), 1,
      anon_sym_DOT,
    STATE(1065), 1,
      sym_type_arguments,
    ACTIONS(1712), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1710), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [39021] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3009), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2840), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [39073] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2434), 1,
      anon_sym_DQUOTE,
    ACTIONS(2436), 1,
      anon_sym_SQUOTE,
    ACTIONS(2542), 1,
      anon_sym_LPAREN,
    ACTIONS(2550), 1,
      anon_sym_new,
    ACTIONS(2552), 1,
      anon_sym_DASH,
    ACTIONS(2858), 1,
      anon_sym_export,
    ACTIONS(2860), 1,
      anon_sym_STAR,
    ACTIONS(2866), 1,
      anon_sym_LBRACK,
    ACTIONS(2868), 1,
      anon_sym_async,
    ACTIONS(2870), 1,
      sym_number,
    ACTIONS(2872), 1,
      anon_sym_static,
    ACTIONS(2878), 1,
      sym_readonly,
    STATE(1920), 1,
      sym_accessibility_modifier,
    STATE(1945), 1,
      sym_decorator,
    STATE(2066), 1,
      sym_formal_parameters,
    STATE(2493), 1,
      sym__call_signature,
    STATE(2668), 1,
      aux_sym_export_statement_repeat1,
    STATE(3032), 1,
      sym_type_parameters,
    ACTIONS(2874), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2876), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1982), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2619), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(2856), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [39171] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3011), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3013), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [39223] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3015), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3017), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [39275] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3019), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3021), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [39327] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1513), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(1515), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(945), 12,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(947), 26,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [39383] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3007), 1,
      anon_sym_DOT,
    STATE(1065), 1,
      sym_type_arguments,
    ACTIONS(1723), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1721), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [39439] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1535), 1,
      anon_sym_extends,
    ACTIONS(3023), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3026), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2985), 12,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2987), 26,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [39497] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(479), 1,
      anon_sym_BQUOTE,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2975), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3031), 1,
      anon_sym_as,
    ACTIONS(3035), 1,
      anon_sym_BANG,
    ACTIONS(3039), 1,
      anon_sym_LT,
    ACTIONS(3041), 1,
      anon_sym_QMARK,
    ACTIONS(3043), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3049), 1,
      anon_sym_AMP,
    ACTIONS(3051), 1,
      anon_sym_PIPE,
    ACTIONS(3055), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3059), 1,
      anon_sym_QMARK_QMARK,
    STATE(2727), 1,
      sym_type_arguments,
    ACTIONS(3045), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3053), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3061), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1171), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3029), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3047), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3037), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3033), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(3057), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [39592] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(479), 1,
      anon_sym_BQUOTE,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2975), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3035), 1,
      anon_sym_BANG,
    ACTIONS(3067), 1,
      anon_sym_LT,
    STATE(2727), 1,
      sym_type_arguments,
    ACTIONS(3061), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1171), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3063), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3065), 19,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [39663] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3074), 1,
      anon_sym_AMP,
    ACTIONS(3076), 1,
      anon_sym_PIPE,
    ACTIONS(3078), 1,
      anon_sym_extends,
    ACTIONS(3070), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3072), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [39720] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1089), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1087), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [39771] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3080), 1,
      anon_sym_LT,
    ACTIONS(1017), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1015), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [39824] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(479), 1,
      anon_sym_BQUOTE,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2975), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3035), 1,
      anon_sym_BANG,
    ACTIONS(3055), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3067), 1,
      anon_sym_LT,
    STATE(2727), 1,
      sym_type_arguments,
    ACTIONS(3061), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1171), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3063), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3065), 18,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [39897] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1533), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1531), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [39948] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1487), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1485), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [39999] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1621), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1619), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [40050] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(479), 1,
      anon_sym_BQUOTE,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2975), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3031), 1,
      anon_sym_as,
    ACTIONS(3035), 1,
      anon_sym_BANG,
    ACTIONS(3039), 1,
      anon_sym_LT,
    ACTIONS(3041), 1,
      anon_sym_QMARK,
    ACTIONS(3043), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3049), 1,
      anon_sym_AMP,
    ACTIONS(3051), 1,
      anon_sym_PIPE,
    ACTIONS(3055), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3059), 1,
      anon_sym_QMARK_QMARK,
    STATE(2727), 1,
      sym_type_arguments,
    ACTIONS(3045), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3053), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3061), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1171), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3029), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3047), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3037), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3057), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3083), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [40145] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1613), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1611), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [40196] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1617), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1615), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [40247] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(479), 1,
      anon_sym_BQUOTE,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2975), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3031), 1,
      anon_sym_as,
    ACTIONS(3035), 1,
      anon_sym_BANG,
    ACTIONS(3039), 1,
      anon_sym_LT,
    ACTIONS(3041), 1,
      anon_sym_QMARK,
    ACTIONS(3043), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3049), 1,
      anon_sym_AMP,
    ACTIONS(3051), 1,
      anon_sym_PIPE,
    ACTIONS(3055), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3059), 1,
      anon_sym_QMARK_QMARK,
    STATE(2727), 1,
      sym_type_arguments,
    ACTIONS(3045), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3053), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3061), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1171), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3029), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3047), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3037), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3057), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3085), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [40342] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1511), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1509), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [40393] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1593), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1591), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [40444] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1491), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1489), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [40495] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1565), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1563), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [40546] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1601), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1599), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [40597] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1585), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1583), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [40648] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    STATE(1229), 1,
      sym_arguments,
    ACTIONS(3087), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3089), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [40703] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1553), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1551), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [40754] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1519), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1517), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [40805] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3091), 1,
      anon_sym_LBRACK,
    ACTIONS(1523), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1521), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [40858] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    STATE(1228), 1,
      sym_arguments,
    ACTIONS(3093), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3095), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [40913] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1537), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1535), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [40964] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1561), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1559), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [41015] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3097), 1,
      anon_sym_LBRACE,
    ACTIONS(3099), 1,
      anon_sym_DOT,
    STATE(1315), 1,
      sym_statement_block,
    ACTIONS(935), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(933), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [41072] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3002), 1,
      anon_sym_DOT,
    ACTIONS(1561), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1559), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [41125] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1515), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1513), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [41176] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2989), 1,
      sym__automatic_semicolon,
    ACTIONS(943), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(941), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [41229] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1081), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1079), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [41280] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3097), 1,
      anon_sym_LBRACE,
    STATE(1315), 1,
      sym_statement_block,
    ACTIONS(935), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(933), 27,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [41335] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1589), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1587), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [41386] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3074), 1,
      anon_sym_AMP,
    ACTIONS(3076), 1,
      anon_sym_PIPE,
    ACTIONS(3078), 1,
      anon_sym_extends,
    ACTIONS(1790), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1788), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [41443] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3091), 1,
      anon_sym_LBRACK,
    ACTIONS(1557), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1555), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [41496] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3101), 1,
      sym__automatic_semicolon,
    ACTIONS(1051), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1049), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [41549] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3074), 1,
      anon_sym_AMP,
    ACTIONS(3076), 1,
      anon_sym_PIPE,
    ACTIONS(1780), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1778), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [41604] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1609), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1607), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [41655] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1191), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1189), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [41706] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1573), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1571), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [41757] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(479), 1,
      anon_sym_BQUOTE,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2975), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3031), 1,
      anon_sym_as,
    ACTIONS(3035), 1,
      anon_sym_BANG,
    ACTIONS(3039), 1,
      anon_sym_LT,
    ACTIONS(3041), 1,
      anon_sym_QMARK,
    ACTIONS(3043), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3049), 1,
      anon_sym_AMP,
    ACTIONS(3051), 1,
      anon_sym_PIPE,
    ACTIONS(3055), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3059), 1,
      anon_sym_QMARK_QMARK,
    STATE(2727), 1,
      sym_type_arguments,
    ACTIONS(3045), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3053), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3061), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1171), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3029), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3047), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3037), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3057), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3103), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [41852] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3105), 1,
      anon_sym_LBRACE,
    STATE(1200), 1,
      sym_statement_block,
    ACTIONS(935), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(933), 27,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [41907] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3105), 1,
      anon_sym_LBRACE,
    ACTIONS(3107), 1,
      anon_sym_DOT,
    STATE(1200), 1,
      sym_statement_block,
    ACTIONS(935), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(933), 26,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [41964] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(479), 1,
      anon_sym_BQUOTE,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2975), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3031), 1,
      anon_sym_as,
    ACTIONS(3035), 1,
      anon_sym_BANG,
    ACTIONS(3039), 1,
      anon_sym_LT,
    ACTIONS(3041), 1,
      anon_sym_QMARK,
    ACTIONS(3043), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3049), 1,
      anon_sym_AMP,
    ACTIONS(3051), 1,
      anon_sym_PIPE,
    ACTIONS(3055), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3059), 1,
      anon_sym_QMARK_QMARK,
    STATE(2727), 1,
      sym_type_arguments,
    ACTIONS(3045), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3053), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3061), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1171), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3029), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3047), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3037), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3057), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3109), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [42059] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(479), 1,
      anon_sym_BQUOTE,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2975), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3031), 1,
      anon_sym_as,
    ACTIONS(3035), 1,
      anon_sym_BANG,
    ACTIONS(3039), 1,
      anon_sym_LT,
    ACTIONS(3041), 1,
      anon_sym_QMARK,
    ACTIONS(3043), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3049), 1,
      anon_sym_AMP,
    ACTIONS(3051), 1,
      anon_sym_PIPE,
    ACTIONS(3055), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3059), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3111), 1,
      anon_sym_COMMA,
    STATE(2727), 1,
      sym_type_arguments,
    ACTIONS(3045), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3053), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3061), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1171), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3029), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3047), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3037), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3113), 4,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(3057), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [42156] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1529), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1527), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [42207] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(479), 1,
      anon_sym_BQUOTE,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2975), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3035), 1,
      anon_sym_BANG,
    ACTIONS(3039), 1,
      anon_sym_LT,
    ACTIONS(3055), 1,
      anon_sym_STAR_STAR,
    STATE(2727), 1,
      sym_type_arguments,
    ACTIONS(3053), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3061), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1171), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3029), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3047), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3063), 7,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3065), 15,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [42286] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1477), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1475), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [42337] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1549), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1547), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [42388] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1581), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1579), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [42439] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2219), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1563), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(1565), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1111), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1113), 24,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [42500] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3119), 2,
      anon_sym_COLON,
      anon_sym_EQ_GT,
    ACTIONS(3115), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3117), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [42553] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1495), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1493), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [42604] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1757), 1,
      anon_sym_DOT,
    ACTIONS(1398), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1396), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [42657] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(479), 1,
      anon_sym_BQUOTE,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2975), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3031), 1,
      anon_sym_as,
    ACTIONS(3035), 1,
      anon_sym_BANG,
    ACTIONS(3039), 1,
      anon_sym_LT,
    ACTIONS(3041), 1,
      anon_sym_QMARK,
    ACTIONS(3043), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3049), 1,
      anon_sym_AMP,
    ACTIONS(3051), 1,
      anon_sym_PIPE,
    ACTIONS(3055), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3059), 1,
      anon_sym_QMARK_QMARK,
    STATE(2727), 1,
      sym_type_arguments,
    ACTIONS(3045), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3053), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3061), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1171), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3029), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3047), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3037), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3057), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3121), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [42752] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(479), 1,
      anon_sym_BQUOTE,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2975), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3035), 1,
      anon_sym_BANG,
    ACTIONS(3127), 1,
      anon_sym_LT,
    STATE(2727), 1,
      sym_type_arguments,
    ACTIONS(3061), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1171), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3123), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3125), 19,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [42823] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(479), 1,
      anon_sym_BQUOTE,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2975), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3035), 1,
      anon_sym_BANG,
    ACTIONS(3127), 1,
      anon_sym_LT,
    STATE(2727), 1,
      sym_type_arguments,
    ACTIONS(3061), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1171), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3123), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3125), 19,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [42894] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(479), 1,
      anon_sym_BQUOTE,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2975), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3031), 1,
      anon_sym_as,
    ACTIONS(3035), 1,
      anon_sym_BANG,
    ACTIONS(3039), 1,
      anon_sym_LT,
    ACTIONS(3041), 1,
      anon_sym_QMARK,
    ACTIONS(3043), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3049), 1,
      anon_sym_AMP,
    ACTIONS(3051), 1,
      anon_sym_PIPE,
    ACTIONS(3055), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3059), 1,
      anon_sym_QMARK_QMARK,
    STATE(2727), 1,
      sym_type_arguments,
    ACTIONS(3045), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3053), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3061), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1171), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3029), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3047), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3037), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3057), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3130), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [42989] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(479), 1,
      anon_sym_BQUOTE,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2975), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3031), 1,
      anon_sym_as,
    ACTIONS(3035), 1,
      anon_sym_BANG,
    ACTIONS(3039), 1,
      anon_sym_LT,
    ACTIONS(3041), 1,
      anon_sym_QMARK,
    ACTIONS(3043), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3049), 1,
      anon_sym_AMP,
    ACTIONS(3051), 1,
      anon_sym_PIPE,
    ACTIONS(3055), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3059), 1,
      anon_sym_QMARK_QMARK,
    STATE(2727), 1,
      sym_type_arguments,
    ACTIONS(3045), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3053), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3061), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1171), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3029), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3047), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3037), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3057), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3132), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [43084] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1545), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1543), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [43135] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1605), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1603), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [43186] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1541), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1539), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [43237] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1483), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1481), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [43288] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2219), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2251), 1,
      anon_sym_COLON,
    ACTIONS(3134), 1,
      anon_sym_EQ,
    ACTIONS(3138), 1,
      anon_sym_in,
    ACTIONS(3141), 1,
      anon_sym_of,
    STATE(2459), 1,
      sym_type_annotation,
    STATE(2763), 1,
      sym__initializer,
    ACTIONS(3136), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(1111), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1113), 18,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [43359] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2219), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2251), 1,
      anon_sym_COLON,
    ACTIONS(3143), 1,
      anon_sym_EQ,
    ACTIONS(3147), 1,
      anon_sym_in,
    ACTIONS(3150), 1,
      anon_sym_of,
    STATE(2458), 1,
      sym_type_annotation,
    STATE(2762), 1,
      sym__initializer,
    ACTIONS(3145), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(1111), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1113), 18,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [43430] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1607), 1,
      anon_sym_extends,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2219), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3152), 1,
      anon_sym_COMMA,
    ACTIONS(3155), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1111), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1113), 24,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [43493] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(479), 1,
      anon_sym_BQUOTE,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2975), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3031), 1,
      anon_sym_as,
    ACTIONS(3035), 1,
      anon_sym_BANG,
    ACTIONS(3039), 1,
      anon_sym_LT,
    ACTIONS(3041), 1,
      anon_sym_QMARK,
    ACTIONS(3043), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3049), 1,
      anon_sym_AMP,
    ACTIONS(3051), 1,
      anon_sym_PIPE,
    ACTIONS(3055), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3059), 1,
      anon_sym_QMARK_QMARK,
    STATE(2727), 1,
      sym_type_arguments,
    ACTIONS(3045), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3053), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3061), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1171), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3029), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3047), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3037), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3057), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3158), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [43588] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1750), 1,
      anon_sym_extends,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2219), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3160), 1,
      anon_sym_COMMA,
    ACTIONS(3163), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1111), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1113), 24,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [43651] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(479), 1,
      anon_sym_BQUOTE,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2975), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3031), 1,
      anon_sym_as,
    ACTIONS(3035), 1,
      anon_sym_BANG,
    ACTIONS(3039), 1,
      anon_sym_LT,
    ACTIONS(3041), 1,
      anon_sym_QMARK,
    ACTIONS(3043), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3049), 1,
      anon_sym_AMP,
    ACTIONS(3051), 1,
      anon_sym_PIPE,
    ACTIONS(3055), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3059), 1,
      anon_sym_QMARK_QMARK,
    STATE(2727), 1,
      sym_type_arguments,
    ACTIONS(3045), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3053), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3061), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1171), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3029), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3047), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3037), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3057), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3166), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [43746] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1569), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1567), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [43797] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(479), 1,
      anon_sym_BQUOTE,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2975), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3031), 1,
      anon_sym_as,
    ACTIONS(3035), 1,
      anon_sym_BANG,
    ACTIONS(3039), 1,
      anon_sym_LT,
    ACTIONS(3041), 1,
      anon_sym_QMARK,
    ACTIONS(3043), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3049), 1,
      anon_sym_AMP,
    ACTIONS(3051), 1,
      anon_sym_PIPE,
    ACTIONS(3055), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3059), 1,
      anon_sym_QMARK_QMARK,
    STATE(2727), 1,
      sym_type_arguments,
    ACTIONS(3045), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3053), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3061), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1171), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3029), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3047), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3037), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3057), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3168), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [43892] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(479), 1,
      anon_sym_BQUOTE,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2975), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3035), 1,
      anon_sym_BANG,
    ACTIONS(3039), 1,
      anon_sym_LT,
    ACTIONS(3055), 1,
      anon_sym_STAR_STAR,
    STATE(2727), 1,
      sym_type_arguments,
    ACTIONS(3053), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3061), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1171), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3029), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3047), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3063), 3,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3037), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3057), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3065), 10,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [43975] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(479), 1,
      anon_sym_BQUOTE,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2975), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3127), 1,
      anon_sym_LT,
    STATE(2727), 1,
      sym_type_arguments,
    ACTIONS(3061), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1171), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3123), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3125), 19,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [44044] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(479), 1,
      anon_sym_BQUOTE,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2975), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3031), 1,
      anon_sym_as,
    ACTIONS(3035), 1,
      anon_sym_BANG,
    ACTIONS(3039), 1,
      anon_sym_LT,
    ACTIONS(3041), 1,
      anon_sym_QMARK,
    ACTIONS(3043), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3049), 1,
      anon_sym_AMP,
    ACTIONS(3051), 1,
      anon_sym_PIPE,
    ACTIONS(3055), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3059), 1,
      anon_sym_QMARK_QMARK,
    STATE(2727), 1,
      sym_type_arguments,
    ACTIONS(3045), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3053), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3061), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1171), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3029), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3047), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3037), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3057), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3170), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [44139] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(479), 1,
      anon_sym_BQUOTE,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2975), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3035), 1,
      anon_sym_BANG,
    ACTIONS(3039), 1,
      anon_sym_LT,
    ACTIONS(3043), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3049), 1,
      anon_sym_AMP,
    ACTIONS(3055), 1,
      anon_sym_STAR_STAR,
    STATE(2727), 1,
      sym_type_arguments,
    ACTIONS(3053), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3061), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3063), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    STATE(1171), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3029), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3047), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3037), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3057), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3065), 9,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [44226] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(479), 1,
      anon_sym_BQUOTE,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2975), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3031), 1,
      anon_sym_as,
    ACTIONS(3035), 1,
      anon_sym_BANG,
    ACTIONS(3039), 1,
      anon_sym_LT,
    ACTIONS(3041), 1,
      anon_sym_QMARK,
    ACTIONS(3043), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3049), 1,
      anon_sym_AMP,
    ACTIONS(3051), 1,
      anon_sym_PIPE,
    ACTIONS(3055), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3059), 1,
      anon_sym_QMARK_QMARK,
    STATE(2727), 1,
      sym_type_arguments,
    ACTIONS(3045), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3053), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3061), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1171), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3029), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3047), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3037), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3057), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3172), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [44321] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(479), 1,
      anon_sym_BQUOTE,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2975), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3031), 1,
      anon_sym_as,
    ACTIONS(3035), 1,
      anon_sym_BANG,
    ACTIONS(3039), 1,
      anon_sym_LT,
    ACTIONS(3041), 1,
      anon_sym_QMARK,
    ACTIONS(3043), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3049), 1,
      anon_sym_AMP,
    ACTIONS(3051), 1,
      anon_sym_PIPE,
    ACTIONS(3055), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3059), 1,
      anon_sym_QMARK_QMARK,
    STATE(2727), 1,
      sym_type_arguments,
    ACTIONS(3045), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3053), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3061), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1171), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3029), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3047), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3037), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3057), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3174), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [44416] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1597), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1595), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [44467] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(479), 1,
      anon_sym_BQUOTE,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2975), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3035), 1,
      anon_sym_BANG,
    ACTIONS(3055), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3067), 1,
      anon_sym_LT,
    STATE(2727), 1,
      sym_type_arguments,
    ACTIONS(3061), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1171), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3029), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3047), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3063), 9,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3065), 15,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [44544] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3074), 1,
      anon_sym_AMP,
    ACTIONS(3076), 1,
      anon_sym_PIPE,
    ACTIONS(3078), 1,
      anon_sym_extends,
    ACTIONS(1770), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1768), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [44601] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(479), 1,
      anon_sym_BQUOTE,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2975), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3031), 1,
      anon_sym_as,
    ACTIONS(3035), 1,
      anon_sym_BANG,
    ACTIONS(3039), 1,
      anon_sym_LT,
    ACTIONS(3041), 1,
      anon_sym_QMARK,
    ACTIONS(3043), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3049), 1,
      anon_sym_AMP,
    ACTIONS(3051), 1,
      anon_sym_PIPE,
    ACTIONS(3055), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3059), 1,
      anon_sym_QMARK_QMARK,
    STATE(2727), 1,
      sym_type_arguments,
    ACTIONS(3045), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3053), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3061), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1171), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3029), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3047), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3037), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3057), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3176), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [44696] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1579), 2,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(1581), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1577), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1575), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [44751] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(479), 1,
      anon_sym_BQUOTE,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2975), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3035), 1,
      anon_sym_BANG,
    ACTIONS(3039), 1,
      anon_sym_LT,
    ACTIONS(3043), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3049), 1,
      anon_sym_AMP,
    ACTIONS(3051), 1,
      anon_sym_PIPE,
    ACTIONS(3055), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3063), 1,
      anon_sym_QMARK,
    STATE(2727), 1,
      sym_type_arguments,
    ACTIONS(3045), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3053), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3061), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1171), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3029), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3047), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3037), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3057), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3065), 7,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK_QMARK,
  [44842] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3178), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3180), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [44892] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(2197), 1,
      anon_sym_LPAREN,
    ACTIONS(2313), 1,
      anon_sym_LBRACK,
    ACTIONS(2318), 1,
      anon_sym_DOT,
    ACTIONS(3184), 1,
      anon_sym_as,
    ACTIONS(3186), 1,
      anon_sym_BANG,
    ACTIONS(3190), 1,
      anon_sym_LT,
    ACTIONS(3192), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3194), 1,
      anon_sym_QMARK,
    ACTIONS(3196), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3202), 1,
      anon_sym_AMP,
    ACTIONS(3204), 1,
      anon_sym_PIPE,
    ACTIONS(3208), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3212), 1,
      anon_sym_QMARK_QMARK,
    STATE(2746), 1,
      sym_type_arguments,
    ACTIONS(3198), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3206), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3214), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1606), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3182), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3200), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3103), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(3188), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3210), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [44986] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1043), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1045), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [45036] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1017), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1015), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [45086] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(479), 1,
      anon_sym_BQUOTE,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2975), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3031), 1,
      anon_sym_as,
    ACTIONS(3035), 1,
      anon_sym_BANG,
    ACTIONS(3039), 1,
      anon_sym_LT,
    ACTIONS(3041), 1,
      anon_sym_QMARK,
    ACTIONS(3043), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3049), 1,
      anon_sym_AMP,
    ACTIONS(3051), 1,
      anon_sym_PIPE,
    ACTIONS(3055), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3059), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3111), 1,
      anon_sym_COMMA,
    ACTIONS(3216), 1,
      anon_sym_RPAREN,
    ACTIONS(3218), 1,
      anon_sym_COLON,
    STATE(2727), 1,
      sym_type_arguments,
    STATE(3167), 1,
      sym_type_annotation,
    ACTIONS(3045), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3053), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3061), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1171), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3029), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3047), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3037), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3057), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [45186] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(2197), 1,
      anon_sym_LPAREN,
    ACTIONS(2313), 1,
      anon_sym_LBRACK,
    ACTIONS(2318), 1,
      anon_sym_DOT,
    ACTIONS(3184), 1,
      anon_sym_as,
    ACTIONS(3186), 1,
      anon_sym_BANG,
    ACTIONS(3190), 1,
      anon_sym_LT,
    ACTIONS(3192), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3194), 1,
      anon_sym_QMARK,
    ACTIONS(3196), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3202), 1,
      anon_sym_AMP,
    ACTIONS(3204), 1,
      anon_sym_PIPE,
    ACTIONS(3208), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3212), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3220), 1,
      anon_sym_COMMA,
    ACTIONS(3223), 1,
      anon_sym_RBRACE,
    STATE(2746), 1,
      sym_type_arguments,
    ACTIONS(3170), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3198), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3206), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3214), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1606), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3182), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3200), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3188), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3210), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [45284] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1073), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1071), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [45334] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3015), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3017), 27,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [45384] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(2197), 1,
      anon_sym_LPAREN,
    ACTIONS(2313), 1,
      anon_sym_LBRACK,
    ACTIONS(2318), 1,
      anon_sym_DOT,
    ACTIONS(3184), 1,
      anon_sym_as,
    ACTIONS(3186), 1,
      anon_sym_BANG,
    ACTIONS(3190), 1,
      anon_sym_LT,
    ACTIONS(3192), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3194), 1,
      anon_sym_QMARK,
    ACTIONS(3196), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3202), 1,
      anon_sym_AMP,
    ACTIONS(3204), 1,
      anon_sym_PIPE,
    ACTIONS(3208), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3212), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3225), 1,
      anon_sym_COMMA,
    ACTIONS(3228), 1,
      anon_sym_RBRACE,
    STATE(2746), 1,
      sym_type_arguments,
    ACTIONS(3172), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3198), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3206), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3214), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1606), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3182), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3200), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3188), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3210), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [45482] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3230), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3103), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [45532] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3232), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3033), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [45582] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(2197), 1,
      anon_sym_LPAREN,
    ACTIONS(2313), 1,
      anon_sym_LBRACK,
    ACTIONS(2318), 1,
      anon_sym_DOT,
    ACTIONS(3184), 1,
      anon_sym_as,
    ACTIONS(3186), 1,
      anon_sym_BANG,
    ACTIONS(3190), 1,
      anon_sym_LT,
    ACTIONS(3192), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3194), 1,
      anon_sym_QMARK,
    ACTIONS(3196), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3202), 1,
      anon_sym_AMP,
    ACTIONS(3204), 1,
      anon_sym_PIPE,
    ACTIONS(3208), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3212), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3234), 1,
      anon_sym_COMMA,
    ACTIONS(3237), 1,
      anon_sym_RBRACE,
    STATE(2746), 1,
      sym_type_arguments,
    ACTIONS(3083), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3198), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3206), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3214), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1606), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3182), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3200), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3188), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3210), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [45680] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3239), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3241), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [45730] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2746), 1,
      sym_type_arguments,
    STATE(1606), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2981), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2983), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [45784] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3243), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3245), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [45834] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(2197), 1,
      anon_sym_LPAREN,
    ACTIONS(2313), 1,
      anon_sym_LBRACK,
    ACTIONS(2318), 1,
      anon_sym_DOT,
    ACTIONS(3186), 1,
      anon_sym_BANG,
    ACTIONS(3192), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3247), 1,
      anon_sym_LT,
    STATE(2746), 1,
      sym_type_arguments,
    ACTIONS(3214), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1606), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3123), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3125), 18,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [45904] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1119), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1121), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [45954] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1101), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1103), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [46004] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3011), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3013), 27,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [46054] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(2197), 1,
      anon_sym_LPAREN,
    ACTIONS(2313), 1,
      anon_sym_LBRACK,
    ACTIONS(2318), 1,
      anon_sym_DOT,
    ACTIONS(3184), 1,
      anon_sym_as,
    ACTIONS(3186), 1,
      anon_sym_BANG,
    ACTIONS(3190), 1,
      anon_sym_LT,
    ACTIONS(3192), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3194), 1,
      anon_sym_QMARK,
    ACTIONS(3196), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3202), 1,
      anon_sym_AMP,
    ACTIONS(3204), 1,
      anon_sym_PIPE,
    ACTIONS(3208), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3212), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3237), 1,
      anon_sym_RBRACE,
    ACTIONS(3250), 1,
      anon_sym_COMMA,
    STATE(2746), 1,
      sym_type_arguments,
    ACTIONS(3174), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3198), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3206), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3214), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1606), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3182), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3200), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3188), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3210), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [46152] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3253), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3255), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [46202] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3257), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3176), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [46252] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(2197), 1,
      anon_sym_LPAREN,
    ACTIONS(2313), 1,
      anon_sym_LBRACK,
    ACTIONS(2318), 1,
      anon_sym_DOT,
    ACTIONS(3184), 1,
      anon_sym_as,
    ACTIONS(3186), 1,
      anon_sym_BANG,
    ACTIONS(3190), 1,
      anon_sym_LT,
    ACTIONS(3192), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3194), 1,
      anon_sym_QMARK,
    ACTIONS(3196), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3202), 1,
      anon_sym_AMP,
    ACTIONS(3204), 1,
      anon_sym_PIPE,
    ACTIONS(3208), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3212), 1,
      anon_sym_QMARK_QMARK,
    STATE(2746), 1,
      sym_type_arguments,
    ACTIONS(3198), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3206), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3214), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1606), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3182), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3200), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3174), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(3188), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3210), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [46346] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3259), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3085), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [46396] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3261), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3263), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [46446] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(2197), 1,
      anon_sym_LPAREN,
    ACTIONS(2313), 1,
      anon_sym_LBRACK,
    ACTIONS(2318), 1,
      anon_sym_DOT,
    ACTIONS(3184), 1,
      anon_sym_as,
    ACTIONS(3186), 1,
      anon_sym_BANG,
    ACTIONS(3190), 1,
      anon_sym_LT,
    ACTIONS(3192), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3194), 1,
      anon_sym_QMARK,
    ACTIONS(3196), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3202), 1,
      anon_sym_AMP,
    ACTIONS(3204), 1,
      anon_sym_PIPE,
    ACTIONS(3208), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3212), 1,
      anon_sym_QMARK_QMARK,
    STATE(2746), 1,
      sym_type_arguments,
    ACTIONS(3198), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3206), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3214), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1606), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3182), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3200), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3166), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(3188), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3210), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [46540] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(2197), 1,
      anon_sym_LPAREN,
    ACTIONS(2313), 1,
      anon_sym_LBRACK,
    ACTIONS(2318), 1,
      anon_sym_DOT,
    ACTIONS(3184), 1,
      anon_sym_as,
    ACTIONS(3186), 1,
      anon_sym_BANG,
    ACTIONS(3190), 1,
      anon_sym_LT,
    ACTIONS(3192), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3194), 1,
      anon_sym_QMARK,
    ACTIONS(3196), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3202), 1,
      anon_sym_AMP,
    ACTIONS(3204), 1,
      anon_sym_PIPE,
    ACTIONS(3208), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3212), 1,
      anon_sym_QMARK_QMARK,
    STATE(2746), 1,
      sym_type_arguments,
    ACTIONS(3198), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3206), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3214), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1606), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3182), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3200), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3168), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(3188), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3210), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [46634] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3265), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3267), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [46684] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(2197), 1,
      anon_sym_LPAREN,
    ACTIONS(2313), 1,
      anon_sym_LBRACK,
    ACTIONS(2318), 1,
      anon_sym_DOT,
    ACTIONS(3184), 1,
      anon_sym_as,
    ACTIONS(3186), 1,
      anon_sym_BANG,
    ACTIONS(3190), 1,
      anon_sym_LT,
    ACTIONS(3192), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3194), 1,
      anon_sym_QMARK,
    ACTIONS(3196), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3202), 1,
      anon_sym_AMP,
    ACTIONS(3204), 1,
      anon_sym_PIPE,
    ACTIONS(3208), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3212), 1,
      anon_sym_QMARK_QMARK,
    STATE(2746), 1,
      sym_type_arguments,
    ACTIONS(3198), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3206), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3214), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1606), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3182), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3200), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3170), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(3188), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3210), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [46778] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(479), 1,
      anon_sym_BQUOTE,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2975), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3031), 1,
      anon_sym_as,
    ACTIONS(3035), 1,
      anon_sym_BANG,
    ACTIONS(3039), 1,
      anon_sym_LT,
    ACTIONS(3041), 1,
      anon_sym_QMARK,
    ACTIONS(3043), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3049), 1,
      anon_sym_AMP,
    ACTIONS(3051), 1,
      anon_sym_PIPE,
    ACTIONS(3055), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3059), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3111), 1,
      anon_sym_COMMA,
    ACTIONS(3218), 1,
      anon_sym_COLON,
    ACTIONS(3269), 1,
      anon_sym_RPAREN,
    STATE(2727), 1,
      sym_type_arguments,
    STATE(3380), 1,
      sym_type_annotation,
    ACTIONS(3045), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3053), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3061), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1171), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3029), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3047), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3037), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3057), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [46878] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(2197), 1,
      anon_sym_LPAREN,
    ACTIONS(2313), 1,
      anon_sym_LBRACK,
    ACTIONS(2318), 1,
      anon_sym_DOT,
    ACTIONS(3184), 1,
      anon_sym_as,
    ACTIONS(3186), 1,
      anon_sym_BANG,
    ACTIONS(3190), 1,
      anon_sym_LT,
    ACTIONS(3192), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3194), 1,
      anon_sym_QMARK,
    ACTIONS(3196), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3202), 1,
      anon_sym_AMP,
    ACTIONS(3204), 1,
      anon_sym_PIPE,
    ACTIONS(3208), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3212), 1,
      anon_sym_QMARK_QMARK,
    STATE(2746), 1,
      sym_type_arguments,
    ACTIONS(3198), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3206), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3214), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1606), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3182), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3200), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3172), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(3188), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3210), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [46972] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(977), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(975), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [47022] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(2197), 1,
      anon_sym_LPAREN,
    ACTIONS(2313), 1,
      anon_sym_LBRACK,
    ACTIONS(2318), 1,
      anon_sym_DOT,
    ACTIONS(3063), 1,
      anon_sym_QMARK,
    ACTIONS(3186), 1,
      anon_sym_BANG,
    ACTIONS(3190), 1,
      anon_sym_LT,
    ACTIONS(3192), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3196), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3202), 1,
      anon_sym_AMP,
    ACTIONS(3204), 1,
      anon_sym_PIPE,
    ACTIONS(3208), 1,
      anon_sym_STAR_STAR,
    STATE(2746), 1,
      sym_type_arguments,
    ACTIONS(3198), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3206), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3214), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1606), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3182), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3200), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3188), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3210), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3065), 6,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_QMARK_QMARK,
  [47112] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(2197), 1,
      anon_sym_LPAREN,
    ACTIONS(2313), 1,
      anon_sym_LBRACK,
    ACTIONS(2318), 1,
      anon_sym_DOT,
    ACTIONS(3186), 1,
      anon_sym_BANG,
    ACTIONS(3192), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3271), 1,
      anon_sym_LT,
    STATE(2746), 1,
      sym_type_arguments,
    ACTIONS(3214), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1606), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3063), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3065), 18,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [47182] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(2197), 1,
      anon_sym_LPAREN,
    ACTIONS(2313), 1,
      anon_sym_LBRACK,
    ACTIONS(2318), 1,
      anon_sym_DOT,
    ACTIONS(3186), 1,
      anon_sym_BANG,
    ACTIONS(3192), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3208), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3271), 1,
      anon_sym_LT,
    STATE(2746), 1,
      sym_type_arguments,
    ACTIONS(3214), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1606), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3182), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3200), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3063), 9,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3065), 14,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [47258] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(2197), 1,
      anon_sym_LPAREN,
    ACTIONS(2313), 1,
      anon_sym_LBRACK,
    ACTIONS(2318), 1,
      anon_sym_DOT,
    ACTIONS(3186), 1,
      anon_sym_BANG,
    ACTIONS(3190), 1,
      anon_sym_LT,
    ACTIONS(3192), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3196), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3202), 1,
      anon_sym_AMP,
    ACTIONS(3208), 1,
      anon_sym_STAR_STAR,
    STATE(2746), 1,
      sym_type_arguments,
    ACTIONS(3063), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(3206), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3214), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1606), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3182), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3200), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3188), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3210), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3065), 8,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [47344] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(2197), 1,
      anon_sym_LPAREN,
    ACTIONS(2313), 1,
      anon_sym_LBRACK,
    ACTIONS(2318), 1,
      anon_sym_DOT,
    ACTIONS(3186), 1,
      anon_sym_BANG,
    ACTIONS(3190), 1,
      anon_sym_LT,
    ACTIONS(3192), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3208), 1,
      anon_sym_STAR_STAR,
    STATE(2746), 1,
      sym_type_arguments,
    ACTIONS(3206), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3214), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1606), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3063), 3,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3182), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3200), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3188), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3210), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3065), 9,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [47426] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3274), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3276), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [47476] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3278), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3280), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [47526] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3282), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3284), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [47576] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(479), 1,
      anon_sym_BQUOTE,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2975), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3031), 1,
      anon_sym_as,
    ACTIONS(3035), 1,
      anon_sym_BANG,
    ACTIONS(3039), 1,
      anon_sym_LT,
    ACTIONS(3041), 1,
      anon_sym_QMARK,
    ACTIONS(3043), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3049), 1,
      anon_sym_AMP,
    ACTIONS(3051), 1,
      anon_sym_PIPE,
    ACTIONS(3055), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3059), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3111), 1,
      anon_sym_COMMA,
    ACTIONS(3218), 1,
      anon_sym_COLON,
    ACTIONS(3286), 1,
      anon_sym_RPAREN,
    STATE(2727), 1,
      sym_type_arguments,
    STATE(3337), 1,
      sym_type_annotation,
    ACTIONS(3045), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3053), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3061), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1171), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3029), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3047), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3037), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3057), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [47676] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3288), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3290), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [47726] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3292), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3294), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [47776] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3296), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3298), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [47826] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(2197), 1,
      anon_sym_LPAREN,
    ACTIONS(2313), 1,
      anon_sym_LBRACK,
    ACTIONS(2318), 1,
      anon_sym_DOT,
    ACTIONS(3186), 1,
      anon_sym_BANG,
    ACTIONS(3190), 1,
      anon_sym_LT,
    ACTIONS(3192), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3208), 1,
      anon_sym_STAR_STAR,
    STATE(2746), 1,
      sym_type_arguments,
    ACTIONS(3206), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3214), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1606), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3182), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3200), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3063), 7,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3065), 14,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [47904] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(2197), 1,
      anon_sym_LPAREN,
    ACTIONS(2313), 1,
      anon_sym_LBRACK,
    ACTIONS(2318), 1,
      anon_sym_DOT,
    ACTIONS(3184), 1,
      anon_sym_as,
    ACTIONS(3186), 1,
      anon_sym_BANG,
    ACTIONS(3190), 1,
      anon_sym_LT,
    ACTIONS(3192), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3194), 1,
      anon_sym_QMARK,
    ACTIONS(3196), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3202), 1,
      anon_sym_AMP,
    ACTIONS(3204), 1,
      anon_sym_PIPE,
    ACTIONS(3208), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3212), 1,
      anon_sym_QMARK_QMARK,
    STATE(2746), 1,
      sym_type_arguments,
    ACTIONS(3198), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3206), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3214), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1606), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3182), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3200), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3176), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(3188), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3210), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [47998] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2313), 1,
      anon_sym_LBRACK,
    ACTIONS(2318), 1,
      anon_sym_DOT,
    ACTIONS(3192), 1,
      anon_sym_QMARK_DOT,
    STATE(2746), 1,
      sym_type_arguments,
    STATE(1606), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2971), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2973), 22,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [48058] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(2197), 1,
      anon_sym_LPAREN,
    ACTIONS(2313), 1,
      anon_sym_LBRACK,
    ACTIONS(2318), 1,
      anon_sym_DOT,
    ACTIONS(3192), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3247), 1,
      anon_sym_LT,
    STATE(2746), 1,
      sym_type_arguments,
    ACTIONS(3214), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1606), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3123), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3125), 18,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [48126] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2197), 1,
      anon_sym_LPAREN,
    ACTIONS(2199), 1,
      anon_sym_LT,
    ACTIONS(2313), 1,
      anon_sym_LBRACK,
    ACTIONS(2318), 1,
      anon_sym_DOT,
    ACTIONS(2322), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2979), 1,
      anon_sym_EQ,
    STATE(1377), 1,
      sym_type_arguments,
    STATE(1513), 1,
      sym_arguments,
    ACTIONS(2209), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2213), 21,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [48192] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(2197), 1,
      anon_sym_LPAREN,
    ACTIONS(2313), 1,
      anon_sym_LBRACK,
    ACTIONS(2318), 1,
      anon_sym_DOT,
    ACTIONS(3186), 1,
      anon_sym_BANG,
    ACTIONS(3192), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3208), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3271), 1,
      anon_sym_LT,
    STATE(2746), 1,
      sym_type_arguments,
    ACTIONS(3214), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1606), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3063), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3065), 17,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [48264] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2994), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2996), 27,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [48314] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1129), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1131), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [48364] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3300), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3302), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [48414] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3304), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3306), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [48464] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3308), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3310), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [48514] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(2197), 1,
      anon_sym_LPAREN,
    ACTIONS(2313), 1,
      anon_sym_LBRACK,
    ACTIONS(2318), 1,
      anon_sym_DOT,
    ACTIONS(3184), 1,
      anon_sym_as,
    ACTIONS(3186), 1,
      anon_sym_BANG,
    ACTIONS(3190), 1,
      anon_sym_LT,
    ACTIONS(3192), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3194), 1,
      anon_sym_QMARK,
    ACTIONS(3196), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3202), 1,
      anon_sym_AMP,
    ACTIONS(3204), 1,
      anon_sym_PIPE,
    ACTIONS(3208), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3212), 1,
      anon_sym_QMARK_QMARK,
    STATE(2746), 1,
      sym_type_arguments,
    ACTIONS(3198), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3206), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3214), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1606), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3182), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3200), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3033), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(3188), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3210), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [48608] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(2197), 1,
      anon_sym_LPAREN,
    ACTIONS(2313), 1,
      anon_sym_LBRACK,
    ACTIONS(2318), 1,
      anon_sym_DOT,
    ACTIONS(3184), 1,
      anon_sym_as,
    ACTIONS(3186), 1,
      anon_sym_BANG,
    ACTIONS(3190), 1,
      anon_sym_LT,
    ACTIONS(3192), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3194), 1,
      anon_sym_QMARK,
    ACTIONS(3196), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3202), 1,
      anon_sym_AMP,
    ACTIONS(3204), 1,
      anon_sym_PIPE,
    ACTIONS(3208), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3212), 1,
      anon_sym_QMARK_QMARK,
    STATE(2746), 1,
      sym_type_arguments,
    ACTIONS(3198), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3206), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3214), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1606), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3182), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3200), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3083), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(3188), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3210), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [48702] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(697), 1,
      anon_sym_BQUOTE,
    ACTIONS(2201), 1,
      anon_sym_LPAREN,
    ACTIONS(2633), 1,
      anon_sym_LBRACK,
    ACTIONS(2651), 1,
      anon_sym_DOT,
    ACTIONS(2721), 1,
      anon_sym_COMMA,
    ACTIONS(3314), 1,
      anon_sym_as,
    ACTIONS(3316), 1,
      anon_sym_LBRACE,
    ACTIONS(3318), 1,
      anon_sym_BANG,
    ACTIONS(3322), 1,
      anon_sym_LT,
    ACTIONS(3324), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3326), 1,
      anon_sym_QMARK,
    ACTIONS(3328), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3334), 1,
      anon_sym_AMP,
    ACTIONS(3336), 1,
      anon_sym_PIPE,
    ACTIONS(3340), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3344), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3348), 1,
      anon_sym_LBRACE_PIPE,
    STATE(2686), 1,
      aux_sym_extends_clause_repeat1,
    STATE(2693), 1,
      sym_type_arguments,
    ACTIONS(3330), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3338), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3346), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1746), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3312), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3332), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3320), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3342), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [48802] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(479), 1,
      anon_sym_BQUOTE,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2975), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3031), 1,
      anon_sym_as,
    ACTIONS(3035), 1,
      anon_sym_BANG,
    ACTIONS(3039), 1,
      anon_sym_LT,
    ACTIONS(3041), 1,
      anon_sym_QMARK,
    ACTIONS(3043), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3049), 1,
      anon_sym_AMP,
    ACTIONS(3051), 1,
      anon_sym_PIPE,
    ACTIONS(3055), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3059), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3111), 1,
      anon_sym_COMMA,
    ACTIONS(3218), 1,
      anon_sym_COLON,
    ACTIONS(3350), 1,
      anon_sym_RPAREN,
    STATE(2727), 1,
      sym_type_arguments,
    STATE(3360), 1,
      sym_type_annotation,
    ACTIONS(3045), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3053), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3061), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1171), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3029), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3047), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3037), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3057), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [48902] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(2197), 1,
      anon_sym_LPAREN,
    ACTIONS(2313), 1,
      anon_sym_LBRACK,
    ACTIONS(2318), 1,
      anon_sym_DOT,
    ACTIONS(3184), 1,
      anon_sym_as,
    ACTIONS(3186), 1,
      anon_sym_BANG,
    ACTIONS(3190), 1,
      anon_sym_LT,
    ACTIONS(3192), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3194), 1,
      anon_sym_QMARK,
    ACTIONS(3196), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3202), 1,
      anon_sym_AMP,
    ACTIONS(3204), 1,
      anon_sym_PIPE,
    ACTIONS(3208), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3212), 1,
      anon_sym_QMARK_QMARK,
    STATE(2746), 1,
      sym_type_arguments,
    ACTIONS(3198), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3206), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3214), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1606), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3182), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3200), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3132), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(3188), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3210), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [48996] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2985), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2987), 27,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [49046] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(2197), 1,
      anon_sym_LPAREN,
    ACTIONS(2313), 1,
      anon_sym_LBRACK,
    ACTIONS(2318), 1,
      anon_sym_DOT,
    ACTIONS(3184), 1,
      anon_sym_as,
    ACTIONS(3186), 1,
      anon_sym_BANG,
    ACTIONS(3190), 1,
      anon_sym_LT,
    ACTIONS(3192), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3194), 1,
      anon_sym_QMARK,
    ACTIONS(3196), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3202), 1,
      anon_sym_AMP,
    ACTIONS(3204), 1,
      anon_sym_PIPE,
    ACTIONS(3208), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3212), 1,
      anon_sym_QMARK_QMARK,
    STATE(2746), 1,
      sym_type_arguments,
    ACTIONS(3198), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3206), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3214), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1606), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3182), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3200), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3085), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(3188), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3210), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [49140] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2197), 1,
      anon_sym_LPAREN,
    ACTIONS(2199), 1,
      anon_sym_LT,
    ACTIONS(2313), 1,
      anon_sym_LBRACK,
    ACTIONS(2318), 1,
      anon_sym_DOT,
    ACTIONS(2322), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2977), 1,
      anon_sym_EQ,
    STATE(1377), 1,
      sym_type_arguments,
    STATE(1513), 1,
      sym_arguments,
    ACTIONS(2209), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2213), 21,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [49206] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3352), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3354), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [49256] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(479), 1,
      anon_sym_BQUOTE,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2975), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3031), 1,
      anon_sym_as,
    ACTIONS(3035), 1,
      anon_sym_BANG,
    ACTIONS(3039), 1,
      anon_sym_LT,
    ACTIONS(3041), 1,
      anon_sym_QMARK,
    ACTIONS(3043), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3049), 1,
      anon_sym_AMP,
    ACTIONS(3051), 1,
      anon_sym_PIPE,
    ACTIONS(3055), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3059), 1,
      anon_sym_QMARK_QMARK,
    STATE(2727), 1,
      sym_type_arguments,
    ACTIONS(3045), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3053), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3061), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1171), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3029), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3047), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3037), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3356), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    ACTIONS(3057), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [49350] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1051), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1049), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [49400] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3358), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3360), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [49450] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(981), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(979), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [49500] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3362), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3168), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [49550] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1065), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1063), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [49600] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(2197), 1,
      anon_sym_LPAREN,
    ACTIONS(2313), 1,
      anon_sym_LBRACK,
    ACTIONS(2318), 1,
      anon_sym_DOT,
    ACTIONS(3184), 1,
      anon_sym_as,
    ACTIONS(3186), 1,
      anon_sym_BANG,
    ACTIONS(3190), 1,
      anon_sym_LT,
    ACTIONS(3192), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3194), 1,
      anon_sym_QMARK,
    ACTIONS(3196), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3202), 1,
      anon_sym_AMP,
    ACTIONS(3204), 1,
      anon_sym_PIPE,
    ACTIONS(3208), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3212), 1,
      anon_sym_QMARK_QMARK,
    STATE(2746), 1,
      sym_type_arguments,
    ACTIONS(3198), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3206), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3214), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1606), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3182), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3200), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3158), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(3188), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3210), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [49694] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3026), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3023), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
    ACTIONS(1535), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2985), 13,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2987), 20,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [49750] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(479), 1,
      anon_sym_BQUOTE,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2975), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3031), 1,
      anon_sym_as,
    ACTIONS(3035), 1,
      anon_sym_BANG,
    ACTIONS(3039), 1,
      anon_sym_LT,
    ACTIONS(3041), 1,
      anon_sym_QMARK,
    ACTIONS(3043), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3049), 1,
      anon_sym_AMP,
    ACTIONS(3051), 1,
      anon_sym_PIPE,
    ACTIONS(3055), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3059), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3111), 1,
      anon_sym_COMMA,
    ACTIONS(3218), 1,
      anon_sym_COLON,
    ACTIONS(3364), 1,
      anon_sym_RPAREN,
    STATE(2727), 1,
      sym_type_arguments,
    STATE(3174), 1,
      sym_type_annotation,
    ACTIONS(3045), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3053), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3061), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1171), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3029), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3047), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3037), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3057), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [49850] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2998), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3000), 27,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [49900] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(987), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(989), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [49950] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3366), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3368), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [50000] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3370), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3372), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [50050] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3374), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3376), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [50100] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(2197), 1,
      anon_sym_LPAREN,
    ACTIONS(2313), 1,
      anon_sym_LBRACK,
    ACTIONS(2318), 1,
      anon_sym_DOT,
    ACTIONS(3186), 1,
      anon_sym_BANG,
    ACTIONS(3192), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3247), 1,
      anon_sym_LT,
    STATE(2746), 1,
      sym_type_arguments,
    ACTIONS(3214), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1606), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3123), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3125), 18,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [50170] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2219), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1111), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1113), 25,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [50226] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3378), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3380), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [50276] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(969), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(971), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [50326] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(479), 1,
      anon_sym_BQUOTE,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2738), 1,
      anon_sym_COMMA,
    ACTIONS(2975), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3031), 1,
      anon_sym_as,
    ACTIONS(3035), 1,
      anon_sym_BANG,
    ACTIONS(3386), 1,
      anon_sym_LT,
    ACTIONS(3388), 1,
      anon_sym_QMARK,
    ACTIONS(3390), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3396), 1,
      anon_sym_AMP,
    ACTIONS(3398), 1,
      anon_sym_PIPE,
    ACTIONS(3402), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3406), 1,
      anon_sym_QMARK_QMARK,
    STATE(2727), 1,
      sym_type_arguments,
    STATE(2733), 1,
      aux_sym_extends_clause_repeat1,
    ACTIONS(3061), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3348), 2,
      anon_sym_LBRACE,
      anon_sym_implements,
    ACTIONS(3392), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3400), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1171), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3382), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3394), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3384), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3404), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [50424] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(945), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(947), 27,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [50474] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3115), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3117), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [50524] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1023), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1025), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [50574] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3070), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3072), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [50624] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1113), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [50674] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1093), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1091), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [50724] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(2197), 1,
      anon_sym_LPAREN,
    ACTIONS(2313), 1,
      anon_sym_LBRACK,
    ACTIONS(2318), 1,
      anon_sym_DOT,
    ACTIONS(3184), 1,
      anon_sym_as,
    ACTIONS(3186), 1,
      anon_sym_BANG,
    ACTIONS(3190), 1,
      anon_sym_LT,
    ACTIONS(3192), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3194), 1,
      anon_sym_QMARK,
    ACTIONS(3196), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3202), 1,
      anon_sym_AMP,
    ACTIONS(3204), 1,
      anon_sym_PIPE,
    ACTIONS(3208), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3212), 1,
      anon_sym_QMARK_QMARK,
    STATE(2746), 1,
      sym_type_arguments,
    ACTIONS(3198), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3206), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3214), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1606), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3182), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3200), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3130), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(3188), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3210), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [50818] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3408), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3109), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [50868] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3019), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3021), 27,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [50918] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1515), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1513), 7,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(945), 13,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(947), 20,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [50972] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1033), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1035), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [51022] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(997), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(999), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [51072] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3410), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3412), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [51122] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3414), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3416), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [51172] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3418), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3420), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [51222] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1007), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1009), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [51272] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3422), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3424), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [51322] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(955), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(957), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [51372] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(2197), 1,
      anon_sym_LPAREN,
    ACTIONS(2313), 1,
      anon_sym_LBRACK,
    ACTIONS(2318), 1,
      anon_sym_DOT,
    ACTIONS(3184), 1,
      anon_sym_as,
    ACTIONS(3186), 1,
      anon_sym_BANG,
    ACTIONS(3190), 1,
      anon_sym_LT,
    ACTIONS(3192), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3194), 1,
      anon_sym_QMARK,
    ACTIONS(3196), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3202), 1,
      anon_sym_AMP,
    ACTIONS(3204), 1,
      anon_sym_PIPE,
    ACTIONS(3208), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3212), 1,
      anon_sym_QMARK_QMARK,
    STATE(2746), 1,
      sym_type_arguments,
    ACTIONS(3198), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3206), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3214), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1606), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3182), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3200), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3121), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(3188), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3210), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [51466] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3009), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2840), 27,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [51516] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3426), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3428), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [51566] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3430), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3432), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [51616] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3434), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3436), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [51666] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1057), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1059), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [51716] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2848), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2852), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [51766] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(2197), 1,
      anon_sym_LPAREN,
    ACTIONS(2313), 1,
      anon_sym_LBRACK,
    ACTIONS(2318), 1,
      anon_sym_DOT,
    ACTIONS(3184), 1,
      anon_sym_as,
    ACTIONS(3186), 1,
      anon_sym_BANG,
    ACTIONS(3190), 1,
      anon_sym_LT,
    ACTIONS(3192), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3194), 1,
      anon_sym_QMARK,
    ACTIONS(3196), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3202), 1,
      anon_sym_AMP,
    ACTIONS(3204), 1,
      anon_sym_PIPE,
    ACTIONS(3208), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3212), 1,
      anon_sym_QMARK_QMARK,
    STATE(2746), 1,
      sym_type_arguments,
    ACTIONS(3198), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3206), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3214), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1606), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3182), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3200), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3109), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(3188), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3210), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [51860] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1017), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1015), 28,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [51910] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(479), 1,
      anon_sym_BQUOTE,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2975), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3031), 1,
      anon_sym_as,
    ACTIONS(3035), 1,
      anon_sym_BANG,
    ACTIONS(3386), 1,
      anon_sym_LT,
    ACTIONS(3388), 1,
      anon_sym_QMARK,
    ACTIONS(3390), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3396), 1,
      anon_sym_AMP,
    ACTIONS(3398), 1,
      anon_sym_PIPE,
    ACTIONS(3402), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3406), 1,
      anon_sym_QMARK_QMARK,
    STATE(2727), 1,
      sym_type_arguments,
    ACTIONS(3061), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3392), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3400), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1171), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3130), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(3382), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3394), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3384), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3404), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [52003] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(479), 1,
      anon_sym_BQUOTE,
    ACTIONS(1147), 1,
      anon_sym_COMMA,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2975), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3031), 1,
      anon_sym_as,
    ACTIONS(3035), 1,
      anon_sym_BANG,
    ACTIONS(3039), 1,
      anon_sym_LT,
    ACTIONS(3041), 1,
      anon_sym_QMARK,
    ACTIONS(3043), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3049), 1,
      anon_sym_AMP,
    ACTIONS(3051), 1,
      anon_sym_PIPE,
    ACTIONS(3055), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3059), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3438), 1,
      anon_sym_RBRACK,
    STATE(2727), 1,
      sym_type_arguments,
    STATE(2797), 1,
      aux_sym_array_repeat1,
    ACTIONS(3045), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3053), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3061), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1171), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3029), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3047), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3037), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3057), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [52100] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(479), 1,
      anon_sym_BQUOTE,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2975), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3031), 1,
      anon_sym_as,
    ACTIONS(3035), 1,
      anon_sym_BANG,
    ACTIONS(3386), 1,
      anon_sym_LT,
    ACTIONS(3388), 1,
      anon_sym_QMARK,
    ACTIONS(3390), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3396), 1,
      anon_sym_AMP,
    ACTIONS(3398), 1,
      anon_sym_PIPE,
    ACTIONS(3402), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3406), 1,
      anon_sym_QMARK_QMARK,
    STATE(2727), 1,
      sym_type_arguments,
    ACTIONS(3061), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3392), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3400), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1171), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3172), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(3382), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3394), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3384), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3404), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [52193] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3119), 2,
      anon_sym_COLON,
      anon_sym_EQ_GT,
    ACTIONS(3115), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3117), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [52244] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(479), 1,
      anon_sym_BQUOTE,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2975), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3031), 1,
      anon_sym_as,
    ACTIONS(3035), 1,
      anon_sym_BANG,
    ACTIONS(3386), 1,
      anon_sym_LT,
    ACTIONS(3388), 1,
      anon_sym_QMARK,
    ACTIONS(3390), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3396), 1,
      anon_sym_AMP,
    ACTIONS(3398), 1,
      anon_sym_PIPE,
    ACTIONS(3402), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3406), 1,
      anon_sym_QMARK_QMARK,
    STATE(2727), 1,
      sym_type_arguments,
    ACTIONS(3061), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3392), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3400), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1171), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3170), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(3382), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3394), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3384), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3404), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [52337] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(697), 1,
      anon_sym_BQUOTE,
    ACTIONS(2201), 1,
      anon_sym_LPAREN,
    ACTIONS(2633), 1,
      anon_sym_LBRACK,
    ACTIONS(2651), 1,
      anon_sym_DOT,
    ACTIONS(3314), 1,
      anon_sym_as,
    ACTIONS(3318), 1,
      anon_sym_BANG,
    ACTIONS(3322), 1,
      anon_sym_LT,
    ACTIONS(3324), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3326), 1,
      anon_sym_QMARK,
    ACTIONS(3328), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3334), 1,
      anon_sym_AMP,
    ACTIONS(3336), 1,
      anon_sym_PIPE,
    ACTIONS(3340), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3344), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3362), 1,
      anon_sym_LBRACE,
    STATE(2693), 1,
      sym_type_arguments,
    ACTIONS(3168), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3330), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3338), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3346), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1746), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3312), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3332), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3320), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3342), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [52432] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(697), 1,
      anon_sym_BQUOTE,
    ACTIONS(2201), 1,
      anon_sym_LPAREN,
    ACTIONS(2633), 1,
      anon_sym_LBRACK,
    ACTIONS(2651), 1,
      anon_sym_DOT,
    ACTIONS(3314), 1,
      anon_sym_as,
    ACTIONS(3318), 1,
      anon_sym_BANG,
    ACTIONS(3322), 1,
      anon_sym_LT,
    ACTIONS(3324), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3326), 1,
      anon_sym_QMARK,
    ACTIONS(3328), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3334), 1,
      anon_sym_AMP,
    ACTIONS(3336), 1,
      anon_sym_PIPE,
    ACTIONS(3340), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3344), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3440), 1,
      anon_sym_LBRACE,
    STATE(2693), 1,
      sym_type_arguments,
    ACTIONS(3170), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3330), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3338), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3346), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1746), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3312), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3332), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3320), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3342), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [52527] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(479), 1,
      anon_sym_BQUOTE,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2975), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3035), 1,
      anon_sym_BANG,
    ACTIONS(3442), 1,
      anon_sym_LT,
    STATE(2727), 1,
      sym_type_arguments,
    ACTIONS(3061), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1171), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3123), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3125), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_implements,
  [52596] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(479), 1,
      anon_sym_BQUOTE,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2975), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3031), 1,
      anon_sym_as,
    ACTIONS(3035), 1,
      anon_sym_BANG,
    ACTIONS(3386), 1,
      anon_sym_LT,
    ACTIONS(3388), 1,
      anon_sym_QMARK,
    ACTIONS(3390), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3396), 1,
      anon_sym_AMP,
    ACTIONS(3398), 1,
      anon_sym_PIPE,
    ACTIONS(3402), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3406), 1,
      anon_sym_QMARK_QMARK,
    STATE(2727), 1,
      sym_type_arguments,
    ACTIONS(3061), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3392), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3400), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1171), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3158), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(3382), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3394), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3384), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3404), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [52689] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(479), 1,
      anon_sym_BQUOTE,
    ACTIONS(1147), 1,
      anon_sym_COMMA,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2975), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3031), 1,
      anon_sym_as,
    ACTIONS(3035), 1,
      anon_sym_BANG,
    ACTIONS(3039), 1,
      anon_sym_LT,
    ACTIONS(3041), 1,
      anon_sym_QMARK,
    ACTIONS(3043), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3049), 1,
      anon_sym_AMP,
    ACTIONS(3051), 1,
      anon_sym_PIPE,
    ACTIONS(3055), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3059), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3445), 1,
      anon_sym_RBRACK,
    STATE(2727), 1,
      sym_type_arguments,
    STATE(2809), 1,
      aux_sym_array_repeat1,
    ACTIONS(3045), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3053), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3061), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1171), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3029), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3047), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3037), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3057), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [52786] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(697), 1,
      anon_sym_BQUOTE,
    ACTIONS(2201), 1,
      anon_sym_LPAREN,
    ACTIONS(2633), 1,
      anon_sym_LBRACK,
    ACTIONS(2651), 1,
      anon_sym_DOT,
    ACTIONS(3259), 1,
      anon_sym_LBRACE,
    ACTIONS(3314), 1,
      anon_sym_as,
    ACTIONS(3318), 1,
      anon_sym_BANG,
    ACTIONS(3322), 1,
      anon_sym_LT,
    ACTIONS(3324), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3326), 1,
      anon_sym_QMARK,
    ACTIONS(3328), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3334), 1,
      anon_sym_AMP,
    ACTIONS(3336), 1,
      anon_sym_PIPE,
    ACTIONS(3340), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3344), 1,
      anon_sym_QMARK_QMARK,
    STATE(2693), 1,
      sym_type_arguments,
    ACTIONS(3085), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3330), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3338), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3346), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1746), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3312), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3332), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3320), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3342), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [52881] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2219), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3152), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(3155), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1607), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1111), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1113), 18,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [52942] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(697), 1,
      anon_sym_BQUOTE,
    ACTIONS(2201), 1,
      anon_sym_LPAREN,
    ACTIONS(2633), 1,
      anon_sym_LBRACK,
    ACTIONS(2651), 1,
      anon_sym_DOT,
    ACTIONS(3314), 1,
      anon_sym_as,
    ACTIONS(3318), 1,
      anon_sym_BANG,
    ACTIONS(3322), 1,
      anon_sym_LT,
    ACTIONS(3324), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3326), 1,
      anon_sym_QMARK,
    ACTIONS(3328), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3334), 1,
      anon_sym_AMP,
    ACTIONS(3336), 1,
      anon_sym_PIPE,
    ACTIONS(3340), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3344), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3447), 1,
      anon_sym_LBRACE,
    STATE(2693), 1,
      sym_type_arguments,
    ACTIONS(3172), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3330), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3338), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3346), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1746), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3312), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3332), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3320), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3342), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [53037] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(479), 1,
      anon_sym_BQUOTE,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2975), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3031), 1,
      anon_sym_as,
    ACTIONS(3035), 1,
      anon_sym_BANG,
    ACTIONS(3039), 1,
      anon_sym_LT,
    ACTIONS(3041), 1,
      anon_sym_QMARK,
    ACTIONS(3043), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3049), 1,
      anon_sym_AMP,
    ACTIONS(3051), 1,
      anon_sym_PIPE,
    ACTIONS(3055), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3059), 1,
      anon_sym_QMARK_QMARK,
    STATE(2727), 1,
      sym_type_arguments,
    ACTIONS(3045), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3053), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3061), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1171), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3029), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3047), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3449), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    ACTIONS(3037), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3057), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [53130] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(697), 1,
      anon_sym_BQUOTE,
    ACTIONS(2201), 1,
      anon_sym_LPAREN,
    ACTIONS(2633), 1,
      anon_sym_LBRACK,
    ACTIONS(2651), 1,
      anon_sym_DOT,
    ACTIONS(3314), 1,
      anon_sym_as,
    ACTIONS(3318), 1,
      anon_sym_BANG,
    ACTIONS(3322), 1,
      anon_sym_LT,
    ACTIONS(3324), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3326), 1,
      anon_sym_QMARK,
    ACTIONS(3328), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3334), 1,
      anon_sym_AMP,
    ACTIONS(3336), 1,
      anon_sym_PIPE,
    ACTIONS(3340), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3344), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3451), 1,
      anon_sym_LBRACE,
    STATE(2693), 1,
      sym_type_arguments,
    ACTIONS(3130), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3330), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3338), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3346), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1746), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3312), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3332), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3320), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3342), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [53225] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(697), 1,
      anon_sym_BQUOTE,
    ACTIONS(2201), 1,
      anon_sym_LPAREN,
    ACTIONS(2633), 1,
      anon_sym_LBRACK,
    ACTIONS(2651), 1,
      anon_sym_DOT,
    ACTIONS(3230), 1,
      anon_sym_LBRACE,
    ACTIONS(3314), 1,
      anon_sym_as,
    ACTIONS(3318), 1,
      anon_sym_BANG,
    ACTIONS(3322), 1,
      anon_sym_LT,
    ACTIONS(3324), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3326), 1,
      anon_sym_QMARK,
    ACTIONS(3328), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3334), 1,
      anon_sym_AMP,
    ACTIONS(3336), 1,
      anon_sym_PIPE,
    ACTIONS(3340), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3344), 1,
      anon_sym_QMARK_QMARK,
    STATE(2693), 1,
      sym_type_arguments,
    ACTIONS(3103), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3330), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3338), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3346), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1746), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3312), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3332), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3320), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3342), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [53320] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(697), 1,
      anon_sym_BQUOTE,
    ACTIONS(2201), 1,
      anon_sym_LPAREN,
    ACTIONS(2633), 1,
      anon_sym_LBRACK,
    ACTIONS(2651), 1,
      anon_sym_DOT,
    ACTIONS(3314), 1,
      anon_sym_as,
    ACTIONS(3318), 1,
      anon_sym_BANG,
    ACTIONS(3322), 1,
      anon_sym_LT,
    ACTIONS(3324), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3326), 1,
      anon_sym_QMARK,
    ACTIONS(3328), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3334), 1,
      anon_sym_AMP,
    ACTIONS(3336), 1,
      anon_sym_PIPE,
    ACTIONS(3340), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3344), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3408), 1,
      anon_sym_LBRACE,
    STATE(2693), 1,
      sym_type_arguments,
    ACTIONS(3109), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3330), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3338), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3346), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1746), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3312), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3332), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3320), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3342), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [53415] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(479), 1,
      anon_sym_BQUOTE,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2975), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3035), 1,
      anon_sym_BANG,
    ACTIONS(3402), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3453), 1,
      anon_sym_LT,
    STATE(2727), 1,
      sym_type_arguments,
    ACTIONS(3061), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1171), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3063), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3065), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_implements,
  [53486] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(697), 1,
      anon_sym_BQUOTE,
    ACTIONS(2201), 1,
      anon_sym_LPAREN,
    ACTIONS(2633), 1,
      anon_sym_LBRACK,
    ACTIONS(2651), 1,
      anon_sym_DOT,
    ACTIONS(3314), 1,
      anon_sym_as,
    ACTIONS(3318), 1,
      anon_sym_BANG,
    ACTIONS(3322), 1,
      anon_sym_LT,
    ACTIONS(3324), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3326), 1,
      anon_sym_QMARK,
    ACTIONS(3328), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3334), 1,
      anon_sym_AMP,
    ACTIONS(3336), 1,
      anon_sym_PIPE,
    ACTIONS(3340), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3344), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3456), 1,
      anon_sym_LBRACE,
    STATE(2693), 1,
      sym_type_arguments,
    ACTIONS(3132), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3330), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3338), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3346), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1746), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3312), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3332), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3320), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3342), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [53581] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(479), 1,
      anon_sym_BQUOTE,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2975), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3035), 1,
      anon_sym_BANG,
    ACTIONS(3386), 1,
      anon_sym_LT,
    ACTIONS(3402), 1,
      anon_sym_STAR_STAR,
    STATE(2727), 1,
      sym_type_arguments,
    ACTIONS(3061), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3400), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1171), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3382), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3394), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3063), 7,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3065), 13,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_implements,
  [53658] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(697), 1,
      anon_sym_BQUOTE,
    ACTIONS(2201), 1,
      anon_sym_LPAREN,
    ACTIONS(2633), 1,
      anon_sym_LBRACK,
    ACTIONS(2651), 1,
      anon_sym_DOT,
    ACTIONS(3318), 1,
      anon_sym_BANG,
    ACTIONS(3322), 1,
      anon_sym_LT,
    ACTIONS(3324), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3328), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3334), 1,
      anon_sym_AMP,
    ACTIONS(3336), 1,
      anon_sym_PIPE,
    ACTIONS(3340), 1,
      anon_sym_STAR_STAR,
    STATE(2693), 1,
      sym_type_arguments,
    ACTIONS(3063), 2,
      anon_sym_LBRACE,
      anon_sym_QMARK,
    ACTIONS(3330), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3338), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3346), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1746), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3312), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3332), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3065), 4,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3320), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3342), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [53747] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(697), 1,
      anon_sym_BQUOTE,
    ACTIONS(2201), 1,
      anon_sym_LPAREN,
    ACTIONS(2633), 1,
      anon_sym_LBRACK,
    ACTIONS(2651), 1,
      anon_sym_DOT,
    ACTIONS(3318), 1,
      anon_sym_BANG,
    ACTIONS(3324), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3458), 1,
      anon_sym_LT,
    STATE(2693), 1,
      sym_type_arguments,
    ACTIONS(3346), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1746), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3063), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3065), 16,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_LBRACE_PIPE,
  [53816] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2197), 1,
      anon_sym_LPAREN,
    ACTIONS(2199), 1,
      anon_sym_LT,
    ACTIONS(2313), 1,
      anon_sym_LBRACK,
    ACTIONS(2318), 1,
      anon_sym_DOT,
    ACTIONS(2322), 1,
      anon_sym_QMARK_DOT,
    STATE(1377), 1,
      sym_type_arguments,
    STATE(1513), 1,
      sym_arguments,
    ACTIONS(2209), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2213), 21,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [53879] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(697), 1,
      anon_sym_BQUOTE,
    ACTIONS(2201), 1,
      anon_sym_LPAREN,
    ACTIONS(2633), 1,
      anon_sym_LBRACK,
    ACTIONS(2651), 1,
      anon_sym_DOT,
    ACTIONS(3318), 1,
      anon_sym_BANG,
    ACTIONS(3322), 1,
      anon_sym_LT,
    ACTIONS(3324), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3328), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3334), 1,
      anon_sym_AMP,
    ACTIONS(3340), 1,
      anon_sym_STAR_STAR,
    STATE(2693), 1,
      sym_type_arguments,
    ACTIONS(3338), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3346), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1746), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3063), 3,
      anon_sym_LBRACE,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(3312), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3332), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3320), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3342), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3065), 6,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_LBRACE_PIPE,
  [53964] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(697), 1,
      anon_sym_BQUOTE,
    ACTIONS(2201), 1,
      anon_sym_LPAREN,
    ACTIONS(2633), 1,
      anon_sym_LBRACK,
    ACTIONS(2651), 1,
      anon_sym_DOT,
    ACTIONS(3318), 1,
      anon_sym_BANG,
    ACTIONS(3322), 1,
      anon_sym_LT,
    ACTIONS(3324), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3340), 1,
      anon_sym_STAR_STAR,
    STATE(2693), 1,
      sym_type_arguments,
    ACTIONS(3338), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3346), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1746), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3312), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3332), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3063), 4,
      anon_sym_LBRACE,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3320), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3342), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3065), 7,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_LBRACE_PIPE,
  [54045] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(479), 1,
      anon_sym_BQUOTE,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2975), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3031), 1,
      anon_sym_as,
    ACTIONS(3035), 1,
      anon_sym_BANG,
    ACTIONS(3386), 1,
      anon_sym_LT,
    ACTIONS(3388), 1,
      anon_sym_QMARK,
    ACTIONS(3390), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3396), 1,
      anon_sym_AMP,
    ACTIONS(3398), 1,
      anon_sym_PIPE,
    ACTIONS(3402), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3406), 1,
      anon_sym_QMARK_QMARK,
    STATE(2727), 1,
      sym_type_arguments,
    ACTIONS(3061), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3392), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3400), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1171), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3382), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3394), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3461), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(3384), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3404), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [54138] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2219), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1565), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1563), 6,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1111), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1113), 18,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [54197] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1065), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1063), 27,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [54246] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(479), 1,
      anon_sym_BQUOTE,
    ACTIONS(1147), 1,
      anon_sym_COMMA,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2975), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3031), 1,
      anon_sym_as,
    ACTIONS(3035), 1,
      anon_sym_BANG,
    ACTIONS(3039), 1,
      anon_sym_LT,
    ACTIONS(3041), 1,
      anon_sym_QMARK,
    ACTIONS(3043), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3049), 1,
      anon_sym_AMP,
    ACTIONS(3051), 1,
      anon_sym_PIPE,
    ACTIONS(3055), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3059), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3463), 1,
      anon_sym_RPAREN,
    STATE(2727), 1,
      sym_type_arguments,
    STATE(2758), 1,
      aux_sym_array_repeat1,
    ACTIONS(3045), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3053), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3061), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1171), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3029), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3047), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3037), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3057), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [54343] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(697), 1,
      anon_sym_BQUOTE,
    ACTIONS(2201), 1,
      anon_sym_LPAREN,
    ACTIONS(2633), 1,
      anon_sym_LBRACK,
    ACTIONS(2651), 1,
      anon_sym_DOT,
    ACTIONS(3314), 1,
      anon_sym_as,
    ACTIONS(3318), 1,
      anon_sym_BANG,
    ACTIONS(3322), 1,
      anon_sym_LT,
    ACTIONS(3324), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3326), 1,
      anon_sym_QMARK,
    ACTIONS(3328), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3334), 1,
      anon_sym_AMP,
    ACTIONS(3336), 1,
      anon_sym_PIPE,
    ACTIONS(3340), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3344), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3465), 1,
      anon_sym_LBRACE,
    STATE(2693), 1,
      sym_type_arguments,
    ACTIONS(3158), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3330), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3338), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3346), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1746), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3312), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3332), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3320), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3342), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [54438] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(697), 1,
      anon_sym_BQUOTE,
    ACTIONS(2201), 1,
      anon_sym_LPAREN,
    ACTIONS(2633), 1,
      anon_sym_LBRACK,
    ACTIONS(2651), 1,
      anon_sym_DOT,
    ACTIONS(3318), 1,
      anon_sym_BANG,
    ACTIONS(3324), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3467), 1,
      anon_sym_LT,
    STATE(2693), 1,
      sym_type_arguments,
    ACTIONS(3346), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1746), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3123), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3125), 16,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_LBRACE_PIPE,
  [54507] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(697), 1,
      anon_sym_BQUOTE,
    ACTIONS(2201), 1,
      anon_sym_LPAREN,
    ACTIONS(2633), 1,
      anon_sym_LBRACK,
    ACTIONS(2651), 1,
      anon_sym_DOT,
    ACTIONS(3318), 1,
      anon_sym_BANG,
    ACTIONS(3322), 1,
      anon_sym_LT,
    ACTIONS(3324), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3340), 1,
      anon_sym_STAR_STAR,
    STATE(2693), 1,
      sym_type_arguments,
    ACTIONS(3338), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3346), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1746), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3312), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3332), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3063), 8,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3065), 12,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_LBRACE_PIPE,
  [54584] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(697), 1,
      anon_sym_BQUOTE,
    ACTIONS(2201), 1,
      anon_sym_LPAREN,
    ACTIONS(2633), 1,
      anon_sym_LBRACK,
    ACTIONS(2651), 1,
      anon_sym_DOT,
    ACTIONS(3318), 1,
      anon_sym_BANG,
    ACTIONS(3324), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3340), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3458), 1,
      anon_sym_LT,
    STATE(2693), 1,
      sym_type_arguments,
    ACTIONS(3346), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1746), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3063), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3065), 15,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_LBRACE_PIPE,
  [54655] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3470), 1,
      anon_sym_DOT,
    STATE(1348), 1,
      sym_type_arguments,
    ACTIONS(1561), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1559), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [54708] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(697), 1,
      anon_sym_BQUOTE,
    ACTIONS(2201), 1,
      anon_sym_LPAREN,
    ACTIONS(2633), 1,
      anon_sym_LBRACK,
    ACTIONS(2651), 1,
      anon_sym_DOT,
    ACTIONS(3232), 1,
      anon_sym_LBRACE,
    ACTIONS(3314), 1,
      anon_sym_as,
    ACTIONS(3318), 1,
      anon_sym_BANG,
    ACTIONS(3322), 1,
      anon_sym_LT,
    ACTIONS(3324), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3326), 1,
      anon_sym_QMARK,
    ACTIONS(3328), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3334), 1,
      anon_sym_AMP,
    ACTIONS(3336), 1,
      anon_sym_PIPE,
    ACTIONS(3340), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3344), 1,
      anon_sym_QMARK_QMARK,
    STATE(2693), 1,
      sym_type_arguments,
    ACTIONS(3033), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3330), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3338), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3346), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1746), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3312), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3332), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3320), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3342), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [54803] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(479), 1,
      anon_sym_BQUOTE,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2975), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3031), 1,
      anon_sym_as,
    ACTIONS(3035), 1,
      anon_sym_BANG,
    ACTIONS(3039), 1,
      anon_sym_LT,
    ACTIONS(3041), 1,
      anon_sym_QMARK,
    ACTIONS(3043), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3049), 1,
      anon_sym_AMP,
    ACTIONS(3051), 1,
      anon_sym_PIPE,
    ACTIONS(3055), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3059), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3472), 1,
      anon_sym_COMMA,
    ACTIONS(3474), 1,
      anon_sym_RBRACK,
    STATE(2727), 1,
      sym_type_arguments,
    STATE(2809), 1,
      aux_sym_array_repeat1,
    ACTIONS(3045), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3053), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3061), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1171), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3029), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3047), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3037), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3057), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [54900] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3476), 1,
      anon_sym_LT,
    ACTIONS(3479), 1,
      anon_sym_DOT,
    STATE(1348), 1,
      sym_type_arguments,
    ACTIONS(1712), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1710), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [54955] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3479), 1,
      anon_sym_DOT,
    STATE(1348), 1,
      sym_type_arguments,
    ACTIONS(1723), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1721), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [55008] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2219), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3481), 1,
      anon_sym_EQ,
    ACTIONS(1111), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1113), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [55065] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1505), 1,
      sym_type_arguments,
    ACTIONS(1617), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1615), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [55116] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2219), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3483), 1,
      anon_sym_EQ,
    ACTIONS(1111), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1113), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [55173] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(697), 1,
      anon_sym_BQUOTE,
    ACTIONS(2201), 1,
      anon_sym_LPAREN,
    ACTIONS(2633), 1,
      anon_sym_LBRACK,
    ACTIONS(2651), 1,
      anon_sym_DOT,
    ACTIONS(3318), 1,
      anon_sym_BANG,
    ACTIONS(3324), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3340), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3458), 1,
      anon_sym_LT,
    STATE(2693), 1,
      sym_type_arguments,
    ACTIONS(3346), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1746), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3312), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3332), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3063), 10,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3065), 12,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_LBRACE_PIPE,
  [55248] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(479), 1,
      anon_sym_BQUOTE,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2975), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3031), 1,
      anon_sym_as,
    ACTIONS(3035), 1,
      anon_sym_BANG,
    ACTIONS(3386), 1,
      anon_sym_LT,
    ACTIONS(3388), 1,
      anon_sym_QMARK,
    ACTIONS(3390), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3396), 1,
      anon_sym_AMP,
    ACTIONS(3398), 1,
      anon_sym_PIPE,
    ACTIONS(3402), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3406), 1,
      anon_sym_QMARK_QMARK,
    STATE(2727), 1,
      sym_type_arguments,
    ACTIONS(3061), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3392), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3400), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1171), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3083), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(3382), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3394), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3384), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3404), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [55341] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1073), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1071), 27,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [55390] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(479), 1,
      anon_sym_BQUOTE,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2975), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3035), 1,
      anon_sym_BANG,
    ACTIONS(3063), 1,
      anon_sym_QMARK,
    ACTIONS(3386), 1,
      anon_sym_LT,
    ACTIONS(3390), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3396), 1,
      anon_sym_AMP,
    ACTIONS(3398), 1,
      anon_sym_PIPE,
    ACTIONS(3402), 1,
      anon_sym_STAR_STAR,
    STATE(2727), 1,
      sym_type_arguments,
    ACTIONS(3061), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3392), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3400), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1171), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3382), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3394), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3384), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3065), 5,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_implements,
    ACTIONS(3404), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [55479] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(697), 1,
      anon_sym_BQUOTE,
    ACTIONS(2201), 1,
      anon_sym_LPAREN,
    ACTIONS(2633), 1,
      anon_sym_LBRACK,
    ACTIONS(2651), 1,
      anon_sym_DOT,
    ACTIONS(3318), 1,
      anon_sym_BANG,
    ACTIONS(3324), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3467), 1,
      anon_sym_LT,
    STATE(2693), 1,
      sym_type_arguments,
    ACTIONS(3346), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1746), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3123), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3125), 16,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_LBRACE_PIPE,
  [55548] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1093), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1091), 27,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [55597] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3489), 1,
      sym_regex_flags,
    ACTIONS(3485), 16,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
    ACTIONS(3487), 24,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [55648] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3491), 1,
      anon_sym_LT,
    STATE(1505), 1,
      sym_type_arguments,
    ACTIONS(1752), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1750), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [55701] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(479), 1,
      anon_sym_BQUOTE,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2975), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3035), 1,
      anon_sym_BANG,
    ACTIONS(3442), 1,
      anon_sym_LT,
    STATE(2727), 1,
      sym_type_arguments,
    ACTIONS(3061), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1171), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3123), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3125), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_implements,
  [55770] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(949), 1,
      sym__automatic_semicolon,
    ACTIONS(941), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(945), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(947), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [55823] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(697), 1,
      anon_sym_BQUOTE,
    ACTIONS(2201), 1,
      anon_sym_LPAREN,
    ACTIONS(2633), 1,
      anon_sym_LBRACK,
    ACTIONS(2651), 1,
      anon_sym_DOT,
    ACTIONS(3314), 1,
      anon_sym_as,
    ACTIONS(3318), 1,
      anon_sym_BANG,
    ACTIONS(3322), 1,
      anon_sym_LT,
    ACTIONS(3324), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3326), 1,
      anon_sym_QMARK,
    ACTIONS(3328), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3334), 1,
      anon_sym_AMP,
    ACTIONS(3336), 1,
      anon_sym_PIPE,
    ACTIONS(3340), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3344), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3494), 1,
      anon_sym_LBRACE,
    STATE(2693), 1,
      sym_type_arguments,
    ACTIONS(3166), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3330), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3338), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3346), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1746), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3312), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3332), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3320), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3342), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [55918] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(2197), 1,
      anon_sym_LPAREN,
    ACTIONS(2313), 1,
      anon_sym_LBRACK,
    ACTIONS(2318), 1,
      anon_sym_DOT,
    ACTIONS(3184), 1,
      anon_sym_as,
    ACTIONS(3186), 1,
      anon_sym_BANG,
    ACTIONS(3190), 1,
      anon_sym_LT,
    ACTIONS(3192), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3194), 1,
      anon_sym_QMARK,
    ACTIONS(3196), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3202), 1,
      anon_sym_AMP,
    ACTIONS(3204), 1,
      anon_sym_PIPE,
    ACTIONS(3208), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3212), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3496), 1,
      anon_sym_COMMA,
    STATE(2746), 1,
      sym_type_arguments,
    ACTIONS(3113), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3198), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3206), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3214), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1606), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3182), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3200), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3188), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3210), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [56013] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(479), 1,
      anon_sym_BQUOTE,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2975), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3031), 1,
      anon_sym_as,
    ACTIONS(3035), 1,
      anon_sym_BANG,
    ACTIONS(3386), 1,
      anon_sym_LT,
    ACTIONS(3388), 1,
      anon_sym_QMARK,
    ACTIONS(3390), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3396), 1,
      anon_sym_AMP,
    ACTIONS(3398), 1,
      anon_sym_PIPE,
    ACTIONS(3402), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3406), 1,
      anon_sym_QMARK_QMARK,
    STATE(2727), 1,
      sym_type_arguments,
    ACTIONS(3061), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3392), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3400), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1171), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3168), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(3382), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3394), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3384), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3404), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [56106] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(479), 1,
      anon_sym_BQUOTE,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2975), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3031), 1,
      anon_sym_as,
    ACTIONS(3035), 1,
      anon_sym_BANG,
    ACTIONS(3039), 1,
      anon_sym_LT,
    ACTIONS(3041), 1,
      anon_sym_QMARK,
    ACTIONS(3043), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3049), 1,
      anon_sym_AMP,
    ACTIONS(3051), 1,
      anon_sym_PIPE,
    ACTIONS(3055), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3059), 1,
      anon_sym_QMARK_QMARK,
    STATE(2727), 1,
      sym_type_arguments,
    ACTIONS(3045), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3053), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3061), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1171), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3029), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3047), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3498), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
    ACTIONS(3037), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3057), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [56199] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(479), 1,
      anon_sym_BQUOTE,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2975), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3031), 1,
      anon_sym_as,
    ACTIONS(3035), 1,
      anon_sym_BANG,
    ACTIONS(3386), 1,
      anon_sym_LT,
    ACTIONS(3388), 1,
      anon_sym_QMARK,
    ACTIONS(3390), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3396), 1,
      anon_sym_AMP,
    ACTIONS(3398), 1,
      anon_sym_PIPE,
    ACTIONS(3402), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3406), 1,
      anon_sym_QMARK_QMARK,
    STATE(2727), 1,
      sym_type_arguments,
    ACTIONS(3061), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3392), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3400), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1171), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3121), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(3382), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3394), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3384), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3404), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [56292] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(697), 1,
      anon_sym_BQUOTE,
    ACTIONS(2201), 1,
      anon_sym_LPAREN,
    ACTIONS(2633), 1,
      anon_sym_LBRACK,
    ACTIONS(2651), 1,
      anon_sym_DOT,
    ACTIONS(3314), 1,
      anon_sym_as,
    ACTIONS(3318), 1,
      anon_sym_BANG,
    ACTIONS(3322), 1,
      anon_sym_LT,
    ACTIONS(3324), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3326), 1,
      anon_sym_QMARK,
    ACTIONS(3328), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3334), 1,
      anon_sym_AMP,
    ACTIONS(3336), 1,
      anon_sym_PIPE,
    ACTIONS(3340), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3344), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3500), 1,
      anon_sym_LBRACE,
    STATE(2693), 1,
      sym_type_arguments,
    ACTIONS(3121), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3330), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3338), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3346), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1746), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3312), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3332), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3320), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3342), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [56387] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(479), 1,
      anon_sym_BQUOTE,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2975), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3031), 1,
      anon_sym_as,
    ACTIONS(3035), 1,
      anon_sym_BANG,
    ACTIONS(3386), 1,
      anon_sym_LT,
    ACTIONS(3388), 1,
      anon_sym_QMARK,
    ACTIONS(3390), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3396), 1,
      anon_sym_AMP,
    ACTIONS(3398), 1,
      anon_sym_PIPE,
    ACTIONS(3402), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3406), 1,
      anon_sym_QMARK_QMARK,
    STATE(2727), 1,
      sym_type_arguments,
    ACTIONS(3061), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3392), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3400), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1171), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3132), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(3382), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3394), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3384), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3404), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [56480] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(479), 1,
      anon_sym_BQUOTE,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2975), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3031), 1,
      anon_sym_as,
    ACTIONS(3035), 1,
      anon_sym_BANG,
    ACTIONS(3386), 1,
      anon_sym_LT,
    ACTIONS(3388), 1,
      anon_sym_QMARK,
    ACTIONS(3390), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3396), 1,
      anon_sym_AMP,
    ACTIONS(3398), 1,
      anon_sym_PIPE,
    ACTIONS(3402), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3406), 1,
      anon_sym_QMARK_QMARK,
    STATE(2727), 1,
      sym_type_arguments,
    ACTIONS(3061), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3392), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3400), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1171), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3166), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(3382), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3394), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3384), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3404), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [56573] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(479), 1,
      anon_sym_BQUOTE,
    ACTIONS(1147), 1,
      anon_sym_COMMA,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2975), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3031), 1,
      anon_sym_as,
    ACTIONS(3035), 1,
      anon_sym_BANG,
    ACTIONS(3039), 1,
      anon_sym_LT,
    ACTIONS(3041), 1,
      anon_sym_QMARK,
    ACTIONS(3043), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3049), 1,
      anon_sym_AMP,
    ACTIONS(3051), 1,
      anon_sym_PIPE,
    ACTIONS(3055), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3059), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3502), 1,
      anon_sym_RPAREN,
    STATE(2727), 1,
      sym_type_arguments,
    STATE(2843), 1,
      aux_sym_array_repeat1,
    ACTIONS(3045), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3053), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3061), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1171), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3029), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3047), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3037), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3057), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [56670] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(479), 1,
      anon_sym_BQUOTE,
    ACTIONS(1147), 1,
      anon_sym_COMMA,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2975), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3031), 1,
      anon_sym_as,
    ACTIONS(3035), 1,
      anon_sym_BANG,
    ACTIONS(3039), 1,
      anon_sym_LT,
    ACTIONS(3041), 1,
      anon_sym_QMARK,
    ACTIONS(3043), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3049), 1,
      anon_sym_AMP,
    ACTIONS(3051), 1,
      anon_sym_PIPE,
    ACTIONS(3055), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3059), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3504), 1,
      anon_sym_RBRACK,
    STATE(2727), 1,
      sym_type_arguments,
    STATE(2783), 1,
      aux_sym_array_repeat1,
    ACTIONS(3045), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3053), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3061), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1171), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3029), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3047), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3037), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3057), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [56767] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(2197), 1,
      anon_sym_LPAREN,
    ACTIONS(2313), 1,
      anon_sym_LBRACK,
    ACTIONS(2318), 1,
      anon_sym_DOT,
    ACTIONS(3184), 1,
      anon_sym_as,
    ACTIONS(3186), 1,
      anon_sym_BANG,
    ACTIONS(3190), 1,
      anon_sym_LT,
    ACTIONS(3192), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3194), 1,
      anon_sym_QMARK,
    ACTIONS(3196), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3202), 1,
      anon_sym_AMP,
    ACTIONS(3204), 1,
      anon_sym_PIPE,
    ACTIONS(3208), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3212), 1,
      anon_sym_QMARK_QMARK,
    STATE(2746), 1,
      sym_type_arguments,
    ACTIONS(3198), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3206), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3214), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1606), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3182), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3200), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3498), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(3188), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3210), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [56860] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(479), 1,
      anon_sym_BQUOTE,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2975), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3031), 1,
      anon_sym_as,
    ACTIONS(3035), 1,
      anon_sym_BANG,
    ACTIONS(3386), 1,
      anon_sym_LT,
    ACTIONS(3388), 1,
      anon_sym_QMARK,
    ACTIONS(3390), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3396), 1,
      anon_sym_AMP,
    ACTIONS(3398), 1,
      anon_sym_PIPE,
    ACTIONS(3402), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3406), 1,
      anon_sym_QMARK_QMARK,
    STATE(2727), 1,
      sym_type_arguments,
    ACTIONS(3061), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3392), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3400), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1171), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3033), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(3382), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3394), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3384), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3404), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [56953] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3506), 1,
      sym__automatic_semicolon,
    ACTIONS(943), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(941), 26,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [57004] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(479), 1,
      anon_sym_BQUOTE,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2975), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3442), 1,
      anon_sym_LT,
    STATE(2727), 1,
      sym_type_arguments,
    ACTIONS(3061), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1171), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3123), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3125), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_implements,
  [57071] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(479), 1,
      anon_sym_BQUOTE,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2975), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3031), 1,
      anon_sym_as,
    ACTIONS(3035), 1,
      anon_sym_BANG,
    ACTIONS(3386), 1,
      anon_sym_LT,
    ACTIONS(3388), 1,
      anon_sym_QMARK,
    ACTIONS(3390), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3396), 1,
      anon_sym_AMP,
    ACTIONS(3398), 1,
      anon_sym_PIPE,
    ACTIONS(3402), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3406), 1,
      anon_sym_QMARK_QMARK,
    STATE(2727), 1,
      sym_type_arguments,
    ACTIONS(3061), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3392), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3400), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1171), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3085), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(3382), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3394), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3384), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3404), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [57164] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(479), 1,
      anon_sym_BQUOTE,
    ACTIONS(1147), 1,
      anon_sym_COMMA,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2975), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3031), 1,
      anon_sym_as,
    ACTIONS(3035), 1,
      anon_sym_BANG,
    ACTIONS(3039), 1,
      anon_sym_LT,
    ACTIONS(3041), 1,
      anon_sym_QMARK,
    ACTIONS(3043), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3049), 1,
      anon_sym_AMP,
    ACTIONS(3051), 1,
      anon_sym_PIPE,
    ACTIONS(3055), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3059), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3508), 1,
      anon_sym_RBRACK,
    STATE(2727), 1,
      sym_type_arguments,
    STATE(2783), 1,
      aux_sym_array_repeat1,
    ACTIONS(3045), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3053), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3061), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1171), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3029), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3047), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3037), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3057), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [57261] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(479), 1,
      anon_sym_BQUOTE,
    ACTIONS(1147), 1,
      anon_sym_COMMA,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2975), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3031), 1,
      anon_sym_as,
    ACTIONS(3035), 1,
      anon_sym_BANG,
    ACTIONS(3039), 1,
      anon_sym_LT,
    ACTIONS(3041), 1,
      anon_sym_QMARK,
    ACTIONS(3043), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3049), 1,
      anon_sym_AMP,
    ACTIONS(3051), 1,
      anon_sym_PIPE,
    ACTIONS(3055), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3059), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3510), 1,
      anon_sym_RBRACK,
    STATE(2727), 1,
      sym_type_arguments,
    STATE(2838), 1,
      aux_sym_array_repeat1,
    ACTIONS(3045), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3053), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3061), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1171), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3029), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3047), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3037), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3057), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [57358] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(479), 1,
      anon_sym_BQUOTE,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2975), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3031), 1,
      anon_sym_as,
    ACTIONS(3035), 1,
      anon_sym_BANG,
    ACTIONS(3386), 1,
      anon_sym_LT,
    ACTIONS(3388), 1,
      anon_sym_QMARK,
    ACTIONS(3390), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3396), 1,
      anon_sym_AMP,
    ACTIONS(3398), 1,
      anon_sym_PIPE,
    ACTIONS(3402), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3406), 1,
      anon_sym_QMARK_QMARK,
    STATE(2727), 1,
      sym_type_arguments,
    ACTIONS(3061), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3392), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3400), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1171), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3103), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(3382), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3394), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3384), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3404), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [57451] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2219), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3160), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(3163), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1750), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1111), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1113), 18,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [57512] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1513), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(1515), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(945), 12,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(947), 23,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [57565] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(2197), 1,
      anon_sym_LPAREN,
    ACTIONS(2313), 1,
      anon_sym_LBRACK,
    ACTIONS(2318), 1,
      anon_sym_DOT,
    ACTIONS(3184), 1,
      anon_sym_as,
    ACTIONS(3186), 1,
      anon_sym_BANG,
    ACTIONS(3190), 1,
      anon_sym_LT,
    ACTIONS(3192), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3194), 1,
      anon_sym_QMARK,
    ACTIONS(3196), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3202), 1,
      anon_sym_AMP,
    ACTIONS(3204), 1,
      anon_sym_PIPE,
    ACTIONS(3208), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3212), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3496), 1,
      anon_sym_COMMA,
    STATE(2746), 1,
      sym_type_arguments,
    ACTIONS(3198), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3206), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3214), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3512), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(1606), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3182), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3200), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3188), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3210), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [57660] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(981), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(979), 27,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [57709] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(697), 1,
      anon_sym_BQUOTE,
    ACTIONS(2201), 1,
      anon_sym_LPAREN,
    ACTIONS(2633), 1,
      anon_sym_LBRACK,
    ACTIONS(2651), 1,
      anon_sym_DOT,
    ACTIONS(3257), 1,
      anon_sym_LBRACE,
    ACTIONS(3314), 1,
      anon_sym_as,
    ACTIONS(3318), 1,
      anon_sym_BANG,
    ACTIONS(3322), 1,
      anon_sym_LT,
    ACTIONS(3324), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3326), 1,
      anon_sym_QMARK,
    ACTIONS(3328), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3334), 1,
      anon_sym_AMP,
    ACTIONS(3336), 1,
      anon_sym_PIPE,
    ACTIONS(3340), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3344), 1,
      anon_sym_QMARK_QMARK,
    STATE(2693), 1,
      sym_type_arguments,
    ACTIONS(3176), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3330), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3338), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3346), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1746), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3312), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3332), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3320), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3342), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [57804] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(697), 1,
      anon_sym_BQUOTE,
    ACTIONS(2201), 1,
      anon_sym_LPAREN,
    ACTIONS(2633), 1,
      anon_sym_LBRACK,
    ACTIONS(2651), 1,
      anon_sym_DOT,
    ACTIONS(3314), 1,
      anon_sym_as,
    ACTIONS(3318), 1,
      anon_sym_BANG,
    ACTIONS(3322), 1,
      anon_sym_LT,
    ACTIONS(3324), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3326), 1,
      anon_sym_QMARK,
    ACTIONS(3328), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3334), 1,
      anon_sym_AMP,
    ACTIONS(3336), 1,
      anon_sym_PIPE,
    ACTIONS(3340), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3344), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3514), 1,
      anon_sym_LBRACE,
    STATE(2693), 1,
      sym_type_arguments,
    ACTIONS(3330), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3338), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3346), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3461), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    STATE(1746), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3312), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3332), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3320), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3342), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [57899] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(697), 1,
      anon_sym_BQUOTE,
    ACTIONS(2201), 1,
      anon_sym_LPAREN,
    ACTIONS(2633), 1,
      anon_sym_LBRACK,
    ACTIONS(2651), 1,
      anon_sym_DOT,
    ACTIONS(3314), 1,
      anon_sym_as,
    ACTIONS(3318), 1,
      anon_sym_BANG,
    ACTIONS(3322), 1,
      anon_sym_LT,
    ACTIONS(3324), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3326), 1,
      anon_sym_QMARK,
    ACTIONS(3328), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3334), 1,
      anon_sym_AMP,
    ACTIONS(3336), 1,
      anon_sym_PIPE,
    ACTIONS(3340), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3344), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3516), 1,
      anon_sym_LBRACE,
    STATE(2693), 1,
      sym_type_arguments,
    ACTIONS(3174), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3330), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3338), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3346), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1746), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3312), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3332), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3320), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3342), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [57994] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(479), 1,
      anon_sym_BQUOTE,
    ACTIONS(1147), 1,
      anon_sym_COMMA,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2975), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3031), 1,
      anon_sym_as,
    ACTIONS(3035), 1,
      anon_sym_BANG,
    ACTIONS(3039), 1,
      anon_sym_LT,
    ACTIONS(3041), 1,
      anon_sym_QMARK,
    ACTIONS(3043), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3049), 1,
      anon_sym_AMP,
    ACTIONS(3051), 1,
      anon_sym_PIPE,
    ACTIONS(3055), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3059), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3518), 1,
      anon_sym_RBRACK,
    STATE(2727), 1,
      sym_type_arguments,
    STATE(2871), 1,
      aux_sym_array_repeat1,
    ACTIONS(3045), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3053), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3061), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1171), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3029), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3047), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3037), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3057), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [58091] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(479), 1,
      anon_sym_BQUOTE,
    ACTIONS(1147), 1,
      anon_sym_COMMA,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2975), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3031), 1,
      anon_sym_as,
    ACTIONS(3035), 1,
      anon_sym_BANG,
    ACTIONS(3039), 1,
      anon_sym_LT,
    ACTIONS(3041), 1,
      anon_sym_QMARK,
    ACTIONS(3043), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3049), 1,
      anon_sym_AMP,
    ACTIONS(3051), 1,
      anon_sym_PIPE,
    ACTIONS(3055), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3059), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3520), 1,
      anon_sym_RPAREN,
    STATE(2727), 1,
      sym_type_arguments,
    STATE(2755), 1,
      aux_sym_array_repeat1,
    ACTIONS(3045), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3053), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3061), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1171), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3029), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3047), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3037), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3057), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [58188] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(2197), 1,
      anon_sym_LPAREN,
    ACTIONS(2313), 1,
      anon_sym_LBRACK,
    ACTIONS(2318), 1,
      anon_sym_DOT,
    ACTIONS(3184), 1,
      anon_sym_as,
    ACTIONS(3186), 1,
      anon_sym_BANG,
    ACTIONS(3190), 1,
      anon_sym_LT,
    ACTIONS(3192), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3194), 1,
      anon_sym_QMARK,
    ACTIONS(3196), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3202), 1,
      anon_sym_AMP,
    ACTIONS(3204), 1,
      anon_sym_PIPE,
    ACTIONS(3208), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3212), 1,
      anon_sym_QMARK_QMARK,
    STATE(2746), 1,
      sym_type_arguments,
    ACTIONS(3198), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3206), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3214), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1606), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3182), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3200), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3498), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(3188), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3210), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [58281] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1535), 1,
      anon_sym_extends,
    ACTIONS(3023), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3026), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2985), 12,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2987), 23,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [58336] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(2197), 1,
      anon_sym_LPAREN,
    ACTIONS(2313), 1,
      anon_sym_LBRACK,
    ACTIONS(2318), 1,
      anon_sym_DOT,
    ACTIONS(3184), 1,
      anon_sym_as,
    ACTIONS(3186), 1,
      anon_sym_BANG,
    ACTIONS(3190), 1,
      anon_sym_LT,
    ACTIONS(3192), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3194), 1,
      anon_sym_QMARK,
    ACTIONS(3196), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3202), 1,
      anon_sym_AMP,
    ACTIONS(3204), 1,
      anon_sym_PIPE,
    ACTIONS(3208), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3212), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3496), 1,
      anon_sym_COMMA,
    STATE(2746), 1,
      sym_type_arguments,
    ACTIONS(3198), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3206), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3214), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3522), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(1606), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3182), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3200), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3188), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3210), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [58431] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2693), 1,
      sym_type_arguments,
    STATE(1746), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2981), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2983), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [58484] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(2197), 1,
      anon_sym_LPAREN,
    ACTIONS(2313), 1,
      anon_sym_LBRACK,
    ACTIONS(2318), 1,
      anon_sym_DOT,
    ACTIONS(3184), 1,
      anon_sym_as,
    ACTIONS(3186), 1,
      anon_sym_BANG,
    ACTIONS(3190), 1,
      anon_sym_LT,
    ACTIONS(3192), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3194), 1,
      anon_sym_QMARK,
    ACTIONS(3196), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3202), 1,
      anon_sym_AMP,
    ACTIONS(3204), 1,
      anon_sym_PIPE,
    ACTIONS(3208), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3212), 1,
      anon_sym_QMARK_QMARK,
    STATE(2746), 1,
      sym_type_arguments,
    ACTIONS(3198), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3206), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3214), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1606), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3182), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3200), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3498), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(3188), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3210), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [58577] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(2197), 1,
      anon_sym_LPAREN,
    ACTIONS(2313), 1,
      anon_sym_LBRACK,
    ACTIONS(2318), 1,
      anon_sym_DOT,
    ACTIONS(3184), 1,
      anon_sym_as,
    ACTIONS(3186), 1,
      anon_sym_BANG,
    ACTIONS(3190), 1,
      anon_sym_LT,
    ACTIONS(3192), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3194), 1,
      anon_sym_QMARK,
    ACTIONS(3196), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3202), 1,
      anon_sym_AMP,
    ACTIONS(3204), 1,
      anon_sym_PIPE,
    ACTIONS(3208), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3212), 1,
      anon_sym_QMARK_QMARK,
    STATE(2746), 1,
      sym_type_arguments,
    ACTIONS(3198), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3206), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3214), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1606), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3182), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3200), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3498), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(3188), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3210), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [58670] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(479), 1,
      anon_sym_BQUOTE,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2975), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3031), 1,
      anon_sym_as,
    ACTIONS(3035), 1,
      anon_sym_BANG,
    ACTIONS(3039), 1,
      anon_sym_LT,
    ACTIONS(3041), 1,
      anon_sym_QMARK,
    ACTIONS(3043), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3049), 1,
      anon_sym_AMP,
    ACTIONS(3051), 1,
      anon_sym_PIPE,
    ACTIONS(3055), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3059), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3472), 1,
      anon_sym_COMMA,
    ACTIONS(3524), 1,
      anon_sym_RBRACK,
    STATE(2727), 1,
      sym_type_arguments,
    STATE(2809), 1,
      aux_sym_array_repeat1,
    ACTIONS(3045), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3053), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3061), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1171), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3029), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3047), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3037), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3057), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [58767] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(479), 1,
      anon_sym_BQUOTE,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2975), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3035), 1,
      anon_sym_BANG,
    ACTIONS(3453), 1,
      anon_sym_LT,
    STATE(2727), 1,
      sym_type_arguments,
    ACTIONS(3061), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1171), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3063), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3065), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_implements,
  [58836] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(479), 1,
      anon_sym_BQUOTE,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2975), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3031), 1,
      anon_sym_as,
    ACTIONS(3035), 1,
      anon_sym_BANG,
    ACTIONS(3386), 1,
      anon_sym_LT,
    ACTIONS(3388), 1,
      anon_sym_QMARK,
    ACTIONS(3390), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3396), 1,
      anon_sym_AMP,
    ACTIONS(3398), 1,
      anon_sym_PIPE,
    ACTIONS(3402), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3406), 1,
      anon_sym_QMARK_QMARK,
    STATE(2727), 1,
      sym_type_arguments,
    ACTIONS(3061), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3392), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3400), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1171), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3109), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(3382), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3394), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3384), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3404), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [58929] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(697), 1,
      anon_sym_BQUOTE,
    ACTIONS(2201), 1,
      anon_sym_LPAREN,
    ACTIONS(2633), 1,
      anon_sym_LBRACK,
    ACTIONS(2651), 1,
      anon_sym_DOT,
    ACTIONS(3314), 1,
      anon_sym_as,
    ACTIONS(3318), 1,
      anon_sym_BANG,
    ACTIONS(3322), 1,
      anon_sym_LT,
    ACTIONS(3324), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3326), 1,
      anon_sym_QMARK,
    ACTIONS(3328), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3334), 1,
      anon_sym_AMP,
    ACTIONS(3336), 1,
      anon_sym_PIPE,
    ACTIONS(3340), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3344), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3526), 1,
      anon_sym_LBRACE,
    STATE(2693), 1,
      sym_type_arguments,
    ACTIONS(3083), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3330), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3338), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3346), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1746), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3312), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3332), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3320), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3342), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [59024] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(479), 1,
      anon_sym_BQUOTE,
    ACTIONS(1147), 1,
      anon_sym_COMMA,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2975), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3031), 1,
      anon_sym_as,
    ACTIONS(3035), 1,
      anon_sym_BANG,
    ACTIONS(3039), 1,
      anon_sym_LT,
    ACTIONS(3041), 1,
      anon_sym_QMARK,
    ACTIONS(3043), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3049), 1,
      anon_sym_AMP,
    ACTIONS(3051), 1,
      anon_sym_PIPE,
    ACTIONS(3055), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3059), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3528), 1,
      anon_sym_RBRACK,
    STATE(2727), 1,
      sym_type_arguments,
    STATE(2809), 1,
      aux_sym_array_repeat1,
    ACTIONS(3045), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3053), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3061), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1171), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3029), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3047), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3037), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3057), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [59121] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(479), 1,
      anon_sym_BQUOTE,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2975), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3035), 1,
      anon_sym_BANG,
    ACTIONS(3386), 1,
      anon_sym_LT,
    ACTIONS(3402), 1,
      anon_sym_STAR_STAR,
    STATE(2727), 1,
      sym_type_arguments,
    ACTIONS(3061), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3400), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1171), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3063), 3,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3382), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3394), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3384), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3404), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3065), 8,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_implements,
  [59202] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2633), 1,
      anon_sym_LBRACK,
    ACTIONS(2651), 1,
      anon_sym_DOT,
    ACTIONS(3324), 1,
      anon_sym_QMARK_DOT,
    STATE(2693), 1,
      sym_type_arguments,
    STATE(1746), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2971), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2973), 20,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [59261] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(479), 1,
      anon_sym_BQUOTE,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2975), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3031), 1,
      anon_sym_as,
    ACTIONS(3035), 1,
      anon_sym_BANG,
    ACTIONS(3386), 1,
      anon_sym_LT,
    ACTIONS(3388), 1,
      anon_sym_QMARK,
    ACTIONS(3390), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3396), 1,
      anon_sym_AMP,
    ACTIONS(3398), 1,
      anon_sym_PIPE,
    ACTIONS(3402), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3406), 1,
      anon_sym_QMARK_QMARK,
    STATE(2727), 1,
      sym_type_arguments,
    ACTIONS(3061), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3392), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3400), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1171), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3174), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(3382), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3394), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3384), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3404), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [59354] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(697), 1,
      anon_sym_BQUOTE,
    ACTIONS(2201), 1,
      anon_sym_LPAREN,
    ACTIONS(2633), 1,
      anon_sym_LBRACK,
    ACTIONS(2651), 1,
      anon_sym_DOT,
    ACTIONS(3324), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3467), 1,
      anon_sym_LT,
    STATE(2693), 1,
      sym_type_arguments,
    ACTIONS(3346), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1746), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3123), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3125), 16,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_LBRACE_PIPE,
  [59421] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(479), 1,
      anon_sym_BQUOTE,
    ACTIONS(1147), 1,
      anon_sym_COMMA,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2975), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3031), 1,
      anon_sym_as,
    ACTIONS(3035), 1,
      anon_sym_BANG,
    ACTIONS(3039), 1,
      anon_sym_LT,
    ACTIONS(3041), 1,
      anon_sym_QMARK,
    ACTIONS(3043), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3049), 1,
      anon_sym_AMP,
    ACTIONS(3051), 1,
      anon_sym_PIPE,
    ACTIONS(3055), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3059), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3530), 1,
      anon_sym_RBRACK,
    STATE(2727), 1,
      sym_type_arguments,
    STATE(2809), 1,
      aux_sym_array_repeat1,
    ACTIONS(3045), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3053), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3061), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1171), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3029), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3047), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3037), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3057), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [59518] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(479), 1,
      anon_sym_BQUOTE,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2975), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3031), 1,
      anon_sym_as,
    ACTIONS(3035), 1,
      anon_sym_BANG,
    ACTIONS(3386), 1,
      anon_sym_LT,
    ACTIONS(3388), 1,
      anon_sym_QMARK,
    ACTIONS(3390), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3396), 1,
      anon_sym_AMP,
    ACTIONS(3398), 1,
      anon_sym_PIPE,
    ACTIONS(3402), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3406), 1,
      anon_sym_QMARK_QMARK,
    STATE(2727), 1,
      sym_type_arguments,
    ACTIONS(3061), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3392), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3400), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1171), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3176), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(3382), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3394), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3384), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3404), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [59611] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(479), 1,
      anon_sym_BQUOTE,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2975), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3035), 1,
      anon_sym_BANG,
    ACTIONS(3386), 1,
      anon_sym_LT,
    ACTIONS(3390), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3396), 1,
      anon_sym_AMP,
    ACTIONS(3402), 1,
      anon_sym_STAR_STAR,
    STATE(2727), 1,
      sym_type_arguments,
    ACTIONS(3061), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3063), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(3400), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1171), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3382), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3394), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3384), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3404), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3065), 7,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_implements,
  [59696] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2201), 1,
      anon_sym_LPAREN,
    ACTIONS(2203), 1,
      anon_sym_LT,
    ACTIONS(2633), 1,
      anon_sym_LBRACK,
    ACTIONS(2639), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2651), 1,
      anon_sym_DOT,
    ACTIONS(2979), 1,
      anon_sym_EQ,
    STATE(1667), 1,
      sym_type_arguments,
    STATE(1677), 1,
      sym_arguments,
    ACTIONS(2209), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2213), 19,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [59761] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1051), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1049), 27,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [59810] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3532), 1,
      sym__automatic_semicolon,
    ACTIONS(1051), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1049), 26,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [59861] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2201), 1,
      anon_sym_LPAREN,
    ACTIONS(2203), 1,
      anon_sym_LT,
    ACTIONS(2633), 1,
      anon_sym_LBRACK,
    ACTIONS(2639), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2651), 1,
      anon_sym_DOT,
    ACTIONS(2977), 1,
      anon_sym_EQ,
    STATE(1667), 1,
      sym_type_arguments,
    STATE(1677), 1,
      sym_arguments,
    ACTIONS(2209), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2213), 19,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [59926] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(479), 1,
      anon_sym_BQUOTE,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2975), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3035), 1,
      anon_sym_BANG,
    ACTIONS(3402), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3453), 1,
      anon_sym_LT,
    STATE(2727), 1,
      sym_type_arguments,
    ACTIONS(3061), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1171), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3382), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3394), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3063), 9,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3065), 13,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_implements,
  [60001] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(479), 1,
      anon_sym_BQUOTE,
    ACTIONS(1147), 1,
      anon_sym_COMMA,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2975), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3031), 1,
      anon_sym_as,
    ACTIONS(3035), 1,
      anon_sym_BANG,
    ACTIONS(3039), 1,
      anon_sym_LT,
    ACTIONS(3041), 1,
      anon_sym_QMARK,
    ACTIONS(3043), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3049), 1,
      anon_sym_AMP,
    ACTIONS(3051), 1,
      anon_sym_PIPE,
    ACTIONS(3055), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3059), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3534), 1,
      anon_sym_RPAREN,
    STATE(2727), 1,
      sym_type_arguments,
    STATE(2835), 1,
      aux_sym_array_repeat1,
    ACTIONS(3045), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3053), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3061), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1171), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3029), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3047), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3037), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3057), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [60098] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(2197), 1,
      anon_sym_LPAREN,
    ACTIONS(2313), 1,
      anon_sym_LBRACK,
    ACTIONS(2318), 1,
      anon_sym_DOT,
    ACTIONS(3184), 1,
      anon_sym_as,
    ACTIONS(3186), 1,
      anon_sym_BANG,
    ACTIONS(3190), 1,
      anon_sym_LT,
    ACTIONS(3192), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3194), 1,
      anon_sym_QMARK,
    ACTIONS(3196), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3202), 1,
      anon_sym_AMP,
    ACTIONS(3204), 1,
      anon_sym_PIPE,
    ACTIONS(3208), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3212), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3496), 1,
      anon_sym_COMMA,
    STATE(2746), 1,
      sym_type_arguments,
    ACTIONS(3198), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3206), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3214), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3536), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(1606), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3182), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3200), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3188), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3210), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [60193] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(977), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(975), 27,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [60242] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3023), 1,
      anon_sym_LBRACK,
    ACTIONS(1535), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(3026), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2985), 12,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2987), 22,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [60296] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1491), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1489), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [60344] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1535), 1,
      anon_sym_extends,
    ACTIONS(3023), 2,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
    ACTIONS(3026), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2985), 13,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2987), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [60398] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1515), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1513), 3,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(945), 13,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(947), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [60450] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2201), 1,
      anon_sym_LPAREN,
    ACTIONS(2203), 1,
      anon_sym_LT,
    ACTIONS(2633), 1,
      anon_sym_LBRACK,
    ACTIONS(2639), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2651), 1,
      anon_sym_DOT,
    STATE(1667), 1,
      sym_type_arguments,
    STATE(1677), 1,
      sym_arguments,
    ACTIONS(2209), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2213), 19,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [60512] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(479), 1,
      anon_sym_BQUOTE,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2975), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3031), 1,
      anon_sym_as,
    ACTIONS(3035), 1,
      anon_sym_BANG,
    ACTIONS(3039), 1,
      anon_sym_LT,
    ACTIONS(3041), 1,
      anon_sym_QMARK,
    ACTIONS(3043), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3049), 1,
      anon_sym_AMP,
    ACTIONS(3051), 1,
      anon_sym_PIPE,
    ACTIONS(3055), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3059), 1,
      anon_sym_QMARK_QMARK,
    STATE(2727), 1,
      sym_type_arguments,
    ACTIONS(3045), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3053), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3061), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3538), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(1171), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3029), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3047), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3037), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3057), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [60604] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(479), 1,
      anon_sym_BQUOTE,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2975), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3031), 1,
      anon_sym_as,
    ACTIONS(3035), 1,
      anon_sym_BANG,
    ACTIONS(3039), 1,
      anon_sym_LT,
    ACTIONS(3041), 1,
      anon_sym_QMARK,
    ACTIONS(3043), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3049), 1,
      anon_sym_AMP,
    ACTIONS(3051), 1,
      anon_sym_PIPE,
    ACTIONS(3055), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3059), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3111), 1,
      anon_sym_COMMA,
    ACTIONS(3540), 1,
      anon_sym_RBRACK,
    STATE(2727), 1,
      sym_type_arguments,
    ACTIONS(3045), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3053), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3061), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1171), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3029), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3047), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3037), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3057), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [60698] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(945), 1,
      anon_sym_EQ,
    ACTIONS(3506), 1,
      sym__automatic_semicolon,
    ACTIONS(943), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(941), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [60750] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3542), 1,
      anon_sym_LPAREN,
    ACTIONS(3545), 1,
      anon_sym_COLON,
    ACTIONS(3547), 2,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(3009), 13,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2840), 23,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [60804] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(479), 1,
      anon_sym_BQUOTE,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2975), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3031), 1,
      anon_sym_as,
    ACTIONS(3035), 1,
      anon_sym_BANG,
    ACTIONS(3039), 1,
      anon_sym_LT,
    ACTIONS(3041), 1,
      anon_sym_QMARK,
    ACTIONS(3043), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3049), 1,
      anon_sym_AMP,
    ACTIONS(3051), 1,
      anon_sym_PIPE,
    ACTIONS(3055), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3059), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3111), 1,
      anon_sym_COMMA,
    ACTIONS(3550), 1,
      anon_sym_RBRACK,
    STATE(2727), 1,
      sym_type_arguments,
    ACTIONS(3045), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3053), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3061), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1171), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3029), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3047), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3037), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3057), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [60898] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1535), 1,
      anon_sym_extends,
    ACTIONS(3023), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3026), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2985), 13,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2987), 21,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [60952] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(2197), 1,
      anon_sym_LPAREN,
    ACTIONS(2313), 1,
      anon_sym_LBRACK,
    ACTIONS(2318), 1,
      anon_sym_DOT,
    ACTIONS(3186), 1,
      anon_sym_BANG,
    ACTIONS(3192), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3552), 1,
      anon_sym_LT,
    STATE(2746), 1,
      sym_type_arguments,
    ACTIONS(3214), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1606), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3123), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3125), 16,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [61020] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(2197), 1,
      anon_sym_LPAREN,
    ACTIONS(2313), 1,
      anon_sym_LBRACK,
    ACTIONS(2318), 1,
      anon_sym_DOT,
    ACTIONS(3186), 1,
      anon_sym_BANG,
    ACTIONS(3192), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3552), 1,
      anon_sym_LT,
    STATE(2746), 1,
      sym_type_arguments,
    ACTIONS(3214), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1606), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3123), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3125), 16,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [61088] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(2197), 1,
      anon_sym_LPAREN,
    ACTIONS(2313), 1,
      anon_sym_LBRACK,
    ACTIONS(2318), 1,
      anon_sym_DOT,
    ACTIONS(3184), 1,
      anon_sym_as,
    ACTIONS(3186), 1,
      anon_sym_BANG,
    ACTIONS(3192), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3559), 1,
      anon_sym_LT,
    ACTIONS(3561), 1,
      anon_sym_QMARK,
    ACTIONS(3563), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3569), 1,
      anon_sym_AMP,
    ACTIONS(3571), 1,
      anon_sym_PIPE,
    ACTIONS(3575), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3579), 1,
      anon_sym_QMARK_QMARK,
    STATE(2746), 1,
      sym_type_arguments,
    ACTIONS(3130), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3214), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3565), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3573), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1606), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3555), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3567), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3557), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3577), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [61180] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(2197), 1,
      anon_sym_LPAREN,
    ACTIONS(2313), 1,
      anon_sym_LBRACK,
    ACTIONS(2318), 1,
      anon_sym_DOT,
    ACTIONS(3184), 1,
      anon_sym_as,
    ACTIONS(3186), 1,
      anon_sym_BANG,
    ACTIONS(3192), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3559), 1,
      anon_sym_LT,
    ACTIONS(3561), 1,
      anon_sym_QMARK,
    ACTIONS(3563), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3569), 1,
      anon_sym_AMP,
    ACTIONS(3571), 1,
      anon_sym_PIPE,
    ACTIONS(3575), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3579), 1,
      anon_sym_QMARK_QMARK,
    STATE(2746), 1,
      sym_type_arguments,
    ACTIONS(3132), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3214), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3565), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3573), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1606), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3555), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3567), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3557), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3577), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [61272] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(2197), 1,
      anon_sym_LPAREN,
    ACTIONS(2313), 1,
      anon_sym_LBRACK,
    ACTIONS(2318), 1,
      anon_sym_DOT,
    ACTIONS(3192), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3552), 1,
      anon_sym_LT,
    STATE(2746), 1,
      sym_type_arguments,
    ACTIONS(3214), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1606), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3123), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3125), 16,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [61338] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3581), 1,
      anon_sym_AMP,
    ACTIONS(3583), 1,
      anon_sym_PIPE,
    ACTIONS(1780), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1778), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [61390] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1569), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1567), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [61438] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1750), 1,
      anon_sym_extends,
    ACTIONS(2313), 1,
      anon_sym_LBRACK,
    ACTIONS(2318), 1,
      anon_sym_DOT,
    ACTIONS(2322), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3160), 1,
      anon_sym_COMMA,
    ACTIONS(3163), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1111), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1113), 21,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [61498] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1607), 1,
      anon_sym_extends,
    ACTIONS(2313), 1,
      anon_sym_LBRACK,
    ACTIONS(2318), 1,
      anon_sym_DOT,
    ACTIONS(2322), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3152), 1,
      anon_sym_COMMA,
    ACTIONS(3155), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1111), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1113), 21,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [61558] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2313), 1,
      anon_sym_LBRACK,
    ACTIONS(2318), 1,
      anon_sym_DOT,
    ACTIONS(2322), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3585), 1,
      anon_sym_EQ,
    ACTIONS(1111), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1113), 22,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [61614] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1105), 1,
      sym__automatic_semicolon,
    ACTIONS(1097), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1101), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1103), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [61666] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2313), 1,
      anon_sym_LBRACK,
    ACTIONS(2318), 1,
      anon_sym_DOT,
    ACTIONS(2322), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3587), 1,
      anon_sym_EQ,
    ACTIONS(1111), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1113), 22,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [61722] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1513), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(1515), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(945), 13,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(947), 21,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [61774] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3581), 1,
      anon_sym_AMP,
    ACTIONS(3583), 1,
      anon_sym_PIPE,
    ACTIONS(3589), 1,
      anon_sym_extends,
    ACTIONS(3070), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3072), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [61828] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1123), 1,
      sym__automatic_semicolon,
    ACTIONS(1115), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1119), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1121), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [61880] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1601), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1599), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [61928] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1585), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1583), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [61976] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(479), 1,
      anon_sym_BQUOTE,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2975), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3031), 1,
      anon_sym_as,
    ACTIONS(3035), 1,
      anon_sym_BANG,
    ACTIONS(3039), 1,
      anon_sym_LT,
    ACTIONS(3041), 1,
      anon_sym_QMARK,
    ACTIONS(3043), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3049), 1,
      anon_sym_AMP,
    ACTIONS(3051), 1,
      anon_sym_PIPE,
    ACTIONS(3055), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3059), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3111), 1,
      anon_sym_COMMA,
    ACTIONS(3591), 1,
      anon_sym_RBRACK,
    STATE(2727), 1,
      sym_type_arguments,
    ACTIONS(3045), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3053), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3061), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1171), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3029), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3047), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3037), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3057), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [62070] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(479), 1,
      anon_sym_BQUOTE,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2975), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3031), 1,
      anon_sym_as,
    ACTIONS(3035), 1,
      anon_sym_BANG,
    ACTIONS(3039), 1,
      anon_sym_LT,
    ACTIONS(3041), 1,
      anon_sym_QMARK,
    ACTIONS(3043), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3049), 1,
      anon_sym_AMP,
    ACTIONS(3051), 1,
      anon_sym_PIPE,
    ACTIONS(3055), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3059), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3111), 1,
      anon_sym_COMMA,
    ACTIONS(3593), 1,
      anon_sym_RBRACE,
    STATE(2727), 1,
      sym_type_arguments,
    ACTIONS(3045), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3053), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3061), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1171), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3029), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3047), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3037), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3057), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [62164] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2197), 1,
      anon_sym_LPAREN,
    STATE(1662), 1,
      sym_arguments,
    ACTIONS(3087), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3089), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [62216] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2197), 1,
      anon_sym_LPAREN,
    STATE(1663), 1,
      sym_arguments,
    ACTIONS(3093), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3095), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [62268] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1047), 1,
      sym__automatic_semicolon,
    ACTIONS(1039), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1043), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1045), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [62320] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1037), 1,
      sym__automatic_semicolon,
    ACTIONS(1029), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1033), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1035), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [62372] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1001), 1,
      sym__automatic_semicolon,
    ACTIONS(993), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(997), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(999), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [62424] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(959), 1,
      sym__automatic_semicolon,
    ACTIONS(951), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(955), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(957), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [62476] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1107), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1111), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1113), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [62526] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1061), 1,
      sym__automatic_semicolon,
    ACTIONS(1053), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1057), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1059), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [62578] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3581), 1,
      anon_sym_AMP,
    ACTIONS(3583), 1,
      anon_sym_PIPE,
    ACTIONS(3589), 1,
      anon_sym_extends,
    ACTIONS(1770), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1768), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [62632] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1541), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1539), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [62680] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1477), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1475), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [62728] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1579), 2,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(1581), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1577), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1575), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [62780] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(945), 1,
      anon_sym_EQ,
    ACTIONS(3595), 1,
      sym__automatic_semicolon,
    ACTIONS(943), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(941), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [62832] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(2197), 1,
      anon_sym_LPAREN,
    ACTIONS(2313), 1,
      anon_sym_LBRACK,
    ACTIONS(2318), 1,
      anon_sym_DOT,
    ACTIONS(3184), 1,
      anon_sym_as,
    ACTIONS(3186), 1,
      anon_sym_BANG,
    ACTIONS(3192), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3559), 1,
      anon_sym_LT,
    ACTIONS(3561), 1,
      anon_sym_QMARK,
    ACTIONS(3563), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3569), 1,
      anon_sym_AMP,
    ACTIONS(3571), 1,
      anon_sym_PIPE,
    ACTIONS(3575), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3579), 1,
      anon_sym_QMARK_QMARK,
    STATE(2746), 1,
      sym_type_arguments,
    ACTIONS(3214), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3565), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3573), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3597), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(1606), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3555), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3567), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3557), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3577), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [62924] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(2197), 1,
      anon_sym_LPAREN,
    ACTIONS(2313), 1,
      anon_sym_LBRACK,
    ACTIONS(2318), 1,
      anon_sym_DOT,
    ACTIONS(3184), 1,
      anon_sym_as,
    ACTIONS(3186), 1,
      anon_sym_BANG,
    ACTIONS(3192), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3559), 1,
      anon_sym_LT,
    ACTIONS(3561), 1,
      anon_sym_QMARK,
    ACTIONS(3563), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3569), 1,
      anon_sym_AMP,
    ACTIONS(3571), 1,
      anon_sym_PIPE,
    ACTIONS(3575), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3579), 1,
      anon_sym_QMARK_QMARK,
    STATE(2746), 1,
      sym_type_arguments,
    ACTIONS(3174), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3214), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3565), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3573), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1606), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3555), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3567), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3557), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3577), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [63016] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(479), 1,
      anon_sym_BQUOTE,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2975), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3031), 1,
      anon_sym_as,
    ACTIONS(3035), 1,
      anon_sym_BANG,
    ACTIONS(3039), 1,
      anon_sym_LT,
    ACTIONS(3041), 1,
      anon_sym_QMARK,
    ACTIONS(3043), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3049), 1,
      anon_sym_AMP,
    ACTIONS(3051), 1,
      anon_sym_PIPE,
    ACTIONS(3055), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3059), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3111), 1,
      anon_sym_COMMA,
    ACTIONS(3599), 1,
      anon_sym_RBRACK,
    STATE(2727), 1,
      sym_type_arguments,
    ACTIONS(3045), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3053), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3061), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1171), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3029), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3047), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3037), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3057), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [63110] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1597), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1595), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [63158] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1605), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1603), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [63206] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(2197), 1,
      anon_sym_LPAREN,
    ACTIONS(2313), 1,
      anon_sym_LBRACK,
    ACTIONS(2318), 1,
      anon_sym_DOT,
    ACTIONS(3184), 1,
      anon_sym_as,
    ACTIONS(3186), 1,
      anon_sym_BANG,
    ACTIONS(3192), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3559), 1,
      anon_sym_LT,
    ACTIONS(3561), 1,
      anon_sym_QMARK,
    ACTIONS(3563), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3569), 1,
      anon_sym_AMP,
    ACTIONS(3571), 1,
      anon_sym_PIPE,
    ACTIONS(3575), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3579), 1,
      anon_sym_QMARK_QMARK,
    STATE(2746), 1,
      sym_type_arguments,
    ACTIONS(3176), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3214), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3565), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3573), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1606), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3555), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3567), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3557), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3577), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [63298] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1545), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1543), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [63346] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(479), 1,
      anon_sym_BQUOTE,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2975), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3031), 1,
      anon_sym_as,
    ACTIONS(3035), 1,
      anon_sym_BANG,
    ACTIONS(3039), 1,
      anon_sym_LT,
    ACTIONS(3041), 1,
      anon_sym_QMARK,
    ACTIONS(3043), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3049), 1,
      anon_sym_AMP,
    ACTIONS(3051), 1,
      anon_sym_PIPE,
    ACTIONS(3055), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3059), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3111), 1,
      anon_sym_COMMA,
    ACTIONS(3601), 1,
      anon_sym_RBRACK,
    STATE(2727), 1,
      sym_type_arguments,
    ACTIONS(3045), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3053), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3061), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1171), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3029), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3047), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3037), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3057), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [63440] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(479), 1,
      anon_sym_BQUOTE,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2975), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3031), 1,
      anon_sym_as,
    ACTIONS(3035), 1,
      anon_sym_BANG,
    ACTIONS(3039), 1,
      anon_sym_LT,
    ACTIONS(3041), 1,
      anon_sym_QMARK,
    ACTIONS(3043), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3049), 1,
      anon_sym_AMP,
    ACTIONS(3051), 1,
      anon_sym_PIPE,
    ACTIONS(3055), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3059), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3111), 1,
      anon_sym_COMMA,
    ACTIONS(3603), 1,
      anon_sym_RBRACK,
    STATE(2727), 1,
      sym_type_arguments,
    ACTIONS(3045), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3053), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3061), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1171), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3029), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3047), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3037), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3057), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [63534] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1133), 1,
      sym__automatic_semicolon,
    ACTIONS(1125), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1129), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1131), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [63586] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(479), 1,
      anon_sym_BQUOTE,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2975), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3031), 1,
      anon_sym_as,
    ACTIONS(3035), 1,
      anon_sym_BANG,
    ACTIONS(3039), 1,
      anon_sym_LT,
    ACTIONS(3041), 1,
      anon_sym_QMARK,
    ACTIONS(3043), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3049), 1,
      anon_sym_AMP,
    ACTIONS(3051), 1,
      anon_sym_PIPE,
    ACTIONS(3055), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3059), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3111), 1,
      anon_sym_COMMA,
    ACTIONS(3605), 1,
      anon_sym_RPAREN,
    STATE(2727), 1,
      sym_type_arguments,
    ACTIONS(3045), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3053), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3061), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1171), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3029), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3047), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3037), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3057), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [63680] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(479), 1,
      anon_sym_BQUOTE,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2975), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3031), 1,
      anon_sym_as,
    ACTIONS(3035), 1,
      anon_sym_BANG,
    ACTIONS(3039), 1,
      anon_sym_LT,
    ACTIONS(3041), 1,
      anon_sym_QMARK,
    ACTIONS(3043), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3049), 1,
      anon_sym_AMP,
    ACTIONS(3051), 1,
      anon_sym_PIPE,
    ACTIONS(3055), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3059), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3111), 1,
      anon_sym_COMMA,
    ACTIONS(3607), 1,
      anon_sym_RBRACK,
    STATE(2727), 1,
      sym_type_arguments,
    ACTIONS(3045), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3053), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3061), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1171), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3029), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3047), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3037), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3057), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [63774] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1750), 1,
      anon_sym_extends,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2219), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2624), 1,
      anon_sym_QMARK,
    ACTIONS(3609), 1,
      anon_sym_EQ,
    ACTIONS(3611), 1,
      anon_sym_RPAREN,
    ACTIONS(2615), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(3163), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1111), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1113), 18,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [63840] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2313), 1,
      anon_sym_LBRACK,
    ACTIONS(2318), 1,
      anon_sym_DOT,
    ACTIONS(2322), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1563), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(1565), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1111), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1113), 21,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [63898] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(2197), 1,
      anon_sym_LPAREN,
    ACTIONS(2313), 1,
      anon_sym_LBRACK,
    ACTIONS(2318), 1,
      anon_sym_DOT,
    ACTIONS(3184), 1,
      anon_sym_as,
    ACTIONS(3186), 1,
      anon_sym_BANG,
    ACTIONS(3192), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3559), 1,
      anon_sym_LT,
    ACTIONS(3561), 1,
      anon_sym_QMARK,
    ACTIONS(3563), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3569), 1,
      anon_sym_AMP,
    ACTIONS(3571), 1,
      anon_sym_PIPE,
    ACTIONS(3575), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3579), 1,
      anon_sym_QMARK_QMARK,
    STATE(2746), 1,
      sym_type_arguments,
    ACTIONS(3121), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3214), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3565), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3573), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1606), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3555), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3567), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3557), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3577), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [63990] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(2197), 1,
      anon_sym_LPAREN,
    ACTIONS(2313), 1,
      anon_sym_LBRACK,
    ACTIONS(2318), 1,
      anon_sym_DOT,
    ACTIONS(3184), 1,
      anon_sym_as,
    ACTIONS(3186), 1,
      anon_sym_BANG,
    ACTIONS(3192), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3559), 1,
      anon_sym_LT,
    ACTIONS(3561), 1,
      anon_sym_QMARK,
    ACTIONS(3563), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3569), 1,
      anon_sym_AMP,
    ACTIONS(3571), 1,
      anon_sym_PIPE,
    ACTIONS(3575), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3579), 1,
      anon_sym_QMARK_QMARK,
    STATE(2746), 1,
      sym_type_arguments,
    ACTIONS(3214), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3565), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3573), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3615), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(1606), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3555), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3567), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3557), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3577), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [64082] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(479), 1,
      anon_sym_BQUOTE,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2975), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3031), 1,
      anon_sym_as,
    ACTIONS(3035), 1,
      anon_sym_BANG,
    ACTIONS(3039), 1,
      anon_sym_LT,
    ACTIONS(3041), 1,
      anon_sym_QMARK,
    ACTIONS(3043), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3049), 1,
      anon_sym_AMP,
    ACTIONS(3051), 1,
      anon_sym_PIPE,
    ACTIONS(3055), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3059), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3111), 1,
      anon_sym_COMMA,
    ACTIONS(3617), 1,
      anon_sym_RBRACK,
    STATE(2727), 1,
      sym_type_arguments,
    ACTIONS(3045), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3053), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3061), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1171), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3029), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3047), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3037), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3057), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [64176] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3119), 2,
      anon_sym_COLON,
      anon_sym_EQ_GT,
    ACTIONS(3115), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3117), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [64226] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(991), 1,
      sym__automatic_semicolon,
    ACTIONS(983), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(987), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(989), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [64278] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(479), 1,
      anon_sym_BQUOTE,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2975), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3031), 1,
      anon_sym_as,
    ACTIONS(3035), 1,
      anon_sym_BANG,
    ACTIONS(3039), 1,
      anon_sym_LT,
    ACTIONS(3041), 1,
      anon_sym_QMARK,
    ACTIONS(3043), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3049), 1,
      anon_sym_AMP,
    ACTIONS(3051), 1,
      anon_sym_PIPE,
    ACTIONS(3055), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3059), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3111), 1,
      anon_sym_COMMA,
    ACTIONS(3619), 1,
      anon_sym_RBRACK,
    STATE(2727), 1,
      sym_type_arguments,
    ACTIONS(3045), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3053), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3061), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1171), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3029), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3047), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3037), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3057), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [64372] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3621), 1,
      sym_regex_flags,
    ACTIONS(3485), 16,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
    ACTIONS(3487), 23,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [64422] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(479), 1,
      anon_sym_BQUOTE,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2975), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3031), 1,
      anon_sym_as,
    ACTIONS(3035), 1,
      anon_sym_BANG,
    ACTIONS(3039), 1,
      anon_sym_LT,
    ACTIONS(3041), 1,
      anon_sym_QMARK,
    ACTIONS(3043), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3049), 1,
      anon_sym_AMP,
    ACTIONS(3051), 1,
      anon_sym_PIPE,
    ACTIONS(3055), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3059), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3111), 1,
      anon_sym_COMMA,
    ACTIONS(3623), 1,
      anon_sym_RBRACK,
    STATE(2727), 1,
      sym_type_arguments,
    ACTIONS(3045), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3053), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3061), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1171), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3029), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3047), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3037), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3057), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [64516] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(479), 1,
      anon_sym_BQUOTE,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2975), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3031), 1,
      anon_sym_as,
    ACTIONS(3035), 1,
      anon_sym_BANG,
    ACTIONS(3039), 1,
      anon_sym_LT,
    ACTIONS(3041), 1,
      anon_sym_QMARK,
    ACTIONS(3043), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3049), 1,
      anon_sym_AMP,
    ACTIONS(3051), 1,
      anon_sym_PIPE,
    ACTIONS(3055), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3059), 1,
      anon_sym_QMARK_QMARK,
    STATE(2727), 1,
      sym_type_arguments,
    ACTIONS(3045), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3053), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3061), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3237), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(1171), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3029), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3047), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3037), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3057), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [64608] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(479), 1,
      anon_sym_BQUOTE,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2975), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3031), 1,
      anon_sym_as,
    ACTIONS(3035), 1,
      anon_sym_BANG,
    ACTIONS(3039), 1,
      anon_sym_LT,
    ACTIONS(3041), 1,
      anon_sym_QMARK,
    ACTIONS(3043), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3049), 1,
      anon_sym_AMP,
    ACTIONS(3051), 1,
      anon_sym_PIPE,
    ACTIONS(3055), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3059), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3111), 1,
      anon_sym_COMMA,
    ACTIONS(3625), 1,
      anon_sym_RBRACK,
    STATE(2727), 1,
      sym_type_arguments,
    ACTIONS(3045), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3053), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3061), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1171), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3029), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3047), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3037), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3057), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [64702] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(479), 1,
      anon_sym_BQUOTE,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2975), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3031), 1,
      anon_sym_as,
    ACTIONS(3035), 1,
      anon_sym_BANG,
    ACTIONS(3039), 1,
      anon_sym_LT,
    ACTIONS(3041), 1,
      anon_sym_QMARK,
    ACTIONS(3043), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3049), 1,
      anon_sym_AMP,
    ACTIONS(3051), 1,
      anon_sym_PIPE,
    ACTIONS(3055), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3059), 1,
      anon_sym_QMARK_QMARK,
    STATE(2727), 1,
      sym_type_arguments,
    ACTIONS(3045), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3053), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3061), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3228), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(1171), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3029), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3047), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3037), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3057), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [64794] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1573), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1571), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [64842] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(2197), 1,
      anon_sym_LPAREN,
    ACTIONS(2313), 1,
      anon_sym_LBRACK,
    ACTIONS(2318), 1,
      anon_sym_DOT,
    ACTIONS(3184), 1,
      anon_sym_as,
    ACTIONS(3186), 1,
      anon_sym_BANG,
    ACTIONS(3192), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3559), 1,
      anon_sym_LT,
    ACTIONS(3561), 1,
      anon_sym_QMARK,
    ACTIONS(3563), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3569), 1,
      anon_sym_AMP,
    ACTIONS(3571), 1,
      anon_sym_PIPE,
    ACTIONS(3575), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3579), 1,
      anon_sym_QMARK_QMARK,
    STATE(2746), 1,
      sym_type_arguments,
    ACTIONS(3083), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3214), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3565), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3573), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1606), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3555), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3567), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3557), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3577), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [64934] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1027), 1,
      sym__automatic_semicolon,
    ACTIONS(1019), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1023), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1025), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [64986] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1011), 1,
      sym__automatic_semicolon,
    ACTIONS(1003), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1007), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1009), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [65038] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1191), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1189), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [65086] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1609), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1607), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [65134] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(479), 1,
      anon_sym_BQUOTE,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2975), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3031), 1,
      anon_sym_as,
    ACTIONS(3035), 1,
      anon_sym_BANG,
    ACTIONS(3039), 1,
      anon_sym_LT,
    ACTIONS(3041), 1,
      anon_sym_QMARK,
    ACTIONS(3043), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3049), 1,
      anon_sym_AMP,
    ACTIONS(3051), 1,
      anon_sym_PIPE,
    ACTIONS(3055), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3059), 1,
      anon_sym_QMARK_QMARK,
    STATE(2727), 1,
      sym_type_arguments,
    ACTIONS(3045), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3053), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3061), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3223), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(1171), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3029), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3047), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3037), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3057), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [65226] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3627), 1,
      anon_sym_LBRACK,
    ACTIONS(1557), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1555), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [65276] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1589), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1587), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [65324] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2313), 1,
      anon_sym_LBRACK,
    ACTIONS(2318), 1,
      anon_sym_DOT,
    ACTIONS(2322), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3585), 1,
      anon_sym_EQ,
    ACTIONS(3629), 1,
      anon_sym_in,
    ACTIONS(3632), 1,
      anon_sym_of,
    ACTIONS(1111), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1113), 21,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [65384] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1581), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1579), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [65432] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1549), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1547), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [65480] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(2197), 1,
      anon_sym_LPAREN,
    ACTIONS(2313), 1,
      anon_sym_LBRACK,
    ACTIONS(2318), 1,
      anon_sym_DOT,
    ACTIONS(3184), 1,
      anon_sym_as,
    ACTIONS(3186), 1,
      anon_sym_BANG,
    ACTIONS(3192), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3559), 1,
      anon_sym_LT,
    ACTIONS(3561), 1,
      anon_sym_QMARK,
    ACTIONS(3563), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3569), 1,
      anon_sym_AMP,
    ACTIONS(3571), 1,
      anon_sym_PIPE,
    ACTIONS(3575), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3579), 1,
      anon_sym_QMARK_QMARK,
    STATE(2746), 1,
      sym_type_arguments,
    ACTIONS(3033), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3214), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3565), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3573), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1606), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3555), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3567), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3557), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3577), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [65572] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3023), 1,
      anon_sym_LBRACK,
    ACTIONS(1535), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(3026), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2985), 12,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2987), 22,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [65626] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1529), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1527), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [65674] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1495), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1493), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [65722] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3581), 1,
      anon_sym_AMP,
    ACTIONS(3583), 1,
      anon_sym_PIPE,
    ACTIONS(3589), 1,
      anon_sym_extends,
    ACTIONS(1790), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1788), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [65776] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(479), 1,
      anon_sym_BQUOTE,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2975), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3035), 1,
      anon_sym_BANG,
    ACTIONS(3634), 1,
      anon_sym_LT,
    STATE(2727), 1,
      sym_type_arguments,
    ACTIONS(3061), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1171), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3123), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3125), 16,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [65844] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(2197), 1,
      anon_sym_LPAREN,
    ACTIONS(2313), 1,
      anon_sym_LBRACK,
    ACTIONS(2318), 1,
      anon_sym_DOT,
    ACTIONS(3186), 1,
      anon_sym_BANG,
    ACTIONS(3192), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3575), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3637), 1,
      anon_sym_LT,
    STATE(2746), 1,
      sym_type_arguments,
    ACTIONS(3214), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1606), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3063), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3065), 15,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [65914] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(2197), 1,
      anon_sym_LPAREN,
    ACTIONS(2313), 1,
      anon_sym_LBRACK,
    ACTIONS(2318), 1,
      anon_sym_DOT,
    ACTIONS(3186), 1,
      anon_sym_BANG,
    ACTIONS(3192), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3559), 1,
      anon_sym_LT,
    ACTIONS(3575), 1,
      anon_sym_STAR_STAR,
    STATE(2746), 1,
      sym_type_arguments,
    ACTIONS(3214), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3573), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1606), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3555), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3567), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3063), 7,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3065), 12,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [65990] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1613), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1611), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [66038] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(2197), 1,
      anon_sym_LPAREN,
    ACTIONS(2313), 1,
      anon_sym_LBRACK,
    ACTIONS(2318), 1,
      anon_sym_DOT,
    ACTIONS(3186), 1,
      anon_sym_BANG,
    ACTIONS(3192), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3559), 1,
      anon_sym_LT,
    ACTIONS(3575), 1,
      anon_sym_STAR_STAR,
    STATE(2746), 1,
      sym_type_arguments,
    ACTIONS(3214), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3573), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1606), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3063), 3,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3555), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3567), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3557), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3577), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3065), 7,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [66118] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(2197), 1,
      anon_sym_LPAREN,
    ACTIONS(2313), 1,
      anon_sym_LBRACK,
    ACTIONS(2318), 1,
      anon_sym_DOT,
    ACTIONS(3186), 1,
      anon_sym_BANG,
    ACTIONS(3192), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3559), 1,
      anon_sym_LT,
    ACTIONS(3563), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3569), 1,
      anon_sym_AMP,
    ACTIONS(3575), 1,
      anon_sym_STAR_STAR,
    STATE(2746), 1,
      sym_type_arguments,
    ACTIONS(3063), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(3214), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3573), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1606), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3555), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3567), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3557), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3577), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3065), 6,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [66202] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(2197), 1,
      anon_sym_LPAREN,
    ACTIONS(2313), 1,
      anon_sym_LBRACK,
    ACTIONS(2318), 1,
      anon_sym_DOT,
    ACTIONS(3186), 1,
      anon_sym_BANG,
    ACTIONS(3192), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3575), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3637), 1,
      anon_sym_LT,
    STATE(2746), 1,
      sym_type_arguments,
    ACTIONS(3214), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1606), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3555), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3567), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3063), 9,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3065), 12,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [66276] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(2197), 1,
      anon_sym_LPAREN,
    ACTIONS(2313), 1,
      anon_sym_LBRACK,
    ACTIONS(2318), 1,
      anon_sym_DOT,
    ACTIONS(3186), 1,
      anon_sym_BANG,
    ACTIONS(3192), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3637), 1,
      anon_sym_LT,
    STATE(2746), 1,
      sym_type_arguments,
    ACTIONS(3214), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1606), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3063), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3065), 16,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [66344] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(2197), 1,
      anon_sym_LPAREN,
    ACTIONS(2313), 1,
      anon_sym_LBRACK,
    ACTIONS(2318), 1,
      anon_sym_DOT,
    ACTIONS(3063), 1,
      anon_sym_QMARK,
    ACTIONS(3186), 1,
      anon_sym_BANG,
    ACTIONS(3192), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3559), 1,
      anon_sym_LT,
    ACTIONS(3563), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3569), 1,
      anon_sym_AMP,
    ACTIONS(3571), 1,
      anon_sym_PIPE,
    ACTIONS(3575), 1,
      anon_sym_STAR_STAR,
    STATE(2746), 1,
      sym_type_arguments,
    ACTIONS(3214), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3565), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3573), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1606), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3555), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3567), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3065), 4,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_QMARK_QMARK,
    ACTIONS(3557), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3577), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [66432] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1628), 1,
      sym_type_arguments,
    ACTIONS(1617), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1615), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [66482] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(2197), 1,
      anon_sym_LPAREN,
    ACTIONS(2313), 1,
      anon_sym_LBRACK,
    ACTIONS(2318), 1,
      anon_sym_DOT,
    ACTIONS(3184), 1,
      anon_sym_as,
    ACTIONS(3186), 1,
      anon_sym_BANG,
    ACTIONS(3192), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3559), 1,
      anon_sym_LT,
    ACTIONS(3561), 1,
      anon_sym_QMARK,
    ACTIONS(3563), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3569), 1,
      anon_sym_AMP,
    ACTIONS(3571), 1,
      anon_sym_PIPE,
    ACTIONS(3575), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3579), 1,
      anon_sym_QMARK_QMARK,
    STATE(2746), 1,
      sym_type_arguments,
    ACTIONS(3172), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3214), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3565), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3573), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1606), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3555), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3567), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3557), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3577), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [66574] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(2197), 1,
      anon_sym_LPAREN,
    ACTIONS(2313), 1,
      anon_sym_LBRACK,
    ACTIONS(2318), 1,
      anon_sym_DOT,
    ACTIONS(3184), 1,
      anon_sym_as,
    ACTIONS(3186), 1,
      anon_sym_BANG,
    ACTIONS(3192), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3559), 1,
      anon_sym_LT,
    ACTIONS(3561), 1,
      anon_sym_QMARK,
    ACTIONS(3563), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3569), 1,
      anon_sym_AMP,
    ACTIONS(3571), 1,
      anon_sym_PIPE,
    ACTIONS(3575), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3579), 1,
      anon_sym_QMARK_QMARK,
    STATE(2746), 1,
      sym_type_arguments,
    ACTIONS(3170), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3214), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3565), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3573), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1606), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3555), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3567), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3557), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3577), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [66666] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(2197), 1,
      anon_sym_LPAREN,
    ACTIONS(2313), 1,
      anon_sym_LBRACK,
    ACTIONS(2318), 1,
      anon_sym_DOT,
    ACTIONS(3184), 1,
      anon_sym_as,
    ACTIONS(3186), 1,
      anon_sym_BANG,
    ACTIONS(3192), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3559), 1,
      anon_sym_LT,
    ACTIONS(3561), 1,
      anon_sym_QMARK,
    ACTIONS(3563), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3569), 1,
      anon_sym_AMP,
    ACTIONS(3571), 1,
      anon_sym_PIPE,
    ACTIONS(3575), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3579), 1,
      anon_sym_QMARK_QMARK,
    STATE(2746), 1,
      sym_type_arguments,
    ACTIONS(3168), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3214), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3565), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3573), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1606), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3555), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3567), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3557), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3577), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [66758] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(2197), 1,
      anon_sym_LPAREN,
    ACTIONS(2313), 1,
      anon_sym_LBRACK,
    ACTIONS(2318), 1,
      anon_sym_DOT,
    ACTIONS(3184), 1,
      anon_sym_as,
    ACTIONS(3186), 1,
      anon_sym_BANG,
    ACTIONS(3192), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3559), 1,
      anon_sym_LT,
    ACTIONS(3561), 1,
      anon_sym_QMARK,
    ACTIONS(3563), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3569), 1,
      anon_sym_AMP,
    ACTIONS(3571), 1,
      anon_sym_PIPE,
    ACTIONS(3575), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3579), 1,
      anon_sym_QMARK_QMARK,
    STATE(2746), 1,
      sym_type_arguments,
    ACTIONS(3166), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3214), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3565), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3573), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1606), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3555), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3567), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3557), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3577), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [66850] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1621), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1619), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [66898] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(479), 1,
      anon_sym_BQUOTE,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2975), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3035), 1,
      anon_sym_BANG,
    ACTIONS(3634), 1,
      anon_sym_LT,
    STATE(2727), 1,
      sym_type_arguments,
    ACTIONS(3061), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1171), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3123), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3125), 16,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [66966] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(479), 1,
      anon_sym_BQUOTE,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2975), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3031), 1,
      anon_sym_as,
    ACTIONS(3035), 1,
      anon_sym_BANG,
    ACTIONS(3039), 1,
      anon_sym_LT,
    ACTIONS(3041), 1,
      anon_sym_QMARK,
    ACTIONS(3043), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3049), 1,
      anon_sym_AMP,
    ACTIONS(3051), 1,
      anon_sym_PIPE,
    ACTIONS(3055), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3059), 1,
      anon_sym_QMARK_QMARK,
    STATE(2727), 1,
      sym_type_arguments,
    ACTIONS(3045), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3053), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3061), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3449), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    STATE(1171), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3029), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3047), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3037), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3057), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [67058] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(479), 1,
      anon_sym_BQUOTE,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2975), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3031), 1,
      anon_sym_as,
    ACTIONS(3035), 1,
      anon_sym_BANG,
    ACTIONS(3644), 1,
      anon_sym_LT,
    ACTIONS(3646), 1,
      anon_sym_QMARK,
    ACTIONS(3648), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3654), 1,
      anon_sym_AMP,
    ACTIONS(3656), 1,
      anon_sym_PIPE,
    ACTIONS(3660), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3664), 1,
      anon_sym_QMARK_QMARK,
    STATE(2727), 1,
      sym_type_arguments,
    ACTIONS(3061), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3130), 2,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(3650), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3658), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1171), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3640), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3652), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3642), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3662), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [67150] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(479), 1,
      anon_sym_BQUOTE,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2975), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3031), 1,
      anon_sym_as,
    ACTIONS(3035), 1,
      anon_sym_BANG,
    ACTIONS(3039), 1,
      anon_sym_LT,
    ACTIONS(3041), 1,
      anon_sym_QMARK,
    ACTIONS(3043), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3049), 1,
      anon_sym_AMP,
    ACTIONS(3051), 1,
      anon_sym_PIPE,
    ACTIONS(3055), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3059), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3111), 1,
      anon_sym_COMMA,
    ACTIONS(3666), 1,
      anon_sym_RPAREN,
    STATE(2727), 1,
      sym_type_arguments,
    ACTIONS(3045), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3053), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3061), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1171), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3029), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3047), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3037), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3057), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [67244] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1533), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1531), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [67292] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(479), 1,
      anon_sym_BQUOTE,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2975), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3031), 1,
      anon_sym_as,
    ACTIONS(3035), 1,
      anon_sym_BANG,
    ACTIONS(3039), 1,
      anon_sym_LT,
    ACTIONS(3041), 1,
      anon_sym_QMARK,
    ACTIONS(3043), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3049), 1,
      anon_sym_AMP,
    ACTIONS(3051), 1,
      anon_sym_PIPE,
    ACTIONS(3055), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3059), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3111), 1,
      anon_sym_COMMA,
    ACTIONS(3668), 1,
      anon_sym_RPAREN,
    STATE(2727), 1,
      sym_type_arguments,
    ACTIONS(3045), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3053), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3061), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1171), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3029), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3047), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3037), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3057), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [67386] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(479), 1,
      anon_sym_BQUOTE,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2975), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3031), 1,
      anon_sym_as,
    ACTIONS(3035), 1,
      anon_sym_BANG,
    ACTIONS(3644), 1,
      anon_sym_LT,
    ACTIONS(3646), 1,
      anon_sym_QMARK,
    ACTIONS(3648), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3654), 1,
      anon_sym_AMP,
    ACTIONS(3656), 1,
      anon_sym_PIPE,
    ACTIONS(3660), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3664), 1,
      anon_sym_QMARK_QMARK,
    STATE(2727), 1,
      sym_type_arguments,
    ACTIONS(3061), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3132), 2,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(3650), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3658), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1171), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3640), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3652), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3642), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3662), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [67478] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(479), 1,
      anon_sym_BQUOTE,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2975), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3031), 1,
      anon_sym_as,
    ACTIONS(3035), 1,
      anon_sym_BANG,
    ACTIONS(3039), 1,
      anon_sym_LT,
    ACTIONS(3041), 1,
      anon_sym_QMARK,
    ACTIONS(3043), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3049), 1,
      anon_sym_AMP,
    ACTIONS(3051), 1,
      anon_sym_PIPE,
    ACTIONS(3055), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3059), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3111), 1,
      anon_sym_COMMA,
    ACTIONS(3670), 1,
      anon_sym_RPAREN,
    STATE(2727), 1,
      sym_type_arguments,
    ACTIONS(3045), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3053), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3061), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1171), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3029), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3047), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3037), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3057), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [67572] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(479), 1,
      anon_sym_BQUOTE,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2975), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3031), 1,
      anon_sym_as,
    ACTIONS(3035), 1,
      anon_sym_BANG,
    ACTIONS(3039), 1,
      anon_sym_LT,
    ACTIONS(3041), 1,
      anon_sym_QMARK,
    ACTIONS(3043), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3049), 1,
      anon_sym_AMP,
    ACTIONS(3051), 1,
      anon_sym_PIPE,
    ACTIONS(3055), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3059), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3111), 1,
      anon_sym_COMMA,
    ACTIONS(3672), 1,
      anon_sym_RPAREN,
    STATE(2727), 1,
      sym_type_arguments,
    ACTIONS(3045), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3053), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3061), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1171), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3029), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3047), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3037), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3057), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [67666] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3080), 1,
      anon_sym_LT,
    ACTIONS(1017), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1015), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [67716] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(479), 1,
      anon_sym_BQUOTE,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2975), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3634), 1,
      anon_sym_LT,
    STATE(2727), 1,
      sym_type_arguments,
    ACTIONS(3061), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1171), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3123), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3125), 16,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [67782] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(479), 1,
      anon_sym_BQUOTE,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2975), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3031), 1,
      anon_sym_as,
    ACTIONS(3035), 1,
      anon_sym_BANG,
    ACTIONS(3039), 1,
      anon_sym_LT,
    ACTIONS(3041), 1,
      anon_sym_QMARK,
    ACTIONS(3043), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3049), 1,
      anon_sym_AMP,
    ACTIONS(3051), 1,
      anon_sym_PIPE,
    ACTIONS(3055), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3059), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3111), 1,
      anon_sym_COMMA,
    ACTIONS(3674), 1,
      anon_sym_COLON,
    STATE(2727), 1,
      sym_type_arguments,
    ACTIONS(3045), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3053), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3061), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1171), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3029), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3047), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3037), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3057), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [67876] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3676), 1,
      anon_sym_DOT,
    STATE(1590), 1,
      sym_type_arguments,
    ACTIONS(1723), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1721), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [67928] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(479), 1,
      anon_sym_BQUOTE,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2975), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3031), 1,
      anon_sym_as,
    ACTIONS(3035), 1,
      anon_sym_BANG,
    ACTIONS(3039), 1,
      anon_sym_LT,
    ACTIONS(3041), 1,
      anon_sym_QMARK,
    ACTIONS(3043), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3049), 1,
      anon_sym_AMP,
    ACTIONS(3051), 1,
      anon_sym_PIPE,
    ACTIONS(3055), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3059), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3111), 1,
      anon_sym_COMMA,
    ACTIONS(3678), 1,
      anon_sym_RPAREN,
    STATE(2727), 1,
      sym_type_arguments,
    ACTIONS(3045), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3053), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3061), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1171), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3029), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3047), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3037), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3057), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [68022] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(479), 1,
      anon_sym_BQUOTE,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2975), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3031), 1,
      anon_sym_as,
    ACTIONS(3035), 1,
      anon_sym_BANG,
    ACTIONS(3039), 1,
      anon_sym_LT,
    ACTIONS(3041), 1,
      anon_sym_QMARK,
    ACTIONS(3043), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3049), 1,
      anon_sym_AMP,
    ACTIONS(3051), 1,
      anon_sym_PIPE,
    ACTIONS(3055), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3059), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3111), 1,
      anon_sym_COMMA,
    ACTIONS(3680), 1,
      anon_sym_RPAREN,
    STATE(2727), 1,
      sym_type_arguments,
    ACTIONS(3045), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3053), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3061), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1171), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3029), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3047), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3037), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3057), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [68116] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(479), 1,
      anon_sym_BQUOTE,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2975), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3031), 1,
      anon_sym_as,
    ACTIONS(3035), 1,
      anon_sym_BANG,
    ACTIONS(3039), 1,
      anon_sym_LT,
    ACTIONS(3041), 1,
      anon_sym_QMARK,
    ACTIONS(3043), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3049), 1,
      anon_sym_AMP,
    ACTIONS(3051), 1,
      anon_sym_PIPE,
    ACTIONS(3055), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3059), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3111), 1,
      anon_sym_COMMA,
    ACTIONS(3682), 1,
      anon_sym_RPAREN,
    STATE(2727), 1,
      sym_type_arguments,
    ACTIONS(3045), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3053), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3061), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1171), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3029), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3047), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3037), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3057), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [68210] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(479), 1,
      anon_sym_BQUOTE,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2975), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3031), 1,
      anon_sym_as,
    ACTIONS(3035), 1,
      anon_sym_BANG,
    ACTIONS(3039), 1,
      anon_sym_LT,
    ACTIONS(3041), 1,
      anon_sym_QMARK,
    ACTIONS(3043), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3049), 1,
      anon_sym_AMP,
    ACTIONS(3051), 1,
      anon_sym_PIPE,
    ACTIONS(3055), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3059), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3111), 1,
      anon_sym_COMMA,
    ACTIONS(3684), 1,
      anon_sym_RPAREN,
    STATE(2727), 1,
      sym_type_arguments,
    ACTIONS(3045), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3053), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3061), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1171), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3029), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3047), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3037), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3057), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [68304] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1757), 1,
      anon_sym_DOT,
    ACTIONS(1398), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1396), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [68354] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(2197), 1,
      anon_sym_LPAREN,
    ACTIONS(2313), 1,
      anon_sym_LBRACK,
    ACTIONS(2318), 1,
      anon_sym_DOT,
    ACTIONS(3184), 1,
      anon_sym_as,
    ACTIONS(3186), 1,
      anon_sym_BANG,
    ACTIONS(3192), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3559), 1,
      anon_sym_LT,
    ACTIONS(3561), 1,
      anon_sym_QMARK,
    ACTIONS(3563), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3569), 1,
      anon_sym_AMP,
    ACTIONS(3571), 1,
      anon_sym_PIPE,
    ACTIONS(3575), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3579), 1,
      anon_sym_QMARK_QMARK,
    STATE(2746), 1,
      sym_type_arguments,
    ACTIONS(3214), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3565), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3573), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3686), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(1606), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3555), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3567), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3557), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3577), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [68446] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(479), 1,
      anon_sym_BQUOTE,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2975), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3031), 1,
      anon_sym_as,
    ACTIONS(3035), 1,
      anon_sym_BANG,
    ACTIONS(3039), 1,
      anon_sym_LT,
    ACTIONS(3041), 1,
      anon_sym_QMARK,
    ACTIONS(3043), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3049), 1,
      anon_sym_AMP,
    ACTIONS(3051), 1,
      anon_sym_PIPE,
    ACTIONS(3055), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3059), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3111), 1,
      anon_sym_COMMA,
    ACTIONS(3688), 1,
      anon_sym_RPAREN,
    STATE(2727), 1,
      sym_type_arguments,
    ACTIONS(3045), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3053), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3061), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1171), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3029), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3047), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3037), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3057), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [68540] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(479), 1,
      anon_sym_BQUOTE,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2975), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3031), 1,
      anon_sym_as,
    ACTIONS(3035), 1,
      anon_sym_BANG,
    ACTIONS(3644), 1,
      anon_sym_LT,
    ACTIONS(3646), 1,
      anon_sym_QMARK,
    ACTIONS(3648), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3654), 1,
      anon_sym_AMP,
    ACTIONS(3656), 1,
      anon_sym_PIPE,
    ACTIONS(3660), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3664), 1,
      anon_sym_QMARK_QMARK,
    STATE(2727), 1,
      sym_type_arguments,
    ACTIONS(3061), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3158), 2,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(3650), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3658), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1171), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3640), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3652), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3642), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3662), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [68632] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(479), 1,
      anon_sym_BQUOTE,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2975), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3031), 1,
      anon_sym_as,
    ACTIONS(3035), 1,
      anon_sym_BANG,
    ACTIONS(3644), 1,
      anon_sym_LT,
    ACTIONS(3646), 1,
      anon_sym_QMARK,
    ACTIONS(3648), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3654), 1,
      anon_sym_AMP,
    ACTIONS(3656), 1,
      anon_sym_PIPE,
    ACTIONS(3660), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3664), 1,
      anon_sym_QMARK_QMARK,
    STATE(2727), 1,
      sym_type_arguments,
    ACTIONS(3061), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3109), 2,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(3650), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3658), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1171), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3640), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3652), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3642), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3662), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [68724] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(479), 1,
      anon_sym_BQUOTE,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2975), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3031), 1,
      anon_sym_as,
    ACTIONS(3035), 1,
      anon_sym_BANG,
    ACTIONS(3644), 1,
      anon_sym_LT,
    ACTIONS(3646), 1,
      anon_sym_QMARK,
    ACTIONS(3648), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3654), 1,
      anon_sym_AMP,
    ACTIONS(3656), 1,
      anon_sym_PIPE,
    ACTIONS(3660), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3664), 1,
      anon_sym_QMARK_QMARK,
    STATE(2727), 1,
      sym_type_arguments,
    ACTIONS(3061), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3103), 2,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(3650), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3658), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1171), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3640), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3652), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3642), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3662), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [68816] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3676), 1,
      anon_sym_DOT,
    ACTIONS(3690), 1,
      anon_sym_LT,
    STATE(1590), 1,
      sym_type_arguments,
    ACTIONS(1712), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1710), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [68870] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(479), 1,
      anon_sym_BQUOTE,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2975), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3031), 1,
      anon_sym_as,
    ACTIONS(3035), 1,
      anon_sym_BANG,
    ACTIONS(3039), 1,
      anon_sym_LT,
    ACTIONS(3041), 1,
      anon_sym_QMARK,
    ACTIONS(3043), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3049), 1,
      anon_sym_AMP,
    ACTIONS(3051), 1,
      anon_sym_PIPE,
    ACTIONS(3055), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3059), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3111), 1,
      anon_sym_COMMA,
    ACTIONS(3693), 1,
      anon_sym_RBRACK,
    STATE(2727), 1,
      sym_type_arguments,
    ACTIONS(3045), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3053), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3061), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1171), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3029), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3047), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3037), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3057), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [68964] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(479), 1,
      anon_sym_BQUOTE,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2975), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3031), 1,
      anon_sym_as,
    ACTIONS(3035), 1,
      anon_sym_BANG,
    ACTIONS(3644), 1,
      anon_sym_LT,
    ACTIONS(3646), 1,
      anon_sym_QMARK,
    ACTIONS(3648), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3654), 1,
      anon_sym_AMP,
    ACTIONS(3656), 1,
      anon_sym_PIPE,
    ACTIONS(3660), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3664), 1,
      anon_sym_QMARK_QMARK,
    STATE(2727), 1,
      sym_type_arguments,
    ACTIONS(3061), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3085), 2,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(3650), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3658), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1171), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3640), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3652), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3642), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3662), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [69056] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(479), 1,
      anon_sym_BQUOTE,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2975), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3031), 1,
      anon_sym_as,
    ACTIONS(3035), 1,
      anon_sym_BANG,
    ACTIONS(3644), 1,
      anon_sym_LT,
    ACTIONS(3646), 1,
      anon_sym_QMARK,
    ACTIONS(3648), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3654), 1,
      anon_sym_AMP,
    ACTIONS(3656), 1,
      anon_sym_PIPE,
    ACTIONS(3660), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3664), 1,
      anon_sym_QMARK_QMARK,
    STATE(2727), 1,
      sym_type_arguments,
    ACTIONS(3061), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3166), 2,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(3650), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3658), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1171), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3640), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3652), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3642), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3662), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [69148] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(479), 1,
      anon_sym_BQUOTE,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2975), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3031), 1,
      anon_sym_as,
    ACTIONS(3035), 1,
      anon_sym_BANG,
    ACTIONS(3644), 1,
      anon_sym_LT,
    ACTIONS(3646), 1,
      anon_sym_QMARK,
    ACTIONS(3648), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3654), 1,
      anon_sym_AMP,
    ACTIONS(3656), 1,
      anon_sym_PIPE,
    ACTIONS(3660), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3664), 1,
      anon_sym_QMARK_QMARK,
    STATE(2727), 1,
      sym_type_arguments,
    ACTIONS(3061), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3168), 2,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(3650), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3658), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1171), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3640), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3652), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3642), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3662), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [69240] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3695), 1,
      anon_sym_DOT,
    STATE(1590), 1,
      sym_type_arguments,
    ACTIONS(1561), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1559), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [69292] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(2197), 1,
      anon_sym_LPAREN,
    ACTIONS(2313), 1,
      anon_sym_LBRACK,
    ACTIONS(2318), 1,
      anon_sym_DOT,
    ACTIONS(3184), 1,
      anon_sym_as,
    ACTIONS(3186), 1,
      anon_sym_BANG,
    ACTIONS(3192), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3559), 1,
      anon_sym_LT,
    ACTIONS(3561), 1,
      anon_sym_QMARK,
    ACTIONS(3563), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3569), 1,
      anon_sym_AMP,
    ACTIONS(3571), 1,
      anon_sym_PIPE,
    ACTIONS(3575), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3579), 1,
      anon_sym_QMARK_QMARK,
    STATE(2746), 1,
      sym_type_arguments,
    ACTIONS(3085), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3214), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3565), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3573), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1606), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3555), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3567), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3557), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3577), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [69384] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(479), 1,
      anon_sym_BQUOTE,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2975), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3031), 1,
      anon_sym_as,
    ACTIONS(3035), 1,
      anon_sym_BANG,
    ACTIONS(3644), 1,
      anon_sym_LT,
    ACTIONS(3646), 1,
      anon_sym_QMARK,
    ACTIONS(3648), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3654), 1,
      anon_sym_AMP,
    ACTIONS(3656), 1,
      anon_sym_PIPE,
    ACTIONS(3660), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3664), 1,
      anon_sym_QMARK_QMARK,
    STATE(2727), 1,
      sym_type_arguments,
    ACTIONS(3061), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3170), 2,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(3650), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3658), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1171), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3640), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3652), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3642), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3662), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [69476] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(479), 1,
      anon_sym_BQUOTE,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2975), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3031), 1,
      anon_sym_as,
    ACTIONS(3035), 1,
      anon_sym_BANG,
    ACTIONS(3644), 1,
      anon_sym_LT,
    ACTIONS(3646), 1,
      anon_sym_QMARK,
    ACTIONS(3648), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3654), 1,
      anon_sym_AMP,
    ACTIONS(3656), 1,
      anon_sym_PIPE,
    ACTIONS(3660), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3664), 1,
      anon_sym_QMARK_QMARK,
    STATE(2727), 1,
      sym_type_arguments,
    ACTIONS(3061), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3172), 2,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(3650), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3658), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1171), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3640), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3652), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3642), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3662), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [69568] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(479), 1,
      anon_sym_BQUOTE,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2975), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3035), 1,
      anon_sym_BANG,
    ACTIONS(3063), 1,
      anon_sym_QMARK,
    ACTIONS(3644), 1,
      anon_sym_LT,
    ACTIONS(3648), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3654), 1,
      anon_sym_AMP,
    ACTIONS(3656), 1,
      anon_sym_PIPE,
    ACTIONS(3660), 1,
      anon_sym_STAR_STAR,
    STATE(2727), 1,
      sym_type_arguments,
    ACTIONS(3061), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3650), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3658), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1171), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3640), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3652), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3065), 4,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK_QMARK,
    ACTIONS(3642), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3662), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [69656] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(479), 1,
      anon_sym_BQUOTE,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2975), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3035), 1,
      anon_sym_BANG,
    ACTIONS(3660), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3697), 1,
      anon_sym_LT,
    STATE(2727), 1,
      sym_type_arguments,
    ACTIONS(3061), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1171), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3640), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3652), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3063), 9,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3065), 12,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [69730] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(479), 1,
      anon_sym_BQUOTE,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2975), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3035), 1,
      anon_sym_BANG,
    ACTIONS(3644), 1,
      anon_sym_LT,
    ACTIONS(3648), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3654), 1,
      anon_sym_AMP,
    ACTIONS(3660), 1,
      anon_sym_STAR_STAR,
    STATE(2727), 1,
      sym_type_arguments,
    ACTIONS(3061), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3063), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(3658), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1171), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3640), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3652), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3642), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3662), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3065), 6,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [69814] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(479), 1,
      anon_sym_BQUOTE,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2975), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3035), 1,
      anon_sym_BANG,
    ACTIONS(3644), 1,
      anon_sym_LT,
    ACTIONS(3660), 1,
      anon_sym_STAR_STAR,
    STATE(2727), 1,
      sym_type_arguments,
    ACTIONS(3061), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3658), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1171), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3063), 3,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3640), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3652), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3642), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3662), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3065), 7,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [69894] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(479), 1,
      anon_sym_BQUOTE,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2975), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3035), 1,
      anon_sym_BANG,
    ACTIONS(3644), 1,
      anon_sym_LT,
    ACTIONS(3660), 1,
      anon_sym_STAR_STAR,
    STATE(2727), 1,
      sym_type_arguments,
    ACTIONS(3061), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3658), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1171), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3640), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3652), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3063), 7,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3065), 12,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [69970] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(2197), 1,
      anon_sym_LPAREN,
    ACTIONS(2313), 1,
      anon_sym_LBRACK,
    ACTIONS(2318), 1,
      anon_sym_DOT,
    ACTIONS(3184), 1,
      anon_sym_as,
    ACTIONS(3186), 1,
      anon_sym_BANG,
    ACTIONS(3192), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3559), 1,
      anon_sym_LT,
    ACTIONS(3561), 1,
      anon_sym_QMARK,
    ACTIONS(3563), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3569), 1,
      anon_sym_AMP,
    ACTIONS(3571), 1,
      anon_sym_PIPE,
    ACTIONS(3575), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3579), 1,
      anon_sym_QMARK_QMARK,
    STATE(2746), 1,
      sym_type_arguments,
    ACTIONS(3103), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3214), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3565), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3573), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1606), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3555), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3567), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3557), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3577), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [70062] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(2197), 1,
      anon_sym_LPAREN,
    ACTIONS(2313), 1,
      anon_sym_LBRACK,
    ACTIONS(2318), 1,
      anon_sym_DOT,
    ACTIONS(3184), 1,
      anon_sym_as,
    ACTIONS(3186), 1,
      anon_sym_BANG,
    ACTIONS(3192), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3559), 1,
      anon_sym_LT,
    ACTIONS(3561), 1,
      anon_sym_QMARK,
    ACTIONS(3563), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3569), 1,
      anon_sym_AMP,
    ACTIONS(3571), 1,
      anon_sym_PIPE,
    ACTIONS(3575), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3579), 1,
      anon_sym_QMARK_QMARK,
    STATE(2746), 1,
      sym_type_arguments,
    ACTIONS(3109), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3214), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3565), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3573), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1606), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3555), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3567), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3557), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3577), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [70154] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(479), 1,
      anon_sym_BQUOTE,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2975), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3035), 1,
      anon_sym_BANG,
    ACTIONS(3660), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3697), 1,
      anon_sym_LT,
    STATE(2727), 1,
      sym_type_arguments,
    ACTIONS(3061), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1171), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3063), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3065), 15,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [70224] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(479), 1,
      anon_sym_BQUOTE,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2975), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3031), 1,
      anon_sym_as,
    ACTIONS(3035), 1,
      anon_sym_BANG,
    ACTIONS(3644), 1,
      anon_sym_LT,
    ACTIONS(3646), 1,
      anon_sym_QMARK,
    ACTIONS(3648), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3654), 1,
      anon_sym_AMP,
    ACTIONS(3656), 1,
      anon_sym_PIPE,
    ACTIONS(3660), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3664), 1,
      anon_sym_QMARK_QMARK,
    STATE(2727), 1,
      sym_type_arguments,
    ACTIONS(3033), 2,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(3061), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3650), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3658), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1171), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3640), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3652), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3642), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3662), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [70316] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(479), 1,
      anon_sym_BQUOTE,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2975), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3031), 1,
      anon_sym_as,
    ACTIONS(3035), 1,
      anon_sym_BANG,
    ACTIONS(3039), 1,
      anon_sym_LT,
    ACTIONS(3041), 1,
      anon_sym_QMARK,
    ACTIONS(3043), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3049), 1,
      anon_sym_AMP,
    ACTIONS(3051), 1,
      anon_sym_PIPE,
    ACTIONS(3055), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3059), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3111), 1,
      anon_sym_COMMA,
    ACTIONS(3700), 1,
      anon_sym_RBRACK,
    STATE(2727), 1,
      sym_type_arguments,
    ACTIONS(3045), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3053), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3061), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1171), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3029), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3047), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3037), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3057), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [70410] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(2197), 1,
      anon_sym_LPAREN,
    ACTIONS(2313), 1,
      anon_sym_LBRACK,
    ACTIONS(2318), 1,
      anon_sym_DOT,
    ACTIONS(3184), 1,
      anon_sym_as,
    ACTIONS(3186), 1,
      anon_sym_BANG,
    ACTIONS(3192), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3559), 1,
      anon_sym_LT,
    ACTIONS(3561), 1,
      anon_sym_QMARK,
    ACTIONS(3563), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3569), 1,
      anon_sym_AMP,
    ACTIONS(3571), 1,
      anon_sym_PIPE,
    ACTIONS(3575), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3579), 1,
      anon_sym_QMARK_QMARK,
    STATE(2746), 1,
      sym_type_arguments,
    ACTIONS(3214), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3565), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3573), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3702), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(1606), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3555), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3567), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3557), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3577), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [70502] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(479), 1,
      anon_sym_BQUOTE,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2975), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3031), 1,
      anon_sym_as,
    ACTIONS(3035), 1,
      anon_sym_BANG,
    ACTIONS(3644), 1,
      anon_sym_LT,
    ACTIONS(3646), 1,
      anon_sym_QMARK,
    ACTIONS(3648), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3654), 1,
      anon_sym_AMP,
    ACTIONS(3656), 1,
      anon_sym_PIPE,
    ACTIONS(3660), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3664), 1,
      anon_sym_QMARK_QMARK,
    STATE(2727), 1,
      sym_type_arguments,
    ACTIONS(3061), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3083), 2,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(3650), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3658), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1171), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3640), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3652), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3642), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3662), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [70594] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2313), 1,
      anon_sym_LBRACK,
    ACTIONS(2318), 1,
      anon_sym_DOT,
    ACTIONS(2322), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3587), 1,
      anon_sym_EQ,
    ACTIONS(3704), 1,
      anon_sym_in,
    ACTIONS(3707), 1,
      anon_sym_of,
    ACTIONS(1111), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1113), 21,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [70654] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(973), 1,
      sym__automatic_semicolon,
    ACTIONS(965), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(969), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(971), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [70706] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(479), 1,
      anon_sym_BQUOTE,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2975), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3035), 1,
      anon_sym_BANG,
    ACTIONS(3697), 1,
      anon_sym_LT,
    STATE(2727), 1,
      sym_type_arguments,
    ACTIONS(3061), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1171), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3063), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3065), 16,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [70774] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1593), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1591), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [70822] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1511), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1509), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [70870] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(479), 1,
      anon_sym_BQUOTE,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2975), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3031), 1,
      anon_sym_as,
    ACTIONS(3035), 1,
      anon_sym_BANG,
    ACTIONS(3644), 1,
      anon_sym_LT,
    ACTIONS(3646), 1,
      anon_sym_QMARK,
    ACTIONS(3648), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3654), 1,
      anon_sym_AMP,
    ACTIONS(3656), 1,
      anon_sym_PIPE,
    ACTIONS(3660), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3664), 1,
      anon_sym_QMARK_QMARK,
    STATE(2727), 1,
      sym_type_arguments,
    ACTIONS(3061), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3121), 2,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(3650), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3658), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1171), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3640), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3652), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3642), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3662), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [70962] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3709), 1,
      anon_sym_LT,
    STATE(1628), 1,
      sym_type_arguments,
    ACTIONS(1752), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1750), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [71014] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(2197), 1,
      anon_sym_LPAREN,
    ACTIONS(2313), 1,
      anon_sym_LBRACK,
    ACTIONS(2318), 1,
      anon_sym_DOT,
    ACTIONS(3184), 1,
      anon_sym_as,
    ACTIONS(3186), 1,
      anon_sym_BANG,
    ACTIONS(3192), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3559), 1,
      anon_sym_LT,
    ACTIONS(3561), 1,
      anon_sym_QMARK,
    ACTIONS(3563), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3569), 1,
      anon_sym_AMP,
    ACTIONS(3571), 1,
      anon_sym_PIPE,
    ACTIONS(3575), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3579), 1,
      anon_sym_QMARK_QMARK,
    STATE(2746), 1,
      sym_type_arguments,
    ACTIONS(3158), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3214), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3565), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3573), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1606), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3555), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3567), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3557), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3577), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [71106] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(479), 1,
      anon_sym_BQUOTE,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2975), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3031), 1,
      anon_sym_as,
    ACTIONS(3035), 1,
      anon_sym_BANG,
    ACTIONS(3644), 1,
      anon_sym_LT,
    ACTIONS(3646), 1,
      anon_sym_QMARK,
    ACTIONS(3648), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3654), 1,
      anon_sym_AMP,
    ACTIONS(3656), 1,
      anon_sym_PIPE,
    ACTIONS(3660), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3664), 1,
      anon_sym_QMARK_QMARK,
    STATE(2727), 1,
      sym_type_arguments,
    ACTIONS(3061), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3174), 2,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(3650), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3658), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1171), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3640), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3652), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3642), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3662), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [71198] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1617), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1615), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [71246] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1515), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1513), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [71294] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(479), 1,
      anon_sym_BQUOTE,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2975), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3031), 1,
      anon_sym_as,
    ACTIONS(3035), 1,
      anon_sym_BANG,
    ACTIONS(3644), 1,
      anon_sym_LT,
    ACTIONS(3646), 1,
      anon_sym_QMARK,
    ACTIONS(3648), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3654), 1,
      anon_sym_AMP,
    ACTIONS(3656), 1,
      anon_sym_PIPE,
    ACTIONS(3660), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3664), 1,
      anon_sym_QMARK_QMARK,
    STATE(2727), 1,
      sym_type_arguments,
    ACTIONS(3061), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3176), 2,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(3650), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3658), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1171), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3640), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3652), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3642), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3662), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [71386] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3470), 1,
      anon_sym_DOT,
    ACTIONS(1561), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1559), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [71436] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1561), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1559), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [71484] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1487), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1485), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [71532] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1537), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1535), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [71580] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1483), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1481), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [71628] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3627), 1,
      anon_sym_LBRACK,
    ACTIONS(1523), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1521), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [71678] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1519), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1517), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [71726] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1553), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1551), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [71774] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1565), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1563), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [71822] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3259), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3085), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [71869] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3265), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3267), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [71916] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3366), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3368), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [71963] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(479), 1,
      anon_sym_BQUOTE,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2975), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3031), 1,
      anon_sym_as,
    ACTIONS(3035), 1,
      anon_sym_BANG,
    ACTIONS(3644), 1,
      anon_sym_LT,
    ACTIONS(3646), 1,
      anon_sym_QMARK,
    ACTIONS(3648), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3654), 1,
      anon_sym_AMP,
    ACTIONS(3656), 1,
      anon_sym_PIPE,
    ACTIONS(3660), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3664), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3712), 1,
      anon_sym_COLON,
    STATE(2727), 1,
      sym_type_arguments,
    ACTIONS(3061), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3650), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3658), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1171), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3640), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3652), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3642), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3662), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [72054] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(2434), 1,
      anon_sym_DQUOTE,
    ACTIONS(2436), 1,
      anon_sym_SQUOTE,
    ACTIONS(2552), 1,
      anon_sym_DASH,
    ACTIONS(2866), 1,
      anon_sym_LBRACK,
    ACTIONS(3714), 1,
      anon_sym_STAR,
    ACTIONS(3716), 1,
      anon_sym_RBRACE,
    ACTIONS(3718), 1,
      anon_sym_async,
    ACTIONS(3720), 1,
      sym_number,
    ACTIONS(3722), 1,
      anon_sym_static,
    ACTIONS(3724), 1,
      anon_sym_abstract,
    ACTIONS(3728), 1,
      sym_readonly,
    STATE(1885), 1,
      sym_method_definition,
    STATE(1918), 1,
      sym_accessibility_modifier,
    ACTIONS(3726), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1645), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(2876), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1971), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2833), 4,
      sym_public_field_definition,
      sym_method_signature,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(2856), 11,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [72137] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3358), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3360), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [72184] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(2434), 1,
      anon_sym_DQUOTE,
    ACTIONS(2436), 1,
      anon_sym_SQUOTE,
    ACTIONS(2552), 1,
      anon_sym_DASH,
    ACTIONS(2866), 1,
      anon_sym_LBRACK,
    ACTIONS(3714), 1,
      anon_sym_STAR,
    ACTIONS(3718), 1,
      anon_sym_async,
    ACTIONS(3720), 1,
      sym_number,
    ACTIONS(3722), 1,
      anon_sym_static,
    ACTIONS(3724), 1,
      anon_sym_abstract,
    ACTIONS(3728), 1,
      sym_readonly,
    ACTIONS(3730), 1,
      anon_sym_RBRACE,
    STATE(1885), 1,
      sym_method_definition,
    STATE(1918), 1,
      sym_accessibility_modifier,
    ACTIONS(3726), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1516), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(2876), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1971), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2833), 4,
      sym_public_field_definition,
      sym_method_signature,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(2856), 11,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [72267] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(969), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(971), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [72314] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(2434), 1,
      anon_sym_DQUOTE,
    ACTIONS(2436), 1,
      anon_sym_SQUOTE,
    ACTIONS(2552), 1,
      anon_sym_DASH,
    ACTIONS(2866), 1,
      anon_sym_LBRACK,
    ACTIONS(3714), 1,
      anon_sym_STAR,
    ACTIONS(3718), 1,
      anon_sym_async,
    ACTIONS(3720), 1,
      sym_number,
    ACTIONS(3722), 1,
      anon_sym_static,
    ACTIONS(3724), 1,
      anon_sym_abstract,
    ACTIONS(3728), 1,
      sym_readonly,
    ACTIONS(3732), 1,
      anon_sym_RBRACE,
    STATE(1885), 1,
      sym_method_definition,
    STATE(1918), 1,
      sym_accessibility_modifier,
    ACTIONS(3726), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1645), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(2876), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1971), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2833), 4,
      sym_public_field_definition,
      sym_method_signature,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(2856), 11,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [72397] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3734), 1,
      anon_sym_LBRACE,
    ACTIONS(3736), 1,
      anon_sym_DOT,
    STATE(1721), 1,
      sym_statement_block,
    ACTIONS(935), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(933), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [72450] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(479), 1,
      anon_sym_BQUOTE,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2975), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3031), 1,
      anon_sym_as,
    ACTIONS(3035), 1,
      anon_sym_BANG,
    ACTIONS(3644), 1,
      anon_sym_LT,
    ACTIONS(3646), 1,
      anon_sym_QMARK,
    ACTIONS(3648), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3654), 1,
      anon_sym_AMP,
    ACTIONS(3656), 1,
      anon_sym_PIPE,
    ACTIONS(3660), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3664), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3738), 1,
      anon_sym_RBRACK,
    STATE(2727), 1,
      sym_type_arguments,
    ACTIONS(3061), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3650), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3658), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1171), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3640), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3652), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3642), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3662), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [72541] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2219), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3740), 1,
      anon_sym_EQ,
    ACTIONS(1111), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1113), 21,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [72596] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2219), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3742), 1,
      anon_sym_EQ,
    ACTIONS(1111), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1113), 21,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [72651] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2633), 1,
      anon_sym_LBRACK,
    ACTIONS(2639), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2651), 1,
      anon_sym_DOT,
    ACTIONS(1563), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(1565), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1111), 12,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1113), 19,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [72708] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3015), 16,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3017), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [72755] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3011), 16,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3013), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [72802] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2313), 1,
      anon_sym_LBRACK,
    ACTIONS(2318), 1,
      anon_sym_DOT,
    ACTIONS(2322), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1111), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1113), 22,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [72855] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1569), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1567), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [72902] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1601), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1599), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [72949] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3370), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3372), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [72996] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3430), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3432), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [73043] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1081), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1079), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [73090] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3744), 1,
      anon_sym_AMP,
    ACTIONS(3746), 1,
      anon_sym_PIPE,
    ACTIONS(1780), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1778), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [73141] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2633), 1,
      anon_sym_LBRACK,
    ACTIONS(2639), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2651), 1,
      anon_sym_DOT,
    ACTIONS(3748), 1,
      anon_sym_EQ,
    ACTIONS(1111), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1113), 20,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [73196] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2633), 1,
      anon_sym_LBRACK,
    ACTIONS(2639), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2651), 1,
      anon_sym_DOT,
    ACTIONS(3750), 1,
      anon_sym_EQ,
    ACTIONS(1111), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1113), 20,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [73251] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3080), 1,
      anon_sym_LT,
    ACTIONS(1017), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1015), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [73300] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2313), 1,
      anon_sym_LBRACK,
    ACTIONS(2318), 1,
      anon_sym_DOT,
    ACTIONS(2322), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1607), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(3155), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1111), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1113), 20,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [73357] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(2434), 1,
      anon_sym_DQUOTE,
    ACTIONS(2436), 1,
      anon_sym_SQUOTE,
    ACTIONS(2552), 1,
      anon_sym_DASH,
    ACTIONS(2866), 1,
      anon_sym_LBRACK,
    ACTIONS(3714), 1,
      anon_sym_STAR,
    ACTIONS(3718), 1,
      anon_sym_async,
    ACTIONS(3720), 1,
      sym_number,
    ACTIONS(3722), 1,
      anon_sym_static,
    ACTIONS(3724), 1,
      anon_sym_abstract,
    ACTIONS(3728), 1,
      sym_readonly,
    ACTIONS(3752), 1,
      anon_sym_RBRACE,
    STATE(1885), 1,
      sym_method_definition,
    STATE(1918), 1,
      sym_accessibility_modifier,
    ACTIONS(3726), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1520), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(2876), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1971), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2833), 4,
      sym_public_field_definition,
      sym_method_signature,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(2856), 11,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [73440] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3744), 1,
      anon_sym_AMP,
    ACTIONS(3746), 1,
      anon_sym_PIPE,
    ACTIONS(3754), 1,
      anon_sym_extends,
    ACTIONS(1770), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1768), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [73493] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1477), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1475), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [73540] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1757), 1,
      anon_sym_DOT,
    ACTIONS(1398), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1396), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [73589] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1113), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [73636] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(2434), 1,
      anon_sym_DQUOTE,
    ACTIONS(2436), 1,
      anon_sym_SQUOTE,
    ACTIONS(2552), 1,
      anon_sym_DASH,
    ACTIONS(2866), 1,
      anon_sym_LBRACK,
    ACTIONS(3714), 1,
      anon_sym_STAR,
    ACTIONS(3718), 1,
      anon_sym_async,
    ACTIONS(3720), 1,
      sym_number,
    ACTIONS(3722), 1,
      anon_sym_static,
    ACTIONS(3724), 1,
      anon_sym_abstract,
    ACTIONS(3728), 1,
      sym_readonly,
    ACTIONS(3756), 1,
      anon_sym_RBRACE,
    STATE(1885), 1,
      sym_method_definition,
    STATE(1918), 1,
      sym_accessibility_modifier,
    ACTIONS(3726), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1645), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(2876), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1971), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2833), 4,
      sym_public_field_definition,
      sym_method_signature,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(2856), 11,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [73719] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3734), 1,
      anon_sym_LBRACE,
    STATE(1721), 1,
      sym_statement_block,
    ACTIONS(935), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(933), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [73770] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2219), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1563), 2,
      anon_sym_RPAREN,
      anon_sym_extends,
    ACTIONS(1565), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1111), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1113), 20,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [73827] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1573), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1571), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [73874] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3362), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3168), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [73921] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1585), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1583), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [73968] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1495), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1493), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [74015] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3304), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3306), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [74062] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(479), 1,
      anon_sym_BQUOTE,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2975), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3031), 1,
      anon_sym_as,
    ACTIONS(3035), 1,
      anon_sym_BANG,
    ACTIONS(3644), 1,
      anon_sym_LT,
    ACTIONS(3646), 1,
      anon_sym_QMARK,
    ACTIONS(3648), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3654), 1,
      anon_sym_AMP,
    ACTIONS(3656), 1,
      anon_sym_PIPE,
    ACTIONS(3660), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3664), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3758), 1,
      anon_sym_COLON,
    STATE(2727), 1,
      sym_type_arguments,
    ACTIONS(3061), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3650), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3658), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1171), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3640), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3652), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3642), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3662), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [74153] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3744), 1,
      anon_sym_AMP,
    ACTIONS(3746), 1,
      anon_sym_PIPE,
    ACTIONS(3754), 1,
      anon_sym_extends,
    ACTIONS(1790), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1788), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [74206] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(109), 1,
      anon_sym_STAR,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(1729), 1,
      anon_sym_LBRACE,
    ACTIONS(3762), 1,
      anon_sym_RBRACE,
    ACTIONS(3764), 1,
      anon_sym_LBRACK,
    ACTIONS(3766), 1,
      anon_sym_async,
    ACTIONS(3768), 1,
      sym_number,
    ACTIONS(3770), 1,
      anon_sym_static,
    ACTIONS(3776), 1,
      sym_readonly,
    STATE(1921), 1,
      sym_accessibility_modifier,
    STATE(2936), 1,
      aux_sym_object_repeat1,
    STATE(3210), 1,
      sym_array,
    STATE(3217), 1,
      sym_object,
    ACTIONS(3772), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3774), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2200), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2933), 4,
      sym_assignment_pattern,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    ACTIONS(3760), 11,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [74291] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(109), 1,
      anon_sym_STAR,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(1729), 1,
      anon_sym_LBRACE,
    ACTIONS(3764), 1,
      anon_sym_LBRACK,
    ACTIONS(3768), 1,
      sym_number,
    ACTIONS(3780), 1,
      anon_sym_RBRACE,
    ACTIONS(3782), 1,
      anon_sym_async,
    ACTIONS(3784), 1,
      anon_sym_static,
    ACTIONS(3790), 1,
      sym_readonly,
    STATE(1921), 1,
      sym_accessibility_modifier,
    STATE(2846), 1,
      aux_sym_object_repeat1,
    STATE(3210), 1,
      sym_array,
    STATE(3217), 1,
      sym_object,
    ACTIONS(3786), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3788), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2200), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2844), 4,
      sym_assignment_pattern,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    ACTIONS(3778), 11,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [74376] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1541), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1539), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [74423] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(2434), 1,
      anon_sym_DQUOTE,
    ACTIONS(2436), 1,
      anon_sym_SQUOTE,
    ACTIONS(2552), 1,
      anon_sym_DASH,
    ACTIONS(2866), 1,
      anon_sym_LBRACK,
    ACTIONS(3714), 1,
      anon_sym_STAR,
    ACTIONS(3718), 1,
      anon_sym_async,
    ACTIONS(3720), 1,
      sym_number,
    ACTIONS(3722), 1,
      anon_sym_static,
    ACTIONS(3724), 1,
      anon_sym_abstract,
    ACTIONS(3728), 1,
      sym_readonly,
    ACTIONS(3792), 1,
      anon_sym_RBRACE,
    STATE(1885), 1,
      sym_method_definition,
    STATE(1918), 1,
      sym_accessibility_modifier,
    ACTIONS(3726), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1659), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(2876), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1971), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2833), 4,
      sym_public_field_definition,
      sym_method_signature,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(2856), 11,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [74506] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3595), 1,
      sym__automatic_semicolon,
    ACTIONS(943), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(941), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [74555] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3253), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3255), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [74602] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3115), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3117), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [74649] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3257), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3176), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [74696] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3009), 16,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2840), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [74743] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1191), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1189), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [74790] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1609), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1607), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [74837] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(2434), 1,
      anon_sym_DQUOTE,
    ACTIONS(2436), 1,
      anon_sym_SQUOTE,
    ACTIONS(2552), 1,
      anon_sym_DASH,
    ACTIONS(2866), 1,
      anon_sym_LBRACK,
    ACTIONS(3714), 1,
      anon_sym_STAR,
    ACTIONS(3718), 1,
      anon_sym_async,
    ACTIONS(3720), 1,
      sym_number,
    ACTIONS(3722), 1,
      anon_sym_static,
    ACTIONS(3724), 1,
      anon_sym_abstract,
    ACTIONS(3728), 1,
      sym_readonly,
    ACTIONS(3794), 1,
      anon_sym_RBRACE,
    STATE(1885), 1,
      sym_method_definition,
    STATE(1918), 1,
      sym_accessibility_modifier,
    ACTIONS(3726), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1645), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(2876), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1971), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2833), 4,
      sym_public_field_definition,
      sym_method_signature,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(2856), 11,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [74920] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3796), 1,
      anon_sym_LBRACK,
    ACTIONS(1557), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1555), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [74969] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1589), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1587), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [75016] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(479), 1,
      anon_sym_BQUOTE,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2975), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3031), 1,
      anon_sym_as,
    ACTIONS(3035), 1,
      anon_sym_BANG,
    ACTIONS(3644), 1,
      anon_sym_LT,
    ACTIONS(3646), 1,
      anon_sym_QMARK,
    ACTIONS(3648), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3654), 1,
      anon_sym_AMP,
    ACTIONS(3656), 1,
      anon_sym_PIPE,
    ACTIONS(3660), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3664), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3798), 1,
      anon_sym_COLON,
    STATE(2727), 1,
      sym_type_arguments,
    ACTIONS(3061), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3650), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3658), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1171), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3640), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3652), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3642), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3662), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [75107] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(945), 16,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(947), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [75154] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3070), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3072), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [75201] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3800), 1,
      sym__automatic_semicolon,
    ACTIONS(1051), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1049), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [75250] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3232), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3033), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [75297] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3292), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3294), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [75344] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3239), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3241), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [75391] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1607), 1,
      anon_sym_extends,
    ACTIONS(2633), 1,
      anon_sym_LBRACK,
    ACTIONS(2639), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2651), 1,
      anon_sym_DOT,
    ACTIONS(3152), 1,
      anon_sym_COMMA,
    ACTIONS(3155), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1111), 12,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1113), 19,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [75450] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3243), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3245), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [75497] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2998), 16,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3000), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [75544] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2994), 16,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2996), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [75591] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3274), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3276), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [75638] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1515), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1513), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [75685] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3288), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3290), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [75732] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2313), 1,
      anon_sym_LBRACK,
    ACTIONS(2318), 1,
      anon_sym_DOT,
    ACTIONS(2322), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3802), 1,
      anon_sym_LPAREN,
    ACTIONS(3805), 1,
      anon_sym_COLON,
    ACTIONS(3807), 2,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1111), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1113), 20,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [75791] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1579), 2,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(1581), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1577), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1575), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [75842] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1057), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1059), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [75889] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1597), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1595), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [75936] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1605), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1603), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [75983] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1545), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1543), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [76030] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(955), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(957), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [76077] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2313), 1,
      anon_sym_LBRACK,
    ACTIONS(2318), 1,
      anon_sym_DOT,
    ACTIONS(2322), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3810), 1,
      anon_sym_EQ,
    ACTIONS(1111), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1113), 21,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [76132] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1491), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1489), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [76179] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(479), 1,
      anon_sym_BQUOTE,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2975), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3031), 1,
      anon_sym_as,
    ACTIONS(3035), 1,
      anon_sym_BANG,
    ACTIONS(3644), 1,
      anon_sym_LT,
    ACTIONS(3646), 1,
      anon_sym_QMARK,
    ACTIONS(3648), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3654), 1,
      anon_sym_AMP,
    ACTIONS(3656), 1,
      anon_sym_PIPE,
    ACTIONS(3660), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3664), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3812), 1,
      anon_sym_COLON,
    STATE(2727), 1,
      sym_type_arguments,
    ACTIONS(3061), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3650), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3658), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1171), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3640), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3652), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3642), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3662), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [76270] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(997), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(999), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [76317] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1581), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1579), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [76364] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1549), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1547), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [76411] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1033), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1035), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [76458] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1129), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1131), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [76505] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(987), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(989), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [76552] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(109), 1,
      anon_sym_STAR,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(1729), 1,
      anon_sym_LBRACE,
    ACTIONS(3764), 1,
      anon_sym_LBRACK,
    ACTIONS(3768), 1,
      sym_number,
    ACTIONS(3816), 1,
      anon_sym_RBRACE,
    ACTIONS(3818), 1,
      anon_sym_async,
    ACTIONS(3820), 1,
      anon_sym_static,
    ACTIONS(3826), 1,
      sym_readonly,
    STATE(1921), 1,
      sym_accessibility_modifier,
    STATE(2912), 1,
      aux_sym_object_repeat1,
    STATE(3210), 1,
      sym_array,
    STATE(3217), 1,
      sym_object,
    ACTIONS(3822), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3824), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2200), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2913), 4,
      sym_assignment_pattern,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    ACTIONS(3814), 11,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [76637] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1529), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1527), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [76684] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3489), 1,
      sym_regex_flags,
    ACTIONS(3485), 17,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_implements,
    ACTIONS(3487), 21,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [76733] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3296), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3298), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [76780] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1023), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1025), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [76827] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1043), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1045), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [76874] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1007), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1009), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [76921] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2219), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3828), 1,
      anon_sym_EQ,
    ACTIONS(3834), 1,
      anon_sym_QMARK,
    ACTIONS(3831), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(1111), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1113), 18,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [76980] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3278), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3280), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [77027] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(479), 1,
      anon_sym_BQUOTE,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2975), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3031), 1,
      anon_sym_as,
    ACTIONS(3035), 1,
      anon_sym_BANG,
    ACTIONS(3644), 1,
      anon_sym_LT,
    ACTIONS(3646), 1,
      anon_sym_QMARK,
    ACTIONS(3648), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3654), 1,
      anon_sym_AMP,
    ACTIONS(3656), 1,
      anon_sym_PIPE,
    ACTIONS(3660), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3664), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3837), 1,
      anon_sym_RBRACK,
    STATE(2727), 1,
      sym_type_arguments,
    ACTIONS(3061), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3650), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3658), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1171), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3640), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3652), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3642), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3662), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [77118] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3282), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3284), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [77165] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3839), 1,
      sym_regex_flags,
    ACTIONS(3485), 17,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
    ACTIONS(3487), 21,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [77214] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3695), 1,
      anon_sym_DOT,
    ACTIONS(1561), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1559), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [77263] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3300), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3302), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [77310] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(479), 1,
      anon_sym_BQUOTE,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2975), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3031), 1,
      anon_sym_as,
    ACTIONS(3035), 1,
      anon_sym_BANG,
    ACTIONS(3644), 1,
      anon_sym_LT,
    ACTIONS(3646), 1,
      anon_sym_QMARK,
    ACTIONS(3648), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3654), 1,
      anon_sym_AMP,
    ACTIONS(3656), 1,
      anon_sym_PIPE,
    ACTIONS(3660), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3664), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3841), 1,
      anon_sym_COLON,
    STATE(2727), 1,
      sym_type_arguments,
    ACTIONS(3061), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3650), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3658), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1171), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3640), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3652), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3642), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3662), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [77401] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1561), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1559), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [77448] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1607), 1,
      anon_sym_extends,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2219), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3152), 1,
      anon_sym_RPAREN,
    ACTIONS(3155), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1111), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1113), 20,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [77507] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2313), 1,
      anon_sym_LBRACK,
    ACTIONS(2318), 1,
      anon_sym_DOT,
    ACTIONS(2322), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1750), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(3163), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1111), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1113), 20,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [77564] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1537), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1535), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [77611] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3308), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3310), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [77658] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3796), 1,
      anon_sym_LBRACK,
    ACTIONS(1523), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1521), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [77707] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1613), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1611), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [77754] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(2434), 1,
      anon_sym_DQUOTE,
    ACTIONS(2436), 1,
      anon_sym_SQUOTE,
    ACTIONS(2552), 1,
      anon_sym_DASH,
    ACTIONS(2866), 1,
      anon_sym_LBRACK,
    ACTIONS(3714), 1,
      anon_sym_STAR,
    ACTIONS(3718), 1,
      anon_sym_async,
    ACTIONS(3720), 1,
      sym_number,
    ACTIONS(3722), 1,
      anon_sym_static,
    ACTIONS(3724), 1,
      anon_sym_abstract,
    ACTIONS(3728), 1,
      sym_readonly,
    ACTIONS(3843), 1,
      anon_sym_RBRACE,
    STATE(1885), 1,
      sym_method_definition,
    STATE(1918), 1,
      sym_accessibility_modifier,
    ACTIONS(3726), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1544), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(2876), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1971), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2833), 4,
      sym_public_field_definition,
      sym_method_signature,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(2856), 11,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [77837] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1519), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1517), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [77884] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3352), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3354), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [77931] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(2434), 1,
      anon_sym_DQUOTE,
    ACTIONS(2436), 1,
      anon_sym_SQUOTE,
    ACTIONS(2552), 1,
      anon_sym_DASH,
    ACTIONS(2866), 1,
      anon_sym_LBRACK,
    ACTIONS(3714), 1,
      anon_sym_STAR,
    ACTIONS(3718), 1,
      anon_sym_async,
    ACTIONS(3720), 1,
      sym_number,
    ACTIONS(3722), 1,
      anon_sym_static,
    ACTIONS(3724), 1,
      anon_sym_abstract,
    ACTIONS(3728), 1,
      sym_readonly,
    ACTIONS(3845), 1,
      anon_sym_RBRACE,
    STATE(1885), 1,
      sym_method_definition,
    STATE(1918), 1,
      sym_accessibility_modifier,
    ACTIONS(3726), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1630), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(2876), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1971), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2833), 4,
      sym_public_field_definition,
      sym_method_signature,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(2856), 11,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [78014] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2985), 16,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2987), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [78061] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1621), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1619), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [78108] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1553), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1551), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [78155] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(2434), 1,
      anon_sym_DQUOTE,
    ACTIONS(2436), 1,
      anon_sym_SQUOTE,
    ACTIONS(2552), 1,
      anon_sym_DASH,
    ACTIONS(2866), 1,
      anon_sym_LBRACK,
    ACTIONS(3714), 1,
      anon_sym_STAR,
    ACTIONS(3718), 1,
      anon_sym_async,
    ACTIONS(3720), 1,
      sym_number,
    ACTIONS(3722), 1,
      anon_sym_static,
    ACTIONS(3724), 1,
      anon_sym_abstract,
    ACTIONS(3728), 1,
      sym_readonly,
    ACTIONS(3847), 1,
      anon_sym_RBRACE,
    STATE(1885), 1,
      sym_method_definition,
    STATE(1918), 1,
      sym_accessibility_modifier,
    ACTIONS(3726), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1565), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(2876), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1971), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2833), 4,
      sym_public_field_definition,
      sym_method_signature,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(2856), 11,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [78238] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1487), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1485), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [78285] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1565), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1563), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [78332] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(2434), 1,
      anon_sym_DQUOTE,
    ACTIONS(2436), 1,
      anon_sym_SQUOTE,
    ACTIONS(2552), 1,
      anon_sym_DASH,
    ACTIONS(2866), 1,
      anon_sym_LBRACK,
    ACTIONS(3714), 1,
      anon_sym_STAR,
    ACTIONS(3718), 1,
      anon_sym_async,
    ACTIONS(3720), 1,
      sym_number,
    ACTIONS(3722), 1,
      anon_sym_static,
    ACTIONS(3724), 1,
      anon_sym_abstract,
    ACTIONS(3728), 1,
      sym_readonly,
    ACTIONS(3849), 1,
      anon_sym_RBRACE,
    STATE(1885), 1,
      sym_method_definition,
    STATE(1918), 1,
      sym_accessibility_modifier,
    ACTIONS(3726), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1645), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(2876), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1971), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2833), 4,
      sym_public_field_definition,
      sym_method_signature,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(2856), 11,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [78415] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1593), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1591), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [78462] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1511), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1509), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [78509] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2219), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1750), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(3163), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1111), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1113), 20,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [78566] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1101), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1103), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [78613] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3422), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3424), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [78660] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2219), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3851), 1,
      anon_sym_EQ,
    ACTIONS(3857), 1,
      anon_sym_COLON,
    ACTIONS(3859), 1,
      anon_sym_QMARK,
    ACTIONS(3854), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(1111), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1113), 18,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [78721] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2219), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3828), 1,
      anon_sym_EQ,
    ACTIONS(3834), 1,
      anon_sym_QMARK,
    ACTIONS(3862), 1,
      anon_sym_COLON,
    ACTIONS(3831), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(1111), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1113), 18,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [78782] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2219), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1607), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(3155), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1111), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1113), 20,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [78839] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3119), 1,
      anon_sym_EQ_GT,
    ACTIONS(3115), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3117), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [78888] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3434), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3436), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [78935] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3426), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3428), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [78982] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(479), 1,
      anon_sym_BQUOTE,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2975), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3031), 1,
      anon_sym_as,
    ACTIONS(3035), 1,
      anon_sym_BANG,
    ACTIONS(3644), 1,
      anon_sym_LT,
    ACTIONS(3646), 1,
      anon_sym_QMARK,
    ACTIONS(3648), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3654), 1,
      anon_sym_AMP,
    ACTIONS(3656), 1,
      anon_sym_PIPE,
    ACTIONS(3660), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3664), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3864), 1,
      anon_sym_COLON,
    STATE(2727), 1,
      sym_type_arguments,
    ACTIONS(3061), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3650), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3658), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1171), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3640), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3652), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3642), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3662), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [79073] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1533), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1531), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [79120] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2201), 1,
      anon_sym_LPAREN,
    STATE(1737), 1,
      sym_arguments,
    ACTIONS(3093), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3095), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [79171] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3869), 1,
      anon_sym_STAR,
    ACTIONS(3872), 1,
      anon_sym_RBRACE,
    ACTIONS(3874), 1,
      anon_sym_LBRACK,
    ACTIONS(3877), 1,
      anon_sym_async,
    ACTIONS(3880), 1,
      anon_sym_DASH,
    ACTIONS(3883), 1,
      anon_sym_DQUOTE,
    ACTIONS(3886), 1,
      anon_sym_SQUOTE,
    ACTIONS(3889), 1,
      sym_number,
    ACTIONS(3892), 1,
      anon_sym_AT,
    ACTIONS(3895), 1,
      anon_sym_static,
    ACTIONS(3898), 1,
      anon_sym_abstract,
    ACTIONS(3907), 1,
      sym_readonly,
    STATE(1885), 1,
      sym_method_definition,
    STATE(1918), 1,
      sym_accessibility_modifier,
    ACTIONS(3901), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1645), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(3904), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1971), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2833), 4,
      sym_public_field_definition,
      sym_method_signature,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(3866), 11,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [79254] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3378), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3380), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [79301] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2219), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2624), 1,
      anon_sym_QMARK,
    ACTIONS(2808), 1,
      anon_sym_COLON,
    ACTIONS(3609), 1,
      anon_sym_EQ,
    ACTIONS(2615), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(1111), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1113), 18,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [79362] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1089), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1087), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [79409] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1750), 1,
      anon_sym_extends,
    ACTIONS(2633), 1,
      anon_sym_LBRACK,
    ACTIONS(2639), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2651), 1,
      anon_sym_DOT,
    ACTIONS(3160), 1,
      anon_sym_COMMA,
    ACTIONS(3163), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1111), 12,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1113), 19,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [79468] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3744), 1,
      anon_sym_AMP,
    ACTIONS(3746), 1,
      anon_sym_PIPE,
    ACTIONS(3754), 1,
      anon_sym_extends,
    ACTIONS(3070), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3072), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [79521] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1119), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1121), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [79568] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1483), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1481), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [79615] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2313), 1,
      anon_sym_LBRACK,
    ACTIONS(2318), 1,
      anon_sym_DOT,
    ACTIONS(2322), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3910), 1,
      anon_sym_EQ,
    ACTIONS(1111), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1113), 21,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [79670] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3019), 16,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3021), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [79717] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2219), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3851), 1,
      anon_sym_EQ,
    ACTIONS(3859), 1,
      anon_sym_QMARK,
    ACTIONS(3854), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(1111), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1113), 18,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [79776] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2219), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2624), 1,
      anon_sym_QMARK,
    ACTIONS(3609), 1,
      anon_sym_EQ,
    ACTIONS(2615), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(1111), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1113), 18,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [79835] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(109), 1,
      anon_sym_STAR,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(1729), 1,
      anon_sym_LBRACE,
    ACTIONS(3764), 1,
      anon_sym_LBRACK,
    ACTIONS(3768), 1,
      sym_number,
    ACTIONS(3914), 1,
      anon_sym_RBRACE,
    ACTIONS(3916), 1,
      anon_sym_async,
    ACTIONS(3918), 1,
      anon_sym_static,
    ACTIONS(3924), 1,
      sym_readonly,
    STATE(1921), 1,
      sym_accessibility_modifier,
    STATE(2874), 1,
      aux_sym_object_repeat1,
    STATE(3210), 1,
      sym_array,
    STATE(3217), 1,
      sym_object,
    ACTIONS(3920), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3922), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2200), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2870), 4,
      sym_assignment_pattern,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    ACTIONS(3912), 11,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [79920] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3418), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3420), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [79967] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(2434), 1,
      anon_sym_DQUOTE,
    ACTIONS(2436), 1,
      anon_sym_SQUOTE,
    ACTIONS(2552), 1,
      anon_sym_DASH,
    ACTIONS(2866), 1,
      anon_sym_LBRACK,
    ACTIONS(3714), 1,
      anon_sym_STAR,
    ACTIONS(3718), 1,
      anon_sym_async,
    ACTIONS(3720), 1,
      sym_number,
    ACTIONS(3722), 1,
      anon_sym_static,
    ACTIONS(3724), 1,
      anon_sym_abstract,
    ACTIONS(3728), 1,
      sym_readonly,
    ACTIONS(3926), 1,
      anon_sym_RBRACE,
    STATE(1885), 1,
      sym_method_definition,
    STATE(1918), 1,
      sym_accessibility_modifier,
    ACTIONS(3726), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1645), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(2876), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1971), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2833), 4,
      sym_public_field_definition,
      sym_method_signature,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(2856), 11,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [80050] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2848), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2852), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [80097] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3261), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3263), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [80144] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3414), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3416), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [80191] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3410), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3412), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [80238] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1617), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1615), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [80285] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(109), 1,
      anon_sym_STAR,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(1729), 1,
      anon_sym_LBRACE,
    ACTIONS(3764), 1,
      anon_sym_LBRACK,
    ACTIONS(3768), 1,
      sym_number,
    ACTIONS(3930), 1,
      anon_sym_RBRACE,
    ACTIONS(3932), 1,
      anon_sym_async,
    ACTIONS(3934), 1,
      anon_sym_static,
    ACTIONS(3940), 1,
      sym_readonly,
    STATE(1921), 1,
      sym_accessibility_modifier,
    STATE(2751), 1,
      aux_sym_object_repeat1,
    STATE(3210), 1,
      sym_array,
    STATE(3217), 1,
      sym_object,
    ACTIONS(3936), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3938), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2200), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2780), 4,
      sym_assignment_pattern,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    ACTIONS(3928), 11,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [80370] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3374), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3376), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [80417] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2201), 1,
      anon_sym_LPAREN,
    STATE(1738), 1,
      sym_arguments,
    ACTIONS(3087), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3089), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [80468] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3178), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3180), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [80515] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3408), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3109), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [80562] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3230), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3103), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [80609] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2313), 1,
      anon_sym_LBRACK,
    ACTIONS(2318), 1,
      anon_sym_DOT,
    ACTIONS(2322), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3942), 1,
      anon_sym_EQ,
    ACTIONS(1111), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1113), 20,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [80663] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1119), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1121), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [80709] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3239), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3241), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [80755] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3378), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3380), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [80801] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1043), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1045), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [80847] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3366), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3368), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [80893] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3265), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3267), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [80939] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1065), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1063), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [80985] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3232), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3033), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [81031] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3274), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3276), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [81077] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3070), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3072), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [81123] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(479), 1,
      anon_sym_BQUOTE,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2975), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3031), 1,
      anon_sym_as,
    ACTIONS(3035), 1,
      anon_sym_BANG,
    ACTIONS(3644), 1,
      anon_sym_LT,
    ACTIONS(3646), 1,
      anon_sym_QMARK,
    ACTIONS(3648), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3654), 1,
      anon_sym_AMP,
    ACTIONS(3656), 1,
      anon_sym_PIPE,
    ACTIONS(3660), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3664), 1,
      anon_sym_QMARK_QMARK,
    STATE(2727), 1,
      sym_type_arguments,
    ACTIONS(3061), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3650), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3658), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1171), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3640), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3652), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3642), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3662), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [81211] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3422), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3424), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [81257] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1033), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1035), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [81303] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1017), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1015), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [81349] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(997), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(999), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [81395] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(955), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(957), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [81441] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1057), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1059), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [81487] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3288), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3290), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [81533] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3370), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3372), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [81579] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2219), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2979), 1,
      anon_sym_EQ,
    ACTIONS(1111), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1113), 20,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [81633] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3358), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3360), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [81679] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(697), 1,
      anon_sym_BQUOTE,
    ACTIONS(2201), 1,
      anon_sym_LPAREN,
    ACTIONS(2633), 1,
      anon_sym_LBRACK,
    ACTIONS(2651), 1,
      anon_sym_DOT,
    ACTIONS(3031), 1,
      anon_sym_as,
    ACTIONS(3035), 1,
      anon_sym_BANG,
    ACTIONS(3324), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3644), 1,
      anon_sym_LT,
    ACTIONS(3646), 1,
      anon_sym_QMARK,
    ACTIONS(3648), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3654), 1,
      anon_sym_AMP,
    ACTIONS(3656), 1,
      anon_sym_PIPE,
    ACTIONS(3660), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3664), 1,
      anon_sym_QMARK_QMARK,
    STATE(2693), 1,
      sym_type_arguments,
    ACTIONS(3061), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3650), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3658), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1746), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3640), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3652), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3642), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3662), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [81767] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2848), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2852), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [81813] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2434), 1,
      anon_sym_DQUOTE,
    ACTIONS(2436), 1,
      anon_sym_SQUOTE,
    ACTIONS(3944), 1,
      anon_sym_STAR,
    ACTIONS(3946), 1,
      anon_sym_EQ,
    ACTIONS(3948), 1,
      anon_sym_LBRACK,
    ACTIONS(3950), 1,
      anon_sym_async,
    ACTIONS(3952), 1,
      sym_number,
    STATE(2854), 1,
      aux_sym_object_repeat1,
    ACTIONS(3954), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1989), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2894), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2856), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [81879] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2219), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2977), 1,
      anon_sym_EQ,
    ACTIONS(1111), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1113), 20,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [81933] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(2197), 1,
      anon_sym_LPAREN,
    ACTIONS(2313), 1,
      anon_sym_LBRACK,
    ACTIONS(2318), 1,
      anon_sym_DOT,
    ACTIONS(3031), 1,
      anon_sym_as,
    ACTIONS(3035), 1,
      anon_sym_BANG,
    ACTIONS(3192), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3644), 1,
      anon_sym_LT,
    ACTIONS(3646), 1,
      anon_sym_QMARK,
    ACTIONS(3648), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3654), 1,
      anon_sym_AMP,
    ACTIONS(3656), 1,
      anon_sym_PIPE,
    ACTIONS(3660), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3664), 1,
      anon_sym_QMARK_QMARK,
    STATE(2746), 1,
      sym_type_arguments,
    ACTIONS(3061), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3650), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3658), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1606), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3640), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3652), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3642), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3662), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [82021] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2434), 1,
      anon_sym_DQUOTE,
    ACTIONS(2436), 1,
      anon_sym_SQUOTE,
    ACTIONS(3944), 1,
      anon_sym_STAR,
    ACTIONS(3946), 1,
      anon_sym_EQ,
    ACTIONS(3950), 1,
      anon_sym_async,
    ACTIONS(3952), 1,
      sym_number,
    ACTIONS(3956), 1,
      anon_sym_LBRACK,
    ACTIONS(3958), 1,
      sym_readonly,
    STATE(2894), 1,
      aux_sym_object_repeat1,
    ACTIONS(3954), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1989), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2894), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2856), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [82089] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3296), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3298), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [82135] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3304), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3306), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [82181] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(3944), 1,
      anon_sym_STAR,
    ACTIONS(3946), 1,
      anon_sym_EQ,
    ACTIONS(3960), 1,
      anon_sym_LBRACK,
    ACTIONS(3962), 1,
      sym_number,
    STATE(2854), 1,
      aux_sym_object_repeat1,
    ACTIONS(3964), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2287), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2894), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1623), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [82245] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1129), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1131), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [82291] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3352), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3354), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [82337] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3115), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3117), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [82383] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3362), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3168), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [82429] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1101), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1103), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [82475] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3300), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3302), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [82521] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3308), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3310), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [82567] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3430), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3432), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [82613] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(969), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(971), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [82659] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(977), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(975), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [82705] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(3944), 1,
      anon_sym_STAR,
    ACTIONS(3946), 1,
      anon_sym_EQ,
    ACTIONS(3960), 1,
      anon_sym_LBRACK,
    ACTIONS(3962), 1,
      sym_number,
    STATE(2806), 1,
      aux_sym_object_repeat1,
    ACTIONS(3964), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2287), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2894), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1623), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [82769] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2313), 1,
      anon_sym_LBRACK,
    ACTIONS(2318), 1,
      anon_sym_DOT,
    ACTIONS(2322), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3966), 1,
      anon_sym_EQ,
    ACTIONS(1111), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1113), 20,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [82823] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2434), 1,
      anon_sym_DQUOTE,
    ACTIONS(2436), 1,
      anon_sym_SQUOTE,
    ACTIONS(3944), 1,
      anon_sym_STAR,
    ACTIONS(3946), 1,
      anon_sym_EQ,
    ACTIONS(3950), 1,
      anon_sym_async,
    ACTIONS(3952), 1,
      sym_number,
    ACTIONS(3956), 1,
      anon_sym_LBRACK,
    ACTIONS(3958), 1,
      sym_readonly,
    STATE(2806), 1,
      aux_sym_object_repeat1,
    ACTIONS(3954), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1989), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2894), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2856), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [82891] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(109), 1,
      anon_sym_STAR,
    ACTIONS(123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(1729), 1,
      anon_sym_LBRACE,
    ACTIONS(3764), 1,
      anon_sym_LBRACK,
    ACTIONS(3768), 1,
      sym_number,
    ACTIONS(3970), 1,
      anon_sym_async,
    ACTIONS(3972), 1,
      anon_sym_static,
    ACTIONS(3978), 1,
      sym_readonly,
    STATE(1921), 1,
      sym_accessibility_modifier,
    STATE(3210), 1,
      sym_array,
    STATE(3217), 1,
      sym_object,
    ACTIONS(2826), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(3974), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3976), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2200), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3011), 4,
      sym_assignment_pattern,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    ACTIONS(3968), 11,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [82971] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(3944), 1,
      anon_sym_STAR,
    ACTIONS(3946), 1,
      anon_sym_EQ,
    ACTIONS(3960), 1,
      anon_sym_LBRACK,
    ACTIONS(3962), 1,
      sym_number,
    STATE(2894), 1,
      aux_sym_object_repeat1,
    ACTIONS(3964), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2287), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2894), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1623), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [83035] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(987), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(989), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [83081] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3292), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3294), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [83127] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1051), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1049), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [83173] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1023), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1025), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [83219] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(981), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(979), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [83265] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1113), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [83311] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2434), 1,
      anon_sym_DQUOTE,
    ACTIONS(2436), 1,
      anon_sym_SQUOTE,
    ACTIONS(3944), 1,
      anon_sym_STAR,
    ACTIONS(3946), 1,
      anon_sym_EQ,
    ACTIONS(3948), 1,
      anon_sym_LBRACK,
    ACTIONS(3950), 1,
      anon_sym_async,
    ACTIONS(3952), 1,
      sym_number,
    STATE(2806), 1,
      aux_sym_object_repeat1,
    ACTIONS(3954), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1989), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2894), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2856), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [83377] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2633), 1,
      anon_sym_LBRACK,
    ACTIONS(2639), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2651), 1,
      anon_sym_DOT,
    ACTIONS(1111), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1113), 20,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [83429] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3261), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3263), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [83475] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3259), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3085), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [83521] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3243), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3245), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [83567] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2434), 1,
      anon_sym_DQUOTE,
    ACTIONS(2436), 1,
      anon_sym_SQUOTE,
    ACTIONS(3944), 1,
      anon_sym_STAR,
    ACTIONS(3946), 1,
      anon_sym_EQ,
    ACTIONS(3950), 1,
      anon_sym_async,
    ACTIONS(3952), 1,
      sym_number,
    ACTIONS(3956), 1,
      anon_sym_LBRACK,
    ACTIONS(3958), 1,
      sym_readonly,
    STATE(2854), 1,
      aux_sym_object_repeat1,
    ACTIONS(3954), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1989), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2894), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2856), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [83635] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1007), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1009), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [83681] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3434), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3436), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [83727] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3253), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3255), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [83773] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3374), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3376), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [83819] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3230), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3103), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [83865] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3408), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3109), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [83911] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3178), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3180), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [83957] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(3944), 1,
      anon_sym_STAR,
    ACTIONS(3946), 1,
      anon_sym_EQ,
    ACTIONS(3960), 1,
      anon_sym_LBRACK,
    ACTIONS(3962), 1,
      sym_number,
    STATE(2868), 1,
      aux_sym_object_repeat1,
    ACTIONS(3964), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2287), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2894), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1623), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [84021] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3410), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3412), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [84067] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3414), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3416), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [84113] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1073), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1071), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [84159] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3257), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3176), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [84205] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2434), 1,
      anon_sym_DQUOTE,
    ACTIONS(2436), 1,
      anon_sym_SQUOTE,
    ACTIONS(3944), 1,
      anon_sym_STAR,
    ACTIONS(3946), 1,
      anon_sym_EQ,
    ACTIONS(3948), 1,
      anon_sym_LBRACK,
    ACTIONS(3950), 1,
      anon_sym_async,
    ACTIONS(3952), 1,
      sym_number,
    STATE(2894), 1,
      aux_sym_object_repeat1,
    ACTIONS(3954), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1989), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2894), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2856), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [84271] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2434), 1,
      anon_sym_DQUOTE,
    ACTIONS(2436), 1,
      anon_sym_SQUOTE,
    ACTIONS(3944), 1,
      anon_sym_STAR,
    ACTIONS(3946), 1,
      anon_sym_EQ,
    ACTIONS(3948), 1,
      anon_sym_LBRACK,
    ACTIONS(3950), 1,
      anon_sym_async,
    ACTIONS(3952), 1,
      sym_number,
    STATE(2868), 1,
      aux_sym_object_repeat1,
    ACTIONS(3954), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1989), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2894), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2856), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [84337] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2434), 1,
      anon_sym_DQUOTE,
    ACTIONS(2436), 1,
      anon_sym_SQUOTE,
    ACTIONS(3944), 1,
      anon_sym_STAR,
    ACTIONS(3946), 1,
      anon_sym_EQ,
    ACTIONS(3950), 1,
      anon_sym_async,
    ACTIONS(3952), 1,
      sym_number,
    ACTIONS(3956), 1,
      anon_sym_LBRACK,
    ACTIONS(3958), 1,
      sym_readonly,
    STATE(2868), 1,
      aux_sym_object_repeat1,
    ACTIONS(3954), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1989), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2894), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2856), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [84405] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3426), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3428), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [84451] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3282), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3284), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [84497] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3278), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3280), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [84543] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1093), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1091), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [84589] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3418), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3420), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [84635] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(3946), 1,
      anon_sym_EQ,
    ACTIONS(3960), 1,
      anon_sym_LBRACK,
    ACTIONS(3962), 1,
      sym_number,
    STATE(2806), 1,
      aux_sym_object_repeat1,
    STATE(2287), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2894), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1623), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [84694] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2434), 1,
      anon_sym_DQUOTE,
    ACTIONS(2436), 1,
      anon_sym_SQUOTE,
    ACTIONS(3944), 1,
      anon_sym_STAR,
    ACTIONS(3946), 1,
      anon_sym_EQ,
    ACTIONS(3948), 1,
      anon_sym_LBRACK,
    ACTIONS(3950), 1,
      anon_sym_async,
    ACTIONS(3952), 1,
      sym_number,
    ACTIONS(2932), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(3954), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1989), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2894), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2856), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [84759] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(3946), 1,
      anon_sym_EQ,
    ACTIONS(3960), 1,
      anon_sym_LBRACK,
    ACTIONS(3962), 1,
      sym_number,
    STATE(2854), 1,
      aux_sym_object_repeat1,
    STATE(2287), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2894), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1623), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [84818] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2434), 1,
      anon_sym_DQUOTE,
    ACTIONS(2436), 1,
      anon_sym_SQUOTE,
    ACTIONS(3948), 1,
      anon_sym_LBRACK,
    ACTIONS(3980), 1,
      anon_sym_STAR,
    ACTIONS(3982), 1,
      anon_sym_async,
    ACTIONS(3984), 1,
      sym_number,
    ACTIONS(3986), 1,
      anon_sym_abstract,
    ACTIONS(3988), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1972), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2894), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2856), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [84881] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2434), 1,
      anon_sym_DQUOTE,
    ACTIONS(2436), 1,
      anon_sym_SQUOTE,
    ACTIONS(3944), 1,
      anon_sym_STAR,
    ACTIONS(3946), 1,
      anon_sym_EQ,
    ACTIONS(3950), 1,
      anon_sym_async,
    ACTIONS(3952), 1,
      sym_number,
    ACTIONS(3956), 1,
      anon_sym_LBRACK,
    ACTIONS(3958), 1,
      sym_readonly,
    ACTIONS(2932), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(3954), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1989), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2894), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2856), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [84948] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(3946), 1,
      anon_sym_EQ,
    ACTIONS(3960), 1,
      anon_sym_LBRACK,
    ACTIONS(3962), 1,
      sym_number,
    STATE(2868), 1,
      aux_sym_object_repeat1,
    STATE(2287), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2894), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1623), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [85007] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(3944), 1,
      anon_sym_STAR,
    ACTIONS(3946), 1,
      anon_sym_EQ,
    ACTIONS(3960), 1,
      anon_sym_LBRACK,
    ACTIONS(3962), 1,
      sym_number,
    ACTIONS(2932), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(3964), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2287), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2894), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1623), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [85070] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2434), 1,
      anon_sym_DQUOTE,
    ACTIONS(2436), 1,
      anon_sym_SQUOTE,
    ACTIONS(3956), 1,
      anon_sym_LBRACK,
    ACTIONS(3990), 1,
      anon_sym_STAR,
    ACTIONS(3992), 1,
      anon_sym_async,
    ACTIONS(3994), 1,
      sym_number,
    ACTIONS(3996), 1,
      anon_sym_abstract,
    ACTIONS(3998), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1976), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2894), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2856), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [85133] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2219), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2979), 1,
      anon_sym_EQ,
    ACTIONS(3704), 1,
      anon_sym_in,
    ACTIONS(3707), 1,
      anon_sym_of,
    ACTIONS(1111), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1113), 18,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [85190] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(3946), 1,
      anon_sym_EQ,
    ACTIONS(3960), 1,
      anon_sym_LBRACK,
    ACTIONS(3962), 1,
      sym_number,
    STATE(2894), 1,
      aux_sym_object_repeat1,
    STATE(2287), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2894), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1623), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [85249] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2219), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2977), 1,
      anon_sym_EQ,
    ACTIONS(3629), 1,
      anon_sym_in,
    ACTIONS(3632), 1,
      anon_sym_of,
    ACTIONS(1111), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1113), 18,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [85306] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2219), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2977), 1,
      anon_sym_EQ,
    ACTIONS(3147), 1,
      anon_sym_in,
    ACTIONS(3150), 1,
      anon_sym_of,
    ACTIONS(1111), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1113), 18,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [85363] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2215), 1,
      anon_sym_LBRACK,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2219), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2979), 1,
      anon_sym_EQ,
    ACTIONS(3138), 1,
      anon_sym_in,
    ACTIONS(3141), 1,
      anon_sym_of,
    ACTIONS(1111), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1113), 18,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [85420] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(3960), 1,
      anon_sym_LBRACK,
    ACTIONS(4000), 1,
      anon_sym_STAR,
    ACTIONS(4002), 1,
      sym_number,
    ACTIONS(4004), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2313), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2894), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1623), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [85478] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2434), 1,
      anon_sym_DQUOTE,
    ACTIONS(2436), 1,
      anon_sym_SQUOTE,
    ACTIONS(3956), 1,
      anon_sym_LBRACK,
    ACTIONS(4006), 1,
      anon_sym_STAR,
    ACTIONS(4008), 1,
      anon_sym_async,
    ACTIONS(4010), 1,
      sym_number,
    ACTIONS(4012), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1993), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2894), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2856), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [85538] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2434), 1,
      anon_sym_DQUOTE,
    ACTIONS(2436), 1,
      anon_sym_SQUOTE,
    ACTIONS(3956), 1,
      anon_sym_LBRACK,
    ACTIONS(4000), 1,
      anon_sym_STAR,
    ACTIONS(4014), 1,
      anon_sym_async,
    ACTIONS(4016), 1,
      sym_number,
    ACTIONS(4020), 1,
      sym_readonly,
    ACTIONS(4018), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1984), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2894), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2856), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [85600] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(3960), 1,
      anon_sym_LBRACK,
    ACTIONS(3990), 1,
      anon_sym_STAR,
    ACTIONS(4022), 1,
      sym_number,
    ACTIONS(4024), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2265), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2894), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1623), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [85658] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2434), 1,
      anon_sym_DQUOTE,
    ACTIONS(2436), 1,
      anon_sym_SQUOTE,
    ACTIONS(3956), 1,
      anon_sym_LBRACK,
    ACTIONS(3990), 1,
      anon_sym_STAR,
    ACTIONS(3992), 1,
      anon_sym_async,
    ACTIONS(3994), 1,
      sym_number,
    ACTIONS(3998), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1976), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2894), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2856), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [85718] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(3960), 1,
      anon_sym_LBRACK,
    ACTIONS(3980), 1,
      anon_sym_STAR,
    ACTIONS(4026), 1,
      sym_number,
    ACTIONS(4028), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2351), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2894), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1623), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [85776] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2434), 1,
      anon_sym_DQUOTE,
    ACTIONS(2436), 1,
      anon_sym_SQUOTE,
    ACTIONS(3956), 1,
      anon_sym_LBRACK,
    ACTIONS(4030), 1,
      anon_sym_STAR,
    ACTIONS(4032), 1,
      anon_sym_async,
    ACTIONS(4034), 1,
      sym_number,
    ACTIONS(4038), 1,
      sym_readonly,
    ACTIONS(4036), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1991), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2894), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2856), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [85838] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2434), 1,
      anon_sym_DQUOTE,
    ACTIONS(2436), 1,
      anon_sym_SQUOTE,
    ACTIONS(3948), 1,
      anon_sym_LBRACK,
    ACTIONS(4000), 1,
      anon_sym_STAR,
    ACTIONS(4014), 1,
      anon_sym_async,
    ACTIONS(4016), 1,
      sym_number,
    ACTIONS(4018), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1984), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2894), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2856), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [85898] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(3960), 1,
      anon_sym_LBRACK,
    ACTIONS(4030), 1,
      anon_sym_STAR,
    ACTIONS(4040), 1,
      sym_number,
    ACTIONS(4042), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2289), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2894), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1623), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [85956] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2434), 1,
      anon_sym_DQUOTE,
    ACTIONS(2436), 1,
      anon_sym_SQUOTE,
    ACTIONS(3956), 1,
      anon_sym_LBRACK,
    ACTIONS(4006), 1,
      anon_sym_STAR,
    ACTIONS(4008), 1,
      anon_sym_async,
    ACTIONS(4010), 1,
      sym_number,
    ACTIONS(4044), 1,
      sym_readonly,
    ACTIONS(4012), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1993), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2894), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2856), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [86018] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(3960), 1,
      anon_sym_LBRACK,
    ACTIONS(4046), 1,
      anon_sym_STAR,
    ACTIONS(4048), 1,
      sym_number,
    ACTIONS(4050), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2291), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2894), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1623), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [86076] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(3960), 1,
      anon_sym_LBRACK,
    ACTIONS(4052), 1,
      anon_sym_STAR,
    ACTIONS(4054), 1,
      sym_number,
    ACTIONS(4056), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2368), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2894), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1623), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [86134] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(3960), 1,
      anon_sym_LBRACK,
    ACTIONS(4058), 1,
      anon_sym_STAR,
    ACTIONS(4060), 1,
      sym_number,
    ACTIONS(4062), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2294), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2894), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1623), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [86192] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(3960), 1,
      anon_sym_LBRACK,
    ACTIONS(4064), 1,
      anon_sym_STAR,
    ACTIONS(4066), 1,
      sym_number,
    ACTIONS(4068), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2317), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2894), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1623), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [86250] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(3960), 1,
      anon_sym_LBRACK,
    ACTIONS(4006), 1,
      anon_sym_STAR,
    ACTIONS(4070), 1,
      sym_number,
    ACTIONS(4072), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2261), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2894), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1623), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [86308] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2434), 1,
      anon_sym_DQUOTE,
    ACTIONS(2436), 1,
      anon_sym_SQUOTE,
    ACTIONS(3956), 1,
      anon_sym_LBRACK,
    ACTIONS(4046), 1,
      anon_sym_STAR,
    ACTIONS(4074), 1,
      anon_sym_async,
    ACTIONS(4076), 1,
      sym_number,
    ACTIONS(4078), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1992), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2894), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2856), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [86368] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1673), 5,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
    ACTIONS(2894), 11,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1671), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [86414] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2434), 1,
      anon_sym_DQUOTE,
    ACTIONS(2436), 1,
      anon_sym_SQUOTE,
    ACTIONS(3956), 1,
      anon_sym_LBRACK,
    ACTIONS(4064), 1,
      anon_sym_STAR,
    ACTIONS(4080), 1,
      anon_sym_async,
    ACTIONS(4082), 1,
      sym_number,
    ACTIONS(4084), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1977), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2894), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2856), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [86474] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2434), 1,
      anon_sym_DQUOTE,
    ACTIONS(2436), 1,
      anon_sym_SQUOTE,
    ACTIONS(3956), 1,
      anon_sym_LBRACK,
    ACTIONS(3990), 1,
      anon_sym_STAR,
    ACTIONS(3992), 1,
      anon_sym_async,
    ACTIONS(3994), 1,
      sym_number,
    ACTIONS(4086), 1,
      sym_readonly,
    ACTIONS(3998), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1976), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2894), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2856), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [86536] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2434), 1,
      anon_sym_DQUOTE,
    ACTIONS(2436), 1,
      anon_sym_SQUOTE,
    ACTIONS(3956), 1,
      anon_sym_LBRACK,
    ACTIONS(4030), 1,
      anon_sym_STAR,
    ACTIONS(4032), 1,
      anon_sym_async,
    ACTIONS(4034), 1,
      sym_number,
    ACTIONS(4036), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1991), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2894), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2856), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [86596] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(3960), 1,
      anon_sym_LBRACK,
    ACTIONS(4088), 1,
      anon_sym_STAR,
    ACTIONS(4090), 1,
      sym_number,
    ACTIONS(4092), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2303), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2894), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1623), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [86654] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2434), 1,
      anon_sym_DQUOTE,
    ACTIONS(2436), 1,
      anon_sym_SQUOTE,
    ACTIONS(3956), 1,
      anon_sym_LBRACK,
    ACTIONS(3980), 1,
      anon_sym_STAR,
    ACTIONS(3982), 1,
      anon_sym_async,
    ACTIONS(3984), 1,
      sym_number,
    ACTIONS(4094), 1,
      sym_readonly,
    ACTIONS(3988), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1972), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2894), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2856), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [86716] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2434), 1,
      anon_sym_DQUOTE,
    ACTIONS(2436), 1,
      anon_sym_SQUOTE,
    ACTIONS(3956), 1,
      anon_sym_LBRACK,
    ACTIONS(4088), 1,
      anon_sym_STAR,
    ACTIONS(4096), 1,
      anon_sym_async,
    ACTIONS(4098), 1,
      sym_number,
    ACTIONS(4100), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1990), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2894), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2856), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [86776] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(3946), 1,
      anon_sym_EQ,
    ACTIONS(3960), 1,
      anon_sym_LBRACK,
    ACTIONS(3962), 1,
      sym_number,
    ACTIONS(2932), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(2287), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2894), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1623), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [86834] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(3960), 1,
      anon_sym_LBRACK,
    ACTIONS(4102), 1,
      anon_sym_STAR,
    ACTIONS(4104), 1,
      sym_number,
    ACTIONS(4106), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2359), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2894), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1623), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [86892] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(459), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1729), 1,
      anon_sym_LBRACE,
    ACTIONS(4110), 1,
      anon_sym_RPAREN,
    ACTIONS(4112), 1,
      anon_sym_LBRACK,
    ACTIONS(4114), 1,
      sym_readonly,
    STATE(1838), 1,
      aux_sym_export_statement_repeat1,
    STATE(1945), 1,
      sym_decorator,
    STATE(1951), 1,
      sym_accessibility_modifier,
    STATE(2186), 1,
      sym__parameter_name,
    STATE(2487), 1,
      sym_array,
    STATE(2505), 1,
      sym_object,
    STATE(2734), 1,
      sym__rest_identifier,
    ACTIONS(4108), 2,
      sym_identifier,
      sym_this,
    ACTIONS(1659), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2954), 3,
      sym_rest_parameter,
      sym_required_parameter,
      sym_optional_parameter,
    ACTIONS(1647), 14,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [86965] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(3960), 1,
      anon_sym_LBRACK,
    ACTIONS(4104), 1,
      sym_number,
    STATE(2359), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2894), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1623), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [87018] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(1435), 1,
      sym_number,
    ACTIONS(1625), 1,
      anon_sym_async,
    ACTIONS(3946), 1,
      anon_sym_EQ,
    ACTIONS(3960), 1,
      anon_sym_LBRACK,
    ACTIONS(4116), 1,
      anon_sym_STAR,
    ACTIONS(4118), 1,
      anon_sym_RBRACE,
    STATE(2873), 1,
      aux_sym_object_repeat1,
    ACTIONS(1627), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2332), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2894), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1623), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [87085] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(1435), 1,
      sym_number,
    ACTIONS(1625), 1,
      anon_sym_async,
    ACTIONS(3946), 1,
      anon_sym_EQ,
    ACTIONS(3960), 1,
      anon_sym_LBRACK,
    ACTIONS(4116), 1,
      anon_sym_STAR,
    ACTIONS(4120), 1,
      anon_sym_RBRACE,
    STATE(2806), 1,
      aux_sym_object_repeat1,
    ACTIONS(1627), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2332), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2894), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1623), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [87152] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(459), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1729), 1,
      anon_sym_LBRACE,
    ACTIONS(4112), 1,
      anon_sym_LBRACK,
    ACTIONS(4114), 1,
      sym_readonly,
    ACTIONS(4122), 1,
      anon_sym_RPAREN,
    STATE(1838), 1,
      aux_sym_export_statement_repeat1,
    STATE(1945), 1,
      sym_decorator,
    STATE(1951), 1,
      sym_accessibility_modifier,
    STATE(2186), 1,
      sym__parameter_name,
    STATE(2487), 1,
      sym_array,
    STATE(2505), 1,
      sym_object,
    STATE(2734), 1,
      sym__rest_identifier,
    ACTIONS(4108), 2,
      sym_identifier,
      sym_this,
    ACTIONS(1659), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2954), 3,
      sym_rest_parameter,
      sym_required_parameter,
      sym_optional_parameter,
    ACTIONS(1647), 14,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [87225] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(1435), 1,
      sym_number,
    ACTIONS(1625), 1,
      anon_sym_async,
    ACTIONS(1629), 1,
      sym_readonly,
    ACTIONS(3946), 1,
      anon_sym_EQ,
    ACTIONS(3960), 1,
      anon_sym_LBRACK,
    ACTIONS(4116), 1,
      anon_sym_STAR,
    ACTIONS(4120), 1,
      anon_sym_RBRACE,
    STATE(2806), 1,
      aux_sym_object_repeat1,
    ACTIONS(1627), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2332), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2894), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1623), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [87294] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(1435), 1,
      sym_number,
    ACTIONS(3946), 1,
      anon_sym_EQ,
    ACTIONS(3960), 1,
      anon_sym_LBRACK,
    ACTIONS(4116), 1,
      anon_sym_STAR,
    ACTIONS(4120), 1,
      anon_sym_RBRACE,
    STATE(2806), 1,
      aux_sym_object_repeat1,
    ACTIONS(1627), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2332), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2894), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1623), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [87359] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2434), 1,
      anon_sym_DQUOTE,
    ACTIONS(2436), 1,
      anon_sym_SQUOTE,
    ACTIONS(3956), 1,
      anon_sym_LBRACK,
    ACTIONS(4124), 1,
      sym_number,
    STATE(2081), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2894), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2856), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [87412] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(3960), 1,
      anon_sym_LBRACK,
    ACTIONS(4126), 1,
      sym_number,
    STATE(2328), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2894), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1623), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [87465] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3946), 1,
      anon_sym_EQ,
    STATE(2854), 1,
      aux_sym_object_repeat1,
    ACTIONS(1673), 5,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
    ACTIONS(2894), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1671), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [87514] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(459), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1729), 1,
      anon_sym_LBRACE,
    ACTIONS(4112), 1,
      anon_sym_LBRACK,
    ACTIONS(4114), 1,
      sym_readonly,
    ACTIONS(4128), 1,
      anon_sym_RPAREN,
    STATE(1848), 1,
      aux_sym_export_statement_repeat1,
    STATE(1945), 1,
      sym_decorator,
    STATE(1951), 1,
      sym_accessibility_modifier,
    STATE(2186), 1,
      sym__parameter_name,
    STATE(2487), 1,
      sym_array,
    STATE(2505), 1,
      sym_object,
    STATE(2734), 1,
      sym__rest_identifier,
    ACTIONS(4108), 2,
      sym_identifier,
      sym_this,
    ACTIONS(1659), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2901), 3,
      sym_rest_parameter,
      sym_required_parameter,
      sym_optional_parameter,
    ACTIONS(1647), 14,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [87587] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(1435), 1,
      sym_number,
    ACTIONS(1625), 1,
      anon_sym_async,
    ACTIONS(1629), 1,
      sym_readonly,
    ACTIONS(3946), 1,
      anon_sym_EQ,
    ACTIONS(3960), 1,
      anon_sym_LBRACK,
    ACTIONS(4116), 1,
      anon_sym_STAR,
    ACTIONS(4118), 1,
      anon_sym_RBRACE,
    STATE(2873), 1,
      aux_sym_object_repeat1,
    ACTIONS(1627), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2332), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2894), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1623), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [87656] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(3960), 1,
      anon_sym_LBRACK,
    ACTIONS(4060), 1,
      sym_number,
    STATE(2294), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2894), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1623), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [87709] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(1205), 1,
      anon_sym_RBRACE,
    ACTIONS(1435), 1,
      sym_number,
    ACTIONS(3946), 1,
      anon_sym_EQ,
    ACTIONS(3960), 1,
      anon_sym_LBRACK,
    ACTIONS(4116), 1,
      anon_sym_STAR,
    STATE(2894), 1,
      aux_sym_object_repeat1,
    ACTIONS(1627), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2332), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2894), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1623), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [87774] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(459), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1729), 1,
      anon_sym_LBRACE,
    ACTIONS(4112), 1,
      anon_sym_LBRACK,
    ACTIONS(4114), 1,
      sym_readonly,
    ACTIONS(4130), 1,
      anon_sym_RPAREN,
    STATE(1838), 1,
      aux_sym_export_statement_repeat1,
    STATE(1945), 1,
      sym_decorator,
    STATE(1951), 1,
      sym_accessibility_modifier,
    STATE(2186), 1,
      sym__parameter_name,
    STATE(2487), 1,
      sym_array,
    STATE(2505), 1,
      sym_object,
    STATE(2734), 1,
      sym__rest_identifier,
    ACTIONS(4108), 2,
      sym_identifier,
      sym_this,
    ACTIONS(1659), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2954), 3,
      sym_rest_parameter,
      sym_required_parameter,
      sym_optional_parameter,
    ACTIONS(1647), 14,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [87847] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(1205), 1,
      anon_sym_RBRACE,
    ACTIONS(1435), 1,
      sym_number,
    ACTIONS(1625), 1,
      anon_sym_async,
    ACTIONS(1629), 1,
      sym_readonly,
    ACTIONS(3946), 1,
      anon_sym_EQ,
    ACTIONS(3960), 1,
      anon_sym_LBRACK,
    ACTIONS(4116), 1,
      anon_sym_STAR,
    STATE(2894), 1,
      aux_sym_object_repeat1,
    ACTIONS(1627), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2332), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2894), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1623), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [87916] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(3960), 1,
      anon_sym_LBRACK,
    ACTIONS(4048), 1,
      sym_number,
    STATE(2291), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2894), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1623), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [87969] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(3960), 1,
      anon_sym_LBRACK,
    ACTIONS(4040), 1,
      sym_number,
    STATE(2289), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2894), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1623), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [88022] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(1205), 1,
      anon_sym_RBRACE,
    ACTIONS(1435), 1,
      sym_number,
    ACTIONS(1625), 1,
      anon_sym_async,
    ACTIONS(3946), 1,
      anon_sym_EQ,
    ACTIONS(3960), 1,
      anon_sym_LBRACK,
    ACTIONS(4116), 1,
      anon_sym_STAR,
    STATE(2894), 1,
      aux_sym_object_repeat1,
    ACTIONS(1627), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2332), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2894), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1623), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [88089] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3946), 1,
      anon_sym_EQ,
    STATE(2894), 1,
      aux_sym_object_repeat1,
    ACTIONS(1673), 5,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
    ACTIONS(2894), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1671), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [88138] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(459), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1729), 1,
      anon_sym_LBRACE,
    ACTIONS(4112), 1,
      anon_sym_LBRACK,
    ACTIONS(4114), 1,
      sym_readonly,
    ACTIONS(4132), 1,
      anon_sym_RPAREN,
    STATE(1838), 1,
      aux_sym_export_statement_repeat1,
    STATE(1945), 1,
      sym_decorator,
    STATE(1951), 1,
      sym_accessibility_modifier,
    STATE(2186), 1,
      sym__parameter_name,
    STATE(2487), 1,
      sym_array,
    STATE(2505), 1,
      sym_object,
    STATE(2734), 1,
      sym__rest_identifier,
    ACTIONS(4108), 2,
      sym_identifier,
      sym_this,
    ACTIONS(1659), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2954), 3,
      sym_rest_parameter,
      sym_required_parameter,
      sym_optional_parameter,
    ACTIONS(1647), 14,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [88211] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(3960), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      sym_number,
    STATE(2313), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2894), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1623), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [88264] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3946), 1,
      anon_sym_EQ,
    STATE(2868), 1,
      aux_sym_object_repeat1,
    ACTIONS(1673), 5,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
    ACTIONS(2894), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1671), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [88313] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(459), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1729), 1,
      anon_sym_LBRACE,
    ACTIONS(4112), 1,
      anon_sym_LBRACK,
    ACTIONS(4114), 1,
      sym_readonly,
    ACTIONS(4134), 1,
      anon_sym_RPAREN,
    STATE(1838), 1,
      aux_sym_export_statement_repeat1,
    STATE(1945), 1,
      sym_decorator,
    STATE(1951), 1,
      sym_accessibility_modifier,
    STATE(2186), 1,
      sym__parameter_name,
    STATE(2487), 1,
      sym_array,
    STATE(2505), 1,
      sym_object,
    STATE(2734), 1,
      sym__rest_identifier,
    ACTIONS(4108), 2,
      sym_identifier,
      sym_this,
    ACTIONS(1659), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2954), 3,
      sym_rest_parameter,
      sym_required_parameter,
      sym_optional_parameter,
    ACTIONS(1647), 14,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [88386] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(1435), 1,
      sym_number,
    ACTIONS(3946), 1,
      anon_sym_EQ,
    ACTIONS(3960), 1,
      anon_sym_LBRACK,
    ACTIONS(4116), 1,
      anon_sym_STAR,
    ACTIONS(4118), 1,
      anon_sym_RBRACE,
    STATE(2873), 1,
      aux_sym_object_repeat1,
    ACTIONS(1627), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2332), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2894), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1623), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [88451] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(3960), 1,
      anon_sym_LBRACK,
    ACTIONS(4070), 1,
      sym_number,
    STATE(2261), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2894), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1623), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [88504] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(3960), 1,
      anon_sym_LBRACK,
    ACTIONS(4022), 1,
      sym_number,
    STATE(2265), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2894), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1623), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [88557] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4140), 1,
      anon_sym_LPAREN,
    ACTIONS(4142), 1,
      anon_sym_DOT,
    STATE(1858), 1,
      sym_arguments,
    ACTIONS(4138), 10,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(4136), 22,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_class,
      anon_sym_async,
      sym_identifier,
      sym_this,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [88606] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(459), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1729), 1,
      anon_sym_LBRACE,
    ACTIONS(4112), 1,
      anon_sym_LBRACK,
    ACTIONS(4114), 1,
      sym_readonly,
    ACTIONS(4144), 1,
      anon_sym_RPAREN,
    STATE(1838), 1,
      aux_sym_export_statement_repeat1,
    STATE(1945), 1,
      sym_decorator,
    STATE(1951), 1,
      sym_accessibility_modifier,
    STATE(2186), 1,
      sym__parameter_name,
    STATE(2487), 1,
      sym_array,
    STATE(2505), 1,
      sym_object,
    STATE(2734), 1,
      sym__rest_identifier,
    ACTIONS(4108), 2,
      sym_identifier,
      sym_this,
    ACTIONS(1659), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2954), 3,
      sym_rest_parameter,
      sym_required_parameter,
      sym_optional_parameter,
    ACTIONS(1647), 14,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [88679] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(3960), 1,
      anon_sym_LBRACK,
    ACTIONS(4026), 1,
      sym_number,
    STATE(2351), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2894), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1623), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [88732] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(459), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1729), 1,
      anon_sym_LBRACE,
    ACTIONS(4112), 1,
      anon_sym_LBRACK,
    ACTIONS(4114), 1,
      sym_readonly,
    ACTIONS(4146), 1,
      anon_sym_RPAREN,
    STATE(1836), 1,
      aux_sym_export_statement_repeat1,
    STATE(1945), 1,
      sym_decorator,
    STATE(1951), 1,
      sym_accessibility_modifier,
    STATE(2186), 1,
      sym__parameter_name,
    STATE(2487), 1,
      sym_array,
    STATE(2505), 1,
      sym_object,
    STATE(2734), 1,
      sym__rest_identifier,
    ACTIONS(4108), 2,
      sym_identifier,
      sym_this,
    ACTIONS(1659), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2918), 3,
      sym_rest_parameter,
      sym_required_parameter,
      sym_optional_parameter,
    ACTIONS(1647), 14,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [88805] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(459), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1729), 1,
      anon_sym_LBRACE,
    ACTIONS(4112), 1,
      anon_sym_LBRACK,
    ACTIONS(4114), 1,
      sym_readonly,
    ACTIONS(4148), 1,
      anon_sym_RPAREN,
    STATE(1838), 1,
      aux_sym_export_statement_repeat1,
    STATE(1945), 1,
      sym_decorator,
    STATE(1951), 1,
      sym_accessibility_modifier,
    STATE(2186), 1,
      sym__parameter_name,
    STATE(2487), 1,
      sym_array,
    STATE(2505), 1,
      sym_object,
    STATE(2734), 1,
      sym__rest_identifier,
    ACTIONS(4108), 2,
      sym_identifier,
      sym_this,
    ACTIONS(1659), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2954), 3,
      sym_rest_parameter,
      sym_required_parameter,
      sym_optional_parameter,
    ACTIONS(1647), 14,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [88878] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(441), 1,
      anon_sym_RPAREN,
    ACTIONS(459), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1729), 1,
      anon_sym_LBRACE,
    ACTIONS(4112), 1,
      anon_sym_LBRACK,
    ACTIONS(4114), 1,
      sym_readonly,
    STATE(1844), 1,
      aux_sym_export_statement_repeat1,
    STATE(1945), 1,
      sym_decorator,
    STATE(1951), 1,
      sym_accessibility_modifier,
    STATE(2186), 1,
      sym__parameter_name,
    STATE(2487), 1,
      sym_array,
    STATE(2505), 1,
      sym_object,
    STATE(2734), 1,
      sym__rest_identifier,
    ACTIONS(4108), 2,
      sym_identifier,
      sym_this,
    ACTIONS(1659), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2909), 3,
      sym_rest_parameter,
      sym_required_parameter,
      sym_optional_parameter,
    ACTIONS(1647), 14,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [88951] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(3960), 1,
      anon_sym_LBRACK,
    ACTIONS(4066), 1,
      sym_number,
    STATE(2317), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2894), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1623), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [89004] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(459), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1729), 1,
      anon_sym_LBRACE,
    ACTIONS(4112), 1,
      anon_sym_LBRACK,
    ACTIONS(4114), 1,
      sym_readonly,
    ACTIONS(4150), 1,
      anon_sym_RPAREN,
    STATE(1838), 1,
      aux_sym_export_statement_repeat1,
    STATE(1945), 1,
      sym_decorator,
    STATE(1951), 1,
      sym_accessibility_modifier,
    STATE(2186), 1,
      sym__parameter_name,
    STATE(2487), 1,
      sym_array,
    STATE(2505), 1,
      sym_object,
    STATE(2734), 1,
      sym__rest_identifier,
    ACTIONS(4108), 2,
      sym_identifier,
      sym_this,
    ACTIONS(1659), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2954), 3,
      sym_rest_parameter,
      sym_required_parameter,
      sym_optional_parameter,
    ACTIONS(1647), 14,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [89077] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2434), 1,
      anon_sym_DQUOTE,
    ACTIONS(2436), 1,
      anon_sym_SQUOTE,
    ACTIONS(3956), 1,
      anon_sym_LBRACK,
    ACTIONS(4152), 1,
      sym_number,
    STATE(2103), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2894), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2856), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [89130] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(1246), 1,
      anon_sym_RBRACE,
    ACTIONS(1435), 1,
      sym_number,
    ACTIONS(1625), 1,
      anon_sym_async,
    ACTIONS(3946), 1,
      anon_sym_EQ,
    ACTIONS(3960), 1,
      anon_sym_LBRACK,
    ACTIONS(4116), 1,
      anon_sym_STAR,
    STATE(2868), 1,
      aux_sym_object_repeat1,
    ACTIONS(1627), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2332), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2894), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1623), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [89197] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(459), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1729), 1,
      anon_sym_LBRACE,
    ACTIONS(4112), 1,
      anon_sym_LBRACK,
    ACTIONS(4114), 1,
      sym_readonly,
    ACTIONS(4154), 1,
      anon_sym_class,
    STATE(1915), 1,
      aux_sym_export_statement_repeat1,
    STATE(1945), 1,
      sym_decorator,
    STATE(1951), 1,
      sym_accessibility_modifier,
    STATE(2186), 1,
      sym__parameter_name,
    STATE(2487), 1,
      sym_array,
    STATE(2505), 1,
      sym_object,
    STATE(2734), 1,
      sym__rest_identifier,
    ACTIONS(4108), 2,
      sym_identifier,
      sym_this,
    ACTIONS(1659), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2778), 3,
      sym_rest_parameter,
      sym_required_parameter,
      sym_optional_parameter,
    ACTIONS(1647), 14,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [89270] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(3960), 1,
      anon_sym_LBRACK,
    ACTIONS(4054), 1,
      sym_number,
    STATE(2368), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2894), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1623), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [89323] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3946), 1,
      anon_sym_EQ,
    STATE(2806), 1,
      aux_sym_object_repeat1,
    ACTIONS(1673), 5,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
    ACTIONS(2894), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1671), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [89372] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(1248), 1,
      anon_sym_RBRACE,
    ACTIONS(1435), 1,
      sym_number,
    ACTIONS(3946), 1,
      anon_sym_EQ,
    ACTIONS(3960), 1,
      anon_sym_LBRACK,
    ACTIONS(4116), 1,
      anon_sym_STAR,
    STATE(2854), 1,
      aux_sym_object_repeat1,
    ACTIONS(1627), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2332), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2894), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1623), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [89437] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(1246), 1,
      anon_sym_RBRACE,
    ACTIONS(1435), 1,
      sym_number,
    ACTIONS(1625), 1,
      anon_sym_async,
    ACTIONS(1629), 1,
      sym_readonly,
    ACTIONS(3946), 1,
      anon_sym_EQ,
    ACTIONS(3960), 1,
      anon_sym_LBRACK,
    ACTIONS(4116), 1,
      anon_sym_STAR,
    STATE(2868), 1,
      aux_sym_object_repeat1,
    ACTIONS(1627), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2332), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2894), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1623), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [89506] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(1246), 1,
      anon_sym_RBRACE,
    ACTIONS(1435), 1,
      sym_number,
    ACTIONS(3946), 1,
      anon_sym_EQ,
    ACTIONS(3960), 1,
      anon_sym_LBRACK,
    ACTIONS(4116), 1,
      anon_sym_STAR,
    STATE(2868), 1,
      aux_sym_object_repeat1,
    ACTIONS(1627), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2332), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2894), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1623), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [89571] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(1248), 1,
      anon_sym_RBRACE,
    ACTIONS(1435), 1,
      sym_number,
    ACTIONS(1625), 1,
      anon_sym_async,
    ACTIONS(1629), 1,
      sym_readonly,
    ACTIONS(3946), 1,
      anon_sym_EQ,
    ACTIONS(3960), 1,
      anon_sym_LBRACK,
    ACTIONS(4116), 1,
      anon_sym_STAR,
    STATE(2854), 1,
      aux_sym_object_repeat1,
    ACTIONS(1627), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2332), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2894), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1623), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [89640] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(459), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1729), 1,
      anon_sym_LBRACE,
    ACTIONS(4112), 1,
      anon_sym_LBRACK,
    ACTIONS(4114), 1,
      sym_readonly,
    ACTIONS(4156), 1,
      anon_sym_RPAREN,
    STATE(1838), 1,
      aux_sym_export_statement_repeat1,
    STATE(1945), 1,
      sym_decorator,
    STATE(1951), 1,
      sym_accessibility_modifier,
    STATE(2186), 1,
      sym__parameter_name,
    STATE(2487), 1,
      sym_array,
    STATE(2505), 1,
      sym_object,
    STATE(2734), 1,
      sym__rest_identifier,
    ACTIONS(4108), 2,
      sym_identifier,
      sym_this,
    ACTIONS(1659), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2954), 3,
      sym_rest_parameter,
      sym_required_parameter,
      sym_optional_parameter,
    ACTIONS(1647), 14,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [89713] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(3960), 1,
      anon_sym_LBRACK,
    ACTIONS(4090), 1,
      sym_number,
    STATE(2303), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2894), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1623), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [89766] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(1248), 1,
      anon_sym_RBRACE,
    ACTIONS(1435), 1,
      sym_number,
    ACTIONS(1625), 1,
      anon_sym_async,
    ACTIONS(3946), 1,
      anon_sym_EQ,
    ACTIONS(3960), 1,
      anon_sym_LBRACK,
    ACTIONS(4116), 1,
      anon_sym_STAR,
    STATE(2854), 1,
      aux_sym_object_repeat1,
    ACTIONS(1627), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2332), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2894), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1623), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [89833] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(3960), 1,
      anon_sym_LBRACK,
    ACTIONS(4158), 1,
      sym_number,
    STATE(2267), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2894), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1623), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [89886] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(1248), 1,
      anon_sym_RBRACE,
    ACTIONS(1435), 1,
      sym_number,
    ACTIONS(3946), 1,
      anon_sym_EQ,
    ACTIONS(3960), 1,
      anon_sym_LBRACK,
    STATE(2854), 1,
      aux_sym_object_repeat1,
    STATE(2332), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2894), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1623), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [89946] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(459), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1729), 1,
      anon_sym_LBRACE,
    ACTIONS(4112), 1,
      anon_sym_LBRACK,
    ACTIONS(4114), 1,
      sym_readonly,
    STATE(1915), 1,
      aux_sym_export_statement_repeat1,
    STATE(1945), 1,
      sym_decorator,
    STATE(1951), 1,
      sym_accessibility_modifier,
    STATE(2186), 1,
      sym__parameter_name,
    STATE(2487), 1,
      sym_array,
    STATE(2505), 1,
      sym_object,
    STATE(2734), 1,
      sym__rest_identifier,
    ACTIONS(4108), 2,
      sym_identifier,
      sym_this,
    ACTIONS(1659), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2808), 3,
      sym_rest_parameter,
      sym_required_parameter,
      sym_optional_parameter,
    ACTIONS(1647), 14,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [90016] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(1205), 1,
      anon_sym_RBRACE,
    ACTIONS(1435), 1,
      sym_number,
    ACTIONS(3946), 1,
      anon_sym_EQ,
    ACTIONS(3960), 1,
      anon_sym_LBRACK,
    STATE(2894), 1,
      aux_sym_object_repeat1,
    STATE(2332), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2894), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1623), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [90076] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(459), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1729), 1,
      anon_sym_LBRACE,
    ACTIONS(4112), 1,
      anon_sym_LBRACK,
    ACTIONS(4114), 1,
      sym_readonly,
    STATE(1915), 1,
      aux_sym_export_statement_repeat1,
    STATE(1945), 1,
      sym_decorator,
    STATE(1951), 1,
      sym_accessibility_modifier,
    STATE(2186), 1,
      sym__parameter_name,
    STATE(2487), 1,
      sym_array,
    STATE(2505), 1,
      sym_object,
    STATE(2734), 1,
      sym__rest_identifier,
    ACTIONS(4108), 2,
      sym_identifier,
      sym_this,
    ACTIONS(1659), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2946), 3,
      sym_rest_parameter,
      sym_required_parameter,
      sym_optional_parameter,
    ACTIONS(1647), 14,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [90146] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(1435), 1,
      sym_number,
    ACTIONS(3946), 1,
      anon_sym_EQ,
    ACTIONS(3960), 1,
      anon_sym_LBRACK,
    ACTIONS(4120), 1,
      anon_sym_RBRACE,
    STATE(2806), 1,
      aux_sym_object_repeat1,
    STATE(2332), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2894), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1623), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [90206] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(459), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1729), 1,
      anon_sym_LBRACE,
    ACTIONS(4112), 1,
      anon_sym_LBRACK,
    ACTIONS(4114), 1,
      sym_readonly,
    STATE(1838), 1,
      aux_sym_export_statement_repeat1,
    STATE(1945), 1,
      sym_decorator,
    STATE(1951), 1,
      sym_accessibility_modifier,
    STATE(2186), 1,
      sym__parameter_name,
    STATE(2487), 1,
      sym_array,
    STATE(2505), 1,
      sym_object,
    STATE(2734), 1,
      sym__rest_identifier,
    ACTIONS(4108), 2,
      sym_identifier,
      sym_this,
    ACTIONS(1659), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2954), 3,
      sym_rest_parameter,
      sym_required_parameter,
      sym_optional_parameter,
    ACTIONS(1647), 14,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [90276] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4162), 11,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(4160), 23,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_DOT,
      anon_sym_class,
      anon_sym_async,
      sym_identifier,
      sym_this,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [90318] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(1246), 1,
      anon_sym_RBRACE,
    ACTIONS(1435), 1,
      sym_number,
    ACTIONS(3946), 1,
      anon_sym_EQ,
    ACTIONS(3960), 1,
      anon_sym_LBRACK,
    STATE(2868), 1,
      aux_sym_object_repeat1,
    STATE(2332), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2894), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1623), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [90378] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3946), 1,
      anon_sym_EQ,
    ACTIONS(2932), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(1673), 5,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
    ACTIONS(2894), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1671), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [90426] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(459), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1729), 1,
      anon_sym_LBRACE,
    ACTIONS(4112), 1,
      anon_sym_LBRACK,
    ACTIONS(4114), 1,
      sym_readonly,
    STATE(1915), 1,
      aux_sym_export_statement_repeat1,
    STATE(1945), 1,
      sym_decorator,
    STATE(1951), 1,
      sym_accessibility_modifier,
    STATE(2186), 1,
      sym__parameter_name,
    STATE(2487), 1,
      sym_array,
    STATE(2505), 1,
      sym_object,
    STATE(2734), 1,
      sym__rest_identifier,
    ACTIONS(4108), 2,
      sym_identifier,
      sym_this,
    ACTIONS(1659), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2778), 3,
      sym_rest_parameter,
      sym_required_parameter,
      sym_optional_parameter,
    ACTIONS(1647), 14,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [90496] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(1435), 1,
      sym_number,
    ACTIONS(3946), 1,
      anon_sym_EQ,
    ACTIONS(3960), 1,
      anon_sym_LBRACK,
    ACTIONS(4116), 1,
      anon_sym_STAR,
    ACTIONS(1627), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4164), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(2332), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2894), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1623), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [90556] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(1435), 1,
      sym_number,
    ACTIONS(3946), 1,
      anon_sym_EQ,
    ACTIONS(3960), 1,
      anon_sym_LBRACK,
    ACTIONS(4118), 1,
      anon_sym_RBRACE,
    STATE(2873), 1,
      aux_sym_object_repeat1,
    STATE(2332), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2894), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1623), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [90616] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(1435), 1,
      sym_number,
    ACTIONS(1625), 1,
      anon_sym_async,
    ACTIONS(1629), 1,
      sym_readonly,
    ACTIONS(3946), 1,
      anon_sym_EQ,
    ACTIONS(3960), 1,
      anon_sym_LBRACK,
    ACTIONS(4116), 1,
      anon_sym_STAR,
    ACTIONS(1627), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4164), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(2332), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2894), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1623), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [90680] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(459), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1729), 1,
      anon_sym_LBRACE,
    ACTIONS(4112), 1,
      anon_sym_LBRACK,
    ACTIONS(4114), 1,
      sym_readonly,
    STATE(1915), 1,
      aux_sym_export_statement_repeat1,
    STATE(1945), 1,
      sym_decorator,
    STATE(1951), 1,
      sym_accessibility_modifier,
    STATE(2186), 1,
      sym__parameter_name,
    STATE(2487), 1,
      sym_array,
    STATE(2505), 1,
      sym_object,
    STATE(2734), 1,
      sym__rest_identifier,
    ACTIONS(4108), 2,
      sym_identifier,
      sym_this,
    ACTIONS(1659), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2839), 3,
      sym_rest_parameter,
      sym_required_parameter,
      sym_optional_parameter,
    ACTIONS(1647), 14,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [90750] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(1435), 1,
      sym_number,
    ACTIONS(1625), 1,
      anon_sym_async,
    ACTIONS(3946), 1,
      anon_sym_EQ,
    ACTIONS(3960), 1,
      anon_sym_LBRACK,
    ACTIONS(4116), 1,
      anon_sym_STAR,
    ACTIONS(1627), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4164), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(2332), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2894), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1623), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [90812] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(2892), 1,
      anon_sym_namespace,
    ACTIONS(2896), 1,
      anon_sym_type,
    ACTIONS(2898), 1,
      anon_sym_import,
    ACTIONS(2900), 1,
      anon_sym_var,
    ACTIONS(2902), 1,
      anon_sym_let,
    ACTIONS(2904), 1,
      anon_sym_const,
    ACTIONS(2906), 1,
      anon_sym_class,
    ACTIONS(2908), 1,
      anon_sym_async,
    ACTIONS(2910), 1,
      anon_sym_function,
    ACTIONS(2912), 1,
      anon_sym_abstract,
    ACTIONS(2914), 1,
      anon_sym_declare,
    ACTIONS(2916), 1,
      anon_sym_module,
    ACTIONS(2918), 1,
      anon_sym_interface,
    ACTIONS(2920), 1,
      anon_sym_enum,
    ACTIONS(4166), 1,
      anon_sym_default,
    STATE(1945), 1,
      sym_decorator,
    STATE(2407), 1,
      aux_sym_export_statement_repeat1,
    STATE(2527), 1,
      sym_internal_module,
    STATE(2570), 1,
      sym__declaration,
    STATE(2519), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [90891] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1201), 1,
      anon_sym_namespace,
    ACTIONS(1207), 1,
      anon_sym_type,
    ACTIONS(1209), 1,
      anon_sym_import,
    ACTIONS(1211), 1,
      anon_sym_var,
    ACTIONS(1213), 1,
      anon_sym_let,
    ACTIONS(1215), 1,
      anon_sym_const,
    ACTIONS(1230), 1,
      anon_sym_class,
    ACTIONS(1232), 1,
      anon_sym_async,
    ACTIONS(1234), 1,
      anon_sym_function,
    ACTIONS(1236), 1,
      anon_sym_abstract,
    ACTIONS(1238), 1,
      anon_sym_declare,
    ACTIONS(1242), 1,
      anon_sym_interface,
    ACTIONS(1244), 1,
      anon_sym_enum,
    ACTIONS(1262), 1,
      anon_sym_module,
    ACTIONS(1264), 1,
      anon_sym_global,
    STATE(542), 1,
      sym_internal_module,
    STATE(557), 1,
      sym__declaration,
    STATE(1945), 1,
      sym_decorator,
    STATE(2373), 1,
      aux_sym_export_statement_repeat1,
    STATE(572), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [90970] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(1435), 1,
      sym_number,
    ACTIONS(3946), 1,
      anon_sym_EQ,
    ACTIONS(3960), 1,
      anon_sym_LBRACK,
    ACTIONS(4164), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(2332), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2894), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1623), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [91025] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1201), 1,
      anon_sym_namespace,
    ACTIONS(1207), 1,
      anon_sym_type,
    ACTIONS(1209), 1,
      anon_sym_import,
    ACTIONS(1211), 1,
      anon_sym_var,
    ACTIONS(1213), 1,
      anon_sym_let,
    ACTIONS(1215), 1,
      anon_sym_const,
    ACTIONS(1230), 1,
      anon_sym_class,
    ACTIONS(1232), 1,
      anon_sym_async,
    ACTIONS(1234), 1,
      anon_sym_function,
    ACTIONS(1236), 1,
      anon_sym_abstract,
    ACTIONS(1238), 1,
      anon_sym_declare,
    ACTIONS(1240), 1,
      anon_sym_module,
    ACTIONS(1242), 1,
      anon_sym_interface,
    ACTIONS(1244), 1,
      anon_sym_enum,
    ACTIONS(4168), 1,
      anon_sym_default,
    STATE(542), 1,
      sym_internal_module,
    STATE(609), 1,
      sym__declaration,
    STATE(1945), 1,
      sym_decorator,
    STATE(2373), 1,
      aux_sym_export_statement_repeat1,
    STATE(572), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [91104] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1201), 1,
      anon_sym_namespace,
    ACTIONS(1207), 1,
      anon_sym_type,
    ACTIONS(1209), 1,
      anon_sym_import,
    ACTIONS(1211), 1,
      anon_sym_var,
    ACTIONS(1213), 1,
      anon_sym_let,
    ACTIONS(1215), 1,
      anon_sym_const,
    ACTIONS(1230), 1,
      anon_sym_class,
    ACTIONS(1232), 1,
      anon_sym_async,
    ACTIONS(1234), 1,
      anon_sym_function,
    ACTIONS(1236), 1,
      anon_sym_abstract,
    ACTIONS(1242), 1,
      anon_sym_interface,
    ACTIONS(1244), 1,
      anon_sym_enum,
    ACTIONS(1264), 1,
      anon_sym_global,
    ACTIONS(1292), 1,
      anon_sym_declare,
    ACTIONS(1296), 1,
      anon_sym_module,
    STATE(542), 1,
      sym_internal_module,
    STATE(557), 1,
      sym__declaration,
    STATE(1945), 1,
      sym_decorator,
    STATE(2373), 1,
      aux_sym_export_statement_repeat1,
    STATE(572), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [91183] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(2892), 1,
      anon_sym_namespace,
    ACTIONS(2896), 1,
      anon_sym_type,
    ACTIONS(2898), 1,
      anon_sym_import,
    ACTIONS(2900), 1,
      anon_sym_var,
    ACTIONS(2902), 1,
      anon_sym_let,
    ACTIONS(2904), 1,
      anon_sym_const,
    ACTIONS(2906), 1,
      anon_sym_class,
    ACTIONS(2908), 1,
      anon_sym_async,
    ACTIONS(2910), 1,
      anon_sym_function,
    ACTIONS(2912), 1,
      anon_sym_abstract,
    ACTIONS(2914), 1,
      anon_sym_declare,
    ACTIONS(2918), 1,
      anon_sym_interface,
    ACTIONS(2920), 1,
      anon_sym_enum,
    ACTIONS(4170), 1,
      anon_sym_module,
    ACTIONS(4172), 1,
      anon_sym_global,
    STATE(1945), 1,
      sym_decorator,
    STATE(2374), 1,
      sym__declaration,
    STATE(2407), 1,
      aux_sym_export_statement_repeat1,
    STATE(2527), 1,
      sym_internal_module,
    STATE(2519), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [91262] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1201), 1,
      anon_sym_namespace,
    ACTIONS(1207), 1,
      anon_sym_type,
    ACTIONS(1209), 1,
      anon_sym_import,
    ACTIONS(1211), 1,
      anon_sym_var,
    ACTIONS(1213), 1,
      anon_sym_let,
    ACTIONS(1215), 1,
      anon_sym_const,
    ACTIONS(1230), 1,
      anon_sym_class,
    ACTIONS(1232), 1,
      anon_sym_async,
    ACTIONS(1234), 1,
      anon_sym_function,
    ACTIONS(1236), 1,
      anon_sym_abstract,
    ACTIONS(1240), 1,
      anon_sym_module,
    ACTIONS(1242), 1,
      anon_sym_interface,
    ACTIONS(1244), 1,
      anon_sym_enum,
    ACTIONS(1292), 1,
      anon_sym_declare,
    ACTIONS(4168), 1,
      anon_sym_default,
    STATE(542), 1,
      sym_internal_module,
    STATE(609), 1,
      sym__declaration,
    STATE(1945), 1,
      sym_decorator,
    STATE(2373), 1,
      aux_sym_export_statement_repeat1,
    STATE(572), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [91341] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3117), 10,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(3115), 22,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_class,
      anon_sym_async,
      sym_identifier,
      sym_this,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [91381] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4176), 10,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(4174), 22,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_class,
      anon_sym_async,
      sym_identifier,
      sym_this,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [91421] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(1248), 1,
      anon_sym_RBRACE,
    ACTIONS(3946), 1,
      anon_sym_EQ,
    STATE(2854), 1,
      aux_sym_object_repeat1,
    ACTIONS(2894), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1673), 5,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
    ACTIONS(1671), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [91471] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4138), 10,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(4136), 22,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_class,
      anon_sym_async,
      sym_identifier,
      sym_this,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [91511] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(1246), 1,
      anon_sym_RBRACE,
    ACTIONS(3946), 1,
      anon_sym_EQ,
    STATE(2868), 1,
      aux_sym_object_repeat1,
    ACTIONS(2894), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1673), 5,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
    ACTIONS(1671), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [91561] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3368), 10,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(3366), 22,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_class,
      anon_sym_async,
      sym_identifier,
      sym_this,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [91601] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(3946), 1,
      anon_sym_EQ,
    ACTIONS(4118), 1,
      anon_sym_RBRACE,
    STATE(2873), 1,
      aux_sym_object_repeat1,
    ACTIONS(2894), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1673), 5,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
    ACTIONS(1671), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [91651] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(3946), 1,
      anon_sym_EQ,
    ACTIONS(4120), 1,
      anon_sym_RBRACE,
    STATE(2806), 1,
      aux_sym_object_repeat1,
    ACTIONS(2894), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1673), 5,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
    ACTIONS(1671), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [91701] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(1205), 1,
      anon_sym_RBRACE,
    ACTIONS(3946), 1,
      anon_sym_EQ,
    STATE(2894), 1,
      aux_sym_object_repeat1,
    ACTIONS(2894), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1673), 5,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
    ACTIONS(1671), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [91751] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3424), 10,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(3422), 22,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_class,
      anon_sym_async,
      sym_identifier,
      sym_this,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [91791] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3946), 1,
      anon_sym_EQ,
    ACTIONS(4164), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(2894), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1673), 5,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
    ACTIONS(1671), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [91836] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(3960), 1,
      anon_sym_LBRACK,
    ACTIONS(4178), 1,
      anon_sym_EQ_GT,
    ACTIONS(4180), 1,
      sym_number,
    ACTIONS(2894), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2268), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1623), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [91886] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4184), 10,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(4182), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [91924] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(3960), 1,
      anon_sym_LBRACK,
    ACTIONS(4186), 1,
      anon_sym_STAR,
    ACTIONS(4188), 1,
      sym_number,
    ACTIONS(4190), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2894), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2290), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1623), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [91976] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4194), 10,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(4192), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [92014] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4198), 10,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(4196), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [92052] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4202), 10,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(4200), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [92090] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(3960), 1,
      anon_sym_LBRACK,
    ACTIONS(4180), 1,
      sym_number,
    ACTIONS(4204), 1,
      anon_sym_STAR,
    ACTIONS(4206), 1,
      anon_sym_async,
    ACTIONS(4210), 1,
      sym_readonly,
    ACTIONS(4208), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2894), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2268), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1623), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [92146] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(3960), 1,
      anon_sym_LBRACK,
    ACTIONS(4212), 1,
      anon_sym_STAR,
    ACTIONS(4214), 1,
      anon_sym_async,
    ACTIONS(4216), 1,
      sym_number,
    ACTIONS(4218), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2894), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2288), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1623), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [92200] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(3960), 1,
      anon_sym_LBRACK,
    ACTIONS(4180), 1,
      sym_number,
    ACTIONS(4204), 1,
      anon_sym_STAR,
    ACTIONS(4208), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2894), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2268), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1623), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [92252] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(3960), 1,
      anon_sym_LBRACK,
    ACTIONS(4180), 1,
      sym_number,
    ACTIONS(4204), 1,
      anon_sym_STAR,
    ACTIONS(4206), 1,
      anon_sym_async,
    ACTIONS(4208), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2894), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2268), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1623), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [92306] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(3960), 1,
      anon_sym_LBRACK,
    ACTIONS(4212), 1,
      anon_sym_STAR,
    ACTIONS(4216), 1,
      sym_number,
    ACTIONS(4218), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2894), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2288), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1623), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [92358] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4222), 10,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(4220), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [92396] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1049), 10,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(1051), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [92434] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1071), 10,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(1073), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [92472] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4224), 1,
      sym__automatic_semicolon,
    ACTIONS(941), 9,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(943), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [92512] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4228), 10,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(4226), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [92550] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4232), 10,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(4230), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [92588] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4238), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(4236), 8,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(4234), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [92628] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4242), 10,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(4240), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [92666] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4246), 10,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(4244), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [92704] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4250), 10,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(4248), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [92742] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4252), 1,
      sym__automatic_semicolon,
    ACTIONS(1049), 9,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(1051), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [92782] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4256), 10,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(4254), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [92820] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4260), 10,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(4258), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [92858] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(3960), 1,
      anon_sym_LBRACK,
    ACTIONS(4262), 1,
      sym_number,
    ACTIONS(2894), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2321), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1623), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [92905] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(3960), 1,
      anon_sym_LBRACK,
    ACTIONS(4066), 1,
      sym_number,
    ACTIONS(2894), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2317), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1623), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [92952] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(3960), 1,
      anon_sym_LBRACK,
    ACTIONS(4216), 1,
      sym_number,
    ACTIONS(2894), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2288), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1623), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [92999] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(3960), 1,
      anon_sym_LBRACK,
    ACTIONS(4264), 1,
      sym_number,
    ACTIONS(2894), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2353), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1623), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [93046] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(3960), 1,
      anon_sym_LBRACK,
    ACTIONS(4048), 1,
      sym_number,
    ACTIONS(2894), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2291), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1623), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [93093] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1729), 1,
      anon_sym_LBRACE,
    ACTIONS(4112), 1,
      anon_sym_LBRACK,
    STATE(2474), 1,
      sym_object,
    STATE(2475), 1,
      sym_array,
    ACTIONS(1727), 2,
      sym_identifier,
      sym_this,
    ACTIONS(1736), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(773), 18,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [93140] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(3960), 1,
      anon_sym_LBRACK,
    ACTIONS(4266), 1,
      sym_number,
    ACTIONS(2894), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2315), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1623), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [93187] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(3960), 1,
      anon_sym_LBRACK,
    ACTIONS(4070), 1,
      sym_number,
    ACTIONS(2894), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2261), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1623), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [93234] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1729), 1,
      anon_sym_LBRACE,
    ACTIONS(4112), 1,
      anon_sym_LBRACK,
    STATE(2496), 1,
      sym_array,
    STATE(2499), 1,
      sym_object,
    ACTIONS(4268), 2,
      sym_identifier,
      sym_this,
    ACTIONS(2223), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(4270), 18,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [93281] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(3960), 1,
      anon_sym_LBRACK,
    ACTIONS(4104), 1,
      sym_number,
    ACTIONS(2894), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2359), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1623), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [93328] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(3960), 1,
      anon_sym_LBRACK,
    ACTIONS(4272), 1,
      sym_number,
    ACTIONS(2894), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2296), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1623), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [93375] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(3960), 1,
      anon_sym_LBRACK,
    ACTIONS(4054), 1,
      sym_number,
    ACTIONS(2894), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2368), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1623), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [93422] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(3960), 1,
      anon_sym_LBRACK,
    ACTIONS(4188), 1,
      sym_number,
    ACTIONS(2894), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2290), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1623), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [93469] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(3960), 1,
      anon_sym_LBRACK,
    ACTIONS(4090), 1,
      sym_number,
    ACTIONS(2894), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2303), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1623), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [93516] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(3960), 1,
      anon_sym_LBRACK,
    ACTIONS(4022), 1,
      sym_number,
    ACTIONS(2894), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2265), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1623), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [93563] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(3960), 1,
      anon_sym_LBRACK,
    ACTIONS(4060), 1,
      sym_number,
    ACTIONS(2894), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2294), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1623), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [93610] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(3960), 1,
      anon_sym_LBRACK,
    ACTIONS(4040), 1,
      sym_number,
    ACTIONS(2894), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2289), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1623), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [93657] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(3960), 1,
      anon_sym_LBRACK,
    ACTIONS(4180), 1,
      sym_number,
    ACTIONS(2894), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2268), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1623), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [93704] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(3960), 1,
      anon_sym_LBRACK,
    ACTIONS(4274), 1,
      anon_sym_RBRACE,
    ACTIONS(4276), 1,
      sym_number,
    STATE(3004), 1,
      sym_enum_assignment,
    STATE(2622), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1623), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [93752] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(3960), 1,
      anon_sym_LBRACK,
    ACTIONS(4278), 1,
      anon_sym_RBRACE,
    ACTIONS(4280), 1,
      sym_number,
    STATE(2759), 1,
      sym_enum_assignment,
    STATE(2379), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1623), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [93800] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(3960), 1,
      anon_sym_LBRACK,
    ACTIONS(4276), 1,
      sym_number,
    ACTIONS(4282), 1,
      anon_sym_RBRACE,
    STATE(3004), 1,
      sym_enum_assignment,
    STATE(2622), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1623), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [93848] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3872), 8,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(4284), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [93884] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(3960), 1,
      anon_sym_LBRACK,
    ACTIONS(4276), 1,
      sym_number,
    ACTIONS(4286), 1,
      anon_sym_RBRACE,
    STATE(3004), 1,
      sym_enum_assignment,
    STATE(2622), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1623), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [93932] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4292), 1,
      anon_sym_AT,
    STATE(1915), 1,
      aux_sym_export_statement_repeat1,
    STATE(1945), 1,
      sym_decorator,
    ACTIONS(4290), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4288), 22,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_class,
      anon_sym_async,
      sym_identifier,
      sym_this,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [93974] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(3960), 1,
      anon_sym_LBRACK,
    ACTIONS(4295), 1,
      anon_sym_RBRACE,
    ACTIONS(4297), 1,
      sym_number,
    STATE(2842), 1,
      sym_enum_assignment,
    STATE(2541), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1623), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [94022] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(3960), 1,
      anon_sym_LBRACK,
    ACTIONS(4276), 1,
      sym_number,
    ACTIONS(4299), 1,
      anon_sym_RBRACE,
    STATE(3004), 1,
      sym_enum_assignment,
    STATE(2622), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1623), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [94070] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2434), 1,
      anon_sym_DQUOTE,
    ACTIONS(2436), 1,
      anon_sym_SQUOTE,
    ACTIONS(3956), 1,
      anon_sym_LBRACK,
    ACTIONS(3980), 1,
      anon_sym_STAR,
    ACTIONS(3982), 1,
      anon_sym_async,
    ACTIONS(3984), 1,
      sym_number,
    ACTIONS(4301), 1,
      anon_sym_static,
    ACTIONS(4303), 1,
      anon_sym_abstract,
    ACTIONS(4305), 1,
      sym_readonly,
    ACTIONS(3988), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1972), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2856), 14,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [94126] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2434), 1,
      anon_sym_DQUOTE,
    ACTIONS(2436), 1,
      anon_sym_SQUOTE,
    ACTIONS(3956), 1,
      anon_sym_LBRACK,
    ACTIONS(4307), 1,
      anon_sym_STAR,
    ACTIONS(4309), 1,
      sym_number,
    ACTIONS(4313), 1,
      sym_readonly,
    ACTIONS(4311), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1974), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2856), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [94175] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2434), 1,
      anon_sym_DQUOTE,
    ACTIONS(2436), 1,
      anon_sym_SQUOTE,
    ACTIONS(3956), 1,
      anon_sym_LBRACK,
    ACTIONS(4000), 1,
      anon_sym_STAR,
    ACTIONS(4014), 1,
      anon_sym_async,
    ACTIONS(4016), 1,
      sym_number,
    ACTIONS(4020), 1,
      sym_readonly,
    ACTIONS(4315), 1,
      anon_sym_static,
    ACTIONS(4018), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1984), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2856), 14,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [94228] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(1435), 1,
      sym_number,
    ACTIONS(1625), 1,
      anon_sym_async,
    ACTIONS(1629), 1,
      sym_readonly,
    ACTIONS(3960), 1,
      anon_sym_LBRACK,
    ACTIONS(4116), 1,
      anon_sym_STAR,
    ACTIONS(4317), 1,
      anon_sym_static,
    ACTIONS(1627), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2332), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1623), 14,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [94281] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(3960), 1,
      anon_sym_LBRACK,
    ACTIONS(4276), 1,
      sym_number,
    STATE(3004), 1,
      sym_enum_assignment,
    STATE(2622), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1623), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [94326] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1673), 2,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(1736), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(1671), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      sym_this,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [94363] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2434), 1,
      anon_sym_DQUOTE,
    ACTIONS(2436), 1,
      anon_sym_SQUOTE,
    ACTIONS(3944), 1,
      anon_sym_STAR,
    ACTIONS(3950), 1,
      anon_sym_async,
    ACTIONS(3952), 1,
      sym_number,
    ACTIONS(3956), 1,
      anon_sym_LBRACK,
    ACTIONS(3958), 1,
      sym_readonly,
    ACTIONS(4319), 1,
      anon_sym_static,
    ACTIONS(3954), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1989), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2856), 14,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [94416] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2434), 1,
      anon_sym_DQUOTE,
    ACTIONS(2436), 1,
      anon_sym_SQUOTE,
    ACTIONS(3956), 1,
      anon_sym_LBRACK,
    ACTIONS(4321), 1,
      anon_sym_STAR,
    ACTIONS(4323), 1,
      sym_number,
    ACTIONS(4327), 1,
      sym_readonly,
    ACTIONS(4325), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1979), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2856), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [94465] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(1435), 1,
      sym_number,
    ACTIONS(3960), 1,
      anon_sym_LBRACK,
    STATE(2332), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1623), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [94507] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2434), 1,
      anon_sym_DQUOTE,
    ACTIONS(2436), 1,
      anon_sym_SQUOTE,
    ACTIONS(3956), 1,
      anon_sym_LBRACK,
    ACTIONS(4124), 1,
      sym_number,
    STATE(2081), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2856), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [94549] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(3960), 1,
      anon_sym_LBRACK,
    ACTIONS(4048), 1,
      sym_number,
    STATE(2291), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1623), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [94591] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(3960), 1,
      anon_sym_LBRACK,
    ACTIONS(4022), 1,
      sym_number,
    STATE(2265), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1623), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [94633] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(3960), 1,
      anon_sym_LBRACK,
    ACTIONS(4040), 1,
      sym_number,
    STATE(2289), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1623), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [94675] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(3960), 1,
      anon_sym_LBRACK,
    ACTIONS(4060), 1,
      sym_number,
    STATE(2294), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1623), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [94717] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(3960), 1,
      anon_sym_LBRACK,
    ACTIONS(4026), 1,
      sym_number,
    STATE(2351), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1623), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [94759] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(3960), 1,
      anon_sym_LBRACK,
    ACTIONS(3962), 1,
      sym_number,
    STATE(2287), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1623), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [94801] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(3960), 1,
      anon_sym_LBRACK,
    ACTIONS(4264), 1,
      sym_number,
    STATE(2353), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1623), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [94843] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(3960), 1,
      anon_sym_LBRACK,
    ACTIONS(4070), 1,
      sym_number,
    STATE(2261), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1623), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [94885] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(3960), 1,
      anon_sym_LBRACK,
    ACTIONS(4266), 1,
      sym_number,
    STATE(2315), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1623), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [94927] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(3960), 1,
      anon_sym_LBRACK,
    ACTIONS(4180), 1,
      sym_number,
    STATE(2268), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1623), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [94969] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(3960), 1,
      anon_sym_LBRACK,
    ACTIONS(4272), 1,
      sym_number,
    STATE(2296), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1623), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [95011] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(3960), 1,
      anon_sym_LBRACK,
    ACTIONS(4054), 1,
      sym_number,
    STATE(2368), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1623), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [95053] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(3960), 1,
      anon_sym_LBRACK,
    ACTIONS(4066), 1,
      sym_number,
    STATE(2317), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1623), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [95095] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(3960), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      sym_number,
    STATE(2313), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1623), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [95137] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(3960), 1,
      anon_sym_LBRACK,
    ACTIONS(4126), 1,
      sym_number,
    STATE(2328), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1623), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [95179] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(3960), 1,
      anon_sym_LBRACK,
    ACTIONS(4090), 1,
      sym_number,
    STATE(2303), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1623), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [95221] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2434), 1,
      anon_sym_DQUOTE,
    ACTIONS(2436), 1,
      anon_sym_SQUOTE,
    ACTIONS(3956), 1,
      anon_sym_LBRACK,
    ACTIONS(4152), 1,
      sym_number,
    STATE(2103), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2856), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [95263] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4331), 4,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AT,
    ACTIONS(4329), 22,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_class,
      anon_sym_async,
      sym_identifier,
      sym_this,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [95297] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(3960), 1,
      anon_sym_LBRACK,
    ACTIONS(4188), 1,
      sym_number,
    STATE(2290), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1623), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [95339] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(3960), 1,
      anon_sym_LBRACK,
    ACTIONS(4158), 1,
      sym_number,
    STATE(2267), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1623), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [95381] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(3960), 1,
      anon_sym_LBRACK,
    ACTIONS(4216), 1,
      sym_number,
    STATE(2288), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1623), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [95423] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(3960), 1,
      anon_sym_LBRACK,
    ACTIONS(4104), 1,
      sym_number,
    STATE(2359), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1623), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [95465] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(3960), 1,
      anon_sym_LBRACK,
    ACTIONS(4262), 1,
      sym_number,
    STATE(2321), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1623), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [95507] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1729), 1,
      anon_sym_LBRACE,
    ACTIONS(4112), 1,
      anon_sym_LBRACK,
    ACTIONS(4333), 1,
      sym_readonly,
    STATE(2474), 1,
      sym_object,
    STATE(2475), 1,
      sym_array,
    ACTIONS(1727), 2,
      sym_identifier,
      sym_this,
    ACTIONS(773), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [95549] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4335), 1,
      sym_identifier,
    STATE(3161), 1,
      sym_mapped_type_clause,
    ACTIONS(4337), 18,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [95579] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1561), 1,
      anon_sym_EQ,
    ACTIONS(4339), 1,
      anon_sym_LT,
    ACTIONS(4341), 1,
      anon_sym_DOT,
    STATE(284), 1,
      sym_type_arguments,
    ACTIONS(1559), 14,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_RPAREN,
      anon_sym_while,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [95611] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1712), 1,
      anon_sym_EQ,
    ACTIONS(4339), 1,
      anon_sym_LT,
    ACTIONS(4343), 1,
      anon_sym_DOT,
    STATE(284), 1,
      sym_type_arguments,
    ACTIONS(1710), 14,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_RPAREN,
      anon_sym_while,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [95643] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1723), 1,
      anon_sym_EQ,
    ACTIONS(4339), 1,
      anon_sym_LT,
    ACTIONS(4343), 1,
      anon_sym_DOT,
    STATE(284), 1,
      sym_type_arguments,
    ACTIONS(1721), 14,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_RPAREN,
      anon_sym_while,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [95675] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1017), 1,
      anon_sym_EQ,
    ACTIONS(1396), 1,
      anon_sym_LT,
    ACTIONS(1015), 15,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_RPAREN,
      anon_sym_while,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [95702] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1752), 1,
      anon_sym_EQ,
    ACTIONS(4339), 1,
      anon_sym_LT,
    STATE(275), 1,
      sym_type_arguments,
    ACTIONS(1750), 14,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_RPAREN,
      anon_sym_while,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [95731] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1617), 1,
      anon_sym_EQ,
    ACTIONS(4339), 1,
      anon_sym_LT,
    STATE(275), 1,
      sym_type_arguments,
    ACTIONS(1615), 14,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_RPAREN,
      anon_sym_while,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [95760] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1081), 1,
      anon_sym_PIPE,
    ACTIONS(1079), 15,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [95784] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1561), 1,
      anon_sym_EQ,
    ACTIONS(4341), 1,
      anon_sym_DOT,
    ACTIONS(1559), 14,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_RPAREN,
      anon_sym_while,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [95810] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1089), 1,
      anon_sym_PIPE,
    ACTIONS(1087), 15,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [95834] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1770), 1,
      anon_sym_EQ,
    ACTIONS(4345), 1,
      anon_sym_AMP,
    ACTIONS(4347), 1,
      anon_sym_PIPE,
    ACTIONS(4349), 1,
      anon_sym_extends,
    ACTIONS(1768), 11,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_RPAREN,
      anon_sym_while,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
  [95863] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4351), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [95884] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4353), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [95905] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1790), 1,
      anon_sym_EQ,
    ACTIONS(4345), 1,
      anon_sym_AMP,
    ACTIONS(4347), 1,
      anon_sym_PIPE,
    ACTIONS(4349), 1,
      anon_sym_extends,
    ACTIONS(1788), 11,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_RPAREN,
      anon_sym_while,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
  [95934] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1780), 1,
      anon_sym_EQ,
    ACTIONS(4345), 1,
      anon_sym_AMP,
    ACTIONS(4347), 1,
      anon_sym_PIPE,
    ACTIONS(1778), 12,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_RPAREN,
      anon_sym_while,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_extends,
  [95961] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4355), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [95982] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4357), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [96003] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4359), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [96024] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4361), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [96045] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2251), 1,
      anon_sym_COLON,
    ACTIONS(2542), 1,
      anon_sym_LPAREN,
    ACTIONS(4363), 1,
      anon_sym_EQ,
    ACTIONS(4367), 1,
      anon_sym_BANG,
    ACTIONS(4369), 1,
      anon_sym_QMARK,
    STATE(2066), 1,
      sym_formal_parameters,
    STATE(2412), 1,
      sym_type_annotation,
    STATE(2414), 1,
      sym__call_signature,
    STATE(2803), 1,
      sym__initializer,
    STATE(3032), 1,
      sym_type_parameters,
    ACTIONS(4365), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [96087] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2251), 1,
      anon_sym_COLON,
    ACTIONS(2542), 1,
      anon_sym_LPAREN,
    ACTIONS(4363), 1,
      anon_sym_EQ,
    ACTIONS(4373), 1,
      anon_sym_BANG,
    ACTIONS(4375), 1,
      anon_sym_QMARK,
    STATE(2066), 1,
      sym_formal_parameters,
    STATE(2606), 1,
      sym_type_annotation,
    STATE(2610), 1,
      sym__call_signature,
    STATE(2890), 1,
      sym__initializer,
    STATE(3032), 1,
      sym_type_parameters,
    ACTIONS(4371), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [96129] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1561), 1,
      anon_sym_PIPE,
    ACTIONS(4377), 1,
      anon_sym_LT,
    ACTIONS(4379), 1,
      anon_sym_DOT,
    STATE(2045), 1,
      sym_type_arguments,
    ACTIONS(1559), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [96157] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2251), 1,
      anon_sym_COLON,
    ACTIONS(2542), 1,
      anon_sym_LPAREN,
    ACTIONS(4363), 1,
      anon_sym_EQ,
    ACTIONS(4383), 1,
      anon_sym_BANG,
    ACTIONS(4385), 1,
      anon_sym_QMARK,
    STATE(2066), 1,
      sym_formal_parameters,
    STATE(2442), 1,
      sym_type_annotation,
    STATE(2785), 1,
      sym__initializer,
    STATE(2847), 1,
      sym__call_signature,
    STATE(3032), 1,
      sym_type_parameters,
    ACTIONS(4381), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [96199] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1712), 1,
      anon_sym_PIPE,
    ACTIONS(4377), 1,
      anon_sym_LT,
    ACTIONS(4387), 1,
      anon_sym_DOT,
    ACTIONS(4389), 1,
      anon_sym_is,
    STATE(2045), 1,
      sym_type_arguments,
    ACTIONS(1710), 9,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [96229] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2251), 1,
      anon_sym_COLON,
    ACTIONS(2542), 1,
      anon_sym_LPAREN,
    ACTIONS(4363), 1,
      anon_sym_EQ,
    ACTIONS(4383), 1,
      anon_sym_BANG,
    ACTIONS(4391), 1,
      anon_sym_QMARK,
    STATE(2066), 1,
      sym_formal_parameters,
    STATE(2442), 1,
      sym_type_annotation,
    STATE(2454), 1,
      sym__call_signature,
    STATE(2785), 1,
      sym__initializer,
    STATE(3032), 1,
      sym_type_parameters,
    ACTIONS(4381), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [96271] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2251), 1,
      anon_sym_COLON,
    ACTIONS(2542), 1,
      anon_sym_LPAREN,
    ACTIONS(4363), 1,
      anon_sym_EQ,
    ACTIONS(4395), 1,
      anon_sym_BANG,
    ACTIONS(4397), 1,
      anon_sym_QMARK,
    STATE(2066), 1,
      sym_formal_parameters,
    STATE(2391), 1,
      sym__call_signature,
    STATE(2402), 1,
      sym_type_annotation,
    STATE(2895), 1,
      sym__initializer,
    STATE(3032), 1,
      sym_type_parameters,
    ACTIONS(4393), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [96313] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1712), 1,
      anon_sym_PIPE,
    ACTIONS(4377), 1,
      anon_sym_LT,
    ACTIONS(4387), 1,
      anon_sym_DOT,
    STATE(2045), 1,
      sym_type_arguments,
    ACTIONS(1710), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [96341] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2251), 1,
      anon_sym_COLON,
    ACTIONS(2542), 1,
      anon_sym_LPAREN,
    ACTIONS(4363), 1,
      anon_sym_EQ,
    ACTIONS(4373), 1,
      anon_sym_BANG,
    ACTIONS(4399), 1,
      anon_sym_QMARK,
    STATE(2066), 1,
      sym_formal_parameters,
    STATE(2606), 1,
      sym_type_annotation,
    STATE(2889), 1,
      sym__call_signature,
    STATE(2890), 1,
      sym__initializer,
    STATE(3032), 1,
      sym_type_parameters,
    ACTIONS(4371), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [96383] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1723), 1,
      anon_sym_PIPE,
    ACTIONS(4377), 1,
      anon_sym_LT,
    ACTIONS(4387), 1,
      anon_sym_DOT,
    STATE(2045), 1,
      sym_type_arguments,
    ACTIONS(1721), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [96411] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4339), 1,
      anon_sym_LT,
    ACTIONS(4343), 1,
      anon_sym_DOT,
    ACTIONS(4401), 1,
      anon_sym_EQ,
    ACTIONS(4406), 1,
      anon_sym_COLON,
    ACTIONS(4408), 1,
      anon_sym_extends,
    STATE(284), 1,
      sym_type_arguments,
    STATE(2660), 1,
      sym_constraint,
    STATE(3109), 1,
      sym_default_type,
    ACTIONS(4403), 2,
      anon_sym_COMMA,
      anon_sym_GT,
    ACTIONS(1710), 3,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
  [96448] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2251), 1,
      anon_sym_COLON,
    ACTIONS(2542), 1,
      anon_sym_LPAREN,
    ACTIONS(4413), 1,
      anon_sym_QMARK,
    STATE(2066), 1,
      sym_formal_parameters,
    STATE(2425), 1,
      sym_type_annotation,
    STATE(2427), 1,
      sym__call_signature,
    STATE(3032), 1,
      sym_type_parameters,
    ACTIONS(4411), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [96483] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1752), 1,
      anon_sym_PIPE,
    ACTIONS(4377), 1,
      anon_sym_LT,
    STATE(2058), 1,
      sym_type_arguments,
    ACTIONS(1750), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [96508] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2251), 1,
      anon_sym_COLON,
    ACTIONS(2542), 1,
      anon_sym_LPAREN,
    ACTIONS(4417), 1,
      anon_sym_QMARK,
    STATE(2066), 1,
      sym_formal_parameters,
    STATE(2513), 1,
      sym_type_annotation,
    STATE(2582), 1,
      sym__call_signature,
    STATE(3032), 1,
      sym_type_parameters,
    ACTIONS(4415), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [96543] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1017), 1,
      anon_sym_PIPE,
    ACTIONS(1396), 1,
      anon_sym_LT,
    ACTIONS(1015), 11,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [96566] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1617), 1,
      anon_sym_PIPE,
    ACTIONS(4377), 1,
      anon_sym_LT,
    STATE(2058), 1,
      sym_type_arguments,
    ACTIONS(1615), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [96591] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2542), 1,
      anon_sym_LPAREN,
    ACTIONS(4419), 1,
      anon_sym_COLON,
    ACTIONS(4421), 1,
      anon_sym_QMARK,
    STATE(2066), 1,
      sym_formal_parameters,
    STATE(2214), 1,
      sym__call_signature,
    STATE(2425), 1,
      sym_type_annotation,
    STATE(3032), 1,
      sym_type_parameters,
    ACTIONS(4411), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [96626] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1015), 1,
      anon_sym_DOT,
    ACTIONS(1398), 1,
      anon_sym_PIPE,
    ACTIONS(1396), 11,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [96649] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2251), 1,
      anon_sym_COLON,
    ACTIONS(2542), 1,
      anon_sym_LPAREN,
    ACTIONS(4423), 1,
      anon_sym_QMARK,
    STATE(2066), 1,
      sym_formal_parameters,
    STATE(2243), 1,
      sym__call_signature,
    STATE(2513), 1,
      sym_type_annotation,
    STATE(3032), 1,
      sym_type_parameters,
    ACTIONS(4415), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [96684] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2251), 1,
      anon_sym_COLON,
    ACTIONS(2542), 1,
      anon_sym_LPAREN,
    ACTIONS(4427), 1,
      anon_sym_QMARK,
    STATE(2066), 1,
      sym_formal_parameters,
    STATE(2376), 1,
      sym__call_signature,
    STATE(2529), 1,
      sym_type_annotation,
    STATE(3032), 1,
      sym_type_parameters,
    ACTIONS(4425), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [96719] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2251), 1,
      anon_sym_COLON,
    ACTIONS(2542), 1,
      anon_sym_LPAREN,
    ACTIONS(4431), 1,
      anon_sym_QMARK,
    STATE(2066), 1,
      sym_formal_parameters,
    STATE(2228), 1,
      sym__call_signature,
    STATE(2470), 1,
      sym_type_annotation,
    STATE(3032), 1,
      sym_type_parameters,
    ACTIONS(4429), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [96754] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2251), 1,
      anon_sym_COLON,
    ACTIONS(2542), 1,
      anon_sym_LPAREN,
    ACTIONS(4433), 1,
      anon_sym_QMARK,
    STATE(2066), 1,
      sym_formal_parameters,
    STATE(2224), 1,
      sym__call_signature,
    STATE(2529), 1,
      sym_type_annotation,
    STATE(3032), 1,
      sym_type_parameters,
    ACTIONS(4425), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [96789] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2251), 1,
      anon_sym_COLON,
    ACTIONS(2542), 1,
      anon_sym_LPAREN,
    ACTIONS(4435), 1,
      anon_sym_QMARK,
    STATE(2066), 1,
      sym_formal_parameters,
    STATE(2470), 1,
      sym_type_annotation,
    STATE(2479), 1,
      sym__call_signature,
    STATE(3032), 1,
      sym_type_parameters,
    ACTIONS(4429), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [96824] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2251), 1,
      anon_sym_COLON,
    ACTIONS(2542), 1,
      anon_sym_LPAREN,
    STATE(2066), 1,
      sym_formal_parameters,
    STATE(2380), 1,
      sym__call_signature,
    STATE(2384), 1,
      sym_type_annotation,
    STATE(3032), 1,
      sym_type_parameters,
    ACTIONS(4437), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [96856] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2251), 1,
      anon_sym_COLON,
    ACTIONS(2542), 1,
      anon_sym_LPAREN,
    STATE(2066), 1,
      sym_formal_parameters,
    STATE(2229), 1,
      sym__call_signature,
    STATE(2469), 1,
      sym_type_annotation,
    STATE(3032), 1,
      sym_type_parameters,
    ACTIONS(4439), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [96888] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2251), 1,
      anon_sym_COLON,
    ACTIONS(2542), 1,
      anon_sym_LPAREN,
    ACTIONS(4363), 1,
      anon_sym_EQ,
    STATE(2066), 1,
      sym_formal_parameters,
    STATE(2601), 1,
      sym__call_signature,
    STATE(2602), 1,
      sym_type_annotation,
    STATE(2885), 1,
      sym__initializer,
    STATE(3032), 1,
      sym_type_parameters,
    ACTIONS(4441), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [96924] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2251), 1,
      anon_sym_COLON,
    ACTIONS(2542), 1,
      anon_sym_LPAREN,
    STATE(2066), 1,
      sym_formal_parameters,
    STATE(2439), 1,
      sym__call_signature,
    STATE(2446), 1,
      sym_type_annotation,
    STATE(3032), 1,
      sym_type_parameters,
    ACTIONS(4443), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [96956] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2251), 1,
      anon_sym_COLON,
    ACTIONS(2542), 1,
      anon_sym_LPAREN,
    ACTIONS(4363), 1,
      anon_sym_EQ,
    STATE(2066), 1,
      sym_formal_parameters,
    STATE(2437), 1,
      sym_type_annotation,
    STATE(2752), 1,
      sym__call_signature,
    STATE(2793), 1,
      sym__initializer,
    STATE(3032), 1,
      sym_type_parameters,
    ACTIONS(4445), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [96992] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2251), 1,
      anon_sym_COLON,
    ACTIONS(2542), 1,
      anon_sym_LPAREN,
    ACTIONS(4363), 1,
      anon_sym_EQ,
    STATE(2066), 1,
      sym_formal_parameters,
    STATE(2387), 1,
      sym__call_signature,
    STATE(2395), 1,
      sym_type_annotation,
    STATE(2935), 1,
      sym__initializer,
    STATE(3032), 1,
      sym_type_parameters,
    ACTIONS(4447), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [97028] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2251), 1,
      anon_sym_COLON,
    ACTIONS(2542), 1,
      anon_sym_LPAREN,
    ACTIONS(4363), 1,
      anon_sym_EQ,
    STATE(2066), 1,
      sym_formal_parameters,
    STATE(2448), 1,
      sym__call_signature,
    STATE(2466), 1,
      sym_type_annotation,
    STATE(2866), 1,
      sym__initializer,
    STATE(3032), 1,
      sym_type_parameters,
    ACTIONS(4449), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [97064] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2251), 1,
      anon_sym_COLON,
    ACTIONS(2542), 1,
      anon_sym_LPAREN,
    STATE(2066), 1,
      sym_formal_parameters,
    STATE(2226), 1,
      sym__call_signature,
    STATE(2384), 1,
      sym_type_annotation,
    STATE(3032), 1,
      sym_type_parameters,
    ACTIONS(4437), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [97096] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4451), 1,
      anon_sym_LT,
    ACTIONS(4453), 1,
      anon_sym_DOT,
    ACTIONS(4455), 1,
      anon_sym_is,
    STATE(2145), 1,
      sym_type_arguments,
    ACTIONS(1710), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [97122] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2251), 1,
      anon_sym_COLON,
    ACTIONS(2542), 1,
      anon_sym_LPAREN,
    STATE(2066), 1,
      sym_formal_parameters,
    STATE(2237), 1,
      sym__call_signature,
    STATE(2616), 1,
      sym_type_annotation,
    STATE(3032), 1,
      sym_type_parameters,
    ACTIONS(4457), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [97154] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2251), 1,
      anon_sym_COLON,
    ACTIONS(2542), 1,
      anon_sym_LPAREN,
    STATE(2066), 1,
      sym_formal_parameters,
    STATE(2469), 1,
      sym_type_annotation,
    STATE(2485), 1,
      sym__call_signature,
    STATE(3032), 1,
      sym_type_parameters,
    ACTIONS(4439), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [97186] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2251), 1,
      anon_sym_COLON,
    ACTIONS(2542), 1,
      anon_sym_LPAREN,
    STATE(2066), 1,
      sym_formal_parameters,
    STATE(2616), 1,
      sym_type_annotation,
    STATE(2617), 1,
      sym__call_signature,
    STATE(3032), 1,
      sym_type_parameters,
    ACTIONS(4457), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [97218] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2251), 1,
      anon_sym_COLON,
    ACTIONS(2542), 1,
      anon_sym_LPAREN,
    STATE(2066), 1,
      sym_formal_parameters,
    STATE(2171), 1,
      sym__call_signature,
    STATE(2446), 1,
      sym_type_annotation,
    STATE(3032), 1,
      sym_type_parameters,
    ACTIONS(4443), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [97250] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2251), 1,
      anon_sym_COLON,
    ACTIONS(2542), 1,
      anon_sym_LPAREN,
    ACTIONS(4363), 1,
      anon_sym_EQ,
    STATE(2066), 1,
      sym_formal_parameters,
    STATE(2395), 1,
      sym_type_annotation,
    STATE(2896), 1,
      sym__call_signature,
    STATE(2935), 1,
      sym__initializer,
    STATE(3032), 1,
      sym_type_parameters,
    ACTIONS(4447), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [97286] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1561), 1,
      anon_sym_PIPE,
    ACTIONS(4379), 1,
      anon_sym_DOT,
    ACTIONS(1559), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [97308] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2251), 1,
      anon_sym_COLON,
    ACTIONS(2542), 1,
      anon_sym_LPAREN,
    ACTIONS(4363), 1,
      anon_sym_EQ,
    STATE(2066), 1,
      sym_formal_parameters,
    STATE(2437), 1,
      sym_type_annotation,
    STATE(2464), 1,
      sym__call_signature,
    STATE(2793), 1,
      sym__initializer,
    STATE(3032), 1,
      sym_type_parameters,
    ACTIONS(4445), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [97344] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4339), 1,
      anon_sym_LT,
    ACTIONS(4343), 1,
      anon_sym_DOT,
    ACTIONS(4459), 1,
      anon_sym_RPAREN,
    STATE(284), 1,
      sym_type_arguments,
    ACTIONS(1710), 4,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
    ACTIONS(2808), 4,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_QMARK,
  [97372] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4339), 1,
      anon_sym_LT,
    ACTIONS(4343), 1,
      anon_sym_DOT,
    STATE(284), 1,
      sym_type_arguments,
    ACTIONS(1710), 4,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
    ACTIONS(4462), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [97398] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1605), 1,
      anon_sym_PIPE,
    ACTIONS(1603), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [97417] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3545), 11,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [97434] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1581), 1,
      anon_sym_PIPE,
    ACTIONS(1579), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [97453] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3946), 1,
      anon_sym_EQ,
    STATE(2894), 1,
      aux_sym_object_repeat1,
    ACTIONS(2894), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [97474] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1191), 1,
      anon_sym_PIPE,
    ACTIONS(1189), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [97493] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1609), 1,
      anon_sym_PIPE,
    ACTIONS(1607), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [97512] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1557), 1,
      anon_sym_PIPE,
    ACTIONS(4464), 1,
      anon_sym_LBRACK,
    ACTIONS(1555), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [97533] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1545), 1,
      anon_sym_PIPE,
    ACTIONS(1543), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [97552] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1597), 1,
      anon_sym_PIPE,
    ACTIONS(1595), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [97571] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1581), 1,
      anon_sym_PIPE,
    ACTIONS(1579), 3,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
    ACTIONS(1575), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [97592] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3946), 1,
      anon_sym_EQ,
    STATE(2854), 1,
      aux_sym_object_repeat1,
    ACTIONS(2894), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [97613] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1541), 1,
      anon_sym_PIPE,
    ACTIONS(1539), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [97632] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4466), 1,
      anon_sym_AMP,
    ACTIONS(4468), 1,
      anon_sym_PIPE,
    ACTIONS(4470), 1,
      anon_sym_extends,
    ACTIONS(1768), 8,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACE,
  [97655] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1589), 1,
      anon_sym_PIPE,
    ACTIONS(1587), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [97674] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1573), 1,
      anon_sym_PIPE,
    ACTIONS(1571), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [97693] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1585), 1,
      anon_sym_PIPE,
    ACTIONS(1583), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [97712] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1601), 1,
      anon_sym_PIPE,
    ACTIONS(1599), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [97731] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4451), 1,
      anon_sym_LT,
    ACTIONS(4453), 1,
      anon_sym_DOT,
    STATE(2145), 1,
      sym_type_arguments,
    ACTIONS(1721), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [97754] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4451), 1,
      anon_sym_LT,
    ACTIONS(4453), 1,
      anon_sym_DOT,
    STATE(2145), 1,
      sym_type_arguments,
    ACTIONS(1710), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [97777] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1569), 1,
      anon_sym_PIPE,
    ACTIONS(1567), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [97796] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4451), 1,
      anon_sym_LT,
    ACTIONS(4472), 1,
      anon_sym_DOT,
    STATE(2145), 1,
      sym_type_arguments,
    ACTIONS(1559), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [97819] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4466), 1,
      anon_sym_AMP,
    ACTIONS(4468), 1,
      anon_sym_PIPE,
    ACTIONS(1778), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [97840] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3946), 1,
      anon_sym_EQ,
    STATE(2806), 1,
      aux_sym_object_repeat1,
    ACTIONS(2894), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [97861] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1515), 1,
      anon_sym_PIPE,
    ACTIONS(1513), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [97880] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3946), 1,
      anon_sym_EQ,
    STATE(2868), 1,
      aux_sym_object_repeat1,
    ACTIONS(2894), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [97901] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1561), 1,
      anon_sym_PIPE,
    ACTIONS(1559), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [97920] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1537), 1,
      anon_sym_PIPE,
    ACTIONS(1535), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [97939] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1523), 1,
      anon_sym_PIPE,
    ACTIONS(4464), 1,
      anon_sym_LBRACK,
    ACTIONS(1521), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [97960] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1519), 1,
      anon_sym_PIPE,
    ACTIONS(1517), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [97979] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1477), 1,
      anon_sym_PIPE,
    ACTIONS(1475), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [97998] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1553), 1,
      anon_sym_PIPE,
    ACTIONS(1551), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [98017] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1565), 1,
      anon_sym_PIPE,
    ACTIONS(1563), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [98036] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1529), 1,
      anon_sym_PIPE,
    ACTIONS(1527), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [98055] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1491), 1,
      anon_sym_PIPE,
    ACTIONS(1489), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [98074] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2894), 11,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [98091] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1752), 1,
      anon_sym_PIPE,
    ACTIONS(4389), 1,
      anon_sym_is,
    ACTIONS(1750), 9,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [98112] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4466), 1,
      anon_sym_AMP,
    ACTIONS(4468), 1,
      anon_sym_PIPE,
    ACTIONS(4470), 1,
      anon_sym_extends,
    ACTIONS(1788), 8,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACE,
  [98135] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1617), 1,
      anon_sym_PIPE,
    ACTIONS(1615), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [98154] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1613), 1,
      anon_sym_PIPE,
    ACTIONS(1611), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [98173] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1621), 1,
      anon_sym_PIPE,
    ACTIONS(1619), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [98192] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1549), 1,
      anon_sym_PIPE,
    ACTIONS(1547), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [98211] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1593), 1,
      anon_sym_PIPE,
    ACTIONS(1591), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [98230] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1533), 1,
      anon_sym_PIPE,
    ACTIONS(1531), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [98249] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1483), 1,
      anon_sym_PIPE,
    ACTIONS(1481), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [98268] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1511), 1,
      anon_sym_PIPE,
    ACTIONS(1509), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [98287] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1495), 1,
      anon_sym_PIPE,
    ACTIONS(1493), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [98306] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1487), 1,
      anon_sym_PIPE,
    ACTIONS(1485), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [98325] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(4474), 1,
      sym_identifier,
    ACTIONS(4476), 1,
      anon_sym_LBRACE,
    ACTIONS(4478), 1,
      anon_sym_implements,
    ACTIONS(4480), 1,
      anon_sym_extends,
    STATE(1617), 1,
      sym_class_body,
    STATE(2234), 1,
      sym_type_parameters,
    STATE(2922), 1,
      sym_extends_clause,
    STATE(3033), 1,
      sym_class_heritage,
    STATE(3290), 1,
      sym_implements_clause,
  [98359] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(4478), 1,
      anon_sym_implements,
    ACTIONS(4480), 1,
      anon_sym_extends,
    ACTIONS(4482), 1,
      sym_identifier,
    ACTIONS(4484), 1,
      anon_sym_LBRACE,
    STATE(1708), 1,
      sym_class_body,
    STATE(2181), 1,
      sym_type_parameters,
    STATE(2922), 1,
      sym_extends_clause,
    STATE(3124), 1,
      sym_class_heritage,
    STATE(3290), 1,
      sym_implements_clause,
  [98393] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4488), 1,
      anon_sym_COLON,
    STATE(2269), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
    ACTIONS(4486), 6,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [98413] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4451), 1,
      anon_sym_LT,
    STATE(2152), 1,
      sym_type_arguments,
    ACTIONS(1750), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [98433] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(4476), 1,
      anon_sym_LBRACE,
    ACTIONS(4478), 1,
      anon_sym_implements,
    ACTIONS(4480), 1,
      anon_sym_extends,
    ACTIONS(4490), 1,
      sym_identifier,
    STATE(1617), 1,
      sym_class_body,
    STATE(2234), 1,
      sym_type_parameters,
    STATE(2922), 1,
      sym_extends_clause,
    STATE(3033), 1,
      sym_class_heritage,
    STATE(3290), 1,
      sym_implements_clause,
  [98467] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(4478), 1,
      anon_sym_implements,
    ACTIONS(4480), 1,
      anon_sym_extends,
    ACTIONS(4484), 1,
      anon_sym_LBRACE,
    ACTIONS(4492), 1,
      sym_identifier,
    STATE(1674), 1,
      sym_class_body,
    STATE(2209), 1,
      sym_type_parameters,
    STATE(2922), 1,
      sym_extends_clause,
    STATE(3001), 1,
      sym_class_heritage,
    STATE(3290), 1,
      sym_implements_clause,
  [98501] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4466), 1,
      anon_sym_AMP,
    ACTIONS(4468), 1,
      anon_sym_PIPE,
    ACTIONS(4470), 1,
      anon_sym_extends,
    ACTIONS(4494), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [98523] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4488), 1,
      anon_sym_COLON,
    STATE(2282), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
    ACTIONS(4496), 6,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [98543] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4339), 1,
      anon_sym_LT,
    ACTIONS(4343), 1,
      anon_sym_DOT,
    ACTIONS(4498), 1,
      anon_sym_is,
    STATE(284), 1,
      sym_type_arguments,
    ACTIONS(1710), 6,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [98567] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2840), 1,
      anon_sym_EQ,
    ACTIONS(3545), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [98585] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(4476), 1,
      anon_sym_LBRACE,
    ACTIONS(4478), 1,
      anon_sym_implements,
    ACTIONS(4480), 1,
      anon_sym_extends,
    ACTIONS(4500), 1,
      sym_identifier,
    STATE(1646), 1,
      sym_class_body,
    STATE(2178), 1,
      sym_type_parameters,
    STATE(2922), 1,
      sym_extends_clause,
    STATE(2941), 1,
      sym_class_heritage,
    STATE(3290), 1,
      sym_implements_clause,
  [98619] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1396), 1,
      anon_sym_LT,
    ACTIONS(1015), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [98637] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1015), 1,
      anon_sym_DOT,
    ACTIONS(1396), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [98655] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2434), 1,
      anon_sym_DQUOTE,
    ACTIONS(2436), 1,
      anon_sym_SQUOTE,
    ACTIONS(2850), 1,
      anon_sym_LBRACE,
    ACTIONS(4502), 1,
      sym_identifier,
    ACTIONS(4504), 1,
      anon_sym_STAR,
    STATE(3106), 1,
      sym_import_clause,
    STATE(3118), 2,
      sym_string,
      sym_import_require_clause,
    STATE(3271), 2,
      sym_namespace_import,
      sym_named_imports,
  [98685] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(4476), 1,
      anon_sym_LBRACE,
    ACTIONS(4478), 1,
      anon_sym_implements,
    ACTIONS(4480), 1,
      anon_sym_extends,
    ACTIONS(4506), 1,
      sym_identifier,
    STATE(1617), 1,
      sym_class_body,
    STATE(2234), 1,
      sym_type_parameters,
    STATE(2922), 1,
      sym_extends_clause,
    STATE(3033), 1,
      sym_class_heritage,
    STATE(3290), 1,
      sym_implements_clause,
  [98719] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(4476), 1,
      anon_sym_LBRACE,
    ACTIONS(4478), 1,
      anon_sym_implements,
    ACTIONS(4480), 1,
      anon_sym_extends,
    ACTIONS(4508), 1,
      sym_identifier,
    STATE(1646), 1,
      sym_class_body,
    STATE(2178), 1,
      sym_type_parameters,
    STATE(2922), 1,
      sym_extends_clause,
    STATE(2941), 1,
      sym_class_heritage,
    STATE(3290), 1,
      sym_implements_clause,
  [98753] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(4478), 1,
      anon_sym_implements,
    ACTIONS(4480), 1,
      anon_sym_extends,
    ACTIONS(4510), 1,
      sym_identifier,
    ACTIONS(4512), 1,
      anon_sym_LBRACE,
    STATE(1187), 1,
      sym_class_body,
    STATE(2208), 1,
      sym_type_parameters,
    STATE(2922), 1,
      sym_extends_clause,
    STATE(3126), 1,
      sym_class_heritage,
    STATE(3290), 1,
      sym_implements_clause,
  [98787] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(4476), 1,
      anon_sym_LBRACE,
    ACTIONS(4478), 1,
      anon_sym_implements,
    ACTIONS(4480), 1,
      anon_sym_extends,
    ACTIONS(4514), 1,
      sym_identifier,
    STATE(1646), 1,
      sym_class_body,
    STATE(2178), 1,
      sym_type_parameters,
    STATE(2922), 1,
      sym_extends_clause,
    STATE(2941), 1,
      sym_class_heritage,
    STATE(3290), 1,
      sym_implements_clause,
  [98821] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3946), 1,
      anon_sym_EQ,
    ACTIONS(2932), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(2894), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [98841] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(4478), 1,
      anon_sym_implements,
    ACTIONS(4480), 1,
      anon_sym_extends,
    ACTIONS(4512), 1,
      anon_sym_LBRACE,
    ACTIONS(4516), 1,
      sym_identifier,
    STATE(1213), 1,
      sym_class_body,
    STATE(2183), 1,
      sym_type_parameters,
    STATE(2922), 1,
      sym_extends_clause,
    STATE(2960), 1,
      sym_class_heritage,
    STATE(3290), 1,
      sym_implements_clause,
  [98875] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4451), 1,
      anon_sym_LT,
    STATE(2152), 1,
      sym_type_arguments,
    ACTIONS(1615), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [98895] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(459), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4518), 1,
      sym_identifier,
    ACTIONS(4520), 1,
      anon_sym_RBRACK,
    STATE(2787), 1,
      sym__rest_identifier,
    STATE(2921), 2,
      sym_labeled_tuple_type_member,
      sym__tuple_type_member,
    STATE(2661), 3,
      sym_rest_identifier,
      sym_optional_identifier,
      sym__tuple_type_identifier,
  [98920] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2251), 1,
      anon_sym_COLON,
    ACTIONS(4363), 1,
      anon_sym_EQ,
    STATE(2402), 1,
      sym_type_annotation,
    STATE(2895), 1,
      sym__initializer,
    ACTIONS(4395), 2,
      anon_sym_BANG,
      anon_sym_QMARK,
    ACTIONS(4393), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [98945] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(4522), 1,
      anon_sym_LBRACE,
    ACTIONS(4524), 1,
      anon_sym_implements,
    ACTIONS(4526), 1,
      anon_sym_extends,
    STATE(2218), 1,
      sym_type_parameters,
    STATE(2600), 1,
      sym_class_body,
    STATE(2922), 1,
      sym_extends_clause,
    STATE(3047), 1,
      sym_class_heritage,
    STATE(3290), 1,
      sym_implements_clause,
  [98976] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(4524), 1,
      anon_sym_implements,
    ACTIONS(4526), 1,
      anon_sym_extends,
    ACTIONS(4528), 1,
      anon_sym_LBRACE,
    STATE(571), 1,
      sym_class_body,
    STATE(2221), 1,
      sym_type_parameters,
    STATE(2922), 1,
      sym_extends_clause,
    STATE(3046), 1,
      sym_class_heritage,
    STATE(3290), 1,
      sym_implements_clause,
  [99007] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(4484), 1,
      anon_sym_LBRACE,
    ACTIONS(4524), 1,
      anon_sym_implements,
    ACTIONS(4526), 1,
      anon_sym_extends,
    STATE(1702), 1,
      sym_class_body,
    STATE(2172), 1,
      sym_type_parameters,
    STATE(2922), 1,
      sym_extends_clause,
    STATE(3146), 1,
      sym_class_heritage,
    STATE(3290), 1,
      sym_implements_clause,
  [99038] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3023), 1,
      anon_sym_RPAREN,
    ACTIONS(1535), 4,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
    ACTIONS(2987), 4,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_QMARK,
  [99057] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(4522), 1,
      anon_sym_LBRACE,
    ACTIONS(4524), 1,
      anon_sym_implements,
    ACTIONS(4526), 1,
      anon_sym_extends,
    STATE(538), 1,
      sym_class_body,
    STATE(2199), 1,
      sym_type_parameters,
    STATE(2922), 1,
      sym_extends_clause,
    STATE(3056), 1,
      sym_class_heritage,
    STATE(3290), 1,
      sym_implements_clause,
  [99088] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(947), 4,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(1513), 5,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [99105] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(459), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4518), 1,
      sym_identifier,
    ACTIONS(4530), 1,
      anon_sym_RBRACK,
    STATE(2787), 1,
      sym__rest_identifier,
    STATE(2815), 2,
      sym_labeled_tuple_type_member,
      sym__tuple_type_member,
    STATE(2661), 3,
      sym_rest_identifier,
      sym_optional_identifier,
      sym__tuple_type_identifier,
  [99130] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4466), 1,
      anon_sym_AMP,
    ACTIONS(4468), 1,
      anon_sym_PIPE,
    ACTIONS(4470), 1,
      anon_sym_extends,
    ACTIONS(4532), 6,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [99151] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(4512), 1,
      anon_sym_LBRACE,
    ACTIONS(4524), 1,
      anon_sym_implements,
    ACTIONS(4526), 1,
      anon_sym_extends,
    STATE(1184), 1,
      sym_class_body,
    STATE(2238), 1,
      sym_type_parameters,
    STATE(2922), 1,
      sym_extends_clause,
    STATE(3007), 1,
      sym_class_heritage,
    STATE(3290), 1,
      sym_implements_clause,
  [99182] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(4524), 1,
      anon_sym_implements,
    ACTIONS(4526), 1,
      anon_sym_extends,
    ACTIONS(4534), 1,
      anon_sym_LBRACE,
    STATE(73), 1,
      sym_class_body,
    STATE(2216), 1,
      sym_type_parameters,
    STATE(2922), 1,
      sym_extends_clause,
    STATE(3085), 1,
      sym_class_heritage,
    STATE(3290), 1,
      sym_implements_clause,
  [99213] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(4522), 1,
      anon_sym_LBRACE,
    ACTIONS(4524), 1,
      anon_sym_implements,
    ACTIONS(4526), 1,
      anon_sym_extends,
    STATE(2231), 1,
      sym_type_parameters,
    STATE(2509), 1,
      sym_class_body,
    STATE(2922), 1,
      sym_extends_clause,
    STATE(3027), 1,
      sym_class_heritage,
    STATE(3290), 1,
      sym_implements_clause,
  [99244] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(459), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1181), 1,
      anon_sym_RBRACK,
    ACTIONS(4518), 1,
      sym_identifier,
    STATE(2787), 1,
      sym__rest_identifier,
    STATE(2790), 2,
      sym_labeled_tuple_type_member,
      sym__tuple_type_member,
    STATE(2661), 3,
      sym_rest_identifier,
      sym_optional_identifier,
      sym__tuple_type_identifier,
  [99269] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(4484), 1,
      anon_sym_LBRACE,
    ACTIONS(4524), 1,
      anon_sym_implements,
    ACTIONS(4526), 1,
      anon_sym_extends,
    STATE(1710), 1,
      sym_class_body,
    STATE(2176), 1,
      sym_type_parameters,
    STATE(2922), 1,
      sym_extends_clause,
    STATE(3130), 1,
      sym_class_heritage,
    STATE(3290), 1,
      sym_implements_clause,
  [99300] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(4522), 1,
      anon_sym_LBRACE,
    ACTIONS(4524), 1,
      anon_sym_implements,
    ACTIONS(4526), 1,
      anon_sym_extends,
    STATE(526), 1,
      sym_class_body,
    STATE(2230), 1,
      sym_type_parameters,
    STATE(2922), 1,
      sym_extends_clause,
    STATE(3014), 1,
      sym_class_heritage,
    STATE(3290), 1,
      sym_implements_clause,
  [99331] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4455), 1,
      anon_sym_is,
    ACTIONS(1750), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [99348] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4472), 1,
      anon_sym_DOT,
    ACTIONS(1559), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [99365] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(459), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4518), 1,
      sym_identifier,
    ACTIONS(4536), 1,
      anon_sym_RBRACK,
    STATE(2787), 1,
      sym__rest_identifier,
    STATE(2877), 2,
      sym_labeled_tuple_type_member,
      sym__tuple_type_member,
    STATE(2661), 3,
      sym_rest_identifier,
      sym_optional_identifier,
      sym__tuple_type_identifier,
  [99390] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1513), 4,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
    ACTIONS(947), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [99407] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(4512), 1,
      anon_sym_LBRACE,
    ACTIONS(4524), 1,
      anon_sym_implements,
    ACTIONS(4526), 1,
      anon_sym_extends,
    STATE(1214), 1,
      sym_class_body,
    STATE(2213), 1,
      sym_type_parameters,
    STATE(2922), 1,
      sym_extends_clause,
    STATE(3116), 1,
      sym_class_heritage,
    STATE(3290), 1,
      sym_implements_clause,
  [99438] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4466), 1,
      anon_sym_AMP,
    ACTIONS(4468), 1,
      anon_sym_PIPE,
    ACTIONS(4470), 1,
      anon_sym_extends,
    ACTIONS(4538), 6,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [99459] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(459), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4518), 1,
      sym_identifier,
    ACTIONS(4540), 1,
      anon_sym_RBRACK,
    STATE(2787), 1,
      sym__rest_identifier,
    STATE(2777), 2,
      sym_labeled_tuple_type_member,
      sym__tuple_type_member,
    STATE(2661), 3,
      sym_rest_identifier,
      sym_optional_identifier,
      sym__tuple_type_identifier,
  [99484] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2251), 1,
      anon_sym_COLON,
    ACTIONS(4363), 1,
      anon_sym_EQ,
    STATE(2442), 1,
      sym_type_annotation,
    STATE(2785), 1,
      sym__initializer,
    ACTIONS(4383), 2,
      anon_sym_BANG,
      anon_sym_QMARK,
    ACTIONS(4381), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [99509] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(4524), 1,
      anon_sym_implements,
    ACTIONS(4526), 1,
      anon_sym_extends,
    ACTIONS(4534), 1,
      anon_sym_LBRACE,
    STATE(98), 1,
      sym_class_body,
    STATE(2179), 1,
      sym_type_parameters,
    STATE(2922), 1,
      sym_extends_clause,
    STATE(3139), 1,
      sym_class_heritage,
    STATE(3290), 1,
      sym_implements_clause,
  [99540] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4345), 1,
      anon_sym_AMP,
    ACTIONS(4347), 1,
      anon_sym_PIPE,
    ACTIONS(4349), 1,
      anon_sym_extends,
    ACTIONS(4542), 1,
      anon_sym_EQ,
    ACTIONS(4494), 5,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_EQ_GT,
  [99563] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4544), 1,
      anon_sym_RPAREN,
    ACTIONS(1189), 4,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
    ACTIONS(1736), 4,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_QMARK,
  [99582] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1750), 4,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
    ACTIONS(4462), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [99599] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(4522), 1,
      anon_sym_LBRACE,
    ACTIONS(4524), 1,
      anon_sym_implements,
    ACTIONS(4526), 1,
      anon_sym_extends,
    STATE(2210), 1,
      sym_type_parameters,
    STATE(2576), 1,
      sym_class_body,
    STATE(2922), 1,
      sym_extends_clause,
    STATE(3123), 1,
      sym_class_heritage,
    STATE(3290), 1,
      sym_implements_clause,
  [99630] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(4476), 1,
      anon_sym_LBRACE,
    ACTIONS(4524), 1,
      anon_sym_implements,
    ACTIONS(4526), 1,
      anon_sym_extends,
    STATE(1519), 1,
      sym_class_body,
    STATE(2245), 1,
      sym_type_parameters,
    STATE(2922), 1,
      sym_extends_clause,
    STATE(2993), 1,
      sym_class_heritage,
    STATE(3290), 1,
      sym_implements_clause,
  [99661] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1189), 4,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
    ACTIONS(2223), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [99678] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(459), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1179), 1,
      anon_sym_RBRACK,
    ACTIONS(4518), 1,
      sym_identifier,
    STATE(2787), 1,
      sym__rest_identifier,
    STATE(2831), 2,
      sym_labeled_tuple_type_member,
      sym__tuple_type_member,
    STATE(2661), 3,
      sym_rest_identifier,
      sym_optional_identifier,
      sym__tuple_type_identifier,
  [99703] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(4476), 1,
      anon_sym_LBRACE,
    ACTIONS(4524), 1,
      anon_sym_implements,
    ACTIONS(4526), 1,
      anon_sym_extends,
    STATE(1492), 1,
      sym_class_body,
    STATE(2207), 1,
      sym_type_parameters,
    STATE(2922), 1,
      sym_extends_clause,
    STATE(3154), 1,
      sym_class_heritage,
    STATE(3290), 1,
      sym_implements_clause,
  [99734] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4547), 1,
      anon_sym_RPAREN,
    ACTIONS(1750), 4,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
    ACTIONS(2808), 4,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_QMARK,
  [99753] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(4476), 1,
      anon_sym_LBRACE,
    ACTIONS(4524), 1,
      anon_sym_implements,
    ACTIONS(4526), 1,
      anon_sym_extends,
    STATE(1399), 1,
      sym_class_body,
    STATE(2220), 1,
      sym_type_parameters,
    STATE(2922), 1,
      sym_extends_clause,
    STATE(3063), 1,
      sym_class_heritage,
    STATE(3290), 1,
      sym_implements_clause,
  [99784] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(4522), 1,
      anon_sym_LBRACE,
    ACTIONS(4524), 1,
      anon_sym_implements,
    ACTIONS(4526), 1,
      anon_sym_extends,
    STATE(2223), 1,
      sym_type_parameters,
    STATE(2494), 1,
      sym_class_body,
    STATE(2922), 1,
      sym_extends_clause,
    STATE(3059), 1,
      sym_class_heritage,
    STATE(3290), 1,
      sym_implements_clause,
  [99815] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(4476), 1,
      anon_sym_LBRACE,
    ACTIONS(4524), 1,
      anon_sym_implements,
    ACTIONS(4526), 1,
      anon_sym_extends,
    STATE(1596), 1,
      sym_class_body,
    STATE(2219), 1,
      sym_type_parameters,
    STATE(2922), 1,
      sym_extends_clause,
    STATE(2949), 1,
      sym_class_heritage,
    STATE(3290), 1,
      sym_implements_clause,
  [99846] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(4524), 1,
      anon_sym_implements,
    ACTIONS(4526), 1,
      anon_sym_extends,
    ACTIONS(4528), 1,
      anon_sym_LBRACE,
    STATE(605), 1,
      sym_class_body,
    STATE(2175), 1,
      sym_type_parameters,
    STATE(2922), 1,
      sym_extends_clause,
    STATE(3140), 1,
      sym_class_heritage,
    STATE(3290), 1,
      sym_implements_clause,
  [99877] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4466), 1,
      anon_sym_AMP,
    ACTIONS(4468), 1,
      anon_sym_PIPE,
    ACTIONS(4470), 1,
      anon_sym_extends,
    ACTIONS(4550), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [99897] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1587), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [99911] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(1248), 1,
      anon_sym_RBRACE,
    ACTIONS(3946), 1,
      anon_sym_EQ,
    STATE(2854), 1,
      aux_sym_object_repeat1,
    ACTIONS(2894), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [99933] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4466), 1,
      anon_sym_AMP,
    ACTIONS(4468), 1,
      anon_sym_PIPE,
    ACTIONS(4470), 1,
      anon_sym_extends,
    ACTIONS(4552), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [99953] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1607), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [99967] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4554), 1,
      anon_sym_LBRACK,
    ACTIONS(1555), 7,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [99983] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1493), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [99997] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1603), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [100011] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1189), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [100025] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(459), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4518), 1,
      sym_identifier,
    STATE(2787), 1,
      sym__rest_identifier,
    STATE(2986), 2,
      sym_labeled_tuple_type_member,
      sym__tuple_type_member,
    STATE(2661), 3,
      sym_rest_identifier,
      sym_optional_identifier,
      sym__tuple_type_identifier,
  [100047] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_COLON,
    STATE(2709), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
    ACTIONS(4486), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
  [100065] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1571), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [100079] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4558), 1,
      anon_sym_AMP,
    ACTIONS(4560), 1,
      anon_sym_PIPE,
    ACTIONS(1778), 6,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
  [100097] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1079), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [100111] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(1205), 1,
      anon_sym_RBRACE,
    ACTIONS(3946), 1,
      anon_sym_EQ,
    STATE(2894), 1,
      aux_sym_object_repeat1,
    ACTIONS(2894), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [100133] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4562), 1,
      anon_sym_LBRACE,
    ACTIONS(4564), 1,
      anon_sym_DOT,
    STATE(2595), 1,
      sym_statement_block,
    ACTIONS(933), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [100153] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1543), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [100167] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1513), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [100181] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(3946), 1,
      anon_sym_EQ,
    ACTIONS(4120), 1,
      anon_sym_RBRACE,
    STATE(2806), 1,
      aux_sym_object_repeat1,
    ACTIONS(2894), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [100203] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2251), 1,
      anon_sym_COLON,
    ACTIONS(4363), 1,
      anon_sym_EQ,
    ACTIONS(4566), 1,
      anon_sym_BANG,
    STATE(2451), 1,
      sym_type_annotation,
    STATE(2754), 1,
      sym__initializer,
    ACTIONS(2242), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [100227] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1559), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [100241] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1535), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [100255] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(3946), 1,
      anon_sym_EQ,
    ACTIONS(4118), 1,
      anon_sym_RBRACE,
    STATE(2873), 1,
      aux_sym_object_repeat1,
    ACTIONS(2894), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [100277] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4554), 1,
      anon_sym_LBRACK,
    ACTIONS(1521), 7,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [100293] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1517), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [100307] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1551), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [100321] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1563), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [100335] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1489), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [100349] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1591), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [100363] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1509), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [100377] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1595), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [100391] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [100405] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1615), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [100419] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_COLON,
    STATE(2711), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
    ACTIONS(4496), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
  [100437] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1485), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [100451] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(1246), 1,
      anon_sym_RBRACE,
    ACTIONS(3946), 1,
      anon_sym_EQ,
    STATE(2868), 1,
      aux_sym_object_repeat1,
    ACTIONS(2894), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [100473] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1481), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [100487] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1087), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [100501] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4558), 1,
      anon_sym_AMP,
    ACTIONS(4560), 1,
      anon_sym_PIPE,
    ACTIONS(4568), 1,
      anon_sym_extends,
    ACTIONS(1788), 5,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
  [100521] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1527), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [100535] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1611), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [100549] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1547), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [100563] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4466), 1,
      anon_sym_AMP,
    ACTIONS(4468), 1,
      anon_sym_PIPE,
    ACTIONS(4470), 1,
      anon_sym_extends,
    ACTIONS(1782), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [100583] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1575), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
    ACTIONS(1579), 4,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [100599] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1579), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [100613] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1567), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [100627] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1539), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [100641] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1599), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [100655] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1531), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [100669] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4558), 1,
      anon_sym_AMP,
    ACTIONS(4560), 1,
      anon_sym_PIPE,
    ACTIONS(4568), 1,
      anon_sym_extends,
    ACTIONS(1768), 5,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
  [100689] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1583), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [100703] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1619), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [100717] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2251), 1,
      anon_sym_COLON,
    ACTIONS(4363), 1,
      anon_sym_EQ,
    STATE(2602), 1,
      sym_type_annotation,
    STATE(2885), 1,
      sym__initializer,
    ACTIONS(4441), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [100738] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1796), 1,
      anon_sym_LBRACE,
    STATE(2985), 1,
      sym_statement_block,
    ACTIONS(4570), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [100755] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4484), 1,
      anon_sym_LBRACE,
    ACTIONS(4524), 1,
      anon_sym_implements,
    ACTIONS(4526), 1,
      anon_sym_extends,
    STATE(1675), 1,
      sym_class_body,
    STATE(2922), 1,
      sym_extends_clause,
    STATE(3141), 1,
      sym_class_heritage,
    STATE(3290), 1,
      sym_implements_clause,
  [100780] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4562), 1,
      anon_sym_LBRACE,
    STATE(2595), 1,
      sym_statement_block,
    ACTIONS(933), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [100797] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4572), 1,
      sym_identifier,
    ACTIONS(4574), 1,
      anon_sym_LBRACE,
    ACTIONS(4576), 1,
      anon_sym_LBRACK,
    ACTIONS(4578), 1,
      anon_sym_enum,
    STATE(2190), 1,
      sym_array,
    STATE(2192), 1,
      sym_object,
    STATE(2732), 1,
      sym_variable_declarator,
  [100822] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4524), 1,
      anon_sym_implements,
    ACTIONS(4526), 1,
      anon_sym_extends,
    ACTIONS(4528), 1,
      anon_sym_LBRACE,
    STATE(585), 1,
      sym_class_body,
    STATE(2922), 1,
      sym_extends_clause,
    STATE(3009), 1,
      sym_class_heritage,
    STATE(3290), 1,
      sym_implements_clause,
  [100847] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4484), 1,
      anon_sym_LBRACE,
    ACTIONS(4524), 1,
      anon_sym_implements,
    ACTIONS(4526), 1,
      anon_sym_extends,
    STATE(1720), 1,
      sym_class_body,
    STATE(2922), 1,
      sym_extends_clause,
    STATE(3155), 1,
      sym_class_heritage,
    STATE(3290), 1,
      sym_implements_clause,
  [100872] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(4580), 1,
      sym_identifier,
    ACTIONS(4582), 1,
      anon_sym_STAR,
    ACTIONS(4584), 1,
      anon_sym_LPAREN,
    STATE(2295), 1,
      sym_formal_parameters,
    STATE(3054), 1,
      sym_type_parameters,
    STATE(3069), 1,
      sym__call_signature,
  [100897] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4476), 1,
      anon_sym_LBRACE,
    ACTIONS(4524), 1,
      anon_sym_implements,
    ACTIONS(4526), 1,
      anon_sym_extends,
    STATE(1611), 1,
      sym_class_body,
    STATE(2922), 1,
      sym_extends_clause,
    STATE(3072), 1,
      sym_class_heritage,
    STATE(3290), 1,
      sym_implements_clause,
  [100922] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4524), 1,
      anon_sym_implements,
    ACTIONS(4526), 1,
      anon_sym_extends,
    ACTIONS(4534), 1,
      anon_sym_LBRACE,
    STATE(83), 1,
      sym_class_body,
    STATE(2922), 1,
      sym_extends_clause,
    STATE(3044), 1,
      sym_class_heritage,
    STATE(3290), 1,
      sym_implements_clause,
  [100947] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(4584), 1,
      anon_sym_LPAREN,
    ACTIONS(4586), 1,
      sym_identifier,
    ACTIONS(4588), 1,
      anon_sym_STAR,
    STATE(2295), 1,
      sym_formal_parameters,
    STATE(2953), 1,
      sym__call_signature,
    STATE(3054), 1,
      sym_type_parameters,
  [100972] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4484), 1,
      anon_sym_LBRACE,
    ACTIONS(4524), 1,
      anon_sym_implements,
    ACTIONS(4526), 1,
      anon_sym_extends,
    STATE(1730), 1,
      sym_class_body,
    STATE(2922), 1,
      sym_extends_clause,
    STATE(3049), 1,
      sym_class_heritage,
    STATE(3290), 1,
      sym_implements_clause,
  [100997] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4592), 1,
      anon_sym_DOT,
    STATE(518), 1,
      sym_nested_identifier,
    STATE(523), 1,
      sym_string,
    STATE(564), 1,
      sym__module,
  [101022] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4512), 1,
      anon_sym_LBRACE,
    ACTIONS(4524), 1,
      anon_sym_implements,
    ACTIONS(4526), 1,
      anon_sym_extends,
    STATE(1185), 1,
      sym_class_body,
    STATE(2922), 1,
      sym_extends_clause,
    STATE(3153), 1,
      sym_class_heritage,
    STATE(3290), 1,
      sym_implements_clause,
  [101047] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(499), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(915), 1,
      anon_sym_LBRACE,
    ACTIONS(4594), 1,
      anon_sym_LT,
    ACTIONS(4596), 1,
      anon_sym_extends,
    STATE(595), 1,
      sym_object_type,
    STATE(2564), 1,
      sym_type_parameters,
    STATE(2859), 1,
      sym_extends_clause,
  [101072] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(4584), 1,
      anon_sym_LPAREN,
    ACTIONS(4598), 1,
      sym_identifier,
    ACTIONS(4600), 1,
      anon_sym_STAR,
    STATE(2295), 1,
      sym_formal_parameters,
    STATE(2953), 1,
      sym__call_signature,
    STATE(3054), 1,
      sym_type_parameters,
  [101097] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3218), 1,
      anon_sym_COLON,
    ACTIONS(4602), 1,
      anon_sym_EQ,
    ACTIONS(4606), 1,
      anon_sym_QMARK,
    STATE(2676), 1,
      sym_type_annotation,
    STATE(3138), 1,
      sym__initializer,
    ACTIONS(4604), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [101120] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2251), 1,
      anon_sym_COLON,
    ACTIONS(4363), 1,
      anon_sym_EQ,
    STATE(2466), 1,
      sym_type_annotation,
    STATE(2866), 1,
      sym__initializer,
    ACTIONS(4449), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [101141] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4558), 1,
      anon_sym_AMP,
    ACTIONS(4560), 1,
      anon_sym_PIPE,
    ACTIONS(4568), 1,
      anon_sym_extends,
    ACTIONS(4538), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
  [101160] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(4590), 1,
      sym_identifier,
    ACTIONS(4608), 1,
      anon_sym_DOT,
    STATE(518), 1,
      sym_nested_identifier,
    STATE(523), 1,
      sym_string,
    STATE(564), 1,
      sym__module,
  [101185] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2251), 1,
      anon_sym_COLON,
    ACTIONS(4363), 1,
      anon_sym_EQ,
    STATE(2459), 1,
      sym_type_annotation,
    STATE(2763), 1,
      sym__initializer,
    ACTIONS(3136), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [101206] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4558), 1,
      anon_sym_AMP,
    ACTIONS(4560), 1,
      anon_sym_PIPE,
    ACTIONS(4568), 1,
      anon_sym_extends,
    ACTIONS(4532), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
  [101225] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2251), 1,
      anon_sym_COLON,
    ACTIONS(4363), 1,
      anon_sym_EQ,
    STATE(2458), 1,
      sym_type_annotation,
    STATE(2762), 1,
      sym__initializer,
    ACTIONS(3145), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [101246] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2434), 1,
      anon_sym_DQUOTE,
    ACTIONS(2436), 1,
      anon_sym_SQUOTE,
    ACTIONS(4610), 1,
      sym_identifier,
    ACTIONS(4612), 1,
      anon_sym_DOT,
    STATE(2133), 1,
      sym_nested_identifier,
    STATE(2173), 1,
      sym_string,
    STATE(2535), 1,
      sym__module,
  [101271] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(613), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2420), 1,
      anon_sym_LBRACE,
    ACTIONS(4594), 1,
      anon_sym_LT,
    ACTIONS(4596), 1,
      anon_sym_extends,
    STATE(2468), 1,
      sym_type_parameters,
    STATE(2563), 1,
      sym_object_type,
    STATE(2764), 1,
      sym_extends_clause,
  [101296] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(4584), 1,
      anon_sym_LPAREN,
    ACTIONS(4614), 1,
      sym_identifier,
    ACTIONS(4616), 1,
      anon_sym_STAR,
    STATE(2295), 1,
      sym_formal_parameters,
    STATE(3054), 1,
      sym_type_parameters,
    STATE(3069), 1,
      sym__call_signature,
  [101321] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(4584), 1,
      anon_sym_LPAREN,
    ACTIONS(4618), 1,
      sym_identifier,
    ACTIONS(4620), 1,
      anon_sym_STAR,
    STATE(2295), 1,
      sym_formal_parameters,
    STATE(2953), 1,
      sym__call_signature,
    STATE(3054), 1,
      sym_type_parameters,
  [101346] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4558), 1,
      anon_sym_AMP,
    ACTIONS(4560), 1,
      anon_sym_PIPE,
    ACTIONS(4568), 1,
      anon_sym_extends,
    ACTIONS(4494), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
  [101365] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(4584), 1,
      anon_sym_LPAREN,
    ACTIONS(4600), 1,
      anon_sym_STAR,
    ACTIONS(4622), 1,
      sym_identifier,
    STATE(2295), 1,
      sym_formal_parameters,
    STATE(2953), 1,
      sym__call_signature,
    STATE(3054), 1,
      sym_type_parameters,
  [101390] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4522), 1,
      anon_sym_LBRACE,
    ACTIONS(4524), 1,
      anon_sym_implements,
    ACTIONS(4526), 1,
      anon_sym_extends,
    STATE(532), 1,
      sym_class_body,
    STATE(2922), 1,
      sym_extends_clause,
    STATE(3083), 1,
      sym_class_heritage,
    STATE(3290), 1,
      sym_implements_clause,
  [101415] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(4584), 1,
      anon_sym_LPAREN,
    ACTIONS(4624), 1,
      anon_sym_COLON,
    ACTIONS(4626), 1,
      anon_sym_QMARK,
    STATE(2295), 1,
      sym_formal_parameters,
    STATE(3054), 1,
      sym_type_parameters,
    STATE(3074), 1,
      sym__call_signature,
  [101440] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3946), 1,
      anon_sym_EQ,
    ACTIONS(4164), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(2894), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [101457] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(4584), 1,
      anon_sym_LPAREN,
    ACTIONS(4628), 1,
      sym_identifier,
    ACTIONS(4630), 1,
      anon_sym_STAR,
    STATE(2295), 1,
      sym_formal_parameters,
    STATE(3054), 1,
      sym_type_parameters,
    STATE(3069), 1,
      sym__call_signature,
  [101482] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2251), 1,
      anon_sym_COLON,
    STATE(2594), 1,
      sym_type_annotation,
    ACTIONS(4632), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [101499] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(4584), 1,
      anon_sym_LPAREN,
    ACTIONS(4634), 1,
      sym_identifier,
    ACTIONS(4636), 1,
      anon_sym_STAR,
    STATE(2295), 1,
      sym_formal_parameters,
    STATE(3054), 1,
      sym_type_parameters,
    STATE(3099), 1,
      sym__call_signature,
  [101524] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2251), 1,
      anon_sym_COLON,
    ACTIONS(4363), 1,
      anon_sym_EQ,
    STATE(2395), 1,
      sym_type_annotation,
    STATE(2935), 1,
      sym__initializer,
    ACTIONS(4447), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [101545] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(4584), 1,
      anon_sym_LPAREN,
    ACTIONS(4638), 1,
      sym_identifier,
    ACTIONS(4640), 1,
      anon_sym_STAR,
    STATE(2295), 1,
      sym_formal_parameters,
    STATE(3026), 1,
      sym__call_signature,
    STATE(3054), 1,
      sym_type_parameters,
  [101570] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4476), 1,
      anon_sym_LBRACE,
    ACTIONS(4524), 1,
      anon_sym_implements,
    ACTIONS(4526), 1,
      anon_sym_extends,
    STATE(1417), 1,
      sym_class_body,
    STATE(2922), 1,
      sym_extends_clause,
    STATE(3088), 1,
      sym_class_heritage,
    STATE(3290), 1,
      sym_implements_clause,
  [101595] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4512), 1,
      anon_sym_LBRACE,
    ACTIONS(4524), 1,
      anon_sym_implements,
    ACTIONS(4526), 1,
      anon_sym_extends,
    STATE(1238), 1,
      sym_class_body,
    STATE(2922), 1,
      sym_extends_clause,
    STATE(3062), 1,
      sym_class_heritage,
    STATE(3290), 1,
      sym_implements_clause,
  [101620] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4484), 1,
      anon_sym_LBRACE,
    ACTIONS(4524), 1,
      anon_sym_implements,
    ACTIONS(4526), 1,
      anon_sym_extends,
    STATE(1707), 1,
      sym_class_body,
    STATE(2922), 1,
      sym_extends_clause,
    STATE(3095), 1,
      sym_class_heritage,
    STATE(3290), 1,
      sym_implements_clause,
  [101645] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4522), 1,
      anon_sym_LBRACE,
    ACTIONS(4524), 1,
      anon_sym_implements,
    ACTIONS(4526), 1,
      anon_sym_extends,
    STATE(2597), 1,
      sym_class_body,
    STATE(2922), 1,
      sym_extends_clause,
    STATE(3061), 1,
      sym_class_heritage,
    STATE(3290), 1,
      sym_implements_clause,
  [101670] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4401), 1,
      anon_sym_EQ,
    STATE(2660), 1,
      sym_constraint,
    STATE(3109), 1,
      sym_default_type,
    ACTIONS(4406), 2,
      anon_sym_COLON,
      anon_sym_extends,
    ACTIONS(4642), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [101691] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4644), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_PIPE_RBRACE,
  [101704] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4512), 1,
      anon_sym_LBRACE,
    ACTIONS(4524), 1,
      anon_sym_implements,
    ACTIONS(4526), 1,
      anon_sym_extends,
    STATE(1218), 1,
      sym_class_body,
    STATE(2922), 1,
      sym_extends_clause,
    STATE(3057), 1,
      sym_class_heritage,
    STATE(3290), 1,
      sym_implements_clause,
  [101729] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1796), 1,
      anon_sym_LBRACE,
    STATE(2995), 1,
      sym_statement_block,
    ACTIONS(4646), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [101746] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3119), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_PIPE_RBRACE,
  [101759] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4524), 1,
      anon_sym_implements,
    ACTIONS(4526), 1,
      anon_sym_extends,
    ACTIONS(4534), 1,
      anon_sym_LBRACE,
    STATE(81), 1,
      sym_class_body,
    STATE(2922), 1,
      sym_extends_clause,
    STATE(3111), 1,
      sym_class_heritage,
    STATE(3290), 1,
      sym_implements_clause,
  [101784] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(4584), 1,
      anon_sym_LPAREN,
    ACTIONS(4630), 1,
      anon_sym_STAR,
    ACTIONS(4648), 1,
      sym_identifier,
    STATE(2295), 1,
      sym_formal_parameters,
    STATE(3054), 1,
      sym_type_parameters,
    STATE(3069), 1,
      sym__call_signature,
  [101809] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4522), 1,
      anon_sym_LBRACE,
    ACTIONS(4524), 1,
      anon_sym_implements,
    ACTIONS(4526), 1,
      anon_sym_extends,
    STATE(2547), 1,
      sym_class_body,
    STATE(2922), 1,
      sym_extends_clause,
    STATE(3039), 1,
      sym_class_heritage,
    STATE(3290), 1,
      sym_implements_clause,
  [101834] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4476), 1,
      anon_sym_LBRACE,
    ACTIONS(4524), 1,
      anon_sym_implements,
    ACTIONS(4526), 1,
      anon_sym_extends,
    STATE(1603), 1,
      sym_class_body,
    STATE(2922), 1,
      sym_extends_clause,
    STATE(3102), 1,
      sym_class_heritage,
    STATE(3290), 1,
      sym_implements_clause,
  [101859] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4476), 1,
      anon_sym_LBRACE,
    ACTIONS(4524), 1,
      anon_sym_implements,
    ACTIONS(4526), 1,
      anon_sym_extends,
    STATE(1379), 1,
      sym_class_body,
    STATE(2922), 1,
      sym_extends_clause,
    STATE(3028), 1,
      sym_class_heritage,
    STATE(3290), 1,
      sym_implements_clause,
  [101884] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4524), 1,
      anon_sym_implements,
    ACTIONS(4526), 1,
      anon_sym_extends,
    ACTIONS(4528), 1,
      anon_sym_LBRACE,
    STATE(587), 1,
      sym_class_body,
    STATE(2922), 1,
      sym_extends_clause,
    STATE(2989), 1,
      sym_class_heritage,
    STATE(3290), 1,
      sym_implements_clause,
  [101909] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4650), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_PIPE_RBRACE,
  [101922] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4522), 1,
      anon_sym_LBRACE,
    ACTIONS(4524), 1,
      anon_sym_implements,
    ACTIONS(4526), 1,
      anon_sym_extends,
    STATE(2483), 1,
      sym_class_body,
    STATE(2922), 1,
      sym_extends_clause,
    STATE(3022), 1,
      sym_class_heritage,
    STATE(3290), 1,
      sym_implements_clause,
  [101947] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1796), 1,
      anon_sym_LBRACE,
    STATE(2971), 1,
      sym_statement_block,
    ACTIONS(4652), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [101964] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4654), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_PIPE_RBRACE,
  [101977] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1796), 1,
      anon_sym_LBRACE,
    STATE(2983), 1,
      sym_statement_block,
    ACTIONS(4656), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [101994] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(4584), 1,
      anon_sym_LPAREN,
    ACTIONS(4658), 1,
      sym_identifier,
    ACTIONS(4660), 1,
      anon_sym_STAR,
    STATE(2295), 1,
      sym_formal_parameters,
    STATE(2963), 1,
      sym__call_signature,
    STATE(3054), 1,
      sym_type_parameters,
  [102019] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1796), 1,
      anon_sym_LBRACE,
    STATE(3096), 1,
      sym_statement_block,
    ACTIONS(4662), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [102036] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1796), 1,
      anon_sym_LBRACE,
    STATE(3087), 1,
      sym_statement_block,
    ACTIONS(4664), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [102053] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4522), 1,
      anon_sym_LBRACE,
    ACTIONS(4524), 1,
      anon_sym_implements,
    ACTIONS(4526), 1,
      anon_sym_extends,
    STATE(525), 1,
      sym_class_body,
    STATE(2922), 1,
      sym_extends_clause,
    STATE(3086), 1,
      sym_class_heritage,
    STATE(3290), 1,
      sym_implements_clause,
  [102078] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4522), 1,
      anon_sym_LBRACE,
    ACTIONS(4524), 1,
      anon_sym_implements,
    ACTIONS(4526), 1,
      anon_sym_extends,
    STATE(2447), 1,
      sym_class_body,
    STATE(2922), 1,
      sym_extends_clause,
    STATE(3016), 1,
      sym_class_heritage,
    STATE(3290), 1,
      sym_implements_clause,
  [102103] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4666), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_PIPE_RBRACE,
  [102116] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(4584), 1,
      anon_sym_LPAREN,
    ACTIONS(4630), 1,
      anon_sym_STAR,
    ACTIONS(4668), 1,
      sym_identifier,
    STATE(2295), 1,
      sym_formal_parameters,
    STATE(3054), 1,
      sym_type_parameters,
    STATE(3069), 1,
      sym__call_signature,
  [102141] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4476), 1,
      anon_sym_LBRACE,
    ACTIONS(4524), 1,
      anon_sym_implements,
    ACTIONS(4526), 1,
      anon_sym_extends,
    STATE(1640), 1,
      sym_class_body,
    STATE(2922), 1,
      sym_extends_clause,
    STATE(3117), 1,
      sym_class_heritage,
    STATE(3290), 1,
      sym_implements_clause,
  [102166] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4498), 1,
      anon_sym_is,
    ACTIONS(1750), 6,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [102181] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2251), 1,
      anon_sym_COLON,
    STATE(2478), 1,
      sym_type_annotation,
    ACTIONS(4670), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [102198] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1796), 1,
      anon_sym_LBRACE,
    STATE(2975), 1,
      sym_statement_block,
    ACTIONS(4672), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [102215] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4512), 1,
      anon_sym_LBRACE,
    ACTIONS(4524), 1,
      anon_sym_implements,
    ACTIONS(4526), 1,
      anon_sym_extends,
    STATE(1135), 1,
      sym_class_body,
    STATE(2922), 1,
      sym_extends_clause,
    STATE(3017), 1,
      sym_class_heritage,
    STATE(3290), 1,
      sym_implements_clause,
  [102240] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4572), 1,
      sym_identifier,
    ACTIONS(4574), 1,
      anon_sym_LBRACE,
    ACTIONS(4576), 1,
      anon_sym_LBRACK,
    ACTIONS(4674), 1,
      anon_sym_enum,
    STATE(2190), 1,
      sym_array,
    STATE(2192), 1,
      sym_object,
    STATE(2744), 1,
      sym_variable_declarator,
  [102265] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(4584), 1,
      anon_sym_LPAREN,
    ACTIONS(4676), 1,
      sym_identifier,
    ACTIONS(4678), 1,
      anon_sym_STAR,
    STATE(2295), 1,
      sym_formal_parameters,
    STATE(3054), 1,
      sym_type_parameters,
    STATE(3152), 1,
      sym__call_signature,
  [102290] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4682), 1,
      anon_sym_is,
    ACTIONS(4680), 6,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [102305] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2251), 1,
      anon_sym_COLON,
    ACTIONS(4363), 1,
      anon_sym_EQ,
    STATE(2437), 1,
      sym_type_annotation,
    STATE(2793), 1,
      sym__initializer,
    ACTIONS(4445), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [102326] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1796), 1,
      anon_sym_LBRACE,
    STATE(3145), 1,
      sym_statement_block,
    ACTIONS(4684), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [102343] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1015), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_PIPE_RBRACE,
  [102356] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4476), 1,
      anon_sym_LBRACE,
    ACTIONS(4524), 1,
      anon_sym_implements,
    ACTIONS(4526), 1,
      anon_sym_extends,
    STATE(1602), 1,
      sym_class_body,
    STATE(2922), 1,
      sym_extends_clause,
    STATE(2974), 1,
      sym_class_heritage,
    STATE(3290), 1,
      sym_implements_clause,
  [102381] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(4584), 1,
      anon_sym_LPAREN,
    ACTIONS(4600), 1,
      anon_sym_STAR,
    ACTIONS(4686), 1,
      sym_identifier,
    STATE(2295), 1,
      sym_formal_parameters,
    STATE(2953), 1,
      sym__call_signature,
    STATE(3054), 1,
      sym_type_parameters,
  [102406] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1796), 1,
      anon_sym_LBRACE,
    STATE(3071), 1,
      sym_statement_block,
    ACTIONS(4688), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [102423] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1796), 1,
      anon_sym_LBRACE,
    STATE(2962), 1,
      sym_statement_block,
    ACTIONS(4690), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [102440] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1796), 1,
      anon_sym_LBRACE,
    STATE(2937), 1,
      sym_statement_block,
    ACTIONS(4692), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [102457] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1796), 1,
      anon_sym_LBRACE,
    STATE(3024), 1,
      sym_statement_block,
    ACTIONS(4694), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [102474] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(4584), 1,
      anon_sym_LPAREN,
    ACTIONS(4696), 1,
      sym_identifier,
    STATE(2295), 1,
      sym_formal_parameters,
    STATE(3054), 1,
      sym_type_parameters,
    STATE(3150), 1,
      sym__call_signature,
  [102496] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4698), 1,
      anon_sym_default,
    ACTIONS(4700), 1,
      anon_sym_RBRACE,
    ACTIONS(4702), 1,
      anon_sym_case,
    STATE(2279), 3,
      sym_switch_case,
      sym_switch_default,
      aux_sym_switch_body_repeat1,
  [102514] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2264), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(2965), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4704), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [102530] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2201), 1,
      anon_sym_LPAREN,
    ACTIONS(4339), 1,
      anon_sym_LT,
    ACTIONS(4706), 1,
      sym_identifier,
    ACTIONS(4708), 1,
      anon_sym_LBRACK,
    STATE(1731), 1,
      sym_arguments,
    STATE(3045), 1,
      sym_type_arguments,
  [102552] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2498), 1,
      anon_sym_typeof,
    ACTIONS(4710), 1,
      sym_identifier,
    STATE(1441), 1,
      sym_nested_type_identifier,
    STATE(3219), 1,
      sym_nested_identifier,
    STATE(1664), 2,
      sym_generic_type,
      sym_type_query,
  [102572] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4714), 1,
      anon_sym_BQUOTE,
    ACTIONS(4716), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(4712), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(2319), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [102590] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4716), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(4720), 1,
      anon_sym_BQUOTE,
    ACTIONS(4718), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(2370), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [102608] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4345), 1,
      anon_sym_AMP,
    ACTIONS(4347), 1,
      anon_sym_PIPE,
    ACTIONS(4349), 1,
      anon_sym_extends,
    ACTIONS(4722), 1,
      anon_sym_COMMA,
    ACTIONS(4724), 1,
      anon_sym_GT,
    STATE(2905), 1,
      aux_sym_implements_clause_repeat1,
  [102630] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2264), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(2967), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4726), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [102646] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2251), 1,
      anon_sym_COLON,
    ACTIONS(4728), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(4730), 1,
      anon_sym_QMARK_COLON,
    STATE(2481), 3,
      sym_omitting_type_annotation,
      sym_opting_type_annotation,
      sym_type_annotation,
  [102664] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2542), 1,
      anon_sym_LPAREN,
    ACTIONS(4732), 1,
      anon_sym_QMARK,
    STATE(2066), 1,
      sym_formal_parameters,
    STATE(2479), 1,
      sym__call_signature,
    STATE(3032), 1,
      sym_type_parameters,
  [102686] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4574), 1,
      anon_sym_LBRACE,
    ACTIONS(4576), 1,
      anon_sym_LBRACK,
    ACTIONS(4734), 1,
      sym_identifier,
    STATE(2190), 1,
      sym_array,
    STATE(2192), 1,
      sym_object,
    STATE(2742), 1,
      sym_variable_declarator,
  [102708] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4574), 1,
      anon_sym_LBRACE,
    ACTIONS(4576), 1,
      anon_sym_LBRACK,
    ACTIONS(4734), 1,
      sym_identifier,
    STATE(2190), 1,
      sym_array,
    STATE(2192), 1,
      sym_object,
    STATE(2744), 1,
      sym_variable_declarator,
  [102730] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2264), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(4739), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4736), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [102746] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2542), 1,
      anon_sym_LPAREN,
    ACTIONS(4741), 1,
      anon_sym_QMARK,
    STATE(2066), 1,
      sym_formal_parameters,
    STATE(2454), 1,
      sym__call_signature,
    STATE(3032), 1,
      sym_type_parameters,
  [102768] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(4584), 1,
      anon_sym_LPAREN,
    ACTIONS(4743), 1,
      sym_identifier,
    STATE(2295), 1,
      sym_formal_parameters,
    STATE(3054), 1,
      sym_type_parameters,
    STATE(3127), 1,
      sym__call_signature,
  [102790] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2542), 1,
      anon_sym_LPAREN,
    ACTIONS(4745), 1,
      anon_sym_QMARK,
    STATE(2066), 1,
      sym_formal_parameters,
    STATE(2847), 1,
      sym__call_signature,
    STATE(3032), 1,
      sym_type_parameters,
  [102812] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(4584), 1,
      anon_sym_LPAREN,
    ACTIONS(4747), 1,
      anon_sym_QMARK,
    STATE(2295), 1,
      sym_formal_parameters,
    STATE(3000), 1,
      sym__call_signature,
    STATE(3054), 1,
      sym_type_parameters,
  [102834] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4749), 6,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [102846] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4751), 6,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [102858] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2264), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(2955), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4753), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [102874] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2721), 1,
      anon_sym_COMMA,
    ACTIONS(3316), 1,
      anon_sym_LBRACE,
    ACTIONS(3348), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4755), 1,
      anon_sym_LT,
    STATE(2686), 1,
      aux_sym_extends_clause_repeat1,
    STATE(2828), 1,
      sym_type_arguments,
  [102896] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4345), 1,
      anon_sym_AMP,
    ACTIONS(4347), 1,
      anon_sym_PIPE,
    ACTIONS(4349), 1,
      anon_sym_extends,
    ACTIONS(4757), 1,
      anon_sym_COMMA,
    ACTIONS(4759), 1,
      anon_sym_GT,
    STATE(2776), 1,
      aux_sym_implements_clause_repeat1,
  [102918] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4764), 1,
      anon_sym_BQUOTE,
    ACTIONS(4766), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(4761), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(2274), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [102936] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2253), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(2961), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4769), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [102952] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4771), 1,
      anon_sym_default,
    ACTIONS(4774), 1,
      anon_sym_RBRACE,
    ACTIONS(4776), 1,
      anon_sym_case,
    STATE(2276), 3,
      sym_switch_case,
      sym_switch_default,
      aux_sym_switch_body_repeat1,
  [102970] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2312), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(4781), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4779), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [102986] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(4584), 1,
      anon_sym_LPAREN,
    ACTIONS(4783), 1,
      sym_identifier,
    STATE(2295), 1,
      sym_formal_parameters,
    STATE(3054), 1,
      sym_type_parameters,
    STATE(3127), 1,
      sym__call_signature,
  [103008] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4698), 1,
      anon_sym_default,
    ACTIONS(4702), 1,
      anon_sym_case,
    ACTIONS(4785), 1,
      anon_sym_RBRACE,
    STATE(2276), 3,
      sym_switch_case,
      sym_switch_default,
      aux_sym_switch_body_repeat1,
  [103026] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4345), 1,
      anon_sym_AMP,
    ACTIONS(4347), 1,
      anon_sym_PIPE,
    ACTIONS(4349), 1,
      anon_sym_extends,
    ACTIONS(4787), 1,
      anon_sym_COMMA,
    ACTIONS(4789), 1,
      anon_sym_GT,
    STATE(2925), 1,
      aux_sym_implements_clause_repeat1,
  [103048] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(4584), 1,
      anon_sym_LPAREN,
    ACTIONS(4791), 1,
      sym_identifier,
    STATE(2295), 1,
      sym_formal_parameters,
    STATE(3054), 1,
      sym_type_parameters,
    STATE(3082), 1,
      sym__call_signature,
  [103070] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4793), 6,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [103082] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2738), 1,
      anon_sym_COMMA,
    ACTIONS(4339), 1,
      anon_sym_LT,
    STATE(275), 1,
      sym_type_arguments,
    STATE(2733), 1,
      aux_sym_extends_clause_repeat1,
    ACTIONS(3348), 2,
      anon_sym_LBRACE,
      anon_sym_implements,
  [103102] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4345), 1,
      anon_sym_AMP,
    ACTIONS(4347), 1,
      anon_sym_PIPE,
    ACTIONS(4349), 1,
      anon_sym_extends,
    ACTIONS(4795), 1,
      anon_sym_LBRACE,
    ACTIONS(4797), 1,
      anon_sym_COMMA,
    STATE(2792), 1,
      aux_sym_implements_clause_repeat1,
  [103124] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2762), 1,
      anon_sym_typeof,
    ACTIONS(4799), 1,
      sym_identifier,
    STATE(489), 1,
      sym_nested_type_identifier,
    STATE(3297), 1,
      sym_nested_identifier,
    STATE(449), 2,
      sym_generic_type,
      sym_type_query,
  [103144] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2264), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(2959), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4801), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [103160] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2542), 1,
      anon_sym_LPAREN,
    ACTIONS(4803), 1,
      anon_sym_QMARK,
    STATE(2066), 1,
      sym_formal_parameters,
    STATE(2243), 1,
      sym__call_signature,
    STATE(3032), 1,
      sym_type_parameters,
  [103182] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(4584), 1,
      anon_sym_LPAREN,
    ACTIONS(4805), 1,
      anon_sym_QMARK,
    STATE(2295), 1,
      sym_formal_parameters,
    STATE(3054), 1,
      sym_type_parameters,
    STATE(3100), 1,
      sym__call_signature,
  [103204] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2542), 1,
      anon_sym_LPAREN,
    ACTIONS(4807), 1,
      anon_sym_QMARK,
    STATE(2066), 1,
      sym_formal_parameters,
    STATE(2228), 1,
      sym__call_signature,
    STATE(3032), 1,
      sym_type_parameters,
  [103226] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(4584), 1,
      anon_sym_LPAREN,
    ACTIONS(4809), 1,
      anon_sym_QMARK,
    STATE(2295), 1,
      sym_formal_parameters,
    STATE(2969), 1,
      sym__call_signature,
    STATE(3054), 1,
      sym_type_parameters,
  [103248] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2542), 1,
      anon_sym_LPAREN,
    ACTIONS(4811), 1,
      anon_sym_QMARK,
    STATE(2066), 1,
      sym_formal_parameters,
    STATE(2224), 1,
      sym__call_signature,
    STATE(3032), 1,
      sym_type_parameters,
  [103270] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2264), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(2953), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4813), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [103286] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2271), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(2953), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4813), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [103302] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2542), 1,
      anon_sym_LPAREN,
    ACTIONS(4815), 1,
      anon_sym_QMARK,
    STATE(2066), 1,
      sym_formal_parameters,
    STATE(2250), 1,
      sym__call_signature,
    STATE(3032), 1,
      sym_type_parameters,
  [103324] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4817), 1,
      anon_sym_COLON,
    ACTIONS(4496), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
    STATE(2961), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
  [103340] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2542), 1,
      anon_sym_LPAREN,
    ACTIONS(4819), 1,
      anon_sym_QMARK,
    STATE(2066), 1,
      sym_formal_parameters,
    STATE(2248), 1,
      sym__call_signature,
    STATE(3032), 1,
      sym_type_parameters,
  [103362] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2422), 1,
      anon_sym_typeof,
    ACTIONS(4821), 1,
      sym_identifier,
    STATE(1986), 1,
      sym_nested_type_identifier,
    STATE(3166), 1,
      sym_nested_identifier,
    STATE(2049), 2,
      sym_generic_type,
      sym_type_query,
  [103382] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4345), 1,
      anon_sym_AMP,
    ACTIONS(4347), 1,
      anon_sym_PIPE,
    ACTIONS(4349), 1,
      anon_sym_extends,
    ACTIONS(4823), 1,
      anon_sym_COMMA,
    ACTIONS(4825), 1,
      anon_sym_GT,
    STATE(2823), 1,
      aux_sym_implements_clause_repeat1,
  [103404] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2264), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(2963), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4827), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [103420] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2336), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(4831), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4829), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [103436] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2286), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(2963), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4827), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [103452] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3218), 1,
      anon_sym_COLON,
    ACTIONS(4602), 1,
      anon_sym_EQ,
    STATE(2673), 1,
      sym_type_annotation,
    STATE(2981), 1,
      sym__initializer,
    ACTIONS(4833), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [103472] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2542), 1,
      anon_sym_LPAREN,
    ACTIONS(4835), 1,
      anon_sym_QMARK,
    STATE(2066), 1,
      sym_formal_parameters,
    STATE(2376), 1,
      sym__call_signature,
    STATE(3032), 1,
      sym_type_parameters,
  [103494] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2251), 1,
      anon_sym_COLON,
    ACTIONS(4728), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(4730), 1,
      anon_sym_QMARK_COLON,
    STATE(2375), 3,
      sym_omitting_type_annotation,
      sym_opting_type_annotation,
      sym_type_annotation,
  [103512] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2251), 1,
      anon_sym_COLON,
    ACTIONS(4728), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(4730), 1,
      anon_sym_QMARK_COLON,
    STATE(2512), 3,
      sym_omitting_type_annotation,
      sym_opting_type_annotation,
      sym_type_annotation,
  [103530] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2251), 1,
      anon_sym_COLON,
    ACTIONS(4728), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(4730), 1,
      anon_sym_QMARK_COLON,
    STATE(2510), 3,
      sym_omitting_type_annotation,
      sym_opting_type_annotation,
      sym_type_annotation,
  [103548] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(4837), 1,
      anon_sym_export,
    ACTIONS(4839), 1,
      anon_sym_class,
    ACTIONS(4841), 1,
      anon_sym_abstract,
    STATE(1915), 1,
      aux_sym_export_statement_repeat1,
    STATE(1945), 1,
      sym_decorator,
  [103570] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(4590), 1,
      sym_identifier,
    STATE(518), 1,
      sym_nested_identifier,
    STATE(523), 1,
      sym_string,
    STATE(561), 1,
      sym__module,
  [103592] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4843), 1,
      sym_identifier,
    ACTIONS(4845), 1,
      anon_sym_COMMA,
    ACTIONS(4847), 1,
      anon_sym_RBRACE,
    STATE(2897), 1,
      sym__import_export_specifier,
    ACTIONS(4849), 2,
      anon_sym_type,
      anon_sym_typeof,
  [103612] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2197), 1,
      anon_sym_LPAREN,
    ACTIONS(4339), 1,
      anon_sym_LT,
    ACTIONS(4851), 1,
      sym_identifier,
    ACTIONS(4853), 1,
      anon_sym_LBRACK,
    STATE(1559), 1,
      sym_arguments,
    STATE(2978), 1,
      sym_type_arguments,
  [103634] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    ACTIONS(4590), 1,
      sym_identifier,
    STATE(518), 1,
      sym_nested_identifier,
    STATE(523), 1,
      sym_string,
    STATE(564), 1,
      sym__module,
  [103656] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2264), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(2961), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4769), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [103672] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2542), 1,
      anon_sym_LPAREN,
    ACTIONS(4855), 1,
      anon_sym_QMARK,
    STATE(2066), 1,
      sym_formal_parameters,
    STATE(2582), 1,
      sym__call_signature,
    STATE(3032), 1,
      sym_type_parameters,
  [103694] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4574), 1,
      anon_sym_LBRACE,
    ACTIONS(4576), 1,
      anon_sym_LBRACK,
    ACTIONS(4734), 1,
      sym_identifier,
    STATE(2190), 1,
      sym_array,
    STATE(2192), 1,
      sym_object,
    STATE(2928), 1,
      sym_variable_declarator,
  [103716] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2542), 1,
      anon_sym_LPAREN,
    ACTIONS(4857), 1,
      anon_sym_QMARK,
    STATE(2066), 1,
      sym_formal_parameters,
    STATE(2507), 1,
      sym__call_signature,
    STATE(3032), 1,
      sym_type_parameters,
  [103738] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2259), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(2957), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4859), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [103754] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2542), 1,
      anon_sym_LPAREN,
    ACTIONS(4861), 1,
      anon_sym_QMARK,
    STATE(2066), 1,
      sym_formal_parameters,
    STATE(2391), 1,
      sym__call_signature,
    STATE(3032), 1,
      sym_type_parameters,
  [103776] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2299), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(4865), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4863), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [103792] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4716), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(4869), 1,
      anon_sym_BQUOTE,
    ACTIONS(4867), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(2274), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [103810] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(4584), 1,
      anon_sym_LPAREN,
    ACTIONS(4871), 1,
      sym_identifier,
    STATE(2295), 1,
      sym_formal_parameters,
    STATE(3054), 1,
      sym_type_parameters,
    STATE(3103), 1,
      sym__call_signature,
  [103832] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2542), 1,
      anon_sym_LPAREN,
    ACTIONS(4873), 1,
      anon_sym_QMARK,
    STATE(2066), 1,
      sym_formal_parameters,
    STATE(2492), 1,
      sym__call_signature,
    STATE(3032), 1,
      sym_type_parameters,
  [103854] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2251), 1,
      anon_sym_COLON,
    ACTIONS(4728), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(4730), 1,
      anon_sym_QMARK_COLON,
    STATE(2490), 3,
      sym_omitting_type_annotation,
      sym_opting_type_annotation,
      sym_type_annotation,
  [103872] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2251), 1,
      anon_sym_COLON,
    ACTIONS(4728), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(4730), 1,
      anon_sym_QMARK_COLON,
    STATE(2476), 3,
      sym_omitting_type_annotation,
      sym_opting_type_annotation,
      sym_type_annotation,
  [103890] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(4584), 1,
      anon_sym_LPAREN,
    ACTIONS(4875), 1,
      sym_identifier,
    STATE(2295), 1,
      sym_formal_parameters,
    STATE(3054), 1,
      sym_type_parameters,
    STATE(3158), 1,
      sym__call_signature,
  [103912] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2292), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(4879), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4877), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [103928] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(4584), 1,
      anon_sym_LPAREN,
    ACTIONS(4881), 1,
      sym_identifier,
    STATE(2295), 1,
      sym_formal_parameters,
    STATE(3054), 1,
      sym_type_parameters,
    STATE(3067), 1,
      sym__call_signature,
  [103950] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2201), 1,
      anon_sym_LPAREN,
    ACTIONS(4339), 1,
      anon_sym_LT,
    ACTIONS(4883), 1,
      sym_identifier,
    ACTIONS(4885), 1,
      anon_sym_LBRACK,
    STATE(1673), 1,
      sym_arguments,
    STATE(3107), 1,
      sym_type_arguments,
  [103972] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2542), 1,
      anon_sym_LPAREN,
    ACTIONS(4887), 1,
      anon_sym_QMARK,
    STATE(2066), 1,
      sym_formal_parameters,
    STATE(2893), 1,
      sym__call_signature,
    STATE(3032), 1,
      sym_type_parameters,
  [103994] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4345), 1,
      anon_sym_AMP,
    ACTIONS(4347), 1,
      anon_sym_PIPE,
    ACTIONS(4349), 1,
      anon_sym_extends,
    ACTIONS(4889), 1,
      anon_sym_COMMA,
    ACTIONS(4891), 1,
      anon_sym_GT,
    STATE(2881), 1,
      aux_sym_implements_clause_repeat1,
  [104016] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4716), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(4895), 1,
      anon_sym_BQUOTE,
    ACTIONS(4893), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(2350), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [104034] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3545), 6,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
  [104046] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(4584), 1,
      anon_sym_LPAREN,
    ACTIONS(4897), 1,
      anon_sym_QMARK,
    STATE(2295), 1,
      sym_formal_parameters,
    STATE(3002), 1,
      sym__call_signature,
    STATE(3054), 1,
      sym_type_parameters,
  [104068] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2454), 1,
      anon_sym_typeof,
    ACTIONS(4899), 1,
      sym_identifier,
    STATE(2079), 1,
      sym_nested_type_identifier,
    STATE(3212), 1,
      sym_nested_identifier,
    STATE(2150), 2,
      sym_generic_type,
      sym_type_query,
  [104088] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2894), 6,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
  [104100] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2434), 1,
      anon_sym_DQUOTE,
    ACTIONS(2436), 1,
      anon_sym_SQUOTE,
    ACTIONS(4610), 1,
      sym_identifier,
    STATE(2133), 1,
      sym_nested_identifier,
    STATE(2173), 1,
      sym_string,
    STATE(2381), 1,
      sym__module,
  [104122] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2264), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(2957), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4859), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [104138] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(4841), 1,
      anon_sym_abstract,
    ACTIONS(4901), 1,
      anon_sym_export,
    ACTIONS(4903), 1,
      anon_sym_class,
    STATE(1915), 1,
      aux_sym_export_statement_repeat1,
    STATE(1945), 1,
      sym_decorator,
  [104160] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(4339), 1,
      anon_sym_LT,
    ACTIONS(4905), 1,
      sym_identifier,
    ACTIONS(4907), 1,
      anon_sym_LBRACK,
    STATE(1153), 1,
      sym_arguments,
    STATE(3023), 1,
      sym_type_arguments,
  [104182] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4345), 1,
      anon_sym_AMP,
    ACTIONS(4347), 1,
      anon_sym_PIPE,
    ACTIONS(4349), 1,
      anon_sym_extends,
    ACTIONS(4909), 3,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
  [104200] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2434), 1,
      anon_sym_DQUOTE,
    ACTIONS(2436), 1,
      anon_sym_SQUOTE,
    ACTIONS(4610), 1,
      sym_identifier,
    STATE(2133), 1,
      sym_nested_identifier,
    STATE(2173), 1,
      sym_string,
    STATE(2535), 1,
      sym__module,
  [104222] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2264), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(2941), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4911), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [104238] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4843), 1,
      sym_identifier,
    ACTIONS(4913), 1,
      anon_sym_COMMA,
    ACTIONS(4915), 1,
      anon_sym_RBRACE,
    STATE(2800), 1,
      sym__import_export_specifier,
    ACTIONS(4849), 2,
      anon_sym_type,
      anon_sym_typeof,
  [104258] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(4584), 1,
      anon_sym_LPAREN,
    ACTIONS(4917), 1,
      sym_identifier,
    STATE(2295), 1,
      sym_formal_parameters,
    STATE(3054), 1,
      sym_type_parameters,
    STATE(3067), 1,
      sym__call_signature,
  [104280] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4574), 1,
      anon_sym_LBRACE,
    ACTIONS(4576), 1,
      anon_sym_LBRACK,
    ACTIONS(4734), 1,
      sym_identifier,
    STATE(2190), 1,
      sym_array,
    STATE(2192), 1,
      sym_object,
    STATE(2729), 1,
      sym_variable_declarator,
  [104302] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2366), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(4921), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4919), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [104318] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4345), 1,
      anon_sym_AMP,
    ACTIONS(4347), 1,
      anon_sym_PIPE,
    ACTIONS(4349), 1,
      anon_sym_extends,
    ACTIONS(4923), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_GT,
  [104336] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2264), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(2939), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4925), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [104352] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    ACTIONS(4339), 1,
      anon_sym_LT,
    ACTIONS(4927), 1,
      sym_identifier,
    ACTIONS(4929), 1,
      anon_sym_LBRACK,
    STATE(1145), 1,
      sym_arguments,
    STATE(3148), 1,
      sym_type_arguments,
  [104374] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2341), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(2939), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4925), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [104390] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4716), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(4931), 1,
      anon_sym_BQUOTE,
    ACTIONS(4867), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(2274), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [104408] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2542), 1,
      anon_sym_LPAREN,
    ACTIONS(4933), 1,
      anon_sym_QMARK,
    STATE(2066), 1,
      sym_formal_parameters,
    STATE(2610), 1,
      sym__call_signature,
    STATE(3032), 1,
      sym_type_parameters,
  [104430] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2347), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(4937), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4935), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [104446] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(4584), 1,
      anon_sym_LPAREN,
    ACTIONS(4939), 1,
      anon_sym_QMARK,
    STATE(2295), 1,
      sym_formal_parameters,
    STATE(3025), 1,
      sym__call_signature,
    STATE(3054), 1,
      sym_type_parameters,
  [104468] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4345), 1,
      anon_sym_AMP,
    ACTIONS(4347), 1,
      anon_sym_PIPE,
    ACTIONS(4349), 1,
      anon_sym_extends,
    ACTIONS(4941), 1,
      anon_sym_COMMA,
    ACTIONS(4943), 1,
      anon_sym_GT,
    STATE(2819), 1,
      aux_sym_implements_clause_repeat1,
  [104490] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(4584), 1,
      anon_sym_LPAREN,
    ACTIONS(4945), 1,
      sym_identifier,
    STATE(2295), 1,
      sym_formal_parameters,
    STATE(3054), 1,
      sym_type_parameters,
    STATE(3127), 1,
      sym__call_signature,
  [104512] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2336), 1,
      anon_sym_typeof,
    ACTIONS(4947), 1,
      sym_identifier,
    STATE(1033), 1,
      sym_nested_type_identifier,
    STATE(3195), 1,
      sym_nested_identifier,
    STATE(1061), 2,
      sym_generic_type,
      sym_type_query,
  [104532] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(787), 1,
      anon_sym_typeof,
    ACTIONS(4949), 1,
      sym_identifier,
    STATE(1958), 1,
      sym_nested_type_identifier,
    STATE(3297), 1,
      sym_nested_identifier,
    STATE(449), 2,
      sym_generic_type,
      sym_type_query,
  [104552] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4345), 1,
      anon_sym_AMP,
    ACTIONS(4347), 1,
      anon_sym_PIPE,
    ACTIONS(4349), 1,
      anon_sym_extends,
    ACTIONS(4951), 1,
      anon_sym_COMMA,
    ACTIONS(4953), 1,
      anon_sym_GT,
    STATE(2875), 1,
      aux_sym_implements_clause_repeat1,
  [104574] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2542), 1,
      anon_sym_LPAREN,
    ACTIONS(4955), 1,
      anon_sym_QMARK,
    STATE(2066), 1,
      sym_formal_parameters,
    STATE(2453), 1,
      sym__call_signature,
    STATE(3032), 1,
      sym_type_parameters,
  [104596] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4817), 1,
      anon_sym_COLON,
    ACTIONS(4486), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
    STATE(3034), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
  [104612] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2264), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(2937), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4957), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [104628] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2251), 1,
      anon_sym_COLON,
    ACTIONS(4728), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(4730), 1,
      anon_sym_QMARK_COLON,
    STATE(2409), 3,
      sym_omitting_type_annotation,
      sym_opting_type_annotation,
      sym_type_annotation,
  [104646] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2251), 1,
      anon_sym_COLON,
    ACTIONS(4728), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(4730), 1,
      anon_sym_QMARK_COLON,
    STATE(2413), 3,
      sym_omitting_type_annotation,
      sym_opting_type_annotation,
      sym_type_annotation,
  [104664] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4574), 1,
      anon_sym_LBRACE,
    ACTIONS(4576), 1,
      anon_sym_LBRACK,
    ACTIONS(4734), 1,
      sym_identifier,
    STATE(2190), 1,
      sym_array,
    STATE(2192), 1,
      sym_object,
    STATE(2732), 1,
      sym_variable_declarator,
  [104686] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2361), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(2947), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4959), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [104702] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2264), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(2947), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4959), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [104718] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(4584), 1,
      anon_sym_LPAREN,
    ACTIONS(4961), 1,
      sym_identifier,
    STATE(2295), 1,
      sym_formal_parameters,
    STATE(3054), 1,
      sym_type_parameters,
    STATE(3067), 1,
      sym__call_signature,
  [104740] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2542), 1,
      anon_sym_LPAREN,
    ACTIONS(4963), 1,
      anon_sym_QMARK,
    STATE(2066), 1,
      sym_formal_parameters,
    STATE(2445), 1,
      sym__call_signature,
    STATE(3032), 1,
      sym_type_parameters,
  [104762] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2251), 1,
      anon_sym_COLON,
    ACTIONS(4728), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(4730), 1,
      anon_sym_QMARK_COLON,
    STATE(2433), 3,
      sym_omitting_type_annotation,
      sym_opting_type_annotation,
      sym_type_annotation,
  [104780] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4716), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(4965), 1,
      anon_sym_BQUOTE,
    ACTIONS(4867), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(2274), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [104798] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2374), 1,
      anon_sym_typeof,
    ACTIONS(4967), 1,
      sym_identifier,
    STATE(1282), 1,
      sym_nested_type_identifier,
    STATE(3214), 1,
      sym_nested_identifier,
    STATE(1500), 2,
      sym_generic_type,
      sym_type_query,
  [104818] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2197), 1,
      anon_sym_LPAREN,
    ACTIONS(4339), 1,
      anon_sym_LT,
    ACTIONS(4969), 1,
      sym_identifier,
    ACTIONS(4971), 1,
      anon_sym_LBRACK,
    STATE(1574), 1,
      sym_arguments,
    STATE(3055), 1,
      sym_type_arguments,
  [104840] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(4841), 1,
      anon_sym_abstract,
    ACTIONS(4973), 1,
      anon_sym_class,
    STATE(1915), 1,
      aux_sym_export_statement_repeat1,
    STATE(1945), 1,
      sym_decorator,
  [104859] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1883), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [104870] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4975), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [104881] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4652), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [104892] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4817), 1,
      anon_sym_COLON,
    ACTIONS(4977), 1,
      anon_sym_EQ_GT,
    STATE(2961), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
  [104907] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3013), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [104918] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4602), 1,
      anon_sym_EQ,
    ACTIONS(4979), 1,
      anon_sym_COMMA,
    ACTIONS(4981), 1,
      anon_sym_RBRACE,
    STATE(2872), 1,
      aux_sym_enum_body_repeat1,
    STATE(3012), 1,
      sym__initializer,
  [104937] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4656), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [104948] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1091), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [104959] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2542), 1,
      anon_sym_LPAREN,
    STATE(2066), 1,
      sym_formal_parameters,
    STATE(2439), 1,
      sym__call_signature,
    STATE(3032), 1,
      sym_type_parameters,
  [104978] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(4983), 1,
      anon_sym_LPAREN,
    STATE(2151), 1,
      sym_formal_parameters,
    STATE(2543), 1,
      sym__call_signature,
    STATE(2945), 1,
      sym_type_parameters,
  [104997] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4985), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [105008] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2542), 1,
      anon_sym_LPAREN,
    STATE(2066), 1,
      sym_formal_parameters,
    STATE(2515), 1,
      sym__call_signature,
    STATE(3032), 1,
      sym_type_parameters,
  [105027] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(4584), 1,
      anon_sym_LPAREN,
    STATE(2295), 1,
      sym_formal_parameters,
    STATE(3054), 1,
      sym_type_parameters,
    STATE(3098), 1,
      sym__call_signature,
  [105046] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4987), 1,
      anon_sym_LBRACE,
    STATE(1888), 1,
      sym_statement_block,
    ACTIONS(4656), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [105061] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2542), 1,
      anon_sym_LPAREN,
    STATE(2066), 1,
      sym_formal_parameters,
    STATE(2448), 1,
      sym__call_signature,
    STATE(3032), 1,
      sym_type_parameters,
  [105080] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4817), 1,
      anon_sym_COLON,
    ACTIONS(4989), 1,
      anon_sym_EQ_GT,
    STATE(3034), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
  [105095] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3021), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [105106] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4987), 1,
      anon_sym_LBRACE,
    STATE(1886), 1,
      sym_statement_block,
    ACTIONS(4652), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [105121] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3017), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [105132] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4654), 5,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_COLON,
  [105143] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(4584), 1,
      anon_sym_LPAREN,
    STATE(2295), 1,
      sym_formal_parameters,
    STATE(3054), 1,
      sym_type_parameters,
    STATE(3091), 1,
      sym__call_signature,
  [105162] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4363), 1,
      anon_sym_EQ,
    STATE(2867), 1,
      sym__initializer,
    ACTIONS(4991), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [105177] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2840), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [105188] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(947), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [105199] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3000), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [105210] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(937), 1,
      anon_sym_LBRACE,
    STATE(71), 1,
      sym_statement_block,
    ACTIONS(4993), 3,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_SEMI,
  [105225] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(4584), 1,
      anon_sym_LPAREN,
    STATE(2295), 1,
      sym_formal_parameters,
    STATE(3008), 1,
      sym__call_signature,
    STATE(3054), 1,
      sym_type_parameters,
  [105244] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(4983), 1,
      anon_sym_LPAREN,
    STATE(2151), 1,
      sym_formal_parameters,
    STATE(2546), 1,
      sym__call_signature,
    STATE(2945), 1,
      sym_type_parameters,
  [105263] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4363), 1,
      anon_sym_EQ,
    STATE(2865), 1,
      sym__initializer,
    ACTIONS(4995), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [105278] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2542), 1,
      anon_sym_LPAREN,
    STATE(2066), 1,
      sym_formal_parameters,
    STATE(2861), 1,
      sym__call_signature,
    STATE(3032), 1,
      sym_type_parameters,
  [105297] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3097), 1,
      anon_sym_LBRACE,
    STATE(1597), 1,
      sym_statement_block,
    ACTIONS(4997), 3,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_SEMI,
  [105312] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(4584), 1,
      anon_sym_LPAREN,
    STATE(2295), 1,
      sym_formal_parameters,
    STATE(3050), 1,
      sym__call_signature,
    STATE(3054), 1,
      sym_type_parameters,
  [105331] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2996), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [105342] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(4999), 1,
      anon_sym_class,
    ACTIONS(5001), 1,
      anon_sym_abstract,
    STATE(1915), 1,
      aux_sym_export_statement_repeat1,
    STATE(1945), 1,
      sym_decorator,
  [105361] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(4584), 1,
      anon_sym_LPAREN,
    STATE(2295), 1,
      sym_formal_parameters,
    STATE(2994), 1,
      sym__call_signature,
    STATE(3054), 1,
      sym_type_parameters,
  [105380] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5003), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [105391] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(4983), 1,
      anon_sym_LPAREN,
    STATE(2151), 1,
      sym_formal_parameters,
    STATE(2588), 1,
      sym__call_signature,
    STATE(2945), 1,
      sym_type_parameters,
  [105410] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2987), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [105421] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4363), 1,
      anon_sym_EQ,
    STATE(2884), 1,
      sym__initializer,
    ACTIONS(5005), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [105436] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5007), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [105447] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4987), 1,
      anon_sym_LBRACE,
    STATE(1879), 1,
      sym_statement_block,
    ACTIONS(4646), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [105462] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4644), 5,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_COLON,
  [105473] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4345), 1,
      anon_sym_AMP,
    ACTIONS(4347), 1,
      anon_sym_PIPE,
    ACTIONS(4349), 1,
      anon_sym_extends,
    ACTIONS(4538), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
  [105490] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5009), 5,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_implements,
      anon_sym_extends,
  [105501] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4666), 5,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_COLON,
  [105512] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5011), 1,
      anon_sym_is,
    ACTIONS(4680), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
  [105525] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4843), 1,
      sym_identifier,
    ACTIONS(5013), 1,
      anon_sym_RBRACE,
    STATE(3089), 1,
      sym__import_export_specifier,
    ACTIONS(4849), 2,
      anon_sym_type,
      anon_sym_typeof,
  [105542] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4650), 5,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_COLON,
  [105553] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(4584), 1,
      anon_sym_LPAREN,
    STATE(2295), 1,
      sym_formal_parameters,
    STATE(3054), 1,
      sym_type_parameters,
    STATE(3081), 1,
      sym__call_signature,
  [105572] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4345), 1,
      anon_sym_AMP,
    ACTIONS(4347), 1,
      anon_sym_PIPE,
    ACTIONS(4349), 1,
      anon_sym_extends,
    ACTIONS(5015), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [105589] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4562), 1,
      anon_sym_LBRACE,
    STATE(528), 1,
      sym_statement_block,
    ACTIONS(4993), 3,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_SEMI,
  [105604] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5017), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [105615] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(4584), 1,
      anon_sym_LPAREN,
    STATE(2295), 1,
      sym_formal_parameters,
    STATE(2999), 1,
      sym__call_signature,
    STATE(3054), 1,
      sym_type_parameters,
  [105634] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4646), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [105645] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1959), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [105656] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3119), 5,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_COLON,
  [105667] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1995), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [105678] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2011), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [105689] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2542), 1,
      anon_sym_LPAREN,
    STATE(2066), 1,
      sym_formal_parameters,
    STATE(2896), 1,
      sym__call_signature,
    STATE(3032), 1,
      sym_type_parameters,
  [105708] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5019), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [105719] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(4584), 1,
      anon_sym_LPAREN,
    STATE(2295), 1,
      sym_formal_parameters,
    STATE(2980), 1,
      sym__call_signature,
    STATE(3054), 1,
      sym_type_parameters,
  [105738] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(4584), 1,
      anon_sym_LPAREN,
    STATE(2295), 1,
      sym_formal_parameters,
    STATE(3054), 1,
      sym_type_parameters,
    STATE(3144), 1,
      sym__call_signature,
  [105757] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(4584), 1,
      anon_sym_LPAREN,
    STATE(2295), 1,
      sym_formal_parameters,
    STATE(3054), 1,
      sym_type_parameters,
    STATE(3149), 1,
      sym__call_signature,
  [105776] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4363), 1,
      anon_sym_EQ,
    STATE(2914), 1,
      sym__initializer,
    ACTIONS(5021), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [105791] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(4584), 1,
      anon_sym_LPAREN,
    STATE(2295), 1,
      sym_formal_parameters,
    STATE(3054), 1,
      sym_type_parameters,
    STATE(3151), 1,
      sym__call_signature,
  [105810] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4570), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [105821] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2542), 1,
      anon_sym_LPAREN,
    STATE(2066), 1,
      sym_formal_parameters,
    STATE(2471), 1,
      sym__call_signature,
    STATE(3032), 1,
      sym_type_parameters,
  [105840] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2019), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [105851] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4363), 1,
      anon_sym_EQ,
    STATE(2915), 1,
      sym__initializer,
    ACTIONS(5023), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [105866] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1097), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [105877] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(4584), 1,
      anon_sym_LPAREN,
    STATE(2295), 1,
      sym_formal_parameters,
    STATE(3054), 1,
      sym_type_parameters,
    STATE(3132), 1,
      sym__call_signature,
  [105896] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4694), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [105907] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5025), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [105918] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1991), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [105929] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4987), 1,
      anon_sym_LBRACE,
    STATE(1887), 1,
      sym_statement_block,
    ACTIONS(4570), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [105944] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1983), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [105955] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2542), 1,
      anon_sym_LPAREN,
    STATE(2066), 1,
      sym_formal_parameters,
    STATE(2501), 1,
      sym__call_signature,
    STATE(3032), 1,
      sym_type_parameters,
  [105974] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4363), 1,
      anon_sym_EQ,
    STATE(2930), 1,
      sym__initializer,
    ACTIONS(5027), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [105989] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(4584), 1,
      anon_sym_LPAREN,
    STATE(2295), 1,
      sym_formal_parameters,
    STATE(3054), 1,
      sym_type_parameters,
    STATE(3092), 1,
      sym__call_signature,
  [106008] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4987), 1,
      anon_sym_LBRACE,
    STATE(1869), 1,
      sym_statement_block,
    ACTIONS(4694), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [106023] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4987), 1,
      anon_sym_LBRACE,
    STATE(1871), 1,
      sym_statement_block,
    ACTIONS(4662), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [106038] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1895), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [106049] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4345), 1,
      anon_sym_AMP,
    ACTIONS(4347), 1,
      anon_sym_PIPE,
    ACTIONS(4349), 1,
      anon_sym_extends,
    ACTIONS(1782), 2,
      anon_sym_else,
      anon_sym_while,
  [106066] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1891), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [106077] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4363), 1,
      anon_sym_EQ,
    STATE(2924), 1,
      sym__initializer,
    ACTIONS(5029), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [106092] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4363), 1,
      anon_sym_EQ,
    STATE(2919), 1,
      sym__initializer,
    ACTIONS(5031), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [106107] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3097), 1,
      anon_sym_LBRACE,
    STATE(1408), 1,
      sym_statement_block,
    ACTIONS(4997), 3,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_SEMI,
  [106122] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2542), 1,
      anon_sym_LPAREN,
    STATE(2066), 1,
      sym_formal_parameters,
    STATE(2387), 1,
      sym__call_signature,
    STATE(3032), 1,
      sym_type_parameters,
  [106141] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(4584), 1,
      anon_sym_LPAREN,
    STATE(2295), 1,
      sym_formal_parameters,
    STATE(3054), 1,
      sym_type_parameters,
    STATE(3068), 1,
      sym__call_signature,
  [106160] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1015), 1,
      anon_sym_DOT,
    ACTIONS(1398), 1,
      anon_sym_LBRACE,
    ACTIONS(1396), 3,
      anon_sym_COMMA,
      anon_sym_LT,
      anon_sym_LBRACE_PIPE,
  [106175] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4987), 1,
      anon_sym_LBRACE,
    STATE(1872), 1,
      sym_statement_block,
    ACTIONS(4664), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [106190] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1887), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [106201] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4363), 1,
      anon_sym_EQ,
    STATE(2849), 1,
      sym__initializer,
    ACTIONS(5033), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [106216] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1729), 1,
      anon_sym_LBRACE,
    ACTIONS(4112), 1,
      anon_sym_LBRACK,
    ACTIONS(5035), 1,
      sym_identifier,
    STATE(3227), 1,
      sym_array,
    STATE(3267), 1,
      sym_object,
  [106235] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(613), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2420), 1,
      anon_sym_LBRACE,
    ACTIONS(4596), 1,
      anon_sym_extends,
    STATE(2605), 1,
      sym_object_type,
    STATE(2841), 1,
      sym_extends_clause,
  [106254] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5037), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [106265] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5039), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [106276] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4692), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [106287] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2223), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [106298] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4462), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [106309] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5041), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [106320] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5043), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [106331] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5045), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [106342] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1879), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [106353] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5047), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [106364] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4662), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [106375] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2542), 1,
      anon_sym_LPAREN,
    STATE(2066), 1,
      sym_formal_parameters,
    STATE(2380), 1,
      sym__call_signature,
    STATE(3032), 1,
      sym_type_parameters,
  [106394] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5049), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [106405] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [106416] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1039), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [106427] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1029), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [106438] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4664), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [106449] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1736), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [106460] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3857), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [106471] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1053), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [106482] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3097), 1,
      anon_sym_LBRACE,
    STATE(1588), 1,
      sym_statement_block,
    ACTIONS(5051), 3,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_SEMI,
  [106497] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5053), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [106508] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(4983), 1,
      anon_sym_LPAREN,
    STATE(2151), 1,
      sym_formal_parameters,
    STATE(2615), 1,
      sym__call_signature,
    STATE(2945), 1,
      sym_type_parameters,
  [106527] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4690), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [106538] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5055), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [106549] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1125), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [106560] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4562), 1,
      anon_sym_LBRACE,
    STATE(2554), 1,
      sym_statement_block,
    ACTIONS(5057), 3,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_SEMI,
  [106575] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5059), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [106586] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4466), 1,
      anon_sym_AMP,
    ACTIONS(4470), 1,
      anon_sym_extends,
    ACTIONS(5063), 1,
      anon_sym_PIPE,
    ACTIONS(5061), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [106603] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(4584), 1,
      anon_sym_LPAREN,
    STATE(2295), 1,
      sym_formal_parameters,
    STATE(3054), 1,
      sym_type_parameters,
    STATE(3101), 1,
      sym__call_signature,
  [106622] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5065), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [106633] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4466), 1,
      anon_sym_AMP,
    ACTIONS(4470), 1,
      anon_sym_extends,
    ACTIONS(5063), 1,
      anon_sym_PIPE,
    ACTIONS(5067), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [106650] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4987), 1,
      anon_sym_LBRACE,
    STATE(1873), 1,
      sym_statement_block,
    ACTIONS(4692), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [106665] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2542), 1,
      anon_sym_LPAREN,
    STATE(2066), 1,
      sym_formal_parameters,
    STATE(2516), 1,
      sym__call_signature,
    STATE(3032), 1,
      sym_type_parameters,
  [106684] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5069), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [106695] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5071), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [106706] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3862), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [106717] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2542), 1,
      anon_sym_LPAREN,
    STATE(2066), 1,
      sym_formal_parameters,
    STATE(2247), 1,
      sym__call_signature,
    STATE(3032), 1,
      sym_type_parameters,
  [106736] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4987), 1,
      anon_sym_LBRACE,
    STATE(1884), 1,
      sym_statement_block,
    ACTIONS(4690), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [106751] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2542), 1,
      anon_sym_LPAREN,
    STATE(2066), 1,
      sym_formal_parameters,
    STATE(2249), 1,
      sym__call_signature,
    STATE(3032), 1,
      sym_type_parameters,
  [106770] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1935), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [106781] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5073), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [106792] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1863), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [106803] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5075), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [106814] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5077), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [106825] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2542), 1,
      anon_sym_LPAREN,
    STATE(2066), 1,
      sym_formal_parameters,
    STATE(2171), 1,
      sym__call_signature,
    STATE(3032), 1,
      sym_type_parameters,
  [106844] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4688), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [106855] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4987), 1,
      anon_sym_LBRACE,
    STATE(1883), 1,
      sym_statement_block,
    ACTIONS(4688), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [106870] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2542), 1,
      anon_sym_LPAREN,
    STATE(2066), 1,
      sym_formal_parameters,
    STATE(2226), 1,
      sym__call_signature,
    STATE(3032), 1,
      sym_type_parameters,
  [106889] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(4584), 1,
      anon_sym_LPAREN,
    STATE(2295), 1,
      sym_formal_parameters,
    STATE(2977), 1,
      sym__call_signature,
    STATE(3054), 1,
      sym_type_parameters,
  [106908] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1107), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [106919] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2542), 1,
      anon_sym_LPAREN,
    STATE(2066), 1,
      sym_formal_parameters,
    STATE(2229), 1,
      sym__call_signature,
    STATE(3032), 1,
      sym_type_parameters,
  [106938] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(4584), 1,
      anon_sym_LPAREN,
    STATE(2295), 1,
      sym_formal_parameters,
    STATE(3019), 1,
      sym__call_signature,
    STATE(3054), 1,
      sym_type_parameters,
  [106957] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5079), 5,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_implements,
      anon_sym_extends,
  [106968] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4817), 1,
      anon_sym_COLON,
    ACTIONS(5081), 1,
      anon_sym_EQ_GT,
    STATE(3034), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
  [106983] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(4584), 1,
      anon_sym_LPAREN,
    STATE(2295), 1,
      sym_formal_parameters,
    STATE(3043), 1,
      sym__call_signature,
    STATE(3054), 1,
      sym_type_parameters,
  [107002] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2135), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [107013] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2123), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [107024] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1107), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [107035] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2987), 5,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
  [107046] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5083), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [107057] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2115), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [107068] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3097), 1,
      anon_sym_LBRACE,
    STATE(1382), 1,
      sym_statement_block,
    ACTIONS(4993), 3,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_SEMI,
  [107083] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(4584), 1,
      anon_sym_LPAREN,
    STATE(2295), 1,
      sym_formal_parameters,
    STATE(3052), 1,
      sym__call_signature,
    STATE(3054), 1,
      sym_type_parameters,
  [107102] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4843), 1,
      sym_identifier,
    ACTIONS(5085), 1,
      anon_sym_RBRACE,
    STATE(2948), 1,
      sym__import_export_specifier,
    ACTIONS(4849), 2,
      anon_sym_type,
      anon_sym_typeof,
  [107119] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(4584), 1,
      anon_sym_LPAREN,
    STATE(2295), 1,
      sym_formal_parameters,
    STATE(3053), 1,
      sym__call_signature,
    STATE(3054), 1,
      sym_type_parameters,
  [107138] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1907), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [107149] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(4983), 1,
      anon_sym_LPAREN,
    STATE(2151), 1,
      sym_formal_parameters,
    STATE(2553), 1,
      sym__call_signature,
    STATE(2945), 1,
      sym_type_parameters,
  [107168] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1963), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [107179] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2996), 5,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
  [107190] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3000), 5,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
  [107201] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(4983), 1,
      anon_sym_LPAREN,
    STATE(2151), 1,
      sym_formal_parameters,
    STATE(2399), 1,
      sym__call_signature,
    STATE(2945), 1,
      sym_type_parameters,
  [107220] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4602), 1,
      anon_sym_EQ,
    ACTIONS(5087), 1,
      anon_sym_COMMA,
    ACTIONS(5089), 1,
      anon_sym_RBRACE,
    STATE(2864), 1,
      aux_sym_enum_body_repeat1,
    STATE(3012), 1,
      sym__initializer,
  [107239] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(4584), 1,
      anon_sym_LPAREN,
    STATE(2295), 1,
      sym_formal_parameters,
    STATE(3054), 1,
      sym_type_parameters,
    STATE(3135), 1,
      sym__call_signature,
  [107258] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(937), 1,
      anon_sym_LBRACE,
    STATE(76), 1,
      sym_statement_block,
    ACTIONS(4997), 3,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_SEMI,
  [107273] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(4584), 1,
      anon_sym_LPAREN,
    STATE(2295), 1,
      sym_formal_parameters,
    STATE(3054), 1,
      sym_type_parameters,
    STATE(3080), 1,
      sym__call_signature,
  [107292] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1967), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [107303] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3097), 1,
      anon_sym_LBRACE,
    STATE(1588), 1,
      sym_statement_block,
    ACTIONS(4993), 3,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_SEMI,
  [107318] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1987), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [107329] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(947), 5,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
  [107340] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(4983), 1,
      anon_sym_LPAREN,
    STATE(2151), 1,
      sym_formal_parameters,
    STATE(2531), 1,
      sym__call_signature,
    STATE(2945), 1,
      sym_type_parameters,
  [107359] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2091), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [107370] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(4983), 1,
      anon_sym_LPAREN,
    STATE(2151), 1,
      sym_formal_parameters,
    STATE(2489), 1,
      sym__call_signature,
    STATE(2945), 1,
      sym_type_parameters,
  [107389] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2027), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [107400] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4562), 1,
      anon_sym_LBRACE,
    STATE(2577), 1,
      sym_statement_block,
    ACTIONS(5051), 3,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_SEMI,
  [107415] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5091), 1,
      sym__automatic_semicolon,
    ACTIONS(983), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [107428] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2075), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [107439] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2840), 5,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
  [107450] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4466), 1,
      anon_sym_AMP,
    ACTIONS(4470), 1,
      anon_sym_extends,
    ACTIONS(5063), 1,
      anon_sym_PIPE,
    ACTIONS(5093), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [107467] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(4584), 1,
      anon_sym_LPAREN,
    STATE(2295), 1,
      sym_formal_parameters,
    STATE(3054), 1,
      sym_type_parameters,
    STATE(3114), 1,
      sym__call_signature,
  [107486] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2131), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [107497] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1979), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [107508] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(4983), 1,
      anon_sym_LPAREN,
    STATE(2151), 1,
      sym_formal_parameters,
    STATE(2495), 1,
      sym__call_signature,
    STATE(2945), 1,
      sym_type_parameters,
  [107527] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3514), 1,
      anon_sym_LBRACE,
    ACTIONS(4755), 1,
      anon_sym_LT,
    STATE(2828), 1,
      sym_type_arguments,
    ACTIONS(3461), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [107544] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2023), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [107555] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(499), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(915), 1,
      anon_sym_LBRACE,
    ACTIONS(4596), 1,
      anon_sym_extends,
    STATE(600), 1,
      sym_object_type,
    STATE(2767), 1,
      sym_extends_clause,
  [107574] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4345), 1,
      anon_sym_AMP,
    ACTIONS(4347), 1,
      anon_sym_PIPE,
    ACTIONS(4349), 1,
      anon_sym_extends,
    ACTIONS(4532), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
  [107591] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2035), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [107602] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4843), 1,
      sym_identifier,
    ACTIONS(5095), 1,
      anon_sym_RBRACE,
    STATE(2948), 1,
      sym__import_export_specifier,
    ACTIONS(4849), 2,
      anon_sym_type,
      anon_sym_typeof,
  [107619] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4817), 1,
      anon_sym_COLON,
    ACTIONS(5097), 1,
      anon_sym_EQ_GT,
    STATE(2961), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
  [107634] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4817), 1,
      anon_sym_COLON,
    ACTIONS(5099), 1,
      anon_sym_EQ_GT,
    STATE(2961), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
  [107649] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2079), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [107660] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4817), 1,
      anon_sym_COLON,
    ACTIONS(5101), 1,
      anon_sym_EQ_GT,
    STATE(3034), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
  [107675] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2051), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [107686] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2031), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [107697] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(4983), 1,
      anon_sym_LPAREN,
    STATE(2151), 1,
      sym_formal_parameters,
    STATE(2404), 1,
      sym__call_signature,
    STATE(2945), 1,
      sym_type_parameters,
  [107716] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(4983), 1,
      anon_sym_LPAREN,
    STATE(2151), 1,
      sym_formal_parameters,
    STATE(2460), 1,
      sym__call_signature,
    STATE(2945), 1,
      sym_type_parameters,
  [107735] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(965), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [107746] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5103), 1,
      sym__automatic_semicolon,
    ACTIONS(951), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [107759] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5105), 1,
      sym__automatic_semicolon,
    ACTIONS(993), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [107772] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2542), 1,
      anon_sym_LPAREN,
    STATE(2066), 1,
      sym_formal_parameters,
    STATE(2485), 1,
      sym__call_signature,
    STATE(3032), 1,
      sym_type_parameters,
  [107791] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4843), 1,
      sym_identifier,
    ACTIONS(5107), 1,
      anon_sym_RBRACE,
    STATE(3089), 1,
      sym__import_export_specifier,
    ACTIONS(4849), 2,
      anon_sym_type,
      anon_sym_typeof,
  [107808] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3013), 5,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
  [107819] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4684), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [107830] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(4983), 1,
      anon_sym_LPAREN,
    STATE(2151), 1,
      sym_formal_parameters,
    STATE(2424), 1,
      sym__call_signature,
    STATE(2945), 1,
      sym_type_parameters,
  [107849] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1003), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [107860] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2840), 1,
      anon_sym_EQ,
    ACTIONS(3545), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [107873] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3017), 5,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
  [107884] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1859), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [107895] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4562), 1,
      anon_sym_LBRACE,
    STATE(529), 1,
      sym_statement_block,
    ACTIONS(4997), 3,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_SEMI,
  [107910] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5109), 1,
      sym__automatic_semicolon,
    ACTIONS(1115), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [107923] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1855), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [107934] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1851), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [107945] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3021), 5,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
  [107956] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2119), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [107967] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4670), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [107978] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(979), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [107989] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2103), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [108000] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1019), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [108011] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(4584), 1,
      anon_sym_LPAREN,
    STATE(2295), 1,
      sym_formal_parameters,
    STATE(3037), 1,
      sym__call_signature,
    STATE(3054), 1,
      sym_type_parameters,
  [108030] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4339), 1,
      anon_sym_LT,
    STATE(275), 1,
      sym_type_arguments,
    ACTIONS(3461), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
  [108045] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2063), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [108056] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4987), 1,
      anon_sym_LBRACE,
    STATE(1890), 1,
      sym_statement_block,
    ACTIONS(4672), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [108071] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4363), 1,
      anon_sym_EQ,
    STATE(2858), 1,
      sym__initializer,
    ACTIONS(5111), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [108086] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4466), 1,
      anon_sym_AMP,
    ACTIONS(4470), 1,
      anon_sym_extends,
    ACTIONS(5063), 1,
      anon_sym_PIPE,
    ACTIONS(5113), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [108103] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2055), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [108114] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2043), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [108125] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4363), 1,
      anon_sym_EQ,
    STATE(2811), 1,
      sym__initializer,
    ACTIONS(5115), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [108140] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2039), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [108151] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4817), 1,
      anon_sym_COLON,
    ACTIONS(5117), 1,
      anon_sym_EQ_GT,
    STATE(2961), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
  [108166] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4817), 1,
      anon_sym_COLON,
    ACTIONS(5119), 1,
      anon_sym_EQ_GT,
    STATE(3034), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
  [108181] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4987), 1,
      anon_sym_LBRACE,
    STATE(1891), 1,
      sym_statement_block,
    ACTIONS(4684), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [108196] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2542), 1,
      anon_sym_LPAREN,
    STATE(2066), 1,
      sym_formal_parameters,
    STATE(2464), 1,
      sym__call_signature,
    STATE(3032), 1,
      sym_type_parameters,
  [108215] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(4584), 1,
      anon_sym_LPAREN,
    STATE(2295), 1,
      sym_formal_parameters,
    STATE(2967), 1,
      sym__call_signature,
    STATE(3054), 1,
      sym_type_parameters,
  [108234] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5121), 5,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_implements,
      anon_sym_extends,
  [108245] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(4584), 1,
      anon_sym_LPAREN,
    STATE(2295), 1,
      sym_formal_parameters,
    STATE(2952), 1,
      sym__call_signature,
    STATE(3054), 1,
      sym_type_parameters,
  [108264] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3097), 1,
      anon_sym_LBRACE,
    STATE(1597), 1,
      sym_statement_block,
    ACTIONS(5057), 3,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_SEMI,
  [108279] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5123), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [108290] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4672), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [108301] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1911), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [108312] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4739), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [108323] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2015), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [108334] = 5,
    ACTIONS(5125), 1,
      anon_sym_DQUOTE,
    ACTIONS(5127), 1,
      aux_sym_string_token1,
    ACTIONS(5129), 1,
      sym_escape_sequence,
    ACTIONS(5131), 1,
      sym_comment,
    STATE(2650), 1,
      aux_sym_string_repeat1,
  [108350] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4602), 1,
      anon_sym_EQ,
    STATE(3012), 1,
      sym__initializer,
    ACTIONS(5133), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [108364] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2721), 1,
      anon_sym_COMMA,
    ACTIONS(5135), 1,
      anon_sym_LBRACE,
    ACTIONS(5137), 1,
      anon_sym_LBRACE_PIPE,
    STATE(2637), 1,
      aux_sym_extends_clause_repeat1,
  [108380] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4345), 1,
      anon_sym_AMP,
    ACTIONS(4347), 1,
      anon_sym_PIPE,
    ACTIONS(4349), 1,
      anon_sym_extends,
    ACTIONS(5139), 1,
      anon_sym_QMARK,
  [108396] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4345), 1,
      anon_sym_AMP,
    ACTIONS(4347), 1,
      anon_sym_PIPE,
    ACTIONS(4349), 1,
      anon_sym_extends,
    ACTIONS(5141), 1,
      anon_sym_QMARK,
  [108412] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4345), 1,
      anon_sym_AMP,
    ACTIONS(4347), 1,
      anon_sym_PIPE,
    ACTIONS(4349), 1,
      anon_sym_extends,
    ACTIONS(5143), 1,
      anon_sym_COLON,
  [108428] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(5145), 1,
      anon_sym_class,
    STATE(1915), 1,
      aux_sym_export_statement_repeat1,
    STATE(1945), 1,
      sym_decorator,
  [108444] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(4584), 1,
      anon_sym_LPAREN,
    STATE(3058), 1,
      sym_type_parameters,
    STATE(3172), 1,
      sym_formal_parameters,
  [108460] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4345), 1,
      anon_sym_AMP,
    ACTIONS(4347), 1,
      anon_sym_PIPE,
    ACTIONS(4349), 1,
      anon_sym_extends,
    ACTIONS(5147), 1,
      anon_sym_COLON,
  [108476] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3113), 4,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [108486] = 5,
    ACTIONS(5131), 1,
      sym_comment,
    ACTIONS(5149), 1,
      anon_sym_SQUOTE,
    ACTIONS(5151), 1,
      aux_sym_string_token2,
    ACTIONS(5153), 1,
      sym_escape_sequence,
    STATE(2647), 1,
      aux_sym_string_repeat2,
  [108502] = 5,
    ACTIONS(5127), 1,
      aux_sym_string_token1,
    ACTIONS(5129), 1,
      sym_escape_sequence,
    ACTIONS(5131), 1,
      sym_comment,
    ACTIONS(5149), 1,
      anon_sym_DQUOTE,
    STATE(2650), 1,
      aux_sym_string_repeat1,
  [108518] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4345), 1,
      anon_sym_AMP,
    ACTIONS(4347), 1,
      anon_sym_PIPE,
    ACTIONS(4349), 1,
      anon_sym_extends,
    ACTIONS(5155), 1,
      anon_sym_QMARK,
  [108534] = 5,
    ACTIONS(5131), 1,
      sym_comment,
    ACTIONS(5157), 1,
      anon_sym_DQUOTE,
    ACTIONS(5159), 1,
      aux_sym_string_token1,
    ACTIONS(5161), 1,
      sym_escape_sequence,
    STATE(2621), 1,
      aux_sym_string_repeat1,
  [108550] = 5,
    ACTIONS(5131), 1,
      sym_comment,
    ACTIONS(5157), 1,
      anon_sym_SQUOTE,
    ACTIONS(5163), 1,
      aux_sym_string_token2,
    ACTIONS(5165), 1,
      sym_escape_sequence,
    STATE(2714), 1,
      aux_sym_string_repeat2,
  [108566] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5167), 1,
      sym_identifier,
    STATE(1503), 1,
      sym_nested_identifier,
    STATE(1504), 1,
      sym_generic_type,
    STATE(3110), 1,
      sym_nested_type_identifier,
  [108582] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3461), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3514), 1,
      anon_sym_LBRACE,
    ACTIONS(5169), 1,
      anon_sym_COMMA,
    STATE(2637), 1,
      aux_sym_extends_clause_repeat1,
  [108598] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5172), 1,
      sym_identifier,
    STATE(1610), 1,
      sym_nested_identifier,
    STATE(1613), 1,
      sym_generic_type,
    STATE(2947), 1,
      sym_nested_type_identifier,
  [108614] = 5,
    ACTIONS(5131), 1,
      sym_comment,
    ACTIONS(5174), 1,
      anon_sym_SQUOTE,
    ACTIONS(5176), 1,
      aux_sym_string_token2,
    ACTIONS(5178), 1,
      sym_escape_sequence,
    STATE(2631), 1,
      aux_sym_string_repeat2,
  [108630] = 5,
    ACTIONS(5131), 1,
      sym_comment,
    ACTIONS(5174), 1,
      anon_sym_DQUOTE,
    ACTIONS(5180), 1,
      aux_sym_string_token1,
    ACTIONS(5182), 1,
      sym_escape_sequence,
    STATE(2632), 1,
      aux_sym_string_repeat1,
  [108646] = 5,
    ACTIONS(5131), 1,
      sym_comment,
    ACTIONS(5184), 1,
      anon_sym_SQUOTE,
    ACTIONS(5186), 1,
      aux_sym_string_token2,
    ACTIONS(5188), 1,
      sym_escape_sequence,
    STATE(2748), 1,
      aux_sym_string_repeat2,
  [108662] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4345), 1,
      anon_sym_AMP,
    ACTIONS(4347), 1,
      anon_sym_PIPE,
    ACTIONS(4349), 1,
      anon_sym_extends,
    ACTIONS(5190), 1,
      anon_sym_COLON,
  [108678] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2721), 1,
      anon_sym_COMMA,
    ACTIONS(3316), 1,
      anon_sym_LBRACE,
    ACTIONS(3348), 1,
      anon_sym_LBRACE_PIPE,
    STATE(2686), 1,
      aux_sym_extends_clause_repeat1,
  [108694] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4345), 1,
      anon_sym_AMP,
    ACTIONS(4347), 1,
      anon_sym_PIPE,
    ACTIONS(4349), 1,
      anon_sym_extends,
    ACTIONS(5192), 1,
      anon_sym_RBRACK,
  [108710] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4345), 1,
      anon_sym_AMP,
    ACTIONS(4347), 1,
      anon_sym_PIPE,
    ACTIONS(4349), 1,
      anon_sym_extends,
    ACTIONS(5194), 1,
      anon_sym_QMARK,
  [108726] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5196), 1,
      anon_sym_COMMA,
    STATE(2646), 1,
      aux_sym_extends_clause_repeat1,
    ACTIONS(3461), 2,
      anon_sym_LBRACE,
      anon_sym_implements,
  [108740] = 5,
    ACTIONS(5131), 1,
      sym_comment,
    ACTIONS(5199), 1,
      anon_sym_SQUOTE,
    ACTIONS(5201), 1,
      aux_sym_string_token2,
    ACTIONS(5204), 1,
      sym_escape_sequence,
    STATE(2647), 1,
      aux_sym_string_repeat2,
  [108756] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5207), 1,
      anon_sym_COMMA,
    STATE(2648), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(5210), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [108770] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4345), 1,
      anon_sym_AMP,
    ACTIONS(4347), 1,
      anon_sym_PIPE,
    ACTIONS(4349), 1,
      anon_sym_extends,
    ACTIONS(5212), 1,
      anon_sym_RPAREN,
  [108786] = 5,
    ACTIONS(5131), 1,
      sym_comment,
    ACTIONS(5214), 1,
      anon_sym_DQUOTE,
    ACTIONS(5216), 1,
      aux_sym_string_token1,
    ACTIONS(5219), 1,
      sym_escape_sequence,
    STATE(2650), 1,
      aux_sym_string_repeat1,
  [108802] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4843), 1,
      sym_identifier,
    STATE(3089), 1,
      sym__import_export_specifier,
    ACTIONS(4849), 2,
      anon_sym_type,
      anon_sym_typeof,
  [108816] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2738), 1,
      anon_sym_COMMA,
    STATE(2733), 1,
      aux_sym_extends_clause_repeat1,
    ACTIONS(3348), 2,
      anon_sym_LBRACE,
      anon_sym_implements,
  [108830] = 5,
    ACTIONS(5131), 1,
      sym_comment,
    ACTIONS(5151), 1,
      aux_sym_string_token2,
    ACTIONS(5153), 1,
      sym_escape_sequence,
    ACTIONS(5222), 1,
      anon_sym_SQUOTE,
    STATE(2647), 1,
      aux_sym_string_repeat2,
  [108846] = 5,
    ACTIONS(5127), 1,
      aux_sym_string_token1,
    ACTIONS(5129), 1,
      sym_escape_sequence,
    ACTIONS(5131), 1,
      sym_comment,
    ACTIONS(5222), 1,
      anon_sym_DQUOTE,
    STATE(2650), 1,
      aux_sym_string_repeat1,
  [108862] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4345), 1,
      anon_sym_AMP,
    ACTIONS(4347), 1,
      anon_sym_PIPE,
    ACTIONS(4349), 1,
      anon_sym_extends,
    ACTIONS(5224), 1,
      anon_sym_RBRACK,
  [108878] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4843), 1,
      sym_identifier,
    STATE(2948), 1,
      sym__import_export_specifier,
    ACTIONS(4849), 2,
      anon_sym_type,
      anon_sym_typeof,
  [108892] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4345), 1,
      anon_sym_AMP,
    ACTIONS(4347), 1,
      anon_sym_PIPE,
    ACTIONS(4349), 1,
      anon_sym_extends,
    ACTIONS(5226), 1,
      anon_sym_QMARK,
  [108908] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5228), 1,
      sym_identifier,
    STATE(433), 1,
      sym_generic_type,
    STATE(491), 1,
      sym_nested_identifier,
    STATE(3120), 1,
      sym_nested_type_identifier,
  [108924] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5230), 1,
      anon_sym_LBRACK,
    ACTIONS(1555), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [108936] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4401), 1,
      anon_sym_EQ,
    STATE(3079), 1,
      sym_default_type,
    ACTIONS(5232), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [108950] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3218), 1,
      anon_sym_COLON,
    STATE(3060), 1,
      sym_type_annotation,
    ACTIONS(5234), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [108964] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5236), 1,
      anon_sym_QMARK,
    ACTIONS(2817), 3,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [108976] = 5,
    ACTIONS(5131), 1,
      sym_comment,
    ACTIONS(5238), 1,
      anon_sym_SQUOTE,
    ACTIONS(5240), 1,
      aux_sym_string_token2,
    ACTIONS(5242), 1,
      sym_escape_sequence,
    STATE(2653), 1,
      aux_sym_string_repeat2,
  [108992] = 5,
    ACTIONS(5131), 1,
      sym_comment,
    ACTIONS(5238), 1,
      anon_sym_DQUOTE,
    ACTIONS(5244), 1,
      aux_sym_string_token1,
    ACTIONS(5246), 1,
      sym_escape_sequence,
    STATE(2654), 1,
      aux_sym_string_repeat1,
  [109008] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4345), 1,
      anon_sym_AMP,
    ACTIONS(4347), 1,
      anon_sym_PIPE,
    ACTIONS(4349), 1,
      anon_sym_extends,
    ACTIONS(5248), 1,
      anon_sym_COLON,
  [109024] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4345), 1,
      anon_sym_AMP,
    ACTIONS(4347), 1,
      anon_sym_PIPE,
    ACTIONS(4349), 1,
      anon_sym_extends,
    ACTIONS(5250), 1,
      anon_sym_RPAREN,
  [109040] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5252), 1,
      sym_identifier,
    STATE(2008), 1,
      sym_nested_identifier,
    STATE(2037), 1,
      sym_generic_type,
    STATE(3077), 1,
      sym_nested_type_identifier,
  [109056] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(5254), 1,
      anon_sym_export,
    STATE(1915), 1,
      aux_sym_export_statement_repeat1,
    STATE(1945), 1,
      sym_decorator,
  [109072] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(2542), 1,
      anon_sym_LPAREN,
    STATE(2203), 1,
      sym_formal_parameters,
    STATE(3073), 1,
      sym_type_parameters,
  [109088] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5256), 1,
      anon_sym_COMMA,
    STATE(2670), 1,
      aux_sym_array_repeat1,
    ACTIONS(3449), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [109102] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4345), 1,
      anon_sym_AMP,
    ACTIONS(4347), 1,
      anon_sym_PIPE,
    ACTIONS(4349), 1,
      anon_sym_extends,
    ACTIONS(5259), 1,
      anon_sym_RBRACK,
  [109118] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4345), 1,
      anon_sym_AMP,
    ACTIONS(4347), 1,
      anon_sym_PIPE,
    ACTIONS(4349), 1,
      anon_sym_extends,
    ACTIONS(5261), 1,
      anon_sym_RBRACK,
  [109134] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4602), 1,
      anon_sym_EQ,
    STATE(2950), 1,
      sym__initializer,
    ACTIONS(5263), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [109148] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4345), 1,
      anon_sym_AMP,
    ACTIONS(4347), 1,
      anon_sym_PIPE,
    ACTIONS(4349), 1,
      anon_sym_extends,
    ACTIONS(5265), 1,
      anon_sym_RBRACK,
  [109164] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4345), 1,
      anon_sym_AMP,
    ACTIONS(4347), 1,
      anon_sym_PIPE,
    ACTIONS(4349), 1,
      anon_sym_extends,
    ACTIONS(5267), 1,
      anon_sym_RBRACK,
  [109180] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4602), 1,
      anon_sym_EQ,
    STATE(2992), 1,
      sym__initializer,
    ACTIONS(5269), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [109194] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2781), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [109204] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4345), 1,
      anon_sym_AMP,
    ACTIONS(4347), 1,
      anon_sym_PIPE,
    ACTIONS(4349), 1,
      anon_sym_extends,
    ACTIONS(5271), 1,
      anon_sym_COLON,
  [109220] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5273), 1,
      anon_sym_COMMA,
    STATE(2648), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(5275), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [109234] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4345), 1,
      anon_sym_AMP,
    ACTIONS(4347), 1,
      anon_sym_PIPE,
    ACTIONS(4349), 1,
      anon_sym_extends,
    ACTIONS(5277), 1,
      anon_sym_RPAREN,
  [109250] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5273), 1,
      anon_sym_COMMA,
    STATE(2648), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(5279), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [109264] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5281), 1,
      anon_sym_from,
    STATE(2964), 1,
      sym__from_clause,
    ACTIONS(5283), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [109278] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4345), 1,
      anon_sym_AMP,
    ACTIONS(4347), 1,
      anon_sym_PIPE,
    ACTIONS(4349), 1,
      anon_sym_extends,
    ACTIONS(5285), 1,
      anon_sym_RBRACK,
  [109294] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(5287), 1,
      anon_sym_class,
    STATE(1915), 1,
      aux_sym_export_statement_repeat1,
    STATE(1945), 1,
      sym_decorator,
  [109310] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5289), 1,
      anon_sym_LBRACK,
    ACTIONS(1555), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [109322] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2721), 1,
      anon_sym_COMMA,
    ACTIONS(5291), 1,
      anon_sym_LBRACE,
    ACTIONS(5293), 1,
      anon_sym_LBRACE_PIPE,
    STATE(2637), 1,
      aux_sym_extends_clause_repeat1,
  [109338] = 5,
    ACTIONS(5131), 1,
      sym_comment,
    ACTIONS(5151), 1,
      aux_sym_string_token2,
    ACTIONS(5153), 1,
      sym_escape_sequence,
    ACTIONS(5295), 1,
      anon_sym_SQUOTE,
    STATE(2647), 1,
      aux_sym_string_repeat2,
  [109354] = 5,
    ACTIONS(5131), 1,
      sym_comment,
    ACTIONS(5151), 1,
      aux_sym_string_token2,
    ACTIONS(5153), 1,
      sym_escape_sequence,
    ACTIONS(5297), 1,
      anon_sym_SQUOTE,
    STATE(2647), 1,
      aux_sym_string_repeat2,
  [109370] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2850), 1,
      anon_sym_LBRACE,
    ACTIONS(4504), 1,
      anon_sym_STAR,
    STATE(3303), 2,
      sym_namespace_import,
      sym_named_imports,
  [109384] = 5,
    ACTIONS(5127), 1,
      aux_sym_string_token1,
    ACTIONS(5129), 1,
      sym_escape_sequence,
    ACTIONS(5131), 1,
      sym_comment,
    ACTIONS(5297), 1,
      anon_sym_DQUOTE,
    STATE(2650), 1,
      aux_sym_string_repeat1,
  [109400] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4345), 1,
      anon_sym_AMP,
    ACTIONS(4347), 1,
      anon_sym_PIPE,
    ACTIONS(4349), 1,
      anon_sym_extends,
    ACTIONS(5299), 1,
      anon_sym_RPAREN,
  [109416] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5301), 1,
      anon_sym_LBRACK,
    ACTIONS(1555), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [109428] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(697), 1,
      anon_sym_BQUOTE,
    ACTIONS(2201), 1,
      anon_sym_LPAREN,
    STATE(1700), 2,
      sym_template_string,
      sym_arguments,
  [109442] = 5,
    ACTIONS(5131), 1,
      sym_comment,
    ACTIONS(5303), 1,
      anon_sym_DQUOTE,
    ACTIONS(5305), 1,
      aux_sym_string_token1,
    ACTIONS(5307), 1,
      sym_escape_sequence,
    STATE(2736), 1,
      aux_sym_string_repeat1,
  [109458] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5273), 1,
      anon_sym_COMMA,
    STATE(2648), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(5309), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [109472] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5273), 1,
      anon_sym_COMMA,
    STATE(2648), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(5311), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [109486] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5313), 1,
      sym_identifier,
    STATE(2097), 1,
      sym_nested_identifier,
    STATE(2138), 1,
      sym_generic_type,
    STATE(3030), 1,
      sym_nested_type_identifier,
  [109502] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(4584), 1,
      anon_sym_LPAREN,
    STATE(3066), 1,
      sym_type_parameters,
    STATE(3377), 1,
      sym_formal_parameters,
  [109518] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5315), 1,
      anon_sym_LBRACK,
    ACTIONS(1555), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [109530] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(4584), 1,
      anon_sym_LPAREN,
    STATE(3031), 1,
      sym_type_parameters,
    STATE(3332), 1,
      sym_formal_parameters,
  [109546] = 5,
    ACTIONS(5131), 1,
      sym_comment,
    ACTIONS(5317), 1,
      anon_sym_SQUOTE,
    ACTIONS(5319), 1,
      aux_sym_string_token2,
    ACTIONS(5321), 1,
      sym_escape_sequence,
    STATE(2688), 1,
      aux_sym_string_repeat2,
  [109562] = 5,
    ACTIONS(5131), 1,
      sym_comment,
    ACTIONS(5317), 1,
      anon_sym_DQUOTE,
    ACTIONS(5323), 1,
      aux_sym_string_token1,
    ACTIONS(5325), 1,
      sym_escape_sequence,
    STATE(2690), 1,
      aux_sym_string_repeat1,
  [109578] = 5,
    ACTIONS(5131), 1,
      sym_comment,
    ACTIONS(5303), 1,
      anon_sym_SQUOTE,
    ACTIONS(5327), 1,
      aux_sym_string_token2,
    ACTIONS(5329), 1,
      sym_escape_sequence,
    STATE(2687), 1,
      aux_sym_string_repeat2,
  [109594] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5331), 1,
      anon_sym_EQ_GT,
    ACTIONS(2894), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
  [109606] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5333), 1,
      anon_sym_LBRACK,
    ACTIONS(1555), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [109618] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4345), 1,
      anon_sym_AMP,
    ACTIONS(4347), 1,
      anon_sym_PIPE,
    ACTIONS(4349), 1,
      anon_sym_extends,
    ACTIONS(5335), 1,
      anon_sym_COLON,
  [109634] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4178), 1,
      anon_sym_EQ_GT,
    ACTIONS(2894), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
  [109646] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4751), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
  [109656] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4749), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
  [109666] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4345), 1,
      anon_sym_AMP,
    ACTIONS(4347), 1,
      anon_sym_PIPE,
    ACTIONS(4349), 1,
      anon_sym_extends,
    ACTIONS(5337), 1,
      anon_sym_RBRACK,
  [109682] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4793), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
  [109692] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4345), 1,
      anon_sym_AMP,
    ACTIONS(4347), 1,
      anon_sym_PIPE,
    ACTIONS(4349), 1,
      anon_sym_extends,
    ACTIONS(5339), 1,
      anon_sym_QMARK,
  [109708] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4345), 1,
      anon_sym_AMP,
    ACTIONS(4347), 1,
      anon_sym_PIPE,
    ACTIONS(4349), 1,
      anon_sym_extends,
    ACTIONS(5341), 1,
      anon_sym_RPAREN,
  [109724] = 5,
    ACTIONS(5125), 1,
      anon_sym_SQUOTE,
    ACTIONS(5131), 1,
      sym_comment,
    ACTIONS(5151), 1,
      aux_sym_string_token2,
    ACTIONS(5153), 1,
      sym_escape_sequence,
    STATE(2647), 1,
      aux_sym_string_repeat2,
  [109740] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(4584), 1,
      anon_sym_LPAREN,
    STATE(3010), 1,
      sym_type_parameters,
    STATE(3309), 1,
      sym_formal_parameters,
  [109756] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5343), 1,
      anon_sym_COMMA,
    STATE(2716), 1,
      aux_sym_implements_clause_repeat1,
    ACTIONS(4923), 2,
      anon_sym_LBRACE,
      anon_sym_GT,
  [109770] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5346), 1,
      anon_sym_LBRACK,
    ACTIONS(1555), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [109782] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4345), 1,
      anon_sym_AMP,
    ACTIONS(4347), 1,
      anon_sym_PIPE,
    ACTIONS(4349), 1,
      anon_sym_extends,
    ACTIONS(5348), 1,
      anon_sym_RBRACK,
  [109798] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(4584), 1,
      anon_sym_LPAREN,
    STATE(2996), 1,
      sym_type_parameters,
    STATE(3282), 1,
      sym_formal_parameters,
  [109814] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4345), 1,
      anon_sym_AMP,
    ACTIONS(4347), 1,
      anon_sym_PIPE,
    ACTIONS(4349), 1,
      anon_sym_extends,
    ACTIONS(5350), 1,
      anon_sym_RPAREN,
  [109830] = 5,
    ACTIONS(5131), 1,
      sym_comment,
    ACTIONS(5184), 1,
      anon_sym_DQUOTE,
    ACTIONS(5352), 1,
      aux_sym_string_token1,
    ACTIONS(5354), 1,
      sym_escape_sequence,
    STATE(2750), 1,
      aux_sym_string_repeat1,
  [109846] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4345), 1,
      anon_sym_AMP,
    ACTIONS(4347), 1,
      anon_sym_PIPE,
    ACTIONS(4349), 1,
      anon_sym_extends,
    ACTIONS(5356), 1,
      anon_sym_RBRACK,
  [109862] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4345), 1,
      anon_sym_AMP,
    ACTIONS(4347), 1,
      anon_sym_PIPE,
    ACTIONS(4349), 1,
      anon_sym_extends,
    ACTIONS(5358), 1,
      anon_sym_RBRACK,
  [109878] = 5,
    ACTIONS(5131), 1,
      sym_comment,
    ACTIONS(5151), 1,
      aux_sym_string_token2,
    ACTIONS(5153), 1,
      sym_escape_sequence,
    ACTIONS(5360), 1,
      anon_sym_SQUOTE,
    STATE(2647), 1,
      aux_sym_string_repeat2,
  [109894] = 5,
    ACTIONS(5127), 1,
      aux_sym_string_token1,
    ACTIONS(5129), 1,
      sym_escape_sequence,
    ACTIONS(5131), 1,
      sym_comment,
    ACTIONS(5360), 1,
      anon_sym_DQUOTE,
    STATE(2650), 1,
      aux_sym_string_repeat1,
  [109910] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(5362), 1,
      anon_sym_class,
    STATE(1915), 1,
      aux_sym_export_statement_repeat1,
    STATE(1945), 1,
      sym_decorator,
  [109926] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(479), 1,
      anon_sym_BQUOTE,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    STATE(1186), 2,
      sym_template_string,
      sym_arguments,
  [109940] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5281), 1,
      anon_sym_from,
    STATE(2979), 1,
      sym__from_clause,
    ACTIONS(5364), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [109954] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5273), 1,
      anon_sym_COMMA,
    STATE(2681), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(5366), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [109968] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5368), 1,
      sym_identifier,
    STATE(1075), 1,
      sym_generic_type,
    STATE(1077), 1,
      sym_nested_identifier,
    STATE(3094), 1,
      sym_nested_type_identifier,
  [109984] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2738), 1,
      anon_sym_COMMA,
    STATE(2646), 1,
      aux_sym_extends_clause_repeat1,
    ACTIONS(5137), 2,
      anon_sym_LBRACE,
      anon_sym_implements,
  [109998] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5273), 1,
      anon_sym_COMMA,
    STATE(2679), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(5370), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [110012] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2738), 1,
      anon_sym_COMMA,
    STATE(2646), 1,
      aux_sym_extends_clause_repeat1,
    ACTIONS(5293), 2,
      anon_sym_LBRACE,
      anon_sym_implements,
  [110026] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3218), 1,
      anon_sym_COLON,
    STATE(3136), 1,
      sym_type_annotation,
    ACTIONS(5372), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [110040] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(4584), 1,
      anon_sym_LPAREN,
    STATE(2938), 1,
      sym_type_parameters,
    STATE(3372), 1,
      sym_formal_parameters,
  [110056] = 5,
    ACTIONS(5127), 1,
      aux_sym_string_token1,
    ACTIONS(5129), 1,
      sym_escape_sequence,
    ACTIONS(5131), 1,
      sym_comment,
    ACTIONS(5295), 1,
      anon_sym_DQUOTE,
    STATE(2650), 1,
      aux_sym_string_repeat1,
  [110072] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5374), 1,
      sym_identifier,
    STATE(433), 1,
      sym_generic_type,
    STATE(1960), 1,
      sym_nested_identifier,
    STATE(3120), 1,
      sym_nested_type_identifier,
  [110088] = 5,
    ACTIONS(5131), 1,
      sym_comment,
    ACTIONS(5376), 1,
      anon_sym_SQUOTE,
    ACTIONS(5378), 1,
      aux_sym_string_token2,
    ACTIONS(5380), 1,
      sym_escape_sequence,
    STATE(2724), 1,
      aux_sym_string_repeat2,
  [110104] = 5,
    ACTIONS(5131), 1,
      sym_comment,
    ACTIONS(5376), 1,
      anon_sym_DQUOTE,
    ACTIONS(5382), 1,
      aux_sym_string_token1,
    ACTIONS(5384), 1,
      sym_escape_sequence,
    STATE(2725), 1,
      aux_sym_string_repeat1,
  [110120] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(4584), 1,
      anon_sym_LPAREN,
    STATE(3112), 1,
      sym_type_parameters,
    STATE(3180), 1,
      sym_formal_parameters,
  [110136] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5386), 4,
      sym__template_chars,
      sym_escape_sequence,
      anon_sym_BQUOTE,
      anon_sym_DOLLAR_LBRACE,
  [110146] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5273), 1,
      anon_sym_COMMA,
    STATE(2696), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(5388), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [110160] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4345), 1,
      anon_sym_AMP,
    ACTIONS(4347), 1,
      anon_sym_PIPE,
    ACTIONS(4349), 1,
      anon_sym_extends,
    ACTIONS(5390), 1,
      anon_sym_COLON,
  [110176] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5273), 1,
      anon_sym_COMMA,
    STATE(2695), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(5392), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [110190] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4345), 1,
      anon_sym_AMP,
    ACTIONS(4347), 1,
      anon_sym_PIPE,
    ACTIONS(4349), 1,
      anon_sym_extends,
    ACTIONS(5394), 1,
      anon_sym_QMARK,
  [110206] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(2197), 1,
      anon_sym_LPAREN,
    STATE(1551), 2,
      sym_template_string,
      sym_arguments,
  [110220] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4345), 1,
      anon_sym_AMP,
    ACTIONS(4347), 1,
      anon_sym_PIPE,
    ACTIONS(4349), 1,
      anon_sym_extends,
    ACTIONS(5396), 1,
      anon_sym_RBRACK,
  [110236] = 5,
    ACTIONS(5131), 1,
      sym_comment,
    ACTIONS(5151), 1,
      aux_sym_string_token2,
    ACTIONS(5153), 1,
      sym_escape_sequence,
    ACTIONS(5398), 1,
      anon_sym_SQUOTE,
    STATE(2647), 1,
      aux_sym_string_repeat2,
  [110252] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4345), 1,
      anon_sym_AMP,
    ACTIONS(4347), 1,
      anon_sym_PIPE,
    ACTIONS(4349), 1,
      anon_sym_extends,
    ACTIONS(5400), 1,
      anon_sym_RBRACK,
  [110268] = 5,
    ACTIONS(5127), 1,
      aux_sym_string_token1,
    ACTIONS(5129), 1,
      sym_escape_sequence,
    ACTIONS(5131), 1,
      sym_comment,
    ACTIONS(5398), 1,
      anon_sym_DQUOTE,
    STATE(2650), 1,
      aux_sym_string_repeat1,
  [110284] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(5402), 1,
      anon_sym_RBRACE,
    STATE(2837), 1,
      aux_sym_object_repeat1,
  [110297] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5404), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [110306] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3754), 1,
      anon_sym_extends,
    ACTIONS(4345), 1,
      anon_sym_AMP,
    ACTIONS(4347), 1,
      anon_sym_PIPE,
  [110319] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5406), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [110328] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1147), 1,
      anon_sym_COMMA,
    ACTIONS(5408), 1,
      anon_sym_RPAREN,
    STATE(2670), 1,
      aux_sym_array_repeat1,
  [110341] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4345), 1,
      anon_sym_AMP,
    ACTIONS(4347), 1,
      anon_sym_PIPE,
    ACTIONS(5410), 1,
      anon_sym_extends,
  [110354] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4345), 1,
      anon_sym_AMP,
    ACTIONS(4347), 1,
      anon_sym_PIPE,
    ACTIONS(4568), 1,
      anon_sym_extends,
  [110367] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1147), 1,
      anon_sym_COMMA,
    ACTIONS(5412), 1,
      anon_sym_RPAREN,
    STATE(2670), 1,
      aux_sym_array_repeat1,
  [110380] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4979), 1,
      anon_sym_COMMA,
    ACTIONS(4981), 1,
      anon_sym_RBRACE,
    STATE(2872), 1,
      aux_sym_enum_body_repeat1,
  [110393] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5414), 1,
      sym_identifier,
    ACTIONS(5416), 1,
      anon_sym_GT,
    STATE(3090), 1,
      sym_type_parameter,
  [110406] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5416), 1,
      anon_sym_GT,
    ACTIONS(5418), 1,
      anon_sym_COMMA,
    STATE(2813), 1,
      aux_sym_type_parameters_repeat1,
  [110419] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5420), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [110428] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5422), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [110437] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(613), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2420), 1,
      anon_sym_LBRACE,
    STATE(2604), 1,
      sym_object_type,
  [110450] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1147), 1,
      anon_sym_COMMA,
    ACTIONS(3502), 1,
      anon_sym_RPAREN,
    STATE(2843), 1,
      aux_sym_array_repeat1,
  [110463] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3078), 1,
      anon_sym_extends,
    ACTIONS(4345), 1,
      anon_sym_AMP,
    ACTIONS(4347), 1,
      anon_sym_PIPE,
  [110476] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(499), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(915), 1,
      anon_sym_LBRACE,
    STATE(580), 1,
      sym_object_type,
  [110489] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5424), 1,
      anon_sym_COMMA,
    ACTIONS(5426), 1,
      anon_sym_RBRACK,
    STATE(2891), 1,
      aux_sym__tuple_type_body_repeat1,
  [110502] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1147), 1,
      anon_sym_COMMA,
    ACTIONS(3502), 1,
      anon_sym_RPAREN,
    STATE(2670), 1,
      aux_sym_array_repeat1,
  [110515] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4650), 3,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
  [110524] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4345), 1,
      anon_sym_AMP,
    ACTIONS(4347), 1,
      anon_sym_PIPE,
    ACTIONS(4470), 1,
      anon_sym_extends,
  [110537] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4148), 1,
      anon_sym_RPAREN,
    ACTIONS(5428), 1,
      anon_sym_COMMA,
    STATE(2904), 1,
      aux_sym_formal_parameters_repeat1,
  [110550] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5430), 1,
      anon_sym_is,
    ACTIONS(4680), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
  [110561] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4110), 1,
      anon_sym_RPAREN,
    ACTIONS(5432), 1,
      anon_sym_COMMA,
    STATE(2904), 1,
      aux_sym_formal_parameters_repeat1,
  [110574] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3589), 1,
      anon_sym_extends,
    ACTIONS(4345), 1,
      anon_sym_AMP,
    ACTIONS(4347), 1,
      anon_sym_PIPE,
  [110587] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2707), 1,
      anon_sym_GT,
    ACTIONS(5434), 1,
      anon_sym_COMMA,
    STATE(2716), 1,
      aux_sym_implements_clause_repeat1,
  [110600] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5424), 1,
      anon_sym_COMMA,
    ACTIONS(5436), 1,
      anon_sym_RBRACK,
    STATE(2804), 1,
      aux_sym__tuple_type_body_repeat1,
  [110613] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4110), 1,
      anon_sym_RPAREN,
    ACTIONS(5432), 1,
      anon_sym_COMMA,
    STATE(2886), 1,
      aux_sym_formal_parameters_repeat1,
  [110626] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1796), 1,
      anon_sym_LBRACE,
    ACTIONS(5438), 1,
      anon_sym_LPAREN,
    STATE(522), 1,
      sym_statement_block,
  [110639] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(5402), 1,
      anon_sym_RBRACE,
    STATE(2807), 1,
      aux_sym_object_repeat1,
  [110652] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3449), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [110661] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1483), 1,
      anon_sym_LBRACE,
    ACTIONS(1481), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [110672] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1147), 1,
      anon_sym_COMMA,
    ACTIONS(5440), 1,
      anon_sym_RBRACK,
    STATE(2670), 1,
      aux_sym_array_repeat1,
  [110685] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5442), 1,
      sym_identifier,
    ACTIONS(5444), 1,
      anon_sym_require,
    STATE(2923), 1,
      sym_nested_identifier,
  [110698] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5446), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [110707] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4644), 3,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
  [110716] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5448), 3,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [110725] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1147), 1,
      anon_sym_COMMA,
    ACTIONS(3528), 1,
      anon_sym_RBRACK,
    STATE(2809), 1,
      aux_sym_array_repeat1,
  [110738] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1147), 1,
      anon_sym_COMMA,
    ACTIONS(3528), 1,
      anon_sym_RBRACK,
    STATE(2670), 1,
      aux_sym_array_repeat1,
  [110751] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5424), 1,
      anon_sym_COMMA,
    ACTIONS(5450), 1,
      anon_sym_RBRACK,
    STATE(2845), 1,
      aux_sym__tuple_type_body_repeat1,
  [110764] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1147), 1,
      anon_sym_COMMA,
    ACTIONS(3463), 1,
      anon_sym_RPAREN,
    STATE(2670), 1,
      aux_sym_array_repeat1,
  [110777] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4797), 1,
      anon_sym_COMMA,
    ACTIONS(5452), 1,
      anon_sym_LBRACE,
    STATE(2716), 1,
      aux_sym_implements_clause_repeat1,
  [110790] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5454), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [110799] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4345), 1,
      anon_sym_AMP,
    ACTIONS(4347), 1,
      anon_sym_PIPE,
    ACTIONS(4349), 1,
      anon_sym_extends,
  [110812] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5456), 1,
      anon_sym_LPAREN,
    ACTIONS(5458), 1,
      anon_sym_await,
    STATE(30), 1,
      sym__for_header,
  [110825] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1147), 1,
      anon_sym_COMMA,
    ACTIONS(3463), 1,
      anon_sym_RPAREN,
    STATE(2758), 1,
      aux_sym_array_repeat1,
  [110838] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1147), 1,
      anon_sym_COMMA,
    ACTIONS(5460), 1,
      anon_sym_RBRACK,
    STATE(2670), 1,
      aux_sym_array_repeat1,
  [110851] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4564), 1,
      anon_sym_DOT,
    ACTIONS(5462), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [110862] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5464), 1,
      anon_sym_EQ,
    ACTIONS(5466), 1,
      anon_sym_COMMA,
    ACTIONS(5468), 1,
      anon_sym_from,
  [110875] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5470), 1,
      anon_sym_COMMA,
    ACTIONS(5472), 1,
      anon_sym_RBRACE,
    STATE(2908), 1,
      aux_sym_named_imports_repeat1,
  [110888] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5474), 1,
      sym_identifier,
    ACTIONS(5476), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [110899] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4134), 1,
      anon_sym_RPAREN,
    ACTIONS(5478), 1,
      anon_sym_COMMA,
    STATE(2904), 1,
      aux_sym_formal_parameters_repeat1,
  [110912] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5480), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [110921] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5424), 1,
      anon_sym_COMMA,
    ACTIONS(5482), 1,
      anon_sym_RBRACK,
    STATE(2891), 1,
      aux_sym__tuple_type_body_repeat1,
  [110934] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5484), 1,
      sym_identifier,
    ACTIONS(5486), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [110945] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(5488), 1,
      anon_sym_RBRACE,
    STATE(2837), 1,
      aux_sym_object_repeat1,
  [110958] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(5490), 1,
      anon_sym_RBRACE,
    STATE(2837), 1,
      aux_sym_object_repeat1,
  [110971] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4150), 1,
      anon_sym_RPAREN,
    ACTIONS(5492), 1,
      anon_sym_COMMA,
    STATE(2802), 1,
      aux_sym_formal_parameters_repeat1,
  [110984] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1147), 1,
      anon_sym_COMMA,
    ACTIONS(5494), 1,
      anon_sym_RBRACK,
    STATE(2670), 1,
      aux_sym_array_repeat1,
  [110997] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4150), 1,
      anon_sym_RPAREN,
    ACTIONS(5492), 1,
      anon_sym_COMMA,
    STATE(2904), 1,
      aux_sym_formal_parameters_repeat1,
  [111010] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5496), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [111019] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5414), 1,
      sym_identifier,
    ACTIONS(5498), 1,
      anon_sym_GT,
    STATE(3090), 1,
      sym_type_parameter,
  [111032] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5500), 1,
      anon_sym_COMMA,
    ACTIONS(5503), 1,
      anon_sym_GT,
    STATE(2813), 1,
      aux_sym_type_parameters_repeat1,
  [111045] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1477), 1,
      anon_sym_LBRACE,
    ACTIONS(1475), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [111056] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5424), 1,
      anon_sym_COMMA,
    ACTIONS(5505), 1,
      anon_sym_RBRACK,
    STATE(2829), 1,
      aux_sym__tuple_type_body_repeat1,
  [111069] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1491), 1,
      anon_sym_LBRACE,
    ACTIONS(1489), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [111080] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3514), 1,
      anon_sym_LBRACE,
    ACTIONS(3461), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [111091] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5414), 1,
      sym_identifier,
    ACTIONS(5507), 1,
      anon_sym_GT,
    STATE(3090), 1,
      sym_type_parameter,
  [111104] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2673), 1,
      anon_sym_GT,
    ACTIONS(5509), 1,
      anon_sym_COMMA,
    STATE(2716), 1,
      aux_sym_implements_clause_repeat1,
  [111117] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5414), 1,
      sym_identifier,
    ACTIONS(5511), 1,
      anon_sym_GT,
    STATE(3090), 1,
      sym_type_parameter,
  [111130] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5513), 1,
      anon_sym_LBRACE,
    ACTIONS(5121), 2,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [111141] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5515), 3,
      sym__automatic_semicolon,
      anon_sym_from,
      anon_sym_SEMI,
  [111150] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2580), 1,
      anon_sym_GT,
    ACTIONS(5517), 1,
      anon_sym_COMMA,
    STATE(2716), 1,
      aux_sym_implements_clause_repeat1,
  [111163] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1147), 1,
      anon_sym_COMMA,
    ACTIONS(3534), 1,
      anon_sym_RPAREN,
    STATE(2835), 1,
      aux_sym_array_repeat1,
  [111176] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1147), 1,
      anon_sym_COMMA,
    ACTIONS(3534), 1,
      anon_sym_RPAREN,
    STATE(2670), 1,
      aux_sym_array_repeat1,
  [111189] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5498), 1,
      anon_sym_GT,
    ACTIONS(5519), 1,
      anon_sym_COMMA,
    STATE(2813), 1,
      aux_sym_type_parameters_repeat1,
  [111202] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5521), 1,
      sym_identifier,
    STATE(1814), 1,
      sym_decorator_member_expression,
    STATE(1860), 1,
      sym_decorator_call_expression,
  [111215] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1487), 1,
      anon_sym_LBRACE,
    ACTIONS(1485), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [111226] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5424), 1,
      anon_sym_COMMA,
    ACTIONS(5523), 1,
      anon_sym_RBRACK,
    STATE(2891), 1,
      aux_sym__tuple_type_body_repeat1,
  [111239] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5525), 1,
      anon_sym_LBRACE,
    ACTIONS(5009), 2,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [111250] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5424), 1,
      anon_sym_COMMA,
    ACTIONS(5527), 1,
      anon_sym_RBRACK,
    STATE(2768), 1,
      aux_sym__tuple_type_body_repeat1,
  [111263] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5529), 1,
      anon_sym_COMMA,
    ACTIONS(5532), 1,
      anon_sym_RBRACE,
    STATE(2832), 1,
      aux_sym_export_clause_repeat1,
  [111276] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4238), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [111285] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5534), 1,
      anon_sym_LBRACE,
    ACTIONS(5079), 2,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [111296] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1147), 1,
      anon_sym_COMMA,
    ACTIONS(5536), 1,
      anon_sym_RPAREN,
    STATE(2670), 1,
      aux_sym_array_repeat1,
  [111309] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5538), 3,
      sym__automatic_semicolon,
      anon_sym_from,
      anon_sym_SEMI,
  [111318] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5540), 1,
      anon_sym_COMMA,
    ACTIONS(5543), 1,
      anon_sym_RBRACE,
    STATE(2837), 1,
      aux_sym_object_repeat1,
  [111331] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1147), 1,
      anon_sym_COMMA,
    ACTIONS(5545), 1,
      anon_sym_RBRACK,
    STATE(2670), 1,
      aux_sym_array_repeat1,
  [111344] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4144), 1,
      anon_sym_RPAREN,
    ACTIONS(5547), 1,
      anon_sym_COMMA,
    STATE(2772), 1,
      aux_sym_formal_parameters_repeat1,
  [111357] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4144), 1,
      anon_sym_RPAREN,
    ACTIONS(5547), 1,
      anon_sym_COMMA,
    STATE(2904), 1,
      aux_sym_formal_parameters_repeat1,
  [111370] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(613), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2420), 1,
      anon_sym_LBRACE,
    STATE(2545), 1,
      sym_object_type,
  [111383] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5087), 1,
      anon_sym_COMMA,
    ACTIONS(5089), 1,
      anon_sym_RBRACE,
    STATE(2864), 1,
      aux_sym_enum_body_repeat1,
  [111396] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1147), 1,
      anon_sym_COMMA,
    ACTIONS(5549), 1,
      anon_sym_RPAREN,
    STATE(2670), 1,
      aux_sym_array_repeat1,
  [111409] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(5551), 1,
      anon_sym_RBRACE,
    STATE(2869), 1,
      aux_sym_object_repeat1,
  [111422] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5424), 1,
      anon_sym_COMMA,
    ACTIONS(5553), 1,
      anon_sym_RBRACK,
    STATE(2891), 1,
      aux_sym__tuple_type_body_repeat1,
  [111435] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(5551), 1,
      anon_sym_RBRACE,
    STATE(2837), 1,
      aux_sym_object_repeat1,
  [111448] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5555), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [111457] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5557), 3,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [111466] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5559), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [111475] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(5561), 1,
      anon_sym_RBRACE,
    STATE(2837), 1,
      aux_sym_object_repeat1,
  [111488] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2434), 1,
      anon_sym_DQUOTE,
    ACTIONS(2436), 1,
      anon_sym_SQUOTE,
    STATE(3029), 1,
      sym_string,
  [111501] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1147), 1,
      anon_sym_COMMA,
    ACTIONS(3518), 1,
      anon_sym_RBRACK,
    STATE(2871), 1,
      aux_sym_array_repeat1,
  [111514] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1147), 1,
      anon_sym_COMMA,
    ACTIONS(3518), 1,
      anon_sym_RBRACK,
    STATE(2670), 1,
      aux_sym_array_repeat1,
  [111527] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(5563), 1,
      anon_sym_RBRACE,
    STATE(2837), 1,
      aux_sym_object_repeat1,
  [111540] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1829), 1,
      anon_sym_while,
    ACTIONS(5565), 1,
      anon_sym_else,
    STATE(545), 1,
      sym_else_clause,
  [111553] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1495), 1,
      anon_sym_LBRACE,
    ACTIONS(1493), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [111564] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(5567), 1,
      anon_sym_RBRACE,
    STATE(2837), 1,
      aux_sym_object_repeat1,
  [111577] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5569), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [111586] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(499), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(915), 1,
      anon_sym_LBRACE,
    STATE(603), 1,
      sym_object_type,
  [111599] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(5571), 1,
      anon_sym_RBRACE,
    STATE(2837), 1,
      aux_sym_object_repeat1,
  [111612] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5573), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [111621] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1147), 1,
      anon_sym_COMMA,
    ACTIONS(3520), 1,
      anon_sym_RPAREN,
    STATE(2755), 1,
      aux_sym_array_repeat1,
  [111634] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1147), 1,
      anon_sym_COMMA,
    ACTIONS(3520), 1,
      anon_sym_RPAREN,
    STATE(2670), 1,
      aux_sym_array_repeat1,
  [111647] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4274), 1,
      anon_sym_RBRACE,
    ACTIONS(5575), 1,
      anon_sym_COMMA,
    STATE(2887), 1,
      aux_sym_enum_body_repeat1,
  [111660] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5577), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [111669] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5579), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [111678] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5581), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [111687] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(5583), 1,
      anon_sym_RBRACE,
    STATE(2837), 1,
      aux_sym_object_repeat1,
  [111700] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(5585), 1,
      anon_sym_RBRACE,
    STATE(2837), 1,
      aux_sym_object_repeat1,
  [111713] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(5587), 1,
      anon_sym_RBRACE,
    STATE(2857), 1,
      aux_sym_object_repeat1,
  [111726] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1147), 1,
      anon_sym_COMMA,
    ACTIONS(5589), 1,
      anon_sym_RBRACK,
    STATE(2670), 1,
      aux_sym_array_repeat1,
  [111739] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4286), 1,
      anon_sym_RBRACE,
    ACTIONS(5591), 1,
      anon_sym_COMMA,
    STATE(2887), 1,
      aux_sym_enum_body_repeat1,
  [111752] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(5593), 1,
      anon_sym_RBRACE,
    STATE(2837), 1,
      aux_sym_object_repeat1,
  [111765] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(5587), 1,
      anon_sym_RBRACE,
    STATE(2837), 1,
      aux_sym_object_repeat1,
  [111778] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2713), 1,
      anon_sym_GT,
    ACTIONS(5595), 1,
      anon_sym_COMMA,
    STATE(2716), 1,
      aux_sym_implements_clause_repeat1,
  [111791] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(5597), 1,
      anon_sym_EQ,
    STATE(3193), 1,
      sym_type_parameters,
  [111804] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5424), 1,
      anon_sym_COMMA,
    ACTIONS(5599), 1,
      anon_sym_RBRACK,
    STATE(2888), 1,
      aux_sym__tuple_type_body_repeat1,
  [111817] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5601), 3,
      sym__automatic_semicolon,
      anon_sym_from,
      anon_sym_SEMI,
  [111826] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5603), 1,
      anon_sym_as,
    ACTIONS(5605), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [111837] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5107), 1,
      anon_sym_RBRACE,
    ACTIONS(5607), 1,
      anon_sym_COMMA,
    STATE(2832), 1,
      aux_sym_export_clause_repeat1,
  [111850] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2732), 1,
      anon_sym_GT,
    ACTIONS(5609), 1,
      anon_sym_COMMA,
    STATE(2716), 1,
      aux_sym_implements_clause_repeat1,
  [111863] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5466), 1,
      anon_sym_COMMA,
    ACTIONS(5468), 1,
      anon_sym_from,
    ACTIONS(5611), 1,
      anon_sym_EQ,
  [111876] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3461), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
  [111885] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5613), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [111894] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5615), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [111903] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4130), 1,
      anon_sym_RPAREN,
    ACTIONS(5617), 1,
      anon_sym_COMMA,
    STATE(2904), 1,
      aux_sym_formal_parameters_repeat1,
  [111916] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5133), 1,
      anon_sym_RBRACE,
    ACTIONS(5619), 1,
      anon_sym_COMMA,
    STATE(2887), 1,
      aux_sym_enum_body_repeat1,
  [111929] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5424), 1,
      anon_sym_COMMA,
    ACTIONS(5622), 1,
      anon_sym_RBRACK,
    STATE(2891), 1,
      aux_sym__tuple_type_body_repeat1,
  [111942] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5624), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [111951] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5626), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [111960] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5628), 1,
      anon_sym_COMMA,
    ACTIONS(5631), 1,
      anon_sym_RBRACK,
    STATE(2891), 1,
      aux_sym__tuple_type_body_repeat1,
  [111973] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5633), 1,
      anon_sym_LPAREN,
    ACTIONS(5635), 1,
      anon_sym_await,
    STATE(34), 1,
      sym__for_header,
  [111986] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5637), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [111995] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(5639), 1,
      anon_sym_RBRACE,
    STATE(2837), 1,
      aux_sym_object_repeat1,
  [112008] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5641), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [112017] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5643), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [112026] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5645), 1,
      anon_sym_COMMA,
    ACTIONS(5647), 1,
      anon_sym_RBRACE,
    STATE(2880), 1,
      aux_sym_export_clause_repeat1,
  [112039] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1147), 1,
      anon_sym_COMMA,
    ACTIONS(3510), 1,
      anon_sym_RBRACK,
    STATE(2670), 1,
      aux_sym_array_repeat1,
  [112052] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1147), 1,
      anon_sym_COMMA,
    ACTIONS(3510), 1,
      anon_sym_RBRACK,
    STATE(2838), 1,
      aux_sym_array_repeat1,
  [112065] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5649), 1,
      anon_sym_as,
    ACTIONS(5651), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [112076] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5653), 1,
      anon_sym_COMMA,
    ACTIONS(5655), 1,
      anon_sym_RPAREN,
    STATE(2840), 1,
      aux_sym_formal_parameters_repeat1,
  [112089] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 1,
      anon_sym_LT,
    ACTIONS(5657), 1,
      anon_sym_EQ,
    STATE(3256), 1,
      sym_type_parameters,
  [112102] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5659), 3,
      sym__automatic_semicolon,
      anon_sym_from,
      anon_sym_SEMI,
  [112111] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5661), 1,
      anon_sym_COMMA,
    ACTIONS(5664), 1,
      anon_sym_RPAREN,
    STATE(2904), 1,
      aux_sym_formal_parameters_repeat1,
  [112124] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2641), 1,
      anon_sym_GT,
    ACTIONS(5666), 1,
      anon_sym_COMMA,
    STATE(2716), 1,
      aux_sym_implements_clause_repeat1,
  [112137] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5668), 1,
      anon_sym_COMMA,
    ACTIONS(5670), 1,
      anon_sym_GT,
    STATE(2761), 1,
      aux_sym_type_parameters_repeat1,
  [112150] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3119), 3,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
  [112159] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5095), 1,
      anon_sym_RBRACE,
    ACTIONS(5672), 1,
      anon_sym_COMMA,
    STATE(2920), 1,
      aux_sym_named_imports_repeat1,
  [112172] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5674), 1,
      anon_sym_COMMA,
    ACTIONS(5676), 1,
      anon_sym_RPAREN,
    STATE(2774), 1,
      aux_sym_formal_parameters_repeat1,
  [112185] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4666), 3,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
  [112194] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4654), 3,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
  [112203] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(5678), 1,
      anon_sym_RBRACE,
    STATE(2837), 1,
      aux_sym_object_repeat1,
  [112216] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(5678), 1,
      anon_sym_RBRACE,
    STATE(2850), 1,
      aux_sym_object_repeat1,
  [112229] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5680), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [112238] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5682), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [112247] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1147), 1,
      anon_sym_COMMA,
    ACTIONS(3438), 1,
      anon_sym_RBRACK,
    STATE(2670), 1,
      aux_sym_array_repeat1,
  [112260] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1147), 1,
      anon_sym_COMMA,
    ACTIONS(3438), 1,
      anon_sym_RBRACK,
    STATE(2797), 1,
      aux_sym_array_repeat1,
  [112273] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5684), 1,
      anon_sym_COMMA,
    ACTIONS(5686), 1,
      anon_sym_RPAREN,
    STATE(2810), 1,
      aux_sym_formal_parameters_repeat1,
  [112286] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [112295] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5690), 1,
      anon_sym_COMMA,
    ACTIONS(5693), 1,
      anon_sym_RBRACE,
    STATE(2920), 1,
      aux_sym_named_imports_repeat1,
  [112308] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5424), 1,
      anon_sym_COMMA,
    ACTIONS(5695), 1,
      anon_sym_RBRACK,
    STATE(2932), 1,
      aux_sym__tuple_type_body_repeat1,
  [112321] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4524), 1,
      anon_sym_implements,
    ACTIONS(5697), 1,
      anon_sym_LBRACE,
    STATE(3198), 1,
      sym_implements_clause,
  [112334] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4564), 1,
      anon_sym_DOT,
    ACTIONS(5699), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [112345] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5701), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [112354] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2592), 1,
      anon_sym_GT,
    ACTIONS(5703), 1,
      anon_sym_COMMA,
    STATE(2716), 1,
      aux_sym_implements_clause_repeat1,
  [112367] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(817), 1,
      anon_sym_DQUOTE,
    ACTIONS(819), 1,
      anon_sym_SQUOTE,
    STATE(3187), 1,
      sym_string,
  [112380] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5705), 1,
      anon_sym_COMMA,
    ACTIONS(5707), 1,
      anon_sym_GT,
    STATE(2826), 1,
      aux_sym_type_parameters_repeat1,
  [112393] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5210), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [112402] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1147), 1,
      anon_sym_COMMA,
    ACTIONS(3504), 1,
      anon_sym_RBRACK,
    STATE(2783), 1,
      aux_sym_array_repeat1,
  [112415] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5709), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [112424] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1147), 1,
      anon_sym_COMMA,
    ACTIONS(3504), 1,
      anon_sym_RBRACK,
    STATE(2670), 1,
      aux_sym_array_repeat1,
  [112437] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5424), 1,
      anon_sym_COMMA,
    ACTIONS(5711), 1,
      anon_sym_RBRACK,
    STATE(2891), 1,
      aux_sym__tuple_type_body_repeat1,
  [112450] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(5713), 1,
      anon_sym_RBRACE,
    STATE(2860), 1,
      aux_sym_object_repeat1,
  [112463] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5715), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [112472] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5717), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [112481] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(5713), 1,
      anon_sym_RBRACE,
    STATE(2837), 1,
      aux_sym_object_repeat1,
  [112494] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4202), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [112502] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4584), 1,
      anon_sym_LPAREN,
    STATE(3393), 1,
      sym_formal_parameters,
  [112512] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3512), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [112520] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3522), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [112528] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4476), 1,
      anon_sym_LBRACE,
    STATE(1617), 1,
      sym_class_body,
  [112538] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5719), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [112546] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5721), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [112554] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5723), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [112562] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4983), 1,
      anon_sym_LPAREN,
    STATE(2128), 1,
      sym_formal_parameters,
  [112572] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5725), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [112580] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5727), 1,
      anon_sym_LT,
    STATE(1628), 1,
      sym_type_arguments,
  [112590] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5729), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [112598] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4476), 1,
      anon_sym_LBRACE,
    STATE(1595), 1,
      sym_class_body,
  [112608] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5731), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [112616] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1796), 1,
      anon_sym_LBRACE,
    STATE(537), 1,
      sym_statement_block,
  [112626] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3097), 1,
      anon_sym_LBRACE,
    STATE(1592), 1,
      sym_statement_block,
  [112636] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3097), 1,
      anon_sym_LBRACE,
    STATE(1601), 1,
      sym_statement_block,
  [112646] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5733), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [112654] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1796), 1,
      anon_sym_LBRACE,
    STATE(593), 1,
      sym_statement_block,
  [112664] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5735), 1,
      anon_sym_LPAREN,
    STATE(33), 1,
      sym__for_header,
  [112674] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5737), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [112682] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5739), 1,
      anon_sym_LBRACE,
    STATE(598), 1,
      sym_enum_body,
  [112692] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4969), 1,
      sym_identifier,
    ACTIONS(4971), 1,
      anon_sym_LBRACK,
  [112702] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4512), 1,
      anon_sym_LBRACE,
    STATE(1187), 1,
      sym_class_body,
  [112712] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4793), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
  [112720] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4232), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [112728] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3105), 1,
      anon_sym_LBRACE,
    STATE(1176), 1,
      sym_statement_block,
  [112738] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2802), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [112746] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5741), 1,
      sym_identifier,
    ACTIONS(5743), 1,
      anon_sym_STAR,
  [112756] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4562), 1,
      anon_sym_LBRACE,
    STATE(2620), 1,
      sym_statement_block,
  [112766] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3097), 1,
      anon_sym_LBRACE,
    STATE(1588), 1,
      sym_statement_block,
  [112776] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5745), 1,
      anon_sym_LBRACE,
    STATE(2566), 1,
      sym_enum_body,
  [112786] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1796), 1,
      anon_sym_LBRACE,
    STATE(3024), 1,
      sym_statement_block,
  [112796] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5747), 1,
      anon_sym_LBRACE,
    STATE(606), 1,
      sym_switch_body,
  [112806] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4242), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [112814] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5749), 1,
      sym_identifier,
    ACTIONS(5751), 1,
      anon_sym_STAR,
  [112824] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4927), 1,
      sym_identifier,
    ACTIONS(4929), 1,
      anon_sym_LBRACK,
  [112834] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4476), 1,
      anon_sym_LBRACE,
    STATE(1584), 1,
      sym_class_body,
  [112844] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4256), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [112852] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5753), 1,
      sym_identifier,
    ACTIONS(5755), 1,
      anon_sym_STAR,
  [112862] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1796), 1,
      anon_sym_LBRACE,
    STATE(2985), 1,
      sym_statement_block,
  [112872] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2197), 1,
      anon_sym_LPAREN,
    STATE(1532), 1,
      sym_arguments,
  [112882] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2742), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [112890] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3097), 1,
      anon_sym_LBRACE,
    STATE(1597), 1,
      sym_statement_block,
  [112900] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5757), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [112908] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4584), 1,
      anon_sym_LPAREN,
    STATE(2571), 1,
      sym_formal_parameters,
  [112918] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4250), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [112926] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5759), 1,
      anon_sym_LPAREN,
    STATE(35), 1,
      sym_parenthesized_expression,
  [112936] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4246), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [112944] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5631), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [112952] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5759), 1,
      anon_sym_LPAREN,
    STATE(31), 1,
      sym_parenthesized_expression,
  [112962] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5759), 1,
      anon_sym_LPAREN,
    STATE(44), 1,
      sym_parenthesized_expression,
  [112972] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4528), 1,
      anon_sym_LBRACE,
    STATE(588), 1,
      sym_class_body,
  [112982] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5761), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [112990] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5414), 1,
      sym_identifier,
    STATE(3090), 1,
      sym_type_parameter,
  [113000] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5763), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [113008] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4476), 1,
      anon_sym_LBRACE,
    STATE(1604), 1,
      sym_class_body,
  [113018] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1796), 1,
      anon_sym_LBRACE,
    STATE(2937), 1,
      sym_statement_block,
  [113028] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4222), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [113036] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4584), 1,
      anon_sym_LPAREN,
    STATE(3270), 1,
      sym_formal_parameters,
  [113046] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4584), 1,
      anon_sym_LPAREN,
    STATE(3272), 1,
      sym_formal_parameters,
  [113056] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5281), 1,
      anon_sym_from,
    STATE(2979), 1,
      sym__from_clause,
  [113066] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1796), 1,
      anon_sym_LBRACE,
    STATE(2975), 1,
      sym_statement_block,
  [113076] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1796), 1,
      anon_sym_LBRACE,
    STATE(3096), 1,
      sym_statement_block,
  [113086] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4484), 1,
      anon_sym_LBRACE,
    STATE(1708), 1,
      sym_class_body,
  [113096] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1796), 1,
      anon_sym_LBRACE,
    STATE(3145), 1,
      sym_statement_block,
  [113106] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5765), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [113114] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5133), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [113122] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5281), 1,
      anon_sym_from,
    STATE(3118), 1,
      sym__from_clause,
  [113132] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5767), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [113140] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4512), 1,
      anon_sym_LBRACE,
    STATE(1226), 1,
      sym_class_body,
  [113150] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(937), 1,
      anon_sym_LBRACE,
    STATE(97), 1,
      sym_statement_block,
  [113160] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4528), 1,
      anon_sym_LBRACE,
    STATE(559), 1,
      sym_class_body,
  [113170] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4584), 1,
      anon_sym_LPAREN,
    STATE(3304), 1,
      sym_formal_parameters,
  [113180] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5543), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [113188] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5769), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [113196] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5735), 1,
      anon_sym_LPAREN,
    STATE(39), 1,
      sym__for_header,
  [113206] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4522), 1,
      anon_sym_LBRACE,
    STATE(524), 1,
      sym_class_body,
  [113216] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5771), 1,
      sym_identifier,
    STATE(2923), 1,
      sym_nested_identifier,
  [113226] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4522), 1,
      anon_sym_LBRACE,
    STATE(2430), 1,
      sym_class_body,
  [113236] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4512), 1,
      anon_sym_LBRACE,
    STATE(1150), 1,
      sym_class_body,
  [113246] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5414), 1,
      sym_identifier,
    STATE(2906), 1,
      sym_type_parameter,
  [113256] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3105), 1,
      anon_sym_LBRACE,
    STATE(1149), 1,
      sym_statement_block,
  [113266] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4584), 1,
      anon_sym_LPAREN,
    STATE(3307), 1,
      sym_formal_parameters,
  [113276] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4584), 1,
      anon_sym_LPAREN,
    STATE(3165), 1,
      sym_formal_parameters,
  [113286] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4522), 1,
      anon_sym_LBRACE,
    STATE(2443), 1,
      sym_class_body,
  [113296] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    STATE(1237), 1,
      sym_arguments,
  [113306] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4184), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [113314] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1796), 1,
      anon_sym_LBRACE,
    STATE(2962), 1,
      sym_statement_block,
  [113324] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5773), 1,
      anon_sym_LBRACE,
    STATE(1699), 1,
      sym_statement_block,
  [113334] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4522), 1,
      anon_sym_LBRACE,
    STATE(2449), 1,
      sym_class_body,
  [113344] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4476), 1,
      anon_sym_LBRACE,
    STATE(1368), 1,
      sym_class_body,
  [113354] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5775), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [113362] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4451), 1,
      anon_sym_LT,
    STATE(2152), 1,
      sym_type_arguments,
  [113372] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4584), 1,
      anon_sym_LPAREN,
    STATE(3326), 1,
      sym_formal_parameters,
  [113382] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2542), 1,
      anon_sym_LPAREN,
    STATE(2061), 1,
      sym_formal_parameters,
  [113392] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4476), 1,
      anon_sym_LBRACE,
    STATE(1641), 1,
      sym_class_body,
  [113402] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4749), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
  [113410] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4751), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
  [113418] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5777), 2,
      sym_identifier,
      sym_this,
  [113426] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1796), 1,
      anon_sym_LBRACE,
    STATE(3087), 1,
      sym_statement_block,
  [113436] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4584), 1,
      anon_sym_LPAREN,
    STATE(2389), 1,
      sym_formal_parameters,
  [113446] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4522), 1,
      anon_sym_LBRACE,
    STATE(2457), 1,
      sym_class_body,
  [113456] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4883), 1,
      sym_identifier,
    ACTIONS(4885), 1,
      anon_sym_LBRACK,
  [113466] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5779), 1,
      sym_identifier,
    ACTIONS(5781), 1,
      anon_sym_STAR,
  [113476] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3113), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [113484] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3097), 1,
      anon_sym_LBRACE,
    STATE(1372), 1,
      sym_statement_block,
  [113494] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4534), 1,
      anon_sym_LBRACE,
    STATE(95), 1,
      sym_class_body,
  [113504] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2201), 1,
      anon_sym_LPAREN,
    STATE(1709), 1,
      sym_arguments,
  [113514] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4528), 1,
      anon_sym_LBRACE,
    STATE(584), 1,
      sym_class_body,
  [113524] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4522), 1,
      anon_sym_LBRACE,
    STATE(2552), 1,
      sym_class_body,
  [113534] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4584), 1,
      anon_sym_LPAREN,
    STATE(3190), 1,
      sym_formal_parameters,
  [113544] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4484), 1,
      anon_sym_LBRACE,
    STATE(1690), 1,
      sym_class_body,
  [113554] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1796), 1,
      anon_sym_LBRACE,
    STATE(3071), 1,
      sym_statement_block,
  [113564] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5783), 2,
      sym_identifier,
      sym_this,
  [113572] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3105), 1,
      anon_sym_LBRACE,
    STATE(1227), 1,
      sym_statement_block,
  [113582] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3105), 1,
      anon_sym_LBRACE,
    STATE(1233), 1,
      sym_statement_block,
  [113592] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4584), 1,
      anon_sym_LPAREN,
    STATE(2360), 1,
      sym_formal_parameters,
  [113602] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2197), 1,
      anon_sym_LPAREN,
    STATE(1658), 1,
      sym_arguments,
  [113612] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4522), 1,
      anon_sym_LBRACE,
    STATE(533), 1,
      sym_class_body,
  [113622] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4512), 1,
      anon_sym_LBRACE,
    STATE(1239), 1,
      sym_class_body,
  [113632] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4584), 1,
      anon_sym_LPAREN,
    STATE(3189), 1,
      sym_formal_parameters,
  [113642] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4522), 1,
      anon_sym_LBRACE,
    STATE(2484), 1,
      sym_class_body,
  [113652] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5785), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [113660] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4522), 1,
      anon_sym_LBRACE,
    STATE(2488), 1,
      sym_class_body,
  [113670] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4512), 1,
      anon_sym_LBRACE,
    STATE(1209), 1,
      sym_class_body,
  [113680] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4476), 1,
      anon_sym_LBRACE,
    STATE(1380), 1,
      sym_class_body,
  [113690] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5787), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [113698] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4584), 1,
      anon_sym_LPAREN,
    STATE(2523), 1,
      sym_formal_parameters,
  [113708] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4584), 1,
      anon_sym_LPAREN,
    STATE(3363), 1,
      sym_formal_parameters,
  [113718] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3097), 1,
      anon_sym_LBRACE,
    STATE(1668), 1,
      sym_statement_block,
  [113728] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4562), 1,
      anon_sym_LBRACE,
    STATE(531), 1,
      sym_statement_block,
  [113738] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3097), 1,
      anon_sym_LBRACE,
    STATE(1666), 1,
      sym_statement_block,
  [113748] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3536), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [113756] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4228), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [113764] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4476), 1,
      anon_sym_LBRACE,
    STATE(1661), 1,
      sym_class_body,
  [113774] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2542), 1,
      anon_sym_LPAREN,
    STATE(2236), 1,
      sym_formal_parameters,
  [113784] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1796), 1,
      anon_sym_LBRACE,
    STATE(2995), 1,
      sym_statement_block,
  [113794] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5789), 1,
      sym_identifier,
    STATE(2798), 1,
      sym_nested_identifier,
  [113804] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5414), 1,
      sym_identifier,
    STATE(2927), 1,
      sym_type_parameter,
  [113814] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4377), 1,
      anon_sym_LT,
    STATE(2058), 1,
      sym_type_arguments,
  [113824] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4584), 1,
      anon_sym_LPAREN,
    STATE(3375), 1,
      sym_formal_parameters,
  [113834] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5791), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [113842] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3097), 1,
      anon_sym_LBRACE,
    STATE(1381), 1,
      sym_statement_block,
  [113852] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4562), 1,
      anon_sym_LBRACE,
    STATE(536), 1,
      sym_statement_block,
  [113862] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3105), 1,
      anon_sym_LBRACE,
    STATE(1199), 1,
      sym_statement_block,
  [113872] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4522), 1,
      anon_sym_LBRACE,
    STATE(540), 1,
      sym_class_body,
  [113882] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5745), 1,
      anon_sym_LBRACE,
    STATE(2591), 1,
      sym_enum_body,
  [113892] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4534), 1,
      anon_sym_LBRACE,
    STATE(78), 1,
      sym_class_body,
  [113902] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4522), 1,
      anon_sym_LBRACE,
    STATE(527), 1,
      sym_class_body,
  [113912] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4198), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [113920] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4476), 1,
      anon_sym_LBRACE,
    STATE(1384), 1,
      sym_class_body,
  [113930] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5793), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [113938] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5503), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [113946] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4562), 1,
      anon_sym_LBRACE,
    STATE(2578), 1,
      sym_statement_block,
  [113956] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1796), 1,
      anon_sym_LBRACE,
    STATE(2983), 1,
      sym_statement_block,
  [113966] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5795), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [113974] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5797), 1,
      anon_sym_LT,
    STATE(1057), 1,
      sym_type_arguments,
  [113984] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4484), 1,
      anon_sym_LBRACE,
    STATE(1725), 1,
      sym_class_body,
  [113994] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4194), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [114002] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5799), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [114010] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4562), 1,
      anon_sym_LBRACE,
    STATE(2589), 1,
      sym_statement_block,
  [114020] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5773), 1,
      anon_sym_LBRACE,
    STATE(1732), 1,
      sym_statement_block,
  [114030] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1796), 1,
      anon_sym_LBRACE,
    STATE(2971), 1,
      sym_statement_block,
  [114040] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3097), 1,
      anon_sym_LBRACE,
    STATE(1651), 1,
      sym_statement_block,
  [114050] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4476), 1,
      anon_sym_LBRACE,
    STATE(1634), 1,
      sym_class_body,
  [114060] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5773), 1,
      anon_sym_LBRACE,
    STATE(1735), 1,
      sym_statement_block,
  [114070] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5759), 1,
      anon_sym_LPAREN,
    STATE(41), 1,
      sym_parenthesized_expression,
  [114080] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1796), 1,
      anon_sym_LBRACE,
    STATE(492), 1,
      sym_statement_block,
  [114090] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5281), 1,
      anon_sym_from,
    STATE(2944), 1,
      sym__from_clause,
  [114100] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2201), 1,
      anon_sym_LPAREN,
    STATE(1748), 1,
      sym_arguments,
  [114110] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5759), 1,
      anon_sym_LPAREN,
    STATE(29), 1,
      sym_parenthesized_expression,
  [114120] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5232), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [114128] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5801), 1,
      anon_sym_LT,
    STATE(1505), 1,
      sym_type_arguments,
  [114138] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4534), 1,
      anon_sym_LBRACE,
    STATE(85), 1,
      sym_class_body,
  [114148] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4584), 1,
      anon_sym_LPAREN,
    STATE(3361), 1,
      sym_formal_parameters,
  [114158] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5759), 1,
      anon_sym_LPAREN,
    STATE(2970), 1,
      sym_parenthesized_expression,
  [114168] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3105), 1,
      anon_sym_LBRACE,
    STATE(1207), 1,
      sym_statement_block,
  [114178] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5759), 1,
      anon_sym_LPAREN,
    STATE(45), 1,
      sym_parenthesized_expression,
  [114188] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4512), 1,
      anon_sym_LBRACE,
    STATE(1231), 1,
      sym_class_body,
  [114198] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4476), 1,
      anon_sym_LBRACE,
    STATE(1531), 1,
      sym_class_body,
  [114208] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5803), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [114216] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5805), 2,
      sym_identifier,
      sym_this,
  [114224] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4339), 1,
      anon_sym_LT,
    STATE(275), 1,
      sym_type_arguments,
  [114234] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2161), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [114242] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4584), 1,
      anon_sym_LPAREN,
    STATE(3327), 1,
      sym_formal_parameters,
  [114252] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4522), 1,
      anon_sym_LBRACE,
    STATE(2584), 1,
      sym_class_body,
  [114262] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4484), 1,
      anon_sym_LBRACE,
    STATE(1744), 1,
      sym_class_body,
  [114272] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5807), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [114280] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4512), 1,
      anon_sym_LBRACE,
    STATE(1236), 1,
      sym_class_body,
  [114290] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3097), 1,
      anon_sym_LBRACE,
    STATE(1517), 1,
      sym_statement_block,
  [114300] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2149), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [114308] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1796), 1,
      anon_sym_LBRACE,
    STATE(568), 1,
      sym_statement_block,
  [114318] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4484), 1,
      anon_sym_LBRACE,
    STATE(1729), 1,
      sym_class_body,
  [114328] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5809), 1,
      anon_sym_LPAREN,
    STATE(3003), 1,
      sym_parenthesized_expression,
  [114338] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5773), 1,
      anon_sym_LBRACE,
    STATE(1717), 1,
      sym_statement_block,
  [114348] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1796), 1,
      anon_sym_LBRACE,
    STATE(535), 1,
      sym_statement_block,
  [114358] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2251), 1,
      anon_sym_COLON,
    STATE(2934), 1,
      sym_type_annotation,
  [114368] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(937), 1,
      anon_sym_LBRACE,
    STATE(77), 1,
      sym_statement_block,
  [114378] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5811), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [114386] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1796), 1,
      anon_sym_LBRACE,
    STATE(534), 1,
      sym_statement_block,
  [114396] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [114404] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4534), 1,
      anon_sym_LBRACE,
    STATE(82), 1,
      sym_class_body,
  [114414] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4528), 1,
      anon_sym_LBRACE,
    STATE(596), 1,
      sym_class_body,
  [114424] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4484), 1,
      anon_sym_LBRACE,
    STATE(1706), 1,
      sym_class_body,
  [114434] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4584), 1,
      anon_sym_LPAREN,
    STATE(2609), 1,
      sym_formal_parameters,
  [114444] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5815), 1,
      anon_sym_in,
    ACTIONS(5817), 1,
      anon_sym_COLON,
  [114454] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5773), 1,
      anon_sym_LBRACE,
    STATE(1672), 1,
      sym_statement_block,
  [114464] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4260), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [114472] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4484), 1,
      anon_sym_LBRACE,
    STATE(1684), 1,
      sym_class_body,
  [114482] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5739), 1,
      anon_sym_LBRACE,
    STATE(547), 1,
      sym_enum_body,
  [114492] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2185), 1,
      anon_sym_LPAREN,
    STATE(1230), 1,
      sym_arguments,
  [114502] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5773), 1,
      anon_sym_LBRACE,
    STATE(1686), 1,
      sym_statement_block,
  [114512] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3105), 1,
      anon_sym_LBRACE,
    STATE(1133), 1,
      sym_statement_block,
  [114522] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5773), 1,
      anon_sym_LBRACE,
    STATE(1687), 1,
      sym_statement_block,
  [114532] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3105), 1,
      anon_sym_LBRACE,
    STATE(1210), 1,
      sym_statement_block,
  [114542] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4512), 1,
      anon_sym_LBRACE,
    STATE(1157), 1,
      sym_class_body,
  [114552] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4476), 1,
      anon_sym_LBRACE,
    STATE(1418), 1,
      sym_class_body,
  [114562] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4484), 1,
      anon_sym_LBRACE,
    STATE(1688), 1,
      sym_class_body,
  [114572] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5281), 1,
      anon_sym_from,
    STATE(2964), 1,
      sym__from_clause,
  [114582] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4584), 1,
      anon_sym_LPAREN,
    STATE(3379), 1,
      sym_formal_parameters,
  [114592] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5773), 1,
      anon_sym_LBRACE,
    STATE(1692), 1,
      sym_statement_block,
  [114602] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5819), 1,
      sym_identifier,
  [114609] = 2,
    ACTIONS(5131), 1,
      sym_comment,
    ACTIONS(5821), 1,
      sym_regex_pattern,
  [114616] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5823), 1,
      anon_sym_RBRACK,
  [114623] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5825), 1,
      anon_sym_EQ_GT,
  [114630] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_EQ_GT,
  [114637] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5829), 1,
      anon_sym_EQ_GT,
  [114644] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5831), 1,
      anon_sym_EQ_GT,
  [114651] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4387), 1,
      anon_sym_DOT,
  [114658] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5833), 1,
      anon_sym_RPAREN,
  [114665] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3625), 1,
      anon_sym_RBRACK,
  [114672] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5835), 1,
      anon_sym_EQ_GT,
  [114679] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5837), 1,
      anon_sym_COLON,
  [114686] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5839), 1,
      sym_identifier,
  [114693] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5841), 1,
      anon_sym_EQ_GT,
  [114700] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5843), 1,
      sym_identifier,
  [114707] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5845), 1,
      anon_sym_RPAREN,
  [114714] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5847), 1,
      sym_readonly,
  [114721] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5849), 1,
      anon_sym_from,
  [114728] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3601), 1,
      anon_sym_RBRACK,
  [114735] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5851), 1,
      sym_identifier,
  [114742] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3666), 1,
      anon_sym_RPAREN,
  [114749] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4977), 1,
      anon_sym_EQ_GT,
  [114756] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5853), 1,
      sym_identifier,
  [114763] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3668), 1,
      anon_sym_RPAREN,
  [114770] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3670), 1,
      anon_sym_RPAREN,
  [114777] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3672), 1,
      anon_sym_RPAREN,
  [114784] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5855), 1,
      anon_sym_from,
  [114791] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5857), 1,
      anon_sym_RBRACE,
  [114798] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5859), 1,
      anon_sym_RPAREN,
  [114805] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5861), 1,
      sym_identifier,
  [114812] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5863), 1,
      anon_sym_EQ_GT,
  [114819] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4989), 1,
      anon_sym_EQ_GT,
  [114826] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5865), 1,
      anon_sym_EQ_GT,
  [114833] = 2,
    ACTIONS(5131), 1,
      sym_comment,
    ACTIONS(5867), 1,
      sym_regex_pattern,
  [114840] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5869), 1,
      anon_sym_EQ,
  [114847] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3605), 1,
      anon_sym_RPAREN,
  [114854] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3007), 1,
      anon_sym_DOT,
  [114861] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5871), 1,
      sym_identifier,
  [114868] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3700), 1,
      anon_sym_RBRACK,
  [114875] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5873), 1,
      anon_sym_LBRACE,
  [114882] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5875), 1,
      anon_sym_COLON,
  [114889] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5877), 1,
      sym_identifier,
  [114896] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3593), 1,
      anon_sym_RBRACE,
  [114903] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3591), 1,
      anon_sym_RBRACK,
  [114910] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5879), 1,
      sym_identifier,
  [114917] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5881), 1,
      anon_sym_DOT,
  [114924] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5883), 1,
      sym_identifier,
  [114931] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5885), 1,
      sym_identifier,
  [114938] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5887), 1,
      sym_identifier,
  [114945] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5889), 1,
      sym_identifier,
  [114952] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5891), 1,
      sym_identifier,
  [114959] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5893), 1,
      anon_sym_EQ,
  [114966] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5895), 1,
      sym_identifier,
  [114973] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4453), 1,
      anon_sym_DOT,
  [114980] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5897), 1,
      sym_identifier,
  [114987] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3479), 1,
      anon_sym_DOT,
  [114994] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5899), 1,
      sym_identifier,
  [115001] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5901), 1,
      sym_identifier,
  [115008] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5903), 1,
      anon_sym_EQ,
  [115015] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3550), 1,
      anon_sym_RBRACK,
  [115022] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3676), 1,
      anon_sym_DOT,
  [115029] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5905), 1,
      sym_identifier,
  [115036] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5907), 1,
      sym_identifier,
  [115043] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3599), 1,
      anon_sym_RBRACK,
  [115050] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5909), 1,
      sym_identifier,
  [115057] = 2,
    ACTIONS(5131), 1,
      sym_comment,
    ACTIONS(5911), 1,
      sym_regex_pattern,
  [115064] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5913), 1,
      anon_sym_RBRACK,
  [115071] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5915), 1,
      sym_identifier,
  [115078] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5917), 1,
      anon_sym_RPAREN,
  [115085] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5919), 1,
      sym_identifier,
  [115092] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5921), 1,
      anon_sym_from,
  [115099] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5923), 1,
      sym_identifier,
  [115106] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5925), 1,
      anon_sym_class,
  [115113] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5927), 1,
      sym_identifier,
  [115120] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5929), 1,
      sym_identifier,
  [115127] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3693), 1,
      anon_sym_RBRACK,
  [115134] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5931), 1,
      anon_sym_EQ_GT,
  [115141] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5933), 1,
      anon_sym_EQ,
  [115148] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5935), 1,
      sym_identifier,
  [115155] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5937), 1,
      sym_identifier,
  [115162] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5939), 1,
      sym_identifier,
  [115169] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5941), 1,
      anon_sym_namespace,
  [115176] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5943), 1,
      sym_identifier,
  [115183] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5945), 1,
      sym_identifier,
  [115190] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5947), 1,
      sym_identifier,
  [115197] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5949), 1,
      sym_identifier,
  [115204] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5951), 1,
      anon_sym_EQ_GT,
  [115211] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5953), 1,
      sym_identifier,
  [115218] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5955), 1,
      anon_sym_EQ_GT,
  [115225] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5957), 1,
      anon_sym_EQ_GT,
  [115232] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5959), 1,
      sym_identifier,
  [115239] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5961), 1,
      sym_identifier,
  [115246] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5963), 1,
      sym_identifier,
  [115253] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5965), 1,
      anon_sym_class,
  [115260] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5647), 1,
      anon_sym_RBRACE,
  [115267] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5967), 1,
      anon_sym_EQ,
  [115274] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5969), 1,
      sym_identifier,
  [115281] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5971), 1,
      anon_sym_EQ,
  [115288] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5973), 1,
      sym_identifier,
  [115295] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4927), 1,
      sym_identifier,
  [115302] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5975), 1,
      anon_sym_target,
  [115309] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5977), 1,
      sym_identifier,
  [115316] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5979), 1,
      sym_identifier,
  [115323] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5981), 1,
      sym_identifier,
  [115330] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5983), 1,
      anon_sym_class,
  [115337] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5985), 1,
      anon_sym_EQ_GT,
  [115344] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5987), 1,
      anon_sym_from,
  [115351] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5989), 1,
      anon_sym_EQ_GT,
  [115358] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5991), 1,
      anon_sym_RPAREN,
  [115365] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5993), 1,
      anon_sym_EQ_GT,
  [115372] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5995), 1,
      anon_sym_RPAREN,
  [115379] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5997), 1,
      anon_sym_EQ_GT,
  [115386] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5468), 1,
      anon_sym_from,
  [115393] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5999), 1,
      anon_sym_EQ_GT,
  [115400] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6001), 1,
      anon_sym_SLASH2,
  [115407] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6003), 1,
      sym_identifier,
  [115414] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6005), 1,
      anon_sym_from,
  [115421] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4969), 1,
      sym_identifier,
  [115428] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6007), 1,
      anon_sym_EQ_GT,
  [115435] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6009), 1,
      sym_identifier,
  [115442] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6011), 1,
      sym_number,
  [115449] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6013), 1,
      anon_sym_target,
  [115456] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6015), 1,
      sym_identifier,
  [115463] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6017), 1,
      anon_sym_EQ_GT,
  [115470] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6019), 1,
      anon_sym_require,
  [115477] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6021), 1,
      anon_sym_EQ_GT,
  [115484] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5331), 1,
      anon_sym_EQ_GT,
  [115491] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6023), 1,
      anon_sym_EQ_GT,
  [115498] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4178), 1,
      anon_sym_EQ_GT,
  [115505] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6025), 1,
      anon_sym_EQ_GT,
  [115512] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4706), 1,
      sym_identifier,
  [115519] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5697), 1,
      anon_sym_LBRACE,
  [115526] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3688), 1,
      anon_sym_RPAREN,
  [115533] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6027), 1,
      anon_sym_SLASH2,
  [115540] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3684), 1,
      anon_sym_RPAREN,
  [115547] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3682), 1,
      anon_sym_RPAREN,
  [115554] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3364), 1,
      anon_sym_RPAREN,
  [115561] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5099), 1,
      anon_sym_EQ_GT,
  [115568] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4343), 1,
      anon_sym_DOT,
  [115575] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6029), 1,
      anon_sym_LPAREN,
  [115582] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6031), 1,
      sym_identifier,
  [115589] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6033), 1,
      sym_number,
  [115596] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6035), 1,
      sym_identifier,
  [115603] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3680), 1,
      anon_sym_RPAREN,
  [115610] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6037), 1,
      anon_sym_from,
  [115617] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6039), 1,
      anon_sym_EQ_GT,
  [115624] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3678), 1,
      anon_sym_RPAREN,
  [115631] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3674), 1,
      anon_sym_COLON,
  [115638] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6041), 1,
      anon_sym_EQ_GT,
  [115645] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6043), 1,
      sym_identifier,
  [115652] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6045), 1,
      anon_sym_EQ_GT,
  [115659] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6047), 1,
      anon_sym_while,
  [115666] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6049), 1,
      anon_sym_COLON,
  [115673] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6051), 1,
      sym_identifier,
  [115680] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6053), 1,
      anon_sym_from,
  [115687] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3216), 1,
      anon_sym_RPAREN,
  [115694] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6055), 1,
      sym_identifier,
  [115701] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6057), 1,
      anon_sym_EQ_GT,
  [115708] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6059), 1,
      sym_identifier,
  [115715] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6061), 1,
      sym_number,
  [115722] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6063), 1,
      sym_identifier,
  [115729] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3350), 1,
      anon_sym_RPAREN,
  [115736] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6065), 1,
      sym_number,
  [115743] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6067), 1,
      sym_identifier,
  [115750] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6069), 1,
      sym_identifier,
  [115757] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5097), 1,
      anon_sym_EQ_GT,
  [115764] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6071), 1,
      anon_sym_SLASH2,
  [115771] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6073), 1,
      anon_sym_EQ_GT,
  [115778] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6075), 1,
      anon_sym_EQ_GT,
  [115785] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6077), 1,
      sym_identifier,
  [115792] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6079), 1,
      anon_sym_as,
  [115799] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6081), 1,
      sym_identifier,
  [115806] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4905), 1,
      sym_identifier,
  [115813] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6083), 1,
      anon_sym_EQ_GT,
  [115820] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6085), 1,
      anon_sym_EQ_GT,
  [115827] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6087), 1,
      anon_sym_target,
  [115834] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4883), 1,
      sym_identifier,
  [115841] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6089), 1,
      anon_sym_EQ_GT,
  [115848] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6091), 1,
      anon_sym_RPAREN,
  [115855] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6093), 1,
      sym_identifier,
  [115862] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6095), 1,
      anon_sym_RBRACK,
  [115869] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6097), 1,
      anon_sym_EQ_GT,
  [115876] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6099), 1,
      anon_sym_function,
  [115883] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6101), 1,
      sym_identifier,
  [115890] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4851), 1,
      sym_identifier,
  [115897] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6103), 1,
      sym_identifier,
  [115904] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6105), 1,
      sym_identifier,
  [115911] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3623), 1,
      anon_sym_RBRACK,
  [115918] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6107), 1,
      anon_sym_EQ_GT,
  [115925] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6109), 1,
      anon_sym_EQ_GT,
  [115932] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6111), 1,
      anon_sym_namespace,
  [115939] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6113), 1,
      anon_sym_EQ_GT,
  [115946] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6115), 1,
      anon_sym_EQ_GT,
  [115953] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6117), 1,
      anon_sym_EQ_GT,
  [115960] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6119), 1,
      sym_identifier,
  [115967] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6121), 1,
      sym_identifier,
  [115974] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6123), 1,
      sym_number,
  [115981] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6125), 1,
      anon_sym_LBRACK,
  [115988] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6127), 1,
      sym_identifier,
  [115995] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3286), 1,
      anon_sym_RPAREN,
  [116002] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6129), 1,
      anon_sym_EQ_GT,
  [116009] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6131), 1,
      anon_sym_RPAREN,
  [116016] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5101), 1,
      anon_sym_EQ_GT,
  [116023] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6133), 1,
      sym_identifier,
  [116030] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6135), 1,
      anon_sym_EQ_GT,
  [116037] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6137), 1,
      sym_identifier,
  [116044] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6139), 1,
      sym_identifier,
  [116051] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6141), 1,
      anon_sym_function,
  [116058] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6143), 1,
      ts_builtin_sym_end,
  [116065] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6145), 1,
      sym_identifier,
  [116072] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6147), 1,
      sym_identifier,
  [116079] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6149), 1,
      anon_sym_class,
  [116086] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6151), 1,
      sym_identifier,
  [116093] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5117), 1,
      anon_sym_EQ_GT,
  [116100] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6153), 1,
      sym_identifier,
  [116107] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6155), 1,
      sym_identifier,
  [116114] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6157), 1,
      anon_sym_EQ_GT,
  [116121] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6159), 1,
      sym_identifier,
  [116128] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6161), 1,
      anon_sym_EQ_GT,
  [116135] = 2,
    ACTIONS(5131), 1,
      sym_comment,
    ACTIONS(6163), 1,
      sym_regex_pattern,
  [116142] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5119), 1,
      anon_sym_EQ_GT,
  [116149] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6165), 1,
      anon_sym_RPAREN,
  [116156] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6167), 1,
      sym_identifier,
  [116163] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6169), 1,
      sym_identifier,
  [116170] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3619), 1,
      anon_sym_RBRACK,
  [116177] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6171), 1,
      anon_sym_SLASH2,
  [116184] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6173), 1,
      anon_sym_EQ_GT,
  [116191] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6175), 1,
      sym_identifier,
  [116198] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6177), 1,
      sym_number,
  [116205] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6179), 1,
      sym_identifier,
  [116212] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3269), 1,
      anon_sym_RPAREN,
  [116219] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3617), 1,
      anon_sym_RBRACK,
  [116226] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3603), 1,
      anon_sym_RBRACK,
  [116233] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6181), 1,
      anon_sym_COLON,
  [116240] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5081), 1,
      anon_sym_EQ_GT,
  [116247] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6183), 1,
      anon_sym_COLON,
  [116254] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3607), 1,
      anon_sym_RBRACK,
};

static uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(644)] = 0,
  [SMALL_STATE(645)] = 95,
  [SMALL_STATE(646)] = 198,
  [SMALL_STATE(647)] = 301,
  [SMALL_STATE(648)] = 397,
  [SMALL_STATE(649)] = 493,
  [SMALL_STATE(650)] = 595,
  [SMALL_STATE(651)] = 691,
  [SMALL_STATE(652)] = 785,
  [SMALL_STATE(653)] = 887,
  [SMALL_STATE(654)] = 985,
  [SMALL_STATE(655)] = 1081,
  [SMALL_STATE(656)] = 1174,
  [SMALL_STATE(657)] = 1271,
  [SMALL_STATE(658)] = 1366,
  [SMALL_STATE(659)] = 1465,
  [SMALL_STATE(660)] = 1558,
  [SMALL_STATE(661)] = 1652,
  [SMALL_STATE(662)] = 1738,
  [SMALL_STATE(663)] = 1830,
  [SMALL_STATE(664)] = 1924,
  [SMALL_STATE(665)] = 2016,
  [SMALL_STATE(666)] = 2142,
  [SMALL_STATE(667)] = 2209,
  [SMALL_STATE(668)] = 2304,
  [SMALL_STATE(669)] = 2391,
  [SMALL_STATE(670)] = 2458,
  [SMALL_STATE(671)] = 2551,
  [SMALL_STATE(672)] = 2638,
  [SMALL_STATE(673)] = 2729,
  [SMALL_STATE(674)] = 2796,
  [SMALL_STATE(675)] = 2863,
  [SMALL_STATE(676)] = 2954,
  [SMALL_STATE(677)] = 3021,
  [SMALL_STATE(678)] = 3088,
  [SMALL_STATE(679)] = 3155,
  [SMALL_STATE(680)] = 3222,
  [SMALL_STATE(681)] = 3311,
  [SMALL_STATE(682)] = 3398,
  [SMALL_STATE(683)] = 3465,
  [SMALL_STATE(684)] = 3560,
  [SMALL_STATE(685)] = 3649,
  [SMALL_STATE(686)] = 3724,
  [SMALL_STATE(687)] = 3811,
  [SMALL_STATE(688)] = 3902,
  [SMALL_STATE(689)] = 3977,
  [SMALL_STATE(690)] = 4065,
  [SMALL_STATE(691)] = 4149,
  [SMALL_STATE(692)] = 4275,
  [SMALL_STATE(693)] = 4363,
  [SMALL_STATE(694)] = 4489,
  [SMALL_STATE(695)] = 4575,
  [SMALL_STATE(696)] = 4663,
  [SMALL_STATE(697)] = 4751,
  [SMALL_STATE(698)] = 4837,
  [SMALL_STATE(699)] = 4963,
  [SMALL_STATE(700)] = 5051,
  [SMALL_STATE(701)] = 5139,
  [SMALL_STATE(702)] = 5227,
  [SMALL_STATE(703)] = 5311,
  [SMALL_STATE(704)] = 5397,
  [SMALL_STATE(705)] = 5523,
  [SMALL_STATE(706)] = 5649,
  [SMALL_STATE(707)] = 5775,
  [SMALL_STATE(708)] = 5860,
  [SMALL_STATE(709)] = 5991,
  [SMALL_STATE(710)] = 6076,
  [SMALL_STATE(711)] = 6207,
  [SMALL_STATE(712)] = 6330,
  [SMALL_STATE(713)] = 6453,
  [SMALL_STATE(714)] = 6576,
  [SMALL_STATE(715)] = 6699,
  [SMALL_STATE(716)] = 6772,
  [SMALL_STATE(717)] = 6845,
  [SMALL_STATE(718)] = 6968,
  [SMALL_STATE(719)] = 7049,
  [SMALL_STATE(720)] = 7172,
  [SMALL_STATE(721)] = 7253,
  [SMALL_STATE(722)] = 7384,
  [SMALL_STATE(723)] = 7507,
  [SMALL_STATE(724)] = 7598,
  [SMALL_STATE(725)] = 7721,
  [SMALL_STATE(726)] = 7844,
  [SMALL_STATE(727)] = 7931,
  [SMALL_STATE(728)] = 8054,
  [SMALL_STATE(729)] = 8139,
  [SMALL_STATE(730)] = 8224,
  [SMALL_STATE(731)] = 8347,
  [SMALL_STATE(732)] = 8432,
  [SMALL_STATE(733)] = 8517,
  [SMALL_STATE(734)] = 8602,
  [SMALL_STATE(735)] = 8733,
  [SMALL_STATE(736)] = 8856,
  [SMALL_STATE(737)] = 8979,
  [SMALL_STATE(738)] = 9102,
  [SMALL_STATE(739)] = 9225,
  [SMALL_STATE(740)] = 9302,
  [SMALL_STATE(741)] = 9425,
  [SMALL_STATE(742)] = 9556,
  [SMALL_STATE(743)] = 9687,
  [SMALL_STATE(744)] = 9772,
  [SMALL_STATE(745)] = 9855,
  [SMALL_STATE(746)] = 9978,
  [SMALL_STATE(747)] = 10065,
  [SMALL_STATE(748)] = 10188,
  [SMALL_STATE(749)] = 10319,
  [SMALL_STATE(750)] = 10442,
  [SMALL_STATE(751)] = 10565,
  [SMALL_STATE(752)] = 10648,
  [SMALL_STATE(753)] = 10771,
  [SMALL_STATE(754)] = 10856,
  [SMALL_STATE(755)] = 10941,
  [SMALL_STATE(756)] = 11064,
  [SMALL_STATE(757)] = 11187,
  [SMALL_STATE(758)] = 11310,
  [SMALL_STATE(759)] = 11399,
  [SMALL_STATE(760)] = 11476,
  [SMALL_STATE(761)] = 11599,
  [SMALL_STATE(762)] = 11722,
  [SMALL_STATE(763)] = 11807,
  [SMALL_STATE(764)] = 11930,
  [SMALL_STATE(765)] = 12017,
  [SMALL_STATE(766)] = 12137,
  [SMALL_STATE(767)] = 12257,
  [SMALL_STATE(768)] = 12321,
  [SMALL_STATE(769)] = 12399,
  [SMALL_STATE(770)] = 12519,
  [SMALL_STATE(771)] = 12583,
  [SMALL_STATE(772)] = 12703,
  [SMALL_STATE(773)] = 12781,
  [SMALL_STATE(774)] = 12859,
  [SMALL_STATE(775)] = 12979,
  [SMALL_STATE(776)] = 13099,
  [SMALL_STATE(777)] = 13163,
  [SMALL_STATE(778)] = 13283,
  [SMALL_STATE(779)] = 13365,
  [SMALL_STATE(780)] = 13485,
  [SMALL_STATE(781)] = 13605,
  [SMALL_STATE(782)] = 13725,
  [SMALL_STATE(783)] = 13845,
  [SMALL_STATE(784)] = 13965,
  [SMALL_STATE(785)] = 14085,
  [SMALL_STATE(786)] = 14205,
  [SMALL_STATE(787)] = 14325,
  [SMALL_STATE(788)] = 14445,
  [SMALL_STATE(789)] = 14565,
  [SMALL_STATE(790)] = 14685,
  [SMALL_STATE(791)] = 14805,
  [SMALL_STATE(792)] = 14925,
  [SMALL_STATE(793)] = 15045,
  [SMALL_STATE(794)] = 15165,
  [SMALL_STATE(795)] = 15285,
  [SMALL_STATE(796)] = 15405,
  [SMALL_STATE(797)] = 15525,
  [SMALL_STATE(798)] = 15645,
  [SMALL_STATE(799)] = 15765,
  [SMALL_STATE(800)] = 15885,
  [SMALL_STATE(801)] = 16005,
  [SMALL_STATE(802)] = 16125,
  [SMALL_STATE(803)] = 16245,
  [SMALL_STATE(804)] = 16365,
  [SMALL_STATE(805)] = 16449,
  [SMALL_STATE(806)] = 16569,
  [SMALL_STATE(807)] = 16649,
  [SMALL_STATE(808)] = 16769,
  [SMALL_STATE(809)] = 16889,
  [SMALL_STATE(810)] = 17009,
  [SMALL_STATE(811)] = 17129,
  [SMALL_STATE(812)] = 17249,
  [SMALL_STATE(813)] = 17369,
  [SMALL_STATE(814)] = 17489,
  [SMALL_STATE(815)] = 17609,
  [SMALL_STATE(816)] = 17729,
  [SMALL_STATE(817)] = 17849,
  [SMALL_STATE(818)] = 17929,
  [SMALL_STATE(819)] = 18049,
  [SMALL_STATE(820)] = 18169,
  [SMALL_STATE(821)] = 18245,
  [SMALL_STATE(822)] = 18365,
  [SMALL_STATE(823)] = 18429,
  [SMALL_STATE(824)] = 18501,
  [SMALL_STATE(825)] = 18621,
  [SMALL_STATE(826)] = 18741,
  [SMALL_STATE(827)] = 18825,
  [SMALL_STATE(828)] = 18945,
  [SMALL_STATE(829)] = 19065,
  [SMALL_STATE(830)] = 19143,
  [SMALL_STATE(831)] = 19263,
  [SMALL_STATE(832)] = 19383,
  [SMALL_STATE(833)] = 19503,
  [SMALL_STATE(834)] = 19623,
  [SMALL_STATE(835)] = 19743,
  [SMALL_STATE(836)] = 19863,
  [SMALL_STATE(837)] = 19983,
  [SMALL_STATE(838)] = 20103,
  [SMALL_STATE(839)] = 20167,
  [SMALL_STATE(840)] = 20287,
  [SMALL_STATE(841)] = 20407,
  [SMALL_STATE(842)] = 20527,
  [SMALL_STATE(843)] = 20647,
  [SMALL_STATE(844)] = 20767,
  [SMALL_STATE(845)] = 20849,
  [SMALL_STATE(846)] = 20969,
  [SMALL_STATE(847)] = 21089,
  [SMALL_STATE(848)] = 21209,
  [SMALL_STATE(849)] = 21329,
  [SMALL_STATE(850)] = 21449,
  [SMALL_STATE(851)] = 21569,
  [SMALL_STATE(852)] = 21641,
  [SMALL_STATE(853)] = 21761,
  [SMALL_STATE(854)] = 21881,
  [SMALL_STATE(855)] = 21965,
  [SMALL_STATE(856)] = 22029,
  [SMALL_STATE(857)] = 22149,
  [SMALL_STATE(858)] = 22213,
  [SMALL_STATE(859)] = 22293,
  [SMALL_STATE(860)] = 22373,
  [SMALL_STATE(861)] = 22441,
  [SMALL_STATE(862)] = 22517,
  [SMALL_STATE(863)] = 22637,
  [SMALL_STATE(864)] = 22757,
  [SMALL_STATE(865)] = 22877,
  [SMALL_STATE(866)] = 22997,
  [SMALL_STATE(867)] = 23117,
  [SMALL_STATE(868)] = 23197,
  [SMALL_STATE(869)] = 23317,
  [SMALL_STATE(870)] = 23437,
  [SMALL_STATE(871)] = 23557,
  [SMALL_STATE(872)] = 23677,
  [SMALL_STATE(873)] = 23797,
  [SMALL_STATE(874)] = 23917,
  [SMALL_STATE(875)] = 24037,
  [SMALL_STATE(876)] = 24157,
  [SMALL_STATE(877)] = 24277,
  [SMALL_STATE(878)] = 24397,
  [SMALL_STATE(879)] = 24517,
  [SMALL_STATE(880)] = 24637,
  [SMALL_STATE(881)] = 24757,
  [SMALL_STATE(882)] = 24877,
  [SMALL_STATE(883)] = 24997,
  [SMALL_STATE(884)] = 25117,
  [SMALL_STATE(885)] = 25191,
  [SMALL_STATE(886)] = 25311,
  [SMALL_STATE(887)] = 25431,
  [SMALL_STATE(888)] = 25495,
  [SMALL_STATE(889)] = 25615,
  [SMALL_STATE(890)] = 25735,
  [SMALL_STATE(891)] = 25819,
  [SMALL_STATE(892)] = 25939,
  [SMALL_STATE(893)] = 26059,
  [SMALL_STATE(894)] = 26179,
  [SMALL_STATE(895)] = 26299,
  [SMALL_STATE(896)] = 26419,
  [SMALL_STATE(897)] = 26539,
  [SMALL_STATE(898)] = 26659,
  [SMALL_STATE(899)] = 26779,
  [SMALL_STATE(900)] = 26899,
  [SMALL_STATE(901)] = 27019,
  [SMALL_STATE(902)] = 27139,
  [SMALL_STATE(903)] = 27217,
  [SMALL_STATE(904)] = 27337,
  [SMALL_STATE(905)] = 27457,
  [SMALL_STATE(906)] = 27577,
  [SMALL_STATE(907)] = 27697,
  [SMALL_STATE(908)] = 27783,
  [SMALL_STATE(909)] = 27903,
  [SMALL_STATE(910)] = 28023,
  [SMALL_STATE(911)] = 28087,
  [SMALL_STATE(912)] = 28207,
  [SMALL_STATE(913)] = 28327,
  [SMALL_STATE(914)] = 28447,
  [SMALL_STATE(915)] = 28531,
  [SMALL_STATE(916)] = 28651,
  [SMALL_STATE(917)] = 28729,
  [SMALL_STATE(918)] = 28811,
  [SMALL_STATE(919)] = 28931,
  [SMALL_STATE(920)] = 29013,
  [SMALL_STATE(921)] = 29133,
  [SMALL_STATE(922)] = 29253,
  [SMALL_STATE(923)] = 29373,
  [SMALL_STATE(924)] = 29493,
  [SMALL_STATE(925)] = 29613,
  [SMALL_STATE(926)] = 29733,
  [SMALL_STATE(927)] = 29804,
  [SMALL_STATE(928)] = 29885,
  [SMALL_STATE(929)] = 29956,
  [SMALL_STATE(930)] = 30035,
  [SMALL_STATE(931)] = 30106,
  [SMALL_STATE(932)] = 30183,
  [SMALL_STATE(933)] = 30254,
  [SMALL_STATE(934)] = 30327,
  [SMALL_STATE(935)] = 30402,
  [SMALL_STATE(936)] = 30477,
  [SMALL_STATE(937)] = 30544,
  [SMALL_STATE(938)] = 30615,
  [SMALL_STATE(939)] = 30694,
  [SMALL_STATE(940)] = 30773,
  [SMALL_STATE(941)] = 30844,
  [SMALL_STATE(942)] = 30925,
  [SMALL_STATE(943)] = 31006,
  [SMALL_STATE(944)] = 31083,
  [SMALL_STATE(945)] = 31158,
  [SMALL_STATE(946)] = 31233,
  [SMALL_STATE(947)] = 31304,
  [SMALL_STATE(948)] = 31375,
  [SMALL_STATE(949)] = 31446,
  [SMALL_STATE(950)] = 31508,
  [SMALL_STATE(951)] = 31582,
  [SMALL_STATE(952)] = 31702,
  [SMALL_STATE(953)] = 31768,
  [SMALL_STATE(954)] = 31842,
  [SMALL_STATE(955)] = 31916,
  [SMALL_STATE(956)] = 31992,
  [SMALL_STATE(957)] = 32070,
  [SMALL_STATE(958)] = 32144,
  [SMALL_STATE(959)] = 32206,
  [SMALL_STATE(960)] = 32284,
  [SMALL_STATE(961)] = 32360,
  [SMALL_STATE(962)] = 32428,
  [SMALL_STATE(963)] = 32496,
  [SMALL_STATE(964)] = 32568,
  [SMALL_STATE(965)] = 32630,
  [SMALL_STATE(966)] = 32702,
  [SMALL_STATE(967)] = 32764,
  [SMALL_STATE(968)] = 32826,
  [SMALL_STATE(969)] = 32946,
  [SMALL_STATE(970)] = 33010,
  [SMALL_STATE(971)] = 33072,
  [SMALL_STATE(972)] = 33134,
  [SMALL_STATE(973)] = 33196,
  [SMALL_STATE(974)] = 33258,
  [SMALL_STATE(975)] = 33320,
  [SMALL_STATE(976)] = 33386,
  [SMALL_STATE(977)] = 33448,
  [SMALL_STATE(978)] = 33513,
  [SMALL_STATE(979)] = 33584,
  [SMALL_STATE(980)] = 33661,
  [SMALL_STATE(981)] = 33738,
  [SMALL_STATE(982)] = 33815,
  [SMALL_STATE(983)] = 33892,
  [SMALL_STATE(984)] = 33963,
  [SMALL_STATE(985)] = 34028,
  [SMALL_STATE(986)] = 34102,
  [SMALL_STATE(987)] = 34170,
  [SMALL_STATE(988)] = 34244,
  [SMALL_STATE(989)] = 34312,
  [SMALL_STATE(990)] = 34387,
  [SMALL_STATE(991)] = 34493,
  [SMALL_STATE(992)] = 34599,
  [SMALL_STATE(993)] = 34709,
  [SMALL_STATE(994)] = 34819,
  [SMALL_STATE(995)] = 34929,
  [SMALL_STATE(996)] = 35035,
  [SMALL_STATE(997)] = 35141,
  [SMALL_STATE(998)] = 35251,
  [SMALL_STATE(999)] = 35357,
  [SMALL_STATE(1000)] = 35463,
  [SMALL_STATE(1001)] = 35570,
  [SMALL_STATE(1002)] = 35679,
  [SMALL_STATE(1003)] = 35781,
  [SMALL_STATE(1004)] = 35883,
  [SMALL_STATE(1005)] = 35985,
  [SMALL_STATE(1006)] = 36087,
  [SMALL_STATE(1007)] = 36189,
  [SMALL_STATE(1008)] = 36291,
  [SMALL_STATE(1009)] = 36393,
  [SMALL_STATE(1010)] = 36495,
  [SMALL_STATE(1011)] = 36597,
  [SMALL_STATE(1012)] = 36699,
  [SMALL_STATE(1013)] = 36801,
  [SMALL_STATE(1014)] = 36903,
  [SMALL_STATE(1015)] = 37005,
  [SMALL_STATE(1016)] = 37107,
  [SMALL_STATE(1017)] = 37209,
  [SMALL_STATE(1018)] = 37311,
  [SMALL_STATE(1019)] = 37413,
  [SMALL_STATE(1020)] = 37515,
  [SMALL_STATE(1021)] = 37578,
  [SMALL_STATE(1022)] = 37631,
  [SMALL_STATE(1023)] = 37684,
  [SMALL_STATE(1024)] = 37753,
  [SMALL_STATE(1025)] = 37822,
  [SMALL_STATE(1026)] = 37879,
  [SMALL_STATE(1027)] = 37931,
  [SMALL_STATE(1028)] = 37987,
  [SMALL_STATE(1029)] = 38043,
  [SMALL_STATE(1030)] = 38095,
  [SMALL_STATE(1031)] = 38147,
  [SMALL_STATE(1032)] = 38199,
  [SMALL_STATE(1033)] = 38297,
  [SMALL_STATE(1034)] = 38351,
  [SMALL_STATE(1035)] = 38449,
  [SMALL_STATE(1036)] = 38547,
  [SMALL_STATE(1037)] = 38645,
  [SMALL_STATE(1038)] = 38743,
  [SMALL_STATE(1039)] = 38841,
  [SMALL_STATE(1040)] = 38907,
  [SMALL_STATE(1041)] = 38963,
  [SMALL_STATE(1042)] = 39021,
  [SMALL_STATE(1043)] = 39073,
  [SMALL_STATE(1044)] = 39171,
  [SMALL_STATE(1045)] = 39223,
  [SMALL_STATE(1046)] = 39275,
  [SMALL_STATE(1047)] = 39327,
  [SMALL_STATE(1048)] = 39383,
  [SMALL_STATE(1049)] = 39439,
  [SMALL_STATE(1050)] = 39497,
  [SMALL_STATE(1051)] = 39592,
  [SMALL_STATE(1052)] = 39663,
  [SMALL_STATE(1053)] = 39720,
  [SMALL_STATE(1054)] = 39771,
  [SMALL_STATE(1055)] = 39824,
  [SMALL_STATE(1056)] = 39897,
  [SMALL_STATE(1057)] = 39948,
  [SMALL_STATE(1058)] = 39999,
  [SMALL_STATE(1059)] = 40050,
  [SMALL_STATE(1060)] = 40145,
  [SMALL_STATE(1061)] = 40196,
  [SMALL_STATE(1062)] = 40247,
  [SMALL_STATE(1063)] = 40342,
  [SMALL_STATE(1064)] = 40393,
  [SMALL_STATE(1065)] = 40444,
  [SMALL_STATE(1066)] = 40495,
  [SMALL_STATE(1067)] = 40546,
  [SMALL_STATE(1068)] = 40597,
  [SMALL_STATE(1069)] = 40648,
  [SMALL_STATE(1070)] = 40703,
  [SMALL_STATE(1071)] = 40754,
  [SMALL_STATE(1072)] = 40805,
  [SMALL_STATE(1073)] = 40858,
  [SMALL_STATE(1074)] = 40913,
  [SMALL_STATE(1075)] = 40964,
  [SMALL_STATE(1076)] = 41015,
  [SMALL_STATE(1077)] = 41072,
  [SMALL_STATE(1078)] = 41125,
  [SMALL_STATE(1079)] = 41176,
  [SMALL_STATE(1080)] = 41229,
  [SMALL_STATE(1081)] = 41280,
  [SMALL_STATE(1082)] = 41335,
  [SMALL_STATE(1083)] = 41386,
  [SMALL_STATE(1084)] = 41443,
  [SMALL_STATE(1085)] = 41496,
  [SMALL_STATE(1086)] = 41549,
  [SMALL_STATE(1087)] = 41604,
  [SMALL_STATE(1088)] = 41655,
  [SMALL_STATE(1089)] = 41706,
  [SMALL_STATE(1090)] = 41757,
  [SMALL_STATE(1091)] = 41852,
  [SMALL_STATE(1092)] = 41907,
  [SMALL_STATE(1093)] = 41964,
  [SMALL_STATE(1094)] = 42059,
  [SMALL_STATE(1095)] = 42156,
  [SMALL_STATE(1096)] = 42207,
  [SMALL_STATE(1097)] = 42286,
  [SMALL_STATE(1098)] = 42337,
  [SMALL_STATE(1099)] = 42388,
  [SMALL_STATE(1100)] = 42439,
  [SMALL_STATE(1101)] = 42500,
  [SMALL_STATE(1102)] = 42553,
  [SMALL_STATE(1103)] = 42604,
  [SMALL_STATE(1104)] = 42657,
  [SMALL_STATE(1105)] = 42752,
  [SMALL_STATE(1106)] = 42823,
  [SMALL_STATE(1107)] = 42894,
  [SMALL_STATE(1108)] = 42989,
  [SMALL_STATE(1109)] = 43084,
  [SMALL_STATE(1110)] = 43135,
  [SMALL_STATE(1111)] = 43186,
  [SMALL_STATE(1112)] = 43237,
  [SMALL_STATE(1113)] = 43288,
  [SMALL_STATE(1114)] = 43359,
  [SMALL_STATE(1115)] = 43430,
  [SMALL_STATE(1116)] = 43493,
  [SMALL_STATE(1117)] = 43588,
  [SMALL_STATE(1118)] = 43651,
  [SMALL_STATE(1119)] = 43746,
  [SMALL_STATE(1120)] = 43797,
  [SMALL_STATE(1121)] = 43892,
  [SMALL_STATE(1122)] = 43975,
  [SMALL_STATE(1123)] = 44044,
  [SMALL_STATE(1124)] = 44139,
  [SMALL_STATE(1125)] = 44226,
  [SMALL_STATE(1126)] = 44321,
  [SMALL_STATE(1127)] = 44416,
  [SMALL_STATE(1128)] = 44467,
  [SMALL_STATE(1129)] = 44544,
  [SMALL_STATE(1130)] = 44601,
  [SMALL_STATE(1131)] = 44696,
  [SMALL_STATE(1132)] = 44751,
  [SMALL_STATE(1133)] = 44842,
  [SMALL_STATE(1134)] = 44892,
  [SMALL_STATE(1135)] = 44986,
  [SMALL_STATE(1136)] = 45036,
  [SMALL_STATE(1137)] = 45086,
  [SMALL_STATE(1138)] = 45186,
  [SMALL_STATE(1139)] = 45284,
  [SMALL_STATE(1140)] = 45334,
  [SMALL_STATE(1141)] = 45384,
  [SMALL_STATE(1142)] = 45482,
  [SMALL_STATE(1143)] = 45532,
  [SMALL_STATE(1144)] = 45582,
  [SMALL_STATE(1145)] = 45680,
  [SMALL_STATE(1146)] = 45730,
  [SMALL_STATE(1147)] = 45784,
  [SMALL_STATE(1148)] = 45834,
  [SMALL_STATE(1149)] = 45904,
  [SMALL_STATE(1150)] = 45954,
  [SMALL_STATE(1151)] = 46004,
  [SMALL_STATE(1152)] = 46054,
  [SMALL_STATE(1153)] = 46152,
  [SMALL_STATE(1154)] = 46202,
  [SMALL_STATE(1155)] = 46252,
  [SMALL_STATE(1156)] = 46346,
  [SMALL_STATE(1157)] = 46396,
  [SMALL_STATE(1158)] = 46446,
  [SMALL_STATE(1159)] = 46540,
  [SMALL_STATE(1160)] = 46634,
  [SMALL_STATE(1161)] = 46684,
  [SMALL_STATE(1162)] = 46778,
  [SMALL_STATE(1163)] = 46878,
  [SMALL_STATE(1164)] = 46972,
  [SMALL_STATE(1165)] = 47022,
  [SMALL_STATE(1166)] = 47112,
  [SMALL_STATE(1167)] = 47182,
  [SMALL_STATE(1168)] = 47258,
  [SMALL_STATE(1169)] = 47344,
  [SMALL_STATE(1170)] = 47426,
  [SMALL_STATE(1171)] = 47476,
  [SMALL_STATE(1172)] = 47526,
  [SMALL_STATE(1173)] = 47576,
  [SMALL_STATE(1174)] = 47676,
  [SMALL_STATE(1175)] = 47726,
  [SMALL_STATE(1176)] = 47776,
  [SMALL_STATE(1177)] = 47826,
  [SMALL_STATE(1178)] = 47904,
  [SMALL_STATE(1179)] = 47998,
  [SMALL_STATE(1180)] = 48058,
  [SMALL_STATE(1181)] = 48126,
  [SMALL_STATE(1182)] = 48192,
  [SMALL_STATE(1183)] = 48264,
  [SMALL_STATE(1184)] = 48314,
  [SMALL_STATE(1185)] = 48364,
  [SMALL_STATE(1186)] = 48414,
  [SMALL_STATE(1187)] = 48464,
  [SMALL_STATE(1188)] = 48514,
  [SMALL_STATE(1189)] = 48608,
  [SMALL_STATE(1190)] = 48702,
  [SMALL_STATE(1191)] = 48802,
  [SMALL_STATE(1192)] = 48902,
  [SMALL_STATE(1193)] = 48996,
  [SMALL_STATE(1194)] = 49046,
  [SMALL_STATE(1195)] = 49140,
  [SMALL_STATE(1196)] = 49206,
  [SMALL_STATE(1197)] = 49256,
  [SMALL_STATE(1198)] = 49350,
  [SMALL_STATE(1199)] = 49400,
  [SMALL_STATE(1200)] = 49450,
  [SMALL_STATE(1201)] = 49500,
  [SMALL_STATE(1202)] = 49550,
  [SMALL_STATE(1203)] = 49600,
  [SMALL_STATE(1204)] = 49694,
  [SMALL_STATE(1205)] = 49750,
  [SMALL_STATE(1206)] = 49850,
  [SMALL_STATE(1207)] = 49900,
  [SMALL_STATE(1208)] = 49950,
  [SMALL_STATE(1209)] = 50000,
  [SMALL_STATE(1210)] = 50050,
  [SMALL_STATE(1211)] = 50100,
  [SMALL_STATE(1212)] = 50170,
  [SMALL_STATE(1213)] = 50226,
  [SMALL_STATE(1214)] = 50276,
  [SMALL_STATE(1215)] = 50326,
  [SMALL_STATE(1216)] = 50424,
  [SMALL_STATE(1217)] = 50474,
  [SMALL_STATE(1218)] = 50524,
  [SMALL_STATE(1219)] = 50574,
  [SMALL_STATE(1220)] = 50624,
  [SMALL_STATE(1221)] = 50674,
  [SMALL_STATE(1222)] = 50724,
  [SMALL_STATE(1223)] = 50818,
  [SMALL_STATE(1224)] = 50868,
  [SMALL_STATE(1225)] = 50918,
  [SMALL_STATE(1226)] = 50972,
  [SMALL_STATE(1227)] = 51022,
  [SMALL_STATE(1228)] = 51072,
  [SMALL_STATE(1229)] = 51122,
  [SMALL_STATE(1230)] = 51172,
  [SMALL_STATE(1231)] = 51222,
  [SMALL_STATE(1232)] = 51272,
  [SMALL_STATE(1233)] = 51322,
  [SMALL_STATE(1234)] = 51372,
  [SMALL_STATE(1235)] = 51466,
  [SMALL_STATE(1236)] = 51516,
  [SMALL_STATE(1237)] = 51566,
  [SMALL_STATE(1238)] = 51616,
  [SMALL_STATE(1239)] = 51666,
  [SMALL_STATE(1240)] = 51716,
  [SMALL_STATE(1241)] = 51766,
  [SMALL_STATE(1242)] = 51860,
  [SMALL_STATE(1243)] = 51910,
  [SMALL_STATE(1244)] = 52003,
  [SMALL_STATE(1245)] = 52100,
  [SMALL_STATE(1246)] = 52193,
  [SMALL_STATE(1247)] = 52244,
  [SMALL_STATE(1248)] = 52337,
  [SMALL_STATE(1249)] = 52432,
  [SMALL_STATE(1250)] = 52527,
  [SMALL_STATE(1251)] = 52596,
  [SMALL_STATE(1252)] = 52689,
  [SMALL_STATE(1253)] = 52786,
  [SMALL_STATE(1254)] = 52881,
  [SMALL_STATE(1255)] = 52942,
  [SMALL_STATE(1256)] = 53037,
  [SMALL_STATE(1257)] = 53130,
  [SMALL_STATE(1258)] = 53225,
  [SMALL_STATE(1259)] = 53320,
  [SMALL_STATE(1260)] = 53415,
  [SMALL_STATE(1261)] = 53486,
  [SMALL_STATE(1262)] = 53581,
  [SMALL_STATE(1263)] = 53658,
  [SMALL_STATE(1264)] = 53747,
  [SMALL_STATE(1265)] = 53816,
  [SMALL_STATE(1266)] = 53879,
  [SMALL_STATE(1267)] = 53964,
  [SMALL_STATE(1268)] = 54045,
  [SMALL_STATE(1269)] = 54138,
  [SMALL_STATE(1270)] = 54197,
  [SMALL_STATE(1271)] = 54246,
  [SMALL_STATE(1272)] = 54343,
  [SMALL_STATE(1273)] = 54438,
  [SMALL_STATE(1274)] = 54507,
  [SMALL_STATE(1275)] = 54584,
  [SMALL_STATE(1276)] = 54655,
  [SMALL_STATE(1277)] = 54708,
  [SMALL_STATE(1278)] = 54803,
  [SMALL_STATE(1279)] = 54900,
  [SMALL_STATE(1280)] = 54955,
  [SMALL_STATE(1281)] = 55008,
  [SMALL_STATE(1282)] = 55065,
  [SMALL_STATE(1283)] = 55116,
  [SMALL_STATE(1284)] = 55173,
  [SMALL_STATE(1285)] = 55248,
  [SMALL_STATE(1286)] = 55341,
  [SMALL_STATE(1287)] = 55390,
  [SMALL_STATE(1288)] = 55479,
  [SMALL_STATE(1289)] = 55548,
  [SMALL_STATE(1290)] = 55597,
  [SMALL_STATE(1291)] = 55648,
  [SMALL_STATE(1292)] = 55701,
  [SMALL_STATE(1293)] = 55770,
  [SMALL_STATE(1294)] = 55823,
  [SMALL_STATE(1295)] = 55918,
  [SMALL_STATE(1296)] = 56013,
  [SMALL_STATE(1297)] = 56106,
  [SMALL_STATE(1298)] = 56199,
  [SMALL_STATE(1299)] = 56292,
  [SMALL_STATE(1300)] = 56387,
  [SMALL_STATE(1301)] = 56480,
  [SMALL_STATE(1302)] = 56573,
  [SMALL_STATE(1303)] = 56670,
  [SMALL_STATE(1304)] = 56767,
  [SMALL_STATE(1305)] = 56860,
  [SMALL_STATE(1306)] = 56953,
  [SMALL_STATE(1307)] = 57004,
  [SMALL_STATE(1308)] = 57071,
  [SMALL_STATE(1309)] = 57164,
  [SMALL_STATE(1310)] = 57261,
  [SMALL_STATE(1311)] = 57358,
  [SMALL_STATE(1312)] = 57451,
  [SMALL_STATE(1313)] = 57512,
  [SMALL_STATE(1314)] = 57565,
  [SMALL_STATE(1315)] = 57660,
  [SMALL_STATE(1316)] = 57709,
  [SMALL_STATE(1317)] = 57804,
  [SMALL_STATE(1318)] = 57899,
  [SMALL_STATE(1319)] = 57994,
  [SMALL_STATE(1320)] = 58091,
  [SMALL_STATE(1321)] = 58188,
  [SMALL_STATE(1322)] = 58281,
  [SMALL_STATE(1323)] = 58336,
  [SMALL_STATE(1324)] = 58431,
  [SMALL_STATE(1325)] = 58484,
  [SMALL_STATE(1326)] = 58577,
  [SMALL_STATE(1327)] = 58670,
  [SMALL_STATE(1328)] = 58767,
  [SMALL_STATE(1329)] = 58836,
  [SMALL_STATE(1330)] = 58929,
  [SMALL_STATE(1331)] = 59024,
  [SMALL_STATE(1332)] = 59121,
  [SMALL_STATE(1333)] = 59202,
  [SMALL_STATE(1334)] = 59261,
  [SMALL_STATE(1335)] = 59354,
  [SMALL_STATE(1336)] = 59421,
  [SMALL_STATE(1337)] = 59518,
  [SMALL_STATE(1338)] = 59611,
  [SMALL_STATE(1339)] = 59696,
  [SMALL_STATE(1340)] = 59761,
  [SMALL_STATE(1341)] = 59810,
  [SMALL_STATE(1342)] = 59861,
  [SMALL_STATE(1343)] = 59926,
  [SMALL_STATE(1344)] = 60001,
  [SMALL_STATE(1345)] = 60098,
  [SMALL_STATE(1346)] = 60193,
  [SMALL_STATE(1347)] = 60242,
  [SMALL_STATE(1348)] = 60296,
  [SMALL_STATE(1349)] = 60344,
  [SMALL_STATE(1350)] = 60398,
  [SMALL_STATE(1351)] = 60450,
  [SMALL_STATE(1352)] = 60512,
  [SMALL_STATE(1353)] = 60604,
  [SMALL_STATE(1354)] = 60698,
  [SMALL_STATE(1355)] = 60750,
  [SMALL_STATE(1356)] = 60804,
  [SMALL_STATE(1357)] = 60898,
  [SMALL_STATE(1358)] = 60952,
  [SMALL_STATE(1359)] = 61020,
  [SMALL_STATE(1360)] = 61088,
  [SMALL_STATE(1361)] = 61180,
  [SMALL_STATE(1362)] = 61272,
  [SMALL_STATE(1363)] = 61338,
  [SMALL_STATE(1364)] = 61390,
  [SMALL_STATE(1365)] = 61438,
  [SMALL_STATE(1366)] = 61498,
  [SMALL_STATE(1367)] = 61558,
  [SMALL_STATE(1368)] = 61614,
  [SMALL_STATE(1369)] = 61666,
  [SMALL_STATE(1370)] = 61722,
  [SMALL_STATE(1371)] = 61774,
  [SMALL_STATE(1372)] = 61828,
  [SMALL_STATE(1373)] = 61880,
  [SMALL_STATE(1374)] = 61928,
  [SMALL_STATE(1375)] = 61976,
  [SMALL_STATE(1376)] = 62070,
  [SMALL_STATE(1377)] = 62164,
  [SMALL_STATE(1378)] = 62216,
  [SMALL_STATE(1379)] = 62268,
  [SMALL_STATE(1380)] = 62320,
  [SMALL_STATE(1381)] = 62372,
  [SMALL_STATE(1382)] = 62424,
  [SMALL_STATE(1383)] = 62476,
  [SMALL_STATE(1384)] = 62526,
  [SMALL_STATE(1385)] = 62578,
  [SMALL_STATE(1386)] = 62632,
  [SMALL_STATE(1387)] = 62680,
  [SMALL_STATE(1388)] = 62728,
  [SMALL_STATE(1389)] = 62780,
  [SMALL_STATE(1390)] = 62832,
  [SMALL_STATE(1391)] = 62924,
  [SMALL_STATE(1392)] = 63016,
  [SMALL_STATE(1393)] = 63110,
  [SMALL_STATE(1394)] = 63158,
  [SMALL_STATE(1395)] = 63206,
  [SMALL_STATE(1396)] = 63298,
  [SMALL_STATE(1397)] = 63346,
  [SMALL_STATE(1398)] = 63440,
  [SMALL_STATE(1399)] = 63534,
  [SMALL_STATE(1400)] = 63586,
  [SMALL_STATE(1401)] = 63680,
  [SMALL_STATE(1402)] = 63774,
  [SMALL_STATE(1403)] = 63840,
  [SMALL_STATE(1404)] = 63898,
  [SMALL_STATE(1405)] = 63990,
  [SMALL_STATE(1406)] = 64082,
  [SMALL_STATE(1407)] = 64176,
  [SMALL_STATE(1408)] = 64226,
  [SMALL_STATE(1409)] = 64278,
  [SMALL_STATE(1410)] = 64372,
  [SMALL_STATE(1411)] = 64422,
  [SMALL_STATE(1412)] = 64516,
  [SMALL_STATE(1413)] = 64608,
  [SMALL_STATE(1414)] = 64702,
  [SMALL_STATE(1415)] = 64794,
  [SMALL_STATE(1416)] = 64842,
  [SMALL_STATE(1417)] = 64934,
  [SMALL_STATE(1418)] = 64986,
  [SMALL_STATE(1419)] = 65038,
  [SMALL_STATE(1420)] = 65086,
  [SMALL_STATE(1421)] = 65134,
  [SMALL_STATE(1422)] = 65226,
  [SMALL_STATE(1423)] = 65276,
  [SMALL_STATE(1424)] = 65324,
  [SMALL_STATE(1425)] = 65384,
  [SMALL_STATE(1426)] = 65432,
  [SMALL_STATE(1427)] = 65480,
  [SMALL_STATE(1428)] = 65572,
  [SMALL_STATE(1429)] = 65626,
  [SMALL_STATE(1430)] = 65674,
  [SMALL_STATE(1431)] = 65722,
  [SMALL_STATE(1432)] = 65776,
  [SMALL_STATE(1433)] = 65844,
  [SMALL_STATE(1434)] = 65914,
  [SMALL_STATE(1435)] = 65990,
  [SMALL_STATE(1436)] = 66038,
  [SMALL_STATE(1437)] = 66118,
  [SMALL_STATE(1438)] = 66202,
  [SMALL_STATE(1439)] = 66276,
  [SMALL_STATE(1440)] = 66344,
  [SMALL_STATE(1441)] = 66432,
  [SMALL_STATE(1442)] = 66482,
  [SMALL_STATE(1443)] = 66574,
  [SMALL_STATE(1444)] = 66666,
  [SMALL_STATE(1445)] = 66758,
  [SMALL_STATE(1446)] = 66850,
  [SMALL_STATE(1447)] = 66898,
  [SMALL_STATE(1448)] = 66966,
  [SMALL_STATE(1449)] = 67058,
  [SMALL_STATE(1450)] = 67150,
  [SMALL_STATE(1451)] = 67244,
  [SMALL_STATE(1452)] = 67292,
  [SMALL_STATE(1453)] = 67386,
  [SMALL_STATE(1454)] = 67478,
  [SMALL_STATE(1455)] = 67572,
  [SMALL_STATE(1456)] = 67666,
  [SMALL_STATE(1457)] = 67716,
  [SMALL_STATE(1458)] = 67782,
  [SMALL_STATE(1459)] = 67876,
  [SMALL_STATE(1460)] = 67928,
  [SMALL_STATE(1461)] = 68022,
  [SMALL_STATE(1462)] = 68116,
  [SMALL_STATE(1463)] = 68210,
  [SMALL_STATE(1464)] = 68304,
  [SMALL_STATE(1465)] = 68354,
  [SMALL_STATE(1466)] = 68446,
  [SMALL_STATE(1467)] = 68540,
  [SMALL_STATE(1468)] = 68632,
  [SMALL_STATE(1469)] = 68724,
  [SMALL_STATE(1470)] = 68816,
  [SMALL_STATE(1471)] = 68870,
  [SMALL_STATE(1472)] = 68964,
  [SMALL_STATE(1473)] = 69056,
  [SMALL_STATE(1474)] = 69148,
  [SMALL_STATE(1475)] = 69240,
  [SMALL_STATE(1476)] = 69292,
  [SMALL_STATE(1477)] = 69384,
  [SMALL_STATE(1478)] = 69476,
  [SMALL_STATE(1479)] = 69568,
  [SMALL_STATE(1480)] = 69656,
  [SMALL_STATE(1481)] = 69730,
  [SMALL_STATE(1482)] = 69814,
  [SMALL_STATE(1483)] = 69894,
  [SMALL_STATE(1484)] = 69970,
  [SMALL_STATE(1485)] = 70062,
  [SMALL_STATE(1486)] = 70154,
  [SMALL_STATE(1487)] = 70224,
  [SMALL_STATE(1488)] = 70316,
  [SMALL_STATE(1489)] = 70410,
  [SMALL_STATE(1490)] = 70502,
  [SMALL_STATE(1491)] = 70594,
  [SMALL_STATE(1492)] = 70654,
  [SMALL_STATE(1493)] = 70706,
  [SMALL_STATE(1494)] = 70774,
  [SMALL_STATE(1495)] = 70822,
  [SMALL_STATE(1496)] = 70870,
  [SMALL_STATE(1497)] = 70962,
  [SMALL_STATE(1498)] = 71014,
  [SMALL_STATE(1499)] = 71106,
  [SMALL_STATE(1500)] = 71198,
  [SMALL_STATE(1501)] = 71246,
  [SMALL_STATE(1502)] = 71294,
  [SMALL_STATE(1503)] = 71386,
  [SMALL_STATE(1504)] = 71436,
  [SMALL_STATE(1505)] = 71484,
  [SMALL_STATE(1506)] = 71532,
  [SMALL_STATE(1507)] = 71580,
  [SMALL_STATE(1508)] = 71628,
  [SMALL_STATE(1509)] = 71678,
  [SMALL_STATE(1510)] = 71726,
  [SMALL_STATE(1511)] = 71774,
  [SMALL_STATE(1512)] = 71822,
  [SMALL_STATE(1513)] = 71869,
  [SMALL_STATE(1514)] = 71916,
  [SMALL_STATE(1515)] = 71963,
  [SMALL_STATE(1516)] = 72054,
  [SMALL_STATE(1517)] = 72137,
  [SMALL_STATE(1518)] = 72184,
  [SMALL_STATE(1519)] = 72267,
  [SMALL_STATE(1520)] = 72314,
  [SMALL_STATE(1521)] = 72397,
  [SMALL_STATE(1522)] = 72450,
  [SMALL_STATE(1523)] = 72541,
  [SMALL_STATE(1524)] = 72596,
  [SMALL_STATE(1525)] = 72651,
  [SMALL_STATE(1526)] = 72708,
  [SMALL_STATE(1527)] = 72755,
  [SMALL_STATE(1528)] = 72802,
  [SMALL_STATE(1529)] = 72855,
  [SMALL_STATE(1530)] = 72902,
  [SMALL_STATE(1531)] = 72949,
  [SMALL_STATE(1532)] = 72996,
  [SMALL_STATE(1533)] = 73043,
  [SMALL_STATE(1534)] = 73090,
  [SMALL_STATE(1535)] = 73141,
  [SMALL_STATE(1536)] = 73196,
  [SMALL_STATE(1537)] = 73251,
  [SMALL_STATE(1538)] = 73300,
  [SMALL_STATE(1539)] = 73357,
  [SMALL_STATE(1540)] = 73440,
  [SMALL_STATE(1541)] = 73493,
  [SMALL_STATE(1542)] = 73540,
  [SMALL_STATE(1543)] = 73589,
  [SMALL_STATE(1544)] = 73636,
  [SMALL_STATE(1545)] = 73719,
  [SMALL_STATE(1546)] = 73770,
  [SMALL_STATE(1547)] = 73827,
  [SMALL_STATE(1548)] = 73874,
  [SMALL_STATE(1549)] = 73921,
  [SMALL_STATE(1550)] = 73968,
  [SMALL_STATE(1551)] = 74015,
  [SMALL_STATE(1552)] = 74062,
  [SMALL_STATE(1553)] = 74153,
  [SMALL_STATE(1554)] = 74206,
  [SMALL_STATE(1555)] = 74291,
  [SMALL_STATE(1556)] = 74376,
  [SMALL_STATE(1557)] = 74423,
  [SMALL_STATE(1558)] = 74506,
  [SMALL_STATE(1559)] = 74555,
  [SMALL_STATE(1560)] = 74602,
  [SMALL_STATE(1561)] = 74649,
  [SMALL_STATE(1562)] = 74696,
  [SMALL_STATE(1563)] = 74743,
  [SMALL_STATE(1564)] = 74790,
  [SMALL_STATE(1565)] = 74837,
  [SMALL_STATE(1566)] = 74920,
  [SMALL_STATE(1567)] = 74969,
  [SMALL_STATE(1568)] = 75016,
  [SMALL_STATE(1569)] = 75107,
  [SMALL_STATE(1570)] = 75154,
  [SMALL_STATE(1571)] = 75201,
  [SMALL_STATE(1572)] = 75250,
  [SMALL_STATE(1573)] = 75297,
  [SMALL_STATE(1574)] = 75344,
  [SMALL_STATE(1575)] = 75391,
  [SMALL_STATE(1576)] = 75450,
  [SMALL_STATE(1577)] = 75497,
  [SMALL_STATE(1578)] = 75544,
  [SMALL_STATE(1579)] = 75591,
  [SMALL_STATE(1580)] = 75638,
  [SMALL_STATE(1581)] = 75685,
  [SMALL_STATE(1582)] = 75732,
  [SMALL_STATE(1583)] = 75791,
  [SMALL_STATE(1584)] = 75842,
  [SMALL_STATE(1585)] = 75889,
  [SMALL_STATE(1586)] = 75936,
  [SMALL_STATE(1587)] = 75983,
  [SMALL_STATE(1588)] = 76030,
  [SMALL_STATE(1589)] = 76077,
  [SMALL_STATE(1590)] = 76132,
  [SMALL_STATE(1591)] = 76179,
  [SMALL_STATE(1592)] = 76270,
  [SMALL_STATE(1593)] = 76317,
  [SMALL_STATE(1594)] = 76364,
  [SMALL_STATE(1595)] = 76411,
  [SMALL_STATE(1596)] = 76458,
  [SMALL_STATE(1597)] = 76505,
  [SMALL_STATE(1598)] = 76552,
  [SMALL_STATE(1599)] = 76637,
  [SMALL_STATE(1600)] = 76684,
  [SMALL_STATE(1601)] = 76733,
  [SMALL_STATE(1602)] = 76780,
  [SMALL_STATE(1603)] = 76827,
  [SMALL_STATE(1604)] = 76874,
  [SMALL_STATE(1605)] = 76921,
  [SMALL_STATE(1606)] = 76980,
  [SMALL_STATE(1607)] = 77027,
  [SMALL_STATE(1608)] = 77118,
  [SMALL_STATE(1609)] = 77165,
  [SMALL_STATE(1610)] = 77214,
  [SMALL_STATE(1611)] = 77263,
  [SMALL_STATE(1612)] = 77310,
  [SMALL_STATE(1613)] = 77401,
  [SMALL_STATE(1614)] = 77448,
  [SMALL_STATE(1615)] = 77507,
  [SMALL_STATE(1616)] = 77564,
  [SMALL_STATE(1617)] = 77611,
  [SMALL_STATE(1618)] = 77658,
  [SMALL_STATE(1619)] = 77707,
  [SMALL_STATE(1620)] = 77754,
  [SMALL_STATE(1621)] = 77837,
  [SMALL_STATE(1622)] = 77884,
  [SMALL_STATE(1623)] = 77931,
  [SMALL_STATE(1624)] = 78014,
  [SMALL_STATE(1625)] = 78061,
  [SMALL_STATE(1626)] = 78108,
  [SMALL_STATE(1627)] = 78155,
  [SMALL_STATE(1628)] = 78238,
  [SMALL_STATE(1629)] = 78285,
  [SMALL_STATE(1630)] = 78332,
  [SMALL_STATE(1631)] = 78415,
  [SMALL_STATE(1632)] = 78462,
  [SMALL_STATE(1633)] = 78509,
  [SMALL_STATE(1634)] = 78566,
  [SMALL_STATE(1635)] = 78613,
  [SMALL_STATE(1636)] = 78660,
  [SMALL_STATE(1637)] = 78721,
  [SMALL_STATE(1638)] = 78782,
  [SMALL_STATE(1639)] = 78839,
  [SMALL_STATE(1640)] = 78888,
  [SMALL_STATE(1641)] = 78935,
  [SMALL_STATE(1642)] = 78982,
  [SMALL_STATE(1643)] = 79073,
  [SMALL_STATE(1644)] = 79120,
  [SMALL_STATE(1645)] = 79171,
  [SMALL_STATE(1646)] = 79254,
  [SMALL_STATE(1647)] = 79301,
  [SMALL_STATE(1648)] = 79362,
  [SMALL_STATE(1649)] = 79409,
  [SMALL_STATE(1650)] = 79468,
  [SMALL_STATE(1651)] = 79521,
  [SMALL_STATE(1652)] = 79568,
  [SMALL_STATE(1653)] = 79615,
  [SMALL_STATE(1654)] = 79670,
  [SMALL_STATE(1655)] = 79717,
  [SMALL_STATE(1656)] = 79776,
  [SMALL_STATE(1657)] = 79835,
  [SMALL_STATE(1658)] = 79920,
  [SMALL_STATE(1659)] = 79967,
  [SMALL_STATE(1660)] = 80050,
  [SMALL_STATE(1661)] = 80097,
  [SMALL_STATE(1662)] = 80144,
  [SMALL_STATE(1663)] = 80191,
  [SMALL_STATE(1664)] = 80238,
  [SMALL_STATE(1665)] = 80285,
  [SMALL_STATE(1666)] = 80370,
  [SMALL_STATE(1667)] = 80417,
  [SMALL_STATE(1668)] = 80468,
  [SMALL_STATE(1669)] = 80515,
  [SMALL_STATE(1670)] = 80562,
  [SMALL_STATE(1671)] = 80609,
  [SMALL_STATE(1672)] = 80663,
  [SMALL_STATE(1673)] = 80709,
  [SMALL_STATE(1674)] = 80755,
  [SMALL_STATE(1675)] = 80801,
  [SMALL_STATE(1676)] = 80847,
  [SMALL_STATE(1677)] = 80893,
  [SMALL_STATE(1678)] = 80939,
  [SMALL_STATE(1679)] = 80985,
  [SMALL_STATE(1680)] = 81031,
  [SMALL_STATE(1681)] = 81077,
  [SMALL_STATE(1682)] = 81123,
  [SMALL_STATE(1683)] = 81211,
  [SMALL_STATE(1684)] = 81257,
  [SMALL_STATE(1685)] = 81303,
  [SMALL_STATE(1686)] = 81349,
  [SMALL_STATE(1687)] = 81395,
  [SMALL_STATE(1688)] = 81441,
  [SMALL_STATE(1689)] = 81487,
  [SMALL_STATE(1690)] = 81533,
  [SMALL_STATE(1691)] = 81579,
  [SMALL_STATE(1692)] = 81633,
  [SMALL_STATE(1693)] = 81679,
  [SMALL_STATE(1694)] = 81767,
  [SMALL_STATE(1695)] = 81813,
  [SMALL_STATE(1696)] = 81879,
  [SMALL_STATE(1697)] = 81933,
  [SMALL_STATE(1698)] = 82021,
  [SMALL_STATE(1699)] = 82089,
  [SMALL_STATE(1700)] = 82135,
  [SMALL_STATE(1701)] = 82181,
  [SMALL_STATE(1702)] = 82245,
  [SMALL_STATE(1703)] = 82291,
  [SMALL_STATE(1704)] = 82337,
  [SMALL_STATE(1705)] = 82383,
  [SMALL_STATE(1706)] = 82429,
  [SMALL_STATE(1707)] = 82475,
  [SMALL_STATE(1708)] = 82521,
  [SMALL_STATE(1709)] = 82567,
  [SMALL_STATE(1710)] = 82613,
  [SMALL_STATE(1711)] = 82659,
  [SMALL_STATE(1712)] = 82705,
  [SMALL_STATE(1713)] = 82769,
  [SMALL_STATE(1714)] = 82823,
  [SMALL_STATE(1715)] = 82891,
  [SMALL_STATE(1716)] = 82971,
  [SMALL_STATE(1717)] = 83035,
  [SMALL_STATE(1718)] = 83081,
  [SMALL_STATE(1719)] = 83127,
  [SMALL_STATE(1720)] = 83173,
  [SMALL_STATE(1721)] = 83219,
  [SMALL_STATE(1722)] = 83265,
  [SMALL_STATE(1723)] = 83311,
  [SMALL_STATE(1724)] = 83377,
  [SMALL_STATE(1725)] = 83429,
  [SMALL_STATE(1726)] = 83475,
  [SMALL_STATE(1727)] = 83521,
  [SMALL_STATE(1728)] = 83567,
  [SMALL_STATE(1729)] = 83635,
  [SMALL_STATE(1730)] = 83681,
  [SMALL_STATE(1731)] = 83727,
  [SMALL_STATE(1732)] = 83773,
  [SMALL_STATE(1733)] = 83819,
  [SMALL_STATE(1734)] = 83865,
  [SMALL_STATE(1735)] = 83911,
  [SMALL_STATE(1736)] = 83957,
  [SMALL_STATE(1737)] = 84021,
  [SMALL_STATE(1738)] = 84067,
  [SMALL_STATE(1739)] = 84113,
  [SMALL_STATE(1740)] = 84159,
  [SMALL_STATE(1741)] = 84205,
  [SMALL_STATE(1742)] = 84271,
  [SMALL_STATE(1743)] = 84337,
  [SMALL_STATE(1744)] = 84405,
  [SMALL_STATE(1745)] = 84451,
  [SMALL_STATE(1746)] = 84497,
  [SMALL_STATE(1747)] = 84543,
  [SMALL_STATE(1748)] = 84589,
  [SMALL_STATE(1749)] = 84635,
  [SMALL_STATE(1750)] = 84694,
  [SMALL_STATE(1751)] = 84759,
  [SMALL_STATE(1752)] = 84818,
  [SMALL_STATE(1753)] = 84881,
  [SMALL_STATE(1754)] = 84948,
  [SMALL_STATE(1755)] = 85007,
  [SMALL_STATE(1756)] = 85070,
  [SMALL_STATE(1757)] = 85133,
  [SMALL_STATE(1758)] = 85190,
  [SMALL_STATE(1759)] = 85249,
  [SMALL_STATE(1760)] = 85306,
  [SMALL_STATE(1761)] = 85363,
  [SMALL_STATE(1762)] = 85420,
  [SMALL_STATE(1763)] = 85478,
  [SMALL_STATE(1764)] = 85538,
  [SMALL_STATE(1765)] = 85600,
  [SMALL_STATE(1766)] = 85658,
  [SMALL_STATE(1767)] = 85718,
  [SMALL_STATE(1768)] = 85776,
  [SMALL_STATE(1769)] = 85838,
  [SMALL_STATE(1770)] = 85898,
  [SMALL_STATE(1771)] = 85956,
  [SMALL_STATE(1772)] = 86018,
  [SMALL_STATE(1773)] = 86076,
  [SMALL_STATE(1774)] = 86134,
  [SMALL_STATE(1775)] = 86192,
  [SMALL_STATE(1776)] = 86250,
  [SMALL_STATE(1777)] = 86308,
  [SMALL_STATE(1778)] = 86368,
  [SMALL_STATE(1779)] = 86414,
  [SMALL_STATE(1780)] = 86474,
  [SMALL_STATE(1781)] = 86536,
  [SMALL_STATE(1782)] = 86596,
  [SMALL_STATE(1783)] = 86654,
  [SMALL_STATE(1784)] = 86716,
  [SMALL_STATE(1785)] = 86776,
  [SMALL_STATE(1786)] = 86834,
  [SMALL_STATE(1787)] = 86892,
  [SMALL_STATE(1788)] = 86965,
  [SMALL_STATE(1789)] = 87018,
  [SMALL_STATE(1790)] = 87085,
  [SMALL_STATE(1791)] = 87152,
  [SMALL_STATE(1792)] = 87225,
  [SMALL_STATE(1793)] = 87294,
  [SMALL_STATE(1794)] = 87359,
  [SMALL_STATE(1795)] = 87412,
  [SMALL_STATE(1796)] = 87465,
  [SMALL_STATE(1797)] = 87514,
  [SMALL_STATE(1798)] = 87587,
  [SMALL_STATE(1799)] = 87656,
  [SMALL_STATE(1800)] = 87709,
  [SMALL_STATE(1801)] = 87774,
  [SMALL_STATE(1802)] = 87847,
  [SMALL_STATE(1803)] = 87916,
  [SMALL_STATE(1804)] = 87969,
  [SMALL_STATE(1805)] = 88022,
  [SMALL_STATE(1806)] = 88089,
  [SMALL_STATE(1807)] = 88138,
  [SMALL_STATE(1808)] = 88211,
  [SMALL_STATE(1809)] = 88264,
  [SMALL_STATE(1810)] = 88313,
  [SMALL_STATE(1811)] = 88386,
  [SMALL_STATE(1812)] = 88451,
  [SMALL_STATE(1813)] = 88504,
  [SMALL_STATE(1814)] = 88557,
  [SMALL_STATE(1815)] = 88606,
  [SMALL_STATE(1816)] = 88679,
  [SMALL_STATE(1817)] = 88732,
  [SMALL_STATE(1818)] = 88805,
  [SMALL_STATE(1819)] = 88878,
  [SMALL_STATE(1820)] = 88951,
  [SMALL_STATE(1821)] = 89004,
  [SMALL_STATE(1822)] = 89077,
  [SMALL_STATE(1823)] = 89130,
  [SMALL_STATE(1824)] = 89197,
  [SMALL_STATE(1825)] = 89270,
  [SMALL_STATE(1826)] = 89323,
  [SMALL_STATE(1827)] = 89372,
  [SMALL_STATE(1828)] = 89437,
  [SMALL_STATE(1829)] = 89506,
  [SMALL_STATE(1830)] = 89571,
  [SMALL_STATE(1831)] = 89640,
  [SMALL_STATE(1832)] = 89713,
  [SMALL_STATE(1833)] = 89766,
  [SMALL_STATE(1834)] = 89833,
  [SMALL_STATE(1835)] = 89886,
  [SMALL_STATE(1836)] = 89946,
  [SMALL_STATE(1837)] = 90016,
  [SMALL_STATE(1838)] = 90076,
  [SMALL_STATE(1839)] = 90146,
  [SMALL_STATE(1840)] = 90206,
  [SMALL_STATE(1841)] = 90276,
  [SMALL_STATE(1842)] = 90318,
  [SMALL_STATE(1843)] = 90378,
  [SMALL_STATE(1844)] = 90426,
  [SMALL_STATE(1845)] = 90496,
  [SMALL_STATE(1846)] = 90556,
  [SMALL_STATE(1847)] = 90616,
  [SMALL_STATE(1848)] = 90680,
  [SMALL_STATE(1849)] = 90750,
  [SMALL_STATE(1850)] = 90812,
  [SMALL_STATE(1851)] = 90891,
  [SMALL_STATE(1852)] = 90970,
  [SMALL_STATE(1853)] = 91025,
  [SMALL_STATE(1854)] = 91104,
  [SMALL_STATE(1855)] = 91183,
  [SMALL_STATE(1856)] = 91262,
  [SMALL_STATE(1857)] = 91341,
  [SMALL_STATE(1858)] = 91381,
  [SMALL_STATE(1859)] = 91421,
  [SMALL_STATE(1860)] = 91471,
  [SMALL_STATE(1861)] = 91511,
  [SMALL_STATE(1862)] = 91561,
  [SMALL_STATE(1863)] = 91601,
  [SMALL_STATE(1864)] = 91651,
  [SMALL_STATE(1865)] = 91701,
  [SMALL_STATE(1866)] = 91751,
  [SMALL_STATE(1867)] = 91791,
  [SMALL_STATE(1868)] = 91836,
  [SMALL_STATE(1869)] = 91886,
  [SMALL_STATE(1870)] = 91924,
  [SMALL_STATE(1871)] = 91976,
  [SMALL_STATE(1872)] = 92014,
  [SMALL_STATE(1873)] = 92052,
  [SMALL_STATE(1874)] = 92090,
  [SMALL_STATE(1875)] = 92146,
  [SMALL_STATE(1876)] = 92200,
  [SMALL_STATE(1877)] = 92252,
  [SMALL_STATE(1878)] = 92306,
  [SMALL_STATE(1879)] = 92358,
  [SMALL_STATE(1880)] = 92396,
  [SMALL_STATE(1881)] = 92434,
  [SMALL_STATE(1882)] = 92472,
  [SMALL_STATE(1883)] = 92512,
  [SMALL_STATE(1884)] = 92550,
  [SMALL_STATE(1885)] = 92588,
  [SMALL_STATE(1886)] = 92628,
  [SMALL_STATE(1887)] = 92666,
  [SMALL_STATE(1888)] = 92704,
  [SMALL_STATE(1889)] = 92742,
  [SMALL_STATE(1890)] = 92782,
  [SMALL_STATE(1891)] = 92820,
  [SMALL_STATE(1892)] = 92858,
  [SMALL_STATE(1893)] = 92905,
  [SMALL_STATE(1894)] = 92952,
  [SMALL_STATE(1895)] = 92999,
  [SMALL_STATE(1896)] = 93046,
  [SMALL_STATE(1897)] = 93093,
  [SMALL_STATE(1898)] = 93140,
  [SMALL_STATE(1899)] = 93187,
  [SMALL_STATE(1900)] = 93234,
  [SMALL_STATE(1901)] = 93281,
  [SMALL_STATE(1902)] = 93328,
  [SMALL_STATE(1903)] = 93375,
  [SMALL_STATE(1904)] = 93422,
  [SMALL_STATE(1905)] = 93469,
  [SMALL_STATE(1906)] = 93516,
  [SMALL_STATE(1907)] = 93563,
  [SMALL_STATE(1908)] = 93610,
  [SMALL_STATE(1909)] = 93657,
  [SMALL_STATE(1910)] = 93704,
  [SMALL_STATE(1911)] = 93752,
  [SMALL_STATE(1912)] = 93800,
  [SMALL_STATE(1913)] = 93848,
  [SMALL_STATE(1914)] = 93884,
  [SMALL_STATE(1915)] = 93932,
  [SMALL_STATE(1916)] = 93974,
  [SMALL_STATE(1917)] = 94022,
  [SMALL_STATE(1918)] = 94070,
  [SMALL_STATE(1919)] = 94126,
  [SMALL_STATE(1920)] = 94175,
  [SMALL_STATE(1921)] = 94228,
  [SMALL_STATE(1922)] = 94281,
  [SMALL_STATE(1923)] = 94326,
  [SMALL_STATE(1924)] = 94363,
  [SMALL_STATE(1925)] = 94416,
  [SMALL_STATE(1926)] = 94465,
  [SMALL_STATE(1927)] = 94507,
  [SMALL_STATE(1928)] = 94549,
  [SMALL_STATE(1929)] = 94591,
  [SMALL_STATE(1930)] = 94633,
  [SMALL_STATE(1931)] = 94675,
  [SMALL_STATE(1932)] = 94717,
  [SMALL_STATE(1933)] = 94759,
  [SMALL_STATE(1934)] = 94801,
  [SMALL_STATE(1935)] = 94843,
  [SMALL_STATE(1936)] = 94885,
  [SMALL_STATE(1937)] = 94927,
  [SMALL_STATE(1938)] = 94969,
  [SMALL_STATE(1939)] = 95011,
  [SMALL_STATE(1940)] = 95053,
  [SMALL_STATE(1941)] = 95095,
  [SMALL_STATE(1942)] = 95137,
  [SMALL_STATE(1943)] = 95179,
  [SMALL_STATE(1944)] = 95221,
  [SMALL_STATE(1945)] = 95263,
  [SMALL_STATE(1946)] = 95297,
  [SMALL_STATE(1947)] = 95339,
  [SMALL_STATE(1948)] = 95381,
  [SMALL_STATE(1949)] = 95423,
  [SMALL_STATE(1950)] = 95465,
  [SMALL_STATE(1951)] = 95507,
  [SMALL_STATE(1952)] = 95549,
  [SMALL_STATE(1953)] = 95579,
  [SMALL_STATE(1954)] = 95611,
  [SMALL_STATE(1955)] = 95643,
  [SMALL_STATE(1956)] = 95675,
  [SMALL_STATE(1957)] = 95702,
  [SMALL_STATE(1958)] = 95731,
  [SMALL_STATE(1959)] = 95760,
  [SMALL_STATE(1960)] = 95784,
  [SMALL_STATE(1961)] = 95810,
  [SMALL_STATE(1962)] = 95834,
  [SMALL_STATE(1963)] = 95863,
  [SMALL_STATE(1964)] = 95884,
  [SMALL_STATE(1965)] = 95905,
  [SMALL_STATE(1966)] = 95934,
  [SMALL_STATE(1967)] = 95961,
  [SMALL_STATE(1968)] = 95982,
  [SMALL_STATE(1969)] = 96003,
  [SMALL_STATE(1970)] = 96024,
  [SMALL_STATE(1971)] = 96045,
  [SMALL_STATE(1972)] = 96087,
  [SMALL_STATE(1973)] = 96129,
  [SMALL_STATE(1974)] = 96157,
  [SMALL_STATE(1975)] = 96199,
  [SMALL_STATE(1976)] = 96229,
  [SMALL_STATE(1977)] = 96271,
  [SMALL_STATE(1978)] = 96313,
  [SMALL_STATE(1979)] = 96341,
  [SMALL_STATE(1980)] = 96383,
  [SMALL_STATE(1981)] = 96411,
  [SMALL_STATE(1982)] = 96448,
  [SMALL_STATE(1983)] = 96483,
  [SMALL_STATE(1984)] = 96508,
  [SMALL_STATE(1985)] = 96543,
  [SMALL_STATE(1986)] = 96566,
  [SMALL_STATE(1987)] = 96591,
  [SMALL_STATE(1988)] = 96626,
  [SMALL_STATE(1989)] = 96649,
  [SMALL_STATE(1990)] = 96684,
  [SMALL_STATE(1991)] = 96719,
  [SMALL_STATE(1992)] = 96754,
  [SMALL_STATE(1993)] = 96789,
  [SMALL_STATE(1994)] = 96824,
  [SMALL_STATE(1995)] = 96856,
  [SMALL_STATE(1996)] = 96888,
  [SMALL_STATE(1997)] = 96924,
  [SMALL_STATE(1998)] = 96956,
  [SMALL_STATE(1999)] = 96992,
  [SMALL_STATE(2000)] = 97028,
  [SMALL_STATE(2001)] = 97064,
  [SMALL_STATE(2002)] = 97096,
  [SMALL_STATE(2003)] = 97122,
  [SMALL_STATE(2004)] = 97154,
  [SMALL_STATE(2005)] = 97186,
  [SMALL_STATE(2006)] = 97218,
  [SMALL_STATE(2007)] = 97250,
  [SMALL_STATE(2008)] = 97286,
  [SMALL_STATE(2009)] = 97308,
  [SMALL_STATE(2010)] = 97344,
  [SMALL_STATE(2011)] = 97372,
  [SMALL_STATE(2012)] = 97398,
  [SMALL_STATE(2013)] = 97417,
  [SMALL_STATE(2014)] = 97434,
  [SMALL_STATE(2015)] = 97453,
  [SMALL_STATE(2016)] = 97474,
  [SMALL_STATE(2017)] = 97493,
  [SMALL_STATE(2018)] = 97512,
  [SMALL_STATE(2019)] = 97533,
  [SMALL_STATE(2020)] = 97552,
  [SMALL_STATE(2021)] = 97571,
  [SMALL_STATE(2022)] = 97592,
  [SMALL_STATE(2023)] = 97613,
  [SMALL_STATE(2024)] = 97632,
  [SMALL_STATE(2025)] = 97655,
  [SMALL_STATE(2026)] = 97674,
  [SMALL_STATE(2027)] = 97693,
  [SMALL_STATE(2028)] = 97712,
  [SMALL_STATE(2029)] = 97731,
  [SMALL_STATE(2030)] = 97754,
  [SMALL_STATE(2031)] = 97777,
  [SMALL_STATE(2032)] = 97796,
  [SMALL_STATE(2033)] = 97819,
  [SMALL_STATE(2034)] = 97840,
  [SMALL_STATE(2035)] = 97861,
  [SMALL_STATE(2036)] = 97880,
  [SMALL_STATE(2037)] = 97901,
  [SMALL_STATE(2038)] = 97920,
  [SMALL_STATE(2039)] = 97939,
  [SMALL_STATE(2040)] = 97960,
  [SMALL_STATE(2041)] = 97979,
  [SMALL_STATE(2042)] = 97998,
  [SMALL_STATE(2043)] = 98017,
  [SMALL_STATE(2044)] = 98036,
  [SMALL_STATE(2045)] = 98055,
  [SMALL_STATE(2046)] = 98074,
  [SMALL_STATE(2047)] = 98091,
  [SMALL_STATE(2048)] = 98112,
  [SMALL_STATE(2049)] = 98135,
  [SMALL_STATE(2050)] = 98154,
  [SMALL_STATE(2051)] = 98173,
  [SMALL_STATE(2052)] = 98192,
  [SMALL_STATE(2053)] = 98211,
  [SMALL_STATE(2054)] = 98230,
  [SMALL_STATE(2055)] = 98249,
  [SMALL_STATE(2056)] = 98268,
  [SMALL_STATE(2057)] = 98287,
  [SMALL_STATE(2058)] = 98306,
  [SMALL_STATE(2059)] = 98325,
  [SMALL_STATE(2060)] = 98359,
  [SMALL_STATE(2061)] = 98393,
  [SMALL_STATE(2062)] = 98413,
  [SMALL_STATE(2063)] = 98433,
  [SMALL_STATE(2064)] = 98467,
  [SMALL_STATE(2065)] = 98501,
  [SMALL_STATE(2066)] = 98523,
  [SMALL_STATE(2067)] = 98543,
  [SMALL_STATE(2068)] = 98567,
  [SMALL_STATE(2069)] = 98585,
  [SMALL_STATE(2070)] = 98619,
  [SMALL_STATE(2071)] = 98637,
  [SMALL_STATE(2072)] = 98655,
  [SMALL_STATE(2073)] = 98685,
  [SMALL_STATE(2074)] = 98719,
  [SMALL_STATE(2075)] = 98753,
  [SMALL_STATE(2076)] = 98787,
  [SMALL_STATE(2077)] = 98821,
  [SMALL_STATE(2078)] = 98841,
  [SMALL_STATE(2079)] = 98875,
  [SMALL_STATE(2080)] = 98895,
  [SMALL_STATE(2081)] = 98920,
  [SMALL_STATE(2082)] = 98945,
  [SMALL_STATE(2083)] = 98976,
  [SMALL_STATE(2084)] = 99007,
  [SMALL_STATE(2085)] = 99038,
  [SMALL_STATE(2086)] = 99057,
  [SMALL_STATE(2087)] = 99088,
  [SMALL_STATE(2088)] = 99105,
  [SMALL_STATE(2089)] = 99130,
  [SMALL_STATE(2090)] = 99151,
  [SMALL_STATE(2091)] = 99182,
  [SMALL_STATE(2092)] = 99213,
  [SMALL_STATE(2093)] = 99244,
  [SMALL_STATE(2094)] = 99269,
  [SMALL_STATE(2095)] = 99300,
  [SMALL_STATE(2096)] = 99331,
  [SMALL_STATE(2097)] = 99348,
  [SMALL_STATE(2098)] = 99365,
  [SMALL_STATE(2099)] = 99390,
  [SMALL_STATE(2100)] = 99407,
  [SMALL_STATE(2101)] = 99438,
  [SMALL_STATE(2102)] = 99459,
  [SMALL_STATE(2103)] = 99484,
  [SMALL_STATE(2104)] = 99509,
  [SMALL_STATE(2105)] = 99540,
  [SMALL_STATE(2106)] = 99563,
  [SMALL_STATE(2107)] = 99582,
  [SMALL_STATE(2108)] = 99599,
  [SMALL_STATE(2109)] = 99630,
  [SMALL_STATE(2110)] = 99661,
  [SMALL_STATE(2111)] = 99678,
  [SMALL_STATE(2112)] = 99703,
  [SMALL_STATE(2113)] = 99734,
  [SMALL_STATE(2114)] = 99753,
  [SMALL_STATE(2115)] = 99784,
  [SMALL_STATE(2116)] = 99815,
  [SMALL_STATE(2117)] = 99846,
  [SMALL_STATE(2118)] = 99877,
  [SMALL_STATE(2119)] = 99897,
  [SMALL_STATE(2120)] = 99911,
  [SMALL_STATE(2121)] = 99933,
  [SMALL_STATE(2122)] = 99953,
  [SMALL_STATE(2123)] = 99967,
  [SMALL_STATE(2124)] = 99983,
  [SMALL_STATE(2125)] = 99997,
  [SMALL_STATE(2126)] = 100011,
  [SMALL_STATE(2127)] = 100025,
  [SMALL_STATE(2128)] = 100047,
  [SMALL_STATE(2129)] = 100065,
  [SMALL_STATE(2130)] = 100079,
  [SMALL_STATE(2131)] = 100097,
  [SMALL_STATE(2132)] = 100111,
  [SMALL_STATE(2133)] = 100133,
  [SMALL_STATE(2134)] = 100153,
  [SMALL_STATE(2135)] = 100167,
  [SMALL_STATE(2136)] = 100181,
  [SMALL_STATE(2137)] = 100203,
  [SMALL_STATE(2138)] = 100227,
  [SMALL_STATE(2139)] = 100241,
  [SMALL_STATE(2140)] = 100255,
  [SMALL_STATE(2141)] = 100277,
  [SMALL_STATE(2142)] = 100293,
  [SMALL_STATE(2143)] = 100307,
  [SMALL_STATE(2144)] = 100321,
  [SMALL_STATE(2145)] = 100335,
  [SMALL_STATE(2146)] = 100349,
  [SMALL_STATE(2147)] = 100363,
  [SMALL_STATE(2148)] = 100377,
  [SMALL_STATE(2149)] = 100391,
  [SMALL_STATE(2150)] = 100405,
  [SMALL_STATE(2151)] = 100419,
  [SMALL_STATE(2152)] = 100437,
  [SMALL_STATE(2153)] = 100451,
  [SMALL_STATE(2154)] = 100473,
  [SMALL_STATE(2155)] = 100487,
  [SMALL_STATE(2156)] = 100501,
  [SMALL_STATE(2157)] = 100521,
  [SMALL_STATE(2158)] = 100535,
  [SMALL_STATE(2159)] = 100549,
  [SMALL_STATE(2160)] = 100563,
  [SMALL_STATE(2161)] = 100583,
  [SMALL_STATE(2162)] = 100599,
  [SMALL_STATE(2163)] = 100613,
  [SMALL_STATE(2164)] = 100627,
  [SMALL_STATE(2165)] = 100641,
  [SMALL_STATE(2166)] = 100655,
  [SMALL_STATE(2167)] = 100669,
  [SMALL_STATE(2168)] = 100689,
  [SMALL_STATE(2169)] = 100703,
  [SMALL_STATE(2170)] = 100717,
  [SMALL_STATE(2171)] = 100738,
  [SMALL_STATE(2172)] = 100755,
  [SMALL_STATE(2173)] = 100780,
  [SMALL_STATE(2174)] = 100797,
  [SMALL_STATE(2175)] = 100822,
  [SMALL_STATE(2176)] = 100847,
  [SMALL_STATE(2177)] = 100872,
  [SMALL_STATE(2178)] = 100897,
  [SMALL_STATE(2179)] = 100922,
  [SMALL_STATE(2180)] = 100947,
  [SMALL_STATE(2181)] = 100972,
  [SMALL_STATE(2182)] = 100997,
  [SMALL_STATE(2183)] = 101022,
  [SMALL_STATE(2184)] = 101047,
  [SMALL_STATE(2185)] = 101072,
  [SMALL_STATE(2186)] = 101097,
  [SMALL_STATE(2187)] = 101120,
  [SMALL_STATE(2188)] = 101141,
  [SMALL_STATE(2189)] = 101160,
  [SMALL_STATE(2190)] = 101185,
  [SMALL_STATE(2191)] = 101206,
  [SMALL_STATE(2192)] = 101225,
  [SMALL_STATE(2193)] = 101246,
  [SMALL_STATE(2194)] = 101271,
  [SMALL_STATE(2195)] = 101296,
  [SMALL_STATE(2196)] = 101321,
  [SMALL_STATE(2197)] = 101346,
  [SMALL_STATE(2198)] = 101365,
  [SMALL_STATE(2199)] = 101390,
  [SMALL_STATE(2200)] = 101415,
  [SMALL_STATE(2201)] = 101440,
  [SMALL_STATE(2202)] = 101457,
  [SMALL_STATE(2203)] = 101482,
  [SMALL_STATE(2204)] = 101499,
  [SMALL_STATE(2205)] = 101524,
  [SMALL_STATE(2206)] = 101545,
  [SMALL_STATE(2207)] = 101570,
  [SMALL_STATE(2208)] = 101595,
  [SMALL_STATE(2209)] = 101620,
  [SMALL_STATE(2210)] = 101645,
  [SMALL_STATE(2211)] = 101670,
  [SMALL_STATE(2212)] = 101691,
  [SMALL_STATE(2213)] = 101704,
  [SMALL_STATE(2214)] = 101729,
  [SMALL_STATE(2215)] = 101746,
  [SMALL_STATE(2216)] = 101759,
  [SMALL_STATE(2217)] = 101784,
  [SMALL_STATE(2218)] = 101809,
  [SMALL_STATE(2219)] = 101834,
  [SMALL_STATE(2220)] = 101859,
  [SMALL_STATE(2221)] = 101884,
  [SMALL_STATE(2222)] = 101909,
  [SMALL_STATE(2223)] = 101922,
  [SMALL_STATE(2224)] = 101947,
  [SMALL_STATE(2225)] = 101964,
  [SMALL_STATE(2226)] = 101977,
  [SMALL_STATE(2227)] = 101994,
  [SMALL_STATE(2228)] = 102019,
  [SMALL_STATE(2229)] = 102036,
  [SMALL_STATE(2230)] = 102053,
  [SMALL_STATE(2231)] = 102078,
  [SMALL_STATE(2232)] = 102103,
  [SMALL_STATE(2233)] = 102116,
  [SMALL_STATE(2234)] = 102141,
  [SMALL_STATE(2235)] = 102166,
  [SMALL_STATE(2236)] = 102181,
  [SMALL_STATE(2237)] = 102198,
  [SMALL_STATE(2238)] = 102215,
  [SMALL_STATE(2239)] = 102240,
  [SMALL_STATE(2240)] = 102265,
  [SMALL_STATE(2241)] = 102290,
  [SMALL_STATE(2242)] = 102305,
  [SMALL_STATE(2243)] = 102326,
  [SMALL_STATE(2244)] = 102343,
  [SMALL_STATE(2245)] = 102356,
  [SMALL_STATE(2246)] = 102381,
  [SMALL_STATE(2247)] = 102406,
  [SMALL_STATE(2248)] = 102423,
  [SMALL_STATE(2249)] = 102440,
  [SMALL_STATE(2250)] = 102457,
  [SMALL_STATE(2251)] = 102474,
  [SMALL_STATE(2252)] = 102496,
  [SMALL_STATE(2253)] = 102514,
  [SMALL_STATE(2254)] = 102530,
  [SMALL_STATE(2255)] = 102552,
  [SMALL_STATE(2256)] = 102572,
  [SMALL_STATE(2257)] = 102590,
  [SMALL_STATE(2258)] = 102608,
  [SMALL_STATE(2259)] = 102630,
  [SMALL_STATE(2260)] = 102646,
  [SMALL_STATE(2261)] = 102664,
  [SMALL_STATE(2262)] = 102686,
  [SMALL_STATE(2263)] = 102708,
  [SMALL_STATE(2264)] = 102730,
  [SMALL_STATE(2265)] = 102746,
  [SMALL_STATE(2266)] = 102768,
  [SMALL_STATE(2267)] = 102790,
  [SMALL_STATE(2268)] = 102812,
  [SMALL_STATE(2269)] = 102834,
  [SMALL_STATE(2270)] = 102846,
  [SMALL_STATE(2271)] = 102858,
  [SMALL_STATE(2272)] = 102874,
  [SMALL_STATE(2273)] = 102896,
  [SMALL_STATE(2274)] = 102918,
  [SMALL_STATE(2275)] = 102936,
  [SMALL_STATE(2276)] = 102952,
  [SMALL_STATE(2277)] = 102970,
  [SMALL_STATE(2278)] = 102986,
  [SMALL_STATE(2279)] = 103008,
  [SMALL_STATE(2280)] = 103026,
  [SMALL_STATE(2281)] = 103048,
  [SMALL_STATE(2282)] = 103070,
  [SMALL_STATE(2283)] = 103082,
  [SMALL_STATE(2284)] = 103102,
  [SMALL_STATE(2285)] = 103124,
  [SMALL_STATE(2286)] = 103144,
  [SMALL_STATE(2287)] = 103160,
  [SMALL_STATE(2288)] = 103182,
  [SMALL_STATE(2289)] = 103204,
  [SMALL_STATE(2290)] = 103226,
  [SMALL_STATE(2291)] = 103248,
  [SMALL_STATE(2292)] = 103270,
  [SMALL_STATE(2293)] = 103286,
  [SMALL_STATE(2294)] = 103302,
  [SMALL_STATE(2295)] = 103324,
  [SMALL_STATE(2296)] = 103340,
  [SMALL_STATE(2297)] = 103362,
  [SMALL_STATE(2298)] = 103382,
  [SMALL_STATE(2299)] = 103404,
  [SMALL_STATE(2300)] = 103420,
  [SMALL_STATE(2301)] = 103436,
  [SMALL_STATE(2302)] = 103452,
  [SMALL_STATE(2303)] = 103472,
  [SMALL_STATE(2304)] = 103494,
  [SMALL_STATE(2305)] = 103512,
  [SMALL_STATE(2306)] = 103530,
  [SMALL_STATE(2307)] = 103548,
  [SMALL_STATE(2308)] = 103570,
  [SMALL_STATE(2309)] = 103592,
  [SMALL_STATE(2310)] = 103612,
  [SMALL_STATE(2311)] = 103634,
  [SMALL_STATE(2312)] = 103656,
  [SMALL_STATE(2313)] = 103672,
  [SMALL_STATE(2314)] = 103694,
  [SMALL_STATE(2315)] = 103716,
  [SMALL_STATE(2316)] = 103738,
  [SMALL_STATE(2317)] = 103754,
  [SMALL_STATE(2318)] = 103776,
  [SMALL_STATE(2319)] = 103792,
  [SMALL_STATE(2320)] = 103810,
  [SMALL_STATE(2321)] = 103832,
  [SMALL_STATE(2322)] = 103854,
  [SMALL_STATE(2323)] = 103872,
  [SMALL_STATE(2324)] = 103890,
  [SMALL_STATE(2325)] = 103912,
  [SMALL_STATE(2326)] = 103928,
  [SMALL_STATE(2327)] = 103950,
  [SMALL_STATE(2328)] = 103972,
  [SMALL_STATE(2329)] = 103994,
  [SMALL_STATE(2330)] = 104016,
  [SMALL_STATE(2331)] = 104034,
  [SMALL_STATE(2332)] = 104046,
  [SMALL_STATE(2333)] = 104068,
  [SMALL_STATE(2334)] = 104088,
  [SMALL_STATE(2335)] = 104100,
  [SMALL_STATE(2336)] = 104122,
  [SMALL_STATE(2337)] = 104138,
  [SMALL_STATE(2338)] = 104160,
  [SMALL_STATE(2339)] = 104182,
  [SMALL_STATE(2340)] = 104200,
  [SMALL_STATE(2341)] = 104222,
  [SMALL_STATE(2342)] = 104238,
  [SMALL_STATE(2343)] = 104258,
  [SMALL_STATE(2344)] = 104280,
  [SMALL_STATE(2345)] = 104302,
  [SMALL_STATE(2346)] = 104318,
  [SMALL_STATE(2347)] = 104336,
  [SMALL_STATE(2348)] = 104352,
  [SMALL_STATE(2349)] = 104374,
  [SMALL_STATE(2350)] = 104390,
  [SMALL_STATE(2351)] = 104408,
  [SMALL_STATE(2352)] = 104430,
  [SMALL_STATE(2353)] = 104446,
  [SMALL_STATE(2354)] = 104468,
  [SMALL_STATE(2355)] = 104490,
  [SMALL_STATE(2356)] = 104512,
  [SMALL_STATE(2357)] = 104532,
  [SMALL_STATE(2358)] = 104552,
  [SMALL_STATE(2359)] = 104574,
  [SMALL_STATE(2360)] = 104596,
  [SMALL_STATE(2361)] = 104612,
  [SMALL_STATE(2362)] = 104628,
  [SMALL_STATE(2363)] = 104646,
  [SMALL_STATE(2364)] = 104664,
  [SMALL_STATE(2365)] = 104686,
  [SMALL_STATE(2366)] = 104702,
  [SMALL_STATE(2367)] = 104718,
  [SMALL_STATE(2368)] = 104740,
  [SMALL_STATE(2369)] = 104762,
  [SMALL_STATE(2370)] = 104780,
  [SMALL_STATE(2371)] = 104798,
  [SMALL_STATE(2372)] = 104818,
  [SMALL_STATE(2373)] = 104840,
  [SMALL_STATE(2374)] = 104859,
  [SMALL_STATE(2375)] = 104870,
  [SMALL_STATE(2376)] = 104881,
  [SMALL_STATE(2377)] = 104892,
  [SMALL_STATE(2378)] = 104907,
  [SMALL_STATE(2379)] = 104918,
  [SMALL_STATE(2380)] = 104937,
  [SMALL_STATE(2381)] = 104948,
  [SMALL_STATE(2382)] = 104959,
  [SMALL_STATE(2383)] = 104978,
  [SMALL_STATE(2384)] = 104997,
  [SMALL_STATE(2385)] = 105008,
  [SMALL_STATE(2386)] = 105027,
  [SMALL_STATE(2387)] = 105046,
  [SMALL_STATE(2388)] = 105061,
  [SMALL_STATE(2389)] = 105080,
  [SMALL_STATE(2390)] = 105095,
  [SMALL_STATE(2391)] = 105106,
  [SMALL_STATE(2392)] = 105121,
  [SMALL_STATE(2393)] = 105132,
  [SMALL_STATE(2394)] = 105143,
  [SMALL_STATE(2395)] = 105162,
  [SMALL_STATE(2396)] = 105177,
  [SMALL_STATE(2397)] = 105188,
  [SMALL_STATE(2398)] = 105199,
  [SMALL_STATE(2399)] = 105210,
  [SMALL_STATE(2400)] = 105225,
  [SMALL_STATE(2401)] = 105244,
  [SMALL_STATE(2402)] = 105263,
  [SMALL_STATE(2403)] = 105278,
  [SMALL_STATE(2404)] = 105297,
  [SMALL_STATE(2405)] = 105312,
  [SMALL_STATE(2406)] = 105331,
  [SMALL_STATE(2407)] = 105342,
  [SMALL_STATE(2408)] = 105361,
  [SMALL_STATE(2409)] = 105380,
  [SMALL_STATE(2410)] = 105391,
  [SMALL_STATE(2411)] = 105410,
  [SMALL_STATE(2412)] = 105421,
  [SMALL_STATE(2413)] = 105436,
  [SMALL_STATE(2414)] = 105447,
  [SMALL_STATE(2415)] = 105462,
  [SMALL_STATE(2416)] = 105473,
  [SMALL_STATE(2417)] = 105490,
  [SMALL_STATE(2418)] = 105501,
  [SMALL_STATE(2419)] = 105512,
  [SMALL_STATE(2420)] = 105525,
  [SMALL_STATE(2421)] = 105542,
  [SMALL_STATE(2422)] = 105553,
  [SMALL_STATE(2423)] = 105572,
  [SMALL_STATE(2424)] = 105589,
  [SMALL_STATE(2425)] = 105604,
  [SMALL_STATE(2426)] = 105615,
  [SMALL_STATE(2427)] = 105634,
  [SMALL_STATE(2428)] = 105645,
  [SMALL_STATE(2429)] = 105656,
  [SMALL_STATE(2430)] = 105667,
  [SMALL_STATE(2431)] = 105678,
  [SMALL_STATE(2432)] = 105689,
  [SMALL_STATE(2433)] = 105708,
  [SMALL_STATE(2434)] = 105719,
  [SMALL_STATE(2435)] = 105738,
  [SMALL_STATE(2436)] = 105757,
  [SMALL_STATE(2437)] = 105776,
  [SMALL_STATE(2438)] = 105791,
  [SMALL_STATE(2439)] = 105810,
  [SMALL_STATE(2440)] = 105821,
  [SMALL_STATE(2441)] = 105840,
  [SMALL_STATE(2442)] = 105851,
  [SMALL_STATE(2443)] = 105866,
  [SMALL_STATE(2444)] = 105877,
  [SMALL_STATE(2445)] = 105896,
  [SMALL_STATE(2446)] = 105907,
  [SMALL_STATE(2447)] = 105918,
  [SMALL_STATE(2448)] = 105929,
  [SMALL_STATE(2449)] = 105944,
  [SMALL_STATE(2450)] = 105955,
  [SMALL_STATE(2451)] = 105974,
  [SMALL_STATE(2452)] = 105989,
  [SMALL_STATE(2453)] = 106008,
  [SMALL_STATE(2454)] = 106023,
  [SMALL_STATE(2455)] = 106038,
  [SMALL_STATE(2456)] = 106049,
  [SMALL_STATE(2457)] = 106066,
  [SMALL_STATE(2458)] = 106077,
  [SMALL_STATE(2459)] = 106092,
  [SMALL_STATE(2460)] = 106107,
  [SMALL_STATE(2461)] = 106122,
  [SMALL_STATE(2462)] = 106141,
  [SMALL_STATE(2463)] = 106160,
  [SMALL_STATE(2464)] = 106175,
  [SMALL_STATE(2465)] = 106190,
  [SMALL_STATE(2466)] = 106201,
  [SMALL_STATE(2467)] = 106216,
  [SMALL_STATE(2468)] = 106235,
  [SMALL_STATE(2469)] = 106254,
  [SMALL_STATE(2470)] = 106265,
  [SMALL_STATE(2471)] = 106276,
  [SMALL_STATE(2472)] = 106287,
  [SMALL_STATE(2473)] = 106298,
  [SMALL_STATE(2474)] = 106309,
  [SMALL_STATE(2475)] = 106320,
  [SMALL_STATE(2476)] = 106331,
  [SMALL_STATE(2477)] = 106342,
  [SMALL_STATE(2478)] = 106353,
  [SMALL_STATE(2479)] = 106364,
  [SMALL_STATE(2480)] = 106375,
  [SMALL_STATE(2481)] = 106394,
  [SMALL_STATE(2482)] = 106405,
  [SMALL_STATE(2483)] = 106416,
  [SMALL_STATE(2484)] = 106427,
  [SMALL_STATE(2485)] = 106438,
  [SMALL_STATE(2486)] = 106449,
  [SMALL_STATE(2487)] = 106460,
  [SMALL_STATE(2488)] = 106471,
  [SMALL_STATE(2489)] = 106482,
  [SMALL_STATE(2490)] = 106497,
  [SMALL_STATE(2491)] = 106508,
  [SMALL_STATE(2492)] = 106527,
  [SMALL_STATE(2493)] = 106538,
  [SMALL_STATE(2494)] = 106549,
  [SMALL_STATE(2495)] = 106560,
  [SMALL_STATE(2496)] = 106575,
  [SMALL_STATE(2497)] = 106586,
  [SMALL_STATE(2498)] = 106603,
  [SMALL_STATE(2499)] = 106622,
  [SMALL_STATE(2500)] = 106633,
  [SMALL_STATE(2501)] = 106650,
  [SMALL_STATE(2502)] = 106665,
  [SMALL_STATE(2503)] = 106684,
  [SMALL_STATE(2504)] = 106695,
  [SMALL_STATE(2505)] = 106706,
  [SMALL_STATE(2506)] = 106717,
  [SMALL_STATE(2507)] = 106736,
  [SMALL_STATE(2508)] = 106751,
  [SMALL_STATE(2509)] = 106770,
  [SMALL_STATE(2510)] = 106781,
  [SMALL_STATE(2511)] = 106792,
  [SMALL_STATE(2512)] = 106803,
  [SMALL_STATE(2513)] = 106814,
  [SMALL_STATE(2514)] = 106825,
  [SMALL_STATE(2515)] = 106844,
  [SMALL_STATE(2516)] = 106855,
  [SMALL_STATE(2517)] = 106870,
  [SMALL_STATE(2518)] = 106889,
  [SMALL_STATE(2519)] = 106908,
  [SMALL_STATE(2520)] = 106919,
  [SMALL_STATE(2521)] = 106938,
  [SMALL_STATE(2522)] = 106957,
  [SMALL_STATE(2523)] = 106968,
  [SMALL_STATE(2524)] = 106983,
  [SMALL_STATE(2525)] = 107002,
  [SMALL_STATE(2526)] = 107013,
  [SMALL_STATE(2527)] = 107024,
  [SMALL_STATE(2528)] = 107035,
  [SMALL_STATE(2529)] = 107046,
  [SMALL_STATE(2530)] = 107057,
  [SMALL_STATE(2531)] = 107068,
  [SMALL_STATE(2532)] = 107083,
  [SMALL_STATE(2533)] = 107102,
  [SMALL_STATE(2534)] = 107119,
  [SMALL_STATE(2535)] = 107138,
  [SMALL_STATE(2536)] = 107149,
  [SMALL_STATE(2537)] = 107168,
  [SMALL_STATE(2538)] = 107179,
  [SMALL_STATE(2539)] = 107190,
  [SMALL_STATE(2540)] = 107201,
  [SMALL_STATE(2541)] = 107220,
  [SMALL_STATE(2542)] = 107239,
  [SMALL_STATE(2543)] = 107258,
  [SMALL_STATE(2544)] = 107273,
  [SMALL_STATE(2545)] = 107292,
  [SMALL_STATE(2546)] = 107303,
  [SMALL_STATE(2547)] = 107318,
  [SMALL_STATE(2548)] = 107329,
  [SMALL_STATE(2549)] = 107340,
  [SMALL_STATE(2550)] = 107359,
  [SMALL_STATE(2551)] = 107370,
  [SMALL_STATE(2552)] = 107389,
  [SMALL_STATE(2553)] = 107400,
  [SMALL_STATE(2554)] = 107415,
  [SMALL_STATE(2555)] = 107428,
  [SMALL_STATE(2556)] = 107439,
  [SMALL_STATE(2557)] = 107450,
  [SMALL_STATE(2558)] = 107467,
  [SMALL_STATE(2559)] = 107486,
  [SMALL_STATE(2560)] = 107497,
  [SMALL_STATE(2561)] = 107508,
  [SMALL_STATE(2562)] = 107527,
  [SMALL_STATE(2563)] = 107544,
  [SMALL_STATE(2564)] = 107555,
  [SMALL_STATE(2565)] = 107574,
  [SMALL_STATE(2566)] = 107591,
  [SMALL_STATE(2567)] = 107602,
  [SMALL_STATE(2568)] = 107619,
  [SMALL_STATE(2569)] = 107634,
  [SMALL_STATE(2570)] = 107649,
  [SMALL_STATE(2571)] = 107660,
  [SMALL_STATE(2572)] = 107675,
  [SMALL_STATE(2573)] = 107686,
  [SMALL_STATE(2574)] = 107697,
  [SMALL_STATE(2575)] = 107716,
  [SMALL_STATE(2576)] = 107735,
  [SMALL_STATE(2577)] = 107746,
  [SMALL_STATE(2578)] = 107759,
  [SMALL_STATE(2579)] = 107772,
  [SMALL_STATE(2580)] = 107791,
  [SMALL_STATE(2581)] = 107808,
  [SMALL_STATE(2582)] = 107819,
  [SMALL_STATE(2583)] = 107830,
  [SMALL_STATE(2584)] = 107849,
  [SMALL_STATE(2585)] = 107860,
  [SMALL_STATE(2586)] = 107873,
  [SMALL_STATE(2587)] = 107884,
  [SMALL_STATE(2588)] = 107895,
  [SMALL_STATE(2589)] = 107910,
  [SMALL_STATE(2590)] = 107923,
  [SMALL_STATE(2591)] = 107934,
  [SMALL_STATE(2592)] = 107945,
  [SMALL_STATE(2593)] = 107956,
  [SMALL_STATE(2594)] = 107967,
  [SMALL_STATE(2595)] = 107978,
  [SMALL_STATE(2596)] = 107989,
  [SMALL_STATE(2597)] = 108000,
  [SMALL_STATE(2598)] = 108011,
  [SMALL_STATE(2599)] = 108030,
  [SMALL_STATE(2600)] = 108045,
  [SMALL_STATE(2601)] = 108056,
  [SMALL_STATE(2602)] = 108071,
  [SMALL_STATE(2603)] = 108086,
  [SMALL_STATE(2604)] = 108103,
  [SMALL_STATE(2605)] = 108114,
  [SMALL_STATE(2606)] = 108125,
  [SMALL_STATE(2607)] = 108140,
  [SMALL_STATE(2608)] = 108151,
  [SMALL_STATE(2609)] = 108166,
  [SMALL_STATE(2610)] = 108181,
  [SMALL_STATE(2611)] = 108196,
  [SMALL_STATE(2612)] = 108215,
  [SMALL_STATE(2613)] = 108234,
  [SMALL_STATE(2614)] = 108245,
  [SMALL_STATE(2615)] = 108264,
  [SMALL_STATE(2616)] = 108279,
  [SMALL_STATE(2617)] = 108290,
  [SMALL_STATE(2618)] = 108301,
  [SMALL_STATE(2619)] = 108312,
  [SMALL_STATE(2620)] = 108323,
  [SMALL_STATE(2621)] = 108334,
  [SMALL_STATE(2622)] = 108350,
  [SMALL_STATE(2623)] = 108364,
  [SMALL_STATE(2624)] = 108380,
  [SMALL_STATE(2625)] = 108396,
  [SMALL_STATE(2626)] = 108412,
  [SMALL_STATE(2627)] = 108428,
  [SMALL_STATE(2628)] = 108444,
  [SMALL_STATE(2629)] = 108460,
  [SMALL_STATE(2630)] = 108476,
  [SMALL_STATE(2631)] = 108486,
  [SMALL_STATE(2632)] = 108502,
  [SMALL_STATE(2633)] = 108518,
  [SMALL_STATE(2634)] = 108534,
  [SMALL_STATE(2635)] = 108550,
  [SMALL_STATE(2636)] = 108566,
  [SMALL_STATE(2637)] = 108582,
  [SMALL_STATE(2638)] = 108598,
  [SMALL_STATE(2639)] = 108614,
  [SMALL_STATE(2640)] = 108630,
  [SMALL_STATE(2641)] = 108646,
  [SMALL_STATE(2642)] = 108662,
  [SMALL_STATE(2643)] = 108678,
  [SMALL_STATE(2644)] = 108694,
  [SMALL_STATE(2645)] = 108710,
  [SMALL_STATE(2646)] = 108726,
  [SMALL_STATE(2647)] = 108740,
  [SMALL_STATE(2648)] = 108756,
  [SMALL_STATE(2649)] = 108770,
  [SMALL_STATE(2650)] = 108786,
  [SMALL_STATE(2651)] = 108802,
  [SMALL_STATE(2652)] = 108816,
  [SMALL_STATE(2653)] = 108830,
  [SMALL_STATE(2654)] = 108846,
  [SMALL_STATE(2655)] = 108862,
  [SMALL_STATE(2656)] = 108878,
  [SMALL_STATE(2657)] = 108892,
  [SMALL_STATE(2658)] = 108908,
  [SMALL_STATE(2659)] = 108924,
  [SMALL_STATE(2660)] = 108936,
  [SMALL_STATE(2661)] = 108950,
  [SMALL_STATE(2662)] = 108964,
  [SMALL_STATE(2663)] = 108976,
  [SMALL_STATE(2664)] = 108992,
  [SMALL_STATE(2665)] = 109008,
  [SMALL_STATE(2666)] = 109024,
  [SMALL_STATE(2667)] = 109040,
  [SMALL_STATE(2668)] = 109056,
  [SMALL_STATE(2669)] = 109072,
  [SMALL_STATE(2670)] = 109088,
  [SMALL_STATE(2671)] = 109102,
  [SMALL_STATE(2672)] = 109118,
  [SMALL_STATE(2673)] = 109134,
  [SMALL_STATE(2674)] = 109148,
  [SMALL_STATE(2675)] = 109164,
  [SMALL_STATE(2676)] = 109180,
  [SMALL_STATE(2677)] = 109194,
  [SMALL_STATE(2678)] = 109204,
  [SMALL_STATE(2679)] = 109220,
  [SMALL_STATE(2680)] = 109234,
  [SMALL_STATE(2681)] = 109250,
  [SMALL_STATE(2682)] = 109264,
  [SMALL_STATE(2683)] = 109278,
  [SMALL_STATE(2684)] = 109294,
  [SMALL_STATE(2685)] = 109310,
  [SMALL_STATE(2686)] = 109322,
  [SMALL_STATE(2687)] = 109338,
  [SMALL_STATE(2688)] = 109354,
  [SMALL_STATE(2689)] = 109370,
  [SMALL_STATE(2690)] = 109384,
  [SMALL_STATE(2691)] = 109400,
  [SMALL_STATE(2692)] = 109416,
  [SMALL_STATE(2693)] = 109428,
  [SMALL_STATE(2694)] = 109442,
  [SMALL_STATE(2695)] = 109458,
  [SMALL_STATE(2696)] = 109472,
  [SMALL_STATE(2697)] = 109486,
  [SMALL_STATE(2698)] = 109502,
  [SMALL_STATE(2699)] = 109518,
  [SMALL_STATE(2700)] = 109530,
  [SMALL_STATE(2701)] = 109546,
  [SMALL_STATE(2702)] = 109562,
  [SMALL_STATE(2703)] = 109578,
  [SMALL_STATE(2704)] = 109594,
  [SMALL_STATE(2705)] = 109606,
  [SMALL_STATE(2706)] = 109618,
  [SMALL_STATE(2707)] = 109634,
  [SMALL_STATE(2708)] = 109646,
  [SMALL_STATE(2709)] = 109656,
  [SMALL_STATE(2710)] = 109666,
  [SMALL_STATE(2711)] = 109682,
  [SMALL_STATE(2712)] = 109692,
  [SMALL_STATE(2713)] = 109708,
  [SMALL_STATE(2714)] = 109724,
  [SMALL_STATE(2715)] = 109740,
  [SMALL_STATE(2716)] = 109756,
  [SMALL_STATE(2717)] = 109770,
  [SMALL_STATE(2718)] = 109782,
  [SMALL_STATE(2719)] = 109798,
  [SMALL_STATE(2720)] = 109814,
  [SMALL_STATE(2721)] = 109830,
  [SMALL_STATE(2722)] = 109846,
  [SMALL_STATE(2723)] = 109862,
  [SMALL_STATE(2724)] = 109878,
  [SMALL_STATE(2725)] = 109894,
  [SMALL_STATE(2726)] = 109910,
  [SMALL_STATE(2727)] = 109926,
  [SMALL_STATE(2728)] = 109940,
  [SMALL_STATE(2729)] = 109954,
  [SMALL_STATE(2730)] = 109968,
  [SMALL_STATE(2731)] = 109984,
  [SMALL_STATE(2732)] = 109998,
  [SMALL_STATE(2733)] = 110012,
  [SMALL_STATE(2734)] = 110026,
  [SMALL_STATE(2735)] = 110040,
  [SMALL_STATE(2736)] = 110056,
  [SMALL_STATE(2737)] = 110072,
  [SMALL_STATE(2738)] = 110088,
  [SMALL_STATE(2739)] = 110104,
  [SMALL_STATE(2740)] = 110120,
  [SMALL_STATE(2741)] = 110136,
  [SMALL_STATE(2742)] = 110146,
  [SMALL_STATE(2743)] = 110160,
  [SMALL_STATE(2744)] = 110176,
  [SMALL_STATE(2745)] = 110190,
  [SMALL_STATE(2746)] = 110206,
  [SMALL_STATE(2747)] = 110220,
  [SMALL_STATE(2748)] = 110236,
  [SMALL_STATE(2749)] = 110252,
  [SMALL_STATE(2750)] = 110268,
  [SMALL_STATE(2751)] = 110284,
  [SMALL_STATE(2752)] = 110297,
  [SMALL_STATE(2753)] = 110306,
  [SMALL_STATE(2754)] = 110319,
  [SMALL_STATE(2755)] = 110328,
  [SMALL_STATE(2756)] = 110341,
  [SMALL_STATE(2757)] = 110354,
  [SMALL_STATE(2758)] = 110367,
  [SMALL_STATE(2759)] = 110380,
  [SMALL_STATE(2760)] = 110393,
  [SMALL_STATE(2761)] = 110406,
  [SMALL_STATE(2762)] = 110419,
  [SMALL_STATE(2763)] = 110428,
  [SMALL_STATE(2764)] = 110437,
  [SMALL_STATE(2765)] = 110450,
  [SMALL_STATE(2766)] = 110463,
  [SMALL_STATE(2767)] = 110476,
  [SMALL_STATE(2768)] = 110489,
  [SMALL_STATE(2769)] = 110502,
  [SMALL_STATE(2770)] = 110515,
  [SMALL_STATE(2771)] = 110524,
  [SMALL_STATE(2772)] = 110537,
  [SMALL_STATE(2773)] = 110550,
  [SMALL_STATE(2774)] = 110561,
  [SMALL_STATE(2775)] = 110574,
  [SMALL_STATE(2776)] = 110587,
  [SMALL_STATE(2777)] = 110600,
  [SMALL_STATE(2778)] = 110613,
  [SMALL_STATE(2779)] = 110626,
  [SMALL_STATE(2780)] = 110639,
  [SMALL_STATE(2781)] = 110652,
  [SMALL_STATE(2782)] = 110661,
  [SMALL_STATE(2783)] = 110672,
  [SMALL_STATE(2784)] = 110685,
  [SMALL_STATE(2785)] = 110698,
  [SMALL_STATE(2786)] = 110707,
  [SMALL_STATE(2787)] = 110716,
  [SMALL_STATE(2788)] = 110725,
  [SMALL_STATE(2789)] = 110738,
  [SMALL_STATE(2790)] = 110751,
  [SMALL_STATE(2791)] = 110764,
  [SMALL_STATE(2792)] = 110777,
  [SMALL_STATE(2793)] = 110790,
  [SMALL_STATE(2794)] = 110799,
  [SMALL_STATE(2795)] = 110812,
  [SMALL_STATE(2796)] = 110825,
  [SMALL_STATE(2797)] = 110838,
  [SMALL_STATE(2798)] = 110851,
  [SMALL_STATE(2799)] = 110862,
  [SMALL_STATE(2800)] = 110875,
  [SMALL_STATE(2801)] = 110888,
  [SMALL_STATE(2802)] = 110899,
  [SMALL_STATE(2803)] = 110912,
  [SMALL_STATE(2804)] = 110921,
  [SMALL_STATE(2805)] = 110934,
  [SMALL_STATE(2806)] = 110945,
  [SMALL_STATE(2807)] = 110958,
  [SMALL_STATE(2808)] = 110971,
  [SMALL_STATE(2809)] = 110984,
  [SMALL_STATE(2810)] = 110997,
  [SMALL_STATE(2811)] = 111010,
  [SMALL_STATE(2812)] = 111019,
  [SMALL_STATE(2813)] = 111032,
  [SMALL_STATE(2814)] = 111045,
  [SMALL_STATE(2815)] = 111056,
  [SMALL_STATE(2816)] = 111069,
  [SMALL_STATE(2817)] = 111080,
  [SMALL_STATE(2818)] = 111091,
  [SMALL_STATE(2819)] = 111104,
  [SMALL_STATE(2820)] = 111117,
  [SMALL_STATE(2821)] = 111130,
  [SMALL_STATE(2822)] = 111141,
  [SMALL_STATE(2823)] = 111150,
  [SMALL_STATE(2824)] = 111163,
  [SMALL_STATE(2825)] = 111176,
  [SMALL_STATE(2826)] = 111189,
  [SMALL_STATE(2827)] = 111202,
  [SMALL_STATE(2828)] = 111215,
  [SMALL_STATE(2829)] = 111226,
  [SMALL_STATE(2830)] = 111239,
  [SMALL_STATE(2831)] = 111250,
  [SMALL_STATE(2832)] = 111263,
  [SMALL_STATE(2833)] = 111276,
  [SMALL_STATE(2834)] = 111285,
  [SMALL_STATE(2835)] = 111296,
  [SMALL_STATE(2836)] = 111309,
  [SMALL_STATE(2837)] = 111318,
  [SMALL_STATE(2838)] = 111331,
  [SMALL_STATE(2839)] = 111344,
  [SMALL_STATE(2840)] = 111357,
  [SMALL_STATE(2841)] = 111370,
  [SMALL_STATE(2842)] = 111383,
  [SMALL_STATE(2843)] = 111396,
  [SMALL_STATE(2844)] = 111409,
  [SMALL_STATE(2845)] = 111422,
  [SMALL_STATE(2846)] = 111435,
  [SMALL_STATE(2847)] = 111448,
  [SMALL_STATE(2848)] = 111457,
  [SMALL_STATE(2849)] = 111466,
  [SMALL_STATE(2850)] = 111475,
  [SMALL_STATE(2851)] = 111488,
  [SMALL_STATE(2852)] = 111501,
  [SMALL_STATE(2853)] = 111514,
  [SMALL_STATE(2854)] = 111527,
  [SMALL_STATE(2855)] = 111540,
  [SMALL_STATE(2856)] = 111553,
  [SMALL_STATE(2857)] = 111564,
  [SMALL_STATE(2858)] = 111577,
  [SMALL_STATE(2859)] = 111586,
  [SMALL_STATE(2860)] = 111599,
  [SMALL_STATE(2861)] = 111612,
  [SMALL_STATE(2862)] = 111621,
  [SMALL_STATE(2863)] = 111634,
  [SMALL_STATE(2864)] = 111647,
  [SMALL_STATE(2865)] = 111660,
  [SMALL_STATE(2866)] = 111669,
  [SMALL_STATE(2867)] = 111678,
  [SMALL_STATE(2868)] = 111687,
  [SMALL_STATE(2869)] = 111700,
  [SMALL_STATE(2870)] = 111713,
  [SMALL_STATE(2871)] = 111726,
  [SMALL_STATE(2872)] = 111739,
  [SMALL_STATE(2873)] = 111752,
  [SMALL_STATE(2874)] = 111765,
  [SMALL_STATE(2875)] = 111778,
  [SMALL_STATE(2876)] = 111791,
  [SMALL_STATE(2877)] = 111804,
  [SMALL_STATE(2878)] = 111817,
  [SMALL_STATE(2879)] = 111826,
  [SMALL_STATE(2880)] = 111837,
  [SMALL_STATE(2881)] = 111850,
  [SMALL_STATE(2882)] = 111863,
  [SMALL_STATE(2883)] = 111876,
  [SMALL_STATE(2884)] = 111885,
  [SMALL_STATE(2885)] = 111894,
  [SMALL_STATE(2886)] = 111903,
  [SMALL_STATE(2887)] = 111916,
  [SMALL_STATE(2888)] = 111929,
  [SMALL_STATE(2889)] = 111942,
  [SMALL_STATE(2890)] = 111951,
  [SMALL_STATE(2891)] = 111960,
  [SMALL_STATE(2892)] = 111973,
  [SMALL_STATE(2893)] = 111986,
  [SMALL_STATE(2894)] = 111995,
  [SMALL_STATE(2895)] = 112008,
  [SMALL_STATE(2896)] = 112017,
  [SMALL_STATE(2897)] = 112026,
  [SMALL_STATE(2898)] = 112039,
  [SMALL_STATE(2899)] = 112052,
  [SMALL_STATE(2900)] = 112065,
  [SMALL_STATE(2901)] = 112076,
  [SMALL_STATE(2902)] = 112089,
  [SMALL_STATE(2903)] = 112102,
  [SMALL_STATE(2904)] = 112111,
  [SMALL_STATE(2905)] = 112124,
  [SMALL_STATE(2906)] = 112137,
  [SMALL_STATE(2907)] = 112150,
  [SMALL_STATE(2908)] = 112159,
  [SMALL_STATE(2909)] = 112172,
  [SMALL_STATE(2910)] = 112185,
  [SMALL_STATE(2911)] = 112194,
  [SMALL_STATE(2912)] = 112203,
  [SMALL_STATE(2913)] = 112216,
  [SMALL_STATE(2914)] = 112229,
  [SMALL_STATE(2915)] = 112238,
  [SMALL_STATE(2916)] = 112247,
  [SMALL_STATE(2917)] = 112260,
  [SMALL_STATE(2918)] = 112273,
  [SMALL_STATE(2919)] = 112286,
  [SMALL_STATE(2920)] = 112295,
  [SMALL_STATE(2921)] = 112308,
  [SMALL_STATE(2922)] = 112321,
  [SMALL_STATE(2923)] = 112334,
  [SMALL_STATE(2924)] = 112345,
  [SMALL_STATE(2925)] = 112354,
  [SMALL_STATE(2926)] = 112367,
  [SMALL_STATE(2927)] = 112380,
  [SMALL_STATE(2928)] = 112393,
  [SMALL_STATE(2929)] = 112402,
  [SMALL_STATE(2930)] = 112415,
  [SMALL_STATE(2931)] = 112424,
  [SMALL_STATE(2932)] = 112437,
  [SMALL_STATE(2933)] = 112450,
  [SMALL_STATE(2934)] = 112463,
  [SMALL_STATE(2935)] = 112472,
  [SMALL_STATE(2936)] = 112481,
  [SMALL_STATE(2937)] = 112494,
  [SMALL_STATE(2938)] = 112502,
  [SMALL_STATE(2939)] = 112512,
  [SMALL_STATE(2940)] = 112520,
  [SMALL_STATE(2941)] = 112528,
  [SMALL_STATE(2942)] = 112538,
  [SMALL_STATE(2943)] = 112546,
  [SMALL_STATE(2944)] = 112554,
  [SMALL_STATE(2945)] = 112562,
  [SMALL_STATE(2946)] = 112572,
  [SMALL_STATE(2947)] = 112580,
  [SMALL_STATE(2948)] = 112590,
  [SMALL_STATE(2949)] = 112598,
  [SMALL_STATE(2950)] = 112608,
  [SMALL_STATE(2951)] = 112616,
  [SMALL_STATE(2952)] = 112626,
  [SMALL_STATE(2953)] = 112636,
  [SMALL_STATE(2954)] = 112646,
  [SMALL_STATE(2955)] = 112654,
  [SMALL_STATE(2956)] = 112664,
  [SMALL_STATE(2957)] = 112674,
  [SMALL_STATE(2958)] = 112682,
  [SMALL_STATE(2959)] = 112692,
  [SMALL_STATE(2960)] = 112702,
  [SMALL_STATE(2961)] = 112712,
  [SMALL_STATE(2962)] = 112720,
  [SMALL_STATE(2963)] = 112728,
  [SMALL_STATE(2964)] = 112738,
  [SMALL_STATE(2965)] = 112746,
  [SMALL_STATE(2966)] = 112756,
  [SMALL_STATE(2967)] = 112766,
  [SMALL_STATE(2968)] = 112776,
  [SMALL_STATE(2969)] = 112786,
  [SMALL_STATE(2970)] = 112796,
  [SMALL_STATE(2971)] = 112806,
  [SMALL_STATE(2972)] = 112814,
  [SMALL_STATE(2973)] = 112824,
  [SMALL_STATE(2974)] = 112834,
  [SMALL_STATE(2975)] = 112844,
  [SMALL_STATE(2976)] = 112852,
  [SMALL_STATE(2977)] = 112862,
  [SMALL_STATE(2978)] = 112872,
  [SMALL_STATE(2979)] = 112882,
  [SMALL_STATE(2980)] = 112890,
  [SMALL_STATE(2981)] = 112900,
  [SMALL_STATE(2982)] = 112908,
  [SMALL_STATE(2983)] = 112918,
  [SMALL_STATE(2984)] = 112926,
  [SMALL_STATE(2985)] = 112936,
  [SMALL_STATE(2986)] = 112944,
  [SMALL_STATE(2987)] = 112952,
  [SMALL_STATE(2988)] = 112962,
  [SMALL_STATE(2989)] = 112972,
  [SMALL_STATE(2990)] = 112982,
  [SMALL_STATE(2991)] = 112990,
  [SMALL_STATE(2992)] = 113000,
  [SMALL_STATE(2993)] = 113008,
  [SMALL_STATE(2994)] = 113018,
  [SMALL_STATE(2995)] = 113028,
  [SMALL_STATE(2996)] = 113036,
  [SMALL_STATE(2997)] = 113046,
  [SMALL_STATE(2998)] = 113056,
  [SMALL_STATE(2999)] = 113066,
  [SMALL_STATE(3000)] = 113076,
  [SMALL_STATE(3001)] = 113086,
  [SMALL_STATE(3002)] = 113096,
  [SMALL_STATE(3003)] = 113106,
  [SMALL_STATE(3004)] = 113114,
  [SMALL_STATE(3005)] = 113122,
  [SMALL_STATE(3006)] = 113132,
  [SMALL_STATE(3007)] = 113140,
  [SMALL_STATE(3008)] = 113150,
  [SMALL_STATE(3009)] = 113160,
  [SMALL_STATE(3010)] = 113170,
  [SMALL_STATE(3011)] = 113180,
  [SMALL_STATE(3012)] = 113188,
  [SMALL_STATE(3013)] = 113196,
  [SMALL_STATE(3014)] = 113206,
  [SMALL_STATE(3015)] = 113216,
  [SMALL_STATE(3016)] = 113226,
  [SMALL_STATE(3017)] = 113236,
  [SMALL_STATE(3018)] = 113246,
  [SMALL_STATE(3019)] = 113256,
  [SMALL_STATE(3020)] = 113266,
  [SMALL_STATE(3021)] = 113276,
  [SMALL_STATE(3022)] = 113286,
  [SMALL_STATE(3023)] = 113296,
  [SMALL_STATE(3024)] = 113306,
  [SMALL_STATE(3025)] = 113314,
  [SMALL_STATE(3026)] = 113324,
  [SMALL_STATE(3027)] = 113334,
  [SMALL_STATE(3028)] = 113344,
  [SMALL_STATE(3029)] = 113354,
  [SMALL_STATE(3030)] = 113362,
  [SMALL_STATE(3031)] = 113372,
  [SMALL_STATE(3032)] = 113382,
  [SMALL_STATE(3033)] = 113392,
  [SMALL_STATE(3034)] = 113402,
  [SMALL_STATE(3035)] = 113410,
  [SMALL_STATE(3036)] = 113418,
  [SMALL_STATE(3037)] = 113426,
  [SMALL_STATE(3038)] = 113436,
  [SMALL_STATE(3039)] = 113446,
  [SMALL_STATE(3040)] = 113456,
  [SMALL_STATE(3041)] = 113466,
  [SMALL_STATE(3042)] = 113476,
  [SMALL_STATE(3043)] = 113484,
  [SMALL_STATE(3044)] = 113494,
  [SMALL_STATE(3045)] = 113504,
  [SMALL_STATE(3046)] = 113514,
  [SMALL_STATE(3047)] = 113524,
  [SMALL_STATE(3048)] = 113534,
  [SMALL_STATE(3049)] = 113544,
  [SMALL_STATE(3050)] = 113554,
  [SMALL_STATE(3051)] = 113564,
  [SMALL_STATE(3052)] = 113572,
  [SMALL_STATE(3053)] = 113582,
  [SMALL_STATE(3054)] = 113592,
  [SMALL_STATE(3055)] = 113602,
  [SMALL_STATE(3056)] = 113612,
  [SMALL_STATE(3057)] = 113622,
  [SMALL_STATE(3058)] = 113632,
  [SMALL_STATE(3059)] = 113642,
  [SMALL_STATE(3060)] = 113652,
  [SMALL_STATE(3061)] = 113660,
  [SMALL_STATE(3062)] = 113670,
  [SMALL_STATE(3063)] = 113680,
  [SMALL_STATE(3064)] = 113690,
  [SMALL_STATE(3065)] = 113698,
  [SMALL_STATE(3066)] = 113708,
  [SMALL_STATE(3067)] = 113718,
  [SMALL_STATE(3068)] = 113728,
  [SMALL_STATE(3069)] = 113738,
  [SMALL_STATE(3070)] = 113748,
  [SMALL_STATE(3071)] = 113756,
  [SMALL_STATE(3072)] = 113764,
  [SMALL_STATE(3073)] = 113774,
  [SMALL_STATE(3074)] = 113784,
  [SMALL_STATE(3075)] = 113794,
  [SMALL_STATE(3076)] = 113804,
  [SMALL_STATE(3077)] = 113814,
  [SMALL_STATE(3078)] = 113824,
  [SMALL_STATE(3079)] = 113834,
  [SMALL_STATE(3080)] = 113842,
  [SMALL_STATE(3081)] = 113852,
  [SMALL_STATE(3082)] = 113862,
  [SMALL_STATE(3083)] = 113872,
  [SMALL_STATE(3084)] = 113882,
  [SMALL_STATE(3085)] = 113892,
  [SMALL_STATE(3086)] = 113902,
  [SMALL_STATE(3087)] = 113912,
  [SMALL_STATE(3088)] = 113920,
  [SMALL_STATE(3089)] = 113930,
  [SMALL_STATE(3090)] = 113938,
  [SMALL_STATE(3091)] = 113946,
  [SMALL_STATE(3092)] = 113956,
  [SMALL_STATE(3093)] = 113966,
  [SMALL_STATE(3094)] = 113974,
  [SMALL_STATE(3095)] = 113984,
  [SMALL_STATE(3096)] = 113994,
  [SMALL_STATE(3097)] = 114002,
  [SMALL_STATE(3098)] = 114010,
  [SMALL_STATE(3099)] = 114020,
  [SMALL_STATE(3100)] = 114030,
  [SMALL_STATE(3101)] = 114040,
  [SMALL_STATE(3102)] = 114050,
  [SMALL_STATE(3103)] = 114060,
  [SMALL_STATE(3104)] = 114070,
  [SMALL_STATE(3105)] = 114080,
  [SMALL_STATE(3106)] = 114090,
  [SMALL_STATE(3107)] = 114100,
  [SMALL_STATE(3108)] = 114110,
  [SMALL_STATE(3109)] = 114120,
  [SMALL_STATE(3110)] = 114128,
  [SMALL_STATE(3111)] = 114138,
  [SMALL_STATE(3112)] = 114148,
  [SMALL_STATE(3113)] = 114158,
  [SMALL_STATE(3114)] = 114168,
  [SMALL_STATE(3115)] = 114178,
  [SMALL_STATE(3116)] = 114188,
  [SMALL_STATE(3117)] = 114198,
  [SMALL_STATE(3118)] = 114208,
  [SMALL_STATE(3119)] = 114216,
  [SMALL_STATE(3120)] = 114224,
  [SMALL_STATE(3121)] = 114234,
  [SMALL_STATE(3122)] = 114242,
  [SMALL_STATE(3123)] = 114252,
  [SMALL_STATE(3124)] = 114262,
  [SMALL_STATE(3125)] = 114272,
  [SMALL_STATE(3126)] = 114280,
  [SMALL_STATE(3127)] = 114290,
  [SMALL_STATE(3128)] = 114300,
  [SMALL_STATE(3129)] = 114308,
  [SMALL_STATE(3130)] = 114318,
  [SMALL_STATE(3131)] = 114328,
  [SMALL_STATE(3132)] = 114338,
  [SMALL_STATE(3133)] = 114348,
  [SMALL_STATE(3134)] = 114358,
  [SMALL_STATE(3135)] = 114368,
  [SMALL_STATE(3136)] = 114378,
  [SMALL_STATE(3137)] = 114386,
  [SMALL_STATE(3138)] = 114396,
  [SMALL_STATE(3139)] = 114404,
  [SMALL_STATE(3140)] = 114414,
  [SMALL_STATE(3141)] = 114424,
  [SMALL_STATE(3142)] = 114434,
  [SMALL_STATE(3143)] = 114444,
  [SMALL_STATE(3144)] = 114454,
  [SMALL_STATE(3145)] = 114464,
  [SMALL_STATE(3146)] = 114472,
  [SMALL_STATE(3147)] = 114482,
  [SMALL_STATE(3148)] = 114492,
  [SMALL_STATE(3149)] = 114502,
  [SMALL_STATE(3150)] = 114512,
  [SMALL_STATE(3151)] = 114522,
  [SMALL_STATE(3152)] = 114532,
  [SMALL_STATE(3153)] = 114542,
  [SMALL_STATE(3154)] = 114552,
  [SMALL_STATE(3155)] = 114562,
  [SMALL_STATE(3156)] = 114572,
  [SMALL_STATE(3157)] = 114582,
  [SMALL_STATE(3158)] = 114592,
  [SMALL_STATE(3159)] = 114602,
  [SMALL_STATE(3160)] = 114609,
  [SMALL_STATE(3161)] = 114616,
  [SMALL_STATE(3162)] = 114623,
  [SMALL_STATE(3163)] = 114630,
  [SMALL_STATE(3164)] = 114637,
  [SMALL_STATE(3165)] = 114644,
  [SMALL_STATE(3166)] = 114651,
  [SMALL_STATE(3167)] = 114658,
  [SMALL_STATE(3168)] = 114665,
  [SMALL_STATE(3169)] = 114672,
  [SMALL_STATE(3170)] = 114679,
  [SMALL_STATE(3171)] = 114686,
  [SMALL_STATE(3172)] = 114693,
  [SMALL_STATE(3173)] = 114700,
  [SMALL_STATE(3174)] = 114707,
  [SMALL_STATE(3175)] = 114714,
  [SMALL_STATE(3176)] = 114721,
  [SMALL_STATE(3177)] = 114728,
  [SMALL_STATE(3178)] = 114735,
  [SMALL_STATE(3179)] = 114742,
  [SMALL_STATE(3180)] = 114749,
  [SMALL_STATE(3181)] = 114756,
  [SMALL_STATE(3182)] = 114763,
  [SMALL_STATE(3183)] = 114770,
  [SMALL_STATE(3184)] = 114777,
  [SMALL_STATE(3185)] = 114784,
  [SMALL_STATE(3186)] = 114791,
  [SMALL_STATE(3187)] = 114798,
  [SMALL_STATE(3188)] = 114805,
  [SMALL_STATE(3189)] = 114812,
  [SMALL_STATE(3190)] = 114819,
  [SMALL_STATE(3191)] = 114826,
  [SMALL_STATE(3192)] = 114833,
  [SMALL_STATE(3193)] = 114840,
  [SMALL_STATE(3194)] = 114847,
  [SMALL_STATE(3195)] = 114854,
  [SMALL_STATE(3196)] = 114861,
  [SMALL_STATE(3197)] = 114868,
  [SMALL_STATE(3198)] = 114875,
  [SMALL_STATE(3199)] = 114882,
  [SMALL_STATE(3200)] = 114889,
  [SMALL_STATE(3201)] = 114896,
  [SMALL_STATE(3202)] = 114903,
  [SMALL_STATE(3203)] = 114910,
  [SMALL_STATE(3204)] = 114917,
  [SMALL_STATE(3205)] = 114924,
  [SMALL_STATE(3206)] = 114931,
  [SMALL_STATE(3207)] = 114938,
  [SMALL_STATE(3208)] = 114945,
  [SMALL_STATE(3209)] = 114952,
  [SMALL_STATE(3210)] = 114959,
  [SMALL_STATE(3211)] = 114966,
  [SMALL_STATE(3212)] = 114973,
  [SMALL_STATE(3213)] = 114980,
  [SMALL_STATE(3214)] = 114987,
  [SMALL_STATE(3215)] = 114994,
  [SMALL_STATE(3216)] = 115001,
  [SMALL_STATE(3217)] = 115008,
  [SMALL_STATE(3218)] = 115015,
  [SMALL_STATE(3219)] = 115022,
  [SMALL_STATE(3220)] = 115029,
  [SMALL_STATE(3221)] = 115036,
  [SMALL_STATE(3222)] = 115043,
  [SMALL_STATE(3223)] = 115050,
  [SMALL_STATE(3224)] = 115057,
  [SMALL_STATE(3225)] = 115064,
  [SMALL_STATE(3226)] = 115071,
  [SMALL_STATE(3227)] = 115078,
  [SMALL_STATE(3228)] = 115085,
  [SMALL_STATE(3229)] = 115092,
  [SMALL_STATE(3230)] = 115099,
  [SMALL_STATE(3231)] = 115106,
  [SMALL_STATE(3232)] = 115113,
  [SMALL_STATE(3233)] = 115120,
  [SMALL_STATE(3234)] = 115127,
  [SMALL_STATE(3235)] = 115134,
  [SMALL_STATE(3236)] = 115141,
  [SMALL_STATE(3237)] = 115148,
  [SMALL_STATE(3238)] = 115155,
  [SMALL_STATE(3239)] = 115162,
  [SMALL_STATE(3240)] = 115169,
  [SMALL_STATE(3241)] = 115176,
  [SMALL_STATE(3242)] = 115183,
  [SMALL_STATE(3243)] = 115190,
  [SMALL_STATE(3244)] = 115197,
  [SMALL_STATE(3245)] = 115204,
  [SMALL_STATE(3246)] = 115211,
  [SMALL_STATE(3247)] = 115218,
  [SMALL_STATE(3248)] = 115225,
  [SMALL_STATE(3249)] = 115232,
  [SMALL_STATE(3250)] = 115239,
  [SMALL_STATE(3251)] = 115246,
  [SMALL_STATE(3252)] = 115253,
  [SMALL_STATE(3253)] = 115260,
  [SMALL_STATE(3254)] = 115267,
  [SMALL_STATE(3255)] = 115274,
  [SMALL_STATE(3256)] = 115281,
  [SMALL_STATE(3257)] = 115288,
  [SMALL_STATE(3258)] = 115295,
  [SMALL_STATE(3259)] = 115302,
  [SMALL_STATE(3260)] = 115309,
  [SMALL_STATE(3261)] = 115316,
  [SMALL_STATE(3262)] = 115323,
  [SMALL_STATE(3263)] = 115330,
  [SMALL_STATE(3264)] = 115337,
  [SMALL_STATE(3265)] = 115344,
  [SMALL_STATE(3266)] = 115351,
  [SMALL_STATE(3267)] = 115358,
  [SMALL_STATE(3268)] = 115365,
  [SMALL_STATE(3269)] = 115372,
  [SMALL_STATE(3270)] = 115379,
  [SMALL_STATE(3271)] = 115386,
  [SMALL_STATE(3272)] = 115393,
  [SMALL_STATE(3273)] = 115400,
  [SMALL_STATE(3274)] = 115407,
  [SMALL_STATE(3275)] = 115414,
  [SMALL_STATE(3276)] = 115421,
  [SMALL_STATE(3277)] = 115428,
  [SMALL_STATE(3278)] = 115435,
  [SMALL_STATE(3279)] = 115442,
  [SMALL_STATE(3280)] = 115449,
  [SMALL_STATE(3281)] = 115456,
  [SMALL_STATE(3282)] = 115463,
  [SMALL_STATE(3283)] = 115470,
  [SMALL_STATE(3284)] = 115477,
  [SMALL_STATE(3285)] = 115484,
  [SMALL_STATE(3286)] = 115491,
  [SMALL_STATE(3287)] = 115498,
  [SMALL_STATE(3288)] = 115505,
  [SMALL_STATE(3289)] = 115512,
  [SMALL_STATE(3290)] = 115519,
  [SMALL_STATE(3291)] = 115526,
  [SMALL_STATE(3292)] = 115533,
  [SMALL_STATE(3293)] = 115540,
  [SMALL_STATE(3294)] = 115547,
  [SMALL_STATE(3295)] = 115554,
  [SMALL_STATE(3296)] = 115561,
  [SMALL_STATE(3297)] = 115568,
  [SMALL_STATE(3298)] = 115575,
  [SMALL_STATE(3299)] = 115582,
  [SMALL_STATE(3300)] = 115589,
  [SMALL_STATE(3301)] = 115596,
  [SMALL_STATE(3302)] = 115603,
  [SMALL_STATE(3303)] = 115610,
  [SMALL_STATE(3304)] = 115617,
  [SMALL_STATE(3305)] = 115624,
  [SMALL_STATE(3306)] = 115631,
  [SMALL_STATE(3307)] = 115638,
  [SMALL_STATE(3308)] = 115645,
  [SMALL_STATE(3309)] = 115652,
  [SMALL_STATE(3310)] = 115659,
  [SMALL_STATE(3311)] = 115666,
  [SMALL_STATE(3312)] = 115673,
  [SMALL_STATE(3313)] = 115680,
  [SMALL_STATE(3314)] = 115687,
  [SMALL_STATE(3315)] = 115694,
  [SMALL_STATE(3316)] = 115701,
  [SMALL_STATE(3317)] = 115708,
  [SMALL_STATE(3318)] = 115715,
  [SMALL_STATE(3319)] = 115722,
  [SMALL_STATE(3320)] = 115729,
  [SMALL_STATE(3321)] = 115736,
  [SMALL_STATE(3322)] = 115743,
  [SMALL_STATE(3323)] = 115750,
  [SMALL_STATE(3324)] = 115757,
  [SMALL_STATE(3325)] = 115764,
  [SMALL_STATE(3326)] = 115771,
  [SMALL_STATE(3327)] = 115778,
  [SMALL_STATE(3328)] = 115785,
  [SMALL_STATE(3329)] = 115792,
  [SMALL_STATE(3330)] = 115799,
  [SMALL_STATE(3331)] = 115806,
  [SMALL_STATE(3332)] = 115813,
  [SMALL_STATE(3333)] = 115820,
  [SMALL_STATE(3334)] = 115827,
  [SMALL_STATE(3335)] = 115834,
  [SMALL_STATE(3336)] = 115841,
  [SMALL_STATE(3337)] = 115848,
  [SMALL_STATE(3338)] = 115855,
  [SMALL_STATE(3339)] = 115862,
  [SMALL_STATE(3340)] = 115869,
  [SMALL_STATE(3341)] = 115876,
  [SMALL_STATE(3342)] = 115883,
  [SMALL_STATE(3343)] = 115890,
  [SMALL_STATE(3344)] = 115897,
  [SMALL_STATE(3345)] = 115904,
  [SMALL_STATE(3346)] = 115911,
  [SMALL_STATE(3347)] = 115918,
  [SMALL_STATE(3348)] = 115925,
  [SMALL_STATE(3349)] = 115932,
  [SMALL_STATE(3350)] = 115939,
  [SMALL_STATE(3351)] = 115946,
  [SMALL_STATE(3352)] = 115953,
  [SMALL_STATE(3353)] = 115960,
  [SMALL_STATE(3354)] = 115967,
  [SMALL_STATE(3355)] = 115974,
  [SMALL_STATE(3356)] = 115981,
  [SMALL_STATE(3357)] = 115988,
  [SMALL_STATE(3358)] = 115995,
  [SMALL_STATE(3359)] = 116002,
  [SMALL_STATE(3360)] = 116009,
  [SMALL_STATE(3361)] = 116016,
  [SMALL_STATE(3362)] = 116023,
  [SMALL_STATE(3363)] = 116030,
  [SMALL_STATE(3364)] = 116037,
  [SMALL_STATE(3365)] = 116044,
  [SMALL_STATE(3366)] = 116051,
  [SMALL_STATE(3367)] = 116058,
  [SMALL_STATE(3368)] = 116065,
  [SMALL_STATE(3369)] = 116072,
  [SMALL_STATE(3370)] = 116079,
  [SMALL_STATE(3371)] = 116086,
  [SMALL_STATE(3372)] = 116093,
  [SMALL_STATE(3373)] = 116100,
  [SMALL_STATE(3374)] = 116107,
  [SMALL_STATE(3375)] = 116114,
  [SMALL_STATE(3376)] = 116121,
  [SMALL_STATE(3377)] = 116128,
  [SMALL_STATE(3378)] = 116135,
  [SMALL_STATE(3379)] = 116142,
  [SMALL_STATE(3380)] = 116149,
  [SMALL_STATE(3381)] = 116156,
  [SMALL_STATE(3382)] = 116163,
  [SMALL_STATE(3383)] = 116170,
  [SMALL_STATE(3384)] = 116177,
  [SMALL_STATE(3385)] = 116184,
  [SMALL_STATE(3386)] = 116191,
  [SMALL_STATE(3387)] = 116198,
  [SMALL_STATE(3388)] = 116205,
  [SMALL_STATE(3389)] = 116212,
  [SMALL_STATE(3390)] = 116219,
  [SMALL_STATE(3391)] = 116226,
  [SMALL_STATE(3392)] = 116233,
  [SMALL_STATE(3393)] = 116240,
  [SMALL_STATE(3394)] = 116247,
  [SMALL_STATE(3395)] = 116254,
};

static TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, SHIFT_EXTRA(),
  [5] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 0),
  [7] = {.entry = {.count = 1, .reusable = false}}, SHIFT(773),
  [9] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15),
  [11] = {.entry = {.count = 1, .reusable = false}}, SHIFT(146),
  [13] = {.entry = {.count = 1, .reusable = false}}, SHIFT(648),
  [15] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5),
  [17] = {.entry = {.count = 1, .reusable = false}}, SHIFT(720),
  [19] = {.entry = {.count = 1, .reusable = false}}, SHIFT(311),
  [21] = {.entry = {.count = 1, .reusable = false}}, SHIFT(989),
  [23] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2344),
  [25] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2364),
  [27] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2174),
  [29] = {.entry = {.count = 1, .reusable = true}}, SHIFT(319),
  [31] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3115),
  [33] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3113),
  [35] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2795),
  [37] = {.entry = {.count = 1, .reusable = true}}, SHIFT(113),
  [39] = {.entry = {.count = 1, .reusable = false}}, SHIFT(354),
  [41] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3108),
  [43] = {.entry = {.count = 1, .reusable = false}}, SHIFT(32),
  [45] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3105),
  [47] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3104),
  [49] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2801),
  [51] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2805),
  [53] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3097),
  [55] = {.entry = {.count = 1, .reusable = false}}, SHIFT(156),
  [57] = {.entry = {.count = 1, .reusable = false}}, SHIFT(251),
  [59] = {.entry = {.count = 1, .reusable = true}}, SHIFT(530),
  [61] = {.entry = {.count = 1, .reusable = false}}, SHIFT(61),
  [63] = {.entry = {.count = 1, .reusable = true}}, SHIFT(142),
  [65] = {.entry = {.count = 1, .reusable = true}}, SHIFT(730),
  [67] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3378),
  [69] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2076),
  [71] = {.entry = {.count = 1, .reusable = false}}, SHIFT(476),
  [73] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2180),
  [75] = {.entry = {.count = 1, .reusable = false}}, SHIFT(249),
  [77] = {.entry = {.count = 1, .reusable = false}}, SHIFT(291),
  [79] = {.entry = {.count = 1, .reusable = true}}, SHIFT(307),
  [81] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2721),
  [83] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2641),
  [85] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2257),
  [87] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1528),
  [89] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1528),
  [91] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2827),
  [93] = {.entry = {.count = 1, .reusable = false}}, SHIFT(772),
  [95] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3370),
  [97] = {.entry = {.count = 1, .reusable = false}}, SHIFT(153),
  [99] = {.entry = {.count = 1, .reusable = false}}, SHIFT(647),
  [101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3369),
  [103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3368),
  [105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(701),
  [107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(119),
  [109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1926),
  [111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(642),
  [113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1715),
  [115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1354),
  [117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(672),
  [119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(134),
  [121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(210),
  [123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(262),
  [125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1582),
  [127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(458),
  [129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(454),
  [131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(135),
  [133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(469),
  [135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(638),
  [137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(692),
  [139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(456),
  [141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(689),
  [143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(121),
  [145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(637),
  [147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1027),
  [149] = {.entry = {.count = 1, .reusable = false}}, SHIFT(675),
  [151] = {.entry = {.count = 1, .reusable = false}}, SHIFT(256),
  [153] = {.entry = {.count = 1, .reusable = false}}, SHIFT(451),
  [155] = {.entry = {.count = 1, .reusable = false}}, SHIFT(459),
  [157] = {.entry = {.count = 1, .reusable = false}}, SHIFT(127),
  [159] = {.entry = {.count = 1, .reusable = false}}, SHIFT(468),
  [161] = {.entry = {.count = 1, .reusable = false}}, SHIFT(641),
  [163] = {.entry = {.count = 1, .reusable = false}}, SHIFT(695),
  [165] = {.entry = {.count = 1, .reusable = false}}, SHIFT(452),
  [167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1293),
  [169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(69),
  [171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(700),
  [173] = {.entry = {.count = 1, .reusable = false}}, SHIFT(120),
  [175] = {.entry = {.count = 1, .reusable = false}}, SHIFT(643),
  [177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1389),
  [179] = {.entry = {.count = 1, .reusable = false}}, SHIFT(687),
  [181] = {.entry = {.count = 1, .reusable = false}}, SHIFT(211),
  [183] = {.entry = {.count = 1, .reusable = false}}, SHIFT(457),
  [185] = {.entry = {.count = 1, .reusable = false}}, SHIFT(455),
  [187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(133),
  [189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(471),
  [191] = {.entry = {.count = 1, .reusable = false}}, SHIFT(639),
  [193] = {.entry = {.count = 1, .reusable = false}}, SHIFT(696),
  [195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(453),
  [197] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2),
  [199] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(773),
  [202] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(146),
  [205] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2),
  [207] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(648),
  [210] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(5),
  [213] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(720),
  [216] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(311),
  [219] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(989),
  [222] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2344),
  [225] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2364),
  [228] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2174),
  [231] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(319),
  [234] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3115),
  [237] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3113),
  [240] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2795),
  [243] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(113),
  [246] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(354),
  [249] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3108),
  [252] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(32),
  [255] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3105),
  [258] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3104),
  [261] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2801),
  [264] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2805),
  [267] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3097),
  [270] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(156),
  [273] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(251),
  [276] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(530),
  [279] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(61),
  [282] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(142),
  [285] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(730),
  [288] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3378),
  [291] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2076),
  [294] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(476),
  [297] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2180),
  [300] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(249),
  [303] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(291),
  [306] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(307),
  [309] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2721),
  [312] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2641),
  [315] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2257),
  [318] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1528),
  [321] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1528),
  [324] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2827),
  [327] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(772),
  [330] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3370),
  [333] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(153),
  [336] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(647),
  [339] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3369),
  [342] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3368),
  [345] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_default, 3),
  [347] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_default, 3),
  [349] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_case, 3, .production_id = 80),
  [351] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_case, 3, .production_id = 80),
  [353] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_default, 2),
  [355] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_default, 2),
  [357] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_case, 4, .production_id = 80),
  [359] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_case, 4, .production_id = 80),
  [361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1341),
  [363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(483),
  [365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(500),
  [367] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 1),
  [369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(488),
  [371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1889),
  [373] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 2),
  [375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(511),
  [377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(79),
  [379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1558),
  [381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1079),
  [383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1085),
  [385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(94),
  [387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1306),
  [389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1571),
  [391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1882),
  [393] = {.entry = {.count = 1, .reusable = false}}, SHIFT(902),
  [395] = {.entry = {.count = 1, .reusable = false}}, SHIFT(148),
  [397] = {.entry = {.count = 1, .reusable = false}}, SHIFT(654),
  [399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4),
  [401] = {.entry = {.count = 1, .reusable = false}}, SHIFT(718),
  [403] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2984),
  [405] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2892),
  [407] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2987),
  [409] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2988),
  [411] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2074),
  [413] = {.entry = {.count = 1, .reusable = false}}, SHIFT(481),
  [415] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2196),
  [417] = {.entry = {.count = 1, .reusable = false}}, SHIFT(829),
  [419] = {.entry = {.count = 1, .reusable = false}}, SHIFT(152),
  [421] = {.entry = {.count = 1, .reusable = false}}, SHIFT(650),
  [423] = {.entry = {.count = 1, .reusable = false}}, SHIFT(723),
  [425] = {.entry = {.count = 1, .reusable = false}}, SHIFT(939),
  [427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(438),
  [429] = {.entry = {.count = 1, .reusable = false}}, SHIFT(656),
  [431] = {.entry = {.count = 1, .reusable = false}}, SHIFT(741),
  [433] = {.entry = {.count = 1, .reusable = false}}, SHIFT(163),
  [435] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1240),
  [437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(306),
  [439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(49),
  [441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2907),
  [443] = {.entry = {.count = 1, .reusable = false}}, SHIFT(309),
  [445] = {.entry = {.count = 1, .reusable = false}}, SHIFT(60),
  [447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(103),
  [449] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3224),
  [451] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2078),
  [453] = {.entry = {.count = 1, .reusable = false}}, SHIFT(490),
  [455] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2227),
  [457] = {.entry = {.count = 1, .reusable = false}}, SHIFT(228),
  [459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3315),
  [461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(794),
  [463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(797),
  [465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(798),
  [467] = {.entry = {.count = 1, .reusable = false}}, SHIFT(263),
  [469] = {.entry = {.count = 1, .reusable = false}}, SHIFT(125),
  [471] = {.entry = {.count = 1, .reusable = false}}, SHIFT(303),
  [473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(360),
  [475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2739),
  [477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2738),
  [479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2330),
  [481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1614),
  [483] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1402),
  [485] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1212),
  [487] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1614),
  [489] = {.entry = {.count = 1, .reusable = false}}, SHIFT(517),
  [491] = {.entry = {.count = 1, .reusable = false}}, SHIFT(907),
  [493] = {.entry = {.count = 1, .reusable = false}}, SHIFT(59),
  [495] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3299),
  [497] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2357),
  [499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(995),
  [501] = {.entry = {.count = 1, .reusable = false}}, SHIFT(680),
  [503] = {.entry = {.count = 1, .reusable = false}}, SHIFT(739),
  [505] = {.entry = {.count = 1, .reusable = false}}, SHIFT(644),
  [507] = {.entry = {.count = 1, .reusable = false}}, SHIFT(710),
  [509] = {.entry = {.count = 1, .reusable = false}}, SHIFT(166),
  [511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(104),
  [513] = {.entry = {.count = 1, .reusable = false}}, SHIFT(472),
  [515] = {.entry = {.count = 1, .reusable = false}}, SHIFT(396),
  [517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1115),
  [519] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1117),
  [521] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1115),
  [523] = {.entry = {.count = 1, .reusable = false}}, SHIFT(690),
  [525] = {.entry = {.count = 1, .reusable = false}}, SHIFT(66),
  [527] = {.entry = {.count = 1, .reusable = false}}, SHIFT(709),
  [529] = {.entry = {.count = 1, .reusable = false}}, SHIFT(950),
  [531] = {.entry = {.count = 1, .reusable = false}}, SHIFT(664),
  [533] = {.entry = {.count = 1, .reusable = false}}, SHIFT(742),
  [535] = {.entry = {.count = 1, .reusable = false}}, SHIFT(164),
  [537] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1660),
  [539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(333),
  [541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(48),
  [543] = {.entry = {.count = 1, .reusable = false}}, SHIFT(329),
  [545] = {.entry = {.count = 1, .reusable = false}}, SHIFT(64),
  [547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(105),
  [549] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2069),
  [551] = {.entry = {.count = 1, .reusable = false}}, SHIFT(510),
  [553] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2198),
  [555] = {.entry = {.count = 1, .reusable = false}}, SHIFT(197),
  [557] = {.entry = {.count = 1, .reusable = false}}, SHIFT(330),
  [559] = {.entry = {.count = 1, .reusable = false}}, SHIFT(129),
  [561] = {.entry = {.count = 1, .reusable = false}}, SHIFT(334),
  [563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(320),
  [565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1538),
  [567] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1615),
  [569] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1538),
  [571] = {.entry = {.count = 1, .reusable = false}}, SHIFT(867),
  [573] = {.entry = {.count = 1, .reusable = false}}, SHIFT(87),
  [575] = {.entry = {.count = 1, .reusable = false}}, SHIFT(684),
  [577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2026),
  [579] = {.entry = {.count = 1, .reusable = false}}, SHIFT(708),
  [581] = {.entry = {.count = 1, .reusable = false}}, SHIFT(157),
  [583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(50),
  [585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(108),
  [587] = {.entry = {.count = 1, .reusable = false}}, SHIFT(231),
  [589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(924),
  [591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(909),
  [593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(780),
  [595] = {.entry = {.count = 1, .reusable = false}}, SHIFT(356),
  [597] = {.entry = {.count = 1, .reusable = false}}, SHIFT(118),
  [599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1254),
  [601] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1312),
  [603] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1254),
  [605] = {.entry = {.count = 1, .reusable = false}}, SHIFT(702),
  [607] = {.entry = {.count = 1, .reusable = false}}, SHIFT(89),
  [609] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3322),
  [611] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2297),
  [613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(998),
  [615] = {.entry = {.count = 1, .reusable = false}}, SHIFT(753),
  [617] = {.entry = {.count = 1, .reusable = false}}, SHIFT(957),
  [619] = {.entry = {.count = 1, .reusable = false}}, SHIFT(662),
  [621] = {.entry = {.count = 1, .reusable = false}}, SHIFT(158),
  [623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(406),
  [625] = {.entry = {.count = 1, .reusable = false}}, SHIFT(404),
  [627] = {.entry = {.count = 1, .reusable = false}}, SHIFT(63),
  [629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(101),
  [631] = {.entry = {.count = 1, .reusable = false}}, SHIFT(503),
  [633] = {.entry = {.count = 1, .reusable = false}}, SHIFT(224),
  [635] = {.entry = {.count = 1, .reusable = false}}, SHIFT(375),
  [637] = {.entry = {.count = 1, .reusable = false}}, SHIFT(141),
  [639] = {.entry = {.count = 1, .reusable = false}}, SHIFT(407),
  [641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(413),
  [643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1638),
  [645] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1633),
  [647] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1638),
  [649] = {.entry = {.count = 1, .reusable = false}}, SHIFT(806),
  [651] = {.entry = {.count = 1, .reusable = false}}, SHIFT(72),
  [653] = {.entry = {.count = 1, .reusable = false}}, SHIFT(726),
  [655] = {.entry = {.count = 1, .reusable = false}}, SHIFT(944),
  [657] = {.entry = {.count = 1, .reusable = false}}, SHIFT(655),
  [659] = {.entry = {.count = 1, .reusable = false}}, SHIFT(721),
  [661] = {.entry = {.count = 1, .reusable = false}}, SHIFT(162),
  [663] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1694),
  [665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(388),
  [667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(51),
  [669] = {.entry = {.count = 1, .reusable = false}}, SHIFT(385),
  [671] = {.entry = {.count = 1, .reusable = false}}, SHIFT(62),
  [673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(102),
  [675] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3192),
  [677] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2064),
  [679] = {.entry = {.count = 1, .reusable = false}}, SHIFT(486),
  [681] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2206),
  [683] = {.entry = {.count = 1, .reusable = false}}, SHIFT(209),
  [685] = {.entry = {.count = 1, .reusable = false}}, SHIFT(264),
  [687] = {.entry = {.count = 1, .reusable = false}}, SHIFT(131),
  [689] = {.entry = {.count = 1, .reusable = false}}, SHIFT(395),
  [691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(267),
  [693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2664),
  [695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2663),
  [697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2256),
  [699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1575),
  [701] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1649),
  [703] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1724),
  [705] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1575),
  [707] = {.entry = {.count = 1, .reusable = false}}, SHIFT(917),
  [709] = {.entry = {.count = 1, .reusable = false}}, SHIFT(99),
  [711] = {.entry = {.count = 1, .reusable = false}}, SHIFT(746),
  [713] = {.entry = {.count = 1, .reusable = false}}, SHIFT(934),
  [715] = {.entry = {.count = 1, .reusable = false}}, SHIFT(659),
  [717] = {.entry = {.count = 1, .reusable = false}}, SHIFT(161),
  [719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(290),
  [721] = {.entry = {.count = 1, .reusable = false}}, SHIFT(272),
  [723] = {.entry = {.count = 1, .reusable = false}}, SHIFT(65),
  [725] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3160),
  [727] = {.entry = {.count = 1, .reusable = false}}, SHIFT(495),
  [729] = {.entry = {.count = 1, .reusable = false}}, SHIFT(184),
  [731] = {.entry = {.count = 1, .reusable = false}}, SHIFT(298),
  [733] = {.entry = {.count = 1, .reusable = false}}, SHIFT(126),
  [735] = {.entry = {.count = 1, .reusable = false}}, SHIFT(317),
  [737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(323),
  [739] = {.entry = {.count = 1, .reusable = false}}, SHIFT(919),
  [741] = {.entry = {.count = 1, .reusable = false}}, SHIFT(91),
  [743] = {.entry = {.count = 1, .reusable = false}}, SHIFT(699),
  [745] = {.entry = {.count = 1, .reusable = false}}, SHIFT(861),
  [747] = {.entry = {.count = 1, .reusable = false}}, SHIFT(651),
  [749] = {.entry = {.count = 1, .reusable = false}}, SHIFT(160),
  [751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(107),
  [753] = {.entry = {.count = 1, .reusable = false}}, SHIFT(475),
  [755] = {.entry = {.count = 1, .reusable = false}}, SHIFT(179),
  [757] = {.entry = {.count = 1, .reusable = false}}, SHIFT(398),
  [759] = {.entry = {.count = 1, .reusable = false}}, SHIFT(140),
  [761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1366),
  [763] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1365),
  [765] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1366),
  [767] = {.entry = {.count = 1, .reusable = false}}, SHIFT(744),
  [769] = {.entry = {.count = 1, .reusable = false}}, SHIFT(67),
  [771] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2011),
  [773] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2472),
  [775] = {.entry = {.count = 1, .reusable = false}}, SHIFT(438),
  [777] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__parameter_name, 1, .production_id = 1), SHIFT(367),
  [780] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expression, 1, .production_id = 1),
  [782] = {.entry = {.count = 1, .reusable = false}}, SHIFT(734),
  [784] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1, .production_id = 1), REDUCE(sym__parameter_name, 1, .production_id = 1),
  [787] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2737),
  [789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(463),
  [791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(100),
  [793] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3076),
  [795] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3331),
  [797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(253),
  [799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2338),
  [801] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2740),
  [803] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__augmented_assignment_lhs, 1, .production_id = 1),
  [805] = {.entry = {.count = 1, .reusable = false}}, SHIFT(794),
  [807] = {.entry = {.count = 1, .reusable = false}}, SHIFT(797),
  [809] = {.entry = {.count = 1, .reusable = false}}, SHIFT(798),
  [811] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3300),
  [813] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression, 1, .production_id = 1),
  [815] = {.entry = {.count = 1, .reusable = false}}, SHIFT(434),
  [817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2702),
  [819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2701),
  [821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(447),
  [823] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2107),
  [825] = {.entry = {.count = 1, .reusable = false}}, SHIFT(447),
  [827] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2110),
  [829] = {.entry = {.count = 1, .reusable = false}}, SHIFT(665),
  [831] = {.entry = {.count = 1, .reusable = false}}, SHIFT(759),
  [833] = {.entry = {.count = 1, .reusable = false}}, SHIFT(260),
  [835] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yield_expression, 1),
  [837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1598),
  [839] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yield_expression, 1),
  [841] = {.entry = {.count = 1, .reusable = false}}, SHIFT(306),
  [843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(112),
  [845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(138),
  [847] = {.entry = {.count = 1, .reusable = false}}, SHIFT(730),
  [849] = {.entry = {.count = 1, .reusable = false}}, SHIFT(204),
  [851] = {.entry = {.count = 1, .reusable = false}}, SHIFT(358),
  [853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1212),
  [855] = {.entry = {.count = 1, .reusable = false}}, SHIFT(820),
  [857] = {.entry = {.count = 1, .reusable = false}}, SHIFT(382),
  [859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1657),
  [861] = {.entry = {.count = 1, .reusable = false}}, SHIFT(319),
  [863] = {.entry = {.count = 1, .reusable = false}}, SHIFT(945),
  [865] = {.entry = {.count = 1, .reusable = false}}, SHIFT(368),
  [867] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1555),
  [869] = {.entry = {.count = 1, .reusable = false}}, SHIFT(388),
  [871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(117),
  [873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(130),
  [875] = {.entry = {.count = 1, .reusable = false}}, SHIFT(208),
  [877] = {.entry = {.count = 1, .reusable = false}}, SHIFT(270),
  [879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1724),
  [881] = {.entry = {.count = 1, .reusable = false}}, SHIFT(954),
  [883] = {.entry = {.count = 1, .reusable = false}}, SHIFT(293),
  [885] = {.entry = {.count = 1, .reusable = false}}, SHIFT(406),
  [887] = {.entry = {.count = 1, .reusable = false}}, SHIFT(234),
  [889] = {.entry = {.count = 1, .reusable = false}}, SHIFT(403),
  [891] = {.entry = {.count = 1, .reusable = false}}, SHIFT(953),
  [893] = {.entry = {.count = 1, .reusable = false}}, SHIFT(325),
  [895] = {.entry = {.count = 1, .reusable = false}}, SHIFT(333),
  [897] = {.entry = {.count = 1, .reusable = false}}, SHIFT(246),
  [899] = {.entry = {.count = 1, .reusable = false}}, SHIFT(321),
  [901] = {.entry = {.count = 1, .reusable = false}}, SHIFT(935),
  [903] = {.entry = {.count = 1, .reusable = false}}, SHIFT(299),
  [905] = {.entry = {.count = 1, .reusable = false}}, SHIFT(290),
  [907] = {.entry = {.count = 1, .reusable = false}}, SHIFT(229),
  [909] = {.entry = {.count = 1, .reusable = false}}, SHIFT(417),
  [911] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1954),
  [913] = {.entry = {.count = 1, .reusable = false}}, SHIFT(367),
  [915] = {.entry = {.count = 1, .reusable = false}}, SHIFT(995),
  [917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(116),
  [919] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2659),
  [921] = {.entry = {.count = 1, .reusable = false}}, SHIFT(802),
  [923] = {.entry = {.count = 1, .reusable = false}}, SHIFT(361),
  [925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(114),
  [927] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3343),
  [929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(223),
  [931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2310),
  [933] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__module, 1, .production_id = 5),
  [935] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__module, 1, .production_id = 5),
  [937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21),
  [939] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3226),
  [941] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statement_block, 2),
  [943] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_statement_block, 2),
  [945] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object, 2),
  [947] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object, 2),
  [949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(513),
  [951] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 5, .production_id = 131),
  [953] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 5, .production_id = 131),
  [955] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function, 5, .production_id = 131),
  [957] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function, 5, .production_id = 131),
  [959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(556),
  [961] = {.entry = {.count = 1, .reusable = false}}, SHIFT(283),
  [963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(212),
  [965] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 3, .production_id = 50),
  [967] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 3, .production_id = 50),
  [969] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 3, .production_id = 50),
  [971] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 3, .production_id = 50),
  [973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(607),
  [975] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_body, 3),
  [977] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_body, 3),
  [979] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__module, 2, .production_id = 27),
  [981] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__module, 2, .production_id = 27),
  [983] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 4, .production_id = 104),
  [985] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 4, .production_id = 104),
  [987] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function, 4, .production_id = 104),
  [989] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function, 4, .production_id = 104),
  [991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(623),
  [993] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function_declaration, 5, .production_id = 131),
  [995] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function_declaration, 5, .production_id = 131),
  [997] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function, 5, .production_id = 131),
  [999] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function, 5, .production_id = 131),
  [1001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(558),
  [1003] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 4, .production_id = 96),
  [1005] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 4, .production_id = 96),
  [1007] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 4, .production_id = 96),
  [1009] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 4, .production_id = 96),
  [1011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(575),
  [1013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(84),
  [1015] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_nested_identifier, 3),
  [1017] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_nested_identifier, 3),
  [1019] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 4, .production_id = 97),
  [1021] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 4, .production_id = 97),
  [1023] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 4, .production_id = 97),
  [1025] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 4, .production_id = 97),
  [1027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(576),
  [1029] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 137),
  [1031] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 137),
  [1033] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 5, .production_id = 137),
  [1035] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 5, .production_id = 137),
  [1037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(562),
  [1039] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 138),
  [1041] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 138),
  [1043] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 5, .production_id = 138),
  [1045] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 5, .production_id = 138),
  [1047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(563),
  [1049] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statement_block, 3),
  [1051] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_statement_block, 3),
  [1053] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 128),
  [1055] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 128),
  [1057] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 5, .production_id = 128),
  [1059] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 5, .production_id = 128),
  [1061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(554),
  [1063] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_body, 2),
  [1065] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_body, 2),
  [1067] = {.entry = {.count = 1, .reusable = false}}, SHIFT(300),
  [1069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(188),
  [1071] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statement_block, 4),
  [1073] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_statement_block, 4),
  [1075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(110),
  [1077] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2692),
  [1079] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 2),
  [1081] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string, 2),
  [1083] = {.entry = {.count = 1, .reusable = false}}, SHIFT(379),
  [1085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(227),
  [1087] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 3),
  [1089] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string, 3),
  [1091] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_internal_module, 2, .production_id = 6),
  [1093] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_internal_module, 2, .production_id = 6),
  [1095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(88),
  [1097] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, .production_id = 161),
  [1099] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, .production_id = 161),
  [1101] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 6, .production_id = 161),
  [1103] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 6, .production_id = 161),
  [1105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(589),
  [1107] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declaration, 1),
  [1109] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declaration, 1),
  [1111] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expression, 1),
  [1113] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression, 1),
  [1115] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function_declaration, 6, .production_id = 158),
  [1117] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function_declaration, 6, .production_id = 158),
  [1119] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function, 6, .production_id = 158),
  [1121] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function, 6, .production_id = 158),
  [1123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(594),
  [1125] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 4, .production_id = 110),
  [1127] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 4, .production_id = 110),
  [1129] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 4, .production_id = 110),
  [1131] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 4, .production_id = 110),
  [1133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(555),
  [1135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(261),
  [1137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(111),
  [1139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3289),
  [1141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(175),
  [1143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2254),
  [1145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(942),
  [1147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(132),
  [1149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2085),
  [1151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(271),
  [1153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1428),
  [1155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1357),
  [1157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1349),
  [1159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1049),
  [1161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1347),
  [1163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1322),
  [1165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1204),
  [1167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(858),
  [1169] = {.entry = {.count = 1, .reusable = false}}, SHIFT(859),
  [1171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(653),
  [1173] = {.entry = {.count = 1, .reusable = false}}, SHIFT(233),
  [1175] = {.entry = {.count = 1, .reusable = false}}, SHIFT(232),
  [1177] = {.entry = {.count = 1, .reusable = false}}, SHIFT(474),
  [1179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2038),
  [1181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(426),
  [1183] = {.entry = {.count = 1, .reusable = false}}, SHIFT(929),
  [1185] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1656),
  [1187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(484),
  [1189] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_predefined_type, 1),
  [1191] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_predefined_type, 1),
  [1193] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3156),
  [1195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(230),
  [1197] = {.entry = {.count = 1, .reusable = false}}, SHIFT(331),
  [1199] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3349),
  [1201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2308),
  [1203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2309),
  [1205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1183),
  [1207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3345),
  [1209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3344),
  [1211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2344),
  [1213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2364),
  [1215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2174),
  [1217] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1, .production_id = 1), REDUCE(sym__property_name, 1, .production_id = 7),
  [1220] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__property_name, 1, .production_id = 7), SHIFT(37),
  [1223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(226),
  [1225] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, .production_id = 1), REDUCE(sym__property_name, 1, .production_id = 7),
  [1228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3343),
  [1230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3342),
  [1232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3341),
  [1234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3041),
  [1236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3370),
  [1238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1851),
  [1240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2311),
  [1242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3369),
  [1244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3368),
  [1246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1578),
  [1248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1029),
  [1250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2411),
  [1252] = {.entry = {.count = 1, .reusable = false}}, SHIFT(938),
  [1254] = {.entry = {.count = 1, .reusable = false}}, SHIFT(931),
  [1256] = {.entry = {.count = 1, .reusable = false}}, SHIFT(657),
  [1258] = {.entry = {.count = 1, .reusable = false}}, SHIFT(493),
  [1260] = {.entry = {.count = 1, .reusable = false}}, SHIFT(258),
  [1262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2182),
  [1264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2955),
  [1266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2528),
  [1268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1624),
  [1270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1555),
  [1272] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_array_repeat1, 1),
  [1274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1193),
  [1276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1704),
  [1278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1026),
  [1280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1560),
  [1282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1217),
  [1284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1857),
  [1286] = {.entry = {.count = 1, .reusable = false}}, SHIFT(399),
  [1288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(37),
  [1290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(38),
  [1292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1854),
  [1294] = {.entry = {.count = 1, .reusable = false}}, SHIFT(764),
  [1296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2189),
  [1298] = {.entry = {.count = 1, .reusable = false}}, SHIFT(778),
  [1300] = {.entry = {.count = 1, .reusable = false}}, SHIFT(758),
  [1302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(610),
  [1304] = {.entry = {.count = 1, .reusable = false}}, SHIFT(668),
  [1306] = {.entry = {.count = 1, .reusable = false}}, SHIFT(733),
  [1308] = {.entry = {.count = 1, .reusable = false}}, SHIFT(854),
  [1310] = {.entry = {.count = 1, .reusable = false}}, SHIFT(694),
  [1312] = {.entry = {.count = 1, .reusable = false}}, SHIFT(731),
  [1314] = {.entry = {.count = 1, .reusable = false}}, SHIFT(728),
  [1316] = {.entry = {.count = 1, .reusable = false}}, SHIFT(707),
  [1318] = {.entry = {.count = 1, .reusable = false}}, SHIFT(762),
  [1320] = {.entry = {.count = 1, .reusable = false}}, SHIFT(981),
  [1322] = {.entry = {.count = 1, .reusable = false}}, SHIFT(979),
  [1324] = {.entry = {.count = 1, .reusable = false}}, SHIFT(667),
  [1326] = {.entry = {.count = 1, .reusable = false}}, SHIFT(390),
  [1328] = {.entry = {.count = 1, .reusable = false}}, SHIFT(519),
  [1330] = {.entry = {.count = 1, .reusable = false}}, SHIFT(671),
  [1332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(42),
  [1334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(43),
  [1336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3),
  [1338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2),
  [1340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6),
  [1342] = {.entry = {.count = 1, .reusable = false}}, SHIFT(703),
  [1344] = {.entry = {.count = 1, .reusable = false}}, SHIFT(697),
  [1346] = {.entry = {.count = 1, .reusable = false}}, SHIFT(640),
  [1348] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3280),
  [1350] = {.entry = {.count = 1, .reusable = false}}, SHIFT(462),
  [1352] = {.entry = {.count = 1, .reusable = false}}, SHIFT(225),
  [1354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1265),
  [1356] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1265),
  [1358] = {.entry = {.count = 1, .reusable = false}}, SHIFT(959),
  [1360] = {.entry = {.count = 1, .reusable = false}}, SHIFT(960),
  [1362] = {.entry = {.count = 1, .reusable = false}}, SHIFT(663),
  [1364] = {.entry = {.count = 1, .reusable = false}}, SHIFT(499),
  [1366] = {.entry = {.count = 1, .reusable = false}}, SHIFT(729),
  [1368] = {.entry = {.count = 1, .reusable = false}}, SHIFT(754),
  [1370] = {.entry = {.count = 1, .reusable = false}}, SHIFT(645),
  [1372] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3259),
  [1374] = {.entry = {.count = 1, .reusable = false}}, SHIFT(470),
  [1376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1039),
  [1378] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1039),
  [1380] = {.entry = {.count = 1, .reusable = false}}, SHIFT(914),
  [1382] = {.entry = {.count = 1, .reusable = false}}, SHIFT(890),
  [1384] = {.entry = {.count = 1, .reusable = false}}, SHIFT(649),
  [1386] = {.entry = {.count = 1, .reusable = false}}, SHIFT(479),
  [1388] = {.entry = {.count = 1, .reusable = false}}, SHIFT(686),
  [1390] = {.entry = {.count = 1, .reusable = false}}, SHIFT(681),
  [1392] = {.entry = {.count = 1, .reusable = false}}, SHIFT(636),
  [1394] = {.entry = {.count = 1, .reusable = false}}, SHIFT(460),
  [1396] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_nested_type_identifier, 3, .production_id = 94),
  [1398] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_nested_type_identifier, 3, .production_id = 94),
  [1400] = {.entry = {.count = 1, .reusable = false}}, SHIFT(732),
  [1402] = {.entry = {.count = 1, .reusable = false}}, SHIFT(743),
  [1404] = {.entry = {.count = 1, .reusable = false}}, SHIFT(646),
  [1406] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3334),
  [1408] = {.entry = {.count = 1, .reusable = false}}, SHIFT(473),
  [1410] = {.entry = {.count = 1, .reusable = false}}, SHIFT(242),
  [1412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1351),
  [1414] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1351),
  [1416] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2704),
  [1418] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2707),
  [1420] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, .production_id = 1), SHIFT(1937),
  [1423] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__expression, 1, .production_id = 1), REDUCE(sym__property_name, 1, .production_id = 7), SHIFT(1819),
  [1427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(243),
  [1429] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__expression, 1, .production_id = 1), REDUCE(sym__property_name, 1, .production_id = 7), SHIFT(3076),
  [1433] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2177),
  [1435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2332),
  [1437] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1868),
  [1439] = {.entry = {.count = 1, .reusable = false}}, SHIFT(956),
  [1441] = {.entry = {.count = 1, .reusable = false}}, SHIFT(955),
  [1443] = {.entry = {.count = 1, .reusable = false}}, SHIFT(660),
  [1445] = {.entry = {.count = 1, .reusable = false}}, SHIFT(498),
  [1447] = {.entry = {.count = 1, .reusable = false}}, SHIFT(804),
  [1449] = {.entry = {.count = 1, .reusable = false}}, SHIFT(826),
  [1451] = {.entry = {.count = 1, .reusable = false}}, SHIFT(652),
  [1453] = {.entry = {.count = 1, .reusable = false}}, SHIFT(477),
  [1455] = {.entry = {.count = 1, .reusable = false}}, SHIFT(504),
  [1457] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2185),
  [1459] = {.entry = {.count = 1, .reusable = false}}, SHIFT(670),
  [1461] = {.entry = {.count = 1, .reusable = false}}, SHIFT(982),
  [1463] = {.entry = {.count = 1, .reusable = false}}, SHIFT(683),
  [1465] = {.entry = {.count = 1, .reusable = false}}, SHIFT(520),
  [1467] = {.entry = {.count = 1, .reusable = false}}, SHIFT(497),
  [1469] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2246),
  [1471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1546),
  [1473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1525),
  [1475] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_arguments, 5),
  [1477] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_arguments, 5),
  [1479] = {.entry = {.count = 1, .reusable = false}}, SHIFT(817),
  [1481] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_arguments, 3),
  [1483] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_arguments, 3),
  [1485] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_type, 2),
  [1487] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generic_type, 2),
  [1489] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_type, 2, .production_id = 14),
  [1491] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generic_type, 2, .production_id = 14),
  [1493] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_arguments, 4),
  [1495] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_arguments, 4),
  [1497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1100),
  [1499] = {.entry = {.count = 1, .reusable = false}}, SHIFT(768),
  [1501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1403),
  [1503] = {.entry = {.count = 1, .reusable = false}}, SHIFT(916),
  [1505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1269),
  [1507] = {.entry = {.count = 1, .reusable = false}}, SHIFT(980),
  [1509] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_infer_type, 2, .production_id = 48),
  [1511] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_infer_type, 2, .production_id = 48),
  [1513] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_type, 2),
  [1515] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_type, 2),
  [1517] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_intersection_type, 2),
  [1519] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_intersection_type, 2),
  [1521] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_flow_maybe_type, 2),
  [1523] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_flow_maybe_type, 2),
  [1525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(763),
  [1527] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_intersection_type, 3),
  [1529] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_intersection_type, 3),
  [1531] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_type, 3),
  [1533] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_type, 3),
  [1535] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__tuple_type_body, 2),
  [1537] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__tuple_type_body, 2),
  [1539] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lookup_type, 4),
  [1541] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lookup_type, 4),
  [1543] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_type, 4),
  [1545] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_type, 4),
  [1547] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_type, 3),
  [1549] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_type, 3),
  [1551] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_type, 2),
  [1553] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_type, 2),
  [1555] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type, 1),
  [1557] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type, 1),
  [1559] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_query, 2),
  [1561] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_query, 2),
  [1563] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__number, 2, .production_id = 8),
  [1565] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__number, 2, .production_id = 8),
  [1567] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_type, 6),
  [1569] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_type, 6),
  [1571] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_existential_type, 1),
  [1573] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_existential_type, 1),
  [1575] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_type, 4),
  [1577] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_type, 4),
  [1579] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_type, 3),
  [1581] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_type, 3),
  [1583] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_type, 5),
  [1585] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_type, 5),
  [1587] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_type, 1),
  [1589] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_type, 1),
  [1591] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_type, 2),
  [1593] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_type, 2),
  [1595] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_type, 4),
  [1597] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_type, 4),
  [1599] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_type, 5),
  [1601] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_type, 5),
  [1603] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__tuple_type_body, 4),
  [1605] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__tuple_type_body, 4),
  [1607] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_literal_type, 1),
  [1609] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_literal_type, 1),
  [1611] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__tuple_type_body, 3),
  [1613] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__tuple_type_body, 3),
  [1615] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_type_query, 2),
  [1617] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_index_type_query, 2),
  [1619] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_type, 3),
  [1621] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_type, 3),
  [1623] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2334),
  [1625] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1876),
  [1627] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1909),
  [1629] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1877),
  [1631] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3264),
  [1633] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3266),
  [1635] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 2, .production_id = 15),
  [1637] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 2, .production_id = 15),
  [1639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(187),
  [1641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3331),
  [1643] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2240),
  [1645] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2010),
  [1647] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2486),
  [1649] = {.entry = {.count = 1, .reusable = false}}, SHIFT(748),
  [1651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(106),
  [1653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3076),
  [1655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3300),
  [1657] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2113),
  [1659] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1923),
  [1661] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2106),
  [1663] = {.entry = {.count = 1, .reusable = false}}, SHIFT(552),
  [1665] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3285),
  [1667] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3287),
  [1669] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2202),
  [1671] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_accessibility_modifier, 1),
  [1673] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_accessibility_modifier, 1),
  [1675] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3351),
  [1677] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3350),
  [1679] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1, .production_id = 1), SHIFT(1819),
  [1682] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, .production_id = 1), SHIFT(3076),
  [1685] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3340),
  [1687] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3268),
  [1689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(237),
  [1691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3289),
  [1693] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2204),
  [1695] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, .production_id = 1), SHIFT(198),
  [1698] = {.entry = {.count = 1, .reusable = false}}, SHIFT(198),
  [1700] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3163),
  [1702] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3162),
  [1704] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3241),
  [1706] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3247),
  [1708] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3245),
  [1710] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__primary_type, 1, .production_id = 14),
  [1712] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__primary_type, 1, .production_id = 14),
  [1714] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary_type, 1, .production_id = 14), SHIFT(906),
  [1717] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3181),
  [1719] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2195),
  [1721] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_type_query, 2, .production_id = 48),
  [1723] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_index_type_query, 2, .production_id = 48),
  [1725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(509),
  [1727] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2473),
  [1729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1665),
  [1731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(124),
  [1733] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, .production_id = 1), REDUCE(sym__parameter_name, 1, .production_id = 1),
  [1736] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 1, .production_id = 1),
  [1738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(122),
  [1740] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 2, .production_id = 13),
  [1742] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 2, .production_id = 13),
  [1744] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2779),
  [1746] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3129),
  [1748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(856),
  [1750] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__primary_type, 1),
  [1752] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__primary_type, 1),
  [1754] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary_type, 1), SHIFT(906),
  [1757] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_nested_identifier, 3), REDUCE(sym_nested_type_identifier, 3, .production_id = 94),
  [1760] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2217),
  [1762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(788),
  [1764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(501),
  [1766] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2233),
  [1768] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 4),
  [1770] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 4),
  [1772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(883),
  [1774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(885),
  [1776] = {.entry = {.count = 1, .reusable = false}}, SHIFT(912),
  [1778] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_conditional_type, 7, .production_id = 188),
  [1780] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_conditional_type, 7, .production_id = 188),
  [1782] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ambient_declaration, 6, .production_id = 160),
  [1784] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ambient_declaration, 6, .production_id = 160),
  [1786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(512),
  [1788] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 3),
  [1790] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 3),
  [1792] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 3, .production_id = 43),
  [1794] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 3, .production_id = 43),
  [1796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16),
  [1798] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3209),
  [1800] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, .production_id = 1), SHIFT(213),
  [1803] = {.entry = {.count = 1, .reusable = false}}, SHIFT(213),
  [1805] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_statement, 2),
  [1807] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_statement, 2),
  [1809] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_clause, 2, .production_id = 13),
  [1811] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_catch_clause, 2, .production_id = 13),
  [1813] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_empty_statement, 1),
  [1815] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_empty_statement, 1),
  [1817] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_clause, 5, .production_id = 172),
  [1819] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_catch_clause, 5, .production_id = 172),
  [1821] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_clause, 5, .production_id = 171),
  [1823] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_catch_clause, 5, .production_id = 171),
  [1825] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_clause, 5, .production_id = 170),
  [1827] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_catch_clause, 5, .production_id = 170),
  [1829] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 3, .production_id = 35),
  [1831] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 3, .production_id = 35),
  [1833] = {.entry = {.count = 1, .reusable = false}}, SHIFT(40),
  [1835] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_else_clause, 2),
  [1837] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_else_clause, 2),
  [1839] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_body, 2),
  [1841] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_body, 2),
  [1843] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 4, .production_id = 86),
  [1845] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 4, .production_id = 86),
  [1847] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 3, .production_id = 44),
  [1849] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 3, .production_id = 44),
  [1851] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration, 4, .production_id = 85),
  [1853] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_declaration, 4, .production_id = 85),
  [1855] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lexical_declaration, 4),
  [1857] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lexical_declaration, 4),
  [1859] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 4),
  [1861] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration, 4),
  [1863] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 5, .production_id = 136),
  [1865] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 5, .production_id = 136),
  [1867] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_statement, 4),
  [1869] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_statement, 4),
  [1871] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, .production_id = 128),
  [1873] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, .production_id = 128),
  [1875] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 110),
  [1877] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 110),
  [1879] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 6, .production_id = 131),
  [1881] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 6, .production_id = 131),
  [1883] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ambient_declaration, 2),
  [1885] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ambient_declaration, 2),
  [1887] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function_declaration, 6, .production_id = 131),
  [1889] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function_declaration, 6, .production_id = 131),
  [1891] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_class_declaration, 6, .production_id = 159),
  [1893] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_class_declaration, 6, .production_id = 159),
  [1895] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 4),
  [1897] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 4),
  [1899] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, .production_id = 137),
  [1901] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, .production_id = 137),
  [1903] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, .production_id = 138),
  [1905] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, .production_id = 138),
  [1907] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module, 2, .production_id = 6),
  [1909] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module, 2, .production_id = 6),
  [1911] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 5),
  [1913] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 5),
  [1915] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_throw_statement, 3),
  [1917] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_throw_statement, 3),
  [1919] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 4, .production_id = 92),
  [1921] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 4, .production_id = 92),
  [1923] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_finally_clause, 2, .production_id = 13),
  [1925] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_finally_clause, 2, .production_id = 13),
  [1927] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 3),
  [1929] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 3),
  [1931] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_continue_statement, 3, .production_id = 46),
  [1933] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_continue_statement, 3, .production_id = 46),
  [1935] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_class_declaration, 5, .production_id = 140),
  [1937] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_class_declaration, 5, .production_id = 140),
  [1939] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_statement, 5, .production_id = 118),
  [1941] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_statement, 5, .production_id = 118),
  [1943] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break_statement, 3, .production_id = 46),
  [1945] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_break_statement, 3, .production_id = 46),
  [1947] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 96),
  [1949] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 96),
  [1951] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 97),
  [1953] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 97),
  [1955] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_statement, 3, .production_id = 45),
  [1957] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_with_statement, 3, .production_id = 45),
  [1959] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_alias, 5),
  [1961] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_alias, 5),
  [1963] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 3),
  [1965] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 3),
  [1967] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 5, .production_id = 128),
  [1969] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 5, .production_id = 128),
  [1971] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_statement, 3, .production_id = 42),
  [1973] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_statement, 3, .production_id = 42),
  [1975] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_labeled_statement, 3, .dynamic_precedence = -1, .production_id = 23),
  [1977] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_labeled_statement, 3, .dynamic_precedence = -1, .production_id = 23),
  [1979] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature, 5, .production_id = 130),
  [1981] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature, 5, .production_id = 130),
  [1983] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_class_declaration, 6, .production_id = 162),
  [1985] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_class_declaration, 6, .production_id = 162),
  [1987] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_class_declaration, 5, .production_id = 134),
  [1989] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_class_declaration, 5, .production_id = 134),
  [1991] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_class_declaration, 6, .production_id = 163),
  [1993] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_class_declaration, 6, .production_id = 163),
  [1995] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_class_declaration, 7, .production_id = 181),
  [1997] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_class_declaration, 7, .production_id = 181),
  [1999] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 7, .production_id = 161),
  [2001] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 7, .production_id = 161),
  [2003] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_alias_declaration, 6, .production_id = 143),
  [2005] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_alias_declaration, 6, .production_id = 143),
  [2007] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_in_statement, 3, .production_id = 37),
  [2009] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_in_statement, 3, .production_id = 37),
  [2011] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 5),
  [2013] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 5),
  [2015] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ambient_declaration, 3),
  [2017] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ambient_declaration, 3),
  [2019] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function_declaration, 7, .production_id = 158),
  [2021] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function_declaration, 7, .production_id = 158),
  [2023] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 3, .production_id = 50),
  [2025] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 3, .production_id = 50),
  [2027] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_class_declaration, 5, .production_id = 133),
  [2029] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_class_declaration, 5, .production_id = 133),
  [2031] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 4, .production_id = 72),
  [2033] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 4, .production_id = 72),
  [2035] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration, 3, .production_id = 62),
  [2037] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_declaration, 3, .production_id = 62),
  [2039] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 2),
  [2041] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 2),
  [2043] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 4, .production_id = 97),
  [2045] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 4, .production_id = 97),
  [2047] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 6, .production_id = 146),
  [2049] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 6, .production_id = 146),
  [2051] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 4, .production_id = 71),
  [2053] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 4, .production_id = 71),
  [2055] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 4, .production_id = 96),
  [2057] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 4, .production_id = 96),
  [2059] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break_statement, 2),
  [2061] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_break_statement, 2),
  [2063] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_class_declaration, 4, .production_id = 109),
  [2065] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_class_declaration, 4, .production_id = 109),
  [2067] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_statement, 3, .production_id = 36),
  [2069] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_statement, 3, .production_id = 36),
  [2071] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 4, .production_id = 50),
  [2073] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 4, .production_id = 50),
  [2075] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lexical_declaration, 3),
  [2077] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lexical_declaration, 3),
  [2079] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 3, .production_id = 69),
  [2081] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 3, .production_id = 69),
  [2083] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 2),
  [2085] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 2),
  [2087] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_debugger_statement, 2),
  [2089] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_debugger_statement, 2),
  [2091] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 3),
  [2093] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration, 3),
  [2095] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_in_statement, 4, .production_id = 87),
  [2097] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_in_statement, 4, .production_id = 87),
  [2099] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_body, 3),
  [2101] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_body, 3),
  [2103] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature, 4, .production_id = 103),
  [2105] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature, 4, .production_id = 103),
  [2107] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_statement, 3),
  [2109] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_statement, 3),
  [2111] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_continue_statement, 2),
  [2113] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_continue_statement, 2),
  [2115] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 3),
  [2117] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 3),
  [2119] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_alias_declaration, 5, .production_id = 117),
  [2121] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_alias_declaration, 5, .production_id = 117),
  [2123] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 2),
  [2125] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 2),
  [2127] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do_statement, 5, .production_id = 122),
  [2129] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do_statement, 5, .production_id = 122),
  [2131] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 5, .production_id = 104),
  [2133] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 5, .production_id = 104),
  [2135] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 2, .production_id = 4),
  [2137] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 2, .production_id = 4),
  [2139] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 7, .production_id = 169),
  [2141] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 7, .production_id = 169),
  [2143] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__for_header, 5, .production_id = 145),
  [2145] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_header, 5, .production_id = 145),
  [2147] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_expression, 4),
  [2149] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_expression, 4),
  [2151] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__for_header, 6, .production_id = 166),
  [2153] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_header, 6, .production_id = 166),
  [2155] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__for_header, 6, .production_id = 168),
  [2157] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_header, 6, .production_id = 168),
  [2159] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_expression, 3),
  [2161] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_expression, 3),
  [2163] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__for_header, 5, .production_id = 144),
  [2165] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_header, 5, .production_id = 144),
  [2167] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__for_header, 6, .production_id = 167),
  [2169] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_header, 6, .production_id = 167),
  [2171] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__for_header, 6, .production_id = 165),
  [2173] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_header, 6, .production_id = 165),
  [2175] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__for_header, 5, .production_id = 148),
  [2177] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_header, 5, .production_id = 148),
  [2179] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__for_header, 5, .production_id = 147),
  [2181] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_header, 5, .production_id = 147),
  [2183] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1092),
  [2185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(143),
  [2187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(811),
  [2189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(68),
  [2191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2694),
  [2193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2703),
  [2195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(518),
  [2197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(139),
  [2199] = {.entry = {.count = 1, .reusable = false}}, SHIFT(827),
  [2201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(136),
  [2203] = {.entry = {.count = 1, .reusable = false}}, SHIFT(891),
  [2205] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1076),
  [2207] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1521),
  [2209] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 2, .production_id = 16),
  [2211] = {.entry = {.count = 1, .reusable = false}}, SHIFT(304),
  [2213] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 2, .production_id = 16),
  [2215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(172),
  [2217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3258),
  [2219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2348),
  [2221] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__augmented_assignment_lhs, 1),
  [2223] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 2, .production_id = 38),
  [2225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2093),
  [2227] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript_expression, 5, .production_id = 132),
  [2229] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript_expression, 5, .production_id = 132),
  [2231] = {.entry = {.count = 1, .reusable = false}}, SHIFT(351),
  [2233] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1), SHIFT(836),
  [2236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3233),
  [2238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(248),
  [2240] = {.entry = {.count = 1, .reusable = false}}, SHIFT(364),
  [2242] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 1, .production_id = 5),
  [2244] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3134),
  [2246] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1), SHIFT(214),
  [2249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(214),
  [2251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(866),
  [2253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(215),
  [2255] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1), SHIFT(906),
  [2258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3255),
  [2260] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2876),
  [2262] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript_expression, 4, .production_id = 74),
  [2264] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript_expression, 4, .production_id = 74),
  [2266] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member_expression, 3, .production_id = 58),
  [2268] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_expression, 3, .production_id = 58),
  [2270] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript_expression, 4, .production_id = 107),
  [2272] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript_expression, 4, .production_id = 107),
  [2274] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member_expression, 3, .production_id = 24),
  [2276] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_expression, 3, .production_id = 24),
  [2278] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript_expression, 5, .production_id = 115),
  [2280] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript_expression, 5, .production_id = 115),
  [2282] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_non_null_expression, 2),
  [2284] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_non_null_expression, 2),
  [2286] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1), REDUCE(sym__primary_type, 1, .production_id = 14),
  [2289] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1), REDUCE(sym__primary_type, 1, .production_id = 14),
  [2292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3328),
  [2294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3239),
  [2296] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_member_expression, 3, .production_id = 58), REDUCE(sym_nested_type_identifier, 3, .production_id = 94),
  [2299] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_member_expression, 3, .production_id = 58), REDUCE(sym_nested_type_identifier, 3, .production_id = 94),
  [2302] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_nested_identifier, 3), REDUCE(sym_member_expression, 3, .production_id = 58),
  [2305] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_nested_identifier, 3), REDUCE(sym_member_expression, 3, .production_id = 58),
  [2308] = {.entry = {.count = 1, .reusable = false}}, SHIFT(355),
  [2310] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1), REDUCE(sym__property_name, 1, .production_id = 7),
  [2313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(254),
  [2315] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1), REDUCE(sym__property_name, 1, .production_id = 7),
  [2318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3276),
  [2320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(236),
  [2322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2372),
  [2324] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1, .production_id = 1), REDUCE(sym_predefined_type, 1),
  [2327] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, .production_id = 1), REDUCE(sym_predefined_type, 1),
  [2330] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1041),
  [2332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1089),
  [2334] = {.entry = {.count = 1, .reusable = false}}, SHIFT(991),
  [2336] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2730),
  [2338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(464),
  [2340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2088),
  [2342] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2698),
  [2344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(872),
  [2346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(873),
  [2348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(874),
  [2350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3387),
  [2352] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1088),
  [2354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1087),
  [2356] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1084),
  [2358] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1087),
  [2360] = {.entry = {.count = 1, .reusable = false}}, SHIFT(852),
  [2362] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3386),
  [2364] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2356),
  [2366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(991),
  [2368] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1279),
  [2370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1415),
  [2372] = {.entry = {.count = 1, .reusable = false}}, SHIFT(996),
  [2374] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2636),
  [2376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(466),
  [2378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2102),
  [2380] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2628),
  [2382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(803),
  [2384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(801),
  [2386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(800),
  [2388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3279),
  [2390] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1419),
  [2392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1420),
  [2394] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1422),
  [2396] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1420),
  [2398] = {.entry = {.count = 1, .reusable = false}}, SHIFT(875),
  [2400] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3278),
  [2402] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2371),
  [2404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(996),
  [2406] = {.entry = {.count = 1, .reusable = false}}, SHIFT(285),
  [2408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3301),
  [2410] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2067),
  [2412] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2235),
  [2414] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3036),
  [2416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3196),
  [2418] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1975),
  [2420] = {.entry = {.count = 1, .reusable = false}}, SHIFT(998),
  [2422] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2667),
  [2424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(461),
  [2426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2111),
  [2428] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2735),
  [2430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3321),
  [2432] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2016),
  [2434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2634),
  [2436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2635),
  [2438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2017),
  [2440] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2047),
  [2442] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2017),
  [2444] = {.entry = {.count = 1, .reusable = false}}, SHIFT(831),
  [2446] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3051),
  [2448] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2002),
  [2450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2129),
  [2452] = {.entry = {.count = 1, .reusable = false}}, SHIFT(999),
  [2454] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2697),
  [2456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(465),
  [2458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2098),
  [2460] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2700),
  [2462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(920),
  [2464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(921),
  [2466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(895),
  [2468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3355),
  [2470] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2126),
  [2472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2640),
  [2474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2639),
  [2476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2122),
  [2478] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2096),
  [2480] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2122),
  [2482] = {.entry = {.count = 1, .reusable = false}}, SHIFT(793),
  [2484] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3119),
  [2486] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3353),
  [2488] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2333),
  [2490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(999),
  [2492] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1470),
  [2494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1547),
  [2496] = {.entry = {.count = 1, .reusable = false}}, SHIFT(990),
  [2498] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2638),
  [2500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(467),
  [2502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2080),
  [2504] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2719),
  [2506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(814),
  [2508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(816),
  [2510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(818),
  [2512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3318),
  [2514] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1563),
  [2516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1564),
  [2518] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1566),
  [2520] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1564),
  [2522] = {.entry = {.count = 1, .reusable = false}}, SHIFT(771),
  [2524] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3317),
  [2526] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2255),
  [2528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(990),
  [2530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3246),
  [2532] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2022),
  [2534] = {.entry = {.count = 1, .reusable = false}}, SHIFT(994),
  [2536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1933),
  [2538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(968),
  [2540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1225),
  [2542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1817),
  [2544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1036),
  [2546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(123),
  [2548] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1701),
  [2550] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2669),
  [2552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3175),
  [2554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1987),
  [2556] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1728),
  [2558] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1751),
  [2560] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1796),
  [2562] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1695),
  [2564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2035),
  [2566] = {.entry = {.count = 1, .reusable = false}}, SHIFT(338),
  [2568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3261),
  [2570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(174),
  [2572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(951),
  [2574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1047),
  [2576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1035),
  [2578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(421),
  [2580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1102),
  [2582] = {.entry = {.count = 1, .reusable = false}}, SHIFT(431),
  [2584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2149),
  [2586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1583),
  [2588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2014),
  [2590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1593),
  [2592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2124),
  [2594] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2036),
  [2596] = {.entry = {.count = 1, .reusable = false}}, SHIFT(992),
  [2598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1370),
  [2600] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1736),
  [2602] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1743),
  [2604] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1754),
  [2606] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1809),
  [2608] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1742),
  [2610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2021),
  [2612] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__parameter_name, 1), SHIFT(351),
  [2615] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1), REDUCE(sym__parameter_name, 1),
  [2618] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__expression, 1), REDUCE(sym__parameter_name, 1), REDUCE(sym__primary_type, 1, .production_id = 14),
  [2622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3216),
  [2624] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1), REDUCE(sym__parameter_name, 1),
  [2627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1097),
  [2629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1541),
  [2631] = {.entry = {.count = 1, .reusable = false}}, SHIFT(308),
  [2633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(239),
  [2635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3237),
  [2637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(195),
  [2639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2327),
  [2641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1550),
  [2643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3230),
  [2645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(203),
  [2647] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1981),
  [2649] = {.entry = {.count = 1, .reusable = false}}, SHIFT(276),
  [2651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3335),
  [2653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3250),
  [2655] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2034),
  [2657] = {.entry = {.count = 1, .reusable = false}}, SHIFT(993),
  [2659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2099),
  [2661] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1712),
  [2663] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1714),
  [2665] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1749),
  [2667] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1826),
  [2669] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1723),
  [2671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1387),
  [2673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2057),
  [2675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1099),
  [2677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1388),
  [2679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(265),
  [2681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1350),
  [2683] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2015),
  [2685] = {.entry = {.count = 1, .reusable = false}}, SHIFT(997),
  [2687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1313),
  [2689] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1716),
  [2691] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1698),
  [2693] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1758),
  [2695] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1806),
  [2697] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1741),
  [2699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2041),
  [2701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(439),
  [2703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2087),
  [2705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1425),
  [2707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1430),
  [2709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1131),
  [2711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3362),
  [2713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(292),
  [2715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2814),
  [2717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2161),
  [2719] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extends_clause, 2, .production_id = 48),
  [2721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(159),
  [2723] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1), SHIFT(765),
  [2726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3323),
  [2728] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extends_clause, 2, .production_id = 48),
  [2730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2162),
  [2732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2856),
  [2734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3242),
  [2736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(440),
  [2738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(154),
  [2740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3388),
  [2742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2572),
  [2744] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2030),
  [2746] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2123),
  [2748] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2717),
  [2750] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1978),
  [2752] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2018),
  [2754] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_extends_clause_repeat1, 2, .production_id = 48),
  [2756] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2705),
  [2758] = {.entry = {.count = 1, .reusable = false}}, SHIFT(423),
  [2760] = {.entry = {.count = 1, .reusable = false}}, SHIFT(480),
  [2762] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2658),
  [2764] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2715),
  [2766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(882),
  [2768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(880),
  [2770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(876),
  [2772] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2285),
  [2774] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1508),
  [2776] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1618),
  [2778] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1), REDUCE(sym__rest_identifier, 2),
  [2781] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__rest_identifier, 2),
  [2783] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2699),
  [2785] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_extends_clause_repeat1, 2, .production_id = 48),
  [2787] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1), SHIFT(177),
  [2790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(177),
  [2792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(198),
  [2794] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1072),
  [2796] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2685),
  [2798] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__expression, 1, .production_id = 1), REDUCE(sym__parameter_name, 1, .production_id = 1), REDUCE(sym_predefined_type, 1),
  [2802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(602),
  [2804] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2141),
  [2806] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2039),
  [2808] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 1),
  [2810] = {.entry = {.count = 1, .reusable = false}}, SHIFT(853),
  [2812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(849),
  [2814] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1), REDUCE(sym__tuple_type_identifier, 1),
  [2817] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__tuple_type_identifier, 1),
  [2819] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1), SHIFT(2848),
  [2822] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2077),
  [2824] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1001),
  [2826] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_object_repeat1, 1),
  [2828] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1755),
  [2830] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1753),
  [2832] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1785),
  [2834] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1843),
  [2836] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1750),
  [2838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(792),
  [2840] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array, 3),
  [2842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(213),
  [2844] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2882),
  [2846] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3329),
  [2848] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import, 1),
  [2850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2342),
  [2852] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import, 1),
  [2854] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2072),
  [2856] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2046),
  [2858] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1000),
  [2860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1941),
  [2862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1038),
  [2864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1580),
  [2866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(217),
  [2868] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1762),
  [2870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1982),
  [2872] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1764),
  [2874] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1808),
  [2876] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1778),
  [2878] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1769),
  [2880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1037),
  [2882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1078),
  [2884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2998),
  [2886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(257),
  [2888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(316),
  [2890] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3240),
  [2892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2335),
  [2894] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__property_name, 1, .production_id = 7),
  [2896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3364),
  [2898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3365),
  [2900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2262),
  [2902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2263),
  [2904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2239),
  [2906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3220),
  [2908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3366),
  [2910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2972),
  [2912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3231),
  [2914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1855),
  [2916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2340),
  [2918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3223),
  [2920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3221),
  [2922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1032),
  [2924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1501),
  [2926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1034),
  [2928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2135),
  [2930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3354),
  [2932] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__property_name, 1, .production_id = 7), REDUCE(aux_sym_object_repeat1, 2, .production_id = 28),
  [2935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2163),
  [2937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2027),
  [2939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1109),
  [2941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1068),
  [2943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2031),
  [2945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(437),
  [2947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2019),
  [2949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1119),
  [2951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1364),
  [2953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1396),
  [2955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1374),
  [2957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(428),
  [2959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2168),
  [2961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1587),
  [2963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2134),
  [2965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1549),
  [2967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(441),
  [2969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1529),
  [2971] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_update_expression, 2, .production_id = 8),
  [2973] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_update_expression, 2, .production_id = 8),
  [2975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2973),
  [2977] = {.entry = {.count = 1, .reusable = false}}, SHIFT(348),
  [2979] = {.entry = {.count = 1, .reusable = false}}, SHIFT(349),
  [2981] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_assertion, 2),
  [2983] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_assertion, 2),
  [2985] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array, 2),
  [2987] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array, 2),
  [2989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1198),
  [2991] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_type, 1), SHIFT(811),
  [2994] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object, 3, .production_id = 28),
  [2996] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object, 3, .production_id = 28),
  [2998] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object, 3),
  [3000] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object, 3),
  [3002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3260),
  [3004] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_type, 1, .production_id = 14), SHIFT(811),
  [3007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3330),
  [3009] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array, 3),
  [3011] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object, 4, .production_id = 28),
  [3013] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object, 4, .production_id = 28),
  [3015] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object, 4),
  [3017] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object, 4),
  [3019] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array, 4),
  [3021] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array, 4),
  [3023] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array, 2), REDUCE(sym__tuple_type_body, 2),
  [3026] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_array, 2), REDUCE(sym__tuple_type_body, 2),
  [3029] = {.entry = {.count = 1, .reusable = false}}, SHIFT(376),
  [3031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(691),
  [3033] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arrow_function, 3, .production_id = 61),
  [3035] = {.entry = {.count = 1, .reusable = false}}, SHIFT(679),
  [3037] = {.entry = {.count = 1, .reusable = false}}, SHIFT(415),
  [3039] = {.entry = {.count = 1, .reusable = false}}, SHIFT(52),
  [3041] = {.entry = {.count = 1, .reusable = false}}, SHIFT(350),
  [3043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(419),
  [3045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(411),
  [3047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(376),
  [3049] = {.entry = {.count = 1, .reusable = false}}, SHIFT(419),
  [3051] = {.entry = {.count = 1, .reusable = false}}, SHIFT(411),
  [3053] = {.entry = {.count = 1, .reusable = false}}, SHIFT(410),
  [3055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(401),
  [3057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(415),
  [3059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(259),
  [3061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1172),
  [3063] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 63),
  [3065] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_binary_expression, 3, .production_id = 63),
  [3067] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 63), SHIFT(52),
  [3070] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_as_expression, 3),
  [3072] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_as_expression, 3),
  [3074] = {.entry = {.count = 1, .reusable = false}}, SHIFT(865),
  [3076] = {.entry = {.count = 1, .reusable = false}}, SHIFT(808),
  [3078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(904),
  [3080] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_nested_identifier, 3), REDUCE(sym_nested_type_identifier, 3, .production_id = 94),
  [3083] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_expression, 3, .production_id = 60),
  [3085] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arrow_function, 4, .production_id = 99),
  [3087] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 3, .production_id = 57),
  [3089] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 3, .production_id = 57),
  [3091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(737),
  [3093] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 3, .production_id = 55),
  [3095] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 3, .production_id = 55),
  [3097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(26),
  [3099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3357),
  [3101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1139),
  [3103] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arrow_function, 4, .production_id = 101),
  [3105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23),
  [3107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3381),
  [3109] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arrow_function, 4, .production_id = 102),
  [3111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(245),
  [3113] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sequence_expression, 3, .production_id = 60),
  [3115] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 2),
  [3117] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 2),
  [3119] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameters, 2),
  [3121] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yield_expression, 3),
  [3123] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unary_expression, 2, .production_id = 8),
  [3125] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unary_expression, 2, .production_id = 8),
  [3127] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_unary_expression, 2, .production_id = 8), SHIFT(52),
  [3130] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_await_expression, 2),
  [3132] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yield_expression, 2),
  [3134] = {.entry = {.count = 1, .reusable = false}}, SHIFT(373),
  [3136] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 1, .production_id = 10),
  [3138] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1), SHIFT(222),
  [3141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(222),
  [3143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(371),
  [3145] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 1, .production_id = 9),
  [3147] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1), SHIFT(216),
  [3150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(216),
  [3152] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1), REDUCE(sym_literal_type, 1),
  [3155] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1), REDUCE(sym_literal_type, 1),
  [3158] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ternary_expression, 5, .production_id = 135),
  [3160] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1), REDUCE(sym__primary_type, 1),
  [3163] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1), REDUCE(sym__primary_type, 1),
  [3166] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_augmented_assignment_expression, 3, .production_id = 60),
  [3168] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arrow_function, 3, .production_id = 67),
  [3170] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_expression, 3, .production_id = 66),
  [3172] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_expression, 3, .production_id = 65),
  [3174] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_expression, 3, .production_id = 22),
  [3176] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arrow_function, 3, .production_id = 25),
  [3178] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function, 4, .production_id = 100),
  [3180] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function, 4, .production_id = 100),
  [3182] = {.entry = {.count = 1, .reusable = false}}, SHIFT(269),
  [3184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(693),
  [3186] = {.entry = {.count = 1, .reusable = false}}, SHIFT(855),
  [3188] = {.entry = {.count = 1, .reusable = false}}, SHIFT(274),
  [3190] = {.entry = {.count = 1, .reusable = false}}, SHIFT(58),
  [3192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2959),
  [3194] = {.entry = {.count = 1, .reusable = false}}, SHIFT(277),
  [3196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(278),
  [3198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(279),
  [3200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(269),
  [3202] = {.entry = {.count = 1, .reusable = false}}, SHIFT(278),
  [3204] = {.entry = {.count = 1, .reusable = false}}, SHIFT(279),
  [3206] = {.entry = {.count = 1, .reusable = false}}, SHIFT(280),
  [3208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(281),
  [3210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(274),
  [3212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(282),
  [3214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1608),
  [3216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(838),
  [3218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(839),
  [3220] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_assignment_pattern, 3, .production_id = 66), REDUCE(sym_assignment_expression, 3, .production_id = 66),
  [3223] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_pattern, 3, .production_id = 66),
  [3225] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_assignment_pattern, 3, .production_id = 65), REDUCE(sym_assignment_expression, 3, .production_id = 65),
  [3228] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_pattern, 3, .production_id = 65),
  [3230] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arrow_function, 4, .production_id = 101),
  [3232] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arrow_function, 3, .production_id = 61),
  [3234] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_assignment_pattern, 3, .production_id = 76), REDUCE(sym_assignment_expression, 3, .production_id = 60),
  [3237] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_pattern, 3, .production_id = 76),
  [3239] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 3, .production_id = 59),
  [3241] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 3, .production_id = 59),
  [3243] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_string, 3),
  [3245] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_string, 3),
  [3247] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_unary_expression, 2, .production_id = 8), SHIFT(58),
  [3250] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_assignment_pattern, 3, .production_id = 76), REDUCE(sym_assignment_expression, 3, .production_id = 22),
  [3253] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 3, .production_id = 26),
  [3255] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 3, .production_id = 26),
  [3257] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arrow_function, 3, .production_id = 25),
  [3259] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arrow_function, 4, .production_id = 99),
  [3261] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 4, .production_id = 98),
  [3263] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 4, .production_id = 98),
  [3265] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 3, .production_id = 56),
  [3267] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 3, .production_id = 56),
  [3269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3121),
  [3271] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 63), SHIFT(58),
  [3274] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_meta_property, 3),
  [3276] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_meta_property, 3),
  [3278] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 2, .production_id = 18),
  [3280] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 2, .production_id = 18),
  [3282] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_update_expression, 2, .production_id = 17),
  [3284] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_update_expression, 2, .production_id = 17),
  [3286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(949),
  [3288] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 3, .production_id = 54),
  [3290] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 3, .production_id = 54),
  [3292] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_regex, 4, .production_id = 95),
  [3294] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_regex, 4, .production_id = 95),
  [3296] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function, 3, .production_id = 53),
  [3298] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function, 3, .production_id = 53),
  [3300] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 3, .production_id = 52),
  [3302] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 3, .production_id = 52),
  [3304] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 3, .production_id = 64),
  [3306] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 3, .production_id = 64),
  [3308] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 3, .production_id = 51),
  [3310] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 3, .production_id = 51),
  [3312] = {.entry = {.count = 1, .reusable = false}}, SHIFT(315),
  [3314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(706),
  [3316] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extends_clause, 2),
  [3318] = {.entry = {.count = 1, .reusable = false}}, SHIFT(967),
  [3320] = {.entry = {.count = 1, .reusable = false}}, SHIFT(318),
  [3322] = {.entry = {.count = 1, .reusable = false}}, SHIFT(56),
  [3324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3040),
  [3326] = {.entry = {.count = 1, .reusable = false}}, SHIFT(365),
  [3328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(326),
  [3330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(336),
  [3332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(315),
  [3334] = {.entry = {.count = 1, .reusable = false}}, SHIFT(326),
  [3336] = {.entry = {.count = 1, .reusable = false}}, SHIFT(336),
  [3338] = {.entry = {.count = 1, .reusable = false}}, SHIFT(344),
  [3340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(357),
  [3342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(318),
  [3344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(370),
  [3346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1745),
  [3348] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extends_clause, 2),
  [3350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(669),
  [3352] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_string, 2),
  [3354] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_string, 2),
  [3356] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_spread_element, 2),
  [3358] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function, 5, .production_id = 129),
  [3360] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function, 5, .production_id = 129),
  [3362] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arrow_function, 3, .production_id = 67),
  [3364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(630),
  [3366] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 4),
  [3368] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 4),
  [3370] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 5, .production_id = 139),
  [3372] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 5, .production_id = 139),
  [3374] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function, 4, .production_id = 100),
  [3376] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function, 4, .production_id = 100),
  [3378] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 2, .production_id = 13),
  [3380] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 2, .production_id = 13),
  [3382] = {.entry = {.count = 1, .reusable = false}}, SHIFT(313),
  [3384] = {.entry = {.count = 1, .reusable = false}}, SHIFT(339),
  [3386] = {.entry = {.count = 1, .reusable = false}}, SHIFT(57),
  [3388] = {.entry = {.count = 1, .reusable = false}}, SHIFT(294),
  [3390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(342),
  [3392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(345),
  [3394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(313),
  [3396] = {.entry = {.count = 1, .reusable = false}}, SHIFT(342),
  [3398] = {.entry = {.count = 1, .reusable = false}}, SHIFT(345),
  [3400] = {.entry = {.count = 1, .reusable = false}}, SHIFT(416),
  [3402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(412),
  [3404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(339),
  [3406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(394),
  [3408] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arrow_function, 4, .production_id = 102),
  [3410] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 4, .production_id = 105),
  [3412] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 4, .production_id = 105),
  [3414] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 4, .production_id = 106),
  [3416] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 4, .production_id = 106),
  [3418] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 4, .production_id = 108),
  [3420] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 4, .production_id = 108),
  [3422] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 3),
  [3424] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 3),
  [3426] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 4, .production_id = 111),
  [3428] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 4, .production_id = 111),
  [3430] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 4, .production_id = 75),
  [3432] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 4, .production_id = 75),
  [3434] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 4, .production_id = 112),
  [3436] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 4, .production_id = 112),
  [3438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2556),
  [3440] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assignment_expression, 3, .production_id = 66),
  [3442] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_unary_expression, 2, .production_id = 8), SHIFT(57),
  [3445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2585),
  [3447] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assignment_expression, 3, .production_id = 65),
  [3449] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_array_repeat1, 2),
  [3451] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_await_expression, 2),
  [3453] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 63), SHIFT(57),
  [3456] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yield_expression, 2),
  [3458] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 63), SHIFT(56),
  [3461] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_extends_clause_repeat1, 2),
  [3463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1866),
  [3465] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ternary_expression, 5, .production_id = 135),
  [3467] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_unary_expression, 2, .production_id = 8), SHIFT(56),
  [3470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3281),
  [3472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(145),
  [3474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(972),
  [3476] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_type, 1, .production_id = 14), SHIFT(827),
  [3479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3374),
  [3481] = {.entry = {.count = 1, .reusable = false}}, SHIFT(378),
  [3483] = {.entry = {.count = 1, .reusable = false}}, SHIFT(384),
  [3485] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_regex, 3, .production_id = 49),
  [3487] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_regex, 3, .production_id = 49),
  [3489] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1175),
  [3491] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_type, 1), SHIFT(827),
  [3494] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_augmented_assignment_expression, 3, .production_id = 60),
  [3496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(255),
  [3498] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__initializer, 2, .production_id = 80),
  [3500] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yield_expression, 3),
  [3502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1232),
  [3504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1235),
  [3506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1340),
  [3508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1355),
  [3510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1042),
  [3512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(566),
  [3514] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_extends_clause_repeat1, 2),
  [3516] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assignment_expression, 3, .production_id = 22),
  [3518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1562),
  [3520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1635),
  [3522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(569),
  [3524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(969),
  [3526] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assignment_expression, 3, .production_id = 60),
  [3528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2396),
  [3530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2068),
  [3532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1286),
  [3534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1683),
  [3536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(521),
  [3538] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pair, 3, .production_id = 77),
  [3540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(958),
  [3542] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array, 3), REDUCE(sym_computed_property_name, 3),
  [3545] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_computed_property_name, 3),
  [3547] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_array, 3), REDUCE(sym_computed_property_name, 3),
  [3550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(822),
  [3552] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_unary_expression, 2, .production_id = 8), SHIFT(53),
  [3555] = {.entry = {.count = 1, .reusable = false}}, SHIFT(340),
  [3557] = {.entry = {.count = 1, .reusable = false}}, SHIFT(343),
  [3559] = {.entry = {.count = 1, .reusable = false}}, SHIFT(53),
  [3561] = {.entry = {.count = 1, .reusable = false}}, SHIFT(383),
  [3563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(353),
  [3565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(366),
  [3567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(340),
  [3569] = {.entry = {.count = 1, .reusable = false}}, SHIFT(353),
  [3571] = {.entry = {.count = 1, .reusable = false}}, SHIFT(366),
  [3573] = {.entry = {.count = 1, .reusable = false}}, SHIFT(369),
  [3575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(387),
  [3577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(343),
  [3579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(389),
  [3581] = {.entry = {.count = 1, .reusable = false}}, SHIFT(789),
  [3583] = {.entry = {.count = 1, .reusable = false}}, SHIFT(790),
  [3585] = {.entry = {.count = 1, .reusable = false}}, SHIFT(286),
  [3587] = {.entry = {.count = 1, .reusable = false}}, SHIFT(287),
  [3589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(777),
  [3591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(887),
  [3593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2741),
  [3595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1719),
  [3597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2573),
  [3599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(673),
  [3601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(678),
  [3603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(767),
  [3605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(36),
  [3607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(971),
  [3609] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__parameter_name, 1),
  [3611] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__expression, 1), REDUCE(sym__parameter_name, 1), REDUCE(sym__primary_type, 1),
  [3615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(550),
  [3617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(974),
  [3619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(973),
  [3621] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1573),
  [3623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(964),
  [3625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(676),
  [3627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(749),
  [3629] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1), SHIFT(173),
  [3632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(173),
  [3634] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_unary_expression, 2, .production_id = 8), SHIFT(55),
  [3637] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 63), SHIFT(53),
  [3640] = {.entry = {.count = 1, .reusable = false}}, SHIFT(312),
  [3642] = {.entry = {.count = 1, .reusable = false}}, SHIFT(322),
  [3644] = {.entry = {.count = 1, .reusable = false}}, SHIFT(55),
  [3646] = {.entry = {.count = 1, .reusable = false}}, SHIFT(391),
  [3648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(327),
  [3650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(332),
  [3652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(312),
  [3654] = {.entry = {.count = 1, .reusable = false}}, SHIFT(327),
  [3656] = {.entry = {.count = 1, .reusable = false}}, SHIFT(332),
  [3658] = {.entry = {.count = 1, .reusable = false}}, SHIFT(337),
  [3660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(341),
  [3662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(322),
  [3664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(347),
  [3666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(629),
  [3668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(632),
  [3670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(628),
  [3672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(633),
  [3674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9),
  [3676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3243),
  [3678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(631),
  [3680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(626),
  [3682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(46),
  [3684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(635),
  [3686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(597),
  [3688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(634),
  [3690] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_type, 1, .production_id = 14), SHIFT(891),
  [3693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(857),
  [3695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3238),
  [3697] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 63), SHIFT(55),
  [3700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(666),
  [3702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2511),
  [3704] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1), SHIFT(193),
  [3707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(193),
  [3709] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_type, 1), SHIFT(891),
  [3712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(397),
  [3714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1932),
  [3716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1711),
  [3718] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1767),
  [3720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1971),
  [3722] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1783),
  [3724] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1925),
  [3726] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1816),
  [3728] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1752),
  [3730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1678),
  [3732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(612),
  [3734] = {.entry = {.count = 1, .reusable = false}}, SHIFT(22),
  [3736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3312),
  [3738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2331),
  [3740] = {.entry = {.count = 1, .reusable = false}}, SHIFT(324),
  [3742] = {.entry = {.count = 1, .reusable = false}}, SHIFT(386),
  [3744] = {.entry = {.count = 1, .reusable = false}}, SHIFT(840),
  [3746] = {.entry = {.count = 1, .reusable = false}}, SHIFT(843),
  [3748] = {.entry = {.count = 1, .reusable = false}}, SHIFT(377),
  [3750] = {.entry = {.count = 1, .reusable = false}}, SHIFT(372),
  [3752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(553),
  [3754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(913),
  [3756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(74),
  [3758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(305),
  [3760] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2140),
  [3762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2548),
  [3764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(137),
  [3766] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1811),
  [3768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2200),
  [3770] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1798),
  [3772] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1846),
  [3774] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1863),
  [3776] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1789),
  [3778] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2153),
  [3780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1569),
  [3782] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1829),
  [3784] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1828),
  [3786] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1842),
  [3788] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1861),
  [3790] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1823),
  [3792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1270),
  [3794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(507),
  [3796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(717),
  [3798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(402),
  [3800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1739),
  [3802] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1), REDUCE(sym__property_name, 1),
  [3805] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__property_name, 1),
  [3807] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1), REDUCE(sym__property_name, 1),
  [3810] = {.entry = {.count = 1, .reusable = false}}, SHIFT(359),
  [3812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(268),
  [3814] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2120),
  [3816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1031),
  [3818] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1827),
  [3820] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1830),
  [3822] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1835),
  [3824] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1859),
  [3826] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1833),
  [3828] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__parameter_name, 1, .production_id = 11), SHIFT(384),
  [3831] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1), REDUCE(sym__parameter_name, 1, .production_id = 11),
  [3834] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1), REDUCE(sym__parameter_name, 1, .production_id = 11),
  [3837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2013),
  [3839] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1718),
  [3841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(328),
  [3843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(86),
  [3845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1202),
  [3847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(502),
  [3849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1164),
  [3851] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__parameter_name, 1, .production_id = 12), SHIFT(378),
  [3854] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1), REDUCE(sym__parameter_name, 1, .production_id = 12),
  [3857] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 1, .production_id = 12),
  [3859] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1), REDUCE(sym__parameter_name, 1, .production_id = 12),
  [3862] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 1, .production_id = 11),
  [3864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(400),
  [3866] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(2046),
  [3869] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(1932),
  [3872] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2),
  [3874] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(217),
  [3877] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(1767),
  [3880] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(3175),
  [3883] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(2634),
  [3886] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(2635),
  [3889] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(1971),
  [3892] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(2827),
  [3895] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(1783),
  [3898] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(1925),
  [3901] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(1816),
  [3904] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(1778),
  [3907] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(1752),
  [3910] = {.entry = {.count = 1, .reusable = false}}, SHIFT(362),
  [3912] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2132),
  [3914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1216),
  [3916] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1800),
  [3918] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1802),
  [3920] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1837),
  [3922] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1865),
  [3924] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1805),
  [3926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1346),
  [3928] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2136),
  [3930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2397),
  [3932] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1793),
  [3934] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1792),
  [3936] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1839),
  [3938] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1864),
  [3940] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1790),
  [3942] = {.entry = {.count = 1, .reusable = false}}, SHIFT(405),
  [3944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1930),
  [3946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(297),
  [3948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(180),
  [3950] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1770),
  [3952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1989),
  [3954] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1804),
  [3956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(408),
  [3958] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1781),
  [3960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(335),
  [3962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2287),
  [3964] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1908),
  [3966] = {.entry = {.count = 1, .reusable = false}}, SHIFT(409),
  [3968] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2201),
  [3970] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1845),
  [3972] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1847),
  [3974] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1852),
  [3976] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1867),
  [3978] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1849),
  [3980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1929),
  [3982] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1765),
  [3984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1972),
  [3986] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1944),
  [3988] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1813),
  [3990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1940),
  [3992] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1775),
  [3994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1976),
  [3996] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1927),
  [3998] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1820),
  [4000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1935),
  [4002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2313),
  [4004] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1899),
  [4006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1943),
  [4008] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1782),
  [4010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1993),
  [4012] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1832),
  [4014] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1776),
  [4016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1984),
  [4018] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1812),
  [4020] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1763),
  [4022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2265),
  [4024] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1893),
  [4026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2351),
  [4028] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1906),
  [4030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1928),
  [4032] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1772),
  [4034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1991),
  [4036] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1803),
  [4038] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1777),
  [4040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2289),
  [4042] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1896),
  [4044] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1784),
  [4046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1931),
  [4048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2291),
  [4050] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1907),
  [4052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1950),
  [4054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2368),
  [4056] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1892),
  [4058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1938),
  [4060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2294),
  [4062] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1902),
  [4064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1949),
  [4066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2317),
  [4068] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1901),
  [4070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2261),
  [4072] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1905),
  [4074] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1774),
  [4076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1992),
  [4078] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1799),
  [4080] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1786),
  [4082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1977),
  [4084] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1788),
  [4086] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1779),
  [4088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1939),
  [4090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2303),
  [4092] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1903),
  [4094] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1766),
  [4096] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1773),
  [4098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1990),
  [4100] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1825),
  [4102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1936),
  [4104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2359),
  [4106] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1898),
  [4108] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2186),
  [4110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2911),
  [4112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(147),
  [4114] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1897),
  [4116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1937),
  [4118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2538),
  [4120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2406),
  [4122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2212),
  [4124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2081),
  [4126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2328),
  [4128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2429),
  [4130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2910),
  [4132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2786),
  [4134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2232),
  [4136] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_decorator, 2),
  [4138] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decorator, 2),
  [4140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(144),
  [4142] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3203),
  [4144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2393),
  [4146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2215),
  [4148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2418),
  [4150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2225),
  [4152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2103),
  [4154] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2075),
  [4156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2415),
  [4158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2267),
  [4160] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_decorator_member_expression, 3, .production_id = 58),
  [4162] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decorator_member_expression, 3, .production_id = 58),
  [4164] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_object_repeat1, 2, .production_id = 28),
  [4166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(301),
  [4168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(346),
  [4170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2193),
  [4172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2966),
  [4174] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_decorator_call_expression, 2, .production_id = 18),
  [4176] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decorator_call_expression, 2, .production_id = 18),
  [4178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(199),
  [4180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2268),
  [4182] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 7, .production_id = 183),
  [4184] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 7, .production_id = 183),
  [4186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1934),
  [4188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2290),
  [4190] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1895),
  [4192] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 5, .production_id = 131),
  [4194] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 5, .production_id = 131),
  [4196] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 5, .production_id = 142),
  [4198] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 5, .production_id = 142),
  [4200] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 8, .production_id = 192),
  [4202] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 8, .production_id = 192),
  [4204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1948),
  [4206] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1878),
  [4208] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1894),
  [4210] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1875),
  [4212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1946),
  [4214] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1870),
  [4216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2288),
  [4218] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1904),
  [4220] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 3, .production_id = 78),
  [4222] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 3, .production_id = 78),
  [4224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1880),
  [4226] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 9, .production_id = 197),
  [4228] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 9, .production_id = 197),
  [4230] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 8, .production_id = 193),
  [4232] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 8, .production_id = 193),
  [4234] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 1),
  [4236] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 1),
  [4238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1913),
  [4240] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 6, .production_id = 158),
  [4242] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 6, .production_id = 158),
  [4244] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 7, .production_id = 182),
  [4246] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 7, .production_id = 182),
  [4248] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 6, .production_id = 164),
  [4250] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 6, .production_id = 164),
  [4252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1881),
  [4254] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 4, .production_id = 116),
  [4256] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 4, .production_id = 116),
  [4258] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 4, .production_id = 104),
  [4260] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 4, .production_id = 104),
  [4262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2321),
  [4264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2353),
  [4266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2315),
  [4268] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2503),
  [4270] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2504),
  [4272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2296),
  [4274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2455),
  [4276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2622),
  [4278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(599),
  [4280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2379),
  [4282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2431),
  [4284] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2),
  [4286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(560),
  [4288] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_export_statement_repeat1, 2, .production_id = 21),
  [4290] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_export_statement_repeat1, 2, .production_id = 21),
  [4292] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_export_statement_repeat1, 2, .production_id = 21), SHIFT_REPEAT(2827),
  [4295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2607),
  [4297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2541),
  [4299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(592),
  [4301] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1780),
  [4303] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1919),
  [4305] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1756),
  [4307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1942),
  [4309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1974),
  [4311] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1795),
  [4313] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1794),
  [4315] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1771),
  [4317] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1874),
  [4319] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1768),
  [4321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1947),
  [4323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1979),
  [4325] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1834),
  [4327] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1822),
  [4329] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_export_statement_repeat1, 1, .production_id = 2),
  [4331] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_export_statement_repeat1, 1, .production_id = 2),
  [4333] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1900),
  [4335] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3143),
  [4337] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3170),
  [4339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(906),
  [4341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3171),
  [4343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3181),
  [4345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(815),
  [4347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(813),
  [4349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(812),
  [4351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(418),
  [4353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(374),
  [4355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(352),
  [4357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(392),
  [4359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(314),
  [4361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(289),
  [4363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(393),
  [4365] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 1, .production_id = 5),
  [4367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2170),
  [4369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1996),
  [4371] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 2, .production_id = 73),
  [4373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2242),
  [4375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2009),
  [4377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(836),
  [4379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3262),
  [4381] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 3, .production_id = 123),
  [4383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2205),
  [4385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2007),
  [4387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3376),
  [4389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(897),
  [4391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1999),
  [4393] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, .production_id = 153),
  [4395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2187),
  [4397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2000),
  [4399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1998),
  [4401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(825),
  [4403] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary_type, 1, .production_id = 14), REDUCE(sym_type_parameter, 1, .production_id = 14),
  [4406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(824),
  [4408] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary_type, 1, .production_id = 14), SHIFT(824),
  [4411] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 1, .production_id = 5),
  [4413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2005),
  [4415] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 2, .production_id = 73),
  [4417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2004),
  [4419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(54),
  [4421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2003),
  [4423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1995),
  [4425] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 4, .production_id = 153),
  [4427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1997),
  [4429] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 3, .production_id = 123),
  [4431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2001),
  [4433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2006),
  [4435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1994),
  [4437] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 4, .production_id = 123),
  [4439] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 3, .production_id = 73),
  [4441] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 2, .production_id = 5),
  [4443] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 5, .production_id = 153),
  [4445] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 3, .production_id = 73),
  [4447] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, .production_id = 123),
  [4449] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, .production_id = 153),
  [4451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(903),
  [4453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3251),
  [4455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(848),
  [4457] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 2, .production_id = 5),
  [4459] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__parameter_name, 1), REDUCE(sym__primary_type, 1, .production_id = 14),
  [4462] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 2),
  [4464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(714),
  [4466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(784),
  [4468] = {.entry = {.count = 1, .reusable = false}}, SHIFT(787),
  [4470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(898),
  [4472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3249),
  [4474] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2104),
  [4476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1557),
  [4478] = {.entry = {.count = 1, .reusable = false}}, SHIFT(835),
  [4480] = {.entry = {.count = 1, .reusable = false}}, SHIFT(151),
  [4482] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2084),
  [4484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1518),
  [4486] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__call_signature, 2, .production_id = 20),
  [4488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(704),
  [4490] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2114),
  [4492] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2094),
  [4494] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_annotation, 2),
  [4496] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__call_signature, 1, .production_id = 3),
  [4498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(915),
  [4500] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2109),
  [4502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2799),
  [4504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3329),
  [4506] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2116),
  [4508] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2112),
  [4510] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2090),
  [4512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1623),
  [4514] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2091),
  [4516] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2100),
  [4518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2662),
  [4520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1616),
  [4522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1627),
  [4524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(835),
  [4526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(151),
  [4528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1539),
  [4530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1074),
  [4532] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_predicate, 3),
  [4534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1620),
  [4536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2139),
  [4538] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_asserts, 5),
  [4540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1506),
  [4542] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_annotation, 2),
  [4544] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__parameter_name, 1, .production_id = 1), REDUCE(sym_predefined_type, 1),
  [4547] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__parameter_name, 1), REDUCE(sym__primary_type, 1),
  [4550] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_omitting_type_annotation, 2),
  [4552] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_opting_type_annotation, 2),
  [4554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(760),
  [4556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(705),
  [4558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(847),
  [4560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(923),
  [4562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20),
  [4564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3338),
  [4566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3134),
  [4568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(911),
  [4570] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 6, .production_id = 185),
  [4572] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2137),
  [4574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1554),
  [4576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(128),
  [4578] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3319),
  [4580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2540),
  [4582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2278),
  [4584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1819),
  [4586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2383),
  [4588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2367),
  [4590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(518),
  [4592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3205),
  [4594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3018),
  [4596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(155),
  [4598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2574),
  [4600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2326),
  [4602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(288),
  [4604] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_required_parameter, 1),
  [4606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2302),
  [4608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3200),
  [4610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2133),
  [4612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3178),
  [4614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2549),
  [4616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2355),
  [4618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2575),
  [4620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2343),
  [4622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2434),
  [4624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(363),
  [4626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2426),
  [4628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2612),
  [4630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2266),
  [4632] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_construct_signature, 2),
  [4634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2438),
  [4636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2324),
  [4638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2444),
  [4640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2320),
  [4642] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter, 1, .production_id = 14),
  [4644] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameters, 6, .production_id = 149),
  [4646] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 2, .production_id = 93),
  [4648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2551),
  [4650] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameters, 3),
  [4652] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 5, .production_id = 174),
  [4654] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameters, 4),
  [4656] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 5, .production_id = 173),
  [4658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2558),
  [4660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2251),
  [4662] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 4, .production_id = 130),
  [4664] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 4, .production_id = 150),
  [4666] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameters, 5, .production_id = 120),
  [4668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2401),
  [4670] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_construct_signature, 3),
  [4672] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 3, .production_id = 125),
  [4674] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3173),
  [4676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2534),
  [4678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2281),
  [4680] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_asserts, 3),
  [4682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(842),
  [4684] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 3, .production_id = 103),
  [4686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2491),
  [4688] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 8, .production_id = 199),
  [4690] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 7, .production_id = 195),
  [4692] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 7, .production_id = 194),
  [4694] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 6, .production_id = 186),
  [4696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2532),
  [4698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3311),
  [4700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(544),
  [4702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(170),
  [4704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1019),
  [4706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(970),
  [4708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(240),
  [4710] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1459),
  [4712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2319),
  [4714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1703),
  [4716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(252),
  [4718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2370),
  [4720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1622),
  [4722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(727),
  [4724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1652),
  [4726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1007),
  [4728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(781),
  [4730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(782),
  [4732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2480),
  [4734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2137),
  [4736] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_object_type_repeat1, 2), SHIFT_REPEAT(1043),
  [4739] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_object_type_repeat1, 2),
  [4741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2461),
  [4743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2498),
  [4745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2432),
  [4747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2452),
  [4749] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__call_signature, 3, .production_id = 68),
  [4751] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_predicate_annotation, 2),
  [4753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1010),
  [4755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(765),
  [4757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(750),
  [4759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1507),
  [4761] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_template_string_repeat1, 2), SHIFT_REPEAT(2274),
  [4764] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_template_string_repeat1, 2),
  [4766] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_template_string_repeat1, 2), SHIFT_REPEAT(252),
  [4769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1017),
  [4771] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_switch_body_repeat1, 2), SHIFT_REPEAT(3311),
  [4774] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_switch_body_repeat1, 2),
  [4776] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_switch_body_repeat1, 2), SHIFT_REPEAT(170),
  [4779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1015),
  [4781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1643),
  [4783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2400),
  [4785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(615),
  [4787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(719),
  [4789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2154),
  [4791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2521),
  [4793] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__call_signature, 2, .production_id = 19),
  [4795] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_implements_clause, 2),
  [4797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(862),
  [4799] = {.entry = {.count = 1, .reusable = false}}, SHIFT(482),
  [4801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1002),
  [4803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2520),
  [4805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2518),
  [4807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2517),
  [4809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2408),
  [4811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2514),
  [4813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1012),
  [4815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2508),
  [4817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(698),
  [4819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2506),
  [4821] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1980),
  [4823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(711),
  [4825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1112),
  [4827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1014),
  [4829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1013),
  [4831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(425),
  [4833] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_parameter, 2),
  [4835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2382),
  [4837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1853),
  [4839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2059),
  [4841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3263),
  [4843] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2900),
  [4845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3253),
  [4847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2903),
  [4849] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3244),
  [4851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(910),
  [4853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(247),
  [4855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2579),
  [4857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2502),
  [4859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1018),
  [4861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2388),
  [4863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1016),
  [4865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2166),
  [4867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2274),
  [4869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1727),
  [4871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2436),
  [4873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2385),
  [4875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2435),
  [4877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1011),
  [4879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1451),
  [4881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2614),
  [4883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(966),
  [4885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(241),
  [4887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2403),
  [4889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(761),
  [4891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2782),
  [4893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2350),
  [4895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1196),
  [4897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2598),
  [4899] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2029),
  [4901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1856),
  [4903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2063),
  [4905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(677),
  [4907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(183),
  [4909] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constraint, 2),
  [4911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1009),
  [4913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3186),
  [4915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3185),
  [4917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2544),
  [4919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1008),
  [4921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2054),
  [4923] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_implements_clause_repeat1, 2),
  [4925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1005),
  [4927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(674),
  [4929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(192),
  [4931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1147),
  [4933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2611),
  [4935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1004),
  [4937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1056),
  [4939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2405),
  [4941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(736),
  [4943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2055),
  [4945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2524),
  [4947] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1048),
  [4949] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1955),
  [4951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(755),
  [4953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(273),
  [4955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2450),
  [4957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1006),
  [4959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1003),
  [4961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2542),
  [4963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2440),
  [4965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1576),
  [4967] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1280),
  [4969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(776),
  [4971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(186),
  [4973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3228),
  [4975] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 5),
  [4977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(821),
  [4979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1914),
  [4981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(619),
  [4983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1797),
  [4985] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 5, .production_id = 175),
  [4987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(28),
  [4989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(830),
  [4991] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, .production_id = 175),
  [4993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(583),
  [4995] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, .production_id = 176),
  [4997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(616),
  [4999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3206),
  [5001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3252),
  [5003] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 6, .production_id = 38),
  [5005] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 2, .production_id = 30),
  [5007] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 6),
  [5009] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameters, 4),
  [5011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(863),
  [5013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2836),
  [5015] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_default_type, 2),
  [5017] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 2, .production_id = 30),
  [5019] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 6, .production_id = 184),
  [5021] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, .production_id = 152),
  [5023] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, .production_id = 151),
  [5025] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 6, .production_id = 187),
  [5027] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 2, .production_id = 30),
  [5029] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 2, .production_id = 32),
  [5031] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 2, .production_id = 34),
  [5033] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 6, .production_id = 187),
  [5035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3269),
  [5037] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 4, .production_id = 152),
  [5039] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 4, .production_id = 151),
  [5041] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 2, .production_id = 39),
  [5043] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 2, .production_id = 40),
  [5045] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 7, .production_id = 88),
  [5047] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_construct_signature, 4),
  [5049] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 4),
  [5051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2560),
  [5053] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 7),
  [5055] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_signature, 1, .production_id = 47),
  [5057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2596),
  [5059] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 3, .production_id = 90),
  [5061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(590),
  [5063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(787),
  [5065] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 3, .production_id = 89),
  [5067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2593),
  [5069] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 3),
  [5071] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 3, .production_id = 88),
  [5073] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 8, .production_id = 198),
  [5075] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 8, .production_id = 184),
  [5077] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 3, .production_id = 124),
  [5079] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameters, 3),
  [5081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(841),
  [5083] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 5, .production_id = 176),
  [5085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3176),
  [5087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1910),
  [5089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2530),
  [5091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2559),
  [5093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2482),
  [5095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3313),
  [5097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(783),
  [5099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(819),
  [5101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(807),
  [5103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2477),
  [5105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2465),
  [5107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2822),
  [5109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2441),
  [5111] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 3, .production_id = 81),
  [5113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(620),
  [5115] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 3, .production_id = 124),
  [5117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(828),
  [5119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(833),
  [5121] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameters, 5),
  [5123] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 3, .production_id = 81),
  [5125] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1961),
  [5127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2650),
  [5129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2650),
  [5131] = {.entry = {.count = 1, .reusable = false}}, SHIFT_EXTRA(),
  [5133] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_enum_body_repeat1, 2),
  [5135] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extends_clause, 3, .production_id = 48),
  [5137] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extends_clause, 3, .production_id = 48),
  [5139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(894),
  [5141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(899),
  [5143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(809),
  [5145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2075),
  [5147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(791),
  [5149] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2155),
  [5151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2647),
  [5153] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2647),
  [5155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(901),
  [5157] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1959),
  [5159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2621),
  [5161] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2621),
  [5163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2714),
  [5165] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2714),
  [5167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1276),
  [5169] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_extends_clause_repeat1, 2), SHIFT_REPEAT(159),
  [5172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1475),
  [5174] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2131),
  [5176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2631),
  [5178] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2631),
  [5180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2632),
  [5182] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2632),
  [5184] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1021),
  [5186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2748),
  [5188] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2748),
  [5190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(795),
  [5192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1556),
  [5194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(888),
  [5196] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_extends_clause_repeat1, 2), SHIFT_REPEAT(154),
  [5199] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_string_repeat2, 2),
  [5201] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_repeat2, 2), SHIFT_REPEAT(2647),
  [5204] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_repeat2, 2), SHIFT_REPEAT(2647),
  [5207] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_variable_declaration_repeat1, 2), SHIFT_REPEAT(2314),
  [5210] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_variable_declaration_repeat1, 2),
  [5212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1625),
  [5214] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_string_repeat1, 2),
  [5216] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(2650),
  [5219] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(2650),
  [5222] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1648),
  [5224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1386),
  [5226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(870),
  [5228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(478),
  [5230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(747),
  [5232] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter, 2, .production_id = 14),
  [5234] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__tuple_type_member, 1),
  [5236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2848),
  [5238] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1533),
  [5240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2653),
  [5242] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2653),
  [5244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2654),
  [5246] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2654),
  [5248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(779),
  [5250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(450),
  [5252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1973),
  [5254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1850),
  [5256] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_array_repeat1, 2), SHIFT_REPEAT(132),
  [5259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2164),
  [5261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2362),
  [5263] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_parameter, 3),
  [5265] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_mapped_type_clause, 3, .production_id = 14),
  [5267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2363),
  [5269] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_required_parameter, 2),
  [5271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(889),
  [5273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2314),
  [5275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(548),
  [5277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2169),
  [5279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(549),
  [5281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2851),
  [5283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(579),
  [5285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2023),
  [5287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2060),
  [5289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(738),
  [5291] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extends_clause, 3),
  [5293] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extends_clause, 3),
  [5295] = {.entry = {.count = 1, .reusable = false}}, SHIFT(92),
  [5297] = {.entry = {.count = 1, .reusable = false}}, SHIFT(436),
  [5299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1446),
  [5301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(722),
  [5303] = {.entry = {.count = 1, .reusable = false}}, SHIFT(90),
  [5305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2736),
  [5307] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2736),
  [5309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2590),
  [5311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2587),
  [5313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2032),
  [5315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(752),
  [5317] = {.entry = {.count = 1, .reusable = false}}, SHIFT(432),
  [5319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2688),
  [5321] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2688),
  [5323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2690),
  [5325] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2690),
  [5327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2687),
  [5329] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2687),
  [5331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(196),
  [5333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(757),
  [5335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(850),
  [5337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1111),
  [5339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(805),
  [5341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2051),
  [5343] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_implements_clause_repeat1, 2), SHIFT_REPEAT(862),
  [5346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(713),
  [5348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(427),
  [5350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1058),
  [5352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2750),
  [5354] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2750),
  [5356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2305),
  [5358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2306),
  [5360] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1053),
  [5362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2073),
  [5364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2537),
  [5366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(613),
  [5368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1040),
  [5370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(608),
  [5372] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rest_parameter, 1),
  [5374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1953),
  [5376] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1080),
  [5378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2724),
  [5380] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2724),
  [5382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2725),
  [5384] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2725),
  [5386] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_substitution, 3),
  [5388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2550),
  [5390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(869),
  [5392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2555),
  [5394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(810),
  [5396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2323),
  [5398] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1022),
  [5400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2322),
  [5402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2398),
  [5404] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_method_signature, 4, .production_id = 150),
  [5406] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 2, .production_id = 29),
  [5408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1514),
  [5410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(912),
  [5412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1862),
  [5414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2211),
  [5416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2830),
  [5418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2820),
  [5420] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 2, .production_id = 31),
  [5422] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 2, .production_id = 33),
  [5424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2127),
  [5426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2012),
  [5428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1831),
  [5430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(922),
  [5432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1801),
  [5434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(735),
  [5436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1435),
  [5438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2467),
  [5440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1224),
  [5442] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2923),
  [5444] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3298),
  [5446] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, .production_id = 154),
  [5448] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rest_identifier, 1),
  [5450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(448),
  [5452] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_implements_clause, 3),
  [5454] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, .production_id = 155),
  [5456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(109),
  [5458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2956),
  [5460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2592),
  [5462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2428),
  [5464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3283),
  [5466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2689),
  [5468] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_clause, 1),
  [5470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2567),
  [5472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3275),
  [5474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2943),
  [5476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(604),
  [5478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1791),
  [5480] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 2, .production_id = 29),
  [5482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1394),
  [5484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2942),
  [5486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(618),
  [5488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2378),
  [5490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2392),
  [5492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1810),
  [5494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2390),
  [5496] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, .production_id = 156),
  [5498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2417),
  [5500] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_parameters_repeat1, 2), SHIFT_REPEAT(2991),
  [5503] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_parameters_repeat1, 2),
  [5505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1060),
  [5507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2613),
  [5509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(745),
  [5511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2821),
  [5513] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_parameters, 5),
  [5515] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_clause, 4, .production_id = 114),
  [5517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(724),
  [5519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2818),
  [5521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1814),
  [5523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1110),
  [5525] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_parameters, 4),
  [5527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2050),
  [5529] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_export_clause_repeat1, 2), SHIFT_REPEAT(2651),
  [5532] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_export_clause_repeat1, 2),
  [5534] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_parameters, 3),
  [5536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1676),
  [5538] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_clause, 5, .production_id = 114),
  [5540] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_object_repeat1, 2), SHIFT_REPEAT(1715),
  [5543] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_object_repeat1, 2),
  [5545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1046),
  [5547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1818),
  [5549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1208),
  [5551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1577),
  [5553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(446),
  [5555] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_method_signature, 4, .production_id = 130),
  [5557] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_identifier, 2),
  [5559] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 7, .production_id = 196),
  [5561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1045),
  [5563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1044),
  [5565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(47),
  [5567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1140),
  [5569] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, .production_id = 157),
  [5571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2586),
  [5573] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_method_signature, 6, .production_id = 185),
  [5575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1912),
  [5577] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 6, .production_id = 191),
  [5579] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 6, .production_id = 190),
  [5581] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 6, .production_id = 189),
  [5583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1527),
  [5585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1526),
  [5587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1206),
  [5589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1654),
  [5591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1917),
  [5593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2581),
  [5595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(740),
  [5597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(881),
  [5599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2158),
  [5601] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_clause, 3),
  [5603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3382),
  [5605] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__import_export_specifier, 2, .production_id = 73),
  [5607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2420),
  [5609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(756),
  [5611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2784),
  [5613] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 3, .production_id = 82),
  [5615] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 3, .production_id = 127),
  [5617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1807),
  [5619] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_body_repeat1, 2), SHIFT_REPEAT(1922),
  [5622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2125),
  [5624] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_method_signature, 3, .production_id = 103),
  [5626] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 3, .production_id = 126),
  [5628] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__tuple_type_body_repeat1, 2), SHIFT_REPEAT(2127),
  [5631] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__tuple_type_body_repeat1, 2),
  [5633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(115),
  [5635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3013),
  [5637] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_method_signature, 5, .production_id = 174),
  [5639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1151),
  [5641] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, .production_id = 180),
  [5643] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_method_signature, 5, .production_id = 173),
  [5645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2580),
  [5647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2878),
  [5649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3213),
  [5651] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__import_export_specifier, 1, .production_id = 5),
  [5653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1815),
  [5655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2421),
  [5657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(774),
  [5659] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_clause, 2),
  [5661] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_formal_parameters_repeat1, 2, .production_id = 21), SHIFT_REPEAT(1840),
  [5664] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_formal_parameters_repeat1, 2, .production_id = 21),
  [5666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(725),
  [5668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2760),
  [5670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2834),
  [5672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2533),
  [5674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1787),
  [5676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2770),
  [5678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1030),
  [5680] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, .production_id = 179),
  [5682] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, .production_id = 178),
  [5684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1821),
  [5686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2222),
  [5688] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 3, .production_id = 84),
  [5690] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_named_imports_repeat1, 2), SHIFT_REPEAT(2656),
  [5693] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_named_imports_repeat1, 2),
  [5695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1619),
  [5697] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_heritage, 1),
  [5699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(578),
  [5701] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 3, .production_id = 83),
  [5703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(712),
  [5705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2812),
  [5707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2522),
  [5709] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 3, .production_id = 82),
  [5711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1586),
  [5713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2539),
  [5715] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 3, .production_id = 81),
  [5717] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, .production_id = 177),
  [5719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(570),
  [5721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(574),
  [5723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(573),
  [5725] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_formal_parameters_repeat1, 3, .production_id = 119),
  [5727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(891),
  [5729] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_named_imports_repeat1, 2, .production_id = 79),
  [5731] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_parameter, 4, .production_id = 121),
  [5733] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_formal_parameters_repeat1, 2),
  [5735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(165),
  [5737] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_require_clause, 6),
  [5739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1911),
  [5741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2536),
  [5743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3373),
  [5745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1916),
  [5747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2252),
  [5749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2561),
  [5751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3371),
  [5753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2583),
  [5755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3215),
  [5757] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_parameter, 3, .production_id = 91),
  [5759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(178),
  [5761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(617),
  [5763] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_required_parameter, 3, .production_id = 91),
  [5765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(622),
  [5767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(565),
  [5769] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_assignment, 2, .production_id = 41),
  [5771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2923),
  [5773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22),
  [5775] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__from_clause, 2, .production_id = 70),
  [5777] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2773),
  [5779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2410),
  [5781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3232),
  [5783] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2241),
  [5785] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_labeled_tuple_type_member, 2),
  [5787] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__import_export_specifier, 4, .production_id = 141),
  [5789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2798),
  [5791] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter, 3, .production_id = 14),
  [5793] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_export_clause_repeat1, 2, .production_id = 114),
  [5795] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__import_export_specifier, 3, .production_id = 113),
  [5797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(811),
  [5799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(611),
  [5801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(827),
  [5803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(551),
  [5805] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2419),
  [5807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2618),
  [5809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(201),
  [5811] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rest_parameter, 2),
  [5813] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_required_parameter, 2, .production_id = 41),
  [5815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(853),
  [5817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(879),
  [5819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2092),
  [5821] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3325),
  [5823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2369),
  [5825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(219),
  [5827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(220),
  [5829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(221),
  [5831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(846),
  [5833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(770),
  [5835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(218),
  [5837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(878),
  [5839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1956),
  [5841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(785),
  [5843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3084),
  [5845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(627),
  [5847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3356),
  [5849] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_imports, 5, .production_id = 79),
  [5851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3394),
  [5853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(206),
  [5855] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_imports, 2),
  [5857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3265),
  [5859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2957),
  [5861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3229),
  [5863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(766),
  [5865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(235),
  [5867] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3384),
  [5869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(905),
  [5871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(851),
  [5873] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_heritage, 2),
  [5875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(845),
  [5877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3199),
  [5879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1841),
  [5881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3308),
  [5883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3392),
  [5885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2115),
  [5887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3125),
  [5889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2083),
  [5891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(539),
  [5893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(295),
  [5895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2082),
  [5897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3093),
  [5899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2422),
  [5901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(946),
  [5903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(296),
  [5905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2108),
  [5907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2968),
  [5909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2194),
  [5911] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3273),
  [5913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2304),
  [5915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(80),
  [5917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3137),
  [5919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2086),
  [5921] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_import, 3),
  [5923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(932),
  [5925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3211),
  [5927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2462),
  [5929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(716),
  [5931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(182),
  [5933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3015),
  [5935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(930),
  [5937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1537),
  [5939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(715),
  [5941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3207),
  [5943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(496),
  [5945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(928),
  [5947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1542),
  [5949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2879),
  [5951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(189),
  [5953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(948),
  [5955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(190),
  [5957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(191),
  [5959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2070),
  [5961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(926),
  [5963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2071),
  [5965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3159),
  [5967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3075),
  [5969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(688),
  [5971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(799),
  [5973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3006),
  [5975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1170),
  [5977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1054),
  [5979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(940),
  [5981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1985),
  [5983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3208),
  [5985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(169),
  [5987] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_imports, 3),
  [5989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(238),
  [5991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3133),
  [5993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(202),
  [5995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2951),
  [5997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(900),
  [5999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(893),
  [6001] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1290),
  [6003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2117),
  [6005] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_imports, 3, .production_id = 79),
  [6007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(786),
  [6009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1495),
  [6011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1511),
  [6013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1579),
  [6015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1456),
  [6017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(892),
  [6019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3298),
  [6021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(194),
  [6023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(176),
  [6025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(775),
  [6027] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1410),
  [6029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2926),
  [6031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(420),
  [6033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(435),
  [6035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(823),
  [6037] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_clause, 3),
  [6039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(871),
  [6041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(925),
  [6043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2463),
  [6045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(796),
  [6047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3131),
  [6049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10),
  [6051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1685),
  [6053] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_imports, 4, .production_id = 79),
  [6055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2677),
  [6057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(877),
  [6059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1632),
  [6061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1629),
  [6063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3147),
  [6065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2043),
  [6067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2056),
  [6069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(962),
  [6071] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1600),
  [6073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(868),
  [6075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(896),
  [6077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(685),
  [6079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3188),
  [6081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1103),
  [6083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(886),
  [6085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(207),
  [6087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1680),
  [6089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(244),
  [6091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(976),
  [6093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2244),
  [6095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2260),
  [6097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(205),
  [6099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2976),
  [6101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2095),
  [6103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3236),
  [6105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2876),
  [6107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(769),
  [6109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(200),
  [6111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3257),
  [6113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(171),
  [6115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(185),
  [6117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(181),
  [6119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2147),
  [6121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2979),
  [6123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2144),
  [6125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1952),
  [6127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1242),
  [6129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(250),
  [6131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(682),
  [6133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(947),
  [6135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(832),
  [6137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2902),
  [6139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3254),
  [6141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2965),
  [6143] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [6145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2958),
  [6147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2184),
  [6149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3274),
  [6151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2394),
  [6153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2386),
  [6155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1464),
  [6157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(837),
  [6159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1988),
  [6161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(918),
  [6163] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3292),
  [6165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3128),
  [6167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1136),
  [6169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3064),
  [6171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1609),
  [6173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(908),
  [6175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1063),
  [6177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1066),
  [6179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(961),
  [6181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(834),
  [6183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(864),
};

#ifdef __cplusplus
extern "C" {
#endif
void *tree_sitter_typescript_external_scanner_create(void);
void tree_sitter_typescript_external_scanner_destroy(void *);
bool tree_sitter_typescript_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_typescript_external_scanner_serialize(void *, char *);
void tree_sitter_typescript_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_typescript(void) {
  static TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .symbol_names = ts_symbol_names,
    .symbol_metadata = ts_symbol_metadata,
    .parse_table = (const uint16_t *)ts_parse_table,
    .parse_actions = ts_parse_actions,
    .lex_modes = ts_lex_modes,
    .alias_sequences = (const TSSymbol *)ts_alias_sequences,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_identifier,
    .external_scanner = {
      (const bool *)ts_external_scanner_states,
      ts_external_scanner_symbol_map,
      tree_sitter_typescript_external_scanner_create,
      tree_sitter_typescript_external_scanner_destroy,
      tree_sitter_typescript_external_scanner_scan,
      tree_sitter_typescript_external_scanner_serialize,
      tree_sitter_typescript_external_scanner_deserialize,
    },
    .field_count = FIELD_COUNT,
    .field_map_slices = (const TSFieldMapSlice *)ts_field_map_slices,
    .field_map_entries = (const TSFieldMapEntry *)ts_field_map_entries,
    .field_names = ts_field_names,
    .large_state_count = LARGE_STATE_COUNT,
    .small_parse_table = (const uint16_t *)ts_small_parse_table,
    .small_parse_table_map = (const uint32_t *)ts_small_parse_table_map,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .state_count = STATE_COUNT,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
